/*!
Feathers UI v1.2.0
https://feathersui.com/

Copyright 2023 Bowler Hat LLC
Released under the MIT license
*/
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("openfl"), require("motion"));
	else if(typeof define === 'function' && define.amd)
		define(["openfl", "motion"], factory);
	else if(typeof exports === 'object')
		exports["feathers"] = factory(require("openfl"), require("motion"));
	else
		root["feathers"] = factory(root["openfl"], root["motion"]);
})(self, (__WEBPACK_EXTERNAL_MODULE_openfl__, __WEBPACK_EXTERNAL_MODULE_motion__) => {
return /******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "./lib/_gen/EReg.js":
/*!**************************!*\
  !*** ./lib/_gen/EReg.js ***!
  \**************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: EReg

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function HxOverrides() {return __webpack_require__(/*! ./HxOverrides */ "./lib/_gen/HxOverrides.js");}
function StringBuf() {return __webpack_require__(/*! ./StringBuf */ "./lib/_gen/StringBuf.js");}

// Constructor

var EReg = function(r,opt) {
	this.r = new RegExp(r,opt.split("u").join(""));
}

// Meta

EReg.__name__ = "EReg";
EReg.__isInterface__ = false;
EReg.prototype = {
	match: function(s) {
		if(this.r.global) {
			this.r.lastIndex = 0;
		}
		this.r.m = this.r.exec(s);
		this.r.s = s;
		return this.r.m != null;
	},
	matched: function(n) {
		if(this.r.m != null && n >= 0 && n < this.r.m.length) {
			return this.r.m[n];
		} else {
			throw new (js__$Boot_HaxeError().default)("EReg::matched");
		}
	},
	matchedRight: function() {
		if(this.r.m == null) {
			throw new (js__$Boot_HaxeError().default)("No string matched");
		}
		var sz = this.r.m.index + this.r.m[0].length;
		return (HxOverrides().default).substr(this.r.s,sz,this.r.s.length - sz);
	},
	matchedPos: function() {
		if(this.r.m == null) {
			throw new (js__$Boot_HaxeError().default)("No string matched");
		}
		return { pos : this.r.m.index, len : this.r.m[0].length};
	},
	matchSub: function(s,pos,len) {
		if(len == null) {
			len = -1;
		}
		if(this.r.global) {
			this.r.lastIndex = pos;
			this.r.m = this.r.exec(len < 0 ? s : (HxOverrides().default).substr(s,0,pos + len));
			var b = this.r.m != null;
			if(b) {
				this.r.s = s;
			}
			return b;
		} else {
			var b1 = this.match(len < 0 ? (HxOverrides().default).substr(s,pos,null) : (HxOverrides().default).substr(s,pos,len));
			if(b1) {
				this.r.s = s;
				this.r.m.index += pos;
			}
			return b1;
		}
	},
	split: function(s) {
		var d = "#__delim__#";
		return this.replace(s,d).split(d);
	},
	replace: function(s,by) {
		return s.replace(this.r,by);
	},
	map: function(s,f) {
		var offset = 0;
		var buf = new (StringBuf().default)();
		while(true) {
			if(offset >= s.length) {
				break;
			} else if(!this.matchSub(s,offset)) {
				buf.add((HxOverrides().default).substr(s,offset,null));
				break;
			}
			var p = this.matchedPos();
			buf.add((HxOverrides().default).substr(s,offset,p.pos - offset));
			buf.add(f(this));
			if(p.len == 0) {
				buf.add((HxOverrides().default).substr(s,p.pos,1));
				offset = p.pos + 1;
			} else {
				offset = p.pos + p.len;
			}
			if(!this.r.global) {
				break;
			}
		}
		if(!this.r.global && offset > 0 && offset < s.length) {
			buf.add((HxOverrides().default).substr(s,offset,null));
		}
		return buf.toString();
	}
};
EReg.prototype.__class__ = EReg.prototype.constructor = $hxClasses["EReg"] = EReg;

// Init



// Statics




// Export

exports["default"] = EReg;

/***/ }),

/***/ "./lib/_gen/HxOverrides.js":
/*!*********************************!*\
  !*** ./lib/_gen/HxOverrides.js ***!
  \*********************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: HxOverrides

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function js_Lib() {return __webpack_require__(/*! ./js/Lib */ "./lib/_gen/js/Lib.js");}

// Constructor

var HxOverrides = function(){}

// Meta

HxOverrides.__name__ = "HxOverrides";
HxOverrides.__isInterface__ = false;
HxOverrides.prototype = {
	
};
HxOverrides.prototype.__class__ = HxOverrides.prototype.constructor = $hxClasses["HxOverrides"] = HxOverrides;

// Init



// Statics

HxOverrides.strDate = function(s) {
	switch(s.length) {
	case 8:
		var k = s.split(":");
		var d = new Date();
		d["setTime"](0);
		d["setUTCHours"](k[0]);
		d["setUTCMinutes"](k[1]);
		d["setUTCSeconds"](k[2]);
		return d;
	case 10:
		var k1 = s.split("-");
		return new Date(k1[0],k1[1] - 1,k1[2],0,0,0);
	case 19:
		var k2 = s.split(" ");
		var y = k2[0].split("-");
		var t = k2[1].split(":");
		return new Date(y[0],y[1] - 1,y[2],t[0],t[1],t[2]);
	default:
		throw new (js__$Boot_HaxeError().default)("Invalid date format : " + s);
	}
}
HxOverrides.cca = function(s,index) {
	var x = s.charCodeAt(index);
	if(x != x) {
		return (js_Lib().default).get_undefined();
	}
	return x;
}
HxOverrides.substr = function(s,pos,len) {
	if(len == null) {
		len = s.length;
	} else if(len < 0) {
		if(pos == 0) {
			len = s.length + len;
		} else {
			return "";
		}
	}
	return s.substr(pos,len);
}
HxOverrides.remove = function(a,obj) {
	var i = a.indexOf(obj);
	if(i == -1) {
		return false;
	}
	a.splice(i,1);
	return true;
}
HxOverrides.iter = function(a) {
	return { cur : 0, arr : a, hasNext : function() {
		return this.cur < this.arr.length;
	}, next : function() {
		return this.arr[this.cur++];
	}};
}


// Export

exports["default"] = HxOverrides;

/***/ }),

/***/ "./lib/_gen/Reflect.js":
/*!*****************************!*\
  !*** ./lib/_gen/Reflect.js ***!
  \*****************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: Reflect

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./import_stub */ "./lib/_gen/import_stub.js")["default"]);
function haxe_CallStack() {return __webpack_require__(/*! ./haxe/CallStack */ "./lib/_gen/haxe/CallStack.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function js_Boot() {return __webpack_require__(/*! ./js/Boot */ "./lib/_gen/js/Boot.js");}

// Constructor

var Reflect = function(){}

// Meta

Reflect.__name__ = "Reflect";
Reflect.__isInterface__ = false;
Reflect.prototype = {
	
};
Reflect.prototype.__class__ = Reflect.prototype.constructor = $hxClasses["Reflect"] = Reflect;

// Init



// Statics

Reflect.hasField = function(o,field) {
	return Object.prototype.hasOwnProperty.call(o,field);
}
Reflect.field = function(o,field) {
	try {
		return o[field];
	} catch( e ) {
		(haxe_CallStack().default).lastException = e;
		var e1 = ((e) instanceof (js__$Boot_HaxeError().default)) ? e.val : e;
		return null;
	}
}
Reflect.setField = function(o,field,value) {
	o[field] = value;
}
Reflect.getProperty = function(o,field) {
	var tmp;
	if(o == null) {
		return null;
	} else {
		var tmp1;
		if(o.__properties__) {
			tmp = o.__properties__["get_" + field];
			tmp1 = tmp;
		} else {
			tmp1 = false;
		}
		if(tmp1) {
			return o[tmp]();
		} else {
			return o[field];
		}
	}
}
Reflect.setProperty = function(o,field,value) {
	var tmp;
	var tmp1;
	if(o.__properties__) {
		tmp = o.__properties__["set_" + field];
		tmp1 = tmp;
	} else {
		tmp1 = false;
	}
	if(tmp1) {
		o[tmp](value);
	} else {
		o[field] = value;
	}
}
Reflect.callMethod = function(o,func,args) {
	return func.apply(o,args);
}
Reflect.fields = function(o) {
	var a = [];
	if(o != null) {
		var hasOwnProperty = Object.prototype.hasOwnProperty;
		for( var f in o ) {
		if(f != "__id__" && f != "hx__closures__" && hasOwnProperty.call(o,f)) {
			a.push(f);
		}
		}
	}
	return a;
}
Reflect.isFunction = function(f) {
	if(typeof(f) == "function") {
		return !((js_Boot().default).isClass(f) || (js_Boot().default).isEnum(f));
	} else {
		return false;
	}
}
Reflect.compare = function(a,b) {
	if(a == b) {
		return 0;
	} else if(a > b) {
		return 1;
	} else {
		return -1;
	}
}
Reflect.compareMethods = function(f1,f2) {
	if(f1 == f2) {
		return true;
	}
	if(!Reflect.isFunction(f1) || !Reflect.isFunction(f2)) {
		return false;
	}
	if(f1.scope == f2.scope && f1.method == f2.method) {
		return f1.method != null;
	} else {
		return false;
	}
}
Reflect.isEnumValue = function(v) {
	if(v != null) {
		return v.__enum__ != null;
	} else {
		return false;
	}
}
Reflect.deleteField = function(o,field) {
	if(!Reflect.hasField(o,field)) {
		return false;
	}
	delete(o[field]);
	return true;
}
Reflect.makeVarArgs = function(f) {
	return function() {
		var a = Array.prototype.slice.call(arguments);
		return f(a);
	};
}


// Export

exports["default"] = Reflect;

/***/ }),

/***/ "./lib/_gen/Std.js":
/*!*************************!*\
  !*** ./lib/_gen/Std.js ***!
  \*************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: Std

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js_Boot() {return __webpack_require__(/*! ./js/Boot */ "./lib/_gen/js/Boot.js");}

// Constructor

var Std = function(){}

// Meta

Std.__name__ = "Std";
Std.__isInterface__ = false;
Std.prototype = {
	
};
Std.prototype.__class__ = Std.prototype.constructor = $hxClasses["Std"] = Std;

// Init

{
	String.prototype.__class__ = $hxClasses["String"] = String
	String.__name__ = "String";
	$hxClasses["Array"] = Array
	Array.__name__ = "Array";
	Date.prototype.__class__ = $hxClasses["Date"] = Date;
	Date.__name__ = "Date";
	var Int = $hxClasses["Int"] = { };
	var Dynamic = $hxClasses["Dynamic"] = { };
	var Float = $hxClasses["Float"] = Number;
	var Bool = $hxClasses["Bool"] = Boolean;
	var Class = $hxClasses["Class"] = { };
	var Enum = $hxClasses["Enum"] = { };
};

// Statics

Std.is = function(v,t) {
	return (js_Boot().default).__instanceof(v,t);
}
Std.downcast = function(value,c) {
	if((js_Boot().default).__downcastCheck(value,c)) {
		return value;
	} else {
		return null;
	}
}
Std.string = function(s) {
	return (js_Boot().default).__string_rec(s,"");
}
Std.int = function(x) {
	return x | 0;
}
Std.parseInt = function(x) {
	var v = parseInt(x, x && x[0]=="0" && (x[1]=="x" || x[1]=="X") ? 16 : 10);
	if(isNaN(v)) {
		return null;
	}
	return v;
}
Std.parseFloat = function(x) {
	return parseFloat(x);
}


// Export

exports["default"] = Std;

/***/ }),

/***/ "./lib/_gen/StringBuf.js":
/*!*******************************!*\
  !*** ./lib/_gen/StringBuf.js ***!
  \*******************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: StringBuf

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./Std */ "./lib/_gen/Std.js");}

// Constructor

var StringBuf = function() {
	this.b = "";
}

// Meta

StringBuf.__name__ = "StringBuf";
StringBuf.__isInterface__ = false;
StringBuf.prototype = {
	get_length: function() {
		return this.b.length;
	},
	add: function(x) {
		this.b += (Std().default).string(x);
	},
	addChar: function(c) {
		this.b += String.fromCodePoint(c);
	},
	toString: function() {
		return this.b;
	}
};
StringBuf.prototype.__class__ = StringBuf.prototype.constructor = $hxClasses["StringBuf"] = StringBuf;

// Init



// Statics




// Export

exports["default"] = StringBuf;

/***/ }),

/***/ "./lib/_gen/StringTools.js":
/*!*********************************!*\
  !*** ./lib/_gen/StringTools.js ***!
  \*********************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: StringTools

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./import_stub */ "./lib/_gen/import_stub.js")["default"]);
function StringBuf() {return __webpack_require__(/*! ./StringBuf */ "./lib/_gen/StringBuf.js");}
function haxe_iterators_StringIteratorUnicode() {return __webpack_require__(/*! ./haxe/iterators/StringIteratorUnicode */ "./lib/_gen/haxe/iterators/StringIteratorUnicode.js");}
function HxOverrides() {return __webpack_require__(/*! ./HxOverrides */ "./lib/_gen/HxOverrides.js");}

// Constructor

var StringTools = function(){}

// Meta

StringTools.__name__ = "StringTools";
StringTools.__isInterface__ = false;
StringTools.prototype = {
	
};
StringTools.prototype.__class__ = StringTools.prototype.constructor = $hxClasses["StringTools"] = StringTools;

// Init



// Statics

StringTools.urlEncode = function(s) {
	return encodeURIComponent(s);
}
StringTools.urlDecode = function(s) {
	return decodeURIComponent(s.split("+").join(" "));
}
StringTools.htmlEscape = function(s,quotes) {
	var buf = new (StringBuf().default)();
	var code = new (haxe_iterators_StringIteratorUnicode().default)(s);
	while(code.hasNext()) {
		var code1 = code.next();
		switch(code1) {
		case 34:
			if(quotes) {
				buf.add("&quot;");
			} else {
				buf.addChar(code1);
			}
			break;
		case 38:
			buf.add("&amp;");
			break;
		case 39:
			if(quotes) {
				buf.add("&#039;");
			} else {
				buf.addChar(code1);
			}
			break;
		case 60:
			buf.add("&lt;");
			break;
		case 62:
			buf.add("&gt;");
			break;
		default:
			buf.addChar(code1);
		}
	}
	return buf.toString();
}
StringTools.startsWith = function(s,start) {
	if(s.length >= start.length) {
		return s.lastIndexOf(start,0) == 0;
	} else {
		return false;
	}
}
StringTools.endsWith = function(s,end) {
	var elen = end.length;
	var slen = s.length;
	if(slen >= elen) {
		return s.indexOf(end,slen - elen) == slen - elen;
	} else {
		return false;
	}
}
StringTools.isSpace = function(s,pos) {
	var c = (HxOverrides().default).cca(s,pos);
	if(!(c > 8 && c < 14)) {
		return c == 32;
	} else {
		return true;
	}
}
StringTools.ltrim = function(s) {
	var l = s.length;
	var r = 0;
	while(r < l && StringTools.isSpace(s,r)) ++r;
	if(r > 0) {
		return (HxOverrides().default).substr(s,r,l - r);
	} else {
		return s;
	}
}
StringTools.rtrim = function(s) {
	var l = s.length;
	var r = 0;
	while(r < l && StringTools.isSpace(s,l - r - 1)) ++r;
	if(r > 0) {
		return (HxOverrides().default).substr(s,0,l - r);
	} else {
		return s;
	}
}
StringTools.trim = function(s) {
	return StringTools.ltrim(StringTools.rtrim(s));
}
StringTools.lpad = function(s,c,l) {
	if(c.length <= 0) {
		return s;
	}
	var buf = new (StringBuf().default)();
	l -= s.length;
	while(buf.get_length() < l) buf.add(c);
	buf.add(s);
	return buf.toString();
}
StringTools.replace = function(s,sub,by) {
	return s.split(sub).join(by);
}
StringTools.hex = function(n,digits) {
	var s = "";
	var hexChars = "0123456789ABCDEF";
	while(true) {
		s = hexChars.charAt(n & 15) + s;
		n >>>= 4;
		if(!(n > 0)) {
			break;
		}
	}
	if(digits != null) {
		while(s.length < digits) s = "0" + s;
	}
	return s;
}
StringTools.fastCodeAt = function(s,index) {
	return s.charCodeAt(index);
}
StringTools.isEof = function(c) {
	return c != c;
}
StringTools.utf16CodePointAt = function(s,index) {
	var c = StringTools.fastCodeAt(s,index);
	if(c >= 55296 && c <= 56319) {
		c = c - 55232 << 10 | StringTools.fastCodeAt(s,index + 1) & 1023;
	}
	return c;
}


// Export

exports["default"] = StringTools;

/***/ }),

/***/ "./lib/_gen/Type.js":
/*!**************************!*\
  !*** ./lib/_gen/Type.js ***!
  \**************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: Type

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js_Boot() {return __webpack_require__(/*! ./js/Boot */ "./lib/_gen/js/Boot.js");}
function Reflect() {return __webpack_require__(/*! ./Reflect */ "./lib/_gen/Reflect.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function ValueType() {return __webpack_require__(/*! ./ValueType */ "./lib/_gen/ValueType.js");}
function haxe_CallStack() {return __webpack_require__(/*! ./haxe/CallStack */ "./lib/_gen/haxe/CallStack.js");}

// Constructor

var Type = function(){}

// Meta

Type.__name__ = "Type";
Type.__isInterface__ = false;
Type.prototype = {
	
};
Type.prototype.__class__ = Type.prototype.constructor = $hxClasses["Type"] = Type;

// Init



// Statics

Type.getClass = function(o) {
	return (js_Boot().default).getClass(o);
}
Type.getSuperClass = function(c) {
	return c.__super__;
}
Type.getClassName = function(c) {
	return c.__name__;
}
Type.getEnumName = function(e) {
	return e.__ename__;
}
Type.resolveClass = function(name) {
	return $hxClasses[name];
}
Type.resolveEnum = function(name) {
	return $hxEnums[name];
}
Type.createInstance = function(cl,args) {
	return new (Function.prototype.bind.apply(cl,[null].concat(args)));
}
Type.createEmptyInstance = function(cl) {
	return Object.create(cl.prototype);
}
Type.createEnum = function(e,constr,params) {
	var f = (Reflect().default).field(e,constr);
	if(f == null) {
		throw new (js__$Boot_HaxeError().default)("No such constructor " + constr);
	}
	if((Reflect().default).isFunction(f)) {
		if(params == null) {
			throw new (js__$Boot_HaxeError().default)("Constructor " + constr + " need parameters");
		}
		return (Reflect().default).callMethod(e,f,params);
	}
	if(params != null && params.length != 0) {
		throw new (js__$Boot_HaxeError().default)("Constructor " + constr + " does not need parameters");
	}
	return f;
}
Type.getEnumConstructs = function(e) {
	return e.__constructs__.slice();
}
Type.typeof = function(v) {
	switch(typeof(v)) {
	case "boolean":
		return (ValueType().default).TBool;
	case "function":
		if((js_Boot().default).isClass(v) || (js_Boot().default).isEnum(v)) {
			return (ValueType().default).TObject;
		}
		return (ValueType().default).TFunction;
	case "number":
		if(Math.ceil(v) == v % 2147483648.0) {
			return (ValueType().default).TInt;
		}
		return (ValueType().default).TFloat;
	case "object":
		if(v == null) {
			return (ValueType().default).TNull;
		}
		var e = v.__enum__;
		if(e != null) {
			return (ValueType().default).TEnum($hxEnums[e]);
		}
		var c = (js_Boot().default).getClass(v);
		if(c != null) {
			return (ValueType().default).TClass(c);
		}
		return (ValueType().default).TObject;
	case "string":
		return (ValueType().default).TClass(String);
	case "undefined":
		return (ValueType().default).TNull;
	default:
		return (ValueType().default).TUnknown;
	}
}
Type.enumEq = function(a,b) {
	if(a == b) {
		return true;
	}
	try {
		var e = a.__enum__;
		if(e == null || e != b.__enum__) {
			return false;
		}
		if(a._hx_index != b._hx_index) {
			return false;
		}
		var enm = $hxEnums[e];
		var ctorName = enm.__constructs__[a._hx_index];
		var params = enm[ctorName].__params__;
		var _g = 0;
		while(_g < params.length) {
			var f = params[_g];
			++_g;
			if(!Type.enumEq(a[f],b[f])) {
				return false;
			}
		}
	} catch( e1 ) {
		(haxe_CallStack().default).lastException = e1;
		var e2 = ((e1) instanceof (js__$Boot_HaxeError().default)) ? e1.val : e1;
		return false;
	}
	return true;
}
Type.enumConstructor = function(e) {
	return $hxEnums[e.__enum__].__constructs__[e._hx_index];
}
Type.enumParameters = function(e) {
	var enm = $hxEnums[e.__enum__];
	var ctorName = enm.__constructs__[e._hx_index];
	var params = enm[ctorName].__params__;
	if(params != null) {
		var _g = [];
		var _g1 = 0;
		while(_g1 < params.length) {
			var p = params[_g1];
			++_g1;
			_g.push(e[p]);
		}
		return _g;
	} else {
		return [];
	}
}
Type.enumIndex = function(e) {
	return e._hx_index;
}


// Export

exports["default"] = Type;

/***/ }),

/***/ "./lib/_gen/ValueType.js":
/*!*******************************!*\
  !*** ./lib/_gen/ValueType.js ***!
  \*******************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: ValueType

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var ValueType = $hxEnums["ValueType"] = { __ename__ : "ValueType", __constructs__ : ["TNull","TInt","TFloat","TBool","TObject","TFunction","TClass","TEnum","TUnknown"]
  ,TUnknown: {_hx_index:8,__enum__:"ValueType",toString:$estr}
  ,TObject: {_hx_index:4,__enum__:"ValueType",toString:$estr}
  ,TNull: {_hx_index:0,__enum__:"ValueType",toString:$estr}
  ,TInt: {_hx_index:1,__enum__:"ValueType",toString:$estr}
  ,TFunction: {_hx_index:5,__enum__:"ValueType",toString:$estr}
  ,TFloat: {_hx_index:2,__enum__:"ValueType",toString:$estr}
  ,TEnum: ($_=function(e) { return {_hx_index:7,e:e,__enum__:"ValueType",toString:$estr}; },$_.__params__ = ["e"],$_)
  ,TClass: ($_=function(c) { return {_hx_index:6,c:c,__enum__:"ValueType",toString:$estr}; },$_.__params__ = ["c"],$_)
  ,TBool: {_hx_index:3,__enum__:"ValueType",toString:$estr}
};

exports["default"] = ValueType;

/***/ }),

/***/ "./lib/_gen/bind_stub.js":
/*!*******************************!*\
  !*** ./lib/_gen/bind_stub.js ***!
  \*******************************/
/***/ ((__unused_webpack_module, exports) => {

// Haxe uses its own caching bind method.  It's faster, but less standard than Function.bind.
// This version is slightly modified for compressability, modularization and readability.
// https://github.com/HaxeFoundation/haxe/issues/1349
// http://stackoverflow.com/a/17638540/1732990

Object.defineProperty(exports, "__esModule", ({value: true}));

var $fid = 0;

exports["default"] = function $bind(obj, method) {
    var func, mId;

    if( method == null ) { return null; }
    mId = method._i = method._i || $fid++;

    if( obj._c == null ) {
        obj._c = {};
    } else {
        func = obj._c[mId];
    }
    if( func == null ) {
        func = function(){
            return func._m.apply(func._s, arguments);
        };
        func._s = obj;
        func._m = method;
        obj._c[mId] = func;
    }
    return func;
};

/***/ }),

/***/ "./lib/_gen/estr_stub.js":
/*!*******************************!*\
  !*** ./lib/_gen/estr_stub.js ***!
  \*******************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

Object.defineProperty(exports, "__esModule", ({value: true}));

var js_Boot = __webpack_require__(/*! ./js/Boot */ "./lib/_gen/js/Boot.js");

exports["default"] = function $estr() {
	return js_Boot.__string_rec(this, '');
}


/***/ }),

/***/ "./lib/_gen/extend_stub.js":
/*!*********************************!*\
  !*** ./lib/_gen/extend_stub.js ***!
  \*********************************/
/***/ ((__unused_webpack_module, exports) => {

Object.defineProperty(exports, "__esModule", ({value: true}));

exports["default"] = function $extend(from, fields) {
    function Inherit() {};
    Inherit.prototype = from;
    var proto = new Inherit();
    for (var name in fields) proto[name] = fields[name];
    if(fields.toString !== Object.prototype.toString) proto.toString = fields.toString;
    return proto;
};


/***/ }),

/***/ "./lib/_gen/feathers/controls/ActivityIndicator.js":
/*!*********************************************************!*\
  !*** ./lib/_gen/feathers/controls/ActivityIndicator.js ***!
  \*********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.ActivityIndicator

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_themes_steel_components_SteelActivityIndicatorStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelActivityIndicatorStyles */ "./lib/_gen/feathers/themes/steel/components/SteelActivityIndicatorStyles.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_utils_MeasurementsUtil() {return __webpack_require__(/*! ./../../feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function openfl_Lib() {return (__webpack_require__(/*! openfl */ "openfl").Lib);}
function feathers_skins_IIndeterminateSkin() {return __webpack_require__(/*! ./../../feathers/skins/IIndeterminateSkin */ "./lib/_gen/feathers/skins/IIndeterminateSkin.js");}

// Constructor

var ActivityIndicator = function() {
	this.__indeterminateDuration = 0.75;
	this.__activitySkin = null;
	this._lastUpdateTime = 0;
	this._reversed = false;
	this._savedSkinAlpha = 1.0;
	this._activitySkinMeasurements = null;
	this.initializeActivityIndicatorTheme();
	(feathers_core_FeathersControl().default).call(this);
	this.addEventListener("addedToStage",$bind(this,this.activityIndicator_addedToStageHandler));
	this.addEventListener("removedFromStage",$bind(this,this.activityIndicator_removedFromStageHandler));
}

// Meta

ActivityIndicator.__name__ = "feathers.controls.ActivityIndicator";
ActivityIndicator.__isInterface__ = false;
ActivityIndicator.__super__ = (feathers_core_FeathersControl().default);
ActivityIndicator.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	initializeActivityIndicatorTheme: function() {
		(feathers_themes_steel_components_SteelActivityIndicatorStyles().default).initialize();
	},
	update: function() {
		var sizeInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SIZE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(stylesInvalid) {
			this.refreshBackgroundSkin();
		}
		sizeInvalid = this.measure() || sizeInvalid;
		if(sizeInvalid || stylesInvalid) {
			this.layoutBackgroundSkin();
		}
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		if(this._currentActivitySkin != null) {
			(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParent(this._activitySkinMeasurements,this._currentActivitySkin,this);
		}
		var measureSkin = null;
		if((js_Boot().default).__implements(this._currentActivitySkin,(feathers_core_IMeasureObject().default))) {
			measureSkin = (js_Boot().default).__cast(this._currentActivitySkin , (feathers_core_IMeasureObject().default));
		}
		if((js_Boot().default).__implements(this._currentActivitySkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentActivitySkin , (feathers_core_IValidating().default))).validateNow();
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			newWidth = 0.0;
			if(this._currentActivitySkin != null) {
				newWidth = Math.max(this._currentActivitySkin.get_width(),newWidth);
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			newHeight = 0.0;
			if(this._currentActivitySkin != null) {
				newHeight = Math.max(this._currentActivitySkin.get_height(),newHeight);
			}
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			newMinWidth = 0.0;
			if(measureSkin != null) {
				newMinWidth = Math.max(measureSkin.get_minWidth(),newMinWidth);
			} else if(this._activitySkinMeasurements != null) {
				newMinWidth = Math.max(this._activitySkinMeasurements.minWidth,newMinWidth);
			}
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			newMinHeight = 0.0;
			if(measureSkin != null) {
				newMinHeight = Math.max(measureSkin.get_minHeight(),newMinHeight);
			} else if(this._activitySkinMeasurements != null) {
				newMinHeight = Math.max(this._activitySkinMeasurements.minHeight,newMinHeight);
			}
		}
		var newMaxWidth = this.get_explicitMaxWidth();
		if(needsMaxWidth) {
			if(measureSkin != null) {
				newMaxWidth = measureSkin.get_maxWidth();
			} else if(this._activitySkinMeasurements != null) {
				newMaxWidth = this._activitySkinMeasurements.maxWidth;
			} else {
				newMaxWidth = 1.0 / 0.0;
			}
		}
		var newMaxHeight = this.get_explicitMaxHeight();
		if(needsMaxHeight) {
			if(measureSkin != null) {
				newMaxHeight = measureSkin.get_maxHeight();
			} else if(this._activitySkinMeasurements != null) {
				newMaxHeight = this._activitySkinMeasurements.maxHeight;
			} else {
				newMaxHeight = 1.0 / 0.0;
			}
		}
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight,newMaxWidth,newMaxHeight);
	},
	layoutBackgroundSkin: function() {
		if(this._currentActivitySkin == null) {
			return;
		}
		var diameter = Math.min(this.actualWidth,this.actualHeight);
		this._currentActivitySkin.set_width(diameter);
		this._currentActivitySkin.set_height(diameter);
		this._currentActivitySkin.set_x((this.actualWidth - diameter) / 2.0);
		this._currentActivitySkin.set_y((this.actualHeight - diameter) / 2.0);
		if((js_Boot().default).__implements(this._currentActivitySkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentActivitySkin , (feathers_core_IValidating().default))).validateNow();
		}
	},
	refreshBackgroundSkin: function() {
		var oldSkin = this._currentActivitySkin;
		this._currentActivitySkin = this.getCurrentBackgroundSkin();
		if(this._currentActivitySkin == oldSkin) {
			return;
		}
		this.removeCurrentBackgroundSkin(oldSkin);
		this.addCurrentBackgroundSkin(this._currentActivitySkin);
	},
	getCurrentBackgroundSkin: function() {
		return this.get_activitySkin();
	},
	addCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			this._activitySkinMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._activitySkinMeasurements == null) {
			this._activitySkinMeasurements = new (feathers_layout_Measurements().default)(skin);
		} else {
			this._activitySkinMeasurements.save(skin);
		}
		this._savedSkinAlpha = skin.get_alpha();
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this.addChildAt(skin,0);
	},
	removeCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		this._activitySkinMeasurements.restore(skin);
		skin.set_alpha(this._savedSkinAlpha);
		if(skin.parent == this) {
			this.removeChild(skin);
		}
	},
	activityIndicator_addedToStageHandler: function(event) {
		this._lastUpdateTime = (openfl_Lib()).getTimer();
		this.addEventListener("enterFrame",$bind(this,this.activityIndicator_enterFrameHandler));
	},
	activityIndicator_removedFromStageHandler: function(event) {
		this.removeEventListener("enterFrame",$bind(this,this.activityIndicator_enterFrameHandler));
	},
	activityIndicator_enterFrameHandler: function(event) {
		if(!this._enabled || !this.get_visible() || this._currentActivitySkin == null) {
			return;
		}
		var currentTime = (openfl_Lib()).getTimer();
		var ratio = (currentTime - this._lastUpdateTime) / (this.get_indeterminateDuration() * 1000.0);
		if(ratio >= 1.0) {
			ratio -= Math.floor(ratio);
			this._lastUpdateTime = currentTime;
			this._reversed = !this._reversed;
		}
		if((js_Boot().default).__implements(this._currentActivitySkin,(feathers_skins_IIndeterminateSkin().default))) {
			var activitySkin = this._currentActivitySkin;
			activitySkin.set_indeterminatePosition(ratio);
		} else {
			this._currentActivitySkin.set_alpha(this._savedSkinAlpha * (this._reversed ? 1.0 - ratio : ratio));
		}
	},
	get_activitySkin: function() {
		return this.__activitySkin;
	},
	set_activitySkin: function(value) {
		if(!this.setStyle("activitySkin")) {
			return this.__activitySkin;
		}
		if(this.__activitySkin == value) {
			return this.__activitySkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_activitySkin);
		this.__activitySkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__activitySkin;
	},
	clearStyle_activitySkin: function() {
		this.set_activitySkin(null);
		return this.get_activitySkin();
	},
	get_indeterminateDuration: function() {
		return this.__indeterminateDuration;
	},
	set_indeterminateDuration: function(value) {
		if(!this.setStyle("indeterminateDuration")) {
			return this.__indeterminateDuration;
		}
		if(this.__indeterminateDuration == value) {
			return this.__indeterminateDuration;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_indeterminateDuration);
		this.__indeterminateDuration = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__indeterminateDuration;
	},
	clearStyle_indeterminateDuration: function() {
		this.set_indeterminateDuration(0.75);
		return this.get_indeterminateDuration();
	}
});
ActivityIndicator.prototype.__class__ = ActivityIndicator.prototype.constructor = $hxClasses["feathers.controls.ActivityIndicator"] = ActivityIndicator;

// Init



// Statics




// Export

exports["default"] = ActivityIndicator;

/***/ }),

/***/ "./lib/_gen/feathers/controls/Alert.js":
/*!*********************************************!*\
  !*** ./lib/_gen/feathers/controls/Alert.js ***!
  \*********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.Alert

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_Panel() {return __webpack_require__(/*! ./../../feathers/controls/Panel */ "./lib/_gen/feathers/controls/Panel.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function feathers_themes_steel_components_SteelAlertStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelAlertStyles */ "./lib/_gen/feathers/themes/steel/components/SteelAlertStyles.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_controls__$Alert_StringWrapper() {return __webpack_require__(/*! ./../../feathers/controls/_Alert/StringWrapper */ "./lib/_gen/feathers/controls/_Alert/StringWrapper.js");}
function feathers_data_ArrayCollection() {return __webpack_require__(/*! ./../../feathers/data/ArrayCollection */ "./lib/_gen/feathers/data/ArrayCollection.js");}
function openfl_Lib() {return (__webpack_require__(/*! openfl */ "openfl").Lib);}
function feathers_core_PopUpManager() {return __webpack_require__(/*! ./../../feathers/core/PopUpManager */ "./lib/_gen/feathers/core/PopUpManager.js");}
function feathers_utils_DisplayObjectFactory() {return __webpack_require__(/*! ./../../feathers/utils/DisplayObjectFactory */ "./lib/_gen/feathers/utils/DisplayObjectFactory.js");}
function feathers_controls_ButtonBar() {return __webpack_require__(/*! ./../../feathers/controls/ButtonBar */ "./lib/_gen/feathers/controls/ButtonBar.js");}
function feathers_controls_Header() {return __webpack_require__(/*! ./../../feathers/controls/Header */ "./lib/_gen/feathers/controls/Header.js");}
function feathers_controls_Label() {return __webpack_require__(/*! ./../../feathers/controls/Label */ "./lib/_gen/feathers/controls/Label.js");}

// Constructor

var Alert = function(text) {
	if(text == null) {
		text = "";
	}
	this.__customMessageLabelVariant = null;
	this.__customHeaderVariant = null;
	this.__customButtonBarVariant = null;
	this.__icon = null;
	this._previousCustomMessageLabelVariant = null;
	this._previousCustomHeaderVariant = null;
	this._previousCustomButtonBarVariant = null;
	this._ignoreIconResizes = false;
	this._currentIcon = null;
	this._iconMeasurements = null;
	this._buttonsDataProvider = null;
	this._titleText = "";
	this._htmlText = null;
	this.initializeAlertTheme();
	(feathers_controls_Panel().default).call(this);
	this.set_text(text);
}

// Meta

Alert.__name__ = "feathers.controls.Alert";
Alert.__isInterface__ = false;
Alert.__super__ = (feathers_controls_Panel().default);
Alert.prototype = $extend((feathers_controls_Panel().default).prototype, {
	get_text: function() {
		return this._text;
	},
	set_text: function(value) {
		if(value == null) {
			if(this._text.length == 0) {
				return this._text;
			}
			value = "";
		}
		if(this._text == value) {
			return this._text;
		}
		this._text = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._text;
	},
	get_htmlText: function() {
		return this._htmlText;
	},
	set_htmlText: function(value) {
		if(this._htmlText == value) {
			return this._htmlText;
		}
		this._htmlText = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._htmlText;
	},
	get_titleText: function() {
		return this._titleText;
	},
	set_titleText: function(value) {
		if(value == null) {
			if(this._titleText.length == 0) {
				return this._titleText;
			}
			value = "";
		}
		if(this._titleText == value) {
			return this._titleText;
		}
		this._titleText = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._titleText;
	},
	get_messageLabelFactory: function() {
		return this._messageLabelFactory;
	},
	set_messageLabelFactory: function(value) {
		if(this._messageLabelFactory == value) {
			return this._messageLabelFactory;
		}
		this._messageLabelFactory = value;
		this.setInvalid(Alert.INVALIDATION_FLAG_MESSAGE_LABEL_FACTORY);
		return this._messageLabelFactory;
	},
	get_headerFactory: function() {
		return this._headerFactory;
	},
	set_headerFactory: function(value) {
		if(this._headerFactory == value) {
			return this._headerFactory;
		}
		this._headerFactory = value;
		this.setInvalid(Alert.INVALIDATION_FLAG_HEADER_FACTORY);
		return this._headerFactory;
	},
	get_buttonBarFactory: function() {
		return this._buttonBarFactory;
	},
	set_buttonBarFactory: function(value) {
		if(this._buttonBarFactory == value) {
			return this._buttonBarFactory;
		}
		this._buttonBarFactory = value;
		this.setInvalid(Alert.INVALIDATION_FLAG_BUTTON_BAR_FACTORY);
		return this._buttonBarFactory;
	},
	get_buttonsDataProvider: function() {
		return this._buttonsDataProvider;
	},
	set_buttonsDataProvider: function(value) {
		if(this._buttonsDataProvider == value) {
			return this._buttonsDataProvider;
		}
		this._buttonsDataProvider = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._buttonsDataProvider;
	},
	set_header: function(value) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Alert header must be created with headerFactory"));
	},
	_set_header: function(value) {
		return (feathers_controls_Panel().default).prototype.set_header.call(this,value);
	},
	set_footer: function(value) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Alert footer must be created with buttonBarFactory"));
	},
	_set_footer: function(value) {
		return (feathers_controls_Panel().default).prototype.set_footer.call(this,value);
	},
	initializeAlertTheme: function() {
		(feathers_themes_steel_components_SteelAlertStyles().default).initialize();
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(this._previousCustomButtonBarVariant != this.get_customButtonBarVariant()) {
			this.setInvalidationFlag(Alert.INVALIDATION_FLAG_BUTTON_BAR_FACTORY);
		}
		var buttonBarInvalid = this.isInvalid(Alert.INVALIDATION_FLAG_BUTTON_BAR_FACTORY);
		if(this._previousCustomHeaderVariant != this.get_customHeaderVariant()) {
			this.setInvalidationFlag(Alert.INVALIDATION_FLAG_HEADER_FACTORY);
		}
		var headerInvalid = this.isInvalid(Alert.INVALIDATION_FLAG_HEADER_FACTORY);
		if(this._previousCustomMessageLabelVariant != this.get_customMessageLabelVariant()) {
			this.setInvalidationFlag(Alert.INVALIDATION_FLAG_MESSAGE_LABEL_FACTORY);
		}
		var messageLabelInvalid = this.isInvalid(Alert.INVALIDATION_FLAG_MESSAGE_LABEL_FACTORY);
		if(headerInvalid) {
			this.createHeader();
		}
		if(buttonBarInvalid) {
			this.createButtonBar();
		}
		if(messageLabelInvalid) {
			this.createMessageLabel();
		}
		if(stylesInvalid || stateInvalid) {
			this.refreshIcon();
		}
		if(dataInvalid || stylesInvalid || stateInvalid || messageLabelInvalid) {
			this.refreshText();
		}
		if(dataInvalid || stylesInvalid || stateInvalid || headerInvalid) {
			this.refreshTitleText();
		}
		if(dataInvalid || buttonBarInvalid) {
			this.refreshButtons();
		}
		(feathers_controls_Panel().default).prototype.update.call(this);
		this._previousCustomButtonBarVariant = this.get_customButtonBarVariant();
		this._previousCustomHeaderVariant = this.get_customHeaderVariant();
		this._previousCustomMessageLabelVariant = this.get_customMessageLabelVariant();
	},
	createButtonBar: function() {
		var _gthis = this;
		if(this.buttonBar != null) {
			this.buttonBar.removeEventListener("itemTrigger",$bind(this,this.alert_buttonBar_itemTriggerHandler));
			if(this._oldButtonBarFactory.destroy != null) {
				this._oldButtonBarFactory.destroy(this.buttonBar);
			}
			this._oldButtonBarFactory = null;
			this.buttonBar = null;
			this.runWithInvalidationFlagsOnly(function() {
				return _gthis._set_footer(null);
			});
		}
		var factory = this._buttonBarFactory != null ? this._buttonBarFactory : Alert.defaultButtonBarFactory;
		this._oldButtonBarFactory = factory;
		this.buttonBar = factory.create();
		if(this.buttonBar.get_variant() == null) {
			this.buttonBar.set_variant(this.get_customButtonBarVariant() != null ? this.get_customButtonBarVariant() : Alert.CHILD_VARIANT_BUTTON_BAR);
		}
		this.buttonBar.addEventListener("itemTrigger",$bind(this,this.alert_buttonBar_itemTriggerHandler));
		this.runWithInvalidationFlagsOnly(function() {
			return _gthis._set_footer(_gthis.buttonBar);
		});
	},
	createHeader: function() {
		var _gthis = this;
		if(this.alertHeader != null) {
			if(this._oldHeaderFactory.destroy != null) {
				this._oldHeaderFactory.destroy(this.alertHeader);
			}
			this._oldHeaderFactory = null;
			this.alertHeader = null;
			this.runWithInvalidationFlagsOnly(function() {
				return _gthis._set_header(null);
			});
		}
		var factory = this._headerFactory != null ? this._headerFactory : Alert.defaultHeaderFactory;
		this._oldHeaderFactory = factory;
		this.alertHeader = factory.create();
		if(this.alertHeader.get_variant() == null) {
			this.alertHeader.set_variant(this.get_customHeaderVariant() != null ? this.get_customHeaderVariant() : Alert.CHILD_VARIANT_HEADER);
		}
		this.runWithInvalidationFlagsOnly(function() {
			return _gthis._set_header(_gthis.alertHeader);
		});
	},
	createMessageLabel: function() {
		if(this.messageLabel != null) {
			this.removeChild(this.messageLabel);
			if(this._oldMessageLabelFactory.destroy != null) {
				this._oldMessageLabelFactory.destroy(this.messageLabel);
			}
			this._oldMessageLabelFactory = null;
			this.messageLabel = null;
		}
		var factory = this._messageLabelFactory != null ? this._messageLabelFactory : Alert.defaultMessageLabelFactory;
		this._oldMessageLabelFactory = factory;
		this.messageLabel = factory.create();
		if(this.messageLabel.get_variant() == null) {
			this.messageLabel.set_variant(this.get_customMessageLabelVariant() != null ? this.get_customMessageLabelVariant() : Alert.CHILD_VARIANT_MESSAGE_LABEL);
		}
		this.addChild(this.messageLabel);
	},
	refreshButtons: function() {
		this.buttonBar.set_dataProvider(this._buttonsDataProvider);
	},
	refreshText: function() {
		this.messageLabel.set_text(this._text);
		this.messageLabel.set_htmlText(this._htmlText);
	},
	refreshTitleText: function() {
		this.alertHeader.set_text(this._titleText);
	},
	refreshIcon: function() {
		var oldIcon = this._currentIcon;
		this._currentIcon = this.getCurrentIcon();
		if(this._currentIcon == oldIcon) {
			return;
		}
		this.removeCurrentIcon(oldIcon);
		if(this._currentIcon == null) {
			this._iconMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(this._currentIcon,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._currentIcon , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._iconMeasurements == null) {
			this._iconMeasurements = new (feathers_layout_Measurements().default)(this._currentIcon);
		} else {
			this._iconMeasurements.save(this._currentIcon);
		}
		if((js_Boot().default).__implements(this._currentIcon,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(this._currentIcon , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		var index = this.getChildIndex(this.messageLabel);
		this.addChildAt(this._currentIcon,index);
	},
	getCurrentIcon: function() {
		return this.get_icon();
	},
	removeCurrentIcon: function(icon) {
		if(icon == null) {
			return;
		}
		if((js_Boot().default).__implements(icon,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(icon , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		this._iconMeasurements.restore(icon);
		if(icon.parent == this) {
			this.removeChild(icon);
		}
	},
	alert_buttonBar_itemTriggerHandler: function(event) {
		this.parent.removeChild(this);
		this.dispatchEvent(event);
	},
	get_styleContext: function() {
		return Alert
	},
	get_icon: function() {
		return this.__icon;
	},
	set_icon: function(value) {
		if(!this.setStyle("icon")) {
			return this.__icon;
		}
		if(this.__icon == value) {
			return this.__icon;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_icon);
		this.__icon = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__icon;
	},
	clearStyle_icon: function() {
		this.set_icon(null);
		return this.get_icon();
	},
	get_customButtonBarVariant: function() {
		return this.__customButtonBarVariant;
	},
	set_customButtonBarVariant: function(value) {
		if(!this.setStyle("customButtonBarVariant")) {
			return this.__customButtonBarVariant;
		}
		if(this.__customButtonBarVariant == value) {
			return this.__customButtonBarVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customButtonBarVariant);
		this.__customButtonBarVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customButtonBarVariant;
	},
	clearStyle_customButtonBarVariant: function() {
		this.set_customButtonBarVariant(null);
		return this.get_customButtonBarVariant();
	},
	get_customHeaderVariant: function() {
		return this.__customHeaderVariant;
	},
	set_customHeaderVariant: function(value) {
		if(!this.setStyle("customHeaderVariant")) {
			return this.__customHeaderVariant;
		}
		if(this.__customHeaderVariant == value) {
			return this.__customHeaderVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customHeaderVariant);
		this.__customHeaderVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customHeaderVariant;
	},
	clearStyle_customHeaderVariant: function() {
		this.set_customHeaderVariant(null);
		return this.get_customHeaderVariant();
	},
	get_customMessageLabelVariant: function() {
		return this.__customMessageLabelVariant;
	},
	set_customMessageLabelVariant: function(value) {
		if(!this.setStyle("customMessageLabelVariant")) {
			return this.__customMessageLabelVariant;
		}
		if(this.__customMessageLabelVariant == value) {
			return this.__customMessageLabelVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customMessageLabelVariant);
		this.__customMessageLabelVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customMessageLabelVariant;
	},
	clearStyle_customMessageLabelVariant: function() {
		this.set_customMessageLabelVariant(null);
		return this.get_customMessageLabelVariant();
	}
});
Alert.prototype.__class__ = Alert.prototype.constructor = $hxClasses["feathers.controls.Alert"] = Alert;

// Init



// Statics

Alert.show = function(text,titleText,buttonsText,callback,alertFactory,popUpAdapter) {
	var alert = alertFactory != null ? alertFactory() : new Alert();
	alert.set_text(text);
	alert.set_titleText(titleText);
	var buttonsData;
	if(buttonsText != null) {
		var result = new Array(buttonsText.length);
		var _g = 0;
		var _g1 = buttonsText.length;
		while(_g < _g1) {
			var i = _g++;
			result[i] = new (feathers_controls__$Alert_StringWrapper().default)(buttonsText[i]);
		}
		buttonsData = result;
	} else {
		buttonsData = [];
	}
	alert.set_buttonsDataProvider(new (feathers_data_ArrayCollection().default)(buttonsData));
	if(callback != null) {
		alert.addEventListener("itemTrigger",function(event) {
			callback(event.state);
			return;
		});
	}
	return Alert.showAlert(alert,popUpAdapter);
}
Alert.showAlert = function(alert,popUpAdapter) {
	if(popUpAdapter != null) {
		popUpAdapter.open(alert,(openfl_Lib()).get_current());
	} else {
		(feathers_core_PopUpManager().default).addPopUp(alert,(openfl_Lib()).get_current(),true,true);
	}
	return alert;
}
Alert.INVALIDATION_FLAG_BUTTON_BAR_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("buttonBarFactory")
Alert.INVALIDATION_FLAG_HEADER_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("headerFactory")
Alert.INVALIDATION_FLAG_MESSAGE_LABEL_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("messageLabelFactory")
Alert.CHILD_VARIANT_HEADER = "alert_header"
Alert.CHILD_VARIANT_MESSAGE_LABEL = "alert_messageLabel"
Alert.CHILD_VARIANT_BUTTON_BAR = "alert_buttonBar"
Alert.defaultButtonBarFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_ButtonBar().default))
Alert.defaultHeaderFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_Header().default))
Alert.defaultMessageLabelFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_Label().default))

// Export

exports["default"] = Alert;

/***/ }),

/***/ "./lib/_gen/feathers/controls/Application.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/controls/Application.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.Application

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IFocusManagerAware() {return __webpack_require__(/*! ./../../feathers/core/IFocusManagerAware */ "./lib/_gen/feathers/core/IFocusManagerAware.js");}
function feathers_controls_LayoutGroup() {return __webpack_require__(/*! ./../../feathers/controls/LayoutGroup */ "./lib/_gen/feathers/controls/LayoutGroup.js");}
function feathers_themes_steel_components_SteelApplicationStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelApplicationStyles */ "./lib/_gen/feathers/themes/steel/components/SteelApplicationStyles.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_core_PopUpManager() {return __webpack_require__(/*! ./../../feathers/core/PopUpManager */ "./lib/_gen/feathers/core/PopUpManager.js");}
function feathers_core_FocusManager() {return __webpack_require__(/*! ./../../feathers/core/FocusManager */ "./lib/_gen/feathers/core/FocusManager.js");}
function feathers_core_ToolTipManager() {return __webpack_require__(/*! ./../../feathers/core/ToolTipManager */ "./lib/_gen/feathers/core/ToolTipManager.js");}
function openfl_display_Sprite() {return (__webpack_require__(/*! openfl */ "openfl").display.Sprite);}

// Constructor

var Application = function() {
	this.__scaleManager = null;
	this._scaleFactor = 1.0;
	if(Application._topLevelApplication == null) {
		Application._topLevelApplication = this;
	}
	this.initializeApplicationTheme();
	(feathers_controls_LayoutGroup().default).call(this);
	this.addEventListener("addedToStage",$bind(this,this.application_addedToStageHandler),false,100);
}

// Meta

Application.__name__ = "feathers.controls.Application";
Application.__isInterface__ = false;
Application.__interfaces__ = [(feathers_core_IFocusManagerAware().default)];
Application.__super__ = (feathers_controls_LayoutGroup().default);
Application.prototype = $extend((feathers_controls_LayoutGroup().default).prototype, {
	get_scaleFactor: function() {
		return this._scaleFactor;
	},
	initializeApplicationTheme: function() {
		(feathers_themes_steel_components_SteelApplicationStyles().default).initialize();
	},
	update: function() {
		var sizeInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SIZE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(sizeInvalid || stylesInvalid) {
			this.refreshScaleManager();
		}
		(feathers_controls_LayoutGroup().default).prototype.update.call(this);
	},
	refreshScaleManager: function() {
		var _gthis = this;
		var oldScaleManager = this._currentScaleManager;
		this._currentScaleManager = this.get_scaleManager();
		if(this._currentScaleManager == oldScaleManager) {
			return;
		}
		if(oldScaleManager != null) {
			oldScaleManager.removeEventListener("change",$bind(this,this.application_scaleManager_changeHandler));
			oldScaleManager.set_target(null);
		}
		if(this._currentScaleManager != null) {
			this._currentScaleManager.addEventListener("change",$bind(this,this.application_scaleManager_changeHandler),false,0,true);
			this.runWithInvalidationFlagsOnly(function() {
				return _gthis._currentScaleManager.set_target(_gthis);
			});
		}
	},
	refreshDimensions: function() {
		if(this._currentScaleManager == null) {
			return;
		}
		this._scaleFactor = this._currentScaleManager.getScale();
		this.set_scaleX(this._scaleFactor);
		this.set_scaleY(this._scaleFactor);
		var bounds = this._currentScaleManager.getBounds();
		this.set_x(bounds.x);
		this.set_y(bounds.y);
		this.set_width(bounds.width);
		this.set_height(bounds.height);
		if(this._applicationPopUpContainer != null) {
			this._applicationPopUpContainer.set_scaleX(this._scaleFactor);
			this._applicationPopUpContainer.set_scaleY(this._scaleFactor);
		}
	},
	preparePopUpManager: function() {
		if(this._applicationPopUpContainer == null) {
			var factory = this.popUpContainerFactory;
			if(factory == null) {
				factory = Application.defaultPopUpContainerFactory;
			}
			this._applicationPopUpContainer = factory();
		}
		this._applicationPopUpContainer.set_scaleX(this._scaleFactor);
		this._applicationPopUpContainer.set_scaleY(this._scaleFactor);
		this.stage.addChild(this._applicationPopUpContainer);
		var popUpManager = (feathers_core_PopUpManager().default).forStage(this.stage);
		popUpManager.set_root(this._applicationPopUpContainer);
	},
	cleanupPopUpManager: function() {
		var popUpManager = (feathers_core_PopUpManager().default).forStage(this.stage);
		if(popUpManager.get_root() == this._applicationPopUpContainer) {
			popUpManager.set_root(this.stage);
		}
		this.stage.removeChild(this._applicationPopUpContainer);
		this._applicationPopUpContainer = null;
	},
	prepareFocusManager: function() {
		if(!(feathers_core_FocusManager().default).hasRoot(this.stage)) {
			this._applicationFocusManager = (feathers_core_FocusManager().default).addRoot(this.stage);
		}
	},
	cleanupFocusManager: function() {
		if(this._applicationFocusManager != null) {
			this._applicationFocusManager = null;
			(feathers_core_FocusManager().default).removeRoot(this.stage);
		}
	},
	prepareToolTipManager: function() {
		if(!(feathers_core_ToolTipManager().default).hasRoot(this.stage)) {
			this._applicationToolTipManager = (feathers_core_ToolTipManager().default).addRoot(this.stage);
		}
	},
	cleanupToolTipManager: function() {
		if(this._applicationToolTipManager != null) {
			this._applicationToolTipManager = null;
			(feathers_core_ToolTipManager().default).removeRoot(this.stage);
		}
	},
	application_addedToStageHandler: function(event) {
		this.addEventListener("removedFromStage",$bind(this,this.application_removedFromStageHandler));
		this.prepareFocusManager();
		this.preparePopUpManager();
		this.prepareToolTipManager();
	},
	application_removedFromStageHandler: function(event) {
		this.removeEventListener("removedFromStage",$bind(this,this.application_removedFromStageHandler));
		this.cleanupToolTipManager();
		this.cleanupPopUpManager();
		this.cleanupFocusManager();
	},
	application_scaleManager_changeHandler: function(event) {
		this.refreshDimensions();
	},
	get_styleContext: function() {
		return Application
	},
	get_scaleManager: function() {
		return this.__scaleManager;
	},
	set_scaleManager: function(value) {
		if(!this.setStyle("scaleManager")) {
			return this.__scaleManager;
		}
		if(this.__scaleManager == value) {
			return this.__scaleManager;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_scaleManager);
		this.__scaleManager = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__scaleManager;
	},
	clearStyle_scaleManager: function() {
		this.set_scaleManager(null);
		return this.get_scaleManager();
	}
});
Application.prototype.__class__ = Application.prototype.constructor = $hxClasses["feathers.controls.Application"] = Application;

// Init



// Statics

Application.get_topLevelApplication = function() {
	return Application._topLevelApplication;
}
Application.defaultPopUpContainerFactory = function() {
	return new (openfl_display_Sprite())();
}


// Export

exports["default"] = Application;

/***/ }),

/***/ "./lib/_gen/feathers/controls/AssetLoader.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/controls/AssetLoader.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.AssetLoader

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function openfl_utils_Assets() {return (__webpack_require__(/*! openfl */ "openfl").utils.Assets);}
function openfl_events_ProgressEvent() {return (__webpack_require__(/*! openfl */ "openfl").events.ProgressEvent);}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function openfl_events_Event() {return (__webpack_require__(/*! openfl */ "openfl").events.Event);}
function openfl_events_IOErrorEvent() {return (__webpack_require__(/*! openfl */ "openfl").events.IOErrorEvent);}
function openfl_display_Loader() {return (__webpack_require__(/*! openfl */ "openfl").display.Loader);}
function openfl_net_URLRequest() {return (__webpack_require__(/*! openfl */ "openfl").net.URLRequest);}
function haxe_CallStack() {return __webpack_require__(/*! ./../../haxe/CallStack */ "./lib/_gen/haxe/CallStack.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_SecurityError() {return (__webpack_require__(/*! openfl */ "openfl").errors.SecurityError);}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function openfl_events_SecurityErrorEvent() {return (__webpack_require__(/*! openfl */ "openfl").events.SecurityErrorEvent);}
function openfl_geom_Rectangle() {return (__webpack_require__(/*! openfl */ "openfl").geom.Rectangle);}
function feathers_utils_ScaleUtil() {return __webpack_require__(/*! ./../../feathers/utils/ScaleUtil */ "./lib/_gen/feathers/utils/ScaleUtil.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_graphics_FillStyle() {return __webpack_require__(/*! ./../../feathers/graphics/FillStyle */ "./lib/_gen/feathers/graphics/FillStyle.js");}
function openfl_display_Bitmap() {return (__webpack_require__(/*! openfl */ "openfl").display.Bitmap);}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}

// Constructor

var AssetLoader = function(source,completeListener) {
	this._scaleMode = "showAll";
	this._scaleModeMask = null;
	this._contentMeasurements = new (feathers_layout_Measurements().default)();
	(feathers_core_FeathersControl().default).call(this);
	this.set_source(source);
	if(completeListener != null) {
		this.addEventListener("complete",completeListener);
	}
}

// Meta

AssetLoader.__name__ = "feathers.controls.AssetLoader";
AssetLoader.__isInterface__ = false;
AssetLoader.__super__ = (feathers_core_FeathersControl().default);
AssetLoader.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_source: function() {
		return this._source;
	},
	set_source: function(value) {
		var _gthis = this;
		if(this._source == value) {
			return this._source;
		}
		if(this.loader != null) {
			this.loader.unloadAndStop();
		}
		if(this.content != null) {
			this.removeChild(this.content);
			this.content = null;
		}
		this._source = value;
		if(this._source == null) {
			this._pendingFuture = null;
			this.cleanupLoader();
		} else if((openfl_utils_Assets()).exists(this._source,"IMAGE")) {
			this.cleanupLoader();
			if((openfl_utils_Assets()).isLocal(this._source,"IMAGE")) {
				this._pendingFuture = null;
				var bitmapData = (openfl_utils_Assets()).getBitmapData(this._source);
				var bitmap = this.createBitmap(bitmapData);
				this._contentMeasurements.save(bitmap);
				this.addChild(bitmap);
				this.content = bitmap;
			} else {
				var future = (openfl_utils_Assets()).loadBitmapData(this._source);
				future.onProgress(function(progress,total) {
					return _gthis.dispatchEvent(new (openfl_events_ProgressEvent())("progress",false,false,progress,total));
				}).onComplete(function(bitmapData1) {
					if(future != _gthis._pendingFuture) {
						return;
					}
					var bitmap1 = _gthis.createBitmap(bitmapData1);
					_gthis._contentMeasurements.save(bitmap1);
					_gthis.addChild(bitmap1);
					_gthis.content = bitmap1;
					_gthis.setInvalid((feathers_core_InvalidationFlag().default).DATA);
					_gthis.dispatchEvent(new (openfl_events_Event())("complete"));
				}).onError(function(event) {
					return _gthis.dispatchEvent(new (openfl_events_IOErrorEvent())("ioError"));
				});
				this._pendingFuture = future;
			}
		} else if((openfl_utils_Assets()).exists(this._source,"MOVIE_CLIP")) {
			this.cleanupLoader();
			if((openfl_utils_Assets()).isLocal(this._source,"MOVIE_CLIP")) {
				this._pendingFuture = null;
				var movieClip = (openfl_utils_Assets()).getMovieClip(this._source);
				this._contentMeasurements.save(movieClip);
				this.addChild(movieClip);
				this.content = movieClip;
			} else {
				var future1 = (openfl_utils_Assets()).loadMovieClip(this._source);
				future1.onProgress(function(progress1,total1) {
					return _gthis.dispatchEvent(new (openfl_events_ProgressEvent())("progress",false,false,progress1,total1));
				}).onComplete(function(movieClip1) {
					if(future1 != _gthis._pendingFuture) {
						return;
					}
					_gthis._contentMeasurements.save(movieClip1);
					_gthis.addChild(movieClip1);
					_gthis.content = movieClip1;
					_gthis.setInvalid((feathers_core_InvalidationFlag().default).DATA);
					_gthis.dispatchEvent(new (openfl_events_Event())("complete"));
				}).onError(function(event1) {
					return _gthis.dispatchEvent(new (openfl_events_IOErrorEvent())("ioError"));
				});
				this._pendingFuture = future1;
			}
		} else {
			this._pendingFuture = null;
			if(this.loader == null) {
				this.loader = new (openfl_display_Loader())();
				this.loader.contentLoaderInfo.addEventListener("complete",$bind(this,this.loader_contentLoaderInfo_completeHandler));
				this.loader.contentLoaderInfo.addEventListener("progress",$bind(this,this.loader_contentLoaderInfo_progressHandler));
				this.loader.contentLoaderInfo.addEventListener("ioError",$bind(this,this.loader_contentLoaderInfo_ioErrorHandler));
				this.loader.contentLoaderInfo.addEventListener("securityError",$bind(this,this.loader_contentLoaderInfo_securityErrorHandler));
			}
			try {
				this.loader.load(new (openfl_net_URLRequest())(this._source));
			} catch( e ) {
				(haxe_CallStack().default).lastException = e;
				var e1 = ((e) instanceof (js__$Boot_HaxeError().default)) ? e.val : e;
				if(((e1) instanceof (openfl_errors_SecurityError()))) {
					var securityError = (js_Boot().default).__cast(e1 , (openfl_errors_SecurityError()));
					this.dispatchEvent(new (openfl_events_SecurityErrorEvent())("securityError",false,false,securityError.message,securityError.errorID));
				}
			}
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._source;
	},
	get_originalSourceWidth: function() {
		if(this._contentMeasurements == null) {
			return null;
		}
		return this._contentMeasurements.width;
	},
	get_originalSourceHeight: function() {
		if(this._contentMeasurements == null) {
			return null;
		}
		return this._contentMeasurements.height;
	},
	get_scaleMode: function() {
		return this._scaleMode;
	},
	set_scaleMode: function(value) {
		if(this._scaleMode == value) {
			return this._scaleMode;
		}
		this._scaleMode = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		return this._scaleMode;
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var layoutInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		this.measure();
		this.layoutChildren();
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		var contentWidth = this._contentMeasurements.width;
		var contentHeight = this._contentMeasurements.height;
		var widthScale = 1.0;
		var heightScale = 1.0;
		if(this.content != null && this._scaleMode != "noScale") {
			if(!needsWidth) {
				widthScale = this.get_explicitWidth() / contentWidth;
			} else if(this.get_explicitMaxWidth() != null && this.get_explicitMaxWidth() < contentWidth) {
				widthScale = this.get_explicitMaxWidth() / contentWidth;
			} else if(this.get_explicitMinWidth() != null && this.get_explicitMinWidth() > contentWidth) {
				widthScale = this.get_explicitMinWidth() / contentWidth;
			}
			if(!needsHeight) {
				heightScale = this.get_explicitHeight() / contentHeight;
			} else if(this.get_explicitMaxHeight() != null && this.get_explicitMaxHeight() < contentHeight) {
				heightScale = this.get_explicitMaxHeight() / contentHeight;
			} else if(this.get_explicitMinHeight() != null && this.get_explicitMinHeight() > contentHeight) {
				heightScale = this.get_explicitMinHeight() / contentHeight;
			}
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			if(this.content != null) {
				newWidth = contentWidth * heightScale;
			} else {
				newWidth = 0.0;
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			if(this.content != null) {
				newHeight = contentHeight * widthScale;
			} else {
				newHeight = 0.0;
			}
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			if(this.content != null) {
				newMinWidth = contentWidth * heightScale;
			} else {
				newMinWidth = 0.0;
			}
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			if(this.content != null) {
				newMinHeight = contentHeight * widthScale;
			} else {
				newMinHeight = 0.0;
			}
		}
		var newMaxWidth = this.get_explicitMaxWidth();
		if(needsMaxWidth) {
			if(this.content != null) {
				newMaxWidth = contentWidth * heightScale;
			} else {
				newMaxWidth = 1.0 / 0.0;
			}
		}
		var newMaxHeight = this.get_explicitMaxHeight();
		if(needsMaxHeight) {
			if(this.content != null) {
				newMaxHeight = contentHeight * widthScale;
			} else {
				newMaxHeight = 1.0 / 0.0;
			}
		}
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight,newMaxWidth,newMaxHeight);
	},
	layoutChildren: function() {
		if(this.content == null) {
			return;
		}
		var needsMask = false;
		switch(this._scaleMode) {
		case "exactFit":
			this.content.set_x(0.0);
			this.content.set_y(0.0);
			this.content.set_width(this.actualWidth);
			this.content.set_height(this.actualHeight);
			break;
		case "noBorder":
			var original = new (openfl_geom_Rectangle())(0.0,0.0,this._contentMeasurements.width,this._contentMeasurements.height);
			var into = new (openfl_geom_Rectangle())(0.0,0.0,this.actualWidth,this.actualHeight);
			var scaled = (feathers_utils_ScaleUtil().default).fillRectangle(original,into,into);
			this.content.set_x(scaled.x);
			this.content.set_y(scaled.y);
			this.content.set_width(scaled.width);
			this.content.set_height(scaled.height);
			needsMask = this.content.get_width() > this.actualWidth || this.content.get_height() > this.actualHeight;
			break;
		case "noScale":
			this.content.set_x(0.0);
			this.content.set_y(0.0);
			this._contentMeasurements.restore(this.content);
			if((js_Boot().default).__implements(this.content,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this.content , (feathers_core_IValidating().default))).validateNow();
			}
			needsMask = this.content.get_width() > this.actualWidth || this.content.get_height() > this.actualHeight;
			break;
		default:
			var original1 = new (openfl_geom_Rectangle())(0.0,0.0,this._contentMeasurements.width,this._contentMeasurements.height);
			var into1 = new (openfl_geom_Rectangle())(0.0,0.0,this.actualWidth,this.actualHeight);
			(feathers_utils_ScaleUtil().default).fitRectangle(original1,into1,into1);
			this.content.set_x(into1.x);
			this.content.set_y(into1.y);
			this.content.set_width(into1.width);
			this.content.set_height(into1.height);
		}
		if(needsMask) {
			if(this._scaleModeMask == null) {
				this._scaleModeMask = new (feathers_skins_RectangleSkin().default)((feathers_graphics_FillStyle().default).SolidColor(16711935));
				this.addChild(this._scaleModeMask);
			}
			this._scaleModeMask.set_width(this.actualWidth);
			this._scaleModeMask.set_height(this.actualHeight);
			this.content.set_mask(this._scaleModeMask);
		} else {
			if(this._scaleModeMask != null) {
				this.removeChild(this._scaleModeMask);
				this._scaleModeMask = null;
			}
			this.content.set_mask(null);
		}
	},
	createBitmap: function(bitmapData) {
		return new (openfl_display_Bitmap())(bitmapData);
	},
	cleanupLoader: function() {
		if(this.loader == null) {
			return;
		}
		this.loader.contentLoaderInfo.removeEventListener("complete",$bind(this,this.loader_contentLoaderInfo_completeHandler));
		this.loader.contentLoaderInfo.removeEventListener("progress",$bind(this,this.loader_contentLoaderInfo_progressHandler));
		this.loader.contentLoaderInfo.removeEventListener("ioError",$bind(this,this.loader_contentLoaderInfo_ioErrorHandler));
		this.loader.contentLoaderInfo.removeEventListener("securityError",$bind(this,this.loader_contentLoaderInfo_securityErrorHandler));
		this.loader = null;
	},
	loader_contentLoaderInfo_progressHandler: function(event) {
		this.dispatchEvent(event);
	},
	loader_contentLoaderInfo_ioErrorHandler: function(event) {
		this.dispatchEvent(event);
	},
	loader_contentLoaderInfo_securityErrorHandler: function(event) {
		this.dispatchEvent(event);
	},
	loader_contentLoaderInfo_completeHandler: function(event) {
		this.addChild(this.loader);
		this.content = this.loader;
		this._contentMeasurements.save(this.content);
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		this.dispatchEvent(event);
	},
	get_styleContext: function() {
		return AssetLoader
	}
});
AssetLoader.prototype.__class__ = AssetLoader.prototype.constructor = $hxClasses["feathers.controls.AssetLoader"] = AssetLoader;

// Init



// Statics




// Export

exports["default"] = AssetLoader;

/***/ }),

/***/ "./lib/_gen/feathers/controls/BasicButton.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/controls/BasicButton.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.BasicButton

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IStateContext() {return __webpack_require__(/*! ./../../feathers/core/IStateContext */ "./lib/_gen/feathers/core/IStateContext.js");}
function feathers_controls_ITriggerView() {return __webpack_require__(/*! ./../../feathers/controls/ITriggerView */ "./lib/_gen/feathers/controls/ITriggerView.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_controls_ButtonState() {return __webpack_require__(/*! ./../../feathers/controls/ButtonState */ "./lib/_gen/feathers/controls/ButtonState.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_utils_PointerToState() {return __webpack_require__(/*! ./../../feathers/utils/PointerToState */ "./lib/_gen/feathers/utils/PointerToState.js");}
function feathers_utils_KeyToState() {return __webpack_require__(/*! ./../../feathers/utils/KeyToState */ "./lib/_gen/feathers/utils/KeyToState.js");}
function feathers_utils_PointerTrigger() {return __webpack_require__(/*! ./../../feathers/utils/PointerTrigger */ "./lib/_gen/feathers/utils/PointerTrigger.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_core_IStateObserver() {return __webpack_require__(/*! ./../../feathers/core/IStateObserver */ "./lib/_gen/feathers/core/IStateObserver.js");}
function feathers_utils_MeasurementsUtil() {return __webpack_require__(/*! ./../../feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function haxe_ds_EnumValueMap() {return __webpack_require__(/*! ./../../haxe/ds/EnumValueMap */ "./lib/_gen/haxe/ds/EnumValueMap.js");}

// Constructor

var BasicButton = function(triggerListener) {
	this.__backgroundSkin = null;
	this.__keepDownStateOnRollOut = false;
	this._stateToSkin = new (haxe_ds_EnumValueMap().default)();
	this._currentBackgroundSkin = null;
	this._backgroundSkinMeasurements = null;
	this._pointerTrigger = null;
	this._keyToState = null;
	this._pointerToState = null;
	this._currentState = (feathers_controls_ButtonState().default).UP;
	(feathers_core_FeathersControl().default).call(this);
	this.mouseChildren = false;
	this.set_buttonMode(true);
	this.useHandCursor = false;
	this.addEventListener("click",$bind(this,this.basicButton_clickHandler));
	this.addEventListener("touchTap",$bind(this,this.basicButton_touchTapHandler));
	if(triggerListener != null) {
		this.addEventListener("trigger",triggerListener);
	}
}

// Meta

BasicButton.__name__ = "feathers.controls.BasicButton";
BasicButton.__isInterface__ = false;
BasicButton.__interfaces__ = [(feathers_core_IStateContext().default),(feathers_controls_ITriggerView().default)];
BasicButton.__super__ = (feathers_core_FeathersControl().default);
BasicButton.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_currentState: function() {
		return this._currentState;
	},
	set_enabled: function(value) {
		(feathers_core_FeathersControl().default).prototype.set_enabled.call(this,value);
		if(this._enabled) {
			if(this._currentState == (feathers_controls_ButtonState().default).DISABLED) {
				this.changeState((feathers_controls_ButtonState().default).UP);
			}
		} else {
			this.changeState((feathers_controls_ButtonState().default).DISABLED);
		}
		return this._enabled;
	},
	getSkinForState: function(state) {
		return this._stateToSkin.get(state);
	},
	setSkinForState: function(state,skin) {
		if(!this.setStyle("setSkinForState",state)) {
			return;
		}
		var oldSkin = this._stateToSkin.get(state);
		if(oldSkin != null && oldSkin == this._currentBackgroundSkin) {
			this.removeCurrentBackgroundSkin(oldSkin);
			this._currentBackgroundSkin = null;
		}
		if(skin == null) {
			this._stateToSkin.remove(state);
		} else {
			this._stateToSkin.set(state,skin);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	initialize: function() {
		(feathers_core_FeathersControl().default).prototype.initialize.call(this);
		if(this._pointerToState == null) {
			this._pointerToState = new (feathers_utils_PointerToState().default)(this,$bind(this,this.changeState),(feathers_controls_ButtonState().default).UP,(feathers_controls_ButtonState().default).DOWN,(feathers_controls_ButtonState().default).HOVER);
		}
		if(this._keyToState == null) {
			this._keyToState = new (feathers_utils_KeyToState().default)(this,$bind(this,this.changeState),(feathers_controls_ButtonState().default).UP,(feathers_controls_ButtonState().default).DOWN);
		}
		if(this._pointerTrigger == null) {
			this._pointerTrigger = new (feathers_utils_PointerTrigger().default)(this);
		}
	},
	update: function() {
		this.commitChanges();
		this.measure();
		this.layoutContent();
	},
	commitChanges: function() {
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		if(stylesInvalid || stateInvalid) {
			this.refreshBackgroundSkin();
		}
		if(stylesInvalid) {
			this.refreshInteractivity();
		}
	},
	layoutContent: function() {
		this.layoutBackgroundSkin();
	},
	refreshInteractivity: function() {
		this._pointerToState.set_keepDownStateOnRollOut(this.get_keepDownStateOnRollOut());
	},
	refreshBackgroundSkin: function() {
		var oldSkin = this._currentBackgroundSkin;
		this._currentBackgroundSkin = this.getCurrentBackgroundSkin();
		if(this._currentBackgroundSkin == oldSkin) {
			return;
		}
		this.removeCurrentBackgroundSkin(oldSkin);
		this.addCurrentBackgroundSkin(this._currentBackgroundSkin);
	},
	getCurrentBackgroundSkin: function() {
		var result = this._stateToSkin.get(this._currentState);
		if(result != null) {
			return result;
		}
		return this.get_backgroundSkin();
	},
	addCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			this._backgroundSkinMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._backgroundSkinMeasurements == null) {
			this._backgroundSkinMeasurements = new (feathers_layout_Measurements().default)(skin);
		} else {
			this._backgroundSkinMeasurements.save(skin);
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IStateObserver().default))).set_stateContext(this);
		}
		this.addChildAt(skin,0);
	},
	removeCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IStateObserver().default))).set_stateContext(null);
		}
		this._backgroundSkinMeasurements.restore(skin);
		if(skin.parent == this) {
			this.removeChild(skin);
		}
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		if(this._currentBackgroundSkin != null) {
			(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParent(this._backgroundSkinMeasurements,this._currentBackgroundSkin,this);
		}
		var measureSkin = null;
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IMeasureObject().default))) {
			measureSkin = (js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IMeasureObject().default));
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			if(this._currentBackgroundSkin != null) {
				newWidth = this._currentBackgroundSkin.get_width();
			} else {
				newWidth = 0.0;
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			if(this._currentBackgroundSkin != null) {
				newHeight = this._currentBackgroundSkin.get_height();
			} else {
				newHeight = 0.0;
			}
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			if(measureSkin != null) {
				newMinWidth = measureSkin.get_minWidth();
			} else if(this._backgroundSkinMeasurements != null) {
				newMinWidth = this._backgroundSkinMeasurements.minWidth;
			} else {
				newMinWidth = 0.0;
			}
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			if(measureSkin != null) {
				newMinHeight = measureSkin.get_minHeight();
			} else if(this._backgroundSkinMeasurements != null) {
				newMinHeight = this._backgroundSkinMeasurements.minHeight;
			} else {
				newMinHeight = 0.0;
			}
		}
		var newMaxWidth = this.get_explicitMaxWidth();
		if(needsMaxWidth) {
			if(measureSkin != null) {
				newMaxWidth = measureSkin.get_maxWidth();
			} else if(this._backgroundSkinMeasurements != null) {
				newMaxWidth = this._backgroundSkinMeasurements.maxWidth;
			} else {
				newMaxWidth = 1.0 / 0.0;
			}
		}
		var newMaxHeight = this.get_explicitMaxHeight();
		if(needsMaxHeight) {
			if(measureSkin != null) {
				newMaxHeight = measureSkin.get_maxHeight();
			} else if(this._backgroundSkinMeasurements != null) {
				newMaxHeight = this._backgroundSkinMeasurements.maxHeight;
			} else {
				newMaxHeight = 1.0 / 0.0;
			}
		}
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight,newMaxWidth,newMaxHeight);
	},
	layoutBackgroundSkin: function() {
		if(this._currentBackgroundSkin == null) {
			return;
		}
		this._currentBackgroundSkin.set_x(0.0);
		this._currentBackgroundSkin.set_y(0.0);
		if(this._currentBackgroundSkin.get_width() != this.actualWidth) {
			this._currentBackgroundSkin.set_width(this.actualWidth);
		}
		if(this._currentBackgroundSkin.get_height() != this.actualHeight) {
			this._currentBackgroundSkin.set_height(this.actualHeight);
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
	},
	changeState: function(state) {
		if(!this._enabled) {
			state = (feathers_controls_ButtonState().default).DISABLED;
		}
		if(this._currentState == state) {
			return;
		}
		this._currentState = state;
		this.setInvalid((feathers_core_InvalidationFlag().default).STATE);
		(feathers_events_FeathersEvent().default).dispatch(this,"stateChange");
	},
	basicButton_clickHandler: function(event) {
		if(!this._enabled) {
			event.stopImmediatePropagation();
			return;
		}
	},
	basicButton_touchTapHandler: function(event) {
		if(!this._enabled) {
			event.stopImmediatePropagation();
			return;
		}
	},
	get_keepDownStateOnRollOut: function() {
		return this.__keepDownStateOnRollOut;
	},
	set_keepDownStateOnRollOut: function(value) {
		if(!this.setStyle("keepDownStateOnRollOut")) {
			return this.__keepDownStateOnRollOut;
		}
		if(this.__keepDownStateOnRollOut == value) {
			return this.__keepDownStateOnRollOut;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_keepDownStateOnRollOut);
		this.__keepDownStateOnRollOut = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__keepDownStateOnRollOut;
	},
	clearStyle_keepDownStateOnRollOut: function() {
		this.set_keepDownStateOnRollOut(false);
		return this.get_keepDownStateOnRollOut();
	},
	get_backgroundSkin: function() {
		return this.__backgroundSkin;
	},
	set_backgroundSkin: function(value) {
		if(!this.setStyle("backgroundSkin")) {
			return this.__backgroundSkin;
		}
		if(this.__backgroundSkin == value) {
			return this.__backgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_backgroundSkin);
		this.__backgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__backgroundSkin;
	},
	clearStyle_backgroundSkin: function() {
		this.set_backgroundSkin(null);
		return this.get_backgroundSkin();
	}
});
BasicButton.prototype.__class__ = BasicButton.prototype.constructor = $hxClasses["feathers.controls.BasicButton"] = BasicButton;

// Init



// Statics


BasicButton.__meta__ = { fields : { setSkinForState : { style : null}}}

// Export

exports["default"] = BasicButton;

/***/ }),

/***/ "./lib/_gen/feathers/controls/BasicToggleButton.js":
/*!*********************************************************!*\
  !*** ./lib/_gen/feathers/controls/BasicToggleButton.js ***!
  \*********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.BasicToggleButton

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IStateContext() {return __webpack_require__(/*! ./../../feathers/core/IStateContext */ "./lib/_gen/feathers/core/IStateContext.js");}
function feathers_controls_IToggle() {return __webpack_require__(/*! ./../../feathers/controls/IToggle */ "./lib/_gen/feathers/controls/IToggle.js");}
function feathers_controls_ITriggerView() {return __webpack_require__(/*! ./../../feathers/controls/ITriggerView */ "./lib/_gen/feathers/controls/ITriggerView.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_controls_ToggleButtonState() {return __webpack_require__(/*! ./../../feathers/controls/ToggleButtonState */ "./lib/_gen/feathers/controls/ToggleButtonState.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function feathers_utils_PointerToState() {return __webpack_require__(/*! ./../../feathers/utils/PointerToState */ "./lib/_gen/feathers/utils/PointerToState.js");}
function feathers_utils_KeyToState() {return __webpack_require__(/*! ./../../feathers/utils/KeyToState */ "./lib/_gen/feathers/utils/KeyToState.js");}
function feathers_utils_PointerTrigger() {return __webpack_require__(/*! ./../../feathers/utils/PointerTrigger */ "./lib/_gen/feathers/utils/PointerTrigger.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_core_IStateObserver() {return __webpack_require__(/*! ./../../feathers/core/IStateObserver */ "./lib/_gen/feathers/core/IStateObserver.js");}
function feathers_utils_MeasurementsUtil() {return __webpack_require__(/*! ./../../feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function haxe_ds_EnumValueMap() {return __webpack_require__(/*! ./../../haxe/ds/EnumValueMap */ "./lib/_gen/haxe/ds/EnumValueMap.js");}

// Constructor

var BasicToggleButton = function(changeListener) {
	this.__selectedBackgroundSkin = null;
	this.__backgroundSkin = null;
	this.__keepDownStateOnRollOut = false;
	this._stateToSkin = new (haxe_ds_EnumValueMap().default)();
	this._currentBackgroundSkin = null;
	this._backgroundSkinMeasurements = null;
	this._pointerTrigger = null;
	this._keyToState = null;
	this._pointerToState = null;
	this._toggleable = true;
	this._selected = false;
	this._currentState = (feathers_controls_ToggleButtonState().default).UP(false);
	(feathers_core_FeathersControl().default).call(this);
	this.mouseChildren = false;
	this.set_buttonMode(true);
	this.useHandCursor = false;
	this.addEventListener("click",$bind(this,this.basicToggleButton_clickHandler));
	this.addEventListener("touchTap",$bind(this,this.basicToggleButton_touchTapHandler));
	this.addEventListener("trigger",$bind(this,this.basicToggleButton_triggerHandler));
	if(changeListener != null) {
		this.addEventListener("change",changeListener);
	}
}

// Meta

BasicToggleButton.__name__ = "feathers.controls.BasicToggleButton";
BasicToggleButton.__isInterface__ = false;
BasicToggleButton.__interfaces__ = [(feathers_core_IStateContext().default),(feathers_controls_IToggle().default),(feathers_controls_ITriggerView().default)];
BasicToggleButton.__super__ = (feathers_core_FeathersControl().default);
BasicToggleButton.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_currentState: function() {
		return this._currentState;
	},
	set_enabled: function(value) {
		(feathers_core_FeathersControl().default).prototype.set_enabled.call(this,value);
		if(this._enabled) {
			var _g = this._currentState;
			if(_g._hx_index == 3) {
				var selected = _g.selected;
				this.changeState((feathers_controls_ToggleButtonState().default).UP(selected));
			}
		} else {
			this.changeState((feathers_controls_ToggleButtonState().default).DISABLED(this._selected));
		}
		return this._enabled;
	},
	get_selected: function() {
		return this._selected;
	},
	set_selected: function(value) {
		if(this._selected == value) {
			return this._selected;
		}
		this._selected = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		this.setInvalid((feathers_core_InvalidationFlag().default).STATE);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		this.changeState(this.get_currentState());
		return this._selected;
	},
	get_toggleable: function() {
		return this._toggleable;
	},
	set_toggleable: function(value) {
		if(this._toggleable == value) {
			return this._toggleable;
		}
		this._toggleable = value;
		return this._toggleable;
	},
	getSkinForState: function(state) {
		return this._stateToSkin.get(state);
	},
	setSkinForState: function(state,skin) {
		if(!this.setStyle("setSkinForState",state)) {
			return;
		}
		var oldSkin = this._stateToSkin.get(state);
		if(oldSkin != null && oldSkin == this._currentBackgroundSkin) {
			this.removeCurrentBackgroundSkin(oldSkin);
			this._currentBackgroundSkin = null;
		}
		if(skin == null) {
			this._stateToSkin.remove(state);
		} else {
			this._stateToSkin.set(state,skin);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	initialize: function() {
		(feathers_core_FeathersControl().default).prototype.initialize.call(this);
		if(this._pointerToState == null) {
			this._pointerToState = new (feathers_utils_PointerToState().default)(this,$bind(this,this.changeState),(feathers_controls_ToggleButtonState().default).UP(false),(feathers_controls_ToggleButtonState().default).DOWN(false),(feathers_controls_ToggleButtonState().default).HOVER(false));
		}
		if(this._keyToState == null) {
			this._keyToState = new (feathers_utils_KeyToState().default)(this,$bind(this,this.changeState),(feathers_controls_ToggleButtonState().default).UP(false),(feathers_controls_ToggleButtonState().default).DOWN(false));
		}
		if(this._pointerTrigger == null) {
			this._pointerTrigger = new (feathers_utils_PointerTrigger().default)(this);
		}
	},
	update: function() {
		this.commitChanges();
		this.measure();
		this.layoutContent();
	},
	commitChanges: function() {
		var selectionInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		if(selectionInvalid || stateInvalid || stylesInvalid) {
			this.refreshBackgroundSkin();
		}
		if(stylesInvalid) {
			this.refreshInteractivity();
		}
	},
	refreshInteractivity: function() {
		this._pointerToState.set_keepDownStateOnRollOut(this.get_keepDownStateOnRollOut());
	},
	refreshBackgroundSkin: function() {
		var oldSkin = this._currentBackgroundSkin;
		this._currentBackgroundSkin = this.getCurrentBackgroundSkin();
		if(this._currentBackgroundSkin == oldSkin) {
			return;
		}
		this.removeCurrentBackgroundSkin(oldSkin);
		this.addCurrentBackgroundSkin(this._currentBackgroundSkin);
	},
	getCurrentBackgroundSkin: function() {
		var result = this._stateToSkin.get(this._currentState);
		if(result != null) {
			return result;
		}
		if(this._selected && this.get_selectedBackgroundSkin() != null) {
			return this.get_selectedBackgroundSkin();
		}
		return this.get_backgroundSkin();
	},
	addCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			this._backgroundSkinMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._backgroundSkinMeasurements == null) {
			this._backgroundSkinMeasurements = new (feathers_layout_Measurements().default)(skin);
		} else {
			this._backgroundSkinMeasurements.save(skin);
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IStateObserver().default))).set_stateContext(this);
		}
		this.addChildAt(skin,0);
	},
	removeCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IStateObserver().default))).set_stateContext(null);
		}
		this._backgroundSkinMeasurements.restore(skin);
		if(skin.parent == this) {
			this.removeChild(skin);
		}
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		if(this._currentBackgroundSkin != null) {
			(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParent(this._backgroundSkinMeasurements,this._currentBackgroundSkin,this);
		}
		var measureSkin = null;
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IMeasureObject().default))) {
			measureSkin = (js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IMeasureObject().default));
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			if(this._currentBackgroundSkin != null) {
				newWidth = this._currentBackgroundSkin.get_width();
			} else {
				newWidth = 0.0;
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			if(this._currentBackgroundSkin != null) {
				newHeight = this._currentBackgroundSkin.get_height();
			} else {
				newHeight = 0.0;
			}
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			if(measureSkin != null) {
				newMinWidth = measureSkin.get_minWidth();
			} else if(this._backgroundSkinMeasurements != null) {
				newMinWidth = this._backgroundSkinMeasurements.minWidth;
			} else {
				newMinWidth = 0.0;
			}
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			if(measureSkin != null) {
				newMinHeight = measureSkin.get_minHeight();
			} else if(this._backgroundSkinMeasurements != null) {
				newMinHeight = this._backgroundSkinMeasurements.minHeight;
			} else {
				newMinHeight = 0.0;
			}
		}
		var newMaxWidth = this.get_explicitMaxWidth();
		if(needsMaxWidth) {
			if(measureSkin != null) {
				newMaxWidth = measureSkin.get_maxWidth();
			} else if(this._backgroundSkinMeasurements != null) {
				newMaxWidth = this._backgroundSkinMeasurements.maxWidth;
			} else {
				newMaxWidth = 1.0 / 0.0;
			}
		}
		var newMaxHeight = this.get_explicitMaxHeight();
		if(needsMaxHeight) {
			if(measureSkin != null) {
				newMaxHeight = measureSkin.get_maxHeight();
			} else if(this._backgroundSkinMeasurements != null) {
				newMaxHeight = this._backgroundSkinMeasurements.maxHeight;
			} else {
				newMaxHeight = 1.0 / 0.0;
			}
		}
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight,newMaxWidth,newMaxHeight);
	},
	layoutContent: function() {
		this.layoutBackgroundSkin();
	},
	layoutBackgroundSkin: function() {
		if(this._currentBackgroundSkin == null) {
			return;
		}
		this._currentBackgroundSkin.set_x(0.0);
		this._currentBackgroundSkin.set_y(0.0);
		if(this._currentBackgroundSkin.get_width() != this.actualWidth) {
			this._currentBackgroundSkin.set_width(this.actualWidth);
		}
		if(this._currentBackgroundSkin.get_height() != this.actualHeight) {
			this._currentBackgroundSkin.set_height(this.actualHeight);
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
	},
	changeState: function(state) {
		var toggleState = (js_Boot().default).__cast(state , (feathers_controls_ToggleButtonState().default));
		if(!this._enabled) {
			toggleState = (feathers_controls_ToggleButtonState().default).DISABLED(this._selected);
		}
		switch(toggleState._hx_index) {
		case 0:
			var selected = toggleState.selected;
			if(this._selected != selected) {
				toggleState = (feathers_controls_ToggleButtonState().default).UP(this._selected);
			}
			break;
		case 1:
			var selected1 = toggleState.selected;
			if(this._selected != selected1) {
				toggleState = (feathers_controls_ToggleButtonState().default).HOVER(this._selected);
			}
			break;
		case 2:
			var selected2 = toggleState.selected;
			if(this._selected != selected2) {
				toggleState = (feathers_controls_ToggleButtonState().default).DOWN(this._selected);
			}
			break;
		case 3:
			var selected3 = toggleState.selected;
			if(this._selected != selected3) {
				toggleState = (feathers_controls_ToggleButtonState().default).DISABLED(this._selected);
			}
			break;
		}
		if(this._currentState == toggleState) {
			return;
		}
		this._currentState = toggleState;
		this.setInvalid((feathers_core_InvalidationFlag().default).STATE);
		(feathers_events_FeathersEvent().default).dispatch(this,"stateChange");
	},
	basicToggleButton_clickHandler: function(event) {
		if(!this._enabled) {
			event.stopImmediatePropagation();
			return;
		}
	},
	basicToggleButton_touchTapHandler: function(event) {
		if(!this._enabled) {
			event.stopImmediatePropagation();
			return;
		}
	},
	basicToggleButton_triggerHandler: function(event) {
		if(!this._enabled || !this._toggleable) {
			return;
		}
		this.set_selected(!this._selected);
	},
	get_keepDownStateOnRollOut: function() {
		return this.__keepDownStateOnRollOut;
	},
	set_keepDownStateOnRollOut: function(value) {
		if(!this.setStyle("keepDownStateOnRollOut")) {
			return this.__keepDownStateOnRollOut;
		}
		if(this.__keepDownStateOnRollOut == value) {
			return this.__keepDownStateOnRollOut;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_keepDownStateOnRollOut);
		this.__keepDownStateOnRollOut = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__keepDownStateOnRollOut;
	},
	clearStyle_keepDownStateOnRollOut: function() {
		this.set_keepDownStateOnRollOut(false);
		return this.get_keepDownStateOnRollOut();
	},
	get_backgroundSkin: function() {
		return this.__backgroundSkin;
	},
	set_backgroundSkin: function(value) {
		if(!this.setStyle("backgroundSkin")) {
			return this.__backgroundSkin;
		}
		if(this.__backgroundSkin == value) {
			return this.__backgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_backgroundSkin);
		this.__backgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__backgroundSkin;
	},
	clearStyle_backgroundSkin: function() {
		this.set_backgroundSkin(null);
		return this.get_backgroundSkin();
	},
	get_selectedBackgroundSkin: function() {
		return this.__selectedBackgroundSkin;
	},
	set_selectedBackgroundSkin: function(value) {
		if(!this.setStyle("selectedBackgroundSkin")) {
			return this.__selectedBackgroundSkin;
		}
		if(this.__selectedBackgroundSkin == value) {
			return this.__selectedBackgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_selectedBackgroundSkin);
		this.__selectedBackgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__selectedBackgroundSkin;
	},
	clearStyle_selectedBackgroundSkin: function() {
		this.set_selectedBackgroundSkin(null);
		return this.get_selectedBackgroundSkin();
	}
});
BasicToggleButton.prototype.__class__ = BasicToggleButton.prototype.constructor = $hxClasses["feathers.controls.BasicToggleButton"] = BasicToggleButton;

// Init



// Statics


BasicToggleButton.__meta__ = { fields : { setSkinForState : { style : null}}}

// Export

exports["default"] = BasicToggleButton;

/***/ }),

/***/ "./lib/_gen/feathers/controls/Button.js":
/*!**********************************************!*\
  !*** ./lib/_gen/feathers/controls/Button.js ***!
  \**********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.Button

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}
function feathers_core_IHTMLTextControl() {return __webpack_require__(/*! ./../../feathers/core/IHTMLTextControl */ "./lib/_gen/feathers/core/IHTMLTextControl.js");}
function feathers_core_ITextControl() {return __webpack_require__(/*! ./../../feathers/core/ITextControl */ "./lib/_gen/feathers/core/ITextControl.js");}
function feathers_controls_BasicButton() {return __webpack_require__(/*! ./../../feathers/controls/BasicButton */ "./lib/_gen/feathers/controls/BasicButton.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_themes_steel_components_SteelButtonStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelButtonStyles */ "./lib/_gen/feathers/themes/steel/components/SteelButtonStyles.js");}
function openfl_text_TextField() {return (__webpack_require__(/*! openfl */ "openfl").text.TextField);}
function feathers_utils_MeasurementsUtil() {return __webpack_require__(/*! ./../../feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_core_IStateObserver() {return __webpack_require__(/*! ./../../feathers/core/IStateObserver */ "./lib/_gen/feathers/core/IStateObserver.js");}
function openfl_events_MouseEvent() {return (__webpack_require__(/*! openfl */ "openfl").events.MouseEvent);}
function haxe_ds_EnumValueMap() {return __webpack_require__(/*! ./../../haxe/ds/EnumValueMap */ "./lib/_gen/haxe/ds/EnumValueMap.js");}

// Constructor

var Button = function(text,triggerListener) {
	this.__showText = true;
	this.__textOffsetY = 0.0;
	this.__textOffsetX = 0.0;
	this.__iconOffsetY = 0.0;
	this.__iconOffsetX = 0.0;
	this.__minGap = 0.0;
	this.__gap = 0.0;
	this.__iconPosition = (feathers_layout_RelativePosition().default).LEFT;
	this.__verticalAlign = (feathers_layout_VerticalAlign().default).MIDDLE;
	this.__horizontalAlign = (feathers_layout_HorizontalAlign().default).CENTER;
	this.__paddingLeft = 0.0;
	this.__paddingBottom = 0.0;
	this.__paddingRight = 0.0;
	this.__paddingTop = 0.0;
	this.__icon = null;
	this.__wordWrap = false;
	this.__embedFonts = false;
	this.__disabledTextFormat = null;
	this.__textFormat = null;
	this._stateToTextFormat = new (haxe_ds_EnumValueMap().default)();
	this._wrappedOnMeasure = false;
	this._ignoreIconResizes = false;
	this._currentIcon = null;
	this._iconMeasurements = null;
	this._stateToIcon = new (haxe_ds_EnumValueMap().default)();
	this._htmlText = null;
	this._updatedTextStyles = false;
	this._previousSimpleTextFormat = null;
	this._previousTextFormat = null;
	this._previousHTMLText = null;
	this._previousText = null;
	this.initializeButtonTheme();
	(feathers_controls_BasicButton().default).call(this,triggerListener);
	this.set_text(text);
	this.set_tabEnabled(true);
	this.set_tabChildren(false);
	this.focusRect = false;
	this.addEventListener("keyDown",$bind(this,this.button_keyDownHandler));
	this.addEventListener("focusIn",$bind(this,this.button_focusInHandler));
	this.addEventListener("focusOut",$bind(this,this.button_focusOutHandler));
}

// Meta

Button.__name__ = "feathers.controls.Button";
Button.__isInterface__ = false;
Button.__interfaces__ = [(feathers_core_IFocusObject().default),(feathers_core_IHTMLTextControl().default),(feathers_core_ITextControl().default)];
Button.__super__ = (feathers_controls_BasicButton().default);
Button.prototype = $extend((feathers_controls_BasicButton().default).prototype, {
	get_text: function() {
		return this._text;
	},
	set_text: function(value) {
		if(this._text == value) {
			return this._text;
		}
		this._text = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._text;
	},
	get_htmlText: function() {
		return this._htmlText;
	},
	set_htmlText: function(value) {
		if(this._htmlText == value) {
			return this._htmlText;
		}
		this._htmlText = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._htmlText;
	},
	get_baseline: function() {
		if(this.textField == null) {
			return 0.0;
		}
		var hasText = this._text != null && this._text.length > 0;
		var hasHTMLText = this._htmlText != null && this._htmlText.length > 0;
		if(!this.get_showText() || !hasText && !hasHTMLText) {
			var textFieldY = this.textField.get_y();
			if(!this.get_showText() || this._text == null && this._htmlText == null) {
				if(this._currentIcon != null) {
					textFieldY = this._currentIcon.get_y() + (this._currentIcon.get_height() - this._textMeasuredHeight) / 2.0;
				} else if(this._currentBackgroundSkin != null) {
					textFieldY = (this._currentBackgroundSkin.get_height() - this._textMeasuredHeight) / 2.0;
				} else {
					return 0.0;
				}
			}
			this.textField.set_text("​");
			var textFieldBaseline = textFieldY + this.textField.getLineMetrics(0).ascent;
			this.textField.set_text("");
			return textFieldBaseline;
		}
		return this.textField.get_y() + this.textField.getLineMetrics(0).ascent;
	},
	getTextFormatForState: function(state) {
		return this._stateToTextFormat.get(state);
	},
	setTextFormatForState: function(state,textFormat) {
		if(!this.setStyle("setTextFormatForState",state)) {
			return;
		}
		if(textFormat == null) {
			this._stateToTextFormat.remove(state);
		} else {
			this._stateToTextFormat.set(state,textFormat);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	getIconForState: function(state) {
		return this._stateToIcon.get(state);
	},
	setIconForState: function(state,icon) {
		if(!this.setStyle("setIconForState",state)) {
			return;
		}
		var oldIcon = this._stateToIcon.get(state);
		if(oldIcon != null && oldIcon == this._currentIcon) {
			this.removeCurrentIcon(oldIcon);
			this._currentIcon = null;
		}
		if(icon == null) {
			this._stateToIcon.remove(state);
		} else {
			this._stateToIcon.set(state,icon);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	initializeButtonTheme: function() {
		(feathers_themes_steel_components_SteelButtonStyles().default).initialize();
	},
	initialize: function() {
		(feathers_controls_BasicButton().default).prototype.initialize.call(this);
		if(this.textField == null) {
			this.textField = new (openfl_text_TextField())();
			this.textField.set_selectable(false);
			this.textField.set_multiline(true);
			this.addChild(this.textField);
		}
	},
	commitChanges: function() {
		(feathers_controls_BasicButton().default).prototype.commitChanges.call(this);
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var sizeInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SIZE);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		this._updatedTextStyles = false;
		if(stylesInvalid || stateInvalid) {
			this.refreshIcon();
		}
		if(stylesInvalid || stateInvalid) {
			this.refreshTextStyles();
		}
		if(dataInvalid || stylesInvalid || stateInvalid || sizeInvalid) {
			this.refreshText(sizeInvalid);
		}
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		var hasText = this.get_showText() && this._text != null;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		if(hasText || hasHTMLText) {
			this.refreshTextFieldDimensions(true);
		}
		if(this._currentBackgroundSkin != null) {
			(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParent(this._backgroundSkinMeasurements,this._currentBackgroundSkin,this);
		}
		var measureSkin = null;
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IMeasureObject().default))) {
			measureSkin = (js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IMeasureObject().default));
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
		if((js_Boot().default).__implements(this._currentIcon,(feathers_core_IValidating().default))) {
			var oldIgnoreIconResizes = this._ignoreIconResizes;
			this._ignoreIconResizes = true;
			((js_Boot().default).__cast(this._currentIcon , (feathers_core_IValidating().default))).validateNow();
			this._ignoreIconResizes = oldIgnoreIconResizes;
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			newWidth = this.measureContentWidth();
			newWidth += this.get_paddingLeft() + this.get_paddingRight();
			if(this._currentBackgroundSkin != null) {
				newWidth = Math.max(this._currentBackgroundSkin.get_width(),newWidth);
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			newHeight = this.measureContentHeight();
			newHeight += this.get_paddingTop() + this.get_paddingBottom();
			if(this._currentBackgroundSkin != null) {
				newHeight = Math.max(this._currentBackgroundSkin.get_height(),newHeight);
			}
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			newMinWidth = this.measureContentMinWidth();
			newMinWidth += this.get_paddingLeft() + this.get_paddingRight();
			if(measureSkin != null) {
				newMinWidth = Math.max(measureSkin.get_minWidth(),newMinWidth);
			} else if(this._backgroundSkinMeasurements != null) {
				newMinWidth = Math.max(this._backgroundSkinMeasurements.minWidth,newMinWidth);
			}
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			newMinHeight = this.measureContentMinHeight();
			newMinHeight += this.get_paddingTop() + this.get_paddingBottom();
			if(measureSkin != null) {
				newMinHeight = Math.max(measureSkin.get_minHeight(),newMinHeight);
			} else if(this._backgroundSkinMeasurements != null) {
				newMinHeight = Math.max(this._backgroundSkinMeasurements.minHeight,newMinHeight);
			}
		}
		var newMaxWidth = this.get_explicitMaxWidth();
		if(needsMaxWidth) {
			if(measureSkin != null) {
				newMaxWidth = measureSkin.get_maxWidth();
			} else if(this._backgroundSkinMeasurements != null) {
				newMaxWidth = this._backgroundSkinMeasurements.maxWidth;
			} else {
				newMaxWidth = 1.0 / 0.0;
			}
		}
		var newMaxHeight = this.get_explicitMaxHeight();
		if(needsMaxHeight) {
			if(measureSkin != null) {
				newMaxHeight = measureSkin.get_maxHeight();
			} else if(this._backgroundSkinMeasurements != null) {
				newMaxHeight = this._backgroundSkinMeasurements.maxHeight;
			} else {
				newMaxHeight = 1.0 / 0.0;
			}
		}
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight,newMaxWidth,newMaxHeight);
	},
	calculateExplicitWidthForTextMeasurement: function() {
		var textFieldExplicitWidth = null;
		if(this.get_explicitWidth() != null) {
			textFieldExplicitWidth = this.get_explicitWidth();
		} else if(this.get_explicitMaxWidth() != null) {
			textFieldExplicitWidth = this.get_explicitMaxWidth();
		} else if(this._backgroundSkinMeasurements != null && this._backgroundSkinMeasurements.maxWidth != null) {
			textFieldExplicitWidth = this._backgroundSkinMeasurements.maxWidth;
		}
		if(textFieldExplicitWidth == null) {
			return textFieldExplicitWidth;
		}
		textFieldExplicitWidth -= this.get_paddingLeft() + this.get_paddingRight();
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		if(this._currentIcon != null) {
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				if((js_Boot().default).__implements(this._currentIcon,(feathers_core_IValidating().default))) {
					((js_Boot().default).__cast(this._currentIcon , (feathers_core_IValidating().default))).validateNow();
				}
				textFieldExplicitWidth -= this._currentIcon.get_width() + adjustedGap;
			}
		}
		if(textFieldExplicitWidth < 0.0) {
			textFieldExplicitWidth = 0.0;
		}
		return textFieldExplicitWidth;
	},
	measureContentWidth: function() {
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		var hasText = this.get_showText() && this._text != null;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		var contentWidth = hasText || hasHTMLText ? this._textMeasuredWidth : 0.0;
		if(this._currentIcon != null) {
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				if(hasText || hasHTMLText) {
					contentWidth += adjustedGap;
				}
				contentWidth += this._currentIcon.get_width();
			} else if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP || this.get_iconPosition() == (feathers_layout_RelativePosition().default).BOTTOM) {
				contentWidth = Math.max(contentWidth,this._currentIcon.get_width());
			}
		}
		return contentWidth;
	},
	measureContentHeight: function() {
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		var hasText = this.get_showText() && this._text != null;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		var contentHeight = hasText || hasHTMLText ? this._textMeasuredHeight : 0.0;
		if(this._currentIcon != null) {
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP || this.get_iconPosition() == (feathers_layout_RelativePosition().default).BOTTOM) {
				if(hasText || hasHTMLText) {
					contentHeight += adjustedGap;
				}
				contentHeight += this._currentIcon.get_height();
			} else if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				contentHeight = Math.max(contentHeight,this._currentIcon.get_height());
			}
		}
		return contentHeight;
	},
	measureContentMinWidth: function() {
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		var hasText = this.get_showText() && this._text != null;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		var contentMinWidth = hasText || hasHTMLText ? this._textMeasuredWidth : 0.0;
		if(this._currentIcon != null) {
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				if(hasText || hasHTMLText) {
					contentMinWidth += adjustedGap;
				}
				contentMinWidth += this._currentIcon.get_width();
			} else if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP || this.get_iconPosition() == (feathers_layout_RelativePosition().default).BOTTOM) {
				contentMinWidth = Math.max(contentMinWidth,this._currentIcon.get_width());
			}
		}
		return contentMinWidth;
	},
	measureContentMinHeight: function() {
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		var hasText = this.get_showText() && this._text != null;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		var contentMinHeight = hasText || hasHTMLText ? this._textMeasuredHeight : 0.0;
		if(this._currentIcon != null) {
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP || this.get_iconPosition() == (feathers_layout_RelativePosition().default).BOTTOM) {
				if(hasText || hasHTMLText) {
					contentMinHeight += adjustedGap;
				}
				contentMinHeight += this._currentIcon.get_height();
			} else if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				contentMinHeight = Math.max(contentMinHeight,this._currentIcon.get_height());
			}
		}
		return contentMinHeight;
	},
	refreshTextStyles: function() {
		if(this.textField.get_wordWrap() != this.get_wordWrap()) {
			this.textField.set_wordWrap(this.get_wordWrap());
			this._updatedTextStyles = true;
		}
		if(this.textField.get_embedFonts() != this.get_embedFonts()) {
			this.textField.set_embedFonts(this.get_embedFonts());
			this._updatedTextStyles = true;
		}
		var textFormat = this.getCurrentTextFormat();
		var simpleTextFormat = textFormat != null ? textFormat.toSimpleTextFormat() : null;
		if(simpleTextFormat == this._previousSimpleTextFormat) {
			return;
		}
		if(this._previousTextFormat != null) {
			this._previousTextFormat.removeEventListener("change",$bind(this,this.button_textFormat_changeHandler));
		}
		if(textFormat != null) {
			textFormat.addEventListener("change",$bind(this,this.button_textFormat_changeHandler),false,0,true);
			this.textField.set_defaultTextFormat(simpleTextFormat);
			this._updatedTextStyles = true;
		}
		this._previousTextFormat = textFormat;
		this._previousSimpleTextFormat = simpleTextFormat;
	},
	refreshText: function(forceMeasurement) {
		var hasText = this.get_showText() && this._text != null && this._text.length > 0;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		this.textField.set_visible(hasText || hasHTMLText);
		if(this._text == this._previousText && this._htmlText == this._previousHTMLText && !this._updatedTextStyles && !forceMeasurement) {
			return;
		}
		this.textField.set_autoSize("left");
		if(hasHTMLText) {
			this.textField.set_htmlText(this._htmlText);
		} else if(hasText) {
			this.textField.set_text(this._text);
		} else {
			this.textField.set_text("​");
		}
		if(this.get_wordWrap()) {
			this.textField.set_wordWrap(false);
		}
		this._textMeasuredWidth = this.textField.get_textWidth() + 4;
		this._wrappedOnMeasure = false;
		if(this.get_wordWrap()) {
			var textFieldExplicitWidth = this.calculateExplicitWidthForTextMeasurement();
			if(textFieldExplicitWidth != null && this._textMeasuredWidth > textFieldExplicitWidth) {
				this.textField.set_wordWrap(true);
				this.textField.set_width(textFieldExplicitWidth);
				this._textMeasuredWidth = this.textField.get_width();
				this._wrappedOnMeasure = true;
			}
		}
		this._textMeasuredHeight = this.textField.get_height();
		this.textField.set_autoSize("none");
		if(this.textField.get_wordWrap() != this.get_wordWrap()) {
			this.textField.set_wordWrap(this.get_wordWrap());
		}
		if(!hasText && !hasHTMLText) {
			this.textField.set_text("");
		}
		this._previousText = this._text;
		this._previousHTMLText = this._htmlText;
	},
	getCurrentTextFormat: function() {
		var result = this._stateToTextFormat.get(this._currentState);
		if(result != null) {
			return result;
		}
		if(!this._enabled && this.get_disabledTextFormat() != null) {
			return this.get_disabledTextFormat();
		}
		return this.get_textFormat();
	},
	layoutContent: function() {
		(feathers_controls_BasicButton().default).prototype.layoutContent.call(this);
		this.layoutChildren();
	},
	layoutChildren: function() {
		this.refreshTextFieldDimensions(false);
		var hasText = this.get_showText() && this._text != null;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		var iconIsInLayout = this._currentIcon != null && this.get_iconPosition() != (feathers_layout_RelativePosition().default).MANUAL;
		if((hasText || hasHTMLText) && iconIsInLayout) {
			this.positionSingleChild(this.textField);
			this.positionTextAndIcon();
		} else if(hasText || hasHTMLText) {
			this.positionSingleChild(this.textField);
		} else if(iconIsInLayout) {
			this.positionSingleChild(this._currentIcon);
		}
		if(this._currentIcon != null) {
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).MANUAL) {
				this._currentIcon.set_x(this.get_paddingLeft());
				this._currentIcon.set_y(this.get_paddingTop());
			}
			var _g = this._currentIcon;
			_g.set_x(_g.get_x() + this.get_iconOffsetX());
			var _g1 = this._currentIcon;
			_g1.set_y(_g1.get_y() + this.get_iconOffsetY());
		}
		if(hasText || hasHTMLText) {
			var _g2 = this.textField;
			_g2.set_x(_g2.get_x() + this.get_textOffsetX());
			var _g3 = this.textField;
			_g3.set_y(_g3.get_y() + this.get_textOffsetY());
		}
	},
	refreshTextFieldDimensions: function(forMeasurement) {
		var oldIgnoreIconResizes = this._ignoreIconResizes;
		this._ignoreIconResizes = true;
		if((js_Boot().default).__implements(this._currentIcon,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentIcon , (feathers_core_IValidating().default))).validateNow();
		}
		this._ignoreIconResizes = oldIgnoreIconResizes;
		var hasText = this.get_showText() && this._text != null;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		if(!hasText && !hasHTMLText) {
			return;
		}
		var calculatedWidth = this.actualWidth;
		var calculatedHeight = this.actualHeight;
		if(forMeasurement) {
			calculatedWidth = 0.0;
			var explicitCalculatedWidth = this.get_explicitWidth();
			if(explicitCalculatedWidth == null) {
				explicitCalculatedWidth = this.get_explicitMaxWidth();
			}
			if(explicitCalculatedWidth != null) {
				calculatedWidth = explicitCalculatedWidth;
			}
			calculatedHeight = 0.0;
			var explicitCalculatedHeight = this.get_explicitHeight();
			if(explicitCalculatedHeight == null) {
				explicitCalculatedHeight = this.get_explicitMaxHeight();
			}
			if(explicitCalculatedHeight != null) {
				calculatedHeight = explicitCalculatedHeight;
			}
		}
		calculatedWidth -= this.get_paddingLeft() + this.get_paddingRight();
		calculatedHeight -= this.get_paddingTop() + this.get_paddingBottom();
		if(this._currentIcon != null) {
			var adjustedGap = this.get_gap();
			if(adjustedGap == 1.0 / 0.0) {
				adjustedGap = this.get_minGap();
			}
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				calculatedWidth -= this._currentIcon.get_width() + adjustedGap;
			}
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP || this.get_iconPosition() == (feathers_layout_RelativePosition().default).BOTTOM) {
				calculatedHeight -= this._currentIcon.get_height() + adjustedGap;
			}
		}
		if(calculatedWidth < 0.0) {
			calculatedWidth = 0.0;
		}
		if(calculatedHeight < 0.0) {
			calculatedHeight = 0.0;
		}
		if(calculatedWidth > this._textMeasuredWidth) {
			calculatedWidth = this._textMeasuredWidth;
		}
		if(calculatedHeight > this._textMeasuredHeight) {
			calculatedHeight = this._textMeasuredHeight;
		}
		this.textField.set_width(calculatedWidth);
		var wordWrap = this.get_wordWrap();
		if(wordWrap && !this._wrappedOnMeasure && calculatedWidth >= this._textMeasuredWidth) {
			wordWrap = false;
		}
		if(this.textField.get_wordWrap() != wordWrap) {
			this.textField.set_wordWrap(wordWrap);
		}
		this.textField.set_height(calculatedHeight);
	},
	positionSingleChild: function(displayObject) {
		if(this.get_horizontalAlign() == (feathers_layout_HorizontalAlign().default).LEFT) {
			displayObject.set_x(this.get_paddingLeft());
		} else if(this.get_horizontalAlign() == (feathers_layout_HorizontalAlign().default).RIGHT) {
			displayObject.set_x(this.actualWidth - this.get_paddingRight() - displayObject.get_width());
		} else {
			displayObject.set_x(this.get_paddingLeft() + (this.actualWidth - this.get_paddingLeft() - this.get_paddingRight() - displayObject.get_width()) / 2.0);
		}
		if(this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).TOP) {
			displayObject.set_y(this.get_paddingTop());
		} else if(this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).BOTTOM) {
			displayObject.set_y(this.actualHeight - this.get_paddingBottom() - displayObject.get_height());
		} else {
			displayObject.set_y(this.get_paddingTop() + (this.actualHeight - this.get_paddingTop() - this.get_paddingBottom() - displayObject.get_height()) / 2.0);
		}
	},
	positionTextAndIcon: function() {
		if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP) {
			if(this.get_gap() == 1.0 / 0.0) {
				this._currentIcon.set_y(this.get_paddingTop());
				this.textField.set_y(this.actualHeight - this.get_paddingBottom() - this.textField.get_height());
			} else {
				if(this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).TOP) {
					var _g = this.textField;
					_g.set_y(_g.get_y() + (this._currentIcon.get_height() + this.get_gap()));
				} else if(this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).MIDDLE) {
					var _g1 = this.textField;
					_g1.set_y(_g1.get_y() + (this._currentIcon.get_height() + this.get_gap()) / 2.0);
				}
				this._currentIcon.set_y(this.textField.get_y() - this._currentIcon.get_height() - this.get_gap());
			}
		} else if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
			if(this.get_gap() == 1.0 / 0.0) {
				this.textField.set_x(this.get_paddingLeft());
				this._currentIcon.set_x(this.actualWidth - this.get_paddingRight() - this._currentIcon.get_width());
			} else {
				if(this.get_horizontalAlign() == (feathers_layout_HorizontalAlign().default).RIGHT) {
					var _g2 = this.textField;
					_g2.set_x(_g2.get_x() - (this._currentIcon.get_width() + this.get_gap()));
				} else if(this.get_horizontalAlign() == (feathers_layout_HorizontalAlign().default).CENTER) {
					var _g3 = this.textField;
					_g3.set_x(_g3.get_x() - (this._currentIcon.get_width() + this.get_gap()) / 2.0);
				}
				this._currentIcon.set_x(this.textField.get_x() + this.textField.get_width() + this.get_gap());
			}
		} else if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).BOTTOM) {
			if(this.get_gap() == 1.0 / 0.0) {
				this.textField.set_y(this.get_paddingTop());
				this._currentIcon.set_y(this.actualHeight - this.get_paddingBottom() - this._currentIcon.get_height());
			} else {
				if(this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).BOTTOM) {
					var _g4 = this.textField;
					_g4.set_y(_g4.get_y() - (this._currentIcon.get_height() + this.get_gap()));
				} else if(this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).MIDDLE) {
					var _g5 = this.textField;
					_g5.set_y(_g5.get_y() - (this._currentIcon.get_height() + this.get_gap()) / 2.0);
				}
				this._currentIcon.set_y(this.textField.get_y() + this.textField.get_height() + this.get_gap());
			}
		} else if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT) {
			if(this.get_gap() == 1.0 / 0.0) {
				this._currentIcon.set_x(this.get_paddingLeft());
				this.textField.set_x(this.actualWidth - this.get_paddingRight() - this.textField.get_width());
			} else {
				if(this.get_horizontalAlign() == (feathers_layout_HorizontalAlign().default).LEFT) {
					var _g6 = this.textField;
					_g6.set_x(_g6.get_x() + (this.get_gap() + this._currentIcon.get_width()));
				} else if(this.get_horizontalAlign() == (feathers_layout_HorizontalAlign().default).CENTER) {
					var _g7 = this.textField;
					_g7.set_x(_g7.get_x() + (this.get_gap() + this._currentIcon.get_width()) / 2.0);
				}
				this._currentIcon.set_x(this.textField.get_x() - this.get_gap() - this._currentIcon.get_width());
			}
		}
		if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
			if(this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).TOP) {
				this._currentIcon.set_y(this.get_paddingTop());
			} else if(this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).BOTTOM) {
				this._currentIcon.set_y(this.actualHeight - this.get_paddingBottom() - this._currentIcon.get_height());
			} else {
				this._currentIcon.set_y(this.get_paddingTop() + (this.actualHeight - this.get_paddingTop() - this.get_paddingBottom() - this._currentIcon.get_height()) / 2.0);
			}
		} else if(this.get_horizontalAlign() == (feathers_layout_HorizontalAlign().default).LEFT) {
			this._currentIcon.set_x(this.get_paddingLeft());
		} else if(this.get_horizontalAlign() == (feathers_layout_HorizontalAlign().default).RIGHT) {
			this._currentIcon.set_x(this.actualWidth - this.get_paddingRight() - this._currentIcon.get_width());
		} else {
			this._currentIcon.set_x(this.get_paddingLeft() + (this.actualWidth - this.get_paddingLeft() - this.get_paddingRight() - this._currentIcon.get_width()) / 2.0);
		}
	},
	refreshIcon: function() {
		var oldIcon = this._currentIcon;
		this._currentIcon = this.getCurrentIcon();
		if(this._currentIcon == oldIcon) {
			return;
		}
		this.removeCurrentIcon(oldIcon);
		this.addCurrentIcon(this._currentIcon);
	},
	addCurrentIcon: function(icon) {
		if(icon == null) {
			this._iconMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(icon,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(icon , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._iconMeasurements == null) {
			this._iconMeasurements = new (feathers_layout_Measurements().default)(icon);
		} else {
			this._iconMeasurements.save(icon);
		}
		if((js_Boot().default).__implements(icon,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(icon , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		if((js_Boot().default).__implements(icon,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(icon , (feathers_core_IStateObserver().default))).set_stateContext(this);
		}
		icon.addEventListener("resize",$bind(this,this.button_icon_resizeHandler),false,0,true);
		var index = this.getChildIndex(this.textField);
		this.addChildAt(icon,index);
	},
	getCurrentIcon: function() {
		var result = this._stateToIcon.get(this._currentState);
		if(result != null) {
			return result;
		}
		return this.get_icon();
	},
	removeCurrentIcon: function(icon) {
		if(icon == null) {
			return;
		}
		icon.removeEventListener("resize",$bind(this,this.button_icon_resizeHandler));
		if((js_Boot().default).__implements(icon,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(icon , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		if((js_Boot().default).__implements(icon,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(icon , (feathers_core_IStateObserver().default))).set_stateContext(null);
		}
		this._iconMeasurements.restore(icon);
		if(icon.parent == this) {
			this.removeChild(icon);
		}
	},
	button_keyDownHandler: function(event) {
		if(!this._enabled || this.get_buttonMode() && this.focusRect == true) {
			return;
		}
		if(this._focusManager != null && this._focusManager.get_focus() != this) {
			return;
		}
		if(event.keyCode != 32 && event.keyCode != 13) {
			return;
		}
		event.preventDefault();
		this.dispatchEvent(new (openfl_events_MouseEvent())("click"));
	},
	button_focusInHandler: function(event) {
		this._keyToState.set_enabled(this._enabled);
	},
	button_focusOutHandler: function(event) {
		this._keyToState.set_enabled(false);
	},
	button_textFormat_changeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	button_icon_resizeHandler: function(event) {
		if(this._ignoreIconResizes) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	get_styleContext: function() {
		return Button
	},
	get_textFormat: function() {
		return this.__textFormat;
	},
	set_textFormat: function(value) {
		if(!this.setStyle("textFormat")) {
			return this.__textFormat;
		}
		if(this.__textFormat == value) {
			return this.__textFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_textFormat);
		this.__textFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__textFormat;
	},
	clearStyle_textFormat: function() {
		this.set_textFormat(null);
		return this.get_textFormat();
	},
	get_disabledTextFormat: function() {
		return this.__disabledTextFormat;
	},
	set_disabledTextFormat: function(value) {
		if(!this.setStyle("disabledTextFormat")) {
			return this.__disabledTextFormat;
		}
		if(this.__disabledTextFormat == value) {
			return this.__disabledTextFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledTextFormat);
		this.__disabledTextFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledTextFormat;
	},
	clearStyle_disabledTextFormat: function() {
		this.set_disabledTextFormat(null);
		return this.get_disabledTextFormat();
	},
	get_embedFonts: function() {
		return this.__embedFonts;
	},
	set_embedFonts: function(value) {
		if(!this.setStyle("embedFonts")) {
			return this.__embedFonts;
		}
		if(this.__embedFonts == value) {
			return this.__embedFonts;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_embedFonts);
		this.__embedFonts = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__embedFonts;
	},
	clearStyle_embedFonts: function() {
		this.set_embedFonts(false);
		return this.get_embedFonts();
	},
	get_wordWrap: function() {
		return this.__wordWrap;
	},
	set_wordWrap: function(value) {
		if(!this.setStyle("wordWrap")) {
			return this.__wordWrap;
		}
		if(this.__wordWrap == value) {
			return this.__wordWrap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_wordWrap);
		this.__wordWrap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__wordWrap;
	},
	clearStyle_wordWrap: function() {
		this.set_wordWrap(false);
		return this.get_wordWrap();
	},
	get_icon: function() {
		return this.__icon;
	},
	set_icon: function(value) {
		if(!this.setStyle("icon")) {
			return this.__icon;
		}
		if(this.__icon == value) {
			return this.__icon;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_icon);
		this.__icon = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__icon;
	},
	clearStyle_icon: function() {
		this.set_icon(null);
		return this.get_icon();
	},
	get_paddingTop: function() {
		return this.__paddingTop;
	},
	set_paddingTop: function(value) {
		if(!this.setStyle("paddingTop")) {
			return this.__paddingTop;
		}
		if(this.__paddingTop == value) {
			return this.__paddingTop;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingTop);
		this.__paddingTop = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingTop;
	},
	clearStyle_paddingTop: function() {
		this.set_paddingTop(0.0);
		return this.get_paddingTop();
	},
	get_paddingRight: function() {
		return this.__paddingRight;
	},
	set_paddingRight: function(value) {
		if(!this.setStyle("paddingRight")) {
			return this.__paddingRight;
		}
		if(this.__paddingRight == value) {
			return this.__paddingRight;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingRight);
		this.__paddingRight = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingRight;
	},
	clearStyle_paddingRight: function() {
		this.set_paddingRight(0.0);
		return this.get_paddingRight();
	},
	get_paddingBottom: function() {
		return this.__paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(!this.setStyle("paddingBottom")) {
			return this.__paddingBottom;
		}
		if(this.__paddingBottom == value) {
			return this.__paddingBottom;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingBottom);
		this.__paddingBottom = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingBottom;
	},
	clearStyle_paddingBottom: function() {
		this.set_paddingBottom(0.0);
		return this.get_paddingBottom();
	},
	get_paddingLeft: function() {
		return this.__paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(!this.setStyle("paddingLeft")) {
			return this.__paddingLeft;
		}
		if(this.__paddingLeft == value) {
			return this.__paddingLeft;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingLeft);
		this.__paddingLeft = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingLeft;
	},
	clearStyle_paddingLeft: function() {
		this.set_paddingLeft(0.0);
		return this.get_paddingLeft();
	},
	get_horizontalAlign: function() {
		return this.__horizontalAlign;
	},
	set_horizontalAlign: function(value) {
		if(!this.setStyle("horizontalAlign")) {
			return this.__horizontalAlign;
		}
		if(this.__horizontalAlign == value) {
			return this.__horizontalAlign;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_horizontalAlign);
		this.__horizontalAlign = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__horizontalAlign;
	},
	clearStyle_horizontalAlign: function() {
		this.set_horizontalAlign((feathers_layout_HorizontalAlign().default).CENTER);
		return this.get_horizontalAlign();
	},
	get_verticalAlign: function() {
		return this.__verticalAlign;
	},
	set_verticalAlign: function(value) {
		if(!this.setStyle("verticalAlign")) {
			return this.__verticalAlign;
		}
		if(this.__verticalAlign == value) {
			return this.__verticalAlign;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_verticalAlign);
		this.__verticalAlign = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__verticalAlign;
	},
	clearStyle_verticalAlign: function() {
		this.set_verticalAlign((feathers_layout_VerticalAlign().default).MIDDLE);
		return this.get_verticalAlign();
	},
	get_iconPosition: function() {
		return this.__iconPosition;
	},
	set_iconPosition: function(value) {
		if(!this.setStyle("iconPosition")) {
			return this.__iconPosition;
		}
		if(this.__iconPosition == value) {
			return this.__iconPosition;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_iconPosition);
		this.__iconPosition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__iconPosition;
	},
	clearStyle_iconPosition: function() {
		this.set_iconPosition((feathers_layout_RelativePosition().default).LEFT);
		return this.get_iconPosition();
	},
	get_gap: function() {
		return this.__gap;
	},
	set_gap: function(value) {
		if(!this.setStyle("gap")) {
			return this.__gap;
		}
		if(this.__gap == value) {
			return this.__gap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_gap);
		this.__gap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__gap;
	},
	clearStyle_gap: function() {
		this.set_gap(0.0);
		return this.get_gap();
	},
	get_minGap: function() {
		return this.__minGap;
	},
	set_minGap: function(value) {
		if(!this.setStyle("minGap")) {
			return this.__minGap;
		}
		if(this.__minGap == value) {
			return this.__minGap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_minGap);
		this.__minGap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__minGap;
	},
	clearStyle_minGap: function() {
		this.set_minGap(0.0);
		return this.get_minGap();
	},
	get_iconOffsetX: function() {
		return this.__iconOffsetX;
	},
	set_iconOffsetX: function(value) {
		if(!this.setStyle("iconOffsetX")) {
			return this.__iconOffsetX;
		}
		if(this.__iconOffsetX == value) {
			return this.__iconOffsetX;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_iconOffsetX);
		this.__iconOffsetX = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__iconOffsetX;
	},
	clearStyle_iconOffsetX: function() {
		this.set_iconOffsetX(0.0);
		return this.get_iconOffsetX();
	},
	get_iconOffsetY: function() {
		return this.__iconOffsetY;
	},
	set_iconOffsetY: function(value) {
		if(!this.setStyle("iconOffsetY")) {
			return this.__iconOffsetY;
		}
		if(this.__iconOffsetY == value) {
			return this.__iconOffsetY;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_iconOffsetY);
		this.__iconOffsetY = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__iconOffsetY;
	},
	clearStyle_iconOffsetY: function() {
		this.set_iconOffsetY(0.0);
		return this.get_iconOffsetY();
	},
	get_textOffsetX: function() {
		return this.__textOffsetX;
	},
	set_textOffsetX: function(value) {
		if(!this.setStyle("textOffsetX")) {
			return this.__textOffsetX;
		}
		if(this.__textOffsetX == value) {
			return this.__textOffsetX;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_textOffsetX);
		this.__textOffsetX = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__textOffsetX;
	},
	clearStyle_textOffsetX: function() {
		this.set_textOffsetX(0.0);
		return this.get_textOffsetX();
	},
	get_textOffsetY: function() {
		return this.__textOffsetY;
	},
	set_textOffsetY: function(value) {
		if(!this.setStyle("textOffsetY")) {
			return this.__textOffsetY;
		}
		if(this.__textOffsetY == value) {
			return this.__textOffsetY;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_textOffsetY);
		this.__textOffsetY = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__textOffsetY;
	},
	clearStyle_textOffsetY: function() {
		this.set_textOffsetY(0.0);
		return this.get_textOffsetY();
	},
	get_showText: function() {
		return this.__showText;
	},
	set_showText: function(value) {
		if(!this.setStyle("showText")) {
			return this.__showText;
		}
		if(this.__showText == value) {
			return this.__showText;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_showText);
		this.__showText = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__showText;
	},
	clearStyle_showText: function() {
		this.set_showText(true);
		return this.get_showText();
	}
});
Button.prototype.__class__ = Button.prototype.constructor = $hxClasses["feathers.controls.Button"] = Button;

// Init



// Statics


Button.__meta__ = { obj : { defaultXmlProperty : ["text"]}, fields : { setTextFormatForState : { style : null}, setIconForState : { style : null}}}
Button.VARIANT_PRIMARY = "primary"
Button.VARIANT_DANGER = "danger"

// Export

exports["default"] = Button;

/***/ }),

/***/ "./lib/_gen/feathers/controls/ButtonBar.js":
/*!*************************************************!*\
  !*** ./lib/_gen/feathers/controls/ButtonBar.js ***!
  \*************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.ButtonBar

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function haxe_ds_StringMap() {return __webpack_require__(/*! ./../../haxe/ds/StringMap */ "./lib/_gen/haxe/ds/StringMap.js");}
function feathers_themes_steel_components_SteelButtonBarStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelButtonBarStyles */ "./lib/_gen/feathers/themes/steel/components/SteelButtonBarStyles.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function Type() {return __webpack_require__(/*! ./../../Type */ "./lib/_gen/Type.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function feathers_controls__$ButtonBar_ButtonStorage() {return __webpack_require__(/*! ./../../feathers/controls/_ButtonBar/ButtonStorage */ "./lib/_gen/feathers/controls/_ButtonBar/ButtonStorage.js");}
function feathers_controls_dataRenderers_IDataRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/IDataRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IDataRenderer.js");}
function feathers_layout_ILayoutIndexObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutIndexObject */ "./lib/_gen/feathers/layout/ILayoutIndexObject.js");}
function feathers_controls_Button() {return __webpack_require__(/*! ./../../feathers/controls/Button */ "./lib/_gen/feathers/controls/Button.js");}
function feathers_events_ButtonBarEvent() {return __webpack_require__(/*! ./../../feathers/events/ButtonBarEvent */ "./lib/_gen/feathers/events/ButtonBarEvent.js");}
function feathers_data_ButtonBarItemState() {return __webpack_require__(/*! ./../../feathers/data/ButtonBarItemState */ "./lib/_gen/feathers/data/ButtonBarItemState.js");}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}
function haxe_ds_ObjectMap() {return __webpack_require__(/*! ./../../haxe/ds/ObjectMap */ "./lib/_gen/haxe/ds/ObjectMap.js");}
function feathers_utils_DisplayObjectRecycler() {return __webpack_require__(/*! ./../../feathers/utils/DisplayObjectRecycler */ "./lib/_gen/feathers/utils/DisplayObjectRecycler.js");}

// Constructor

var ButtonBar = function(dataProvider,itemTriggerListener) {
	this.__disabledBackgroundSkin = null;
	this.__backgroundSkin = null;
	this.__layout = null;
	this.__customButtonVariant = null;
	this._ignoreChildChanges = false;
	this._layoutResult = new (feathers_layout_LayoutBoundsResult().default)();
	this._layoutMeasurements = new (feathers_layout_Measurements().default)();
	this._backgroundSkinMeasurements = null;
	this._currentBackgroundSkin = null;
	this._ignoreSelectionChange = false;
	this._layoutItems = [];
	this._unrenderedData = [];
	this.itemStatePool = new (lime_utils_ObjectPool().default)(function() {
		return new (feathers_data_ButtonBarItemState().default)();
	});
	this.buttonToItemState = new (haxe_ds_ObjectMap().default)();
	this.dataToButton = new (haxe_ds_ObjectMap().default)();
	this._additionalStorage = null;
	this._defaultStorage = new (feathers_controls__$ButtonBar_ButtonStorage().default)(null,(feathers_utils_DisplayObjectRecycler().default).withClass((feathers_controls_Button().default)));
	this._recyclerMap = null;
	this._forceItemStateUpdate = false;
	this._previousCustomButtonVariant = null;
	this.initializeButtonBarTheme();
	(feathers_core_FeathersControl().default).call(this);
	this.set_dataProvider(dataProvider);
	if(itemTriggerListener != null) {
		this.addEventListener("itemTrigger",itemTriggerListener);
	}
}

// Meta

ButtonBar.__name__ = "feathers.controls.ButtonBar";
ButtonBar.__isInterface__ = false;
ButtonBar.__super__ = (feathers_core_FeathersControl().default);
ButtonBar.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_dataProvider: function() {
		return this._dataProvider;
	},
	set_dataProvider: function(value) {
		if(this._dataProvider == value) {
			return this._dataProvider;
		}
		if(this._dataProvider != null) {
			this._dataProvider.removeEventListener("change",$bind(this,this.buttonBar_dataProvider_changeHandler));
			this._dataProvider.removeEventListener("updateItem",$bind(this,this.buttonBar_dataProvider_updateItemHandler));
			this._dataProvider.removeEventListener("updateAll",$bind(this,this.buttonBar_dataProvider_updateAllHandler));
		}
		this._dataProvider = value;
		if(this._dataProvider != null) {
			this._dataProvider.addEventListener("change",$bind(this,this.buttonBar_dataProvider_changeHandler));
			this._dataProvider.addEventListener("updateItem",$bind(this,this.buttonBar_dataProvider_updateItemHandler));
			this._dataProvider.addEventListener("updateAll",$bind(this,this.buttonBar_dataProvider_updateAllHandler));
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._dataProvider;
	},
	get_buttonRecycler: function() {
		return this._defaultStorage.buttonRecycler;
	},
	set_buttonRecycler: function(value) {
		if(this._defaultStorage.buttonRecycler == value) {
			return this._defaultStorage.buttonRecycler;
		}
		this._defaultStorage.oldButtonRecycler = this._defaultStorage.buttonRecycler;
		this._defaultStorage.buttonRecycler = value;
		this.setInvalid(ButtonBar.INVALIDATION_FLAG_BUTTON_FACTORY);
		return this._defaultStorage.buttonRecycler;
	},
	get_forceItemStateUpdate: function() {
		return this._forceItemStateUpdate;
	},
	set_forceItemStateUpdate: function(value) {
		if(this._forceItemStateUpdate == value) {
			return this._forceItemStateUpdate;
		}
		this._forceItemStateUpdate = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._forceItemStateUpdate;
	},
	get_buttonRecyclerIDFunction: function() {
		return this._buttonRecyclerIDFunction;
	},
	set_buttonRecyclerIDFunction: function(value) {
		if(this._buttonRecyclerIDFunction == value) {
			return this._buttonRecyclerIDFunction;
		}
		this._buttonRecyclerIDFunction = value;
		this.setInvalid(ButtonBar.INVALIDATION_FLAG_BUTTON_FACTORY);
		return this._buttonRecyclerIDFunction;
	},
	itemToText: function(data) {
		return (Std().default).string(data);
	},
	itemToEnabled: function(data) {
		return true;
	},
	itemToButton: function(item) {
		if(item == null) {
			return null;
		}
		return this.dataToButton.get(item);
	},
	indexToButton: function(index) {
		if(this._dataProvider == null || index < 0 || index >= this._dataProvider.get_length()) {
			return null;
		}
		var item = this._dataProvider.get(index);
		return this.dataToButton.get(item);
	},
	getButtonRecycler: function(id) {
		if(this._recyclerMap == null) {
			return null;
		}
		return this._recyclerMap.get(id);
	},
	setButtonRecycler: function(id,recycler) {
		if(this._recyclerMap == null) {
			this._recyclerMap = new (haxe_ds_StringMap().default)();
		}
		if(recycler == null) {
			this._recyclerMap.remove(id);
			return;
		}
		this._recyclerMap.set(id,recycler);
		this.setInvalid(ButtonBar.INVALIDATION_FLAG_BUTTON_FACTORY);
	},
	initializeButtonBarTheme: function() {
		(feathers_themes_steel_components_SteelButtonBarStyles().default).initialize();
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var layoutInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		var selectionInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(this._previousCustomButtonVariant != this.get_customButtonVariant()) {
			this.setInvalidationFlag(ButtonBar.INVALIDATION_FLAG_BUTTON_FACTORY);
		}
		var buttonsInvalid = this.isInvalid(ButtonBar.INVALIDATION_FLAG_BUTTON_FACTORY);
		if(stylesInvalid || stateInvalid) {
			this.refreshBackgroundSkin();
		}
		if(buttonsInvalid || selectionInvalid || stateInvalid || dataInvalid) {
			this.refreshButtons();
		}
		this.refreshViewPortBounds();
		this.handleLayout();
		this.handleLayoutResult();
		this.layoutBackgroundSkin();
		this.validateChildren();
		this._previousCustomButtonVariant = this.get_customButtonVariant();
	},
	refreshViewPortBounds: function() {
		this._layoutMeasurements.save(this);
	},
	handleLayout: function() {
		var oldIgnoreChildChanges = this._ignoreChildChanges;
		this._ignoreChildChanges = true;
		this._layoutResult.reset();
		if(this.get_layout() != null) {
			this.get_layout().layout(this._layoutItems,this._layoutMeasurements,this._layoutResult);
		}
		this._ignoreChildChanges = oldIgnoreChildChanges;
	},
	handleLayoutResult: function() {
		var viewPortWidth = this._layoutResult.viewPortWidth;
		var viewPortHeight = this._layoutResult.viewPortHeight;
		this.saveMeasurements(viewPortWidth,viewPortHeight,viewPortWidth,viewPortHeight);
	},
	validateChildren: function() {
		var _g = 0;
		var _g1 = this._layoutItems;
		while(_g < _g1.length) {
			var button = _g1[_g];
			++_g;
			if(!(js_Boot().default).__implements(button,(feathers_core_IValidating().default))) {
				return;
			}
			((js_Boot().default).__cast(button , (feathers_core_IValidating().default))).validateNow();
		}
	},
	refreshButtons: function() {
		if(this.get_buttonRecycler().update == null) {
			this.get_buttonRecycler().update = ButtonBar.defaultUpdateButton;
			if(this.get_buttonRecycler().reset == null) {
				this.get_buttonRecycler().reset = ButtonBar.defaultResetButton;
			}
		}
		if(this._recyclerMap != null) {
			var recycler = this._recyclerMap.iterator();
			while(recycler.hasNext()) {
				var recycler1 = recycler.next();
				if(recycler1.update == null) {
					if(recycler1.update == null) {
						recycler1.update = ButtonBar.defaultUpdateButton;
						if(recycler1.reset == null) {
							recycler1.reset = ButtonBar.defaultResetButton;
						}
					}
				}
			}
		}
		var buttonsInvalid = this.isInvalid(ButtonBar.INVALIDATION_FLAG_BUTTON_FACTORY);
		this.refreshInactiveButtons(this._defaultStorage,buttonsInvalid);
		if(this._additionalStorage != null) {
			var _g = 0;
			var _g1 = this._additionalStorage.length;
			while(_g < _g1) {
				var i = _g++;
				var storage = this._additionalStorage[i];
				this.refreshInactiveButtons(storage,buttonsInvalid);
			}
		}
		this.findUnrenderedData();
		this.recoverInactiveButtons(this._defaultStorage);
		if(this._additionalStorage != null) {
			var _g2 = 0;
			var _g11 = this._additionalStorage.length;
			while(_g2 < _g11) {
				var i1 = _g2++;
				var storage1 = this._additionalStorage[i1];
				this.recoverInactiveButtons(storage1);
			}
		}
		this.renderUnrenderedData();
		this.freeInactiveButtons(this._defaultStorage);
		if(this._defaultStorage.inactiveButtons.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive buttons should be empty after updating."));
		}
		if(this._additionalStorage != null) {
			var _g3 = 0;
			var _g12 = this._additionalStorage.length;
			while(_g3 < _g12) {
				var i2 = _g3++;
				var storage2 = this._additionalStorage[i2];
				this.freeInactiveButtons(storage2);
				if(storage2.inactiveButtons.length > 0) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive buttons " + storage2.id + " should be empty after updating."));
				}
			}
		}
	},
	refreshInactiveButtons: function(storage,factoryInvalid) {
		var temp = storage.inactiveButtons;
		storage.inactiveButtons = storage.activeButtons;
		storage.activeButtons = temp;
		if(storage.activeButtons.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": active buttons should be empty before updating."));
		}
		if(factoryInvalid) {
			this.recoverInactiveButtons(storage);
			this.freeInactiveButtons(storage);
		}
	},
	recoverInactiveButtons: function(storage) {
		var _g = 0;
		var _g1 = storage.inactiveButtons;
		while(_g < _g1.length) {
			var button = _g1[_g];
			++_g;
			if(button == null) {
				continue;
			}
			var state = this.buttonToItemState.get(button);
			if(state == null) {
				continue;
			}
			var item = state.data;
			this.buttonToItemState.remove(button);
			this.dataToButton.remove(item);
			button.removeEventListener("trigger",$bind(this,this.buttonBar_button_triggerHandler));
			this.resetButton(button,state);
			this.itemStatePool.release(state);
		}
	},
	freeInactiveButtons: function(storage) {
		var _g = 0;
		var _g1 = storage.inactiveButtons;
		while(_g < _g1.length) {
			var button = _g1[_g];
			++_g;
			if(button == null) {
				continue;
			}
			this.destroyButton(button);
		}
		storage.inactiveButtons.length = 0;
	},
	refreshBackgroundSkin: function() {
		var oldSkin = this._currentBackgroundSkin;
		this._currentBackgroundSkin = this.getCurrentBackgroundSkin();
		if(this._currentBackgroundSkin == oldSkin) {
			return;
		}
		this.removeCurrentBackgroundSkin(oldSkin);
		this.addCurrentBackgroundSkin(this._currentBackgroundSkin);
	},
	getCurrentBackgroundSkin: function() {
		if(!this._enabled && this.get_disabledBackgroundSkin() != null) {
			return this.get_disabledBackgroundSkin();
		}
		return this.get_backgroundSkin();
	},
	addCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			this._backgroundSkinMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._backgroundSkinMeasurements == null) {
			this._backgroundSkinMeasurements = new (feathers_layout_Measurements().default)(skin);
		} else {
			this._backgroundSkinMeasurements.save(skin);
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this.addChildAt(skin,0);
	},
	removeCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		this._backgroundSkinMeasurements.restore(skin);
		if(skin.parent == this) {
			this.removeChild(skin);
		}
	},
	layoutBackgroundSkin: function() {
		if(this._currentBackgroundSkin == null) {
			return;
		}
		this._currentBackgroundSkin.set_x(0.0);
		this._currentBackgroundSkin.set_y(0.0);
		if(this._currentBackgroundSkin.get_width() != this.actualWidth) {
			this._currentBackgroundSkin.set_width(this.actualWidth);
		}
		if(this._currentBackgroundSkin.get_height() != this.actualHeight) {
			this._currentBackgroundSkin.set_height(this.actualHeight);
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
	},
	findUnrenderedData: function() {
		this._layoutItems.length = 0;
		if(this._dataProvider == null || this._dataProvider.get_length() == 0) {
			return;
		}
		this._layoutItems.length = this._dataProvider.get_length();
		var depthOffset = this._currentBackgroundSkin != null ? 1 : 0;
		var _g = 0;
		var _g1 = this._dataProvider.get_length();
		while(_g < _g1) {
			var i = _g++;
			var item = this._dataProvider.get(i);
			var button = this.dataToButton.get(item);
			if(button != null) {
				var state = this.buttonToItemState.get(button);
				var changed = this.populateCurrentItemState(item,i,state,this._forceItemStateUpdate);
				var oldRecyclerID = state.recyclerID;
				var storage = this.itemStateToStorage(state);
				if(storage.id != oldRecyclerID) {
					this._unrenderedData.push(item);
					continue;
				}
				if(changed) {
					this.updateButton(button,state,storage);
				}
				this._layoutItems[i] = button;
				this.setChildIndex(button,i + depthOffset);
				var removed = (HxOverrides().default).remove(storage.inactiveButtons,button);
				if(!removed) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": button renderer map contains bad data for item at index " + i + ". This may be caused by duplicate items in the data provider, which is not allowed."));
				}
				storage.activeButtons.push(button);
			} else {
				this._unrenderedData.push(item);
			}
		}
	},
	renderUnrenderedData: function() {
		var depthOffset = this._currentBackgroundSkin != null ? 1 : 0;
		var _g = 0;
		var _g1 = this._unrenderedData;
		while(_g < _g1.length) {
			var item = _g1[_g];
			++_g;
			var index = this._dataProvider.indexOf(item);
			var state = this.itemStatePool.get();
			this.populateCurrentItemState(item,index,state,true);
			var button = this.createButton(state);
			this.addChildAt(button,index + depthOffset);
			this._layoutItems[index] = button;
		}
		this._unrenderedData.length = 0;
	},
	createButton: function(state) {
		var storage = this.itemStateToStorage(state);
		var button = null;
		if(storage.inactiveButtons.length == 0) {
			button = this.get_buttonRecycler().create();
			if(button.get_variant() == null) {
				var variant = this.get_customButtonVariant() != null ? this.get_customButtonVariant() : ButtonBar.CHILD_VARIANT_BUTTON;
				button.set_variant(variant);
			}
			button.initializeNow();
		} else {
			button = storage.inactiveButtons.shift();
		}
		this.updateButton(button,state,storage);
		button.addEventListener("trigger",$bind(this,this.buttonBar_button_triggerHandler));
		this.buttonToItemState.set(button,state);
		this.dataToButton.set(state.data,button);
		storage.activeButtons.push(button);
		return button;
	},
	destroyButton: function(button) {
		this.removeChild(button);
		if(this.get_buttonRecycler().destroy != null) {
			this.get_buttonRecycler().destroy(button);
		}
	},
	itemStateToStorage: function(state) {
		var recyclerID = null;
		if(this._buttonRecyclerIDFunction != null) {
			recyclerID = this._buttonRecyclerIDFunction(state);
		}
		var recycler = null;
		if(recyclerID != null) {
			if(this._recyclerMap != null) {
				recycler = this._recyclerMap.get(recyclerID);
			}
			if(recycler == null) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Item renderer recycler ID \"" + recyclerID + "\" is not registered."));
			}
		}
		if(recycler == null) {
			return this._defaultStorage;
		}
		if(this._additionalStorage == null) {
			this._additionalStorage = [];
		}
		var _g = 0;
		var _g1 = this._additionalStorage.length;
		while(_g < _g1) {
			var i = _g++;
			var storage = this._additionalStorage[i];
			if(storage.buttonRecycler == recycler) {
				return storage;
			}
		}
		var storage1 = new (feathers_controls__$ButtonBar_ButtonStorage().default)(recyclerID,recycler);
		this._additionalStorage.push(storage1);
		return storage1;
	},
	populateCurrentItemState: function(item,index,state,force) {
		var changed = false;
		if(force || state.owner != this) {
			state.owner = this;
			changed = true;
		}
		if(force || state.data != item) {
			state.data = item;
			changed = true;
		}
		if(force || state.index != index) {
			state.index = index;
			changed = true;
		}
		var enabled = this._enabled && this.itemToEnabled(item);
		if(force || state.enabled != enabled) {
			state.enabled = enabled;
			changed = true;
		}
		var text = this.itemToText(item);
		if(force || state.text != text) {
			state.text = text;
			changed = true;
		}
		return changed;
	},
	updateButton: function(button,state,storage) {
		state.recyclerID = storage.id;
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		if(this.get_buttonRecycler().update != null) {
			this.get_buttonRecycler().update(button,state);
		}
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		this.refreshButtonProperties(button,state);
	},
	resetButton: function(button,state) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		if(this.get_buttonRecycler() != null && this.get_buttonRecycler().reset != null) {
			this.get_buttonRecycler().reset(button,state);
		}
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		this.refreshButtonProperties(button,ButtonBar.RESET_BUTTON_STATE);
	},
	refreshButtonProperties: function(button,state) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		if((js_Boot().default).__implements(button,(feathers_core_IUIControl().default))) {
			var uiControl = (js_Boot().default).__cast(button , (feathers_core_IUIControl().default));
			uiControl.set_enabled(state.enabled);
		}
		if((js_Boot().default).__implements(button,(feathers_controls_dataRenderers_IDataRenderer().default))) {
			var dataRenderer = (js_Boot().default).__cast(button , (feathers_controls_dataRenderers_IDataRenderer().default));
			dataRenderer.set_data(state.data);
		}
		if((js_Boot().default).__implements(button,(feathers_layout_ILayoutIndexObject().default))) {
			var layoutObject = (js_Boot().default).__cast(button , (feathers_layout_ILayoutIndexObject().default));
			layoutObject.set_layoutIndex(state.index);
		}
		button.set_enabled(state.enabled);
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
	},
	buttonBar_button_triggerHandler: function(event) {
		var button = (js_Boot().default).__cast(event.currentTarget , (feathers_controls_Button().default));
		var state = this.buttonToItemState.get(button);
		(feathers_events_ButtonBarEvent().default).dispatch(this,"itemTrigger",state);
	},
	buttonBar_dataProvider_changeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
	},
	updateButtonForIndex: function(index) {
		var item = this._dataProvider.get(index);
		var button = this.dataToButton.get(item);
		if(button == null) {
			this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
			return;
		}
		var state = this.buttonToItemState.get(button);
		if(state.owner == null) {
			return;
		}
		var storage = this.itemStateToStorage(state);
		this.populateCurrentItemState(item,index,state,true);
		this.resetButton(button,state);
		state.owner = null;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
	},
	buttonBar_dataProvider_updateItemHandler: function(event) {
		this.updateButtonForIndex(event.index);
	},
	buttonBar_dataProvider_updateAllHandler: function(event) {
		var _g = 0;
		var _g1 = this._dataProvider.get_length();
		while(_g < _g1) {
			var i = _g++;
			this.updateButtonForIndex(i);
		}
	},
	get_customButtonVariant: function() {
		return this.__customButtonVariant;
	},
	set_customButtonVariant: function(value) {
		if(!this.setStyle("customButtonVariant")) {
			return this.__customButtonVariant;
		}
		if(this.__customButtonVariant == value) {
			return this.__customButtonVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customButtonVariant);
		this.__customButtonVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customButtonVariant;
	},
	clearStyle_customButtonVariant: function() {
		this.set_customButtonVariant(null);
		return this.get_customButtonVariant();
	},
	get_layout: function() {
		return this.__layout;
	},
	set_layout: function(value) {
		if(!this.setStyle("layout")) {
			return this.__layout;
		}
		if(this.__layout == value) {
			return this.__layout;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_layout);
		this.__layout = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__layout;
	},
	clearStyle_layout: function() {
		this.set_layout(null);
		return this.get_layout();
	},
	get_backgroundSkin: function() {
		return this.__backgroundSkin;
	},
	set_backgroundSkin: function(value) {
		if(!this.setStyle("backgroundSkin")) {
			return this.__backgroundSkin;
		}
		if(this.__backgroundSkin == value) {
			return this.__backgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_backgroundSkin);
		this.__backgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__backgroundSkin;
	},
	clearStyle_backgroundSkin: function() {
		this.set_backgroundSkin(null);
		return this.get_backgroundSkin();
	},
	get_disabledBackgroundSkin: function() {
		return this.__disabledBackgroundSkin;
	},
	set_disabledBackgroundSkin: function(value) {
		if(!this.setStyle("disabledBackgroundSkin")) {
			return this.__disabledBackgroundSkin;
		}
		if(this.__disabledBackgroundSkin == value) {
			return this.__disabledBackgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledBackgroundSkin);
		this.__disabledBackgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledBackgroundSkin;
	},
	clearStyle_disabledBackgroundSkin: function() {
		this.set_disabledBackgroundSkin(null);
		return this.get_disabledBackgroundSkin();
	},
	get_styleContext: function() {
		return ButtonBar
	}
});
ButtonBar.prototype.__class__ = ButtonBar.prototype.constructor = $hxClasses["feathers.controls.ButtonBar"] = ButtonBar;

// Init



// Statics

ButtonBar.defaultUpdateButton = function(button,state) {
	button.set_text(state.text);
}
ButtonBar.defaultResetButton = function(button,state) {
	button.set_text(null);
}
ButtonBar.__meta__ = { obj : { defaultXmlProperty : ["dataProvider"]}}
ButtonBar.INVALIDATION_FLAG_BUTTON_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("buttonFactory")
ButtonBar.CHILD_VARIANT_BUTTON = "buttonBar_button"
ButtonBar.RESET_BUTTON_STATE = new (feathers_data_ButtonBarItemState().default)()

// Export

exports["default"] = ButtonBar;

/***/ }),

/***/ "./lib/_gen/feathers/controls/ButtonState.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/controls/ButtonState.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.controls.ButtonState

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var ButtonState = $hxEnums["feathers.controls.ButtonState"] = { __ename__ : "feathers.controls.ButtonState", __constructs__ : ["UP","HOVER","DOWN","DISABLED"]
  ,UP: {_hx_index:0,__enum__:"feathers.controls.ButtonState",toString:$estr}
  ,HOVER: {_hx_index:1,__enum__:"feathers.controls.ButtonState",toString:$estr}
  ,DOWN: {_hx_index:2,__enum__:"feathers.controls.ButtonState",toString:$estr}
  ,DISABLED: {_hx_index:3,__enum__:"feathers.controls.ButtonState",toString:$estr}
};

exports["default"] = ButtonState;

/***/ }),

/***/ "./lib/_gen/feathers/controls/CalendarGrid.js":
/*!****************************************************!*\
  !*** ./lib/_gen/feathers/controls/CalendarGrid.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.CalendarGrid

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IDateSelector() {return __webpack_require__(/*! ./../../feathers/core/IDateSelector */ "./lib/_gen/feathers/core/IDateSelector.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_RangeError() {return (__webpack_require__(/*! openfl */ "openfl").errors.RangeError);}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function feathers_themes_steel_components_SteelCalendarGridStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelCalendarGridStyles */ "./lib/_gen/feathers/themes/steel/components/SteelCalendarGridStyles.js");}
function feathers_layout_CalendarGridLayout() {return __webpack_require__(/*! ./../../feathers/layout/CalendarGridLayout */ "./lib/_gen/feathers/layout/CalendarGridLayout.js");}
function feathers_controls_Label() {return __webpack_require__(/*! ./../../feathers/controls/Label */ "./lib/_gen/feathers/controls/Label.js");}
function feathers_controls_ToggleButton() {return __webpack_require__(/*! ./../../feathers/controls/ToggleButton */ "./lib/_gen/feathers/controls/ToggleButton.js");}
function feathers_utils_MeasurementsUtil() {return __webpack_require__(/*! ./../../feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_utils_DateUtil() {return __webpack_require__(/*! ./../../feathers/utils/DateUtil */ "./lib/_gen/feathers/utils/DateUtil.js");}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}

// Constructor

var CalendarGrid = function() {
	this.__showDatesFromAdjacentMonths = true;
	this.__showWeekdayLabels = true;
	this.__customWeekdayLabelVariant = null;
	this.__customMutedToggleButtonVariant = null;
	this.__customToggleButtonVariant = null;
	this.__disabledBackgroundSkin = null;
	this.__backgroundSkin = null;
	this._layoutResult = new (feathers_layout_LayoutBoundsResult().default)();
	this._layoutMeasurements = new (feathers_layout_Measurements().default)();
	this._actualLocaleIDName = null;
	this._requestedLocaleIDName = null;
	this._customStartOfWeek = null;
	this._currentStartOfWeek = 0;
	this._customWeekdayNames = null;
	this._previousCustomWeekdayLabelVariant = null;
	this._previousCustomMutedToggleButtonVariant = null;
	this._previousCustomToggleButtonVariant = null;
	this._backgroundSkinMeasurements = null;
	this._currentBackgroundSkin = null;
	this._selectedDate = null;
	this._selectable = true;
	this._displayedMonth = new Date().getMonth();
	this._displayedFullYear = new Date().getFullYear();
	this._layoutItems = [];
	this._dateButtons = [];
	this._dayNameLabels = [];
	this.DEFAULT_START_OF_WEEK = 0;
	this.DEFAULT_WEEKDAY_NAMES = ["S","M","T","W","T","F","S"];
	this.initializeCalendarGridTheme();
	(feathers_core_FeathersControl().default).call(this);
}

// Meta

CalendarGrid.__name__ = "feathers.controls.CalendarGrid";
CalendarGrid.__isInterface__ = false;
CalendarGrid.__interfaces__ = [(feathers_core_IDateSelector().default)];
CalendarGrid.__super__ = (feathers_core_FeathersControl().default);
CalendarGrid.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_displayedFullYear: function() {
		return this._displayedFullYear;
	},
	set_displayedFullYear: function(value) {
		if(this._displayedFullYear == value) {
			return this._displayedFullYear;
		}
		this._displayedFullYear = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		(feathers_events_FeathersEvent().default).dispatch(this,"scroll");
		return this._displayedFullYear;
	},
	get_displayedMonth: function() {
		return this._displayedMonth;
	},
	set_displayedMonth: function(value) {
		if(value < 0 || value > 11) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("displayedMonth must be in the range 0-11"));
		}
		if(this._displayedMonth == value) {
			return this._displayedMonth;
		}
		this._displayedMonth = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		(feathers_events_FeathersEvent().default).dispatch(this,"scroll");
		return this._displayedMonth;
	},
	get_selectable: function() {
		return this._selectable;
	},
	set_selectable: function(value) {
		if(this._selectable == value) {
			return this._selectable;
		}
		this._selectable = value;
		if(!this._selectable && this._selectedDate != null) {
			this.set_selectedDate(null);
		}
		return this._selectable;
	},
	get_selectedDate: function() {
		return this._selectedDate;
	},
	set_selectedDate: function(value) {
		if(!this._selectable) {
			value = null;
		}
		if(this._selectedDate == value) {
			return this._selectedDate;
		}
		this._selectedDate = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedDate;
	},
	get_customWeekdayNames: function() {
		return this._customWeekdayNames;
	},
	set_customWeekdayNames: function(value) {
		if(value != null && value.length != 7) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Length of customWeekdayNames must be exactly equal to 7"));
		}
		if(this._customWeekdayNames == value) {
			return this._customWeekdayNames;
		}
		this._customWeekdayNames = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._customWeekdayNames;
	},
	get_customStartOfWeek: function() {
		return this._customStartOfWeek;
	},
	set_customStartOfWeek: function(value) {
		if(value != null && (value < 0 || value > 6)) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("startOfWeek must be in the range 0-6"));
		}
		if(this._customStartOfWeek == value) {
			return this._customStartOfWeek;
		}
		this._customStartOfWeek = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._customStartOfWeek;
	},
	get_requestedLocaleIDName: function() {
		return this._requestedLocaleIDName;
	},
	set_requestedLocaleIDName: function(value) {
		if(this._requestedLocaleIDName == value) {
			return this._requestedLocaleIDName;
		}
		this._requestedLocaleIDName = value;
		this._actualLocaleIDName = null;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._requestedLocaleIDName;
	},
	get_actualLocaleIDName: function() {
		return this._actualLocaleIDName;
	},
	initializeCalendarGridTheme: function() {
		(feathers_themes_steel_components_SteelCalendarGridStyles().default).initialize();
	},
	initialize: function() {
		if(this._layout == null) {
			this._layout = new (feathers_layout_CalendarGridLayout().default)();
		}
		var dayNameLabel = new (feathers_controls_Label().default)();
		this.addChild(dayNameLabel);
		this._dayNameLabels.push(dayNameLabel);
		this._layoutItems[0] = dayNameLabel;
		var dayNameLabel1 = new (feathers_controls_Label().default)();
		this.addChild(dayNameLabel1);
		this._dayNameLabels.push(dayNameLabel1);
		this._layoutItems[1] = dayNameLabel1;
		var dayNameLabel2 = new (feathers_controls_Label().default)();
		this.addChild(dayNameLabel2);
		this._dayNameLabels.push(dayNameLabel2);
		this._layoutItems[2] = dayNameLabel2;
		var dayNameLabel3 = new (feathers_controls_Label().default)();
		this.addChild(dayNameLabel3);
		this._dayNameLabels.push(dayNameLabel3);
		this._layoutItems[3] = dayNameLabel3;
		var dayNameLabel4 = new (feathers_controls_Label().default)();
		this.addChild(dayNameLabel4);
		this._dayNameLabels.push(dayNameLabel4);
		this._layoutItems[4] = dayNameLabel4;
		var dayNameLabel5 = new (feathers_controls_Label().default)();
		this.addChild(dayNameLabel5);
		this._dayNameLabels.push(dayNameLabel5);
		this._layoutItems[5] = dayNameLabel5;
		var dayNameLabel6 = new (feathers_controls_Label().default)();
		this.addChild(dayNameLabel6);
		this._dayNameLabels.push(dayNameLabel6);
		this._layoutItems[6] = dayNameLabel6;
		var _g = 0;
		while(_g < 42) {
			var i = _g++;
			var dateButton = new (feathers_controls_ToggleButton().default)();
			dateButton.set_toggleable(false);
			dateButton.addEventListener("trigger",$bind(this,this.dateButton_triggerHandler));
			this.addChild(dateButton);
			this._dateButtons.push(dateButton);
			this._layoutItems[i + 7] = dateButton;
		}
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var selectionInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(this._previousCustomWeekdayLabelVariant != this.get_customWeekdayLabelVariant()) {
			this.setInvalidationFlag(CalendarGrid.INVALIDATION_FLAG_WEEKDAY_LABEL_FACTORY);
		}
		if(this._previousCustomToggleButtonVariant != this.get_customToggleButtonVariant()) {
			this.setInvalidationFlag(CalendarGrid.INVALIDATION_FLAG_TOGGLE_BUTTON_FACTORY);
		}
		if(this._previousCustomMutedToggleButtonVariant != this.get_customMutedToggleButtonVariant()) {
			this.setInvalidationFlag(CalendarGrid.INVALIDATION_FLAG_MUTED_TOGGLE_BUTTON_FACTORY);
		}
		var weekdayLabelFactoryInvalid = this.isInvalid(CalendarGrid.INVALIDATION_FLAG_WEEKDAY_LABEL_FACTORY);
		var toggleButtonFactoryInvalid = this.isInvalid(CalendarGrid.INVALIDATION_FLAG_TOGGLE_BUTTON_FACTORY);
		var mutedToggleButtonFactoryInvalid = this.isInvalid(CalendarGrid.INVALIDATION_FLAG_MUTED_TOGGLE_BUTTON_FACTORY);
		if(stylesInvalid || stateInvalid) {
			this.refreshBackgroundSkin();
		}
		if(dataInvalid) {
			this.refreshLocale();
		}
		if(weekdayLabelFactoryInvalid || dataInvalid || stylesInvalid) {
			this.refreshWeekdayLabels();
		}
		if(toggleButtonFactoryInvalid || mutedToggleButtonFactoryInvalid || dataInvalid || selectionInvalid) {
			this.refreshDisplayedMonth();
		}
		if(stateInvalid || weekdayLabelFactoryInvalid || toggleButtonFactoryInvalid || mutedToggleButtonFactoryInvalid) {
			this.refreshEnabled();
		}
		this.refreshViewPortBounds();
		this._layoutResult.reset();
		this._layout.layout(this._layoutItems,this._layoutMeasurements,this._layoutResult);
		this.handleLayoutResult();
	},
	refreshLocale: function() {
		this._actualLocaleIDName = "en-US";
		this._currentWeekdayNames = this._customWeekdayNames != null ? this._customWeekdayNames : this.DEFAULT_WEEKDAY_NAMES;
		this._currentStartOfWeek = this._customStartOfWeek != null ? this._customStartOfWeek : this.DEFAULT_START_OF_WEEK;
	},
	refreshEnabled: function() {
		var _g = 0;
		var _g1 = this._dayNameLabels;
		while(_g < _g1.length) {
			var dayNameLabel = _g1[_g];
			++_g;
			dayNameLabel.set_enabled(this._enabled);
		}
		var _g2 = 0;
		var _g3 = this._dateButtons;
		while(_g2 < _g3.length) {
			var dateButton = _g3[_g2];
			++_g2;
			dateButton.set_enabled(this._enabled);
		}
	},
	refreshViewPortBounds: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(this._currentBackgroundSkin != null) {
			(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParent(this._backgroundSkinMeasurements,this._currentBackgroundSkin,this);
			if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
			}
		}
		this._layoutMeasurements.width = this.get_explicitWidth();
		this._layoutMeasurements.height = this.get_explicitHeight();
		var viewPortMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			viewPortMinWidth = 0.0;
		}
		var viewPortMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			viewPortMinHeight = 0.0;
		}
		var viewPortMaxWidth = this.get_explicitMaxWidth();
		if(needsMaxWidth) {
			viewPortMaxWidth = 1.0 / 0.0;
		}
		var viewPortMaxHeight = this.get_explicitMaxHeight();
		if(needsMaxHeight) {
			viewPortMaxHeight = 1.0 / 0.0;
		}
		if(this._backgroundSkinMeasurements != null) {
			if(this._backgroundSkinMeasurements.width != null) {
				if(this._backgroundSkinMeasurements.width > viewPortMinWidth) {
					viewPortMinWidth = this._backgroundSkinMeasurements.width;
				}
			} else if(this._backgroundSkinMeasurements.minWidth != null) {
				if(this._backgroundSkinMeasurements.minWidth > viewPortMinWidth) {
					viewPortMinWidth = this._backgroundSkinMeasurements.minWidth;
				}
			}
			if(this._backgroundSkinMeasurements.height != null) {
				if(this._backgroundSkinMeasurements.height > viewPortMinHeight) {
					viewPortMinHeight = this._backgroundSkinMeasurements.height;
				}
			} else if(this._backgroundSkinMeasurements.minHeight != null) {
				if(this._backgroundSkinMeasurements.minHeight > viewPortMinHeight) {
					viewPortMinHeight = this._backgroundSkinMeasurements.minHeight;
				}
			}
		}
		this._layoutMeasurements.minWidth = viewPortMinWidth;
		this._layoutMeasurements.minHeight = viewPortMinHeight;
		this._layoutMeasurements.maxWidth = viewPortMaxWidth;
		this._layoutMeasurements.maxHeight = viewPortMaxHeight;
	},
	handleLayoutResult: function() {
		var viewPortWidth = this._layoutResult.viewPortWidth;
		var viewPortHeight = this._layoutResult.viewPortHeight;
		this.saveMeasurements(viewPortWidth,viewPortHeight,viewPortWidth,viewPortHeight);
	},
	refreshWeekdayLabels: function() {
		var weekdayLabelVariant = this.get_customWeekdayLabelVariant() != null ? this.get_customWeekdayLabelVariant() : CalendarGrid.CHILD_VARIANT_WEEKDAY_LABEL;
		var _g = 0;
		var _g1 = this._dayNameLabels.length;
		while(_g < _g1) {
			var i = _g++;
			var nameIndex = (i + this._currentStartOfWeek) % this._dayNameLabels.length;
			var dayNameLabel = this._dayNameLabels[i];
			dayNameLabel.set_variant(weekdayLabelVariant);
			dayNameLabel.set_text(this._currentWeekdayNames[nameIndex]);
			dayNameLabel.set_visible(this.get_showWeekdayLabels());
			dayNameLabel.set_includeInLayout(this.get_showWeekdayLabels());
		}
	},
	refreshBackgroundSkin: function() {
		var oldSkin = this._currentBackgroundSkin;
		this._currentBackgroundSkin = this.getCurrentBackgroundSkin();
		if(this._currentBackgroundSkin == oldSkin) {
			return;
		}
		this.removeCurrentBackgroundSkin(oldSkin);
		this.addCurrentBackgroundSkin(this._currentBackgroundSkin);
	},
	getCurrentBackgroundSkin: function() {
		if(!this._enabled && this.get_disabledBackgroundSkin() != null) {
			return this.get_disabledBackgroundSkin();
		}
		return this.get_backgroundSkin();
	},
	addCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			this._backgroundSkinMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._backgroundSkinMeasurements == null) {
			this._backgroundSkinMeasurements = new (feathers_layout_Measurements().default)(skin);
		} else {
			this._backgroundSkinMeasurements.save(skin);
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this.addChildAt(skin,0);
	},
	removeCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		this._backgroundSkinMeasurements.restore(skin);
		if(skin.parent == this) {
			this.removeChild(skin);
		}
	},
	refreshDisplayedMonth: function() {
		var startOfWeek = this._customStartOfWeek != null ? this._customStartOfWeek : 0;
		var dayIndexOfFirst = -startOfWeek + new Date(this._displayedFullYear,this._displayedMonth,1,0,0,0).getDay();
		if(dayIndexOfFirst < 0) {
			dayIndexOfFirst = 0;
		}
		var lastMonthYear = this._displayedFullYear;
		var lastMonth = this._displayedMonth - 1;
		if(lastMonth < 0) {
			lastMonth = 11;
			--lastMonthYear;
		}
		var numDays = (feathers_utils_DateUtil().default).getDaysInMonth(this._displayedMonth,this._displayedFullYear);
		var numDaysLastMonth = (feathers_utils_DateUtil().default).getDaysInMonth(lastMonth,lastMonthYear);
		var currentDate = numDaysLastMonth - dayIndexOfFirst + 1;
		var inCurrentMonth = false;
		var toggleButtonVariant = this.get_customToggleButtonVariant() != null ? this.get_customToggleButtonVariant() : CalendarGrid.CHILD_VARIANT_DATE_TOGGLE_BUTTON;
		var mutedToggleButtonVariant = this.get_customMutedToggleButtonVariant() != null ? this.get_customMutedToggleButtonVariant() : CalendarGrid.CHILD_VARIANT_MUTED_DATE_TOGGLE_BUTTON;
		var _g = 0;
		var _g1 = this._dateButtons.length;
		while(_g < _g1) {
			var i = _g++;
			if(!inCurrentMonth && currentDate > numDaysLastMonth) {
				currentDate = 1;
				inCurrentMonth = true;
			}
			if(inCurrentMonth && currentDate > numDays) {
				currentDate = 1;
				inCurrentMonth = false;
			}
			var dateButton = this._dateButtons[i];
			dateButton.set_selected(inCurrentMonth && this._selectedDate != null && this._displayedFullYear == this._selectedDate.getFullYear() && this._displayedMonth == this._selectedDate.getMonth() && currentDate == this._selectedDate.getDate());
			dateButton.set_text(currentDate == null ? "null" : "" + currentDate);
			dateButton.set_variant(inCurrentMonth ? toggleButtonVariant : mutedToggleButtonVariant);
			dateButton.set_toggleable(this._selectable);
			dateButton.set_visible(inCurrentMonth || this.get_showDatesFromAdjacentMonths());
			++currentDate;
		}
	},
	getDateForButtonIndex: function(index) {
		var startOfWeek = this._customStartOfWeek != null ? this._customStartOfWeek : 0;
		var dayIndexOfFirst = -startOfWeek + new Date(this._displayedFullYear,this._displayedMonth,1,0,0,0).getDay();
		if(dayIndexOfFirst < 0) {
			dayIndexOfFirst = 0;
		}
		var numDays = (feathers_utils_DateUtil().default).getDaysInMonth(this._displayedMonth,this._displayedFullYear);
		if(index < dayIndexOfFirst) {
			var lastMonthYear = this._displayedFullYear;
			var lastMonth = this._displayedMonth - 1;
			if(lastMonth < 0) {
				lastMonth = 11;
				--lastMonthYear;
			}
			var numDaysLastMonth = (feathers_utils_DateUtil().default).getDaysInMonth(lastMonth,lastMonthYear);
			return new Date(lastMonthYear,lastMonth,numDaysLastMonth - (dayIndexOfFirst - index) + 1,0,0,0);
		}
		var offset = index - dayIndexOfFirst - numDays;
		if(offset >= 0) {
			var nextMonth = this._displayedMonth + 1;
			var nextYear = this._displayedFullYear;
			if(nextMonth > 11) {
				nextMonth = 0;
				++nextYear;
			}
			return new Date(nextYear,nextMonth,offset + 1,0,0,0);
		}
		return new Date(this._displayedFullYear,this._displayedMonth,index - dayIndexOfFirst + 1,0,0,0);
	},
	dateButton_triggerHandler: function(event) {
		var button = (js_Boot().default).__cast(event.currentTarget , (feathers_controls_ToggleButton().default));
		this.set_selectedDate(this.getDateForButtonIndex(this._dateButtons.indexOf(button)));
		this.set_displayedFullYear(this.get_selectedDate().getFullYear());
		this.set_displayedMonth(this.get_selectedDate().getMonth());
	},
	get_backgroundSkin: function() {
		return this.__backgroundSkin;
	},
	set_backgroundSkin: function(value) {
		if(!this.setStyle("backgroundSkin")) {
			return this.__backgroundSkin;
		}
		if(this.__backgroundSkin == value) {
			return this.__backgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_backgroundSkin);
		this.__backgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__backgroundSkin;
	},
	clearStyle_backgroundSkin: function() {
		this.set_backgroundSkin(null);
		return this.get_backgroundSkin();
	},
	get_disabledBackgroundSkin: function() {
		return this.__disabledBackgroundSkin;
	},
	set_disabledBackgroundSkin: function(value) {
		if(!this.setStyle("disabledBackgroundSkin")) {
			return this.__disabledBackgroundSkin;
		}
		if(this.__disabledBackgroundSkin == value) {
			return this.__disabledBackgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledBackgroundSkin);
		this.__disabledBackgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledBackgroundSkin;
	},
	clearStyle_disabledBackgroundSkin: function() {
		this.set_disabledBackgroundSkin(null);
		return this.get_disabledBackgroundSkin();
	},
	get_customToggleButtonVariant: function() {
		return this.__customToggleButtonVariant;
	},
	set_customToggleButtonVariant: function(value) {
		if(!this.setStyle("customToggleButtonVariant")) {
			return this.__customToggleButtonVariant;
		}
		if(this.__customToggleButtonVariant == value) {
			return this.__customToggleButtonVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customToggleButtonVariant);
		this.__customToggleButtonVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customToggleButtonVariant;
	},
	clearStyle_customToggleButtonVariant: function() {
		this.set_customToggleButtonVariant(null);
		return this.get_customToggleButtonVariant();
	},
	get_customMutedToggleButtonVariant: function() {
		return this.__customMutedToggleButtonVariant;
	},
	set_customMutedToggleButtonVariant: function(value) {
		if(!this.setStyle("customMutedToggleButtonVariant")) {
			return this.__customMutedToggleButtonVariant;
		}
		if(this.__customMutedToggleButtonVariant == value) {
			return this.__customMutedToggleButtonVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customMutedToggleButtonVariant);
		this.__customMutedToggleButtonVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customMutedToggleButtonVariant;
	},
	clearStyle_customMutedToggleButtonVariant: function() {
		this.set_customMutedToggleButtonVariant(null);
		return this.get_customMutedToggleButtonVariant();
	},
	get_customWeekdayLabelVariant: function() {
		return this.__customWeekdayLabelVariant;
	},
	set_customWeekdayLabelVariant: function(value) {
		if(!this.setStyle("customWeekdayLabelVariant")) {
			return this.__customWeekdayLabelVariant;
		}
		if(this.__customWeekdayLabelVariant == value) {
			return this.__customWeekdayLabelVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customWeekdayLabelVariant);
		this.__customWeekdayLabelVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customWeekdayLabelVariant;
	},
	clearStyle_customWeekdayLabelVariant: function() {
		this.set_customWeekdayLabelVariant(null);
		return this.get_customWeekdayLabelVariant();
	},
	get_showWeekdayLabels: function() {
		return this.__showWeekdayLabels;
	},
	set_showWeekdayLabels: function(value) {
		if(!this.setStyle("showWeekdayLabels")) {
			return this.__showWeekdayLabels;
		}
		if(this.__showWeekdayLabels == value) {
			return this.__showWeekdayLabels;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_showWeekdayLabels);
		this.__showWeekdayLabels = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__showWeekdayLabels;
	},
	clearStyle_showWeekdayLabels: function() {
		this.set_showWeekdayLabels(true);
		return this.get_showWeekdayLabels();
	},
	get_showDatesFromAdjacentMonths: function() {
		return this.__showDatesFromAdjacentMonths;
	},
	set_showDatesFromAdjacentMonths: function(value) {
		if(!this.setStyle("showDatesFromAdjacentMonths")) {
			return this.__showDatesFromAdjacentMonths;
		}
		if(this.__showDatesFromAdjacentMonths == value) {
			return this.__showDatesFromAdjacentMonths;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_showDatesFromAdjacentMonths);
		this.__showDatesFromAdjacentMonths = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__showDatesFromAdjacentMonths;
	},
	clearStyle_showDatesFromAdjacentMonths: function() {
		this.set_showDatesFromAdjacentMonths(true);
		return this.get_showDatesFromAdjacentMonths();
	}
});
CalendarGrid.prototype.__class__ = CalendarGrid.prototype.constructor = $hxClasses["feathers.controls.CalendarGrid"] = CalendarGrid;

// Init



// Statics


CalendarGrid.CHILD_VARIANT_DATE_TOGGLE_BUTTON = "calendarGrid_dateToggleButton"
CalendarGrid.CHILD_VARIANT_MUTED_DATE_TOGGLE_BUTTON = "calendarGrid_mutedDateToggleButton"
CalendarGrid.CHILD_VARIANT_WEEKDAY_LABEL = "calendarGrid_weekdayLabel"
CalendarGrid.INVALIDATION_FLAG_TOGGLE_BUTTON_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("dateToggleButtonFactory")
CalendarGrid.INVALIDATION_FLAG_MUTED_TOGGLE_BUTTON_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("mutedDateToggleButtonFactory")
CalendarGrid.INVALIDATION_FLAG_WEEKDAY_LABEL_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("weekdayLabelFactory")

// Export

exports["default"] = CalendarGrid;

/***/ }),

/***/ "./lib/_gen/feathers/controls/Callout.js":
/*!***********************************************!*\
  !*** ./lib/_gen/feathers/controls/Callout.js ***!
  \***********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.Callout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function feathers_themes_steel_components_SteelCalloutStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelCalloutStyles */ "./lib/_gen/feathers/themes/steel/components/SteelCalloutStyles.js");}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function feathers_utils_MeasurementsUtil() {return __webpack_require__(/*! ./../../feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}
function feathers_core_PopUpManager() {return __webpack_require__(/*! ./../../feathers/core/PopUpManager */ "./lib/_gen/feathers/core/PopUpManager.js");}
function openfl_geom_Rectangle() {return (__webpack_require__(/*! openfl */ "openfl").geom.Rectangle);}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function openfl_display_Sprite() {return (__webpack_require__(/*! openfl */ "openfl").display.Sprite);}

// Constructor

var Callout = function(content) {
	this.__leftArrowGap = 0.0;
	this.__bottomArrowGap = 0.0;
	this.__rightArrowGap = 0.0;
	this.__topArrowGap = 0.0;
	this.__leftArrowSkin = null;
	this.__bottomArrowSkin = null;
	this.__rightArrowSkin = null;
	this.__topArrowSkin = null;
	this.__backgroundSkin = null;
	this.__arrowPosition = (feathers_layout_RelativePosition().default).TOP;
	this.__verticalAlign = (feathers_layout_VerticalAlign().default).MIDDLE;
	this.__horizontalAlign = (feathers_layout_HorizontalAlign().default).CENTER;
	this.__paddingLeft = 0.0;
	this.__paddingBottom = 0.0;
	this.__paddingRight = 0.0;
	this.__paddingTop = 0.0;
	this.__marginLeft = 0.0;
	this.__marginBottom = 0.0;
	this.__marginRight = 0.0;
	this.__marginTop = 0.0;
	this.__gap = 0.0;
	this.closeOnPointerOutside = true;
	this._ignoreContentResize = false;
	this._arrowOffset = 0.0;
	this.initializeCalloutTheme();
	(feathers_core_FeathersControl().default).call(this);
	this.set_content(content);
	this.addEventListener("addedToStage",$bind(this,this.callout_addedToStageHandler));
	this.addEventListener("removedFromStage",$bind(this,this.callout_removedFromStageHandler));
}

// Meta

Callout.__name__ = "feathers.controls.Callout";
Callout.__isInterface__ = false;
Callout.__super__ = (feathers_core_FeathersControl().default);
Callout.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_content: function() {
		return this._content;
	},
	set_content: function(value) {
		if(this._content == value) {
			return this._content;
		}
		if(this._content != null) {
			this._content.removeEventListener("resize",$bind(this,this.callout_content_resizeHandler));
			this._contentMeasurements.restore(this._content);
			if(this._content.parent == this) {
				this.removeChild(this._content);
			}
		}
		this._content = value;
		if(this._content != null) {
			this._content.addEventListener("resize",$bind(this,this.callout_content_resizeHandler),false,0,true);
			this.addChild(this._content);
			if((js_Boot().default).__implements(this._content,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(this._content , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(this._contentMeasurements == null) {
				this._contentMeasurements = new (feathers_layout_Measurements().default)(this._content);
			} else {
				this._contentMeasurements.save(this._content);
			}
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		return this._content;
	},
	get_origin: function() {
		return this._origin;
	},
	set_origin: function(value) {
		if(this._origin == value) {
			return this._origin;
		}
		if(value != null && value.stage == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("origin must be added to the stage."));
		}
		if(this._origin != null) {
			this._origin.removeEventListener("removedFromStage",$bind(this,this.callout_origin_removedFromStageHandler));
			this.removeEventListener("enterFrame",$bind(this,this.callout_enterFrameHandler));
		}
		this._origin = value;
		if(this._origin != null) {
			this._origin.addEventListener("removedFromStage",$bind(this,this.callout_origin_removedFromStageHandler));
			if(this.stage != null) {
				this.addEventListener("enterFrame",$bind(this,this.callout_enterFrameHandler));
			}
		}
		this._lastPopUpOriginBounds = null;
		this.setInvalid(Callout.INVALIDATION_FLAG_ORIGIN);
		return this._origin;
	},
	close: function() {
		if(this.parent != null) {
			this.parent.removeChild(this);
		}
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	initializeCalloutTheme: function() {
		(feathers_themes_steel_components_SteelCalloutStyles().default).initialize();
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var originInvalid = this.isInvalid(Callout.INVALIDATION_FLAG_ORIGIN);
		var sizeInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SIZE);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(sizeInvalid) {
			this._lastPopUpOriginBounds = null;
			originInvalid = true;
		}
		if(stylesInvalid || stateInvalid) {
			this.refreshBackgroundSkin();
		}
		if(stylesInvalid || stateInvalid) {
			this.refreshArrowSkin();
		}
		if(originInvalid) {
			this.positionRelativeToOrigin();
		}
		if(stateInvalid || dataInvalid) {
			this.refreshEnabled();
		}
		sizeInvalid = this.measure() || sizeInvalid;
		this.layoutChildren();
	},
	measure: function() {
		return this.measureWithArrowPosition(this.get_arrowPosition());
	},
	measureWithArrowPosition: function(arrowPosition) {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		var stageWidth = 0.0;
		var stageHeight = 0.0;
		if(this.stage != null) {
			var stageTopLeft = new (openfl_geom_Point())();
			stageTopLeft = this.globalToLocal(stageTopLeft);
			var stageBottomRight = new (openfl_geom_Point())(this.stage.stageWidth,this.stage.stageHeight);
			stageBottomRight = this.globalToLocal(stageBottomRight);
			stageWidth = stageBottomRight.x - stageTopLeft.x;
			stageHeight = stageBottomRight.y - stageTopLeft.y;
		}
		var maxWidthWithStage = this.get_explicitMaxWidth();
		if(this.stage != null) {
			var stageMaxWidth = stageWidth - this.get_marginLeft() - this.get_marginRight();
			if(maxWidthWithStage == null || maxWidthWithStage < stageMaxWidth) {
				maxWidthWithStage = stageMaxWidth;
			}
		} else {
			maxWidthWithStage = 1.0 / 0.0;
		}
		var maxHeightWithStage = this.get_explicitMaxHeight();
		if(this.stage != null) {
			var stageMaxHeight = stageHeight - this.get_marginTop() - this.get_marginBottom();
			if(maxHeightWithStage == null || maxHeightWithStage < stageMaxHeight) {
				maxHeightWithStage = stageMaxHeight;
			}
		} else {
			maxHeightWithStage = 1.0 / 0.0;
		}
		if(this._currentBackgroundSkin != null) {
			(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParentValues(this._backgroundSkinMeasurements,this._currentBackgroundSkin,this.get_explicitWidth(),this.get_explicitHeight(),this.get_explicitMinWidth(),this.get_explicitMinHeight(),maxWidthWithStage,maxHeightWithStage);
		}
		var measureSkin = null;
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IMeasureObject().default))) {
			measureSkin = (js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IMeasureObject().default));
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
		if((js_Boot().default).__implements(this.get_topArrowSkin(),(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this.get_topArrowSkin() , (feathers_core_IValidating().default))).validateNow();
		}
		if((js_Boot().default).__implements(this.get_rightArrowSkin(),(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this.get_rightArrowSkin() , (feathers_core_IValidating().default))).validateNow();
		}
		if((js_Boot().default).__implements(this.get_bottomArrowSkin(),(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this.get_bottomArrowSkin() , (feathers_core_IValidating().default))).validateNow();
		}
		if((js_Boot().default).__implements(this.get_leftArrowSkin(),(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this.get_leftArrowSkin() , (feathers_core_IValidating().default))).validateNow();
		}
		var leftOrRightArrowWidth = 0.0;
		var leftOrRightArrowHeight = 0.0;
		var topOrBottomArrowWidth = 0.0;
		var topOrBottomArrowHeight = 0.0;
		if(this._currentArrowSkin != null) {
			switch(arrowPosition._hx_index) {
			case 1:
				leftOrRightArrowWidth = this.get_rightArrowSkin().get_width() + this.get_rightArrowGap();
				leftOrRightArrowHeight = this.get_rightArrowSkin().get_height();
				break;
			case 2:
				topOrBottomArrowWidth = this.get_bottomArrowSkin().get_width();
				topOrBottomArrowHeight = this.get_bottomArrowSkin().get_height() + this.get_bottomArrowGap();
				break;
			case 3:
				leftOrRightArrowWidth = this.get_leftArrowSkin().get_width() + this.get_leftArrowGap();
				leftOrRightArrowHeight = this.get_leftArrowSkin().get_height();
				break;
			default:
				topOrBottomArrowWidth = this.get_topArrowSkin().get_width();
				topOrBottomArrowHeight = this.get_topArrowSkin().get_height() + this.get_topArrowGap();
			}
		}
		var measureContent = null;
		if((js_Boot().default).__implements(this._content,(feathers_core_IMeasureObject().default))) {
			measureContent = (js_Boot().default).__cast(this._content , (feathers_core_IMeasureObject().default));
		}
		if(this._content != null) {
			var oldIgnoreContentResize = this._ignoreContentResize;
			this._ignoreContentResize = true;
			(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParentValues(this._contentMeasurements,this._content,this.get_explicitWidth() != null ? this.get_explicitWidth() - leftOrRightArrowWidth - this.get_paddingLeft() - this.get_paddingRight() : null,this.get_explicitHeight() != null ? this.get_explicitHeight() - topOrBottomArrowHeight - this.get_paddingTop() - this.get_paddingBottom() : null,this.get_explicitMinWidth() != null ? this.get_explicitMinWidth() - leftOrRightArrowWidth - this.get_paddingLeft() - this.get_paddingRight() : null,this.get_explicitMinHeight() != null ? this.get_explicitMinHeight() - topOrBottomArrowHeight - this.get_paddingLeft() - this.get_paddingRight() : null,maxWidthWithStage != null ? maxWidthWithStage - leftOrRightArrowWidth - this.get_paddingLeft() - this.get_paddingRight() : null,maxHeightWithStage != null ? maxHeightWithStage - topOrBottomArrowHeight - this.get_paddingLeft() - this.get_paddingRight() : null);
			if((js_Boot().default).__implements(this._content,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._content , (feathers_core_IValidating().default))).validateNow();
			}
			this._ignoreContentResize = oldIgnoreContentResize;
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			var contentWidth = 0.0;
			if(this._content != null) {
				contentWidth = this._content.get_width();
			}
			if(contentWidth < topOrBottomArrowWidth) {
				contentWidth = topOrBottomArrowWidth;
			}
			newWidth = contentWidth + this.get_paddingLeft() + this.get_paddingRight();
			if(this._currentBackgroundSkin != null) {
				var backgroundWidth = this._currentBackgroundSkin.get_width();
				if(newWidth < backgroundWidth) {
					newWidth = backgroundWidth;
				}
			}
			newWidth += leftOrRightArrowWidth;
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			var contentHeight = 0.0;
			if(this._content != null) {
				contentHeight = this._content.get_height();
			}
			if(contentHeight < leftOrRightArrowHeight) {
				contentHeight = leftOrRightArrowHeight;
			}
			newHeight = contentHeight + this.get_paddingTop() + this.get_paddingBottom();
			if(this._currentBackgroundSkin != null) {
				var backgroundHeight = this._currentBackgroundSkin.get_height();
				if(newHeight < backgroundHeight) {
					newHeight = backgroundHeight;
				}
			}
			newHeight += topOrBottomArrowHeight;
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			var contentMinWidth = 0.0;
			if(measureContent != null) {
				contentMinWidth = measureContent.get_minWidth();
			} else if(this._contentMeasurements != null) {
				contentMinWidth = this._contentMeasurements.minWidth;
			}
			if(contentMinWidth < topOrBottomArrowWidth) {
				contentMinWidth = topOrBottomArrowWidth;
			}
			newMinWidth = contentMinWidth + this.get_paddingLeft() + this.get_paddingRight();
			var backgroundMinWidth = 0.0;
			if(measureSkin != null) {
				backgroundMinWidth = measureSkin.get_minWidth();
			} else if(this._backgroundSkinMeasurements != null) {
				backgroundMinWidth = this._backgroundSkinMeasurements.minWidth;
			}
			if(newMinWidth < backgroundMinWidth) {
				newMinWidth = backgroundMinWidth;
			}
			newMinWidth += leftOrRightArrowWidth;
			if(newMinWidth > maxWidthWithStage) {
				newMinWidth = maxWidthWithStage;
			}
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			var contentMinHeight = 0.0;
			if(measureContent != null) {
				contentMinHeight = measureContent.get_minWidth();
			} else if(this._contentMeasurements != null) {
				contentMinHeight = this._contentMeasurements.minHeight;
			}
			if(contentMinHeight < leftOrRightArrowHeight) {
				contentMinHeight = leftOrRightArrowHeight;
			}
			newMinHeight = contentMinHeight + this.get_paddingTop() + this.get_paddingBottom();
			var backgroundMinHeight = 0.0;
			if(measureSkin != null) {
				backgroundMinHeight = measureSkin.get_minHeight();
			} else if(this._backgroundSkinMeasurements != null) {
				backgroundMinHeight = this._backgroundSkinMeasurements.minHeight;
			}
			if(newMinHeight < backgroundMinHeight) {
				newMinHeight = backgroundMinHeight;
			}
			newMinHeight += topOrBottomArrowHeight;
			if(newMinHeight > maxHeightWithStage) {
				newMinHeight = maxHeightWithStage;
			}
		}
		var newMaxWidth = maxWidthWithStage;
		var newMaxHeight = maxHeightWithStage;
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight,newMaxWidth,newMaxHeight);
	},
	getCurrentBackgroundSkin: function() {
		return this.get_backgroundSkin();
	},
	refreshBackgroundSkin: function() {
		var oldSkin = this._currentBackgroundSkin;
		this._currentBackgroundSkin = this.getCurrentBackgroundSkin();
		if(this._currentBackgroundSkin == oldSkin) {
			return;
		}
		this.removeCurrentBackgroundSkin(oldSkin);
		this.addCurrentBackgroundSkin(this._currentBackgroundSkin);
	},
	addCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			this._backgroundSkinMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._backgroundSkinMeasurements == null) {
			this._backgroundSkinMeasurements = new (feathers_layout_Measurements().default)(skin);
		} else {
			this._backgroundSkinMeasurements.save(skin);
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this.addChildAt(skin,0);
	},
	removeCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this._backgroundSkinMeasurements.restore(skin);
		if(skin.parent == this) {
			this.removeChild(skin);
		}
	},
	refreshArrowSkin: function() {
		var oldArrowSkin = this._currentArrowSkin;
		this._currentArrowSkin = this.getCurrentArrowSkin();
		if(oldArrowSkin == this._currentArrowSkin) {
			return;
		}
		this.removeCurrentArrowSkin(oldArrowSkin);
		if((js_Boot().default).__implements(this._currentArrowSkin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(this._currentArrowSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this.addChild(this._currentArrowSkin);
	},
	getCurrentArrowSkin: function() {
		switch(this.get_arrowPosition()._hx_index) {
		case 1:
			return this.get_rightArrowSkin();
		case 2:
			return this.get_bottomArrowSkin();
		case 3:
			return this.get_leftArrowSkin();
		default:
			return this.get_topArrowSkin();
		}
	},
	removeCurrentArrowSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		if(skin.parent == this) {
			this.removeChild(skin);
		}
	},
	refreshEnabled: function() {
		if((js_Boot().default).__implements(this._content,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._content , (feathers_core_IUIControl().default))).set_enabled(this._enabled);
		}
	},
	layoutChildren: function() {
		if((js_Boot().default).__implements(this._currentArrowSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentArrowSkin , (feathers_core_IValidating().default))).validateNow();
		}
		var xPosition = 0.0;
		var yPosition = 0.0;
		var widthOffset = 0.0;
		var heightOffset = 0.0;
		if(this._currentArrowSkin != null) {
			switch(this.get_arrowPosition()._hx_index) {
			case 1:
				widthOffset = this._currentArrowSkin.get_width() + this.get_rightArrowGap();
				break;
			case 2:
				heightOffset = this._currentArrowSkin.get_height() + this.get_bottomArrowGap();
				break;
			case 3:
				xPosition = this._currentArrowSkin.get_width() + this.get_leftArrowGap();
				break;
			default:
				yPosition = this._currentArrowSkin.get_height() + this.get_topArrowGap();
			}
		}
		var backgroundWidth = this.actualWidth - xPosition - widthOffset;
		var backgroundHeight = this.actualHeight - yPosition - heightOffset;
		if(this._currentBackgroundSkin != null) {
			this._currentBackgroundSkin.set_x(xPosition);
			this._currentBackgroundSkin.set_y(yPosition);
			this._currentBackgroundSkin.set_width(backgroundWidth);
			this._currentBackgroundSkin.set_height(backgroundHeight);
		}
		if(this._currentArrowSkin != null) {
			var contentWidth = backgroundWidth - this.get_paddingLeft() - this.get_paddingRight();
			var contentHeight = backgroundHeight - this.get_paddingTop() - this.get_paddingBottom();
			switch(this.get_arrowPosition()._hx_index) {
			case 1:
				this.get_rightArrowSkin().set_x(xPosition + backgroundWidth + this.get_rightArrowGap());
				var rightArrowSkinY = this._arrowOffset + yPosition + this.get_paddingTop();
				if(this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).MIDDLE) {
					rightArrowSkinY += Math.round((contentHeight - this.get_rightArrowSkin().get_height()) / 2.0);
				} else if(this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).BOTTOM) {
					rightArrowSkinY += contentHeight - this.get_rightArrowSkin().get_height();
				}
				var minRightArrowSkinY = yPosition + this.get_paddingTop();
				if(minRightArrowSkinY > rightArrowSkinY) {
					rightArrowSkinY = minRightArrowSkinY;
				} else {
					var maxRightArrowSkinY = yPosition + this.get_paddingTop() + contentHeight - this.get_rightArrowSkin().get_height();
					if(maxRightArrowSkinY < rightArrowSkinY) {
						rightArrowSkinY = maxRightArrowSkinY;
					}
				}
				this.get_rightArrowSkin().set_y(rightArrowSkinY);
				break;
			case 2:
				var bottomArrowSkinX = this._arrowOffset + xPosition + this.get_paddingLeft();
				if(this.get_horizontalAlign() == (feathers_layout_HorizontalAlign().default).CENTER) {
					bottomArrowSkinX += Math.round((contentWidth - this.get_bottomArrowSkin().get_width()) / 2.0);
				} else if(this.get_horizontalAlign() == (feathers_layout_HorizontalAlign().default).RIGHT) {
					bottomArrowSkinX += contentWidth - this.get_bottomArrowSkin().get_width();
				}
				var minBottomArrowSkinX = xPosition + this.get_paddingLeft();
				if(minBottomArrowSkinX > bottomArrowSkinX) {
					bottomArrowSkinX = minBottomArrowSkinX;
				} else {
					var maxBottomArrowSkinX = xPosition + this.get_paddingLeft() + contentWidth - this.get_bottomArrowSkin().get_width();
					if(maxBottomArrowSkinX < bottomArrowSkinX) {
						bottomArrowSkinX = maxBottomArrowSkinX;
					}
				}
				this.get_bottomArrowSkin().set_x(bottomArrowSkinX);
				this.get_bottomArrowSkin().set_y(yPosition + backgroundHeight + this.get_bottomArrowGap());
				break;
			case 3:
				this.get_leftArrowSkin().set_x(xPosition - this.get_leftArrowSkin().get_width() - this.get_leftArrowGap());
				var leftArrowSkinY = this._arrowOffset + yPosition + this.get_paddingTop();
				if(this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).MIDDLE) {
					leftArrowSkinY += Math.round((contentHeight - this.get_leftArrowSkin().get_height()) / 2.0);
				} else if(this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).BOTTOM) {
					leftArrowSkinY += contentHeight - this.get_leftArrowSkin().get_height();
				}
				var minLeftArrowSkinY = yPosition + this.get_paddingTop();
				if(minLeftArrowSkinY > leftArrowSkinY) {
					leftArrowSkinY = minLeftArrowSkinY;
				} else {
					var maxLeftArrowSkinY = yPosition + this.get_paddingTop() + contentHeight - this.get_leftArrowSkin().get_height();
					if(maxLeftArrowSkinY < leftArrowSkinY) {
						leftArrowSkinY = maxLeftArrowSkinY;
					}
				}
				this.get_leftArrowSkin().set_y(leftArrowSkinY);
				break;
			default:
				var topArrowSkinX = this._arrowOffset + xPosition + this.get_paddingLeft();
				if(this.get_horizontalAlign() == (feathers_layout_HorizontalAlign().default).CENTER) {
					topArrowSkinX += Math.round((contentWidth - this.get_topArrowSkin().get_width()) / 2.0);
				} else if(this.get_horizontalAlign() == (feathers_layout_HorizontalAlign().default).RIGHT) {
					topArrowSkinX += contentWidth - this.get_topArrowSkin().get_width();
				}
				var minTopArrowSkinX = xPosition + this.get_paddingLeft();
				if(minTopArrowSkinX > topArrowSkinX) {
					topArrowSkinX = minTopArrowSkinX;
				} else {
					var maxTopArrowSkinX = xPosition + this.get_paddingLeft() + contentWidth - this.get_topArrowSkin().get_width();
					if(maxTopArrowSkinX < topArrowSkinX) {
						topArrowSkinX = maxTopArrowSkinX;
					}
				}
				this.get_topArrowSkin().set_x(topArrowSkinX);
				this.get_topArrowSkin().set_y(yPosition - this.get_topArrowSkin().get_height() - this.get_topArrowGap());
			}
		}
		if(this._content != null) {
			this._content.set_x(xPosition + this.get_paddingLeft());
			this._content.set_y(yPosition + this.get_paddingTop());
			var oldIgnoreContentResize = this._ignoreContentResize;
			this._ignoreContentResize = true;
			this._content.set_width(backgroundWidth - this.get_paddingLeft() - this.get_paddingRight());
			this._content.set_height(backgroundHeight - this.get_paddingTop() - this.get_paddingBottom());
			if((js_Boot().default).__implements(this._content,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._content , (feathers_core_IValidating().default))).validateNow();
			}
			this._ignoreContentResize = oldIgnoreContentResize;
		}
	},
	checkForOriginMoved: function() {
		if(this._origin == null) {
			return false;
		}
		var popUpRoot = (feathers_core_PopUpManager().default).forStage(this.stage).get_root();
		var originTopLeft = new (openfl_geom_Point())(this.get_origin().get_x(),this.get_origin().get_y());
		originTopLeft = this.get_origin().parent.localToGlobal(originTopLeft);
		originTopLeft = popUpRoot.globalToLocal(originTopLeft);
		var originBottomRight = new (openfl_geom_Point())(this.get_origin().get_x() + this.get_origin().get_width(),this.get_origin().get_y() + this.get_origin().get_height());
		originBottomRight = this.get_origin().parent.localToGlobal(originBottomRight);
		originBottomRight = popUpRoot.globalToLocal(originBottomRight);
		var bounds = new (openfl_geom_Rectangle())(originTopLeft.x,originTopLeft.y,originBottomRight.x - originTopLeft.x,originBottomRight.y - originTopLeft.y);
		var hasPopUpBounds = this._lastPopUpOriginBounds != null;
		if(hasPopUpBounds && this._lastPopUpOriginBounds.equals(bounds)) {
			return false;
		}
		this._lastPopUpOriginBounds = bounds;
		return true;
	},
	positionRelativeToOrigin: function() {
		this.checkForOriginMoved();
		var popUpRoot = (feathers_core_PopUpManager().default).forStage(this.stage).get_root();
		var stageBottomRight = new (openfl_geom_Point())(this.stage.stageWidth,this.stage.stageHeight);
		stageBottomRight = popUpRoot.globalToLocal(stageBottomRight);
		var upSpace = -Infinity;
		var downSpace = -Infinity;
		var rightSpace = -Infinity;
		var leftSpace = -Infinity;
		var positions = this.supportedPositions;
		if(positions == null) {
			positions = [(feathers_layout_RelativePosition().default).BOTTOM,(feathers_layout_RelativePosition().default).TOP,(feathers_layout_RelativePosition().default).RIGHT,(feathers_layout_RelativePosition().default).LEFT];
		}
		var _g = 0;
		while(_g < positions.length) {
			var position = positions[_g];
			++_g;
			switch(position._hx_index) {
			case 0:
				this.measureWithArrowPosition((feathers_layout_RelativePosition().default).BOTTOM);
				upSpace = this._lastPopUpOriginBounds.y - this.actualHeight;
				if(upSpace >= this.get_marginTop()) {
					Callout.positionAboveOrigin(this,this._lastPopUpOriginBounds);
					return;
				}
				if(upSpace < 0.0) {
					upSpace = 0.0;
				}
				break;
			case 1:
				this.measureWithArrowPosition((feathers_layout_RelativePosition().default).LEFT);
				rightSpace = stageBottomRight.x - this.actualWidth - (this._lastPopUpOriginBounds.x + this._lastPopUpOriginBounds.width);
				if(rightSpace >= this.get_marginRight()) {
					Callout.positionRightOfOrigin(this,this._lastPopUpOriginBounds);
					return;
				}
				if(rightSpace < 0.0) {
					rightSpace = 0.0;
				}
				break;
			case 3:
				this.measureWithArrowPosition((feathers_layout_RelativePosition().default).RIGHT);
				leftSpace = this._lastPopUpOriginBounds.x - this.actualWidth;
				if(leftSpace >= this.get_marginLeft()) {
					Callout.positionLeftOfOrigin(this,this._lastPopUpOriginBounds);
					return;
				}
				if(leftSpace < 0.0) {
					leftSpace = 0.0;
				}
				break;
			default:
				this.measureWithArrowPosition((feathers_layout_RelativePosition().default).TOP);
				downSpace = stageBottomRight.y - this.actualHeight - (this._lastPopUpOriginBounds.y + this._lastPopUpOriginBounds.height);
				if(downSpace >= this.get_marginBottom()) {
					Callout.positionBelowOrigin(this,this._lastPopUpOriginBounds);
					return;
				}
				if(downSpace < 0.0) {
					downSpace = 0.0;
				}
			}
		}
		if(downSpace != -Infinity && downSpace >= upSpace && downSpace >= rightSpace && downSpace >= leftSpace) {
			Callout.positionBelowOrigin(this,this._lastPopUpOriginBounds);
		} else if(upSpace != -Infinity && upSpace >= rightSpace && upSpace >= leftSpace) {
			Callout.positionAboveOrigin(this,this._lastPopUpOriginBounds);
		} else if(rightSpace != -Infinity && rightSpace >= leftSpace) {
			Callout.positionRightOfOrigin(this,this._lastPopUpOriginBounds);
		} else if(leftSpace != -Infinity) {
			Callout.positionLeftOfOrigin(this,this._lastPopUpOriginBounds);
		} else {
			Callout.positionBelowOrigin(this,this._lastPopUpOriginBounds);
		}
	},
	callout_addedToStageHandler: function(event) {
		this.stage.addEventListener("mouseDown",$bind(this,this.callout_stage_mouseDownHandler),false,0,true);
		this.stage.addEventListener("touchBegin",$bind(this,this.callout_stage_touchBeginHandler),false,0,true);
		if(this._origin != null) {
			this.addEventListener("enterFrame",$bind(this,this.callout_enterFrameHandler));
		}
	},
	callout_removedFromStageHandler: function(event) {
		this.stage.removeEventListener("mouseDown",$bind(this,this.callout_stage_mouseDownHandler));
		this.stage.removeEventListener("touchBegin",$bind(this,this.callout_stage_touchBeginHandler));
		this.removeEventListener("enterFrame",$bind(this,this.callout_enterFrameHandler));
		(feathers_events_FeathersEvent().default).dispatch(this,"close");
	},
	callout_enterFrameHandler: function(event) {
		if(!this.checkForOriginMoved()) {
			return;
		}
		this.setInvalid(Callout.INVALIDATION_FLAG_ORIGIN);
	},
	callout_origin_removedFromStageHandler: function(event) {
		this.close();
	},
	callout_content_resizeHandler: function(event) {
		if(this._ignoreContentResize) {
			return;
		}
		this._contentMeasurements.save(this.get_content());
		this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
	},
	callout_stage_mouseDownHandler: function(event) {
		if(!this.closeOnPointerOutside) {
			return;
		}
		if(this.hitTestPoint(event.stageX,event.stageY)) {
			return;
		}
		this.close();
	},
	callout_stage_touchBeginHandler: function(event) {
		if(event.isPrimaryTouchPoint) {
			return;
		}
		if(!this.closeOnPointerOutside) {
			return;
		}
		if(this.hitTestPoint(event.stageX,event.stageY)) {
			return;
		}
		this.close();
	},
	get_gap: function() {
		return this.__gap;
	},
	set_gap: function(value) {
		if(!this.setStyle("gap")) {
			return this.__gap;
		}
		if(this.__gap == value) {
			return this.__gap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_gap);
		this.__gap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__gap;
	},
	clearStyle_gap: function() {
		this.set_gap(0.0);
		return this.get_gap();
	},
	get_marginTop: function() {
		return this.__marginTop;
	},
	set_marginTop: function(value) {
		if(!this.setStyle("marginTop")) {
			return this.__marginTop;
		}
		if(this.__marginTop == value) {
			return this.__marginTop;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_marginTop);
		this.__marginTop = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__marginTop;
	},
	clearStyle_marginTop: function() {
		this.set_marginTop(0.0);
		return this.get_marginTop();
	},
	get_marginRight: function() {
		return this.__marginRight;
	},
	set_marginRight: function(value) {
		if(!this.setStyle("marginRight")) {
			return this.__marginRight;
		}
		if(this.__marginRight == value) {
			return this.__marginRight;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_marginRight);
		this.__marginRight = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__marginRight;
	},
	clearStyle_marginRight: function() {
		this.set_marginRight(0.0);
		return this.get_marginRight();
	},
	get_marginBottom: function() {
		return this.__marginBottom;
	},
	set_marginBottom: function(value) {
		if(!this.setStyle("marginBottom")) {
			return this.__marginBottom;
		}
		if(this.__marginBottom == value) {
			return this.__marginBottom;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_marginBottom);
		this.__marginBottom = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__marginBottom;
	},
	clearStyle_marginBottom: function() {
		this.set_marginBottom(0.0);
		return this.get_marginBottom();
	},
	get_marginLeft: function() {
		return this.__marginLeft;
	},
	set_marginLeft: function(value) {
		if(!this.setStyle("marginLeft")) {
			return this.__marginLeft;
		}
		if(this.__marginLeft == value) {
			return this.__marginLeft;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_marginLeft);
		this.__marginLeft = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__marginLeft;
	},
	clearStyle_marginLeft: function() {
		this.set_marginLeft(0.0);
		return this.get_marginLeft();
	},
	get_paddingTop: function() {
		return this.__paddingTop;
	},
	set_paddingTop: function(value) {
		if(!this.setStyle("paddingTop")) {
			return this.__paddingTop;
		}
		if(this.__paddingTop == value) {
			return this.__paddingTop;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingTop);
		this.__paddingTop = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingTop;
	},
	clearStyle_paddingTop: function() {
		this.set_paddingTop(0.0);
		return this.get_paddingTop();
	},
	get_paddingRight: function() {
		return this.__paddingRight;
	},
	set_paddingRight: function(value) {
		if(!this.setStyle("paddingRight")) {
			return this.__paddingRight;
		}
		if(this.__paddingRight == value) {
			return this.__paddingRight;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingRight);
		this.__paddingRight = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingRight;
	},
	clearStyle_paddingRight: function() {
		this.set_paddingRight(0.0);
		return this.get_paddingRight();
	},
	get_paddingBottom: function() {
		return this.__paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(!this.setStyle("paddingBottom")) {
			return this.__paddingBottom;
		}
		if(this.__paddingBottom == value) {
			return this.__paddingBottom;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingBottom);
		this.__paddingBottom = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingBottom;
	},
	clearStyle_paddingBottom: function() {
		this.set_paddingBottom(0.0);
		return this.get_paddingBottom();
	},
	get_paddingLeft: function() {
		return this.__paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(!this.setStyle("paddingLeft")) {
			return this.__paddingLeft;
		}
		if(this.__paddingLeft == value) {
			return this.__paddingLeft;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingLeft);
		this.__paddingLeft = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingLeft;
	},
	clearStyle_paddingLeft: function() {
		this.set_paddingLeft(0.0);
		return this.get_paddingLeft();
	},
	get_horizontalAlign: function() {
		return this.__horizontalAlign;
	},
	set_horizontalAlign: function(value) {
		if(!this.setStyle("horizontalAlign")) {
			return this.__horizontalAlign;
		}
		if(this.__horizontalAlign == value) {
			return this.__horizontalAlign;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_horizontalAlign);
		this.__horizontalAlign = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__horizontalAlign;
	},
	clearStyle_horizontalAlign: function() {
		this.set_horizontalAlign((feathers_layout_HorizontalAlign().default).CENTER);
		return this.get_horizontalAlign();
	},
	get_verticalAlign: function() {
		return this.__verticalAlign;
	},
	set_verticalAlign: function(value) {
		if(!this.setStyle("verticalAlign")) {
			return this.__verticalAlign;
		}
		if(this.__verticalAlign == value) {
			return this.__verticalAlign;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_verticalAlign);
		this.__verticalAlign = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__verticalAlign;
	},
	clearStyle_verticalAlign: function() {
		this.set_verticalAlign((feathers_layout_VerticalAlign().default).MIDDLE);
		return this.get_verticalAlign();
	},
	get_arrowPosition: function() {
		return this.__arrowPosition;
	},
	set_arrowPosition: function(value) {
		if(!this.setStyle("arrowPosition")) {
			return this.__arrowPosition;
		}
		if(this.__arrowPosition == value) {
			return this.__arrowPosition;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_arrowPosition);
		this.__arrowPosition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__arrowPosition;
	},
	clearStyle_arrowPosition: function() {
		this.set_arrowPosition((feathers_layout_RelativePosition().default).TOP);
		return this.get_arrowPosition();
	},
	get_backgroundSkin: function() {
		return this.__backgroundSkin;
	},
	set_backgroundSkin: function(value) {
		if(!this.setStyle("backgroundSkin")) {
			return this.__backgroundSkin;
		}
		if(this.__backgroundSkin == value) {
			return this.__backgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_backgroundSkin);
		this.__backgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__backgroundSkin;
	},
	clearStyle_backgroundSkin: function() {
		this.set_backgroundSkin(null);
		return this.get_backgroundSkin();
	},
	get_topArrowSkin: function() {
		return this.__topArrowSkin;
	},
	set_topArrowSkin: function(value) {
		if(!this.setStyle("topArrowSkin")) {
			return this.__topArrowSkin;
		}
		if(this.__topArrowSkin == value) {
			return this.__topArrowSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_topArrowSkin);
		this.__topArrowSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__topArrowSkin;
	},
	clearStyle_topArrowSkin: function() {
		this.set_topArrowSkin(null);
		return this.get_topArrowSkin();
	},
	get_rightArrowSkin: function() {
		return this.__rightArrowSkin;
	},
	set_rightArrowSkin: function(value) {
		if(!this.setStyle("rightArrowSkin")) {
			return this.__rightArrowSkin;
		}
		if(this.__rightArrowSkin == value) {
			return this.__rightArrowSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_rightArrowSkin);
		this.__rightArrowSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__rightArrowSkin;
	},
	clearStyle_rightArrowSkin: function() {
		this.set_rightArrowSkin(null);
		return this.get_rightArrowSkin();
	},
	get_bottomArrowSkin: function() {
		return this.__bottomArrowSkin;
	},
	set_bottomArrowSkin: function(value) {
		if(!this.setStyle("bottomArrowSkin")) {
			return this.__bottomArrowSkin;
		}
		if(this.__bottomArrowSkin == value) {
			return this.__bottomArrowSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_bottomArrowSkin);
		this.__bottomArrowSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__bottomArrowSkin;
	},
	clearStyle_bottomArrowSkin: function() {
		this.set_bottomArrowSkin(null);
		return this.get_bottomArrowSkin();
	},
	get_leftArrowSkin: function() {
		return this.__leftArrowSkin;
	},
	set_leftArrowSkin: function(value) {
		if(!this.setStyle("leftArrowSkin")) {
			return this.__leftArrowSkin;
		}
		if(this.__leftArrowSkin == value) {
			return this.__leftArrowSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_leftArrowSkin);
		this.__leftArrowSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__leftArrowSkin;
	},
	clearStyle_leftArrowSkin: function() {
		this.set_leftArrowSkin(null);
		return this.get_leftArrowSkin();
	},
	get_topArrowGap: function() {
		return this.__topArrowGap;
	},
	set_topArrowGap: function(value) {
		if(!this.setStyle("topArrowGap")) {
			return this.__topArrowGap;
		}
		if(this.__topArrowGap == value) {
			return this.__topArrowGap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_topArrowGap);
		this.__topArrowGap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__topArrowGap;
	},
	clearStyle_topArrowGap: function() {
		this.set_topArrowGap(0.0);
		return this.get_topArrowGap();
	},
	get_rightArrowGap: function() {
		return this.__rightArrowGap;
	},
	set_rightArrowGap: function(value) {
		if(!this.setStyle("rightArrowGap")) {
			return this.__rightArrowGap;
		}
		if(this.__rightArrowGap == value) {
			return this.__rightArrowGap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_rightArrowGap);
		this.__rightArrowGap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__rightArrowGap;
	},
	clearStyle_rightArrowGap: function() {
		this.set_rightArrowGap(0.0);
		return this.get_rightArrowGap();
	},
	get_bottomArrowGap: function() {
		return this.__bottomArrowGap;
	},
	set_bottomArrowGap: function(value) {
		if(!this.setStyle("bottomArrowGap")) {
			return this.__bottomArrowGap;
		}
		if(this.__bottomArrowGap == value) {
			return this.__bottomArrowGap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_bottomArrowGap);
		this.__bottomArrowGap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__bottomArrowGap;
	},
	clearStyle_bottomArrowGap: function() {
		this.set_bottomArrowGap(0.0);
		return this.get_bottomArrowGap();
	},
	get_leftArrowGap: function() {
		return this.__leftArrowGap;
	},
	set_leftArrowGap: function(value) {
		if(!this.setStyle("leftArrowGap")) {
			return this.__leftArrowGap;
		}
		if(this.__leftArrowGap == value) {
			return this.__leftArrowGap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_leftArrowGap);
		this.__leftArrowGap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__leftArrowGap;
	},
	clearStyle_leftArrowGap: function() {
		this.set_leftArrowGap(0.0);
		return this.get_leftArrowGap();
	},
	get_styleContext: function() {
		return Callout
	}
});
Callout.prototype.__class__ = Callout.prototype.constructor = $hxClasses["feathers.controls.Callout"] = Callout;

// Init



// Statics

Callout.show = function(content,origin,supportedPositions,modal,customOverlayFactory) {
	if(modal == null) {
		modal = true;
	}
	var callout = new Callout();
	callout.set_content(content);
	return Callout.showCallout(callout,origin,supportedPositions,modal,customOverlayFactory);
}
Callout.showCallout = function(callout,origin,supportedPositions,modal,customOverlayFactory) {
	if(modal == null) {
		modal = true;
	}
	callout.supportedPositions = supportedPositions;
	callout.set_origin(origin);
	var overlayFactory = customOverlayFactory;
	if(overlayFactory == null) {
		overlayFactory = function() {
			var overlay = new (openfl_display_Sprite())();
			overlay.get_graphics().beginFill(16711935,0.0);
			overlay.get_graphics().drawRect(0,0,1,1);
			overlay.get_graphics().endFill();
			return overlay;
		};
	}
	(feathers_core_PopUpManager().default).addPopUp(callout,origin,modal,false,overlayFactory);
	return callout;
}
Callout.positionBelowOrigin = function(callout,originBounds) {
	callout.measureWithArrowPosition((feathers_layout_RelativePosition().default).TOP);
	var popUpRoot = (feathers_core_PopUpManager().default).forStage(callout.stage).get_root();
	var stageTopLeft = new (openfl_geom_Point())();
	stageTopLeft = popUpRoot.globalToLocal(stageTopLeft);
	var stageBottomRight = new (openfl_geom_Point())(callout.stage.stageWidth,callout.stage.stageHeight);
	stageBottomRight = popUpRoot.globalToLocal(stageBottomRight);
	var idealXPosition = originBounds.x;
	switch(callout.get_horizontalAlign()._hx_index) {
	case 1:
		idealXPosition += (originBounds.width - callout.get_width()) / 2.0;
		break;
	case 2:
		idealXPosition += originBounds.width - callout.get_width();
		break;
	default:
	}
	var minX = stageTopLeft.x + callout.get_marginLeft();
	var maxX = stageBottomRight.x - callout.get_width() - callout.get_marginRight();
	var xPosition = idealXPosition;
	if(xPosition < minX) {
		xPosition = minX;
	} else if(xPosition > maxX) {
		xPosition = maxX;
	}
	callout.set_x(xPosition);
	callout.set_y(originBounds.y + originBounds.height + callout.get_gap());
	callout._arrowOffset = idealXPosition - xPosition;
	callout.set_arrowPosition((feathers_layout_RelativePosition().default).TOP);
}
Callout.positionAboveOrigin = function(callout,originBounds) {
	callout.measureWithArrowPosition((feathers_layout_RelativePosition().default).BOTTOM);
	var popUpRoot = (feathers_core_PopUpManager().default).forStage(callout.stage).get_root();
	var stageTopLeft = new (openfl_geom_Point())();
	stageTopLeft = popUpRoot.globalToLocal(stageTopLeft);
	var stageBottomRight = new (openfl_geom_Point())(callout.stage.stageWidth,callout.stage.stageHeight);
	stageBottomRight = popUpRoot.globalToLocal(stageBottomRight);
	var idealXPosition = originBounds.x;
	switch(callout.get_horizontalAlign()._hx_index) {
	case 1:
		idealXPosition += (originBounds.width - callout.get_width()) / 2.0;
		break;
	case 2:
		idealXPosition += originBounds.width - callout.get_width();
		break;
	default:
	}
	var minX = stageTopLeft.x + callout.get_marginLeft();
	var maxX = stageBottomRight.x - callout.get_width() - callout.get_marginRight();
	var xPosition = idealXPosition;
	if(xPosition < minX) {
		xPosition = minX;
	} else if(xPosition > maxX) {
		xPosition = maxX;
	}
	callout.set_x(xPosition);
	callout.set_y(originBounds.y - callout.get_height() - callout.get_gap());
	callout._arrowOffset = idealXPosition - xPosition;
	callout.set_arrowPosition((feathers_layout_RelativePosition().default).BOTTOM);
}
Callout.positionLeftOfOrigin = function(callout,originBounds) {
	callout.measureWithArrowPosition((feathers_layout_RelativePosition().default).RIGHT);
	var popUpRoot = (feathers_core_PopUpManager().default).forStage(callout.stage).get_root();
	var stageTopLeft = new (openfl_geom_Point())();
	stageTopLeft = popUpRoot.globalToLocal(stageTopLeft);
	var stageBottomRight = new (openfl_geom_Point())(callout.stage.stageWidth,callout.stage.stageHeight);
	stageBottomRight = popUpRoot.globalToLocal(stageBottomRight);
	var idealYPosition = originBounds.y;
	switch(callout.get_verticalAlign()._hx_index) {
	case 1:
		idealYPosition += (originBounds.height - callout.get_height()) / 2.0;
		break;
	case 2:
		idealYPosition += originBounds.height - callout.get_height();
		break;
	default:
	}
	var minY = stageTopLeft.y + callout.get_marginTop();
	var maxY = stageBottomRight.y - callout.get_height() - callout.get_marginBottom();
	var yPosition = idealYPosition;
	if(yPosition < minY) {
		yPosition = minY;
	} else if(yPosition > maxY) {
		yPosition = maxY;
	}
	callout.set_x(originBounds.x - callout.get_width() - callout.get_gap());
	callout.set_y(yPosition);
	callout._arrowOffset = idealYPosition - yPosition;
	callout.set_arrowPosition((feathers_layout_RelativePosition().default).RIGHT);
}
Callout.positionRightOfOrigin = function(callout,originBounds) {
	callout.measureWithArrowPosition((feathers_layout_RelativePosition().default).RIGHT);
	var popUpRoot = (feathers_core_PopUpManager().default).forStage(callout.stage).get_root();
	var stageTopLeft = new (openfl_geom_Point())();
	stageTopLeft = popUpRoot.globalToLocal(stageTopLeft);
	var stageBottomRight = new (openfl_geom_Point())(callout.stage.stageWidth,callout.stage.stageHeight);
	stageBottomRight = popUpRoot.globalToLocal(stageBottomRight);
	var idealYPosition = originBounds.y;
	switch(callout.get_verticalAlign()._hx_index) {
	case 1:
		idealYPosition += (originBounds.height - callout.get_height()) / 2.0;
		break;
	case 2:
		idealYPosition += originBounds.height - callout.get_height();
		break;
	default:
	}
	var minY = stageTopLeft.y + callout.get_marginTop();
	var maxY = stageBottomRight.y - callout.get_height() - callout.get_marginBottom();
	var yPosition = idealYPosition;
	if(yPosition < minY) {
		yPosition = minY;
	} else if(yPosition > maxY) {
		yPosition = maxY;
	}
	callout.set_x(originBounds.x + originBounds.width + callout.get_gap());
	callout.set_y(yPosition);
	callout._arrowOffset = idealYPosition - yPosition;
	callout.set_arrowPosition((feathers_layout_RelativePosition().default).LEFT);
}
Callout.__meta__ = { obj : { defaultXmlProperty : ["content"]}}
Callout.INVALIDATION_FLAG_ORIGIN = (feathers_core_InvalidationFlag().default).CUSTOM("origin")

// Export

exports["default"] = Callout;

/***/ }),

/***/ "./lib/_gen/feathers/controls/Check.js":
/*!*********************************************!*\
  !*** ./lib/_gen/feathers/controls/Check.js ***!
  \*********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.Check

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_ToggleButton() {return __webpack_require__(/*! ./../../feathers/controls/ToggleButton */ "./lib/_gen/feathers/controls/ToggleButton.js");}
function feathers_themes_steel_components_SteelCheckStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelCheckStyles */ "./lib/_gen/feathers/themes/steel/components/SteelCheckStyles.js");}

// Constructor

var Check = function(text,selected,changeListener) {
	if(selected == null) {
		selected = false;
	}
	this.initializeCheckTheme();
	(feathers_controls_ToggleButton().default).call(this,text,selected,changeListener);
}

// Meta

Check.__name__ = "feathers.controls.Check";
Check.__isInterface__ = false;
Check.__super__ = (feathers_controls_ToggleButton().default);
Check.prototype = $extend((feathers_controls_ToggleButton().default).prototype, {
	initializeCheckTheme: function() {
		(feathers_themes_steel_components_SteelCheckStyles().default).initialize();
	},
	get_styleContext: function() {
		return Check
	}
});
Check.prototype.__class__ = Check.prototype.constructor = $hxClasses["feathers.controls.Check"] = Check;

// Init



// Statics




// Export

exports["default"] = Check;

/***/ }),

/***/ "./lib/_gen/feathers/controls/ComboBox.js":
/*!************************************************!*\
  !*** ./lib/_gen/feathers/controls/ComboBox.js ***!
  \************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.ComboBox

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IStageFocusDelegate() {return __webpack_require__(/*! ./../../feathers/core/IStageFocusDelegate */ "./lib/_gen/feathers/core/IStageFocusDelegate.js");}
function feathers_core_IDataSelector() {return __webpack_require__(/*! ./../../feathers/core/IDataSelector */ "./lib/_gen/feathers/core/IDataSelector.js");}
function feathers_core_IIndexSelector() {return __webpack_require__(/*! ./../../feathers/core/IIndexSelector */ "./lib/_gen/feathers/core/IIndexSelector.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_themes_steel_components_SteelComboBoxStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelComboBoxStyles */ "./lib/_gen/feathers/themes/steel/components/SteelComboBoxStyles.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_controls_popups_DropDownPopUpAdapter() {return __webpack_require__(/*! ./../../feathers/controls/popups/DropDownPopUpAdapter */ "./lib/_gen/feathers/controls/popups/DropDownPopUpAdapter.js");}
function feathers_utils_DisplayObjectFactory() {return __webpack_require__(/*! ./../../feathers/utils/DisplayObjectFactory */ "./lib/_gen/feathers/utils/DisplayObjectFactory.js");}
function feathers_controls_Button() {return __webpack_require__(/*! ./../../feathers/controls/Button */ "./lib/_gen/feathers/controls/Button.js");}
function feathers_controls_TextInput() {return __webpack_require__(/*! ./../../feathers/controls/TextInput */ "./lib/_gen/feathers/controls/TextInput.js");}
function feathers_controls_ListView() {return __webpack_require__(/*! ./../../feathers/controls/ListView */ "./lib/_gen/feathers/controls/ListView.js");}
function feathers_utils_DisplayObjectRecycler() {return __webpack_require__(/*! ./../../feathers/utils/DisplayObjectRecycler */ "./lib/_gen/feathers/utils/DisplayObjectRecycler.js");}
function feathers_controls_dataRenderers_ItemRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/ItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ItemRenderer.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}

// Constructor

var ComboBox = function(dataProvider,changeListener) {
	this.__customListViewVariant = null;
	this.__customButtonVariant = null;
	this.__customTextInputVariant = null;
	this.__popUpAdapter = new (feathers_controls_popups_DropDownPopUpAdapter().default)();
	this.openListViewOnFocus = false;
	this._filterText = null;
	this._previousCustomListViewVariant = null;
	this._previousCustomButtonVariant = null;
	this._previousCustomTextInputVariant = null;
	this._ignoreButtonToggleListView = false;
	this._ignoreListViewChange = false;
	this._ignoreTextInputChange = false;
	this._itemRendererRecycler = (feathers_utils_DisplayObjectRecycler().default).withClass((feathers_controls_dataRenderers_ItemRenderer().default));
	this._selectedItem = null;
	this._customSelectedItem = null;
	this._selectedIndex = -1;
	this.pendingSelectedIndex = -1;
	this._allowCustomUserValue = true;
	this.textInputMeasurements = new (feathers_layout_Measurements().default)();
	this.buttonMeasurements = new (feathers_layout_Measurements().default)();
	this.initializeComboBoxTheme();
	(feathers_core_FeathersControl().default).call(this);
	this.set_dataProvider(dataProvider);
	this.addEventListener("focusIn",$bind(this,this.comboBox_focusInHandler));
	this.addEventListener("removedFromStage",$bind(this,this.comboBox_removedFromStageHandler));
	this.addEventListener("keyUp",$bind(this,this.comboBox_keyUpHandler));
	if(changeListener != null) {
		this.addEventListener("change",changeListener);
	}
}

// Meta

ComboBox.__name__ = "feathers.controls.ComboBox";
ComboBox.__isInterface__ = false;
ComboBox.__interfaces__ = [(feathers_core_IStageFocusDelegate().default),(feathers_core_IDataSelector().default),(feathers_core_IIndexSelector().default)];
ComboBox.__super__ = (feathers_core_FeathersControl().default);
ComboBox.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_stageFocusTarget: function() {
		return this.textInput;
	},
	get_dataProvider: function() {
		return this._dataProvider;
	},
	set_dataProvider: function(value) {
		if(this._dataProvider == value) {
			return this._dataProvider;
		}
		if(this._dataProvider != null) {
			this._dataProvider.removeEventListener("removeAll",$bind(this,this.comboBox_dataProvider_removeAllHandler));
		}
		var oldSelectedIndex = this._selectedIndex;
		var oldSelectedItem = this._selectedItem;
		this._dataProvider = value;
		if(this._dataProvider != null) {
			this._dataProvider.addEventListener("removeAll",$bind(this,this.comboBox_dataProvider_removeAllHandler));
		}
		if(this._dataProvider == null || this._dataProvider.get_length() == 0) {
			this._selectedIndex = -1;
			this._selectedItem = null;
		} else {
			this._selectedIndex = 0;
			this._selectedItem = this._dataProvider.get(0);
		}
		if(this._selectedIndex != oldSelectedIndex || this._selectedItem != oldSelectedItem) {
			this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
		}
		if(this._dataProvider != null) {
			this._dataProvider.set_filterFunction($bind(this,this.comboBoxFilterFunction));
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._dataProvider;
	},
	get_allowCustomUserValue: function() {
		return this._allowCustomUserValue;
	},
	set_allowCustomUserValue: function(value) {
		if(this._allowCustomUserValue == value) {
			return this._allowCustomUserValue;
		}
		this._allowCustomUserValue = value;
		return this._allowCustomUserValue;
	},
	get_selectedIndex: function() {
		return this._selectedIndex;
	},
	set_selectedIndex: function(value) {
		if(this._dataProvider == null) {
			value = -1;
		}
		if(this._selectedIndex == value && (!this.get_open() || this.pendingSelectedIndex == value)) {
			return this._selectedIndex;
		}
		this._selectedIndex = value;
		if(this.get_open()) {
			this.pendingSelectedIndex = value;
		}
		if(this._selectedIndex == -1) {
			this._selectedItem = null;
		} else {
			this._selectedItem = this._dataProvider.get(this._selectedIndex);
		}
		this._customSelectedItem = null;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedIndex;
	},
	get_maxSelectedIndex: function() {
		if(this._dataProvider == null) {
			return -1;
		}
		return this._dataProvider.get_length() - 1;
	},
	get_selectedItem: function() {
		if(this._customSelectedItem != null) {
			return this._customSelectedItem;
		}
		return this._selectedItem;
	},
	set_selectedItem: function(value) {
		if(value == null || this._dataProvider == null) {
			this.set_selectedIndex(-1);
			return this._selectedItem;
		}
		var index = this._dataProvider.indexOf(value);
		if(index == -1) {
			if(this._allowCustomUserValue) {
				this._selectedIndex = -1;
				this._selectedItem = null;
				this._customSelectedItem = value;
				this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
				(feathers_events_FeathersEvent().default).dispatch(this,"change");
				return this._customSelectedItem;
			}
			this.set_selectedIndex(-1);
			return this._selectedItem;
		}
		if(this._selectedItem == value && this._selectedIndex == index) {
			return this._selectedItem;
		}
		this._selectedIndex = index;
		this._selectedItem = value;
		this._customSelectedItem = null;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedItem;
	},
	get_prompt: function() {
		return this._prompt;
	},
	set_prompt: function(value) {
		if(this._prompt == value) {
			return this._prompt;
		}
		this._prompt = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._prompt;
	},
	get_itemRendererRecycler: function() {
		return this._itemRendererRecycler;
	},
	set_itemRendererRecycler: function(value) {
		if(this._itemRendererRecycler == value) {
			return this._itemRendererRecycler;
		}
		this._itemRendererRecycler = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._itemRendererRecycler;
	},
	itemToText: function(data) {
		return (Std().default).string(data);
	},
	itemToEnabled: function(data) {
		return true;
	},
	textToItem: function(text) {
		return text;
	},
	get_buttonFactory: function() {
		return this._buttonFactory;
	},
	set_buttonFactory: function(value) {
		if(this._buttonFactory == value) {
			return this._buttonFactory;
		}
		this._buttonFactory = value;
		this.setInvalid(ComboBox.INVALIDATION_FLAG_BUTTON_FACTORY);
		return this._buttonFactory;
	},
	get_textInputFactory: function() {
		return this._textInputFactory;
	},
	set_textInputFactory: function(value) {
		if(this._textInputFactory == value) {
			return this._textInputFactory;
		}
		this._textInputFactory = value;
		this.setInvalid(ComboBox.INVALIDATION_FLAG_TEXT_INPUT_FACTORY);
		return this._textInputFactory;
	},
	get_listViewFactory: function() {
		return this._listViewFactory;
	},
	set_listViewFactory: function(value) {
		if(this._listViewFactory == value) {
			return this._listViewFactory;
		}
		this._listViewFactory = value;
		this.setInvalid(ComboBox.INVALIDATION_FLAG_LIST_VIEW_FACTORY);
		return this._listViewFactory;
	},
	get_open: function() {
		if(this.listView != null) {
			return this.listView.parent != null;
		} else {
			return false;
		}
	},
	showFocus: function(show) {
		(feathers_core_FeathersControl().default).prototype.showFocus.call(this,show);
		if(this.textInput != null) {
			this.textInput.showFocus(show);
		}
	},
	openListView: function() {
		if(this.get_open() || this.stage == null) {
			return;
		}
		this.validateNow();
		this._filterText = null;
		if(this._dataProvider != null) {
			this._dataProvider.refresh();
		}
		this.pendingSelectedIndex = this._selectedIndex;
		this.get_popUpAdapter().addEventListener("open",$bind(this,this.comboBox_popUpAdapter_openHandler));
		this.get_popUpAdapter().addEventListener("close",$bind(this,this.comboBox_popUpAdapter_closeHandler));
		this.get_popUpAdapter().open(this.listView,this);
		this.listView.set_visible(this._dataProvider != null && this._dataProvider.get_length() > 0);
		this.listView.validateNow();
		this.listView.addEventListener("removedFromStage",$bind(this,this.comboBox_listView_removedFromStageHandler));
		this.textInput.addEventListener("focusOut",$bind(this,this.comboBox_textInput_focusOutHandler));
		this.stage.addEventListener("mouseDown",$bind(this,this.comboBox_stage_mouseDownHandler),false,0,true);
		this.stage.addEventListener("touchBegin",$bind(this,this.comboBox_stage_touchBeginHandler),false,0,true);
		this.listView.scrollToIndex(this._selectedIndex);
	},
	closeListView: function() {
		if(!this.get_open()) {
			return;
		}
		this.get_popUpAdapter().close();
	},
	initializeComboBoxTheme: function() {
		(feathers_themes_steel_components_SteelComboBoxStyles().default).initialize();
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var selectionInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		if(this._previousCustomTextInputVariant != this.get_customTextInputVariant()) {
			this.setInvalidationFlag(ComboBox.INVALIDATION_FLAG_TEXT_INPUT_FACTORY);
		}
		if(this._previousCustomButtonVariant != this.get_customButtonVariant()) {
			this.setInvalidationFlag(ComboBox.INVALIDATION_FLAG_BUTTON_FACTORY);
		}
		if(this._previousCustomListViewVariant != this.get_customListViewVariant()) {
			this.setInvalidationFlag(ComboBox.INVALIDATION_FLAG_LIST_VIEW_FACTORY);
		}
		var buttonFactoryInvalid = this.isInvalid(ComboBox.INVALIDATION_FLAG_BUTTON_FACTORY);
		var textInputFactoryInvalid = this.isInvalid(ComboBox.INVALIDATION_FLAG_TEXT_INPUT_FACTORY);
		var listViewFactoryInvalid = this.isInvalid(ComboBox.INVALIDATION_FLAG_LIST_VIEW_FACTORY);
		if(buttonFactoryInvalid) {
			this.createButton();
		}
		if(textInputFactoryInvalid) {
			this.createTextInput();
		}
		if(listViewFactoryInvalid) {
			this.createListView();
		}
		if(dataInvalid || listViewFactoryInvalid) {
			this.refreshListViewData();
		}
		if(dataInvalid || textInputFactoryInvalid) {
			this.refreshTextInputData();
		}
		if(selectionInvalid || listViewFactoryInvalid || buttonFactoryInvalid || textInputFactoryInvalid) {
			this.refreshSelection();
		}
		if(stateInvalid || listViewFactoryInvalid || buttonFactoryInvalid || textInputFactoryInvalid) {
			this.refreshEnabled();
		}
		this.measure();
		this.layoutChildren();
		this._previousCustomTextInputVariant = this.get_customTextInputVariant();
		this._previousCustomButtonVariant = this.get_customButtonVariant();
		this._previousCustomListViewVariant = this.get_customListViewVariant();
	},
	createButton: function() {
		if(this.button != null) {
			this.button.removeEventListener("mouseDown",$bind(this,this.comboBox_button_mouseDownHandler));
			this.button.removeEventListener("touchBegin",$bind(this,this.comboBox_button_touchBeginHandler));
			this.removeChild(this.button);
			if(this._oldButtonFactory.destroy != null) {
				this._oldButtonFactory.destroy(this.button);
			}
			this._oldButtonFactory = null;
			this.button = null;
		}
		var factory = this._buttonFactory != null ? this._buttonFactory : ComboBox.defaultButtonFactory;
		this._oldButtonFactory = factory;
		this.button = factory.create();
		if(this.button.get_variant() == null) {
			this.button.set_variant(this.get_customButtonVariant() != null ? this.get_customButtonVariant() : ComboBox.CHILD_VARIANT_BUTTON);
		}
		this.button.set_focusEnabled(false);
		this.button.addEventListener("mouseDown",$bind(this,this.comboBox_button_mouseDownHandler));
		this.button.addEventListener("touchBegin",$bind(this,this.comboBox_button_touchBeginHandler));
		this.button.initializeNow();
		this.buttonMeasurements.save(this.button);
		this.addChild(this.button);
	},
	createTextInput: function() {
		if(this.textInput != null) {
			this.textInput.removeEventListener("change",$bind(this,this.comboBox_textInput_changeHandler));
			this.textInput.removeEventListener("keyDown",$bind(this,this.comboBox_textInput_keyDownHandler));
			this.textInput.removeEventListener("focusIn",$bind(this,this.comboBox_textInput_focusInHandler));
			this.textInput.removeEventListener("mouseDown",$bind(this,this.comboBox_textInput_mouseDownHandler));
			this.textInput.removeEventListener("mouseFocusChange",$bind(this,this.comboBox_textInput_mouseFocusChangeHandler));
			this.removeChild(this.textInput);
			if(this._oldTextInputFactory.destroy != null) {
				this._oldTextInputFactory.destroy(this.textInput);
			}
			this._oldTextInputFactory = null;
			this.textInput = null;
		}
		var factory = this._textInputFactory != null ? this._textInputFactory : ComboBox.defaultTextInputFactory;
		this._oldTextInputFactory = factory;
		this.textInput = factory.create();
		if(this.textInput.get_variant() == null) {
			this.textInput.set_variant(this.get_customTextInputVariant() != null ? this.get_customTextInputVariant() : ComboBox.CHILD_VARIANT_TEXT_INPUT);
		}
		this.textInput.addEventListener("change",$bind(this,this.comboBox_textInput_changeHandler));
		this.textInput.addEventListener("keyDown",$bind(this,this.comboBox_textInput_keyDownHandler));
		this.textInput.addEventListener("focusIn",$bind(this,this.comboBox_textInput_focusInHandler));
		this.textInput.addEventListener("mouseDown",$bind(this,this.comboBox_textInput_mouseDownHandler));
		this.textInput.addEventListener("mouseFocusChange",$bind(this,this.comboBox_textInput_mouseFocusChangeHandler));
		this.textInput.initializeNow();
		this.textInputMeasurements.save(this.textInput);
		this.addChild(this.textInput);
	},
	createListView: function() {
		if(this.listView != null) {
			this.listView.removeEventListener("change",$bind(this,this.comboBox_listView_changeHandler));
			this.listView.removeEventListener("itemTrigger",$bind(this,this.comboBox_listView_itemTriggerHandler));
			this.listView.set_focusOwner(null);
			if(this._oldListViewFactory.destroy != null) {
				this._oldListViewFactory.destroy(this.listView);
			}
			this._oldListViewFactory = null;
			this.listView = null;
		}
		var factory = this._listViewFactory != null ? this._listViewFactory : ComboBox.defaultListViewFactory;
		this._oldListViewFactory = factory;
		this.listView = factory.create();
		this.listView.set_focusOwner(this);
		this.listView.set_focusEnabled(false);
		if(this.listView.get_variant() == null) {
			this.listView.set_variant(this.get_customListViewVariant() != null ? this.get_customListViewVariant() : ComboBox.CHILD_VARIANT_LIST_VIEW);
		}
		this.listView.addEventListener("change",$bind(this,this.comboBox_listView_changeHandler));
		this.listView.addEventListener("itemTrigger",$bind(this,this.comboBox_listView_itemTriggerHandler));
	},
	refreshListViewData: function() {
		var oldIgnoreListViewChange = this._ignoreListViewChange;
		this._ignoreListViewChange = true;
		this.listView.set_dataProvider(this._dataProvider);
		this._ignoreListViewChange = oldIgnoreListViewChange;
		this.listView.set_itemRendererRecycler(this._itemRendererRecycler);
		this.listView.itemToEnabled = $bind(this,this.itemToEnabled);
		this.listView.itemToText = $bind(this,this.itemToText);
	},
	refreshTextInputData: function() {
		this.textInput.set_prompt(this._prompt);
	},
	refreshSelection: function() {
		var oldIgnoreListViewChange = this._ignoreListViewChange;
		this._ignoreListViewChange = true;
		this.listView.set_selectedIndex(this._selectedIndex);
		this._ignoreListViewChange = oldIgnoreListViewChange;
		var oldIgnoreTextInputChange = this._ignoreTextInputChange;
		this._ignoreTextInputChange = true;
		var item = this._customSelectedItem != null ? this._customSelectedItem : this._selectedItem;
		if(item != null) {
			this.textInput.set_text(typeof(item) == "string" ? (js_Boot().default).__cast(item , String) : this.itemToText(item));
		} else {
			this.textInput.set_text("");
		}
		this._ignoreTextInputChange = oldIgnoreTextInputChange;
	},
	refreshEnabled: function() {
		this.button.set_enabled(this._enabled);
		this.textInput.set_enabled(this._enabled);
		this.listView.set_enabled(this._enabled);
	},
	comboBoxFilterFunction: function(item) {
		if(this._filterText == null || this._filterText.length == 0) {
			return true;
		}
		var itemText = typeof(item) == "string" ? (js_Boot().default).__cast(item , String) : this.itemToText(item);
		itemText = itemText.toLowerCase();
		return itemText.indexOf(this._filterText.toLowerCase()) != -1;
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		this.buttonMeasurements.restore(this.button);
		this.button.validateNow();
		this.textInputMeasurements.restore(this.textInput);
		this.textInput.validateNow();
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			newWidth = this.button.get_width() + this.textInput.get_width();
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			newHeight = Math.max(this.button.get_height(),this.textInput.get_height());
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			newMinWidth = this.button.get_minWidth() + this.textInput.get_minWidth();
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			newMinHeight = Math.max(this.button.get_minHeight(),this.textInput.get_minHeight());
		}
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight);
	},
	layoutChildren: function() {
		this.button.validateNow();
		this.button.set_x(this.actualWidth - this.button.get_width());
		this.button.set_y(0.0);
		if(this.button.get_height() != this.actualHeight) {
			this.button.set_height(this.actualHeight);
		}
		this.textInput.set_x(0.0);
		this.textInput.set_y(0.0);
		var textInputWidth = this.actualWidth - this.button.get_width();
		if(this.textInput.get_width() != textInputWidth) {
			this.textInput.set_width(textInputWidth);
		}
		if(this.textInput.get_height() != this.actualHeight) {
			this.textInput.set_height(this.actualHeight);
		}
		this.button.validateNow();
		this.textInput.validateNow();
	},
	navigateWithKeyboard: function(event) {
		if(event.isDefaultPrevented()) {
			return;
		}
		if(this._dataProvider == null || this._dataProvider.get_length() == 0) {
			return;
		}
		var result = this.get_open() ? this.pendingSelectedIndex : this._selectedIndex;
		switch(event.keyCode) {
		case 33:
			--result;
			break;
		case 34:
			++result;
			break;
		case 35:
			result = this._dataProvider.get_length() - 1;
			break;
		case 36:
			result = 0;
			break;
		case 38:
			--result;
			break;
		case 40:
			++result;
			break;
		default:
			return;
		}
		if(result < 0) {
			result = 0;
		} else if(result >= this._dataProvider.get_length()) {
			result = this._dataProvider.get_length() - 1;
		}
		event.preventDefault();
		this.set_selectedIndex(result);
		if(this.textInput.get_selectionActiveIndex() != this.textInput.get_selectionAnchorIndex()) {
			this.textInput.selectRange(this.textInput.get_selectionAnchorIndex(),this.textInput.get_selectionAnchorIndex());
		}
		if(this.get_open()) {
			this.listView.set_selectedIndex(result);
			this.listView.scrollToIndex(result);
		}
	},
	comboBox_textInput_keyDownHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		this.navigateWithKeyboard(event);
		if(event.keyCode == 13) {
			event.preventDefault();
			this.closeListView();
		}
	},
	comboBox_textInput_changeHandler: function(event) {
		if(this._ignoreTextInputChange) {
			return;
		}
		if(!this.get_open()) {
			this.openListView();
		}
		if(this._dataProvider != null) {
			this.pendingSelectedIndex = -1;
			this._filterText = this.textInput.get_text();
			this._dataProvider.refresh();
		}
		this.listView.set_visible(this.get_open() && this._dataProvider != null && this._dataProvider.get_length() > 0);
	},
	comboBox_textInput_mouseFocusChangeHandler: function(event) {
		if(this.get_focusManager() != null || event.isDefaultPrevented() || event.target != null && !this.textInput.contains(event.target) || event.relatedObject != null && !this.listView.contains(event.relatedObject)) {
			return;
		}
		event.preventDefault();
	},
	comboBox_textInput_focusInHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(this.openListViewOnFocus && !this.get_open()) {
			this.openListView();
			this._ignoreButtonToggleListView = true;
			this.addEventListener("enterFrame",$bind(this,this.comboBox_focus_enterFrameHandler));
		}
	},
	comboBox_focus_enterFrameHandler: function(event) {
		this.removeEventListener("enterFrame",$bind(this,this.comboBox_focus_enterFrameHandler));
		this._ignoreButtonToggleListView = false;
	},
	comboBox_textInput_focusOutHandler: function(event) {
		if(event.relatedObject != null && (event.relatedObject == this.listView || this.listView.contains(event.relatedObject))) {
			return;
		}
	},
	comboBox_button_mouseDownHandler: function(event) {
		if(this.openListViewOnFocus && this.get_open() && this._ignoreButtonToggleListView) {
			return;
		}
		if(!this._enabled) {
			return;
		}
		if(this.get_open()) {
			this.closeListView();
		} else {
			this.openListView();
		}
	},
	comboBox_button_touchBeginHandler: function(event) {
		if(this.openListViewOnFocus && this.get_open() && this._ignoreButtonToggleListView) {
			return;
		}
		if(!this._enabled) {
			return;
		}
		if(event.isPrimaryTouchPoint) {
			return;
		}
		if(this.get_open()) {
			this.closeListView();
		} else {
			this.openListView();
		}
	},
	comboBox_listView_itemTriggerHandler: function(event) {
		this._filterText = null;
		this.pendingSelectedIndex = event.state.index;
		this.dispatchEvent(event);
		if(!this.get_popUpAdapter().get_persistent()) {
			this.closeListView();
		}
	},
	comboBox_listView_changeHandler: function(event) {
		if(this._ignoreListViewChange) {
			return;
		}
		if(this.get_open()) {
			this.pendingSelectedIndex = this.listView.get_selectedIndex();
		} else {
			this.pendingSelectedIndex = -1;
			this._filterText = null;
			if(this._selectedIndex != this.listView.get_selectedIndex() || this._selectedItem != this.listView.get_selectedItem()) {
				this._selectedIndex = this.listView.get_selectedIndex();
				this._selectedItem = this.listView.get_selectedItem();
				(feathers_events_FeathersEvent().default).dispatch(this,"change");
			}
			this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		}
	},
	comboBox_listView_removedFromStageHandler: function(event) {
		this.listView.removeEventListener("removedFromStage",$bind(this,this.comboBox_listView_removedFromStageHandler));
		this.textInput.removeEventListener("focusOut",$bind(this,this.comboBox_textInput_focusOutHandler));
		this.stage.removeEventListener("mouseDown",$bind(this,this.comboBox_stage_mouseDownHandler));
		this.stage.removeEventListener("touchBegin",$bind(this,this.comboBox_stage_touchBeginHandler));
	},
	comboBox_focusInHandler: function(event) {
		if(this.stage != null && this.stage.get_focus() != null && this.textInput != null && !this.textInput.contains(this.stage.get_focus())) {
			event.stopImmediatePropagation();
			this.stage.set_focus(this.textInput);
		}
	},
	comboBox_removedFromStageHandler: function(event) {
		this.closeListView();
	},
	comboBox_keyUpHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		switch(event.keyCode) {
		case 27:
			if(event.isDefaultPrevented()) {
				return;
			}
			if(!this.get_open()) {
				return;
			}
			event.preventDefault();
			this.closeListView();
			break;
		case 1073742094:
			if(event.isDefaultPrevented()) {
				return;
			}
			if(!this.get_open()) {
				return;
			}
			event.preventDefault();
			this.closeListView();
			break;
		}
	},
	comboBox_stage_mouseDownHandler: function(event) {
		if(this.hitTestPoint(event.stageX,event.stageY) || this.listView.hitTestPoint(event.stageX,event.stageY)) {
			return;
		}
		this.closeListView();
	},
	comboBox_stage_touchBeginHandler: function(event) {
		if(event.isPrimaryTouchPoint) {
			return;
		}
		if(this.hitTestPoint(event.stageX,event.stageY) || this.listView.hitTestPoint(event.stageX,event.stageY)) {
			return;
		}
		this.closeListView();
	},
	comboBox_popUpAdapter_openHandler: function(event) {
		(feathers_events_FeathersEvent().default).dispatch(this,"open");
	},
	comboBox_popUpAdapter_closeHandler: function(event) {
		this.get_popUpAdapter().removeEventListener("open",$bind(this,this.comboBox_popUpAdapter_openHandler));
		this.get_popUpAdapter().removeEventListener("close",$bind(this,this.comboBox_popUpAdapter_closeHandler));
		(feathers_events_FeathersEvent().default).dispatch(this,"close");
		var newSelectedItem = null;
		if(this.pendingSelectedIndex != -1) {
			newSelectedItem = this._dataProvider.get(this.pendingSelectedIndex);
		} else if(this._filterText != null) {
			var filterText = this._filterText.toLowerCase();
			if(this._dataProvider != null && this._dataProvider.get_length() > 0) {
				var item = this._dataProvider.iterator();
				while(item.hasNext()) {
					var item1 = item.next();
					var itemText = typeof(item1) == "string" ? (js_Boot().default).__cast(item1 , String) : this.itemToText(item1);
					itemText = itemText.toLowerCase();
					if(itemText == filterText) {
						newSelectedItem = item1;
						break;
					}
				}
			}
		} else {
			return;
		}
		var customSelectedItem = null;
		if(this._allowCustomUserValue && newSelectedItem == null && this._filterText != null && this._filterText.length > 0) {
			customSelectedItem = this.textToItem(this._filterText);
		}
		this._filterText = null;
		this.pendingSelectedIndex = -1;
		if(this._dataProvider != null) {
			this._dataProvider.refresh();
		}
		if(customSelectedItem != null) {
			this._customSelectedItem = customSelectedItem;
			this._selectedItem = null;
			this._selectedIndex = -1;
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
		} else if(newSelectedItem != null) {
			this.set_selectedItem(newSelectedItem);
		} else if(this._allowCustomUserValue) {
			this._customSelectedItem = null;
			this._selectedItem = null;
			this._selectedIndex = -1;
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
	},
	comboBox_dataProvider_removeAllHandler: function(event) {
		this.set_selectedIndex(-1);
	},
	comboBox_textInput_mouseDownHandler: function(event) {
		if(this.textInput.get_editable() || this.textInput.get_selectable()) {
			return;
		}
		this.openListView();
	},
	get_popUpAdapter: function() {
		return this.__popUpAdapter;
	},
	set_popUpAdapter: function(value) {
		if(!this.setStyle("popUpAdapter")) {
			return this.__popUpAdapter;
		}
		if(this.__popUpAdapter == value) {
			return this.__popUpAdapter;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_popUpAdapter);
		this.__popUpAdapter = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__popUpAdapter;
	},
	clearStyle_popUpAdapter: function() {
		this.set_popUpAdapter(new (feathers_controls_popups_DropDownPopUpAdapter().default)());
		return this.get_popUpAdapter();
	},
	get_customTextInputVariant: function() {
		return this.__customTextInputVariant;
	},
	set_customTextInputVariant: function(value) {
		if(!this.setStyle("customTextInputVariant")) {
			return this.__customTextInputVariant;
		}
		if(this.__customTextInputVariant == value) {
			return this.__customTextInputVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customTextInputVariant);
		this.__customTextInputVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customTextInputVariant;
	},
	clearStyle_customTextInputVariant: function() {
		this.set_customTextInputVariant(null);
		return this.get_customTextInputVariant();
	},
	get_customButtonVariant: function() {
		return this.__customButtonVariant;
	},
	set_customButtonVariant: function(value) {
		if(!this.setStyle("customButtonVariant")) {
			return this.__customButtonVariant;
		}
		if(this.__customButtonVariant == value) {
			return this.__customButtonVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customButtonVariant);
		this.__customButtonVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customButtonVariant;
	},
	clearStyle_customButtonVariant: function() {
		this.set_customButtonVariant(null);
		return this.get_customButtonVariant();
	},
	get_customListViewVariant: function() {
		return this.__customListViewVariant;
	},
	set_customListViewVariant: function(value) {
		if(!this.setStyle("customListViewVariant")) {
			return this.__customListViewVariant;
		}
		if(this.__customListViewVariant == value) {
			return this.__customListViewVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customListViewVariant);
		this.__customListViewVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customListViewVariant;
	},
	clearStyle_customListViewVariant: function() {
		this.set_customListViewVariant(null);
		return this.get_customListViewVariant();
	},
	get_styleContext: function() {
		return ComboBox
	}
});
ComboBox.prototype.__class__ = ComboBox.prototype.constructor = $hxClasses["feathers.controls.ComboBox"] = ComboBox;

// Init



// Statics


ComboBox.__meta__ = { obj : { defaultXmlProperty : ["dataProvider"]}}
ComboBox.INVALIDATION_FLAG_BUTTON_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("buttonFactory")
ComboBox.INVALIDATION_FLAG_TEXT_INPUT_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("textInputFactory")
ComboBox.INVALIDATION_FLAG_LIST_VIEW_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("listViewFactory")
ComboBox.CHILD_VARIANT_BUTTON = "comboBox_button"
ComboBox.CHILD_VARIANT_TEXT_INPUT = "comboBox_textInput"
ComboBox.CHILD_VARIANT_LIST_VIEW = "comboBox_listView"
ComboBox.defaultButtonFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_Button().default))
ComboBox.defaultTextInputFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_TextInput().default))
ComboBox.defaultListViewFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_ListView().default))

// Export

exports["default"] = ComboBox;

/***/ }),

/***/ "./lib/_gen/feathers/controls/DatePicker.js":
/*!**************************************************!*\
  !*** ./lib/_gen/feathers/controls/DatePicker.js ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.DatePicker

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}
function feathers_core_IDateSelector() {return __webpack_require__(/*! ./../../feathers/core/IDateSelector */ "./lib/_gen/feathers/core/IDateSelector.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_RangeError() {return (__webpack_require__(/*! openfl */ "openfl").errors.RangeError);}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function feathers_themes_steel_components_SteelDatePickerStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelDatePickerStyles */ "./lib/_gen/feathers/themes/steel/components/SteelDatePickerStyles.js");}
function feathers_controls_LayoutGroup() {return __webpack_require__(/*! ./../../feathers/controls/LayoutGroup */ "./lib/_gen/feathers/controls/LayoutGroup.js");}
function feathers_layout_CalendarGridLayout() {return __webpack_require__(/*! ./../../feathers/layout/CalendarGridLayout */ "./lib/_gen/feathers/layout/CalendarGridLayout.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_controls_Label() {return __webpack_require__(/*! ./../../feathers/controls/Label */ "./lib/_gen/feathers/controls/Label.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function Type() {return __webpack_require__(/*! ./../../Type */ "./lib/_gen/Type.js");}
function feathers_style_IVariantStyleObject() {return __webpack_require__(/*! ./../../feathers/style/IVariantStyleObject */ "./lib/_gen/feathers/style/IVariantStyleObject.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_controls_ITriggerView() {return __webpack_require__(/*! ./../../feathers/controls/ITriggerView */ "./lib/_gen/feathers/controls/ITriggerView.js");}
function feathers_controls_IToggle() {return __webpack_require__(/*! ./../../feathers/controls/IToggle */ "./lib/_gen/feathers/controls/IToggle.js");}
function feathers_controls_dataRenderers_IDataRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/IDataRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IDataRenderer.js");}
function feathers_utils_DateUtil() {return __webpack_require__(/*! ./../../feathers/utils/DateUtil */ "./lib/_gen/feathers/utils/DateUtil.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function StringTools() {return __webpack_require__(/*! ./../../StringTools */ "./lib/_gen/StringTools.js");}
function openfl_display_DisplayObject() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObject);}
function feathers_events_DatePickerEvent() {return __webpack_require__(/*! ./../../feathers/events/DatePickerEvent */ "./lib/_gen/feathers/events/DatePickerEvent.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}
function feathers_data_DatePickerItemState() {return __webpack_require__(/*! ./../../feathers/data/DatePickerItemState */ "./lib/_gen/feathers/data/DatePickerItemState.js");}
function feathers_utils_DisplayObjectFactory() {return __webpack_require__(/*! ./../../feathers/utils/DisplayObjectFactory */ "./lib/_gen/feathers/utils/DisplayObjectFactory.js");}
function feathers_controls_Button() {return __webpack_require__(/*! ./../../feathers/controls/Button */ "./lib/_gen/feathers/controls/Button.js");}
function feathers_core_ITextControl() {return __webpack_require__(/*! ./../../feathers/core/ITextControl */ "./lib/_gen/feathers/core/ITextControl.js");}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}
function feathers_controls__$DatePicker_DateRendererStorage() {return __webpack_require__(/*! ./../../feathers/controls/_DatePicker/DateRendererStorage */ "./lib/_gen/feathers/controls/_DatePicker/DateRendererStorage.js");}
function feathers_utils_DisplayObjectRecycler() {return __webpack_require__(/*! ./../../feathers/utils/DisplayObjectRecycler */ "./lib/_gen/feathers/utils/DisplayObjectRecycler.js");}
function feathers_controls_dataRenderers_ItemRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/ItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ItemRenderer.js");}
function haxe_ds_ObjectMap() {return __webpack_require__(/*! ./../../haxe/ds/ObjectMap */ "./lib/_gen/haxe/ds/ObjectMap.js");}

// Constructor

var DatePicker = function() {
	this.__showDatesFromAdjacentMonths = true;
	this.__customMutedDateRendererVariant = null;
	this.__customDateRendererVariant = null;
	this.__customWeekdayLabelVariant = null;
	this.__showWeekdayLabels = true;
	this.__showYearButtons = true;
	this.__showMonthButtons = true;
	this.__showMonthTitleView = true;
	this.__monthTitleViewPosition = (feathers_layout_HorizontalAlign().default).CENTER;
	this.__paddingLeft = 0.0;
	this.__paddingBottom = 0.0;
	this.__paddingRight = 0.0;
	this.__paddingTop = 0.0;
	this.__headerGap = 0.0;
	this.__customMonthTitleViewVariant = null;
	this.__customIncrementYearButtonVariant = null;
	this.__customDecrementYearButtonVariant = null;
	this.__customIncrementMonthButtonVariant = null;
	this.__customDecrementMonthButtonVariant = null;
	this.__disabledBackgroundSkin = null;
	this.__backgroundSkin = null;
	this.pointerSelectionEnabled = true;
	this._previousCustomMutedDateRendererVariant = null;
	this._previousCustomDateRendererVariant = null;
	this._previousCustomWeekdayLabelVariant = null;
	this._customStartOfWeek = null;
	this._currentStartOfWeek = 0;
	this._customWeekdayNames = null;
	this._customMonthNames = null;
	this._actualLocaleIDName = null;
	this._requestedLocaleIDName = null;
	this._previousCustomMonthTitleViewVariant = null;
	this._previousCustomIncrementYearButtonVariant = null;
	this._previousCustomDecrementYearButtonVariant = null;
	this._previousCustomIncrementMonthButtonVariant = null;
	this._previousCustomDecrementMonthButtonVariant = null;
	this._backgroundSkinMeasurements = null;
	this._currentBackgroundSkin = null;
	this._selectedDate = null;
	this._ignoreSelectionChange = false;
	this._selectable = true;
	this._displayedMonth = new Date().getMonth();
	this._displayedFullYear = new Date().getFullYear();
	this.itemStatePool = new (lime_utils_ObjectPool().default)(function() {
		return new (feathers_data_DatePickerItemState().default)();
	});
	this.monthTitleViewMeasurements = new (feathers_layout_Measurements().default)();
	this.incrementYearButtonMeasurements = new (feathers_layout_Measurements().default)();
	this.decrementYearButtonMeasurements = new (feathers_layout_Measurements().default)();
	this.incrementMonthButtonMeasurements = new (feathers_layout_Measurements().default)();
	this.decrementMonthButtonMeasurements = new (feathers_layout_Measurements().default)();
	this._mutedStorage = new (feathers_controls__$DatePicker_DateRendererStorage().default)(null,(feathers_utils_DisplayObjectRecycler().default).withClass((feathers_controls_dataRenderers_ItemRenderer().default)));
	this._defaultStorage = new (feathers_controls__$DatePicker_DateRendererStorage().default)(null,(feathers_utils_DisplayObjectRecycler().default).withClass((feathers_controls_dataRenderers_ItemRenderer().default)));
	this.dateRendererToItemState = new (haxe_ds_ObjectMap().default)();
	this._dayNameLabels = [];
	this.DEFAULT_START_OF_WEEK = 0;
	this.DEFAULT_WEEKDAY_NAMES = ["S","M","T","W","T","F","S"];
	this.initializeDatePickerTheme();
	(feathers_core_FeathersControl().default).call(this);
}

// Meta

DatePicker.__name__ = "feathers.controls.DatePicker";
DatePicker.__isInterface__ = false;
DatePicker.__interfaces__ = [(feathers_core_IFocusObject().default),(feathers_core_IDateSelector().default)];
DatePicker.__super__ = (feathers_core_FeathersControl().default);
DatePicker.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_displayedFullYear: function() {
		return this._displayedFullYear;
	},
	set_displayedFullYear: function(value) {
		if(this._displayedFullYear == value) {
			return this._displayedFullYear;
		}
		this._displayedFullYear = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"scroll");
		return this._displayedFullYear;
	},
	get_displayedMonth: function() {
		return this._displayedMonth;
	},
	set_displayedMonth: function(value) {
		if(value < 0 || value > 11) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("displayedMonth must be in the range 0-11"));
		}
		if(this._displayedMonth == value) {
			return this._displayedMonth;
		}
		this._displayedMonth = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"scroll");
		return this._displayedMonth;
	},
	get_selectable: function() {
		return this._selectable;
	},
	set_selectable: function(value) {
		if(this._selectable == value) {
			return this._selectable;
		}
		this._selectable = value;
		if(!this._selectable && this._selectedDate != null) {
			this.set_selectedDate(null);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		return this._selectable;
	},
	get_selectedDate: function() {
		return this._selectedDate;
	},
	set_selectedDate: function(value) {
		if(!this._selectable) {
			value = null;
		}
		if(this._selectedDate == value) {
			return this._selectedDate;
		}
		this._selectedDate = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedDate;
	},
	get_decrementMonthButtonFactory: function() {
		return this._decrementMonthButtonFactory;
	},
	set_decrementMonthButtonFactory: function(value) {
		if(this._decrementMonthButtonFactory == value) {
			return this._decrementMonthButtonFactory;
		}
		this._decrementMonthButtonFactory = value;
		this.setInvalid(DatePicker.INVALIDATION_FLAG_DECREMENT_MONTH_BUTTON_FACTORY);
		return this._decrementMonthButtonFactory;
	},
	get_incrementMonthButtonFactory: function() {
		return this._incrementMonthButtonFactory;
	},
	set_incrementMonthButtonFactory: function(value) {
		if(this._incrementMonthButtonFactory == value) {
			return this._incrementMonthButtonFactory;
		}
		this._incrementMonthButtonFactory = value;
		this.setInvalid(DatePicker.INVALIDATION_FLAG_INCREMENT_MONTH_BUTTON_FACTORY);
		return this._incrementMonthButtonFactory;
	},
	get_decrementYearButtonFactory: function() {
		return this._decrementYearButtonFactory;
	},
	set_decrementYearButtonFactory: function(value) {
		if(this._decrementYearButtonFactory == value) {
			return this._decrementYearButtonFactory;
		}
		this._decrementYearButtonFactory = value;
		this.setInvalid(DatePicker.INVALIDATION_FLAG_DECREMENT_YEAR_BUTTON_FACTORY);
		return this._decrementYearButtonFactory;
	},
	get_incrementYearButtonFactory: function() {
		return this._incrementYearButtonFactory;
	},
	set_incrementYearButtonFactory: function(value) {
		if(this._incrementYearButtonFactory == value) {
			return this._incrementYearButtonFactory;
		}
		this._incrementYearButtonFactory = value;
		this.setInvalid(DatePicker.INVALIDATION_FLAG_INCREMENT_YEAR_BUTTON_FACTORY);
		return this._incrementYearButtonFactory;
	},
	get_monthTitleViewFactory: function() {
		return this._monthTitleViewFactory;
	},
	set_monthTitleViewFactory: function(value) {
		if(this._monthTitleViewFactory == value) {
			return this._monthTitleViewFactory;
		}
		this._monthTitleViewFactory = value;
		this.setInvalid(DatePicker.INVALIDATION_FLAG_MONTH_TITLE_VIEW_FACTORY);
		return this._monthTitleViewFactory;
	},
	get_requestedLocaleIDName: function() {
		return this._requestedLocaleIDName;
	},
	set_requestedLocaleIDName: function(value) {
		if(this._requestedLocaleIDName == value) {
			return this._requestedLocaleIDName;
		}
		this._requestedLocaleIDName = value;
		this._actualLocaleIDName = null;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._requestedLocaleIDName;
	},
	get_actualLocaleIDName: function() {
		return this._actualLocaleIDName;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	get_customMonthNames: function() {
		return this._customMonthNames;
	},
	set_customMonthNames: function(value) {
		if(value != null && value.length != 12) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Length of customMonthNames must be exactly equal to 12"));
		}
		if(this._customMonthNames == value) {
			return this._customMonthNames;
		}
		this._customMonthNames = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._customMonthNames;
	},
	get_customWeekdayNames: function() {
		return this._customWeekdayNames;
	},
	set_customWeekdayNames: function(value) {
		if(value != null && value.length != 7) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Length of customWeekdayNames must be exactly equal to 7"));
		}
		if(this._customWeekdayNames == value) {
			return this._customWeekdayNames;
		}
		this._customWeekdayNames = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._customWeekdayNames;
	},
	get_customStartOfWeek: function() {
		return this._customStartOfWeek;
	},
	set_customStartOfWeek: function(value) {
		if(value != null && (value < 0 || value > 6)) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("startOfWeek must be in the range 0-6"));
		}
		if(this._customStartOfWeek == value) {
			return this._customStartOfWeek;
		}
		this._customStartOfWeek = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._customStartOfWeek;
	},
	get_weekdayLabelFactory: function() {
		return this._weekdayLabelFactory;
	},
	set_weekdayLabelFactory: function(value) {
		if(this._weekdayLabelFactory == value) {
			return this._weekdayLabelFactory;
		}
		this._weekdayLabelFactory = value;
		this.setInvalid(DatePicker.INVALIDATION_FLAG_WEEKDAY_LABEL_FACTORY);
		return this._weekdayLabelFactory;
	},
	get_dateRendererRecycler: function() {
		return this._defaultStorage.dateRendererRecycler;
	},
	set_dateRendererRecycler: function(value) {
		if(this._defaultStorage.dateRendererRecycler == value) {
			return this._defaultStorage.dateRendererRecycler;
		}
		this._defaultStorage.oldDateRendererRecycler = this._defaultStorage.dateRendererRecycler;
		this._defaultStorage.dateRendererRecycler = value;
		this._defaultStorage.measurements = null;
		this._mutedStorage.oldDateRendererRecycler = this._mutedStorage.dateRendererRecycler;
		this._mutedStorage.dateRendererRecycler = value;
		this._mutedStorage.measurements = null;
		this.setInvalid(DatePicker.INVALIDATION_FLAG_DATE_RENDERER_FACTORY);
		return this._defaultStorage.dateRendererRecycler;
	},
	initializeDatePickerTheme: function() {
		(feathers_themes_steel_components_SteelDatePickerStyles().default).initialize();
	},
	initialize: function() {
		if(this.dateContainer == null) {
			this.dateContainer = new (feathers_controls_LayoutGroup().default)();
			this.dateContainer.set_layout(new (feathers_layout_CalendarGridLayout().default)());
			this.addChild(this.dateContainer);
		}
		(feathers_core_FeathersControl().default).prototype.initialize.call(this);
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var selectionInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(this._previousCustomDateRendererVariant != this.get_customDateRendererVariant()) {
			this.setInvalidationFlag(DatePicker.INVALIDATION_FLAG_DATE_RENDERER_FACTORY);
		}
		if(this._previousCustomMutedDateRendererVariant != this.get_customMutedDateRendererVariant()) {
			this.setInvalidationFlag(DatePicker.INVALIDATION_FLAG_DATE_RENDERER_FACTORY);
		}
		if(this._previousCustomWeekdayLabelVariant != this.get_customWeekdayLabelVariant()) {
			this.setInvalidationFlag(DatePicker.INVALIDATION_FLAG_WEEKDAY_LABEL_FACTORY);
		}
		if(this._previousCustomDecrementMonthButtonVariant != this.get_customDecrementMonthButtonVariant()) {
			this.setInvalidationFlag(DatePicker.INVALIDATION_FLAG_DECREMENT_MONTH_BUTTON_FACTORY);
		}
		if(this._previousCustomIncrementMonthButtonVariant != this.get_customIncrementMonthButtonVariant()) {
			this.setInvalidationFlag(DatePicker.INVALIDATION_FLAG_INCREMENT_MONTH_BUTTON_FACTORY);
		}
		if(this._previousCustomDecrementYearButtonVariant != this.get_customDecrementYearButtonVariant()) {
			this.setInvalidationFlag(DatePicker.INVALIDATION_FLAG_DECREMENT_YEAR_BUTTON_FACTORY);
		}
		if(this._previousCustomIncrementYearButtonVariant != this.get_customIncrementYearButtonVariant()) {
			this.setInvalidationFlag(DatePicker.INVALIDATION_FLAG_INCREMENT_YEAR_BUTTON_FACTORY);
		}
		if(this._previousCustomMonthTitleViewVariant != this.get_customMonthTitleViewVariant()) {
			this.setInvalidationFlag(DatePicker.INVALIDATION_FLAG_MONTH_TITLE_VIEW_FACTORY);
		}
		var dateRendererFactoryInvalid = this.isInvalid(DatePicker.INVALIDATION_FLAG_DATE_RENDERER_FACTORY);
		var weekdayLabelFactoryInvalid = this.isInvalid(DatePicker.INVALIDATION_FLAG_WEEKDAY_LABEL_FACTORY);
		var decrementMonthButtonFactoryInvalid = this.isInvalid(DatePicker.INVALIDATION_FLAG_DECREMENT_MONTH_BUTTON_FACTORY);
		var incrementMonthButtonFactoryInvalid = this.isInvalid(DatePicker.INVALIDATION_FLAG_INCREMENT_MONTH_BUTTON_FACTORY);
		var decrementYearButtonFactoryInvalid = this.isInvalid(DatePicker.INVALIDATION_FLAG_DECREMENT_YEAR_BUTTON_FACTORY);
		var incrementYearButtonFactoryInvalid = this.isInvalid(DatePicker.INVALIDATION_FLAG_INCREMENT_YEAR_BUTTON_FACTORY);
		var monthTitleViewFactoryInvalid = this.isInvalid(DatePicker.INVALIDATION_FLAG_MONTH_TITLE_VIEW_FACTORY);
		if(stylesInvalid || stateInvalid) {
			this.refreshBackgroundSkin();
		}
		if(monthTitleViewFactoryInvalid) {
			this.createMonthTitleView();
		}
		if(decrementMonthButtonFactoryInvalid) {
			this.createDecrementMonthButton();
		}
		if(incrementMonthButtonFactoryInvalid) {
			this.createIncrementMonthButton();
		}
		if(decrementYearButtonFactoryInvalid) {
			this.createDecrementYearButton();
		}
		if(incrementYearButtonFactoryInvalid) {
			this.createIncrementYearButton();
		}
		if(weekdayLabelFactoryInvalid) {
			this.createWeekdayLabels();
		}
		if(dataInvalid) {
			this.refreshLocale();
		}
		if(dataInvalid || selectionInvalid || dateRendererFactoryInvalid) {
			this.refreshDateRenderers();
		}
		if(weekdayLabelFactoryInvalid || dataInvalid || stylesInvalid) {
			this.refreshWeekdayLabels();
		}
		if(stateInvalid || monthTitleViewFactoryInvalid || decrementMonthButtonFactoryInvalid || incrementMonthButtonFactoryInvalid || decrementYearButtonFactoryInvalid || incrementYearButtonFactoryInvalid) {
			this.refreshEnabled();
		}
		if(dataInvalid || selectionInvalid) {
			this.refreshMonthTitle();
		}
		this.measure();
		this.layoutChildren();
		this._previousCustomDateRendererVariant = this.get_customDateRendererVariant();
		this._previousCustomMutedDateRendererVariant = this.get_customMutedDateRendererVariant();
		this._previousCustomMonthTitleViewVariant = this.get_customMonthTitleViewVariant();
		this._previousCustomWeekdayLabelVariant = this.get_customWeekdayLabelVariant();
		this._previousCustomDecrementMonthButtonVariant = this.get_customDecrementMonthButtonVariant();
		this._previousCustomIncrementMonthButtonVariant = this.get_customIncrementMonthButtonVariant();
		this._previousCustomDecrementYearButtonVariant = this.get_customDecrementYearButtonVariant();
		this._previousCustomIncrementYearButtonVariant = this.get_customIncrementYearButtonVariant();
	},
	createMonthTitleView: function() {
		if(this.monthTitleView != null) {
			if(this._oldMonthTitleViewFactory.destroy != null) {
				this._oldMonthTitleViewFactory.destroy(this.monthTitleView);
			}
			this._oldMonthTitleViewFactory = null;
			this.monthTitleView = null;
		}
		var factory = this._monthTitleViewFactory != null ? this._monthTitleViewFactory : DatePicker.defaultMonthTitleViewFactory;
		this._oldMonthTitleViewFactory = factory;
		this.monthTitleView = factory.create();
		if(this.monthTitleView.get_variant() == null) {
			this.monthTitleView.set_variant(this.get_customMonthTitleViewVariant() != null ? this.get_customMonthTitleViewVariant() : DatePicker.CHILD_VARIANT_MONTH_TITLE_VIEW);
		}
		this.monthTitleView.initializeNow();
		this.monthTitleViewMeasurements.save(this.monthTitleView);
		this.addChild(this.monthTitleView);
	},
	createDecrementMonthButton: function() {
		if(this.decrementMonthButton != null) {
			this.decrementMonthButton.removeEventListener("trigger",$bind(this,this.datePicker_decrementMonthButton_triggerHandler));
			if(this._oldDecrementMonthButtonFactory.destroy != null) {
				this._oldDecrementMonthButtonFactory.destroy(this.decrementMonthButton);
			}
			this._oldDecrementMonthButtonFactory = null;
			this.decrementMonthButton = null;
		}
		var factory = this._decrementMonthButtonFactory != null ? this._decrementMonthButtonFactory : DatePicker.defaultDecrementMonthButtonFactory;
		this._oldDecrementMonthButtonFactory = factory;
		this.decrementMonthButton = factory.create();
		if(this.decrementMonthButton.get_variant() == null) {
			this.decrementMonthButton.set_variant(this.get_customDecrementMonthButtonVariant() != null ? this.get_customDecrementMonthButtonVariant() : DatePicker.CHILD_VARIANT_DECREMENT_MONTH_BUTTON);
		}
		this.decrementMonthButton.initializeNow();
		this.decrementMonthButtonMeasurements.save(this.decrementMonthButton);
		this.addChild(this.decrementMonthButton);
		this.decrementMonthButton.addEventListener("trigger",$bind(this,this.datePicker_decrementMonthButton_triggerHandler));
	},
	createIncrementMonthButton: function() {
		if(this.incrementMonthButton != null) {
			this.incrementMonthButton.removeEventListener("trigger",$bind(this,this.datePicker_incrementMonthButton_triggerHandler));
			if(this._oldIncrementMonthButtonFactory.destroy != null) {
				this._oldIncrementMonthButtonFactory.destroy(this.incrementMonthButton);
			}
			this._oldIncrementMonthButtonFactory = null;
			this.incrementMonthButton = null;
		}
		var factory = this._incrementMonthButtonFactory != null ? this._incrementMonthButtonFactory : DatePicker.defaultIncrementMonthButtonFactory;
		this._oldIncrementMonthButtonFactory = factory;
		this.incrementMonthButton = factory.create();
		if(this.incrementMonthButton.get_variant() == null) {
			this.incrementMonthButton.set_variant(this.get_customIncrementMonthButtonVariant() != null ? this.get_customIncrementMonthButtonVariant() : DatePicker.CHILD_VARIANT_INCREMENT_MONTH_BUTTON);
		}
		this.incrementMonthButton.initializeNow();
		this.incrementMonthButtonMeasurements.save(this.incrementMonthButton);
		this.addChild(this.incrementMonthButton);
		this.incrementMonthButton.addEventListener("trigger",$bind(this,this.datePicker_incrementMonthButton_triggerHandler));
	},
	createDecrementYearButton: function() {
		if(this.decrementYearButton != null) {
			this.decrementYearButton.removeEventListener("trigger",$bind(this,this.datePicker_decrementYearButton_triggerHandler));
			if(this._oldDecrementYearButtonFactory.destroy != null) {
				this._oldDecrementYearButtonFactory.destroy(this.decrementYearButton);
			}
			this._oldDecrementYearButtonFactory = null;
			this.decrementYearButton = null;
		}
		var factory = this._decrementYearButtonFactory != null ? this._decrementYearButtonFactory : DatePicker.defaultDecrementYearButtonFactory;
		this._oldDecrementYearButtonFactory = factory;
		this.decrementYearButton = factory.create();
		if(this.decrementYearButton.get_variant() == null) {
			this.decrementYearButton.set_variant(this.get_customDecrementYearButtonVariant() != null ? this.get_customDecrementYearButtonVariant() : DatePicker.CHILD_VARIANT_DECREMENT_YEAR_BUTTON);
		}
		this.decrementYearButton.initializeNow();
		this.decrementYearButtonMeasurements.save(this.decrementYearButton);
		this.addChild(this.decrementYearButton);
		this.decrementYearButton.addEventListener("trigger",$bind(this,this.datePicker_decrementYearButton_triggerHandler));
	},
	createIncrementYearButton: function() {
		if(this.incrementYearButton != null) {
			this.incrementYearButton.removeEventListener("trigger",$bind(this,this.datePicker_incrementYearButton_triggerHandler));
			if(this._oldIncrementYearButtonFactory.destroy != null) {
				this._oldIncrementYearButtonFactory.destroy(this.incrementYearButton);
			}
			this._oldIncrementYearButtonFactory = null;
			this.incrementYearButton = null;
		}
		var factory = this._incrementYearButtonFactory != null ? this._incrementYearButtonFactory : DatePicker.defaultIncrementYearButtonFactory;
		this._oldIncrementYearButtonFactory = factory;
		this.incrementYearButton = factory.create();
		if(this.incrementYearButton.get_variant() == null) {
			this.incrementYearButton.set_variant(this.get_customIncrementYearButtonVariant() != null ? this.get_customIncrementYearButtonVariant() : DatePicker.CHILD_VARIANT_INCREMENT_YEAR_BUTTON);
		}
		this.incrementYearButton.initializeNow();
		this.incrementYearButtonMeasurements.save(this.incrementYearButton);
		this.addChild(this.incrementYearButton);
		this.incrementYearButton.addEventListener("trigger",$bind(this,this.datePicker_incrementYearButton_triggerHandler));
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		this.dateContainer.validateNow();
		this.monthTitleViewMeasurements.restore(this.monthTitleView);
		var oldText = this.monthTitleView.get_text();
		var measureText = this.getMonthText(this.getMonthWithLongestName(),0);
		this.monthTitleView.set_text(measureText);
		this.monthTitleView.validateNow();
		this.decrementMonthButtonMeasurements.restore(this.decrementMonthButton);
		this.decrementMonthButton.validateNow();
		this.incrementMonthButtonMeasurements.restore(this.incrementMonthButton);
		this.incrementMonthButton.validateNow();
		this.decrementYearButtonMeasurements.restore(this.decrementYearButton);
		this.decrementYearButton.validateNow();
		this.incrementYearButtonMeasurements.restore(this.incrementYearButton);
		this.incrementYearButton.validateNow();
		var headerWidth = 0.0;
		var headerHeight = 0.0;
		if(this.get_showMonthTitleView()) {
			headerWidth = this.monthTitleView.get_width();
			headerHeight = this.monthTitleView.get_height();
		}
		if(this.get_showMonthButtons()) {
			headerWidth += 2.0 * this.get_headerGap() + this.decrementMonthButton.get_width() + this.incrementMonthButton.get_width();
			headerHeight = Math.max(headerHeight,Math.max(this.decrementMonthButton.get_height(),this.incrementMonthButton.get_height()));
		}
		if(this.get_showYearButtons()) {
			headerWidth += 2.0 * this.get_headerGap() + this.decrementYearButton.get_width() + this.incrementYearButton.get_width();
			headerHeight = Math.max(headerHeight,Math.max(this.decrementYearButton.get_height(),this.incrementYearButton.get_height()));
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			newWidth = Math.max(this.dateContainer.get_width(),headerWidth);
			newWidth += this.get_paddingLeft() + this.get_paddingRight();
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			newHeight = headerHeight + this.dateContainer.get_height();
			newHeight += this.get_paddingTop() + this.get_paddingBottom();
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			newMinWidth = Math.max(this.dateContainer.get_minWidth(),headerWidth);
			newMinWidth += this.get_paddingLeft() + this.get_paddingRight();
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			newMinHeight = headerHeight + this.dateContainer.get_minHeight();
			newMinHeight += this.get_paddingTop() + this.get_paddingBottom();
		}
		this.monthTitleView.set_text(oldText);
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight);
	},
	refreshEnabled: function() {
		this.monthTitleView.set_enabled(this.get_enabled());
		this.decrementMonthButton.set_enabled(this.get_enabled());
		this.incrementMonthButton.set_enabled(this.get_enabled());
		this.decrementYearButton.set_enabled(this.get_enabled());
		this.incrementYearButton.set_enabled(this.get_enabled());
		this.dateContainer.set_enabled(this.get_enabled());
	},
	createWeekdayLabels: function() {
		var _g = 0;
		var _g1 = this._dayNameLabels;
		while(_g < _g1.length) {
			var dayNameLabel = _g1[_g];
			++_g;
			this.dateContainer.removeChild(dayNameLabel);
			if(this._oldWeekdayLabelFactory.destroy != null) {
				this._oldWeekdayLabelFactory.destroy(dayNameLabel);
			}
		}
		this._oldWeekdayLabelFactory = null;
		this._dayNameLabels.length = 0;
		var factory = this._weekdayLabelFactory != null ? this._weekdayLabelFactory : DatePicker.defaultWeekdayLabelFactory;
		var weekdayLabelVariant = this.get_customWeekdayLabelVariant() != null ? this.get_customWeekdayLabelVariant() : DatePicker.CHILD_VARIANT_WEEKDAY_LABEL;
		var dayNameLabel1 = (js_Boot().default).__cast(factory.create() , (feathers_controls_Label().default));
		this._oldWeekdayLabelFactory = factory;
		if(dayNameLabel1.get_variant() == null) {
			dayNameLabel1.set_variant(weekdayLabelVariant);
		}
		this.dateContainer.addChildAt(dayNameLabel1,0);
		this._dayNameLabels.push(dayNameLabel1);
		var dayNameLabel2 = (js_Boot().default).__cast(factory.create() , (feathers_controls_Label().default));
		this._oldWeekdayLabelFactory = factory;
		if(dayNameLabel2.get_variant() == null) {
			dayNameLabel2.set_variant(weekdayLabelVariant);
		}
		this.dateContainer.addChildAt(dayNameLabel2,1);
		this._dayNameLabels.push(dayNameLabel2);
		var dayNameLabel3 = (js_Boot().default).__cast(factory.create() , (feathers_controls_Label().default));
		this._oldWeekdayLabelFactory = factory;
		if(dayNameLabel3.get_variant() == null) {
			dayNameLabel3.set_variant(weekdayLabelVariant);
		}
		this.dateContainer.addChildAt(dayNameLabel3,2);
		this._dayNameLabels.push(dayNameLabel3);
		var dayNameLabel4 = (js_Boot().default).__cast(factory.create() , (feathers_controls_Label().default));
		this._oldWeekdayLabelFactory = factory;
		if(dayNameLabel4.get_variant() == null) {
			dayNameLabel4.set_variant(weekdayLabelVariant);
		}
		this.dateContainer.addChildAt(dayNameLabel4,3);
		this._dayNameLabels.push(dayNameLabel4);
		var dayNameLabel5 = (js_Boot().default).__cast(factory.create() , (feathers_controls_Label().default));
		this._oldWeekdayLabelFactory = factory;
		if(dayNameLabel5.get_variant() == null) {
			dayNameLabel5.set_variant(weekdayLabelVariant);
		}
		this.dateContainer.addChildAt(dayNameLabel5,4);
		this._dayNameLabels.push(dayNameLabel5);
		var dayNameLabel6 = (js_Boot().default).__cast(factory.create() , (feathers_controls_Label().default));
		this._oldWeekdayLabelFactory = factory;
		if(dayNameLabel6.get_variant() == null) {
			dayNameLabel6.set_variant(weekdayLabelVariant);
		}
		this.dateContainer.addChildAt(dayNameLabel6,5);
		this._dayNameLabels.push(dayNameLabel6);
		var dayNameLabel7 = (js_Boot().default).__cast(factory.create() , (feathers_controls_Label().default));
		this._oldWeekdayLabelFactory = factory;
		if(dayNameLabel7.get_variant() == null) {
			dayNameLabel7.set_variant(weekdayLabelVariant);
		}
		this.dateContainer.addChildAt(dayNameLabel7,6);
		this._dayNameLabels.push(dayNameLabel7);
	},
	refreshWeekdayLabels: function() {
		var _g = 0;
		var _g1 = this._dayNameLabels.length;
		while(_g < _g1) {
			var i = _g++;
			var nameIndex = (i + this._currentStartOfWeek) % this._dayNameLabels.length;
			var dayNameLabel = this._dayNameLabels[i];
			dayNameLabel.set_text(this._currentWeekdayNames[nameIndex]);
			dayNameLabel.set_visible(this.get_showWeekdayLabels());
			dayNameLabel.set_includeInLayout(this.get_showWeekdayLabels());
		}
	},
	refreshDateRenderers: function() {
		if(this._defaultStorage.dateRendererRecycler.update == null) {
			this._defaultStorage.dateRendererRecycler.update = DatePicker.defaultUpdateDateRenderer;
			if(this._defaultStorage.dateRendererRecycler.reset == null) {
				this._defaultStorage.dateRendererRecycler.reset = DatePicker.defaultResetDateRenderer;
			}
		}
		if(this._mutedStorage.dateRendererRecycler.update == null) {
			this._mutedStorage.dateRendererRecycler.update = DatePicker.defaultUpdateDateRenderer;
			if(this._mutedStorage.dateRendererRecycler.reset == null) {
				this._mutedStorage.dateRendererRecycler.reset = DatePicker.defaultResetDateRenderer;
			}
		}
		var dateRendererInvalid = this.isInvalid(DatePicker.INVALIDATION_FLAG_DATE_RENDERER_FACTORY);
		this.refreshInactiveDateRenderers(this._defaultStorage,dateRendererInvalid);
		this.refreshInactiveDateRenderers(this._mutedStorage,dateRendererInvalid);
		this.recoverInactiveDateRenderers(this._defaultStorage);
		this.recoverInactiveDateRenderers(this._mutedStorage);
		this.renderUnrenderedData();
		this.freeInactiveDateRenderers(this._defaultStorage);
		this.freeInactiveDateRenderers(this._mutedStorage);
	},
	refreshInactiveDateRenderers: function(storage,factoryInvalid) {
		var temp = storage.inactiveDateRenderers;
		storage.inactiveDateRenderers = storage.activeDateRenderers;
		storage.activeDateRenderers = temp;
		if(storage.activeDateRenderers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": active date renderers should be empty before updating."));
		}
		if(factoryInvalid) {
			this.recoverInactiveDateRenderers(storage);
			this.freeInactiveDateRenderers(storage);
			storage.oldDateRendererRecycler = null;
		}
	},
	recoverInactiveDateRenderers: function(storage) {
		var _g = 0;
		var _g1 = storage.inactiveDateRenderers;
		while(_g < _g1.length) {
			var dateRenderer = _g1[_g];
			++_g;
			if(dateRenderer == null) {
				continue;
			}
			var state = this.dateRendererToItemState.get(dateRenderer);
			if(state == null) {
				continue;
			}
			this.dateRendererToItemState.remove(dateRenderer);
			dateRenderer.removeEventListener("trigger",$bind(this,this.datePicker_dateRenderer_triggerHandler));
			dateRenderer.removeEventListener("click",$bind(this,this.datePicker_dateRenderer_clickHandler));
			dateRenderer.removeEventListener("touchTap",$bind(this,this.datePicker_dateRenderer_touchTapHandler));
			dateRenderer.removeEventListener("change",$bind(this,this.datePicker_dateRenderer_changeHandler));
			this.resetDateRenderer(dateRenderer,state,storage);
			if(storage.measurements != null) {
				storage.measurements.restore(dateRenderer);
			}
			this.itemStatePool.release(state);
		}
	},
	freeInactiveDateRenderers: function(storage) {
		var recycler = storage.oldDateRendererRecycler != null ? storage.oldDateRendererRecycler : storage.dateRendererRecycler;
		var _g = 0;
		var _g1 = storage.inactiveDateRenderers;
		while(_g < _g1.length) {
			var dateRenderer = _g1[_g];
			++_g;
			if(dateRenderer == null) {
				continue;
			}
			this.destroyDateRenderer(dateRenderer,recycler);
		}
		storage.inactiveDateRenderers.length = 0;
	},
	createDateRenderer: function(state,storage) {
		var dateRenderer = null;
		if(storage.inactiveDateRenderers.length == 0) {
			dateRenderer = storage.dateRendererRecycler.create();
			if((js_Boot().default).__implements(dateRenderer,(feathers_style_IVariantStyleObject().default))) {
				var variantItemRenderer = (js_Boot().default).__cast(dateRenderer , (feathers_style_IVariantStyleObject().default));
				if(variantItemRenderer.get_variant() == null) {
					if(storage == this._mutedStorage) {
						var variant = this.get_customMutedDateRendererVariant() != null ? this.get_customMutedDateRendererVariant() : DatePicker.CHILD_VARIANT_MUTED_DATE_RENDERER;
						variantItemRenderer.set_variant(variant);
					} else {
						var variant1 = this.get_customDateRendererVariant() != null ? this.get_customDateRendererVariant() : DatePicker.CHILD_VARIANT_DATE_RENDERER;
						variantItemRenderer.set_variant(variant1);
					}
				}
			}
			if((js_Boot().default).__implements(dateRenderer,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(dateRenderer , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(storage.measurements == null) {
				storage.measurements = new (feathers_layout_Measurements().default)(dateRenderer);
			}
		} else {
			dateRenderer = storage.inactiveDateRenderers.shift();
		}
		this.updateDateRenderer(dateRenderer,state,storage);
		if((js_Boot().default).__implements(dateRenderer,(feathers_controls_ITriggerView().default))) {
			dateRenderer.addEventListener("trigger",$bind(this,this.datePicker_dateRenderer_triggerHandler));
		} else {
			dateRenderer.addEventListener("click",$bind(this,this.datePicker_dateRenderer_clickHandler));
		}
		if((js_Boot().default).__implements(dateRenderer,(feathers_controls_IToggle().default))) {
			dateRenderer.addEventListener("change",$bind(this,this.datePicker_dateRenderer_changeHandler));
		}
		this.dateRendererToItemState.set(dateRenderer,state);
		storage.activeDateRenderers.push(dateRenderer);
		return dateRenderer;
	},
	destroyDateRenderer: function(dateRenderer,recycler) {
		this.dateContainer.removeChild(dateRenderer);
		if(recycler != null && recycler.destroy != null) {
			recycler.destroy(dateRenderer);
		}
	},
	populateCurrentItemState: function(date,state) {
		state.owner = this;
		state.date = date;
		state.selected = this._selectedDate != null && this._displayedFullYear == this._selectedDate.getFullYear() && this._displayedMonth == this._selectedDate.getMonth() && date.getFullYear() == this._selectedDate.getFullYear() && date.getMonth() == this._selectedDate.getMonth() && date.getDate() == this._selectedDate.getDate();
		state.enabled = this._enabled;
	},
	resetDateRenderer: function(dateRenderer,state,storage) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		var recycler = storage.oldDateRendererRecycler != null ? storage.oldDateRendererRecycler : storage.dateRendererRecycler;
		if(recycler != null && recycler.reset != null) {
			recycler.reset(dateRenderer,state);
		}
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		this.refreshDateRendererProperties(dateRenderer,DatePicker.RESET_ITEM_STATE);
		dateRenderer.set_visible(true);
	},
	updateDateRenderer: function(dateRenderer,state,storage) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		if(storage.dateRendererRecycler.update != null) {
			storage.dateRendererRecycler.update(dateRenderer,state);
		}
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		this.refreshDateRendererProperties(dateRenderer,state);
		dateRenderer.set_visible(this.get_showDatesFromAdjacentMonths() || state.date != null && this._displayedFullYear == state.date.getFullYear() && this._displayedMonth == state.date.getMonth());
	},
	refreshDateRendererProperties: function(dateRenderer,state) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		if((js_Boot().default).__implements(dateRenderer,(feathers_core_IUIControl().default))) {
			var uiControl = (js_Boot().default).__cast(dateRenderer , (feathers_core_IUIControl().default));
			uiControl.set_enabled(state.enabled);
		}
		if((js_Boot().default).__implements(dateRenderer,(feathers_controls_dataRenderers_IDataRenderer().default))) {
			var dataRenderer = (js_Boot().default).__cast(dateRenderer , (feathers_controls_dataRenderers_IDataRenderer().default));
			dataRenderer.set_data(state.date);
		}
		if((js_Boot().default).__implements(dateRenderer,(feathers_controls_IToggle().default))) {
			var toggle = (js_Boot().default).__cast(dateRenderer , (feathers_controls_IToggle().default));
			toggle.set_selected(state.selected);
		}
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
	},
	renderUnrenderedData: function() {
		var startOfWeek = this._customStartOfWeek != null ? this._customStartOfWeek : 0;
		var dayIndexOfFirst = -startOfWeek + new Date(this._displayedFullYear,this._displayedMonth,1,0,0,0).getDay();
		if(dayIndexOfFirst < 0) {
			dayIndexOfFirst = 0;
		}
		var lastMonthYear = this._displayedFullYear;
		var lastMonth = this._displayedMonth - 1;
		if(lastMonth < 0) {
			lastMonth = 11;
			--lastMonthYear;
		}
		var numDays = (feathers_utils_DateUtil().default).getDaysInMonth(this._displayedMonth,this._displayedFullYear);
		var numDaysLastMonth = (feathers_utils_DateUtil().default).getDaysInMonth(lastMonth,lastMonthYear);
		var currentFullYear = this._displayedFullYear;
		var currentMonth = this._displayedMonth;
		var currentDate = numDaysLastMonth - dayIndexOfFirst + 1;
		if(currentDate > 1) {
			currentMonth = lastMonth;
			currentFullYear = lastMonthYear;
		}
		var _g = 0;
		while(_g < 42) {
			var i = _g++;
			if((currentMonth < this._displayedMonth || currentFullYear < this._displayedFullYear) && currentDate > numDaysLastMonth) {
				currentDate = 1;
				++currentMonth;
				if(currentMonth == 12) {
					currentMonth = 0;
					++currentFullYear;
				}
			}
			if(currentMonth == this._displayedMonth && currentDate > numDays) {
				currentDate = 1;
				++currentMonth;
				if(currentMonth == 12) {
					currentMonth = 0;
					++currentFullYear;
				}
			}
			var state = this.itemStatePool.get();
			var stateDate = new Date(currentFullYear,currentMonth,currentDate,0,0,0);
			this.populateCurrentItemState(stateDate,state);
			var storage = currentMonth == this._displayedMonth ? this._defaultStorage : this._mutedStorage;
			var dateRenderer = this.createDateRenderer(state,storage);
			this.dateContainer.addChildAt(dateRenderer,7 + i);
			this.updateDateRenderer(dateRenderer,state,storage);
			++currentDate;
		}
	},
	refreshLocale: function() {
		this._actualLocaleIDName = "en-US";
		this._currentMonthNames = DatePicker.DEFAULT_MONTH_NAMES;
		this._currentWeekdayNames = this._customWeekdayNames != null ? this._customWeekdayNames : this.DEFAULT_WEEKDAY_NAMES;
		this._currentStartOfWeek = this._customStartOfWeek != null ? this._customStartOfWeek : this.DEFAULT_START_OF_WEEK;
	},
	refreshBackgroundSkin: function() {
		var oldSkin = this._currentBackgroundSkin;
		this._currentBackgroundSkin = this.getCurrentBackgroundSkin();
		if(this._currentBackgroundSkin == oldSkin) {
			return;
		}
		this.removeCurrentBackgroundSkin(oldSkin);
		this.addCurrentBackgroundSkin(this._currentBackgroundSkin);
	},
	getCurrentBackgroundSkin: function() {
		if(!this._enabled && this.get_disabledBackgroundSkin() != null) {
			return this.get_disabledBackgroundSkin();
		}
		return this.get_backgroundSkin();
	},
	addCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			this._backgroundSkinMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._backgroundSkinMeasurements == null) {
			this._backgroundSkinMeasurements = new (feathers_layout_Measurements().default)(skin);
		} else {
			this._backgroundSkinMeasurements.save(skin);
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this.addChildAt(skin,0);
	},
	removeCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		this._backgroundSkinMeasurements.restore(skin);
		if(skin.parent == this) {
			this.removeChild(skin);
		}
	},
	layoutChildren: function() {
		this.layoutBackgroundSkin();
		this.decrementMonthButton.set_visible(this.get_showMonthButtons());
		this.incrementMonthButton.set_visible(this.get_showMonthButtons());
		this.decrementYearButton.set_visible(this.get_showYearButtons());
		this.incrementYearButton.set_visible(this.get_showYearButtons());
		this.monthTitleView.set_visible(this.get_showMonthTitleView());
		this.monthTitleView.validateNow();
		this.decrementMonthButton.validateNow();
		this.incrementMonthButton.validateNow();
		this.decrementYearButton.validateNow();
		this.incrementYearButton.validateNow();
		var maxButtonHeight = 0.0;
		if(this.get_showMonthButtons()) {
			maxButtonHeight = Math.max(maxButtonHeight,Math.max(this.decrementMonthButton.get_height(),this.incrementMonthButton.get_height()));
		}
		if(this.get_showYearButtons()) {
			maxButtonHeight = Math.max(maxButtonHeight,Math.max(this.decrementYearButton.get_height(),this.incrementYearButton.get_height()));
		}
		if(this.decrementMonthButton.get_height() != maxButtonHeight) {
			this.decrementMonthButton.set_height(maxButtonHeight);
		}
		if(this.incrementMonthButton.get_height() != maxButtonHeight) {
			this.incrementMonthButton.set_height(maxButtonHeight);
		}
		if(this.decrementYearButton.get_height() != maxButtonHeight) {
			this.decrementYearButton.set_height(maxButtonHeight);
		}
		if(this.incrementYearButton.get_height() != maxButtonHeight) {
			this.incrementYearButton.set_height(maxButtonHeight);
		}
		var headerHeight = maxButtonHeight;
		if(this.get_showMonthTitleView()) {
			headerHeight = Math.max(headerHeight,this.monthTitleView.get_height());
		}
		switch(this.get_monthTitleViewPosition()._hx_index) {
		case 0:
			this.monthTitleView.set_x(this.get_paddingLeft());
			var currentX = this.actualWidth - this.get_paddingRight();
			if(this.get_showYearButtons()) {
				currentX -= this.incrementYearButton.get_width();
				this.incrementYearButton.set_x(currentX);
				currentX -= this.get_headerGap();
			}
			if(this.get_showMonthButtons()) {
				currentX -= this.incrementMonthButton.get_width();
				this.incrementMonthButton.set_x(currentX);
				currentX -= this.get_headerGap();
			}
			if(this.get_showMonthButtons()) {
				currentX -= this.decrementMonthButton.get_width();
				this.decrementMonthButton.set_x(currentX);
				currentX -= this.get_headerGap();
			}
			if(this.get_showYearButtons()) {
				currentX -= this.decrementYearButton.get_width();
				this.decrementYearButton.set_x(currentX);
				currentX -= this.get_headerGap();
			}
			break;
		case 1:
			this.monthTitleView.set_x(this.get_paddingLeft() + (this.actualWidth - this.get_paddingLeft() - this.get_paddingRight() - this.monthTitleView.get_width()) / 2.0);
			var currentX1 = this.get_paddingLeft();
			if(this.get_showYearButtons()) {
				this.decrementYearButton.set_x(currentX1);
				currentX1 += this.decrementYearButton.get_width() + this.get_headerGap();
			}
			if(this.get_showMonthButtons()) {
				this.decrementMonthButton.set_x(currentX1);
				currentX1 += this.decrementMonthButton.get_width() + this.get_headerGap();
			}
			var currentX2 = this.actualWidth - this.get_paddingRight();
			if(this.get_showYearButtons()) {
				currentX2 -= this.incrementYearButton.get_width();
				this.incrementYearButton.set_x(currentX2);
				currentX2 -= this.get_headerGap();
			}
			if(this.get_showMonthButtons()) {
				currentX2 -= this.incrementMonthButton.get_width();
				this.incrementMonthButton.set_x(currentX2);
				currentX2 -= this.get_headerGap();
			}
			break;
		case 2:
			this.monthTitleView.set_x(this.actualWidth - this.get_paddingRight() - this.monthTitleView.get_width());
			var currentX3 = this.get_paddingLeft();
			if(this.get_showYearButtons()) {
				this.decrementYearButton.set_x(currentX3);
				currentX3 += this.decrementYearButton.get_width() + this.get_headerGap();
			}
			if(this.get_showMonthButtons()) {
				this.decrementMonthButton.set_x(currentX3);
				currentX3 += this.decrementMonthButton.get_width() + this.get_headerGap();
			}
			if(this.get_showMonthButtons()) {
				this.incrementMonthButton.set_x(currentX3);
				currentX3 += this.incrementMonthButton.get_width() + this.get_headerGap();
			}
			if(this.get_showYearButtons()) {
				this.incrementYearButton.set_x(currentX3);
				currentX3 += this.incrementYearButton.get_width() + this.get_headerGap();
			}
			break;
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Invalid month position: " + (Std().default).string(this.get_monthTitleViewPosition())));
		}
		if(this.get_showMonthTitleView()) {
			this.monthTitleView.set_y(this.get_paddingTop() + (headerHeight - this.monthTitleView.get_height()) / 2.0);
		}
		if(this.get_showMonthButtons()) {
			this.decrementMonthButton.set_y(this.get_paddingTop() + (headerHeight - this.decrementMonthButton.get_height()) / 2.0);
			this.incrementMonthButton.set_y(this.get_paddingTop() + (headerHeight - this.incrementMonthButton.get_height()) / 2.0);
		}
		if(this.get_showYearButtons()) {
			this.decrementYearButton.set_y(this.get_paddingTop() + (headerHeight - this.decrementYearButton.get_height()) / 2.0);
			this.incrementYearButton.set_y(this.get_paddingTop() + (headerHeight - this.incrementYearButton.get_height()) / 2.0);
		}
		this.dateContainer.set_x(this.get_paddingLeft());
		this.dateContainer.set_y(this.get_paddingTop() + headerHeight);
		var calendarWidth = this.actualWidth - this.get_paddingLeft() - this.get_paddingRight();
		var calendarHeight = this.actualHeight - headerHeight - this.get_paddingTop() - this.get_paddingBottom();
		if(this.dateContainer.get_width() != calendarWidth) {
			this.dateContainer.set_width(calendarWidth);
		}
		if(this.dateContainer.get_height() != calendarHeight) {
			this.dateContainer.set_height(calendarHeight);
		}
		this.dateContainer.validateNow();
	},
	layoutBackgroundSkin: function() {
		if(this._currentBackgroundSkin == null) {
			return;
		}
		this._currentBackgroundSkin.set_x(0.0);
		this._currentBackgroundSkin.set_y(0.0);
		if(this._currentBackgroundSkin.get_width() != this.actualWidth) {
			this._currentBackgroundSkin.set_width(this.actualWidth);
		}
		if(this._currentBackgroundSkin.get_height() != this.actualHeight) {
			this._currentBackgroundSkin.set_height(this.actualHeight);
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
	},
	refreshMonthTitle: function() {
		this.monthTitleView.set_text(this.getMonthText(this.get_displayedMonth(),this.get_displayedFullYear()));
	},
	getMonthWithLongestName: function() {
		var maxLength = 0;
		var maxIndex = -1;
		var _g = 0;
		var _g1 = this._currentMonthNames.length;
		while(_g < _g1) {
			var i = _g++;
			var monthName = this._currentMonthNames[i];
			var currentLength = monthName.length;
			if(maxLength < currentLength) {
				maxLength = currentLength;
				maxIndex = i;
			}
		}
		return maxIndex;
	},
	getMonthText: function(month,fullYear) {
		var monthName = this._currentMonthNames[month];
		return "" + monthName + " " + (StringTools().default).lpad(fullYear == null ? "null" : "" + fullYear,"0",4);
	},
	datePicker_decrementMonthButton_triggerHandler: function(event) {
		var displayedMonth = this._displayedMonth;
		var displayedFullYear = this._displayedFullYear;
		--displayedMonth;
		if(displayedMonth < 0) {
			displayedMonth = 11;
			--displayedFullYear;
		}
		this.set_displayedMonth(displayedMonth);
		this.set_displayedFullYear(displayedFullYear);
	},
	datePicker_incrementMonthButton_triggerHandler: function(event) {
		var displayedMonth = this._displayedMonth;
		var displayedFullYear = this._displayedFullYear;
		++displayedMonth;
		if(displayedMonth > 11) {
			displayedMonth = 0;
			++displayedFullYear;
		}
		this.set_displayedMonth(displayedMonth);
		this.set_displayedFullYear(displayedFullYear);
	},
	datePicker_decrementYearButton_triggerHandler: function(event) {
		var _g = this;
		_g.set_displayedFullYear(_g.get_displayedFullYear() - 1);
	},
	datePicker_incrementYearButton_triggerHandler: function(event) {
		var _g = this;
		_g.set_displayedFullYear(_g.get_displayedFullYear() + 1);
	},
	datePicker_dateRenderer_touchTapHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(event.isPrimaryTouchPoint) {
			return;
		}
		var dateRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this.dateRendererToItemState.get(dateRenderer);
		(feathers_events_DatePickerEvent().default).dispatch(this,"itemTrigger",state);
		if(!this._selectable || !this.pointerSelectionEnabled) {
			return;
		}
		this.set_selectedDate(state.date);
		this.set_displayedFullYear(this.get_selectedDate().getFullYear());
		this.set_displayedMonth(this.get_selectedDate().getMonth());
	},
	datePicker_dateRenderer_clickHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		var dateRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this.dateRendererToItemState.get(dateRenderer);
		(feathers_events_DatePickerEvent().default).dispatch(this,"itemTrigger",state);
		if(!this._selectable || !this.pointerSelectionEnabled) {
			return;
		}
		this.set_selectedDate(state.date);
		this.set_displayedFullYear(this.get_selectedDate().getFullYear());
		this.set_displayedMonth(this.get_selectedDate().getMonth());
	},
	datePicker_dateRenderer_triggerHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		var dateRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this.dateRendererToItemState.get(dateRenderer);
		(feathers_events_DatePickerEvent().default).dispatch(this,"itemTrigger",state);
		if(!this._selectable) {
			return;
		}
		this.set_selectedDate(state.date);
		this.set_displayedFullYear(this.get_selectedDate().getFullYear());
		this.set_displayedMonth(this.get_selectedDate().getMonth());
	},
	datePicker_dateRenderer_changeHandler: function(event) {
		if(this._ignoreSelectionChange) {
			return;
		}
		var dateRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var toggleDateRenderer = (js_Boot().default).__cast(dateRenderer , (feathers_controls_IToggle().default));
		var state = this.dateRendererToItemState.get(dateRenderer);
		if(toggleDateRenderer.get_selected() == state.selected) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
	},
	get_backgroundSkin: function() {
		return this.__backgroundSkin;
	},
	set_backgroundSkin: function(value) {
		if(!this.setStyle("backgroundSkin")) {
			return this.__backgroundSkin;
		}
		if(this.__backgroundSkin == value) {
			return this.__backgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_backgroundSkin);
		this.__backgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__backgroundSkin;
	},
	clearStyle_backgroundSkin: function() {
		this.set_backgroundSkin(null);
		return this.get_backgroundSkin();
	},
	get_disabledBackgroundSkin: function() {
		return this.__disabledBackgroundSkin;
	},
	set_disabledBackgroundSkin: function(value) {
		if(!this.setStyle("disabledBackgroundSkin")) {
			return this.__disabledBackgroundSkin;
		}
		if(this.__disabledBackgroundSkin == value) {
			return this.__disabledBackgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledBackgroundSkin);
		this.__disabledBackgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledBackgroundSkin;
	},
	clearStyle_disabledBackgroundSkin: function() {
		this.set_disabledBackgroundSkin(null);
		return this.get_disabledBackgroundSkin();
	},
	get_customDecrementMonthButtonVariant: function() {
		return this.__customDecrementMonthButtonVariant;
	},
	set_customDecrementMonthButtonVariant: function(value) {
		if(!this.setStyle("customDecrementMonthButtonVariant")) {
			return this.__customDecrementMonthButtonVariant;
		}
		if(this.__customDecrementMonthButtonVariant == value) {
			return this.__customDecrementMonthButtonVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customDecrementMonthButtonVariant);
		this.__customDecrementMonthButtonVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customDecrementMonthButtonVariant;
	},
	clearStyle_customDecrementMonthButtonVariant: function() {
		this.set_customDecrementMonthButtonVariant(null);
		return this.get_customDecrementMonthButtonVariant();
	},
	get_customIncrementMonthButtonVariant: function() {
		return this.__customIncrementMonthButtonVariant;
	},
	set_customIncrementMonthButtonVariant: function(value) {
		if(!this.setStyle("customIncrementMonthButtonVariant")) {
			return this.__customIncrementMonthButtonVariant;
		}
		if(this.__customIncrementMonthButtonVariant == value) {
			return this.__customIncrementMonthButtonVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customIncrementMonthButtonVariant);
		this.__customIncrementMonthButtonVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customIncrementMonthButtonVariant;
	},
	clearStyle_customIncrementMonthButtonVariant: function() {
		this.set_customIncrementMonthButtonVariant(null);
		return this.get_customIncrementMonthButtonVariant();
	},
	get_customDecrementYearButtonVariant: function() {
		return this.__customDecrementYearButtonVariant;
	},
	set_customDecrementYearButtonVariant: function(value) {
		if(!this.setStyle("customDecrementYearButtonVariant")) {
			return this.__customDecrementYearButtonVariant;
		}
		if(this.__customDecrementYearButtonVariant == value) {
			return this.__customDecrementYearButtonVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customDecrementYearButtonVariant);
		this.__customDecrementYearButtonVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customDecrementYearButtonVariant;
	},
	clearStyle_customDecrementYearButtonVariant: function() {
		this.set_customDecrementYearButtonVariant(null);
		return this.get_customDecrementYearButtonVariant();
	},
	get_customIncrementYearButtonVariant: function() {
		return this.__customIncrementYearButtonVariant;
	},
	set_customIncrementYearButtonVariant: function(value) {
		if(!this.setStyle("customIncrementYearButtonVariant")) {
			return this.__customIncrementYearButtonVariant;
		}
		if(this.__customIncrementYearButtonVariant == value) {
			return this.__customIncrementYearButtonVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customIncrementYearButtonVariant);
		this.__customIncrementYearButtonVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customIncrementYearButtonVariant;
	},
	clearStyle_customIncrementYearButtonVariant: function() {
		this.set_customIncrementYearButtonVariant(null);
		return this.get_customIncrementYearButtonVariant();
	},
	get_customMonthTitleViewVariant: function() {
		return this.__customMonthTitleViewVariant;
	},
	set_customMonthTitleViewVariant: function(value) {
		if(!this.setStyle("customMonthTitleViewVariant")) {
			return this.__customMonthTitleViewVariant;
		}
		if(this.__customMonthTitleViewVariant == value) {
			return this.__customMonthTitleViewVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customMonthTitleViewVariant);
		this.__customMonthTitleViewVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customMonthTitleViewVariant;
	},
	clearStyle_customMonthTitleViewVariant: function() {
		this.set_customMonthTitleViewVariant(null);
		return this.get_customMonthTitleViewVariant();
	},
	get_headerGap: function() {
		return this.__headerGap;
	},
	set_headerGap: function(value) {
		if(!this.setStyle("headerGap")) {
			return this.__headerGap;
		}
		if(this.__headerGap == value) {
			return this.__headerGap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_headerGap);
		this.__headerGap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__headerGap;
	},
	clearStyle_headerGap: function() {
		this.set_headerGap(0.0);
		return this.get_headerGap();
	},
	get_paddingTop: function() {
		return this.__paddingTop;
	},
	set_paddingTop: function(value) {
		if(!this.setStyle("paddingTop")) {
			return this.__paddingTop;
		}
		if(this.__paddingTop == value) {
			return this.__paddingTop;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingTop);
		this.__paddingTop = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingTop;
	},
	clearStyle_paddingTop: function() {
		this.set_paddingTop(0.0);
		return this.get_paddingTop();
	},
	get_paddingRight: function() {
		return this.__paddingRight;
	},
	set_paddingRight: function(value) {
		if(!this.setStyle("paddingRight")) {
			return this.__paddingRight;
		}
		if(this.__paddingRight == value) {
			return this.__paddingRight;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingRight);
		this.__paddingRight = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingRight;
	},
	clearStyle_paddingRight: function() {
		this.set_paddingRight(0.0);
		return this.get_paddingRight();
	},
	get_paddingBottom: function() {
		return this.__paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(!this.setStyle("paddingBottom")) {
			return this.__paddingBottom;
		}
		if(this.__paddingBottom == value) {
			return this.__paddingBottom;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingBottom);
		this.__paddingBottom = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingBottom;
	},
	clearStyle_paddingBottom: function() {
		this.set_paddingBottom(0.0);
		return this.get_paddingBottom();
	},
	get_paddingLeft: function() {
		return this.__paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(!this.setStyle("paddingLeft")) {
			return this.__paddingLeft;
		}
		if(this.__paddingLeft == value) {
			return this.__paddingLeft;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingLeft);
		this.__paddingLeft = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingLeft;
	},
	clearStyle_paddingLeft: function() {
		this.set_paddingLeft(0.0);
		return this.get_paddingLeft();
	},
	get_monthTitleViewPosition: function() {
		return this.__monthTitleViewPosition;
	},
	set_monthTitleViewPosition: function(value) {
		if(!this.setStyle("monthTitleViewPosition")) {
			return this.__monthTitleViewPosition;
		}
		if(this.__monthTitleViewPosition == value) {
			return this.__monthTitleViewPosition;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_monthTitleViewPosition);
		this.__monthTitleViewPosition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__monthTitleViewPosition;
	},
	clearStyle_monthTitleViewPosition: function() {
		this.set_monthTitleViewPosition((feathers_layout_HorizontalAlign().default).CENTER);
		return this.get_monthTitleViewPosition();
	},
	get_showMonthTitleView: function() {
		return this.__showMonthTitleView;
	},
	set_showMonthTitleView: function(value) {
		if(!this.setStyle("showMonthTitleView")) {
			return this.__showMonthTitleView;
		}
		if(this.__showMonthTitleView == value) {
			return this.__showMonthTitleView;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_showMonthTitleView);
		this.__showMonthTitleView = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__showMonthTitleView;
	},
	clearStyle_showMonthTitleView: function() {
		this.set_showMonthTitleView(true);
		return this.get_showMonthTitleView();
	},
	get_showMonthButtons: function() {
		return this.__showMonthButtons;
	},
	set_showMonthButtons: function(value) {
		if(!this.setStyle("showMonthButtons")) {
			return this.__showMonthButtons;
		}
		if(this.__showMonthButtons == value) {
			return this.__showMonthButtons;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_showMonthButtons);
		this.__showMonthButtons = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__showMonthButtons;
	},
	clearStyle_showMonthButtons: function() {
		this.set_showMonthButtons(true);
		return this.get_showMonthButtons();
	},
	get_showYearButtons: function() {
		return this.__showYearButtons;
	},
	set_showYearButtons: function(value) {
		if(!this.setStyle("showYearButtons")) {
			return this.__showYearButtons;
		}
		if(this.__showYearButtons == value) {
			return this.__showYearButtons;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_showYearButtons);
		this.__showYearButtons = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__showYearButtons;
	},
	clearStyle_showYearButtons: function() {
		this.set_showYearButtons(true);
		return this.get_showYearButtons();
	},
	get_showWeekdayLabels: function() {
		return this.__showWeekdayLabels;
	},
	set_showWeekdayLabels: function(value) {
		if(!this.setStyle("showWeekdayLabels")) {
			return this.__showWeekdayLabels;
		}
		if(this.__showWeekdayLabels == value) {
			return this.__showWeekdayLabels;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_showWeekdayLabels);
		this.__showWeekdayLabels = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__showWeekdayLabels;
	},
	clearStyle_showWeekdayLabels: function() {
		this.set_showWeekdayLabels(true);
		return this.get_showWeekdayLabels();
	},
	get_customWeekdayLabelVariant: function() {
		return this.__customWeekdayLabelVariant;
	},
	set_customWeekdayLabelVariant: function(value) {
		if(!this.setStyle("customWeekdayLabelVariant")) {
			return this.__customWeekdayLabelVariant;
		}
		if(this.__customWeekdayLabelVariant == value) {
			return this.__customWeekdayLabelVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customWeekdayLabelVariant);
		this.__customWeekdayLabelVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customWeekdayLabelVariant;
	},
	clearStyle_customWeekdayLabelVariant: function() {
		this.set_customWeekdayLabelVariant(null);
		return this.get_customWeekdayLabelVariant();
	},
	get_customDateRendererVariant: function() {
		return this.__customDateRendererVariant;
	},
	set_customDateRendererVariant: function(value) {
		if(!this.setStyle("customDateRendererVariant")) {
			return this.__customDateRendererVariant;
		}
		if(this.__customDateRendererVariant == value) {
			return this.__customDateRendererVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customDateRendererVariant);
		this.__customDateRendererVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customDateRendererVariant;
	},
	clearStyle_customDateRendererVariant: function() {
		this.set_customDateRendererVariant(null);
		return this.get_customDateRendererVariant();
	},
	get_customMutedDateRendererVariant: function() {
		return this.__customMutedDateRendererVariant;
	},
	set_customMutedDateRendererVariant: function(value) {
		if(!this.setStyle("customMutedDateRendererVariant")) {
			return this.__customMutedDateRendererVariant;
		}
		if(this.__customMutedDateRendererVariant == value) {
			return this.__customMutedDateRendererVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customMutedDateRendererVariant);
		this.__customMutedDateRendererVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customMutedDateRendererVariant;
	},
	clearStyle_customMutedDateRendererVariant: function() {
		this.set_customMutedDateRendererVariant(null);
		return this.get_customMutedDateRendererVariant();
	},
	get_showDatesFromAdjacentMonths: function() {
		return this.__showDatesFromAdjacentMonths;
	},
	set_showDatesFromAdjacentMonths: function(value) {
		if(!this.setStyle("showDatesFromAdjacentMonths")) {
			return this.__showDatesFromAdjacentMonths;
		}
		if(this.__showDatesFromAdjacentMonths == value) {
			return this.__showDatesFromAdjacentMonths;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_showDatesFromAdjacentMonths);
		this.__showDatesFromAdjacentMonths = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__showDatesFromAdjacentMonths;
	},
	clearStyle_showDatesFromAdjacentMonths: function() {
		this.set_showDatesFromAdjacentMonths(true);
		return this.get_showDatesFromAdjacentMonths();
	},
	get_styleContext: function() {
		return DatePicker
	}
});
DatePicker.prototype.__class__ = DatePicker.prototype.constructor = $hxClasses["feathers.controls.DatePicker"] = DatePicker;

// Init



// Statics

DatePicker.defaultUpdateDateRenderer = function(dateRenderer,state) {
	if((js_Boot().default).__implements(dateRenderer,(feathers_core_ITextControl().default))) {
		var textControl = (js_Boot().default).__cast(dateRenderer , (feathers_core_ITextControl().default));
		textControl.set_text((Std().default).string(state.date.getDate()));
	}
}
DatePicker.defaultResetDateRenderer = function(dateRenderer,state) {
	if((js_Boot().default).__implements(dateRenderer,(feathers_core_ITextControl().default))) {
		var textControl = (js_Boot().default).__cast(dateRenderer , (feathers_core_ITextControl().default));
		textControl.set_text(null);
	}
}
DatePicker.DEFAULT_MONTH_NAMES = ["January","February","March","April","May","June","July","August","September","October","November","December"]
DatePicker.INVALIDATION_FLAG_MONTH_TITLE_VIEW_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("monthTitleViewFactory")
DatePicker.INVALIDATION_FLAG_DECREMENT_MONTH_BUTTON_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("decrementMonthButtonFactory")
DatePicker.INVALIDATION_FLAG_INCREMENT_MONTH_BUTTON_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("incrementMonthButtonFactory")
DatePicker.INVALIDATION_FLAG_DECREMENT_YEAR_BUTTON_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("decrementYearButtonFactory")
DatePicker.INVALIDATION_FLAG_INCREMENT_YEAR_BUTTON_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("incrementYearButtonFactory")
DatePicker.INVALIDATION_FLAG_DATE_RENDERER_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("dateRendererFactory")
DatePicker.INVALIDATION_FLAG_WEEKDAY_LABEL_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("weekdayLabelFactory")
DatePicker.RESET_ITEM_STATE = new (feathers_data_DatePickerItemState().default)()
DatePicker.CHILD_VARIANT_DATE_RENDERER = "datePicker_dateRenderer"
DatePicker.CHILD_VARIANT_MUTED_DATE_RENDERER = "datePicker_mutedDateRenderer"
DatePicker.CHILD_VARIANT_DECREMENT_MONTH_BUTTON = "datePicker_decrementMonthButton"
DatePicker.CHILD_VARIANT_INCREMENT_MONTH_BUTTON = "datePicker_incrementMonthButton"
DatePicker.CHILD_VARIANT_DECREMENT_YEAR_BUTTON = "datePicker_decrementYearButton"
DatePicker.CHILD_VARIANT_INCREMENT_YEAR_BUTTON = "datePicker_incrementYearButton"
DatePicker.CHILD_VARIANT_MONTH_TITLE_VIEW = "datePicker_monthTitleView"
DatePicker.CHILD_VARIANT_WEEKDAY_LABEL = "datePicker_weekdayLabel"
DatePicker.defaultDecrementMonthButtonFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_Button().default))
DatePicker.defaultIncrementMonthButtonFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_Button().default))
DatePicker.defaultDecrementYearButtonFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_Button().default))
DatePicker.defaultIncrementYearButtonFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_Button().default))
DatePicker.defaultMonthTitleViewFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_Label().default))
DatePicker.defaultWeekdayLabelFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_Label().default))

// Export

exports["default"] = DatePicker;

/***/ }),

/***/ "./lib/_gen/feathers/controls/Drawer.js":
/*!**********************************************!*\
  !*** ./lib/_gen/feathers/controls/Drawer.js ***!
  \**********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.Drawer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IFocusExclusions() {return __webpack_require__(/*! ./../../feathers/core/IFocusExclusions */ "./lib/_gen/feathers/core/IFocusExclusions.js");}
function feathers_core_IOpenCloseToggle() {return __webpack_require__(/*! ./../../feathers/core/IOpenCloseToggle */ "./lib/_gen/feathers/core/IOpenCloseToggle.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function feathers_layout_AutoSizeMode() {return __webpack_require__(/*! ./../../feathers/layout/AutoSizeMode */ "./lib/_gen/feathers/layout/AutoSizeMode.js");}
function feathers_themes_steel_components_SteelDrawerStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelDrawerStyles */ "./lib/_gen/feathers/themes/steel/components/SteelDrawerStyles.js");}
function feathers_utils_EdgePuller() {return __webpack_require__(/*! ./../../feathers/utils/EdgePuller */ "./lib/_gen/feathers/utils/EdgePuller.js");}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_utils_MeasurementsUtil() {return __webpack_require__(/*! ./../../feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function openfl_display_Sprite() {return (__webpack_require__(/*! openfl */ "openfl").display.Sprite);}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}
function openfl_display_DisplayObjectContainer() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObjectContainer);}
function openfl_display_DisplayObject() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObject);}
function feathers_utils_ExclusivePointer() {return __webpack_require__(/*! ./../../feathers/utils/ExclusivePointer */ "./lib/_gen/feathers/utils/ExclusivePointer.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}

// Constructor

var Drawer = function(content,drawer) {
	this.__overlaySkin = null;
	this._swipeOpenEnabled = true;
	this._swipeCloseEnabled = true;
	this._clickOverlayToClose = true;
	this._clickStartY = 0.0;
	this._clickStartX = 0.0;
	this._simulateTouch = false;
	this._autoSizeMode = (feathers_layout_AutoSizeMode().default).STAGE;
	this._opened = false;
	this._pendingOpened = null;
	this._pullableEdge = (feathers_layout_RelativePosition().default).LEFT;
	this._ignoreContentResize = false;
	this._ignoreDrawerResize = false;
	this._focusExclusions = [];
	this.initializeDrawerTheme();
	(feathers_core_FeathersControl().default).call(this);
	this.set_content(content);
	this.set_drawer(drawer);
	this.addEventListener("addedToStage",$bind(this,this.drawer_addedToStageHandler));
}

// Meta

Drawer.__name__ = "feathers.controls.Drawer";
Drawer.__isInterface__ = false;
Drawer.__interfaces__ = [(feathers_core_IFocusExclusions().default),(feathers_core_IOpenCloseToggle().default)];
Drawer.__super__ = (feathers_core_FeathersControl().default);
Drawer.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_focusExclusions: function() {
		if(this._edgePuller != null && (this._edgePuller.get_opened() || this._edgePuller.get_active())) {
			return this._focusExclusions;
		}
		return null;
	},
	get_drawer: function() {
		return this._drawer;
	},
	set_drawer: function(value) {
		if(this._drawer == value) {
			return this._drawer;
		}
		if(this._drawer != null) {
			this._drawer.removeEventListener("resize",$bind(this,this.drawer_drawer_resizeHandler));
			this._drawerMeasurements.restore(this._drawer);
			if(this._drawer.parent == this) {
				this.removeChild(this._drawer);
			}
		}
		this._drawer = value;
		if(this._drawer != null) {
			this._drawer.set_visible(false);
			this.addChild(this._drawer);
			if((js_Boot().default).__implements(this._drawer,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(this._drawer , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(this._drawerMeasurements == null) {
				this._drawerMeasurements = new (feathers_layout_Measurements().default)(this._drawer);
			} else {
				this._drawerMeasurements.save(this._drawer);
			}
			this._drawer.addEventListener("resize",$bind(this,this.drawer_drawer_resizeHandler),false,0,true);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._drawer;
	},
	get_content: function() {
		return this._content;
	},
	set_content: function(value) {
		if(this._content == value) {
			return this._content;
		}
		if(this._content != null) {
			this._content.removeEventListener("resize",$bind(this,this.drawer_content_resizeHandler));
			this._contentMeasurements.restore(this._content);
			if(this._content.parent == this) {
				this.removeChild(this._content);
			}
			(HxOverrides().default).remove(this._focusExclusions,this._content);
		}
		this._content = value;
		if(this._content != null) {
			this.addChildAt(this._content,0);
			if((js_Boot().default).__implements(this._content,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(this._content , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(this._contentMeasurements == null) {
				this._contentMeasurements = new (feathers_layout_Measurements().default)(this._content);
			} else {
				this._contentMeasurements.save(this._content);
			}
			this._content.addEventListener("resize",$bind(this,this.drawer_content_resizeHandler),false,0,true);
			this._focusExclusions.push(this._content);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._content;
	},
	get_pullableEdge: function() {
		return this._pullableEdge;
	},
	set_pullableEdge: function(value) {
		if(this._pullableEdge == value) {
			return this._pullableEdge;
		}
		this._pullableEdge = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._pullableEdge;
	},
	get_opened: function() {
		if(this._pendingOpened != null) {
			return this._pendingOpened;
		}
		return this._opened;
	},
	set_opened: function(value) {
		if(this._pendingOpened == value) {
			return this._pendingOpened;
		}
		this._pendingOpened = value;
		if(value && this._drawer == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Cannot set opened property to true because drawer property is null"));
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._pendingOpened;
	},
	get_autoSizeMode: function() {
		return this._autoSizeMode;
	},
	set_autoSizeMode: function(value) {
		if(this._autoSizeMode == value) {
			return this._autoSizeMode;
		}
		this._autoSizeMode = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		if(this.stage != null) {
			if(this._autoSizeMode == (feathers_layout_AutoSizeMode().default).STAGE) {
				this.stage.addEventListener("resize",$bind(this,this.drawer_stage_resizeHandler));
				this.addEventListener("removedFromStage",$bind(this,this.drawer_removedFromStageHandler));
			} else {
				this.stage.removeEventListener("resize",$bind(this,this.drawer_stage_resizeHandler));
				this.removeEventListener("removedFromStage",$bind(this,this.drawer_removedFromStageHandler));
			}
		}
		return this._autoSizeMode;
	},
	get_simulateTouch: function() {
		return this._simulateTouch;
	},
	set_simulateTouch: function(value) {
		if(this._simulateTouch == value) {
			return this._simulateTouch;
		}
		this._simulateTouch = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._simulateTouch;
	},
	get_clickOverlayToClose: function() {
		return this._clickOverlayToClose;
	},
	set_clickOverlayToClose: function(value) {
		this._clickOverlayToClose = value;
		return this._clickOverlayToClose;
	},
	get_swipeCloseEnabled: function() {
		return this._swipeCloseEnabled;
	},
	set_swipeCloseEnabled: function(value) {
		if(this._swipeCloseEnabled == value) {
			return this._swipeCloseEnabled;
		}
		this._swipeCloseEnabled = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STATE);
		return this._swipeCloseEnabled;
	},
	get_swipeOpenEnabled: function() {
		return this._swipeOpenEnabled;
	},
	set_swipeOpenEnabled: function(value) {
		if(this._swipeOpenEnabled == value) {
			return this._swipeOpenEnabled;
		}
		this._swipeOpenEnabled = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STATE);
		return this._swipeOpenEnabled;
	},
	initializeDrawerTheme: function() {
		(feathers_themes_steel_components_SteelDrawerStyles().default).initialize();
	},
	initialize: function() {
		(feathers_core_FeathersControl().default).prototype.initialize.call(this);
		if(this._edgePuller == null) {
			this._edgePuller = new (feathers_utils_EdgePuller().default)(this._content);
		}
		this._edgePuller.addEventListener("opening",$bind(this,this.drawer_edgePuller_openingHandler));
		this._edgePuller.addEventListener("closing",$bind(this,this.drawer_edgePuller_closingHandler));
		this._edgePuller.addEventListener("open",$bind(this,this.drawer_edgePuller_openHandler));
		this._edgePuller.addEventListener("close",$bind(this,this.drawer_edgePuller_closeHandler));
		this._edgePuller.addEventListener("cancel",$bind(this,this.drawer_edgePuller_cancelHandler));
		this._edgePuller.addEventListener("change",$bind(this,this.drawer_edgePuller_changeHandler));
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(dataInvalid) {
			this._edgePuller.set_target(this._content);
			this._edgePuller.set_pullableEdge(this._pullableEdge);
			this._edgePuller.simulateTouch = this._simulateTouch;
		}
		if(stylesInvalid) {
			this.refreshOverlaySkin();
		}
		if(stateInvalid || dataInvalid) {
			this.refreshEnabled();
		}
		this.measure();
		this.layoutChildren();
		if(dataInvalid) {
			if(this._pendingOpened != null) {
				this._edgePuller.set_opened(this._pendingOpened);
				this._pendingOpened = null;
			} else {
				this._edgePuller.set_opened(this._opened);
			}
		}
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		var needsToMeasureContent = this._autoSizeMode == (feathers_layout_AutoSizeMode().default).CONTENT || this.stage == null;
		var stageWidth = 0.0;
		var stageHeight = 0.0;
		if(!needsToMeasureContent) {
			var topLeft = this.globalToLocal(new (openfl_geom_Point())());
			var bottomRight = this.globalToLocal(new (openfl_geom_Point())(this.stage.stageWidth,this.stage.stageHeight));
			stageWidth = bottomRight.x - topLeft.x;
			stageHeight = bottomRight.y - topLeft.y;
			return this.saveMeasurements(stageWidth,stageHeight,stageWidth,stageHeight);
		}
		var measureContent = null;
		if((js_Boot().default).__implements(this._content,(feathers_core_IMeasureObject().default))) {
			measureContent = (js_Boot().default).__cast(this._content , (feathers_core_IMeasureObject().default));
		}
		if(this._content != null) {
			var oldIgnoreContentResize = this._ignoreContentResize;
			this._ignoreContentResize = true;
			(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParentValues(this._contentMeasurements,this._content,this.get_explicitWidth(),this.get_explicitHeight(),this.get_explicitMinWidth(),this.get_explicitMinHeight(),this.get_explicitMaxWidth(),this.get_explicitMaxHeight());
			if((js_Boot().default).__implements(this._content,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._content , (feathers_core_IValidating().default))).validateNow();
			}
			this._ignoreContentResize = oldIgnoreContentResize;
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			newWidth = 0.0;
			if(this._content != null) {
				newWidth = this._content.get_width();
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			newHeight = 0.0;
			if(this._content != null) {
				newHeight = this._content.get_height();
			}
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			if(measureContent != null) {
				newMinWidth = measureContent.get_minWidth();
			} else if(this._contentMeasurements != null) {
				newMinWidth = this._contentMeasurements.minWidth;
			}
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			if(measureContent != null) {
				newMinHeight = measureContent.get_minHeight();
			} else if(this._contentMeasurements != null) {
				newMinHeight = this._contentMeasurements.minHeight;
			}
		}
		var newMaxWidth = this.get_explicitMaxWidth();
		if(needsMaxWidth) {
			if(measureContent != null) {
				newMaxWidth = measureContent.get_maxWidth();
			} else if(this._contentMeasurements != null) {
				newMaxWidth = this._contentMeasurements.maxWidth;
			}
		}
		var newMaxHeight = this.get_explicitMaxHeight();
		if(needsMaxHeight) {
			if(measureContent != null) {
				newMaxHeight = measureContent.get_maxHeight();
			} else if(this._contentMeasurements != null) {
				newMaxHeight = this._contentMeasurements.maxHeight;
			}
		}
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight,newMaxWidth,newMaxHeight);
	},
	refreshEnabled: function() {
		this._edgePuller.enabled = this._enabled && this._drawer != null && (this._opened && this._swipeCloseEnabled || !this._opened && this._swipeOpenEnabled);
		if((js_Boot().default).__implements(this._content,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._content , (feathers_core_IUIControl().default))).set_enabled(this._enabled);
		}
		if((js_Boot().default).__implements(this._drawer,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._drawer , (feathers_core_IUIControl().default))).set_enabled(this._enabled);
		}
	},
	refreshOverlaySkin: function() {
		var oldSkin = this._currentOverlaySkin;
		this._currentOverlaySkin = this.getCurrentOverlaySkin();
		if(this._currentOverlaySkin == oldSkin) {
			return;
		}
		this.removeCurrentOverlaySkin(oldSkin);
		if(this._currentOverlaySkin == null) {
			this._overlaySkinMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(this._currentOverlaySkin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._currentOverlaySkin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._overlaySkinMeasurements == null) {
			this._overlaySkinMeasurements = new (feathers_layout_Measurements().default)(this._currentOverlaySkin);
		} else {
			this._overlaySkinMeasurements.save(this._currentOverlaySkin);
		}
		this._overlaySkinAlpha = this._currentOverlaySkin.get_alpha();
		if((js_Boot().default).__implements(this._currentOverlaySkin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(this._currentOverlaySkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this._currentOverlaySkin.addEventListener("mouseDown",$bind(this,this.drawer_overlaySkin_mouseDownHandler),false,0,true);
		this._currentOverlaySkin.addEventListener("click",$bind(this,this.drawer_overlaySkin_clickHandler),false,0,true);
		this._currentOverlaySkin.addEventListener("touchBegin",$bind(this,this.drawer_overlaySkin_touchBeginHandler),false,0,true);
		this._currentOverlaySkin.addEventListener("touchTap",$bind(this,this.drawer_overlaySkin_touchTapHandler),false,0,true);
		this._currentOverlaySkin.set_visible(false);
		var index = -1;
		if(this._drawer != null) {
			index = this.getChildIndex(this._drawer);
		}
		if(index == -1) {
			index = this.get_numChildren();
		}
		this.addChildAt(this._currentOverlaySkin,index);
	},
	getCurrentOverlaySkin: function() {
		if(this.get_overlaySkin() == null) {
			if(this._fallbackOverlaySkin == null) {
				this._fallbackOverlaySkin = new (openfl_display_Sprite())();
				this._fallbackOverlaySkin.get_graphics().beginFill(16711935,0.0);
				this._fallbackOverlaySkin.get_graphics().drawRect(0.0,0.0,1.0,1.0);
				this._fallbackOverlaySkin.get_graphics().endFill();
			}
			return this._fallbackOverlaySkin;
		}
		return this.get_overlaySkin();
	},
	removeCurrentOverlaySkin: function(skin) {
		if(skin == null) {
			return;
		}
		skin.removeEventListener("mouseDown",$bind(this,this.drawer_overlaySkin_mouseDownHandler));
		skin.removeEventListener("click",$bind(this,this.drawer_overlaySkin_clickHandler));
		skin.removeEventListener("touchBegin",$bind(this,this.drawer_overlaySkin_touchBeginHandler));
		skin.removeEventListener("touchTap",$bind(this,this.drawer_overlaySkin_touchTapHandler));
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		this._overlaySkinMeasurements.restore(skin);
		this._currentOverlaySkin.set_alpha(this._overlaySkinAlpha);
		if(skin.parent == this) {
			this.removeChild(skin);
		}
	},
	layoutChildren: function() {
		var oldIgnoreContentResize = this._ignoreContentResize;
		this._ignoreContentResize = true;
		if(this._content != null) {
			this._content.set_x(0.0);
			this._content.set_y(0.0);
			if(this._content.get_width() != this.actualWidth) {
				this._content.set_width(this.actualWidth);
			}
			if(this._content.get_height() != this.actualHeight) {
				this._content.set_height(this.actualHeight);
			}
			if((js_Boot().default).__implements(this._content,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._content , (feathers_core_IValidating().default))).validateNow();
			}
		}
		this._ignoreContentResize = oldIgnoreContentResize;
		if(this._currentOverlaySkin != null) {
			this._currentOverlaySkin.set_x(0.0);
			this._currentOverlaySkin.set_y(0.0);
			this._currentOverlaySkin.set_width(this.actualWidth);
			this._currentOverlaySkin.set_height(this.actualHeight);
		}
		var oldIgnoreDrawerResize = this._ignoreDrawerResize;
		this._ignoreDrawerResize = true;
		if(this._drawer != null) {
			switch(this._pullableEdge._hx_index) {
			case 0:
				this._drawer.set_x(0.0);
				this._drawer.set_width(this.actualWidth);
				break;
			case 1:
				this._drawer.set_y(0.0);
				this._drawer.set_height(this.actualHeight);
				break;
			case 2:
				this._drawer.set_x(0.0);
				this._drawer.set_width(this.actualWidth);
				break;
			case 3:
				this._drawer.set_y(0.0);
				this._drawer.set_height(this.actualHeight);
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown pullable edge position: " + (Std().default).string(this._pullableEdge)));
			}
			if((js_Boot().default).__implements(this._drawer,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._drawer , (feathers_core_IValidating().default))).validateNow();
			}
			var maxPullDistance = 0.0;
			if(this._drawer != null) {
				switch(this._pullableEdge._hx_index) {
				case 0:
					maxPullDistance = this._drawer.get_height();
					break;
				case 1:
					maxPullDistance = this._drawer.get_width();
					break;
				case 2:
					maxPullDistance = this._drawer.get_height();
					break;
				case 3:
					maxPullDistance = this._drawer.get_width();
					break;
				default:
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown pullable edge position: " + (Std().default).string(this._pullableEdge)));
				}
			}
			this._edgePuller.set_maxPullDistance(maxPullDistance);
		}
		this._ignoreDrawerResize = oldIgnoreDrawerResize;
	},
	updateWithPullDistance: function() {
		switch(this._pullableEdge._hx_index) {
		case 0:
			this._drawer.set_y(-this._drawer.get_height() + this._edgePuller.get_pullDistance());
			break;
		case 1:
			this._drawer.set_x(this.actualWidth - this._edgePuller.get_pullDistance());
			break;
		case 2:
			this._drawer.set_y(this.actualHeight - this._edgePuller.get_pullDistance());
			break;
		case 3:
			this._drawer.set_x(-this._drawer.get_width() + this._edgePuller.get_pullDistance());
			break;
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown pullable edge position: " + (Std().default).string(this._pullableEdge)));
		}
		if(this._currentOverlaySkin != null) {
			this._currentOverlaySkin.set_alpha(this._overlaySkinAlpha * (this._edgePuller.get_pullDistance() / this.getMaxPullDistance()));
		}
	},
	getMaxPullDistance: function() {
		if(this._edgePuller.get_maxPullDistance() != null) {
			return this._edgePuller.get_maxPullDistance();
		}
		if(this._content == null) {
			return 0.0;
		}
		switch(this._pullableEdge._hx_index) {
		case 0:
			return this._content.get_height();
		case 1:
			return this._content.get_width();
		case 2:
			return this._content.get_height();
		case 3:
			return this._content.get_width();
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown pullable edge position: " + (Std().default).string(this._pullableEdge)));
		}
	},
	clearFocusOnOpening: function() {
		if(this._focusManager != null) {
			if(this._focusManager.get_focus() == null) {
				return;
			}
			if((js_Boot().default).__implements(this._content,(feathers_core_IFocusObject().default)) && this._focusManager.get_focus() == (js_Boot().default).__cast(this._content , (feathers_core_IFocusObject().default))) {
				this._focusManager.set_focus(null);
			} else if(((this._content) instanceof (openfl_display_DisplayObjectContainer())) && ((js_Boot().default).__cast(this._content , (openfl_display_DisplayObjectContainer()))).contains((js_Boot().default).__cast(this._focusManager.get_focus() , (openfl_display_DisplayObject())))) {
				this._focusManager.set_focus(null);
			}
		}
		if(this.stage.get_focus() == null) {
			return;
		}
		if(this.stage.get_focus() == this._content || ((this._content) instanceof (openfl_display_DisplayObjectContainer())) && ((js_Boot().default).__cast(this._content , (openfl_display_DisplayObjectContainer()))).contains(this.stage.get_focus())) {
			this.stage.set_focus(this.stage);
		}
	},
	drawer_edgePuller_openingHandler: function(event) {
		var touchPointID = this._edgePuller.get_touchPointID();
		if(touchPointID != null) {
			var exclusivePointer = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
			if(this._edgePuller.get_touchPointIsSimulated()) {
				var result = exclusivePointer.claimMouse(this);
				if(!result) {
					event.preventDefault();
					return;
				}
			} else {
				var result1 = exclusivePointer.claimTouch(touchPointID,this);
				if(!result1) {
					event.preventDefault();
					return;
				}
			}
		}
		var result2 = (feathers_events_FeathersEvent().default).dispatch(this,"opening");
		if(!result2) {
			event.preventDefault();
			return;
		}
		this.clearFocusOnOpening();
		this.updateWithPullDistance();
		this._drawer.set_visible(true);
		if(this._currentOverlaySkin != null) {
			this._currentOverlaySkin.set_visible(true);
		}
	},
	drawer_edgePuller_closingHandler: function(event) {
		var result = (feathers_events_FeathersEvent().default).dispatch(this,"closing");
		if(!result) {
			event.preventDefault();
			return;
		}
		this.updateWithPullDistance();
		this._drawer.set_visible(true);
		if(this._currentOverlaySkin != null) {
			this._currentOverlaySkin.set_visible(true);
		}
	},
	drawer_edgePuller_openHandler: function(event) {
		if(this._currentOverlaySkin != null) {
			this._currentOverlaySkin.set_alpha(this._overlaySkinAlpha);
			this._currentOverlaySkin.set_visible(true);
		}
		this._opened = true;
		(feathers_events_FeathersEvent().default).dispatch(this,"open");
		this.setInvalid((feathers_core_InvalidationFlag().default).STATE);
	},
	drawer_edgePuller_closeHandler: function(event) {
		this._drawer.set_visible(false);
		if(this._currentOverlaySkin != null) {
			this._currentOverlaySkin.set_alpha(this._overlaySkinAlpha);
			this._currentOverlaySkin.set_visible(false);
		}
		this._opened = false;
		(feathers_events_FeathersEvent().default).dispatch(this,"close");
		this.setInvalid((feathers_core_InvalidationFlag().default).STATE);
	},
	drawer_edgePuller_cancelHandler: function(event) {
		if(!this._opened) {
			this._drawer.set_visible(false);
			if(this._currentOverlaySkin != null) {
				this._currentOverlaySkin.set_alpha(this._overlaySkinAlpha);
				this._currentOverlaySkin.set_visible(false);
			}
		}
		(feathers_events_FeathersEvent().default).dispatch(this,"cancel");
		this.setInvalid((feathers_core_InvalidationFlag().default).STATE);
	},
	drawer_edgePuller_changeHandler: function(event) {
		this.updateWithPullDistance();
	},
	drawer_addedToStageHandler: function(event) {
		if(this._autoSizeMode == (feathers_layout_AutoSizeMode().default).STAGE) {
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
			this.addEventListener("removedFromStage",$bind(this,this.drawer_removedFromStageHandler));
			this.stage.addEventListener("resize",$bind(this,this.drawer_stage_resizeHandler));
		}
	},
	drawer_removedFromStageHandler: function(event) {
		this.removeEventListener("removedFromStage",$bind(this,this.drawer_removedFromStageHandler));
		this.stage.removeEventListener("resize",$bind(this,this.drawer_stage_resizeHandler));
	},
	drawer_stage_resizeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
	},
	drawer_overlaySkin_mouseDownHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		this._clickStartX = event.localX;
		this._clickStartY = event.localY;
	},
	drawer_overlaySkin_clickHandler: function(event) {
		if(!this._enabled || !this._clickOverlayToClose) {
			return;
		}
		var movementX = Math.abs(event.localX - this._clickStartX);
		var movementY = Math.abs(event.localY - this._clickStartY);
		if(movementX > Drawer.MAX_CLICK_DISTANCE_FOR_CLOSE || movementY > Drawer.MAX_CLICK_DISTANCE_FOR_CLOSE) {
			return;
		}
		this.set_opened(false);
	},
	drawer_overlaySkin_touchBeginHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(event.isPrimaryTouchPoint) {
			return;
		}
		this._clickStartX = event.localX;
		this._clickStartY = event.localY;
	},
	drawer_overlaySkin_touchTapHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(event.isPrimaryTouchPoint) {
			return;
		}
		var movementX = Math.abs(event.localX - this._clickStartX);
		var movementY = Math.abs(event.localY - this._clickStartY);
		if(movementX > Drawer.MAX_CLICK_DISTANCE_FOR_CLOSE || movementY > Drawer.MAX_CLICK_DISTANCE_FOR_CLOSE) {
			return;
		}
		this.set_opened(false);
	},
	drawer_drawer_resizeHandler: function(event) {
		if(this._ignoreDrawerResize) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
	},
	drawer_content_resizeHandler: function(event) {
		if(this._ignoreContentResize) {
			return;
		}
		this._contentMeasurements.save(this.get_content());
		this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
	},
	get_overlaySkin: function() {
		return this.__overlaySkin;
	},
	set_overlaySkin: function(value) {
		if(!this.setStyle("overlaySkin")) {
			return this.__overlaySkin;
		}
		if(this.__overlaySkin == value) {
			return this.__overlaySkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_overlaySkin);
		this.__overlaySkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__overlaySkin;
	},
	clearStyle_overlaySkin: function() {
		this.set_overlaySkin(null);
		return this.get_overlaySkin();
	},
	get_styleContext: function() {
		return Drawer
	}
});
Drawer.prototype.__class__ = Drawer.prototype.constructor = $hxClasses["feathers.controls.Drawer"] = Drawer;

// Init



// Statics


Drawer.__meta__ = { obj : { defaultXmlProperty : ["content"]}}
Drawer.MAX_CLICK_DISTANCE_FOR_CLOSE = 6.0

// Export

exports["default"] = Drawer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/Form.js":
/*!********************************************!*\
  !*** ./lib/_gen/feathers/controls/Form.js ***!
  \********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.Form

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_LayoutGroup() {return __webpack_require__(/*! ./../../feathers/controls/LayoutGroup */ "./lib/_gen/feathers/controls/LayoutGroup.js");}
function feathers_events_FormEvent() {return __webpack_require__(/*! ./../../feathers/events/FormEvent */ "./lib/_gen/feathers/events/FormEvent.js");}
function feathers_themes_steel_components_SteelFormStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelFormStyles */ "./lib/_gen/feathers/themes/steel/components/SteelFormStyles.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function openfl_display_DisplayObject() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObject);}
function feathers_controls_FormItem() {return __webpack_require__(/*! ./../../feathers/controls/FormItem */ "./lib/_gen/feathers/controls/FormItem.js");}

// Constructor

var Form = function() {
	this.initializeFormTheme();
	(feathers_controls_LayoutGroup().default).call(this);
	this.addEventListener("keyDown",$bind(this,this.form_keyDownHandler));
}

// Meta

Form.__name__ = "feathers.controls.Form";
Form.__isInterface__ = false;
Form.__super__ = (feathers_controls_LayoutGroup().default);
Form.prototype = $extend((feathers_controls_LayoutGroup().default).prototype, {
	get_submitButton: function() {
		return this._submitButton;
	},
	set_submitButton: function(value) {
		if(this._submitButton == value) {
			return this._submitButton;
		}
		if(this._submitButton != null) {
			this._submitButton.removeEventListener("trigger",$bind(this,this.form_submitButton_triggerHandler));
		}
		this._submitButton = value;
		if(this._submitButton != null) {
			this._submitButton.addEventListener("trigger",$bind(this,this.form_submitButton_triggerHandler),false,0,true);
		}
		return this._submitButton;
	},
	submit: function() {
		(feathers_events_FormEvent().default).dispatch(this,"submit");
	},
	initializeFormTheme: function() {
		(feathers_themes_steel_components_SteelFormStyles().default).initialize();
	},
	form_keyDownHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(event.keyCode != 13) {
			return;
		}
		if(event.isDefaultPrevented()) {
			return;
		}
		var current = (js_Boot().default).__cast(event.target , (openfl_display_DisplayObject()));
		while(current != this && current != null) {
			if(((current) instanceof (feathers_controls_FormItem().default))) {
				var formItem = (js_Boot().default).__cast(current , (feathers_controls_FormItem().default));
				if(!formItem.submitOnEnterEnabled) {
					return;
				}
			}
			current = current.parent;
		}
		event.preventDefault();
		this.submit();
	},
	form_submitButton_triggerHandler: function(event) {
		this.submit();
	},
	get_styleContext: function() {
		return Form
	}
});
Form.prototype.__class__ = Form.prototype.constructor = $hxClasses["feathers.controls.Form"] = Form;

// Init



// Statics




// Export

exports["default"] = Form;

/***/ }),

/***/ "./lib/_gen/feathers/controls/FormItem.js":
/*!************************************************!*\
  !*** ./lib/_gen/feathers/controls/FormItem.js ***!
  \************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.FormItem

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IFocusManagerAware() {return __webpack_require__(/*! ./../../feathers/core/IFocusManagerAware */ "./lib/_gen/feathers/core/IFocusManagerAware.js");}
function feathers_core_ITextControl() {return __webpack_require__(/*! ./../../feathers/core/ITextControl */ "./lib/_gen/feathers/core/ITextControl.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_themes_steel_components_SteelFormItemStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelFormItemStyles */ "./lib/_gen/feathers/themes/steel/components/SteelFormItemStyles.js");}
function openfl_text_TextField() {return (__webpack_require__(/*! openfl */ "openfl").text.TextField);}
function feathers_utils_MeasurementsUtil() {return __webpack_require__(/*! ./../../feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}

// Constructor

var FormItem = function(text,content,required) {
	if(required == null) {
		required = false;
	}
	if(text == null) {
		text = "";
	}
	this.__textPosition = (feathers_layout_RelativePosition().default).TOP;
	this.__disabledBackgroundSkin = null;
	this.__backgroundSkin = null;
	this.__wordWrap = false;
	this.__verticalAlign = (feathers_layout_VerticalAlign().default).MIDDLE;
	this.__horizontalAlign = (feathers_layout_HorizontalAlign().default).LEFT;
	this.__gap = 0.0;
	this.__paddingLeft = 0.0;
	this.__paddingBottom = 0.0;
	this.__paddingRight = 0.0;
	this.__paddingTop = 0.0;
	this.__embedFonts = false;
	this.__disabledTextFormat = null;
	this.__textFormat = null;
	this.__requiredSkin = null;
	this._backgroundSkinMeasurements = null;
	this._currentBackgroundSkin = null;
	this._customTextColumnWidth = null;
	this._requiredSkinMeasurements = null;
	this._currentRequiredSkin = null;
	this.submitOnEnterEnabled = true;
	this._required = false;
	this._selectable = false;
	this._currentContent = null;
	this._contentMeasurements = null;
	this._htmlText = null;
	this._wrappedOnMeasure = false;
	this._updatedTextStyles = false;
	this._previousSimpleTextFormat = null;
	this._previousTextFormat = null;
	this._previousHTMLText = null;
	this._previousText = null;
	this.initializeFormItemTheme();
	(feathers_core_FeathersControl().default).call(this);
	this.set_text(text);
	this.set_content(content);
	this.set_required(required);
}

// Meta

FormItem.__name__ = "feathers.controls.FormItem";
FormItem.__isInterface__ = false;
FormItem.__interfaces__ = [(feathers_core_IFocusManagerAware().default),(feathers_core_ITextControl().default)];
FormItem.__super__ = (feathers_core_FeathersControl().default);
FormItem.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_text: function() {
		return this._text;
	},
	set_text: function(value) {
		if(value == null) {
			if(this._text.length == 0) {
				return this._text;
			}
			value = "";
		}
		if(this._text == value) {
			return this._text;
		}
		this._text = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._text;
	},
	get_htmlText: function() {
		return this._htmlText;
	},
	set_htmlText: function(value) {
		if(this._htmlText == value) {
			return this._htmlText;
		}
		this._htmlText = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._htmlText;
	},
	get_baseline: function() {
		if(this.textField == null) {
			return 0.0;
		}
		var textFieldBaseline = 0.0;
		var hasText = this._text != null && this._text.length > 0;
		var hasHTMLText = this._htmlText != null && this._htmlText.length > 0;
		if(hasText || hasHTMLText) {
			textFieldBaseline = this.textField.get_y() + this.textField.getLineMetrics(0).ascent;
		} else {
			this.textField.set_text("​");
			textFieldBaseline = this.textField.get_y() + this.textField.getLineMetrics(0).ascent;
			this.textField.set_text("");
		}
		var contentBaseline = 0.0;
		if((js_Boot().default).__implements(this._currentContent,(feathers_core_ITextControl().default))) {
			contentBaseline = this._currentContent.get_y() + ((js_Boot().default).__cast(this._currentContent , (feathers_core_ITextControl().default))).get_baseline();
		}
		return Math.max(textFieldBaseline,contentBaseline);
	},
	get_content: function() {
		return this._content;
	},
	set_content: function(value) {
		if(this._content == value) {
			return this._content;
		}
		this._content = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._content;
	},
	get_selectable: function() {
		return this._selectable;
	},
	set_selectable: function(value) {
		if(this._selectable == value) {
			return this._selectable;
		}
		this._selectable = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		return this._selectable;
	},
	get_selectionBeginIndex: function() {
		if(!this._selectable) {
			return -1;
		}
		if(this.textField == null) {
			return 0;
		}
		return this.textField.get_selectionBeginIndex();
	},
	get_selectionEndIndex: function() {
		if(!this._selectable) {
			return -1;
		}
		if(this.textField == null) {
			return 0;
		}
		return this.textField.get_selectionEndIndex();
	},
	get_required: function() {
		return this._required;
	},
	set_required: function(value) {
		if(this._required == value) {
			return this._required;
		}
		this._required = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		return this._required;
	},
	get_customTextColumnWidth: function() {
		return this._customTextColumnWidth;
	},
	set_customTextColumnWidth: function(value) {
		if(this._customTextColumnWidth == value) {
			return this._customTextColumnWidth;
		}
		this._customTextColumnWidth = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		return this._customTextColumnWidth;
	},
	getTextMeasuredWidth: function() {
		var result = this._textMeasuredWidth;
		if(this._currentRequiredSkin != null) {
			result += this.get_gap() + this._currentRequiredSkin.get_width();
		}
		return result;
	},
	getTextMeasuredMaxWidth: function() {
		if(this._explicitWidth != null) {
			var textMeasuredWidth = this.getTextMeasuredWidth();
			var maxWidth = this._explicitWidth;
			if(this._currentContent != null) {
				if((js_Boot().default).__implements(this._currentContent,(feathers_core_IMeasureObject().default))) {
					maxWidth -= ((js_Boot().default).__cast(this._currentContent , (feathers_core_IMeasureObject().default))).get_minWidth();
				} else {
					maxWidth -= this._currentContent.get_width();
				}
				maxWidth -= this.get_gap();
			}
			if(maxWidth < 0.0) {
				maxWidth = 0.0;
			}
			if(textMeasuredWidth > maxWidth) {
				return maxWidth;
			}
		}
		return 1.0 / 0.0;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	initializeFormItemTheme: function() {
		(feathers_themes_steel_components_SteelFormItemStyles().default).initialize();
	},
	initialize: function() {
		(feathers_core_FeathersControl().default).prototype.initialize.call(this);
		if(this.textField == null) {
			this.textField = new (openfl_text_TextField())();
			this.textField.set_multiline(true);
			this.addChild(this.textField);
		}
		this.textField.addEventListener("click",$bind(this,this.formItem_textField_clickHandler));
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var selectionInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		var sizeInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SIZE);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		this._updatedTextStyles = false;
		if(stylesInvalid || stateInvalid) {
			this.refreshBackgroundSkin();
		}
		if(stylesInvalid || stateInvalid) {
			this.refreshRequiredSkin();
		}
		if(stylesInvalid || stateInvalid) {
			this.refreshTextStyles();
		}
		if(dataInvalid || stylesInvalid || stateInvalid || sizeInvalid) {
			this.refreshText(sizeInvalid);
		}
		if(dataInvalid || stylesInvalid || selectionInvalid) {
			this.refreshSelection();
		}
		if(dataInvalid) {
			this.refreshContent();
		}
		if(dataInvalid || stateInvalid) {
			this.refreshEnabled();
		}
		sizeInvalid = this.measure() || sizeInvalid;
		this.layoutContent();
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		if(this._currentBackgroundSkin != null) {
			(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParent(this._backgroundSkinMeasurements,this._currentBackgroundSkin,this);
		}
		var measureSkin = null;
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IMeasureObject().default))) {
			measureSkin = (js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IMeasureObject().default));
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
		if((js_Boot().default).__implements(this._currentRequiredSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentRequiredSkin , (feathers_core_IValidating().default))).validateNow();
		}
		var measureContent = null;
		if((js_Boot().default).__implements(this._currentContent,(feathers_core_IMeasureObject().default))) {
			measureContent = (js_Boot().default).__cast(this._currentContent , (feathers_core_IMeasureObject().default));
		}
		if(this._currentContent != null) {
			this._contentMeasurements.restore(this._currentContent);
		}
		if((js_Boot().default).__implements(this._currentContent,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentContent , (feathers_core_IValidating().default))).validateNow();
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			newWidth = this._textMeasuredWidth;
			if(this._customTextColumnWidth != null && (this.get_textPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_textPosition() == (feathers_layout_RelativePosition().default).RIGHT)) {
				newWidth = this._customTextColumnWidth;
			} else if(this._requiredSkinMeasurements != null) {
				newWidth += this.get_gap() + this._requiredSkinMeasurements.width;
			}
			newWidth += this.get_paddingLeft() + this.get_paddingRight();
			if(this._currentContent != null) {
				if(this.get_textPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_textPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
					newWidth += this.get_gap() + this._currentContent.get_width();
				} else {
					newWidth = Math.max(newWidth,this._currentContent.get_width() + this.get_paddingLeft() + this.get_paddingRight());
				}
			}
			if(this._currentBackgroundSkin != null) {
				newWidth = Math.max(this._currentBackgroundSkin.get_width(),newWidth);
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			newHeight = this._textMeasuredHeight;
			if(this._requiredSkinMeasurements != null) {
				newHeight = Math.max(newHeight,this._requiredSkinMeasurements.height);
			}
			if(this._currentContent != null) {
				if(this.get_textPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_textPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
					newHeight = Math.max(newHeight,this._currentContent.get_height());
				} else {
					newHeight += this.get_gap() + this._currentContent.get_height();
				}
			}
			newHeight += this.get_paddingTop() + this.get_paddingBottom();
			if(this._currentBackgroundSkin != null) {
				newHeight = Math.max(this._currentBackgroundSkin.get_height(),newHeight);
			}
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			newMinWidth = this._textMeasuredWidth;
			if(this._customTextColumnWidth != null && (this.get_textPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_textPosition() == (feathers_layout_RelativePosition().default).RIGHT)) {
				newMinWidth = this._customTextColumnWidth;
			} else if(this._requiredSkinMeasurements != null) {
				newMinWidth += this.get_gap() + this._requiredSkinMeasurements.width;
			}
			newMinWidth += this.get_paddingLeft() + this.get_paddingRight();
			if(this._currentContent != null) {
				if(this.get_textPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_textPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
					if(measureContent != null) {
						newMinWidth += measureContent.get_minWidth();
					} else {
						newMinWidth += this._currentContent.get_width();
					}
					newMinWidth += this.get_gap();
				} else if(measureContent != null) {
					newMinWidth = Math.max(newMinWidth,measureContent.get_minWidth() + this.get_paddingLeft() + this.get_paddingRight());
				} else {
					newMinWidth = Math.max(newMinWidth,this._currentContent.get_width() + this.get_paddingLeft() + this.get_paddingRight());
				}
			}
			if(measureSkin != null) {
				newMinWidth = Math.max(measureSkin.get_minWidth(),newMinWidth);
			} else if(this._backgroundSkinMeasurements != null) {
				newMinWidth = Math.max(this._backgroundSkinMeasurements.minWidth,newMinWidth);
			}
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			newMinHeight = this._textMeasuredHeight;
			if(this._requiredSkinMeasurements != null) {
				newMinHeight = Math.max(newMinHeight,this._requiredSkinMeasurements.height);
			}
			if(this._currentContent != null) {
				if(this.get_textPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_textPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
					if(measureContent != null) {
						newMinHeight = Math.max(newMinHeight,measureContent.get_minHeight());
					} else {
						newMinHeight = Math.max(newMinHeight,this._currentContent.get_height());
					}
				} else {
					if(measureContent != null) {
						newMinHeight += measureContent.get_minHeight();
					} else {
						newMinHeight += this._currentContent.get_height();
					}
					newMinHeight += this.get_gap();
				}
			}
			newMinHeight += this.get_paddingTop() + this.get_paddingBottom();
			if(measureSkin != null) {
				newMinHeight = Math.max(measureSkin.get_minHeight(),newMinHeight);
			} else if(this._backgroundSkinMeasurements != null) {
				newMinHeight = Math.max(this._backgroundSkinMeasurements.minHeight,newMinHeight);
			}
		}
		var newMaxWidth = this.get_explicitMaxWidth();
		if(needsMaxWidth) {
			if(measureSkin != null) {
				newMaxWidth = measureSkin.get_maxWidth();
			} else if(this._backgroundSkinMeasurements != null) {
				newMaxWidth = this._backgroundSkinMeasurements.maxWidth;
			} else {
				newMaxWidth = 1.0 / 0.0;
			}
		}
		var newMaxHeight = this.get_explicitMaxHeight();
		if(needsMaxHeight) {
			if(measureSkin != null) {
				newMaxHeight = measureSkin.get_maxHeight();
			} else if(this._backgroundSkinMeasurements != null) {
				newMaxHeight = this._backgroundSkinMeasurements.maxHeight;
			} else {
				newMaxHeight = 1.0 / 0.0;
			}
		}
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight,newMaxWidth,newMaxHeight);
	},
	refreshTextStyles: function() {
		if(this.textField.get_wordWrap() != this.get_wordWrap()) {
			this.textField.set_wordWrap(this.get_wordWrap());
			this._updatedTextStyles = true;
		}
		if(this.textField.get_embedFonts() != this.get_embedFonts()) {
			this.textField.set_embedFonts(this.get_embedFonts());
			this._updatedTextStyles = true;
		}
		var textFormat = this.getCurrentTextFormat();
		var simpleTextFormat = textFormat != null ? textFormat.toSimpleTextFormat() : null;
		if(simpleTextFormat == this._previousSimpleTextFormat) {
			return;
		}
		if(this._previousTextFormat != null) {
			this._previousTextFormat.removeEventListener("change",$bind(this,this.formItem_textFormat_changeHandler));
		}
		if(textFormat != null) {
			textFormat.addEventListener("change",$bind(this,this.formItem_textFormat_changeHandler),false,0,true);
			this.textField.set_defaultTextFormat(simpleTextFormat);
			this._updatedTextStyles = true;
		}
		this._previousTextFormat = textFormat;
		this._previousSimpleTextFormat = simpleTextFormat;
	},
	refreshText: function(forceMeasurement) {
		var hasText = this._text != null && this._text.length > 0;
		var hasHTMLText = this._htmlText != null && this._htmlText.length > 0;
		this.textField.set_visible(hasText || hasHTMLText);
		if(this._text == this._previousText && this._htmlText == this._previousHTMLText && !this._updatedTextStyles && !forceMeasurement) {
			return;
		}
		this.textField.set_autoSize("left");
		if(hasHTMLText) {
			this.textField.set_text(this._htmlText);
		} else if(hasText) {
			this.textField.set_text(this._text);
		} else {
			this.textField.set_text("​");
		}
		if(this.get_wordWrap()) {
			this.textField.set_wordWrap(false);
		}
		this._textMeasuredWidth = this.textField.get_textWidth() + 4;
		this._wrappedOnMeasure = false;
		if(this.get_wordWrap()) {
			var textFieldExplicitWidth = this.calculateExplicitWidthForTextMeasurement();
			if(textFieldExplicitWidth != null && this._textMeasuredWidth > textFieldExplicitWidth) {
				this.textField.set_wordWrap(true);
				this.textField.set_width(textFieldExplicitWidth);
				this._textMeasuredWidth = this.textField.get_width();
				this._wrappedOnMeasure = true;
			}
		}
		this._textMeasuredHeight = this.textField.get_height();
		this.textField.set_autoSize("none");
		if(this.textField.get_wordWrap() != this.get_wordWrap()) {
			this.textField.set_wordWrap(this.get_wordWrap());
		}
		if(!hasText && !hasHTMLText) {
			this.textField.set_text("");
		}
		this._previousText = this._text;
		this._previousHTMLText = this._htmlText;
	},
	calculateExplicitWidthForTextMeasurement: function() {
		var textFieldExplicitWidth = null;
		if(this.get_explicitWidth() != null) {
			textFieldExplicitWidth = this.get_explicitWidth();
		} else if(this.get_explicitMaxWidth() != null) {
			textFieldExplicitWidth = this.get_explicitMaxWidth();
		} else if(this._backgroundSkinMeasurements != null && this._backgroundSkinMeasurements.maxWidth != null) {
			textFieldExplicitWidth = this._backgroundSkinMeasurements.maxWidth;
		}
		if(textFieldExplicitWidth == null) {
			return textFieldExplicitWidth;
		}
		textFieldExplicitWidth -= this.get_paddingLeft() + this.get_paddingRight();
		if(this.get_content() != null) {
			if(this.get_textPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_textPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				if((js_Boot().default).__implements(this._content,(feathers_core_IValidating().default))) {
					((js_Boot().default).__cast(this._content , (feathers_core_IValidating().default))).validateNow();
				}
				textFieldExplicitWidth -= this._content.get_width() + this.get_gap();
			}
		}
		if(textFieldExplicitWidth < 0.0) {
			textFieldExplicitWidth = 0.0;
		}
		return textFieldExplicitWidth;
	},
	refreshSelection: function() {
		var selectable = this._selectable && this._enabled;
		if(this.textField.get_selectable() != selectable) {
			this.textField.set_selectable(selectable);
		}
	},
	getCurrentTextFormat: function() {
		if(!this._enabled && this.get_disabledTextFormat() != null) {
			return this.get_disabledTextFormat();
		}
		return this.get_textFormat();
	},
	refreshBackgroundSkin: function() {
		var oldSkin = this._currentBackgroundSkin;
		this._currentBackgroundSkin = this.getCurrentBackgroundSkin();
		if(this._currentBackgroundSkin == oldSkin) {
			return;
		}
		this.removeCurrentBackgroundSkin(oldSkin);
		this.addCurrentBackgroundSkin(this._currentBackgroundSkin);
	},
	getCurrentBackgroundSkin: function() {
		if(!this._enabled && this.get_disabledBackgroundSkin() != null) {
			return this.get_disabledBackgroundSkin();
		}
		return this.get_backgroundSkin();
	},
	addCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			this._backgroundSkinMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._backgroundSkinMeasurements == null) {
			this._backgroundSkinMeasurements = new (feathers_layout_Measurements().default)(skin);
		} else {
			this._backgroundSkinMeasurements.save(skin);
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this.addChildAt(skin,0);
	},
	removeCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		this._backgroundSkinMeasurements.restore(skin);
		if(skin.parent == this) {
			this.removeChild(skin);
		}
	},
	refreshRequiredSkin: function() {
		var oldSkin = this._currentRequiredSkin;
		this._currentRequiredSkin = this.getCurrentRequiredSkin();
		if(this._currentRequiredSkin == oldSkin) {
			return;
		}
		this.removeCurrentRequiredSkin(oldSkin);
		this.addCurrentRequiredSkin(this._currentRequiredSkin);
	},
	getCurrentRequiredSkin: function() {
		if(this._required) {
			return this.get_requiredSkin();
		}
		return null;
	},
	addCurrentRequiredSkin: function(skin) {
		if(skin == null) {
			this._requiredSkinMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._requiredSkinMeasurements == null) {
			this._requiredSkinMeasurements = new (feathers_layout_Measurements().default)(skin);
		} else {
			this._requiredSkinMeasurements.save(skin);
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this.addChild(skin);
	},
	removeCurrentRequiredSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		this._requiredSkinMeasurements.restore(skin);
		if(skin.parent == this) {
			this.removeChild(skin);
		}
	},
	refreshContent: function() {
		var oldContent = this._currentContent;
		this._currentContent = this._content;
		if(this._currentContent == oldContent) {
			return;
		}
		if(oldContent != null) {
			this._contentMeasurements.restore(oldContent);
			this.removeChild(oldContent);
		}
		if(this._currentContent == null) {
			this._contentMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(this._currentContent,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._currentContent , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._contentMeasurements == null) {
			this._contentMeasurements = new (feathers_layout_Measurements().default)(this._currentContent);
		} else {
			this._contentMeasurements.save(this._currentContent);
		}
		this.addChild(this._currentContent);
	},
	refreshEnabled: function() {
		if(this._currentContent != null && (js_Boot().default).__implements(this._currentContent,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._currentContent , (feathers_core_IUIControl().default))).set_enabled(this._enabled);
		}
	},
	layoutContent: function() {
		this.layoutBackgroundSkin();
		if((js_Boot().default).__implements(this._currentRequiredSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentRequiredSkin , (feathers_core_IValidating().default))).validateNow();
		}
		if((js_Boot().default).__implements(this._currentContent,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentContent , (feathers_core_IValidating().default))).validateNow();
		}
		var requiredOffset = 0.0;
		if(this._currentRequiredSkin != null) {
			requiredOffset = this.get_gap() + this._currentRequiredSkin.get_width();
		}
		var textFieldWidth = this._textMeasuredWidth;
		if(this._customTextColumnWidth != null && (this.get_textPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_textPosition() == (feathers_layout_RelativePosition().default).RIGHT)) {
			textFieldWidth = this._customTextColumnWidth - requiredOffset;
		}
		if(textFieldWidth < 0.0) {
			textFieldWidth = 0.0;
		}
		var textFieldHeight = this._textMeasuredHeight;
		var remainingWidth = this.actualWidth - this.get_paddingLeft() - this.get_paddingRight();
		if(this.get_textPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_textPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
			remainingWidth -= this.get_gap() + requiredOffset;
		}
		if(remainingWidth < 0.0) {
			remainingWidth = 0.0;
		}
		if(textFieldWidth > remainingWidth) {
			textFieldWidth = remainingWidth;
		}
		var remainingHeight = this.actualHeight - this.get_paddingTop() - this.get_paddingBottom();
		if(this.get_textPosition() != (feathers_layout_RelativePosition().default).LEFT && this.get_textPosition() != (feathers_layout_RelativePosition().default).RIGHT) {
			remainingHeight -= this.get_gap();
		}
		if(remainingHeight < 0.0) {
			remainingHeight = 0.0;
		}
		if(textFieldHeight > remainingHeight) {
			textFieldHeight = remainingHeight;
		}
		switch(this.get_textPosition()._hx_index) {
		case 0:
			this.textField.set_x(this.get_paddingLeft());
			this.textField.set_y(this.get_paddingTop());
			remainingHeight -= textFieldHeight;
			break;
		case 1:
			this.textField.set_x(this.actualWidth - textFieldWidth - requiredOffset - this.get_paddingRight());
			remainingWidth -= textFieldWidth;
			break;
		case 2:
			this.textField.set_x(this.get_paddingLeft());
			this.textField.set_y(this.actualHeight - textFieldHeight - this.get_paddingBottom());
			remainingHeight -= textFieldHeight;
			break;
		case 3:
			this.textField.set_x(this.get_paddingLeft());
			remainingWidth -= textFieldWidth;
			break;
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown text position: " + (Std().default).string(this.get_textPosition())));
		}
		this.textField.set_width(textFieldWidth);
		var wordWrap = this.get_wordWrap();
		if(wordWrap && !this._wrappedOnMeasure && textFieldWidth >= this._textMeasuredWidth) {
			wordWrap = false;
		}
		if(this.textField.get_wordWrap() != wordWrap) {
			this.textField.set_wordWrap(wordWrap);
		}
		this.textField.set_height(textFieldHeight);
		if(this._currentContent != null) {
			var contentStartX = this.get_paddingLeft();
			var contentStartY = this.get_paddingRight();
			switch(this.get_textPosition()._hx_index) {
			case 0:
				contentStartY = this.textField.get_y() + textFieldHeight + this.get_gap();
				break;
			case 1:
				break;
			case 2:
				break;
			case 3:
				contentStartX = this.textField.get_x() + textFieldWidth + this.get_gap() + requiredOffset;
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown text position: " + (Std().default).string(this.get_textPosition())));
			}
			if(this._currentContent.get_width() > remainingWidth) {
				this._currentContent.set_width(remainingWidth);
			}
			if(this._currentContent.get_height() > remainingHeight) {
				this._currentContent.set_height(remainingHeight);
			}
			switch(this.get_horizontalAlign()._hx_index) {
			case 0:
				this._currentContent.set_x(contentStartX);
				break;
			case 1:
				this._currentContent.set_x(contentStartX + (remainingWidth - this._currentContent.get_width()) / 2.0);
				break;
			case 2:
				this._currentContent.set_x(contentStartX + remainingWidth - this._currentContent.get_width());
				break;
			case 3:
				this._currentContent.set_x(contentStartX);
				this._currentContent.set_width(remainingWidth);
				break;
			}
			switch(this.get_verticalAlign()._hx_index) {
			case 0:
				this._currentContent.set_y(contentStartY);
				break;
			case 1:
				this._currentContent.set_y(contentStartY + (remainingHeight - this._currentContent.get_height()) / 2.0);
				break;
			case 2:
				this._currentContent.set_y(contentStartY + remainingHeight - this._currentContent.get_height());
				break;
			case 3:
				this._currentContent.set_y(contentStartY);
				this._currentContent.set_height(remainingHeight);
				break;
			}
			if(this.get_textPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_textPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				if((js_Boot().default).__implements(this._currentContent,(feathers_core_ITextControl().default))) {
					var textFieldLineMetrics = this.textField.getLineMetrics(0);
					var textFieldBaseline = textFieldLineMetrics.ascent + 2.0;
					var contentBaseline = ((js_Boot().default).__cast(this._currentContent , (feathers_core_ITextControl().default))).get_baseline();
					var maxBaseline = Math.max(contentBaseline,textFieldBaseline);
					var startY = this._currentContent.get_y();
					this.textField.set_y(startY + (maxBaseline - textFieldBaseline));
					if(this._currentContent != null) {
						this._currentContent.set_y(startY + (maxBaseline - contentBaseline));
					}
				} else {
					switch(this.get_verticalAlign()._hx_index) {
					case 0:
						this.textField.set_y(this._currentContent.get_y());
						break;
					case 1:
						this.textField.set_y(this._currentContent.get_y() + (this._currentContent.get_height() - this.textField.get_height()) / 2.0);
						break;
					case 2:
						this.textField.set_y(this._currentContent.get_y() + this._currentContent.get_height() - this.textField.get_height());
						break;
					case 3:
						this.textField.set_y(this._currentContent.get_y());
						break;
					}
				}
			}
			if(this._currentRequiredSkin != null) {
				this._currentRequiredSkin.set_y(this.textField.get_y() + (textFieldHeight - this._currentRequiredSkin.get_height()) / 2.0);
				this._currentRequiredSkin.set_x(this.textField.get_x() + textFieldWidth + this.get_gap());
			}
		}
	},
	layoutBackgroundSkin: function() {
		if(this._currentBackgroundSkin == null) {
			return;
		}
		this._currentBackgroundSkin.set_x(0.0);
		this._currentBackgroundSkin.set_y(0.0);
		if(this._currentBackgroundSkin.get_width() != this.actualWidth) {
			this._currentBackgroundSkin.set_width(this.actualWidth);
		}
		if(this._currentBackgroundSkin.get_height() != this.actualHeight) {
			this._currentBackgroundSkin.set_height(this.actualHeight);
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
	},
	formItem_textFormat_changeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	formItem_textField_clickHandler: function(event) {
		if(this._focusManager == null) {
			return;
		}
		var newFocus = null;
		if((js_Boot().default).__implements(this._currentContent,(feathers_core_IFocusObject().default))) {
			newFocus = (js_Boot().default).__cast(this._currentContent , (feathers_core_IFocusObject().default));
		}
		this._focusManager.set_focus(newFocus);
	},
	get_requiredSkin: function() {
		return this.__requiredSkin;
	},
	set_requiredSkin: function(value) {
		if(!this.setStyle("requiredSkin")) {
			return this.__requiredSkin;
		}
		if(this.__requiredSkin == value) {
			return this.__requiredSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_requiredSkin);
		this.__requiredSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__requiredSkin;
	},
	clearStyle_requiredSkin: function() {
		this.set_requiredSkin(null);
		return this.get_requiredSkin();
	},
	get_textFormat: function() {
		return this.__textFormat;
	},
	set_textFormat: function(value) {
		if(!this.setStyle("textFormat")) {
			return this.__textFormat;
		}
		if(this.__textFormat == value) {
			return this.__textFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_textFormat);
		this.__textFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__textFormat;
	},
	clearStyle_textFormat: function() {
		this.set_textFormat(null);
		return this.get_textFormat();
	},
	get_disabledTextFormat: function() {
		return this.__disabledTextFormat;
	},
	set_disabledTextFormat: function(value) {
		if(!this.setStyle("disabledTextFormat")) {
			return this.__disabledTextFormat;
		}
		if(this.__disabledTextFormat == value) {
			return this.__disabledTextFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledTextFormat);
		this.__disabledTextFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledTextFormat;
	},
	clearStyle_disabledTextFormat: function() {
		this.set_disabledTextFormat(null);
		return this.get_disabledTextFormat();
	},
	get_embedFonts: function() {
		return this.__embedFonts;
	},
	set_embedFonts: function(value) {
		if(!this.setStyle("embedFonts")) {
			return this.__embedFonts;
		}
		if(this.__embedFonts == value) {
			return this.__embedFonts;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_embedFonts);
		this.__embedFonts = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__embedFonts;
	},
	clearStyle_embedFonts: function() {
		this.set_embedFonts(false);
		return this.get_embedFonts();
	},
	get_paddingTop: function() {
		return this.__paddingTop;
	},
	set_paddingTop: function(value) {
		if(!this.setStyle("paddingTop")) {
			return this.__paddingTop;
		}
		if(this.__paddingTop == value) {
			return this.__paddingTop;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingTop);
		this.__paddingTop = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingTop;
	},
	clearStyle_paddingTop: function() {
		this.set_paddingTop(0.0);
		return this.get_paddingTop();
	},
	get_paddingRight: function() {
		return this.__paddingRight;
	},
	set_paddingRight: function(value) {
		if(!this.setStyle("paddingRight")) {
			return this.__paddingRight;
		}
		if(this.__paddingRight == value) {
			return this.__paddingRight;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingRight);
		this.__paddingRight = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingRight;
	},
	clearStyle_paddingRight: function() {
		this.set_paddingRight(0.0);
		return this.get_paddingRight();
	},
	get_paddingBottom: function() {
		return this.__paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(!this.setStyle("paddingBottom")) {
			return this.__paddingBottom;
		}
		if(this.__paddingBottom == value) {
			return this.__paddingBottom;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingBottom);
		this.__paddingBottom = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingBottom;
	},
	clearStyle_paddingBottom: function() {
		this.set_paddingBottom(0.0);
		return this.get_paddingBottom();
	},
	get_paddingLeft: function() {
		return this.__paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(!this.setStyle("paddingLeft")) {
			return this.__paddingLeft;
		}
		if(this.__paddingLeft == value) {
			return this.__paddingLeft;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingLeft);
		this.__paddingLeft = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingLeft;
	},
	clearStyle_paddingLeft: function() {
		this.set_paddingLeft(0.0);
		return this.get_paddingLeft();
	},
	get_gap: function() {
		return this.__gap;
	},
	set_gap: function(value) {
		if(!this.setStyle("gap")) {
			return this.__gap;
		}
		if(this.__gap == value) {
			return this.__gap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_gap);
		this.__gap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__gap;
	},
	clearStyle_gap: function() {
		this.set_gap(0.0);
		return this.get_gap();
	},
	get_horizontalAlign: function() {
		return this.__horizontalAlign;
	},
	set_horizontalAlign: function(value) {
		if(!this.setStyle("horizontalAlign")) {
			return this.__horizontalAlign;
		}
		if(this.__horizontalAlign == value) {
			return this.__horizontalAlign;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_horizontalAlign);
		this.__horizontalAlign = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__horizontalAlign;
	},
	clearStyle_horizontalAlign: function() {
		this.set_horizontalAlign((feathers_layout_HorizontalAlign().default).LEFT);
		return this.get_horizontalAlign();
	},
	get_verticalAlign: function() {
		return this.__verticalAlign;
	},
	set_verticalAlign: function(value) {
		if(!this.setStyle("verticalAlign")) {
			return this.__verticalAlign;
		}
		if(this.__verticalAlign == value) {
			return this.__verticalAlign;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_verticalAlign);
		this.__verticalAlign = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__verticalAlign;
	},
	clearStyle_verticalAlign: function() {
		this.set_verticalAlign((feathers_layout_VerticalAlign().default).MIDDLE);
		return this.get_verticalAlign();
	},
	get_wordWrap: function() {
		return this.__wordWrap;
	},
	set_wordWrap: function(value) {
		if(!this.setStyle("wordWrap")) {
			return this.__wordWrap;
		}
		if(this.__wordWrap == value) {
			return this.__wordWrap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_wordWrap);
		this.__wordWrap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__wordWrap;
	},
	clearStyle_wordWrap: function() {
		this.set_wordWrap(false);
		return this.get_wordWrap();
	},
	get_backgroundSkin: function() {
		return this.__backgroundSkin;
	},
	set_backgroundSkin: function(value) {
		if(!this.setStyle("backgroundSkin")) {
			return this.__backgroundSkin;
		}
		if(this.__backgroundSkin == value) {
			return this.__backgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_backgroundSkin);
		this.__backgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__backgroundSkin;
	},
	clearStyle_backgroundSkin: function() {
		this.set_backgroundSkin(null);
		return this.get_backgroundSkin();
	},
	get_disabledBackgroundSkin: function() {
		return this.__disabledBackgroundSkin;
	},
	set_disabledBackgroundSkin: function(value) {
		if(!this.setStyle("disabledBackgroundSkin")) {
			return this.__disabledBackgroundSkin;
		}
		if(this.__disabledBackgroundSkin == value) {
			return this.__disabledBackgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledBackgroundSkin);
		this.__disabledBackgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledBackgroundSkin;
	},
	clearStyle_disabledBackgroundSkin: function() {
		this.set_disabledBackgroundSkin(null);
		return this.get_disabledBackgroundSkin();
	},
	get_textPosition: function() {
		return this.__textPosition;
	},
	set_textPosition: function(value) {
		if(!this.setStyle("textPosition")) {
			return this.__textPosition;
		}
		if(this.__textPosition == value) {
			return this.__textPosition;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_textPosition);
		this.__textPosition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__textPosition;
	},
	clearStyle_textPosition: function() {
		this.set_textPosition((feathers_layout_RelativePosition().default).TOP);
		return this.get_textPosition();
	},
	get_styleContext: function() {
		return FormItem
	}
});
FormItem.prototype.__class__ = FormItem.prototype.constructor = $hxClasses["feathers.controls.FormItem"] = FormItem;

// Init



// Statics


FormItem.__meta__ = { obj : { defaultXmlProperty : ["content"]}}

// Export

exports["default"] = FormItem;

/***/ }),

/***/ "./lib/_gen/feathers/controls/GridView.js":
/*!************************************************!*\
  !*** ./lib/_gen/feathers/controls/GridView.js ***!
  \************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.GridView

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IFocusContainer() {return __webpack_require__(/*! ./../../feathers/core/IFocusContainer */ "./lib/_gen/feathers/core/IFocusContainer.js");}
function feathers_core_IDataSelector() {return __webpack_require__(/*! ./../../feathers/core/IDataSelector */ "./lib/_gen/feathers/core/IDataSelector.js");}
function feathers_core_IIndexSelector() {return __webpack_require__(/*! ./../../feathers/core/IIndexSelector */ "./lib/_gen/feathers/core/IIndexSelector.js");}
function feathers_controls_supportClasses_BaseScrollContainer() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/BaseScrollContainer */ "./lib/_gen/feathers/controls/supportClasses/BaseScrollContainer.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function feathers_data_SortOrder() {return __webpack_require__(/*! ./../../feathers/data/SortOrder */ "./lib/_gen/feathers/data/SortOrder.js");}
function feathers_themes_steel_components_SteelGridViewStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelGridViewStyles */ "./lib/_gen/feathers/themes/steel/components/SteelGridViewStyles.js");}
function feathers_layout_GridViewRowLayout() {return __webpack_require__(/*! ./../../feathers/layout/GridViewRowLayout */ "./lib/_gen/feathers/layout/GridViewRowLayout.js");}
function feathers_controls_LayoutGroup() {return __webpack_require__(/*! ./../../feathers/controls/LayoutGroup */ "./lib/_gen/feathers/controls/LayoutGroup.js");}
function openfl_display_Sprite() {return (__webpack_require__(/*! openfl */ "openfl").display.Sprite);}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_IScrollLayout() {return __webpack_require__(/*! ./../../feathers/layout/IScrollLayout */ "./lib/_gen/feathers/layout/IScrollLayout.js");}
function feathers_layout_IVirtualLayout() {return __webpack_require__(/*! ./../../feathers/layout/IVirtualLayout */ "./lib/_gen/feathers/layout/IVirtualLayout.js");}
function Reflect() {return __webpack_require__(/*! ./../../Reflect */ "./lib/_gen/Reflect.js");}
function feathers_controls_GridViewColumn() {return __webpack_require__(/*! ./../../feathers/controls/GridViewColumn */ "./lib/_gen/feathers/controls/GridViewColumn.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_data_ArrayCollection() {return __webpack_require__(/*! ./../../feathers/data/ArrayCollection */ "./lib/_gen/feathers/data/ArrayCollection.js");}
function feathers_utils_MathUtil() {return __webpack_require__(/*! ./../../feathers/utils/MathUtil */ "./lib/_gen/feathers/utils/MathUtil.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function openfl_display_InteractiveObject() {return (__webpack_require__(/*! openfl */ "openfl").display.InteractiveObject);}
function openfl_display_DisplayObjectContainer() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObjectContainer);}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function Type() {return __webpack_require__(/*! ./../../Type */ "./lib/_gen/Type.js");}
function feathers_style_IVariantStyleObject() {return __webpack_require__(/*! ./../../feathers/style/IVariantStyleObject */ "./lib/_gen/feathers/style/IVariantStyleObject.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_controls_ITriggerView() {return __webpack_require__(/*! ./../../feathers/controls/ITriggerView */ "./lib/_gen/feathers/controls/ITriggerView.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_controls_dataRenderers_IGridViewHeaderRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/IGridViewHeaderRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IGridViewHeaderRenderer.js");}
function feathers_data_ISortOrderObserver() {return __webpack_require__(/*! ./../../feathers/data/ISortOrderObserver */ "./lib/_gen/feathers/data/ISortOrderObserver.js");}
function feathers_layout_ILayoutIndexObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutIndexObject */ "./lib/_gen/feathers/layout/ILayoutIndexObject.js");}
function feathers_layout_IKeyboardNavigationLayout() {return __webpack_require__(/*! ./../../feathers/layout/IKeyboardNavigationLayout */ "./lib/_gen/feathers/layout/IKeyboardNavigationLayout.js");}
function feathers_controls_dataRenderers_GridViewRowRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/GridViewRowRenderer */ "./lib/_gen/feathers/controls/dataRenderers/GridViewRowRenderer.js");}
function feathers_utils_ExclusivePointer() {return __webpack_require__(/*! ./../../feathers/utils/ExclusivePointer */ "./lib/_gen/feathers/utils/ExclusivePointer.js");}
function feathers_utils_DisplayUtil() {return __webpack_require__(/*! ./../../feathers/utils/DisplayUtil */ "./lib/_gen/feathers/utils/DisplayUtil.js");}
function openfl_ui_Mouse() {return (__webpack_require__(/*! openfl */ "openfl").ui.Mouse);}
function openfl_display_DisplayObject() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObject);}
function feathers_events_GridViewEvent() {return __webpack_require__(/*! ./../../feathers/events/GridViewEvent */ "./lib/_gen/feathers/events/GridViewEvent.js");}
function openfl_display_Stage() {return (__webpack_require__(/*! openfl */ "openfl").display.Stage);}
function feathers_utils_DisplayObjectFactory() {return __webpack_require__(/*! ./../../feathers/utils/DisplayObjectFactory */ "./lib/_gen/feathers/utils/DisplayObjectFactory.js");}
function feathers_controls_Button() {return __webpack_require__(/*! ./../../feathers/controls/Button */ "./lib/_gen/feathers/controls/Button.js");}
function feathers_data_GridViewHeaderState() {return __webpack_require__(/*! ./../../feathers/data/GridViewHeaderState */ "./lib/_gen/feathers/data/GridViewHeaderState.js");}
function feathers_controls_GridViewRowState() {return __webpack_require__(/*! ./../../feathers/controls/GridViewRowState */ "./lib/_gen/feathers/controls/GridViewRowState.js");}
function feathers_core_ITextControl() {return __webpack_require__(/*! ./../../feathers/core/ITextControl */ "./lib/_gen/feathers/core/ITextControl.js");}
function feathers_layout_VirtualLayoutRange() {return __webpack_require__(/*! ./../../feathers/layout/VirtualLayoutRange */ "./lib/_gen/feathers/layout/VirtualLayoutRange.js");}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}
function haxe_ds_ObjectMap() {return __webpack_require__(/*! ./../../haxe/ds/ObjectMap */ "./lib/_gen/haxe/ds/ObjectMap.js");}
function feathers_utils_DisplayObjectRecycler() {return __webpack_require__(/*! ./../../feathers/utils/DisplayObjectRecycler */ "./lib/_gen/feathers/utils/DisplayObjectRecycler.js");}
function feathers_controls_dataRenderers_ItemRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/ItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ItemRenderer.js");}
function openfl_geom_Rectangle() {return (__webpack_require__(/*! openfl */ "openfl").geom.Rectangle);}
function feathers_controls__$GridView_ColumnDividerStorage() {return __webpack_require__(/*! ./../../feathers/controls/_GridView/ColumnDividerStorage */ "./lib/_gen/feathers/controls/_GridView/ColumnDividerStorage.js");}
function feathers_controls__$GridView_HeaderDividerStorage() {return __webpack_require__(/*! ./../../feathers/controls/_GridView/HeaderDividerStorage */ "./lib/_gen/feathers/controls/_GridView/HeaderDividerStorage.js");}
function feathers_controls__$GridView_HeaderRendererStorage() {return __webpack_require__(/*! ./../../feathers/controls/_GridView/HeaderRendererStorage */ "./lib/_gen/feathers/controls/_GridView/HeaderRendererStorage.js");}
function feathers_controls_dataRenderers_SortOrderHeaderRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/SortOrderHeaderRenderer */ "./lib/_gen/feathers/controls/dataRenderers/SortOrderHeaderRenderer.js");}
function feathers_controls_supportClasses_AdvancedLayoutViewPort() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/AdvancedLayoutViewPort */ "./lib/_gen/feathers/controls/supportClasses/AdvancedLayoutViewPort.js");}

// Constructor

var GridView = function(dataProvider,columns,changeListener) {
	this.__showHeaderDividersOnlyWhenResizable = false;
	this.__extendedScrollBarY = false;
	this.__columnResizeSkin = null;
	this.__layout = null;
	this.__customColumnDividerVariant = null;
	this.__columnDividerFactory = null;
	this.__customHeaderDividerVariant = null;
	this.__headerDividerFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_Button().default));
	this.__customHeaderRendererVariant = null;
	this.__customCellRendererVariant = null;
	this._pendingScrollDuration = null;
	this._pendingScrollRowIndex = -1;
	this._ignoreHeaderLayoutChanges = false;
	this._ignoreLayoutChanges = false;
	this._ignoreSelectionChange = false;
	this._selectable = true;
	this._tempVisibleIndices = new (feathers_layout_VirtualLayoutRange().default)(0,0);
	this._visibleIndices = new (feathers_layout_VirtualLayoutRange().default)(0,0);
	this._virtualCache = [];
	this._rowLayoutItems = [];
	this._unrenderedData = [];
	this.rowStatePool = new (lime_utils_ObjectPool().default)(function() {
		return new (feathers_controls_GridViewRowState().default)();
	});
	this.headerStatePool = new (lime_utils_ObjectPool().default)(function() {
		return new (feathers_data_GridViewHeaderState().default)();
	});
	this.rowRendererToRowState = new (haxe_ds_ObjectMap().default)();
	this.dataToRowRenderer = new (haxe_ds_ObjectMap().default)();
	this.activeRowRenderers = [];
	this.inactiveRowRenderers = [];
	this.headerRendererToHeaderState = new (haxe_ds_ObjectMap().default)();
	this.dataToHeaderRenderer = new (haxe_ds_ObjectMap().default)();
	this._sortedColumn = null;
	this._sortOrder = (feathers_data_SortOrder().default).NONE;
	this._resizableColumns = false;
	this._sortableColumns = false;
	this._cellRendererRecycler = (feathers_utils_DisplayObjectRecycler().default).withClass((feathers_controls_dataRenderers_ItemRenderer().default));
	this._virtualLayout = true;
	this._selectedItems = [];
	this._selectedIndices = [];
	this._selectionAnchorIndex = -1;
	this._allowMultipleSelection = false;
	this._selectedItem = null;
	this._selectedIndex = -1;
	this._rowRendererRecycler = (feathers_utils_DisplayObjectRecycler().default).withClass((feathers_controls_dataRenderers_GridViewRowRenderer().default));
	this._previousCustomHeaderRendererVariant = null;
	this._forceItemStateUpdate = false;
	this._columns = null;
	this._autoPopulatedColumns = null;
	this._ignoreDataProviderChanges = false;
	this._childFocusEnabled = true;
	this._headerScrollRect2 = new (openfl_geom_Rectangle())();
	this._headerScrollRect1 = new (openfl_geom_Rectangle())();
	this._columnDividerLayoutItems = [];
	this._defaultColumnDividerStorage = new (feathers_controls__$GridView_ColumnDividerStorage().default)();
	this._headerDividerLayoutItems = [];
	this._defaultHeaderDividerStorage = new (feathers_controls__$GridView_HeaderDividerStorage().default)((feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_Button().default)));
	this._headerLayoutItems = [];
	this._unrenderedHeaderData = [];
	this._defaultHeaderStorage = new (feathers_controls__$GridView_HeaderRendererStorage().default)((feathers_utils_DisplayObjectRecycler().default).withClass((feathers_controls_dataRenderers_SortOrderHeaderRenderer().default)));
	this._resizingHeaderTouchPointIsMouse = false;
	this._resizingHeaderTouchPointID = null;
	this._resizingHeaderIndex = -1;
	this.initializeGridViewTheme();
	(feathers_controls_supportClasses_BaseScrollContainer().default).call(this);
	this.set_dataProvider(dataProvider);
	this.set_columns(columns);
	this.set_tabEnabled(true);
	this.focusRect = null;
	if(this.get_viewPort() == null) {
		this.gridViewPort = new (feathers_controls_supportClasses_AdvancedLayoutViewPort().default)();
		this.addChild(this.gridViewPort);
		this.set_viewPort(this.gridViewPort);
	}
	if(changeListener != null) {
		this.addEventListener("change",changeListener);
	}
}

// Meta

GridView.__name__ = "feathers.controls.GridView";
GridView.__isInterface__ = false;
GridView.__interfaces__ = [(feathers_core_IFocusContainer().default),(feathers_core_IDataSelector().default),(feathers_core_IIndexSelector().default)];
GridView.__super__ = (feathers_controls_supportClasses_BaseScrollContainer().default);
GridView.prototype = $extend((feathers_controls_supportClasses_BaseScrollContainer().default).prototype, {
	get_tabEnabled: function() {
		if((this._selectable || this.get_maxScrollY() != this.get_minScrollY() || this.get_maxScrollX() != this.get_minScrollX()) && this._enabled) {
			return this.get_rawTabEnabled();
		} else {
			return false;
		}
	},
	get_childFocusEnabled: function() {
		if(this._enabled) {
			return this._childFocusEnabled;
		} else {
			return false;
		}
	},
	set_childFocusEnabled: function(value) {
		if(this._childFocusEnabled == value) {
			return this._childFocusEnabled;
		}
		this._childFocusEnabled = value;
		return this._childFocusEnabled;
	},
	get_dataProvider: function() {
		return this._dataProvider;
	},
	set_dataProvider: function(value) {
		if(this._dataProvider == value) {
			return this._dataProvider;
		}
		this._virtualCache.length = 0;
		if(this._dataProvider != null) {
			this._dataProvider.removeEventListener("change",$bind(this,this.gridView_dataProvider_changeHandler));
			this._dataProvider.removeEventListener("addItem",$bind(this,this.gridView_dataProvider_addItemHandler));
			this._dataProvider.removeEventListener("removeItem",$bind(this,this.gridView_dataProvider_removeItemHandler));
			this._dataProvider.removeEventListener("replaceItem",$bind(this,this.gridView_dataProvider_replaceItemHandler));
			this._dataProvider.removeEventListener("removeAll",$bind(this,this.gridView_dataProvider_removeAllHandler));
			this._dataProvider.removeEventListener("reset",$bind(this,this.gridView_dataProvider_resetHandler));
			this._dataProvider.removeEventListener("sortChange",$bind(this,this.gridView_dataProvider_sortChangeHandler));
			this._dataProvider.removeEventListener("filterChange",$bind(this,this.gridView_dataProvider_filterChangeHandler));
			this._dataProvider.removeEventListener("updateItem",$bind(this,this.gridView_dataProvider_updateItemHandler));
			this._dataProvider.removeEventListener("updateAll",$bind(this,this.gridView_dataProvider_updateAllHandler));
		}
		this._dataProvider = value;
		if(this._dataProvider != null) {
			this._virtualCache.length = this._dataProvider.get_length();
			this._dataProvider.addEventListener("change",$bind(this,this.gridView_dataProvider_changeHandler));
			this._dataProvider.addEventListener("addItem",$bind(this,this.gridView_dataProvider_addItemHandler));
			this._dataProvider.addEventListener("removeItem",$bind(this,this.gridView_dataProvider_removeItemHandler));
			this._dataProvider.addEventListener("replaceItem",$bind(this,this.gridView_dataProvider_replaceItemHandler));
			this._dataProvider.addEventListener("removeAll",$bind(this,this.gridView_dataProvider_removeAllHandler));
			this._dataProvider.addEventListener("reset",$bind(this,this.gridView_dataProvider_resetHandler));
			this._dataProvider.addEventListener("sortChange",$bind(this,this.gridView_dataProvider_sortChangeHandler));
			this._dataProvider.addEventListener("filterChange",$bind(this,this.gridView_dataProvider_filterChangeHandler));
			this._dataProvider.addEventListener("updateItem",$bind(this,this.gridView_dataProvider_updateItemHandler));
			this._dataProvider.addEventListener("updateAll",$bind(this,this.gridView_dataProvider_updateAllHandler));
		}
		this.set_scrollX(0.0);
		this.set_scrollY(0.0);
		this.set_selectedIndex(-1);
		if(this._autoPopulatedColumns != null) {
			this._autoPopulatedColumns = null;
			this.set_columns(null);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._dataProvider;
	},
	get_columns: function() {
		return this._columns;
	},
	set_columns: function(value) {
		if(this._columns == value) {
			return this._columns;
		}
		if(this._columns != null) {
			this._columns.removeEventListener("change",$bind(this,this.gridView_columns_changeHandler));
			this._columns.removeEventListener("addItem",$bind(this,this.gridView_columns_addItemHandler));
			this._columns.removeEventListener("removeItem",$bind(this,this.gridView_columns_removeItemHandler));
		}
		this._columns = value;
		if(this._columns != null) {
			this._columns.addEventListener("change",$bind(this,this.gridView_columns_changeHandler));
			this._columns.addEventListener("addItem",$bind(this,this.gridView_columns_addItemHandler));
			this._columns.addEventListener("removeItem",$bind(this,this.gridView_columns_removeItemHandler));
		}
		this._autoPopulatedColumns = null;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._columns;
	},
	get_headerRendererRecycler: function() {
		return this._defaultHeaderStorage.headerRendererRecycler;
	},
	set_headerRendererRecycler: function(value) {
		if(this._defaultHeaderStorage.headerRendererRecycler == value) {
			return this._defaultHeaderStorage.headerRendererRecycler;
		}
		this._defaultHeaderStorage.oldHeaderRendererRecycler = this._defaultHeaderStorage.headerRendererRecycler;
		this._defaultHeaderStorage.headerRendererRecycler = value;
		this.setInvalid(GridView.INVALIDATION_FLAG_HEADER_RENDERER_FACTORY);
		return this._defaultHeaderStorage.headerRendererRecycler;
	},
	get_forceItemStateUpdate: function() {
		return this._forceItemStateUpdate;
	},
	set_forceItemStateUpdate: function(value) {
		if(this._forceItemStateUpdate == value) {
			return this._forceItemStateUpdate;
		}
		this._forceItemStateUpdate = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._forceItemStateUpdate;
	},
	get_selectedIndex: function() {
		return this._selectedIndex;
	},
	set_selectedIndex: function(value) {
		if(!this._selectable || this._dataProvider == null) {
			value = -1;
		}
		if(this._selectedIndex == value && this._selectedIndices.length <= 1) {
			return this._selectedIndex;
		}
		if(value == -1) {
			this._selectionAnchorIndex = -1;
			this._selectedIndex = -1;
			this._selectedItem = null;
			this._selectedIndices.length = 0;
			this._selectedItems.length = 0;
			this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
			return this._selectedIndex;
		}
		this._selectedIndex = value;
		this._selectedItem = this._dataProvider.get(this._selectedIndex);
		this._selectedIndices.length = 1;
		this._selectedIndices[0] = this._selectedIndex;
		this._selectedItems.length = 1;
		this._selectedItems[0] = this._selectedItem;
		this._selectionAnchorIndex = this._selectedIndex;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedIndex;
	},
	get_maxSelectedIndex: function() {
		if(this._dataProvider == null) {
			return -1;
		}
		return this._dataProvider.get_length() - 1;
	},
	get_selectedItem: function() {
		return this._selectedItem;
	},
	set_selectedItem: function(value) {
		if(value == null || !this._selectable || this._dataProvider == null) {
			this.set_selectedIndex(-1);
			return this._selectedItem;
		}
		var index = this._dataProvider.indexOf(value);
		if(index == -1) {
			this.set_selectedIndex(-1);
			return this._selectedItem;
		}
		if(this._selectedItem == value && this._selectedIndex == index && this._selectedIndices.length == 1) {
			return this._selectedItem;
		}
		this._selectedIndex = index;
		this._selectedItem = value;
		this._selectedIndices.length = 1;
		this._selectedIndices[0] = this._selectedIndex;
		this._selectedItems.length = 1;
		this._selectedItems[0] = this._selectedItem;
		this._selectionAnchorIndex = this._selectedIndex;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedItem;
	},
	get_allowMultipleSelection: function() {
		return this._allowMultipleSelection;
	},
	set_allowMultipleSelection: function(value) {
		if(this._allowMultipleSelection == value) {
			return this._allowMultipleSelection;
		}
		this._allowMultipleSelection = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		return this._allowMultipleSelection;
	},
	get_selectedIndices: function() {
		return this._selectedIndices;
	},
	set_selectedIndices: function(value) {
		if(value == null || value.length == 0 || !this._selectable || this._dataProvider == null) {
			this.set_selectedIndex(-1);
			return this._selectedIndices;
		}
		if(this._selectedIndices == value) {
			return this._selectedIndices;
		}
		if(!this._allowMultipleSelection && value.length > 1) {
			value.length = 1;
		}
		this._selectedIndices = value;
		this._selectedIndex = this._selectedIndices[0];
		this._selectedItems.length = this._selectedIndices.length;
		var _g = 0;
		var _g1 = this._selectedIndices.length;
		while(_g < _g1) {
			var i = _g++;
			var index = this._selectedIndices[i];
			this._selectedItems[i] = this._dataProvider.get(index);
		}
		this._selectedItem = this._selectedItems[0];
		this._selectionAnchorIndex = this._selectedIndex;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedIndices;
	},
	get_selectedItems: function() {
		return this._selectedItems;
	},
	set_selectedItems: function(value) {
		if(value == null || value.length == 0 || !this._selectable || this._dataProvider == null) {
			this.set_selectedIndex(-1);
			return this._selectedItems;
		}
		if(this._selectedItems == value) {
			return this._selectedItems;
		}
		if(!this._allowMultipleSelection && value.length > 1) {
			value.length = 1;
		}
		var indices = [];
		var i = 0;
		while(i < value.length) {
			var item = value[i];
			var index = this._dataProvider.indexOf(item);
			if(index == -1) {
				value.splice(i,1);
				continue;
			}
			indices.push(index);
			++i;
		}
		this._selectedIndices = indices;
		this._selectedItems = value;
		if(value.length == 0) {
			this._selectedIndex = -1;
			this._selectedItem = null;
		} else {
			this._selectedIndex = this._selectedIndices[0];
			this._selectedItem = this._selectedItems[0];
		}
		this._selectionAnchorIndex = this._selectedIndex;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedIndices;
	},
	get_virtualLayout: function() {
		return this._virtualLayout;
	},
	set_virtualLayout: function(value) {
		if(this._virtualLayout = value) {
			return this._virtualLayout;
		}
		this._virtualLayout = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		return this._virtualLayout;
	},
	get_cellRendererRecycler: function() {
		return this._cellRendererRecycler;
	},
	set_cellRendererRecycler: function(value) {
		if(this._cellRendererRecycler == value) {
			return this._cellRendererRecycler;
		}
		this._cellRendererRecycler = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._cellRendererRecycler;
	},
	get_sortableColumns: function() {
		return this._sortableColumns;
	},
	set_sortableColumns: function(value) {
		if(this._sortableColumns == value) {
			return this._sortableColumns;
		}
		this._sortableColumns = value;
		return this._sortableColumns;
	},
	get_resizableColumns: function() {
		return this._resizableColumns;
	},
	set_resizableColumns: function(value) {
		if(this._resizableColumns == value) {
			return this._resizableColumns;
		}
		this._resizableColumns = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		return this._resizableColumns;
	},
	get_sortOrder: function() {
		return this._sortOrder;
	},
	set_sortOrder: function(value) {
		if(this._sortedColumn == null) {
			value = (feathers_data_SortOrder().default).NONE;
		}
		if(this._sortOrder == value) {
			return this._sortOrder;
		}
		this._sortOrder = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SORT);
		return this._sortOrder;
	},
	get_sortedColumn: function() {
		return this._sortedColumn;
	},
	set_sortedColumn: function(value) {
		if(this._sortedColumn == value) {
			return this._sortedColumn;
		}
		if(this._columns.indexOf(value) == -1) {
			this._sortedColumn = null;
			this._sortOrder = (feathers_data_SortOrder().default).NONE;
			return this._sortedColumn;
		}
		this._sortedColumn = value;
		if(this._sortedColumn != null) {
			this.set_sortOrder(this._sortedColumn.defaultSortOrder);
		} else {
			this._sortOrder = (feathers_data_SortOrder().default).NONE;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SORT);
		return this._sortedColumn;
	},
	get_selectable: function() {
		return this._selectable;
	},
	set_selectable: function(value) {
		if(this._selectable == value) {
			return this._selectable;
		}
		this._selectable = value;
		if(!this._selectable) {
			this.set_selectedIndex(-1);
		}
		return this._selectable;
	},
	scrollToRowIndex: function(rowIndex,animationDuration) {
		if(this._dataProvider == null || this._dataProvider.get_length() == 0) {
			return;
		}
		this._pendingScrollRowIndex = rowIndex;
		this._pendingScrollDuration = animationDuration;
		this.setInvalid((feathers_core_InvalidationFlag().default).SCROLL);
	},
	itemAndColumnToCellRenderer: function(item,column) {
		if(item == null) {
			return null;
		}
		var rowRenderer = this.dataToRowRenderer.get(item);
		if(rowRenderer == null) {
			return null;
		}
		return rowRenderer.columnToCellRenderer(column);
	},
	columnToHeaderRenderer: function(column) {
		return this.dataToHeaderRenderer.get(column);
	},
	headerRendererToColumn: function(headerRenderer) {
		var state = this.headerRendererToHeaderState.get(headerRenderer);
		if(state == null) {
			return null;
		}
		return state.column;
	},
	initializeGridViewTheme: function() {
		(feathers_themes_steel_components_SteelGridViewStyles().default).initialize();
	},
	initialize: function() {
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.initialize.call(this);
		if(this._headerContainerLayout == null) {
			this._headerContainerLayout = new (feathers_layout_GridViewRowLayout().default)();
		}
		if(this._headerContainer == null) {
			this._headerContainer = new (feathers_controls_LayoutGroup().default)();
			this._headerContainer.set_layout(this._headerContainerLayout);
			this.addChild(this._headerContainer);
		}
		if(this._headerResizeContainer == null) {
			this._headerResizeContainer = new (openfl_display_Sprite())();
			this.addChild(this._headerResizeContainer);
		}
		if(this._columnDividerContainer == null) {
			this._columnDividerContainer = new (openfl_display_Sprite())();
			this._columnDividerContainer.mouseEnabled = false;
			this._columnDividerContainer.mouseChildren = false;
			this.addChild(this._columnDividerContainer);
		}
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var layoutInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		var sortInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SORT);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(this._previousCustomHeaderRendererVariant != this.get_customHeaderRendererVariant()) {
			this.setInvalidationFlag(GridView.INVALIDATION_FLAG_HEADER_RENDERER_FACTORY);
		}
		var headerRendererInvalid = this.isInvalid(GridView.INVALIDATION_FLAG_HEADER_RENDERER_FACTORY);
		if(this._defaultHeaderDividerStorage.headerDividerFactory != this.get_headerDividerFactory()) {
			this._defaultHeaderDividerStorage.oldHeaderDividerFactory = this._defaultHeaderDividerStorage.headerDividerFactory;
			this._defaultHeaderDividerStorage.headerDividerFactory = this.get_headerDividerFactory();
			this.setInvalidationFlag(GridView.INVALIDATION_FLAG_HEADER_DIVIDER_FACTORY);
		}
		if(this._defaultHeaderDividerStorage.customHeaderDividerVariant != this.get_customHeaderDividerVariant()) {
			this._defaultHeaderDividerStorage.customHeaderDividerVariant = this.get_customHeaderDividerVariant();
			this.setInvalidationFlag(GridView.INVALIDATION_FLAG_HEADER_DIVIDER_FACTORY);
		}
		var headerDividerInvalid = this.isInvalid(GridView.INVALIDATION_FLAG_HEADER_DIVIDER_FACTORY);
		if(this._defaultColumnDividerStorage.columnDividerFactory != this.get_columnDividerFactory()) {
			this._defaultColumnDividerStorage.oldColumnDividerFactory = this._defaultColumnDividerStorage.columnDividerFactory;
			this._defaultColumnDividerStorage.columnDividerFactory = this.get_columnDividerFactory();
			this.setInvalidationFlag(GridView.INVALIDATION_FLAG_COLUMN_DIVIDER_FACTORY);
		}
		if(this._defaultColumnDividerStorage.customColumnDividerVariant != this.get_customColumnDividerVariant()) {
			this._defaultColumnDividerStorage.customColumnDividerVariant = this.get_customColumnDividerVariant();
			this.setInvalidationFlag(GridView.INVALIDATION_FLAG_COLUMN_DIVIDER_FACTORY);
		}
		var columnDividerInvalid = this.isInvalid(GridView.INVALIDATION_FLAG_COLUMN_DIVIDER_FACTORY);
		this.validateColumns();
		if(dataInvalid || sortInvalid) {
			this.refreshSortedColumn(sortInvalid);
		}
		if(stylesInvalid || layoutInvalid) {
			this.refreshColumnResizeSkin();
		}
		if(headerRendererInvalid || stateInvalid || dataInvalid || sortInvalid) {
			this.refreshHeaderRenderers();
		}
		if(headerDividerInvalid || stateInvalid || dataInvalid || sortInvalid) {
			this.refreshHeaderDividers();
		}
		if(columnDividerInvalid || stateInvalid || dataInvalid || sortInvalid) {
			this.refreshColumnDividers();
		}
		if(layoutInvalid) {
			this._headerResizeContainer.mouseEnabled = this._resizableColumns;
			this._headerResizeContainer.mouseChildren = this._resizableColumns;
			var oldIgnoreHeaderLayoutChanges = this._ignoreHeaderLayoutChanges;
			this._ignoreHeaderLayoutChanges = true;
			this._headerContainerLayout.set_customColumnWidths(this._customColumnWidths);
			this._ignoreHeaderLayoutChanges = oldIgnoreHeaderLayoutChanges;
		}
		if(layoutInvalid || stylesInvalid) {
			if(this._previousLayout != this.get_layout()) {
				this._virtualCache.length = 0;
				if(this._dataProvider != null) {
					this._virtualCache.length = this._dataProvider.get_length();
				}
			}
			this.gridViewPort.set_layout(this.get_layout());
			this._previousLayout = this.get_layout();
		}
		this.gridViewPort.refreshChildren = $bind(this,this.refreshRowRenderers);
		var flag = this._invalidationFlags.keys();
		while(flag.hasNext()) {
			var flag1 = flag.next();
			this.gridViewPort.setInvalid(flag1);
		}
		if(this._allInvalid) {
			this.gridViewPort.setInvalid();
		}
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.update.call(this);
		this._previousCustomHeaderRendererVariant = this.get_customHeaderRendererVariant();
		this.validateCustomColumnWidths();
		this.layoutHeaders();
		this.layoutHeaderDividers();
		this.layoutColumnDividers();
		this.handlePendingScroll();
	},
	createScroller: function() {
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.createScroller.call(this);
		this.gridViewPort.set_scroller(this.scroller);
	},
	refreshScrollerValues: function() {
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.refreshScrollerValues.call(this);
		if((js_Boot().default).__implements(this.get_layout(),(feathers_layout_IScrollLayout().default))) {
			var scrollLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_IScrollLayout().default));
			this.scroller.forceElasticTop = scrollLayout.get_elasticTop();
			this.scroller.forceElasticRight = scrollLayout.get_elasticRight();
			this.scroller.forceElasticBottom = scrollLayout.get_elasticBottom();
			this.scroller.forceElasticLeft = scrollLayout.get_elasticLeft();
		} else {
			this.scroller.forceElasticTop = false;
			this.scroller.forceElasticRight = false;
			this.scroller.forceElasticBottom = false;
			this.scroller.forceElasticLeft = false;
		}
		this.scroller.snapPositionsX = this.gridViewPort.get_snapPositionsX();
		this.scroller.snapPositionsY = this.gridViewPort.get_snapPositionsY();
	},
	needsScrollMeasurement: function() {
		var oldStart = this._visibleIndices.start;
		var oldEnd = this._visibleIndices.end;
		if(this._virtualLayout && (js_Boot().default).__implements(this.get_layout(),(feathers_layout_IVirtualLayout().default))) {
			var virtualLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_IVirtualLayout().default));
			var oldIgnoreLayoutChanges = this._ignoreLayoutChanges;
			this._ignoreLayoutChanges = true;
			virtualLayout.set_scrollX(this.scroller.get_scrollX());
			virtualLayout.set_scrollY(this.scroller.get_scrollY());
			this._ignoreLayoutChanges = oldIgnoreLayoutChanges;
			virtualLayout.getVisibleIndices(this._rowLayoutItems.length,this.gridViewPort.get_visibleWidth(),this.gridViewPort.get_visibleHeight(),this._tempVisibleIndices);
		} else {
			this._tempVisibleIndices.start = 0;
			this._tempVisibleIndices.end = this._rowLayoutItems.length - 1;
		}
		if(oldStart == this._tempVisibleIndices.start) {
			return oldEnd != this._tempVisibleIndices.end;
		} else {
			return true;
		}
	},
	calculateViewPortOffsets: function(forceScrollBars,useActualBounds) {
		var oldTopViewPortOffset = this.topViewPortOffset;
		var oldRightViewPortOffset = this.rightViewPortOffset;
		var oldBottomViewPortOffset = this.bottomViewPortOffset;
		var oldLeftViewPortOffset = this.leftViewPortOffset;
		if(this.get_fixedScrollBars() && this.get_showScrollBars()) {
			(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.calculateViewPortOffsets.call(this,forceScrollBars,useActualBounds);
		}
		if(this._headerContainer != null) {
			var oldIgnoreHeaderLayoutChanges = this._ignoreHeaderLayoutChanges;
			this._ignoreHeaderLayoutChanges = true;
			if(this.get_scrollBarYPosition()._hx_index == 3) {
				this._headerContainerLayout.set_paddingLeft(this.leftViewPortOffset);
				this._headerContainerLayout.set_paddingRight(0.0);
			} else {
				this._headerContainerLayout.set_paddingLeft(0.0);
				this._headerContainerLayout.set_paddingRight(this.rightViewPortOffset);
			}
			this._ignoreHeaderLayoutChanges = oldIgnoreHeaderLayoutChanges;
			this.topViewPortOffset = oldTopViewPortOffset;
			this.rightViewPortOffset = oldRightViewPortOffset;
			this.bottomViewPortOffset = oldBottomViewPortOffset;
			this.leftViewPortOffset = oldLeftViewPortOffset;
			this._headerContainer.validateNow();
			this.topViewPortOffset += this._headerContainer.get_height();
			this.chromeMeasuredWidth = Math.max(this.chromeMeasuredWidth,this._headerContainer.get_width());
			this.chromeMeasuredMinWidth = Math.max(this.chromeMeasuredMinWidth,this._headerContainer.get_width());
			(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.calculateViewPortOffsets.call(this,forceScrollBars,useActualBounds);
			var oldIgnoreHeaderLayoutChanges1 = this._ignoreHeaderLayoutChanges;
			this._ignoreHeaderLayoutChanges = true;
			if(this.get_scrollBarYPosition()._hx_index == 3) {
				this._headerContainerLayout.set_paddingLeft(this.leftViewPortOffset);
				this._headerContainerLayout.set_paddingRight(0.0);
			} else {
				this._headerContainerLayout.set_paddingLeft(0.0);
				this._headerContainerLayout.set_paddingRight(this.rightViewPortOffset);
			}
			this._ignoreHeaderLayoutChanges = oldIgnoreHeaderLayoutChanges1;
		}
	},
	validateColumns: function() {
		var _gthis = this;
		if(this._columns != null) {
			return;
		}
		var newColumns = null;
		if(this._dataProvider != null && this._dataProvider.get_length() > 0) {
			var item = this._dataProvider.get(0);
			var _this = (Reflect().default).fields(item);
			var result = new Array(_this.length);
			var _g = 0;
			var _g1 = _this.length;
			while(_g < _g1) {
				var i = _g++;
				var fieldName = [_this[i]];
				result[i] = new (feathers_controls_GridViewColumn().default)(fieldName[0],(function(fieldName1) {
					return function(item1) {
						return (Std().default).string((Reflect().default).getProperty(item1,fieldName1[0]));
					};
				})(fieldName));
			}
			newColumns = new (feathers_data_ArrayCollection().default)(result);
		} else {
			newColumns = new (feathers_data_ArrayCollection().default)();
		}
		this.runWithInvalidationFlagsOnly(function() {
			return _gthis.set_columns(newColumns);
		});
		this._autoPopulatedColumns = newColumns;
	},
	layoutHeaders: function() {
		if(this._headerContainer == null) {
			return;
		}
		this._headerContainer.set_x(this.get_paddingLeft());
		this._headerContainer.set_y(this.get_paddingTop());
		var minHeaderWidth = this.actualWidth - this.get_paddingLeft() - this.get_paddingRight();
		this._headerContainer.set_width(Math.max(this._viewPort.get_width() + this._headerContainerLayout.get_paddingLeft() + this._headerContainerLayout.get_paddingRight(),minHeaderWidth));
		this._headerContainer.validateNow();
		if(!(feathers_utils_MathUtil().default).fuzzyEquals(this.get_maxScrollX(),this.get_minScrollX())) {
			var scrollRect = this._scrollRect1;
			if(this._currentScrollRect == scrollRect) {
				scrollRect = this._scrollRect2;
			}
			this._currentScrollRect = scrollRect;
			var scrollRectWidth = minHeaderWidth;
			if(scrollRectWidth < 0.0) {
				scrollRectWidth = 0.0;
			}
			var scrollRectHeight = this._headerContainer.get_height();
			if(scrollRectHeight < 0.0) {
				scrollRectHeight = 0.0;
			}
			scrollRect.setTo(this.get_scrollX() - this.get_minScrollX(),0.0,scrollRectWidth,scrollRectHeight);
			this._headerContainer.set_scrollRect(scrollRect);
		} else {
			this._headerContainer.set_scrollRect(null);
		}
	},
	layoutHeaderDividers: function() {
		this._headerResizeContainer.set_x(this._headerContainer.get_x());
		this._headerResizeContainer.set_y(this._headerContainer.get_y());
		var _g = 0;
		var _g1 = this._headerDividerLayoutItems.length;
		while(_g < _g1) {
			var i = _g++;
			var headerDivider = this._headerDividerLayoutItems[i];
			headerDivider.set_visible(!this.get_showHeaderDividersOnlyWhenResizable() || this.get_resizableColumns());
			if((js_Boot().default).__implements(headerDivider,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(headerDivider , (feathers_core_IValidating().default))).validateNow();
			}
			var headerRenderer = this._headerLayoutItems[i];
			headerDivider.set_x(headerRenderer.get_x() + headerRenderer.get_width() - headerDivider.get_width() / 2.0);
			headerDivider.set_y(headerRenderer.get_y());
			headerDivider.set_height(headerRenderer.get_height());
		}
	},
	layoutColumnDividers: function() {
		this._columnDividerContainer.set_x(this._viewPort.get_x());
		this._columnDividerContainer.set_y(this._viewPort.get_y());
		var _g = 0;
		var _g1 = this._columnDividerLayoutItems.length;
		while(_g < _g1) {
			var i = _g++;
			var columnDivider = this._columnDividerLayoutItems[i];
			if((js_Boot().default).__implements(columnDivider,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(columnDivider , (feathers_core_IValidating().default))).validateNow();
			}
			var headerRenderer = this._headerLayoutItems[i];
			columnDivider.set_x(headerRenderer.get_x() + headerRenderer.get_width() - columnDivider.get_width() / 2.0);
			columnDivider.set_y(headerRenderer.get_y());
			columnDivider.set_height(this._viewPort.get_visibleHeight());
		}
	},
	layoutScrollBars: function() {
		if(!this.get_extendedScrollBarY()) {
			(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.layoutScrollBars.call(this);
			return;
		}
		var oldTopViewPortOffset = this.topViewPortOffset;
		this.topViewPortOffset = 0.0;
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.layoutScrollBars.call(this);
		this.topViewPortOffset = oldTopViewPortOffset;
	},
	refreshColumnResizeSkin: function() {
		var oldSkin = this._currentColumnResizeSkin;
		this._currentColumnResizeSkin = this.getCurrentColumnResizeSkin();
		if(this._currentColumnResizeSkin == oldSkin) {
			return;
		}
		this.removeCurrentColumnResizeSkin(oldSkin);
		if(this._currentColumnResizeSkin == null) {
			return;
		}
		if((js_Boot().default).__implements(this._currentColumnResizeSkin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._currentColumnResizeSkin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if((js_Boot().default).__implements(this._currentColumnResizeSkin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(this._currentColumnResizeSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this._currentColumnResizeSkin.set_visible(false);
		if(((this._currentColumnResizeSkin) instanceof (openfl_display_InteractiveObject()))) {
			((js_Boot().default).__cast(this._currentColumnResizeSkin , (openfl_display_InteractiveObject()))).mouseEnabled = false;
		}
		if(((this._currentColumnResizeSkin) instanceof (openfl_display_DisplayObjectContainer()))) {
			((js_Boot().default).__cast(this._currentColumnResizeSkin , (openfl_display_DisplayObjectContainer()))).mouseChildren = false;
		}
		this.addChildAt(this._currentColumnResizeSkin,0);
	},
	getCurrentColumnResizeSkin: function() {
		return this.get_columnResizeSkin();
	},
	removeCurrentColumnResizeSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		if(skin.parent == this) {
			this.removeChild(skin);
		}
	},
	refreshHeaderRenderers: function() {
		var oldIgnoreHeaderLayoutChanges = this._ignoreHeaderLayoutChanges;
		this._ignoreHeaderLayoutChanges = true;
		this._headerContainerLayout.set_columns(this._columns);
		this._ignoreHeaderLayoutChanges = oldIgnoreHeaderLayoutChanges;
		if(this._defaultHeaderStorage.headerRendererRecycler.update == null) {
			this._defaultHeaderStorage.headerRendererRecycler.update = GridView.defaultUpdateHeaderRenderer;
			if(this._defaultHeaderStorage.headerRendererRecycler.reset == null) {
				this._defaultHeaderStorage.headerRendererRecycler.reset = GridView.defaultResetHeaderRenderer;
			}
		}
		var headerRendererInvalid = this.isInvalid(GridView.INVALIDATION_FLAG_HEADER_RENDERER_FACTORY);
		this.refreshInactiveHeaderRenderers(headerRendererInvalid);
		this.findUnrenderedHeaderData();
		this.recoverInactiveHeaderRenderers();
		this.renderUnrenderedHeaderData();
		this.freeInactiveHeaderRenderers();
		if(this._defaultHeaderStorage.inactiveHeaderRenderers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive header renderers should be empty after updating."));
		}
	},
	refreshHeaderDividers: function() {
		var headerDividerInvalid = this.isInvalid(GridView.INVALIDATION_FLAG_HEADER_DIVIDER_FACTORY);
		this.refreshInactiveHeaderDividers(headerDividerInvalid);
		this.refreshActiveHeaderDividers();
		this.freeInactiveHeaderDividers();
		if(this._defaultHeaderDividerStorage.inactiveHeaderDividers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive header dividers should be empty after updating."));
		}
	},
	refreshColumnDividers: function() {
		var columnDividerInvalid = this.isInvalid(GridView.INVALIDATION_FLAG_COLUMN_DIVIDER_FACTORY);
		this.refreshInactiveColumnDividers(columnDividerInvalid);
		this.refreshActiveColumnDividers();
		this.freeInactiveColumnDividers();
		if(this._defaultColumnDividerStorage.inactiveColumnDividers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive column dividers should be empty after updating."));
		}
	},
	refreshInactiveHeaderDividers: function(factoryInvalid) {
		var temp = this._defaultHeaderDividerStorage.inactiveHeaderDividers;
		this._defaultHeaderDividerStorage.inactiveHeaderDividers = this._defaultHeaderDividerStorage.activeHeaderDividers;
		this._defaultHeaderDividerStorage.activeHeaderDividers = temp;
		if(this._defaultHeaderDividerStorage.activeHeaderDividers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": active header dividers should be empty before updating."));
		}
		if(factoryInvalid) {
			this.freeInactiveHeaderDividers();
			this._defaultHeaderDividerStorage.oldHeaderDividerFactory = null;
		}
	},
	freeInactiveHeaderDividers: function() {
		var factory = this._defaultHeaderDividerStorage.oldHeaderDividerFactory != null ? this._defaultHeaderDividerStorage.oldHeaderDividerFactory : this._defaultHeaderDividerStorage.headerDividerFactory;
		var _g = 0;
		var _g1 = this._defaultHeaderDividerStorage.inactiveHeaderDividers;
		while(_g < _g1.length) {
			var headerDivider = _g1[_g];
			++_g;
			if(headerDivider == null) {
				continue;
			}
			this.destroyHeaderDivider(headerDivider,factory);
		}
		this._defaultHeaderDividerStorage.inactiveHeaderDividers.length = 0;
	},
	refreshActiveHeaderDividers: function() {
		this._headerDividerLayoutItems.length = 0;
		if(this._defaultHeaderDividerStorage.headerDividerFactory == null) {
			return;
		}
		var _g = 0;
		var _g1 = this._columns.get_length() - 1;
		while(_g < _g1) {
			var i = _g++;
			var column = this._columns.get(i);
			var headerDivider = this.createHeaderDivider(column,i);
			this._headerDividerLayoutItems[i] = headerDivider;
			this._defaultHeaderDividerStorage.activeHeaderDividers.push(headerDivider);
		}
	},
	createHeaderDivider: function(column,columnIndex) {
		var headerDivider = null;
		if(this._defaultHeaderDividerStorage.inactiveHeaderDividers.length == 0) {
			headerDivider = this._defaultHeaderDividerStorage.headerDividerFactory.create();
			if((js_Boot().default).__implements(headerDivider,(feathers_style_IVariantStyleObject().default))) {
				var variantHeaderDivider = (js_Boot().default).__cast(headerDivider , (feathers_style_IVariantStyleObject().default));
				if(variantHeaderDivider.get_variant() == null) {
					var variant = this.get_customHeaderDividerVariant() != null ? this.get_customHeaderDividerVariant() : GridView.CHILD_VARIANT_HEADER_DIVIDER;
					variantHeaderDivider.set_variant(variant);
				}
			}
			if((js_Boot().default).__implements(headerDivider,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(headerDivider , (feathers_core_IUIControl().default))).initializeNow();
			}
			headerDivider.addEventListener("rollOver",$bind(this,this.gridView_headerDivider_rollOverHandler));
			headerDivider.addEventListener("rollOut",$bind(this,this.gridView_headerDivider_rollOutHandler));
			headerDivider.addEventListener("mouseDown",$bind(this,this.gridView_headerDivider_mouseDownHandler));
			headerDivider.addEventListener("touchBegin",$bind(this,this.gridView_headerDivider_touchBeginHandler));
			this._headerResizeContainer.addChildAt(headerDivider,columnIndex);
		} else {
			headerDivider = this._defaultHeaderDividerStorage.inactiveHeaderDividers.shift();
			this._headerResizeContainer.setChildIndex(headerDivider,columnIndex);
		}
		return headerDivider;
	},
	destroyHeaderDivider: function(headerDivider,factory) {
		headerDivider.removeEventListener("rollOver",$bind(this,this.gridView_headerDivider_rollOverHandler));
		headerDivider.removeEventListener("rollOut",$bind(this,this.gridView_headerDivider_rollOutHandler));
		headerDivider.removeEventListener("mouseDown",$bind(this,this.gridView_headerDivider_mouseDownHandler));
		headerDivider.removeEventListener("touchBegin",$bind(this,this.gridView_headerDivider_touchBeginHandler));
		this._headerResizeContainer.removeChild(headerDivider);
		if(factory != null && factory.destroy != null) {
			factory.destroy(headerDivider);
		}
	},
	refreshInactiveColumnDividers: function(factoryInvalid) {
		var temp = this._defaultColumnDividerStorage.inactiveColumnDividers;
		this._defaultColumnDividerStorage.inactiveColumnDividers = this._defaultColumnDividerStorage.activeColumnDividers;
		this._defaultColumnDividerStorage.activeColumnDividers = temp;
		if(this._defaultColumnDividerStorage.activeColumnDividers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": active column dividers should be empty before updating."));
		}
		if(factoryInvalid) {
			this.freeInactiveHeaderDividers();
			this._defaultColumnDividerStorage.oldColumnDividerFactory = null;
		}
	},
	freeInactiveColumnDividers: function() {
		var factory = this._defaultColumnDividerStorage.oldColumnDividerFactory != null ? this._defaultColumnDividerStorage.oldColumnDividerFactory : this._defaultColumnDividerStorage.columnDividerFactory;
		var _g = 0;
		var _g1 = this._defaultColumnDividerStorage.inactiveColumnDividers;
		while(_g < _g1.length) {
			var headerDivider = _g1[_g];
			++_g;
			if(headerDivider == null) {
				continue;
			}
			this.destroyColumnDivider(headerDivider,factory);
		}
		this._defaultColumnDividerStorage.inactiveColumnDividers.length = 0;
	},
	refreshActiveColumnDividers: function() {
		this._columnDividerLayoutItems.length = 0;
		if(this._defaultColumnDividerStorage.columnDividerFactory == null) {
			return;
		}
		var _g = 0;
		var _g1 = this._columns.get_length() - 1;
		while(_g < _g1) {
			var i = _g++;
			var column = this._columns.get(i);
			var columnDivider = this.createColumnDivider(column,i);
			this._columnDividerLayoutItems[i] = columnDivider;
			this._defaultColumnDividerStorage.activeColumnDividers.push(columnDivider);
		}
	},
	createColumnDivider: function(column,columnIndex) {
		var columnDivider = null;
		if(this._defaultColumnDividerStorage.inactiveColumnDividers.length == 0) {
			columnDivider = this._defaultColumnDividerStorage.columnDividerFactory.create();
			if((js_Boot().default).__implements(columnDivider,(feathers_style_IVariantStyleObject().default))) {
				var variantColumnDivider = (js_Boot().default).__cast(columnDivider , (feathers_style_IVariantStyleObject().default));
				if(variantColumnDivider.get_variant() == null) {
					var variant = this.get_customColumnDividerVariant() != null ? this.get_customColumnDividerVariant() : GridView.CHILD_VARIANT_COLUMN_DIVIDER;
					variantColumnDivider.set_variant(variant);
				}
			}
			if((js_Boot().default).__implements(columnDivider,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(columnDivider , (feathers_core_IUIControl().default))).initializeNow();
			}
			this._columnDividerContainer.addChildAt(columnDivider,columnIndex);
		} else {
			columnDivider = this._defaultColumnDividerStorage.inactiveColumnDividers.shift();
			this._columnDividerContainer.setChildIndex(columnDivider,columnIndex);
		}
		return columnDivider;
	},
	destroyColumnDivider: function(columnDivider,factory) {
		this._columnDividerContainer.removeChild(columnDivider);
		if(factory != null && factory.destroy != null) {
			factory.destroy(columnDivider);
		}
	},
	refreshInactiveHeaderRenderers: function(factoryInvalid) {
		var temp = this._defaultHeaderStorage.inactiveHeaderRenderers;
		this._defaultHeaderStorage.inactiveHeaderRenderers = this._defaultHeaderStorage.activeHeaderRenderers;
		this._defaultHeaderStorage.activeHeaderRenderers = temp;
		if(this._defaultHeaderStorage.activeHeaderRenderers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": active header renderers should be empty before updating."));
		}
		if(factoryInvalid) {
			this.recoverInactiveHeaderRenderers();
			this.freeInactiveHeaderRenderers();
			this._defaultHeaderStorage.oldHeaderRendererRecycler = null;
		}
	},
	recoverInactiveHeaderRenderers: function() {
		var _g = 0;
		var _g1 = this._defaultHeaderStorage.inactiveHeaderRenderers;
		while(_g < _g1.length) {
			var headerRenderer = _g1[_g];
			++_g;
			if(headerRenderer == null) {
				continue;
			}
			var state = this.headerRendererToHeaderState.get(headerRenderer);
			if(state == null) {
				continue;
			}
			var column = state.column;
			this.headerRendererToHeaderState.remove(headerRenderer);
			this.dataToHeaderRenderer.remove(column);
			headerRenderer.removeEventListener("trigger",$bind(this,this.gridView_headerRenderer_triggerHandler));
			headerRenderer.removeEventListener("click",$bind(this,this.gridView_headerRenderer_clickHandler));
			headerRenderer.removeEventListener("touchTap",$bind(this,this.gridView_headerRenderer_touchTapHandler));
			headerRenderer.removeEventListener("resize",$bind(this,this.gridView_headerRenderer_resizeHandler));
			this.resetHeaderRenderer(headerRenderer,state);
			if(this._defaultHeaderStorage.measurements != null) {
				this._defaultHeaderStorage.measurements.restore(headerRenderer);
			}
			this.headerStatePool.release(state);
		}
	},
	freeInactiveHeaderRenderers: function() {
		var recycler = this._defaultHeaderStorage.oldHeaderRendererRecycler != null ? this._defaultHeaderStorage.oldHeaderRendererRecycler : this._defaultHeaderStorage.headerRendererRecycler;
		var _g = 0;
		var _g1 = this._defaultHeaderStorage.inactiveHeaderRenderers;
		while(_g < _g1.length) {
			var headerRenderer = _g1[_g];
			++_g;
			if(headerRenderer == null) {
				continue;
			}
			this.destroyHeaderRenderer(headerRenderer,recycler);
		}
		this._defaultHeaderStorage.inactiveHeaderRenderers.length = 0;
	},
	findUnrenderedHeaderData: function() {
		this._rowLayoutItems.length = 0;
		if(this._columns == null || this._columns.get_length() == 0) {
			return;
		}
		this._rowLayoutItems.length = this._columns.get_length();
		var _g = 0;
		var _g1 = this._columns.get_length();
		while(_g < _g1) {
			var i = _g++;
			var column = this._columns.get(i);
			var headerRenderer = this.dataToHeaderRenderer.get(column);
			if(headerRenderer != null) {
				var state = this.headerRendererToHeaderState.get(headerRenderer);
				var changed = this.populateCurrentHeaderState(column,i,state,this._forceItemStateUpdate);
				if(changed) {
					this.updateHeaderRenderer(headerRenderer,state);
				}
				headerRenderer.set_visible(true);
				this._headerLayoutItems[i] = headerRenderer;
				var removed = (HxOverrides().default).remove(this._defaultHeaderStorage.inactiveHeaderRenderers,headerRenderer);
				if(!removed) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": header renderer map contains bad data for column at index " + i + ". This may be caused by duplicate columns, which is not allowed."));
				}
				this._defaultHeaderStorage.activeHeaderRenderers.push(headerRenderer);
			} else {
				this._unrenderedHeaderData.push(column);
			}
		}
	},
	renderUnrenderedHeaderData: function() {
		var _g = 0;
		var _g1 = this._unrenderedHeaderData;
		while(_g < _g1.length) {
			var column = _g1[_g];
			++_g;
			var index = this._columns.indexOf(column);
			var state = this.headerStatePool.get();
			this.populateCurrentHeaderState(column,index,state,true);
			var headerRenderer = this.createHeaderRenderer(state);
			headerRenderer.set_visible(true);
			this._headerContainer.addChildAt(headerRenderer,index);
			this._headerLayoutItems[index] = headerRenderer;
		}
		this._unrenderedHeaderData.length = 0;
	},
	refreshRowRenderers: function(items) {
		this._rowLayoutItems = items;
		this.refreshInactiveRowRenderers();
		this.findUnrenderedData();
		this.recoverInactiveRowRenderers();
		this.renderUnrenderedData();
		this.freeInactiveRowRenderers();
		if(this.inactiveRowRenderers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive row renderers should be empty after updating."));
		}
	},
	refreshInactiveRowRenderers: function() {
		var temp = this.inactiveRowRenderers;
		this.inactiveRowRenderers = this.activeRowRenderers;
		this.activeRowRenderers = temp;
		if(this.activeRowRenderers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": active row renderers should be empty before updating."));
		}
	},
	recoverInactiveRowRenderers: function() {
		var _g = 0;
		var _g1 = this.inactiveRowRenderers;
		while(_g < _g1.length) {
			var rowRenderer = _g1[_g];
			++_g;
			if(rowRenderer == null) {
				continue;
			}
			var state = this.rowRendererToRowState.get(rowRenderer);
			if(state == null) {
				continue;
			}
			var item = state.data;
			this.rowRendererToRowState.remove(rowRenderer);
			this.dataToRowRenderer.remove(item);
			rowRenderer.removeEventListener("cellTrigger",$bind(this,this.gridView_rowRenderer_cellTriggerHandler));
			rowRenderer.removeEventListener("trigger",$bind(this,this.gridView_rowRenderer_triggerHandler));
			this.resetRowRenderer(rowRenderer,state);
			if(this._rowRendererMeasurements != null) {
				this._rowRendererMeasurements.restore(rowRenderer);
			}
			this.rowStatePool.release(state);
		}
	},
	freeInactiveRowRenderers: function() {
		var _g = 0;
		var _g1 = this.inactiveRowRenderers;
		while(_g < _g1.length) {
			var rowRenderer = _g1[_g];
			++_g;
			if(rowRenderer == null) {
				continue;
			}
			this.destroyRowRenderer(rowRenderer);
		}
		this.inactiveRowRenderers.length = 0;
	},
	findUnrenderedData: function() {
		this._rowLayoutItems.length = 0;
		this._visibleIndices.start = 0;
		this._visibleIndices.end = 0;
		if(this._dataProvider == null || this._dataProvider.get_length() == 0) {
			return;
		}
		this._rowLayoutItems.length = this._dataProvider.get_length();
		if(this._virtualLayout && (js_Boot().default).__implements(this.get_layout(),(feathers_layout_IVirtualLayout().default))) {
			var virtualLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_IVirtualLayout().default));
			var oldIgnoreLayoutChanges = this._ignoreLayoutChanges;
			this._ignoreLayoutChanges = true;
			virtualLayout.set_scrollX(this.scroller.get_scrollX());
			virtualLayout.set_scrollY(this.scroller.get_scrollY());
			virtualLayout.set_virtualCache(this._virtualCache);
			this._ignoreLayoutChanges = oldIgnoreLayoutChanges;
			virtualLayout.getVisibleIndices(this._dataProvider.get_length(),this.gridViewPort.get_visibleWidth(),this.gridViewPort.get_visibleHeight(),this._visibleIndices);
		} else {
			this._visibleIndices.start = 0;
			var tmp = this._dataProvider.get_length();
			this._visibleIndices.end = tmp - 1;
		}
		if(this._dataProvider == null || this._dataProvider.get_length() == 0) {
			return;
		}
		var _g = this._visibleIndices.start;
		var _g1 = this._visibleIndices.end + 1;
		while(_g < _g1) {
			var i = _g++;
			var item = this._dataProvider.get(i);
			var rowRenderer = this.dataToRowRenderer.get(item);
			if(rowRenderer != null) {
				var state = this.rowRendererToRowState.get(rowRenderer);
				var changed = this.populateCurrentRowState(item,i,state,this._forceItemStateUpdate);
				if(changed) {
					this.updateRowRenderer(rowRenderer,state);
				}
				this._rowLayoutItems[i] = rowRenderer;
				var removed = (HxOverrides().default).remove(this.inactiveRowRenderers,rowRenderer);
				if(!removed) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": row renderer map contains bad data for item at index " + i + ". This may be caused by duplicate items in the data provider, which is not allowed."));
				}
				this.activeRowRenderers.push(rowRenderer);
			} else {
				this._unrenderedData.push(item);
			}
		}
	},
	renderUnrenderedData: function() {
		var _g = 0;
		var _g1 = this._unrenderedData;
		while(_g < _g1.length) {
			var item = _g1[_g];
			++_g;
			var rowIndex = this._dataProvider.indexOf(item);
			var state = this.rowStatePool.get();
			this.populateCurrentRowState(item,rowIndex,state,true);
			var rowRenderer = this.createRowRenderer(state);
			rowRenderer.set_visible(true);
			this.activeRowRenderers.push(rowRenderer);
			this.gridViewPort.addChild(rowRenderer);
			this._rowLayoutItems[rowIndex] = rowRenderer;
		}
		this._unrenderedData.length = 0;
	},
	createRowRenderer: function(state) {
		var rowRenderer = null;
		if(this.inactiveRowRenderers.length == 0) {
			rowRenderer = this._rowRendererRecycler.create();
			if(this._rowRendererMeasurements == null) {
				this._rowRendererMeasurements = new (feathers_layout_Measurements().default)(rowRenderer);
			}
			rowRenderer.initializeNow();
		} else {
			rowRenderer = this.inactiveRowRenderers.shift();
		}
		this.updateRowRenderer(rowRenderer,state);
		rowRenderer.set_gridView(this);
		rowRenderer.addEventListener("cellTrigger",$bind(this,this.gridView_rowRenderer_cellTriggerHandler));
		rowRenderer.addEventListener("trigger",$bind(this,this.gridView_rowRenderer_triggerHandler));
		this.rowRendererToRowState.set(rowRenderer,state);
		this.dataToRowRenderer.set(state.data,rowRenderer);
		return rowRenderer;
	},
	destroyRowRenderer: function(rowRenderer) {
		rowRenderer.set_gridView(null);
		this.gridViewPort.removeChild(rowRenderer);
		if(this._rowRendererRecycler.destroy != null) {
			this._rowRendererRecycler.destroy(rowRenderer);
		}
	},
	updateRowRenderer: function(rowRenderer,state) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		if(this._rowRendererRecycler.update != null) {
			this._rowRendererRecycler.update(rowRenderer,state);
		}
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		this.refreshRowRendererProperties(rowRenderer,state);
	},
	resetRowRenderer: function(rowRenderer,state) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		if(this._rowRendererRecycler.reset != null) {
			this._rowRendererRecycler.reset(rowRenderer,state);
		}
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		this.refreshRowRendererProperties(rowRenderer,GridView.RESET_ROW_STATE);
	},
	populateCurrentRowState: function(item,rowIndex,state,force) {
		var changed = false;
		if(force || state.owner != this) {
			state.owner = this;
			changed = true;
		}
		if(force || state.data != item) {
			state.data = item;
			changed = true;
		}
		if(force || state.rowIndex != rowIndex) {
			state.rowIndex = rowIndex;
			changed = true;
		}
		var selected = this._selectedIndices.indexOf(rowIndex) != -1;
		if(force || state.selected != selected) {
			state.selected = selected;
			changed = true;
		}
		var enabled = this._enabled;
		if(force || state.enabled != enabled) {
			state.enabled = enabled;
			changed = true;
		}
		var columns = this._columns;
		if(force || state.columns != columns) {
			state.columns = columns;
			changed = true;
		}
		var selectable = this._selectable;
		if(force || state.selectable != selectable) {
			state.selectable = selectable;
			changed = true;
		}
		var cellRendererRecycler = this._cellRendererRecycler;
		if(force || state.cellRendererRecycler != cellRendererRecycler) {
			state.cellRendererRecycler = cellRendererRecycler;
			changed = true;
		}
		var customColumnWidths = this._customColumnWidths;
		if(force || state.customColumnWidths != customColumnWidths) {
			state.customColumnWidths = customColumnWidths;
			changed = true;
		}
		var customCellRendererVariant = this.get_customCellRendererVariant();
		if(force || state.customCellRendererVariant != customCellRendererVariant) {
			state.customCellRendererVariant = customCellRendererVariant;
			changed = true;
		}
		var forceItemStateUpdate = this._forceItemStateUpdate;
		if(force || state.forceItemStateUpdate != forceItemStateUpdate) {
			state.forceItemStateUpdate = forceItemStateUpdate;
			changed = true;
		}
		return changed;
	},
	refreshRowRendererProperties: function(rowRenderer,state) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		rowRenderer.set_data(state.data);
		rowRenderer.set_rowIndex(state.rowIndex);
		rowRenderer.set_selected(state.selected);
		rowRenderer.set_enabled(state.enabled);
		rowRenderer.set_columns(state.columns);
		rowRenderer.selectable = state.selectable;
		rowRenderer.set_cellRendererRecycler(state.cellRendererRecycler);
		rowRenderer.set_customColumnWidths(state.customColumnWidths);
		rowRenderer.set_customCellRendererVariant(state.customCellRendererVariant);
		rowRenderer.set_forceCellStateUpdate(state.forceItemStateUpdate);
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
	},
	createHeaderRenderer: function(state) {
		var headerRenderer = null;
		if(this._defaultHeaderStorage.inactiveHeaderRenderers.length == 0) {
			headerRenderer = this._defaultHeaderStorage.headerRendererRecycler.create();
			if((js_Boot().default).__implements(headerRenderer,(feathers_style_IVariantStyleObject().default))) {
				var variantHeaderRenderer = (js_Boot().default).__cast(headerRenderer , (feathers_style_IVariantStyleObject().default));
				if(variantHeaderRenderer.get_variant() == null) {
					var variant = this.get_customHeaderRendererVariant() != null ? this.get_customHeaderRendererVariant() : GridView.CHILD_VARIANT_HEADER_RENDERER;
					variantHeaderRenderer.set_variant(variant);
				}
			}
			if((js_Boot().default).__implements(headerRenderer,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(headerRenderer , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(this._defaultHeaderStorage.measurements == null) {
				this._defaultHeaderStorage.measurements = new (feathers_layout_Measurements().default)(headerRenderer);
			}
		} else {
			headerRenderer = this._defaultHeaderStorage.inactiveHeaderRenderers.shift();
		}
		this.updateHeaderRenderer(headerRenderer,state);
		if((js_Boot().default).__implements(headerRenderer,(feathers_controls_ITriggerView().default))) {
			headerRenderer.addEventListener("trigger",$bind(this,this.gridView_headerRenderer_triggerHandler));
		} else {
			headerRenderer.addEventListener("click",$bind(this,this.gridView_headerRenderer_clickHandler));
		}
		if((js_Boot().default).__implements(headerRenderer,(feathers_core_IMeasureObject().default))) {
			headerRenderer.addEventListener("resize",$bind(this,this.gridView_headerRenderer_resizeHandler));
		}
		this.headerRendererToHeaderState.set(headerRenderer,state);
		this.dataToHeaderRenderer.set(state.column,headerRenderer);
		this._defaultHeaderStorage.activeHeaderRenderers.push(headerRenderer);
		return headerRenderer;
	},
	destroyHeaderRenderer: function(headerRenderer,recycler) {
		this._headerContainer.removeChild(headerRenderer);
		if(recycler != null && recycler.destroy != null) {
			recycler.destroy(headerRenderer);
		}
	},
	populateCurrentHeaderState: function(column,columnIndex,state,force) {
		var changed = false;
		if(force || state.owner != this) {
			state.owner = this;
			changed = true;
		}
		if(force || state.column != column) {
			state.column = column;
			changed = true;
		}
		if(force || state.columnIndex != columnIndex) {
			state.columnIndex = columnIndex;
			changed = true;
		}
		var headerText = column.headerText;
		if(force || state.text != headerText) {
			state.text = headerText;
			changed = true;
		}
		var enabled = this._enabled;
		if(force || state.enabled != enabled) {
			state.enabled = enabled;
			changed = true;
		}
		return changed;
	},
	updateHeaderRenderer: function(headerRenderer,state) {
		if(this._defaultHeaderStorage.headerRendererRecycler.update != null) {
			this._defaultHeaderStorage.headerRendererRecycler.update(headerRenderer,state);
		}
		this.refreshHeaderRendererProperties(headerRenderer,state);
	},
	resetHeaderRenderer: function(headerRenderer,state) {
		var recycler = this._defaultHeaderStorage.oldHeaderRendererRecycler != null ? this._defaultHeaderStorage.oldHeaderRendererRecycler : this._defaultHeaderStorage.headerRendererRecycler;
		if(recycler != null && recycler.reset != null) {
			recycler.reset(headerRenderer,state);
		}
		this.refreshHeaderRendererProperties(headerRenderer,GridView.RESET_HEADER_STATE);
	},
	refreshHeaderRendererProperties: function(headerRenderer,state) {
		if((js_Boot().default).__implements(headerRenderer,(feathers_core_IUIControl().default))) {
			var uiControl = (js_Boot().default).__cast(headerRenderer , (feathers_core_IUIControl().default));
			uiControl.set_enabled(state.enabled);
		}
		if((js_Boot().default).__implements(headerRenderer,(feathers_controls_dataRenderers_IGridViewHeaderRenderer().default))) {
			var header = (js_Boot().default).__cast(headerRenderer , (feathers_controls_dataRenderers_IGridViewHeaderRenderer().default));
			header.set_column(state.column);
			header.set_columnIndex(state.columnIndex);
			header.set_gridViewOwner(state.owner);
		}
		if((js_Boot().default).__implements(headerRenderer,(feathers_data_ISortOrderObserver().default))) {
			var sortObject = (js_Boot().default).__cast(headerRenderer , (feathers_data_ISortOrderObserver().default));
			if(this._sortedColumn == state.column) {
				sortObject.set_sortOrder(this._sortOrder);
			} else {
				sortObject.set_sortOrder((feathers_data_SortOrder().default).NONE);
			}
		}
		if((js_Boot().default).__implements(headerRenderer,(feathers_layout_ILayoutIndexObject().default))) {
			var layoutObject = (js_Boot().default).__cast(headerRenderer , (feathers_layout_ILayoutIndexObject().default));
			layoutObject.set_layoutIndex(state.columnIndex);
		}
	},
	refreshSelectedIndicesAfterFilterOrSort: function() {
		if(this._selectedIndex == -1) {
			return;
		}
		this.set_selectedIndex(this._dataProvider.indexOf(this._selectedItem));
	},
	navigateWithKeyboard: function(event) {
		if(event.isDefaultPrevented()) {
			return;
		}
		if(this._dataProvider == null || this._dataProvider.get_length() == 0) {
			return;
		}
		var result = this._selectedIndex;
		if((js_Boot().default).__implements(this.get_layout(),(feathers_layout_IKeyboardNavigationLayout().default))) {
			if(event.keyCode != 38 && event.keyCode != 40 && event.keyCode != 37 && event.keyCode != 39 && event.keyCode != 33 && event.keyCode != 34 && event.keyCode != 36 && event.keyCode != 35) {
				return;
			}
			result = ((js_Boot().default).__cast(this.get_layout() , (feathers_layout_IKeyboardNavigationLayout().default))).findNextKeyboardIndex(result,event,false,this._rowLayoutItems,null,this.gridViewPort.get_visibleWidth(),this.gridViewPort.get_visibleHeight());
		} else {
			switch(event.keyCode) {
			case 33:
				--result;
				break;
			case 34:
				++result;
				break;
			case 35:
				result = this._dataProvider.get_length() - 1;
				break;
			case 36:
				result = 0;
				break;
			case 37:
				--result;
				break;
			case 38:
				--result;
				break;
			case 39:
				++result;
				break;
			case 40:
				++result;
				break;
			default:
				return;
			}
		}
		if(result < 0) {
			result = 0;
		} else if(result >= this._dataProvider.get_length()) {
			result = this._dataProvider.get_length() - 1;
		}
		var changed = this._selectedIndex != result;
		if(!changed && result != -1) {
			var rowRenderer = this.dataToRowRenderer.get(this._dataProvider.get(result));
			if(rowRenderer == null) {
				changed = true;
			}
		}
		if(!changed) {
			return;
		}
		event.preventDefault();
		this.set_selectedIndex(result);
		if(this._selectedIndex != -1) {
			this.scrollToRowIndex(this._selectedIndex);
		}
		if(this._focusManager != null) {
			this._focusManager.set_focus(this);
		} else if(this.stage != null) {
			this.stage.set_focus(this);
		}
	},
	handleSelectionChange: function(item,index,ctrlKey,shiftKey) {
		if(index == -1 || !this._selectable) {
			this.set_selectedItem(null);
			return;
		}
		var selectionIndex = this._selectedItems.indexOf(item);
		if(this._allowMultipleSelection && (ctrlKey || shiftKey)) {
			if(shiftKey) {
				var anchorIndex = this._selectionAnchorIndex;
				if(anchorIndex == -1) {
					anchorIndex = 0;
				}
				var selectedIndices = [];
				if(index == anchorIndex) {
					selectedIndices.unshift(anchorIndex);
				} else {
					var i = anchorIndex;
					while(true) {
						selectedIndices.unshift(i);
						i += anchorIndex > index ? -1 : 1;
						if(!(i != index)) {
							break;
						}
					}
					if(index != anchorIndex) {
						selectedIndices.unshift(index);
					}
				}
				this.set_selectedIndices(selectedIndices);
				this._selectionAnchorIndex = anchorIndex;
			} else {
				if(selectionIndex == -1) {
					var selectedItems = this._selectedItems.slice();
					selectedItems.unshift(item);
					this.set_selectedItems(selectedItems);
				} else {
					var selectedItems1 = this._selectedItems.slice();
					selectedItems1.splice(selectionIndex,1);
					this.set_selectedItems(selectedItems1);
				}
				this._selectionAnchorIndex = index;
			}
		} else {
			this.set_selectedItem(item);
		}
	},
	handlePendingScroll: function() {
		if(this._pendingScrollRowIndex == -1) {
			return;
		}
		var rowIndex = this._pendingScrollRowIndex;
		var duration = this._pendingScrollDuration != null ? this._pendingScrollDuration : 0.0;
		this._pendingScrollRowIndex = -1;
		this._pendingScrollDuration = null;
		if(this._dataProvider == null || this._dataProvider.get_length() == 0) {
			return;
		}
		var targetX = this.get_scrollX();
		var targetY = this.get_scrollY();
		if((js_Boot().default).__implements(this.get_layout(),(feathers_layout_IScrollLayout().default))) {
			var scrollLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_IScrollLayout().default));
			var result = scrollLayout.getNearestScrollPositionForIndex(rowIndex,this._dataProvider.get_length(),this.get_viewPort().get_visibleWidth(),this.get_viewPort().get_visibleHeight());
			targetX = result.x;
			targetY = result.y;
		} else {
			var row = this._dataProvider.get(rowIndex);
			var rowRenderer = this.dataToRowRenderer.get(row);
			if(rowRenderer == null) {
				return;
			}
			var maxX = rowRenderer.get_x();
			var minX = maxX + rowRenderer.get_width() - this.get_viewPort().get_visibleWidth();
			if(targetX < minX) {
				targetX = minX;
			} else if(targetX > maxX) {
				targetX = maxX;
			}
			var maxY = rowRenderer.get_y();
			var minY = maxY + rowRenderer.get_height() - this.get_viewPort().get_visibleHeight();
			if(targetY < minY) {
				targetY = minY;
			} else if(targetY > maxY) {
				targetY = maxY;
			}
		}
		if(duration == 0.0) {
			this.scroller.set_scrollX(targetX);
			this.scroller.set_scrollY(targetY);
		} else {
			this.scroller.throwTo(targetX,targetY,duration);
		}
	},
	baseScrollContainer_keyDownHandler: function(event) {
		if(!this._selectable) {
			(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.baseScrollContainer_keyDownHandler.call(this,event);
			return;
		}
		if(!this._enabled || event.isDefaultPrevented()) {
			return;
		}
		this.navigateWithKeyboard(event);
	},
	gridView_rowRenderer_triggerHandler: function(event) {
		var rowRenderer = (js_Boot().default).__cast(event.currentTarget , (feathers_controls_dataRenderers_GridViewRowRenderer().default));
		var state = this.rowRendererToRowState.get(rowRenderer);
		this.handleSelectionChange(state.data,state.rowIndex,event.ctrlKey,event.shiftKey);
	},
	gridView_rowRenderer_cellTriggerHandler: function(event) {
		this.dispatchEvent(event.clone());
	},
	gridView_dataProvider_changeHandler: function(event) {
		if(this._ignoreDataProviderChanges) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
	},
	gridView_dataProvider_addItemHandler: function(event) {
		if(this._virtualCache != null) {
			this._virtualCache.splice(event.index,0,null);
		}
		if(this._selectedIndex == -1) {
			return;
		}
		var changed = false;
		var _g = 0;
		var _g1 = this._selectedIndices.length;
		while(_g < _g1) {
			var i = _g++;
			var selectedIndex = this._selectedIndices[i];
			if(selectedIndex >= event.index) {
				this._selectedIndices[i] = selectedIndex + 1;
				changed = true;
			}
		}
		if(changed) {
			this._selectedIndex = this._selectedIndices[0];
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
		}
	},
	gridView_dataProvider_removeItemHandler: function(event) {
		if(this._virtualCache != null) {
			(HxOverrides().default).remove(this._virtualCache,event.index);
		}
		if(this._selectedIndex == -1) {
			return;
		}
		var changed = false;
		var i = this._selectedIndices.length - 1;
		while(i >= 0) {
			var selectedIndex = this._selectedIndices[i];
			if(selectedIndex == event.index) {
				this._selectedIndices.splice(i,1);
				this._selectedItems.splice(i,1);
				changed = true;
			} else if(selectedIndex > event.index) {
				this._selectedIndices[i] = selectedIndex - 1;
				changed = true;
			}
			--i;
		}
		if(changed) {
			if(this._selectedIndices.length > 0) {
				this._selectedIndex = this._selectedIndices[0];
				this._selectedItem = this._dataProvider.get(this._selectedIndex);
			} else {
				this._selectedIndex = -1;
				this._selectedItem = null;
			}
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
		}
	},
	gridView_dataProvider_replaceItemHandler: function(event) {
		if(this._virtualCache != null) {
			this._virtualCache[event.index] = null;
		}
		if(this._selectedIndex == -1) {
			return;
		}
		var _g = 0;
		var _g1 = this._selectedIndices.length;
		while(_g < _g1) {
			var i = _g++;
			var selectedIndex = this._selectedIndices[i];
			if(selectedIndex == event.index) {
				this._selectedItems[i] = this._dataProvider.get(selectedIndex);
				this._selectedItem = this._selectedItems[0];
				(feathers_events_FeathersEvent().default).dispatch(this,"change");
				break;
			}
		}
	},
	gridView_dataProvider_removeAllHandler: function(event) {
		if(this._virtualCache != null) {
			this._virtualCache.length = 0;
		}
		this.set_selectedIndex(-1);
	},
	gridView_dataProvider_resetHandler: function(event) {
		if(this._virtualCache != null) {
			this._virtualCache.length = 0;
			this._virtualCache.length = this._dataProvider.get_length();
		}
		this.set_selectedIndex(-1);
	},
	gridView_dataProvider_sortChangeHandler: function(event) {
		if(this._virtualCache != null) {
			this._virtualCache.length = 0;
			this._virtualCache.length = this._dataProvider.get_length();
		}
		this.refreshSelectedIndicesAfterFilterOrSort();
	},
	gridView_dataProvider_filterChangeHandler: function(event) {
		if(this._virtualCache != null) {
			this._virtualCache.length = 0;
			this._virtualCache.length = this._dataProvider.get_length();
		}
		this.refreshSelectedIndicesAfterFilterOrSort();
	},
	updateRowRendererForIndex: function(index) {
		if(this._virtualCache != null) {
			this._virtualCache[index] = null;
		}
		var item = this._dataProvider.get(index);
		var rowRenderer = this.dataToRowRenderer.get(item);
		if(rowRenderer == null) {
			this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
			return;
		}
		var state = this.rowRendererToRowState.get(rowRenderer);
		if(state.owner == null) {
			return;
		}
		rowRenderer.updateCells();
		this.populateCurrentRowState(item,index,state,true);
		this.resetRowRenderer(rowRenderer,state);
		if(this._rowRendererMeasurements != null) {
			this._rowRendererMeasurements.restore(rowRenderer);
		}
		state.owner = null;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
	},
	validateCustomColumnWidths: function() {
		if(this._customColumnWidths == null || this._customColumnWidths.length < this._columns.get_length()) {
			return;
		}
		var minContainerWidth = this.actualWidth - this.get_paddingLeft() - this.get_paddingRight();
		var totalContainerWidth = Math.max(this._viewPort.get_width() + this._headerContainerLayout.get_paddingLeft() + this._headerContainerLayout.get_paddingRight(),minContainerWidth);
		var availableWidth = totalContainerWidth - this._headerContainerLayout.get_paddingLeft() - this._headerContainerLayout.get_paddingRight();
		var totalWidth = 0.0;
		var indices = [];
		var _g = 0;
		var _g1 = this._customColumnWidths.length;
		while(_g < _g1) {
			var i = _g++;
			var column = this._columns.get(i);
			if(column.width != null) {
				availableWidth -= column.width;
				continue;
			}
			var size = this._customColumnWidths[i];
			totalWidth += size;
			indices.push(i);
		}
		if(totalWidth == availableWidth) {
			return;
		}
		this._customColumnWidths = this._customColumnWidths.slice();
		var widthToDistribute = availableWidth - totalWidth;
		this.distributeWidthToIndices(widthToDistribute,indices,totalWidth);
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	calculateResizedColumnWidth: function(offset) {
		var columnCount = this._columns.get_length();
		if(this._customColumnWidths == null) {
			this._customColumnWidths = [];
			this._customColumnWidths.length = columnCount;
		} else {
			this._customColumnWidths = this._customColumnWidths.slice();
			this._customColumnWidths.length = columnCount;
		}
		var column = this._columns.get(this._resizingHeaderIndex);
		column.width = null;
		var headerRenderer = this._headerLayoutItems[this._resizingHeaderIndex];
		var column1 = this._columns.get(this._resizingHeaderIndex);
		var minX = this._headerContainer.get_x() + headerRenderer.get_x() + column1.minWidth;
		var maxX = this.actualWidth - this.rightViewPortOffset;
		var originalX = this._headerContainer.get_x() + headerRenderer.get_x() + headerRenderer.get_width();
		var newX = Math.min(Math.max(originalX + offset,minX),maxX);
		var preferredWidth = newX - headerRenderer.get_x() - this._headerContainer.get_x();
		var totalMinWidth = 0.0;
		var originalWidth = headerRenderer.get_width();
		var totalWidthAfter = 0.0;
		var indicesAfter = [];
		var _g = 0;
		var _g1 = columnCount;
		while(_g < _g1) {
			var i = _g++;
			var currentColumn = this._columns.get(i);
			if(i == this._resizingHeaderIndex) {
				continue;
			} else if(i < this._resizingHeaderIndex) {
				headerRenderer = this._headerLayoutItems[i];
				this._customColumnWidths[i] = headerRenderer.get_width();
				totalMinWidth += headerRenderer.get_width();
			} else {
				if(currentColumn.width != null) {
					totalMinWidth += currentColumn.width;
					continue;
				}
				totalMinWidth += currentColumn.minWidth;
				headerRenderer = this._headerLayoutItems[i];
				var columnWidth = headerRenderer.get_width();
				totalWidthAfter += columnWidth;
				this._customColumnWidths[i] = columnWidth;
				indicesAfter[indicesAfter.length] = i;
			}
		}
		if(indicesAfter.length == 0) {
			var index = this._resizingHeaderIndex + 1;
			indicesAfter[0] = index;
			column1 = this._columns.get(index);
			totalWidthAfter = column1.width;
			totalMinWidth -= totalWidthAfter;
			totalMinWidth += column1.minWidth;
			this._customColumnWidths[index] = totalWidthAfter;
			column1.width = null;
		}
		var newWidth = preferredWidth;
		var maxWidth = this._headerContainer.get_width() - totalMinWidth;
		if(newWidth > maxWidth) {
			newWidth = maxWidth;
		}
		if(newWidth < column1.minWidth) {
			newWidth = column1.minWidth;
		}
		this._customColumnWidths[this._resizingHeaderIndex] = newWidth;
		var widthToDistribute = originalWidth - newWidth;
		this.distributeWidthToIndices(widthToDistribute,indicesAfter,totalWidthAfter);
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	distributeWidthToIndices: function(widthToDistribute,indices,totalWidthOfIndices) {
		while(Math.abs(widthToDistribute) > 1.0) {
			var nextWidthToDistribute = widthToDistribute;
			var i = indices.length - 1;
			while(i >= 0) {
				var index = indices[i];
				var headerRenderer = this._headerLayoutItems[index];
				var columnWidth = headerRenderer.get_width();
				var column = this._columns.get(index);
				var percent = columnWidth / totalWidthOfIndices;
				var offset = widthToDistribute * percent;
				var newWidth = this._customColumnWidths[index] + offset;
				if(newWidth < column.minWidth) {
					offset += column.minWidth - newWidth;
					newWidth = column.minWidth;
					indices.splice(i,1);
					totalWidthOfIndices -= columnWidth;
				}
				this._customColumnWidths[index] = newWidth;
				nextWidthToDistribute -= offset;
				--i;
			}
			widthToDistribute = nextWidthToDistribute;
		}
		if(widthToDistribute != 0.0) {
			this._customColumnWidths[this._customColumnWidths.length - 1] += widthToDistribute;
		}
	},
	layoutColumnResizeSkin: function(offset) {
		if(this._currentColumnResizeSkin == null) {
			return;
		}
		var headerRenderer = this._headerLayoutItems[this._resizingHeaderIndex];
		var column = this._columns.get(this._resizingHeaderIndex);
		var minX = this._headerContainer.get_x() + headerRenderer.get_x() + column.minWidth;
		var maxX = this.actualWidth - this.rightViewPortOffset;
		var originalX = this._headerContainer.get_x() + headerRenderer.get_x() + headerRenderer.get_width();
		var newX = Math.min(Math.max(originalX + offset,minX),maxX) - this._currentColumnResizeSkin.get_width() / 2.0;
		this._currentColumnResizeSkin.set_visible(true);
		this._currentColumnResizeSkin.set_x(newX);
		this._currentColumnResizeSkin.set_y(this.get_paddingTop());
		this._currentColumnResizeSkin.set_height(this.actualHeight - this.get_paddingTop() - this.bottomViewPortOffset);
		this.setChildIndex(this._currentColumnResizeSkin,this.get_numChildren() - 1);
	},
	headerResizeTouchBegin: function(touchPointID,isMouse,divider,stageX) {
		if(!this._enabled || !this._resizableColumns || this._resizingHeaderIndex != -1 || this.stage == null) {
			return;
		}
		var exclusivePointer = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
		var result = false;
		if(isMouse) {
			result = exclusivePointer.claimMouse(divider);
		} else {
			result = exclusivePointer.claimTouch(touchPointID,divider);
		}
		if(!result) {
			return;
		}
		this._resizingHeaderTouchPointID = touchPointID;
		this._resizingHeaderTouchPointIsMouse = isMouse;
		this._resizingHeaderIndex = this._headerDividerLayoutItems.indexOf(divider);
		this._resizingHeaderStartStageX = stageX;
		this.layoutColumnResizeSkin(0.0);
		if(isMouse) {
			this.stage.addEventListener("mouseMove",$bind(this,this.gridView_headerDivider_stage_mouseMoveHandler),false,0,true);
			this.stage.addEventListener("mouseUp",$bind(this,this.gridView_headerDivider_stage_mouseUpHandler),false,0,true);
		} else {
			this.stage.addEventListener("touchMove",$bind(this,this.gridView_headerDivider_stage_touchMoveHandler),false,0,true);
			this.stage.addEventListener("touchEnd",$bind(this,this.gridView_headerDivider_stage_touchEndHandler),false,0,true);
		}
	},
	headerResizeTouchMove: function(touchPointID,isMouse,stageX) {
		if(this._resizingHeaderTouchPointID == null || this._resizingHeaderTouchPointID != touchPointID || this._resizingHeaderTouchPointIsMouse != isMouse) {
			return;
		}
		var offset = stageX - this._resizingHeaderStartStageX;
		offset *= (feathers_utils_DisplayUtil().default).getConcatenatedScaleX(this);
		this.layoutColumnResizeSkin(offset);
	},
	headerResizeTouchEnd: function(touchPointID,isMouse,stageX) {
		if(this._resizingHeaderTouchPointID == null || this._resizingHeaderTouchPointID != touchPointID || this._resizingHeaderTouchPointIsMouse != isMouse) {
			return;
		}
		if(isMouse) {
			this.stage.removeEventListener("mouseMove",$bind(this,this.gridView_headerDivider_stage_mouseMoveHandler));
			this.stage.removeEventListener("mouseUp",$bind(this,this.gridView_headerDivider_stage_mouseUpHandler));
		} else {
			this.stage.removeEventListener("touchMove",$bind(this,this.gridView_headerDivider_stage_touchMoveHandler));
			this.stage.removeEventListener("touchEnd",$bind(this,this.gridView_headerDivider_stage_touchEndHandler));
		}
		if(this._currentColumnResizeSkin != null) {
			this._currentColumnResizeSkin.set_visible(false);
		}
		var offset = stageX - this._resizingHeaderStartStageX;
		offset *= (feathers_utils_DisplayUtil().default).getConcatenatedScaleX(this);
		this.calculateResizedColumnWidth(offset);
		this._resizingHeaderTouchPointID = null;
		this._resizingHeaderTouchPointIsMouse = false;
		this._resizingHeaderIndex = -1;
		if(this._oldHeaderDividerMouseCursor != null) {
			(openfl_ui_Mouse()).set_cursor(this._oldHeaderDividerMouseCursor);
			this._oldHeaderDividerMouseCursor = null;
		}
	},
	reverseSortCompareFunction: function(a,b) {
		return -this.sortCompareFunction(a,b);
	},
	sortCompareFunction: function(a,b) {
		if(this._sortedColumn.sortCompareFunction == null) {
			var aText = this._sortedColumn.itemToText(a);
			var bText = this._sortedColumn.itemToText(b);
			return GridView.defaultSortCompareFunction(aText,bText);
		}
		return this._sortedColumn.sortCompareFunction(a,b);
	},
	refreshSortedColumn: function(sortInvalid) {
		if(this._dataProvider == null) {
			return;
		}
		var oldIgnoreDataProviderChanges = this._ignoreDataProviderChanges;
		this._ignoreDataProviderChanges = true;
		if(this._sortOrder == (feathers_data_SortOrder().default).ASCENDING) {
			this._dataProvider.set_sortCompareFunction($bind(this,this.sortCompareFunction));
		} else if(this._sortOrder == (feathers_data_SortOrder().default).DESCENDING) {
			this._dataProvider.set_sortCompareFunction($bind(this,this.reverseSortCompareFunction));
		} else if(this._dataProvider.get_sortCompareFunction() == $bind(this,this.sortCompareFunction) || (Reflect().default).compareMethods(this._dataProvider.get_sortCompareFunction(),$bind(this,this.sortCompareFunction)) || this._dataProvider.get_sortCompareFunction() == $bind(this,this.reverseSortCompareFunction) || (Reflect().default).compareMethods(this._dataProvider.get_sortCompareFunction(),$bind(this,this.reverseSortCompareFunction))) {
			this._dataProvider.set_sortCompareFunction(null);
		}
		if(sortInvalid) {
			this._dataProvider.refresh();
		}
		this._ignoreDataProviderChanges = oldIgnoreDataProviderChanges;
	},
	updateSortedColumn: function(column) {
		if(!this._sortableColumns || column.defaultSortOrder == (feathers_data_SortOrder().default).NONE) {
			return;
		}
		if(this._sortedColumn != column) {
			this.set_sortedColumn(column);
		} else {
			this.set_sortOrder(this._sortOrder == (feathers_data_SortOrder().default).ASCENDING ? (feathers_data_SortOrder().default).DESCENDING : (feathers_data_SortOrder().default).ASCENDING);
		}
	},
	gridView_dataProvider_updateItemHandler: function(event) {
		this.updateRowRendererForIndex(event.index);
	},
	gridView_dataProvider_updateAllHandler: function(event) {
		var _g = 0;
		var _g1 = this._dataProvider.get_length();
		while(_g < _g1) {
			var i = _g++;
			this.updateRowRendererForIndex(i);
		}
	},
	gridView_columns_addItemHandler: function(event) {
		if(this._customColumnWidths == null) {
			return;
		}
		var column = (js_Boot().default).__cast(event.addedItem , (feathers_controls_GridViewColumn().default));
		var columnIndex = event.index;
		if(column.width != null || columnIndex > this._customColumnWidths.length) {
			return;
		}
		this._customColumnWidths.splice(columnIndex,0,0.0);
		var minContainerWidth = this.actualWidth - this.get_paddingLeft() - this.get_paddingRight();
		var totalContainerWidth = Math.max(this._viewPort.get_width() + this._headerContainerLayout.get_paddingLeft() + this._headerContainerLayout.get_paddingRight(),minContainerWidth);
		var availableWidth = totalContainerWidth - this._headerContainerLayout.get_paddingLeft() - this._headerContainerLayout.get_paddingRight();
		var totalWidth = 0.0;
		var indices = [];
		var _g = 0;
		var _g1 = this._customColumnWidths.length;
		while(_g < _g1) {
			var i = _g++;
			if(i == columnIndex) {
				continue;
			}
			var column1 = this._columns.get(i);
			if(column1.width != null) {
				availableWidth -= column1.width;
				continue;
			}
			var size = this._customColumnWidths[i];
			totalWidth += size;
			indices.push(i);
		}
		var idealColumnWidth = totalWidth / (indices.length + 1);
		this._customColumnWidths[columnIndex] = idealColumnWidth;
		this._customColumnWidths = this._customColumnWidths.slice();
		var widthToDistribute = -idealColumnWidth;
		this.distributeWidthToIndices(widthToDistribute,indices,totalWidth);
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	gridView_columns_removeItemHandler: function(event) {
		if(this._customColumnWidths == null) {
			return;
		}
		var column = (js_Boot().default).__cast(event.removedItem , (feathers_controls_GridViewColumn().default));
		var columnIndex = event.index;
		if(column.width != null || columnIndex > this._customColumnWidths.length) {
			return;
		}
		this._customColumnWidths.splice(columnIndex,1);
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	gridView_columns_changeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
	},
	gridView_headerRenderer_touchTapHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(event.isPrimaryTouchPoint) {
			return;
		}
		var headerRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this.headerRendererToHeaderState.get(headerRenderer);
		this.updateSortedColumn(state.column);
		(feathers_events_GridViewEvent().default).dispatchForHeader(this,"headerTrigger",state);
	},
	gridView_headerRenderer_clickHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		var headerRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this.headerRendererToHeaderState.get(headerRenderer);
		this.updateSortedColumn(state.column);
		(feathers_events_GridViewEvent().default).dispatchForHeader(this,"headerTrigger",state);
	},
	gridView_headerRenderer_triggerHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		var headerRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this.headerRendererToHeaderState.get(headerRenderer);
		this.updateSortedColumn(state.column);
		(feathers_events_GridViewEvent().default).dispatchForHeader(this,"headerTrigger",state);
	},
	gridView_headerRenderer_resizeHandler: function(event) {
		if(this._validating) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	gridView_headerDivider_mouseDownHandler: function(event) {
		var headerDivider = (js_Boot().default).__cast(event.currentTarget , (openfl_display_InteractiveObject()));
		this.headerResizeTouchBegin(GridView.POINTER_ID_MOUSE,true,headerDivider,headerDivider.stage.get_mouseX());
	},
	gridView_headerDivider_stage_mouseMoveHandler: function(event) {
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		this.headerResizeTouchMove(GridView.POINTER_ID_MOUSE,true,stage.get_mouseX());
	},
	gridView_headerDivider_stage_mouseUpHandler: function(event) {
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		this.headerResizeTouchEnd(GridView.POINTER_ID_MOUSE,true,stage.get_mouseX());
	},
	gridView_headerDivider_touchBeginHandler: function(event) {
		if(event.isPrimaryTouchPoint) {
			return;
		}
		var headerDivider = (js_Boot().default).__cast(event.currentTarget , (openfl_display_InteractiveObject()));
		this.headerResizeTouchBegin(event.touchPointID,false,headerDivider,headerDivider.stage.get_mouseX());
	},
	gridView_headerDivider_stage_touchMoveHandler: function(event) {
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		this.headerResizeTouchMove(event.touchPointID,false,stage.get_mouseX());
	},
	gridView_headerDivider_stage_touchEndHandler: function(event) {
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		this.headerResizeTouchEnd(event.touchPointID,false,stage.get_mouseX());
	},
	gridView_headerDivider_rollOverHandler: function(event) {
		if(!this._resizableColumns || this._resizingHeaderIndex != -1 || (openfl_ui_Mouse()).get_cursor() != "auto") {
			return;
		}
	},
	gridView_headerDivider_rollOutHandler: function(event) {
		if(!this._resizableColumns || this._resizingHeaderIndex != -1 || this._oldHeaderDividerMouseCursor == null) {
			return;
		}
		(openfl_ui_Mouse()).set_cursor(this._oldHeaderDividerMouseCursor);
		this._oldHeaderDividerMouseCursor = null;
	},
	get_styleContext: function() {
		return GridView
	},
	get_customCellRendererVariant: function() {
		return this.__customCellRendererVariant;
	},
	set_customCellRendererVariant: function(value) {
		if(!this.setStyle("customCellRendererVariant")) {
			return this.__customCellRendererVariant;
		}
		if(this.__customCellRendererVariant == value) {
			return this.__customCellRendererVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customCellRendererVariant);
		this.__customCellRendererVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customCellRendererVariant;
	},
	clearStyle_customCellRendererVariant: function() {
		this.set_customCellRendererVariant(null);
		return this.get_customCellRendererVariant();
	},
	get_customHeaderRendererVariant: function() {
		return this.__customHeaderRendererVariant;
	},
	set_customHeaderRendererVariant: function(value) {
		if(!this.setStyle("customHeaderRendererVariant")) {
			return this.__customHeaderRendererVariant;
		}
		if(this.__customHeaderRendererVariant == value) {
			return this.__customHeaderRendererVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customHeaderRendererVariant);
		this.__customHeaderRendererVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customHeaderRendererVariant;
	},
	clearStyle_customHeaderRendererVariant: function() {
		this.set_customHeaderRendererVariant(null);
		return this.get_customHeaderRendererVariant();
	},
	get_headerDividerFactory: function() {
		return this.__headerDividerFactory;
	},
	set_headerDividerFactory: function(value) {
		if(!this.setStyle("headerDividerFactory")) {
			return this.__headerDividerFactory;
		}
		if(this.__headerDividerFactory == value) {
			return this.__headerDividerFactory;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_headerDividerFactory);
		this.__headerDividerFactory = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__headerDividerFactory;
	},
	clearStyle_headerDividerFactory: function() {
		this.set_headerDividerFactory((feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_Button().default)));
		return this.get_headerDividerFactory();
	},
	get_customHeaderDividerVariant: function() {
		return this.__customHeaderDividerVariant;
	},
	set_customHeaderDividerVariant: function(value) {
		if(!this.setStyle("customHeaderDividerVariant")) {
			return this.__customHeaderDividerVariant;
		}
		if(this.__customHeaderDividerVariant == value) {
			return this.__customHeaderDividerVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customHeaderDividerVariant);
		this.__customHeaderDividerVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customHeaderDividerVariant;
	},
	clearStyle_customHeaderDividerVariant: function() {
		this.set_customHeaderDividerVariant(null);
		return this.get_customHeaderDividerVariant();
	},
	get_columnDividerFactory: function() {
		return this.__columnDividerFactory;
	},
	set_columnDividerFactory: function(value) {
		if(!this.setStyle("columnDividerFactory")) {
			return this.__columnDividerFactory;
		}
		if(this.__columnDividerFactory == value) {
			return this.__columnDividerFactory;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_columnDividerFactory);
		this.__columnDividerFactory = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__columnDividerFactory;
	},
	clearStyle_columnDividerFactory: function() {
		this.set_columnDividerFactory(null);
		return this.get_columnDividerFactory();
	},
	get_customColumnDividerVariant: function() {
		return this.__customColumnDividerVariant;
	},
	set_customColumnDividerVariant: function(value) {
		if(!this.setStyle("customColumnDividerVariant")) {
			return this.__customColumnDividerVariant;
		}
		if(this.__customColumnDividerVariant == value) {
			return this.__customColumnDividerVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customColumnDividerVariant);
		this.__customColumnDividerVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customColumnDividerVariant;
	},
	clearStyle_customColumnDividerVariant: function() {
		this.set_customColumnDividerVariant(null);
		return this.get_customColumnDividerVariant();
	},
	get_layout: function() {
		return this.__layout;
	},
	set_layout: function(value) {
		if(!this.setStyle("layout")) {
			return this.__layout;
		}
		if(this.__layout == value) {
			return this.__layout;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_layout);
		this.__layout = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__layout;
	},
	clearStyle_layout: function() {
		this.set_layout(null);
		return this.get_layout();
	},
	get_columnResizeSkin: function() {
		return this.__columnResizeSkin;
	},
	set_columnResizeSkin: function(value) {
		if(!this.setStyle("columnResizeSkin")) {
			return this.__columnResizeSkin;
		}
		if(this.__columnResizeSkin == value) {
			return this.__columnResizeSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_columnResizeSkin);
		this.__columnResizeSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__columnResizeSkin;
	},
	clearStyle_columnResizeSkin: function() {
		this.set_columnResizeSkin(null);
		return this.get_columnResizeSkin();
	},
	get_extendedScrollBarY: function() {
		return this.__extendedScrollBarY;
	},
	set_extendedScrollBarY: function(value) {
		if(!this.setStyle("extendedScrollBarY")) {
			return this.__extendedScrollBarY;
		}
		if(this.__extendedScrollBarY == value) {
			return this.__extendedScrollBarY;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_extendedScrollBarY);
		this.__extendedScrollBarY = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__extendedScrollBarY;
	},
	clearStyle_extendedScrollBarY: function() {
		this.set_extendedScrollBarY(false);
		return this.get_extendedScrollBarY();
	},
	get_showHeaderDividersOnlyWhenResizable: function() {
		return this.__showHeaderDividersOnlyWhenResizable;
	},
	set_showHeaderDividersOnlyWhenResizable: function(value) {
		if(!this.setStyle("showHeaderDividersOnlyWhenResizable")) {
			return this.__showHeaderDividersOnlyWhenResizable;
		}
		if(this.__showHeaderDividersOnlyWhenResizable == value) {
			return this.__showHeaderDividersOnlyWhenResizable;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_showHeaderDividersOnlyWhenResizable);
		this.__showHeaderDividersOnlyWhenResizable = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__showHeaderDividersOnlyWhenResizable;
	},
	clearStyle_showHeaderDividersOnlyWhenResizable: function() {
		this.set_showHeaderDividersOnlyWhenResizable(false);
		return this.get_showHeaderDividersOnlyWhenResizable();
	}
});
GridView.prototype.__class__ = GridView.prototype.constructor = $hxClasses["feathers.controls.GridView"] = GridView;

// Init



// Statics

GridView.defaultUpdateHeaderRenderer = function(headerRenderer,state) {
	if((js_Boot().default).__implements(headerRenderer,(feathers_core_ITextControl().default))) {
		var textControl = (js_Boot().default).__cast(headerRenderer , (feathers_core_ITextControl().default));
		textControl.set_text(state.text);
	}
}
GridView.defaultResetHeaderRenderer = function(headerRenderer,state) {
	if((js_Boot().default).__implements(headerRenderer,(feathers_core_ITextControl().default))) {
		var textControl = (js_Boot().default).__cast(headerRenderer , (feathers_core_ITextControl().default));
		textControl.set_text(null);
	}
}
GridView.defaultSortCompareFunction = function(a,b) {
	var aString = (Std().default).string(a).toLowerCase();
	var bString = (Std().default).string(b).toLowerCase();
	if(aString < bString) {
		return -1;
	}
	if(aString > bString) {
		return 1;
	}
	return 0;
}
GridView.__meta__ = { obj : { defaultXmlProperty : ["dataProvider"]}}
GridView.VARIANT_BORDERLESS = "borderless"
GridView.VARIANT_BORDER = "border"
GridView.CHILD_VARIANT_CELL_RENDERER = "gridView_cellRenderer"
GridView.CHILD_VARIANT_HEADER_RENDERER = "gridView_headerRenderer"
GridView.CHILD_VARIANT_HEADER_DIVIDER = "gridView_headerDivider"
GridView.CHILD_VARIANT_COLUMN_DIVIDER = "gridView_columnDivider"
GridView.INVALIDATION_FLAG_HEADER_RENDERER_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("headerRendererFactory")
GridView.INVALIDATION_FLAG_HEADER_DIVIDER_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("headerDividerFactory")
GridView.INVALIDATION_FLAG_COLUMN_DIVIDER_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("columnDividerFactory")
GridView.RESET_HEADER_STATE = new (feathers_data_GridViewHeaderState().default)()
GridView.RESET_ROW_STATE = new (feathers_controls_GridViewRowState().default)()
GridView.POINTER_ID_MOUSE = -1000

// Export

exports["default"] = GridView;

/***/ }),

/***/ "./lib/_gen/feathers/controls/GridViewColumn.js":
/*!******************************************************!*\
  !*** ./lib/_gen/feathers/controls/GridViewColumn.js ***!
  \******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.GridViewColumn

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_IGridViewColumn() {return __webpack_require__(/*! ./../../feathers/controls/IGridViewColumn */ "./lib/_gen/feathers/controls/IGridViewColumn.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_data_SortOrder() {return __webpack_require__(/*! ./../../feathers/data/SortOrder */ "./lib/_gen/feathers/data/SortOrder.js");}

// Constructor

var GridViewColumn = function(headerText,itemToText,width) {
	this.defaultSortOrder = (feathers_data_SortOrder().default).ASCENDING;
	this.sortCompareFunction = null;
	this.cellRendererRecycler = null;
	this.minWidth = 0.0;
	this.width = null;
	(openfl_events_EventDispatcher()).call(this);
	this.headerText = headerText;
	if(itemToText != null) {
		this.itemToText = itemToText;
	}
	this.width = width;
}

// Meta

GridViewColumn.__name__ = "feathers.controls.GridViewColumn";
GridViewColumn.__isInterface__ = false;
GridViewColumn.__interfaces__ = [(feathers_controls_IGridViewColumn().default)];
GridViewColumn.__super__ = (openfl_events_EventDispatcher());
GridViewColumn.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	itemToText: function(data) {
		return (Std().default).string(data);
	}
});
GridViewColumn.prototype.__class__ = GridViewColumn.prototype.constructor = $hxClasses["feathers.controls.GridViewColumn"] = GridViewColumn;

// Init



// Statics




// Export

exports["default"] = GridViewColumn;

/***/ }),

/***/ "./lib/_gen/feathers/controls/GridViewRowState.js":
/*!********************************************************!*\
  !*** ./lib/_gen/feathers/controls/GridViewRowState.js ***!
  \********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.GridViewRowState

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var GridViewRowState = function() {
	this.selectable = false;
	this.enabled = true;
	this.selected = false;
	this.rowIndex = -1;
}

// Meta

GridViewRowState.__name__ = "feathers.controls.GridViewRowState";
GridViewRowState.__isInterface__ = false;
GridViewRowState.prototype = {
	
};
GridViewRowState.prototype.__class__ = GridViewRowState.prototype.constructor = $hxClasses["feathers.controls.GridViewRowState"] = GridViewRowState;

// Init



// Statics




// Export

exports["default"] = GridViewRowState;

/***/ }),

/***/ "./lib/_gen/feathers/controls/GroupListView.js":
/*!*****************************************************!*\
  !*** ./lib/_gen/feathers/controls/GroupListView.js ***!
  \*****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.GroupListView

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IFocusContainer() {return __webpack_require__(/*! ./../../feathers/core/IFocusContainer */ "./lib/_gen/feathers/core/IFocusContainer.js");}
function feathers_core_IDataSelector() {return __webpack_require__(/*! ./../../feathers/core/IDataSelector */ "./lib/_gen/feathers/core/IDataSelector.js");}
function feathers_controls_supportClasses_BaseScrollContainer() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/BaseScrollContainer */ "./lib/_gen/feathers/controls/supportClasses/BaseScrollContainer.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function haxe_ds_StringMap() {return __webpack_require__(/*! ./../../haxe/ds/StringMap */ "./lib/_gen/haxe/ds/StringMap.js");}
function feathers_themes_steel_components_SteelGroupListViewStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelGroupListViewStyles */ "./lib/_gen/feathers/themes/steel/components/SteelGroupListViewStyles.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_IScrollLayout() {return __webpack_require__(/*! ./../../feathers/layout/IScrollLayout */ "./lib/_gen/feathers/layout/IScrollLayout.js");}
function feathers_layout_IVirtualLayout() {return __webpack_require__(/*! ./../../feathers/layout/IVirtualLayout */ "./lib/_gen/feathers/layout/IVirtualLayout.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function Type() {return __webpack_require__(/*! ./../../Type */ "./lib/_gen/Type.js");}
function feathers_data_GroupListViewItemType() {return __webpack_require__(/*! ./../../feathers/data/GroupListViewItemType */ "./lib/_gen/feathers/data/GroupListViewItemType.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function feathers_style_IVariantStyleObject() {return __webpack_require__(/*! ./../../feathers/style/IVariantStyleObject */ "./lib/_gen/feathers/style/IVariantStyleObject.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_controls_ITriggerView() {return __webpack_require__(/*! ./../../feathers/controls/ITriggerView */ "./lib/_gen/feathers/controls/ITriggerView.js");}
function feathers_controls_IToggle() {return __webpack_require__(/*! ./../../feathers/controls/IToggle */ "./lib/_gen/feathers/controls/IToggle.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_controls__$GroupListView_ItemRendererStorage() {return __webpack_require__(/*! ./../../feathers/controls/_GroupListView/ItemRendererStorage */ "./lib/_gen/feathers/controls/_GroupListView/ItemRendererStorage.js");}
function feathers_controls_dataRenderers_IDataRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/IDataRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IDataRenderer.js");}
function feathers_layout_ILayoutIndexObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutIndexObject */ "./lib/_gen/feathers/layout/ILayoutIndexObject.js");}
function feathers_controls_dataRenderers_IGroupListViewItemRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/IGroupListViewItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IGroupListViewItemRenderer.js");}
function feathers_layout_IKeyboardNavigationLayout() {return __webpack_require__(/*! ./../../feathers/layout/IKeyboardNavigationLayout */ "./lib/_gen/feathers/layout/IKeyboardNavigationLayout.js");}
function feathers_events_GroupListViewEvent() {return __webpack_require__(/*! ./../../feathers/events/GroupListViewEvent */ "./lib/_gen/feathers/events/GroupListViewEvent.js");}
function openfl_display_DisplayObject() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObject);}
function feathers_data_GroupListViewItemState() {return __webpack_require__(/*! ./../../feathers/data/GroupListViewItemState */ "./lib/_gen/feathers/data/GroupListViewItemState.js");}
function feathers_core_ITextControl() {return __webpack_require__(/*! ./../../feathers/core/ITextControl */ "./lib/_gen/feathers/core/ITextControl.js");}
function feathers_layout_VirtualLayoutRange() {return __webpack_require__(/*! ./../../feathers/layout/VirtualLayoutRange */ "./lib/_gen/feathers/layout/VirtualLayoutRange.js");}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}
function haxe_ds_ObjectMap() {return __webpack_require__(/*! ./../../haxe/ds/ObjectMap */ "./lib/_gen/haxe/ds/ObjectMap.js");}
function feathers_utils_DisplayObjectRecycler() {return __webpack_require__(/*! ./../../feathers/utils/DisplayObjectRecycler */ "./lib/_gen/feathers/utils/DisplayObjectRecycler.js");}
function feathers_controls_dataRenderers_ItemRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/ItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ItemRenderer.js");}
function feathers_controls_supportClasses_AdvancedLayoutViewPort() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/AdvancedLayoutViewPort */ "./lib/_gen/feathers/controls/supportClasses/AdvancedLayoutViewPort.js");}

// Constructor

var GroupListView = function(dataProvider,changeListener) {
	this.__customItemRendererVariant = null;
	this.__customHeaderRendererVariant = null;
	this.__layout = null;
	this._pendingScrollDuration = null;
	this._pendingScrollLocation = null;
	this._ignoreLayoutChanges = false;
	this._ignoreSelectionChange = false;
	this.pointerSelectionEnabled = true;
	this._virtualLayout = true;
	this._selectable = true;
	this._layoutHeaderIndices = [];
	this._layoutItems = [];
	this._totalLayoutCount = 0;
	this._tempVisibleIndices = new (feathers_layout_VirtualLayoutRange().default)(0,0);
	this._visibleIndices = new (feathers_layout_VirtualLayoutRange().default)(0,0);
	this._virtualCache = [];
	this._unrenderedLayoutIndices = [];
	this._unrenderedLocations = [];
	this.itemStatePool = new (lime_utils_ObjectPool().default)(function() {
		return new (feathers_data_GroupListViewItemState().default)();
	});
	this.itemRendererToItemState = new (haxe_ds_ObjectMap().default)();
	this.dataToItemRenderer = new (haxe_ds_ObjectMap().default)();
	this._additionalHeaderStorage = null;
	this._additionalItemStorage = null;
	this._defaultHeaderStorage = new (feathers_controls__$GroupListView_ItemRendererStorage().default)((feathers_data_GroupListViewItemType().default).HEADER,null,(feathers_utils_DisplayObjectRecycler().default).withClass((feathers_controls_dataRenderers_ItemRenderer().default)));
	this._defaultItemStorage = new (feathers_controls__$GroupListView_ItemRendererStorage().default)((feathers_data_GroupListViewItemType().default).STANDARD,null,(feathers_utils_DisplayObjectRecycler().default).withClass((feathers_controls_dataRenderers_ItemRenderer().default)));
	this._headerRendererRecyclerMap = null;
	this._itemRendererRecyclerMap = null;
	this._forceItemStateUpdate = false;
	this._previousCustomItemRendererVariant = null;
	this._previousCustomHeaderRendererVariant = null;
	this._selectedItem = null;
	this._selectedLocation = null;
	this._childFocusEnabled = true;
	this.initializeGroupListViewTheme();
	(feathers_controls_supportClasses_BaseScrollContainer().default).call(this);
	this.set_dataProvider(dataProvider);
	this.set_tabEnabled(true);
	this.focusRect = null;
	if(this.get_viewPort() == null) {
		this.groupViewPort = new (feathers_controls_supportClasses_AdvancedLayoutViewPort().default)();
		this.addChild(this.groupViewPort);
		this.set_viewPort(this.groupViewPort);
	}
	this.addEventListener("keyDown",$bind(this,this.groupListView_keyDownHandler));
	if(changeListener != null) {
		this.addEventListener("change",changeListener);
	}
}

// Meta

GroupListView.__name__ = "feathers.controls.GroupListView";
GroupListView.__isInterface__ = false;
GroupListView.__interfaces__ = [(feathers_core_IFocusContainer().default),(feathers_core_IDataSelector().default)];
GroupListView.__super__ = (feathers_controls_supportClasses_BaseScrollContainer().default);
GroupListView.prototype = $extend((feathers_controls_supportClasses_BaseScrollContainer().default).prototype, {
	get_tabEnabled: function() {
		if((this._selectable || this.get_maxScrollY() != this.get_minScrollY() || this.get_maxScrollX() != this.get_minScrollX()) && this._enabled) {
			return this.get_rawTabEnabled();
		} else {
			return false;
		}
	},
	get_childFocusEnabled: function() {
		if(this._enabled) {
			return this._childFocusEnabled;
		} else {
			return false;
		}
	},
	set_childFocusEnabled: function(value) {
		if(this._childFocusEnabled == value) {
			return this._childFocusEnabled;
		}
		this._childFocusEnabled = value;
		return this._childFocusEnabled;
	},
	get_dataProvider: function() {
		return this._dataProvider;
	},
	set_dataProvider: function(value) {
		if(this._dataProvider == value) {
			return this._dataProvider;
		}
		this._virtualCache.length = 0;
		this._totalLayoutCount = 0;
		if(this._dataProvider != null) {
			this._dataProvider.removeEventListener("change",$bind(this,this.groupListView_dataProvider_changeHandler));
			this._dataProvider.removeEventListener("addItem",$bind(this,this.groupListView_dataProvider_addItemHandler));
			this._dataProvider.removeEventListener("removeItem",$bind(this,this.groupListView_dataProvider_removeItemHandler));
			this._dataProvider.removeEventListener("replaceItem",$bind(this,this.groupListView_dataProvider_replaceItemHandler));
			this._dataProvider.removeEventListener("removeAll",$bind(this,this.groupListView_dataProvider_removeAllHandler));
			this._dataProvider.removeEventListener("reset",$bind(this,this.groupListView_dataProvider_resetHandler));
			this._dataProvider.removeEventListener("filterChange",$bind(this,this.groupListView_dataProvider_filterChangeHandler));
			this._dataProvider.removeEventListener("sortChange",$bind(this,this.groupListView_dataProvider_sortChangeHandler));
			this._dataProvider.removeEventListener("updateItem",$bind(this,this.groupListView_dataProvider_updateItemHandler));
			this._dataProvider.removeEventListener("updateAll",$bind(this,this.groupListView_dataProvider_updateAllHandler));
		}
		this._dataProvider = value;
		if(this._dataProvider != null) {
			this._totalLayoutCount = this.calculateTotalLayoutCount([]);
			this._virtualCache.length = this._totalLayoutCount;
			this._dataProvider.addEventListener("change",$bind(this,this.groupListView_dataProvider_changeHandler));
			this._dataProvider.addEventListener("addItem",$bind(this,this.groupListView_dataProvider_addItemHandler));
			this._dataProvider.addEventListener("removeItem",$bind(this,this.groupListView_dataProvider_removeItemHandler));
			this._dataProvider.addEventListener("replaceItem",$bind(this,this.groupListView_dataProvider_replaceItemHandler));
			this._dataProvider.addEventListener("removeAll",$bind(this,this.groupListView_dataProvider_removeAllHandler));
			this._dataProvider.addEventListener("reset",$bind(this,this.groupListView_dataProvider_resetHandler));
			this._dataProvider.addEventListener("filterChange",$bind(this,this.groupListView_dataProvider_filterChangeHandler));
			this._dataProvider.addEventListener("sortChange",$bind(this,this.groupListView_dataProvider_sortChangeHandler));
			this._dataProvider.addEventListener("updateItem",$bind(this,this.groupListView_dataProvider_updateItemHandler));
			this._dataProvider.addEventListener("updateAll",$bind(this,this.groupListView_dataProvider_updateAllHandler));
		}
		this.set_scrollX(0.0);
		this.set_scrollY(0.0);
		this.set_selectedLocation(null);
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._dataProvider;
	},
	get_selectedLocation: function() {
		return this._selectedLocation;
	},
	set_selectedLocation: function(value) {
		if(!this._selectable || this._dataProvider == null) {
			value = null;
		}
		if(this._selectedLocation == value || this.compareLocations(this._selectedLocation,value) == 0) {
			return this._selectedLocation;
		}
		if(value != null && value.length != 2) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("GroupListView selectedLocation must have a length of 2"));
		}
		this._selectedLocation = value;
		if(this._selectedLocation == null) {
			this._selectedItem = null;
		} else {
			this._selectedItem = this._dataProvider.get(this._selectedLocation);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedLocation;
	},
	get_selectedItem: function() {
		return this._selectedItem;
	},
	set_selectedItem: function(value) {
		if(value == null || !this._selectable || this._dataProvider == null) {
			this.set_selectedLocation(null);
			return this._selectedItem;
		}
		var location = this._dataProvider.locationOf(value);
		if(this._selectedItem == value && this.compareLocations(this._selectedLocation,location) == 0) {
			return this._selectedItem;
		}
		this._selectedItem = value;
		this._selectedLocation = location;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedItem;
	},
	get_forceItemStateUpdate: function() {
		return this._forceItemStateUpdate;
	},
	set_forceItemStateUpdate: function(value) {
		if(this._forceItemStateUpdate == value) {
			return this._forceItemStateUpdate;
		}
		this._forceItemStateUpdate = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._forceItemStateUpdate;
	},
	get_itemRendererRecycler: function() {
		return this._defaultItemStorage.itemRendererRecycler;
	},
	set_itemRendererRecycler: function(value) {
		if(this._defaultItemStorage.itemRendererRecycler == value) {
			return this._defaultItemStorage.itemRendererRecycler;
		}
		this._defaultItemStorage.oldItemRendererRecycler = this._defaultItemStorage.itemRendererRecycler;
		this._defaultItemStorage.itemRendererRecycler = value;
		this._defaultItemStorage.measurements = null;
		this.setInvalid(GroupListView.INVALIDATION_FLAG_ITEM_RENDERER_FACTORY);
		return this._defaultItemStorage.itemRendererRecycler;
	},
	get_headerRendererRecycler: function() {
		return this._defaultHeaderStorage.itemRendererRecycler;
	},
	set_headerRendererRecycler: function(value) {
		if(this._defaultHeaderStorage.itemRendererRecycler == value) {
			return this._defaultHeaderStorage.itemRendererRecycler;
		}
		this._defaultHeaderStorage.oldItemRendererRecycler = this._defaultHeaderStorage.itemRendererRecycler;
		this._defaultHeaderStorage.itemRendererRecycler = value;
		this.setInvalid(GroupListView.INVALIDATION_FLAG_HEADER_RENDERER_FACTORY);
		return this._defaultHeaderStorage.itemRendererRecycler;
	},
	get_itemRendererRecyclerIDFunction: function() {
		return this._itemRendererRecyclerIDFunction;
	},
	set_itemRendererRecyclerIDFunction: function(value) {
		if(this._itemRendererRecyclerIDFunction == value) {
			return this._itemRendererRecyclerIDFunction;
		}
		this._itemRendererRecyclerIDFunction = value;
		if(this._itemRendererRecyclerIDFunction != null && this._additionalItemStorage == null) {
			this._additionalItemStorage = [];
		}
		this.setInvalid(GroupListView.INVALIDATION_FLAG_ITEM_RENDERER_FACTORY);
		return this._itemRendererRecyclerIDFunction;
	},
	get_headerRendererRecyclerIDFunction: function() {
		return this._headerRendererRecyclerIDFunction;
	},
	set_headerRendererRecyclerIDFunction: function(value) {
		if(this._headerRendererRecyclerIDFunction == value) {
			return this._headerRendererRecyclerIDFunction;
		}
		this._headerRendererRecyclerIDFunction = value;
		if(this._headerRendererRecyclerIDFunction != null && this._additionalHeaderStorage == null) {
			this._additionalHeaderStorage = [];
		}
		this.setInvalid(GroupListView.INVALIDATION_FLAG_HEADER_RENDERER_FACTORY);
		return this._headerRendererRecyclerIDFunction;
	},
	get_selectable: function() {
		return this._selectable;
	},
	set_selectable: function(value) {
		if(this._selectable == value) {
			return this._selectable;
		}
		this._selectable = value;
		if(!this._selectable) {
			this.set_selectedLocation(null);
		}
		return this._selectable;
	},
	get_virtualLayout: function() {
		return this._virtualLayout;
	},
	set_virtualLayout: function(value) {
		if(this._virtualLayout = value) {
			return this._virtualLayout;
		}
		this._virtualLayout = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		return this._virtualLayout;
	},
	itemToText: function(data) {
		return (Std().default).string(data);
	},
	itemToEnabled: function(data) {
		return true;
	},
	itemToHeaderText: function(data) {
		return (Std().default).string(data);
	},
	itemToItemRenderer: function(item) {
		if(item == null) {
			return null;
		}
		return this.dataToItemRenderer.get(item);
	},
	itemRendererToItem: function(itemRenderer) {
		if(itemRenderer == null) {
			return null;
		}
		var state = this.itemRendererToItemState.get(itemRenderer);
		if(state == null) {
			return null;
		}
		return state.data;
	},
	locationToItemRenderer: function(location) {
		if(this._dataProvider == null || !this.isValidLocation(location)) {
			return null;
		}
		var item = this._dataProvider.get(location);
		return this.dataToItemRenderer.get(item);
	},
	getItemRendererRecycler: function(id) {
		if(this._itemRendererRecyclerMap == null) {
			return null;
		}
		return this._itemRendererRecyclerMap.get(id);
	},
	setItemRendererRecycler: function(id,recycler) {
		if(this._itemRendererRecyclerMap == null) {
			this._itemRendererRecyclerMap = new (haxe_ds_StringMap().default)();
		}
		if(recycler == null) {
			this._itemRendererRecyclerMap.remove(id);
			return;
		}
		this._itemRendererRecyclerMap.set(id,recycler);
		this.setInvalid(GroupListView.INVALIDATION_FLAG_ITEM_RENDERER_FACTORY);
	},
	getHeaderRendererRecycler: function(id) {
		if(this._headerRendererRecyclerMap == null) {
			return null;
		}
		return this._headerRendererRecyclerMap.get(id);
	},
	setHeaderRendererRecycler: function(id,recycler) {
		if(this._headerRendererRecyclerMap == null) {
			this._headerRendererRecyclerMap = new (haxe_ds_StringMap().default)();
		}
		if(recycler == null) {
			this._headerRendererRecyclerMap.remove(id);
			return;
		}
		this._headerRendererRecyclerMap.set(id,recycler);
		this.setInvalid(GroupListView.INVALIDATION_FLAG_HEADER_RENDERER_FACTORY);
	},
	scrollToLocation: function(location,animationDuration) {
		if(this._dataProvider == null || this._dataProvider.getLength() == 0) {
			return;
		}
		this._pendingScrollLocation = location;
		this._pendingScrollDuration = animationDuration;
		this.setInvalid((feathers_core_InvalidationFlag().default).SCROLL);
	},
	initializeGroupListViewTheme: function() {
		(feathers_themes_steel_components_SteelGroupListViewStyles().default).initialize();
	},
	update: function() {
		var layoutInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(this._previousCustomHeaderRendererVariant != this.get_customHeaderRendererVariant()) {
			this.setInvalidationFlag(GroupListView.INVALIDATION_FLAG_HEADER_RENDERER_FACTORY);
		}
		if(this._previousCustomItemRendererVariant != this.get_customItemRendererVariant()) {
			this.setInvalidationFlag(GroupListView.INVALIDATION_FLAG_ITEM_RENDERER_FACTORY);
		}
		if(layoutInvalid || stylesInvalid) {
			if(this._previousLayout != this.get_layout()) {
				this._virtualCache.length = 0;
				this._virtualCache.length = this._totalLayoutCount;
			}
			this.groupViewPort.set_layout(this.get_layout());
			this._previousLayout = this.get_layout();
		}
		this.groupViewPort.refreshChildren = $bind(this,this.refreshItemRenderers);
		var flag = this._invalidationFlags.keys();
		while(flag.hasNext()) {
			var flag1 = flag.next();
			this.groupViewPort.setInvalid(flag1);
		}
		if(this._allInvalid) {
			this.groupViewPort.setInvalid();
		}
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.update.call(this);
		this._previousCustomItemRendererVariant = this.get_customItemRendererVariant();
		this._previousCustomHeaderRendererVariant = this.get_customHeaderRendererVariant();
		this.handlePendingScroll();
	},
	createScroller: function() {
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.createScroller.call(this);
		this.groupViewPort.set_scroller(this.scroller);
	},
	refreshScrollerValues: function() {
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.refreshScrollerValues.call(this);
		if((js_Boot().default).__implements(this.get_layout(),(feathers_layout_IScrollLayout().default))) {
			var scrollLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_IScrollLayout().default));
			this.scroller.forceElasticTop = scrollLayout.get_elasticTop();
			this.scroller.forceElasticRight = scrollLayout.get_elasticRight();
			this.scroller.forceElasticBottom = scrollLayout.get_elasticBottom();
			this.scroller.forceElasticLeft = scrollLayout.get_elasticLeft();
		} else {
			this.scroller.forceElasticTop = false;
			this.scroller.forceElasticRight = false;
			this.scroller.forceElasticBottom = false;
			this.scroller.forceElasticLeft = false;
		}
		this.scroller.snapPositionsX = this.groupViewPort.get_snapPositionsX();
		this.scroller.snapPositionsY = this.groupViewPort.get_snapPositionsY();
	},
	needsScrollMeasurement: function() {
		var oldStart = this._visibleIndices.start;
		var oldEnd = this._visibleIndices.end;
		if(this._virtualLayout && (js_Boot().default).__implements(this.get_layout(),(feathers_layout_IVirtualLayout().default))) {
			var virtualLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_IVirtualLayout().default));
			var oldIgnoreLayoutChanges = this._ignoreLayoutChanges;
			this._ignoreLayoutChanges = true;
			virtualLayout.set_scrollX(this.scroller.get_scrollX());
			virtualLayout.set_scrollY(this.scroller.get_scrollY());
			this._ignoreLayoutChanges = oldIgnoreLayoutChanges;
			virtualLayout.getVisibleIndices(this._layoutItems.length,this.groupViewPort.get_visibleWidth(),this.groupViewPort.get_visibleHeight(),this._tempVisibleIndices);
		} else {
			this._tempVisibleIndices.start = 0;
			this._tempVisibleIndices.end = this._layoutItems.length - 1;
		}
		if(oldStart == this._tempVisibleIndices.start) {
			return oldEnd != this._tempVisibleIndices.end;
		} else {
			return true;
		}
	},
	refreshItemRenderers: function(items) {
		this._layoutItems = items;
		if(this._defaultItemStorage.itemRendererRecycler.update == null) {
			this._defaultItemStorage.itemRendererRecycler.update = GroupListView.defaultUpdateItemRenderer;
			if(this._defaultItemStorage.itemRendererRecycler.reset == null) {
				this._defaultItemStorage.itemRendererRecycler.reset = GroupListView.defaultResetItemRenderer;
			}
		}
		if(this._defaultHeaderStorage.itemRendererRecycler.update == null) {
			this._defaultHeaderStorage.itemRendererRecycler.update = GroupListView.defaultUpdateItemRenderer;
			if(this._defaultHeaderStorage.itemRendererRecycler.reset == null) {
				this._defaultHeaderStorage.itemRendererRecycler.reset = GroupListView.defaultResetItemRenderer;
			}
		}
		if(this._itemRendererRecyclerMap != null) {
			var recycler = this._itemRendererRecyclerMap.iterator();
			while(recycler.hasNext()) {
				var recycler1 = recycler.next();
				if(recycler1.update == null) {
					if(recycler1.update == null) {
						recycler1.update = GroupListView.defaultUpdateItemRenderer;
						if(recycler1.reset == null) {
							recycler1.reset = GroupListView.defaultResetItemRenderer;
						}
					}
				}
			}
		}
		if(this._headerRendererRecyclerMap != null) {
			var recycler2 = this._headerRendererRecyclerMap.iterator();
			while(recycler2.hasNext()) {
				var recycler3 = recycler2.next();
				if(recycler3.update == null) {
					if(recycler3.update == null) {
						recycler3.update = GroupListView.defaultUpdateItemRenderer;
						if(recycler3.reset == null) {
							recycler3.reset = GroupListView.defaultResetItemRenderer;
						}
					}
				}
			}
		}
		var itemRendererInvalid = this.groupViewPort.isInvalid(GroupListView.INVALIDATION_FLAG_ITEM_RENDERER_FACTORY);
		var headerRendererInvalid = this.groupViewPort.isInvalid(GroupListView.INVALIDATION_FLAG_HEADER_RENDERER_FACTORY);
		this.refreshInactiveItemRenderers(this._defaultItemStorage,itemRendererInvalid);
		if(this._additionalItemStorage != null) {
			var _g = 0;
			var _g1 = this._additionalItemStorage.length;
			while(_g < _g1) {
				var i = _g++;
				var storage = this._additionalItemStorage[i];
				this.refreshInactiveItemRenderers(storage,itemRendererInvalid);
			}
		}
		this.refreshInactiveItemRenderers(this._defaultHeaderStorage,headerRendererInvalid);
		if(this._additionalHeaderStorage != null) {
			var _g2 = 0;
			var _g11 = this._additionalHeaderStorage.length;
			while(_g2 < _g11) {
				var i1 = _g2++;
				var storage1 = this._additionalHeaderStorage[i1];
				this.refreshInactiveItemRenderers(storage1,headerRendererInvalid);
			}
		}
		this.findUnrenderedData();
		this.recoverInactiveItemRenderers(this._defaultItemStorage);
		if(this._additionalItemStorage != null) {
			var _g3 = 0;
			var _g12 = this._additionalItemStorage.length;
			while(_g3 < _g12) {
				var i2 = _g3++;
				var storage2 = this._additionalItemStorage[i2];
				this.recoverInactiveItemRenderers(storage2);
			}
		}
		this.recoverInactiveItemRenderers(this._defaultHeaderStorage);
		if(this._additionalHeaderStorage != null) {
			var _g4 = 0;
			var _g13 = this._additionalHeaderStorage.length;
			while(_g4 < _g13) {
				var i3 = _g4++;
				var storage3 = this._additionalHeaderStorage[i3];
				this.recoverInactiveItemRenderers(storage3);
			}
		}
		this.renderUnrenderedData();
		this.freeInactiveItemRenderers(this._defaultItemStorage);
		if(this._defaultItemStorage.inactiveItemRenderers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive item renderers should be empty after updating."));
		}
		if(this._additionalItemStorage != null) {
			var _g5 = 0;
			var _g14 = this._additionalItemStorage.length;
			while(_g5 < _g14) {
				var i4 = _g5++;
				var storage4 = this._additionalItemStorage[i4];
				this.freeInactiveItemRenderers(storage4);
				if(storage4.inactiveItemRenderers.length > 0) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive item renderers " + storage4.id + " should be empty after updating."));
				}
			}
		}
		this.freeInactiveItemRenderers(this._defaultHeaderStorage);
		if(this._defaultHeaderStorage.inactiveItemRenderers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive header renderers should be empty after updating."));
		}
		if(this._additionalHeaderStorage != null) {
			var _g6 = 0;
			var _g15 = this._additionalHeaderStorage.length;
			while(_g6 < _g15) {
				var i5 = _g6++;
				var storage5 = this._additionalHeaderStorage[i5];
				this.freeInactiveItemRenderers(storage5);
				if(storage5.inactiveItemRenderers.length > 0) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive header renderers " + storage5.id + " should be empty after updating."));
				}
			}
		}
	},
	refreshInactiveItemRenderers: function(storage,factoryInvalid) {
		var temp = storage.inactiveItemRenderers;
		storage.inactiveItemRenderers = storage.activeItemRenderers;
		storage.activeItemRenderers = temp;
		if(storage.activeItemRenderers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": active " + (Std().default).string(storage.type) + " renderers should be empty before updating."));
		}
		if(factoryInvalid) {
			this.recoverInactiveItemRenderers(storage);
			this.freeInactiveItemRenderers(storage);
			storage.oldItemRendererRecycler = null;
		}
	},
	recoverInactiveItemRenderers: function(storage) {
		var _g = 0;
		var _g1 = storage.inactiveItemRenderers;
		while(_g < _g1.length) {
			var itemRenderer = _g1[_g];
			++_g;
			if(itemRenderer == null) {
				continue;
			}
			var state = this.itemRendererToItemState.get(itemRenderer);
			if(state == null) {
				continue;
			}
			var item = state.data;
			this.itemRendererToItemState.remove(itemRenderer);
			this.dataToItemRenderer.remove(item);
			if(storage.type == (feathers_data_GroupListViewItemType().default).STANDARD) {
				itemRenderer.removeEventListener("trigger",$bind(this,this.groupListView_itemRenderer_triggerHandler));
				itemRenderer.removeEventListener("click",$bind(this,this.groupListView_itemRenderer_clickHandler));
				itemRenderer.removeEventListener("touchTap",$bind(this,this.groupListView_itemRenderer_touchTapHandler));
				itemRenderer.removeEventListener("change",$bind(this,this.groupListView_itemRenderer_changeHandler));
			}
			itemRenderer.removeEventListener("resize",$bind(this,this.groupListView_itemRenderer_resizeHandler));
			this.resetItemRenderer(itemRenderer,state,storage);
			if(storage.measurements != null) {
				storage.measurements.restore(itemRenderer);
			}
			this.itemStatePool.release(state);
		}
	},
	freeInactiveItemRenderers: function(storage) {
		var recycler = storage.oldItemRendererRecycler != null ? storage.oldItemRendererRecycler : storage.itemRendererRecycler;
		var _g = 0;
		var _g1 = storage.inactiveItemRenderers;
		while(_g < _g1.length) {
			var itemRenderer = _g1[_g];
			++_g;
			if(itemRenderer == null) {
				continue;
			}
			this.destroyItemRenderer(itemRenderer,recycler);
		}
		storage.inactiveItemRenderers.length = 0;
	},
	findUnrenderedData: function() {
		this._layoutItems.length = 0;
		this._layoutItems.length = this._totalLayoutCount;
		this._layoutHeaderIndices.length = 0;
		if(this._virtualLayout && (js_Boot().default).__implements(this.get_layout(),(feathers_layout_IVirtualLayout().default))) {
			var virtualLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_IVirtualLayout().default));
			var oldIgnoreLayoutChanges = this._ignoreLayoutChanges;
			this._ignoreLayoutChanges = true;
			virtualLayout.set_scrollX(this.scroller.get_scrollX());
			virtualLayout.set_scrollY(this.scroller.get_scrollY());
			virtualLayout.set_virtualCache(this._virtualCache);
			this._ignoreLayoutChanges = oldIgnoreLayoutChanges;
			virtualLayout.getVisibleIndices(this._layoutItems.length,this.groupViewPort.get_visibleWidth(),this.groupViewPort.get_visibleHeight(),this._visibleIndices);
		} else {
			this._visibleIndices.start = 0;
			this._visibleIndices.end = this._layoutItems.length - 1;
		}
		this.findUnrenderedDataForLocation([],0);
	},
	findUnrenderedDataForLocation: function(location,layoutIndex) {
		if(this._dataProvider == null) {
			return layoutIndex;
		}
		var _g = 0;
		var _g1 = this._dataProvider.getLength(location);
		while(_g < _g1) {
			var i = _g++;
			location.push(i);
			var item = this._dataProvider.get(location);
			if(layoutIndex < this._visibleIndices.start || layoutIndex > this._visibleIndices.end) {
				this._layoutItems[layoutIndex] = null;
				if(location.length == 1) {
					this._layoutHeaderIndices.push(layoutIndex);
				}
			} else {
				this.findItemRenderer(item,location.slice(),layoutIndex);
			}
			++layoutIndex;
			if(layoutIndex > this._visibleIndices.end) {
				break;
			}
			if(location.length == 1 && this._dataProvider.isBranch(item)) {
				layoutIndex = this.findUnrenderedDataForLocation(location,layoutIndex);
				if(layoutIndex > this._visibleIndices.end) {
					break;
				}
			}
			location.pop();
		}
		return layoutIndex;
	},
	findItemRenderer: function(item,location,layoutIndex) {
		var itemRenderer = this.dataToItemRenderer.get(item);
		if(itemRenderer == null) {
			this._unrenderedLocations.push(location);
			this._unrenderedLayoutIndices.push(layoutIndex);
			return;
		}
		var type = location.length == 1 ? (feathers_data_GroupListViewItemType().default).HEADER : (feathers_data_GroupListViewItemType().default).STANDARD;
		var state = this.itemRendererToItemState.get(itemRenderer);
		var changed = this.populateCurrentItemState(item,type,location,layoutIndex,state,this._forceItemStateUpdate);
		var oldRecyclerID = state.recyclerID;
		var storage = this.itemStateToStorage(state);
		if(storage.id != oldRecyclerID) {
			this._unrenderedLocations.push(location);
			this._unrenderedLayoutIndices.push(layoutIndex);
			return;
		}
		if(changed) {
			this.updateItemRenderer(itemRenderer,state,storage);
		}
		itemRenderer.set_visible(true);
		this._layoutItems[layoutIndex] = itemRenderer;
		if(state.type == (feathers_data_GroupListViewItemType().default).HEADER) {
			this._layoutHeaderIndices.push(layoutIndex);
		}
		var removed = (HxOverrides().default).remove(storage.inactiveItemRenderers,itemRenderer);
		if(!removed) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": item renderer map contains bad data for item at location " + (Std().default).string(location) + ". This may be caused by duplicate items in the data provider, which is not allowed."));
		}
		storage.activeItemRenderers.push(itemRenderer);
	},
	renderUnrenderedData: function() {
		var _g = 0;
		var _g1 = this._unrenderedLocations;
		while(_g < _g1.length) {
			var location = _g1[_g];
			++_g;
			var item = this._dataProvider.get(location);
			var type = location.length == 1 ? (feathers_data_GroupListViewItemType().default).HEADER : (feathers_data_GroupListViewItemType().default).STANDARD;
			var layoutIndex = this._unrenderedLayoutIndices.shift();
			var state = this.itemStatePool.get();
			this.populateCurrentItemState(item,type,location,layoutIndex,state,true);
			var itemRenderer = this.createItemRenderer(state);
			itemRenderer.set_visible(true);
			this.groupViewPort.addChild(itemRenderer);
			this._layoutItems[layoutIndex] = itemRenderer;
			if(type == (feathers_data_GroupListViewItemType().default).HEADER) {
				this._layoutHeaderIndices.push(layoutIndex);
			}
		}
		this._unrenderedLocations.length = 0;
	},
	createItemRenderer: function(state) {
		var storage = this.itemStateToStorage(state);
		var itemRenderer = null;
		if(storage.inactiveItemRenderers.length == 0) {
			itemRenderer = storage.itemRendererRecycler.create();
			if((js_Boot().default).__implements(itemRenderer,(feathers_style_IVariantStyleObject().default))) {
				var variantItemRenderer = (js_Boot().default).__cast(itemRenderer , (feathers_style_IVariantStyleObject().default));
				if(variantItemRenderer.get_variant() == null) {
					if(state.type == (feathers_data_GroupListViewItemType().default).HEADER) {
						var variant = this.get_customHeaderRendererVariant() != null ? this.get_customHeaderRendererVariant() : GroupListView.CHILD_VARIANT_HEADER_RENDERER;
						variantItemRenderer.set_variant(variant);
					} else {
						var variant1 = this.get_customItemRendererVariant() != null ? this.get_customItemRendererVariant() : GroupListView.CHILD_VARIANT_ITEM_RENDERER;
						variantItemRenderer.set_variant(variant1);
					}
				}
			}
			if((js_Boot().default).__implements(itemRenderer,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(itemRenderer , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(storage.measurements == null) {
				storage.measurements = new (feathers_layout_Measurements().default)(itemRenderer);
			}
		} else {
			itemRenderer = storage.inactiveItemRenderers.shift();
		}
		this.updateItemRenderer(itemRenderer,state,storage);
		if(state.type == (feathers_data_GroupListViewItemType().default).STANDARD) {
			if((js_Boot().default).__implements(itemRenderer,(feathers_controls_ITriggerView().default))) {
				itemRenderer.addEventListener("trigger",$bind(this,this.groupListView_itemRenderer_triggerHandler));
			} else {
				itemRenderer.addEventListener("click",$bind(this,this.groupListView_itemRenderer_clickHandler));
			}
			if((js_Boot().default).__implements(itemRenderer,(feathers_controls_IToggle().default))) {
				itemRenderer.addEventListener("change",$bind(this,this.groupListView_itemRenderer_changeHandler));
			}
		}
		if((js_Boot().default).__implements(itemRenderer,(feathers_core_IMeasureObject().default))) {
			itemRenderer.addEventListener("resize",$bind(this,this.groupListView_itemRenderer_resizeHandler));
		}
		this.itemRendererToItemState.set(itemRenderer,state);
		this.dataToItemRenderer.set(state.data,itemRenderer);
		storage.activeItemRenderers.push(itemRenderer);
		return itemRenderer;
	},
	destroyItemRenderer: function(itemRenderer,recycler) {
		this.groupViewPort.removeChild(itemRenderer);
		if(recycler != null && recycler.destroy != null) {
			recycler.destroy(itemRenderer);
		}
	},
	itemOrHeaderStateToStorage: function(state,recyclerIDFunction,recyclerMap,defaultStorage,additionalStorage) {
		var recyclerID = null;
		if(recyclerIDFunction != null) {
			recyclerID = recyclerIDFunction(state);
		}
		var recycler = null;
		if(recyclerID != null) {
			if(recyclerMap != null) {
				recycler = recyclerMap.get(recyclerID);
			}
			if(recycler == null) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Item renderer recycler ID \"" + recyclerID + "\" is not registered."));
			}
		}
		if(recycler == null) {
			return defaultStorage;
		}
		var _g = 0;
		var _g1 = additionalStorage.length;
		while(_g < _g1) {
			var i = _g++;
			var storage = additionalStorage[i];
			if(storage.itemRendererRecycler == recycler) {
				return storage;
			}
		}
		var storage1 = new (feathers_controls__$GroupListView_ItemRendererStorage().default)(state.type,recyclerID,recycler);
		additionalStorage.push(storage1);
		return storage1;
	},
	itemStateToStorage: function(state) {
		if(state.type == (feathers_data_GroupListViewItemType().default).HEADER) {
			return this.itemOrHeaderStateToStorage(state,this._headerRendererRecyclerIDFunction,this._headerRendererRecyclerMap,this._defaultHeaderStorage,this._additionalHeaderStorage);
		}
		return this.itemOrHeaderStateToStorage(state,this._itemRendererRecyclerIDFunction,this._itemRendererRecyclerMap,this._defaultItemStorage,this._additionalItemStorage);
	},
	populateCurrentItemState: function(item,type,location,layoutIndex,state,force) {
		var changed = false;
		if(force || state.owner != this) {
			state.owner = this;
			changed = true;
		}
		if(force || state.type != type) {
			state.type = type;
			changed = true;
		}
		if(force || state.data != item) {
			state.data = item;
			changed = true;
		}
		if(force || state.location != location && this.compareLocations(state.location,location) != 0) {
			state.location = location;
			changed = true;
		}
		if(force || state.layoutIndex != layoutIndex) {
			state.layoutIndex = layoutIndex;
			changed = true;
		}
		var selected = location.length > 1 && item == this._selectedItem;
		if(force || state.selected != selected) {
			state.selected = selected;
			changed = true;
		}
		var enabled = this._enabled && this.itemToEnabled(item);
		if(force || state.enabled != enabled) {
			state.enabled = enabled;
			changed = true;
		}
		var text = type == (feathers_data_GroupListViewItemType().default).HEADER ? this.itemToHeaderText(item) : this.itemToText(item);
		if(force || state.text != text) {
			state.text = text;
			changed = true;
		}
		return changed;
	},
	updateItemRenderer: function(itemRenderer,state,storage) {
		state.recyclerID = storage.id;
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		if(storage.itemRendererRecycler.update != null) {
			storage.itemRendererRecycler.update(itemRenderer,state);
		}
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		this.refreshItemRendererProperties(itemRenderer,state);
	},
	resetItemRenderer: function(itemRenderer,state,storage) {
		var recycler = storage.oldItemRendererRecycler != null ? storage.oldItemRendererRecycler : storage.itemRendererRecycler;
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		if(recycler != null && recycler.reset != null) {
			recycler.reset(itemRenderer,state);
		}
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		this.refreshItemRendererProperties(itemRenderer,GroupListView.RESET_ITEM_STATE);
	},
	refreshItemRendererProperties: function(itemRenderer,state) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		if((js_Boot().default).__implements(itemRenderer,(feathers_core_IUIControl().default))) {
			var uiControl = (js_Boot().default).__cast(itemRenderer , (feathers_core_IUIControl().default));
			uiControl.set_enabled(state.enabled);
		}
		if((js_Boot().default).__implements(itemRenderer,(feathers_controls_dataRenderers_IDataRenderer().default))) {
			var dataRenderer = (js_Boot().default).__cast(itemRenderer , (feathers_controls_dataRenderers_IDataRenderer().default));
			dataRenderer.set_data(state.data);
		}
		if((js_Boot().default).__implements(itemRenderer,(feathers_layout_ILayoutIndexObject().default))) {
			var layoutRenderer = (js_Boot().default).__cast(itemRenderer , (feathers_layout_ILayoutIndexObject().default));
			layoutRenderer.set_layoutIndex(state.layoutIndex);
		}
		if((js_Boot().default).__implements(itemRenderer,(feathers_controls_dataRenderers_IGroupListViewItemRenderer().default))) {
			var groupListRenderer = (js_Boot().default).__cast(itemRenderer , (feathers_controls_dataRenderers_IGroupListViewItemRenderer().default));
			groupListRenderer.set_location(state.location);
			groupListRenderer.set_groupListViewOwner(state.owner);
		}
		if((js_Boot().default).__implements(itemRenderer,(feathers_controls_IToggle().default))) {
			var toggle = (js_Boot().default).__cast(itemRenderer , (feathers_controls_IToggle().default));
			toggle.set_selected(state.selected);
		}
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
	},
	refreshSelectedLocationAfterFilterOrSort: function() {
		if(this._selectedLocation == null) {
			return;
		}
		this.set_selectedLocation(this._dataProvider.locationOf(this._selectedItem));
	},
	calculateTotalLayoutCount: function(location) {
		if(this._dataProvider == null) {
			return 0;
		}
		var itemCount = this._dataProvider.getLength(location);
		var result = itemCount;
		var _g = 0;
		var _g1 = itemCount;
		while(_g < _g1) {
			var i = _g++;
			location.push(i);
			var item = this._dataProvider.get(location);
			if(location.length == 1 && this._dataProvider.isBranch(item)) {
				result += this.calculateTotalLayoutCount(location);
			}
			location.pop();
		}
		return result;
	},
	containsLocation: function(parent,possibleChild) {
		if(parent == null || possibleChild == null || parent.length >= possibleChild.length) {
			return false;
		}
		var _g = 0;
		var _g1 = parent.length;
		while(_g < _g1) {
			var i = _g++;
			var a = parent[i];
			var b = possibleChild[i];
			if(a != b) {
				return false;
			}
		}
		return true;
	},
	compareLocations: function(location1,location2) {
		var null1 = location1 == null;
		var null2 = location2 == null;
		if(null1 && null2) {
			return 0;
		} else if(null1) {
			return 1;
		} else if(null2) {
			return -1;
		}
		var length1 = location1.length;
		var length2 = location2.length;
		var min = length1;
		if(length2 < min) {
			min = length2;
		}
		var _g = 0;
		var _g1 = min;
		while(_g < _g1) {
			var i = _g++;
			var index1 = location1[i];
			var index2 = location2[i];
			if(index1 < index2) {
				return -1;
			}
			if(index1 > index2) {
				return 1;
			}
		}
		if(length1 < length2) {
			return -1;
		} else if(length1 > length2) {
			return 1;
		}
		return 0;
	},
	displayIndexToLocation: function(displayIndex) {
		if(displayIndex < 0) {
			return null;
		}
		this._currentDisplayIndex = -1;
		return this.displayIndexToLocationAtBranch(displayIndex,[]);
	},
	displayIndexToLocationAtBranch: function(target,locationOfBranch) {
		var _g = 0;
		var _g1 = this._dataProvider.getLength(locationOfBranch);
		while(_g < _g1) {
			var i = _g++;
			this._currentDisplayIndex++;
			locationOfBranch[locationOfBranch.length] = i;
			if(this._currentDisplayIndex == target) {
				return locationOfBranch;
			}
			var child = this._dataProvider.get(locationOfBranch);
			if(locationOfBranch.length == 1 && this._dataProvider.isBranch(child)) {
				var result = this.displayIndexToLocationAtBranch(target,locationOfBranch);
				if(result != null) {
					return result;
				}
			}
			locationOfBranch.length -= 1;
		}
		return null;
	},
	locationToDisplayIndex: function(location) {
		this._currentDisplayIndex = -1;
		return this.locationToDisplayIndexAtBranch([],location);
	},
	locationToDisplayIndexAtBranch: function(locationOfBranch,locationToFind) {
		var _g = 0;
		var _g1 = this._dataProvider.getLength(locationOfBranch);
		while(_g < _g1) {
			var i = _g++;
			this._currentDisplayIndex++;
			locationOfBranch[locationOfBranch.length] = i;
			if(this.compareLocations(locationOfBranch,locationToFind) == 0) {
				return this._currentDisplayIndex;
			}
			var child = this._dataProvider.get(locationOfBranch);
			if(locationOfBranch.length == 1 && this._dataProvider.isBranch(child)) {
				var result = this.locationToDisplayIndexAtBranch(locationOfBranch,locationToFind);
				if(result != -1) {
					return result;
				}
			}
			locationOfBranch.length -= 1;
		}
		return -1;
	},
	isValidLocation: function(location) {
		var locationOfBranch = [];
		var _g = 0;
		while(_g < location.length) {
			var index = location[_g];
			++_g;
			if(index < 0) {
				return false;
			}
			if(index >= this._dataProvider.getLength(locationOfBranch)) {
				return false;
			}
			locationOfBranch.push(index);
		}
		return true;
	},
	navigateWithKeyboard: function(event) {
		if(event.isDefaultPrevented()) {
			return;
		}
		if(this._layoutItems.length == 0) {
			return;
		}
		var location = null;
		var startIndex = this.locationToDisplayIndex(this._selectedLocation);
		var result = startIndex;
		if((js_Boot().default).__implements(this.get_layout(),(feathers_layout_IKeyboardNavigationLayout().default))) {
			if(event.keyCode != 38 && event.keyCode != 40 && event.keyCode != 37 && event.keyCode != 39 && event.keyCode != 33 && event.keyCode != 34 && event.keyCode != 36 && event.keyCode != 35) {
				return;
			}
			result = ((js_Boot().default).__cast(this.get_layout() , (feathers_layout_IKeyboardNavigationLayout().default))).findNextKeyboardIndex(result,event,false,this._layoutItems,this._layoutHeaderIndices,this.groupViewPort.get_visibleWidth(),this.groupViewPort.get_visibleHeight());
			location = this.displayIndexToLocation(result);
			if(location == null || location.length != 2) {
				return;
			}
		} else {
			var needsAnotherPass = true;
			var nextKeyCode = event.keyCode;
			var lastResult = -1;
			while(needsAnotherPass) {
				needsAnotherPass = false;
				switch(nextKeyCode) {
				case 33:
					--result;
					break;
				case 34:
					++result;
					break;
				case 35:
					result = this._layoutItems.length - 1;
					nextKeyCode = 38;
					break;
				case 36:
					result = 0;
					nextKeyCode = 40;
					break;
				case 37:
					--result;
					break;
				case 38:
					--result;
					break;
				case 39:
					++result;
					break;
				case 40:
					++result;
					break;
				default:
					return;
				}
				if(result < 0) {
					result = 0;
				} else if(result >= this._layoutItems.length) {
					result = this._layoutItems.length - 1;
				}
				location = this.displayIndexToLocation(result);
				if(location.length != 2) {
					if(result == lastResult) {
						return;
					}
					needsAnotherPass = true;
				}
				lastResult = result;
			}
		}
		var changed = result != startIndex;
		if(!changed && result != -1) {
			var itemRenderer = this.itemToItemRenderer(this._dataProvider.get(location));
			if(itemRenderer == null) {
				changed = true;
			}
		}
		if(!changed) {
			return;
		}
		event.preventDefault();
		this.set_selectedLocation(location);
		if(this._selectedLocation != null) {
			this.scrollToLocation(this._selectedLocation);
		}
		if(this._focusManager != null) {
			this._focusManager.set_focus(this);
		} else if(this.stage != null) {
			this.stage.set_focus(this);
		}
	},
	handleSelectionChange: function(item,location,ctrlKey,shiftKey) {
		if(location == null || location.length != 2 || !this._selectable) {
			this.set_selectedItem(null);
			return;
		}
		this.set_selectedLocation(location);
	},
	handlePendingScroll: function() {
		if(this._pendingScrollLocation == null) {
			return;
		}
		var location = this._pendingScrollLocation;
		var duration = this._pendingScrollDuration != null ? this._pendingScrollDuration : 0.0;
		this._pendingScrollLocation = null;
		this._pendingScrollDuration = null;
		if(this._dataProvider == null || this._dataProvider.getLength() == 0) {
			return;
		}
		var targetX = this.get_scrollX();
		var targetY = this.get_scrollY();
		if((js_Boot().default).__implements(this.get_layout(),(feathers_layout_IScrollLayout().default))) {
			var displayIndex = this.locationToDisplayIndex(location);
			var scrollLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_IScrollLayout().default));
			var result = scrollLayout.getNearestScrollPositionForIndex(displayIndex,this._layoutItems.length,this.get_viewPort().get_visibleWidth(),this.get_viewPort().get_visibleHeight());
			targetX = result.x;
			targetY = result.y;
		} else {
			var item = this._dataProvider.get(location);
			var itemRenderer = this.dataToItemRenderer.get(item);
			if(itemRenderer == null) {
				return;
			}
			var maxX = itemRenderer.get_x();
			var minX = maxX + itemRenderer.get_width() - this.get_viewPort().get_visibleWidth();
			if(targetX < minX) {
				targetX = minX;
			} else if(targetX > maxX) {
				targetX = maxX;
			}
			var maxY = itemRenderer.get_y();
			var minY = maxY + itemRenderer.get_height() - this.get_viewPort().get_visibleHeight();
			if(targetY < minY) {
				targetY = minY;
			} else if(targetY > maxY) {
				targetY = maxY;
			}
		}
		if(duration == 0.0) {
			this.scroller.set_scrollX(targetX);
			this.scroller.set_scrollY(targetY);
		} else {
			this.scroller.throwTo(targetX,targetY,duration);
		}
	},
	baseScrollContainer_keyDownHandler: function(event) {
		if(!this._selectable) {
			(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.baseScrollContainer_keyDownHandler.call(this,event);
			return;
		}
		if(!this._enabled || event.isDefaultPrevented()) {
			return;
		}
		this.navigateWithKeyboard(event);
	},
	groupListView_keyDownHandler: function(event) {
		if(!this._enabled || event.isDefaultPrevented()) {
			return;
		}
		if(event.keyCode == 32 || event.keyCode == 13) {
			if(this._selectedItem != null) {
				var itemRenderer = this.dataToItemRenderer.get(this._selectedItem);
				var state = null;
				if(itemRenderer != null) {
					state = this.itemRendererToItemState.get(itemRenderer);
				}
				var isTemporary = false;
				if(state == null) {
					isTemporary = true;
					state = this.itemStatePool.get();
				}
				var type = this._selectedLocation.length == 1 ? (feathers_data_GroupListViewItemType().default).HEADER : (feathers_data_GroupListViewItemType().default).STANDARD;
				var layoutIndex = this.locationToDisplayIndex(this._selectedLocation);
				this.populateCurrentItemState(this._selectedItem,type,this._selectedLocation,layoutIndex,state,true);
				(feathers_events_GroupListViewEvent().default).dispatch(this,"itemTrigger",state);
				if(isTemporary) {
					this.itemStatePool.release(state);
				}
			}
		}
	},
	groupListView_itemRenderer_touchTapHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(event.isPrimaryTouchPoint) {
			return;
		}
		var itemRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this.itemRendererToItemState.get(itemRenderer);
		(feathers_events_GroupListViewEvent().default).dispatch(this,"itemTrigger",state);
		if(!this._selectable || !this.pointerSelectionEnabled) {
			return;
		}
		this.handleSelectionChange(state.data,state.location,event.ctrlKey,event.shiftKey);
	},
	groupListView_itemRenderer_clickHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		var itemRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this.itemRendererToItemState.get(itemRenderer);
		(feathers_events_GroupListViewEvent().default).dispatch(this,"itemTrigger",state);
		if(!this._selectable || !this.pointerSelectionEnabled) {
			return;
		}
		this.handleSelectionChange(state.data,state.location,event.ctrlKey,event.shiftKey);
	},
	groupListView_itemRenderer_triggerHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		var itemRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this.itemRendererToItemState.get(itemRenderer);
		(feathers_events_GroupListViewEvent().default).dispatch(this,"itemTrigger",state);
		if(!this._selectable) {
			return;
		}
		this.handleSelectionChange(state.data,state.location,event.ctrlKey,event.shiftKey);
	},
	groupListView_itemRenderer_resizeHandler: function(event) {
		if(this._validating) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	groupListView_itemRenderer_changeHandler: function(event) {
		if(this._ignoreSelectionChange) {
			return;
		}
		var itemRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var toggleItemRenderer = (js_Boot().default).__cast(itemRenderer , (feathers_controls_IToggle().default));
		var state = this.itemRendererToItemState.get(itemRenderer);
		if(toggleItemRenderer.get_selected() == state.selected) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
	},
	groupListView_dataProvider_changeHandler: function(event) {
		this._totalLayoutCount = this.calculateTotalLayoutCount([]);
		if(this._virtualCache != null) {
			this._virtualCache.length = 0;
			this._virtualCache.length = this._totalLayoutCount;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
	},
	groupListView_dataProvider_addItemHandler: function(event) {
		if(this._selectedLocation == null) {
			return;
		}
		if(this.compareLocations(this._selectedLocation,event.location) >= 0) {
			this.set_selectedLocation(this._dataProvider.locationOf(this._selectedItem));
		}
	},
	groupListView_dataProvider_removeItemHandler: function(event) {
		if(this._selectedLocation != null) {
			if(this.containsLocation(event.location,this._selectedLocation)) {
				this.set_selectedLocation(null);
			} else {
				var comparisonResult = this.compareLocations(this._selectedLocation,event.location);
				if(comparisonResult == 0) {
					this.set_selectedLocation(null);
				} else if(comparisonResult > 0) {
					this.set_selectedLocation(this._dataProvider.locationOf(this._selectedItem));
				}
			}
		}
	},
	groupListView_dataProvider_replaceItemHandler: function(event) {
		if(this._selectedLocation != null) {
			if(this.containsLocation(event.location,this._selectedLocation)) {
				this.set_selectedLocation(null);
			} else if(this.compareLocations(this._selectedLocation,event.location) == 0) {
				this._selectedItem = this._dataProvider.get(event.location);
				(feathers_events_FeathersEvent().default).dispatch(this,"change");
			}
		}
	},
	groupListView_dataProvider_removeAllHandler: function(event) {
		this.set_selectedLocation(null);
	},
	groupListView_dataProvider_resetHandler: function(event) {
		this.set_selectedLocation(null);
	},
	groupListView_dataProvider_sortChangeHandler: function(event) {
		this.refreshSelectedLocationAfterFilterOrSort();
	},
	groupListView_dataProvider_filterChangeHandler: function(event) {
		this.refreshSelectedLocationAfterFilterOrSort();
	},
	updateItemRendererForLocation: function(location) {
		var layoutIndex = this.locationToDisplayIndex(location);
		if(this._virtualCache != null) {
			this._virtualCache[layoutIndex] = null;
		}
		var item = this._dataProvider.get(location);
		var type = location.length == 1 ? (feathers_data_GroupListViewItemType().default).HEADER : (feathers_data_GroupListViewItemType().default).STANDARD;
		var itemRenderer = this.dataToItemRenderer.get(item);
		if(itemRenderer == null) {
			this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		} else {
			var state = this.itemRendererToItemState.get(itemRenderer);
			if(state.owner != null) {
				var storage = this.itemStateToStorage(state);
				this.populateCurrentItemState(item,type,location,layoutIndex,state,true);
				this.resetItemRenderer(itemRenderer,state,storage);
				if(storage.measurements != null) {
					storage.measurements.restore(itemRenderer);
				}
				state.owner = null;
				this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
			}
		}
		if(type == (feathers_data_GroupListViewItemType().default).HEADER) {
			var _g = 0;
			var _g1 = this._dataProvider.getLength(location);
			while(_g < _g1) {
				var i = _g++;
				location.push(i);
				this.updateItemRendererForLocation(location);
				location.pop();
			}
		}
	},
	groupListView_dataProvider_updateItemHandler: function(event) {
		this.updateItemRendererForLocation(event.location);
	},
	groupListView_dataProvider_updateAllHandler: function(event) {
		var location = [];
		var _g = 0;
		var _g1 = this._dataProvider.getLength();
		while(_g < _g1) {
			var i = _g++;
			location[0] = i;
			this.updateItemRendererForLocation(location);
		}
	},
	get_styleContext: function() {
		return GroupListView
	},
	get_layout: function() {
		return this.__layout;
	},
	set_layout: function(value) {
		if(!this.setStyle("layout")) {
			return this.__layout;
		}
		if(this.__layout == value) {
			return this.__layout;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_layout);
		this.__layout = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__layout;
	},
	clearStyle_layout: function() {
		this.set_layout(null);
		return this.get_layout();
	},
	get_customHeaderRendererVariant: function() {
		return this.__customHeaderRendererVariant;
	},
	set_customHeaderRendererVariant: function(value) {
		if(!this.setStyle("customHeaderRendererVariant")) {
			return this.__customHeaderRendererVariant;
		}
		if(this.__customHeaderRendererVariant == value) {
			return this.__customHeaderRendererVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customHeaderRendererVariant);
		this.__customHeaderRendererVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customHeaderRendererVariant;
	},
	clearStyle_customHeaderRendererVariant: function() {
		this.set_customHeaderRendererVariant(null);
		return this.get_customHeaderRendererVariant();
	},
	get_customItemRendererVariant: function() {
		return this.__customItemRendererVariant;
	},
	set_customItemRendererVariant: function(value) {
		if(!this.setStyle("customItemRendererVariant")) {
			return this.__customItemRendererVariant;
		}
		if(this.__customItemRendererVariant == value) {
			return this.__customItemRendererVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customItemRendererVariant);
		this.__customItemRendererVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customItemRendererVariant;
	},
	clearStyle_customItemRendererVariant: function() {
		this.set_customItemRendererVariant(null);
		return this.get_customItemRendererVariant();
	}
});
GroupListView.prototype.__class__ = GroupListView.prototype.constructor = $hxClasses["feathers.controls.GroupListView"] = GroupListView;

// Init



// Statics

GroupListView.defaultUpdateItemRenderer = function(itemRenderer,state) {
	if((js_Boot().default).__implements(itemRenderer,(feathers_core_ITextControl().default))) {
		var textControl = (js_Boot().default).__cast(itemRenderer , (feathers_core_ITextControl().default));
		textControl.set_text(state.text);
	}
}
GroupListView.defaultResetItemRenderer = function(itemRenderer,state) {
	if((js_Boot().default).__implements(itemRenderer,(feathers_core_ITextControl().default))) {
		var textControl = (js_Boot().default).__cast(itemRenderer , (feathers_core_ITextControl().default));
		textControl.set_text(null);
	}
}
GroupListView.__meta__ = { obj : { defaultXmlProperty : ["dataProvider"]}}
GroupListView.CHILD_VARIANT_HEADER_RENDERER = "groupListView_headerRenderer"
GroupListView.CHILD_VARIANT_ITEM_RENDERER = "groupListView_itemRenderer"
GroupListView.VARIANT_BORDERLESS = "borderless"
GroupListView.VARIANT_BORDER = "border"
GroupListView.INVALIDATION_FLAG_ITEM_RENDERER_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("itemRendererFactory")
GroupListView.INVALIDATION_FLAG_HEADER_RENDERER_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("headerRendererFactory")
GroupListView.RESET_ITEM_STATE = new (feathers_data_GroupListViewItemState().default)()

// Export

exports["default"] = GroupListView;

/***/ }),

/***/ "./lib/_gen/feathers/controls/HDividedBox.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/controls/HDividedBox.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.HDividedBox

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_supportClasses_BaseDividedBox() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/BaseDividedBox */ "./lib/_gen/feathers/controls/supportClasses/BaseDividedBox.js");}
function feathers_themes_steel_components_SteelHDividedBoxStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelHDividedBoxStyles */ "./lib/_gen/feathers/themes/steel/components/SteelHDividedBoxStyles.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_layout_HDividedBoxLayout() {return __webpack_require__(/*! ./../../feathers/layout/HDividedBoxLayout */ "./lib/_gen/feathers/layout/HDividedBoxLayout.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_utils_DisplayUtil() {return __webpack_require__(/*! ./../../feathers/utils/DisplayUtil */ "./lib/_gen/feathers/utils/DisplayUtil.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}

// Constructor

var HDividedBox = function() {
	this._fallbackFluidIndex = -1;
	this._customItemWidths = [];
	this.initializeHDividedBoxTheme();
	(feathers_controls_supportClasses_BaseDividedBox().default).call(this);
}

// Meta

HDividedBox.__name__ = "feathers.controls.HDividedBox";
HDividedBox.__isInterface__ = false;
HDividedBox.__super__ = (feathers_controls_supportClasses_BaseDividedBox().default);
HDividedBox.prototype = $extend((feathers_controls_supportClasses_BaseDividedBox().default).prototype, {
	initializeHDividedBoxTheme: function() {
		(feathers_themes_steel_components_SteelHDividedBoxStyles().default).initialize();
	},
	addItemAt: function(child,index) {
		var result = (feathers_controls_supportClasses_BaseDividedBox().default).prototype.addItemAt.call(this,child,index);
		var explicitWidth = null;
		if((js_Boot().default).__implements(child,(feathers_core_IMeasureObject().default))) {
			var measureChild = (js_Boot().default).__cast(child , (feathers_core_IMeasureObject().default));
			explicitWidth = measureChild.get_explicitWidth();
		}
		this._customItemWidths.splice(index,0,explicitWidth);
		var layoutIndex = this._layoutItems.indexOf(child);
		if(explicitWidth == null) {
			if(this._fallbackFluidIndex == -1 || layoutIndex > this._fallbackFluidIndex) {
				this._fallbackFluidIndex = layoutIndex;
			}
		}
		return result;
	},
	removeItem: function(child) {
		var index = this.items.indexOf(child);
		var layoutIndex = this._layoutItems.indexOf(child);
		if(this._fallbackFluidIndex == layoutIndex) {
			this._fallbackFluidIndex = -1;
		}
		var result = (feathers_controls_supportClasses_BaseDividedBox().default).prototype.removeItem.call(this,child);
		if(index != -1) {
			this._customItemWidths.splice(index,1);
		}
		return result;
	},
	initialize: function() {
		(feathers_controls_supportClasses_BaseDividedBox().default).prototype.initialize.call(this);
		if(this._hDividedBoxLayout == null) {
			this._hDividedBoxLayout = new (feathers_layout_HDividedBoxLayout().default)();
		}
		this._hDividedBoxLayout.set_customItemWidths(this._customItemWidths);
		this.layout = this._hDividedBoxLayout;
	},
	handleLayout: function() {
		var oldIgnoreChildChanges = this._ignoreChildChanges;
		this._ignoreChildChanges = true;
		this._hDividedBoxLayout.set_fallbackFluidIndex(this._fallbackFluidIndex);
		this._ignoreChildChanges = oldIgnoreChildChanges;
		(feathers_controls_supportClasses_BaseDividedBox().default).prototype.handleLayout.call(this);
	},
	prepareResize: function(dividerIndex,stageX,stageY) {
		this._resizeStartStageX = stageX;
		var firstItem = this.items[dividerIndex];
		var secondItem = this.items[dividerIndex + 1];
		this._resizeStartWidth1 = firstItem.get_width();
		this._resizeStartWidth2 = secondItem.get_width();
		if(this._currentResizeDraggingSkin != null) {
			var divider = this.dividers[dividerIndex];
			this._currentResizeDraggingSkin.set_y(divider.get_y());
			this._currentResizeDraggingSkin.set_height(divider.get_height());
			if((js_Boot().default).__implements(this._currentResizeDraggingSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentResizeDraggingSkin , (feathers_core_IValidating().default))).validateNow();
			}
			this._currentResizeDraggingSkin.set_x(divider.get_x() + (divider.get_width() - this._currentResizeDraggingSkin.get_width()) / 2.0);
		}
	},
	commitResize: function(dividerIndex,stageX,stageY,live) {
		var offsetX = stageX - this._resizeStartStageX;
		offsetX *= (feathers_utils_DisplayUtil().default).getConcatenatedScaleX(this);
		if(live && !this.liveDragging) {
			if(this._currentResizeDraggingSkin != null) {
				var divider = this.dividers[dividerIndex];
				this._currentResizeDraggingSkin.set_y(divider.get_y());
				this._currentResizeDraggingSkin.set_height(divider.get_height());
				if((js_Boot().default).__implements(this._currentResizeDraggingSkin,(feathers_core_IValidating().default))) {
					((js_Boot().default).__cast(this._currentResizeDraggingSkin , (feathers_core_IValidating().default))).validateNow();
				}
				this._currentResizeDraggingSkin.set_x(divider.get_x() + offsetX + (divider.get_width() - this._currentResizeDraggingSkin.get_width()) / 2.0);
			}
			return;
		}
		var firstItem = this.items[dividerIndex];
		var secondItem = this.items[dividerIndex + 1];
		var totalWidth = this._resizeStartWidth1 + this._resizeStartWidth2;
		var secondItemWidth = this._resizeStartWidth2 - offsetX;
		if((js_Boot().default).__implements(secondItem,(feathers_core_IMeasureObject().default))) {
			var secondMeasureItem = (js_Boot().default).__cast(secondItem , (feathers_core_IMeasureObject().default));
			if(secondMeasureItem.get_explicitMinWidth() != null && secondItemWidth < secondMeasureItem.get_explicitMinWidth()) {
				secondItemWidth = secondMeasureItem.get_explicitMinWidth();
			} else if(secondMeasureItem.get_explicitMaxWidth() != null && secondItemWidth > secondMeasureItem.get_explicitMaxWidth()) {
				secondItemWidth = secondMeasureItem.get_explicitMaxWidth();
			}
		}
		if(secondItemWidth < 0.0) {
			secondItemWidth = 0.0;
		} else if(secondItemWidth > totalWidth) {
			secondItemWidth = totalWidth;
		}
		var firstItemWidth = totalWidth - secondItemWidth;
		if((js_Boot().default).__implements(firstItem,(feathers_core_IMeasureObject().default))) {
			var firstMeasureItem = (js_Boot().default).__cast(firstItem , (feathers_core_IMeasureObject().default));
			if(firstMeasureItem.get_explicitMinWidth() != null && firstItemWidth < firstMeasureItem.get_explicitMinWidth()) {
				firstItemWidth = firstMeasureItem.get_explicitMinWidth();
			} else if(firstMeasureItem.get_explicitMaxWidth() != null && firstItemWidth > firstMeasureItem.get_explicitMaxWidth()) {
				firstItemWidth = firstMeasureItem.get_explicitMaxWidth();
			}
		}
		if(firstItemWidth < 0.0) {
			firstItemWidth = 0.0;
		} else if(firstItemWidth > totalWidth) {
			firstItemWidth = totalWidth;
		}
		secondItemWidth = totalWidth - firstItemWidth;
		this._customItemWidths[dividerIndex] = firstItemWidth;
		this._customItemWidths[dividerIndex + 1] = secondItemWidth;
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	}
});
HDividedBox.prototype.__class__ = HDividedBox.prototype.constructor = $hxClasses["feathers.controls.HDividedBox"] = HDividedBox;

// Init



// Statics




// Export

exports["default"] = HDividedBox;

/***/ }),

/***/ "./lib/_gen/feathers/controls/HProgressBar.js":
/*!****************************************************!*\
  !*** ./lib/_gen/feathers/controls/HProgressBar.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.HProgressBar

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_supportClasses_BaseProgressBar() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/BaseProgressBar */ "./lib/_gen/feathers/controls/supportClasses/BaseProgressBar.js");}
function feathers_themes_steel_components_SteelHProgressBarStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelHProgressBarStyles */ "./lib/_gen/feathers/themes/steel/components/SteelHProgressBarStyles.js");}
function feathers_utils_MeasurementsUtil() {return __webpack_require__(/*! ./../../feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_graphics_FillStyle() {return __webpack_require__(/*! ./../../feathers/graphics/FillStyle */ "./lib/_gen/feathers/graphics/FillStyle.js");}
function openfl_geom_Rectangle() {return (__webpack_require__(/*! openfl */ "openfl").geom.Rectangle);}

// Constructor

var HProgressBar = function(value,minimum,maximum,changeListener) {
	if(maximum == null) {
		maximum = 1.0;
	}
	if(minimum == null) {
		minimum = 0.0;
	}
	if(value == null) {
		value = 0.0;
	}
	this.initializeHProgressBarTheme();
	(feathers_controls_supportClasses_BaseProgressBar().default).call(this,value,minimum,maximum,changeListener);
}

// Meta

HProgressBar.__name__ = "feathers.controls.HProgressBar";
HProgressBar.__isInterface__ = false;
HProgressBar.__super__ = (feathers_controls_supportClasses_BaseProgressBar().default);
HProgressBar.prototype = $extend((feathers_controls_supportClasses_BaseProgressBar().default).prototype, {
	initializeHProgressBarTheme: function() {
		(feathers_themes_steel_components_SteelHProgressBarStyles().default).initialize();
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		if(this._backgroundSkinMeasurements != null) {
			(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParent(this._backgroundSkinMeasurements,this._currentBackgroundSkin,this);
		}
		var measureBackgroundSkin = null;
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IMeasureObject().default))) {
			measureBackgroundSkin = (js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IMeasureObject().default));
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			if(this._currentBackgroundSkin != null) {
				newWidth = this._backgroundSkinMeasurements.width;
			} else {
				newWidth = 0.0;
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			if(this._currentBackgroundSkin != null) {
				newHeight = this._backgroundSkinMeasurements.height;
			} else {
				newHeight = 0.0;
			}
		}
		var newMinWidth = this.get_explicitMinWidth();
		var needsMinWidth1 = needsMinWidth;
		var newMinHeight = this.get_explicitMinHeight();
		var needsMinHeight1 = needsMinHeight;
		var newMaxWidth = this.get_explicitMaxWidth();
		var needsMaxWidth1 = needsMaxWidth;
		var newMaxHeight = this.get_explicitMaxHeight();
		var needsMaxHeight1 = needsMaxHeight;
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight,newMaxWidth,newMaxHeight);
	},
	layoutBackground: function() {
		if(this._currentBackgroundSkin == null) {
			return;
		}
		this._currentBackgroundSkin.set_x(0.0);
		this._currentBackgroundSkin.set_y(0.0);
		if(this._currentBackgroundSkin.get_width() != this.actualWidth) {
			this._currentBackgroundSkin.set_width(this.actualWidth);
		}
		if(this._currentBackgroundSkin.get_height() != this.actualHeight) {
			this._currentBackgroundSkin.set_height(this.actualHeight);
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
	},
	layoutFill: function() {
		if(this._currentFillSkin == null) {
			return;
		}
		var percentage = 1.0;
		if(this._minimum != this._maximum) {
			percentage = (this._value - this._minimum) / (this._maximum - this._minimum);
			if(percentage < 0.0) {
				percentage = 0.0;
			} else if(percentage > 1.0) {
				percentage = 1.0;
			}
		}
		var calculatedWidth = Math.round(percentage * (this.actualWidth - this.get_paddingLeft() - this.get_paddingRight()));
		this._currentFillSkin.set_x(this.get_paddingLeft());
		this._currentFillSkin.set_y(this.get_paddingTop());
		this._currentFillSkin.set_height(this.actualHeight - this.get_paddingTop() - this.get_paddingBottom());
		switch(this.get_fillMode()._hx_index) {
		case 0:
			this._currentFillSkin.set_scrollRect(null);
			if(this._currentMask == null) {
				this._currentMask = new (feathers_skins_RectangleSkin().default)((feathers_graphics_FillStyle().default).SolidColor(16711935));
				this.addChild(this._currentMask);
			}
			this._currentFillSkin.set_mask(this._currentMask);
			this._currentFillSkin.set_width(this.actualWidth - this.get_paddingLeft() - this.get_paddingRight());
			this._currentMask.set_x(this._currentFillSkin.get_x());
			this._currentMask.set_y(this._currentFillSkin.get_y());
			this._currentMask.set_width(calculatedWidth);
			this._currentMask.set_height(this._currentFillSkin.get_height());
			break;
		case 1:
			this._currentFillSkin.set_width(this.actualWidth - this.get_paddingLeft() - this.get_paddingRight());
			this._currentFillSkin.set_scrollRect(new (openfl_geom_Rectangle())(0.0,0.0,calculatedWidth,this._currentFillSkin.get_height()));
			break;
		case 2:
			this._currentFillSkin.set_mask(null);
			this._currentFillSkin.set_scrollRect(null);
			if(this._currentMask != null) {
				if(this._currentMask.parent == this) {
					this.removeChild(this._currentMask);
				}
				this._currentMask = null;
			}
			if(this._fillSkinMeasurements.minWidth != null && calculatedWidth < this._fillSkinMeasurements.minWidth) {
				calculatedWidth = this._fillSkinMeasurements.minWidth;
				this._currentFillSkin.set_visible(this._value > this._minimum);
			} else {
				this._currentFillSkin.set_visible(true);
			}
			this._currentFillSkin.set_width(calculatedWidth);
			break;
		}
		if((js_Boot().default).__implements(this._currentFillSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentFillSkin , (feathers_core_IValidating().default))).validateNow();
		}
	},
	get_styleContext: function() {
		return HProgressBar
	}
});
HProgressBar.prototype.__class__ = HProgressBar.prototype.constructor = $hxClasses["feathers.controls.HProgressBar"] = HProgressBar;

// Init



// Statics




// Export

exports["default"] = HProgressBar;

/***/ }),

/***/ "./lib/_gen/feathers/controls/HScrollBar.js":
/*!**************************************************!*\
  !*** ./lib/_gen/feathers/controls/HScrollBar.js ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.HScrollBar

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_supportClasses_BaseScrollBar() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/BaseScrollBar */ "./lib/_gen/feathers/controls/supportClasses/BaseScrollBar.js");}
function feathers_themes_steel_components_SteelHScrollBarStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelHScrollBarStyles */ "./lib/_gen/feathers/themes/steel/components/SteelHScrollBarStyles.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}

// Constructor

var HScrollBar = function(value,minimum,maximum,changeListener) {
	if(maximum == null) {
		maximum = 1.0;
	}
	if(minimum == null) {
		minimum = 0.0;
	}
	if(value == null) {
		value = 0.0;
	}
	this.initializeHScrollBarTheme();
	(feathers_controls_supportClasses_BaseScrollBar().default).call(this,value,minimum,maximum,changeListener);
}

// Meta

HScrollBar.__name__ = "feathers.controls.HScrollBar";
HScrollBar.__isInterface__ = false;
HScrollBar.__super__ = (feathers_controls_supportClasses_BaseScrollBar().default);
HScrollBar.prototype = $extend((feathers_controls_supportClasses_BaseScrollBar().default).prototype, {
	initializeHScrollBarTheme: function() {
		(feathers_themes_steel_components_SteelHScrollBarStyles().default).initialize();
	},
	valueToLocation: function(value) {
		if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IValidating().default))).validateNow();
		}
		var normalized = this.normalizeValue(value);
		var trackScrollableWidth = this.actualWidth - this.get_paddingLeft() - this.get_paddingRight() - this._currentThumbSkin.get_width();
		return this.get_paddingLeft() + trackScrollableWidth * normalized;
	},
	locationToValue: function(x,y) {
		var percentage = 0.0;
		var trackScrollableWidth = this.actualWidth - this.get_paddingLeft() - this.get_paddingRight() - this._currentThumbSkin.get_width();
		var xOffset = x - this._pointerStartX;
		var xPosition = Math.min(Math.max(0.0,this._thumbStartX - this.get_paddingLeft() + xOffset),trackScrollableWidth);
		percentage = xPosition / trackScrollableWidth;
		return this._minimum + percentage * (this._maximum - this._minimum);
	},
	saveThumbStart: function(x,y) {
		var trackWidthMinusThumbWidth = this.actualWidth;
		var locationMinusHalfThumbWidth = x;
		if(this._currentThumbSkin != null) {
			trackWidthMinusThumbWidth -= this._currentThumbSkin.get_width();
			locationMinusHalfThumbWidth -= this._currentThumbSkin.get_width() / 2.0;
		}
		this._thumbStartX = Math.min(trackWidthMinusThumbWidth,locationMinusHalfThumbWidth);
		this._thumbStartY = y;
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		if(this._currentThumbSkin != null) {
			this._thumbSkinMeasurements.restore(this._currentThumbSkin);
			if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IValidating().default))).validateNow();
			}
		}
		if(this._currentTrackSkin != null) {
			this._trackSkinMeasurements.restore(this._currentTrackSkin);
			if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentTrackSkin , (feathers_core_IValidating().default))).validateNow();
			}
		}
		if(this._currentSecondaryTrackSkin != null) {
			this._secondaryTrackSkinMeasurements.restore(this._currentSecondaryTrackSkin);
			if((js_Boot().default).__implements(this._currentSecondaryTrackSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentSecondaryTrackSkin , (feathers_core_IValidating().default))).validateNow();
			}
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			newWidth = 0.0;
			if(this._currentTrackSkin != null) {
				newWidth += this._currentTrackSkin.get_width();
				if(this._currentSecondaryTrackSkin != null) {
					newWidth += this._currentSecondaryTrackSkin.get_width();
				}
			}
			var thumbWidth = this.get_paddingLeft() + this.get_paddingRight();
			if(this._currentThumbSkin != null) {
				thumbWidth += this._currentThumbSkin.get_width();
			}
			if(newWidth < thumbWidth) {
				newWidth = thumbWidth;
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			newHeight = this.get_paddingTop() + this.get_paddingBottom();
			if(this._currentThumbSkin != null) {
				newHeight += this._currentThumbSkin.get_height();
			}
			if(this._currentTrackSkin != null) {
				if(newHeight < this._currentTrackSkin.get_height()) {
					newHeight = this._currentTrackSkin.get_height();
				}
				if(this._currentSecondaryTrackSkin != null && newHeight < this._currentSecondaryTrackSkin.get_height()) {
					newHeight = this._currentSecondaryTrackSkin.get_height();
				}
			}
		}
		var newMinWidth = newWidth;
		var newMinHeight = newHeight;
		var newMaxHeight = newHeight;
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight,null,newMaxHeight);
	},
	layoutSplitTrack: function() {
		var location = this.valueToLocation(this.get_value());
		if(this._currentThumbSkin != null) {
			if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IValidating().default))).validateNow();
			}
			location += Math.round(this._currentThumbSkin.get_width() / 2.0);
		}
		this._currentTrackSkin.set_x(0.0);
		this._currentTrackSkin.set_width(location);
		this._currentSecondaryTrackSkin.set_x(location);
		this._currentSecondaryTrackSkin.set_width(this.actualWidth - location);
		if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentTrackSkin , (feathers_core_IValidating().default))).validateNow();
		}
		if((js_Boot().default).__implements(this._currentSecondaryTrackSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentSecondaryTrackSkin , (feathers_core_IValidating().default))).validateNow();
		}
		this._currentTrackSkin.set_y((this.actualHeight - this._currentTrackSkin.get_height()) / 2.0);
		this._currentSecondaryTrackSkin.set_y((this.actualHeight - this._currentSecondaryTrackSkin.get_height()) / 2.0);
	},
	layoutSingleTrack: function() {
		if(this._currentTrackSkin == null) {
			return;
		}
		this._currentTrackSkin.set_x(0.0);
		this._currentTrackSkin.set_width(this.actualWidth);
		if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentTrackSkin , (feathers_core_IValidating().default))).validateNow();
		}
		this._currentTrackSkin.set_y((this.actualHeight - this._currentTrackSkin.get_height()) / 2.0);
	},
	layoutThumb: function() {
		if(this._currentThumbSkin == null) {
			return;
		}
		var range = this._maximum - this._minimum;
		this._currentThumbSkin.set_visible((!this.get_hideThumbWhenDisabled() || this._enabled) && range > 0.0);
		if(!this._currentThumbSkin.get_visible()) {
			return;
		}
		if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IValidating().default))).validateNow();
		}
		var valueOffset = 0.0;
		if(this._value < this._minimum) {
			valueOffset = this._minimum - this._value;
		} else if(this._value > this._maximum) {
			valueOffset = this._value - this._maximum;
		}
		var contentWidth = this.actualWidth - this.get_paddingLeft() - this.get_paddingRight();
		var contentHeight = this.actualHeight - this.get_paddingTop() - this.get_paddingBottom();
		if(this.get_fixedThumbSize()) {
			if(this._thumbSkinMeasurements.width != null) {
				this._currentThumbSkin.set_width(this._thumbSkinMeasurements.width);
			}
		} else {
			var adjustedPage = this.getAdjustedPage();
			var thumbWidth = contentWidth * adjustedPage / (range + adjustedPage);
			if(thumbWidth > 0.0) {
				var widthOffset = contentWidth - thumbWidth;
				if(widthOffset > thumbWidth) {
					widthOffset = thumbWidth;
				}
				widthOffset *= valueOffset / (range * thumbWidth / contentWidth);
				thumbWidth -= widthOffset;
			}
			if(this._thumbSkinMeasurements.minWidth != null) {
				if(thumbWidth < this._thumbSkinMeasurements.minWidth) {
					thumbWidth = this._thumbSkinMeasurements.minWidth;
				}
			} else if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IMeasureObject().default))) {
				var measureSkin = (js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IMeasureObject().default));
				if(thumbWidth < measureSkin.get_minWidth()) {
					thumbWidth = measureSkin.get_minWidth();
				}
			}
			if(thumbWidth < 0.0) {
				thumbWidth = 0.0;
			}
			this._currentThumbSkin.set_width(thumbWidth);
		}
		this._currentThumbSkin.set_x(this.valueToLocation(this._value));
		this._currentThumbSkin.set_y(this.get_paddingTop() + (contentHeight - this._currentThumbSkin.get_height()) / 2.0);
	},
	get_styleContext: function() {
		return HScrollBar
	}
});
HScrollBar.prototype.__class__ = HScrollBar.prototype.constructor = $hxClasses["feathers.controls.HScrollBar"] = HScrollBar;

// Init



// Statics




// Export

exports["default"] = HScrollBar;

/***/ }),

/***/ "./lib/_gen/feathers/controls/HSlider.js":
/*!***********************************************!*\
  !*** ./lib/_gen/feathers/controls/HSlider.js ***!
  \***********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.HSlider

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_supportClasses_BaseSlider() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/BaseSlider */ "./lib/_gen/feathers/controls/supportClasses/BaseSlider.js");}
function feathers_themes_steel_components_SteelHSliderStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelHSliderStyles */ "./lib/_gen/feathers/themes/steel/components/SteelHSliderStyles.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}

// Constructor

var HSlider = function(value,minimum,maximum,changeListener) {
	if(maximum == null) {
		maximum = 1.0;
	}
	if(minimum == null) {
		minimum = 0.0;
	}
	if(value == null) {
		value = 0.0;
	}
	this.initializeHSliderTheme();
	(feathers_controls_supportClasses_BaseSlider().default).call(this,value,minimum,maximum,changeListener);
	this.addEventListener("keyDown",$bind(this,this.hSlider_keyDownHandler));
}

// Meta

HSlider.__name__ = "feathers.controls.HSlider";
HSlider.__isInterface__ = false;
HSlider.__super__ = (feathers_controls_supportClasses_BaseSlider().default);
HSlider.prototype = $extend((feathers_controls_supportClasses_BaseSlider().default).prototype, {
	initializeHSliderTheme: function() {
		(feathers_themes_steel_components_SteelHSliderStyles().default).initialize();
	},
	valueToLocation: function(value) {
		if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IValidating().default))).validateNow();
		}
		var normalized = this.normalizeValue(value);
		var trackScrollableWidth = this.actualWidth - this.get_minimumPadding() - this.get_maximumPadding();
		if(this._currentThumbSkin != null) {
			trackScrollableWidth -= this._currentThumbSkin.get_width();
		}
		return Math.round(this.get_minimumPadding() + trackScrollableWidth * normalized);
	},
	locationToValue: function(x,y) {
		var percentage = 0.0;
		var trackScrollableWidth = this.actualWidth - this.get_minimumPadding() - this.get_maximumPadding();
		if(this._currentThumbSkin != null) {
			trackScrollableWidth -= this._currentThumbSkin.get_width();
		}
		var xOffset = x - this._pointerStartX - this.get_minimumPadding();
		var xPosition = Math.min(Math.max(0.0,this._thumbStartX + xOffset),trackScrollableWidth);
		percentage = xPosition / trackScrollableWidth;
		return this._minimum + percentage * (this._maximum - this._minimum);
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		if(this._currentThumbSkin != null) {
			this._thumbSkinMeasurements.restore(this._currentThumbSkin);
			if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IValidating().default))).validateNow();
			}
		}
		if(this._currentTrackSkin != null) {
			this._trackSkinMeasurements.restore(this._currentTrackSkin);
			if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentTrackSkin , (feathers_core_IValidating().default))).validateNow();
			}
		}
		if(this._currentSecondaryTrackSkin != null) {
			this._secondaryTrackSkinMeasurements.restore(this._currentSecondaryTrackSkin);
			if((js_Boot().default).__implements(this._currentSecondaryTrackSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentSecondaryTrackSkin , (feathers_core_IValidating().default))).validateNow();
			}
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			newWidth = 0.0;
			if(this._currentTrackSkin != null) {
				newWidth += this._currentTrackSkin.get_width();
				if(this._currentSecondaryTrackSkin != null) {
					newWidth += this._currentSecondaryTrackSkin.get_width();
				}
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			newHeight = 0.0;
			if(this._currentThumbSkin != null) {
				newHeight += this._currentThumbSkin.get_height();
			}
			if(this._currentTrackSkin != null) {
				if(newHeight < this._currentTrackSkin.get_height()) {
					newHeight = this._currentTrackSkin.get_height();
				}
				if(this._currentSecondaryTrackSkin != null && newHeight < this._currentSecondaryTrackSkin.get_height()) {
					newHeight = this._currentSecondaryTrackSkin.get_height();
				}
			}
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			newMinWidth = 0.0;
			if(this._currentTrackSkin != null) {
				newMinWidth += this._currentTrackSkin.get_width();
				if(this._currentSecondaryTrackSkin != null) {
					newMinWidth += this._secondaryTrackSkinMeasurements.width;
				}
			}
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			newMinHeight = 0.0;
			if(this._currentThumbSkin != null) {
				newMinHeight += this._currentThumbSkin.get_height();
			}
			if(this._currentTrackSkin != null) {
				if(newMinHeight < this._currentTrackSkin.get_height()) {
					newMinHeight = this._currentTrackSkin.get_height();
				}
				if(this._currentSecondaryTrackSkin != null && newHeight < this._currentSecondaryTrackSkin.get_height()) {
					newMinHeight = this._currentSecondaryTrackSkin.get_height();
				}
			}
		}
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight);
	},
	saveThumbStart: function(x,y) {
		var trackWidthMinusThumbWidth = this.actualWidth;
		var locationMinusHalfThumbWidth = x;
		if(this._currentThumbSkin != null) {
			trackWidthMinusThumbWidth -= this._currentThumbSkin.get_width();
			locationMinusHalfThumbWidth -= this._currentThumbSkin.get_width() / 2.0;
		}
		this._thumbStartX = Math.min(trackWidthMinusThumbWidth - this.get_maximumPadding(),Math.max(this.get_minimumPadding(),locationMinusHalfThumbWidth));
		this._thumbStartY = y;
	},
	layoutSplitTrack: function() {
		var location = this.valueToLocation(this.get_value());
		if(this._currentThumbSkin != null) {
			if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IValidating().default))).validateNow();
			}
			location += Math.round(this._currentThumbSkin.get_width() / 2.0);
		}
		this._currentTrackSkin.set_x(0.0);
		this._currentTrackSkin.set_width(location);
		this._currentSecondaryTrackSkin.set_x(location);
		this._currentSecondaryTrackSkin.set_width(this.actualWidth - location);
		if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentTrackSkin , (feathers_core_IValidating().default))).validateNow();
		}
		if((js_Boot().default).__implements(this._currentSecondaryTrackSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentSecondaryTrackSkin , (feathers_core_IValidating().default))).validateNow();
		}
		this._currentTrackSkin.set_y((this.actualHeight - this._currentTrackSkin.get_height()) / 2.0);
		this._currentSecondaryTrackSkin.set_y((this.actualHeight - this._currentSecondaryTrackSkin.get_height()) / 2.0);
	},
	layoutSingleTrack: function() {
		if(this._currentTrackSkin == null) {
			return;
		}
		this._currentTrackSkin.set_x(0.0);
		this._currentTrackSkin.set_width(this.actualWidth);
		if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentTrackSkin , (feathers_core_IValidating().default))).validateNow();
		}
		this._currentTrackSkin.set_y((this.actualHeight - this._currentTrackSkin.get_height()) / 2.0);
	},
	layoutThumb: function() {
		if(this._currentThumbSkin == null) {
			return;
		}
		var thumbLocation = this.valueToLocation(this._value);
		this._currentThumbSkin.set_x(thumbLocation);
		this._currentThumbSkin.set_y((this.actualHeight - this.get_thumbSkin().get_height()) / 2.0);
	},
	hSlider_keyDownHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(event.isDefaultPrevented()) {
			return;
		}
		var newValue = this._value;
		switch(event.keyCode) {
		case 35:
			newValue = this._maximum;
			break;
		case 36:
			newValue = this._minimum;
			break;
		case 37:
			newValue -= this._step;
			break;
		case 39:
			newValue += this._step;
			break;
		default:
			return;
		}
		if(newValue < this._minimum) {
			newValue = this._minimum;
		} else if(newValue > this._maximum) {
			newValue = this._maximum;
		}
		event.preventDefault();
		this.set_value(newValue);
	},
	get_styleContext: function() {
		return HSlider
	}
});
HSlider.prototype.__class__ = HSlider.prototype.constructor = $hxClasses["feathers.controls.HSlider"] = HSlider;

// Init



// Statics




// Export

exports["default"] = HSlider;

/***/ }),

/***/ "./lib/_gen/feathers/controls/Header.js":
/*!**********************************************!*\
  !*** ./lib/_gen/feathers/controls/Header.js ***!
  \**********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.Header

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_ITextControl() {return __webpack_require__(/*! ./../../feathers/core/ITextControl */ "./lib/_gen/feathers/core/ITextControl.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_themes_steel_components_SteelHeaderStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelHeaderStyles */ "./lib/_gen/feathers/themes/steel/components/SteelHeaderStyles.js");}
function openfl_text_TextField() {return (__webpack_require__(/*! openfl */ "openfl").text.TextField);}
function feathers_utils_MeasurementsUtil() {return __webpack_require__(/*! ./../../feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}

// Constructor

var Header = function(text) {
	if(text == null) {
		text = "";
	}
	this.__verticalAlign = (feathers_layout_VerticalAlign().default).MIDDLE;
	this.__minGap = 0.0;
	this.__paddingLeft = 0.0;
	this.__paddingBottom = 0.0;
	this.__paddingRight = 0.0;
	this.__paddingTop = 0.0;
	this.__disabledBackgroundSkin = null;
	this.__backgroundSkin = null;
	this.__disabledTextFormat = null;
	this.__embedFonts = false;
	this.__textFormat = null;
	this._rightView = null;
	this._ignoreRightViewResize = false;
	this._leftView = null;
	this._ignoreLeftViewResize = false;
	this._backgroundSkinMeasurements = null;
	this._currentBackgroundSkin = null;
	this._htmlText = null;
	this._updatedTextStyles = false;
	this._previousSimpleTextFormat = null;
	this._previousTextFormat = null;
	this._previousHTMLText = null;
	this._previousText = null;
	this.initializeHeaderTheme();
	(feathers_core_FeathersControl().default).call(this);
	this.set_text(text);
}

// Meta

Header.__name__ = "feathers.controls.Header";
Header.__isInterface__ = false;
Header.__interfaces__ = [(feathers_core_ITextControl().default)];
Header.__super__ = (feathers_core_FeathersControl().default);
Header.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_text: function() {
		return this._text;
	},
	set_text: function(value) {
		if(value == null) {
			if(this._text.length == 0) {
				return this._text;
			}
			value = "";
		}
		if(this._text == value) {
			return this._text;
		}
		this._text = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._text;
	},
	get_baseline: function() {
		if(this.textField == null) {
			return 0.0;
		}
		var hasText = this._text != null && this._text.length > 0;
		var hasHTMLText = this._htmlText != null && this._htmlText.length > 0;
		if(!hasText && !hasHTMLText) {
			this.textField.set_text("​");
			var result = this.textField.get_y() + this.textField.getLineMetrics(0).ascent;
			this.textField.set_text("");
			return result;
		}
		return this.textField.get_y() + this.textField.getLineMetrics(0).ascent;
	},
	get_htmlText: function() {
		return this._htmlText;
	},
	set_htmlText: function(value) {
		if(this._htmlText == value) {
			return this._htmlText;
		}
		this._htmlText = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._htmlText;
	},
	get_leftView: function() {
		return this._leftView;
	},
	set_leftView: function(value) {
		if(this._leftView == value) {
			return this._leftView;
		}
		if(this._leftView != null) {
			this._leftView.removeEventListener("resize",$bind(this,this.header_leftView_resizeHandler));
			if(this._leftView.parent == this) {
				this.removeChild(this._leftView);
			}
		}
		this._leftView = value;
		if(this._leftView != null) {
			this.addChild(this._leftView);
			this._leftView.addEventListener("resize",$bind(this,this.header_leftView_resizeHandler),false,0,true);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		return this._leftView;
	},
	get_rightView: function() {
		return this._rightView;
	},
	set_rightView: function(value) {
		if(this._rightView == value) {
			return this._rightView;
		}
		if(this._rightView != null) {
			this._rightView.removeEventListener("resize",$bind(this,this.header_rightView_resizeHandler));
			if(this._rightView.parent == this) {
				this.removeChild(this._rightView);
			}
		}
		this._rightView = value;
		if(this._rightView != null) {
			this.addChild(this._rightView);
			this._rightView.addEventListener("resize",$bind(this,this.header_rightView_resizeHandler),false,0,true);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		return this._rightView;
	},
	initializeHeaderTheme: function() {
		(feathers_themes_steel_components_SteelHeaderStyles().default).initialize();
	},
	initialize: function() {
		(feathers_core_FeathersControl().default).prototype.initialize.call(this);
		if(this.textField == null) {
			this.textField = new (openfl_text_TextField())();
			this.textField.set_multiline(true);
			this.textField.set_selectable(false);
			this.addChild(this.textField);
		}
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var selectionInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		var sizeInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SIZE);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		this._updatedTextStyles = false;
		if(stylesInvalid || stateInvalid) {
			this.refreshBackgroundSkin();
		}
		if(stylesInvalid || stateInvalid) {
			this.refreshTextStyles();
		}
		if(dataInvalid || stylesInvalid || stateInvalid || sizeInvalid) {
			this.refreshText(sizeInvalid);
		}
		sizeInvalid = this.measure() || sizeInvalid;
		if(stylesInvalid || stateInvalid || dataInvalid || sizeInvalid) {
			this.layoutContent();
		}
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		var oldIgnoreLeftViewResize = this._ignoreLeftViewResize;
		this._ignoreLeftViewResize = true;
		var oldIgnoreRightViewResize = this._ignoreRightViewResize;
		this._ignoreRightViewResize = true;
		if(this._currentBackgroundSkin != null) {
			(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParent(this._backgroundSkinMeasurements,this._currentBackgroundSkin,this);
		}
		var measureSkin = null;
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IMeasureObject().default))) {
			measureSkin = (js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IMeasureObject().default));
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
		if((js_Boot().default).__implements(this._leftView,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._leftView , (feathers_core_IValidating().default))).validateNow();
		}
		if((js_Boot().default).__implements(this._rightView,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._rightView , (feathers_core_IValidating().default))).validateNow();
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			newWidth = this._textMeasuredWidth + this.get_paddingLeft() + this.get_paddingRight();
			if(this._leftView != null) {
				newWidth += this._leftView.get_width() + this.get_minGap();
			}
			if(this._rightView != null) {
				newWidth += this._rightView.get_width() + this.get_minGap();
			}
			if(this._currentBackgroundSkin != null) {
				newWidth = Math.max(this._currentBackgroundSkin.get_width(),newWidth);
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			newHeight = this._textMeasuredHeight;
			if(this._leftView != null) {
				newHeight = Math.max(newHeight,this._leftView.get_height());
			}
			if(this._rightView != null) {
				newHeight = Math.max(newHeight,this._rightView.get_height());
			}
			newHeight += this.get_paddingTop() + this.get_paddingBottom();
			if(this._currentBackgroundSkin != null) {
				newHeight = Math.max(this._currentBackgroundSkin.get_height(),newHeight);
			}
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			newMinWidth = this._textMeasuredWidth + this.get_paddingLeft() + this.get_paddingRight();
			if(this._leftView != null) {
				newMinWidth += this._leftView.get_width() + this.get_minGap();
			}
			if(this._rightView != null) {
				newMinWidth += this._rightView.get_width() + this.get_minGap();
			}
			if(measureSkin != null) {
				newMinWidth = Math.max(measureSkin.get_minWidth(),newMinWidth);
			} else if(this._backgroundSkinMeasurements != null) {
				newMinWidth = Math.max(this._backgroundSkinMeasurements.minWidth,newMinWidth);
			}
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			newMinHeight = this._textMeasuredHeight;
			if(this._leftView != null) {
				newMinHeight = Math.max(newMinHeight,this._leftView.get_height());
			}
			if(this._rightView != null) {
				newMinHeight = Math.max(newMinHeight,this._rightView.get_height());
			}
			newMinHeight += this.get_paddingTop() + this.get_paddingBottom();
			if(measureSkin != null) {
				newMinHeight = Math.max(measureSkin.get_minHeight(),newMinHeight);
			} else if(this._backgroundSkinMeasurements != null) {
				newMinHeight = Math.max(this._backgroundSkinMeasurements.minHeight,newMinHeight);
			}
		}
		var newMaxWidth = this.get_explicitMaxWidth();
		if(needsMaxWidth) {
			if(measureSkin != null) {
				newMaxWidth = measureSkin.get_maxWidth();
			} else if(this._backgroundSkinMeasurements != null) {
				newMaxWidth = this._backgroundSkinMeasurements.maxWidth;
			} else {
				newMaxWidth = 1.0 / 0.0;
			}
		}
		var newMaxHeight = this.get_explicitMaxHeight();
		if(needsMaxHeight) {
			if(measureSkin != null) {
				newMaxHeight = measureSkin.get_maxHeight();
			} else if(this._backgroundSkinMeasurements != null) {
				newMaxHeight = this._backgroundSkinMeasurements.maxHeight;
			} else {
				newMaxHeight = 1.0 / 0.0;
			}
		}
		this._ignoreLeftViewResize = oldIgnoreLeftViewResize;
		this._ignoreRightViewResize = oldIgnoreRightViewResize;
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight,newMaxWidth,newMaxHeight);
	},
	refreshTextStyles: function() {
		if(this.textField.get_embedFonts() != this.get_embedFonts()) {
			this.textField.set_embedFonts(this.get_embedFonts());
			this._updatedTextStyles = true;
		}
		var textFormat = this.getCurrentTextFormat();
		var simpleTextFormat = textFormat != null ? textFormat.toSimpleTextFormat() : null;
		if(simpleTextFormat == this._previousSimpleTextFormat) {
			return;
		}
		if(this._previousTextFormat != null) {
			this._previousTextFormat.removeEventListener("change",$bind(this,this.header_textFormat_changeHandler));
		}
		if(textFormat != null) {
			textFormat.addEventListener("change",$bind(this,this.header_textFormat_changeHandler),false,0,true);
			this.textField.set_defaultTextFormat(simpleTextFormat);
			this._updatedTextStyles = true;
		}
		this._previousTextFormat = textFormat;
		this._previousSimpleTextFormat = simpleTextFormat;
	},
	refreshText: function(forceMeasurement) {
		var hasText = this._text != null && this._text.length > 0;
		var hasHTMLText = this._htmlText != null && this._htmlText.length > 0;
		this.textField.set_visible(hasText || hasHTMLText);
		if(this._text == this._previousText && this._htmlText == this._previousHTMLText && !this._updatedTextStyles && !forceMeasurement) {
			return;
		}
		this.textField.set_autoSize("left");
		if(hasHTMLText) {
			this.textField.set_htmlText(this._htmlText);
		} else if(hasText) {
			this.textField.set_text(this._text);
		} else {
			this.textField.set_text("​");
		}
		var textFieldWidth = null;
		if(this.get_explicitWidth() != null) {
			textFieldWidth = this.get_explicitWidth();
		} else if(this.get_explicitMaxWidth() != null) {
			textFieldWidth = this.get_explicitMaxWidth();
		}
		if(textFieldWidth != null) {
			this.textField.set_width(textFieldWidth);
		}
		this._textMeasuredWidth = this.textField.get_width();
		this._textMeasuredHeight = this.textField.get_height();
		this.textField.set_autoSize("none");
		if(!hasText && !hasHTMLText) {
			this.textField.set_text("");
		}
		this._previousText = this._text;
		this._previousHTMLText = this._htmlText;
	},
	getCurrentTextFormat: function() {
		if(!this._enabled && this.get_disabledTextFormat() != null) {
			return this.get_disabledTextFormat();
		}
		return this.get_textFormat();
	},
	refreshBackgroundSkin: function() {
		var oldSkin = this._currentBackgroundSkin;
		this._currentBackgroundSkin = this.getCurrentBackgroundSkin();
		if(this._currentBackgroundSkin == oldSkin) {
			return;
		}
		this.removeCurrentBackgroundSkin(oldSkin);
		this.addCurrentBackgroundSkin(this._currentBackgroundSkin);
	},
	getCurrentBackgroundSkin: function() {
		if(!this._enabled && this.get_disabledBackgroundSkin() != null) {
			return this.get_disabledBackgroundSkin();
		}
		return this.get_backgroundSkin();
	},
	addCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			this._backgroundSkinMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._backgroundSkinMeasurements == null) {
			this._backgroundSkinMeasurements = new (feathers_layout_Measurements().default)(skin);
		} else {
			this._backgroundSkinMeasurements.save(skin);
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this.addChildAt(skin,0);
	},
	removeCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		this._backgroundSkinMeasurements.restore(skin);
		if(skin.parent == this) {
			this.removeChild(skin);
		}
	},
	layoutContent: function() {
		this.layoutBackgroundSkin();
		var textFieldMinX = this.get_paddingLeft();
		var textFieldMaxX = this.actualWidth - this.get_paddingRight();
		var maxContentWidth = this.actualWidth - this.get_paddingLeft() - this.get_paddingRight();
		var maxContentHeight = this.actualHeight - this.get_paddingTop() - this.get_paddingBottom();
		var textFieldMaxWidth = maxContentWidth;
		if(this._leftView != null) {
			if((js_Boot().default).__implements(this._leftView,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._leftView , (feathers_core_IValidating().default))).validateNow();
			}
			this._leftView.set_x(this.get_paddingLeft());
			switch(this.get_verticalAlign()._hx_index) {
			case 0:
				this._leftView.set_y(this.get_paddingTop());
				break;
			case 2:
				this._leftView.set_y(this.actualHeight - this.get_paddingBottom() - this._leftView.get_height());
				break;
			default:
				this._leftView.set_y(this.get_paddingTop() + (maxContentHeight - this._leftView.get_height()) / 2.0);
			}
			textFieldMaxWidth -= this._leftView.get_width() + this.get_minGap();
			textFieldMinX = this._leftView.get_x() + this._leftView.get_width() + this.get_minGap();
		}
		if(this._rightView != null) {
			if((js_Boot().default).__implements(this._rightView,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._rightView , (feathers_core_IValidating().default))).validateNow();
			}
			this._rightView.set_x(this.actualWidth - this.get_paddingRight() - this._rightView.get_width());
			switch(this.get_verticalAlign()._hx_index) {
			case 0:
				this._rightView.set_y(this.get_paddingTop());
				break;
			case 2:
				this._rightView.set_y(this.actualHeight - this.get_paddingBottom() - this._rightView.get_height());
				break;
			default:
				this._rightView.set_y(this.get_paddingTop() + (maxContentHeight - this._rightView.get_height()) / 2.0);
			}
			textFieldMaxWidth -= this._rightView.get_width() + this.get_minGap();
			textFieldMaxX = this._rightView.get_x() - this.get_minGap();
		}
		var textFieldWidth = this._textMeasuredWidth;
		if(textFieldWidth > textFieldMaxWidth) {
			textFieldWidth = textFieldMaxWidth;
		}
		this.textField.set_width(textFieldWidth);
		textFieldMaxX -= textFieldWidth;
		var textFieldHeight = this._textMeasuredHeight;
		if(textFieldHeight > maxContentHeight) {
			textFieldHeight = maxContentHeight;
		}
		this.textField.set_height(textFieldHeight);
		var textFieldX = this.get_paddingLeft() + (maxContentWidth - textFieldWidth) / 2.0;
		if(textFieldX < textFieldMinX) {
			textFieldX = textFieldMinX;
		} else if(textFieldX > textFieldMaxX) {
			textFieldX = textFieldMaxX;
		}
		this.textField.set_x(textFieldX);
		switch(this.get_verticalAlign()._hx_index) {
		case 0:
			this.textField.set_y(this.get_paddingTop());
			break;
		case 2:
			this.textField.set_y(this.actualHeight - this.get_paddingBottom() - textFieldHeight);
			break;
		default:
			this.textField.set_y(this.get_paddingTop() + (maxContentHeight - textFieldHeight) / 2.0);
		}
	},
	layoutBackgroundSkin: function() {
		if(this._currentBackgroundSkin == null) {
			return;
		}
		this._currentBackgroundSkin.set_x(0.0);
		this._currentBackgroundSkin.set_y(0.0);
		if(this._currentBackgroundSkin.get_width() != this.actualWidth) {
			this._currentBackgroundSkin.set_width(this.actualWidth);
		}
		if(this._currentBackgroundSkin.get_height() != this.actualHeight) {
			this._currentBackgroundSkin.set_height(this.actualHeight);
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
	},
	header_textFormat_changeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	header_leftView_resizeHandler: function(event) {
		if(this._ignoreLeftViewResize) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	header_rightView_resizeHandler: function(event) {
		if(this._ignoreRightViewResize) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	get_textFormat: function() {
		return this.__textFormat;
	},
	set_textFormat: function(value) {
		if(!this.setStyle("textFormat")) {
			return this.__textFormat;
		}
		if(this.__textFormat == value) {
			return this.__textFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_textFormat);
		this.__textFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__textFormat;
	},
	clearStyle_textFormat: function() {
		this.set_textFormat(null);
		return this.get_textFormat();
	},
	get_embedFonts: function() {
		return this.__embedFonts;
	},
	set_embedFonts: function(value) {
		if(!this.setStyle("embedFonts")) {
			return this.__embedFonts;
		}
		if(this.__embedFonts == value) {
			return this.__embedFonts;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_embedFonts);
		this.__embedFonts = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__embedFonts;
	},
	clearStyle_embedFonts: function() {
		this.set_embedFonts(false);
		return this.get_embedFonts();
	},
	get_disabledTextFormat: function() {
		return this.__disabledTextFormat;
	},
	set_disabledTextFormat: function(value) {
		if(!this.setStyle("disabledTextFormat")) {
			return this.__disabledTextFormat;
		}
		if(this.__disabledTextFormat == value) {
			return this.__disabledTextFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledTextFormat);
		this.__disabledTextFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledTextFormat;
	},
	clearStyle_disabledTextFormat: function() {
		this.set_disabledTextFormat(null);
		return this.get_disabledTextFormat();
	},
	get_backgroundSkin: function() {
		return this.__backgroundSkin;
	},
	set_backgroundSkin: function(value) {
		if(!this.setStyle("backgroundSkin")) {
			return this.__backgroundSkin;
		}
		if(this.__backgroundSkin == value) {
			return this.__backgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_backgroundSkin);
		this.__backgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__backgroundSkin;
	},
	clearStyle_backgroundSkin: function() {
		this.set_backgroundSkin(null);
		return this.get_backgroundSkin();
	},
	get_disabledBackgroundSkin: function() {
		return this.__disabledBackgroundSkin;
	},
	set_disabledBackgroundSkin: function(value) {
		if(!this.setStyle("disabledBackgroundSkin")) {
			return this.__disabledBackgroundSkin;
		}
		if(this.__disabledBackgroundSkin == value) {
			return this.__disabledBackgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledBackgroundSkin);
		this.__disabledBackgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledBackgroundSkin;
	},
	clearStyle_disabledBackgroundSkin: function() {
		this.set_disabledBackgroundSkin(null);
		return this.get_disabledBackgroundSkin();
	},
	get_paddingTop: function() {
		return this.__paddingTop;
	},
	set_paddingTop: function(value) {
		if(!this.setStyle("paddingTop")) {
			return this.__paddingTop;
		}
		if(this.__paddingTop == value) {
			return this.__paddingTop;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingTop);
		this.__paddingTop = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingTop;
	},
	clearStyle_paddingTop: function() {
		this.set_paddingTop(0.0);
		return this.get_paddingTop();
	},
	get_paddingRight: function() {
		return this.__paddingRight;
	},
	set_paddingRight: function(value) {
		if(!this.setStyle("paddingRight")) {
			return this.__paddingRight;
		}
		if(this.__paddingRight == value) {
			return this.__paddingRight;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingRight);
		this.__paddingRight = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingRight;
	},
	clearStyle_paddingRight: function() {
		this.set_paddingRight(0.0);
		return this.get_paddingRight();
	},
	get_paddingBottom: function() {
		return this.__paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(!this.setStyle("paddingBottom")) {
			return this.__paddingBottom;
		}
		if(this.__paddingBottom == value) {
			return this.__paddingBottom;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingBottom);
		this.__paddingBottom = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingBottom;
	},
	clearStyle_paddingBottom: function() {
		this.set_paddingBottom(0.0);
		return this.get_paddingBottom();
	},
	get_paddingLeft: function() {
		return this.__paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(!this.setStyle("paddingLeft")) {
			return this.__paddingLeft;
		}
		if(this.__paddingLeft == value) {
			return this.__paddingLeft;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingLeft);
		this.__paddingLeft = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingLeft;
	},
	clearStyle_paddingLeft: function() {
		this.set_paddingLeft(0.0);
		return this.get_paddingLeft();
	},
	get_minGap: function() {
		return this.__minGap;
	},
	set_minGap: function(value) {
		if(!this.setStyle("minGap")) {
			return this.__minGap;
		}
		if(this.__minGap == value) {
			return this.__minGap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_minGap);
		this.__minGap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__minGap;
	},
	clearStyle_minGap: function() {
		this.set_minGap(0.0);
		return this.get_minGap();
	},
	get_verticalAlign: function() {
		return this.__verticalAlign;
	},
	set_verticalAlign: function(value) {
		if(!this.setStyle("verticalAlign")) {
			return this.__verticalAlign;
		}
		if(this.__verticalAlign == value) {
			return this.__verticalAlign;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_verticalAlign);
		this.__verticalAlign = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__verticalAlign;
	},
	clearStyle_verticalAlign: function() {
		this.set_verticalAlign((feathers_layout_VerticalAlign().default).MIDDLE);
		return this.get_verticalAlign();
	}
});
Header.prototype.__class__ = Header.prototype.constructor = $hxClasses["feathers.controls.Header"] = Header;

// Init



// Statics




// Export

exports["default"] = Header;

/***/ }),

/***/ "./lib/_gen/feathers/controls/IGridViewColumn.js":
/*!*******************************************************!*\
  !*** ./lib/_gen/feathers/controls/IGridViewColumn.js ***!
  \*******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.IGridViewColumn

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var IGridViewColumn = function() {}

// Meta

IGridViewColumn.__name__ = "feathers.controls.IGridViewColumn";
IGridViewColumn.__isInterface__ = true;
IGridViewColumn.prototype = {
	
};
IGridViewColumn.prototype.__class__ = IGridViewColumn.prototype.constructor = $hxClasses["feathers.controls.IGridViewColumn"] = IGridViewColumn;

// Init



// Statics




// Export

exports["default"] = IGridViewColumn;

/***/ }),

/***/ "./lib/_gen/feathers/controls/IGroupedToggle.js":
/*!******************************************************!*\
  !*** ./lib/_gen/feathers/controls/IGroupedToggle.js ***!
  \******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.IGroupedToggle

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_controls_IToggle() {return __webpack_require__(/*! ./../../feathers/controls/IToggle */ "./lib/_gen/feathers/controls/IToggle.js");}

// Constructor

var IGroupedToggle = function() {}

// Meta

IGroupedToggle.__name__ = "feathers.controls.IGroupedToggle";
IGroupedToggle.__isInterface__ = true;
IGroupedToggle.__interfaces__ = [(feathers_controls_IToggle().default)];
IGroupedToggle.prototype = {
	
};
IGroupedToggle.prototype.__class__ = IGroupedToggle.prototype.constructor = $hxClasses["feathers.controls.IGroupedToggle"] = IGroupedToggle;

// Init



// Statics




// Export

exports["default"] = IGroupedToggle;

/***/ }),

/***/ "./lib/_gen/feathers/controls/IRange.js":
/*!**********************************************!*\
  !*** ./lib/_gen/feathers/controls/IRange.js ***!
  \**********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.IRange

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}

// Constructor

var IRange = function() {}

// Meta

IRange.__name__ = "feathers.controls.IRange";
IRange.__isInterface__ = true;
IRange.__interfaces__ = [(feathers_core_IUIControl().default)];
IRange.prototype = {
	
};
IRange.prototype.__class__ = IRange.prototype.constructor = $hxClasses["feathers.controls.IRange"] = IRange;

// Init



// Statics




// Export

exports["default"] = IRange;

/***/ }),

/***/ "./lib/_gen/feathers/controls/IScrollBar.js":
/*!**************************************************!*\
  !*** ./lib/_gen/feathers/controls/IScrollBar.js ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.IScrollBar

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_controls_IRange() {return __webpack_require__(/*! ./../../feathers/controls/IRange */ "./lib/_gen/feathers/controls/IRange.js");}

// Constructor

var IScrollBar = function() {}

// Meta

IScrollBar.__name__ = "feathers.controls.IScrollBar";
IScrollBar.__isInterface__ = true;
IScrollBar.__interfaces__ = [(feathers_controls_IRange().default)];
IScrollBar.prototype = {
	
};
IScrollBar.prototype.__class__ = IScrollBar.prototype.constructor = $hxClasses["feathers.controls.IScrollBar"] = IScrollBar;

// Init



// Statics




// Export

exports["default"] = IScrollBar;

/***/ }),

/***/ "./lib/_gen/feathers/controls/IToggle.js":
/*!***********************************************!*\
  !*** ./lib/_gen/feathers/controls/IToggle.js ***!
  \***********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.IToggle

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}

// Constructor

var IToggle = function() {}

// Meta

IToggle.__name__ = "feathers.controls.IToggle";
IToggle.__isInterface__ = true;
IToggle.__interfaces__ = [(feathers_core_IUIControl().default)];
IToggle.prototype = {
	
};
IToggle.prototype.__class__ = IToggle.prototype.constructor = $hxClasses["feathers.controls.IToggle"] = IToggle;

// Init



// Statics




// Export

exports["default"] = IToggle;

/***/ }),

/***/ "./lib/_gen/feathers/controls/ITriggerView.js":
/*!****************************************************!*\
  !*** ./lib/_gen/feathers/controls/ITriggerView.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.ITriggerView

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}

// Constructor

var ITriggerView = function() {}

// Meta

ITriggerView.__name__ = "feathers.controls.ITriggerView";
ITriggerView.__isInterface__ = true;
ITriggerView.__interfaces__ = [(feathers_core_IUIControl().default)];
ITriggerView.prototype = {
	
};
ITriggerView.prototype.__class__ = ITriggerView.prototype.constructor = $hxClasses["feathers.controls.ITriggerView"] = ITriggerView;

// Init



// Statics




// Export

exports["default"] = ITriggerView;

/***/ }),

/***/ "./lib/_gen/feathers/controls/Label.js":
/*!*********************************************!*\
  !*** ./lib/_gen/feathers/controls/Label.js ***!
  \*********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.Label

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IStageFocusDelegate() {return __webpack_require__(/*! ./../../feathers/core/IStageFocusDelegate */ "./lib/_gen/feathers/core/IStageFocusDelegate.js");}
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}
function feathers_core_IHTMLTextControl() {return __webpack_require__(/*! ./../../feathers/core/IHTMLTextControl */ "./lib/_gen/feathers/core/IHTMLTextControl.js");}
function feathers_core_ITextControl() {return __webpack_require__(/*! ./../../feathers/core/ITextControl */ "./lib/_gen/feathers/core/ITextControl.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_themes_steel_components_SteelLabelStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelLabelStyles */ "./lib/_gen/feathers/themes/steel/components/SteelLabelStyles.js");}
function openfl_text_TextField() {return (__webpack_require__(/*! openfl */ "openfl").text.TextField);}
function feathers_utils_MeasurementsUtil() {return __webpack_require__(/*! ./../../feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}

// Constructor

var Label = function(text) {
	if(text == null) {
		text = "";
	}
	this.__disabledBackgroundSkin = null;
	this.__backgroundSkin = null;
	this.__wordWrap = false;
	this.__verticalAlign = (feathers_layout_VerticalAlign().default).TOP;
	this.__paddingLeft = 0.0;
	this.__paddingBottom = 0.0;
	this.__paddingRight = 0.0;
	this.__paddingTop = 0.0;
	this.__disabledTextFormat = null;
	this.__embedFonts = false;
	this.__textFormat = null;
	this._backgroundSkinMeasurements = null;
	this._currentBackgroundSkin = null;
	this._selectable = false;
	this._htmlText = null;
	this._wrappedOnMeasure = false;
	this._updatedTextStyles = false;
	this._previousSimpleTextFormat = null;
	this._previousTextFormat = null;
	this._previousHTMLText = null;
	this._previousText = null;
	this.initializeLabelTheme();
	(feathers_core_FeathersControl().default).call(this);
	this.set_text(text);
	this.set_tabEnabled(false);
	this.set_tabChildren(false);
	this.addEventListener("focusIn",$bind(this,this.label_focusInHandler));
}

// Meta

Label.__name__ = "feathers.controls.Label";
Label.__isInterface__ = false;
Label.__interfaces__ = [(feathers_core_IStageFocusDelegate().default),(feathers_core_IFocusObject().default),(feathers_core_IHTMLTextControl().default),(feathers_core_ITextControl().default)];
Label.__super__ = (feathers_core_FeathersControl().default);
Label.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_text: function() {
		return this._text;
	},
	set_text: function(value) {
		if(value == null) {
			if(this._text.length == 0) {
				return this._text;
			}
			value = "";
		}
		if(this._text == value) {
			return this._text;
		}
		this._text = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._text;
	},
	get_baseline: function() {
		if(this.textField == null) {
			return 0.0;
		}
		var hasText = this._text != null && this._text.length > 0;
		var hasHTMLText = this._htmlText != null && this._htmlText.length > 0;
		if(!hasText && !hasHTMLText) {
			this.textField.set_text("​");
			var result = this.textField.get_y() + this.textField.getLineMetrics(0).ascent;
			this.textField.set_text("");
			return result;
		}
		return this.textField.get_y() + this.textField.getLineMetrics(0).ascent;
	},
	get_htmlText: function() {
		return this._htmlText;
	},
	set_htmlText: function(value) {
		if(this._htmlText == value) {
			return this._htmlText;
		}
		this._htmlText = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._htmlText;
	},
	get_selectable: function() {
		return this._selectable;
	},
	set_selectable: function(value) {
		if(this._selectable == value) {
			return this._selectable;
		}
		this._selectable = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		return this._selectable;
	},
	get_tabEnabled: function() {
		if(this._selectable && this._enabled) {
			return this.get_rawTabEnabled();
		} else {
			return false;
		}
	},
	get_stageFocusTarget: function() {
		return this.textField;
	},
	get_selectionBeginIndex: function() {
		if(!this._selectable) {
			return -1;
		}
		if(this.textField == null) {
			return 0;
		}
		return this.textField.get_selectionBeginIndex();
	},
	get_selectionEndIndex: function() {
		if(!this._selectable) {
			return -1;
		}
		if(this.textField == null) {
			return 0;
		}
		return this.textField.get_selectionEndIndex();
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	initializeLabelTheme: function() {
		(feathers_themes_steel_components_SteelLabelStyles().default).initialize();
	},
	initialize: function() {
		(feathers_core_FeathersControl().default).prototype.initialize.call(this);
		if(this.textField == null) {
			this.textField = new (openfl_text_TextField())();
			this.textField.set_multiline(true);
			this.addChild(this.textField);
		}
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var selectionInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		var sizeInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SIZE);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		this._updatedTextStyles = false;
		if(stylesInvalid || stateInvalid) {
			this.refreshBackgroundSkin();
		}
		if(stylesInvalid || stateInvalid) {
			this.refreshTextStyles();
		}
		if(dataInvalid || stylesInvalid || stateInvalid || sizeInvalid) {
			this.refreshText(sizeInvalid);
		}
		if(dataInvalid || stylesInvalid || selectionInvalid) {
			this.refreshSelection();
		}
		sizeInvalid = this.measure() || sizeInvalid;
		if(stylesInvalid || stateInvalid || dataInvalid || sizeInvalid) {
			this.layoutContent();
		}
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		if(this._currentBackgroundSkin != null) {
			(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParent(this._backgroundSkinMeasurements,this._currentBackgroundSkin,this);
		}
		var measureSkin = null;
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IMeasureObject().default))) {
			measureSkin = (js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IMeasureObject().default));
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			newWidth = this._textMeasuredWidth + this.get_paddingLeft() + this.get_paddingRight();
			if(this._currentBackgroundSkin != null) {
				newWidth = Math.max(this._currentBackgroundSkin.get_width(),newWidth);
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			newHeight = this._textMeasuredHeight + this.get_paddingTop() + this.get_paddingBottom();
			if(this._currentBackgroundSkin != null) {
				newHeight = Math.max(this._currentBackgroundSkin.get_height(),newHeight);
			}
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			newMinWidth = this._textMeasuredWidth + this.get_paddingLeft() + this.get_paddingRight();
			if(measureSkin != null) {
				newMinWidth = Math.max(measureSkin.get_minWidth(),newMinWidth);
			} else if(this._backgroundSkinMeasurements != null) {
				newMinWidth = Math.max(this._backgroundSkinMeasurements.minWidth,newMinWidth);
			}
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			newMinHeight = this._textMeasuredHeight + this.get_paddingTop() + this.get_paddingBottom();
			if(measureSkin != null) {
				newMinHeight = Math.max(measureSkin.get_minHeight(),newMinHeight);
			} else if(this._backgroundSkinMeasurements != null) {
				newMinHeight = Math.max(this._backgroundSkinMeasurements.minHeight,newMinHeight);
			}
		}
		var newMaxWidth = this.get_explicitMaxWidth();
		if(needsMaxWidth) {
			if(measureSkin != null) {
				newMaxWidth = measureSkin.get_maxWidth();
			} else if(this._backgroundSkinMeasurements != null) {
				newMaxWidth = this._backgroundSkinMeasurements.maxWidth;
			} else {
				newMaxWidth = 1.0 / 0.0;
			}
		}
		var newMaxHeight = this.get_explicitMaxHeight();
		if(needsMaxHeight) {
			if(measureSkin != null) {
				newMaxHeight = measureSkin.get_maxHeight();
			} else if(this._backgroundSkinMeasurements != null) {
				newMaxHeight = this._backgroundSkinMeasurements.maxHeight;
			} else {
				newMaxHeight = 1.0 / 0.0;
			}
		}
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight,newMaxWidth,newMaxHeight);
	},
	refreshTextStyles: function() {
		if(this.textField.get_wordWrap() != this.get_wordWrap()) {
			this.textField.set_wordWrap(this.get_wordWrap());
			this._updatedTextStyles = true;
		}
		if(this.textField.get_embedFonts() != this.get_embedFonts()) {
			this.textField.set_embedFonts(this.get_embedFonts());
			this._updatedTextStyles = true;
		}
		var textFormat = this.getCurrentTextFormat();
		var simpleTextFormat = textFormat != null ? textFormat.toSimpleTextFormat() : null;
		if(simpleTextFormat == this._previousSimpleTextFormat) {
			return;
		}
		if(this._previousTextFormat != null) {
			this._previousTextFormat.removeEventListener("change",$bind(this,this.label_textFormat_changeHandler));
		}
		if(this.textField.get_caretIndex() != -1 && this.textField.get_selectionBeginIndex() != this.textField.get_selectionEndIndex()) {
			this.textField.setSelection(0,0);
		}
		if(textFormat != null) {
			textFormat.addEventListener("change",$bind(this,this.label_textFormat_changeHandler),false,0,true);
			this.textField.set_defaultTextFormat(simpleTextFormat);
			this._updatedTextStyles = true;
		}
		this._previousTextFormat = textFormat;
		this._previousSimpleTextFormat = simpleTextFormat;
	},
	refreshText: function(forceMeasurement) {
		var hasText = this._text != null && this._text.length > 0;
		var hasHTMLText = this._htmlText != null && this._htmlText.length > 0;
		this.textField.set_visible(hasText || hasHTMLText);
		if(this._text == this._previousText && this._htmlText == this._previousHTMLText && !this._updatedTextStyles && !forceMeasurement) {
			return;
		}
		this.textField.set_autoSize("left");
		if(hasHTMLText) {
			this.textField.set_htmlText(this._htmlText);
		} else if(hasText) {
			this.textField.set_text(this._text);
		} else {
			this.textField.set_text("​");
		}
		if(this.get_wordWrap()) {
			this.textField.set_wordWrap(false);
		}
		this._textMeasuredWidth = this.textField.get_textWidth() + 4;
		this._wrappedOnMeasure = false;
		if(this.get_wordWrap()) {
			var textFieldExplicitWidth = this.calculateExplicitWidthForTextMeasurement();
			if(textFieldExplicitWidth != null && this._textMeasuredWidth > textFieldExplicitWidth) {
				this.textField.set_wordWrap(true);
				this.textField.set_width(textFieldExplicitWidth);
				this._textMeasuredWidth = this.textField.get_width();
				this._wrappedOnMeasure = true;
			}
		}
		this._textMeasuredHeight = this.textField.get_height();
		this.textField.set_autoSize("none");
		if(this.textField.get_wordWrap() != this.get_wordWrap()) {
			this.textField.set_wordWrap(this.get_wordWrap());
		}
		if(!hasText && !hasHTMLText) {
			this.textField.set_text("");
		}
		this._previousText = this._text;
		this._previousHTMLText = this._htmlText;
	},
	calculateExplicitWidthForTextMeasurement: function() {
		var textFieldExplicitWidth = null;
		if(this.get_explicitWidth() != null) {
			textFieldExplicitWidth = this.get_explicitWidth();
		} else if(this.get_explicitMaxWidth() != null) {
			textFieldExplicitWidth = this.get_explicitMaxWidth();
		} else if(this._backgroundSkinMeasurements != null && this._backgroundSkinMeasurements.maxWidth != null) {
			textFieldExplicitWidth = this._backgroundSkinMeasurements.maxWidth;
		}
		if(textFieldExplicitWidth == null) {
			return textFieldExplicitWidth;
		}
		textFieldExplicitWidth -= this.get_paddingLeft() + this.get_paddingRight();
		return textFieldExplicitWidth;
	},
	refreshSelection: function() {
		var selectable = this._selectable && this._enabled;
		if(this.textField.get_selectable() != selectable) {
			this.textField.set_selectable(selectable);
		}
	},
	getCurrentTextFormat: function() {
		if(!this._enabled && this.get_disabledTextFormat() != null) {
			return this.get_disabledTextFormat();
		}
		return this.get_textFormat();
	},
	refreshBackgroundSkin: function() {
		var oldSkin = this._currentBackgroundSkin;
		this._currentBackgroundSkin = this.getCurrentBackgroundSkin();
		if(this._currentBackgroundSkin == oldSkin) {
			return;
		}
		this.removeCurrentBackgroundSkin(oldSkin);
		this.addCurrentBackgroundSkin(this._currentBackgroundSkin);
	},
	getCurrentBackgroundSkin: function() {
		if(!this._enabled && this.get_disabledBackgroundSkin() != null) {
			return this.get_disabledBackgroundSkin();
		}
		return this.get_backgroundSkin();
	},
	addCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			this._backgroundSkinMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._backgroundSkinMeasurements == null) {
			this._backgroundSkinMeasurements = new (feathers_layout_Measurements().default)(skin);
		} else {
			this._backgroundSkinMeasurements.save(skin);
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this.addChildAt(skin,0);
	},
	removeCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		this._backgroundSkinMeasurements.restore(skin);
		if(skin.parent == this) {
			this.removeChild(skin);
		}
	},
	layoutContent: function() {
		this.layoutBackgroundSkin();
		var textFieldLayoutWidth = this.actualWidth - this.get_paddingLeft() - this.get_paddingRight();
		this.textField.set_x(this.get_paddingLeft());
		this.textField.set_width(textFieldLayoutWidth);
		var wordWrap = this.get_wordWrap();
		if(wordWrap && !this._wrappedOnMeasure && textFieldLayoutWidth >= this._textMeasuredWidth) {
			wordWrap = false;
		}
		if(this.textField.get_wordWrap() != wordWrap) {
			this.textField.set_wordWrap(wordWrap);
		}
		var textFieldHeight = this._textMeasuredHeight;
		var maxHeight = this.actualHeight - this.get_paddingTop() - this.get_paddingBottom();
		if(textFieldHeight > maxHeight) {
			textFieldHeight = maxHeight;
		}
		this.textField.set_height(textFieldHeight);
		switch(this.get_verticalAlign()._hx_index) {
		case 0:
			this.textField.set_y(this.get_paddingTop());
			break;
		case 2:
			this.textField.set_y(this.actualHeight - this.get_paddingBottom() - textFieldHeight);
			break;
		default:
			this.textField.set_y(this.get_paddingTop() + (maxHeight - textFieldHeight) / 2.0);
		}
	},
	layoutBackgroundSkin: function() {
		if(this._currentBackgroundSkin == null) {
			return;
		}
		this._currentBackgroundSkin.set_x(0.0);
		this._currentBackgroundSkin.set_y(0.0);
		if(this._currentBackgroundSkin.get_width() != this.actualWidth) {
			this._currentBackgroundSkin.set_width(this.actualWidth);
		}
		if(this._currentBackgroundSkin.get_height() != this.actualHeight) {
			this._currentBackgroundSkin.set_height(this.actualHeight);
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
	},
	label_focusInHandler: function(event) {
		if(this.stage != null && this.stage.get_focus() != this.textField) {
			event.stopImmediatePropagation();
			this.stage.set_focus(this.textField);
		}
	},
	label_textFormat_changeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	get_textFormat: function() {
		return this.__textFormat;
	},
	set_textFormat: function(value) {
		if(!this.setStyle("textFormat")) {
			return this.__textFormat;
		}
		if(this.__textFormat == value) {
			return this.__textFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_textFormat);
		this.__textFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__textFormat;
	},
	clearStyle_textFormat: function() {
		this.set_textFormat(null);
		return this.get_textFormat();
	},
	get_embedFonts: function() {
		return this.__embedFonts;
	},
	set_embedFonts: function(value) {
		if(!this.setStyle("embedFonts")) {
			return this.__embedFonts;
		}
		if(this.__embedFonts == value) {
			return this.__embedFonts;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_embedFonts);
		this.__embedFonts = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__embedFonts;
	},
	clearStyle_embedFonts: function() {
		this.set_embedFonts(false);
		return this.get_embedFonts();
	},
	get_disabledTextFormat: function() {
		return this.__disabledTextFormat;
	},
	set_disabledTextFormat: function(value) {
		if(!this.setStyle("disabledTextFormat")) {
			return this.__disabledTextFormat;
		}
		if(this.__disabledTextFormat == value) {
			return this.__disabledTextFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledTextFormat);
		this.__disabledTextFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledTextFormat;
	},
	clearStyle_disabledTextFormat: function() {
		this.set_disabledTextFormat(null);
		return this.get_disabledTextFormat();
	},
	get_paddingTop: function() {
		return this.__paddingTop;
	},
	set_paddingTop: function(value) {
		if(!this.setStyle("paddingTop")) {
			return this.__paddingTop;
		}
		if(this.__paddingTop == value) {
			return this.__paddingTop;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingTop);
		this.__paddingTop = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingTop;
	},
	clearStyle_paddingTop: function() {
		this.set_paddingTop(0.0);
		return this.get_paddingTop();
	},
	get_paddingRight: function() {
		return this.__paddingRight;
	},
	set_paddingRight: function(value) {
		if(!this.setStyle("paddingRight")) {
			return this.__paddingRight;
		}
		if(this.__paddingRight == value) {
			return this.__paddingRight;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingRight);
		this.__paddingRight = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingRight;
	},
	clearStyle_paddingRight: function() {
		this.set_paddingRight(0.0);
		return this.get_paddingRight();
	},
	get_paddingBottom: function() {
		return this.__paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(!this.setStyle("paddingBottom")) {
			return this.__paddingBottom;
		}
		if(this.__paddingBottom == value) {
			return this.__paddingBottom;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingBottom);
		this.__paddingBottom = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingBottom;
	},
	clearStyle_paddingBottom: function() {
		this.set_paddingBottom(0.0);
		return this.get_paddingBottom();
	},
	get_paddingLeft: function() {
		return this.__paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(!this.setStyle("paddingLeft")) {
			return this.__paddingLeft;
		}
		if(this.__paddingLeft == value) {
			return this.__paddingLeft;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingLeft);
		this.__paddingLeft = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingLeft;
	},
	clearStyle_paddingLeft: function() {
		this.set_paddingLeft(0.0);
		return this.get_paddingLeft();
	},
	get_verticalAlign: function() {
		return this.__verticalAlign;
	},
	set_verticalAlign: function(value) {
		if(!this.setStyle("verticalAlign")) {
			return this.__verticalAlign;
		}
		if(this.__verticalAlign == value) {
			return this.__verticalAlign;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_verticalAlign);
		this.__verticalAlign = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__verticalAlign;
	},
	clearStyle_verticalAlign: function() {
		this.set_verticalAlign((feathers_layout_VerticalAlign().default).TOP);
		return this.get_verticalAlign();
	},
	get_wordWrap: function() {
		return this.__wordWrap;
	},
	set_wordWrap: function(value) {
		if(!this.setStyle("wordWrap")) {
			return this.__wordWrap;
		}
		if(this.__wordWrap == value) {
			return this.__wordWrap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_wordWrap);
		this.__wordWrap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__wordWrap;
	},
	clearStyle_wordWrap: function() {
		this.set_wordWrap(false);
		return this.get_wordWrap();
	},
	get_backgroundSkin: function() {
		return this.__backgroundSkin;
	},
	set_backgroundSkin: function(value) {
		if(!this.setStyle("backgroundSkin")) {
			return this.__backgroundSkin;
		}
		if(this.__backgroundSkin == value) {
			return this.__backgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_backgroundSkin);
		this.__backgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__backgroundSkin;
	},
	clearStyle_backgroundSkin: function() {
		this.set_backgroundSkin(null);
		return this.get_backgroundSkin();
	},
	get_disabledBackgroundSkin: function() {
		return this.__disabledBackgroundSkin;
	},
	set_disabledBackgroundSkin: function(value) {
		if(!this.setStyle("disabledBackgroundSkin")) {
			return this.__disabledBackgroundSkin;
		}
		if(this.__disabledBackgroundSkin == value) {
			return this.__disabledBackgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledBackgroundSkin);
		this.__disabledBackgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledBackgroundSkin;
	},
	clearStyle_disabledBackgroundSkin: function() {
		this.set_disabledBackgroundSkin(null);
		return this.get_disabledBackgroundSkin();
	},
	get_styleContext: function() {
		return Label
	}
});
Label.prototype.__class__ = Label.prototype.constructor = $hxClasses["feathers.controls.Label"] = Label;

// Init



// Statics


Label.__meta__ = { obj : { defaultXmlProperty : ["text"]}}
Label.VARIANT_HEADING = "heading"
Label.VARIANT_DETAIL = "detail"
Label.VARIANT_DANGER = "danger"

// Export

exports["default"] = Label;

/***/ }),

/***/ "./lib/_gen/feathers/controls/LayoutGroup.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/controls/LayoutGroup.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.LayoutGroup

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_layout_AutoSizeMode() {return __webpack_require__(/*! ./../../feathers/layout/AutoSizeMode */ "./lib/_gen/feathers/layout/AutoSizeMode.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_ILayoutObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutObject */ "./lib/_gen/feathers/layout/ILayoutObject.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_RangeError() {return (__webpack_require__(/*! openfl */ "openfl").errors.RangeError);}
function feathers_themes_steel_components_SteelLayoutGroupStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelLayoutGroupStyles */ "./lib/_gen/feathers/themes/steel/components/SteelLayoutGroupStyles.js");}
function Type() {return __webpack_require__(/*! ./../../Type */ "./lib/_gen/Type.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function openfl_display_Sprite() {return (__webpack_require__(/*! openfl */ "openfl").display.Sprite);}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_utils_MeasurementsUtil() {return __webpack_require__(/*! ./../../feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}

// Constructor

var LayoutGroup = function() {
	this.__maskSkin = null;
	this.__disabledBackgroundSkin = null;
	this.__backgroundSkin = null;
	this.__layout = null;
	this._layoutChanged = false;
	this._layoutActive = false;
	this._xmlContent = null;
	this._autoSizeMode = (feathers_layout_AutoSizeMode().default).CONTENT;
	this._currentMaskSkin = null;
	this._backgroundSkinMeasurements = null;
	this._currentBackgroundSkin = null;
	this._ignoreLayoutChanges = false;
	this._ignoreChangesButSetFlags = false;
	this._ignoreChildChanges = false;
	this._layoutMeasurements = new (feathers_layout_Measurements().default)();
	this._layoutResult = new (feathers_layout_LayoutBoundsResult().default)();
	this.items = [];
	this.initializeLayoutGroupTheme();
	(feathers_core_FeathersControl().default).call(this);
	this.addEventListener("addedToStage",$bind(this,this.layoutGroup_addedToStageHandler));
}

// Meta

LayoutGroup.__name__ = "feathers.controls.LayoutGroup";
LayoutGroup.__isInterface__ = false;
LayoutGroup.__super__ = (feathers_core_FeathersControl().default);
LayoutGroup.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_autoSizeMode: function() {
		return this._autoSizeMode;
	},
	set_autoSizeMode: function(value) {
		if(this._autoSizeMode == value) {
			return this._autoSizeMode;
		}
		this._autoSizeMode = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		if(this.stage != null) {
			if(this._autoSizeMode == (feathers_layout_AutoSizeMode().default).STAGE) {
				this.stage.addEventListener("resize",$bind(this,this.layoutGroup_stage_resizeHandler),false,0,true);
				this.addEventListener("removedFromStage",$bind(this,this.layoutGroup_removedFromStageHandler));
			} else {
				this.stage.removeEventListener("resize",$bind(this,this.layoutGroup_stage_resizeHandler));
				this.removeEventListener("removedFromStage",$bind(this,this.layoutGroup_removedFromStageHandler));
			}
		}
		return this._autoSizeMode;
	},
	get_numChildren: function() {
		return this.items.length;
	},
	get__numChildren: function() {
		return (feathers_core_FeathersControl().default).prototype.get_numChildren.call(this);
	},
	addChildAt: function(child,index) {
		var oldIndex = this.items.indexOf(child);
		if(oldIndex == index) {
			return child;
		}
		var privateIndex = this.getPrivateIndexForPublicIndex(index);
		if(oldIndex >= 0) {
			this.items.splice(oldIndex,1);
		}
		this.items.splice(index,0,child);
		var result = this._addChildAt(child,privateIndex);
		child.addEventListener("resize",$bind(this,this.layoutGroup_child_resizeHandler));
		if((js_Boot().default).__implements(child,(feathers_layout_ILayoutObject().default))) {
			child.addEventListener("layoutDataChange",$bind(this,this.layoutGroup_child_layoutDataChangeHandler),false,0,true);
		}
		if(this._ignoreChangesButSetFlags) {
			this.setInvalidationFlag((feathers_core_InvalidationFlag().default).LAYOUT);
		} else {
			this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		}
		return result;
	},
	_addChild: function(child) {
		return (feathers_core_FeathersControl().default).prototype.addChildAt.call(this,child,this.get__numChildren());
	},
	_addChildAt: function(child,index) {
		return (feathers_core_FeathersControl().default).prototype.addChildAt.call(this,child,index);
	},
	removeChild: function(child) {
		if(child == null || child.parent != this) {
			return child;
		}
		(HxOverrides().default).remove(this.items,child);
		var result = this._removeChild(child);
		child.removeEventListener("resize",$bind(this,this.layoutGroup_child_resizeHandler));
		if((js_Boot().default).__implements(child,(feathers_layout_ILayoutObject().default))) {
			child.removeEventListener("layoutDataChange",$bind(this,this.layoutGroup_child_layoutDataChangeHandler));
		}
		if(this._ignoreChangesButSetFlags) {
			this.setInvalidationFlag((feathers_core_InvalidationFlag().default).LAYOUT);
		} else {
			this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		}
		return result;
	},
	_removeChild: function(child) {
		return (feathers_core_FeathersControl().default).prototype.removeChild.call(this,child);
	},
	removeChildAt: function(index) {
		if(index >= 0 && index < this.items.length) {
			return this.removeChild(this.items[index]);
		}
		return null;
	},
	_removeChildAt: function(index) {
		return (feathers_core_FeathersControl().default).prototype.removeChildAt.call(this,index);
	},
	getChildIndex: function(child) {
		return this.items.indexOf(child);
	},
	_getChildIndex: function(child) {
		return (feathers_core_FeathersControl().default).prototype.getChildIndex.call(this,child);
	},
	getChildByName: function(name) {
		var _g = 0;
		var _g1 = this.items;
		while(_g < _g1.length) {
			var child = _g1[_g];
			++_g;
			if(child.get_name() == name) {
				return child;
			}
		}
		return null;
	},
	_getChildByName: function(name) {
		return (feathers_core_FeathersControl().default).prototype.getChildByName.call(this,name);
	},
	removeChildren: function(beginIndex,endIndex) {
		if(endIndex == null) {
			endIndex = 2147483647;
		}
		if(beginIndex == null) {
			beginIndex = 0;
		}
		if(endIndex == 2147483647) {
			endIndex = this.items.length - 1;
			if(endIndex < 0) {
				return;
			}
		}
		if(beginIndex > this.items.length - 1) {
			return;
		} else if(endIndex < beginIndex || beginIndex < 0 || endIndex > this.items.length) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("The supplied index is out of bounds."));
		}
		var numRemovals = endIndex - beginIndex;
		while(numRemovals >= 0) {
			this.removeChildAt(beginIndex);
			--numRemovals;
		}
	},
	_removeChildren: function(beginIndex,endIndex) {
		if(endIndex == null) {
			endIndex = 2147483647;
		}
		if(beginIndex == null) {
			beginIndex = 0;
		}
		(feathers_core_FeathersControl().default).prototype.removeChildren.call(this,beginIndex,endIndex);
	},
	setChildIndex: function(child,index) {
		var oldIndex = this.getChildIndex(child);
		if(oldIndex == index) {
			return;
		}
		this._setChildIndex(child,this.getPrivateIndexForPublicIndex(index));
		(HxOverrides().default).remove(this.items,child);
		this.items.splice(index,0,child);
		if(this._ignoreChangesButSetFlags) {
			this.setInvalidationFlag((feathers_core_InvalidationFlag().default).LAYOUT);
		} else {
			this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		}
	},
	_setChildIndex: function(child,index) {
		(feathers_core_FeathersControl().default).prototype.setChildIndex.call(this,child,index);
	},
	getChildAt: function(index) {
		return this.items[index];
	},
	_getChildAt: function(index) {
		return (feathers_core_FeathersControl().default).prototype.getChildAt.call(this,index);
	},
	initializeLayoutGroupTheme: function() {
		(feathers_themes_steel_components_SteelLayoutGroupStyles().default).initialize();
	},
	getPrivateIndexForPublicIndex: function(publicIndex) {
		if(this.items.length > 0) {
			return publicIndex + this._getChildIndex(this.items[0]);
		} else if(this.get__numChildren() > 0) {
			return publicIndex + this.get__numChildren();
		}
		return publicIndex;
	},
	get_xmlContent: function() {
		return this._xmlContent;
	},
	set_xmlContent: function(value) {
		if(this._xmlContent == value) {
			return this._xmlContent;
		}
		if(this._xmlContent != null) {
			var _g = 0;
			var _g1 = this._xmlContent;
			while(_g < _g1.length) {
				var child = _g1[_g];
				++_g;
				this.removeChild(child);
			}
		}
		this._xmlContent = value;
		if(this._xmlContent != null) {
			var _g2 = 0;
			var _g11 = this._xmlContent;
			while(_g2 < _g11.length) {
				var child1 = _g11[_g2];
				++_g2;
				this.addChild(child1);
			}
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._xmlContent;
	},
	validateNow: function() {
		var oldIgnoreChildChanges = this._ignoreChangesButSetFlags;
		this._ignoreChangesButSetFlags = true;
		(feathers_core_FeathersControl().default).prototype.validateNow.call(this);
		this._ignoreChangesButSetFlags = oldIgnoreChildChanges;
	},
	update: function() {
		var _gthis = this;
		this._ignoreChangesButSetFlags = false;
		var layoutInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		var sizeInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SIZE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		if(stylesInvalid || stateInvalid) {
			this.refreshBackgroundSkin();
		}
		if(stylesInvalid) {
			this.refreshMaskSkin();
			this.refreshLayout();
		}
		if(sizeInvalid || layoutInvalid || stylesInvalid || stateInvalid) {
			this.refreshViewPortBounds();
			this.runWithInvalidationFlagsOnly(function() {
				_gthis._layoutActive = true;
				var loopCount = 0;
				while(true) {
					_gthis._layoutChanged = false;
					_gthis.handleLayout();
					++loopCount;
					if(loopCount >= 10) {
						_gthis._layoutActive = false;
						var className = (Type().default).getClassName((Type().default).getClass(_gthis));
						var layoutClassName = _gthis.get_layout() != null ? (Type().default).getClassName((Type().default).getClass(_gthis.get_layout())) : "The layout";
						throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + className + " is stuck in an infinite loop during layout. " + layoutClassName + " may be dispatching Event.CHANGE too frequently."));
					}
					if(!_gthis._layoutChanged) {
						break;
					}
				}
				return _gthis._layoutActive = false;
			});
			this.refreshBackgroundLayout();
			this.refreshDisabledOverlay();
			this.refreshMaskLayout();
			this.validateChildren();
		}
	},
	refreshDisabledOverlay: function() {
		if(!this._enabled) {
			if(this._disabledOverlay == null) {
				this._disabledOverlay = new (openfl_display_Sprite())();
				this._disabledOverlay.get_graphics().beginFill(16711935,0.0);
				this._disabledOverlay.get_graphics().drawRect(0.0,0.0,1.0,1.0);
				this._disabledOverlay.get_graphics().endFill();
				this._addChild(this._disabledOverlay);
			} else {
				this._setChildIndex(this._disabledOverlay,this.get__numChildren() - 1);
			}
		}
		if(this._disabledOverlay != null) {
			this._disabledOverlay.set_visible(!this._enabled);
			this._disabledOverlay.set_x(0.0);
			this._disabledOverlay.set_y(0.0);
			this._disabledOverlay.set_width(this.actualWidth);
			this._disabledOverlay.set_height(this.actualHeight);
		}
	},
	refreshLayout: function() {
		var newLayout = this.get_layout();
		if(this._currentLayout == newLayout) {
			return;
		}
		if(this._currentLayout != null) {
			this._currentLayout.removeEventListener("change",$bind(this,this.layoutGroup_layout_changeHandler));
		}
		this._currentLayout = newLayout;
		if(this._currentLayout != null) {
			this._currentLayout.addEventListener("change",$bind(this,this.layoutGroup_layout_changeHandler));
		}
	},
	refreshBackgroundSkin: function() {
		var oldSkin = this._currentBackgroundSkin;
		this._currentBackgroundSkin = this.getCurrentBackgroundSkin();
		if(this._currentBackgroundSkin == oldSkin) {
			return;
		}
		this.removeCurrentBackgroundSkin(oldSkin);
		this.addCurrentBackgroundSkin(this._currentBackgroundSkin);
	},
	getCurrentBackgroundSkin: function() {
		if(!this._enabled && this.get_disabledBackgroundSkin() != null) {
			return this.get_disabledBackgroundSkin();
		}
		return this.get_backgroundSkin();
	},
	addCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			this._backgroundSkinMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._backgroundSkinMeasurements == null) {
			this._backgroundSkinMeasurements = new (feathers_layout_Measurements().default)(skin);
		} else {
			this._backgroundSkinMeasurements.save(skin);
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this._addChildAt(skin,0);
	},
	removeCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		this._backgroundSkinMeasurements.restore(skin);
		if(skin.parent == this) {
			this._removeChild(skin);
		}
	},
	refreshMaskSkin: function() {
		var oldSkin = this._currentMaskSkin;
		this._currentMaskSkin = this.getCurrentMaskSkin();
		if(this._currentMaskSkin == oldSkin) {
			return;
		}
		this.removeCurrentMaskSkin(oldSkin);
		this.addCurrentMaskSkin(this._currentMaskSkin);
	},
	getCurrentMaskSkin: function() {
		return this.get_maskSkin();
	},
	addCurrentMaskSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this._addChild(skin);
		this.set_mask(skin);
	},
	removeCurrentMaskSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		if(skin.parent == this) {
			this._removeChild(skin);
		}
		this.set_mask(null);
	},
	refreshViewPortBounds: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(this._currentBackgroundSkin != null) {
			(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParent(this._backgroundSkinMeasurements,this._currentBackgroundSkin,this);
			if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
			}
		}
		var needsToMeasureContent = this._autoSizeMode == (feathers_layout_AutoSizeMode().default).CONTENT || this.stage == null;
		var stageWidth = 0.0;
		var stageHeight = 0.0;
		if(!needsToMeasureContent) {
			var topLeft = this.globalToLocal(new (openfl_geom_Point())());
			var bottomRight = this.globalToLocal(new (openfl_geom_Point())(this.stage.stageWidth,this.stage.stageHeight));
			stageWidth = bottomRight.x - topLeft.x;
			stageHeight = bottomRight.y - topLeft.y;
		}
		if(needsWidth && !needsToMeasureContent) {
			this._layoutMeasurements.width = stageWidth;
		} else {
			this._layoutMeasurements.width = this.get_explicitWidth();
		}
		if(needsHeight && !needsToMeasureContent) {
			this._layoutMeasurements.height = stageHeight;
		} else {
			this._layoutMeasurements.height = this.get_explicitHeight();
		}
		var viewPortMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			viewPortMinWidth = 0.0;
		}
		var viewPortMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			viewPortMinHeight = 0.0;
		}
		var viewPortMaxWidth = this.get_explicitMaxWidth();
		if(needsMaxWidth) {
			viewPortMaxWidth = 1.0 / 0.0;
		}
		var viewPortMaxHeight = this.get_explicitMaxHeight();
		if(needsMaxHeight) {
			viewPortMaxHeight = 1.0 / 0.0;
		}
		if(this._backgroundSkinMeasurements != null) {
			if(this._backgroundSkinMeasurements.width != null) {
				if(this._backgroundSkinMeasurements.width > viewPortMinWidth) {
					viewPortMinWidth = this._backgroundSkinMeasurements.width;
				}
			} else if(this._backgroundSkinMeasurements.minWidth != null) {
				if(this._backgroundSkinMeasurements.minWidth > viewPortMinWidth) {
					viewPortMinWidth = this._backgroundSkinMeasurements.minWidth;
				}
			}
			if(this._backgroundSkinMeasurements.height != null) {
				if(this._backgroundSkinMeasurements.height > viewPortMinHeight) {
					viewPortMinHeight = this._backgroundSkinMeasurements.height;
				}
			} else if(this._backgroundSkinMeasurements.minHeight != null) {
				if(this._backgroundSkinMeasurements.minHeight > viewPortMinHeight) {
					viewPortMinHeight = this._backgroundSkinMeasurements.minHeight;
				}
			}
		}
		this._layoutMeasurements.minWidth = viewPortMinWidth;
		this._layoutMeasurements.minHeight = viewPortMinHeight;
		this._layoutMeasurements.maxWidth = viewPortMaxWidth;
		this._layoutMeasurements.maxHeight = viewPortMaxHeight;
	},
	handleLayout: function() {
		if(this._currentLayout != null) {
			this.handleCustomLayout();
		} else {
			this.handleManualLayout();
		}
		this.handleLayoutResult();
	},
	handleCustomLayout: function() {
		var oldIgnoreChildChanges = this._ignoreChildChanges;
		this._ignoreChildChanges = true;
		this._layoutResult.reset();
		this._currentLayout.layout(this.items,this._layoutMeasurements,this._layoutResult);
		this._ignoreChildChanges = oldIgnoreChildChanges;
	},
	handleManualLayout: function() {
		var maxX = this._layoutMeasurements.width;
		if(maxX == null) {
			maxX = 0.0;
		}
		var maxY = this._layoutMeasurements.height;
		if(maxY == null) {
			maxY = 0.0;
		}
		var oldIgnoreChildChanges = this._ignoreChildChanges;
		this._ignoreChildChanges = true;
		var _g = 0;
		var _g1 = this.items;
		while(_g < _g1.length) {
			var item = _g1[_g];
			++_g;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default)) && !((js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default))).get_includeInLayout()) {
				continue;
			}
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
			var itemMaxX = item.get_x() + item.get_width();
			var itemMaxY = item.get_y() + item.get_height();
			if(maxX < itemMaxX) {
				maxX = itemMaxX;
			}
			if(maxY < itemMaxY) {
				maxY = itemMaxY;
			}
		}
		this._ignoreChildChanges = oldIgnoreChildChanges;
		this._layoutResult.contentX = 0.0;
		this._layoutResult.contentY = 0.0;
		this._layoutResult.contentWidth = maxX;
		this._layoutResult.contentHeight = maxY;
		if(this._layoutMeasurements.width != null) {
			this._layoutResult.viewPortWidth = this._layoutMeasurements.width;
		} else {
			if(this._layoutMeasurements.minWidth != null && maxX < this._layoutMeasurements.minWidth) {
				maxX = this._layoutMeasurements.minWidth;
			} else if(this._layoutMeasurements.maxWidth != null && maxX > this._layoutMeasurements.maxWidth) {
				maxX = this._layoutMeasurements.maxWidth;
			}
			this._layoutResult.viewPortWidth = maxX;
		}
		if(this._layoutMeasurements.height != null) {
			this._layoutResult.viewPortHeight = this._layoutMeasurements.height;
		} else {
			if(this._layoutMeasurements.minHeight != null && maxY < this._layoutMeasurements.minHeight) {
				maxY = this._layoutMeasurements.minHeight;
			} else if(this._layoutMeasurements.maxHeight != null && maxY > this._layoutMeasurements.maxHeight) {
				maxY = this._layoutMeasurements.maxHeight;
			}
			this._layoutResult.viewPortHeight = maxY;
		}
	},
	handleLayoutResult: function() {
		var viewPortWidth = this._layoutResult.viewPortWidth;
		var viewPortHeight = this._layoutResult.viewPortHeight;
		this.saveMeasurements(viewPortWidth,viewPortHeight,viewPortWidth,viewPortHeight);
	},
	refreshMaskLayout: function() {
		if(this._currentMaskSkin == null) {
			return;
		}
		this._currentMaskSkin.set_x(0.0);
		this._currentMaskSkin.set_y(0.0);
		this._currentMaskSkin.set_width(this.actualWidth);
		this._currentMaskSkin.set_height(this.actualHeight);
		if((js_Boot().default).__implements(this._currentMaskSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentMaskSkin , (feathers_core_IValidating().default))).validateNow();
		}
	},
	refreshBackgroundLayout: function() {
		if(this._currentBackgroundSkin == null) {
			return;
		}
		this._currentBackgroundSkin.set_x(0.0);
		this._currentBackgroundSkin.set_y(0.0);
		if(this._currentBackgroundSkin.get_width() != this.actualWidth) {
			this._currentBackgroundSkin.set_width(this.actualWidth);
		}
		if(this._currentBackgroundSkin.get_height() != this.actualHeight) {
			this._currentBackgroundSkin.set_height(this.actualHeight);
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
	},
	validateChildren: function() {
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
		var _g = 0;
		var _g1 = this.items;
		while(_g < _g1.length) {
			var item = _g1[_g];
			++_g;
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
		}
	},
	layoutGroup_addedToStageHandler: function(event) {
		if(this._autoSizeMode == (feathers_layout_AutoSizeMode().default).STAGE) {
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
			this.addEventListener("removedFromStage",$bind(this,this.layoutGroup_removedFromStageHandler));
			this.stage.addEventListener("resize",$bind(this,this.layoutGroup_stage_resizeHandler),false,0,true);
		}
	},
	layoutGroup_removedFromStageHandler: function(event) {
		this.removeEventListener("removedFromStage",$bind(this,this.layoutGroup_removedFromStageHandler));
		this.stage.removeEventListener("resize",$bind(this,this.layoutGroup_stage_resizeHandler));
	},
	layoutGroup_stage_resizeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
	},
	layoutGroup_child_resizeHandler: function(event) {
		if(this._ignoreChildChanges) {
			return;
		}
		if(this._ignoreChangesButSetFlags) {
			this.setInvalidationFlag((feathers_core_InvalidationFlag().default).LAYOUT);
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	layoutGroup_child_layoutDataChangeHandler: function(event) {
		if(this._ignoreChildChanges) {
			return;
		}
		if(this._ignoreChangesButSetFlags) {
			this.setInvalidationFlag((feathers_core_InvalidationFlag().default).LAYOUT);
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	layoutGroup_layout_changeHandler: function(event) {
		if(this._ignoreLayoutChanges) {
			return;
		}
		if(this._layoutActive) {
			this._layoutChanged = true;
			return;
		}
		if(this._ignoreChangesButSetFlags) {
			this.setInvalidationFlag((feathers_core_InvalidationFlag().default).LAYOUT);
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	get_layout: function() {
		return this.__layout;
	},
	set_layout: function(value) {
		if(!this.setStyle("layout")) {
			return this.__layout;
		}
		if(this.__layout == value) {
			return this.__layout;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_layout);
		this.__layout = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__layout;
	},
	clearStyle_layout: function() {
		this.set_layout(null);
		return this.get_layout();
	},
	get_backgroundSkin: function() {
		return this.__backgroundSkin;
	},
	set_backgroundSkin: function(value) {
		if(!this.setStyle("backgroundSkin")) {
			return this.__backgroundSkin;
		}
		if(this.__backgroundSkin == value) {
			return this.__backgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_backgroundSkin);
		this.__backgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__backgroundSkin;
	},
	clearStyle_backgroundSkin: function() {
		this.set_backgroundSkin(null);
		return this.get_backgroundSkin();
	},
	get_disabledBackgroundSkin: function() {
		return this.__disabledBackgroundSkin;
	},
	set_disabledBackgroundSkin: function(value) {
		if(!this.setStyle("disabledBackgroundSkin")) {
			return this.__disabledBackgroundSkin;
		}
		if(this.__disabledBackgroundSkin == value) {
			return this.__disabledBackgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledBackgroundSkin);
		this.__disabledBackgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledBackgroundSkin;
	},
	clearStyle_disabledBackgroundSkin: function() {
		this.set_disabledBackgroundSkin(null);
		return this.get_disabledBackgroundSkin();
	},
	get_maskSkin: function() {
		return this.__maskSkin;
	},
	set_maskSkin: function(value) {
		if(!this.setStyle("maskSkin")) {
			return this.__maskSkin;
		}
		if(this.__maskSkin == value) {
			return this.__maskSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_maskSkin);
		this.__maskSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__maskSkin;
	},
	clearStyle_maskSkin: function() {
		this.set_maskSkin(null);
		return this.get_maskSkin();
	},
	get_styleContext: function() {
		return LayoutGroup
	}
});
LayoutGroup.prototype.__class__ = LayoutGroup.prototype.constructor = $hxClasses["feathers.controls.LayoutGroup"] = LayoutGroup;

// Init



// Statics


LayoutGroup.__meta__ = { obj : { defaultXmlProperty : ["xmlContent"]}}
LayoutGroup.VARIANT_TOOL_BAR = "toolBar"

// Export

exports["default"] = LayoutGroup;

/***/ }),

/***/ "./lib/_gen/feathers/controls/ListView.js":
/*!************************************************!*\
  !*** ./lib/_gen/feathers/controls/ListView.js ***!
  \************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.ListView

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IFocusContainer() {return __webpack_require__(/*! ./../../feathers/core/IFocusContainer */ "./lib/_gen/feathers/core/IFocusContainer.js");}
function feathers_core_IDataSelector() {return __webpack_require__(/*! ./../../feathers/core/IDataSelector */ "./lib/_gen/feathers/core/IDataSelector.js");}
function feathers_core_IIndexSelector() {return __webpack_require__(/*! ./../../feathers/core/IIndexSelector */ "./lib/_gen/feathers/core/IIndexSelector.js");}
function feathers_controls_supportClasses_BaseScrollContainer() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/BaseScrollContainer */ "./lib/_gen/feathers/controls/supportClasses/BaseScrollContainer.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function haxe_ds_StringMap() {return __webpack_require__(/*! ./../../haxe/ds/StringMap */ "./lib/_gen/haxe/ds/StringMap.js");}
function feathers_themes_steel_components_SteelListViewStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelListViewStyles */ "./lib/_gen/feathers/themes/steel/components/SteelListViewStyles.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_IScrollLayout() {return __webpack_require__(/*! ./../../feathers/layout/IScrollLayout */ "./lib/_gen/feathers/layout/IScrollLayout.js");}
function feathers_layout_IVirtualLayout() {return __webpack_require__(/*! ./../../feathers/layout/IVirtualLayout */ "./lib/_gen/feathers/layout/IVirtualLayout.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function Type() {return __webpack_require__(/*! ./../../Type */ "./lib/_gen/Type.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_controls_dataRenderers_IDataRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/IDataRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IDataRenderer.js");}
function feathers_controls_dataRenderers_IListViewItemRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/IListViewItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IListViewItemRenderer.js");}
function feathers_layout_ILayoutIndexObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutIndexObject */ "./lib/_gen/feathers/layout/ILayoutIndexObject.js");}
function feathers_controls_IToggle() {return __webpack_require__(/*! ./../../feathers/controls/IToggle */ "./lib/_gen/feathers/controls/IToggle.js");}
function feathers_style_IVariantStyleObject() {return __webpack_require__(/*! ./../../feathers/style/IVariantStyleObject */ "./lib/_gen/feathers/style/IVariantStyleObject.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_controls_ITriggerView() {return __webpack_require__(/*! ./../../feathers/controls/ITriggerView */ "./lib/_gen/feathers/controls/ITriggerView.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_controls__$ListView_ItemRendererStorage() {return __webpack_require__(/*! ./../../feathers/controls/_ListView/ItemRendererStorage */ "./lib/_gen/feathers/controls/_ListView/ItemRendererStorage.js");}
function openfl_display_DisplayObject() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObject);}
function feathers_events_ListViewEvent() {return __webpack_require__(/*! ./../../feathers/events/ListViewEvent */ "./lib/_gen/feathers/events/ListViewEvent.js");}
function feathers_layout_IKeyboardNavigationLayout() {return __webpack_require__(/*! ./../../feathers/layout/IKeyboardNavigationLayout */ "./lib/_gen/feathers/layout/IKeyboardNavigationLayout.js");}
function feathers_data_ListViewItemState() {return __webpack_require__(/*! ./../../feathers/data/ListViewItemState */ "./lib/_gen/feathers/data/ListViewItemState.js");}
function feathers_core_ITextControl() {return __webpack_require__(/*! ./../../feathers/core/ITextControl */ "./lib/_gen/feathers/core/ITextControl.js");}
function feathers_layout_VirtualLayoutRange() {return __webpack_require__(/*! ./../../feathers/layout/VirtualLayoutRange */ "./lib/_gen/feathers/layout/VirtualLayoutRange.js");}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}
function haxe_ds_ObjectMap() {return __webpack_require__(/*! ./../../haxe/ds/ObjectMap */ "./lib/_gen/haxe/ds/ObjectMap.js");}
function feathers_utils_DisplayObjectRecycler() {return __webpack_require__(/*! ./../../feathers/utils/DisplayObjectRecycler */ "./lib/_gen/feathers/utils/DisplayObjectRecycler.js");}
function feathers_controls_dataRenderers_ItemRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/ItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ItemRenderer.js");}
function feathers_controls_supportClasses_AdvancedLayoutViewPort() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/AdvancedLayoutViewPort */ "./lib/_gen/feathers/controls/supportClasses/AdvancedLayoutViewPort.js");}

// Constructor

var ListView = function(dataProvider,changeListener) {
	this.__customItemRendererVariant = null;
	this.__layout = null;
	this._ignoreLayoutChanges = false;
	this._ignoreSelectionChange = false;
	this._pendingScrollDuration = null;
	this._pendingScrollIndex = -1;
	this.pointerSelectionEnabled = true;
	this._virtualLayout = true;
	this._selectable = true;
	this._layoutItems = [];
	this._tempVisibleIndices = new (feathers_layout_VirtualLayoutRange().default)(0,0);
	this._visibleIndices = new (feathers_layout_VirtualLayoutRange().default)(0,0);
	this._virtualCache = [];
	this._unrenderedData = [];
	this.itemStatePool = new (lime_utils_ObjectPool().default)(function() {
		return new (feathers_data_ListViewItemState().default)();
	});
	this.itemRendererToItemState = new (haxe_ds_ObjectMap().default)();
	this.dataToItemRenderer = new (haxe_ds_ObjectMap().default)();
	this._additionalStorage = null;
	this._defaultStorage = new (feathers_controls__$ListView_ItemRendererStorage().default)(null,(feathers_utils_DisplayObjectRecycler().default).withClass((feathers_controls_dataRenderers_ItemRenderer().default)));
	this._recyclerMap = null;
	this._forceItemStateUpdate = false;
	this._previousCustomItemRendererVariant = null;
	this._selectedItems = [];
	this._selectedIndices = [];
	this._selectionAnchorIndex = -1;
	this._allowMultipleSelection = false;
	this._selectedItem = null;
	this._selectedIndex = -1;
	this._childFocusEnabled = true;
	this.initializeListViewTheme();
	(feathers_controls_supportClasses_BaseScrollContainer().default).call(this);
	this.set_dataProvider(dataProvider);
	this.set_tabEnabled(true);
	this.focusRect = null;
	if(this.get_viewPort() == null) {
		this.listViewPort = new (feathers_controls_supportClasses_AdvancedLayoutViewPort().default)();
		this.addChild(this.listViewPort);
		this.set_viewPort(this.listViewPort);
	}
	this.addEventListener("keyDown",$bind(this,this.listView_keyDownHandler));
	if(changeListener != null) {
		this.addEventListener("change",changeListener);
	}
}

// Meta

ListView.__name__ = "feathers.controls.ListView";
ListView.__isInterface__ = false;
ListView.__interfaces__ = [(feathers_core_IFocusContainer().default),(feathers_core_IDataSelector().default),(feathers_core_IIndexSelector().default)];
ListView.__super__ = (feathers_controls_supportClasses_BaseScrollContainer().default);
ListView.prototype = $extend((feathers_controls_supportClasses_BaseScrollContainer().default).prototype, {
	get_tabEnabled: function() {
		if((this._selectable || this.get_maxScrollY() != this.get_minScrollY() || this.get_maxScrollX() != this.get_minScrollX()) && this._enabled) {
			return this.get_rawTabEnabled();
		} else {
			return false;
		}
	},
	get_childFocusEnabled: function() {
		if(this._enabled) {
			return this._childFocusEnabled;
		} else {
			return false;
		}
	},
	set_childFocusEnabled: function(value) {
		if(this._childFocusEnabled == value) {
			return this._childFocusEnabled;
		}
		this._childFocusEnabled = value;
		return this._childFocusEnabled;
	},
	get_dataProvider: function() {
		return this._dataProvider;
	},
	set_dataProvider: function(value) {
		if(this._dataProvider == value) {
			return this._dataProvider;
		}
		this._virtualCache.length = 0;
		if(this._dataProvider != null) {
			this._dataProvider.removeEventListener("change",$bind(this,this.listView_dataProvider_changeHandler));
			this._dataProvider.removeEventListener("addItem",$bind(this,this.listView_dataProvider_addItemHandler));
			this._dataProvider.removeEventListener("removeItem",$bind(this,this.listView_dataProvider_removeItemHandler));
			this._dataProvider.removeEventListener("replaceItem",$bind(this,this.listView_dataProvider_replaceItemHandler));
			this._dataProvider.removeEventListener("removeAll",$bind(this,this.listView_dataProvider_removeAllHandler));
			this._dataProvider.removeEventListener("reset",$bind(this,this.listView_dataProvider_resetHandler));
			this._dataProvider.removeEventListener("sortChange",$bind(this,this.listView_dataProvider_sortChangeHandler));
			this._dataProvider.removeEventListener("filterChange",$bind(this,this.listView_dataProvider_filterChangeHandler));
			this._dataProvider.removeEventListener("updateItem",$bind(this,this.listView_dataProvider_updateItemHandler));
			this._dataProvider.removeEventListener("updateAll",$bind(this,this.listView_dataProvider_updateAllHandler));
		}
		this._dataProvider = value;
		if(this._dataProvider != null) {
			this._virtualCache.length = this._dataProvider.get_length();
			this._dataProvider.addEventListener("change",$bind(this,this.listView_dataProvider_changeHandler));
			this._dataProvider.addEventListener("addItem",$bind(this,this.listView_dataProvider_addItemHandler));
			this._dataProvider.addEventListener("removeItem",$bind(this,this.listView_dataProvider_removeItemHandler));
			this._dataProvider.addEventListener("replaceItem",$bind(this,this.listView_dataProvider_replaceItemHandler));
			this._dataProvider.addEventListener("removeAll",$bind(this,this.listView_dataProvider_removeAllHandler));
			this._dataProvider.addEventListener("reset",$bind(this,this.listView_dataProvider_resetHandler));
			this._dataProvider.addEventListener("sortChange",$bind(this,this.listView_dataProvider_sortChangeHandler));
			this._dataProvider.addEventListener("filterChange",$bind(this,this.listView_dataProvider_filterChangeHandler));
			this._dataProvider.addEventListener("updateItem",$bind(this,this.listView_dataProvider_updateItemHandler));
			this._dataProvider.addEventListener("updateAll",$bind(this,this.listView_dataProvider_updateAllHandler));
		}
		this.set_scrollX(0.0);
		this.set_scrollY(0.0);
		this.set_selectedIndex(-1);
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._dataProvider;
	},
	get_selectedIndex: function() {
		return this._selectedIndex;
	},
	set_selectedIndex: function(value) {
		if(!this._selectable || this._dataProvider == null) {
			value = -1;
		}
		if(this._selectedIndex == value && this._selectedIndices.length <= 1) {
			return this._selectedIndex;
		}
		if(value == -1) {
			this._selectionAnchorIndex = -1;
			this._selectedIndex = -1;
			this._selectedItem = null;
			this._selectedIndices.length = 0;
			this._selectedItems.length = 0;
			this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
			return this._selectedIndex;
		}
		this._selectedIndex = value;
		this._selectedItem = this._dataProvider.get(this._selectedIndex);
		this._selectedIndices.length = 1;
		this._selectedIndices[0] = this._selectedIndex;
		this._selectedItems.length = 1;
		this._selectedItems[0] = this._selectedItem;
		this._selectionAnchorIndex = this._selectedIndex;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedIndex;
	},
	get_maxSelectedIndex: function() {
		if(this._dataProvider == null) {
			return -1;
		}
		return this._dataProvider.get_length() - 1;
	},
	get_selectedItem: function() {
		return this._selectedItem;
	},
	set_selectedItem: function(value) {
		if(value == null || !this._selectable || this._dataProvider == null) {
			this.set_selectedIndex(-1);
			return this._selectedItem;
		}
		var index = this._dataProvider.indexOf(value);
		if(index == -1) {
			this.set_selectedIndex(-1);
			return this._selectedItem;
		}
		if(this._selectedItem == value && this._selectedIndex == index && this._selectedIndices.length == 1) {
			return this._selectedItem;
		}
		this._selectedIndex = index;
		this._selectedItem = value;
		this._selectedIndices.length = 1;
		this._selectedIndices[0] = this._selectedIndex;
		this._selectedItems.length = 1;
		this._selectedItems[0] = this._selectedItem;
		this._selectionAnchorIndex = this._selectedIndex;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedItem;
	},
	get_allowMultipleSelection: function() {
		return this._allowMultipleSelection;
	},
	set_allowMultipleSelection: function(value) {
		if(this._allowMultipleSelection == value) {
			return this._allowMultipleSelection;
		}
		this._allowMultipleSelection = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		return this._allowMultipleSelection;
	},
	get_selectedIndices: function() {
		return this._selectedIndices;
	},
	set_selectedIndices: function(value) {
		if(value == null || value.length == 0 || !this._selectable || this._dataProvider == null) {
			this.set_selectedIndex(-1);
			return this._selectedIndices;
		}
		if(this._selectedIndices == value) {
			return this._selectedIndices;
		}
		if(!this._allowMultipleSelection && value.length > 1) {
			value.length = 1;
		}
		this._selectedIndices = value;
		this._selectedIndex = this._selectedIndices[0];
		this._selectedItems.length = this._selectedIndices.length;
		var _g = 0;
		var _g1 = this._selectedIndices.length;
		while(_g < _g1) {
			var i = _g++;
			var index = this._selectedIndices[i];
			this._selectedItems[i] = this._dataProvider.get(index);
		}
		this._selectedItem = this._selectedItems[0];
		this._selectionAnchorIndex = this._selectedIndex;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedIndices;
	},
	get_selectedItems: function() {
		return this._selectedItems;
	},
	set_selectedItems: function(value) {
		if(value == null || value.length == 0 || !this._selectable || this._dataProvider == null) {
			this.set_selectedIndex(-1);
			return this._selectedItems;
		}
		if(this._selectedItems == value) {
			return this._selectedItems;
		}
		if(!this._allowMultipleSelection && value.length > 1) {
			value.length = 1;
		}
		var indices = [];
		var i = 0;
		while(i < value.length) {
			var item = value[i];
			var index = this._dataProvider.indexOf(item);
			if(index == -1) {
				value.splice(i,1);
				continue;
			}
			indices.push(index);
			++i;
		}
		this._selectedIndices = indices;
		this._selectedItems = value;
		if(value.length == 0) {
			this._selectedIndex = -1;
			this._selectedItem = null;
		} else {
			this._selectedIndex = this._selectedIndices[0];
			this._selectedItem = this._selectedItems[0];
		}
		this._selectionAnchorIndex = this._selectedIndex;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedIndices;
	},
	get_itemRendererRecycler: function() {
		return this._defaultStorage.itemRendererRecycler;
	},
	set_itemRendererRecycler: function(value) {
		if(this._defaultStorage.itemRendererRecycler == value) {
			return this._defaultStorage.itemRendererRecycler;
		}
		this._defaultStorage.oldItemRendererRecycler = this._defaultStorage.itemRendererRecycler;
		this._defaultStorage.itemRendererRecycler = value;
		this._defaultStorage.measurements = null;
		this.setInvalid(ListView.INVALIDATION_FLAG_ITEM_RENDERER_FACTORY);
		return this._defaultStorage.itemRendererRecycler;
	},
	get_forceItemStateUpdate: function() {
		return this._forceItemStateUpdate;
	},
	set_forceItemStateUpdate: function(value) {
		if(this._forceItemStateUpdate == value) {
			return this._forceItemStateUpdate;
		}
		this._forceItemStateUpdate = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._forceItemStateUpdate;
	},
	get_itemRendererRecyclerIDFunction: function() {
		return this._itemRendererRecyclerIDFunction;
	},
	set_itemRendererRecyclerIDFunction: function(value) {
		if(this._itemRendererRecyclerIDFunction == value) {
			return this._itemRendererRecyclerIDFunction;
		}
		this._itemRendererRecyclerIDFunction = value;
		this.setInvalid(ListView.INVALIDATION_FLAG_ITEM_RENDERER_FACTORY);
		return this._itemRendererRecyclerIDFunction;
	},
	get_selectable: function() {
		return this._selectable;
	},
	set_selectable: function(value) {
		if(this._selectable == value) {
			return this._selectable;
		}
		this._selectable = value;
		if(!this._selectable) {
			this.set_selectedIndex(-1);
		}
		return this._selectable;
	},
	get_virtualLayout: function() {
		return this._virtualLayout;
	},
	set_virtualLayout: function(value) {
		if(this._virtualLayout = value) {
			return this._virtualLayout;
		}
		this._virtualLayout = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		return this._virtualLayout;
	},
	itemToText: function(data) {
		return (Std().default).string(data);
	},
	itemToEnabled: function(data) {
		return true;
	},
	scrollToIndex: function(index,animationDuration) {
		if(this._dataProvider == null || this._dataProvider.get_length() == 0) {
			return;
		}
		this._pendingScrollIndex = index;
		this._pendingScrollDuration = animationDuration;
		this.setInvalid((feathers_core_InvalidationFlag().default).SCROLL);
	},
	itemToItemRenderer: function(item) {
		if(item == null) {
			return null;
		}
		return this.dataToItemRenderer.get(item);
	},
	itemRendererToItem: function(itemRenderer) {
		if(itemRenderer == null) {
			return null;
		}
		var state = this.itemRendererToItemState.get(itemRenderer);
		if(state == null) {
			return null;
		}
		return state.data;
	},
	indexToItemRenderer: function(index) {
		if(this._dataProvider == null || index < 0 || index >= this._dataProvider.get_length()) {
			return null;
		}
		var item = this._dataProvider.get(index);
		return this.dataToItemRenderer.get(item);
	},
	getItemRendererRecycler: function(id) {
		if(this._recyclerMap == null) {
			return null;
		}
		return this._recyclerMap.get(id);
	},
	setItemRendererRecycler: function(id,recycler) {
		if(this._recyclerMap == null) {
			this._recyclerMap = new (haxe_ds_StringMap().default)();
		}
		if(recycler == null) {
			this._recyclerMap.remove(id);
			return;
		}
		this._recyclerMap.set(id,recycler);
		this.setInvalid(ListView.INVALIDATION_FLAG_ITEM_RENDERER_FACTORY);
	},
	initializeListViewTheme: function() {
		(feathers_themes_steel_components_SteelListViewStyles().default).initialize();
	},
	update: function() {
		var layoutInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(this._previousCustomItemRendererVariant != this.get_customItemRendererVariant()) {
			this.setInvalidationFlag(ListView.INVALIDATION_FLAG_ITEM_RENDERER_FACTORY);
		}
		if(layoutInvalid || stylesInvalid) {
			if(this._previousLayout != this.get_layout()) {
				this._virtualCache.length = 0;
				if(this._dataProvider != null) {
					this._virtualCache.length = this._dataProvider.get_length();
				}
			}
			this.listViewPort.set_layout(this.get_layout());
			this._previousLayout = this.get_layout();
		}
		this.listViewPort.refreshChildren = $bind(this,this.refreshItemRenderers);
		var flag = this._invalidationFlags.keys();
		while(flag.hasNext()) {
			var flag1 = flag.next();
			this.listViewPort.setInvalid(flag1);
		}
		if(this._allInvalid) {
			this.listViewPort.setInvalid();
		}
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.update.call(this);
		this._previousCustomItemRendererVariant = this.get_customItemRendererVariant();
		this.handlePendingScroll();
	},
	createScroller: function() {
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.createScroller.call(this);
		this.listViewPort.set_scroller(this.scroller);
	},
	refreshScrollerValues: function() {
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.refreshScrollerValues.call(this);
		if((js_Boot().default).__implements(this.get_layout(),(feathers_layout_IScrollLayout().default))) {
			var scrollLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_IScrollLayout().default));
			this.scroller.forceElasticTop = scrollLayout.get_elasticTop();
			this.scroller.forceElasticRight = scrollLayout.get_elasticRight();
			this.scroller.forceElasticBottom = scrollLayout.get_elasticBottom();
			this.scroller.forceElasticLeft = scrollLayout.get_elasticLeft();
		} else {
			this.scroller.forceElasticTop = false;
			this.scroller.forceElasticRight = false;
			this.scroller.forceElasticBottom = false;
			this.scroller.forceElasticLeft = false;
		}
		this.scroller.snapPositionsX = this.listViewPort.get_snapPositionsX();
		this.scroller.snapPositionsY = this.listViewPort.get_snapPositionsY();
	},
	needsScrollMeasurement: function() {
		var oldStart = this._visibleIndices.start;
		var oldEnd = this._visibleIndices.end;
		if(this._virtualLayout && (js_Boot().default).__implements(this.get_layout(),(feathers_layout_IVirtualLayout().default))) {
			var virtualLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_IVirtualLayout().default));
			var oldIgnoreLayoutChanges = this._ignoreLayoutChanges;
			this._ignoreLayoutChanges = true;
			virtualLayout.set_scrollX(this.scroller.get_scrollX());
			virtualLayout.set_scrollY(this.scroller.get_scrollY());
			this._ignoreLayoutChanges = oldIgnoreLayoutChanges;
			virtualLayout.getVisibleIndices(this._layoutItems.length,this.listViewPort.get_visibleWidth(),this.listViewPort.get_visibleHeight(),this._tempVisibleIndices);
		} else {
			this._tempVisibleIndices.start = 0;
			this._tempVisibleIndices.end = this._layoutItems.length - 1;
		}
		if(oldStart == this._tempVisibleIndices.start) {
			return oldEnd != this._tempVisibleIndices.end;
		} else {
			return true;
		}
	},
	refreshItemRenderers: function(items) {
		this._layoutItems = items;
		if(this._defaultStorage.itemRendererRecycler.update == null) {
			this._defaultStorage.itemRendererRecycler.update = ListView.defaultUpdateItemRenderer;
			if(this._defaultStorage.itemRendererRecycler.reset == null) {
				this._defaultStorage.itemRendererRecycler.reset = ListView.defaultResetItemRenderer;
			}
		}
		if(this._recyclerMap != null) {
			var recycler = this._recyclerMap.iterator();
			while(recycler.hasNext()) {
				var recycler1 = recycler.next();
				if(recycler1.update == null) {
					if(recycler1.update == null) {
						recycler1.update = ListView.defaultUpdateItemRenderer;
						if(recycler1.reset == null) {
							recycler1.reset = ListView.defaultResetItemRenderer;
						}
					}
				}
			}
		}
		var itemRendererInvalid = this.listViewPort.isInvalid(ListView.INVALIDATION_FLAG_ITEM_RENDERER_FACTORY);
		this.refreshInactiveItemRenderers(this._defaultStorage,itemRendererInvalid);
		if(this._additionalStorage != null) {
			var _g = 0;
			var _g1 = this._additionalStorage.length;
			while(_g < _g1) {
				var i = _g++;
				var storage = this._additionalStorage[i];
				this.refreshInactiveItemRenderers(storage,itemRendererInvalid);
			}
		}
		this.findUnrenderedData();
		this.recoverInactiveItemRenderers(this._defaultStorage);
		if(this._additionalStorage != null) {
			var _g2 = 0;
			var _g11 = this._additionalStorage.length;
			while(_g2 < _g11) {
				var i1 = _g2++;
				var storage1 = this._additionalStorage[i1];
				this.recoverInactiveItemRenderers(storage1);
			}
		}
		this.renderUnrenderedData();
		this.freeInactiveItemRenderers(this._defaultStorage);
		if(this._defaultStorage.inactiveItemRenderers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive item renderers should be empty after updating."));
		}
		if(this._additionalStorage != null) {
			var _g3 = 0;
			var _g12 = this._additionalStorage.length;
			while(_g3 < _g12) {
				var i2 = _g3++;
				var storage2 = this._additionalStorage[i2];
				this.freeInactiveItemRenderers(storage2);
				if(storage2.inactiveItemRenderers.length > 0) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive item renderers " + storage2.id + " should be empty after updating."));
				}
			}
		}
	},
	refreshInactiveItemRenderers: function(storage,factoryInvalid) {
		var temp = storage.inactiveItemRenderers;
		storage.inactiveItemRenderers = storage.activeItemRenderers;
		storage.activeItemRenderers = temp;
		if(storage.activeItemRenderers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": active item renderers should be empty before updating."));
		}
		if(factoryInvalid) {
			this.recoverInactiveItemRenderers(storage);
			this.freeInactiveItemRenderers(storage);
			storage.oldItemRendererRecycler = null;
		}
	},
	recoverInactiveItemRenderers: function(storage) {
		var _g = 0;
		var _g1 = storage.inactiveItemRenderers;
		while(_g < _g1.length) {
			var itemRenderer = _g1[_g];
			++_g;
			if(itemRenderer == null) {
				continue;
			}
			var state = this.itemRendererToItemState.get(itemRenderer);
			if(state == null) {
				continue;
			}
			var item = state.data;
			this.itemRendererToItemState.remove(itemRenderer);
			this.dataToItemRenderer.remove(item);
			itemRenderer.removeEventListener("trigger",$bind(this,this.listView_itemRenderer_triggerHandler));
			itemRenderer.removeEventListener("click",$bind(this,this.listView_itemRenderer_clickHandler));
			itemRenderer.removeEventListener("touchTap",$bind(this,this.listView_itemRenderer_touchTapHandler));
			itemRenderer.removeEventListener("change",$bind(this,this.listView_itemRenderer_changeHandler));
			itemRenderer.removeEventListener("resize",$bind(this,this.listView_itemRenderer_resizeHandler));
			this.resetItemRenderer(itemRenderer,state,storage);
			if(storage.measurements != null) {
				storage.measurements.restore(itemRenderer);
			}
			this.itemStatePool.release(state);
		}
	},
	freeInactiveItemRenderers: function(storage) {
		var recycler = storage.oldItemRendererRecycler != null ? storage.oldItemRendererRecycler : storage.itemRendererRecycler;
		var _g = 0;
		var _g1 = storage.inactiveItemRenderers;
		while(_g < _g1.length) {
			var itemRenderer = _g1[_g];
			++_g;
			if(itemRenderer == null) {
				continue;
			}
			this.destroyItemRenderer(itemRenderer,recycler);
		}
		storage.inactiveItemRenderers.length = 0;
	},
	findUnrenderedData: function() {
		this._layoutItems.length = 0;
		this._visibleIndices.start = 0;
		this._visibleIndices.end = 0;
		if(this._dataProvider == null || this._dataProvider.get_length() == 0) {
			return;
		}
		this._layoutItems.length = this._dataProvider.get_length();
		if(this._virtualLayout && (js_Boot().default).__implements(this.get_layout(),(feathers_layout_IVirtualLayout().default))) {
			var virtualLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_IVirtualLayout().default));
			var oldIgnoreLayoutChanges = this._ignoreLayoutChanges;
			this._ignoreLayoutChanges = true;
			virtualLayout.set_scrollX(this.scroller.get_scrollX());
			virtualLayout.set_scrollY(this.scroller.get_scrollY());
			virtualLayout.set_virtualCache(this._virtualCache);
			this._ignoreLayoutChanges = oldIgnoreLayoutChanges;
			virtualLayout.getVisibleIndices(this._dataProvider.get_length(),this.listViewPort.get_visibleWidth(),this.listViewPort.get_visibleHeight(),this._visibleIndices);
		} else {
			this._visibleIndices.start = 0;
			var tmp = this._dataProvider.get_length();
			this._visibleIndices.end = tmp - 1;
		}
		var _g = this._visibleIndices.start;
		var _g1 = this._visibleIndices.end + 1;
		while(_g < _g1) {
			var i = _g++;
			var item = this._dataProvider.get(i);
			var itemRenderer = this.dataToItemRenderer.get(item);
			if(itemRenderer != null) {
				var state = this.itemRendererToItemState.get(itemRenderer);
				var changed = this.populateCurrentItemState(item,i,state,this._forceItemStateUpdate);
				var oldRecyclerID = state.recyclerID;
				var storage = this.itemStateToStorage(state);
				if(storage.id != oldRecyclerID) {
					this._unrenderedData.push(item);
					continue;
				}
				if(changed) {
					this.updateItemRenderer(itemRenderer,state,storage);
				}
				itemRenderer.set_visible(true);
				this._layoutItems[i] = itemRenderer;
				var removed = (HxOverrides().default).remove(storage.inactiveItemRenderers,itemRenderer);
				if(!removed) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": item renderer map contains bad data for item at index " + i + ". This may be caused by duplicate items in the data provider, which is not allowed."));
				}
				storage.activeItemRenderers.push(itemRenderer);
			} else {
				this._unrenderedData.push(item);
			}
		}
	},
	populateCurrentItemState: function(item,index,state,force) {
		var changed = false;
		if(force || state.owner != this) {
			state.owner = this;
			changed = true;
		}
		if(force || state.data != item) {
			state.data = item;
			changed = true;
		}
		if(force || state.index != index) {
			state.index = index;
			changed = true;
		}
		var selected = this._selectedIndices.indexOf(index) != -1;
		if(force || state.selected != selected) {
			state.selected = selected;
			changed = true;
		}
		var enabled = this._enabled && this.itemToEnabled(item);
		if(force || state.enabled != enabled) {
			state.enabled = enabled;
			changed = true;
		}
		var text = this.itemToText(item);
		if(force || state.text != text) {
			state.text = text;
			changed = true;
		}
		return changed;
	},
	resetItemRenderer: function(itemRenderer,state,storage) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		var recycler = storage.oldItemRendererRecycler != null ? storage.oldItemRendererRecycler : storage.itemRendererRecycler;
		if(recycler != null && recycler.reset != null) {
			recycler.reset(itemRenderer,state);
		}
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		this.refreshItemRendererProperties(itemRenderer,ListView.RESET_ITEM_STATE);
	},
	updateItemRenderer: function(itemRenderer,state,storage) {
		state.recyclerID = storage.id;
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		if(storage.itemRendererRecycler.update != null) {
			storage.itemRendererRecycler.update(itemRenderer,state);
		}
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		this.refreshItemRendererProperties(itemRenderer,state);
	},
	refreshItemRendererProperties: function(itemRenderer,state) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		if((js_Boot().default).__implements(itemRenderer,(feathers_core_IUIControl().default))) {
			var uiControl = (js_Boot().default).__cast(itemRenderer , (feathers_core_IUIControl().default));
			uiControl.set_enabled(state.enabled);
		}
		if((js_Boot().default).__implements(itemRenderer,(feathers_controls_dataRenderers_IDataRenderer().default))) {
			var dataRenderer = (js_Boot().default).__cast(itemRenderer , (feathers_controls_dataRenderers_IDataRenderer().default));
			dataRenderer.set_data(state.data);
		}
		if((js_Boot().default).__implements(itemRenderer,(feathers_controls_dataRenderers_IListViewItemRenderer().default))) {
			var listRenderer = (js_Boot().default).__cast(itemRenderer , (feathers_controls_dataRenderers_IListViewItemRenderer().default));
			listRenderer.set_index(state.index);
			listRenderer.set_listViewOwner(state.owner);
		}
		if((js_Boot().default).__implements(itemRenderer,(feathers_layout_ILayoutIndexObject().default))) {
			var layoutIndexObject = (js_Boot().default).__cast(itemRenderer , (feathers_layout_ILayoutIndexObject().default));
			layoutIndexObject.set_layoutIndex(state.index);
		}
		if((js_Boot().default).__implements(itemRenderer,(feathers_controls_IToggle().default))) {
			var toggle = (js_Boot().default).__cast(itemRenderer , (feathers_controls_IToggle().default));
			toggle.set_selected(state.selected);
		}
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
	},
	renderUnrenderedData: function() {
		var _g = 0;
		var _g1 = this._unrenderedData;
		while(_g < _g1.length) {
			var item = _g1[_g];
			++_g;
			var index = this._dataProvider.indexOf(item);
			var state = this.itemStatePool.get();
			this.populateCurrentItemState(item,index,state,true);
			var itemRenderer = this.createItemRenderer(state);
			itemRenderer.set_visible(true);
			this.listViewPort.addChild(itemRenderer);
			this._layoutItems[index] = itemRenderer;
		}
		this._unrenderedData.length = 0;
	},
	createItemRenderer: function(state) {
		var storage = this.itemStateToStorage(state);
		var itemRenderer = null;
		if(storage.inactiveItemRenderers.length == 0) {
			itemRenderer = storage.itemRendererRecycler.create();
			if((js_Boot().default).__implements(itemRenderer,(feathers_style_IVariantStyleObject().default))) {
				var variantItemRenderer = (js_Boot().default).__cast(itemRenderer , (feathers_style_IVariantStyleObject().default));
				if(variantItemRenderer.get_variant() == null) {
					var variant = this.get_customItemRendererVariant() != null ? this.get_customItemRendererVariant() : ListView.CHILD_VARIANT_ITEM_RENDERER;
					variantItemRenderer.set_variant(variant);
				}
			}
			if((js_Boot().default).__implements(itemRenderer,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(itemRenderer , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(storage.measurements == null) {
				storage.measurements = new (feathers_layout_Measurements().default)(itemRenderer);
			}
		} else {
			itemRenderer = storage.inactiveItemRenderers.shift();
		}
		this.updateItemRenderer(itemRenderer,state,storage);
		if((js_Boot().default).__implements(itemRenderer,(feathers_controls_ITriggerView().default))) {
			itemRenderer.addEventListener("trigger",$bind(this,this.listView_itemRenderer_triggerHandler));
		} else {
			itemRenderer.addEventListener("click",$bind(this,this.listView_itemRenderer_clickHandler));
		}
		if((js_Boot().default).__implements(itemRenderer,(feathers_controls_IToggle().default))) {
			itemRenderer.addEventListener("change",$bind(this,this.listView_itemRenderer_changeHandler));
		}
		if((js_Boot().default).__implements(itemRenderer,(feathers_core_IMeasureObject().default))) {
			itemRenderer.addEventListener("resize",$bind(this,this.listView_itemRenderer_resizeHandler));
		}
		this.itemRendererToItemState.set(itemRenderer,state);
		this.dataToItemRenderer.set(state.data,itemRenderer);
		storage.activeItemRenderers.push(itemRenderer);
		return itemRenderer;
	},
	destroyItemRenderer: function(itemRenderer,recycler) {
		this.listViewPort.removeChild(itemRenderer);
		if(recycler != null && recycler.destroy != null) {
			recycler.destroy(itemRenderer);
		}
	},
	itemStateToStorage: function(state) {
		var recyclerID = null;
		if(this._itemRendererRecyclerIDFunction != null) {
			recyclerID = this._itemRendererRecyclerIDFunction(state);
		}
		var recycler = null;
		if(recyclerID != null) {
			if(this._recyclerMap != null) {
				recycler = this._recyclerMap.get(recyclerID);
			}
			if(recycler == null) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Item renderer recycler ID \"" + recyclerID + "\" is not registered."));
			}
		}
		if(recycler == null) {
			return this._defaultStorage;
		}
		if(this._additionalStorage == null) {
			this._additionalStorage = [];
		}
		var _g = 0;
		var _g1 = this._additionalStorage.length;
		while(_g < _g1) {
			var i = _g++;
			var storage = this._additionalStorage[i];
			if(storage.itemRendererRecycler == recycler) {
				return storage;
			}
		}
		var storage1 = new (feathers_controls__$ListView_ItemRendererStorage().default)(recyclerID,recycler);
		this._additionalStorage.push(storage1);
		return storage1;
	},
	refreshSelectedIndicesAfterFilterOrSort: function() {
		if(this._selectedIndex == -1) {
			return;
		}
		this.set_selectedIndex(this._dataProvider.indexOf(this._selectedItem));
	},
	handleSelectionChange: function(item,index,ctrlKey,shiftKey) {
		if(index == -1 || !this._selectable) {
			this.set_selectedItem(null);
			return;
		}
		var selectionIndex = this._selectedItems.indexOf(item);
		if(this._allowMultipleSelection && (ctrlKey || shiftKey)) {
			if(shiftKey) {
				var anchorIndex = this._selectionAnchorIndex;
				if(anchorIndex == -1) {
					anchorIndex = 0;
				}
				var selectedIndices = [];
				if(index == anchorIndex) {
					selectedIndices.unshift(anchorIndex);
				} else {
					var i = anchorIndex;
					while(true) {
						selectedIndices.unshift(i);
						i += anchorIndex > index ? -1 : 1;
						if(!(i != index)) {
							break;
						}
					}
					if(index != anchorIndex) {
						selectedIndices.unshift(index);
					}
				}
				this.set_selectedIndices(selectedIndices);
				this._selectionAnchorIndex = anchorIndex;
			} else {
				if(selectionIndex == -1) {
					var selectedItems = this._selectedItems.slice();
					selectedItems.unshift(item);
					this.set_selectedItems(selectedItems);
				} else {
					var selectedItems1 = this._selectedItems.slice();
					selectedItems1.splice(selectionIndex,1);
					this.set_selectedItems(selectedItems1);
				}
				this._selectionAnchorIndex = index;
			}
		} else {
			this.set_selectedItem(item);
		}
	},
	handlePendingScroll: function() {
		if(this._pendingScrollIndex == -1) {
			return;
		}
		var index = this._pendingScrollIndex;
		var duration = this._pendingScrollDuration != null ? this._pendingScrollDuration : 0.0;
		this._pendingScrollIndex = -1;
		this._pendingScrollDuration = null;
		if(this._dataProvider == null || this._dataProvider.get_length() == 0) {
			return;
		}
		var targetX = this.get_scrollX();
		var targetY = this.get_scrollY();
		if((js_Boot().default).__implements(this.get_layout(),(feathers_layout_IScrollLayout().default))) {
			var scrollLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_IScrollLayout().default));
			var result = scrollLayout.getNearestScrollPositionForIndex(index,this._dataProvider.get_length(),this.get_viewPort().get_visibleWidth(),this.get_viewPort().get_visibleHeight());
			targetX = result.x;
			targetY = result.y;
		} else {
			var item = this._dataProvider.get(index);
			var itemRenderer = this.dataToItemRenderer.get(item);
			if(itemRenderer == null) {
				return;
			}
			var maxX = itemRenderer.get_x();
			var minX = maxX + itemRenderer.get_width() - this.get_viewPort().get_visibleWidth();
			if(targetX < minX) {
				targetX = minX;
			} else if(targetX > maxX) {
				targetX = maxX;
			}
			var maxY = itemRenderer.get_y();
			var minY = maxY + itemRenderer.get_height() - this.get_viewPort().get_visibleHeight();
			if(targetY < minY) {
				targetY = minY;
			} else if(targetY > maxY) {
				targetY = maxY;
			}
		}
		if(duration == 0.0) {
			this.scroller.set_scrollX(targetX);
			this.scroller.set_scrollY(targetY);
		} else {
			this.scroller.throwTo(targetX,targetY,duration);
		}
	},
	listView_itemRenderer_touchTapHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(event.isPrimaryTouchPoint) {
			return;
		}
		var itemRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this.itemRendererToItemState.get(itemRenderer);
		(feathers_events_ListViewEvent().default).dispatch(this,"itemTrigger",state);
		if(!this._selectable || !this.pointerSelectionEnabled) {
			return;
		}
		this.handleSelectionChange(state.data,state.index,event.ctrlKey,event.shiftKey);
	},
	listView_itemRenderer_clickHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		var itemRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this.itemRendererToItemState.get(itemRenderer);
		(feathers_events_ListViewEvent().default).dispatch(this,"itemTrigger",state);
		if(!this._selectable || !this.pointerSelectionEnabled) {
			return;
		}
		this.handleSelectionChange(state.data,state.index,event.ctrlKey,event.shiftKey);
	},
	listView_itemRenderer_triggerHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		var itemRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this.itemRendererToItemState.get(itemRenderer);
		(feathers_events_ListViewEvent().default).dispatch(this,"itemTrigger",state);
		if(!this._selectable) {
			return;
		}
		this.handleSelectionChange(state.data,state.index,event.ctrlKey,event.shiftKey);
	},
	listView_itemRenderer_resizeHandler: function(event) {
		if(this._validating) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	listView_itemRenderer_changeHandler: function(event) {
		if(this._ignoreSelectionChange) {
			return;
		}
		var itemRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var toggleItemRenderer = (js_Boot().default).__cast(itemRenderer , (feathers_controls_IToggle().default));
		var state = this.itemRendererToItemState.get(itemRenderer);
		if(toggleItemRenderer.get_selected() == state.selected) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
	},
	listView_dataProvider_changeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
	},
	listView_dataProvider_addItemHandler: function(event) {
		if(this._virtualCache != null) {
			this._virtualCache.splice(event.index,0,null);
		}
		if(this._selectedIndex == -1) {
			return;
		}
		var changed = false;
		var _g = 0;
		var _g1 = this._selectedIndices.length;
		while(_g < _g1) {
			var i = _g++;
			var selectedIndex = this._selectedIndices[i];
			if(selectedIndex >= event.index) {
				this._selectedIndices[i] = selectedIndex + 1;
				changed = true;
			}
		}
		if(changed) {
			this._selectedIndex = this._selectedIndices[0];
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
		}
	},
	listView_dataProvider_removeItemHandler: function(event) {
		if(this._virtualCache != null) {
			(HxOverrides().default).remove(this._virtualCache,event.index);
		}
		if(this.get_selectedIndex() == -1) {
			return;
		}
		var changed = false;
		var i = this._selectedIndices.length - 1;
		while(i >= 0) {
			var selectedIndex = this._selectedIndices[i];
			if(selectedIndex == event.index) {
				this._selectedIndices.splice(i,1);
				this._selectedItems.splice(i,1);
				changed = true;
			} else if(selectedIndex > event.index) {
				this._selectedIndices[i] = selectedIndex - 1;
				changed = true;
			}
			--i;
		}
		if(changed) {
			if(this._selectedIndices.length > 0) {
				this._selectedIndex = this._selectedIndices[0];
				this._selectedItem = this._dataProvider.get(this._selectedIndex);
			} else {
				this._selectedIndex = -1;
				this._selectedItem = null;
			}
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
		}
	},
	listView_dataProvider_replaceItemHandler: function(event) {
		if(this._virtualCache != null) {
			this._virtualCache[event.index] = null;
		}
		if(this._selectedIndex == -1) {
			return;
		}
		var _g = 0;
		var _g1 = this._selectedIndices.length;
		while(_g < _g1) {
			var i = _g++;
			var selectedIndex = this._selectedIndices[i];
			if(selectedIndex == event.index) {
				this._selectedItems[i] = this._dataProvider.get(selectedIndex);
				this._selectedItem = this._selectedItems[0];
				(feathers_events_FeathersEvent().default).dispatch(this,"change");
				break;
			}
		}
	},
	listView_dataProvider_removeAllHandler: function(event) {
		if(this._virtualCache != null) {
			this._virtualCache.length = 0;
		}
		this.set_selectedIndex(-1);
	},
	listView_dataProvider_resetHandler: function(event) {
		if(this._virtualCache != null) {
			this._virtualCache.length = 0;
			this._virtualCache.length = this._dataProvider.get_length();
		}
		this.set_selectedIndex(-1);
	},
	listView_dataProvider_sortChangeHandler: function(event) {
		if(this._virtualCache != null) {
			this._virtualCache.length = 0;
			this._virtualCache.length = this._dataProvider.get_length();
		}
		this.refreshSelectedIndicesAfterFilterOrSort();
	},
	listView_dataProvider_filterChangeHandler: function(event) {
		if(this._virtualCache != null) {
			this._virtualCache.length = 0;
			this._virtualCache.length = this._dataProvider.get_length();
		}
		this.refreshSelectedIndicesAfterFilterOrSort();
	},
	updateItemRendererForIndex: function(index) {
		if(this._virtualCache != null) {
			this._virtualCache[index] = null;
		}
		var item = this._dataProvider.get(index);
		var itemRenderer = this.dataToItemRenderer.get(item);
		if(itemRenderer == null) {
			this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
			return;
		}
		var state = this.itemRendererToItemState.get(itemRenderer);
		if(state.owner == null) {
			return;
		}
		var storage = this.itemStateToStorage(state);
		this.populateCurrentItemState(item,index,state,true);
		this.resetItemRenderer(itemRenderer,state,storage);
		if(storage.measurements != null) {
			storage.measurements.restore(itemRenderer);
		}
		state.owner = null;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
	},
	listView_dataProvider_updateItemHandler: function(event) {
		this.updateItemRendererForIndex(event.index);
	},
	listView_dataProvider_updateAllHandler: function(event) {
		var _g = 0;
		var _g1 = this._dataProvider.get_length();
		while(_g < _g1) {
			var i = _g++;
			this.updateItemRendererForIndex(i);
		}
	},
	navigateWithKeyboard: function(event) {
		if(event.isDefaultPrevented()) {
			return;
		}
		if(this._dataProvider == null || this._dataProvider.get_length() == 0) {
			return;
		}
		var result = this._selectedIndex;
		if((js_Boot().default).__implements(this.get_layout(),(feathers_layout_IKeyboardNavigationLayout().default))) {
			if(event.keyCode != 38 && event.keyCode != 40 && event.keyCode != 37 && event.keyCode != 39 && event.keyCode != 33 && event.keyCode != 34 && event.keyCode != 36 && event.keyCode != 35) {
				return;
			}
			result = ((js_Boot().default).__cast(this.get_layout() , (feathers_layout_IKeyboardNavigationLayout().default))).findNextKeyboardIndex(result,event,false,this._layoutItems,null,this.listViewPort.get_visibleWidth(),this.listViewPort.get_visibleHeight());
		} else {
			switch(event.keyCode) {
			case 33:
				--result;
				break;
			case 34:
				++result;
				break;
			case 35:
				result = this._dataProvider.get_length() - 1;
				break;
			case 36:
				result = 0;
				break;
			case 37:
				--result;
				break;
			case 38:
				--result;
				break;
			case 39:
				++result;
				break;
			case 40:
				++result;
				break;
			default:
				return;
			}
		}
		if(result < 0) {
			result = 0;
		} else if(result >= this._dataProvider.get_length()) {
			result = this._dataProvider.get_length() - 1;
		}
		var changed = this._selectedIndex != result;
		if(!changed && result != -1) {
			var itemRenderer = this.itemToItemRenderer(this._dataProvider.get(result));
			if(itemRenderer == null) {
				changed = true;
			}
		}
		if(!changed) {
			return;
		}
		event.preventDefault();
		this.set_selectedIndex(result);
		if(this._selectedIndex != -1) {
			this.scrollToIndex(this._selectedIndex);
		}
		if(this._focusManager != null) {
			this._focusManager.set_focus(this);
		} else if(this.stage != null) {
			this.stage.set_focus(this);
		}
	},
	baseScrollContainer_keyDownHandler: function(event) {
		if(!this._selectable) {
			(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.baseScrollContainer_keyDownHandler.call(this,event);
			return;
		}
		if(!this._enabled || event.isDefaultPrevented()) {
			return;
		}
		this.navigateWithKeyboard(event);
	},
	listView_keyDownHandler: function(event) {
		if(!this._enabled || event.isDefaultPrevented()) {
			return;
		}
		if(event.keyCode == 32 || event.keyCode == 13) {
			if(this._selectedItem != null) {
				var itemRenderer = this.dataToItemRenderer.get(this._selectedItem);
				var state = null;
				if(itemRenderer != null) {
					state = this.itemRendererToItemState.get(itemRenderer);
				}
				var isTemporary = false;
				if(state == null) {
					isTemporary = true;
					state = this.itemStatePool.get();
				}
				this.populateCurrentItemState(this._selectedItem,this._selectedIndex,state,true);
				(feathers_events_ListViewEvent().default).dispatch(this,"itemTrigger",state);
				if(isTemporary) {
					this.itemStatePool.release(state);
				}
			}
		}
	},
	get_styleContext: function() {
		return ListView
	},
	get_layout: function() {
		return this.__layout;
	},
	set_layout: function(value) {
		if(!this.setStyle("layout")) {
			return this.__layout;
		}
		if(this.__layout == value) {
			return this.__layout;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_layout);
		this.__layout = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__layout;
	},
	clearStyle_layout: function() {
		this.set_layout(null);
		return this.get_layout();
	},
	get_customItemRendererVariant: function() {
		return this.__customItemRendererVariant;
	},
	set_customItemRendererVariant: function(value) {
		if(!this.setStyle("customItemRendererVariant")) {
			return this.__customItemRendererVariant;
		}
		if(this.__customItemRendererVariant == value) {
			return this.__customItemRendererVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customItemRendererVariant);
		this.__customItemRendererVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customItemRendererVariant;
	},
	clearStyle_customItemRendererVariant: function() {
		this.set_customItemRendererVariant(null);
		return this.get_customItemRendererVariant();
	}
});
ListView.prototype.__class__ = ListView.prototype.constructor = $hxClasses["feathers.controls.ListView"] = ListView;

// Init



// Statics

ListView.defaultUpdateItemRenderer = function(itemRenderer,state) {
	if((js_Boot().default).__implements(itemRenderer,(feathers_core_ITextControl().default))) {
		var textControl = (js_Boot().default).__cast(itemRenderer , (feathers_core_ITextControl().default));
		textControl.set_text(state.text);
	}
}
ListView.defaultResetItemRenderer = function(itemRenderer,state) {
	if((js_Boot().default).__implements(itemRenderer,(feathers_core_ITextControl().default))) {
		var textControl = (js_Boot().default).__cast(itemRenderer , (feathers_core_ITextControl().default));
		textControl.set_text(null);
	}
}
ListView.__meta__ = { obj : { defaultXmlProperty : ["dataProvider"]}}
ListView.VARIANT_BORDERLESS = "borderless"
ListView.VARIANT_BORDER = "border"
ListView.VARIANT_POP_UP = "popUp"
ListView.CHILD_VARIANT_ITEM_RENDERER = "listView_itemRenderer"
ListView.INVALIDATION_FLAG_ITEM_RENDERER_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("itemRendererFactory")
ListView.RESET_ITEM_STATE = new (feathers_data_ListViewItemState().default)()

// Export

exports["default"] = ListView;

/***/ }),

/***/ "./lib/_gen/feathers/controls/NumericStepper.js":
/*!******************************************************!*\
  !*** ./lib/_gen/feathers/controls/NumericStepper.js ***!
  \******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.NumericStepper

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IStageFocusDelegate() {return __webpack_require__(/*! ./../../feathers/core/IStageFocusDelegate */ "./lib/_gen/feathers/core/IStageFocusDelegate.js");}
function feathers_controls_IRange() {return __webpack_require__(/*! ./../../feathers/controls/IRange */ "./lib/_gen/feathers/controls/IRange.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function feathers_themes_steel_components_SteelNumericStepperStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelNumericStepperStyles */ "./lib/_gen/feathers/themes/steel/components/SteelNumericStepperStyles.js");}
function feathers_layout_Direction() {return __webpack_require__(/*! ./../../feathers/layout/Direction */ "./lib/_gen/feathers/layout/Direction.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_utils_MathUtil() {return __webpack_require__(/*! ./../../feathers/utils/MathUtil */ "./lib/_gen/feathers/utils/MathUtil.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function feathers_utils_ExclusivePointer() {return __webpack_require__(/*! ./../../feathers/utils/ExclusivePointer */ "./lib/_gen/feathers/utils/ExclusivePointer.js");}
function feathers_utils_DisplayObjectFactory() {return __webpack_require__(/*! ./../../feathers/utils/DisplayObjectFactory */ "./lib/_gen/feathers/utils/DisplayObjectFactory.js");}
function feathers_controls_Button() {return __webpack_require__(/*! ./../../feathers/controls/Button */ "./lib/_gen/feathers/controls/Button.js");}
function feathers_controls_TextInput() {return __webpack_require__(/*! ./../../feathers/controls/TextInput */ "./lib/_gen/feathers/controls/TextInput.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}

// Constructor

var NumericStepper = function(value,minimum,maximum,changeListener) {
	if(maximum == null) {
		maximum = 1.0;
	}
	if(minimum == null) {
		minimum = 0.0;
	}
	if(value == null) {
		value = 0.0;
	}
	this.__buttonGap = 0.0;
	this.__textInputGap = 0.0;
	this.__buttonDirection = (feathers_layout_Direction().default).HORIZONTAL;
	this.__textInputPosition = (feathers_layout_HorizontalAlign().default).CENTER;
	this.__customTextInputVariant = null;
	this.__customIncrementButtonVariant = null;
	this.__customDecrementButtonVariant = null;
	this._pendingTextInputChanges = false;
	this._previousCustomTextInputVariant = null;
	this._previousCustomIncrementButtonVariant = null;
	this._previousCustomDecrementButtonVariant = null;
	this._enableButtonsAtRangeLimits = true;
	this._editable = true;
	this._snapInterval = 0.0;
	this._step = 0.01;
	this._maximum = 1.0;
	this._minimum = 0.0;
	this._value = 0.0;
	this._isDefaultValue = true;
	this.textInputMeasurements = new (feathers_layout_Measurements().default)();
	this.incrementButtonMeasurements = new (feathers_layout_Measurements().default)();
	this.decrementButtonMeasurements = new (feathers_layout_Measurements().default)();
	this.initializeNumericStepperTheme();
	(feathers_core_FeathersControl().default).call(this);
	this.addEventListener("focusIn",$bind(this,this.numericStepper_focusInHandler));
	this.set_minimum(minimum);
	this.set_maximum(maximum);
	this.set_value(value);
	if(changeListener != null) {
		this.addEventListener("change",changeListener);
	}
}

// Meta

NumericStepper.__name__ = "feathers.controls.NumericStepper";
NumericStepper.__isInterface__ = false;
NumericStepper.__interfaces__ = [(feathers_core_IStageFocusDelegate().default),(feathers_controls_IRange().default)];
NumericStepper.__super__ = (feathers_core_FeathersControl().default);
NumericStepper.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_value: function() {
		return this._value;
	},
	set_value: function(value) {
		if(this._value == value) {
			return this._value;
		}
		this._isDefaultValue = false;
		this._value = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._value;
	},
	get_minimum: function() {
		return this._minimum;
	},
	set_minimum: function(value) {
		if(this._minimum == value) {
			return this._minimum;
		}
		this._minimum = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._minimum;
	},
	get_maximum: function() {
		return this._maximum;
	},
	set_maximum: function(value) {
		if(this._maximum == value) {
			return this._maximum;
		}
		this._maximum = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._maximum;
	},
	get_step: function() {
		return this._step;
	},
	set_step: function(value) {
		if(this._step == value) {
			return this._step;
		}
		this._step = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._step;
	},
	get_snapInterval: function() {
		return this._snapInterval;
	},
	set_snapInterval: function(value) {
		if(this._snapInterval == value) {
			return this._snapInterval;
		}
		this._snapInterval = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._snapInterval;
	},
	get_editable: function() {
		return this._editable;
	},
	set_editable: function(value) {
		if(this._editable == value) {
			return this._editable;
		}
		this._editable = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STATE);
		return this._editable;
	},
	get_enableButtonsAtRangeLimits: function() {
		return this._enableButtonsAtRangeLimits;
	},
	set_enableButtonsAtRangeLimits: function(value) {
		if(this._enableButtonsAtRangeLimits == value) {
			return this._enableButtonsAtRangeLimits;
		}
		this._enableButtonsAtRangeLimits = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STATE);
		return this._enableButtonsAtRangeLimits;
	},
	get_valueFormatFunction: function() {
		return this._valueFormatFunction;
	},
	set_valueFormatFunction: function(value) {
		if(this._valueFormatFunction == value) {
			return this._valueFormatFunction;
		}
		this._valueFormatFunction = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._valueFormatFunction;
	},
	get_valueParseFunction: function() {
		return this._valueParseFunction;
	},
	set_valueParseFunction: function(value) {
		if(this._valueParseFunction == value) {
			return this._valueParseFunction;
		}
		this._valueParseFunction = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._valueParseFunction;
	},
	get_stageFocusTarget: function() {
		return this.textInput;
	},
	get_decrementButtonFactory: function() {
		return this._decrementButtonFactory;
	},
	set_decrementButtonFactory: function(value) {
		if(this._decrementButtonFactory == value) {
			return this._decrementButtonFactory;
		}
		this._decrementButtonFactory = value;
		this.setInvalid(NumericStepper.INVALIDATION_FLAG_DECREMENT_BUTTON_FACTORY);
		return this._decrementButtonFactory;
	},
	get_incrementButtonFactory: function() {
		return this._incrementButtonFactory;
	},
	set_incrementButtonFactory: function(value) {
		if(this._incrementButtonFactory == value) {
			return this._incrementButtonFactory;
		}
		this._incrementButtonFactory = value;
		this.setInvalid(NumericStepper.INVALIDATION_FLAG_INCREMENT_BUTTON_FACTORY);
		return this._incrementButtonFactory;
	},
	get_textInputFactory: function() {
		return this._textInputFactory;
	},
	set_textInputFactory: function(value) {
		if(this._textInputFactory == value) {
			return this._textInputFactory;
		}
		this._textInputFactory = value;
		this.setInvalid(NumericStepper.INVALIDATION_FLAG_TEXT_INPUT_FACTORY);
		return this._textInputFactory;
	},
	showFocus: function(show) {
		(feathers_core_FeathersControl().default).prototype.showFocus.call(this,show);
		if(this.textInput != null) {
			this.textInput.showFocus(show);
		}
	},
	applyValueRestrictions: function() {
		this.set_value(this.restrictValue(this._value));
	},
	initializeNumericStepperTheme: function() {
		(feathers_themes_steel_components_SteelNumericStepperStyles().default).initialize();
	},
	initialize: function() {
		(feathers_core_FeathersControl().default).prototype.initialize.call(this);
		if(this._isDefaultValue) {
			this.set_value(this.restrictValue(this._value));
		}
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var sizeInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SIZE);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(this._previousCustomTextInputVariant != this.get_customTextInputVariant()) {
			this.setInvalidationFlag(NumericStepper.INVALIDATION_FLAG_TEXT_INPUT_FACTORY);
		}
		if(this._previousCustomDecrementButtonVariant != this.get_customDecrementButtonVariant()) {
			this.setInvalidationFlag(NumericStepper.INVALIDATION_FLAG_DECREMENT_BUTTON_FACTORY);
		}
		if(this._previousCustomIncrementButtonVariant != this.get_customIncrementButtonVariant()) {
			this.setInvalidationFlag(NumericStepper.INVALIDATION_FLAG_INCREMENT_BUTTON_FACTORY);
		}
		var decrementButtonFactoryInvalid = this.isInvalid(NumericStepper.INVALIDATION_FLAG_DECREMENT_BUTTON_FACTORY);
		var incrementButtonFactoryInvalid = this.isInvalid(NumericStepper.INVALIDATION_FLAG_INCREMENT_BUTTON_FACTORY);
		var textInputFactoryInvalid = this.isInvalid(NumericStepper.INVALIDATION_FLAG_TEXT_INPUT_FACTORY);
		if(decrementButtonFactoryInvalid) {
			this.createDecrementButton();
		}
		if(incrementButtonFactoryInvalid) {
			this.createIncrementButton();
		}
		if(textInputFactoryInvalid) {
			this.createTextInput();
		}
		if(stateInvalid || dataInvalid) {
			this.refreshEnabled();
		}
		if(stateInvalid) {
			this.refreshEditable();
		}
		if(dataInvalid) {
			this.refreshMeasureText();
		}
		if(dataInvalid) {
			this.refreshTextInputData();
		}
		sizeInvalid = this.measure() || sizeInvalid;
		this.layoutContent();
		this._previousCustomTextInputVariant = this.get_customTextInputVariant();
		this._previousCustomDecrementButtonVariant = this.get_customDecrementButtonVariant();
		this._previousCustomIncrementButtonVariant = this.get_customIncrementButtonVariant();
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		this.decrementButtonMeasurements.restore(this.decrementButton);
		this.decrementButton.validateNow();
		this.incrementButtonMeasurements.restore(this.incrementButton);
		this.incrementButton.validateNow();
		this.textInputMeasurements.restore(this.textInput);
		this.textInput.validateNow();
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			var buttonWidth = Math.max(this.decrementButton.get_width(),this.incrementButton.get_width());
			if(this.get_buttonDirection() == (feathers_layout_Direction().default).VERTICAL) {
				if(this.get_textInputPosition() == (feathers_layout_HorizontalAlign().default).CENTER) {
					newWidth = Math.max(this.textInput.get_width(),buttonWidth);
				} else {
					newWidth = this.textInput.get_width() + this.get_textInputGap() + buttonWidth;
				}
			} else if(this.get_textInputPosition() == (feathers_layout_HorizontalAlign().default).CENTER) {
				newWidth = 2.0 * (buttonWidth + this.get_textInputGap()) + this.textInput.get_width();
			} else {
				newWidth = 2.0 * buttonWidth + this.get_buttonGap() + this.get_textInputGap() + this.textInput.get_width();
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			var buttonHeight = Math.max(this.decrementButton.get_height(),this.incrementButton.get_height());
			if(this.get_buttonDirection() == (feathers_layout_Direction().default).VERTICAL) {
				if(this.get_textInputPosition() == (feathers_layout_HorizontalAlign().default).CENTER) {
					newHeight = 2.0 * (buttonHeight + this.get_textInputGap()) + this.textInput.get_height();
				} else {
					newHeight = Math.max(this.textInput.get_height(),2.0 * buttonHeight + this.get_buttonGap());
				}
			} else {
				newHeight = Math.max(this.textInput.get_height(),buttonHeight);
			}
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			var buttonWidth1 = Math.max(this.decrementButton.get_width(),this.incrementButton.get_width());
			if(this.get_buttonDirection() == (feathers_layout_Direction().default).VERTICAL) {
				if(this.get_textInputPosition() == (feathers_layout_HorizontalAlign().default).CENTER) {
					newMinWidth = Math.max(this.textInput.get_minWidth(),buttonWidth1);
				} else {
					newMinWidth = this.textInput.get_minWidth() + this.get_textInputGap() + buttonWidth1;
				}
			} else if(this.get_textInputPosition() == (feathers_layout_HorizontalAlign().default).CENTER) {
				newMinWidth = 2.0 * (buttonWidth1 + this.get_textInputGap()) + this.textInput.get_minWidth();
			} else {
				newMinWidth = 2.0 * buttonWidth1 + this.get_buttonGap() + this.get_textInputGap() + this.textInput.get_minWidth();
			}
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			var buttonHeight1 = Math.max(this.decrementButton.get_height(),this.incrementButton.get_height());
			if(this.get_buttonDirection() == (feathers_layout_Direction().default).VERTICAL) {
				if(this.get_textInputPosition() == (feathers_layout_HorizontalAlign().default).CENTER) {
					newMinHeight = 2.0 * (buttonHeight1 + this.get_textInputGap()) + this.textInput.get_minHeight();
				} else {
					newMinHeight = Math.max(this.textInput.get_minHeight(),2.0 * buttonHeight1 + this.get_buttonGap());
				}
			} else {
				newMinHeight = Math.max(this.textInput.get_minHeight(),buttonHeight1);
			}
		}
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight);
	},
	refreshMeasureText: function() {
		var maxCharactersBeforeDecimal = (Std().default).int(Math.max(Math.max((Std().default).string((Std().default).int(this._minimum)).length,(Std().default).string((Std().default).int(this._maximum)).length),(Std().default).string((Std().default).int(this._step)).length));
		var maxCharactersAfterDecimal = (Std().default).int(Math.max(Math.max((Std().default).string((feathers_utils_MathUtil().default).roundToPrecision(this._minimum - (Std().default).int(this._minimum),10)).length,(Std().default).string((feathers_utils_MathUtil().default).roundToPrecision(this._maximum - (Std().default).int(this._maximum),10)).length),(Std().default).string((feathers_utils_MathUtil().default).roundToPrecision(this._step - (Std().default).int(this._step),10)).length)) - 2;
		if(maxCharactersAfterDecimal < 0) {
			maxCharactersAfterDecimal = 0;
		}
		var measureText = "";
		var _g = 0;
		var _g1 = maxCharactersBeforeDecimal + maxCharactersAfterDecimal;
		while(_g < _g1) {
			var i = _g++;
			measureText += "0";
		}
		if(maxCharactersAfterDecimal > 0) {
			measureText += ".";
		}
		this.textInput.set_measureText(measureText);
	},
	refreshEnabled: function() {
		this.decrementButton.set_enabled(this._enabled && (this._enableButtonsAtRangeLimits || this._value != this._minimum));
		this.incrementButton.set_enabled(this._enabled && (this._enableButtonsAtRangeLimits || this._value != this._maximum));
		this.textInput.set_enabled(this._enabled);
	},
	refreshEditable: function() {
		this.textInput.set_editable(this._editable);
	},
	refreshTextInputData: function() {
		var valueToFormat = (feathers_utils_MathUtil().default).roundToPrecision(this._value,10);
		if(this._valueFormatFunction != null) {
			this.textInput.set_text(this._valueFormatFunction(valueToFormat));
		} else {
			this.textInput.set_text(valueToFormat == null ? "null" : "" + valueToFormat);
		}
	},
	parseTextInputValue: function() {
		var newValue = this._value;
		if(this._valueFormatFunction != null) {
			newValue = this._valueParseFunction(this.textInput.get_text());
		} else {
			newValue = (Std().default).parseFloat(this.textInput.get_text());
		}
		if(!isNaN(newValue)) {
			newValue = this.restrictValue(newValue);
			this.set_value(newValue);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		this._pendingTextInputChanges = false;
	},
	layoutContent: function() {
		this.decrementButton.validateNow();
		this.incrementButton.validateNow();
		this.textInput.validateNow();
		if(this.get_buttonDirection() == (feathers_layout_Direction().default).VERTICAL) {
			this.layoutContentWithVerticalButtons();
		} else {
			this.layoutContentWithHorizontalButtons();
		}
	},
	layoutContentWithHorizontalButtons: function() {
		var buttonWidth = Math.max(this.decrementButton.get_width(),this.incrementButton.get_width());
		var textInputWidth = this.actualWidth;
		if(this.get_textInputPosition() == (feathers_layout_HorizontalAlign().default).CENTER) {
			textInputWidth -= 2.0 * (buttonWidth + this.get_textInputGap());
		} else {
			textInputWidth -= 2.0 * buttonWidth + this.get_buttonGap() + this.get_textInputGap();
		}
		textInputWidth = Math.max(0.0,textInputWidth);
		if(this.textInput.get_width() != textInputWidth) {
			this.textInput.set_width(textInputWidth);
		}
		if(this.textInput.get_height() != this.actualHeight) {
			this.textInput.set_height(this.actualHeight);
		}
		if(this.decrementButton.get_width() != buttonWidth) {
			this.decrementButton.set_width(buttonWidth);
		}
		if(this.decrementButton.get_height() != this.actualHeight) {
			this.decrementButton.set_height(this.actualHeight);
		}
		if(this.incrementButton.get_width() != buttonWidth) {
			this.incrementButton.set_width(buttonWidth);
		}
		if(this.incrementButton.get_height() != this.actualHeight) {
			this.incrementButton.set_height(this.actualHeight);
		}
		switch(this.get_textInputPosition()._hx_index) {
		case 0:
			this.textInput.set_x(0.0);
			this.textInput.set_y(0.0);
			this.incrementButton.set_x(this.actualWidth - buttonWidth);
			this.incrementButton.set_y(0.0);
			this.decrementButton.set_x(this.actualWidth - 2.0 * buttonWidth - this.get_buttonGap());
			this.decrementButton.set_y(0.0);
			break;
		case 1:
			this.decrementButton.set_x(0.0);
			this.decrementButton.set_y(0.0);
			this.incrementButton.set_x(this.actualWidth - buttonWidth);
			this.incrementButton.set_y(0.0);
			this.textInput.set_x(buttonWidth + this.get_textInputGap());
			this.textInput.set_y(0.0);
			break;
		case 2:
			this.decrementButton.set_x(0.0);
			this.decrementButton.set_y(0.0);
			this.incrementButton.set_x(buttonWidth + this.get_buttonGap());
			this.incrementButton.set_y(0.0);
			this.textInput.set_x(this.actualWidth - textInputWidth);
			this.textInput.set_y(0.0);
			break;
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Invalid text input position: " + (Std().default).string(this.get_textInputPosition())));
		}
	},
	layoutContentWithVerticalButtons: function() {
		switch(this.get_textInputPosition()._hx_index) {
		case 0:
			var buttonWidth = Math.max(this.incrementButton.get_width(),this.decrementButton.get_width());
			var buttonHeight = (this.actualHeight - this.get_buttonGap()) / 2.0;
			var textInputWidth = Math.max(0.0,this.actualWidth - buttonWidth - this.get_textInputGap());
			if(this.textInput.get_width() != textInputWidth) {
				this.textInput.set_width(textInputWidth);
			}
			if(this.textInput.get_height() != this.actualHeight) {
				this.textInput.set_height(this.actualHeight);
			}
			this.textInput.set_x(0.0);
			this.textInput.set_y(0.0);
			this.incrementButton.set_x(this.actualWidth - buttonWidth);
			this.incrementButton.set_y(0.0);
			if(this.incrementButton.get_width() != buttonWidth) {
				this.incrementButton.set_width(buttonWidth);
			}
			if(this.incrementButton.get_height() != buttonHeight) {
				this.incrementButton.set_height(buttonHeight);
			}
			this.decrementButton.set_x(this.actualWidth - buttonWidth);
			this.decrementButton.set_y(this.actualHeight - buttonHeight);
			if(this.decrementButton.get_width() != buttonWidth) {
				this.decrementButton.set_width(buttonWidth);
			}
			if(this.decrementButton.get_height() != buttonHeight) {
				this.decrementButton.set_height(buttonHeight);
			}
			break;
		case 1:
			var buttonHeight1 = Math.max(this.decrementButton.get_height(),this.incrementButton.get_height());
			var textInputHeight = Math.max(0.0,this.actualHeight - 2.0 * (buttonHeight1 + this.get_textInputGap()));
			this.incrementButton.set_x(0.0);
			this.incrementButton.set_y(0.0);
			if(this.incrementButton.get_width() != this.actualWidth) {
				this.incrementButton.set_width(this.actualWidth);
			}
			if(this.incrementButton.get_height() != buttonHeight1) {
				this.incrementButton.set_height(buttonHeight1);
			}
			this.textInput.set_x(0.0);
			this.textInput.set_y(buttonHeight1 + this.get_textInputGap());
			if(this.textInput.get_width() != this.actualWidth) {
				this.textInput.set_width(this.actualWidth);
			}
			if(this.textInput.get_height() != textInputHeight) {
				this.textInput.set_height(textInputHeight);
			}
			this.decrementButton.set_x(0.0);
			this.decrementButton.set_y(this.actualHeight - buttonHeight1);
			if(this.decrementButton.get_width() != this.actualWidth) {
				this.decrementButton.set_width(this.actualWidth);
			}
			if(this.decrementButton.get_height() != buttonHeight1) {
				this.decrementButton.set_height(buttonHeight1);
			}
			break;
		case 2:
			var buttonWidth1 = Math.max(this.incrementButton.get_width(),this.decrementButton.get_width());
			var buttonHeight2 = (this.actualHeight - this.get_buttonGap()) / 2.0;
			var textInputWidth1 = Math.max(0.0,this.actualWidth - buttonWidth1 - this.get_textInputGap());
			if(this.textInput.get_width() != textInputWidth1) {
				this.textInput.set_width(textInputWidth1);
			}
			if(this.textInput.get_height() != this.actualHeight) {
				this.textInput.set_height(this.actualHeight);
			}
			this.textInput.set_x(this.actualWidth - textInputWidth1);
			this.textInput.set_y(0.0);
			this.incrementButton.set_x(0.0);
			this.incrementButton.set_y(0.0);
			if(this.incrementButton.get_width() != buttonWidth1) {
				this.incrementButton.set_width(buttonWidth1);
			}
			if(this.incrementButton.get_height() != buttonHeight2) {
				this.incrementButton.set_height(buttonHeight2);
			}
			this.decrementButton.set_x(0.0);
			this.decrementButton.set_y(this.actualHeight - buttonHeight2);
			if(this.decrementButton.get_width() != buttonWidth1) {
				this.decrementButton.set_width(buttonWidth1);
			}
			if(this.decrementButton.get_height() != buttonHeight2) {
				this.decrementButton.set_height(buttonHeight2);
			}
			break;
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Invalid text input position: " + (Std().default).string(this.get_textInputPosition())));
		}
	},
	createDecrementButton: function() {
		if(this.decrementButton != null) {
			this.decrementButton.removeEventListener("mouseDown",$bind(this,this.numericStepper_decrementButton_mouseDownHandler));
			this.decrementButton.removeEventListener("touchBegin",$bind(this,this.numericStepper_decrementButton_touchBeginHandler));
			this.removeChild(this.decrementButton);
			if(this._oldDecrementButtonFactory.destroy != null) {
				this._oldDecrementButtonFactory.destroy(this.decrementButton);
			}
			this._oldDecrementButtonFactory = null;
			this.decrementButton = null;
		}
		var factory = this._decrementButtonFactory != null ? this._decrementButtonFactory : NumericStepper.defaultDecrementButtonFactory;
		this._oldDecrementButtonFactory = factory;
		this.decrementButton = factory.create();
		if(this.decrementButton.get_variant() == null) {
			this.decrementButton.set_variant(this.get_customDecrementButtonVariant() != null ? this.get_customDecrementButtonVariant() : NumericStepper.CHILD_VARIANT_DECREMENT_BUTTON);
		}
		if(this.decrementButton.get_text() == null) {
			this.decrementButton.set_text("-");
		}
		this.decrementButton.addEventListener("mouseDown",$bind(this,this.numericStepper_decrementButton_mouseDownHandler));
		this.decrementButton.addEventListener("touchBegin",$bind(this,this.numericStepper_decrementButton_touchBeginHandler));
		this.decrementButton.initializeNow();
		this.decrementButtonMeasurements.save(this.decrementButton);
		this.addChild(this.decrementButton);
	},
	createIncrementButton: function() {
		if(this.incrementButton != null) {
			this.incrementButton.removeEventListener("mouseDown",$bind(this,this.numericStepper_incrementButton_mouseDownHandler));
			this.incrementButton.removeEventListener("touchBegin",$bind(this,this.numericStepper_incrementButton_touchBeginHandler));
			this.removeChild(this.incrementButton);
			if(this._oldIncrementButtonFactory.destroy != null) {
				this._oldIncrementButtonFactory.destroy(this.incrementButton);
			}
			this._oldIncrementButtonFactory = null;
			this.incrementButton = null;
		}
		var factory = this._incrementButtonFactory != null ? this._incrementButtonFactory : NumericStepper.defaultIncrementButtonFactory;
		this._oldIncrementButtonFactory = factory;
		this.incrementButton = factory.create();
		if(this.incrementButton.get_variant() == null) {
			this.incrementButton.set_variant(this.get_customIncrementButtonVariant() != null ? this.get_customIncrementButtonVariant() : NumericStepper.CHILD_VARIANT_INCREMENT_BUTTON);
		}
		if(this.incrementButton.get_text() == null) {
			this.incrementButton.set_text("+");
		}
		this.incrementButton.addEventListener("mouseDown",$bind(this,this.numericStepper_incrementButton_mouseDownHandler));
		this.incrementButton.addEventListener("touchBegin",$bind(this,this.numericStepper_incrementButton_touchBeginHandler));
		this.incrementButton.initializeNow();
		this.incrementButtonMeasurements.save(this.incrementButton);
		this.addChild(this.incrementButton);
	},
	createTextInput: function() {
		if(this.textInput != null) {
			this.textInput.removeEventListener("keyDown",$bind(this,this.numericStepper_textInput_keyDownHandler));
			this.textInput.removeEventListener("change",$bind(this,this.numericStepper_textInput_changeHandler));
			this.textInput.removeEventListener("focusIn",$bind(this,this.numericStepper_textInput_focusInHandler));
			this.textInput.removeEventListener("focusOut",$bind(this,this.numericStepper_textInput_focusOutHandler));
			this.removeChild(this.textInput);
			if(this._oldTextInputFactory.destroy != null) {
				this._oldTextInputFactory.destroy(this.textInput);
			}
			this._oldTextInputFactory = null;
			this.textInput = null;
		}
		var factory = this._textInputFactory != null ? this._textInputFactory : NumericStepper.defaultTextInputFactory;
		this._oldTextInputFactory = factory;
		this.textInput = factory.create();
		if(this.textInput.get_variant() == null) {
			this.textInput.set_variant(this.get_customTextInputVariant() != null ? this.get_customTextInputVariant() : NumericStepper.CHILD_VARIANT_TEXT_INPUT);
		}
		this.textInput.addEventListener("keyDown",$bind(this,this.numericStepper_textInput_keyDownHandler));
		this.textInput.addEventListener("change",$bind(this,this.numericStepper_textInput_changeHandler));
		this.textInput.addEventListener("focusIn",$bind(this,this.numericStepper_textInput_focusInHandler));
		this.textInput.addEventListener("focusOut",$bind(this,this.numericStepper_textInput_focusOutHandler));
		this.textInput.initializeNow();
		this.textInputMeasurements.save(this.textInput);
		this.addChild(this.textInput);
	},
	restrictValue: function(value) {
		if(this._snapInterval != 0.0 && value != this._minimum && value != this._maximum) {
			value = (feathers_utils_MathUtil().default).roundToNearest(value,this._snapInterval);
		}
		if(value < this._minimum) {
			value = this._minimum;
		} else if(value > this._maximum) {
			value = this._maximum;
		}
		return value;
	},
	decrement: function() {
		var newValue = this._value - this._step;
		newValue = this.restrictValue(newValue);
		this.set_value(newValue);
	},
	increment: function() {
		var newValue = this._value + this._step;
		newValue = this.restrictValue(newValue);
		this.set_value(newValue);
	},
	numericStepper_focusInHandler: function(event) {
		if(this.stage != null && this.stage.get_focus() != null && this.textInput != null && !this.textInput.contains(this.stage.get_focus())) {
			event.stopImmediatePropagation();
			this.stage.set_focus(this.textInput);
		}
	},
	canKeyCodeUpdateValue: function(keyCode) {
		if(!(keyCode == 38 || keyCode == 40 || keyCode == 36)) {
			return keyCode == 35;
		} else {
			return true;
		}
	},
	updateValueWithKeyboard: function(event) {
		if(event.isDefaultPrevented()) {
			return;
		}
		if(!this._enabled || !this.canKeyCodeUpdateValue(event.keyCode)) {
			return;
		}
		this.parseTextInputValue();
		var newValue = this._value;
		switch(event.keyCode) {
		case 35:
			newValue = this._maximum;
			break;
		case 36:
			newValue = this._minimum;
			break;
		case 38:
			newValue += this._step;
			break;
		case 40:
			newValue -= this._step;
			break;
		default:
			return;
		}
		if(newValue < this._minimum) {
			newValue = this._minimum;
		} else if(newValue > this._maximum) {
			newValue = this._maximum;
		}
		event.preventDefault();
		this.set_value(newValue);
		if(this.textInput.get_selectionActiveIndex() != this.textInput.get_selectionAnchorIndex()) {
			this.textInput.selectRange(this.textInput.get_selectionAnchorIndex(),this.textInput.get_selectionAnchorIndex());
		}
	},
	numericStepper_decrementButton_mouseDownHandler: function(event) {
		if(!this._enabled || !this.decrementButton.get_enabled() || this.stage == null) {
			return;
		}
		var exclusivePointer = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
		var result = exclusivePointer.claimMouse(this);
		if(!result) {
			return;
		}
		this.decrement();
	},
	numericStepper_decrementButton_touchBeginHandler: function(event) {
		if(event.isPrimaryTouchPoint) {
			return;
		}
		if(!this._enabled || !this.decrementButton.get_enabled() || this.stage == null) {
			return;
		}
		var exclusivePointer = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
		var result = exclusivePointer.claimMouse(this);
		if(!result) {
			return;
		}
		this.decrement();
	},
	numericStepper_incrementButton_mouseDownHandler: function(event) {
		if(!this._enabled || !this.incrementButton.get_enabled() || this.stage == null) {
			return;
		}
		var exclusivePointer = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
		var result = exclusivePointer.claimMouse(this);
		if(!result) {
			return;
		}
		this.increment();
	},
	numericStepper_incrementButton_touchBeginHandler: function(event) {
		if(event.isPrimaryTouchPoint) {
			return;
		}
		if(!this._enabled || !this.incrementButton.get_enabled() || this.stage == null) {
			return;
		}
		var exclusivePointer = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
		var result = exclusivePointer.claimMouse(this);
		if(!result) {
			return;
		}
		this.increment();
	},
	numericStepper_textInput_keyDownHandler: function(event) {
		if(!this._enabled || event.isDefaultPrevented()) {
			return;
		}
		if(event.keyCode == 13) {
			event.preventDefault();
			this.parseTextInputValue();
			return;
		} else {
			this.updateValueWithKeyboard(event);
		}
	},
	numericStepper_textInput_focusInHandler: function(event) {
		this._pendingTextInputChanges = false;
	},
	numericStepper_textInput_changeHandler: function(event) {
		this._pendingTextInputChanges = true;
	},
	numericStepper_textInput_focusOutHandler: function(event) {
		if(!this._pendingTextInputChanges) {
			return;
		}
		this.parseTextInputValue();
	},
	get_customDecrementButtonVariant: function() {
		return this.__customDecrementButtonVariant;
	},
	set_customDecrementButtonVariant: function(value) {
		if(!this.setStyle("customDecrementButtonVariant")) {
			return this.__customDecrementButtonVariant;
		}
		if(this.__customDecrementButtonVariant == value) {
			return this.__customDecrementButtonVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customDecrementButtonVariant);
		this.__customDecrementButtonVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customDecrementButtonVariant;
	},
	clearStyle_customDecrementButtonVariant: function() {
		this.set_customDecrementButtonVariant(null);
		return this.get_customDecrementButtonVariant();
	},
	get_customIncrementButtonVariant: function() {
		return this.__customIncrementButtonVariant;
	},
	set_customIncrementButtonVariant: function(value) {
		if(!this.setStyle("customIncrementButtonVariant")) {
			return this.__customIncrementButtonVariant;
		}
		if(this.__customIncrementButtonVariant == value) {
			return this.__customIncrementButtonVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customIncrementButtonVariant);
		this.__customIncrementButtonVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customIncrementButtonVariant;
	},
	clearStyle_customIncrementButtonVariant: function() {
		this.set_customIncrementButtonVariant(null);
		return this.get_customIncrementButtonVariant();
	},
	get_customTextInputVariant: function() {
		return this.__customTextInputVariant;
	},
	set_customTextInputVariant: function(value) {
		if(!this.setStyle("customTextInputVariant")) {
			return this.__customTextInputVariant;
		}
		if(this.__customTextInputVariant == value) {
			return this.__customTextInputVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customTextInputVariant);
		this.__customTextInputVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customTextInputVariant;
	},
	clearStyle_customTextInputVariant: function() {
		this.set_customTextInputVariant(null);
		return this.get_customTextInputVariant();
	},
	get_textInputPosition: function() {
		return this.__textInputPosition;
	},
	set_textInputPosition: function(value) {
		if(!this.setStyle("textInputPosition")) {
			return this.__textInputPosition;
		}
		if(this.__textInputPosition == value) {
			return this.__textInputPosition;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_textInputPosition);
		this.__textInputPosition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__textInputPosition;
	},
	clearStyle_textInputPosition: function() {
		this.set_textInputPosition((feathers_layout_HorizontalAlign().default).CENTER);
		return this.get_textInputPosition();
	},
	get_buttonDirection: function() {
		return this.__buttonDirection;
	},
	set_buttonDirection: function(value) {
		if(!this.setStyle("buttonDirection")) {
			return this.__buttonDirection;
		}
		if(this.__buttonDirection == value) {
			return this.__buttonDirection;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_buttonDirection);
		this.__buttonDirection = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__buttonDirection;
	},
	clearStyle_buttonDirection: function() {
		this.set_buttonDirection((feathers_layout_Direction().default).HORIZONTAL);
		return this.get_buttonDirection();
	},
	get_textInputGap: function() {
		return this.__textInputGap;
	},
	set_textInputGap: function(value) {
		if(!this.setStyle("textInputGap")) {
			return this.__textInputGap;
		}
		if(this.__textInputGap == value) {
			return this.__textInputGap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_textInputGap);
		this.__textInputGap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__textInputGap;
	},
	clearStyle_textInputGap: function() {
		this.set_textInputGap(0.0);
		return this.get_textInputGap();
	},
	get_buttonGap: function() {
		return this.__buttonGap;
	},
	set_buttonGap: function(value) {
		if(!this.setStyle("buttonGap")) {
			return this.__buttonGap;
		}
		if(this.__buttonGap == value) {
			return this.__buttonGap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_buttonGap);
		this.__buttonGap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__buttonGap;
	},
	clearStyle_buttonGap: function() {
		this.set_buttonGap(0.0);
		return this.get_buttonGap();
	}
});
NumericStepper.prototype.__class__ = NumericStepper.prototype.constructor = $hxClasses["feathers.controls.NumericStepper"] = NumericStepper;

// Init



// Statics


NumericStepper.INVALIDATION_FLAG_DECREMENT_BUTTON_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("decrementButtonFactory")
NumericStepper.INVALIDATION_FLAG_INCREMENT_BUTTON_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("incrementButtonFactory")
NumericStepper.INVALIDATION_FLAG_TEXT_INPUT_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("textInputFactory")
NumericStepper.CHILD_VARIANT_DECREMENT_BUTTON = "numericStepper_decrementButton"
NumericStepper.CHILD_VARIANT_INCREMENT_BUTTON = "numericStepper_incrementButton"
NumericStepper.CHILD_VARIANT_TEXT_INPUT = "numericStepper_textInput"
NumericStepper.defaultDecrementButtonFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_Button().default))
NumericStepper.defaultIncrementButtonFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_Button().default))
NumericStepper.defaultTextInputFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_TextInput().default))

// Export

exports["default"] = NumericStepper;

/***/ }),

/***/ "./lib/_gen/feathers/controls/PageIndicator.js":
/*!*****************************************************!*\
  !*** ./lib/_gen/feathers/controls/PageIndicator.js ***!
  \*****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.PageIndicator

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}
function feathers_core_IIndexSelector() {return __webpack_require__(/*! ./../../feathers/core/IIndexSelector */ "./lib/_gen/feathers/core/IIndexSelector.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_RangeError() {return (__webpack_require__(/*! openfl */ "openfl").errors.RangeError);}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function feathers_controls_PageIndicatorInteractionMode() {return __webpack_require__(/*! ./../../feathers/controls/PageIndicatorInteractionMode */ "./lib/_gen/feathers/controls/PageIndicatorInteractionMode.js");}
function feathers_themes_steel_components_SteelPageIndicatorStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelPageIndicatorStyles */ "./lib/_gen/feathers/themes/steel/components/SteelPageIndicatorStyles.js");}
function feathers_layout_HorizontalLayout() {return __webpack_require__(/*! ./../../feathers/layout/HorizontalLayout */ "./lib/_gen/feathers/layout/HorizontalLayout.js");}
function feathers_layout_VerticalLayout() {return __webpack_require__(/*! ./../../feathers/layout/VerticalLayout */ "./lib/_gen/feathers/layout/VerticalLayout.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function Type() {return __webpack_require__(/*! ./../../Type */ "./lib/_gen/Type.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_controls_ToggleButton() {return __webpack_require__(/*! ./../../feathers/controls/ToggleButton */ "./lib/_gen/feathers/controls/ToggleButton.js");}
function feathers_data_PageIndicatorItemState() {return __webpack_require__(/*! ./../../feathers/data/PageIndicatorItemState */ "./lib/_gen/feathers/data/PageIndicatorItemState.js");}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}
function feathers_utils_DisplayObjectRecycler() {return __webpack_require__(/*! ./../../feathers/utils/DisplayObjectRecycler */ "./lib/_gen/feathers/utils/DisplayObjectRecycler.js");}

// Constructor

var PageIndicator = function(maxSelectedIndex,changeListener) {
	if(maxSelectedIndex == null) {
		maxSelectedIndex = -1;
	}
	this.__disabledBackgroundSkin = null;
	this.__backgroundSkin = null;
	this.__layout = null;
	this.__customToggleButtonVariant = null;
	this._currentItemState = new (feathers_data_PageIndicatorItemState().default)();
	this._ignoreChildChanges = false;
	this._layoutResult = new (feathers_layout_LayoutBoundsResult().default)();
	this._layoutMeasurements = new (feathers_layout_Measurements().default)();
	this._interactionMode = (feathers_controls_PageIndicatorInteractionMode().default).PREVIOUS_NEXT;
	this._backgroundSkinMeasurements = null;
	this._currentBackgroundSkin = null;
	this._ignoreSelectionChange = false;
	this._layoutItems = [];
	this.activeToggleButtons = [];
	this.inactiveToggleButtons = [];
	this._toggleButtonRecycler = (feathers_utils_DisplayObjectRecycler().default).withClass((feathers_controls_ToggleButton().default));
	this._previousCustomToggleButtonVariant = null;
	this._maxSelectedIndex = -1;
	this._selectedIndex = -1;
	this.initializePageIndicatorTheme();
	(feathers_core_FeathersControl().default).call(this);
	this.mouseChildren = this._interactionMode == (feathers_controls_PageIndicatorInteractionMode().default).PRECISE;
	this.set_tabEnabled(true);
	this.set_tabChildren(false);
	this.set_maxSelectedIndex(maxSelectedIndex);
	this.addEventListener("click",$bind(this,this.pageIndicator_clickHandler));
	this.addEventListener("keyDown",$bind(this,this.pageIndicator_keyDownHandler));
	if(changeListener != null) {
		this.addEventListener("change",changeListener);
	}
}

// Meta

PageIndicator.__name__ = "feathers.controls.PageIndicator";
PageIndicator.__isInterface__ = false;
PageIndicator.__interfaces__ = [(feathers_core_IFocusObject().default),(feathers_core_IIndexSelector().default)];
PageIndicator.__super__ = (feathers_core_FeathersControl().default);
PageIndicator.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_selectedIndex: function() {
		return this._selectedIndex;
	},
	set_selectedIndex: function(value) {
		if(this._selectedIndex == value) {
			return this._selectedIndex;
		}
		if(value < -1 || value > this._maxSelectedIndex) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Index " + value + " is out of range " + this._maxSelectedIndex + " for PageIndicator."));
		}
		this._selectedIndex = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedIndex;
	},
	get_maxSelectedIndex: function() {
		return this._maxSelectedIndex;
	},
	set_maxSelectedIndex: function(value) {
		if(this._maxSelectedIndex == value) {
			return this._maxSelectedIndex;
		}
		this._maxSelectedIndex = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		if(this._maxSelectedIndex >= 0 && this._selectedIndex < 0) {
			this.set_selectedIndex(0);
		} else if(this.get_selectedIndex() > this._maxSelectedIndex) {
			this.set_selectedIndex(this._maxSelectedIndex);
		}
		return this._maxSelectedIndex;
	},
	get_toggleButtonRecycler: function() {
		return this._toggleButtonRecycler;
	},
	set_toggleButtonRecycler: function(value) {
		if(this._toggleButtonRecycler == value) {
			return this._toggleButtonRecycler;
		}
		this._oldToggleButtonRecycler = this._toggleButtonRecycler;
		this._toggleButtonRecycler = value;
		this.setInvalid(PageIndicator.INVALIDATION_FLAG_TOGGLE_BUTTON_FACTORY);
		return this._toggleButtonRecycler;
	},
	get_interactionMode: function() {
		return this._interactionMode;
	},
	set_interactionMode: function(value) {
		if(this._interactionMode == value) {
			return this._interactionMode;
		}
		this._interactionMode = value;
		this.mouseChildren = this._interactionMode == (feathers_controls_PageIndicatorInteractionMode().default).PRECISE;
		return this._interactionMode;
	},
	indexToToggleButton: function(index) {
		if(index < 0 || index >= this.activeToggleButtons.length) {
			return null;
		}
		return this.activeToggleButtons[index];
	},
	initializePageIndicatorTheme: function() {
		(feathers_themes_steel_components_SteelPageIndicatorStyles().default).initialize();
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var dataInvalid1 = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var layoutInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		var selectionInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(this._previousCustomToggleButtonVariant != this.get_customToggleButtonVariant()) {
			this.setInvalidationFlag(PageIndicator.INVALIDATION_FLAG_TOGGLE_BUTTON_FACTORY);
		}
		var buttonsInvalid = this.isInvalid(PageIndicator.INVALIDATION_FLAG_TOGGLE_BUTTON_FACTORY);
		if(stylesInvalid || stateInvalid) {
			this.refreshBackgroundSkin();
		}
		if(buttonsInvalid || selectionInvalid || stateInvalid || dataInvalid1) {
			this.refreshToggleButtons();
		}
		this.refreshViewPortBounds();
		this.handleLayout();
		this.handleLayoutResult();
		this.layoutBackgroundSkin();
		this.validateChildren();
		this._previousCustomToggleButtonVariant = this.get_customToggleButtonVariant();
	},
	refreshViewPortBounds: function() {
		this._layoutMeasurements.save(this);
	},
	handleLayout: function() {
		if(!((this.get_layout()) instanceof (feathers_layout_HorizontalLayout().default)) && !((this.get_layout()) instanceof (feathers_layout_VerticalLayout().default))) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("PageIndicator must use HorizontalLayout or VerticalLayout"));
		}
		var oldIgnoreChildChanges = this._ignoreChildChanges;
		this._ignoreChildChanges = true;
		this._layoutResult.reset();
		if(this.get_layout() != null) {
			this.get_layout().layout(this._layoutItems,this._layoutMeasurements,this._layoutResult);
		}
		this._ignoreChildChanges = oldIgnoreChildChanges;
	},
	handleLayoutResult: function() {
		var viewPortWidth = this._layoutResult.viewPortWidth;
		var viewPortHeight = this._layoutResult.viewPortHeight;
		this.saveMeasurements(viewPortWidth,viewPortHeight,viewPortWidth,viewPortHeight);
	},
	validateChildren: function() {
		var _g = 0;
		var _g1 = this.activeToggleButtons;
		while(_g < _g1.length) {
			var button = _g1[_g];
			++_g;
			button.validateNow();
		}
	},
	refreshToggleButtons: function() {
		this._layoutItems.length = 0;
		this._layoutItems.length = this._maxSelectedIndex + 1;
		var buttonsInvalid = this.isInvalid(PageIndicator.INVALIDATION_FLAG_TOGGLE_BUTTON_FACTORY);
		this.refreshInactiveToggleButtons(buttonsInvalid);
		this.recoverInactiveToggleButtons();
		var _g = 0;
		var _g1 = this._maxSelectedIndex + 1;
		while(_g < _g1) {
			var i = _g++;
			var button = this.createToggleButton(i);
			this._layoutItems[i] = button;
		}
		this.freeInactiveToggleButtons();
		if(this.inactiveToggleButtons.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())((Type().default).getClassName((Type().default).getClass(this)) + ": inactive item renderers should be empty after updating."));
		}
	},
	refreshInactiveToggleButtons: function(factoryInvalid) {
		var temp = this.inactiveToggleButtons;
		this.inactiveToggleButtons = this.activeToggleButtons;
		this.activeToggleButtons = temp;
		if(this.activeToggleButtons.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())((Type().default).getClassName((Type().default).getClass(this)) + ": active item renderers should be empty before updating."));
		}
		if(factoryInvalid) {
			this.recoverInactiveToggleButtons();
			this.freeInactiveToggleButtons();
			this._oldToggleButtonRecycler = null;
		}
	},
	recoverInactiveToggleButtons: function() {
		var recycler = this._oldToggleButtonRecycler != null ? this._oldToggleButtonRecycler : this._toggleButtonRecycler;
		var _g = 0;
		var _g1 = this.inactiveToggleButtons;
		while(_g < _g1.length) {
			var button = _g1[_g];
			++_g;
			if(button == null) {
				continue;
			}
			button.removeEventListener("change",$bind(this,this.pageIndicator_toggleButton_changeHandler));
			this._currentItemState.owner = this;
			this._currentItemState.index = -1;
			this._currentItemState.selected = false;
			this._currentItemState.enabled = true;
			var oldIgnoreSelectionChange = this._ignoreSelectionChange;
			this._ignoreSelectionChange = true;
			if(recycler.reset != null) {
				recycler.reset(button,this._currentItemState);
			}
			button.set_selected(this._currentItemState.selected);
			button.set_enabled(this._currentItemState.enabled);
			this._ignoreSelectionChange = oldIgnoreSelectionChange;
		}
	},
	freeInactiveToggleButtons: function() {
		var recycler = this._oldToggleButtonRecycler != null ? this._oldToggleButtonRecycler : this._toggleButtonRecycler;
		var _g = 0;
		var _g1 = this.inactiveToggleButtons;
		while(_g < _g1.length) {
			var button = _g1[_g];
			++_g;
			if(button == null) {
				continue;
			}
			this.destroyToggleButton(button,recycler);
		}
		this.inactiveToggleButtons.length = 0;
	},
	refreshBackgroundSkin: function() {
		var oldSkin = this._currentBackgroundSkin;
		this._currentBackgroundSkin = this.getCurrentBackgroundSkin();
		if(this._currentBackgroundSkin == oldSkin) {
			return;
		}
		this.removeCurrentBackgroundSkin(oldSkin);
		this.addCurrentBackgroundSkin(this._currentBackgroundSkin);
	},
	getCurrentBackgroundSkin: function() {
		if(!this._enabled && this.get_disabledBackgroundSkin() != null) {
			return this.get_disabledBackgroundSkin();
		}
		return this.get_backgroundSkin();
	},
	addCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			this._backgroundSkinMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._backgroundSkinMeasurements == null) {
			this._backgroundSkinMeasurements = new (feathers_layout_Measurements().default)(skin);
		} else {
			this._backgroundSkinMeasurements.save(skin);
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this.addChildAt(skin,0);
	},
	removeCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		this._backgroundSkinMeasurements.restore(skin);
		if(skin.parent == this) {
			this.removeChild(skin);
		}
	},
	layoutBackgroundSkin: function() {
		if(this._currentBackgroundSkin == null) {
			this.get_graphics().clear();
			this.get_graphics().beginFill(16711935,0.0);
			this.get_graphics().drawRect(0,0,this.actualWidth,this.actualHeight);
			this.get_graphics().endFill();
			return;
		}
		this._currentBackgroundSkin.set_x(0.0);
		this._currentBackgroundSkin.set_y(0.0);
		if(this._currentBackgroundSkin.get_width() != this.actualWidth) {
			this._currentBackgroundSkin.set_width(this.actualWidth);
		}
		if(this._currentBackgroundSkin.get_height() != this.actualHeight) {
			this._currentBackgroundSkin.set_height(this.actualHeight);
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
	},
	createToggleButton: function(index) {
		var depthOffset = this._currentBackgroundSkin != null ? 1 : 0;
		var button = null;
		if(this.inactiveToggleButtons.length == 0) {
			button = this._toggleButtonRecycler.create();
			if(button.get_variant() == null) {
				var variant = this.get_customToggleButtonVariant() != null ? this.get_customToggleButtonVariant() : PageIndicator.CHILD_VARIANT_TOGGLE_BUTTON;
				button.set_variant(variant);
			}
			button.initializeNow();
			this.addChildAt(button,index + depthOffset);
		} else {
			button = this.inactiveToggleButtons.shift();
			this.setChildIndex(button,index + depthOffset);
		}
		this.refreshToggleButtonProperties(button,index);
		button.addEventListener("change",$bind(this,this.pageIndicator_toggleButton_changeHandler));
		this.activeToggleButtons.push(button);
		return button;
	},
	destroyToggleButton: function(button,recycler) {
		this.removeChild(button);
		if(recycler.destroy != null) {
			recycler.destroy(button);
		}
	},
	populateCurrentItemState: function(index) {
		this._currentItemState.owner = this;
		this._currentItemState.index = index;
		this._currentItemState.selected = index == this._selectedIndex;
		this._currentItemState.enabled = this._enabled;
	},
	refreshToggleButtonProperties: function(button,index) {
		this.populateCurrentItemState(index);
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		if(this._toggleButtonRecycler.update != null) {
			this._toggleButtonRecycler.update(button,this._currentItemState);
		}
		button.set_selected(this._currentItemState.selected);
		button.set_enabled(this._currentItemState.enabled);
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
	},
	navigateWithKeyboard: function(event) {
		if(event.isDefaultPrevented()) {
			return;
		}
		var result = this._selectedIndex;
		switch(event.keyCode) {
		case 33:
			--result;
			break;
		case 34:
			++result;
			break;
		case 35:
			result = this._maxSelectedIndex;
			break;
		case 36:
			result = 0;
			break;
		case 37:
			--result;
			break;
		case 38:
			if(event.keyLocation == 4) {
				return;
			}
			++result;
			break;
		case 39:
			++result;
			break;
		case 40:
			if(event.keyLocation == 4) {
				return;
			}
			--result;
			break;
		default:
			return;
		}
		if(result < 0) {
			result = 0;
		} else if(result > this._maxSelectedIndex) {
			result = this._maxSelectedIndex;
		}
		event.preventDefault();
		this.set_selectedIndex(result);
	},
	pageIndicator_keyDownHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		this.navigateWithKeyboard(event);
	},
	pageIndicator_toggleButton_changeHandler: function(event) {
		if(this._ignoreSelectionChange) {
			return;
		}
		var button = (js_Boot().default).__cast(event.currentTarget , (feathers_controls_ToggleButton().default));
		if(!button.get_selected()) {
			button.set_selected(true);
			return;
		}
		this.set_selectedIndex(this.activeToggleButtons.indexOf(button));
	},
	handleClickOrTap: function(localX,localY) {
		var selectedIndex = this._selectedIndex;
		if(selectedIndex != -1) {
			var button = this.activeToggleButtons[selectedIndex];
			if(((this.get_layout()) instanceof (feathers_layout_VerticalLayout().default))) {
				if(localY < button.get_y()) {
					--selectedIndex;
				} else if(localY > button.get_y() + button.get_height()) {
					++selectedIndex;
				}
			} else if(localX < button.get_x()) {
				--selectedIndex;
			} else if(localX > button.get_x() + button.get_width()) {
				++selectedIndex;
			}
		}
		if(selectedIndex < 0) {
			selectedIndex = 0;
		} else if(selectedIndex > this._maxSelectedIndex) {
			selectedIndex = this._maxSelectedIndex;
		}
		this.set_selectedIndex(selectedIndex);
	},
	pageIndicator_clickHandler: function(event) {
		if(!this._enabled || this._interactionMode != (feathers_controls_PageIndicatorInteractionMode().default).PREVIOUS_NEXT) {
			return;
		}
		this.handleClickOrTap(event.localX,event.localY);
	},
	pageIndicator_touchTapHandler: function(event) {
		if(!this._enabled || this._interactionMode != (feathers_controls_PageIndicatorInteractionMode().default).PREVIOUS_NEXT) {
			return;
		}
		if(event.isPrimaryTouchPoint) {
			return;
		}
		this.handleClickOrTap(event.localX,event.localY);
	},
	get_customToggleButtonVariant: function() {
		return this.__customToggleButtonVariant;
	},
	set_customToggleButtonVariant: function(value) {
		if(!this.setStyle("customToggleButtonVariant")) {
			return this.__customToggleButtonVariant;
		}
		if(this.__customToggleButtonVariant == value) {
			return this.__customToggleButtonVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customToggleButtonVariant);
		this.__customToggleButtonVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customToggleButtonVariant;
	},
	clearStyle_customToggleButtonVariant: function() {
		this.set_customToggleButtonVariant(null);
		return this.get_customToggleButtonVariant();
	},
	get_layout: function() {
		return this.__layout;
	},
	set_layout: function(value) {
		if(!this.setStyle("layout")) {
			return this.__layout;
		}
		if(this.__layout == value) {
			return this.__layout;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_layout);
		this.__layout = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__layout;
	},
	clearStyle_layout: function() {
		this.set_layout(null);
		return this.get_layout();
	},
	get_backgroundSkin: function() {
		return this.__backgroundSkin;
	},
	set_backgroundSkin: function(value) {
		if(!this.setStyle("backgroundSkin")) {
			return this.__backgroundSkin;
		}
		if(this.__backgroundSkin == value) {
			return this.__backgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_backgroundSkin);
		this.__backgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__backgroundSkin;
	},
	clearStyle_backgroundSkin: function() {
		this.set_backgroundSkin(null);
		return this.get_backgroundSkin();
	},
	get_disabledBackgroundSkin: function() {
		return this.__disabledBackgroundSkin;
	},
	set_disabledBackgroundSkin: function(value) {
		if(!this.setStyle("disabledBackgroundSkin")) {
			return this.__disabledBackgroundSkin;
		}
		if(this.__disabledBackgroundSkin == value) {
			return this.__disabledBackgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledBackgroundSkin);
		this.__disabledBackgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledBackgroundSkin;
	},
	clearStyle_disabledBackgroundSkin: function() {
		this.set_disabledBackgroundSkin(null);
		return this.get_disabledBackgroundSkin();
	},
	get_styleContext: function() {
		return PageIndicator
	}
});
PageIndicator.prototype.__class__ = PageIndicator.prototype.constructor = $hxClasses["feathers.controls.PageIndicator"] = PageIndicator;

// Init



// Statics


PageIndicator.INVALIDATION_FLAG_TOGGLE_BUTTON_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("toggleButtonFactory")
PageIndicator.CHILD_VARIANT_TOGGLE_BUTTON = "pageIndicator_toggleButton"

// Export

exports["default"] = PageIndicator;

/***/ }),

/***/ "./lib/_gen/feathers/controls/PageIndicatorInteractionMode.js":
/*!********************************************************************!*\
  !*** ./lib/_gen/feathers/controls/PageIndicatorInteractionMode.js ***!
  \********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.controls.PageIndicatorInteractionMode

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var PageIndicatorInteractionMode = $hxEnums["feathers.controls.PageIndicatorInteractionMode"] = { __ename__ : "feathers.controls.PageIndicatorInteractionMode", __constructs__ : ["PREVIOUS_NEXT","PRECISE"]
  ,PREVIOUS_NEXT: {_hx_index:0,__enum__:"feathers.controls.PageIndicatorInteractionMode",toString:$estr}
  ,PRECISE: {_hx_index:1,__enum__:"feathers.controls.PageIndicatorInteractionMode",toString:$estr}
};

exports["default"] = PageIndicatorInteractionMode;

/***/ }),

/***/ "./lib/_gen/feathers/controls/Panel.js":
/*!*********************************************!*\
  !*** ./lib/_gen/feathers/controls/Panel.js ***!
  \*********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.Panel

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IFocusExtras() {return __webpack_require__(/*! ./../../feathers/core/IFocusExtras */ "./lib/_gen/feathers/core/IFocusExtras.js");}
function feathers_controls_ScrollContainer() {return __webpack_require__(/*! ./../../feathers/controls/ScrollContainer */ "./lib/_gen/feathers/controls/ScrollContainer.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_themes_steel_components_SteelPanelStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelPanelStyles */ "./lib/_gen/feathers/themes/steel/components/SteelPanelStyles.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}

// Constructor

var Panel = function() {
	this._focusExtrasAfter = [];
	this._focusExtrasBefore = [];
	this._footer = null;
	this._footerMeasurements = null;
	this._ignoreFooterResize = false;
	this._header = null;
	this._headerMeasurements = null;
	this._ignoreHeaderResize = false;
	this.initializePanelTheme();
	(feathers_controls_ScrollContainer().default).call(this);
}

// Meta

Panel.__name__ = "feathers.controls.Panel";
Panel.__isInterface__ = false;
Panel.__interfaces__ = [(feathers_core_IFocusExtras().default)];
Panel.__super__ = (feathers_controls_ScrollContainer().default);
Panel.prototype = $extend((feathers_controls_ScrollContainer().default).prototype, {
	get_header: function() {
		return this._header;
	},
	set_header: function(value) {
		if(this._header == value) {
			return this._header;
		}
		if(this._header != null) {
			this._header.removeEventListener("resize",$bind(this,this.panel_header_resizeHandler));
			(HxOverrides().default).remove(this._focusExtrasBefore,this._header);
			this.removeRawChild(this._header);
		}
		this._header = value;
		if(this._header != null) {
			this._focusExtrasBefore.push(this._header);
			var index = this.layoutViewPort != null ? this.getRawChildIndex(this.layoutViewPort) + 1 : 0;
			this.addRawChildAt(this._header,index);
			if((js_Boot().default).__implements(this._header,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(this._header , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(this._headerMeasurements == null) {
				this._headerMeasurements = new (feathers_layout_Measurements().default)(this._header);
			} else {
				this._headerMeasurements.save(this._header);
			}
			this._header.addEventListener("resize",$bind(this,this.panel_header_resizeHandler),false,0,true);
		} else {
			this._headerMeasurements = null;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		return this._header;
	},
	get_footer: function() {
		return this._footer;
	},
	set_footer: function(value) {
		if(this._footer == value) {
			return this._footer;
		}
		if(this._footer != null) {
			this._header.removeEventListener("resize",$bind(this,this.panel_header_resizeHandler));
			(HxOverrides().default).remove(this._focusExtrasAfter,this._footer);
			this.removeRawChild(this._footer);
		}
		this._footer = value;
		if(this._footer != null) {
			this._focusExtrasAfter.push(this._footer);
			this.addRawChild(this._footer);
			if((js_Boot().default).__implements(this._footer,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(this._footer , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(this._footerMeasurements == null) {
				this._footerMeasurements = new (feathers_layout_Measurements().default)(this._footer);
			} else {
				this._footerMeasurements.save(this._footer);
			}
			this._footer.addEventListener("resize",$bind(this,this.panel_footer_resizeHandler),false,0,true);
		} else {
			this._footerMeasurements = null;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		return this._footer;
	},
	get_focusExtrasBefore: function() {
		return this._focusExtrasBefore;
	},
	get_focusExtrasAfter: function() {
		return this._focusExtrasAfter;
	},
	initializePanelTheme: function() {
		(feathers_themes_steel_components_SteelPanelStyles().default).initialize();
	},
	update: function() {
		this._ignoreChangesButSetFlags = false;
		(feathers_controls_ScrollContainer().default).prototype.update.call(this);
		var oldIgnoreHeaderResize = this._ignoreHeaderResize;
		this._ignoreHeaderResize = true;
		this.layoutHeader();
		this._ignoreHeaderResize = oldIgnoreHeaderResize;
		var oldIgnoreFooterResize = this._ignoreFooterResize;
		this._ignoreFooterResize = true;
		this.layoutFooter();
		this._ignoreFooterResize = oldIgnoreFooterResize;
	},
	calculateViewPortOffsets: function(forceScrollBars,useActualBounds) {
		if(this._header != null) {
			var oldIgnoreHeaderResize = this._ignoreHeaderResize;
			this._ignoreHeaderResize = true;
			if(this._headerMeasurements != null) {
				this._headerMeasurements.restore(this._header);
			}
			if((js_Boot().default).__implements(this._header,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._header , (feathers_core_IValidating().default))).validateNow();
			}
			this.topViewPortOffset += this._header.get_height();
			this.chromeMeasuredWidth = Math.max(this.chromeMeasuredWidth,this._header.get_width());
			if((js_Boot().default).__implements(this._header,(feathers_core_IMeasureObject().default))) {
				var measureHeader = (js_Boot().default).__cast(this._header , (feathers_core_IMeasureObject().default));
				this.chromeMeasuredMinWidth = Math.max(this.chromeMeasuredMinWidth,measureHeader.get_minWidth());
			}
			this._ignoreHeaderResize = oldIgnoreHeaderResize;
		}
		if(this._footer != null) {
			var oldIgnoreFooterResize = this._ignoreFooterResize;
			this._ignoreFooterResize = true;
			if(this._footerMeasurements != null) {
				this._footerMeasurements.restore(this._footer);
			}
			if((js_Boot().default).__implements(this._footer,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._footer , (feathers_core_IValidating().default))).validateNow();
			}
			this.bottomViewPortOffset += this._footer.get_height();
			this.chromeMeasuredWidth = Math.max(this.chromeMeasuredWidth,this._footer.get_width());
			if((js_Boot().default).__implements(this._footer,(feathers_core_IMeasureObject().default))) {
				var measureFooter = (js_Boot().default).__cast(this._footer , (feathers_core_IMeasureObject().default));
				this.chromeMeasuredMinWidth = Math.max(this.chromeMeasuredMinWidth,measureFooter.get_minWidth());
			}
			this._ignoreFooterResize = oldIgnoreFooterResize;
		}
		(feathers_controls_ScrollContainer().default).prototype.calculateViewPortOffsets.call(this,forceScrollBars,useActualBounds);
	},
	layoutHeader: function() {
		if(this._header == null) {
			return;
		}
		this._header.set_x(this.get_paddingLeft());
		this._header.set_y(this.get_paddingTop());
		this._header.set_width(this.actualWidth - this.get_paddingLeft() - this.get_paddingRight());
		if((js_Boot().default).__implements(this._header,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._header , (feathers_core_IValidating().default))).validateNow();
		}
	},
	layoutFooter: function() {
		if(this._footer == null) {
			return;
		}
		this._footer.set_x(this.get_paddingLeft());
		this._footer.set_width(this.actualWidth - this.get_paddingLeft() - this.get_paddingRight());
		if((js_Boot().default).__implements(this._footer,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._footer , (feathers_core_IValidating().default))).validateNow();
		}
		this._footer.set_y(this.actualHeight - this._footer.get_height() - this.get_paddingBottom());
	},
	panel_header_resizeHandler: function(event) {
		if(this._ignoreHeaderResize) {
			return;
		}
		if(this._headerMeasurements != null) {
			this._headerMeasurements.save(this._header);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
	},
	panel_footer_resizeHandler: function(event) {
		if(this._ignoreFooterResize) {
			return;
		}
		if(this._footerMeasurements != null) {
			this._footerMeasurements.save(this._footer);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
	},
	get_styleContext: function() {
		return Panel
	}
});
Panel.prototype.__class__ = Panel.prototype.constructor = $hxClasses["feathers.controls.Panel"] = Panel;

// Init



// Statics




// Export

exports["default"] = Panel;

/***/ }),

/***/ "./lib/_gen/feathers/controls/PopUpDatePicker.js":
/*!*******************************************************!*\
  !*** ./lib/_gen/feathers/controls/PopUpDatePicker.js ***!
  \*******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.PopUpDatePicker

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IStageFocusDelegate() {return __webpack_require__(/*! ./../../feathers/core/IStageFocusDelegate */ "./lib/_gen/feathers/core/IStageFocusDelegate.js");}
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}
function feathers_core_IDateSelector() {return __webpack_require__(/*! ./../../feathers/core/IDateSelector */ "./lib/_gen/feathers/core/IDateSelector.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function openfl_errors_RangeError() {return (__webpack_require__(/*! openfl */ "openfl").errors.RangeError);}
function feathers_themes_steel_components_SteelPopUpDatePickerStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelPopUpDatePickerStyles */ "./lib/_gen/feathers/themes/steel/components/SteelPopUpDatePickerStyles.js");}
function feathers_controls_popups_DropDownPopUpAdapter() {return __webpack_require__(/*! ./../../feathers/controls/popups/DropDownPopUpAdapter */ "./lib/_gen/feathers/controls/popups/DropDownPopUpAdapter.js");}
function feathers_utils_DisplayObjectFactory() {return __webpack_require__(/*! ./../../feathers/utils/DisplayObjectFactory */ "./lib/_gen/feathers/utils/DisplayObjectFactory.js");}
function feathers_controls_Button() {return __webpack_require__(/*! ./../../feathers/controls/Button */ "./lib/_gen/feathers/controls/Button.js");}
function feathers_controls_TextInput() {return __webpack_require__(/*! ./../../feathers/controls/TextInput */ "./lib/_gen/feathers/controls/TextInput.js");}
function feathers_controls_DatePicker() {return __webpack_require__(/*! ./../../feathers/controls/DatePicker */ "./lib/_gen/feathers/controls/DatePicker.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}

// Constructor

var PopUpDatePicker = function() {
	this.__customDatePickerVariant = null;
	this.__customButtonVariant = null;
	this.__customTextInputVariant = null;
	this.__popUpAdapter = new (feathers_controls_popups_DropDownPopUpAdapter().default)();
	this.openDatePickerOnFocus = false;
	this._filterText = null;
	this._customStartOfWeek = null;
	this._customWeekdayNames = null;
	this._customMonthNames = null;
	this._actualLocaleIDName = null;
	this._requestedLocaleIDName = null;
	this._previousCustomDatePickerVariant = null;
	this._previousCustomButtonVariant = null;
	this._previousCustomTextInputVariant = null;
	this._ignoreDatePickerChange = false;
	this._ignoreTextInputChange = false;
	this._selectedDate = null;
	this.textInputMeasurements = new (feathers_layout_Measurements().default)();
	this.buttonMeasurements = new (feathers_layout_Measurements().default)();
	this.initializePopUpDatePickerTheme();
	(feathers_core_FeathersControl().default).call(this);
	this.addEventListener("focusIn",$bind(this,this.popUpDatePicker_focusInHandler));
}

// Meta

PopUpDatePicker.__name__ = "feathers.controls.PopUpDatePicker";
PopUpDatePicker.__isInterface__ = false;
PopUpDatePicker.__interfaces__ = [(feathers_core_IStageFocusDelegate().default),(feathers_core_IFocusObject().default),(feathers_core_IDateSelector().default)];
PopUpDatePicker.__super__ = (feathers_core_FeathersControl().default);
PopUpDatePicker.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_stageFocusTarget: function() {
		return this.textInput;
	},
	get_selectedDate: function() {
		return this._selectedDate;
	},
	set_selectedDate: function(value) {
		if(this._selectedDate == value) {
			return this._selectedDate;
		}
		this._selectedDate = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedDate;
	},
	get_prompt: function() {
		return this._prompt;
	},
	set_prompt: function(value) {
		if(this._prompt == value) {
			return this._prompt;
		}
		this._prompt = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._prompt;
	},
	get_buttonFactory: function() {
		return this._buttonFactory;
	},
	set_buttonFactory: function(value) {
		if(this._buttonFactory == value) {
			return this._buttonFactory;
		}
		this._buttonFactory = value;
		this.setInvalid(PopUpDatePicker.INVALIDATION_FLAG_BUTTON_FACTORY);
		return this._buttonFactory;
	},
	get_textInputFactory: function() {
		return this._textInputFactory;
	},
	set_textInputFactory: function(value) {
		if(this._textInputFactory == value) {
			return this._textInputFactory;
		}
		this._textInputFactory = value;
		this.setInvalid(PopUpDatePicker.INVALIDATION_FLAG_TEXT_INPUT_FACTORY);
		return this._textInputFactory;
	},
	get_datePickerFactory: function() {
		return this._datePickerFactory;
	},
	set_datePickerFactory: function(value) {
		if(this._datePickerFactory == value) {
			return this._datePickerFactory;
		}
		this._datePickerFactory = value;
		this.setInvalid(PopUpDatePicker.INVALIDATION_FLAG_DATE_PICKER_FACTORY);
		return this._datePickerFactory;
	},
	get_requestedLocaleIDName: function() {
		return this._requestedLocaleIDName;
	},
	set_requestedLocaleIDName: function(value) {
		if(this._requestedLocaleIDName == value) {
			return this._requestedLocaleIDName;
		}
		this._requestedLocaleIDName = value;
		this._actualLocaleIDName = null;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._requestedLocaleIDName;
	},
	get_actualLocaleIDName: function() {
		return this._actualLocaleIDName;
	},
	get_customMonthNames: function() {
		return this._customMonthNames;
	},
	set_customMonthNames: function(value) {
		if(value != null && value.length != 12) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Length of customMonthNames must be exactly equal to 12"));
		}
		if(this._customMonthNames == value) {
			return this._customMonthNames;
		}
		this._customMonthNames = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._customMonthNames;
	},
	get_customWeekdayNames: function() {
		return this._customWeekdayNames;
	},
	set_customWeekdayNames: function(value) {
		if(value != null && value.length != 7) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Length of customWeekdayNames must be exactly equal to 7"));
		}
		if(this._customWeekdayNames == value) {
			return this._customWeekdayNames;
		}
		this._customWeekdayNames = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._customWeekdayNames;
	},
	get_customStartOfWeek: function() {
		return this._customStartOfWeek;
	},
	set_customStartOfWeek: function(value) {
		if(value != null && (value < 0 || value > 6)) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("startOfWeek must be in the range 0-6"));
		}
		if(this._customStartOfWeek == value) {
			return this._customStartOfWeek;
		}
		this._customStartOfWeek = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._customStartOfWeek;
	},
	get_open: function() {
		if(this.datePicker != null) {
			return this.datePicker.parent != null;
		} else {
			return false;
		}
	},
	showFocus: function(show) {
		(feathers_core_FeathersControl().default).prototype.showFocus.call(this,show);
		if(this.textInput != null) {
			this.textInput.showFocus(show);
		}
	},
	openDatePicker: function() {
		if(this.get_open() || this.stage == null) {
			return;
		}
		this.validateNow();
		this.get_popUpAdapter().addEventListener("open",$bind(this,this.popUpDatePicker_popUpAdapter_openHandler));
		this.get_popUpAdapter().addEventListener("close",$bind(this,this.popUpDatePicker_popUpAdapter_closeHandler));
		this.get_popUpAdapter().open(this.datePicker,this);
		if(this.get_selectedDate() != null) {
			this.datePicker.set_displayedFullYear(this.get_selectedDate().getFullYear());
			this.datePicker.set_displayedMonth(this.get_selectedDate().getMonth());
		} else {
			var now = new Date();
			this.datePicker.set_displayedFullYear(now.getFullYear());
			this.datePicker.set_displayedMonth(now.getMonth());
		}
		this.datePicker.validateNow();
		this.textInput.addEventListener("focusOut",$bind(this,this.popUpDatePicker_textInput_focusOutHandler));
		this.datePicker.addEventListener("removedFromStage",$bind(this,this.popUpDatePicker_datePicker_removedFromStageHandler));
		this.stage.addEventListener("mouseDown",$bind(this,this.popUpDatePicker_stage_mouseDownHandler),false,0,true);
		this.stage.addEventListener("touchBegin",$bind(this,this.popUpDatePicker_stage_touchBeginHandler),false,0,true);
	},
	closeDatePicker: function() {
		if(!this.get_open()) {
			return;
		}
		this.get_popUpAdapter().close();
	},
	initializePopUpDatePickerTheme: function() {
		(feathers_themes_steel_components_SteelPopUpDatePickerStyles().default).initialize();
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var selectionInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		if(this._previousCustomTextInputVariant != this.get_customTextInputVariant()) {
			this.setInvalidationFlag(PopUpDatePicker.INVALIDATION_FLAG_TEXT_INPUT_FACTORY);
		}
		if(this._previousCustomButtonVariant != this.get_customButtonVariant()) {
			this.setInvalidationFlag(PopUpDatePicker.INVALIDATION_FLAG_BUTTON_FACTORY);
		}
		if(this._previousCustomDatePickerVariant != this.get_customDatePickerVariant()) {
			this.setInvalidationFlag(PopUpDatePicker.INVALIDATION_FLAG_DATE_PICKER_FACTORY);
		}
		var buttonFactoryInvalid = this.isInvalid(PopUpDatePicker.INVALIDATION_FLAG_BUTTON_FACTORY);
		var textInputFactoryInvalid = this.isInvalid(PopUpDatePicker.INVALIDATION_FLAG_TEXT_INPUT_FACTORY);
		var datePickerFactoryInvalid = this.isInvalid(PopUpDatePicker.INVALIDATION_FLAG_DATE_PICKER_FACTORY);
		if(buttonFactoryInvalid) {
			this.createButton();
		}
		if(textInputFactoryInvalid) {
			this.createTextInput();
		}
		if(datePickerFactoryInvalid) {
			this.createDatePicker();
		}
		if(dataInvalid) {
			this.refreshLocale();
		}
		if(dataInvalid || selectionInvalid || datePickerFactoryInvalid) {
			this.refreshDatePickerData();
		}
		if(dataInvalid || selectionInvalid || textInputFactoryInvalid) {
			this.refreshTextInputData();
		}
		if(stateInvalid || datePickerFactoryInvalid || buttonFactoryInvalid || textInputFactoryInvalid) {
			this.refreshEnabled();
		}
		this.measure();
		this.layoutChildren();
		this._previousCustomTextInputVariant = this.get_customTextInputVariant();
		this._previousCustomButtonVariant = this.get_customButtonVariant();
		this._previousCustomDatePickerVariant = this.get_customDatePickerVariant();
	},
	createButton: function() {
		if(this.button != null) {
			this.button.removeEventListener("mouseDown",$bind(this,this.popUpDatePicker_button_mouseDownHandler));
			this.button.removeEventListener("touchBegin",$bind(this,this.popUpDatePicker_button_touchBeginHandler));
			this.removeChild(this.button);
			if(this._oldButtonFactory.destroy != null) {
				this._oldButtonFactory.destroy(this.button);
			}
			this._oldButtonFactory = null;
			this.button = null;
		}
		var factory = this._buttonFactory != null ? this._buttonFactory : PopUpDatePicker.defaultButtonFactory;
		this._oldButtonFactory = factory;
		this.button = factory.create();
		if(this.button.get_variant() == null) {
			this.button.set_variant(this.get_customButtonVariant() != null ? this.get_customButtonVariant() : PopUpDatePicker.CHILD_VARIANT_BUTTON);
		}
		this.button.set_focusEnabled(false);
		this.button.addEventListener("mouseDown",$bind(this,this.popUpDatePicker_button_mouseDownHandler));
		this.button.addEventListener("touchBegin",$bind(this,this.popUpDatePicker_button_touchBeginHandler));
		this.button.initializeNow();
		this.buttonMeasurements.save(this.button);
		this.addChild(this.button);
	},
	refreshLocale: function() {
		this._actualLocaleIDName = "en-US";
	},
	createTextInput: function() {
		if(this.textInput != null) {
			this.textInput.removeEventListener("mouseDown",$bind(this,this.popUpDatePicker_textInput_mouseDownHandler));
			this.removeChild(this.textInput);
			if(this._oldTextInputFactory.destroy != null) {
				this._oldTextInputFactory.destroy(this.textInput);
			}
			this._oldTextInputFactory = null;
			this.textInput = null;
		}
		var factory = this._textInputFactory != null ? this._textInputFactory : PopUpDatePicker.defaultTextInputFactory;
		this._oldTextInputFactory = factory;
		this.textInput = factory.create();
		this.textInput.set_editable(false);
		if(this.textInput.get_variant() == null) {
			this.textInput.set_variant(this.get_customTextInputVariant() != null ? this.get_customTextInputVariant() : PopUpDatePicker.CHILD_VARIANT_TEXT_INPUT);
		}
		this.textInput.initializeNow();
		this.textInputMeasurements.save(this.textInput);
		this.textInput.addEventListener("mouseDown",$bind(this,this.popUpDatePicker_textInput_mouseDownHandler));
		this.addChild(this.textInput);
	},
	createDatePicker: function() {
		if(this.datePicker != null) {
			this.datePicker.removeEventListener("change",$bind(this,this.popUpDatePicker_datePicker_changeHandler));
			this.datePicker.removeEventListener("itemTrigger",$bind(this,this.popUpDatePicker_datePicker_itemTriggerHandler));
			this.datePicker.set_focusOwner(null);
			if(this._oldDatePickerFactory.destroy != null) {
				this._oldDatePickerFactory.destroy(this.datePicker);
			}
			this._oldDatePickerFactory = null;
			this.datePicker = null;
		}
		var factory = this._datePickerFactory != null ? this._datePickerFactory : PopUpDatePicker.defaultDatePickerFactory;
		this._oldDatePickerFactory = factory;
		this.datePicker = factory.create();
		this.datePicker.set_focusOwner(this);
		this.datePicker.set_focusEnabled(false);
		if(this.datePicker.get_variant() == null) {
			this.datePicker.set_variant(this.get_customDatePickerVariant() != null ? this.get_customDatePickerVariant() : PopUpDatePicker.CHILD_VARIANT_DATE_PICKER);
		}
		this.datePicker.addEventListener("change",$bind(this,this.popUpDatePicker_datePicker_changeHandler));
		this.datePicker.addEventListener("itemTrigger",$bind(this,this.popUpDatePicker_datePicker_itemTriggerHandler));
	},
	refreshDatePickerData: function() {
		var oldIgnoreDatePickerChange = this._ignoreDatePickerChange;
		this._ignoreDatePickerChange = true;
		this.datePicker.set_requestedLocaleIDName(this._requestedLocaleIDName);
		this.datePicker.set_selectedDate(this._selectedDate);
		this.datePicker.set_customMonthNames(this._customMonthNames);
		this.datePicker.set_customWeekdayNames(this._customWeekdayNames);
		this.datePicker.set_customStartOfWeek(this._customStartOfWeek);
		this._ignoreDatePickerChange = oldIgnoreDatePickerChange;
	},
	refreshTextInputData: function() {
		this.textInput.set_prompt(this._prompt);
		if(this._selectedDate != null) {
			this.textInput.set_text("" + (this._selectedDate.getMonth() + 1) + "/" + this._selectedDate.getDate() + "/" + this._selectedDate.getFullYear());
		} else {
			this.textInput.set_text("");
		}
	},
	refreshEnabled: function() {
		this.button.set_enabled(this._enabled);
		this.textInput.set_enabled(this._enabled);
		this.datePicker.set_enabled(this._enabled);
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		this.buttonMeasurements.restore(this.button);
		this.button.validateNow();
		this.textInputMeasurements.restore(this.textInput);
		this.textInput.validateNow();
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			newWidth = this.button.get_width() + this.textInput.get_width();
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			newHeight = Math.max(this.button.get_height(),this.textInput.get_height());
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			newMinWidth = this.button.get_minWidth() + this.textInput.get_minWidth();
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			newMinHeight = Math.max(this.button.get_minHeight(),this.textInput.get_minHeight());
		}
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight);
	},
	layoutChildren: function() {
		this.button.validateNow();
		this.button.set_x(this.actualWidth - this.button.get_width());
		this.button.set_y(0.0);
		if(this.button.get_height() != this.actualHeight) {
			this.button.set_height(this.actualHeight);
		}
		this.textInput.set_x(0.0);
		this.textInput.set_y(0.0);
		var textInputWidth = this.actualWidth - this.button.get_width();
		if(this.textInput.get_width() != textInputWidth) {
			this.textInput.set_width(textInputWidth);
		}
		if(this.textInput.get_height() != this.actualHeight) {
			this.textInput.set_height(this.actualHeight);
		}
		this.button.validateNow();
		this.textInput.validateNow();
	},
	popUpDatePicker_textInput_focusOutHandler: function(event) {
		if(event.relatedObject != null && (event.relatedObject == this.datePicker || this.datePicker.contains(event.relatedObject))) {
			return;
		}
	},
	popUpDatePicker_button_mouseDownHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(this.get_open()) {
			this.closeDatePicker();
		} else {
			this.openDatePicker();
		}
	},
	popUpDatePicker_button_touchBeginHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(event.isPrimaryTouchPoint) {
			return;
		}
		if(this.get_open()) {
			this.closeDatePicker();
		} else {
			this.openDatePicker();
		}
	},
	popUpDatePicker_datePicker_changeHandler: function(event) {
		if(this._ignoreDatePickerChange) {
			return;
		}
		this.set_selectedDate(this.datePicker.get_selectedDate());
	},
	popUpDatePicker_datePicker_itemTriggerHandler: function(event) {
		this.dispatchEvent(event);
		if(this.get_popUpAdapter() == null || !this.get_popUpAdapter().get_persistent()) {
			this.closeDatePicker();
		}
	},
	popUpDatePicker_datePicker_removedFromStageHandler: function(event) {
		this.textInput.removeEventListener("focusOut",$bind(this,this.popUpDatePicker_textInput_focusOutHandler));
		this.datePicker.removeEventListener("removedFromStage",$bind(this,this.popUpDatePicker_datePicker_removedFromStageHandler));
		this.stage.removeEventListener("mouseDown",$bind(this,this.popUpDatePicker_stage_mouseDownHandler));
		this.stage.removeEventListener("touchBegin",$bind(this,this.popUpDatePicker_stage_touchBeginHandler));
	},
	popUpDatePicker_focusInHandler: function(event) {
		if(this.stage != null && this.stage.get_focus() != null && this.textInput != null && !this.textInput.contains(this.stage.get_focus())) {
			event.stopImmediatePropagation();
			this.stage.set_focus(this.textInput);
		}
	},
	popUpDatePicker_removedFromStageHandler: function(event) {
		this.closeDatePicker();
	},
	popUpDatePicker_keyUpHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		switch(event.keyCode) {
		case 27:
			if(event.isDefaultPrevented()) {
				return;
			}
			if(!this.get_open()) {
				return;
			}
			event.preventDefault();
			this.closeDatePicker();
			break;
		case 1073742094:
			if(event.isDefaultPrevented()) {
				return;
			}
			if(!this.get_open()) {
				return;
			}
			event.preventDefault();
			this.closeDatePicker();
			break;
		}
	},
	popUpDatePicker_stage_mouseDownHandler: function(event) {
		if(this.hitTestPoint(event.stageX,event.stageY) || this.datePicker.hitTestPoint(event.stageX,event.stageY)) {
			return;
		}
		this.closeDatePicker();
	},
	popUpDatePicker_stage_touchBeginHandler: function(event) {
		if(event.isPrimaryTouchPoint) {
			return;
		}
		if(this.hitTestPoint(event.stageX,event.stageY) || this.datePicker.hitTestPoint(event.stageX,event.stageY)) {
			return;
		}
		this.closeDatePicker();
	},
	popUpDatePicker_popUpAdapter_openHandler: function(event) {
		(feathers_events_FeathersEvent().default).dispatch(this,"open");
	},
	popUpDatePicker_popUpAdapter_closeHandler: function(event) {
		this.get_popUpAdapter().removeEventListener("open",$bind(this,this.popUpDatePicker_popUpAdapter_openHandler));
		this.get_popUpAdapter().removeEventListener("close",$bind(this,this.popUpDatePicker_popUpAdapter_closeHandler));
		(feathers_events_FeathersEvent().default).dispatch(this,"close");
	},
	popUpDatePicker_textInput_mouseDownHandler: function(event) {
		if(!this.get_enabled()) {
			return;
		}
		this.openDatePicker();
	},
	get_popUpAdapter: function() {
		return this.__popUpAdapter;
	},
	set_popUpAdapter: function(value) {
		if(!this.setStyle("popUpAdapter")) {
			return this.__popUpAdapter;
		}
		if(this.__popUpAdapter == value) {
			return this.__popUpAdapter;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_popUpAdapter);
		this.__popUpAdapter = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__popUpAdapter;
	},
	clearStyle_popUpAdapter: function() {
		this.set_popUpAdapter(new (feathers_controls_popups_DropDownPopUpAdapter().default)());
		return this.get_popUpAdapter();
	},
	get_customTextInputVariant: function() {
		return this.__customTextInputVariant;
	},
	set_customTextInputVariant: function(value) {
		if(!this.setStyle("customTextInputVariant")) {
			return this.__customTextInputVariant;
		}
		if(this.__customTextInputVariant == value) {
			return this.__customTextInputVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customTextInputVariant);
		this.__customTextInputVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customTextInputVariant;
	},
	clearStyle_customTextInputVariant: function() {
		this.set_customTextInputVariant(null);
		return this.get_customTextInputVariant();
	},
	get_customButtonVariant: function() {
		return this.__customButtonVariant;
	},
	set_customButtonVariant: function(value) {
		if(!this.setStyle("customButtonVariant")) {
			return this.__customButtonVariant;
		}
		if(this.__customButtonVariant == value) {
			return this.__customButtonVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customButtonVariant);
		this.__customButtonVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customButtonVariant;
	},
	clearStyle_customButtonVariant: function() {
		this.set_customButtonVariant(null);
		return this.get_customButtonVariant();
	},
	get_customDatePickerVariant: function() {
		return this.__customDatePickerVariant;
	},
	set_customDatePickerVariant: function(value) {
		if(!this.setStyle("customDatePickerVariant")) {
			return this.__customDatePickerVariant;
		}
		if(this.__customDatePickerVariant == value) {
			return this.__customDatePickerVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customDatePickerVariant);
		this.__customDatePickerVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customDatePickerVariant;
	},
	clearStyle_customDatePickerVariant: function() {
		this.set_customDatePickerVariant(null);
		return this.get_customDatePickerVariant();
	},
	get_styleContext: function() {
		return PopUpDatePicker
	}
});
PopUpDatePicker.prototype.__class__ = PopUpDatePicker.prototype.constructor = $hxClasses["feathers.controls.PopUpDatePicker"] = PopUpDatePicker;

// Init



// Statics


PopUpDatePicker.INVALIDATION_FLAG_BUTTON_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("buttonFactory")
PopUpDatePicker.INVALIDATION_FLAG_TEXT_INPUT_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("textInputFactory")
PopUpDatePicker.INVALIDATION_FLAG_DATE_PICKER_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("datePickerFactory")
PopUpDatePicker.CHILD_VARIANT_BUTTON = "popUpDatePicker_button"
PopUpDatePicker.CHILD_VARIANT_TEXT_INPUT = "popUpDatePicker_textInput"
PopUpDatePicker.CHILD_VARIANT_DATE_PICKER = "popUpDatePicker_datePicker"
PopUpDatePicker.defaultButtonFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_Button().default))
PopUpDatePicker.defaultTextInputFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_TextInput().default))
PopUpDatePicker.defaultDatePickerFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_DatePicker().default))

// Export

exports["default"] = PopUpDatePicker;

/***/ }),

/***/ "./lib/_gen/feathers/controls/PopUpListView.js":
/*!*****************************************************!*\
  !*** ./lib/_gen/feathers/controls/PopUpListView.js ***!
  \*****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.PopUpListView

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IStageFocusDelegate() {return __webpack_require__(/*! ./../../feathers/core/IStageFocusDelegate */ "./lib/_gen/feathers/core/IStageFocusDelegate.js");}
function feathers_core_IDataSelector() {return __webpack_require__(/*! ./../../feathers/core/IDataSelector */ "./lib/_gen/feathers/core/IDataSelector.js");}
function feathers_core_IIndexSelector() {return __webpack_require__(/*! ./../../feathers/core/IIndexSelector */ "./lib/_gen/feathers/core/IIndexSelector.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_core_PopUpManager() {return __webpack_require__(/*! ./../../feathers/core/PopUpManager */ "./lib/_gen/feathers/core/PopUpManager.js");}
function feathers_themes_steel_components_SteelPopUpListViewStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelPopUpListViewStyles */ "./lib/_gen/feathers/themes/steel/components/SteelPopUpListViewStyles.js");}
function feathers_utils_MeasurementsUtil() {return __webpack_require__(/*! ./../../feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");}
function feathers_utils_DisplayObjectFactory() {return __webpack_require__(/*! ./../../feathers/utils/DisplayObjectFactory */ "./lib/_gen/feathers/utils/DisplayObjectFactory.js");}
function feathers_controls_Button() {return __webpack_require__(/*! ./../../feathers/controls/Button */ "./lib/_gen/feathers/controls/Button.js");}
function feathers_controls_ListView() {return __webpack_require__(/*! ./../../feathers/controls/ListView */ "./lib/_gen/feathers/controls/ListView.js");}
function feathers_utils_DisplayObjectRecycler() {return __webpack_require__(/*! ./../../feathers/utils/DisplayObjectRecycler */ "./lib/_gen/feathers/utils/DisplayObjectRecycler.js");}
function feathers_controls_dataRenderers_ItemRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/ItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ItemRenderer.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}

// Constructor

var PopUpListView = function(dataProvider,changeListener) {
	this.__customListViewVariant = null;
	this.__customButtonVariant = null;
	this.__popUpAdapter = null;
	this._previousCustomListViewVariant = null;
	this._previousCustomButtonVariant = null;
	this._itemRendererRecycler = (feathers_utils_DisplayObjectRecycler().default).withClass((feathers_controls_dataRenderers_ItemRenderer().default));
	this._selectedItem = null;
	this._selectedIndex = -1;
	this._ignoreListViewChange = false;
	this.buttonMeasurements = new (feathers_layout_Measurements().default)();
	this.initializePopUpListViewTheme();
	(feathers_core_FeathersControl().default).call(this);
	this.set_dataProvider(dataProvider);
	this.addEventListener("focusIn",$bind(this,this.popUpListView_focusInHandler));
	this.addEventListener("removedFromStage",$bind(this,this.popUpListView_removedFromStageHandler));
	if(changeListener != null) {
		this.addEventListener("change",changeListener);
	}
}

// Meta

PopUpListView.__name__ = "feathers.controls.PopUpListView";
PopUpListView.__isInterface__ = false;
PopUpListView.__interfaces__ = [(feathers_core_IStageFocusDelegate().default),(feathers_core_IDataSelector().default),(feathers_core_IIndexSelector().default)];
PopUpListView.__super__ = (feathers_core_FeathersControl().default);
PopUpListView.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_stageFocusTarget: function() {
		return this.button;
	},
	get_dataProvider: function() {
		return this._dataProvider;
	},
	set_dataProvider: function(value) {
		if(this._dataProvider == value) {
			return this._dataProvider;
		}
		if(this._dataProvider != null) {
			this._dataProvider.removeEventListener("removeAll",$bind(this,this.popUpListView_dataProvider_removeAllHandler));
		}
		var oldSelectedIndex = this._selectedIndex;
		var oldSelectedItem = this._selectedItem;
		this._dataProvider = value;
		if(this._dataProvider != null) {
			this._dataProvider.addEventListener("removeAll",$bind(this,this.popUpListView_dataProvider_removeAllHandler));
		}
		if(this._dataProvider == null || this._dataProvider.get_length() == 0) {
			this._selectedIndex = -1;
			this._selectedItem = null;
		} else {
			this._selectedIndex = 0;
			this._selectedItem = this._dataProvider.get(0);
		}
		if(this._selectedIndex != oldSelectedIndex || this._selectedItem != oldSelectedItem) {
			this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._dataProvider;
	},
	get_selectedIndex: function() {
		return this._selectedIndex;
	},
	set_selectedIndex: function(value) {
		if(this._dataProvider == null) {
			value = -1;
		}
		if(this._selectedIndex == value) {
			return this._selectedIndex;
		}
		this._selectedIndex = value;
		if(this._selectedIndex == -1) {
			this._selectedItem = null;
		} else {
			this._selectedItem = this._dataProvider.get(this._selectedIndex);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedIndex;
	},
	get_maxSelectedIndex: function() {
		if(this._dataProvider == null) {
			return -1;
		}
		return this._dataProvider.get_length() - 1;
	},
	get_selectedItem: function() {
		return this._selectedItem;
	},
	set_selectedItem: function(value) {
		if(value == null || this._dataProvider == null) {
			this.set_selectedIndex(-1);
			return this._selectedItem;
		}
		var index = this._dataProvider.indexOf(value);
		if(index == -1) {
			this.set_selectedIndex(-1);
			return this._selectedItem;
		}
		if(this._selectedItem == value && this._selectedIndex == index) {
			return this._selectedItem;
		}
		this._selectedIndex = index;
		this._selectedItem = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedItem;
	},
	get_prompt: function() {
		return this._prompt;
	},
	set_prompt: function(value) {
		if(this._prompt == value) {
			return this._prompt;
		}
		this._prompt = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._prompt;
	},
	get_itemRendererRecycler: function() {
		return this._itemRendererRecycler;
	},
	set_itemRendererRecycler: function(value) {
		if(this._itemRendererRecycler == value) {
			return this._itemRendererRecycler;
		}
		this._itemRendererRecycler = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._itemRendererRecycler;
	},
	itemToText: function(data) {
		return (Std().default).string(data);
	},
	itemToEnabled: function(data) {
		return true;
	},
	get_buttonFactory: function() {
		return this._buttonFactory;
	},
	set_buttonFactory: function(value) {
		if(this._buttonFactory == value) {
			return this._buttonFactory;
		}
		this._buttonFactory = value;
		this.setInvalid(PopUpListView.INVALIDATION_FLAG_BUTTON_FACTORY);
		return this._buttonFactory;
	},
	get_listViewFactory: function() {
		return this._listViewFactory;
	},
	set_listViewFactory: function(value) {
		if(this._listViewFactory == value) {
			return this._listViewFactory;
		}
		this._listViewFactory = value;
		this.setInvalid(PopUpListView.INVALIDATION_FLAG_LIST_VIEW_FACTORY);
		return this._listViewFactory;
	},
	get_open: function() {
		if(this.listView != null) {
			return this.listView.parent != null;
		} else {
			return false;
		}
	},
	showFocus: function(show) {
		(feathers_core_FeathersControl().default).prototype.showFocus.call(this,show);
		if(this.button != null) {
			this.button.showFocus(show);
		}
	},
	openListView: function() {
		if(this.get_open() || this.stage == null) {
			return;
		}
		this.validateNow();
		if(this.get_popUpAdapter() != null) {
			this.get_popUpAdapter().addEventListener("open",$bind(this,this.popUpListView_popUpAdapter_openHandler));
			this.get_popUpAdapter().addEventListener("close",$bind(this,this.popUpListView_popUpAdapter_closeHandler));
			this.get_popUpAdapter().open(this.listView,this.button);
		} else {
			(feathers_core_PopUpManager().default).addPopUp(this.listView,this.button);
			(feathers_events_FeathersEvent().default).dispatch(this,"open");
		}
		this.listView.validateNow();
		this.button.addEventListener("focusOut",$bind(this,this.popUpListView_button_focusOutHandler));
		this.listView.addEventListener("removedFromStage",$bind(this,this.popUpListView_listView_removedFromStageHandler));
		this.listView.addEventListener("focusOut",$bind(this,this.popUpListView_listView_focusOutHandler));
		this.listView.addEventListener("keyFocusChange",$bind(this,this.popUpListView_listView_keyFocusChangeHandler));
		this.listView.addEventListener("mouseFocusChange",$bind(this,this.popUpListView_listView_mouseFocusChangeHandler));
		this.stage.addEventListener("mouseDown",$bind(this,this.popUpListView_stage_mouseDownHandler),false,0,true);
		this.stage.addEventListener("touchBegin",$bind(this,this.popUpListView_stage_touchBeginHandler),false,0,true);
		this.listView.scrollToIndex(this._selectedIndex);
		if(this.listView.get_focusManager() != null) {
			this.listView.get_focusManager().set_focus(this.listView);
		} else {
			this.stage.set_focus(this.listView);
		}
	},
	closeListView: function() {
		if(!this.get_open()) {
			return;
		}
		if(this._focusManager == null) {
			this.stage.set_focus(this);
			if(!this.get_open()) {
				return;
			}
		}
		if(this.get_popUpAdapter() != null) {
			this.get_popUpAdapter().close();
		} else {
			this.listView.parent.removeChild(this.listView);
			(feathers_events_FeathersEvent().default).dispatch(this,"close");
		}
	},
	initializePopUpListViewTheme: function() {
		(feathers_themes_steel_components_SteelPopUpListViewStyles().default).initialize();
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var selectionInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		if(this._previousCustomButtonVariant != this.get_customButtonVariant()) {
			this.setInvalidationFlag(PopUpListView.INVALIDATION_FLAG_BUTTON_FACTORY);
		}
		if(this._previousCustomListViewVariant != this.get_customListViewVariant()) {
			this.setInvalidationFlag(PopUpListView.INVALIDATION_FLAG_LIST_VIEW_FACTORY);
		}
		var buttonFactoryInvalid = this.isInvalid(PopUpListView.INVALIDATION_FLAG_BUTTON_FACTORY);
		var listViewFactoryInvalid = this.isInvalid(PopUpListView.INVALIDATION_FLAG_LIST_VIEW_FACTORY);
		if(buttonFactoryInvalid) {
			this.createButton();
		}
		if(listViewFactoryInvalid) {
			this.createListView();
		}
		if(dataInvalid || listViewFactoryInvalid) {
			this.refreshListViewData();
		}
		if(selectionInvalid || listViewFactoryInvalid || buttonFactoryInvalid) {
			this.refreshSelection();
		}
		if(stateInvalid || listViewFactoryInvalid || buttonFactoryInvalid) {
			this.refreshEnabled();
		}
		this.measure();
		this.layoutChildren();
		this._previousCustomButtonVariant = this.get_customButtonVariant();
		this._previousCustomListViewVariant = this.get_customListViewVariant();
	},
	createButton: function() {
		if(this.button != null) {
			this.button.removeEventListener("mouseDown",$bind(this,this.popUpListView_button_mouseDownHandler));
			this.button.removeEventListener("touchBegin",$bind(this,this.popUpListView_button_touchBeginHandler));
			this.button.removeEventListener("keyDown",$bind(this,this.popUpListView_button_keyDownHandler));
			this.removeChild(this.button);
			if(this._oldButtonFactory.destroy != null) {
				this._oldButtonFactory.destroy(this.button);
			}
			this._oldButtonFactory = null;
			this.button = null;
		}
		var factory = this._buttonFactory != null ? this._buttonFactory : PopUpListView.defaultButtonFactory;
		this._oldButtonFactory = factory;
		this.button = factory.create();
		if(this.button.get_variant() == null) {
			this.button.set_variant(this.get_customButtonVariant() != null ? this.get_customButtonVariant() : PopUpListView.CHILD_VARIANT_BUTTON);
		}
		this.button.addEventListener("mouseDown",$bind(this,this.popUpListView_button_mouseDownHandler));
		this.button.addEventListener("touchBegin",$bind(this,this.popUpListView_button_touchBeginHandler));
		this.button.addEventListener("keyDown",$bind(this,this.popUpListView_button_keyDownHandler));
		this.button.initializeNow();
		this.buttonMeasurements.save(this.button);
		this.addChild(this.button);
	},
	createListView: function() {
		if(this.listView != null) {
			this.listView.removeEventListener("change",$bind(this,this.popUpListView_listView_changeHandler));
			this.listView.removeEventListener("itemTrigger",$bind(this,this.popUpListView_listView_itemTriggerHandler));
			this.listView.removeEventListener("keyUp",$bind(this,this.popUpListView_listView_keyUpHandler));
			if(this._oldListViewFactory.destroy != null) {
				this._oldListViewFactory.destroy(this.listView);
			}
			this._oldListViewFactory = null;
			this.listView = null;
		}
		var factory = this._listViewFactory != null ? this._listViewFactory : PopUpListView.defaultListViewFactory;
		this._oldListViewFactory = factory;
		this.listView = factory.create();
		if(this.listView.get_variant() == null) {
			this.listView.set_variant(this.get_customListViewVariant() != null ? this.get_customListViewVariant() : PopUpListView.CHILD_VARIANT_LIST_VIEW);
		}
		this.listView.set_focusOwner(this);
		this.listView.addEventListener("change",$bind(this,this.popUpListView_listView_changeHandler));
		this.listView.addEventListener("itemTrigger",$bind(this,this.popUpListView_listView_itemTriggerHandler));
		this.listView.addEventListener("keyUp",$bind(this,this.popUpListView_listView_keyUpHandler));
	},
	refreshListViewData: function() {
		var oldIgnoreListViewChange = this._ignoreListViewChange;
		this._ignoreListViewChange = true;
		this.listView.set_dataProvider(this._dataProvider);
		this._ignoreListViewChange = oldIgnoreListViewChange;
		this.listView.set_itemRendererRecycler(this._itemRendererRecycler);
		this.listView.itemToEnabled = $bind(this,this.itemToEnabled);
		this.listView.itemToText = $bind(this,this.itemToText);
	},
	refreshSelection: function() {
		var oldIgnoreListViewChange = this._ignoreListViewChange;
		this._ignoreListViewChange = true;
		this.listView.set_selectedIndex(this._selectedIndex);
		this._ignoreListViewChange = oldIgnoreListViewChange;
		if(this._selectedItem != null) {
			this.button.set_text(this.itemToText(this._selectedItem));
		} else if(this._prompt != null) {
			this.button.set_text(this._prompt);
		} else {
			this.button.set_text("");
		}
	},
	refreshEnabled: function() {
		this.button.set_enabled(this._enabled);
		this.listView.set_enabled(this._enabled);
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParent(this.buttonMeasurements,this.button,this);
		this.button.validateNow();
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			newWidth = this.button.get_width();
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			newHeight = this.button.get_height();
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			newMinWidth = this.button.get_minWidth();
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			newMinHeight = this.button.get_minHeight();
		}
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight);
	},
	layoutChildren: function() {
		this.button.validateNow();
		if(this.button.get_width() != this.actualWidth) {
			this.button.set_width(this.actualWidth);
		}
		if(this.button.get_height() != this.actualHeight) {
			this.button.set_height(this.actualHeight);
		}
		this.button.validateNow();
	},
	navigateWithKeyboard: function(event) {
		if(event.isDefaultPrevented()) {
			return;
		}
		if(this._dataProvider == null || this._dataProvider.get_length() == 0) {
			return;
		}
		var result = this._selectedIndex;
		switch(event.keyCode) {
		case 33:
			--result;
			break;
		case 34:
			++result;
			break;
		case 35:
			result = this._dataProvider.get_length() - 1;
			break;
		case 36:
			result = 0;
			break;
		case 37:
			--result;
			break;
		case 38:
			--result;
			break;
		case 39:
			++result;
			break;
		case 40:
			++result;
			break;
		default:
			return;
		}
		if(result < 0) {
			result = 0;
		} else if(result >= this._dataProvider.get_length()) {
			result = this._dataProvider.get_length() - 1;
		}
		event.preventDefault();
		this.set_selectedIndex(result);
	},
	popUpListView_button_keyDownHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(!this.get_open() && event.keyLocation != 4) {
			this.navigateWithKeyboard(event);
		}
		if(event.keyCode != 32 && event.keyCode != 13) {
			return;
		}
		if(this.get_open()) {
			event.preventDefault();
			this.closeListView();
		} else {
			event.preventDefault();
			this.openListView();
		}
	},
	popUpListView_button_mouseDownHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(this.get_open()) {
			this.closeListView();
		} else {
			this.openListView();
		}
	},
	popUpListView_button_touchBeginHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(event.isPrimaryTouchPoint) {
			return;
		}
		if(this.get_open()) {
			this.closeListView();
		} else {
			this.openListView();
		}
	},
	popUpListView_listView_itemTriggerHandler: function(event) {
		this.dispatchEvent(event);
		if(this.get_popUpAdapter() == null || !this.get_popUpAdapter().get_persistent()) {
			this.closeListView();
		}
	},
	popUpListView_listView_changeHandler: function(event) {
		if(this._ignoreListViewChange) {
			return;
		}
		this._selectedIndex = this.listView.get_selectedIndex();
		this._selectedItem = this.listView.get_selectedItem();
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
	},
	popUpListView_listView_removedFromStageHandler: function(event) {
		this.button.removeEventListener("focusOut",$bind(this,this.popUpListView_button_focusOutHandler));
		this.listView.removeEventListener("removedFromStage",$bind(this,this.popUpListView_listView_removedFromStageHandler));
		this.listView.removeEventListener("focusOut",$bind(this,this.popUpListView_listView_focusOutHandler));
		this.listView.removeEventListener("keyFocusChange",$bind(this,this.popUpListView_listView_keyFocusChangeHandler));
		this.listView.removeEventListener("mouseFocusChange",$bind(this,this.popUpListView_listView_mouseFocusChangeHandler));
		this.stage.removeEventListener("mouseDown",$bind(this,this.popUpListView_stage_mouseDownHandler));
		this.stage.removeEventListener("touchBegin",$bind(this,this.popUpListView_stage_touchBeginHandler));
	},
	popUpListView_listView_mouseFocusChangeHandler: function(event) {
		if(this.listView.get_focusManager() != null || event.isDefaultPrevented() || event.target != this.listView || event.relatedObject != null && !this.listView.contains(event.relatedObject)) {
			return;
		}
		event.preventDefault();
	},
	popUpListView_listView_keyFocusChangeHandler: function(event) {
		if(this.listView.get_focusManager() != null || event.isDefaultPrevented() || event.target != this.listView) {
			return;
		}
		event.preventDefault();
		this.stage.set_focus(this.button);
	},
	popUpListView_listView_focusOutHandler: function(event) {
		if(event.relatedObject != null && (event.relatedObject == this.listView || this.listView.contains(event.relatedObject))) {
			return;
		}
	},
	popUpListView_focusInHandler: function(event) {
		if(this.stage != null && this.stage.get_focus() != this.button) {
			event.stopImmediatePropagation();
			this.stage.set_focus(this.button);
		}
	},
	popUpListView_button_focusOutHandler: function(event) {
		if(event.relatedObject != null && (event.relatedObject == this.listView || this.listView.contains(event.relatedObject))) {
			return;
		}
		this.closeListView();
	},
	popUpListView_removedFromStageHandler: function(event) {
		this.closeListView();
	},
	popUpListView_listView_keyUpHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		switch(event.keyCode) {
		case 27:
			if(event.isDefaultPrevented()) {
				return;
			}
			if(!this.get_open()) {
				return;
			}
			event.preventDefault();
			this.closeListView();
			break;
		case 1073742094:
			if(event.isDefaultPrevented()) {
				return;
			}
			if(!this.get_open()) {
				return;
			}
			event.preventDefault();
			this.closeListView();
			break;
		}
	},
	popUpListView_stage_mouseDownHandler: function(event) {
		if(this.button.hitTestPoint(event.stageX,event.stageY) || this.listView.hitTestPoint(event.stageX,event.stageY)) {
			return;
		}
		this.closeListView();
	},
	popUpListView_stage_touchBeginHandler: function(event) {
		if(event.isPrimaryTouchPoint) {
			return;
		}
		if(this.button.hitTestPoint(event.stageX,event.stageY) || this.listView.hitTestPoint(event.stageX,event.stageY)) {
			return;
		}
		this.closeListView();
	},
	popUpListView_popUpAdapter_openHandler: function(event) {
		(feathers_events_FeathersEvent().default).dispatch(this,"open");
	},
	popUpListView_popUpAdapter_closeHandler: function(event) {
		(feathers_events_FeathersEvent().default).dispatch(this,"close");
	},
	popUpListView_dataProvider_removeAllHandler: function(event) {
		this.set_selectedIndex(-1);
	},
	get_popUpAdapter: function() {
		return this.__popUpAdapter;
	},
	set_popUpAdapter: function(value) {
		if(!this.setStyle("popUpAdapter")) {
			return this.__popUpAdapter;
		}
		if(this.__popUpAdapter == value) {
			return this.__popUpAdapter;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_popUpAdapter);
		this.__popUpAdapter = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__popUpAdapter;
	},
	clearStyle_popUpAdapter: function() {
		this.set_popUpAdapter(null);
		return this.get_popUpAdapter();
	},
	get_customButtonVariant: function() {
		return this.__customButtonVariant;
	},
	set_customButtonVariant: function(value) {
		if(!this.setStyle("customButtonVariant")) {
			return this.__customButtonVariant;
		}
		if(this.__customButtonVariant == value) {
			return this.__customButtonVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customButtonVariant);
		this.__customButtonVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customButtonVariant;
	},
	clearStyle_customButtonVariant: function() {
		this.set_customButtonVariant(null);
		return this.get_customButtonVariant();
	},
	get_customListViewVariant: function() {
		return this.__customListViewVariant;
	},
	set_customListViewVariant: function(value) {
		if(!this.setStyle("customListViewVariant")) {
			return this.__customListViewVariant;
		}
		if(this.__customListViewVariant == value) {
			return this.__customListViewVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customListViewVariant);
		this.__customListViewVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customListViewVariant;
	},
	clearStyle_customListViewVariant: function() {
		this.set_customListViewVariant(null);
		return this.get_customListViewVariant();
	},
	get_styleContext: function() {
		return PopUpListView
	}
});
PopUpListView.prototype.__class__ = PopUpListView.prototype.constructor = $hxClasses["feathers.controls.PopUpListView"] = PopUpListView;

// Init



// Statics


PopUpListView.__meta__ = { obj : { defaultXmlProperty : ["dataProvider"]}}
PopUpListView.INVALIDATION_FLAG_BUTTON_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("buttonFactory")
PopUpListView.INVALIDATION_FLAG_LIST_VIEW_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("listViewFactory")
PopUpListView.CHILD_VARIANT_BUTTON = "popUpListView_button"
PopUpListView.CHILD_VARIANT_LIST_VIEW = "popUpListView_listView"
PopUpListView.defaultButtonFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_Button().default))
PopUpListView.defaultListViewFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_ListView().default))

// Export

exports["default"] = PopUpListView;

/***/ }),

/***/ "./lib/_gen/feathers/controls/ProgressBarFillMode.js":
/*!***********************************************************!*\
  !*** ./lib/_gen/feathers/controls/ProgressBarFillMode.js ***!
  \***********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.controls.ProgressBarFillMode

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var ProgressBarFillMode = $hxEnums["feathers.controls.ProgressBarFillMode"] = { __ename__ : "feathers.controls.ProgressBarFillMode", __constructs__ : ["MASK","SCROLL_RECT","RESIZE"]
  ,SCROLL_RECT: {_hx_index:1,__enum__:"feathers.controls.ProgressBarFillMode",toString:$estr}
  ,RESIZE: {_hx_index:2,__enum__:"feathers.controls.ProgressBarFillMode",toString:$estr}
  ,MASK: {_hx_index:0,__enum__:"feathers.controls.ProgressBarFillMode",toString:$estr}
};

exports["default"] = ProgressBarFillMode;

/***/ }),

/***/ "./lib/_gen/feathers/controls/Radio.js":
/*!*********************************************!*\
  !*** ./lib/_gen/feathers/controls/Radio.js ***!
  \*********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.Radio

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_IGroupedToggle() {return __webpack_require__(/*! ./../../feathers/controls/IGroupedToggle */ "./lib/_gen/feathers/controls/IGroupedToggle.js");}
function feathers_controls_ToggleButton() {return __webpack_require__(/*! ./../../feathers/controls/ToggleButton */ "./lib/_gen/feathers/controls/ToggleButton.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function feathers_themes_steel_components_SteelRadioStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelRadioStyles */ "./lib/_gen/feathers/themes/steel/components/SteelRadioStyles.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}
function openfl_display_InteractiveObject() {return (__webpack_require__(/*! openfl */ "openfl").display.InteractiveObject);}
function feathers_core_ToggleGroup() {return __webpack_require__(/*! ./../../feathers/core/ToggleGroup */ "./lib/_gen/feathers/core/ToggleGroup.js");}

// Constructor

var Radio = function(text,selected,changeListener) {
	if(selected == null) {
		selected = false;
	}
	this._toggleGroup = null;
	this.initializeRadioTheme();
	(feathers_controls_ToggleButton().default).call(this,text,selected);
	(feathers_controls_ToggleButton().default).prototype.set_toggleable.call(this,true);
	this.addEventListener("addedToStage",$bind(this,this.radio_addedToStageHandler));
	this.addEventListener("keyDown",$bind(this,this.radio_keyDownHandler));
	if(changeListener != null) {
		this.addEventListener("change",changeListener);
	}
}

// Meta

Radio.__name__ = "feathers.controls.Radio";
Radio.__isInterface__ = false;
Radio.__interfaces__ = [(feathers_controls_IGroupedToggle().default)];
Radio.__super__ = (feathers_controls_ToggleButton().default);
Radio.prototype = $extend((feathers_controls_ToggleButton().default).prototype, {
	set_toggleable: function(value) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Radio toggleable must always be true"));
	},
	get_toggleGroup: function() {
		return this._toggleGroup;
	},
	set_toggleGroup: function(value) {
		if(this._toggleGroup == value) {
			return this._toggleGroup;
		}
		if(value == null && this._toggleGroup != Radio.defaultRadioGroup && this.stage != null) {
			value = Radio.defaultRadioGroup;
		}
		if(this._toggleGroup != null && this._toggleGroup.hasItem(this)) {
			this._toggleGroup.removeItem(this);
		}
		this._toggleGroup = value;
		if(this._toggleGroup != null && !this._toggleGroup.hasItem(this)) {
			this._toggleGroup.addItem(this);
		}
		return this._toggleGroup;
	},
	initializeRadioTheme: function() {
		(feathers_themes_steel_components_SteelRadioStyles().default).initialize();
	},
	navigateWithKeyboard: function(event) {
		if(event.isDefaultPrevented()) {
			return;
		}
		if(this._toggleGroup == null) {
			return;
		}
		if(event.keyLocation == 4) {
			return;
		}
		var startIndex = this._toggleGroup.getItemIndex(this);
		if(startIndex == -1) {
			return;
		}
		var result = startIndex;
		var needsAnotherPass = true;
		var lastResult = -1;
		while(needsAnotherPass) {
			needsAnotherPass = false;
			switch(event.keyCode) {
			case 37:
				--result;
				break;
			case 38:
				--result;
				break;
			case 39:
				++result;
				break;
			case 40:
				++result;
				break;
			default:
				return;
			}
			if(result < 0) {
				result = 0;
			} else if(result >= this._toggleGroup.get_numItems()) {
				result = this._toggleGroup.get_numItems() - 1;
			}
			var nextItem = this._toggleGroup.getItemAt(result);
			if(!nextItem.get_enabled()) {
				if(result == lastResult) {
					return;
				}
				needsAnotherPass = true;
			}
			lastResult = result;
		}
		event.preventDefault();
		this._toggleGroup.set_selectedIndex(result);
		var nextFocus = (js_Boot().default).__cast(this._toggleGroup.get_selectedItem() , (feathers_core_IFocusObject().default));
		if(this._focusManager != null) {
			this._focusManager.set_focus(nextFocus);
			nextFocus.showFocus(true);
		} else {
			this.stage.set_focus((js_Boot().default).__cast(nextFocus , (openfl_display_InteractiveObject())));
		}
	},
	radio_addedToStageHandler: function(event) {
		if(this._toggleGroup == null) {
			this.set_toggleGroup(Radio.defaultRadioGroup);
		}
		this.addEventListener("removedFromStage",$bind(this,this.radio_removedFromStageHandler));
	},
	radio_removedFromStageHandler: function(event) {
		this.removeEventListener("removedFromStage",$bind(this,this.radio_removedFromStageHandler));
		if(this._toggleGroup == Radio.defaultRadioGroup) {
			this._toggleGroup.removeItem(this);
		}
	},
	radio_keyDownHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		this.navigateWithKeyboard(event);
	},
	get_styleContext: function() {
		return Radio
	}
});
Radio.prototype.__class__ = Radio.prototype.constructor = $hxClasses["feathers.controls.Radio"] = Radio;

// Init



// Statics


Radio.defaultRadioGroup = new (feathers_core_ToggleGroup().default)()

// Export

exports["default"] = Radio;

/***/ }),

/***/ "./lib/_gen/feathers/controls/ScrollContainer.js":
/*!*******************************************************!*\
  !*** ./lib/_gen/feathers/controls/ScrollContainer.js ***!
  \*******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.ScrollContainer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IFocusContainer() {return __webpack_require__(/*! ./../../feathers/core/IFocusContainer */ "./lib/_gen/feathers/core/IFocusContainer.js");}
function feathers_controls_supportClasses_BaseScrollContainer() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/BaseScrollContainer */ "./lib/_gen/feathers/controls/supportClasses/BaseScrollContainer.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_layout_AutoSizeMode() {return __webpack_require__(/*! ./../../feathers/layout/AutoSizeMode */ "./lib/_gen/feathers/layout/AutoSizeMode.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_ILayoutObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutObject */ "./lib/_gen/feathers/layout/ILayoutObject.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_RangeError() {return (__webpack_require__(/*! openfl */ "openfl").errors.RangeError);}
function feathers_themes_steel_components_SteelScrollContainerStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelScrollContainerStyles */ "./lib/_gen/feathers/themes/steel/components/SteelScrollContainerStyles.js");}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function feathers_layout_IScrollLayout() {return __webpack_require__(/*! ./../../feathers/layout/IScrollLayout */ "./lib/_gen/feathers/layout/IScrollLayout.js");}
function feathers_controls_supportClasses_LayoutViewPort() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/LayoutViewPort */ "./lib/_gen/feathers/controls/supportClasses/LayoutViewPort.js");}

// Constructor

var ScrollContainer = function() {
	this.__layout = null;
	this._manageChildVisibility = false;
	this._autoSizeMode = (feathers_layout_AutoSizeMode().default).CONTENT;
	this._childFocusEnabled = true;
	this._xmlContent = null;
	this.items = [];
	this._displayListBypassEnabled = true;
	this._ignoreChangesButSetFlags = false;
	this._ignoreChildChanges = false;
	this.initializeScrollContainerTheme();
	(feathers_controls_supportClasses_BaseScrollContainer().default).call(this);
	if(this.get_viewPort() == null) {
		this.layoutViewPort = new (feathers_controls_supportClasses_LayoutViewPort().default)();
		this.addRawChild(this.layoutViewPort);
		this.set_viewPort(this.layoutViewPort);
	}
	this.addEventListener("addedToStage",$bind(this,this.scrollContainer_addedToStageHandler));
}

// Meta

ScrollContainer.__name__ = "feathers.controls.ScrollContainer";
ScrollContainer.__isInterface__ = false;
ScrollContainer.__interfaces__ = [(feathers_core_IFocusContainer().default)];
ScrollContainer.__super__ = (feathers_controls_supportClasses_BaseScrollContainer().default);
ScrollContainer.prototype = $extend((feathers_controls_supportClasses_BaseScrollContainer().default).prototype, {
	get_xmlContent: function() {
		return this._xmlContent;
	},
	set_xmlContent: function(value) {
		if(this._xmlContent == value) {
			return this._xmlContent;
		}
		if(this._xmlContent != null) {
			var _g = 0;
			var _g1 = this._xmlContent;
			while(_g < _g1.length) {
				var child = _g1[_g];
				++_g;
				this.removeChild(child);
			}
		}
		this._xmlContent = value;
		if(this._xmlContent != null) {
			var _g2 = 0;
			var _g11 = this._xmlContent;
			while(_g2 < _g11.length) {
				var child1 = _g11[_g2];
				++_g2;
				this.addChild(child1);
			}
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._xmlContent;
	},
	get_childFocusEnabled: function() {
		if(this._enabled) {
			return this._childFocusEnabled;
		} else {
			return false;
		}
	},
	set_childFocusEnabled: function(value) {
		if(this._childFocusEnabled == value) {
			return this._childFocusEnabled;
		}
		this._childFocusEnabled = value;
		return this._childFocusEnabled;
	},
	get_autoSizeMode: function() {
		return this._autoSizeMode;
	},
	set_autoSizeMode: function(value) {
		if(this._autoSizeMode == value) {
			return this._autoSizeMode;
		}
		this._autoSizeMode = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		if(this.stage != null) {
			if(this._autoSizeMode == (feathers_layout_AutoSizeMode().default).STAGE) {
				this.stage.addEventListener("resize",$bind(this,this.scrollContainer_stage_resizeHandler),false,0,true);
				this.addEventListener("removedFromStage",$bind(this,this.scrollContainer_removedFromStageHandler));
			} else {
				this.stage.removeEventListener("resize",$bind(this,this.scrollContainer_stage_resizeHandler));
				this.removeEventListener("removedFromStage",$bind(this,this.scrollContainer_removedFromStageHandler));
			}
		}
		return this._autoSizeMode;
	},
	get_manageChildVisibility: function() {
		return this._manageChildVisibility;
	},
	set_manageChildVisibility: function(value) {
		if(this._manageChildVisibility == value) {
			return this._manageChildVisibility;
		}
		this._manageChildVisibility = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		return this._manageChildVisibility;
	},
	get_numRawChildren: function() {
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = false;
		var result = this.get_numChildren();
		this._displayListBypassEnabled = oldBypass;
		return result;
	},
	get_numChildren: function() {
		if(!this._displayListBypassEnabled) {
			return (feathers_controls_supportClasses_BaseScrollContainer().default).prototype.get_numChildren.call(this);
		}
		return this.layoutViewPort.get_numChildren();
	},
	addChild: function(child) {
		if(!this._displayListBypassEnabled) {
			return (feathers_controls_supportClasses_BaseScrollContainer().default).prototype.addChild.call(this,child);
		}
		return this.addChildAt(child,this.layoutViewPort.get_numChildren());
	},
	addChildAt: function(child,index) {
		if(!this._displayListBypassEnabled) {
			return (feathers_controls_supportClasses_BaseScrollContainer().default).prototype.addChildAt.call(this,child,index);
		}
		var oldIndex = this.items.indexOf(child);
		if(oldIndex == index) {
			return child;
		}
		if(oldIndex >= 0) {
			(HxOverrides().default).remove(this.items,child);
		}
		this.items.splice(index,0,child);
		var result = this.layoutViewPort.addChildAt(child,index);
		child.addEventListener("resize",$bind(this,this.scrollContainer_child_resizeHandler));
		if((js_Boot().default).__implements(child,(feathers_layout_ILayoutObject().default))) {
			child.addEventListener("layoutDataChange",$bind(this,this.scrollContainer_child_layoutDataChangeHandler),false,0,true);
		}
		if(this._ignoreChangesButSetFlags) {
			this.setInvalidationFlag((feathers_core_InvalidationFlag().default).LAYOUT);
		} else {
			this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		}
		return result;
	},
	removeChild: function(child) {
		if(!this._displayListBypassEnabled) {
			return (feathers_controls_supportClasses_BaseScrollContainer().default).prototype.removeChild.call(this,child);
		}
		if(child == null || child.parent != this.layoutViewPort) {
			return child;
		}
		(HxOverrides().default).remove(this.items,child);
		var result = this.layoutViewPort.removeChild(child);
		child.removeEventListener("resize",$bind(this,this.scrollContainer_child_resizeHandler));
		if((js_Boot().default).__implements(child,(feathers_layout_ILayoutObject().default))) {
			child.removeEventListener("layoutDataChange",$bind(this,this.scrollContainer_child_layoutDataChangeHandler));
		}
		if(this._ignoreChangesButSetFlags) {
			this.setInvalidationFlag((feathers_core_InvalidationFlag().default).LAYOUT);
		} else {
			this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		}
		return result;
	},
	removeChildAt: function(index) {
		if(!this._displayListBypassEnabled) {
			return (feathers_controls_supportClasses_BaseScrollContainer().default).prototype.removeChildAt.call(this,index);
		}
		return this.removeChild(this.layoutViewPort.getChildAt(index));
	},
	getChildAt: function(index) {
		if(!this._displayListBypassEnabled) {
			return (feathers_controls_supportClasses_BaseScrollContainer().default).prototype.removeChildAt.call(this,index);
		}
		return this.layoutViewPort.getChildAt(index);
	},
	getChildIndex: function(child) {
		if(!this._displayListBypassEnabled) {
			return (feathers_controls_supportClasses_BaseScrollContainer().default).prototype.getChildIndex.call(this,child);
		}
		return this.items.indexOf(child);
	},
	setChildIndex: function(child,index) {
		if(!this._displayListBypassEnabled) {
			(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.setChildIndex.call(this,child,index);
			return;
		}
		var oldIndex = this.getChildIndex(child);
		if(oldIndex == index) {
			return;
		}
		(HxOverrides().default).remove(this.items,child);
		this.items.splice(index,0,child);
		if(this._ignoreChangesButSetFlags) {
			this.setInvalidationFlag((feathers_core_InvalidationFlag().default).LAYOUT);
		} else {
			this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		}
	},
	getChildByName: function(name) {
		if(!this._displayListBypassEnabled) {
			return (feathers_controls_supportClasses_BaseScrollContainer().default).prototype.getChildByName.call(this,name);
		}
		var _g = 0;
		var _g1 = this.items;
		while(_g < _g1.length) {
			var child = _g1[_g];
			++_g;
			if(child.get_name() == name) {
				return child;
			}
		}
		return null;
	},
	addRawChild: function(child) {
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = false;
		var result = this.addChild(child);
		this._displayListBypassEnabled = oldBypass;
		return result;
	},
	addRawChildAt: function(child,index) {
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = false;
		var result = this.addChildAt(child,index);
		this._displayListBypassEnabled = oldBypass;
		return result;
	},
	removeRawChild: function(child) {
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = false;
		var result = this.removeChild(child);
		this._displayListBypassEnabled = oldBypass;
		return result;
	},
	removeRawChildAt: function(index) {
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = false;
		var result = this.removeChildAt(index);
		this._displayListBypassEnabled = oldBypass;
		return result;
	},
	getRawChildByName: function(name) {
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = false;
		var result = this.getChildByName(name);
		this._displayListBypassEnabled = oldBypass;
		return result;
	},
	getRawChildAt: function(index) {
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = false;
		var result = this.getChildAt(index);
		this._displayListBypassEnabled = oldBypass;
		return result;
	},
	getRawChildIndex: function(child) {
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = false;
		var result = this.getChildIndex(child);
		this._displayListBypassEnabled = oldBypass;
		return result;
	},
	setRawChildIndex: function(child,index) {
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = false;
		this.setChildIndex(child,index);
		this._displayListBypassEnabled = oldBypass;
	},
	removeChildren: function(beginIndex,endIndex) {
		if(endIndex == null) {
			endIndex = 2147483647;
		}
		if(beginIndex == null) {
			beginIndex = 0;
		}
		if(!this._displayListBypassEnabled) {
			(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.removeChildren.call(this,beginIndex,endIndex);
			return;
		}
		if(endIndex == 2147483647) {
			endIndex = this.items.length - 1;
			if(endIndex < 0) {
				return;
			}
		}
		if(beginIndex > this.items.length - 1) {
			return;
		} else if(endIndex < beginIndex || beginIndex < 0 || endIndex > this.items.length) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("The supplied index is out of bounds."));
		}
		var numRemovals = endIndex - beginIndex;
		while(numRemovals >= 0) {
			this.removeChildAt(beginIndex);
			--numRemovals;
		}
	},
	removeRawChildren: function(beginIndex,endIndex) {
		if(endIndex == null) {
			endIndex = 2147483647;
		}
		if(beginIndex == null) {
			beginIndex = 0;
		}
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = false;
		this.removeChildren(beginIndex,endIndex);
		this._displayListBypassEnabled = oldBypass;
	},
	initializeScrollContainerTheme: function() {
		(feathers_themes_steel_components_SteelScrollContainerStyles().default).initialize();
	},
	dispatchEvent: function(event) {
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = true;
		var result = (feathers_controls_supportClasses_BaseScrollContainer().default).prototype.dispatchEvent.call(this,event);
		this._displayListBypassEnabled = oldBypass;
		return result;
	},
	validateNow: function() {
		var oldIgnoreChildChanges = this._ignoreChangesButSetFlags;
		this._ignoreChangesButSetFlags = true;
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.validateNow.call(this);
		this._ignoreChangesButSetFlags = oldIgnoreChildChanges;
	},
	update: function() {
		this._ignoreChangesButSetFlags = false;
		var layoutInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(layoutInvalid || stylesInvalid) {
			this.refreshLayout();
		}
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = false;
		var oldIgnoreChildChanges = this._ignoreChildChanges;
		this._ignoreChildChanges = true;
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.update.call(this);
		this._ignoreChildChanges = oldIgnoreChildChanges;
		this._displayListBypassEnabled = oldBypass;
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		if(this._autoSizeMode == (feathers_layout_AutoSizeMode().default).STAGE && this.stage != null) {
			var topLeft = this.globalToLocal(new (openfl_geom_Point())());
			var bottomRight = this.globalToLocal(new (openfl_geom_Point())(this.stage.stageWidth,this.stage.stageHeight));
			var stageWidth = bottomRight.x - topLeft.x;
			var stageHeight = bottomRight.y - topLeft.y;
			return this.saveMeasurements(stageWidth,stageHeight,stageWidth,stageHeight);
		}
		return (feathers_controls_supportClasses_BaseScrollContainer().default).prototype.measure.call(this);
	},
	refreshViewPortBoundsForMeasurement: function() {
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = true;
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.refreshViewPortBoundsForMeasurement.call(this);
		this._displayListBypassEnabled = oldBypass;
	},
	refreshViewPortBoundsForLayout: function() {
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = true;
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.refreshViewPortBoundsForLayout.call(this);
		this._displayListBypassEnabled = oldBypass;
	},
	refreshScrollerValues: function() {
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.refreshScrollerValues.call(this);
		if((js_Boot().default).__implements(this.get_layout(),(feathers_layout_IScrollLayout().default))) {
			var scrollLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_IScrollLayout().default));
			this.scroller.forceElasticTop = scrollLayout.get_elasticTop();
			this.scroller.forceElasticRight = scrollLayout.get_elasticRight();
			this.scroller.forceElasticBottom = scrollLayout.get_elasticBottom();
			this.scroller.forceElasticLeft = scrollLayout.get_elasticLeft();
		} else {
			this.scroller.forceElasticTop = false;
			this.scroller.forceElasticRight = false;
			this.scroller.forceElasticBottom = false;
			this.scroller.forceElasticLeft = false;
		}
		this.scroller.snapPositionsX = this.layoutViewPort.get_snapPositionsX();
		this.scroller.snapPositionsY = this.layoutViewPort.get_snapPositionsY();
	},
	needsScrollMeasurement: function() {
		return (js_Boot().default).__implements(this.get_layout(),(feathers_layout_IScrollLayout().default));
	},
	refreshLayout: function() {
		this.layoutViewPort.set_manageChildVisibility(this._manageChildVisibility);
		this.layoutViewPort.set_layout(this.get_layout());
	},
	scrollContainer_addedToStageHandler: function(event) {
		if(this._autoSizeMode == (feathers_layout_AutoSizeMode().default).STAGE) {
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
			this.addEventListener("removedFromStage",$bind(this,this.scrollContainer_removedFromStageHandler));
			this.stage.addEventListener("resize",$bind(this,this.scrollContainer_stage_resizeHandler),false,0,true);
		}
	},
	scrollContainer_removedFromStageHandler: function(event) {
		this.removeEventListener("removedFromStage",$bind(this,this.scrollContainer_removedFromStageHandler));
		this.stage.removeEventListener("resize",$bind(this,this.scrollContainer_stage_resizeHandler));
	},
	scrollContainer_stage_resizeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
	},
	scrollContainer_child_layoutDataChangeHandler: function(event) {
		if(this._ignoreChildChanges) {
			return;
		}
		if(this._ignoreChangesButSetFlags) {
			this.setInvalidationFlag((feathers_core_InvalidationFlag().default).LAYOUT);
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	scrollContainer_child_resizeHandler: function(event) {
		if(this._ignoreChildChanges) {
			return;
		}
		if(this._ignoreChangesButSetFlags) {
			this.setInvalidationFlag((feathers_core_InvalidationFlag().default).LAYOUT);
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	get_styleContext: function() {
		return ScrollContainer
	},
	get_layout: function() {
		return this.__layout;
	},
	set_layout: function(value) {
		if(!this.setStyle("layout")) {
			return this.__layout;
		}
		if(this.__layout == value) {
			return this.__layout;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_layout);
		this.__layout = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__layout;
	},
	clearStyle_layout: function() {
		this.set_layout(null);
		return this.get_layout();
	}
});
ScrollContainer.prototype.__class__ = ScrollContainer.prototype.constructor = $hxClasses["feathers.controls.ScrollContainer"] = ScrollContainer;

// Init



// Statics


ScrollContainer.__meta__ = { obj : { defaultXmlProperty : ["xmlContent"]}}

// Export

exports["default"] = ScrollContainer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/ScrollMode.js":
/*!**************************************************!*\
  !*** ./lib/_gen/feathers/controls/ScrollMode.js ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.controls.ScrollMode

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var ScrollMode = $hxEnums["feathers.controls.ScrollMode"] = { __ename__ : "feathers.controls.ScrollMode", __constructs__ : ["SCROLL_RECT","MASK","MASKLESS"]
  ,SCROLL_RECT: {_hx_index:0,__enum__:"feathers.controls.ScrollMode",toString:$estr}
  ,MASKLESS: {_hx_index:2,__enum__:"feathers.controls.ScrollMode",toString:$estr}
  ,MASK: {_hx_index:1,__enum__:"feathers.controls.ScrollMode",toString:$estr}
};

exports["default"] = ScrollMode;

/***/ }),

/***/ "./lib/_gen/feathers/controls/ScrollPolicy.js":
/*!****************************************************!*\
  !*** ./lib/_gen/feathers/controls/ScrollPolicy.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.controls.ScrollPolicy

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var ScrollPolicy = $hxEnums["feathers.controls.ScrollPolicy"] = { __ename__ : "feathers.controls.ScrollPolicy", __constructs__ : ["ON","OFF","AUTO"]
  ,ON: {_hx_index:0,__enum__:"feathers.controls.ScrollPolicy",toString:$estr}
  ,OFF: {_hx_index:1,__enum__:"feathers.controls.ScrollPolicy",toString:$estr}
  ,AUTO: {_hx_index:2,__enum__:"feathers.controls.ScrollPolicy",toString:$estr}
};

exports["default"] = ScrollPolicy;

/***/ }),

/***/ "./lib/_gen/feathers/controls/TabBar.js":
/*!**********************************************!*\
  !*** ./lib/_gen/feathers/controls/TabBar.js ***!
  \**********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.TabBar

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}
function feathers_core_IDataSelector() {return __webpack_require__(/*! ./../../feathers/core/IDataSelector */ "./lib/_gen/feathers/core/IDataSelector.js");}
function feathers_core_IIndexSelector() {return __webpack_require__(/*! ./../../feathers/core/IIndexSelector */ "./lib/_gen/feathers/core/IIndexSelector.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function haxe_ds_StringMap() {return __webpack_require__(/*! ./../../haxe/ds/StringMap */ "./lib/_gen/haxe/ds/StringMap.js");}
function feathers_themes_steel_components_SteelTabBarStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelTabBarStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTabBarStyles.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function Type() {return __webpack_require__(/*! ./../../Type */ "./lib/_gen/Type.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function feathers_controls__$TabBar_TabStorage() {return __webpack_require__(/*! ./../../feathers/controls/_TabBar/TabStorage */ "./lib/_gen/feathers/controls/_TabBar/TabStorage.js");}
function feathers_controls_dataRenderers_IDataRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/IDataRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IDataRenderer.js");}
function feathers_layout_ILayoutIndexObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutIndexObject */ "./lib/_gen/feathers/layout/ILayoutIndexObject.js");}
function feathers_controls_ToggleButton() {return __webpack_require__(/*! ./../../feathers/controls/ToggleButton */ "./lib/_gen/feathers/controls/ToggleButton.js");}
function feathers_events_TabBarEvent() {return __webpack_require__(/*! ./../../feathers/events/TabBarEvent */ "./lib/_gen/feathers/events/TabBarEvent.js");}
function feathers_data_TabBarItemState() {return __webpack_require__(/*! ./../../feathers/data/TabBarItemState */ "./lib/_gen/feathers/data/TabBarItemState.js");}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}
function haxe_ds_ObjectMap() {return __webpack_require__(/*! ./../../haxe/ds/ObjectMap */ "./lib/_gen/haxe/ds/ObjectMap.js");}
function feathers_utils_DisplayObjectRecycler() {return __webpack_require__(/*! ./../../feathers/utils/DisplayObjectRecycler */ "./lib/_gen/feathers/utils/DisplayObjectRecycler.js");}

// Constructor

var TabBar = function(dataProvider,changeListener) {
	this.__disabledBackgroundSkin = null;
	this.__backgroundSkin = null;
	this.__layout = null;
	this.__customTabVariant = null;
	this._ignoreChildChanges = false;
	this._layoutResult = new (feathers_layout_LayoutBoundsResult().default)();
	this._layoutMeasurements = new (feathers_layout_Measurements().default)();
	this._backgroundSkinMeasurements = null;
	this._currentBackgroundSkin = null;
	this._ignoreSelectionChange = false;
	this._layoutItems = [];
	this._unrenderedData = [];
	this.itemStatePool = new (lime_utils_ObjectPool().default)(function() {
		return new (feathers_data_TabBarItemState().default)();
	});
	this.tabToItemState = new (haxe_ds_ObjectMap().default)();
	this.dataToTab = new (haxe_ds_ObjectMap().default)();
	this._additionalStorage = null;
	this._defaultStorage = new (feathers_controls__$TabBar_TabStorage().default)(null,(feathers_utils_DisplayObjectRecycler().default).withClass((feathers_controls_ToggleButton().default)));
	this._recyclerMap = null;
	this._forceItemStateUpdate = false;
	this._previousCustomTabVariant = null;
	this._selectedItem = null;
	this._selectedIndex = -1;
	this._dataProvider = null;
	this.initializeTabBarTheme();
	(feathers_core_FeathersControl().default).call(this);
	this.set_dataProvider(dataProvider);
	this.set_tabEnabled(true);
	this.set_tabChildren(false);
	this.addEventListener("keyDown",$bind(this,this.tabBar_keyDownHandler));
	if(changeListener != null) {
		this.addEventListener("change",changeListener);
	}
}

// Meta

TabBar.__name__ = "feathers.controls.TabBar";
TabBar.__isInterface__ = false;
TabBar.__interfaces__ = [(feathers_core_IFocusObject().default),(feathers_core_IDataSelector().default),(feathers_core_IIndexSelector().default)];
TabBar.__super__ = (feathers_core_FeathersControl().default);
TabBar.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_dataProvider: function() {
		return this._dataProvider;
	},
	set_dataProvider: function(value) {
		if(this._dataProvider == value) {
			return this._dataProvider;
		}
		if(this._dataProvider != null) {
			this._dataProvider.removeEventListener("change",$bind(this,this.tabBar_dataProvider_changeHandler));
			this._dataProvider.removeEventListener("addItem",$bind(this,this.tabBar_dataProvider_addItemHandler));
			this._dataProvider.removeEventListener("removeItem",$bind(this,this.tabBar_dataProvider_removeItemHandler));
			this._dataProvider.removeEventListener("replaceItem",$bind(this,this.tabBar_dataProvider_replaceItemHandler));
			this._dataProvider.removeEventListener("removeAll",$bind(this,this.tabBar_dataProvider_removeAllHandler));
			this._dataProvider.removeEventListener("reset",$bind(this,this.tabBar_dataProvider_resetHandler));
			this._dataProvider.removeEventListener("sortChange",$bind(this,this.tabBar_dataProvider_sortChangeHandler));
			this._dataProvider.removeEventListener("filterChange",$bind(this,this.tabBar_dataProvider_filterChangeHandler));
			this._dataProvider.removeEventListener("updateItem",$bind(this,this.tabBar_dataProvider_updateItemHandler));
			this._dataProvider.removeEventListener("updateAll",$bind(this,this.tabBar_dataProvider_updateAllHandler));
		}
		var oldSelectedIndex = this._selectedIndex;
		var oldSelectedItem = this._selectedItem;
		this._dataProvider = value;
		if(this._dataProvider != null) {
			this._dataProvider.addEventListener("change",$bind(this,this.tabBar_dataProvider_changeHandler));
			this._dataProvider.addEventListener("addItem",$bind(this,this.tabBar_dataProvider_addItemHandler));
			this._dataProvider.addEventListener("removeItem",$bind(this,this.tabBar_dataProvider_removeItemHandler));
			this._dataProvider.addEventListener("replaceItem",$bind(this,this.tabBar_dataProvider_replaceItemHandler));
			this._dataProvider.addEventListener("removeAll",$bind(this,this.tabBar_dataProvider_removeAllHandler));
			this._dataProvider.addEventListener("reset",$bind(this,this.tabBar_dataProvider_resetHandler));
			this._dataProvider.addEventListener("sortChange",$bind(this,this.tabBar_dataProvider_sortChangeHandler));
			this._dataProvider.addEventListener("filterChange",$bind(this,this.tabBar_dataProvider_filterChangeHandler));
			this._dataProvider.addEventListener("updateItem",$bind(this,this.tabBar_dataProvider_updateItemHandler));
			this._dataProvider.addEventListener("updateAll",$bind(this,this.tabBar_dataProvider_updateAllHandler));
		}
		if(this._dataProvider == null || this._dataProvider.get_length() == 0) {
			this._selectedIndex = -1;
			this._selectedItem = null;
		} else {
			this._selectedIndex = 0;
			this._selectedItem = this._dataProvider.get(0);
		}
		if(this._selectedIndex != oldSelectedIndex || this._selectedItem != oldSelectedItem) {
			this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._dataProvider;
	},
	get_selectedIndex: function() {
		return this._selectedIndex;
	},
	set_selectedIndex: function(value) {
		if(this._dataProvider == null) {
			value = -1;
		}
		if(this._selectedIndex == value) {
			return this._selectedIndex;
		}
		if(value == -1) {
			this._selectedIndex = -1;
			this._selectedItem = null;
			this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
			return this._selectedIndex;
		}
		this._selectedIndex = value;
		this._selectedItem = this._dataProvider.get(this._selectedIndex);
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedIndex;
	},
	get_maxSelectedIndex: function() {
		if(this._dataProvider == null) {
			return -1;
		}
		return this._dataProvider.get_length() - 1;
	},
	get_selectedItem: function() {
		return this._selectedItem;
	},
	set_selectedItem: function(value) {
		if(value == null || this._dataProvider == null) {
			this.set_selectedIndex(-1);
			return this._selectedItem;
		}
		var index = this._dataProvider.indexOf(value);
		if(index == -1) {
			this.set_selectedIndex(-1);
			return this._selectedItem;
		}
		if(this._selectedItem == value && this._selectedIndex == index) {
			return this._selectedItem;
		}
		this._selectedIndex = index;
		this._selectedItem = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedItem;
	},
	get_tabRecycler: function() {
		return this._defaultStorage.tabRecycler;
	},
	set_tabRecycler: function(value) {
		if(this._defaultStorage.tabRecycler == value) {
			return this._defaultStorage.tabRecycler;
		}
		this._defaultStorage.oldTabRecycler = this._defaultStorage.tabRecycler;
		this._defaultStorage.tabRecycler = value;
		this.setInvalid(TabBar.INVALIDATION_FLAG_TAB_FACTORY);
		return this._defaultStorage.tabRecycler;
	},
	get_forceItemStateUpdate: function() {
		return this._forceItemStateUpdate;
	},
	set_forceItemStateUpdate: function(value) {
		if(this._forceItemStateUpdate == value) {
			return this._forceItemStateUpdate;
		}
		this._forceItemStateUpdate = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._forceItemStateUpdate;
	},
	get_tabRecyclerIDFunction: function() {
		return this._tabRecyclerIDFunction;
	},
	set_tabRecyclerIDFunction: function(value) {
		if(this._tabRecyclerIDFunction == value) {
			return this._tabRecyclerIDFunction;
		}
		this._tabRecyclerIDFunction = value;
		this.setInvalid(TabBar.INVALIDATION_FLAG_TAB_FACTORY);
		return this._tabRecyclerIDFunction;
	},
	itemToText: function(data) {
		return (Std().default).string(data);
	},
	itemToEnabled: function(data) {
		return true;
	},
	itemToTab: function(item) {
		if(item == null) {
			return null;
		}
		return this.dataToTab.get(item);
	},
	indexToTab: function(index) {
		if(this._dataProvider == null || index < 0 || index >= this._dataProvider.get_length()) {
			return null;
		}
		var item = this._dataProvider.get(index);
		return this.dataToTab.get(item);
	},
	getTabRecycler: function(id) {
		if(this._recyclerMap == null) {
			return null;
		}
		return this._recyclerMap.get(id);
	},
	setTabRecycler: function(id,recycler) {
		if(this._recyclerMap == null) {
			this._recyclerMap = new (haxe_ds_StringMap().default)();
		}
		if(recycler == null) {
			this._recyclerMap.remove(id);
			return;
		}
		this._recyclerMap.set(id,recycler);
		this.setInvalid(TabBar.INVALIDATION_FLAG_TAB_FACTORY);
	},
	initializeTabBarTheme: function() {
		(feathers_themes_steel_components_SteelTabBarStyles().default).initialize();
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var layoutInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		var selectionInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(this._previousCustomTabVariant != this.get_customTabVariant()) {
			this.setInvalidationFlag(TabBar.INVALIDATION_FLAG_TAB_FACTORY);
		}
		var tabsInvalid = this.isInvalid(TabBar.INVALIDATION_FLAG_TAB_FACTORY);
		if(stylesInvalid || stateInvalid) {
			this.refreshBackgroundSkin();
		}
		if(tabsInvalid || selectionInvalid || stateInvalid || dataInvalid) {
			this.refreshTabs();
		}
		this.refreshViewPortBounds();
		this.handleLayout();
		this.handleLayoutResult();
		this.layoutBackgroundSkin();
		this.validateChildren();
		this._previousCustomTabVariant = this.get_customTabVariant();
	},
	refreshViewPortBounds: function() {
		this._layoutMeasurements.save(this);
	},
	handleLayout: function() {
		var oldIgnoreChildChanges = this._ignoreChildChanges;
		this._ignoreChildChanges = true;
		this._layoutResult.reset();
		if(this.get_layout() != null) {
			this.get_layout().layout(this._layoutItems,this._layoutMeasurements,this._layoutResult);
		}
		this._ignoreChildChanges = oldIgnoreChildChanges;
	},
	handleLayoutResult: function() {
		var viewPortWidth = this._layoutResult.viewPortWidth;
		var viewPortHeight = this._layoutResult.viewPortHeight;
		this.saveMeasurements(viewPortWidth,viewPortHeight,viewPortWidth,viewPortHeight);
	},
	validateChildren: function() {
		var _g = 0;
		var _g1 = this._layoutItems;
		while(_g < _g1.length) {
			var tab = _g1[_g];
			++_g;
			if(!(js_Boot().default).__implements(tab,(feathers_core_IValidating().default))) {
				return;
			}
			((js_Boot().default).__cast(tab , (feathers_core_IValidating().default))).validateNow();
		}
	},
	refreshTabs: function() {
		if(this.get_tabRecycler().update == null) {
			this.get_tabRecycler().update = TabBar.defaultUpdateTab;
			if(this.get_tabRecycler().reset == null) {
				this.get_tabRecycler().reset = TabBar.defaultResetTab;
			}
		}
		if(this._recyclerMap != null) {
			var recycler = this._recyclerMap.iterator();
			while(recycler.hasNext()) {
				var recycler1 = recycler.next();
				if(recycler1.update == null) {
					if(recycler1.update == null) {
						recycler1.update = TabBar.defaultUpdateTab;
						if(recycler1.reset == null) {
							recycler1.reset = TabBar.defaultResetTab;
						}
					}
				}
			}
		}
		var tabsInvalid = this.isInvalid(TabBar.INVALIDATION_FLAG_TAB_FACTORY);
		this.refreshInactiveTabs(this._defaultStorage,tabsInvalid);
		if(this._additionalStorage != null) {
			var _g = 0;
			var _g1 = this._additionalStorage.length;
			while(_g < _g1) {
				var i = _g++;
				var storage = this._additionalStorage[i];
				this.refreshInactiveTabs(storage,tabsInvalid);
			}
		}
		this.findUnrenderedData();
		this.recoverInactiveTabs(this._defaultStorage);
		if(this._additionalStorage != null) {
			var _g2 = 0;
			var _g11 = this._additionalStorage.length;
			while(_g2 < _g11) {
				var i1 = _g2++;
				var storage1 = this._additionalStorage[i1];
				this.recoverInactiveTabs(storage1);
			}
		}
		this.renderUnrenderedData();
		this.freeInactiveTabs(this._defaultStorage);
		if(this._defaultStorage.inactiveTabs.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive tabs should be empty after updating."));
		}
		if(this._additionalStorage != null) {
			var _g3 = 0;
			var _g12 = this._additionalStorage.length;
			while(_g3 < _g12) {
				var i2 = _g3++;
				var storage2 = this._additionalStorage[i2];
				this.freeInactiveTabs(storage2);
				if(storage2.inactiveTabs.length > 0) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive tabs " + storage2.id + " should be empty after updating."));
				}
			}
		}
	},
	refreshInactiveTabs: function(storage,factoryInvalid) {
		var temp = storage.inactiveTabs;
		storage.inactiveTabs = storage.activeTabs;
		storage.activeTabs = temp;
		if(storage.activeTabs.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": active tabs should be empty before updating."));
		}
		if(factoryInvalid) {
			this.recoverInactiveTabs(storage);
			this.freeInactiveTabs(storage);
		}
	},
	recoverInactiveTabs: function(storage) {
		var _g = 0;
		var _g1 = storage.inactiveTabs;
		while(_g < _g1.length) {
			var tab = _g1[_g];
			++_g;
			if(tab == null) {
				continue;
			}
			var state = this.tabToItemState.get(tab);
			if(state == null) {
				continue;
			}
			var item = state.data;
			this.tabToItemState.remove(tab);
			this.dataToTab.remove(item);
			tab.removeEventListener("trigger",$bind(this,this.tabBar_tab_triggerHandler));
			tab.removeEventListener("change",$bind(this,this.tabBar_tab_changeHandler));
			this.resetTab(tab,state);
			this.itemStatePool.release(state);
		}
	},
	freeInactiveTabs: function(storage) {
		var _g = 0;
		var _g1 = storage.inactiveTabs;
		while(_g < _g1.length) {
			var tab = _g1[_g];
			++_g;
			if(tab == null) {
				continue;
			}
			this.destroyTab(tab);
		}
		storage.inactiveTabs.length = 0;
	},
	refreshBackgroundSkin: function() {
		var oldSkin = this._currentBackgroundSkin;
		this._currentBackgroundSkin = this.getCurrentBackgroundSkin();
		if(this._currentBackgroundSkin == oldSkin) {
			return;
		}
		this.removeCurrentBackgroundSkin(oldSkin);
		this.addCurrentBackgroundSkin(this._currentBackgroundSkin);
	},
	getCurrentBackgroundSkin: function() {
		if(!this._enabled && this.get_disabledBackgroundSkin() != null) {
			return this.get_disabledBackgroundSkin();
		}
		return this.get_backgroundSkin();
	},
	addCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			this._backgroundSkinMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._backgroundSkinMeasurements == null) {
			this._backgroundSkinMeasurements = new (feathers_layout_Measurements().default)(skin);
		} else {
			this._backgroundSkinMeasurements.save(skin);
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this.addChildAt(skin,0);
	},
	removeCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		this._backgroundSkinMeasurements.restore(skin);
		if(skin.parent == this) {
			this.removeChild(skin);
		}
	},
	layoutBackgroundSkin: function() {
		if(this._currentBackgroundSkin == null) {
			return;
		}
		this._currentBackgroundSkin.set_x(0.0);
		this._currentBackgroundSkin.set_y(0.0);
		if(this._currentBackgroundSkin.get_width() != this.actualWidth) {
			this._currentBackgroundSkin.set_width(this.actualWidth);
		}
		if(this._currentBackgroundSkin.get_height() != this.actualHeight) {
			this._currentBackgroundSkin.set_height(this.actualHeight);
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
	},
	findUnrenderedData: function() {
		this._layoutItems.length = 0;
		if(this._dataProvider == null || this._dataProvider.get_length() == 0) {
			return;
		}
		this._layoutItems.length = this._dataProvider.get_length();
		var depthOffset = this._currentBackgroundSkin != null ? 1 : 0;
		var _g = 0;
		var _g1 = this._dataProvider.get_length();
		while(_g < _g1) {
			var i = _g++;
			var item = this._dataProvider.get(i);
			var tab = this.dataToTab.get(item);
			if(tab != null) {
				var state = this.tabToItemState.get(tab);
				var changed = this.populateCurrentItemState(item,i,state,this._forceItemStateUpdate);
				var oldRecyclerID = state.recyclerID;
				var storage = this.itemStateToStorage(state);
				if(storage.id != oldRecyclerID) {
					this._unrenderedData.push(item);
					continue;
				}
				if(changed) {
					this.updateTab(tab,state,storage);
				}
				this._layoutItems[i] = tab;
				this.setChildIndex(tab,i + depthOffset);
				var removed = (HxOverrides().default).remove(storage.inactiveTabs,tab);
				if(!removed) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": tab renderer map contains bad data for item at index " + i + ". This may be caused by duplicate items in the data provider, which is not allowed."));
				}
				storage.activeTabs.push(tab);
			} else {
				this._unrenderedData.push(item);
			}
		}
	},
	renderUnrenderedData: function() {
		var depthOffset = this._currentBackgroundSkin != null ? 1 : 0;
		var _g = 0;
		var _g1 = this._unrenderedData;
		while(_g < _g1.length) {
			var item = _g1[_g];
			++_g;
			var index = this._dataProvider.indexOf(item);
			var state = this.itemStatePool.get();
			this.populateCurrentItemState(item,index,state,true);
			var tab = this.createTab(state);
			this.addChildAt(tab,index + depthOffset);
			this._layoutItems[index] = tab;
		}
		this._unrenderedData.length = 0;
	},
	createTab: function(state) {
		var storage = this.itemStateToStorage(state);
		var tab = null;
		if(storage.inactiveTabs.length == 0) {
			tab = this.get_tabRecycler().create();
			if(tab.get_variant() == null) {
				var variant = this.get_customTabVariant() != null ? this.get_customTabVariant() : TabBar.CHILD_VARIANT_TAB;
				tab.set_variant(variant);
			}
			tab.initializeNow();
		} else {
			tab = storage.inactiveTabs.shift();
		}
		this.updateTab(tab,state,storage);
		tab.addEventListener("trigger",$bind(this,this.tabBar_tab_triggerHandler));
		tab.addEventListener("change",$bind(this,this.tabBar_tab_changeHandler));
		this.tabToItemState.set(tab,state);
		this.dataToTab.set(state.data,tab);
		storage.activeTabs.push(tab);
		return tab;
	},
	destroyTab: function(tab) {
		this.removeChild(tab);
		if(this.get_tabRecycler().destroy != null) {
			this.get_tabRecycler().destroy(tab);
		}
	},
	itemStateToStorage: function(state) {
		var recyclerID = null;
		if(this._tabRecyclerIDFunction != null) {
			recyclerID = this._tabRecyclerIDFunction(state);
		}
		var recycler = null;
		if(recyclerID != null) {
			if(this._recyclerMap != null) {
				recycler = this._recyclerMap.get(recyclerID);
			}
			if(recycler == null) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Item renderer recycler ID \"" + recyclerID + "\" is not registered."));
			}
		}
		if(recycler == null) {
			return this._defaultStorage;
		}
		if(this._additionalStorage == null) {
			this._additionalStorage = [];
		}
		var _g = 0;
		var _g1 = this._additionalStorage.length;
		while(_g < _g1) {
			var i = _g++;
			var storage = this._additionalStorage[i];
			if(storage.tabRecycler == recycler) {
				return storage;
			}
		}
		var storage1 = new (feathers_controls__$TabBar_TabStorage().default)(recyclerID,recycler);
		this._additionalStorage.push(storage1);
		return storage1;
	},
	populateCurrentItemState: function(item,index,state,force) {
		var changed = false;
		if(force || state.owner != this) {
			state.owner = this;
			changed = true;
		}
		if(force || state.data != item) {
			state.data = item;
			changed = true;
		}
		if(force || state.index != index) {
			state.index = index;
			changed = true;
		}
		var selected = item == this._selectedItem;
		if(force || state.selected != selected) {
			state.selected = selected;
			changed = true;
		}
		var enabled = this._enabled && this.itemToEnabled(item);
		if(force || state.enabled != enabled) {
			state.enabled = enabled;
			changed = true;
		}
		var text = this.itemToText(item);
		if(force || state.text != text) {
			state.text = text;
			changed = true;
		}
		return changed;
	},
	updateTab: function(tab,state,storage) {
		state.recyclerID = storage.id;
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		if(this.get_tabRecycler().update != null) {
			this.get_tabRecycler().update(tab,state);
		}
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		this.refreshTabProperties(tab,state);
	},
	resetTab: function(tab,state) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		if(this.get_tabRecycler() != null && this.get_tabRecycler().reset != null) {
			this.get_tabRecycler().reset(tab,state);
		}
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		this.refreshTabProperties(tab,TabBar.RESET_TAB_STATE);
	},
	refreshTabProperties: function(tab,state) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		if((js_Boot().default).__implements(tab,(feathers_core_IUIControl().default))) {
			var uiControl = (js_Boot().default).__cast(tab , (feathers_core_IUIControl().default));
			uiControl.set_enabled(state.enabled);
		}
		if((js_Boot().default).__implements(tab,(feathers_controls_dataRenderers_IDataRenderer().default))) {
			var dataRenderer = (js_Boot().default).__cast(tab , (feathers_controls_dataRenderers_IDataRenderer().default));
			dataRenderer.set_data(state.data);
		}
		if((js_Boot().default).__implements(tab,(feathers_layout_ILayoutIndexObject().default))) {
			var layoutObject = (js_Boot().default).__cast(tab , (feathers_layout_ILayoutIndexObject().default));
			layoutObject.set_layoutIndex(state.index);
		}
		tab.set_selected(state.selected);
		tab.set_enabled(state.enabled);
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
	},
	refreshSelectedIndicesAfterFilterOrSort: function() {
		if(this._selectedIndex == -1) {
			return;
		}
		this.set_selectedIndex(this._dataProvider.indexOf(this._selectedItem));
	},
	navigateWithKeyboard: function(event) {
		if(event.isDefaultPrevented()) {
			return;
		}
		if(this._dataProvider == null || this._dataProvider.get_length() == 0) {
			return;
		}
		var result = this._selectedIndex;
		switch(event.keyCode) {
		case 33:
			--result;
			break;
		case 34:
			++result;
			break;
		case 35:
			result = this._dataProvider.get_length() - 1;
			break;
		case 36:
			result = 0;
			break;
		case 37:
			--result;
			break;
		case 38:
			if(event.keyLocation == 4) {
				return;
			}
			--result;
			break;
		case 39:
			++result;
			break;
		case 40:
			if(event.keyLocation == 4) {
				return;
			}
			++result;
			break;
		default:
			return;
		}
		if(result < 0) {
			result = 0;
		} else if(result >= this._dataProvider.get_length()) {
			result = this._dataProvider.get_length() - 1;
		}
		event.preventDefault();
		this.set_selectedIndex(result);
	},
	tabBar_keyDownHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		this.navigateWithKeyboard(event);
	},
	tabBar_tab_triggerHandler: function(event) {
		var tab = (js_Boot().default).__cast(event.currentTarget , (feathers_controls_ToggleButton().default));
		var state = this.tabToItemState.get(tab);
		(feathers_events_TabBarEvent().default).dispatch(this,"itemTrigger",state);
	},
	tabBar_tab_changeHandler: function(event) {
		if(this._ignoreSelectionChange) {
			return;
		}
		var tab = (js_Boot().default).__cast(event.currentTarget , (feathers_controls_ToggleButton().default));
		if(!tab.get_selected()) {
			tab.set_selected(true);
			return;
		}
		var state = this.tabToItemState.get(tab);
		this.set_selectedItem(state.data);
	},
	tabBar_dataProvider_changeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
	},
	tabBar_dataProvider_addItemHandler: function(event) {
		if(this._selectedIndex == -1) {
			return;
		}
		if(this._selectedIndex >= event.index) {
			this._selectedIndex++;
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
		}
	},
	tabBar_dataProvider_removeItemHandler: function(event) {
		if(this._selectedIndex == -1) {
			return;
		}
		if(this._selectedIndex == event.index) {
			if(event.index == this._dataProvider.get_length()) {
				this._selectedIndex = this._dataProvider.get_length() - 1;
			}
			if(this._selectedIndex == -1) {
				this._selectedItem = null;
			} else {
				this._selectedItem = this._dataProvider.get(this._selectedIndex);
			}
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
		} else if(this._selectedIndex > event.index) {
			this._selectedIndex--;
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
		}
	},
	tabBar_dataProvider_replaceItemHandler: function(event) {
		if(this._selectedIndex == -1) {
			return;
		}
		if(this._selectedIndex == event.index) {
			this._selectedItem = this._dataProvider.get(this._selectedIndex);
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
		}
	},
	tabBar_dataProvider_removeAllHandler: function(event) {
		this.set_selectedIndex(-1);
	},
	tabBar_dataProvider_resetHandler: function(event) {
		this.set_selectedIndex(-1);
	},
	tabBar_dataProvider_sortChangeHandler: function(event) {
		this.refreshSelectedIndicesAfterFilterOrSort();
	},
	tabBar_dataProvider_filterChangeHandler: function(event) {
		this.refreshSelectedIndicesAfterFilterOrSort();
	},
	updateTabForIndex: function(index) {
		var item = this._dataProvider.get(index);
		var tab = this.dataToTab.get(item);
		if(tab == null) {
			this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
			return;
		}
		var state = this.tabToItemState.get(tab);
		if(state.owner == null) {
			return;
		}
		var storage = this.itemStateToStorage(state);
		this.populateCurrentItemState(item,index,state,true);
		this.resetTab(tab,state);
		state.owner = null;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
	},
	tabBar_dataProvider_updateItemHandler: function(event) {
		this.updateTabForIndex(event.index);
	},
	tabBar_dataProvider_updateAllHandler: function(event) {
		var _g = 0;
		var _g1 = this._dataProvider.get_length();
		while(_g < _g1) {
			var i = _g++;
			this.updateTabForIndex(i);
		}
	},
	get_customTabVariant: function() {
		return this.__customTabVariant;
	},
	set_customTabVariant: function(value) {
		if(!this.setStyle("customTabVariant")) {
			return this.__customTabVariant;
		}
		if(this.__customTabVariant == value) {
			return this.__customTabVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customTabVariant);
		this.__customTabVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customTabVariant;
	},
	clearStyle_customTabVariant: function() {
		this.set_customTabVariant(null);
		return this.get_customTabVariant();
	},
	get_layout: function() {
		return this.__layout;
	},
	set_layout: function(value) {
		if(!this.setStyle("layout")) {
			return this.__layout;
		}
		if(this.__layout == value) {
			return this.__layout;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_layout);
		this.__layout = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__layout;
	},
	clearStyle_layout: function() {
		this.set_layout(null);
		return this.get_layout();
	},
	get_backgroundSkin: function() {
		return this.__backgroundSkin;
	},
	set_backgroundSkin: function(value) {
		if(!this.setStyle("backgroundSkin")) {
			return this.__backgroundSkin;
		}
		if(this.__backgroundSkin == value) {
			return this.__backgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_backgroundSkin);
		this.__backgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__backgroundSkin;
	},
	clearStyle_backgroundSkin: function() {
		this.set_backgroundSkin(null);
		return this.get_backgroundSkin();
	},
	get_disabledBackgroundSkin: function() {
		return this.__disabledBackgroundSkin;
	},
	set_disabledBackgroundSkin: function(value) {
		if(!this.setStyle("disabledBackgroundSkin")) {
			return this.__disabledBackgroundSkin;
		}
		if(this.__disabledBackgroundSkin == value) {
			return this.__disabledBackgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledBackgroundSkin);
		this.__disabledBackgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledBackgroundSkin;
	},
	clearStyle_disabledBackgroundSkin: function() {
		this.set_disabledBackgroundSkin(null);
		return this.get_disabledBackgroundSkin();
	},
	get_styleContext: function() {
		return TabBar
	}
});
TabBar.prototype.__class__ = TabBar.prototype.constructor = $hxClasses["feathers.controls.TabBar"] = TabBar;

// Init



// Statics

TabBar.defaultUpdateTab = function(tab,state) {
	tab.set_text(state.text);
}
TabBar.defaultResetTab = function(tab,state) {
	tab.set_text(null);
}
TabBar.__meta__ = { obj : { defaultXmlProperty : ["dataProvider"]}}
TabBar.INVALIDATION_FLAG_TAB_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("tabFactory")
TabBar.CHILD_VARIANT_TAB = "tabBar_tab"
TabBar.RESET_TAB_STATE = new (feathers_data_TabBarItemState().default)()

// Export

exports["default"] = TabBar;

/***/ }),

/***/ "./lib/_gen/feathers/controls/TextArea.js":
/*!************************************************!*\
  !*** ./lib/_gen/feathers/controls/TextArea.js ***!
  \************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.TextArea

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IStageFocusDelegate() {return __webpack_require__(/*! ./../../feathers/core/IStageFocusDelegate */ "./lib/_gen/feathers/core/IStageFocusDelegate.js");}
function feathers_core_ITextControl() {return __webpack_require__(/*! ./../../feathers/core/ITextControl */ "./lib/_gen/feathers/core/ITextControl.js");}
function feathers_core_IStateContext() {return __webpack_require__(/*! ./../../feathers/core/IStateContext */ "./lib/_gen/feathers/core/IStateContext.js");}
function feathers_controls_supportClasses_BaseScrollContainer() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/BaseScrollContainer */ "./lib/_gen/feathers/controls/supportClasses/BaseScrollContainer.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function feathers_themes_steel_components_SteelTextAreaStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelTextAreaStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTextAreaStyles.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IStateObserver() {return __webpack_require__(/*! ./../../feathers/core/IStateObserver */ "./lib/_gen/feathers/core/IStateObserver.js");}
function openfl_text_TextField() {return (__webpack_require__(/*! openfl */ "openfl").text.TextField);}
function feathers_controls_TextInputState() {return __webpack_require__(/*! ./../../feathers/controls/TextInputState */ "./lib/_gen/feathers/controls/TextInputState.js");}
function feathers_core_PopUpManager() {return __webpack_require__(/*! ./../../feathers/core/PopUpManager */ "./lib/_gen/feathers/core/PopUpManager.js");}
function feathers_controls_TextCallout() {return __webpack_require__(/*! ./../../feathers/controls/TextCallout */ "./lib/_gen/feathers/controls/TextCallout.js");}
function feathers_controls_TextInput() {return __webpack_require__(/*! ./../../feathers/controls/TextInput */ "./lib/_gen/feathers/controls/TextInput.js");}
function haxe_ds_EnumValueMap() {return __webpack_require__(/*! ./../../haxe/ds/EnumValueMap */ "./lib/_gen/haxe/ds/EnumValueMap.js");}
function feathers_controls_supportClasses_TextFieldViewPort() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/TextFieldViewPort */ "./lib/_gen/feathers/controls/supportClasses/TextFieldViewPort.js");}

// Constructor

var TextArea = function(text,prompt,changeListener) {
	if(text == null) {
		text = "";
	}
	this.__customErrorCalloutVariant = null;
	this.__showPromptWhenEmptyAndFocused = true;
	this.__textPaddingLeft = 0.0;
	this.__textPaddingBottom = 0.0;
	this.__textPaddingRight = 0.0;
	this.__textPaddingTop = 0.0;
	this.__wordWrap = true;
	this.__embedFonts = false;
	this.__promptTextFormat = null;
	this.__disabledTextFormat = null;
	this.__textFormat = null;
	this.__smoothScrolling = false;
	this._stateToSkin = new (haxe_ds_EnumValueMap().default)();
	this._ignoreViewPortTextChange = false;
	this._previousCustomErrorCalloutVariant = null;
	this._maxChars = 0;
	this._stateToTextFormat = new (haxe_ds_EnumValueMap().default)();
	this._errorString = null;
	this._displayAsPassword = false;
	this._currentState = (feathers_controls_TextInputState().default).ENABLED;
	this._selectable = true;
	this._editable = true;
	this._updatedPromptStyles = false;
	this._previousSimplePromptTextFormat = null;
	this._previousPromptTextFormat = null;
	this._previousPrompt = null;
	this._previousSimpleTextFormat = null;
	this._previousTextFormat = null;
	this.initializeTextAreaTheme();
	(feathers_controls_supportClasses_BaseScrollContainer().default).call(this);
	this.set_text(text);
	this.set_prompt(prompt);
	this.set_tabEnabled(true);
	this.set_tabChildren(false);
	this.focusRect = null;
	if(this.get_viewPort() == null) {
		this.textFieldViewPort = new (feathers_controls_supportClasses_TextFieldViewPort().default)();
		this.textFieldViewPort.set_wordWrap(true);
		this.textFieldViewPort.set_multiline(true);
		this.textFieldViewPort.addEventListener("change",$bind(this,this.textArea_viewPort_changeHandler));
		this.addChild(this.textFieldViewPort);
		this.set_viewPort(this.textFieldViewPort);
	}
	this.addEventListener("focusIn",$bind(this,this.textArea_focusInHandler));
	this.addEventListener("focusOut",$bind(this,this.textArea_focusOutHandler));
	if(changeListener != null) {
		this.addEventListener("change",changeListener);
	}
}

// Meta

TextArea.__name__ = "feathers.controls.TextArea";
TextArea.__isInterface__ = false;
TextArea.__interfaces__ = [(feathers_core_IStageFocusDelegate().default),(feathers_core_ITextControl().default),(feathers_core_IStateContext().default)];
TextArea.__super__ = (feathers_controls_supportClasses_BaseScrollContainer().default);
TextArea.prototype = $extend((feathers_controls_supportClasses_BaseScrollContainer().default).prototype, {
	get_tabEnabled: function() {
		if(this._enabled) {
			return this.get_rawTabEnabled();
		} else {
			return false;
		}
	},
	get_editable: function() {
		return this._editable;
	},
	set_editable: function(value) {
		if(this._editable == value) {
			return this._editable;
		}
		this._editable = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STATE);
		return this._editable;
	},
	get_selectable: function() {
		return this._selectable;
	},
	set_selectable: function(value) {
		if(this._selectable == value) {
			return this._selectable;
		}
		this._selectable = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._selectable;
	},
	get_currentState: function() {
		return this._currentState;
	},
	set_enabled: function(value) {
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.set_enabled.call(this,value);
		this.refreshState();
		return this._enabled;
	},
	get_text: function() {
		return this._text;
	},
	set_text: function(value) {
		if(value == null) {
			if(this._text.length == 0) {
				return this._text;
			}
			value = "";
		}
		if(this._text == value) {
			return this._text;
		}
		this._text = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._text;
	},
	get_baseline: function() {
		if(this.textFieldViewPort == null) {
			return 0.0;
		}
		return this.get_paddingTop() + this.textFieldViewPort.get_baseline();
	},
	get_prompt: function() {
		return this._prompt;
	},
	set_prompt: function(value) {
		if(this._prompt == value) {
			return this._prompt;
		}
		this._prompt = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._prompt;
	},
	get_restrict: function() {
		return this.__restrict;
	},
	set_restrict: function(value) {
		if(this.__restrict == value) {
			return this.__restrict;
		}
		this.__restrict = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this.__restrict;
	},
	get_displayAsPassword: function() {
		return this._displayAsPassword;
	},
	set_displayAsPassword: function(value) {
		if(this._displayAsPassword == value) {
			return this._displayAsPassword;
		}
		this._displayAsPassword = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._displayAsPassword;
	},
	get_errorString: function() {
		return this._errorString;
	},
	set_errorString: function(value) {
		if(this._errorString == value) {
			return this._errorString;
		}
		this._errorString = value;
		this.refreshState();
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._text;
	},
	get_errorStringCalloutOpen: function() {
		if(this.errorStringCallout != null) {
			return this.errorStringCallout.parent != null;
		} else {
			return false;
		}
	},
	get_selectionAnchorIndex: function() {
		return this.textFieldViewPort.get_selectionAnchorIndex();
	},
	get_selectionActiveIndex: function() {
		return this.textFieldViewPort.get_selectionActiveIndex();
	},
	get_maxChars: function() {
		return this._maxChars;
	},
	set_maxChars: function(value) {
		if(this._maxChars == value) {
			return this._maxChars;
		}
		this._maxChars = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._maxChars;
	},
	get_measureViewPort: function() {
		return false;
	},
	get_stageFocusTarget: function() {
		return this.textFieldViewPort;
	},
	getSkinForState: function(state) {
		return this._stateToSkin.get(state);
	},
	setSkinForState: function(state,skin) {
		if(!this.setStyle("setSkinForState",state)) {
			return;
		}
		var oldSkin = this._stateToSkin.get(state);
		if(oldSkin != null && oldSkin == this._currentBackgroundSkin) {
			this.removeCurrentBackgroundSkin(oldSkin);
			this._currentBackgroundSkin = null;
		}
		if(skin == null) {
			this._stateToSkin.remove(state);
		} else {
			this._stateToSkin.set(state,skin);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	getTextFormatForState: function(state) {
		return this._stateToTextFormat.get(state);
	},
	setTextFormatForState: function(state,textFormat) {
		if(!this.setStyle("setTextFormatForState",state)) {
			return;
		}
		if(textFormat == null) {
			this._stateToTextFormat.remove(state);
		} else {
			this._stateToTextFormat.set(state,textFormat);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	selectRange: function(anchorIndex,activeIndex) {
		this.textFieldViewPort.selectRange(anchorIndex,activeIndex);
	},
	selectAll: function() {
		this.textFieldViewPort.selectRange(0,this._text.length);
	},
	setTextPadding: function(value) {
		this.set_textPaddingTop(value);
		this.set_textPaddingRight(value);
		this.set_textPaddingBottom(value);
		this.set_textPaddingLeft(value);
	},
	showFocus: function(show) {
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.showFocus.call(this,show);
		if(show) {
			this.selectRange(this._text.length,0);
		}
	},
	initializeTextAreaTheme: function() {
		(feathers_themes_steel_components_SteelTextAreaStyles().default).initialize();
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var sizeInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SIZE);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(this._previousCustomErrorCalloutVariant != this.get_customErrorCalloutVariant()) {
			this.setInvalidationFlag(TextArea.INVALIDATION_FLAG_ERROR_CALLOUT_FACTORY);
		}
		var errorCalloutFactoryInvalid = this.isInvalid(TextArea.INVALIDATION_FLAG_ERROR_CALLOUT_FACTORY);
		this._updatedPromptStyles = false;
		if(errorCalloutFactoryInvalid || dataInvalid) {
			this.createErrorCallout();
		}
		if(dataInvalid || stateInvalid) {
			this.refreshPrompt();
		}
		if(stylesInvalid || stateInvalid) {
			this.refreshPromptStyles();
		}
		if(dataInvalid || stylesInvalid || sizeInvalid) {
			this.refreshPromptText(sizeInvalid);
		}
		if(stylesInvalid) {
			this.refreshTextStyles();
			this.textFieldViewPort.set_embedFonts(this.get_embedFonts());
			this.textFieldViewPort.set_wordWrap(this.get_wordWrap());
			this.textFieldViewPort.set_paddingTop(this.get_textPaddingTop());
			this.textFieldViewPort.set_paddingRight(this.get_textPaddingRight());
			this.textFieldViewPort.set_paddingBottom(this.get_textPaddingBottom());
			this.textFieldViewPort.set_paddingLeft(this.get_textPaddingLeft());
			this.textFieldViewPort.set_smoothScrolling(this.get_smoothScrolling());
		}
		if(dataInvalid) {
			var oldIgnoreViewPortTextChange = this._ignoreViewPortTextChange;
			this._ignoreViewPortTextChange = true;
			this.textFieldViewPort.set_text(this._text);
			this._ignoreViewPortTextChange = oldIgnoreViewPortTextChange;
			this.textFieldViewPort.set_restrict(this.__restrict);
			this.textFieldViewPort.set_maxChars(this._maxChars);
			this.textFieldViewPort.set_displayAsPassword(this._displayAsPassword);
			if(this._editable) {
				this.textFieldViewPort.set_selectable(this._enabled);
			} else {
				this.textFieldViewPort.set_selectable(this._enabled && this._selectable);
			}
		}
		if(stateInvalid) {
			this.textFieldViewPort.set_enabled(this._enabled);
			this.textFieldViewPort.set_textFieldType(this._editable ? "input" : "dynamic");
		}
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.update.call(this);
		if(errorCalloutFactoryInvalid || stateInvalid || dataInvalid) {
			this.refreshErrorString();
		}
		this._previousCustomErrorCalloutVariant = this.get_customErrorCalloutVariant();
	},
	layoutChildren: function() {
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.layoutChildren.call(this);
		this.layoutPrompt();
	},
	addCurrentBackgroundSkin: function(skin) {
		if(skin != null) {
			if((js_Boot().default).__implements(skin,(feathers_core_IStateObserver().default))) {
				((js_Boot().default).__cast(skin , (feathers_core_IStateObserver().default))).set_stateContext(this);
			}
		}
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.addCurrentBackgroundSkin.call(this,skin);
	},
	removeCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IStateObserver().default))).set_stateContext(null);
		}
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.removeCurrentBackgroundSkin.call(this,skin);
	},
	refreshTextStyles: function() {
		var textFormat = this.getCurrentTextFormat();
		var simpleTextFormat = textFormat != null ? textFormat.toSimpleTextFormat() : null;
		if(simpleTextFormat == this._previousSimpleTextFormat) {
			return;
		}
		if(this._previousTextFormat != null) {
			this._previousTextFormat.removeEventListener("change",$bind(this,this.textArea_textFormat_changeHandler));
		}
		if(textFormat != null) {
			textFormat.addEventListener("change",$bind(this,this.textArea_textFormat_changeHandler),false,0,true);
			this.textFieldViewPort.set_textFormat(simpleTextFormat);
		}
		this._previousTextFormat = textFormat;
		this._previousSimpleTextFormat = simpleTextFormat;
	},
	refreshPrompt: function() {
		if(this._prompt == null) {
			if(this.promptTextField != null) {
				this.removeChild(this.promptTextField);
				this.promptTextField = null;
			}
			return;
		}
		if(this.promptTextField == null) {
			this.promptTextField = new (openfl_text_TextField())();
			this.promptTextField.set_selectable(false);
			this.promptTextField.set_mouseWheelEnabled(false);
			this.promptTextField.mouseEnabled = false;
			this.promptTextField.set_multiline(true);
			this.addChildAt(this.promptTextField,this.getChildIndex(this.textFieldViewPort));
		}
		this.promptTextField.set_visible(this._text.length == 0 && (this.get_currentState() != (feathers_controls_TextInputState().default).FOCUSED || this.get_showPromptWhenEmptyAndFocused()));
	},
	refreshPromptText: function(sizeInvalid) {
		if(this._prompt == null || this._prompt == this._previousPrompt && !this._updatedPromptStyles && !sizeInvalid) {
			return;
		}
		this.promptTextField.set_autoSize("left");
		var hasPromptText = this._prompt.length > 0;
		if(hasPromptText) {
			this.promptTextField.set_text(this._prompt);
		} else {
			this.promptTextField.set_text("​");
		}
		this.promptTextField.set_wordWrap(false);
		this._promptTextMeasuredWidth = this.promptTextField.get_width();
		this._promptTextMeasuredHeight = this.promptTextField.get_height();
		this.promptTextField.set_autoSize("none");
		this.promptTextField.set_wordWrap(true);
		if(!hasPromptText) {
			this.promptTextField.set_text("");
		}
		this._previousPrompt = this._prompt;
	},
	refreshPromptStyles: function() {
		if(this._prompt == null) {
			return;
		}
		if(this.promptTextField.get_embedFonts() != this.get_embedFonts()) {
			this.promptTextField.set_embedFonts(this.get_embedFonts());
			this._updatedPromptStyles = true;
		}
		var textFormat = this.getCurrentPromptTextFormat();
		var simpleTextFormat = textFormat != null ? textFormat.toSimpleTextFormat() : null;
		if(simpleTextFormat == this._previousSimplePromptTextFormat) {
			return;
		}
		if(this._previousPromptTextFormat != null) {
			this._previousPromptTextFormat.removeEventListener("change",$bind(this,this.textArea_promptTextFormat_changeHandler));
		}
		if(textFormat != null) {
			textFormat.addEventListener("change",$bind(this,this.textArea_promptTextFormat_changeHandler),false,0,true);
			this.promptTextField.set_defaultTextFormat(simpleTextFormat);
			this._updatedPromptStyles = true;
		}
		this._previousPromptTextFormat = textFormat;
		this._previousSimplePromptTextFormat = simpleTextFormat;
	},
	getCurrentPromptTextFormat: function() {
		var textFormat = this.get_promptTextFormat();
		if(textFormat == null) {
			textFormat = this.get_textFormat();
		}
		return textFormat;
	},
	refreshErrorString: function() {
		if(this.errorStringCallout == null) {
			return;
		}
		this.errorStringCallout.set_text(this._errorString);
		if(this._currentState == (feathers_controls_TextInputState().default).FOCUSED && this.errorStringCallout.parent == null) {
			(feathers_core_PopUpManager().default).addPopUp(this.errorStringCallout,this,false,false);
		} else if(this._currentState != (feathers_controls_TextInputState().default).FOCUSED && this.errorStringCallout.parent != null) {
			this.errorStringCallout.parent.removeChild(this.errorStringCallout);
		}
	},
	layoutPrompt: function() {
		if(this._prompt == null) {
			return;
		}
		this.promptTextField.set_x(this.leftViewPortOffset + this.get_textPaddingLeft());
		this.promptTextField.set_y(this.topViewPortOffset + this.get_textPaddingTop());
		var maxPromptWidth = this.get_viewPort().get_visibleWidth() - this.get_textPaddingLeft() - this.get_textPaddingRight();
		if(this._promptTextMeasuredWidth > maxPromptWidth) {
			this.promptTextField.set_width(maxPromptWidth);
		} else {
			this.promptTextField.set_width(this._promptTextMeasuredWidth);
		}
		this.promptTextField.set_height(this.get_viewPort().get_visibleHeight() - this.get_textPaddingTop() - this.get_textPaddingBottom());
	},
	getCurrentBackgroundSkin: function() {
		var result = this._stateToSkin.get(this._currentState);
		if(result != null) {
			return result;
		}
		return (feathers_controls_supportClasses_BaseScrollContainer().default).prototype.getCurrentBackgroundSkin.call(this);
	},
	getCurrentTextFormat: function() {
		var result = this._stateToTextFormat.get(this._currentState);
		if(result != null) {
			return result;
		}
		if(!this._enabled && this.get_disabledTextFormat() != null) {
			return this.get_disabledTextFormat();
		}
		return this.get_textFormat();
	},
	createErrorCallout: function() {
		if(this.errorStringCallout != null) {
			if(this.errorStringCallout.parent != null) {
				this.errorStringCallout.parent.removeChild(this.errorStringCallout);
			}
			this.errorStringCallout = null;
		}
		if(this._errorString == null || this._errorString.length == 0) {
			return;
		}
		this.errorStringCallout = new (feathers_controls_TextCallout().default)();
		if(this.errorStringCallout.get_variant() == null) {
			this.errorStringCallout.set_variant(this.get_customErrorCalloutVariant() != null ? this.get_customErrorCalloutVariant() : (feathers_controls_TextInput().default).CHILD_VARIANT_ERROR_CALLOUT);
		}
		this.errorStringCallout.set_origin(this);
		this.errorStringCallout.closeOnPointerOutside = false;
	},
	changeState: function(state) {
		if(!this._enabled) {
			state = (feathers_controls_TextInputState().default).DISABLED;
		}
		if(this._currentState == state) {
			return;
		}
		this._currentState = state;
		this.setInvalid((feathers_core_InvalidationFlag().default).STATE);
		(feathers_events_FeathersEvent().default).dispatch(this,"stateChange");
	},
	refreshState: function() {
		if(this._enabled) {
			var focused = this.stage != null && this.stage.get_focus() == this.textFieldViewPort.get_textField();
			if(focused) {
				this.changeState((feathers_controls_TextInputState().default).FOCUSED);
			} else if(this._errorString != null) {
				this.changeState((feathers_controls_TextInputState().default).ERROR);
			} else {
				this.changeState((feathers_controls_TextInputState().default).ENABLED);
			}
		} else {
			this.changeState((feathers_controls_TextInputState().default).DISABLED);
		}
	},
	textArea_focusInHandler: function(event) {
		if(this.stage != null && this.stage.get_focus() != null && this.textFieldViewPort != null && !this.textFieldViewPort.contains(this.stage.get_focus())) {
			event.stopImmediatePropagation();
			this.stage.set_focus(this.textFieldViewPort);
		}
		this.refreshState();
	},
	textArea_focusOutHandler: function(event) {
		this.refreshState();
	},
	baseScrollContainer_keyDownHandler: function(event) {
	},
	textArea_viewPort_changeHandler: function(event) {
		if(this._ignoreViewPortTextChange) {
			return;
		}
		this.set_text(this.textFieldViewPort.get_text());
	},
	textArea_textFormat_changeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	textArea_promptTextFormat_changeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	get_styleContext: function() {
		return TextArea
	},
	get_smoothScrolling: function() {
		return this.__smoothScrolling;
	},
	set_smoothScrolling: function(value) {
		if(!this.setStyle("smoothScrolling")) {
			return this.__smoothScrolling;
		}
		if(this.__smoothScrolling == value) {
			return this.__smoothScrolling;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_smoothScrolling);
		this.__smoothScrolling = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__smoothScrolling;
	},
	clearStyle_smoothScrolling: function() {
		this.set_smoothScrolling(false);
		return this.get_smoothScrolling();
	},
	get_textFormat: function() {
		return this.__textFormat;
	},
	set_textFormat: function(value) {
		if(!this.setStyle("textFormat")) {
			return this.__textFormat;
		}
		if(this.__textFormat == value) {
			return this.__textFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_textFormat);
		this.__textFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__textFormat;
	},
	clearStyle_textFormat: function() {
		this.set_textFormat(null);
		return this.get_textFormat();
	},
	get_disabledTextFormat: function() {
		return this.__disabledTextFormat;
	},
	set_disabledTextFormat: function(value) {
		if(!this.setStyle("disabledTextFormat")) {
			return this.__disabledTextFormat;
		}
		if(this.__disabledTextFormat == value) {
			return this.__disabledTextFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledTextFormat);
		this.__disabledTextFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledTextFormat;
	},
	clearStyle_disabledTextFormat: function() {
		this.set_disabledTextFormat(null);
		return this.get_disabledTextFormat();
	},
	get_promptTextFormat: function() {
		return this.__promptTextFormat;
	},
	set_promptTextFormat: function(value) {
		if(!this.setStyle("promptTextFormat")) {
			return this.__promptTextFormat;
		}
		if(this.__promptTextFormat == value) {
			return this.__promptTextFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_promptTextFormat);
		this.__promptTextFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__promptTextFormat;
	},
	clearStyle_promptTextFormat: function() {
		this.set_promptTextFormat(null);
		return this.get_promptTextFormat();
	},
	get_embedFonts: function() {
		return this.__embedFonts;
	},
	set_embedFonts: function(value) {
		if(!this.setStyle("embedFonts")) {
			return this.__embedFonts;
		}
		if(this.__embedFonts == value) {
			return this.__embedFonts;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_embedFonts);
		this.__embedFonts = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__embedFonts;
	},
	clearStyle_embedFonts: function() {
		this.set_embedFonts(false);
		return this.get_embedFonts();
	},
	get_wordWrap: function() {
		return this.__wordWrap;
	},
	set_wordWrap: function(value) {
		if(!this.setStyle("wordWrap")) {
			return this.__wordWrap;
		}
		if(this.__wordWrap == value) {
			return this.__wordWrap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_wordWrap);
		this.__wordWrap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__wordWrap;
	},
	clearStyle_wordWrap: function() {
		this.set_wordWrap(true);
		return this.get_wordWrap();
	},
	get_textPaddingTop: function() {
		return this.__textPaddingTop;
	},
	set_textPaddingTop: function(value) {
		if(!this.setStyle("textPaddingTop")) {
			return this.__textPaddingTop;
		}
		if(this.__textPaddingTop == value) {
			return this.__textPaddingTop;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_textPaddingTop);
		this.__textPaddingTop = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__textPaddingTop;
	},
	clearStyle_textPaddingTop: function() {
		this.set_textPaddingTop(0.0);
		return this.get_textPaddingTop();
	},
	get_textPaddingRight: function() {
		return this.__textPaddingRight;
	},
	set_textPaddingRight: function(value) {
		if(!this.setStyle("textPaddingRight")) {
			return this.__textPaddingRight;
		}
		if(this.__textPaddingRight == value) {
			return this.__textPaddingRight;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_textPaddingRight);
		this.__textPaddingRight = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__textPaddingRight;
	},
	clearStyle_textPaddingRight: function() {
		this.set_textPaddingRight(0.0);
		return this.get_textPaddingRight();
	},
	get_textPaddingBottom: function() {
		return this.__textPaddingBottom;
	},
	set_textPaddingBottom: function(value) {
		if(!this.setStyle("textPaddingBottom")) {
			return this.__textPaddingBottom;
		}
		if(this.__textPaddingBottom == value) {
			return this.__textPaddingBottom;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_textPaddingBottom);
		this.__textPaddingBottom = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__textPaddingBottom;
	},
	clearStyle_textPaddingBottom: function() {
		this.set_textPaddingBottom(0.0);
		return this.get_textPaddingBottom();
	},
	get_textPaddingLeft: function() {
		return this.__textPaddingLeft;
	},
	set_textPaddingLeft: function(value) {
		if(!this.setStyle("textPaddingLeft")) {
			return this.__textPaddingLeft;
		}
		if(this.__textPaddingLeft == value) {
			return this.__textPaddingLeft;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_textPaddingLeft);
		this.__textPaddingLeft = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__textPaddingLeft;
	},
	clearStyle_textPaddingLeft: function() {
		this.set_textPaddingLeft(0.0);
		return this.get_textPaddingLeft();
	},
	get_showPromptWhenEmptyAndFocused: function() {
		return this.__showPromptWhenEmptyAndFocused;
	},
	set_showPromptWhenEmptyAndFocused: function(value) {
		if(!this.setStyle("showPromptWhenEmptyAndFocused")) {
			return this.__showPromptWhenEmptyAndFocused;
		}
		if(this.__showPromptWhenEmptyAndFocused == value) {
			return this.__showPromptWhenEmptyAndFocused;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_showPromptWhenEmptyAndFocused);
		this.__showPromptWhenEmptyAndFocused = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__showPromptWhenEmptyAndFocused;
	},
	clearStyle_showPromptWhenEmptyAndFocused: function() {
		this.set_showPromptWhenEmptyAndFocused(true);
		return this.get_showPromptWhenEmptyAndFocused();
	},
	get_customErrorCalloutVariant: function() {
		return this.__customErrorCalloutVariant;
	},
	set_customErrorCalloutVariant: function(value) {
		if(!this.setStyle("customErrorCalloutVariant")) {
			return this.__customErrorCalloutVariant;
		}
		if(this.__customErrorCalloutVariant == value) {
			return this.__customErrorCalloutVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customErrorCalloutVariant);
		this.__customErrorCalloutVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customErrorCalloutVariant;
	},
	clearStyle_customErrorCalloutVariant: function() {
		this.set_customErrorCalloutVariant(null);
		return this.get_customErrorCalloutVariant();
	}
});
TextArea.prototype.__class__ = TextArea.prototype.constructor = $hxClasses["feathers.controls.TextArea"] = TextArea;

// Init



// Statics


TextArea.__meta__ = { obj : { defaultXmlProperty : ["text"]}, fields : { setSkinForState : { style : null}, setTextFormatForState : { style : null}}}
TextArea.INVALIDATION_FLAG_ERROR_CALLOUT_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("errorCalloutFactory")
TextArea.CHILD_VARIANT_ERROR_CALLOUT = "textArea_errorCallout"

// Export

exports["default"] = TextArea;

/***/ }),

/***/ "./lib/_gen/feathers/controls/TextCallout.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/controls/TextCallout.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.TextCallout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IHTMLTextControl() {return __webpack_require__(/*! ./../../feathers/core/IHTMLTextControl */ "./lib/_gen/feathers/core/IHTMLTextControl.js");}
function feathers_core_ITextControl() {return __webpack_require__(/*! ./../../feathers/core/ITextControl */ "./lib/_gen/feathers/core/ITextControl.js");}
function feathers_controls_Callout() {return __webpack_require__(/*! ./../../feathers/controls/Callout */ "./lib/_gen/feathers/controls/Callout.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_themes_steel_components_SteelTextCalloutStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelTextCalloutStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTextCalloutStyles.js");}
function feathers_controls_Label() {return __webpack_require__(/*! ./../../feathers/controls/Label */ "./lib/_gen/feathers/controls/Label.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}

// Constructor

var TextCallout = function(text) {
	if(text == null) {
		text = "";
	}
	this.__wordWrap = false;
	this.__disabledTextFormat = null;
	this.__embedFonts = false;
	this.__textFormat = null;
	this._htmlText = null;
	this.initializeTextCalloutTheme();
	(feathers_controls_Callout().default).call(this);
	this.set_text(text);
}

// Meta

TextCallout.__name__ = "feathers.controls.TextCallout";
TextCallout.__isInterface__ = false;
TextCallout.__interfaces__ = [(feathers_core_IHTMLTextControl().default),(feathers_core_ITextControl().default)];
TextCallout.__super__ = (feathers_controls_Callout().default);
TextCallout.prototype = $extend((feathers_controls_Callout().default).prototype, {
	get_text: function() {
		return this._text;
	},
	set_text: function(value) {
		if(this._text == value) {
			return this._text;
		}
		this._text = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._text;
	},
	get_htmlText: function() {
		return this._htmlText;
	},
	set_htmlText: function(value) {
		if(this._htmlText == value) {
			return this._htmlText;
		}
		this._htmlText = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._htmlText;
	},
	get_baseline: function() {
		if(this.label == null) {
			return 0.0;
		}
		return this.label.get_y() + this.label.get_baseline();
	},
	initializeTextCalloutTheme: function() {
		(feathers_themes_steel_components_SteelTextCalloutStyles().default).initialize();
	},
	initialize: function() {
		(feathers_controls_Callout().default).prototype.initialize.call(this);
		if(this.label == null) {
			this.label = new (feathers_controls_Label().default)();
			this.addChild(this.label);
			this.set_content(this.label);
		}
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(stylesInvalid || stateInvalid) {
			this.refreshTextStyles();
		}
		if(dataInvalid || stylesInvalid || stateInvalid) {
			this.refreshText();
		}
		(feathers_controls_Callout().default).prototype.update.call(this);
	},
	refreshTextStyles: function() {
		this.label.set_wordWrap(this.get_wordWrap());
		this.label.set_textFormat(this.get_textFormat());
		this.label.set_disabledTextFormat(this.get_disabledTextFormat());
		this.label.set_embedFonts(this.get_embedFonts());
	},
	refreshText: function() {
		this.label.set_text(this._text);
		this.label.set_htmlText(this._htmlText);
	},
	get_styleContext: function() {
		return TextCallout
	},
	get_textFormat: function() {
		return this.__textFormat;
	},
	set_textFormat: function(value) {
		if(!this.setStyle("textFormat")) {
			return this.__textFormat;
		}
		if(this.__textFormat == value) {
			return this.__textFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_textFormat);
		this.__textFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__textFormat;
	},
	clearStyle_textFormat: function() {
		this.set_textFormat(null);
		return this.get_textFormat();
	},
	get_embedFonts: function() {
		return this.__embedFonts;
	},
	set_embedFonts: function(value) {
		if(!this.setStyle("embedFonts")) {
			return this.__embedFonts;
		}
		if(this.__embedFonts == value) {
			return this.__embedFonts;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_embedFonts);
		this.__embedFonts = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__embedFonts;
	},
	clearStyle_embedFonts: function() {
		this.set_embedFonts(false);
		return this.get_embedFonts();
	},
	get_disabledTextFormat: function() {
		return this.__disabledTextFormat;
	},
	set_disabledTextFormat: function(value) {
		if(!this.setStyle("disabledTextFormat")) {
			return this.__disabledTextFormat;
		}
		if(this.__disabledTextFormat == value) {
			return this.__disabledTextFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledTextFormat);
		this.__disabledTextFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledTextFormat;
	},
	clearStyle_disabledTextFormat: function() {
		this.set_disabledTextFormat(null);
		return this.get_disabledTextFormat();
	},
	get_wordWrap: function() {
		return this.__wordWrap;
	},
	set_wordWrap: function(value) {
		if(!this.setStyle("wordWrap")) {
			return this.__wordWrap;
		}
		if(this.__wordWrap == value) {
			return this.__wordWrap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_wordWrap);
		this.__wordWrap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__wordWrap;
	},
	clearStyle_wordWrap: function() {
		this.set_wordWrap(false);
		return this.get_wordWrap();
	}
});
TextCallout.prototype.__class__ = TextCallout.prototype.constructor = $hxClasses["feathers.controls.TextCallout"] = TextCallout;

// Init



// Statics

TextCallout.show = function(text,origin,supportedPositions,modal) {
	if(modal == null) {
		modal = true;
	}
	var callout = new TextCallout(text);
	return (js_Boot().default).__cast((feathers_controls_Callout().default).showCallout(callout,origin,supportedPositions,modal) , TextCallout);
}
TextCallout.__meta__ = { obj : { defaultXmlProperty : ["text"]}}
TextCallout.VARIANT_DANGER = "danger"

// Export

exports["default"] = TextCallout;

/***/ }),

/***/ "./lib/_gen/feathers/controls/TextInput.js":
/*!*************************************************!*\
  !*** ./lib/_gen/feathers/controls/TextInput.js ***!
  \*************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.TextInput

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IStageFocusDelegate() {return __webpack_require__(/*! ./../../feathers/core/IStageFocusDelegate */ "./lib/_gen/feathers/core/IStageFocusDelegate.js");}
function feathers_core_ITextControl() {return __webpack_require__(/*! ./../../feathers/core/ITextControl */ "./lib/_gen/feathers/core/ITextControl.js");}
function feathers_core_IStateContext() {return __webpack_require__(/*! ./../../feathers/core/IStateContext */ "./lib/_gen/feathers/core/IStateContext.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function feathers_themes_steel_components_SteelTextInputStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelTextInputStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTextInputStyles.js");}
function openfl_text_TextField() {return (__webpack_require__(/*! openfl */ "openfl").text.TextField);}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_core_IStateObserver() {return __webpack_require__(/*! ./../../feathers/core/IStateObserver */ "./lib/_gen/feathers/core/IStateObserver.js");}
function feathers_utils_MeasurementsUtil() {return __webpack_require__(/*! ./../../feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_controls_TextInputState() {return __webpack_require__(/*! ./../../feathers/controls/TextInputState */ "./lib/_gen/feathers/controls/TextInputState.js");}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}
function feathers_core_PopUpManager() {return __webpack_require__(/*! ./../../feathers/core/PopUpManager */ "./lib/_gen/feathers/core/PopUpManager.js");}
function feathers_controls_TextCallout() {return __webpack_require__(/*! ./../../feathers/controls/TextCallout */ "./lib/_gen/feathers/controls/TextCallout.js");}
function haxe_ds_EnumValueMap() {return __webpack_require__(/*! ./../../haxe/ds/EnumValueMap */ "./lib/_gen/haxe/ds/EnumValueMap.js");}

// Constructor

var TextInput = function(text,prompt,changeListener) {
	if(text == null) {
		text = "";
	}
	this.__customErrorCalloutVariant = null;
	this.__autoSizeWidth = false;
	this.__verticalAlign = (feathers_layout_VerticalAlign().default).MIDDLE;
	this.__paddingLeft = 0.0;
	this.__paddingBottom = 0.0;
	this.__paddingRight = 0.0;
	this.__paddingTop = 0.0;
	this.__embedFonts = false;
	this.__promptTextFormat = null;
	this.__disabledTextFormat = null;
	this.__textFormat = null;
	this.__rightViewGap = 0.0;
	this.__rightView = null;
	this.__leftViewGap = 0.0;
	this.__leftView = null;
	this.__showPromptWhenEmptyAndFocused = true;
	this.__backgroundSkin = null;
	this._previousCustomErrorCalloutVariant = null;
	this._maxChars = 0;
	this._pendingSelectionActiveIndex = -1;
	this._pendingSelectionAnchorIndex = -1;
	this._scrollX = 0.0;
	this._stateToTextFormat = new (haxe_ds_EnumValueMap().default)();
	this._errorString = null;
	this._displayAsPassword = false;
	this._measureText = null;
	this._updatedPromptStyles = false;
	this._updatedTextStyles = false;
	this._previousPromptTextFormat = null;
	this._previousTextFormat = null;
	this._previousPrompt = null;
	this._previousMeasureText = null;
	this._previousText = null;
	this._stateToSkin = new (haxe_ds_EnumValueMap().default)();
	this._ignoreRightViewResize = false;
	this._ignoreLeftViewResize = false;
	this._currentBackgroundSkin = null;
	this._backgroundSkinMeasurements = null;
	this._currentState = (feathers_controls_TextInputState().default).ENABLED;
	this._selectable = true;
	this._editable = true;
	this.initializeTextInputTheme();
	(feathers_core_FeathersControl().default).call(this);
	this.set_text(text);
	this.set_prompt(prompt);
	this.set_tabEnabled(true);
	this.set_tabChildren(false);
	this.focusRect = null;
	this.addEventListener("focusIn",$bind(this,this.textInput_focusInHandler));
	this.addEventListener("focusOut",$bind(this,this.textInput_focusOutHandler));
	if(changeListener != null) {
		this.addEventListener("change",changeListener);
	}
}

// Meta

TextInput.__name__ = "feathers.controls.TextInput";
TextInput.__isInterface__ = false;
TextInput.__interfaces__ = [(feathers_core_IStageFocusDelegate().default),(feathers_core_ITextControl().default),(feathers_core_IStateContext().default)];
TextInput.__super__ = (feathers_core_FeathersControl().default);
TextInput.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_editable: function() {
		return this._editable;
	},
	set_editable: function(value) {
		if(this._editable == value) {
			return this._editable;
		}
		this._editable = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STATE);
		return this._editable;
	},
	get_selectable: function() {
		return this._selectable;
	},
	set_selectable: function(value) {
		if(this._selectable == value) {
			return this._selectable;
		}
		this._selectable = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STATE);
		return this._selectable;
	},
	get_stageFocusTarget: function() {
		return this.textField;
	},
	get_currentState: function() {
		return this._currentState;
	},
	set_enabled: function(value) {
		(feathers_core_FeathersControl().default).prototype.set_enabled.call(this,value);
		this.refreshState();
		return this._enabled;
	},
	get_text: function() {
		return this._text;
	},
	set_text: function(value) {
		if(value == null) {
			if(this._text.length == 0) {
				return this._text;
			}
			value = "";
		}
		if(this._text == value) {
			return this._text;
		}
		this._text = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._text;
	},
	get_measureText: function() {
		return this._measureText;
	},
	set_measureText: function(value) {
		if(this._measureText == value) {
			return this._measureText;
		}
		this._measureText = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._measureText;
	},
	get_baseline: function() {
		if(this.textField == null) {
			return 0.0;
		}
		var hasText = this._text != null && this._text.length > 0;
		if(!hasText) {
			this.textField.set_text("​");
			var result = this.textField.get_y() + this.textField.getLineMetrics(0).ascent;
			this.textField.set_text("");
			return result;
		}
		return this.textField.get_y() + this.textField.getLineMetrics(0).ascent;
	},
	get_prompt: function() {
		return this._prompt;
	},
	set_prompt: function(value) {
		if(this._prompt == value) {
			return this._prompt;
		}
		this._prompt = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._prompt;
	},
	get_restrict: function() {
		return this.__restrict;
	},
	set_restrict: function(value) {
		if(this.__restrict == value) {
			return this.__restrict;
		}
		this.__restrict = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this.__restrict;
	},
	get_displayAsPassword: function() {
		return this._displayAsPassword;
	},
	set_displayAsPassword: function(value) {
		if(this._displayAsPassword == value) {
			return this._displayAsPassword;
		}
		this._displayAsPassword = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._displayAsPassword;
	},
	get_errorString: function() {
		return this._errorString;
	},
	set_errorString: function(value) {
		if(this._errorString == value) {
			return this._errorString;
		}
		this._errorString = value;
		this.refreshState();
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._text;
	},
	get_errorStringCalloutOpen: function() {
		if(this.errorStringCallout != null) {
			return this.errorStringCallout.parent != null;
		} else {
			return false;
		}
	},
	get_scrollX: function() {
		return this._scrollX;
	},
	set_scrollX: function(value) {
		if(this._scrollX == value) {
			return this._scrollX;
		}
		this._scrollX = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SCROLL);
		(feathers_events_FeathersEvent().default).dispatch(this,"scroll");
		return this._scrollX;
	},
	get_selectionAnchorIndex: function() {
		if(this.textField != null && this._pendingSelectionAnchorIndex == -1) {
			if(this.textField.get_caretIndex() == this.textField.get_selectionBeginIndex()) {
				return this.textField.get_selectionEndIndex();
			}
			return this.textField.get_selectionBeginIndex();
		}
		return this._pendingSelectionAnchorIndex;
	},
	get_selectionActiveIndex: function() {
		if(this.textField != null && this._pendingSelectionActiveIndex == -1) {
			return this.textField.get_caretIndex();
		}
		return this._pendingSelectionActiveIndex;
	},
	get_maxChars: function() {
		return this._maxChars;
	},
	set_maxChars: function(value) {
		if(this._maxChars == value) {
			return this._maxChars;
		}
		this._maxChars = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._maxChars;
	},
	getSkinForState: function(state) {
		return this._stateToSkin.get(state);
	},
	setSkinForState: function(state,skin) {
		if(!this.setStyle("setSkinForState",state)) {
			return;
		}
		var oldSkin = this._stateToSkin.get(state);
		if(oldSkin != null && oldSkin == this._currentBackgroundSkin) {
			this.removeCurrentBackgroundSkin(oldSkin);
			this._currentBackgroundSkin = null;
		}
		if(skin == null) {
			this._stateToSkin.remove(state);
		} else {
			this._stateToSkin.set(state,skin);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	getTextFormatForState: function(state) {
		return this._stateToTextFormat.get(state);
	},
	setTextFormatForState: function(state,textFormat) {
		if(!this.setStyle("setTextFormatForState",state)) {
			return;
		}
		if(textFormat == null) {
			this._stateToTextFormat.remove(state);
		} else {
			this._stateToTextFormat.set(state,textFormat);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	selectRange: function(anchorIndex,activeIndex) {
		this._pendingSelectionAnchorIndex = anchorIndex;
		this._pendingSelectionActiveIndex = activeIndex;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
	},
	selectAll: function() {
		this.selectRange(0,this._text.length);
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	showFocus: function(show) {
		(feathers_core_FeathersControl().default).prototype.showFocus.call(this,show);
		if(show) {
			this.selectRange(this._text.length,0);
		}
	},
	initializeTextInputTheme: function() {
		(feathers_themes_steel_components_SteelTextInputStyles().default).initialize();
	},
	initialize: function() {
		(feathers_core_FeathersControl().default).prototype.initialize.call(this);
		if(this.textField == null) {
			this.textField = new (openfl_text_TextField())();
			this.textField.set_tabEnabled(false);
			this.refreshTextFieldType();
			this.textField.addEventListener("change",$bind(this,this.textField_changeHandler));
			this.textField.addEventListener("scroll",$bind(this,this.textField_scrollHandler));
			this.addChild(this.textField);
		}
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var scrollInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SCROLL);
		var selectionInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		var sizeInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SIZE);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(this._previousCustomErrorCalloutVariant != this.get_customErrorCalloutVariant()) {
			this.setInvalidationFlag(TextInput.INVALIDATION_FLAG_ERROR_CALLOUT_FACTORY);
		}
		var errorCalloutFactoryInvalid = this.isInvalid(TextInput.INVALIDATION_FLAG_ERROR_CALLOUT_FACTORY);
		this._updatedTextStyles = false;
		this._updatedPromptStyles = false;
		if(errorCalloutFactoryInvalid || dataInvalid) {
			this.createErrorCallout();
		}
		if(stylesInvalid || stateInvalid) {
			this.refreshBackgroundSkin();
			this.refreshLeftView();
			this.refreshRightView();
		}
		if(dataInvalid || stateInvalid) {
			this.refreshPrompt();
		}
		if(stylesInvalid || stateInvalid) {
			this.refreshTextStyles();
			this.refreshPromptStyles();
		}
		if(dataInvalid || stylesInvalid || stateInvalid || sizeInvalid) {
			this.refreshText(sizeInvalid);
		}
		if(dataInvalid || stylesInvalid || sizeInvalid) {
			this.refreshPromptText(sizeInvalid);
		}
		if(selectionInvalid) {
			this.refreshSelection();
		}
		if(scrollInvalid) {
			this.refreshScrollPosition();
		}
		this.measure();
		this.layoutContent();
		if(errorCalloutFactoryInvalid || stateInvalid || dataInvalid) {
			this.refreshErrorString();
		}
		this._previousCustomErrorCalloutVariant = this.get_customErrorCalloutVariant();
	},
	refreshBackgroundSkin: function() {
		var oldSkin = this._currentBackgroundSkin;
		this._currentBackgroundSkin = this.getCurrentBackgroundSkin();
		if(this._currentBackgroundSkin == oldSkin) {
			return;
		}
		this.removeCurrentBackgroundSkin(oldSkin);
		this.addCurrentBackgroundSkin(this._currentBackgroundSkin);
	},
	getCurrentBackgroundSkin: function() {
		var result = this._stateToSkin.get(this._currentState);
		if(result != null) {
			return result;
		}
		return this.get_backgroundSkin();
	},
	addCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			this._backgroundSkinMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._backgroundSkinMeasurements == null) {
			this._backgroundSkinMeasurements = new (feathers_layout_Measurements().default)(skin);
		} else {
			this._backgroundSkinMeasurements.save(skin);
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IStateObserver().default))).set_stateContext(this);
		}
		this.addChildAt(skin,0);
	},
	removeCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IStateObserver().default))).set_stateContext(null);
		}
		this._backgroundSkinMeasurements.restore(skin);
		if(skin.parent == this) {
			this.removeChild(skin);
		}
	},
	refreshLeftView: function() {
		var oldView = this._currentLeftView;
		this._currentLeftView = this.getCurrentLeftView();
		if(this._currentLeftView == oldView) {
			return;
		}
		this.removeCurrentLeftView(oldView);
		if(this._currentLeftView == null) {
			this._leftViewMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(this._currentLeftView,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._currentLeftView , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._leftViewMeasurements == null) {
			this._leftViewMeasurements = new (feathers_layout_Measurements().default)(this._currentLeftView);
		} else {
			this._leftViewMeasurements.save(this._currentLeftView);
		}
		if((js_Boot().default).__implements(this._currentLeftView,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(this._currentLeftView , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		if((js_Boot().default).__implements(this._currentLeftView,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(this._currentLeftView , (feathers_core_IStateObserver().default))).set_stateContext(this);
		}
		this._currentLeftView.addEventListener("resize",$bind(this,this.textInput_leftView_resizeHandler),false,0,true);
		this.addChild(this._currentLeftView);
	},
	getCurrentLeftView: function() {
		return this.get_leftView();
	},
	removeCurrentLeftView: function(view) {
		if(view == null) {
			return;
		}
		view.removeEventListener("resize",$bind(this,this.textInput_leftView_resizeHandler));
		if((js_Boot().default).__implements(view,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(view , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		if((js_Boot().default).__implements(view,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(view , (feathers_core_IStateObserver().default))).set_stateContext(null);
		}
		this._leftViewMeasurements.restore(view);
		if(view.parent == this) {
			this.removeChild(view);
		}
	},
	refreshRightView: function() {
		var oldView = this._currentRightView;
		this._currentRightView = this.getCurrentRightView();
		if(this._currentRightView == oldView) {
			return;
		}
		this.removeCurrentRightView(oldView);
		if(this._currentRightView == null) {
			this._rightViewMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(this._currentRightView,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._currentRightView , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._rightViewMeasurements == null) {
			this._rightViewMeasurements = new (feathers_layout_Measurements().default)(this._currentRightView);
		} else {
			this._rightViewMeasurements.save(this._currentRightView);
		}
		if((js_Boot().default).__implements(this._currentRightView,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(this._currentRightView , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		if((js_Boot().default).__implements(this._currentRightView,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(this._currentRightView , (feathers_core_IStateObserver().default))).set_stateContext(this);
		}
		this._currentRightView.addEventListener("resize",$bind(this,this.textInput_rightView_resizeHandler),false,0,true);
		this.addChild(this._currentRightView);
	},
	getCurrentRightView: function() {
		return this.get_rightView();
	},
	removeCurrentRightView: function(view) {
		if(view == null) {
			return;
		}
		view.removeEventListener("resize",$bind(this,this.textInput_rightView_resizeHandler));
		if((js_Boot().default).__implements(view,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(view , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		if((js_Boot().default).__implements(view,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(view , (feathers_core_IStateObserver().default))).set_stateContext(null);
		}
		this._rightViewMeasurements.restore(view);
		if(view.parent == this) {
			this.removeChild(view);
		}
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		if(this._backgroundSkinMeasurements != null) {
			(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParent(this._backgroundSkinMeasurements,this._currentBackgroundSkin,this);
		}
		var measureSkin = null;
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IMeasureObject().default))) {
			measureSkin = (js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IMeasureObject().default));
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
		var oldIgnoreLeftViewResize = this._ignoreLeftViewResize;
		this._ignoreLeftViewResize = true;
		var oldIgnoreRightViewResize = this._ignoreRightViewResize;
		this._ignoreRightViewResize = true;
		var measureLeftView = null;
		if((js_Boot().default).__implements(this._currentLeftView,(feathers_core_IMeasureObject().default))) {
			measureLeftView = (js_Boot().default).__cast(this._currentLeftView , (feathers_core_IMeasureObject().default));
		}
		if((js_Boot().default).__implements(this._currentLeftView,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentLeftView , (feathers_core_IValidating().default))).validateNow();
		}
		var measureRightView = null;
		if((js_Boot().default).__implements(this._currentRightView,(feathers_core_IMeasureObject().default))) {
			measureRightView = (js_Boot().default).__cast(this._currentRightView , (feathers_core_IMeasureObject().default));
		}
		if((js_Boot().default).__implements(this._currentRightView,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentRightView , (feathers_core_IValidating().default))).validateNow();
		}
		this._ignoreLeftViewResize = oldIgnoreLeftViewResize;
		this._ignoreRightViewResize = oldIgnoreRightViewResize;
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			if(this.get_autoSizeWidth() || this._measureText != null) {
				newWidth = this._textMeasuredWidth;
			} else {
				newWidth = 0.0;
			}
			if(this._prompt != null) {
				newWidth = Math.max(newWidth,this._promptTextMeasuredWidth);
			}
			if(measureLeftView != null) {
				newWidth += measureLeftView.get_width() + this.get_leftViewGap();
			} else if(this._leftViewMeasurements != null) {
				newWidth += this._leftViewMeasurements.width + this.get_leftViewGap();
			}
			if(measureRightView != null) {
				newWidth += measureRightView.get_width() + this.get_rightViewGap();
			} else if(this._rightViewMeasurements != null) {
				newWidth += this._rightViewMeasurements.width + this.get_rightViewGap();
			}
			newWidth += this.get_paddingLeft() + this.get_paddingRight();
			if(this._currentBackgroundSkin != null) {
				newWidth = Math.max(this._currentBackgroundSkin.get_width(),newWidth);
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			newHeight = this._textMeasuredHeight;
			if(this._prompt != null) {
				newHeight = Math.max(newHeight,this._promptTextMeasuredHeight);
			}
			if(measureLeftView != null && newHeight < measureLeftView.get_height()) {
				newHeight = measureLeftView.get_height();
			} else if(this._leftViewMeasurements != null && newHeight < this._leftViewMeasurements.height) {
				newHeight = this._leftViewMeasurements.height;
			}
			if(measureRightView != null && newHeight < measureRightView.get_height()) {
				newHeight = measureRightView.get_height();
			} else if(this._rightViewMeasurements != null && newHeight < this._rightViewMeasurements.height) {
				newHeight = this._rightViewMeasurements.height;
			}
			newHeight += this.get_paddingTop() + this.get_paddingBottom();
			if(this._currentBackgroundSkin != null) {
				newHeight = Math.max(this._currentBackgroundSkin.get_height(),newHeight);
			}
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			if(this.get_autoSizeWidth() || this._measureText != null) {
				newMinWidth = this._textMeasuredWidth;
			} else {
				newMinWidth = 0.0;
			}
			if(this._prompt != null) {
				newMinWidth = Math.max(newMinWidth,this._promptTextMeasuredWidth);
			}
			if(measureLeftView != null) {
				newMinWidth += measureLeftView.get_minWidth() + this.get_leftViewGap();
			} else if(this._leftViewMeasurements != null) {
				newMinWidth += this._leftViewMeasurements.minWidth + this.get_leftViewGap();
			}
			if(measureRightView != null) {
				newMinWidth += measureRightView.get_minWidth() + this.get_rightViewGap();
			} else if(this._rightViewMeasurements != null) {
				newMinWidth += this._rightViewMeasurements.minWidth + this.get_rightViewGap();
			}
			newMinWidth += this.get_paddingLeft() + this.get_paddingRight();
			if(measureSkin != null) {
				newMinWidth = Math.max(measureSkin.get_minWidth(),newMinWidth);
			} else if(this._backgroundSkinMeasurements != null) {
				newMinWidth = Math.max(this._backgroundSkinMeasurements.minWidth,newMinWidth);
			}
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			newMinHeight = this._textMeasuredHeight;
			if(this._prompt != null) {
				newMinHeight = Math.max(newMinHeight,this._promptTextMeasuredHeight);
			}
			if(measureLeftView != null && newMinHeight < measureLeftView.get_minHeight()) {
				newMinHeight = measureLeftView.get_minHeight();
			} else if(this._leftViewMeasurements != null && newMinHeight < this._leftViewMeasurements.minHeight) {
				newMinHeight = this._leftViewMeasurements.minHeight;
			}
			if(measureRightView != null && newMinHeight < measureRightView.get_minHeight()) {
				newMinHeight = measureRightView.get_minHeight();
			} else if(this._rightViewMeasurements != null && newMinHeight < this._rightViewMeasurements.minHeight) {
				newMinHeight = this._rightViewMeasurements.minHeight;
			}
			newMinHeight += this.get_paddingTop() + this.get_paddingBottom();
			if(measureSkin != null) {
				newMinHeight = Math.max(measureSkin.get_minHeight(),newMinHeight);
			} else if(this._backgroundSkinMeasurements != null) {
				newMinHeight = Math.max(this._backgroundSkinMeasurements.minHeight,newMinHeight);
			}
		}
		var newMaxWidth = this.get_explicitMaxWidth();
		if(needsMaxWidth) {
			if(measureSkin != null) {
				newMaxWidth = measureSkin.get_maxWidth();
			} else if(this._backgroundSkinMeasurements != null) {
				newMaxWidth = this._backgroundSkinMeasurements.maxWidth;
			} else {
				newMaxWidth = 1.0 / 0.0;
			}
		}
		var newMaxHeight = this.get_explicitMaxHeight();
		if(needsMaxHeight) {
			if(measureSkin != null) {
				newMaxHeight = measureSkin.get_maxHeight();
			} else if(this._backgroundSkinMeasurements != null) {
				newMaxHeight = this._backgroundSkinMeasurements.maxHeight;
			} else {
				newMaxHeight = 1.0 / 0.0;
			}
		}
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight,newMaxWidth,newMaxHeight);
	},
	refreshTextFieldType: function() {
		if(this._enabled && this._editable && this.textField.get_type() != "input") {
			this.textField.set_type("input");
		} else if((!this._enabled || !this._editable) && this.textField.get_type() == "input") {
			this.textField.set_type("dynamic");
		}
	},
	refreshTextStyles: function() {
		this.refreshTextFieldType();
		if(this.textField.get_embedFonts() != this.get_embedFonts()) {
			this.textField.set_embedFonts(this.get_embedFonts());
			this._updatedTextStyles = true;
		}
		if(this.textField.get_displayAsPassword() != this._displayAsPassword) {
			this.textField.set_displayAsPassword(this._displayAsPassword);
			this._updatedTextStyles = true;
		}
		var textFormat = this.getCurrentTextFormat();
		var simpleTextFormat = textFormat != null ? textFormat.toSimpleTextFormat() : null;
		if(simpleTextFormat == this._previousSimpleTextFormat) {
			return;
		}
		if(this._previousTextFormat != null) {
			this._previousTextFormat.removeEventListener("change",$bind(this,this.textInput_textFormat_changeHandler));
		}
		if(textFormat != null) {
			textFormat.addEventListener("change",$bind(this,this.textInput_textFormat_changeHandler),false,0,true);
			this.textField.set_defaultTextFormat(simpleTextFormat);
			this._updatedTextStyles = true;
		}
		this._previousTextFormat = textFormat;
		this._previousSimpleTextFormat = simpleTextFormat;
	},
	refreshPrompt: function() {
		if(this._prompt == null) {
			if(this.promptTextField != null) {
				this.removeChild(this.promptTextField);
				this.promptTextField = null;
			}
			return;
		}
		if(this.promptTextField == null) {
			this.promptTextField = new (openfl_text_TextField())();
			this.addChildAt(this.promptTextField,this.getChildIndex(this.textField));
		}
		this.promptTextField.set_selectable(false);
		this.promptTextField.set_mouseWheelEnabled(false);
		this.promptTextField.mouseEnabled = false;
		this.promptTextField.set_visible(this._text.length == 0 && (this.get_currentState() != (feathers_controls_TextInputState().default).FOCUSED || this.get_showPromptWhenEmptyAndFocused()));
	},
	refreshPromptText: function(sizeInvalid) {
		if(this._prompt == null || this._prompt == this._previousPrompt && !this._updatedPromptStyles && !sizeInvalid) {
			return;
		}
		this.promptTextField.set_autoSize("left");
		var hasPromptText = this._prompt.length > 0;
		if(hasPromptText) {
			this.promptTextField.set_text(this._prompt);
		} else {
			this.promptTextField.set_text("​");
		}
		this._promptTextMeasuredWidth = this.promptTextField.get_width();
		this._promptTextMeasuredHeight = this.promptTextField.get_height();
		this.promptTextField.set_autoSize("none");
		if(!hasPromptText) {
			this.promptTextField.set_text("");
		}
		this._previousPrompt = this._prompt;
	},
	refreshPromptStyles: function() {
		if(this._prompt == null) {
			return;
		}
		if(this.promptTextField.get_embedFonts() != this.get_embedFonts()) {
			this.promptTextField.set_embedFonts(this.get_embedFonts());
			this._updatedPromptStyles = true;
		}
		var textFormat = this.getCurrentPromptTextFormat();
		var simpleTextFormat = textFormat != null ? textFormat.toSimpleTextFormat() : null;
		if(simpleTextFormat == this._previousPromptSimpleTextFormat) {
			return;
		}
		if(this._previousPromptTextFormat != null) {
			this._previousPromptTextFormat.removeEventListener("change",$bind(this,this.textInput_promptTextFormat_changeHandler));
		}
		if(textFormat != null) {
			textFormat.addEventListener("change",$bind(this,this.textInput_textFormat_changeHandler),false,0,true);
			this.promptTextField.set_defaultTextFormat(simpleTextFormat);
			this._updatedPromptStyles = true;
		}
		this._previousPromptTextFormat = textFormat;
		this._previousPromptSimpleTextFormat = simpleTextFormat;
	},
	getCurrentPromptTextFormat: function() {
		var textFormat = this.get_promptTextFormat();
		if(textFormat == null) {
			textFormat = this.get_textFormat();
		}
		return textFormat;
	},
	refreshText: function(forceMeasurement) {
		this.textField.set_restrict(this.__restrict);
		this.textField.set_maxChars(this._maxChars);
		if(this._editable) {
			this.textField.set_selectable(this._enabled);
		} else {
			this.textField.set_selectable(this._enabled && this._selectable);
		}
		var hasMeasureText = this._measureText != null;
		var measureText = hasMeasureText ? this._measureText : this._text;
		if(measureText == null || measureText.length == 0) {
			hasMeasureText = true;
			measureText = "​";
		}
		if(this._text == this._previousText && measureText == this._previousMeasureText && !this._updatedTextStyles && !forceMeasurement) {
			return;
		}
		this.textField.set_autoSize("left");
		this.textField.set_text(measureText);
		this._textMeasuredWidth = this.textField.get_width();
		this._textMeasuredHeight = this.textField.get_height();
		this.textField.set_autoSize("none");
		var finalText = null;
		if(this._text == null || this._text.length == 0) {
			finalText = "";
		} else if(hasMeasureText) {
			finalText = this._text;
		}
		if(finalText != null) {
			this.textField.set_text(finalText);
		}
		this._previousText = this._text;
		this._previousMeasureText = measureText;
	},
	refreshSelection: function() {
		if(this._pendingSelectionActiveIndex == -1 && this._pendingSelectionAnchorIndex == -1) {
			return;
		}
		var anchorIndex = this._pendingSelectionAnchorIndex;
		var activeIndex = this._pendingSelectionActiveIndex;
		this._pendingSelectionAnchorIndex = -1;
		this._pendingSelectionActiveIndex = -1;
		this.textField.setSelection(anchorIndex,activeIndex);
	},
	refreshScrollPosition: function() {
		this.textField.set_scrollH(Math.round(this._scrollX));
	},
	getCurrentTextFormat: function() {
		var result = this._stateToTextFormat.get(this._currentState);
		if(result != null) {
			return result;
		}
		if(!this._enabled && this.get_disabledTextFormat() != null) {
			return this.get_disabledTextFormat();
		}
		return this.get_textFormat();
	},
	layoutContent: function() {
		var oldIgnoreLeftViewResize = this._ignoreLeftViewResize;
		this._ignoreLeftViewResize = true;
		var oldIgnoreRightViewResize = this._ignoreRightViewResize;
		this._ignoreRightViewResize = true;
		this.layoutBackgroundSkin();
		var textFieldHeight = this._textMeasuredHeight;
		var maxHeight = this.actualHeight - this.get_paddingTop() - this.get_paddingBottom();
		if(textFieldHeight > maxHeight || this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).JUSTIFY) {
			textFieldHeight = maxHeight;
		}
		this.textField.set_height(textFieldHeight);
		var leftViewOffset = 0.0;
		if(this._currentLeftView != null) {
			if((js_Boot().default).__implements(this._currentLeftView,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentLeftView , (feathers_core_IValidating().default))).validateNow();
			}
			this._currentLeftView.set_x(this.get_paddingLeft());
			this._currentLeftView.set_y(Math.max(this.get_paddingTop(),this.get_paddingTop() + (maxHeight - this._currentLeftView.get_height()) / 2.0));
			leftViewOffset = this._currentLeftView.get_width() + this.get_leftViewGap();
		}
		var rightViewOffset = 0.0;
		if(this._currentRightView != null) {
			if((js_Boot().default).__implements(this._currentRightView,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentRightView , (feathers_core_IValidating().default))).validateNow();
			}
			this._currentRightView.set_x(this.actualWidth - this.get_paddingRight() - this._currentRightView.get_width());
			this._currentRightView.set_y(Math.max(this.get_paddingTop(),this.get_paddingTop() + (maxHeight - this._currentRightView.get_height()) / 2.0));
			rightViewOffset = this._currentRightView.get_width() + this.get_rightViewGap();
		}
		var textFieldWidth = this.actualWidth - this.get_paddingLeft() - this.get_paddingRight() - leftViewOffset - rightViewOffset;
		this.textField.set_width(textFieldWidth);
		this.textField.set_x(this.get_paddingLeft() + leftViewOffset);
		this.alignTextField(this.textField,textFieldHeight,maxHeight);
		if(this.promptTextField != null) {
			this.promptTextField.set_width(textFieldWidth);
			var textFieldHeight1 = this._promptTextMeasuredHeight;
			if(textFieldHeight1 > maxHeight || this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).JUSTIFY) {
				textFieldHeight1 = maxHeight;
			}
			this.promptTextField.set_height(textFieldHeight1);
			this.promptTextField.set_x(this.get_paddingLeft() + leftViewOffset);
			this.alignTextField(this.promptTextField,textFieldHeight1,maxHeight);
		}
		this._ignoreLeftViewResize = oldIgnoreLeftViewResize;
		this._ignoreRightViewResize = oldIgnoreRightViewResize;
	},
	alignTextField: function(textField,textFieldHeight,maxHeight) {
		switch(this.get_verticalAlign()._hx_index) {
		case 0:
			textField.set_y(this.get_paddingTop());
			break;
		case 2:
			textField.set_y(this.actualHeight - this.get_paddingBottom() - textFieldHeight);
			break;
		case 3:
			textField.set_y(this.get_paddingTop());
			break;
		default:
			textField.set_y(this.get_paddingTop() + (maxHeight - textFieldHeight) / 2.0);
		}
	},
	layoutBackgroundSkin: function() {
		if(this._currentBackgroundSkin == null) {
			return;
		}
		this._currentBackgroundSkin.set_x(0.0);
		this._currentBackgroundSkin.set_y(0.0);
		if(this._currentBackgroundSkin.get_width() != this.actualWidth) {
			this._currentBackgroundSkin.set_width(this.actualWidth);
		}
		if(this._currentBackgroundSkin.get_height() != this.actualHeight) {
			this._currentBackgroundSkin.set_height(this.actualHeight);
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
	},
	refreshErrorString: function() {
		if(this.errorStringCallout == null) {
			return;
		}
		this.errorStringCallout.set_text(this._errorString);
		if(this._currentState == (feathers_controls_TextInputState().default).FOCUSED && this.errorStringCallout.parent == null) {
			(feathers_core_PopUpManager().default).addPopUp(this.errorStringCallout,this,false,false);
		} else if(this._currentState != (feathers_controls_TextInputState().default).FOCUSED && this.errorStringCallout.parent != null) {
			this.errorStringCallout.parent.removeChild(this.errorStringCallout);
		}
	},
	createErrorCallout: function() {
		if(this.errorStringCallout != null) {
			if(this.errorStringCallout.parent != null) {
				this.errorStringCallout.parent.removeChild(this.errorStringCallout);
			}
			this.errorStringCallout = null;
		}
		if(this._errorString == null || this._errorString.length == 0) {
			return;
		}
		this.errorStringCallout = new (feathers_controls_TextCallout().default)();
		if(this.errorStringCallout.get_variant() == null) {
			this.errorStringCallout.set_variant(this.get_customErrorCalloutVariant() != null ? this.get_customErrorCalloutVariant() : TextInput.CHILD_VARIANT_ERROR_CALLOUT);
		}
		this.errorStringCallout.set_origin(this);
		this.errorStringCallout.closeOnPointerOutside = false;
	},
	changeState: function(state) {
		if(!this._enabled) {
			state = (feathers_controls_TextInputState().default).DISABLED;
		}
		if(this._currentState == state) {
			return;
		}
		this._currentState = state;
		this.setInvalid((feathers_core_InvalidationFlag().default).STATE);
		(feathers_events_FeathersEvent().default).dispatch(this,"stateChange");
	},
	refreshState: function() {
		if(this._enabled) {
			if(this.stage != null && this.stage.get_focus() == this.textField) {
				this.changeState((feathers_controls_TextInputState().default).FOCUSED);
			} else if(this._errorString != null) {
				this.changeState((feathers_controls_TextInputState().default).ERROR);
			} else {
				this.changeState((feathers_controls_TextInputState().default).ENABLED);
			}
		} else {
			this.changeState((feathers_controls_TextInputState().default).DISABLED);
		}
	},
	textField_changeHandler: function(event) {
		event.stopPropagation();
		var oldText = this._text;
		var newText = this.textField.get_text();
		this._text = newText;
		var hasMeasureText = this._measureText != null;
		var measureText = hasMeasureText ? this._measureText : this._text;
		if(measureText == null || measureText.length == 0) {
			hasMeasureText = true;
			measureText = "​";
		}
		var hasText = this._text != null && this._text.length > 0;
		var hasOldText = oldText != null && oldText.length > 0;
		var hasPrompt = this._prompt != null && this._prompt.length > 0;
		if(this.get_autoSizeWidth() || hasPrompt && (!hasText && hasOldText || hasText && !hasOldText)) {
			this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		} else {
			this._previousMeasureText = measureText;
			this._previousText = this._text;
		}
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
	},
	textField_scrollHandler: function(event) {
		this._scrollX = this.textField.get_scrollH();
		(feathers_events_FeathersEvent().default).dispatch(this,"scroll");
	},
	textInput_focusInHandler: function(event) {
		if(this.stage != null && this.stage.get_focus() != this.textField) {
			event.stopImmediatePropagation();
			this.stage.set_focus(this.textField);
		}
		this.refreshState();
	},
	textInput_focusOutHandler: function(event) {
		this.refreshState();
	},
	textInput_textFormat_changeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	textInput_promptTextFormat_changeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	textInput_leftView_resizeHandler: function(event) {
		if(this._ignoreLeftViewResize) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	textInput_rightView_resizeHandler: function(event) {
		if(this._ignoreRightViewResize) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	get_backgroundSkin: function() {
		return this.__backgroundSkin;
	},
	set_backgroundSkin: function(value) {
		if(!this.setStyle("backgroundSkin")) {
			return this.__backgroundSkin;
		}
		if(this.__backgroundSkin == value) {
			return this.__backgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_backgroundSkin);
		this.__backgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__backgroundSkin;
	},
	clearStyle_backgroundSkin: function() {
		this.set_backgroundSkin(null);
		return this.get_backgroundSkin();
	},
	get_showPromptWhenEmptyAndFocused: function() {
		return this.__showPromptWhenEmptyAndFocused;
	},
	set_showPromptWhenEmptyAndFocused: function(value) {
		if(!this.setStyle("showPromptWhenEmptyAndFocused")) {
			return this.__showPromptWhenEmptyAndFocused;
		}
		if(this.__showPromptWhenEmptyAndFocused == value) {
			return this.__showPromptWhenEmptyAndFocused;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_showPromptWhenEmptyAndFocused);
		this.__showPromptWhenEmptyAndFocused = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__showPromptWhenEmptyAndFocused;
	},
	clearStyle_showPromptWhenEmptyAndFocused: function() {
		this.set_showPromptWhenEmptyAndFocused(true);
		return this.get_showPromptWhenEmptyAndFocused();
	},
	get_leftView: function() {
		return this.__leftView;
	},
	set_leftView: function(value) {
		if(!this.setStyle("leftView")) {
			return this.__leftView;
		}
		if(this.__leftView == value) {
			return this.__leftView;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_leftView);
		this.__leftView = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__leftView;
	},
	clearStyle_leftView: function() {
		this.set_leftView(null);
		return this.get_leftView();
	},
	get_leftViewGap: function() {
		return this.__leftViewGap;
	},
	set_leftViewGap: function(value) {
		if(!this.setStyle("leftViewGap")) {
			return this.__leftViewGap;
		}
		if(this.__leftViewGap == value) {
			return this.__leftViewGap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_leftViewGap);
		this.__leftViewGap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__leftViewGap;
	},
	clearStyle_leftViewGap: function() {
		this.set_leftViewGap(0.0);
		return this.get_leftViewGap();
	},
	get_rightView: function() {
		return this.__rightView;
	},
	set_rightView: function(value) {
		if(!this.setStyle("rightView")) {
			return this.__rightView;
		}
		if(this.__rightView == value) {
			return this.__rightView;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_rightView);
		this.__rightView = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__rightView;
	},
	clearStyle_rightView: function() {
		this.set_rightView(null);
		return this.get_rightView();
	},
	get_rightViewGap: function() {
		return this.__rightViewGap;
	},
	set_rightViewGap: function(value) {
		if(!this.setStyle("rightViewGap")) {
			return this.__rightViewGap;
		}
		if(this.__rightViewGap == value) {
			return this.__rightViewGap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_rightViewGap);
		this.__rightViewGap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__rightViewGap;
	},
	clearStyle_rightViewGap: function() {
		this.set_rightViewGap(0.0);
		return this.get_rightViewGap();
	},
	get_textFormat: function() {
		return this.__textFormat;
	},
	set_textFormat: function(value) {
		if(!this.setStyle("textFormat")) {
			return this.__textFormat;
		}
		if(this.__textFormat == value) {
			return this.__textFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_textFormat);
		this.__textFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__textFormat;
	},
	clearStyle_textFormat: function() {
		this.set_textFormat(null);
		return this.get_textFormat();
	},
	get_disabledTextFormat: function() {
		return this.__disabledTextFormat;
	},
	set_disabledTextFormat: function(value) {
		if(!this.setStyle("disabledTextFormat")) {
			return this.__disabledTextFormat;
		}
		if(this.__disabledTextFormat == value) {
			return this.__disabledTextFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledTextFormat);
		this.__disabledTextFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledTextFormat;
	},
	clearStyle_disabledTextFormat: function() {
		this.set_disabledTextFormat(null);
		return this.get_disabledTextFormat();
	},
	get_promptTextFormat: function() {
		return this.__promptTextFormat;
	},
	set_promptTextFormat: function(value) {
		if(!this.setStyle("promptTextFormat")) {
			return this.__promptTextFormat;
		}
		if(this.__promptTextFormat == value) {
			return this.__promptTextFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_promptTextFormat);
		this.__promptTextFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__promptTextFormat;
	},
	clearStyle_promptTextFormat: function() {
		this.set_promptTextFormat(null);
		return this.get_promptTextFormat();
	},
	get_embedFonts: function() {
		return this.__embedFonts;
	},
	set_embedFonts: function(value) {
		if(!this.setStyle("embedFonts")) {
			return this.__embedFonts;
		}
		if(this.__embedFonts == value) {
			return this.__embedFonts;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_embedFonts);
		this.__embedFonts = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__embedFonts;
	},
	clearStyle_embedFonts: function() {
		this.set_embedFonts(false);
		return this.get_embedFonts();
	},
	get_paddingTop: function() {
		return this.__paddingTop;
	},
	set_paddingTop: function(value) {
		if(!this.setStyle("paddingTop")) {
			return this.__paddingTop;
		}
		if(this.__paddingTop == value) {
			return this.__paddingTop;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingTop);
		this.__paddingTop = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingTop;
	},
	clearStyle_paddingTop: function() {
		this.set_paddingTop(0.0);
		return this.get_paddingTop();
	},
	get_paddingRight: function() {
		return this.__paddingRight;
	},
	set_paddingRight: function(value) {
		if(!this.setStyle("paddingRight")) {
			return this.__paddingRight;
		}
		if(this.__paddingRight == value) {
			return this.__paddingRight;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingRight);
		this.__paddingRight = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingRight;
	},
	clearStyle_paddingRight: function() {
		this.set_paddingRight(0.0);
		return this.get_paddingRight();
	},
	get_paddingBottom: function() {
		return this.__paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(!this.setStyle("paddingBottom")) {
			return this.__paddingBottom;
		}
		if(this.__paddingBottom == value) {
			return this.__paddingBottom;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingBottom);
		this.__paddingBottom = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingBottom;
	},
	clearStyle_paddingBottom: function() {
		this.set_paddingBottom(0.0);
		return this.get_paddingBottom();
	},
	get_paddingLeft: function() {
		return this.__paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(!this.setStyle("paddingLeft")) {
			return this.__paddingLeft;
		}
		if(this.__paddingLeft == value) {
			return this.__paddingLeft;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingLeft);
		this.__paddingLeft = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingLeft;
	},
	clearStyle_paddingLeft: function() {
		this.set_paddingLeft(0.0);
		return this.get_paddingLeft();
	},
	get_verticalAlign: function() {
		return this.__verticalAlign;
	},
	set_verticalAlign: function(value) {
		if(!this.setStyle("verticalAlign")) {
			return this.__verticalAlign;
		}
		if(this.__verticalAlign == value) {
			return this.__verticalAlign;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_verticalAlign);
		this.__verticalAlign = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__verticalAlign;
	},
	clearStyle_verticalAlign: function() {
		this.set_verticalAlign((feathers_layout_VerticalAlign().default).MIDDLE);
		return this.get_verticalAlign();
	},
	get_autoSizeWidth: function() {
		return this.__autoSizeWidth;
	},
	set_autoSizeWidth: function(value) {
		if(!this.setStyle("autoSizeWidth")) {
			return this.__autoSizeWidth;
		}
		if(this.__autoSizeWidth == value) {
			return this.__autoSizeWidth;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_autoSizeWidth);
		this.__autoSizeWidth = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__autoSizeWidth;
	},
	clearStyle_autoSizeWidth: function() {
		this.set_autoSizeWidth(false);
		return this.get_autoSizeWidth();
	},
	get_customErrorCalloutVariant: function() {
		return this.__customErrorCalloutVariant;
	},
	set_customErrorCalloutVariant: function(value) {
		if(!this.setStyle("customErrorCalloutVariant")) {
			return this.__customErrorCalloutVariant;
		}
		if(this.__customErrorCalloutVariant == value) {
			return this.__customErrorCalloutVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customErrorCalloutVariant);
		this.__customErrorCalloutVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customErrorCalloutVariant;
	},
	clearStyle_customErrorCalloutVariant: function() {
		this.set_customErrorCalloutVariant(null);
		return this.get_customErrorCalloutVariant();
	},
	get_styleContext: function() {
		return TextInput
	}
});
TextInput.prototype.__class__ = TextInput.prototype.constructor = $hxClasses["feathers.controls.TextInput"] = TextInput;

// Init



// Statics


TextInput.__meta__ = { obj : { defaultXmlProperty : ["text"]}, fields : { setSkinForState : { style : null}, setTextFormatForState : { style : null}}}
TextInput.INVALIDATION_FLAG_ERROR_CALLOUT_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("errorCalloutFactory")
TextInput.VARIANT_SEARCH = "search"
TextInput.CHILD_VARIANT_ERROR_CALLOUT = "textInput_errorCallout"

// Export

exports["default"] = TextInput;

/***/ }),

/***/ "./lib/_gen/feathers/controls/TextInputState.js":
/*!******************************************************!*\
  !*** ./lib/_gen/feathers/controls/TextInputState.js ***!
  \******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.controls.TextInputState

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var TextInputState = $hxEnums["feathers.controls.TextInputState"] = { __ename__ : "feathers.controls.TextInputState", __constructs__ : ["ENABLED","DISABLED","FOCUSED","ERROR"]
  ,FOCUSED: {_hx_index:2,__enum__:"feathers.controls.TextInputState",toString:$estr}
  ,ERROR: {_hx_index:3,__enum__:"feathers.controls.TextInputState",toString:$estr}
  ,ENABLED: {_hx_index:0,__enum__:"feathers.controls.TextInputState",toString:$estr}
  ,DISABLED: {_hx_index:1,__enum__:"feathers.controls.TextInputState",toString:$estr}
};

exports["default"] = TextInputState;

/***/ }),

/***/ "./lib/_gen/feathers/controls/ToggleButton.js":
/*!****************************************************!*\
  !*** ./lib/_gen/feathers/controls/ToggleButton.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.ToggleButton

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}
function feathers_core_IHTMLTextControl() {return __webpack_require__(/*! ./../../feathers/core/IHTMLTextControl */ "./lib/_gen/feathers/core/IHTMLTextControl.js");}
function feathers_core_ITextControl() {return __webpack_require__(/*! ./../../feathers/core/ITextControl */ "./lib/_gen/feathers/core/ITextControl.js");}
function feathers_controls_BasicToggleButton() {return __webpack_require__(/*! ./../../feathers/controls/BasicToggleButton */ "./lib/_gen/feathers/controls/BasicToggleButton.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_themes_steel_components_SteelToggleButtonStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelToggleButtonStyles */ "./lib/_gen/feathers/themes/steel/components/SteelToggleButtonStyles.js");}
function openfl_text_TextField() {return (__webpack_require__(/*! openfl */ "openfl").text.TextField);}
function feathers_utils_MeasurementsUtil() {return __webpack_require__(/*! ./../../feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_core_IStateObserver() {return __webpack_require__(/*! ./../../feathers/core/IStateObserver */ "./lib/_gen/feathers/core/IStateObserver.js");}
function openfl_events_MouseEvent() {return (__webpack_require__(/*! openfl */ "openfl").events.MouseEvent);}
function haxe_ds_EnumValueMap() {return __webpack_require__(/*! ./../../haxe/ds/EnumValueMap */ "./lib/_gen/haxe/ds/EnumValueMap.js");}

// Constructor

var ToggleButton = function(text,selected,changeListener) {
	if(selected == null) {
		selected = false;
	}
	this.__showText = true;
	this.__textOffsetY = 0.0;
	this.__textOffsetX = 0.0;
	this.__iconOffsetY = 0.0;
	this.__iconOffsetX = 0.0;
	this.__verticalAlign = (feathers_layout_VerticalAlign().default).MIDDLE;
	this.__horizontalAlign = (feathers_layout_HorizontalAlign().default).CENTER;
	this.__paddingLeft = 0.0;
	this.__paddingBottom = 0.0;
	this.__paddingRight = 0.0;
	this.__paddingTop = 0.0;
	this.__minGap = 0.0;
	this.__gap = 0.0;
	this.__iconPosition = (feathers_layout_RelativePosition().default).LEFT;
	this.__selectedTextFormat = null;
	this.__disabledTextFormat = null;
	this.__wordWrap = false;
	this.__embedFonts = false;
	this.__textFormat = null;
	this.__selectedIcon = null;
	this.__disabledIcon = null;
	this.__icon = null;
	this._stateToTextFormat = new (haxe_ds_EnumValueMap().default)();
	this._ignoreIconResizes = false;
	this._currentIcon = null;
	this._iconMeasurements = null;
	this._stateToIcon = new (haxe_ds_EnumValueMap().default)();
	this._htmlText = null;
	this._updatedTextStyles = false;
	this._previousSimpleTextFormat = null;
	this._previousTextFormat = null;
	this._previousHTMLText = null;
	this._previousText = null;
	this.initializeToggleButtonTheme();
	(feathers_controls_BasicToggleButton().default).call(this,changeListener);
	this.set_text(text);
	this.set_selected(selected);
	this.set_tabEnabled(true);
	this.set_tabChildren(false);
	this.addEventListener("keyDown",$bind(this,this.toggleButton_keyDownHandler));
	this.addEventListener("focusIn",$bind(this,this.toggleButton_focusInHandler));
	this.addEventListener("focusOut",$bind(this,this.toggleButton_focusOutHandler));
}

// Meta

ToggleButton.__name__ = "feathers.controls.ToggleButton";
ToggleButton.__isInterface__ = false;
ToggleButton.__interfaces__ = [(feathers_core_IFocusObject().default),(feathers_core_IHTMLTextControl().default),(feathers_core_ITextControl().default)];
ToggleButton.__super__ = (feathers_controls_BasicToggleButton().default);
ToggleButton.prototype = $extend((feathers_controls_BasicToggleButton().default).prototype, {
	get_text: function() {
		return this._text;
	},
	set_text: function(value) {
		if(this._text == value) {
			return this._text;
		}
		this._text = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._text;
	},
	get_htmlText: function() {
		return this._htmlText;
	},
	set_htmlText: function(value) {
		if(this._htmlText == value) {
			return this._htmlText;
		}
		this._htmlText = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._htmlText;
	},
	get_baseline: function() {
		if(this.textField == null) {
			return 0.0;
		}
		var hasText = this._text != null && this._text.length > 0;
		var hasHTMLText = this._htmlText != null && this._htmlText.length > 0;
		if(!this.get_showText() || !hasText && !hasHTMLText) {
			var textFieldY = this.textField.get_y();
			if(!this.get_showText() || this._text == null && this._htmlText == null) {
				if(this._currentIcon != null) {
					textFieldY = this._currentIcon.get_y() + (this._currentIcon.get_height() - this._textMeasuredHeight) / 2.0;
				} else if(this._currentBackgroundSkin != null) {
					textFieldY = (this._currentBackgroundSkin.get_height() - this._textMeasuredHeight) / 2.0;
				} else {
					return 0.0;
				}
			}
			this.textField.set_text("​");
			var textFieldBaseline = textFieldY + this.textField.getLineMetrics(0).ascent;
			this.textField.set_text("");
			return textFieldBaseline;
		}
		return this.textField.get_y() + this.textField.getLineMetrics(0).ascent;
	},
	getTextFormatForState: function(state) {
		return this._stateToTextFormat.get(state);
	},
	setTextFormatForState: function(state,textFormat) {
		if(!this.setStyle("setTextFormatForState",state)) {
			return;
		}
		if(textFormat == null) {
			this._stateToTextFormat.remove(state);
		} else {
			this._stateToTextFormat.set(state,textFormat);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	getIconForState: function(state) {
		return this._stateToIcon.get(state);
	},
	setIconForState: function(state,icon) {
		if(!this.setStyle("setIconForState",state)) {
			return;
		}
		var oldIcon = this._stateToIcon.get(state);
		if(oldIcon != null && oldIcon == this._currentIcon) {
			this.removeCurrentIcon(oldIcon);
			this._currentIcon = null;
		}
		if(icon == null) {
			this._stateToIcon.remove(state);
		} else {
			this._stateToIcon.set(state,icon);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	initializeToggleButtonTheme: function() {
		(feathers_themes_steel_components_SteelToggleButtonStyles().default).initialize();
	},
	initialize: function() {
		(feathers_controls_BasicToggleButton().default).prototype.initialize.call(this);
		if(this.textField == null) {
			this.textField = new (openfl_text_TextField())();
			this.textField.set_selectable(false);
			this.textField.set_multiline(true);
			this.addChild(this.textField);
		}
	},
	commitChanges: function() {
		(feathers_controls_BasicToggleButton().default).prototype.commitChanges.call(this);
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var sizeInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SIZE);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		this._updatedTextStyles = false;
		if(stylesInvalid || stateInvalid) {
			this.refreshIcon();
		}
		if(stylesInvalid || stateInvalid) {
			this.refreshTextStyles();
		}
		if(dataInvalid || stylesInvalid || stateInvalid || sizeInvalid) {
			this.refreshText(sizeInvalid);
		}
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		var hasText = this.get_showText() && this._text != null;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		if(hasText || hasHTMLText) {
			this.refreshTextFieldDimensions(true);
		}
		if(this._currentBackgroundSkin != null) {
			(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParent(this._backgroundSkinMeasurements,this._currentBackgroundSkin,this);
		}
		var measureSkin = null;
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IMeasureObject().default))) {
			measureSkin = (js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IMeasureObject().default));
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
		if((js_Boot().default).__implements(this._currentIcon,(feathers_core_IValidating().default))) {
			var oldIgnoreIconResizes = this._ignoreIconResizes;
			this._ignoreIconResizes = true;
			((js_Boot().default).__cast(this._currentIcon , (feathers_core_IValidating().default))).validateNow();
			this._ignoreIconResizes = oldIgnoreIconResizes;
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			newWidth = this.measureContentWidth();
			newWidth += this.get_paddingLeft() + this.get_paddingRight();
			if(this._currentBackgroundSkin != null) {
				newWidth = Math.max(this._currentBackgroundSkin.get_width(),newWidth);
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			newHeight = this.measureContentHeight();
			newHeight += this.get_paddingTop() + this.get_paddingBottom();
			if(this._currentBackgroundSkin != null) {
				newHeight = Math.max(this._currentBackgroundSkin.get_height(),newHeight);
			}
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			newMinWidth = this.measureContentMinWidth();
			newMinWidth += this.get_paddingLeft() + this.get_paddingRight();
			if(measureSkin != null) {
				newMinWidth = Math.max(measureSkin.get_minWidth(),newMinWidth);
			} else if(this._backgroundSkinMeasurements != null) {
				newMinWidth = Math.max(this._backgroundSkinMeasurements.minWidth,newMinWidth);
			}
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			newMinHeight = this.measureContentMinHeight();
			newMinHeight += this.get_paddingTop() + this.get_paddingBottom();
			if(measureSkin != null) {
				newMinHeight = Math.max(measureSkin.get_minHeight(),newMinHeight);
			} else if(this._backgroundSkinMeasurements != null) {
				newMinHeight = Math.max(this._backgroundSkinMeasurements.minHeight,newMinHeight);
			}
		}
		var newMaxWidth = this.get_explicitMaxWidth();
		if(needsMaxWidth) {
			if(measureSkin != null) {
				newMaxWidth = measureSkin.get_maxWidth();
			} else if(this._backgroundSkinMeasurements != null) {
				newMaxWidth = this._backgroundSkinMeasurements.maxWidth;
			} else {
				newMaxWidth = 1.0 / 0.0;
			}
		}
		var newMaxHeight = this.get_explicitMaxHeight();
		if(needsMaxHeight) {
			if(measureSkin != null) {
				newMaxHeight = measureSkin.get_maxHeight();
			} else if(this._backgroundSkinMeasurements != null) {
				newMaxHeight = this._backgroundSkinMeasurements.maxHeight;
			} else {
				newMaxHeight = 1.0 / 0.0;
			}
		}
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight,newMaxWidth,newMaxHeight);
	},
	calculateExplicitWidthForTextMeasurement: function() {
		var textFieldExplicitWidth = null;
		if(this.get_explicitWidth() != null) {
			textFieldExplicitWidth = this.get_explicitWidth();
		} else if(this.get_explicitMaxWidth() != null) {
			textFieldExplicitWidth = this.get_explicitMaxWidth();
		} else if(this._backgroundSkinMeasurements != null && this._backgroundSkinMeasurements.maxWidth != null) {
			textFieldExplicitWidth = this._backgroundSkinMeasurements.maxWidth;
		}
		if(textFieldExplicitWidth == null) {
			return textFieldExplicitWidth;
		}
		textFieldExplicitWidth -= this.get_paddingLeft() + this.get_paddingRight();
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		if(this._currentIcon != null) {
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				if((js_Boot().default).__implements(this._currentIcon,(feathers_core_IValidating().default))) {
					((js_Boot().default).__cast(this._currentIcon , (feathers_core_IValidating().default))).validateNow();
				}
				textFieldExplicitWidth -= this._currentIcon.get_width() + adjustedGap;
			}
		}
		if(textFieldExplicitWidth < 0.0) {
			textFieldExplicitWidth = 0.0;
		}
		return textFieldExplicitWidth;
	},
	measureContentWidth: function() {
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		var hasText = this.get_showText() && this._text != null;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		var contentWidth = hasText || hasHTMLText ? this._textMeasuredWidth : 0.0;
		if(this._currentIcon != null) {
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				if(hasText || hasHTMLText) {
					contentWidth += adjustedGap;
				}
				contentWidth += this._currentIcon.get_width();
			} else if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP || this.get_iconPosition() == (feathers_layout_RelativePosition().default).BOTTOM) {
				contentWidth = Math.max(contentWidth,this._currentIcon.get_width());
			}
		}
		return contentWidth;
	},
	measureContentHeight: function() {
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		var hasText = this.get_showText() && this._text != null;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		var contentHeight = hasText || hasHTMLText ? this._textMeasuredHeight : 0.0;
		if(this._currentIcon != null) {
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP || this.get_iconPosition() == (feathers_layout_RelativePosition().default).BOTTOM) {
				if(hasText || hasHTMLText) {
					contentHeight += adjustedGap;
				}
				contentHeight += this._currentIcon.get_height();
			} else if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				contentHeight = Math.max(contentHeight,this._currentIcon.get_height());
			}
		}
		return contentHeight;
	},
	measureContentMinWidth: function() {
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		var hasText = this.get_showText() && this._text != null;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		var contentMinWidth = hasText || hasHTMLText ? this._textMeasuredWidth : 0.0;
		if(this._currentIcon != null) {
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				if(hasText || hasHTMLText) {
					contentMinWidth += adjustedGap;
				}
				contentMinWidth += this._currentIcon.get_width();
			} else if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP || this.get_iconPosition() == (feathers_layout_RelativePosition().default).BOTTOM) {
				contentMinWidth = Math.max(contentMinWidth,this._currentIcon.get_width());
			}
		}
		return contentMinWidth;
	},
	measureContentMinHeight: function() {
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		var hasText = this.get_showText() && this._text != null;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		var contentMinHeight = hasText || hasHTMLText ? this._textMeasuredHeight : 0.0;
		if(this._currentIcon != null) {
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP || this.get_iconPosition() == (feathers_layout_RelativePosition().default).BOTTOM) {
				if(hasText || hasHTMLText) {
					contentMinHeight += adjustedGap;
				}
				contentMinHeight += this._currentIcon.get_height();
			} else if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				contentMinHeight = Math.max(contentMinHeight,this._currentIcon.get_height());
			}
		}
		return contentMinHeight;
	},
	refreshTextStyles: function() {
		if(this.textField.get_wordWrap() != this.get_wordWrap()) {
			this.textField.set_wordWrap(this.get_wordWrap());
			this._updatedTextStyles = true;
		}
		if(this.textField.get_embedFonts() != this.get_embedFonts()) {
			this.textField.set_embedFonts(this.get_embedFonts());
			this._updatedTextStyles = true;
		}
		var textFormat = this.getCurrentTextFormat();
		var simpleTextFormat = textFormat != null ? textFormat.toSimpleTextFormat() : null;
		if(simpleTextFormat == this._previousSimpleTextFormat) {
			return;
		}
		if(this._previousTextFormat != null) {
			this._previousTextFormat.removeEventListener("change",$bind(this,this.toggleButton_textFormat_changeHandler));
		}
		if(textFormat != null) {
			textFormat.addEventListener("change",$bind(this,this.toggleButton_textFormat_changeHandler),false,0,true);
			this.textField.set_defaultTextFormat(simpleTextFormat);
			this._updatedTextStyles = true;
		}
		this._previousTextFormat = textFormat;
		this._previousSimpleTextFormat = simpleTextFormat;
	},
	refreshText: function(forceMeasurement) {
		var hasText = this.get_showText() && this._text != null && this._text.length > 0;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		this.textField.set_visible(hasText || hasHTMLText);
		if(this._text == this._previousText && this._htmlText != this._previousHTMLText && !this._updatedTextStyles && !forceMeasurement) {
			return;
		}
		this.textField.set_autoSize("left");
		if(hasHTMLText) {
			this.textField.set_htmlText(this._htmlText);
		} else if(hasText) {
			this.textField.set_text(this._text);
		} else {
			this.textField.set_text("​");
		}
		if(this.get_wordWrap()) {
			this.textField.set_wordWrap(false);
		}
		this._textMeasuredWidth = this.textField.get_textWidth() + 4;
		this._wrappedOnMeasure = false;
		if(this.get_wordWrap()) {
			var textFieldExplicitWidth = this.calculateExplicitWidthForTextMeasurement();
			if(textFieldExplicitWidth != null && this._textMeasuredWidth > textFieldExplicitWidth) {
				this.textField.set_wordWrap(true);
				this.textField.set_width(textFieldExplicitWidth);
				this._textMeasuredWidth = this.textField.get_width();
				this._wrappedOnMeasure = true;
			}
		}
		this._textMeasuredHeight = this.textField.get_height();
		this.textField.set_autoSize("none");
		if(this.textField.get_wordWrap() != this.get_wordWrap()) {
			this.textField.set_wordWrap(this.get_wordWrap());
		}
		if(!hasText && !hasHTMLText) {
			this.textField.set_text("");
		}
		this._previousText = this._text;
		this._previousHTMLText = this._htmlText;
	},
	getCurrentTextFormat: function() {
		var result = this._stateToTextFormat.get(this._currentState);
		if(result != null) {
			return result;
		}
		if(!this._enabled && this.get_disabledTextFormat() != null) {
			return this.get_disabledTextFormat();
		}
		if(this._selected && this.get_selectedTextFormat() != null) {
			return this.get_selectedTextFormat();
		}
		return this.get_textFormat();
	},
	layoutContent: function() {
		(feathers_controls_BasicToggleButton().default).prototype.layoutContent.call(this);
		this.layoutChildren();
	},
	layoutChildren: function() {
		this.refreshTextFieldDimensions(false);
		var hasText = this.get_showText() && this._text != null;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		var iconIsInLayout = this._currentIcon != null && this.get_iconPosition() != (feathers_layout_RelativePosition().default).MANUAL;
		if((hasText || hasHTMLText) && iconIsInLayout) {
			this.positionSingleChild(this.textField);
			this.positionTextAndIcon();
		} else if(hasText || hasHTMLText) {
			this.positionSingleChild(this.textField);
		} else if(iconIsInLayout) {
			this.positionSingleChild(this._currentIcon);
		}
		if(this._currentIcon != null) {
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).MANUAL) {
				this._currentIcon.set_x(this.get_paddingLeft());
				this._currentIcon.set_y(this.get_paddingTop());
			}
			var _g = this._currentIcon;
			_g.set_x(_g.get_x() + this.get_iconOffsetX());
			var _g1 = this._currentIcon;
			_g1.set_y(_g1.get_y() + this.get_iconOffsetY());
		}
		if(hasText) {
			var _g2 = this.textField;
			_g2.set_x(_g2.get_x() + this.get_textOffsetX());
			var _g3 = this.textField;
			_g3.set_y(_g3.get_y() + this.get_textOffsetY());
		}
	},
	refreshTextFieldDimensions: function(forMeasurement) {
		var oldIgnoreIconResizes = this._ignoreIconResizes;
		this._ignoreIconResizes = true;
		if((js_Boot().default).__implements(this._currentIcon,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentIcon , (feathers_core_IValidating().default))).validateNow();
		}
		this._ignoreIconResizes = oldIgnoreIconResizes;
		var hasText = this.get_showText() && this._text != null;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		if(!hasText && !hasHTMLText) {
			return;
		}
		var calculatedWidth = this.actualWidth;
		var calculatedHeight = this.actualHeight;
		if(forMeasurement) {
			calculatedWidth = 0.0;
			var explicitCalculatedWidth = this.get_explicitWidth();
			if(explicitCalculatedWidth == null) {
				explicitCalculatedWidth = this.get_explicitMaxWidth();
			}
			if(explicitCalculatedWidth != null) {
				calculatedWidth = explicitCalculatedWidth;
			}
			calculatedHeight = 0.0;
			var explicitCalculatedHeight = this.get_explicitHeight();
			if(explicitCalculatedHeight == null) {
				explicitCalculatedHeight = this.get_explicitMaxHeight();
			}
			if(explicitCalculatedHeight != null) {
				calculatedHeight = explicitCalculatedHeight;
			}
		}
		calculatedWidth -= this.get_paddingLeft() + this.get_paddingRight();
		calculatedHeight -= this.get_paddingTop() + this.get_paddingBottom();
		if(this._currentIcon != null) {
			var adjustedGap = this.get_gap();
			if(adjustedGap == 1.0 / 0.0) {
				adjustedGap = this.get_minGap();
			}
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				calculatedWidth -= this._currentIcon.get_width() + adjustedGap;
			}
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP || this.get_iconPosition() == (feathers_layout_RelativePosition().default).BOTTOM) {
				calculatedHeight -= this._currentIcon.get_height() + adjustedGap;
			}
		}
		if(calculatedWidth < 0.0) {
			calculatedWidth = 0.0;
		}
		if(calculatedHeight < 0.0) {
			calculatedHeight = 0.0;
		}
		if(calculatedWidth > this._textMeasuredWidth) {
			calculatedWidth = this._textMeasuredWidth;
		}
		if(calculatedHeight > this._textMeasuredHeight) {
			calculatedHeight = this._textMeasuredHeight;
		}
		this.textField.set_width(calculatedWidth);
		var wordWrap = this.get_wordWrap();
		if(wordWrap && !this._wrappedOnMeasure && calculatedWidth >= this._textMeasuredWidth) {
			wordWrap = false;
		}
		if(this.textField.get_wordWrap() != wordWrap) {
			this.textField.set_wordWrap(wordWrap);
		}
		this.textField.set_height(calculatedHeight);
	},
	positionSingleChild: function(displayObject) {
		if(this.get_horizontalAlign() == (feathers_layout_HorizontalAlign().default).LEFT) {
			displayObject.set_x(this.get_paddingLeft());
		} else if(this.get_horizontalAlign() == (feathers_layout_HorizontalAlign().default).RIGHT) {
			displayObject.set_x(this.actualWidth - this.get_paddingRight() - displayObject.get_width());
		} else {
			displayObject.set_x(this.get_paddingLeft() + (this.actualWidth - this.get_paddingLeft() - this.get_paddingRight() - displayObject.get_width()) / 2.0);
		}
		if(this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).TOP) {
			displayObject.set_y(this.get_paddingTop());
		} else if(this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).BOTTOM) {
			displayObject.set_y(this.actualHeight - this.get_paddingBottom() - displayObject.get_height());
		} else {
			displayObject.set_y(this.get_paddingTop() + (this.actualHeight - this.get_paddingTop() - this.get_paddingBottom() - displayObject.get_height()) / 2.0);
		}
	},
	positionTextAndIcon: function() {
		if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP) {
			if(this.get_gap() == 1.0 / 0.0) {
				this._currentIcon.set_y(this.get_paddingTop());
				this.textField.set_y(this.actualHeight - this.get_paddingBottom() - this.textField.get_height());
			} else {
				if(this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).TOP) {
					var _g = this.textField;
					_g.set_y(_g.get_y() + (this._currentIcon.get_height() + this.get_gap()));
				} else if(this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).MIDDLE) {
					var _g1 = this.textField;
					_g1.set_y(_g1.get_y() + (this._currentIcon.get_height() + this.get_gap()) / 2.0);
				}
				this._currentIcon.set_y(this.textField.get_y() - this._currentIcon.get_height() - this.get_gap());
			}
		} else if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
			if(this.get_gap() == 1.0 / 0.0) {
				this.textField.set_x(this.get_paddingLeft());
				this._currentIcon.set_x(this.actualWidth - this.get_paddingRight() - this._currentIcon.get_width());
			} else {
				if(this.get_horizontalAlign() == (feathers_layout_HorizontalAlign().default).RIGHT) {
					var _g2 = this.textField;
					_g2.set_x(_g2.get_x() - (this._currentIcon.get_width() + this.get_gap()));
				} else if(this.get_horizontalAlign() == (feathers_layout_HorizontalAlign().default).CENTER) {
					var _g3 = this.textField;
					_g3.set_x(_g3.get_x() - (this._currentIcon.get_width() + this.get_gap()) / 2.0);
				}
				this._currentIcon.set_x(this.textField.get_x() + this.textField.get_width() + this.get_gap());
			}
		} else if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).BOTTOM) {
			if(this.get_gap() == 1.0 / 0.0) {
				this.textField.set_y(this.get_paddingTop());
				this._currentIcon.set_y(this.actualHeight - this.get_paddingBottom() - this._currentIcon.get_height());
			} else {
				if(this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).BOTTOM) {
					var _g4 = this.textField;
					_g4.set_y(_g4.get_y() - (this._currentIcon.get_height() + this.get_gap()));
				} else if(this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).MIDDLE) {
					var _g5 = this.textField;
					_g5.set_y(_g5.get_y() - (this._currentIcon.get_height() + this.get_gap()) / 2.0);
				}
				this._currentIcon.set_y(this.textField.get_y() + this.textField.get_height() + this.get_gap());
			}
		} else if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT) {
			if(this.get_gap() == 1.0 / 0.0) {
				this._currentIcon.set_x(this.get_paddingLeft());
				this.textField.set_x(this.actualWidth - this.get_paddingRight() - this.textField.get_width());
			} else {
				if(this.get_horizontalAlign() == (feathers_layout_HorizontalAlign().default).LEFT) {
					var _g6 = this.textField;
					_g6.set_x(_g6.get_x() + (this.get_gap() + this._currentIcon.get_width()));
				} else if(this.get_horizontalAlign() == (feathers_layout_HorizontalAlign().default).CENTER) {
					var _g7 = this.textField;
					_g7.set_x(_g7.get_x() + (this.get_gap() + this._currentIcon.get_width()) / 2.0);
				}
				this._currentIcon.set_x(this.textField.get_x() - this.get_gap() - this._currentIcon.get_width());
			}
		}
		if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
			if(this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).TOP) {
				this._currentIcon.set_y(this.get_paddingTop());
			} else if(this.get_verticalAlign() == (feathers_layout_VerticalAlign().default).BOTTOM) {
				this._currentIcon.set_y(this.actualHeight - this.get_paddingBottom() - this._currentIcon.get_height());
			} else {
				this._currentIcon.set_y(this.get_paddingTop() + (this.actualHeight - this.get_paddingTop() - this.get_paddingBottom() - this._currentIcon.get_height()) / 2.0);
			}
		} else if(this.get_horizontalAlign() == (feathers_layout_HorizontalAlign().default).LEFT) {
			this._currentIcon.set_x(this.get_paddingLeft());
		} else if(this.get_horizontalAlign() == (feathers_layout_HorizontalAlign().default).RIGHT) {
			this._currentIcon.set_x(this.actualWidth - this.get_paddingRight() - this._currentIcon.get_width());
		} else {
			this._currentIcon.set_x(this.get_paddingLeft() + (this.actualWidth - this.get_paddingLeft() - this.get_paddingRight() - this._currentIcon.get_width()) / 2.0);
		}
	},
	refreshIcon: function() {
		var oldIcon = this._currentIcon;
		this._currentIcon = this.getCurrentIcon();
		if(this._currentIcon == oldIcon) {
			return;
		}
		this.removeCurrentIcon(oldIcon);
		this.addCurrentIcon(this._currentIcon);
	},
	getCurrentIcon: function() {
		var result = this._stateToIcon.get(this._currentState);
		if(result != null) {
			return result;
		}
		if(!this._enabled && this.get_disabledIcon() != null) {
			return this.get_disabledIcon();
		}
		if(this._selected && this.get_selectedIcon() != null) {
			return this.get_selectedIcon();
		}
		return this.get_icon();
	},
	addCurrentIcon: function(icon) {
		if(icon == null) {
			this._iconMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(icon,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(icon , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._iconMeasurements == null) {
			this._iconMeasurements = new (feathers_layout_Measurements().default)(icon);
		} else {
			this._iconMeasurements.save(icon);
		}
		if((js_Boot().default).__implements(icon,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(icon , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		if((js_Boot().default).__implements(icon,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(icon , (feathers_core_IStateObserver().default))).set_stateContext(this);
		}
		icon.addEventListener("resize",$bind(this,this.toggleButton_icon_resizeHandler),false,0,true);
		var index = this.getChildIndex(this.textField);
		this.addChildAt(icon,index);
	},
	removeCurrentIcon: function(icon) {
		if(icon == null) {
			return;
		}
		icon.removeEventListener("resize",$bind(this,this.toggleButton_icon_resizeHandler));
		if((js_Boot().default).__implements(icon,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(icon , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		if((js_Boot().default).__implements(icon,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(icon , (feathers_core_IStateObserver().default))).set_stateContext(null);
		}
		this._iconMeasurements.restore(icon);
		if(icon.parent == this) {
			this.removeChild(icon);
		}
	},
	toggleButton_keyDownHandler: function(event) {
		if(!this._enabled || this.get_buttonMode() && this.focusRect == true) {
			return;
		}
		if(this._focusManager != null && this._focusManager.get_focus() != this) {
			return;
		}
		if(event.keyCode != 32 && event.keyCode != 13) {
			return;
		}
		event.preventDefault();
		this.dispatchEvent(new (openfl_events_MouseEvent())("click"));
	},
	toggleButton_focusInHandler: function(event) {
		this._keyToState.set_enabled(this._enabled);
	},
	toggleButton_focusOutHandler: function(event) {
		this._keyToState.set_enabled(false);
	},
	toggleButton_textFormat_changeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	toggleButton_icon_resizeHandler: function(event) {
		if(this._ignoreIconResizes) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	get_styleContext: function() {
		return ToggleButton
	},
	get_icon: function() {
		return this.__icon;
	},
	set_icon: function(value) {
		if(!this.setStyle("icon")) {
			return this.__icon;
		}
		if(this.__icon == value) {
			return this.__icon;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_icon);
		this.__icon = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__icon;
	},
	clearStyle_icon: function() {
		this.set_icon(null);
		return this.get_icon();
	},
	get_disabledIcon: function() {
		return this.__disabledIcon;
	},
	set_disabledIcon: function(value) {
		if(!this.setStyle("disabledIcon")) {
			return this.__disabledIcon;
		}
		if(this.__disabledIcon == value) {
			return this.__disabledIcon;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledIcon);
		this.__disabledIcon = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledIcon;
	},
	clearStyle_disabledIcon: function() {
		this.set_disabledIcon(null);
		return this.get_disabledIcon();
	},
	get_selectedIcon: function() {
		return this.__selectedIcon;
	},
	set_selectedIcon: function(value) {
		if(!this.setStyle("selectedIcon")) {
			return this.__selectedIcon;
		}
		if(this.__selectedIcon == value) {
			return this.__selectedIcon;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_selectedIcon);
		this.__selectedIcon = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__selectedIcon;
	},
	clearStyle_selectedIcon: function() {
		this.set_selectedIcon(null);
		return this.get_selectedIcon();
	},
	get_textFormat: function() {
		return this.__textFormat;
	},
	set_textFormat: function(value) {
		if(!this.setStyle("textFormat")) {
			return this.__textFormat;
		}
		if(this.__textFormat == value) {
			return this.__textFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_textFormat);
		this.__textFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__textFormat;
	},
	clearStyle_textFormat: function() {
		this.set_textFormat(null);
		return this.get_textFormat();
	},
	get_embedFonts: function() {
		return this.__embedFonts;
	},
	set_embedFonts: function(value) {
		if(!this.setStyle("embedFonts")) {
			return this.__embedFonts;
		}
		if(this.__embedFonts == value) {
			return this.__embedFonts;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_embedFonts);
		this.__embedFonts = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__embedFonts;
	},
	clearStyle_embedFonts: function() {
		this.set_embedFonts(false);
		return this.get_embedFonts();
	},
	get_wordWrap: function() {
		return this.__wordWrap;
	},
	set_wordWrap: function(value) {
		if(!this.setStyle("wordWrap")) {
			return this.__wordWrap;
		}
		if(this.__wordWrap == value) {
			return this.__wordWrap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_wordWrap);
		this.__wordWrap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__wordWrap;
	},
	clearStyle_wordWrap: function() {
		this.set_wordWrap(false);
		return this.get_wordWrap();
	},
	get_disabledTextFormat: function() {
		return this.__disabledTextFormat;
	},
	set_disabledTextFormat: function(value) {
		if(!this.setStyle("disabledTextFormat")) {
			return this.__disabledTextFormat;
		}
		if(this.__disabledTextFormat == value) {
			return this.__disabledTextFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledTextFormat);
		this.__disabledTextFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledTextFormat;
	},
	clearStyle_disabledTextFormat: function() {
		this.set_disabledTextFormat(null);
		return this.get_disabledTextFormat();
	},
	get_selectedTextFormat: function() {
		return this.__selectedTextFormat;
	},
	set_selectedTextFormat: function(value) {
		if(!this.setStyle("selectedTextFormat")) {
			return this.__selectedTextFormat;
		}
		if(this.__selectedTextFormat == value) {
			return this.__selectedTextFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_selectedTextFormat);
		this.__selectedTextFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__selectedTextFormat;
	},
	clearStyle_selectedTextFormat: function() {
		this.set_selectedTextFormat(null);
		return this.get_selectedTextFormat();
	},
	get_iconPosition: function() {
		return this.__iconPosition;
	},
	set_iconPosition: function(value) {
		if(!this.setStyle("iconPosition")) {
			return this.__iconPosition;
		}
		if(this.__iconPosition == value) {
			return this.__iconPosition;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_iconPosition);
		this.__iconPosition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__iconPosition;
	},
	clearStyle_iconPosition: function() {
		this.set_iconPosition((feathers_layout_RelativePosition().default).LEFT);
		return this.get_iconPosition();
	},
	get_gap: function() {
		return this.__gap;
	},
	set_gap: function(value) {
		if(!this.setStyle("gap")) {
			return this.__gap;
		}
		if(this.__gap == value) {
			return this.__gap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_gap);
		this.__gap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__gap;
	},
	clearStyle_gap: function() {
		this.set_gap(0.0);
		return this.get_gap();
	},
	get_minGap: function() {
		return this.__minGap;
	},
	set_minGap: function(value) {
		if(!this.setStyle("minGap")) {
			return this.__minGap;
		}
		if(this.__minGap == value) {
			return this.__minGap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_minGap);
		this.__minGap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__minGap;
	},
	clearStyle_minGap: function() {
		this.set_minGap(0.0);
		return this.get_minGap();
	},
	get_paddingTop: function() {
		return this.__paddingTop;
	},
	set_paddingTop: function(value) {
		if(!this.setStyle("paddingTop")) {
			return this.__paddingTop;
		}
		if(this.__paddingTop == value) {
			return this.__paddingTop;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingTop);
		this.__paddingTop = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingTop;
	},
	clearStyle_paddingTop: function() {
		this.set_paddingTop(0.0);
		return this.get_paddingTop();
	},
	get_paddingRight: function() {
		return this.__paddingRight;
	},
	set_paddingRight: function(value) {
		if(!this.setStyle("paddingRight")) {
			return this.__paddingRight;
		}
		if(this.__paddingRight == value) {
			return this.__paddingRight;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingRight);
		this.__paddingRight = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingRight;
	},
	clearStyle_paddingRight: function() {
		this.set_paddingRight(0.0);
		return this.get_paddingRight();
	},
	get_paddingBottom: function() {
		return this.__paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(!this.setStyle("paddingBottom")) {
			return this.__paddingBottom;
		}
		if(this.__paddingBottom == value) {
			return this.__paddingBottom;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingBottom);
		this.__paddingBottom = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingBottom;
	},
	clearStyle_paddingBottom: function() {
		this.set_paddingBottom(0.0);
		return this.get_paddingBottom();
	},
	get_paddingLeft: function() {
		return this.__paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(!this.setStyle("paddingLeft")) {
			return this.__paddingLeft;
		}
		if(this.__paddingLeft == value) {
			return this.__paddingLeft;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingLeft);
		this.__paddingLeft = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingLeft;
	},
	clearStyle_paddingLeft: function() {
		this.set_paddingLeft(0.0);
		return this.get_paddingLeft();
	},
	get_horizontalAlign: function() {
		return this.__horizontalAlign;
	},
	set_horizontalAlign: function(value) {
		if(!this.setStyle("horizontalAlign")) {
			return this.__horizontalAlign;
		}
		if(this.__horizontalAlign == value) {
			return this.__horizontalAlign;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_horizontalAlign);
		this.__horizontalAlign = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__horizontalAlign;
	},
	clearStyle_horizontalAlign: function() {
		this.set_horizontalAlign((feathers_layout_HorizontalAlign().default).CENTER);
		return this.get_horizontalAlign();
	},
	get_verticalAlign: function() {
		return this.__verticalAlign;
	},
	set_verticalAlign: function(value) {
		if(!this.setStyle("verticalAlign")) {
			return this.__verticalAlign;
		}
		if(this.__verticalAlign == value) {
			return this.__verticalAlign;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_verticalAlign);
		this.__verticalAlign = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__verticalAlign;
	},
	clearStyle_verticalAlign: function() {
		this.set_verticalAlign((feathers_layout_VerticalAlign().default).MIDDLE);
		return this.get_verticalAlign();
	},
	get_iconOffsetX: function() {
		return this.__iconOffsetX;
	},
	set_iconOffsetX: function(value) {
		if(!this.setStyle("iconOffsetX")) {
			return this.__iconOffsetX;
		}
		if(this.__iconOffsetX == value) {
			return this.__iconOffsetX;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_iconOffsetX);
		this.__iconOffsetX = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__iconOffsetX;
	},
	clearStyle_iconOffsetX: function() {
		this.set_iconOffsetX(0.0);
		return this.get_iconOffsetX();
	},
	get_iconOffsetY: function() {
		return this.__iconOffsetY;
	},
	set_iconOffsetY: function(value) {
		if(!this.setStyle("iconOffsetY")) {
			return this.__iconOffsetY;
		}
		if(this.__iconOffsetY == value) {
			return this.__iconOffsetY;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_iconOffsetY);
		this.__iconOffsetY = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__iconOffsetY;
	},
	clearStyle_iconOffsetY: function() {
		this.set_iconOffsetY(0.0);
		return this.get_iconOffsetY();
	},
	get_textOffsetX: function() {
		return this.__textOffsetX;
	},
	set_textOffsetX: function(value) {
		if(!this.setStyle("textOffsetX")) {
			return this.__textOffsetX;
		}
		if(this.__textOffsetX == value) {
			return this.__textOffsetX;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_textOffsetX);
		this.__textOffsetX = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__textOffsetX;
	},
	clearStyle_textOffsetX: function() {
		this.set_textOffsetX(0.0);
		return this.get_textOffsetX();
	},
	get_textOffsetY: function() {
		return this.__textOffsetY;
	},
	set_textOffsetY: function(value) {
		if(!this.setStyle("textOffsetY")) {
			return this.__textOffsetY;
		}
		if(this.__textOffsetY == value) {
			return this.__textOffsetY;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_textOffsetY);
		this.__textOffsetY = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__textOffsetY;
	},
	clearStyle_textOffsetY: function() {
		this.set_textOffsetY(0.0);
		return this.get_textOffsetY();
	},
	get_showText: function() {
		return this.__showText;
	},
	set_showText: function(value) {
		if(!this.setStyle("showText")) {
			return this.__showText;
		}
		if(this.__showText == value) {
			return this.__showText;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_showText);
		this.__showText = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__showText;
	},
	clearStyle_showText: function() {
		this.set_showText(true);
		return this.get_showText();
	}
});
ToggleButton.prototype.__class__ = ToggleButton.prototype.constructor = $hxClasses["feathers.controls.ToggleButton"] = ToggleButton;

// Init



// Statics


ToggleButton.__meta__ = { obj : { defaultXmlProperty : ["text"]}, fields : { setTextFormatForState : { style : null}, setIconForState : { style : null}}}

// Export

exports["default"] = ToggleButton;

/***/ }),

/***/ "./lib/_gen/feathers/controls/ToggleButtonState.js":
/*!*********************************************************!*\
  !*** ./lib/_gen/feathers/controls/ToggleButtonState.js ***!
  \*********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.controls.ToggleButtonState

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var ToggleButtonState = $hxEnums["feathers.controls.ToggleButtonState"] = { __ename__ : "feathers.controls.ToggleButtonState", __constructs__ : ["UP","HOVER","DOWN","DISABLED"]
  ,UP: ($_=function(selected) { return {_hx_index:0,selected:selected,__enum__:"feathers.controls.ToggleButtonState",toString:$estr}; },$_.__params__ = ["selected"],$_)
  ,HOVER: ($_=function(selected) { return {_hx_index:1,selected:selected,__enum__:"feathers.controls.ToggleButtonState",toString:$estr}; },$_.__params__ = ["selected"],$_)
  ,DOWN: ($_=function(selected) { return {_hx_index:2,selected:selected,__enum__:"feathers.controls.ToggleButtonState",toString:$estr}; },$_.__params__ = ["selected"],$_)
  ,DISABLED: ($_=function(selected) { return {_hx_index:3,selected:selected,__enum__:"feathers.controls.ToggleButtonState",toString:$estr}; },$_.__params__ = ["selected"],$_)
};

exports["default"] = ToggleButtonState;

/***/ }),

/***/ "./lib/_gen/feathers/controls/ToggleSwitch.js":
/*!****************************************************!*\
  !*** ./lib/_gen/feathers/controls/ToggleSwitch.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.ToggleSwitch

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}
function feathers_controls_IToggle() {return __webpack_require__(/*! ./../../feathers/controls/IToggle */ "./lib/_gen/feathers/controls/IToggle.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_themes_steel_components_SteelToggleSwitchStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelToggleSwitchStyles */ "./lib/_gen/feathers/themes/steel/components/SteelToggleSwitchStyles.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function motion_Actuate() {return (__webpack_require__(/*! motion */ "motion").Actuate);}
function motion_actuators_SimpleActuator() {return (__webpack_require__(/*! motion */ "motion").actuators.SimpleActuator);}
function openfl_events_MouseEvent() {return (__webpack_require__(/*! openfl */ "openfl").events.MouseEvent);}
function feathers_utils_ExclusivePointer() {return __webpack_require__(/*! ./../../feathers/utils/ExclusivePointer */ "./lib/_gen/feathers/utils/ExclusivePointer.js");}
function openfl_display_Stage() {return (__webpack_require__(/*! openfl */ "openfl").display.Stage);}
function motion_easing_Quart() {return (__webpack_require__(/*! motion */ "motion").easing.Quart);}

// Constructor

var ToggleSwitch = function(selected,changeListener) {
	if(selected == null) {
		selected = false;
	}
	this.__toggleEase = (motion_easing_Quart()).easeOut;
	this.__toggleDuration = 0.15;
	this.__paddingLeft = 0.0;
	this.__paddingRight = 0.0;
	this.__secondaryTrackSkin = null;
	this.__trackSkin = null;
	this.__thumbSkin = null;
	this._animateSelectionChange = false;
	this._ignoreClick = false;
	this._toggleTween = null;
	this._secondaryTrackSkinMeasurements = null;
	this._currentSecondaryTrackSkin = null;
	this._trackSkinMeasurements = null;
	this._currentTrackSkin = null;
	this._thumbSkinMeasurements = null;
	this._currentThumbSkin = null;
	this._selected = false;
	this.initializeToggleSwitchTheme();
	(feathers_core_FeathersControl().default).call(this);
	this.set_selected(selected);
	this.mouseChildren = false;
	this.set_buttonMode(true);
	this.useHandCursor = false;
	this.set_tabEnabled(true);
	this.set_tabChildren(false);
	this.focusRect = null;
	this.addEventListener("keyDown",$bind(this,this.toggleSwitch_keyDownHandler));
	this.addEventListener("mouseDown",$bind(this,this.toggleSwitch_mouseDownHandler));
	this.addEventListener("click",$bind(this,this.toggleSwitch_clickHandler));
	this.addEventListener("touchTap",$bind(this,this.toggleSwitch_touchTapHandler));
	if(changeListener != null) {
		this.addEventListener("change",changeListener);
	}
}

// Meta

ToggleSwitch.__name__ = "feathers.controls.ToggleSwitch";
ToggleSwitch.__isInterface__ = false;
ToggleSwitch.__interfaces__ = [(feathers_core_IFocusObject().default),(feathers_controls_IToggle().default)];
ToggleSwitch.__super__ = (feathers_core_FeathersControl().default);
ToggleSwitch.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_selected: function() {
		return this._selected;
	},
	set_selected: function(value) {
		this._animateSelectionChange = false;
		if(this._selected == value) {
			return this._selected;
		}
		this._selected = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		return this._selected;
	},
	setSelectionWithAnimation: function(selected) {
		if(this._selected == selected) {
			return this._selected;
		}
		this.set_selected(selected);
		this._animateSelectionChange = true;
		return this._selected;
	},
	setPadding: function(value) {
		this.set_paddingRight(value);
		this.set_paddingLeft(value);
	},
	initializeToggleSwitchTheme: function() {
		(feathers_themes_steel_components_SteelToggleSwitchStyles().default).initialize();
	},
	update: function() {
		var selectionInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		var sizeInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SIZE);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(stylesInvalid) {
			this.refreshThumb();
			this.refreshTrack();
			this.refreshSecondaryTrack();
		}
		if(selectionInvalid || stylesInvalid) {
			this.refreshSelection();
		}
		if(stateInvalid || stylesInvalid) {
			this.refreshEnabled();
		}
		sizeInvalid = this.measure() || sizeInvalid;
		this.layoutContent();
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		if(this._currentThumbSkin != null) {
			this._thumbSkinMeasurements.restore(this._currentThumbSkin);
			if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IValidating().default))).validateNow();
			}
		}
		if(this._currentTrackSkin != null) {
			this._trackSkinMeasurements.restore(this._currentTrackSkin);
			if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentTrackSkin , (feathers_core_IValidating().default))).validateNow();
			}
		}
		if(this._currentSecondaryTrackSkin != null) {
			this._secondaryTrackSkinMeasurements.restore(this._currentSecondaryTrackSkin);
			if((js_Boot().default).__implements(this._currentSecondaryTrackSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentSecondaryTrackSkin , (feathers_core_IValidating().default))).validateNow();
			}
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			newWidth = 0.0;
			if(this._currentTrackSkin != null) {
				newWidth += this._currentTrackSkin.get_width();
				if(this._currentSecondaryTrackSkin != null) {
					newWidth += this._currentSecondaryTrackSkin.get_width();
				}
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			newHeight = 0.0;
			if(this._currentThumbSkin != null) {
				newHeight += this._currentThumbSkin.get_height();
			}
			if(this._currentTrackSkin != null) {
				if(newHeight < this._currentTrackSkin.get_height()) {
					newHeight = this._currentTrackSkin.get_height();
				}
				if(this._currentSecondaryTrackSkin != null && newHeight < this._currentSecondaryTrackSkin.get_height()) {
					newHeight = this._currentSecondaryTrackSkin.get_height();
				}
			}
		}
		var newMinWidth = newWidth;
		var newMinHeight = newHeight;
		var newMaxWidth = newWidth;
		var newMaxHeight = newHeight;
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight,newMaxWidth,newMaxHeight);
	},
	refreshThumb: function() {
		var oldSkin = this._currentThumbSkin;
		this._currentThumbSkin = this.get_thumbSkin();
		if(this._currentThumbSkin == oldSkin) {
			return;
		}
		if(oldSkin != null && oldSkin.parent == this) {
			if((js_Boot().default).__implements(oldSkin,(feathers_skins_IProgrammaticSkin().default))) {
				((js_Boot().default).__cast(oldSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
			}
			this.removeChild(oldSkin);
		}
		if(this._currentThumbSkin != null) {
			if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(this._thumbSkinMeasurements == null) {
				this._thumbSkinMeasurements = new (feathers_layout_Measurements().default)(this._currentThumbSkin);
			} else {
				this._thumbSkinMeasurements.save(this._currentThumbSkin);
			}
			if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_skins_IProgrammaticSkin().default))) {
				((js_Boot().default).__cast(this._currentThumbSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
			}
			this.addChild(this._currentThumbSkin);
		} else {
			this._thumbSkinMeasurements = null;
		}
	},
	refreshTrack: function() {
		var oldSkin = this._currentTrackSkin;
		this._currentTrackSkin = this.get_trackSkin();
		if(this._currentTrackSkin == oldSkin) {
			return;
		}
		if(oldSkin != null && oldSkin.parent == this) {
			if((js_Boot().default).__implements(oldSkin,(feathers_skins_IProgrammaticSkin().default))) {
				((js_Boot().default).__cast(oldSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
			}
			this.removeChild(oldSkin);
		}
		if(this._currentTrackSkin != null) {
			if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(this._currentTrackSkin , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(this._trackSkinMeasurements == null) {
				this._trackSkinMeasurements = new (feathers_layout_Measurements().default)(this._currentTrackSkin);
			} else {
				this._trackSkinMeasurements.save(this._currentTrackSkin);
			}
			if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_skins_IProgrammaticSkin().default))) {
				((js_Boot().default).__cast(this._currentTrackSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
			}
			this.addChildAt(this._currentTrackSkin,0);
		} else {
			this._trackSkinMeasurements = null;
		}
	},
	refreshSecondaryTrack: function() {
		var oldSkin = this._currentSecondaryTrackSkin;
		this._currentSecondaryTrackSkin = this.get_secondaryTrackSkin();
		if(this._currentSecondaryTrackSkin == oldSkin) {
			return;
		}
		if(oldSkin != null && oldSkin.parent == this) {
			if((js_Boot().default).__implements(oldSkin,(feathers_skins_IProgrammaticSkin().default))) {
				((js_Boot().default).__cast(oldSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
			}
			this.removeChild(oldSkin);
		}
		if(this._currentSecondaryTrackSkin != null) {
			if((js_Boot().default).__implements(this._currentSecondaryTrackSkin,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(this._currentSecondaryTrackSkin , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(this._secondaryTrackSkinMeasurements == null) {
				this._secondaryTrackSkinMeasurements = new (feathers_layout_Measurements().default)(this._currentSecondaryTrackSkin);
			} else {
				this._secondaryTrackSkinMeasurements.save(this._currentSecondaryTrackSkin);
			}
			if((js_Boot().default).__implements(this._currentSecondaryTrackSkin,(feathers_skins_IProgrammaticSkin().default))) {
				((js_Boot().default).__cast(this._currentSecondaryTrackSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
			}
			var index = this._currentTrackSkin != null ? 1 : 0;
			this.addChildAt(this._currentSecondaryTrackSkin,index);
		} else {
			this._secondaryTrackSkinMeasurements = null;
		}
	},
	refreshSelection: function() {
		if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_controls_IToggle().default))) {
			((js_Boot().default).__cast(this._currentThumbSkin , (feathers_controls_IToggle().default))).set_selected(this._selected);
		}
		if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_controls_IToggle().default))) {
			((js_Boot().default).__cast(this._currentTrackSkin , (feathers_controls_IToggle().default))).set_selected(this._selected);
		}
		if((js_Boot().default).__implements(this._currentSecondaryTrackSkin,(feathers_controls_IToggle().default))) {
			((js_Boot().default).__cast(this._currentSecondaryTrackSkin , (feathers_controls_IToggle().default))).set_selected(this._selected);
		}
		if(this._toggleTween != null) {
			(motion_Actuate()).stop(this._toggleTween,null,false,false);
			this._toggleTween = null;
		}
	},
	refreshEnabled: function() {
		if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IUIControl().default))).set_enabled(this._enabled);
		}
		if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._currentTrackSkin , (feathers_core_IUIControl().default))).set_enabled(this._enabled);
		}
		if((js_Boot().default).__implements(this._currentSecondaryTrackSkin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._currentSecondaryTrackSkin , (feathers_core_IUIControl().default))).set_enabled(this._enabled);
		}
	},
	layoutContent: function() {
		this.layoutThumb();
		if(this._currentTrackSkin != null && this._currentSecondaryTrackSkin != null) {
			this.layoutSplitTrack();
		} else {
			this.layoutSingleTrack();
		}
	},
	layoutThumb: function() {
		var _gthis = this;
		if(this._currentThumbSkin == null) {
			return;
		}
		if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IValidating().default))).validateNow();
		}
		var xPosition = this.get_paddingLeft();
		if(this._selected) {
			xPosition = this.actualWidth - this._currentThumbSkin.get_width() - this.get_paddingRight();
		}
		if(this._animateSelectionChange) {
			var tween = (motion_Actuate()).update(function(x) {
				return _gthis._currentThumbSkin.set_x(x);
			},this.get_toggleDuration(),[this._currentThumbSkin.get_x()],[xPosition],true);
			this._toggleTween = (js_Boot().default).__cast(tween , (motion_actuators_SimpleActuator()));
			this._toggleTween.ease(this.get_toggleEase());
			this._toggleTween.onUpdate($bind(this,this.toggleTween_onUpdate));
			this._toggleTween.onComplete($bind(this,this.toggleTween_onComplete));
		} else if(this._toggleTween == null) {
			this._currentThumbSkin.set_x(xPosition);
		}
		this._currentThumbSkin.set_y((this.actualHeight - this._currentThumbSkin.get_height()) / 2.0);
		this._animateSelectionChange = false;
	},
	layoutSplitTrack: function() {
		if(this._currentTrackSkin == null || this._currentSecondaryTrackSkin == null) {
			return;
		}
		var location = this._currentThumbSkin.get_x() + this._currentThumbSkin.get_width() / 2.0;
		this._currentTrackSkin.set_x(0.0);
		this._currentTrackSkin.set_width(location);
		this._currentSecondaryTrackSkin.set_x(location);
		this._currentSecondaryTrackSkin.set_width(this.actualWidth - location);
		if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentTrackSkin , (feathers_core_IValidating().default))).validateNow();
		}
		if((js_Boot().default).__implements(this._currentSecondaryTrackSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentSecondaryTrackSkin , (feathers_core_IValidating().default))).validateNow();
		}
		this._currentTrackSkin.set_y((this.actualHeight - this._currentTrackSkin.get_height()) / 2.0);
		this._currentSecondaryTrackSkin.set_y((this.actualHeight - this._currentSecondaryTrackSkin.get_height()) / 2.0);
	},
	layoutSingleTrack: function() {
		if(this._currentTrackSkin == null) {
			return;
		}
		this._currentTrackSkin.set_x(0.0);
		this._currentTrackSkin.set_width(this.actualWidth);
		if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentTrackSkin , (feathers_core_IValidating().default))).validateNow();
		}
		this._currentTrackSkin.set_y((this.actualHeight - this._currentTrackSkin.get_height()) / 2.0);
	},
	toggleSwitch_keyDownHandler: function(event) {
		if(!this._enabled || this.get_buttonMode() && this.focusRect == true) {
			return;
		}
		if(event.keyCode != 32 && event.keyCode != 13) {
			return;
		}
		event.preventDefault();
		this.dispatchEvent(new (openfl_events_MouseEvent())("click"));
	},
	toggleSwitch_mouseDownHandler: function(event) {
		if(!this._enabled || this.stage == null) {
			return;
		}
		var exclusivePointer = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
		var result = exclusivePointer.claimMouse(this);
		if(!result) {
			return;
		}
		this._dragStartX = this.get_mouseX();
		this._ignoreClick = false;
		this.stage.addEventListener("mouseMove",$bind(this,this.toggleSwitch_stage_mouseMoveHandler),false,0,true);
		this.stage.addEventListener("mouseUp",$bind(this,this.toggleSwitch_stage_mouseUpHandler),false,0,true);
	},
	toggleSwitch_clickHandler: function(event) {
		if(!this._enabled || this._ignoreClick) {
			return;
		}
		this.setSelectionWithAnimation(!this._selected);
	},
	toggleSwitch_touchTapHandler: function(event) {
		if(event.isPrimaryTouchPoint) {
			return;
		}
		if(!this._enabled || this._ignoreClick) {
			return;
		}
		this.setSelectionWithAnimation(!this._selected);
	},
	toggleSwitch_stage_mouseMoveHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		var halfDistance = (this.actualWidth - this.get_paddingLeft() - this.get_paddingRight()) / 2.0;
		var dragOffset = this.get_mouseX() - this._dragStartX;
		var selected = this._selected;
		if(dragOffset >= halfDistance) {
			selected = true;
		} else if(dragOffset <= -halfDistance) {
			selected = false;
		}
		if(this._selected != selected) {
			this._ignoreClick = true;
			this._dragStartX = this.get_mouseX();
			this.setSelectionWithAnimation(selected);
		}
	},
	toggleSwitch_stage_mouseUpHandler: function(event) {
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		stage.removeEventListener("mouseMove",$bind(this,this.toggleSwitch_stage_mouseMoveHandler));
		stage.removeEventListener("mouseUp",$bind(this,this.toggleSwitch_stage_mouseUpHandler));
	},
	toggleTween_onUpdate: function() {
		this.layoutContent();
	},
	toggleTween_onComplete: function() {
		this._toggleTween = null;
	},
	get_thumbSkin: function() {
		return this.__thumbSkin;
	},
	set_thumbSkin: function(value) {
		if(!this.setStyle("thumbSkin")) {
			return this.__thumbSkin;
		}
		if(this.__thumbSkin == value) {
			return this.__thumbSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_thumbSkin);
		this.__thumbSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__thumbSkin;
	},
	clearStyle_thumbSkin: function() {
		this.set_thumbSkin(null);
		return this.get_thumbSkin();
	},
	get_trackSkin: function() {
		return this.__trackSkin;
	},
	set_trackSkin: function(value) {
		if(!this.setStyle("trackSkin")) {
			return this.__trackSkin;
		}
		if(this.__trackSkin == value) {
			return this.__trackSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_trackSkin);
		this.__trackSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__trackSkin;
	},
	clearStyle_trackSkin: function() {
		this.set_trackSkin(null);
		return this.get_trackSkin();
	},
	get_secondaryTrackSkin: function() {
		return this.__secondaryTrackSkin;
	},
	set_secondaryTrackSkin: function(value) {
		if(!this.setStyle("secondaryTrackSkin")) {
			return this.__secondaryTrackSkin;
		}
		if(this.__secondaryTrackSkin == value) {
			return this.__secondaryTrackSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_secondaryTrackSkin);
		this.__secondaryTrackSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__secondaryTrackSkin;
	},
	clearStyle_secondaryTrackSkin: function() {
		this.set_secondaryTrackSkin(null);
		return this.get_secondaryTrackSkin();
	},
	get_paddingRight: function() {
		return this.__paddingRight;
	},
	set_paddingRight: function(value) {
		if(!this.setStyle("paddingRight")) {
			return this.__paddingRight;
		}
		if(this.__paddingRight == value) {
			return this.__paddingRight;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingRight);
		this.__paddingRight = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingRight;
	},
	clearStyle_paddingRight: function() {
		this.set_paddingRight(0.0);
		return this.get_paddingRight();
	},
	get_paddingLeft: function() {
		return this.__paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(!this.setStyle("paddingLeft")) {
			return this.__paddingLeft;
		}
		if(this.__paddingLeft == value) {
			return this.__paddingLeft;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingLeft);
		this.__paddingLeft = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingLeft;
	},
	clearStyle_paddingLeft: function() {
		this.set_paddingLeft(0.0);
		return this.get_paddingLeft();
	},
	get_toggleDuration: function() {
		return this.__toggleDuration;
	},
	set_toggleDuration: function(value) {
		if(!this.setStyle("toggleDuration")) {
			return this.__toggleDuration;
		}
		if(this.__toggleDuration == value) {
			return this.__toggleDuration;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_toggleDuration);
		this.__toggleDuration = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__toggleDuration;
	},
	clearStyle_toggleDuration: function() {
		this.set_toggleDuration(0.15);
		return this.get_toggleDuration();
	},
	get_toggleEase: function() {
		return this.__toggleEase;
	},
	set_toggleEase: function(value) {
		if(!this.setStyle("toggleEase")) {
			return this.__toggleEase;
		}
		if(this.__toggleEase == value) {
			return this.__toggleEase;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_toggleEase);
		this.__toggleEase = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__toggleEase;
	},
	clearStyle_toggleEase: function() {
		this.set_toggleEase((motion_easing_Quart()).easeOut);
		return this.get_toggleEase();
	},
	get_styleContext: function() {
		return ToggleSwitch
	}
});
ToggleSwitch.prototype.__class__ = ToggleSwitch.prototype.constructor = $hxClasses["feathers.controls.ToggleSwitch"] = ToggleSwitch;

// Init



// Statics




// Export

exports["default"] = ToggleSwitch;

/***/ }),

/***/ "./lib/_gen/feathers/controls/TreeGridView.js":
/*!****************************************************!*\
  !*** ./lib/_gen/feathers/controls/TreeGridView.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.TreeGridView

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IFocusContainer() {return __webpack_require__(/*! ./../../feathers/core/IFocusContainer */ "./lib/_gen/feathers/core/IFocusContainer.js");}
function feathers_core_IDataSelector() {return __webpack_require__(/*! ./../../feathers/core/IDataSelector */ "./lib/_gen/feathers/core/IDataSelector.js");}
function feathers_controls_supportClasses_BaseScrollContainer() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/BaseScrollContainer */ "./lib/_gen/feathers/controls/supportClasses/BaseScrollContainer.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function feathers_themes_steel_components_SteelTreeGridViewStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelTreeGridViewStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTreeGridViewStyles.js");}
function feathers_layout_GridViewRowLayout() {return __webpack_require__(/*! ./../../feathers/layout/GridViewRowLayout */ "./lib/_gen/feathers/layout/GridViewRowLayout.js");}
function feathers_controls_LayoutGroup() {return __webpack_require__(/*! ./../../feathers/controls/LayoutGroup */ "./lib/_gen/feathers/controls/LayoutGroup.js");}
function openfl_display_Sprite() {return (__webpack_require__(/*! openfl */ "openfl").display.Sprite);}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_IScrollLayout() {return __webpack_require__(/*! ./../../feathers/layout/IScrollLayout */ "./lib/_gen/feathers/layout/IScrollLayout.js");}
function feathers_layout_IVirtualLayout() {return __webpack_require__(/*! ./../../feathers/layout/IVirtualLayout */ "./lib/_gen/feathers/layout/IVirtualLayout.js");}
function Reflect() {return __webpack_require__(/*! ./../../Reflect */ "./lib/_gen/Reflect.js");}
function feathers_controls_TreeGridViewColumn() {return __webpack_require__(/*! ./../../feathers/controls/TreeGridViewColumn */ "./lib/_gen/feathers/controls/TreeGridViewColumn.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_data_ArrayCollection() {return __webpack_require__(/*! ./../../feathers/data/ArrayCollection */ "./lib/_gen/feathers/data/ArrayCollection.js");}
function feathers_utils_MathUtil() {return __webpack_require__(/*! ./../../feathers/utils/MathUtil */ "./lib/_gen/feathers/utils/MathUtil.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function openfl_display_InteractiveObject() {return (__webpack_require__(/*! openfl */ "openfl").display.InteractiveObject);}
function openfl_display_DisplayObjectContainer() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObjectContainer);}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function Type() {return __webpack_require__(/*! ./../../Type */ "./lib/_gen/Type.js");}
function feathers_style_IVariantStyleObject() {return __webpack_require__(/*! ./../../feathers/style/IVariantStyleObject */ "./lib/_gen/feathers/style/IVariantStyleObject.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_controls_ITriggerView() {return __webpack_require__(/*! ./../../feathers/controls/ITriggerView */ "./lib/_gen/feathers/controls/ITriggerView.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_controls_dataRenderers_ITreeGridViewHeaderRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/ITreeGridViewHeaderRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ITreeGridViewHeaderRenderer.js");}
function feathers_layout_ILayoutIndexObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutIndexObject */ "./lib/_gen/feathers/layout/ILayoutIndexObject.js");}
function feathers_layout_IKeyboardNavigationLayout() {return __webpack_require__(/*! ./../../feathers/layout/IKeyboardNavigationLayout */ "./lib/_gen/feathers/layout/IKeyboardNavigationLayout.js");}
function feathers_data_TreeGridViewCellState() {return __webpack_require__(/*! ./../../feathers/data/TreeGridViewCellState */ "./lib/_gen/feathers/data/TreeGridViewCellState.js");}
function feathers_events_TreeGridViewEvent() {return __webpack_require__(/*! ./../../feathers/events/TreeGridViewEvent */ "./lib/_gen/feathers/events/TreeGridViewEvent.js");}
function feathers_controls_dataRenderers_TreeGridViewRowRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/TreeGridViewRowRenderer */ "./lib/_gen/feathers/controls/dataRenderers/TreeGridViewRowRenderer.js");}
function feathers_utils_ExclusivePointer() {return __webpack_require__(/*! ./../../feathers/utils/ExclusivePointer */ "./lib/_gen/feathers/utils/ExclusivePointer.js");}
function feathers_utils_DisplayUtil() {return __webpack_require__(/*! ./../../feathers/utils/DisplayUtil */ "./lib/_gen/feathers/utils/DisplayUtil.js");}
function openfl_ui_Mouse() {return (__webpack_require__(/*! openfl */ "openfl").ui.Mouse);}
function openfl_display_DisplayObject() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObject);}
function openfl_display_Stage() {return (__webpack_require__(/*! openfl */ "openfl").display.Stage);}
function feathers_utils_DisplayObjectFactory() {return __webpack_require__(/*! ./../../feathers/utils/DisplayObjectFactory */ "./lib/_gen/feathers/utils/DisplayObjectFactory.js");}
function feathers_controls_Button() {return __webpack_require__(/*! ./../../feathers/controls/Button */ "./lib/_gen/feathers/controls/Button.js");}
function feathers_data_TreeGridViewHeaderState() {return __webpack_require__(/*! ./../../feathers/data/TreeGridViewHeaderState */ "./lib/_gen/feathers/data/TreeGridViewHeaderState.js");}
function feathers_controls_TreeGridViewRowState() {return __webpack_require__(/*! ./../../feathers/controls/TreeGridViewRowState */ "./lib/_gen/feathers/controls/TreeGridViewRowState.js");}
function feathers_core_ITextControl() {return __webpack_require__(/*! ./../../feathers/core/ITextControl */ "./lib/_gen/feathers/core/ITextControl.js");}
function feathers_layout_VirtualLayoutRange() {return __webpack_require__(/*! ./../../feathers/layout/VirtualLayoutRange */ "./lib/_gen/feathers/layout/VirtualLayoutRange.js");}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}
function haxe_ds_ObjectMap() {return __webpack_require__(/*! ./../../haxe/ds/ObjectMap */ "./lib/_gen/haxe/ds/ObjectMap.js");}
function feathers_utils_DisplayObjectRecycler() {return __webpack_require__(/*! ./../../feathers/utils/DisplayObjectRecycler */ "./lib/_gen/feathers/utils/DisplayObjectRecycler.js");}
function feathers_controls_dataRenderers_HierarchicalItemRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/HierarchicalItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/HierarchicalItemRenderer.js");}
function openfl_geom_Rectangle() {return (__webpack_require__(/*! openfl */ "openfl").geom.Rectangle);}
function feathers_controls__$TreeGridView_ColumnDividerStorage() {return __webpack_require__(/*! ./../../feathers/controls/_TreeGridView/ColumnDividerStorage */ "./lib/_gen/feathers/controls/_TreeGridView/ColumnDividerStorage.js");}
function feathers_controls__$TreeGridView_HeaderDividerStorage() {return __webpack_require__(/*! ./../../feathers/controls/_TreeGridView/HeaderDividerStorage */ "./lib/_gen/feathers/controls/_TreeGridView/HeaderDividerStorage.js");}
function feathers_controls__$TreeGridView_HeaderRendererStorage() {return __webpack_require__(/*! ./../../feathers/controls/_TreeGridView/HeaderRendererStorage */ "./lib/_gen/feathers/controls/_TreeGridView/HeaderRendererStorage.js");}
function feathers_controls_dataRenderers_SortOrderHeaderRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/SortOrderHeaderRenderer */ "./lib/_gen/feathers/controls/dataRenderers/SortOrderHeaderRenderer.js");}
function feathers_controls_supportClasses_AdvancedLayoutViewPort() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/AdvancedLayoutViewPort */ "./lib/_gen/feathers/controls/supportClasses/AdvancedLayoutViewPort.js");}

// Constructor

var TreeGridView = function(dataProvider,columns,changeListener) {
	this.__showHeaderDividersOnlyWhenResizable = false;
	this.__extendedScrollBarY = false;
	this.__columnResizeSkin = null;
	this.__layout = null;
	this.__customColumnDividerVariant = null;
	this.__columnDividerFactory = null;
	this.__customHeaderDividerVariant = null;
	this.__headerDividerFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_Button().default));
	this.__customHeaderRendererVariant = null;
	this.__customCellRendererVariant = null;
	this._pendingScrollDuration = null;
	this._pendingScrollLocation = null;
	this._ignoreHeaderLayoutChanges = false;
	this._ignoreLayoutChanges = false;
	this._ignoreOpenedChange = false;
	this._ignoreSelectionChange = false;
	this._selectable = true;
	this._tempVisibleIndices = new (feathers_layout_VirtualLayoutRange().default)(0,0);
	this._visibleIndices = new (feathers_layout_VirtualLayoutRange().default)(0,0);
	this._virtualCache = [];
	this._totalRowLayoutCount = 0;
	this._rowLayoutItems = [];
	this._unrenderedLayoutIndices = [];
	this._unrenderedLocations = [];
	this.rowStatePool = new (lime_utils_ObjectPool().default)(function() {
		return new (feathers_controls_TreeGridViewRowState().default)();
	});
	this.headerStatePool = new (lime_utils_ObjectPool().default)(function() {
		return new (feathers_data_TreeGridViewHeaderState().default)();
	});
	this.rowRendererToRowState = new (haxe_ds_ObjectMap().default)();
	this.dataToRowRenderer = new (haxe_ds_ObjectMap().default)();
	this.activeRowRenderers = [];
	this.inactiveRowRenderers = [];
	this.headerRendererToHeaderState = new (haxe_ds_ObjectMap().default)();
	this.dataToHeaderRenderer = new (haxe_ds_ObjectMap().default)();
	this._resizableColumns = false;
	this._cellRendererRecycler = (feathers_utils_DisplayObjectRecycler().default).withClass((feathers_controls_dataRenderers_HierarchicalItemRenderer().default));
	this._virtualLayout = true;
	this._selectedItem = null;
	this._selectedLocation = null;
	this._forceItemStateUpdate = false;
	this._rowRendererRecycler = (feathers_utils_DisplayObjectRecycler().default).withClass((feathers_controls_dataRenderers_TreeGridViewRowRenderer().default));
	this._previousCustomHeaderRendererVariant = null;
	this._columns = null;
	this._autoPopulatedColumns = null;
	this.openBranches = [];
	this._childFocusEnabled = true;
	this._headerScrollRect2 = new (openfl_geom_Rectangle())();
	this._headerScrollRect1 = new (openfl_geom_Rectangle())();
	this._columnDividerLayoutItems = [];
	this._defaultColumnDividerStorage = new (feathers_controls__$TreeGridView_ColumnDividerStorage().default)();
	this._headerDividerLayoutItems = [];
	this._defaultHeaderDividerStorage = new (feathers_controls__$TreeGridView_HeaderDividerStorage().default)((feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_Button().default)));
	this._headerLayoutItems = [];
	this._unrenderedHeaderData = [];
	this._defaultHeaderStorage = new (feathers_controls__$TreeGridView_HeaderRendererStorage().default)((feathers_utils_DisplayObjectRecycler().default).withClass((feathers_controls_dataRenderers_SortOrderHeaderRenderer().default)));
	this._resizingHeaderTouchPointIsMouse = false;
	this._resizingHeaderTouchPointID = null;
	this._resizingHeaderIndex = -1;
	this.initializeTreeGridViewTheme();
	(feathers_controls_supportClasses_BaseScrollContainer().default).call(this);
	this.set_dataProvider(dataProvider);
	this.set_columns(columns);
	this.set_tabEnabled(true);
	this.focusRect = null;
	if(this.get_viewPort() == null) {
		this.treeGridViewPort = new (feathers_controls_supportClasses_AdvancedLayoutViewPort().default)();
		this.addChild(this.treeGridViewPort);
		this.set_viewPort(this.treeGridViewPort);
	}
	if(changeListener != null) {
		this.addEventListener("change",changeListener);
	}
}

// Meta

TreeGridView.__name__ = "feathers.controls.TreeGridView";
TreeGridView.__isInterface__ = false;
TreeGridView.__interfaces__ = [(feathers_core_IFocusContainer().default),(feathers_core_IDataSelector().default)];
TreeGridView.__super__ = (feathers_controls_supportClasses_BaseScrollContainer().default);
TreeGridView.prototype = $extend((feathers_controls_supportClasses_BaseScrollContainer().default).prototype, {
	get_tabEnabled: function() {
		if((this._selectable || this.get_maxScrollY() != this.get_minScrollY() || this.get_maxScrollX() != this.get_minScrollX()) && this._enabled) {
			return this.get_rawTabEnabled();
		} else {
			return false;
		}
	},
	get_childFocusEnabled: function() {
		if(this._enabled) {
			return this._childFocusEnabled;
		} else {
			return false;
		}
	},
	set_childFocusEnabled: function(value) {
		if(this._childFocusEnabled == value) {
			return this._childFocusEnabled;
		}
		this._childFocusEnabled = value;
		return this._childFocusEnabled;
	},
	get_dataProvider: function() {
		return this._dataProvider;
	},
	set_dataProvider: function(value) {
		if(this._dataProvider == value) {
			return this._dataProvider;
		}
		this._virtualCache.length = 0;
		this._totalRowLayoutCount = 0;
		this.openBranches.length = 0;
		if(this._dataProvider != null) {
			this._dataProvider.removeEventListener("change",$bind(this,this.treeGridView_dataProvider_changeHandler));
			this._dataProvider.removeEventListener("addItem",$bind(this,this.treeGridView_dataProvider_addItemHandler));
			this._dataProvider.removeEventListener("removeItem",$bind(this,this.treeGridView_dataProvider_removeItemHandler));
			this._dataProvider.removeEventListener("replaceItem",$bind(this,this.treeGridView_dataProvider_replaceItemHandler));
			this._dataProvider.removeEventListener("removeAll",$bind(this,this.treeGridView_dataProvider_removeAllHandler));
			this._dataProvider.removeEventListener("reset",$bind(this,this.treeGridView_dataProvider_resetHandler));
			this._dataProvider.removeEventListener("filterChange",$bind(this,this.treeGridView_dataProvider_filterChangeHandler));
			this._dataProvider.removeEventListener("sortChange",$bind(this,this.treeGridView_dataProvider_sortChangeHandler));
			this._dataProvider.removeEventListener("updateItem",$bind(this,this.treeGridView_dataProvider_updateItemHandler));
			this._dataProvider.removeEventListener("updateAll",$bind(this,this.treeGridView_dataProvider_updateAllHandler));
		}
		this._dataProvider = value;
		if(this._dataProvider != null) {
			this._totalRowLayoutCount = this.calculateTotalLayoutCount([]);
			this._virtualCache.length = this._totalRowLayoutCount;
			this._dataProvider.addEventListener("change",$bind(this,this.treeGridView_dataProvider_changeHandler));
			this._dataProvider.addEventListener("addItem",$bind(this,this.treeGridView_dataProvider_addItemHandler));
			this._dataProvider.addEventListener("removeItem",$bind(this,this.treeGridView_dataProvider_removeItemHandler));
			this._dataProvider.addEventListener("replaceItem",$bind(this,this.treeGridView_dataProvider_replaceItemHandler));
			this._dataProvider.addEventListener("removeAll",$bind(this,this.treeGridView_dataProvider_removeAllHandler));
			this._dataProvider.addEventListener("reset",$bind(this,this.treeGridView_dataProvider_resetHandler));
			this._dataProvider.addEventListener("filterChange",$bind(this,this.treeGridView_dataProvider_filterChangeHandler));
			this._dataProvider.addEventListener("sortChange",$bind(this,this.treeGridView_dataProvider_sortChangeHandler));
			this._dataProvider.addEventListener("updateItem",$bind(this,this.treeGridView_dataProvider_updateItemHandler));
			this._dataProvider.addEventListener("updateAll",$bind(this,this.treeGridView_dataProvider_updateAllHandler));
		}
		this.set_scrollX(0.0);
		this.set_scrollY(0.0);
		this.set_selectedLocation(null);
		if(this._autoPopulatedColumns != null) {
			this._autoPopulatedColumns = null;
			this.set_columns(null);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._dataProvider;
	},
	get_columns: function() {
		return this._columns;
	},
	set_columns: function(value) {
		if(this._columns == value) {
			return this._columns;
		}
		if(this._columns != null) {
			this._columns.removeEventListener("change",$bind(this,this.treeGridView_columns_changeHandler));
			this._columns.removeEventListener("addItem",$bind(this,this.treeGridView_columns_addItemHandler));
			this._columns.removeEventListener("removeItem",$bind(this,this.treeGridView_columns_removeItemHandler));
		}
		this._columns = value;
		if(this._columns != null) {
			this._columns.addEventListener("change",$bind(this,this.treeGridView_columns_changeHandler));
			this._columns.addEventListener("addItem",$bind(this,this.treeGridView_columns_addItemHandler));
			this._columns.addEventListener("removeItem",$bind(this,this.treeGridView_columns_removeItemHandler));
		}
		this._autoPopulatedColumns = null;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._columns;
	},
	get_headerRendererRecycler: function() {
		return this._defaultHeaderStorage.headerRendererRecycler;
	},
	set_headerRendererRecycler: function(value) {
		if(this._defaultHeaderStorage.headerRendererRecycler == value) {
			return this._defaultHeaderStorage.headerRendererRecycler;
		}
		this._defaultHeaderStorage.oldHeaderRendererRecycler = this._defaultHeaderStorage.headerRendererRecycler;
		this._defaultHeaderStorage.headerRendererRecycler = value;
		this.setInvalid(TreeGridView.INVALIDATION_FLAG_HEADER_RENDERER_FACTORY);
		return this._defaultHeaderStorage.headerRendererRecycler;
	},
	get_forceItemStateUpdate: function() {
		return this._forceItemStateUpdate;
	},
	set_forceItemStateUpdate: function(value) {
		if(this._forceItemStateUpdate == value) {
			return this._forceItemStateUpdate;
		}
		this._forceItemStateUpdate = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._forceItemStateUpdate;
	},
	get_selectedLocation: function() {
		return this._selectedLocation;
	},
	set_selectedLocation: function(value) {
		if(!this._selectable || this._dataProvider == null) {
			value = null;
		}
		if(this._selectedLocation == value || this.compareLocations(this._selectedLocation,value) == 0) {
			return this._selectedLocation;
		}
		this._selectedLocation = value;
		if(this._selectedLocation == null) {
			this._selectedItem = null;
		} else {
			this._selectedItem = this._dataProvider.get(this._selectedLocation);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedLocation;
	},
	get_selectedItem: function() {
		return this._selectedItem;
	},
	set_selectedItem: function(value) {
		if(value == null || !this._selectable || this._dataProvider == null) {
			this.set_selectedLocation(null);
			return this._selectedItem;
		}
		var location = this._dataProvider.locationOf(value);
		if(this._selectedItem == value && this.compareLocations(this._selectedLocation,location) == 0) {
			return this._selectedItem;
		}
		this._selectedItem = value;
		this._selectedLocation = location;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedItem;
	},
	get_virtualLayout: function() {
		return this._virtualLayout;
	},
	set_virtualLayout: function(value) {
		if(this._virtualLayout = value) {
			return this._virtualLayout;
		}
		this._virtualLayout = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		return this._virtualLayout;
	},
	get_cellRendererRecycler: function() {
		return this._cellRendererRecycler;
	},
	set_cellRendererRecycler: function(value) {
		if(this._cellRendererRecycler == value) {
			return this._cellRendererRecycler;
		}
		this._cellRendererRecycler = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._cellRendererRecycler;
	},
	get_resizableColumns: function() {
		return this._resizableColumns;
	},
	set_resizableColumns: function(value) {
		if(this._resizableColumns == value) {
			return this._resizableColumns;
		}
		this._resizableColumns = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		return this._resizableColumns;
	},
	get_selectable: function() {
		return this._selectable;
	},
	set_selectable: function(value) {
		if(this._selectable == value) {
			return this._selectable;
		}
		this._selectable = value;
		if(!this._selectable) {
			this.set_selectedLocation(null);
		}
		return this._selectable;
	},
	scrollToLocation: function(location,animationDuration) {
		if(this._dataProvider == null || this._dataProvider.getLength() == 0) {
			return;
		}
		this._pendingScrollLocation = location;
		this._pendingScrollDuration = animationDuration;
		this.setInvalid((feathers_core_InvalidationFlag().default).SCROLL);
	},
	itemAndColumnToCellRenderer: function(item,column) {
		if(item == null) {
			return null;
		}
		var rowRenderer = this.dataToRowRenderer.get(item);
		if(rowRenderer == null) {
			return null;
		}
		return rowRenderer.columnToCellRenderer(column);
	},
	columnToHeaderRenderer: function(column) {
		return this.dataToHeaderRenderer.get(column);
	},
	headerRendererToColumn: function(headerRenderer) {
		var state = this.headerRendererToHeaderState.get(headerRenderer);
		if(state == null) {
			return null;
		}
		return state.column;
	},
	isBranchOpen: function(branch) {
		if(this._dataProvider == null || !this._dataProvider.contains(branch)) {
			return false;
		}
		if(this._dataProvider.isBranch(branch)) {
			return this.openBranches.indexOf(branch) != -1;
		} else {
			return false;
		}
	},
	toggleBranch: function(branch,open) {
		var location = this._dataProvider != null ? this._dataProvider.locationOf(branch) : null;
		if(location == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Cannot open branch because it is not in the data provider."));
		}
		if(!this._dataProvider.isBranch(branch)) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Cannot open item because it is not a branch."));
		}
		var alreadyOpen = this.openBranches.indexOf(branch) != -1;
		if(open && alreadyOpen || !open && !alreadyOpen) {
			return;
		}
		var layoutIndex = this.locationToDisplayIndex(location,false);
		this.toggleBranchInternal(branch,location,layoutIndex,open);
		this._totalRowLayoutCount = this.calculateTotalLayoutCount([]);
	},
	toggleChildrenOf: function(branch,open) {
		var location = this._dataProvider != null ? this._dataProvider.locationOf(branch) : null;
		if(location == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Cannot open branch because it is not in the data provider."));
		}
		if(!this._dataProvider.isBranch(branch)) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Cannot open item because it is not a branch."));
		}
		var layoutIndex = this.locationToDisplayIndex(location,false);
		this.toggleChildrenOfInternal(branch,location,layoutIndex,open);
		this._totalRowLayoutCount = this.calculateTotalLayoutCount([]);
	},
	initializeTreeGridViewTheme: function() {
		(feathers_themes_steel_components_SteelTreeGridViewStyles().default).initialize();
	},
	initialize: function() {
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.initialize.call(this);
		if(this._headerContainerLayout == null) {
			this._headerContainerLayout = new (feathers_layout_GridViewRowLayout().default)();
		}
		if(this._headerContainer == null) {
			this._headerContainer = new (feathers_controls_LayoutGroup().default)();
			this._headerContainer.set_layout(this._headerContainerLayout);
			this.addChild(this._headerContainer);
		}
		if(this._headerResizeContainer == null) {
			this._headerResizeContainer = new (openfl_display_Sprite())();
			this.addChild(this._headerResizeContainer);
		}
		if(this._columnDividerContainer == null) {
			this._columnDividerContainer = new (openfl_display_Sprite())();
			this._columnDividerContainer.mouseEnabled = false;
			this._columnDividerContainer.mouseChildren = false;
			this.addChild(this._columnDividerContainer);
		}
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var layoutInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(this._previousCustomHeaderRendererVariant != this.get_customHeaderRendererVariant()) {
			this.setInvalidationFlag(TreeGridView.INVALIDATION_FLAG_HEADER_RENDERER_FACTORY);
		}
		var headerRendererInvalid = this.isInvalid(TreeGridView.INVALIDATION_FLAG_HEADER_RENDERER_FACTORY);
		if(this._defaultHeaderDividerStorage.headerDividerFactory != this.get_headerDividerFactory()) {
			this._defaultHeaderDividerStorage.oldHeaderDividerFactory = this._defaultHeaderDividerStorage.headerDividerFactory;
			this._defaultHeaderDividerStorage.headerDividerFactory = this.get_headerDividerFactory();
			this.setInvalidationFlag(TreeGridView.INVALIDATION_FLAG_HEADER_DIVIDER_FACTORY);
		}
		if(this._defaultHeaderDividerStorage.customHeaderDividerVariant != this.get_customHeaderDividerVariant()) {
			this._defaultHeaderDividerStorage.customHeaderDividerVariant = this.get_customHeaderDividerVariant();
			this.setInvalidationFlag(TreeGridView.INVALIDATION_FLAG_HEADER_DIVIDER_FACTORY);
		}
		var headerDividerInvalid = this.isInvalid(TreeGridView.INVALIDATION_FLAG_HEADER_DIVIDER_FACTORY);
		if(this._defaultColumnDividerStorage.columnDividerFactory != this.get_columnDividerFactory()) {
			this._defaultColumnDividerStorage.oldColumnDividerFactory = this._defaultColumnDividerStorage.columnDividerFactory;
			this._defaultColumnDividerStorage.columnDividerFactory = this.get_columnDividerFactory();
			this.setInvalidationFlag(TreeGridView.INVALIDATION_FLAG_COLUMN_DIVIDER_FACTORY);
		}
		if(this._defaultColumnDividerStorage.customColumnDividerVariant != this.get_customColumnDividerVariant()) {
			this._defaultColumnDividerStorage.customColumnDividerVariant = this.get_customColumnDividerVariant();
			this.setInvalidationFlag(TreeGridView.INVALIDATION_FLAG_COLUMN_DIVIDER_FACTORY);
		}
		var columnDividerInvalid = this.isInvalid(TreeGridView.INVALIDATION_FLAG_COLUMN_DIVIDER_FACTORY);
		this.validateColumns();
		if(stylesInvalid || layoutInvalid) {
			this.refreshColumnResizeSkin();
		}
		if(headerRendererInvalid || stateInvalid || dataInvalid) {
			this.refreshHeaderRenderers();
		}
		if(headerDividerInvalid || stateInvalid || dataInvalid) {
			this.refreshHeaderDividers();
		}
		if(columnDividerInvalid || stateInvalid || dataInvalid) {
			this.refreshColumnDividers();
		}
		if(layoutInvalid) {
			this._headerResizeContainer.mouseEnabled = this._resizableColumns;
			this._headerResizeContainer.mouseChildren = this._resizableColumns;
			var oldIgnoreHeaderLayoutChanges = this._ignoreHeaderLayoutChanges;
			this._ignoreHeaderLayoutChanges = true;
			this._headerContainerLayout.set_customColumnWidths(this._customColumnWidths);
			this._ignoreHeaderLayoutChanges = oldIgnoreHeaderLayoutChanges;
		}
		if(layoutInvalid || stylesInvalid) {
			if(this._previousLayout != this.get_layout()) {
				this._virtualCache.length = 0;
				this._virtualCache.length = this._totalRowLayoutCount;
			}
			this.treeGridViewPort.set_layout(this.get_layout());
			this._previousLayout = this.get_layout();
		}
		this.treeGridViewPort.refreshChildren = $bind(this,this.refreshRowRenderers);
		var flag = this._invalidationFlags.keys();
		while(flag.hasNext()) {
			var flag1 = flag.next();
			this.treeGridViewPort.setInvalid(flag1);
		}
		if(this._allInvalid) {
			this.treeGridViewPort.setInvalid();
		}
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.update.call(this);
		this._previousCustomHeaderRendererVariant = this.get_customHeaderRendererVariant();
		this.validateCustomColumnWidths();
		this.layoutHeaders();
		this.layoutHeaderDividers();
		this.layoutColumnDividers();
		this.handlePendingScroll();
	},
	createScroller: function() {
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.createScroller.call(this);
		this.treeGridViewPort.set_scroller(this.scroller);
	},
	refreshScrollerValues: function() {
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.refreshScrollerValues.call(this);
		if((js_Boot().default).__implements(this.get_layout(),(feathers_layout_IScrollLayout().default))) {
			var scrollLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_IScrollLayout().default));
			this.scroller.forceElasticTop = scrollLayout.get_elasticTop();
			this.scroller.forceElasticRight = scrollLayout.get_elasticRight();
			this.scroller.forceElasticBottom = scrollLayout.get_elasticBottom();
			this.scroller.forceElasticLeft = scrollLayout.get_elasticLeft();
		} else {
			this.scroller.forceElasticTop = false;
			this.scroller.forceElasticRight = false;
			this.scroller.forceElasticBottom = false;
			this.scroller.forceElasticLeft = false;
		}
		this.scroller.snapPositionsX = this.treeGridViewPort.get_snapPositionsX();
		this.scroller.snapPositionsY = this.treeGridViewPort.get_snapPositionsY();
	},
	needsScrollMeasurement: function() {
		var oldStart = this._visibleIndices.start;
		var oldEnd = this._visibleIndices.end;
		if(this._virtualLayout && (js_Boot().default).__implements(this.get_layout(),(feathers_layout_IVirtualLayout().default))) {
			var virtualLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_IVirtualLayout().default));
			var oldIgnoreLayoutChanges = this._ignoreLayoutChanges;
			this._ignoreLayoutChanges = true;
			virtualLayout.set_scrollX(this.scroller.get_scrollX());
			virtualLayout.set_scrollY(this.scroller.get_scrollY());
			this._ignoreLayoutChanges = oldIgnoreLayoutChanges;
			virtualLayout.getVisibleIndices(this._rowLayoutItems.length,this.treeGridViewPort.get_visibleWidth(),this.treeGridViewPort.get_visibleHeight(),this._tempVisibleIndices);
		} else {
			this._tempVisibleIndices.start = 0;
			this._tempVisibleIndices.end = this._rowLayoutItems.length - 1;
		}
		if(oldStart == this._tempVisibleIndices.start) {
			return oldEnd != this._tempVisibleIndices.end;
		} else {
			return true;
		}
	},
	calculateViewPortOffsets: function(forceScrollBars,useActualBounds) {
		var oldTopViewPortOffset = this.topViewPortOffset;
		var oldRightViewPortOffset = this.rightViewPortOffset;
		var oldBottomViewPortOffset = this.bottomViewPortOffset;
		var oldLeftViewPortOffset = this.leftViewPortOffset;
		if(this.get_fixedScrollBars() && this.get_showScrollBars()) {
			(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.calculateViewPortOffsets.call(this,forceScrollBars,useActualBounds);
		}
		if(this._headerContainer != null) {
			var oldIgnoreHeaderLayoutChanges = this._ignoreHeaderLayoutChanges;
			this._ignoreHeaderLayoutChanges = true;
			if(this.get_scrollBarYPosition()._hx_index == 3) {
				this._headerContainerLayout.set_paddingLeft(this.leftViewPortOffset);
				this._headerContainerLayout.set_paddingRight(0.0);
			} else {
				this._headerContainerLayout.set_paddingLeft(0.0);
				this._headerContainerLayout.set_paddingRight(this.rightViewPortOffset);
			}
			this._ignoreHeaderLayoutChanges = oldIgnoreHeaderLayoutChanges;
			this.topViewPortOffset = oldTopViewPortOffset;
			this.rightViewPortOffset = oldRightViewPortOffset;
			this.bottomViewPortOffset = oldBottomViewPortOffset;
			this.leftViewPortOffset = oldLeftViewPortOffset;
			this._headerContainer.validateNow();
			this.topViewPortOffset += this._headerContainer.get_height();
			this.chromeMeasuredWidth = Math.max(this.chromeMeasuredWidth,this._headerContainer.get_width());
			this.chromeMeasuredMinWidth = Math.max(this.chromeMeasuredMinWidth,this._headerContainer.get_width());
			(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.calculateViewPortOffsets.call(this,forceScrollBars,useActualBounds);
			var oldIgnoreHeaderLayoutChanges1 = this._ignoreHeaderLayoutChanges;
			this._ignoreHeaderLayoutChanges = true;
			if(this.get_scrollBarYPosition()._hx_index == 3) {
				this._headerContainerLayout.set_paddingLeft(this.leftViewPortOffset);
				this._headerContainerLayout.set_paddingRight(0.0);
			} else {
				this._headerContainerLayout.set_paddingLeft(0.0);
				this._headerContainerLayout.set_paddingRight(this.rightViewPortOffset);
			}
			this._ignoreHeaderLayoutChanges = oldIgnoreHeaderLayoutChanges1;
		}
	},
	validateColumns: function() {
		var _gthis = this;
		if(this._columns != null) {
			return;
		}
		var newColumns = null;
		if(this._dataProvider != null && this._dataProvider.getLength() > 0) {
			var item = this._dataProvider.get([0]);
			var _this = (Reflect().default).fields(item);
			var result = new Array(_this.length);
			var _g = 0;
			var _g1 = _this.length;
			while(_g < _g1) {
				var i = _g++;
				var fieldName = [_this[i]];
				result[i] = new (feathers_controls_TreeGridViewColumn().default)(fieldName[0],(function(fieldName1) {
					return function(item1) {
						return (Std().default).string((Reflect().default).getProperty(item1,fieldName1[0]));
					};
				})(fieldName));
			}
			newColumns = new (feathers_data_ArrayCollection().default)(result);
		} else {
			newColumns = new (feathers_data_ArrayCollection().default)();
		}
		this.runWithInvalidationFlagsOnly(function() {
			return _gthis.set_columns(newColumns);
		});
		this._autoPopulatedColumns = newColumns;
	},
	layoutHeaders: function() {
		if(this._headerContainer == null) {
			return;
		}
		this._headerContainer.set_x(this.get_paddingLeft());
		this._headerContainer.set_y(this.get_paddingTop());
		var minHeaderWidth = this.actualWidth - this.get_paddingLeft() - this.get_paddingRight();
		this._headerContainer.set_width(Math.max(this._viewPort.get_width() + this._headerContainerLayout.get_paddingLeft() + this._headerContainerLayout.get_paddingRight(),minHeaderWidth));
		this._headerContainer.validateNow();
		if(!(feathers_utils_MathUtil().default).fuzzyEquals(this.get_maxScrollX(),this.get_minScrollX())) {
			var scrollRect = this._scrollRect1;
			if(this._currentScrollRect == scrollRect) {
				scrollRect = this._scrollRect2;
			}
			this._currentScrollRect = scrollRect;
			var scrollRectWidth = minHeaderWidth;
			if(scrollRectWidth < 0.0) {
				scrollRectWidth = 0.0;
			}
			var scrollRectHeight = this._headerContainer.get_height();
			if(scrollRectHeight < 0.0) {
				scrollRectHeight = 0.0;
			}
			scrollRect.setTo(this.get_scrollX() - this.get_minScrollX(),0.0,scrollRectWidth,scrollRectHeight);
			this._headerContainer.set_scrollRect(scrollRect);
		} else {
			this._headerContainer.set_scrollRect(null);
		}
	},
	layoutHeaderDividers: function() {
		this._headerResizeContainer.set_x(this._headerContainer.get_x());
		this._headerResizeContainer.set_y(this._headerContainer.get_y());
		var _g = 0;
		var _g1 = this._headerDividerLayoutItems.length;
		while(_g < _g1) {
			var i = _g++;
			var headerDivider = this._headerDividerLayoutItems[i];
			headerDivider.set_visible(!this.get_showHeaderDividersOnlyWhenResizable() || this.get_resizableColumns());
			if((js_Boot().default).__implements(headerDivider,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(headerDivider , (feathers_core_IValidating().default))).validateNow();
			}
			var headerRenderer = this._headerLayoutItems[i];
			headerDivider.set_x(headerRenderer.get_x() + headerRenderer.get_width() - headerDivider.get_width() / 2.0);
			headerDivider.set_y(headerRenderer.get_y());
			headerDivider.set_height(headerRenderer.get_height());
		}
	},
	layoutColumnDividers: function() {
		this._columnDividerContainer.set_x(this._viewPort.get_x());
		this._columnDividerContainer.set_y(this._viewPort.get_y());
		var _g = 0;
		var _g1 = this._columnDividerLayoutItems.length;
		while(_g < _g1) {
			var i = _g++;
			var columnDivider = this._columnDividerLayoutItems[i];
			if((js_Boot().default).__implements(columnDivider,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(columnDivider , (feathers_core_IValidating().default))).validateNow();
			}
			var headerRenderer = this._headerLayoutItems[i];
			columnDivider.set_x(headerRenderer.get_x() + headerRenderer.get_width() - columnDivider.get_width() / 2.0);
			columnDivider.set_y(headerRenderer.get_y());
			columnDivider.set_height(this._viewPort.get_visibleHeight());
		}
	},
	layoutScrollBars: function() {
		if(!this.get_extendedScrollBarY()) {
			(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.layoutScrollBars.call(this);
			return;
		}
		var oldTopViewPortOffset = this.topViewPortOffset;
		this.topViewPortOffset = 0.0;
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.layoutScrollBars.call(this);
		this.topViewPortOffset = oldTopViewPortOffset;
	},
	refreshColumnResizeSkin: function() {
		var oldSkin = this._currentColumnResizeSkin;
		this._currentColumnResizeSkin = this.getCurrentColumnResizeSkin();
		if(this._currentColumnResizeSkin == oldSkin) {
			return;
		}
		this.removeCurrentColumnResizeSkin(oldSkin);
		if(this._currentColumnResizeSkin == null) {
			return;
		}
		if((js_Boot().default).__implements(this._currentColumnResizeSkin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._currentColumnResizeSkin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if((js_Boot().default).__implements(this._currentColumnResizeSkin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(this._currentColumnResizeSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this._currentColumnResizeSkin.set_visible(false);
		if(((this._currentColumnResizeSkin) instanceof (openfl_display_InteractiveObject()))) {
			((js_Boot().default).__cast(this._currentColumnResizeSkin , (openfl_display_InteractiveObject()))).mouseEnabled = false;
		}
		if(((this._currentColumnResizeSkin) instanceof (openfl_display_DisplayObjectContainer()))) {
			((js_Boot().default).__cast(this._currentColumnResizeSkin , (openfl_display_DisplayObjectContainer()))).mouseChildren = false;
		}
		this.addChildAt(this._currentColumnResizeSkin,0);
	},
	getCurrentColumnResizeSkin: function() {
		return this.get_columnResizeSkin();
	},
	removeCurrentColumnResizeSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		if(skin.parent == this) {
			this.removeChild(skin);
		}
	},
	refreshHeaderRenderers: function() {
		var oldIgnoreHeaderLayoutChanges = this._ignoreHeaderLayoutChanges;
		this._ignoreHeaderLayoutChanges = true;
		this._headerContainerLayout.set_columns(this._columns);
		this._ignoreHeaderLayoutChanges = oldIgnoreHeaderLayoutChanges;
		if(this._defaultHeaderStorage.headerRendererRecycler.update == null) {
			this._defaultHeaderStorage.headerRendererRecycler.update = TreeGridView.defaultUpdateHeaderRenderer;
			if(this._defaultHeaderStorage.headerRendererRecycler.reset == null) {
				this._defaultHeaderStorage.headerRendererRecycler.reset = TreeGridView.defaultResetHeaderRenderer;
			}
		}
		var headerRendererInvalid = this.isInvalid(TreeGridView.INVALIDATION_FLAG_HEADER_RENDERER_FACTORY);
		this.refreshInactiveHeaderRenderers(headerRendererInvalid);
		this.findUnrenderedHeaderData();
		this.recoverInactiveHeaderRenderers();
		this.renderUnrenderedHeaderData();
		this.freeInactiveHeaderRenderers();
		if(this._defaultHeaderStorage.inactiveHeaderRenderers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive header renderers should be empty after updating."));
		}
	},
	refreshHeaderDividers: function() {
		var headerDividerInvalid = this.isInvalid(TreeGridView.INVALIDATION_FLAG_HEADER_DIVIDER_FACTORY);
		this.refreshInactiveHeaderDividers(headerDividerInvalid);
		this.refreshActiveHeaderDividers();
		this.freeInactiveHeaderDividers();
		if(this._defaultHeaderDividerStorage.inactiveHeaderDividers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive header dividers should be empty after updating."));
		}
	},
	refreshColumnDividers: function() {
		var columnDividerInvalid = this.isInvalid(TreeGridView.INVALIDATION_FLAG_COLUMN_DIVIDER_FACTORY);
		this.refreshInactiveColumnDividers(columnDividerInvalid);
		this.refreshActiveColumnDividers();
		this.freeInactiveColumnDividers();
		if(this._defaultColumnDividerStorage.inactiveColumnDividers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive column dividers should be empty after updating."));
		}
	},
	refreshInactiveHeaderDividers: function(factoryInvalid) {
		var temp = this._defaultHeaderDividerStorage.inactiveHeaderDividers;
		this._defaultHeaderDividerStorage.inactiveHeaderDividers = this._defaultHeaderDividerStorage.activeHeaderDividers;
		this._defaultHeaderDividerStorage.activeHeaderDividers = temp;
		if(this._defaultHeaderDividerStorage.activeHeaderDividers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": active header dividers should be empty before updating."));
		}
		if(factoryInvalid) {
			this.freeInactiveHeaderDividers();
			this._defaultHeaderDividerStorage.oldHeaderDividerFactory = null;
		}
	},
	freeInactiveHeaderDividers: function() {
		var factory = this._defaultHeaderDividerStorage.oldHeaderDividerFactory != null ? this._defaultHeaderDividerStorage.oldHeaderDividerFactory : this._defaultHeaderDividerStorage.headerDividerFactory;
		var _g = 0;
		var _g1 = this._defaultHeaderDividerStorage.inactiveHeaderDividers;
		while(_g < _g1.length) {
			var headerDivider = _g1[_g];
			++_g;
			if(headerDivider == null) {
				continue;
			}
			this.destroyHeaderDivider(headerDivider,factory);
		}
		this._defaultHeaderDividerStorage.inactiveHeaderDividers.length = 0;
	},
	refreshActiveHeaderDividers: function() {
		this._headerDividerLayoutItems.length = 0;
		if(this._defaultHeaderDividerStorage.headerDividerFactory == null) {
			return;
		}
		var _g = 0;
		var _g1 = this._columns.get_length() - 1;
		while(_g < _g1) {
			var i = _g++;
			var column = this._columns.get(i);
			var headerDivider = this.createHeaderDivider(column,i);
			this._headerDividerLayoutItems[i] = headerDivider;
			this._defaultHeaderDividerStorage.activeHeaderDividers.push(headerDivider);
		}
	},
	createHeaderDivider: function(column,columnIndex) {
		var headerDivider = null;
		if(this._defaultHeaderDividerStorage.inactiveHeaderDividers.length == 0) {
			headerDivider = this._defaultHeaderDividerStorage.headerDividerFactory.create();
			if((js_Boot().default).__implements(headerDivider,(feathers_style_IVariantStyleObject().default))) {
				var variantHeaderDivider = (js_Boot().default).__cast(headerDivider , (feathers_style_IVariantStyleObject().default));
				if(variantHeaderDivider.get_variant() == null) {
					var variant = this.get_customHeaderDividerVariant() != null ? this.get_customHeaderDividerVariant() : TreeGridView.CHILD_VARIANT_HEADER_DIVIDER;
					variantHeaderDivider.set_variant(variant);
				}
			}
			if((js_Boot().default).__implements(headerDivider,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(headerDivider , (feathers_core_IUIControl().default))).initializeNow();
			}
			headerDivider.addEventListener("rollOver",$bind(this,this.treeGridView_headerDivider_rollOverHandler));
			headerDivider.addEventListener("rollOut",$bind(this,this.treeGridView_headerDivider_rollOutHandler));
			headerDivider.addEventListener("mouseDown",$bind(this,this.treeGridView_headerDivider_mouseDownHandler));
			headerDivider.addEventListener("touchBegin",$bind(this,this.treeGridView_headerDivider_touchBeginHandler));
			this._headerResizeContainer.addChildAt(headerDivider,columnIndex);
		} else {
			headerDivider = this._defaultHeaderDividerStorage.inactiveHeaderDividers.shift();
			this._headerResizeContainer.setChildIndex(headerDivider,columnIndex);
		}
		return headerDivider;
	},
	destroyHeaderDivider: function(headerDivider,factory) {
		headerDivider.removeEventListener("rollOver",$bind(this,this.treeGridView_headerDivider_rollOverHandler));
		headerDivider.removeEventListener("rollOut",$bind(this,this.treeGridView_headerDivider_rollOutHandler));
		headerDivider.removeEventListener("mouseDown",$bind(this,this.treeGridView_headerDivider_mouseDownHandler));
		headerDivider.removeEventListener("touchBegin",$bind(this,this.treeGridView_headerDivider_touchBeginHandler));
		this._headerResizeContainer.removeChild(headerDivider);
		if(factory != null && factory.destroy != null) {
			factory.destroy(headerDivider);
		}
	},
	refreshInactiveColumnDividers: function(factoryInvalid) {
		var temp = this._defaultColumnDividerStorage.inactiveColumnDividers;
		this._defaultColumnDividerStorage.inactiveColumnDividers = this._defaultColumnDividerStorage.activeColumnDividers;
		this._defaultColumnDividerStorage.activeColumnDividers = temp;
		if(this._defaultColumnDividerStorage.activeColumnDividers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": active column dividers should be empty before updating."));
		}
		if(factoryInvalid) {
			this.freeInactiveHeaderDividers();
			this._defaultColumnDividerStorage.oldColumnDividerFactory = null;
		}
	},
	freeInactiveColumnDividers: function() {
		var factory = this._defaultColumnDividerStorage.oldColumnDividerFactory != null ? this._defaultColumnDividerStorage.oldColumnDividerFactory : this._defaultColumnDividerStorage.columnDividerFactory;
		var _g = 0;
		var _g1 = this._defaultColumnDividerStorage.inactiveColumnDividers;
		while(_g < _g1.length) {
			var headerDivider = _g1[_g];
			++_g;
			if(headerDivider == null) {
				continue;
			}
			this.destroyColumnDivider(headerDivider,factory);
		}
		this._defaultColumnDividerStorage.inactiveColumnDividers.length = 0;
	},
	refreshActiveColumnDividers: function() {
		this._columnDividerLayoutItems.length = 0;
		if(this._defaultColumnDividerStorage.columnDividerFactory == null) {
			return;
		}
		var _g = 0;
		var _g1 = this._columns.get_length() - 1;
		while(_g < _g1) {
			var i = _g++;
			var column = this._columns.get(i);
			var columnDivider = this.createColumnDivider(column,i);
			this._columnDividerLayoutItems[i] = columnDivider;
			this._defaultColumnDividerStorage.activeColumnDividers.push(columnDivider);
		}
	},
	createColumnDivider: function(column,columnIndex) {
		var columnDivider = null;
		if(this._defaultColumnDividerStorage.inactiveColumnDividers.length == 0) {
			columnDivider = this._defaultColumnDividerStorage.columnDividerFactory.create();
			if((js_Boot().default).__implements(columnDivider,(feathers_style_IVariantStyleObject().default))) {
				var variantColumnDivider = (js_Boot().default).__cast(columnDivider , (feathers_style_IVariantStyleObject().default));
				if(variantColumnDivider.get_variant() == null) {
					var variant = this.get_customColumnDividerVariant() != null ? this.get_customColumnDividerVariant() : TreeGridView.CHILD_VARIANT_COLUMN_DIVIDER;
					variantColumnDivider.set_variant(variant);
				}
			}
			if((js_Boot().default).__implements(columnDivider,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(columnDivider , (feathers_core_IUIControl().default))).initializeNow();
			}
			this._columnDividerContainer.addChildAt(columnDivider,columnIndex);
		} else {
			columnDivider = this._defaultColumnDividerStorage.inactiveColumnDividers.shift();
			this._columnDividerContainer.setChildIndex(columnDivider,columnIndex);
		}
		return columnDivider;
	},
	destroyColumnDivider: function(columnDivider,factory) {
		this._columnDividerContainer.removeChild(columnDivider);
		if(factory != null && factory.destroy != null) {
			factory.destroy(columnDivider);
		}
	},
	refreshInactiveHeaderRenderers: function(factoryInvalid) {
		var temp = this._defaultHeaderStorage.inactiveHeaderRenderers;
		this._defaultHeaderStorage.inactiveHeaderRenderers = this._defaultHeaderStorage.activeHeaderRenderers;
		this._defaultHeaderStorage.activeHeaderRenderers = temp;
		if(this._defaultHeaderStorage.activeHeaderRenderers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": active header renderers should be empty before updating."));
		}
		if(factoryInvalid) {
			this.recoverInactiveHeaderRenderers();
			this.freeInactiveHeaderRenderers();
			this._defaultHeaderStorage.oldHeaderRendererRecycler = null;
		}
	},
	recoverInactiveHeaderRenderers: function() {
		var _g = 0;
		var _g1 = this._defaultHeaderStorage.inactiveHeaderRenderers;
		while(_g < _g1.length) {
			var headerRenderer = _g1[_g];
			++_g;
			if(headerRenderer == null) {
				continue;
			}
			var state = this.headerRendererToHeaderState.get(headerRenderer);
			if(state == null) {
				continue;
			}
			var column = state.column;
			this.headerRendererToHeaderState.remove(headerRenderer);
			this.dataToHeaderRenderer.remove(column);
			headerRenderer.removeEventListener("trigger",$bind(this,this.treeGridView_headerRenderer_triggerHandler));
			headerRenderer.removeEventListener("click",$bind(this,this.treeGridView_headerRenderer_clickHandler));
			headerRenderer.removeEventListener("touchTap",$bind(this,this.treeGridView_headerRenderer_touchTapHandler));
			headerRenderer.removeEventListener("resize",$bind(this,this.treeGridView_headerRenderer_resizeHandler));
			this.resetHeaderRenderer(headerRenderer,state);
			if(this._defaultHeaderStorage.measurements != null) {
				this._defaultHeaderStorage.measurements.restore(headerRenderer);
			}
			this.headerStatePool.release(state);
		}
	},
	freeInactiveHeaderRenderers: function() {
		var recycler = this._defaultHeaderStorage.oldHeaderRendererRecycler != null ? this._defaultHeaderStorage.oldHeaderRendererRecycler : this._defaultHeaderStorage.headerRendererRecycler;
		var _g = 0;
		var _g1 = this._defaultHeaderStorage.inactiveHeaderRenderers;
		while(_g < _g1.length) {
			var headerRenderer = _g1[_g];
			++_g;
			if(headerRenderer == null) {
				continue;
			}
			this.destroyHeaderRenderer(headerRenderer,recycler);
		}
		this._defaultHeaderStorage.inactiveHeaderRenderers.length = 0;
	},
	findUnrenderedHeaderData: function() {
		this._rowLayoutItems.length = 0;
		if(this._columns == null || this._columns.get_length() == 0) {
			return;
		}
		this._rowLayoutItems.length = this._columns.get_length();
		var _g = 0;
		var _g1 = this._columns.get_length();
		while(_g < _g1) {
			var i = _g++;
			var column = this._columns.get(i);
			var headerRenderer = this.dataToHeaderRenderer.get(column);
			if(headerRenderer != null) {
				var state = this.headerRendererToHeaderState.get(headerRenderer);
				var changed = this.populateCurrentHeaderState(column,i,state,this._forceItemStateUpdate);
				if(changed) {
					this.updateHeaderRenderer(headerRenderer,state);
				}
				headerRenderer.set_visible(true);
				this._headerLayoutItems[i] = headerRenderer;
				var removed = (HxOverrides().default).remove(this._defaultHeaderStorage.inactiveHeaderRenderers,headerRenderer);
				if(!removed) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": header renderer map contains bad data for column at index " + i + ". This may be caused by duplicate columns, which is not allowed."));
				}
				this._defaultHeaderStorage.activeHeaderRenderers.push(headerRenderer);
			} else {
				this._unrenderedHeaderData.push(column);
			}
		}
	},
	renderUnrenderedHeaderData: function() {
		var _g = 0;
		var _g1 = this._unrenderedHeaderData;
		while(_g < _g1.length) {
			var column = _g1[_g];
			++_g;
			var index = this._columns.indexOf(column);
			var state = this.headerStatePool.get();
			this.populateCurrentHeaderState(column,index,state,true);
			var headerRenderer = this.createHeaderRenderer(state);
			headerRenderer.set_visible(true);
			this._headerContainer.addChildAt(headerRenderer,index);
			this._headerLayoutItems[index] = headerRenderer;
		}
		this._unrenderedHeaderData.length = 0;
	},
	refreshRowRenderers: function(items) {
		this._rowLayoutItems = items;
		this.refreshInactiveRowRenderers();
		this.findUnrenderedData();
		this.recoverInactiveRowRenderers();
		this.renderUnrenderedData();
		this.freeInactiveRowRenderers();
		if(this.inactiveRowRenderers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive row renderers should be empty after updating."));
		}
	},
	refreshInactiveRowRenderers: function() {
		var temp = this.inactiveRowRenderers;
		this.inactiveRowRenderers = this.activeRowRenderers;
		this.activeRowRenderers = temp;
		if(this.activeRowRenderers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": active row renderers should be empty before updating."));
		}
	},
	recoverInactiveRowRenderers: function() {
		var _g = 0;
		var _g1 = this.inactiveRowRenderers;
		while(_g < _g1.length) {
			var rowRenderer = _g1[_g];
			++_g;
			if(rowRenderer == null) {
				continue;
			}
			var state = this.rowRendererToRowState.get(rowRenderer);
			if(state == null) {
				continue;
			}
			var item = state.data;
			this.rowRendererToRowState.remove(rowRenderer);
			this.dataToRowRenderer.remove(item);
			rowRenderer.removeEventListener("cellTrigger",$bind(this,this.treeGridView_rowRenderer_cellTriggerHandler));
			rowRenderer.removeEventListener("trigger",$bind(this,this.treeGridView_rowRenderer_triggerHandler));
			rowRenderer.removeEventListener("open",$bind(this,this.treeGridView_rowRenderer_openHandler));
			rowRenderer.removeEventListener("close",$bind(this,this.treeGridView_rowRenderer_closeHandler));
			this.resetRowRenderer(rowRenderer,state);
			if(this._rowRendererMeasurements != null) {
				this._rowRendererMeasurements.restore(rowRenderer);
			}
			this.rowStatePool.release(state);
		}
	},
	freeInactiveRowRenderers: function() {
		var _g = 0;
		var _g1 = this.inactiveRowRenderers;
		while(_g < _g1.length) {
			var rowRenderer = _g1[_g];
			++_g;
			if(rowRenderer == null) {
				continue;
			}
			this.destroyRowRenderer(rowRenderer);
		}
		this.inactiveRowRenderers.length = 0;
	},
	findUnrenderedData: function() {
		this._rowLayoutItems.length = 0;
		this._rowLayoutItems.length = this._totalRowLayoutCount;
		if(this._virtualLayout && (js_Boot().default).__implements(this.get_layout(),(feathers_layout_IVirtualLayout().default))) {
			var virtualLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_IVirtualLayout().default));
			var oldIgnoreLayoutChanges = this._ignoreLayoutChanges;
			this._ignoreLayoutChanges = true;
			virtualLayout.set_scrollX(this.scroller.get_scrollX());
			virtualLayout.set_scrollY(this.scroller.get_scrollY());
			virtualLayout.set_virtualCache(this._virtualCache);
			this._ignoreLayoutChanges = oldIgnoreLayoutChanges;
			virtualLayout.getVisibleIndices(this._rowLayoutItems.length,this.treeGridViewPort.get_visibleWidth(),this.treeGridViewPort.get_visibleHeight(),this._visibleIndices);
		} else {
			this._visibleIndices.start = 0;
			this._visibleIndices.end = this._rowLayoutItems.length - 1;
		}
		this.findUnrenderedDataForLocation([],0);
	},
	findUnrenderedDataForLocation: function(location,layoutIndex) {
		if(this._dataProvider == null) {
			return layoutIndex;
		}
		var _g = 0;
		var _g1 = this._dataProvider.getLength(location);
		while(_g < _g1) {
			var i = _g++;
			location.push(i);
			var item = this._dataProvider.get(location);
			if(layoutIndex < this._visibleIndices.start || layoutIndex > this._visibleIndices.end) {
				this._rowLayoutItems[layoutIndex] = null;
			} else {
				this.findRowRenderer(item,location.slice(),layoutIndex);
			}
			++layoutIndex;
			if(layoutIndex > this._visibleIndices.end) {
				break;
			}
			if(this._dataProvider.isBranch(item) && this.openBranches.indexOf(item) != -1) {
				layoutIndex = this.findUnrenderedDataForLocation(location,layoutIndex);
				if(layoutIndex > this._visibleIndices.end) {
					break;
				}
			}
			location.pop();
		}
		return layoutIndex;
	},
	findRowRenderer: function(item,location,layoutIndex) {
		var rowRenderer = this.dataToRowRenderer.get(item);
		if(rowRenderer == null) {
			this._unrenderedLocations.push(location);
			this._unrenderedLayoutIndices.push(layoutIndex);
			return;
		}
		var state = this.rowRendererToRowState.get(rowRenderer);
		var changed = this.populateCurrentRowState(item,location,layoutIndex,state,this._forceItemStateUpdate);
		if(changed) {
			this.updateRowRenderer(rowRenderer,state);
		}
		rowRenderer.set_visible(true);
		this._rowLayoutItems[layoutIndex] = rowRenderer;
		var removed = (HxOverrides().default).remove(this.inactiveRowRenderers,rowRenderer);
		if(!removed) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": row renderer map contains bad data for item at location " + (Std().default).string(location) + ". This may be caused by duplicate items in the data provider, which is not allowed."));
		}
		this.activeRowRenderers.push(rowRenderer);
	},
	renderUnrenderedData: function() {
		var _g = 0;
		var _g1 = this._unrenderedLocations;
		while(_g < _g1.length) {
			var location = _g1[_g];
			++_g;
			var layoutIndex = this._unrenderedLayoutIndices.shift();
			var item = this._dataProvider.get(location);
			var state = this.rowStatePool.get();
			this.populateCurrentRowState(item,location,layoutIndex,state,true);
			var rowRenderer = this.createRowRenderer(state);
			rowRenderer.set_visible(true);
			this.treeGridViewPort.addChild(rowRenderer);
			this._rowLayoutItems[layoutIndex] = rowRenderer;
		}
		this._unrenderedLocations.length = 0;
	},
	createRowRenderer: function(state) {
		var rowRenderer = null;
		if(this.inactiveRowRenderers.length == 0) {
			rowRenderer = this._rowRendererRecycler.create();
			if(this._rowRendererMeasurements == null) {
				this._rowRendererMeasurements = new (feathers_layout_Measurements().default)(rowRenderer);
			}
			rowRenderer.initializeNow();
		} else {
			rowRenderer = this.inactiveRowRenderers.shift();
		}
		this.updateRowRenderer(rowRenderer,state);
		rowRenderer.set_treeGridView(this);
		rowRenderer.addEventListener("cellTrigger",$bind(this,this.treeGridView_rowRenderer_cellTriggerHandler));
		rowRenderer.addEventListener("trigger",$bind(this,this.treeGridView_rowRenderer_triggerHandler));
		rowRenderer.addEventListener("open",$bind(this,this.treeGridView_rowRenderer_openHandler));
		rowRenderer.addEventListener("close",$bind(this,this.treeGridView_rowRenderer_closeHandler));
		this.rowRendererToRowState.set(rowRenderer,state);
		this.dataToRowRenderer.set(state.data,rowRenderer);
		this.activeRowRenderers.push(rowRenderer);
		return rowRenderer;
	},
	destroyRowRenderer: function(rowRenderer) {
		rowRenderer.set_treeGridView(null);
		this.treeGridViewPort.removeChild(rowRenderer);
		if(this._rowRendererRecycler.destroy != null) {
			this._rowRendererRecycler.destroy(rowRenderer);
		}
	},
	updateRowRenderer: function(rowRenderer,state) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		var oldIgnoreOpenedChange = this._ignoreOpenedChange;
		this._ignoreOpenedChange = true;
		if(this._rowRendererRecycler.update != null) {
			this._rowRendererRecycler.update(rowRenderer,state);
		}
		this._ignoreOpenedChange = oldIgnoreOpenedChange;
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		this.refreshRowRendererProperties(rowRenderer,state);
	},
	resetRowRenderer: function(rowRenderer,state) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		var oldIgnoreOpenedChange = this._ignoreOpenedChange;
		this._ignoreOpenedChange = true;
		if(this._rowRendererRecycler.reset != null) {
			this._rowRendererRecycler.reset(rowRenderer,state);
		}
		this._ignoreOpenedChange = oldIgnoreOpenedChange;
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		this.refreshRowRendererProperties(rowRenderer,TreeGridView.RESET_ROW_STATE);
	},
	populateCurrentRowState: function(item,location,layoutIndex,state,force) {
		var changed = false;
		if(force || state.owner != this) {
			state.owner = this;
			changed = true;
		}
		if(force || state.data != item) {
			state.data = item;
			changed = true;
		}
		if(force || state.rowLocation != location && this.compareLocations(state.rowLocation,location) != 0) {
			state.rowLocation = location;
			changed = true;
		}
		if(force || state.layoutIndex != layoutIndex) {
			state.layoutIndex = layoutIndex;
			changed = true;
		}
		var branch = this._dataProvider != null && this._dataProvider.isBranch(item);
		if(force || state.branch != branch) {
			state.branch = branch;
			changed = true;
		}
		var opened = state.branch && this.openBranches.indexOf(item) != -1;
		if(force || state.opened != opened) {
			state.opened = opened;
			changed = true;
		}
		var selected = this.compareLocations(location,this._selectedLocation) == 0;
		if(force || state.selected != selected) {
			state.selected = selected;
			changed = true;
		}
		var enabled = this._enabled;
		if(force || state.enabled != enabled) {
			state.enabled = enabled;
			changed = true;
		}
		var columns = this._columns;
		if(force || state.columns != columns) {
			state.columns = columns;
			changed = true;
		}
		var selectable = this._selectable;
		if(force || state.selectable != selectable) {
			state.selectable = selectable;
			changed = true;
		}
		var cellRendererRecycler = this._cellRendererRecycler;
		if(force || state.cellRendererRecycler != cellRendererRecycler) {
			state.cellRendererRecycler = cellRendererRecycler;
			changed = true;
		}
		var customColumnWidths = this._customColumnWidths;
		if(force || state.customColumnWidths != customColumnWidths) {
			state.customColumnWidths = customColumnWidths;
			changed = true;
		}
		var customCellRendererVariant = this.get_customCellRendererVariant();
		if(force || state.customCellRendererVariant != customCellRendererVariant) {
			state.customCellRendererVariant = customCellRendererVariant;
			changed = true;
		}
		var forceItemStateUpdate = this._forceItemStateUpdate;
		if(force || state.forceItemStateUpdate != forceItemStateUpdate) {
			state.forceItemStateUpdate = forceItemStateUpdate;
			changed = true;
		}
		return changed;
	},
	populateCurrentRowCellState: function(item,location,column,columnIndex,layoutIndex,state,force) {
		var changed = false;
		if(force || state.owner != this) {
			state.owner = this;
			changed = true;
		}
		if(force || state.data != item) {
			state.data = item;
			changed = true;
		}
		if(force || state.rowLocation != location && this.compareLocations(state.rowLocation,location) != 0) {
			state.rowLocation = location;
			changed = true;
		}
		if(force || state.columnIndex != columnIndex) {
			state.columnIndex = columnIndex;
			changed = true;
		}
		if(force || state.column != column) {
			state.column = column;
			changed = true;
		}
		if(force || state.layoutIndex != layoutIndex) {
			state.layoutIndex = layoutIndex;
			changed = true;
		}
		var branch = this._dataProvider != null && this._dataProvider.isBranch(item);
		if(force || state.branch != branch) {
			state.branch = branch;
			changed = true;
		}
		var opened = state.branch && this.openBranches.indexOf(item) != -1;
		if(force || state.opened != opened) {
			state.opened = opened;
			changed = true;
		}
		var selected = this.compareLocations(location,this._selectedLocation) == 0;
		if(force || state.selected != selected) {
			state.selected = selected;
			changed = true;
		}
		var enabled = this._enabled;
		if(force || state.enabled != enabled) {
			state.enabled = enabled;
			changed = true;
		}
		var text = column != null ? column.itemToText(item) : null;
		if(force || state.text != text) {
			state.text = text;
			changed = true;
		}
		return changed;
	},
	refreshRowRendererProperties: function(rowRenderer,state) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		var oldIgnoreOpenedChange = this._ignoreOpenedChange;
		this._ignoreOpenedChange = true;
		rowRenderer.set_data(state.data);
		rowRenderer.set_rowLocation(state.rowLocation);
		rowRenderer.set_layoutIndex(state.layoutIndex);
		rowRenderer.set_branch(state.branch);
		rowRenderer.set_opened(state.opened);
		rowRenderer.set_selected(state.selected);
		rowRenderer.set_enabled(state.enabled);
		rowRenderer.set_columns(state.columns);
		rowRenderer.selectable = state.selectable;
		rowRenderer.set_cellRendererRecycler(state.cellRendererRecycler);
		rowRenderer.set_customCellRendererVariant(state.customCellRendererVariant);
		rowRenderer.set_customColumnWidths(state.customColumnWidths);
		rowRenderer.set_forceCellStateUpdate(state.forceItemStateUpdate);
		this._ignoreOpenedChange = oldIgnoreOpenedChange;
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
	},
	createHeaderRenderer: function(state) {
		var headerRenderer = null;
		if(this._defaultHeaderStorage.inactiveHeaderRenderers.length == 0) {
			headerRenderer = this._defaultHeaderStorage.headerRendererRecycler.create();
			if((js_Boot().default).__implements(headerRenderer,(feathers_style_IVariantStyleObject().default))) {
				var variantHeaderRenderer = (js_Boot().default).__cast(headerRenderer , (feathers_style_IVariantStyleObject().default));
				if(variantHeaderRenderer.get_variant() == null) {
					var variant = this.get_customHeaderRendererVariant() != null ? this.get_customHeaderRendererVariant() : TreeGridView.CHILD_VARIANT_HEADER_RENDERER;
					variantHeaderRenderer.set_variant(variant);
				}
			}
			if((js_Boot().default).__implements(headerRenderer,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(headerRenderer , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(this._defaultHeaderStorage.measurements == null) {
				this._defaultHeaderStorage.measurements = new (feathers_layout_Measurements().default)(headerRenderer);
			}
		} else {
			headerRenderer = this._defaultHeaderStorage.inactiveHeaderRenderers.shift();
		}
		this.updateHeaderRenderer(headerRenderer,state);
		if((js_Boot().default).__implements(headerRenderer,(feathers_controls_ITriggerView().default))) {
			headerRenderer.addEventListener("trigger",$bind(this,this.treeGridView_headerRenderer_triggerHandler));
		} else {
			headerRenderer.addEventListener("click",$bind(this,this.treeGridView_headerRenderer_clickHandler));
		}
		if((js_Boot().default).__implements(headerRenderer,(feathers_core_IMeasureObject().default))) {
			headerRenderer.addEventListener("resize",$bind(this,this.treeGridView_headerRenderer_resizeHandler));
		}
		this.headerRendererToHeaderState.set(headerRenderer,state);
		this.dataToHeaderRenderer.set(state.column,headerRenderer);
		this._defaultHeaderStorage.activeHeaderRenderers.push(headerRenderer);
		return headerRenderer;
	},
	destroyHeaderRenderer: function(headerRenderer,recycler) {
		this._headerContainer.removeChild(headerRenderer);
		if(recycler != null && recycler.destroy != null) {
			recycler.destroy(headerRenderer);
		}
	},
	populateCurrentHeaderState: function(column,columnIndex,state,force) {
		var changed = false;
		if(force || state.owner != this) {
			state.owner = this;
			changed = true;
		}
		if(force || state.column != column) {
			state.column = column;
			changed = true;
		}
		if(force || state.columnIndex != columnIndex) {
			state.columnIndex = columnIndex;
			changed = true;
		}
		var headerText = column.headerText;
		if(force || state.text != headerText) {
			state.text = headerText;
			changed = true;
		}
		var enabled = this._enabled;
		if(force || state.enabled != enabled) {
			state.enabled = enabled;
			changed = true;
		}
		return changed;
	},
	updateHeaderRenderer: function(headerRenderer,state) {
		if(this._defaultHeaderStorage.headerRendererRecycler.update != null) {
			this._defaultHeaderStorage.headerRendererRecycler.update(headerRenderer,state);
		}
		this.refreshHeaderRendererProperties(headerRenderer,state);
	},
	resetHeaderRenderer: function(headerRenderer,state) {
		var recycler = this._defaultHeaderStorage.oldHeaderRendererRecycler != null ? this._defaultHeaderStorage.oldHeaderRendererRecycler : this._defaultHeaderStorage.headerRendererRecycler;
		if(recycler != null && recycler.reset != null) {
			recycler.reset(headerRenderer,state);
		}
		this.refreshHeaderRendererProperties(headerRenderer,TreeGridView.RESET_HEADER_STATE);
	},
	refreshHeaderRendererProperties: function(headerRenderer,state) {
		if((js_Boot().default).__implements(headerRenderer,(feathers_core_IUIControl().default))) {
			var uiControl = (js_Boot().default).__cast(headerRenderer , (feathers_core_IUIControl().default));
			uiControl.set_enabled(state.enabled);
		}
		if((js_Boot().default).__implements(headerRenderer,(feathers_controls_dataRenderers_ITreeGridViewHeaderRenderer().default))) {
			var header = (js_Boot().default).__cast(headerRenderer , (feathers_controls_dataRenderers_ITreeGridViewHeaderRenderer().default));
			header.set_column(state.column);
			header.set_columnIndex(state.columnIndex);
			header.set_treeGridViewOwner(state.owner);
		}
		if((js_Boot().default).__implements(headerRenderer,(feathers_layout_ILayoutIndexObject().default))) {
			var layoutObject = (js_Boot().default).__cast(headerRenderer , (feathers_layout_ILayoutIndexObject().default));
			layoutObject.set_layoutIndex(state.columnIndex);
		}
	},
	displayIndexToLocation: function(displayIndex) {
		this._currentDisplayIndex = -1;
		return this.displayIndexToLocationAtBranch(displayIndex,[]);
	},
	displayIndexToLocationAtBranch: function(target,locationOfBranch) {
		var _g = 0;
		var _g1 = this._dataProvider.getLength(locationOfBranch);
		while(_g < _g1) {
			var i = _g++;
			this._currentDisplayIndex++;
			locationOfBranch[locationOfBranch.length] = i;
			if(this._currentDisplayIndex == target) {
				return locationOfBranch;
			}
			var child = this._dataProvider.get(locationOfBranch);
			if(this._dataProvider.isBranch(child)) {
				if(this.openBranches.indexOf(child) != -1) {
					var result = this.displayIndexToLocationAtBranch(target,locationOfBranch);
					if(result != null) {
						return result;
					}
				}
			}
			locationOfBranch.length -= 1;
		}
		return null;
	},
	locationToDisplayIndex: function(location,returnNearestIfBranchNotOpen) {
		this._currentDisplayIndex = -1;
		var nearestNotOpenBranch = null;
		if(returnNearestIfBranchNotOpen) {
			nearestNotOpenBranch = [];
		}
		return this.locationToDisplayIndexAtBranch([],location,nearestNotOpenBranch);
	},
	locationToDisplayIndexAtBranch: function(locationOfBranch,locationToFind,nearestNotOpenBranch) {
		if(nearestNotOpenBranch != null) {
			nearestNotOpenBranch.push(locationToFind[locationOfBranch.length]);
		}
		var _g = 0;
		var _g1 = this._dataProvider.getLength(locationOfBranch);
		while(_g < _g1) {
			var i = _g++;
			this._currentDisplayIndex++;
			locationOfBranch[locationOfBranch.length] = i;
			if(this.compareLocations(locationOfBranch,locationToFind) == 0) {
				return this._currentDisplayIndex;
			}
			var child = this._dataProvider.get(locationOfBranch);
			if(this._dataProvider.isBranch(child)) {
				if(this.openBranches.indexOf(child) != -1) {
					var result = this.locationToDisplayIndexAtBranch(locationOfBranch,locationToFind,nearestNotOpenBranch);
					if(result != -1) {
						return result;
					}
				} else if(nearestNotOpenBranch != null && this.compareLocations(nearestNotOpenBranch,locationOfBranch) == 0) {
					return this._currentDisplayIndex;
				}
			}
			locationOfBranch.length -= 1;
		}
		if(nearestNotOpenBranch != null) {
			nearestNotOpenBranch.pop();
		}
		return -1;
	},
	navigateWithKeyboard: function(event) {
		if(event.isDefaultPrevented()) {
			return;
		}
		if(this._rowLayoutItems.length == 0) {
			return;
		}
		var startIndex = this.locationToDisplayIndex(this._selectedLocation,false);
		var result = startIndex;
		if((js_Boot().default).__implements(this.get_layout(),(feathers_layout_IKeyboardNavigationLayout().default))) {
			if(event.keyCode != 38 && event.keyCode != 40 && event.keyCode != 37 && event.keyCode != 39 && event.keyCode != 33 && event.keyCode != 34 && event.keyCode != 36 && event.keyCode != 35) {
				return;
			}
			result = ((js_Boot().default).__cast(this.get_layout() , (feathers_layout_IKeyboardNavigationLayout().default))).findNextKeyboardIndex(result,event,false,this._rowLayoutItems,null,this.treeGridViewPort.get_visibleWidth(),this.treeGridViewPort.get_visibleHeight());
		} else {
			switch(event.keyCode) {
			case 33:
				--result;
				break;
			case 34:
				++result;
				break;
			case 35:
				result = this._rowLayoutItems.length - 1;
				break;
			case 36:
				result = 0;
				break;
			case 37:
				--result;
				break;
			case 38:
				--result;
				break;
			case 39:
				++result;
				break;
			case 40:
				++result;
				break;
			default:
				return;
			}
		}
		if(result < 0) {
			result = 0;
		} else if(result >= this._rowLayoutItems.length) {
			result = this._rowLayoutItems.length - 1;
		}
		var changed = result != startIndex;
		var pendingLocation = null;
		if(!changed && result != -1) {
			pendingLocation = this.displayIndexToLocation(result);
			var itemRenderer = this.dataToRowRenderer.get(this._dataProvider.get(pendingLocation));
			if(itemRenderer == null) {
				changed = true;
			}
		}
		if(!changed) {
			return;
		}
		event.preventDefault();
		if(pendingLocation == null) {
			pendingLocation = this.displayIndexToLocation(result);
		}
		this.set_selectedLocation(pendingLocation);
		if(this._selectedLocation != null) {
			this.scrollToLocation(this._selectedLocation);
		}
		if(this._focusManager != null) {
			this._focusManager.set_focus(this);
		} else if(this.stage != null) {
			this.stage.set_focus(this);
		}
	},
	handlePendingScroll: function() {
		if(this._pendingScrollLocation == null) {
			return;
		}
		var location = this._pendingScrollLocation;
		var duration = this._pendingScrollDuration != null ? this._pendingScrollDuration : 0.0;
		this._pendingScrollLocation = null;
		this._pendingScrollDuration = null;
		if(this._dataProvider == null || this._dataProvider.getLength() == 0) {
			return;
		}
		var targetX = this.get_scrollX();
		var targetY = this.get_scrollY();
		if((js_Boot().default).__implements(this.get_layout(),(feathers_layout_IScrollLayout().default))) {
			var displayIndex = this.locationToDisplayIndex(location,true);
			var scrollLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_IScrollLayout().default));
			var result = scrollLayout.getNearestScrollPositionForIndex(displayIndex,this._rowLayoutItems.length,this.get_viewPort().get_visibleWidth(),this.get_viewPort().get_visibleHeight());
			targetX = result.x;
			targetY = result.y;
		} else {
			var item = this._dataProvider.get(location);
			var rowRenderer = this.dataToRowRenderer.get(item);
			if(rowRenderer == null) {
				return;
			}
			var maxX = rowRenderer.get_x();
			var minX = maxX + rowRenderer.get_width() - this.get_viewPort().get_visibleWidth();
			if(targetX < minX) {
				targetX = minX;
			} else if(targetX > maxX) {
				targetX = maxX;
			}
			var maxY = rowRenderer.get_y();
			var minY = maxY + rowRenderer.get_height() - this.get_viewPort().get_visibleHeight();
			if(targetY < minY) {
				targetY = minY;
			} else if(targetY > maxY) {
				targetY = maxY;
			}
		}
		if(duration == 0.0) {
			this.scroller.set_scrollX(targetX);
			this.scroller.set_scrollY(targetY);
		} else {
			this.scroller.throwTo(targetX,targetY,duration);
		}
	},
	toggleBranchInternal: function(branch,location,layoutIndex,open) {
		var rowRenderer = this.dataToRowRenderer.get(branch);
		var state = null;
		if(rowRenderer != null) {
			state = this.rowRendererToRowState.get(rowRenderer);
		}
		var isTemporary = false;
		if(state == null) {
			isTemporary = true;
			state = this.rowStatePool.get();
		}
		state.rowLocation = location;
		state.layoutIndex = layoutIndex;
		var alreadyOpen = this.openBranches.indexOf(branch) != -1;
		if(open && !alreadyOpen) {
			this.openBranches.push(branch);
			this.populateCurrentRowState(branch,location,layoutIndex,state,true);
			layoutIndex = this.insertChildrenIntoVirtualCache(location,layoutIndex);
			if(rowRenderer != null) {
				this.updateRowRenderer(rowRenderer,state);
			}
			var cellState = new (feathers_data_TreeGridViewCellState().default)();
			this.populateCurrentRowCellState(branch,location,null,-1,layoutIndex,cellState,true);
			(feathers_events_TreeGridViewEvent().default).dispatchForCell(this,"branchOpen",cellState);
		} else if(!open && alreadyOpen) {
			(HxOverrides().default).remove(this.openBranches,branch);
			this.populateCurrentRowState(branch,location,layoutIndex,state,true);
			this.removeChildrenFromVirtualCache(location,layoutIndex);
			if(rowRenderer != null) {
				this.updateRowRenderer(rowRenderer,state);
			}
			var cellState1 = new (feathers_data_TreeGridViewCellState().default)();
			this.populateCurrentRowCellState(branch,location,null,-1,layoutIndex,cellState1,true);
			(feathers_events_TreeGridViewEvent().default).dispatchForCell(this,"branchClose",cellState1);
		}
		if(isTemporary) {
			this.rowStatePool.release(state);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return layoutIndex;
	},
	toggleChildrenOfInternal: function(branch,location,layoutIndex,open) {
		layoutIndex = this.toggleBranchInternal(branch,location,layoutIndex,open);
		var itemCount = this._dataProvider.getLength(location);
		var _g = 0;
		var _g1 = itemCount;
		while(_g < _g1) {
			var i = _g++;
			location.push(i);
			var child = this._dataProvider.get(location);
			if(this._dataProvider.isBranch(child)) {
				this.toggleChildrenOfInternal(child,location,layoutIndex,open);
			}
			location.pop();
		}
	},
	refreshOpenBranchesFromDataProviderChange: function(removedItem,addedItem) {
		if(removedItem == null) {
			return;
		}
		var i = this.openBranches.length - 1;
		while(i >= 0) {
			var openBranch = this.openBranches[i];
			if(openBranch == removedItem) {
				if(removedItem != addedItem) {
					this.openBranches.splice(i,1);
				}
				continue;
			}
			var location = this._dataProvider.locationOf(openBranch);
			if(location == null) {
				this.openBranches.splice(i,1);
			}
			--i;
		}
	},
	baseScrollContainer_keyDownHandler: function(event) {
		if(!this._selectable) {
			(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.baseScrollContainer_keyDownHandler.call(this,event);
			return;
		}
		if(!this._enabled || event.isDefaultPrevented()) {
			return;
		}
		this.navigateWithKeyboard(event);
	},
	treeGridView_rowRenderer_triggerHandler: function(event) {
		if(!this._selectable) {
			return;
		}
		var rowRenderer = (js_Boot().default).__cast(event.currentTarget , (feathers_controls_dataRenderers_TreeGridViewRowRenderer().default));
		var state = this.rowRendererToRowState.get(rowRenderer);
		this.set_selectedLocation(state.rowLocation.slice());
	},
	treeGridView_rowRenderer_cellTriggerHandler: function(event) {
		this.dispatchEvent(event.clone());
	},
	treeGridView_rowRenderer_openHandler: function(event) {
		if(this._ignoreOpenedChange) {
			return;
		}
		var rowRenderer = (js_Boot().default).__cast(event.currentTarget , (feathers_controls_dataRenderers_TreeGridViewRowRenderer().default));
		var state = this.rowRendererToRowState.get(rowRenderer);
		this.toggleBranch(state.data,true);
	},
	treeGridView_rowRenderer_closeHandler: function(event) {
		if(this._ignoreOpenedChange) {
			return;
		}
		var rowRenderer = (js_Boot().default).__cast(event.currentTarget , (feathers_controls_dataRenderers_TreeGridViewRowRenderer().default));
		var state = this.rowRendererToRowState.get(rowRenderer);
		this.toggleBranch(state.data,false);
	},
	treeGridView_dataProvider_changeHandler: function(event) {
		this._totalRowLayoutCount = this.calculateTotalLayoutCount([]);
		if(this._virtualCache != null) {
			this._virtualCache.length = 0;
			this._virtualCache.length = this._totalRowLayoutCount;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
	},
	treeGridView_dataProvider_addItemHandler: function(event) {
		if(this._selectedLocation == null) {
			return;
		}
		if(this.compareLocations(this._selectedLocation,event.location) >= 0) {
			this.set_selectedLocation(this._dataProvider.locationOf(this._selectedItem));
		}
	},
	treeGridView_dataProvider_removeItemHandler: function(event) {
		this.refreshOpenBranchesFromDataProviderChange(event.removedItem,event.addedItem);
		if(this._selectedLocation != null) {
			if(this.containsLocation(event.location,this._selectedLocation)) {
				this.set_selectedLocation(null);
			} else {
				var comparisonResult = this.compareLocations(this._selectedLocation,event.location);
				if(comparisonResult == 0) {
					this.set_selectedLocation(null);
				} else if(comparisonResult > 0) {
					this.set_selectedLocation(this._dataProvider.locationOf(this._selectedItem));
				}
			}
		}
	},
	treeGridView_dataProvider_replaceItemHandler: function(event) {
		this.refreshOpenBranchesFromDataProviderChange(event.removedItem,event.addedItem);
		if(this._selectedLocation != null) {
			if(this.containsLocation(event.location,this._selectedLocation)) {
				this.set_selectedLocation(null);
			} else if(this.compareLocations(this._selectedLocation,event.location) == 0) {
				this._selectedItem = this._dataProvider.get(event.location);
				(feathers_events_FeathersEvent().default).dispatch(this,"change");
			}
		}
	},
	treeGridView_dataProvider_removeAllHandler: function(event) {
		this.openBranches.length = 0;
		this.set_selectedLocation(null);
	},
	treeGridView_dataProvider_resetHandler: function(event) {
		this.openBranches.length = 0;
		this.set_selectedLocation(null);
	},
	treeGridView_dataProvider_sortChangeHandler: function(event) {
		this.refreshSelectedLocationAfterFilterOrSort();
	},
	treeGridView_dataProvider_filterChangeHandler: function(event) {
		this.refreshSelectedLocationAfterFilterOrSort();
	},
	updateRowRendererForLocation: function(location) {
		var layoutIndex = this.locationToDisplayIndex(location,false);
		if(this._virtualCache != null && layoutIndex != -1) {
			this._virtualCache[layoutIndex] = null;
		}
		var item = this._dataProvider.get(location);
		var rowRenderer = this.dataToRowRenderer.get(item);
		if(rowRenderer == null) {
			this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
			return;
		}
		var state = this.rowRendererToRowState.get(rowRenderer);
		if(state.owner == null) {
			return;
		}
		rowRenderer.updateCells();
		this.populateCurrentRowState(item,location,layoutIndex,state,true);
		this.resetRowRenderer(rowRenderer,state);
		if(this._rowRendererMeasurements != null) {
			this._rowRendererMeasurements.restore(rowRenderer);
		}
		state.owner = null;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
	},
	validateCustomColumnWidths: function() {
		if(this._customColumnWidths == null || this._customColumnWidths.length < this._columns.get_length()) {
			return;
		}
		var minContainerWidth = this.actualWidth - this.get_paddingLeft() - this.get_paddingRight();
		var totalContainerWidth = Math.max(this._viewPort.get_width() + this._headerContainerLayout.get_paddingLeft() + this._headerContainerLayout.get_paddingRight(),minContainerWidth);
		var availableWidth = totalContainerWidth - this._headerContainerLayout.get_paddingLeft() - this._headerContainerLayout.get_paddingRight();
		var totalWidth = 0.0;
		var indices = [];
		var _g = 0;
		var _g1 = this._customColumnWidths.length;
		while(_g < _g1) {
			var i = _g++;
			var column = this._columns.get(i);
			if(column.width != null) {
				availableWidth -= column.width;
				continue;
			}
			var size = this._customColumnWidths[i];
			totalWidth += size;
			indices.push(i);
		}
		if(totalWidth == availableWidth) {
			return;
		}
		this._customColumnWidths = this._customColumnWidths.slice();
		var widthToDistribute = availableWidth - totalWidth;
		this.distributeWidthToIndices(widthToDistribute,indices,totalWidth);
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	calculateResizedColumnWidth: function(offset) {
		var columnCount = this._columns.get_length();
		if(this._customColumnWidths == null) {
			this._customColumnWidths = [];
			this._customColumnWidths.length = columnCount;
		} else {
			this._customColumnWidths = this._customColumnWidths.slice();
			this._customColumnWidths.length = columnCount;
		}
		var column = this._columns.get(this._resizingHeaderIndex);
		column.width = null;
		var headerRenderer = this._headerLayoutItems[this._resizingHeaderIndex];
		var column1 = this._columns.get(this._resizingHeaderIndex);
		var minX = this._headerContainer.get_x() + headerRenderer.get_x() + column1.minWidth;
		var maxX = this.actualWidth - this.rightViewPortOffset;
		var originalX = this._headerContainer.get_x() + headerRenderer.get_x() + headerRenderer.get_width();
		var newX = Math.min(Math.max(originalX + offset,minX),maxX);
		var preferredWidth = newX - headerRenderer.get_x() - this._headerContainer.get_x();
		var totalMinWidth = 0.0;
		var originalWidth = headerRenderer.get_width();
		var totalWidthAfter = 0.0;
		var indicesAfter = [];
		var _g = 0;
		var _g1 = columnCount;
		while(_g < _g1) {
			var i = _g++;
			var currentColumn = this._columns.get(i);
			if(i == this._resizingHeaderIndex) {
				continue;
			} else if(i < this._resizingHeaderIndex) {
				headerRenderer = this._headerLayoutItems[i];
				this._customColumnWidths[i] = headerRenderer.get_width();
				totalMinWidth += headerRenderer.get_width();
			} else {
				if(currentColumn.width != null) {
					totalMinWidth += currentColumn.width;
					continue;
				}
				totalMinWidth += currentColumn.minWidth;
				headerRenderer = this._headerLayoutItems[i];
				var columnWidth = headerRenderer.get_width();
				totalWidthAfter += columnWidth;
				this._customColumnWidths[i] = columnWidth;
				indicesAfter[indicesAfter.length] = i;
			}
		}
		if(indicesAfter.length == 0) {
			var index = this._resizingHeaderIndex + 1;
			indicesAfter[0] = index;
			column1 = this._columns.get(index);
			totalWidthAfter = column1.width;
			totalMinWidth -= totalWidthAfter;
			totalMinWidth += column1.minWidth;
			this._customColumnWidths[index] = totalWidthAfter;
			column1.width = null;
		}
		var newWidth = preferredWidth;
		var maxWidth = this._headerContainer.get_width() - totalMinWidth;
		if(newWidth > maxWidth) {
			newWidth = maxWidth;
		}
		if(newWidth < column1.minWidth) {
			newWidth = column1.minWidth;
		}
		this._customColumnWidths[this._resizingHeaderIndex] = newWidth;
		var widthToDistribute = originalWidth - newWidth;
		this.distributeWidthToIndices(widthToDistribute,indicesAfter,totalWidthAfter);
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	distributeWidthToIndices: function(widthToDistribute,indices,totalWidthOfIndices) {
		while(Math.abs(widthToDistribute) > 1.0) {
			var nextWidthToDistribute = widthToDistribute;
			var i = indices.length - 1;
			while(i >= 0) {
				var index = indices[i];
				var headerRenderer = this._headerLayoutItems[index];
				var columnWidth = headerRenderer.get_width();
				var column = this._columns.get(index);
				var percent = columnWidth / totalWidthOfIndices;
				var offset = widthToDistribute * percent;
				var newWidth = this._customColumnWidths[index] + offset;
				if(newWidth < column.minWidth) {
					offset += column.minWidth - newWidth;
					newWidth = column.minWidth;
					indices.splice(i,1);
					totalWidthOfIndices -= columnWidth;
				}
				this._customColumnWidths[index] = newWidth;
				nextWidthToDistribute -= offset;
				--i;
			}
			widthToDistribute = nextWidthToDistribute;
		}
		if(widthToDistribute != 0.0) {
			this._customColumnWidths[this._customColumnWidths.length - 1] += widthToDistribute;
		}
	},
	layoutColumnResizeSkin: function(offset) {
		if(this._currentColumnResizeSkin == null) {
			return;
		}
		var headerRenderer = this._headerLayoutItems[this._resizingHeaderIndex];
		var column = this._columns.get(this._resizingHeaderIndex);
		var minX = this._headerContainer.get_x() + headerRenderer.get_x() + column.minWidth;
		var maxX = this.actualWidth - this.rightViewPortOffset;
		var originalX = this._headerContainer.get_x() + headerRenderer.get_x() + headerRenderer.get_width();
		var newX = Math.min(Math.max(originalX + offset,minX),maxX) - this._currentColumnResizeSkin.get_width() / 2.0;
		this._currentColumnResizeSkin.set_visible(true);
		this._currentColumnResizeSkin.set_x(newX);
		this._currentColumnResizeSkin.set_y(this.get_paddingTop());
		this._currentColumnResizeSkin.set_height(this.actualHeight - this.get_paddingTop() - this.bottomViewPortOffset);
		this.setChildIndex(this._currentColumnResizeSkin,this.get_numChildren() - 1);
	},
	headerResizeTouchBegin: function(touchPointID,isMouse,divider,stageX) {
		if(!this._enabled || !this._resizableColumns || this._resizingHeaderIndex != -1 || this.stage == null) {
			return;
		}
		var exclusivePointer = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
		var result = false;
		if(isMouse) {
			result = exclusivePointer.claimMouse(divider);
		} else {
			result = exclusivePointer.claimTouch(touchPointID,divider);
		}
		if(!result) {
			return;
		}
		this._resizingHeaderTouchPointID = touchPointID;
		this._resizingHeaderTouchPointIsMouse = isMouse;
		this._resizingHeaderIndex = this._headerDividerLayoutItems.indexOf(divider);
		this._resizingHeaderStartStageX = stageX;
		this.layoutColumnResizeSkin(0.0);
		if(isMouse) {
			this.stage.addEventListener("mouseMove",$bind(this,this.treeGridView_headerDivider_stage_mouseMoveHandler),false,0,true);
			this.stage.addEventListener("mouseUp",$bind(this,this.treeGridView_headerDivider_stage_mouseUpHandler),false,0,true);
		} else {
			this.stage.addEventListener("touchMove",$bind(this,this.treeGridView_headerDivider_stage_touchMoveHandler),false,0,true);
			this.stage.addEventListener("touchEnd",$bind(this,this.treeGridView_headerDivider_stage_touchEndHandler),false,0,true);
		}
	},
	headerResizeTouchMove: function(touchPointID,isMouse,stageX) {
		if(this._resizingHeaderTouchPointID == null || this._resizingHeaderTouchPointID != touchPointID || this._resizingHeaderTouchPointIsMouse != isMouse) {
			return;
		}
		var offset = stageX - this._resizingHeaderStartStageX;
		offset *= (feathers_utils_DisplayUtil().default).getConcatenatedScaleX(this);
		this.layoutColumnResizeSkin(offset);
	},
	headerResizeTouchEnd: function(touchPointID,isMouse,stageX) {
		if(this._resizingHeaderTouchPointID == null || this._resizingHeaderTouchPointID != touchPointID || this._resizingHeaderTouchPointIsMouse != isMouse) {
			return;
		}
		if(isMouse) {
			this.stage.removeEventListener("mouseMove",$bind(this,this.treeGridView_headerDivider_stage_mouseMoveHandler));
			this.stage.removeEventListener("mouseUp",$bind(this,this.treeGridView_headerDivider_stage_mouseUpHandler));
		} else {
			this.stage.removeEventListener("touchMove",$bind(this,this.treeGridView_headerDivider_stage_touchMoveHandler));
			this.stage.removeEventListener("touchEnd",$bind(this,this.treeGridView_headerDivider_stage_touchEndHandler));
		}
		if(this._currentColumnResizeSkin != null) {
			this._currentColumnResizeSkin.set_visible(false);
		}
		var offset = stageX - this._resizingHeaderStartStageX;
		offset *= (feathers_utils_DisplayUtil().default).getConcatenatedScaleX(this);
		this.calculateResizedColumnWidth(offset);
		this._resizingHeaderTouchPointID = null;
		this._resizingHeaderTouchPointIsMouse = false;
		this._resizingHeaderIndex = -1;
		if(this._oldHeaderDividerMouseCursor != null) {
			(openfl_ui_Mouse()).set_cursor(this._oldHeaderDividerMouseCursor);
			this._oldHeaderDividerMouseCursor = null;
		}
	},
	refreshSelectedLocationAfterFilterOrSort: function() {
		if(this._selectedLocation == null) {
			return;
		}
		this.set_selectedLocation(this._dataProvider.locationOf(this._selectedItem));
	},
	calculateTotalLayoutCount: function(location) {
		if(this._dataProvider == null) {
			return 0;
		}
		var itemCount = this._dataProvider.getLength(location);
		var result = itemCount;
		var _g = 0;
		var _g1 = itemCount;
		while(_g < _g1) {
			var i = _g++;
			location.push(i);
			var item = this._dataProvider.get(location);
			if(this._dataProvider.isBranch(item) && this.openBranches.indexOf(item) != -1) {
				result += this.calculateTotalLayoutCount(location);
			}
			location.pop();
		}
		return result;
	},
	insertChildrenIntoVirtualCache: function(location,layoutIndex) {
		var length = this._dataProvider.getLength(location);
		var _g = 0;
		var _g1 = length;
		while(_g < _g1) {
			var i = _g++;
			location.push(i);
			++layoutIndex;
			this._virtualCache.splice(layoutIndex,0,null);
			var item = this._dataProvider.get(location);
			if(this._dataProvider.isBranch(item) && this.openBranches.indexOf(item) != -1) {
				layoutIndex = this.insertChildrenIntoVirtualCache(location,layoutIndex);
			}
			location.pop();
		}
		return layoutIndex;
	},
	removeChildrenFromVirtualCache: function(location,layoutIndex) {
		var length = this._dataProvider.getLength(location);
		++layoutIndex;
		var _g = 0;
		var _g1 = length;
		while(_g < _g1) {
			var i = _g++;
			location.push(i);
			var item = this._dataProvider.get(location);
			if(this._dataProvider.isBranch(item) && this.openBranches.indexOf(item) != -1) {
				this.removeChildrenFromVirtualCache(location,layoutIndex);
			}
			this._virtualCache.splice(layoutIndex,1);
			location.pop();
		}
	},
	containsLocation: function(parent,possibleChild) {
		if(parent == null || possibleChild == null || parent.length >= possibleChild.length) {
			return false;
		}
		var _g = 0;
		var _g1 = parent.length;
		while(_g < _g1) {
			var i = _g++;
			var a = parent[i];
			var b = possibleChild[i];
			if(a != b) {
				return false;
			}
		}
		return true;
	},
	compareLocations: function(location1,location2) {
		var null1 = location1 == null;
		var null2 = location2 == null;
		if(null1 && null2) {
			return 0;
		} else if(null1) {
			return 1;
		} else if(null2) {
			return -1;
		}
		var length1 = location1.length;
		var length2 = location2.length;
		var min = length1;
		if(length2 < min) {
			min = length2;
		}
		var _g = 0;
		var _g1 = min;
		while(_g < _g1) {
			var i = _g++;
			var index1 = location1[i];
			var index2 = location2[i];
			if(index1 < index2) {
				return -1;
			}
			if(index1 > index2) {
				return 1;
			}
		}
		if(length1 < length2) {
			return -1;
		} else if(length1 > length2) {
			return 1;
		}
		return 0;
	},
	treeGridView_dataProvider_updateItemHandler: function(event) {
		this.updateRowRendererForLocation(event.location);
	},
	treeGridView_dataProvider_updateAllHandler: function(event) {
		var location = [];
		var _g = 0;
		var _g1 = this._dataProvider.getLength();
		while(_g < _g1) {
			var i = _g++;
			location[0] = i;
			this.updateRowRendererForLocation(location);
		}
	},
	treeGridView_columns_addItemHandler: function(event) {
		if(this._customColumnWidths == null) {
			return;
		}
		var column = (js_Boot().default).__cast(event.addedItem , (feathers_controls_TreeGridViewColumn().default));
		var columnIndex = event.index;
		if(column.width != null || columnIndex > this._customColumnWidths.length) {
			return;
		}
		this._customColumnWidths.splice(columnIndex,0,0.0);
		var minContainerWidth = this.actualWidth - this.get_paddingLeft() - this.get_paddingRight();
		var totalContainerWidth = Math.max(this._viewPort.get_width() + this._headerContainerLayout.get_paddingLeft() + this._headerContainerLayout.get_paddingRight(),minContainerWidth);
		var availableWidth = totalContainerWidth - this._headerContainerLayout.get_paddingLeft() - this._headerContainerLayout.get_paddingRight();
		var totalWidth = 0.0;
		var indices = [];
		var _g = 0;
		var _g1 = this._customColumnWidths.length;
		while(_g < _g1) {
			var i = _g++;
			if(i == columnIndex) {
				continue;
			}
			var column1 = this._columns.get(i);
			if(column1.width != null) {
				availableWidth -= column1.width;
				continue;
			}
			var size = this._customColumnWidths[i];
			totalWidth += size;
			indices.push(i);
		}
		var idealColumnWidth = totalWidth / (indices.length + 1);
		this._customColumnWidths[columnIndex] = idealColumnWidth;
		this._customColumnWidths = this._customColumnWidths.slice();
		var widthToDistribute = -idealColumnWidth;
		this.distributeWidthToIndices(widthToDistribute,indices,totalWidth);
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	treeGridView_columns_removeItemHandler: function(event) {
		if(this._customColumnWidths == null) {
			return;
		}
		var column = (js_Boot().default).__cast(event.removedItem , (feathers_controls_TreeGridViewColumn().default));
		var columnIndex = event.index;
		if(column.width != null || columnIndex > this._customColumnWidths.length) {
			return;
		}
		this._customColumnWidths.splice(columnIndex,1);
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	treeGridView_columns_changeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
	},
	treeGridView_headerRenderer_touchTapHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(event.isPrimaryTouchPoint) {
			return;
		}
		var headerRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this.headerRendererToHeaderState.get(headerRenderer);
		(feathers_events_TreeGridViewEvent().default).dispatchForHeader(this,"headerTrigger",state);
	},
	treeGridView_headerRenderer_clickHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		var headerRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this.headerRendererToHeaderState.get(headerRenderer);
		(feathers_events_TreeGridViewEvent().default).dispatchForHeader(this,"headerTrigger",state);
	},
	treeGridView_headerRenderer_triggerHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		var headerRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this.headerRendererToHeaderState.get(headerRenderer);
		(feathers_events_TreeGridViewEvent().default).dispatchForHeader(this,"headerTrigger",state);
	},
	treeGridView_headerRenderer_resizeHandler: function(event) {
		if(this._validating) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	treeGridView_headerDivider_mouseDownHandler: function(event) {
		var headerDivider = (js_Boot().default).__cast(event.currentTarget , (openfl_display_InteractiveObject()));
		this.headerResizeTouchBegin(TreeGridView.POINTER_ID_MOUSE,true,headerDivider,headerDivider.stage.get_mouseX());
	},
	treeGridView_headerDivider_stage_mouseMoveHandler: function(event) {
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		this.headerResizeTouchMove(TreeGridView.POINTER_ID_MOUSE,true,stage.get_mouseX());
	},
	treeGridView_headerDivider_stage_mouseUpHandler: function(event) {
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		this.headerResizeTouchEnd(TreeGridView.POINTER_ID_MOUSE,true,stage.get_mouseX());
	},
	treeGridView_headerDivider_touchBeginHandler: function(event) {
		if(event.isPrimaryTouchPoint) {
			return;
		}
		var headerDivider = (js_Boot().default).__cast(event.currentTarget , (openfl_display_InteractiveObject()));
		this.headerResizeTouchBegin(event.touchPointID,false,headerDivider,headerDivider.stage.get_mouseX());
	},
	treeGridView_headerDivider_stage_touchMoveHandler: function(event) {
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		this.headerResizeTouchMove(event.touchPointID,false,stage.get_mouseX());
	},
	treeGridView_headerDivider_stage_touchEndHandler: function(event) {
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		this.headerResizeTouchEnd(event.touchPointID,false,stage.get_mouseX());
	},
	treeGridView_headerDivider_rollOverHandler: function(event) {
		if(!this._resizableColumns || this._resizingHeaderIndex != -1 || (openfl_ui_Mouse()).get_cursor() != "auto") {
			return;
		}
	},
	treeGridView_headerDivider_rollOutHandler: function(event) {
		if(!this._resizableColumns || this._resizingHeaderIndex != -1 || this._oldHeaderDividerMouseCursor == null) {
			return;
		}
		(openfl_ui_Mouse()).set_cursor(this._oldHeaderDividerMouseCursor);
		this._oldHeaderDividerMouseCursor = null;
	},
	get_styleContext: function() {
		return TreeGridView
	},
	get_customCellRendererVariant: function() {
		return this.__customCellRendererVariant;
	},
	set_customCellRendererVariant: function(value) {
		if(!this.setStyle("customCellRendererVariant")) {
			return this.__customCellRendererVariant;
		}
		if(this.__customCellRendererVariant == value) {
			return this.__customCellRendererVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customCellRendererVariant);
		this.__customCellRendererVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customCellRendererVariant;
	},
	clearStyle_customCellRendererVariant: function() {
		this.set_customCellRendererVariant(null);
		return this.get_customCellRendererVariant();
	},
	get_customHeaderRendererVariant: function() {
		return this.__customHeaderRendererVariant;
	},
	set_customHeaderRendererVariant: function(value) {
		if(!this.setStyle("customHeaderRendererVariant")) {
			return this.__customHeaderRendererVariant;
		}
		if(this.__customHeaderRendererVariant == value) {
			return this.__customHeaderRendererVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customHeaderRendererVariant);
		this.__customHeaderRendererVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customHeaderRendererVariant;
	},
	clearStyle_customHeaderRendererVariant: function() {
		this.set_customHeaderRendererVariant(null);
		return this.get_customHeaderRendererVariant();
	},
	get_headerDividerFactory: function() {
		return this.__headerDividerFactory;
	},
	set_headerDividerFactory: function(value) {
		if(!this.setStyle("headerDividerFactory")) {
			return this.__headerDividerFactory;
		}
		if(this.__headerDividerFactory == value) {
			return this.__headerDividerFactory;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_headerDividerFactory);
		this.__headerDividerFactory = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__headerDividerFactory;
	},
	clearStyle_headerDividerFactory: function() {
		this.set_headerDividerFactory((feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_Button().default)));
		return this.get_headerDividerFactory();
	},
	get_customHeaderDividerVariant: function() {
		return this.__customHeaderDividerVariant;
	},
	set_customHeaderDividerVariant: function(value) {
		if(!this.setStyle("customHeaderDividerVariant")) {
			return this.__customHeaderDividerVariant;
		}
		if(this.__customHeaderDividerVariant == value) {
			return this.__customHeaderDividerVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customHeaderDividerVariant);
		this.__customHeaderDividerVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customHeaderDividerVariant;
	},
	clearStyle_customHeaderDividerVariant: function() {
		this.set_customHeaderDividerVariant(null);
		return this.get_customHeaderDividerVariant();
	},
	get_columnDividerFactory: function() {
		return this.__columnDividerFactory;
	},
	set_columnDividerFactory: function(value) {
		if(!this.setStyle("columnDividerFactory")) {
			return this.__columnDividerFactory;
		}
		if(this.__columnDividerFactory == value) {
			return this.__columnDividerFactory;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_columnDividerFactory);
		this.__columnDividerFactory = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__columnDividerFactory;
	},
	clearStyle_columnDividerFactory: function() {
		this.set_columnDividerFactory(null);
		return this.get_columnDividerFactory();
	},
	get_customColumnDividerVariant: function() {
		return this.__customColumnDividerVariant;
	},
	set_customColumnDividerVariant: function(value) {
		if(!this.setStyle("customColumnDividerVariant")) {
			return this.__customColumnDividerVariant;
		}
		if(this.__customColumnDividerVariant == value) {
			return this.__customColumnDividerVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customColumnDividerVariant);
		this.__customColumnDividerVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customColumnDividerVariant;
	},
	clearStyle_customColumnDividerVariant: function() {
		this.set_customColumnDividerVariant(null);
		return this.get_customColumnDividerVariant();
	},
	get_layout: function() {
		return this.__layout;
	},
	set_layout: function(value) {
		if(!this.setStyle("layout")) {
			return this.__layout;
		}
		if(this.__layout == value) {
			return this.__layout;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_layout);
		this.__layout = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__layout;
	},
	clearStyle_layout: function() {
		this.set_layout(null);
		return this.get_layout();
	},
	get_columnResizeSkin: function() {
		return this.__columnResizeSkin;
	},
	set_columnResizeSkin: function(value) {
		if(!this.setStyle("columnResizeSkin")) {
			return this.__columnResizeSkin;
		}
		if(this.__columnResizeSkin == value) {
			return this.__columnResizeSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_columnResizeSkin);
		this.__columnResizeSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__columnResizeSkin;
	},
	clearStyle_columnResizeSkin: function() {
		this.set_columnResizeSkin(null);
		return this.get_columnResizeSkin();
	},
	get_extendedScrollBarY: function() {
		return this.__extendedScrollBarY;
	},
	set_extendedScrollBarY: function(value) {
		if(!this.setStyle("extendedScrollBarY")) {
			return this.__extendedScrollBarY;
		}
		if(this.__extendedScrollBarY == value) {
			return this.__extendedScrollBarY;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_extendedScrollBarY);
		this.__extendedScrollBarY = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__extendedScrollBarY;
	},
	clearStyle_extendedScrollBarY: function() {
		this.set_extendedScrollBarY(false);
		return this.get_extendedScrollBarY();
	},
	get_showHeaderDividersOnlyWhenResizable: function() {
		return this.__showHeaderDividersOnlyWhenResizable;
	},
	set_showHeaderDividersOnlyWhenResizable: function(value) {
		if(!this.setStyle("showHeaderDividersOnlyWhenResizable")) {
			return this.__showHeaderDividersOnlyWhenResizable;
		}
		if(this.__showHeaderDividersOnlyWhenResizable == value) {
			return this.__showHeaderDividersOnlyWhenResizable;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_showHeaderDividersOnlyWhenResizable);
		this.__showHeaderDividersOnlyWhenResizable = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__showHeaderDividersOnlyWhenResizable;
	},
	clearStyle_showHeaderDividersOnlyWhenResizable: function() {
		this.set_showHeaderDividersOnlyWhenResizable(false);
		return this.get_showHeaderDividersOnlyWhenResizable();
	}
});
TreeGridView.prototype.__class__ = TreeGridView.prototype.constructor = $hxClasses["feathers.controls.TreeGridView"] = TreeGridView;

// Init



// Statics

TreeGridView.defaultUpdateHeaderRenderer = function(headerRenderer,state) {
	if((js_Boot().default).__implements(headerRenderer,(feathers_core_ITextControl().default))) {
		var textControl = (js_Boot().default).__cast(headerRenderer , (feathers_core_ITextControl().default));
		textControl.set_text(state.text);
	}
}
TreeGridView.defaultResetHeaderRenderer = function(headerRenderer,state) {
	if((js_Boot().default).__implements(headerRenderer,(feathers_core_ITextControl().default))) {
		var textControl = (js_Boot().default).__cast(headerRenderer , (feathers_core_ITextControl().default));
		textControl.set_text(null);
	}
}
TreeGridView.__meta__ = { obj : { defaultXmlProperty : ["dataProvider"]}}
TreeGridView.VARIANT_BORDERLESS = "borderless"
TreeGridView.VARIANT_BORDER = "border"
TreeGridView.CHILD_VARIANT_CELL_RENDERER = "treeGridView_cellRenderer"
TreeGridView.CHILD_VARIANT_HEADER_RENDERER = "treeGridView_headerRenderer"
TreeGridView.CHILD_VARIANT_HEADER_DIVIDER = "treeGridView_headerDivider"
TreeGridView.CHILD_VARIANT_COLUMN_DIVIDER = "treeGridView_columnDivider"
TreeGridView.INVALIDATION_FLAG_HEADER_RENDERER_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("headerRendererFactory")
TreeGridView.INVALIDATION_FLAG_HEADER_DIVIDER_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("headerDividerFactory")
TreeGridView.INVALIDATION_FLAG_COLUMN_DIVIDER_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("columnDividerFactory")
TreeGridView.RESET_HEADER_STATE = new (feathers_data_TreeGridViewHeaderState().default)()
TreeGridView.RESET_ROW_STATE = new (feathers_controls_TreeGridViewRowState().default)()
TreeGridView.POINTER_ID_MOUSE = -1000

// Export

exports["default"] = TreeGridView;

/***/ }),

/***/ "./lib/_gen/feathers/controls/TreeGridViewColumn.js":
/*!**********************************************************!*\
  !*** ./lib/_gen/feathers/controls/TreeGridViewColumn.js ***!
  \**********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.TreeGridViewColumn

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_IGridViewColumn() {return __webpack_require__(/*! ./../../feathers/controls/IGridViewColumn */ "./lib/_gen/feathers/controls/IGridViewColumn.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}

// Constructor

var TreeGridViewColumn = function(headerText,itemToText,width) {
	this.cellRendererRecycler = null;
	this.minWidth = 0.0;
	this.width = null;
	(openfl_events_EventDispatcher()).call(this);
	this.headerText = headerText;
	if(itemToText != null) {
		this.itemToText = itemToText;
	}
	this.width = width;
}

// Meta

TreeGridViewColumn.__name__ = "feathers.controls.TreeGridViewColumn";
TreeGridViewColumn.__isInterface__ = false;
TreeGridViewColumn.__interfaces__ = [(feathers_controls_IGridViewColumn().default)];
TreeGridViewColumn.__super__ = (openfl_events_EventDispatcher());
TreeGridViewColumn.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	itemToText: function(data) {
		return (Std().default).string(data);
	}
});
TreeGridViewColumn.prototype.__class__ = TreeGridViewColumn.prototype.constructor = $hxClasses["feathers.controls.TreeGridViewColumn"] = TreeGridViewColumn;

// Init



// Statics




// Export

exports["default"] = TreeGridViewColumn;

/***/ }),

/***/ "./lib/_gen/feathers/controls/TreeGridViewRowState.js":
/*!************************************************************!*\
  !*** ./lib/_gen/feathers/controls/TreeGridViewRowState.js ***!
  \************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.TreeGridViewRowState

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var TreeGridViewRowState = function() {
	this.selectable = false;
	this.enabled = true;
	this.selected = false;
	this.opened = false;
	this.branch = false;
	this.layoutIndex = -1;
	this.rowLocation = null;
}

// Meta

TreeGridViewRowState.__name__ = "feathers.controls.TreeGridViewRowState";
TreeGridViewRowState.__isInterface__ = false;
TreeGridViewRowState.prototype = {
	
};
TreeGridViewRowState.prototype.__class__ = TreeGridViewRowState.prototype.constructor = $hxClasses["feathers.controls.TreeGridViewRowState"] = TreeGridViewRowState;

// Init



// Statics




// Export

exports["default"] = TreeGridViewRowState;

/***/ }),

/***/ "./lib/_gen/feathers/controls/TreeView.js":
/*!************************************************!*\
  !*** ./lib/_gen/feathers/controls/TreeView.js ***!
  \************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.TreeView

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IFocusContainer() {return __webpack_require__(/*! ./../../feathers/core/IFocusContainer */ "./lib/_gen/feathers/core/IFocusContainer.js");}
function feathers_core_IDataSelector() {return __webpack_require__(/*! ./../../feathers/core/IDataSelector */ "./lib/_gen/feathers/core/IDataSelector.js");}
function feathers_controls_supportClasses_BaseScrollContainer() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/BaseScrollContainer */ "./lib/_gen/feathers/controls/supportClasses/BaseScrollContainer.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function haxe_ds_StringMap() {return __webpack_require__(/*! ./../../haxe/ds/StringMap */ "./lib/_gen/haxe/ds/StringMap.js");}
function feathers_themes_steel_components_SteelTreeViewStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelTreeViewStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTreeViewStyles.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_IScrollLayout() {return __webpack_require__(/*! ./../../feathers/layout/IScrollLayout */ "./lib/_gen/feathers/layout/IScrollLayout.js");}
function feathers_layout_IVirtualLayout() {return __webpack_require__(/*! ./../../feathers/layout/IVirtualLayout */ "./lib/_gen/feathers/layout/IVirtualLayout.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function Type() {return __webpack_require__(/*! ./../../Type */ "./lib/_gen/Type.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_controls_dataRenderers_IDataRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/IDataRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IDataRenderer.js");}
function feathers_controls_IToggle() {return __webpack_require__(/*! ./../../feathers/controls/IToggle */ "./lib/_gen/feathers/controls/IToggle.js");}
function feathers_controls_dataRenderers_IHierarchicalItemRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/IHierarchicalItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IHierarchicalItemRenderer.js");}
function feathers_controls_dataRenderers_IHierarchicalDepthItemRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/IHierarchicalDepthItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IHierarchicalDepthItemRenderer.js");}
function feathers_controls_dataRenderers_ITreeViewItemRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/ITreeViewItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ITreeViewItemRenderer.js");}
function feathers_layout_ILayoutIndexObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutIndexObject */ "./lib/_gen/feathers/layout/ILayoutIndexObject.js");}
function feathers_core_IOpenCloseToggle() {return __webpack_require__(/*! ./../../feathers/core/IOpenCloseToggle */ "./lib/_gen/feathers/core/IOpenCloseToggle.js");}
function feathers_style_IVariantStyleObject() {return __webpack_require__(/*! ./../../feathers/style/IVariantStyleObject */ "./lib/_gen/feathers/style/IVariantStyleObject.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_controls_ITriggerView() {return __webpack_require__(/*! ./../../feathers/controls/ITriggerView */ "./lib/_gen/feathers/controls/ITriggerView.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_controls__$TreeView_ItemRendererStorage() {return __webpack_require__(/*! ./../../feathers/controls/_TreeView/ItemRendererStorage */ "./lib/_gen/feathers/controls/_TreeView/ItemRendererStorage.js");}
function feathers_layout_IKeyboardNavigationLayout() {return __webpack_require__(/*! ./../../feathers/layout/IKeyboardNavigationLayout */ "./lib/_gen/feathers/layout/IKeyboardNavigationLayout.js");}
function feathers_events_TreeViewEvent() {return __webpack_require__(/*! ./../../feathers/events/TreeViewEvent */ "./lib/_gen/feathers/events/TreeViewEvent.js");}
function openfl_display_DisplayObject() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObject);}
function feathers_data_TreeViewItemState() {return __webpack_require__(/*! ./../../feathers/data/TreeViewItemState */ "./lib/_gen/feathers/data/TreeViewItemState.js");}
function feathers_core_ITextControl() {return __webpack_require__(/*! ./../../feathers/core/ITextControl */ "./lib/_gen/feathers/core/ITextControl.js");}
function feathers_layout_VirtualLayoutRange() {return __webpack_require__(/*! ./../../feathers/layout/VirtualLayoutRange */ "./lib/_gen/feathers/layout/VirtualLayoutRange.js");}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}
function haxe_ds_ObjectMap() {return __webpack_require__(/*! ./../../haxe/ds/ObjectMap */ "./lib/_gen/haxe/ds/ObjectMap.js");}
function feathers_utils_DisplayObjectRecycler() {return __webpack_require__(/*! ./../../feathers/utils/DisplayObjectRecycler */ "./lib/_gen/feathers/utils/DisplayObjectRecycler.js");}
function feathers_controls_dataRenderers_HierarchicalItemRenderer() {return __webpack_require__(/*! ./../../feathers/controls/dataRenderers/HierarchicalItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/HierarchicalItemRenderer.js");}
function feathers_controls_supportClasses_AdvancedLayoutViewPort() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/AdvancedLayoutViewPort */ "./lib/_gen/feathers/controls/supportClasses/AdvancedLayoutViewPort.js");}

// Constructor

var TreeView = function(dataProvider,changeListener) {
	this.__customItemRendererVariant = null;
	this.__layout = null;
	this._pendingScrollDuration = null;
	this._pendingScrollLocation = null;
	this._ignoreLayoutChanges = false;
	this._ignoreOpenedChange = false;
	this._ignoreSelectionChange = false;
	this.pointerSelectionEnabled = true;
	this._virtualLayout = true;
	this._selectable = true;
	this._totalLayoutCount = 0;
	this._layoutItems = [];
	this._tempVisibleIndices = new (feathers_layout_VirtualLayoutRange().default)(0,0);
	this._visibleIndices = new (feathers_layout_VirtualLayoutRange().default)(0,0);
	this._virtualCache = [];
	this._unrenderedLayoutIndices = [];
	this._unrenderedLocations = [];
	this.itemStatePool = new (lime_utils_ObjectPool().default)(function() {
		return new (feathers_data_TreeViewItemState().default)();
	});
	this.itemRendererToItemState = new (haxe_ds_ObjectMap().default)();
	this.dataToItemRenderer = new (haxe_ds_ObjectMap().default)();
	this._additionalStorage = null;
	this._defaultStorage = new (feathers_controls__$TreeView_ItemRendererStorage().default)(null,(feathers_utils_DisplayObjectRecycler().default).withClass((feathers_controls_dataRenderers_HierarchicalItemRenderer().default)));
	this._recyclerMap = null;
	this._forceItemStateUpdate = false;
	this._previousCustomItemRendererVariant = null;
	this._selectedItem = null;
	this._selectedLocation = null;
	this.openBranches = [];
	this._childFocusEnabled = true;
	this.initializeTreeViewTheme();
	(feathers_controls_supportClasses_BaseScrollContainer().default).call(this);
	this.set_dataProvider(dataProvider);
	this.set_tabEnabled(true);
	this.focusRect = null;
	if(this.get_viewPort() == null) {
		this.treeViewPort = new (feathers_controls_supportClasses_AdvancedLayoutViewPort().default)();
		this.addChild(this.treeViewPort);
		this.set_viewPort(this.treeViewPort);
	}
	if(changeListener != null) {
		this.addEventListener("change",changeListener);
	}
}

// Meta

TreeView.__name__ = "feathers.controls.TreeView";
TreeView.__isInterface__ = false;
TreeView.__interfaces__ = [(feathers_core_IFocusContainer().default),(feathers_core_IDataSelector().default)];
TreeView.__super__ = (feathers_controls_supportClasses_BaseScrollContainer().default);
TreeView.prototype = $extend((feathers_controls_supportClasses_BaseScrollContainer().default).prototype, {
	get_tabEnabled: function() {
		if((this._selectable || this.get_maxScrollY() != this.get_minScrollY() || this.get_maxScrollX() != this.get_minScrollX()) && this._enabled) {
			return this.get_rawTabEnabled();
		} else {
			return false;
		}
	},
	get_childFocusEnabled: function() {
		if(this._enabled) {
			return this._childFocusEnabled;
		} else {
			return false;
		}
	},
	set_childFocusEnabled: function(value) {
		if(this._childFocusEnabled == value) {
			return this._childFocusEnabled;
		}
		this._childFocusEnabled = value;
		return this._childFocusEnabled;
	},
	get_dataProvider: function() {
		return this._dataProvider;
	},
	set_dataProvider: function(value) {
		if(this._dataProvider == value) {
			return this._dataProvider;
		}
		this._virtualCache.length = 0;
		this._totalLayoutCount = 0;
		this.openBranches.length = 0;
		if(this._dataProvider != null) {
			this._dataProvider.removeEventListener("change",$bind(this,this.treeView_dataProvider_changeHandler));
			this._dataProvider.removeEventListener("addItem",$bind(this,this.treeView_dataProvider_addItemHandler));
			this._dataProvider.removeEventListener("removeItem",$bind(this,this.treeView_dataProvider_removeItemHandler));
			this._dataProvider.removeEventListener("replaceItem",$bind(this,this.treeView_dataProvider_replaceItemHandler));
			this._dataProvider.removeEventListener("removeAll",$bind(this,this.treeView_dataProvider_removeAllHandler));
			this._dataProvider.removeEventListener("reset",$bind(this,this.treeView_dataProvider_resetHandler));
			this._dataProvider.removeEventListener("filterChange",$bind(this,this.treeView_dataProvider_filterChangeHandler));
			this._dataProvider.removeEventListener("sortChange",$bind(this,this.treeView_dataProvider_sortChangeHandler));
			this._dataProvider.removeEventListener("updateItem",$bind(this,this.treeView_dataProvider_updateItemHandler));
			this._dataProvider.removeEventListener("updateAll",$bind(this,this.treeView_dataProvider_updateAllHandler));
		}
		this._dataProvider = value;
		if(this._dataProvider != null) {
			this._totalLayoutCount = this.calculateTotalLayoutCount([]);
			this._virtualCache.length = this._totalLayoutCount;
			this._dataProvider.addEventListener("change",$bind(this,this.treeView_dataProvider_changeHandler));
			this._dataProvider.addEventListener("addItem",$bind(this,this.treeView_dataProvider_addItemHandler));
			this._dataProvider.addEventListener("removeItem",$bind(this,this.treeView_dataProvider_removeItemHandler));
			this._dataProvider.addEventListener("replaceItem",$bind(this,this.treeView_dataProvider_replaceItemHandler));
			this._dataProvider.addEventListener("removeAll",$bind(this,this.treeView_dataProvider_removeAllHandler));
			this._dataProvider.addEventListener("reset",$bind(this,this.treeView_dataProvider_resetHandler));
			this._dataProvider.addEventListener("filterChange",$bind(this,this.treeView_dataProvider_filterChangeHandler));
			this._dataProvider.addEventListener("sortChange",$bind(this,this.treeView_dataProvider_sortChangeHandler));
			this._dataProvider.addEventListener("updateItem",$bind(this,this.treeView_dataProvider_updateItemHandler));
			this._dataProvider.addEventListener("updateAll",$bind(this,this.treeView_dataProvider_updateAllHandler));
		}
		this.set_scrollX(0.0);
		this.set_scrollY(0.0);
		this.set_selectedLocation(null);
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._dataProvider;
	},
	get_selectedLocation: function() {
		return this._selectedLocation;
	},
	set_selectedLocation: function(value) {
		if(!this._selectable || this._dataProvider == null) {
			value = null;
		}
		if(this._selectedLocation == value || this.compareLocations(this._selectedLocation,value) == 0) {
			return this._selectedLocation;
		}
		this._selectedLocation = value;
		if(this._selectedLocation == null) {
			this._selectedItem = null;
		} else {
			this._selectedItem = this._dataProvider.get(this._selectedLocation);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedLocation;
	},
	get_selectedItem: function() {
		return this._selectedItem;
	},
	set_selectedItem: function(value) {
		if(value == null || !this._selectable || this._dataProvider == null) {
			this.set_selectedLocation(null);
			return this._selectedItem;
		}
		var location = this._dataProvider.locationOf(value);
		if(this._selectedItem == value && this.compareLocations(this._selectedLocation,location) == 0) {
			return this._selectedItem;
		}
		this._selectedItem = value;
		this._selectedLocation = location;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selectedItem;
	},
	get_itemRendererRecycler: function() {
		return this._defaultStorage.itemRendererRecycler;
	},
	set_itemRendererRecycler: function(value) {
		if(this._defaultStorage.itemRendererRecycler == value) {
			return this._defaultStorage.itemRendererRecycler;
		}
		this._defaultStorage.oldItemRendererRecycler = this._defaultStorage.itemRendererRecycler;
		this._defaultStorage.itemRendererRecycler = value;
		this._defaultStorage.measurements = null;
		this.setInvalid(TreeView.INVALIDATION_FLAG_ITEM_RENDERER_FACTORY);
		return this._defaultStorage.itemRendererRecycler;
	},
	get_forceItemStateUpdate: function() {
		return this._forceItemStateUpdate;
	},
	set_forceItemStateUpdate: function(value) {
		if(this._forceItemStateUpdate == value) {
			return this._forceItemStateUpdate;
		}
		this._forceItemStateUpdate = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._forceItemStateUpdate;
	},
	get_itemRendererRecyclerIDFunction: function() {
		return this._itemRendererRecyclerIDFunction;
	},
	set_itemRendererRecyclerIDFunction: function(value) {
		if(this._itemRendererRecyclerIDFunction == value) {
			return this._itemRendererRecyclerIDFunction;
		}
		this._itemRendererRecyclerIDFunction = value;
		this.setInvalid(TreeView.INVALIDATION_FLAG_ITEM_RENDERER_FACTORY);
		return this._itemRendererRecyclerIDFunction;
	},
	get_selectable: function() {
		return this._selectable;
	},
	set_selectable: function(value) {
		if(this._selectable == value) {
			return this._selectable;
		}
		this._selectable = value;
		if(!this._selectable) {
			this.set_selectedLocation(null);
		}
		return this._selectable;
	},
	get_virtualLayout: function() {
		return this._virtualLayout;
	},
	set_virtualLayout: function(value) {
		if(this._virtualLayout = value) {
			return this._virtualLayout;
		}
		this._virtualLayout = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		return this._virtualLayout;
	},
	itemToText: function(data) {
		return (Std().default).string(data);
	},
	itemToEnabled: function(data) {
		return true;
	},
	isBranchOpen: function(branch) {
		if(this._dataProvider == null || !this._dataProvider.contains(branch)) {
			return false;
		}
		if(this._dataProvider.isBranch(branch)) {
			return this.openBranches.indexOf(branch) != -1;
		} else {
			return false;
		}
	},
	toggleBranch: function(branch,open) {
		var location = this._dataProvider != null ? this._dataProvider.locationOf(branch) : null;
		if(location == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Cannot open branch because it is not in the data provider."));
		}
		if(!this._dataProvider.isBranch(branch)) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Cannot open item because it is not a branch."));
		}
		var alreadyOpen = this.openBranches.indexOf(branch) != -1;
		if(open && alreadyOpen || !open && !alreadyOpen) {
			return;
		}
		var layoutIndex = this.locationToDisplayIndex(location,false);
		this.toggleBranchInternal(branch,location,layoutIndex,open);
		this._totalLayoutCount = this.calculateTotalLayoutCount([]);
	},
	toggleChildrenOf: function(branch,open) {
		var location = this._dataProvider != null ? this._dataProvider.locationOf(branch) : null;
		if(location == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Cannot open branch because it is not in the data provider."));
		}
		if(!this._dataProvider.isBranch(branch)) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Cannot open item because it is not a branch."));
		}
		var layoutIndex = this.locationToDisplayIndex(location,false);
		this.toggleChildrenOfInternal(branch,location,layoutIndex,open);
		this._totalLayoutCount = this.calculateTotalLayoutCount([]);
	},
	itemToItemRenderer: function(item) {
		if(item == null) {
			return null;
		}
		return this.dataToItemRenderer.get(item);
	},
	itemRendererToItem: function(itemRenderer) {
		if(itemRenderer == null) {
			return null;
		}
		var state = this.itemRendererToItemState.get(itemRenderer);
		if(state == null) {
			return null;
		}
		return state.data;
	},
	locationToItemRenderer: function(location) {
		if(this._dataProvider == null || !this.isValidLocation(location)) {
			return null;
		}
		var item = this._dataProvider.get(location);
		return this.dataToItemRenderer.get(item);
	},
	scrollToLocation: function(location,animationDuration) {
		if(this._dataProvider == null || this._dataProvider.getLength() == 0) {
			return;
		}
		this._pendingScrollLocation = location;
		this._pendingScrollDuration = animationDuration;
		this.setInvalid((feathers_core_InvalidationFlag().default).SCROLL);
	},
	getItemRendererRecycler: function(id) {
		if(this._recyclerMap == null) {
			return null;
		}
		return this._recyclerMap.get(id);
	},
	setItemRendererRecycler: function(id,recycler) {
		if(this._recyclerMap == null) {
			this._recyclerMap = new (haxe_ds_StringMap().default)();
		}
		if(recycler == null) {
			this._recyclerMap.remove(id);
			return;
		}
		this._recyclerMap.set(id,recycler);
		this.setInvalid(TreeView.INVALIDATION_FLAG_ITEM_RENDERER_FACTORY);
	},
	initializeTreeViewTheme: function() {
		(feathers_themes_steel_components_SteelTreeViewStyles().default).initialize();
	},
	update: function() {
		var layoutInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(this._previousCustomItemRendererVariant != this.get_customItemRendererVariant()) {
			this.setInvalidationFlag(TreeView.INVALIDATION_FLAG_ITEM_RENDERER_FACTORY);
		}
		if(layoutInvalid || stylesInvalid) {
			if(this._previousLayout != this.get_layout()) {
				this._virtualCache.length = 0;
				this._virtualCache.length = this._totalLayoutCount;
			}
			this.treeViewPort.set_layout(this.get_layout());
			this._previousLayout = this.get_layout();
		}
		this.treeViewPort.refreshChildren = $bind(this,this.refreshItemRenderers);
		var flag = this._invalidationFlags.keys();
		while(flag.hasNext()) {
			var flag1 = flag.next();
			this.treeViewPort.setInvalid(flag1);
		}
		if(this._allInvalid) {
			this.treeViewPort.setInvalid();
		}
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.update.call(this);
		this._previousCustomItemRendererVariant = this.get_customItemRendererVariant();
		this.handlePendingScroll();
	},
	createScroller: function() {
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.createScroller.call(this);
		this.treeViewPort.set_scroller(this.scroller);
	},
	refreshScrollerValues: function() {
		(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.refreshScrollerValues.call(this);
		if((js_Boot().default).__implements(this.get_layout(),(feathers_layout_IScrollLayout().default))) {
			var scrollLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_IScrollLayout().default));
			this.scroller.forceElasticTop = scrollLayout.get_elasticTop();
			this.scroller.forceElasticRight = scrollLayout.get_elasticRight();
			this.scroller.forceElasticBottom = scrollLayout.get_elasticBottom();
			this.scroller.forceElasticLeft = scrollLayout.get_elasticLeft();
		} else {
			this.scroller.forceElasticTop = false;
			this.scroller.forceElasticRight = false;
			this.scroller.forceElasticBottom = false;
			this.scroller.forceElasticLeft = false;
		}
		this.scroller.snapPositionsX = this.treeViewPort.get_snapPositionsX();
		this.scroller.snapPositionsY = this.treeViewPort.get_snapPositionsY();
	},
	needsScrollMeasurement: function() {
		var oldStart = this._visibleIndices.start;
		var oldEnd = this._visibleIndices.end;
		if(this._virtualLayout && (js_Boot().default).__implements(this.get_layout(),(feathers_layout_IVirtualLayout().default))) {
			var virtualLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_IVirtualLayout().default));
			var oldIgnoreLayoutChanges = this._ignoreLayoutChanges;
			this._ignoreLayoutChanges = true;
			virtualLayout.set_scrollX(this.scroller.get_scrollX());
			virtualLayout.set_scrollY(this.scroller.get_scrollY());
			this._ignoreLayoutChanges = oldIgnoreLayoutChanges;
			virtualLayout.getVisibleIndices(this._layoutItems.length,this.treeViewPort.get_visibleWidth(),this.treeViewPort.get_visibleHeight(),this._tempVisibleIndices);
		} else {
			this._tempVisibleIndices.start = 0;
			this._tempVisibleIndices.end = this._layoutItems.length - 1;
		}
		if(oldStart == this._tempVisibleIndices.start) {
			return oldEnd != this._tempVisibleIndices.end;
		} else {
			return true;
		}
	},
	refreshItemRenderers: function(items) {
		this._layoutItems = items;
		if(this._defaultStorage.itemRendererRecycler.update == null) {
			this._defaultStorage.itemRendererRecycler.update = TreeView.defaultUpdateItemRenderer;
			if(this._defaultStorage.itemRendererRecycler.reset == null) {
				this._defaultStorage.itemRendererRecycler.reset = TreeView.defaultResetItemRenderer;
			}
		}
		if(this._recyclerMap != null) {
			var recycler = this._recyclerMap.iterator();
			while(recycler.hasNext()) {
				var recycler1 = recycler.next();
				if(recycler1.update == null) {
					if(recycler1.update == null) {
						recycler1.update = TreeView.defaultUpdateItemRenderer;
						if(recycler1.reset == null) {
							recycler1.reset = TreeView.defaultResetItemRenderer;
						}
					}
				}
			}
		}
		var itemRendererInvalid = this.treeViewPort.isInvalid(TreeView.INVALIDATION_FLAG_ITEM_RENDERER_FACTORY);
		this.refreshInactiveItemRenderers(this._defaultStorage,itemRendererInvalid);
		if(this._additionalStorage != null) {
			var _g = 0;
			var _g1 = this._additionalStorage.length;
			while(_g < _g1) {
				var i = _g++;
				var storage = this._additionalStorage[i];
				this.refreshInactiveItemRenderers(storage,itemRendererInvalid);
			}
		}
		this.findUnrenderedData();
		this.recoverInactiveItemRenderers(this._defaultStorage);
		if(this._additionalStorage != null) {
			var _g2 = 0;
			var _g11 = this._additionalStorage.length;
			while(_g2 < _g11) {
				var i1 = _g2++;
				var storage1 = this._additionalStorage[i1];
				this.recoverInactiveItemRenderers(storage1);
			}
		}
		this.renderUnrenderedData();
		this.freeInactiveItemRenderers(this._defaultStorage);
		if(this._defaultStorage.inactiveItemRenderers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive item renderers should be empty after updating."));
		}
		if(this._additionalStorage != null) {
			var _g3 = 0;
			var _g12 = this._additionalStorage.length;
			while(_g3 < _g12) {
				var i2 = _g3++;
				var storage2 = this._additionalStorage[i2];
				this.freeInactiveItemRenderers(storage2);
				if(storage2.inactiveItemRenderers.length > 0) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive item renderers " + storage2.id + " should be empty after updating."));
				}
			}
		}
	},
	refreshInactiveItemRenderers: function(storage,factoryInvalid) {
		var temp = storage.inactiveItemRenderers;
		storage.inactiveItemRenderers = storage.activeItemRenderers;
		storage.activeItemRenderers = temp;
		if(storage.activeItemRenderers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": active item renderers should be empty before updating."));
		}
		if(factoryInvalid) {
			this.recoverInactiveItemRenderers(storage);
			this.freeInactiveItemRenderers(storage);
			storage.oldItemRendererRecycler = null;
		}
	},
	recoverInactiveItemRenderers: function(storage) {
		var _g = 0;
		var _g1 = storage.inactiveItemRenderers;
		while(_g < _g1.length) {
			var itemRenderer = _g1[_g];
			++_g;
			if(itemRenderer == null) {
				continue;
			}
			var state = this.itemRendererToItemState.get(itemRenderer);
			if(state == null) {
				continue;
			}
			var item = state.data;
			this.itemRendererToItemState.remove(itemRenderer);
			this.dataToItemRenderer.remove(item);
			itemRenderer.removeEventListener("trigger",$bind(this,this.treeView_itemRenderer_triggerHandler));
			itemRenderer.removeEventListener("click",$bind(this,this.treeView_itemRenderer_clickHandler));
			itemRenderer.removeEventListener("touchTap",$bind(this,this.treeView_itemRenderer_touchTapHandler));
			itemRenderer.removeEventListener("change",$bind(this,this.treeView_itemRenderer_changeHandler));
			itemRenderer.removeEventListener("resize",$bind(this,this.treeView_itemRenderer_resizeHandler));
			itemRenderer.removeEventListener("open",$bind(this,this.treeView_itemRenderer_openHandler));
			itemRenderer.removeEventListener("close",$bind(this,this.treeView_itemRenderer_closeHandler));
			this.resetItemRenderer(itemRenderer,state,storage);
			if(storage.measurements != null) {
				storage.measurements.restore(itemRenderer);
			}
			this.itemStatePool.release(state);
		}
	},
	freeInactiveItemRenderers: function(storage) {
		var recycler = storage.oldItemRendererRecycler != null ? storage.oldItemRendererRecycler : storage.itemRendererRecycler;
		var _g = 0;
		var _g1 = storage.inactiveItemRenderers;
		while(_g < _g1.length) {
			var itemRenderer = _g1[_g];
			++_g;
			if(itemRenderer == null) {
				continue;
			}
			this.destroyItemRenderer(itemRenderer,recycler);
		}
		storage.inactiveItemRenderers.length = 0;
	},
	findUnrenderedData: function() {
		this._layoutItems.length = 0;
		this._layoutItems.length = this._totalLayoutCount;
		if(this._virtualLayout && (js_Boot().default).__implements(this.get_layout(),(feathers_layout_IVirtualLayout().default))) {
			var virtualLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_IVirtualLayout().default));
			var oldIgnoreLayoutChanges = this._ignoreLayoutChanges;
			this._ignoreLayoutChanges = true;
			virtualLayout.set_scrollX(this.scroller.get_scrollX());
			virtualLayout.set_scrollY(this.scroller.get_scrollY());
			virtualLayout.set_virtualCache(this._virtualCache);
			this._ignoreLayoutChanges = oldIgnoreLayoutChanges;
			virtualLayout.getVisibleIndices(this._layoutItems.length,this.treeViewPort.get_visibleWidth(),this.treeViewPort.get_visibleHeight(),this._visibleIndices);
		} else {
			this._visibleIndices.start = 0;
			this._visibleIndices.end = this._layoutItems.length - 1;
		}
		this.findUnrenderedDataForLocation([],0);
	},
	findUnrenderedDataForLocation: function(location,layoutIndex) {
		if(this._dataProvider == null) {
			return layoutIndex;
		}
		var _g = 0;
		var _g1 = this._dataProvider.getLength(location);
		while(_g < _g1) {
			var i = _g++;
			location.push(i);
			var item = this._dataProvider.get(location);
			if(layoutIndex < this._visibleIndices.start || layoutIndex > this._visibleIndices.end) {
				this._layoutItems[layoutIndex] = null;
			} else {
				this.findItemRenderer(item,location.slice(),layoutIndex);
			}
			++layoutIndex;
			if(layoutIndex > this._visibleIndices.end) {
				break;
			}
			if(this._dataProvider.isBranch(item) && this.openBranches.indexOf(item) != -1) {
				layoutIndex = this.findUnrenderedDataForLocation(location,layoutIndex);
				if(layoutIndex > this._visibleIndices.end) {
					break;
				}
			}
			location.pop();
		}
		return layoutIndex;
	},
	findItemRenderer: function(item,location,layoutIndex) {
		var itemRenderer = this.dataToItemRenderer.get(item);
		if(itemRenderer == null) {
			this._unrenderedLocations.push(location);
			this._unrenderedLayoutIndices.push(layoutIndex);
			return;
		}
		var state = this.itemRendererToItemState.get(itemRenderer);
		var changed = this.populateCurrentItemState(item,location,layoutIndex,state,this._forceItemStateUpdate);
		var oldRecyclerID = state.recyclerID;
		var storage = this.itemStateToStorage(state);
		if(storage.id != oldRecyclerID) {
			this._unrenderedLocations.push(location);
			this._unrenderedLayoutIndices.push(layoutIndex);
			return;
		}
		if(changed) {
			this.updateItemRenderer(itemRenderer,state,storage);
		}
		itemRenderer.set_visible(true);
		this._layoutItems[layoutIndex] = itemRenderer;
		var removed = (HxOverrides().default).remove(storage.inactiveItemRenderers,itemRenderer);
		if(!removed) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": item renderer map contains bad data for item at location " + (Std().default).string(location) + ". This may be caused by duplicate items in the data provider, which is not allowed."));
		}
		storage.activeItemRenderers.push(itemRenderer);
	},
	populateCurrentItemState: function(item,location,layoutIndex,state,force) {
		var changed = false;
		if(force || state.owner != this) {
			state.owner = this;
			changed = true;
		}
		if(force || state.data != item) {
			state.data = item;
			changed = true;
		}
		if(force || state.location != location && this.compareLocations(state.location,location) != 0) {
			state.location = location;
			changed = true;
		}
		if(force || state.layoutIndex != layoutIndex) {
			state.layoutIndex = layoutIndex;
			changed = true;
		}
		var branch = this._dataProvider != null && this._dataProvider.isBranch(item);
		if(force || state.branch != branch) {
			state.branch = branch;
			changed = true;
		}
		var opened = state.branch && this.openBranches.indexOf(item) != -1;
		if(force || state.opened != opened) {
			state.opened = opened;
			changed = true;
		}
		var selected = item == this._selectedItem;
		if(force || state.selected != selected) {
			state.selected = selected;
			changed = true;
		}
		var enabled = this._enabled && this.itemToEnabled(item);
		if(force || state.enabled != enabled) {
			state.enabled = enabled;
			changed = true;
		}
		var text = this.itemToText(item);
		if(force || state.text != text) {
			state.text = text;
			changed = true;
		}
		return changed;
	},
	updateItemRenderer: function(itemRenderer,state,storage) {
		state.recyclerID = storage.id;
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		var oldIgnoreOpenedChange = this._ignoreOpenedChange;
		this._ignoreOpenedChange = true;
		if(storage.itemRendererRecycler.update != null) {
			storage.itemRendererRecycler.update(itemRenderer,state);
		}
		this._ignoreOpenedChange = oldIgnoreOpenedChange;
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		this.refreshItemRendererProperties(itemRenderer,state);
	},
	resetItemRenderer: function(itemRenderer,state,storage) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		var oldIgnoreOpenedChange = this._ignoreOpenedChange;
		this._ignoreOpenedChange = true;
		var recycler = storage.oldItemRendererRecycler != null ? storage.oldItemRendererRecycler : storage.itemRendererRecycler;
		if(recycler != null && recycler.reset != null) {
			recycler.reset(itemRenderer,state);
		}
		this._ignoreOpenedChange = oldIgnoreOpenedChange;
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		this.refreshItemRendererProperties(itemRenderer,TreeView.RESET_ITEM_STATE);
	},
	refreshItemRendererProperties: function(itemRenderer,state) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		var oldIgnoreOpenedChange = this._ignoreOpenedChange;
		this._ignoreOpenedChange = true;
		if((js_Boot().default).__implements(itemRenderer,(feathers_core_IUIControl().default))) {
			var uiControl = (js_Boot().default).__cast(itemRenderer , (feathers_core_IUIControl().default));
			uiControl.set_enabled(state.enabled);
		}
		if((js_Boot().default).__implements(itemRenderer,(feathers_controls_dataRenderers_IDataRenderer().default))) {
			var dataRenderer = (js_Boot().default).__cast(itemRenderer , (feathers_controls_dataRenderers_IDataRenderer().default));
			dataRenderer.set_data(state.data);
		}
		if((js_Boot().default).__implements(itemRenderer,(feathers_controls_IToggle().default))) {
			var toggle = (js_Boot().default).__cast(itemRenderer , (feathers_controls_IToggle().default));
			toggle.set_selected(state.selected);
		}
		if((js_Boot().default).__implements(itemRenderer,(feathers_controls_dataRenderers_IHierarchicalItemRenderer().default))) {
			var hierarchicalItem = (js_Boot().default).__cast(itemRenderer , (feathers_controls_dataRenderers_IHierarchicalItemRenderer().default));
			hierarchicalItem.set_branch(state.branch);
		}
		if((js_Boot().default).__implements(itemRenderer,(feathers_controls_dataRenderers_IHierarchicalDepthItemRenderer().default))) {
			var depthItem = (js_Boot().default).__cast(itemRenderer , (feathers_controls_dataRenderers_IHierarchicalDepthItemRenderer().default));
			depthItem.set_hierarchyDepth(state.location != null ? state.location.length - 1 : 0);
		}
		if((js_Boot().default).__implements(itemRenderer,(feathers_controls_dataRenderers_ITreeViewItemRenderer().default))) {
			var treeItem = (js_Boot().default).__cast(itemRenderer , (feathers_controls_dataRenderers_ITreeViewItemRenderer().default));
			treeItem.set_location(state.location);
			treeItem.set_treeViewOwner(state.owner);
		}
		if((js_Boot().default).__implements(itemRenderer,(feathers_layout_ILayoutIndexObject().default))) {
			var layoutIndexObject = (js_Boot().default).__cast(itemRenderer , (feathers_layout_ILayoutIndexObject().default));
			layoutIndexObject.set_layoutIndex(state.layoutIndex);
		}
		if((js_Boot().default).__implements(itemRenderer,(feathers_core_IOpenCloseToggle().default))) {
			var openCloseItem = (js_Boot().default).__cast(itemRenderer , (feathers_core_IOpenCloseToggle().default));
			openCloseItem.set_opened(state.opened);
		}
		this._ignoreOpenedChange = oldIgnoreOpenedChange;
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
	},
	renderUnrenderedData: function() {
		var _g = 0;
		var _g1 = this._unrenderedLocations;
		while(_g < _g1.length) {
			var location = _g1[_g];
			++_g;
			var layoutIndex = this._unrenderedLayoutIndices.shift();
			var item = this._dataProvider.get(location);
			var state = this.itemStatePool.get();
			this.populateCurrentItemState(item,location,layoutIndex,state,true);
			var itemRenderer = this.createItemRenderer(state);
			itemRenderer.set_visible(true);
			this.treeViewPort.addChild(itemRenderer);
			this._layoutItems[layoutIndex] = itemRenderer;
		}
		this._unrenderedLocations.length = 0;
	},
	createItemRenderer: function(state) {
		var storage = this.itemStateToStorage(state);
		var itemRenderer = null;
		if(storage.inactiveItemRenderers.length == 0) {
			itemRenderer = storage.itemRendererRecycler.create();
			if((js_Boot().default).__implements(itemRenderer,(feathers_style_IVariantStyleObject().default))) {
				var variantItemRenderer = (js_Boot().default).__cast(itemRenderer , (feathers_style_IVariantStyleObject().default));
				if(variantItemRenderer.get_variant() == null) {
					var variant = this.get_customItemRendererVariant() != null ? this.get_customItemRendererVariant() : TreeView.CHILD_VARIANT_ITEM_RENDERER;
					variantItemRenderer.set_variant(variant);
				}
			}
			if((js_Boot().default).__implements(itemRenderer,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(itemRenderer , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(storage.measurements == null) {
				storage.measurements = new (feathers_layout_Measurements().default)(itemRenderer);
			}
		} else {
			itemRenderer = storage.inactiveItemRenderers.shift();
		}
		this.updateItemRenderer(itemRenderer,state,storage);
		if((js_Boot().default).__implements(itemRenderer,(feathers_controls_ITriggerView().default))) {
			itemRenderer.addEventListener("trigger",$bind(this,this.treeView_itemRenderer_triggerHandler));
		} else {
			itemRenderer.addEventListener("click",$bind(this,this.treeView_itemRenderer_clickHandler));
		}
		if((js_Boot().default).__implements(itemRenderer,(feathers_controls_IToggle().default))) {
			itemRenderer.addEventListener("change",$bind(this,this.treeView_itemRenderer_changeHandler));
		}
		if((js_Boot().default).__implements(itemRenderer,(feathers_core_IMeasureObject().default))) {
			itemRenderer.addEventListener("resize",$bind(this,this.treeView_itemRenderer_resizeHandler));
		}
		if((js_Boot().default).__implements(itemRenderer,(feathers_core_IOpenCloseToggle().default))) {
			itemRenderer.addEventListener("open",$bind(this,this.treeView_itemRenderer_openHandler));
			itemRenderer.addEventListener("close",$bind(this,this.treeView_itemRenderer_closeHandler));
		}
		this.itemRendererToItemState.set(itemRenderer,state);
		this.dataToItemRenderer.set(state.data,itemRenderer);
		storage.activeItemRenderers.push(itemRenderer);
		return itemRenderer;
	},
	destroyItemRenderer: function(itemRenderer,recycler) {
		this.treeViewPort.removeChild(itemRenderer);
		if(recycler != null && recycler.destroy != null) {
			recycler.destroy(itemRenderer);
		}
	},
	itemStateToStorage: function(state) {
		var recyclerID = null;
		if(this._itemRendererRecyclerIDFunction != null) {
			recyclerID = this._itemRendererRecyclerIDFunction(state);
		}
		var recycler = null;
		if(recyclerID != null) {
			if(this._recyclerMap != null) {
				recycler = this._recyclerMap.get(recyclerID);
			}
			if(recycler == null) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Item renderer recycler ID \"" + recyclerID + "\" is not registered."));
			}
		}
		if(recycler == null) {
			return this._defaultStorage;
		}
		if(this._additionalStorage == null) {
			this._additionalStorage = [];
		}
		var _g = 0;
		var _g1 = this._additionalStorage.length;
		while(_g < _g1) {
			var i = _g++;
			var storage = this._additionalStorage[i];
			if(storage.itemRendererRecycler == recycler) {
				return storage;
			}
		}
		var storage1 = new (feathers_controls__$TreeView_ItemRendererStorage().default)(recyclerID,recycler);
		this._additionalStorage.push(storage1);
		return storage1;
	},
	refreshSelectedLocationAfterFilterOrSort: function() {
		if(this._selectedLocation == null) {
			return;
		}
		this.set_selectedLocation(this._dataProvider.locationOf(this._selectedItem));
	},
	calculateTotalLayoutCount: function(location) {
		if(this._dataProvider == null) {
			return 0;
		}
		var itemCount = this._dataProvider.getLength(location);
		var result = itemCount;
		var _g = 0;
		var _g1 = itemCount;
		while(_g < _g1) {
			var i = _g++;
			location.push(i);
			var item = this._dataProvider.get(location);
			if(this._dataProvider.isBranch(item) && this.openBranches.indexOf(item) != -1) {
				result += this.calculateTotalLayoutCount(location);
			}
			location.pop();
		}
		return result;
	},
	insertChildrenIntoVirtualCache: function(location,layoutIndex) {
		var length = this._dataProvider.getLength(location);
		var _g = 0;
		var _g1 = length;
		while(_g < _g1) {
			var i = _g++;
			location.push(i);
			++layoutIndex;
			this._virtualCache.splice(layoutIndex,0,null);
			var item = this._dataProvider.get(location);
			if(this._dataProvider.isBranch(item) && this.openBranches.indexOf(item) != -1) {
				layoutIndex = this.insertChildrenIntoVirtualCache(location,layoutIndex);
			}
			location.pop();
		}
		return layoutIndex;
	},
	removeChildrenFromVirtualCache: function(location,layoutIndex) {
		var length = this._dataProvider.getLength(location);
		++layoutIndex;
		var _g = 0;
		var _g1 = length;
		while(_g < _g1) {
			var i = _g++;
			location.push(i);
			var item = this._dataProvider.get(location);
			if(this._dataProvider.isBranch(item) && this.openBranches.indexOf(item) != -1) {
				this.removeChildrenFromVirtualCache(location,layoutIndex);
			}
			this._virtualCache.splice(layoutIndex,1);
			location.pop();
		}
	},
	containsLocation: function(parent,possibleChild) {
		if(parent == null || possibleChild == null || parent.length >= possibleChild.length) {
			return false;
		}
		var _g = 0;
		var _g1 = parent.length;
		while(_g < _g1) {
			var i = _g++;
			var a = parent[i];
			var b = possibleChild[i];
			if(a != b) {
				return false;
			}
		}
		return true;
	},
	compareLocations: function(location1,location2) {
		var null1 = location1 == null;
		var null2 = location2 == null;
		if(null1 && null2) {
			return 0;
		} else if(null1) {
			return 1;
		} else if(null2) {
			return -1;
		}
		var length1 = location1.length;
		var length2 = location2.length;
		var min = length1;
		if(length2 < min) {
			min = length2;
		}
		var _g = 0;
		var _g1 = min;
		while(_g < _g1) {
			var i = _g++;
			var index1 = location1[i];
			var index2 = location2[i];
			if(index1 < index2) {
				return -1;
			}
			if(index1 > index2) {
				return 1;
			}
		}
		if(length1 < length2) {
			return -1;
		} else if(length1 > length2) {
			return 1;
		}
		return 0;
	},
	displayIndexToLocation: function(displayIndex) {
		this._currentDisplayIndex = -1;
		return this.displayIndexToLocationAtBranch(displayIndex,[]);
	},
	displayIndexToLocationAtBranch: function(target,locationOfBranch) {
		var _g = 0;
		var _g1 = this._dataProvider.getLength(locationOfBranch);
		while(_g < _g1) {
			var i = _g++;
			this._currentDisplayIndex++;
			locationOfBranch[locationOfBranch.length] = i;
			if(this._currentDisplayIndex == target) {
				return locationOfBranch;
			}
			var child = this._dataProvider.get(locationOfBranch);
			if(this._dataProvider.isBranch(child)) {
				if(this.openBranches.indexOf(child) != -1) {
					var result = this.displayIndexToLocationAtBranch(target,locationOfBranch);
					if(result != null) {
						return result;
					}
				}
			}
			locationOfBranch.length -= 1;
		}
		return null;
	},
	locationToDisplayIndex: function(location,returnNearestIfBranchNotOpen) {
		this._currentDisplayIndex = -1;
		var nearestNotOpenBranch = null;
		if(returnNearestIfBranchNotOpen) {
			nearestNotOpenBranch = [];
		}
		return this.locationToDisplayIndexAtBranch([],location,nearestNotOpenBranch);
	},
	locationToDisplayIndexAtBranch: function(locationOfBranch,locationToFind,nearestNotOpenBranch) {
		if(nearestNotOpenBranch != null) {
			nearestNotOpenBranch.push(locationToFind[locationOfBranch.length]);
		}
		var _g = 0;
		var _g1 = this._dataProvider.getLength(locationOfBranch);
		while(_g < _g1) {
			var i = _g++;
			this._currentDisplayIndex++;
			locationOfBranch[locationOfBranch.length] = i;
			if(this.compareLocations(locationOfBranch,locationToFind) == 0) {
				return this._currentDisplayIndex;
			}
			var child = this._dataProvider.get(locationOfBranch);
			if(this._dataProvider.isBranch(child)) {
				if(this.openBranches.indexOf(child) != -1) {
					var result = this.locationToDisplayIndexAtBranch(locationOfBranch,locationToFind,nearestNotOpenBranch);
					if(result != -1) {
						return result;
					}
				} else if(nearestNotOpenBranch != null && this.compareLocations(nearestNotOpenBranch,locationOfBranch) == 0) {
					return this._currentDisplayIndex;
				}
			}
			locationOfBranch.length -= 1;
		}
		if(nearestNotOpenBranch != null) {
			nearestNotOpenBranch.pop();
		}
		return -1;
	},
	navigateWithKeyboard: function(event) {
		if(event.isDefaultPrevented()) {
			return;
		}
		if(this._layoutItems.length == 0) {
			return;
		}
		var startIndex = this.locationToDisplayIndex(this._selectedLocation,false);
		var result = startIndex;
		if((js_Boot().default).__implements(this.get_layout(),(feathers_layout_IKeyboardNavigationLayout().default))) {
			if(event.keyCode != 38 && event.keyCode != 40 && event.keyCode != 37 && event.keyCode != 39 && event.keyCode != 33 && event.keyCode != 34 && event.keyCode != 36 && event.keyCode != 35) {
				return;
			}
			result = ((js_Boot().default).__cast(this.get_layout() , (feathers_layout_IKeyboardNavigationLayout().default))).findNextKeyboardIndex(result,event,false,this._layoutItems,null,this.treeViewPort.get_visibleWidth(),this.treeViewPort.get_visibleHeight());
		} else {
			switch(event.keyCode) {
			case 33:
				--result;
				break;
			case 34:
				++result;
				break;
			case 35:
				result = this._layoutItems.length - 1;
				break;
			case 36:
				result = 0;
				break;
			case 37:
				--result;
				break;
			case 38:
				--result;
				break;
			case 39:
				++result;
				break;
			case 40:
				++result;
				break;
			default:
				return;
			}
		}
		if(result < 0) {
			result = 0;
		} else if(result >= this._layoutItems.length) {
			result = this._layoutItems.length - 1;
		}
		var changed = result != startIndex;
		var pendingLocation = null;
		if(!changed && result != -1) {
			pendingLocation = this.displayIndexToLocation(result);
			var itemRenderer = this.itemToItemRenderer(this._dataProvider.get(pendingLocation));
			if(itemRenderer == null) {
				changed = true;
			}
		}
		if(!changed) {
			return;
		}
		event.preventDefault();
		if(pendingLocation == null) {
			pendingLocation = this.displayIndexToLocation(result);
		}
		this.set_selectedLocation(pendingLocation);
		if(this._selectedLocation != null) {
			this.scrollToLocation(this._selectedLocation);
		}
		if(this._focusManager != null) {
			this._focusManager.set_focus(this);
		} else if(this.stage != null) {
			this.stage.set_focus(this);
		}
	},
	handlePendingScroll: function() {
		if(this._pendingScrollLocation == null) {
			return;
		}
		var location = this._pendingScrollLocation;
		var duration = this._pendingScrollDuration != null ? this._pendingScrollDuration : 0.0;
		this._pendingScrollLocation = null;
		this._pendingScrollDuration = null;
		if(this._dataProvider == null || this._dataProvider.getLength() == 0) {
			return;
		}
		var targetX = this.get_scrollX();
		var targetY = this.get_scrollY();
		if((js_Boot().default).__implements(this.get_layout(),(feathers_layout_IScrollLayout().default))) {
			var displayIndex = this.locationToDisplayIndex(location,true);
			var scrollLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_IScrollLayout().default));
			var result = scrollLayout.getNearestScrollPositionForIndex(displayIndex,this._layoutItems.length,this.get_viewPort().get_visibleWidth(),this.get_viewPort().get_visibleHeight());
			targetX = result.x;
			targetY = result.y;
		} else {
			var item = this._dataProvider.get(location);
			var itemRenderer = this.dataToItemRenderer.get(item);
			if(itemRenderer == null) {
				return;
			}
			var maxX = itemRenderer.get_x();
			var minX = maxX + itemRenderer.get_width() - this.get_viewPort().get_visibleWidth();
			if(targetX < minX) {
				targetX = minX;
			} else if(targetX > maxX) {
				targetX = maxX;
			}
			var maxY = itemRenderer.get_y();
			var minY = maxY + itemRenderer.get_height() - this.get_viewPort().get_visibleHeight();
			if(targetY < minY) {
				targetY = minY;
			} else if(targetY > maxY) {
				targetY = maxY;
			}
		}
		if(duration == 0.0) {
			this.scroller.set_scrollX(targetX);
			this.scroller.set_scrollY(targetY);
		} else {
			this.scroller.throwTo(targetX,targetY,duration);
		}
	},
	baseScrollContainer_keyDownHandler: function(event) {
		if(!this._selectable) {
			(feathers_controls_supportClasses_BaseScrollContainer().default).prototype.baseScrollContainer_keyDownHandler.call(this,event);
			return;
		}
		if(!this._enabled || event.isDefaultPrevented() || this._dataProvider == null) {
			return;
		}
		if(event.keyCode == 37) {
			if(this._dataProvider.isBranch(this._selectedItem)) {
				if(this.openBranches.indexOf(this._selectedItem) != -1) {
					this.toggleBranch(this._selectedItem,false);
					return;
				}
			}
			var parentLocation = this._selectedLocation.slice();
			parentLocation.pop();
			if(parentLocation.length > 0) {
				this.set_selectedLocation(parentLocation);
			}
		}
		if(event.keyCode == 39) {
			if(this._dataProvider.isBranch(this._selectedItem)) {
				if(this.openBranches.indexOf(this._selectedItem) == -1) {
					this.toggleBranch(this._selectedItem,true);
					return;
				}
				var childCount = this._dataProvider.getLength(this._selectedLocation);
				if(childCount > 0) {
					var childLocation = this._selectedLocation.slice();
					childLocation.push(0);
					this.set_selectedLocation(childLocation);
				}
			}
		}
		if(event.keyCode == 13) {
			if(this._selectedItem != null) {
				var itemRenderer = this.dataToItemRenderer.get(this._selectedItem);
				var state = null;
				if(itemRenderer != null) {
					state = this.itemRendererToItemState.get(itemRenderer);
				}
				var isTemporary = false;
				if(state == null) {
					isTemporary = true;
					state = this.itemStatePool.get();
				}
				var layoutIndex = this.locationToDisplayIndex(this._selectedLocation,false);
				this.populateCurrentItemState(this._selectedItem,this._selectedLocation,layoutIndex,state,true);
				(feathers_events_TreeViewEvent().default).dispatch(this,"itemTrigger",state);
				if(isTemporary) {
					this.itemStatePool.release(state);
				}
			}
		}
		if(this._selectedLocation != null && event.keyCode == 32) {
			if(this._dataProvider.isBranch(this._selectedItem)) {
				event.preventDefault();
				this.toggleBranch(this._selectedItem,this.openBranches.indexOf(this._selectedItem) == -1);
			}
			return;
		}
		this.navigateWithKeyboard(event);
	},
	isValidLocation: function(location) {
		var locationOfBranch = [];
		var _g = 0;
		while(_g < location.length) {
			var index = location[_g];
			++_g;
			if(index < 0) {
				return false;
			}
			if(index >= this._dataProvider.getLength(locationOfBranch)) {
				return false;
			}
			locationOfBranch.push(index);
		}
		return true;
	},
	toggleBranchInternal: function(branch,location,layoutIndex,open) {
		var itemRenderer = this.dataToItemRenderer.get(branch);
		var state = null;
		if(itemRenderer != null) {
			state = this.itemRendererToItemState.get(itemRenderer);
		}
		var isTemporary = false;
		if(state == null) {
			isTemporary = true;
			state = this.itemStatePool.get();
		}
		state.location = location;
		state.layoutIndex = layoutIndex;
		var alreadyOpen = this.openBranches.indexOf(branch) != -1;
		if(open && !alreadyOpen) {
			this.openBranches.push(branch);
			this.populateCurrentItemState(branch,location,layoutIndex,state,true);
			layoutIndex = this.insertChildrenIntoVirtualCache(location,layoutIndex);
			if(itemRenderer != null) {
				var storage = this.itemStateToStorage(state);
				this.updateItemRenderer(itemRenderer,state,storage);
			}
			(feathers_events_TreeViewEvent().default).dispatch(this,"branchOpen",state);
		} else if(!open && alreadyOpen) {
			(HxOverrides().default).remove(this.openBranches,branch);
			this.populateCurrentItemState(branch,location,layoutIndex,state,true);
			this.removeChildrenFromVirtualCache(location,layoutIndex);
			if(itemRenderer != null) {
				var storage1 = this.itemStateToStorage(state);
				this.updateItemRenderer(itemRenderer,state,storage1);
			}
			(feathers_events_TreeViewEvent().default).dispatch(this,"branchClose",state);
		}
		if(isTemporary) {
			this.itemStatePool.release(state);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return layoutIndex;
	},
	toggleChildrenOfInternal: function(branch,location,layoutIndex,open) {
		layoutIndex = this.toggleBranchInternal(branch,location,layoutIndex,open);
		var itemCount = this._dataProvider.getLength(location);
		var _g = 0;
		var _g1 = itemCount;
		while(_g < _g1) {
			var i = _g++;
			location.push(i);
			var child = this._dataProvider.get(location);
			if(this._dataProvider.isBranch(child)) {
				this.toggleChildrenOfInternal(child,location,layoutIndex,open);
			}
			location.pop();
		}
	},
	refreshOpenBranchesFromDataProviderChange: function(removedItem,addedItem) {
		if(removedItem == null) {
			return;
		}
		var i = this.openBranches.length - 1;
		while(i >= 0) {
			var openBranch = this.openBranches[i];
			if(openBranch == removedItem) {
				if(removedItem != addedItem) {
					this.openBranches.splice(i,1);
				}
				continue;
			}
			var location = this._dataProvider.locationOf(openBranch);
			if(location == null) {
				this.openBranches.splice(i,1);
			}
			--i;
		}
	},
	treeView_itemRenderer_touchTapHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(event.isPrimaryTouchPoint) {
			return;
		}
		var itemRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this.itemRendererToItemState.get(itemRenderer);
		(feathers_events_TreeViewEvent().default).dispatch(this,"itemTrigger",state);
		if(!this._selectable || !this.pointerSelectionEnabled) {
			return;
		}
		this.set_selectedLocation(state.location.slice());
	},
	treeView_itemRenderer_clickHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		var itemRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this.itemRendererToItemState.get(itemRenderer);
		(feathers_events_TreeViewEvent().default).dispatch(this,"itemTrigger",state);
		if(!this._selectable || !this.pointerSelectionEnabled) {
			return;
		}
		this.set_selectedLocation(state.location.slice());
	},
	treeView_itemRenderer_triggerHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		var itemRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this.itemRendererToItemState.get(itemRenderer);
		(feathers_events_TreeViewEvent().default).dispatch(this,"itemTrigger",state);
		if(!this._selectable || !this.pointerSelectionEnabled) {
			return;
		}
		this.set_selectedLocation(state.location.slice());
	},
	treeView_itemRenderer_resizeHandler: function(event) {
		if(this._validating) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	treeView_itemRenderer_changeHandler: function(event) {
		if(this._ignoreSelectionChange) {
			return;
		}
		var itemRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var toggleItemRenderer = (js_Boot().default).__cast(itemRenderer , (feathers_controls_IToggle().default));
		var state = this.itemRendererToItemState.get(itemRenderer);
		if(toggleItemRenderer.get_selected() == state.selected) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
	},
	treeView_itemRenderer_openHandler: function(event) {
		if(this._ignoreOpenedChange) {
			return;
		}
		var itemRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this.itemRendererToItemState.get(itemRenderer);
		this.toggleBranch(state.data,true);
	},
	treeView_itemRenderer_closeHandler: function(event) {
		if(this._ignoreOpenedChange) {
			return;
		}
		var itemRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this.itemRendererToItemState.get(itemRenderer);
		this.toggleBranch(state.data,false);
	},
	treeView_dataProvider_changeHandler: function(event) {
		this._totalLayoutCount = this.calculateTotalLayoutCount([]);
		if(this._virtualCache != null) {
			this._virtualCache.length = 0;
			this._virtualCache.length = this._totalLayoutCount;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
	},
	treeView_dataProvider_addItemHandler: function(event) {
		if(this._selectedLocation == null) {
			return;
		}
		if(this.compareLocations(this._selectedLocation,event.location) >= 0) {
			this.set_selectedLocation(this._dataProvider.locationOf(this._selectedItem));
		}
	},
	treeView_dataProvider_removeItemHandler: function(event) {
		this.refreshOpenBranchesFromDataProviderChange(event.removedItem,event.addedItem);
		if(this._selectedLocation != null) {
			if(this.containsLocation(event.location,this._selectedLocation)) {
				this.set_selectedLocation(null);
			} else {
				var comparisonResult = this.compareLocations(this._selectedLocation,event.location);
				if(comparisonResult == 0) {
					this.set_selectedLocation(null);
				} else if(comparisonResult > 0) {
					this.set_selectedLocation(this._dataProvider.locationOf(this._selectedItem));
				}
			}
		}
	},
	treeView_dataProvider_replaceItemHandler: function(event) {
		this.refreshOpenBranchesFromDataProviderChange(event.removedItem,event.addedItem);
		if(this._selectedLocation != null) {
			if(this.containsLocation(event.location,this._selectedLocation)) {
				this.set_selectedLocation(null);
			} else if(this.compareLocations(this._selectedLocation,event.location) == 0) {
				this._selectedItem = this._dataProvider.get(event.location);
				(feathers_events_FeathersEvent().default).dispatch(this,"change");
			}
		}
	},
	treeView_dataProvider_removeAllHandler: function(event) {
		this.openBranches.length = 0;
		this.set_selectedLocation(null);
	},
	treeView_dataProvider_resetHandler: function(event) {
		this.openBranches.length = 0;
		this.set_selectedLocation(null);
	},
	treeView_dataProvider_sortChangeHandler: function(event) {
		this.refreshSelectedLocationAfterFilterOrSort();
	},
	treeView_dataProvider_filterChangeHandler: function(event) {
		this.refreshSelectedLocationAfterFilterOrSort();
	},
	updateItemRendererForLocation: function(location) {
		var layoutIndex = this.locationToDisplayIndex(location,false);
		if(this._virtualCache != null && layoutIndex != -1) {
			this._virtualCache[layoutIndex] = null;
		}
		var item = this._dataProvider.get(location);
		var itemRenderer = this.dataToItemRenderer.get(item);
		if(itemRenderer == null) {
			this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		} else {
			var state = this.itemRendererToItemState.get(itemRenderer);
			if(state.owner != null) {
				var storage = this.itemStateToStorage(state);
				this.populateCurrentItemState(item,location,layoutIndex,state,true);
				this.resetItemRenderer(itemRenderer,state,storage);
				if(storage.measurements != null) {
					storage.measurements.restore(itemRenderer);
				}
				state.owner = null;
				this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
			}
		}
		if(this._dataProvider.isBranch(item)) {
			var _g = 0;
			var _g1 = this._dataProvider.getLength(location);
			while(_g < _g1) {
				var i = _g++;
				location.push(i);
				this.updateItemRendererForLocation(location);
				location.pop();
			}
		}
	},
	treeView_dataProvider_updateItemHandler: function(event) {
		this.updateItemRendererForLocation(event.location);
	},
	treeView_dataProvider_updateAllHandler: function(event) {
		var location = [];
		var _g = 0;
		var _g1 = this._dataProvider.getLength();
		while(_g < _g1) {
			var i = _g++;
			location[0] = i;
			this.updateItemRendererForLocation(location);
		}
	},
	get_styleContext: function() {
		return TreeView
	},
	get_layout: function() {
		return this.__layout;
	},
	set_layout: function(value) {
		if(!this.setStyle("layout")) {
			return this.__layout;
		}
		if(this.__layout == value) {
			return this.__layout;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_layout);
		this.__layout = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__layout;
	},
	clearStyle_layout: function() {
		this.set_layout(null);
		return this.get_layout();
	},
	get_customItemRendererVariant: function() {
		return this.__customItemRendererVariant;
	},
	set_customItemRendererVariant: function(value) {
		if(!this.setStyle("customItemRendererVariant")) {
			return this.__customItemRendererVariant;
		}
		if(this.__customItemRendererVariant == value) {
			return this.__customItemRendererVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customItemRendererVariant);
		this.__customItemRendererVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customItemRendererVariant;
	},
	clearStyle_customItemRendererVariant: function() {
		this.set_customItemRendererVariant(null);
		return this.get_customItemRendererVariant();
	}
});
TreeView.prototype.__class__ = TreeView.prototype.constructor = $hxClasses["feathers.controls.TreeView"] = TreeView;

// Init



// Statics

TreeView.defaultUpdateItemRenderer = function(itemRenderer,state) {
	if((js_Boot().default).__implements(itemRenderer,(feathers_core_ITextControl().default))) {
		var textControl = (js_Boot().default).__cast(itemRenderer , (feathers_core_ITextControl().default));
		textControl.set_text(state.text);
	}
}
TreeView.defaultResetItemRenderer = function(itemRenderer,state) {
	if((js_Boot().default).__implements(itemRenderer,(feathers_core_ITextControl().default))) {
		var textControl = (js_Boot().default).__cast(itemRenderer , (feathers_core_ITextControl().default));
		textControl.set_text(null);
	}
}
TreeView.__meta__ = { obj : { defaultXmlProperty : ["dataProvider"]}}
TreeView.VARIANT_BORDERLESS = "borderless"
TreeView.VARIANT_BORDER = "border"
TreeView.CHILD_VARIANT_ITEM_RENDERER = "treeView_itemRenderer"
TreeView.INVALIDATION_FLAG_ITEM_RENDERER_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("itemRendererFactory")
TreeView.RESET_ITEM_STATE = new (feathers_data_TreeViewItemState().default)()

// Export

exports["default"] = TreeView;

/***/ }),

/***/ "./lib/_gen/feathers/controls/VDividedBox.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/controls/VDividedBox.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.VDividedBox

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_supportClasses_BaseDividedBox() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/BaseDividedBox */ "./lib/_gen/feathers/controls/supportClasses/BaseDividedBox.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_themes_steel_components_SteelVDividedBoxStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelVDividedBoxStyles */ "./lib/_gen/feathers/themes/steel/components/SteelVDividedBoxStyles.js");}
function feathers_layout_VDividedBoxLayout() {return __webpack_require__(/*! ./../../feathers/layout/VDividedBoxLayout */ "./lib/_gen/feathers/layout/VDividedBoxLayout.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_utils_DisplayUtil() {return __webpack_require__(/*! ./../../feathers/utils/DisplayUtil */ "./lib/_gen/feathers/utils/DisplayUtil.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}

// Constructor

var VDividedBox = function() {
	this._fallbackFluidIndex = -1;
	this._customItemHeights = [];
	this.initializeVDividedBoxTheme();
	(feathers_controls_supportClasses_BaseDividedBox().default).call(this);
}

// Meta

VDividedBox.__name__ = "feathers.controls.VDividedBox";
VDividedBox.__isInterface__ = false;
VDividedBox.__super__ = (feathers_controls_supportClasses_BaseDividedBox().default);
VDividedBox.prototype = $extend((feathers_controls_supportClasses_BaseDividedBox().default).prototype, {
	addItemAt: function(child,index) {
		var result = (feathers_controls_supportClasses_BaseDividedBox().default).prototype.addItemAt.call(this,child,index);
		var explicitHeight = null;
		if((js_Boot().default).__implements(child,(feathers_core_IMeasureObject().default))) {
			var measureChild = (js_Boot().default).__cast(child , (feathers_core_IMeasureObject().default));
			explicitHeight = measureChild.get_explicitHeight();
		}
		this._customItemHeights.splice(index,0,explicitHeight);
		var layoutIndex = this._layoutItems.indexOf(child);
		if(explicitHeight == null) {
			if(this._fallbackFluidIndex == -1 || layoutIndex > this._fallbackFluidIndex) {
				this._fallbackFluidIndex = layoutIndex;
			}
		}
		return result;
	},
	removeItem: function(child) {
		var index = this.items.indexOf(child);
		var layoutIndex = this._layoutItems.indexOf(child);
		if(this._fallbackFluidIndex == layoutIndex) {
			this._fallbackFluidIndex = -1;
		}
		var result = (feathers_controls_supportClasses_BaseDividedBox().default).prototype.removeItem.call(this,child);
		if(index != -1) {
			this._customItemHeights.splice(index,1);
		}
		return result;
	},
	initializeVDividedBoxTheme: function() {
		(feathers_themes_steel_components_SteelVDividedBoxStyles().default).initialize();
	},
	initialize: function() {
		(feathers_controls_supportClasses_BaseDividedBox().default).prototype.initialize.call(this);
		if(this._vDividedBoxLayout == null) {
			this._vDividedBoxLayout = new (feathers_layout_VDividedBoxLayout().default)();
		}
		this._vDividedBoxLayout.set_customItemHeights(this._customItemHeights);
		this.layout = this._vDividedBoxLayout;
	},
	handleLayout: function() {
		var oldIgnoreChildChanges = this._ignoreChildChanges;
		this._ignoreChildChanges = true;
		this._vDividedBoxLayout.set_fallbackFluidIndex(this._fallbackFluidIndex);
		this._ignoreChildChanges = oldIgnoreChildChanges;
		(feathers_controls_supportClasses_BaseDividedBox().default).prototype.handleLayout.call(this);
	},
	prepareResize: function(dividerIndex,stageX,stageY) {
		this._resizeStartStageY = stageY;
		var firstItem = this.items[dividerIndex];
		var secondItem = this.items[dividerIndex + 1];
		this._resizeStartHeight1 = firstItem.get_height();
		this._resizeStartHeight2 = secondItem.get_height();
		if(this._currentResizeDraggingSkin != null) {
			var divider = this.dividers[dividerIndex];
			this._currentResizeDraggingSkin.set_x(divider.get_x());
			this._currentResizeDraggingSkin.set_width(divider.get_width());
			if((js_Boot().default).__implements(this._currentResizeDraggingSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentResizeDraggingSkin , (feathers_core_IValidating().default))).validateNow();
			}
			this._currentResizeDraggingSkin.set_y(divider.get_y() + (divider.get_height() - this._currentResizeDraggingSkin.get_height()) / 2.0);
		}
	},
	commitResize: function(dividerIndex,stageX,stageY,live) {
		var offsetY = stageY - this._resizeStartStageY;
		offsetY *= (feathers_utils_DisplayUtil().default).getConcatenatedScaleY(this);
		if(live && !this.liveDragging) {
			if(this._currentResizeDraggingSkin != null) {
				var divider = this.dividers[dividerIndex];
				this._currentResizeDraggingSkin.set_x(divider.get_x());
				this._currentResizeDraggingSkin.set_width(divider.get_width());
				if((js_Boot().default).__implements(this._currentResizeDraggingSkin,(feathers_core_IValidating().default))) {
					((js_Boot().default).__cast(this._currentResizeDraggingSkin , (feathers_core_IValidating().default))).validateNow();
				}
				this._currentResizeDraggingSkin.set_y(divider.get_y() + offsetY + (divider.get_height() - this._currentResizeDraggingSkin.get_height()) / 2.0);
			}
			return;
		}
		var firstItem = this.items[dividerIndex];
		var secondItem = this.items[dividerIndex + 1];
		var totalHeight = this._resizeStartHeight1 + this._resizeStartHeight2;
		var secondItemHeight = this._resizeStartHeight2 - offsetY;
		if((js_Boot().default).__implements(secondItem,(feathers_core_IMeasureObject().default))) {
			var secondMeasureItem = (js_Boot().default).__cast(secondItem , (feathers_core_IMeasureObject().default));
			if(secondMeasureItem.get_explicitMinHeight() != null && secondItemHeight < secondMeasureItem.get_explicitMinHeight()) {
				secondItemHeight = secondMeasureItem.get_explicitMinHeight();
			} else if(secondMeasureItem.get_explicitMaxHeight() != null && secondItemHeight > secondMeasureItem.get_explicitMaxHeight()) {
				secondItemHeight = secondMeasureItem.get_explicitMaxHeight();
			}
		}
		if(secondItemHeight < 0.0) {
			secondItemHeight = 0.0;
		} else if(secondItemHeight > totalHeight) {
			secondItemHeight = totalHeight;
		}
		var firstItemHeight = totalHeight - secondItemHeight;
		if((js_Boot().default).__implements(firstItem,(feathers_core_IMeasureObject().default))) {
			var firstMeasureItem = (js_Boot().default).__cast(firstItem , (feathers_core_IMeasureObject().default));
			if(firstMeasureItem.get_explicitMinHeight() != null && firstItemHeight < firstMeasureItem.get_explicitMinHeight()) {
				firstItemHeight = firstMeasureItem.get_explicitMinHeight();
			} else if(firstMeasureItem.get_explicitMaxHeight() != null && firstItemHeight > firstMeasureItem.get_explicitMaxHeight()) {
				firstItemHeight = firstMeasureItem.get_explicitMaxHeight();
			}
		}
		if(firstItemHeight < 0.0) {
			firstItemHeight = 0.0;
		} else if(firstItemHeight > totalHeight) {
			firstItemHeight = totalHeight;
		}
		secondItemHeight = totalHeight - firstItemHeight;
		this._customItemHeights[dividerIndex] = firstItemHeight;
		this._customItemHeights[dividerIndex + 1] = secondItemHeight;
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	}
});
VDividedBox.prototype.__class__ = VDividedBox.prototype.constructor = $hxClasses["feathers.controls.VDividedBox"] = VDividedBox;

// Init



// Statics




// Export

exports["default"] = VDividedBox;

/***/ }),

/***/ "./lib/_gen/feathers/controls/VProgressBar.js":
/*!****************************************************!*\
  !*** ./lib/_gen/feathers/controls/VProgressBar.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.VProgressBar

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_supportClasses_BaseProgressBar() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/BaseProgressBar */ "./lib/_gen/feathers/controls/supportClasses/BaseProgressBar.js");}
function feathers_themes_steel_components_SteelVProgressBarStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelVProgressBarStyles */ "./lib/_gen/feathers/themes/steel/components/SteelVProgressBarStyles.js");}
function feathers_utils_MeasurementsUtil() {return __webpack_require__(/*! ./../../feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_graphics_FillStyle() {return __webpack_require__(/*! ./../../feathers/graphics/FillStyle */ "./lib/_gen/feathers/graphics/FillStyle.js");}
function openfl_geom_Rectangle() {return (__webpack_require__(/*! openfl */ "openfl").geom.Rectangle);}

// Constructor

var VProgressBar = function(value,minimum,maximum,changeListener) {
	if(maximum == null) {
		maximum = 1.0;
	}
	if(minimum == null) {
		minimum = 0.0;
	}
	if(value == null) {
		value = 0.0;
	}
	this.initializeVProgressBarTheme();
	(feathers_controls_supportClasses_BaseProgressBar().default).call(this,value,minimum,maximum,changeListener);
}

// Meta

VProgressBar.__name__ = "feathers.controls.VProgressBar";
VProgressBar.__isInterface__ = false;
VProgressBar.__super__ = (feathers_controls_supportClasses_BaseProgressBar().default);
VProgressBar.prototype = $extend((feathers_controls_supportClasses_BaseProgressBar().default).prototype, {
	initializeVProgressBarTheme: function() {
		(feathers_themes_steel_components_SteelVProgressBarStyles().default).initialize();
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		if(this._backgroundSkinMeasurements != null) {
			(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParent(this._backgroundSkinMeasurements,this._currentBackgroundSkin,this);
		}
		var measureBackgroundSkin = null;
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IMeasureObject().default))) {
			measureBackgroundSkin = (js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IMeasureObject().default));
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			if(this._currentBackgroundSkin != null) {
				newWidth = this._backgroundSkinMeasurements.width;
			} else {
				newWidth = 0.0;
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			if(this._currentBackgroundSkin != null) {
				newHeight = this._backgroundSkinMeasurements.height;
			} else {
				newHeight = 0.0;
			}
		}
		var newMinWidth = this.get_explicitMinWidth();
		var needsMinWidth1 = needsMinWidth;
		var newMinHeight = this.get_explicitMinHeight();
		var needsMinHeight1 = needsMinHeight;
		var newMaxWidth = this.get_explicitMaxWidth();
		var needsMaxWidth1 = needsMaxWidth;
		var newMaxHeight = this.get_explicitMaxHeight();
		var needsMaxHeight1 = needsMaxHeight;
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight,newMaxWidth,newMaxHeight);
	},
	layoutBackground: function() {
		if(this._currentBackgroundSkin == null) {
			return;
		}
		this._currentBackgroundSkin.set_x(0.0);
		this._currentBackgroundSkin.set_y(0.0);
		if(this._currentBackgroundSkin.get_width() != this.actualWidth) {
			this._currentBackgroundSkin.set_width(this.actualWidth);
		}
		if(this._currentBackgroundSkin.get_height() != this.actualHeight) {
			this._currentBackgroundSkin.set_height(this.actualHeight);
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
	},
	layoutFill: function() {
		if(this._currentFillSkin == null) {
			return;
		}
		var percentage = 1.0;
		if(this._minimum != this._maximum) {
			percentage = (this._value - this._minimum) / (this._maximum - this._minimum);
			if(percentage < 0.0) {
				percentage = 0.0;
			} else if(percentage > 1.0) {
				percentage = 1.0;
			}
		}
		var calculatedHeight = Math.round(percentage * (this.actualHeight - this.get_paddingTop() - this.get_paddingBottom()));
		this._currentFillSkin.set_x(this.get_paddingLeft());
		this._currentFillSkin.set_width(this.actualWidth - this.get_paddingLeft() - this.get_paddingRight());
		switch(this.get_fillMode()._hx_index) {
		case 0:
			this._currentFillSkin.set_scrollRect(null);
			if(this._currentMask == null) {
				this._currentMask = new (feathers_skins_RectangleSkin().default)((feathers_graphics_FillStyle().default).SolidColor(16711935));
				this.addChild(this._currentMask);
			}
			this._currentFillSkin.set_mask(this._currentMask);
			this._currentFillSkin.set_y(this.get_paddingTop());
			this._currentFillSkin.set_height(this.actualHeight - this.get_paddingTop() - this.get_paddingBottom());
			this._currentMask.set_x(this._currentFillSkin.get_x());
			this._currentMask.set_y(this.actualHeight - this.get_paddingBottom() - calculatedHeight);
			this._currentMask.set_width(this._currentFillSkin.get_width());
			this._currentMask.set_height(calculatedHeight);
			break;
		case 1:
			this._currentFillSkin.set_y(this.actualHeight - this.get_paddingBottom() - calculatedHeight);
			this._currentFillSkin.set_height(this.actualHeight - this.get_paddingTop() - this.get_paddingBottom());
			this._currentFillSkin.set_scrollRect(new (openfl_geom_Rectangle())(0.0,this._currentFillSkin.get_height() - calculatedHeight,this._currentFillSkin.get_width(),calculatedHeight));
			break;
		case 2:
			this._currentFillSkin.set_mask(null);
			this._currentFillSkin.set_scrollRect(null);
			if(this._currentMask != null) {
				if(this._currentMask.parent == this) {
					this.removeChild(this._currentMask);
				}
				this._currentMask = null;
			}
			if(this._fillSkinMeasurements.minHeight != null && calculatedHeight < this._fillSkinMeasurements.minHeight) {
				calculatedHeight = this._fillSkinMeasurements.minHeight;
				this._currentFillSkin.set_visible(this._value > this._minimum);
			} else {
				this._currentFillSkin.set_visible(true);
			}
			this._currentFillSkin.set_y(this.actualHeight - this.get_paddingBottom() - calculatedHeight);
			this._currentFillSkin.set_height(calculatedHeight);
			break;
		}
		if((js_Boot().default).__implements(this._currentFillSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentFillSkin , (feathers_core_IValidating().default))).validateNow();
		}
	},
	get_styleContext: function() {
		return VProgressBar
	}
});
VProgressBar.prototype.__class__ = VProgressBar.prototype.constructor = $hxClasses["feathers.controls.VProgressBar"] = VProgressBar;

// Init



// Statics




// Export

exports["default"] = VProgressBar;

/***/ }),

/***/ "./lib/_gen/feathers/controls/VScrollBar.js":
/*!**************************************************!*\
  !*** ./lib/_gen/feathers/controls/VScrollBar.js ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.VScrollBar

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_supportClasses_BaseScrollBar() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/BaseScrollBar */ "./lib/_gen/feathers/controls/supportClasses/BaseScrollBar.js");}
function feathers_themes_steel_components_SteelVScrollBarStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelVScrollBarStyles */ "./lib/_gen/feathers/themes/steel/components/SteelVScrollBarStyles.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}

// Constructor

var VScrollBar = function(value,minimum,maximum,changeListener) {
	if(maximum == null) {
		maximum = 1.0;
	}
	if(minimum == null) {
		minimum = 0.0;
	}
	if(value == null) {
		value = 0.0;
	}
	this.initializeVScrollBarTheme();
	(feathers_controls_supportClasses_BaseScrollBar().default).call(this,value,minimum,maximum,changeListener);
}

// Meta

VScrollBar.__name__ = "feathers.controls.VScrollBar";
VScrollBar.__isInterface__ = false;
VScrollBar.__super__ = (feathers_controls_supportClasses_BaseScrollBar().default);
VScrollBar.prototype = $extend((feathers_controls_supportClasses_BaseScrollBar().default).prototype, {
	initializeVScrollBarTheme: function() {
		(feathers_themes_steel_components_SteelVScrollBarStyles().default).initialize();
	},
	valueToLocation: function(value) {
		if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IValidating().default))).validateNow();
		}
		var normalized = this.normalizeValue(value);
		var trackScrollableHeight = this.actualHeight - this.get_paddingTop() - this.get_paddingBottom() - this._currentThumbSkin.get_height();
		return this.get_paddingTop() + trackScrollableHeight * normalized;
	},
	locationToValue: function(x,y) {
		var percentage = 0.0;
		var trackScrollableHeight = this.actualHeight - this.get_paddingTop() - this.get_paddingBottom() - this._currentThumbSkin.get_height();
		var yOffset = y - this._pointerStartY;
		var yPosition = Math.min(Math.max(0.0,this._thumbStartY - this.get_paddingTop() + yOffset),trackScrollableHeight);
		percentage = yPosition / trackScrollableHeight;
		return this._minimum + percentage * (this._maximum - this._minimum);
	},
	saveThumbStart: function(x,y) {
		var trackHeightMinusThumbHeight = this.actualHeight;
		var locationMinusHalfThumbHeight = y;
		if(this._currentThumbSkin != null) {
			trackHeightMinusThumbHeight -= this._currentThumbSkin.get_height();
			locationMinusHalfThumbHeight -= this._currentThumbSkin.get_height() / 2.0;
		}
		this._thumbStartX = x;
		this._thumbStartY = Math.min(trackHeightMinusThumbHeight,locationMinusHalfThumbHeight);
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		if(this._currentThumbSkin != null) {
			this._thumbSkinMeasurements.restore(this._currentThumbSkin);
			if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IValidating().default))).validateNow();
			}
		}
		if(this._currentTrackSkin != null) {
			this._trackSkinMeasurements.restore(this._currentTrackSkin);
			if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentTrackSkin , (feathers_core_IValidating().default))).validateNow();
			}
		}
		if(this._currentSecondaryTrackSkin != null) {
			this._secondaryTrackSkinMeasurements.restore(this._currentSecondaryTrackSkin);
			if((js_Boot().default).__implements(this._currentSecondaryTrackSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentSecondaryTrackSkin , (feathers_core_IValidating().default))).validateNow();
			}
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			newWidth = this.get_paddingLeft() + this.get_paddingRight();
			if(this._currentThumbSkin != null) {
				newWidth += this._currentThumbSkin.get_width();
			}
			if(this._currentTrackSkin != null) {
				if(newWidth < this._currentTrackSkin.get_width()) {
					newWidth = this._currentTrackSkin.get_width();
				}
				if(this._currentSecondaryTrackSkin != null && newWidth < this._currentSecondaryTrackSkin.get_width()) {
					newWidth = this._currentSecondaryTrackSkin.get_width();
				}
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			newHeight = 0.0;
			if(this._currentTrackSkin != null) {
				newHeight += this._currentTrackSkin.get_height();
				if(this._currentSecondaryTrackSkin != null) {
					newHeight += this._currentSecondaryTrackSkin.get_height();
				}
			}
			var thumbHeight = this.get_paddingTop() + this.get_paddingBottom();
			if(this._currentThumbSkin != null) {
				thumbHeight += this._currentThumbSkin.get_height();
			}
			if(newHeight < thumbHeight) {
				newHeight = thumbHeight;
			}
		}
		var newMinWidth = newWidth;
		var newMinHeight = newHeight;
		var newMaxWidth = newWidth;
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight,newMaxWidth,null);
	},
	layoutSplitTrack: function() {
		var location = this.valueToLocation(this.get_value());
		if(this._currentThumbSkin != null) {
			if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IValidating().default))).validateNow();
			}
			location += Math.round(this._currentThumbSkin.get_height() / 2.0);
		}
		this._currentSecondaryTrackSkin.set_y(0.0);
		this._currentSecondaryTrackSkin.set_height(location);
		this._currentTrackSkin.set_y(location);
		this._currentTrackSkin.set_height(this.actualHeight - location);
		if((js_Boot().default).__implements(this._currentSecondaryTrackSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentSecondaryTrackSkin , (feathers_core_IValidating().default))).validateNow();
		}
		if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentTrackSkin , (feathers_core_IValidating().default))).validateNow();
		}
		this._currentSecondaryTrackSkin.set_x((this.actualWidth - this._currentSecondaryTrackSkin.get_width()) / 2.0);
		this._currentTrackSkin.set_x((this.actualWidth - this._currentTrackSkin.get_width()) / 2.0);
	},
	layoutSingleTrack: function() {
		if(this._currentTrackSkin == null) {
			return;
		}
		this._currentTrackSkin.set_y(0.0);
		this._currentTrackSkin.set_height(this.actualHeight);
		if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentTrackSkin , (feathers_core_IValidating().default))).validateNow();
		}
		this._currentTrackSkin.set_x((this.actualWidth - this._currentTrackSkin.get_width()) / 2.0);
	},
	layoutThumb: function() {
		if(this._currentThumbSkin == null) {
			return;
		}
		var range = this._maximum - this._minimum;
		this._currentThumbSkin.set_visible((!this.get_hideThumbWhenDisabled() || this._enabled) && range > 0.0);
		if(!this._currentThumbSkin.get_visible()) {
			return;
		}
		if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IValidating().default))).validateNow();
		}
		var valueOffset = 0.0;
		if(this._value < this._minimum) {
			valueOffset = this._minimum - this._value;
		} else if(this._value > this._maximum) {
			valueOffset = this._value - this._maximum;
		}
		var contentWidth = this.actualWidth - this.get_paddingLeft() - this.get_paddingRight();
		var contentHeight = this.actualHeight - this.get_paddingTop() - this.get_paddingBottom();
		if(this.get_fixedThumbSize()) {
			if(this._thumbSkinMeasurements.height != null) {
				this._currentThumbSkin.set_height(this._thumbSkinMeasurements.height);
			}
		} else {
			var adjustedPage = this.getAdjustedPage();
			var thumbHeight = contentHeight * adjustedPage / (range + adjustedPage);
			if(thumbHeight > 0.0) {
				var heightOffset = contentHeight - thumbHeight;
				if(heightOffset > thumbHeight) {
					heightOffset = thumbHeight;
				}
				heightOffset *= valueOffset / (range * thumbHeight / contentHeight);
				thumbHeight -= heightOffset;
			}
			if(this._thumbSkinMeasurements.minHeight != null) {
				if(thumbHeight < this._thumbSkinMeasurements.minHeight) {
					thumbHeight = this._thumbSkinMeasurements.minHeight;
				}
			} else if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IMeasureObject().default))) {
				var measureSkin = (js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IMeasureObject().default));
				if(thumbHeight < measureSkin.get_minHeight()) {
					thumbHeight = measureSkin.get_minHeight();
				}
			}
			if(thumbHeight < 0.0) {
				thumbHeight = 0.0;
			}
			this._currentThumbSkin.set_height(thumbHeight);
		}
		this._currentThumbSkin.set_x(this.get_paddingLeft() + (contentWidth - this._currentThumbSkin.get_width()) / 2.0);
		this._currentThumbSkin.set_y(this.valueToLocation(this._value));
	},
	get_styleContext: function() {
		return VScrollBar
	}
});
VScrollBar.prototype.__class__ = VScrollBar.prototype.constructor = $hxClasses["feathers.controls.VScrollBar"] = VScrollBar;

// Init



// Statics




// Export

exports["default"] = VScrollBar;

/***/ }),

/***/ "./lib/_gen/feathers/controls/VSlider.js":
/*!***********************************************!*\
  !*** ./lib/_gen/feathers/controls/VSlider.js ***!
  \***********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.VSlider

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_supportClasses_BaseSlider() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/BaseSlider */ "./lib/_gen/feathers/controls/supportClasses/BaseSlider.js");}
function feathers_themes_steel_components_SteelVSliderStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelVSliderStyles */ "./lib/_gen/feathers/themes/steel/components/SteelVSliderStyles.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}

// Constructor

var VSlider = function(value,minimum,maximum,changeListener) {
	if(maximum == null) {
		maximum = 1.0;
	}
	if(minimum == null) {
		minimum = 0.0;
	}
	if(value == null) {
		value = 0.0;
	}
	this.initializeVSliderTheme();
	(feathers_controls_supportClasses_BaseSlider().default).call(this,value,minimum,maximum,changeListener);
	this.addEventListener("keyDown",$bind(this,this.vSlider_keyDownHandler));
}

// Meta

VSlider.__name__ = "feathers.controls.VSlider";
VSlider.__isInterface__ = false;
VSlider.__super__ = (feathers_controls_supportClasses_BaseSlider().default);
VSlider.prototype = $extend((feathers_controls_supportClasses_BaseSlider().default).prototype, {
	initializeVSliderTheme: function() {
		(feathers_themes_steel_components_SteelVSliderStyles().default).initialize();
	},
	valueToLocation: function(value) {
		if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IValidating().default))).validateNow();
		}
		var normalized = this.normalizeValue(value);
		var trackScrollableHeight = this.actualHeight - this.get_minimumPadding() - this.get_maximumPadding();
		if(this._currentThumbSkin != null) {
			trackScrollableHeight -= this._currentThumbSkin.get_height();
		}
		return Math.round(this.get_maximumPadding() + trackScrollableHeight * (1.0 - normalized));
	},
	locationToValue: function(x,y) {
		var percentage = 0.0;
		var trackScrollableHeight = this.actualHeight - this.get_minimumPadding() - this.get_maximumPadding();
		if(this._currentThumbSkin != null) {
			trackScrollableHeight -= this._currentThumbSkin.get_height();
		}
		var yOffset = y - this._pointerStartY - this.get_maximumPadding();
		var yPosition = Math.min(Math.max(0.0,this._thumbStartY + yOffset),trackScrollableHeight);
		percentage = 1.0 - yPosition / trackScrollableHeight;
		return this._minimum + percentage * (this._maximum - this._minimum);
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		if(this._currentThumbSkin != null) {
			this._thumbSkinMeasurements.restore(this._currentThumbSkin);
			if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IValidating().default))).validateNow();
			}
		}
		if(this._currentTrackSkin != null) {
			this._trackSkinMeasurements.restore(this._currentTrackSkin);
			if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentTrackSkin , (feathers_core_IValidating().default))).validateNow();
			}
		}
		if(this._currentSecondaryTrackSkin != null) {
			this._secondaryTrackSkinMeasurements.restore(this._currentSecondaryTrackSkin);
			if((js_Boot().default).__implements(this._currentSecondaryTrackSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentSecondaryTrackSkin , (feathers_core_IValidating().default))).validateNow();
			}
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			newWidth = 0.0;
			if(this._currentThumbSkin != null) {
				newWidth += this._currentThumbSkin.get_width();
			}
			if(this._currentTrackSkin != null) {
				if(newWidth < this._currentTrackSkin.get_width()) {
					newWidth = this._currentTrackSkin.get_width();
				}
				if(this._currentSecondaryTrackSkin != null && newWidth < this._currentSecondaryTrackSkin.get_width()) {
					newWidth = this._currentSecondaryTrackSkin.get_width();
				}
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			newHeight = 0.0;
			if(this._currentTrackSkin != null) {
				newHeight += this._currentTrackSkin.get_height();
				if(this._currentSecondaryTrackSkin != null) {
					newHeight += this._currentSecondaryTrackSkin.get_height();
				}
			}
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			newMinWidth = 0.0;
			if(this._currentThumbSkin != null) {
				newMinWidth += this._currentThumbSkin.get_width();
			}
			if(this._currentTrackSkin != null) {
				if(newMinWidth < this._currentTrackSkin.get_width()) {
					newMinWidth = this._currentTrackSkin.get_width();
				}
				if(this._currentSecondaryTrackSkin != null && newMinWidth < this._currentSecondaryTrackSkin.get_width()) {
					newMinWidth = this._currentSecondaryTrackSkin.get_width();
				}
			}
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			newMinHeight = 0.0;
			if(this._currentTrackSkin != null) {
				newMinHeight += this._currentTrackSkin.get_height();
				if(this._currentSecondaryTrackSkin != null) {
					newMinHeight += this._secondaryTrackSkinMeasurements.height;
				}
			}
		}
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight);
	},
	saveThumbStart: function(x,y) {
		var trackHeightMinusThumbHeight = this.actualHeight;
		var locationMinusHalfThumbHeight = y;
		if(this._currentThumbSkin != null) {
			trackHeightMinusThumbHeight -= this._currentThumbSkin.get_height();
			locationMinusHalfThumbHeight -= this._currentThumbSkin.get_height() / 2.0;
		}
		this._thumbStartX = x;
		this._thumbStartY = Math.min(trackHeightMinusThumbHeight - this.get_maximumPadding(),Math.max(this.get_minimumPadding(),locationMinusHalfThumbHeight));
	},
	layoutSplitTrack: function() {
		var location = this.valueToLocation(this.get_value());
		if(this._currentThumbSkin != null) {
			if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IValidating().default))).validateNow();
			}
			location += Math.round(this._currentThumbSkin.get_height() / 2.0);
		}
		this._currentSecondaryTrackSkin.set_y(0.0);
		this._currentSecondaryTrackSkin.set_height(location);
		this._currentTrackSkin.set_y(location);
		this._currentTrackSkin.set_height(this.actualHeight - location);
		if((js_Boot().default).__implements(this._currentSecondaryTrackSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentSecondaryTrackSkin , (feathers_core_IValidating().default))).validateNow();
		}
		if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentTrackSkin , (feathers_core_IValidating().default))).validateNow();
		}
		this._currentSecondaryTrackSkin.set_x((this.actualWidth - this._currentSecondaryTrackSkin.get_width()) / 2.0);
		this._currentTrackSkin.set_x((this.actualWidth - this._currentTrackSkin.get_width()) / 2.0);
	},
	layoutSingleTrack: function() {
		if(this._currentTrackSkin == null) {
			return;
		}
		this._currentTrackSkin.set_y(0.0);
		this._currentTrackSkin.set_height(this.actualHeight);
		if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentTrackSkin , (feathers_core_IValidating().default))).validateNow();
		}
		this._currentTrackSkin.set_x((this.actualWidth - this._currentTrackSkin.get_width()) / 2.0);
	},
	layoutThumb: function() {
		if(this._currentThumbSkin == null) {
			return;
		}
		var thumbLocation = this.valueToLocation(this._value);
		this._currentThumbSkin.set_x((this.actualWidth - this._currentThumbSkin.get_width()) / 2.0);
		this._currentThumbSkin.set_y(thumbLocation);
	},
	vSlider_keyDownHandler: function(event) {
		if(event.isDefaultPrevented()) {
			return;
		}
		if(!this._enabled) {
			return;
		}
		var newValue = this._value;
		switch(event.keyCode) {
		case 35:
			newValue = this._maximum;
			break;
		case 36:
			newValue = this._minimum;
			break;
		case 38:
			newValue += this._step;
			break;
		case 40:
			newValue -= this._step;
			break;
		default:
			return;
		}
		if(newValue < this._minimum) {
			newValue = this._minimum;
		} else if(newValue > this._maximum) {
			newValue = this._maximum;
		}
		event.preventDefault();
		this.set_value(newValue);
	},
	get_styleContext: function() {
		return VSlider
	}
});
VSlider.prototype.__class__ = VSlider.prototype.constructor = $hxClasses["feathers.controls.VSlider"] = VSlider;

// Init



// Statics




// Export

exports["default"] = VSlider;

/***/ }),

/***/ "./lib/_gen/feathers/controls/_Alert/StringWrapper.js":
/*!************************************************************!*\
  !*** ./lib/_gen/feathers/controls/_Alert/StringWrapper.js ***!
  \************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls._Alert.StringWrapper

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var StringWrapper = function(text) {
	this._text = text;
}

// Meta

StringWrapper.__name__ = "feathers.controls._Alert.StringWrapper";
StringWrapper.__isInterface__ = false;
StringWrapper.prototype = {
	toString: function() {
		return this._text;
	}
};
StringWrapper.prototype.__class__ = StringWrapper.prototype.constructor = $hxClasses["feathers.controls._Alert.StringWrapper"] = StringWrapper;

// Init



// Statics




// Export

exports["default"] = StringWrapper;

/***/ }),

/***/ "./lib/_gen/feathers/controls/_ButtonBar/ButtonStorage.js":
/*!****************************************************************!*\
  !*** ./lib/_gen/feathers/controls/_ButtonBar/ButtonStorage.js ***!
  \****************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls._ButtonBar.ButtonStorage

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var ButtonStorage = function(id,recycler) {
	this.inactiveButtons = [];
	this.activeButtons = [];
	this.id = id;
	this.buttonRecycler = recycler;
}

// Meta

ButtonStorage.__name__ = "feathers.controls._ButtonBar.ButtonStorage";
ButtonStorage.__isInterface__ = false;
ButtonStorage.prototype = {
	
};
ButtonStorage.prototype.__class__ = ButtonStorage.prototype.constructor = $hxClasses["feathers.controls._ButtonBar.ButtonStorage"] = ButtonStorage;

// Init



// Statics




// Export

exports["default"] = ButtonStorage;

/***/ }),

/***/ "./lib/_gen/feathers/controls/_DatePicker/DateRendererStorage.js":
/*!***********************************************************************!*\
  !*** ./lib/_gen/feathers/controls/_DatePicker/DateRendererStorage.js ***!
  \***********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls._DatePicker.DateRendererStorage

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var DateRendererStorage = function(id,recycler) {
	this.inactiveDateRenderers = [];
	this.activeDateRenderers = [];
	this.id = id;
	this.dateRendererRecycler = recycler;
}

// Meta

DateRendererStorage.__name__ = "feathers.controls._DatePicker.DateRendererStorage";
DateRendererStorage.__isInterface__ = false;
DateRendererStorage.prototype = {
	
};
DateRendererStorage.prototype.__class__ = DateRendererStorage.prototype.constructor = $hxClasses["feathers.controls._DatePicker.DateRendererStorage"] = DateRendererStorage;

// Init



// Statics




// Export

exports["default"] = DateRendererStorage;

/***/ }),

/***/ "./lib/_gen/feathers/controls/_GridView/ColumnDividerStorage.js":
/*!**********************************************************************!*\
  !*** ./lib/_gen/feathers/controls/_GridView/ColumnDividerStorage.js ***!
  \**********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls._GridView.ColumnDividerStorage

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var ColumnDividerStorage = function(factory) {
	this.inactiveColumnDividers = [];
	this.activeColumnDividers = [];
	this.columnDividerFactory = factory;
}

// Meta

ColumnDividerStorage.__name__ = "feathers.controls._GridView.ColumnDividerStorage";
ColumnDividerStorage.__isInterface__ = false;
ColumnDividerStorage.prototype = {
	
};
ColumnDividerStorage.prototype.__class__ = ColumnDividerStorage.prototype.constructor = $hxClasses["feathers.controls._GridView.ColumnDividerStorage"] = ColumnDividerStorage;

// Init



// Statics




// Export

exports["default"] = ColumnDividerStorage;

/***/ }),

/***/ "./lib/_gen/feathers/controls/_GridView/HeaderDividerStorage.js":
/*!**********************************************************************!*\
  !*** ./lib/_gen/feathers/controls/_GridView/HeaderDividerStorage.js ***!
  \**********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls._GridView.HeaderDividerStorage

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var HeaderDividerStorage = function(factory) {
	this.inactiveHeaderDividers = [];
	this.activeHeaderDividers = [];
	this.headerDividerFactory = factory;
}

// Meta

HeaderDividerStorage.__name__ = "feathers.controls._GridView.HeaderDividerStorage";
HeaderDividerStorage.__isInterface__ = false;
HeaderDividerStorage.prototype = {
	
};
HeaderDividerStorage.prototype.__class__ = HeaderDividerStorage.prototype.constructor = $hxClasses["feathers.controls._GridView.HeaderDividerStorage"] = HeaderDividerStorage;

// Init



// Statics




// Export

exports["default"] = HeaderDividerStorage;

/***/ }),

/***/ "./lib/_gen/feathers/controls/_GridView/HeaderRendererStorage.js":
/*!***********************************************************************!*\
  !*** ./lib/_gen/feathers/controls/_GridView/HeaderRendererStorage.js ***!
  \***********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls._GridView.HeaderRendererStorage

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var HeaderRendererStorage = function(recycler) {
	this.inactiveHeaderRenderers = [];
	this.activeHeaderRenderers = [];
	this.headerRendererRecycler = recycler;
}

// Meta

HeaderRendererStorage.__name__ = "feathers.controls._GridView.HeaderRendererStorage";
HeaderRendererStorage.__isInterface__ = false;
HeaderRendererStorage.prototype = {
	
};
HeaderRendererStorage.prototype.__class__ = HeaderRendererStorage.prototype.constructor = $hxClasses["feathers.controls._GridView.HeaderRendererStorage"] = HeaderRendererStorage;

// Init



// Statics




// Export

exports["default"] = HeaderRendererStorage;

/***/ }),

/***/ "./lib/_gen/feathers/controls/_GroupListView/ItemRendererStorage.js":
/*!**************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/_GroupListView/ItemRendererStorage.js ***!
  \**************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls._GroupListView.ItemRendererStorage

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var ItemRendererStorage = function(type,id,recycler) {
	this.inactiveItemRenderers = [];
	this.activeItemRenderers = [];
	this.type = type;
	this.id = id;
	this.itemRendererRecycler = recycler;
}

// Meta

ItemRendererStorage.__name__ = "feathers.controls._GroupListView.ItemRendererStorage";
ItemRendererStorage.__isInterface__ = false;
ItemRendererStorage.prototype = {
	
};
ItemRendererStorage.prototype.__class__ = ItemRendererStorage.prototype.constructor = $hxClasses["feathers.controls._GroupListView.ItemRendererStorage"] = ItemRendererStorage;

// Init



// Statics




// Export

exports["default"] = ItemRendererStorage;

/***/ }),

/***/ "./lib/_gen/feathers/controls/_ListView/ItemRendererStorage.js":
/*!*********************************************************************!*\
  !*** ./lib/_gen/feathers/controls/_ListView/ItemRendererStorage.js ***!
  \*********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls._ListView.ItemRendererStorage

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var ItemRendererStorage = function(id,recycler) {
	this.inactiveItemRenderers = [];
	this.activeItemRenderers = [];
	this.id = id;
	this.itemRendererRecycler = recycler;
}

// Meta

ItemRendererStorage.__name__ = "feathers.controls._ListView.ItemRendererStorage";
ItemRendererStorage.__isInterface__ = false;
ItemRendererStorage.prototype = {
	
};
ItemRendererStorage.prototype.__class__ = ItemRendererStorage.prototype.constructor = $hxClasses["feathers.controls._ListView.ItemRendererStorage"] = ItemRendererStorage;

// Init



// Statics




// Export

exports["default"] = ItemRendererStorage;

/***/ }),

/***/ "./lib/_gen/feathers/controls/_TabBar/TabStorage.js":
/*!**********************************************************!*\
  !*** ./lib/_gen/feathers/controls/_TabBar/TabStorage.js ***!
  \**********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls._TabBar.TabStorage

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var TabStorage = function(id,recycler) {
	this.inactiveTabs = [];
	this.activeTabs = [];
	this.id = id;
	this.tabRecycler = recycler;
}

// Meta

TabStorage.__name__ = "feathers.controls._TabBar.TabStorage";
TabStorage.__isInterface__ = false;
TabStorage.prototype = {
	
};
TabStorage.prototype.__class__ = TabStorage.prototype.constructor = $hxClasses["feathers.controls._TabBar.TabStorage"] = TabStorage;

// Init



// Statics




// Export

exports["default"] = TabStorage;

/***/ }),

/***/ "./lib/_gen/feathers/controls/_TreeGridView/ColumnDividerStorage.js":
/*!**************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/_TreeGridView/ColumnDividerStorage.js ***!
  \**************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls._TreeGridView.ColumnDividerStorage

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var ColumnDividerStorage = function(factory) {
	this.inactiveColumnDividers = [];
	this.activeColumnDividers = [];
	this.columnDividerFactory = factory;
}

// Meta

ColumnDividerStorage.__name__ = "feathers.controls._TreeGridView.ColumnDividerStorage";
ColumnDividerStorage.__isInterface__ = false;
ColumnDividerStorage.prototype = {
	
};
ColumnDividerStorage.prototype.__class__ = ColumnDividerStorage.prototype.constructor = $hxClasses["feathers.controls._TreeGridView.ColumnDividerStorage"] = ColumnDividerStorage;

// Init



// Statics




// Export

exports["default"] = ColumnDividerStorage;

/***/ }),

/***/ "./lib/_gen/feathers/controls/_TreeGridView/HeaderDividerStorage.js":
/*!**************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/_TreeGridView/HeaderDividerStorage.js ***!
  \**************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls._TreeGridView.HeaderDividerStorage

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var HeaderDividerStorage = function(factory) {
	this.inactiveHeaderDividers = [];
	this.activeHeaderDividers = [];
	this.headerDividerFactory = factory;
}

// Meta

HeaderDividerStorage.__name__ = "feathers.controls._TreeGridView.HeaderDividerStorage";
HeaderDividerStorage.__isInterface__ = false;
HeaderDividerStorage.prototype = {
	
};
HeaderDividerStorage.prototype.__class__ = HeaderDividerStorage.prototype.constructor = $hxClasses["feathers.controls._TreeGridView.HeaderDividerStorage"] = HeaderDividerStorage;

// Init



// Statics




// Export

exports["default"] = HeaderDividerStorage;

/***/ }),

/***/ "./lib/_gen/feathers/controls/_TreeGridView/HeaderRendererStorage.js":
/*!***************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/_TreeGridView/HeaderRendererStorage.js ***!
  \***************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls._TreeGridView.HeaderRendererStorage

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var HeaderRendererStorage = function(recycler) {
	this.inactiveHeaderRenderers = [];
	this.activeHeaderRenderers = [];
	this.headerRendererRecycler = recycler;
}

// Meta

HeaderRendererStorage.__name__ = "feathers.controls._TreeGridView.HeaderRendererStorage";
HeaderRendererStorage.__isInterface__ = false;
HeaderRendererStorage.prototype = {
	
};
HeaderRendererStorage.prototype.__class__ = HeaderRendererStorage.prototype.constructor = $hxClasses["feathers.controls._TreeGridView.HeaderRendererStorage"] = HeaderRendererStorage;

// Init



// Statics




// Export

exports["default"] = HeaderRendererStorage;

/***/ }),

/***/ "./lib/_gen/feathers/controls/_TreeView/ItemRendererStorage.js":
/*!*********************************************************************!*\
  !*** ./lib/_gen/feathers/controls/_TreeView/ItemRendererStorage.js ***!
  \*********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls._TreeView.ItemRendererStorage

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var ItemRendererStorage = function(id,recycler) {
	this.inactiveItemRenderers = [];
	this.activeItemRenderers = [];
	this.id = id;
	this.itemRendererRecycler = recycler;
}

// Meta

ItemRendererStorage.__name__ = "feathers.controls._TreeView.ItemRendererStorage";
ItemRendererStorage.__isInterface__ = false;
ItemRendererStorage.prototype = {
	
};
ItemRendererStorage.prototype.__class__ = ItemRendererStorage.prototype.constructor = $hxClasses["feathers.controls._TreeView.ItemRendererStorage"] = ItemRendererStorage;

// Init



// Statics




// Export

exports["default"] = ItemRendererStorage;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/GridViewHeaderRenderer.js":
/*!****************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/GridViewHeaderRenderer.js ***!
  \****************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers.GridViewHeaderRenderer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_data_ISortOrderObserver() {return __webpack_require__(/*! ./../../../feathers/data/ISortOrderObserver */ "./lib/_gen/feathers/data/ISortOrderObserver.js");}
function feathers_controls_dataRenderers_IGridViewHeaderRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/IGridViewHeaderRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IGridViewHeaderRenderer.js");}
function feathers_controls_dataRenderers_ItemRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/ItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ItemRenderer.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_themes_steel_components_SteelGridViewHeaderRendererStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelGridViewHeaderRendererStyles */ "./lib/_gen/feathers/themes/steel/components/SteelGridViewHeaderRendererStyles.js");}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function Std() {return __webpack_require__(/*! ./../../../Std */ "./lib/_gen/Std.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_core_IStateObserver() {return __webpack_require__(/*! ./../../../feathers/core/IStateObserver */ "./lib/_gen/feathers/core/IStateObserver.js");}
function feathers_data_SortOrder() {return __webpack_require__(/*! ./../../../feathers/data/SortOrder */ "./lib/_gen/feathers/data/SortOrder.js");}

// Constructor

var GridViewHeaderRenderer = function() {
	this.__sortDescendingIcon = null;
	this.__sortAscendingIcon = null;
	this._sortOrder = (feathers_data_SortOrder().default).NONE;
	this._columnIndex = -1;
	this.initializeGridViewHeaderRendererTheme();
	(feathers_controls_dataRenderers_ItemRenderer().default).call(this);
	this.set_toggleable(false);
}

// Meta

GridViewHeaderRenderer.__name__ = "feathers.controls.dataRenderers.GridViewHeaderRenderer";
GridViewHeaderRenderer.__isInterface__ = false;
GridViewHeaderRenderer.__interfaces__ = [(feathers_data_ISortOrderObserver().default),(feathers_controls_dataRenderers_IGridViewHeaderRenderer().default)];
GridViewHeaderRenderer.__super__ = (feathers_controls_dataRenderers_ItemRenderer().default);
GridViewHeaderRenderer.prototype = $extend((feathers_controls_dataRenderers_ItemRenderer().default).prototype, {
	get_column: function() {
		return this._column;
	},
	set_column: function(value) {
		if(this._column == value) {
			return this._column;
		}
		this._column = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._column;
	},
	get_columnIndex: function() {
		return this._columnIndex;
	},
	set_columnIndex: function(value) {
		if(this._columnIndex == value) {
			return this._columnIndex;
		}
		this._columnIndex = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._columnIndex;
	},
	get_gridViewOwner: function() {
		return this._gridViewOwner;
	},
	set_gridViewOwner: function(value) {
		if(this._gridViewOwner == value) {
			return this._gridViewOwner;
		}
		this._gridViewOwner = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._gridViewOwner;
	},
	get_sortOrder: function() {
		return this._sortOrder;
	},
	set_sortOrder: function(value) {
		if(this._sortOrder == value) {
			return this._sortOrder;
		}
		this._sortOrder = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._sortOrder;
	},
	initializeGridViewHeaderRendererTheme: function() {
		(feathers_themes_steel_components_SteelGridViewHeaderRendererStyles().default).initialize();
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(stylesInvalid || stateInvalid || dataInvalid) {
			this.refreshSortOrderIcon();
		}
		(feathers_controls_dataRenderers_ItemRenderer().default).prototype.update.call(this);
	},
	calculateExplicitWidthForTextMeasurement: function() {
		var textFieldExplicitWidth = (feathers_controls_dataRenderers_ItemRenderer().default).prototype.calculateExplicitWidthForTextMeasurement.call(this);
		if(textFieldExplicitWidth == null) {
			return textFieldExplicitWidth;
		}
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		if(this._currentSortOrderIcon != null) {
			if((js_Boot().default).__implements(this._currentSortOrderIcon,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentSortOrderIcon , (feathers_core_IValidating().default))).validateNow();
			}
			textFieldExplicitWidth -= this._currentSortOrderIcon.get_width() + adjustedGap;
		}
		if(textFieldExplicitWidth < 0.0) {
			textFieldExplicitWidth = 0.0;
		}
		return textFieldExplicitWidth;
	},
	measureContentWidth: function() {
		var contentWidth = (feathers_controls_dataRenderers_ItemRenderer().default).prototype.measureContentWidth.call(this);
		if((js_Boot().default).__implements(this._currentSortOrderIcon,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentSortOrderIcon , (feathers_core_IValidating().default))).validateNow();
		}
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		if(this._currentSortOrderIcon != null) {
			contentWidth += this._currentSortOrderIcon.get_width() + adjustedGap;
		}
		return contentWidth;
	},
	measureContentMinWidth: function() {
		var contentMinWidth = (feathers_controls_dataRenderers_ItemRenderer().default).prototype.measureContentMinWidth.call(this);
		if((js_Boot().default).__implements(this._currentSortOrderIcon,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentSortOrderIcon , (feathers_core_IValidating().default))).validateNow();
		}
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		if(this._currentSortOrderIcon != null) {
			contentMinWidth += this._currentSortOrderIcon.get_width() + adjustedGap;
		}
		return contentMinWidth;
	},
	layoutChildren: function() {
		var _gthis = this;
		if((js_Boot().default).__implements(this._currentSortOrderIcon,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentSortOrderIcon , (feathers_core_IValidating().default))).validateNow();
		}
		var paddingRight = this.get_paddingRight();
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		this.runWithoutInvalidation(function() {
			var newPaddingRight = paddingRight;
			if(_gthis._currentSortOrderIcon != null) {
				newPaddingRight += _gthis._currentSortOrderIcon.get_width() + adjustedGap;
			}
			return _gthis.set_paddingRight(newPaddingRight);
		});
		(feathers_controls_dataRenderers_ItemRenderer().default).prototype.layoutChildren.call(this);
		this.runWithoutInvalidation(function() {
			return _gthis.set_paddingRight(paddingRight);
		});
		if(this._currentSortOrderIcon != null) {
			this._currentSortOrderIcon.set_x(this.actualWidth - this.get_paddingRight() - this._currentSortOrderIcon.get_width());
			switch(this.get_verticalAlign()._hx_index) {
			case 0:
				this._currentSortOrderIcon.set_y(this.get_paddingTop());
				break;
			case 1:
				this._currentSortOrderIcon.set_y(Math.max(this.get_paddingTop(),this.get_paddingTop() + (this.actualHeight - this.get_paddingTop() - this.get_paddingBottom() - this._currentSortOrderIcon.get_height()) / 2.0));
				break;
			case 2:
				this._currentSortOrderIcon.set_y(Math.max(this.get_paddingTop(),this.get_paddingTop() + this.actualHeight - this.get_paddingTop() - this.get_paddingBottom() - this._currentSortOrderIcon.get_height()));
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown vertical align: " + (Std().default).string(this.get_verticalAlign())));
			}
		}
	},
	refreshSortOrderIcon: function() {
		var oldIcon = this._currentSortOrderIcon;
		this._currentSortOrderIcon = this.getCurrentSortOrderIcon();
		if(this._currentSortOrderIcon == oldIcon) {
			return;
		}
		this.removeCurrentSortOrderIcon(oldIcon);
		if(this._currentSortOrderIcon == null) {
			this._sortOrderIconMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(this._currentSortOrderIcon,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._currentSortOrderIcon , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._sortOrderIconMeasurements == null) {
			this._sortOrderIconMeasurements = new (feathers_layout_Measurements().default)(this._currentSortOrderIcon);
		} else {
			this._sortOrderIconMeasurements.save(this._currentSortOrderIcon);
		}
		if((js_Boot().default).__implements(this._currentSortOrderIcon,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(this._currentSortOrderIcon , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		if((js_Boot().default).__implements(this._currentSortOrderIcon,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(this._currentSortOrderIcon , (feathers_core_IStateObserver().default))).set_stateContext(this);
		}
		this.addChild(this._currentSortOrderIcon);
	},
	getCurrentSortOrderIcon: function() {
		switch(this._sortOrder._hx_index) {
		case 0:
			return this.get_sortAscendingIcon();
		case 1:
			return this.get_sortDescendingIcon();
		default:
			return null;
		}
	},
	removeCurrentSortOrderIcon: function(icon) {
		if(icon == null) {
			return;
		}
		if((js_Boot().default).__implements(icon,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(icon , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		if((js_Boot().default).__implements(icon,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(icon , (feathers_core_IStateObserver().default))).set_stateContext(null);
		}
		this._sortOrderIconMeasurements.restore(icon);
		if(icon.parent == this) {
			this.removeChild(icon);
		}
	},
	get_styleContext: function() {
		return GridViewHeaderRenderer
	},
	get_sortAscendingIcon: function() {
		return this.__sortAscendingIcon;
	},
	set_sortAscendingIcon: function(value) {
		if(!this.setStyle("sortAscendingIcon")) {
			return this.__sortAscendingIcon;
		}
		if(this.__sortAscendingIcon == value) {
			return this.__sortAscendingIcon;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_sortAscendingIcon);
		this.__sortAscendingIcon = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__sortAscendingIcon;
	},
	clearStyle_sortAscendingIcon: function() {
		this.set_sortAscendingIcon(null);
		return this.get_sortAscendingIcon();
	},
	get_sortDescendingIcon: function() {
		return this.__sortDescendingIcon;
	},
	set_sortDescendingIcon: function(value) {
		if(!this.setStyle("sortDescendingIcon")) {
			return this.__sortDescendingIcon;
		}
		if(this.__sortDescendingIcon == value) {
			return this.__sortDescendingIcon;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_sortDescendingIcon);
		this.__sortDescendingIcon = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__sortDescendingIcon;
	},
	clearStyle_sortDescendingIcon: function() {
		this.set_sortDescendingIcon(null);
		return this.get_sortDescendingIcon();
	}
});
GridViewHeaderRenderer.prototype.__class__ = GridViewHeaderRenderer.prototype.constructor = $hxClasses["feathers.controls.dataRenderers.GridViewHeaderRenderer"] = GridViewHeaderRenderer;

// Init



// Statics




// Export

exports["default"] = GridViewHeaderRenderer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/GridViewRowRenderer.js":
/*!*************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/GridViewRowRenderer.js ***!
  \*************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers.GridViewRowRenderer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_dataRenderers_IDataRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/IDataRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IDataRenderer.js");}
function feathers_controls_IToggle() {return __webpack_require__(/*! ./../../../feathers/controls/IToggle */ "./lib/_gen/feathers/controls/IToggle.js");}
function feathers_controls_ITriggerView() {return __webpack_require__(/*! ./../../../feathers/controls/ITriggerView */ "./lib/_gen/feathers/controls/ITriggerView.js");}
function feathers_controls_LayoutGroup() {return __webpack_require__(/*! ./../../../feathers/controls/LayoutGroup */ "./lib/_gen/feathers/controls/LayoutGroup.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function feathers_layout_GridViewRowLayout() {return __webpack_require__(/*! ./../../../feathers/layout/GridViewRowLayout */ "./lib/_gen/feathers/layout/GridViewRowLayout.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function Type() {return __webpack_require__(/*! ./../../../Type */ "./lib/_gen/Type.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function feathers_controls_dataRenderers__$GridViewRowRenderer_CellRendererStorage() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/_GridViewRowRenderer/CellRendererStorage */ "./lib/_gen/feathers/controls/dataRenderers/_GridViewRowRenderer/CellRendererStorage.js");}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_style_IVariantStyleObject() {return __webpack_require__(/*! ./../../../feathers/style/IVariantStyleObject */ "./lib/_gen/feathers/style/IVariantStyleObject.js");}
function feathers_controls_GridView() {return __webpack_require__(/*! ./../../../feathers/controls/GridView */ "./lib/_gen/feathers/controls/GridView.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_controls_dataRenderers_IGridViewCellRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/IGridViewCellRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IGridViewCellRenderer.js");}
function feathers_layout_ILayoutIndexObject() {return __webpack_require__(/*! ./../../../feathers/layout/ILayoutIndexObject */ "./lib/_gen/feathers/layout/ILayoutIndexObject.js");}
function feathers_core_IPointerDelegate() {return __webpack_require__(/*! ./../../../feathers/core/IPointerDelegate */ "./lib/_gen/feathers/core/IPointerDelegate.js");}
function feathers_events_TriggerEvent() {return __webpack_require__(/*! ./../../../feathers/events/TriggerEvent */ "./lib/_gen/feathers/events/TriggerEvent.js");}
function openfl_display_DisplayObject() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObject);}
function feathers_events_GridViewEvent() {return __webpack_require__(/*! ./../../../feathers/events/GridViewEvent */ "./lib/_gen/feathers/events/GridViewEvent.js");}
function feathers_data_GridViewCellState() {return __webpack_require__(/*! ./../../../feathers/data/GridViewCellState */ "./lib/_gen/feathers/data/GridViewCellState.js");}
function feathers_core_ITextControl() {return __webpack_require__(/*! ./../../../feathers/core/ITextControl */ "./lib/_gen/feathers/core/ITextControl.js");}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}
function haxe_ds_ObjectMap() {return __webpack_require__(/*! ./../../../haxe/ds/ObjectMap */ "./lib/_gen/haxe/ds/ObjectMap.js");}

// Constructor

var GridViewRowRenderer = function() {
	this._customCellRendererVariant = null;
	this._forceCellStateUpdate = false;
	this._columns = null;
	this._data = null;
	this._rowIndex = -1;
	this.selectable = true;
	this._ignoreSelectionChange = false;
	this._selected = false;
	this.cellStatePool = new (lime_utils_ObjectPool().default)(function() {
		return new (feathers_data_GridViewCellState().default)();
	});
	this._cellRendererToCellState = new (haxe_ds_ObjectMap().default)();
	this._columnToCellRenderer = new (haxe_ds_ObjectMap().default)();
	this._unrenderedData = [];
	this._additionalStorage = null;
	this._defaultStorage = new (feathers_controls_dataRenderers__$GridViewRowRenderer_CellRendererStorage().default)();
	(feathers_controls_LayoutGroup().default).call(this);
}

// Meta

GridViewRowRenderer.__name__ = "feathers.controls.dataRenderers.GridViewRowRenderer";
GridViewRowRenderer.__isInterface__ = false;
GridViewRowRenderer.__interfaces__ = [(feathers_controls_dataRenderers_IDataRenderer().default),(feathers_controls_IToggle().default),(feathers_controls_ITriggerView().default)];
GridViewRowRenderer.__super__ = (feathers_controls_LayoutGroup().default);
GridViewRowRenderer.prototype = $extend((feathers_controls_LayoutGroup().default).prototype, {
	get_gridView: function() {
		return this._gridView;
	},
	set_gridView: function(value) {
		if(this._gridView == value) {
			return this._gridView;
		}
		if(this._gridView != null) {
			this._gridView.removeEventListener("keyDown",$bind(this,this.gridViewRowRenderer_gridView_keyDownHandler));
		}
		this._gridView = value;
		if(this._gridView != null) {
			this._gridView.addEventListener("keyDown",$bind(this,this.gridViewRowRenderer_gridView_keyDownHandler),false,0,true);
		} else {
			this.refreshInactiveCellRenderers(this._defaultStorage,true);
			if(this._additionalStorage != null) {
				var _g = 0;
				var _g1 = this._additionalStorage.length;
				while(_g < _g1) {
					var i = _g++;
					var storage = this._additionalStorage[i];
					this.refreshInactiveCellRenderers(storage,true);
				}
			}
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._gridView;
	},
	get_selected: function() {
		return this._selected;
	},
	set_selected: function(value) {
		if(this._selected == value) {
			return this._selected;
		}
		this._selected = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selected;
	},
	get_rowIndex: function() {
		return this._rowIndex;
	},
	set_rowIndex: function(value) {
		if(this._rowIndex == value) {
			return this._rowIndex;
		}
		this._rowIndex = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._rowIndex;
	},
	get_data: function() {
		return this._data;
	},
	set_data: function(value) {
		if(this._data == value) {
			return this._data;
		}
		this._data = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._data;
	},
	get_columns: function() {
		return this._columns;
	},
	set_columns: function(value) {
		if(this._columns == value) {
			return this._columns;
		}
		if(this._columns != null) {
			this._columns.removeEventListener("change",$bind(this,this.gridViewRowRenderer_columns_changeHandler));
		}
		this._columns = value;
		if(this._columns != null) {
			this._columns.addEventListener("change",$bind(this,this.gridViewRowRenderer_columns_changeHandler),false,0,true);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._columns;
	},
	get_cellRendererRecycler: function() {
		return this._defaultStorage.cellRendererRecycler;
	},
	set_cellRendererRecycler: function(value) {
		if(this._defaultStorage.cellRendererRecycler == value) {
			return this._defaultStorage.cellRendererRecycler;
		}
		this._defaultStorage.oldCellRendererRecycler = this._defaultStorage.cellRendererRecycler;
		this._defaultStorage.cellRendererRecycler = value;
		this._defaultStorage.measurements = null;
		this.setInvalid(GridViewRowRenderer.INVALIDATION_FLAG_CELL_RENDERER_FACTORY);
		return this._defaultStorage.cellRendererRecycler;
	},
	get_forceCellStateUpdate: function() {
		return this._forceCellStateUpdate;
	},
	set_forceCellStateUpdate: function(value) {
		if(this._forceCellStateUpdate == value) {
			return this._forceCellStateUpdate;
		}
		this._forceCellStateUpdate = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._forceCellStateUpdate;
	},
	get_customCellRendererVariant: function() {
		return this._customCellRendererVariant;
	},
	set_customCellRendererVariant: function(value) {
		if(this._customCellRendererVariant == value) {
			return this._customCellRendererVariant;
		}
		this._customCellRendererVariant = value;
		this.setInvalid(GridViewRowRenderer.INVALIDATION_FLAG_CELL_RENDERER_FACTORY);
		return this._customCellRendererVariant;
	},
	get_customColumnWidths: function() {
		return this._customColumnWidths;
	},
	set_customColumnWidths: function(value) {
		if(this._customColumnWidths == value) {
			return this._customColumnWidths;
		}
		this._customColumnWidths = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._customColumnWidths;
	},
	initialize: function() {
		(feathers_controls_LayoutGroup().default).prototype.initialize.call(this);
		if(this.get_layout() == null) {
			this._rowLayout = new (feathers_layout_GridViewRowLayout().default)();
			this.set_layout(this._rowLayout);
		}
	},
	columnToCellRenderer: function(column) {
		if(column == null) {
			return null;
		}
		return this._columnToCellRenderer.get(column);
	},
	updateCells: function() {
		var _g = 0;
		var _g1 = this._columns.get_length();
		while(_g < _g1) {
			var i = _g++;
			this.updateCellRendererForColumnIndex(i);
		}
	},
	update: function() {
		this.preLayout();
		(feathers_controls_LayoutGroup().default).prototype.update.call(this);
	},
	preLayout: function() {
		this._rowLayout.set_columns(this._columns);
		this._rowLayout.set_customColumnWidths(this._customColumnWidths);
		if(this._defaultStorage.cellRendererRecycler.update == null) {
			this._defaultStorage.cellRendererRecycler.update = GridViewRowRenderer.defaultUpdateCellRenderer;
			if(this._defaultStorage.cellRendererRecycler.reset == null) {
				this._defaultStorage.cellRendererRecycler.reset = GridViewRowRenderer.defaultResetCellRenderer;
			}
		}
		var column = this._columns.iterator();
		while(column.hasNext()) {
			var column1 = column.next();
			if(column1.cellRendererRecycler != null) {
				if(column1.cellRendererRecycler.update == null) {
					column1.cellRendererRecycler.update = GridViewRowRenderer.defaultUpdateCellRenderer;
					if(column1.cellRendererRecycler.reset == null) {
						column1.cellRendererRecycler.reset = GridViewRowRenderer.defaultResetCellRenderer;
					}
				}
			}
		}
		this.refreshInactiveCellRenderers(this._defaultStorage,false);
		if(this._additionalStorage != null) {
			var _g = 0;
			var _g1 = this._additionalStorage.length;
			while(_g < _g1) {
				var i = _g++;
				var storage = this._additionalStorage[i];
				this.refreshInactiveCellRenderers(storage,false);
			}
		}
		this.findUnrenderedData();
		this.recoverInactiveCellRenderers(this._defaultStorage);
		if(this._additionalStorage != null) {
			var _g2 = 0;
			var _g11 = this._additionalStorage.length;
			while(_g2 < _g11) {
				var i1 = _g2++;
				var storage1 = this._additionalStorage[i1];
				this.recoverInactiveCellRenderers(storage1);
			}
		}
		this.renderUnrenderedData();
		this.freeInactiveCellRenderers(this._defaultStorage);
		if(this._additionalStorage != null) {
			var _g3 = 0;
			var _g12 = this._additionalStorage.length;
			while(_g3 < _g12) {
				var i2 = _g3++;
				var storage2 = this._additionalStorage[i2];
				this.freeInactiveCellRenderers(storage2);
			}
		}
		if(this._defaultStorage.inactiveCellRenderers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive cell renderers should be empty after updating."));
		}
		if(this._additionalStorage != null) {
			var _g4 = 0;
			var _g13 = this._additionalStorage.length;
			while(_g4 < _g13) {
				var i3 = _g4++;
				var storage3 = this._additionalStorage[i3];
				if(storage3.inactiveCellRenderers.length > 0) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive cell renderers should be empty after updating."));
				}
			}
		}
	},
	refreshInactiveCellRenderers: function(storage,forceCleanup) {
		var temp = storage.inactiveCellRenderers;
		storage.inactiveCellRenderers = storage.activeCellRenderers;
		storage.activeCellRenderers = temp;
		if(storage.activeCellRenderers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": active cell renderers should be empty before updating."));
		}
		if(forceCleanup) {
			this.recoverInactiveCellRenderers(storage);
			this.freeInactiveCellRenderers(storage);
			storage.oldCellRendererRecycler = null;
		}
	},
	findUnrenderedData: function() {
		var _g = 0;
		var _g1 = this._columns.get_length();
		while(_g < _g1) {
			var i = _g++;
			var column = this._columns.get(i);
			var cellRenderer = this._columnToCellRenderer.get(column);
			if(cellRenderer != null) {
				var storage = this.cellRendererRecyclerToStorage(column.cellRendererRecycler);
				var state = this._cellRendererToCellState.get(cellRenderer);
				var changed = this.populateCurrentItemState(column,i,state,this._forceCellStateUpdate);
				if(changed) {
					this.updateCellRenderer(cellRenderer,state,storage);
				}
				this.setChildIndex(cellRenderer,i);
				var removed = (HxOverrides().default).remove(storage.inactiveCellRenderers,cellRenderer);
				if(!removed) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": cell renderer map contains bad data for item at row index " + this._rowIndex + " and column index " + i + ". This may be caused by duplicate items in the data provider, which is not allowed."));
				}
				storage.activeCellRenderers.push(cellRenderer);
			} else {
				this._unrenderedData.push(i);
			}
		}
	},
	cellRendererRecyclerToStorage: function(recycler) {
		if(recycler == null) {
			return this._defaultStorage;
		}
		if(this._additionalStorage == null) {
			this._additionalStorage = [];
		}
		var _g = 0;
		var _g1 = this._additionalStorage.length;
		while(_g < _g1) {
			var i = _g++;
			var storage = this._additionalStorage[i];
			if(storage.cellRendererRecycler == recycler) {
				return storage;
			}
		}
		var storage1 = new (feathers_controls_dataRenderers__$GridViewRowRenderer_CellRendererStorage().default)(recycler);
		this._additionalStorage.push(storage1);
		return storage1;
	},
	recoverInactiveCellRenderers: function(storage) {
		var _g = 0;
		var _g1 = storage.inactiveCellRenderers;
		while(_g < _g1.length) {
			var cellRenderer = _g1[_g];
			++_g;
			if(cellRenderer == null) {
				continue;
			}
			var state = this._cellRendererToCellState.get(cellRenderer);
			if(state == null) {
				continue;
			}
			var column = state.column;
			this._cellRendererToCellState.remove(cellRenderer);
			this._columnToCellRenderer.remove(column);
			cellRenderer.removeEventListener("click",$bind(this,this.gridViewRowRenderer_cellRenderer_clickHandler));
			cellRenderer.removeEventListener("touchTap",$bind(this,this.gridViewRowRenderer_cellRenderer_touchTapHandler));
			cellRenderer.removeEventListener("trigger",$bind(this,this.gridViewRowRenderer_cellRenderer_triggerHandler));
			cellRenderer.removeEventListener("change",$bind(this,this.gridViewRowRenderer_cellRenderer_changeHandler));
			this.resetCellRenderer(cellRenderer,state,storage);
			if(storage.measurements != null) {
				storage.measurements.restore(cellRenderer);
			}
			this.cellStatePool.release(state);
		}
	},
	renderUnrenderedData: function() {
		var _g = 0;
		var _g1 = this._unrenderedData;
		while(_g < _g1.length) {
			var columnIndex = _g1[_g];
			++_g;
			var column = this._columns.get(columnIndex);
			var state = this.cellStatePool.get();
			this.populateCurrentItemState(column,columnIndex,state,true);
			var cellRenderer = this.createCellRenderer(state);
			this.addChild(cellRenderer);
		}
		this._unrenderedData.length = 0;
	},
	freeInactiveCellRenderers: function(storage) {
		var cellRendererRecycler = storage.oldCellRendererRecycler != null ? storage.oldCellRendererRecycler : storage.cellRendererRecycler;
		var _g = 0;
		var _g1 = storage.inactiveCellRenderers;
		while(_g < _g1.length) {
			var cellRenderer = _g1[_g];
			++_g;
			if(cellRenderer == null) {
				continue;
			}
			this.destroyCellRenderer(cellRenderer,cellRendererRecycler);
		}
		storage.inactiveCellRenderers.length = 0;
	},
	createCellRenderer: function(state) {
		var column = state.column;
		var cellRenderer = null;
		var storage = this.cellRendererRecyclerToStorage(column.cellRendererRecycler);
		if(storage.inactiveCellRenderers.length == 0) {
			cellRenderer = storage.cellRendererRecycler.create();
			if((js_Boot().default).__implements(cellRenderer,(feathers_style_IVariantStyleObject().default))) {
				var variantCellRenderer = (js_Boot().default).__cast(cellRenderer , (feathers_style_IVariantStyleObject().default));
				if(variantCellRenderer.get_variant() == null) {
					var variant = this.get_customCellRendererVariant() != null ? this.get_customCellRendererVariant() : (feathers_controls_GridView().default).CHILD_VARIANT_CELL_RENDERER;
					variantCellRenderer.set_variant(variant);
				}
			}
			if((js_Boot().default).__implements(cellRenderer,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(cellRenderer , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(storage.measurements == null) {
				storage.measurements = new (feathers_layout_Measurements().default)(cellRenderer);
			}
		} else {
			cellRenderer = storage.inactiveCellRenderers.shift();
		}
		var storage1 = this.cellRendererRecyclerToStorage(column.cellRendererRecycler);
		this.updateCellRenderer(cellRenderer,state,storage1);
		if((js_Boot().default).__implements(cellRenderer,(feathers_controls_ITriggerView().default))) {
			cellRenderer.addEventListener("trigger",$bind(this,this.gridViewRowRenderer_cellRenderer_triggerHandler));
		} else {
			cellRenderer.addEventListener("click",$bind(this,this.gridViewRowRenderer_cellRenderer_clickHandler));
		}
		if((js_Boot().default).__implements(cellRenderer,(feathers_controls_IToggle().default))) {
			cellRenderer.addEventListener("change",$bind(this,this.gridViewRowRenderer_cellRenderer_changeHandler));
		}
		if((js_Boot().default).__implements(cellRenderer,(feathers_core_IMeasureObject().default))) {
			cellRenderer.addEventListener("resize",$bind(this,this.gridViewRowRenderer_cellRenderer_resizeHandler));
		}
		this._cellRendererToCellState.set(cellRenderer,state);
		this._columnToCellRenderer.set(column,cellRenderer);
		storage1.activeCellRenderers.push(cellRenderer);
		return cellRenderer;
	},
	destroyCellRenderer: function(cellRenderer,cellRendererRecycler) {
		this.removeChild(cellRenderer);
		if(cellRendererRecycler != null && cellRendererRecycler.destroy != null) {
			cellRendererRecycler.destroy(cellRenderer);
		}
	},
	updateCellRendererForColumnIndex: function(columnIndex) {
		var column = this._columns.get(columnIndex);
		var cellRenderer = this._columnToCellRenderer.get(column);
		if(cellRenderer == null) {
			this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
			return;
		}
		var storage = this.cellRendererRecyclerToStorage(column.cellRendererRecycler);
		var state = this._cellRendererToCellState.get(cellRenderer);
		if(state.owner == null) {
			return;
		}
		this.populateCurrentItemState(column,columnIndex,state,true);
		this.resetCellRenderer(cellRenderer,state,storage);
		state.owner = null;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
	},
	populateCurrentItemState: function(column,columnIndex,state,force) {
		var changed = false;
		if(force || state.owner != this._gridView) {
			state.owner = this._gridView;
			changed = true;
		}
		if(force || state.data != this._data) {
			state.data = this._data;
			changed = true;
		}
		if(force || state.rowIndex != this._rowIndex) {
			state.rowIndex = this._rowIndex;
			changed = true;
		}
		if(force || state.columnIndex != columnIndex) {
			state.columnIndex = columnIndex;
			changed = true;
		}
		if(force || state.column != column) {
			state.column = column;
			changed = true;
		}
		if(force || state.selected != this._selected) {
			state.selected = this._selected;
			changed = true;
		}
		if(force || state.enabled != this._enabled) {
			state.enabled = this._enabled;
			changed = true;
		}
		var text = this._rowIndex != -1 ? column.itemToText(this._data) : null;
		if(force || state.text != text) {
			state.text = text;
			changed = true;
		}
		return changed;
	},
	updateCellRenderer: function(cellRenderer,state,storage) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		if(storage.cellRendererRecycler.update != null) {
			storage.cellRendererRecycler.update(cellRenderer,state);
		}
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		this.refreshCellRendererProperties(cellRenderer,state);
	},
	resetCellRenderer: function(cellRenderer,state,storage) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		var recycler = storage.oldCellRendererRecycler != null ? storage.oldCellRendererRecycler : storage.cellRendererRecycler;
		if(recycler != null && recycler.reset != null) {
			recycler.reset(cellRenderer,state);
		}
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		this.refreshCellRendererProperties(cellRenderer,GridViewRowRenderer.RESET_CELL_STATE);
	},
	refreshCellRendererProperties: function(cellRenderer,state) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		if((js_Boot().default).__implements(cellRenderer,(feathers_core_IUIControl().default))) {
			var uiControl = (js_Boot().default).__cast(cellRenderer , (feathers_core_IUIControl().default));
			uiControl.set_enabled(state.enabled);
		}
		if((js_Boot().default).__implements(cellRenderer,(feathers_controls_dataRenderers_IDataRenderer().default))) {
			var dataRenderer = (js_Boot().default).__cast(cellRenderer , (feathers_controls_dataRenderers_IDataRenderer().default));
			dataRenderer.set_data(state.data);
		}
		if((js_Boot().default).__implements(cellRenderer,(feathers_controls_IToggle().default))) {
			var toggle = (js_Boot().default).__cast(cellRenderer , (feathers_controls_IToggle().default));
			toggle.set_selected(state.selected);
		}
		if((js_Boot().default).__implements(cellRenderer,(feathers_controls_dataRenderers_IGridViewCellRenderer().default))) {
			var gridCell = (js_Boot().default).__cast(cellRenderer , (feathers_controls_dataRenderers_IGridViewCellRenderer().default));
			gridCell.set_column(state.column);
			gridCell.set_columnIndex(state.columnIndex);
			gridCell.set_rowIndex(state.rowIndex);
			gridCell.set_gridViewOwner(state.owner);
		}
		if((js_Boot().default).__implements(cellRenderer,(feathers_layout_ILayoutIndexObject().default))) {
			var layoutIndexObject = (js_Boot().default).__cast(cellRenderer , (feathers_layout_ILayoutIndexObject().default));
			layoutIndexObject.set_layoutIndex(state.rowIndex);
		}
		if((js_Boot().default).__implements(cellRenderer,(feathers_core_IPointerDelegate().default))) {
			var pointerDelgate = (js_Boot().default).__cast(cellRenderer , (feathers_core_IPointerDelegate().default));
			pointerDelgate.set_pointerTarget(state.rowIndex == -1 ? null : this);
		}
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
	},
	gridViewRowRenderer_cellRenderer_touchTapHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(event.isPrimaryTouchPoint) {
			return;
		}
		(feathers_events_TriggerEvent().default).dispatchFromTouchEvent(this,event);
		var cellRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this._cellRendererToCellState.get(cellRenderer);
		(feathers_events_GridViewEvent().default).dispatchForCell(this,"cellTrigger",state);
	},
	gridViewRowRenderer_cellRenderer_clickHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		(feathers_events_TriggerEvent().default).dispatchFromMouseEvent(this,event);
		var cellRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this._cellRendererToCellState.get(cellRenderer);
		(feathers_events_GridViewEvent().default).dispatchForCell(this,"cellTrigger",state);
	},
	gridViewRowRenderer_cellRenderer_triggerHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		this.dispatchEvent(event.clone());
		var cellRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this._cellRendererToCellState.get(cellRenderer);
		(feathers_events_GridViewEvent().default).dispatchForCell(this,"cellTrigger",state);
	},
	gridViewRowRenderer_cellRenderer_resizeHandler: function(event) {
		if(this._validating) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	gridViewRowRenderer_cellRenderer_changeHandler: function(event) {
		if(this._ignoreSelectionChange) {
			return;
		}
		var cellRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var toggleCellRenderer = (js_Boot().default).__cast(cellRenderer , (feathers_controls_IToggle().default));
		var state = this._cellRendererToCellState.get(cellRenderer);
		if(toggleCellRenderer.get_selected() == state.selected) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
	},
	gridViewRowRenderer_gridView_keyDownHandler: function(event) {
		if(!this._enabled || event.isDefaultPrevented()) {
			return;
		}
		if(event.keyCode == 32 || event.keyCode == 13) {
			if(this._selected) {
				var column = this._columns.get(0);
				var cellRenderer = this.columnToCellRenderer(column);
				var state = null;
				if(cellRenderer != null) {
					state = this._cellRendererToCellState.get(cellRenderer);
				}
				var isTemporary = false;
				if(state == null) {
					isTemporary = true;
					state = this.cellStatePool.get();
				}
				this.populateCurrentItemState(column,0,state,true);
				(feathers_events_GridViewEvent().default).dispatchForCell(this,"cellTrigger",state);
				if(isTemporary) {
					this.cellStatePool.release(state);
				}
			}
		}
	},
	gridViewRowRenderer_columns_changeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
	}
});
GridViewRowRenderer.prototype.__class__ = GridViewRowRenderer.prototype.constructor = $hxClasses["feathers.controls.dataRenderers.GridViewRowRenderer"] = GridViewRowRenderer;

// Init



// Statics

GridViewRowRenderer.defaultUpdateCellRenderer = function(cellRenderer,state) {
	if((js_Boot().default).__implements(cellRenderer,(feathers_core_ITextControl().default))) {
		var textControl = (js_Boot().default).__cast(cellRenderer , (feathers_core_ITextControl().default));
		textControl.set_text(state.text);
	}
}
GridViewRowRenderer.defaultResetCellRenderer = function(cellRenderer,state) {
	if((js_Boot().default).__implements(cellRenderer,(feathers_core_ITextControl().default))) {
		var textControl = (js_Boot().default).__cast(cellRenderer , (feathers_core_ITextControl().default));
		textControl.set_text(null);
	}
}
GridViewRowRenderer.INVALIDATION_FLAG_CELL_RENDERER_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("cellRendererFactory")
GridViewRowRenderer.RESET_CELL_STATE = new (feathers_data_GridViewCellState().default)()

// Export

exports["default"] = GridViewRowRenderer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/HierarchicalItemRenderer.js":
/*!******************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/HierarchicalItemRenderer.js ***!
  \******************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers.HierarchicalItemRenderer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IOpenCloseToggle() {return __webpack_require__(/*! ./../../../feathers/core/IOpenCloseToggle */ "./lib/_gen/feathers/core/IOpenCloseToggle.js");}
function feathers_controls_dataRenderers_IOptionalHierarchyItemRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/IOptionalHierarchyItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IOptionalHierarchyItemRenderer.js");}
function feathers_controls_dataRenderers_IHierarchicalDepthItemRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/IHierarchicalDepthItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IHierarchicalDepthItemRenderer.js");}
function feathers_controls_dataRenderers_IHierarchicalItemRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/IHierarchicalItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IHierarchicalItemRenderer.js");}
function feathers_controls_dataRenderers_ItemRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/ItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ItemRenderer.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function Std() {return __webpack_require__(/*! ./../../../Std */ "./lib/_gen/Std.js");}
function feathers_themes_steel_components_SteelHierarchicalItemRendererStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelHierarchicalItemRendererStyles */ "./lib/_gen/feathers/themes/steel/components/SteelHierarchicalItemRendererStyles.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_core_IStateObserver() {return __webpack_require__(/*! ./../../../feathers/core/IStateObserver */ "./lib/_gen/feathers/core/IStateObserver.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_utils_DisplayObjectFactory() {return __webpack_require__(/*! ./../../../feathers/utils/DisplayObjectFactory */ "./lib/_gen/feathers/utils/DisplayObjectFactory.js");}
function feathers_controls_ToggleButton() {return __webpack_require__(/*! ./../../../feathers/controls/ToggleButton */ "./lib/_gen/feathers/controls/ToggleButton.js");}

// Constructor

var HierarchicalItemRenderer = function() {
	this.__customDisclosureButtonVariant = null;
	this.__leafIcon = null;
	this.__branchClosedIcon = null;
	this.__branchOpenIcon = null;
	this.__branchIcon = null;
	this.__indentation = 0.0;
	this._previousCustomDisclosureButtonVariant = null;
	this._ignoreBranchOrLeafIconResizes = false;
	this._showHierarchy = true;
	this._ignoreOpenCloseChange = false;
	this._opened = false;
	this._branch = false;
	this._hierarchyDepth = 0;
	this.initializeHierarchicalItemRendererTheme();
	(feathers_controls_dataRenderers_ItemRenderer().default).call(this);
}

// Meta

HierarchicalItemRenderer.__name__ = "feathers.controls.dataRenderers.HierarchicalItemRenderer";
HierarchicalItemRenderer.__isInterface__ = false;
HierarchicalItemRenderer.__interfaces__ = [(feathers_core_IOpenCloseToggle().default),(feathers_controls_dataRenderers_IOptionalHierarchyItemRenderer().default),(feathers_controls_dataRenderers_IHierarchicalDepthItemRenderer().default),(feathers_controls_dataRenderers_IHierarchicalItemRenderer().default)];
HierarchicalItemRenderer.__super__ = (feathers_controls_dataRenderers_ItemRenderer().default);
HierarchicalItemRenderer.prototype = $extend((feathers_controls_dataRenderers_ItemRenderer().default).prototype, {
	get_hierarchyDepth: function() {
		return this._hierarchyDepth;
	},
	set_hierarchyDepth: function(value) {
		if(this._hierarchyDepth == value) {
			return this._hierarchyDepth;
		}
		this._hierarchyDepth = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._hierarchyDepth;
	},
	get_branch: function() {
		return this._branch;
	},
	set_branch: function(value) {
		if(this._branch == value) {
			return this._branch;
		}
		this._branch = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._branch;
	},
	get_opened: function() {
		return this._opened;
	},
	set_opened: function(value) {
		if(this._opened == value) {
			return this._opened;
		}
		this._opened = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		if(this._opened) {
			(feathers_events_FeathersEvent().default).dispatch(this,"open");
		} else {
			(feathers_events_FeathersEvent().default).dispatch(this,"close");
		}
		return this._opened;
	},
	get_showHierarchy: function() {
		return this._showHierarchy;
	},
	set_showHierarchy: function(value) {
		if(this._showHierarchy == value) {
			return this._showHierarchy;
		}
		this._showHierarchy = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._showHierarchy;
	},
	get_disclosureButtonFactory: function() {
		return this._disclosureButtonFactory;
	},
	set_disclosureButtonFactory: function(value) {
		if(this._disclosureButtonFactory == value) {
			return this._disclosureButtonFactory;
		}
		this._disclosureButtonFactory = value;
		this.setInvalid(HierarchicalItemRenderer.INVALIDATION_FLAG_DISCLOSURE_BUTTON_FACTORY);
		return this._disclosureButtonFactory;
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(this._previousCustomDisclosureButtonVariant != this.get_customDisclosureButtonVariant()) {
			this.setInvalidationFlag(HierarchicalItemRenderer.INVALIDATION_FLAG_DISCLOSURE_BUTTON_FACTORY);
		}
		var disclosureButtonFactoryInvalid = this.isInvalid(HierarchicalItemRenderer.INVALIDATION_FLAG_DISCLOSURE_BUTTON_FACTORY);
		if(disclosureButtonFactoryInvalid) {
			this.createDisclosureButton();
		}
		if(stylesInvalid || stateInvalid || dataInvalid) {
			this.refreshBranchOrLeafIcon();
		}
		if(dataInvalid) {
			this.refreshBranchOrLeafStatus();
		}
		if(stateInvalid || disclosureButtonFactoryInvalid) {
			this.disclosureButton.set_enabled(this._enabled);
		}
		if(dataInvalid || disclosureButtonFactoryInvalid) {
			this.refreshOpenedState();
		}
		(feathers_controls_dataRenderers_ItemRenderer().default).prototype.update.call(this);
		this._previousCustomDisclosureButtonVariant = this.get_customDisclosureButtonVariant();
	},
	calculateExplicitWidthForTextMeasurement: function() {
		var textFieldExplicitWidth = (feathers_controls_dataRenderers_ItemRenderer().default).prototype.calculateExplicitWidthForTextMeasurement.call(this);
		if(textFieldExplicitWidth == null || !this._showHierarchy) {
			return textFieldExplicitWidth;
		}
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		var indent = this._showHierarchy ? this.get_indentation() * this._hierarchyDepth : 0;
		textFieldExplicitWidth -= indent;
		this.disclosureButton.validateNow();
		textFieldExplicitWidth -= this.disclosureButton.get_width() + adjustedGap;
		if(this._currentBranchOrLeafIcon != null) {
			var oldgnoreBranchOrLeafIconResizes = this._ignoreBranchOrLeafIconResizes;
			this._ignoreBranchOrLeafIconResizes = true;
			if((js_Boot().default).__implements(this._currentBranchOrLeafIcon,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentBranchOrLeafIcon , (feathers_core_IValidating().default))).validateNow();
			}
			this._ignoreBranchOrLeafIconResizes = oldgnoreBranchOrLeafIconResizes;
			textFieldExplicitWidth -= this._currentBranchOrLeafIcon.get_width() + adjustedGap;
		}
		if(textFieldExplicitWidth < 0.0) {
			textFieldExplicitWidth = 0.0;
		}
		return textFieldExplicitWidth;
	},
	measureContentWidth: function() {
		var contentWidth = (feathers_controls_dataRenderers_ItemRenderer().default).prototype.measureContentWidth.call(this);
		if(!this._showHierarchy) {
			return contentWidth;
		}
		this.disclosureButton.validateNow();
		var oldgnoreBranchOrLeafIconResizes = this._ignoreBranchOrLeafIconResizes;
		this._ignoreBranchOrLeafIconResizes = true;
		if((js_Boot().default).__implements(this._currentBranchOrLeafIcon,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBranchOrLeafIcon , (feathers_core_IValidating().default))).validateNow();
		}
		this._ignoreBranchOrLeafIconResizes = oldgnoreBranchOrLeafIconResizes;
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		var indent = this._showHierarchy ? this.get_indentation() * this._hierarchyDepth : 0;
		contentWidth += indent + this.disclosureButton.get_width() + adjustedGap;
		if(this._currentBranchOrLeafIcon != null) {
			contentWidth += this._currentBranchOrLeafIcon.get_width() + adjustedGap;
		}
		return contentWidth;
	},
	measureContentMinWidth: function() {
		var contentMinWidth = (feathers_controls_dataRenderers_ItemRenderer().default).prototype.measureContentMinWidth.call(this);
		if(!this._showHierarchy) {
			return contentMinWidth;
		}
		this.disclosureButton.validateNow();
		var oldgnoreBranchOrLeafIconResizes = this._ignoreBranchOrLeafIconResizes;
		this._ignoreBranchOrLeafIconResizes = true;
		if((js_Boot().default).__implements(this._currentBranchOrLeafIcon,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBranchOrLeafIcon , (feathers_core_IValidating().default))).validateNow();
		}
		this._ignoreBranchOrLeafIconResizes = oldgnoreBranchOrLeafIconResizes;
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		var indent = this._showHierarchy ? this.get_indentation() * this._hierarchyDepth : 0;
		contentMinWidth += indent + this.disclosureButton.get_width() + adjustedGap;
		if(this._currentBranchOrLeafIcon != null) {
			contentMinWidth += this._currentBranchOrLeafIcon.get_width() + adjustedGap;
		}
		return contentMinWidth;
	},
	layoutChildren: function() {
		var _gthis = this;
		if(!this._showHierarchy) {
			(feathers_controls_dataRenderers_ItemRenderer().default).prototype.layoutChildren.call(this);
			return;
		}
		this.disclosureButton.validateNow();
		var oldgnoreBranchOrLeafIconResizes = this._ignoreBranchOrLeafIconResizes;
		this._ignoreBranchOrLeafIconResizes = true;
		if((js_Boot().default).__implements(this._currentBranchOrLeafIcon,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBranchOrLeafIcon , (feathers_core_IValidating().default))).validateNow();
		}
		this._ignoreBranchOrLeafIconResizes = oldgnoreBranchOrLeafIconResizes;
		var paddingLeft = this.get_paddingLeft();
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		var disclosureGap = adjustedGap;
		var branchOrLeafIconGap = adjustedGap;
		var indent = this._showHierarchy ? this.get_indentation() * this._hierarchyDepth : 0;
		this.runWithoutInvalidation(function() {
			var newPaddingLeft = paddingLeft + indent + _gthis.disclosureButton.get_width() + disclosureGap;
			if(_gthis._currentBranchOrLeafIcon != null) {
				newPaddingLeft += _gthis._currentBranchOrLeafIcon.get_width() + branchOrLeafIconGap;
			}
			return _gthis.set_paddingLeft(newPaddingLeft);
		});
		(feathers_controls_dataRenderers_ItemRenderer().default).prototype.layoutChildren.call(this);
		this.runWithoutInvalidation(function() {
			return _gthis.set_paddingLeft(paddingLeft);
		});
		this.disclosureButton.set_x(this.get_paddingLeft() + indent);
		switch(this.get_verticalAlign()._hx_index) {
		case 0:
			this.disclosureButton.set_y(this.get_paddingTop());
			break;
		case 1:
			this.disclosureButton.set_y(Math.max(this.get_paddingTop(),this.get_paddingTop() + (this.actualHeight - this.get_paddingTop() - this.get_paddingBottom() - this.disclosureButton.get_height()) / 2.0));
			break;
		case 2:
			this.disclosureButton.set_y(Math.max(this.get_paddingTop(),this.get_paddingTop() + this.actualHeight - this.get_paddingTop() - this.get_paddingBottom() - this.disclosureButton.get_height()));
			break;
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown vertical align: " + (Std().default).string(this.get_verticalAlign())));
		}
		if(this._currentBranchOrLeafIcon != null) {
			this._currentBranchOrLeafIcon.set_x(this.disclosureButton.get_x() + this.disclosureButton.get_width() + disclosureGap);
			switch(this.get_verticalAlign()._hx_index) {
			case 0:
				this._currentBranchOrLeafIcon.set_y(this.get_paddingTop());
				break;
			case 1:
				this._currentBranchOrLeafIcon.set_y(Math.max(this.get_paddingTop(),this.get_paddingTop() + (this.actualHeight - this.get_paddingTop() - this.get_paddingBottom() - this._currentBranchOrLeafIcon.get_height()) / 2.0));
				break;
			case 2:
				this._currentBranchOrLeafIcon.set_y(Math.max(this.get_paddingTop(),this.get_paddingTop() + this.actualHeight - this.get_paddingTop() - this.get_paddingBottom() - this._currentBranchOrLeafIcon.get_height()));
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown vertical align: " + (Std().default).string(this.get_verticalAlign())));
			}
		}
	},
	initializeHierarchicalItemRendererTheme: function() {
		(feathers_themes_steel_components_SteelHierarchicalItemRendererStyles().default).initialize();
	},
	createDisclosureButton: function() {
		if(this.disclosureButton != null) {
			this.disclosureButton.removeEventListener("change",$bind(this,this.hierarchicalItemRenderer_disclosureButton_changeHandler));
			this.removeChild(this.disclosureButton);
			if(this._oldDisclosureButtonFactory.destroy != null) {
				this._oldDisclosureButtonFactory.destroy(this.disclosureButton);
			}
			this._oldDisclosureButtonFactory = null;
			this.disclosureButton = null;
		}
		var factory = this._disclosureButtonFactory != null ? this._disclosureButtonFactory : HierarchicalItemRenderer.defaultDisclosureButtonFactory;
		this._oldDisclosureButtonFactory = factory;
		this.disclosureButton = factory.create();
		if(this.disclosureButton.get_variant() == null) {
			this.disclosureButton.set_variant(this.get_customDisclosureButtonVariant() != null ? this.get_customDisclosureButtonVariant() : HierarchicalItemRenderer.CHILD_VARIANT_DISCLOSURE_BUTTON);
		}
		this.disclosureButton.set_tabEnabled(false);
		this.disclosureButton.addEventListener("change",$bind(this,this.hierarchicalItemRenderer_disclosureButton_changeHandler));
		this.disclosureButton.initializeNow();
		this.addChild(this.disclosureButton);
	},
	refreshBranchOrLeafIcon: function() {
		var oldIcon = this._currentBranchOrLeafIcon;
		this._currentBranchOrLeafIcon = this.getCurrentBranchOrLeafIcon();
		if(this._currentBranchOrLeafIcon != null) {
			this._currentBranchOrLeafIcon.set_visible(this._showHierarchy);
		}
		if(this._currentBranchOrLeafIcon == oldIcon) {
			return;
		}
		this.removeCurrentBranchOrLeafIcon(oldIcon);
		this.addCurrentBranchOrLeafIcon(this._currentBranchOrLeafIcon);
	},
	getCurrentBranchOrLeafIcon: function() {
		if(this._branch) {
			if(this._opened && this.get_branchOpenIcon() != null) {
				return this.get_branchOpenIcon();
			}
			if(!this._opened && this.get_branchClosedIcon() != null) {
				return this.get_branchClosedIcon();
			}
			return this.get_branchIcon();
		}
		return this.get_leafIcon();
	},
	removeCurrentBranchOrLeafIcon: function(icon) {
		if(icon == null) {
			return;
		}
		icon.removeEventListener("resize",$bind(this,this.hierarchicalItemRenderer_branchOrLeafIcon_resizeHandler));
		if((js_Boot().default).__implements(icon,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(icon , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		if((js_Boot().default).__implements(icon,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(icon , (feathers_core_IStateObserver().default))).set_stateContext(null);
		}
		this._branchOrLeafIconMeasurements.restore(icon);
		if(icon.parent == this) {
			this.removeChild(icon);
		}
	},
	addCurrentBranchOrLeafIcon: function(icon) {
		if(icon == null) {
			this._branchOrLeafIconMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(icon,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(icon , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._branchOrLeafIconMeasurements == null) {
			this._branchOrLeafIconMeasurements = new (feathers_layout_Measurements().default)(icon);
		} else {
			this._branchOrLeafIconMeasurements.save(icon);
		}
		if((js_Boot().default).__implements(icon,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(icon , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		if((js_Boot().default).__implements(icon,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(icon , (feathers_core_IStateObserver().default))).set_stateContext(this);
		}
		icon.addEventListener("resize",$bind(this,this.hierarchicalItemRenderer_branchOrLeafIcon_resizeHandler),false,0,true);
		this.addChild(icon);
	},
	refreshBranchOrLeafStatus: function() {
		this.disclosureButton.set_visible(this._showHierarchy && this._branch);
	},
	refreshOpenedState: function() {
		var oldIgnoreOpenCloseChange = this._ignoreOpenCloseChange;
		this._ignoreOpenCloseChange = true;
		this.disclosureButton.set_selected(this._opened);
		this._ignoreOpenCloseChange = oldIgnoreOpenCloseChange;
	},
	hierarchicalItemRenderer_disclosureButton_changeHandler: function(event) {
		if(this._ignoreOpenCloseChange) {
			return;
		}
		this.set_opened(this.disclosureButton.get_selected());
	},
	hierarchicalItemRenderer_branchOrLeafIcon_resizeHandler: function(event) {
		if(this._ignoreBranchOrLeafIconResizes) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	get_styleContext: function() {
		return HierarchicalItemRenderer
	},
	get_indentation: function() {
		return this.__indentation;
	},
	set_indentation: function(value) {
		if(!this.setStyle("indentation")) {
			return this.__indentation;
		}
		if(this.__indentation == value) {
			return this.__indentation;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_indentation);
		this.__indentation = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__indentation;
	},
	clearStyle_indentation: function() {
		this.set_indentation(0.0);
		return this.get_indentation();
	},
	get_branchIcon: function() {
		return this.__branchIcon;
	},
	set_branchIcon: function(value) {
		if(!this.setStyle("branchIcon")) {
			return this.__branchIcon;
		}
		if(this.__branchIcon == value) {
			return this.__branchIcon;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_branchIcon);
		this.__branchIcon = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__branchIcon;
	},
	clearStyle_branchIcon: function() {
		this.set_branchIcon(null);
		return this.get_branchIcon();
	},
	get_branchOpenIcon: function() {
		return this.__branchOpenIcon;
	},
	set_branchOpenIcon: function(value) {
		if(!this.setStyle("branchOpenIcon")) {
			return this.__branchOpenIcon;
		}
		if(this.__branchOpenIcon == value) {
			return this.__branchOpenIcon;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_branchOpenIcon);
		this.__branchOpenIcon = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__branchOpenIcon;
	},
	clearStyle_branchOpenIcon: function() {
		this.set_branchOpenIcon(null);
		return this.get_branchOpenIcon();
	},
	get_branchClosedIcon: function() {
		return this.__branchClosedIcon;
	},
	set_branchClosedIcon: function(value) {
		if(!this.setStyle("branchClosedIcon")) {
			return this.__branchClosedIcon;
		}
		if(this.__branchClosedIcon == value) {
			return this.__branchClosedIcon;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_branchClosedIcon);
		this.__branchClosedIcon = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__branchClosedIcon;
	},
	clearStyle_branchClosedIcon: function() {
		this.set_branchClosedIcon(null);
		return this.get_branchClosedIcon();
	},
	get_leafIcon: function() {
		return this.__leafIcon;
	},
	set_leafIcon: function(value) {
		if(!this.setStyle("leafIcon")) {
			return this.__leafIcon;
		}
		if(this.__leafIcon == value) {
			return this.__leafIcon;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_leafIcon);
		this.__leafIcon = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__leafIcon;
	},
	clearStyle_leafIcon: function() {
		this.set_leafIcon(null);
		return this.get_leafIcon();
	},
	get_customDisclosureButtonVariant: function() {
		return this.__customDisclosureButtonVariant;
	},
	set_customDisclosureButtonVariant: function(value) {
		if(!this.setStyle("customDisclosureButtonVariant")) {
			return this.__customDisclosureButtonVariant;
		}
		if(this.__customDisclosureButtonVariant == value) {
			return this.__customDisclosureButtonVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customDisclosureButtonVariant);
		this.__customDisclosureButtonVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customDisclosureButtonVariant;
	},
	clearStyle_customDisclosureButtonVariant: function() {
		this.set_customDisclosureButtonVariant(null);
		return this.get_customDisclosureButtonVariant();
	}
});
HierarchicalItemRenderer.prototype.__class__ = HierarchicalItemRenderer.prototype.constructor = $hxClasses["feathers.controls.dataRenderers.HierarchicalItemRenderer"] = HierarchicalItemRenderer;

// Init



// Statics


HierarchicalItemRenderer.INVALIDATION_FLAG_DISCLOSURE_BUTTON_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("disclosureButtonFactory")
HierarchicalItemRenderer.defaultDisclosureButtonFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_ToggleButton().default))
HierarchicalItemRenderer.VARIANT_FILE_SYSTEM = "fileSystem"
HierarchicalItemRenderer.CHILD_VARIANT_DISCLOSURE_BUTTON = "hierarchicalItemRenderer_disclosureButton"

// Export

exports["default"] = HierarchicalItemRenderer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/IDataRenderer.js":
/*!*******************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/IDataRenderer.js ***!
  \*******************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers.IDataRenderer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}

// Constructor

var IDataRenderer = function() {}

// Meta

IDataRenderer.__name__ = "feathers.controls.dataRenderers.IDataRenderer";
IDataRenderer.__isInterface__ = true;
IDataRenderer.__interfaces__ = [(feathers_core_IUIControl().default)];
IDataRenderer.prototype = {
	
};
IDataRenderer.prototype.__class__ = IDataRenderer.prototype.constructor = $hxClasses["feathers.controls.dataRenderers.IDataRenderer"] = IDataRenderer;

// Init



// Statics




// Export

exports["default"] = IDataRenderer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/IGridViewCellRenderer.js":
/*!***************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/IGridViewCellRenderer.js ***!
  \***************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers.IGridViewCellRenderer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}

// Constructor

var IGridViewCellRenderer = function() {}

// Meta

IGridViewCellRenderer.__name__ = "feathers.controls.dataRenderers.IGridViewCellRenderer";
IGridViewCellRenderer.__isInterface__ = true;
IGridViewCellRenderer.__interfaces__ = [(feathers_core_IUIControl().default)];
IGridViewCellRenderer.prototype = {
	
};
IGridViewCellRenderer.prototype.__class__ = IGridViewCellRenderer.prototype.constructor = $hxClasses["feathers.controls.dataRenderers.IGridViewCellRenderer"] = IGridViewCellRenderer;

// Init



// Statics




// Export

exports["default"] = IGridViewCellRenderer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/IGridViewHeaderRenderer.js":
/*!*****************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/IGridViewHeaderRenderer.js ***!
  \*****************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers.IGridViewHeaderRenderer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}

// Constructor

var IGridViewHeaderRenderer = function() {}

// Meta

IGridViewHeaderRenderer.__name__ = "feathers.controls.dataRenderers.IGridViewHeaderRenderer";
IGridViewHeaderRenderer.__isInterface__ = true;
IGridViewHeaderRenderer.__interfaces__ = [(feathers_core_IUIControl().default)];
IGridViewHeaderRenderer.prototype = {
	
};
IGridViewHeaderRenderer.prototype.__class__ = IGridViewHeaderRenderer.prototype.constructor = $hxClasses["feathers.controls.dataRenderers.IGridViewHeaderRenderer"] = IGridViewHeaderRenderer;

// Init



// Statics




// Export

exports["default"] = IGridViewHeaderRenderer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/IGroupListViewItemRenderer.js":
/*!********************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/IGroupListViewItemRenderer.js ***!
  \********************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers.IGroupListViewItemRenderer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}

// Constructor

var IGroupListViewItemRenderer = function() {}

// Meta

IGroupListViewItemRenderer.__name__ = "feathers.controls.dataRenderers.IGroupListViewItemRenderer";
IGroupListViewItemRenderer.__isInterface__ = true;
IGroupListViewItemRenderer.__interfaces__ = [(feathers_core_IUIControl().default)];
IGroupListViewItemRenderer.prototype = {
	
};
IGroupListViewItemRenderer.prototype.__class__ = IGroupListViewItemRenderer.prototype.constructor = $hxClasses["feathers.controls.dataRenderers.IGroupListViewItemRenderer"] = IGroupListViewItemRenderer;

// Init



// Statics




// Export

exports["default"] = IGroupListViewItemRenderer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/IHierarchicalDepthItemRenderer.js":
/*!************************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/IHierarchicalDepthItemRenderer.js ***!
  \************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers.IHierarchicalDepthItemRenderer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}

// Constructor

var IHierarchicalDepthItemRenderer = function() {}

// Meta

IHierarchicalDepthItemRenderer.__name__ = "feathers.controls.dataRenderers.IHierarchicalDepthItemRenderer";
IHierarchicalDepthItemRenderer.__isInterface__ = true;
IHierarchicalDepthItemRenderer.__interfaces__ = [(feathers_core_IUIControl().default)];
IHierarchicalDepthItemRenderer.prototype = {
	
};
IHierarchicalDepthItemRenderer.prototype.__class__ = IHierarchicalDepthItemRenderer.prototype.constructor = $hxClasses["feathers.controls.dataRenderers.IHierarchicalDepthItemRenderer"] = IHierarchicalDepthItemRenderer;

// Init



// Statics




// Export

exports["default"] = IHierarchicalDepthItemRenderer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/IHierarchicalItemRenderer.js":
/*!*******************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/IHierarchicalItemRenderer.js ***!
  \*******************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers.IHierarchicalItemRenderer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}

// Constructor

var IHierarchicalItemRenderer = function() {}

// Meta

IHierarchicalItemRenderer.__name__ = "feathers.controls.dataRenderers.IHierarchicalItemRenderer";
IHierarchicalItemRenderer.__isInterface__ = true;
IHierarchicalItemRenderer.__interfaces__ = [(feathers_core_IUIControl().default)];
IHierarchicalItemRenderer.prototype = {
	
};
IHierarchicalItemRenderer.prototype.__class__ = IHierarchicalItemRenderer.prototype.constructor = $hxClasses["feathers.controls.dataRenderers.IHierarchicalItemRenderer"] = IHierarchicalItemRenderer;

// Init



// Statics




// Export

exports["default"] = IHierarchicalItemRenderer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/IListViewItemRenderer.js":
/*!***************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/IListViewItemRenderer.js ***!
  \***************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers.IListViewItemRenderer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}

// Constructor

var IListViewItemRenderer = function() {}

// Meta

IListViewItemRenderer.__name__ = "feathers.controls.dataRenderers.IListViewItemRenderer";
IListViewItemRenderer.__isInterface__ = true;
IListViewItemRenderer.__interfaces__ = [(feathers_core_IUIControl().default)];
IListViewItemRenderer.prototype = {
	
};
IListViewItemRenderer.prototype.__class__ = IListViewItemRenderer.prototype.constructor = $hxClasses["feathers.controls.dataRenderers.IListViewItemRenderer"] = IListViewItemRenderer;

// Init



// Statics




// Export

exports["default"] = IListViewItemRenderer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/IOptionalHierarchyItemRenderer.js":
/*!************************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/IOptionalHierarchyItemRenderer.js ***!
  \************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers.IOptionalHierarchyItemRenderer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}

// Constructor

var IOptionalHierarchyItemRenderer = function() {}

// Meta

IOptionalHierarchyItemRenderer.__name__ = "feathers.controls.dataRenderers.IOptionalHierarchyItemRenderer";
IOptionalHierarchyItemRenderer.__isInterface__ = true;
IOptionalHierarchyItemRenderer.__interfaces__ = [(feathers_core_IUIControl().default)];
IOptionalHierarchyItemRenderer.prototype = {
	
};
IOptionalHierarchyItemRenderer.prototype.__class__ = IOptionalHierarchyItemRenderer.prototype.constructor = $hxClasses["feathers.controls.dataRenderers.IOptionalHierarchyItemRenderer"] = IOptionalHierarchyItemRenderer;

// Init



// Statics




// Export

exports["default"] = IOptionalHierarchyItemRenderer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/ITreeGridViewCellRenderer.js":
/*!*******************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/ITreeGridViewCellRenderer.js ***!
  \*******************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers.ITreeGridViewCellRenderer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_controls_dataRenderers_IHierarchicalItemRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/IHierarchicalItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IHierarchicalItemRenderer.js");}

// Constructor

var ITreeGridViewCellRenderer = function() {}

// Meta

ITreeGridViewCellRenderer.__name__ = "feathers.controls.dataRenderers.ITreeGridViewCellRenderer";
ITreeGridViewCellRenderer.__isInterface__ = true;
ITreeGridViewCellRenderer.__interfaces__ = [(feathers_controls_dataRenderers_IHierarchicalItemRenderer().default)];
ITreeGridViewCellRenderer.prototype = {
	
};
ITreeGridViewCellRenderer.prototype.__class__ = ITreeGridViewCellRenderer.prototype.constructor = $hxClasses["feathers.controls.dataRenderers.ITreeGridViewCellRenderer"] = ITreeGridViewCellRenderer;

// Init



// Statics




// Export

exports["default"] = ITreeGridViewCellRenderer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/ITreeGridViewHeaderRenderer.js":
/*!*********************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/ITreeGridViewHeaderRenderer.js ***!
  \*********************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers.ITreeGridViewHeaderRenderer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}

// Constructor

var ITreeGridViewHeaderRenderer = function() {}

// Meta

ITreeGridViewHeaderRenderer.__name__ = "feathers.controls.dataRenderers.ITreeGridViewHeaderRenderer";
ITreeGridViewHeaderRenderer.__isInterface__ = true;
ITreeGridViewHeaderRenderer.__interfaces__ = [(feathers_core_IUIControl().default)];
ITreeGridViewHeaderRenderer.prototype = {
	
};
ITreeGridViewHeaderRenderer.prototype.__class__ = ITreeGridViewHeaderRenderer.prototype.constructor = $hxClasses["feathers.controls.dataRenderers.ITreeGridViewHeaderRenderer"] = ITreeGridViewHeaderRenderer;

// Init



// Statics




// Export

exports["default"] = ITreeGridViewHeaderRenderer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/ITreeViewItemRenderer.js":
/*!***************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/ITreeViewItemRenderer.js ***!
  \***************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers.ITreeViewItemRenderer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_controls_dataRenderers_IHierarchicalItemRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/IHierarchicalItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IHierarchicalItemRenderer.js");}

// Constructor

var ITreeViewItemRenderer = function() {}

// Meta

ITreeViewItemRenderer.__name__ = "feathers.controls.dataRenderers.ITreeViewItemRenderer";
ITreeViewItemRenderer.__isInterface__ = true;
ITreeViewItemRenderer.__interfaces__ = [(feathers_controls_dataRenderers_IHierarchicalItemRenderer().default)];
ITreeViewItemRenderer.prototype = {
	
};
ITreeViewItemRenderer.prototype.__class__ = ITreeViewItemRenderer.prototype.constructor = $hxClasses["feathers.controls.dataRenderers.ITreeViewItemRenderer"] = ITreeViewItemRenderer;

// Init



// Statics




// Export

exports["default"] = ITreeViewItemRenderer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/ItemRenderer.js":
/*!******************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/ItemRenderer.js ***!
  \******************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers.ItemRenderer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IPointerDelegate() {return __webpack_require__(/*! ./../../../feathers/core/IPointerDelegate */ "./lib/_gen/feathers/core/IPointerDelegate.js");}
function feathers_controls_dataRenderers_IDataRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/IDataRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IDataRenderer.js");}
function feathers_layout_ILayoutIndexObject() {return __webpack_require__(/*! ./../../../feathers/layout/ILayoutIndexObject */ "./lib/_gen/feathers/layout/ILayoutIndexObject.js");}
function feathers_core_IFocusContainer() {return __webpack_require__(/*! ./../../../feathers/core/IFocusContainer */ "./lib/_gen/feathers/core/IFocusContainer.js");}
function feathers_controls_ToggleButton() {return __webpack_require__(/*! ./../../../feathers/controls/ToggleButton */ "./lib/_gen/feathers/controls/ToggleButton.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_themes_steel_components_SteelItemRendererStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelItemRendererStyles */ "./lib/_gen/feathers/themes/steel/components/SteelItemRendererStyles.js");}
function openfl_text_TextField() {return (__webpack_require__(/*! openfl */ "openfl").text.TextField);}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_core_IStateObserver() {return __webpack_require__(/*! ./../../../feathers/core/IStateObserver */ "./lib/_gen/feathers/core/IStateObserver.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function Std() {return __webpack_require__(/*! ./../../../Std */ "./lib/_gen/Std.js");}
function openfl_display_DisplayObjectContainer() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObjectContainer);}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function openfl_display_InteractiveObject() {return (__webpack_require__(/*! openfl */ "openfl").display.InteractiveObject);}
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}
function feathers_layout_ILayoutObject() {return __webpack_require__(/*! ./../../../feathers/layout/ILayoutObject */ "./lib/_gen/feathers/layout/ILayoutObject.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function haxe_ds_EnumValueMap() {return __webpack_require__(/*! ./../../../haxe/ds/EnumValueMap */ "./lib/_gen/haxe/ds/EnumValueMap.js");}

// Constructor

var ItemRenderer = function() {
	this.__accessoryView = null;
	this.__showSecondaryText = true;
	this.__alternateBackgroundSkin = null;
	this.__selectedSecondaryTextFormat = null;
	this.__disabledSecondaryTextFormat = null;
	this.__secondaryTextFormat = null;
	this._stateToSecondaryTextFormat = new (haxe_ds_EnumValueMap().default)();
	this._ignoreAccessoryResizes = false;
	this._layoutIndex = -1;
	this._childFocusEnabled = true;
	this._secondaryHtmlText = null;
	this._updatedSecondaryTextStyles = false;
	this._previousSecondarySimpleTextFormat = null;
	this._previousSecondaryTextFormat = null;
	this._previousSecondaryHTMLText = null;
	this._previousSecondaryText = null;
	this.initializeItemRendererTheme();
	(feathers_controls_ToggleButton().default).call(this);
	this.mouseChildren = true;
	this.set_buttonMode(false);
	this.set_toggleable(false);
	this.set_tabEnabled(false);
	this.set_tabChildren(true);
}

// Meta

ItemRenderer.__name__ = "feathers.controls.dataRenderers.ItemRenderer";
ItemRenderer.__isInterface__ = false;
ItemRenderer.__interfaces__ = [(feathers_core_IPointerDelegate().default),(feathers_controls_dataRenderers_IDataRenderer().default),(feathers_layout_ILayoutIndexObject().default),(feathers_core_IFocusContainer().default)];
ItemRenderer.__super__ = (feathers_controls_ToggleButton().default);
ItemRenderer.prototype = $extend((feathers_controls_ToggleButton().default).prototype, {
	get_data: function() {
		return this._data;
	},
	set_data: function(value) {
		if(this._data == value) {
			return this._data;
		}
		this._data = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._data;
	},
	get_secondaryText: function() {
		return this._secondaryText;
	},
	set_secondaryText: function(value) {
		if(this._secondaryText == value) {
			return this._secondaryText;
		}
		this._secondaryText = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._secondaryText;
	},
	get_secondaryHtmlText: function() {
		return this._secondaryHtmlText;
	},
	set_secondaryHtmlText: function(value) {
		if(this._secondaryHtmlText == value) {
			return this._secondaryHtmlText;
		}
		this._secondaryHtmlText = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._secondaryHtmlText;
	},
	get_childFocusEnabled: function() {
		if(this._enabled) {
			return this._childFocusEnabled;
		} else {
			return false;
		}
	},
	set_childFocusEnabled: function(value) {
		if(this._childFocusEnabled == value) {
			return this._childFocusEnabled;
		}
		this._childFocusEnabled = value;
		return this._childFocusEnabled;
	},
	get_layoutIndex: function() {
		return this._layoutIndex;
	},
	set_layoutIndex: function(value) {
		if(this._layoutIndex == value) {
			return this._layoutIndex;
		}
		this._layoutIndex = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._layoutIndex;
	},
	get_pointerTarget: function() {
		return this._pointerTarget;
	},
	set_pointerTarget: function(value) {
		if(this._pointerTarget == value) {
			return this._pointerTarget;
		}
		this._pointerTarget = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._pointerTarget;
	},
	get_baseline: function() {
		if(this.textField == null) {
			return 0.0;
		}
		var hasText = this._text != null && this._text.length > 0;
		var hasHTMLText = this._htmlText != null && this._htmlText.length > 0;
		if(!this.get_showText() || !hasText && !hasHTMLText) {
			var textFieldY = this.textField.get_y();
			if(!this.get_showText() || this._text == null && this._htmlText == null) {
				if(this._currentIcon != null) {
					textFieldY = this._currentIcon.get_y() + (this._currentIcon.get_height() - this._textMeasuredHeight) / 2.0;
				} else if(this._currentBackgroundSkin != null) {
					textFieldY = (this._currentBackgroundSkin.get_height() - this._textMeasuredHeight) / 2.0;
				} else {
					return 0.0;
				}
			}
			this.textField.set_text("​");
			var textFieldBaseline = textFieldY + this.textField.getLineMetrics(0).ascent;
			this.textField.set_text("");
			return textFieldBaseline;
		}
		return this.textField.get_y() + this.textField.getLineMetrics(0).ascent;
	},
	getSecondaryTextFormatForState: function(state) {
		return this._stateToSecondaryTextFormat.get(state);
	},
	setSecondaryTextFormatForState: function(state,textFormat) {
		if(!this.setStyle("setSecondaryTextFormatForState",state)) {
			return;
		}
		if(textFormat == null) {
			this._stateToSecondaryTextFormat.remove(state);
		} else {
			this._stateToSecondaryTextFormat.set(state,textFormat);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	initializeItemRendererTheme: function() {
		(feathers_themes_steel_components_SteelItemRendererStyles().default).initialize();
	},
	initialize: function() {
		(feathers_controls_ToggleButton().default).prototype.initialize.call(this);
		this._pointerToState.set_customHitTest($bind(this,this.customHitTest));
		this._pointerTrigger.set_customHitTest($bind(this,this.customHitTest));
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var sizeInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SIZE);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		this._updatedSecondaryTextStyles = false;
		if(dataInvalid) {
			this._pointerToState.set_target(this._pointerTarget != null ? this._pointerTarget : this);
			this.refreshSecondaryTextField();
		}
		if(dataInvalid || stylesInvalid || stateInvalid) {
			this.refreshSecondaryTextStyles();
		}
		if(stylesInvalid || stateInvalid) {
			this.refreshAccessoryView();
		}
		if(dataInvalid || stylesInvalid || stateInvalid || sizeInvalid) {
			this.refreshSecondaryText(sizeInvalid);
		}
		(feathers_controls_ToggleButton().default).prototype.update.call(this);
	},
	refreshSecondaryTextField: function() {
		if(this._secondaryText == null && this._secondaryHtmlText == null) {
			if(this.secondaryTextField != null) {
				this.removeChild(this.secondaryTextField);
				this.secondaryTextField = null;
			}
			this._previousSecondaryText = null;
			this._previousSecondaryHTMLText = null;
			this._previousSecondaryTextFormat = null;
			this._previousSecondarySimpleTextFormat = null;
			return;
		}
		if(this.secondaryTextField != null) {
			return;
		}
		this.secondaryTextField = new (openfl_text_TextField())();
		this.secondaryTextField.set_selectable(false);
		this.secondaryTextField.set_multiline(true);
		this.addChild(this.secondaryTextField);
	},
	refreshSecondaryTextStyles: function() {
		if(this.secondaryTextField == null) {
			return;
		}
		if(this.secondaryTextField.get_embedFonts() != this.get_embedFonts()) {
			this.secondaryTextField.set_embedFonts(this.get_embedFonts());
			this._updatedSecondaryTextStyles = true;
		}
		var textFormat = this.getCurrentSecondaryTextFormat();
		var simpleTextFormat = textFormat != null ? textFormat.toSimpleTextFormat() : null;
		if(simpleTextFormat == this._previousSecondarySimpleTextFormat) {
			return;
		}
		if(this._previousSecondaryTextFormat != null) {
			this._previousSecondaryTextFormat.removeEventListener("change",$bind(this,this.itemRenderer_secondaryTextFormat_changeHandler));
		}
		if(textFormat != null) {
			textFormat.addEventListener("change",$bind(this,this.itemRenderer_secondaryTextFormat_changeHandler),false,0,true);
			this.secondaryTextField.set_defaultTextFormat(simpleTextFormat);
			this._updatedSecondaryTextStyles = true;
		}
		this._previousSecondaryTextFormat = textFormat;
		this._previousSecondarySimpleTextFormat = simpleTextFormat;
	},
	refreshSecondaryText: function(forceMeasurement) {
		if(this.secondaryTextField == null) {
			return;
		}
		var hasSecondaryText = this.get_showSecondaryText() && this._secondaryText != null && this._secondaryText.length > 0;
		var hasSecondaryHTMLText = this.get_showSecondaryText() && this._secondaryHtmlText != null && this._secondaryHtmlText.length > 0;
		this.secondaryTextField.set_visible(hasSecondaryText || hasSecondaryHTMLText);
		if(this._secondaryText == this._previousSecondaryText && this._secondaryHtmlText == this._previousSecondaryHTMLText && !this._updatedSecondaryTextStyles && !forceMeasurement) {
			return;
		}
		this.secondaryTextField.set_autoSize("left");
		if(hasSecondaryHTMLText) {
			this.secondaryTextField.set_htmlText(this._secondaryHtmlText);
		} else if(hasSecondaryText) {
			this.secondaryTextField.set_text(this._secondaryText);
		} else {
			this.secondaryTextField.set_text("​");
		}
		this._secondaryTextMeasuredWidth = this.secondaryTextField.get_width();
		this._secondaryTextMeasuredHeight = this.secondaryTextField.get_height();
		this.secondaryTextField.set_autoSize("none");
		if(!hasSecondaryText && !hasSecondaryHTMLText) {
			this.secondaryTextField.set_text("");
		}
		this._previousSecondaryText = this._secondaryText;
		this._previousSecondaryHTMLText = this._secondaryHtmlText;
	},
	getCurrentSecondaryTextFormat: function() {
		var result = this._stateToSecondaryTextFormat.get(this._currentState);
		if(result != null) {
			return result;
		}
		if(!this._enabled && this.get_disabledSecondaryTextFormat() != null) {
			return this.get_disabledSecondaryTextFormat();
		}
		if(this._selected && this.get_selectedSecondaryTextFormat() != null) {
			return this.get_selectedSecondaryTextFormat();
		}
		return this.get_secondaryTextFormat();
	},
	refreshAccessoryView: function() {
		var oldView = this._currentAccessoryView;
		this._currentAccessoryView = this.getCurrentAccessoryView();
		if(this._currentAccessoryView == oldView) {
			return;
		}
		this.removeCurrentAccessoryView(oldView);
		this.addCurrentAccessoryView(this._currentAccessoryView);
	},
	getCurrentAccessoryView: function() {
		return this.get_accessoryView();
	},
	removeCurrentAccessoryView: function(view) {
		if(view == null) {
			return;
		}
		view.removeEventListener("resize",$bind(this,this.itemRenderer_accessoryView_resizeHandler));
		if((js_Boot().default).__implements(view,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(view , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		if((js_Boot().default).__implements(view,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(view , (feathers_core_IStateObserver().default))).set_stateContext(null);
		}
		this._accessoryViewMeasurements.restore(view);
		if(view.parent == this) {
			this.removeChild(view);
		}
	},
	addCurrentAccessoryView: function(view) {
		if(view == null) {
			this._accessoryViewMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(view,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(view , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._accessoryViewMeasurements == null) {
			this._accessoryViewMeasurements = new (feathers_layout_Measurements().default)(view);
		} else {
			this._accessoryViewMeasurements.save(view);
		}
		if((js_Boot().default).__implements(view,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(view , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		if((js_Boot().default).__implements(view,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(view , (feathers_core_IStateObserver().default))).set_stateContext(this);
		}
		view.addEventListener("resize",$bind(this,this.itemRenderer_accessoryView_resizeHandler),false,0,true);
		this.addChild(view);
	},
	customHitTest: function(stageX,stageY) {
		var pointerTargetContainer = (Std().default).downcast(this._pointerTarget,(openfl_display_DisplayObjectContainer()));
		if(pointerTargetContainer == null) {
			pointerTargetContainer = this;
		}
		if(pointerTargetContainer.stage == null) {
			return false;
		}
		if(pointerTargetContainer.mouseChildren) {
			var objects = pointerTargetContainer.stage.getObjectsUnderPoint(new (openfl_geom_Point())(stageX,stageY));
			if(objects.length > 0) {
				var lastObject = objects[objects.length - 1];
				if(pointerTargetContainer.contains(lastObject)) {
					while(lastObject != null && lastObject != pointerTargetContainer) {
						if(((lastObject) instanceof (openfl_display_InteractiveObject()))) {
							var interactive = (js_Boot().default).__cast(lastObject , (openfl_display_InteractiveObject()));
							if(!interactive.mouseEnabled) {
								lastObject = lastObject.parent;
								continue;
							}
						}
						if((js_Boot().default).__implements(lastObject,(feathers_core_IFocusObject().default))) {
							var focusable = (js_Boot().default).__cast(lastObject , (feathers_core_IFocusObject().default));
							if(focusable.parent != this._pointerTarget && focusable.get_focusEnabled()) {
								return false;
							}
						}
						lastObject = lastObject.parent;
					}
				}
			}
		}
		return true;
	},
	refreshTextFieldDimensions: function(forMeasurement) {
		var oldIgnoreIconResizes = this._ignoreIconResizes;
		this._ignoreIconResizes = true;
		if((js_Boot().default).__implements(this._currentIcon,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentIcon , (feathers_core_IValidating().default))).validateNow();
		}
		this._ignoreIconResizes = oldIgnoreIconResizes;
		var oldIgnoreAccessoryResizes = this._ignoreAccessoryResizes;
		this._ignoreAccessoryResizes = true;
		if((js_Boot().default).__implements(this._currentAccessoryView,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentAccessoryView , (feathers_core_IValidating().default))).validateNow();
		}
		this._ignoreAccessoryResizes = oldIgnoreAccessoryResizes;
		var hasText = this.get_showText() && this._text != null;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		if(!hasText && !hasHTMLText) {
			return;
		}
		var calculatedWidth = this.actualWidth;
		var calculatedHeight = this.actualHeight;
		if(forMeasurement) {
			calculatedWidth = 0.0;
			var explicitCalculatedWidth = this.get_explicitWidth();
			if(explicitCalculatedWidth == null) {
				explicitCalculatedWidth = this.get_explicitMaxWidth();
			}
			if(explicitCalculatedWidth != null) {
				calculatedWidth = explicitCalculatedWidth;
			}
			calculatedHeight = 0.0;
			var explicitCalculatedHeight = this.get_explicitHeight();
			if(explicitCalculatedHeight == null) {
				explicitCalculatedHeight = this.get_explicitMaxHeight();
			}
			if(explicitCalculatedHeight != null) {
				calculatedHeight = explicitCalculatedHeight;
			}
		}
		calculatedWidth -= this.get_paddingLeft() + this.get_paddingRight();
		calculatedHeight -= this.get_paddingTop() + this.get_paddingBottom();
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		if(this._currentIcon != null) {
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				calculatedWidth -= this._currentIcon.get_width() + adjustedGap;
			}
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP || this.get_iconPosition() == (feathers_layout_RelativePosition().default).BOTTOM) {
				calculatedHeight -= this._currentIcon.get_height() + adjustedGap;
			}
		}
		if(this.hasAccessoryViewInLayout()) {
			calculatedWidth -= this._currentAccessoryView.get_width() + adjustedGap;
		}
		if(this.secondaryTextField != null) {
			calculatedHeight -= this._secondaryTextMeasuredHeight + adjustedGap;
		}
		if(calculatedWidth < 0.0) {
			calculatedWidth = 0.0;
		}
		if(calculatedHeight < 0.0) {
			calculatedHeight = 0.0;
		}
		if(calculatedWidth > this._textMeasuredWidth) {
			calculatedWidth = this._textMeasuredWidth;
		}
		if(calculatedHeight > this._textMeasuredHeight) {
			calculatedHeight = this._textMeasuredHeight;
		}
		this.textField.set_width(calculatedWidth);
		var wordWrap = this.get_wordWrap();
		if(wordWrap && !this._wrappedOnMeasure && calculatedWidth >= this._textMeasuredWidth) {
			wordWrap = false;
		}
		if(this.textField.get_wordWrap() != wordWrap) {
			this.textField.set_wordWrap(wordWrap);
		}
		this.textField.set_height(calculatedHeight);
	},
	calculateExplicitWidthForTextMeasurement: function() {
		var textFieldExplicitWidth = (feathers_controls_ToggleButton().default).prototype.calculateExplicitWidthForTextMeasurement.call(this);
		if(textFieldExplicitWidth == null) {
			return textFieldExplicitWidth;
		}
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		if(this.hasAccessoryViewInLayout()) {
			var oldIgnoreAccessoryResizes = this._ignoreAccessoryResizes;
			this._ignoreAccessoryResizes = true;
			if((js_Boot().default).__implements(this._currentAccessoryView,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentAccessoryView , (feathers_core_IValidating().default))).validateNow();
			}
			this._ignoreAccessoryResizes = oldIgnoreAccessoryResizes;
			textFieldExplicitWidth -= this._currentAccessoryView.get_width() + adjustedGap;
		}
		if(textFieldExplicitWidth < 0.0) {
			textFieldExplicitWidth = 0.0;
		}
		return textFieldExplicitWidth;
	},
	measureContentWidth: function() {
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		var hasText = this.get_showText() && this._text != null;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		var contentWidth = hasText || hasHTMLText ? this._textMeasuredWidth : 0.0;
		var hasSecondaryText = this.get_showSecondaryText() && this._secondaryText != null;
		var hasSecondaryHTMLText = this.get_showSecondaryText() && this._secondaryHtmlText != null && this._secondaryHtmlText.length > 0;
		if(hasSecondaryText || hasSecondaryHTMLText) {
			contentWidth = Math.max(contentWidth,this._secondaryTextMeasuredWidth);
		}
		if(this.hasAccessoryViewInLayout()) {
			var oldIgnoreAccessoryResizes = this._ignoreAccessoryResizes;
			this._ignoreAccessoryResizes = true;
			if((js_Boot().default).__implements(this._currentAccessoryView,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentAccessoryView , (feathers_core_IValidating().default))).validateNow();
			}
			this._ignoreAccessoryResizes = oldIgnoreAccessoryResizes;
			if(hasText || hasHTMLText || hasSecondaryText || hasSecondaryHTMLText) {
				contentWidth += adjustedGap;
			}
			contentWidth += this._currentAccessoryView.get_width();
		}
		if(this._currentIcon != null) {
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				if(hasText || hasHTMLText || hasSecondaryText || hasSecondaryHTMLText || this.hasAccessoryViewInLayout()) {
					contentWidth += adjustedGap;
				}
				contentWidth += this._currentIcon.get_width();
			} else if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP || this.get_iconPosition() == (feathers_layout_RelativePosition().default).BOTTOM) {
				contentWidth = Math.max(contentWidth,this._currentIcon.get_width());
			}
		}
		return contentWidth;
	},
	measureContentHeight: function() {
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		var hasText = this.get_showText() && this._text != null;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		var contentHeight = hasText || hasHTMLText ? this._textMeasuredHeight : 0.0;
		var hasSecondaryText = this.get_showSecondaryText() && this._secondaryText != null;
		var hasSecondaryHTMLText = this.get_showSecondaryText() && this._secondaryHtmlText != null && this._secondaryHtmlText.length > 0;
		if(hasSecondaryText || hasSecondaryHTMLText) {
			contentHeight += this._secondaryTextMeasuredHeight;
			if(hasText || hasHTMLText) {
				contentHeight += adjustedGap;
			}
		}
		if(this.hasAccessoryViewInLayout()) {
			var oldIgnoreAccessoryResizes = this._ignoreAccessoryResizes;
			this._ignoreAccessoryResizes = true;
			if((js_Boot().default).__implements(this._currentAccessoryView,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentAccessoryView , (feathers_core_IValidating().default))).validateNow();
			}
			this._ignoreAccessoryResizes = oldIgnoreAccessoryResizes;
			contentHeight = Math.max(contentHeight,this._currentAccessoryView.get_height());
		}
		if(this._currentIcon != null) {
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP || this.get_iconPosition() == (feathers_layout_RelativePosition().default).BOTTOM) {
				if(hasText || hasHTMLText || hasSecondaryText || hasSecondaryHTMLText) {
					contentHeight += adjustedGap;
				}
				contentHeight += this._currentIcon.get_height();
			} else if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				contentHeight = Math.max(contentHeight,this._currentIcon.get_height());
			}
		}
		return contentHeight;
	},
	measureContentMinWidth: function() {
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		var hasText = this.get_showText() && this._text != null;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		var contentMinWidth = hasText || hasHTMLText ? this._textMeasuredWidth : 0.0;
		var hasSecondaryText = this.get_showSecondaryText() && this._secondaryText != null;
		var hasSecondaryHTMLText = this.get_showSecondaryText() && this._secondaryHtmlText != null && this._secondaryHtmlText.length > 0;
		if(hasSecondaryText || hasSecondaryHTMLText) {
			contentMinWidth = Math.max(contentMinWidth,this._secondaryTextMeasuredWidth);
		}
		if(this.hasAccessoryViewInLayout()) {
			var oldIgnoreAccessoryResizes = this._ignoreAccessoryResizes;
			this._ignoreAccessoryResizes = true;
			if((js_Boot().default).__implements(this._currentAccessoryView,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentAccessoryView , (feathers_core_IValidating().default))).validateNow();
			}
			this._ignoreAccessoryResizes = oldIgnoreAccessoryResizes;
			if(hasText || hasHTMLText || hasSecondaryText || hasSecondaryHTMLText) {
				contentMinWidth += adjustedGap;
			}
			contentMinWidth += this._currentAccessoryView.get_width();
		}
		if(this._currentIcon != null) {
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				if(hasText || hasHTMLText || hasSecondaryText || hasSecondaryHTMLText || this.hasAccessoryViewInLayout()) {
					contentMinWidth += adjustedGap;
				}
				contentMinWidth += this._currentIcon.get_width();
			} else if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP || this.get_iconPosition() == (feathers_layout_RelativePosition().default).BOTTOM) {
				contentMinWidth = Math.max(contentMinWidth,this._currentIcon.get_width());
			}
		}
		return contentMinWidth;
	},
	measureContentMinHeight: function() {
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		var hasText = this.get_showText() && this._text != null;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		var contentMinHeight = hasText || hasHTMLText ? this._textMeasuredHeight : 0.0;
		var hasSecondaryText = this.get_showSecondaryText() && this._secondaryText != null;
		var hasSecondaryHTMLText = this.get_showSecondaryText() && this._secondaryHtmlText != null && this._secondaryHtmlText.length > 0;
		if(hasSecondaryText || hasSecondaryHTMLText) {
			contentMinHeight += this._secondaryTextMeasuredHeight;
			if(hasText || hasHTMLText) {
				contentMinHeight += adjustedGap;
			}
		}
		if(this.hasAccessoryViewInLayout()) {
			var oldIgnoreAccessoryResizes = this._ignoreAccessoryResizes;
			this._ignoreAccessoryResizes = true;
			if((js_Boot().default).__implements(this._currentAccessoryView,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentAccessoryView , (feathers_core_IValidating().default))).validateNow();
			}
			this._ignoreAccessoryResizes = oldIgnoreAccessoryResizes;
			contentMinHeight = Math.max(contentMinHeight,this._currentAccessoryView.get_height());
		}
		if(this._currentIcon != null) {
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP || this.get_iconPosition() == (feathers_layout_RelativePosition().default).BOTTOM) {
				if(hasText || hasHTMLText || hasSecondaryText || hasSecondaryHTMLText) {
					contentMinHeight += adjustedGap;
				}
				contentMinHeight += this._currentIcon.get_height();
			} else if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				contentMinHeight = Math.max(contentMinHeight,this._currentIcon.get_height());
			}
		}
		return contentMinHeight;
	},
	hasAccessoryViewInLayout: function() {
		if(this._currentAccessoryView == null) {
			return false;
		}
		if((js_Boot().default).__implements(this._currentAccessoryView,(feathers_layout_ILayoutObject().default))) {
			return ((js_Boot().default).__cast(this._currentAccessoryView , (feathers_layout_ILayoutObject().default))).get_includeInLayout();
		}
		return true;
	},
	getCurrentBackgroundSkin: function() {
		var result = this._stateToSkin.get(this._currentState);
		if(result != null) {
			return result;
		}
		if(this._selected && this.get_selectedBackgroundSkin() != null) {
			return this.get_selectedBackgroundSkin();
		}
		if(this.get_alternateBackgroundSkin() != null && this._layoutIndex % 2 == 1) {
			return this.get_alternateBackgroundSkin();
		}
		return this.get_backgroundSkin();
	},
	layoutChildren: function() {
		this.refreshTextFieldDimensions(false);
		var flexGap = false;
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
			flexGap = true;
		}
		var hasText = this.get_showText() && this._text != null;
		var hasHTMLText = this.get_showText() && this._htmlText != null && this._htmlText.length > 0;
		var hasSecondaryText = this.get_showSecondaryText() && this._secondaryText != null;
		var hasSecondaryHTMLText = this.get_showSecondaryText() && this._secondaryHtmlText != null && this._secondaryHtmlText.length > 0;
		var availableContentWidth = this.actualWidth - this.get_paddingLeft() - this.get_paddingRight();
		var availableContentHeight = this.actualHeight - this.get_paddingTop() - this.get_paddingBottom();
		var totalContentWidth = hasText || hasHTMLText ? this._textMeasuredWidth : 0.0;
		var totalContentHeight = hasText || hasHTMLText ? this._textMeasuredHeight : 0.0;
		if((hasSecondaryText || hasSecondaryHTMLText) && this.secondaryTextField != null) {
			totalContentWidth = Math.max(totalContentWidth,this._secondaryTextMeasuredWidth);
			totalContentHeight += this._secondaryTextMeasuredHeight + adjustedGap;
		}
		if(this._currentIcon != null) {
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				totalContentWidth += adjustedGap + this._currentIcon.get_width();
			}
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP || this.get_iconPosition() == (feathers_layout_RelativePosition().default).BOTTOM) {
				totalContentHeight += adjustedGap + this._currentIcon.get_height();
			}
		}
		var flexGapVertical = flexGap && (hasText || hasHTMLText || hasSecondaryText || hasSecondaryHTMLText) && this._currentIcon != null && (this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP || this.get_iconPosition() == (feathers_layout_RelativePosition().default).BOTTOM);
		var flexGapHorizontal = flexGap && (hasText || hasHTMLText || hasSecondaryText || hasSecondaryHTMLText) && this._currentIcon != null && (this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT);
		if(this.hasAccessoryViewInLayout()) {
			this._currentAccessoryView.set_x(this.actualWidth - this.get_paddingRight() - this._currentAccessoryView.get_width());
			switch(this.get_verticalAlign()._hx_index) {
			case 0:
				this._currentAccessoryView.set_y(this.get_paddingTop());
				break;
			case 1:
				this._currentAccessoryView.set_y(Math.max(this.get_paddingTop(),this.get_paddingTop() + (availableContentHeight - this._currentAccessoryView.get_height()) / 2.0));
				break;
			case 2:
				this._currentAccessoryView.set_y(Math.max(this.get_paddingTop(),this.get_paddingTop() + availableContentHeight - this._currentAccessoryView.get_height()));
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown vertical align: " + (Std().default).string(this.get_verticalAlign())));
			}
			availableContentWidth -= this._currentAccessoryView.get_width() + adjustedGap;
		}
		if(this._currentIcon != null) {
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP || this.get_iconPosition() == (feathers_layout_RelativePosition().default).BOTTOM) {
				switch(this.get_horizontalAlign()._hx_index) {
				case 0:
					this._currentIcon.set_x(this.get_paddingLeft());
					break;
				case 1:
					this._currentIcon.set_x(Math.max(this.get_paddingLeft(),this.get_paddingLeft() + (availableContentWidth - this._currentIcon.get_height()) / 2.0));
					break;
				case 2:
					this._currentIcon.set_x(Math.max(this.get_paddingLeft(),this.get_paddingLeft() + availableContentWidth - this._currentIcon.get_width()));
					break;
				default:
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown horizontal align: " + (Std().default).string(this.get_horizontalAlign())));
				}
			}
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				switch(this.get_verticalAlign()._hx_index) {
				case 0:
					this._currentIcon.set_y(this.get_paddingTop());
					break;
				case 1:
					this._currentIcon.set_y(Math.max(this.get_paddingTop(),this.get_paddingTop() + (availableContentHeight - this._currentIcon.get_height()) / 2.0));
					break;
				case 2:
					this._currentIcon.set_y(Math.max(this.get_paddingTop(),this.get_paddingTop() + availableContentHeight - this._currentIcon.get_height()));
					break;
				default:
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown vertical align: " + (Std().default).string(this.get_verticalAlign())));
				}
			}
		}
		var currentX = this.get_paddingLeft();
		var currentY = this.get_paddingTop();
		if(flexGapHorizontal) {
			currentX = this.get_paddingLeft();
		} else {
			switch(this.get_horizontalAlign()._hx_index) {
			case 0:
				currentX = this.get_paddingLeft();
				break;
			case 1:
				currentX = Math.max(this.get_paddingLeft(),this.get_paddingLeft() + (availableContentWidth - totalContentWidth) / 2.0);
				break;
			case 2:
				currentX = Math.max(this.get_paddingLeft(),this.get_paddingLeft() + availableContentWidth - totalContentWidth);
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown horizontal align: " + (Std().default).string(this.get_horizontalAlign())));
			}
		}
		if(flexGapVertical) {
			currentY = this.get_paddingTop();
		} else {
			switch(this.get_verticalAlign()._hx_index) {
			case 0:
				currentY = this.get_paddingTop();
				break;
			case 1:
				currentY = Math.max(this.get_paddingTop(),this.get_paddingTop() + (availableContentHeight - totalContentHeight) / 2.0);
				break;
			case 2:
				currentY = Math.max(this.get_paddingTop(),this.get_paddingTop() + availableContentHeight - totalContentHeight);
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown vertical align: " + (Std().default).string(this.get_verticalAlign())));
			}
		}
		if(this._currentIcon != null) {
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT) {
				this._currentIcon.set_x(currentX);
				currentX += adjustedGap + this._currentIcon.get_width();
			} else if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP) {
				this._currentIcon.set_y(currentY);
				currentY += adjustedGap + this._currentIcon.get_height();
			}
		}
		var totalTextWidth = 0.0;
		var totalTextHeight = 0.0;
		var availableTextWidth = availableContentWidth;
		if(this._currentIcon != null && (this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT || this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT)) {
			availableTextWidth -= adjustedGap + this._currentIcon.get_width();
		}
		if(hasText || hasHTMLText) {
			this.textField.set_x(currentX);
			this.textField.set_y(currentY);
			currentY += this._textMeasuredHeight + adjustedGap;
			totalTextWidth = Math.max(totalTextWidth,this.textField.get_width());
			totalTextHeight += this.textField.get_height();
			if(hasSecondaryText || hasSecondaryHTMLText) {
				totalTextHeight += adjustedGap;
			}
		}
		if((hasSecondaryText || hasSecondaryHTMLText) && this.secondaryTextField != null) {
			this.secondaryTextField.set_x(currentX);
			this.secondaryTextField.set_y(currentY);
			this.secondaryTextField.set_width(this._secondaryTextMeasuredWidth < availableTextWidth ? this._secondaryTextMeasuredWidth : availableTextWidth);
			currentY += this._secondaryTextMeasuredHeight + adjustedGap;
			totalTextWidth = Math.max(totalTextWidth,this.secondaryTextField.get_width());
			totalTextHeight += this.secondaryTextField.get_height();
		}
		if(flexGapHorizontal && this.get_iconPosition() == (feathers_layout_RelativePosition().default).LEFT) {
			if(hasText || hasHTMLText) {
				this.textField.set_x(Math.max(this.textField.get_x(),this.get_paddingLeft() + availableContentWidth - totalTextWidth));
			}
			if(hasSecondaryText || hasSecondaryHTMLText) {
				this.secondaryTextField.set_x(Math.max(this.secondaryTextField.get_x(),this.get_paddingLeft() + availableContentWidth - totalTextWidth));
			}
		} else if(flexGapVertical && this.get_iconPosition() == (feathers_layout_RelativePosition().default).TOP) {
			if(hasText || hasHTMLText) {
				this.textField.set_y(Math.max(this.textField.get_y(),this.get_paddingTop() + availableContentHeight - totalTextHeight));
			}
			if(hasSecondaryText || hasSecondaryHTMLText) {
				this.secondaryTextField.set_y(this.get_paddingTop() + availableContentHeight - this.secondaryTextField.get_height());
			}
		}
		if(hasText || hasHTMLText || hasSecondaryText || hasSecondaryHTMLText) {
			currentX += totalTextWidth + adjustedGap;
		}
		if(this._currentIcon != null) {
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).RIGHT) {
				if(flexGapHorizontal) {
					this._currentIcon.set_x(Math.max(currentX,this.get_paddingLeft() + availableContentWidth - this._currentIcon.get_width()));
				} else {
					this._currentIcon.set_x(currentX);
				}
			}
			if(this.get_iconPosition() == (feathers_layout_RelativePosition().default).BOTTOM) {
				if(flexGapVertical) {
					this._currentIcon.set_y(Math.max(currentY,this.get_paddingTop() + availableContentHeight - this._currentIcon.get_height()));
				} else {
					this._currentIcon.set_y(currentY);
				}
			}
		}
	},
	itemRenderer_secondaryTextFormat_changeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	itemRenderer_accessoryView_resizeHandler: function(event) {
		if(this._ignoreAccessoryResizes) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	get_secondaryTextFormat: function() {
		return this.__secondaryTextFormat;
	},
	set_secondaryTextFormat: function(value) {
		if(!this.setStyle("secondaryTextFormat")) {
			return this.__secondaryTextFormat;
		}
		if(this.__secondaryTextFormat == value) {
			return this.__secondaryTextFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_secondaryTextFormat);
		this.__secondaryTextFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__secondaryTextFormat;
	},
	clearStyle_secondaryTextFormat: function() {
		this.set_secondaryTextFormat(null);
		return this.get_secondaryTextFormat();
	},
	get_disabledSecondaryTextFormat: function() {
		return this.__disabledSecondaryTextFormat;
	},
	set_disabledSecondaryTextFormat: function(value) {
		if(!this.setStyle("disabledSecondaryTextFormat")) {
			return this.__disabledSecondaryTextFormat;
		}
		if(this.__disabledSecondaryTextFormat == value) {
			return this.__disabledSecondaryTextFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledSecondaryTextFormat);
		this.__disabledSecondaryTextFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledSecondaryTextFormat;
	},
	clearStyle_disabledSecondaryTextFormat: function() {
		this.set_disabledSecondaryTextFormat(null);
		return this.get_disabledSecondaryTextFormat();
	},
	get_selectedSecondaryTextFormat: function() {
		return this.__selectedSecondaryTextFormat;
	},
	set_selectedSecondaryTextFormat: function(value) {
		if(!this.setStyle("selectedSecondaryTextFormat")) {
			return this.__selectedSecondaryTextFormat;
		}
		if(this.__selectedSecondaryTextFormat == value) {
			return this.__selectedSecondaryTextFormat;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_selectedSecondaryTextFormat);
		this.__selectedSecondaryTextFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__selectedSecondaryTextFormat;
	},
	clearStyle_selectedSecondaryTextFormat: function() {
		this.set_selectedSecondaryTextFormat(null);
		return this.get_selectedSecondaryTextFormat();
	},
	get_alternateBackgroundSkin: function() {
		return this.__alternateBackgroundSkin;
	},
	set_alternateBackgroundSkin: function(value) {
		if(!this.setStyle("alternateBackgroundSkin")) {
			return this.__alternateBackgroundSkin;
		}
		if(this.__alternateBackgroundSkin == value) {
			return this.__alternateBackgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_alternateBackgroundSkin);
		this.__alternateBackgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__alternateBackgroundSkin;
	},
	clearStyle_alternateBackgroundSkin: function() {
		this.set_alternateBackgroundSkin(null);
		return this.get_alternateBackgroundSkin();
	},
	get_showSecondaryText: function() {
		return this.__showSecondaryText;
	},
	set_showSecondaryText: function(value) {
		if(!this.setStyle("showSecondaryText")) {
			return this.__showSecondaryText;
		}
		if(this.__showSecondaryText == value) {
			return this.__showSecondaryText;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_showSecondaryText);
		this.__showSecondaryText = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__showSecondaryText;
	},
	clearStyle_showSecondaryText: function() {
		this.set_showSecondaryText(true);
		return this.get_showSecondaryText();
	},
	get_accessoryView: function() {
		return this.__accessoryView;
	},
	set_accessoryView: function(value) {
		if(!this.setStyle("accessoryView")) {
			return this.__accessoryView;
		}
		if(this.__accessoryView == value) {
			return this.__accessoryView;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_accessoryView);
		this.__accessoryView = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__accessoryView;
	},
	clearStyle_accessoryView: function() {
		this.set_accessoryView(null);
		return this.get_accessoryView();
	},
	get_styleContext: function() {
		return ItemRenderer
	}
});
ItemRenderer.prototype.__class__ = ItemRenderer.prototype.constructor = $hxClasses["feathers.controls.dataRenderers.ItemRenderer"] = ItemRenderer;

// Init



// Statics


ItemRenderer.__meta__ = { fields : { setSecondaryTextFormatForState : { style : null}}}

// Export

exports["default"] = ItemRenderer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/LayoutGroupItemRenderer.js":
/*!*****************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/LayoutGroupItemRenderer.js ***!
  \*****************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers.LayoutGroupItemRenderer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IPointerDelegate() {return __webpack_require__(/*! ./../../../feathers/core/IPointerDelegate */ "./lib/_gen/feathers/core/IPointerDelegate.js");}
function feathers_controls_IToggle() {return __webpack_require__(/*! ./../../../feathers/controls/IToggle */ "./lib/_gen/feathers/controls/IToggle.js");}
function feathers_controls_dataRenderers_IDataRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/IDataRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IDataRenderer.js");}
function feathers_layout_ILayoutIndexObject() {return __webpack_require__(/*! ./../../../feathers/layout/ILayoutIndexObject */ "./lib/_gen/feathers/layout/ILayoutIndexObject.js");}
function feathers_core_IStateContext() {return __webpack_require__(/*! ./../../../feathers/core/IStateContext */ "./lib/_gen/feathers/core/IStateContext.js");}
function feathers_controls_LayoutGroup() {return __webpack_require__(/*! ./../../../feathers/controls/LayoutGroup */ "./lib/_gen/feathers/controls/LayoutGroup.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function feathers_themes_steel_components_SteelLayoutGroupItemRendererStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelLayoutGroupItemRendererStyles */ "./lib/_gen/feathers/themes/steel/components/SteelLayoutGroupItemRendererStyles.js");}
function feathers_utils_PointerToState() {return __webpack_require__(/*! ./../../../feathers/utils/PointerToState */ "./lib/_gen/feathers/utils/PointerToState.js");}
function feathers_controls_ToggleButtonState() {return __webpack_require__(/*! ./../../../feathers/controls/ToggleButtonState */ "./lib/_gen/feathers/controls/ToggleButtonState.js");}
function Std() {return __webpack_require__(/*! ./../../../Std */ "./lib/_gen/Std.js");}
function openfl_display_DisplayObjectContainer() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObjectContainer);}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function openfl_display_InteractiveObject() {return (__webpack_require__(/*! openfl */ "openfl").display.InteractiveObject);}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}
function feathers_core_IStateObserver() {return __webpack_require__(/*! ./../../../feathers/core/IStateObserver */ "./lib/_gen/feathers/core/IStateObserver.js");}
function haxe_ds_EnumValueMap() {return __webpack_require__(/*! ./../../../haxe/ds/EnumValueMap */ "./lib/_gen/haxe/ds/EnumValueMap.js");}

// Constructor

var LayoutGroupItemRenderer = function() {
	this.__alternateBackgroundSkin = null;
	this.__selectedBackgroundSkin = null;
	this._stateToSkin = new (haxe_ds_EnumValueMap().default)();
	this._pointerToState = null;
	this._selected = false;
	this._layoutIndex = -1;
	this._currentState = (feathers_controls_ToggleButtonState().default).UP(false);
	this.initializeLayoutGroupItemRendererTheme();
	(feathers_controls_LayoutGroup().default).call(this);
}

// Meta

LayoutGroupItemRenderer.__name__ = "feathers.controls.dataRenderers.LayoutGroupItemRenderer";
LayoutGroupItemRenderer.__isInterface__ = false;
LayoutGroupItemRenderer.__interfaces__ = [(feathers_core_IPointerDelegate().default),(feathers_controls_IToggle().default),(feathers_controls_dataRenderers_IDataRenderer().default),(feathers_layout_ILayoutIndexObject().default),(feathers_core_IStateContext().default)];
LayoutGroupItemRenderer.__super__ = (feathers_controls_LayoutGroup().default);
LayoutGroupItemRenderer.prototype = $extend((feathers_controls_LayoutGroup().default).prototype, {
	get_data: function() {
		return this._data;
	},
	set_data: function(value) {
		if(this._data == value) {
			return this._data;
		}
		this._data = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._data;
	},
	get_currentState: function() {
		return this._currentState;
	},
	get_layoutIndex: function() {
		return this._layoutIndex;
	},
	set_layoutIndex: function(value) {
		if(this._layoutIndex == value) {
			return this._layoutIndex;
		}
		this._layoutIndex = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._layoutIndex;
	},
	get_selected: function() {
		return this._selected;
	},
	set_selected: function(value) {
		if(this._selected == value) {
			return this._selected;
		}
		this._selected = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		this.changeState(this.get_currentState());
		return this._selected;
	},
	get_pointerTarget: function() {
		return this._pointerTarget;
	},
	set_pointerTarget: function(value) {
		if(this._pointerTarget == value) {
			return this._pointerTarget;
		}
		this._pointerTarget = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._pointerTarget;
	},
	getSkinForState: function(state) {
		return this._stateToSkin.get(state);
	},
	setSkinForState: function(state,skin) {
		if(!this.setStyle("setSkinForState",state)) {
			return;
		}
		var oldSkin = this._stateToSkin.get(state);
		if(oldSkin != null && oldSkin == this._currentBackgroundSkin) {
			this.removeCurrentBackgroundSkin(oldSkin);
			this._currentBackgroundSkin = null;
		}
		if(skin == null) {
			this._stateToSkin.remove(state);
		} else {
			this._stateToSkin.set(state,skin);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	initializeLayoutGroupItemRendererTheme: function() {
		(feathers_themes_steel_components_SteelLayoutGroupItemRendererStyles().default).initialize();
	},
	initialize: function() {
		(feathers_controls_LayoutGroup().default).prototype.initialize.call(this);
		if(this._pointerToState == null) {
			this._pointerToState = new (feathers_utils_PointerToState().default)(this,$bind(this,this.changeState),(feathers_controls_ToggleButtonState().default).UP(false),(feathers_controls_ToggleButtonState().default).DOWN(false),(feathers_controls_ToggleButtonState().default).HOVER(false));
		}
		this._pointerToState.set_customHitTest($bind(this,this.customHitTest));
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		if(dataInvalid) {
			this._pointerToState.set_target(this._pointerTarget != null ? this._pointerTarget : this);
		}
		(feathers_controls_LayoutGroup().default).prototype.update.call(this);
	},
	customHitTest: function(stageX,stageY) {
		var pointerTargetContainer = (Std().default).downcast(this._pointerTarget,(openfl_display_DisplayObjectContainer()));
		if(pointerTargetContainer == null) {
			pointerTargetContainer = this;
		}
		if(pointerTargetContainer.stage == null) {
			return false;
		}
		if(pointerTargetContainer.mouseChildren) {
			var objects = pointerTargetContainer.stage.getObjectsUnderPoint(new (openfl_geom_Point())(stageX,stageY));
			if(objects.length > 0) {
				var lastObject = objects[objects.length - 1];
				if(pointerTargetContainer.contains(lastObject)) {
					while(lastObject != null && lastObject != pointerTargetContainer) {
						if(((lastObject) instanceof (openfl_display_InteractiveObject()))) {
							var interactive = (js_Boot().default).__cast(lastObject , (openfl_display_InteractiveObject()));
							if(!interactive.mouseEnabled) {
								lastObject = lastObject.parent;
								continue;
							}
						}
						if((js_Boot().default).__implements(lastObject,(feathers_core_IFocusObject().default))) {
							var focusable = (js_Boot().default).__cast(lastObject , (feathers_core_IFocusObject().default));
							if(focusable.parent != this._pointerTarget && focusable.get_focusEnabled()) {
								return false;
							}
						}
						lastObject = lastObject.parent;
					}
				}
			}
		}
		return true;
	},
	changeState: function(state) {
		var toggleState = (js_Boot().default).__cast(state , (feathers_controls_ToggleButtonState().default));
		if(!this._enabled) {
			toggleState = (feathers_controls_ToggleButtonState().default).DISABLED(this._selected);
		}
		switch(toggleState._hx_index) {
		case 0:
			var selected = toggleState.selected;
			if(this._selected != selected) {
				toggleState = (feathers_controls_ToggleButtonState().default).UP(this._selected);
			}
			break;
		case 1:
			var selected1 = toggleState.selected;
			if(this._selected != selected1) {
				toggleState = (feathers_controls_ToggleButtonState().default).HOVER(this._selected);
			}
			break;
		case 2:
			var selected2 = toggleState.selected;
			if(this._selected != selected2) {
				toggleState = (feathers_controls_ToggleButtonState().default).DOWN(this._selected);
			}
			break;
		case 3:
			var selected3 = toggleState.selected;
			if(this._selected != selected3) {
				toggleState = (feathers_controls_ToggleButtonState().default).DISABLED(this._selected);
			}
			break;
		}
		if(this._currentState == toggleState) {
			return;
		}
		this._currentState = toggleState;
		this.setInvalid((feathers_core_InvalidationFlag().default).STATE);
		(feathers_events_FeathersEvent().default).dispatch(this,"stateChange");
	},
	getCurrentBackgroundSkin: function() {
		var result = this._stateToSkin.get(this._currentState);
		if(result != null) {
			return result;
		}
		if(!this._enabled && this.get_disabledBackgroundSkin() != null) {
			return this.get_disabledBackgroundSkin();
		}
		if(this._selected && this.get_selectedBackgroundSkin() != null) {
			return this.get_selectedBackgroundSkin();
		}
		if(this.get_alternateBackgroundSkin() != null && this._layoutIndex % 2 == 1) {
			return this.get_alternateBackgroundSkin();
		}
		return this.get_backgroundSkin();
	},
	addCurrentBackgroundSkin: function(skin) {
		if(skin != null) {
			if((js_Boot().default).__implements(skin,(feathers_core_IStateObserver().default))) {
				((js_Boot().default).__cast(skin , (feathers_core_IStateObserver().default))).set_stateContext(this);
			}
		}
		(feathers_controls_LayoutGroup().default).prototype.addCurrentBackgroundSkin.call(this,skin);
	},
	removeCurrentBackgroundSkin: function(skin) {
		if(skin != null) {
			if((js_Boot().default).__implements(skin,(feathers_core_IStateObserver().default))) {
				((js_Boot().default).__cast(skin , (feathers_core_IStateObserver().default))).set_stateContext(null);
			}
		}
		(feathers_controls_LayoutGroup().default).prototype.removeCurrentBackgroundSkin.call(this,skin);
	},
	get_styleContext: function() {
		return LayoutGroupItemRenderer
	},
	get_selectedBackgroundSkin: function() {
		return this.__selectedBackgroundSkin;
	},
	set_selectedBackgroundSkin: function(value) {
		if(!this.setStyle("selectedBackgroundSkin")) {
			return this.__selectedBackgroundSkin;
		}
		if(this.__selectedBackgroundSkin == value) {
			return this.__selectedBackgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_selectedBackgroundSkin);
		this.__selectedBackgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__selectedBackgroundSkin;
	},
	clearStyle_selectedBackgroundSkin: function() {
		this.set_selectedBackgroundSkin(null);
		return this.get_selectedBackgroundSkin();
	},
	get_alternateBackgroundSkin: function() {
		return this.__alternateBackgroundSkin;
	},
	set_alternateBackgroundSkin: function(value) {
		if(!this.setStyle("alternateBackgroundSkin")) {
			return this.__alternateBackgroundSkin;
		}
		if(this.__alternateBackgroundSkin == value) {
			return this.__alternateBackgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_alternateBackgroundSkin);
		this.__alternateBackgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__alternateBackgroundSkin;
	},
	clearStyle_alternateBackgroundSkin: function() {
		this.set_alternateBackgroundSkin(null);
		return this.get_alternateBackgroundSkin();
	}
});
LayoutGroupItemRenderer.prototype.__class__ = LayoutGroupItemRenderer.prototype.constructor = $hxClasses["feathers.controls.dataRenderers.LayoutGroupItemRenderer"] = LayoutGroupItemRenderer;

// Init



// Statics


LayoutGroupItemRenderer.__meta__ = { fields : { setSkinForState : { style : null}}}

// Export

exports["default"] = LayoutGroupItemRenderer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/SortOrderHeaderRenderer.js":
/*!*****************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/SortOrderHeaderRenderer.js ***!
  \*****************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers.SortOrderHeaderRenderer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_data_ISortOrderObserver() {return __webpack_require__(/*! ./../../../feathers/data/ISortOrderObserver */ "./lib/_gen/feathers/data/ISortOrderObserver.js");}
function feathers_controls_dataRenderers_ItemRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/ItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ItemRenderer.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_themes_steel_components_SteelSortOrderHeaderRendererStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelSortOrderHeaderRendererStyles */ "./lib/_gen/feathers/themes/steel/components/SteelSortOrderHeaderRendererStyles.js");}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function Std() {return __webpack_require__(/*! ./../../../Std */ "./lib/_gen/Std.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_core_IStateObserver() {return __webpack_require__(/*! ./../../../feathers/core/IStateObserver */ "./lib/_gen/feathers/core/IStateObserver.js");}
function feathers_data_SortOrder() {return __webpack_require__(/*! ./../../../feathers/data/SortOrder */ "./lib/_gen/feathers/data/SortOrder.js");}

// Constructor

var SortOrderHeaderRenderer = function() {
	this.__sortDescendingIcon = null;
	this.__sortAscendingIcon = null;
	this._sortOrder = (feathers_data_SortOrder().default).NONE;
	this.initializeSortOrderHeaderRendererTheme();
	(feathers_controls_dataRenderers_ItemRenderer().default).call(this);
	this.set_toggleable(false);
}

// Meta

SortOrderHeaderRenderer.__name__ = "feathers.controls.dataRenderers.SortOrderHeaderRenderer";
SortOrderHeaderRenderer.__isInterface__ = false;
SortOrderHeaderRenderer.__interfaces__ = [(feathers_data_ISortOrderObserver().default)];
SortOrderHeaderRenderer.__super__ = (feathers_controls_dataRenderers_ItemRenderer().default);
SortOrderHeaderRenderer.prototype = $extend((feathers_controls_dataRenderers_ItemRenderer().default).prototype, {
	get_sortOrder: function() {
		return this._sortOrder;
	},
	set_sortOrder: function(value) {
		if(this._sortOrder == value) {
			return this._sortOrder;
		}
		this._sortOrder = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._sortOrder;
	},
	initializeSortOrderHeaderRendererTheme: function() {
		(feathers_themes_steel_components_SteelSortOrderHeaderRendererStyles().default).initialize();
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(stylesInvalid || stateInvalid || dataInvalid) {
			this.refreshSortOrderIcon();
		}
		(feathers_controls_dataRenderers_ItemRenderer().default).prototype.update.call(this);
	},
	calculateExplicitWidthForTextMeasurement: function() {
		var textFieldExplicitWidth = (feathers_controls_dataRenderers_ItemRenderer().default).prototype.calculateExplicitWidthForTextMeasurement.call(this);
		if(textFieldExplicitWidth == null) {
			return textFieldExplicitWidth;
		}
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		if(this._currentSortOrderIcon != null) {
			if((js_Boot().default).__implements(this._currentSortOrderIcon,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentSortOrderIcon , (feathers_core_IValidating().default))).validateNow();
			}
			textFieldExplicitWidth -= this._currentSortOrderIcon.get_width() + adjustedGap;
		}
		if(textFieldExplicitWidth < 0.0) {
			textFieldExplicitWidth = 0.0;
		}
		return textFieldExplicitWidth;
	},
	measureContentWidth: function() {
		var contentWidth = (feathers_controls_dataRenderers_ItemRenderer().default).prototype.measureContentWidth.call(this);
		if((js_Boot().default).__implements(this._currentSortOrderIcon,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentSortOrderIcon , (feathers_core_IValidating().default))).validateNow();
		}
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		if(this._currentSortOrderIcon != null) {
			contentWidth += this._currentSortOrderIcon.get_width() + adjustedGap;
		}
		return contentWidth;
	},
	measureContentMinWidth: function() {
		var contentMinWidth = (feathers_controls_dataRenderers_ItemRenderer().default).prototype.measureContentMinWidth.call(this);
		if((js_Boot().default).__implements(this._currentSortOrderIcon,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentSortOrderIcon , (feathers_core_IValidating().default))).validateNow();
		}
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		if(this._currentSortOrderIcon != null) {
			contentMinWidth += this._currentSortOrderIcon.get_width() + adjustedGap;
		}
		return contentMinWidth;
	},
	layoutChildren: function() {
		var _gthis = this;
		if((js_Boot().default).__implements(this._currentSortOrderIcon,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentSortOrderIcon , (feathers_core_IValidating().default))).validateNow();
		}
		var paddingRight = this.get_paddingRight();
		var adjustedGap = this.get_gap();
		if(adjustedGap == 1.0 / 0.0) {
			adjustedGap = this.get_minGap();
		}
		this.runWithoutInvalidation(function() {
			var newPaddingRight = paddingRight;
			if(_gthis._currentSortOrderIcon != null) {
				newPaddingRight += _gthis._currentSortOrderIcon.get_width() + adjustedGap;
			}
			return _gthis.set_paddingRight(newPaddingRight);
		});
		(feathers_controls_dataRenderers_ItemRenderer().default).prototype.layoutChildren.call(this);
		this.runWithoutInvalidation(function() {
			return _gthis.set_paddingRight(paddingRight);
		});
		if(this._currentSortOrderIcon != null) {
			this._currentSortOrderIcon.set_x(this.actualWidth - this.get_paddingRight() - this._currentSortOrderIcon.get_width());
			switch(this.get_verticalAlign()._hx_index) {
			case 0:
				this._currentSortOrderIcon.set_y(this.get_paddingTop());
				break;
			case 1:
				this._currentSortOrderIcon.set_y(Math.max(this.get_paddingTop(),this.get_paddingTop() + (this.actualHeight - this.get_paddingTop() - this.get_paddingBottom() - this._currentSortOrderIcon.get_height()) / 2.0));
				break;
			case 2:
				this._currentSortOrderIcon.set_y(Math.max(this.get_paddingTop(),this.get_paddingTop() + this.actualHeight - this.get_paddingTop() - this.get_paddingBottom() - this._currentSortOrderIcon.get_height()));
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown vertical align: " + (Std().default).string(this.get_verticalAlign())));
			}
		}
	},
	refreshSortOrderIcon: function() {
		var oldIcon = this._currentSortOrderIcon;
		this._currentSortOrderIcon = this.getCurrentSortOrderIcon();
		if(this._currentSortOrderIcon == oldIcon) {
			return;
		}
		this.removeCurrentSortOrderIcon(oldIcon);
		if(this._currentSortOrderIcon == null) {
			this._sortOrderIconMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(this._currentSortOrderIcon,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._currentSortOrderIcon , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._sortOrderIconMeasurements == null) {
			this._sortOrderIconMeasurements = new (feathers_layout_Measurements().default)(this._currentSortOrderIcon);
		} else {
			this._sortOrderIconMeasurements.save(this._currentSortOrderIcon);
		}
		if((js_Boot().default).__implements(this._currentSortOrderIcon,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(this._currentSortOrderIcon , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		if((js_Boot().default).__implements(this._currentSortOrderIcon,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(this._currentSortOrderIcon , (feathers_core_IStateObserver().default))).set_stateContext(this);
		}
		this.addChild(this._currentSortOrderIcon);
	},
	getCurrentSortOrderIcon: function() {
		switch(this._sortOrder._hx_index) {
		case 0:
			return this.get_sortAscendingIcon();
		case 1:
			return this.get_sortDescendingIcon();
		default:
			return null;
		}
	},
	removeCurrentSortOrderIcon: function(icon) {
		if(icon == null) {
			return;
		}
		if((js_Boot().default).__implements(icon,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(icon , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		if((js_Boot().default).__implements(icon,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(icon , (feathers_core_IStateObserver().default))).set_stateContext(null);
		}
		this._sortOrderIconMeasurements.restore(icon);
		if(icon.parent == this) {
			this.removeChild(icon);
		}
	},
	get_styleContext: function() {
		return SortOrderHeaderRenderer
	},
	get_sortAscendingIcon: function() {
		return this.__sortAscendingIcon;
	},
	set_sortAscendingIcon: function(value) {
		if(!this.setStyle("sortAscendingIcon")) {
			return this.__sortAscendingIcon;
		}
		if(this.__sortAscendingIcon == value) {
			return this.__sortAscendingIcon;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_sortAscendingIcon);
		this.__sortAscendingIcon = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__sortAscendingIcon;
	},
	clearStyle_sortAscendingIcon: function() {
		this.set_sortAscendingIcon(null);
		return this.get_sortAscendingIcon();
	},
	get_sortDescendingIcon: function() {
		return this.__sortDescendingIcon;
	},
	set_sortDescendingIcon: function(value) {
		if(!this.setStyle("sortDescendingIcon")) {
			return this.__sortDescendingIcon;
		}
		if(this.__sortDescendingIcon == value) {
			return this.__sortDescendingIcon;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_sortDescendingIcon);
		this.__sortDescendingIcon = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__sortDescendingIcon;
	},
	clearStyle_sortDescendingIcon: function() {
		this.set_sortDescendingIcon(null);
		return this.get_sortDescendingIcon();
	}
});
SortOrderHeaderRenderer.prototype.__class__ = SortOrderHeaderRenderer.prototype.constructor = $hxClasses["feathers.controls.dataRenderers.SortOrderHeaderRenderer"] = SortOrderHeaderRenderer;

// Init



// Statics




// Export

exports["default"] = SortOrderHeaderRenderer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/TreeGridViewCellRenderer.js":
/*!******************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/TreeGridViewCellRenderer.js ***!
  \******************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers.TreeGridViewCellRenderer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_dataRenderers_ITreeGridViewCellRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/ITreeGridViewCellRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ITreeGridViewCellRenderer.js");}
function feathers_controls_dataRenderers_HierarchicalItemRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/HierarchicalItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/HierarchicalItemRenderer.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}

// Constructor

var TreeGridViewCellRenderer = function() {
	this._column = null;
	this._columnIndex = -1;
	(feathers_controls_dataRenderers_HierarchicalItemRenderer().default).call(this);
}

// Meta

TreeGridViewCellRenderer.__name__ = "feathers.controls.dataRenderers.TreeGridViewCellRenderer";
TreeGridViewCellRenderer.__isInterface__ = false;
TreeGridViewCellRenderer.__interfaces__ = [(feathers_controls_dataRenderers_ITreeGridViewCellRenderer().default)];
TreeGridViewCellRenderer.__super__ = (feathers_controls_dataRenderers_HierarchicalItemRenderer().default);
TreeGridViewCellRenderer.prototype = $extend((feathers_controls_dataRenderers_HierarchicalItemRenderer().default).prototype, {
	get_rowLocation: function() {
		return this._rowLocation;
	},
	set_rowLocation: function(value) {
		if(this._rowLocation == value) {
			return this._rowLocation;
		}
		this._rowLocation = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._rowLocation;
	},
	get_columnIndex: function() {
		return this._columnIndex;
	},
	set_columnIndex: function(value) {
		if(this._columnIndex == value) {
			return this._columnIndex;
		}
		this._columnIndex = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._columnIndex;
	},
	get_column: function() {
		return this._column;
	},
	set_column: function(value) {
		if(this._column == value) {
			return this._column;
		}
		this._column = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._column;
	},
	get_treeGridViewOwner: function() {
		return this._treeGridViewOwner;
	},
	set_treeGridViewOwner: function(value) {
		if(this._treeGridViewOwner == value) {
			return this._treeGridViewOwner;
		}
		this._treeGridViewOwner = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._treeGridViewOwner;
	}
});
TreeGridViewCellRenderer.prototype.__class__ = TreeGridViewCellRenderer.prototype.constructor = $hxClasses["feathers.controls.dataRenderers.TreeGridViewCellRenderer"] = TreeGridViewCellRenderer;

// Init



// Statics




// Export

exports["default"] = TreeGridViewCellRenderer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/TreeGridViewRowRenderer.js":
/*!*****************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/TreeGridViewRowRenderer.js ***!
  \*****************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers.TreeGridViewRowRenderer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_dataRenderers_IDataRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/IDataRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IDataRenderer.js");}
function feathers_controls_IToggle() {return __webpack_require__(/*! ./../../../feathers/controls/IToggle */ "./lib/_gen/feathers/controls/IToggle.js");}
function feathers_controls_ITriggerView() {return __webpack_require__(/*! ./../../../feathers/controls/ITriggerView */ "./lib/_gen/feathers/controls/ITriggerView.js");}
function feathers_controls_LayoutGroup() {return __webpack_require__(/*! ./../../../feathers/controls/LayoutGroup */ "./lib/_gen/feathers/controls/LayoutGroup.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function feathers_layout_GridViewRowLayout() {return __webpack_require__(/*! ./../../../feathers/layout/GridViewRowLayout */ "./lib/_gen/feathers/layout/GridViewRowLayout.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function Type() {return __webpack_require__(/*! ./../../../Type */ "./lib/_gen/Type.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function Std() {return __webpack_require__(/*! ./../../../Std */ "./lib/_gen/Std.js");}
function feathers_controls_dataRenderers__$TreeGridViewRowRenderer_CellRendererStorage() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/_TreeGridViewRowRenderer/CellRendererStorage */ "./lib/_gen/feathers/controls/dataRenderers/_TreeGridViewRowRenderer/CellRendererStorage.js");}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_style_IVariantStyleObject() {return __webpack_require__(/*! ./../../../feathers/style/IVariantStyleObject */ "./lib/_gen/feathers/style/IVariantStyleObject.js");}
function feathers_controls_TreeGridView() {return __webpack_require__(/*! ./../../../feathers/controls/TreeGridView */ "./lib/_gen/feathers/controls/TreeGridView.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_core_IOpenCloseToggle() {return __webpack_require__(/*! ./../../../feathers/core/IOpenCloseToggle */ "./lib/_gen/feathers/core/IOpenCloseToggle.js");}
function feathers_controls_dataRenderers_IHierarchicalItemRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/IHierarchicalItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IHierarchicalItemRenderer.js");}
function feathers_controls_dataRenderers_IOptionalHierarchyItemRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/IOptionalHierarchyItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IOptionalHierarchyItemRenderer.js");}
function feathers_controls_dataRenderers_IHierarchicalDepthItemRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/IHierarchicalDepthItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IHierarchicalDepthItemRenderer.js");}
function feathers_controls_dataRenderers_ITreeGridViewCellRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/ITreeGridViewCellRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ITreeGridViewCellRenderer.js");}
function feathers_layout_ILayoutIndexObject() {return __webpack_require__(/*! ./../../../feathers/layout/ILayoutIndexObject */ "./lib/_gen/feathers/layout/ILayoutIndexObject.js");}
function feathers_core_IPointerDelegate() {return __webpack_require__(/*! ./../../../feathers/core/IPointerDelegate */ "./lib/_gen/feathers/core/IPointerDelegate.js");}
function feathers_events_TriggerEvent() {return __webpack_require__(/*! ./../../../feathers/events/TriggerEvent */ "./lib/_gen/feathers/events/TriggerEvent.js");}
function openfl_display_DisplayObject() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObject);}
function feathers_events_TreeGridViewEvent() {return __webpack_require__(/*! ./../../../feathers/events/TreeGridViewEvent */ "./lib/_gen/feathers/events/TreeGridViewEvent.js");}
function feathers_data_TreeGridViewCellState() {return __webpack_require__(/*! ./../../../feathers/data/TreeGridViewCellState */ "./lib/_gen/feathers/data/TreeGridViewCellState.js");}
function feathers_core_ITextControl() {return __webpack_require__(/*! ./../../../feathers/core/ITextControl */ "./lib/_gen/feathers/core/ITextControl.js");}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}
function haxe_ds_ObjectMap() {return __webpack_require__(/*! ./../../../haxe/ds/ObjectMap */ "./lib/_gen/haxe/ds/ObjectMap.js");}

// Constructor

var TreeGridViewRowRenderer = function() {
	this._customCellRendererVariant = null;
	this._forceCellStateUpdate = false;
	this._columns = null;
	this._data = null;
	this._opened = false;
	this._branch = false;
	this._layoutIndex = -1;
	this._rowLocation = null;
	this.selectable = true;
	this._ignoreOpenedChange = false;
	this._ignoreSelectionChange = false;
	this._selected = false;
	this.cellStatePool = new (lime_utils_ObjectPool().default)(function() {
		return new (feathers_data_TreeGridViewCellState().default)();
	});
	this._cellRendererToCellState = new (haxe_ds_ObjectMap().default)();
	this._columnToCellRenderer = new (haxe_ds_ObjectMap().default)();
	this._unrenderedData = [];
	this._additionalStorage = null;
	this._defaultStorage = new (feathers_controls_dataRenderers__$TreeGridViewRowRenderer_CellRendererStorage().default)();
	(feathers_controls_LayoutGroup().default).call(this);
}

// Meta

TreeGridViewRowRenderer.__name__ = "feathers.controls.dataRenderers.TreeGridViewRowRenderer";
TreeGridViewRowRenderer.__isInterface__ = false;
TreeGridViewRowRenderer.__interfaces__ = [(feathers_controls_dataRenderers_IDataRenderer().default),(feathers_controls_IToggle().default),(feathers_controls_ITriggerView().default)];
TreeGridViewRowRenderer.__super__ = (feathers_controls_LayoutGroup().default);
TreeGridViewRowRenderer.prototype = $extend((feathers_controls_LayoutGroup().default).prototype, {
	get_treeGridView: function() {
		return this._treeGridView;
	},
	set_treeGridView: function(value) {
		if(this._treeGridView == value) {
			return this._treeGridView;
		}
		if(this._treeGridView != null) {
			this._treeGridView.removeEventListener("keyDown",$bind(this,this.treeGridViewRowRenderer_treeGridView_keyDownHandler));
		}
		this._treeGridView = value;
		if(this._treeGridView != null) {
			this._treeGridView.addEventListener("keyDown",$bind(this,this.treeGridViewRowRenderer_treeGridView_keyDownHandler),false,0,true);
		} else {
			this.refreshInactiveCellRenderers(this._defaultStorage,true);
			if(this._additionalStorage != null) {
				var _g = 0;
				var _g1 = this._additionalStorage.length;
				while(_g < _g1) {
					var i = _g++;
					var storage = this._additionalStorage[i];
					this.refreshInactiveCellRenderers(storage,true);
				}
			}
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._treeGridView;
	},
	get_selected: function() {
		return this._selected;
	},
	set_selected: function(value) {
		if(this._selected == value) {
			return this._selected;
		}
		this._selected = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._selected;
	},
	get_rowLocation: function() {
		return this._rowLocation;
	},
	set_rowLocation: function(value) {
		if(this._rowLocation == value) {
			return this._rowLocation;
		}
		this._rowLocation = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._rowLocation;
	},
	get_layoutIndex: function() {
		return this._layoutIndex;
	},
	set_layoutIndex: function(value) {
		if(this._layoutIndex == value) {
			return this._layoutIndex;
		}
		this._layoutIndex = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._layoutIndex;
	},
	get_branch: function() {
		return this._branch;
	},
	set_branch: function(value) {
		if(this._branch == value) {
			return this._branch;
		}
		this._branch = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._branch;
	},
	get_opened: function() {
		return this._branch;
	},
	set_opened: function(value) {
		if(this._opened == value) {
			return this._opened;
		}
		this._opened = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._opened;
	},
	get_data: function() {
		return this._data;
	},
	set_data: function(value) {
		if(this._data == value) {
			return this._data;
		}
		this._data = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._data;
	},
	get_columns: function() {
		return this._columns;
	},
	set_columns: function(value) {
		if(this._columns == value) {
			return this._columns;
		}
		if(this._columns != null) {
			this._columns.removeEventListener("change",$bind(this,this.treeGridViewRowRenderer_columns_changeHandler));
		}
		this._columns = value;
		if(this._columns != null) {
			this._columns.addEventListener("change",$bind(this,this.treeGridViewRowRenderer_columns_changeHandler),false,0,true);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._columns;
	},
	get_cellRendererRecycler: function() {
		return this._defaultStorage.cellRendererRecycler;
	},
	set_cellRendererRecycler: function(value) {
		if(this._defaultStorage.cellRendererRecycler == value) {
			return this._defaultStorage.cellRendererRecycler;
		}
		this._defaultStorage.oldCellRendererRecycler = this._defaultStorage.cellRendererRecycler;
		this._defaultStorage.cellRendererRecycler = value;
		this._defaultStorage.measurements = null;
		this.setInvalid(TreeGridViewRowRenderer.INVALIDATION_FLAG_CELL_RENDERER_FACTORY);
		return this._defaultStorage.cellRendererRecycler;
	},
	get_forceCellStateUpdate: function() {
		return this._forceCellStateUpdate;
	},
	set_forceCellStateUpdate: function(value) {
		if(this._forceCellStateUpdate == value) {
			return this._forceCellStateUpdate;
		}
		this._forceCellStateUpdate = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._forceCellStateUpdate;
	},
	get_customCellRendererVariant: function() {
		return this._customCellRendererVariant;
	},
	set_customCellRendererVariant: function(value) {
		if(this._customCellRendererVariant == value) {
			return this._customCellRendererVariant;
		}
		this._customCellRendererVariant = value;
		this.setInvalid(TreeGridViewRowRenderer.INVALIDATION_FLAG_CELL_RENDERER_FACTORY);
		return this._customCellRendererVariant;
	},
	get_customColumnWidths: function() {
		return this._customColumnWidths;
	},
	set_customColumnWidths: function(value) {
		if(this._customColumnWidths == value) {
			return this._customColumnWidths;
		}
		this._customColumnWidths = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._customColumnWidths;
	},
	initialize: function() {
		(feathers_controls_LayoutGroup().default).prototype.initialize.call(this);
		if(this.get_layout() == null) {
			this._rowLayout = new (feathers_layout_GridViewRowLayout().default)();
			this.set_layout(this._rowLayout);
		}
	},
	columnToCellRenderer: function(column) {
		if(column == null) {
			return null;
		}
		return this._columnToCellRenderer.get(column);
	},
	updateCells: function() {
		var _g = 0;
		var _g1 = this._columns.get_length();
		while(_g < _g1) {
			var i = _g++;
			this.updateCellRendererForColumnIndex(i);
		}
	},
	update: function() {
		this.preLayout();
		(feathers_controls_LayoutGroup().default).prototype.update.call(this);
	},
	preLayout: function() {
		this._rowLayout.set_columns(this._columns);
		this._rowLayout.set_customColumnWidths(this._customColumnWidths);
		if(this._defaultStorage.cellRendererRecycler.update == null) {
			this._defaultStorage.cellRendererRecycler.update = TreeGridViewRowRenderer.defaultUpdateCellRenderer;
			if(this._defaultStorage.cellRendererRecycler.reset == null) {
				this._defaultStorage.cellRendererRecycler.reset = TreeGridViewRowRenderer.defaultResetCellRenderer;
			}
		}
		var column = this._columns.iterator();
		while(column.hasNext()) {
			var column1 = column.next();
			if(column1.cellRendererRecycler != null) {
				if(column1.cellRendererRecycler.update == null) {
					column1.cellRendererRecycler.update = TreeGridViewRowRenderer.defaultUpdateCellRenderer;
					if(column1.cellRendererRecycler.reset == null) {
						column1.cellRendererRecycler.reset = TreeGridViewRowRenderer.defaultResetCellRenderer;
					}
				}
			}
		}
		this.refreshInactiveCellRenderers(this._defaultStorage,false);
		if(this._additionalStorage != null) {
			var _g = 0;
			var _g1 = this._additionalStorage.length;
			while(_g < _g1) {
				var i = _g++;
				var storage = this._additionalStorage[i];
				this.refreshInactiveCellRenderers(storage,false);
			}
		}
		this.findUnrenderedData();
		this.recoverInactiveCellRenderers(this._defaultStorage);
		if(this._additionalStorage != null) {
			var _g2 = 0;
			var _g11 = this._additionalStorage.length;
			while(_g2 < _g11) {
				var i1 = _g2++;
				var storage1 = this._additionalStorage[i1];
				this.recoverInactiveCellRenderers(storage1);
			}
		}
		this.renderUnrenderedData();
		this.freeInactiveCellRenderers(this._defaultStorage);
		if(this._additionalStorage != null) {
			var _g3 = 0;
			var _g12 = this._additionalStorage.length;
			while(_g3 < _g12) {
				var i2 = _g3++;
				var storage2 = this._additionalStorage[i2];
				this.freeInactiveCellRenderers(storage2);
			}
		}
		if(this._defaultStorage.inactiveCellRenderers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive cell renderers should be empty after updating."));
		}
		if(this._additionalStorage != null) {
			var _g4 = 0;
			var _g13 = this._additionalStorage.length;
			while(_g4 < _g13) {
				var i3 = _g4++;
				var storage3 = this._additionalStorage[i3];
				if(storage3.inactiveCellRenderers.length > 0) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": inactive cell renderers should be empty after updating."));
				}
			}
		}
	},
	refreshInactiveCellRenderers: function(storage,forceCleanup) {
		var temp = storage.inactiveCellRenderers;
		storage.inactiveCellRenderers = storage.activeCellRenderers;
		storage.activeCellRenderers = temp;
		if(storage.activeCellRenderers.length > 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": active cell renderers should be empty before updating."));
		}
		if(forceCleanup) {
			this.recoverInactiveCellRenderers(storage);
			this.freeInactiveCellRenderers(storage);
			storage.oldCellRendererRecycler = null;
		}
	},
	findUnrenderedData: function() {
		var _g = 0;
		var _g1 = this._columns.get_length();
		while(_g < _g1) {
			var i = _g++;
			var column = this._columns.get(i);
			var cellRenderer = this._columnToCellRenderer.get(column);
			if(cellRenderer != null) {
				var storage = this.cellRendererRecyclerToStorage(column.cellRendererRecycler);
				var state = this._cellRendererToCellState.get(cellRenderer);
				var changed = this.populateCurrentItemState(column,i,state,this._forceCellStateUpdate);
				if(changed) {
					this.updateCellRenderer(cellRenderer,state,storage);
				}
				this.setChildIndex(cellRenderer,i);
				var removed = (HxOverrides().default).remove(storage.inactiveCellRenderers,cellRenderer);
				if(!removed) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + (Type().default).getClassName((Type().default).getClass(this)) + ": cell renderer map contains bad data for item at row location " + (Std().default).string(this._rowLocation) + " and column index " + i + ". This may be caused by duplicate items in the data provider, which is not allowed."));
				}
				storage.activeCellRenderers.push(cellRenderer);
			} else {
				this._unrenderedData.push(i);
			}
		}
	},
	cellRendererRecyclerToStorage: function(recycler) {
		if(recycler == null) {
			return this._defaultStorage;
		}
		if(this._additionalStorage == null) {
			this._additionalStorage = [];
		}
		var _g = 0;
		var _g1 = this._additionalStorage.length;
		while(_g < _g1) {
			var i = _g++;
			var storage = this._additionalStorage[i];
			if(storage.cellRendererRecycler == recycler) {
				return storage;
			}
		}
		var storage1 = new (feathers_controls_dataRenderers__$TreeGridViewRowRenderer_CellRendererStorage().default)(recycler);
		this._additionalStorage.push(storage1);
		return storage1;
	},
	recoverInactiveCellRenderers: function(storage) {
		var _g = 0;
		var _g1 = storage.inactiveCellRenderers;
		while(_g < _g1.length) {
			var cellRenderer = _g1[_g];
			++_g;
			if(cellRenderer == null) {
				continue;
			}
			var state = this._cellRendererToCellState.get(cellRenderer);
			if(state == null) {
				continue;
			}
			var column = state.column;
			this._cellRendererToCellState.remove(cellRenderer);
			this._columnToCellRenderer.remove(column);
			cellRenderer.removeEventListener("click",$bind(this,this.treeGridViewRowRenderer_cellRenderer_clickHandler));
			cellRenderer.removeEventListener("touchTap",$bind(this,this.treeGridViewRowRenderer_cellRenderer_touchTapHandler));
			cellRenderer.removeEventListener("trigger",$bind(this,this.treeGridViewRowRenderer_cellRenderer_triggerHandler));
			cellRenderer.removeEventListener("change",$bind(this,this.treeGridViewRowRenderer_cellRenderer_changeHandler));
			cellRenderer.removeEventListener("resize",$bind(this,this.treeGridViewRowRenderer_cellRenderer_resizeHandler));
			cellRenderer.removeEventListener("open",$bind(this,this.treeGridViewRowRenderer_cellRenderer_openHandler));
			cellRenderer.removeEventListener("close",$bind(this,this.treeGridViewRowRenderer_cellRenderer_closeHandler));
			this.resetCellRenderer(cellRenderer,state,storage);
			if(storage.measurements != null) {
				storage.measurements.restore(cellRenderer);
			}
			this.cellStatePool.release(state);
		}
	},
	renderUnrenderedData: function() {
		var _g = 0;
		var _g1 = this._unrenderedData;
		while(_g < _g1.length) {
			var columnIndex = _g1[_g];
			++_g;
			var column = this._columns.get(columnIndex);
			var state = this.cellStatePool.get();
			this.populateCurrentItemState(column,columnIndex,state,true);
			var cellRenderer = this.createCellRenderer(state);
			this.addChild(cellRenderer);
		}
		this._unrenderedData.length = 0;
	},
	freeInactiveCellRenderers: function(storage) {
		var cellRendererRecycler = storage.oldCellRendererRecycler != null ? storage.oldCellRendererRecycler : storage.cellRendererRecycler;
		var _g = 0;
		var _g1 = storage.inactiveCellRenderers;
		while(_g < _g1.length) {
			var cellRenderer = _g1[_g];
			++_g;
			if(cellRenderer == null) {
				continue;
			}
			this.destroyCellRenderer(cellRenderer,cellRendererRecycler);
		}
		storage.inactiveCellRenderers.length = 0;
	},
	createCellRenderer: function(state) {
		var column = state.column;
		var cellRenderer = null;
		var storage = this.cellRendererRecyclerToStorage(column.cellRendererRecycler);
		if(storage.inactiveCellRenderers.length == 0) {
			cellRenderer = storage.cellRendererRecycler.create();
			if((js_Boot().default).__implements(cellRenderer,(feathers_style_IVariantStyleObject().default))) {
				var variantCellRenderer = (js_Boot().default).__cast(cellRenderer , (feathers_style_IVariantStyleObject().default));
				if(variantCellRenderer.get_variant() == null) {
					var variant = this.get_customCellRendererVariant() != null ? this.get_customCellRendererVariant() : (feathers_controls_TreeGridView().default).CHILD_VARIANT_CELL_RENDERER;
					variantCellRenderer.set_variant(variant);
				}
			}
			if((js_Boot().default).__implements(cellRenderer,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(cellRenderer , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(storage.measurements == null) {
				storage.measurements = new (feathers_layout_Measurements().default)(cellRenderer);
			}
		} else {
			cellRenderer = storage.inactiveCellRenderers.shift();
		}
		var storage1 = this.cellRendererRecyclerToStorage(column.cellRendererRecycler);
		this.updateCellRenderer(cellRenderer,state,storage1);
		if((js_Boot().default).__implements(cellRenderer,(feathers_controls_ITriggerView().default))) {
			cellRenderer.addEventListener("trigger",$bind(this,this.treeGridViewRowRenderer_cellRenderer_triggerHandler));
		} else {
			cellRenderer.addEventListener("click",$bind(this,this.treeGridViewRowRenderer_cellRenderer_clickHandler));
		}
		if((js_Boot().default).__implements(cellRenderer,(feathers_controls_IToggle().default))) {
			cellRenderer.addEventListener("change",$bind(this,this.treeGridViewRowRenderer_cellRenderer_changeHandler));
		}
		if((js_Boot().default).__implements(cellRenderer,(feathers_core_IMeasureObject().default))) {
			cellRenderer.addEventListener("resize",$bind(this,this.treeGridViewRowRenderer_cellRenderer_resizeHandler));
		}
		if((js_Boot().default).__implements(cellRenderer,(feathers_core_IOpenCloseToggle().default))) {
			cellRenderer.addEventListener("open",$bind(this,this.treeGridViewRowRenderer_cellRenderer_openHandler));
			cellRenderer.addEventListener("close",$bind(this,this.treeGridViewRowRenderer_cellRenderer_closeHandler));
		}
		this._cellRendererToCellState.set(cellRenderer,state);
		this._columnToCellRenderer.set(column,cellRenderer);
		storage1.activeCellRenderers.push(cellRenderer);
		return cellRenderer;
	},
	destroyCellRenderer: function(cellRenderer,cellRendererRecycler) {
		this.removeChild(cellRenderer);
		if(cellRendererRecycler != null && cellRendererRecycler.destroy != null) {
			cellRendererRecycler.destroy(cellRenderer);
		}
	},
	updateCellRendererForColumnIndex: function(columnIndex) {
		var column = this._columns.get(columnIndex);
		var cellRenderer = this._columnToCellRenderer.get(column);
		if(cellRenderer == null) {
			this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
			return;
		}
		var storage = this.cellRendererRecyclerToStorage(column.cellRendererRecycler);
		var state = this._cellRendererToCellState.get(cellRenderer);
		if(state.owner == null) {
			return;
		}
		this.populateCurrentItemState(column,columnIndex,state,true);
		this.resetCellRenderer(cellRenderer,state,storage);
		state.owner = null;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
	},
	populateCurrentItemState: function(column,columnIndex,state,force) {
		var changed = false;
		if(force || state.owner != this._treeGridView) {
			state.owner = this._treeGridView;
			changed = true;
		}
		if(force || state.data != this._data) {
			state.data = this._data;
			changed = true;
		}
		if(force || state.rowLocation != this._rowLocation && this.compareLocations(state.rowLocation,this._rowLocation) != 0) {
			state.rowLocation = this._rowLocation;
			changed = true;
		}
		if(force || state.columnIndex != columnIndex) {
			state.columnIndex = columnIndex;
			changed = true;
		}
		if(force || state.column != column) {
			state.column = column;
			changed = true;
		}
		if(force || state.layoutIndex != this._layoutIndex) {
			state.layoutIndex = this._layoutIndex;
			changed = true;
		}
		if(force || state.branch != this._branch) {
			state.branch = this._branch;
			changed = true;
		}
		if(force || state.opened != this._opened) {
			state.opened = this._opened;
			changed = true;
		}
		if(force || state.selected != this._selected) {
			state.selected = this._selected;
			changed = true;
		}
		if(force || state.enabled != this._enabled) {
			state.enabled = this._enabled;
			changed = true;
		}
		var text = this._rowLocation != null ? column.itemToText(this._data) : null;
		if(force || state.text != text) {
			state.text = text;
			changed = true;
		}
		return changed;
	},
	updateCellRenderer: function(cellRenderer,state,storage) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		var oldIgnoreOpenedChange = this._ignoreOpenedChange;
		this._ignoreOpenedChange = true;
		if(storage.cellRendererRecycler.update != null) {
			storage.cellRendererRecycler.update(cellRenderer,state);
		}
		this._ignoreOpenedChange = oldIgnoreOpenedChange;
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		this.refreshCellRendererProperties(cellRenderer,state);
	},
	resetCellRenderer: function(cellRenderer,state,storage) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		var oldIgnoreOpenedChange = this._ignoreOpenedChange;
		this._ignoreOpenedChange = true;
		var recycler = storage.oldCellRendererRecycler != null ? storage.oldCellRendererRecycler : storage.cellRendererRecycler;
		if(recycler != null && recycler.reset != null) {
			recycler.reset(cellRenderer,state);
		}
		this._ignoreOpenedChange = oldIgnoreOpenedChange;
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		this.refreshCellRendererProperties(cellRenderer,TreeGridViewRowRenderer.RESET_CELL_STATE);
	},
	refreshCellRendererProperties: function(cellRenderer,state) {
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		var oldIgnoreOpenedChange = this._ignoreOpenedChange;
		this._ignoreOpenedChange = true;
		if((js_Boot().default).__implements(cellRenderer,(feathers_core_IUIControl().default))) {
			var uiControl = (js_Boot().default).__cast(cellRenderer , (feathers_core_IUIControl().default));
			uiControl.set_enabled(state.enabled);
		}
		if((js_Boot().default).__implements(cellRenderer,(feathers_controls_dataRenderers_IDataRenderer().default))) {
			var dataRenderer = (js_Boot().default).__cast(cellRenderer , (feathers_controls_dataRenderers_IDataRenderer().default));
			dataRenderer.set_data(state.data);
		}
		if((js_Boot().default).__implements(cellRenderer,(feathers_controls_IToggle().default))) {
			var toggle = (js_Boot().default).__cast(cellRenderer , (feathers_controls_IToggle().default));
			toggle.set_selected(state.selected);
		}
		if((js_Boot().default).__implements(cellRenderer,(feathers_controls_dataRenderers_IHierarchicalItemRenderer().default))) {
			var hierarchicalCell = (js_Boot().default).__cast(cellRenderer , (feathers_controls_dataRenderers_IHierarchicalItemRenderer().default));
			hierarchicalCell.set_branch(state.branch);
		}
		if((js_Boot().default).__implements(cellRenderer,(feathers_controls_dataRenderers_IOptionalHierarchyItemRenderer().default))) {
			var optionalCell = (js_Boot().default).__cast(cellRenderer , (feathers_controls_dataRenderers_IOptionalHierarchyItemRenderer().default));
			optionalCell.set_showHierarchy(state.columnIndex == 0);
		}
		if((js_Boot().default).__implements(cellRenderer,(feathers_controls_dataRenderers_IHierarchicalDepthItemRenderer().default))) {
			var depthCell = (js_Boot().default).__cast(cellRenderer , (feathers_controls_dataRenderers_IHierarchicalDepthItemRenderer().default));
			depthCell.set_hierarchyDepth(state.rowLocation != null ? state.rowLocation.length - 1 : 0);
		}
		if((js_Boot().default).__implements(cellRenderer,(feathers_controls_dataRenderers_ITreeGridViewCellRenderer().default))) {
			var gridCell = (js_Boot().default).__cast(cellRenderer , (feathers_controls_dataRenderers_ITreeGridViewCellRenderer().default));
			gridCell.set_column(state.column);
			gridCell.set_columnIndex(state.columnIndex);
			gridCell.set_rowLocation(state.rowLocation);
			gridCell.set_treeGridViewOwner(state.owner);
		}
		if((js_Boot().default).__implements(cellRenderer,(feathers_layout_ILayoutIndexObject().default))) {
			var layoutIndexObject = (js_Boot().default).__cast(cellRenderer , (feathers_layout_ILayoutIndexObject().default));
			layoutIndexObject.set_layoutIndex(state.layoutIndex);
		}
		if((js_Boot().default).__implements(cellRenderer,(feathers_core_IOpenCloseToggle().default))) {
			var openCloseItem = (js_Boot().default).__cast(cellRenderer , (feathers_core_IOpenCloseToggle().default));
			openCloseItem.set_opened(state.opened);
		}
		if((js_Boot().default).__implements(cellRenderer,(feathers_core_IPointerDelegate().default))) {
			var pointerDelgate = (js_Boot().default).__cast(cellRenderer , (feathers_core_IPointerDelegate().default));
			pointerDelgate.set_pointerTarget(state.rowLocation == null ? null : this);
		}
		this._ignoreOpenedChange = oldIgnoreOpenedChange;
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
	},
	compareLocations: function(location1,location2) {
		var null1 = location1 == null;
		var null2 = location2 == null;
		if(null1 && null2) {
			return 0;
		} else if(null1) {
			return 1;
		} else if(null2) {
			return -1;
		}
		var length1 = location1.length;
		var length2 = location2.length;
		var min = length1;
		if(length2 < min) {
			min = length2;
		}
		var _g = 0;
		var _g1 = min;
		while(_g < _g1) {
			var i = _g++;
			var index1 = location1[i];
			var index2 = location2[i];
			if(index1 < index2) {
				return -1;
			}
			if(index1 > index2) {
				return 1;
			}
		}
		if(length1 < length2) {
			return -1;
		} else if(length1 > length2) {
			return 1;
		}
		return 0;
	},
	treeGridViewRowRenderer_cellRenderer_touchTapHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(event.isPrimaryTouchPoint) {
			return;
		}
		(feathers_events_TriggerEvent().default).dispatchFromTouchEvent(this,event);
		var cellRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this._cellRendererToCellState.get(cellRenderer);
		(feathers_events_TreeGridViewEvent().default).dispatchForCell(this,"cellTrigger",state);
	},
	treeGridViewRowRenderer_cellRenderer_clickHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		(feathers_events_TriggerEvent().default).dispatchFromMouseEvent(this,event);
		var cellRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this._cellRendererToCellState.get(cellRenderer);
		(feathers_events_TreeGridViewEvent().default).dispatchForCell(this,"cellTrigger",state);
	},
	treeGridViewRowRenderer_cellRenderer_triggerHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		this.dispatchEvent(event.clone());
		var cellRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var state = this._cellRendererToCellState.get(cellRenderer);
		(feathers_events_TreeGridViewEvent().default).dispatchForCell(this,"cellTrigger",state);
	},
	treeGridViewRowRenderer_cellRenderer_resizeHandler: function(event) {
		if(this._validating) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	treeGridViewRowRenderer_cellRenderer_changeHandler: function(event) {
		if(this._ignoreSelectionChange) {
			return;
		}
		var cellRenderer = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		var toggleCellRenderer = (js_Boot().default).__cast(cellRenderer , (feathers_controls_IToggle().default));
		var state = this._cellRendererToCellState.get(cellRenderer);
		if(toggleCellRenderer.get_selected() == state.selected) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
	},
	treeGridViewRowRenderer_cellRenderer_openHandler: function(event) {
		if(this._ignoreOpenedChange) {
			return;
		}
		this.dispatchEvent(event.clone());
	},
	treeGridViewRowRenderer_cellRenderer_closeHandler: function(event) {
		if(this._ignoreOpenedChange) {
			return;
		}
		this.dispatchEvent(event.clone());
	},
	treeGridViewRowRenderer_treeGridView_keyDownHandler: function(event) {
		if(!this._enabled || event.isDefaultPrevented()) {
			return;
		}
		if(this._selected && event.keyCode == 37) {
			if(this._branch) {
				if(this._opened) {
					this.get_treeGridView().toggleBranch(this._data,false);
					return;
				}
			}
			var parentLocation = this._rowLocation.slice();
			parentLocation.pop();
			if(parentLocation.length > 0) {
				this.get_treeGridView().set_selectedLocation(parentLocation);
			}
		}
		if(this._selected && event.keyCode == 39) {
			if(this._branch) {
				if(!this._opened) {
					this.get_treeGridView().toggleBranch(this._data,true);
					return;
				}
				var childCount = this.get_treeGridView().get_dataProvider().getLength(this._rowLocation);
				if(childCount > 0) {
					var childLocation = this._rowLocation.slice();
					childLocation.push(0);
					this.get_treeGridView().set_selectedLocation(childLocation);
				}
			}
		}
		if(this._selected && event.keyCode == 13) {
			var column = this._columns.get(0);
			var cellRenderer = this.columnToCellRenderer(column);
			var state = null;
			if(cellRenderer != null) {
				state = this._cellRendererToCellState.get(cellRenderer);
			}
			var isTemporary = false;
			if(state == null) {
				isTemporary = true;
				state = this.cellStatePool.get();
			}
			this.populateCurrentItemState(column,0,state,true);
			(feathers_events_TreeGridViewEvent().default).dispatchForCell(this,"cellTrigger",state);
			if(isTemporary) {
				this.cellStatePool.release(state);
			}
		}
		if(this._selected && event.keyCode == 32) {
			if(this._branch) {
				event.preventDefault();
				this.get_treeGridView().toggleBranch(this._data,!this._opened);
			}
		}
	},
	treeGridViewRowRenderer_columns_changeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
	}
});
TreeGridViewRowRenderer.prototype.__class__ = TreeGridViewRowRenderer.prototype.constructor = $hxClasses["feathers.controls.dataRenderers.TreeGridViewRowRenderer"] = TreeGridViewRowRenderer;

// Init



// Statics

TreeGridViewRowRenderer.defaultUpdateCellRenderer = function(cellRenderer,state) {
	if((js_Boot().default).__implements(cellRenderer,(feathers_core_ITextControl().default))) {
		var textControl = (js_Boot().default).__cast(cellRenderer , (feathers_core_ITextControl().default));
		textControl.set_text(state.text);
	}
}
TreeGridViewRowRenderer.defaultResetCellRenderer = function(cellRenderer,state) {
	if((js_Boot().default).__implements(cellRenderer,(feathers_core_ITextControl().default))) {
		var textControl = (js_Boot().default).__cast(cellRenderer , (feathers_core_ITextControl().default));
		textControl.set_text(null);
	}
}
TreeGridViewRowRenderer.INVALIDATION_FLAG_CELL_RENDERER_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("cellRendererFactory")
TreeGridViewRowRenderer.RESET_CELL_STATE = new (feathers_data_TreeGridViewCellState().default)()

// Export

exports["default"] = TreeGridViewRowRenderer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/TreeViewItemRenderer.js":
/*!**************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/TreeViewItemRenderer.js ***!
  \**************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers.TreeViewItemRenderer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_dataRenderers_ITreeViewItemRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/ITreeViewItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ITreeViewItemRenderer.js");}
function feathers_controls_dataRenderers_HierarchicalItemRenderer() {return __webpack_require__(/*! ./../../../feathers/controls/dataRenderers/HierarchicalItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/HierarchicalItemRenderer.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}

// Constructor

var TreeViewItemRenderer = function() {
	(feathers_controls_dataRenderers_HierarchicalItemRenderer().default).call(this);
}

// Meta

TreeViewItemRenderer.__name__ = "feathers.controls.dataRenderers.TreeViewItemRenderer";
TreeViewItemRenderer.__isInterface__ = false;
TreeViewItemRenderer.__interfaces__ = [(feathers_controls_dataRenderers_ITreeViewItemRenderer().default)];
TreeViewItemRenderer.__super__ = (feathers_controls_dataRenderers_HierarchicalItemRenderer().default);
TreeViewItemRenderer.prototype = $extend((feathers_controls_dataRenderers_HierarchicalItemRenderer().default).prototype, {
	get_location: function() {
		return this._location;
	},
	set_location: function(value) {
		if(this._location == value) {
			return this._location;
		}
		this._location = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._location;
	},
	get_treeViewOwner: function() {
		return this._treeViewOwner;
	},
	set_treeViewOwner: function(value) {
		if(this._treeViewOwner == value) {
			return this._treeViewOwner;
		}
		this._treeViewOwner = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._treeViewOwner;
	}
});
TreeViewItemRenderer.prototype.__class__ = TreeViewItemRenderer.prototype.constructor = $hxClasses["feathers.controls.dataRenderers.TreeViewItemRenderer"] = TreeViewItemRenderer;

// Init



// Statics




// Export

exports["default"] = TreeViewItemRenderer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/_GridViewRowRenderer/CellRendererStorage.js":
/*!**********************************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/_GridViewRowRenderer/CellRendererStorage.js ***!
  \**********************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers._GridViewRowRenderer.CellRendererStorage

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var CellRendererStorage = function(recycler) {
	this.inactiveCellRenderers = [];
	this.activeCellRenderers = [];
	this.cellRendererRecycler = recycler;
}

// Meta

CellRendererStorage.__name__ = "feathers.controls.dataRenderers._GridViewRowRenderer.CellRendererStorage";
CellRendererStorage.__isInterface__ = false;
CellRendererStorage.prototype = {
	
};
CellRendererStorage.prototype.__class__ = CellRendererStorage.prototype.constructor = $hxClasses["feathers.controls.dataRenderers._GridViewRowRenderer.CellRendererStorage"] = CellRendererStorage;

// Init



// Statics




// Export

exports["default"] = CellRendererStorage;

/***/ }),

/***/ "./lib/_gen/feathers/controls/dataRenderers/_TreeGridViewRowRenderer/CellRendererStorage.js":
/*!**************************************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/dataRenderers/_TreeGridViewRowRenderer/CellRendererStorage.js ***!
  \**************************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.dataRenderers._TreeGridViewRowRenderer.CellRendererStorage

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var CellRendererStorage = function(recycler) {
	this.inactiveCellRenderers = [];
	this.activeCellRenderers = [];
	this.cellRendererRecycler = recycler;
}

// Meta

CellRendererStorage.__name__ = "feathers.controls.dataRenderers._TreeGridViewRowRenderer.CellRendererStorage";
CellRendererStorage.__isInterface__ = false;
CellRendererStorage.prototype = {
	
};
CellRendererStorage.prototype.__class__ = CellRendererStorage.prototype.constructor = $hxClasses["feathers.controls.dataRenderers._TreeGridViewRowRenderer.CellRendererStorage"] = CellRendererStorage;

// Init



// Statics




// Export

exports["default"] = CellRendererStorage;

/***/ }),

/***/ "./lib/_gen/feathers/controls/navigators/BaseNavigator.js":
/*!****************************************************************!*\
  !*** ./lib/_gen/feathers/controls/navigators/BaseNavigator.js ***!
  \****************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.navigators.BaseNavigator

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IFocusContainer() {return __webpack_require__(/*! ./../../../feathers/core/IFocusContainer */ "./lib/_gen/feathers/core/IFocusContainer.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_layout_AutoSizeMode() {return __webpack_require__(/*! ./../../../feathers/layout/AutoSizeMode */ "./lib/_gen/feathers/layout/AutoSizeMode.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_utils_MeasurementsUtil() {return __webpack_require__(/*! ./../../../feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function HxOverrides() {return __webpack_require__(/*! ./../../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}
function openfl_display_DisplayObjectContainer() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObjectContainer);}
function openfl_display_DisplayObject() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObject);}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_events_TransitionEvent() {return __webpack_require__(/*! ./../../../feathers/events/TransitionEvent */ "./lib/_gen/feathers/events/TransitionEvent.js");}
function openfl_display_InteractiveObject() {return (__webpack_require__(/*! openfl */ "openfl").display.InteractiveObject);}
function feathers_motion_effects_NoOpEffectContext() {return __webpack_require__(/*! ./../../../feathers/motion/effects/NoOpEffectContext */ "./lib/_gen/feathers/motion/effects/NoOpEffectContext.js");}
function haxe_ds_StringMap() {return __webpack_require__(/*! ./../../../haxe/ds/StringMap */ "./lib/_gen/haxe/ds/StringMap.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}

// Constructor

var BaseNavigator = function() {
	this.leftContentOffset = 0.0;
	this.bottomContentOffset = 0.0;
	this.rightContentOffset = 0.0;
	this.topContentOffset = 0.0;
	this._autoSizeMode = (feathers_layout_AutoSizeMode().default).STAGE;
	this._waitingForTransitionFrameCount = 0;
	this._waitingForDelayedTransition = false;
	this._clearAfterTransition = false;
	this._addedItems = new (haxe_ds_StringMap().default)();
	this._addedItemIDs = [];
	this._activeViewMeasurements = new (feathers_layout_Measurements().default)();
	this._childFocusEnabled = true;
	(feathers_core_FeathersControl().default).call(this);
	this._viewsContainer = this;
	this.addEventListener("addedToStage",$bind(this,this.baseNavigator_addedToStageHandler));
}

// Meta

BaseNavigator.__name__ = "feathers.controls.navigators.BaseNavigator";
BaseNavigator.__isInterface__ = false;
BaseNavigator.__interfaces__ = [(feathers_core_IFocusContainer().default)];
BaseNavigator.__super__ = (feathers_core_FeathersControl().default);
BaseNavigator.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_activeItemID: function() {
		return this._activeItemID;
	},
	get_activeItemView: function() {
		return this._activeItemView;
	},
	get_transitionActive: function() {
		return this._transitionActive;
	},
	get_tabEnabled: function() {
		return false;
	},
	get_childFocusEnabled: function() {
		if(this._enabled && !this._transitionActive) {
			return this._childFocusEnabled;
		} else {
			return false;
		}
	},
	set_childFocusEnabled: function(value) {
		if(this._childFocusEnabled == value) {
			return this._childFocusEnabled;
		}
		this._childFocusEnabled = value;
		return this._childFocusEnabled;
	},
	get_autoSizeMode: function() {
		return this._autoSizeMode;
	},
	set_autoSizeMode: function(value) {
		if(this._autoSizeMode == value) {
			return this._autoSizeMode;
		}
		this._autoSizeMode = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		if(this._activeItemView != null) {
			if(this._autoSizeMode == (feathers_layout_AutoSizeMode().default).STAGE) {
				this._activeItemView.removeEventListener("resize",$bind(this,this.activeItemView_resizeHandler));
			} else {
				this._activeItemView.addEventListener("resize",$bind(this,this.activeItemView_resizeHandler));
			}
		}
		if(this.stage != null) {
			if(this._autoSizeMode == (feathers_layout_AutoSizeMode().default).STAGE) {
				this.stage.addEventListener("resize",$bind(this,this.baseNavigator_stage_resizeHandler));
				this.addEventListener("removedFromStage",$bind(this,this.baseNavigator_removedFromStageHandler));
			} else {
				this.stage.removeEventListener("resize",$bind(this,this.baseNavigator_stage_resizeHandler));
				this.removeEventListener("removedFromStage",$bind(this,this.baseNavigator_removedFromStageHandler));
			}
		}
		return this._autoSizeMode;
	},
	removeAllItems: function() {
		if(this._transitionActive) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Cannot remove all items while a transition is active."));
		}
		if(this._activeItemView != null) {
			this.clearActiveItemInternal(null);
			(feathers_events_FeathersEvent().default).dispatch(this,"clear");
		}
		this._addedItems.clear();
		this._addedItemIDs.length = 0;
	},
	hasItem: function(id) {
		return this._addedItems.exists(id);
	},
	getItemIDs: function(result) {
		if(result == null) {
			result = [];
		}
		var id = this._addedItems.keys();
		while(id.hasNext()) {
			var id1 = id.next();
			result.push(id1);
		}
		return result;
	},
	update: function() {
		var sizeInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SIZE);
		this.topContentOffset = 0.0;
		this.rightContentOffset = 0.0;
		this.bottomContentOffset = 0.0;
		this.leftContentOffset = 0.0;
		sizeInvalid = this.measure() || sizeInvalid;
		this.layoutContent();
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		var needsToMeasureContent = this._autoSizeMode == (feathers_layout_AutoSizeMode().default).CONTENT || this.stage == null;
		var stageWidth = 0.0;
		var stageHeight = 0.0;
		if(!needsToMeasureContent) {
			var topLeft = this.globalToLocal(new (openfl_geom_Point())());
			var bottomRight = this.globalToLocal(new (openfl_geom_Point())(this.stage.stageWidth,this.stage.stageHeight));
			stageWidth = bottomRight.x - topLeft.x;
			stageHeight = bottomRight.y - topLeft.y;
		}
		var measureView = null;
		if((js_Boot().default).__implements(this._activeItemView,(feathers_core_IMeasureObject().default))) {
			measureView = (js_Boot().default).__cast(this._activeItemView , (feathers_core_IMeasureObject().default));
		}
		if(this._activeItemView != null) {
			if(needsToMeasureContent) {
				(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParent(this._activeViewMeasurements,this._activeItemView,this);
			}
			if(!needsWidth && this._activeItemView.get_width() != this.get_explicitWidth()) {
				this._activeItemView.set_width(this.get_explicitWidth());
			} else if(!needsToMeasureContent && this._activeItemView.get_width() != stageWidth) {
				this._activeItemView.set_width(stageWidth);
			}
			if(!needsHeight && this._activeItemView.get_height() != this.get_explicitHeight()) {
				this._activeItemView.set_height(this.get_explicitHeight());
			} else if(!needsToMeasureContent && this._activeItemView.get_height() != stageHeight) {
				this._activeItemView.set_height(stageHeight);
			}
		}
		if((js_Boot().default).__implements(this._activeItemView,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._activeItemView , (feathers_core_IValidating().default))).validateNow();
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			if(needsToMeasureContent) {
				if(this._activeItemView != null) {
					newWidth = this._activeItemView.get_width();
				} else {
					newWidth = 0.0;
				}
				newWidth += this.rightContentOffset + this.leftContentOffset;
			} else {
				newWidth = stageWidth;
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			if(needsToMeasureContent) {
				if(this._activeItemView != null) {
					newHeight = this._activeItemView.get_height();
				} else {
					newHeight = 0.0;
				}
				newHeight += this.topContentOffset + this.bottomContentOffset;
			} else {
				newHeight = stageHeight;
			}
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			if(needsToMeasureContent) {
				if(measureView != null) {
					newMinWidth = measureView.get_minWidth();
				} else if(this._activeItemView != null) {
					newMinWidth = this._activeItemView.get_width();
				} else {
					newMinWidth = 0.0;
				}
				newMinWidth += this.rightContentOffset + this.leftContentOffset;
			} else {
				newMinWidth = stageWidth;
			}
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			if(needsToMeasureContent) {
				if(measureView != null) {
					newMinHeight = measureView.get_minHeight();
				} else if(this._activeItemView != null) {
					newMinHeight = this._activeItemView.get_height();
				} else {
					newMinHeight = 0.0;
				}
				newMinHeight += this.topContentOffset + this.bottomContentOffset;
			} else {
				newMinHeight = stageHeight;
			}
		}
		var newMaxWidth = this.get_explicitMaxWidth();
		if(needsMaxWidth) {
			if(needsToMeasureContent) {
				if(measureView != null) {
					newMaxWidth = measureView.get_maxWidth();
				} else if(this._activeItemView != null) {
					newMaxWidth = this._activeItemView.get_width();
				} else {
					newMaxWidth = 1.0 / 0.0;
				}
				newMaxWidth += this.rightContentOffset + this.leftContentOffset;
			} else {
				newMaxWidth = stageWidth;
			}
		}
		var newMaxHeight = this.get_explicitMaxHeight();
		if(needsMaxHeight) {
			if(needsToMeasureContent) {
				if(measureView != null) {
					newMaxHeight = measureView.get_maxHeight();
				} else if(this._activeItemView != null) {
					newMaxHeight = this._activeItemView.get_height();
				} else {
					newMaxHeight = 1.0 / 0.0;
				}
				newMaxHeight += this.topContentOffset + this.bottomContentOffset;
			} else {
				newMaxHeight = stageHeight;
			}
		}
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight,newMaxWidth,newMaxHeight);
	},
	layoutContent: function() {
		if(this._activeItemView != null) {
			this._activeItemView.set_x(0.0);
			this._activeItemView.set_y(0.0);
			if(this._activeItemView.get_width() != this.actualWidth) {
				this._activeItemView.set_width(this.actualWidth);
			}
			if(this._activeItemView.get_height() != this.actualHeight) {
				this._activeItemView.set_height(this.actualHeight);
			}
			if((js_Boot().default).__implements(this._activeItemView,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._activeItemView , (feathers_core_IValidating().default))).validateNow();
			}
		}
		if(this._nextViewInTransition != null) {
			this._nextViewInTransition.set_x(0.0);
			this._nextViewInTransition.set_y(0.0);
			if(this._nextViewInTransition.get_width() != this.actualWidth) {
				this._nextViewInTransition.set_width(this.actualWidth);
			}
			if(this._nextViewInTransition.get_height() != this.actualHeight) {
				this._nextViewInTransition.set_height(this.actualHeight);
			}
			if((js_Boot().default).__implements(this._nextViewInTransition,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._nextViewInTransition , (feathers_core_IValidating().default))).validateNow();
			}
		}
		if(this._viewsContainer != this && (js_Boot().default).__implements(this._viewsContainer,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._viewsContainer , (feathers_core_IValidating().default))).validateNow();
		}
	},
	getView: function(id) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Missing override of BaseNavigator.getView()"));
	},
	disposeView: function(id,view) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Missing override of BaseNavigator.disposeView()"));
	},
	transitionComplete: function() {
	},
	transitionCancel: function() {
	},
	addItemInternal: function(id,item) {
		if(this._addedItems.exists(id)) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Item with id '" + id + "' already defined. Cannot add two items with the same id."));
		}
		this._addedItems.set(id,item);
		this._addedItemIDs.push(id);
	},
	removeItemInternal: function(id) {
		if(!this._addedItems.exists(id)) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Item with id '" + id + "' cannot be removed because this id has not been added."));
		}
		if(this._transitionActive && (id == this._previousViewInTransitionID || id == this._activeItemID)) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Cannot remove an item while it is transitioning in or out."));
		}
		if(id == this._activeItemID) {
			this.clearActiveItemInternal(null);
			(feathers_events_FeathersEvent().default).dispatch(this,"clear");
		}
		var item = this._addedItems.get(id);
		this._addedItems.remove(id);
		(HxOverrides().default).remove(this._addedItemIDs,id);
		return item;
	},
	clearFocusFromPreviousView: function() {
		if(this._previousViewInTransition == null) {
			return;
		}
		if(this._focusManager != null) {
			if(this._focusManager.get_focus() == null) {
				return;
			}
			if((js_Boot().default).__implements(this._previousViewInTransition,(feathers_core_IFocusObject().default)) && this._focusManager.get_focus() == (js_Boot().default).__cast(this._previousViewInTransition , (feathers_core_IFocusObject().default))) {
				this._focusManager.set_focus(null);
			} else if(((this._previousViewInTransition) instanceof (openfl_display_DisplayObjectContainer())) && ((js_Boot().default).__cast(this._previousViewInTransition , (openfl_display_DisplayObjectContainer()))).contains((js_Boot().default).__cast(this._focusManager.get_focus() , (openfl_display_DisplayObject())))) {
				this._focusManager.set_focus(null);
			}
		}
		if(this.stage.get_focus() == null) {
			return;
		}
		if(this.stage.get_focus() == this._previousViewInTransition || ((this._previousViewInTransition) instanceof (openfl_display_DisplayObjectContainer())) && ((js_Boot().default).__cast(this._previousViewInTransition , (openfl_display_DisplayObjectContainer()))).contains(this.stage.get_focus())) {
			this.stage.set_focus(this.stage);
		}
	},
	showItemInternal: function(id,transition) {
		if(!this.hasItem(id)) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Item with id '" + id + "' cannot be displayed because this id has not been added."));
		}
		if(this._transitionActive) {
			this._pendingItemID = id;
			this._pendingItemTransition = transition;
			this._clearAfterTransition = false;
			return null;
		}
		this._previousViewInTransition = this._activeItemView;
		this._previousViewInTransitionID = this._activeItemID;
		this.clearFocusFromPreviousView();
		this._transitionActive = true;
		var item = this._addedItems.get(id);
		this._nextViewInTransition = this.getView(id);
		if(this._nextViewInTransition == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Failed to display navigator item with id '" + id + "'. Call to getView() incorrectly returned null."));
		}
		this._nextViewInTransitionID = id;
		if(this._autoSizeMode == (feathers_layout_AutoSizeMode().default).CONTENT || this.stage == null) {
			this._nextViewInTransition.addEventListener("resize",$bind(this,this.activeItemView_resizeHandler));
		}
		var sameInstance = this._previousViewInTransition == this._nextViewInTransition;
		this._viewsContainer.addChild(this._nextViewInTransition);
		if((js_Boot().default).__implements(this._nextViewInTransition,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._nextViewInTransition , (feathers_core_IUIControl().default))).initializeNow();
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		if(this._validationQueue != null && this._validationQueue.get_validating()) {
			this._validationQueue.validateNow();
		} else if(!this._validating) {
			this.validateNow();
		}
		if(sameInstance) {
			this._activeItemView = this._nextViewInTransition;
			this._activeItemID = this._nextViewInTransitionID;
			this._activeViewMeasurements.save(this._activeItemView);
			this._previousViewInTransition = null;
			this._previousViewInTransitionID = null;
			this._nextViewInTransition = null;
			this._nextViewInTransitionID = null;
			this._transitionActive = false;
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
		} else {
			this.startTransition(transition);
		}
		return this._activeItemView;
	},
	clearActiveItemInternal: function(transition) {
		if(this._activeItemView == null) {
			return;
		}
		if(this._transitionActive) {
			this._pendingItemID = null;
			this._pendingItemTransition = transition;
			this._clearAfterTransition = true;
			return;
		}
		this.clearFocusFromPreviousView();
		this._transitionActive = true;
		this._previousViewInTransition = this._activeItemView;
		this._previousViewInTransitionID = this._activeItemID;
		this._nextViewInTransition = null;
		this._nextViewInTransitionID = null;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		this.startTransition(transition);
	},
	startTransition: function(transition) {
		(feathers_events_TransitionEvent().default).dispatch(this,"transitionStart",this._previousViewInTransitionID,this._previousViewInTransition,this._nextViewInTransitionID,this._nextViewInTransition);
		if(transition != null && transition != BaseNavigator.defaultTransition) {
			if(this._nextViewInTransition != null) {
				this._nextViewInTransition.set_visible(false);
			}
			this._waitingForTransitionFrameCount = 0;
			this._waitingTransition = transition;
			this.addEventListener("enterFrame",$bind(this,this.baseNavigator_transitionWait_enterFrameHandler));
		} else {
			if(this._nextViewInTransition != null) {
				this._nextViewInTransition.set_visible(true);
			}
			var transitionContext = BaseNavigator.defaultTransition(this._previousViewInTransition,this._nextViewInTransition);
			transitionContext.addEventListener("complete",$bind(this,this.transition_completeHandler));
			transitionContext.addEventListener("cancel",$bind(this,this.transition_cancelHandler));
			transitionContext.play();
		}
	},
	startWaitingTransition: function() {
		this.removeEventListener("enterFrame",$bind(this,this.baseNavigator_transitionWait_enterFrameHandler));
		if(this._nextViewInTransition != null) {
			this._nextViewInTransition.set_visible(true);
		}
		var transition = this._waitingTransition;
		this._waitingTransition = null;
		var transitionContext = transition(this._previousViewInTransition,this._nextViewInTransition);
		transitionContext.addEventListener("complete",$bind(this,this.transition_completeHandler));
		transitionContext.addEventListener("cancel",$bind(this,this.transition_cancelHandler));
		transitionContext.play();
	},
	baseNavigator_addedToStageHandler: function(event) {
		if(this._autoSizeMode == (feathers_layout_AutoSizeMode().default).STAGE) {
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
			this.stage.addEventListener("resize",$bind(this,this.baseNavigator_stage_resizeHandler));
			this.addEventListener("removedFromStage",$bind(this,this.baseNavigator_removedFromStageHandler));
		}
	},
	baseNavigator_removedFromStageHandler: function(event) {
		this.removeEventListener("removedFromStage",$bind(this,this.baseNavigator_removedFromStageHandler));
		this.stage.removeEventListener("resize",$bind(this,this.baseNavigator_stage_resizeHandler));
	},
	baseNavigator_transitionWait_enterFrameHandler: function(event) {
		if(this._waitingForTransitionFrameCount < 2) {
			this._waitingForTransitionFrameCount++;
			return;
		}
		this.startWaitingTransition();
	},
	baseNavigator_stage_resizeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
	},
	activeItemView_resizeHandler: function(event) {
		if(this._validating || this._autoSizeMode != (feathers_layout_AutoSizeMode().default).CONTENT) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
	},
	transition_completeHandler: function(event) {
		this._transitionActive = this._clearAfterTransition || this._pendingItemID != null;
		this.transitionComplete();
		var nextView = this._nextViewInTransition;
		var nextItemID = this._nextViewInTransitionID;
		var previousView = this._previousViewInTransition;
		var previousItemID = this._previousViewInTransitionID;
		this._previousViewInTransition = null;
		this._previousViewInTransitionID = null;
		this._nextViewInTransition = null;
		this._nextViewInTransitionID = null;
		if(previousView != null) {
			previousView.removeEventListener("resize",$bind(this,this.activeItemView_resizeHandler));
			this._viewsContainer.removeChild(previousView);
			this.disposeView(previousItemID,previousView);
		}
		this._activeItemView = nextView;
		this._activeItemID = nextItemID;
		this._activeViewMeasurements.save(nextView);
		(feathers_events_TransitionEvent().default).dispatch(this,"transitionComplete",previousItemID,previousView,nextItemID,nextView);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		if(this.stage != null && (this.stage.get_focus() == null || this.stage.get_focus().stage == null)) {
			if(((nextView) instanceof (openfl_display_InteractiveObject()))) {
				this.stage.set_focus((js_Boot().default).__cast(nextView , (openfl_display_InteractiveObject())));
			}
		}
		this._transitionActive = false;
		var pendingTransition = this._pendingItemTransition;
		this._pendingItemTransition = null;
		if(this._clearAfterTransition) {
			this._clearAfterTransition = false;
			this.clearActiveItemInternal(pendingTransition);
		} else if(this._pendingItemID != null) {
			var pendingItemID = this._pendingItemID;
			this._pendingItemID = null;
			this.showItemInternal(pendingItemID,pendingTransition);
		}
	},
	transition_cancelHandler: function(event) {
		this._transitionActive = this._clearAfterTransition || this._pendingItemID != null;
		var nextView = this._nextViewInTransition;
		var nextItemID = this._nextViewInTransitionID;
		var previousView = this._previousViewInTransition;
		var previousItemID = this._previousViewInTransitionID;
		this._previousViewInTransition = null;
		this._previousViewInTransitionID = null;
		this._nextViewInTransition = null;
		this._nextViewInTransitionID = null;
		if(nextView != null) {
			this._viewsContainer.removeChild(nextView);
			this._activeViewMeasurements.restore(nextView);
			this.disposeView(nextItemID,nextView);
		}
		this._activeItemView = previousView;
		this._activeItemID = previousItemID;
		this._activeViewMeasurements.save(previousView);
		this.transitionCancel();
		(feathers_events_TransitionEvent().default).dispatch(this,"transitionCancel",previousItemID,previousView,nextItemID,nextView);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		if(this.stage != null && (this.stage.get_focus() == null || this.stage.get_focus().stage == null)) {
			if(((this._activeItemView) instanceof (openfl_display_InteractiveObject()))) {
				this.stage.set_focus((js_Boot().default).__cast(this._activeItemView , (openfl_display_InteractiveObject())));
			}
		}
		this._transitionActive = false;
		var pendingTransition = this._pendingItemTransition;
		this._pendingItemTransition = null;
		if(this._clearAfterTransition) {
			this._clearAfterTransition = false;
			this.clearActiveItemInternal(pendingTransition);
		} else if(this._pendingItemID != null) {
			var pendingItemID = this._pendingItemID;
			this._pendingItemID = null;
			this.showItemInternal(pendingItemID,pendingTransition);
		}
	}
});
BaseNavigator.prototype.__class__ = BaseNavigator.prototype.constructor = $hxClasses["feathers.controls.navigators.BaseNavigator"] = BaseNavigator;

// Init



// Statics

BaseNavigator.defaultTransition = function(oldView,newView) {
	return new (feathers_motion_effects_NoOpEffectContext())(oldView);
}


// Export

exports["default"] = BaseNavigator;

/***/ }),

/***/ "./lib/_gen/feathers/controls/navigators/PageItem.js":
/*!***********************************************************!*\
  !*** ./lib/_gen/feathers/controls/navigators/PageItem.js ***!
  \***********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.navigators.PageItem

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Type() {return __webpack_require__(/*! ./../../../Type */ "./lib/_gen/Type.js");}
function Std() {return __webpack_require__(/*! ./../../../Std */ "./lib/_gen/Std.js");}

// Constructor

var PageItem = function() {
	this.internalID = (Std().default).string(PageItem.internalIDCounter);
	PageItem.internalIDCounter++;
}

// Meta

PageItem.__name__ = "feathers.controls.navigators.PageItem";
PageItem.__isInterface__ = false;
PageItem.prototype = {
	getView: function(navigator) {
		var view = this.viewInstance;
		if(view == null && this.viewClass != null) {
			view = (Type().default).createInstance(this.viewClass,[]);
		}
		if(view == null && this.viewFunction != null) {
			view = this.viewFunction();
		}
		return view;
	},
	returnView: function(view) {
	}
};
PageItem.prototype.__class__ = PageItem.prototype.constructor = $hxClasses["feathers.controls.navigators.PageItem"] = PageItem;

// Init



// Statics

PageItem.withClass = function(viewClass) {
	var item = new PageItem();
	item.viewClass = viewClass;
	return item;
}
PageItem.withFunction = function(viewFunction) {
	var item = new PageItem();
	item.viewFunction = viewFunction;
	return item;
}
PageItem.withDisplayObject = function(viewInstance) {
	var item = new PageItem();
	item.viewInstance = viewInstance;
	return item;
}
PageItem.internalIDCounter = 0

// Export

exports["default"] = PageItem;

/***/ }),

/***/ "./lib/_gen/feathers/controls/navigators/PageNavigator.js":
/*!****************************************************************!*\
  !*** ./lib/_gen/feathers/controls/navigators/PageNavigator.js ***!
  \****************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.navigators.PageNavigator

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IDataSelector() {return __webpack_require__(/*! ./../../../feathers/core/IDataSelector */ "./lib/_gen/feathers/core/IDataSelector.js");}
function feathers_core_IIndexSelector() {return __webpack_require__(/*! ./../../../feathers/core/IIndexSelector */ "./lib/_gen/feathers/core/IIndexSelector.js");}
function feathers_controls_navigators_BaseNavigator() {return __webpack_require__(/*! ./../../../feathers/controls/navigators/BaseNavigator */ "./lib/_gen/feathers/controls/navigators/BaseNavigator.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_utils_EdgePuller() {return __webpack_require__(/*! ./../../../feathers/utils/EdgePuller */ "./lib/_gen/feathers/utils/EdgePuller.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}
function feathers_themes_steel_components_SteelPageNavigatorStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelPageNavigatorStyles */ "./lib/_gen/feathers/themes/steel/components/SteelPageNavigatorStyles.js");}
function feathers_layout_AutoSizeMode() {return __webpack_require__(/*! ./../../../feathers/layout/AutoSizeMode */ "./lib/_gen/feathers/layout/AutoSizeMode.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function Std() {return __webpack_require__(/*! ./../../../Std */ "./lib/_gen/Std.js");}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_controls_navigators_PageItem() {return __webpack_require__(/*! ./../../../feathers/controls/navigators/PageItem */ "./lib/_gen/feathers/controls/navigators/PageItem.js");}
function feathers_motion_effects_EventToPositionEffectContext() {return __webpack_require__(/*! ./../../../feathers/motion/effects/EventToPositionEffectContext */ "./lib/_gen/feathers/motion/effects/EventToPositionEffectContext.js");}
function feathers_utils_ExclusivePointer() {return __webpack_require__(/*! ./../../../feathers/utils/ExclusivePointer */ "./lib/_gen/feathers/utils/ExclusivePointer.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function feathers_utils_DisplayObjectFactory() {return __webpack_require__(/*! ./../../../feathers/utils/DisplayObjectFactory */ "./lib/_gen/feathers/utils/DisplayObjectFactory.js");}
function feathers_controls_PageIndicator() {return __webpack_require__(/*! ./../../../feathers/controls/PageIndicator */ "./lib/_gen/feathers/controls/PageIndicator.js");}
function feathers_controls_LayoutGroup() {return __webpack_require__(/*! ./../../../feathers/controls/LayoutGroup */ "./lib/_gen/feathers/controls/LayoutGroup.js");}

// Constructor

var PageNavigator = function(dataProvider) {
	this.__customPageIndicatorVariant = null;
	this.__gap = 0.0;
	this.__nextTransition = null;
	this.__previousTransition = null;
	this.__pageIndicatorPosition = (feathers_layout_RelativePosition().default).BOTTOM;
	this._ignoreSelectionChange = false;
	this._previousCustomPageIndicatorVariant = null;
	this._simulateTouch = false;
	this._swipeEnabled = true;
	this._selectedItem = null;
	this._selectedIndex = -1;
	this._activeItemIndex = -1;
	this.initializePageNavigatorTheme();
	this.set_dataProvider(dataProvider);
	(feathers_controls_navigators_BaseNavigator().default).call(this);
	this._viewsContainer = new (feathers_controls_LayoutGroup().default)();
	this.addChild(this._viewsContainer);
}

// Meta

PageNavigator.__name__ = "feathers.controls.navigators.PageNavigator";
PageNavigator.__isInterface__ = false;
PageNavigator.__interfaces__ = [(feathers_core_IDataSelector().default),(feathers_core_IIndexSelector().default)];
PageNavigator.__super__ = (feathers_controls_navigators_BaseNavigator().default);
PageNavigator.prototype = $extend((feathers_controls_navigators_BaseNavigator().default).prototype, {
	get_dataProvider: function() {
		return this._dataProvider;
	},
	set_dataProvider: function(value) {
		if(this._dataProvider == value) {
			return this._dataProvider;
		}
		if(this._dataProvider != null) {
			this._dataProvider.removeEventListener("addItem",$bind(this,this.pageNavigator_dataProvider_addItemHandler));
			this._dataProvider.removeEventListener("removeItem",$bind(this,this.pageNavigator_dataProvider_removeItemHandler));
			this._dataProvider.removeEventListener("replaceItem",$bind(this,this.pageNavigator_dataProvider_replaceItemHandler));
			this._dataProvider.removeEventListener("removeAll",$bind(this,this.pageNavigator_dataProvider_removeAllHandler));
			this._dataProvider.removeEventListener("reset",$bind(this,this.pageNavigator_dataProvider_resetHandler));
			var item = this._dataProvider.iterator();
			while(item.hasNext()) {
				var item1 = item.next();
				this.removeItemInternal(item1.internalID);
			}
		}
		this._dataProvider = value;
		if(this._dataProvider != null) {
			var item2 = this._dataProvider.iterator();
			while(item2.hasNext()) {
				var item3 = item2.next();
				this.addItemInternal(item3.internalID,item3);
			}
			this._dataProvider.addEventListener("addItem",$bind(this,this.pageNavigator_dataProvider_addItemHandler),false,0,true);
			this._dataProvider.addEventListener("removeItem",$bind(this,this.pageNavigator_dataProvider_removeItemHandler),false,0,true);
			this._dataProvider.addEventListener("replaceItem",$bind(this,this.pageNavigator_dataProvider_replaceItemHandler),false,0,true);
			this._dataProvider.addEventListener("removeAll",$bind(this,this.pageNavigator_dataProvider_removeAllHandler),false,0,true);
			this._dataProvider.addEventListener("reset",$bind(this,this.pageNavigator_dataProvider_resetHandler),false,0,true);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		if(this._dataProvider == null || this._dataProvider.get_length() == 0) {
			this.set_selectedIndex(-1);
		} else {
			this.set_selectedIndex(0);
		}
		return this._dataProvider;
	},
	get_selectedIndex: function() {
		return this._selectedIndex;
	},
	set_selectedIndex: function(value) {
		if(this._dataProvider == null) {
			value = -1;
		}
		if(this._selectedIndex == value) {
			return this._selectedIndex;
		}
		this._selectedIndex = value;
		if(this._selectedIndex == -1) {
			this._selectedItem = null;
		} else {
			this._selectedItem = this._dataProvider.get(this._selectedIndex);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		return this._selectedIndex;
	},
	get_maxSelectedIndex: function() {
		if(this._dataProvider == null) {
			return -1;
		}
		return this._dataProvider.get_length() - 1;
	},
	get_selectedItem: function() {
		return this._selectedItem;
	},
	set_selectedItem: function(value) {
		if(this._dataProvider == null) {
			this.set_selectedIndex(-1);
			return this._selectedItem;
		}
		this.set_selectedIndex(this._dataProvider.indexOf(value));
		return this._selectedItem;
	},
	get_swipeEnabled: function() {
		return this._swipeEnabled;
	},
	set_swipeEnabled: function(value) {
		if(this._swipeEnabled == value) {
			return this._swipeEnabled;
		}
		this._swipeEnabled = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._swipeEnabled;
	},
	get_simulateTouch: function() {
		return this._simulateTouch;
	},
	set_simulateTouch: function(value) {
		if(this._simulateTouch == value) {
			return this._simulateTouch;
		}
		this._simulateTouch = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._simulateTouch;
	},
	get_pageIndicatorFactory: function() {
		return this._pageIndicatorFactory;
	},
	set_pageIndicatorFactory: function(value) {
		if(this._pageIndicatorFactory == value) {
			return this._pageIndicatorFactory;
		}
		this._pageIndicatorFactory = value;
		this.setInvalid(PageNavigator.INVALIDATION_FLAG_PAGE_INDICATOR_FACTORY);
		return this._pageIndicatorFactory;
	},
	initialize: function() {
		(feathers_controls_navigators_BaseNavigator().default).prototype.initialize.call(this);
		if(this._previousEdgePuller == null) {
			this._previousEdgePuller = new (feathers_utils_EdgePuller().default)(this,(feathers_layout_RelativePosition().default).LEFT);
			this._previousEdgePuller.addEventListener("opening",$bind(this,this.pageNavigator_previousEdgePuller_openingHandler));
			this._previousEdgePuller.addEventListener("cancel",$bind(this,this.pageNavigator_previousEdgePuller_cancelHandler));
			this._previousEdgePuller.addEventListener("open",$bind(this,this.pageNavigator_previousEdgePuller_openHandler));
		}
		if(this._nextEdgePuller == null) {
			this._nextEdgePuller = new (feathers_utils_EdgePuller().default)(this,(feathers_layout_RelativePosition().default).RIGHT);
			this._nextEdgePuller.addEventListener("opening",$bind(this,this.pageNavigator_nextEdgePuller_openingHandler));
			this._nextEdgePuller.addEventListener("cancel",$bind(this,this.pageNavigator_nextEdgePuller_cancelHandler));
			this._nextEdgePuller.addEventListener("open",$bind(this,this.pageNavigator_nextEdgePuller_openHandler));
		}
	},
	initializePageNavigatorTheme: function() {
		(feathers_themes_steel_components_SteelPageNavigatorStyles().default).initialize();
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var selectionInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		if(this._previousCustomPageIndicatorVariant != this.get_customPageIndicatorVariant()) {
			this.setInvalidationFlag(PageNavigator.INVALIDATION_FLAG_PAGE_INDICATOR_FACTORY);
		}
		var pageIndicatorInvalid = this.isInvalid(PageNavigator.INVALIDATION_FLAG_PAGE_INDICATOR_FACTORY);
		if(pageIndicatorInvalid) {
			this.createPageIndicator();
		}
		if(dataInvalid) {
			this._previousEdgePuller.simulateTouch = this._simulateTouch;
			this._nextEdgePuller.simulateTouch = this._simulateTouch;
		}
		if(dataInvalid || selectionInvalid || pageIndicatorInvalid) {
			this.refreshSelection();
		}
		(feathers_controls_navigators_BaseNavigator().default).prototype.update.call(this);
		this._previousCustomPageIndicatorVariant = this.get_customPageIndicatorVariant();
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		var needsToMeasureContent = this._autoSizeMode == (feathers_layout_AutoSizeMode().default).CONTENT || this.stage == null;
		if(needsToMeasureContent) {
			if(this.get_explicitWidth() != null) {
				this.pageIndicator.set_width(this.get_explicitWidth());
			} else {
				this.pageIndicator.resetWidth();
			}
			this.pageIndicator.validateNow();
			switch(this.get_pageIndicatorPosition()._hx_index) {
			case 0:
				this.topContentOffset = this.pageIndicator.get_height() + this.get_gap();
				break;
			case 2:
				this.bottomContentOffset = this.pageIndicator.get_height() + this.get_gap();
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Invalid pageIndicatorPosition " + (Std().default).string(this.get_pageIndicatorPosition())));
			}
		}
		return (feathers_controls_navigators_BaseNavigator().default).prototype.measure.call(this);
	},
	createPageIndicator: function() {
		if(this.pageIndicator != null) {
			this.pageIndicator.removeEventListener("change",$bind(this,this.pageNavigator_pageIndicator_changeHandler));
			this.removeChild(this.pageIndicator);
			if(this._oldPageIndicatorFactory.destroy != null) {
				this._oldPageIndicatorFactory.destroy(this.pageIndicator);
			}
			this._oldPageIndicatorFactory = null;
			this.pageIndicator = null;
		}
		var factory = this._pageIndicatorFactory != null ? this._pageIndicatorFactory : PageNavigator.defaultPageIndicatorFactory;
		this._oldPageIndicatorFactory = factory;
		this.pageIndicator = factory.create();
		if(this.pageIndicator.get_variant() == null) {
			this.pageIndicator.set_variant(this.get_customPageIndicatorVariant() != null ? this.get_customPageIndicatorVariant() : PageNavigator.CHILD_VARIANT_PAGE_INDICATOR);
		}
		this.pageIndicator.addEventListener("change",$bind(this,this.pageNavigator_pageIndicator_changeHandler));
		this.addChild(this.pageIndicator);
	},
	layoutContent: function() {
		this.pageIndicator.set_x(0.0);
		this.pageIndicator.set_width(this.actualWidth);
		this.pageIndicator.validateNow();
		switch(this.get_pageIndicatorPosition()._hx_index) {
		case 0:
			this.pageIndicator.set_y(0.0);
			break;
		case 2:
			this.pageIndicator.set_y(this.actualHeight - this.pageIndicator.get_height());
			break;
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Invalid pageIndicatorPosition " + (Std().default).string(this.get_pageIndicatorPosition())));
		}
		this._viewsContainer.set_x(0.0);
		switch(this.get_pageIndicatorPosition()._hx_index) {
		case 0:
			this._viewsContainer.set_y(this.pageIndicator.get_height() + this.get_gap());
			break;
		case 2:
			this._viewsContainer.set_y(0.0);
			break;
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Invalid pageIndicatorPosition " + (Std().default).string(this.get_pageIndicatorPosition())));
		}
		this._viewsContainer.set_width(this.actualWidth);
		this._viewsContainer.set_height(this.actualHeight - this.pageIndicator.get_height() - this.get_gap());
		if(this._activeItemView != null) {
			this._activeItemView.set_x(0.0);
			this._activeItemView.set_y(0.0);
			this._activeItemView.set_width(this._viewsContainer.get_width());
			this._activeItemView.set_height(this._viewsContainer.get_height());
		}
		if(this._nextViewInTransition != null) {
			this._nextViewInTransition.set_x(0.0);
			this._nextViewInTransition.set_y(0.0);
			this._nextViewInTransition.set_width(this._viewsContainer.get_width());
			this._nextViewInTransition.set_height(this._viewsContainer.get_height());
		}
	},
	getView: function(id) {
		var item = (js_Boot().default).__cast(this._addedItems.get(id) , (feathers_controls_navigators_PageItem().default));
		return item.getView(this);
	},
	disposeView: function(id,view) {
		var item = (js_Boot().default).__cast(this._addedItems.get(id) , (feathers_controls_navigators_PageItem().default));
		item.returnView(view);
	},
	refreshSelection: function() {
		var _gthis = this;
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		this.pageIndicator.set_maxSelectedIndex(this.get_maxSelectedIndex());
		this.pageIndicator.set_selectedIndex(this._selectedIndex);
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		if(this._selectedItem == null) {
			this._activeItemIndex = -1;
			if(this.get_activeItemID() != null) {
				this.clearActiveItemInternal();
			}
		} else if(this._selectedItem != null) {
			var oldIndex = this._activeItemIndex;
			this._activeItemIndex = this._selectedIndex;
			if(!this._previousEdgePuller.get_active() && !this._nextEdgePuller.get_active()) {
				var activeID = this._transitionActive ? this._nextViewInTransitionID : this._activeItemID;
				if(activeID != this._selectedItem.internalID) {
					var transition = null;
					if(oldIndex != -1 && oldIndex != this._selectedIndex) {
						transition = oldIndex < this._selectedIndex ? this.get_nextTransition() : this.get_previousTransition();
					}
					this.runWithInvalidationFlagsOnly(function() {
						return _gthis.showItemInternal(_gthis._selectedItem.internalID,transition);
					});
				}
			}
		}
		var tmp = this._enabled && this._swipeEnabled && this._selectedIndex > 0 && !this._nextEdgePuller.get_active();
		this._previousEdgePuller.enabled = tmp;
		var tmp1 = this._enabled && this._swipeEnabled && this._selectedIndex < this.get_maxSelectedIndex() && !this._previousEdgePuller.get_active();
		this._nextEdgePuller.enabled = tmp1;
	},
	startPreviousDragTransition: function(one,two) {
		var _gthis = this;
		var effectContext = (this.get_previousTransition())(one,two);
		this._previousEdgePuller.set_snapDuration(effectContext.get_duration());
		this._dragTransitionContext = new (feathers_motion_effects_EventToPositionEffectContext())(effectContext,this._previousEdgePuller,"change",function(event) {
			return _gthis._dragTransitionContext.set_position(_gthis._previousEdgePuller.get_pullDistance() / _gthis.actualWidth);
		});
		return this._dragTransitionContext;
	},
	startNextDragTransition: function(one,two) {
		var _gthis = this;
		var effectContext = (this.get_nextTransition())(one,two);
		this._nextEdgePuller.set_snapDuration(effectContext.get_duration());
		this._dragTransitionContext = new (feathers_motion_effects_EventToPositionEffectContext())(effectContext,this._nextEdgePuller,"change",function(event) {
			return _gthis._dragTransitionContext.set_position(_gthis._nextEdgePuller.get_pullDistance() / _gthis.actualWidth);
		});
		return this._dragTransitionContext;
	},
	pageNavigator_pageIndicator_changeHandler: function(event) {
		if(this._ignoreSelectionChange) {
			return;
		}
		this.set_selectedIndex(this.pageIndicator.get_selectedIndex());
	},
	pageNavigator_dataProvider_addItemHandler: function(event) {
		var item = (js_Boot().default).__cast(event.addedItem , (feathers_controls_navigators_PageItem().default));
		this.addItemInternal(item.internalID,item);
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		if(this._selectedIndex >= event.index) {
			var _g = this;
			_g.set_selectedIndex(_g.get_selectedIndex() + 1);
		} else if(this._selectedIndex == -1) {
			this.set_selectedIndex(0);
		}
	},
	pageNavigator_dataProvider_removeItemHandler: function(event) {
		var item = (js_Boot().default).__cast(event.removedItem , (feathers_controls_navigators_PageItem().default));
		this.removeItemInternal(item.internalID);
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		if(this._dataProvider.get_length() == 0) {
			this.set_selectedIndex(-1);
		} else if(this._selectedIndex >= event.index) {
			var _g = this;
			_g.set_selectedIndex(_g.get_selectedIndex() - 1);
		}
	},
	pageNavigator_dataProvider_replaceItemHandler: function(event) {
		var addedItem = (js_Boot().default).__cast(event.addedItem , (feathers_controls_navigators_PageItem().default));
		var removedItem = (js_Boot().default).__cast(event.removedItem , (feathers_controls_navigators_PageItem().default));
		this.removeItemInternal(removedItem.internalID);
		this.addItemInternal(addedItem.internalID,addedItem);
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		if(this._selectedIndex == event.index) {
			this.set_selectedItem(this._dataProvider.get(this._selectedIndex));
		}
	},
	pageNavigator_dataProvider_removeAllHandler: function(event) {
		this.set_selectedIndex(-1);
		var id = this._addedItems.keys();
		while(id.hasNext()) {
			var id1 = id.next();
			var item = this._addedItems.get(id1);
			this.removeItemInternal(item.internalID);
		}
	},
	pageNavigator_dataProvider_resetHandler: function(event) {
		this.set_selectedIndex(-1);
		var id = this._addedItems.keys();
		while(id.hasNext()) {
			var id1 = id.next();
			var item = this._addedItems.get(id1);
			this.removeItemInternal(item.internalID);
		}
	},
	pageNavigator_previousEdgePuller_openingHandler: function(event) {
		var newIndex = this._selectedIndex - 1;
		if(newIndex < 0) {
			event.preventDefault();
			return;
		}
		var touchPointID = this._previousEdgePuller.get_touchPointID();
		if(touchPointID != null) {
			var exclusivePointer = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
			if(this._previousEdgePuller.get_touchPointIsSimulated()) {
				var result = exclusivePointer.claimMouse(this);
				if(!result) {
					event.preventDefault();
					return;
				}
			} else {
				var result1 = exclusivePointer.claimTouch(touchPointID,this);
				if(!result1) {
					event.preventDefault();
					return;
				}
			}
		}
		if(this.get_previousTransition() != null) {
			this._nextEdgePuller.enabled = false;
			var item = this._dataProvider.get(newIndex);
			this.showItemInternal(item.internalID,$bind(this,this.startPreviousDragTransition));
		} else {
			event.preventDefault();
			this.set_selectedIndex(newIndex);
		}
	},
	pageNavigator_previousEdgePuller_cancelHandler: function(event) {
		this._previousEdgePuller.enabled = this._enabled && this._swipeEnabled && this._selectedIndex > 0;
		var tmp = this._enabled && this._swipeEnabled && this._selectedIndex < this.get_maxSelectedIndex();
		this._nextEdgePuller.enabled = tmp;
		var context = this._dragTransitionContext;
		this._dragTransitionContext = null;
		if(context != null) {
			context.set_dispatcher(null);
			(feathers_events_FeathersEvent().default).dispatch(context,"cancel");
		}
	},
	pageNavigator_previousEdgePuller_openHandler: function(event) {
		var oldSnapDuration = this._previousEdgePuller.get_snapDuration();
		this._previousEdgePuller.set_snapDuration(0.0);
		this._previousEdgePuller.set_opened(false);
		this._previousEdgePuller.set_snapDuration(oldSnapDuration);
		var _g = this;
		_g.set_selectedIndex(_g.get_selectedIndex() - 1);
		this._previousEdgePuller.enabled = this._enabled && this._swipeEnabled && this._selectedIndex > 0;
		var tmp = this._enabled && this._swipeEnabled && this._selectedIndex < this.get_maxSelectedIndex();
		this._nextEdgePuller.enabled = tmp;
		var context = this._dragTransitionContext;
		this._dragTransitionContext = null;
		if(context != null) {
			context.set_dispatcher(null);
			(feathers_events_FeathersEvent().default).dispatch(context,"complete");
		}
	},
	pageNavigator_nextEdgePuller_openingHandler: function(event) {
		var newIndex = this._selectedIndex + 1;
		if(newIndex > this.get_maxSelectedIndex()) {
			event.preventDefault();
			return;
		}
		var touchPointID = this._nextEdgePuller.get_touchPointID();
		if(touchPointID != null) {
			var exclusivePointer = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
			if(this._nextEdgePuller.get_touchPointIsSimulated()) {
				var result = exclusivePointer.claimMouse(this);
				if(!result) {
					event.preventDefault();
					return;
				}
			} else {
				var result1 = exclusivePointer.claimTouch(touchPointID,this);
				if(!result1) {
					event.preventDefault();
					return;
				}
			}
		}
		if(this.get_nextTransition() != null) {
			this._previousEdgePuller.enabled = false;
			var item = this._dataProvider.get(newIndex);
			this.showItemInternal(item.internalID,$bind(this,this.startNextDragTransition));
		} else {
			event.preventDefault();
			this.set_selectedIndex(newIndex);
		}
	},
	pageNavigator_nextEdgePuller_cancelHandler: function(event) {
		this._previousEdgePuller.enabled = this._enabled && this._swipeEnabled && this._selectedIndex > 0;
		var tmp = this._enabled && this._swipeEnabled && this._selectedIndex < this.get_maxSelectedIndex();
		this._nextEdgePuller.enabled = tmp;
		var context = this._dragTransitionContext;
		this._dragTransitionContext = null;
		if(context != null) {
			context.set_dispatcher(null);
			(feathers_events_FeathersEvent().default).dispatch(context,"cancel");
		}
	},
	pageNavigator_nextEdgePuller_openHandler: function(event) {
		var oldSnapDuration = this._nextEdgePuller.get_snapDuration();
		this._nextEdgePuller.set_snapDuration(0.0);
		this._nextEdgePuller.set_opened(false);
		this._nextEdgePuller.set_snapDuration(oldSnapDuration);
		var _g = this;
		_g.set_selectedIndex(_g.get_selectedIndex() + 1);
		this._previousEdgePuller.enabled = this._enabled && this._swipeEnabled && this._selectedIndex > 0;
		var tmp = this._enabled && this._swipeEnabled && this._selectedIndex < this.get_maxSelectedIndex();
		this._nextEdgePuller.enabled = tmp;
		var context = this._dragTransitionContext;
		this._dragTransitionContext = null;
		if(context != null) {
			context.set_dispatcher(null);
			(feathers_events_FeathersEvent().default).dispatch(context,"complete");
		}
	},
	get_styleContext: function() {
		return PageNavigator
	},
	get_pageIndicatorPosition: function() {
		return this.__pageIndicatorPosition;
	},
	set_pageIndicatorPosition: function(value) {
		if(!this.setStyle("pageIndicatorPosition")) {
			return this.__pageIndicatorPosition;
		}
		if(this.__pageIndicatorPosition == value) {
			return this.__pageIndicatorPosition;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_pageIndicatorPosition);
		this.__pageIndicatorPosition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__pageIndicatorPosition;
	},
	clearStyle_pageIndicatorPosition: function() {
		this.set_pageIndicatorPosition((feathers_layout_RelativePosition().default).BOTTOM);
		return this.get_pageIndicatorPosition();
	},
	get_previousTransition: function() {
		return this.__previousTransition;
	},
	set_previousTransition: function(value) {
		if(!this.setStyle("previousTransition")) {
			return this.__previousTransition;
		}
		if(this.__previousTransition == value) {
			return this.__previousTransition;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_previousTransition);
		this.__previousTransition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__previousTransition;
	},
	clearStyle_previousTransition: function() {
		this.set_previousTransition(null);
		return this.get_previousTransition();
	},
	get_nextTransition: function() {
		return this.__nextTransition;
	},
	set_nextTransition: function(value) {
		if(!this.setStyle("nextTransition")) {
			return this.__nextTransition;
		}
		if(this.__nextTransition == value) {
			return this.__nextTransition;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_nextTransition);
		this.__nextTransition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__nextTransition;
	},
	clearStyle_nextTransition: function() {
		this.set_nextTransition(null);
		return this.get_nextTransition();
	},
	get_gap: function() {
		return this.__gap;
	},
	set_gap: function(value) {
		if(!this.setStyle("gap")) {
			return this.__gap;
		}
		if(this.__gap == value) {
			return this.__gap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_gap);
		this.__gap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__gap;
	},
	clearStyle_gap: function() {
		this.set_gap(0.0);
		return this.get_gap();
	},
	get_customPageIndicatorVariant: function() {
		return this.__customPageIndicatorVariant;
	},
	set_customPageIndicatorVariant: function(value) {
		if(!this.setStyle("customPageIndicatorVariant")) {
			return this.__customPageIndicatorVariant;
		}
		if(this.__customPageIndicatorVariant == value) {
			return this.__customPageIndicatorVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customPageIndicatorVariant);
		this.__customPageIndicatorVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customPageIndicatorVariant;
	},
	clearStyle_customPageIndicatorVariant: function() {
		this.set_customPageIndicatorVariant(null);
		return this.get_customPageIndicatorVariant();
	}
});
PageNavigator.prototype.__class__ = PageNavigator.prototype.constructor = $hxClasses["feathers.controls.navigators.PageNavigator"] = PageNavigator;

// Init



// Statics


PageNavigator.__meta__ = { obj : { defaultXmlProperty : ["dataProvider"]}}
PageNavigator.INVALIDATION_FLAG_PAGE_INDICATOR_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("pageIndicatorFactory")
PageNavigator.CHILD_VARIANT_PAGE_INDICATOR = "pageNavigator_pageIndicator"
PageNavigator.defaultPageIndicatorFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_PageIndicator().default))

// Export

exports["default"] = PageNavigator;

/***/ }),

/***/ "./lib/_gen/feathers/controls/navigators/Route.js":
/*!********************************************************!*\
  !*** ./lib/_gen/feathers/controls/navigators/Route.js ***!
  \********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.navigators.Route

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function haxe_ds_StringMap() {return __webpack_require__(/*! ./../../../haxe/ds/StringMap */ "./lib/_gen/haxe/ds/StringMap.js");}
function Type() {return __webpack_require__(/*! ./../../../Type */ "./lib/_gen/Type.js");}
function feathers_controls_navigators__$Route_ViewListener() {return __webpack_require__(/*! ./../../../feathers/controls/navigators/_Route/ViewListener */ "./lib/_gen/feathers/controls/navigators/_Route/ViewListener.js");}
function haxe_ds_ObjectMap() {return __webpack_require__(/*! ./../../../haxe/ds/ObjectMap */ "./lib/_gen/haxe/ds/ObjectMap.js");}

// Constructor

var Route = function() {
	this._viewToEvents = new (haxe_ds_ObjectMap().default)();
}

// Meta

Route.__name__ = "feathers.controls.navigators.Route";
Route.__isInterface__ = false;
Route.prototype = {
	updateState: function(view,routeState) {
	},
	saveData: function(view) {
		return null;
	},
	setAction: function(eventType,action) {
		if(this.actions == null) {
			this.actions = new (haxe_ds_StringMap().default)();
		}
		if(action == null) {
			this.actions.remove(eventType);
		} else {
			this.actions.set(eventType,action);
		}
	},
	getView: function(navigator) {
		var view = this.viewInstance;
		if(view == null && this.viewClass != null) {
			view = (Type().default).createInstance(this.viewClass,[]);
		}
		if(view == null && this.viewFunction != null) {
			view = this.viewFunction();
		}
		var listeners = this.addActionListeners(view,navigator);
		this._viewToEvents.set(view,listeners);
		return view;
	},
	returnView: function(view) {
		var viewListeners = this._viewToEvents.get(view);
		this.removeEventsFromView(view,viewListeners);
		this._viewToEvents.remove(view);
	},
	addActionListeners: function(view,navigator) {
		var listeners = [];
		if(this.actions == null) {
			return listeners;
		}
		var eventType = this.actions.keys();
		while(eventType.hasNext()) {
			var eventType1 = eventType.next();
			var action = this.actions.get(eventType1);
			var listener = this.createActionEventListener(action,navigator);
			view.addEventListener(eventType1,listener);
			listeners.push(new (feathers_controls_navigators__$Route_ViewListener().default)(eventType1,listener));
		}
		return listeners;
	},
	performAction: function(action,event,navigator) {
		switch(action._hx_index) {
		case 0:
			var transition = action.transition;
			var newHistoryState = action.newHistoryState;
			var url = action.url;
			navigator.push(url,newHistoryState,transition);
			break;
		case 1:
			var transition1 = action.transition;
			var newHistoryState1 = action.newHistoryState;
			var url1 = action.url;
			navigator.replace(url1,newHistoryState1,transition1);
			break;
		case 2:
			var transition2 = action.transition;
			navigator.goBack(transition2);
			break;
		case 3:
			var transition3 = action.transition;
			navigator.goForward(transition3);
			break;
		case 4:
			var transition4 = action.transition;
			var n = action.n;
			navigator.go(n);
			break;
		case 5:
			var fn = action.callback;
			fn(event);
			break;
		case 6:
			var fn1 = action.callback;
			return fn1(event);
		}
		return null;
	},
	createActionEventListener: function(action,navigator) {
		var _gthis = this;
		var eventListener = function(event) {
			if(navigator.get_transitionActive()) {
				return;
			}
			var current = action;
			while(current != null) current = _gthis.performAction(current,event,navigator);
		};
		return eventListener;
	},
	removeEventsFromView: function(view,viewListeners) {
		var _g = 0;
		while(_g < viewListeners.length) {
			var viewListener = viewListeners[_g];
			++_g;
			view.removeEventListener(viewListener.eventType,viewListener.listener);
		}
	}
};
Route.prototype.__class__ = Route.prototype.constructor = $hxClasses["feathers.controls.navigators.Route"] = Route;

// Init



// Statics

Route.withClass = function(path,viewClass,actions,updateState,saveData) {
	var item = new Route();
	item.path = path;
	item.viewClass = viewClass;
	item.actions = actions;
	item.updateState = updateState;
	item.saveData = saveData;
	return item;
}
Route.withFunction = function(path,viewFunction,actions,updateState,saveData) {
	var item = new Route();
	item.path = path;
	item.viewFunction = viewFunction;
	item.actions = actions;
	item.updateState = updateState;
	item.saveData = saveData;
	return item;
}
Route.withDisplayObject = function(path,viewInstance,actions,updateState,saveData) {
	var item = new Route();
	item.path = path;
	item.viewInstance = viewInstance;
	item.actions = actions;
	item.updateState = updateState;
	item.saveData = saveData;
	return item;
}
Route.withRedirect = function(path,redirectTo) {
	var item = new Route();
	item.path = path;
	item.redirectTo = redirectTo;
	return item;
}


// Export

exports["default"] = Route;

/***/ }),

/***/ "./lib/_gen/feathers/controls/navigators/RouterAction.js":
/*!***************************************************************!*\
  !*** ./lib/_gen/feathers/controls/navigators/RouterAction.js ***!
  \***************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.controls.navigators.RouterAction

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var RouterAction = $hxEnums["feathers.controls.navigators.RouterAction"] = { __ename__ : "feathers.controls.navigators.RouterAction", __constructs__ : ["Push","Replace","GoBack","GoForward","Go","Listener","NewAction"]
  ,Replace: ($_=function(url,newHistoryState,transition) { return {_hx_index:1,url:url,newHistoryState:newHistoryState,transition:transition,__enum__:"feathers.controls.navigators.RouterAction",toString:$estr}; },$_.__params__ = ["url","newHistoryState","transition"],$_)
  ,Push: ($_=function(url,newHistoryState,transition) { return {_hx_index:0,url:url,newHistoryState:newHistoryState,transition:transition,__enum__:"feathers.controls.navigators.RouterAction",toString:$estr}; },$_.__params__ = ["url","newHistoryState","transition"],$_)
  ,NewAction: ($_=function(callback) { return {_hx_index:6,callback:callback,__enum__:"feathers.controls.navigators.RouterAction",toString:$estr}; },$_.__params__ = ["callback"],$_)
  ,Listener: ($_=function(callback) { return {_hx_index:5,callback:callback,__enum__:"feathers.controls.navigators.RouterAction",toString:$estr}; },$_.__params__ = ["callback"],$_)
  ,GoForward: ($_=function(transition) { return {_hx_index:3,transition:transition,__enum__:"feathers.controls.navigators.RouterAction",toString:$estr}; },$_.__params__ = ["transition"],$_)
  ,GoBack: ($_=function(transition) { return {_hx_index:2,transition:transition,__enum__:"feathers.controls.navigators.RouterAction",toString:$estr}; },$_.__params__ = ["transition"],$_)
  ,Go: ($_=function(n,transition) { return {_hx_index:4,n:n,transition:transition,__enum__:"feathers.controls.navigators.RouterAction",toString:$estr}; },$_.__params__ = ["n","transition"],$_)
};

exports["default"] = RouterAction;

/***/ }),

/***/ "./lib/_gen/feathers/controls/navigators/RouterNavigator.js":
/*!******************************************************************!*\
  !*** ./lib/_gen/feathers/controls/navigators/RouterNavigator.js ***!
  \******************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.navigators.RouterNavigator

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_navigators_BaseNavigator() {return __webpack_require__(/*! ./../../../feathers/controls/navigators/BaseNavigator */ "./lib/_gen/feathers/controls/navigators/BaseNavigator.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function feathers_themes_steel_components_SteelRouterNavigatorStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelRouterNavigatorStyles */ "./lib/_gen/feathers/themes/steel/components/SteelRouterNavigatorStyles.js");}
function StringTools() {return __webpack_require__(/*! ./../../../StringTools */ "./lib/_gen/StringTools.js");}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function openfl_net__$URLVariables_URLVariables_$Impl_$() {return (__webpack_require__(/*! openfl */ "openfl").net._URLVariables.URLVariables_Impl_);}
function haxe_CallStack() {return __webpack_require__(/*! ./../../../haxe/CallStack */ "./lib/_gen/haxe/CallStack.js");}
function haxe_ds_StringMap() {return __webpack_require__(/*! ./../../../haxe/ds/StringMap */ "./lib/_gen/haxe/ds/StringMap.js");}
function feathers_utils_Path2EReg() {return __webpack_require__(/*! ./../../../feathers/utils/Path2EReg */ "./lib/_gen/feathers/utils/Path2EReg.js");}
function feathers_controls_navigators_Route() {return __webpack_require__(/*! ./../../../feathers/controls/navigators/Route */ "./lib/_gen/feathers/controls/navigators/Route.js");}
function feathers_data_RouteState() {return __webpack_require__(/*! ./../../../feathers/data/RouteState */ "./lib/_gen/feathers/data/RouteState.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}

// Constructor

var RouterNavigator = function() {
	this.__replaceTransition = null;
	this.__backTransition = null;
	this.__forwardTransition = null;
	this._cachedPaths = new (haxe_ds_StringMap().default)();
	this._preferHashRouting = false;
	this._savedGoTransition = null;
	this.basePath = null;
	this.historyDepth = 0;
	this.initializeRouterNavigatorTheme();
	(feathers_controls_navigators_BaseNavigator().default).call(this);
	this.addEventListener("addedToStage",$bind(this,this.routerNavigator_addedToStageHandler));
	this.addEventListener("removedFromStage",$bind(this,this.routerNavigator_removedFromStageHandler));
}

// Meta

RouterNavigator.__name__ = "feathers.controls.navigators.RouterNavigator";
RouterNavigator.__isInterface__ = false;
RouterNavigator.__super__ = (feathers_controls_navigators_BaseNavigator().default);
RouterNavigator.prototype = $extend((feathers_controls_navigators_BaseNavigator().default).prototype, {
	get_preferHashRouting: function() {
		return this._preferHashRouting;
	},
	set_preferHashRouting: function(value) {
		if(this._preferHashRouting == value) {
			return this._preferHashRouting;
		}
		if(this._activeItemView != null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Must set preferHashRouting before a view is displayed"));
		}
		this._preferHashRouting = value;
		return this._preferHashRouting;
	},
	initializeRouterNavigatorTheme: function() {
		(feathers_themes_steel_components_SteelRouterNavigatorStyles().default).initialize();
	},
	addRoute: function(route) {
		if(route.path == null) {
			route.path = "";
		}
		this.addItemInternal(route.path,route);
		if(this.stage != null && this.get_activeItemView() == null) {
			var matched = this.matchRoute();
			if(matched == route) {
				if(route.redirectTo != null) {
					this.redirect(route);
				} else {
					this.showItemInternal(matched.path,null);
				}
			}
		}
	},
	push: function(path,newHistoryState,transition) {
		if(this._activeItemView != null) {
			var viewData = null;
			var oldItem = this._addedItems.get(this._activeItemID);
			if(oldItem.saveData != null) {
				viewData = oldItem.saveData(this._activeItemView);
			}
			var historyState = this.htmlWindow.history.state;
			if(historyState == null) {
				historyState = { depth : this.historyDepth, state : null, viewData : viewData};
			} else {
				historyState.viewData = viewData;
			}
			var oldPathname = this.getPathname();
			var oldURL = oldPathname + this.get_location().search;
			if(this.basePath != null && !(StringTools().default).startsWith(oldPathname,this.basePath + "/")) {
				var needsSlash = !(StringTools().default).startsWith(oldPathname,"/");
				oldPathname = this.basePath + (needsSlash ? "/" : "") + oldPathname;
				oldURL = oldPathname + this.get_location().search;
			}
			if(this._preferHashRouting || this.htmlWindow.location.protocol == "file:") {
				oldURL = this.htmlWindow.location.pathname + this.get_location().search + "#" + oldPathname;
			}
			this.htmlWindow.history.replaceState(historyState,null,oldURL);
		}
		var newPathParts = path.split("?");
		var newPathname = newPathParts[0];
		var newSearch = "";
		if(newPathParts.length > 1) {
			newSearch = "?" + newPathParts[1];
		}
		var newURL = newPathname + newSearch;
		if(this.basePath != null && !(StringTools().default).startsWith(newPathname,this.basePath + "/")) {
			var needsSlash1 = !(StringTools().default).startsWith(newPathname,"/");
			newPathname = this.basePath + (needsSlash1 ? "/" : "") + newPathname;
			newURL = newPathname + newSearch;
		}
		if(this._preferHashRouting || this.htmlWindow.location.protocol == "file:") {
			newURL = this.htmlWindow.location.pathname + newSearch + "#" + newPathname;
		}
		this.historyDepth++;
		this.htmlWindow.history.pushState({ depth : this.historyDepth, state : newHistoryState, viewData : null},null,newURL);
		if(transition == null) {
			transition = this.get_forwardTransition();
		}
		return this.matchRouteAndShow(transition);
	},
	replace: function(path,newHistoryState,transition) {
		var newPathParts = path.split("?");
		var newPathname = newPathParts[0];
		var newSearch = "";
		if(newPathParts.length > 1) {
			newSearch = "?" + newPathParts[1];
		}
		var newURL = newPathname + newSearch;
		if(this.basePath != null && !(StringTools().default).startsWith(newPathname,this.basePath + "/")) {
			var needsSlash = !(StringTools().default).startsWith(newPathname,"/");
			newPathname = this.basePath + (needsSlash ? "/" : "") + newPathname;
			newURL = newPathname + newSearch;
		}
		if(this._preferHashRouting || this.htmlWindow.location.protocol == "file:") {
			newURL = this.htmlWindow.location.pathname + newSearch + "#" + newPathname;
		}
		this.htmlWindow.history.replaceState({ depth : this.historyDepth, state : newHistoryState, viewData : null},null,newURL);
		if(transition == null) {
			transition = this.get_replaceTransition();
		}
		return this.matchRouteAndShow(transition);
	},
	go: function(n,transition) {
		if(n == 0) {
			return this.get_activeItemView();
		}
		if(transition == null) {
			transition = n < 0 ? this.get_backTransition() : this.get_forwardTransition();
		}
		this._savedGoTransition = transition;
		this.htmlWindow.history.go(n);
		return null;
	},
	goBack: function(transition) {
		return this.go(-1,transition);
	},
	goForward: function(transition) {
		return this.go(1,transition);
	},
	routerNavigator_addedToStageHandler: function(event) {
		this.htmlWindow = (js_Boot().default).__cast($global , Window);
		this.htmlWindow.addEventListener("popstate",$bind(this,this.htmlWindow_popstateHandler));
		this.matchRouteAndShow(null);
	},
	get_location: function() {
		return this.htmlWindow.location;
	},
	get_pathname: function() {
		return this.getPathname();
	},
	getURLVariables: function() {
		var search = this.get_location().search;
		if(search.length > 0) {
			search = (HxOverrides().default).substr(search,1,null);
		}
		try {
			return (openfl_net__$URLVariables_URLVariables_$Impl_$().default)._new(search);
		} catch( e ) {
			(haxe_CallStack().default).lastException = e;
			var e1 = ((e) instanceof (js__$Boot_HaxeError().default)) ? e.val : e;
			return (openfl_net__$URLVariables_URLVariables_$Impl_$().default)._new();
		}
	},
	getPathname: function() {
		var pathname = null;
		if(this._preferHashRouting || this.htmlWindow.location.protocol == "file:") {
			pathname = this.htmlWindow.location.hash;
			if(pathname.length == 0) {
				pathname = "/";
			} else {
				pathname = (HxOverrides().default).substr(pathname,1,null);
			}
		} else {
			pathname = this.htmlWindow.location.pathname;
		}
		if(this.basePath != null && (StringTools().default).startsWith(pathname,this.basePath + "/")) {
			pathname = (HxOverrides().default).substr(pathname,this.basePath.length,null);
		}
		return pathname;
	},
	redirect: function(route) {
		var newURL = route.redirectTo;
		var itemPath = route.path;
		var params = new (haxe_ds_StringMap().default)();
		if(itemPath != null && itemPath.length > 0) {
			var matcher = this.getMatcher(itemPath);
			var _g = 0;
			var _g1 = matcher.keys.length;
			while(_g < _g1) {
				var i = _g++;
				var key = matcher.keys[i];
				params.set(key.name,matcher.ereg.matched(i + 1));
			}
		}
		var _g2 = params.keyValueIterator();
		while(_g2.hasNext()) {
			var _g11 = _g2.next();
			var name = _g11.key;
			var value = _g11.value;
			newURL = (StringTools().default).replace(newURL,":name",value);
		}
		this.replace(newURL);
	},
	getMatcher: function(path) {
		var matcher = this._cachedPaths.get(path);
		if(matcher == null) {
			matcher = (feathers_utils_Path2EReg().default).toEReg(path,{ end : true});
			this._cachedPaths.set(path,matcher);
		}
		return matcher;
	},
	matchRoute: function() {
		var pathname = this.getPathname();
		var _g = 0;
		var _g1 = this._addedItemIDs;
		while(_g < _g1.length) {
			var path = _g1[_g];
			++_g;
			if(path == null || path.length == 0) {
				return this._addedItems.get(path);
			}
			var matcher = this.getMatcher(path);
			if(matcher.ereg.match(pathname)) {
				return this._addedItems.get(path);
			}
		}
		return null;
	},
	matchRouteAndShow: function(transition) {
		var matched = this.matchRoute();
		if(matched != null) {
			if(matched.redirectTo != null) {
				this.redirect(matched);
				return null;
			}
			return this.showItemInternal(matched.path,transition);
		}
		this.clearActiveItemInternal(null);
		return null;
	},
	getView: function(id) {
		var item = (js_Boot().default).__cast(this._addedItems.get(id) , (feathers_controls_navigators_Route().default));
		var itemPath = item.path;
		var params = new (haxe_ds_StringMap().default)();
		if(itemPath != null && itemPath.length > 0) {
			var matcher = this.getMatcher(itemPath);
			var _g = 0;
			var _g1 = matcher.keys.length;
			while(_g < _g1) {
				var i = _g++;
				var key = matcher.keys[i];
				params.set(key.name,matcher.ereg.matched(i + 1));
			}
		}
		var routeState = new (feathers_data_RouteState().default)(item.path,this.getPathname(),params);
		var view = item.getView(this);
		var historyState = this.htmlWindow.history.state;
		routeState.historyState = historyState != null ? historyState.state : null;
		routeState.data = historyState != null ? historyState.viewData : null;
		routeState.urlVariables = this.getURLVariables();
		if(item.updateState != null) {
			item.updateState(view,routeState);
		}
		view.addEventListener("link",$bind(this,this.routerNavigator_activeView_linkHandler));
		return view;
	},
	disposeView: function(id,view) {
		view.removeEventListener("link",$bind(this,this.routerNavigator_activeView_linkHandler));
		var item = (js_Boot().default).__cast(this._addedItems.get(id) , (feathers_controls_navigators_Route().default));
		item.returnView(view);
	},
	routerNavigator_removedFromStageHandler: function(event) {
		if(this.htmlWindow != null) {
			this.htmlWindow.removeEventListener("popstate",$bind(this,this.htmlWindow_popstateHandler));
			this.htmlWindow = null;
		}
	},
	routerNavigator_activeView_linkHandler: function(event) {
		if(event.isDefaultPrevented()) {
			return;
		}
		if(!(StringTools().default).startsWith(event.text,"router:")) {
			return;
		}
		event.preventDefault();
		var url = (HxOverrides().default).substr(event.text,7,null);
		this.push(url);
	},
	htmlWindow_popstateHandler: function(event) {
		event.preventDefault();
		var newDepth = this.historyDepth;
		var historyState = this.htmlWindow.history.state;
		if(historyState != null && historyState.depth != null) {
			newDepth = historyState.depth;
		}
		var transition = this._savedGoTransition;
		this._savedGoTransition = null;
		if(this._activeItemView != null && transition == null) {
			if(this.historyDepth > newDepth) {
				transition = this.get_backTransition();
			} else if(this.historyDepth < newDepth) {
				transition = this.get_forwardTransition();
			}
		}
		this.historyDepth = newDepth;
		this.matchRouteAndShow(transition);
	},
	get_styleContext: function() {
		return RouterNavigator
	},
	get_forwardTransition: function() {
		return this.__forwardTransition;
	},
	set_forwardTransition: function(value) {
		if(!this.setStyle("forwardTransition")) {
			return this.__forwardTransition;
		}
		if(this.__forwardTransition == value) {
			return this.__forwardTransition;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_forwardTransition);
		this.__forwardTransition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__forwardTransition;
	},
	clearStyle_forwardTransition: function() {
		this.set_forwardTransition(null);
		return this.get_forwardTransition();
	},
	get_backTransition: function() {
		return this.__backTransition;
	},
	set_backTransition: function(value) {
		if(!this.setStyle("backTransition")) {
			return this.__backTransition;
		}
		if(this.__backTransition == value) {
			return this.__backTransition;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_backTransition);
		this.__backTransition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__backTransition;
	},
	clearStyle_backTransition: function() {
		this.set_backTransition(null);
		return this.get_backTransition();
	},
	get_replaceTransition: function() {
		return this.__replaceTransition;
	},
	set_replaceTransition: function(value) {
		if(!this.setStyle("replaceTransition")) {
			return this.__replaceTransition;
		}
		if(this.__replaceTransition == value) {
			return this.__replaceTransition;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_replaceTransition);
		this.__replaceTransition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__replaceTransition;
	},
	clearStyle_replaceTransition: function() {
		this.set_replaceTransition(null);
		return this.get_replaceTransition();
	}
});
RouterNavigator.prototype.__class__ = RouterNavigator.prototype.constructor = $hxClasses["feathers.controls.navigators.RouterNavigator"] = RouterNavigator;

// Init



// Statics




// Export

exports["default"] = RouterNavigator;

/***/ }),

/***/ "./lib/_gen/feathers/controls/navigators/StackAction.js":
/*!**************************************************************!*\
  !*** ./lib/_gen/feathers/controls/navigators/StackAction.js ***!
  \**************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.controls.navigators.StackAction

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var StackAction = $hxEnums["feathers.controls.navigators.StackAction"] = { __ename__ : "feathers.controls.navigators.StackAction", __constructs__ : ["Push","Replace","Pop","PopMultiple","PopToRoot","PopToRootAndReplace","Listener","NewAction"]
  ,Replace: ($_=function(id,inject,transition) { return {_hx_index:1,id:id,inject:inject,transition:transition,__enum__:"feathers.controls.navigators.StackAction",toString:$estr}; },$_.__params__ = ["id","inject","transition"],$_)
  ,Push: ($_=function(id,inject,transition) { return {_hx_index:0,id:id,inject:inject,transition:transition,__enum__:"feathers.controls.navigators.StackAction",toString:$estr}; },$_.__params__ = ["id","inject","transition"],$_)
  ,PopToRootAndReplace: ($_=function(id,inject,transition) { return {_hx_index:5,id:id,inject:inject,transition:transition,__enum__:"feathers.controls.navigators.StackAction",toString:$estr}; },$_.__params__ = ["id","inject","transition"],$_)
  ,PopToRoot: ($_=function(returnedObject,transition) { return {_hx_index:4,returnedObject:returnedObject,transition:transition,__enum__:"feathers.controls.navigators.StackAction",toString:$estr}; },$_.__params__ = ["returnedObject","transition"],$_)
  ,PopMultiple: ($_=function(count,returnedObject,transition) { return {_hx_index:3,count:count,returnedObject:returnedObject,transition:transition,__enum__:"feathers.controls.navigators.StackAction",toString:$estr}; },$_.__params__ = ["count","returnedObject","transition"],$_)
  ,Pop: ($_=function(returnedObject,transition) { return {_hx_index:2,returnedObject:returnedObject,transition:transition,__enum__:"feathers.controls.navigators.StackAction",toString:$estr}; },$_.__params__ = ["returnedObject","transition"],$_)
  ,NewAction: ($_=function(callback) { return {_hx_index:7,callback:callback,__enum__:"feathers.controls.navigators.StackAction",toString:$estr}; },$_.__params__ = ["callback"],$_)
  ,Listener: ($_=function(callback) { return {_hx_index:6,callback:callback,__enum__:"feathers.controls.navigators.StackAction",toString:$estr}; },$_.__params__ = ["callback"],$_)
};

exports["default"] = StackAction;

/***/ }),

/***/ "./lib/_gen/feathers/controls/navigators/StackItem.js":
/*!************************************************************!*\
  !*** ./lib/_gen/feathers/controls/navigators/StackItem.js ***!
  \************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.navigators.StackItem

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function haxe_ds_StringMap() {return __webpack_require__(/*! ./../../../haxe/ds/StringMap */ "./lib/_gen/haxe/ds/StringMap.js");}
function Type() {return __webpack_require__(/*! ./../../../Type */ "./lib/_gen/Type.js");}
function feathers_controls_navigators__$StackItem_ViewListener() {return __webpack_require__(/*! ./../../../feathers/controls/navigators/_StackItem/ViewListener */ "./lib/_gen/feathers/controls/navigators/_StackItem/ViewListener.js");}
function haxe_ds_ObjectMap() {return __webpack_require__(/*! ./../../../haxe/ds/ObjectMap */ "./lib/_gen/haxe/ds/ObjectMap.js");}

// Constructor

var StackItem = function() {
	this._viewToEvents = new (haxe_ds_ObjectMap().default)();
}

// Meta

StackItem.__name__ = "feathers.controls.navigators.StackItem";
StackItem.__isInterface__ = false;
StackItem.prototype = {
	setAction: function(eventType,action) {
		if(this.actions == null) {
			this.actions = new (haxe_ds_StringMap().default)();
		}
		if(action == null) {
			this.actions.remove(eventType);
		} else {
			this.actions.set(eventType,action);
		}
	},
	saveData: function(view) {
		return null;
	},
	restoreData: function(view,data) {
	},
	getView: function(navigator) {
		var view = this.viewInstance;
		if(view == null && this.viewClass != null) {
			view = (Type().default).createInstance(this.viewClass,[]);
		}
		if(view == null && this.viewFunction != null) {
			view = this.viewFunction();
		}
		var listeners = this.addActionListeners(view,navigator);
		this._viewToEvents.set(view,listeners);
		return view;
	},
	returnView: function(view) {
		var viewListeners = this._viewToEvents.get(view);
		this.removeEventsFromView(view,viewListeners);
		this._viewToEvents.remove(view);
	},
	addActionListeners: function(view,navigator) {
		var listeners = [];
		if(this.actions == null) {
			return listeners;
		}
		var eventType = this.actions.keys();
		while(eventType.hasNext()) {
			var eventType1 = eventType.next();
			var action = this.actions.get(eventType1);
			var listener = this.createActionEventListener(action,navigator);
			view.addEventListener(eventType1,listener);
			listeners.push(new (feathers_controls_navigators__$StackItem_ViewListener().default)(eventType1,listener));
		}
		return listeners;
	},
	performAction: function(action,event,navigator) {
		switch(action._hx_index) {
		case 0:
			var transition = action.transition;
			var inject = action.inject;
			var id = action.id;
			navigator.pushItem(id,inject,transition);
			break;
		case 1:
			var transition1 = action.transition;
			var inject1 = action.inject;
			var id1 = action.id;
			navigator.replaceItem(id1,inject1,transition1);
			break;
		case 2:
			var transition2 = action.transition;
			var returnedObject = action.returnedObject;
			navigator.popItem(returnedObject,transition2);
			break;
		case 3:
			var transition3 = action.transition;
			var returnedObject1 = action.returnedObject;
			var count = action.count;
			navigator.popMultipleItems(count,returnedObject1,transition3);
			break;
		case 4:
			var transition4 = action.transition;
			var returnedObject2 = action.returnedObject;
			navigator.popToRootItem(returnedObject2,transition4);
			break;
		case 5:
			var transition5 = action.transition;
			var inject2 = action.inject;
			var id2 = action.id;
			navigator.popToRootItemAndReplace(id2,inject2,transition5);
			break;
		case 6:
			var fn = action.callback;
			fn(event);
			break;
		case 7:
			var fn1 = action.callback;
			return fn1(event);
		}
		return null;
	},
	createActionEventListener: function(action,navigator) {
		var _gthis = this;
		var eventListener = function(event) {
			if(navigator.get_transitionActive()) {
				return;
			}
			var current = action;
			while(current != null) current = _gthis.performAction(current,event,navigator);
		};
		return eventListener;
	},
	removeEventsFromView: function(view,viewListeners) {
		var _g = 0;
		while(_g < viewListeners.length) {
			var viewListener = viewListeners[_g];
			++_g;
			view.removeEventListener(viewListener.eventType,viewListener.listener);
		}
	}
};
StackItem.prototype.__class__ = StackItem.prototype.constructor = $hxClasses["feathers.controls.navigators.StackItem"] = StackItem;

// Init



// Statics

StackItem.withClass = function(id,viewClass,actions,returnHandlers,saveData,restoreData) {
	var item = new StackItem();
	item.id = id;
	item.viewClass = viewClass;
	item.actions = actions;
	item.returnHandlers = returnHandlers;
	item.saveData = saveData;
	item.restoreData = restoreData;
	return item;
}
StackItem.withFunction = function(id,viewFunction,actions,returnHandlers,saveData,restoreData) {
	var item = new StackItem();
	item.id = id;
	item.viewFunction = viewFunction;
	item.actions = actions;
	item.returnHandlers = returnHandlers;
	item.saveData = saveData;
	item.restoreData = restoreData;
	return item;
}
StackItem.withDisplayObject = function(id,viewInstance,actions,returnHandlers,saveData,restoreData) {
	var item = new StackItem();
	item.id = id;
	item.viewInstance = viewInstance;
	item.actions = actions;
	item.returnHandlers = returnHandlers;
	item.saveData = saveData;
	item.restoreData = restoreData;
	return item;
}


// Export

exports["default"] = StackItem;

/***/ }),

/***/ "./lib/_gen/feathers/controls/navigators/StackNavigator.js":
/*!*****************************************************************!*\
  !*** ./lib/_gen/feathers/controls/navigators/StackNavigator.js ***!
  \*****************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.navigators.StackNavigator

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_navigators_BaseNavigator() {return __webpack_require__(/*! ./../../../feathers/controls/navigators/BaseNavigator */ "./lib/_gen/feathers/controls/navigators/BaseNavigator.js");}
function feathers_controls_navigators__$StackNavigator_HistoryItem() {return __webpack_require__(/*! ./../../../feathers/controls/navigators/_StackNavigator/HistoryItem */ "./lib/_gen/feathers/controls/navigators/_StackNavigator/HistoryItem.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_themes_steel_components_SteelStackNavigatorStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelStackNavigatorStyles */ "./lib/_gen/feathers/themes/steel/components/SteelStackNavigatorStyles.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_controls_navigators_StackItem() {return __webpack_require__(/*! ./../../../feathers/controls/navigators/StackItem */ "./lib/_gen/feathers/controls/navigators/StackItem.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_RangeError() {return (__webpack_require__(/*! openfl */ "openfl").errors.RangeError);}
function feathers_utils_EdgePuller() {return __webpack_require__(/*! ./../../../feathers/utils/EdgePuller */ "./lib/_gen/feathers/utils/EdgePuller.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}
function feathers_motion_effects_EventToPositionEffectContext() {return __webpack_require__(/*! ./../../../feathers/motion/effects/EventToPositionEffectContext */ "./lib/_gen/feathers/motion/effects/EventToPositionEffectContext.js");}
function feathers_utils_ExclusivePointer() {return __webpack_require__(/*! ./../../../feathers/utils/ExclusivePointer */ "./lib/_gen/feathers/utils/ExclusivePointer.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}

// Constructor

var StackNavigator = function() {
	this.__replaceTransition = null;
	this.__popTransition = null;
	this.__pushTransition = null;
	this._poppedHistoryItems = null;
	this.savedIsPop = false;
	this._popSwipeActiveEdgeSize = 30.0;
	this._simulateTouch = false;
	this._popSwipeEnabled = false;
	this._history = [];
	this.initializeStackNavigatorTheme();
	(feathers_controls_navigators_BaseNavigator().default).call(this);
	this.addEventListener("initialize",$bind(this,this.stackNavigator_initializeHandler));
	this.addEventListener("addedToStage",$bind(this,this.stackNavigator_addedToStageHandler));
	this.addEventListener("removedFromStage",$bind(this,this.stackNavigator_removedFromStageHandler));
}

// Meta

StackNavigator.__name__ = "feathers.controls.navigators.StackNavigator";
StackNavigator.__isInterface__ = false;
StackNavigator.__super__ = (feathers_controls_navigators_BaseNavigator().default);
StackNavigator.prototype = $extend((feathers_controls_navigators_BaseNavigator().default).prototype, {
	get_stackSize: function() {
		return this._history.length;
	},
	get_rootItemID: function() {
		if(this._history.length > 0) {
			return this._history[0].id;
		}
		return this._tempRootItemID;
	},
	set_rootItemID: function(value) {
		if(!this.get_initialized()) {
			this._tempRootItemID = value;
			return this._tempRootItemID;
		}
		this._tempRootItemID = null;
		this._history.length = 0;
		if(value == null) {
			this.clearActiveItemInternal(null);
			return null;
		}
		var historyItem = new (feathers_controls_navigators__$StackNavigator_HistoryItem().default)(value,null,null,null);
		this._history.push(historyItem);
		this.showItemWithInjectAndReturnedObject(value,null,null,null,null,false);
		return value;
	},
	get_popSwipeEnabled: function() {
		return this._popSwipeEnabled;
	},
	set_popSwipeEnabled: function(value) {
		if(this._popSwipeEnabled == value) {
			return this._popSwipeEnabled;
		}
		this._popSwipeEnabled = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._popSwipeEnabled;
	},
	get_simulateTouch: function() {
		return this._simulateTouch;
	},
	set_simulateTouch: function(value) {
		if(this._simulateTouch == value) {
			return this._simulateTouch;
		}
		this._simulateTouch = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._simulateTouch;
	},
	get_popSwipeActiveEdgeSize: function() {
		return this._popSwipeActiveEdgeSize;
	},
	set_popSwipeActiveEdgeSize: function(value) {
		if(this._popSwipeActiveEdgeSize == value) {
			return this._popSwipeActiveEdgeSize;
		}
		this._popSwipeActiveEdgeSize = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._popSwipeActiveEdgeSize;
	},
	initializeStackNavigatorTheme: function() {
		(feathers_themes_steel_components_SteelStackNavigatorStyles().default).initialize();
	},
	addItem: function(item) {
		this.addItemInternal(item.id,item);
	},
	removeItem: function(id) {
		var _g = 0;
		var _g1 = this._history;
		while(_g < _g1.length) {
			var item = _g1[_g];
			++_g;
			if(item.id == id) {
				(HxOverrides().default).remove(this._history,item);
			}
		}
		var item1 = this.removeItemInternal(id);
		return (js_Boot().default).__cast(item1 , (feathers_controls_navigators_StackItem().default));
	},
	removeAllItems: function() {
		this._history.length = 0;
		(feathers_controls_navigators_BaseNavigator().default).prototype.removeAllItems.call(this);
	},
	getItem: function(id) {
		var item = this._addedItems.get(id);
		if(item == null) {
			return null;
		}
		return (js_Boot().default).__cast(item , (feathers_controls_navigators_StackItem().default));
	},
	pushItem: function(id,inject,transition) {
		if(transition == null) {
			var item = this.getItem(id);
			if(item != null && item.pushTransition != null) {
				transition = item.pushTransition;
			} else {
				transition = this.get_pushTransition();
			}
		}
		if(this._activeItemView != null) {
			var viewData = null;
			var oldItem = this._addedItems.get(this._activeItemID);
			if(oldItem.saveData != null) {
				viewData = oldItem.saveData(this._activeItemView);
			}
			var historyItem = this._history[this._history.length - 1];
			historyItem.viewData = viewData;
		}
		var historyItem1 = new (feathers_controls_navigators__$StackNavigator_HistoryItem().default)(id,inject,null,transition);
		this._history.push(historyItem1);
		return this.showItemWithInjectAndReturnedObject(id,transition,inject,null,null,false);
	},
	popItem: function(returnedObject,transition) {
		if(this._history.length <= 1) {
			return this.get_activeItemView();
		}
		if(transition == null) {
			var item = this.getItem(this.get_activeItemID());
			if(item != null && item.popTransition != null) {
				transition = item.popTransition;
			} else {
				transition = this.get_popTransition();
			}
		}
		this._poppedHistoryItems = [this._history.pop()];
		var item1 = this._history[this._history.length - 1];
		return this.showItemWithInjectAndReturnedObject(item1.id,transition,item1.inject,returnedObject,item1.viewData,true);
	},
	popMultipleItems: function(count,returnedObject,transition) {
		if(count <= 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("popMultipleItems() must be called with a value greater than zero"));
		}
		if(transition == null) {
			var item = this.getItem(this.get_activeItemID());
			if(item != null && item.popTransition != null) {
				transition = item.popTransition;
			} else {
				transition = this.get_popTransition();
			}
		}
		var newHistoryLength = this._history.length - count;
		if(newHistoryLength < 1) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("popMultipleItems() called with value larger than available history. Received " + count + ". Expected less than " + this._history.length + "."));
		}
		this._poppedHistoryItems = this._history.slice(newHistoryLength);
		this._history.length = newHistoryLength;
		var item1 = this._history[this._history.length - 1];
		return this.showItemWithInjectAndReturnedObject(item1.id,transition,item1.inject,returnedObject,item1.viewData,true);
	},
	popToRootItem: function(returnedObject,transition) {
		if(this._history.length <= 1) {
			return this.get_activeItemView();
		}
		if(transition == null) {
			transition = this.get_popTransition();
		}
		this._poppedHistoryItems = this._history.slice(1);
		this._history.length = 1;
		var item = this._history[0];
		return this.showItemWithInjectAndReturnedObject(item.id,transition,item.inject,returnedObject,null,true);
	},
	popAll: function(transition) {
		if(this._history.length == 0) {
			return;
		}
		if(transition == null) {
			transition = this.get_popTransition();
		}
		this._poppedHistoryItems = this._history.slice();
		this._history.length = 0;
		this.clearActiveItemInternal(transition);
	},
	replaceItem: function(id,inject,transition) {
		if(transition == null) {
			transition = this.get_replaceTransition();
		}
		var historyItem = new (feathers_controls_navigators__$StackNavigator_HistoryItem().default)(id,inject,null,transition);
		this._history[this._history.length - 1] = historyItem;
		return this.showItemWithInjectAndReturnedObject(id,transition,inject,null,null,false);
	},
	popToRootItemAndReplace: function(id,inject,transition) {
		if(transition == null) {
			transition = this.get_popTransition();
		}
		this._history.length = 1;
		this._history[0] = new (feathers_controls_navigators__$StackNavigator_HistoryItem().default)(id,inject,null,transition);
		return this.showItemWithInjectAndReturnedObject(id,transition,inject,null,null,false);
	},
	initialize: function() {
		(feathers_controls_navigators_BaseNavigator().default).prototype.initialize.call(this);
		if(this._backEdgePuller == null) {
			this._backEdgePuller = new (feathers_utils_EdgePuller().default)(this,(feathers_layout_RelativePosition().default).LEFT);
			this._backEdgePuller.addEventListener("opening",$bind(this,this.stackNavigator_backEdgePuller_openingHandler));
			this._backEdgePuller.addEventListener("cancel",$bind(this,this.stackNavigator_backEdgePuller_cancelHandler));
			this._backEdgePuller.addEventListener("open",$bind(this,this.stackNavigator_backEdgePuller_openHandler));
		}
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var selectionInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		if(dataInvalid || selectionInvalid) {
			var tmp = this._enabled && this._popSwipeEnabled && this.get_stackSize() > 1;
			this._backEdgePuller.enabled = tmp;
			this._backEdgePuller.set_activeBorderSize(this._popSwipeActiveEdgeSize);
			this._backEdgePuller.simulateTouch = this._simulateTouch;
		}
		(feathers_controls_navigators_BaseNavigator().default).prototype.update.call(this);
	},
	getView: function(id) {
		var item = (js_Boot().default).__cast(this._addedItems.get(id) , (feathers_controls_navigators_StackItem().default));
		var view = item.getView(this);
		if(this.savedInject != null) {
			this.savedInject(view);
		}
		if(item.restoreData != null) {
			item.restoreData(view,this.savedViewData);
		}
		if(this.savedIsPop) {
			var returnHandlers = item.returnHandlers;
			if(returnHandlers != null && returnHandlers.exists(this._previousViewInTransitionID)) {
				(returnHandlers.get(this._previousViewInTransitionID))(view,this.savedReturnedObject);
			}
		}
		return view;
	},
	disposeView: function(id,view) {
		var item = (js_Boot().default).__cast(this._addedItems.get(id) , (feathers_controls_navigators_StackItem().default));
		item.returnView(view);
	},
	transitionComplete: function() {
		this._poppedHistoryItems = null;
	},
	transitionCancel: function() {
		if(this._poppedHistoryItems != null) {
			var _g = 0;
			var _g1 = this._poppedHistoryItems;
			while(_g < _g1.length) {
				var item = _g1[_g];
				++_g;
				this._history.push(item);
			}
			this._poppedHistoryItems = null;
		}
	},
	showItemWithInjectAndReturnedObject: function(id,transition,inject,returnedObject,viewData,isPop) {
		this.savedInject = inject;
		this.savedReturnedObject = returnedObject;
		this.savedViewData = viewData;
		this.savedIsPop = isPop;
		var result = this.showItemInternal(id,transition);
		this.savedInject = null;
		this.savedReturnedObject = null;
		this.savedIsPop = false;
		this.savedViewData = null;
		return result;
	},
	startBackDragTransition: function(one,two) {
		var _gthis = this;
		var effectContext = (this.get_popTransition())(one,two);
		this._backEdgePuller.set_snapDuration(effectContext.get_duration());
		this._dragTransitionContext = new (feathers_motion_effects_EventToPositionEffectContext())(effectContext,this._backEdgePuller,"change",function(event) {
			return _gthis._dragTransitionContext.set_position(_gthis._backEdgePuller.get_pullDistance() / _gthis.actualWidth);
		});
		return this._dragTransitionContext;
	},
	stackNavigator_initializeHandler: function(event) {
		if(this._tempRootItemID != null) {
			var id = this._tempRootItemID;
			this._tempRootItemID = null;
			var historyItem = new (feathers_controls_navigators__$StackNavigator_HistoryItem().default)(id,null,null,null);
			this._history.push(historyItem);
			this.showItemWithInjectAndReturnedObject(id,null,null,null,null,false);
		}
	},
	stackNavigator_addedToStageHandler: function(event) {
		this.stage.addEventListener("keyUp",$bind(this,this.stackNavigator_stage_keyUpHandler),false,0,true);
	},
	stackNavigator_removedFromStageHandler: function(event) {
		this.stage.removeEventListener("keyUp",$bind(this,this.stackNavigator_stage_keyUpHandler));
	},
	stackNavigator_stage_backKeyUpHandler: function(event) {
		if(event.isDefaultPrevented()) {
			return;
		}
		if(this._history.length <= 1) {
			return;
		}
		event.preventDefault();
		this.popItem();
	},
	stackNavigator_stage_keyUpHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(event.keyCode == 1073742094) {
			this.stackNavigator_stage_backKeyUpHandler(event);
		}
	},
	stackNavigator_backEdgePuller_openingHandler: function(event) {
		if(this.get_stackSize() <= 1) {
			event.preventDefault();
			return;
		}
		var touchPointID = this._backEdgePuller.get_touchPointID();
		if(touchPointID != null) {
			var exclusivePointer = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
			if(this._backEdgePuller.get_touchPointIsSimulated()) {
				var result = exclusivePointer.claimMouse(this);
				if(!result) {
					event.preventDefault();
					return;
				}
			} else {
				var result1 = exclusivePointer.claimTouch(touchPointID,this);
				if(!result1) {
					event.preventDefault();
					return;
				}
			}
		}
		if(this.get_popTransition() != null) {
			this.popItem(null,$bind(this,this.startBackDragTransition));
		} else {
			event.preventDefault();
			this.popItem();
		}
	},
	stackNavigator_backEdgePuller_cancelHandler: function(event) {
		var context = this._dragTransitionContext;
		this._dragTransitionContext = null;
		if(context != null) {
			context.set_dispatcher(null);
			(feathers_events_FeathersEvent().default).dispatch(context,"cancel");
		}
		var tmp = this._enabled && this._popSwipeEnabled && this.get_stackSize() > 1;
		this._backEdgePuller.enabled = tmp;
	},
	stackNavigator_backEdgePuller_openHandler: function(event) {
		var context = this._dragTransitionContext;
		this._dragTransitionContext = null;
		if(context != null) {
			context.set_dispatcher(null);
			(feathers_events_FeathersEvent().default).dispatch(context,"complete");
		}
		var oldSnapDuration = this._backEdgePuller.get_snapDuration();
		this._backEdgePuller.set_snapDuration(0.0);
		this._backEdgePuller.set_opened(false);
		this._backEdgePuller.set_snapDuration(oldSnapDuration);
		var tmp = this._enabled && this._popSwipeEnabled && this.get_stackSize() > 1;
		this._backEdgePuller.enabled = tmp;
	},
	get_styleContext: function() {
		return StackNavigator
	},
	get_pushTransition: function() {
		return this.__pushTransition;
	},
	set_pushTransition: function(value) {
		if(!this.setStyle("pushTransition")) {
			return this.__pushTransition;
		}
		if(this.__pushTransition == value) {
			return this.__pushTransition;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_pushTransition);
		this.__pushTransition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__pushTransition;
	},
	clearStyle_pushTransition: function() {
		this.set_pushTransition(null);
		return this.get_pushTransition();
	},
	get_popTransition: function() {
		return this.__popTransition;
	},
	set_popTransition: function(value) {
		if(!this.setStyle("popTransition")) {
			return this.__popTransition;
		}
		if(this.__popTransition == value) {
			return this.__popTransition;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_popTransition);
		this.__popTransition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__popTransition;
	},
	clearStyle_popTransition: function() {
		this.set_popTransition(null);
		return this.get_popTransition();
	},
	get_replaceTransition: function() {
		return this.__replaceTransition;
	},
	set_replaceTransition: function(value) {
		if(!this.setStyle("replaceTransition")) {
			return this.__replaceTransition;
		}
		if(this.__replaceTransition == value) {
			return this.__replaceTransition;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_replaceTransition);
		this.__replaceTransition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__replaceTransition;
	},
	clearStyle_replaceTransition: function() {
		this.set_replaceTransition(null);
		return this.get_replaceTransition();
	}
});
StackNavigator.prototype.__class__ = StackNavigator.prototype.constructor = $hxClasses["feathers.controls.navigators.StackNavigator"] = StackNavigator;

// Init



// Statics




// Export

exports["default"] = StackNavigator;

/***/ }),

/***/ "./lib/_gen/feathers/controls/navigators/TabItem.js":
/*!**********************************************************!*\
  !*** ./lib/_gen/feathers/controls/navigators/TabItem.js ***!
  \**********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.navigators.TabItem

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Type() {return __webpack_require__(/*! ./../../../Type */ "./lib/_gen/Type.js");}
function Std() {return __webpack_require__(/*! ./../../../Std */ "./lib/_gen/Std.js");}

// Constructor

var TabItem = function() {
	this.internalID = (Std().default).string(TabItem.internalIDCounter);
	TabItem.internalIDCounter++;
}

// Meta

TabItem.__name__ = "feathers.controls.navigators.TabItem";
TabItem.__isInterface__ = false;
TabItem.prototype = {
	getView: function(navigator) {
		var view = this.viewInstance;
		if(view == null && this.viewClass != null) {
			view = (Type().default).createInstance(this.viewClass,[]);
		}
		if(view == null && this.viewFunction != null) {
			view = this.viewFunction();
		}
		return view;
	},
	returnView: function(view) {
	}
};
TabItem.prototype.__class__ = TabItem.prototype.constructor = $hxClasses["feathers.controls.navigators.TabItem"] = TabItem;

// Init



// Statics

TabItem.withClass = function(text,viewClass) {
	var item = new TabItem();
	item.text = text;
	item.viewClass = viewClass;
	return item;
}
TabItem.withFunction = function(text,viewFunction) {
	var item = new TabItem();
	item.text = text;
	item.viewFunction = viewFunction;
	return item;
}
TabItem.withDisplayObject = function(text,viewInstance) {
	var item = new TabItem();
	item.text = text;
	item.viewInstance = viewInstance;
	return item;
}
TabItem.internalIDCounter = 0

// Export

exports["default"] = TabItem;

/***/ }),

/***/ "./lib/_gen/feathers/controls/navigators/TabNavigator.js":
/*!***************************************************************!*\
  !*** ./lib/_gen/feathers/controls/navigators/TabNavigator.js ***!
  \***************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.navigators.TabNavigator

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IDataSelector() {return __webpack_require__(/*! ./../../../feathers/core/IDataSelector */ "./lib/_gen/feathers/core/IDataSelector.js");}
function feathers_core_IIndexSelector() {return __webpack_require__(/*! ./../../../feathers/core/IIndexSelector */ "./lib/_gen/feathers/core/IIndexSelector.js");}
function feathers_controls_navigators_BaseNavigator() {return __webpack_require__(/*! ./../../../feathers/controls/navigators/BaseNavigator */ "./lib/_gen/feathers/controls/navigators/BaseNavigator.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_utils_EdgePuller() {return __webpack_require__(/*! ./../../../feathers/utils/EdgePuller */ "./lib/_gen/feathers/utils/EdgePuller.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}
function feathers_themes_steel_components_SteelTabNavigatorStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelTabNavigatorStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTabNavigatorStyles.js");}
function feathers_layout_AutoSizeMode() {return __webpack_require__(/*! ./../../../feathers/layout/AutoSizeMode */ "./lib/_gen/feathers/layout/AutoSizeMode.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function Std() {return __webpack_require__(/*! ./../../../Std */ "./lib/_gen/Std.js");}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_controls_navigators_TabItem() {return __webpack_require__(/*! ./../../../feathers/controls/navigators/TabItem */ "./lib/_gen/feathers/controls/navigators/TabItem.js");}
function feathers_motion_effects_EventToPositionEffectContext() {return __webpack_require__(/*! ./../../../feathers/motion/effects/EventToPositionEffectContext */ "./lib/_gen/feathers/motion/effects/EventToPositionEffectContext.js");}
function feathers_utils_ExclusivePointer() {return __webpack_require__(/*! ./../../../feathers/utils/ExclusivePointer */ "./lib/_gen/feathers/utils/ExclusivePointer.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function feathers_utils_DisplayObjectFactory() {return __webpack_require__(/*! ./../../../feathers/utils/DisplayObjectFactory */ "./lib/_gen/feathers/utils/DisplayObjectFactory.js");}
function feathers_controls_TabBar() {return __webpack_require__(/*! ./../../../feathers/controls/TabBar */ "./lib/_gen/feathers/controls/TabBar.js");}
function feathers_controls_LayoutGroup() {return __webpack_require__(/*! ./../../../feathers/controls/LayoutGroup */ "./lib/_gen/feathers/controls/LayoutGroup.js");}

// Constructor

var TabNavigator = function(dataProvider) {
	this.__customTabBarVariant = null;
	this.__gap = 0.0;
	this.__nextTransition = null;
	this.__previousTransition = null;
	this.__tabBarPosition = (feathers_layout_RelativePosition().default).BOTTOM;
	this._ignoreSelectionChange = false;
	this._previousCustomTabBarVariant = null;
	this._simulateTouch = false;
	this._swipeEnabled = false;
	this._selectedItem = null;
	this._selectedIndex = -1;
	this._activeItemIndex = -1;
	this.initializeTabNavigatorTheme();
	(feathers_controls_navigators_BaseNavigator().default).call(this);
	this.set_dataProvider(dataProvider);
	this._viewsContainer = new (feathers_controls_LayoutGroup().default)();
	this.addChild(this._viewsContainer);
}

// Meta

TabNavigator.__name__ = "feathers.controls.navigators.TabNavigator";
TabNavigator.__isInterface__ = false;
TabNavigator.__interfaces__ = [(feathers_core_IDataSelector().default),(feathers_core_IIndexSelector().default)];
TabNavigator.__super__ = (feathers_controls_navigators_BaseNavigator().default);
TabNavigator.prototype = $extend((feathers_controls_navigators_BaseNavigator().default).prototype, {
	get_dataProvider: function() {
		return this._dataProvider;
	},
	set_dataProvider: function(value) {
		if(this._dataProvider == value) {
			return this._dataProvider;
		}
		if(this._dataProvider != null) {
			this._dataProvider.removeEventListener("addItem",$bind(this,this.tabNavigator_dataProvider_addItemHandler));
			this._dataProvider.removeEventListener("removeItem",$bind(this,this.tabNavigator_dataProvider_removeItemHandler));
			this._dataProvider.removeEventListener("replaceItem",$bind(this,this.tabNavigator_dataProvider_replaceItemHandler));
			this._dataProvider.removeEventListener("removeAll",$bind(this,this.tabNavigator_dataProvider_removeAllHandler));
			this._dataProvider.removeEventListener("reset",$bind(this,this.tabNavigator_dataProvider_resetHandler));
			var item = this._dataProvider.iterator();
			while(item.hasNext()) {
				var item1 = item.next();
				this.removeItemInternal(item1.internalID);
			}
		}
		this._dataProvider = value;
		if(this._dataProvider != null) {
			var item2 = this._dataProvider.iterator();
			while(item2.hasNext()) {
				var item3 = item2.next();
				this.addItemInternal(item3.internalID,item3);
			}
			this._dataProvider.addEventListener("addItem",$bind(this,this.tabNavigator_dataProvider_addItemHandler),false,0,true);
			this._dataProvider.addEventListener("removeItem",$bind(this,this.tabNavigator_dataProvider_removeItemHandler),false,0,true);
			this._dataProvider.addEventListener("replaceItem",$bind(this,this.tabNavigator_dataProvider_replaceItemHandler),false,0,true);
			this._dataProvider.addEventListener("removeAll",$bind(this,this.tabNavigator_dataProvider_removeAllHandler),false,0,true);
			this._dataProvider.addEventListener("reset",$bind(this,this.tabNavigator_dataProvider_resetHandler),false,0,true);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		if(this._dataProvider == null || this._dataProvider.get_length() == 0) {
			this.set_selectedIndex(-1);
		} else {
			this.set_selectedIndex(0);
		}
		return this._dataProvider;
	},
	get_selectedIndex: function() {
		return this._selectedIndex;
	},
	set_selectedIndex: function(value) {
		if(this._dataProvider == null) {
			value = -1;
		}
		if(this._selectedIndex == value) {
			return this._selectedIndex;
		}
		this._selectedIndex = value;
		if(this._selectedIndex == -1) {
			this._selectedItem = null;
		} else {
			this._selectedItem = this._dataProvider.get(this._selectedIndex);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		return this._selectedIndex;
	},
	get_maxSelectedIndex: function() {
		if(this._dataProvider == null) {
			return -1;
		}
		return this._dataProvider.get_length() - 1;
	},
	get_selectedItem: function() {
		return this._selectedItem;
	},
	set_selectedItem: function(value) {
		if(this._dataProvider == null) {
			this.set_selectedIndex(-1);
			return this._selectedItem;
		}
		this.set_selectedIndex(this._dataProvider.indexOf(value));
		return this._selectedItem;
	},
	get_swipeEnabled: function() {
		return this._swipeEnabled;
	},
	set_swipeEnabled: function(value) {
		if(this._swipeEnabled == value) {
			return this._swipeEnabled;
		}
		this._swipeEnabled = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._swipeEnabled;
	},
	get_simulateTouch: function() {
		return this._simulateTouch;
	},
	set_simulateTouch: function(value) {
		if(this._simulateTouch == value) {
			return this._simulateTouch;
		}
		this._simulateTouch = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._simulateTouch;
	},
	get_tabBarFactory: function() {
		return this._tabBarFactory;
	},
	set_tabBarFactory: function(value) {
		if(this._tabBarFactory == value) {
			return this._tabBarFactory;
		}
		this._tabBarFactory = value;
		this.setInvalid(TabNavigator.INVALIDATION_FLAG_TAB_BAR_FACTORY);
		return this._tabBarFactory;
	},
	initialize: function() {
		(feathers_controls_navigators_BaseNavigator().default).prototype.initialize.call(this);
		if(this._previousEdgePuller == null) {
			this._previousEdgePuller = new (feathers_utils_EdgePuller().default)(this,(feathers_layout_RelativePosition().default).LEFT);
			this._previousEdgePuller.addEventListener("opening",$bind(this,this.tabNavigator_previousEdgePuller_openingHandler));
			this._previousEdgePuller.addEventListener("cancel",$bind(this,this.tabNavigator_previousEdgePuller_cancelHandler));
			this._previousEdgePuller.addEventListener("open",$bind(this,this.tabNavigator_previousEdgePuller_openHandler));
		}
		if(this._nextEdgePuller == null) {
			this._nextEdgePuller = new (feathers_utils_EdgePuller().default)(this,(feathers_layout_RelativePosition().default).RIGHT);
			this._nextEdgePuller.addEventListener("opening",$bind(this,this.tabNavigator_nextEdgePuller_openingHandler));
			this._nextEdgePuller.addEventListener("cancel",$bind(this,this.tabNavigator_nextEdgePuller_cancelHandler));
			this._nextEdgePuller.addEventListener("open",$bind(this,this.tabNavigator_nextEdgePuller_openHandler));
		}
	},
	itemToText: function(item) {
		return item.text;
	},
	initializeTabNavigatorTheme: function() {
		(feathers_themes_steel_components_SteelTabNavigatorStyles().default).initialize();
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var selectionInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		if(this._previousCustomTabBarVariant != this.get_customTabBarVariant()) {
			this.setInvalidationFlag(TabNavigator.INVALIDATION_FLAG_TAB_BAR_FACTORY);
		}
		var tabBarInvalid = this.isInvalid(TabNavigator.INVALIDATION_FLAG_TAB_BAR_FACTORY);
		if(tabBarInvalid) {
			this.createTabBar();
		}
		if(dataInvalid || tabBarInvalid) {
			this.tabBar.itemToText = $bind(this,this.itemToText);
			var oldIgnoreSelectionChange = this._ignoreSelectionChange;
			this._ignoreSelectionChange = true;
			this.tabBar.set_dataProvider(this._dataProvider);
			this._ignoreSelectionChange = oldIgnoreSelectionChange;
		}
		if(dataInvalid) {
			this._previousEdgePuller.simulateTouch = this._simulateTouch;
			this._nextEdgePuller.simulateTouch = this._simulateTouch;
		}
		if(dataInvalid || selectionInvalid || tabBarInvalid) {
			this.refreshSelection();
		}
		(feathers_controls_navigators_BaseNavigator().default).prototype.update.call(this);
		this._previousCustomTabBarVariant = this.get_customTabBarVariant();
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		var needsToMeasureContent = this._autoSizeMode == (feathers_layout_AutoSizeMode().default).CONTENT || this.stage == null;
		if(needsToMeasureContent) {
			if(this.get_explicitWidth() != null) {
				this.tabBar.set_width(this.get_explicitWidth());
			} else {
				this.tabBar.resetWidth();
			}
			this.tabBar.validateNow();
			switch(this.get_tabBarPosition()._hx_index) {
			case 0:
				this.topContentOffset = this.tabBar.get_height() + this.get_gap();
				break;
			case 2:
				this.bottomContentOffset = this.tabBar.get_height() + this.get_gap();
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Invalid tabBarPosition " + (Std().default).string(this.get_tabBarPosition())));
			}
		}
		return (feathers_controls_navigators_BaseNavigator().default).prototype.measure.call(this);
	},
	createTabBar: function() {
		if(this.tabBar != null) {
			this.tabBar.removeEventListener("itemTrigger",$bind(this,this.tabNavigator_tabBar_itemTriggerHandler));
			this.tabBar.removeEventListener("change",$bind(this,this.tabNavigator_tabBar_changeHandler));
			this.removeChild(this.tabBar);
			if(this._oldTabBarFactory.destroy != null) {
				this._oldTabBarFactory.destroy(this.tabBar);
			}
			this._oldTabBarFactory = null;
			this.tabBar = null;
		}
		var factory = this._tabBarFactory != null ? this._tabBarFactory : TabNavigator.defaultTabBarFactory;
		this._oldTabBarFactory = factory;
		this.tabBar = factory.create();
		if(this.tabBar.get_variant() == null) {
			this.tabBar.set_variant(this.get_customTabBarVariant() != null ? this.get_customTabBarVariant() : TabNavigator.CHILD_VARIANT_TAB_BAR);
		}
		this.tabBar.addEventListener("itemTrigger",$bind(this,this.tabNavigator_tabBar_itemTriggerHandler));
		this.tabBar.addEventListener("change",$bind(this,this.tabNavigator_tabBar_changeHandler));
		this.addChild(this.tabBar);
	},
	layoutContent: function() {
		this.tabBar.set_x(0.0);
		this.tabBar.set_width(this.actualWidth);
		this.tabBar.validateNow();
		switch(this.get_tabBarPosition()._hx_index) {
		case 0:
			this.tabBar.set_y(0.0);
			break;
		case 2:
			this.tabBar.set_y(this.actualHeight - this.tabBar.get_height());
			break;
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Invalid tabBarPosition " + (Std().default).string(this.get_tabBarPosition())));
		}
		this._viewsContainer.set_x(0.0);
		switch(this.get_tabBarPosition()._hx_index) {
		case 0:
			this._viewsContainer.set_y(this.tabBar.get_height() + this.get_gap());
			break;
		case 2:
			this._viewsContainer.set_y(0.0);
			break;
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Invalid tabBarPosition " + (Std().default).string(this.get_tabBarPosition())));
		}
		this._viewsContainer.set_width(this.actualWidth);
		this._viewsContainer.set_height(this.actualHeight - this.tabBar.get_height() - this.get_gap());
		if(this._activeItemView != null) {
			this._activeItemView.set_x(0.0);
			this._activeItemView.set_y(0.0);
			this._activeItemView.set_width(this._viewsContainer.get_width());
			this._activeItemView.set_height(this._viewsContainer.get_height());
		}
		if(this._nextViewInTransition != null) {
			this._nextViewInTransition.set_x(0.0);
			this._nextViewInTransition.set_y(0.0);
			this._nextViewInTransition.set_width(this._viewsContainer.get_width());
			this._nextViewInTransition.set_height(this._viewsContainer.get_height());
		}
		if((js_Boot().default).__implements(this._viewsContainer,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._viewsContainer , (feathers_core_IValidating().default))).validateNow();
		}
	},
	getView: function(id) {
		var item = (js_Boot().default).__cast(this._addedItems.get(id) , (feathers_controls_navigators_TabItem().default));
		return item.getView(this);
	},
	disposeView: function(id,view) {
		var item = (js_Boot().default).__cast(this._addedItems.get(id) , (feathers_controls_navigators_TabItem().default));
		item.returnView(view);
	},
	refreshSelection: function() {
		var _gthis = this;
		var oldIgnoreSelectionChange = this._ignoreSelectionChange;
		this._ignoreSelectionChange = true;
		this.tabBar.set_selectedIndex(this._selectedIndex);
		this._ignoreSelectionChange = oldIgnoreSelectionChange;
		if(this._selectedItem == null) {
			this._activeItemIndex = -1;
			if(this.get_activeItemID() != null) {
				this.clearActiveItemInternal();
			}
		} else if(this._selectedItem != null) {
			var oldIndex = this._activeItemIndex;
			this._activeItemIndex = this._selectedIndex;
			if(!this._previousEdgePuller.get_active() && !this._nextEdgePuller.get_active()) {
				var activeID = this._transitionActive ? this._nextViewInTransitionID : this._activeItemID;
				if(activeID != this._selectedItem.internalID) {
					var transition = null;
					if(oldIndex != -1 && oldIndex != this._selectedIndex) {
						transition = oldIndex < this._selectedIndex ? this.get_nextTransition() : this.get_previousTransition();
					}
					this.runWithInvalidationFlagsOnly(function() {
						return _gthis.showItemInternal(_gthis._selectedItem.internalID,transition);
					});
				}
			}
		}
		var tmp = this._enabled && this._swipeEnabled && this._selectedIndex > 0 && !this._nextEdgePuller.get_active();
		this._previousEdgePuller.enabled = tmp;
		var tmp1 = this._enabled && this._swipeEnabled && this._selectedIndex < this.get_maxSelectedIndex() && !this._previousEdgePuller.get_active();
		this._nextEdgePuller.enabled = tmp1;
	},
	startPreviousDragTransition: function(one,two) {
		var _gthis = this;
		var effectContext = (this.get_previousTransition())(one,two);
		this._previousEdgePuller.set_snapDuration(effectContext.get_duration());
		this._dragTransitionContext = new (feathers_motion_effects_EventToPositionEffectContext())(effectContext,this._previousEdgePuller,"change",function(event) {
			return _gthis._dragTransitionContext.set_position(_gthis._previousEdgePuller.get_pullDistance() / _gthis.actualWidth);
		});
		return this._dragTransitionContext;
	},
	startNextDragTransition: function(one,two) {
		var _gthis = this;
		var effectContext = (this.get_nextTransition())(one,two);
		this._nextEdgePuller.set_snapDuration(effectContext.get_duration());
		this._dragTransitionContext = new (feathers_motion_effects_EventToPositionEffectContext())(effectContext,this._nextEdgePuller,"change",function(event) {
			return _gthis._dragTransitionContext.set_position(_gthis._nextEdgePuller.get_pullDistance() / _gthis.actualWidth);
		});
		return this._dragTransitionContext;
	},
	tabNavigator_tabBar_changeHandler: function(event) {
		if(this._ignoreSelectionChange) {
			return;
		}
		this.set_selectedIndex(this.tabBar.get_selectedIndex());
	},
	tabNavigator_tabBar_itemTriggerHandler: function(event) {
		this.dispatchEvent(event);
	},
	tabNavigator_dataProvider_addItemHandler: function(event) {
		var item = (js_Boot().default).__cast(event.addedItem , (feathers_controls_navigators_TabItem().default));
		this.addItemInternal(item.internalID,item);
		if(this._selectedIndex >= event.index) {
			var _g = this;
			_g.set_selectedIndex(_g.get_selectedIndex() + 1);
		} else if(this._selectedIndex == -1) {
			this.set_selectedIndex(0);
		}
	},
	tabNavigator_dataProvider_removeItemHandler: function(event) {
		var item = (js_Boot().default).__cast(event.removedItem , (feathers_controls_navigators_TabItem().default));
		this.removeItemInternal(item.internalID);
		if(this._dataProvider.get_length() == 0) {
			this.set_selectedIndex(-1);
		} else if(this._selectedIndex >= event.index) {
			var _g = this;
			_g.set_selectedIndex(_g.get_selectedIndex() - 1);
		}
	},
	tabNavigator_dataProvider_replaceItemHandler: function(event) {
		var addedItem = (js_Boot().default).__cast(event.addedItem , (feathers_controls_navigators_TabItem().default));
		var removedItem = (js_Boot().default).__cast(event.removedItem , (feathers_controls_navigators_TabItem().default));
		this.removeItemInternal(removedItem.internalID);
		this.addItemInternal(addedItem.internalID,addedItem);
		if(this._selectedIndex == event.index) {
			this.set_selectedItem(this._dataProvider.get(this._selectedIndex));
		}
	},
	tabNavigator_dataProvider_removeAllHandler: function(event) {
		this.set_selectedIndex(-1);
		var id = this._addedItems.keys();
		while(id.hasNext()) {
			var id1 = id.next();
			var item = this._addedItems.get(id1);
			this.removeItemInternal(item.internalID);
		}
	},
	tabNavigator_dataProvider_resetHandler: function(event) {
		this.set_selectedIndex(-1);
		var id = this._addedItems.keys();
		while(id.hasNext()) {
			var id1 = id.next();
			var item = this._addedItems.get(id1);
			this.removeItemInternal(item.internalID);
		}
	},
	tabNavigator_previousEdgePuller_openingHandler: function(event) {
		var newIndex = this._selectedIndex - 1;
		if(newIndex < 0) {
			event.preventDefault();
			return;
		}
		var touchPointID = this._previousEdgePuller.get_touchPointID();
		if(touchPointID != null) {
			var exclusivePointer = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
			if(this._previousEdgePuller.get_touchPointIsSimulated()) {
				var result = exclusivePointer.claimMouse(this);
				if(!result) {
					event.preventDefault();
					return;
				}
			} else {
				var result1 = exclusivePointer.claimTouch(touchPointID,this);
				if(!result1) {
					event.preventDefault();
					return;
				}
			}
		}
		if(this.get_previousTransition() != null) {
			this._nextEdgePuller.enabled = false;
			var item = this._dataProvider.get(newIndex);
			this.showItemInternal(item.internalID,$bind(this,this.startPreviousDragTransition));
		} else {
			event.preventDefault();
			this.set_selectedIndex(newIndex);
		}
	},
	tabNavigator_previousEdgePuller_cancelHandler: function(event) {
		this._previousEdgePuller.enabled = this._enabled && this._swipeEnabled && this._selectedIndex > 0;
		var tmp = this._enabled && this._swipeEnabled && this._selectedIndex < this.get_maxSelectedIndex();
		this._nextEdgePuller.enabled = tmp;
		var context = this._dragTransitionContext;
		this._dragTransitionContext = null;
		if(context != null) {
			context.set_dispatcher(null);
			(feathers_events_FeathersEvent().default).dispatch(context,"cancel");
		}
	},
	tabNavigator_previousEdgePuller_openHandler: function(event) {
		var oldSnapDuration = this._previousEdgePuller.get_snapDuration();
		this._previousEdgePuller.set_snapDuration(0.0);
		this._previousEdgePuller.set_opened(false);
		this._previousEdgePuller.set_snapDuration(oldSnapDuration);
		var _g = this;
		_g.set_selectedIndex(_g.get_selectedIndex() - 1);
		this._previousEdgePuller.enabled = this._enabled && this._swipeEnabled && this._selectedIndex > 0;
		var tmp = this._enabled && this._swipeEnabled && this._selectedIndex < this.get_maxSelectedIndex();
		this._nextEdgePuller.enabled = tmp;
		var context = this._dragTransitionContext;
		this._dragTransitionContext = null;
		if(context != null) {
			context.set_dispatcher(null);
			(feathers_events_FeathersEvent().default).dispatch(context,"complete");
		}
	},
	tabNavigator_nextEdgePuller_openingHandler: function(event) {
		var newIndex = this._selectedIndex + 1;
		if(newIndex > this.get_maxSelectedIndex()) {
			event.preventDefault();
			return;
		}
		var touchPointID = this._nextEdgePuller.get_touchPointID();
		if(touchPointID != null) {
			var exclusivePointer = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
			if(this._nextEdgePuller.get_touchPointIsSimulated()) {
				var result = exclusivePointer.claimMouse(this);
				if(!result) {
					event.preventDefault();
					return;
				}
			} else {
				var result1 = exclusivePointer.claimTouch(touchPointID,this);
				if(!result1) {
					event.preventDefault();
					return;
				}
			}
		}
		if(this.get_nextTransition() != null) {
			this._previousEdgePuller.enabled = false;
			var item = this._dataProvider.get(newIndex);
			this.showItemInternal(item.internalID,$bind(this,this.startNextDragTransition));
		} else {
			event.preventDefault();
			this.set_selectedIndex(newIndex);
		}
	},
	tabNavigator_nextEdgePuller_cancelHandler: function(event) {
		this._previousEdgePuller.enabled = this._enabled && this._swipeEnabled && this._selectedIndex > 0;
		var tmp = this._enabled && this._swipeEnabled && this._selectedIndex < this.get_maxSelectedIndex();
		this._nextEdgePuller.enabled = tmp;
		var context = this._dragTransitionContext;
		this._dragTransitionContext = null;
		if(context != null) {
			context.set_dispatcher(null);
			(feathers_events_FeathersEvent().default).dispatch(context,"cancel");
		}
	},
	tabNavigator_nextEdgePuller_openHandler: function(event) {
		var oldSnapDuration = this._nextEdgePuller.get_snapDuration();
		this._nextEdgePuller.set_snapDuration(0.0);
		this._nextEdgePuller.set_opened(false);
		this._nextEdgePuller.set_snapDuration(oldSnapDuration);
		var _g = this;
		_g.set_selectedIndex(_g.get_selectedIndex() + 1);
		this._previousEdgePuller.enabled = this._enabled && this._swipeEnabled && this._selectedIndex > 0;
		var tmp = this._enabled && this._swipeEnabled && this._selectedIndex < this.get_maxSelectedIndex();
		this._nextEdgePuller.enabled = tmp;
		var context = this._dragTransitionContext;
		this._dragTransitionContext = null;
		if(context != null) {
			context.set_dispatcher(null);
			(feathers_events_FeathersEvent().default).dispatch(context,"complete");
		}
	},
	get_styleContext: function() {
		return TabNavigator
	},
	get_tabBarPosition: function() {
		return this.__tabBarPosition;
	},
	set_tabBarPosition: function(value) {
		if(!this.setStyle("tabBarPosition")) {
			return this.__tabBarPosition;
		}
		if(this.__tabBarPosition == value) {
			return this.__tabBarPosition;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_tabBarPosition);
		this.__tabBarPosition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__tabBarPosition;
	},
	clearStyle_tabBarPosition: function() {
		this.set_tabBarPosition((feathers_layout_RelativePosition().default).BOTTOM);
		return this.get_tabBarPosition();
	},
	get_previousTransition: function() {
		return this.__previousTransition;
	},
	set_previousTransition: function(value) {
		if(!this.setStyle("previousTransition")) {
			return this.__previousTransition;
		}
		if(this.__previousTransition == value) {
			return this.__previousTransition;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_previousTransition);
		this.__previousTransition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__previousTransition;
	},
	clearStyle_previousTransition: function() {
		this.set_previousTransition(null);
		return this.get_previousTransition();
	},
	get_nextTransition: function() {
		return this.__nextTransition;
	},
	set_nextTransition: function(value) {
		if(!this.setStyle("nextTransition")) {
			return this.__nextTransition;
		}
		if(this.__nextTransition == value) {
			return this.__nextTransition;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_nextTransition);
		this.__nextTransition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__nextTransition;
	},
	clearStyle_nextTransition: function() {
		this.set_nextTransition(null);
		return this.get_nextTransition();
	},
	get_gap: function() {
		return this.__gap;
	},
	set_gap: function(value) {
		if(!this.setStyle("gap")) {
			return this.__gap;
		}
		if(this.__gap == value) {
			return this.__gap;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_gap);
		this.__gap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__gap;
	},
	clearStyle_gap: function() {
		this.set_gap(0.0);
		return this.get_gap();
	},
	get_customTabBarVariant: function() {
		return this.__customTabBarVariant;
	},
	set_customTabBarVariant: function(value) {
		if(!this.setStyle("customTabBarVariant")) {
			return this.__customTabBarVariant;
		}
		if(this.__customTabBarVariant == value) {
			return this.__customTabBarVariant;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_customTabBarVariant);
		this.__customTabBarVariant = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__customTabBarVariant;
	},
	clearStyle_customTabBarVariant: function() {
		this.set_customTabBarVariant(null);
		return this.get_customTabBarVariant();
	}
});
TabNavigator.prototype.__class__ = TabNavigator.prototype.constructor = $hxClasses["feathers.controls.navigators.TabNavigator"] = TabNavigator;

// Init



// Statics


TabNavigator.__meta__ = { obj : { defaultXmlProperty : ["dataProvider"]}}
TabNavigator.INVALIDATION_FLAG_TAB_BAR_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("tabBarFactory")
TabNavigator.CHILD_VARIANT_TAB_BAR = "tabNavigator_tabBar"
TabNavigator.defaultTabBarFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_TabBar().default))

// Export

exports["default"] = TabNavigator;

/***/ }),

/***/ "./lib/_gen/feathers/controls/navigators/_Route/ViewListener.js":
/*!**********************************************************************!*\
  !*** ./lib/_gen/feathers/controls/navigators/_Route/ViewListener.js ***!
  \**********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.navigators._Route.ViewListener

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var ViewListener = function(eventType,listener) {
	this.eventType = eventType;
	this.listener = listener;
}

// Meta

ViewListener.__name__ = "feathers.controls.navigators._Route.ViewListener";
ViewListener.__isInterface__ = false;
ViewListener.prototype = {
	
};
ViewListener.prototype.__class__ = ViewListener.prototype.constructor = $hxClasses["feathers.controls.navigators._Route.ViewListener"] = ViewListener;

// Init



// Statics




// Export

exports["default"] = ViewListener;

/***/ }),

/***/ "./lib/_gen/feathers/controls/navigators/_StackItem/ViewListener.js":
/*!**************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/navigators/_StackItem/ViewListener.js ***!
  \**************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.navigators._StackItem.ViewListener

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var ViewListener = function(eventType,listener) {
	this.eventType = eventType;
	this.listener = listener;
}

// Meta

ViewListener.__name__ = "feathers.controls.navigators._StackItem.ViewListener";
ViewListener.__isInterface__ = false;
ViewListener.prototype = {
	
};
ViewListener.prototype.__class__ = ViewListener.prototype.constructor = $hxClasses["feathers.controls.navigators._StackItem.ViewListener"] = ViewListener;

// Init



// Statics




// Export

exports["default"] = ViewListener;

/***/ }),

/***/ "./lib/_gen/feathers/controls/navigators/_StackNavigator/HistoryItem.js":
/*!******************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/navigators/_StackNavigator/HistoryItem.js ***!
  \******************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.navigators._StackNavigator.HistoryItem

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var HistoryItem = function(id,inject,viewData,transition) {
	this.id = id;
	this.inject = inject;
	this.viewData = viewData;
	this.transition = transition;
}

// Meta

HistoryItem.__name__ = "feathers.controls.navigators._StackNavigator.HistoryItem";
HistoryItem.__isInterface__ = false;
HistoryItem.prototype = {
	
};
HistoryItem.prototype.__class__ = HistoryItem.prototype.constructor = $hxClasses["feathers.controls.navigators._StackNavigator.HistoryItem"] = HistoryItem;

// Init



// Statics




// Export

exports["default"] = HistoryItem;

/***/ }),

/***/ "./lib/_gen/feathers/controls/popups/CalloutPopUpAdapter.js":
/*!******************************************************************!*\
  !*** ./lib/_gen/feathers/controls/popups/CalloutPopUpAdapter.js ***!
  \******************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.popups.CalloutPopUpAdapter

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_popups_IPopUpAdapter() {return __webpack_require__(/*! ./../../../feathers/controls/popups/IPopUpAdapter */ "./lib/_gen/feathers/controls/popups/IPopUpAdapter.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function feathers_controls_Callout() {return __webpack_require__(/*! ./../../../feathers/controls/Callout */ "./lib/_gen/feathers/controls/Callout.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function feathers_core_PopUpManager() {return __webpack_require__(/*! ./../../../feathers/core/PopUpManager */ "./lib/_gen/feathers/core/PopUpManager.js");}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}

// Constructor

var CalloutPopUpAdapter = function() {
	this._contentMeasurements = new (feathers_layout_Measurements().default)();
	this._fitContentToOriginWidth = false;
	this.modal = false;
	this.callout = null;
	this.origin = null;
	this.content = null;
	(openfl_events_EventDispatcher()).call(this);
}

// Meta

CalloutPopUpAdapter.__name__ = "feathers.controls.popups.CalloutPopUpAdapter";
CalloutPopUpAdapter.__isInterface__ = false;
CalloutPopUpAdapter.__interfaces__ = [(feathers_controls_popups_IPopUpAdapter().default)];
CalloutPopUpAdapter.__super__ = (openfl_events_EventDispatcher());
CalloutPopUpAdapter.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_active: function() {
		return this.content != null;
	},
	get_fitContentToOriginWidth: function() {
		return this._fitContentToOriginWidth;
	},
	set_fitContentToOriginWidth: function(value) {
		if(this._fitContentToOriginWidth == value) {
			return this._fitContentToOriginWidth;
		}
		this._fitContentToOriginWidth = value;
		if(this.get_active()) {
			this.layout();
		}
		return this._fitContentToOriginWidth;
	},
	get_persistent: function() {
		return false;
	},
	open: function(content,origin) {
		if(this.get_active()) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Pop-up adapter is already open. Close the previous content before opening new content."));
		}
		if(origin.stage == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Pop-up adapter failed to open because the origin is not added to the stage."));
		}
		this.content = content;
		this.origin = origin;
		this.callout = (feathers_controls_Callout().default).show(this.content,this.origin,null,this.modal);
		this.callout.closeOnPointerOutside = false;
		if(!this.get_active()) {
			return;
		}
		this._contentMeasurements.save(this.content);
		this.layout();
		(feathers_events_FeathersEvent().default).dispatch(this,"open");
	},
	close: function() {
		if(!this.get_active()) {
			return;
		}
		var content = this.content;
		var callout = this.callout;
		this.callout.set_content(null);
		this.origin = null;
		this.content = null;
		this.callout = null;
		callout.close();
		this._contentMeasurements.restore(content);
		(feathers_events_FeathersEvent().default).dispatch(this,"close");
	},
	layout: function() {
		var popUpRoot = (feathers_core_PopUpManager().default).forStage(this.origin.stage).get_root();
		var originTopLeft = new (openfl_geom_Point())(this.origin.get_x(),this.origin.get_y());
		originTopLeft = this.origin.parent.localToGlobal(originTopLeft);
		originTopLeft = popUpRoot.globalToLocal(originTopLeft);
		var originBottomRight = new (openfl_geom_Point())(this.origin.get_x() + this.origin.get_width(),this.origin.get_y() + this.origin.get_height());
		originBottomRight = this.origin.parent.localToGlobal(originBottomRight);
		originBottomRight = popUpRoot.globalToLocal(originBottomRight);
		var originWidth = Math.max(0.0,originBottomRight.x - originTopLeft.x);
		var hasSetMinWidth = false;
		if(this._fitContentToOriginWidth && this.callout.get_minWidth() < originWidth) {
			this.callout.set_minWidth(originWidth);
			hasSetMinWidth = true;
		}
		if((js_Boot().default).__implements(this.callout,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this.callout , (feathers_core_IValidating().default))).validateNow();
		}
		if(this._fitContentToOriginWidth && !hasSetMinWidth && this.content.get_width() < originWidth) {
			this.callout.set_width(originWidth);
		}
	}
});
CalloutPopUpAdapter.prototype.__class__ = CalloutPopUpAdapter.prototype.constructor = $hxClasses["feathers.controls.popups.CalloutPopUpAdapter"] = CalloutPopUpAdapter;

// Init



// Statics




// Export

exports["default"] = CalloutPopUpAdapter;

/***/ }),

/***/ "./lib/_gen/feathers/controls/popups/DropDownPopUpAdapter.js":
/*!*******************************************************************!*\
  !*** ./lib/_gen/feathers/controls/popups/DropDownPopUpAdapter.js ***!
  \*******************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.popups.DropDownPopUpAdapter

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_popups_IPopUpAdapter() {return __webpack_require__(/*! ./../../../feathers/controls/popups/IPopUpAdapter */ "./lib/_gen/feathers/controls/popups/IPopUpAdapter.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function feathers_core_PopUpManager() {return __webpack_require__(/*! ./../../../feathers/core/PopUpManager */ "./lib/_gen/feathers/core/PopUpManager.js");}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function openfl_display_Stage() {return (__webpack_require__(/*! openfl */ "openfl").display.Stage);}
function feathers_core_ValidationQueue() {return __webpack_require__(/*! ./../../../feathers/core/ValidationQueue */ "./lib/_gen/feathers/core/ValidationQueue.js");}
function openfl_display_DisplayObject() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObject);}
function openfl_display_DisplayObjectContainer() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObjectContainer);}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}

// Constructor

var DropDownPopUpAdapter = function() {
	this._ignoreOriginResizing = false;
	this._ignoreContentResizing = false;
	this._contentMeasurements = new (feathers_layout_Measurements().default)();
	this.closeOnPointerActiveOutside = false;
	this._fitContentToOriginWidth = true;
	this.modal = false;
	this._gap = 0.0;
	this.origin = null;
	this.content = null;
	(openfl_events_EventDispatcher()).call(this);
}

// Meta

DropDownPopUpAdapter.__name__ = "feathers.controls.popups.DropDownPopUpAdapter";
DropDownPopUpAdapter.__isInterface__ = false;
DropDownPopUpAdapter.__interfaces__ = [(feathers_controls_popups_IPopUpAdapter().default)];
DropDownPopUpAdapter.__super__ = (openfl_events_EventDispatcher());
DropDownPopUpAdapter.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_active: function() {
		return this.content != null;
	},
	get_gap: function() {
		return this._gap;
	},
	set_gap: function(value) {
		if(this._gap == value) {
			return this._gap;
		}
		this._gap = value;
		if(this.get_active()) {
			this.layout();
		}
		return this._gap;
	},
	get_fitContentToOriginWidth: function() {
		return this._fitContentToOriginWidth;
	},
	set_fitContentToOriginWidth: function(value) {
		if(this._fitContentToOriginWidth == value) {
			return this._fitContentToOriginWidth;
		}
		this._fitContentToOriginWidth = value;
		if(this.get_active()) {
			this.layout();
		}
		return this._fitContentToOriginWidth;
	},
	get_persistent: function() {
		return false;
	},
	open: function(content,origin) {
		if(this.get_active()) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Pop-up adapter is already open. Close the previous content before opening new content."));
		}
		if(origin.stage == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Pop-up adapter failed to open because the origin is not added to the stage."));
		}
		this._stage = origin.stage;
		this._stage.addEventListener("mouseDown",$bind(this,this.dropDownPopUpAdapter_stage_mouseDownHandler),false,0,true);
		this._stage.addEventListener("touchBegin",$bind(this,this.dropDownPopUpAdapter_stage_touchBeginHandler),false,0,true);
		this._stage.addEventListener("resize",$bind(this,this.dropDownPopUpAdapter_stage_resizeHandler),false,0,true);
		this.content = content;
		this.content.addEventListener("enterFrame",$bind(this,this.dropDownPopUpAdapter_content_enterFrameHandler),false,0,true);
		this.content.addEventListener("resize",$bind(this,this.dropDownPopUpAdapter_content_resizeHandler),false,0,true);
		this.content.addEventListener("removedFromStage",$bind(this,this.dropDownPopUpAdapter_content_removedFromStageHandler),false,0,true);
		this.origin = origin;
		this.origin.addEventListener("resize",$bind(this,this.dropDownPopUpAdapter_origin_resizeHandler),false,0,true);
		this.origin.addEventListener("removedFromStage",$bind(this,this.dropDownPopUpAdapter_origin_removedFromStageHandler),false,0,true);
		(feathers_core_PopUpManager().default).addPopUp(this.content,this.origin,this.modal,false);
		if(!this.get_active()) {
			return;
		}
		if((js_Boot().default).__implements(this.content,(feathers_core_IValidating().default))) {
			var oldIgnoreContentResizing = this._ignoreContentResizing;
			this._ignoreContentResizing = true;
			((js_Boot().default).__cast(this.content , (feathers_core_IValidating().default))).validateNow();
			this._ignoreContentResizing = oldIgnoreContentResizing;
		}
		this._contentMeasurements.save(this.content);
		this.layout();
		(feathers_events_FeathersEvent().default).dispatch(this,"open");
	},
	close: function() {
		if(!this.get_active()) {
			return;
		}
		this._stage.removeEventListener("resize",$bind(this,this.dropDownPopUpAdapter_stage_resizeHandler));
		this._stage.removeEventListener("mouseDown",$bind(this,this.dropDownPopUpAdapter_stage_mouseDownHandler));
		this._stage.addEventListener("touchBegin",$bind(this,this.dropDownPopUpAdapter_stage_touchBeginHandler));
		this.content.removeEventListener("enterFrame",$bind(this,this.dropDownPopUpAdapter_content_enterFrameHandler));
		this.content.removeEventListener("resize",$bind(this,this.dropDownPopUpAdapter_content_resizeHandler));
		this.content.removeEventListener("removedFromStage",$bind(this,this.dropDownPopUpAdapter_content_removedFromStageHandler));
		this.origin.removeEventListener("resize",$bind(this,this.dropDownPopUpAdapter_origin_resizeHandler));
		this.origin.removeEventListener("removedFromStage",$bind(this,this.dropDownPopUpAdapter_origin_removedFromStageHandler));
		var content = this.content;
		this.origin = null;
		this.content = null;
		this._stage = null;
		if(content.parent != null) {
			content.parent.removeChild(content);
		}
		this._contentMeasurements.restore(content);
		(feathers_events_FeathersEvent().default).dispatch(this,"close");
	},
	layout: function() {
		if((js_Boot().default).__implements(this.origin,(feathers_core_IValidating().default))) {
			var oldIgnoreOriginResizing = this._ignoreOriginResizing;
			this._ignoreOriginResizing = true;
			((js_Boot().default).__cast(this.origin , (feathers_core_IValidating().default))).validateNow();
			this._ignoreOriginResizing = oldIgnoreOriginResizing;
		}
		var popUpRoot = (feathers_core_PopUpManager().default).forStage(this._stage).get_root();
		var originTopLeft = new (openfl_geom_Point())(this.origin.get_x(),this.origin.get_y());
		originTopLeft = this.origin.parent.localToGlobal(originTopLeft);
		originTopLeft = popUpRoot.globalToLocal(originTopLeft);
		var originBottomRight = new (openfl_geom_Point())(this.origin.get_x() + this.origin.get_width(),this.origin.get_y() + this.origin.get_height());
		originBottomRight = this.origin.parent.localToGlobal(originBottomRight);
		originBottomRight = popUpRoot.globalToLocal(originBottomRight);
		this._prevOriginX = originTopLeft.x;
		this._prevOriginY = originTopLeft.y;
		var originWidth = Math.max(0.0,originBottomRight.x - originTopLeft.x);
		var hasSetMinWidth = false;
		if(this._fitContentToOriginWidth && (js_Boot().default).__implements(this.content,(feathers_core_IMeasureObject().default))) {
			var measureContent = (js_Boot().default).__cast(this.content , (feathers_core_IMeasureObject().default));
			if(measureContent.get_minWidth() < originWidth) {
				measureContent.set_minWidth(originWidth);
				hasSetMinWidth = true;
			}
		}
		var oldIgnoreContentResizing = this._ignoreContentResizing;
		this._ignoreContentResizing = true;
		if((js_Boot().default).__implements(this.content,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this.content , (feathers_core_IValidating().default))).validateNow();
		}
		if(this._fitContentToOriginWidth && !hasSetMinWidth && this.content.get_width() < originWidth) {
			this.content.set_width(originWidth);
		}
		this._ignoreContentResizing = oldIgnoreContentResizing;
		var stageTopLeft = popUpRoot.globalToLocal(new (openfl_geom_Point())());
		var stageBottomRight = popUpRoot.globalToLocal(new (openfl_geom_Point())(this._stage.stageWidth,this._stage.stageHeight));
		var contentX = originTopLeft.x;
		if(contentX < stageTopLeft.x) {
			contentX = stageTopLeft.x;
		} else if(contentX + this.content.get_width() > stageBottomRight.x) {
			contentX = Math.max(stageTopLeft.x,stageBottomRight.x - this.content.get_width());
		}
		this.content.set_x(contentX);
		var contentY = originBottomRight.y + this._gap;
		if(contentY + this.content.get_height() > stageBottomRight.y) {
			contentY = Math.max(stageTopLeft.y,originTopLeft.y - this._gap - this.content.get_height());
		}
		this.content.set_y(contentY);
	},
	dropDownPopUpAdapter_origin_removedFromStageHandler: function(event) {
		if(!this.get_active()) {
			return;
		}
		this.close();
	},
	dropDownPopUpAdapter_content_removedFromStageHandler: function(event) {
		if(!this.get_active()) {
			return;
		}
		this.close();
	},
	dropDownPopUpAdapter_stage_resizeHandler: function(event) {
		if(!this.get_active()) {
			return;
		}
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		(feathers_core_ValidationQueue().default).forStage(stage).validateNow();
		this.layout();
	},
	dropDownPopUpAdapter_content_resizeHandler: function(event) {
		if(!this.get_active() || this._ignoreContentResizing) {
			return;
		}
		this.layout();
	},
	dropDownPopUpAdapter_origin_resizeHandler: function(event) {
		if(!this.get_active() || this._ignoreOriginResizing) {
			return;
		}
		this.layout();
	},
	dropDownPopUpAdapter_content_enterFrameHandler: function(event) {
		if(!this.get_active()) {
			return;
		}
		var popUpRoot = (feathers_core_PopUpManager().default).forStage(this._stage).get_root();
		var originTopLeft = new (openfl_geom_Point())(this.origin.get_x(),this.origin.get_y());
		originTopLeft = this.origin.parent.localToGlobal(originTopLeft);
		originTopLeft = popUpRoot.globalToLocal(originTopLeft);
		if(originTopLeft.x != this._prevOriginX || originTopLeft.y != this._prevOriginY) {
			this.layout();
		}
	},
	dropDownPopUpAdapter_stage_mouseDownHandler: function(event) {
		if(!this.closeOnPointerActiveOutside) {
			return;
		}
		var mouseTarget = (js_Boot().default).__cast(event.target , (openfl_display_DisplayObject()));
		if(((this.content) instanceof (openfl_display_DisplayObjectContainer()))) {
			var container = (js_Boot().default).__cast(this.content , (openfl_display_DisplayObjectContainer()));
			if(container.contains(mouseTarget)) {
				return;
			}
		} else if(this.content == mouseTarget) {
			return;
		}
		if(((this.origin) instanceof (openfl_display_DisplayObjectContainer()))) {
			var container1 = (js_Boot().default).__cast(this.origin , (openfl_display_DisplayObjectContainer()));
			if(container1.contains(mouseTarget)) {
				return;
			}
		} else if(this.origin == mouseTarget) {
			return;
		}
		this.close();
	},
	dropDownPopUpAdapter_stage_touchBeginHandler: function(event) {
		if(!this.closeOnPointerActiveOutside) {
			return;
		}
		if(event.isPrimaryTouchPoint) {
			return;
		}
		var mouseTarget = (js_Boot().default).__cast(event.target , (openfl_display_DisplayObject()));
		if(((this.content) instanceof (openfl_display_DisplayObjectContainer()))) {
			var container = (js_Boot().default).__cast(this.content , (openfl_display_DisplayObjectContainer()));
			if(container.contains(mouseTarget)) {
				return;
			}
		} else if(this.content == mouseTarget) {
			return;
		}
		if(((this.origin) instanceof (openfl_display_DisplayObjectContainer()))) {
			var container1 = (js_Boot().default).__cast(this.origin , (openfl_display_DisplayObjectContainer()));
			if(container1.contains(mouseTarget)) {
				return;
			}
		} else if(this.origin == mouseTarget) {
			return;
		}
		this.close();
	}
});
DropDownPopUpAdapter.prototype.__class__ = DropDownPopUpAdapter.prototype.constructor = $hxClasses["feathers.controls.popups.DropDownPopUpAdapter"] = DropDownPopUpAdapter;

// Init



// Statics




// Export

exports["default"] = DropDownPopUpAdapter;

/***/ }),

/***/ "./lib/_gen/feathers/controls/popups/IPopUpAdapter.js":
/*!************************************************************!*\
  !*** ./lib/_gen/feathers/controls/popups/IPopUpAdapter.js ***!
  \************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.popups.IPopUpAdapter

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function openfl_events_IEventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.IEventDispatcher);}

// Constructor

var IPopUpAdapter = function() {}

// Meta

IPopUpAdapter.__name__ = "feathers.controls.popups.IPopUpAdapter";
IPopUpAdapter.__isInterface__ = true;
IPopUpAdapter.__interfaces__ = [(openfl_events_IEventDispatcher())];
IPopUpAdapter.prototype = {
	
};
IPopUpAdapter.prototype.__class__ = IPopUpAdapter.prototype.constructor = $hxClasses["feathers.controls.popups.IPopUpAdapter"] = IPopUpAdapter;

// Init



// Statics




// Export

exports["default"] = IPopUpAdapter;

/***/ }),

/***/ "./lib/_gen/feathers/controls/supportClasses/AdvancedLayoutViewPort.js":
/*!*****************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/supportClasses/AdvancedLayoutViewPort.js ***!
  \*****************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.supportClasses.AdvancedLayoutViewPort

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_supportClasses_IViewPort() {return __webpack_require__(/*! ./../../../feathers/controls/supportClasses/IViewPort */ "./lib/_gen/feathers/controls/supportClasses/IViewPort.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function Type() {return __webpack_require__(/*! ./../../../Type */ "./lib/_gen/Type.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_IScrollLayout() {return __webpack_require__(/*! ./../../../feathers/layout/IScrollLayout */ "./lib/_gen/feathers/layout/IScrollLayout.js");}
function feathers_layout_ISnapLayout() {return __webpack_require__(/*! ./../../../feathers/layout/ISnapLayout */ "./lib/_gen/feathers/layout/ISnapLayout.js");}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function openfl_display_Sprite() {return (__webpack_require__(/*! openfl */ "openfl").display.Sprite);}

// Constructor

var AdvancedLayoutViewPort = function() {
	this._layoutChanged = false;
	this._layoutActive = false;
	this._snapPositionsY = null;
	this._snapPositionsX = null;
	this._scrollY = 0.0;
	this._scrollX = 0.0;
	this._ignoreLayoutChanges = false;
	this._layoutResult = new (feathers_layout_LayoutBoundsResult().default)();
	this._layoutMeasurements = new (feathers_layout_Measurements().default)();
	this._layoutItems = [];
	this._layout = null;
	this._explicitVisibleHeight = null;
	this._actualVisibleHeight = 0.0;
	this._maxVisibleHeight = 1.0 / 0.0;
	this._actualMinVisibleHeight = 0.0;
	this._explicitVisibleWidth = null;
	this._actualVisibleWidth = 0.0;
	this._maxVisibleWidth = 1.0 / 0.0;
	this._explicitMinVisibleWidth = null;
	this._actualMinVisibleWidth = 0.0;
	(feathers_core_FeathersControl().default).call(this);
	this._viewPortBackground = new (openfl_display_Sprite())();
	this._viewPortBackground.get_graphics().beginFill(16711935,0.0);
	this._viewPortBackground.get_graphics().drawRect(0.0,0.0,1.0,1.0);
	this._viewPortBackground.get_graphics().endFill();
	this.addChildAt(this._viewPortBackground,0);
}

// Meta

AdvancedLayoutViewPort.__name__ = "feathers.controls.supportClasses.AdvancedLayoutViewPort";
AdvancedLayoutViewPort.__isInterface__ = false;
AdvancedLayoutViewPort.__interfaces__ = [(feathers_controls_supportClasses_IViewPort().default)];
AdvancedLayoutViewPort.__super__ = (feathers_core_FeathersControl().default);
AdvancedLayoutViewPort.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_minVisibleWidth: function() {
		if(this._explicitMinVisibleWidth == null) {
			return this._actualMinVisibleWidth;
		}
		return this._explicitMinVisibleWidth;
	},
	set_minVisibleWidth: function(value) {
		if(this._explicitMinVisibleWidth == value) {
			return this._explicitMinVisibleWidth;
		}
		var oldValue = this._explicitMinVisibleWidth;
		this._explicitMinVisibleWidth = value;
		if(value == null) {
			this._actualMinVisibleWidth = 0.0;
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		} else {
			this._actualMinVisibleWidth = value;
			if(this._explicitVisibleWidth == null && (this._actualVisibleWidth < value || this._actualVisibleWidth == oldValue)) {
				this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
			}
		}
		return this._explicitMinVisibleWidth;
	},
	get_maxVisibleWidth: function() {
		return this._maxVisibleWidth;
	},
	set_maxVisibleWidth: function(value) {
		if(this._maxVisibleWidth == value) {
			return this._maxVisibleWidth;
		}
		if(value == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("maxVisibleWidth cannot be null"));
		}
		var oldValue = this._maxVisibleWidth;
		this._maxVisibleWidth = value;
		if(this._explicitVisibleWidth == null && (this._actualVisibleWidth > value || this._actualVisibleWidth == oldValue)) {
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		}
		return this._maxVisibleWidth;
	},
	get_visibleWidth: function() {
		if(this._explicitVisibleWidth == null) {
			return this._actualVisibleWidth;
		}
		return this._explicitVisibleWidth;
	},
	set_visibleWidth: function(value) {
		if(this._explicitVisibleWidth == value) {
			return this._explicitVisibleWidth;
		}
		this._explicitVisibleWidth = value;
		if(this._actualVisibleWidth != value) {
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		}
		return this._explicitVisibleWidth;
	},
	get_minVisibleHeight: function() {
		if(this._explicitMinVisibleHeight == null) {
			return this._actualMinVisibleHeight;
		}
		return this._explicitMinVisibleHeight;
	},
	set_minVisibleHeight: function(value) {
		if(this._explicitMinVisibleHeight == value) {
			return this._explicitMinVisibleHeight;
		}
		var oldValue = this._explicitMinVisibleHeight;
		this._explicitMinVisibleHeight = value;
		if(value == null) {
			this._actualMinVisibleHeight = 0.0;
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		} else {
			this._actualMinVisibleHeight = value;
			if(this._explicitVisibleHeight == null && (this._actualVisibleHeight < value || this._actualVisibleHeight == oldValue)) {
				this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
			}
		}
		return this._explicitMinVisibleHeight;
	},
	get_maxVisibleHeight: function() {
		return this._maxVisibleHeight;
	},
	set_maxVisibleHeight: function(value) {
		if(this._maxVisibleHeight == value) {
			return this._maxVisibleHeight;
		}
		if(value == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("maxVisibleHeight cannot be null"));
		}
		var oldValue = this._maxVisibleHeight;
		this._maxVisibleHeight = value;
		if(this._explicitVisibleHeight == null && (this._actualVisibleHeight > value || this._actualVisibleHeight == oldValue)) {
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		}
		return this._maxVisibleHeight;
	},
	get_visibleHeight: function() {
		if(this._explicitVisibleHeight == null) {
			return this._actualVisibleHeight;
		}
		return this._explicitVisibleHeight;
	},
	set_visibleHeight: function(value) {
		if(this._explicitVisibleHeight == value) {
			return this._explicitVisibleHeight;
		}
		this._explicitVisibleHeight = value;
		if(this._actualVisibleHeight != value) {
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		}
		return this._explicitVisibleWidth;
	},
	get_layout: function() {
		return this._layout;
	},
	set_layout: function(value) {
		if(this._layout == value) {
			return this._layout;
		}
		if(this._layout != null) {
			this._layout.removeEventListener("change",$bind(this,this.advancedLayoutViewPort_layout_changeHandler));
			this._layout.removeEventListener("scroll",$bind(this,this.advancedLayoutViewPort_layout_scrollHandler));
		}
		this._layout = value;
		if(this._layout != null) {
			this._layout.addEventListener("change",$bind(this,this.advancedLayoutViewPort_layout_changeHandler));
			this._layout.addEventListener("scroll",$bind(this,this.advancedLayoutViewPort_layout_scrollHandler));
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		return this._layout;
	},
	get_scrollX: function() {
		return this._scrollX;
	},
	set_scrollX: function(value) {
		if(this._scrollX == value) {
			return this._scrollX;
		}
		this._scrollX = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SCROLL);
		return this._scrollX;
	},
	get_scrollY: function() {
		return this._scrollY;
	},
	set_scrollY: function(value) {
		if(this._scrollY == value) {
			return this._scrollY;
		}
		this._scrollY = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SCROLL);
		return this._scrollY;
	},
	get_snapPositionsX: function() {
		return this._snapPositionsX;
	},
	get_snapPositionsY: function() {
		return this._snapPositionsY;
	},
	get_scroller: function() {
		return this._scroller;
	},
	set_scroller: function(value) {
		if(this._scroller == value) {
			return this._scroller;
		}
		this._scroller = value;
		return this._scroller;
	},
	refreshChildren: function(items) {
	},
	update: function() {
		var _gthis = this;
		this.refreshLayoutMeasurements();
		this.refreshLayoutProperties();
		this.runWithInvalidationFlagsOnly(function() {
			_gthis._layoutActive = true;
			var loopCount = 0;
			while(true) {
				_gthis._layoutChanged = false;
				_gthis.refreshLayout();
				_gthis._invalidationFlags.clear();
				_gthis._allInvalid = false;
				++loopCount;
				if(loopCount >= 10) {
					_gthis._layoutActive = false;
					var parentClassName = (Type().default).getClassName((Type().default).getClass(_gthis.parent));
					var layoutClassName = _gthis._layout != null ? (Type().default).getClassName((Type().default).getClass(_gthis._layout)) : "The layout";
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("" + parentClassName + " is stuck in an infinite loop during layout. " + layoutClassName + " may be dispatching Event.CHANGE too frequently."));
				}
				if(!_gthis._layoutChanged) {
					break;
				}
			}
			return _gthis._layoutActive = false;
		});
	},
	refreshLayout: function() {
		this.refreshChildren(this._layoutItems);
		this._layoutResult.reset();
		if(this._layout != null) {
			this._layout.layout(this._layoutItems,this._layoutMeasurements,this._layoutResult);
		}
		this.handleLayoutResult();
	},
	refreshLayoutProperties: function() {
		var oldIgnoreLayoutChanges = this._ignoreLayoutChanges;
		this._ignoreLayoutChanges = true;
		if((js_Boot().default).__implements(this._layout,(feathers_layout_IScrollLayout().default))) {
			var scrollLayout = (js_Boot().default).__cast(this._layout , (feathers_layout_IScrollLayout().default));
			scrollLayout.set_scrollX(this._scrollX);
			scrollLayout.set_scrollY(this._scrollY);
		}
		this._ignoreLayoutChanges = oldIgnoreLayoutChanges;
	},
	refreshLayoutMeasurements: function() {
		var needsMinWidth = this._explicitMinVisibleWidth == null;
		var needsMinHeight = this._explicitMinVisibleHeight == null;
		var needsMaxWidth = this._maxVisibleWidth == null;
		var needsMaxHeight = this._maxVisibleHeight == null;
		this._layoutMeasurements.width = this._explicitVisibleWidth;
		this._layoutMeasurements.height = this._explicitVisibleHeight;
		var viewPortMinWidth = this._explicitMinVisibleWidth;
		if(needsMinWidth) {
			viewPortMinWidth = 0.0;
		}
		var viewPortMinHeight = this._explicitMinVisibleHeight;
		if(needsMinHeight) {
			viewPortMinHeight = 0.0;
		}
		var viewPortMaxWidth = this._maxVisibleWidth;
		if(needsMaxWidth) {
			viewPortMaxWidth = 1.0 / 0.0;
		}
		var viewPortMaxHeight = this._maxVisibleHeight;
		if(needsMaxHeight) {
			viewPortMaxHeight = 1.0 / 0.0;
		}
		this._layoutMeasurements.minWidth = viewPortMinWidth;
		this._layoutMeasurements.minHeight = viewPortMinHeight;
		this._layoutMeasurements.maxWidth = viewPortMaxWidth;
		this._layoutMeasurements.maxHeight = viewPortMaxHeight;
	},
	handleLayoutResult: function() {
		this.saveMeasurements(this._layoutResult.contentWidth,this._layoutResult.contentHeight,this._layoutResult.contentMinWidth,this._layoutResult.contentMinHeight);
		var viewPortWidth = this._layoutResult.viewPortWidth;
		var viewPortHeight = this._layoutResult.viewPortHeight;
		this._actualVisibleWidth = viewPortWidth;
		this._actualVisibleHeight = viewPortHeight;
		this._actualMinVisibleWidth = this._layoutResult.contentMinWidth;
		this._actualMinVisibleHeight = this._layoutResult.contentMinHeight;
		this._viewPortBackground.set_x(Math.min(this.get_scrollX(),0.0));
		this._viewPortBackground.set_y(Math.min(this.get_scrollY(),0.0));
		this._viewPortBackground.set_width(Math.max(this.actualWidth,this._actualVisibleWidth));
		this._viewPortBackground.set_height(Math.max(this.actualHeight,this._actualVisibleHeight));
		if((js_Boot().default).__implements(this.get_layout(),(feathers_layout_ISnapLayout().default))) {
			var snapLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_ISnapLayout().default));
			this._snapPositionsX = snapLayout.getSnapPositionsX(this._layoutItems,this._actualVisibleWidth,this._actualVisibleHeight,this._snapPositionsX);
			this._snapPositionsY = snapLayout.getSnapPositionsY(this._layoutItems,this._actualVisibleWidth,this._actualVisibleHeight,this._snapPositionsY);
		} else {
			this._snapPositionsX = null;
			this._snapPositionsY = null;
		}
	},
	advancedLayoutViewPort_layout_changeHandler: function(event) {
		if(this._ignoreLayoutChanges) {
			return;
		}
		if(this._layoutActive) {
			this._layoutChanged = true;
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	advancedLayoutViewPort_layout_scrollHandler: function(event) {
		if(this._scroller == null || !this._scroller.get_scrolling()) {
			return;
		}
		this._scroller.applyLayoutShift(event.x,event.y);
		if(this._layoutActive) {
			this._layoutChanged = true;
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	}
});
AdvancedLayoutViewPort.prototype.__class__ = AdvancedLayoutViewPort.prototype.constructor = $hxClasses["feathers.controls.supportClasses.AdvancedLayoutViewPort"] = AdvancedLayoutViewPort;

// Init



// Statics




// Export

exports["default"] = AdvancedLayoutViewPort;

/***/ }),

/***/ "./lib/_gen/feathers/controls/supportClasses/BaseDividedBox.js":
/*!*********************************************************************!*\
  !*** ./lib/_gen/feathers/controls/supportClasses/BaseDividedBox.js ***!
  \*********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.supportClasses.BaseDividedBox

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_layout_AutoSizeMode() {return __webpack_require__(/*! ./../../../feathers/layout/AutoSizeMode */ "./lib/_gen/feathers/layout/AutoSizeMode.js");}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function openfl_display_InteractiveObject() {return (__webpack_require__(/*! openfl */ "openfl").display.InteractiveObject);}
function HxOverrides() {return __webpack_require__(/*! ./../../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_RangeError() {return (__webpack_require__(/*! openfl */ "openfl").errors.RangeError);}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function openfl_display_DisplayObjectContainer() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObjectContainer);}
function feathers_utils_MeasurementsUtil() {return __webpack_require__(/*! ./../../../feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function openfl_errors_TypeError() {return (__webpack_require__(/*! openfl */ "openfl").errors.TypeError);}
function Type() {return __webpack_require__(/*! ./../../../Type */ "./lib/_gen/Type.js");}
function feathers_utils_ExclusivePointer() {return __webpack_require__(/*! ./../../../feathers/utils/ExclusivePointer */ "./lib/_gen/feathers/utils/ExclusivePointer.js");}
function openfl_ui_Mouse() {return (__webpack_require__(/*! openfl */ "openfl").ui.Mouse);}
function openfl_display_Stage() {return (__webpack_require__(/*! openfl */ "openfl").display.Stage);}
function feathers_utils_DisplayObjectFactory() {return __webpack_require__(/*! ./../../../feathers/utils/DisplayObjectFactory */ "./lib/_gen/feathers/utils/DisplayObjectFactory.js");}
function openfl_display_Sprite() {return (__webpack_require__(/*! openfl */ "openfl").display.Sprite);}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}

// Constructor

var BaseDividedBox = function() {
	this.__resizeDraggingSkin = null;
	this.__disabledBackgroundSkin = null;
	this.__backgroundSkin = null;
	this._xmlContent = null;
	this.layout = null;
	this._layoutResult = new (feathers_layout_LayoutBoundsResult().default)();
	this._layoutMeasurements = new (feathers_layout_Measurements().default)();
	this._ignoreChildChanges = false;
	this._displayListBypassEnabled = true;
	this._layoutItems = [];
	this.dividers = [];
	this.items = [];
	this.liveDragging = true;
	this._backgroundSkinMeasurements = null;
	this._currentBackgroundSkin = null;
	this._autoSizeMode = (feathers_layout_AutoSizeMode().default).CONTENT;
	this._resizingDividerIndex = -1;
	this._resizingTouchPointIsMouse = false;
	this._resizingTouchPointID = null;
	(feathers_core_FeathersControl().default).call(this);
	this.addEventListener("addedToStage",$bind(this,this.baseDividedBox_addedToStageHandler));
}

// Meta

BaseDividedBox.__name__ = "feathers.controls.supportClasses.BaseDividedBox";
BaseDividedBox.__isInterface__ = false;
BaseDividedBox.__super__ = (feathers_core_FeathersControl().default);
BaseDividedBox.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_autoSizeMode: function() {
		return this._autoSizeMode;
	},
	set_autoSizeMode: function(value) {
		if(this._autoSizeMode == value) {
			return this._autoSizeMode;
		}
		this._autoSizeMode = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		if(this.stage != null) {
			if(this._autoSizeMode == (feathers_layout_AutoSizeMode().default).STAGE) {
				this.stage.addEventListener("resize",$bind(this,this.baseDividedBox_stage_resizeHandler));
				this.addEventListener("removedFromStage",$bind(this,this.baseDividedBox_removedFromStageHandler));
			} else {
				this.stage.removeEventListener("resize",$bind(this,this.baseDividedBox_stage_resizeHandler));
				this.removeEventListener("removedFromStage",$bind(this,this.baseDividedBox_removedFromStageHandler));
			}
		}
		return this._autoSizeMode;
	},
	get_dividerFactory: function() {
		return this._dividerFactory;
	},
	set_dividerFactory: function(value) {
		if(this._dividerFactory == value) {
			return this._dividerFactory;
		}
		if(this.items.length > 1) {
			var _g = 1;
			var _g1 = this.items.length;
			while(_g < _g1) {
				var i = _g++;
				var layoutIndex = i * 2;
				var childIndex = layoutIndex + (this._currentBackgroundSkin != null ? 1 : 0);
				var oldDivider = this.removeRawChildAt(childIndex - 1);
				this.destroyDivider((js_Boot().default).__cast(oldDivider , (openfl_display_InteractiveObject())),this._dividerFactory);
			}
		}
		this._dividerFactory = value;
		if(this.items.length > 1) {
			var _g2 = 1;
			var _g11 = this.items.length;
			while(_g2 < _g11) {
				var i1 = _g2++;
				var layoutIndex1 = i1 * 2;
				var childIndex1 = layoutIndex1 + (this._currentBackgroundSkin != null ? 1 : 0);
				var newDivider = this.createDivider();
				this.addRawChildAt(newDivider,childIndex1 - 1);
				this.dividers[i1 - 1] = newDivider;
				this._layoutItems[layoutIndex1 - 1] = newDivider;
			}
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		return this._dividerFactory;
	},
	get_xmlContent: function() {
		return this._xmlContent;
	},
	set_xmlContent: function(value) {
		if(this._xmlContent == value) {
			return this._xmlContent;
		}
		if(this._xmlContent != null) {
			var _g = 0;
			var _g1 = this._xmlContent;
			while(_g < _g1.length) {
				var child = _g1[_g];
				++_g;
				this.removeChild(child);
			}
		}
		this._xmlContent = value;
		if(this._xmlContent != null) {
			var _g2 = 0;
			var _g11 = this._xmlContent;
			while(_g2 < _g11.length) {
				var child1 = _g11[_g2];
				++_g2;
				this.addChild(child1);
			}
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._xmlContent;
	},
	get_numRawChildren: function() {
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = false;
		var result = this.get_numChildren();
		this._displayListBypassEnabled = oldBypass;
		return result;
	},
	get_numChildren: function() {
		if(!this._displayListBypassEnabled) {
			return (feathers_core_FeathersControl().default).prototype.get_numChildren.call(this);
		}
		return this.items.length;
	},
	addChild: function(child) {
		if(!this._displayListBypassEnabled) {
			return (feathers_core_FeathersControl().default).prototype.addChild.call(this,child);
		}
		return this.addChildAt(child,this.items.length);
	},
	addChildAt: function(child,index) {
		if(!this._displayListBypassEnabled) {
			return (feathers_core_FeathersControl().default).prototype.addChildAt.call(this,child,index);
		}
		var oldIndex = this.items.indexOf(child);
		if(oldIndex == index) {
			return child;
		}
		if(oldIndex >= 0) {
			this.removeItem(child);
		}
		var result = this.addItemAt(child,index);
		child.addEventListener("resize",$bind(this,this.baseDividedBox_child_resizeHandler));
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		return result;
	},
	removeChild: function(child) {
		if(!this._displayListBypassEnabled) {
			return (feathers_core_FeathersControl().default).prototype.removeChild.call(this,child);
		}
		if(child == null || child.parent != this) {
			return child;
		}
		var result = this.removeItem(child);
		child.removeEventListener("resize",$bind(this,this.baseDividedBox_child_resizeHandler));
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		return result;
	},
	removeChildAt: function(index) {
		if(!this._displayListBypassEnabled) {
			return (feathers_core_FeathersControl().default).prototype.removeChildAt.call(this,index);
		}
		return this.removeChild(this.items[index]);
	},
	getChildAt: function(index) {
		if(!this._displayListBypassEnabled) {
			return (feathers_core_FeathersControl().default).prototype.removeChildAt.call(this,index);
		}
		return this.items[index];
	},
	getChildIndex: function(child) {
		if(!this._displayListBypassEnabled) {
			return (feathers_core_FeathersControl().default).prototype.getChildIndex.call(this,child);
		}
		return this.items.indexOf(child);
	},
	setChildIndex: function(child,index) {
		if(!this._displayListBypassEnabled) {
			(feathers_core_FeathersControl().default).prototype.setChildIndex.call(this,child,index);
			return;
		}
		(HxOverrides().default).remove(this.items,child);
		this.items.splice(index,0,child);
	},
	getChildByName: function(name) {
		if(!this._displayListBypassEnabled) {
			return (feathers_core_FeathersControl().default).prototype.getChildByName.call(this,name);
		}
		var _g = 0;
		var _g1 = this.items;
		while(_g < _g1.length) {
			var child = _g1[_g];
			++_g;
			if(child.get_name() == name) {
				return child;
			}
		}
		return null;
	},
	removeChildren: function(beginIndex,endIndex) {
		if(endIndex == null) {
			endIndex = 2147483647;
		}
		if(beginIndex == null) {
			beginIndex = 0;
		}
		if(!this._displayListBypassEnabled) {
			(feathers_core_FeathersControl().default).prototype.removeChildren.call(this,beginIndex,endIndex);
			return;
		}
		if(endIndex == 2147483647) {
			endIndex = this.items.length - 1;
			if(endIndex < 0) {
				return;
			}
		}
		if(beginIndex > this.items.length - 1) {
			return;
		} else if(endIndex < beginIndex || beginIndex < 0 || endIndex > this.items.length) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("The supplied index is out of bounds."));
		}
		var numRemovals = endIndex - beginIndex;
		while(numRemovals >= 0) {
			this.removeChildAt(beginIndex);
			--numRemovals;
		}
	},
	addRawChild: function(child) {
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = false;
		var result = this.addChild(child);
		this._displayListBypassEnabled = oldBypass;
		return result;
	},
	addRawChildAt: function(child,index) {
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = false;
		var result = this.addChildAt(child,index);
		this._displayListBypassEnabled = oldBypass;
		return result;
	},
	removeRawChild: function(child) {
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = false;
		var result = this.removeChild(child);
		this._displayListBypassEnabled = oldBypass;
		return result;
	},
	removeRawChildAt: function(index) {
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = false;
		var result = this.removeChildAt(index);
		this._displayListBypassEnabled = oldBypass;
		return result;
	},
	getRawChildByName: function(name) {
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = false;
		var result = this.getChildByName(name);
		this._displayListBypassEnabled = oldBypass;
		return result;
	},
	getRawChildAt: function(index) {
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = false;
		var result = this.getChildAt(index);
		this._displayListBypassEnabled = oldBypass;
		return result;
	},
	getRawChildIndex: function(child) {
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = false;
		var result = this.getChildIndex(child);
		this._displayListBypassEnabled = oldBypass;
		return result;
	},
	setRawChildIndex: function(child,index) {
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = false;
		this.setChildIndex(child,index);
		this._displayListBypassEnabled = oldBypass;
	},
	removeRawChildren: function(beginIndex,endIndex) {
		if(endIndex == null) {
			endIndex = 2147483647;
		}
		if(beginIndex == null) {
			beginIndex = 0;
		}
		var oldBypass = this._displayListBypassEnabled;
		this._displayListBypassEnabled = false;
		this.removeRawChildren(beginIndex,endIndex);
		this._displayListBypassEnabled = oldBypass;
	},
	addItemAt: function(child,index) {
		this.items.splice(index,0,child);
		var layoutIndex = index * 2;
		var childIndex = layoutIndex + (this._currentBackgroundSkin != null ? 1 : 0);
		if(index != 0) {
			var divider = this.createDivider();
			(feathers_core_FeathersControl().default).prototype.addChildAt.call(this,divider,childIndex - 1);
			this.dividers.splice(index - 1,0,divider);
			this._layoutItems.splice(layoutIndex - 1,0,divider);
		}
		this._layoutItems.splice(layoutIndex,0,child);
		return (feathers_core_FeathersControl().default).prototype.addChildAt.call(this,child,childIndex);
	},
	removeItem: function(child) {
		(HxOverrides().default).remove(this.items,child);
		var index = this.getRawChildIndex(child);
		if(index != 0) {
			var divider = (feathers_core_FeathersControl().default).prototype.getChildAt.call(this,index - 1);
			this.dividers.splice(index - 1,1);
			(HxOverrides().default).remove(this._layoutItems,divider);
			this.destroyDivider((js_Boot().default).__cast(divider , (openfl_display_InteractiveObject())),this._dividerFactory);
		}
		(HxOverrides().default).remove(this._layoutItems,child);
		return (feathers_core_FeathersControl().default).prototype.removeChild.call(this,child);
	},
	update: function() {
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(stylesInvalid || stateInvalid) {
			this.refreshBackgroundSkin();
		}
		if(stylesInvalid || stateInvalid) {
			this.refreshResizeDraggingSkin();
		}
		this.refreshViewPortBounds();
		this.handleLayout();
		this.handleLayoutResult();
		this.refreshBackgroundLayout();
		this.validateChildren();
	},
	refreshBackgroundSkin: function() {
		var oldSkin = this._currentBackgroundSkin;
		this._currentBackgroundSkin = this.getCurrentBackgroundSkin();
		if(this._currentBackgroundSkin == oldSkin) {
			return;
		}
		this.removeCurrentBackgroundSkin(oldSkin);
		this.addCurrentBackgroundSkin(this._currentBackgroundSkin);
	},
	getCurrentBackgroundSkin: function() {
		if(!this._enabled && this.get_disabledBackgroundSkin() != null) {
			return this.get_disabledBackgroundSkin();
		}
		return this.get_backgroundSkin();
	},
	addCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			this._backgroundSkinMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._backgroundSkinMeasurements == null) {
			this._backgroundSkinMeasurements = new (feathers_layout_Measurements().default)(skin);
		} else {
			this._backgroundSkinMeasurements.save(skin);
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this.addRawChildAt(skin,0);
	},
	removeCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		this._backgroundSkinMeasurements.restore(skin);
		if(skin.parent == this) {
			this.removeRawChild(skin);
		}
	},
	refreshResizeDraggingSkin: function() {
		var oldSkin = this._currentResizeDraggingSkin;
		this._currentResizeDraggingSkin = this.getCurrentResizeDraggingSkin();
		if(this._currentResizeDraggingSkin == oldSkin) {
			return;
		}
		this.removeCurrentResizeDraggingSkin(oldSkin);
		if(this._currentResizeDraggingSkin == null) {
			return;
		}
		if((js_Boot().default).__implements(this._currentResizeDraggingSkin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._currentResizeDraggingSkin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if((js_Boot().default).__implements(this._currentResizeDraggingSkin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(this._currentResizeDraggingSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this._currentResizeDraggingSkin.set_visible(false);
		if(((this._currentResizeDraggingSkin) instanceof (openfl_display_InteractiveObject()))) {
			((js_Boot().default).__cast(this._currentResizeDraggingSkin , (openfl_display_InteractiveObject()))).mouseEnabled = false;
		}
		if(((this._currentResizeDraggingSkin) instanceof (openfl_display_DisplayObjectContainer()))) {
			((js_Boot().default).__cast(this._currentResizeDraggingSkin , (openfl_display_DisplayObjectContainer()))).mouseChildren = false;
		}
		this.addRawChild(this._currentResizeDraggingSkin);
	},
	getCurrentResizeDraggingSkin: function() {
		return this.get_resizeDraggingSkin();
	},
	removeCurrentResizeDraggingSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		if(skin.parent == this) {
			this.removeRawChild(skin);
		}
	},
	createDivider: function() {
		var dividerFactory = this._dividerFactory != null ? this._dividerFactory : BaseDividedBox.defaultDividerFactory;
		var divider = dividerFactory.create();
		divider.addEventListener("rollOver",$bind(this,this.baseDividedBox_divider_rollOverHandler));
		divider.addEventListener("rollOut",$bind(this,this.baseDividedBox_divider_rollOutHandler));
		divider.addEventListener("mouseDown",$bind(this,this.baseDividedBox_divider_mouseDownHandler));
		divider.addEventListener("touchBegin",$bind(this,this.baseDividedBox_divider_touchBeginHandler));
		return divider;
	},
	destroyDivider: function(divider,factory) {
		divider.removeEventListener("rollOver",$bind(this,this.baseDividedBox_divider_rollOverHandler));
		divider.removeEventListener("rollOut",$bind(this,this.baseDividedBox_divider_rollOutHandler));
		divider.removeEventListener("mouseDown",$bind(this,this.baseDividedBox_divider_mouseDownHandler));
		divider.removeEventListener("touchBegin",$bind(this,this.baseDividedBox_divider_touchBeginHandler));
		if(factory != null && factory.destroy != null) {
			factory.destroy(divider);
		}
	},
	refreshViewPortBounds: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(this._currentBackgroundSkin != null) {
			(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParent(this._backgroundSkinMeasurements,this._currentBackgroundSkin,this);
			if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
			}
		}
		var needsToMeasureContent = this._autoSizeMode == (feathers_layout_AutoSizeMode().default).CONTENT || this.stage == null;
		var stageWidth = 0.0;
		var stageHeight = 0.0;
		if(!needsToMeasureContent) {
			var topLeft = this.globalToLocal(new (openfl_geom_Point())());
			var bottomRight = this.globalToLocal(new (openfl_geom_Point())(this.stage.stageWidth,this.stage.stageHeight));
			stageWidth = bottomRight.x - topLeft.x;
			stageHeight = bottomRight.y - topLeft.y;
		}
		if(needsWidth && !needsToMeasureContent) {
			this._layoutMeasurements.width = stageWidth;
		} else {
			this._layoutMeasurements.width = this.get_explicitWidth();
		}
		if(needsHeight && !needsToMeasureContent) {
			this._layoutMeasurements.height = stageHeight;
		} else {
			this._layoutMeasurements.height = this.get_explicitHeight();
		}
		var viewPortMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			viewPortMinWidth = 0.0;
		}
		var viewPortMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			viewPortMinHeight = 0.0;
		}
		var viewPortMaxWidth = this.get_explicitMaxWidth();
		if(needsMaxWidth) {
			viewPortMaxWidth = 1.0 / 0.0;
		}
		var viewPortMaxHeight = this.get_explicitMaxHeight();
		if(needsMaxHeight) {
			viewPortMaxHeight = 1.0 / 0.0;
		}
		if(this._backgroundSkinMeasurements != null) {
			if(this._backgroundSkinMeasurements.width != null) {
				if(this._backgroundSkinMeasurements.width > viewPortMinWidth) {
					viewPortMinWidth = this._backgroundSkinMeasurements.width;
				}
			} else if(this._backgroundSkinMeasurements.minWidth != null) {
				if(this._backgroundSkinMeasurements.minWidth > viewPortMinWidth) {
					viewPortMinWidth = this._backgroundSkinMeasurements.minWidth;
				}
			}
			if(this._backgroundSkinMeasurements.height != null) {
				if(this._backgroundSkinMeasurements.height > viewPortMinHeight) {
					viewPortMinHeight = this._backgroundSkinMeasurements.height;
				}
			} else if(this._backgroundSkinMeasurements.minHeight != null) {
				if(this._backgroundSkinMeasurements.minHeight > viewPortMinHeight) {
					viewPortMinHeight = this._backgroundSkinMeasurements.minHeight;
				}
			}
		}
		this._layoutMeasurements.minWidth = viewPortMinWidth;
		this._layoutMeasurements.minHeight = viewPortMinHeight;
		this._layoutMeasurements.maxWidth = viewPortMaxWidth;
		this._layoutMeasurements.maxHeight = viewPortMaxHeight;
	},
	handleLayout: function() {
		var oldIgnoreChildChanges = this._ignoreChildChanges;
		this._ignoreChildChanges = true;
		this._layoutResult.reset();
		this.layout.layout(this._layoutItems,this._layoutMeasurements,this._layoutResult);
		this._ignoreChildChanges = oldIgnoreChildChanges;
	},
	handleLayoutResult: function() {
		var viewPortWidth = this._layoutResult.viewPortWidth;
		var viewPortHeight = this._layoutResult.viewPortHeight;
		this.saveMeasurements(viewPortWidth,viewPortHeight,viewPortWidth,viewPortHeight);
	},
	refreshBackgroundLayout: function() {
		if(this._currentBackgroundSkin == null) {
			return;
		}
		this._currentBackgroundSkin.set_x(0.0);
		this._currentBackgroundSkin.set_y(0.0);
		if(this._currentBackgroundSkin.get_width() != this.actualWidth) {
			this._currentBackgroundSkin.set_width(this.actualWidth);
		}
		if(this._currentBackgroundSkin.get_height() != this.actualHeight) {
			this._currentBackgroundSkin.set_height(this.actualHeight);
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
	},
	validateChildren: function() {
		var _g = 0;
		var _g1 = this._layoutItems;
		while(_g < _g1.length) {
			var layoutItem = _g1[_g];
			++_g;
			if((js_Boot().default).__implements(layoutItem,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(layoutItem , (feathers_core_IValidating().default))).validateNow();
			}
		}
	},
	prepareResize: function(dividerIndex,stageX,stageY) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_TypeError())("Missing override for 'prepareResize' in type " + (Type().default).getClassName((Type().default).getClass(this))));
	},
	commitResize: function(dividerIndex,stageX,stageY,live) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_TypeError())("Missing override for 'commitResize' in type " + (Type().default).getClassName((Type().default).getClass(this))));
	},
	resizeTouchBegin: function(touchPointID,isMouse,divider,stageX,stageY) {
		if(!this._enabled || this._resizingDividerIndex != -1 || this.stage == null) {
			return;
		}
		var exclusivePointer = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
		var result = false;
		if(isMouse) {
			result = exclusivePointer.claimMouse(divider);
		} else {
			result = exclusivePointer.claimTouch(touchPointID,divider);
		}
		if(!result) {
			return;
		}
		this._resizingTouchPointID = touchPointID;
		this._resizingTouchPointIsMouse = isMouse;
		this._resizingDividerIndex = this.dividers.indexOf(divider);
		this.prepareResize(this._resizingDividerIndex,stageX,stageY);
		if(!this.liveDragging && this._currentResizeDraggingSkin != null) {
			this._currentResizeDraggingSkin.set_visible(true);
		}
		if(isMouse) {
			this.stage.addEventListener("mouseMove",$bind(this,this.baseDividedBox_divider_stage_mouseMoveHandler),false,0,true);
			this.stage.addEventListener("mouseUp",$bind(this,this.baseDividedBox_divider_stage_mouseUpHandler),false,0,true);
		} else {
			this.stage.addEventListener("touchMove",$bind(this,this.baseDividedBox_divider_stage_touchMoveHandler),false,0,true);
			this.stage.addEventListener("touchEnd",$bind(this,this.baseDividedBox_divider_stage_touchEndHandler),false,0,true);
		}
	},
	resizeTouchMove: function(touchPointID,isMouse,stageX,stageY) {
		if(this._resizingTouchPointID == null || this._resizingTouchPointID != touchPointID || this._resizingTouchPointIsMouse != isMouse) {
			return;
		}
		this.commitResize(this._resizingDividerIndex,stageX,stageY,true);
	},
	resizeTouchEnd: function(touchPointID,isMouse,stageX,stageY) {
		if(this._resizingTouchPointID == null || this._resizingTouchPointID != touchPointID || this._resizingTouchPointIsMouse != isMouse) {
			return;
		}
		if(isMouse) {
			this.stage.removeEventListener("mouseMove",$bind(this,this.baseDividedBox_divider_stage_mouseMoveHandler));
			this.stage.removeEventListener("mouseUp",$bind(this,this.baseDividedBox_divider_stage_mouseUpHandler));
		} else {
			this.stage.removeEventListener("touchMove",$bind(this,this.baseDividedBox_divider_stage_touchMoveHandler));
			this.stage.removeEventListener("touchEnd",$bind(this,this.baseDividedBox_divider_stage_touchEndHandler));
		}
		if(!this.liveDragging) {
			this.commitResize(this._resizingDividerIndex,stageX,stageY,false);
		}
		if(this._currentResizeDraggingSkin != null) {
			this._currentResizeDraggingSkin.set_visible(false);
		}
		this._resizingTouchPointID = null;
		this._resizingTouchPointIsMouse = false;
		this._resizingDividerIndex = -1;
		if(this._oldDividerMouseCursor != null) {
			(openfl_ui_Mouse()).set_cursor(this._oldDividerMouseCursor);
			this._oldDividerMouseCursor = null;
		}
	},
	baseDividedBox_child_resizeHandler: function(event) {
		if(this._ignoreChildChanges) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
	},
	baseDividedBox_addedToStageHandler: function(event) {
		if(this._autoSizeMode == (feathers_layout_AutoSizeMode().default).STAGE) {
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
			this.stage.addEventListener("resize",$bind(this,this.baseDividedBox_stage_resizeHandler));
			this.addEventListener("removedFromStage",$bind(this,this.baseDividedBox_removedFromStageHandler));
		}
	},
	baseDividedBox_removedFromStageHandler: function(event) {
		this.removeEventListener("removedFromStage",$bind(this,this.baseDividedBox_removedFromStageHandler));
		this.stage.removeEventListener("resize",$bind(this,this.baseDividedBox_stage_resizeHandler));
	},
	baseDividedBox_stage_resizeHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
	},
	baseDividedBox_divider_rollOverHandler: function(event) {
		if(!this._enabled || this._resizingDividerIndex != -1 || (openfl_ui_Mouse()).get_cursor() != "auto") {
			return;
		}
		this._oldDividerMouseCursor = (openfl_ui_Mouse()).get_cursor();
		(openfl_ui_Mouse()).set_cursor(this.resizeCursor);
	},
	baseDividedBox_divider_rollOutHandler: function(event) {
		if(!this._enabled || this._resizingDividerIndex != -1 || this._oldDividerMouseCursor == null) {
			return;
		}
		(openfl_ui_Mouse()).set_cursor(this._oldDividerMouseCursor);
		this._oldDividerMouseCursor = null;
	},
	baseDividedBox_divider_mouseDownHandler: function(event) {
		var divider = (js_Boot().default).__cast(event.currentTarget , (openfl_display_InteractiveObject()));
		this.resizeTouchBegin(BaseDividedBox.POINTER_ID_MOUSE,true,divider,this.stage.get_mouseX(),this.stage.get_mouseY());
	},
	baseDividedBox_divider_stage_mouseMoveHandler: function(event) {
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		this.resizeTouchMove(BaseDividedBox.POINTER_ID_MOUSE,true,stage.get_mouseX(),stage.get_mouseY());
	},
	baseDividedBox_divider_stage_mouseUpHandler: function(event) {
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		this.resizeTouchEnd(BaseDividedBox.POINTER_ID_MOUSE,true,stage.get_mouseX(),stage.get_mouseY());
	},
	baseDividedBox_divider_touchBeginHandler: function(event) {
		if(event.isPrimaryTouchPoint) {
			return;
		}
		var divider = (js_Boot().default).__cast(event.currentTarget , (openfl_display_InteractiveObject()));
		this.resizeTouchBegin(event.touchPointID,false,divider,event.stageX,event.stageY);
	},
	baseDividedBox_divider_stage_touchMoveHandler: function(event) {
		this.resizeTouchMove(event.touchPointID,false,event.stageX,event.stageY);
	},
	baseDividedBox_divider_stage_touchEndHandler: function(event) {
		this.resizeTouchEnd(event.touchPointID,false,event.stageX,event.stageY);
	},
	get_backgroundSkin: function() {
		return this.__backgroundSkin;
	},
	set_backgroundSkin: function(value) {
		if(!this.setStyle("backgroundSkin")) {
			return this.__backgroundSkin;
		}
		if(this.__backgroundSkin == value) {
			return this.__backgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_backgroundSkin);
		this.__backgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__backgroundSkin;
	},
	clearStyle_backgroundSkin: function() {
		this.set_backgroundSkin(null);
		return this.get_backgroundSkin();
	},
	get_disabledBackgroundSkin: function() {
		return this.__disabledBackgroundSkin;
	},
	set_disabledBackgroundSkin: function(value) {
		if(!this.setStyle("disabledBackgroundSkin")) {
			return this.__disabledBackgroundSkin;
		}
		if(this.__disabledBackgroundSkin == value) {
			return this.__disabledBackgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledBackgroundSkin);
		this.__disabledBackgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledBackgroundSkin;
	},
	clearStyle_disabledBackgroundSkin: function() {
		this.set_disabledBackgroundSkin(null);
		return this.get_disabledBackgroundSkin();
	},
	get_resizeDraggingSkin: function() {
		return this.__resizeDraggingSkin;
	},
	set_resizeDraggingSkin: function(value) {
		if(!this.setStyle("resizeDraggingSkin")) {
			return this.__resizeDraggingSkin;
		}
		if(this.__resizeDraggingSkin == value) {
			return this.__resizeDraggingSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_resizeDraggingSkin);
		this.__resizeDraggingSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__resizeDraggingSkin;
	},
	clearStyle_resizeDraggingSkin: function() {
		this.set_resizeDraggingSkin(null);
		return this.get_resizeDraggingSkin();
	}
});
BaseDividedBox.prototype.__class__ = BaseDividedBox.prototype.constructor = $hxClasses["feathers.controls.supportClasses.BaseDividedBox"] = BaseDividedBox;

// Init



// Statics


BaseDividedBox.__meta__ = { obj : { defaultXmlProperty : ["xmlContent"]}}
BaseDividedBox.POINTER_ID_MOUSE = -1000
BaseDividedBox.defaultDividerFactory = (feathers_utils_DisplayObjectFactory().default).withFunction(function() {
	var divider = new (openfl_display_Sprite())();
	divider.get_graphics().beginFill(16711935,0.0);
	divider.get_graphics().drawRect(0.0,0.0,6.0,6.0);
	divider.get_graphics().endFill();
	return divider;
})

// Export

exports["default"] = BaseDividedBox;

/***/ }),

/***/ "./lib/_gen/feathers/controls/supportClasses/BaseProgressBar.js":
/*!**********************************************************************!*\
  !*** ./lib/_gen/feathers/controls/supportClasses/BaseProgressBar.js ***!
  \**********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.supportClasses.BaseProgressBar

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_IRange() {return __webpack_require__(/*! ./../../../feathers/controls/IRange */ "./lib/_gen/feathers/controls/IRange.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_TypeError() {return (__webpack_require__(/*! openfl */ "openfl").errors.TypeError);}
function Type() {return __webpack_require__(/*! ./../../../Type */ "./lib/_gen/Type.js");}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_controls_ProgressBarFillMode() {return __webpack_require__(/*! ./../../../feathers/controls/ProgressBarFillMode */ "./lib/_gen/feathers/controls/ProgressBarFillMode.js");}

// Constructor

var BaseProgressBar = function(value,minimum,maximum,changeListener) {
	if(maximum == null) {
		maximum = 1.0;
	}
	if(minimum == null) {
		minimum = 0.0;
	}
	if(value == null) {
		value = 0.0;
	}
	this.__paddingLeft = 0.0;
	this.__paddingBottom = 0.0;
	this.__paddingRight = 0.0;
	this.__paddingTop = 0.0;
	this.__fillMode = (feathers_controls_ProgressBarFillMode().default).RESIZE;
	this.__disabledFillSkin = null;
	this.__fillSkin = null;
	this.__disabledBackgroundSkin = null;
	this.__backgroundSkin = null;
	this._currentFillSkin = null;
	this._fillSkinMeasurements = null;
	this._currentBackgroundSkin = null;
	this._backgroundSkinMeasurements = null;
	this._maximum = 1.0;
	this._minimum = 0.0;
	this._value = 0.0;
	(feathers_core_FeathersControl().default).call(this);
	this.set_minimum(minimum);
	this.set_maximum(maximum);
	this.set_value(value);
	if(changeListener != null) {
		this.addEventListener("change",changeListener);
	}
}

// Meta

BaseProgressBar.__name__ = "feathers.controls.supportClasses.BaseProgressBar";
BaseProgressBar.__isInterface__ = false;
BaseProgressBar.__interfaces__ = [(feathers_controls_IRange().default)];
BaseProgressBar.__super__ = (feathers_core_FeathersControl().default);
BaseProgressBar.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_value: function() {
		return this._value;
	},
	set_value: function(value) {
		if(this._value == value) {
			return this._value;
		}
		this._value = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._value;
	},
	get_minimum: function() {
		return this._minimum;
	},
	set_minimum: function(value) {
		if(this._minimum == value) {
			return this._minimum;
		}
		this._minimum = value;
		if(this.get_initialized() && this._value < this._minimum) {
			this.set_value(this._minimum);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._minimum;
	},
	get_maximum: function() {
		return this._maximum;
	},
	set_maximum: function(value) {
		if(this._maximum == value) {
			return this._maximum;
		}
		this._maximum = value;
		if(this.get_initialized() && this._value > this._maximum) {
			this.set_value(this._maximum);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._maximum;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	update: function() {
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		if(stylesInvalid || stateInvalid) {
			this.refreshBackgroundSkin();
			this.refreshFillSkin();
		}
		this.measure();
		this.layoutContent();
	},
	measure: function() {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_TypeError())("Missing override for 'measure' in type " + (Type().default).getClassName((Type().default).getClass(this))));
	},
	refreshBackgroundSkin: function() {
		var oldSkin = this._currentBackgroundSkin;
		this._currentBackgroundSkin = this.getCurrentBackgroundSkin();
		if(this._currentBackgroundSkin == oldSkin) {
			return;
		}
		this.removeCurrentBackgroundSkin(oldSkin);
		this.addCurrentBackgroundSkin(this._currentBackgroundSkin);
	},
	getCurrentBackgroundSkin: function() {
		if(!this._enabled && this.get_disabledBackgroundSkin() != null) {
			return this.get_disabledBackgroundSkin();
		}
		return this.get_backgroundSkin();
	},
	addCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			this._backgroundSkinMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._backgroundSkinMeasurements == null) {
			this._backgroundSkinMeasurements = new (feathers_layout_Measurements().default)(skin);
		} else {
			this._backgroundSkinMeasurements.save(skin);
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this.addChildAt(skin,0);
	},
	removeCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		this._backgroundSkinMeasurements.restore(skin);
		if(skin.parent == this) {
			this.removeChild(skin);
		}
	},
	refreshFillSkin: function() {
		var oldSkin = this._currentFillSkin;
		this._currentFillSkin = this.getCurrentFillSkin();
		if(this._currentFillSkin == oldSkin) {
			return;
		}
		this.removeCurrentFillSkin(oldSkin);
		if(this._currentFillSkin == null) {
			this._fillSkinMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(this._currentFillSkin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._currentFillSkin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._fillSkinMeasurements == null) {
			this._fillSkinMeasurements = new (feathers_layout_Measurements().default)(this._currentFillSkin);
		} else {
			this._fillSkinMeasurements.save(this._currentFillSkin);
		}
		if((js_Boot().default).__implements(this._currentFillSkin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(this._currentFillSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this.addChild(this._currentFillSkin);
	},
	getCurrentFillSkin: function() {
		if(!this._enabled && this.get_disabledFillSkin() != null) {
			return this.get_disabledFillSkin();
		}
		return this.get_fillSkin();
	},
	removeCurrentFillSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		if(skin.parent == this) {
			this.removeChild(skin);
		}
	},
	layoutContent: function() {
		this.layoutBackground();
		this.layoutFill();
	},
	layoutBackground: function() {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_TypeError())("Missing override for 'layoutBackground' in type " + (Type().default).getClassName((Type().default).getClass(this))));
	},
	layoutFill: function() {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_TypeError())("Missing override for 'layoutFill' in type " + (Type().default).getClassName((Type().default).getClass(this))));
	},
	get_backgroundSkin: function() {
		return this.__backgroundSkin;
	},
	set_backgroundSkin: function(value) {
		if(!this.setStyle("backgroundSkin")) {
			return this.__backgroundSkin;
		}
		if(this.__backgroundSkin == value) {
			return this.__backgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_backgroundSkin);
		this.__backgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__backgroundSkin;
	},
	clearStyle_backgroundSkin: function() {
		this.set_backgroundSkin(null);
		return this.get_backgroundSkin();
	},
	get_disabledBackgroundSkin: function() {
		return this.__disabledBackgroundSkin;
	},
	set_disabledBackgroundSkin: function(value) {
		if(!this.setStyle("disabledBackgroundSkin")) {
			return this.__disabledBackgroundSkin;
		}
		if(this.__disabledBackgroundSkin == value) {
			return this.__disabledBackgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledBackgroundSkin);
		this.__disabledBackgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledBackgroundSkin;
	},
	clearStyle_disabledBackgroundSkin: function() {
		this.set_disabledBackgroundSkin(null);
		return this.get_disabledBackgroundSkin();
	},
	get_fillSkin: function() {
		return this.__fillSkin;
	},
	set_fillSkin: function(value) {
		if(!this.setStyle("fillSkin")) {
			return this.__fillSkin;
		}
		if(this.__fillSkin == value) {
			return this.__fillSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_fillSkin);
		this.__fillSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__fillSkin;
	},
	clearStyle_fillSkin: function() {
		this.set_fillSkin(null);
		return this.get_fillSkin();
	},
	get_disabledFillSkin: function() {
		return this.__disabledFillSkin;
	},
	set_disabledFillSkin: function(value) {
		if(!this.setStyle("disabledFillSkin")) {
			return this.__disabledFillSkin;
		}
		if(this.__disabledFillSkin == value) {
			return this.__disabledFillSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledFillSkin);
		this.__disabledFillSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledFillSkin;
	},
	clearStyle_disabledFillSkin: function() {
		this.set_disabledFillSkin(null);
		return this.get_disabledFillSkin();
	},
	get_fillMode: function() {
		return this.__fillMode;
	},
	set_fillMode: function(value) {
		if(!this.setStyle("fillMode")) {
			return this.__fillMode;
		}
		if(this.__fillMode == value) {
			return this.__fillMode;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_fillMode);
		this.__fillMode = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__fillMode;
	},
	clearStyle_fillMode: function() {
		this.set_fillMode((feathers_controls_ProgressBarFillMode().default).RESIZE);
		return this.get_fillMode();
	},
	get_paddingTop: function() {
		return this.__paddingTop;
	},
	set_paddingTop: function(value) {
		if(!this.setStyle("paddingTop")) {
			return this.__paddingTop;
		}
		if(this.__paddingTop == value) {
			return this.__paddingTop;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingTop);
		this.__paddingTop = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingTop;
	},
	clearStyle_paddingTop: function() {
		this.set_paddingTop(0.0);
		return this.get_paddingTop();
	},
	get_paddingRight: function() {
		return this.__paddingRight;
	},
	set_paddingRight: function(value) {
		if(!this.setStyle("paddingRight")) {
			return this.__paddingRight;
		}
		if(this.__paddingRight == value) {
			return this.__paddingRight;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingRight);
		this.__paddingRight = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingRight;
	},
	clearStyle_paddingRight: function() {
		this.set_paddingRight(0.0);
		return this.get_paddingRight();
	},
	get_paddingBottom: function() {
		return this.__paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(!this.setStyle("paddingBottom")) {
			return this.__paddingBottom;
		}
		if(this.__paddingBottom == value) {
			return this.__paddingBottom;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingBottom);
		this.__paddingBottom = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingBottom;
	},
	clearStyle_paddingBottom: function() {
		this.set_paddingBottom(0.0);
		return this.get_paddingBottom();
	},
	get_paddingLeft: function() {
		return this.__paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(!this.setStyle("paddingLeft")) {
			return this.__paddingLeft;
		}
		if(this.__paddingLeft == value) {
			return this.__paddingLeft;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingLeft);
		this.__paddingLeft = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingLeft;
	},
	clearStyle_paddingLeft: function() {
		this.set_paddingLeft(0.0);
		return this.get_paddingLeft();
	}
});
BaseProgressBar.prototype.__class__ = BaseProgressBar.prototype.constructor = $hxClasses["feathers.controls.supportClasses.BaseProgressBar"] = BaseProgressBar;

// Init



// Statics




// Export

exports["default"] = BaseProgressBar;

/***/ }),

/***/ "./lib/_gen/feathers/controls/supportClasses/BaseScrollBar.js":
/*!********************************************************************!*\
  !*** ./lib/_gen/feathers/controls/supportClasses/BaseScrollBar.js ***!
  \********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.supportClasses.BaseScrollBar

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_IScrollBar() {return __webpack_require__(/*! ./../../../feathers/controls/IScrollBar */ "./lib/_gen/feathers/controls/IScrollBar.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_TypeError() {return (__webpack_require__(/*! openfl */ "openfl").errors.TypeError);}
function Type() {return __webpack_require__(/*! ./../../../Type */ "./lib/_gen/Type.js");}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_utils_MathUtil() {return __webpack_require__(/*! ./../../../feathers/utils/MathUtil */ "./lib/_gen/feathers/utils/MathUtil.js");}
function feathers_utils_ExclusivePointer() {return __webpack_require__(/*! ./../../../feathers/utils/ExclusivePointer */ "./lib/_gen/feathers/utils/ExclusivePointer.js");}
function feathers_events_ScrollEvent() {return __webpack_require__(/*! ./../../../feathers/events/ScrollEvent */ "./lib/_gen/feathers/events/ScrollEvent.js");}
function openfl_display_Stage() {return (__webpack_require__(/*! openfl */ "openfl").display.Stage);}

// Constructor

var BaseScrollBar = function(value,minimum,maximum,changeListener) {
	if(maximum == null) {
		maximum = 1.0;
	}
	if(minimum == null) {
		minimum = 0.0;
	}
	if(value == null) {
		value = 0.0;
	}
	this.__hideThumbWhenDisabled = false;
	this.__paddingLeft = 0.0;
	this.__paddingBottom = 0.0;
	this.__paddingRight = 0.0;
	this.__paddingTop = 0.0;
	this.__fixedThumbSize = false;
	this.__secondaryTrackSkin = null;
	this.__trackSkin = null;
	this.__thumbSkin = null;
	this._previousFallbackTrackHeight = 0.0;
	this._previousFallbackTrackWidth = 0.0;
	this._thumbStartY = 0.0;
	this._thumbStartX = 0.0;
	this._pointerStartY = 0.0;
	this._pointerStartX = 0.0;
	this._dragging = false;
	this._secondaryTrackSkinMeasurements = null;
	this._currentSecondaryTrackSkin = null;
	this._trackSkinMeasurements = null;
	this._currentTrackSkin = null;
	this._thumbSkinMeasurements = null;
	this._currentThumbSkin = null;
	this.liveDragging = true;
	this._page = 0.0;
	this._snapInterval = 0.0;
	this._step = 0.01;
	this._maximum = 1.0;
	this._minimum = 0.0;
	this._value = 0.0;
	this._isDefaultValue = true;
	(feathers_core_FeathersControl().default).call(this);
	this.set_tabChildren(false);
	this.focusRect = null;
	this.set_minimum(minimum);
	this.set_maximum(maximum);
	this.set_value(value);
	if(changeListener != null) {
		this.addEventListener("change",changeListener);
	}
}

// Meta

BaseScrollBar.__name__ = "feathers.controls.supportClasses.BaseScrollBar";
BaseScrollBar.__isInterface__ = false;
BaseScrollBar.__interfaces__ = [(feathers_controls_IScrollBar().default)];
BaseScrollBar.__super__ = (feathers_core_FeathersControl().default);
BaseScrollBar.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_value: function() {
		return this._value;
	},
	set_value: function(value) {
		if(this._value == value) {
			return this._value;
		}
		this._isDefaultValue = false;
		this._value = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		if(this.liveDragging || !this._dragging) {
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
		}
		return this._value;
	},
	get_minimum: function() {
		return this._minimum;
	},
	set_minimum: function(value) {
		if(this._minimum == value) {
			return this._minimum;
		}
		this._minimum = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._minimum;
	},
	get_maximum: function() {
		return this._maximum;
	},
	set_maximum: function(value) {
		if(this._maximum == value) {
			return this._maximum;
		}
		this._maximum = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._maximum;
	},
	get_step: function() {
		return this._step;
	},
	set_step: function(value) {
		if(this._step == value) {
			return this._step;
		}
		this._step = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._step;
	},
	get_snapInterval: function() {
		return this._snapInterval;
	},
	set_snapInterval: function(value) {
		if(this._snapInterval == value) {
			return this._snapInterval;
		}
		this._snapInterval = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._snapInterval;
	},
	get_page: function() {
		return this._page;
	},
	set_page: function(value) {
		if(this._page == value) {
			return this._page;
		}
		this._page = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._page;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	applyValueRestrictions: function() {
		this.set_value(this.restrictValue(this._value));
	},
	initialize: function() {
		(feathers_core_FeathersControl().default).prototype.initialize.call(this);
		if(this._isDefaultValue) {
			this.set_value(this.restrictValue(this._value));
		}
	},
	update: function() {
		var sizeInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SIZE);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(stylesInvalid) {
			this.refreshThumb();
			this.refreshTrack();
			this.refreshSecondaryTrack();
		}
		if(stateInvalid || stylesInvalid) {
			this.refreshEnabled();
		}
		sizeInvalid = this.measure() || sizeInvalid;
		this.layoutContent();
	},
	measure: function() {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_TypeError())("Missing override for 'measure' in type " + (Type().default).getClassName((Type().default).getClass(this))));
	},
	refreshThumb: function() {
		var oldSkin = this._currentThumbSkin;
		this._currentThumbSkin = this.get_thumbSkin();
		if(this._currentThumbSkin == oldSkin) {
			return;
		}
		if(oldSkin != null) {
			if((js_Boot().default).__implements(oldSkin,(feathers_skins_IProgrammaticSkin().default))) {
				((js_Boot().default).__cast(oldSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
			}
			oldSkin.removeEventListener("mouseDown",$bind(this,this.thumbSkin_mouseDownHandler));
			this.removeChild(oldSkin);
		}
		if(this._currentThumbSkin != null) {
			if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(this._thumbSkinMeasurements == null) {
				this._thumbSkinMeasurements = new (feathers_layout_Measurements().default)(this._currentThumbSkin);
			} else {
				this._thumbSkinMeasurements.save(this._currentThumbSkin);
			}
			this.addChild(this._currentThumbSkin);
			this._currentThumbSkin.addEventListener("mouseDown",$bind(this,this.thumbSkin_mouseDownHandler));
			if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_skins_IProgrammaticSkin().default))) {
				((js_Boot().default).__cast(this._currentThumbSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
			}
		} else {
			this._thumbSkinMeasurements = null;
		}
	},
	refreshTrack: function() {
		var oldSkin = this._currentTrackSkin;
		this._currentTrackSkin = this.get_trackSkin();
		if(this._currentTrackSkin == oldSkin) {
			return;
		}
		if(oldSkin != null) {
			if((js_Boot().default).__implements(oldSkin,(feathers_skins_IProgrammaticSkin().default))) {
				((js_Boot().default).__cast(oldSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
			}
			this.removeChild(oldSkin);
			oldSkin.removeEventListener("mouseDown",$bind(this,this.trackSkin_mouseDownHandler));
		}
		if(this._currentTrackSkin != null) {
			if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(this._currentTrackSkin , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(this._trackSkinMeasurements == null) {
				this._trackSkinMeasurements = new (feathers_layout_Measurements().default)(this._currentTrackSkin);
			} else {
				this._trackSkinMeasurements.save(this._currentTrackSkin);
			}
			this.addChildAt(this._currentTrackSkin,0);
			this._currentTrackSkin.addEventListener("mouseDown",$bind(this,this.trackSkin_mouseDownHandler));
			if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_skins_IProgrammaticSkin().default))) {
				((js_Boot().default).__cast(this._currentTrackSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
			}
		} else {
			this._trackSkinMeasurements = null;
		}
	},
	refreshSecondaryTrack: function() {
		var oldSkin = this._currentSecondaryTrackSkin;
		this._currentSecondaryTrackSkin = this.get_secondaryTrackSkin();
		if(this._currentSecondaryTrackSkin == oldSkin) {
			return;
		}
		if(oldSkin != null) {
			if((js_Boot().default).__implements(oldSkin,(feathers_skins_IProgrammaticSkin().default))) {
				((js_Boot().default).__cast(oldSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
			}
			this.removeChild(oldSkin);
			oldSkin.removeEventListener("mouseDown",$bind(this,this.trackSkin_mouseDownHandler));
		}
		if(this._currentSecondaryTrackSkin != null) {
			if((js_Boot().default).__implements(this._currentSecondaryTrackSkin,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(this._currentSecondaryTrackSkin , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(this._secondaryTrackSkinMeasurements == null) {
				this._secondaryTrackSkinMeasurements = new (feathers_layout_Measurements().default)(this._currentSecondaryTrackSkin);
			} else {
				this._secondaryTrackSkinMeasurements.save(this._currentSecondaryTrackSkin);
			}
			var index = this._currentTrackSkin != null ? 1 : 0;
			this.addChildAt(this._currentSecondaryTrackSkin,index);
			this._currentSecondaryTrackSkin.addEventListener("mouseDown",$bind(this,this.trackSkin_mouseDownHandler));
			if((js_Boot().default).__implements(this._currentSecondaryTrackSkin,(feathers_skins_IProgrammaticSkin().default))) {
				((js_Boot().default).__cast(this._currentSecondaryTrackSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
			}
		} else {
			this._secondaryTrackSkinMeasurements = null;
		}
	},
	refreshEnabled: function() {
		if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IUIControl().default))).set_enabled(this._enabled);
		}
	},
	layoutContent: function() {
		if(this._currentTrackSkin != null && this._currentSecondaryTrackSkin != null) {
			this.get_graphics().clear();
			this.layoutSplitTrack();
		} else if(this._currentTrackSkin != null) {
			this.get_graphics().clear();
			this.layoutSingleTrack();
		} else {
			this.drawFallbackTrack();
		}
		this.layoutThumb();
	},
	layoutSplitTrack: function() {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_TypeError())("Missing override for 'layoutSplitTrack' in type " + (Type().default).getClassName((Type().default).getClass(this))));
	},
	layoutSingleTrack: function() {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_TypeError())("Missing override for 'layoutSingleTrack' in type " + (Type().default).getClassName((Type().default).getClass(this))));
	},
	layoutThumb: function() {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_TypeError())("Missing override for 'layoutThumb' in type " + (Type().default).getClassName((Type().default).getClass(this))));
	},
	drawFallbackTrack: function() {
		if(this.actualWidth == this._previousFallbackTrackWidth && this.actualHeight == this._previousFallbackTrackHeight) {
			return;
		}
		this.get_graphics().clear();
		this.get_graphics().beginFill(16711935,0.0);
		this.get_graphics().drawRect(0,0,this.actualWidth,this.actualHeight);
		this.get_graphics().endFill();
		this._previousFallbackTrackWidth = this.actualWidth;
		this._previousFallbackTrackHeight = this.actualHeight;
	},
	normalizeValue: function(value) {
		var normalized = 0.0;
		if(this._minimum != this._maximum) {
			normalized = (value - this._minimum) / (this._maximum - this._minimum);
			if(normalized < 0.0) {
				normalized = 0.0;
			} else if(normalized > 1.0) {
				normalized = 1.0;
			}
		}
		return normalized;
	},
	restrictValue: function(value) {
		if(this._snapInterval != 0.0 && value != this._minimum && value != this._maximum) {
			value = (feathers_utils_MathUtil().default).roundToNearest(value,this._snapInterval);
		}
		if(value < this._minimum) {
			value = this._minimum;
		} else if(value > this._maximum) {
			value = this._maximum;
		}
		return value;
	},
	valueToLocation: function(value) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_TypeError())("Missing override for 'valueToLocation' in type " + (Type().default).getClassName((Type().default).getClass(this))));
	},
	locationToValue: function(x,y) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_TypeError())("Missing override for 'locationToValue' in type " + (Type().default).getClassName((Type().default).getClass(this))));
	},
	saveThumbStart: function(x,y) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_TypeError())("Missing override for 'saveThumbStart' in type " + (Type().default).getClassName((Type().default).getClass(this))));
	},
	getAdjustedPage: function() {
		var range = this._maximum - this._minimum;
		var adjustedPage = this._page;
		if(adjustedPage == 0.0) {
			adjustedPage = this._step;
		} else if(adjustedPage > range) {
			adjustedPage = range;
		}
		return adjustedPage;
	},
	thumbSkin_mouseDownHandler: function(event) {
		if(!this._enabled || this.stage == null) {
			return;
		}
		var exclusivePointer = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
		var result = exclusivePointer.claimMouse(this);
		if(!result) {
			return;
		}
		this.stage.addEventListener("mouseMove",$bind(this,this.thumbSkin_stage_mouseMoveHandler),false,0,true);
		this.stage.addEventListener("mouseUp",$bind(this,this.thumbSkin_stage_mouseUpHandler),false,0,true);
		this._thumbStartX = this._currentThumbSkin.get_x();
		this._thumbStartY = this._currentThumbSkin.get_y();
		this._pointerStartX = this.get_mouseX();
		this._pointerStartY = this.get_mouseY();
		this._dragging = true;
		(feathers_events_ScrollEvent().default).dispatch(this,"scrollStart");
	},
	thumbSkin_stage_mouseMoveHandler: function(event) {
		var newValue = this.locationToValue(this.get_mouseX(),this.get_mouseY());
		newValue = this.restrictValue(newValue);
		this.set_value(newValue);
	},
	thumbSkin_stage_mouseUpHandler: function(event) {
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		stage.removeEventListener("mouseMove",$bind(this,this.thumbSkin_stage_mouseMoveHandler));
		stage.removeEventListener("mouseUp",$bind(this,this.thumbSkin_stage_mouseUpHandler));
		this._dragging = false;
		(feathers_events_ScrollEvent().default).dispatch(this,"scrollComplete");
		if(!this.liveDragging) {
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
		}
	},
	trackSkin_mouseDownHandler: function(event) {
		if(!this._enabled || this.stage == null) {
			return;
		}
		var exclusivePointer = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
		var result = exclusivePointer.claimMouse(this);
		if(!result) {
			return;
		}
		this.stage.addEventListener("mouseMove",$bind(this,this.trackSkin_stage_mouseMoveHandler),false,0,true);
		this.stage.addEventListener("mouseUp",$bind(this,this.trackSkin_stage_mouseUpHandler),false,0,true);
		this.saveThumbStart(this.get_mouseX(),this.get_mouseY());
		this._pointerStartX = this.get_mouseX();
		this._pointerStartY = this.get_mouseY();
		this._dragging = true;
		(feathers_events_ScrollEvent().default).dispatch(this,"scrollStart");
		var newValue = this.locationToValue(this.get_mouseX(),this.get_mouseY());
		newValue = this.restrictValue(newValue);
		this.set_value(newValue);
	},
	trackSkin_stage_mouseMoveHandler: function(event) {
		var newValue = this.locationToValue(this.get_mouseX(),this.get_mouseY());
		newValue = this.restrictValue(newValue);
		this.set_value(newValue);
	},
	trackSkin_stage_mouseUpHandler: function(event) {
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		stage.removeEventListener("mouseMove",$bind(this,this.trackSkin_stage_mouseMoveHandler));
		stage.removeEventListener("mouseUp",$bind(this,this.trackSkin_stage_mouseUpHandler));
		this._dragging = false;
		(feathers_events_ScrollEvent().default).dispatch(this,"scrollComplete");
		if(!this.liveDragging) {
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
		}
	},
	get_thumbSkin: function() {
		return this.__thumbSkin;
	},
	set_thumbSkin: function(value) {
		if(!this.setStyle("thumbSkin")) {
			return this.__thumbSkin;
		}
		if(this.__thumbSkin == value) {
			return this.__thumbSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_thumbSkin);
		this.__thumbSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__thumbSkin;
	},
	clearStyle_thumbSkin: function() {
		this.set_thumbSkin(null);
		return this.get_thumbSkin();
	},
	get_trackSkin: function() {
		return this.__trackSkin;
	},
	set_trackSkin: function(value) {
		if(!this.setStyle("trackSkin")) {
			return this.__trackSkin;
		}
		if(this.__trackSkin == value) {
			return this.__trackSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_trackSkin);
		this.__trackSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__trackSkin;
	},
	clearStyle_trackSkin: function() {
		this.set_trackSkin(null);
		return this.get_trackSkin();
	},
	get_secondaryTrackSkin: function() {
		return this.__secondaryTrackSkin;
	},
	set_secondaryTrackSkin: function(value) {
		if(!this.setStyle("secondaryTrackSkin")) {
			return this.__secondaryTrackSkin;
		}
		if(this.__secondaryTrackSkin == value) {
			return this.__secondaryTrackSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_secondaryTrackSkin);
		this.__secondaryTrackSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__secondaryTrackSkin;
	},
	clearStyle_secondaryTrackSkin: function() {
		this.set_secondaryTrackSkin(null);
		return this.get_secondaryTrackSkin();
	},
	get_fixedThumbSize: function() {
		return this.__fixedThumbSize;
	},
	set_fixedThumbSize: function(value) {
		if(!this.setStyle("fixedThumbSize")) {
			return this.__fixedThumbSize;
		}
		if(this.__fixedThumbSize == value) {
			return this.__fixedThumbSize;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_fixedThumbSize);
		this.__fixedThumbSize = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__fixedThumbSize;
	},
	clearStyle_fixedThumbSize: function() {
		this.set_fixedThumbSize(false);
		return this.get_fixedThumbSize();
	},
	get_paddingTop: function() {
		return this.__paddingTop;
	},
	set_paddingTop: function(value) {
		if(!this.setStyle("paddingTop")) {
			return this.__paddingTop;
		}
		if(this.__paddingTop == value) {
			return this.__paddingTop;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingTop);
		this.__paddingTop = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingTop;
	},
	clearStyle_paddingTop: function() {
		this.set_paddingTop(0.0);
		return this.get_paddingTop();
	},
	get_paddingRight: function() {
		return this.__paddingRight;
	},
	set_paddingRight: function(value) {
		if(!this.setStyle("paddingRight")) {
			return this.__paddingRight;
		}
		if(this.__paddingRight == value) {
			return this.__paddingRight;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingRight);
		this.__paddingRight = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingRight;
	},
	clearStyle_paddingRight: function() {
		this.set_paddingRight(0.0);
		return this.get_paddingRight();
	},
	get_paddingBottom: function() {
		return this.__paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(!this.setStyle("paddingBottom")) {
			return this.__paddingBottom;
		}
		if(this.__paddingBottom == value) {
			return this.__paddingBottom;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingBottom);
		this.__paddingBottom = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingBottom;
	},
	clearStyle_paddingBottom: function() {
		this.set_paddingBottom(0.0);
		return this.get_paddingBottom();
	},
	get_paddingLeft: function() {
		return this.__paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(!this.setStyle("paddingLeft")) {
			return this.__paddingLeft;
		}
		if(this.__paddingLeft == value) {
			return this.__paddingLeft;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingLeft);
		this.__paddingLeft = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingLeft;
	},
	clearStyle_paddingLeft: function() {
		this.set_paddingLeft(0.0);
		return this.get_paddingLeft();
	},
	get_hideThumbWhenDisabled: function() {
		return this.__hideThumbWhenDisabled;
	},
	set_hideThumbWhenDisabled: function(value) {
		if(!this.setStyle("hideThumbWhenDisabled")) {
			return this.__hideThumbWhenDisabled;
		}
		if(this.__hideThumbWhenDisabled == value) {
			return this.__hideThumbWhenDisabled;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_hideThumbWhenDisabled);
		this.__hideThumbWhenDisabled = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__hideThumbWhenDisabled;
	},
	clearStyle_hideThumbWhenDisabled: function() {
		this.set_hideThumbWhenDisabled(false);
		return this.get_hideThumbWhenDisabled();
	}
});
BaseScrollBar.prototype.__class__ = BaseScrollBar.prototype.constructor = $hxClasses["feathers.controls.supportClasses.BaseScrollBar"] = BaseScrollBar;

// Init



// Statics




// Export

exports["default"] = BaseScrollBar;

/***/ }),

/***/ "./lib/_gen/feathers/controls/supportClasses/BaseScrollContainer.js":
/*!**************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/supportClasses/BaseScrollContainer.js ***!
  \**************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.supportClasses.BaseScrollContainer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_ScrollEvent() {return __webpack_require__(/*! ./../../../feathers/events/ScrollEvent */ "./lib/_gen/feathers/events/ScrollEvent.js");}
function openfl_geom_Rectangle() {return (__webpack_require__(/*! openfl */ "openfl").geom.Rectangle);}
function feathers_utils_Scroller() {return __webpack_require__(/*! ./../../../feathers/utils/Scroller */ "./lib/_gen/feathers/utils/Scroller.js");}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function openfl_display_DisplayObject() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObject);}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_controls_ScrollPolicy() {return __webpack_require__(/*! ./../../../feathers/controls/ScrollPolicy */ "./lib/_gen/feathers/controls/ScrollPolicy.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}
function feathers_utils_MathUtil() {return __webpack_require__(/*! ./../../../feathers/utils/MathUtil */ "./lib/_gen/feathers/utils/MathUtil.js");}
function feathers_controls_ScrollMode() {return __webpack_require__(/*! ./../../../feathers/controls/ScrollMode */ "./lib/_gen/feathers/controls/ScrollMode.js");}
function openfl_display_InteractiveObject() {return (__webpack_require__(/*! openfl */ "openfl").display.InteractiveObject);}
function openfl_display_DisplayObjectContainer() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObjectContainer);}
function feathers_utils_MeasurementsUtil() {return __webpack_require__(/*! ./../../../feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_graphics_FillStyle() {return __webpack_require__(/*! ./../../../feathers/graphics/FillStyle */ "./lib/_gen/feathers/graphics/FillStyle.js");}
function feathers_utils_DisplayUtil() {return __webpack_require__(/*! ./../../../feathers/utils/DisplayUtil */ "./lib/_gen/feathers/utils/DisplayUtil.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function Std() {return __webpack_require__(/*! ./../../../Std */ "./lib/_gen/Std.js");}
function motion_Actuate() {return (__webpack_require__(/*! motion */ "motion").Actuate);}
function openfl_Lib() {return (__webpack_require__(/*! openfl */ "openfl").Lib);}
function motion_actuators_SimpleActuator() {return (__webpack_require__(/*! motion */ "motion").actuators.SimpleActuator);}
function feathers_utils_ExclusivePointer() {return __webpack_require__(/*! ./../../../feathers/utils/ExclusivePointer */ "./lib/_gen/feathers/utils/ExclusivePointer.js");}
function motion_easing_Quart() {return (__webpack_require__(/*! motion */ "motion").easing.Quart);}
function feathers_utils_DisplayObjectFactory() {return __webpack_require__(/*! ./../../../feathers/utils/DisplayObjectFactory */ "./lib/_gen/feathers/utils/DisplayObjectFactory.js");}
function feathers_controls_HScrollBar() {return __webpack_require__(/*! ./../../../feathers/controls/HScrollBar */ "./lib/_gen/feathers/controls/HScrollBar.js");}
function feathers_controls_VScrollBar() {return __webpack_require__(/*! ./../../../feathers/controls/VScrollBar */ "./lib/_gen/feathers/controls/VScrollBar.js");}

// Constructor

var BaseScrollContainer = function() {
	this.__scrollPixelSnapping = false;
	this.__hideScrollBarEase = (motion_easing_Quart()).easeOut;
	this.__hideScrollBarDuration = 0.2;
	this.__showScrollBarMinimumDuration = 0.5;
	this.__scrollBarYPosition = (feathers_layout_RelativePosition().default).RIGHT;
	this.__scrollBarXPosition = (feathers_layout_RelativePosition().default).BOTTOM;
	this.__autoHideScrollBars = true;
	this.__showScrollBars = true;
	this.__fixedScrollBars = false;
	this.__viewPortMaskSkin = null;
	this.__maskSkin = null;
	this.__disabledBackgroundSkin = null;
	this.__backgroundSkin = null;
	this.__paddingLeft = 0.0;
	this.__paddingBottom = 0.0;
	this.__paddingRight = 0.0;
	this.__paddingTop = 0.0;
	this._scrollMode = (feathers_controls_ScrollMode().default).MASK;
	this._ignoreViewPortResizing = false;
	this._settingScrollerDimensions = false;
	this._ignoreScrollerChanges = false;
	this._scrollRect2 = new (openfl_geom_Rectangle())();
	this._scrollRect1 = new (openfl_geom_Rectangle())();
	this._prevMaxScrollY = 0.0;
	this._prevMinScrollY = 0.0;
	this._prevMaxScrollX = 0.0;
	this._prevMinScrollX = 0.0;
	this._hideScrollBarY = null;
	this._hideScrollBarX = null;
	this._scrollPolicyY = (feathers_controls_ScrollPolicy().default).AUTO;
	this._scrollPolicyX = (feathers_controls_ScrollPolicy().default).AUTO;
	this._scrollStepY = 0.0;
	this._scrollStepX = 0.0;
	this._temporaryRestrictedScrollY = null;
	this._temporaryScrollY = null;
	this._temporaryRestrictedScrollX = null;
	this._temporaryScrollX = null;
	this.showScrollBarY = false;
	this.showScrollBarX = false;
	this._ignoreScrollBarYChange = false;
	this._ignoreScrollBarXChange = false;
	this.chromeMeasuredMaxHeight = 1.0 / 0.0;
	this.chromeMeasuredMinHeight = 0.0;
	this.chromeMeasuredHeight = 0.0;
	this.chromeMeasuredMaxWidth = 1.0 / 0.0;
	this.chromeMeasuredMinWidth = 0.0;
	this.chromeMeasuredWidth = 0.0;
	this.leftViewPortOffset = 0.0;
	this.bottomViewPortOffset = 0.0;
	this.rightViewPortOffset = 0.0;
	this.topViewPortOffset = 0.0;
	this._fallbackViewPortMaskSkin = null;
	this._currentViewPortMaskSkin = null;
	this._currentMaskSkin = null;
	this._backgroundSkinMeasurements = null;
	this._currentBackgroundSkin = null;
	this._scrollBarYHover = false;
	this._scrollBarXHover = false;
	this._scrollerDraggingY = false;
	this._scrollerDraggingX = false;
	(feathers_core_FeathersControl().default).call(this);
	this.set_tabEnabled(true);
	this.set_tabChildren(true);
	this.focusRect = null;
	this.addEventListener("keyDown",$bind(this,this.baseScrollContainer_keyDownHandler));
	this.addEventListener("addedToStage",$bind(this,this.baseScrollContainer_addedToStageHandler));
	this.addEventListener("removedFromStage",$bind(this,this.baseScrollContainer_removedFromStageHandler));
}

// Meta

BaseScrollContainer.__name__ = "feathers.controls.supportClasses.BaseScrollContainer";
BaseScrollContainer.__isInterface__ = false;
BaseScrollContainer.__interfaces__ = [(feathers_core_IFocusObject().default)];
BaseScrollContainer.__super__ = (feathers_core_FeathersControl().default);
BaseScrollContainer.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_viewPort: function() {
		return this._viewPort;
	},
	set_viewPort: function(value) {
		if(this._viewPort == value) {
			return this._viewPort;
		}
		if(this._viewPort != null) {
			this._viewPort.removeEventListener("resize",$bind(this,this.viewPort_resizeHandler));
		}
		if(this.scroller != null) {
			this.scroller.set_target(null);
		}
		this._viewPort = value;
		if(this._viewPort != null) {
			this._viewPort.addEventListener("resize",$bind(this,this.viewPort_resizeHandler));
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SCROLL);
		return this._viewPort;
	},
	get_tabEnabled: function() {
		if(this.get_maxScrollY() != this.get_minScrollY() || this.get_maxScrollX() != this.get_minScrollX()) {
			return this.get_rawTabEnabled();
		} else {
			return false;
		}
	},
	get_scrollBarXFactory: function() {
		return this._scrollBarXFactory;
	},
	set_scrollBarXFactory: function(value) {
		if(this._scrollBarXFactory == value) {
			return this._scrollBarXFactory;
		}
		this._scrollBarXFactory = value;
		this.setInvalid(BaseScrollContainer.INVALIDATION_FLAG_SCROLL_BAR_FACTORY);
		return this._scrollBarXFactory;
	},
	get_scrollBarYFactory: function() {
		return this._scrollBarYFactory;
	},
	set_scrollBarYFactory: function(value) {
		if(this._scrollBarYFactory == value) {
			return this._scrollBarYFactory;
		}
		this._scrollBarYFactory = value;
		this.setInvalid(BaseScrollContainer.INVALIDATION_FLAG_SCROLL_BAR_FACTORY);
		return this._scrollBarYFactory;
	},
	get_scrollerFactory: function() {
		return this._scrollerFactory;
	},
	set_scrollerFactory: function(value) {
		if(this._scrollerFactory == value) {
			return this._scrollerFactory;
		}
		this._scrollerFactory = value;
		this.setInvalid(BaseScrollContainer.INVALIDATION_FLAG_SCROLLER_FACTORY);
		return this._scrollerFactory;
	},
	get_scrollX: function() {
		if(this.scroller == null) {
			if(this._temporaryRestrictedScrollX != null) {
				return this._temporaryRestrictedScrollX;
			}
			if(this._temporaryScrollX != null) {
				return this._temporaryScrollX;
			}
			return 0.0;
		}
		return this.scroller.get_scrollX();
	},
	set_scrollX: function(value) {
		if(this.scroller == null) {
			this._temporaryScrollX = value;
			this._temporaryRestrictedScrollX = null;
			(feathers_events_ScrollEvent().default).dispatch(this,"scroll",false,false,this._temporaryScrollX,this._temporaryScrollY);
			return this._temporaryScrollX;
		}
		this.scroller.set_scrollX(value);
		return this.scroller.get_scrollX();
	},
	get_restrictedScrollX: function() {
		if(this.scroller == null) {
			return this.get_scrollX();
		}
		return this.scroller.get_restrictedScrollX();
	},
	set_restrictedScrollX: function(value) {
		if(this.scroller == null) {
			this._temporaryRestrictedScrollX = value;
			this._temporaryScrollX = null;
			(feathers_events_ScrollEvent().default).dispatch(this,"scroll",false,false,this._temporaryScrollX,this._temporaryScrollY);
			return this._temporaryRestrictedScrollX;
		}
		this.scroller.set_restrictedScrollX(value);
		return this.scroller.get_restrictedScrollX();
	},
	get_scrollY: function() {
		if(this.scroller == null) {
			if(this._temporaryRestrictedScrollY != null) {
				return this._temporaryRestrictedScrollY;
			}
			if(this._temporaryScrollY != null) {
				return this._temporaryScrollY;
			}
			return 0.0;
		}
		return this.scroller.get_scrollY();
	},
	set_scrollY: function(value) {
		if(this.scroller == null) {
			this._temporaryScrollY = value;
			this._temporaryRestrictedScrollY = null;
			(feathers_events_ScrollEvent().default).dispatch(this,"scroll",false,false,this._temporaryScrollX,this._temporaryScrollY);
			return this._temporaryScrollY;
		}
		this.scroller.set_scrollY(value);
		return this.scroller.get_scrollY();
	},
	get_restrictedScrollY: function() {
		if(this.scroller == null) {
			this.get_scrollY();
		}
		return this.scroller.get_restrictedScrollY();
	},
	set_restrictedScrollY: function(value) {
		if(this.scroller == null) {
			this._temporaryRestrictedScrollY = value;
			this._temporaryScrollY = null;
			(feathers_events_ScrollEvent().default).dispatch(this,"scroll",false,false,this._temporaryScrollX,this._temporaryScrollY);
			return this._temporaryRestrictedScrollY;
		}
		this.scroller.set_restrictedScrollY(value);
		return this.scroller.get_restrictedScrollY();
	},
	get_minScrollX: function() {
		if(this.scroller == null) {
			return 0.0;
		}
		return this.scroller.get_minScrollX();
	},
	get_minScrollY: function() {
		if(this.scroller == null) {
			return 0.0;
		}
		return this.scroller.get_minScrollY();
	},
	get_maxScrollX: function() {
		if(this.scroller == null) {
			return 0.0;
		}
		return this.scroller.get_maxScrollX();
	},
	get_maxScrollY: function() {
		if(this.scroller == null) {
			return 0.0;
		}
		return this.scroller.get_maxScrollY();
	},
	get_scrollStepX: function() {
		return this._scrollStepX;
	},
	set_scrollStepX: function(value) {
		if(this._scrollStepX == value) {
			return this._scrollStepX;
		}
		this._scrollStepX = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SCROLL);
		return this._scrollStepX;
	},
	get_scrollStepY: function() {
		return this._scrollStepY;
	},
	set_scrollStepY: function(value) {
		if(this._scrollStepY == value) {
			return this._scrollStepY;
		}
		this._scrollStepY = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SCROLL);
		return this._scrollStepY;
	},
	get_scrollPolicyX: function() {
		return this._scrollPolicyX;
	},
	set_scrollPolicyX: function(value) {
		if(this._scrollPolicyX == value) {
			return this._scrollPolicyX;
		}
		this._scrollPolicyX = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SCROLL);
		return this._scrollPolicyX;
	},
	get_scrollPolicyY: function() {
		return this._scrollPolicyY;
	},
	set_scrollPolicyY: function(value) {
		if(this._scrollPolicyY == value) {
			return this._scrollPolicyY;
		}
		this._scrollPolicyY = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SCROLL);
		return this._scrollPolicyY;
	},
	get_measureViewPort: function() {
		return true;
	},
	get_scrollMode: function() {
		return this._scrollMode;
	},
	set_scrollMode: function(value) {
		if(this._scrollMode == value) {
			return this._scrollMode;
		}
		this._scrollMode = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		return this._scrollMode;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	getViewPortVisibleBounds: function(result) {
		var viewPortX = this.leftViewPortOffset + this.get_paddingLeft();
		var viewPortY = this.topViewPortOffset + this.get_paddingTop();
		if(result == null) {
			result = new (openfl_geom_Rectangle())(viewPortX,viewPortY,this._viewPort.get_visibleWidth(),this._viewPort.get_visibleHeight());
		} else {
			result.setTo(viewPortX,viewPortY,this._viewPort.get_visibleWidth(),this._viewPort.get_visibleHeight());
		}
		return result;
	},
	update: function() {
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		var sizeInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SIZE);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var scrollerInvalid = this.isInvalid(BaseScrollContainer.INVALIDATION_FLAG_SCROLLER_FACTORY);
		var scrollBarFactoryInvalid = this.isInvalid(BaseScrollContainer.INVALIDATION_FLAG_SCROLL_BAR_FACTORY);
		var oldIgnoreScrollerChanges = this._ignoreScrollerChanges;
		this._ignoreScrollerChanges = true;
		if(scrollerInvalid) {
			this.createScroller();
		}
		if(stylesInvalid || stateInvalid) {
			this.refreshBackgroundSkin();
		}
		if(stylesInvalid) {
			this.refreshMaskSkin();
			this.refreshViewPortMaskSkin();
		}
		if(scrollBarFactoryInvalid) {
			this.createScrollBars();
		}
		this.refreshEnabled();
		this.refreshScrollerValues();
		this.refreshViewPort();
		this.applyTemporaryScrollPositions();
		this.refreshScrollRect();
		this.refreshScrollBarValues();
		this.layoutChildren();
		this._ignoreScrollerChanges = oldIgnoreScrollerChanges;
	},
	applyTemporaryScrollPositions: function() {
		if(this._temporaryScrollX != null) {
			this.scroller.set_scrollX(this._temporaryScrollX);
		} else if(this._temporaryRestrictedScrollX != null) {
			this.scroller.set_restrictedScrollX(this._temporaryRestrictedScrollX);
		}
		if(this._temporaryScrollY != null) {
			this.scroller.set_scrollY(this._temporaryScrollY);
		} else if(this._temporaryRestrictedScrollY != null) {
			this.scroller.set_restrictedScrollY(this._temporaryRestrictedScrollY);
		}
		this._temporaryScrollX = null;
		this._temporaryScrollY = null;
		this._temporaryRestrictedScrollX = null;
		this._temporaryRestrictedScrollY = null;
	},
	needsMeasurement: function() {
		if(!(this.isInvalid((feathers_core_InvalidationFlag().default).SCROLL) && this.needsScrollMeasurement() || this.isInvalid((feathers_core_InvalidationFlag().default).DATA) || this.isInvalid((feathers_core_InvalidationFlag().default).SIZE) || this.isInvalid((feathers_core_InvalidationFlag().default).STYLES) || this.isInvalid(BaseScrollContainer.INVALIDATION_FLAG_SCROLL_BAR_FACTORY) || this.isInvalid((feathers_core_InvalidationFlag().default).STATE))) {
			return this.isInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		} else {
			return true;
		}
	},
	needsScrollMeasurement: function() {
		return false;
	},
	createScroller: function() {
		if(this.scroller != null) {
			this._temporaryScrollX = this.scroller.get_scrollX();
			this._temporaryScrollY = this.scroller.get_scrollY();
			this._temporaryRestrictedScrollX = null;
			this._temporaryRestrictedScrollY = null;
			this.scroller.set_target(null);
			this.scroller.removeEventListener("scroll",$bind(this,this.baseScrollContainer_scroller_scrollHandler));
			this.scroller.removeEventListener("scrollStart",$bind(this,this.baseScrollContainer_scroller_scrollStartHandler));
			this.scroller.removeEventListener("scrollComplete",$bind(this,this.baseScrollContainer_scroller_scrollCompleteHandler));
			this.scroller = null;
		}
		this.scroller = this._scrollerFactory != null ? this._scrollerFactory() : new (feathers_utils_Scroller().default)();
		this.scroller.addEventListener("scroll",$bind(this,this.baseScrollContainer_scroller_scrollHandler));
		this.scroller.addEventListener("scrollStart",$bind(this,this.baseScrollContainer_scroller_scrollStartHandler));
		this.scroller.addEventListener("scrollComplete",$bind(this,this.baseScrollContainer_scroller_scrollCompleteHandler));
	},
	createScrollBars: function() {
		if(this.scrollBarX != null) {
			this.scrollBarX.removeEventListener("change",$bind(this,this.scrollBarX_changeHandler));
			this.scrollBarX.removeEventListener("rollOver",$bind(this,this.scrollBarX_rollOverHandler));
			this.scrollBarX.removeEventListener("rollOut",$bind(this,this.scrollBarX_rollOutHandler));
			this.scrollBarX.removeEventListener("scrollStart",$bind(this,this.scrollBarX_scrollStartHandler));
			this.scrollBarX.removeEventListener("scrollComplete",$bind(this,this.scrollBarX_scrollCompleteHandler));
			this.removeChild((js_Boot().default).__cast(this.scrollBarX , (openfl_display_DisplayObject())));
			if(this._oldScrollBarXFactory.destroy != null) {
				this._oldScrollBarXFactory.destroy(this.scrollBarX);
			}
			this._oldScrollBarXFactory = null;
			this.scrollBarX = null;
		}
		if(this.scrollBarY != null) {
			this.scrollBarY.removeEventListener("change",$bind(this,this.scrollBarY_changeHandler));
			this.scrollBarY.removeEventListener("rollOver",$bind(this,this.scrollBarY_rollOverHandler));
			this.scrollBarY.removeEventListener("rollOut",$bind(this,this.scrollBarY_rollOutHandler));
			this.scrollBarY.removeEventListener("scrollStart",$bind(this,this.scrollBarY_scrollStartHandler));
			this.scrollBarY.removeEventListener("scrollComplete",$bind(this,this.scrollBarY_scrollCompleteHandler));
			this.removeChild((js_Boot().default).__cast(this.scrollBarY , (openfl_display_DisplayObject())));
			if(this._oldScrollBarYFactory.destroy != null) {
				this._oldScrollBarYFactory.destroy(this.scrollBarY);
			}
			this._oldScrollBarYFactory = null;
			this.scrollBarY = null;
		}
		var factory = this._scrollBarXFactory != null ? this._scrollBarXFactory : BaseScrollContainer.defaultScrollBarXFactory;
		this._oldScrollBarXFactory = factory;
		this.scrollBarX = factory.create();
		if(this.get_autoHideScrollBars()) {
			this.scrollBarX.set_alpha(0.0);
		}
		this.scrollBarX.addEventListener("change",$bind(this,this.scrollBarX_changeHandler));
		this.scrollBarX.addEventListener("rollOver",$bind(this,this.scrollBarX_rollOverHandler));
		this.scrollBarX.addEventListener("rollOut",$bind(this,this.scrollBarX_rollOutHandler));
		this.scrollBarX.addEventListener("scrollStart",$bind(this,this.scrollBarX_scrollStartHandler));
		this.scrollBarX.addEventListener("scrollComplete",$bind(this,this.scrollBarX_scrollCompleteHandler));
		this.addChild((js_Boot().default).__cast(this.scrollBarX , (openfl_display_DisplayObject())));
		var factory1 = this._scrollBarYFactory != null ? this._scrollBarYFactory : BaseScrollContainer.defaultScrollBarYFactory;
		this._oldScrollBarYFactory = factory1;
		this.scrollBarY = factory1.create();
		if(this.get_autoHideScrollBars()) {
			this.scrollBarY.set_alpha(0.0);
		}
		this.scrollBarY.addEventListener("change",$bind(this,this.scrollBarY_changeHandler));
		this.scrollBarY.addEventListener("rollOver",$bind(this,this.scrollBarY_rollOverHandler));
		this.scrollBarY.addEventListener("rollOut",$bind(this,this.scrollBarY_rollOutHandler));
		this.scrollBarY.addEventListener("scrollStart",$bind(this,this.scrollBarY_scrollStartHandler));
		this.scrollBarY.addEventListener("scrollComplete",$bind(this,this.scrollBarY_scrollCompleteHandler));
		this.addChild((js_Boot().default).__cast(this.scrollBarY , (openfl_display_DisplayObject())));
	},
	refreshEnabled: function() {
		this._viewPort.set_enabled(this._enabled);
		if(this.scrollBarX != null) {
			this.scrollBarX.set_enabled(this._enabled);
		}
		if(this.scrollBarY != null) {
			this.scrollBarY.set_enabled(this._enabled);
		}
	},
	restrictScrollAfterRefreshViewPort: function() {
		if(this.scroller.get_scrolling()) {
			return;
		}
		if(this._prevMinScrollX != this.scroller.get_minScrollX() && this.scroller.get_scrollX() < this.scroller.get_minScrollX()) {
			this.scroller.set_restrictedScrollX(this.scroller.get_scrollX());
		} else if(this._prevMaxScrollX != this.scroller.get_maxScrollX() && this.scroller.get_scrollX() > this.scroller.get_maxScrollX()) {
			this.scroller.set_restrictedScrollX(this.scroller.get_scrollX());
		}
		if(this._prevMinScrollY != this.scroller.get_minScrollY() && this.scroller.get_scrollY() < this.scroller.get_minScrollY()) {
			this.scroller.set_restrictedScrollY(this.scroller.get_scrollY());
		} else if(this._prevMaxScrollY != this.scroller.get_maxScrollY() && this.scroller.get_scrollY() > this.scroller.get_maxScrollY()) {
			this.scroller.set_restrictedScrollY(this.scroller.get_scrollY());
		}
	},
	refreshViewPort: function() {
		if((js_Boot().default).__implements(this.scrollBarX,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this.scrollBarX , (feathers_core_IValidating().default))).validateNow();
		}
		if((js_Boot().default).__implements(this.scrollBarY,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this.scrollBarY , (feathers_core_IValidating().default))).validateNow();
		}
		this._viewPort.set_scrollX(this.get_scrollX());
		this._viewPort.set_scrollY(this.get_scrollY());
		this._prevMinScrollX = this.scroller.get_minScrollX();
		this._prevMaxScrollX = this.scroller.get_maxScrollX();
		this._prevMinScrollY = this.scroller.get_minScrollY();
		this._prevMaxScrollY = this.scroller.get_maxScrollY();
		if(!this.needsMeasurement()) {
			this._viewPort.validateNow();
			var oldSettingScrollerDimensions = this._settingScrollerDimensions;
			this._settingScrollerDimensions = true;
			this.scroller.setDimensions(this._viewPort.get_visibleWidth(),this._viewPort.get_visibleHeight(),this._viewPort.get_width(),this._viewPort.get_height());
			this._settingScrollerDimensions = oldSettingScrollerDimensions;
			this.restrictScrollAfterRefreshViewPort();
			return;
		}
		this.resetViewPortOffsets();
		this.calculateViewPortOffsets(false,false);
		this.refreshViewPortBoundsForMeasurement();
		if(this.get_scrollPolicyX() == (feathers_controls_ScrollPolicy().default).AUTO) {
			var oldShowScrollBarX = this.showScrollBarX;
			this.calculateViewPortOffsetsForFixedScrollBarX(false);
			if(this.get_fixedScrollBars() && this.showScrollBarX != oldShowScrollBarX) {
				this.refreshViewPortBoundsForMeasurement();
			}
		}
		if(this.get_scrollPolicyY() == (feathers_controls_ScrollPolicy().default).AUTO) {
			var oldShowScrollBarY = this.showScrollBarY;
			this.calculateViewPortOffsetsForFixedScrollBarY(false);
			if(this.get_fixedScrollBars() && this.showScrollBarY != oldShowScrollBarY) {
				this.refreshViewPortBoundsForMeasurement();
			}
		}
		if(this.get_fixedScrollBars() && !this.showScrollBarX && this.showScrollBarY && this.get_scrollPolicyX() == (feathers_controls_ScrollPolicy().default).AUTO && this.get_scrollPolicyY() == (feathers_controls_ScrollPolicy().default).AUTO) {
			var oldShowScrollBarX1 = this.showScrollBarX;
			this.calculateViewPortOffsetsForFixedScrollBarX(false);
			if(this.showScrollBarX != oldShowScrollBarX1) {
				this.refreshViewPortBoundsForMeasurement();
			}
		}
		var oldSettingScrollerDimensions1 = this._settingScrollerDimensions;
		this._settingScrollerDimensions = true;
		this.scroller.setDimensions(this._viewPort.get_visibleWidth(),this._viewPort.get_visibleHeight(),this._viewPort.get_width(),this._viewPort.get_height());
		this._settingScrollerDimensions = oldSettingScrollerDimensions1;
		this.measure();
		this.resetViewPortOffsets();
		this.calculateViewPortOffsets(false,true);
		this.refreshViewPortBoundsForLayout();
		if(this.get_scrollPolicyX() == (feathers_controls_ScrollPolicy().default).AUTO) {
			var oldShowScrollBarX2 = this.showScrollBarX;
			this.calculateViewPortOffsetsForFixedScrollBarX(true);
			if(this.get_fixedScrollBars() && this.showScrollBarX != oldShowScrollBarX2) {
				this.refreshViewPortBoundsForLayout();
			}
		}
		if(this.get_scrollPolicyY() == (feathers_controls_ScrollPolicy().default).AUTO) {
			var oldShowScrollBarY1 = this.showScrollBarY;
			this.calculateViewPortOffsetsForFixedScrollBarY(true);
			if(this.get_fixedScrollBars() && this.showScrollBarY != oldShowScrollBarY1) {
				this.refreshViewPortBoundsForLayout();
			}
		}
		if(this.get_fixedScrollBars() && !this.showScrollBarX && this.showScrollBarY && this.get_scrollPolicyX() == (feathers_controls_ScrollPolicy().default).AUTO && this.get_scrollPolicyY() == (feathers_controls_ScrollPolicy().default).AUTO) {
			var oldShowScrollBarX3 = this.showScrollBarX;
			this.calculateViewPortOffsetsForFixedScrollBarX(true);
			if(this.showScrollBarX != oldShowScrollBarX3) {
				this.refreshViewPortBoundsForLayout();
			}
		}
		var oldSettingScrollerDimensions2 = this._settingScrollerDimensions;
		this._settingScrollerDimensions = true;
		this.scroller.setDimensions(this._viewPort.get_visibleWidth(),this._viewPort.get_visibleHeight(),this._viewPort.get_width(),this._viewPort.get_height());
		this._settingScrollerDimensions = oldSettingScrollerDimensions2;
		this.restrictScrollAfterRefreshViewPort();
	},
	resetViewPortOffsets: function() {
		this.showScrollBarX = this.get_showScrollBars() && (this._scrollPolicyX == (feathers_controls_ScrollPolicy().default).ON || this._scrollPolicyX == (feathers_controls_ScrollPolicy().default).AUTO && this.scroller.get_minScrollX() != this.scroller.get_maxScrollX());
		this.showScrollBarY = this.get_showScrollBars() && (this._scrollPolicyX == (feathers_controls_ScrollPolicy().default).ON || this._scrollPolicyY == (feathers_controls_ScrollPolicy().default).AUTO && this.scroller.get_minScrollY() != this.scroller.get_maxScrollY());
		this.topViewPortOffset = this.get_fixedScrollBars() && this.showScrollBarX && this.get_scrollBarXPosition() == (feathers_layout_RelativePosition().default).TOP ? this.scrollBarX.get_height() : 0.0;
		this.bottomViewPortOffset = this.get_fixedScrollBars() && this.showScrollBarX && this.get_scrollBarXPosition() == (feathers_layout_RelativePosition().default).BOTTOM ? this.scrollBarX.get_height() : 0.0;
		this.leftViewPortOffset = this.get_fixedScrollBars() && this.showScrollBarY && this.get_scrollBarYPosition() == (feathers_layout_RelativePosition().default).LEFT ? this.scrollBarY.get_width() : 0.0;
		this.rightViewPortOffset = this.get_fixedScrollBars() && this.showScrollBarY && this.get_scrollBarYPosition() == (feathers_layout_RelativePosition().default).RIGHT ? this.scrollBarY.get_width() : 0.0;
		this.chromeMeasuredWidth = 0.0;
		this.chromeMeasuredMinWidth = 0.0;
		this.chromeMeasuredMaxWidth = 1.0 / 0.0;
		this.chromeMeasuredHeight = 0.0;
		this.chromeMeasuredMinHeight = 0.0;
		this.chromeMeasuredMaxHeight = 1.0 / 0.0;
	},
	calculateViewPortOffsets: function(forceScrollBars,useActualBounds) {
	},
	calculateViewPortOffsetsForFixedScrollBarX: function(useActualBounds) {
		if(this.scrollBarX == null) {
			return;
		}
		var newShowScrollBarX = false;
		if(this.get_showScrollBars() && this.get_scrollPolicyX() != (feathers_controls_ScrollPolicy().default).OFF) {
			newShowScrollBarX = this.get_scrollPolicyX() == (feathers_controls_ScrollPolicy().default).ON;
			if(!newShowScrollBarX && this.get_scrollPolicyX() == (feathers_controls_ScrollPolicy().default).AUTO) {
				var availableWidth = useActualBounds ? this.actualWidth : this.get_explicitWidth();
				if(availableWidth != null) {
					availableWidth -= this.get_paddingLeft() + this.get_paddingRight() + this.leftViewPortOffset + this.rightViewPortOffset;
					if(availableWidth < 0.0) {
						availableWidth = 0.0;
					}
				}
				if(availableWidth == null && !useActualBounds) {
					availableWidth = this._viewPort.get_visibleWidth();
				}
				var totalContentWidth = this._viewPort.get_width();
				newShowScrollBarX = availableWidth != null && totalContentWidth > availableWidth && !(feathers_utils_MathUtil().default).fuzzyEquals(totalContentWidth,availableWidth);
				if(!newShowScrollBarX) {
					var maxAvailableWidth = this.get_explicitMaxWidth();
					if(maxAvailableWidth != null) {
						maxAvailableWidth -= this.get_paddingLeft() + this.get_paddingRight() + this.leftViewPortOffset + this.rightViewPortOffset;
						if(maxAvailableWidth < 0.0) {
							maxAvailableWidth = 0.0;
						}
					}
					newShowScrollBarX = maxAvailableWidth != null && totalContentWidth > maxAvailableWidth && !(feathers_utils_MathUtil().default).fuzzyEquals(totalContentWidth,maxAvailableWidth);
				}
			}
		}
		if(this.showScrollBarX == newShowScrollBarX) {
			return;
		}
		this.showScrollBarX = newShowScrollBarX;
		if(!this.get_fixedScrollBars()) {
			return;
		}
		var offset = this.scrollBarX.get_height();
		if(!this.showScrollBarX) {
			offset = -offset;
		}
		if(this.get_scrollBarXPosition() == (feathers_layout_RelativePosition().default).TOP) {
			this.topViewPortOffset += offset;
		} else {
			this.bottomViewPortOffset += offset;
		}
	},
	calculateViewPortOffsetsForFixedScrollBarY: function(useActualBounds) {
		if(this.scrollBarY == null) {
			return;
		}
		var newShowScrollBarY = false;
		if(this.get_showScrollBars() && this.get_scrollPolicyY() != (feathers_controls_ScrollPolicy().default).OFF) {
			newShowScrollBarY = this.get_scrollPolicyY() == (feathers_controls_ScrollPolicy().default).ON;
			if(!newShowScrollBarY && this.get_scrollPolicyY() == (feathers_controls_ScrollPolicy().default).AUTO) {
				var availableHeight = useActualBounds ? this.actualHeight : this.get_explicitHeight();
				if(availableHeight != null) {
					availableHeight -= this.get_paddingTop() + this.get_paddingBottom() + this.topViewPortOffset + this.bottomViewPortOffset;
					if(availableHeight < 0.0) {
						availableHeight = 0.0;
					}
				}
				if(availableHeight == null && !useActualBounds) {
					availableHeight = this._viewPort.get_visibleHeight();
				}
				var totalContentHeight = this._viewPort.get_height();
				newShowScrollBarY = availableHeight != null && totalContentHeight > availableHeight && !(feathers_utils_MathUtil().default).fuzzyEquals(totalContentHeight,availableHeight);
				if(!newShowScrollBarY) {
					var maxAvailableHeight = this.get_explicitMaxHeight();
					if(maxAvailableHeight != null) {
						maxAvailableHeight -= this.get_paddingTop() + this.get_paddingBottom() + this.topViewPortOffset + this.bottomViewPortOffset;
						if(maxAvailableHeight < 0.0) {
							maxAvailableHeight = 0.0;
						}
					}
					newShowScrollBarY = maxAvailableHeight != null && totalContentHeight > maxAvailableHeight && !(feathers_utils_MathUtil().default).fuzzyEquals(totalContentHeight,maxAvailableHeight);
				}
			}
		}
		if(this.showScrollBarY == newShowScrollBarY) {
			return;
		}
		this.showScrollBarY = newShowScrollBarY;
		if(!this.get_fixedScrollBars()) {
			return;
		}
		var offset = this.scrollBarY.get_width();
		if(!this.showScrollBarY) {
			offset = -offset;
		}
		if(this.get_scrollBarYPosition() == (feathers_layout_RelativePosition().default).LEFT) {
			this.leftViewPortOffset += offset;
		} else {
			this.rightViewPortOffset += offset;
		}
	},
	refreshViewPortBoundsForMeasurement: function() {
		var oldIgnoreViewPortResizing = this._ignoreViewPortResizing;
		this._ignoreViewPortResizing = true;
		var viewPortX = this.get_paddingLeft() + this.leftViewPortOffset;
		var viewPortY = this.get_paddingTop() + this.topViewPortOffset;
		if(this._scrollMode == (feathers_controls_ScrollMode().default).MASK || this._scrollMode == (feathers_controls_ScrollMode().default).MASKLESS || this._currentViewPortMaskSkin != null) {
			viewPortX -= this.get_scrollX();
			viewPortY -= this.get_scrollY();
		}
		this._viewPort.set_x(viewPortX);
		this._viewPort.set_y(viewPortY);
		if(this.get_explicitWidth() != null) {
			var visibleWidth = this.get_explicitWidth() - this.leftViewPortOffset - this.rightViewPortOffset - this.get_paddingLeft() - this.get_paddingRight();
			if(visibleWidth < 0.0) {
				visibleWidth = 0.0;
			}
			this._viewPort.set_visibleWidth(visibleWidth);
		} else {
			this._viewPort.set_visibleWidth(null);
		}
		if(this.get_explicitHeight() != null) {
			var visibleHeight = this.get_explicitHeight() - this.topViewPortOffset - this.bottomViewPortOffset - this.get_paddingTop() - this.get_paddingBottom();
			if(visibleHeight < 0.0) {
				visibleHeight = 0.0;
			}
			this._viewPort.set_visibleHeight(visibleHeight);
		} else {
			this._viewPort.set_visibleHeight(null);
		}
		if(this.get_explicitMinWidth() != null) {
			var minVisibleWidth = this.get_explicitMinWidth() - this.leftViewPortOffset - this.rightViewPortOffset - this.get_paddingLeft() - this.get_paddingRight();
			if(minVisibleWidth < 0.0) {
				minVisibleWidth = 0.0;
			}
			this._viewPort.set_minVisibleWidth(minVisibleWidth);
		} else {
			this._viewPort.set_minVisibleWidth(null);
		}
		if(this.get_explicitMinHeight() != null) {
			var minVisibleHeight = this.get_explicitMinHeight() - this.topViewPortOffset - this.bottomViewPortOffset - this.get_paddingTop() - this.get_paddingBottom();
			if(minVisibleHeight < 0.0) {
				minVisibleHeight = 0.0;
			}
			this._viewPort.set_minVisibleHeight(minVisibleHeight);
		} else {
			this._viewPort.set_minVisibleHeight(null);
		}
		if(this.get_explicitMaxWidth() != null) {
			var maxVisibleWidth = this.get_explicitMaxWidth() - this.leftViewPortOffset - this.rightViewPortOffset - this.get_paddingLeft() - this.get_paddingRight();
			if(maxVisibleWidth < 0.0) {
				maxVisibleWidth = 0.0;
			}
			this._viewPort.set_maxVisibleWidth(maxVisibleWidth);
		} else if(this._backgroundSkinMeasurements != null && this._backgroundSkinMeasurements.maxWidth != null) {
			var maxVisibleWidth1 = this._backgroundSkinMeasurements.maxWidth - this.leftViewPortOffset - this.rightViewPortOffset - this.get_paddingLeft() - this.get_paddingRight();
			if(maxVisibleWidth1 < 0.0) {
				maxVisibleWidth1 = 0.0;
			}
			this._viewPort.set_maxVisibleWidth(maxVisibleWidth1);
		} else {
			this._viewPort.set_maxVisibleWidth(1.0 / 0.0);
		}
		if(this.get_explicitMaxHeight() != null) {
			var maxVisibleHeight = this.get_explicitMaxHeight() - this.topViewPortOffset - this.bottomViewPortOffset - this.get_paddingTop() - this.get_paddingBottom();
			if(maxVisibleHeight < 0.0) {
				maxVisibleHeight = 0.0;
			}
			this._viewPort.set_maxVisibleHeight(maxVisibleHeight);
		} else if(this._backgroundSkinMeasurements != null && this._backgroundSkinMeasurements.maxHeight != null) {
			var maxVisibleHeight1 = this._backgroundSkinMeasurements.maxHeight - this.topViewPortOffset - this.bottomViewPortOffset - this.get_paddingTop() - this.get_paddingBottom();
			if(maxVisibleHeight1 < 0.0) {
				maxVisibleHeight1 = 0.0;
			}
			this._viewPort.set_maxVisibleHeight(maxVisibleHeight1);
		} else {
			this._viewPort.set_maxVisibleHeight(1.0 / 0.0);
		}
		this._viewPort.validateNow();
		this._ignoreViewPortResizing = oldIgnoreViewPortResizing;
	},
	refreshViewPortBoundsForLayout: function() {
		var oldIgnoreViewPortResizing = this._ignoreViewPortResizing;
		this._ignoreViewPortResizing = true;
		var visibleWidth = this.actualWidth - this.leftViewPortOffset - this.rightViewPortOffset - this.get_paddingLeft() - this.get_paddingRight();
		if(visibleWidth < 0.0) {
			visibleWidth = 0.0;
		}
		var visibleHeight = this.actualHeight - this.topViewPortOffset - this.bottomViewPortOffset - this.get_paddingTop() - this.get_paddingBottom();
		if(visibleHeight < 0.0) {
			visibleHeight = 0.0;
		}
		var minVisibleWidth = this.actualMinWidth - this.leftViewPortOffset - this.rightViewPortOffset - this.get_paddingLeft() - this.get_paddingRight();
		if(minVisibleWidth < 0.0) {
			minVisibleWidth = 0.0;
		}
		var minVisibleHeight = this.actualMinHeight - this.topViewPortOffset - this.bottomViewPortOffset - this.get_paddingTop() - this.get_paddingBottom();
		if(minVisibleHeight < 0.0) {
			minVisibleHeight = 0.0;
		}
		var maxVisibleWidth = this.actualMaxWidth - this.leftViewPortOffset - this.rightViewPortOffset - this.get_paddingLeft() - this.get_paddingRight();
		if(maxVisibleWidth < 0.0) {
			maxVisibleWidth = 0.0;
		}
		var maxVisibleHeight = this.actualMaxHeight - this.topViewPortOffset - this.bottomViewPortOffset - this.get_paddingTop() - this.get_paddingBottom();
		if(maxVisibleHeight < 0.0) {
			maxVisibleHeight = 0.0;
		}
		var viewPortX = this.get_paddingLeft() + this.leftViewPortOffset;
		var viewPortY = this.get_paddingTop() + this.topViewPortOffset;
		if(this._scrollMode == (feathers_controls_ScrollMode().default).MASK || this._scrollMode == (feathers_controls_ScrollMode().default).MASKLESS || this._currentViewPortMaskSkin != null) {
			viewPortX -= this.get_scrollX();
			viewPortY -= this.get_scrollY();
		}
		this._viewPort.set_x(viewPortX);
		this._viewPort.set_y(viewPortY);
		this._viewPort.set_visibleWidth(visibleWidth);
		this._viewPort.set_visibleHeight(visibleHeight);
		this._viewPort.set_minVisibleWidth(minVisibleWidth);
		this._viewPort.set_minVisibleHeight(minVisibleHeight);
		this._viewPort.set_maxVisibleWidth(maxVisibleWidth);
		this._viewPort.set_maxVisibleHeight(maxVisibleHeight);
		this._viewPort.validateNow();
		this._ignoreViewPortResizing = oldIgnoreViewPortResizing;
	},
	refreshScrollerValues: function() {
		if(this.stage != null) {
			this.scroller.set_target((js_Boot().default).__cast(this._viewPort , (openfl_display_InteractiveObject())));
		}
		this.scroller.enabledX = this._enabled && this._scrollPolicyX != (feathers_controls_ScrollPolicy().default).OFF;
		this.scroller.enabledY = this._enabled && this._scrollPolicyY != (feathers_controls_ScrollPolicy().default).OFF;
	},
	refreshScrollBarValues: function() {
		if(this.scrollBarX != null) {
			var oldIgnoreScrollBarXChange = this._ignoreScrollBarXChange;
			this._ignoreScrollBarXChange = true;
			this.scrollBarX.set_minimum(this.scroller.get_minScrollX());
			this.scrollBarX.set_maximum(this.scroller.get_maxScrollX());
			this.scrollBarX.set_value(this.scroller.get_scrollX());
			this.scrollBarX.set_page((this.scroller.get_maxScrollX() - this.scroller.get_minScrollX()) * this._viewPort.get_visibleWidth() / this._viewPort.get_width());
			this.scrollBarX.set_step(this._scrollStepX);
			var displayScrollBarX = (js_Boot().default).__cast(this.scrollBarX , (openfl_display_DisplayObjectContainer()));
			displayScrollBarX.set_visible(this.showScrollBarX);
			if(this.get_fixedScrollBars() || !this.get_autoHideScrollBars()) {
				this.scrollBarX.set_alpha(1.0);
			}
			this._ignoreScrollBarXChange = oldIgnoreScrollBarXChange;
		}
		if(this.scrollBarY != null) {
			var oldIgnoreScrollBarYChange = this._ignoreScrollBarYChange;
			this._ignoreScrollBarYChange = true;
			this.scrollBarY.set_minimum(this.scroller.get_minScrollY());
			this.scrollBarY.set_maximum(this.scroller.get_maxScrollY());
			this.scrollBarY.set_value(this.scroller.get_scrollY());
			this.scrollBarY.set_page((this.scroller.get_maxScrollY() - this.scroller.get_minScrollY()) * this._viewPort.get_visibleHeight() / this._viewPort.get_height());
			this.scrollBarY.set_step(this._scrollStepY);
			var displayScrollBarY = (js_Boot().default).__cast(this.scrollBarY , (openfl_display_DisplayObjectContainer()));
			displayScrollBarY.set_visible(this.showScrollBarY);
			if(this.get_fixedScrollBars() || !this.get_autoHideScrollBars()) {
				this.scrollBarY.set_alpha(1.0);
			}
			this._ignoreScrollBarYChange = oldIgnoreScrollBarYChange;
		}
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		if(this._currentBackgroundSkin != null) {
			(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParent(this._backgroundSkinMeasurements,this._currentBackgroundSkin,this);
		}
		var measureSkin = null;
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IMeasureObject().default))) {
			measureSkin = (js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IMeasureObject().default));
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			if(this.get_measureViewPort()) {
				newWidth = this._viewPort.get_visibleWidth();
			} else {
				newWidth = 0.0;
			}
			newWidth += this.leftViewPortOffset + this.rightViewPortOffset;
			newWidth = Math.max(newWidth,this.chromeMeasuredWidth);
			newWidth += this.get_paddingLeft() + this.get_paddingRight();
			if(this._currentBackgroundSkin != null) {
				newWidth = Math.max(newWidth,this._currentBackgroundSkin.get_width());
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			if(this.get_measureViewPort()) {
				newHeight = this._viewPort.get_visibleHeight();
			} else {
				newHeight = 0.0;
			}
			newHeight += this.topViewPortOffset + this.bottomViewPortOffset;
			newHeight = Math.max(newHeight,this.chromeMeasuredHeight);
			newHeight += this.get_paddingTop() + this.get_paddingBottom();
			if(this._currentBackgroundSkin != null) {
				newHeight = Math.max(newHeight,this._currentBackgroundSkin.get_height());
			}
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			if(this.get_measureViewPort()) {
				newMinWidth = this._viewPort.get_minVisibleWidth();
			} else {
				newMinWidth = 0.0;
			}
			newMinWidth += this.leftViewPortOffset + this.rightViewPortOffset;
			newMinWidth = Math.max(newMinWidth,this.chromeMeasuredMinWidth);
			newMinWidth += this.get_paddingLeft() + this.get_paddingRight();
			if(measureSkin != null) {
				newMinWidth = Math.max(newMinWidth,measureSkin.get_minWidth());
			} else if(this._backgroundSkinMeasurements != null) {
				newMinWidth = Math.max(newMinWidth,this._backgroundSkinMeasurements.minWidth);
			}
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			if(this.get_measureViewPort()) {
				newMinHeight = this._viewPort.get_minVisibleHeight();
			} else {
				newMinHeight = 0.0;
			}
			newMinHeight += this.topViewPortOffset + this.bottomViewPortOffset;
			newMinHeight = Math.max(newMinHeight,this.chromeMeasuredMinHeight);
			newMinHeight += this.get_paddingTop() + this.get_paddingBottom();
			if(measureSkin != null) {
				newMinHeight = Math.max(newMinHeight,measureSkin.get_minHeight());
			} else if(this._backgroundSkinMeasurements != null) {
				newMinHeight = Math.max(newMinHeight,this._backgroundSkinMeasurements.minHeight);
			}
		}
		var newMaxWidth = this.get_explicitMaxWidth();
		if(needsMaxWidth) {
			if(this.get_measureViewPort()) {
				newMaxWidth = this._viewPort.get_maxVisibleWidth();
			} else {
				newMaxWidth = 1.0 / 0.0;
			}
			newMaxWidth += this.leftViewPortOffset + this.rightViewPortOffset;
			newMaxWidth = Math.min(newMaxWidth,this.chromeMeasuredMaxWidth);
			newMaxWidth += this.get_paddingLeft() + this.get_paddingRight();
			if(measureSkin != null) {
				newMaxWidth = Math.min(newMaxWidth,measureSkin.get_maxWidth());
			} else if(this._backgroundSkinMeasurements != null) {
				newMaxWidth = Math.min(newMaxWidth,this._backgroundSkinMeasurements.maxWidth);
			}
		}
		var newMaxHeight = this.get_explicitMaxHeight();
		if(needsMaxHeight) {
			if(this.get_measureViewPort()) {
				newMaxHeight = this._viewPort.get_maxVisibleHeight();
			} else {
				newMaxHeight = 1.0 / 0.0;
			}
			newMaxHeight += this.topViewPortOffset + this.bottomViewPortOffset;
			newMaxHeight = Math.min(newMaxHeight,this.chromeMeasuredMaxHeight);
			newMaxHeight += this.get_paddingTop() + this.get_paddingBottom();
			if(measureSkin != null) {
				newMaxHeight = Math.min(newMaxHeight,measureSkin.get_maxHeight());
			} else if(this._backgroundSkinMeasurements != null) {
				newMaxHeight = Math.min(newMaxHeight,this._backgroundSkinMeasurements.maxHeight);
			}
		}
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight,newMaxWidth,newMaxHeight);
	},
	refreshBackgroundSkin: function() {
		var oldSkin = this._currentBackgroundSkin;
		this._currentBackgroundSkin = this.getCurrentBackgroundSkin();
		if(this._currentBackgroundSkin == oldSkin) {
			return;
		}
		this.removeCurrentBackgroundSkin(oldSkin);
		this.addCurrentBackgroundSkin(this._currentBackgroundSkin);
	},
	getCurrentBackgroundSkin: function() {
		if(!this._enabled && this.get_disabledBackgroundSkin() != null) {
			return this.get_disabledBackgroundSkin();
		}
		return this.get_backgroundSkin();
	},
	addCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			this._backgroundSkinMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._backgroundSkinMeasurements == null) {
			this._backgroundSkinMeasurements = new (feathers_layout_Measurements().default)(skin);
		} else {
			this._backgroundSkinMeasurements.save(skin);
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this.addChildAt(skin,0);
	},
	removeCurrentBackgroundSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		this._backgroundSkinMeasurements.restore(skin);
		if(skin.parent == this) {
			this.removeChild(skin);
		}
	},
	refreshMaskSkin: function() {
		var oldSkin = this._currentMaskSkin;
		this._currentMaskSkin = this.getCurrentMaskSkin();
		if(this._currentMaskSkin == oldSkin) {
			return;
		}
		this.removeCurrentMaskSkin(oldSkin);
		this.addCurrentMaskSkin(this._currentMaskSkin);
	},
	getCurrentMaskSkin: function() {
		return this.get_maskSkin();
	},
	addCurrentMaskSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this.addChild(skin);
		this.set_mask(skin);
	},
	removeCurrentMaskSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		if(skin.parent == this) {
			this.removeChild(skin);
		}
		this.set_mask(null);
	},
	refreshViewPortMaskSkin: function() {
		var oldSkin = this._currentViewPortMaskSkin;
		this._currentViewPortMaskSkin = this.getCurrentViewPortMaskSkin();
		if(this._currentViewPortMaskSkin == oldSkin) {
			return;
		}
		this.removeCurrentViewPortMaskSkin(oldSkin);
		this.addCurrentViewPortMaskSkin(this._currentViewPortMaskSkin);
	},
	getCurrentViewPortMaskSkin: function() {
		if(this.get_viewPortMaskSkin() != null) {
			return this.get_viewPortMaskSkin();
		}
		if(this._scrollMode == (feathers_controls_ScrollMode().default).MASK) {
			if(this._fallbackViewPortMaskSkin == null) {
				this._fallbackViewPortMaskSkin = new (feathers_skins_RectangleSkin().default)((feathers_graphics_FillStyle().default).SolidColor(16711935));
			}
			return this._fallbackViewPortMaskSkin;
		}
		return null;
	},
	addCurrentViewPortMaskSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(skin , (feathers_core_IUIControl().default))).initializeNow();
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
		}
		this.addChild(skin);
		((js_Boot().default).__cast(this._viewPort , (openfl_display_DisplayObject()))).set_mask(skin);
	},
	removeCurrentViewPortMaskSkin: function(skin) {
		if(skin == null) {
			return;
		}
		if((js_Boot().default).__implements(skin,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(skin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		if(skin.parent == this) {
			this.removeChild(skin);
		}
		((js_Boot().default).__cast(this._viewPort , (openfl_display_DisplayObject()))).set_mask(null);
	},
	layoutChildren: function() {
		this.layoutBackgroundSkin();
		this.layoutMaskSkin();
		this.layoutViewPortMaskSkin();
		this.layoutScrollBars();
	},
	layoutBackgroundSkin: function() {
		if(this._currentBackgroundSkin == null) {
			return;
		}
		this._currentBackgroundSkin.set_x(0.0);
		this._currentBackgroundSkin.set_y(0.0);
		if(this._currentBackgroundSkin.get_width() != this.actualWidth) {
			this._currentBackgroundSkin.set_width(this.actualWidth);
		}
		if(this._currentBackgroundSkin.get_height() != this.actualHeight) {
			this._currentBackgroundSkin.set_height(this.actualHeight);
		}
		if((js_Boot().default).__implements(this._currentBackgroundSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentBackgroundSkin , (feathers_core_IValidating().default))).validateNow();
		}
	},
	layoutMaskSkin: function() {
		if(this._currentMaskSkin == null) {
			return;
		}
		this._currentMaskSkin.set_x(0.0);
		this._currentMaskSkin.set_y(0.0);
		this._currentMaskSkin.set_width(this.actualWidth);
		this._currentMaskSkin.set_height(this.actualHeight);
		if((js_Boot().default).__implements(this._currentMaskSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentMaskSkin , (feathers_core_IValidating().default))).validateNow();
		}
	},
	layoutViewPortMaskSkin: function() {
		if(this._currentViewPortMaskSkin == null) {
			return;
		}
		var maskX = this.get_paddingLeft() + this.leftViewPortOffset;
		var maskY = this.get_paddingTop() + this.topViewPortOffset;
		var maskWidth = this._viewPort.get_visibleWidth();
		var maskHeight = this._viewPort.get_visibleHeight();
		if(this.get_fixedScrollBars() && this.scrollBarY.get_visible()) {
			maskWidth += this.scrollBarY.get_width();
			if(this.get_scrollBarYPosition() == (feathers_layout_RelativePosition().default).LEFT) {
				maskX -= this.scrollBarY.get_width();
			}
		}
		if(this.get_fixedScrollBars() && this.scrollBarX.get_visible()) {
			maskHeight += this.scrollBarX.get_height();
			if(this.get_scrollBarXPosition() == (feathers_layout_RelativePosition().default).TOP) {
				maskX -= this.scrollBarX.get_height();
			}
		}
		this._currentViewPortMaskSkin.set_x(maskX);
		this._currentViewPortMaskSkin.set_y(maskY);
		this._currentViewPortMaskSkin.set_width(maskWidth);
		this._currentViewPortMaskSkin.set_height(maskHeight);
		if((js_Boot().default).__implements(this._currentViewPortMaskSkin,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentViewPortMaskSkin , (feathers_core_IValidating().default))).validateNow();
		}
	},
	layoutScrollBars: function() {
		var visibleWidth = this.actualWidth - this.leftViewPortOffset - this.rightViewPortOffset - this.get_paddingLeft() - this.get_paddingRight();
		if(visibleWidth < 0.0) {
			visibleWidth = 0.0;
		}
		var visibleHeight = this.actualHeight - this.topViewPortOffset - this.bottomViewPortOffset - this.get_paddingTop() - this.get_paddingBottom();
		if(visibleHeight < 0.0) {
			visibleHeight = 0.0;
		}
		if(this.scrollBarX != null && (js_Boot().default).__implements(this.scrollBarX,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this.scrollBarX , (feathers_core_IValidating().default))).validateNow();
		}
		if(this.scrollBarY != null && (js_Boot().default).__implements(this.scrollBarY,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this.scrollBarY , (feathers_core_IValidating().default))).validateNow();
		}
		if(this.scrollBarX != null) {
			if(this.get_scrollBarXPosition()._hx_index == 0) {
				this.scrollBarX.set_y(this.get_paddingTop());
			} else {
				this.scrollBarX.set_y(this.get_paddingTop() + this.topViewPortOffset + visibleHeight);
			}
			this.scrollBarX.set_x(this.get_paddingLeft() + this.leftViewPortOffset);
			if(!this.get_fixedScrollBars()) {
				var _g1 = this.scrollBarX;
				_g1.set_y(_g1.get_y() - this.scrollBarX.get_height());
				if((this.showScrollBarY || this._hideScrollBarY != null) && this.scrollBarY != null) {
					var scrollBarXWidth = visibleWidth - this.scrollBarY.get_width();
					if(scrollBarXWidth < 0.0) {
						scrollBarXWidth = 0.0;
					}
					this.scrollBarX.set_width(scrollBarXWidth);
				} else {
					this.scrollBarX.set_width(visibleWidth);
				}
			} else {
				this.scrollBarX.set_width(visibleWidth);
			}
		}
		if(this.scrollBarY != null) {
			if(this.get_scrollBarYPosition()._hx_index == 3) {
				this.scrollBarY.set_x(this.get_paddingLeft());
			} else {
				this.scrollBarY.set_x(this.get_paddingLeft() + this.leftViewPortOffset + visibleWidth);
			}
			this.scrollBarY.set_y(this.get_paddingTop() + this.topViewPortOffset);
			if(!this.get_fixedScrollBars()) {
				var _g11 = this.scrollBarY;
				_g11.set_x(_g11.get_x() - this.scrollBarY.get_width());
				if((this.showScrollBarX || this._hideScrollBarX != null) && this.scrollBarX != null) {
					var scrollBarYHeight = visibleHeight - this.scrollBarX.get_height();
					if(scrollBarYHeight < 0.0) {
						scrollBarYHeight = 0.0;
					}
					this.scrollBarY.set_height(scrollBarYHeight);
				} else {
					this.scrollBarY.set_height(visibleHeight);
				}
			} else {
				this.scrollBarY.set_height(visibleHeight);
			}
		}
	},
	refreshScrollRect: function() {
		var scrollX = this.scroller.get_scrollX();
		var scrollY = this.scroller.get_scrollY();
		if(this.get_scrollPixelSnapping()) {
			var scaleFactorX = (feathers_utils_DisplayUtil().default).getConcatenatedScaleX(this);
			var scaleFactorY = (feathers_utils_DisplayUtil().default).getConcatenatedScaleY(this);
			scrollX = Math.round(scrollX / scaleFactorX) * scaleFactorX;
			scrollY = Math.round(scrollY / scaleFactorY) * scaleFactorY;
		}
		if(this._scrollMode == (feathers_controls_ScrollMode().default).MASK || this._scrollMode == (feathers_controls_ScrollMode().default).MASKLESS || this._currentViewPortMaskSkin != null) {
			var displayViewPort = (js_Boot().default).__cast(this._viewPort , (openfl_display_DisplayObject()));
			displayViewPort.set_scrollRect(null);
			this._viewPort.set_x(this.get_paddingLeft() + this.leftViewPortOffset - scrollX);
			this._viewPort.set_y(this.get_paddingTop() + this.topViewPortOffset - scrollY);
		} else if(this._scrollMode == (feathers_controls_ScrollMode().default).SCROLL_RECT) {
			var scrollRect = this._scrollRect1;
			if(this._currentScrollRect == scrollRect) {
				scrollRect = this._scrollRect2;
			}
			this._currentScrollRect = scrollRect;
			var scrollRectWidth = this.actualWidth - this.leftViewPortOffset - this.rightViewPortOffset - this.get_paddingLeft() - this.get_paddingRight();
			if(scrollRectWidth < 0.0) {
				scrollRectWidth = 0.0;
			}
			var scrollRectHeight = this.actualHeight - this.topViewPortOffset - this.bottomViewPortOffset - this.get_paddingTop() - this.get_paddingBottom();
			if(scrollRectHeight < 0.0) {
				scrollRectHeight = 0.0;
			}
			scrollRect.setTo(scrollX,scrollY,scrollRectWidth,scrollRectHeight);
			var displayViewPort1 = (js_Boot().default).__cast(this._viewPort , (openfl_display_DisplayObject()));
			displayViewPort1.set_scrollRect(scrollRect);
		} else {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown scrollMode: " + (Std().default).string(this._scrollMode)));
		}
	},
	revealScrollBarX: function() {
		if(this.scrollBarX == null || this.scroller.get_minScrollX() == this.scroller.get_maxScrollX()) {
			return;
		}
		if(this._hideScrollBarX != null) {
			(motion_Actuate()).stop(this._hideScrollBarX);
		}
		this.scrollBarX.set_alpha(1.0);
		this._scrollBarXRevealTime = (openfl_Lib()).getTimer();
	},
	revealScrollBarY: function() {
		if(this.scrollBarY == null || this.scroller.get_minScrollY() == this.scroller.get_maxScrollY()) {
			return;
		}
		if(this._hideScrollBarY != null) {
			(motion_Actuate()).stop(this._hideScrollBarY);
		}
		this.scrollBarY.set_alpha(1.0);
		this._scrollBarYRevealTime = (openfl_Lib()).getTimer();
	},
	hideScrollBarX: function() {
		var _gthis = this;
		if(this.scrollBarX == null || this._hideScrollBarX != null) {
			return;
		}
		if(this.scrollBarX.get_alpha() == 0.0) {
			return;
		}
		if(this.get_hideScrollBarDuration() == 0.0) {
			this.scrollBarX.set_alpha(0.0);
			return;
		}
		var tween = (motion_Actuate()).update(function(alpha) {
			return _gthis.scrollBarX.set_alpha(alpha);
		},this.get_hideScrollBarDuration(),[this.scrollBarX.get_alpha()],[0.0],true);
		this._hideScrollBarX = (js_Boot().default).__cast(tween , (motion_actuators_SimpleActuator()));
		this._hideScrollBarX.ease(this.get_hideScrollBarEase());
		this._hideScrollBarX.autoVisible(false);
		var visibleTime = ((openfl_Lib()).getTimer() - this._scrollBarXRevealTime) / 1000.0;
		if(visibleTime < this.get_showScrollBarMinimumDuration()) {
			this._hideScrollBarX.delay(this.get_showScrollBarMinimumDuration() - visibleTime);
		}
		this._hideScrollBarX.onComplete($bind(this,this.hideScrollBarX_onComplete));
	},
	hideScrollBarY: function() {
		var _gthis = this;
		if(this.scrollBarY == null || this._hideScrollBarY != null) {
			return;
		}
		if(this.scrollBarY.get_alpha() == 0.0) {
			return;
		}
		if(this.get_hideScrollBarDuration() == 0.0) {
			this.scrollBarY.set_alpha(0.0);
			return;
		}
		var tween = (motion_Actuate()).update(function(alpha) {
			return _gthis.scrollBarY.set_alpha(alpha);
		},this.get_hideScrollBarDuration(),[this.scrollBarY.get_alpha()],[0.0],true);
		this._hideScrollBarY = (js_Boot().default).__cast(tween , (motion_actuators_SimpleActuator()));
		this._hideScrollBarY.ease(this.get_hideScrollBarEase());
		this._hideScrollBarY.autoVisible(false);
		var visibleTime = ((openfl_Lib()).getTimer() - this._scrollBarYRevealTime) / 1000.0;
		if(visibleTime < this.get_showScrollBarMinimumDuration()) {
			this._hideScrollBarY.delay(this.get_showScrollBarMinimumDuration() - visibleTime);
		}
		this._hideScrollBarY.onComplete($bind(this,this.hideScrollBarY_onComplete));
	},
	checkForRevealScrollBars: function() {
		if(!this._scrollerDraggingX && this.scroller.get_draggingX()) {
			this._scrollerDraggingX = true;
			this.revealScrollBarX();
		}
		if(!this._scrollerDraggingY && this.scroller.get_draggingY()) {
			this._scrollerDraggingY = true;
			this.revealScrollBarY();
		}
	},
	scrollWithKeyboard: function(event) {
		if(this._scrollPolicyY == (feathers_controls_ScrollPolicy().default).OFF && this._scrollPolicyX == (feathers_controls_ScrollPolicy().default).OFF) {
			return;
		}
		var stepX = this._scrollStepX;
		if(stepX <= 0.0) {
			stepX = 1.0;
		}
		var stepY = this._scrollStepY;
		if(stepY <= 0.0) {
			stepY = 1.0;
		}
		var newScrollX = this.get_scrollX();
		var newScrollY = this.get_scrollY();
		switch(event.keyCode) {
		case 33:
			newScrollY = this.get_scrollY() - this._viewPort.get_visibleHeight();
			break;
		case 34:
			newScrollY = this.get_scrollY() + this._viewPort.get_visibleHeight();
			break;
		case 35:
			newScrollY = this.get_maxScrollY();
			break;
		case 36:
			newScrollY = this.get_minScrollY();
			break;
		case 37:
			newScrollX = this.get_scrollX() - stepX;
			break;
		case 38:
			newScrollY = this.get_scrollY() - stepY;
			break;
		case 39:
			newScrollX = this.get_scrollX() + stepX;
			break;
		case 40:
			newScrollY = this.get_scrollY() + stepY;
			break;
		default:
			return;
		}
		if(newScrollY < this.get_minScrollY()) {
			newScrollY = this.get_minScrollY();
		} else if(newScrollY > this.get_maxScrollY()) {
			newScrollY = this.get_maxScrollY();
		}
		if(newScrollX < this.get_minScrollX()) {
			newScrollX = this.get_minScrollX();
		} else if(newScrollX > this.get_maxScrollX()) {
			newScrollX = this.get_maxScrollX();
		}
		var scrolled = false;
		if(this.get_scrollY() != newScrollY && this._scrollPolicyY != (feathers_controls_ScrollPolicy().default).OFF) {
			scrolled = true;
			this.set_scrollY(newScrollY);
		}
		if(this.get_scrollX() != newScrollX && this._scrollPolicyX != (feathers_controls_ScrollPolicy().default).OFF) {
			scrolled = true;
			this.set_scrollX(newScrollX);
		}
		if(scrolled) {
			event.preventDefault();
		}
	},
	baseScrollContainer_addedToStageHandler: function(event) {
		this.setInvalid((feathers_core_InvalidationFlag().default).SCROLL);
	},
	baseScrollContainer_removedFromStageHandler: function(event) {
		if(this.scroller != null) {
			this.scroller.set_target(null);
		}
	},
	baseScrollContainer_keyDownHandler: function(event) {
		if(!this._enabled || event.isDefaultPrevented()) {
			return;
		}
		this.scrollWithKeyboard(event);
	},
	baseScrollContainer_scroller_scrollStartHandler: function(event) {
		var touchPointID = this.scroller.get_touchPointID();
		if(this.scroller.get_touchPointIsSimulated()) {
			var exclusivePointer = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
			var result = exclusivePointer.claimMouse(this);
			if(!result) {
				this.scroller.stop();
				return;
			}
		} else if(touchPointID != null) {
			var exclusivePointer1 = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
			var result1 = exclusivePointer1.claimTouch(touchPointID,this);
			if(!result1) {
				this.scroller.stop();
				return;
			}
		}
		this._viewPort.addEventListener("mouseDown",$bind(this,this.baseScrollContainer_viewPort_mouseDownHandler));
		this._viewPort.addEventListener("touchBegin",$bind(this,this.baseScrollContainer_viewPort_touchBeginHandler));
		this._scrollerDraggingX = false;
		this._scrollerDraggingY = false;
		this.checkForRevealScrollBars();
		(feathers_events_ScrollEvent().default).dispatch(this,"scrollStart",false,false,this.scroller.get_scrollX(),this.scroller.get_scrollY());
	},
	baseScrollContainer_scroller_scrollHandler: function(event) {
		if(this._ignoreScrollerChanges) {
			if(this._settingScrollerDimensions && this.needsScrollMeasurement()) {
				this.setInvalid((feathers_core_InvalidationFlag().default).SCROLL);
			} else {
				this._viewPort.set_scrollX(this.get_scrollX());
				this._viewPort.set_scrollY(this.get_scrollY());
			}
			return;
		}
		this.checkForRevealScrollBars();
		if(this.needsScrollMeasurement()) {
			this.setInvalid((feathers_core_InvalidationFlag().default).SCROLL);
		} else {
			this._viewPort.set_scrollX(this.get_scrollX());
			this._viewPort.set_scrollY(this.get_scrollY());
			this.refreshScrollRect();
			this.refreshScrollBarValues();
		}
		(feathers_events_ScrollEvent().default).dispatch(this,"scroll",false,false,this.scroller.get_scrollX(),this.scroller.get_scrollY());
	},
	baseScrollContainer_scroller_scrollCompleteHandler: function(event) {
		this._viewPort.removeEventListener("mouseDown",$bind(this,this.baseScrollContainer_viewPort_mouseDownHandler));
		this._viewPort.removeEventListener("touchBegin",$bind(this,this.baseScrollContainer_viewPort_touchBeginHandler));
		this._scrollerDraggingX = false;
		this._scrollerDraggingY = false;
		if(!this._scrollBarXHover && !this.get_fixedScrollBars() && this.get_autoHideScrollBars()) {
			this.hideScrollBarX();
		}
		if(!this._scrollBarYHover && !this.get_fixedScrollBars() && this.get_autoHideScrollBars()) {
			this.hideScrollBarY();
		}
		(feathers_events_ScrollEvent().default).dispatch(this,"scrollComplete",false,false,this.scroller.get_scrollX(),this.scroller.get_scrollY());
	},
	reclaimMouse: function() {
		if(!this.scroller.get_touchPointIsSimulated()) {
			return;
		}
		var exclusivePointer = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
		var claim = exclusivePointer.getMouseClaim();
		if(claim != null) {
			return;
		}
		exclusivePointer.claimMouse(this);
	},
	reclaimTouch: function(touchPointID) {
		if(this.scroller.get_touchPointIsSimulated() || this.scroller.get_touchPointID() == null || this.scroller.get_touchPointID() != touchPointID) {
			return;
		}
		var exclusivePointer = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
		var claim = exclusivePointer.getTouchClaim(touchPointID);
		if(claim != null) {
			return;
		}
		exclusivePointer.claimTouch(touchPointID,this);
	},
	baseScrollContainer_viewPort_mouseDownHandler: function(event) {
		this.reclaimMouse();
	},
	baseScrollContainer_viewPort_touchBeginHandler: function(event) {
		this.reclaimTouch(event.touchPointID);
	},
	scrollBarX_changeHandler: function(event) {
		if(this._ignoreScrollBarXChange) {
			return;
		}
		this.scroller.set_scrollX(this.scrollBarX.get_value());
	},
	scrollBarY_changeHandler: function(event) {
		if(this._ignoreScrollBarYChange) {
			return;
		}
		this.scroller.set_scrollY(this.scrollBarY.get_value());
	},
	scrollBarX_rollOverHandler: function(event) {
		this._scrollBarXHover = true;
		this.revealScrollBarX();
	},
	scrollBarX_rollOutHandler: function(event) {
		if(!this._scrollBarXHover) {
			return;
		}
		this._scrollBarXHover = false;
		if(!this._scrollerDraggingX && !this.get_fixedScrollBars() && this.get_autoHideScrollBars()) {
			this.hideScrollBarX();
		}
	},
	scrollBarY_rollOverHandler: function(event) {
		this._scrollBarYHover = true;
		this.revealScrollBarY();
	},
	scrollBarY_rollOutHandler: function(event) {
		if(!this._scrollBarYHover) {
			return;
		}
		this._scrollBarYHover = false;
		if(!this._scrollerDraggingY && !this.get_fixedScrollBars() && this.get_autoHideScrollBars()) {
			this.hideScrollBarY();
		}
	},
	scrollBarX_scrollStartHandler: function(event) {
		this.scroller.stop();
		this._scrollerDraggingX = true;
		(feathers_events_ScrollEvent().default).dispatch(this,"scrollStart",false,false,this.scroller.get_scrollX(),this.scroller.get_scrollY());
	},
	scrollBarX_scrollCompleteHandler: function(event) {
		this._scrollerDraggingX = false;
		if(!this._scrollBarXHover && !this.get_fixedScrollBars() && this.get_autoHideScrollBars()) {
			this.hideScrollBarX();
		}
		(feathers_events_ScrollEvent().default).dispatch(this,"scrollComplete",false,false,this.scroller.get_scrollX(),this.scroller.get_scrollY());
	},
	scrollBarY_scrollStartHandler: function(event) {
		this.scroller.stop();
		this._scrollerDraggingY = true;
		(feathers_events_ScrollEvent().default).dispatch(this,"scrollStart",false,false,this.scroller.get_scrollX(),this.scroller.get_scrollY());
	},
	scrollBarY_scrollCompleteHandler: function(event) {
		this._scrollerDraggingY = false;
		if(!this._scrollBarYHover && !this.get_fixedScrollBars() && this.get_autoHideScrollBars()) {
			this.hideScrollBarY();
		}
		(feathers_events_ScrollEvent().default).dispatch(this,"scrollComplete",false,false,this.scroller.get_scrollX(),this.scroller.get_scrollY());
	},
	hideScrollBarX_onComplete: function() {
		this._hideScrollBarX = null;
	},
	hideScrollBarY_onComplete: function() {
		this._hideScrollBarY = null;
	},
	viewPort_resizeHandler: function(event) {
		if(this._ignoreViewPortResizing) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
	},
	get_paddingTop: function() {
		return this.__paddingTop;
	},
	set_paddingTop: function(value) {
		if(!this.setStyle("paddingTop")) {
			return this.__paddingTop;
		}
		if(this.__paddingTop == value) {
			return this.__paddingTop;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingTop);
		this.__paddingTop = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingTop;
	},
	clearStyle_paddingTop: function() {
		this.set_paddingTop(0.0);
		return this.get_paddingTop();
	},
	get_paddingRight: function() {
		return this.__paddingRight;
	},
	set_paddingRight: function(value) {
		if(!this.setStyle("paddingRight")) {
			return this.__paddingRight;
		}
		if(this.__paddingRight == value) {
			return this.__paddingRight;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingRight);
		this.__paddingRight = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingRight;
	},
	clearStyle_paddingRight: function() {
		this.set_paddingRight(0.0);
		return this.get_paddingRight();
	},
	get_paddingBottom: function() {
		return this.__paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(!this.setStyle("paddingBottom")) {
			return this.__paddingBottom;
		}
		if(this.__paddingBottom == value) {
			return this.__paddingBottom;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingBottom);
		this.__paddingBottom = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingBottom;
	},
	clearStyle_paddingBottom: function() {
		this.set_paddingBottom(0.0);
		return this.get_paddingBottom();
	},
	get_paddingLeft: function() {
		return this.__paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(!this.setStyle("paddingLeft")) {
			return this.__paddingLeft;
		}
		if(this.__paddingLeft == value) {
			return this.__paddingLeft;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_paddingLeft);
		this.__paddingLeft = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__paddingLeft;
	},
	clearStyle_paddingLeft: function() {
		this.set_paddingLeft(0.0);
		return this.get_paddingLeft();
	},
	get_backgroundSkin: function() {
		return this.__backgroundSkin;
	},
	set_backgroundSkin: function(value) {
		if(!this.setStyle("backgroundSkin")) {
			return this.__backgroundSkin;
		}
		if(this.__backgroundSkin == value) {
			return this.__backgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_backgroundSkin);
		this.__backgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__backgroundSkin;
	},
	clearStyle_backgroundSkin: function() {
		this.set_backgroundSkin(null);
		return this.get_backgroundSkin();
	},
	get_disabledBackgroundSkin: function() {
		return this.__disabledBackgroundSkin;
	},
	set_disabledBackgroundSkin: function(value) {
		if(!this.setStyle("disabledBackgroundSkin")) {
			return this.__disabledBackgroundSkin;
		}
		if(this.__disabledBackgroundSkin == value) {
			return this.__disabledBackgroundSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_disabledBackgroundSkin);
		this.__disabledBackgroundSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__disabledBackgroundSkin;
	},
	clearStyle_disabledBackgroundSkin: function() {
		this.set_disabledBackgroundSkin(null);
		return this.get_disabledBackgroundSkin();
	},
	get_maskSkin: function() {
		return this.__maskSkin;
	},
	set_maskSkin: function(value) {
		if(!this.setStyle("maskSkin")) {
			return this.__maskSkin;
		}
		if(this.__maskSkin == value) {
			return this.__maskSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_maskSkin);
		this.__maskSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__maskSkin;
	},
	clearStyle_maskSkin: function() {
		this.set_maskSkin(null);
		return this.get_maskSkin();
	},
	get_viewPortMaskSkin: function() {
		return this.__viewPortMaskSkin;
	},
	set_viewPortMaskSkin: function(value) {
		if(!this.setStyle("viewPortMaskSkin")) {
			return this.__viewPortMaskSkin;
		}
		if(this.__viewPortMaskSkin == value) {
			return this.__viewPortMaskSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_viewPortMaskSkin);
		this.__viewPortMaskSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__viewPortMaskSkin;
	},
	clearStyle_viewPortMaskSkin: function() {
		this.set_viewPortMaskSkin(null);
		return this.get_viewPortMaskSkin();
	},
	get_fixedScrollBars: function() {
		return this.__fixedScrollBars;
	},
	set_fixedScrollBars: function(value) {
		if(!this.setStyle("fixedScrollBars")) {
			return this.__fixedScrollBars;
		}
		if(this.__fixedScrollBars == value) {
			return this.__fixedScrollBars;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_fixedScrollBars);
		this.__fixedScrollBars = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__fixedScrollBars;
	},
	clearStyle_fixedScrollBars: function() {
		this.set_fixedScrollBars(false);
		return this.get_fixedScrollBars();
	},
	get_showScrollBars: function() {
		return this.__showScrollBars;
	},
	set_showScrollBars: function(value) {
		if(!this.setStyle("showScrollBars")) {
			return this.__showScrollBars;
		}
		if(this.__showScrollBars == value) {
			return this.__showScrollBars;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_showScrollBars);
		this.__showScrollBars = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__showScrollBars;
	},
	clearStyle_showScrollBars: function() {
		this.set_showScrollBars(true);
		return this.get_showScrollBars();
	},
	get_autoHideScrollBars: function() {
		return this.__autoHideScrollBars;
	},
	set_autoHideScrollBars: function(value) {
		if(!this.setStyle("autoHideScrollBars")) {
			return this.__autoHideScrollBars;
		}
		if(this.__autoHideScrollBars == value) {
			return this.__autoHideScrollBars;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_autoHideScrollBars);
		this.__autoHideScrollBars = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__autoHideScrollBars;
	},
	clearStyle_autoHideScrollBars: function() {
		this.set_autoHideScrollBars(true);
		return this.get_autoHideScrollBars();
	},
	get_scrollBarXPosition: function() {
		return this.__scrollBarXPosition;
	},
	set_scrollBarXPosition: function(value) {
		if(!this.setStyle("scrollBarXPosition")) {
			return this.__scrollBarXPosition;
		}
		if(this.__scrollBarXPosition == value) {
			return this.__scrollBarXPosition;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_scrollBarXPosition);
		this.__scrollBarXPosition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__scrollBarXPosition;
	},
	clearStyle_scrollBarXPosition: function() {
		this.set_scrollBarXPosition((feathers_layout_RelativePosition().default).BOTTOM);
		return this.get_scrollBarXPosition();
	},
	get_scrollBarYPosition: function() {
		return this.__scrollBarYPosition;
	},
	set_scrollBarYPosition: function(value) {
		if(!this.setStyle("scrollBarYPosition")) {
			return this.__scrollBarYPosition;
		}
		if(this.__scrollBarYPosition == value) {
			return this.__scrollBarYPosition;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_scrollBarYPosition);
		this.__scrollBarYPosition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__scrollBarYPosition;
	},
	clearStyle_scrollBarYPosition: function() {
		this.set_scrollBarYPosition((feathers_layout_RelativePosition().default).RIGHT);
		return this.get_scrollBarYPosition();
	},
	get_showScrollBarMinimumDuration: function() {
		return this.__showScrollBarMinimumDuration;
	},
	set_showScrollBarMinimumDuration: function(value) {
		if(!this.setStyle("showScrollBarMinimumDuration")) {
			return this.__showScrollBarMinimumDuration;
		}
		if(this.__showScrollBarMinimumDuration == value) {
			return this.__showScrollBarMinimumDuration;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_showScrollBarMinimumDuration);
		this.__showScrollBarMinimumDuration = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__showScrollBarMinimumDuration;
	},
	clearStyle_showScrollBarMinimumDuration: function() {
		this.set_showScrollBarMinimumDuration(0.5);
		return this.get_showScrollBarMinimumDuration();
	},
	get_hideScrollBarDuration: function() {
		return this.__hideScrollBarDuration;
	},
	set_hideScrollBarDuration: function(value) {
		if(!this.setStyle("hideScrollBarDuration")) {
			return this.__hideScrollBarDuration;
		}
		if(this.__hideScrollBarDuration == value) {
			return this.__hideScrollBarDuration;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_hideScrollBarDuration);
		this.__hideScrollBarDuration = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__hideScrollBarDuration;
	},
	clearStyle_hideScrollBarDuration: function() {
		this.set_hideScrollBarDuration(0.2);
		return this.get_hideScrollBarDuration();
	},
	get_hideScrollBarEase: function() {
		return this.__hideScrollBarEase;
	},
	set_hideScrollBarEase: function(value) {
		if(!this.setStyle("hideScrollBarEase")) {
			return this.__hideScrollBarEase;
		}
		if(this.__hideScrollBarEase == value) {
			return this.__hideScrollBarEase;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_hideScrollBarEase);
		this.__hideScrollBarEase = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__hideScrollBarEase;
	},
	clearStyle_hideScrollBarEase: function() {
		this.set_hideScrollBarEase((motion_easing_Quart()).easeOut);
		return this.get_hideScrollBarEase();
	},
	get_scrollPixelSnapping: function() {
		return this.__scrollPixelSnapping;
	},
	set_scrollPixelSnapping: function(value) {
		if(!this.setStyle("scrollPixelSnapping")) {
			return this.__scrollPixelSnapping;
		}
		if(this.__scrollPixelSnapping == value) {
			return this.__scrollPixelSnapping;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_scrollPixelSnapping);
		this.__scrollPixelSnapping = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__scrollPixelSnapping;
	},
	clearStyle_scrollPixelSnapping: function() {
		this.set_scrollPixelSnapping(false);
		return this.get_scrollPixelSnapping();
	}
});
BaseScrollContainer.prototype.__class__ = BaseScrollContainer.prototype.constructor = $hxClasses["feathers.controls.supportClasses.BaseScrollContainer"] = BaseScrollContainer;

// Init



// Statics


BaseScrollContainer.INVALIDATION_FLAG_SCROLLER_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("scrollerFactory")
BaseScrollContainer.INVALIDATION_FLAG_SCROLL_BAR_FACTORY = (feathers_core_InvalidationFlag().default).CUSTOM("scrollBarFactory")
BaseScrollContainer.defaultScrollBarXFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_HScrollBar().default))
BaseScrollContainer.defaultScrollBarYFactory = (feathers_utils_DisplayObjectFactory().default).withClass((feathers_controls_VScrollBar().default))

// Export

exports["default"] = BaseScrollContainer;

/***/ }),

/***/ "./lib/_gen/feathers/controls/supportClasses/BaseSlider.js":
/*!*****************************************************************!*\
  !*** ./lib/_gen/feathers/controls/supportClasses/BaseSlider.js ***!
  \*****************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.supportClasses.BaseSlider

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}
function feathers_controls_IRange() {return __webpack_require__(/*! ./../../../feathers/controls/IRange */ "./lib/_gen/feathers/controls/IRange.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_TypeError() {return (__webpack_require__(/*! openfl */ "openfl").errors.TypeError);}
function Type() {return __webpack_require__(/*! ./../../../Type */ "./lib/_gen/Type.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_utils_MathUtil() {return __webpack_require__(/*! ./../../../feathers/utils/MathUtil */ "./lib/_gen/feathers/utils/MathUtil.js");}
function feathers_utils_ExclusivePointer() {return __webpack_require__(/*! ./../../../feathers/utils/ExclusivePointer */ "./lib/_gen/feathers/utils/ExclusivePointer.js");}
function openfl_display_Stage() {return (__webpack_require__(/*! openfl */ "openfl").display.Stage);}

// Constructor

var BaseSlider = function(value,minimum,maximum,changeListener) {
	if(maximum == null) {
		maximum = 1.0;
	}
	if(minimum == null) {
		minimum = 0.0;
	}
	if(value == null) {
		value = 0.0;
	}
	this.__maximumPadding = 0.0;
	this.__minimumPadding = 0.0;
	this.__secondaryTrackSkin = null;
	this.__trackSkin = null;
	this.__thumbSkin = null;
	this._thumbStartY = 0.0;
	this._thumbStartX = 0.0;
	this._pointerStartY = 0.0;
	this._pointerStartX = 0.0;
	this._dragging = false;
	this._secondaryTrackSkinMeasurements = null;
	this._currentSecondaryTrackSkin = null;
	this._trackSkinMeasurements = null;
	this._currentTrackSkin = null;
	this._thumbSkinMeasurements = null;
	this._currentThumbSkin = null;
	this.liveDragging = true;
	this._snapInterval = 0.0;
	this._step = 0.01;
	this._maximum = 1.0;
	this._minimum = 0.0;
	this._value = 0.0;
	this._isDefaultValue = true;
	(feathers_core_FeathersControl().default).call(this);
	this.set_tabEnabled(true);
	this.set_tabChildren(false);
	this.set_minimum(minimum);
	this.set_maximum(maximum);
	this.set_value(value);
	if(changeListener != null) {
		this.addEventListener("change",changeListener);
	}
}

// Meta

BaseSlider.__name__ = "feathers.controls.supportClasses.BaseSlider";
BaseSlider.__isInterface__ = false;
BaseSlider.__interfaces__ = [(feathers_core_IFocusObject().default),(feathers_controls_IRange().default)];
BaseSlider.__super__ = (feathers_core_FeathersControl().default);
BaseSlider.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_value: function() {
		return this._value;
	},
	set_value: function(value) {
		if(this._value == value) {
			return this._value;
		}
		this._isDefaultValue = false;
		this._value = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		if(this.liveDragging || !this._dragging) {
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
		}
		return this._value;
	},
	get_minimum: function() {
		return this._minimum;
	},
	set_minimum: function(value) {
		if(this._minimum == value) {
			return this._minimum;
		}
		this._minimum = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._minimum;
	},
	get_maximum: function() {
		return this._maximum;
	},
	set_maximum: function(value) {
		if(this._maximum == value) {
			return this._maximum;
		}
		this._maximum = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._maximum;
	},
	get_step: function() {
		return this._step;
	},
	set_step: function(value) {
		if(this._step == value) {
			return this._step;
		}
		this._step = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._step;
	},
	get_snapInterval: function() {
		return this._snapInterval;
	},
	set_snapInterval: function(value) {
		if(this._snapInterval == value) {
			return this._snapInterval;
		}
		this._snapInterval = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._snapInterval;
	},
	showFocus: function(show) {
		(feathers_core_FeathersControl().default).prototype.showFocus.call(this,show);
		if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IFocusObject().default))) {
			var focusThumb = (js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IFocusObject().default));
			if(focusThumb.get_focusEnabled()) {
				focusThumb.showFocus(show);
			}
		}
	},
	applyValueRestrictions: function() {
		this.set_value(this.restrictValue(this._value));
	},
	initialize: function() {
		(feathers_core_FeathersControl().default).prototype.initialize.call(this);
		if(this._isDefaultValue) {
			this.set_value(this.restrictValue(this._value));
		}
	},
	update: function() {
		var sizeInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SIZE);
		var stateInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STATE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		if(stylesInvalid) {
			this.refreshThumb();
			this.refreshTrack();
			this.refreshSecondaryTrack();
		}
		if(stateInvalid || stylesInvalid) {
			this.refreshEnabled();
		}
		sizeInvalid = this.measure() || sizeInvalid;
		this.layoutContent();
	},
	measure: function() {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_TypeError())("Missing override for 'measure' in type " + (Type().default).getClassName((Type().default).getClass(this))));
	},
	refreshThumb: function() {
		var oldSkin = this._currentThumbSkin;
		this._currentThumbSkin = this.get_thumbSkin();
		if(this._currentThumbSkin == oldSkin) {
			return;
		}
		if(oldSkin != null) {
			if((js_Boot().default).__implements(oldSkin,(feathers_skins_IProgrammaticSkin().default))) {
				((js_Boot().default).__cast(oldSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
			}
			oldSkin.removeEventListener("mouseDown",$bind(this,this.thumbSkin_mouseDownHandler));
			this.removeChild(oldSkin);
		}
		if(this._currentThumbSkin != null) {
			if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(this._thumbSkinMeasurements == null) {
				this._thumbSkinMeasurements = new (feathers_layout_Measurements().default)(this._currentThumbSkin);
			} else {
				this._thumbSkinMeasurements.save(this._currentThumbSkin);
			}
			this.addChild(this._currentThumbSkin);
			this._currentThumbSkin.addEventListener("mouseDown",$bind(this,this.thumbSkin_mouseDownHandler));
			if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_skins_IProgrammaticSkin().default))) {
				((js_Boot().default).__cast(this._currentThumbSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
			}
		} else {
			this._thumbSkinMeasurements = null;
		}
	},
	refreshTrack: function() {
		var oldSkin = this._currentTrackSkin;
		this._currentTrackSkin = this.get_trackSkin();
		if(this._currentTrackSkin == oldSkin) {
			return;
		}
		if(oldSkin != null) {
			if((js_Boot().default).__implements(oldSkin,(feathers_skins_IProgrammaticSkin().default))) {
				((js_Boot().default).__cast(oldSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
			}
			this.removeChild(oldSkin);
			oldSkin.removeEventListener("mouseDown",$bind(this,this.trackSkin_mouseDownHandler));
		}
		if(this._currentTrackSkin != null) {
			if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(this._currentTrackSkin , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(this._trackSkinMeasurements == null) {
				this._trackSkinMeasurements = new (feathers_layout_Measurements().default)(this._currentTrackSkin);
			} else {
				this._trackSkinMeasurements.save(this._currentTrackSkin);
			}
			this.addChildAt(this._currentTrackSkin,0);
			this._currentTrackSkin.addEventListener("mouseDown",$bind(this,this.trackSkin_mouseDownHandler));
			if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_skins_IProgrammaticSkin().default))) {
				((js_Boot().default).__cast(this._currentTrackSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
			}
		} else {
			this._trackSkinMeasurements = null;
		}
	},
	refreshSecondaryTrack: function() {
		var oldSkin = this._currentSecondaryTrackSkin;
		this._currentSecondaryTrackSkin = this.get_secondaryTrackSkin();
		if(this._currentSecondaryTrackSkin == oldSkin) {
			return;
		}
		if(oldSkin != null) {
			if((js_Boot().default).__implements(oldSkin,(feathers_skins_IProgrammaticSkin().default))) {
				((js_Boot().default).__cast(oldSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
			}
			this.removeChild(oldSkin);
			oldSkin.removeEventListener("mouseDown",$bind(this,this.trackSkin_mouseDownHandler));
		}
		if(this._currentSecondaryTrackSkin != null) {
			if((js_Boot().default).__implements(this._currentSecondaryTrackSkin,(feathers_core_IUIControl().default))) {
				((js_Boot().default).__cast(this._currentSecondaryTrackSkin , (feathers_core_IUIControl().default))).initializeNow();
			}
			if(this._secondaryTrackSkinMeasurements == null) {
				this._secondaryTrackSkinMeasurements = new (feathers_layout_Measurements().default)(this._currentSecondaryTrackSkin);
			} else {
				this._secondaryTrackSkinMeasurements.save(this._currentSecondaryTrackSkin);
			}
			var index = this._currentTrackSkin != null ? 1 : 0;
			this.addChildAt(this._currentSecondaryTrackSkin,index);
			this._currentSecondaryTrackSkin.addEventListener("mouseDown",$bind(this,this.trackSkin_mouseDownHandler));
			if((js_Boot().default).__implements(this._currentSecondaryTrackSkin,(feathers_skins_IProgrammaticSkin().default))) {
				((js_Boot().default).__cast(this._currentSecondaryTrackSkin , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this);
			}
		} else {
			this._secondaryTrackSkinMeasurements = null;
		}
	},
	refreshEnabled: function() {
		if((js_Boot().default).__implements(this._currentThumbSkin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._currentThumbSkin , (feathers_core_IUIControl().default))).set_enabled(this._enabled);
		}
		if((js_Boot().default).__implements(this._currentTrackSkin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._currentTrackSkin , (feathers_core_IUIControl().default))).set_enabled(this._enabled);
		}
		if((js_Boot().default).__implements(this._currentSecondaryTrackSkin,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._currentSecondaryTrackSkin , (feathers_core_IUIControl().default))).set_enabled(this._enabled);
		}
	},
	layoutContent: function() {
		if(this._currentTrackSkin != null && this._currentSecondaryTrackSkin != null) {
			this.layoutSplitTrack();
		} else {
			this.layoutSingleTrack();
		}
		this.layoutThumb();
	},
	layoutSplitTrack: function() {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_TypeError())("Missing override for 'layoutSplitTrack' in type " + (Type().default).getClassName((Type().default).getClass(this))));
	},
	layoutSingleTrack: function() {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_TypeError())("Missing override for 'layoutSingleTrack' in type " + (Type().default).getClassName((Type().default).getClass(this))));
	},
	layoutThumb: function() {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_TypeError())("Missing override for 'layoutThumb' in type " + (Type().default).getClassName((Type().default).getClass(this))));
	},
	normalizeValue: function(value) {
		var normalized = 0.0;
		if(this._minimum != this._maximum) {
			normalized = (value - this._minimum) / (this._maximum - this._minimum);
			if(normalized < 0.0) {
				normalized = 0.0;
			} else if(normalized > 1.0) {
				normalized = 1.0;
			}
		}
		return normalized;
	},
	restrictValue: function(value) {
		if(this._snapInterval != 0.0 && value != this._minimum && value != this._maximum) {
			value = (feathers_utils_MathUtil().default).roundToNearest(value,this._snapInterval);
		}
		if(value < this._minimum) {
			value = this._minimum;
		} else if(value > this._maximum) {
			value = this._maximum;
		}
		return value;
	},
	valueToLocation: function(value) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_TypeError())("Missing override for 'valueToLocation' in type " + (Type().default).getClassName((Type().default).getClass(this))));
	},
	locationToValue: function(x,y) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_TypeError())("Missing override for 'locationToValue' in type " + (Type().default).getClassName((Type().default).getClass(this))));
	},
	saveThumbStart: function(x,y) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_TypeError())("Missing override for 'saveThumbStart' in type " + (Type().default).getClassName((Type().default).getClass(this))));
	},
	thumbSkin_mouseDownHandler: function(event) {
		if(!this._enabled || this.stage == null) {
			return;
		}
		var exclusivePointer = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
		var result = exclusivePointer.claimMouse(this);
		if(!result) {
			return;
		}
		this.stage.addEventListener("mouseMove",$bind(this,this.thumbSkin_stage_mouseMoveHandler),false,0,true);
		this.stage.addEventListener("mouseUp",$bind(this,this.thumbSkin_stage_mouseUpHandler),false,0,true);
		this._thumbStartX = this._currentThumbSkin.get_x();
		this._thumbStartY = this._currentThumbSkin.get_y();
		this._pointerStartX = this.get_mouseX();
		this._pointerStartY = this.get_mouseY();
		this._dragging = true;
	},
	thumbSkin_stage_mouseMoveHandler: function(event) {
		var newValue = this.locationToValue(this.get_mouseX(),this.get_mouseY());
		newValue = this.restrictValue(newValue);
		this.set_value(newValue);
	},
	thumbSkin_stage_mouseUpHandler: function(event) {
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		stage.removeEventListener("mouseMove",$bind(this,this.thumbSkin_stage_mouseMoveHandler));
		stage.removeEventListener("mouseUp",$bind(this,this.thumbSkin_stage_mouseUpHandler));
		this._dragging = false;
		if(!this.liveDragging) {
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
		}
	},
	trackSkin_mouseDownHandler: function(event) {
		if(!this._enabled || this.stage == null) {
			return;
		}
		var exclusivePointer = (feathers_utils_ExclusivePointer().default).forStage(this.stage);
		var result = exclusivePointer.claimMouse(this);
		if(!result) {
			return;
		}
		this.stage.addEventListener("mouseMove",$bind(this,this.trackSkin_stage_mouseMoveHandler),false,0,true);
		this.stage.addEventListener("mouseUp",$bind(this,this.trackSkin_stage_mouseUpHandler),false,0,true);
		this.saveThumbStart(this.get_mouseX(),this.get_mouseY());
		this._pointerStartX = this.get_mouseX();
		this._pointerStartY = this.get_mouseY();
		this._dragging = true;
		var newValue = this.locationToValue(this.get_mouseX(),this.get_mouseY());
		newValue = this.restrictValue(newValue);
		this.set_value(newValue);
	},
	trackSkin_stage_mouseMoveHandler: function(event) {
		var newValue = this.locationToValue(this.get_mouseX(),this.get_mouseY());
		newValue = this.restrictValue(newValue);
		this.set_value(newValue);
	},
	trackSkin_stage_mouseUpHandler: function(event) {
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		stage.removeEventListener("mouseMove",$bind(this,this.trackSkin_stage_mouseMoveHandler));
		stage.removeEventListener("mouseUp",$bind(this,this.trackSkin_stage_mouseUpHandler));
		this._dragging = false;
		if(!this.liveDragging) {
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
		}
	},
	get_thumbSkin: function() {
		return this.__thumbSkin;
	},
	set_thumbSkin: function(value) {
		if(!this.setStyle("thumbSkin")) {
			return this.__thumbSkin;
		}
		if(this.__thumbSkin == value) {
			return this.__thumbSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_thumbSkin);
		this.__thumbSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__thumbSkin;
	},
	clearStyle_thumbSkin: function() {
		this.set_thumbSkin(null);
		return this.get_thumbSkin();
	},
	get_trackSkin: function() {
		return this.__trackSkin;
	},
	set_trackSkin: function(value) {
		if(!this.setStyle("trackSkin")) {
			return this.__trackSkin;
		}
		if(this.__trackSkin == value) {
			return this.__trackSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_trackSkin);
		this.__trackSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__trackSkin;
	},
	clearStyle_trackSkin: function() {
		this.set_trackSkin(null);
		return this.get_trackSkin();
	},
	get_secondaryTrackSkin: function() {
		return this.__secondaryTrackSkin;
	},
	set_secondaryTrackSkin: function(value) {
		if(!this.setStyle("secondaryTrackSkin")) {
			return this.__secondaryTrackSkin;
		}
		if(this.__secondaryTrackSkin == value) {
			return this.__secondaryTrackSkin;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_secondaryTrackSkin);
		this.__secondaryTrackSkin = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__secondaryTrackSkin;
	},
	clearStyle_secondaryTrackSkin: function() {
		this.set_secondaryTrackSkin(null);
		return this.get_secondaryTrackSkin();
	},
	get_minimumPadding: function() {
		return this.__minimumPadding;
	},
	set_minimumPadding: function(value) {
		if(!this.setStyle("minimumPadding")) {
			return this.__minimumPadding;
		}
		if(this.__minimumPadding == value) {
			return this.__minimumPadding;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_minimumPadding);
		this.__minimumPadding = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__minimumPadding;
	},
	clearStyle_minimumPadding: function() {
		this.set_minimumPadding(0.0);
		return this.get_minimumPadding();
	},
	get_maximumPadding: function() {
		return this.__maximumPadding;
	},
	set_maximumPadding: function(value) {
		if(!this.setStyle("maximumPadding")) {
			return this.__maximumPadding;
		}
		if(this.__maximumPadding == value) {
			return this.__maximumPadding;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_maximumPadding);
		this.__maximumPadding = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this.__maximumPadding;
	},
	clearStyle_maximumPadding: function() {
		this.set_maximumPadding(0.0);
		return this.get_maximumPadding();
	}
});
BaseSlider.prototype.__class__ = BaseSlider.prototype.constructor = $hxClasses["feathers.controls.supportClasses.BaseSlider"] = BaseSlider;

// Init



// Statics




// Export

exports["default"] = BaseSlider;

/***/ }),

/***/ "./lib/_gen/feathers/controls/supportClasses/IViewPort.js":
/*!****************************************************************!*\
  !*** ./lib/_gen/feathers/controls/supportClasses/IViewPort.js ***!
  \****************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.supportClasses.IViewPort

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}

// Constructor

var IViewPort = function() {}

// Meta

IViewPort.__name__ = "feathers.controls.supportClasses.IViewPort";
IViewPort.__isInterface__ = true;
IViewPort.__interfaces__ = [(feathers_core_IMeasureObject().default),(feathers_core_IValidating().default),(feathers_core_IUIControl().default)];
IViewPort.prototype = {
	
};
IViewPort.prototype.__class__ = IViewPort.prototype.constructor = $hxClasses["feathers.controls.supportClasses.IViewPort"] = IViewPort;

// Init



// Statics




// Export

exports["default"] = IViewPort;

/***/ }),

/***/ "./lib/_gen/feathers/controls/supportClasses/LayoutViewPort.js":
/*!*********************************************************************!*\
  !*** ./lib/_gen/feathers/controls/supportClasses/LayoutViewPort.js ***!
  \*********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.supportClasses.LayoutViewPort

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_controls_supportClasses_IViewPort() {return __webpack_require__(/*! ./../../../feathers/controls/supportClasses/IViewPort */ "./lib/_gen/feathers/controls/supportClasses/IViewPort.js");}
function feathers_controls_LayoutGroup() {return __webpack_require__(/*! ./../../../feathers/controls/LayoutGroup */ "./lib/_gen/feathers/controls/LayoutGroup.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_IScrollLayout() {return __webpack_require__(/*! ./../../../feathers/layout/IScrollLayout */ "./lib/_gen/feathers/layout/IScrollLayout.js");}
function feathers_utils_MeasurementsUtil() {return __webpack_require__(/*! ./../../../feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");}
function feathers_layout_AutoSizeMode() {return __webpack_require__(/*! ./../../../feathers/layout/AutoSizeMode */ "./lib/_gen/feathers/layout/AutoSizeMode.js");}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function feathers_layout_ISnapLayout() {return __webpack_require__(/*! ./../../../feathers/layout/ISnapLayout */ "./lib/_gen/feathers/layout/ISnapLayout.js");}
function openfl_display_Sprite() {return (__webpack_require__(/*! openfl */ "openfl").display.Sprite);}

// Constructor

var LayoutViewPort = function() {
	this._manageChildVisibility = false;
	this._snapPositionsY = null;
	this._snapPositionsX = null;
	this._scrollY = 0.0;
	this._scrollX = 0.0;
	this._explicitVisibleHeight = null;
	this._actualVisibleHeight = 0.0;
	this._maxVisibleHeight = 1.0 / 0.0;
	this._actualMinVisibleHeight = 0.0;
	this._explicitVisibleWidth = null;
	this._actualVisibleWidth = 0.0;
	this._maxVisibleWidth = 1.0 / 0.0;
	this._explicitMinVisibleWidth = null;
	this._actualMinVisibleWidth = 0.0;
	(feathers_controls_LayoutGroup().default).call(this);
	this._viewPortBackground = new (openfl_display_Sprite())();
	this._viewPortBackground.get_graphics().beginFill(16711935,0.0);
	this._viewPortBackground.get_graphics().drawRect(0.0,0.0,1.0,1.0);
	this._viewPortBackground.get_graphics().endFill();
	this._addChildAt(this._viewPortBackground,0);
}

// Meta

LayoutViewPort.__name__ = "feathers.controls.supportClasses.LayoutViewPort";
LayoutViewPort.__isInterface__ = false;
LayoutViewPort.__interfaces__ = [(feathers_controls_supportClasses_IViewPort().default)];
LayoutViewPort.__super__ = (feathers_controls_LayoutGroup().default);
LayoutViewPort.prototype = $extend((feathers_controls_LayoutGroup().default).prototype, {
	get_minVisibleWidth: function() {
		if(this._explicitMinVisibleWidth == null) {
			return this._actualMinVisibleWidth;
		}
		return this._explicitMinVisibleWidth;
	},
	set_minVisibleWidth: function(value) {
		if(this._explicitMinVisibleWidth == value) {
			return this._explicitMinVisibleWidth;
		}
		var oldValue = this._explicitMinVisibleWidth;
		this._explicitMinVisibleWidth = value;
		if(value == null) {
			this._actualMinVisibleWidth = 0.0;
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		} else {
			this._actualMinVisibleWidth = value;
			if(this._explicitVisibleWidth == null && (this._actualVisibleWidth < value || this._actualVisibleWidth == oldValue)) {
				this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
			}
		}
		return this._explicitMinVisibleWidth;
	},
	get_maxVisibleWidth: function() {
		return this._maxVisibleWidth;
	},
	set_maxVisibleWidth: function(value) {
		if(this._maxVisibleWidth == value) {
			return this._maxVisibleWidth;
		}
		if(value == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("maxVisibleWidth cannot be null"));
		}
		var oldValue = this._maxVisibleWidth;
		this._maxVisibleWidth = value;
		if(this._explicitVisibleWidth == null && (this._actualVisibleWidth > value || this._actualVisibleWidth == oldValue)) {
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		}
		return this._maxVisibleWidth;
	},
	get_visibleWidth: function() {
		if(this._explicitVisibleWidth == null) {
			return this._actualVisibleWidth;
		}
		return this._explicitVisibleWidth;
	},
	set_visibleWidth: function(value) {
		if(this._explicitVisibleWidth == value) {
			return this._explicitVisibleWidth;
		}
		this._explicitVisibleWidth = value;
		if(this._actualVisibleWidth != value) {
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		}
		return this._explicitVisibleWidth;
	},
	get_minVisibleHeight: function() {
		if(this._explicitMinVisibleHeight == null) {
			return this._actualMinVisibleHeight;
		}
		return this._explicitMinVisibleHeight;
	},
	set_minVisibleHeight: function(value) {
		if(this._explicitMinVisibleHeight == value) {
			return this._explicitMinVisibleHeight;
		}
		var oldValue = this._explicitMinVisibleHeight;
		this._explicitMinVisibleHeight = value;
		if(value == null) {
			this._actualMinVisibleHeight = 0.0;
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		} else {
			this._actualMinVisibleHeight = value;
			if(this._explicitVisibleHeight == null && (this._actualVisibleHeight < value || this._actualVisibleHeight == oldValue)) {
				this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
			}
		}
		return this._explicitMinVisibleHeight;
	},
	get_maxVisibleHeight: function() {
		return this._maxVisibleHeight;
	},
	set_maxVisibleHeight: function(value) {
		if(this._maxVisibleHeight == value) {
			return this._maxVisibleHeight;
		}
		if(value == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("maxVisibleHeight cannot be null"));
		}
		var oldValue = this._maxVisibleHeight;
		this._maxVisibleHeight = value;
		if(this._explicitVisibleHeight == null && (this._actualVisibleHeight > value || this._actualVisibleHeight == oldValue)) {
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		}
		return this._maxVisibleHeight;
	},
	get_visibleHeight: function() {
		if(this._explicitVisibleHeight == null) {
			return this._actualVisibleHeight;
		}
		return this._explicitVisibleHeight;
	},
	set_visibleHeight: function(value) {
		if(this._explicitVisibleHeight == value) {
			return this._explicitVisibleHeight;
		}
		this._explicitVisibleHeight = value;
		if(this._actualVisibleHeight != value) {
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		}
		return this._explicitVisibleWidth;
	},
	get_scrollX: function() {
		return this._scrollX;
	},
	set_scrollX: function(value) {
		if(this._scrollX == value) {
			return this._scrollX;
		}
		this._scrollX = value;
		if(this._manageChildVisibility || (js_Boot().default).__implements(this._currentLayout,(feathers_layout_IScrollLayout().default))) {
			this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		}
		return this._scrollX;
	},
	get_scrollY: function() {
		return this._scrollY;
	},
	set_scrollY: function(value) {
		if(this._scrollY == value) {
			return this._scrollY;
		}
		this._scrollY = value;
		if(this._manageChildVisibility || (js_Boot().default).__implements(this._currentLayout,(feathers_layout_IScrollLayout().default))) {
			this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		}
		return this._scrollY;
	},
	get_snapPositionsX: function() {
		return this._snapPositionsX;
	},
	get_snapPositionsY: function() {
		return this._snapPositionsY;
	},
	refreshViewPortBounds: function() {
		var needsWidth = this._explicitVisibleWidth == null;
		var needsHeight = this._explicitVisibleHeight == null;
		var needsMinWidth = this._explicitMinVisibleWidth == null;
		var needsMinHeight = this._explicitMinVisibleHeight == null;
		var needsMaxWidth = this._maxVisibleWidth == null;
		var needsMaxHeight = this._maxVisibleHeight == null;
		if(this._currentBackgroundSkin != null) {
			(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParent(this._backgroundSkinMeasurements,this._currentBackgroundSkin,this);
		}
		var needsToMeasureContent = this.get_autoSizeMode() == (feathers_layout_AutoSizeMode().default).CONTENT || this.stage == null;
		var stageWidth = 0.0;
		var stageHeight = 0.0;
		if(!needsToMeasureContent) {
			var topLeft = this.globalToLocal(new (openfl_geom_Point())());
			var bottomRight = this.globalToLocal(new (openfl_geom_Point())(this.stage.stageWidth,this.stage.stageHeight));
			stageWidth = bottomRight.x - topLeft.x;
			stageHeight = bottomRight.y - topLeft.y;
		}
		if(needsWidth && !needsToMeasureContent) {
			this._layoutMeasurements.width = stageWidth;
		} else {
			this._layoutMeasurements.width = this._explicitVisibleWidth;
		}
		if(needsHeight && !needsToMeasureContent) {
			this._layoutMeasurements.height = stageHeight;
		} else {
			this._layoutMeasurements.height = this._explicitVisibleHeight;
		}
		var viewPortMinWidth = this._explicitMinVisibleWidth;
		if(needsMinWidth) {
			viewPortMinWidth = 0.0;
		}
		var viewPortMinHeight = this._explicitMinVisibleHeight;
		if(needsMinHeight) {
			viewPortMinHeight = 0.0;
		}
		var viewPortMaxWidth = this._maxVisibleWidth;
		if(needsMaxWidth) {
			viewPortMaxWidth = 1.0 / 0.0;
		}
		var viewPortMaxHeight = this._maxVisibleHeight;
		if(needsMaxHeight) {
			viewPortMaxHeight = 1.0 / 0.0;
		}
		if(this._currentBackgroundSkin != null) {
			if(this._currentBackgroundSkin.get_width() > viewPortMinWidth) {
				viewPortMinWidth = this._currentBackgroundSkin.get_width();
			}
			if(this._currentBackgroundSkin.get_height() > viewPortMinHeight) {
				viewPortMinHeight = this._currentBackgroundSkin.get_height();
			}
		}
		this._layoutMeasurements.minWidth = viewPortMinWidth;
		this._layoutMeasurements.minHeight = viewPortMinHeight;
		this._layoutMeasurements.maxWidth = viewPortMaxWidth;
		this._layoutMeasurements.maxHeight = viewPortMaxHeight;
	},
	handleCustomLayout: function() {
		var oldIgnoreLayoutChanges = this._ignoreLayoutChanges;
		this._ignoreLayoutChanges = true;
		if((js_Boot().default).__implements(this._currentLayout,(feathers_layout_IScrollLayout().default))) {
			var scrollLayout = (js_Boot().default).__cast(this._currentLayout , (feathers_layout_IScrollLayout().default));
			scrollLayout.set_scrollX(this._scrollX);
			scrollLayout.set_scrollY(this._scrollY);
		}
		this._ignoreLayoutChanges = oldIgnoreLayoutChanges;
		(feathers_controls_LayoutGroup().default).prototype.handleCustomLayout.call(this);
	},
	handleLayoutResult: function() {
		this.saveMeasurements(this._layoutResult.contentWidth,this._layoutResult.contentHeight,this._layoutResult.contentMinWidth,this._layoutResult.contentMinHeight);
		var viewPortWidth = this._layoutResult.viewPortWidth;
		var viewPortHeight = this._layoutResult.viewPortHeight;
		this._actualVisibleWidth = viewPortWidth;
		this._actualVisibleHeight = viewPortHeight;
		this._actualMinVisibleWidth = this._layoutResult.contentMinWidth;
		this._actualMinVisibleHeight = this._layoutResult.contentMinHeight;
		this._viewPortBackground.set_x(Math.min(this.get_scrollX(),0.0));
		this._viewPortBackground.set_y(Math.min(this.get_scrollY(),0.0));
		this._viewPortBackground.set_width(Math.max(this.actualWidth,this._actualVisibleWidth));
		this._viewPortBackground.set_height(Math.max(this.actualHeight,this._actualVisibleHeight));
		if((js_Boot().default).__implements(this.get_layout(),(feathers_layout_ISnapLayout().default))) {
			var snapLayout = (js_Boot().default).__cast(this.get_layout() , (feathers_layout_ISnapLayout().default));
			this._snapPositionsX = snapLayout.getSnapPositionsX(this.items,this._actualVisibleWidth,this._actualVisibleHeight,this._snapPositionsX);
			this._snapPositionsY = snapLayout.getSnapPositionsY(this.items,this._actualVisibleWidth,this._actualVisibleHeight,this._snapPositionsY);
		} else {
			this._snapPositionsX = null;
			this._snapPositionsY = null;
		}
	},
	get_manageChildVisibility: function() {
		return this._manageChildVisibility;
	},
	set_manageChildVisibility: function(value) {
		if(this._manageChildVisibility == value) {
			return this._manageChildVisibility;
		}
		this._manageChildVisibility = value;
		if(this._manageChildVisibility) {
			this.setInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		} else {
			var _g = 0;
			var _g1 = this.items;
			while(_g < _g1.length) {
				var child = _g1[_g];
				++_g;
				child.set_visible(true);
			}
		}
		return this._manageChildVisibility;
	},
	update: function() {
		var layoutInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).LAYOUT);
		var sizeInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SIZE);
		var scrollInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SCROLL);
		(feathers_controls_LayoutGroup().default).prototype.update.call(this);
		if(layoutInvalid || sizeInvalid || scrollInvalid) {
			this.refreshChildVisibility();
		}
	},
	refreshChildVisibility: function() {
		if(!this._manageChildVisibility) {
			return;
		}
		var maxX = this._scrollX + this._actualVisibleWidth;
		var maxY = this._scrollY + this._actualVisibleHeight;
		var _g = 0;
		var _g1 = this.items;
		while(_g < _g1.length) {
			var child = _g1[_g];
			++_g;
			child.set_visible(!(child.get_x() > maxX || child.get_x() + child.get_width() < this._scrollX || child.get_y() > maxY || child.get_y() + child.get_height() < this._scrollY));
		}
	},
	removeChild: function(child) {
		if(this._manageChildVisibility && child != null) {
			child.set_visible(true);
		}
		return (feathers_controls_LayoutGroup().default).prototype.removeChild.call(this,child);
	},
	removeChildAt: function(index) {
		var child = (feathers_controls_LayoutGroup().default).prototype.removeChildAt.call(this,index);
		if(this._manageChildVisibility && child != null) {
			child.set_visible(true);
		}
		return child;
	}
});
LayoutViewPort.prototype.__class__ = LayoutViewPort.prototype.constructor = $hxClasses["feathers.controls.supportClasses.LayoutViewPort"] = LayoutViewPort;

// Init



// Statics




// Export

exports["default"] = LayoutViewPort;

/***/ }),

/***/ "./lib/_gen/feathers/controls/supportClasses/TextFieldViewPort.js":
/*!************************************************************************!*\
  !*** ./lib/_gen/feathers/controls/supportClasses/TextFieldViewPort.js ***!
  \************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.controls.supportClasses.TextFieldViewPort

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IStageFocusDelegate() {return __webpack_require__(/*! ./../../../feathers/core/IStageFocusDelegate */ "./lib/_gen/feathers/core/IStageFocusDelegate.js");}
function feathers_core_IFocusManagerAware() {return __webpack_require__(/*! ./../../../feathers/core/IFocusManagerAware */ "./lib/_gen/feathers/core/IFocusManagerAware.js");}
function feathers_core_ITextControl() {return __webpack_require__(/*! ./../../../feathers/core/ITextControl */ "./lib/_gen/feathers/core/ITextControl.js");}
function feathers_controls_supportClasses_IViewPort() {return __webpack_require__(/*! ./../../../feathers/controls/supportClasses/IViewPort */ "./lib/_gen/feathers/controls/supportClasses/IViewPort.js");}
function feathers_core_FeathersControl() {return __webpack_require__(/*! ./../../../feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function openfl_text_TextField() {return (__webpack_require__(/*! openfl */ "openfl").text.TextField);}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_controls_supportClasses_BaseScrollContainer() {return __webpack_require__(/*! ./../../../feathers/controls/supportClasses/BaseScrollContainer */ "./lib/_gen/feathers/controls/supportClasses/BaseScrollContainer.js");}

// Constructor

var TextFieldViewPort = function() {
	this._ignoreTextFieldScroll = false;
	this._textFieldHasFocus = false;
	this._pendingSelectionActiveIndex = -1;
	this._pendingSelectionAnchorIndex = -1;
	this._scrollY = 0.0;
	this._scrollX = 0.0;
	this._explicitVisibleHeight = null;
	this._actualVisibleHeight = 0.0;
	this._maxVisibleHeight = 1.0 / 0.0;
	this._actualMinVisibleHeight = 0.0;
	this._explicitVisibleWidth = null;
	this._actualVisibleWidth = 0.0;
	this._maxVisibleWidth = 1.0 / 0.0;
	this._explicitMinVisibleWidth = null;
	this._actualMinVisibleWidth = 0.0;
	this._paddingLeft = 0.0;
	this._paddingBottom = 0.0;
	this._paddingRight = 0.0;
	this._paddingTop = 0.0;
	this._embedFonts = false;
	this._savedLineMetrics = null;
	this._previousWidth = null;
	this._previousTextFormat = null;
	this._previousText = null;
	this._updatedTextStyles = false;
	this._smoothScrolling = false;
	this._selectable = true;
	this._maxChars = 0;
	this._displayAsPassword = false;
	this._multiline = false;
	this._wordWrap = false;
	this._textFieldType = "dynamic";
	(feathers_core_FeathersControl().default).call(this);
	this.addEventListener("focusIn",$bind(this,this.textFieldViewPort_focusInHandler));
}

// Meta

TextFieldViewPort.__name__ = "feathers.controls.supportClasses.TextFieldViewPort";
TextFieldViewPort.__isInterface__ = false;
TextFieldViewPort.__interfaces__ = [(feathers_core_IStageFocusDelegate().default),(feathers_core_IFocusManagerAware().default),(feathers_core_ITextControl().default),(feathers_controls_supportClasses_IViewPort().default)];
TextFieldViewPort.__super__ = (feathers_core_FeathersControl().default);
TextFieldViewPort.prototype = $extend((feathers_core_FeathersControl().default).prototype, {
	get_textField: function() {
		return this._textField;
	},
	get_textFieldType: function() {
		return this._textFieldType;
	},
	set_textFieldType: function(value) {
		if(this._textFieldType == value) {
			return this._textFieldType;
		}
		this._textFieldType = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._textFieldType;
	},
	get_text: function() {
		return this._text;
	},
	set_text: function(value) {
		if(this._text == value) {
			return this._text;
		}
		this._text = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._text;
	},
	get_baseline: function() {
		if(this._textField == null) {
			return 0.0;
		}
		var hasText = this._text != null && this._text.length > 0;
		if(!hasText) {
			this.get_textField().set_text("​");
			var result = this.get_textField().get_y() + this.get_textField().getLineMetrics(0).ascent;
			this.get_textField().set_text("");
			return result;
		}
		return this._textField.get_y() + this._textField.getLineMetrics(0).ascent;
	},
	get_wordWrap: function() {
		return this._wordWrap;
	},
	set_wordWrap: function(value) {
		if(this._wordWrap == value) {
			return this._wordWrap;
		}
		this._wordWrap = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._wordWrap;
	},
	get_multiline: function() {
		return this._multiline;
	},
	set_multiline: function(value) {
		if(this._multiline == value) {
			return this._multiline;
		}
		this._multiline = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._multiline;
	},
	get_restrict: function() {
		return this.__restrict;
	},
	set_restrict: function(value) {
		if(this.__restrict == value) {
			return this.__restrict;
		}
		this.__restrict = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this.__restrict;
	},
	get_displayAsPassword: function() {
		return this._displayAsPassword;
	},
	set_displayAsPassword: function(value) {
		if(this._displayAsPassword == value) {
			return this._displayAsPassword;
		}
		this._displayAsPassword = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._displayAsPassword;
	},
	get_maxChars: function() {
		return this._maxChars;
	},
	set_maxChars: function(value) {
		if(this._maxChars == value) {
			return this._maxChars;
		}
		this._maxChars = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._maxChars;
	},
	get_selectable: function() {
		return this._selectable;
	},
	set_selectable: function(value) {
		if(this._selectable == value) {
			return this._selectable;
		}
		this._selectable = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._selectable;
	},
	get_smoothScrolling: function() {
		return this._smoothScrolling;
	},
	set_smoothScrolling: function(value) {
		if(this._smoothScrolling == value) {
			return this._smoothScrolling;
		}
		this._smoothScrolling = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._smoothScrolling;
	},
	get_textFormat: function() {
		return this._textFormat;
	},
	set_textFormat: function(value) {
		if(this._textFormat == value) {
			return this._textFormat;
		}
		this._textFormat = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._textFormat;
	},
	get_embedFonts: function() {
		return this._embedFonts;
	},
	set_embedFonts: function(value) {
		if(this._embedFonts == value) {
			return this._embedFonts;
		}
		this._embedFonts = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._embedFonts;
	},
	get_paddingTop: function() {
		return this._paddingTop;
	},
	set_paddingTop: function(value) {
		if(this._paddingTop == value) {
			return this._paddingTop;
		}
		this._paddingTop = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._paddingTop;
	},
	get_paddingRight: function() {
		return this._paddingRight;
	},
	set_paddingRight: function(value) {
		if(this._paddingRight == value) {
			return this._paddingRight;
		}
		this._paddingRight = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._paddingRight;
	},
	get_paddingBottom: function() {
		return this._paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(this._paddingBottom == value) {
			return this._paddingBottom;
		}
		this._paddingBottom = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._paddingBottom;
	},
	get_paddingLeft: function() {
		return this._paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(this._paddingLeft == value) {
			return this._paddingLeft;
		}
		this._paddingLeft = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._paddingLeft;
	},
	get_stageFocusTarget: function() {
		return this._textField;
	},
	get_minVisibleWidth: function() {
		if(this._explicitMinVisibleWidth == null) {
			return this._actualMinVisibleWidth;
		}
		return this._explicitMinVisibleWidth;
	},
	set_minVisibleWidth: function(value) {
		if(this._explicitMinVisibleWidth == value) {
			return this._explicitMinVisibleWidth;
		}
		var oldValue = this._explicitMinVisibleWidth;
		this._explicitMinVisibleWidth = value;
		if(value == null) {
			this._actualMinVisibleWidth = 0.0;
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		} else {
			this._actualMinVisibleWidth = value;
			if(this._explicitVisibleWidth == null && (this._actualVisibleWidth < value || this._actualVisibleWidth == oldValue)) {
				this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
			}
		}
		return this._explicitMinVisibleWidth;
	},
	get_maxVisibleWidth: function() {
		return this._maxVisibleWidth;
	},
	set_maxVisibleWidth: function(value) {
		if(this._maxVisibleWidth == value) {
			return this._maxVisibleWidth;
		}
		if(value == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("maxVisibleWidth cannot be null"));
		}
		var oldValue = this._maxVisibleWidth;
		this._maxVisibleWidth = value;
		if(this._explicitVisibleWidth == null && (this._actualVisibleWidth > value || this._actualVisibleWidth == oldValue)) {
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		}
		return this._maxVisibleWidth;
	},
	get_visibleWidth: function() {
		if(this._explicitVisibleWidth == null) {
			return this._actualVisibleWidth;
		}
		return this._explicitVisibleWidth;
	},
	set_visibleWidth: function(value) {
		if(this._explicitVisibleWidth == value) {
			return this._explicitVisibleWidth;
		}
		this._explicitVisibleWidth = value;
		if(this._actualVisibleWidth != value) {
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		}
		return this._explicitVisibleWidth;
	},
	get_minVisibleHeight: function() {
		if(this._explicitMinVisibleHeight == null) {
			return this._actualMinVisibleHeight;
		}
		return this._explicitMinVisibleHeight;
	},
	set_minVisibleHeight: function(value) {
		if(this._explicitMinVisibleHeight == value) {
			return this._explicitMinVisibleHeight;
		}
		var oldValue = this._explicitMinVisibleHeight;
		this._explicitMinVisibleHeight = value;
		if(value == null) {
			this._actualMinVisibleHeight = 0.0;
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		} else {
			this._actualMinVisibleHeight = value;
			if(this._explicitVisibleHeight == null && (this._actualVisibleHeight < value || this._actualVisibleHeight == oldValue)) {
				this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
			}
		}
		return this._explicitMinVisibleHeight;
	},
	get_maxVisibleHeight: function() {
		return this._maxVisibleHeight;
	},
	set_maxVisibleHeight: function(value) {
		if(this._maxVisibleHeight == value) {
			return this._maxVisibleHeight;
		}
		if(value == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("maxVisibleHeight cannot be null"));
		}
		var oldValue = this._maxVisibleHeight;
		this._maxVisibleHeight = value;
		if(this._explicitVisibleHeight == null && (this._actualVisibleHeight > value || this._actualVisibleHeight == oldValue)) {
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		}
		return this._maxVisibleHeight;
	},
	get_visibleHeight: function() {
		if(this._explicitVisibleHeight == null) {
			return this._actualVisibleHeight;
		}
		return this._explicitVisibleHeight;
	},
	set_visibleHeight: function(value) {
		if(this._explicitVisibleHeight == value) {
			return this._explicitVisibleHeight;
		}
		this._explicitVisibleHeight = value;
		if(this._actualVisibleHeight != value) {
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		}
		return this._explicitVisibleWidth;
	},
	get_scrollX: function() {
		return this._scrollX;
	},
	set_scrollX: function(value) {
		if(this._scrollX == value) {
			return this._scrollX;
		}
		this._scrollX = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SCROLL);
		return this._scrollX;
	},
	get_scrollY: function() {
		return this._scrollY;
	},
	set_scrollY: function(value) {
		if(this._scrollY == value) {
			return this._scrollY;
		}
		this._scrollY = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).SCROLL);
		return this._scrollY;
	},
	get_selectionAnchorIndex: function() {
		if(this._textField != null && this._pendingSelectionAnchorIndex == -1) {
			if(this._textField.get_caretIndex() == this._textField.get_selectionBeginIndex()) {
				return this._textField.get_selectionEndIndex();
			}
			return this._textField.get_selectionBeginIndex();
		}
		return this._pendingSelectionAnchorIndex;
	},
	get_selectionActiveIndex: function() {
		if(this._textField != null && this._pendingSelectionActiveIndex == -1) {
			return this._textField.get_caretIndex();
		}
		return this._pendingSelectionActiveIndex;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	selectRange: function(anchorIndex,activeIndex) {
		this._pendingSelectionAnchorIndex = anchorIndex;
		this._pendingSelectionActiveIndex = activeIndex;
		this.setInvalid((feathers_core_InvalidationFlag().default).SELECTION);
	},
	initialize: function() {
		(feathers_core_FeathersControl().default).prototype.initialize.call(this);
		if(this._textField == null) {
			this._textField = new (openfl_text_TextField())();
			this.addChild(this._textField);
		}
		this._textField.set_selectable(true);
		this._textField.set_tabEnabled(false);
		this._textField.set_mouseWheelEnabled(false);
		this._textField.addEventListener("change",$bind(this,this.textField_changeHandler));
		this._textField.addEventListener("scroll",$bind(this,this.textField_scrollHandler));
		this._textField.addEventListener("focusIn",$bind(this,this.textField_focusInHandler));
		this._textField.addEventListener("focusOut",$bind(this,this.textField_focusOutHandler));
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var selectionInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SELECTION);
		var sizeInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SIZE);
		var stylesInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).STYLES);
		this._updatedTextStyles = false;
		var oldIgnoreTextFieldScroll = this._ignoreTextFieldScroll;
		this._ignoreTextFieldScroll = true;
		if(stylesInvalid) {
			this.refreshTextStyles();
		}
		if(dataInvalid || sizeInvalid || stylesInvalid) {
			this.refreshText();
		}
		this.measure();
		if(selectionInvalid) {
			this.refreshSelection();
		}
		this.layoutTextField();
		this._ignoreTextFieldScroll = oldIgnoreTextFieldScroll;
	},
	measureSelf: function() {
		var needsWidth = this._explicitVisibleWidth == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this._explicitMinVisibleWidth == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		var newWidth = this._explicitVisibleWidth;
		if(needsWidth) {
			newWidth = this._paddingLeft + this._paddingRight;
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			newHeight = this._textMeasuredHeight + this._paddingTop + this._paddingBottom;
		}
		var newMinWidth = this._explicitMinVisibleWidth;
		if(needsMinWidth) {
			newMinWidth = this._paddingLeft + this._paddingRight;
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			newMinHeight = this._textMeasuredHeight + this._paddingTop + this._paddingBottom;
		}
		var newMaxWidth = this.get_explicitMaxWidth();
		if(needsMaxWidth) {
			newMaxWidth = 1.0 / 0.0;
		}
		var newMaxHeight = this.get_explicitMaxHeight();
		if(needsMaxHeight) {
			newMaxHeight = 1.0 / 0.0;
		}
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight,newMaxWidth,newMaxHeight);
	},
	measure: function() {
		var result = this.measureSelf();
		var needsVisibleWidth = this._explicitVisibleWidth == null;
		var needsVisibleHeight = this._explicitVisibleHeight == null;
		var needsVisibleMinWidth = this._explicitMinVisibleWidth == null;
		var needsVisibleMinHeight = this._explicitMinVisibleHeight == null;
		if(needsVisibleWidth) {
			this._actualVisibleWidth = this.actualWidth;
		} else {
			this._actualVisibleWidth = this._explicitVisibleWidth;
		}
		if(needsVisibleHeight) {
			this._actualVisibleHeight = this.actualHeight;
		} else {
			this._actualVisibleHeight = this._explicitVisibleHeight;
		}
		if(needsVisibleMinWidth) {
			this._actualMinVisibleWidth = this.actualMinWidth;
		} else {
			this._actualMinVisibleWidth = this._explicitMinVisibleWidth;
		}
		if(needsVisibleMinHeight) {
			this._actualMinVisibleHeight = this.actualMinHeight;
		} else {
			this._actualMinVisibleHeight = this._explicitMinVisibleHeight;
		}
		return result;
	},
	refreshTextStyles: function() {
		if(this._textField.get_embedFonts() != this._embedFonts) {
			this._textField.set_embedFonts(this._embedFonts);
			this._updatedTextStyles = true;
		}
		if(this._textFormat != this._previousTextFormat) {
			this._textField.set_defaultTextFormat(this._textFormat);
			this._updatedTextStyles = true;
			this._previousTextFormat = this._textFormat;
		}
	},
	refreshText: function() {
		var textFieldType = this._enabled ? this._textFieldType : "dynamic";
		if(this._textField.get_type() != textFieldType) {
			this._textField.set_type(textFieldType);
		}
		var calculatedWordWrap = this._explicitVisibleWidth != null && this._wordWrap;
		if(this._textField.get_wordWrap() != calculatedWordWrap) {
			this._textField.set_wordWrap(calculatedWordWrap);
			this._updatedTextStyles = true;
		}
		if(this._textField.get_multiline() != this._multiline) {
			this._textField.set_multiline(this._multiline);
			this._updatedTextStyles = true;
		}
		this._textField.set_restrict(this.__restrict);
		this._textField.set_displayAsPassword(this._displayAsPassword);
		this._textField.set_maxChars(this._maxChars);
		this._textField.set_selectable(this._selectable);
		var calculatedWidth = this._explicitVisibleWidth;
		if(calculatedWidth != null) {
			calculatedWidth -= this._paddingLeft + this._paddingRight;
		}
		if(this._text == this._previousText && !this._updatedTextStyles && calculatedWidth == this._previousWidth) {
			return;
		}
		if(calculatedWidth != null) {
			this._textField.set_width(calculatedWidth);
		}
		this._textField.set_autoSize("left");
		var hasText = this._text != null && this._text.length > 0;
		if(hasText) {
			this._textField.set_text(this._text);
		} else {
			this._textField.set_text("​");
		}
		this._savedLineMetrics = this._textField.getLineMetrics(0);
		this._textMeasuredWidth = this._textField.get_width();
		this._textMeasuredHeight = 4 + (this._savedLineMetrics.height + this._savedLineMetrics.leading) * this._textField.get_numLines();
		this._textField.set_autoSize("none");
		if(!hasText) {
			this._textField.set_text("");
		}
		this._previousText = this._text;
		this._previousWidth = calculatedWidth;
	},
	refreshSelection: function() {
		if(this._pendingSelectionActiveIndex == -1 && this._pendingSelectionAnchorIndex == -1) {
			return;
		}
		var anchorIndex = this._pendingSelectionAnchorIndex;
		var activeIndex = this._pendingSelectionActiveIndex;
		this._pendingSelectionAnchorIndex = -1;
		this._pendingSelectionActiveIndex = -1;
		this._textField.setSelection(anchorIndex,activeIndex);
	},
	layoutTextField: function() {
		if(this._smoothScrolling) {
			this._textField.set_x(this._paddingLeft);
			this._textField.set_y(this._paddingTop);
			var calculatedWidth = Math.max(this.actualWidth,this._actualVisibleWidth);
			var calculatedHeight = Math.max(this.actualHeight,this._actualVisibleHeight);
			this._textField.set_width(calculatedWidth - this._paddingLeft - this._paddingRight);
			this._textField.set_height(calculatedHeight - this._paddingTop - this._paddingBottom);
			this._textField.set_scrollV(1);
		} else {
			this._textField.set_x(this._paddingLeft + this._scrollX);
			this._textField.set_y(this._paddingTop + this._scrollY);
			this._textField.set_width(this._actualVisibleWidth - this._paddingLeft - this._paddingRight);
			this._textField.set_height(this._actualVisibleHeight - this._paddingTop - this._paddingBottom);
			var textFieldHeight = this._textField.get_textHeight();
			var maxScrollX = Math.max(0.0,this.actualWidth - this._actualVisibleWidth);
			var maxScrollY = Math.max(0.0,this.actualHeight - this._actualVisibleHeight);
			if(this._textField.get_maxScrollV() == 1 || maxScrollY == 0.0) {
				this._textField.set_scrollV(1);
			} else {
				this._textField.set_scrollV(1 + Math.ceil(this._scrollY / (this._savedLineMetrics.height + this._savedLineMetrics.leading)));
			}
			if(this._textField.get_maxScrollH() == 0 || maxScrollX == 0.0) {
				this._textField.set_scrollH(0);
			} else {
				this._textField.set_scrollH(Math.round(this._textField.get_maxScrollH() * (this._scrollX / maxScrollX)));
			}
		}
	},
	textField_changeHandler: function(event) {
		event.stopPropagation();
		this.set_text(this._textField.get_text());
		if(this._textFieldHasFocus) {
			var container = (js_Boot().default).__cast(this.parent , (feathers_controls_supportClasses_BaseScrollContainer().default));
			container.validateNow();
			if(container.get_maxScrollY() > 0.0) {
				var lineIndex = -1;
				var caretIndex = this._textField.get_caretIndex();
				if(caretIndex == this._textField.get_length()) {
					if(caretIndex == 0) {
						return;
					}
					--caretIndex;
					lineIndex = this._textField.getLineIndexOfChar(caretIndex);
					var charAtIndex = this._textField.get_text().charAt(caretIndex);
					if(charAtIndex == "\n" || charAtIndex == "\r") {
						++lineIndex;
					}
				} else {
					lineIndex = this._textField.getLineIndexOfChar(caretIndex);
				}
				if(this._smoothScrolling) {
					var lineHeight = this._savedLineMetrics.height + this._savedLineMetrics.leading;
					var minScrollYForLine = container.get_maxScrollY() - (this._textField.get_numLines() - lineIndex - 1) * lineHeight;
					var maxScrollYForLine = minScrollYForLine + (this._textField.get_numLines() - Math.floor(this.get_visibleHeight() / lineHeight)) * lineHeight;
					var targetScrollY = this._scrollY;
					if(minScrollYForLine - targetScrollY > 0.0) {
						targetScrollY = minScrollYForLine;
					} else if(targetScrollY - maxScrollYForLine > 0.0) {
						targetScrollY = maxScrollYForLine;
					}
					container.set_scrollY(targetScrollY);
				} else if(this._textField.get_maxScrollV() > 1) {
					var minScrollVForLine = this._textField.get_maxScrollV() - (this._textField.get_numLines() - lineIndex - 1);
					var maxScrollVForLine = minScrollVForLine + (this._textField.get_numLines() - this._textField.get_maxScrollV());
					if(maxScrollVForLine > this._textField.get_maxScrollV()) {
						maxScrollVForLine = this._textField.get_maxScrollV();
					}
					var targetScrollV = this._textField.get_scrollV();
					if(minScrollVForLine - targetScrollV > 0) {
						targetScrollV = minScrollVForLine;
					} else if(targetScrollV - maxScrollVForLine > 0) {
						targetScrollV = maxScrollVForLine;
					}
					if(targetScrollV != this._textField.get_scrollV()) {
						container.set_scrollY((targetScrollV - 1) * (this._savedLineMetrics.height + this._savedLineMetrics.leading));
					}
				}
			}
		}
	},
	textField_focusInHandler: function(event) {
		this._textFieldHasFocus = true;
	},
	textField_focusOutHandler: function(event) {
		this._textFieldHasFocus = false;
	},
	textField_scrollHandler: function(event) {
		if(this._ignoreTextFieldScroll || this._smoothScrolling) {
			return;
		}
		var container = (js_Boot().default).__cast(this.parent , (feathers_controls_supportClasses_BaseScrollContainer().default));
		if(container.get_maxScrollY() > 0.0 && this._textField.get_maxScrollV() > 1) {
			container.set_scrollY((this._textField.get_scrollV() - 1) * (this._savedLineMetrics.height + this._savedLineMetrics.leading));
		}
	},
	textFieldViewPort_focusInHandler: function(event) {
		if(this.stage != null && this.stage.get_focus() != this._textField) {
			event.stopImmediatePropagation();
			this.stage.set_focus(this._textField);
		}
	}
});
TextFieldViewPort.prototype.__class__ = TextFieldViewPort.prototype.constructor = $hxClasses["feathers.controls.supportClasses.TextFieldViewPort"] = TextFieldViewPort;

// Init



// Statics




// Export

exports["default"] = TextFieldViewPort;

/***/ }),

/***/ "./lib/_gen/feathers/core/CustomScaleManager.js":
/*!******************************************************!*\
  !*** ./lib/_gen/feathers/core/CustomScaleManager.js ***!
  \******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.CustomScaleManager

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IScaleManager() {return __webpack_require__(/*! ./../../feathers/core/IScaleManager */ "./lib/_gen/feathers/core/IScaleManager.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function openfl_geom_Rectangle() {return (__webpack_require__(/*! openfl */ "openfl").geom.Rectangle);}
function feathers_utils_MathUtil() {return __webpack_require__(/*! ./../../feathers/utils/MathUtil */ "./lib/_gen/feathers/utils/MathUtil.js");}

// Constructor

var CustomScaleManager = function(customScale,customBounds) {
	if(customScale == null) {
		customScale = 1.0;
	}
	(openfl_events_EventDispatcher()).call(this);
	this._customScale = customScale;
	this._customBounds = customBounds;
}

// Meta

CustomScaleManager.__name__ = "feathers.core.CustomScaleManager";
CustomScaleManager.__isInterface__ = false;
CustomScaleManager.__interfaces__ = [(feathers_core_IScaleManager().default)];
CustomScaleManager.__super__ = (openfl_events_EventDispatcher());
CustomScaleManager.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_target: function() {
		return this._target;
	},
	set_target: function(value) {
		if(this._target == value) {
			return this._target;
		}
		if(this._target != null) {
			this.removeTargetStageListeners();
			this._target.removeEventListener("addedToStage",$bind(this,this.customScaleManager_target_addedToStageHandler));
			this._target.removeEventListener("removedFromStage",$bind(this,this.customScaleManager_target_removedFromStageHandler));
		}
		this._target = value;
		if(this._target != null) {
			this._target.addEventListener("addedToStage",$bind(this,this.customScaleManager_target_addedToStageHandler),false,0,true);
			this._target.addEventListener("removedFromStage",$bind(this,this.customScaleManager_target_removedFromStageHandler),false,0,true);
			this.addTargetStageListeners();
		}
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._target;
	},
	get_customScale: function() {
		return this._customScale;
	},
	set_customScale: function(value) {
		if(this._customScale == value) {
			return this._customScale;
		}
		this._customScale = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._customScale;
	},
	get_customBounds: function() {
		return this._customBounds;
	},
	set_customBounds: function(value) {
		if(this._customBounds == value) {
			return this._customBounds;
		}
		this._customBounds = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._customBounds;
	},
	getScale: function() {
		return this._customScale;
	},
	getBounds: function() {
		if(this._customBounds != null) {
			return this._customBounds;
		}
		var bounds = new (openfl_geom_Rectangle())();
		if(this._target == null) {
			return bounds;
		}
		var stage = this._target.stage;
		if(stage == null) {
			return bounds;
		}
		var needsToBeDivisibleByTwo = Math.floor(this._target.get_scaleX()) != this._target.get_scaleX();
		var appWidth = Math.floor(stage.stageWidth);
		if(needsToBeDivisibleByTwo) {
			appWidth = (feathers_utils_MathUtil().default).roundDownToNearest(appWidth,2);
		}
		bounds.width = appWidth;
		var appHeight = Math.floor(stage.stageHeight);
		if(needsToBeDivisibleByTwo) {
			appHeight = (feathers_utils_MathUtil().default).roundDownToNearest(appHeight,2);
		}
		bounds.height = appHeight;
		return bounds;
	},
	addTargetStageListeners: function() {
		if(this._target == null || this._target.stage == null) {
			return;
		}
		this._target.stage.addEventListener("resize",$bind(this,this.customScaleManager_stage_resizeHandler),false,0,true);
	},
	removeTargetStageListeners: function() {
		if(this._target == null || this._target.stage == null) {
			return;
		}
		this._target.stage.removeEventListener("resize",$bind(this,this.customScaleManager_stage_resizeHandler));
	},
	customScaleManager_target_addedToStageHandler: function(event) {
		this.addTargetStageListeners();
	},
	customScaleManager_target_removedFromStageHandler: function(event) {
		this.removeTargetStageListeners();
	},
	customScaleManager_stage_resizeHandler: function(event) {
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
	}
});
CustomScaleManager.prototype.__class__ = CustomScaleManager.prototype.constructor = $hxClasses["feathers.core.CustomScaleManager"] = CustomScaleManager;

// Init



// Statics




// Export

exports["default"] = CustomScaleManager;

/***/ }),

/***/ "./lib/_gen/feathers/core/DefaultFocusManager.js":
/*!*******************************************************!*\
  !*** ./lib/_gen/feathers/core/DefaultFocusManager.js ***!
  \*******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.DefaultFocusManager

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IFocusManager() {return __webpack_require__(/*! ./../../feathers/core/IFocusManager */ "./lib/_gen/feathers/core/IFocusManager.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function openfl_display_Sprite() {return (__webpack_require__(/*! openfl */ "openfl").display.Sprite);}
function feathers_core_PopUpManager() {return __webpack_require__(/*! ./../../feathers/core/PopUpManager */ "./lib/_gen/feathers/core/PopUpManager.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function openfl_display_InteractiveObject() {return (__webpack_require__(/*! openfl */ "openfl").display.InteractiveObject);}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function openfl_display_DisplayObject() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObject);}
function feathers_core_IFocusContainer() {return __webpack_require__(/*! ./../../feathers/core/IFocusContainer */ "./lib/_gen/feathers/core/IFocusContainer.js");}
function openfl_display_DisplayObjectContainer() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObjectContainer);}
function feathers_core__$DefaultFocusManager_FocusResult() {return __webpack_require__(/*! ./../../feathers/core/_DefaultFocusManager/FocusResult */ "./lib/_gen/feathers/core/_DefaultFocusManager/FocusResult.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}
function feathers_utils_FocusUtil() {return __webpack_require__(/*! ./../../feathers/utils/FocusUtil */ "./lib/_gen/feathers/utils/FocusUtil.js");}
function feathers_utils_DPadFocusUtil() {return __webpack_require__(/*! ./../../feathers/utils/DPadFocusUtil */ "./lib/_gen/feathers/utils/DPadFocusUtil.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_utils_PopUpUtil() {return __webpack_require__(/*! ./../../feathers/utils/PopUpUtil */ "./lib/_gen/feathers/utils/PopUpUtil.js");}
function feathers_core_IFocusManagerAware() {return __webpack_require__(/*! ./../../feathers/core/IFocusManagerAware */ "./lib/_gen/feathers/core/IFocusManagerAware.js");}
function feathers_core_IFocusExtras() {return __webpack_require__(/*! ./../../feathers/core/IFocusExtras */ "./lib/_gen/feathers/core/IFocusExtras.js");}
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}
function feathers_controls_supportClasses_IViewPort() {return __webpack_require__(/*! ./../../feathers/controls/supportClasses/IViewPort */ "./lib/_gen/feathers/controls/supportClasses/IViewPort.js");}
function haxe_CallStack() {return __webpack_require__(/*! ./../../haxe/CallStack */ "./lib/_gen/haxe/CallStack.js");}
function feathers_core_IFocusExclusions() {return __webpack_require__(/*! ./../../feathers/core/IFocusExclusions */ "./lib/_gen/feathers/core/IFocusExclusions.js");}
function feathers_controls_IGroupedToggle() {return __webpack_require__(/*! ./../../feathers/controls/IGroupedToggle */ "./lib/_gen/feathers/controls/IGroupedToggle.js");}
function feathers_core_IStageFocusDelegate() {return __webpack_require__(/*! ./../../feathers/core/IStageFocusDelegate */ "./lib/_gen/feathers/core/IStageFocusDelegate.js");}
function openfl_text_TextField() {return (__webpack_require__(/*! openfl */ "openfl").text.TextField);}

// Constructor

var DefaultFocusManager = function(root) {
	this._cancelMouseFocusChange = false;
	this._showFocusIndicator = false;
	this._focusPane = null;
	this._root = null;
	this._enabled = true;
	(openfl_events_EventDispatcher()).call(this);
	this.set_root(root);
}

// Meta

DefaultFocusManager.__name__ = "feathers.core.DefaultFocusManager";
DefaultFocusManager.__isInterface__ = false;
DefaultFocusManager.__interfaces__ = [(feathers_core_IFocusManager().default)];
DefaultFocusManager.__super__ = (openfl_events_EventDispatcher());
DefaultFocusManager.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_enabled: function() {
		return this._enabled;
	},
	set_enabled: function(value) {
		if(this._enabled == value) {
			return this._enabled;
		}
		if(value && this._root == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Cannot enable focus manager without a root container."));
		}
		this._enabled = value;
		if(this._root.stage != null) {
			if(this._enabled) {
				this.restoreFocus();
			} else {
				this.set_focus(null);
			}
		}
		return this._enabled;
	},
	get_root: function() {
		return this._root;
	},
	set_root: function(value) {
		if(this._root == value) {
			return this._root;
		}
		if(this._root != null) {
			this.clearFocusManager(this._root);
			this._root.removeEventListener("addedToStage",$bind(this,this.defaultFocusManager_root_addedToStageHandler));
			this._root.removeEventListener("removedFromStage",$bind(this,this.defaultFocusManager_root_removedFromStageHandler));
			this._root.removeEventListener("added",$bind(this,this.defaultFocusManager_root_addedHandler));
			this._root.removeEventListener("removed",$bind(this,this.defaultFocusManager_root_removedHandler));
			this._root.removeEventListener("mouseDown",$bind(this,this.defaultFocusManager_root_mouseDownCaptureHandler),true);
			this._root.removeEventListener("focusIn",$bind(this,this.defaultFocusManager_root_focusInCaptureHandler),true);
			this._root.removeEventListener("mouseFocusChange",$bind(this,this.defaultFocusManager_root_mouseFocusChangeHandler));
			this._root.removeEventListener("activate",$bind(this,this.defaultFocusManager_root_activateHandler));
			this._root.removeEventListener("deactivate",$bind(this,this.defaultFocusManager_root_deactivateHandler));
			this.handleRootRemovedFromStage(this._root.stage);
		}
		this._root = value;
		if(this._root != null) {
			this.handleRootAddedToStage(this._root);
			this.setFocusManager(this._root);
			this._root.addEventListener("addedToStage",$bind(this,this.defaultFocusManager_root_addedToStageHandler),false,0,true);
			this._root.addEventListener("removedFromStage",$bind(this,this.defaultFocusManager_root_removedFromStageHandler),false,0,true);
			this._root.addEventListener("added",$bind(this,this.defaultFocusManager_root_addedHandler),false,0,true);
			this._root.addEventListener("removed",$bind(this,this.defaultFocusManager_root_removedHandler),false,0,true);
			this._root.addEventListener("mouseDown",$bind(this,this.defaultFocusManager_root_mouseDownCaptureHandler),true,0,true);
			this._root.addEventListener("focusIn",$bind(this,this.defaultFocusManager_root_focusInCaptureHandler),true,0,true);
			this._root.addEventListener("mouseFocusChange",$bind(this,this.defaultFocusManager_root_mouseFocusChangeHandler),false,0,true);
			this._root.addEventListener("activate",$bind(this,this.defaultFocusManager_root_activateHandler),false,0,true);
			this._root.addEventListener("deactivate",$bind(this,this.defaultFocusManager_root_deactivateHandler),false,0,true);
		}
		return this._root;
	},
	get_focusPane: function() {
		if(this._focusPane == null) {
			this._focusPane = new (openfl_display_Sprite())();
			this._focusPane.mouseEnabled = false;
			this._focusPane.mouseChildren = false;
			this._focusPane.set_tabEnabled(false);
			this._focusPane.set_tabChildren(false);
			(feathers_core_PopUpManager().default).forStage(this._root.stage).addPopUp(this._focusPane,false,false);
		}
		return this._focusPane;
	},
	get_showFocusIndicator: function() {
		return this._showFocusIndicator;
	},
	get_focus: function() {
		if(this._root.stage == null) {
			return null;
		}
		return this.findFocusForDisplayObject(this._root.stage.get_focus());
	},
	set_focus: function(value) {
		if(this._enabled && this._root.stage != null) {
			var oldFocus = this.findFocusForDisplayObject(this._root.stage.get_focus());
			if(oldFocus == value) {
				this.setStageFocus((js_Boot().default).__cast(value , (openfl_display_InteractiveObject())));
				return this.get_focus();
			}
		}
		if(value != null && value.get_focusManager() != this) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Failed to change focus. Object is not managed by this focus manager: " + (Std().default).string(value)));
		}
		if(this._enabled && this._root.stage != null) {
			this.setStageFocus((js_Boot().default).__cast(value , (openfl_display_InteractiveObject())));
		}
		return this.get_focus();
	},
	dispose: function() {
		if(this.get_focus() != null) {
			this.set_focus(null);
		}
		if(this._focusPane != null) {
			if(this._focusPane.parent != null) {
				this._focusPane.parent.removeChild(this._focusPane);
			}
			this._focusPane = null;
		}
		var savedRoot = this._root;
		this.set_root(null);
		this._root = savedRoot;
		(feathers_events_FeathersEvent().default).dispatch(this,"clear");
		this._root = null;
	},
	findNextFocus: function(backward) {
		if(backward == null) {
			backward = false;
		}
		var result = this.findNextFocusInternal(backward);
		return result.newFocus;
	},
	findNextFocusInternal: function(backward) {
		if(backward == null) {
			backward = false;
		}
		var newFocus = null;
		var wrapped = false;
		var currentFocus = this.get_focus();
		if(currentFocus != null && currentFocus.get_focusOwner() != null) {
			var focusOwner = currentFocus.get_focusOwner();
			if(focusOwner != null && focusOwner.get_focusManager() != this) {
				focusOwner = null;
			}
			if(focusOwner != null) {
				newFocus = focusOwner;
			}
		} else if(backward) {
			if(currentFocus != null && currentFocus.parent != null) {
				newFocus = this.findPreviousContainerFocus(currentFocus.parent,(js_Boot().default).__cast(currentFocus , (openfl_display_DisplayObject())),true);
			}
			if(newFocus == null) {
				newFocus = this.findPreviousChildFocus(this._root);
				wrapped = currentFocus != null;
			}
		} else {
			if(currentFocus != null) {
				if((js_Boot().default).__implements(currentFocus,(feathers_core_IFocusContainer().default)) && ((js_Boot().default).__cast(currentFocus , (feathers_core_IFocusContainer().default))).get_childFocusEnabled()) {
					newFocus = this.findNextContainerFocus((js_Boot().default).__cast(currentFocus , (openfl_display_DisplayObjectContainer())),null,true);
				} else if(currentFocus.parent != null) {
					newFocus = this.findNextContainerFocus(currentFocus.parent,(js_Boot().default).__cast(currentFocus , (openfl_display_DisplayObject())),true);
				}
			}
			if(newFocus == null) {
				newFocus = this.findNextChildFocus(this._root);
				wrapped = currentFocus != null;
			}
		}
		return new (feathers_core__$DefaultFocusManager_FocusResult().default)(newFocus,wrapped);
	},
	findNextRelativeFocusInternal: function(keyCode) {
		var relativePosition;
		switch(keyCode) {
		case 37:
			relativePosition = (feathers_layout_RelativePosition().default).LEFT;
			break;
		case 38:
			relativePosition = (feathers_layout_RelativePosition().default).TOP;
			break;
		case 39:
			relativePosition = (feathers_layout_RelativePosition().default).RIGHT;
			break;
		case 40:
			relativePosition = (feathers_layout_RelativePosition().default).BOTTOM;
			break;
		default:
			return new (feathers_core__$DefaultFocusManager_FocusResult().default)(null,false);
		}
		var currentFocus = this.get_focus();
		var focusableObjects = (feathers_utils_FocusUtil().default).findAllFocusableObjects(this._root);
		if(currentFocus == null) {
			if(focusableObjects.length > 0) {
				return new (feathers_core__$DefaultFocusManager_FocusResult().default)(focusableObjects[0],false);
			}
			return new (feathers_core__$DefaultFocusManager_FocusResult().default)(null,false);
		}
		var newFocus = currentFocus;
		var focusedRect = ((js_Boot().default).__cast(currentFocus , (openfl_display_DisplayObject()))).getBounds(currentFocus.stage);
		var _g = 0;
		while(_g < focusableObjects.length) {
			var focusableObject = focusableObjects[_g];
			++_g;
			if(focusableObject == currentFocus) {
				continue;
			}
			if(!this.isValidFocus(focusableObject)) {
				continue;
			}
			if((feathers_utils_DPadFocusUtil().default).isBetterFocusForRelativePosition((js_Boot().default).__cast(focusableObject , (openfl_display_DisplayObject())),(js_Boot().default).__cast(newFocus , (openfl_display_DisplayObject())),focusedRect,relativePosition)) {
				newFocus = focusableObject;
			}
		}
		return new (feathers_core__$DefaultFocusManager_FocusResult().default)(newFocus,false);
	},
	isValidFocusWithKeyboard: function(target) {
		if(((target) instanceof (openfl_display_InteractiveObject())) && !((js_Boot().default).__cast(target , (openfl_display_InteractiveObject()))).get_tabEnabled()) {
			return false;
		}
		return this.isValidFocus(target);
	},
	isValidFocus: function(target,allowIfUnderModal) {
		if(allowIfUnderModal == null) {
			allowIfUnderModal = false;
		}
		if(target == null || target.stage == null || target.get_focusManager() != this || !target.get_focusEnabled() || !target.get_visible()) {
			return false;
		}
		if((js_Boot().default).__implements(target,(feathers_core_IUIControl().default))) {
			var uiTarget = (js_Boot().default).__cast(target , (feathers_core_IUIControl().default));
			if(!uiTarget.get_enabled()) {
				return false;
			}
		}
		if(!allowIfUnderModal) {
			var popUpManager = (feathers_core_PopUpManager().default).forStage(this._root.stage);
			if(popUpManager.hasModalPopUps()) {
				var displayTarget = (js_Boot().default).__cast(target , (openfl_display_DisplayObject()));
				if(!(feathers_utils_PopUpUtil().default).isTopLevelPopUpOrIsContainedByTopLevelPopUp(displayTarget)) {
					return false;
				}
			}
		}
		return true;
	},
	setFocusManager: function(target) {
		if((js_Boot().default).__implements(target,(feathers_core_IFocusManagerAware().default))) {
			var targetWithFocus = (js_Boot().default).__cast(target , (feathers_core_IFocusManagerAware().default));
			targetWithFocus.set_focusManager(this);
		}
		var container = (Std().default).downcast(target,(openfl_display_DisplayObjectContainer()));
		if(container != null) {
			var _g = 0;
			var _g1 = container.get_numChildren();
			while(_g < _g1) {
				var i = _g++;
				var child = container.getChildAt(i);
				this.setFocusManager(child);
			}
			if((js_Boot().default).__implements(container,(feathers_core_IFocusExtras().default))) {
				var containerWithExtras = (js_Boot().default).__cast(container , (feathers_core_IFocusExtras().default));
				var extras = containerWithExtras.get_focusExtrasBefore();
				if(extras != null) {
					var _g2 = 0;
					while(_g2 < extras.length) {
						var child1 = extras[_g2];
						++_g2;
						this.setFocusManager(child1);
					}
				}
				extras = containerWithExtras.get_focusExtrasAfter();
				if(extras != null) {
					var _g21 = 0;
					while(_g21 < extras.length) {
						var child2 = extras[_g21];
						++_g21;
						this.setFocusManager(child2);
					}
				}
			}
		}
	},
	clearFocusManager: function(target) {
		if((js_Boot().default).__implements(target,(feathers_core_IFocusManagerAware().default))) {
			var targetWithFocus = (js_Boot().default).__cast(target , (feathers_core_IFocusManagerAware().default));
			if(targetWithFocus.get_focusManager() == this) {
				if(targetWithFocus == this._focusToRestore) {
					this._focusToRestore = null;
				}
				if(this.get_focus() == targetWithFocus) {
					var focusOwner = null;
					if((js_Boot().default).__implements(target,(feathers_core_IFocusObject().default))) {
						focusOwner = ((js_Boot().default).__cast(targetWithFocus , (feathers_core_IFocusObject().default))).get_focusOwner();
					}
					if(focusOwner != null && focusOwner.get_focusManager() != this) {
						focusOwner = null;
					}
					this.set_focus(focusOwner);
				}
				targetWithFocus.set_focusManager(null);
			}
		}
		var container = (Std().default).downcast(target,(openfl_display_DisplayObjectContainer()));
		if(container != null) {
			var _g = 0;
			var _g1 = container.get_numChildren();
			while(_g < _g1) {
				var i = _g++;
				var child = container.getChildAt(i);
				this.clearFocusManager(child);
			}
			if((js_Boot().default).__implements(container,(feathers_core_IFocusExtras().default))) {
				var containerWithExtras = (js_Boot().default).__cast(container , (feathers_core_IFocusExtras().default));
				var extras = containerWithExtras.get_focusExtrasBefore();
				if(extras != null) {
					var _g2 = 0;
					while(_g2 < extras.length) {
						var child1 = extras[_g2];
						++_g2;
						this.clearFocusManager(child1);
					}
				}
				extras = containerWithExtras.get_focusExtrasAfter();
				if(extras != null) {
					var _g21 = 0;
					while(_g21 < extras.length) {
						var child2 = extras[_g21];
						++_g21;
						this.clearFocusManager(child2);
					}
				}
			}
		}
	},
	findPreviousContainerFocus: function(container,beforeChild,fallbackToGlobal) {
		var outerContainer = container;
		if((js_Boot().default).__implements(container,(feathers_controls_supportClasses_IViewPort().default)) && !(js_Boot().default).__implements(container,(feathers_core_IFocusContainer().default))) {
			outerContainer = container.parent;
		}
		var hasProcessedBeforeChild = beforeChild == null;
		if((js_Boot().default).__implements(outerContainer,(feathers_core_IFocusExtras().default))) {
			var focusWithExtras = (js_Boot().default).__cast(outerContainer , (feathers_core_IFocusExtras().default));
			var extras = focusWithExtras.get_focusExtrasAfter();
			if(extras != null) {
				var startIndex = extras.length - 1;
				if(!hasProcessedBeforeChild) {
					var extraIndex = extras.indexOf(beforeChild);
					if(extraIndex != -1) {
						startIndex = extraIndex - 1;
						hasProcessedBeforeChild = true;
					}
				}
				if(hasProcessedBeforeChild) {
					var i = startIndex;
					while(i >= 0) {
						var child = extras[i];
						var foundChild = this.findPreviousChildFocus(child);
						if(foundChild != null) {
							return foundChild;
						}
						--i;
					}
				}
			}
		}
		var startIndex1 = container.get_numChildren() - 1;
		if(!hasProcessedBeforeChild) {
			var childIndex = -1;
			try {
				childIndex = container.getChildIndex(beforeChild);
			} catch( e ) {
				(haxe_CallStack().default).lastException = e;
				var e1 = ((e) instanceof (js__$Boot_HaxeError().default)) ? e.val : e;
			}
			if(childIndex != -1) {
				startIndex1 = childIndex - 1;
				hasProcessedBeforeChild = true;
			}
		}
		if(hasProcessedBeforeChild) {
			var i1 = startIndex1;
			while(i1 >= 0) {
				var child1 = container.getChildAt(i1);
				var foundChild1 = this.findPreviousChildFocus(child1);
				if(foundChild1 != null) {
					return foundChild1;
				}
				--i1;
			}
		}
		if((js_Boot().default).__implements(outerContainer,(feathers_core_IFocusExtras().default))) {
			var focusWithExtras1 = (js_Boot().default).__cast(outerContainer , (feathers_core_IFocusExtras().default));
			var extras1 = focusWithExtras1.get_focusExtrasBefore();
			if(extras1 != null) {
				var startIndex2 = extras1.length - 1;
				if(!hasProcessedBeforeChild) {
					var extraIndex1 = extras1.indexOf(beforeChild);
					if(extraIndex1 != -1) {
						startIndex2 = extraIndex1 - 1;
						hasProcessedBeforeChild = true;
					}
				}
				if(hasProcessedBeforeChild) {
					var i2 = startIndex2;
					while(i2 >= 0) {
						var child2 = extras1[i2];
						var foundChild2 = this.findPreviousChildFocus(child2);
						if(foundChild2 != null) {
							return foundChild2;
						}
						--i2;
					}
				}
			}
		}
		if(fallbackToGlobal && outerContainer != this._root) {
			if((js_Boot().default).__implements(outerContainer,(feathers_core_IFocusObject().default))) {
				var focusContainer = (js_Boot().default).__cast(outerContainer , (feathers_core_IFocusObject().default));
				if(this.isValidFocusWithKeyboard(focusContainer)) {
					return focusContainer;
				}
			}
			return this.findPreviousContainerFocus(outerContainer.parent,outerContainer,true);
		}
		return null;
	},
	findNextContainerFocus: function(container,afterChild,fallbackToGlobal) {
		var outerContainer = container;
		if((js_Boot().default).__implements(container,(feathers_controls_supportClasses_IViewPort().default)) && !(js_Boot().default).__implements(container,(feathers_core_IFocusContainer().default))) {
			outerContainer = container.parent;
		}
		var hasProcessedAfterChild = afterChild == null;
		var exclusions = null;
		if((js_Boot().default).__implements(outerContainer,(feathers_core_IFocusExclusions().default))) {
			exclusions = ((js_Boot().default).__cast(outerContainer , (feathers_core_IFocusExclusions().default))).get_focusExclusions();
		}
		if((js_Boot().default).__implements(outerContainer,(feathers_core_IFocusExtras().default))) {
			var focusWithExtras = (js_Boot().default).__cast(outerContainer , (feathers_core_IFocusExtras().default));
			var extras = focusWithExtras.get_focusExtrasBefore();
			if(extras != null) {
				var startIndex = 0;
				if(!hasProcessedAfterChild) {
					var extrasIndex = extras.indexOf(afterChild);
					if(extrasIndex != -1) {
						startIndex = extrasIndex + 1;
						hasProcessedAfterChild = true;
					}
				}
				if(hasProcessedAfterChild) {
					var _g = startIndex;
					var _g1 = extras.length;
					while(_g < _g1) {
						var i = _g++;
						var child = extras[i];
						if(exclusions != null && exclusions.indexOf(child) != -1) {
							continue;
						}
						var foundChild = this.findNextChildFocus(child);
						if(foundChild != null) {
							return foundChild;
						}
					}
				}
			}
		}
		var startIndex1 = 0;
		if(!hasProcessedAfterChild) {
			var childIndex = -1;
			try {
				childIndex = container.getChildIndex(afterChild);
			} catch( e ) {
				(haxe_CallStack().default).lastException = e;
				var e1 = ((e) instanceof (js__$Boot_HaxeError().default)) ? e.val : e;
			}
			if(childIndex != -1) {
				startIndex1 = childIndex + 1;
				hasProcessedAfterChild = true;
			}
		}
		if(hasProcessedAfterChild) {
			var _g2 = startIndex1;
			var _g11 = container.get_numChildren();
			while(_g2 < _g11) {
				var i1 = _g2++;
				var child1 = container.getChildAt(i1);
				if(exclusions != null && exclusions.indexOf(child1) != -1) {
					continue;
				}
				var foundChild1 = this.findNextChildFocus(child1);
				if(foundChild1 != null) {
					return foundChild1;
				}
			}
		}
		if((js_Boot().default).__implements(outerContainer,(feathers_core_IFocusExtras().default))) {
			var focusWithExtras1 = (js_Boot().default).__cast(outerContainer , (feathers_core_IFocusExtras().default));
			var extras1 = focusWithExtras1.get_focusExtrasAfter();
			if(extras1 != null) {
				var startIndex2 = 0;
				if(!hasProcessedAfterChild) {
					var extrasIndex1 = extras1.indexOf(afterChild);
					if(extrasIndex1 != -1) {
						startIndex2 = extrasIndex1 + 1;
						hasProcessedAfterChild = true;
					}
				}
				if(hasProcessedAfterChild) {
					var _g3 = startIndex2;
					var _g12 = extras1.length;
					while(_g3 < _g12) {
						var i2 = _g3++;
						var child2 = extras1[i2];
						if(exclusions != null && exclusions.indexOf(child2) != -1) {
							continue;
						}
						var foundChild2 = this.findNextChildFocus(child2);
						if(foundChild2 != null) {
							return foundChild2;
						}
					}
				}
			}
		}
		if(fallbackToGlobal && outerContainer != this._root && outerContainer.parent != null) {
			var foundChild3 = this.findNextContainerFocus(outerContainer.parent,outerContainer,true);
			if(foundChild3 != null) {
				return foundChild3;
			}
		}
		return null;
	},
	findPreviousChildFocus: function(child) {
		var childContainer = (Std().default).downcast(child,(openfl_display_DisplayObjectContainer()));
		if(childContainer != null) {
			var findPrevChildContainer = !(js_Boot().default).__implements(childContainer,(feathers_core_IFocusObject().default));
			if(!findPrevChildContainer && (js_Boot().default).__implements(childContainer,(feathers_core_IFocusContainer().default))) {
				var focusContainer = (js_Boot().default).__cast(childContainer , (feathers_core_IFocusContainer().default));
				findPrevChildContainer = focusContainer.get_childFocusEnabled();
			}
			if(findPrevChildContainer) {
				var foundChild = this.findPreviousContainerFocus(childContainer,null,false);
				if(foundChild != null) {
					return foundChild;
				}
			}
		}
		if((js_Boot().default).__implements(child,(feathers_core_IFocusObject().default))) {
			var childWithFocus = (js_Boot().default).__cast(child , (feathers_core_IFocusObject().default));
			if(this.isValidFocusWithKeyboard(childWithFocus)) {
				if(!(js_Boot().default).__implements(childWithFocus,(feathers_controls_IGroupedToggle().default))) {
					return childWithFocus;
				}
				var toggleGroup = ((js_Boot().default).__cast(childWithFocus , (feathers_controls_IGroupedToggle().default))).get_toggleGroup();
				if(toggleGroup == null) {
					return childWithFocus;
				}
				if((js_Boot().default).__implements(toggleGroup.get_selectedItem(),(feathers_core_IFocusObject().default))) {
					var selectedItem = (js_Boot().default).__cast(toggleGroup.get_selectedItem() , (feathers_core_IFocusObject().default));
					if(this.get_focus() != selectedItem) {
						return selectedItem;
					}
				}
			}
		}
		return null;
	},
	findNextChildFocus: function(child) {
		if((js_Boot().default).__implements(child,(feathers_core_IFocusObject().default))) {
			var childWithFocus = (js_Boot().default).__cast(child , (feathers_core_IFocusObject().default));
			if(this.isValidFocusWithKeyboard(childWithFocus)) {
				if(!(js_Boot().default).__implements(childWithFocus,(feathers_controls_IGroupedToggle().default))) {
					return childWithFocus;
				}
				var toggleGroup = ((js_Boot().default).__cast(childWithFocus , (feathers_controls_IGroupedToggle().default))).get_toggleGroup();
				if(toggleGroup == null) {
					return childWithFocus;
				}
				if((js_Boot().default).__implements(toggleGroup.get_selectedItem(),(feathers_core_IFocusObject().default))) {
					var selectedItem = (js_Boot().default).__cast(toggleGroup.get_selectedItem() , (feathers_core_IFocusObject().default));
					if(this.get_focus() != selectedItem) {
						return selectedItem;
					}
				}
			}
		}
		var childContainer = (Std().default).downcast(child,(openfl_display_DisplayObjectContainer()));
		if(childContainer != null) {
			var findNextChildContainer = !(js_Boot().default).__implements(childContainer,(feathers_core_IFocusObject().default));
			if(!findNextChildContainer && (js_Boot().default).__implements(childContainer,(feathers_core_IFocusContainer().default))) {
				var focusContainer = (js_Boot().default).__cast(childContainer , (feathers_core_IFocusContainer().default));
				findNextChildContainer = focusContainer.get_childFocusEnabled();
			}
			if(findNextChildContainer) {
				var foundChild = this.findNextContainerFocus(childContainer,null,false);
				if(foundChild != null) {
					return foundChild;
				}
			}
		}
		return null;
	},
	setStageFocus: function(value) {
		while((js_Boot().default).__implements(value,(feathers_core_IStageFocusDelegate().default))) {
			var newFocusTarget = ((js_Boot().default).__cast(value , (feathers_core_IStageFocusDelegate().default))).get_stageFocusTarget();
			if(newFocusTarget == null) {
				break;
			}
			value = newFocusTarget;
		}
		if(value == null) {
			value = this._root.stage;
		}
		if(this._root.stage.window == null) {
			return;
		}
		if(this._root.stage.get_focus() != value) {
			this._root.stage.set_focus(value);
		}
	},
	handleRootAddedToStage: function(root) {
		var stage = this._root.stage;
		if(stage == null) {
			return;
		}
		stage.stageFocusRect = false;
		if(this._enabled && stage.get_focus() == null) {
			stage.set_focus(stage);
		}
		this._root.addEventListener("keyDown",$bind(this,this.defaultFocusManager_root_keyDownHandler2),false,0,true);
	},
	handleRootRemovedFromStage: function(root) {
		this.set_focus(null);
		var stage = this._root.stage;
		if(stage == null) {
			return;
		}
		this._root.removeEventListener("keyDown",$bind(this,this.defaultFocusManager_root_keyDownHandler2));
	},
	defaultFocusManager_root_addedToStageHandler: function(event) {
		this.handleRootAddedToStage((js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject())));
	},
	defaultFocusManager_root_removedFromStageHandler: function(event) {
		this.handleRootRemovedFromStage((js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject())));
	},
	restoreFocus: function() {
		if(this._root.stage == null || this._focusToRestore == null || !this.isValidFocus(this._focusToRestore)) {
			return;
		}
		this.set_focus(this._focusToRestore);
	},
	shouldBeManaged: function(target) {
		if(target == this._root) {
			return true;
		}
		var container = target.parent;
		var valid = false;
		try {
			valid = container.getChildIndex(target) != -1;
		} catch( e ) {
			(haxe_CallStack().default).lastException = e;
			var e1 = ((e) instanceof (js__$Boot_HaxeError().default)) ? e.val : e;
		}
		if(valid && (js_Boot().default).__implements(container,(feathers_controls_supportClasses_IViewPort().default)) && !(js_Boot().default).__implements(container,(feathers_core_IFocusContainer().default))) {
			container = container.parent;
		} else if(!valid && (js_Boot().default).__implements(container,(feathers_core_IFocusExtras().default))) {
			var container1 = (js_Boot().default).__cast(container , (feathers_core_IFocusExtras().default));
			if(container1.get_focusExtrasBefore() != null) {
				var _g = 0;
				var _g1 = container1.get_focusExtrasBefore();
				while(_g < _g1.length) {
					var child = _g1[_g];
					++_g;
					if(child == target) {
						valid = true;
						break;
					}
					if(((child) instanceof (openfl_display_DisplayObjectContainer()))) {
						valid = ((js_Boot().default).__cast(child , (openfl_display_DisplayObjectContainer()))).contains(child);
						if(valid) {
							break;
						}
					}
				}
			}
			if(!valid && container1.get_focusExtrasAfter() != null) {
				var _g2 = 0;
				var _g11 = container1.get_focusExtrasAfter();
				while(_g2 < _g11.length) {
					var child1 = _g11[_g2];
					++_g2;
					if(child1 == target) {
						valid = true;
						break;
					}
					if(((child1) instanceof (openfl_display_DisplayObjectContainer()))) {
						valid = ((js_Boot().default).__cast(child1 , (openfl_display_DisplayObjectContainer()))).contains(child1);
						if(valid) {
							break;
						}
					}
				}
			}
		}
		if(!valid) {
			return false;
		}
		if(container != null && container != this._root) {
			return this.shouldBeManaged(container);
		}
		return true;
	},
	defaultFocusManager_root_addedHandler: function(event) {
		var target = (js_Boot().default).__cast(event.target , (openfl_display_DisplayObject()));
		if(this._focusPane != null) {
			if(this._focusPane == target || this._focusPane.contains(target)) {
				(feathers_core_PopUpManager().default).forStage(this._root.stage).addPopUp(this._focusPane,false,false);
				return;
			}
		}
		if(this.shouldBeManaged(target)) {
			this.setFocusManager(target);
		}
		var currentFocus = null;
		if(this._root.stage != null) {
			currentFocus = this.findFocusForDisplayObject(this._root.stage.get_focus(),true);
		}
		if(currentFocus != null && !this.isValidFocus(currentFocus)) {
			this.set_focus(null);
		}
	},
	defaultFocusManager_root_removedHandler: function(event) {
		var target = (js_Boot().default).__cast(event.target , (openfl_display_DisplayObject()));
		this.clearFocusManager(target);
	},
	defaultFocusManager_root_mouseFocusChangeHandler: function(event) {
		if(event.isDefaultPrevented()) {
			this._cancelMouseFocusChange = true;
			return;
		}
		if(!this._enabled) {
			return;
		}
		var textField = (Std().default).downcast(event.relatedObject,(openfl_text_TextField()));
		if(textField != null) {
			if(textField.get_type() == "input" || textField.get_selectable()) {
				return;
			}
			var newFocus = (js_Boot().default).__cast(this.findFocusForDisplayObject(textField) , (openfl_display_DisplayObject()));
			while((js_Boot().default).__implements(newFocus,(feathers_core_IStageFocusDelegate().default))) {
				var newFocusTarget = ((js_Boot().default).__cast(newFocus , (feathers_core_IStageFocusDelegate().default))).get_stageFocusTarget();
				if(newFocusTarget == null) {
					break;
				}
				newFocus = newFocusTarget;
			}
			if(textField == newFocus) {
				return;
			}
		}
		event.preventDefault();
	},
	defaultFocusManager_root_keyDownHandler2: function(event) {
		if(!this._enabled) {
			return;
		}
		if(event.keyCode != 9) {
			return;
		}
		this._showFocusIndicator = true;
		var result = this.findNextFocusInternal(event.shiftKey);
		this.set_focus(result.newFocus);
		if(this.get_focus() != null) {
			event.preventDefault();
		}
	},
	findFocusForDisplayObject: function(target,allowIfUnderModal) {
		if(allowIfUnderModal == null) {
			allowIfUnderModal = false;
		}
		if(target == null) {
			return null;
		}
		var focusTarget = null;
		while(true) {
			if((js_Boot().default).__implements(target,(feathers_core_IFocusObject().default))) {
				var tempFocusTarget = (js_Boot().default).__cast(target , (feathers_core_IFocusObject().default));
				if(this.isValidFocus(tempFocusTarget,allowIfUnderModal)) {
					if(focusTarget == null || !(js_Boot().default).__implements(tempFocusTarget,(feathers_core_IFocusContainer().default)) || !((js_Boot().default).__cast(tempFocusTarget , (feathers_core_IFocusContainer().default))).get_childFocusEnabled()) {
						focusTarget = tempFocusTarget;
					}
				} else if(tempFocusTarget.get_focusOwner() != null && this.isValidFocus(tempFocusTarget.get_focusOwner(),allowIfUnderModal)) {
					focusTarget = tempFocusTarget.get_focusOwner();
					target = (js_Boot().default).__cast(tempFocusTarget , (openfl_display_DisplayObject()));
				}
			}
			if(target == this._root) {
				break;
			}
			target = target.parent;
			if(!(target != null)) {
				break;
			}
		}
		return focusTarget;
	},
	defaultFocusManager_root_mouseDownCaptureHandler: function(event) {
		this._showFocusIndicator = false;
		if(this._cancelMouseFocusChange) {
			this._cancelMouseFocusChange = false;
			return;
		}
		if(!this._enabled) {
			return;
		}
		var interactiveTarget = event.target;
		var newFocus = this.findFocusForDisplayObject(interactiveTarget);
		this.set_focus(newFocus);
	},
	defaultFocusManager_root_focusInCaptureHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		this._focusToRestore = this.findFocusForDisplayObject((js_Boot().default).__cast(event.target , (openfl_display_DisplayObject())));
	},
	defaultFocusManager_root_activateHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		this.restoreFocus();
	},
	defaultFocusManager_root_deactivateHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		this.set_focus(null);
	}
});
DefaultFocusManager.prototype.__class__ = DefaultFocusManager.prototype.constructor = $hxClasses["feathers.core.DefaultFocusManager"] = DefaultFocusManager;

// Init



// Statics


DefaultFocusManager.WRAP_OBJECT_HIGH_TAB_INDEX = 2147483647

// Export

exports["default"] = DefaultFocusManager;

/***/ }),

/***/ "./lib/_gen/feathers/core/DefaultPopUpManager.js":
/*!*******************************************************!*\
  !*** ./lib/_gen/feathers/core/DefaultPopUpManager.js ***!
  \*******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.DefaultPopUpManager

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
function feathers_core_IPopUpManager() {return __webpack_require__(/*! ./../../feathers/core/IPopUpManager */ "./lib/_gen/feathers/core/IPopUpManager.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function Reflect() {return __webpack_require__(/*! ./../../Reflect */ "./lib/_gen/Reflect.js");}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function openfl_display_DisplayObject() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObject);}
function openfl_display_Stage() {return (__webpack_require__(/*! openfl */ "openfl").display.Stage);}
function openfl_display_Sprite() {return (__webpack_require__(/*! openfl */ "openfl").display.Sprite);}
function haxe_ds_ObjectMap() {return __webpack_require__(/*! ./../../haxe/ds/ObjectMap */ "./lib/_gen/haxe/ds/ObjectMap.js");}

// Constructor

var DefaultPopUpManager = function(root) {
	this._popUpToOverlay = new (haxe_ds_ObjectMap().default)();
	this._centeredPopUps = [];
	this.popUps = [];
	this._ignoreRemoval = false;
	this.set_root(root);
}

// Meta

DefaultPopUpManager.__name__ = "feathers.core.DefaultPopUpManager";
DefaultPopUpManager.__isInterface__ = false;
DefaultPopUpManager.__interfaces__ = [(feathers_core_IPopUpManager().default)];
DefaultPopUpManager.prototype = {
	get_root: function() {
		return this._root;
	},
	set_root: function(value) {
		if(this._root == value) {
			return this._root;
		}
		if(value.stage == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("DefaultPopUpManager root's stage property must not be null."));
		}
		var oldIgnoreRemoval = this._ignoreRemoval;
		this._ignoreRemoval = true;
		var _g = 0;
		var _g1 = this.popUps;
		while(_g < _g1.length) {
			var popUp = _g1[_g];
			++_g;
			this._root.removeChild(popUp);
			var overlay = this._popUpToOverlay.get(popUp);
			if(overlay != null) {
				this._root.removeChild(overlay);
			}
		}
		this._ignoreRemoval = oldIgnoreRemoval;
		this._root = value;
		var _g2 = 0;
		var _g3 = this.popUps;
		while(_g2 < _g3.length) {
			var popUp1 = _g3[_g2];
			++_g2;
			var overlay1 = this._popUpToOverlay.get(popUp1);
			if(overlay1 != null) {
				this._root.addChild(overlay1);
			}
			this._root.addChild(popUp1);
		}
		return this._root;
	},
	get_overlayFactory: function() {
		return this._overlayFactory;
	},
	set_overlayFactory: function(value) {
		if((Reflect().default).compareMethods(this._overlayFactory,value)) {
			return this._overlayFactory;
		}
		this._overlayFactory = value;
		return this._overlayFactory;
	},
	get_popUpCount: function() {
		return this.popUps.length;
	},
	get_topLevelPopUpCount: function() {
		var count = 0;
		var i = this.popUps.length - 1;
		while(i >= 0) {
			++count;
			var popUp = this.popUps[i];
			var overlay = this._popUpToOverlay.get(popUp);
			if(overlay != null) {
				return count;
			}
			--i;
		}
		return count;
	},
	getPopUpAt: function(index) {
		return this.popUps[index];
	},
	isPopUp: function(target) {
		return this.popUps.indexOf(target) != -1;
	},
	isTopLevelPopUp: function(target) {
		var i = this.popUps.length - 1;
		while(i >= 0) {
			var otherPopUp = this.popUps[i];
			if(otherPopUp == target) {
				return true;
			}
			var overlay = this._popUpToOverlay.get(otherPopUp);
			if(overlay != null) {
				return false;
			}
			--i;
		}
		return false;
	},
	isModal: function(target) {
		if(target == null) {
			return false;
		}
		return this._popUpToOverlay.get(target) != null;
	},
	hasModalPopUps: function() {
		return this._popUpToOverlay.keyValueIterator().hasNext();
	},
	addPopUp: function(popUp,isModal,isCentered,customOverlayFactory) {
		if(isCentered == null) {
			isCentered = true;
		}
		if(isModal == null) {
			isModal = true;
		}
		var index = this.popUps.indexOf(popUp);
		if(index != -1) {
			this.cleanupOverlay(popUp);
			this.popUps.splice(index,1);
		}
		if(isModal) {
			if(customOverlayFactory == null) {
				customOverlayFactory = this._overlayFactory;
			}
			if(customOverlayFactory == null) {
				customOverlayFactory = DefaultPopUpManager.defaultOverlayFactory;
			}
			var overlay = customOverlayFactory();
			var stage = this._root.stage;
			var stageTopLeft = this._root.globalToLocal(new (openfl_geom_Point())());
			var stageBottomRight = this._root.globalToLocal(new (openfl_geom_Point())(stage.stageWidth,stage.stageHeight));
			overlay.set_x(stageTopLeft.x);
			overlay.set_y(stageTopLeft.y);
			overlay.set_width(stageBottomRight.x - stageTopLeft.x);
			overlay.set_height(stageBottomRight.y - stageTopLeft.y);
			this._root.addChild(overlay);
			this._popUpToOverlay.set(popUp,overlay);
		}
		this.popUps.push(popUp);
		var result = this._root.addChild(popUp);
		if(popUp.parent == null) {
			this.cleanupOverlay(popUp);
			(HxOverrides().default).remove(this.popUps,popUp);
			return null;
		}
		popUp.addEventListener("removedFromStage",$bind(this,this.defaultPopUpManager_popUp_removedFromStageHandler));
		if(this.popUps.length == 1) {
			this._root.stage.addEventListener("resize",$bind(this,this.defaultPopUpManager_stage_resizeHandler),false,0,true);
		}
		if(isCentered) {
			if((js_Boot().default).__implements(popUp,(feathers_core_IMeasureObject().default))) {
				var measurePopUp = (js_Boot().default).__cast(popUp , (feathers_core_IMeasureObject().default));
				measurePopUp.addEventListener("resize",$bind(this,this.defaultPopUpManager_popUp_resizeHandler));
			}
			this._centeredPopUps.push(popUp);
			this.centerPopUp(popUp);
		}
		return result;
	},
	removePopUp: function(popUp) {
		var index = this.popUps.indexOf(popUp);
		if(index == -1) {
			return popUp;
		}
		return this._root.removeChild(popUp);
	},
	removeAllPopUps: function() {
		var popUps = this.popUps.slice();
		var _g = 0;
		while(_g < popUps.length) {
			var popUp = popUps[_g];
			++_g;
			if(this.isPopUp(popUp)) {
				this.removePopUp(popUp);
			}
		}
	},
	centerPopUp: function(popUp) {
		if((js_Boot().default).__implements(popUp,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(popUp , (feathers_core_IValidating().default))).validateNow();
		}
		var stage = this._root.stage;
		var stageTopLeft = this._root.globalToLocal(new (openfl_geom_Point())());
		var stageBottomRight = this._root.globalToLocal(new (openfl_geom_Point())(stage.stageWidth,stage.stageHeight));
		popUp.set_x(stageTopLeft.x + (stageBottomRight.x - stageTopLeft.x - popUp.get_width()) / 2.0);
		popUp.set_y(stageTopLeft.y + (stageBottomRight.y - stageTopLeft.y - popUp.get_height()) / 2.0);
	},
	cleanupOverlay: function(popUp) {
		var overlay = this._popUpToOverlay.get(popUp);
		if(overlay == null) {
			return;
		}
		this._root.removeChild(overlay);
		this._popUpToOverlay.remove(popUp);
	},
	defaultPopUpManager_popUp_removedFromStageHandler: function(event) {
		if(this._ignoreRemoval) {
			return;
		}
		var popUp = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		popUp.removeEventListener("removedFromStage",$bind(this,this.defaultPopUpManager_popUp_removedFromStageHandler));
		(HxOverrides().default).remove(this.popUps,popUp);
		this.cleanupOverlay(popUp);
		if(this.popUps.length == 0) {
			this._root.stage.removeEventListener("resize",$bind(this,this.defaultPopUpManager_stage_resizeHandler));
		}
	},
	defaultPopUpManager_popUp_resizeHandler: function(event) {
		var popUp = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		this.centerPopUp(popUp);
	},
	defaultPopUpManager_stage_resizeHandler: function(event) {
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		var stageTopLeft = this._root.globalToLocal(new (openfl_geom_Point())());
		var stageBottomRight = this._root.globalToLocal(new (openfl_geom_Point())(stage.stageWidth,stage.stageHeight));
		var _g = 0;
		var _g1 = this.popUps;
		while(_g < _g1.length) {
			var popUp = _g1[_g];
			++_g;
			var overlay = this._popUpToOverlay.get(popUp);
			if(overlay != null) {
				overlay.set_x(stageTopLeft.x);
				overlay.set_y(stageTopLeft.y);
				overlay.set_width(stageBottomRight.x - stageTopLeft.x);
				overlay.set_height(stageBottomRight.y - stageTopLeft.y);
			}
		}
		var _g2 = 0;
		var _g3 = this._centeredPopUps;
		while(_g2 < _g3.length) {
			var popUp1 = _g3[_g2];
			++_g2;
			this.centerPopUp(popUp1);
		}
	}
};
DefaultPopUpManager.prototype.__class__ = DefaultPopUpManager.prototype.constructor = $hxClasses["feathers.core.DefaultPopUpManager"] = DefaultPopUpManager;

// Init



// Statics

DefaultPopUpManager.defaultOverlayFactory = function() {
	var overlay = new (openfl_display_Sprite())();
	overlay.get_graphics().beginFill(8421504,0.75);
	overlay.get_graphics().drawRect(0,0,1,1);
	overlay.get_graphics().endFill();
	return overlay;
}


// Export

exports["default"] = DefaultPopUpManager;

/***/ }),

/***/ "./lib/_gen/feathers/core/DefaultToolTipManager.js":
/*!*********************************************************!*\
  !*** ./lib/_gen/feathers/core/DefaultToolTipManager.js ***!
  \*********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.DefaultToolTipManager

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function feathers_core_IToolTipManager() {return __webpack_require__(/*! ./../../feathers/core/IToolTipManager */ "./lib/_gen/feathers/core/IToolTipManager.js");}
function feathers_themes_steel_components_SteelToolTipStyles() {return __webpack_require__(/*! ./../../feathers/themes/steel/components/SteelToolTipStyles */ "./lib/_gen/feathers/themes/steel/components/SteelToolTipStyles.js");}
function openfl_Lib() {return (__webpack_require__(/*! openfl */ "openfl").Lib);}
function feathers_core_PopUpManager() {return __webpack_require__(/*! ./../../feathers/core/PopUpManager */ "./lib/_gen/feathers/core/PopUpManager.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function openfl_display_DisplayObject() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObject);}
function feathers_controls_Label() {return __webpack_require__(/*! ./../../feathers/controls/Label */ "./lib/_gen/feathers/controls/Label.js");}
function openfl_display_InteractiveObject() {return (__webpack_require__(/*! openfl */ "openfl").display.InteractiveObject);}
function openfl_display_DisplayObjectContainer() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObjectContainer);}
function feathers_style_IVariantStyleObject() {return __webpack_require__(/*! ./../../feathers/style/IVariantStyleObject */ "./lib/_gen/feathers/style/IVariantStyleObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}

// Constructor

var DefaultToolTipManager = function(root) {
	this._offsetY = 0.0;
	this._offsetX = 0.0;
	this._hideTime = -1;
	this._delay = 0.5;
	this._delayTimeoutID = null;
	this.initializeToolTipStyles();
	this._root = root;
	this._root.addEventListener("mouseMove",$bind(this,this.defaultToolTipManager_root_mouseMoveHandler),false,0,true);
}

// Meta

DefaultToolTipManager.__name__ = "feathers.core.DefaultToolTipManager";
DefaultToolTipManager.__isInterface__ = false;
DefaultToolTipManager.__interfaces__ = [(feathers_core_IToolTipManager().default)];
DefaultToolTipManager.prototype = {
	get_root: function() {
		return this._root;
	},
	dispose: function() {
		this.clearTarget();
		if(this._root != null) {
			this._root.removeEventListener("mouseMove",$bind(this,this.defaultToolTipManager_root_mouseMoveHandler));
			this._root = null;
		}
	},
	initializeToolTipStyles: function() {
		(feathers_themes_steel_components_SteelToolTipStyles().default).initialize();
	},
	clearTarget: function() {
		this.hideToolTip();
		if(this._target != null) {
			this._target.removeEventListener("mouseDown",$bind(this,this.defaultToolTipManager_target_mouseDownHandler));
			this._target.removeEventListener("rightMouseDown",$bind(this,this.defaultToolTipManager_target_rightMouseDownHandler));
			this._target.removeEventListener("middleMouseDown",$bind(this,this.defaultToolTipManager_target_middleMouseDownHandler));
			this._target.removeEventListener("rollOut",$bind(this,this.defaultToolTipManager_target_rollOutHandler));
			this._target.removeEventListener("removedFromStage",$bind(this,this.defaultToolTipManager_target_removedFromStageHandler));
			this._target = null;
		}
	},
	hideToolTip: function() {
		if(this._delayTimeoutID != null) {
			(openfl_Lib()).clearTimeout(this._delayTimeoutID);
			this._delayTimeoutID = null;
		}
		if(this._toolTip != null && this._toolTip.parent != null) {
			(feathers_core_PopUpManager().default).removePopUp((js_Boot().default).__cast(this._toolTip , (openfl_display_DisplayObject())));
			this._hideTime = (openfl_Lib()).getTimer();
		}
	},
	hoverDelayCallback: function() {
		this._delayTimeoutID = null;
		if(this._target.get_toolTip() == null) {
			return;
		}
		if(this._toolTip == null) {
			var toolTip = new (feathers_controls_Label().default)();
			toolTip.set_variant(DefaultToolTipManager.CHILD_VARIANT_TOOL_TIP);
			this._toolTip = toolTip;
		}
		if(((this._toolTip) instanceof (openfl_display_InteractiveObject()))) {
			((js_Boot().default).__cast(this._toolTip , (openfl_display_InteractiveObject()))).mouseEnabled = false;
			((js_Boot().default).__cast(this._toolTip , (openfl_display_InteractiveObject()))).set_tabEnabled(false);
		}
		if(((this._toolTip) instanceof (openfl_display_DisplayObjectContainer()))) {
			((js_Boot().default).__cast(this._toolTip , (openfl_display_DisplayObjectContainer()))).mouseChildren = false;
		}
		if((js_Boot().default).__implements(this._toolTip,(feathers_style_IVariantStyleObject().default))) {
			var variantToolTip = (js_Boot().default).__cast(this._toolTip , (feathers_style_IVariantStyleObject().default));
			if(variantToolTip.get_variant() == null) {
				variantToolTip.set_variant(DefaultToolTipManager.CHILD_VARIANT_TOOL_TIP);
			}
		}
		this._toolTip.set_text(this._target.get_toolTip());
		if((js_Boot().default).__implements(this._toolTip,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._toolTip , (feathers_core_IValidating().default))).validateNow();
		}
		var stage = this._target.stage;
		var popUpManager = (feathers_core_PopUpManager().default).forStage(stage);
		var position = popUpManager.get_root().globalToLocal(new (openfl_geom_Point())(this._toolTipStageX,this._toolTipStageY));
		var dimensions = popUpManager.get_root().globalToLocal(new (openfl_geom_Point())(stage.stageWidth,stage.stageHeight));
		var toolTipX = position.x + this._offsetX;
		if(toolTipX < 0.0) {
			toolTipX = 0.0;
		} else if(toolTipX + this._toolTip.get_width() > dimensions.x) {
			toolTipX = dimensions.x - this._toolTip.get_width();
		}
		var toolTipY = position.y - this._toolTip.get_height() + this._offsetY;
		if(toolTipY < 0.0) {
			toolTipY = 0.0;
		} else if(toolTipY + this._toolTip.get_height() > dimensions.y) {
			toolTipY = dimensions.y - this._toolTip.get_height();
		}
		this._toolTip.set_x(toolTipX);
		this._toolTip.set_y(toolTipY);
		(feathers_core_PopUpManager().default).addPopUp((js_Boot().default).__cast(this._toolTip , (openfl_display_DisplayObject())),(js_Boot().default).__cast(this._target , (openfl_display_DisplayObject())),false,false);
	},
	defaultToolTipManager_root_mouseMoveHandler: function(event) {
		if(event.buttonDown) {
			return;
		}
		var eventTarget = (js_Boot().default).__cast(event.target , (openfl_display_DisplayObject()));
		while(eventTarget != null && !(js_Boot().default).__implements(eventTarget,(feathers_core_IUIControl().default))) eventTarget = eventTarget.parent;
		if(!(js_Boot().default).__implements(eventTarget,(feathers_core_IUIControl().default))) {
			this.clearTarget();
			return;
		}
		var uiTarget = (js_Boot().default).__cast(eventTarget , (feathers_core_IUIControl().default));
		if(this._target == uiTarget) {
			this._toolTipStageX = event.stageX;
			this._toolTipStageY = event.stageY;
			return;
		}
		this.clearTarget();
		this._target = uiTarget;
		if(this._target.get_toolTip() == null) {
			this._target = null;
			return;
		}
		this._target.addEventListener("mouseDown",$bind(this,this.defaultToolTipManager_target_mouseDownHandler),false,0,true);
		this._target.addEventListener("rightMouseDown",$bind(this,this.defaultToolTipManager_target_rightMouseDownHandler),false,0,true);
		this._target.addEventListener("middleMouseDown",$bind(this,this.defaultToolTipManager_target_middleMouseDownHandler),false,0,true);
		this._target.addEventListener("rollOut",$bind(this,this.defaultToolTipManager_target_rollOutHandler),false,0,true);
		this._target.addEventListener("removedFromStage",$bind(this,this.defaultToolTipManager_target_removedFromStageHandler),false,0,true);
		this._toolTipStageX = event.stageX;
		this._toolTipStageY = event.stageY;
		this._delayTimeoutID = (openfl_Lib()).setTimeout($bind(this,this.hoverDelayCallback),(Std().default).int(this._delay * 1000.0));
	},
	defaultToolTipManager_target_mouseDownHandler: function(event) {
		this.hideToolTip();
	},
	defaultToolTipManager_target_rightMouseDownHandler: function(event) {
		this.hideToolTip();
	},
	defaultToolTipManager_target_middleMouseDownHandler: function(event) {
		this.hideToolTip();
	},
	defaultToolTipManager_target_rollOutHandler: function(event) {
		this.clearTarget();
	},
	defaultToolTipManager_target_removedFromStageHandler: function(event) {
		this.clearTarget();
	}
};
DefaultToolTipManager.prototype.__class__ = DefaultToolTipManager.prototype.constructor = $hxClasses["feathers.core.DefaultToolTipManager"] = DefaultToolTipManager;

// Init



// Statics


DefaultToolTipManager.CHILD_VARIANT_TOOL_TIP = "toolTip"

// Export

exports["default"] = DefaultToolTipManager;

/***/ }),

/***/ "./lib/_gen/feathers/core/FeathersControl.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/core/FeathersControl.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.FeathersControl

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_ILayoutObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutObject */ "./lib/_gen/feathers/layout/ILayoutObject.js");}
function feathers_style_IVariantStyleObject() {return __webpack_require__(/*! ./../../feathers/style/IVariantStyleObject */ "./lib/_gen/feathers/style/IVariantStyleObject.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_core_MeasureSprite() {return __webpack_require__(/*! ./../../feathers/core/MeasureSprite */ "./lib/_gen/feathers/core/MeasureSprite.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function feathers_core__$FeathersControl_StyleDefinition() {return __webpack_require__(/*! ./../../feathers/core/_FeathersControl/StyleDefinition */ "./lib/_gen/feathers/core/_FeathersControl/StyleDefinition.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function Type() {return __webpack_require__(/*! ./../../Type */ "./lib/_gen/Type.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function Reflect() {return __webpack_require__(/*! ./../../Reflect */ "./lib/_gen/Reflect.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}

// Constructor

var FeathersControl = function() {
	this._restrictedStyles = [];
	this._styleProviderStyles = [];
	this._clearingStyles = false;
	this._applyingStyles = false;
	this._focusPaddingLeft = 0.0;
	this._focusPaddingBottom = 0.0;
	this._focusPaddingRight = 0.0;
	this._focusPaddingTop = 0.0;
	this._focusRectSkin = null;
	this._focusEnabled = true;
	this._focusManager = null;
	this.disabledAlpha = null;
	this._explicitAlpha = 1.0;
	this._includeInLayout = true;
	this._customStyleProvider = null;
	this._currentStyleProvider = null;
	this._themeEnabled = true;
	this._toolTip = null;
	this._enabled = true;
	this._created = false;
	this._initialized = false;
	this._initializing = false;
	this._waitingToApplyStyles = false;
	(feathers_core_MeasureSprite().default).call(this);
	this.set_tabEnabled((js_Boot().default).__implements(this,(feathers_core_IFocusObject().default)));
	this.addEventListener("addedToStage",$bind(this,this.feathersControl_addedToStageHandler));
	this.addEventListener("removedFromStage",$bind(this,this.feathersControl_removedFromStageHandler));
	this.addEventListener("focusIn",$bind(this,this.feathersControl_focusInHandler));
	this.addEventListener("focusOut",$bind(this,this.feathersControl_focusOutHandler));
}

// Meta

FeathersControl.__name__ = "feathers.core.FeathersControl";
FeathersControl.__isInterface__ = false;
FeathersControl.__interfaces__ = [(feathers_layout_ILayoutObject().default),(feathers_style_IVariantStyleObject().default),(feathers_core_IUIControl().default)];
FeathersControl.__super__ = (feathers_core_MeasureSprite().default);
FeathersControl.prototype = $extend((feathers_core_MeasureSprite().default).prototype, {
	get_initialized: function() {
		return this._initialized;
	},
	get_created: function() {
		return this._created;
	},
	get_enabled: function() {
		return this._enabled;
	},
	set_enabled: function(value) {
		if(this._enabled == value) {
			return this._enabled;
		}
		this._enabled = value;
		if(this._enabled || this.disabledAlpha == null) {
			(feathers_core_MeasureSprite().default).prototype.set_alpha.call(this,this._explicitAlpha);
		} else if(!this._enabled && this.disabledAlpha != null) {
			(feathers_core_MeasureSprite().default).prototype.set_alpha.call(this,this.disabledAlpha);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STATE);
		if(this._enabled) {
			(feathers_events_FeathersEvent().default).dispatch(this,"enable");
		} else {
			(feathers_events_FeathersEvent().default).dispatch(this,"disable");
		}
		return this._enabled;
	},
	get_toolTip: function() {
		return this._toolTip;
	},
	set_toolTip: function(value) {
		if(this._toolTip == value) {
			return this._toolTip;
		}
		this._toolTip = value;
		return this._toolTip;
	},
	get_themeEnabled: function() {
		return this._themeEnabled;
	},
	set_themeEnabled: function(value) {
		if(this._themeEnabled == value) {
			return this._themeEnabled;
		}
		this._themeEnabled = value;
		if(this._initialized && this.stage != null) {
			this.applyStyles();
		} else {
			this._waitingToApplyStyles = true;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._themeEnabled;
	},
	get_styleProvider: function() {
		if(this._customStyleProvider != null) {
			return this._customStyleProvider;
		}
		return this._currentStyleProvider;
	},
	set_styleProvider: function(value) {
		if(this._customStyleProvider == value) {
			return this._customStyleProvider;
		}
		if(this._customStyleProvider != null) {
			this._customStyleProvider.removeEventListener("clear",$bind(this,this.customStyleProvider_clearHandler));
		}
		this._customStyleProvider = value;
		if(this._customStyleProvider != null) {
			this._customStyleProvider.addEventListener("clear",$bind(this,this.customStyleProvider_clearHandler),false,0,true);
		}
		if(this._initialized && this.stage != null) {
			this.applyStyles();
		} else {
			this._waitingToApplyStyles = true;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._customStyleProvider;
	},
	get_styleContext: function() {
		return null;
	},
	get_includeInLayout: function() {
		return this._includeInLayout;
	},
	set_includeInLayout: function(value) {
		if(this._includeInLayout == value) {
			return this._includeInLayout;
		}
		this._includeInLayout = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"layoutDataChange");
		return this._includeInLayout;
	},
	get_layoutData: function() {
		return this._layoutData;
	},
	set_layoutData: function(value) {
		if(!this.setStyle("layoutData")) {
			return this._layoutData;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_layoutData);
		return this.setLayoutDataInternal(value);
	},
	set_alpha: function(value) {
		this._explicitAlpha = value;
		if(this._enabled || this.disabledAlpha == null) {
			(feathers_core_MeasureSprite().default).prototype.set_alpha.call(this,value);
		}
		return this._explicitAlpha;
	},
	get_focusManager: function() {
		return this._focusManager;
	},
	set_focusManager: function(value) {
		if(this._focusManager == value) {
			return this._focusManager;
		}
		if(this._focusManager != null) {
			this.showFocus(false);
		}
		this._focusManager = value;
		return this._focusManager;
	},
	get_focusOwner: function() {
		return this._focusOwner;
	},
	set_focusOwner: function(value) {
		if(this._focusOwner == value) {
			return this._focusOwner;
		}
		this._focusOwner = value;
		return this._focusOwner;
	},
	get_rawTabEnabled: function() {
		return (feathers_core_MeasureSprite().default).prototype.get_tabEnabled.call(this);
	},
	get_focusEnabled: function() {
		if(this._enabled) {
			return this._focusEnabled;
		} else {
			return false;
		}
	},
	set_focusEnabled: function(value) {
		if(this._focusEnabled == value) {
			return this._focusEnabled;
		}
		this._focusEnabled = value;
		return this._focusEnabled;
	},
	get_tabEnabled: function() {
		if(this._enabled) {
			return (feathers_core_MeasureSprite().default).prototype.get_tabEnabled.call(this);
		} else {
			return false;
		}
	},
	get_focusRectSkin: function() {
		return this._focusRectSkin;
	},
	set_focusRectSkin: function(value) {
		if(!this.setStyle("focusRectSkin")) {
			return this._focusRectSkin;
		}
		this.showFocus(false);
		this._previousClearStyle = $bind(this,this.clearStyle_focusRectSkin);
		this._focusRectSkin = value;
		return this._focusRectSkin;
	},
	get_focusPaddingTop: function() {
		return this._focusPaddingTop;
	},
	set_focusPaddingTop: function(value) {
		if(!this.setStyle("focusPaddingTop")) {
			return this._focusPaddingTop;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_focusPaddingTop);
		this._focusPaddingTop = value;
		return this._focusPaddingTop;
	},
	get_focusPaddingRight: function() {
		return this._focusPaddingRight;
	},
	set_focusPaddingRight: function(value) {
		if(!this.setStyle("focusPaddingRight")) {
			return this._focusPaddingRight;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_focusPaddingRight);
		this._focusPaddingRight = value;
		return this._focusPaddingRight;
	},
	get_focusPaddingBottom: function() {
		return this._focusPaddingBottom;
	},
	set_focusPaddingBottom: function(value) {
		if(!this.setStyle("focusPaddingBottom")) {
			return this._focusPaddingBottom;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_focusPaddingBottom);
		this._focusPaddingBottom = value;
		return this._focusPaddingBottom;
	},
	get_focusPaddingLeft: function() {
		return this._focusPaddingLeft;
	},
	set_focusPaddingLeft: function(value) {
		if(!this.setStyle("focusPaddingLeft")) {
			return this._focusPaddingLeft;
		}
		this._previousClearStyle = $bind(this,this.clearStyle_focusPaddingLeft);
		this._focusPaddingLeft = value;
		return this._focusPaddingLeft;
	},
	setFocusPadding: function(value) {
		this.set_focusPaddingTop(value);
		this.set_focusPaddingRight(value);
		this.set_focusPaddingBottom(value);
		this.set_focusPaddingLeft(value);
	},
	showFocus: function(show) {
		if(this._focusManager == null || this._focusRectSkin == null) {
			return;
		}
		if(show) {
			this._focusManager.get_focusPane().addChild(this._focusRectSkin);
			this.addEventListener("enterFrame",$bind(this,this.feathersControl_focusRect_enterFrameHandler));
			this.positionFocusRect();
		} else if(this._focusRectSkin.parent != null) {
			this.removeEventListener("enterFrame",$bind(this,this.feathersControl_focusRect_enterFrameHandler));
			this._focusRectSkin.parent.removeChild(this._focusRectSkin);
		}
	},
	clearStyle_layoutData: function() {
		return this.setLayoutDataInternal(null);
	},
	clearStyle_focusRectSkin: function() {
		this.showFocus(false);
		this._focusRectSkin = null;
		return this._focusRectSkin;
	},
	clearStyle_focusPaddingTop: function() {
		this._focusPaddingTop = 0.0;
		return this._focusPaddingTop;
	},
	clearStyle_focusPaddingRight: function() {
		this._focusPaddingRight = 0.0;
		return this._focusPaddingRight;
	},
	clearStyle_focusPaddingBottom: function() {
		this._focusPaddingBottom = 0.0;
		return this._focusPaddingBottom;
	},
	clearStyle_focusPaddingLeft: function() {
		this._focusPaddingLeft = 0.0;
		return this._focusPaddingLeft;
	},
	positionFocusRect: function() {
		if(this._focusManager == null || this._focusRectSkin == null || this._focusRectSkin.parent == null) {
			return;
		}
		var point = new (openfl_geom_Point())(-this._focusPaddingLeft,-this._focusPaddingTop);
		point = this.localToGlobal(point);
		point = this._focusManager.get_focusPane().globalToLocal(point);
		this._focusRectSkin.set_x(point.x);
		this._focusRectSkin.set_y(point.y);
		point.setTo(this.actualWidth + this._focusPaddingRight,this.actualHeight + this._focusPaddingBottom);
		point = this.localToGlobal(point);
		point = this._focusManager.get_focusPane().globalToLocal(point);
		this._focusRectSkin.set_width(point.x - this._focusRectSkin.get_x());
		this._focusRectSkin.set_height(point.y - this._focusRectSkin.get_y());
	},
	setLayoutDataInternal: function(value) {
		if(this._layoutData == value) {
			return this._layoutData;
		}
		if(this._layoutData != null) {
			this._layoutData.removeEventListener("change",$bind(this,this.layoutData_changeHandler));
		}
		this._layoutData = value;
		if(this._layoutData != null) {
			this._layoutData.addEventListener("change",$bind(this,this.layoutData_changeHandler),false,0,true);
		}
		(feathers_events_FeathersEvent().default).dispatch(this,"layoutDataChange");
		return this._layoutData;
	},
	get_variant: function() {
		return this._variant;
	},
	set_variant: function(value) {
		if(this._variant == value) {
			return this._variant;
		}
		this._variant = value;
		if(this._initialized && this.stage != null) {
			this.applyStyles();
		} else {
			this._waitingToApplyStyles = true;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._variant;
	},
	validateNow: function() {
		if(!this._initialized) {
			if(this._initializing) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("A component cannot validate until after it has finished initializing."));
			}
			this.initializeNow();
		}
		if(this._waitingToApplyStyles) {
			this.applyStyles();
		}
		(feathers_core_MeasureSprite().default).prototype.validateNow.call(this);
		if(!this._created) {
			this._created = true;
			(feathers_events_FeathersEvent().default).dispatch(this,"creationComplete");
		}
	},
	initializeNow: function() {
		if(this._initialized || this._initializing) {
			return;
		}
		this._waitingToApplyStyles = true;
		this._initializing = true;
		this.initialize();
		this.setInvalid();
		this._initializing = false;
		this._initialized = true;
		(feathers_events_FeathersEvent().default).dispatch(this,"initialize");
	},
	move: function(x,y) {
		this.set_x(x);
		this.set_y(y);
	},
	setSize: function(width,height) {
		this.set_width(width);
		this.set_height(height);
	},
	initialize: function() {
	},
	setStyle: function(styleName,state) {
		var styleDef = state == null ? (feathers_core__$FeathersControl_StyleDefinition().default).Name(styleName) : (feathers_core__$FeathersControl_StyleDefinition().default).NameAndState(styleName,state);
		var restricted = this.containsStyleDef(this._restrictedStyles,styleDef);
		if(this._applyingStyles && restricted) {
			return false;
		}
		if(this._applyingStyles) {
			if(!this._clearingStyles && !this.containsStyleDef(this._styleProviderStyles,styleDef)) {
				this._styleProviderStyles.push(styleDef);
			}
		} else if(!restricted) {
			if(!this._clearingStyles && this.containsStyleDef(this._styleProviderStyles,styleDef)) {
				(HxOverrides().default).remove(this._styleProviderStyles,styleDef);
			}
			this._restrictedStyles.push(styleDef);
		}
		return true;
	},
	isStyleRestricted: function(styleName,state) {
		var styleDef = state == null ? (feathers_core__$FeathersControl_StyleDefinition().default).Name(styleName) : (feathers_core__$FeathersControl_StyleDefinition().default).NameAndState(styleName,state);
		return this.containsStyleDef(this._restrictedStyles,styleDef);
	},
	containsStyleDef: function(target,styleDef) {
		var _g = 0;
		while(_g < target.length) {
			var other = target[_g];
			++_g;
			if((Type().default).enumEq(styleDef,other)) {
				return true;
			}
		}
		return false;
	},
	applyStyles: function() {
		if(!this._initialized) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Cannot apply styles until after a Feathers UI component has initialized."));
		}
		this._waitingToApplyStyles = false;
		var styleProvider = this._customStyleProvider;
		if(styleProvider == null) {
			var theme = (feathers_style_Theme().default).getTheme(this);
			if(theme != null) {
				styleProvider = theme.getStyleProvider(this);
			}
		}
		if(this._themeEnabled && styleProvider == null) {
			var theme1 = (feathers_style_Theme().default).get_fallbackTheme();
			if(theme1 != null) {
				styleProvider = theme1.getStyleProvider(this);
			}
		}
		if(styleProvider == null) {
			styleProvider = this._currentStyleProvider;
		}
		if(this._currentStyleProvider != styleProvider) {
			if(this._currentStyleProvider != null) {
				this._currentStyleProvider.removeEventListener("stylesChange",$bind(this,this.styleProvider_stylesChangeHandler));
				this._currentStyleProvider.removeEventListener("clear",$bind(this,this.styleProvider_clearHandler));
			}
			this._currentStyleProvider = styleProvider;
			if(this._currentStyleProvider != null) {
				this._currentStyleProvider.addEventListener("stylesChange",$bind(this,this.styleProvider_stylesChangeHandler),false,0,true);
				this._currentStyleProvider.addEventListener("clear",$bind(this,this.styleProvider_clearHandler),false,0,true);
			}
		}
		var oldApplyingStyles = this._applyingStyles;
		this._applyingStyles = true;
		this.clearStyles();
		if(this._currentStyleProvider != null) {
			this._currentStyleProvider.applyStyles(this);
		}
		this._applyingStyles = oldApplyingStyles;
	},
	clearStyles: function() {
		var oldClearingStyles = this._clearingStyles;
		this._clearingStyles = true;
		var _g = 0;
		var _g1 = this._styleProviderStyles;
		while(_g < _g1.length) {
			var styleDef = _g1[_g];
			++_g;
			switch(styleDef._hx_index) {
			case 0:
				var name = styleDef.name;
				var clearMethodName = "clearStyle_" + name;
				var clearMethod = (Reflect().default).field(this,clearMethodName);
				if(clearMethod == null) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Missing @style method: '" + clearMethodName + "'"));
				}
				(Reflect().default).callMethod(this,clearMethod,[]);
				break;
			case 1:
				var state = styleDef.state;
				var name1 = styleDef.name;
				var method = (Reflect().default).field(this,name1);
				(Reflect().default).callMethod(this,method,[state,null]);
				break;
			}
		}
		this._styleProviderStyles = [];
		this._clearingStyles = oldClearingStyles;
	},
	clearStyleProvider: function() {
		if(this._currentStyleProvider == null) {
			return;
		}
		this._currentStyleProvider.removeEventListener("stylesChange",$bind(this,this.styleProvider_stylesChangeHandler));
		this._currentStyleProvider.removeEventListener("clear",$bind(this,this.styleProvider_clearHandler));
		this._currentStyleProvider = null;
		this._waitingToApplyStyles = true;
	},
	feathersControl_addedToStageHandler: function(event) {
		if(!this._initialized) {
			this.initializeNow();
		}
		if(this._waitingToApplyStyles) {
			this.applyStyles();
		}
	},
	feathersControl_removedFromStageHandler: function(event) {
		this.showFocus(false);
		this.clearStyleProvider();
	},
	feathersControl_focusInHandler: function(event) {
		var focusThis = null;
		if((js_Boot().default).__implements(this,(feathers_core_IFocusObject().default))) {
			focusThis = (js_Boot().default).__cast(this , (feathers_core_IFocusObject().default));
		}
		if(this._focusManager == null || !this._focusManager.get_showFocusIndicator() || this._focusManager.get_focus() != focusThis) {
			return;
		}
		this.showFocus(true);
	},
	feathersControl_focusOutHandler: function(event) {
		if(this._focusManager == null) {
			return;
		}
		this.showFocus(false);
	},
	styleProvider_stylesChangeHandler: function(event) {
		if(!event.affectsTarget(this)) {
			return;
		}
		if(this.stage != null) {
			this.applyStyles();
		} else {
			this._waitingToApplyStyles = true;
		}
	},
	customStyleProvider_clearHandler: function(event) {
		this._customStyleProvider.removeEventListener("clear",$bind(this,this.customStyleProvider_clearHandler));
		this._customStyleProvider = null;
	},
	styleProvider_clearHandler: function(event) {
		this.clearStyleProvider();
		if(this.stage != null) {
			this.applyStyles();
		}
	},
	layoutData_changeHandler: function(event) {
		(feathers_events_FeathersEvent().default).dispatch(this,"layoutDataChange");
	},
	feathersControl_focusRect_enterFrameHandler: function(event) {
		this.positionFocusRect();
	}
});
FeathersControl.prototype.__class__ = FeathersControl.prototype.constructor = $hxClasses["feathers.core.FeathersControl"] = FeathersControl;

// Init



// Statics


FeathersControl.__meta__ = { fields : { layoutData : { style : null}, focusRectSkin : { style : null}, focusPaddingTop : { style : null}, focusPaddingRight : { style : null}, focusPaddingBottom : { style : null}, focusPaddingLeft : { style : null}}}

// Export

exports["default"] = FeathersControl;

/***/ }),

/***/ "./lib/_gen/feathers/core/FocusManager.js":
/*!************************************************!*\
  !*** ./lib/_gen/feathers/core/FocusManager.js ***!
  \************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.FocusManager

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function haxe_ds_ObjectMap() {return __webpack_require__(/*! ./../../haxe/ds/ObjectMap */ "./lib/_gen/haxe/ds/ObjectMap.js");}
function feathers_core_DefaultFocusManager() {return __webpack_require__(/*! ./../../feathers/core/DefaultFocusManager */ "./lib/_gen/feathers/core/DefaultFocusManager.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IFocusManager() {return __webpack_require__(/*! ./../../feathers/core/IFocusManager */ "./lib/_gen/feathers/core/IFocusManager.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function openfl_display_Stage() {return (__webpack_require__(/*! openfl */ "openfl").display.Stage);}

// Constructor

var FocusManager = function(){}

// Meta

FocusManager.__name__ = "feathers.core.FocusManager";
FocusManager.__isInterface__ = false;
FocusManager.prototype = {
	FocusManager: function() {
	}
};
FocusManager.prototype.__class__ = FocusManager.prototype.constructor = $hxClasses["feathers.core.FocusManager"] = FocusManager;

// Init



// Statics

FocusManager.defaultFocusManagerFactory = function(root) {
	return new (feathers_core_DefaultFocusManager().default)(root);
}
FocusManager.get_focusManagerFactory = function() {
	return FocusManager._focusManagerFactory;
}
FocusManager.set_focusManagerFactory = function(value) {
	if(value == null) {
		FocusManager._focusManagerFactory = FocusManager.defaultFocusManagerFactory;
	}
	if(FocusManager._focusManagerFactory == value) {
		return FocusManager._focusManagerFactory;
	}
	FocusManager._focusManagerFactory = value;
	return FocusManager._focusManagerFactory;
}
FocusManager.hasRoot = function(stage) {
	return FocusManager.stageToManager.exists(stage);
}
FocusManager.addRoot = function(stage) {
	if(stage == null) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("FocusManager stage argument must not be null."));
	}
	if(FocusManager.stageToManager.exists(stage)) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Focus manager root already exists"));
	}
	var focusManager = FocusManager.stageToManager.get(stage);
	var factory = FocusManager.get_focusManagerFactory();
	if(factory == null) {
		factory = FocusManager.defaultFocusManagerFactory;
	}
	focusManager = factory(stage);
	focusManager.addEventListener("clear",FocusManager.focusManager_clearHandler,false,0,true);
	FocusManager.stageToManager.set(stage,focusManager);
	return focusManager;
}
FocusManager.removeRoot = function(stage) {
	var focusManager = FocusManager.stageToManager.get(stage);
	if(focusManager == null) {
		return;
	}
	focusManager.dispose();
}
FocusManager.dispose = function() {
	var stage = FocusManager.stageToManager.keys();
	while(stage.hasNext()) {
		var stage1 = stage.next();
		var focusManager = FocusManager.stageToManager.get(stage1);
		focusManager.dispose();
		FocusManager.stageToManager.remove(stage1);
	}
}
FocusManager.setFocus = function(focusable) {
	var focusManager = focusable.get_focusManager();
	if(focusManager == null) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Cannot set focus because focus manager is null."));
	}
	focusManager.set_focus(focusable);
}
FocusManager.focusManager_clearHandler = function(event) {
	var focusManager = (js_Boot().default).__cast(event.currentTarget , (feathers_core_IFocusManager().default));
	focusManager.removeEventListener("clear",FocusManager.focusManager_clearHandler);
	var stage = (Std().default).downcast(focusManager.get_root(),(openfl_display_Stage()));
	if(stage != null) {
		FocusManager.stageToManager.remove(stage);
	}
}
FocusManager.stageToManager = new (haxe_ds_ObjectMap().default)()
FocusManager._focusManagerFactory = FocusManager.defaultFocusManagerFactory

// Export

exports["default"] = FocusManager;

/***/ }),

/***/ "./lib/_gen/feathers/core/IDataSelector.js":
/*!*************************************************!*\
  !*** ./lib/_gen/feathers/core/IDataSelector.js ***!
  \*************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IDataSelector

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var IDataSelector = function() {}

// Meta

IDataSelector.__name__ = "feathers.core.IDataSelector";
IDataSelector.__isInterface__ = true;
IDataSelector.prototype = {
	
};
IDataSelector.prototype.__class__ = IDataSelector.prototype.constructor = $hxClasses["feathers.core.IDataSelector"] = IDataSelector;

// Init



// Statics




// Export

exports["default"] = IDataSelector;

/***/ }),

/***/ "./lib/_gen/feathers/core/IDateSelector.js":
/*!*************************************************!*\
  !*** ./lib/_gen/feathers/core/IDateSelector.js ***!
  \*************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IDateSelector

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var IDateSelector = function() {}

// Meta

IDateSelector.__name__ = "feathers.core.IDateSelector";
IDateSelector.__isInterface__ = true;
IDateSelector.prototype = {
	
};
IDateSelector.prototype.__class__ = IDateSelector.prototype.constructor = $hxClasses["feathers.core.IDateSelector"] = IDateSelector;

// Init



// Statics




// Export

exports["default"] = IDateSelector;

/***/ }),

/***/ "./lib/_gen/feathers/core/IDisplayObject.js":
/*!**************************************************!*\
  !*** ./lib/_gen/feathers/core/IDisplayObject.js ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IDisplayObject

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function openfl_events_IEventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.IEventDispatcher);}

// Constructor

var IDisplayObject = function() {}

// Meta

IDisplayObject.__name__ = "feathers.core.IDisplayObject";
IDisplayObject.__isInterface__ = true;
IDisplayObject.__interfaces__ = [(openfl_events_IEventDispatcher())];
IDisplayObject.prototype = {
	
};
IDisplayObject.prototype.__class__ = IDisplayObject.prototype.constructor = $hxClasses["feathers.core.IDisplayObject"] = IDisplayObject;

// Init



// Statics




// Export

exports["default"] = IDisplayObject;

/***/ }),

/***/ "./lib/_gen/feathers/core/IFocusContainer.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/core/IFocusContainer.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IFocusContainer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}

// Constructor

var IFocusContainer = function() {}

// Meta

IFocusContainer.__name__ = "feathers.core.IFocusContainer";
IFocusContainer.__isInterface__ = true;
IFocusContainer.__interfaces__ = [(feathers_core_IFocusObject().default)];
IFocusContainer.prototype = {
	
};
IFocusContainer.prototype.__class__ = IFocusContainer.prototype.constructor = $hxClasses["feathers.core.IFocusContainer"] = IFocusContainer;

// Init



// Statics




// Export

exports["default"] = IFocusContainer;

/***/ }),

/***/ "./lib/_gen/feathers/core/IFocusExclusions.js":
/*!****************************************************!*\
  !*** ./lib/_gen/feathers/core/IFocusExclusions.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IFocusExclusions

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IFocusManagerAware() {return __webpack_require__(/*! ./../../feathers/core/IFocusManagerAware */ "./lib/_gen/feathers/core/IFocusManagerAware.js");}

// Constructor

var IFocusExclusions = function() {}

// Meta

IFocusExclusions.__name__ = "feathers.core.IFocusExclusions";
IFocusExclusions.__isInterface__ = true;
IFocusExclusions.__interfaces__ = [(feathers_core_IFocusManagerAware().default)];
IFocusExclusions.prototype = {
	
};
IFocusExclusions.prototype.__class__ = IFocusExclusions.prototype.constructor = $hxClasses["feathers.core.IFocusExclusions"] = IFocusExclusions;

// Init



// Statics




// Export

exports["default"] = IFocusExclusions;

/***/ }),

/***/ "./lib/_gen/feathers/core/IFocusExtras.js":
/*!************************************************!*\
  !*** ./lib/_gen/feathers/core/IFocusExtras.js ***!
  \************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IFocusExtras

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IFocusManagerAware() {return __webpack_require__(/*! ./../../feathers/core/IFocusManagerAware */ "./lib/_gen/feathers/core/IFocusManagerAware.js");}

// Constructor

var IFocusExtras = function() {}

// Meta

IFocusExtras.__name__ = "feathers.core.IFocusExtras";
IFocusExtras.__isInterface__ = true;
IFocusExtras.__interfaces__ = [(feathers_core_IFocusManagerAware().default)];
IFocusExtras.prototype = {
	
};
IFocusExtras.prototype.__class__ = IFocusExtras.prototype.constructor = $hxClasses["feathers.core.IFocusExtras"] = IFocusExtras;

// Init



// Statics




// Export

exports["default"] = IFocusExtras;

/***/ }),

/***/ "./lib/_gen/feathers/core/IFocusManager.js":
/*!*************************************************!*\
  !*** ./lib/_gen/feathers/core/IFocusManager.js ***!
  \*************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IFocusManager

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function openfl_events_IEventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.IEventDispatcher);}

// Constructor

var IFocusManager = function() {}

// Meta

IFocusManager.__name__ = "feathers.core.IFocusManager";
IFocusManager.__isInterface__ = true;
IFocusManager.__interfaces__ = [(openfl_events_IEventDispatcher())];
IFocusManager.prototype = {
	
};
IFocusManager.prototype.__class__ = IFocusManager.prototype.constructor = $hxClasses["feathers.core.IFocusManager"] = IFocusManager;

// Init



// Statics




// Export

exports["default"] = IFocusManager;

/***/ }),

/***/ "./lib/_gen/feathers/core/IFocusManagerAware.js":
/*!******************************************************!*\
  !*** ./lib/_gen/feathers/core/IFocusManagerAware.js ***!
  \******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IFocusManagerAware

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var IFocusManagerAware = function() {}

// Meta

IFocusManagerAware.__name__ = "feathers.core.IFocusManagerAware";
IFocusManagerAware.__isInterface__ = true;
IFocusManagerAware.prototype = {
	
};
IFocusManagerAware.prototype.__class__ = IFocusManagerAware.prototype.constructor = $hxClasses["feathers.core.IFocusManagerAware"] = IFocusManagerAware;

// Init



// Statics




// Export

exports["default"] = IFocusManagerAware;

/***/ }),

/***/ "./lib/_gen/feathers/core/IFocusObject.js":
/*!************************************************!*\
  !*** ./lib/_gen/feathers/core/IFocusObject.js ***!
  \************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IFocusObject

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IDisplayObject() {return __webpack_require__(/*! ./../../feathers/core/IDisplayObject */ "./lib/_gen/feathers/core/IDisplayObject.js");}
function feathers_core_IFocusManagerAware() {return __webpack_require__(/*! ./../../feathers/core/IFocusManagerAware */ "./lib/_gen/feathers/core/IFocusManagerAware.js");}

// Constructor

var IFocusObject = function() {}

// Meta

IFocusObject.__name__ = "feathers.core.IFocusObject";
IFocusObject.__isInterface__ = true;
IFocusObject.__interfaces__ = [(feathers_core_IDisplayObject().default),(feathers_core_IFocusManagerAware().default)];
IFocusObject.prototype = {
	
};
IFocusObject.prototype.__class__ = IFocusObject.prototype.constructor = $hxClasses["feathers.core.IFocusObject"] = IFocusObject;

// Init



// Statics




// Export

exports["default"] = IFocusObject;

/***/ }),

/***/ "./lib/_gen/feathers/core/IHTMLTextControl.js":
/*!****************************************************!*\
  !*** ./lib/_gen/feathers/core/IHTMLTextControl.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IHTMLTextControl

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}

// Constructor

var IHTMLTextControl = function() {}

// Meta

IHTMLTextControl.__name__ = "feathers.core.IHTMLTextControl";
IHTMLTextControl.__isInterface__ = true;
IHTMLTextControl.__interfaces__ = [(feathers_core_IUIControl().default)];
IHTMLTextControl.prototype = {
	
};
IHTMLTextControl.prototype.__class__ = IHTMLTextControl.prototype.constructor = $hxClasses["feathers.core.IHTMLTextControl"] = IHTMLTextControl;

// Init



// Statics




// Export

exports["default"] = IHTMLTextControl;

/***/ }),

/***/ "./lib/_gen/feathers/core/IIndexSelector.js":
/*!**************************************************!*\
  !*** ./lib/_gen/feathers/core/IIndexSelector.js ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IIndexSelector

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var IIndexSelector = function() {}

// Meta

IIndexSelector.__name__ = "feathers.core.IIndexSelector";
IIndexSelector.__isInterface__ = true;
IIndexSelector.prototype = {
	
};
IIndexSelector.prototype.__class__ = IIndexSelector.prototype.constructor = $hxClasses["feathers.core.IIndexSelector"] = IIndexSelector;

// Init



// Statics




// Export

exports["default"] = IIndexSelector;

/***/ }),

/***/ "./lib/_gen/feathers/core/IMeasureObject.js":
/*!**************************************************!*\
  !*** ./lib/_gen/feathers/core/IMeasureObject.js ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IMeasureObject

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IDisplayObject() {return __webpack_require__(/*! ./../../feathers/core/IDisplayObject */ "./lib/_gen/feathers/core/IDisplayObject.js");}

// Constructor

var IMeasureObject = function() {}

// Meta

IMeasureObject.__name__ = "feathers.core.IMeasureObject";
IMeasureObject.__isInterface__ = true;
IMeasureObject.__interfaces__ = [(feathers_core_IDisplayObject().default)];
IMeasureObject.prototype = {
	
};
IMeasureObject.prototype.__class__ = IMeasureObject.prototype.constructor = $hxClasses["feathers.core.IMeasureObject"] = IMeasureObject;

// Init



// Statics




// Export

exports["default"] = IMeasureObject;

/***/ }),

/***/ "./lib/_gen/feathers/core/IOpenCloseToggle.js":
/*!****************************************************!*\
  !*** ./lib/_gen/feathers/core/IOpenCloseToggle.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IOpenCloseToggle

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}

// Constructor

var IOpenCloseToggle = function() {}

// Meta

IOpenCloseToggle.__name__ = "feathers.core.IOpenCloseToggle";
IOpenCloseToggle.__isInterface__ = true;
IOpenCloseToggle.__interfaces__ = [(feathers_core_IUIControl().default)];
IOpenCloseToggle.prototype = {
	
};
IOpenCloseToggle.prototype.__class__ = IOpenCloseToggle.prototype.constructor = $hxClasses["feathers.core.IOpenCloseToggle"] = IOpenCloseToggle;

// Init



// Statics




// Export

exports["default"] = IOpenCloseToggle;

/***/ }),

/***/ "./lib/_gen/feathers/core/IPointerDelegate.js":
/*!****************************************************!*\
  !*** ./lib/_gen/feathers/core/IPointerDelegate.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IPointerDelegate

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var IPointerDelegate = function() {}

// Meta

IPointerDelegate.__name__ = "feathers.core.IPointerDelegate";
IPointerDelegate.__isInterface__ = true;
IPointerDelegate.prototype = {
	
};
IPointerDelegate.prototype.__class__ = IPointerDelegate.prototype.constructor = $hxClasses["feathers.core.IPointerDelegate"] = IPointerDelegate;

// Init



// Statics




// Export

exports["default"] = IPointerDelegate;

/***/ }),

/***/ "./lib/_gen/feathers/core/IPopUpManager.js":
/*!*************************************************!*\
  !*** ./lib/_gen/feathers/core/IPopUpManager.js ***!
  \*************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IPopUpManager

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var IPopUpManager = function() {}

// Meta

IPopUpManager.__name__ = "feathers.core.IPopUpManager";
IPopUpManager.__isInterface__ = true;
IPopUpManager.prototype = {
	
};
IPopUpManager.prototype.__class__ = IPopUpManager.prototype.constructor = $hxClasses["feathers.core.IPopUpManager"] = IPopUpManager;

// Init



// Statics




// Export

exports["default"] = IPopUpManager;

/***/ }),

/***/ "./lib/_gen/feathers/core/IScaleManager.js":
/*!*************************************************!*\
  !*** ./lib/_gen/feathers/core/IScaleManager.js ***!
  \*************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IScaleManager

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function openfl_events_IEventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.IEventDispatcher);}

// Constructor

var IScaleManager = function() {}

// Meta

IScaleManager.__name__ = "feathers.core.IScaleManager";
IScaleManager.__isInterface__ = true;
IScaleManager.__interfaces__ = [(openfl_events_IEventDispatcher())];
IScaleManager.prototype = {
	
};
IScaleManager.prototype.__class__ = IScaleManager.prototype.constructor = $hxClasses["feathers.core.IScaleManager"] = IScaleManager;

// Init



// Statics




// Export

exports["default"] = IScaleManager;

/***/ }),

/***/ "./lib/_gen/feathers/core/IStageFocusDelegate.js":
/*!*******************************************************!*\
  !*** ./lib/_gen/feathers/core/IStageFocusDelegate.js ***!
  \*******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IStageFocusDelegate

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}

// Constructor

var IStageFocusDelegate = function() {}

// Meta

IStageFocusDelegate.__name__ = "feathers.core.IStageFocusDelegate";
IStageFocusDelegate.__isInterface__ = true;
IStageFocusDelegate.__interfaces__ = [(feathers_core_IFocusObject().default)];
IStageFocusDelegate.prototype = {
	
};
IStageFocusDelegate.prototype.__class__ = IStageFocusDelegate.prototype.constructor = $hxClasses["feathers.core.IStageFocusDelegate"] = IStageFocusDelegate;

// Init



// Statics




// Export

exports["default"] = IStageFocusDelegate;

/***/ }),

/***/ "./lib/_gen/feathers/core/IStateContext.js":
/*!*************************************************!*\
  !*** ./lib/_gen/feathers/core/IStateContext.js ***!
  \*************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IStateContext

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function openfl_events_IEventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.IEventDispatcher);}

// Constructor

var IStateContext = function() {}

// Meta

IStateContext.__name__ = "feathers.core.IStateContext";
IStateContext.__isInterface__ = true;
IStateContext.__interfaces__ = [(openfl_events_IEventDispatcher())];
IStateContext.prototype = {
	
};
IStateContext.prototype.__class__ = IStateContext.prototype.constructor = $hxClasses["feathers.core.IStateContext"] = IStateContext;

// Init



// Statics




// Export

exports["default"] = IStateContext;

/***/ }),

/***/ "./lib/_gen/feathers/core/IStateObserver.js":
/*!**************************************************!*\
  !*** ./lib/_gen/feathers/core/IStateObserver.js ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IStateObserver

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var IStateObserver = function() {}

// Meta

IStateObserver.__name__ = "feathers.core.IStateObserver";
IStateObserver.__isInterface__ = true;
IStateObserver.prototype = {
	
};
IStateObserver.prototype.__class__ = IStateObserver.prototype.constructor = $hxClasses["feathers.core.IStateObserver"] = IStateObserver;

// Init



// Statics




// Export

exports["default"] = IStateObserver;

/***/ }),

/***/ "./lib/_gen/feathers/core/ITextControl.js":
/*!************************************************!*\
  !*** ./lib/_gen/feathers/core/ITextControl.js ***!
  \************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.ITextControl

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}

// Constructor

var ITextControl = function() {}

// Meta

ITextControl.__name__ = "feathers.core.ITextControl";
ITextControl.__isInterface__ = true;
ITextControl.__interfaces__ = [(feathers_core_IUIControl().default)];
ITextControl.prototype = {
	
};
ITextControl.prototype.__class__ = ITextControl.prototype.constructor = $hxClasses["feathers.core.ITextControl"] = ITextControl;

// Init



// Statics




// Export

exports["default"] = ITextControl;

/***/ }),

/***/ "./lib/_gen/feathers/core/IToolTipManager.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/core/IToolTipManager.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IToolTipManager

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var IToolTipManager = function() {}

// Meta

IToolTipManager.__name__ = "feathers.core.IToolTipManager";
IToolTipManager.__isInterface__ = true;
IToolTipManager.prototype = {
	
};
IToolTipManager.prototype.__class__ = IToolTipManager.prototype.constructor = $hxClasses["feathers.core.IToolTipManager"] = IToolTipManager;

// Init



// Statics




// Export

exports["default"] = IToolTipManager;

/***/ }),

/***/ "./lib/_gen/feathers/core/IUIControl.js":
/*!**********************************************!*\
  !*** ./lib/_gen/feathers/core/IUIControl.js ***!
  \**********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IUIControl

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IDisplayObject() {return __webpack_require__(/*! ./../../feathers/core/IDisplayObject */ "./lib/_gen/feathers/core/IDisplayObject.js");}

// Constructor

var IUIControl = function() {}

// Meta

IUIControl.__name__ = "feathers.core.IUIControl";
IUIControl.__isInterface__ = true;
IUIControl.__interfaces__ = [(feathers_core_IDisplayObject().default)];
IUIControl.prototype = {
	
};
IUIControl.prototype.__class__ = IUIControl.prototype.constructor = $hxClasses["feathers.core.IUIControl"] = IUIControl;

// Init



// Statics




// Export

exports["default"] = IUIControl;

/***/ }),

/***/ "./lib/_gen/feathers/core/IValidating.js":
/*!***********************************************!*\
  !*** ./lib/_gen/feathers/core/IValidating.js ***!
  \***********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.IValidating

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var IValidating = function() {}

// Meta

IValidating.__name__ = "feathers.core.IValidating";
IValidating.__isInterface__ = true;
IValidating.prototype = {
	
};
IValidating.prototype.__class__ = IValidating.prototype.constructor = $hxClasses["feathers.core.IValidating"] = IValidating;

// Init



// Statics




// Export

exports["default"] = IValidating;

/***/ }),

/***/ "./lib/_gen/feathers/core/InvalidationFlag.js":
/*!****************************************************!*\
  !*** ./lib/_gen/feathers/core/InvalidationFlag.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.core.InvalidationFlag

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var InvalidationFlag = $hxEnums["feathers.core.InvalidationFlag"] = { __ename__ : "feathers.core.InvalidationFlag", __constructs__ : ["STATE","SIZE","STYLES","SKIN","LAYOUT","DATA","SCROLL","SELECTION","FOCUS","SORT","CUSTOM"]
  ,STYLES: {_hx_index:2,__enum__:"feathers.core.InvalidationFlag",toString:$estr}
  ,STATE: {_hx_index:0,__enum__:"feathers.core.InvalidationFlag",toString:$estr}
  ,SORT: {_hx_index:9,__enum__:"feathers.core.InvalidationFlag",toString:$estr}
  ,SKIN: {_hx_index:3,__enum__:"feathers.core.InvalidationFlag",toString:$estr}
  ,SIZE: {_hx_index:1,__enum__:"feathers.core.InvalidationFlag",toString:$estr}
  ,SELECTION: {_hx_index:7,__enum__:"feathers.core.InvalidationFlag",toString:$estr}
  ,SCROLL: {_hx_index:6,__enum__:"feathers.core.InvalidationFlag",toString:$estr}
  ,LAYOUT: {_hx_index:4,__enum__:"feathers.core.InvalidationFlag",toString:$estr}
  ,FOCUS: {_hx_index:8,__enum__:"feathers.core.InvalidationFlag",toString:$estr}
  ,DATA: {_hx_index:5,__enum__:"feathers.core.InvalidationFlag",toString:$estr}
  ,CUSTOM: ($_=function(value) { return {_hx_index:10,value:value,__enum__:"feathers.core.InvalidationFlag",toString:$estr}; },$_.__params__ = ["value"],$_)
};

exports["default"] = InvalidationFlag;

/***/ }),

/***/ "./lib/_gen/feathers/core/LetterboxScaleManager.js":
/*!*********************************************************!*\
  !*** ./lib/_gen/feathers/core/LetterboxScaleManager.js ***!
  \*********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.LetterboxScaleManager

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IScaleManager() {return __webpack_require__(/*! ./../../feathers/core/IScaleManager */ "./lib/_gen/feathers/core/IScaleManager.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function feathers_utils_ScaleUtil() {return __webpack_require__(/*! ./../../feathers/utils/ScaleUtil */ "./lib/_gen/feathers/utils/ScaleUtil.js");}
function openfl_geom_Rectangle() {return (__webpack_require__(/*! openfl */ "openfl").geom.Rectangle);}

// Constructor

var LetterboxScaleManager = function(originalWidth,originalHeight) {
	(openfl_events_EventDispatcher()).call(this);
	this.addTargetStageListeners();
	this._originalWidth = originalWidth;
	this._originalHeight = originalHeight;
}

// Meta

LetterboxScaleManager.__name__ = "feathers.core.LetterboxScaleManager";
LetterboxScaleManager.__isInterface__ = false;
LetterboxScaleManager.__interfaces__ = [(feathers_core_IScaleManager().default)];
LetterboxScaleManager.__super__ = (openfl_events_EventDispatcher());
LetterboxScaleManager.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_target: function() {
		return this._target;
	},
	set_target: function(value) {
		if(this._target == value) {
			return this._target;
		}
		if(this._target != null) {
			this.removeTargetStageListeners();
			this._target.removeEventListener("addedToStage",$bind(this,this.letterboxScaleManager_target_addedToStageHandler));
			this._target.removeEventListener("removedFromStage",$bind(this,this.letterboxScaleManager_target_removedFromStageHandler));
		}
		this._target = value;
		if(this._target != null) {
			this._target.addEventListener("addedToStage",$bind(this,this.letterboxScaleManager_target_addedToStageHandler),false,0,true);
			this._target.addEventListener("removedFromStage",$bind(this,this.letterboxScaleManager_target_removedFromStageHandler),false,0,true);
			this.addTargetStageListeners();
		}
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._target;
	},
	get_originalWidth: function() {
		return this._originalWidth;
	},
	set_originalWidth: function(value) {
		if(this._originalWidth == value) {
			return this._originalWidth;
		}
		this._originalWidth = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._originalWidth;
	},
	get_originalHeight: function() {
		return this._originalHeight;
	},
	set_originalHeight: function(value) {
		if(this._originalHeight == value) {
			return this._originalHeight;
		}
		this._originalHeight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._originalHeight;
	},
	getScale: function() {
		var stage = this._target.stage;
		if(stage == null) {
			return 1.0;
		}
		return (feathers_utils_ScaleUtil().default).scaleToFit(this._originalWidth,this._originalHeight,stage.stageWidth,stage.stageHeight);
	},
	getBounds: function() {
		var bounds = new (openfl_geom_Rectangle())();
		if(this._target == null) {
			return bounds;
		}
		var stage = this._target.stage;
		if(stage == null) {
			return bounds;
		}
		bounds.width = this._originalWidth * this._target.get_scaleX();
		bounds.height = this._originalHeight * this._target.get_scaleY();
		bounds.x = (stage.stageWidth - bounds.width) / 2.0;
		bounds.y = (stage.stageHeight - bounds.height) / 2.0;
		return bounds;
	},
	addTargetStageListeners: function() {
		if(this._target == null || this._target.stage == null) {
			return;
		}
		this._target.stage.addEventListener("resize",$bind(this,this.letterboxScaleManager_stage_resizeHandler),false,0,true);
	},
	removeTargetStageListeners: function() {
		if(this._target == null || this._target.stage == null) {
			return;
		}
		this._target.stage.removeEventListener("resize",$bind(this,this.letterboxScaleManager_stage_resizeHandler));
	},
	letterboxScaleManager_target_addedToStageHandler: function(event) {
		this.addTargetStageListeners();
	},
	letterboxScaleManager_target_removedFromStageHandler: function(event) {
		this.removeTargetStageListeners();
	},
	letterboxScaleManager_stage_resizeHandler: function(event) {
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
	}
});
LetterboxScaleManager.prototype.__class__ = LetterboxScaleManager.prototype.constructor = $hxClasses["feathers.core.LetterboxScaleManager"] = LetterboxScaleManager;

// Init



// Statics




// Export

exports["default"] = LetterboxScaleManager;

/***/ }),

/***/ "./lib/_gen/feathers/core/MeasureSprite.js":
/*!*************************************************!*\
  !*** ./lib/_gen/feathers/core/MeasureSprite.js ***!
  \*************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.MeasureSprite

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_core_ValidatingSprite() {return __webpack_require__(/*! ./../../feathers/core/ValidatingSprite */ "./lib/_gen/feathers/core/ValidatingSprite.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function openfl_geom_Matrix() {return (__webpack_require__(/*! openfl */ "openfl").geom.Matrix);}
function openfl_geom_Rectangle() {return (__webpack_require__(/*! openfl */ "openfl").geom.Rectangle);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}

// Constructor

var MeasureSprite = function() {
	this._explicitMaxHeight = null;
	this._explicitMaxWidth = null;
	this._explicitMinHeight = null;
	this._explicitMinWidth = null;
	this._explicitHeight = null;
	this._explicitWidth = null;
	this.scaledActualMaxHeight = 1.0 / 0.0;
	this.scaledActualMaxWidth = 1.0 / 0.0;
	this.scaledActualMinHeight = 0.0;
	this.scaledActualMinWidth = 0.0;
	this.scaledActualHeight = 0.0;
	this.scaledActualWidth = 0.0;
	this.actualMaxHeight = 1.0 / 0.0;
	this.actualMaxWidth = 1.0 / 0.0;
	this.actualMinHeight = 0.0;
	this.actualMinWidth = 0.0;
	this.actualHeight = 0.0;
	this.actualWidth = 0.0;
	(feathers_core_ValidatingSprite().default).call(this);
}

// Meta

MeasureSprite.__name__ = "feathers.core.MeasureSprite";
MeasureSprite.__isInterface__ = false;
MeasureSprite.__interfaces__ = [(feathers_core_IMeasureObject().default)];
MeasureSprite.__super__ = (feathers_core_ValidatingSprite().default);
MeasureSprite.prototype = $extend((feathers_core_ValidatingSprite().default).prototype, {
	get_width: function() {
		return this.scaledActualWidth;
	},
	set_width: function(value) {
		if(this.get_scaleX() != 1.0) {
			value /= this.get_scaleX();
		}
		this.set_explicitWidth(value);
		return this.scaledActualWidth;
	},
	get_height: function() {
		return this.scaledActualHeight;
	},
	set_height: function(value) {
		if(this.get_scaleY() != 1.0) {
			value /= this.get_scaleY();
		}
		this.set_explicitHeight(value);
		return this.scaledActualHeight;
	},
	set_scaleX: function(value) {
		(feathers_core_ValidatingSprite().default).prototype.set_scaleX.call(this,value);
		this.saveMeasurements(this.actualWidth,this.actualHeight,this.actualMinWidth,this.actualMinHeight,this.actualMaxWidth,this.actualMaxHeight);
		return this.get_scaleX();
	},
	set_scaleY: function(value) {
		(feathers_core_ValidatingSprite().default).prototype.set_scaleY.call(this,value);
		this.saveMeasurements(this.actualWidth,this.actualHeight,this.actualMinWidth,this.actualMinHeight,this.actualMaxWidth,this.actualMaxHeight);
		return this.get_scaleY();
	},
	get_explicitWidth: function() {
		return this._explicitWidth;
	},
	set_explicitWidth: function(value) {
		if(this._explicitWidth == value) {
			return this._explicitWidth;
		}
		this._explicitWidth = value;
		if(value == null) {
			this.actualWidth = 0.0;
			this.scaledActualWidth = 0.0;
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		} else {
			var result = this.saveMeasurements(value,this.actualHeight,this.actualMinWidth,this.actualMinHeight,this.actualMaxWidth,this.actualMaxHeight);
			if(result) {
				this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
			}
		}
		return this._explicitWidth;
	},
	get_explicitHeight: function() {
		return this._explicitHeight;
	},
	set_explicitHeight: function(value) {
		if(this._explicitHeight == value) {
			return this._explicitHeight;
		}
		this._explicitHeight = value;
		if(value == null) {
			this.actualHeight = 0.0;
			this.scaledActualHeight = 0.0;
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		} else {
			var result = this.saveMeasurements(this.actualWidth,value,this.actualMinWidth,this.actualMinHeight,this.actualMaxWidth,this.actualMaxHeight);
			if(result) {
				this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
			}
		}
		return this._explicitHeight;
	},
	get_explicitMinWidth: function() {
		return this._explicitMinWidth;
	},
	set_explicitMinWidth: function(value) {
		if(this._explicitMinWidth == value) {
			return this._explicitMinWidth;
		}
		var oldValue = this._explicitMinWidth;
		this._explicitMinWidth = value;
		if(value == null) {
			this.actualMinWidth = 0.0;
			this.scaledActualMinWidth = 0.0;
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		} else {
			var actualWidth = this.actualWidth;
			this.saveMeasurements(this.actualWidth,this.actualHeight,value,this.actualMinHeight,this.actualMaxWidth,this.actualMaxHeight);
			if(this._explicitWidth == null && (actualWidth < value || actualWidth == oldValue)) {
				this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
			}
		}
		return this._explicitMinWidth;
	},
	get_explicitMinHeight: function() {
		return this._explicitMinHeight;
	},
	set_explicitMinHeight: function(value) {
		if(this._explicitMinHeight == value) {
			return this._explicitMinHeight;
		}
		var oldValue = this._explicitMinHeight;
		this._explicitMinHeight = value;
		if(value == null) {
			this.actualMinHeight = 0.0;
			this.scaledActualMinHeight = 0.0;
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		} else {
			var actualHeight = this.actualHeight;
			this.saveMeasurements(this.actualWidth,this.actualHeight,this.actualMinWidth,value,this.actualMaxWidth,this.actualMaxHeight);
			if(this._explicitHeight == null && (actualHeight < value || actualHeight == oldValue)) {
				this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
			}
		}
		return this._explicitMinHeight;
	},
	get_minWidth: function() {
		return this.scaledActualMinWidth;
	},
	set_minWidth: function(value) {
		if(this.get_scaleX() != 1) {
			value /= this.get_scaleX();
		}
		this.set_explicitMinWidth(value);
		return this.scaledActualMinWidth;
	},
	get_minHeight: function() {
		return this.scaledActualMinHeight;
	},
	set_minHeight: function(value) {
		if(this.get_scaleY() != 1) {
			value /= this.get_scaleY();
		}
		this.set_explicitMinHeight(value);
		return this.scaledActualMinHeight;
	},
	get_explicitMaxWidth: function() {
		return this._explicitMaxWidth;
	},
	set_explicitMaxWidth: function(value) {
		if(this._explicitMaxWidth == value) {
			return this._explicitMaxWidth;
		}
		var oldValue = this._explicitMaxWidth;
		this._explicitMaxWidth = value;
		if(value == null) {
			this.actualMaxWidth = 1.0 / 0.0;
			this.scaledActualMaxWidth = 1.0 / 0.0;
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		} else {
			var actualWidth = this.actualWidth;
			this.saveMeasurements(this.actualWidth,this.actualHeight,this.actualMinWidth,this.actualMinHeight,value,this.actualMaxHeight);
			if(this._explicitWidth == null && (actualWidth > value || actualWidth == oldValue)) {
				this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
			}
		}
		return this._explicitMaxWidth;
	},
	get_explicitMaxHeight: function() {
		return this._explicitMaxHeight;
	},
	set_explicitMaxHeight: function(value) {
		if(this._explicitMaxHeight == value) {
			return this._explicitMaxHeight;
		}
		var oldValue = this._explicitMaxHeight;
		this._explicitMaxHeight = value;
		if(value == null) {
			this.actualMaxHeight = 1.0 / 0.0;
			this.scaledActualMaxHeight = 1.0 / 0.0;
			this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
		} else {
			var actualHeight = this.actualHeight;
			this.saveMeasurements(this.actualWidth,this.actualHeight,this.actualMinWidth,this.actualMinHeight,this.actualMaxWidth,value);
			if(this._explicitHeight == null && (actualHeight > value || actualHeight == oldValue)) {
				this.setInvalid((feathers_core_InvalidationFlag().default).SIZE);
			}
		}
		return this._explicitMaxHeight;
	},
	get_maxWidth: function() {
		return this.scaledActualMaxWidth;
	},
	set_maxWidth: function(value) {
		if(this.get_scaleX() != 1) {
			value /= this.get_scaleX();
		}
		this.set_explicitMaxWidth(value);
		return this.scaledActualMaxWidth;
	},
	get_maxHeight: function() {
		return this.scaledActualMaxHeight;
	},
	set_maxHeight: function(value) {
		if(this.get_scaleY() != 1) {
			value /= this.get_scaleY();
		}
		this.set_explicitMaxHeight(value);
		return this.scaledActualMaxHeight;
	},
	resetWidth: function() {
		this.set_explicitWidth(null);
	},
	resetHeight: function() {
		this.set_explicitHeight(null);
	},
	resetMinWidth: function() {
		this.set_explicitMinWidth(null);
	},
	resetMinHeight: function() {
		this.set_explicitMinHeight(null);
	},
	resetMaxWidth: function() {
		this.set_explicitMaxWidth(null);
	},
	resetMaxHeight: function() {
		this.set_explicitMaxHeight(null);
	},
	getBounds: function(targetCoordinateSpace) {
		if(this.__getBoundsHelperMatrix1 == null) {
			this.__getBoundsHelperMatrix1 = new (openfl_geom_Matrix())();
		} else {
			this.__getBoundsHelperMatrix1.identity();
		}
		if(targetCoordinateSpace != null && targetCoordinateSpace != this) {
			if(this.__getBoundsHelperMatrix2 == null) {
				this.__getBoundsHelperMatrix2 = new (openfl_geom_Matrix())();
			}
			var worldTransform1 = this.__getWorldTransform();
			this.__getBoundsHelperMatrix1.copyFrom(worldTransform1);
			var worldTransform2 = targetCoordinateSpace.__getWorldTransform();
			this.__getBoundsHelperMatrix2.copyFrom(worldTransform2);
			this.__getBoundsHelperMatrix2.invert();
			this.__getBoundsHelperMatrix1.concat(this.__getBoundsHelperMatrix2);
			this.__getBoundsHelperMatrix2.identity();
		}
		var x = this.__getBoundsHelperMatrix1.tx;
		var y = this.__getBoundsHelperMatrix1.ty;
		var w = this.actualWidth * this.__getBoundsHelperMatrix1.a + this.actualHeight * this.__getBoundsHelperMatrix1.c + this.__getBoundsHelperMatrix1.tx - x;
		var h = this.actualWidth * this.__getBoundsHelperMatrix1.b + this.actualHeight * this.__getBoundsHelperMatrix1.d + this.__getBoundsHelperMatrix1.ty - y;
		this.__getBoundsHelperMatrix1.identity();
		return new (openfl_geom_Rectangle())(x,y,w,h);
	},
	saveMeasurements: function(width,height,minWidth,minHeight,maxWidth,maxHeight) {
		if(minHeight == null) {
			minHeight = 0.0;
		}
		if(minWidth == null) {
			minWidth = 0.0;
		}
		if(maxWidth == null) {
			maxWidth = 1.0 / 0.0;
		}
		if(maxHeight == null) {
			maxHeight = 1.0 / 0.0;
		}
		if(this._explicitMinWidth != null) {
			minWidth = this._explicitMinWidth;
		}
		if(this._explicitMinHeight != null) {
			minHeight = this._explicitMinHeight;
		}
		if(this._explicitMaxWidth != null) {
			maxWidth = this._explicitMaxWidth;
		} else if(maxWidth == null) {
			maxWidth = 1.0 / 0.0;
		}
		if(this._explicitMaxHeight != null) {
			maxHeight = this._explicitMaxHeight;
		} else if(maxHeight == null) {
			maxHeight = 1.0 / 0.0;
		}
		if(this._explicitMaxWidth == null && maxWidth < minWidth) {
			maxWidth = minWidth;
		}
		if(this._explicitMinWidth == null && minWidth > maxWidth) {
			minWidth = maxWidth;
		}
		if(this._explicitMaxHeight == null && maxHeight < minHeight) {
			maxHeight = minHeight;
		}
		if(this._explicitMinHeight == null && minHeight > maxHeight) {
			minHeight = maxHeight;
		}
		if(this._explicitWidth != null) {
			width = this._explicitWidth;
		} else if(width < minWidth) {
			width = minWidth;
		} else if(width > maxWidth) {
			width = maxWidth;
		}
		if(this._explicitHeight != null) {
			height = this._explicitHeight;
		} else if(height < minHeight) {
			height = minHeight;
		} else if(height > maxHeight) {
			height = maxHeight;
		}
		var scaleX = this.get_scaleX();
		if(scaleX < 0.0) {
			scaleX = -scaleX;
		}
		var scaleY = this.get_scaleY();
		if(scaleY < 0.0) {
			scaleY = -scaleY;
		}
		var resized = false;
		if(this.actualWidth != width) {
			this.actualWidth = width;
			resized = true;
		}
		if(this.actualHeight != height) {
			this.actualHeight = height;
			resized = true;
		}
		if(this.actualMinWidth != minWidth) {
			this.actualMinWidth = minWidth;
			resized = true;
		}
		if(this.actualMinHeight != minHeight) {
			this.actualMinHeight = minHeight;
			resized = true;
		}
		if(this.actualMaxWidth != maxWidth) {
			this.actualMaxWidth = maxWidth;
			resized = true;
		}
		if(this.actualMaxHeight != maxHeight) {
			this.actualMaxHeight = maxHeight;
			resized = true;
		}
		width = this.scaledActualWidth;
		height = this.scaledActualHeight;
		this.scaledActualWidth = this.actualWidth * scaleX;
		this.scaledActualHeight = this.actualHeight * scaleY;
		this.scaledActualMinWidth = this.actualMinWidth * scaleX;
		this.scaledActualMinHeight = this.actualMinHeight * scaleY;
		this.scaledActualMaxWidth = this.actualMaxWidth * scaleX;
		this.scaledActualMaxHeight = this.actualMaxHeight * scaleY;
		if(width != this.scaledActualWidth || height != this.scaledActualHeight) {
			resized = true;
			(feathers_events_FeathersEvent().default).dispatch(this,"resize");
		}
		return resized;
	}
});
MeasureSprite.prototype.__class__ = MeasureSprite.prototype.constructor = $hxClasses["feathers.core.MeasureSprite"] = MeasureSprite;

// Init



// Statics




// Export

exports["default"] = MeasureSprite;

/***/ }),

/***/ "./lib/_gen/feathers/core/PopUpManager.js":
/*!************************************************!*\
  !*** ./lib/_gen/feathers/core/PopUpManager.js ***!
  \************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.PopUpManager

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function haxe_ds_ObjectMap() {return __webpack_require__(/*! ./../../haxe/ds/ObjectMap */ "./lib/_gen/haxe/ds/ObjectMap.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function feathers_core_DefaultPopUpManager() {return __webpack_require__(/*! ./../../feathers/core/DefaultPopUpManager */ "./lib/_gen/feathers/core/DefaultPopUpManager.js");}

// Constructor

var PopUpManager = function(){}

// Meta

PopUpManager.__name__ = "feathers.core.PopUpManager";
PopUpManager.__isInterface__ = false;
PopUpManager.prototype = {
	
};
PopUpManager.prototype.__class__ = PopUpManager.prototype.constructor = $hxClasses["feathers.core.PopUpManager"] = PopUpManager;

// Init



// Statics

PopUpManager.set_root = function(value) {
	var popUpManager = PopUpManager.forStage(value.stage);
	popUpManager.set_root(value);
	return value;
}
PopUpManager.get_popUpCount = function() {
	var count = 0;
	var popUpManager = PopUpManager.stageToManager.iterator();
	while(popUpManager.hasNext()) {
		var popUpManager1 = popUpManager.next();
		count += popUpManager1.get_popUpCount();
	}
	return count;
}
PopUpManager.forStage = function(stage) {
	if(stage == null) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("PopUpManager stage argument must not be null."));
	}
	var popUpManager = PopUpManager.stageToManager.get(stage);
	if(popUpManager == null) {
		var factory = PopUpManager.popUpManagerFactory;
		if(factory == null) {
			factory = PopUpManager.defaultPopUpManagerFactory;
		}
		popUpManager = factory(stage);
		PopUpManager.stageToManager.set(stage,popUpManager);
	}
	return popUpManager;
}
PopUpManager.dispose = function() {
	PopUpManager.removeAllPopUps();
	var stage = PopUpManager.stageToManager.keys();
	while(stage.hasNext()) {
		var stage1 = stage.next();
		PopUpManager.stageToManager.remove(stage1);
	}
}
PopUpManager.addPopUp = function(popUp,owner,isModal,isCentered,customOverlayFactory) {
	if(isCentered == null) {
		isCentered = true;
	}
	if(isModal == null) {
		isModal = true;
	}
	if(owner == null) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("The pop-up's owner must not be null."));
	}
	var stage = owner.stage;
	if(stage == null) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("The stage property of a pop-up's owner must not be null."));
	}
	var popUpManager = PopUpManager.forStage(stage);
	return popUpManager.addPopUp(popUp,isModal,isCentered,customOverlayFactory);
}
PopUpManager.removePopUp = function(popUp) {
	var stage = popUp.stage;
	if(stage == null) {
		return popUp;
	}
	var popUpManager = PopUpManager.forStage(stage);
	return popUpManager.removePopUp(popUp);
}
PopUpManager.removeAllPopUps = function() {
	var popUpManager = PopUpManager.stageToManager.iterator();
	while(popUpManager.hasNext()) {
		var popUpManager1 = popUpManager.next();
		popUpManager1.removeAllPopUps();
	}
}
PopUpManager.centerPopUp = function(target) {
	var stage = target.stage;
	if(stage == null) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("A pop-up's stage property must not be null."));
	}
	var popUpManager = PopUpManager.forStage(stage);
	popUpManager.centerPopUp(target);
}
PopUpManager.isPopUp = function(target) {
	if(target == null) {
		return false;
	}
	var stage = target.stage;
	if(stage == null) {
		return false;
	}
	var popUpManager = PopUpManager.forStage(stage);
	return popUpManager.isPopUp(target);
}
PopUpManager.isModal = function(target) {
	if(target == null) {
		return false;
	}
	var stage = target.stage;
	if(stage == null) {
		return false;
	}
	var popUpManager = PopUpManager.forStage(stage);
	return popUpManager.isModal(target);
}
PopUpManager.isTopLevelPopUp = function(target) {
	if(target == null) {
		return false;
	}
	var stage = target.stage;
	if(stage == null) {
		return false;
	}
	var popUpManager = PopUpManager.forStage(stage);
	return popUpManager.isTopLevelPopUp(target);
}
PopUpManager.defaultPopUpManagerFactory = function(stage) {
	return new (feathers_core_DefaultPopUpManager().default)(stage);
}
PopUpManager.stageToManager = new (haxe_ds_ObjectMap().default)()

// Export

exports["default"] = PopUpManager;

/***/ }),

/***/ "./lib/_gen/feathers/core/ScreenDensityScaleManager.js":
/*!*************************************************************!*\
  !*** ./lib/_gen/feathers/core/ScreenDensityScaleManager.js ***!
  \*************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.ScreenDensityScaleManager

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IScaleManager() {return __webpack_require__(/*! ./../../feathers/core/IScaleManager */ "./lib/_gen/feathers/core/IScaleManager.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function EReg() {return __webpack_require__(/*! ./../../EReg */ "./lib/_gen/EReg.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function openfl_geom_Rectangle() {return (__webpack_require__(/*! openfl */ "openfl").geom.Rectangle);}
function feathers_utils_MathUtil() {return __webpack_require__(/*! ./../../feathers/utils/MathUtil */ "./lib/_gen/feathers/utils/MathUtil.js");}

// Constructor

var ScreenDensityScaleManager = function(scaler) {
	(openfl_events_EventDispatcher()).call(this);
	this._scaler = scaler;
}

// Meta

ScreenDensityScaleManager.__name__ = "feathers.core.ScreenDensityScaleManager";
ScreenDensityScaleManager.__isInterface__ = false;
ScreenDensityScaleManager.__interfaces__ = [(feathers_core_IScaleManager().default)];
ScreenDensityScaleManager.__super__ = (openfl_events_EventDispatcher());
ScreenDensityScaleManager.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_target: function() {
		return this._target;
	},
	set_target: function(value) {
		if(this._target == value) {
			return this._target;
		}
		if(this._target != null) {
			this.removeTargetStageListeners();
			this._target.removeEventListener("addedToStage",$bind(this,this.screenDensityScaleManager_target_addedToStageHandler));
			this._target.removeEventListener("removedFromStage",$bind(this,this.screenDensityScaleManager_target_removedFromStageHandler));
		}
		this._target = value;
		if(this._target != null) {
			this._target.addEventListener("addedToStage",$bind(this,this.screenDensityScaleManager_target_addedToStageHandler),false,0,true);
			this._target.addEventListener("removedFromStage",$bind(this,this.screenDensityScaleManager_target_removedFromStageHandler),false,0,true);
			this.addTargetStageListeners();
		}
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._target;
	},
	get_scaler: function() {
		return this._scaler;
	},
	set_scaler: function(value) {
		if(this._scaler == value) {
			return this._scaler;
		}
		this._scaler = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._scaler;
	},
	getScale: function() {
		var result = 1.0;
		if(this._target == null) {
			return result;
		}
		result = this._target.stage.window.get_scale();
		var jsWindow = (js_Boot().default).__cast($global , Window);
		var viewportElement = jsWindow.document.getElementById("viewport");
		if(viewportElement != null && viewportElement.localName == "meta") {
			var content = viewportElement.getAttribute("content");
			if(content.indexOf("user-scalable=no") != -1) {
				var initialScalePattern = new (EReg().default)("initial-scale=(\\d(?:\\.\\d+)?)","");
				if(initialScalePattern.match(content)) {
					var initialScale = (Std().default).parseFloat(initialScalePattern.matched(1));
					result *= 1.0 / initialScale;
				}
			}
		}
		return result;
	},
	getBounds: function() {
		var bounds = new (openfl_geom_Rectangle())();
		if(this._target == null) {
			return bounds;
		}
		var stage = this._target.stage;
		if(stage == null) {
			return bounds;
		}
		var needsToBeDivisibleByTwo = Math.floor(this._target.get_scaleX()) != this._target.get_scaleX();
		var appWidth = Math.floor(stage.stageWidth);
		if(needsToBeDivisibleByTwo) {
			appWidth = (feathers_utils_MathUtil().default).roundDownToNearest(appWidth,2);
		}
		bounds.width = appWidth;
		var appHeight = Math.floor(stage.stageHeight);
		if(needsToBeDivisibleByTwo) {
			appHeight = (feathers_utils_MathUtil().default).roundDownToNearest(appHeight,2);
		}
		bounds.height = appHeight;
		return bounds;
	},
	addTargetStageListeners: function() {
		if(this._target == null || this._target.stage == null) {
			return;
		}
		this._target.stage.addEventListener("resize",$bind(this,this.screenDensityScaleManager_stage_resizeHandler),false,0,true);
	},
	removeTargetStageListeners: function() {
		if(this._target == null || this._target.stage == null) {
			return;
		}
		this._target.stage.removeEventListener("resize",$bind(this,this.screenDensityScaleManager_stage_resizeHandler));
	},
	screenDensityScaleManager_target_addedToStageHandler: function(event) {
		this.addTargetStageListeners();
	},
	screenDensityScaleManager_target_removedFromStageHandler: function(event) {
		this.removeTargetStageListeners();
	},
	screenDensityScaleManager_stage_resizeHandler: function(event) {
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
	}
});
ScreenDensityScaleManager.prototype.__class__ = ScreenDensityScaleManager.prototype.constructor = $hxClasses["feathers.core.ScreenDensityScaleManager"] = ScreenDensityScaleManager;

// Init



// Statics




// Export

exports["default"] = ScreenDensityScaleManager;

/***/ }),

/***/ "./lib/_gen/feathers/core/ToggleGroup.js":
/*!***********************************************!*\
  !*** ./lib/_gen/feathers/core/ToggleGroup.js ***!
  \***********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.ToggleGroup

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IDataSelector() {return __webpack_require__(/*! ./../../feathers/core/IDataSelector */ "./lib/_gen/feathers/core/IDataSelector.js");}
function feathers_core_IIndexSelector() {return __webpack_require__(/*! ./../../feathers/core/IIndexSelector */ "./lib/_gen/feathers/core/IIndexSelector.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_RangeError() {return (__webpack_require__(/*! openfl */ "openfl").errors.RangeError);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_controls_IGroupedToggle() {return __webpack_require__(/*! ./../../feathers/controls/IGroupedToggle */ "./lib/_gen/feathers/controls/IGroupedToggle.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function feathers_controls_IToggle() {return __webpack_require__(/*! ./../../feathers/controls/IToggle */ "./lib/_gen/feathers/controls/IToggle.js");}

// Constructor

var ToggleGroup = function() {
	this._requireSelection = true;
	this._selectedIndex = -1;
	this._ignoreChanges = false;
	this._items = [];
	(openfl_events_EventDispatcher()).call(this);
}

// Meta

ToggleGroup.__name__ = "feathers.core.ToggleGroup";
ToggleGroup.__isInterface__ = false;
ToggleGroup.__interfaces__ = [(feathers_core_IDataSelector().default),(feathers_core_IIndexSelector().default)];
ToggleGroup.__super__ = (openfl_events_EventDispatcher());
ToggleGroup.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_numItems: function() {
		return this._items.length;
	},
	get_selectedIndex: function() {
		return this._selectedIndex;
	},
	set_selectedIndex: function(value) {
		var itemCount = this._items.length;
		if(value < -1 || value > itemCount) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Index " + value + " is out of range " + itemCount + " for ToggleGroup."));
		}
		var hasChanged = this._selectedIndex != value;
		this._selectedIndex = value;
		var oldIgnoreChanges = this._ignoreChanges;
		this._ignoreChanges = true;
		var _g = 0;
		var _g1 = this._items.length;
		while(_g < _g1) {
			var i = _g++;
			var item = this._items[i];
			item.set_selected(i == value);
		}
		this._ignoreChanges = oldIgnoreChanges;
		if(hasChanged) {
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
		}
		return this._selectedIndex;
	},
	get_maxSelectedIndex: function() {
		return this._items.length - 1;
	},
	get_selectedItem: function() {
		if(this._selectedIndex == -1) {
			return null;
		}
		return this._items[this._selectedIndex];
	},
	set_selectedItem: function(value) {
		this.set_selectedIndex(this._items.indexOf(value));
		return this.get_selectedItem();
	},
	get_requireSelection: function() {
		return this._requireSelection;
	},
	set_requireSelection: function(value) {
		if(this._requireSelection == value) {
			return this._requireSelection;
		}
		this._requireSelection = value;
		if(this._requireSelection && this._selectedIndex == -1 && this._items.length > 0) {
			this.set_selectedIndex(0);
		}
		return this._requireSelection;
	},
	addItem: function(item) {
		if(item == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("IToggle passed to ToggleGroup addItem() must not be null."));
		}
		var index = this._items.indexOf(item);
		if(index != -1) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Cannot add an item to a ToggleGroup more than once."));
		}
		this._items.push(item);
		if(item.get_selected()) {
			this.set_selectedItem(item);
		} else if(this._selectedIndex < 0 && this._requireSelection) {
			this.set_selectedItem(item);
		} else {
			item.set_selected(false);
		}
		item.addEventListener("change",$bind(this,this.item_changeHandler),false,0,true);
		if((js_Boot().default).__implements(item,(feathers_controls_IGroupedToggle().default))) {
			((js_Boot().default).__cast(item , (feathers_controls_IGroupedToggle().default))).set_toggleGroup(this);
		}
	},
	removeItem: function(item) {
		var index = this._items.indexOf(item);
		if(index == -1) {
			return;
		}
		(HxOverrides().default).remove(this._items,item);
		item.removeEventListener("change",$bind(this,this.item_changeHandler));
		if((js_Boot().default).__implements(item,(feathers_controls_IGroupedToggle().default))) {
			((js_Boot().default).__cast(item , (feathers_controls_IGroupedToggle().default))).set_toggleGroup(null);
		}
		if(this._selectedIndex > index) {
			var _g = this;
			_g.set_selectedIndex(_g.get_selectedIndex() - 1);
		} else if(this.get_selectedIndex() == index) {
			if(this._requireSelection) {
				var maxSelectedIndex = this._items.length - 1;
				if(this._selectedIndex > maxSelectedIndex) {
					this.set_selectedIndex(maxSelectedIndex);
				} else {
					(feathers_events_FeathersEvent().default).dispatch(this,"change");
				}
			} else {
				this.set_selectedIndex(-1);
			}
		}
	},
	removeAllItems: function() {
		var _g = 0;
		var _g1 = this._items;
		while(_g < _g1.length) {
			var item = _g1[_g];
			++_g;
			item.removeEventListener("change",$bind(this,this.item_changeHandler));
			if((js_Boot().default).__implements(item,(feathers_controls_IGroupedToggle().default))) {
				((js_Boot().default).__cast(item , (feathers_controls_IGroupedToggle().default))).set_toggleGroup(null);
			}
		}
		this._items.length = 0;
		this.set_selectedIndex(-1);
	},
	hasItem: function(item) {
		return this._items.indexOf(item) != -1;
	},
	getItemAt: function(index) {
		if(index < 0 || index >= this._items.length) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("The supplied index is out of bounds."));
		}
		return this._items[index];
	},
	getItemIndex: function(item) {
		return this._items.indexOf(item);
	},
	setItemIndex: function(item,index) {
		var oldIndex = this._items.indexOf(item);
		if(oldIndex < 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Attempting to set index of an item that has not been added to this ToggleGroup."));
		}
		if(oldIndex == index) {
			return;
		}
		(HxOverrides().default).remove(this._items,item);
		this._items.splice(index,0,item);
		if(this._selectedIndex >= 0) {
			if(this._selectedIndex == oldIndex) {
				this.set_selectedIndex(index);
			} else if(oldIndex < this._selectedIndex && index > this._selectedIndex) {
				var _g = this;
				_g.set_selectedIndex(_g.get_selectedIndex() - 1);
			} else if(oldIndex > this._selectedIndex && index < this._selectedIndex) {
				var _g1 = this;
				_g1.set_selectedIndex(_g1.get_selectedIndex() + 1);
			}
		}
	},
	item_changeHandler: function(event) {
		if(this._ignoreChanges) {
			return;
		}
		var item = (js_Boot().default).__cast(event.currentTarget , (feathers_controls_IToggle().default));
		var index = this._items.indexOf(item);
		if(item.get_selected() || this._requireSelection && this._selectedIndex == index) {
			this.set_selectedIndex(index);
		} else if(!item.get_selected()) {
			this.set_selectedIndex(-1);
		}
	}
});
ToggleGroup.prototype.__class__ = ToggleGroup.prototype.constructor = $hxClasses["feathers.core.ToggleGroup"] = ToggleGroup;

// Init



// Statics




// Export

exports["default"] = ToggleGroup;

/***/ }),

/***/ "./lib/_gen/feathers/core/ToolTipManager.js":
/*!**************************************************!*\
  !*** ./lib/_gen/feathers/core/ToolTipManager.js ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.ToolTipManager

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function feathers_core_DefaultToolTipManager() {return __webpack_require__(/*! ./../../feathers/core/DefaultToolTipManager */ "./lib/_gen/feathers/core/DefaultToolTipManager.js");}
function haxe_ds_ObjectMap() {return __webpack_require__(/*! ./../../haxe/ds/ObjectMap */ "./lib/_gen/haxe/ds/ObjectMap.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}

// Constructor

var ToolTipManager = function(){}

// Meta

ToolTipManager.__name__ = "feathers.core.ToolTipManager";
ToolTipManager.__isInterface__ = false;
ToolTipManager.prototype = {
	ToolTipManager: function() {
	}
};
ToolTipManager.prototype.__class__ = ToolTipManager.prototype.constructor = $hxClasses["feathers.core.ToolTipManager"] = ToolTipManager;

// Init



// Statics

ToolTipManager.defaultToolTipManagerFactory = function(root) {
	return new (feathers_core_DefaultToolTipManager().default)(root);
}
ToolTipManager.get_toolTipManagerFactory = function() {
	return ToolTipManager._toolTipManagerFactory;
}
ToolTipManager.set_toolTipManagerFactory = function(value) {
	if(value == null) {
		ToolTipManager._toolTipManagerFactory = ToolTipManager.defaultToolTipManagerFactory;
	}
	if(ToolTipManager._toolTipManagerFactory == value) {
		return ToolTipManager._toolTipManagerFactory;
	}
	ToolTipManager._toolTipManagerFactory = value;
	return ToolTipManager._toolTipManagerFactory;
}
ToolTipManager.hasRoot = function(stage) {
	return ToolTipManager.stageToManager.exists(stage);
}
ToolTipManager.forRoot = function(stage) {
	return ToolTipManager.stageToManager.get(stage);
}
ToolTipManager.addRoot = function(stage) {
	if(stage == null) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("ToolTipManager stage argument must not be null."));
	}
	if(ToolTipManager.stageToManager.exists(stage)) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Tool tip manager root already exists"));
	}
	var toolTipManager = ToolTipManager.stageToManager.get(stage);
	var factory = ToolTipManager.get_toolTipManagerFactory();
	if(factory == null) {
		factory = ToolTipManager.defaultToolTipManagerFactory;
	}
	toolTipManager = factory(stage);
	ToolTipManager.stageToManager.set(stage,toolTipManager);
	return toolTipManager;
}
ToolTipManager.removeRoot = function(stage) {
	var toolTipManager = ToolTipManager.stageToManager.get(stage);
	if(toolTipManager == null) {
		return;
	}
	toolTipManager.dispose();
	ToolTipManager.stageToManager.remove(stage);
}
ToolTipManager.dispose = function() {
	var stage = ToolTipManager.stageToManager.keys();
	while(stage.hasNext()) {
		var stage1 = stage.next();
		ToolTipManager.stageToManager.remove(stage1);
	}
}
ToolTipManager._toolTipManagerFactory = ToolTipManager.defaultToolTipManagerFactory
ToolTipManager.stageToManager = new (haxe_ds_ObjectMap().default)()

// Export

exports["default"] = ToolTipManager;

/***/ }),

/***/ "./lib/_gen/feathers/core/ValidatingSprite.js":
/*!****************************************************!*\
  !*** ./lib/_gen/feathers/core/ValidatingSprite.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.ValidatingSprite

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function openfl_display_Sprite() {return (__webpack_require__(/*! openfl */ "openfl").display.Sprite);}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function Type() {return __webpack_require__(/*! ./../../Type */ "./lib/_gen/Type.js");}
function feathers_utils_DisplayUtil() {return __webpack_require__(/*! ./../../feathers/utils/DisplayUtil */ "./lib/_gen/feathers/utils/DisplayUtil.js");}
function feathers_core_ValidationQueue() {return __webpack_require__(/*! ./../../feathers/core/ValidationQueue */ "./lib/_gen/feathers/core/ValidationQueue.js");}
function haxe_ds_EnumValueMap() {return __webpack_require__(/*! ./../../haxe/ds/EnumValueMap */ "./lib/_gen/haxe/ds/EnumValueMap.js");}

// Constructor

var ValidatingSprite = function() {
	this._setInvalidationFlagsOnly = false;
	this._ignoreInvalidationFlags = false;
	this._depth = -1;
	this._validationQueue = null;
	this._setInvalidCount = 0;
	this._delayedInvalidationFlags = new (haxe_ds_EnumValueMap().default)();
	this._invalidationFlags = new (haxe_ds_EnumValueMap().default)();
	this._allInvalidDelayed = false;
	this._allInvalid = false;
	this._validating = false;
	(openfl_display_Sprite()).call(this);
	this.addEventListener("addedToStage",$bind(this,this.validatingSprite_addedToStageHandler));
	this.addEventListener("removedFromStage",$bind(this,this.validatingSprite_removedFromStageHandler));
}

// Meta

ValidatingSprite.__name__ = "feathers.core.ValidatingSprite";
ValidatingSprite.__isInterface__ = false;
ValidatingSprite.__interfaces__ = [(feathers_core_IValidating().default)];
ValidatingSprite.__super__ = (openfl_display_Sprite());
ValidatingSprite.prototype = $extend((openfl_display_Sprite()).prototype, {
	get_validating: function() {
		return this._validating;
	},
	get_depth: function() {
		return this._depth;
	},
	isInvalid: function(flag) {
		if(this._allInvalid) {
			return true;
		}
		if(flag == null) {
			return this._invalidationFlags.keys().hasNext();
		}
		return this._invalidationFlags.exists(flag);
	},
	runWithoutInvalidation: function(callback) {
		var oldIgnoreValidation = this._ignoreInvalidationFlags;
		this._ignoreInvalidationFlags = true;
		callback();
		this._ignoreInvalidationFlags = oldIgnoreValidation;
	},
	runWithInvalidationFlagsOnly: function(callback) {
		var oldValue = this._setInvalidationFlagsOnly;
		this._setInvalidationFlagsOnly = true;
		callback();
		this._setInvalidationFlagsOnly = oldValue;
	},
	setInvalid: function(flag) {
		if(this._ignoreInvalidationFlags) {
			return;
		}
		if(this._setInvalidationFlagsOnly) {
			if(flag == null) {
				this._allInvalid = true;
			} else {
				this.setInvalidationFlag(flag);
			}
			return;
		}
		var alreadyInvalid = this.isInvalid();
		var alreadyDelayedInvalid = false;
		if(this._validating) {
			var otherFlag = this._delayedInvalidationFlags.keys();
			while(otherFlag.hasNext()) {
				var otherFlag1 = otherFlag.next();
				alreadyDelayedInvalid = true;
				break;
			}
		}
		if(flag == null) {
			if(this._validating) {
				this._allInvalidDelayed = true;
			} else {
				this._allInvalid = true;
			}
		} else if(this._validating) {
			this._delayedInvalidationFlags.set(flag,true);
		} else if(flag != null && !this._invalidationFlags.exists(flag)) {
			this._invalidationFlags.set(flag,true);
		}
		if(this._validationQueue == null) {
			return;
		}
		if(this._validating) {
			if(alreadyDelayedInvalid) {
				return;
			}
			this._setInvalidCount++;
			if(this._setInvalidCount >= 10) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())((Type().default).getClassName((Type().default).getClass(this)) + " returned to validation queue too many times during validation. This may be an infinite loop. Try to avoid doing anything that calls setInvalid() during validation."));
			}
			this._validationQueue.addControl(this);
			return;
		}
		if(alreadyInvalid) {
			return;
		}
		this._setInvalidCount = 0;
		this._validationQueue.addControl(this);
	},
	validateNow: function() {
		if(!this.isInvalid()) {
			return;
		}
		if(this._validating) {
			return;
		}
		this._validating = true;
		this.update();
		var flag = this._invalidationFlags.keys();
		while(flag.hasNext()) {
			var flag1 = flag.next();
			this._invalidationFlags.remove(flag1);
		}
		this._allInvalid = this._allInvalidDelayed;
		var flag2 = this._delayedInvalidationFlags.keys();
		while(flag2.hasNext()) {
			var flag3 = flag2.next();
			if(flag3 == null) {
				this._allInvalid = true;
			} else {
				this._invalidationFlags.set(flag3,true);
			}
			this._delayedInvalidationFlags.remove(flag3);
		}
		this._validating = false;
	},
	setInvalidationFlag: function(flag) {
		if(this._ignoreInvalidationFlags) {
			return;
		}
		if(this._invalidationFlags.exists(flag)) {
			return;
		}
		this._invalidationFlags.set(flag,true);
	},
	update: function() {
	},
	validatingSprite_addedToStageHandler: function(event) {
		this._depth = (feathers_utils_DisplayUtil().default).getDisplayObjectDepthFromStage(this);
		this._validationQueue = (feathers_core_ValidationQueue().default).forStage(this.stage);
		if(this._validationQueue != null && this.isInvalid()) {
			this._setInvalidCount = 0;
			this._validationQueue.addControl(this);
		}
	},
	validatingSprite_removedFromStageHandler: function(event) {
		this._depth = -1;
		this._validationQueue = null;
	}
});
ValidatingSprite.prototype.__class__ = ValidatingSprite.prototype.constructor = $hxClasses["feathers.core.ValidatingSprite"] = ValidatingSprite;

// Init



// Statics




// Export

exports["default"] = ValidatingSprite;

/***/ }),

/***/ "./lib/_gen/feathers/core/ValidationQueue.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/core/ValidationQueue.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core.ValidationQueue

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function haxe_ds_ObjectMap() {return __webpack_require__(/*! ./../../haxe/ds/ObjectMap */ "./lib/_gen/haxe/ds/ObjectMap.js");}

// Constructor

var ValidationQueue = function(stage) {
	this._validating = false;
	this._queue = [];
	this._stage = null;
	this._stage = stage;
	this._stage.addEventListener("render",$bind(this,this.validationQueue_stage_renderHandler),false,-1000,true);
}

// Meta

ValidationQueue.__name__ = "feathers.core.ValidationQueue";
ValidationQueue.__isInterface__ = false;
ValidationQueue.prototype = {
	get_validating: function() {
		return this._validating;
	},
	dispose: function() {
		if(this._stage == null) {
			return;
		}
		this._stage.removeEventListener("render",$bind(this,this.validationQueue_stage_renderHandler));
		this._stage = null;
	},
	addControl: function(control) {
		if(this._queue.indexOf(control) != -1) {
			return;
		}
		var queueLength = this._queue.length;
		if(this._validating) {
			var depth = control.get_depth();
			var i = queueLength - 1;
			while(i >= 0) {
				var otherControl = this._queue[i];
				var otherDepth = otherControl.get_depth();
				if(depth >= otherDepth) {
					break;
				}
				--i;
			}
			++i;
			this._queue.splice(i,0,control);
		} else {
			this._queue[queueLength] = control;
			this._stage.invalidate();
		}
	},
	validateNow: function() {
		if(this._validating) {
			return;
		}
		var queueLength = this._queue.length;
		if(queueLength == 0) {
			return;
		}
		this._validating = true;
		if(queueLength > 1) {
			this._queue.sort(function(first,second) {
				var difference = second.get_depth() - first.get_depth();
				if(difference > 0) {
					return -1;
				} else if(difference < 0) {
					return 1;
				}
				return 0;
			});
		}
		while(this._queue.length > 0) {
			var item = this._queue.shift();
			if(item.get_depth() < 0) {
				continue;
			}
			item.validateNow();
		}
		this._validating = false;
	},
	validationQueue_stage_renderHandler: function(event) {
		this.validateNow();
	}
};
ValidationQueue.prototype.__class__ = ValidationQueue.prototype.constructor = $hxClasses["feathers.core.ValidationQueue"] = ValidationQueue;

// Init



// Statics

ValidationQueue.forStage = function(stage) {
	if(stage == null) {
		return null;
	}
	if(!ValidationQueue.STAGE_TO_VALIDATION_QUEUE.exists(stage)) {
		ValidationQueue.STAGE_TO_VALIDATION_QUEUE.set(stage,new ValidationQueue(stage));
	}
	return ValidationQueue.STAGE_TO_VALIDATION_QUEUE.get(stage);
}
ValidationQueue.STAGE_TO_VALIDATION_QUEUE = new (haxe_ds_ObjectMap().default)()

// Export

exports["default"] = ValidationQueue;

/***/ }),

/***/ "./lib/_gen/feathers/core/_DefaultFocusManager/FocusResult.js":
/*!********************************************************************!*\
  !*** ./lib/_gen/feathers/core/_DefaultFocusManager/FocusResult.js ***!
  \********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.core._DefaultFocusManager.FocusResult

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var FocusResult = function(newFocus,wrapped) {
	this.newFocus = newFocus;
	this.wrapped = wrapped;
}

// Meta

FocusResult.__name__ = "feathers.core._DefaultFocusManager.FocusResult";
FocusResult.__isInterface__ = false;
FocusResult.prototype = {
	
};
FocusResult.prototype.__class__ = FocusResult.prototype.constructor = $hxClasses["feathers.core._DefaultFocusManager.FocusResult"] = FocusResult;

// Init



// Statics




// Export

exports["default"] = FocusResult;

/***/ }),

/***/ "./lib/_gen/feathers/core/_FeathersControl/StyleDefinition.js":
/*!********************************************************************!*\
  !*** ./lib/_gen/feathers/core/_FeathersControl/StyleDefinition.js ***!
  \********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.core._FeathersControl.StyleDefinition

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var StyleDefinition = $hxEnums["feathers.core._FeathersControl.StyleDefinition"] = { __ename__ : "feathers.core._FeathersControl.StyleDefinition", __constructs__ : ["Name","NameAndState"]
  ,NameAndState: ($_=function(name,state) { return {_hx_index:1,name:name,state:state,__enum__:"feathers.core._FeathersControl.StyleDefinition",toString:$estr}; },$_.__params__ = ["name","state"],$_)
  ,Name: ($_=function(name) { return {_hx_index:0,name:name,__enum__:"feathers.core._FeathersControl.StyleDefinition",toString:$estr}; },$_.__params__ = ["name"],$_)
};

exports["default"] = StyleDefinition;

/***/ }),

/***/ "./lib/_gen/feathers/data/ArrayCollection.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/data/ArrayCollection.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.data.ArrayCollection

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_utils_IExternalizable() {return (__webpack_require__(/*! openfl */ "openfl").utils.IExternalizable);}
function feathers_data_IFlatCollection() {return __webpack_require__(/*! ./../../feathers/data/IFlatCollection */ "./lib/_gen/feathers/data/IFlatCollection.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FlatCollectionEvent() {return __webpack_require__(/*! ./../../feathers/events/FlatCollectionEvent */ "./lib/_gen/feathers/events/FlatCollectionEvent.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_RangeError() {return (__webpack_require__(/*! openfl */ "openfl").errors.RangeError);}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}

// Constructor

var ArrayCollection = function(array) {
	this._sortCompareFunction = null;
	this._filterFunction = null;
	this._pendingRefresh = false;
	this._array = null;
	this._filterAndSortData = null;
	(openfl_events_EventDispatcher()).call(this);
	if(array == null) {
		array = [];
	}
	this.set_array(array);
}

// Meta

ArrayCollection.__name__ = "feathers.data.ArrayCollection";
ArrayCollection.__isInterface__ = false;
ArrayCollection.__interfaces__ = [(openfl_utils_IExternalizable()),(feathers_data_IFlatCollection().default)];
ArrayCollection.__super__ = (openfl_events_EventDispatcher());
ArrayCollection.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_array: function() {
		return this._array;
	},
	set_array: function(value) {
		if(this._array == value) {
			return this._array;
		}
		if(value == null) {
			value = [];
		}
		this._array = value;
		(feathers_events_FlatCollectionEvent().default).dispatch(this,"reset",-1);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._array;
	},
	get_length: function() {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(this._filterAndSortData != null) {
			return this._filterAndSortData.length;
		}
		return this._array.length;
	},
	get_filterFunction: function() {
		return this._filterFunction;
	},
	set_filterFunction: function(value) {
		if(this._filterFunction == value) {
			return this._filterFunction;
		}
		this._filterFunction = value;
		this._pendingRefresh = true;
		(feathers_events_FlatCollectionEvent().default).dispatch(this,"filterChange",-1);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._filterFunction;
	},
	get_sortCompareFunction: function() {
		return this._sortCompareFunction;
	},
	set_sortCompareFunction: function(value) {
		if(this._sortCompareFunction == value) {
			return this._sortCompareFunction;
		}
		this._sortCompareFunction = value;
		this._pendingRefresh = true;
		(feathers_events_FlatCollectionEvent().default).dispatch(this,"sortChange",-1);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._sortCompareFunction;
	},
	get: function(index) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(index < 0 || index >= this.get_length()) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Failed to get item at index " + index + ". Expected a value between 0 and " + (this.get_length() - 1) + "."));
		}
		if(this._filterAndSortData != null) {
			return this._filterAndSortData[index];
		}
		return this._array[index];
	},
	set: function(index,item) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(index < 0 || index > this.get_length()) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Failed to set item at index " + index + ". Expected a value between 0 and " + this.get_length() + "."));
		}
		if(this._filterAndSortData != null) {
			var unfilteredIndex = this._array.length;
			var oldItem = null;
			if(index < this._filterAndSortData.length) {
				oldItem = this._filterAndSortData[index];
				unfilteredIndex = this._array.indexOf(oldItem);
			}
			this._array[unfilteredIndex] = item;
			if(this._filterFunction != null) {
				var includeItem = this._filterFunction(item);
				if(index < this._filterAndSortData.length) {
					if(includeItem) {
						this._filterAndSortData[index] = item;
						(feathers_events_FlatCollectionEvent().default).dispatch(this,"replaceItem",index,item,oldItem);
						(feathers_events_FeathersEvent().default).dispatch(this,"change");
					} else {
						this._filterAndSortData.splice(index,1);
						(feathers_events_FlatCollectionEvent().default).dispatch(this,"removeItem",index,null,oldItem);
						(feathers_events_FeathersEvent().default).dispatch(this,"change");
					}
				} else if(includeItem) {
					this._filterAndSortData[this._filterAndSortData.length] = item;
					(feathers_events_FlatCollectionEvent().default).dispatch(this,"addItem",index,item);
					(feathers_events_FeathersEvent().default).dispatch(this,"change");
				}
				return;
			} else if(this._sortCompareFunction != null) {
				(HxOverrides().default).remove(this._filterAndSortData,oldItem);
				var sortedIndex = this.getSortedInsertionIndex(item);
				this._filterAndSortData[sortedIndex] = item;
				(feathers_events_FlatCollectionEvent().default).dispatch(this,"replaceItem",index,item,oldItem);
				(feathers_events_FeathersEvent().default).dispatch(this,"change");
				return;
			}
		}
		if(index < this._array.length) {
			var oldItem1 = this._array[index];
			this._array[index] = item;
			(feathers_events_FlatCollectionEvent().default).dispatch(this,"replaceItem",index,item,oldItem1);
		} else {
			this._array[index] = item;
			(feathers_events_FlatCollectionEvent().default).dispatch(this,"addItem",index,item);
		}
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
	},
	add: function(item) {
		this.addAtInternal(item,this.get_length(),true);
	},
	addAt: function(item,index) {
		this.addAtInternal(item,index,true);
	},
	addAll: function(collection) {
		var item = collection.iterator();
		while(item.hasNext()) {
			var item1 = item.next();
			this.add(item1);
		}
	},
	addAllAt: function(collection,index) {
		if(index < 0 || index > this.get_length()) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Failed to add collection at index " + index + ". Expected a value between 0 and " + this.get_length() + "."));
		}
		var item = collection.iterator();
		while(item.hasNext()) {
			var item1 = item.next();
			this.addAt(item1,index);
			++index;
		}
	},
	reset: function(collection) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(this._filterAndSortData != null) {
			this._filterAndSortData.length = 0;
		}
		this._array.length = 0;
		if(collection != null) {
			var item = collection.iterator();
			while(item.hasNext()) {
				var item1 = item.next();
				this.addAtInternal(item1,this.get_length(),false);
			}
		}
		(feathers_events_FlatCollectionEvent().default).dispatch(this,"reset",-1);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
	},
	remove: function(item) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		var index = this.indexOf(item);
		if(index == -1) {
			return;
		}
		if(this._filterAndSortData != null) {
			(HxOverrides().default).remove(this._filterAndSortData,item);
		}
		(HxOverrides().default).remove(this._array,item);
		(feathers_events_FlatCollectionEvent().default).dispatch(this,"removeItem",index,null,item);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
	},
	removeAt: function(index) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(index < 0 || index >= this.get_length()) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Failed to remove item at index " + index + ". Expected a value between 0 and " + (this.get_length() - 1) + "."));
		}
		var item = null;
		if(this._filterAndSortData != null) {
			item = this._filterAndSortData[index];
			(HxOverrides().default).remove(this._filterAndSortData,item);
			(HxOverrides().default).remove(this._array,item);
		} else {
			item = this._array[index];
			(HxOverrides().default).remove(this._array,item);
		}
		(feathers_events_FlatCollectionEvent().default).dispatch(this,"removeItem",index,null,item);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return item;
	},
	removeAll: function() {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(this._array.length == 0) {
			return;
		}
		if(this._filterAndSortData != null) {
			this._filterAndSortData.length = 0;
		}
		this._array.length = 0;
		(feathers_events_FlatCollectionEvent().default).dispatch(this,"removeAll",-1);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
	},
	indexOf: function(item) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(this._filterAndSortData != null) {
			return this._filterAndSortData.indexOf(item);
		}
		return this._array.indexOf(item);
	},
	contains: function(item) {
		return this.indexOf(item) != -1;
	},
	iterator: function() {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(this._filterAndSortData != null) {
			return (HxOverrides().default).iter(this._filterAndSortData);
		}
		return (HxOverrides().default).iter(this._array);
	},
	updateAt: function(index) {
		if(index < 0 || index >= this.get_length()) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Failed to update item at index " + index + ". Expected a value between 0 and " + (this.get_length() - 1) + "."));
		}
		(feathers_events_FlatCollectionEvent().default).dispatch(this,"updateItem",index);
		this.refresh();
	},
	updateAll: function() {
		(feathers_events_FlatCollectionEvent().default).dispatch(this,"updateAll",-1);
		this.refresh();
	},
	refresh: function() {
		if(this._filterFunction == null && this._sortCompareFunction == null) {
			return;
		}
		this._pendingRefresh = true;
		if(this._filterFunction != null) {
			(feathers_events_FlatCollectionEvent().default).dispatch(this,"filterChange",-1);
		}
		if(this._sortCompareFunction != null) {
			(feathers_events_FlatCollectionEvent().default).dispatch(this,"sortChange",-1);
		}
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
	},
	find: function(callback) {
		var _g = 0;
		var _g1 = this.get_length();
		while(_g < _g1) {
			var i = _g++;
			var item = this.get(i);
			var result = callback(item,i,this);
			if(result) {
				return item;
			}
		}
		return null;
	},
	findIndex: function(callback) {
		var _g = 0;
		var _g1 = this.get_length();
		while(_g < _g1) {
			var i = _g++;
			var item = this.get(i);
			var result = callback(item,i,this);
			if(result) {
				return i;
			}
		}
		return -1;
	},
	some: function(callback) {
		var _g = 0;
		var _g1 = this.get_length();
		while(_g < _g1) {
			var i = _g++;
			var item = this.get(i);
			var result = callback(item,i,this);
			if(result) {
				return true;
			}
		}
		return false;
	},
	every: function(callback) {
		var _g = 0;
		var _g1 = this.get_length();
		while(_g < _g1) {
			var i = _g++;
			var item = this.get(i);
			var result = callback(item,i,this);
			if(!result) {
				return false;
			}
		}
		return true;
	},
	forEach: function(callback) {
		var _g = 0;
		var _g1 = this.get_length();
		while(_g < _g1) {
			var i = _g++;
			var item = this.get(i);
			callback(item,i,this);
		}
	},
	map: function(callback) {
		var result = [];
		var _g = 0;
		var _g1 = this.get_length();
		while(_g < _g1) {
			var i = _g++;
			var item = this.get(i);
			result.push(callback(item,i,this));
		}
		return new ArrayCollection(result);
	},
	readExternal: function(input) {
		this.set_array((Std().default).downcast(input.readObject(),Array));
	},
	writeExternal: function(output) {
		output.writeObject(this.get_array());
	},
	refreshFilterAndSort: function() {
		this._pendingRefresh = false;
		var oldFilterAndSortData = this._filterAndSortData;
		this._filterAndSortData = null;
		if(this._filterFunction != null) {
			var result = oldFilterAndSortData;
			if(result != null) {
				result.length = 0;
			} else {
				result = [];
			}
			var _g = 0;
			var _g1 = this._array.length;
			while(_g < _g1) {
				var i = _g++;
				var item = this._array[i];
				if(this._filterFunction(item)) {
					result.push(item);
				}
			}
			this._filterAndSortData = result;
		} else if(this._sortCompareFunction != null) {
			var result1 = oldFilterAndSortData;
			if(result1 != null) {
				result1.length = this._array.length;
				var _g2 = 0;
				var _g11 = this._array.length;
				while(_g2 < _g11) {
					var i1 = _g2++;
					result1[i1] = this._array[i1];
				}
			} else {
				result1 = this._array.slice(0);
			}
			this._filterAndSortData = result1;
		}
		if(this._sortCompareFunction != null) {
			this._filterAndSortData.sort(this._sortCompareFunction);
		}
	},
	toArray: function() {
		if(this._filterAndSortData != null) {
			return this._filterAndSortData.slice();
		}
		return this._array.slice();
	},
	getSortedInsertionIndex: function(item) {
		if(this._sortCompareFunction == null) {
			return this._filterAndSortData.length;
		}
		var _g = 0;
		var _g1 = this._filterAndSortData.length;
		while(_g < _g1) {
			var i = _g++;
			var otherItem = this._filterAndSortData[i];
			var result = this._sortCompareFunction(item,otherItem);
			if(result < 1) {
				return i;
			}
		}
		return this._filterAndSortData.length;
	},
	addAtInternal: function(item,index,dispatchEvents) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(index < 0 || index > this.get_length()) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Failed to add item at index " + index + ". Expected a value between 0 and " + this.get_length() + "."));
		}
		if(this._filterAndSortData != null) {
			var unfilteredIndex = this._array.length;
			if(index < this._filterAndSortData.length) {
				var oldItem = this._filterAndSortData[index];
				unfilteredIndex = this._array.indexOf(oldItem);
			}
			this._array.splice(unfilteredIndex,0,item);
			var includeItem = true;
			if(this._filterFunction != null) {
				includeItem = this._filterFunction(item);
			}
			if(includeItem) {
				var sortedIndex = index;
				if(this._sortCompareFunction != null) {
					sortedIndex = this.getSortedInsertionIndex(item);
				}
				this._filterAndSortData.splice(sortedIndex,0,item);
				if(dispatchEvents) {
					(feathers_events_FlatCollectionEvent().default).dispatch(this,"addItem",index,item);
					(feathers_events_FeathersEvent().default).dispatch(this,"change");
				}
			}
		} else {
			this._array.splice(index,0,item);
			if(dispatchEvents) {
				(feathers_events_FlatCollectionEvent().default).dispatch(this,"addItem",index,item);
				(feathers_events_FeathersEvent().default).dispatch(this,"change");
			}
		}
	}
});
ArrayCollection.prototype.__class__ = ArrayCollection.prototype.constructor = $hxClasses["feathers.data.ArrayCollection"] = ArrayCollection;

// Init



// Statics


ArrayCollection.__meta__ = { obj : { defaultXmlProperty : ["array"]}}

// Export

exports["default"] = ArrayCollection;

/***/ }),

/***/ "./lib/_gen/feathers/data/ArrayHierarchicalCollection.js":
/*!***************************************************************!*\
  !*** ./lib/_gen/feathers/data/ArrayHierarchicalCollection.js ***!
  \***************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.data.ArrayHierarchicalCollection

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_utils_IExternalizable() {return (__webpack_require__(/*! openfl */ "openfl").utils.IExternalizable);}
function feathers_data_IHierarchicalCollection() {return __webpack_require__(/*! ./../../feathers/data/IHierarchicalCollection */ "./lib/_gen/feathers/data/IHierarchicalCollection.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_HierarchicalCollectionEvent() {return __webpack_require__(/*! ./../../feathers/events/HierarchicalCollectionEvent */ "./lib/_gen/feathers/events/HierarchicalCollectionEvent.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_RangeError() {return (__webpack_require__(/*! openfl */ "openfl").errors.RangeError);}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function feathers_data__$ArrayHierarchicalCollection_FilterAndSortItem() {return __webpack_require__(/*! ./../../feathers/data/_ArrayHierarchicalCollection/FilterAndSortItem */ "./lib/_gen/feathers/data/_ArrayHierarchicalCollection/FilterAndSortItem.js");}

// Constructor

var ArrayHierarchicalCollection = function(array,itemToChildren) {
	this._sortCompareFunction = null;
	this._filterFunction = null;
	this._pendingRefresh = false;
	this._array = null;
	this._filterAndSortData = null;
	(openfl_events_EventDispatcher()).call(this);
	if(array == null) {
		array = [];
	}
	this.set_array(array);
	this.set_itemToChildren(itemToChildren);
}

// Meta

ArrayHierarchicalCollection.__name__ = "feathers.data.ArrayHierarchicalCollection";
ArrayHierarchicalCollection.__isInterface__ = false;
ArrayHierarchicalCollection.__interfaces__ = [(openfl_utils_IExternalizable()),(feathers_data_IHierarchicalCollection().default)];
ArrayHierarchicalCollection.__super__ = (openfl_events_EventDispatcher());
ArrayHierarchicalCollection.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_array: function() {
		return this._array;
	},
	set_array: function(value) {
		if(this._array == value) {
			return this._array;
		}
		if(value == null) {
			value = [];
		}
		this._array = value;
		(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"reset",null);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._array;
	},
	get_itemToChildren: function() {
		return this._itemToChildren;
	},
	set_itemToChildren: function(value) {
		if(this._itemToChildren == value) {
			return this._itemToChildren;
		}
		this._itemToChildren = value;
		(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"reset",null);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._itemToChildren;
	},
	get_filterFunction: function() {
		return this._filterFunction;
	},
	set_filterFunction: function(value) {
		if(this._filterFunction == value) {
			return this._filterFunction;
		}
		this._filterFunction = value;
		this._pendingRefresh = true;
		(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"filterChange",null);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._filterFunction;
	},
	get_sortCompareFunction: function() {
		return this._sortCompareFunction;
	},
	set_sortCompareFunction: function(value) {
		if(this._sortCompareFunction == value) {
			return this._sortCompareFunction;
		}
		this._sortCompareFunction = value;
		this._pendingRefresh = true;
		(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"sortChange",null);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._sortCompareFunction;
	},
	getLength: function(location) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		var branchChildren = this._array;
		var itemToChildren = this._itemToChildren;
		if(this._filterAndSortData != null) {
			branchChildren = this._filterAndSortData;
			itemToChildren = $bind(this,this.filterAndSortDataItemToChildren);
		}
		if(location != null && location.length > 0) {
			var _g = 0;
			var _g1 = location.length;
			while(_g < _g1) {
				var i = _g++;
				var index = location[i];
				if(index < 0 || index >= branchChildren.length) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Branch not found at location: " + (Std().default).string(location)));
				}
				var child = branchChildren[index];
				branchChildren = itemToChildren != null ? itemToChildren(child) : null;
				if(branchChildren == null) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Branch not found at location: " + (Std().default).string(location)));
				}
			}
		}
		return branchChildren.length;
	},
	get: function(location) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(location == null || location.length == 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item not found at location: " + (Std().default).string(location)));
		}
		if(this._filterAndSortData != null) {
			var branchChildren = this.findBranchChildren(this._filterAndSortData,$bind(this,this.filterAndSortDataItemToChildren),location);
			var index = location[location.length - 1];
			if(index < 0 || index >= branchChildren.length) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item not found at location: " + (Std().default).string(location)));
			}
			return branchChildren[index].item;
		}
		var branchChildren1 = this.findBranchChildren(this._array,this._itemToChildren,location);
		var index1 = location[location.length - 1];
		if(index1 < 0 || index1 >= branchChildren1.length) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item not found at location: " + (Std().default).string(location)));
		}
		return branchChildren1[index1];
	},
	set: function(location,value) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(location == null || location.length == 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item not found at location: " + (Std().default).string(location)));
		}
		if(this._filterAndSortData != null) {
			var lastLocationIndex = location[location.length - 1];
			var branchChildren = this.findBranchChildren(this._array,this._itemToChildren,location);
			var filteredOrSortedBranchChildren = this.findBranchChildren(this._filterAndSortData,$bind(this,this.filterAndSortDataItemToChildren),location);
			var oldItem = null;
			var unfilteredLastLocationIndex = branchChildren.length;
			if(lastLocationIndex < filteredOrSortedBranchChildren.length) {
				oldItem = filteredOrSortedBranchChildren[lastLocationIndex].item;
				unfilteredLastLocationIndex = branchChildren.indexOf(oldItem);
			}
			branchChildren[unfilteredLastLocationIndex] = value;
			if(this._filterFunction != null) {
				var includeItem = this._filterFunction(value);
				if(lastLocationIndex < filteredOrSortedBranchChildren.length) {
					if(includeItem) {
						filteredOrSortedBranchChildren[lastLocationIndex] = this.createFilterAndSortItem(value);
						(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"replaceItem",location,value,oldItem);
						(feathers_events_FeathersEvent().default).dispatch(this,"change");
					} else {
						filteredOrSortedBranchChildren.splice(lastLocationIndex,1);
						(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"removeItem",location,null,oldItem);
						(feathers_events_FeathersEvent().default).dispatch(this,"change");
					}
				} else if(includeItem) {
					filteredOrSortedBranchChildren[filteredOrSortedBranchChildren.length] = this.createFilterAndSortItem(value);
					(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"addItem",location,value);
					(feathers_events_FeathersEvent().default).dispatch(this,"change");
				}
			} else if(this._sortCompareFunction != null) {
				filteredOrSortedBranchChildren.splice(lastLocationIndex,1);
				var wrappedItem = this.createFilterAndSortItem(value);
				var sortedIndex = this.getSortedInsertionIndex(filteredOrSortedBranchChildren,wrappedItem);
				filteredOrSortedBranchChildren[sortedIndex] = wrappedItem;
				(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"replaceItem",location,value,oldItem);
				(feathers_events_FeathersEvent().default).dispatch(this,"change");
				return;
			}
			return;
		}
		var branchChildren1 = this.findBranchChildren(this._array,this._itemToChildren,location);
		var index = location[location.length - 1];
		if(index < 0 || index > branchChildren1.length) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item not found at location: " + (Std().default).string(location)));
		}
		var oldValue = branchChildren1[index];
		branchChildren1[index] = value;
		(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"replaceItem",location,value,oldValue);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
	},
	isBranch: function(item) {
		if(item == null) {
			return false;
		}
		var children = this._itemToChildren != null ? this._itemToChildren(item) : null;
		return children != null;
	},
	locationOf: function(item) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		var result = [];
		var found = false;
		if(this._filterAndSortData != null) {
			found = this.findItemInFilteredOrSortedBranch(this._filterAndSortData,item,result);
		} else {
			found = this.findItemInBranch(this._array,item,result);
		}
		if(!found) {
			return null;
		}
		return result;
	},
	contains: function(item) {
		return this.locationOf(item) != null;
	},
	addAt: function(itemToAdd,location) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(location == null || location.length == 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item cannot be added at location: " + (Std().default).string(location)));
		}
		if(this._filterAndSortData != null) {
			var lastLocationIndex = location[location.length - 1];
			var branchChildren = this.findBranchChildren(this._array,this._itemToChildren,location);
			var filteredOrSortedBranchChildren = this.findBranchChildren(this._filterAndSortData,$bind(this,this.filterAndSortDataItemToChildren),location);
			var oldItem = null;
			var unfilteredLastLocationIndex = branchChildren.length;
			if(lastLocationIndex < filteredOrSortedBranchChildren.length) {
				oldItem = filteredOrSortedBranchChildren[lastLocationIndex].item;
				unfilteredLastLocationIndex = branchChildren.indexOf(oldItem);
			}
			branchChildren.splice(unfilteredLastLocationIndex,0,itemToAdd);
			var includeItem = true;
			if(this._filterFunction != null) {
				includeItem = this._filterFunction(itemToAdd);
			}
			if(includeItem) {
				var sortedIndex = lastLocationIndex;
				var wrappedItem = this.createFilterAndSortItem(itemToAdd);
				if(this._sortCompareFunction != null) {
					sortedIndex = this.getSortedInsertionIndex(filteredOrSortedBranchChildren,wrappedItem);
				}
				filteredOrSortedBranchChildren.splice(sortedIndex,0,wrappedItem);
				(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"addItem",location,itemToAdd);
				(feathers_events_FeathersEvent().default).dispatch(this,"change");
			}
			return;
		}
		var branchChildren1 = this.findBranchChildren(this._array,this._itemToChildren,location);
		var index = location[location.length - 1];
		if(index < 0 || index > branchChildren1.length) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item cannot be added at location: " + (Std().default).string(location)));
		}
		branchChildren1.splice(index,0,itemToAdd);
		(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"addItem",location,itemToAdd);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
	},
	removeAt: function(location) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(location == null || location.length == 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item not found at location: " + (Std().default).string(location)));
		}
		if(this._filterAndSortData != null) {
			var lastLocationIndex = location[location.length - 1];
			var branchChildren = this.findBranchChildren(this._array,this._itemToChildren,location);
			var filteredOrSortedBranchChildren = this.findBranchChildren(this._filterAndSortData,$bind(this,this.filterAndSortDataItemToChildren),location);
			var removedItem = filteredOrSortedBranchChildren.splice(lastLocationIndex,1)[0].item;
			(HxOverrides().default).remove(branchChildren,removedItem);
			(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"removeItem",location,null,removedItem);
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
			return removedItem;
		}
		var branchChildren1 = this.findBranchChildren(this._array,this._itemToChildren,location);
		var index = location[location.length - 1];
		if(index < 0 || index >= branchChildren1.length) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item not found at location: " + (Std().default).string(location)));
		}
		var removedItem1 = branchChildren1[index];
		(HxOverrides().default).remove(branchChildren1,removedItem1);
		(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"removeItem",location,null,removedItem1);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return removedItem1;
	},
	remove: function(item) {
		var location = this.locationOf(item);
		if(location == null) {
			return;
		}
		this.removeAt(location);
	},
	removeAll: function(location) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(this._array.length == 0) {
			return;
		}
		if(location == null || location.length == 0) {
			if(this._filterAndSortData != null) {
				this._filterAndSortData.length = 0;
			}
			this._array.length = 0;
			(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"removeAll",null);
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
			return;
		}
		if(this._filterAndSortData != null) {
			var firstChildLocation = location.slice();
			firstChildLocation.push(0);
			var branchChildren = this.findBranchChildren(this._array,this._itemToChildren,firstChildLocation);
			var filteredOrSortedBranchChildren = this.findBranchChildren(this._filterAndSortData,$bind(this,this.filterAndSortDataItemToChildren),firstChildLocation);
			filteredOrSortedBranchChildren.length = 0;
			branchChildren.length = 0;
			(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"removeAll",location);
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
			return;
		}
		var firstChildLocation1 = location.slice();
		firstChildLocation1.push(0);
		var branchChildren1 = this.findBranchChildren(this._array,this._itemToChildren,firstChildLocation1);
		branchChildren1.length = 0;
		(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"removeAll",location);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
	},
	updateAt: function(location) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(location == null || location.length == 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item not found at location: " + (Std().default).string(location)));
		}
		var branchChildren = this._filterAndSortData != null ? this.findBranchChildren(this._filterAndSortData,$bind(this,this.filterAndSortDataItemToChildren),location) : this.findBranchChildren(this._array,this._itemToChildren,location);
		var index = location[location.length - 1];
		if(index < 0 || index >= branchChildren.length) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Failed to update item at index " + index + ". Expected a value between 0 and " + (branchChildren.length - 1) + " at index " + (location.length - 1) + "."));
		}
		(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"updateItem",location);
		this.refresh();
	},
	updateAll: function() {
		(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"updateAll",null);
		this.refresh();
	},
	refresh: function() {
		if(this._filterFunction == null && this._sortCompareFunction == null) {
			return;
		}
		this._pendingRefresh = true;
		if(this._filterFunction != null) {
			(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"filterChange",null);
		}
		if(this._sortCompareFunction != null) {
			(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"sortChange",null);
		}
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
	},
	readExternal: function(input) {
		this.set_array((Std().default).downcast(input.readObject(),Array));
	},
	writeExternal: function(output) {
		output.writeObject(this.get_array());
	},
	findItemInBranch: function(branchChildren,itemToFind,result) {
		var _g = 0;
		var _g1 = branchChildren.length;
		while(_g < _g1) {
			var i = _g++;
			var item = branchChildren[i];
			if(item == itemToFind) {
				result.push(i);
				return true;
			}
			if(!this.isBranch(item)) {
				continue;
			}
			var itemChildren = this._itemToChildren != null ? this._itemToChildren(item) : null;
			if(itemChildren != null) {
				result.push(i);
				var found = this.findItemInBranch(itemChildren,itemToFind,result);
				if(found) {
					return true;
				}
				result.pop();
			}
		}
		return false;
	},
	findItemInFilteredOrSortedBranch: function(branchChildren,itemToFind,result) {
		var _g = 0;
		var _g1 = branchChildren.length;
		while(_g < _g1) {
			var i = _g++;
			var item = branchChildren[i];
			if(item.item == itemToFind) {
				result.push(i);
				return true;
			}
			var itemChildren = this.filterAndSortDataItemToChildren(item);
			if(itemChildren != null) {
				result.push(i);
				var found = this.findItemInFilteredOrSortedBranch(itemChildren,itemToFind,result);
				if(found) {
					return true;
				}
				result.pop();
			}
		}
		return false;
	},
	refreshFilterAndSort: function() {
		this._pendingRefresh = false;
		var oldFilterAndSortData = this._filterAndSortData;
		this._filterAndSortData = null;
		if(this._filterFunction != null || this._sortCompareFunction != null) {
			var result = oldFilterAndSortData;
			if(result != null) {
				result.length = 0;
			} else {
				result = [];
			}
			this.refreshFilterAndSortInternal(this._array,result);
			this._filterAndSortData = result;
		}
		if(this._sortCompareFunction != null) {
			this.refreshSort(this._filterAndSortData);
		}
	},
	getSortedInsertionIndex: function(branchChildren,item) {
		if(this._sortCompareFunction == null) {
			return branchChildren.length;
		}
		var _g = 0;
		var _g1 = branchChildren.length;
		while(_g < _g1) {
			var i = _g++;
			var otherItem = branchChildren[i];
			var result = this.sortCompareFunctionInternal(item,otherItem);
			if(result < 1) {
				return i;
			}
		}
		return branchChildren.length;
	},
	refreshSort: function(array) {
		array.sort($bind(this,this.sortCompareFunctionInternal));
		var _g = 0;
		while(_g < array.length) {
			var item = array[_g];
			++_g;
			if(item.children == null) {
				continue;
			}
			this.refreshSort(item.children);
		}
	},
	refreshFilterAndSortInternal: function(items,result) {
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var item = items[i];
			var filterAndSortItem = this.createFilterAndSortItem(item);
			if(filterAndSortItem != null) {
				result.push(filterAndSortItem);
			}
		}
	},
	createFilterAndSortItem: function(item) {
		var result = null;
		if(this._filterFunction == null || this._filterFunction(item)) {
			result = new (feathers_data__$ArrayHierarchicalCollection_FilterAndSortItem().default)(item);
		}
		if(result != null) {
			var children = this._itemToChildren != null ? this._itemToChildren(item) : null;
			if(children != null) {
				result.children = [];
				this.refreshFilterAndSortInternal(children,result.children);
			}
		}
		return result;
	},
	findBranchChildren: function(source,itemToChildren,location) {
		var branchChildren = source;
		var _g = 0;
		var _g1 = location.length - 1;
		while(_g < _g1) {
			var i = _g++;
			var index = location[i];
			if(index < 0 || index >= branchChildren.length) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item not found at location: " + (Std().default).string(location)));
			}
			var child = branchChildren[index];
			branchChildren = itemToChildren != null ? itemToChildren(child) : null;
			if(branchChildren == null) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item not found at location: " + (Std().default).string(location)));
			}
		}
		return branchChildren;
	},
	filterAndSortDataItemToChildren: function(item) {
		return item.children;
	},
	sortCompareFunctionInternal: function(item1,item2) {
		return this._sortCompareFunction(item1.item,item2.item);
	}
});
ArrayHierarchicalCollection.prototype.__class__ = ArrayHierarchicalCollection.prototype.constructor = $hxClasses["feathers.data.ArrayHierarchicalCollection"] = ArrayHierarchicalCollection;

// Init



// Statics


ArrayHierarchicalCollection.__meta__ = { obj : { defaultXmlProperty : ["array"]}}

// Export

exports["default"] = ArrayHierarchicalCollection;

/***/ }),

/***/ "./lib/_gen/feathers/data/ButtonBarItemState.js":
/*!******************************************************!*\
  !*** ./lib/_gen/feathers/data/ButtonBarItemState.js ***!
  \******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.data.ButtonBarItemState

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var ButtonBarItemState = function(data,index,text) {
	if(index == null) {
		index = -1;
	}
	this.enabled = true;
	this.index = -1;
	this.data = data;
	this.index = index;
	this.text = text;
}

// Meta

ButtonBarItemState.__name__ = "feathers.data.ButtonBarItemState";
ButtonBarItemState.__isInterface__ = false;
ButtonBarItemState.prototype = {
	
};
ButtonBarItemState.prototype.__class__ = ButtonBarItemState.prototype.constructor = $hxClasses["feathers.data.ButtonBarItemState"] = ButtonBarItemState;

// Init



// Statics




// Export

exports["default"] = ButtonBarItemState;

/***/ }),

/***/ "./lib/_gen/feathers/data/DatePickerItemState.js":
/*!*******************************************************!*\
  !*** ./lib/_gen/feathers/data/DatePickerItemState.js ***!
  \*******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.data.DatePickerItemState

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var DatePickerItemState = function(date,selected) {
	if(selected == null) {
		selected = false;
	}
	this.enabled = true;
	this.selected = false;
	this.date = date;
	this.selected = false;
}

// Meta

DatePickerItemState.__name__ = "feathers.data.DatePickerItemState";
DatePickerItemState.__isInterface__ = false;
DatePickerItemState.prototype = {
	
};
DatePickerItemState.prototype.__class__ = DatePickerItemState.prototype.constructor = $hxClasses["feathers.data.DatePickerItemState"] = DatePickerItemState;

// Init



// Statics




// Export

exports["default"] = DatePickerItemState;

/***/ }),

/***/ "./lib/_gen/feathers/data/GridViewCellState.js":
/*!*****************************************************!*\
  !*** ./lib/_gen/feathers/data/GridViewCellState.js ***!
  \*****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.data.GridViewCellState

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var GridViewCellState = function(data,rowIndex,columnIndex,selected,text) {
	if(selected == null) {
		selected = false;
	}
	if(columnIndex == null) {
		columnIndex = -1;
	}
	if(rowIndex == null) {
		rowIndex = -1;
	}
	this.enabled = true;
	this.selected = false;
	this.columnIndex = -1;
	this.rowIndex = -1;
	this.data = data;
	this.rowIndex = rowIndex;
	this.columnIndex = columnIndex;
	this.selected = false;
	this.text = text;
}

// Meta

GridViewCellState.__name__ = "feathers.data.GridViewCellState";
GridViewCellState.__isInterface__ = false;
GridViewCellState.prototype = {
	
};
GridViewCellState.prototype.__class__ = GridViewCellState.prototype.constructor = $hxClasses["feathers.data.GridViewCellState"] = GridViewCellState;

// Init



// Statics




// Export

exports["default"] = GridViewCellState;

/***/ }),

/***/ "./lib/_gen/feathers/data/GridViewHeaderState.js":
/*!*******************************************************!*\
  !*** ./lib/_gen/feathers/data/GridViewHeaderState.js ***!
  \*******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.data.GridViewHeaderState

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var GridViewHeaderState = function(column,columnIndex,text) {
	if(columnIndex == null) {
		columnIndex = -1;
	}
	this.enabled = true;
	this.columnIndex = -1;
	this.column = column;
	this.columnIndex = columnIndex;
	this.text = text;
}

// Meta

GridViewHeaderState.__name__ = "feathers.data.GridViewHeaderState";
GridViewHeaderState.__isInterface__ = false;
GridViewHeaderState.prototype = {
	
};
GridViewHeaderState.prototype.__class__ = GridViewHeaderState.prototype.constructor = $hxClasses["feathers.data.GridViewHeaderState"] = GridViewHeaderState;

// Init



// Statics




// Export

exports["default"] = GridViewHeaderState;

/***/ }),

/***/ "./lib/_gen/feathers/data/GroupListViewItemState.js":
/*!**********************************************************!*\
  !*** ./lib/_gen/feathers/data/GroupListViewItemState.js ***!
  \**********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.data.GroupListViewItemState

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function feathers_data_GroupListViewItemType() {return __webpack_require__(/*! ./../../feathers/data/GroupListViewItemType */ "./lib/_gen/feathers/data/GroupListViewItemType.js");}

// Constructor

var GroupListViewItemState = function(type,data,location,layoutIndex,selected,text) {
	if(selected == null) {
		selected = false;
	}
	if(layoutIndex == null) {
		layoutIndex = -1;
	}
	if(type == null) {
		type = (feathers_data_GroupListViewItemType().default).STANDARD;
	}
	this.enabled = true;
	this.selected = false;
	this.layoutIndex = -1;
	this.type = type;
	this.data = data;
	this.location = location;
	this.layoutIndex = layoutIndex;
	this.selected = false;
	this.text = text;
}

// Meta

GroupListViewItemState.__name__ = "feathers.data.GroupListViewItemState";
GroupListViewItemState.__isInterface__ = false;
GroupListViewItemState.prototype = {
	
};
GroupListViewItemState.prototype.__class__ = GroupListViewItemState.prototype.constructor = $hxClasses["feathers.data.GroupListViewItemState"] = GroupListViewItemState;

// Init



// Statics




// Export

exports["default"] = GroupListViewItemState;

/***/ }),

/***/ "./lib/_gen/feathers/data/GroupListViewItemType.js":
/*!*********************************************************!*\
  !*** ./lib/_gen/feathers/data/GroupListViewItemType.js ***!
  \*********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.data.GroupListViewItemType

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var GroupListViewItemType = $hxEnums["feathers.data.GroupListViewItemType"] = { __ename__ : "feathers.data.GroupListViewItemType", __constructs__ : ["STANDARD","HEADER"]
  ,STANDARD: {_hx_index:0,__enum__:"feathers.data.GroupListViewItemType",toString:$estr}
  ,HEADER: {_hx_index:1,__enum__:"feathers.data.GroupListViewItemType",toString:$estr}
};

exports["default"] = GroupListViewItemType;

/***/ }),

/***/ "./lib/_gen/feathers/data/IFlatCollection.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/data/IFlatCollection.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.data.IFlatCollection

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function openfl_events_IEventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.IEventDispatcher);}

// Constructor

var IFlatCollection = function() {}

// Meta

IFlatCollection.__name__ = "feathers.data.IFlatCollection";
IFlatCollection.__isInterface__ = true;
IFlatCollection.__interfaces__ = [(openfl_events_IEventDispatcher())];
IFlatCollection.prototype = {
	
};
IFlatCollection.prototype.__class__ = IFlatCollection.prototype.constructor = $hxClasses["feathers.data.IFlatCollection"] = IFlatCollection;

// Init



// Statics




// Export

exports["default"] = IFlatCollection;

/***/ }),

/***/ "./lib/_gen/feathers/data/IHierarchicalCollection.js":
/*!***********************************************************!*\
  !*** ./lib/_gen/feathers/data/IHierarchicalCollection.js ***!
  \***********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.data.IHierarchicalCollection

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function openfl_events_IEventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.IEventDispatcher);}

// Constructor

var IHierarchicalCollection = function() {}

// Meta

IHierarchicalCollection.__name__ = "feathers.data.IHierarchicalCollection";
IHierarchicalCollection.__isInterface__ = true;
IHierarchicalCollection.__interfaces__ = [(openfl_events_IEventDispatcher())];
IHierarchicalCollection.prototype = {
	
};
IHierarchicalCollection.prototype.__class__ = IHierarchicalCollection.prototype.constructor = $hxClasses["feathers.data.IHierarchicalCollection"] = IHierarchicalCollection;

// Init



// Statics




// Export

exports["default"] = IHierarchicalCollection;

/***/ }),

/***/ "./lib/_gen/feathers/data/ISortOrderObserver.js":
/*!******************************************************!*\
  !*** ./lib/_gen/feathers/data/ISortOrderObserver.js ***!
  \******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.data.ISortOrderObserver

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var ISortOrderObserver = function() {}

// Meta

ISortOrderObserver.__name__ = "feathers.data.ISortOrderObserver";
ISortOrderObserver.__isInterface__ = true;
ISortOrderObserver.prototype = {
	
};
ISortOrderObserver.prototype.__class__ = ISortOrderObserver.prototype.constructor = $hxClasses["feathers.data.ISortOrderObserver"] = ISortOrderObserver;

// Init



// Statics




// Export

exports["default"] = ISortOrderObserver;

/***/ }),

/***/ "./lib/_gen/feathers/data/ListViewItemState.js":
/*!*****************************************************!*\
  !*** ./lib/_gen/feathers/data/ListViewItemState.js ***!
  \*****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.data.ListViewItemState

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var ListViewItemState = function(data,index,selected,text) {
	if(selected == null) {
		selected = false;
	}
	if(index == null) {
		index = -1;
	}
	this.enabled = true;
	this.selected = false;
	this.index = -1;
	this.data = data;
	this.index = index;
	this.selected = false;
	this.text = text;
}

// Meta

ListViewItemState.__name__ = "feathers.data.ListViewItemState";
ListViewItemState.__isInterface__ = false;
ListViewItemState.prototype = {
	
};
ListViewItemState.prototype.__class__ = ListViewItemState.prototype.constructor = $hxClasses["feathers.data.ListViewItemState"] = ListViewItemState;

// Init



// Statics




// Export

exports["default"] = ListViewItemState;

/***/ }),

/***/ "./lib/_gen/feathers/data/PageIndicatorItemState.js":
/*!**********************************************************!*\
  !*** ./lib/_gen/feathers/data/PageIndicatorItemState.js ***!
  \**********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.data.PageIndicatorItemState

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var PageIndicatorItemState = function(index,selected) {
	if(selected == null) {
		selected = false;
	}
	if(index == null) {
		index = -1;
	}
	this.enabled = true;
	this.selected = false;
	this.index = -1;
	this.index = index;
	this.selected = false;
}

// Meta

PageIndicatorItemState.__name__ = "feathers.data.PageIndicatorItemState";
PageIndicatorItemState.__isInterface__ = false;
PageIndicatorItemState.prototype = {
	
};
PageIndicatorItemState.prototype.__class__ = PageIndicatorItemState.prototype.constructor = $hxClasses["feathers.data.PageIndicatorItemState"] = PageIndicatorItemState;

// Init



// Statics




// Export

exports["default"] = PageIndicatorItemState;

/***/ }),

/***/ "./lib/_gen/feathers/data/RouteState.js":
/*!**********************************************!*\
  !*** ./lib/_gen/feathers/data/RouteState.js ***!
  \**********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.data.RouteState

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var RouteState = function(pattern,pathname,params,historyState,data) {
	this.pattern = pattern;
	this.pathname = pathname;
	this.params = params;
	this.historyState = historyState;
	this.data = data;
}

// Meta

RouteState.__name__ = "feathers.data.RouteState";
RouteState.__isInterface__ = false;
RouteState.prototype = {
	
};
RouteState.prototype.__class__ = RouteState.prototype.constructor = $hxClasses["feathers.data.RouteState"] = RouteState;

// Init



// Statics




// Export

exports["default"] = RouteState;

/***/ }),

/***/ "./lib/_gen/feathers/data/SortOrder.js":
/*!*********************************************!*\
  !*** ./lib/_gen/feathers/data/SortOrder.js ***!
  \*********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.data.SortOrder

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var SortOrder = $hxEnums["feathers.data.SortOrder"] = { __ename__ : "feathers.data.SortOrder", __constructs__ : ["ASCENDING","DESCENDING","NONE"]
  ,NONE: {_hx_index:2,__enum__:"feathers.data.SortOrder",toString:$estr}
  ,DESCENDING: {_hx_index:1,__enum__:"feathers.data.SortOrder",toString:$estr}
  ,ASCENDING: {_hx_index:0,__enum__:"feathers.data.SortOrder",toString:$estr}
};

exports["default"] = SortOrder;

/***/ }),

/***/ "./lib/_gen/feathers/data/TabBarItemState.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/data/TabBarItemState.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.data.TabBarItemState

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var TabBarItemState = function(data,index,selected,text) {
	if(selected == null) {
		selected = false;
	}
	if(index == null) {
		index = -1;
	}
	this.enabled = true;
	this.selected = false;
	this.index = -1;
	this.data = data;
	this.index = index;
	this.selected = false;
	this.text = text;
}

// Meta

TabBarItemState.__name__ = "feathers.data.TabBarItemState";
TabBarItemState.__isInterface__ = false;
TabBarItemState.prototype = {
	
};
TabBarItemState.prototype.__class__ = TabBarItemState.prototype.constructor = $hxClasses["feathers.data.TabBarItemState"] = TabBarItemState;

// Init



// Statics




// Export

exports["default"] = TabBarItemState;

/***/ }),

/***/ "./lib/_gen/feathers/data/TreeCollection.js":
/*!**************************************************!*\
  !*** ./lib/_gen/feathers/data/TreeCollection.js ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.data.TreeCollection

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_data_IHierarchicalCollection() {return __webpack_require__(/*! ./../../feathers/data/IHierarchicalCollection */ "./lib/_gen/feathers/data/IHierarchicalCollection.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_HierarchicalCollectionEvent() {return __webpack_require__(/*! ./../../feathers/events/HierarchicalCollectionEvent */ "./lib/_gen/feathers/events/HierarchicalCollectionEvent.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_RangeError() {return (__webpack_require__(/*! openfl */ "openfl").errors.RangeError);}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function feathers_data__$TreeCollection_FilterAndSortItem() {return __webpack_require__(/*! ./../../feathers/data/_TreeCollection/FilterAndSortItem */ "./lib/_gen/feathers/data/_TreeCollection/FilterAndSortItem.js");}

// Constructor

var TreeCollection = function(array) {
	this._sortCompareFunction = null;
	this._filterFunction = null;
	this._pendingRefresh = false;
	this._array = null;
	this._filterAndSortData = null;
	(openfl_events_EventDispatcher()).call(this);
	if(array == null) {
		array = [];
	}
	this.set_array(array);
}

// Meta

TreeCollection.__name__ = "feathers.data.TreeCollection";
TreeCollection.__isInterface__ = false;
TreeCollection.__interfaces__ = [(feathers_data_IHierarchicalCollection().default)];
TreeCollection.__super__ = (openfl_events_EventDispatcher());
TreeCollection.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_array: function() {
		return this._array;
	},
	set_array: function(value) {
		if(this._array == value) {
			return this._array;
		}
		if(value == null) {
			value = [];
		}
		this._array = value;
		(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"reset",null);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._array;
	},
	get_filterFunction: function() {
		return this._filterFunction;
	},
	set_filterFunction: function(value) {
		if(this._filterFunction == value) {
			return this._filterFunction;
		}
		this._filterFunction = value;
		this._pendingRefresh = true;
		(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"filterChange",null);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._filterFunction;
	},
	get_sortCompareFunction: function() {
		return this._sortCompareFunction;
	},
	set_sortCompareFunction: function(value) {
		if(this._sortCompareFunction == value) {
			return this._sortCompareFunction;
		}
		this._sortCompareFunction = value;
		this._pendingRefresh = true;
		(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"sortChange",null);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._sortCompareFunction;
	},
	getLength: function(location) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(this._filterAndSortData != null) {
			var branchChildren = this._filterAndSortData;
			if(location != null && location.length > 0) {
				var _g = 0;
				var _g1 = location.length;
				while(_g < _g1) {
					var i = _g++;
					var index = location[i];
					if(index < 0 || index >= branchChildren.length) {
						throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Branch not found at location: " + (Std().default).string(location)));
					}
					var child = branchChildren[index];
					branchChildren = child.children;
					if(branchChildren == null) {
						throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Branch not found at location: " + (Std().default).string(location)));
					}
				}
			}
			return branchChildren.length;
		}
		var branchChildren1 = this._array;
		if(location != null && location.length > 0) {
			var _g2 = 0;
			var _g11 = location.length;
			while(_g2 < _g11) {
				var i1 = _g2++;
				var index1 = location[i1];
				if(index1 < 0 || index1 >= branchChildren1.length) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Branch not found at location: " + (Std().default).string(location)));
				}
				var child1 = branchChildren1[index1];
				branchChildren1 = child1.children;
				if(branchChildren1 == null) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Branch not found at location: " + (Std().default).string(location)));
				}
			}
		}
		return branchChildren1.length;
	},
	get: function(location) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(location == null || location.length == 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item not found at location: " + (Std().default).string(location)));
		}
		if(this._filterAndSortData != null) {
			var branchChildren = this.findBranchChildren(this._filterAndSortData,location);
			var index = location[location.length - 1];
			if(index < 0 || index >= branchChildren.length) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item not found at location: " + (Std().default).string(location)));
			}
			return branchChildren[index].item;
		}
		var branchChildren1 = this.findBranchChildren(this._array,location);
		var index1 = location[location.length - 1];
		if(index1 < 0 || index1 >= branchChildren1.length) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item not found at location: " + (Std().default).string(location)));
		}
		return branchChildren1[index1];
	},
	set: function(location,value) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(location == null || location.length == 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item not found at location: " + (Std().default).string(location)));
		}
		if(this._filterAndSortData != null) {
			var lastLocationIndex = location[location.length - 1];
			var branchChildren = this.findBranchChildren(this._array,location);
			var filteredOrSortedBranchChildren = this.findBranchChildren(this._filterAndSortData,location);
			var oldItem = null;
			var unfilteredLastLocationIndex = branchChildren.length;
			if(lastLocationIndex < filteredOrSortedBranchChildren.length) {
				oldItem = filteredOrSortedBranchChildren[lastLocationIndex].item;
				unfilteredLastLocationIndex = branchChildren.indexOf(oldItem);
			}
			branchChildren[unfilteredLastLocationIndex] = value;
			if(this._filterFunction != null) {
				var includeItem = this._filterFunction(value);
				if(lastLocationIndex < filteredOrSortedBranchChildren.length) {
					if(includeItem) {
						filteredOrSortedBranchChildren[lastLocationIndex] = this.createFilterAndSortItem(value);
						(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"replaceItem",location,value,oldItem);
						(feathers_events_FeathersEvent().default).dispatch(this,"change");
					} else {
						filteredOrSortedBranchChildren.splice(lastLocationIndex,1);
						(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"removeItem",location,null,oldItem);
						(feathers_events_FeathersEvent().default).dispatch(this,"change");
					}
				} else if(includeItem) {
					filteredOrSortedBranchChildren[filteredOrSortedBranchChildren.length] = this.createFilterAndSortItem(value);
					(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"addItem",location,value);
					(feathers_events_FeathersEvent().default).dispatch(this,"change");
				}
			} else if(this._sortCompareFunction != null) {
				filteredOrSortedBranchChildren.splice(lastLocationIndex,1);
				var wrappedItem = this.createFilterAndSortItem(value);
				var sortedIndex = this.getSortedInsertionIndex(filteredOrSortedBranchChildren,wrappedItem);
				filteredOrSortedBranchChildren[sortedIndex] = wrappedItem;
				(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"replaceItem",location,value,oldItem);
				(feathers_events_FeathersEvent().default).dispatch(this,"change");
				return;
			}
			return;
		}
		var branchChildren1 = this.findBranchChildren(this._array,location);
		var index = location[location.length - 1];
		if(index < 0 || index > branchChildren1.length) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item not found at location: " + (Std().default).string(location)));
		}
		var oldValue = branchChildren1[index];
		branchChildren1[index] = value;
		(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"replaceItem",location,value,oldValue);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
	},
	isBranch: function(item) {
		if(item == null) {
			return false;
		}
		return item.isBranch();
	},
	locationOf: function(item) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		var result = [];
		var found = false;
		if(this._filterAndSortData != null) {
			found = this.findItemInFilteredOrSortedBranch(this._filterAndSortData,item,result);
		} else {
			found = this.findItemInBranch(this._array,item,result);
		}
		if(!found) {
			return null;
		}
		return result;
	},
	contains: function(item) {
		return this.locationOf(item) != null;
	},
	addAt: function(itemToAdd,location) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(location == null || location.length == 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item cannot be added at location: " + (Std().default).string(location)));
		}
		if(this._filterAndSortData != null) {
			var lastLocationIndex = location[location.length - 1];
			var branchChildren = this.findBranchChildren(this._array,location);
			var filteredOrSortedBranchChildren = this.findBranchChildren(this._filterAndSortData,location);
			var oldItem = null;
			var unfilteredLastLocationIndex = branchChildren.length;
			if(lastLocationIndex < filteredOrSortedBranchChildren.length) {
				oldItem = filteredOrSortedBranchChildren[lastLocationIndex].item;
				unfilteredLastLocationIndex = branchChildren.indexOf(oldItem);
			}
			branchChildren.splice(unfilteredLastLocationIndex,0,itemToAdd);
			var includeItem = true;
			if(this._filterFunction != null) {
				includeItem = this._filterFunction(itemToAdd);
			}
			if(includeItem) {
				var sortedIndex = lastLocationIndex;
				var wrappedItem = this.createFilterAndSortItem(itemToAdd);
				if(this._sortCompareFunction != null) {
					sortedIndex = this.getSortedInsertionIndex(filteredOrSortedBranchChildren,wrappedItem);
				}
				filteredOrSortedBranchChildren.splice(sortedIndex,0,wrappedItem);
				(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"addItem",location,itemToAdd);
				(feathers_events_FeathersEvent().default).dispatch(this,"change");
			}
			return;
		}
		var branchChildren1 = this.findBranchChildren(this._array,location);
		var index = location[location.length - 1];
		if(index < 0 || index > branchChildren1.length) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item cannot be added at location: " + (Std().default).string(location)));
		}
		branchChildren1.splice(index,0,itemToAdd);
		(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"addItem",location,itemToAdd);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
	},
	removeAt: function(location) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(location == null || location.length == 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item not found at location: " + (Std().default).string(location)));
		}
		if(this._filterAndSortData != null) {
			var lastLocationIndex = location[location.length - 1];
			var branchChildren = this.findBranchChildren(this._array,location);
			var filteredOrSortedBranchChildren = this.findBranchChildren(this._filterAndSortData,location);
			var removedItem = filteredOrSortedBranchChildren.splice(lastLocationIndex,1)[0].item;
			(HxOverrides().default).remove(branchChildren,removedItem);
			(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"removeItem",location,null,removedItem);
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
			return removedItem;
		}
		var branchChildren1 = this.findBranchChildren(this._array,location);
		var index = location[location.length - 1];
		if(index < 0 || index >= branchChildren1.length) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item not found at location: " + (Std().default).string(location)));
		}
		var removedItem1 = branchChildren1[index];
		(HxOverrides().default).remove(branchChildren1,removedItem1);
		(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"removeItem",location,null,removedItem1);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return removedItem1;
	},
	remove: function(item) {
		var location = this.locationOf(item);
		if(location == null) {
			return;
		}
		this.removeAt(location);
	},
	removeAll: function(location) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(this._array.length == 0) {
			return;
		}
		if(location == null || location.length == 0) {
			if(this._filterAndSortData != null) {
				this._filterAndSortData.length = 0;
			}
			this._array.length = 0;
			(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"removeAll",null);
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
			return;
		}
		if(this._filterAndSortData != null) {
			var firstChildLocation = location.slice();
			firstChildLocation.push(0);
			var branchChildren = this.findBranchChildren(this._array,firstChildLocation);
			var filteredOrSortedBranchChildren = this.findBranchChildren(this._filterAndSortData,firstChildLocation);
			filteredOrSortedBranchChildren.length = 0;
			branchChildren.length = 0;
			(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"removeAll",location);
			(feathers_events_FeathersEvent().default).dispatch(this,"change");
			return;
		}
		var firstChildLocation1 = location.slice();
		firstChildLocation1.push(0);
		var branchChildren1 = this.findBranchChildren(this._array,firstChildLocation1);
		branchChildren1.length = 0;
		(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"removeAll",location);
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
	},
	updateAt: function(location) {
		if(this._pendingRefresh) {
			this.refreshFilterAndSort();
		}
		if(location == null || location.length == 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item not found at location: " + (Std().default).string(location)));
		}
		var branchChildren = this._filterAndSortData != null ? this.findBranchChildren(this._filterAndSortData,location) : this.findBranchChildren(this._array,location);
		var index = location[location.length - 1];
		if(index < 0 || index >= branchChildren.length) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Failed to update item at index " + index + ". Expected a value between 0 and " + (branchChildren.length - 1) + " at index " + (location.length - 1) + "."));
		}
		(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"updateItem",location);
		this.refresh();
	},
	updateAll: function() {
		(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"updateAll",null);
		this.refresh();
	},
	refresh: function() {
		if(this._filterFunction == null && this._sortCompareFunction == null) {
			return;
		}
		this._pendingRefresh = true;
		if(this._filterFunction != null) {
			(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"filterChange",null);
		}
		if(this._sortCompareFunction != null) {
			(feathers_events_HierarchicalCollectionEvent().default).dispatch(this,"sortChange",null);
		}
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
	},
	findItemInBranch: function(branchChildren,itemToFind,result) {
		var _g = 0;
		var _g1 = branchChildren.length;
		while(_g < _g1) {
			var i = _g++;
			var item = branchChildren[i];
			if(item == itemToFind) {
				result.push(i);
				return true;
			}
			if(!item.isBranch()) {
				continue;
			}
			result.push(i);
			var found = this.findItemInBranch(item.children,itemToFind,result);
			if(found) {
				return true;
			}
			result.pop();
		}
		return false;
	},
	findItemInFilteredOrSortedBranch: function(branchChildren,itemToFind,result) {
		var _g = 0;
		var _g1 = branchChildren.length;
		while(_g < _g1) {
			var i = _g++;
			var item = branchChildren[i];
			if(item.item == itemToFind) {
				result.push(i);
				return true;
			}
			var itemChildren = item.children;
			if(itemChildren != null) {
				result.push(i);
				var found = this.findItemInFilteredOrSortedBranch(itemChildren,itemToFind,result);
				if(found) {
					return true;
				}
				result.pop();
			}
		}
		return false;
	},
	refreshFilterAndSort: function() {
		this._pendingRefresh = false;
		var oldFilterAndSortData = this._filterAndSortData;
		this._filterAndSortData = null;
		if(this._filterFunction != null || this._sortCompareFunction != null) {
			var result = oldFilterAndSortData;
			if(result != null) {
				result.length = 0;
			} else {
				result = [];
			}
			this.refreshFilterAndSortInternal(this._array,result);
			this._filterAndSortData = result;
		}
		if(this._sortCompareFunction != null) {
			this.refreshSort(this._filterAndSortData);
		}
	},
	getSortedInsertionIndex: function(branchChildren,item) {
		if(this._sortCompareFunction == null) {
			return branchChildren.length;
		}
		var _g = 0;
		var _g1 = branchChildren.length;
		while(_g < _g1) {
			var i = _g++;
			var otherItem = branchChildren[i];
			var result = this.sortCompareFunctionInternal(item,otherItem);
			if(result < 1) {
				return i;
			}
		}
		return branchChildren.length;
	},
	refreshSort: function(array) {
		array.sort($bind(this,this.sortCompareFunctionInternal));
		var _g = 0;
		while(_g < array.length) {
			var item = array[_g];
			++_g;
			if(item.children == null) {
				continue;
			}
			this.refreshSort(item.children);
		}
	},
	refreshFilterAndSortInternal: function(items,result) {
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var item = items[i];
			var filterAndSortItem = this.createFilterAndSortItem(item);
			if(filterAndSortItem != null) {
				result.push(filterAndSortItem);
			}
		}
	},
	createFilterAndSortItem: function(item) {
		var result = null;
		if(this._filterFunction == null || this._filterFunction(item)) {
			result = new (feathers_data__$TreeCollection_FilterAndSortItem().default)(item);
		}
		if(result != null) {
			var children = item.children;
			if(children != null) {
				result.children = [];
				this.refreshFilterAndSortInternal(children,result.children);
			}
		}
		return result;
	},
	findBranchChildren: function(source,location) {
		var branchChildren = source;
		var _g = 0;
		var _g1 = location.length - 1;
		while(_g < _g1) {
			var i = _g++;
			var index = location[i];
			if(index < 0 || index >= branchChildren.length) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item not found at location: " + (Std().default).string(location)));
			}
			var child = branchChildren[index];
			branchChildren = child.children;
			if(branchChildren == null) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Item not found at location: " + (Std().default).string(location)));
			}
		}
		return branchChildren;
	},
	sortCompareFunctionInternal: function(item1,item2) {
		return this._sortCompareFunction(item1.item,item2.item);
	}
});
TreeCollection.prototype.__class__ = TreeCollection.prototype.constructor = $hxClasses["feathers.data.TreeCollection"] = TreeCollection;

// Init



// Statics


TreeCollection.__meta__ = { obj : { defaultXmlProperty : ["array"]}}

// Export

exports["default"] = TreeCollection;

/***/ }),

/***/ "./lib/_gen/feathers/data/TreeGridViewCellState.js":
/*!*********************************************************!*\
  !*** ./lib/_gen/feathers/data/TreeGridViewCellState.js ***!
  \*********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.data.TreeGridViewCellState

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var TreeGridViewCellState = function(data,rowLocation,columnIndex,layoutIndex,branch,opened,selected,text) {
	if(selected == null) {
		selected = false;
	}
	if(opened == null) {
		opened = false;
	}
	if(branch == null) {
		branch = false;
	}
	if(layoutIndex == null) {
		layoutIndex = -1;
	}
	if(columnIndex == null) {
		columnIndex = -1;
	}
	this.enabled = true;
	this.selected = false;
	this.opened = false;
	this.branch = false;
	this.layoutIndex = -1;
	this.columnIndex = -1;
	this.rowLocation = null;
	this.data = data;
	this.rowLocation = rowLocation;
	this.columnIndex = columnIndex;
	this.layoutIndex = layoutIndex;
	this.branch = branch;
	this.opened = opened;
	this.selected = false;
	this.text = text;
}

// Meta

TreeGridViewCellState.__name__ = "feathers.data.TreeGridViewCellState";
TreeGridViewCellState.__isInterface__ = false;
TreeGridViewCellState.prototype = {
	
};
TreeGridViewCellState.prototype.__class__ = TreeGridViewCellState.prototype.constructor = $hxClasses["feathers.data.TreeGridViewCellState"] = TreeGridViewCellState;

// Init



// Statics




// Export

exports["default"] = TreeGridViewCellState;

/***/ }),

/***/ "./lib/_gen/feathers/data/TreeGridViewHeaderState.js":
/*!***********************************************************!*\
  !*** ./lib/_gen/feathers/data/TreeGridViewHeaderState.js ***!
  \***********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.data.TreeGridViewHeaderState

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var TreeGridViewHeaderState = function(column,columnIndex,text) {
	if(columnIndex == null) {
		columnIndex = -1;
	}
	this.enabled = true;
	this.columnIndex = -1;
	this.column = column;
	this.columnIndex = columnIndex;
	this.text = text;
}

// Meta

TreeGridViewHeaderState.__name__ = "feathers.data.TreeGridViewHeaderState";
TreeGridViewHeaderState.__isInterface__ = false;
TreeGridViewHeaderState.prototype = {
	
};
TreeGridViewHeaderState.prototype.__class__ = TreeGridViewHeaderState.prototype.constructor = $hxClasses["feathers.data.TreeGridViewHeaderState"] = TreeGridViewHeaderState;

// Init



// Statics




// Export

exports["default"] = TreeGridViewHeaderState;

/***/ }),

/***/ "./lib/_gen/feathers/data/TreeNode.js":
/*!********************************************!*\
  !*** ./lib/_gen/feathers/data/TreeNode.js ***!
  \********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.data.TreeNode

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var TreeNode = function(data,children) {
	this.data = data;
	this.children = children;
}

// Meta

TreeNode.__name__ = "feathers.data.TreeNode";
TreeNode.__isInterface__ = false;
TreeNode.prototype = {
	isBranch: function() {
		return this.children != null;
	}
};
TreeNode.prototype.__class__ = TreeNode.prototype.constructor = $hxClasses["feathers.data.TreeNode"] = TreeNode;

// Init



// Statics




// Export

exports["default"] = TreeNode;

/***/ }),

/***/ "./lib/_gen/feathers/data/TreeViewItemState.js":
/*!*****************************************************!*\
  !*** ./lib/_gen/feathers/data/TreeViewItemState.js ***!
  \*****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.data.TreeViewItemState

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var TreeViewItemState = function(data,location,layoutIndex,branch,selected,text) {
	if(selected == null) {
		selected = false;
	}
	if(branch == null) {
		branch = false;
	}
	if(layoutIndex == null) {
		layoutIndex = -1;
	}
	this.enabled = true;
	this.selected = false;
	this.opened = false;
	this.branch = false;
	this.layoutIndex = -1;
	this.data = data;
	this.location = location;
	this.layoutIndex = layoutIndex;
	this.branch = branch;
	this.selected = false;
	this.text = text;
}

// Meta

TreeViewItemState.__name__ = "feathers.data.TreeViewItemState";
TreeViewItemState.__isInterface__ = false;
TreeViewItemState.prototype = {
	
};
TreeViewItemState.prototype.__class__ = TreeViewItemState.prototype.constructor = $hxClasses["feathers.data.TreeViewItemState"] = TreeViewItemState;

// Init



// Statics




// Export

exports["default"] = TreeViewItemState;

/***/ }),

/***/ "./lib/_gen/feathers/data/_ArrayHierarchicalCollection/FilterAndSortItem.js":
/*!**********************************************************************************!*\
  !*** ./lib/_gen/feathers/data/_ArrayHierarchicalCollection/FilterAndSortItem.js ***!
  \**********************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.data._ArrayHierarchicalCollection.FilterAndSortItem

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var FilterAndSortItem = function(item,children) {
	this.item = item;
	this.children = children;
}

// Meta

FilterAndSortItem.__name__ = "feathers.data._ArrayHierarchicalCollection.FilterAndSortItem";
FilterAndSortItem.__isInterface__ = false;
FilterAndSortItem.prototype = {
	
};
FilterAndSortItem.prototype.__class__ = FilterAndSortItem.prototype.constructor = $hxClasses["feathers.data._ArrayHierarchicalCollection.FilterAndSortItem"] = FilterAndSortItem;

// Init



// Statics




// Export

exports["default"] = FilterAndSortItem;

/***/ }),

/***/ "./lib/_gen/feathers/data/_TreeCollection/FilterAndSortItem.js":
/*!*********************************************************************!*\
  !*** ./lib/_gen/feathers/data/_TreeCollection/FilterAndSortItem.js ***!
  \*********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.data._TreeCollection.FilterAndSortItem

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var FilterAndSortItem = function(item,children) {
	this.item = item;
	this.children = children;
}

// Meta

FilterAndSortItem.__name__ = "feathers.data._TreeCollection.FilterAndSortItem";
FilterAndSortItem.__isInterface__ = false;
FilterAndSortItem.prototype = {
	
};
FilterAndSortItem.prototype.__class__ = FilterAndSortItem.prototype.constructor = $hxClasses["feathers.data._TreeCollection.FilterAndSortItem"] = FilterAndSortItem;

// Init



// Statics




// Export

exports["default"] = FilterAndSortItem;

/***/ }),

/***/ "./lib/_gen/feathers/display/Scale9Bitmap.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/display/Scale9Bitmap.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.display.Scale9Bitmap

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_display_Sprite() {return (__webpack_require__(/*! openfl */ "openfl").display.Sprite);}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function openfl_display_BitmapData() {return (__webpack_require__(/*! openfl */ "openfl").display.BitmapData);}
function openfl_display_Bitmap() {return (__webpack_require__(/*! openfl */ "openfl").display.Bitmap);}
function openfl_geom_Rectangle() {return (__webpack_require__(/*! openfl */ "openfl").geom.Rectangle);}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function openfl_geom_Matrix() {return (__webpack_require__(/*! openfl */ "openfl").geom.Matrix);}

// Constructor

var Scale9Bitmap = function(bitmapData,scale9Grid,smoothing) {
	if(smoothing == null) {
		smoothing = false;
	}
	this._rectangle = new (openfl_geom_Rectangle())();
	this._point = new (openfl_geom_Point())();
	this._matrix = new (openfl_geom_Matrix())();
	this._smoothing = false;
	this._height = 0.0;
	this._width = 0.0;
	this.middle = 0;
	this.center = 0;
	this.left = 0;
	this.bottom = 0;
	this.right = 0;
	this.top = 0;
	this._allowRefresh = true;
	(openfl_display_Sprite()).call(this);
	this._allowRefresh = false;
	this.set_bitmapData(bitmapData);
	this.set_scale9Grid(scale9Grid);
	this._width = this._bitmapData.width;
	this._height = this._bitmapData.height;
	this.set_smoothing(smoothing);
	this._allowRefresh = true;
	this.refreshSubBitmapData();
	this.draw();
}

// Meta

Scale9Bitmap.__name__ = "feathers.display.Scale9Bitmap";
Scale9Bitmap.__isInterface__ = false;
Scale9Bitmap.__super__ = (openfl_display_Sprite());
Scale9Bitmap.prototype = $extend((openfl_display_Sprite()).prototype, {
	get_width: function() {
		return this._width;
	},
	set_width: function(value) {
		if(this._width == value) {
			return this._width;
		}
		this._width = value;
		if(this._allowRefresh) {
			this.draw();
		}
		return this._width;
	},
	get_height: function() {
		return this._height;
	},
	set_height: function(value) {
		if(this._height == value) {
			return this._height;
		}
		this._height = value;
		if(this._allowRefresh) {
			this.draw();
		}
		return this._height;
	},
	get_smoothing: function() {
		return this._smoothing;
	},
	set_smoothing: function(value) {
		if(this._smoothing == value) {
			return this._smoothing;
		}
		this._smoothing = value;
		if(this._allowRefresh) {
			this.draw();
		}
		return this._smoothing;
	},
	get_bitmapData: function() {
		return this._bitmapData;
	},
	set_bitmapData: function(value) {
		if(this._bitmapData == value) {
			return this._bitmapData;
		}
		this._bitmapData = value;
		if(this._bitmapData == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Invalid BitmapData"));
		}
		if(this._allowRefresh) {
			this.refreshSubBitmapData();
			this.draw();
		}
		return this._bitmapData;
	},
	get_scale9Grid: function() {
		return this._scale9Grid;
	},
	set_scale9Grid: function(value) {
		if(this._scale9Grid == value || this._scale9Grid != null && this._scale9Grid.equals(value)) {
			return this._scale9Grid;
		}
		this._scale9Grid = value;
		if(this._allowRefresh) {
			this.refreshSubBitmapData();
			this.draw();
		}
		return this._scale9Grid;
	},
	refreshSubBitmapData: function() {
		if(this.topLeft != null) {
			this.topLeft.dispose();
			this.topLeft = null;
		}
		if(this.topCenter != null) {
			this.topCenter.dispose();
			this.topCenter = null;
		}
		if(this.topRight != null) {
			this.topRight.dispose();
			this.topRight = null;
		}
		if(this.middleLeft != null) {
			this.middleLeft.dispose();
			this.middleLeft = null;
		}
		if(this.middleCenter != null) {
			this.middleCenter.dispose();
			this.middleCenter = null;
		}
		if(this.middleRight != null) {
			this.middleRight.dispose();
			this.middleRight = null;
		}
		if(this.bottomLeft != null) {
			this.bottomLeft.dispose();
			this.bottomLeft = null;
		}
		if(this.bottomCenter != null) {
			this.bottomCenter.dispose();
			this.bottomCenter = null;
		}
		if(this.bottomRight != null) {
			this.bottomRight.dispose();
			this.bottomRight = null;
		}
		if(this._scale9Grid == null) {
			return;
		}
		this.left = (Std().default).int(Math.max(0.0,this._scale9Grid.x));
		this.top = (Std().default).int(Math.max(0.0,this._scale9Grid.y));
		this.center = (Std().default).int(Math.max(0.0,this._scale9Grid.width));
		this.middle = (Std().default).int(Math.max(0.0,this._scale9Grid.height));
		this.right = (Std().default).int(Math.max(0.0,this._bitmapData.width - this.left - this.center));
		this.bottom = (Std().default).int(Math.max(0.0,this._bitmapData.height - this.top - this.middle));
		this._point.setTo(0.0,0.0);
		this.topLeft = new (openfl_display_BitmapData())(this.left,this.top);
		this._rectangle.setTo(0.0,0.0,this.topLeft.width,this.topLeft.height);
		this.topLeft.copyPixels(this._bitmapData,this._rectangle,this._point);
		this.topCenter = new (openfl_display_BitmapData())(this.center,this.top);
		this._rectangle.setTo(this.left,0.0,this.topCenter.width,this.topCenter.height);
		this.topCenter.copyPixels(this._bitmapData,this._rectangle,this._point);
		this.topRight = new (openfl_display_BitmapData())(this.right,this.top);
		this._rectangle.setTo(this.left + this.center,0.0,this.topRight.width,this.topRight.height);
		this.topRight.copyPixels(this._bitmapData,this._rectangle,this._point);
		this.middleLeft = new (openfl_display_BitmapData())(this.left,this.middle);
		this._rectangle.setTo(0.0,this.top,this.middleLeft.width,this.middleLeft.height);
		this.middleLeft.copyPixels(this._bitmapData,this._rectangle,this._point);
		this.middleCenter = new (openfl_display_BitmapData())(this.center,this.middle);
		this._rectangle.setTo(this.left,this.top,this.middleCenter.width,this.middleCenter.height);
		this.middleCenter.copyPixels(this._bitmapData,this._rectangle,this._point);
		this.middleRight = new (openfl_display_BitmapData())(this.right,this.middle);
		this._rectangle.setTo(this.left + this.center,this.top,this.middleRight.width,this.middleRight.height);
		this.middleRight.copyPixels(this._bitmapData,this._rectangle,this._point);
		this.bottomLeft = new (openfl_display_BitmapData())(this.top,this.bottom);
		this._rectangle.setTo(0.0,this.top + this.middle,this.bottomLeft.width,this.bottomLeft.height);
		this.bottomLeft.copyPixels(this._bitmapData,this._rectangle,this._point);
		this.bottomCenter = new (openfl_display_BitmapData())(this.center,this.bottom);
		this._rectangle.setTo(this.left,this.top + this.middle,this.bottomCenter.width,this.bottomCenter.height);
		this.bottomCenter.copyPixels(this._bitmapData,this._rectangle,this._point);
		this.bottomRight = new (openfl_display_BitmapData())(this.right,this.bottom);
		this._rectangle.setTo(this.left + this.center,this.top + this.middle,this.bottomRight.width,this.bottomRight.height);
		this.bottomRight.copyPixels(this._bitmapData,this._rectangle,this._point);
	},
	draw: function() {
		if(this._width == 0 || this._height == 0) {
			this.cleanupBitmaps();
			return;
		}
		var center2 = Math.max(0.0,this._width - this.left - this.right);
		var middle2 = Math.max(0.0,this._height - this.top - this.bottom);
		var left2 = this.left;
		var right2 = this.right;
		var minWidth = this.left + this.right;
		if(this._width < minWidth) {
			var ratio = this._width / minWidth;
			left2 *= ratio;
			right2 *= ratio;
		}
		var top2 = this.top;
		var bottom2 = this.bottom;
		var minHeight = this.top + this.bottom;
		if(this._height < minHeight) {
			var ratio1 = this._height / minHeight;
			top2 *= ratio1;
			bottom2 *= ratio1;
		}
		if(this.topLeft != null) {
			if(this._topLeftBitmap == null) {
				this._topLeftBitmap = new (openfl_display_Bitmap())(null,"never",this._smoothing);
				this.addChild(this._topLeftBitmap);
			}
			this._topLeftBitmap.set_bitmapData(this.topLeft);
			this._topLeftBitmap.smoothing = this._smoothing;
			this._topLeftBitmap.set_x(0.0);
			this._topLeftBitmap.set_y(0.0);
			this._topLeftBitmap.set_width(left2);
			this._topLeftBitmap.set_height(top2);
		} else if(this._topLeftBitmap != null) {
			this.removeChild(this._topLeftBitmap);
			this._topLeftBitmap = null;
		}
		if(this.topCenter != null) {
			if(this._topCenterBitmap == null) {
				this._topCenterBitmap = new (openfl_display_Bitmap())(null,"never",this._smoothing);
				this.addChild(this._topCenterBitmap);
			}
			this._topCenterBitmap.set_bitmapData(this.topCenter);
			this._topCenterBitmap.smoothing = this._smoothing;
			this._topCenterBitmap.set_x(left2);
			this._topCenterBitmap.set_y(0.0);
			this._topCenterBitmap.set_width(center2);
			this._topCenterBitmap.set_height(top2);
		} else if(this._topCenterBitmap != null) {
			this.removeChild(this._topCenterBitmap);
			this._topCenterBitmap = null;
		}
		if(this.topRight != null) {
			if(this._topRightBitmap == null) {
				this._topRightBitmap = new (openfl_display_Bitmap())(null,"never",this._smoothing);
				this.addChild(this._topRightBitmap);
			}
			this._topRightBitmap.set_bitmapData(this.topRight);
			this._topRightBitmap.smoothing = this._smoothing;
			this._topRightBitmap.set_x(left2 + center2);
			this._topRightBitmap.set_y(0.0);
			this._topRightBitmap.set_width(right2);
			this._topRightBitmap.set_height(top2);
		} else if(this._topRightBitmap != null) {
			this.removeChild(this._topRightBitmap);
			this._topRightBitmap = null;
		}
		if(this.middleLeft != null) {
			if(this._middleLeftBitmap == null) {
				this._middleLeftBitmap = new (openfl_display_Bitmap())(null,"never",this._smoothing);
				this.addChild(this._middleLeftBitmap);
			}
			this._middleLeftBitmap.set_bitmapData(this.middleLeft);
			this._middleLeftBitmap.smoothing = this._smoothing;
			this._middleLeftBitmap.set_x(0.0);
			this._middleLeftBitmap.set_y(top2);
			this._middleLeftBitmap.set_width(left2);
			this._middleLeftBitmap.set_height(middle2);
		} else if(this._middleLeftBitmap != null) {
			this.removeChild(this._middleLeftBitmap);
			this._middleLeftBitmap = null;
		}
		if(this.middleCenter != null) {
			if(this._middleCenterBitmap == null) {
				this._middleCenterBitmap = new (openfl_display_Bitmap())(null,"never",this._smoothing);
				this.addChild(this._middleCenterBitmap);
			}
			this._middleCenterBitmap.set_bitmapData(this.middleCenter);
			this._middleCenterBitmap.smoothing = this._smoothing;
			this._middleCenterBitmap.set_x(left2);
			this._middleCenterBitmap.set_y(top2);
			this._middleCenterBitmap.set_width(center2);
			this._middleCenterBitmap.set_height(middle2);
		} else if(this._middleCenterBitmap != null) {
			this.removeChild(this._middleCenterBitmap);
			this._middleCenterBitmap = null;
		}
		if(this.middleRight != null) {
			if(this._middleRightBitmap == null) {
				this._middleRightBitmap = new (openfl_display_Bitmap())(null,"never",this._smoothing);
				this.addChild(this._middleRightBitmap);
			}
			this._middleRightBitmap.set_bitmapData(this.middleRight);
			this._middleRightBitmap.smoothing = this._smoothing;
			this._middleRightBitmap.set_x(left2 + center2);
			this._middleRightBitmap.set_y(top2);
			this._middleRightBitmap.set_width(right2);
			this._middleRightBitmap.set_height(middle2);
		} else if(this._middleRightBitmap != null) {
			this.removeChild(this._middleRightBitmap);
			this._middleRightBitmap = null;
		}
		if(this.bottomLeft != null) {
			if(this._bottomLeftBitmap == null) {
				this._bottomLeftBitmap = new (openfl_display_Bitmap())(null,"never",this._smoothing);
				this.addChild(this._bottomLeftBitmap);
			}
			this._bottomLeftBitmap.set_bitmapData(this.bottomLeft);
			this._bottomLeftBitmap.smoothing = this._smoothing;
			this._bottomLeftBitmap.set_x(0.0);
			this._bottomLeftBitmap.set_y(top2 + middle2);
			this._bottomLeftBitmap.set_width(left2);
			this._bottomLeftBitmap.set_height(bottom2);
		} else if(this._bottomLeftBitmap != null) {
			this.removeChild(this._bottomLeftBitmap);
			this._bottomLeftBitmap = null;
		}
		if(this.bottomCenter != null) {
			if(this._bottomCenterBitmap == null) {
				this._bottomCenterBitmap = new (openfl_display_Bitmap())(null,"never",this._smoothing);
				this.addChild(this._bottomCenterBitmap);
			}
			this._bottomCenterBitmap.set_bitmapData(this.bottomCenter);
			this._bottomCenterBitmap.smoothing = this._smoothing;
			this._bottomCenterBitmap.set_x(left2);
			this._bottomCenterBitmap.set_y(top2 + middle2);
			this._bottomCenterBitmap.set_width(center2);
			this._bottomCenterBitmap.set_height(bottom2);
		} else if(this._bottomCenterBitmap != null) {
			this.removeChild(this._bottomCenterBitmap);
			this._bottomCenterBitmap = null;
		}
		if(this.bottomRight != null) {
			if(this._bottomRightBitmap == null) {
				this._bottomRightBitmap = new (openfl_display_Bitmap())(null,"never",this._smoothing);
				this.addChild(this._bottomRightBitmap);
			}
			this._bottomRightBitmap.set_bitmapData(this.bottomRight);
			this._bottomRightBitmap.smoothing = this._smoothing;
			this._bottomRightBitmap.set_x(left2 + center2);
			this._bottomRightBitmap.set_y(top2 + middle2);
			this._bottomRightBitmap.set_width(right2);
			this._bottomRightBitmap.set_height(bottom2);
		} else if(this._bottomRightBitmap != null) {
			this.removeChild(this._bottomRightBitmap);
			this._bottomRightBitmap = null;
		}
	},
	cleanupBitmaps: function() {
		if(this._topLeftBitmap != null) {
			this.removeChild(this._topLeftBitmap);
			this._topLeftBitmap = null;
		}
		if(this._topCenterBitmap != null) {
			this.removeChild(this._topCenterBitmap);
			this._topCenterBitmap = null;
		}
		if(this._topRightBitmap != null) {
			this.removeChild(this._topRightBitmap);
			this._topRightBitmap = null;
		}
		if(this._middleLeftBitmap != null) {
			this.removeChild(this._middleLeftBitmap);
			this._middleLeftBitmap = null;
		}
		if(this._middleCenterBitmap != null) {
			this.removeChild(this._middleCenterBitmap);
			this._middleCenterBitmap = null;
		}
		if(this._middleRightBitmap != null) {
			this.removeChild(this._middleRightBitmap);
			this._middleRightBitmap = null;
		}
		if(this._bottomLeftBitmap != null) {
			this.removeChild(this._bottomLeftBitmap);
			this._bottomLeftBitmap = null;
		}
		if(this._bottomCenterBitmap != null) {
			this.removeChild(this._bottomCenterBitmap);
			this._bottomCenterBitmap = null;
		}
		if(this._bottomRightBitmap != null) {
			this.removeChild(this._bottomRightBitmap);
			this._bottomRightBitmap = null;
		}
	}
});
Scale9Bitmap.prototype.__class__ = Scale9Bitmap.prototype.constructor = $hxClasses["feathers.display.Scale9Bitmap"] = Scale9Bitmap;

// Init



// Statics




// Export

exports["default"] = Scale9Bitmap;

/***/ }),

/***/ "./lib/_gen/feathers/events/ButtonBarEvent.js":
/*!****************************************************!*\
  !*** ./lib/_gen/feathers/events/ButtonBarEvent.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.events.ButtonBarEvent

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_events_Event() {return (__webpack_require__(/*! openfl */ "openfl").events.Event);}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}

// Constructor

var ButtonBarEvent = function(type,state) {
	(openfl_events_Event()).call(this,type,false,false);
	this.state = state;
}

// Meta

ButtonBarEvent.__name__ = "feathers.events.ButtonBarEvent";
ButtonBarEvent.__isInterface__ = false;
ButtonBarEvent.__super__ = (openfl_events_Event());
ButtonBarEvent.prototype = $extend((openfl_events_Event()).prototype, {
	clone: function() {
		return new ButtonBarEvent(this.type,this.state);
	}
});
ButtonBarEvent.prototype.__class__ = ButtonBarEvent.prototype.constructor = $hxClasses["feathers.events.ButtonBarEvent"] = ButtonBarEvent;

// Init



// Statics

ButtonBarEvent.dispatch = function(dispatcher,type,state) {
	var event = ButtonBarEvent._pool.get();
	event.type = type;
	event.state = state;
	var result = dispatcher.dispatchEvent(event);
	ButtonBarEvent._pool.release(event);
	return result;
}
ButtonBarEvent.ITEM_TRIGGER = "itemTrigger"
ButtonBarEvent._pool = new (lime_utils_ObjectPool().default)(function() {
	return new ButtonBarEvent(null,null);
},function(event) {
	event.target = null;
	event.currentTarget = null;
	event.__preventDefault = false;
	event.__isCanceled = false;
	event.__isCanceledNow = false;
	return event.state = null;
})

// Export

exports["default"] = ButtonBarEvent;

/***/ }),

/***/ "./lib/_gen/feathers/events/DatePickerEvent.js":
/*!*****************************************************!*\
  !*** ./lib/_gen/feathers/events/DatePickerEvent.js ***!
  \*****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.events.DatePickerEvent

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_events_Event() {return (__webpack_require__(/*! openfl */ "openfl").events.Event);}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}

// Constructor

var DatePickerEvent = function(type,state) {
	(openfl_events_Event()).call(this,type,false,false);
	this.state = state;
}

// Meta

DatePickerEvent.__name__ = "feathers.events.DatePickerEvent";
DatePickerEvent.__isInterface__ = false;
DatePickerEvent.__super__ = (openfl_events_Event());
DatePickerEvent.prototype = $extend((openfl_events_Event()).prototype, {
	clone: function() {
		return new DatePickerEvent(this.type,this.state);
	}
});
DatePickerEvent.prototype.__class__ = DatePickerEvent.prototype.constructor = $hxClasses["feathers.events.DatePickerEvent"] = DatePickerEvent;

// Init



// Statics

DatePickerEvent.dispatch = function(dispatcher,type,state) {
	var event = DatePickerEvent._pool.get();
	event.type = type;
	event.state = state;
	var result = dispatcher.dispatchEvent(event);
	DatePickerEvent._pool.release(event);
	return result;
}
DatePickerEvent.ITEM_TRIGGER = "itemTrigger"
DatePickerEvent._pool = new (lime_utils_ObjectPool().default)(function() {
	return new DatePickerEvent(null,null);
},function(event) {
	event.target = null;
	event.currentTarget = null;
	event.__preventDefault = false;
	event.__isCanceled = false;
	event.__isCanceledNow = false;
	return event.state = null;
})

// Export

exports["default"] = DatePickerEvent;

/***/ }),

/***/ "./lib/_gen/feathers/events/FeathersEvent.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/events/FeathersEvent.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.events.FeathersEvent

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_events_Event() {return (__webpack_require__(/*! openfl */ "openfl").events.Event);}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}

// Constructor

var FeathersEvent = function(type,bubbles,cancelable) {
	if(cancelable == null) {
		cancelable = false;
	}
	if(bubbles == null) {
		bubbles = false;
	}
	(openfl_events_Event()).call(this,type,bubbles,cancelable);
}

// Meta

FeathersEvent.__name__ = "feathers.events.FeathersEvent";
FeathersEvent.__isInterface__ = false;
FeathersEvent.__super__ = (openfl_events_Event());
FeathersEvent.prototype = $extend((openfl_events_Event()).prototype, {
	clone: function() {
		return new FeathersEvent(this.type,this.bubbles,this.cancelable);
	}
});
FeathersEvent.prototype.__class__ = FeathersEvent.prototype.constructor = $hxClasses["feathers.events.FeathersEvent"] = FeathersEvent;

// Init



// Statics

FeathersEvent.dispatch = function(dispatcher,type,bubbles,cancelable) {
	if(cancelable == null) {
		cancelable = false;
	}
	if(bubbles == null) {
		bubbles = false;
	}
	var event = FeathersEvent._pool.get();
	event.type = type;
	event.bubbles = bubbles;
	event.cancelable = cancelable;
	var result = dispatcher.dispatchEvent(event);
	FeathersEvent._pool.release(event);
	return result;
}
FeathersEvent.INITIALIZE = "initialize"
FeathersEvent.CREATION_COMPLETE = "creationComplete"
FeathersEvent.LAYOUT_DATA_CHANGE = "layoutDataChange"
FeathersEvent.STATE_CHANGE = "stateChange"
FeathersEvent.OPENING = "opening"
FeathersEvent.CLOSING = "closing"
FeathersEvent.ENABLE = "enable"
FeathersEvent.DISABLE = "disable"
FeathersEvent._pool = new (lime_utils_ObjectPool().default)(function() {
	return new FeathersEvent(null,false,false);
},function(event) {
	event.target = null;
	event.currentTarget = null;
	event.__preventDefault = false;
	event.__isCanceled = false;
	return event.__isCanceledNow = false;
})

// Export

exports["default"] = FeathersEvent;

/***/ }),

/***/ "./lib/_gen/feathers/events/FlatCollectionEvent.js":
/*!*********************************************************!*\
  !*** ./lib/_gen/feathers/events/FlatCollectionEvent.js ***!
  \*********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.events.FlatCollectionEvent

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_events_Event() {return (__webpack_require__(/*! openfl */ "openfl").events.Event);}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}

// Constructor

var FlatCollectionEvent = function(type,index,addedItem,removedItem,bubbles,cancelable) {
	if(cancelable == null) {
		cancelable = false;
	}
	if(bubbles == null) {
		bubbles = false;
	}
	(openfl_events_Event()).call(this,type,bubbles,cancelable);
	this.index = index;
	this.addedItem = addedItem;
	this.removedItem = removedItem;
}

// Meta

FlatCollectionEvent.__name__ = "feathers.events.FlatCollectionEvent";
FlatCollectionEvent.__isInterface__ = false;
FlatCollectionEvent.__super__ = (openfl_events_Event());
FlatCollectionEvent.prototype = $extend((openfl_events_Event()).prototype, {
	clone: function() {
		return new FlatCollectionEvent(this.type,this.index,this.addedItem,this.removedItem,this.bubbles,this.cancelable);
	}
});
FlatCollectionEvent.prototype.__class__ = FlatCollectionEvent.prototype.constructor = $hxClasses["feathers.events.FlatCollectionEvent"] = FlatCollectionEvent;

// Init



// Statics

FlatCollectionEvent.dispatch = function(dispatcher,type,index,addedItem,removedItem,bubbles,cancelable) {
	if(cancelable == null) {
		cancelable = false;
	}
	if(bubbles == null) {
		bubbles = false;
	}
	var event = FlatCollectionEvent._pool.get();
	event.type = type;
	event.index = index;
	event.addedItem = addedItem;
	event.removedItem = removedItem;
	event.bubbles = bubbles;
	event.cancelable = cancelable;
	var result = dispatcher.dispatchEvent(event);
	FlatCollectionEvent._pool.release(event);
	return result;
}
FlatCollectionEvent.ADD_ITEM = "addItem"
FlatCollectionEvent.REMOVE_ITEM = "removeItem"
FlatCollectionEvent.REPLACE_ITEM = "replaceItem"
FlatCollectionEvent.UPDATE_ITEM = "updateItem"
FlatCollectionEvent.UPDATE_ALL = "updateAll"
FlatCollectionEvent.RESET = "reset"
FlatCollectionEvent.REMOVE_ALL = "removeAll"
FlatCollectionEvent.FILTER_CHANGE = "filterChange"
FlatCollectionEvent.SORT_CHANGE = "sortChange"
FlatCollectionEvent._pool = new (lime_utils_ObjectPool().default)(function() {
	return new FlatCollectionEvent(null,-1,false,false);
},function(event) {
	event.target = null;
	event.currentTarget = null;
	event.__preventDefault = false;
	event.__isCanceled = false;
	event.__isCanceledNow = false;
	event.addedItem = null;
	event.removedItem = null;
	return;
})

// Export

exports["default"] = FlatCollectionEvent;

/***/ }),

/***/ "./lib/_gen/feathers/events/FormEvent.js":
/*!***********************************************!*\
  !*** ./lib/_gen/feathers/events/FormEvent.js ***!
  \***********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.events.FormEvent

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_events_Event() {return (__webpack_require__(/*! openfl */ "openfl").events.Event);}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}

// Constructor

var FormEvent = function(type) {
	(openfl_events_Event()).call(this,type,false,false);
}

// Meta

FormEvent.__name__ = "feathers.events.FormEvent";
FormEvent.__isInterface__ = false;
FormEvent.__super__ = (openfl_events_Event());
FormEvent.prototype = $extend((openfl_events_Event()).prototype, {
	clone: function() {
		return new FormEvent(this.type);
	}
});
FormEvent.prototype.__class__ = FormEvent.prototype.constructor = $hxClasses["feathers.events.FormEvent"] = FormEvent;

// Init



// Statics

FormEvent.dispatch = function(dispatcher,type) {
	var event = FormEvent._pool.get();
	event.type = type;
	var result = dispatcher.dispatchEvent(event);
	FormEvent._pool.release(event);
	return result;
}
FormEvent.SUBMIT = "submit"
FormEvent._pool = new (lime_utils_ObjectPool().default)(function() {
	return new FormEvent(null);
},function(event) {
	event.target = null;
	event.currentTarget = null;
	event.__preventDefault = false;
	event.__isCanceled = false;
	return event.__isCanceledNow = false;
})

// Export

exports["default"] = FormEvent;

/***/ }),

/***/ "./lib/_gen/feathers/events/GridViewEvent.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/events/GridViewEvent.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.events.GridViewEvent

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_events_Event() {return (__webpack_require__(/*! openfl */ "openfl").events.Event);}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}

// Constructor

var GridViewEvent = function(type,state) {
	(openfl_events_Event()).call(this,type,false,false);
	this.state = state;
}

// Meta

GridViewEvent.__name__ = "feathers.events.GridViewEvent";
GridViewEvent.__isInterface__ = false;
GridViewEvent.__super__ = (openfl_events_Event());
GridViewEvent.prototype = $extend((openfl_events_Event()).prototype, {
	clone: function() {
		return new GridViewEvent(this.type,this.state);
	}
});
GridViewEvent.prototype.__class__ = GridViewEvent.prototype.constructor = $hxClasses["feathers.events.GridViewEvent"] = GridViewEvent;

// Init



// Statics

GridViewEvent.dispatchForCell = function(dispatcher,type,state) {
	var event = GridViewEvent._cellPool.get();
	event.type = type;
	event.state = state;
	var result = dispatcher.dispatchEvent(event);
	GridViewEvent._cellPool.release(event);
	return result;
}
GridViewEvent.dispatchForHeader = function(dispatcher,type,state) {
	var event = GridViewEvent._headerPool.get();
	event.type = type;
	event.state = state;
	var result = dispatcher.dispatchEvent(event);
	GridViewEvent._headerPool.release(event);
	return result;
}
GridViewEvent.CELL_TRIGGER = "cellTrigger"
GridViewEvent.HEADER_TRIGGER = "headerTrigger"
GridViewEvent._cellPool = new (lime_utils_ObjectPool().default)(function() {
	return new GridViewEvent(null,null);
},function(event) {
	event.target = null;
	event.currentTarget = null;
	event.__preventDefault = false;
	event.__isCanceled = false;
	event.__isCanceledNow = false;
	return event.state = null;
})
GridViewEvent._headerPool = new (lime_utils_ObjectPool().default)(function() {
	return new GridViewEvent(null,null);
},function(event) {
	event.target = null;
	event.currentTarget = null;
	event.__preventDefault = false;
	event.__isCanceled = false;
	event.__isCanceledNow = false;
	return event.state = null;
})

// Export

exports["default"] = GridViewEvent;

/***/ }),

/***/ "./lib/_gen/feathers/events/GroupListViewEvent.js":
/*!********************************************************!*\
  !*** ./lib/_gen/feathers/events/GroupListViewEvent.js ***!
  \********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.events.GroupListViewEvent

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_events_Event() {return (__webpack_require__(/*! openfl */ "openfl").events.Event);}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}

// Constructor

var GroupListViewEvent = function(type,state) {
	(openfl_events_Event()).call(this,type,false,false);
	this.state = state;
}

// Meta

GroupListViewEvent.__name__ = "feathers.events.GroupListViewEvent";
GroupListViewEvent.__isInterface__ = false;
GroupListViewEvent.__super__ = (openfl_events_Event());
GroupListViewEvent.prototype = $extend((openfl_events_Event()).prototype, {
	clone: function() {
		return new GroupListViewEvent(this.type,this.state);
	}
});
GroupListViewEvent.prototype.__class__ = GroupListViewEvent.prototype.constructor = $hxClasses["feathers.events.GroupListViewEvent"] = GroupListViewEvent;

// Init



// Statics

GroupListViewEvent.dispatch = function(dispatcher,type,state) {
	var event = GroupListViewEvent._pool.get();
	event.type = type;
	event.state = state;
	var result = dispatcher.dispatchEvent(event);
	GroupListViewEvent._pool.release(event);
	return result;
}
GroupListViewEvent.ITEM_TRIGGER = "itemTrigger"
GroupListViewEvent._pool = new (lime_utils_ObjectPool().default)(function() {
	return new GroupListViewEvent(null,null);
},function(event) {
	event.target = null;
	event.currentTarget = null;
	event.__preventDefault = false;
	event.__isCanceled = false;
	event.__isCanceledNow = false;
	return event.state = null;
})

// Export

exports["default"] = GroupListViewEvent;

/***/ }),

/***/ "./lib/_gen/feathers/events/HierarchicalCollectionEvent.js":
/*!*****************************************************************!*\
  !*** ./lib/_gen/feathers/events/HierarchicalCollectionEvent.js ***!
  \*****************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.events.HierarchicalCollectionEvent

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_events_Event() {return (__webpack_require__(/*! openfl */ "openfl").events.Event);}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}

// Constructor

var HierarchicalCollectionEvent = function(type,location,addedItem,removedItem,bubbles,cancelable) {
	if(cancelable == null) {
		cancelable = false;
	}
	if(bubbles == null) {
		bubbles = false;
	}
	(openfl_events_Event()).call(this,type,bubbles,cancelable);
	this.location = location;
	this.addedItem = addedItem;
	this.removedItem = removedItem;
}

// Meta

HierarchicalCollectionEvent.__name__ = "feathers.events.HierarchicalCollectionEvent";
HierarchicalCollectionEvent.__isInterface__ = false;
HierarchicalCollectionEvent.__super__ = (openfl_events_Event());
HierarchicalCollectionEvent.prototype = $extend((openfl_events_Event()).prototype, {
	clone: function() {
		return new HierarchicalCollectionEvent(this.type,this.location,this.addedItem,this.removedItem,this.bubbles,this.cancelable);
	}
});
HierarchicalCollectionEvent.prototype.__class__ = HierarchicalCollectionEvent.prototype.constructor = $hxClasses["feathers.events.HierarchicalCollectionEvent"] = HierarchicalCollectionEvent;

// Init



// Statics

HierarchicalCollectionEvent.dispatch = function(dispatcher,type,location,addedItem,removedItem,bubbles,cancelable) {
	if(cancelable == null) {
		cancelable = false;
	}
	if(bubbles == null) {
		bubbles = false;
	}
	var event = HierarchicalCollectionEvent._pool.get();
	event.type = type;
	event.location = location;
	event.addedItem = addedItem;
	event.removedItem = removedItem;
	event.bubbles = bubbles;
	event.cancelable = cancelable;
	var result = dispatcher.dispatchEvent(event);
	HierarchicalCollectionEvent._pool.release(event);
	return result;
}
HierarchicalCollectionEvent.ADD_ITEM = "addItem"
HierarchicalCollectionEvent.REMOVE_ITEM = "removeItem"
HierarchicalCollectionEvent.REPLACE_ITEM = "replaceItem"
HierarchicalCollectionEvent.UPDATE_ITEM = "updateItem"
HierarchicalCollectionEvent.UPDATE_ALL = "updateAll"
HierarchicalCollectionEvent.RESET = "reset"
HierarchicalCollectionEvent.REMOVE_ALL = "removeAll"
HierarchicalCollectionEvent.FILTER_CHANGE = "filterChange"
HierarchicalCollectionEvent.SORT_CHANGE = "sortChange"
HierarchicalCollectionEvent._pool = new (lime_utils_ObjectPool().default)(function() {
	return new HierarchicalCollectionEvent(null,null,false,false);
},function(event) {
	event.target = null;
	event.currentTarget = null;
	event.__preventDefault = false;
	event.__isCanceled = false;
	event.__isCanceledNow = false;
	event.addedItem = null;
	event.removedItem = null;
	return event.location = null;
})

// Export

exports["default"] = HierarchicalCollectionEvent;

/***/ }),

/***/ "./lib/_gen/feathers/events/ListViewEvent.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/events/ListViewEvent.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.events.ListViewEvent

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_events_Event() {return (__webpack_require__(/*! openfl */ "openfl").events.Event);}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}

// Constructor

var ListViewEvent = function(type,state) {
	(openfl_events_Event()).call(this,type,false,false);
	this.state = state;
}

// Meta

ListViewEvent.__name__ = "feathers.events.ListViewEvent";
ListViewEvent.__isInterface__ = false;
ListViewEvent.__super__ = (openfl_events_Event());
ListViewEvent.prototype = $extend((openfl_events_Event()).prototype, {
	clone: function() {
		return new ListViewEvent(this.type,this.state);
	}
});
ListViewEvent.prototype.__class__ = ListViewEvent.prototype.constructor = $hxClasses["feathers.events.ListViewEvent"] = ListViewEvent;

// Init



// Statics

ListViewEvent.dispatch = function(dispatcher,type,state) {
	var event = ListViewEvent._pool.get();
	event.type = type;
	event.state = state;
	var result = dispatcher.dispatchEvent(event);
	ListViewEvent._pool.release(event);
	return result;
}
ListViewEvent.ITEM_TRIGGER = "itemTrigger"
ListViewEvent._pool = new (lime_utils_ObjectPool().default)(function() {
	return new ListViewEvent(null,null);
},function(event) {
	event.target = null;
	event.currentTarget = null;
	event.__preventDefault = false;
	event.__isCanceled = false;
	event.__isCanceledNow = false;
	return event.state = null;
})

// Export

exports["default"] = ListViewEvent;

/***/ }),

/***/ "./lib/_gen/feathers/events/LongPressEvent.js":
/*!****************************************************!*\
  !*** ./lib/_gen/feathers/events/LongPressEvent.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.events.LongPressEvent

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_events_Event() {return (__webpack_require__(/*! openfl */ "openfl").events.Event);}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function Reflect() {return __webpack_require__(/*! ./../../Reflect */ "./lib/_gen/Reflect.js");}

// Constructor

var LongPressEvent = function(type,bubbles,cancelable,touchPointID,isPrimaryTouchPoint,localX,localY,sizeX,sizeY,pressure,relatedObject,ctrlKey,altKey,shiftKey,commandKey) {
	if(commandKey == null) {
		commandKey = false;
	}
	if(shiftKey == null) {
		shiftKey = false;
	}
	if(altKey == null) {
		altKey = false;
	}
	if(ctrlKey == null) {
		ctrlKey = false;
	}
	if(pressure == null) {
		pressure = 1.0;
	}
	if(sizeY == null) {
		sizeY = 0.0;
	}
	if(sizeX == null) {
		sizeX = 0.0;
	}
	if(localY == null) {
		localY = 0.0;
	}
	if(localX == null) {
		localX = 0.0;
	}
	if(isPrimaryTouchPoint == null) {
		isPrimaryTouchPoint = false;
	}
	if(touchPointID == null) {
		touchPointID = 0;
	}
	if(cancelable == null) {
		cancelable = false;
	}
	if(bubbles == null) {
		bubbles = false;
	}
	(openfl_events_Event()).call(this,type,bubbles,cancelable);
	this.touchPointID = touchPointID;
	this.isPrimaryTouchPoint = isPrimaryTouchPoint;
	this.localX = localX;
	this.localY = localY;
	this.stageX = NaN;
	this.stageY = NaN;
	this.sizeX = sizeX;
	this.sizeY = sizeY;
	this.pressure = pressure;
	this.relatedObject = relatedObject;
	this.ctrlKey = ctrlKey;
	this.altKey = altKey;
	this.shiftKey = shiftKey;
	this.commandKey = commandKey;
}

// Meta

LongPressEvent.__name__ = "feathers.events.LongPressEvent";
LongPressEvent.__isInterface__ = false;
LongPressEvent.__super__ = (openfl_events_Event());
LongPressEvent.prototype = $extend((openfl_events_Event()).prototype, {
	clone: function() {
		var result = new LongPressEvent(this.type,this.bubbles,this.cancelable,this.touchPointID,this.isPrimaryTouchPoint,this.localX,this.localY,this.sizeX,this.sizeY,this.pressure,this.relatedObject,this.ctrlKey,this.altKey,this.shiftKey,this.commandKey);
		result.stageX = this.stageX;
		result.stageY = this.stageY;
		return result;
	}
});
LongPressEvent.prototype.__class__ = LongPressEvent.prototype.constructor = $hxClasses["feathers.events.LongPressEvent"] = LongPressEvent;

// Init



// Statics

LongPressEvent.dispatchFromMouseEvent = function(dispatcher,mouseEvent) {
	var event = LongPressEvent._pool.get();
	event = LongPressEvent.fromMouseEvent(mouseEvent,event);
	var result = dispatcher.dispatchEvent(event);
	LongPressEvent._pool.release(event);
	return result;
}
LongPressEvent.dispatchFromTouchEvent = function(dispatcher,touchEvent) {
	var event = LongPressEvent._pool.get();
	event = LongPressEvent.fromTouchEvent(touchEvent,event);
	var result = dispatcher.dispatchEvent(event);
	LongPressEvent._pool.release(event);
	return result;
}
LongPressEvent.fromMouseEvent = function(event,existing) {
	if(event.type != "mouseDown") {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("LongPressEvent.fromMouseEvent() requires MouseEvent.MOUSE_DOWN"));
	}
	if(existing != null) {
		existing.type = "longPress";
		existing.bubbles = false;
		existing.cancelable = event.cancelable;
		existing.touchPointID = -1;
		existing.isPrimaryTouchPoint = false;
		existing.localX = event.localX;
		existing.localY = event.localY;
		existing.stageX = event.stageX;
		existing.stageY = event.stageY;
		existing.sizeX = 0.0;
		existing.sizeY = 0.0;
		existing.pressure = 1.0;
		existing.relatedObject = event.relatedObject;
		existing.ctrlKey = event.ctrlKey;
		existing.altKey = event.altKey;
		existing.shiftKey = event.shiftKey;
		existing.commandKey = event.commandKey;
		return existing;
	}
	var result = new LongPressEvent("longPress",event.bubbles,event.cancelable,-1,false,event.localX,event.localY,0.0,0.0,1.0,event.relatedObject,event.ctrlKey,event.altKey,event.shiftKey,(Reflect().default).hasField(event,"commandKey") && (Reflect().default).field(event,"commandKey"));
	result.stageX = event.stageX;
	result.stageY = event.stageY;
	return result;
}
LongPressEvent.fromTouchEvent = function(event,existing) {
	if(event.type != "touchBegin") {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("LongPressEvent.fromTouchEvent() requires TouchEvent.TOUCH_BEGIN"));
	}
	if(existing != null) {
		existing.type = "longPress";
		existing.bubbles = false;
		existing.cancelable = event.cancelable;
		existing.touchPointID = event.touchPointID;
		existing.isPrimaryTouchPoint = event.isPrimaryTouchPoint;
		existing.localX = event.localX;
		existing.localY = event.localY;
		existing.stageX = event.stageX;
		existing.stageY = event.stageY;
		existing.sizeX = event.sizeX;
		existing.sizeY = event.sizeY;
		existing.pressure = event.pressure;
		existing.relatedObject = event.relatedObject;
		existing.ctrlKey = event.ctrlKey;
		existing.altKey = event.altKey;
		existing.shiftKey = event.shiftKey;
		existing.commandKey = event.commandKey;
		return existing;
	}
	var result = new LongPressEvent("longPress",event.bubbles,event.cancelable,event.touchPointID,event.isPrimaryTouchPoint,event.localX,event.localY,event.sizeX,event.sizeY,event.pressure,event.relatedObject,event.ctrlKey,event.altKey,event.shiftKey,(Reflect().default).hasField(event,"commandKey") && (Reflect().default).field(event,"commandKey"));
	result.stageX = event.stageX;
	result.stageY = event.stageY;
	return result;
}
LongPressEvent.LONG_PRESS = "longPress"
LongPressEvent._pool = new (lime_utils_ObjectPool().default)(function() {
	return new LongPressEvent(null);
},function(event) {
	event.target = null;
	event.currentTarget = null;
	event.__preventDefault = false;
	event.__isCanceled = false;
	event.__isCanceledNow = false;
	return event.relatedObject = null;
})

// Export

exports["default"] = LongPressEvent;

/***/ }),

/***/ "./lib/_gen/feathers/events/ScrollEvent.js":
/*!*************************************************!*\
  !*** ./lib/_gen/feathers/events/ScrollEvent.js ***!
  \*************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.events.ScrollEvent

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_events_Event() {return (__webpack_require__(/*! openfl */ "openfl").events.Event);}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}

// Constructor

var ScrollEvent = function(type,bubbles,cancelable,x,y) {
	if(y == null) {
		y = 0.0;
	}
	if(x == null) {
		x = 0.0;
	}
	if(cancelable == null) {
		cancelable = false;
	}
	if(bubbles == null) {
		bubbles = false;
	}
	(openfl_events_Event()).call(this,type,bubbles,cancelable);
	this.x = x;
	this.y = y;
}

// Meta

ScrollEvent.__name__ = "feathers.events.ScrollEvent";
ScrollEvent.__isInterface__ = false;
ScrollEvent.__super__ = (openfl_events_Event());
ScrollEvent.prototype = $extend((openfl_events_Event()).prototype, {
	clone: function() {
		return new ScrollEvent(this.type,this.bubbles,this.cancelable,this.x,this.y);
	}
});
ScrollEvent.prototype.__class__ = ScrollEvent.prototype.constructor = $hxClasses["feathers.events.ScrollEvent"] = ScrollEvent;

// Init



// Statics

ScrollEvent.dispatch = function(dispatcher,type,bubbles,cancelable,x,y) {
	if(y == null) {
		y = 0.0;
	}
	if(x == null) {
		x = 0.0;
	}
	if(cancelable == null) {
		cancelable = false;
	}
	if(bubbles == null) {
		bubbles = false;
	}
	var event = ScrollEvent._pool.get();
	event.type = type;
	event.bubbles = bubbles;
	event.cancelable = cancelable;
	event.x = x;
	event.y = y;
	var result = dispatcher.dispatchEvent(event);
	ScrollEvent._pool.release(event);
	return result;
}
ScrollEvent.SCROLL_START = "scrollStart"
ScrollEvent.SCROLL_COMPLETE = "scrollComplete"
ScrollEvent.SCROLL = "scroll"
ScrollEvent._pool = new (lime_utils_ObjectPool().default)(function() {
	return new ScrollEvent(null,false,false);
},function(event) {
	event.target = null;
	event.currentTarget = null;
	event.__preventDefault = false;
	event.__isCanceled = false;
	return event.__isCanceledNow = false;
})

// Export

exports["default"] = ScrollEvent;

/***/ }),

/***/ "./lib/_gen/feathers/events/StyleProviderEvent.js":
/*!********************************************************!*\
  !*** ./lib/_gen/feathers/events/StyleProviderEvent.js ***!
  \********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.events.StyleProviderEvent

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_events_Event() {return (__webpack_require__(/*! openfl */ "openfl").events.Event);}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}

// Constructor

var StyleProviderEvent = function(type,affectsTarget) {
	(openfl_events_Event()).call(this,type);
	this.affectsTarget = affectsTarget != null ? affectsTarget : StyleProviderEvent.defaultAffectsTarget;
}

// Meta

StyleProviderEvent.__name__ = "feathers.events.StyleProviderEvent";
StyleProviderEvent.__isInterface__ = false;
StyleProviderEvent.__super__ = (openfl_events_Event());
StyleProviderEvent.prototype = $extend((openfl_events_Event()).prototype, {
	clone: function() {
		return new StyleProviderEvent(this.type,this.affectsTarget);
	}
});
StyleProviderEvent.prototype.__class__ = StyleProviderEvent.prototype.constructor = $hxClasses["feathers.events.StyleProviderEvent"] = StyleProviderEvent;

// Init



// Statics

StyleProviderEvent.dispatch = function(dispatcher,type,affectsTarget) {
	var event = StyleProviderEvent._pool.get();
	event.type = type;
	event.affectsTarget = affectsTarget != null ? affectsTarget : StyleProviderEvent.defaultAffectsTarget;
	var result = dispatcher.dispatchEvent(event);
	StyleProviderEvent._pool.release(event);
	return result;
}
StyleProviderEvent.defaultAffectsTarget = function(value) {
	return true;
}
StyleProviderEvent.STYLES_CHANGE = "stylesChange"
StyleProviderEvent._pool = new (lime_utils_ObjectPool().default)(function() {
	return new StyleProviderEvent(null,null);
},function(event) {
	event.target = null;
	event.currentTarget = null;
	event.__preventDefault = false;
	event.__isCanceled = false;
	event.__isCanceledNow = false;
	return event.affectsTarget = null;
})

// Export

exports["default"] = StyleProviderEvent;

/***/ }),

/***/ "./lib/_gen/feathers/events/TabBarEvent.js":
/*!*************************************************!*\
  !*** ./lib/_gen/feathers/events/TabBarEvent.js ***!
  \*************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.events.TabBarEvent

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_events_Event() {return (__webpack_require__(/*! openfl */ "openfl").events.Event);}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}

// Constructor

var TabBarEvent = function(type,state) {
	(openfl_events_Event()).call(this,type,false,false);
	this.state = state;
}

// Meta

TabBarEvent.__name__ = "feathers.events.TabBarEvent";
TabBarEvent.__isInterface__ = false;
TabBarEvent.__super__ = (openfl_events_Event());
TabBarEvent.prototype = $extend((openfl_events_Event()).prototype, {
	clone: function() {
		return new TabBarEvent(this.type,this.state);
	}
});
TabBarEvent.prototype.__class__ = TabBarEvent.prototype.constructor = $hxClasses["feathers.events.TabBarEvent"] = TabBarEvent;

// Init



// Statics

TabBarEvent.dispatch = function(dispatcher,type,state) {
	var event = TabBarEvent._pool.get();
	event.type = type;
	event.state = state;
	var result = dispatcher.dispatchEvent(event);
	TabBarEvent._pool.release(event);
	return result;
}
TabBarEvent.ITEM_TRIGGER = "itemTrigger"
TabBarEvent._pool = new (lime_utils_ObjectPool().default)(function() {
	return new TabBarEvent(null,null);
},function(event) {
	event.target = null;
	event.currentTarget = null;
	event.__preventDefault = false;
	event.__isCanceled = false;
	event.__isCanceledNow = false;
	return event.state = null;
})

// Export

exports["default"] = TabBarEvent;

/***/ }),

/***/ "./lib/_gen/feathers/events/TransitionEvent.js":
/*!*****************************************************!*\
  !*** ./lib/_gen/feathers/events/TransitionEvent.js ***!
  \*****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.events.TransitionEvent

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_events_Event() {return (__webpack_require__(/*! openfl */ "openfl").events.Event);}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}

// Constructor

var TransitionEvent = function(type,previousViewID,previousView,nextViewID,nextView) {
	(openfl_events_Event()).call(this,type,false,false);
	this.previousViewID = previousViewID;
	this.previousView = previousView;
	this.nextViewID = nextViewID;
	this.nextView = nextView;
}

// Meta

TransitionEvent.__name__ = "feathers.events.TransitionEvent";
TransitionEvent.__isInterface__ = false;
TransitionEvent.__super__ = (openfl_events_Event());
TransitionEvent.prototype = $extend((openfl_events_Event()).prototype, {
	clone: function() {
		return new TransitionEvent(this.type,this.previousViewID,this.previousView,this.nextViewID,this.nextView);
	}
});
TransitionEvent.prototype.__class__ = TransitionEvent.prototype.constructor = $hxClasses["feathers.events.TransitionEvent"] = TransitionEvent;

// Init



// Statics

TransitionEvent.dispatch = function(dispatcher,type,previousViewID,previousView,nextViewID,nextView) {
	var event = TransitionEvent._pool.get();
	event.type = type;
	event.bubbles = false;
	event.cancelable = false;
	event.previousViewID = previousViewID;
	event.previousView = previousView;
	event.nextViewID = nextViewID;
	event.nextView = nextView;
	var result = dispatcher.dispatchEvent(event);
	TransitionEvent._pool.release(event);
	return result;
}
TransitionEvent.TRANSITION_START = "transitionStart"
TransitionEvent.TRANSITION_COMPLETE = "transitionComplete"
TransitionEvent.TRANSITION_CANCEL = "transitionCancel"
TransitionEvent._pool = new (lime_utils_ObjectPool().default)(function() {
	return new TransitionEvent(null,null,null,null,null);
},function(event) {
	event.previousViewID = null;
	event.previousView = null;
	event.nextViewID = null;
	event.nextView = null;
	event.target = null;
	event.currentTarget = null;
	event.__preventDefault = false;
	event.__isCanceled = false;
	return event.__isCanceledNow = false;
})

// Export

exports["default"] = TransitionEvent;

/***/ }),

/***/ "./lib/_gen/feathers/events/TreeGridViewEvent.js":
/*!*******************************************************!*\
  !*** ./lib/_gen/feathers/events/TreeGridViewEvent.js ***!
  \*******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.events.TreeGridViewEvent

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_events_Event() {return (__webpack_require__(/*! openfl */ "openfl").events.Event);}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}

// Constructor

var TreeGridViewEvent = function(type,state) {
	(openfl_events_Event()).call(this,type,false,false);
	this.state = state;
}

// Meta

TreeGridViewEvent.__name__ = "feathers.events.TreeGridViewEvent";
TreeGridViewEvent.__isInterface__ = false;
TreeGridViewEvent.__super__ = (openfl_events_Event());
TreeGridViewEvent.prototype = $extend((openfl_events_Event()).prototype, {
	clone: function() {
		return new TreeGridViewEvent(this.type,this.state);
	}
});
TreeGridViewEvent.prototype.__class__ = TreeGridViewEvent.prototype.constructor = $hxClasses["feathers.events.TreeGridViewEvent"] = TreeGridViewEvent;

// Init



// Statics

TreeGridViewEvent.dispatchForCell = function(dispatcher,type,state) {
	var event = TreeGridViewEvent._cellPool.get();
	event.type = type;
	event.state = state;
	var result = dispatcher.dispatchEvent(event);
	TreeGridViewEvent._cellPool.release(event);
	return result;
}
TreeGridViewEvent.dispatchForHeader = function(dispatcher,type,state) {
	var event = TreeGridViewEvent._headerPool.get();
	event.type = type;
	event.state = state;
	var result = dispatcher.dispatchEvent(event);
	TreeGridViewEvent._headerPool.release(event);
	return result;
}
TreeGridViewEvent.CELL_TRIGGER = "cellTrigger"
TreeGridViewEvent.HEADER_TRIGGER = "headerTrigger"
TreeGridViewEvent.BRANCH_OPEN = "branchOpen"
TreeGridViewEvent.BRANCH_CLOSE = "branchClose"
TreeGridViewEvent._cellPool = new (lime_utils_ObjectPool().default)(function() {
	return new TreeGridViewEvent(null,null);
},function(event) {
	event.target = null;
	event.currentTarget = null;
	event.__preventDefault = false;
	event.__isCanceled = false;
	event.__isCanceledNow = false;
	return event.state = null;
})
TreeGridViewEvent._headerPool = new (lime_utils_ObjectPool().default)(function() {
	return new TreeGridViewEvent(null,null);
},function(event) {
	event.target = null;
	event.currentTarget = null;
	event.__preventDefault = false;
	event.__isCanceled = false;
	event.__isCanceledNow = false;
	return event.state = null;
})

// Export

exports["default"] = TreeGridViewEvent;

/***/ }),

/***/ "./lib/_gen/feathers/events/TreeViewEvent.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/events/TreeViewEvent.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.events.TreeViewEvent

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_events_Event() {return (__webpack_require__(/*! openfl */ "openfl").events.Event);}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}

// Constructor

var TreeViewEvent = function(type,state) {
	(openfl_events_Event()).call(this,type,false,false);
	this.state = state;
}

// Meta

TreeViewEvent.__name__ = "feathers.events.TreeViewEvent";
TreeViewEvent.__isInterface__ = false;
TreeViewEvent.__super__ = (openfl_events_Event());
TreeViewEvent.prototype = $extend((openfl_events_Event()).prototype, {
	clone: function() {
		return new TreeViewEvent(this.type,this.state);
	}
});
TreeViewEvent.prototype.__class__ = TreeViewEvent.prototype.constructor = $hxClasses["feathers.events.TreeViewEvent"] = TreeViewEvent;

// Init



// Statics

TreeViewEvent.dispatch = function(dispatcher,type,state) {
	var event = TreeViewEvent._pool.get();
	event.type = type;
	event.state = state;
	var result = dispatcher.dispatchEvent(event);
	TreeViewEvent._pool.release(event);
	return result;
}
TreeViewEvent.ITEM_TRIGGER = "itemTrigger"
TreeViewEvent.BRANCH_OPEN = "branchOpen"
TreeViewEvent.BRANCH_CLOSE = "branchClose"
TreeViewEvent._pool = new (lime_utils_ObjectPool().default)(function() {
	return new TreeViewEvent(null,null);
},function(event) {
	event.target = null;
	event.currentTarget = null;
	event.__preventDefault = false;
	event.__isCanceled = false;
	event.__isCanceledNow = false;
	return event.state = null;
})

// Export

exports["default"] = TreeViewEvent;

/***/ }),

/***/ "./lib/_gen/feathers/events/TriggerEvent.js":
/*!**************************************************!*\
  !*** ./lib/_gen/feathers/events/TriggerEvent.js ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.events.TriggerEvent

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_events_Event() {return (__webpack_require__(/*! openfl */ "openfl").events.Event);}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function Reflect() {return __webpack_require__(/*! ./../../Reflect */ "./lib/_gen/Reflect.js");}

// Constructor

var TriggerEvent = function(type,bubbles,cancelable,touchPointID,isPrimaryTouchPoint,localX,localY,sizeX,sizeY,pressure,relatedObject,ctrlKey,altKey,shiftKey,commandKey) {
	if(commandKey == null) {
		commandKey = false;
	}
	if(shiftKey == null) {
		shiftKey = false;
	}
	if(altKey == null) {
		altKey = false;
	}
	if(ctrlKey == null) {
		ctrlKey = false;
	}
	if(pressure == null) {
		pressure = 1.0;
	}
	if(sizeY == null) {
		sizeY = 0.0;
	}
	if(sizeX == null) {
		sizeX = 0.0;
	}
	if(localY == null) {
		localY = 0.0;
	}
	if(localX == null) {
		localX = 0.0;
	}
	if(isPrimaryTouchPoint == null) {
		isPrimaryTouchPoint = false;
	}
	if(touchPointID == null) {
		touchPointID = 0;
	}
	if(cancelable == null) {
		cancelable = false;
	}
	if(bubbles == null) {
		bubbles = false;
	}
	(openfl_events_Event()).call(this,type,bubbles,cancelable);
	this.touchPointID = touchPointID;
	this.isPrimaryTouchPoint = isPrimaryTouchPoint;
	this.localX = localX;
	this.localY = localY;
	this.stageX = NaN;
	this.stageY = NaN;
	this.sizeX = sizeX;
	this.sizeY = sizeY;
	this.pressure = pressure;
	this.relatedObject = relatedObject;
	this.ctrlKey = ctrlKey;
	this.altKey = altKey;
	this.shiftKey = shiftKey;
	this.commandKey = commandKey;
}

// Meta

TriggerEvent.__name__ = "feathers.events.TriggerEvent";
TriggerEvent.__isInterface__ = false;
TriggerEvent.__super__ = (openfl_events_Event());
TriggerEvent.prototype = $extend((openfl_events_Event()).prototype, {
	clone: function() {
		var result = new TriggerEvent(this.type,this.bubbles,this.cancelable,this.touchPointID,this.isPrimaryTouchPoint,this.localX,this.localY,this.sizeX,this.sizeY,this.pressure,this.relatedObject,this.ctrlKey,this.altKey,this.shiftKey,this.commandKey);
		result.stageX = this.stageX;
		result.stageY = this.stageY;
		return result;
	}
});
TriggerEvent.prototype.__class__ = TriggerEvent.prototype.constructor = $hxClasses["feathers.events.TriggerEvent"] = TriggerEvent;

// Init



// Statics

TriggerEvent.dispatchFromMouseEvent = function(dispatcher,mouseEvent) {
	var event = TriggerEvent._pool.get();
	event = TriggerEvent.fromMouseEvent(mouseEvent,event);
	var result = dispatcher.dispatchEvent(event);
	TriggerEvent._pool.release(event);
	return result;
}
TriggerEvent.dispatchFromTouchEvent = function(dispatcher,touchEvent) {
	var event = TriggerEvent._pool.get();
	event = TriggerEvent.fromTouchEvent(touchEvent,event);
	var result = dispatcher.dispatchEvent(event);
	TriggerEvent._pool.release(event);
	return result;
}
TriggerEvent.fromMouseEvent = function(event,existing) {
	if(event.type != "click") {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("TriggerEvent.fromMouseEvent() requires MouseEvent.CLICK"));
	}
	if(existing != null) {
		existing.type = "trigger";
		existing.bubbles = false;
		existing.cancelable = event.cancelable;
		existing.touchPointID = -1;
		existing.isPrimaryTouchPoint = false;
		existing.localX = event.localX;
		existing.localY = event.localY;
		existing.stageX = event.stageX;
		existing.stageY = event.stageY;
		existing.sizeX = 0.0;
		existing.sizeY = 0.0;
		existing.pressure = 1.0;
		existing.relatedObject = event.relatedObject;
		existing.ctrlKey = event.ctrlKey;
		existing.altKey = event.altKey;
		existing.shiftKey = event.shiftKey;
		existing.commandKey = event.commandKey;
		return existing;
	}
	var result = new TriggerEvent("trigger",false,event.cancelable,-1,false,event.localX,event.localY,0.0,0.0,1.0,event.relatedObject,event.ctrlKey,event.altKey,event.shiftKey,(Reflect().default).hasField(event,"commandKey") && (Reflect().default).field(event,"commandKey"));
	result.stageX = event.stageX;
	result.stageY = event.stageY;
	return result;
}
TriggerEvent.fromTouchEvent = function(event,existing) {
	if(event.type != "touchTap") {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("TriggerEvent.fromTouchEvent() requires TouchEvent.TOUCH_TAP"));
	}
	if(existing != null) {
		existing.type = "trigger";
		existing.bubbles = false;
		existing.cancelable = event.cancelable;
		existing.touchPointID = event.touchPointID;
		existing.isPrimaryTouchPoint = event.isPrimaryTouchPoint;
		existing.localX = event.localX;
		existing.localY = event.localY;
		existing.stageX = event.stageX;
		existing.stageY = event.stageY;
		existing.sizeX = event.sizeX;
		existing.sizeY = event.sizeY;
		existing.pressure = event.pressure;
		existing.relatedObject = event.relatedObject;
		existing.ctrlKey = event.ctrlKey;
		existing.altKey = event.altKey;
		existing.shiftKey = event.shiftKey;
		existing.commandKey = event.commandKey;
		return existing;
	}
	var result = new TriggerEvent("trigger",false,event.cancelable,event.touchPointID,event.isPrimaryTouchPoint,event.localX,event.localY,event.sizeX,event.sizeY,event.pressure,event.relatedObject,event.ctrlKey,event.altKey,event.shiftKey,(Reflect().default).hasField(event,"commandKey") && (Reflect().default).field(event,"commandKey"));
	result.stageX = event.stageX;
	result.stageY = event.stageY;
	return result;
}
TriggerEvent.TRIGGER = "trigger"
TriggerEvent._pool = new (lime_utils_ObjectPool().default)(function() {
	return new TriggerEvent(null);
},function(event) {
	event.target = null;
	event.currentTarget = null;
	event.__preventDefault = false;
	event.__isCanceled = false;
	event.__isCanceledNow = false;
	return event.relatedObject = null;
})

// Export

exports["default"] = TriggerEvent;

/***/ }),

/***/ "./lib/_gen/feathers/graphics/FillStyle.js":
/*!*************************************************!*\
  !*** ./lib/_gen/feathers/graphics/FillStyle.js ***!
  \*************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.graphics.FillStyle

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var FillStyle = $hxEnums["feathers.graphics.FillStyle"] = { __ename__ : "feathers.graphics.FillStyle", __constructs__ : ["SolidColor","Bitmap","Gradient","None"]
  ,SolidColor: ($_=function(color,alpha) { return {_hx_index:0,color:color,alpha:alpha,__enum__:"feathers.graphics.FillStyle",toString:$estr}; },$_.__params__ = ["color","alpha"],$_)
  ,None: {_hx_index:3,__enum__:"feathers.graphics.FillStyle",toString:$estr}
  ,Gradient: ($_=function(type,colors,alphas,ratios,matrix,spreadMethod,interpolationMethod,focalPointRatio) { return {_hx_index:2,type:type,colors:colors,alphas:alphas,ratios:ratios,matrix:matrix,spreadMethod:spreadMethod,interpolationMethod:interpolationMethod,focalPointRatio:focalPointRatio,__enum__:"feathers.graphics.FillStyle",toString:$estr}; },$_.__params__ = ["type","colors","alphas","ratios","matrix","spreadMethod","interpolationMethod","focalPointRatio"],$_)
  ,Bitmap: ($_=function(bitmapData,matrix,repeat,smoothing) { return {_hx_index:1,bitmapData:bitmapData,matrix:matrix,repeat:repeat,smoothing:smoothing,__enum__:"feathers.graphics.FillStyle",toString:$estr}; },$_.__params__ = ["bitmapData","matrix","repeat","smoothing"],$_)
};

exports["default"] = FillStyle;

/***/ }),

/***/ "./lib/_gen/feathers/graphics/GradientBoxTransform.js":
/*!************************************************************!*\
  !*** ./lib/_gen/feathers/graphics/GradientBoxTransform.js ***!
  \************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.graphics.GradientBoxTransform

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var GradientBoxTransform = $hxEnums["feathers.graphics.GradientBoxTransform"] = { __ename__ : "feathers.graphics.GradientBoxTransform", __constructs__ : ["RotateRadians","RotateDegrees","Translate","RotateRadiansAndTranslate","RotateDegreesAndTranslate"]
  ,Translate: ($_=function(tx,ty) { return {_hx_index:2,tx:tx,ty:ty,__enum__:"feathers.graphics.GradientBoxTransform",toString:$estr}; },$_.__params__ = ["tx","ty"],$_)
  ,RotateRadiansAndTranslate: ($_=function(rotation,tx,ty) { return {_hx_index:3,rotation:rotation,tx:tx,ty:ty,__enum__:"feathers.graphics.GradientBoxTransform",toString:$estr}; },$_.__params__ = ["rotation","tx","ty"],$_)
  ,RotateRadians: ($_=function(rotation) { return {_hx_index:0,rotation:rotation,__enum__:"feathers.graphics.GradientBoxTransform",toString:$estr}; },$_.__params__ = ["rotation"],$_)
  ,RotateDegreesAndTranslate: ($_=function(rotation,tx,ty) { return {_hx_index:4,rotation:rotation,tx:tx,ty:ty,__enum__:"feathers.graphics.GradientBoxTransform",toString:$estr}; },$_.__params__ = ["rotation","tx","ty"],$_)
  ,RotateDegrees: ($_=function(rotation) { return {_hx_index:1,rotation:rotation,__enum__:"feathers.graphics.GradientBoxTransform",toString:$estr}; },$_.__params__ = ["rotation"],$_)
};

exports["default"] = GradientBoxTransform;

/***/ }),

/***/ "./lib/_gen/feathers/graphics/LineStyle.js":
/*!*************************************************!*\
  !*** ./lib/_gen/feathers/graphics/LineStyle.js ***!
  \*************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.graphics.LineStyle

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var LineStyle = $hxEnums["feathers.graphics.LineStyle"] = { __ename__ : "feathers.graphics.LineStyle", __constructs__ : ["SolidColor","Bitmap","Gradient","None"]
  ,SolidColor: ($_=function(thickness,color,alpha,pixelHinting,scaleMode,caps,joints,miterLimit) { return {_hx_index:0,thickness:thickness,color:color,alpha:alpha,pixelHinting:pixelHinting,scaleMode:scaleMode,caps:caps,joints:joints,miterLimit:miterLimit,__enum__:"feathers.graphics.LineStyle",toString:$estr}; },$_.__params__ = ["thickness","color","alpha","pixelHinting","scaleMode","caps","joints","miterLimit"],$_)
  ,None: {_hx_index:3,__enum__:"feathers.graphics.LineStyle",toString:$estr}
  ,Gradient: ($_=function(thickness,type,colors,alphas,ratios,matrix,spreadMethod,interpolationMethod,focalPointRatio) { return {_hx_index:2,thickness:thickness,type:type,colors:colors,alphas:alphas,ratios:ratios,matrix:matrix,spreadMethod:spreadMethod,interpolationMethod:interpolationMethod,focalPointRatio:focalPointRatio,__enum__:"feathers.graphics.LineStyle",toString:$estr}; },$_.__params__ = ["thickness","type","colors","alphas","ratios","matrix","spreadMethod","interpolationMethod","focalPointRatio"],$_)
  ,Bitmap: ($_=function(thickness,bitmapData,matrix,repeat,smooth) { return {_hx_index:1,thickness:thickness,bitmapData:bitmapData,matrix:matrix,repeat:repeat,smooth:smooth,__enum__:"feathers.graphics.LineStyle",toString:$estr}; },$_.__params__ = ["thickness","bitmapData","matrix","repeat","smooth"],$_)
};

exports["default"] = LineStyle;

/***/ }),

/***/ "./lib/_gen/feathers/graphics/_CreateGradientBoxMatrix/CreateGradientBoxMatrix_Impl_.js":
/*!**********************************************************************************************!*\
  !*** ./lib/_gen/feathers/graphics/_CreateGradientBoxMatrix/CreateGradientBoxMatrix_Impl_.js ***!
  \**********************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.graphics._CreateGradientBoxMatrix.CreateGradientBoxMatrix_Impl_

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function openfl_geom_Matrix() {return __webpack_require__(/*! ./../../../openfl/geom/Matrix */ "./lib/_gen/openfl/geom/Matrix.js");}

// Constructor

var CreateGradientBoxMatrix_Impl_ = function(){}

// Meta

CreateGradientBoxMatrix_Impl_.__name__ = "feathers.graphics._CreateGradientBoxMatrix.CreateGradientBoxMatrix_Impl_";
CreateGradientBoxMatrix_Impl_.__isInterface__ = false;
CreateGradientBoxMatrix_Impl_.prototype = {
	
};
CreateGradientBoxMatrix_Impl_.prototype.__class__ = CreateGradientBoxMatrix_Impl_.prototype.constructor = $hxClasses["feathers.graphics._CreateGradientBoxMatrix.CreateGradientBoxMatrix_Impl_"] = CreateGradientBoxMatrix_Impl_;

// Init



// Statics

CreateGradientBoxMatrix_Impl_.fromGradientBoxTransform = function(transform) {
	switch(transform._hx_index) {
	case 0:
		var rotation = transform.rotation;
		return function(defaultWidth,defaultHeight,defaultRadians,defaultTx,defaultTy) {
			var matrix = new (openfl_geom_Matrix().default)();
			matrix.createGradientBox(defaultWidth,defaultHeight,rotation,defaultTx,defaultTy);
			return matrix;
		};
	case 1:
		var rotation1 = transform.rotation;
		return function(defaultWidth1,defaultHeight1,defaultRadians1,defaultTx1,defaultTy1) {
			var matrix1 = new (openfl_geom_Matrix().default)();
			matrix1.createGradientBox(defaultWidth1,defaultHeight1,rotation1 * Math.PI / 180.0,defaultTx1,defaultTy1);
			return matrix1;
		};
	case 2:
		var ty = transform.ty;
		var tx = transform.tx;
		return function(defaultWidth2,defaultHeight2,defaultRadians2,defaultTx2,defaultTy2) {
			var matrix2 = new (openfl_geom_Matrix().default)();
			matrix2.createGradientBox(defaultWidth2,defaultHeight2,defaultRadians2,tx,ty);
			return matrix2;
		};
	case 3:
		var ty1 = transform.ty;
		var tx1 = transform.tx;
		var rotation2 = transform.rotation;
		return function(defaultWidth3,defaultHeight3,defaultRadians3,defaultTx3,defaultTy3) {
			var matrix3 = new (openfl_geom_Matrix().default)();
			matrix3.createGradientBox(defaultWidth3,defaultHeight3,rotation2,tx1,ty1);
			return matrix3;
		};
	case 4:
		var ty2 = transform.ty;
		var tx2 = transform.tx;
		var rotation3 = transform.rotation;
		return function(defaultWidth4,defaultHeight4,defaultRadians4,defaultTx4,defaultTy4) {
			var matrix4 = new (openfl_geom_Matrix().default)();
			matrix4.createGradientBox(defaultWidth4,defaultHeight4,rotation3 * Math.PI / 180.0,tx2,ty2);
			return matrix4;
		};
	}
}
CreateGradientBoxMatrix_Impl_.fromRadians = function(radians) {
	return function(defaultWidth,defaultHeight,defaultRadians,defaultTx,defaultTy) {
		var matrix = new (openfl_geom_Matrix().default)();
		matrix.createGradientBox(defaultWidth,defaultHeight,radians,defaultTx,defaultTy);
		return matrix;
	};
}
CreateGradientBoxMatrix_Impl_.fromMatrix = function(matrix) {
	return function(defaultWidth,defaultHeight,defaultRadians,defaultTx,defaultTy) {
		return matrix;
	};
}


// Export

exports["default"] = CreateGradientBoxMatrix_Impl_;

/***/ }),

/***/ "./lib/_gen/feathers/layout/Anchor.js":
/*!********************************************!*\
  !*** ./lib/_gen/feathers/layout/Anchor.js ***!
  \********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.Anchor

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_events_EventDispatcher() {return __webpack_require__(/*! ./../../openfl/events/EventDispatcher */ "./lib/_gen/openfl/events/EventDispatcher.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}

// Constructor

var Anchor = function(value,relativeTo) {
	(openfl_events_EventDispatcher().default).call(this);
	this._value = value;
	this._relativeTo = relativeTo;
}

// Meta

Anchor.__name__ = "feathers.layout.Anchor";
Anchor.__isInterface__ = false;
Anchor.__super__ = (openfl_events_EventDispatcher().default);
Anchor.prototype = $extend((openfl_events_EventDispatcher().default).prototype, {
	get_value: function() {
		return this._value;
	},
	set_value: function(newValue) {
		if(this._value == newValue) {
			return this._value;
		}
		this._value = newValue;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._value;
	},
	get_relativeTo: function() {
		return this._relativeTo;
	},
	set_relativeTo: function(value) {
		if(this._relativeTo == value) {
			return this._relativeTo;
		}
		this._relativeTo = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._relativeTo;
	}
});
Anchor.prototype.__class__ = Anchor.prototype.constructor = $hxClasses["feathers.layout.Anchor"] = Anchor;

// Init



// Statics




// Export

exports["default"] = Anchor;

/***/ }),

/***/ "./lib/_gen/feathers/layout/AnchorLayout.js":
/*!**************************************************!*\
  !*** ./lib/_gen/feathers/layout/AnchorLayout.js ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.AnchorLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_ILayout() {return __webpack_require__(/*! ./../../feathers/layout/ILayout */ "./lib/_gen/feathers/layout/ILayout.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_ILayoutObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutObject */ "./lib/_gen/feathers/layout/ILayoutObject.js");}
function feathers_layout_AnchorLayoutData() {return __webpack_require__(/*! ./../../feathers/layout/AnchorLayoutData */ "./lib/_gen/feathers/layout/AnchorLayoutData.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}

// Constructor

var AnchorLayout = function() {
	(openfl_events_EventDispatcher()).call(this);
}

// Meta

AnchorLayout.__name__ = "feathers.layout.AnchorLayout";
AnchorLayout.__isInterface__ = false;
AnchorLayout.__interfaces__ = [(feathers_layout_ILayout().default)];
AnchorLayout.__super__ = (openfl_events_EventDispatcher());
AnchorLayout.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	layout: function(items,measurements,result) {
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			var layoutObject = null;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				layoutObject = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutObject.get_includeInLayout()) {
					continue;
				}
				var layoutData = null;
				if(layoutObject != null && ((layoutObject.get_layoutData()) instanceof (feathers_layout_AnchorLayoutData().default))) {
					layoutData = (js_Boot().default).__cast(layoutObject.get_layoutData() , (feathers_layout_AnchorLayoutData().default));
				}
				if(layoutData != null) {
					if(measurements.width != null) {
						var leftAnchor = layoutData.get_left();
						var rightAnchor = layoutData.get_right();
						if(leftAnchor != null && rightAnchor != null && leftAnchor.get_relativeTo() == null && rightAnchor.get_relativeTo() == null) {
							item.set_width(measurements.width - leftAnchor.get_value() - rightAnchor.get_value());
						}
					}
					if(measurements.height != null) {
						var topAnchor = layoutData.get_top();
						var bottomAnchor = layoutData.get_bottom();
						if(topAnchor != null && bottomAnchor != null && topAnchor.get_relativeTo() == null && bottomAnchor.get_relativeTo() == null) {
							item.set_height(measurements.height - topAnchor.get_value() - bottomAnchor.get_value());
						}
					}
				}
			}
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
		}
		var maxX = 0.0;
		var maxY = 0.0;
		var doneItems = [];
		while(doneItems.length < items.length) {
			var oldDoneCount = doneItems.length;
			var _g1 = 0;
			while(_g1 < items.length) {
				var item1 = items[_g1];
				++_g1;
				if(doneItems.indexOf(item1) != -1) {
					continue;
				}
				var layoutObject1 = null;
				if((js_Boot().default).__implements(item1,(feathers_layout_ILayoutObject().default))) {
					layoutObject1 = (js_Boot().default).__cast(item1 , (feathers_layout_ILayoutObject().default));
					if(!layoutObject1.get_includeInLayout()) {
						doneItems.push(item1);
						continue;
					}
				}
				var layoutData1 = null;
				if(layoutObject1 != null && ((layoutObject1.get_layoutData()) instanceof (feathers_layout_AnchorLayoutData().default))) {
					layoutData1 = (js_Boot().default).__cast(layoutObject1.get_layoutData() , (feathers_layout_AnchorLayoutData().default));
				}
				if((js_Boot().default).__implements(item1,(feathers_core_IValidating().default))) {
					((js_Boot().default).__cast(item1 , (feathers_core_IValidating().default))).validateNow();
				}
				if(layoutData1 == null) {
					var itemMaxX = item1.get_x() + item1.get_width();
					if(maxX < itemMaxX) {
						maxX = itemMaxX;
					}
					var itemMaxY = item1.get_y() + item1.get_height();
					if(maxY < itemMaxY) {
						maxY = itemMaxY;
					}
				} else {
					if(layoutData1.get_top() != null) {
						var top = layoutData1.get_top();
						var value = top.get_value();
						var relativeTo = top.get_relativeTo();
						if(relativeTo != null && doneItems.indexOf(relativeTo) == -1) {
							continue;
						}
						item1.set_y(value);
						if(relativeTo != null) {
							var _g11 = item1;
							_g11.set_y(_g11.get_y() + (relativeTo.get_y() + relativeTo.get_height()));
						}
					}
					if(layoutData1.get_left() != null) {
						var left = layoutData1.get_left();
						var value1 = left.get_value();
						var relativeTo1 = left.get_relativeTo();
						if(relativeTo1 != null && doneItems.indexOf(relativeTo1) == -1) {
							continue;
						}
						item1.set_x(value1);
						if(relativeTo1 != null) {
							var _g12 = item1;
							_g12.set_x(_g12.get_x() + (relativeTo1.get_x() + relativeTo1.get_width()));
						}
					}
					if(layoutData1.get_verticalCenter() == null) {
						var itemMaxY1 = item1.get_y() + item1.get_height();
						if(layoutData1.get_bottom() != null) {
							var bottom = layoutData1.get_bottom();
							var value2 = bottom.get_value();
							if(layoutData1.get_top() != null) {
								itemMaxY1 += value2;
							} else {
								itemMaxY1 = item1.get_height() + value2;
							}
						}
						if(maxY < itemMaxY1) {
							maxY = itemMaxY1;
						}
					} else {
						var itemMaxY2 = item1.get_height();
						if(maxY < itemMaxY2) {
							maxY = itemMaxY2;
						}
					}
					if(layoutData1.get_horizontalCenter() == null) {
						var itemMaxX1 = item1.get_x() + item1.get_width();
						if(layoutData1.get_right() != null) {
							var right = layoutData1.get_right();
							var value3 = right.get_value();
							if(layoutData1.get_left() != null) {
								itemMaxX1 += value3;
							} else {
								itemMaxX1 = item1.get_width() + value3;
							}
						}
						if(maxX < itemMaxX1) {
							maxX = itemMaxX1;
						}
					} else {
						var itemMaxX2 = item1.get_width();
						if(maxX < itemMaxX2) {
							maxX = itemMaxX2;
						}
					}
				}
				doneItems.push(item1);
			}
			if(oldDoneCount == doneItems.length) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("AnchorLayout failed."));
			}
		}
		var viewPortWidth = 0.0;
		var viewPortHeight = 0.0;
		var loopCount = 0;
		var needsAnotherPass = true;
		while(needsAnotherPass) {
			needsAnotherPass = false;
			if(measurements.width != null) {
				viewPortWidth = measurements.width;
			} else {
				viewPortWidth = maxX;
				if(measurements.minWidth != null && viewPortWidth < measurements.minWidth) {
					viewPortWidth = measurements.minWidth;
				} else if(measurements.maxWidth != null && viewPortWidth > measurements.maxWidth) {
					viewPortWidth = measurements.maxWidth;
				}
			}
			if(measurements.height != null) {
				viewPortHeight = measurements.height;
			} else {
				viewPortHeight = maxY;
				if(measurements.minHeight != null && viewPortHeight < measurements.minHeight) {
					viewPortHeight = measurements.minHeight;
				} else if(measurements.maxHeight != null && viewPortHeight > measurements.maxHeight) {
					viewPortHeight = measurements.maxHeight;
				}
			}
			doneItems.length = 0;
			while(doneItems.length < items.length) {
				var oldDoneCount1 = doneItems.length;
				var _g13 = 0;
				while(_g13 < items.length) {
					var item2 = items[_g13];
					++_g13;
					if(doneItems.indexOf(item2) != -1) {
						continue;
					}
					var layoutObject2 = null;
					if((js_Boot().default).__implements(item2,(feathers_layout_ILayoutObject().default))) {
						layoutObject2 = (js_Boot().default).__cast(item2 , (feathers_layout_ILayoutObject().default));
						if(!layoutObject2.get_includeInLayout()) {
							doneItems.push(item2);
							continue;
						}
					}
					var layoutData2 = null;
					if(layoutObject2 != null && ((layoutObject2.get_layoutData()) instanceof (feathers_layout_AnchorLayoutData().default))) {
						layoutData2 = (js_Boot().default).__cast(layoutObject2.get_layoutData() , (feathers_layout_AnchorLayoutData().default));
					}
					if(layoutData2 == null) {
						doneItems.push(item2);
						continue;
					}
					if(layoutData2.get_top() != null) {
						var top1 = layoutData2.get_top();
						var relativeTo2 = top1.get_relativeTo();
						if(relativeTo2 != null && doneItems.indexOf(relativeTo2) == -1) {
							continue;
						}
						var y = top1.get_value();
						if(relativeTo2 != null) {
							y += relativeTo2.get_y() + relativeTo2.get_height();
						}
						item2.set_y(y);
					}
					if(layoutData2.get_left() != null) {
						var left1 = layoutData2.get_left();
						var relativeTo3 = left1.get_relativeTo();
						if(relativeTo3 != null && doneItems.indexOf(relativeTo3) == -1) {
							continue;
						}
						var x = left1.get_value();
						if(relativeTo3 != null) {
							x += relativeTo3.get_x() + relativeTo3.get_width();
						}
						item2.set_x(x);
					}
					if(layoutData2.get_bottom() != null) {
						var bottom1 = layoutData2.get_bottom();
						var relativeTo4 = bottom1.get_relativeTo();
						if(relativeTo4 != null && doneItems.indexOf(relativeTo4) == -1) {
							continue;
						}
						var bottomPixels = bottom1.get_value();
						var bottomEdge = viewPortHeight;
						if(relativeTo4 != null) {
							bottomEdge = relativeTo4.get_y();
						}
						if(layoutData2.get_top() == null) {
							item2.set_y(bottomEdge - bottomPixels - item2.get_height());
						} else {
							var itemHeight = bottomEdge - bottomPixels - item2.get_y();
							if(itemHeight < 0.0) {
								itemHeight = 0.0;
							}
							if(item2.get_height() != itemHeight) {
								item2.set_height(itemHeight);
								if(measurements.width == null && (js_Boot().default).__implements(item2,(feathers_core_IValidating().default))) {
									((js_Boot().default).__cast(item2 , (feathers_core_IValidating().default))).validateNow();
									var maxItemX = item2.get_x() + item2.get_width();
									if(maxX < maxItemX) {
										maxX = maxItemX;
										needsAnotherPass = true;
										break;
									}
								}
							}
						}
					} else if(layoutData2.get_verticalCenter() != null) {
						item2.set_y(layoutData2.get_verticalCenter() + (viewPortHeight - item2.get_height()) / 2.0);
					}
					if(layoutData2.get_right() != null) {
						var right1 = layoutData2.get_right();
						var relativeTo5 = right1.get_relativeTo();
						if(relativeTo5 != null && doneItems.indexOf(relativeTo5) == -1) {
							continue;
						}
						var rightPixels = right1.get_value();
						var rightEdge = viewPortWidth;
						if(relativeTo5 != null) {
							rightEdge = relativeTo5.get_x();
						}
						if(layoutData2.get_left() == null) {
							item2.set_x(rightEdge - rightPixels - item2.get_width());
						} else {
							var itemWidth = rightEdge - rightPixels - item2.get_x();
							if(itemWidth < 0.0) {
								itemWidth = 0.0;
							}
							if(item2.get_width() != itemWidth) {
								item2.set_width(itemWidth);
								if(measurements.height == null && (js_Boot().default).__implements(item2,(feathers_core_IValidating().default))) {
									((js_Boot().default).__cast(item2 , (feathers_core_IValidating().default))).validateNow();
									var maxItemY = item2.get_y() + item2.get_height();
									if(maxY < maxItemY) {
										maxY = maxItemY;
										needsAnotherPass = true;
										break;
									}
								}
							}
						}
					} else if(layoutData2.get_horizontalCenter() != null) {
						item2.set_x(layoutData2.get_horizontalCenter() + (viewPortWidth - item2.get_width()) / 2.0);
					}
					doneItems.push(item2);
				}
				if(!needsAnotherPass && oldDoneCount1 == doneItems.length) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("AnchorLayout failed."));
				}
			}
			if(needsAnotherPass) {
				++loopCount;
				if(loopCount > items.length) {
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("AnchorLayout is stuck in an infinite loop."));
				}
			}
		}
		if(result == null) {
			result = new (feathers_layout_LayoutBoundsResult().default)();
		}
		result.contentX = 0.0;
		result.contentY = 0.0;
		result.contentWidth = viewPortWidth;
		result.contentHeight = viewPortHeight;
		result.viewPortWidth = viewPortWidth;
		result.viewPortHeight = viewPortHeight;
		return result;
	}
});
AnchorLayout.prototype.__class__ = AnchorLayout.prototype.constructor = $hxClasses["feathers.layout.AnchorLayout"] = AnchorLayout;

// Init



// Statics




// Export

exports["default"] = AnchorLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/AnchorLayoutData.js":
/*!******************************************************!*\
  !*** ./lib/_gen/feathers/layout/AnchorLayoutData.js ***!
  \******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.AnchorLayoutData

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_ILayoutData() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutData */ "./lib/_gen/feathers/layout/ILayoutData.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function feathers_layout__$AnchorLayout_AbstractAnchor_$Impl_$() {return __webpack_require__(/*! ./../../feathers/layout/_AnchorLayout/AbstractAnchor_Impl_ */ "./lib/_gen/feathers/layout/_AnchorLayout/AbstractAnchor_Impl_.js");}

// Constructor

var AnchorLayoutData = function(top,right,bottom,left,horizontalCenter,verticalCenter) {
	this._verticalCenter = null;
	this._horizontalCenter = null;
	this._left = null;
	this._bottom = null;
	this._right = null;
	this._top = null;
	(openfl_events_EventDispatcher()).call(this);
	this.set_top(top);
	this.set_right(right);
	this.set_bottom(bottom);
	this.set_left(left);
	this.set_horizontalCenter(horizontalCenter);
	this.set_verticalCenter(verticalCenter);
}

// Meta

AnchorLayoutData.__name__ = "feathers.layout.AnchorLayoutData";
AnchorLayoutData.__isInterface__ = false;
AnchorLayoutData.__interfaces__ = [(feathers_layout_ILayoutData().default)];
AnchorLayoutData.__super__ = (openfl_events_EventDispatcher());
AnchorLayoutData.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_top: function() {
		return this._top;
	},
	set_top: function(value) {
		if(this._top == value) {
			return this._top;
		}
		if(this._top != null) {
			var top = this._top;
			top.removeEventListener("change",$bind(this,this.anchorLayoutData_anchor_changeHandler));
		}
		this._top = value;
		if(this._top != null) {
			var top1 = this._top;
			top1.addEventListener("change",$bind(this,this.anchorLayoutData_anchor_changeHandler),false,0,true);
		}
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._top;
	},
	get_right: function() {
		return this._right;
	},
	set_right: function(value) {
		if(this._right == value) {
			return this._right;
		}
		if(this._right != null) {
			var anchor = this._right;
			anchor.removeEventListener("change",$bind(this,this.anchorLayoutData_anchor_changeHandler));
		}
		this._right = value;
		if(this._right != null) {
			var anchor1 = this._right;
			anchor1.addEventListener("change",$bind(this,this.anchorLayoutData_anchor_changeHandler),false,0,true);
		}
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._right;
	},
	get_bottom: function() {
		return this._bottom;
	},
	set_bottom: function(value) {
		if(this._bottom == value) {
			return this._bottom;
		}
		if(this._bottom != null) {
			var anchor = this._bottom;
			anchor.removeEventListener("change",$bind(this,this.anchorLayoutData_anchor_changeHandler));
		}
		this._bottom = value;
		if(this._bottom != null) {
			var anchor1 = this._bottom;
			anchor1.addEventListener("change",$bind(this,this.anchorLayoutData_anchor_changeHandler),false,0,true);
		}
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._bottom;
	},
	get_left: function() {
		return this._left;
	},
	set_left: function(value) {
		if(this._left == value) {
			return this._left;
		}
		if(this._left != null) {
			var anchor = this._left;
			anchor.removeEventListener("change",$bind(this,this.anchorLayoutData_anchor_changeHandler));
		}
		this._left = value;
		if(this._left != null) {
			var anchor1 = this._left;
			anchor1.addEventListener("change",$bind(this,this.anchorLayoutData_anchor_changeHandler),false,0,true);
		}
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._left;
	},
	get_horizontalCenter: function() {
		return this._horizontalCenter;
	},
	set_horizontalCenter: function(value) {
		if(this._horizontalCenter == value) {
			return this._horizontalCenter;
		}
		this._horizontalCenter = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._horizontalCenter;
	},
	get_verticalCenter: function() {
		return this._verticalCenter;
	},
	set_verticalCenter: function(value) {
		if(this._verticalCenter == value) {
			return this._verticalCenter;
		}
		this._verticalCenter = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._verticalCenter;
	},
	anchorLayoutData_anchor_changeHandler: function(event) {
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
	}
});
AnchorLayoutData.prototype.__class__ = AnchorLayoutData.prototype.constructor = $hxClasses["feathers.layout.AnchorLayoutData"] = AnchorLayoutData;

// Init



// Statics

AnchorLayoutData.center = function(x,y) {
	if(y == null) {
		y = 0.0;
	}
	if(x == null) {
		x = 0.0;
	}
	return new AnchorLayoutData(null,null,null,null,x,y);
}
AnchorLayoutData.fill = function(padding) {
	if(padding == null) {
		padding = 0.0;
	}
	return new AnchorLayoutData((feathers_layout__$AnchorLayout_AbstractAnchor_$Impl_$().default).fromPixels(padding),(feathers_layout__$AnchorLayout_AbstractAnchor_$Impl_$().default).fromPixels(padding),(feathers_layout__$AnchorLayout_AbstractAnchor_$Impl_$().default).fromPixels(padding),(feathers_layout__$AnchorLayout_AbstractAnchor_$Impl_$().default).fromPixels(padding));
}
AnchorLayoutData.fillHorizontal = function(padding) {
	if(padding == null) {
		padding = 0.0;
	}
	return new AnchorLayoutData(null,(feathers_layout__$AnchorLayout_AbstractAnchor_$Impl_$().default).fromPixels(padding),null,(feathers_layout__$AnchorLayout_AbstractAnchor_$Impl_$().default).fromPixels(padding));
}
AnchorLayoutData.fillVertical = function(padding) {
	if(padding == null) {
		padding = 0.0;
	}
	return new AnchorLayoutData((feathers_layout__$AnchorLayout_AbstractAnchor_$Impl_$().default).fromPixels(padding),null,(feathers_layout__$AnchorLayout_AbstractAnchor_$Impl_$().default).fromPixels(padding),null);
}
AnchorLayoutData.topLeft = function(top,left) {
	if(left == null) {
		left = 0.0;
	}
	if(top == null) {
		top = 0.0;
	}
	return new AnchorLayoutData((feathers_layout__$AnchorLayout_AbstractAnchor_$Impl_$().default).fromPixels(top),null,null,(feathers_layout__$AnchorLayout_AbstractAnchor_$Impl_$().default).fromPixels(left));
}
AnchorLayoutData.topCenter = function(top,horizontalCenter) {
	if(horizontalCenter == null) {
		horizontalCenter = 0.0;
	}
	if(top == null) {
		top = 0.0;
	}
	return new AnchorLayoutData((feathers_layout__$AnchorLayout_AbstractAnchor_$Impl_$().default).fromPixels(top),null,null,null,horizontalCenter);
}
AnchorLayoutData.topRight = function(top,right) {
	if(right == null) {
		right = 0.0;
	}
	if(top == null) {
		top = 0.0;
	}
	return new AnchorLayoutData((feathers_layout__$AnchorLayout_AbstractAnchor_$Impl_$().default).fromPixels(top),(feathers_layout__$AnchorLayout_AbstractAnchor_$Impl_$().default).fromPixels(right));
}
AnchorLayoutData.middleLeft = function(verticalCenter,left) {
	if(left == null) {
		left = 0.0;
	}
	if(verticalCenter == null) {
		verticalCenter = 0.0;
	}
	return new AnchorLayoutData(null,null,null,(feathers_layout__$AnchorLayout_AbstractAnchor_$Impl_$().default).fromPixels(left),null,verticalCenter);
}
AnchorLayoutData.middleRight = function(verticalCenter,right) {
	if(right == null) {
		right = 0.0;
	}
	if(verticalCenter == null) {
		verticalCenter = 0.0;
	}
	return new AnchorLayoutData(null,(feathers_layout__$AnchorLayout_AbstractAnchor_$Impl_$().default).fromPixels(right),null,null,null,verticalCenter);
}
AnchorLayoutData.bottomLeft = function(bottom,left) {
	if(left == null) {
		left = 0.0;
	}
	if(bottom == null) {
		bottom = 0.0;
	}
	return new AnchorLayoutData(null,null,(feathers_layout__$AnchorLayout_AbstractAnchor_$Impl_$().default).fromPixels(bottom),(feathers_layout__$AnchorLayout_AbstractAnchor_$Impl_$().default).fromPixels(left));
}
AnchorLayoutData.bottomCenter = function(bottom,horizontalCenter) {
	if(horizontalCenter == null) {
		horizontalCenter = 0.0;
	}
	if(bottom == null) {
		bottom = 0.0;
	}
	return new AnchorLayoutData(null,null,(feathers_layout__$AnchorLayout_AbstractAnchor_$Impl_$().default).fromPixels(bottom),null,horizontalCenter);
}
AnchorLayoutData.bottomRight = function(bottom,right) {
	if(right == null) {
		right = 0.0;
	}
	if(bottom == null) {
		bottom = 0.0;
	}
	return new AnchorLayoutData(null,(feathers_layout__$AnchorLayout_AbstractAnchor_$Impl_$().default).fromPixels(right),(feathers_layout__$AnchorLayout_AbstractAnchor_$Impl_$().default).fromPixels(bottom));
}


// Export

exports["default"] = AnchorLayoutData;

/***/ }),

/***/ "./lib/_gen/feathers/layout/AutoSizeMode.js":
/*!**************************************************!*\
  !*** ./lib/_gen/feathers/layout/AutoSizeMode.js ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.layout.AutoSizeMode

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var AutoSizeMode = $hxEnums["feathers.layout.AutoSizeMode"] = { __ename__ : "feathers.layout.AutoSizeMode", __constructs__ : ["STAGE","CONTENT"]
  ,STAGE: {_hx_index:0,__enum__:"feathers.layout.AutoSizeMode",toString:$estr}
  ,CONTENT: {_hx_index:1,__enum__:"feathers.layout.AutoSizeMode",toString:$estr}
};

exports["default"] = AutoSizeMode;

/***/ }),

/***/ "./lib/_gen/feathers/layout/Breakpoint.js":
/*!************************************************!*\
  !*** ./lib/_gen/feathers/layout/Breakpoint.js ***!
  \************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.layout.Breakpoint

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var Breakpoint = $hxEnums["feathers.layout.Breakpoint"] = { __ename__ : "feathers.layout.Breakpoint", __constructs__ : ["XS","SM","MD","LG","XL","XXL"]
  ,XXL: {_hx_index:5,__enum__:"feathers.layout.Breakpoint",toString:$estr}
  ,XS: {_hx_index:0,__enum__:"feathers.layout.Breakpoint",toString:$estr}
  ,XL: {_hx_index:4,__enum__:"feathers.layout.Breakpoint",toString:$estr}
  ,SM: {_hx_index:1,__enum__:"feathers.layout.Breakpoint",toString:$estr}
  ,MD: {_hx_index:2,__enum__:"feathers.layout.Breakpoint",toString:$estr}
  ,LG: {_hx_index:3,__enum__:"feathers.layout.Breakpoint",toString:$estr}
};

exports["default"] = Breakpoint;

/***/ }),

/***/ "./lib/_gen/feathers/layout/CalendarGridLayout.js":
/*!********************************************************!*\
  !*** ./lib/_gen/feathers/layout/CalendarGridLayout.js ***!
  \********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.CalendarGridLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_ILayout() {return __webpack_require__(/*! ./../../feathers/layout/ILayout */ "./lib/_gen/feathers/layout/ILayout.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_ILayoutObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutObject */ "./lib/_gen/feathers/layout/ILayoutObject.js");}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}

// Constructor

var CalendarGridLayout = function() {
	this._verticalGap = 0.0;
	this._horizontalGap = 0.0;
	this._paddingLeft = 0.0;
	this._paddingBottom = 0.0;
	this._paddingRight = 0.0;
	this._paddingTop = 0.0;
	(openfl_events_EventDispatcher()).call(this);
}

// Meta

CalendarGridLayout.__name__ = "feathers.layout.CalendarGridLayout";
CalendarGridLayout.__isInterface__ = false;
CalendarGridLayout.__interfaces__ = [(feathers_layout_ILayout().default)];
CalendarGridLayout.__super__ = (openfl_events_EventDispatcher());
CalendarGridLayout.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_paddingTop: function() {
		return this._paddingTop;
	},
	set_paddingTop: function(value) {
		if(this._paddingTop == value) {
			return this._paddingTop;
		}
		this._paddingTop = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingTop;
	},
	get_paddingRight: function() {
		return this._paddingRight;
	},
	set_paddingRight: function(value) {
		if(this._paddingRight == value) {
			return this._paddingRight;
		}
		this._paddingRight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingRight;
	},
	get_paddingBottom: function() {
		return this._paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(this._paddingBottom == value) {
			return this._paddingBottom;
		}
		this._paddingBottom = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingBottom;
	},
	get_paddingLeft: function() {
		return this._paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(this._paddingLeft == value) {
			return this._paddingLeft;
		}
		this._paddingLeft = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingLeft;
	},
	get_horizontalGap: function() {
		return this._horizontalGap;
	},
	set_horizontalGap: function(value) {
		if(this._horizontalGap == value) {
			return this._horizontalGap;
		}
		this._horizontalGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._horizontalGap;
	},
	get_verticalGap: function() {
		return this._verticalGap;
	},
	set_verticalGap: function(value) {
		if(this._verticalGap == value) {
			return this._verticalGap;
		}
		this._verticalGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._verticalGap;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	setGap: function(value) {
		this.set_horizontalGap(value);
		this.set_verticalGap(value);
	},
	layout: function(items,measurements,result) {
		this.validateItems(items,measurements);
		var tileWidth = 0.0;
		var tileHeight = 0.0;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				var layoutItem = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutItem.get_includeInLayout()) {
					continue;
				}
			}
			tileWidth = Math.max(tileWidth,item.get_width());
			tileHeight = Math.max(tileHeight,item.get_height());
		}
		if(tileWidth < 0.0) {
			tileWidth = 0.0;
		}
		if(tileHeight < 0.0) {
			tileHeight = 0.0;
		}
		var horizontalTileCount = 7;
		var verticalTileCount = Math.ceil(items.length / horizontalTileCount);
		var viewPortWidth = measurements.width;
		if(viewPortWidth != null) {
			var availableWidth = viewPortWidth - this._paddingLeft - this._paddingRight - this._horizontalGap * horizontalTileCount + this._horizontalGap;
			tileWidth = availableWidth / horizontalTileCount;
		} else {
			viewPortWidth = this._paddingLeft + this._paddingRight + horizontalTileCount * (tileWidth + this._horizontalGap) - this._horizontalGap;
			if(measurements.minWidth != null && viewPortWidth < measurements.minWidth) {
				viewPortWidth = measurements.minWidth;
			} else if(measurements.maxWidth != null && viewPortWidth > measurements.maxWidth) {
				viewPortWidth = measurements.maxWidth;
			}
		}
		var viewPortHeight = measurements.height;
		if(viewPortHeight != null) {
			var availableHeight = viewPortHeight - this._paddingTop - this._paddingBottom - this._verticalGap * verticalTileCount + this._verticalGap;
			tileHeight = availableHeight / verticalTileCount;
		} else {
			viewPortHeight = this._paddingTop + this._paddingBottom + verticalTileCount * (tileHeight + this._verticalGap) - this._verticalGap;
			if(measurements.minHeight != null && viewPortHeight < measurements.minHeight) {
				viewPortHeight = measurements.minHeight;
			} else if(measurements.maxHeight != null && viewPortHeight > measurements.maxHeight) {
				viewPortHeight = measurements.maxHeight;
			}
		}
		var currentColumnCount = 0;
		var xPosition = this._paddingLeft;
		var yPosition = this._paddingTop;
		var _g1 = 0;
		var _g2 = items.length;
		while(_g1 < _g2) {
			var i = _g1++;
			var item1 = items[i];
			if((js_Boot().default).__implements(item1,(feathers_layout_ILayoutObject().default))) {
				var layoutItem1 = (js_Boot().default).__cast(item1 , (feathers_layout_ILayoutObject().default));
				if(!layoutItem1.get_includeInLayout()) {
					continue;
				}
			}
			if(item1.get_width() != tileWidth) {
				item1.set_width(tileWidth);
			}
			if(item1.get_height() != tileHeight) {
				item1.set_height(tileHeight);
			}
			if(currentColumnCount >= horizontalTileCount) {
				xPosition = this._paddingLeft;
				yPosition += tileHeight + this._verticalGap;
				currentColumnCount = 0;
			}
			item1.set_x(xPosition);
			item1.set_y(yPosition);
			xPosition += tileWidth + this._horizontalGap;
			++currentColumnCount;
		}
		yPosition += tileHeight + this.get_paddingBottom();
		if(result == null) {
			result = new (feathers_layout_LayoutBoundsResult().default)();
		}
		result.contentX = 0.0;
		result.contentY = 0.0;
		result.contentWidth = viewPortWidth;
		result.contentHeight = viewPortHeight;
		result.viewPortWidth = viewPortWidth;
		result.viewPortHeight = viewPortHeight;
		return result;
	},
	validateItems: function(items,measurements) {
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				var layoutItem = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutItem.get_includeInLayout()) {
					continue;
				}
			}
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
		}
	}
});
CalendarGridLayout.prototype.__class__ = CalendarGridLayout.prototype.constructor = $hxClasses["feathers.layout.CalendarGridLayout"] = CalendarGridLayout;

// Init



// Statics




// Export

exports["default"] = CalendarGridLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/Direction.js":
/*!***********************************************!*\
  !*** ./lib/_gen/feathers/layout/Direction.js ***!
  \***********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.layout.Direction

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var Direction = $hxEnums["feathers.layout.Direction"] = { __ename__ : "feathers.layout.Direction", __constructs__ : ["VERTICAL","HORIZONTAL","NONE"]
  ,VERTICAL: {_hx_index:0,__enum__:"feathers.layout.Direction",toString:$estr}
  ,NONE: {_hx_index:2,__enum__:"feathers.layout.Direction",toString:$estr}
  ,HORIZONTAL: {_hx_index:1,__enum__:"feathers.layout.Direction",toString:$estr}
};

exports["default"] = Direction;

/***/ }),

/***/ "./lib/_gen/feathers/layout/FlowRowsLayout.js":
/*!****************************************************!*\
  !*** ./lib/_gen/feathers/layout/FlowRowsLayout.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.FlowRowsLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_ILayout() {return __webpack_require__(/*! ./../../feathers/layout/ILayout */ "./lib/_gen/feathers/layout/ILayout.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_ILayoutObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutObject */ "./lib/_gen/feathers/layout/ILayoutObject.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}

// Constructor

var FlowRowsLayout = function() {
	this._rowItems = [];
	this._justifyResetEnabled = false;
	this._rowVerticalAlign = (feathers_layout_VerticalAlign().default).TOP;
	this._verticalAlign = (feathers_layout_VerticalAlign().default).TOP;
	this._horizontalAlign = (feathers_layout_HorizontalAlign().default).LEFT;
	this._verticalGap = 0.0;
	this._horizontalGap = 0.0;
	this._paddingLeft = 0.0;
	this._paddingBottom = 0.0;
	this._paddingRight = 0.0;
	this._paddingTop = 0.0;
	(openfl_events_EventDispatcher()).call(this);
}

// Meta

FlowRowsLayout.__name__ = "feathers.layout.FlowRowsLayout";
FlowRowsLayout.__isInterface__ = false;
FlowRowsLayout.__interfaces__ = [(feathers_layout_ILayout().default)];
FlowRowsLayout.__super__ = (openfl_events_EventDispatcher());
FlowRowsLayout.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_paddingTop: function() {
		return this._paddingTop;
	},
	set_paddingTop: function(value) {
		if(this._paddingTop == value) {
			return this._paddingTop;
		}
		this._paddingTop = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingTop;
	},
	get_paddingRight: function() {
		return this._paddingRight;
	},
	set_paddingRight: function(value) {
		if(this._paddingRight == value) {
			return this._paddingRight;
		}
		this._paddingRight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingRight;
	},
	get_paddingBottom: function() {
		return this._paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(this._paddingBottom == value) {
			return this._paddingBottom;
		}
		this._paddingBottom = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingBottom;
	},
	get_paddingLeft: function() {
		return this._paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(this._paddingLeft == value) {
			return this._paddingLeft;
		}
		this._paddingLeft = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingLeft;
	},
	get_horizontalGap: function() {
		return this._horizontalGap;
	},
	set_horizontalGap: function(value) {
		if(this._horizontalGap == value) {
			return this._horizontalGap;
		}
		this._horizontalGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._horizontalGap;
	},
	get_verticalGap: function() {
		return this._verticalGap;
	},
	set_verticalGap: function(value) {
		if(this._verticalGap == value) {
			return this._verticalGap;
		}
		this._verticalGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._verticalGap;
	},
	get_horizontalAlign: function() {
		return this._horizontalAlign;
	},
	set_horizontalAlign: function(value) {
		if(this._horizontalAlign == value) {
			return this._horizontalAlign;
		}
		this._horizontalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._horizontalAlign;
	},
	get_verticalAlign: function() {
		return this._verticalAlign;
	},
	set_verticalAlign: function(value) {
		if(this._verticalAlign == value) {
			return this._verticalAlign;
		}
		this._verticalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._verticalAlign;
	},
	get_rowVerticalAlign: function() {
		return this._rowVerticalAlign;
	},
	set_rowVerticalAlign: function(value) {
		if(this._rowVerticalAlign == value) {
			return this._rowVerticalAlign;
		}
		this._rowVerticalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._rowVerticalAlign;
	},
	get_justifyResetEnabled: function() {
		return this._justifyResetEnabled;
	},
	set_justifyResetEnabled: function(value) {
		if(this._justifyResetEnabled == value) {
			return this._justifyResetEnabled;
		}
		this._justifyResetEnabled = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._justifyResetEnabled;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	setGap: function(value) {
		this.set_horizontalGap(value);
		this.set_verticalGap(value);
	},
	layout: function(items,measurements,result) {
		if(result == null) {
			result = new (feathers_layout_LayoutBoundsResult().default)();
		}
		if(items.length == 0) {
			result.contentX = 0.0;
			result.contentY = 0.0;
			result.contentWidth = this._paddingLeft + this._paddingRight;
			result.contentHeight = this._paddingTop + this._paddingBottom;
			result.viewPortWidth = result.contentWidth;
			result.viewPortHeight = result.contentHeight;
			return result;
		}
		this.validateItems(items,measurements);
		var supportsMultipleRows = true;
		var availableRowWidth = measurements.width;
		var needsWidth = availableRowWidth == null;
		if(needsWidth) {
			availableRowWidth = measurements.maxWidth;
			if(availableRowWidth == null) {
				availableRowWidth = 1.0 / 0.0;
			}
			if(availableRowWidth == 1.0 / 0.0) {
				supportsMultipleRows = false;
			}
		}
		var i = 0;
		var itemCount = items.length;
		var positionY = this._paddingTop;
		var maxRowWidth = 0.0;
		var maxItemHeight = 0.0;
		while(true) {
			if(i > 0) {
				positionY += maxItemHeight + this.get_verticalGap();
			}
			maxItemHeight = 0.0;
			var positionX = this._paddingLeft;
			this._rowItems.length = 0;
			while(i < itemCount) {
				var item = items[i];
				if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default)) && !((js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default))).get_includeInLayout()) {
					continue;
				}
				var itemWidth = item.get_width();
				var itemHeight = item.get_height();
				if(supportsMultipleRows && this._rowItems.length > 0 && positionX + itemWidth > availableRowWidth - this._paddingRight) {
					break;
				}
				this._rowItems.push(item);
				item.set_x(positionX);
				positionX += itemWidth + this._horizontalGap;
				if(itemHeight > maxItemHeight) {
					maxItemHeight = itemHeight;
				}
				++i;
			}
			var totalRowWidth = positionX - this._horizontalGap + this._paddingRight;
			if(totalRowWidth > maxRowWidth) {
				maxRowWidth = totalRowWidth;
			}
			if(supportsMultipleRows) {
				var horizontalAlignOffsetX;
				switch(this._horizontalAlign._hx_index) {
				case 0:
					horizontalAlignOffsetX = 0.0;
					break;
				case 1:
					horizontalAlignOffsetX = (availableRowWidth - totalRowWidth) / 2.0;
					break;
				case 2:
					horizontalAlignOffsetX = availableRowWidth - totalRowWidth;
					break;
				default:
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown horizontal align: " + (Std().default).string(this._horizontalAlign)));
				}
				if(horizontalAlignOffsetX != 0.0) {
					var _g1 = 0;
					var _g2 = this._rowItems;
					while(_g1 < _g2.length) {
						var item1 = _g2[_g1];
						++_g1;
						if((js_Boot().default).__implements(item1,(feathers_layout_ILayoutObject().default)) && !((js_Boot().default).__cast(item1 , (feathers_layout_ILayoutObject().default))).get_includeInLayout()) {
							continue;
						}
						var _g11 = item1;
						_g11.set_x(_g11.get_x() + horizontalAlignOffsetX);
					}
				}
			}
			var _g = 0;
			var _g12 = this._rowItems;
			while(_g < _g12.length) {
				var item2 = _g12[_g];
				++_g;
				if((js_Boot().default).__implements(item2,(feathers_layout_ILayoutObject().default)) && !((js_Boot().default).__cast(item2 , (feathers_layout_ILayoutObject().default))).get_includeInLayout()) {
					continue;
				}
				switch(this._rowVerticalAlign._hx_index) {
				case 0:
					item2.set_y(positionY);
					break;
				case 1:
					item2.set_y(positionY + (maxItemHeight - item2.get_height()) / 2.0);
					break;
				case 2:
					item2.set_y(positionY + maxItemHeight - item2.get_height());
					break;
				case 3:
					item2.set_y(positionY);
					if(item2.get_height() != maxItemHeight) {
						item2.set_height(maxItemHeight);
					}
					break;
				}
			}
			if(!(i < itemCount)) {
				break;
			}
		}
		this._rowItems.length = 0;
		var contentRowWidth = maxRowWidth;
		if(supportsMultipleRows && (needsWidth || measurements.width < maxRowWidth)) {
			var contentRowWidth1 = maxRowWidth;
			if(measurements.minWidth != null && contentRowWidth1 < measurements.minWidth) {
				contentRowWidth1 = measurements.minWidth;
			} else if(measurements.maxWidth != null && contentRowWidth1 > measurements.maxWidth) {
				contentRowWidth1 = measurements.maxWidth;
			}
			var horizontalAlignOffsetX1;
			switch(this._horizontalAlign._hx_index) {
			case 0:
				horizontalAlignOffsetX1 = 0.0;
				break;
			case 1:
				horizontalAlignOffsetX1 = (availableRowWidth - contentRowWidth1) / 2.0;
				break;
			case 2:
				horizontalAlignOffsetX1 = availableRowWidth - contentRowWidth1;
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown horizontal align: " + (Std().default).string(this._horizontalAlign)));
			}
			if(horizontalAlignOffsetX1 != 0.0) {
				var _g13 = 0;
				while(_g13 < items.length) {
					var item3 = items[_g13];
					++_g13;
					if((js_Boot().default).__implements(item3,(feathers_layout_ILayoutObject().default)) && !((js_Boot().default).__cast(item3 , (feathers_layout_ILayoutObject().default))).get_includeInLayout()) {
						continue;
					}
					var _g14 = item3;
					_g14.set_x(_g14.get_x() - horizontalAlignOffsetX1);
				}
			}
		}
		if(needsWidth) {
			availableRowWidth = contentRowWidth;
		}
		var totalHeight = positionY + maxItemHeight + this._paddingBottom;
		var availableHeight = measurements.height;
		if(availableHeight == null) {
			availableHeight = totalHeight;
			if(measurements.minHeight != null && availableHeight < measurements.minHeight) {
				availableHeight = measurements.minHeight;
			} else if(measurements.maxHeight != null && availableHeight > measurements.maxHeight) {
				availableHeight = measurements.maxHeight;
			}
		}
		if(totalHeight < availableHeight) {
			var verticalAlignOffset;
			switch(this._verticalAlign._hx_index) {
			case 0:
				verticalAlignOffset = 0.0;
				break;
			case 1:
				verticalAlignOffset = (availableHeight - totalHeight) / 2.0;
				break;
			case 2:
				verticalAlignOffset = availableHeight - totalHeight;
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown vertical align: " + (Std().default).string(this._verticalAlign)));
			}
			if(verticalAlignOffset != 0.0) {
				var _g15 = 0;
				while(_g15 < items.length) {
					var item4 = items[_g15];
					++_g15;
					if((js_Boot().default).__implements(item4,(feathers_layout_ILayoutObject().default)) && !((js_Boot().default).__cast(item4 , (feathers_layout_ILayoutObject().default))).get_includeInLayout()) {
						continue;
					}
					var _g16 = item4;
					_g16.set_y(_g16.get_y() + verticalAlignOffset);
				}
			}
		}
		if(result == null) {
			result = new (feathers_layout_LayoutBoundsResult().default)();
		}
		result.contentX = 0.0;
		result.contentY = 0.0;
		result.contentWidth = availableRowWidth;
		result.contentHeight = totalHeight;
		result.viewPortWidth = availableRowWidth;
		result.viewPortHeight = availableHeight;
		return result;
	},
	validateItems: function(items,measurements) {
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				var layoutItem = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutItem.get_includeInLayout()) {
					continue;
				}
			}
			if(this._rowVerticalAlign == (feathers_layout_VerticalAlign().default).JUSTIFY && this._justifyResetEnabled && (js_Boot().default).__implements(item,(feathers_core_IMeasureObject().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IMeasureObject().default))).resetHeight();
			}
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
		}
	}
});
FlowRowsLayout.prototype.__class__ = FlowRowsLayout.prototype.constructor = $hxClasses["feathers.layout.FlowRowsLayout"] = FlowRowsLayout;

// Init



// Statics




// Export

exports["default"] = FlowRowsLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/FormLayout.js":
/*!************************************************!*\
  !*** ./lib/_gen/feathers/layout/FormLayout.js ***!
  \************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.FormLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_ILayout() {return __webpack_require__(/*! ./../../feathers/layout/ILayout */ "./lib/_gen/feathers/layout/ILayout.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_ILayoutObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutObject */ "./lib/_gen/feathers/layout/ILayoutObject.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_controls_FormItem() {return __webpack_require__(/*! ./../../feathers/controls/FormItem */ "./lib/_gen/feathers/controls/FormItem.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}

// Constructor

var FormLayout = function() {
	this._verticalAlign = (feathers_layout_VerticalAlign().default).TOP;
	this._gap = 0.0;
	this._paddingLeft = 0.0;
	this._paddingBottom = 0.0;
	this._paddingRight = 0.0;
	this._paddingTop = 0.0;
	(openfl_events_EventDispatcher()).call(this);
}

// Meta

FormLayout.__name__ = "feathers.layout.FormLayout";
FormLayout.__isInterface__ = false;
FormLayout.__interfaces__ = [(feathers_layout_ILayout().default)];
FormLayout.__super__ = (openfl_events_EventDispatcher());
FormLayout.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_paddingTop: function() {
		return this._paddingTop;
	},
	set_paddingTop: function(value) {
		if(this._paddingTop == value) {
			return this._paddingTop;
		}
		this._paddingTop = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingTop;
	},
	get_paddingRight: function() {
		return this._paddingRight;
	},
	set_paddingRight: function(value) {
		if(this._paddingRight == value) {
			return this._paddingRight;
		}
		this._paddingRight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingRight;
	},
	get_paddingBottom: function() {
		return this._paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(this._paddingBottom == value) {
			return this._paddingBottom;
		}
		this._paddingBottom = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingBottom;
	},
	get_paddingLeft: function() {
		return this._paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(this._paddingLeft == value) {
			return this._paddingLeft;
		}
		this._paddingLeft = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingLeft;
	},
	get_gap: function() {
		return this._gap;
	},
	set_gap: function(value) {
		if(this._gap == value) {
			return this._gap;
		}
		this._gap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._gap;
	},
	get_verticalAlign: function() {
		return this._verticalAlign;
	},
	set_verticalAlign: function(value) {
		if(this._verticalAlign == value) {
			return this._verticalAlign;
		}
		this._verticalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._verticalAlign;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	layout: function(items,measurements,result) {
		this.validateItems(items);
		var maxMaxLeftTextWidth = 1.0 / 0.0;
		var maxMaxRightTextWidth = 1.0 / 0.0;
		var maxLeftTextWidth = 0.0;
		var maxRightTextWidth = 0.0;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			var layoutObject = null;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				layoutObject = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutObject.get_includeInLayout()) {
					continue;
				}
			}
			var formItem = (Std().default).downcast(item,(feathers_controls_FormItem().default));
			if(formItem == null) {
				continue;
			}
			switch(formItem.get_textPosition()._hx_index) {
			case 1:
				maxRightTextWidth = Math.max(maxRightTextWidth,formItem.getTextMeasuredWidth());
				maxMaxRightTextWidth = Math.min(maxMaxRightTextWidth,formItem.getTextMeasuredMaxWidth());
				break;
			case 3:
				maxLeftTextWidth = Math.max(maxLeftTextWidth,formItem.getTextMeasuredWidth());
				maxMaxLeftTextWidth = Math.min(maxMaxLeftTextWidth,formItem.getTextMeasuredMaxWidth());
				break;
			default:
				continue;
			}
		}
		if(maxLeftTextWidth > maxMaxLeftTextWidth) {
			maxLeftTextWidth = maxMaxLeftTextWidth;
		}
		if(maxRightTextWidth > maxMaxRightTextWidth) {
			maxRightTextWidth = maxMaxRightTextWidth;
		}
		var contentWidth = 0.0;
		var contentHeight = this._paddingTop;
		var _g1 = 0;
		while(_g1 < items.length) {
			var item1 = items[_g1];
			++_g1;
			var layoutObject1 = null;
			if((js_Boot().default).__implements(item1,(feathers_layout_ILayoutObject().default))) {
				layoutObject1 = (js_Boot().default).__cast(item1 , (feathers_layout_ILayoutObject().default));
				if(!layoutObject1.get_includeInLayout()) {
					continue;
				}
			}
			var formItem1 = (Std().default).downcast(item1,(feathers_controls_FormItem().default));
			if(formItem1 != null) {
				switch(formItem1.get_textPosition()._hx_index) {
				case 1:
					formItem1.set_customTextColumnWidth(maxRightTextWidth);
					break;
				case 3:
					formItem1.set_customTextColumnWidth(maxLeftTextWidth);
					break;
				default:
					formItem1.set_customTextColumnWidth(null);
				}
				if((js_Boot().default).__implements(item1,(feathers_core_IValidating().default))) {
					((js_Boot().default).__cast(item1 , (feathers_core_IValidating().default))).validateNow();
				}
			}
			if(contentWidth < item1.get_width()) {
				contentWidth = item1.get_width();
			}
			item1.set_x(this._paddingLeft);
			item1.set_y(contentHeight);
			contentHeight += item1.get_height() + this._gap;
		}
		contentWidth += this._paddingLeft + this._paddingRight;
		contentHeight += this._paddingBottom;
		if(items.length > 0) {
			contentHeight -= this._gap;
		}
		var viewPortWidth = contentWidth;
		if(measurements.width != null) {
			viewPortWidth = measurements.width;
		} else if(measurements.minWidth != null && viewPortWidth < measurements.minWidth) {
			viewPortWidth = measurements.minWidth;
		} else if(measurements.maxWidth != null && viewPortWidth > measurements.maxWidth) {
			viewPortWidth = measurements.maxWidth;
		}
		var viewPortHeight = contentHeight;
		if(measurements.height != null) {
			viewPortHeight = measurements.height;
		} else if(measurements.minHeight != null && viewPortHeight < measurements.minHeight) {
			viewPortHeight = measurements.minHeight;
		} else if(measurements.maxHeight != null && viewPortHeight > measurements.maxHeight) {
			viewPortHeight = measurements.maxHeight;
		}
		this.applyHorizontalAlign(items,viewPortWidth);
		this.applyVerticalAlign(items,contentHeight - this._paddingTop - this._paddingBottom,viewPortHeight);
		if(contentWidth < viewPortWidth) {
			contentWidth = viewPortWidth;
		}
		if(contentHeight < viewPortHeight) {
			contentHeight = viewPortHeight;
		}
		if(result == null) {
			result = new (feathers_layout_LayoutBoundsResult().default)();
		}
		result.contentX = 0.0;
		result.contentY = 0.0;
		result.contentWidth = contentWidth;
		result.contentHeight = contentHeight;
		result.viewPortWidth = viewPortWidth;
		result.viewPortHeight = viewPortHeight;
		return result;
	},
	validateItems: function(items) {
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
		}
	},
	applyHorizontalAlign: function(items,viewPortWidth) {
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			var layoutObject = null;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				layoutObject = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutObject.get_includeInLayout()) {
					continue;
				}
			}
			item.set_width(viewPortWidth - this._paddingLeft - this._paddingRight);
		}
	},
	applyVerticalAlign: function(items,contentHeight,viewPortHeight) {
		if(this._verticalAlign != (feathers_layout_VerticalAlign().default).BOTTOM && this._verticalAlign != (feathers_layout_VerticalAlign().default).MIDDLE) {
			return;
		}
		var maxAlignmentHeight = viewPortHeight - this._paddingTop - this._paddingBottom;
		if(contentHeight >= maxAlignmentHeight) {
			return;
		}
		var verticalOffset = 0.0;
		if(this._verticalAlign == (feathers_layout_VerticalAlign().default).BOTTOM) {
			verticalOffset = maxAlignmentHeight - contentHeight;
		} else if(this._verticalAlign == (feathers_layout_VerticalAlign().default).MIDDLE) {
			verticalOffset = (maxAlignmentHeight - contentHeight) / 2.0;
		}
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			var layoutObject = null;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				layoutObject = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutObject.get_includeInLayout()) {
					continue;
				}
			}
			item.set_y(Math.max(this._paddingTop,item.get_y() + verticalOffset));
		}
	}
});
FormLayout.prototype.__class__ = FormLayout.prototype.constructor = $hxClasses["feathers.layout.FormLayout"] = FormLayout;

// Init



// Statics




// Export

exports["default"] = FormLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/GridViewRowLayout.js":
/*!*******************************************************!*\
  !*** ./lib/_gen/feathers/layout/GridViewRowLayout.js ***!
  \*******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.GridViewRowLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_ILayout() {return __webpack_require__(/*! ./../../feathers/layout/ILayout */ "./lib/_gen/feathers/layout/ILayout.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}

// Constructor

var GridViewRowLayout = function() {
	this._heightResetEnabled = true;
	this._paddingRight = 0.0;
	this._paddingLeft = 0.0;
	(openfl_events_EventDispatcher()).call(this);
}

// Meta

GridViewRowLayout.__name__ = "feathers.layout.GridViewRowLayout";
GridViewRowLayout.__isInterface__ = false;
GridViewRowLayout.__interfaces__ = [(feathers_layout_ILayout().default)];
GridViewRowLayout.__super__ = (openfl_events_EventDispatcher());
GridViewRowLayout.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_paddingLeft: function() {
		return this._paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(this._paddingLeft == value) {
			return this._paddingLeft;
		}
		this._paddingLeft = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingLeft;
	},
	get_paddingRight: function() {
		return this._paddingRight;
	},
	set_paddingRight: function(value) {
		if(this._paddingRight == value) {
			return this._paddingRight;
		}
		this._paddingRight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingRight;
	},
	get_columns: function() {
		return this._columns;
	},
	set_columns: function(value) {
		if(this._columns == value) {
			return this._columns;
		}
		this._columns = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._columns;
	},
	get_customColumnWidths: function() {
		return this._customColumnWidths;
	},
	set_customColumnWidths: function(value) {
		if(this._customColumnWidths == value) {
			return this._customColumnWidths;
		}
		this._customColumnWidths = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._customColumnWidths;
	},
	get_heightResetEnabled: function() {
		return this._heightResetEnabled;
	},
	set_heightResetEnabled: function(value) {
		if(this._heightResetEnabled == value) {
			return this._heightResetEnabled;
		}
		this._heightResetEnabled = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._heightResetEnabled;
	},
	setPadding: function(value) {
		this.set_paddingRight(value);
		this.set_paddingLeft(value);
	},
	layout: function(items,measurements,result) {
		this.applyColumnWidths(items,measurements.width,measurements.minWidth,measurements.maxWidth);
		var contentWidth = this._paddingLeft;
		var contentHeight = 0.0;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			if(this._heightResetEnabled && measurements.height == null && (js_Boot().default).__implements(item,(feathers_core_IMeasureObject().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IMeasureObject().default))).resetHeight();
			}
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
			if(contentHeight < item.get_height()) {
				contentHeight = item.get_height();
			}
			item.set_x(contentWidth);
			contentWidth += item.get_width();
		}
		var viewPortWidth = contentWidth += this._paddingRight;
		if(measurements.width != null) {
			viewPortWidth = measurements.width;
		} else if(measurements.minWidth != null && viewPortWidth < measurements.minWidth) {
			viewPortWidth = measurements.minWidth;
		} else if(measurements.maxWidth != null && viewPortWidth > measurements.maxWidth) {
			viewPortWidth = measurements.maxWidth;
		}
		var viewPortHeight = contentHeight;
		if(measurements.height != null) {
			viewPortHeight = measurements.height;
		} else if(measurements.minHeight != null && viewPortHeight < measurements.minHeight) {
			viewPortHeight = measurements.minHeight;
		} else if(measurements.maxHeight != null && viewPortHeight > measurements.maxHeight) {
			viewPortHeight = measurements.maxHeight;
		}
		this.applyViewPortHeight(items,viewPortHeight);
		if(contentWidth < viewPortWidth) {
			contentWidth = viewPortWidth;
		}
		if(contentHeight < viewPortHeight) {
			contentHeight = viewPortHeight;
		}
		if(result == null) {
			result = new (feathers_layout_LayoutBoundsResult().default)();
		}
		result.contentX = 0.0;
		result.contentY = 0.0;
		result.contentWidth = contentWidth;
		result.contentHeight = contentHeight;
		result.viewPortWidth = viewPortWidth;
		result.viewPortHeight = viewPortHeight;
		return result;
	},
	validateItems: function(items) {
		var _g = 0;
		var _g1 = this._columns.get_length();
		while(_g < _g1) {
			var i = _g++;
			var column = this._columns.get(i);
			var item = items[i];
			var columnWidth = column.width;
			if(columnWidth != null) {
				item.set_width(columnWidth);
			} else if(this._customColumnWidths != null && i < this._customColumnWidths.length) {
				item.set_width(this._customColumnWidths[i]);
			}
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
		}
	},
	applyViewPortHeight: function(items,viewPortHeight) {
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			item.set_height(viewPortHeight);
		}
	},
	applyColumnWidths: function(items,explicitWidth,explicitMinWidth,explicitMaxWidth) {
		var pendingIndices = [];
		var totalMeasuredWidth = 0.0;
		var totalPercentWidth = 0.0;
		var maxMinWidth = 0.0;
		var _g = 0;
		var _g1 = this._columns.get_length();
		while(_g < _g1) {
			var i = _g++;
			var column = this._columns.get(i);
			var columnWidth = column.width;
			var item = items[i];
			if(columnWidth != null) {
				item.set_width(columnWidth);
				if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
					((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
				}
			} else if(this._customColumnWidths != null && i < this._customColumnWidths.length) {
				item.set_width(this._customColumnWidths[i]);
				if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
					((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
				}
			} else {
				var percentWidth = 100.0;
				var itemMinWidth = 0.0;
				if((js_Boot().default).__implements(item,(feathers_core_IMeasureObject().default))) {
					if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
						((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
					}
					itemMinWidth = ((js_Boot().default).__cast(item , (feathers_core_IMeasureObject().default))).get_minWidth();
				}
				itemMinWidth = Math.max(column.minWidth,itemMinWidth);
				maxMinWidth = Math.max(itemMinWidth,maxMinWidth);
				totalPercentWidth += percentWidth;
				pendingIndices.push(i);
				continue;
			}
			totalMeasuredWidth += item.get_width();
		}
		totalMeasuredWidth += this._paddingLeft + this._paddingRight;
		var remainingWidth = 0.0;
		if(explicitWidth != null) {
			remainingWidth = explicitWidth;
		} else {
			var totalMaxMinWidth = pendingIndices.length * maxMinWidth;
			remainingWidth = totalMeasuredWidth + totalMaxMinWidth;
			if(explicitMinWidth != null && remainingWidth < explicitMinWidth) {
				remainingWidth = explicitMinWidth;
			} else if(explicitMaxWidth != null && remainingWidth > explicitMaxWidth) {
				remainingWidth = explicitMaxWidth;
			}
		}
		remainingWidth -= totalMeasuredWidth;
		if(remainingWidth < 0.0) {
			remainingWidth = 0.0;
		}
		var needsAnotherPass = false;
		while(true) {
			needsAnotherPass = false;
			var widthSum = 0.0;
			var percentToPixels = remainingWidth / totalPercentWidth;
			var _g2 = 0;
			while(_g2 < pendingIndices.length) {
				var index = pendingIndices[_g2];
				++_g2;
				var item1 = items[index];
				var column1 = this._columns.get(index);
				var percentWidth1 = 100.0;
				var itemWidth = Math.floor(percentToPixels * percentWidth1);
				var columnMinWidth = column1.minWidth;
				if(columnMinWidth > remainingWidth) {
					columnMinWidth = remainingWidth;
				}
				if(itemWidth < columnMinWidth) {
					itemWidth = columnMinWidth;
					remainingWidth -= itemWidth;
					totalPercentWidth -= percentWidth1;
					(HxOverrides().default).remove(pendingIndices,index);
					needsAnotherPass = true;
				}
				item1.set_width(itemWidth);
				if((js_Boot().default).__implements(item1,(feathers_core_IValidating().default))) {
					((js_Boot().default).__cast(item1 , (feathers_core_IValidating().default))).validateNow();
				}
				widthSum += itemWidth;
			}
			if(needsAnotherPass) {
				widthSum = 0.0;
			} else {
				remainingWidth -= widthSum;
			}
			if(!needsAnotherPass) {
				break;
			}
		}
		if(remainingWidth > 0.0 && pendingIndices.length > 0) {
			var index1 = pendingIndices[pendingIndices.length - 1];
			var finalItem = items[index1];
			var _g21 = finalItem;
			_g21.set_width(_g21.get_width() + remainingWidth);
		}
	}
});
GridViewRowLayout.prototype.__class__ = GridViewRowLayout.prototype.constructor = $hxClasses["feathers.layout.GridViewRowLayout"] = GridViewRowLayout;

// Init



// Statics




// Export

exports["default"] = GridViewRowLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/HDividedBoxLayout.js":
/*!*******************************************************!*\
  !*** ./lib/_gen/feathers/layout/HDividedBoxLayout.js ***!
  \*******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.HDividedBoxLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_ILayout() {return __webpack_require__(/*! ./../../feathers/layout/ILayout */ "./lib/_gen/feathers/layout/ILayout.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}

// Constructor

var HDividedBoxLayout = function() {
	this._fallbackFluidIndex = -1;
	this._verticalAlign = (feathers_layout_VerticalAlign().default).JUSTIFY;
	this._paddingLeft = 0.0;
	this._paddingBottom = 0.0;
	this._paddingRight = 0.0;
	this._paddingTop = 0.0;
	(openfl_events_EventDispatcher()).call(this);
}

// Meta

HDividedBoxLayout.__name__ = "feathers.layout.HDividedBoxLayout";
HDividedBoxLayout.__isInterface__ = false;
HDividedBoxLayout.__interfaces__ = [(feathers_layout_ILayout().default)];
HDividedBoxLayout.__super__ = (openfl_events_EventDispatcher());
HDividedBoxLayout.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_paddingTop: function() {
		return this._paddingTop;
	},
	set_paddingTop: function(value) {
		if(this._paddingTop == value) {
			return this._paddingTop;
		}
		this._paddingTop = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingTop;
	},
	get_paddingRight: function() {
		return this._paddingRight;
	},
	set_paddingRight: function(value) {
		if(this._paddingRight == value) {
			return this._paddingRight;
		}
		this._paddingRight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingRight;
	},
	get_paddingBottom: function() {
		return this._paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(this._paddingBottom == value) {
			return this._paddingBottom;
		}
		this._paddingBottom = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingBottom;
	},
	get_paddingLeft: function() {
		return this._paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(this._paddingLeft == value) {
			return this._paddingLeft;
		}
		this._paddingLeft = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingLeft;
	},
	get_verticalAlign: function() {
		return this._verticalAlign;
	},
	set_verticalAlign: function(value) {
		if(this._verticalAlign == value) {
			return this._verticalAlign;
		}
		this._verticalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._verticalAlign;
	},
	get_customItemWidths: function() {
		return this._customItemWidths;
	},
	set_customItemWidths: function(value) {
		if(this._customItemWidths == value) {
			return this._customItemWidths;
		}
		this._customItemWidths = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._customItemWidths;
	},
	get_fallbackFluidIndex: function() {
		return this._fallbackFluidIndex;
	},
	set_fallbackFluidIndex: function(value) {
		if(this._fallbackFluidIndex == value) {
			return this._fallbackFluidIndex;
		}
		this._fallbackFluidIndex = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._fallbackFluidIndex;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	layout: function(items,measurements,result) {
		this.validateItems(items);
		this.applyPercentWidth(items,measurements.width,measurements.minWidth,measurements.maxWidth);
		var contentWidth = this._paddingLeft;
		var contentHeight = 0.0;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
			if(contentHeight < item.get_height()) {
				contentHeight = item.get_height();
			}
			item.set_x(contentWidth);
			contentWidth += item.get_width();
		}
		contentWidth += this._paddingRight;
		contentHeight += this._paddingTop + this._paddingBottom;
		var viewPortWidth = contentWidth;
		if(measurements.width != null) {
			viewPortWidth = measurements.width;
		} else if(measurements.minWidth != null && viewPortWidth < measurements.minWidth) {
			viewPortWidth = measurements.minWidth;
		} else if(measurements.maxWidth != null && viewPortWidth > measurements.maxWidth) {
			viewPortWidth = measurements.maxWidth;
		}
		var viewPortHeight = contentHeight;
		if(measurements.height != null) {
			viewPortHeight = measurements.height;
		} else if(measurements.minHeight != null && viewPortHeight < measurements.minHeight) {
			viewPortHeight = measurements.minHeight;
		} else if(measurements.maxHeight != null && viewPortHeight > measurements.maxHeight) {
			viewPortHeight = measurements.maxHeight;
		}
		this.applyPercentHeight(items,viewPortHeight);
		this.applyVerticalAlign(items,viewPortHeight);
		if(contentWidth < viewPortWidth) {
			contentWidth = viewPortWidth;
		}
		if(contentHeight < viewPortHeight) {
			contentHeight = viewPortHeight;
		}
		if(result == null) {
			result = new (feathers_layout_LayoutBoundsResult().default)();
		}
		result.contentX = 0.0;
		result.contentY = 0.0;
		result.contentWidth = contentWidth;
		result.contentHeight = contentHeight;
		result.viewPortWidth = viewPortWidth;
		result.viewPortHeight = viewPortHeight;
		return result;
	},
	validateItems: function(items) {
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var item = items[i];
			var isDivider = i % 2 == 1;
			if(!isDivider) {
				if(this._customItemWidths != null && i < this._customItemWidths.length) {
					var itemWidth = this._customItemWidths[i];
					if(itemWidth != null) {
						item.set_width(itemWidth);
					}
				}
			}
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
		}
	},
	applyVerticalAlign: function(items,viewPortHeight) {
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var isDivider = i % 2 == 1;
			if(!isDivider) {
				continue;
			}
			var item = items[i];
			switch(this._verticalAlign._hx_index) {
			case 0:
				item.set_y(this._paddingTop);
				break;
			case 1:
				item.set_y(Math.max(this._paddingTop,this._paddingTop + (viewPortHeight - this._paddingTop - this._paddingBottom - item.get_height()) / 2.0));
				break;
			case 2:
				item.set_y(Math.max(this._paddingTop,this._paddingTop + (viewPortHeight - this._paddingTop - this._paddingBottom) - item.get_height()));
				break;
			case 3:
				item.set_y(this._paddingTop);
				item.set_height(viewPortHeight - this._paddingTop - this._paddingBottom);
				break;
			}
		}
	},
	applyPercentWidth: function(items,explicitWidth,explicitMinWidth,explicitMaxWidth) {
		var customWidthIndices = [];
		var pendingIndices = [];
		var totalMeasuredWidth = 0.0;
		var totalMinWidth = 0.0;
		var totalPercentWidth = 0.0;
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var item = items[i];
			var isDivider = i % 2 == 1;
			if(!isDivider) {
				var nonDividerIndex = Math.floor(i / 2);
				var needsPercentWidth = true;
				if(this._customItemWidths != null && nonDividerIndex < this._customItemWidths.length) {
					var itemWidth = this._customItemWidths[nonDividerIndex];
					if(itemWidth != null) {
						needsPercentWidth = false;
						item.set_width(itemWidth);
						customWidthIndices.push(i);
						if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
							((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
						}
					}
				}
				if(needsPercentWidth) {
					var percentWidth = 100.0;
					if((js_Boot().default).__implements(item,(feathers_core_IMeasureObject().default))) {
						var measureItem = (js_Boot().default).__cast(item , (feathers_core_IMeasureObject().default));
						var columnExplicitMinWidth = measureItem.get_explicitMinWidth();
						if(columnExplicitMinWidth != null) {
							totalMinWidth += columnExplicitMinWidth;
						}
					}
					totalPercentWidth += percentWidth;
					pendingIndices.push(i);
					continue;
				}
			}
			totalMeasuredWidth += item.get_width();
		}
		totalMeasuredWidth += this._paddingLeft + this._paddingRight;
		var remainingWidth = 0.0;
		if(explicitWidth != null) {
			remainingWidth = explicitWidth;
		} else {
			remainingWidth = totalMeasuredWidth + totalMinWidth;
			if(explicitMinWidth != null && remainingWidth < explicitMinWidth) {
				remainingWidth = explicitMinWidth;
			} else if(explicitMaxWidth != null && remainingWidth > explicitMaxWidth) {
				remainingWidth = explicitMaxWidth;
			}
		}
		remainingWidth -= totalMeasuredWidth;
		var needsAnotherPass = false;
		while(true) {
			needsAnotherPass = false;
			var widthSum = 0.0;
			var percentToPixels = remainingWidth / totalPercentWidth;
			if(percentToPixels < 0.0) {
				percentToPixels = 0.0;
			}
			var _g2 = 0;
			while(_g2 < pendingIndices.length) {
				var index = pendingIndices[_g2];
				++_g2;
				var item1 = items[index];
				var percentWidth1 = 100.0;
				var itemWidth1 = Math.floor(percentToPixels * percentWidth1);
				var columnMinWidth = null;
				if((js_Boot().default).__implements(item1,(feathers_core_IMeasureObject().default))) {
					var measureItem1 = (js_Boot().default).__cast(item1 , (feathers_core_IMeasureObject().default));
					columnMinWidth = measureItem1.get_explicitMinWidth();
				}
				if(columnMinWidth != null) {
					if(columnMinWidth > remainingWidth) {
						columnMinWidth = remainingWidth;
					}
					if(itemWidth1 < columnMinWidth) {
						itemWidth1 = columnMinWidth;
						remainingWidth -= itemWidth1;
						totalPercentWidth -= percentWidth1;
						(HxOverrides().default).remove(pendingIndices,index);
						needsAnotherPass = true;
					}
				}
				item1.set_width(itemWidth1);
				if((js_Boot().default).__implements(item1,(feathers_core_IValidating().default))) {
					((js_Boot().default).__cast(item1 , (feathers_core_IValidating().default))).validateNow();
				}
				widthSum += itemWidth1;
			}
			if(needsAnotherPass) {
				widthSum = 0.0;
			} else {
				remainingWidth -= widthSum;
			}
			if(!needsAnotherPass) {
				break;
			}
		}
		if(remainingWidth > 0.0 && pendingIndices.length > 0) {
			var index1 = pendingIndices[pendingIndices.length - 1];
			var finalItem = items[index1];
			var _g21 = finalItem;
			_g21.set_width(_g21.get_width() + remainingWidth);
			return;
		}
		if(remainingWidth == 0.0) {
			return;
		}
		var index2 = this._fallbackFluidIndex;
		if(index2 == -1) {
			index2 = items.length - 1;
		}
		if(index2 != -1) {
			var fallbackItem = items[index2];
			var itemWidth2 = fallbackItem.get_width() + remainingWidth;
			if(itemWidth2 < 0.0) {
				remainingWidth = itemWidth2;
				itemWidth2 = 0.0;
				(HxOverrides().default).remove(customWidthIndices,index2);
			} else {
				remainingWidth = 0.0;
			}
			fallbackItem.set_width(itemWidth2);
		}
		if(remainingWidth == 0.0) {
			return;
		}
		var offset = remainingWidth / customWidthIndices.length;
		var _g22 = 0;
		while(_g22 < customWidthIndices.length) {
			var index3 = customWidthIndices[_g22];
			++_g22;
			var item2 = items[index3];
			var _g23 = item2;
			_g23.set_width(_g23.get_width() + offset);
		}
	},
	applyPercentHeight: function(items,viewPortHeight) {
		var availableHeight = viewPortHeight - this._paddingTop - this._paddingBottom;
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var isDivider = i % 2 == 1;
			if(isDivider) {
				continue;
			}
			var item = items[i];
			var itemHeight = availableHeight;
			if((js_Boot().default).__implements(item,(feathers_core_IMeasureObject().default))) {
				var measureItem = (js_Boot().default).__cast(item , (feathers_core_IMeasureObject().default));
				var itemMinHeight = measureItem.get_explicitMinHeight();
				if(itemMinHeight != null) {
					if(itemMinHeight > availableHeight) {
						itemMinHeight = availableHeight;
					}
					if(itemHeight < itemMinHeight) {
						itemHeight = itemMinHeight;
					}
				}
				var itemMaxHeight = measureItem.get_explicitMaxHeight();
				if(itemMaxHeight != null && itemHeight > itemMaxHeight) {
					itemHeight = itemMaxHeight;
				}
			}
			item.set_height(itemHeight);
		}
	}
});
HDividedBoxLayout.prototype.__class__ = HDividedBoxLayout.prototype.constructor = $hxClasses["feathers.layout.HDividedBoxLayout"] = HDividedBoxLayout;

// Init



// Statics




// Export

exports["default"] = HDividedBoxLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/HorizontalAlign.js":
/*!*****************************************************!*\
  !*** ./lib/_gen/feathers/layout/HorizontalAlign.js ***!
  \*****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.layout.HorizontalAlign

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var HorizontalAlign = $hxEnums["feathers.layout.HorizontalAlign"] = { __ename__ : "feathers.layout.HorizontalAlign", __constructs__ : ["LEFT","CENTER","RIGHT","JUSTIFY"]
  ,RIGHT: {_hx_index:2,__enum__:"feathers.layout.HorizontalAlign",toString:$estr}
  ,LEFT: {_hx_index:0,__enum__:"feathers.layout.HorizontalAlign",toString:$estr}
  ,JUSTIFY: {_hx_index:3,__enum__:"feathers.layout.HorizontalAlign",toString:$estr}
  ,CENTER: {_hx_index:1,__enum__:"feathers.layout.HorizontalAlign",toString:$estr}
};

exports["default"] = HorizontalAlign;

/***/ }),

/***/ "./lib/_gen/feathers/layout/HorizontalDistributedLayout.js":
/*!*****************************************************************!*\
  !*** ./lib/_gen/feathers/layout/HorizontalDistributedLayout.js ***!
  \*****************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.HorizontalDistributedLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_ILayout() {return __webpack_require__(/*! ./../../feathers/layout/ILayout */ "./lib/_gen/feathers/layout/ILayout.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_ILayoutObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutObject */ "./lib/_gen/feathers/layout/ILayoutObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}

// Constructor

var HorizontalDistributedLayout = function() {
	this._verticalAlign = (feathers_layout_VerticalAlign().default).TOP;
	this._minItemWidth = 0.0;
	this._maxItemWidth = 1.0 / 0.0;
	this._gap = 0.0;
	this._paddingLeft = 0.0;
	this._paddingBottom = 0.0;
	this._paddingRight = 0.0;
	this._paddingTop = 0.0;
	(openfl_events_EventDispatcher()).call(this);
}

// Meta

HorizontalDistributedLayout.__name__ = "feathers.layout.HorizontalDistributedLayout";
HorizontalDistributedLayout.__isInterface__ = false;
HorizontalDistributedLayout.__interfaces__ = [(feathers_layout_ILayout().default)];
HorizontalDistributedLayout.__super__ = (openfl_events_EventDispatcher());
HorizontalDistributedLayout.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_paddingTop: function() {
		return this._paddingTop;
	},
	set_paddingTop: function(value) {
		if(this._paddingTop == value) {
			return this._paddingTop;
		}
		this._paddingTop = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingTop;
	},
	get_paddingRight: function() {
		return this._paddingRight;
	},
	set_paddingRight: function(value) {
		if(this._paddingRight == value) {
			return this._paddingRight;
		}
		this._paddingRight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingRight;
	},
	get_paddingBottom: function() {
		return this._paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(this._paddingBottom == value) {
			return this._paddingBottom;
		}
		this._paddingBottom = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingBottom;
	},
	get_paddingLeft: function() {
		return this._paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(this._paddingLeft == value) {
			return this._paddingLeft;
		}
		this._paddingLeft = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingLeft;
	},
	get_gap: function() {
		return this._gap;
	},
	set_gap: function(value) {
		if(this._gap == value) {
			return this._gap;
		}
		this._gap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._gap;
	},
	get_maxItemWidth: function() {
		return this._maxItemWidth;
	},
	set_maxItemWidth: function(value) {
		if(this._maxItemWidth == value) {
			return this._maxItemWidth;
		}
		this._maxItemWidth = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._maxItemWidth;
	},
	get_minItemWidth: function() {
		return this._minItemWidth;
	},
	set_minItemWidth: function(value) {
		if(this._minItemWidth == value) {
			return this._minItemWidth;
		}
		this._minItemWidth = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._minItemWidth;
	},
	get_verticalAlign: function() {
		return this._verticalAlign;
	},
	set_verticalAlign: function(value) {
		if(this._verticalAlign == value) {
			return this._verticalAlign;
		}
		this._verticalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._verticalAlign;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	layout: function(items,measurements,result) {
		this.applyDistributedWidth(items,measurements.width,measurements.minWidth,measurements.maxWidth);
		var contentWidth = this._paddingLeft;
		var contentHeight = 0.0;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			var layoutObject = null;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				layoutObject = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutObject.get_includeInLayout()) {
					continue;
				}
			}
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
			if(contentHeight < item.get_height()) {
				contentHeight = item.get_height();
			}
			item.set_x(contentWidth);
			contentWidth += item.get_width() + this._gap;
		}
		contentWidth += this._paddingRight;
		if(items.length > 0) {
			contentWidth -= this._gap;
		}
		contentHeight += this._paddingTop + this._paddingBottom;
		var viewPortWidth = contentWidth;
		if(measurements.width != null) {
			viewPortWidth = measurements.width;
		} else if(measurements.minWidth != null && viewPortWidth < measurements.minWidth) {
			viewPortWidth = measurements.minWidth;
		} else if(measurements.maxWidth != null && viewPortWidth > measurements.maxWidth) {
			viewPortWidth = measurements.maxWidth;
		}
		var viewPortHeight = contentHeight;
		if(measurements.height != null) {
			viewPortHeight = measurements.height;
		} else if(measurements.minHeight != null && viewPortHeight < measurements.minHeight) {
			viewPortHeight = measurements.minHeight;
		} else if(measurements.maxHeight != null && viewPortHeight > measurements.maxHeight) {
			viewPortHeight = measurements.maxHeight;
		}
		this.applyVerticalAlign(items,viewPortHeight);
		if(contentWidth < viewPortWidth) {
			contentWidth = viewPortWidth;
		}
		if(contentHeight < viewPortHeight) {
			contentHeight = viewPortHeight;
		}
		if(result == null) {
			result = new (feathers_layout_LayoutBoundsResult().default)();
		}
		result.contentX = 0.0;
		result.contentY = 0.0;
		result.contentWidth = contentWidth;
		result.contentHeight = contentHeight;
		result.viewPortWidth = viewPortWidth;
		result.viewPortHeight = viewPortHeight;
		return result;
	},
	applyDistributedWidth: function(items,explicitWidth,explicitMinWidth,explicitMaxWidth) {
		var maxMinWidth = 0.0;
		var totalPercentWidth = 0.0;
		var itemsInLayoutCount = 0;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				var layoutObject = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutObject.get_includeInLayout()) {
					continue;
				}
			}
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
			var itemMinWidth = 0.0;
			if((js_Boot().default).__implements(item,(feathers_core_IMeasureObject().default))) {
				var measureItem = (js_Boot().default).__cast(item , (feathers_core_IMeasureObject().default));
				itemMinWidth = measureItem.get_minWidth();
			} else {
				itemMinWidth = item.get_width();
			}
			if(maxMinWidth < itemMinWidth) {
				maxMinWidth = itemMinWidth;
			}
			totalPercentWidth += 100.0;
			++itemsInLayoutCount;
		}
		var remainingWidth = 0.0;
		if(explicitWidth != null) {
			remainingWidth = explicitWidth;
		} else {
			remainingWidth = this._paddingLeft + this._paddingRight + (maxMinWidth + this._gap) * itemsInLayoutCount - this._gap;
			if(explicitMinWidth != null && remainingWidth < explicitMinWidth) {
				remainingWidth = explicitMinWidth;
			} else if(explicitMaxWidth != null && remainingWidth > explicitMaxWidth) {
				remainingWidth = explicitMaxWidth;
			}
		}
		remainingWidth -= this._paddingLeft + this._paddingRight + this._gap * (itemsInLayoutCount - 1);
		if(remainingWidth < 0.0) {
			remainingWidth = 0.0;
		}
		var percentToPixels = remainingWidth / totalPercentWidth;
		var _g1 = 0;
		while(_g1 < items.length) {
			var item1 = items[_g1];
			++_g1;
			if((js_Boot().default).__implements(item1,(feathers_layout_ILayoutObject().default))) {
				var layoutObject1 = (js_Boot().default).__cast(item1 , (feathers_layout_ILayoutObject().default));
				if(!layoutObject1.get_includeInLayout()) {
					continue;
				}
			}
			var itemWidth = percentToPixels * 100.0;
			if(itemWidth < this._minItemWidth) {
				itemWidth = this._minItemWidth;
			} else if(itemWidth > this._maxItemWidth) {
				itemWidth = this._maxItemWidth;
			}
			item1.set_width(itemWidth);
			if((js_Boot().default).__implements(item1,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item1 , (feathers_core_IValidating().default))).validateNow();
			}
		}
	},
	applyVerticalAlign: function(items,viewPortHeight) {
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			var layoutObject = null;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				layoutObject = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutObject.get_includeInLayout()) {
					continue;
				}
			}
			switch(this._verticalAlign._hx_index) {
			case 0:
				item.set_y(this._paddingTop);
				break;
			case 1:
				item.set_y(Math.max(this._paddingTop,this._paddingTop + (viewPortHeight - this._paddingTop - this._paddingBottom - item.get_height()) / 2.0));
				break;
			case 2:
				item.set_y(Math.max(this._paddingTop,this._paddingTop + (viewPortHeight - this._paddingTop - this._paddingBottom) - item.get_height()));
				break;
			case 3:
				item.set_y(this._paddingTop);
				item.set_height(viewPortHeight - this._paddingTop - this._paddingBottom);
				break;
			}
		}
	}
});
HorizontalDistributedLayout.prototype.__class__ = HorizontalDistributedLayout.prototype.constructor = $hxClasses["feathers.layout.HorizontalDistributedLayout"] = HorizontalDistributedLayout;

// Init



// Statics




// Export

exports["default"] = HorizontalDistributedLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/HorizontalLayout.js":
/*!******************************************************!*\
  !*** ./lib/_gen/feathers/layout/HorizontalLayout.js ***!
  \******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.HorizontalLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_ILayout() {return __webpack_require__(/*! ./../../feathers/layout/ILayout */ "./lib/_gen/feathers/layout/ILayout.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_ILayoutObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutObject */ "./lib/_gen/feathers/layout/ILayoutObject.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_layout_HorizontalLayoutData() {return __webpack_require__(/*! ./../../feathers/layout/HorizontalLayoutData */ "./lib/_gen/feathers/layout/HorizontalLayoutData.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function openfl_display_DisplayObject() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObject);}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}

// Constructor

var HorizontalLayout = function() {
	this._percentHeightResetEnabled = false;
	this._percentWidthResetEnabled = false;
	this._justifyResetEnabled = false;
	this._verticalAlign = (feathers_layout_VerticalAlign().default).TOP;
	this._horizontalAlign = (feathers_layout_HorizontalAlign().default).LEFT;
	this._minGap = 0.0;
	this._gap = 0.0;
	this._paddingLeft = 0.0;
	this._paddingBottom = 0.0;
	this._paddingRight = 0.0;
	this._paddingTop = 0.0;
	(openfl_events_EventDispatcher()).call(this);
}

// Meta

HorizontalLayout.__name__ = "feathers.layout.HorizontalLayout";
HorizontalLayout.__isInterface__ = false;
HorizontalLayout.__interfaces__ = [(feathers_layout_ILayout().default)];
HorizontalLayout.__super__ = (openfl_events_EventDispatcher());
HorizontalLayout.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_paddingTop: function() {
		return this._paddingTop;
	},
	set_paddingTop: function(value) {
		if(this._paddingTop == value) {
			return this._paddingTop;
		}
		this._paddingTop = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingTop;
	},
	get_paddingRight: function() {
		return this._paddingRight;
	},
	set_paddingRight: function(value) {
		if(this._paddingRight == value) {
			return this._paddingRight;
		}
		this._paddingRight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingRight;
	},
	get_paddingBottom: function() {
		return this._paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(this._paddingBottom == value) {
			return this._paddingBottom;
		}
		this._paddingBottom = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingBottom;
	},
	get_paddingLeft: function() {
		return this._paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(this._paddingLeft == value) {
			return this._paddingLeft;
		}
		this._paddingLeft = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingLeft;
	},
	get_gap: function() {
		return this._gap;
	},
	set_gap: function(value) {
		if(this._gap == value) {
			return this._gap;
		}
		this._gap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._gap;
	},
	get_minGap: function() {
		return this._minGap;
	},
	set_minGap: function(value) {
		if(this._minGap == value) {
			return this._minGap;
		}
		this._minGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._minGap;
	},
	get_horizontalAlign: function() {
		return this._horizontalAlign;
	},
	set_horizontalAlign: function(value) {
		if(this._horizontalAlign == value) {
			return this._horizontalAlign;
		}
		this._horizontalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._horizontalAlign;
	},
	get_verticalAlign: function() {
		return this._verticalAlign;
	},
	set_verticalAlign: function(value) {
		if(this._verticalAlign == value) {
			return this._verticalAlign;
		}
		this._verticalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._verticalAlign;
	},
	get_justifyResetEnabled: function() {
		return this._justifyResetEnabled;
	},
	set_justifyResetEnabled: function(value) {
		if(this._justifyResetEnabled == value) {
			return this._justifyResetEnabled;
		}
		this._justifyResetEnabled = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._justifyResetEnabled;
	},
	get_percentWidthResetEnabled: function() {
		return this._percentWidthResetEnabled;
	},
	set_percentWidthResetEnabled: function(value) {
		if(this._percentWidthResetEnabled == value) {
			return this._percentWidthResetEnabled;
		}
		this._percentWidthResetEnabled = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._percentWidthResetEnabled;
	},
	get_percentHeightResetEnabled: function() {
		return this._percentHeightResetEnabled;
	},
	set_percentHeightResetEnabled: function(value) {
		if(this._percentHeightResetEnabled == value) {
			return this._percentHeightResetEnabled;
		}
		this._percentHeightResetEnabled = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._percentHeightResetEnabled;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	layout: function(items,measurements,result) {
		var adjustedGap = this._gap;
		var hasFlexGap = this._gap == 1.0 / 0.0;
		if(hasFlexGap) {
			adjustedGap = this._minGap;
		}
		this.validateItems(items,measurements);
		this.applyPercentWidth(items,measurements.width,measurements.minWidth,measurements.maxWidth,adjustedGap);
		var contentWidth = this._paddingLeft;
		var contentHeight = 0.0;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			var layoutData = null;
			var layoutObject = null;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				layoutObject = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutObject.get_includeInLayout()) {
					continue;
				}
				layoutData = (Std().default).downcast(layoutObject.get_layoutData(),(feathers_layout_HorizontalLayoutData().default));
			}
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
			if(layoutData != null && layoutData.get_marginLeft() != null) {
				contentWidth += layoutData.get_marginLeft();
			}
			if(contentHeight < item.get_height()) {
				contentHeight = item.get_height();
			}
			item.set_x(contentWidth);
			contentWidth += item.get_width() + adjustedGap;
			if(layoutData != null && layoutData.get_marginRight() != null) {
				contentWidth += layoutData.get_marginRight();
			}
		}
		var maxItemHeight = contentHeight;
		contentWidth += this._paddingRight;
		if(items.length > 0) {
			contentWidth -= adjustedGap;
		}
		contentHeight += this._paddingTop + this._paddingBottom;
		var viewPortWidth = contentWidth;
		if(measurements.width != null) {
			viewPortWidth = measurements.width;
		} else if(measurements.minWidth != null && viewPortWidth < measurements.minWidth) {
			viewPortWidth = measurements.minWidth;
		} else if(measurements.maxWidth != null && viewPortWidth > measurements.maxWidth) {
			viewPortWidth = measurements.maxWidth;
		}
		var viewPortHeight = contentHeight;
		if(measurements.height != null) {
			viewPortHeight = measurements.height;
		} else if(measurements.minHeight != null && viewPortHeight < measurements.minHeight) {
			viewPortHeight = measurements.minHeight;
		} else if(measurements.maxHeight != null && viewPortHeight > measurements.maxHeight) {
			viewPortHeight = measurements.maxHeight;
		}
		this.applyPercentHeight(items,viewPortHeight);
		this.applyVerticalAlign(items,maxItemHeight,viewPortHeight);
		this.applyHorizontalAlign(items,contentWidth - this._paddingLeft - this._paddingRight,viewPortWidth);
		if(contentWidth < viewPortWidth) {
			contentWidth = viewPortWidth;
		}
		if(contentHeight < viewPortHeight) {
			contentHeight = viewPortHeight;
		}
		if(result == null) {
			result = new (feathers_layout_LayoutBoundsResult().default)();
		}
		result.contentX = 0.0;
		result.contentY = 0.0;
		result.contentWidth = contentWidth;
		result.contentHeight = contentHeight;
		result.viewPortWidth = viewPortWidth;
		result.viewPortHeight = viewPortHeight;
		return result;
	},
	validateItems: function(items,measurements) {
		var isJustified = this._verticalAlign == (feathers_layout_VerticalAlign().default).JUSTIFY;
		var explicitContentWidth = measurements.width;
		if(explicitContentWidth != null) {
			explicitContentWidth -= this._paddingLeft + this._paddingRight;
		}
		var explicitContentHeight = measurements.height;
		if(explicitContentHeight != null) {
			explicitContentHeight -= this._paddingTop + this._paddingBottom;
		}
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			var percentWidth = null;
			var percentHeight = null;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				var layoutItem = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutItem.get_includeInLayout()) {
					continue;
				}
				var layoutData = (Std().default).downcast(layoutItem.get_layoutData(),(feathers_layout_HorizontalLayoutData().default));
				if(layoutData != null) {
					percentWidth = layoutData.get_percentWidth();
					percentHeight = layoutData.get_percentHeight();
				}
			}
			if(isJustified) {
				if(explicitContentHeight != null) {
					item.set_height(explicitContentHeight);
				} else if(this._justifyResetEnabled && (js_Boot().default).__implements(item,(feathers_core_IMeasureObject().default))) {
					((js_Boot().default).__cast(item , (feathers_core_IMeasureObject().default))).resetHeight();
				}
			} else if(explicitContentHeight != null) {
				if(percentHeight != null) {
					if(percentHeight < 0.0) {
						percentHeight = 0.0;
					} else if(percentHeight > 100.0) {
						percentHeight = 100.0;
					}
					item.set_height(explicitContentHeight * (percentHeight / 100.0));
				}
			} else if(percentHeight != null && this._percentHeightResetEnabled && (js_Boot().default).__implements(item,(feathers_core_IMeasureObject().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IMeasureObject().default))).resetHeight();
			}
			if(percentWidth != null && this._percentWidthResetEnabled && explicitContentWidth == null && (js_Boot().default).__implements(item,(feathers_core_IMeasureObject().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IMeasureObject().default))).resetWidth();
			}
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
			if(isJustified && explicitContentHeight == null && measurements.maxHeight != null) {
				var maxExplicitContentHeight = measurements.maxHeight - this._paddingTop - this._paddingBottom;
				if(item.get_height() > maxExplicitContentHeight) {
					item.set_height(maxExplicitContentHeight);
					if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
						((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
					}
				}
			}
		}
	},
	applyVerticalAlign: function(items,maxItemHeight,viewPortHeight) {
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			var layoutObject = null;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				layoutObject = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutObject.get_includeInLayout()) {
					continue;
				}
			}
			switch(this._verticalAlign._hx_index) {
			case 0:
				item.set_y(this._paddingTop);
				break;
			case 1:
				item.set_y(Math.max(this._paddingTop,this._paddingTop + (viewPortHeight - this._paddingTop - this._paddingBottom - item.get_height()) / 2.0));
				break;
			case 2:
				item.set_y(Math.max(this._paddingTop,this._paddingTop + (viewPortHeight - this._paddingTop - this._paddingBottom) - item.get_height()));
				break;
			case 3:
				item.set_y(this._paddingTop);
				item.set_height(viewPortHeight - this._paddingTop - this._paddingBottom);
				break;
			}
		}
	},
	applyHorizontalAlign: function(items,contentWidth,viewPortWidth) {
		var alignOffset = 0.0;
		var gapOffset = 0.0;
		var maxAlignmentWidth = viewPortWidth - this._paddingLeft - this._paddingRight;
		var adjustedGap = this._gap;
		var hasFlexGap = this._gap == 1.0 / 0.0;
		if(hasFlexGap) {
			adjustedGap = this._minGap;
			if(items.length > 1 && maxAlignmentWidth > contentWidth) {
				adjustedGap += (maxAlignmentWidth - contentWidth) / (items.length - 1);
			}
			gapOffset = adjustedGap - this._minGap;
		} else {
			switch(this._horizontalAlign._hx_index) {
			case 0:
				alignOffset = 0.0;
				break;
			case 1:
				alignOffset = (maxAlignmentWidth - contentWidth) / 2.0;
				break;
			case 2:
				alignOffset = maxAlignmentWidth - contentWidth;
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown horizontal align: " + (Std().default).string(this._horizontalAlign)));
			}
			if(alignOffset < 0.0) {
				alignOffset = 0.0;
			}
		}
		if(alignOffset == 0.0 && gapOffset == 0.0) {
			return;
		}
		var totalOffset = alignOffset;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			var layoutObject = null;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				layoutObject = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutObject.get_includeInLayout()) {
					continue;
				}
			}
			item.set_x(Math.max(this._paddingLeft,item.get_x() + totalOffset));
			totalOffset += gapOffset;
		}
	},
	applyPercentWidth: function(items,explicitWidth,explicitMinWidth,explicitMaxWidth,adjustedGap) {
		var pendingItems = [];
		var totalMeasuredWidth = 0.0;
		var totalMinWidth = 0.0;
		var totalPercentWidth = 0.0;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				var layoutItem = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutItem.get_includeInLayout()) {
					continue;
				}
				var layoutData = (Std().default).downcast(layoutItem.get_layoutData(),(feathers_layout_HorizontalLayoutData().default));
				if(layoutData != null) {
					var percentWidth = layoutData.get_percentWidth();
					if(percentWidth != null) {
						if(percentWidth < 0.0) {
							percentWidth = 0.0;
						}
						if((js_Boot().default).__implements(layoutItem,(feathers_core_IMeasureObject().default))) {
							var measureItem = (js_Boot().default).__cast(layoutItem , (feathers_core_IMeasureObject().default));
							totalMinWidth += measureItem.get_minWidth();
						}
						totalPercentWidth += percentWidth;
						if(layoutData.get_marginLeft() != null) {
							totalMeasuredWidth += layoutData.get_marginLeft();
						}
						if(layoutData.get_marginRight() != null) {
							totalMeasuredWidth += layoutData.get_marginRight();
						}
						totalMeasuredWidth += adjustedGap;
						pendingItems.push(layoutItem);
						continue;
					}
				}
			}
			totalMeasuredWidth += item.get_width() + adjustedGap;
		}
		totalMeasuredWidth -= adjustedGap;
		totalMeasuredWidth += this._paddingLeft + this._paddingRight;
		if(totalPercentWidth < 100.0) {
			totalPercentWidth = 100.0;
		}
		var remainingWidth = 0.0;
		if(explicitWidth != null) {
			remainingWidth = explicitWidth;
		} else {
			remainingWidth = totalMeasuredWidth + totalMinWidth;
			if(explicitMinWidth != null && remainingWidth < explicitMinWidth) {
				remainingWidth = explicitMinWidth;
			} else if(explicitMaxWidth != null && remainingWidth > explicitMaxWidth) {
				remainingWidth = explicitMaxWidth;
			}
		}
		remainingWidth -= totalMeasuredWidth;
		if(remainingWidth < 0.0) {
			remainingWidth = 0.0;
		}
		var needsAnotherPass = true;
		while(needsAnotherPass) {
			needsAnotherPass = false;
			var percentToPixels = remainingWidth / totalPercentWidth;
			var _g1 = 0;
			while(_g1 < pendingItems.length) {
				var layoutItem1 = pendingItems[_g1];
				++_g1;
				var layoutData1 = (js_Boot().default).__cast(layoutItem1.get_layoutData() , (feathers_layout_HorizontalLayoutData().default));
				var percentWidth1 = layoutData1.get_percentWidth();
				if(percentWidth1 < 0.0) {
					percentWidth1 = 0.0;
				}
				var itemWidth = percentToPixels * percentWidth1;
				if((js_Boot().default).__implements(layoutItem1,(feathers_core_IMeasureObject().default))) {
					var measureItem1 = (js_Boot().default).__cast(layoutItem1 , (feathers_core_IMeasureObject().default));
					var itemMinWidth = measureItem1.get_explicitMinWidth();
					if(itemMinWidth != null && itemMinWidth > remainingWidth) {
						itemMinWidth = remainingWidth;
					}
					if(itemWidth < itemMinWidth) {
						itemWidth = itemMinWidth;
						remainingWidth -= itemWidth;
						totalPercentWidth -= percentWidth1;
						(HxOverrides().default).remove(pendingItems,layoutItem1);
						needsAnotherPass = true;
					}
				}
				((js_Boot().default).__cast(layoutItem1 , (openfl_display_DisplayObject()))).set_width(itemWidth);
				if((js_Boot().default).__implements(layoutItem1,(feathers_core_IValidating().default))) {
					((js_Boot().default).__cast(layoutItem1 , (feathers_core_IValidating().default))).validateNow();
				}
			}
		}
	},
	applyPercentHeight: function(items,viewPortHeight) {
		var availableHeight = viewPortHeight - this._paddingTop - this._paddingBottom;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			if(!(js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				continue;
			}
			var layoutItem = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
			if(!layoutItem.get_includeInLayout()) {
				continue;
			}
			var layoutData = (Std().default).downcast(layoutItem.get_layoutData(),(feathers_layout_HorizontalLayoutData().default));
			if(layoutData == null) {
				continue;
			}
			var percentHeight = layoutData.get_percentHeight();
			if(percentHeight == null) {
				continue;
			}
			if(percentHeight < 0.0) {
				percentHeight = 0.0;
			} else if(percentHeight > 100.0) {
				percentHeight = 100.0;
			}
			var itemHeight = availableHeight * percentHeight / 100.0;
			if((js_Boot().default).__implements(item,(feathers_core_IMeasureObject().default))) {
				var measureItem = (js_Boot().default).__cast(item , (feathers_core_IMeasureObject().default));
				var itemMinHeight = measureItem.get_explicitMinHeight();
				if(itemMinHeight != null) {
					if(itemMinHeight > availableHeight) {
						itemMinHeight = availableHeight;
					}
					if(itemHeight < itemMinHeight) {
						itemHeight = itemMinHeight;
					}
				}
				var itemMaxHeight = measureItem.get_explicitMaxHeight();
				if(itemMaxHeight != null && itemHeight > itemMaxHeight) {
					itemHeight = itemMaxHeight;
				}
			}
			item.set_height(itemHeight);
		}
	}
});
HorizontalLayout.prototype.__class__ = HorizontalLayout.prototype.constructor = $hxClasses["feathers.layout.HorizontalLayout"] = HorizontalLayout;

// Init



// Statics




// Export

exports["default"] = HorizontalLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/HorizontalLayoutData.js":
/*!**********************************************************!*\
  !*** ./lib/_gen/feathers/layout/HorizontalLayoutData.js ***!
  \**********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.HorizontalLayoutData

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_ILayoutData() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutData */ "./lib/_gen/feathers/layout/ILayoutData.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}

// Constructor

var HorizontalLayoutData = function(percentWidth,percentHeight) {
	this._marginRight = null;
	this._marginLeft = null;
	this._percentHeight = null;
	this._percentWidth = null;
	(openfl_events_EventDispatcher()).call(this);
	this.set_percentWidth(percentWidth);
	this.set_percentHeight(percentHeight);
}

// Meta

HorizontalLayoutData.__name__ = "feathers.layout.HorizontalLayoutData";
HorizontalLayoutData.__isInterface__ = false;
HorizontalLayoutData.__interfaces__ = [(feathers_layout_ILayoutData().default)];
HorizontalLayoutData.__super__ = (openfl_events_EventDispatcher());
HorizontalLayoutData.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_percentWidth: function() {
		return this._percentWidth;
	},
	set_percentWidth: function(value) {
		if(this._percentWidth == value) {
			return this._percentWidth;
		}
		this._percentWidth = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._percentWidth;
	},
	get_percentHeight: function() {
		return this._percentHeight;
	},
	set_percentHeight: function(value) {
		if(this._percentHeight == value) {
			return this._percentHeight;
		}
		this._percentHeight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._percentHeight;
	},
	get_marginLeft: function() {
		return this._marginLeft;
	},
	set_marginLeft: function(value) {
		if(this._marginLeft == value) {
			return this._marginLeft;
		}
		this._marginLeft = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._marginLeft;
	},
	get_marginRight: function() {
		return this._marginRight;
	},
	set_marginRight: function(value) {
		if(this._marginRight == value) {
			return this._marginRight;
		}
		this._marginRight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._marginRight;
	}
});
HorizontalLayoutData.prototype.__class__ = HorizontalLayoutData.prototype.constructor = $hxClasses["feathers.layout.HorizontalLayoutData"] = HorizontalLayoutData;

// Init



// Statics

HorizontalLayoutData.fill = function() {
	return new HorizontalLayoutData(100.0,100.0);
}
HorizontalLayoutData.fillHorizontal = function(percentWidth) {
	if(percentWidth == null) {
		percentWidth = 100.0;
	}
	return new HorizontalLayoutData(percentWidth,null);
}
HorizontalLayoutData.fillVertical = function(percentHeight) {
	if(percentHeight == null) {
		percentHeight = 100.0;
	}
	return new HorizontalLayoutData(null,percentHeight);
}


// Export

exports["default"] = HorizontalLayoutData;

/***/ }),

/***/ "./lib/_gen/feathers/layout/HorizontalListLayout.js":
/*!**********************************************************!*\
  !*** ./lib/_gen/feathers/layout/HorizontalListLayout.js ***!
  \**********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.HorizontalListLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_IKeyboardNavigationLayout() {return __webpack_require__(/*! ./../../feathers/layout/IKeyboardNavigationLayout */ "./lib/_gen/feathers/layout/IKeyboardNavigationLayout.js");}
function feathers_layout_IVirtualLayout() {return __webpack_require__(/*! ./../../feathers/layout/IVirtualLayout */ "./lib/_gen/feathers/layout/IVirtualLayout.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_layout__$HorizontalListLayout_VirtualCacheItem() {return __webpack_require__(/*! ./../../feathers/layout/_HorizontalListLayout/VirtualCacheItem */ "./lib/_gen/feathers/layout/_HorizontalListLayout/VirtualCacheItem.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_ILayoutObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutObject */ "./lib/_gen/feathers/layout/ILayoutObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_events_ScrollEvent() {return __webpack_require__(/*! ./../../feathers/events/ScrollEvent */ "./lib/_gen/feathers/events/ScrollEvent.js");}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}
function feathers_layout_VirtualLayoutRange() {return __webpack_require__(/*! ./../../feathers/layout/VirtualLayoutRange */ "./lib/_gen/feathers/layout/VirtualLayoutRange.js");}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}

// Constructor

var HorizontalListLayout = function() {
	this._heightResetEnabled = true;
	this._contentJustify = false;
	this._horizontalAlign = (feathers_layout_HorizontalAlign().default).LEFT;
	this._minGap = 0.0;
	this._gap = 0.0;
	this._paddingLeft = 0.0;
	this._paddingBottom = 0.0;
	this._paddingRight = 0.0;
	this._paddingTop = 0.0;
	this._requestedMaxColumnCount = null;
	this._requestedMinColumnCount = null;
	this._requestedColumnCount = null;
	this._scrollY = 0.0;
	this._scrollX = 0.0;
	(openfl_events_EventDispatcher()).call(this);
}

// Meta

HorizontalListLayout.__name__ = "feathers.layout.HorizontalListLayout";
HorizontalListLayout.__isInterface__ = false;
HorizontalListLayout.__interfaces__ = [(feathers_layout_IKeyboardNavigationLayout().default),(feathers_layout_IVirtualLayout().default)];
HorizontalListLayout.__super__ = (openfl_events_EventDispatcher());
HorizontalListLayout.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_scrollX: function() {
		return this._scrollX;
	},
	set_scrollX: function(value) {
		this._scrollX = value;
		return this._scrollX;
	},
	get_scrollY: function() {
		return this._scrollY;
	},
	set_scrollY: function(value) {
		this._scrollY = value;
		return this._scrollY;
	},
	get_virtualCache: function() {
		return this._virtualCache;
	},
	set_virtualCache: function(value) {
		this._virtualCache = value;
		return this._virtualCache;
	},
	get_elasticTop: function() {
		return false;
	},
	get_elasticRight: function() {
		return true;
	},
	get_elasticBottom: function() {
		return false;
	},
	get_elasticLeft: function() {
		return true;
	},
	get_requestedColumnCount: function() {
		return this._requestedColumnCount;
	},
	set_requestedColumnCount: function(value) {
		if(this._requestedColumnCount == value) {
			return this._requestedColumnCount;
		}
		this._requestedColumnCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedColumnCount;
	},
	get_requestedMinColumnCount: function() {
		return this._requestedMinColumnCount;
	},
	set_requestedMinColumnCount: function(value) {
		if(this._requestedMinColumnCount == value) {
			return this._requestedMinColumnCount;
		}
		this._requestedMinColumnCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedMinColumnCount;
	},
	get_requestedMaxColumnCount: function() {
		return this._requestedMaxColumnCount;
	},
	set_requestedMaxColumnCount: function(value) {
		if(this._requestedMaxColumnCount == value) {
			return this._requestedMaxColumnCount;
		}
		this._requestedMaxColumnCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedMaxColumnCount;
	},
	get_paddingTop: function() {
		return this._paddingTop;
	},
	set_paddingTop: function(value) {
		if(this._paddingTop == value) {
			return this._paddingTop;
		}
		this._paddingTop = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingTop;
	},
	get_paddingRight: function() {
		return this._paddingRight;
	},
	set_paddingRight: function(value) {
		if(this._paddingRight == value) {
			return this._paddingRight;
		}
		this._paddingRight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingRight;
	},
	get_paddingBottom: function() {
		return this._paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(this._paddingBottom == value) {
			return this._paddingBottom;
		}
		this._paddingBottom = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingBottom;
	},
	get_paddingLeft: function() {
		return this._paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(this._paddingLeft == value) {
			return this._paddingLeft;
		}
		this._paddingLeft = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingLeft;
	},
	get_gap: function() {
		return this._gap;
	},
	set_gap: function(value) {
		if(this._gap == value) {
			return this._gap;
		}
		this._gap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._gap;
	},
	get_minGap: function() {
		return this._minGap;
	},
	set_minGap: function(value) {
		if(this._minGap == value) {
			return this._minGap;
		}
		this._minGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._minGap;
	},
	get_horizontalAlign: function() {
		return this._horizontalAlign;
	},
	set_horizontalAlign: function(value) {
		if(this._horizontalAlign == value) {
			return this._horizontalAlign;
		}
		this._horizontalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._horizontalAlign;
	},
	get_contentJustify: function() {
		return this._contentJustify;
	},
	set_contentJustify: function(value) {
		if(this._contentJustify == value) {
			return this._contentJustify;
		}
		this._contentJustify = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._contentJustify;
	},
	get_heightResetEnabled: function() {
		return this._heightResetEnabled;
	},
	set_heightResetEnabled: function(value) {
		if(this._heightResetEnabled == value) {
			return this._heightResetEnabled;
		}
		this._heightResetEnabled = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._heightResetEnabled;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	layout: function(items,measurements,result) {
		var adjustedGap = this._gap;
		var hasFlexGap = this._gap == 1.0 / 0.0;
		if(hasFlexGap) {
			adjustedGap = this._minGap;
		}
		var maxItemHeight = this.calculateMaxItemHeight(items,measurements);
		var viewPortHeight = this.calculateViewPortHeight(maxItemHeight,measurements);
		var minItemHeight = viewPortHeight - this._paddingTop - this._paddingBottom;
		var itemHeight = maxItemHeight;
		if(!this._contentJustify || itemHeight < minItemHeight) {
			itemHeight = minItemHeight;
		}
		var virtualColumnWidth = this.calculateVirtualColumnWidth(items,itemHeight);
		var positionX = this._paddingLeft;
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var item = items[i];
			if(item == null) {
				var itemWidth = virtualColumnWidth;
				if(this._virtualCache != null) {
					var cacheItem = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$HorizontalListLayout_VirtualCacheItem().default));
					if(cacheItem != null && cacheItem.itemWidth != null) {
						itemWidth = cacheItem.itemWidth;
					}
				}
				positionX += itemWidth + adjustedGap;
				continue;
			}
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				if(!((js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default))).get_includeInLayout()) {
					continue;
				}
			}
			item.set_x(positionX);
			item.set_y(this._paddingTop);
			item.set_height(itemHeight);
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
			var itemWidth1 = item.get_width();
			if(this._virtualCache != null) {
				var cacheItem1 = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$HorizontalListLayout_VirtualCacheItem().default));
				if(cacheItem1 != null && cacheItem1.itemWidth != itemWidth1) {
					var cachedWidth = cacheItem1.itemWidth;
					cacheItem1.itemWidth = itemWidth1;
					if(cachedWidth == null && positionX < this.get_scrollX()) {
						var offsetX = itemWidth1 - virtualColumnWidth;
						(feathers_events_ScrollEvent().default).dispatch(this,"scroll",false,false,offsetX,0.0);
					}
					if(cachedWidth != null || itemWidth1 != virtualColumnWidth) {
						(feathers_events_FeathersEvent().default).dispatch(this,"change");
					}
				}
			}
			positionX += itemWidth1 + adjustedGap;
		}
		if(items.length > 0) {
			positionX -= adjustedGap;
		}
		var viewPortWidth = positionX += this._paddingRight;
		if(measurements.width != null) {
			viewPortWidth = measurements.width;
		} else {
			if(this._requestedColumnCount != null) {
				viewPortWidth = this._paddingLeft + this._paddingRight + (this._requestedColumnCount * (virtualColumnWidth + adjustedGap) - adjustedGap);
			} else if(this._requestedMinColumnCount != null && items.length < this._requestedMinColumnCount) {
				viewPortWidth = this._paddingLeft + this._paddingRight + (this._requestedMinColumnCount * (virtualColumnWidth + adjustedGap) - adjustedGap);
			} else if(this._requestedMaxColumnCount != null && items.length > this._requestedMaxColumnCount) {
				viewPortWidth = this._paddingLeft + this._paddingRight + (this._requestedMaxColumnCount * (virtualColumnWidth + adjustedGap) - adjustedGap);
			}
			if(measurements.minWidth != null && viewPortWidth < measurements.minWidth) {
				viewPortWidth = measurements.minWidth;
			} else if(measurements.maxWidth != null && viewPortWidth > measurements.maxWidth) {
				viewPortWidth = measurements.maxWidth;
			}
		}
		this.applyHorizontalAlign(items,positionX - this._paddingLeft - this._paddingRight,viewPortWidth);
		if(result == null) {
			result = new (feathers_layout_LayoutBoundsResult().default)();
		}
		result.contentX = 0.0;
		result.contentY = 0.0;
		result.contentWidth = positionX;
		result.contentHeight = itemHeight + this._paddingTop + this._paddingBottom;
		if(this._requestedMinColumnCount != null) {
			result.contentMinWidth = this._paddingLeft + this._paddingRight + (this._requestedMinColumnCount * (virtualColumnWidth + adjustedGap) - adjustedGap);
		}
		result.viewPortHeight = viewPortHeight;
		result.viewPortWidth = viewPortWidth;
		return result;
	},
	calculateMaxItemHeight: function(items,measurements) {
		var maxItemHeight = 0.0;
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var item = items[i];
			if(this._virtualCache != null && this._virtualCache.length > i) {
				var cacheItem = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$HorizontalListLayout_VirtualCacheItem().default));
				if(cacheItem != null) {
					var itemHeight = cacheItem.itemHeight;
					if(maxItemHeight < itemHeight) {
						maxItemHeight = itemHeight;
					}
					continue;
				}
			}
			if(item == null) {
				continue;
			}
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				if(!((js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default))).get_includeInLayout()) {
					continue;
				}
			}
			if(this._heightResetEnabled && measurements.height == null && (js_Boot().default).__implements(item,(feathers_core_IMeasureObject().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IMeasureObject().default))).resetHeight();
			}
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
			var itemHeight1 = item.get_height();
			if(maxItemHeight < itemHeight1) {
				maxItemHeight = itemHeight1;
			}
			if(this._virtualCache != null) {
				var cacheItem1 = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$HorizontalListLayout_VirtualCacheItem().default));
				if(cacheItem1 == null) {
					if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
						((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
					}
					cacheItem1 = new (feathers_layout__$HorizontalListLayout_VirtualCacheItem().default)(null,itemHeight1);
					this._virtualCache[i] = cacheItem1;
				}
			}
		}
		if(measurements.maxHeight != null) {
			var maxJustifyHeight = measurements.maxHeight - this._paddingTop - this._paddingBottom;
			if(maxItemHeight > maxJustifyHeight) {
				maxItemHeight = maxJustifyHeight;
			}
		}
		return maxItemHeight;
	},
	calculateViewPortHeight: function(maxItemHeight,measurements) {
		if(measurements.height != null) {
			return measurements.height;
		}
		return maxItemHeight + this._paddingTop + this._paddingBottom;
	},
	calculateVirtualColumnWidth: function(items,itemHeight) {
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var item = items[i];
			if(item == null) {
				if(this._virtualCache == null || this._virtualCache.length <= i) {
					continue;
				}
				var cacheItem = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$HorizontalListLayout_VirtualCacheItem().default));
				if(cacheItem == null || cacheItem.itemWidth == null) {
					continue;
				}
				return cacheItem.itemWidth;
			}
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				if(!((js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default))).get_includeInLayout()) {
					continue;
				}
			}
			item.set_height(itemHeight);
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
			var itemWidth = item.get_width();
			if(this._virtualCache != null) {
				var cacheItem1 = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$HorizontalListLayout_VirtualCacheItem().default));
				if(cacheItem1 != null && (cacheItem1.itemWidth == null || cacheItem1.itemWidth != itemWidth)) {
					cacheItem1.itemWidth = itemWidth;
					(feathers_events_FeathersEvent().default).dispatch(this,"change");
				}
			}
			return itemWidth;
		}
		return 0.0;
	},
	getVisibleIndices: function(itemCount,width,height,result) {
		var adjustedGap = this._gap;
		var hasFlexGap = this._gap == 1.0 / 0.0;
		if(hasFlexGap) {
			adjustedGap = this._minGap;
		}
		var startIndex = -1;
		var endIndex = -1;
		var estimatedItemWidth = null;
		var positionX = this._paddingLeft;
		var scrollX = this._scrollX;
		if(scrollX < 0.0) {
			scrollX = 0.0;
		}
		var minItems = 0;
		var maxX = scrollX + width;
		var skippedMissingItems = 0;
		var _g = 0;
		var _g1 = itemCount;
		while(_g < _g1) {
			var i = _g++;
			var itemWidth = 0.0;
			if(this._virtualCache != null) {
				var cacheItem = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$HorizontalListLayout_VirtualCacheItem().default));
				if(cacheItem != null && cacheItem.itemWidth != null) {
					itemWidth = cacheItem.itemWidth;
					if(estimatedItemWidth == null) {
						estimatedItemWidth = itemWidth;
						minItems = Math.ceil(width / estimatedItemWidth + adjustedGap) + 1;
						if(skippedMissingItems > 0) {
							var _g2 = 0;
							var _g11 = skippedMissingItems;
							while(_g2 < _g11) {
								var j = _g2++;
								positionX += estimatedItemWidth + adjustedGap;
								if(startIndex == -1 && positionX >= scrollX) {
									startIndex = j;
								}
								if(startIndex != -1) {
									endIndex = j;
									if(positionX >= maxX && endIndex - startIndex + 1 >= minItems) {
										break;
									}
								}
							}
							skippedMissingItems = 0;
						}
					}
				} else if(estimatedItemWidth != null) {
					itemWidth = estimatedItemWidth;
				} else {
					if(skippedMissingItems < 5) {
						++skippedMissingItems;
						continue;
					}
					startIndex = 0;
					endIndex = 0;
					break;
				}
			}
			positionX += itemWidth + adjustedGap;
			if(startIndex == -1 && positionX >= scrollX) {
				startIndex = i;
			}
			if(startIndex != -1) {
				endIndex = i;
				if(positionX >= maxX && endIndex - startIndex + 1 >= minItems) {
					break;
				}
			}
		}
		if(startIndex == -1 && this._horizontalAlign != (feathers_layout_HorizontalAlign().default).LEFT) {
			startIndex = itemCount - 1;
			endIndex = startIndex;
		}
		if((positionX < maxX || endIndex - startIndex + 1 < minItems) && startIndex > 0) {
			while(true) {
				--startIndex;
				var itemWidth1 = 0.0;
				if(this._virtualCache != null) {
					var cacheItem1 = (Std().default).downcast(this._virtualCache[startIndex],(feathers_layout__$HorizontalListLayout_VirtualCacheItem().default));
					if(cacheItem1 != null && cacheItem1.itemWidth != null) {
						itemWidth1 = cacheItem1.itemWidth;
						if(estimatedItemWidth == null) {
							estimatedItemWidth = itemWidth1;
							minItems = Math.ceil(width / estimatedItemWidth + adjustedGap) + 1;
						}
					} else if(estimatedItemWidth != null) {
						itemWidth1 = estimatedItemWidth;
					}
				}
				positionX += itemWidth1 + adjustedGap;
				if(positionX >= maxX && endIndex - startIndex + 1 >= minItems) {
					break;
				}
				if(!(startIndex > 0)) {
					break;
				}
			}
		}
		if(startIndex < 0) {
			startIndex = 0;
		}
		if(estimatedItemWidth == null) {
			endIndex = startIndex;
		} else if(endIndex < 0) {
			endIndex = startIndex;
		}
		if(result == null) {
			return new (feathers_layout_VirtualLayoutRange().default)(startIndex,endIndex);
		}
		result.start = startIndex;
		result.end = endIndex;
		return result;
	},
	getNearestScrollPositionForIndex: function(index,itemCount,width,height,result) {
		var adjustedGap = this._gap;
		var hasFlexGap = this._gap == 1.0 / 0.0;
		if(hasFlexGap) {
			adjustedGap = this._minGap;
		}
		var estimatedItemWidth = null;
		var minX = 0.0;
		var maxX = 0.0;
		var positionX = this._paddingLeft;
		var _g = 0;
		var _g1 = itemCount;
		while(_g < _g1) {
			var i = _g++;
			var itemWidth = 0.0;
			if(this._virtualCache != null) {
				var cacheItem = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$HorizontalListLayout_VirtualCacheItem().default));
				if(cacheItem != null && cacheItem.itemWidth != null) {
					itemWidth = cacheItem.itemWidth;
					if(estimatedItemWidth == null) {
						estimatedItemWidth = itemWidth;
					}
				} else if(estimatedItemWidth != null) {
					itemWidth = estimatedItemWidth;
				}
			}
			if(i == index) {
				maxX = positionX;
				minX = maxX + itemWidth - width;
				break;
			}
			positionX += itemWidth + adjustedGap;
		}
		var targetX = this._scrollX;
		if(targetX < minX) {
			targetX = minX;
		} else if(targetX > maxX) {
			targetX = maxX;
		}
		if(result == null) {
			result = new (openfl_geom_Point())();
		}
		result.x = targetX;
		result.y = this._scrollY;
		return result;
	},
	findNextKeyboardIndex: function(startIndex,event,wrapArrowKeys,items,indicesToSkip,viewPortWidth,viewPortHeight) {
		if(items.length == 0) {
			return -1;
		}
		var adjustedGap = this._gap;
		var hasFlexGap = this._gap == 1.0 / 0.0;
		if(hasFlexGap) {
			adjustedGap = this._minGap;
		}
		var estimatedItemWidth = null;
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var itemWidth = 0.0;
			if(this._virtualCache != null) {
				var cacheItem = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$HorizontalListLayout_VirtualCacheItem().default));
				if(cacheItem != null && cacheItem.itemWidth != null) {
					itemWidth = cacheItem.itemWidth;
					if(estimatedItemWidth == null) {
						estimatedItemWidth = itemWidth;
						break;
					}
				}
			}
		}
		var maxIndex = items.length - 1;
		var result = startIndex;
		if(result == -1) {
			switch(event.keyCode) {
			case 37:
				result = wrapArrowKeys ? maxIndex : -1;
				break;
			case 39:
				result = 0;
				break;
			default:
				result = -1;
			}
			if(result == -1) {
				return result;
			}
			if(indicesToSkip == null || indicesToSkip.indexOf(result) == -1) {
				return result;
			}
		}
		var needsAnotherPass = true;
		var nextKeyCode = event.keyCode;
		var lastResult = result;
		while(needsAnotherPass) {
			needsAnotherPass = false;
			switch(nextKeyCode) {
			case 33:
				var xPosition = 0.0;
				var i1 = startIndex;
				while(i1 >= 0) {
					var item = items[i1];
					var itemWidth1 = estimatedItemWidth;
					if(item == null) {
						if(this._virtualCache != null) {
							var cacheItem1 = (Std().default).downcast(this._virtualCache[i1],(feathers_layout__$HorizontalListLayout_VirtualCacheItem().default));
							if(cacheItem1 != null && cacheItem1.itemWidth != null) {
								itemWidth1 = cacheItem1.itemWidth;
							}
						}
					} else {
						itemWidth1 = item.get_width();
					}
					xPosition += itemWidth1;
					if(indicesToSkip != null && indicesToSkip.indexOf(i1) != -1) {
						xPosition += adjustedGap;
						--i1;
						continue;
					}
					if(xPosition > viewPortWidth) {
						break;
					}
					xPosition += adjustedGap;
					result = i1;
					--i1;
				}
				nextKeyCode = 38;
				break;
			case 34:
				var xPosition1 = 0.0;
				var _g2 = startIndex;
				var _g3 = items.length;
				while(_g2 < _g3) {
					var i2 = _g2++;
					var item1 = items[i2];
					var itemWidth2 = estimatedItemWidth;
					if(item1 == null) {
						if(this._virtualCache != null) {
							var cacheItem2 = (Std().default).downcast(this._virtualCache[i2],(feathers_layout__$HorizontalListLayout_VirtualCacheItem().default));
							if(cacheItem2 != null && cacheItem2.itemWidth != null) {
								itemWidth2 = cacheItem2.itemWidth;
							}
						}
					} else {
						itemWidth2 = item1.get_width();
					}
					xPosition1 += itemWidth2;
					if(indicesToSkip != null && indicesToSkip.indexOf(i2) != -1) {
						xPosition1 += adjustedGap;
						continue;
					}
					if(xPosition1 > viewPortWidth) {
						break;
					}
					xPosition1 += adjustedGap;
					result = i2;
				}
				nextKeyCode = 40;
				break;
			case 35:
				var i3 = maxIndex;
				while(i3 > startIndex) {
					if(indicesToSkip == null || indicesToSkip.indexOf(i3) == -1) {
						result = i3;
						break;
					}
					--i3;
				}
				break;
			case 36:
				var _g21 = 0;
				var _g31 = startIndex;
				while(_g21 < _g31) {
					var i4 = _g21++;
					if(indicesToSkip == null || indicesToSkip.indexOf(i4) == -1) {
						result = i4;
						break;
					}
				}
				break;
			case 37:
				--result;
				break;
			case 39:
				++result;
				break;
			default:
				return startIndex;
			}
			if(result < 0) {
				if(wrapArrowKeys) {
					result = maxIndex;
				} else {
					result = 0;
				}
			} else if(result > maxIndex) {
				if(wrapArrowKeys) {
					result = 0;
				} else {
					result = maxIndex;
				}
			}
			if(indicesToSkip != null && indicesToSkip.indexOf(result) != -1) {
				if(result == lastResult) {
					return startIndex;
				}
				needsAnotherPass = true;
			}
			lastResult = result;
		}
		return result;
	},
	applyHorizontalAlign: function(items,contentWidth,viewPortWidth) {
		var alignOffset = 0.0;
		var gapOffset = 0.0;
		var maxAlignmentWidth = viewPortWidth - this._paddingLeft - this._paddingRight;
		var adjustedGap = this._gap;
		var hasFlexGap = this._gap == 1.0 / 0.0;
		if(hasFlexGap) {
			adjustedGap = this._minGap;
			if(items.length > 1 && maxAlignmentWidth > contentWidth) {
				adjustedGap += (maxAlignmentWidth - contentWidth) / (items.length - 1);
			}
			gapOffset = adjustedGap - this._minGap;
		} else {
			switch(this._horizontalAlign._hx_index) {
			case 0:
				alignOffset = 0.0;
				break;
			case 1:
				alignOffset = (maxAlignmentWidth - contentWidth) / 2.0;
				break;
			case 2:
				alignOffset = maxAlignmentWidth - contentWidth;
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown horizontal align: " + (Std().default).string(this._horizontalAlign)));
			}
			if(alignOffset < 0.0) {
				alignOffset = 0.0;
			}
		}
		if(alignOffset == 0.0 && gapOffset == 0.0) {
			return;
		}
		var totalOffset = alignOffset;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			var layoutObject = null;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				layoutObject = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutObject.get_includeInLayout()) {
					continue;
				}
			}
			if(item != null) {
				item.set_x(Math.max(this._paddingLeft,item.get_x() + totalOffset));
			}
			totalOffset += gapOffset;
		}
	}
});
HorizontalListLayout.prototype.__class__ = HorizontalListLayout.prototype.constructor = $hxClasses["feathers.layout.HorizontalListLayout"] = HorizontalListLayout;

// Init



// Statics




// Export

exports["default"] = HorizontalListLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/IKeyboardNavigationLayout.js":
/*!***************************************************************!*\
  !*** ./lib/_gen/feathers/layout/IKeyboardNavigationLayout.js ***!
  \***************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.IKeyboardNavigationLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_layout_ILayout() {return __webpack_require__(/*! ./../../feathers/layout/ILayout */ "./lib/_gen/feathers/layout/ILayout.js");}

// Constructor

var IKeyboardNavigationLayout = function() {}

// Meta

IKeyboardNavigationLayout.__name__ = "feathers.layout.IKeyboardNavigationLayout";
IKeyboardNavigationLayout.__isInterface__ = true;
IKeyboardNavigationLayout.__interfaces__ = [(feathers_layout_ILayout().default)];
IKeyboardNavigationLayout.prototype = {
	
};
IKeyboardNavigationLayout.prototype.__class__ = IKeyboardNavigationLayout.prototype.constructor = $hxClasses["feathers.layout.IKeyboardNavigationLayout"] = IKeyboardNavigationLayout;

// Init



// Statics




// Export

exports["default"] = IKeyboardNavigationLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/ILayout.js":
/*!*********************************************!*\
  !*** ./lib/_gen/feathers/layout/ILayout.js ***!
  \*********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.ILayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function openfl_events_IEventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.IEventDispatcher);}

// Constructor

var ILayout = function() {}

// Meta

ILayout.__name__ = "feathers.layout.ILayout";
ILayout.__isInterface__ = true;
ILayout.__interfaces__ = [(openfl_events_IEventDispatcher())];
ILayout.prototype = {
	
};
ILayout.prototype.__class__ = ILayout.prototype.constructor = $hxClasses["feathers.layout.ILayout"] = ILayout;

// Init



// Statics




// Export

exports["default"] = ILayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/ILayoutData.js":
/*!*************************************************!*\
  !*** ./lib/_gen/feathers/layout/ILayoutData.js ***!
  \*************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.ILayoutData

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function openfl_events_IEventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.IEventDispatcher);}

// Constructor

var ILayoutData = function() {}

// Meta

ILayoutData.__name__ = "feathers.layout.ILayoutData";
ILayoutData.__isInterface__ = true;
ILayoutData.__interfaces__ = [(openfl_events_IEventDispatcher())];
ILayoutData.prototype = {
	
};
ILayoutData.prototype.__class__ = ILayoutData.prototype.constructor = $hxClasses["feathers.layout.ILayoutData"] = ILayoutData;

// Init



// Statics




// Export

exports["default"] = ILayoutData;

/***/ }),

/***/ "./lib/_gen/feathers/layout/ILayoutIndexObject.js":
/*!********************************************************!*\
  !*** ./lib/_gen/feathers/layout/ILayoutIndexObject.js ***!
  \********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.ILayoutIndexObject

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var ILayoutIndexObject = function() {}

// Meta

ILayoutIndexObject.__name__ = "feathers.layout.ILayoutIndexObject";
ILayoutIndexObject.__isInterface__ = true;
ILayoutIndexObject.prototype = {
	
};
ILayoutIndexObject.prototype.__class__ = ILayoutIndexObject.prototype.constructor = $hxClasses["feathers.layout.ILayoutIndexObject"] = ILayoutIndexObject;

// Init



// Statics




// Export

exports["default"] = ILayoutIndexObject;

/***/ }),

/***/ "./lib/_gen/feathers/layout/ILayoutObject.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/layout/ILayoutObject.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.ILayoutObject

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function openfl_events_IEventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.IEventDispatcher);}

// Constructor

var ILayoutObject = function() {}

// Meta

ILayoutObject.__name__ = "feathers.layout.ILayoutObject";
ILayoutObject.__isInterface__ = true;
ILayoutObject.__interfaces__ = [(openfl_events_IEventDispatcher())];
ILayoutObject.prototype = {
	
};
ILayoutObject.prototype.__class__ = ILayoutObject.prototype.constructor = $hxClasses["feathers.layout.ILayoutObject"] = ILayoutObject;

// Init



// Statics




// Export

exports["default"] = ILayoutObject;

/***/ }),

/***/ "./lib/_gen/feathers/layout/IScrollLayout.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/layout/IScrollLayout.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.IScrollLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_layout_ILayout() {return __webpack_require__(/*! ./../../feathers/layout/ILayout */ "./lib/_gen/feathers/layout/ILayout.js");}

// Constructor

var IScrollLayout = function() {}

// Meta

IScrollLayout.__name__ = "feathers.layout.IScrollLayout";
IScrollLayout.__isInterface__ = true;
IScrollLayout.__interfaces__ = [(feathers_layout_ILayout().default)];
IScrollLayout.prototype = {
	
};
IScrollLayout.prototype.__class__ = IScrollLayout.prototype.constructor = $hxClasses["feathers.layout.IScrollLayout"] = IScrollLayout;

// Init



// Statics




// Export

exports["default"] = IScrollLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/ISnapLayout.js":
/*!*************************************************!*\
  !*** ./lib/_gen/feathers/layout/ISnapLayout.js ***!
  \*************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.ISnapLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_layout_ILayout() {return __webpack_require__(/*! ./../../feathers/layout/ILayout */ "./lib/_gen/feathers/layout/ILayout.js");}

// Constructor

var ISnapLayout = function() {}

// Meta

ISnapLayout.__name__ = "feathers.layout.ISnapLayout";
ISnapLayout.__isInterface__ = true;
ISnapLayout.__interfaces__ = [(feathers_layout_ILayout().default)];
ISnapLayout.prototype = {
	
};
ISnapLayout.prototype.__class__ = ISnapLayout.prototype.constructor = $hxClasses["feathers.layout.ISnapLayout"] = ISnapLayout;

// Init



// Statics




// Export

exports["default"] = ISnapLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/IVirtualLayout.js":
/*!****************************************************!*\
  !*** ./lib/_gen/feathers/layout/IVirtualLayout.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.IVirtualLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_layout_IScrollLayout() {return __webpack_require__(/*! ./../../feathers/layout/IScrollLayout */ "./lib/_gen/feathers/layout/IScrollLayout.js");}

// Constructor

var IVirtualLayout = function() {}

// Meta

IVirtualLayout.__name__ = "feathers.layout.IVirtualLayout";
IVirtualLayout.__isInterface__ = true;
IVirtualLayout.__interfaces__ = [(feathers_layout_IScrollLayout().default)];
IVirtualLayout.prototype = {
	
};
IVirtualLayout.prototype.__class__ = IVirtualLayout.prototype.constructor = $hxClasses["feathers.layout.IVirtualLayout"] = IVirtualLayout;

// Init



// Statics




// Export

exports["default"] = IVirtualLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/LayoutBoundsResult.js":
/*!********************************************************!*\
  !*** ./lib/_gen/feathers/layout/LayoutBoundsResult.js ***!
  \********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.LayoutBoundsResult

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var LayoutBoundsResult = function() {
	this.reset();
}

// Meta

LayoutBoundsResult.__name__ = "feathers.layout.LayoutBoundsResult";
LayoutBoundsResult.__isInterface__ = false;
LayoutBoundsResult.prototype = {
	reset: function() {
		this.contentX = 0.0;
		this.contentY = 0.0;
		this.contentWidth = 0.0;
		this.contentHeight = 0.0;
		this.contentMinWidth = 0.0;
		this.contentMinHeight = 0.0;
		this.contentMaxWidth = 1.0 / 0.0;
		this.contentMaxHeight = 1.0 / 0.0;
		this.viewPortWidth = 0.0;
		this.viewPortHeight = 0.0;
	}
};
LayoutBoundsResult.prototype.__class__ = LayoutBoundsResult.prototype.constructor = $hxClasses["feathers.layout.LayoutBoundsResult"] = LayoutBoundsResult;

// Init



// Statics




// Export

exports["default"] = LayoutBoundsResult;

/***/ }),

/***/ "./lib/_gen/feathers/layout/Measurements.js":
/*!**************************************************!*\
  !*** ./lib/_gen/feathers/layout/Measurements.js ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.Measurements

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}

// Constructor

var Measurements = function(target) {
	this.maxHeight = null;
	this.maxWidth = null;
	this.minHeight = null;
	this.minWidth = null;
	this.height = null;
	this.width = null;
	this.save(target);
}

// Meta

Measurements.__name__ = "feathers.layout.Measurements";
Measurements.__isInterface__ = false;
Measurements.prototype = {
	save: function(target) {
		if(target == null) {
			this.width = null;
			this.height = null;
			this.minWidth = null;
			this.minHeight = null;
			this.maxWidth = null;
			this.maxHeight = null;
			return;
		}
		if((js_Boot().default).__implements(target,(feathers_core_IMeasureObject().default))) {
			var measureTarget = (js_Boot().default).__cast(target , (feathers_core_IMeasureObject().default));
			this.width = measureTarget.get_explicitWidth();
			this.height = measureTarget.get_explicitHeight();
			this.minWidth = measureTarget.get_explicitMinWidth();
			this.minHeight = measureTarget.get_explicitMinHeight();
			this.maxWidth = measureTarget.get_explicitMaxWidth();
			this.maxHeight = measureTarget.get_explicitMaxHeight();
			return;
		}
		this.width = target.get_width();
		this.height = target.get_height();
		this.minWidth = this.width;
		this.minHeight = this.height;
		this.maxWidth = this.width;
		this.maxHeight = this.height;
	},
	restore: function(target) {
		if((js_Boot().default).__implements(target,(feathers_core_IMeasureObject().default))) {
			var measureTarget = (js_Boot().default).__cast(target , (feathers_core_IMeasureObject().default));
			if(this.width == null) {
				measureTarget.resetWidth();
			} else {
				measureTarget.set_width(this.width);
			}
			if(this.height == null) {
				measureTarget.resetHeight();
			} else {
				measureTarget.set_height(this.height);
			}
			if(this.minWidth == null) {
				measureTarget.resetMinWidth();
			} else {
				measureTarget.set_minWidth(this.minWidth);
			}
			if(this.minHeight == null) {
				measureTarget.resetMinHeight();
			} else {
				measureTarget.set_minHeight(this.minHeight);
			}
			if(this.maxWidth == null) {
				measureTarget.resetMaxWidth();
			} else {
				measureTarget.set_maxWidth(this.maxWidth);
			}
			if(this.maxHeight == null) {
				measureTarget.resetMaxHeight();
			} else {
				measureTarget.set_maxHeight(this.maxHeight);
			}
			return;
		}
		if(this.width != null) {
			target.set_width(this.width);
		}
		if(this.height != null) {
			target.set_height(this.height);
		}
	}
};
Measurements.prototype.__class__ = Measurements.prototype.constructor = $hxClasses["feathers.layout.Measurements"] = Measurements;

// Init



// Statics




// Export

exports["default"] = Measurements;

/***/ }),

/***/ "./lib/_gen/feathers/layout/PagedTiledRowsListLayout.js":
/*!**************************************************************!*\
  !*** ./lib/_gen/feathers/layout/PagedTiledRowsListLayout.js ***!
  \**************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.PagedTiledRowsListLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_ISnapLayout() {return __webpack_require__(/*! ./../../feathers/layout/ISnapLayout */ "./lib/_gen/feathers/layout/ISnapLayout.js");}
function feathers_layout_IKeyboardNavigationLayout() {return __webpack_require__(/*! ./../../feathers/layout/IKeyboardNavigationLayout */ "./lib/_gen/feathers/layout/IKeyboardNavigationLayout.js");}
function feathers_layout_IVirtualLayout() {return __webpack_require__(/*! ./../../feathers/layout/IVirtualLayout */ "./lib/_gen/feathers/layout/IVirtualLayout.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_layout_Direction() {return __webpack_require__(/*! ./../../feathers/layout/Direction */ "./lib/_gen/feathers/layout/Direction.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_layout__$PagedTiledRowsListLayout_VirtualCacheItem() {return __webpack_require__(/*! ./../../feathers/layout/_PagedTiledRowsListLayout/VirtualCacheItem */ "./lib/_gen/feathers/layout/_PagedTiledRowsListLayout/VirtualCacheItem.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_ILayoutObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutObject */ "./lib/_gen/feathers/layout/ILayoutObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function feathers_layout_VirtualLayoutRange() {return __webpack_require__(/*! ./../../feathers/layout/VirtualLayoutRange */ "./lib/_gen/feathers/layout/VirtualLayoutRange.js");}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}

// Constructor

var PagedTiledRowsListLayout = function(pageDirection) {
	if(pageDirection == null) {
		pageDirection = (feathers_layout_Direction().default).HORIZONTAL;
	}
	this._requestedMaxRowCount = null;
	this._requestedMinRowCount = null;
	this._requestedRowCount = null;
	this._requestedMaxColumnCount = null;
	this._requestedMinColumnCount = null;
	this._requestedColumnCount = null;
	this._minVerticalGap = 0.0;
	this._verticalGap = 0.0;
	this._minHorizontalGap = 0.0;
	this._horizontalGap = 0.0;
	this._paddingLeft = 0.0;
	this._paddingBottom = 0.0;
	this._paddingRight = 0.0;
	this._paddingTop = 0.0;
	this._pageDirection = (feathers_layout_Direction().default).HORIZONTAL;
	this._verticalAlign = (feathers_layout_VerticalAlign().default).TOP;
	this._alignEmptyVerticalTiles = false;
	this._horizontalAlign = (feathers_layout_HorizontalAlign().default).LEFT;
	this._alignEmptyHorizontalTiles = false;
	this._scrollY = 0.0;
	this._scrollX = 0.0;
	(openfl_events_EventDispatcher()).call(this);
	this._pageDirection = pageDirection;
}

// Meta

PagedTiledRowsListLayout.__name__ = "feathers.layout.PagedTiledRowsListLayout";
PagedTiledRowsListLayout.__isInterface__ = false;
PagedTiledRowsListLayout.__interfaces__ = [(feathers_layout_ISnapLayout().default),(feathers_layout_IKeyboardNavigationLayout().default),(feathers_layout_IVirtualLayout().default)];
PagedTiledRowsListLayout.__super__ = (openfl_events_EventDispatcher());
PagedTiledRowsListLayout.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_scrollX: function() {
		return this._scrollX;
	},
	set_scrollX: function(value) {
		this._scrollX = value;
		return this._scrollX;
	},
	get_scrollY: function() {
		return this._scrollY;
	},
	set_scrollY: function(value) {
		this._scrollY = value;
		return this._scrollY;
	},
	get_virtualCache: function() {
		return this._virtualCache;
	},
	set_virtualCache: function(value) {
		this._virtualCache = value;
		return this._virtualCache;
	},
	get_elasticTop: function() {
		return this._pageDirection == (feathers_layout_Direction().default).VERTICAL;
	},
	get_elasticRight: function() {
		return this._pageDirection == (feathers_layout_Direction().default).HORIZONTAL;
	},
	get_elasticBottom: function() {
		return this._pageDirection == (feathers_layout_Direction().default).VERTICAL;
	},
	get_elasticLeft: function() {
		return this._pageDirection == (feathers_layout_Direction().default).HORIZONTAL;
	},
	get_alignEmptyHorizontalTiles: function() {
		return this._alignEmptyHorizontalTiles;
	},
	set_alignEmptyHorizontalTiles: function(value) {
		if(this._alignEmptyHorizontalTiles == value) {
			return this._alignEmptyHorizontalTiles;
		}
		this._alignEmptyHorizontalTiles = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._alignEmptyHorizontalTiles;
	},
	get_horizontalAlign: function() {
		return this._horizontalAlign;
	},
	set_horizontalAlign: function(value) {
		if(this._horizontalAlign == value) {
			return this._horizontalAlign;
		}
		this._horizontalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._horizontalAlign;
	},
	get_alignEmptyVerticalTiles: function() {
		return this._alignEmptyVerticalTiles;
	},
	set_alignEmptyVerticalTiles: function(value) {
		if(this._alignEmptyVerticalTiles == value) {
			return this._alignEmptyVerticalTiles;
		}
		this._alignEmptyVerticalTiles = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._alignEmptyVerticalTiles;
	},
	get_verticalAlign: function() {
		return this._verticalAlign;
	},
	set_verticalAlign: function(value) {
		if(this._verticalAlign == value) {
			return this._verticalAlign;
		}
		this._verticalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._verticalAlign;
	},
	get_pageDirection: function() {
		return this._pageDirection;
	},
	set_pageDirection: function(value) {
		if(this._pageDirection == value) {
			return this._pageDirection;
		}
		this._pageDirection = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._pageDirection;
	},
	get_paddingTop: function() {
		return this._paddingTop;
	},
	set_paddingTop: function(value) {
		if(this._paddingTop == value) {
			return this._paddingTop;
		}
		this._paddingTop = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingTop;
	},
	get_paddingRight: function() {
		return this._paddingRight;
	},
	set_paddingRight: function(value) {
		if(this._paddingRight == value) {
			return this._paddingRight;
		}
		this._paddingRight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingRight;
	},
	get_paddingBottom: function() {
		return this._paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(this._paddingBottom == value) {
			return this._paddingBottom;
		}
		this._paddingBottom = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingBottom;
	},
	get_paddingLeft: function() {
		return this._paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(this._paddingLeft == value) {
			return this._paddingLeft;
		}
		this._paddingLeft = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingLeft;
	},
	get_horizontalGap: function() {
		return this._horizontalGap;
	},
	set_horizontalGap: function(value) {
		if(this._horizontalGap == value) {
			return this._horizontalGap;
		}
		this._horizontalGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._horizontalGap;
	},
	get_minHorizontalGap: function() {
		return this._minHorizontalGap;
	},
	set_minHorizontalGap: function(value) {
		if(this._minHorizontalGap == value) {
			return this._minHorizontalGap;
		}
		this._minHorizontalGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._minHorizontalGap;
	},
	get_verticalGap: function() {
		return this._verticalGap;
	},
	set_verticalGap: function(value) {
		if(this._verticalGap == value) {
			return this._verticalGap;
		}
		this._verticalGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._verticalGap;
	},
	get_minVerticalGap: function() {
		return this._minVerticalGap;
	},
	set_minVerticalGap: function(value) {
		if(this._minVerticalGap == value) {
			return this._minVerticalGap;
		}
		this._minVerticalGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._minVerticalGap;
	},
	get_requestedColumnCount: function() {
		return this._requestedColumnCount;
	},
	set_requestedColumnCount: function(value) {
		if(this._requestedColumnCount == value) {
			return this._requestedColumnCount;
		}
		this._requestedColumnCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedColumnCount;
	},
	get_requestedMinColumnCount: function() {
		return this._requestedMinColumnCount;
	},
	set_requestedMinColumnCount: function(value) {
		if(this._requestedMinColumnCount == value) {
			return this._requestedMinColumnCount;
		}
		this._requestedMinColumnCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedMinColumnCount;
	},
	get_requestedMaxColumnCount: function() {
		return this._requestedMaxColumnCount;
	},
	set_requestedMaxColumnCount: function(value) {
		if(this._requestedMaxColumnCount == value) {
			return this._requestedMaxColumnCount;
		}
		this._requestedMaxColumnCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedMaxColumnCount;
	},
	get_requestedRowCount: function() {
		return this._requestedRowCount;
	},
	set_requestedRowCount: function(value) {
		if(this._requestedRowCount == value) {
			return this._requestedRowCount;
		}
		this._requestedRowCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedRowCount;
	},
	get_requestedMinRowCount: function() {
		return this._requestedMinRowCount;
	},
	set_requestedMinRowCount: function(value) {
		if(this._requestedMinRowCount == value) {
			return this._requestedMinRowCount;
		}
		this._requestedMinRowCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedMinRowCount;
	},
	get_requestedMaxRowCount: function() {
		return this._requestedMaxRowCount;
	},
	set_requestedMaxRowCount: function(value) {
		if(this._requestedMaxRowCount == value) {
			return this._requestedMaxRowCount;
		}
		this._requestedMaxRowCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedMaxRowCount;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	setGap: function(value) {
		this.set_horizontalGap(value);
		this.set_verticalGap(value);
	},
	layout: function(items,measurements,result) {
		var adjustedHorizontalGap = this._horizontalGap;
		var hasFlexHorizontalGap = this._horizontalGap == 1.0 / 0.0;
		if(hasFlexHorizontalGap) {
			adjustedHorizontalGap = this._minHorizontalGap;
		}
		var adjustedVerticalGap = this._verticalGap;
		var hasFlexVerticalGap = this._verticalGap == 1.0 / 0.0;
		if(hasFlexVerticalGap) {
			adjustedVerticalGap = this._minVerticalGap;
		}
		if(items.length == 0) {
			if(result == null) {
				result = new (feathers_layout_LayoutBoundsResult().default)();
			}
			result.contentX = 0.0;
			result.contentY = 0.0;
			result.contentWidth = this._paddingLeft + this._paddingRight;
			result.contentHeight = this._paddingTop + this._paddingBottom;
			result.viewPortWidth = result.contentWidth;
			if(this._requestedColumnCount != null) {
				if(this._requestedColumnCount > 1) {
					result.viewPortWidth += this._requestedColumnCount * adjustedHorizontalGap - adjustedHorizontalGap;
				}
			} else if(this._requestedMinColumnCount != null) {
				if(this._requestedMinColumnCount > 1) {
					result.viewPortWidth += this._requestedMinColumnCount * adjustedHorizontalGap - adjustedHorizontalGap;
				}
			}
			result.viewPortHeight = result.contentHeight;
			if(this._requestedRowCount != null) {
				if(this._requestedRowCount > 1) {
					result.viewPortHeight += this._requestedRowCount * adjustedVerticalGap - adjustedVerticalGap;
				}
			} else if(this._requestedMinRowCount != null) {
				if(this._requestedMinRowCount > 1) {
					result.viewPortHeight += this._requestedMinRowCount * adjustedVerticalGap - adjustedVerticalGap;
				}
			}
			if(this._requestedMinColumnCount != null) {
				if(this._requestedMinColumnCount > 1) {
					result.contentMinWidth = this._paddingLeft + this._paddingRight + (this._requestedMinColumnCount * adjustedHorizontalGap - adjustedHorizontalGap);
				}
			}
			if(this._requestedMinRowCount != null) {
				if(this._requestedMinRowCount > 1) {
					result.contentMinHeight = this._paddingTop + this._paddingBottom + (this._requestedMinRowCount * adjustedVerticalGap - adjustedVerticalGap);
				}
			}
			return result;
		}
		var tileWidth = 0.0;
		var tileHeight = 0.0;
		if(this._virtualCache != null && this._virtualCache.length != 0) {
			var cacheItem = (Std().default).downcast(this._virtualCache[0],(feathers_layout__$PagedTiledRowsListLayout_VirtualCacheItem().default));
			if(cacheItem != null) {
				tileWidth = cacheItem.itemWidth;
				tileHeight = cacheItem.itemHeight;
			}
		}
		if(tileWidth == 0.0 && tileHeight == 0.0) {
			var _g = 0;
			while(_g < items.length) {
				var item = items[_g];
				++_g;
				if(item == null) {
					continue;
				} else {
					if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
						if(!((js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default))).get_includeInLayout()) {
							continue;
						}
					}
					if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
						((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
					}
					tileWidth = item.get_width();
					tileHeight = item.get_height();
					if(this._virtualCache != null) {
						var cacheItem1 = (Std().default).downcast(this._virtualCache[0],(feathers_layout__$PagedTiledRowsListLayout_VirtualCacheItem().default));
						if(cacheItem1 == null || cacheItem1.itemWidth != tileWidth || cacheItem1.itemHeight != tileHeight) {
							if(cacheItem1 == null) {
								cacheItem1 = new (feathers_layout__$PagedTiledRowsListLayout_VirtualCacheItem().default)(tileWidth,tileHeight);
							} else {
								cacheItem1.itemWidth = tileWidth;
								cacheItem1.itemHeight = tileHeight;
							}
							this._virtualCache[0] = cacheItem1;
							(feathers_events_FeathersEvent().default).dispatch(this,"change");
						}
					}
					break;
				}
			}
		}
		var horizontalTileCount = this.calculateHorizontalTileCount(tileWidth,measurements.width,measurements.maxWidth,adjustedHorizontalGap,items.length);
		var viewPortWidth = measurements.width;
		if(viewPortWidth == null) {
			viewPortWidth = this._paddingLeft + this._paddingRight + horizontalTileCount * (tileWidth + adjustedHorizontalGap) - adjustedHorizontalGap;
			if(measurements.minWidth != null && viewPortWidth < measurements.minWidth) {
				viewPortWidth = measurements.minWidth;
			} else if(measurements.maxWidth != null && viewPortWidth > measurements.maxWidth) {
				viewPortWidth = measurements.maxWidth;
			}
		}
		var availableRowWidth = viewPortWidth - this.get_paddingLeft() - this.get_paddingRight();
		var verticalTileCount = this.calculateVerticalTileCount(tileHeight,measurements.height,measurements.maxHeight,adjustedVerticalGap,items.length,horizontalTileCount);
		var viewPortHeight = measurements.height;
		if(viewPortHeight == null) {
			viewPortHeight = this._paddingTop + this._paddingBottom + verticalTileCount * tileHeight + (Std().default).int(verticalTileCount) * adjustedVerticalGap - adjustedVerticalGap;
			if(measurements.minHeight != null && viewPortHeight < measurements.minHeight) {
				viewPortHeight = measurements.minHeight;
			} else if(measurements.maxHeight != null && viewPortHeight > measurements.maxHeight) {
				viewPortHeight = measurements.maxHeight;
			}
		}
		var availablePageHeight = viewPortHeight - this._paddingTop - this._paddingBottom;
		var xPosition = this._paddingLeft;
		var yPosition = this._paddingTop;
		var currentColumnCount = 0;
		var currentRowCount = 0;
		var currentPageIndex = 0;
		var numItemsPerPage = horizontalTileCount * verticalTileCount;
		var _g1 = 0;
		var _g11 = items.length;
		while(_g1 < _g11) {
			var i = _g1++;
			var item1 = items[i];
			if((js_Boot().default).__implements(item1,(feathers_layout_ILayoutObject().default))) {
				var layoutItem = (js_Boot().default).__cast(item1 , (feathers_layout_ILayoutObject().default));
				if(!layoutItem.get_includeInLayout()) {
					continue;
				}
			}
			if(currentColumnCount >= horizontalTileCount) {
				this.applyHorizontalAlignToRow(items,i - currentColumnCount,currentColumnCount,horizontalTileCount,availableRowWidth,tileWidth);
				switch(this._pageDirection._hx_index) {
				case 0:
					xPosition = this._paddingLeft;
					break;
				case 1:
					xPosition = this._paddingLeft + currentPageIndex * viewPortWidth;
					break;
				default:
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown paging direction: " + (Std().default).string(this._pageDirection)));
				}
				yPosition += tileHeight;
				currentColumnCount = 0;
				++currentRowCount;
				if(currentRowCount == verticalTileCount) {
					this.applyVerticalAlignToPage(items,currentPageIndex * numItemsPerPage,numItemsPerPage,currentRowCount,verticalTileCount,horizontalTileCount,availablePageHeight,tileHeight,adjustedVerticalGap);
					++currentPageIndex;
					currentRowCount = 0;
					switch(this._pageDirection._hx_index) {
					case 0:
						xPosition = this._paddingLeft;
						yPosition = this._paddingTop + currentPageIndex * viewPortHeight;
						break;
					case 1:
						xPosition = this._paddingLeft + currentPageIndex * viewPortWidth;
						yPosition = this._paddingTop;
						break;
					default:
						throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown paging direction: " + (Std().default).string(this._pageDirection)));
					}
				}
			}
			if(item1 != null) {
				item1.set_x(xPosition);
				item1.set_y(yPosition);
				item1.set_width(tileWidth);
				item1.set_height(tileHeight);
			}
			xPosition += tileWidth + adjustedHorizontalGap;
			++currentColumnCount;
		}
		this.applyHorizontalAlignToRow(items,items.length - currentColumnCount,currentColumnCount,horizontalTileCount,availableRowWidth,tileWidth);
		yPosition += tileHeight + this.get_paddingBottom();
		++currentRowCount;
		this.applyVerticalAlignToPage(items,currentPageIndex * numItemsPerPage,numItemsPerPage,currentRowCount,verticalTileCount,horizontalTileCount,availablePageHeight,tileHeight,adjustedVerticalGap);
		var contentWidth;
		switch(this._pageDirection._hx_index) {
		case 0:
			contentWidth = viewPortWidth;
			break;
		case 1:
			contentWidth = Math.ceil(items.length / numItemsPerPage) * viewPortWidth;
			break;
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown paging direction: " + (Std().default).string(this._pageDirection)));
		}
		var contentHeight;
		switch(this._pageDirection._hx_index) {
		case 0:
			contentHeight = Math.ceil(items.length / numItemsPerPage) * viewPortHeight;
			break;
		case 1:
			contentHeight = viewPortHeight;
			break;
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown paging direction: " + (Std().default).string(this._pageDirection)));
		}
		if(result == null) {
			result = new (feathers_layout_LayoutBoundsResult().default)();
		}
		result.contentX = 0.0;
		result.contentY = 0.0;
		result.contentWidth = contentWidth;
		result.contentHeight = contentHeight;
		if(this._requestedMinColumnCount != null) {
			result.contentMinWidth = this._paddingLeft + this._paddingRight + (this._requestedMinColumnCount * (tileWidth + adjustedHorizontalGap) - adjustedHorizontalGap);
		}
		if(this._requestedMinRowCount != null) {
			result.contentMinHeight = this._paddingTop + this._paddingBottom + (this._requestedMinRowCount * (tileHeight + adjustedVerticalGap) - adjustedVerticalGap);
		}
		result.viewPortWidth = viewPortWidth;
		result.viewPortHeight = viewPortHeight;
		return result;
	},
	getVisibleIndices: function(itemCount,width,height,result) {
		switch(this._pageDirection._hx_index) {
		case 0:
			return this.getVisibleIndicesVertical(itemCount,width,height,result);
		case 1:
			return this.getVisibleIndicesHorizontal(itemCount,width,height,result);
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown paging direction: " + (Std().default).string(this._pageDirection)));
		}
	},
	getNearestScrollPositionForIndex: function(index,itemCount,width,height,result) {
		if(result == null) {
			result = new (openfl_geom_Point())();
		}
		var tileWidth = 0.0;
		var tileHeight = 0.0;
		if(this._virtualCache != null && this._virtualCache.length != 0) {
			var cacheItem = (Std().default).downcast(this._virtualCache[0],(feathers_layout__$PagedTiledRowsListLayout_VirtualCacheItem().default));
			if(cacheItem != null) {
				tileWidth = cacheItem.itemWidth;
				tileHeight = cacheItem.itemHeight;
			}
		}
		if(tileWidth == 0.0 || tileHeight == 0.0) {
			return result;
		}
		var adjustedHorizontalGap = this._horizontalGap;
		var hasFlexHorizontalGap = this._horizontalGap == 1.0 / 0.0;
		if(hasFlexHorizontalGap) {
			adjustedHorizontalGap = this._minHorizontalGap;
		}
		var adjustedVerticalGap = this._verticalGap;
		var hasFlexVerticalGap = this._verticalGap == 1.0 / 0.0;
		if(hasFlexVerticalGap) {
			adjustedVerticalGap = this._minVerticalGap;
		}
		var horizontalTileCount = this.calculateHorizontalTileCount(tileWidth,width,null,adjustedHorizontalGap,itemCount);
		var verticalTileCount = this.calculateVerticalTileCount(tileHeight,height,null,adjustedVerticalGap,itemCount,horizontalTileCount);
		var perPage = horizontalTileCount * verticalTileCount;
		var pageIndex = (Std().default).int(index / perPage);
		switch(this._pageDirection._hx_index) {
		case 0:
			result.x = 0;
			result.y = pageIndex * height;
			break;
		case 1:
			result.x = pageIndex * width;
			result.y = 0;
			break;
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown paging direction: " + (Std().default).string(this._pageDirection)));
		}
		return result;
	},
	findNextKeyboardIndex: function(startIndex,event,wrapArrowKeys,items,indicesToSkip,viewPortWidth,viewPortHeight) {
		var itemCount = items.length;
		if(itemCount == 0) {
			return -1;
		}
		var tileWidth = 0.0;
		var tileHeight = 0.0;
		if(this._virtualCache != null && this._virtualCache.length != 0) {
			var cacheItem = (Std().default).downcast(this._virtualCache[0],(feathers_layout__$PagedTiledRowsListLayout_VirtualCacheItem().default));
			if(cacheItem != null) {
				tileWidth = cacheItem.itemWidth;
				tileHeight = cacheItem.itemHeight;
			}
		}
		if(tileWidth == 0.0 || tileHeight == 0.0) {
			return startIndex;
		}
		var adjustedHorizontalGap = this._horizontalGap;
		var hasFlexHorizontalGap = this._horizontalGap == 1.0 / 0.0;
		if(hasFlexHorizontalGap) {
			var availableRowWidth = viewPortWidth - this.get_paddingLeft() - this.get_paddingRight();
			adjustedHorizontalGap = this._minHorizontalGap;
			var maxContentWidth = itemCount * (tileWidth + adjustedHorizontalGap);
			if(itemCount > 0) {
				maxContentWidth -= adjustedHorizontalGap;
			}
			if(availableRowWidth > maxContentWidth) {
				adjustedHorizontalGap += (availableRowWidth - maxContentWidth) / (itemCount - 1);
			}
		}
		var adjustedVerticalGap = this._verticalGap;
		var hasFlexVerticalGap = this._verticalGap == 1.0 / 0.0;
		if(hasFlexVerticalGap) {
			adjustedVerticalGap = this._minVerticalGap;
		}
		var result = startIndex;
		if(result == -1) {
			switch(event.keyCode) {
			case 37:
				result = wrapArrowKeys ? itemCount - 1 : -1;
				break;
			case 38:
				result = wrapArrowKeys ? itemCount - 1 : -1;
				break;
			case 39:
				result = 0;
				break;
			case 40:
				result = 0;
				break;
			default:
				result = -1;
			}
			if(result == -1) {
				return result;
			}
			if(indicesToSkip == null || indicesToSkip.indexOf(result) == -1) {
				return result;
			}
		}
		var pageHorizontalTileCount = this.calculateHorizontalTileCount(tileWidth,viewPortWidth,null,adjustedHorizontalGap,itemCount);
		var pageVerticalTileCount = this.calculateVerticalTileCount(tileHeight,viewPortHeight,null,adjustedVerticalGap,itemCount,pageHorizontalTileCount);
		var horizontalTileCount = pageHorizontalTileCount;
		var verticalTileCount = Math.ceil(itemCount / horizontalTileCount);
		var rowIndex = (Std().default).int(startIndex / pageHorizontalTileCount);
		var columnIndex = (Std().default).int(startIndex % pageHorizontalTileCount);
		if(this._pageDirection == (feathers_layout_Direction().default).HORIZONTAL) {
			verticalTileCount = pageVerticalTileCount;
			var perPage = pageHorizontalTileCount * pageVerticalTileCount;
			var pageCount = Math.ceil(itemCount / perPage);
			horizontalTileCount *= pageCount;
			while(rowIndex >= verticalTileCount) {
				rowIndex -= verticalTileCount;
				columnIndex += pageHorizontalTileCount;
			}
		}
		var needsAnotherPass = true;
		var nextKeyCode = event.keyCode;
		var lastResult = result;
		while(needsAnotherPass) {
			needsAnotherPass = false;
			switch(nextKeyCode) {
			case 33:
				switch(this._pageDirection._hx_index) {
				case 0:
					rowIndex -= pageVerticalTileCount;
					break;
				case 1:
					columnIndex -= pageHorizontalTileCount;
					break;
				default:
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown paging direction: " + (Std().default).string(this._pageDirection)));
				}
				nextKeyCode = 38;
				break;
			case 34:
				switch(this._pageDirection._hx_index) {
				case 0:
					rowIndex += pageVerticalTileCount;
					break;
				case 1:
					columnIndex += pageHorizontalTileCount;
					break;
				default:
					throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown paging direction: " + (Std().default).string(this._pageDirection)));
				}
				nextKeyCode = 40;
				break;
			case 35:
				rowIndex = verticalTileCount - 1;
				columnIndex = horizontalTileCount - 1;
				break;
			case 36:
				rowIndex = 0;
				columnIndex = 0;
				break;
			case 37:
				--columnIndex;
				break;
			case 38:
				--rowIndex;
				break;
			case 39:
				++columnIndex;
				break;
			case 40:
				++rowIndex;
				break;
			}
			if(rowIndex < 0) {
				if(wrapArrowKeys) {
					rowIndex = verticalTileCount - 1;
				} else {
					rowIndex = 0;
				}
			} else if(rowIndex >= verticalTileCount) {
				if(wrapArrowKeys) {
					rowIndex = 0;
				} else {
					rowIndex = verticalTileCount - 1;
				}
			}
			if(columnIndex < 0) {
				if(wrapArrowKeys) {
					columnIndex = horizontalTileCount - 1;
				} else {
					columnIndex = 0;
				}
			} else if(columnIndex >= horizontalTileCount) {
				if(wrapArrowKeys) {
					columnIndex = 0;
				} else {
					columnIndex = horizontalTileCount - 1;
				}
			}
			if(this._pageDirection == (feathers_layout_Direction().default).HORIZONTAL) {
				var tempColumnIndex = columnIndex;
				var tempRowIndex = rowIndex;
				while(tempColumnIndex >= pageHorizontalTileCount) {
					tempColumnIndex -= pageHorizontalTileCount;
					tempRowIndex += verticalTileCount;
				}
				result = tempRowIndex * pageHorizontalTileCount + tempColumnIndex;
			} else {
				result = rowIndex * pageHorizontalTileCount + columnIndex;
			}
			if(result >= itemCount) {
				result = itemCount - 1;
			}
			if(indicesToSkip != null && indicesToSkip.indexOf(result) != -1) {
				if(result == lastResult) {
					return startIndex;
				}
				needsAnotherPass = true;
			}
			lastResult = result;
		}
		return result;
	},
	getSnapPositionsX: function(items,viewPortWidth,viewPortHeight,result) {
		if(this._pageDirection == (feathers_layout_Direction().default).VERTICAL) {
			return null;
		}
		if(result == null) {
			result = [];
		} else {
			result.length = 0;
		}
		var itemCount = items.length;
		if(itemCount == 0) {
			result.push(0.0);
			return result;
		}
		var tileWidth = 0.0;
		var tileHeight = 0.0;
		if(this._virtualCache != null && this._virtualCache.length != 0) {
			var cacheItem = (Std().default).downcast(this._virtualCache[0],(feathers_layout__$PagedTiledRowsListLayout_VirtualCacheItem().default));
			if(cacheItem != null) {
				tileWidth = cacheItem.itemWidth;
				tileHeight = cacheItem.itemHeight;
			}
		}
		if(tileWidth == 0.0 || tileHeight == 0.0) {
			result.push(0.0);
			return result;
		}
		var adjustedHorizontalGap = this._horizontalGap;
		var hasFlexHorizontalGap = this._horizontalGap == 1.0 / 0.0;
		if(hasFlexHorizontalGap) {
			adjustedHorizontalGap = this._minHorizontalGap;
		}
		var adjustedVerticalGap = this._verticalGap;
		var hasFlexVerticalGap = this._verticalGap == 1.0 / 0.0;
		if(hasFlexVerticalGap) {
			adjustedVerticalGap = this._minVerticalGap;
		}
		var horizontalTileCount = this.calculateHorizontalTileCount(tileWidth,viewPortWidth,null,adjustedHorizontalGap,itemCount);
		var verticalTileCount = this.calculateVerticalTileCount(tileHeight,viewPortHeight,null,adjustedVerticalGap,itemCount,horizontalTileCount);
		var perPage = horizontalTileCount * verticalTileCount;
		var pageCount = Math.ceil(itemCount / perPage);
		var positionX = 0.0;
		var _g = 0;
		var _g1 = pageCount;
		while(_g < _g1) {
			var i = _g++;
			result[i] = positionX;
			positionX += viewPortWidth;
		}
		return result;
	},
	getSnapPositionsY: function(items,viewPortWidth,viewPortHeight,result) {
		if(this._pageDirection == (feathers_layout_Direction().default).HORIZONTAL) {
			return null;
		}
		if(result == null) {
			result = [];
		} else {
			result.length = 0;
		}
		var itemCount = items.length;
		if(itemCount == 0) {
			result.push(0.0);
			return result;
		}
		var tileWidth = 0.0;
		var tileHeight = 0.0;
		if(this._virtualCache != null && this._virtualCache.length != 0) {
			var cacheItem = (Std().default).downcast(this._virtualCache[0],(feathers_layout__$PagedTiledRowsListLayout_VirtualCacheItem().default));
			if(cacheItem != null) {
				tileWidth = cacheItem.itemWidth;
				tileHeight = cacheItem.itemHeight;
			}
		}
		if(tileWidth == 0.0 || tileHeight == 0.0) {
			result.push(0.0);
			return result;
		}
		var adjustedHorizontalGap = this._horizontalGap;
		var hasFlexHorizontalGap = this._horizontalGap == 1.0 / 0.0;
		if(hasFlexHorizontalGap) {
			adjustedHorizontalGap = this._minHorizontalGap;
		}
		var adjustedVerticalGap = this._verticalGap;
		var hasFlexVerticalGap = this._verticalGap == 1.0 / 0.0;
		if(hasFlexVerticalGap) {
			adjustedVerticalGap = this._minVerticalGap;
		}
		var horizontalTileCount = this.calculateHorizontalTileCount(tileWidth,viewPortWidth,null,adjustedHorizontalGap,itemCount);
		var verticalTileCount = this.calculateVerticalTileCount(tileHeight,viewPortHeight,null,adjustedVerticalGap,itemCount,horizontalTileCount);
		var perPage = horizontalTileCount * verticalTileCount;
		var pageCount = Math.ceil(itemCount / perPage);
		var positionY = 0.0;
		var _g = 0;
		var _g1 = pageCount;
		while(_g < _g1) {
			var i = _g++;
			result[i] = positionY;
			positionY += viewPortHeight;
		}
		return result;
	},
	calculateHorizontalTileCount: function(tileWidth,explicitWidth,explicitMaxWidth,horizontalGap,totalItemCount) {
		if(explicitWidth != null) {
			var maxHorizontalTileCount = (Std().default).int((explicitWidth - this._paddingLeft - this._paddingRight + horizontalGap) / (tileWidth + horizontalGap));
			if(this._requestedColumnCount != null) {
				if(this._requestedColumnCount > maxHorizontalTileCount) {
					return maxHorizontalTileCount;
				}
				return (Std().default).int(Math.max(1,this._requestedColumnCount));
			}
			var horizontalTileCount = maxHorizontalTileCount;
			if(horizontalTileCount < 1) {
				horizontalTileCount = 1;
			} else if(horizontalTileCount > totalItemCount) {
				horizontalTileCount = totalItemCount;
			}
			if(this._requestedMinColumnCount != null) {
				if(this._requestedMinColumnCount < horizontalTileCount) {
					return horizontalTileCount;
				}
				return (Std().default).int(Math.max(1,this._requestedMinColumnCount));
			}
			if(this._requestedMaxColumnCount != null) {
				if(this._requestedMaxColumnCount > horizontalTileCount) {
					return horizontalTileCount;
				}
				return (Std().default).int(Math.max(1,this._requestedMaxColumnCount));
			}
			return horizontalTileCount;
		}
		var horizontalTileCount1 = totalItemCount;
		if(this._requestedColumnCount != null) {
			horizontalTileCount1 = (Std().default).int(Math.max(1,this._requestedColumnCount));
		} else if(this._requestedMinColumnCount != null) {
			if(horizontalTileCount1 < this._requestedMinColumnCount) {
				horizontalTileCount1 = this._requestedMinColumnCount;
			}
		} else if(this._requestedMaxColumnCount != null) {
			if(horizontalTileCount1 > this._requestedMaxColumnCount) {
				horizontalTileCount1 = this._requestedMaxColumnCount;
			}
		}
		var maxHorizontalTileCount1 = 2147483647;
		if(explicitMaxWidth != null && explicitMaxWidth < Infinity) {
			maxHorizontalTileCount1 = (Std().default).int((explicitMaxWidth - this._paddingLeft - this._paddingRight + horizontalGap) / (tileWidth + horizontalGap));
			if(maxHorizontalTileCount1 < 1) {
				maxHorizontalTileCount1 = 1;
			}
		}
		if(horizontalTileCount1 > maxHorizontalTileCount1) {
			horizontalTileCount1 = maxHorizontalTileCount1;
		}
		if(horizontalTileCount1 < 1) {
			horizontalTileCount1 = 1;
		}
		return horizontalTileCount1;
	},
	calculateVerticalTileCount: function(tileHeight,explicitHeight,explicitMaxHeight,verticalGap,totalItemCount,horizontalTileCount) {
		var defaultVerticalTileCount = Math.ceil(totalItemCount / horizontalTileCount);
		if(explicitHeight != null) {
			var maxVerticalTileCount = (Std().default).int((explicitHeight - this._paddingTop - this._paddingBottom + verticalGap) / (tileHeight + verticalGap));
			if(this._requestedRowCount != null && this._requestedRowCount >= 0) {
				if(this._requestedRowCount > maxVerticalTileCount) {
					return maxVerticalTileCount;
				}
				return this._requestedRowCount;
			}
			var verticalTileCount = maxVerticalTileCount;
			if(verticalTileCount > defaultVerticalTileCount) {
				verticalTileCount = defaultVerticalTileCount;
			}
			if(verticalTileCount < 1) {
				verticalTileCount = 1;
			}
			if(this._requestedMinRowCount != null && this._requestedMinRowCount >= 1) {
				if(this._requestedMinRowCount < verticalTileCount) {
					return verticalTileCount;
				}
				return this._requestedMinRowCount;
			}
			if(this._requestedMaxRowCount != null && this._requestedMaxRowCount >= 1) {
				if(this._requestedMaxRowCount > verticalTileCount) {
					return verticalTileCount;
				}
				return this._requestedMaxRowCount;
			}
			return verticalTileCount;
		}
		var verticalTileCount1 = defaultVerticalTileCount;
		if(this._requestedRowCount > 0) {
			verticalTileCount1 = this._requestedRowCount;
		}
		if(this._requestedMinRowCount != null && this._requestedMinRowCount >= 1.0 && verticalTileCount1 < this._requestedMinRowCount) {
			return this._requestedMinRowCount;
		}
		var maxVerticalTileCount1 = 2147483647;
		if(explicitMaxHeight != null && explicitMaxHeight < Infinity) {
			maxVerticalTileCount1 = (Std().default).int((explicitMaxHeight - this._paddingTop - this._paddingBottom + verticalGap) / (tileHeight + verticalGap));
			if(maxVerticalTileCount1 < 1) {
				maxVerticalTileCount1 = 1;
			}
		}
		if(verticalTileCount1 > maxVerticalTileCount1) {
			verticalTileCount1 = maxVerticalTileCount1;
		}
		if(this._requestedMaxRowCount != null && this._requestedMaxRowCount >= 1.0 && verticalTileCount1 > this._requestedMaxRowCount) {
			verticalTileCount1 = this._requestedMaxRowCount;
		}
		if(verticalTileCount1 < 1) {
			verticalTileCount1 = 1;
		}
		return verticalTileCount1;
	},
	applyHorizontalAlignToRow: function(items,startIndex,numItemsInRow,horizontalTileCount,availableRowWidth,tileWidth) {
		if(this._alignEmptyHorizontalTiles && horizontalTileCount > numItemsInRow) {
			numItemsInRow = horizontalTileCount;
		}
		var alignOffset = 0.0;
		var gapOffset = 0.0;
		var adjustedHorizontalGap = this._horizontalGap;
		var hasFlexHorizontalGap = this._horizontalGap == 1.0 / 0.0;
		if(hasFlexHorizontalGap) {
			adjustedHorizontalGap = this._minHorizontalGap;
			var rowContentWidth = numItemsInRow * (tileWidth + adjustedHorizontalGap);
			if(numItemsInRow > 0) {
				rowContentWidth -= adjustedHorizontalGap;
			}
			if(numItemsInRow > 1 && availableRowWidth > rowContentWidth) {
				adjustedHorizontalGap += (availableRowWidth - rowContentWidth) / (numItemsInRow - 1);
			}
			gapOffset = adjustedHorizontalGap - this._minHorizontalGap;
		} else {
			var rowContentWidth1 = numItemsInRow * (tileWidth + adjustedHorizontalGap);
			if(numItemsInRow > 0) {
				rowContentWidth1 -= adjustedHorizontalGap;
			}
			switch(this._horizontalAlign._hx_index) {
			case 0:
				alignOffset = 0.0;
				break;
			case 1:
				alignOffset = (availableRowWidth - rowContentWidth1) / 2.0;
				break;
			case 2:
				alignOffset = availableRowWidth - rowContentWidth1;
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown horizontal align: " + (Std().default).string(this._horizontalAlign)));
			}
			if(alignOffset < 0.0) {
				alignOffset = 0.0;
			}
		}
		if(alignOffset == 0.0 && gapOffset == 0.0) {
			return;
		}
		var totalOffset = alignOffset;
		var endIndex = startIndex + numItemsInRow;
		if(endIndex > items.length) {
			endIndex = items.length;
		}
		var _g = startIndex;
		var _g1 = endIndex;
		while(_g < _g1) {
			var i = _g++;
			var item = items[i];
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				var layoutItem = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutItem.get_includeInLayout()) {
					continue;
				}
			}
			if(item != null) {
				var _g2 = item;
				_g2.set_x(_g2.get_x() + totalOffset);
			}
			totalOffset += gapOffset;
		}
	},
	applyVerticalAlignToPage: function(items,startIndex,numItemsInPage,numRows,verticalTileCount,horizontalTileCount,availableHeight,tileHeight,adjustedVerticalGap) {
		if(this._alignEmptyVerticalTiles && verticalTileCount > numRows) {
			numRows = verticalTileCount;
		}
		var alignOffset = 0.0;
		var gapOffset = adjustedVerticalGap;
		var hasFlexVerticalGap = this._verticalGap == 1.0 / 0.0;
		var contentHeight = numRows * (tileHeight + adjustedVerticalGap) - adjustedVerticalGap;
		if(hasFlexVerticalGap) {
			if(availableHeight > contentHeight) {
				gapOffset += (availableHeight - contentHeight) / (numRows - 1);
			}
		} else {
			switch(this._verticalAlign._hx_index) {
			case 0:
				alignOffset = 0.0;
				break;
			case 1:
				alignOffset = (availableHeight - contentHeight) / 2.0;
				break;
			case 2:
				alignOffset = availableHeight - contentHeight;
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown vertical align: " + (Std().default).string(this._verticalAlign)));
			}
			if(alignOffset < 0.0) {
				alignOffset = 0.0;
			}
		}
		if(alignOffset == 0.0 && gapOffset == 0.0) {
			return;
		}
		var totalOffset = alignOffset;
		var columnIndex = 0;
		var endIndex = (Std().default).int(Math.min(startIndex + numItemsInPage,items.length));
		var layoutIndex = 0;
		var _g = startIndex;
		var _g1 = endIndex;
		while(_g < _g1) {
			var i = _g++;
			var item = items[i];
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				var layoutItem = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutItem.get_includeInLayout()) {
					continue;
				}
			}
			if(layoutIndex % horizontalTileCount == 0) {
				if(columnIndex > 0) {
					totalOffset += gapOffset;
				}
				++columnIndex;
			}
			if(item != null) {
				var _g2 = item;
				_g2.set_y(_g2.get_y() + totalOffset);
			}
			++layoutIndex;
		}
	},
	getVisibleIndicesHorizontal: function(itemCount,width,height,result) {
		var tileWidth = 0.0;
		var tileHeight = 0.0;
		if(this._virtualCache != null && this._virtualCache.length != 0) {
			var cacheItem = (Std().default).downcast(this._virtualCache[0],(feathers_layout__$PagedTiledRowsListLayout_VirtualCacheItem().default));
			if(cacheItem != null) {
				tileWidth = cacheItem.itemWidth;
				tileHeight = cacheItem.itemHeight;
			}
		}
		if(tileWidth == 0.0 || tileHeight == 0.0) {
			if(result == null) {
				result = new (feathers_layout_VirtualLayoutRange().default)(0,0);
			} else {
				result.start = 0;
				result.end = 0;
			}
			return result;
		}
		var adjustedHorizontalGap = this._horizontalGap;
		var hasFlexHorizontalGap = this._horizontalGap == 1.0 / 0.0;
		if(hasFlexHorizontalGap) {
			adjustedHorizontalGap = this._minHorizontalGap;
		}
		var adjustedVerticalGap = this._verticalGap;
		var hasFlexVerticalGap = this._verticalGap == 1.0 / 0.0;
		if(hasFlexVerticalGap) {
			adjustedVerticalGap = this._minVerticalGap;
		}
		var horizontalTileCount = this.calculateHorizontalTileCount(tileWidth,width,null,adjustedHorizontalGap,itemCount);
		var verticalTileCount = this.calculateVerticalTileCount(tileHeight,height,null,adjustedVerticalGap,itemCount,horizontalTileCount);
		var perPage = horizontalTileCount * verticalTileCount;
		var minimumItemCount = perPage + 2 * verticalTileCount;
		if(minimumItemCount > itemCount) {
			minimumItemCount = itemCount;
		}
		var startPageIndex = Math.round(this.get_scrollX() / width);
		var minimum = startPageIndex * perPage;
		var totalRowWidth = horizontalTileCount * (tileWidth + adjustedHorizontalGap) - adjustedHorizontalGap;
		var leftSideOffset = 0.0;
		var rightSideOffset = 0.0;
		if(totalRowWidth < width) {
			switch(this._horizontalAlign._hx_index) {
			case 0:
				leftSideOffset = 0;
				rightSideOffset = width - this._paddingLeft - this._paddingRight - totalRowWidth;
				break;
			case 1:
				rightSideOffset = Math.round((width - this._paddingLeft - this._paddingRight - totalRowWidth) / 2.0);
				leftSideOffset = rightSideOffset;
				break;
			case 2:
				leftSideOffset = width - this._paddingLeft - this._paddingRight - totalRowWidth;
				rightSideOffset = 0;
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown horizontal align: " + (Std().default).string(this._horizontalAlign)));
			}
		}
		var columnOffset = 0;
		var pageStartPosition = startPageIndex * width;
		var partialPageSize = this._scrollX - pageStartPosition;
		if(partialPageSize < 0.0) {
			partialPageSize = -partialPageSize - this._paddingRight - rightSideOffset;
			if(partialPageSize < 0) {
				partialPageSize = 0;
			}
			columnOffset = -(Std().default).int(partialPageSize / (tileWidth + adjustedHorizontalGap)) - 1;
			minimum += -perPage + horizontalTileCount + columnOffset;
		} else if(partialPageSize > 0) {
			partialPageSize = partialPageSize - this._paddingLeft - leftSideOffset;
			if(partialPageSize < 0) {
				partialPageSize = 0;
			}
			columnOffset = (Std().default).int(partialPageSize / (tileWidth + adjustedHorizontalGap));
			minimum += columnOffset;
		}
		if(minimum < 0) {
			minimum = 0;
			columnOffset = 0;
		}
		if(result == null) {
			result = new (feathers_layout_VirtualLayoutRange().default)(0,0);
		} else {
			result.start = 0;
			result.end = 0;
		}
		if(minimum + minimumItemCount >= itemCount) {
			minimum = itemCount - minimumItemCount;
			result.start = minimum;
			result.end = itemCount - 1;
		} else {
			result.start = minimum;
			var rowIndex = 0;
			var columnIndex = (horizontalTileCount + columnOffset) % horizontalTileCount;
			var pageStart = (Std().default).int(minimum / perPage) * perPage;
			var i = minimum;
			var resultLength = 0;
			while(true) {
				if(i < itemCount) {
					if(result.end < i) {
						result.end = i;
					}
					++resultLength;
				}
				++rowIndex;
				if(rowIndex == verticalTileCount) {
					rowIndex = 0;
					++columnIndex;
					if(columnIndex == horizontalTileCount) {
						columnIndex = 0;
						pageStart += perPage;
					}
					i = pageStart + columnIndex - horizontalTileCount;
				}
				i += horizontalTileCount;
				if(!(resultLength < minimumItemCount && pageStart < itemCount)) {
					break;
				}
			}
		}
		return result;
	},
	getVisibleIndicesVertical: function(itemCount,width,height,result) {
		var tileWidth = 0.0;
		var tileHeight = 0.0;
		if(this._virtualCache != null && this._virtualCache.length != 0) {
			var cacheItem = (Std().default).downcast(this._virtualCache[0],(feathers_layout__$PagedTiledRowsListLayout_VirtualCacheItem().default));
			if(cacheItem != null) {
				tileWidth = cacheItem.itemWidth;
				tileHeight = cacheItem.itemHeight;
			}
		}
		if(tileWidth == 0.0 || tileHeight == 0.0) {
			if(result == null) {
				result = new (feathers_layout_VirtualLayoutRange().default)(0,0);
			} else {
				result.start = 0;
				result.end = 0;
			}
			return result;
		}
		var adjustedHorizontalGap = this._horizontalGap;
		var hasFlexHorizontalGap = this._horizontalGap == 1.0 / 0.0;
		if(hasFlexHorizontalGap) {
			adjustedHorizontalGap = this._minHorizontalGap;
		}
		var adjustedVerticalGap = this._verticalGap;
		var hasFlexVerticalGap = this._verticalGap == 1.0 / 0.0;
		if(hasFlexVerticalGap) {
			adjustedVerticalGap = this._minVerticalGap;
		}
		var horizontalTileCount = this.calculateHorizontalTileCount(tileWidth,width,null,adjustedHorizontalGap,itemCount);
		var verticalTileCount = this.calculateVerticalTileCount(tileHeight,height,null,adjustedVerticalGap,itemCount,horizontalTileCount);
		var perPage = horizontalTileCount * verticalTileCount;
		var minimumItemCount = perPage + 2 * horizontalTileCount;
		if(minimumItemCount > itemCount) {
			minimumItemCount = itemCount;
		}
		var startPageIndex = Math.round(this.get_scrollY() / height);
		var minimum = startPageIndex * perPage;
		var totalColumnHeight = verticalTileCount * (tileHeight + adjustedVerticalGap) - adjustedVerticalGap;
		var topSideOffset = 0.0;
		var bottomSideOffset = 0.0;
		if(totalColumnHeight < height) {
			switch(this._verticalAlign._hx_index) {
			case 0:
				topSideOffset = 0;
				bottomSideOffset = height - this._paddingTop - this._paddingBottom - totalColumnHeight;
				break;
			case 1:
				bottomSideOffset = Math.round((height - this._paddingTop - this._paddingBottom - totalColumnHeight) / 2.0);
				topSideOffset = bottomSideOffset;
				break;
			case 2:
				topSideOffset = height - this._paddingTop - this._paddingBottom - totalColumnHeight;
				bottomSideOffset = 0;
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown vertical align: " + (Std().default).string(this._verticalAlign)));
			}
		}
		var rowOffset = 0;
		var pageStartPosition = startPageIndex * height;
		var partialPageSize = this.get_scrollY() - pageStartPosition;
		if(partialPageSize < 0) {
			partialPageSize = -partialPageSize - this._paddingBottom - bottomSideOffset;
			if(partialPageSize < 0) {
				partialPageSize = 0;
			}
			rowOffset = -Math.floor(partialPageSize / (tileHeight + adjustedVerticalGap)) - 1;
			minimum += horizontalTileCount * rowOffset;
		} else if(partialPageSize > 0) {
			partialPageSize = partialPageSize - this._paddingTop - topSideOffset;
			if(partialPageSize < 0) {
				partialPageSize = 0;
			}
			rowOffset = Math.floor(partialPageSize / (tileHeight + adjustedVerticalGap));
			minimum += horizontalTileCount * rowOffset;
		}
		if(minimum < 0) {
			minimum = 0;
			rowOffset = 0;
		}
		var maximum = minimum + minimumItemCount;
		if(maximum >= itemCount) {
			maximum = itemCount - 1;
			minimum = maximum - minimumItemCount;
			if(minimum < 0) {
				minimum = 0;
			}
		}
		if(result == null) {
			result = new (feathers_layout_VirtualLayoutRange().default)(minimum,maximum);
		} else {
			result.start = minimum;
			result.end = maximum;
		}
		return result;
	}
});
PagedTiledRowsListLayout.prototype.__class__ = PagedTiledRowsListLayout.prototype.constructor = $hxClasses["feathers.layout.PagedTiledRowsListLayout"] = PagedTiledRowsListLayout;

// Init



// Statics




// Export

exports["default"] = PagedTiledRowsListLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/RelativePosition.js":
/*!******************************************************!*\
  !*** ./lib/_gen/feathers/layout/RelativePosition.js ***!
  \******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.layout.RelativePosition

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var RelativePosition = $hxEnums["feathers.layout.RelativePosition"] = { __ename__ : "feathers.layout.RelativePosition", __constructs__ : ["TOP","RIGHT","BOTTOM","LEFT","MANUAL"]
  ,TOP: {_hx_index:0,__enum__:"feathers.layout.RelativePosition",toString:$estr}
  ,RIGHT: {_hx_index:1,__enum__:"feathers.layout.RelativePosition",toString:$estr}
  ,MANUAL: {_hx_index:4,__enum__:"feathers.layout.RelativePosition",toString:$estr}
  ,LEFT: {_hx_index:3,__enum__:"feathers.layout.RelativePosition",toString:$estr}
  ,BOTTOM: {_hx_index:2,__enum__:"feathers.layout.RelativePosition",toString:$estr}
};

exports["default"] = RelativePosition;

/***/ }),

/***/ "./lib/_gen/feathers/layout/ResponsiveGridLayout.js":
/*!**********************************************************!*\
  !*** ./lib/_gen/feathers/layout/ResponsiveGridLayout.js ***!
  \**********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.ResponsiveGridLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_ILayout() {return __webpack_require__(/*! ./../../feathers/layout/ILayout */ "./lib/_gen/feathers/layout/ILayout.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_ILayoutObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutObject */ "./lib/_gen/feathers/layout/ILayoutObject.js");}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_layout_Breakpoint() {return __webpack_require__(/*! ./../../feathers/layout/Breakpoint */ "./lib/_gen/feathers/layout/Breakpoint.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_layout_ResponsiveGridLayoutData() {return __webpack_require__(/*! ./../../feathers/layout/ResponsiveGridLayoutData */ "./lib/_gen/feathers/layout/ResponsiveGridLayoutData.js");}

// Constructor

var ResponsiveGridLayout = function(columnCount,sm,md,lg,xl,xxl) {
	if(xxl == null) {
		xxl = 1400.0;
	}
	if(xl == null) {
		xl = 1200.0;
	}
	if(lg == null) {
		lg = 992.0;
	}
	if(md == null) {
		md = 768.0;
	}
	if(sm == null) {
		sm = 576.0;
	}
	if(columnCount == null) {
		columnCount = 12;
	}
	this._rowItems = [];
	this._justifyResetEnabled = false;
	this._rowVerticalAlign = (feathers_layout_VerticalAlign().default).TOP;
	this._paddingLeft = 0.0;
	this._paddingBottom = 0.0;
	this._paddingRight = 0.0;
	this._paddingTop = 0.0;
	this._columnGap = 0.0;
	this._rowGap = 0.0;
	this._xxl = 1400.0;
	this._xl = 1200.0;
	this._lg = 992.0;
	this._md = 768.0;
	this._sm = 576.0;
	(openfl_events_EventDispatcher()).call(this);
	this._columnCount = columnCount;
	this._sm = sm;
	this._md = md;
	this._lg = lg;
	this._xl = xl;
	this._xxl = xxl;
}

// Meta

ResponsiveGridLayout.__name__ = "feathers.layout.ResponsiveGridLayout";
ResponsiveGridLayout.__isInterface__ = false;
ResponsiveGridLayout.__interfaces__ = [(feathers_layout_ILayout().default)];
ResponsiveGridLayout.__super__ = (openfl_events_EventDispatcher());
ResponsiveGridLayout.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_columnCount: function() {
		return this._columnCount;
	},
	set_columnCount: function(value) {
		if(this._columnCount == value) {
			return this._columnCount;
		}
		this._columnCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._columnCount;
	},
	get_sm: function() {
		return this._sm;
	},
	set_sm: function(value) {
		if(this._sm == value) {
			return this._sm;
		}
		this._sm = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._sm;
	},
	get_md: function() {
		return this._md;
	},
	set_md: function(value) {
		if(this._md == value) {
			return this._md;
		}
		this._md = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._md;
	},
	get_lg: function() {
		return this._lg;
	},
	set_lg: function(value) {
		if(this._lg == value) {
			return this._lg;
		}
		this._lg = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._lg;
	},
	get_xl: function() {
		return this._xl;
	},
	set_xl: function(value) {
		if(this._xl == value) {
			return this._xl;
		}
		this._xl = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._xl;
	},
	get_xxl: function() {
		return this._xxl;
	},
	set_xxl: function(value) {
		if(this._xxl == value) {
			return this._xxl;
		}
		this._xxl = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._xxl;
	},
	get_rowGap: function() {
		return this._rowGap;
	},
	set_rowGap: function(value) {
		if(this._rowGap == value) {
			return this._rowGap;
		}
		this._rowGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._rowGap;
	},
	get_columnGap: function() {
		return this._columnGap;
	},
	set_columnGap: function(value) {
		if(this._columnGap == value) {
			return this._columnGap;
		}
		this._columnGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._columnGap;
	},
	get_paddingTop: function() {
		return this._paddingTop;
	},
	set_paddingTop: function(value) {
		if(this._paddingTop == value) {
			return this._paddingTop;
		}
		this._paddingTop = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingTop;
	},
	get_paddingRight: function() {
		return this._paddingRight;
	},
	set_paddingRight: function(value) {
		if(this._paddingRight == value) {
			return this._paddingRight;
		}
		this._paddingRight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingRight;
	},
	get_paddingBottom: function() {
		return this._paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(this._paddingBottom == value) {
			return this._paddingBottom;
		}
		this._paddingBottom = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingBottom;
	},
	get_paddingLeft: function() {
		return this._paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(this._paddingLeft == value) {
			return this._paddingLeft;
		}
		this._paddingLeft = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingLeft;
	},
	get_rowVerticalAlign: function() {
		return this._rowVerticalAlign;
	},
	set_rowVerticalAlign: function(value) {
		if(this._rowVerticalAlign == value) {
			return this._rowVerticalAlign;
		}
		this._rowVerticalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._rowVerticalAlign;
	},
	get_justifyResetEnabled: function() {
		return this._justifyResetEnabled;
	},
	set_justifyResetEnabled: function(value) {
		if(this._justifyResetEnabled == value) {
			return this._justifyResetEnabled;
		}
		this._justifyResetEnabled = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._justifyResetEnabled;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	setGap: function(value) {
		this.set_columnGap(value);
		this.set_rowGap(value);
	},
	layout: function(items,measurements,result) {
		if(this._xxl < this._xl) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("xxl must be greater than xl"));
		}
		if(this._xl < this._lg) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("xl must be greater than lg"));
		}
		if(this._lg < this._md) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("lg must be greater than md"));
		}
		if(this._md < this._sm) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("md must be greater than sm"));
		}
		var viewPortWidth = measurements.width != null ? measurements.width : this._md;
		var contentHeight = this.layoutItems(items,viewPortWidth);
		var viewPortHeight = contentHeight;
		if(measurements.height != null) {
			viewPortHeight = measurements.height;
		}
		if(result == null) {
			result = new (feathers_layout_LayoutBoundsResult().default)();
		}
		result.contentX = 0.0;
		result.contentY = 0.0;
		result.contentWidth = viewPortWidth;
		result.contentHeight = contentHeight;
		result.viewPortWidth = viewPortWidth;
		result.viewPortHeight = viewPortHeight;
		return result;
	},
	layoutItems: function(items,viewPortWidth) {
		var breakpoint = this.getBreakpoint(viewPortWidth);
		var availableWidth = viewPortWidth - this._paddingLeft - this._paddingRight;
		var columnWidth = (availableWidth + this._columnGap) / this._columnCount - this._columnGap;
		var totalOffset = 0;
		var yPosition = this._paddingTop;
		var maxRowHeight = 0.0;
		this._rowItems.length = 0;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				var layoutItem = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutItem.get_includeInLayout()) {
					continue;
				}
			}
			var display = this.getDisplay(item,breakpoint);
			item.set_visible(display);
			if(!display) {
				continue;
			}
			var span = this.getSpan(item,breakpoint);
			var offset = this.getOffset(item,span,breakpoint);
			if(totalOffset + offset + span > this._columnCount) {
				this.alignRow(yPosition,maxRowHeight);
				this._rowItems.length = 0;
				totalOffset = 0;
				yPosition += maxRowHeight + this._rowGap;
				maxRowHeight = 0.0;
			}
			totalOffset += offset;
			this.positionItem(item,span,totalOffset,columnWidth,yPosition);
			totalOffset += span;
			maxRowHeight = Math.max(maxRowHeight,item.get_height());
			this._rowItems.push(item);
		}
		this.alignRow(yPosition,maxRowHeight);
		this._rowItems.length = 0;
		if(maxRowHeight == 0.0) {
			yPosition -= this._rowGap;
		}
		return yPosition + maxRowHeight + this._paddingBottom;
	},
	alignRow: function(positionY,maxItemHeight) {
		var _g = 0;
		var _g1 = this._rowItems;
		while(_g < _g1.length) {
			var item = _g1[_g];
			++_g;
			switch(this._rowVerticalAlign._hx_index) {
			case 0:
				item.set_y(positionY);
				break;
			case 1:
				item.set_y(positionY + (maxItemHeight - item.get_height()) / 2.0);
				break;
			case 2:
				item.set_y(positionY + maxItemHeight - item.get_height());
				break;
			case 3:
				item.set_y(positionY);
				if(item.get_height() != maxItemHeight) {
					item.set_height(maxItemHeight);
				}
				break;
			}
		}
	},
	positionItem: function(item,span,offset,columnWidth,yPosition) {
		item.set_x(this._paddingLeft + (offset != 0 ? (columnWidth + this._columnGap) * offset : 0.0));
		item.set_y(yPosition);
		item.set_width(span != 0 ? (columnWidth + this._columnGap) * span - this._columnGap : columnWidth);
		if(this._rowVerticalAlign == (feathers_layout_VerticalAlign().default).JUSTIFY && this._justifyResetEnabled && (js_Boot().default).__implements(item,(feathers_core_IMeasureObject().default))) {
			((js_Boot().default).__cast(item , (feathers_core_IMeasureObject().default))).resetHeight();
		}
		if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
		}
	},
	getBreakpoint: function(viewPortWidth) {
		if(viewPortWidth >= this._xxl) {
			return (feathers_layout_Breakpoint().default).XXL;
		}
		if(viewPortWidth >= this._xl) {
			return (feathers_layout_Breakpoint().default).XL;
		}
		if(viewPortWidth >= this._lg) {
			return (feathers_layout_Breakpoint().default).LG;
		}
		if(viewPortWidth >= this._md) {
			return (feathers_layout_Breakpoint().default).MD;
		}
		if(viewPortWidth >= this._sm) {
			return (feathers_layout_Breakpoint().default).SM;
		}
		return (feathers_layout_Breakpoint().default).XS;
	},
	getSpan: function(item,breakpoint) {
		if(!(js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
			return 1;
		}
		var layoutItem = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
		if(!layoutItem.get_includeInLayout()) {
			return 0;
		}
		var layoutData = (Std().default).downcast(layoutItem.get_layoutData(),(feathers_layout_ResponsiveGridLayoutData().default));
		if(layoutData == null) {
			return 1;
		}
		var span = layoutData.getSpan(breakpoint);
		if(span > this._columnCount) {
			return this._columnCount;
		}
		return span;
	},
	getOffset: function(item,span,breakpoint) {
		if(!(js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
			return 0;
		}
		var layoutItem = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
		if(!layoutItem.get_includeInLayout()) {
			return 0;
		}
		var layoutData = (Std().default).downcast(layoutItem.get_layoutData(),(feathers_layout_ResponsiveGridLayoutData().default));
		if(layoutData == null) {
			return 0;
		}
		var offset = layoutData.getOffset(breakpoint);
		var maxOffset = this._columnCount - span;
		if(offset > maxOffset) {
			return maxOffset;
		}
		return offset;
	},
	getDisplay: function(item,breakpoint) {
		if(!(js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
			return true;
		}
		var layoutItem = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
		var layoutData = (Std().default).downcast(layoutItem.get_layoutData(),(feathers_layout_ResponsiveGridLayoutData().default));
		if(layoutData == null) {
			return true;
		}
		return layoutData.getDisplay(breakpoint);
	}
});
ResponsiveGridLayout.prototype.__class__ = ResponsiveGridLayout.prototype.constructor = $hxClasses["feathers.layout.ResponsiveGridLayout"] = ResponsiveGridLayout;

// Init



// Statics




// Export

exports["default"] = ResponsiveGridLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/ResponsiveGridLayoutData.js":
/*!**************************************************************!*\
  !*** ./lib/_gen/feathers/layout/ResponsiveGridLayoutData.js ***!
  \**************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.ResponsiveGridLayoutData

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_ILayoutData() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutData */ "./lib/_gen/feathers/layout/ILayoutData.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function feathers_layout_Breakpoint() {return __webpack_require__(/*! ./../../feathers/layout/Breakpoint */ "./lib/_gen/feathers/layout/Breakpoint.js");}

// Constructor

var ResponsiveGridLayoutData = function(span,offset,smSpan,smOffset,mdSpan,mdOffset,lgSpan,lgOffset,xlSpan,xlOffset) {
	if(xlOffset == null) {
		xlOffset = -1;
	}
	if(xlSpan == null) {
		xlSpan = -1;
	}
	if(lgOffset == null) {
		lgOffset = -1;
	}
	if(lgSpan == null) {
		lgSpan = -1;
	}
	if(mdOffset == null) {
		mdOffset = -1;
	}
	if(mdSpan == null) {
		mdSpan = -1;
	}
	if(smOffset == null) {
		smOffset = -1;
	}
	if(smSpan == null) {
		smSpan = -1;
	}
	if(offset == null) {
		offset = 0;
	}
	if(span == null) {
		span = 1;
	}
	this._xxlDisplay = null;
	this._xxlOffset = -1;
	this._xxlSpan = -1;
	this._xlDisplay = null;
	this._xlOffset = -1;
	this._xlSpan = -1;
	this._lgDisplay = null;
	this._lgOffset = -1;
	this._lgSpan = -1;
	this._mdDisplay = null;
	this._mdOffset = -1;
	this._mdSpan = -1;
	this._smDisplay = null;
	this._smOffset = -1;
	this._smSpan = -1;
	this._display = true;
	this._offset = 0;
	this._span = 1;
	(openfl_events_EventDispatcher()).call(this);
	this.set_span(span);
	this.set_offset(offset);
	this.set_smSpan(smSpan);
	this.set_smOffset(smOffset);
	this.set_mdSpan(mdSpan);
	this.set_mdOffset(mdOffset);
	this.set_lgSpan(lgSpan);
	this.set_lgOffset(lgOffset);
	this.set_xlSpan(xlSpan);
	this.set_xlOffset(xlOffset);
}

// Meta

ResponsiveGridLayoutData.__name__ = "feathers.layout.ResponsiveGridLayoutData";
ResponsiveGridLayoutData.__isInterface__ = false;
ResponsiveGridLayoutData.__interfaces__ = [(feathers_layout_ILayoutData().default)];
ResponsiveGridLayoutData.__super__ = (openfl_events_EventDispatcher());
ResponsiveGridLayoutData.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_span: function() {
		return this._span;
	},
	set_span: function(value) {
		if(value <= 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("span must be greater than 0"));
		}
		if(this._span == value) {
			return this._span;
		}
		this._span = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._span;
	},
	get_offset: function() {
		return this._offset;
	},
	set_offset: function(value) {
		if(this._offset == value) {
			return this._offset;
		}
		this._offset = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._offset;
	},
	get_display: function() {
		return this._display;
	},
	set_display: function(value) {
		if(this._display == value) {
			return this._display;
		}
		this._display = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._display;
	},
	get_smSpan: function() {
		return this._smSpan;
	},
	set_smSpan: function(value) {
		if(this._smSpan == value) {
			return this._smSpan;
		}
		this._smSpan = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._smSpan;
	},
	get_smOffset: function() {
		return this._smOffset;
	},
	set_smOffset: function(value) {
		if(this._smOffset == value) {
			return this._smOffset;
		}
		this._smOffset = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._smOffset;
	},
	get_smDisplay: function() {
		return this._smDisplay;
	},
	set_smDisplay: function(value) {
		if(this._smDisplay == value) {
			return this._smDisplay;
		}
		this._smDisplay = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._smDisplay;
	},
	get_mdSpan: function() {
		return this._mdSpan;
	},
	set_mdSpan: function(value) {
		if(this._mdSpan == value) {
			return this._mdSpan;
		}
		this._mdSpan = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._mdSpan;
	},
	get_mdOffset: function() {
		return this._mdOffset;
	},
	set_mdOffset: function(value) {
		if(this._mdOffset == value) {
			return this._mdOffset;
		}
		this._mdOffset = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._mdOffset;
	},
	get_mdDisplay: function() {
		return this._mdDisplay;
	},
	set_mdDisplay: function(value) {
		if(this._mdDisplay == value) {
			return this._mdDisplay;
		}
		this._mdDisplay = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._mdDisplay;
	},
	get_lgSpan: function() {
		return this._lgSpan;
	},
	set_lgSpan: function(value) {
		if(this._lgSpan == value) {
			return this._lgSpan;
		}
		this._lgSpan = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._lgSpan;
	},
	get_lgOffset: function() {
		return this._lgOffset;
	},
	set_lgOffset: function(value) {
		if(this._lgOffset == value) {
			return this._lgOffset;
		}
		this._lgOffset = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._lgOffset;
	},
	get_lgDisplay: function() {
		return this._lgDisplay;
	},
	set_lgDisplay: function(value) {
		if(this._lgDisplay == value) {
			return this._lgDisplay;
		}
		this._lgDisplay = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._lgDisplay;
	},
	get_xlSpan: function() {
		return this._xlSpan;
	},
	set_xlSpan: function(value) {
		if(this._xlSpan == value) {
			return this._xlSpan;
		}
		this._xlSpan = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._xlSpan;
	},
	get_xlOffset: function() {
		return this._xlOffset;
	},
	set_xlOffset: function(value) {
		if(this._xlOffset == value) {
			return this._xlOffset;
		}
		this._xlOffset = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._xlOffset;
	},
	get_xlDisplay: function() {
		return this._xlDisplay;
	},
	set_xlDisplay: function(value) {
		if(this._xlDisplay == value) {
			return this._xlDisplay;
		}
		this._xlDisplay = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._xlDisplay;
	},
	get_xxlSpan: function() {
		return this._xxlSpan;
	},
	set_xxlSpan: function(value) {
		if(this._xxlSpan == value) {
			return this._xxlSpan;
		}
		this._xxlSpan = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._xxlSpan;
	},
	get_xxlOffset: function() {
		return this._xxlOffset;
	},
	set_xxlOffset: function(value) {
		if(this._xxlOffset == value) {
			return this._xxlOffset;
		}
		this._xxlOffset = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._xxlOffset;
	},
	get_xxlDisplay: function() {
		return this._xxlDisplay;
	},
	set_xxlDisplay: function(value) {
		if(this._xxlDisplay == value) {
			return this._xxlDisplay;
		}
		this._xxlDisplay = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._xxlDisplay;
	},
	getSpan: function(breakpoint) {
		switch(breakpoint._hx_index) {
		case 0:
			return this._span;
		case 1:
			if(this._smSpan == -1) {
				return this.getSpan((feathers_layout_Breakpoint().default).XS);
			}
			return this._smSpan;
		case 2:
			if(this._mdSpan == -1) {
				return this.getSpan((feathers_layout_Breakpoint().default).SM);
			}
			return this._mdSpan;
		case 3:
			if(this._lgSpan == -1) {
				return this.getSpan((feathers_layout_Breakpoint().default).MD);
			}
			return this._lgSpan;
		case 4:
			if(this._xlSpan == -1) {
				return this.getSpan((feathers_layout_Breakpoint().default).LG);
			}
			return this._xlSpan;
		case 5:
			if(this._xxlSpan == -1) {
				return this.getSpan((feathers_layout_Breakpoint().default).XL);
			}
			return this._xxlSpan;
		}
	},
	getOffset: function(breakpoint) {
		switch(breakpoint._hx_index) {
		case 0:
			return this._offset;
		case 1:
			if(this._smOffset == -1) {
				return this.getOffset((feathers_layout_Breakpoint().default).XS);
			}
			return this._smOffset;
		case 2:
			if(this._mdOffset == -1) {
				return this.getOffset((feathers_layout_Breakpoint().default).SM);
			}
			return this._mdOffset;
		case 3:
			if(this._lgOffset == -1) {
				return this.getOffset((feathers_layout_Breakpoint().default).MD);
			}
			return this._lgOffset;
		case 4:
			if(this._xlOffset == -1) {
				return this.getOffset((feathers_layout_Breakpoint().default).LG);
			}
			return this._xlOffset;
		case 5:
			if(this._xxlOffset == -1) {
				return this.getOffset((feathers_layout_Breakpoint().default).XL);
			}
			return this._xxlOffset;
		}
	},
	getDisplay: function(breakpoint) {
		switch(breakpoint._hx_index) {
		case 0:
			return this._display;
		case 1:
			if(this._smDisplay == null) {
				return this.getDisplay((feathers_layout_Breakpoint().default).XS);
			}
			return this._smDisplay;
		case 2:
			if(this._mdDisplay == null) {
				return this.getDisplay((feathers_layout_Breakpoint().default).SM);
			}
			return this._mdDisplay;
		case 3:
			if(this._lgDisplay == null) {
				return this.getDisplay((feathers_layout_Breakpoint().default).MD);
			}
			return this._lgDisplay;
		case 4:
			if(this._xlDisplay == null) {
				return this.getDisplay((feathers_layout_Breakpoint().default).LG);
			}
			return this._xlDisplay;
		case 5:
			if(this._xxlDisplay == null) {
				return this.getDisplay((feathers_layout_Breakpoint().default).XL);
			}
			return this._xxlDisplay;
		}
	}
});
ResponsiveGridLayoutData.prototype.__class__ = ResponsiveGridLayoutData.prototype.constructor = $hxClasses["feathers.layout.ResponsiveGridLayoutData"] = ResponsiveGridLayoutData;

// Init



// Statics




// Export

exports["default"] = ResponsiveGridLayoutData;

/***/ }),

/***/ "./lib/_gen/feathers/layout/TiledRowsLayout.js":
/*!*****************************************************!*\
  !*** ./lib/_gen/feathers/layout/TiledRowsLayout.js ***!
  \*****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.TiledRowsLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_ILayout() {return __webpack_require__(/*! ./../../feathers/layout/ILayout */ "./lib/_gen/feathers/layout/ILayout.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_ILayoutObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutObject */ "./lib/_gen/feathers/layout/ILayoutObject.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}

// Constructor

var TiledRowsLayout = function() {
	this._requestedMaxColumnCount = null;
	this._requestedMinColumnCount = null;
	this._requestedColumnCount = null;
	this._alignEmptyHorizontalTiles = false;
	this._verticalAlign = (feathers_layout_VerticalAlign().default).TOP;
	this._horizontalAlign = (feathers_layout_HorizontalAlign().default).LEFT;
	this._minVerticalGap = 0.0;
	this._verticalGap = 0.0;
	this._minHorizontalGap = 0.0;
	this._horizontalGap = 0.0;
	this._paddingLeft = 0.0;
	this._paddingBottom = 0.0;
	this._paddingRight = 0.0;
	this._paddingTop = 0.0;
	(openfl_events_EventDispatcher()).call(this);
}

// Meta

TiledRowsLayout.__name__ = "feathers.layout.TiledRowsLayout";
TiledRowsLayout.__isInterface__ = false;
TiledRowsLayout.__interfaces__ = [(feathers_layout_ILayout().default)];
TiledRowsLayout.__super__ = (openfl_events_EventDispatcher());
TiledRowsLayout.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_paddingTop: function() {
		return this._paddingTop;
	},
	set_paddingTop: function(value) {
		if(this._paddingTop == value) {
			return this._paddingTop;
		}
		this._paddingTop = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingTop;
	},
	get_paddingRight: function() {
		return this._paddingRight;
	},
	set_paddingRight: function(value) {
		if(this._paddingRight == value) {
			return this._paddingRight;
		}
		this._paddingRight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingRight;
	},
	get_paddingBottom: function() {
		return this._paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(this._paddingBottom == value) {
			return this._paddingBottom;
		}
		this._paddingBottom = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingBottom;
	},
	get_paddingLeft: function() {
		return this._paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(this._paddingLeft == value) {
			return this._paddingLeft;
		}
		this._paddingLeft = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingLeft;
	},
	get_horizontalGap: function() {
		return this._horizontalGap;
	},
	set_horizontalGap: function(value) {
		if(this._horizontalGap == value) {
			return this._horizontalGap;
		}
		this._horizontalGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._horizontalGap;
	},
	get_minHorizontalGap: function() {
		return this._minHorizontalGap;
	},
	set_minHorizontalGap: function(value) {
		if(this._minHorizontalGap == value) {
			return this._minHorizontalGap;
		}
		this._minHorizontalGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._minHorizontalGap;
	},
	get_verticalGap: function() {
		return this._verticalGap;
	},
	set_verticalGap: function(value) {
		if(this._verticalGap == value) {
			return this._verticalGap;
		}
		this._verticalGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._verticalGap;
	},
	get_minVerticalGap: function() {
		return this._minVerticalGap;
	},
	set_minVerticalGap: function(value) {
		if(this._minVerticalGap == value) {
			return this._minVerticalGap;
		}
		this._minVerticalGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._minVerticalGap;
	},
	get_horizontalAlign: function() {
		return this._horizontalAlign;
	},
	set_horizontalAlign: function(value) {
		if(this._horizontalAlign == value) {
			return this._horizontalAlign;
		}
		this._horizontalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._horizontalAlign;
	},
	get_verticalAlign: function() {
		return this._verticalAlign;
	},
	set_verticalAlign: function(value) {
		if(this._verticalAlign == value) {
			return this._verticalAlign;
		}
		this._verticalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._verticalAlign;
	},
	get_alignEmptyHorizontalTiles: function() {
		return this._alignEmptyHorizontalTiles;
	},
	set_alignEmptyHorizontalTiles: function(value) {
		if(this._alignEmptyHorizontalTiles == value) {
			return this._alignEmptyHorizontalTiles;
		}
		this._alignEmptyHorizontalTiles = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._alignEmptyHorizontalTiles;
	},
	get_requestedColumnCount: function() {
		return this._requestedColumnCount;
	},
	set_requestedColumnCount: function(value) {
		if(this._requestedColumnCount == value) {
			return this._requestedColumnCount;
		}
		this._requestedColumnCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedColumnCount;
	},
	get_requestedMinColumnCount: function() {
		return this._requestedMinColumnCount;
	},
	set_requestedMinColumnCount: function(value) {
		if(this._requestedMinColumnCount == value) {
			return this._requestedMinColumnCount;
		}
		this._requestedMinColumnCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedMinColumnCount;
	},
	get_requestedMaxColumnCount: function() {
		return this._requestedMaxColumnCount;
	},
	set_requestedMaxColumnCount: function(value) {
		if(this._requestedMaxColumnCount == value) {
			return this._requestedMaxColumnCount;
		}
		this._requestedMaxColumnCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedMaxColumnCount;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	setGap: function(value) {
		this.set_horizontalGap(value);
		this.set_verticalGap(value);
	},
	layout: function(items,measurements,result) {
		var adjustedHorizontalGap = this._horizontalGap;
		var hasFlexHorizontalGap = this._horizontalGap == 1.0 / 0.0;
		if(hasFlexHorizontalGap) {
			adjustedHorizontalGap = this._minHorizontalGap;
		}
		var adjustedVerticalGap = this._verticalGap;
		var hasFlexVerticalGap = this._verticalGap == 1.0 / 0.0;
		if(hasFlexVerticalGap) {
			adjustedVerticalGap = this._minVerticalGap;
		}
		if(items.length == 0) {
			if(result == null) {
				result = new (feathers_layout_LayoutBoundsResult().default)();
			}
			result.contentX = 0.0;
			result.contentY = 0.0;
			result.contentWidth = this._paddingLeft + this._paddingRight;
			result.contentHeight = this._paddingTop + this._paddingBottom;
			result.viewPortWidth = result.contentWidth;
			if(this._requestedColumnCount != null) {
				if(this._requestedColumnCount > 1) {
					result.viewPortWidth += this._requestedColumnCount * adjustedHorizontalGap - adjustedHorizontalGap;
				}
			} else if(this._requestedMinColumnCount != null) {
				if(this._requestedMinColumnCount > 1) {
					result.viewPortWidth += this._requestedMinColumnCount * adjustedHorizontalGap - adjustedHorizontalGap;
				}
			}
			result.viewPortHeight = result.contentHeight;
			if(this._requestedMinColumnCount != null) {
				if(this._requestedMinColumnCount > 1) {
					result.contentMinWidth = this._paddingLeft + this._paddingRight + (this._requestedMinColumnCount * adjustedHorizontalGap - adjustedHorizontalGap);
				}
			}
			return result;
		}
		this.validateItems(items,measurements);
		var tileWidth = 0.0;
		var tileHeight = 0.0;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				var layoutItem = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutItem.get_includeInLayout()) {
					continue;
				}
			}
			tileWidth = Math.max(tileWidth,item.get_width());
			tileHeight = Math.max(tileHeight,item.get_height());
		}
		if(tileWidth < 0.0) {
			tileWidth = 0.0;
		}
		if(tileHeight < 0.0) {
			tileHeight = 0.0;
		}
		var horizontalTileCount = this.calculateHorizontalTileCount(tileWidth,measurements.width,measurements.maxWidth,adjustedHorizontalGap,items.length);
		var viewPortWidth = measurements.width;
		if(viewPortWidth == null) {
			viewPortWidth = this._paddingLeft + this._paddingRight + horizontalTileCount * (tileWidth + adjustedHorizontalGap) - adjustedHorizontalGap;
			if(measurements.minWidth != null && viewPortWidth < measurements.minWidth) {
				viewPortWidth = measurements.minWidth;
			} else if(measurements.maxWidth != null && viewPortWidth > measurements.maxWidth) {
				viewPortWidth = measurements.maxWidth;
			}
		}
		var availableRowWidth = viewPortWidth - this.get_paddingLeft() - this.get_paddingRight();
		var maxColumnCount = 0;
		var currentColumnCount = 0;
		var rowCount = 1;
		var xPosition = this._paddingLeft;
		var yPosition = this._paddingTop;
		var _g1 = 0;
		var _g2 = items.length;
		while(_g1 < _g2) {
			var i = _g1++;
			var item1 = items[i];
			if((js_Boot().default).__implements(item1,(feathers_layout_ILayoutObject().default))) {
				var layoutItem1 = (js_Boot().default).__cast(item1 , (feathers_layout_ILayoutObject().default));
				if(!layoutItem1.get_includeInLayout()) {
					continue;
				}
			}
			if(item1.get_width() != tileWidth) {
				item1.set_width(tileWidth);
			}
			if(item1.get_height() != tileHeight) {
				item1.set_height(tileHeight);
			}
			if(currentColumnCount >= horizontalTileCount) {
				this.applyHorizontalAlignToRow(items,i - currentColumnCount,currentColumnCount,horizontalTileCount,availableRowWidth,tileWidth);
				xPosition = this._paddingLeft;
				yPosition += tileHeight;
				++rowCount;
				maxColumnCount = (Std().default).int(Math.max(maxColumnCount,currentColumnCount));
				currentColumnCount = 0;
			}
			item1.set_x(xPosition);
			item1.set_y(yPosition);
			xPosition += tileWidth + adjustedHorizontalGap;
			++currentColumnCount;
		}
		this.applyHorizontalAlignToRow(items,items.length - currentColumnCount,currentColumnCount,horizontalTileCount,availableRowWidth,tileWidth);
		maxColumnCount = (Std().default).int(Math.max(maxColumnCount,currentColumnCount));
		yPosition += tileHeight + this.get_paddingBottom();
		var viewPortHeight = measurements.height;
		if(viewPortHeight == null) {
			viewPortHeight = this._paddingTop + this._paddingBottom + rowCount * (tileHeight + adjustedVerticalGap) - adjustedVerticalGap;
			if(measurements.minHeight != null && viewPortHeight < measurements.minHeight) {
				viewPortHeight = measurements.minHeight;
			} else if(measurements.maxHeight != null && viewPortHeight > measurements.maxHeight) {
				viewPortHeight = measurements.maxHeight;
			}
		}
		var availableContentHeight = viewPortHeight - this.get_paddingTop() - this.get_paddingBottom();
		if(hasFlexVerticalGap) {
			var maxContentHeight = rowCount * (tileHeight + adjustedVerticalGap) - adjustedVerticalGap;
			if(availableContentHeight > maxContentHeight) {
				adjustedVerticalGap += (availableContentHeight - maxContentHeight) / (rowCount - 1);
			}
		}
		yPosition += (rowCount - 1) * adjustedVerticalGap;
		this.applyVerticalAlignAndGap(items,viewPortHeight - this.get_paddingTop() - this.get_paddingBottom(),tileHeight,rowCount,maxColumnCount,adjustedVerticalGap);
		if(result == null) {
			result = new (feathers_layout_LayoutBoundsResult().default)();
		}
		result.contentX = 0.0;
		result.contentY = 0.0;
		result.contentWidth = viewPortWidth;
		result.contentHeight = yPosition;
		if(this._requestedMinColumnCount != null) {
			result.contentMinWidth = this._paddingLeft + this._paddingRight + (this._requestedMinColumnCount * (tileWidth + adjustedHorizontalGap) - adjustedHorizontalGap);
		}
		result.viewPortWidth = viewPortWidth;
		result.viewPortHeight = viewPortHeight;
		return result;
	},
	applyHorizontalAlignToRow: function(items,startIndex,numItemsInRow,horizontalTileCount,availableRowWidth,tileWidth) {
		if(this._alignEmptyHorizontalTiles && horizontalTileCount > numItemsInRow) {
			numItemsInRow = horizontalTileCount;
		}
		var alignOffset = 0.0;
		var gapOffset = 0.0;
		var adjustedHorizontalGap = this._horizontalGap;
		var hasFlexHorizontalGap = this._horizontalGap == 1.0 / 0.0;
		if(hasFlexHorizontalGap) {
			adjustedHorizontalGap = this._minHorizontalGap;
			var rowContentWidth = numItemsInRow * (tileWidth + adjustedHorizontalGap);
			if(numItemsInRow > 0) {
				rowContentWidth -= adjustedHorizontalGap;
			}
			if(numItemsInRow > 1 && availableRowWidth > rowContentWidth) {
				adjustedHorizontalGap += (availableRowWidth - rowContentWidth) / (numItemsInRow - 1);
			}
			gapOffset = adjustedHorizontalGap - this._minHorizontalGap;
		} else {
			var rowContentWidth1 = numItemsInRow * (tileWidth + adjustedHorizontalGap);
			if(numItemsInRow > 0) {
				rowContentWidth1 -= adjustedHorizontalGap;
			}
			switch(this._horizontalAlign._hx_index) {
			case 0:
				alignOffset = 0.0;
				break;
			case 1:
				alignOffset = (availableRowWidth - rowContentWidth1) / 2.0;
				break;
			case 2:
				alignOffset = availableRowWidth - rowContentWidth1;
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown horizontal align: " + (Std().default).string(this._horizontalAlign)));
			}
			if(alignOffset < 0) {
				alignOffset = 0.0;
			}
		}
		if(alignOffset == 0.0 && gapOffset == 0.0) {
			return;
		}
		var totalOffset = alignOffset;
		var endIndex = startIndex + numItemsInRow;
		if(endIndex > items.length) {
			endIndex = items.length;
		}
		var _g = startIndex;
		var _g1 = endIndex;
		while(_g < _g1) {
			var i = _g++;
			var item = items[i];
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				var layoutItem = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutItem.get_includeInLayout()) {
					continue;
				}
			}
			var _g2 = item;
			_g2.set_x(_g2.get_x() + totalOffset);
			totalOffset += gapOffset;
		}
	},
	applyVerticalAlignAndGap: function(items,availableHeight,tileHeight,rowCount,columnCount,adjustedVerticalGap) {
		var alignOffset = 0.0;
		var gapOffset = adjustedVerticalGap;
		var hasFlexVerticalGap = this._verticalGap == 1.0 / 0.0;
		if(!hasFlexVerticalGap) {
			var contentHeight = rowCount * (tileHeight + adjustedVerticalGap) - adjustedVerticalGap;
			switch(this._verticalAlign._hx_index) {
			case 0:
				alignOffset = 0.0;
				break;
			case 1:
				alignOffset = (availableHeight - contentHeight) / 2.0;
				break;
			case 2:
				alignOffset = availableHeight - contentHeight;
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown vertical align: " + (Std().default).string(this._verticalAlign)));
			}
			if(alignOffset < 0.0) {
				alignOffset = 0.0;
			}
		}
		if(alignOffset == 0.0 && gapOffset == 0.0) {
			return;
		}
		var totalOffset = alignOffset;
		var layoutIndex = 0;
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var item = items[i];
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				var layoutItem = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutItem.get_includeInLayout()) {
					continue;
				}
			}
			if(layoutIndex > 0 && layoutIndex % columnCount == 0) {
				totalOffset += gapOffset;
			}
			var _g2 = item;
			_g2.set_y(_g2.get_y() + totalOffset);
			++layoutIndex;
		}
	},
	validateItems: function(items,measurements) {
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				var layoutItem = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutItem.get_includeInLayout()) {
					continue;
				}
			}
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
		}
	},
	calculateHorizontalTileCount: function(tileWidth,explicitWidth,explicitMaxWidth,horizontalGap,totalItemCount) {
		if(explicitWidth != null) {
			var maxHorizontalTileCount = (Std().default).int((explicitWidth - this._paddingLeft - this._paddingRight + horizontalGap) / (tileWidth + horizontalGap));
			if(this._requestedColumnCount != null) {
				if(this._requestedColumnCount > maxHorizontalTileCount) {
					return maxHorizontalTileCount;
				}
				return (Std().default).int(Math.max(1,this._requestedColumnCount));
			}
			var horizontalTileCount = maxHorizontalTileCount;
			if(horizontalTileCount < 1) {
				horizontalTileCount = 1;
			} else if(horizontalTileCount > totalItemCount) {
				horizontalTileCount = totalItemCount;
			}
			if(this._requestedMinColumnCount != null) {
				if(this._requestedMinColumnCount < horizontalTileCount) {
					return horizontalTileCount;
				}
				return (Std().default).int(Math.max(1,this._requestedMinColumnCount));
			}
			if(this._requestedMaxColumnCount != null) {
				if(this._requestedMaxColumnCount > horizontalTileCount) {
					return horizontalTileCount;
				}
				return (Std().default).int(Math.max(1,this._requestedMaxColumnCount));
			}
			return horizontalTileCount;
		}
		var horizontalTileCount1 = totalItemCount;
		if(this._requestedColumnCount != null) {
			horizontalTileCount1 = (Std().default).int(Math.max(1,this._requestedColumnCount));
		} else if(this._requestedMinColumnCount != null) {
			if(horizontalTileCount1 < this._requestedMinColumnCount) {
				horizontalTileCount1 = this._requestedMinColumnCount;
			}
		} else if(this._requestedMaxColumnCount != null) {
			if(horizontalTileCount1 > this._requestedMaxColumnCount) {
				horizontalTileCount1 = this._requestedMaxColumnCount;
			}
		}
		var maxHorizontalTileCount1 = 2147483647;
		if(explicitMaxWidth != null && explicitMaxWidth < Infinity) {
			maxHorizontalTileCount1 = (Std().default).int((explicitMaxWidth - this._paddingLeft - this._paddingRight + horizontalGap) / (tileWidth + horizontalGap));
			if(maxHorizontalTileCount1 < 1) {
				maxHorizontalTileCount1 = 1;
			}
		}
		if(horizontalTileCount1 > maxHorizontalTileCount1) {
			horizontalTileCount1 = maxHorizontalTileCount1;
		}
		if(horizontalTileCount1 < 1) {
			horizontalTileCount1 = 1;
		}
		return horizontalTileCount1;
	}
});
TiledRowsLayout.prototype.__class__ = TiledRowsLayout.prototype.constructor = $hxClasses["feathers.layout.TiledRowsLayout"] = TiledRowsLayout;

// Init



// Statics




// Export

exports["default"] = TiledRowsLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/TiledRowsListLayout.js":
/*!*********************************************************!*\
  !*** ./lib/_gen/feathers/layout/TiledRowsListLayout.js ***!
  \*********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.TiledRowsListLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_IKeyboardNavigationLayout() {return __webpack_require__(/*! ./../../feathers/layout/IKeyboardNavigationLayout */ "./lib/_gen/feathers/layout/IKeyboardNavigationLayout.js");}
function feathers_layout_IVirtualLayout() {return __webpack_require__(/*! ./../../feathers/layout/IVirtualLayout */ "./lib/_gen/feathers/layout/IVirtualLayout.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_layout__$TiledRowsListLayout_VirtualCacheItem() {return __webpack_require__(/*! ./../../feathers/layout/_TiledRowsListLayout/VirtualCacheItem */ "./lib/_gen/feathers/layout/_TiledRowsListLayout/VirtualCacheItem.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_ILayoutObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutObject */ "./lib/_gen/feathers/layout/ILayoutObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_layout_VirtualLayoutRange() {return __webpack_require__(/*! ./../../feathers/layout/VirtualLayoutRange */ "./lib/_gen/feathers/layout/VirtualLayoutRange.js");}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}

// Constructor

var TiledRowsListLayout = function() {
	this._requestedMaxRowCount = null;
	this._requestedMinRowCount = null;
	this._requestedRowCount = null;
	this._requestedMaxColumnCount = null;
	this._requestedMinColumnCount = null;
	this._requestedColumnCount = null;
	this._minVerticalGap = 0.0;
	this._verticalGap = 0.0;
	this._minHorizontalGap = 0.0;
	this._horizontalGap = 0.0;
	this._paddingLeft = 0.0;
	this._paddingBottom = 0.0;
	this._paddingRight = 0.0;
	this._paddingTop = 0.0;
	this._verticalAlign = (feathers_layout_VerticalAlign().default).TOP;
	this._horizontalAlign = (feathers_layout_HorizontalAlign().default).LEFT;
	this._alignEmptyHorizontalTiles = false;
	this._scrollY = 0.0;
	this._scrollX = 0.0;
	(openfl_events_EventDispatcher()).call(this);
}

// Meta

TiledRowsListLayout.__name__ = "feathers.layout.TiledRowsListLayout";
TiledRowsListLayout.__isInterface__ = false;
TiledRowsListLayout.__interfaces__ = [(feathers_layout_IKeyboardNavigationLayout().default),(feathers_layout_IVirtualLayout().default)];
TiledRowsListLayout.__super__ = (openfl_events_EventDispatcher());
TiledRowsListLayout.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_scrollX: function() {
		return this._scrollX;
	},
	set_scrollX: function(value) {
		this._scrollX = value;
		return this._scrollX;
	},
	get_scrollY: function() {
		return this._scrollY;
	},
	set_scrollY: function(value) {
		this._scrollY = value;
		return this._scrollY;
	},
	get_virtualCache: function() {
		return this._virtualCache;
	},
	set_virtualCache: function(value) {
		this._virtualCache = value;
		return this._virtualCache;
	},
	get_elasticTop: function() {
		return true;
	},
	get_elasticRight: function() {
		return false;
	},
	get_elasticBottom: function() {
		return true;
	},
	get_elasticLeft: function() {
		return false;
	},
	get_alignEmptyHorizontalTiles: function() {
		return this._alignEmptyHorizontalTiles;
	},
	set_alignEmptyHorizontalTiles: function(value) {
		if(this._alignEmptyHorizontalTiles == value) {
			return this._alignEmptyHorizontalTiles;
		}
		this._alignEmptyHorizontalTiles = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._alignEmptyHorizontalTiles;
	},
	get_horizontalAlign: function() {
		return this._horizontalAlign;
	},
	set_horizontalAlign: function(value) {
		if(this._horizontalAlign == value) {
			return this._horizontalAlign;
		}
		this._horizontalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._horizontalAlign;
	},
	get_verticalAlign: function() {
		return this._verticalAlign;
	},
	set_verticalAlign: function(value) {
		if(this._verticalAlign == value) {
			return this._verticalAlign;
		}
		this._verticalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._verticalAlign;
	},
	get_paddingTop: function() {
		return this._paddingTop;
	},
	set_paddingTop: function(value) {
		if(this._paddingTop == value) {
			return this._paddingTop;
		}
		this._paddingTop = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingTop;
	},
	get_paddingRight: function() {
		return this._paddingRight;
	},
	set_paddingRight: function(value) {
		if(this._paddingRight == value) {
			return this._paddingRight;
		}
		this._paddingRight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingRight;
	},
	get_paddingBottom: function() {
		return this._paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(this._paddingBottom == value) {
			return this._paddingBottom;
		}
		this._paddingBottom = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingBottom;
	},
	get_paddingLeft: function() {
		return this._paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(this._paddingLeft == value) {
			return this._paddingLeft;
		}
		this._paddingLeft = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingLeft;
	},
	get_horizontalGap: function() {
		return this._horizontalGap;
	},
	set_horizontalGap: function(value) {
		if(this._horizontalGap == value) {
			return this._horizontalGap;
		}
		this._horizontalGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._horizontalGap;
	},
	get_minHorizontalGap: function() {
		return this._minHorizontalGap;
	},
	set_minHorizontalGap: function(value) {
		if(this._minHorizontalGap == value) {
			return this._minHorizontalGap;
		}
		this._minHorizontalGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._minHorizontalGap;
	},
	get_verticalGap: function() {
		return this._verticalGap;
	},
	set_verticalGap: function(value) {
		if(this._verticalGap == value) {
			return this._verticalGap;
		}
		this._verticalGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._verticalGap;
	},
	get_minVerticalGap: function() {
		return this._minVerticalGap;
	},
	set_minVerticalGap: function(value) {
		if(this._minVerticalGap == value) {
			return this._minVerticalGap;
		}
		this._minVerticalGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._minVerticalGap;
	},
	get_requestedColumnCount: function() {
		return this._requestedColumnCount;
	},
	set_requestedColumnCount: function(value) {
		if(this._requestedColumnCount == value) {
			return this._requestedColumnCount;
		}
		this._requestedColumnCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedColumnCount;
	},
	get_requestedMinColumnCount: function() {
		return this._requestedMinColumnCount;
	},
	set_requestedMinColumnCount: function(value) {
		if(this._requestedMinColumnCount == value) {
			return this._requestedMinColumnCount;
		}
		this._requestedMinColumnCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedMinColumnCount;
	},
	get_requestedMaxColumnCount: function() {
		return this._requestedMaxColumnCount;
	},
	set_requestedMaxColumnCount: function(value) {
		if(this._requestedMaxColumnCount == value) {
			return this._requestedMaxColumnCount;
		}
		this._requestedMaxColumnCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedMaxColumnCount;
	},
	get_requestedRowCount: function() {
		return this._requestedRowCount;
	},
	set_requestedRowCount: function(value) {
		if(this._requestedRowCount == value) {
			return this._requestedRowCount;
		}
		this._requestedRowCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedRowCount;
	},
	get_requestedMinRowCount: function() {
		return this._requestedMinRowCount;
	},
	set_requestedMinRowCount: function(value) {
		if(this._requestedMinRowCount == value) {
			return this._requestedMinRowCount;
		}
		this._requestedMinRowCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedMinRowCount;
	},
	get_requestedMaxRowCount: function() {
		return this._requestedMaxRowCount;
	},
	set_requestedMaxRowCount: function(value) {
		if(this._requestedMaxRowCount == value) {
			return this._requestedMaxRowCount;
		}
		this._requestedMaxRowCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedMaxRowCount;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	setGap: function(value) {
		this.set_horizontalGap(value);
		this.set_verticalGap(value);
	},
	layout: function(items,measurements,result) {
		var adjustedHorizontalGap = this._horizontalGap;
		var hasFlexHorizontalGap = this._horizontalGap == 1.0 / 0.0;
		if(hasFlexHorizontalGap) {
			adjustedHorizontalGap = this._minHorizontalGap;
		}
		var adjustedVerticalGap = this._verticalGap;
		var hasFlexVerticalGap = this._verticalGap == 1.0 / 0.0;
		if(hasFlexVerticalGap) {
			adjustedVerticalGap = this._minVerticalGap;
		}
		if(items.length == 0) {
			if(result == null) {
				result = new (feathers_layout_LayoutBoundsResult().default)();
			}
			result.contentX = 0.0;
			result.contentY = 0.0;
			result.contentWidth = this._paddingLeft + this._paddingRight;
			result.contentHeight = this._paddingTop + this._paddingBottom;
			result.viewPortWidth = result.contentWidth;
			if(this._requestedColumnCount != null) {
				if(this._requestedColumnCount > 1) {
					result.viewPortWidth += this._requestedColumnCount * adjustedHorizontalGap - adjustedHorizontalGap;
				}
			} else if(this._requestedMinColumnCount != null) {
				if(this._requestedMinColumnCount > 1) {
					result.viewPortWidth += this._requestedMinColumnCount * adjustedHorizontalGap - adjustedHorizontalGap;
				}
			}
			result.viewPortHeight = result.contentHeight;
			if(this._requestedRowCount != null) {
				if(this._requestedRowCount > 1) {
					result.viewPortHeight += this._requestedRowCount * adjustedVerticalGap - adjustedVerticalGap;
				}
			} else if(this._requestedMinRowCount != null) {
				if(this._requestedMinRowCount > 1) {
					result.viewPortHeight += this._requestedMinRowCount * adjustedVerticalGap - adjustedVerticalGap;
				}
			}
			if(this._requestedMinColumnCount != null) {
				if(this._requestedMinColumnCount > 1) {
					result.contentMinWidth = this._paddingLeft + this._paddingRight + (this._requestedMinColumnCount * adjustedHorizontalGap - adjustedHorizontalGap);
				}
			}
			if(this._requestedMinRowCount != null) {
				if(this._requestedMinRowCount > 1) {
					result.contentMinHeight = this._paddingTop + this._paddingBottom + (this._requestedMinRowCount * adjustedVerticalGap - adjustedVerticalGap);
				}
			}
			return result;
		}
		var tileWidth = 0.0;
		var tileHeight = 0.0;
		if(this._virtualCache != null && this._virtualCache.length != 0) {
			var cacheItem = (Std().default).downcast(this._virtualCache[0],(feathers_layout__$TiledRowsListLayout_VirtualCacheItem().default));
			if(cacheItem != null) {
				tileWidth = cacheItem.itemWidth;
				tileHeight = cacheItem.itemHeight;
			}
		}
		if(tileWidth == 0.0 && tileHeight == 0.0) {
			var _g = 0;
			while(_g < items.length) {
				var item = items[_g];
				++_g;
				if(item == null) {
					continue;
				} else {
					if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
						if(!((js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default))).get_includeInLayout()) {
							continue;
						}
					}
					if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
						((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
					}
					tileWidth = item.get_width();
					tileHeight = item.get_height();
					if(this._virtualCache != null) {
						var cacheItem1 = (Std().default).downcast(this._virtualCache[0],(feathers_layout__$TiledRowsListLayout_VirtualCacheItem().default));
						if(cacheItem1 == null || cacheItem1.itemWidth != tileWidth || cacheItem1.itemHeight != tileHeight) {
							if(cacheItem1 == null) {
								cacheItem1 = new (feathers_layout__$TiledRowsListLayout_VirtualCacheItem().default)(tileWidth,tileHeight);
							} else {
								cacheItem1.itemWidth = tileWidth;
								cacheItem1.itemHeight = tileHeight;
							}
							this._virtualCache[0] = cacheItem1;
							(feathers_events_FeathersEvent().default).dispatch(this,"change");
						}
					}
					break;
				}
			}
		}
		var horizontalTileCount = this.calculateHorizontalTileCount(tileWidth,measurements.width,measurements.maxWidth,adjustedHorizontalGap,items.length);
		var viewPortWidth = measurements.width;
		if(viewPortWidth == null) {
			viewPortWidth = this._paddingLeft + this._paddingRight + horizontalTileCount * (tileWidth + adjustedHorizontalGap) - adjustedHorizontalGap;
			if(measurements.minWidth != null && viewPortWidth < measurements.minWidth) {
				viewPortWidth = measurements.minWidth;
			} else if(measurements.maxWidth != null && viewPortWidth > measurements.maxWidth) {
				viewPortWidth = measurements.maxWidth;
			}
		}
		var availableRowWidth = viewPortWidth - this.get_paddingLeft() - this.get_paddingRight();
		var maxColumnCount = 0;
		var currentColumnCount = 0;
		var rowCount = 1;
		var xPosition = this._paddingLeft;
		var yPosition = this._paddingTop;
		var _g1 = 0;
		var _g11 = items.length;
		while(_g1 < _g11) {
			var i = _g1++;
			var item1 = items[i];
			if((js_Boot().default).__implements(item1,(feathers_layout_ILayoutObject().default))) {
				var layoutItem = (js_Boot().default).__cast(item1 , (feathers_layout_ILayoutObject().default));
				if(!layoutItem.get_includeInLayout()) {
					continue;
				}
			}
			if(currentColumnCount >= horizontalTileCount) {
				this.applyHorizontalAlignToRow(items,i - currentColumnCount,currentColumnCount,horizontalTileCount,availableRowWidth,tileWidth);
				xPosition = this._paddingLeft;
				yPosition += tileHeight;
				++rowCount;
				maxColumnCount = (Std().default).int(Math.max(maxColumnCount,currentColumnCount));
				currentColumnCount = 0;
			}
			if(item1 != null) {
				item1.set_x(xPosition);
				item1.set_y(yPosition);
				item1.set_width(tileWidth);
				item1.set_height(tileHeight);
			}
			xPosition += tileWidth + adjustedHorizontalGap;
			++currentColumnCount;
		}
		this.applyHorizontalAlignToRow(items,items.length - currentColumnCount,currentColumnCount,horizontalTileCount,availableRowWidth,tileWidth);
		maxColumnCount = (Std().default).int(Math.max(maxColumnCount,currentColumnCount));
		yPosition += tileHeight + this.get_paddingBottom();
		var verticalTileCount = this.calculateVerticalTileCount(tileHeight,measurements.height,measurements.maxHeight,adjustedVerticalGap,items.length,horizontalTileCount);
		var viewPortHeight = measurements.height;
		if(viewPortHeight == null) {
			viewPortHeight = this._paddingTop + this._paddingBottom + verticalTileCount * tileHeight + (Std().default).int(verticalTileCount) * adjustedVerticalGap - adjustedVerticalGap;
			if(measurements.minHeight != null && viewPortHeight < measurements.minHeight) {
				viewPortHeight = measurements.minHeight;
			} else if(measurements.maxHeight != null && viewPortHeight > measurements.maxHeight) {
				viewPortHeight = measurements.maxHeight;
			}
		}
		var availableContentHeight = viewPortHeight - this.get_paddingTop() - this.get_paddingBottom();
		if(hasFlexVerticalGap) {
			var maxContentHeight = rowCount * (tileHeight + adjustedVerticalGap) - adjustedVerticalGap;
			if(availableContentHeight > maxContentHeight) {
				adjustedVerticalGap += (availableContentHeight - maxContentHeight) / (rowCount - 1);
			}
		}
		yPosition += (rowCount - 1) * adjustedVerticalGap;
		this.applyVerticalAlignAndGap(items,viewPortHeight - this.get_paddingTop() - this.get_paddingBottom(),tileHeight,rowCount,maxColumnCount,adjustedVerticalGap);
		if(result == null) {
			result = new (feathers_layout_LayoutBoundsResult().default)();
		}
		result.contentX = 0.0;
		result.contentY = 0.0;
		result.contentWidth = viewPortWidth;
		result.contentHeight = yPosition;
		if(this._requestedMinColumnCount != null) {
			result.contentMinWidth = this._paddingLeft + this._paddingRight + (this._requestedMinColumnCount * (tileWidth + adjustedHorizontalGap) - adjustedHorizontalGap);
		}
		if(this._requestedMinRowCount != null) {
			result.contentMinHeight = this._paddingTop + this._paddingBottom + (this._requestedMinRowCount * (tileHeight + adjustedVerticalGap) - adjustedVerticalGap);
		}
		result.viewPortWidth = viewPortWidth;
		result.viewPortHeight = viewPortHeight;
		return result;
	},
	getVisibleIndices: function(itemCount,width,height,result) {
		var tileWidth = 0.0;
		var tileHeight = 0.0;
		if(this._virtualCache != null && this._virtualCache.length != 0) {
			var cacheItem = (Std().default).downcast(this._virtualCache[0],(feathers_layout__$TiledRowsListLayout_VirtualCacheItem().default));
			if(cacheItem != null) {
				tileWidth = cacheItem.itemWidth;
				tileHeight = cacheItem.itemHeight;
			}
		}
		if(tileWidth == 0.0 || tileHeight == 0.0) {
			if(result == null) {
				result = new (feathers_layout_VirtualLayoutRange().default)(0,0);
			} else {
				result.start = 0;
				result.end = 0;
			}
			return result;
		}
		var adjustedHorizontalGap = this._horizontalGap;
		var hasFlexHorizontalGap = this._horizontalGap == 1.0 / 0.0;
		if(hasFlexHorizontalGap) {
			var availableRowWidth = width - this.get_paddingLeft() - this.get_paddingRight();
			adjustedHorizontalGap = this._minHorizontalGap;
			var maxContentWidth = itemCount * (tileWidth + adjustedHorizontalGap);
			if(itemCount > 0) {
				maxContentWidth -= adjustedHorizontalGap;
			}
			if(availableRowWidth > maxContentWidth) {
				adjustedHorizontalGap += (availableRowWidth - maxContentWidth) / (itemCount - 1);
			}
		}
		var adjustedVerticalGap = this._verticalGap;
		var hasFlexVerticalGap = this._verticalGap == 1.0 / 0.0;
		if(hasFlexVerticalGap) {
			adjustedVerticalGap = this._minVerticalGap;
		}
		var horizontalTileCount = this.calculateHorizontalTileCount(tileWidth,width,null,adjustedHorizontalGap,itemCount);
		var verticalTileCount = Math.ceil((height - this._paddingTop - this._paddingBottom + adjustedVerticalGap) / (tileHeight + adjustedVerticalGap)) + 1;
		var minimumItemCount = Math.ceil(verticalTileCount * horizontalTileCount);
		if(minimumItemCount > itemCount) {
			minimumItemCount = itemCount;
		}
		var rowIndexOffset = 0;
		var totalRowHeight = Math.ceil(itemCount / horizontalTileCount) * (tileHeight + adjustedVerticalGap) - adjustedVerticalGap;
		if(totalRowHeight < height) {
			if(this._verticalAlign == (feathers_layout_VerticalAlign().default).BOTTOM) {
				rowIndexOffset = Math.ceil((height - totalRowHeight) / (tileHeight + adjustedVerticalGap));
			} else if(this._verticalAlign == (feathers_layout_VerticalAlign().default).MIDDLE) {
				rowIndexOffset = Math.ceil((height - totalRowHeight) / (tileHeight + adjustedVerticalGap) / 2.0);
			}
		}
		var rowIndex = -rowIndexOffset + (Std().default).int((this.get_scrollY() - this._paddingTop + adjustedVerticalGap) / (tileHeight + adjustedVerticalGap));
		var minimum = rowIndex * horizontalTileCount;
		if(minimum < 0) {
			minimum = 0;
		}
		var maximum = minimum + minimumItemCount;
		if(maximum >= itemCount) {
			maximum = itemCount - 1;
			minimum = maximum - minimumItemCount;
			if(minimum < 0) {
				minimum = 0;
			}
		}
		if(result == null) {
			result = new (feathers_layout_VirtualLayoutRange().default)(minimum,maximum);
			return result;
		}
		result.start = minimum;
		result.end = maximum;
		return result;
	},
	getNearestScrollPositionForIndex: function(index,itemCount,width,height,result) {
		var tileWidth = 0.0;
		var tileHeight = 0.0;
		if(this._virtualCache != null && this._virtualCache.length != 0) {
			var cacheItem = (Std().default).downcast(this._virtualCache[0],(feathers_layout__$TiledRowsListLayout_VirtualCacheItem().default));
			if(cacheItem != null) {
				tileWidth = cacheItem.itemWidth;
				tileHeight = cacheItem.itemHeight;
			}
		}
		var adjustedHorizontalGap = this._horizontalGap;
		var hasFlexHorizontalGap = this._horizontalGap == 1.0 / 0.0;
		if(hasFlexHorizontalGap) {
			var availableRowWidth = width - this.get_paddingLeft() - this.get_paddingRight();
			adjustedHorizontalGap = this._minHorizontalGap;
			var maxContentWidth = itemCount * (tileWidth + adjustedHorizontalGap);
			if(itemCount > 0) {
				maxContentWidth -= adjustedHorizontalGap;
			}
			if(availableRowWidth > maxContentWidth) {
				adjustedHorizontalGap += (availableRowWidth - maxContentWidth) / (itemCount - 1);
			}
		}
		var adjustedVerticalGap = this._verticalGap;
		var hasFlexVerticalGap = this._verticalGap == 1.0 / 0.0;
		if(hasFlexVerticalGap) {
			adjustedVerticalGap = this._minVerticalGap;
		}
		var horizontalTileCount = this.calculateHorizontalTileCount(tileWidth,width,null,adjustedHorizontalGap,itemCount);
		var resultY = this._paddingTop + (tileHeight + adjustedVerticalGap) * (Std().default).int(index / horizontalTileCount);
		var bottomPosition = resultY - (height - tileHeight);
		if(this.get_scrollY() >= bottomPosition && this.get_scrollY() <= resultY) {
			resultY = this.get_scrollY();
		} else {
			var topDifference = Math.abs(resultY - this.get_scrollY());
			var bottomDifference = Math.abs(bottomPosition - this.get_scrollY());
			if(bottomDifference < topDifference) {
				resultY = bottomPosition;
			}
		}
		if(result == null) {
			result = new (openfl_geom_Point())();
		}
		result.x = 0.0;
		result.y = resultY;
		return result;
	},
	findNextKeyboardIndex: function(startIndex,event,wrapArrowKeys,items,indicesToSkip,viewPortWidth,viewPortHeight) {
		var itemCount = items.length;
		if(itemCount == 0) {
			return -1;
		}
		var tileWidth = 0.0;
		var tileHeight = 0.0;
		if(this._virtualCache != null && this._virtualCache.length != 0) {
			var cacheItem = (Std().default).downcast(this._virtualCache[0],(feathers_layout__$TiledRowsListLayout_VirtualCacheItem().default));
			if(cacheItem != null) {
				tileWidth = cacheItem.itemWidth;
				tileHeight = cacheItem.itemHeight;
			}
		}
		if(tileWidth == 0.0 || tileHeight == 0.0) {
			return startIndex;
		}
		var adjustedHorizontalGap = this._horizontalGap;
		var hasFlexHorizontalGap = this._horizontalGap == 1.0 / 0.0;
		if(hasFlexHorizontalGap) {
			var availableRowWidth = viewPortWidth - this.get_paddingLeft() - this.get_paddingRight();
			adjustedHorizontalGap = this._minHorizontalGap;
			var maxContentWidth = itemCount * (tileWidth + adjustedHorizontalGap);
			if(itemCount > 0) {
				maxContentWidth -= adjustedHorizontalGap;
			}
			if(availableRowWidth > maxContentWidth) {
				adjustedHorizontalGap += (availableRowWidth - maxContentWidth) / (itemCount - 1);
			}
		}
		var adjustedVerticalGap = this._verticalGap;
		var hasFlexVerticalGap = this._verticalGap == 1.0 / 0.0;
		if(hasFlexVerticalGap) {
			adjustedVerticalGap = this._minVerticalGap;
		}
		var result = startIndex;
		var horizontalTileCount = this.calculateHorizontalTileCount(tileWidth,viewPortWidth,null,adjustedHorizontalGap,itemCount);
		var verticalTileCount = (Std().default).int(this.calculateVerticalTileCount(tileHeight,viewPortHeight,null,adjustedVerticalGap,itemCount,horizontalTileCount));
		var numRows = Math.ceil(itemCount / horizontalTileCount);
		var rowIndex = (Std().default).int(startIndex / horizontalTileCount);
		var columnIndex = (Std().default).int(startIndex % horizontalTileCount);
		if(result == -1) {
			switch(event.keyCode) {
			case 37:
				result = wrapArrowKeys ? itemCount - 1 : -1;
				break;
			case 38:
				result = wrapArrowKeys ? itemCount - 1 : -1;
				break;
			case 39:
				result = 0;
				break;
			case 40:
				result = 0;
				break;
			default:
				result = -1;
			}
			if(result == -1) {
				return result;
			}
			if(indicesToSkip == null || indicesToSkip.indexOf(result) == -1) {
				return result;
			}
		}
		var needsAnotherPass = true;
		var nextKeyCode = event.keyCode;
		var lastResult = result;
		while(needsAnotherPass) {
			needsAnotherPass = false;
			switch(nextKeyCode) {
			case 33:
				rowIndex -= verticalTileCount;
				nextKeyCode = 38;
				break;
			case 34:
				rowIndex += verticalTileCount;
				nextKeyCode = 40;
				break;
			case 35:
				rowIndex = numRows - 1;
				columnIndex = horizontalTileCount - 1;
				break;
			case 36:
				rowIndex = 0;
				columnIndex = 0;
				break;
			case 37:
				--columnIndex;
				break;
			case 38:
				--rowIndex;
				break;
			case 39:
				++columnIndex;
				break;
			case 40:
				++rowIndex;
				break;
			}
			if(rowIndex < 0) {
				if(wrapArrowKeys) {
					rowIndex = numRows - 1;
				} else {
					rowIndex = 0;
				}
			} else if(rowIndex >= numRows) {
				if(wrapArrowKeys) {
					rowIndex = 0;
				} else {
					rowIndex = numRows - 1;
				}
			}
			if(columnIndex < 0) {
				if(wrapArrowKeys) {
					columnIndex = horizontalTileCount - 1;
				} else {
					columnIndex = 0;
				}
			} else if(columnIndex >= horizontalTileCount) {
				if(wrapArrowKeys) {
					columnIndex = 0;
				} else {
					columnIndex = horizontalTileCount - 1;
				}
			}
			result = rowIndex * horizontalTileCount + columnIndex;
			if(result >= itemCount) {
				result = itemCount - 1;
			}
			if(indicesToSkip != null && indicesToSkip.indexOf(result) != -1) {
				if(result == lastResult) {
					return startIndex;
				}
				needsAnotherPass = true;
			}
			lastResult = result;
		}
		return result;
	},
	calculateHorizontalTileCount: function(tileWidth,explicitWidth,explicitMaxWidth,horizontalGap,totalItemCount) {
		if(explicitWidth != null) {
			var maxHorizontalTileCount = (Std().default).int((explicitWidth - this._paddingLeft - this._paddingRight + horizontalGap) / (tileWidth + horizontalGap));
			if(this._requestedColumnCount != null) {
				if(this._requestedColumnCount > maxHorizontalTileCount) {
					return maxHorizontalTileCount;
				}
				return (Std().default).int(Math.max(1,this._requestedColumnCount));
			}
			var horizontalTileCount = maxHorizontalTileCount;
			if(horizontalTileCount < 1) {
				horizontalTileCount = 1;
			} else if(horizontalTileCount > totalItemCount) {
				horizontalTileCount = totalItemCount;
			}
			if(this._requestedMinColumnCount != null) {
				if(this._requestedMinColumnCount < horizontalTileCount) {
					return horizontalTileCount;
				}
				return (Std().default).int(Math.max(1,this._requestedMinColumnCount));
			}
			if(this._requestedMaxColumnCount != null) {
				if(this._requestedMaxColumnCount > horizontalTileCount) {
					return horizontalTileCount;
				}
				return (Std().default).int(Math.max(1,this._requestedMaxColumnCount));
			}
			return horizontalTileCount;
		}
		var horizontalTileCount1 = totalItemCount;
		if(this._requestedColumnCount != null) {
			horizontalTileCount1 = (Std().default).int(Math.max(1,this._requestedColumnCount));
		} else if(this._requestedMinColumnCount != null) {
			if(horizontalTileCount1 < this._requestedMinColumnCount) {
				horizontalTileCount1 = this._requestedMinColumnCount;
			}
		} else if(this._requestedMaxColumnCount != null) {
			if(horizontalTileCount1 > this._requestedMaxColumnCount) {
				horizontalTileCount1 = this._requestedMaxColumnCount;
			}
		}
		var maxHorizontalTileCount1 = 2147483647;
		if(explicitMaxWidth != null && explicitMaxWidth < Infinity) {
			maxHorizontalTileCount1 = (Std().default).int((explicitMaxWidth - this._paddingLeft - this._paddingRight + horizontalGap) / (tileWidth + horizontalGap));
			if(maxHorizontalTileCount1 < 1) {
				maxHorizontalTileCount1 = 1;
			}
		}
		if(horizontalTileCount1 > maxHorizontalTileCount1) {
			horizontalTileCount1 = maxHorizontalTileCount1;
		}
		if(horizontalTileCount1 < 1) {
			horizontalTileCount1 = 1;
		}
		return horizontalTileCount1;
	},
	calculateVerticalTileCount: function(tileHeight,explicitHeight,explicitMaxHeight,verticalGap,totalItemCount,horizontalTileCount) {
		var defaultVerticalTileCount = Math.ceil(totalItemCount / horizontalTileCount);
		if(explicitHeight != null) {
			var maxVerticalTileCount = (explicitHeight - this._paddingTop - this._paddingBottom + verticalGap) / (tileHeight + verticalGap);
			if(this._requestedRowCount != null && this._requestedRowCount >= 0.0) {
				if(this._requestedRowCount > maxVerticalTileCount) {
					return maxVerticalTileCount;
				}
				return this._requestedRowCount;
			}
			var verticalTileCount = maxVerticalTileCount;
			if(verticalTileCount > defaultVerticalTileCount) {
				verticalTileCount = defaultVerticalTileCount;
			}
			if(verticalTileCount < 1.0) {
				verticalTileCount = 1.0;
			}
			if(this._requestedMinRowCount != null && this._requestedMinRowCount >= 1.0) {
				if(this._requestedMinRowCount < verticalTileCount) {
					return verticalTileCount;
				}
				return this._requestedMinRowCount;
			}
			if(this._requestedMaxRowCount != null && this._requestedMaxRowCount >= 1.0) {
				if(this._requestedMaxRowCount > verticalTileCount) {
					return verticalTileCount;
				}
				return this._requestedMaxRowCount;
			}
			return verticalTileCount;
		}
		var verticalTileCount1 = defaultVerticalTileCount;
		if(this._requestedRowCount > 0.0) {
			verticalTileCount1 = this._requestedRowCount;
		}
		if(this._requestedMinRowCount != null && this._requestedMinRowCount >= 1.0 && verticalTileCount1 < this._requestedMinRowCount) {
			return this._requestedMinRowCount;
		}
		var maxVerticalTileCount1 = Infinity;
		if(explicitMaxHeight != null && explicitMaxHeight < Infinity) {
			maxVerticalTileCount1 = (Std().default).int((explicitMaxHeight - this._paddingTop - this._paddingBottom + verticalGap) / (tileHeight + verticalGap));
			if(maxVerticalTileCount1 < 1) {
				maxVerticalTileCount1 = 1;
			}
		}
		if(verticalTileCount1 > maxVerticalTileCount1) {
			verticalTileCount1 = maxVerticalTileCount1;
		}
		if(this._requestedMaxRowCount != null && this._requestedMaxRowCount >= 1.0 && verticalTileCount1 > this._requestedMaxRowCount) {
			verticalTileCount1 = this._requestedMaxRowCount;
		}
		if(verticalTileCount1 < 1.0) {
			verticalTileCount1 = 1.0;
		}
		return verticalTileCount1;
	},
	applyHorizontalAlignToRow: function(items,startIndex,numItemsInRow,horizontalTileCount,availableRowWidth,tileWidth) {
		if(this._alignEmptyHorizontalTiles && horizontalTileCount > numItemsInRow) {
			numItemsInRow = horizontalTileCount;
		}
		var alignOffset = 0.0;
		var gapOffset = 0.0;
		var adjustedHorizontalGap = this._horizontalGap;
		var hasFlexHorizontalGap = this._horizontalGap == 1.0 / 0.0;
		if(hasFlexHorizontalGap) {
			adjustedHorizontalGap = this._minHorizontalGap;
			var rowContentWidth = numItemsInRow * (tileWidth + adjustedHorizontalGap);
			if(numItemsInRow > 0) {
				rowContentWidth -= adjustedHorizontalGap;
			}
			if(numItemsInRow > 1 && availableRowWidth > rowContentWidth) {
				adjustedHorizontalGap += (availableRowWidth - rowContentWidth) / (numItemsInRow - 1);
			}
			gapOffset = adjustedHorizontalGap - this._minHorizontalGap;
		} else {
			var rowContentWidth1 = numItemsInRow * (tileWidth + adjustedHorizontalGap);
			if(numItemsInRow > 0) {
				rowContentWidth1 -= adjustedHorizontalGap;
			}
			switch(this._horizontalAlign._hx_index) {
			case 0:
				alignOffset = 0.0;
				break;
			case 1:
				alignOffset = (availableRowWidth - rowContentWidth1) / 2.0;
				break;
			case 2:
				alignOffset = availableRowWidth - rowContentWidth1;
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown horizontal align: " + (Std().default).string(this._horizontalAlign)));
			}
			if(alignOffset < 0.0) {
				alignOffset = 0.0;
			}
		}
		if(alignOffset == 0.0 && gapOffset == 0.0) {
			return;
		}
		var totalOffset = alignOffset;
		var endIndex = startIndex + numItemsInRow;
		if(endIndex > items.length) {
			endIndex = items.length;
		}
		var _g = startIndex;
		var _g1 = endIndex;
		while(_g < _g1) {
			var i = _g++;
			var item = items[i];
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				var layoutItem = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutItem.get_includeInLayout()) {
					continue;
				}
			}
			if(item != null) {
				var _g2 = item;
				_g2.set_x(_g2.get_x() + totalOffset);
			}
			totalOffset += gapOffset;
		}
	},
	applyVerticalAlignAndGap: function(items,availableHeight,tileHeight,rowCount,columnCount,adjustedVerticalGap) {
		var alignOffset = 0.0;
		var gapOffset = adjustedVerticalGap;
		var hasFlexVerticalGap = this._verticalGap == 1.0 / 0.0;
		if(!hasFlexVerticalGap) {
			var contentHeight = rowCount * (tileHeight + adjustedVerticalGap) - adjustedVerticalGap;
			switch(this._verticalAlign._hx_index) {
			case 0:
				alignOffset = 0.0;
				break;
			case 1:
				alignOffset = (availableHeight - contentHeight) / 2.0;
				break;
			case 2:
				alignOffset = availableHeight - contentHeight;
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown vertical align: " + (Std().default).string(this._verticalAlign)));
			}
			if(alignOffset < 0.0) {
				alignOffset = 0.0;
			}
		}
		if(alignOffset == 0.0 && gapOffset == 0.0) {
			return;
		}
		var totalOffset = alignOffset;
		var layoutIndex = 0;
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var item = items[i];
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				var layoutItem = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutItem.get_includeInLayout()) {
					continue;
				}
			}
			if(layoutIndex > 0 && layoutIndex % columnCount == 0) {
				totalOffset += gapOffset;
			}
			if(item != null) {
				var _g2 = item;
				_g2.set_y(_g2.get_y() + totalOffset);
			}
			++layoutIndex;
		}
	}
});
TiledRowsListLayout.prototype.__class__ = TiledRowsListLayout.prototype.constructor = $hxClasses["feathers.layout.TiledRowsListLayout"] = TiledRowsListLayout;

// Init



// Statics




// Export

exports["default"] = TiledRowsListLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/VDividedBoxLayout.js":
/*!*******************************************************!*\
  !*** ./lib/_gen/feathers/layout/VDividedBoxLayout.js ***!
  \*******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.VDividedBoxLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_ILayout() {return __webpack_require__(/*! ./../../feathers/layout/ILayout */ "./lib/_gen/feathers/layout/ILayout.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}

// Constructor

var VDividedBoxLayout = function() {
	this._fallbackFluidIndex = -1;
	this._horizontalAlign = (feathers_layout_HorizontalAlign().default).JUSTIFY;
	this._paddingLeft = 0.0;
	this._paddingBottom = 0.0;
	this._paddingRight = 0.0;
	this._paddingTop = 0.0;
	(openfl_events_EventDispatcher()).call(this);
}

// Meta

VDividedBoxLayout.__name__ = "feathers.layout.VDividedBoxLayout";
VDividedBoxLayout.__isInterface__ = false;
VDividedBoxLayout.__interfaces__ = [(feathers_layout_ILayout().default)];
VDividedBoxLayout.__super__ = (openfl_events_EventDispatcher());
VDividedBoxLayout.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_paddingTop: function() {
		return this._paddingTop;
	},
	set_paddingTop: function(value) {
		if(this._paddingTop == value) {
			return this._paddingTop;
		}
		this._paddingTop = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingTop;
	},
	get_paddingRight: function() {
		return this._paddingRight;
	},
	set_paddingRight: function(value) {
		if(this._paddingRight == value) {
			return this._paddingRight;
		}
		this._paddingRight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingRight;
	},
	get_paddingBottom: function() {
		return this._paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(this._paddingBottom == value) {
			return this._paddingBottom;
		}
		this._paddingBottom = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingBottom;
	},
	get_paddingLeft: function() {
		return this._paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(this._paddingLeft == value) {
			return this._paddingLeft;
		}
		this._paddingLeft = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingLeft;
	},
	get_horizontalAlign: function() {
		return this._horizontalAlign;
	},
	set_horizontalAlign: function(value) {
		if(this._horizontalAlign == value) {
			return this._horizontalAlign;
		}
		this._horizontalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._horizontalAlign;
	},
	get_customItemHeights: function() {
		return this._customItemHeights;
	},
	set_customItemHeights: function(value) {
		if(this._customItemHeights == value) {
			return this._customItemHeights;
		}
		this._customItemHeights = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._customItemHeights;
	},
	get_fallbackFluidIndex: function() {
		return this._fallbackFluidIndex;
	},
	set_fallbackFluidIndex: function(value) {
		if(this._fallbackFluidIndex == value) {
			return this._fallbackFluidIndex;
		}
		this._fallbackFluidIndex = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._fallbackFluidIndex;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	layout: function(items,measurements,result) {
		this.validateItems(items);
		this.applyPercentHeight(items,measurements.height,measurements.minHeight,measurements.maxHeight);
		var contentWidth = 0.0;
		var contentHeight = this._paddingTop;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
			if(contentWidth < item.get_width()) {
				contentWidth = item.get_width();
			}
			item.set_y(contentHeight);
			contentHeight += item.get_height();
		}
		contentWidth += this._paddingLeft + this._paddingRight;
		contentHeight += this._paddingBottom;
		var viewPortWidth = contentWidth;
		if(measurements.width != null) {
			viewPortWidth = measurements.width;
		} else if(measurements.minWidth != null && viewPortWidth < measurements.minWidth) {
			viewPortWidth = measurements.minWidth;
		} else if(measurements.maxWidth != null && viewPortWidth > measurements.maxWidth) {
			viewPortWidth = measurements.maxWidth;
		}
		var viewPortHeight = contentHeight;
		if(measurements.height != null) {
			viewPortHeight = measurements.height;
		} else if(measurements.minHeight != null && viewPortHeight < measurements.minHeight) {
			viewPortHeight = measurements.minHeight;
		} else if(measurements.maxHeight != null && viewPortHeight > measurements.maxHeight) {
			viewPortHeight = measurements.maxHeight;
		}
		this.applyPercentWidth(items,viewPortWidth);
		this.applyHorizontalAlign(items,viewPortWidth);
		if(contentWidth < viewPortWidth) {
			contentWidth = viewPortWidth;
		}
		if(contentHeight < viewPortHeight) {
			contentHeight = viewPortHeight;
		}
		if(result == null) {
			result = new (feathers_layout_LayoutBoundsResult().default)();
		}
		result.contentX = 0.0;
		result.contentY = 0.0;
		result.contentWidth = contentWidth;
		result.contentHeight = contentHeight;
		result.viewPortWidth = viewPortWidth;
		result.viewPortHeight = viewPortHeight;
		return result;
	},
	validateItems: function(items) {
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var item = items[i];
			var isDivider = i % 2 == 1;
			if(!isDivider) {
				if(this._customItemHeights != null && i < this._customItemHeights.length) {
					var itemHeight = this._customItemHeights[i];
					if(itemHeight != null) {
						item.set_height(itemHeight);
					}
				}
			}
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
		}
	},
	applyHorizontalAlign: function(items,viewPortWidth) {
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var isDivider = i % 2 == 1;
			if(!isDivider) {
				continue;
			}
			var item = items[i];
			switch(this._horizontalAlign._hx_index) {
			case 0:
				item.set_x(this._paddingLeft);
				break;
			case 1:
				item.set_x(Math.max(this._paddingLeft,this._paddingLeft + (viewPortWidth - this._paddingLeft - this._paddingRight - item.get_width()) / 2.0));
				break;
			case 2:
				item.set_x(Math.max(this._paddingLeft,this._paddingLeft + (viewPortWidth - this._paddingLeft - this._paddingRight) - item.get_width()));
				break;
			case 3:
				item.set_x(this._paddingLeft);
				item.set_width(viewPortWidth - this._paddingLeft - this._paddingRight);
				break;
			}
		}
	},
	applyPercentHeight: function(items,explicitHeight,explicitMinHeight,explicitMaxHeight) {
		var customHeightIndices = [];
		var pendingIndices = [];
		var totalMeasuredHeight = 0.0;
		var totalMinHeight = 0.0;
		var totalPercentHeight = 0.0;
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var item = items[i];
			var isDivider = i % 2 == 1;
			if(!isDivider) {
				var nonDividerIndex = Math.floor(i / 2);
				var needsPercentHeight = true;
				if(this._customItemHeights != null && nonDividerIndex < this._customItemHeights.length) {
					var itemHeight = this._customItemHeights[nonDividerIndex];
					if(itemHeight != null) {
						needsPercentHeight = false;
						item.set_height(itemHeight);
						customHeightIndices.push(i);
						if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
							((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
						}
					}
				}
				if(needsPercentHeight) {
					var percentHeight = 100.0;
					if((js_Boot().default).__implements(item,(feathers_core_IMeasureObject().default))) {
						var measureItem = (js_Boot().default).__cast(item , (feathers_core_IMeasureObject().default));
						var columnExplicitMinHeight = measureItem.get_explicitMinHeight();
						if(columnExplicitMinHeight != null) {
							totalMinHeight += columnExplicitMinHeight;
						}
					}
					totalPercentHeight += percentHeight;
					pendingIndices.push(i);
					continue;
				}
			}
			totalMeasuredHeight += item.get_height();
		}
		totalMeasuredHeight += this._paddingTop + this._paddingBottom;
		var remainingHeight = 0.0;
		if(explicitHeight != null) {
			remainingHeight = explicitHeight;
		} else {
			remainingHeight = totalMeasuredHeight + totalMinHeight;
			if(explicitMinHeight != null && remainingHeight < explicitMinHeight) {
				remainingHeight = explicitMinHeight;
			} else if(explicitMaxHeight != null && remainingHeight > explicitMaxHeight) {
				remainingHeight = explicitMaxHeight;
			}
		}
		remainingHeight -= totalMeasuredHeight;
		var needsAnotherPass = false;
		while(true) {
			needsAnotherPass = false;
			var heightSum = 0.0;
			var percentToPixels = remainingHeight / totalPercentHeight;
			if(percentToPixels < 0.0) {
				percentToPixels = 0.0;
			}
			var _g2 = 0;
			while(_g2 < pendingIndices.length) {
				var index = pendingIndices[_g2];
				++_g2;
				var item1 = items[index];
				var percentHeight1 = 100.0;
				var itemHeight1 = Math.floor(percentToPixels * percentHeight1);
				var columnMinHeight = null;
				if((js_Boot().default).__implements(item1,(feathers_core_IMeasureObject().default))) {
					var measureItem1 = (js_Boot().default).__cast(item1 , (feathers_core_IMeasureObject().default));
					columnMinHeight = measureItem1.get_explicitMinHeight();
				}
				if(columnMinHeight != null) {
					if(columnMinHeight > remainingHeight) {
						columnMinHeight = remainingHeight;
					}
					if(itemHeight1 < columnMinHeight) {
						itemHeight1 = columnMinHeight;
						remainingHeight -= itemHeight1;
						totalPercentHeight -= percentHeight1;
						(HxOverrides().default).remove(pendingIndices,index);
						needsAnotherPass = true;
					}
				}
				item1.set_height(itemHeight1);
				if((js_Boot().default).__implements(item1,(feathers_core_IValidating().default))) {
					((js_Boot().default).__cast(item1 , (feathers_core_IValidating().default))).validateNow();
				}
				heightSum += itemHeight1;
			}
			if(needsAnotherPass) {
				heightSum = 0.0;
			} else {
				remainingHeight -= heightSum;
			}
			if(!needsAnotherPass) {
				break;
			}
		}
		if(remainingHeight > 0.0 && pendingIndices.length > 0) {
			var index1 = pendingIndices[pendingIndices.length - 1];
			var finalItem = items[index1];
			var _g21 = finalItem;
			_g21.set_height(_g21.get_height() + remainingHeight);
			return;
		}
		if(remainingHeight == 0.0) {
			return;
		}
		var index2 = this._fallbackFluidIndex;
		if(index2 == -1) {
			index2 = items.length - 1;
		}
		if(index2 != -1) {
			var fallbackItem = items[index2];
			var itemHeight2 = fallbackItem.get_height() + remainingHeight;
			if(itemHeight2 < 0.0) {
				remainingHeight = itemHeight2;
				itemHeight2 = 0.0;
				(HxOverrides().default).remove(customHeightIndices,index2);
			} else {
				remainingHeight = 0.0;
			}
			fallbackItem.set_height(itemHeight2);
		}
		if(remainingHeight == 0.0) {
			return;
		}
		var offset = remainingHeight / customHeightIndices.length;
		var _g22 = 0;
		while(_g22 < customHeightIndices.length) {
			var index3 = customHeightIndices[_g22];
			++_g22;
			var item2 = items[index3];
			var _g23 = item2;
			_g23.set_height(_g23.get_height() + offset);
		}
	},
	applyPercentWidth: function(items,viewPortWidth) {
		var availableWidth = viewPortWidth - this._paddingLeft - this._paddingRight;
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var isDivider = i % 2 == 1;
			if(isDivider) {
				continue;
			}
			var item = items[i];
			var itemWidth = availableWidth;
			if((js_Boot().default).__implements(item,(feathers_core_IMeasureObject().default))) {
				var measureItem = (js_Boot().default).__cast(item , (feathers_core_IMeasureObject().default));
				var itemMinWidth = measureItem.get_explicitMinWidth();
				if(itemMinWidth != null) {
					if(itemMinWidth > availableWidth) {
						itemMinWidth = availableWidth;
					}
					if(itemWidth < itemMinWidth) {
						itemWidth = itemMinWidth;
					}
				}
				var itemMaxWidth = measureItem.get_explicitMaxWidth();
				if(itemMaxWidth != null && itemWidth > itemMaxWidth) {
					itemWidth = itemMaxWidth;
				}
			}
			item.set_width(itemWidth);
		}
	}
});
VDividedBoxLayout.prototype.__class__ = VDividedBoxLayout.prototype.constructor = $hxClasses["feathers.layout.VDividedBoxLayout"] = VDividedBoxLayout;

// Init



// Statics




// Export

exports["default"] = VDividedBoxLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/VerticalAlign.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/layout/VerticalAlign.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.layout.VerticalAlign

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var VerticalAlign = $hxEnums["feathers.layout.VerticalAlign"] = { __ename__ : "feathers.layout.VerticalAlign", __constructs__ : ["TOP","MIDDLE","BOTTOM","JUSTIFY"]
  ,TOP: {_hx_index:0,__enum__:"feathers.layout.VerticalAlign",toString:$estr}
  ,MIDDLE: {_hx_index:1,__enum__:"feathers.layout.VerticalAlign",toString:$estr}
  ,JUSTIFY: {_hx_index:3,__enum__:"feathers.layout.VerticalAlign",toString:$estr}
  ,BOTTOM: {_hx_index:2,__enum__:"feathers.layout.VerticalAlign",toString:$estr}
};

exports["default"] = VerticalAlign;

/***/ }),

/***/ "./lib/_gen/feathers/layout/VerticalDistributedLayout.js":
/*!***************************************************************!*\
  !*** ./lib/_gen/feathers/layout/VerticalDistributedLayout.js ***!
  \***************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.VerticalDistributedLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_ILayout() {return __webpack_require__(/*! ./../../feathers/layout/ILayout */ "./lib/_gen/feathers/layout/ILayout.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_ILayoutObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutObject */ "./lib/_gen/feathers/layout/ILayoutObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}

// Constructor

var VerticalDistributedLayout = function() {
	this._horizontalAlign = (feathers_layout_HorizontalAlign().default).LEFT;
	this._minItemHeight = 0.0;
	this._maxItemHeight = 1.0 / 0.0;
	this._gap = 0.0;
	this._paddingLeft = 0.0;
	this._paddingBottom = 0.0;
	this._paddingRight = 0.0;
	this._paddingTop = 0.0;
	(openfl_events_EventDispatcher()).call(this);
}

// Meta

VerticalDistributedLayout.__name__ = "feathers.layout.VerticalDistributedLayout";
VerticalDistributedLayout.__isInterface__ = false;
VerticalDistributedLayout.__interfaces__ = [(feathers_layout_ILayout().default)];
VerticalDistributedLayout.__super__ = (openfl_events_EventDispatcher());
VerticalDistributedLayout.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_paddingTop: function() {
		return this._paddingTop;
	},
	set_paddingTop: function(value) {
		if(this._paddingTop == value) {
			return this._paddingTop;
		}
		this._paddingTop = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingTop;
	},
	get_paddingRight: function() {
		return this._paddingRight;
	},
	set_paddingRight: function(value) {
		if(this._paddingRight == value) {
			return this._paddingRight;
		}
		this._paddingRight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingRight;
	},
	get_paddingBottom: function() {
		return this._paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(this._paddingBottom == value) {
			return this._paddingBottom;
		}
		this._paddingBottom = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingBottom;
	},
	get_paddingLeft: function() {
		return this._paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(this._paddingLeft == value) {
			return this._paddingLeft;
		}
		this._paddingLeft = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingLeft;
	},
	get_gap: function() {
		return this._gap;
	},
	set_gap: function(value) {
		if(this._gap == value) {
			return this._gap;
		}
		this._gap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._gap;
	},
	get_maxItemHeight: function() {
		return this._maxItemHeight;
	},
	set_maxItemHeight: function(value) {
		if(this._maxItemHeight == value) {
			return this._maxItemHeight;
		}
		this._maxItemHeight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._maxItemHeight;
	},
	get_minItemHeight: function() {
		return this._minItemHeight;
	},
	set_minItemHeight: function(value) {
		if(this._minItemHeight == value) {
			return this._minItemHeight;
		}
		this._minItemHeight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._minItemHeight;
	},
	get_horizontalAlign: function() {
		return this._horizontalAlign;
	},
	set_horizontalAlign: function(value) {
		if(this._horizontalAlign == value) {
			return this._horizontalAlign;
		}
		this._horizontalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._horizontalAlign;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	layout: function(items,measurements,result) {
		this.applyDistributedHeight(items,measurements.height,measurements.minHeight,measurements.maxHeight);
		var contentWidth = 0.0;
		var contentHeight = this._paddingTop;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			var layoutObject = null;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				layoutObject = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutObject.get_includeInLayout()) {
					continue;
				}
			}
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
			if(contentWidth < item.get_width()) {
				contentWidth = item.get_width();
			}
			item.set_y(contentHeight);
			contentHeight += item.get_height() + this._gap;
		}
		var maxItemWidth = contentWidth;
		contentWidth += this._paddingLeft + this._paddingRight;
		contentHeight += this._paddingBottom;
		if(items.length > 0) {
			contentHeight -= this._gap;
		}
		var viewPortWidth = contentWidth;
		if(measurements.width != null) {
			viewPortWidth = measurements.width;
		} else if(measurements.minWidth != null && viewPortWidth < measurements.minWidth) {
			viewPortWidth = measurements.minWidth;
		} else if(measurements.maxWidth != null && viewPortWidth > measurements.maxWidth) {
			viewPortWidth = measurements.maxWidth;
		}
		var viewPortHeight = contentHeight;
		if(measurements.height != null) {
			viewPortHeight = measurements.height;
		} else if(measurements.minHeight != null && viewPortHeight < measurements.minHeight) {
			viewPortHeight = measurements.minHeight;
		} else if(measurements.maxHeight != null && viewPortHeight > measurements.maxHeight) {
			viewPortHeight = measurements.maxHeight;
		}
		this.applyHorizontalAlign(items,maxItemWidth,viewPortWidth);
		if(contentWidth < viewPortWidth) {
			contentWidth = viewPortWidth;
		}
		if(contentHeight < viewPortHeight) {
			contentHeight = viewPortHeight;
		}
		if(result == null) {
			result = new (feathers_layout_LayoutBoundsResult().default)();
		}
		result.contentX = 0.0;
		result.contentY = 0.0;
		result.contentWidth = contentWidth;
		result.contentHeight = contentHeight;
		result.viewPortWidth = viewPortWidth;
		result.viewPortHeight = viewPortHeight;
		return result;
	},
	validateItems: function(items) {
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
		}
	},
	applyDistributedHeight: function(items,explicitHeight,explicitMinHeight,explicitMaxHeight) {
		var maxMinHeight = 0.0;
		var totalPercentHeight = 0.0;
		var itemsInLayoutCount = 0;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				var layoutObject = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutObject.get_includeInLayout()) {
					continue;
				}
			}
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
			var itemMinHeight = 0.0;
			if((js_Boot().default).__implements(item,(feathers_core_IMeasureObject().default))) {
				var measureItem = (js_Boot().default).__cast(item , (feathers_core_IMeasureObject().default));
				itemMinHeight = measureItem.get_minHeight();
			} else {
				itemMinHeight = item.get_height();
			}
			if(maxMinHeight < itemMinHeight) {
				maxMinHeight = itemMinHeight;
			}
			totalPercentHeight += 100.0;
			++itemsInLayoutCount;
		}
		var remainingHeight = 0.0;
		if(explicitHeight != null) {
			remainingHeight = explicitHeight;
		} else {
			remainingHeight = this._paddingTop + this._paddingBottom + (maxMinHeight + this._gap) * itemsInLayoutCount - this._gap;
			if(explicitMinHeight != null && remainingHeight < explicitMinHeight) {
				remainingHeight = explicitMinHeight;
			} else if(explicitMaxHeight != null && remainingHeight > explicitMaxHeight) {
				remainingHeight = explicitMaxHeight;
			}
		}
		remainingHeight -= this._paddingTop + this._paddingBottom + this._gap * (itemsInLayoutCount - 1);
		if(remainingHeight < 0.0) {
			remainingHeight = 0.0;
		}
		var percentToPixels = remainingHeight / totalPercentHeight;
		var _g1 = 0;
		while(_g1 < items.length) {
			var item1 = items[_g1];
			++_g1;
			if((js_Boot().default).__implements(item1,(feathers_layout_ILayoutObject().default))) {
				var layoutObject1 = (js_Boot().default).__cast(item1 , (feathers_layout_ILayoutObject().default));
				if(!layoutObject1.get_includeInLayout()) {
					continue;
				}
			}
			var itemHeight = percentToPixels * 100.0;
			if(itemHeight < this._minItemHeight) {
				itemHeight = this._minItemHeight;
			} else if(itemHeight > this._maxItemHeight) {
				itemHeight = this._maxItemHeight;
			}
			item1.set_height(itemHeight);
			if((js_Boot().default).__implements(item1,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item1 , (feathers_core_IValidating().default))).validateNow();
			}
		}
	},
	applyHorizontalAlign: function(items,maxItemWidth,viewPortWidth) {
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			var layoutObject = null;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				layoutObject = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutObject.get_includeInLayout()) {
					continue;
				}
			}
			switch(this._horizontalAlign._hx_index) {
			case 0:
				item.set_x(this._paddingLeft);
				break;
			case 1:
				item.set_x(Math.max(this._paddingLeft,this._paddingLeft + (viewPortWidth - this._paddingLeft - this._paddingRight - item.get_width()) / 2.0));
				break;
			case 2:
				item.set_x(Math.max(this._paddingLeft,this._paddingLeft + (viewPortWidth - this._paddingLeft - this._paddingRight) - item.get_width()));
				break;
			case 3:
				item.set_x(this._paddingLeft);
				item.set_width(viewPortWidth - this._paddingLeft - this._paddingRight);
				break;
			}
		}
	}
});
VerticalDistributedLayout.prototype.__class__ = VerticalDistributedLayout.prototype.constructor = $hxClasses["feathers.layout.VerticalDistributedLayout"] = VerticalDistributedLayout;

// Init



// Statics




// Export

exports["default"] = VerticalDistributedLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/VerticalLayout.js":
/*!****************************************************!*\
  !*** ./lib/_gen/feathers/layout/VerticalLayout.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.VerticalLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_ILayout() {return __webpack_require__(/*! ./../../feathers/layout/ILayout */ "./lib/_gen/feathers/layout/ILayout.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_ILayoutObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutObject */ "./lib/_gen/feathers/layout/ILayoutObject.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_layout_VerticalLayoutData() {return __webpack_require__(/*! ./../../feathers/layout/VerticalLayoutData */ "./lib/_gen/feathers/layout/VerticalLayoutData.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function openfl_display_DisplayObject() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObject);}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}

// Constructor

var VerticalLayout = function() {
	this._percentHeightResetEnabled = false;
	this._percentWidthResetEnabled = false;
	this._justifyResetEnabled = false;
	this._verticalAlign = (feathers_layout_VerticalAlign().default).TOP;
	this._horizontalAlign = (feathers_layout_HorizontalAlign().default).LEFT;
	this._minGap = 0.0;
	this._gap = 0.0;
	this._paddingLeft = 0.0;
	this._paddingBottom = 0.0;
	this._paddingRight = 0.0;
	this._paddingTop = 0.0;
	(openfl_events_EventDispatcher()).call(this);
}

// Meta

VerticalLayout.__name__ = "feathers.layout.VerticalLayout";
VerticalLayout.__isInterface__ = false;
VerticalLayout.__interfaces__ = [(feathers_layout_ILayout().default)];
VerticalLayout.__super__ = (openfl_events_EventDispatcher());
VerticalLayout.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_paddingTop: function() {
		return this._paddingTop;
	},
	set_paddingTop: function(value) {
		if(this._paddingTop == value) {
			return this._paddingTop;
		}
		this._paddingTop = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingTop;
	},
	get_paddingRight: function() {
		return this._paddingRight;
	},
	set_paddingRight: function(value) {
		if(this._paddingRight == value) {
			return this._paddingRight;
		}
		this._paddingRight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingRight;
	},
	get_paddingBottom: function() {
		return this._paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(this._paddingBottom == value) {
			return this._paddingBottom;
		}
		this._paddingBottom = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingBottom;
	},
	get_paddingLeft: function() {
		return this._paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(this._paddingLeft == value) {
			return this._paddingLeft;
		}
		this._paddingLeft = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingLeft;
	},
	get_gap: function() {
		return this._gap;
	},
	set_gap: function(value) {
		if(this._gap == value) {
			return this._gap;
		}
		this._gap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._gap;
	},
	get_minGap: function() {
		return this._minGap;
	},
	set_minGap: function(value) {
		if(this._minGap == value) {
			return this._minGap;
		}
		this._minGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._minGap;
	},
	get_horizontalAlign: function() {
		return this._horizontalAlign;
	},
	set_horizontalAlign: function(value) {
		if(this._horizontalAlign == value) {
			return this._horizontalAlign;
		}
		this._horizontalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._horizontalAlign;
	},
	get_verticalAlign: function() {
		return this._verticalAlign;
	},
	set_verticalAlign: function(value) {
		if(this._verticalAlign == value) {
			return this._verticalAlign;
		}
		this._verticalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._verticalAlign;
	},
	get_justifyResetEnabled: function() {
		return this._justifyResetEnabled;
	},
	set_justifyResetEnabled: function(value) {
		if(this._justifyResetEnabled == value) {
			return this._justifyResetEnabled;
		}
		this._justifyResetEnabled = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._justifyResetEnabled;
	},
	get_percentWidthResetEnabled: function() {
		return this._percentWidthResetEnabled;
	},
	set_percentWidthResetEnabled: function(value) {
		if(this._percentWidthResetEnabled == value) {
			return this._percentWidthResetEnabled;
		}
		this._percentWidthResetEnabled = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._percentWidthResetEnabled;
	},
	get_percentHeightResetEnabled: function() {
		return this._percentHeightResetEnabled;
	},
	set_percentHeightResetEnabled: function(value) {
		if(this._percentHeightResetEnabled == value) {
			return this._percentHeightResetEnabled;
		}
		this._percentHeightResetEnabled = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._percentHeightResetEnabled;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	layout: function(items,measurements,result) {
		var adjustedGap = this._gap;
		var hasFlexGap = this._gap == 1.0 / 0.0;
		if(hasFlexGap) {
			adjustedGap = this._minGap;
		}
		this.validateItems(items,measurements);
		this.applyPercentHeight(items,measurements.height,measurements.minHeight,measurements.maxHeight,adjustedGap);
		var contentWidth = 0.0;
		var contentHeight = this._paddingTop;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			var layoutData = null;
			var layoutObject = null;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				layoutObject = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutObject.get_includeInLayout()) {
					continue;
				}
				layoutData = (Std().default).downcast(layoutObject.get_layoutData(),(feathers_layout_VerticalLayoutData().default));
			}
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
			if(contentWidth < item.get_width()) {
				contentWidth = item.get_width();
			}
			if(layoutData != null && layoutData.get_marginTop() != null) {
				contentHeight += layoutData.get_marginTop();
			}
			item.set_y(contentHeight);
			contentHeight += item.get_height() + adjustedGap;
			if(layoutData != null && layoutData.get_marginBottom() != null) {
				contentHeight += layoutData.get_marginBottom();
			}
		}
		var maxItemWidth = contentWidth;
		contentWidth += this._paddingLeft + this._paddingRight;
		contentHeight += this._paddingBottom;
		if(items.length > 0) {
			contentHeight -= adjustedGap;
		}
		var viewPortWidth = contentWidth;
		if(measurements.width != null) {
			viewPortWidth = measurements.width;
		} else if(measurements.minWidth != null && viewPortWidth < measurements.minWidth) {
			viewPortWidth = measurements.minWidth;
		} else if(measurements.maxWidth != null && viewPortWidth > measurements.maxWidth) {
			viewPortWidth = measurements.maxWidth;
		}
		var viewPortHeight = contentHeight;
		if(measurements.height != null) {
			viewPortHeight = measurements.height;
		} else if(measurements.minHeight != null && viewPortHeight < measurements.minHeight) {
			viewPortHeight = measurements.minHeight;
		} else if(measurements.maxHeight != null && viewPortHeight > measurements.maxHeight) {
			viewPortHeight = measurements.maxHeight;
		}
		this.applyPercentWidth(items,viewPortWidth);
		this.applyHorizontalAlign(items,maxItemWidth,viewPortWidth);
		this.applyVerticalAlign(items,contentHeight - this._paddingTop - this._paddingBottom,viewPortHeight);
		if(contentWidth < viewPortWidth) {
			contentWidth = viewPortWidth;
		}
		if(contentHeight < viewPortHeight) {
			contentHeight = viewPortHeight;
		}
		if(result == null) {
			result = new (feathers_layout_LayoutBoundsResult().default)();
		}
		result.contentX = 0.0;
		result.contentY = 0.0;
		result.contentWidth = contentWidth;
		result.contentHeight = contentHeight;
		result.viewPortWidth = viewPortWidth;
		result.viewPortHeight = viewPortHeight;
		return result;
	},
	validateItems: function(items,measurements) {
		var isJustified = this._horizontalAlign == (feathers_layout_HorizontalAlign().default).JUSTIFY;
		var explicitContentWidth = measurements.width;
		if(explicitContentWidth != null) {
			explicitContentWidth -= this._paddingLeft + this._paddingRight;
		}
		var explicitContentHeight = measurements.height;
		if(explicitContentHeight != null) {
			explicitContentHeight -= this._paddingTop + this._paddingBottom;
		}
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			var percentWidth = null;
			var percentHeight = null;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				var layoutItem = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutItem.get_includeInLayout()) {
					continue;
				}
				var layoutData = (Std().default).downcast(layoutItem.get_layoutData(),(feathers_layout_VerticalLayoutData().default));
				if(layoutData != null) {
					percentWidth = layoutData.get_percentWidth();
					percentHeight = layoutData.get_percentHeight();
				}
			}
			if(isJustified) {
				if(explicitContentWidth != null) {
					item.set_width(explicitContentWidth);
				} else if(this._justifyResetEnabled && (js_Boot().default).__implements(item,(feathers_core_IMeasureObject().default))) {
					((js_Boot().default).__cast(item , (feathers_core_IMeasureObject().default))).resetWidth();
				}
			} else if(explicitContentWidth != null) {
				if(percentWidth != null) {
					if(percentWidth < 0.0) {
						percentWidth = 0.0;
					} else if(percentWidth > 100.0) {
						percentWidth = 100.0;
					}
					item.set_width(explicitContentWidth * (percentWidth / 100.0));
				}
			} else if(percentWidth != null && this._percentWidthResetEnabled && (js_Boot().default).__implements(item,(feathers_core_IMeasureObject().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IMeasureObject().default))).resetWidth();
			}
			if(percentHeight != null && this._percentHeightResetEnabled && explicitContentHeight == null && (js_Boot().default).__implements(item,(feathers_core_IMeasureObject().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IMeasureObject().default))).resetHeight();
			}
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
			if(isJustified && explicitContentWidth == null && measurements.maxWidth != null) {
				var maxExplicitContentWidth = measurements.maxWidth - this._paddingLeft - this._paddingRight;
				if(item.get_width() > maxExplicitContentWidth) {
					item.set_width(maxExplicitContentWidth);
					if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
						((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
					}
				}
			}
		}
	},
	applyHorizontalAlign: function(items,maxItemWidth,viewPortWidth) {
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			var layoutObject = null;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				layoutObject = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutObject.get_includeInLayout()) {
					continue;
				}
			}
			switch(this._horizontalAlign._hx_index) {
			case 0:
				item.set_x(this._paddingLeft);
				break;
			case 1:
				item.set_x(Math.max(this._paddingLeft,this._paddingLeft + (viewPortWidth - this._paddingLeft - this._paddingRight - item.get_width()) / 2.0));
				break;
			case 2:
				item.set_x(Math.max(this._paddingLeft,this._paddingLeft + (viewPortWidth - this._paddingLeft - this._paddingRight) - item.get_width()));
				break;
			case 3:
				item.set_x(this._paddingLeft);
				item.set_width(viewPortWidth - this._paddingLeft - this._paddingRight);
				break;
			}
		}
	},
	applyVerticalAlign: function(items,contentHeight,viewPortHeight) {
		var alignOffset = 0.0;
		var gapOffset = 0.0;
		var maxAlignmentHeight = viewPortHeight - this._paddingTop - this._paddingBottom;
		var adjustedGap = this._gap;
		var hasFlexGap = this._gap == 1.0 / 0.0;
		if(hasFlexGap) {
			adjustedGap = this._minGap;
			if(items.length > 1 && maxAlignmentHeight > contentHeight) {
				adjustedGap += (maxAlignmentHeight - contentHeight) / (items.length - 1);
			}
			gapOffset = adjustedGap - this._minGap;
		} else {
			switch(this._verticalAlign._hx_index) {
			case 0:
				alignOffset = 0.0;
				break;
			case 1:
				alignOffset = (maxAlignmentHeight - contentHeight) / 2.0;
				break;
			case 2:
				alignOffset = maxAlignmentHeight - contentHeight;
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown vertical align: " + (Std().default).string(this._verticalAlign)));
			}
			if(alignOffset < 0.0) {
				alignOffset = 0.0;
			}
		}
		if(alignOffset == 0.0 && gapOffset == 0.0) {
			return;
		}
		var totalOffset = alignOffset;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			var layoutObject = null;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				layoutObject = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutObject.get_includeInLayout()) {
					continue;
				}
			}
			item.set_y(Math.max(this._paddingTop,item.get_y() + totalOffset));
			totalOffset += gapOffset;
		}
	},
	applyPercentWidth: function(items,viewPortWidth) {
		var availableWidth = viewPortWidth - this._paddingLeft - this._paddingRight;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			if(!(js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				continue;
			}
			var layoutItem = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
			if(!layoutItem.get_includeInLayout()) {
				continue;
			}
			var layoutData = (Std().default).downcast(layoutItem.get_layoutData(),(feathers_layout_VerticalLayoutData().default));
			if(layoutData == null) {
				continue;
			}
			var percentWidth = layoutData.get_percentWidth();
			if(percentWidth == null) {
				continue;
			}
			if(percentWidth < 0.0) {
				percentWidth = 0.0;
			} else if(percentWidth > 100.0) {
				percentWidth = 100.0;
			}
			var itemWidth = availableWidth * percentWidth / 100.0;
			if((js_Boot().default).__implements(item,(feathers_core_IMeasureObject().default))) {
				var measureItem = (js_Boot().default).__cast(item , (feathers_core_IMeasureObject().default));
				var itemMinWidth = measureItem.get_explicitMinWidth();
				if(itemMinWidth != null) {
					if(itemMinWidth > availableWidth) {
						itemMinWidth = availableWidth;
					}
					if(itemWidth < itemMinWidth) {
						itemWidth = itemMinWidth;
					}
				}
				var itemMaxWidth = measureItem.get_explicitMaxWidth();
				if(itemMaxWidth != null && itemWidth > itemMaxWidth) {
					itemWidth = itemMaxWidth;
				}
			}
			item.set_width(itemWidth);
		}
	},
	applyPercentHeight: function(items,explicitHeight,explicitMinHeight,explicitMaxHeight,adjustedGap) {
		var pendingItems = [];
		var totalMeasuredHeight = 0.0;
		var totalMinHeight = 0.0;
		var totalPercentHeight = 0.0;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				var layoutItem = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutItem.get_includeInLayout()) {
					continue;
				}
				var layoutData = (Std().default).downcast(layoutItem.get_layoutData(),(feathers_layout_VerticalLayoutData().default));
				if(layoutData != null) {
					var percentHeight = layoutData.get_percentHeight();
					if(percentHeight != null) {
						if(percentHeight < 0.0) {
							percentHeight = 0.0;
						}
						if((js_Boot().default).__implements(layoutItem,(feathers_core_IMeasureObject().default))) {
							var measureItem = (js_Boot().default).__cast(layoutItem , (feathers_core_IMeasureObject().default));
							totalMinHeight += measureItem.get_minHeight();
						}
						totalPercentHeight += percentHeight;
						if(layoutData.get_marginTop() != null) {
							totalMeasuredHeight += layoutData.get_marginTop();
						}
						if(layoutData.get_marginBottom() != null) {
							totalMeasuredHeight += layoutData.get_marginBottom();
						}
						totalMeasuredHeight += adjustedGap;
						pendingItems.push(layoutItem);
						continue;
					}
				}
			}
			totalMeasuredHeight += item.get_height() + adjustedGap;
		}
		totalMeasuredHeight -= adjustedGap;
		totalMeasuredHeight += this._paddingTop + this._paddingBottom;
		if(totalPercentHeight < 100.0) {
			totalPercentHeight = 100.0;
		}
		var remainingHeight = 0.0;
		if(explicitHeight != null) {
			remainingHeight = explicitHeight;
		} else {
			remainingHeight = totalMeasuredHeight + totalMinHeight;
			if(explicitMinHeight != null && remainingHeight < explicitMinHeight) {
				remainingHeight = explicitMinHeight;
			} else if(explicitMaxHeight != null && remainingHeight > explicitMaxHeight) {
				remainingHeight = explicitMaxHeight;
			}
		}
		remainingHeight -= totalMeasuredHeight;
		if(remainingHeight < 0.0) {
			remainingHeight = 0.0;
		}
		var needsAnotherPass = true;
		while(needsAnotherPass) {
			needsAnotherPass = false;
			var percentToPixels = remainingHeight / totalPercentHeight;
			var _g1 = 0;
			while(_g1 < pendingItems.length) {
				var layoutItem1 = pendingItems[_g1];
				++_g1;
				var layoutData1 = (js_Boot().default).__cast(layoutItem1.get_layoutData() , (feathers_layout_VerticalLayoutData().default));
				var percentHeight1 = layoutData1.get_percentHeight();
				if(percentHeight1 < 0.0) {
					percentHeight1 = 0.0;
				}
				var itemHeight = percentToPixels * percentHeight1;
				if((js_Boot().default).__implements(layoutItem1,(feathers_core_IMeasureObject().default))) {
					var measureItem1 = (js_Boot().default).__cast(layoutItem1 , (feathers_core_IMeasureObject().default));
					var itemMinHeight = measureItem1.get_explicitMinHeight();
					if(itemMinHeight != null && itemMinHeight > remainingHeight) {
						itemMinHeight = remainingHeight;
					}
					if(itemHeight < itemMinHeight) {
						itemHeight = itemMinHeight;
						remainingHeight -= itemHeight;
						totalPercentHeight -= percentHeight1;
						(HxOverrides().default).remove(pendingItems,layoutItem1);
						needsAnotherPass = true;
					}
				}
				((js_Boot().default).__cast(layoutItem1 , (openfl_display_DisplayObject()))).set_height(itemHeight);
				if((js_Boot().default).__implements(layoutItem1,(feathers_core_IValidating().default))) {
					((js_Boot().default).__cast(layoutItem1 , (feathers_core_IValidating().default))).validateNow();
				}
			}
		}
	}
});
VerticalLayout.prototype.__class__ = VerticalLayout.prototype.constructor = $hxClasses["feathers.layout.VerticalLayout"] = VerticalLayout;

// Init



// Statics




// Export

exports["default"] = VerticalLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/VerticalLayoutData.js":
/*!********************************************************!*\
  !*** ./lib/_gen/feathers/layout/VerticalLayoutData.js ***!
  \********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.VerticalLayoutData

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_ILayoutData() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutData */ "./lib/_gen/feathers/layout/ILayoutData.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}

// Constructor

var VerticalLayoutData = function(percentWidth,percentHeight) {
	this._marginBottom = null;
	this._marginTop = null;
	this._percentHeight = null;
	this._percentWidth = null;
	(openfl_events_EventDispatcher()).call(this);
	this.set_percentWidth(percentWidth);
	this.set_percentHeight(percentHeight);
}

// Meta

VerticalLayoutData.__name__ = "feathers.layout.VerticalLayoutData";
VerticalLayoutData.__isInterface__ = false;
VerticalLayoutData.__interfaces__ = [(feathers_layout_ILayoutData().default)];
VerticalLayoutData.__super__ = (openfl_events_EventDispatcher());
VerticalLayoutData.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_percentWidth: function() {
		return this._percentWidth;
	},
	set_percentWidth: function(value) {
		if(this._percentWidth == value) {
			return this._percentWidth;
		}
		this._percentWidth = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._percentWidth;
	},
	get_percentHeight: function() {
		return this._percentHeight;
	},
	set_percentHeight: function(value) {
		if(this._percentHeight == value) {
			return this._percentHeight;
		}
		this._percentHeight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._percentHeight;
	},
	get_marginTop: function() {
		return this._marginTop;
	},
	set_marginTop: function(value) {
		if(this._marginTop == value) {
			return this._marginTop;
		}
		this._marginTop = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._marginTop;
	},
	get_marginBottom: function() {
		return this._marginBottom;
	},
	set_marginBottom: function(value) {
		if(this._marginBottom == value) {
			return this._marginBottom;
		}
		this._marginBottom = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._marginBottom;
	}
});
VerticalLayoutData.prototype.__class__ = VerticalLayoutData.prototype.constructor = $hxClasses["feathers.layout.VerticalLayoutData"] = VerticalLayoutData;

// Init



// Statics

VerticalLayoutData.fill = function() {
	return new VerticalLayoutData(100.0,100.0);
}
VerticalLayoutData.fillHorizontal = function(percentWidth) {
	if(percentWidth == null) {
		percentWidth = 100.0;
	}
	return new VerticalLayoutData(percentWidth,null);
}
VerticalLayoutData.fillVertical = function(percentHeight) {
	if(percentHeight == null) {
		percentHeight = 100.0;
	}
	return new VerticalLayoutData(null,percentHeight);
}


// Export

exports["default"] = VerticalLayoutData;

/***/ }),

/***/ "./lib/_gen/feathers/layout/VerticalListFixedRowLayout.js":
/*!****************************************************************!*\
  !*** ./lib/_gen/feathers/layout/VerticalListFixedRowLayout.js ***!
  \****************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.VerticalListFixedRowLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_IKeyboardNavigationLayout() {return __webpack_require__(/*! ./../../feathers/layout/IKeyboardNavigationLayout */ "./lib/_gen/feathers/layout/IKeyboardNavigationLayout.js");}
function feathers_layout_IVirtualLayout() {return __webpack_require__(/*! ./../../feathers/layout/IVirtualLayout */ "./lib/_gen/feathers/layout/IVirtualLayout.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_ILayoutObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutObject */ "./lib/_gen/feathers/layout/ILayoutObject.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_layout__$VerticalListFixedRowLayout_VirtualCacheItem() {return __webpack_require__(/*! ./../../feathers/layout/_VerticalListFixedRowLayout/VirtualCacheItem */ "./lib/_gen/feathers/layout/_VerticalListFixedRowLayout/VirtualCacheItem.js");}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_layout_VirtualLayoutRange() {return __webpack_require__(/*! ./../../feathers/layout/VirtualLayoutRange */ "./lib/_gen/feathers/layout/VirtualLayoutRange.js");}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}

// Constructor

var VerticalListFixedRowLayout = function() {
	this._contentJustify = false;
	this._verticalAlign = (feathers_layout_VerticalAlign().default).TOP;
	this._minGap = 0.0;
	this._gap = 0.0;
	this._paddingLeft = 0.0;
	this._paddingBottom = 0.0;
	this._paddingRight = 0.0;
	this._paddingTop = 0.0;
	this._requestedMaxRowCount = null;
	this._requestedMinRowCount = null;
	this._requestedRowCount = null;
	this._rowHeight = null;
	this._scrollY = 0.0;
	this._scrollX = 0.0;
	(openfl_events_EventDispatcher()).call(this);
}

// Meta

VerticalListFixedRowLayout.__name__ = "feathers.layout.VerticalListFixedRowLayout";
VerticalListFixedRowLayout.__isInterface__ = false;
VerticalListFixedRowLayout.__interfaces__ = [(feathers_layout_IKeyboardNavigationLayout().default),(feathers_layout_IVirtualLayout().default)];
VerticalListFixedRowLayout.__super__ = (openfl_events_EventDispatcher());
VerticalListFixedRowLayout.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_scrollX: function() {
		return this._scrollX;
	},
	set_scrollX: function(value) {
		this._scrollX = value;
		return this._scrollX;
	},
	get_scrollY: function() {
		return this._scrollY;
	},
	set_scrollY: function(value) {
		this._scrollY = value;
		return this._scrollY;
	},
	get_virtualCache: function() {
		return this._virtualCache;
	},
	set_virtualCache: function(value) {
		this._virtualCache = value;
		return this._virtualCache;
	},
	get_elasticTop: function() {
		return true;
	},
	get_elasticRight: function() {
		return false;
	},
	get_elasticBottom: function() {
		return true;
	},
	get_elasticLeft: function() {
		return false;
	},
	get_rowHeight: function() {
		return this._rowHeight;
	},
	set_rowHeight: function(value) {
		if(this._rowHeight == value) {
			return this._rowHeight;
		}
		this._rowHeight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._rowHeight;
	},
	get_requestedRowCount: function() {
		return this._requestedRowCount;
	},
	set_requestedRowCount: function(value) {
		if(this._requestedRowCount == value) {
			return this._requestedRowCount;
		}
		this._requestedRowCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedRowCount;
	},
	get_requestedMinRowCount: function() {
		return this._requestedMinRowCount;
	},
	set_requestedMinRowCount: function(value) {
		if(this._requestedMinRowCount == value) {
			return this._requestedMinRowCount;
		}
		this._requestedMinRowCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedMinRowCount;
	},
	get_requestedMaxRowCount: function() {
		return this._requestedMaxRowCount;
	},
	set_requestedMaxRowCount: function(value) {
		if(this._requestedMaxRowCount == value) {
			return this._requestedMaxRowCount;
		}
		this._requestedMaxRowCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedMaxRowCount;
	},
	get_paddingTop: function() {
		return this._paddingTop;
	},
	set_paddingTop: function(value) {
		if(this._paddingTop == value) {
			return this._paddingTop;
		}
		this._paddingTop = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingTop;
	},
	get_paddingRight: function() {
		return this._paddingRight;
	},
	set_paddingRight: function(value) {
		if(this._paddingRight == value) {
			return this._paddingRight;
		}
		this._paddingRight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingRight;
	},
	get_paddingBottom: function() {
		return this._paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(this._paddingBottom == value) {
			return this._paddingBottom;
		}
		this._paddingBottom = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingBottom;
	},
	get_paddingLeft: function() {
		return this._paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(this._paddingLeft == value) {
			return this._paddingLeft;
		}
		this._paddingLeft = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingLeft;
	},
	get_gap: function() {
		return this._gap;
	},
	set_gap: function(value) {
		if(this._gap == value) {
			return this._gap;
		}
		this._gap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._gap;
	},
	get_minGap: function() {
		return this._minGap;
	},
	set_minGap: function(value) {
		if(this._minGap == value) {
			return this._minGap;
		}
		this._minGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._minGap;
	},
	get_verticalAlign: function() {
		return this._verticalAlign;
	},
	set_verticalAlign: function(value) {
		if(this._verticalAlign == value) {
			return this._verticalAlign;
		}
		this._verticalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._verticalAlign;
	},
	get_contentJustify: function() {
		return this._contentJustify;
	},
	set_contentJustify: function(value) {
		if(this._contentJustify == value) {
			return this._contentJustify;
		}
		this._contentJustify = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._contentJustify;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	layout: function(items,measurements,result) {
		var adjustedGap = this._gap;
		var hasFlexGap = this._gap == 1.0 / 0.0;
		if(hasFlexGap) {
			adjustedGap = this._minGap;
		}
		var maxItemWidth = this.calculateMaxItemWidth(items,measurements);
		var viewPortWidth = this.calculateViewPortWidth(maxItemWidth,measurements);
		var minItemWidth = viewPortWidth - this._paddingLeft - this._paddingRight;
		var itemWidth = maxItemWidth;
		if(!this._contentJustify || itemWidth < minItemWidth) {
			itemWidth = minItemWidth;
		}
		var actualRowHeight = this.calculateRowHeight(items,itemWidth);
		var positionY = this._paddingTop;
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var item = items[i];
			if(item != null) {
				if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
					if(!((js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default))).get_includeInLayout()) {
						continue;
					}
				}
				item.set_x(this._paddingLeft);
				item.set_y(positionY);
				item.set_width(itemWidth);
				item.set_height(actualRowHeight);
				if(this._virtualCache != null) {
					var cacheItem = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$VerticalListFixedRowLayout_VirtualCacheItem().default));
					if(cacheItem != null && cacheItem.itemHeight != actualRowHeight) {
						cacheItem.itemHeight = actualRowHeight;
					}
				}
			}
			positionY += actualRowHeight + adjustedGap;
		}
		if(items.length > 0) {
			positionY -= adjustedGap;
		}
		var viewPortHeight = positionY += this._paddingBottom;
		if(measurements.height != null) {
			viewPortHeight = measurements.height;
		} else {
			if(this._requestedRowCount != null) {
				viewPortHeight = this._paddingTop + this._paddingBottom + (this._requestedRowCount * (actualRowHeight + adjustedGap) - adjustedGap);
			} else if(this._requestedMinRowCount != null && items.length < this._requestedMinRowCount) {
				viewPortHeight = this._paddingTop + this._paddingBottom + (this._requestedMinRowCount * (actualRowHeight + adjustedGap) - adjustedGap);
			} else if(this._requestedMaxRowCount != null && items.length > this._requestedMaxRowCount) {
				viewPortHeight = this._paddingTop + this._paddingBottom + (this._requestedMaxRowCount * (actualRowHeight + adjustedGap) - adjustedGap);
			}
			if(measurements.minHeight != null && viewPortHeight < measurements.minHeight) {
				viewPortHeight = measurements.minHeight;
			} else if(measurements.maxHeight != null && viewPortHeight > measurements.maxHeight) {
				viewPortHeight = measurements.maxHeight;
			}
		}
		this.applyVerticalAlign(items,positionY - this._paddingTop - this._paddingBottom,viewPortHeight);
		if(result == null) {
			result = new (feathers_layout_LayoutBoundsResult().default)();
		}
		result.contentX = 0.0;
		result.contentY = 0.0;
		result.contentWidth = itemWidth + this._paddingLeft + this._paddingRight;
		result.contentHeight = positionY;
		if(this._requestedMinRowCount != null) {
			result.contentMinHeight = this._paddingTop + this._paddingBottom + (this._requestedMinRowCount * (actualRowHeight + adjustedGap) - adjustedGap);
		}
		result.viewPortWidth = viewPortWidth;
		result.viewPortHeight = viewPortHeight;
		return result;
	},
	calculateMaxItemWidth: function(items,measurements) {
		var maxItemWidth = 0.0;
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var item = items[i];
			if(this._virtualCache != null && this._virtualCache.length > i) {
				var cacheItem = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$VerticalListFixedRowLayout_VirtualCacheItem().default));
				if(cacheItem != null) {
					var itemWidth = cacheItem.itemWidth;
					if(maxItemWidth < itemWidth) {
						maxItemWidth = itemWidth;
					}
					continue;
				}
			}
			if(item == null) {
				continue;
			}
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				if(!((js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default))).get_includeInLayout()) {
					continue;
				}
			}
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
			var itemWidth1 = item.get_width();
			if(maxItemWidth < itemWidth1) {
				maxItemWidth = itemWidth1;
			}
			if(this._virtualCache != null) {
				var cacheItem1 = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$VerticalListFixedRowLayout_VirtualCacheItem().default));
				if(cacheItem1 == null) {
					if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
						((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
					}
					cacheItem1 = new (feathers_layout__$VerticalListFixedRowLayout_VirtualCacheItem().default)(itemWidth1,0.0);
					this._virtualCache[i] = cacheItem1;
				}
			}
		}
		if(measurements.maxWidth != null) {
			var maxJustifyWidth = measurements.maxWidth - this._paddingLeft - this._paddingRight;
			if(maxItemWidth > maxJustifyWidth) {
				maxItemWidth = maxJustifyWidth;
			}
		}
		return maxItemWidth;
	},
	calculateViewPortWidth: function(maxItemWidth,measurements) {
		if(measurements.width != null) {
			return measurements.width;
		}
		return maxItemWidth + this._paddingLeft + this._paddingRight;
	},
	calculateRowHeight: function(items,itemWidth) {
		var actualRowHeight = 0.0;
		if(this._rowHeight != null) {
			actualRowHeight = this._rowHeight;
		} else {
			var _g = 0;
			var _g1 = items.length;
			while(_g < _g1) {
				var i = _g++;
				var item = items[i];
				if(item == null) {
					if(this._virtualCache == null || this._virtualCache.length <= i) {
						continue;
					}
					var cacheItem = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$VerticalListFixedRowLayout_VirtualCacheItem().default));
					if(cacheItem == null) {
						continue;
					}
					actualRowHeight = cacheItem.itemHeight;
					break;
				}
				if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
					if(!((js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default))).get_includeInLayout()) {
						continue;
					}
				}
				item.set_width(itemWidth);
				if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
					((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
				}
				actualRowHeight = item.get_height();
				if(this._virtualCache != null) {
					var cacheItem1 = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$VerticalListFixedRowLayout_VirtualCacheItem().default));
					if(cacheItem1 != null && cacheItem1.itemHeight != actualRowHeight) {
						cacheItem1.itemHeight = actualRowHeight;
						(feathers_events_FeathersEvent().default).dispatch(this,"change");
					}
				}
				break;
			}
		}
		return actualRowHeight;
	},
	getVisibleIndices: function(itemCount,width,height,result) {
		var adjustedGap = this._gap;
		var hasFlexGap = this._gap == 1.0 / 0.0;
		if(hasFlexGap) {
			adjustedGap = this._minGap;
		}
		var itemHeight = 0.0;
		if(this._rowHeight != null) {
			itemHeight = this._rowHeight;
		} else if(this._virtualCache != null) {
			var _g = 0;
			while(_g < 6) {
				var i = _g++;
				var cacheItem = this._virtualCache[i];
				if(cacheItem != null) {
					itemHeight = cacheItem.itemHeight;
					break;
				}
			}
		}
		itemHeight += adjustedGap;
		var startIndex = 0;
		var endIndex = 0;
		if(itemHeight > 0.0) {
			startIndex = Math.floor((this._scrollY - this._paddingTop) / itemHeight);
			if(startIndex < 0) {
				startIndex = 0;
			}
			endIndex = startIndex + Math.ceil(height / itemHeight);
			if(endIndex >= itemCount) {
				var oldEndIndex = endIndex;
				endIndex = itemCount - 1;
				startIndex -= oldEndIndex - endIndex;
				if(startIndex < 0) {
					startIndex = 0;
				}
			}
		}
		if(result == null) {
			return new (feathers_layout_VirtualLayoutRange().default)(startIndex,endIndex);
		}
		result.start = startIndex;
		result.end = endIndex;
		return result;
	},
	getNearestScrollPositionForIndex: function(index,itemCount,width,height,result) {
		var adjustedGap = this._gap;
		var hasFlexGap = this._gap == 1.0 / 0.0;
		if(hasFlexGap) {
			adjustedGap = this._minGap;
		}
		var itemHeight = 0.0;
		if(this._rowHeight != null) {
			itemHeight = this._rowHeight;
		} else if(this._virtualCache != null) {
			var _g = 0;
			var _g1 = this._virtualCache;
			while(_g < _g1.length) {
				var cacheItem = _g1[_g];
				++_g;
				if(cacheItem != null) {
					itemHeight = cacheItem.itemHeight;
					break;
				}
			}
		}
		itemHeight += adjustedGap;
		var maxY = this._paddingTop + itemHeight * index;
		var minY = maxY + itemHeight - height;
		var targetY = this._scrollY;
		if(targetY < minY) {
			targetY = minY;
		} else if(targetY > maxY) {
			targetY = maxY;
		}
		if(result == null) {
			result = new (openfl_geom_Point())();
		}
		result.x = this._scrollX;
		result.y = targetY;
		return result;
	},
	findNextKeyboardIndex: function(startIndex,event,wrapArrowKeys,items,indicesToSkip,viewPortWidth,viewPortHeight) {
		if(items.length == 0) {
			return -1;
		}
		var adjustedGap = this._gap;
		var hasFlexGap = this._gap == 1.0 / 0.0;
		if(hasFlexGap) {
			adjustedGap = this._minGap;
		}
		var itemHeight = 0.0;
		if(this._rowHeight != null) {
			itemHeight = this._rowHeight;
		} else if(this._virtualCache != null) {
			var _g = 0;
			var _g1 = this._virtualCache;
			while(_g < _g1.length) {
				var cacheItem = _g1[_g];
				++_g;
				if(cacheItem != null) {
					itemHeight = cacheItem.itemHeight;
					break;
				}
			}
		}
		var maxIndex = items.length - 1;
		var result = startIndex;
		if(result == -1) {
			switch(event.keyCode) {
			case 38:
				result = wrapArrowKeys ? maxIndex : -1;
				break;
			case 40:
				result = 0;
				break;
			default:
				result = -1;
			}
			if(result == -1) {
				return result;
			}
			if(indicesToSkip == null || indicesToSkip.indexOf(result) == -1) {
				return result;
			}
		}
		var needsAnotherPass = true;
		var nextKeyCode = event.keyCode;
		var lastResult = result;
		while(needsAnotherPass) {
			needsAnotherPass = false;
			switch(nextKeyCode) {
			case 33:
				var yPosition = 0.0;
				var i = startIndex;
				while(i >= 0) {
					yPosition += itemHeight;
					if(indicesToSkip != null && indicesToSkip.indexOf(i) != -1) {
						yPosition += adjustedGap;
						--i;
						continue;
					}
					if(yPosition > viewPortHeight) {
						break;
					}
					yPosition += adjustedGap;
					result = i;
					--i;
				}
				nextKeyCode = 38;
				break;
			case 34:
				var yPosition1 = 0.0;
				var _g2 = startIndex;
				var _g11 = items.length;
				while(_g2 < _g11) {
					var i1 = _g2++;
					yPosition1 += itemHeight;
					if(indicesToSkip != null && indicesToSkip.indexOf(i1) != -1) {
						yPosition1 += adjustedGap;
						continue;
					}
					if(yPosition1 > viewPortHeight) {
						break;
					}
					yPosition1 += adjustedGap;
					result = i1;
				}
				nextKeyCode = 40;
				break;
			case 35:
				var i2 = maxIndex;
				while(i2 > startIndex) {
					if(indicesToSkip == null || indicesToSkip.indexOf(i2) == -1) {
						result = i2;
						break;
					}
					--i2;
				}
				break;
			case 36:
				var _g3 = 0;
				var _g12 = startIndex;
				while(_g3 < _g12) {
					var i3 = _g3++;
					if(indicesToSkip == null || indicesToSkip.indexOf(i3) == -1) {
						result = i3;
						break;
					}
				}
				break;
			case 38:
				--result;
				break;
			case 40:
				++result;
				break;
			default:
				return startIndex;
			}
			if(result < 0) {
				if(wrapArrowKeys) {
					result = maxIndex;
				} else {
					result = 0;
				}
			} else if(result > maxIndex) {
				if(wrapArrowKeys) {
					result = 0;
				} else {
					result = maxIndex;
				}
			}
			if(indicesToSkip != null && indicesToSkip.indexOf(result) != -1) {
				if(result == lastResult) {
					return startIndex;
				}
				needsAnotherPass = true;
			}
			lastResult = result;
		}
		return result;
	},
	applyVerticalAlign: function(items,contentHeight,viewPortHeight) {
		var alignOffset = 0.0;
		var gapOffset = 0.0;
		var maxAlignmentHeight = viewPortHeight - this._paddingTop - this._paddingBottom;
		var adjustedGap = this._gap;
		var hasFlexGap = this._gap == 1.0 / 0.0;
		if(hasFlexGap) {
			adjustedGap = this._minGap;
			if(items.length > 1 && maxAlignmentHeight > contentHeight) {
				adjustedGap += (maxAlignmentHeight - contentHeight) / (items.length - 1);
			}
			gapOffset = adjustedGap - this._minGap;
		} else {
			switch(this._verticalAlign._hx_index) {
			case 0:
				alignOffset = 0.0;
				break;
			case 1:
				alignOffset = (maxAlignmentHeight - contentHeight) / 2.0;
				break;
			case 2:
				alignOffset = maxAlignmentHeight - contentHeight;
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown vertical align: " + (Std().default).string(this._verticalAlign)));
			}
			if(alignOffset < 0.0) {
				alignOffset = 0.0;
			}
		}
		if(alignOffset == 0.0 && gapOffset == 0.0) {
			return;
		}
		var totalOffset = alignOffset;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			var layoutObject = null;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				layoutObject = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutObject.get_includeInLayout()) {
					continue;
				}
			}
			if(item != null) {
				item.set_y(Math.max(this._paddingTop,item.get_y() + totalOffset));
			}
			totalOffset += gapOffset;
		}
	}
});
VerticalListFixedRowLayout.prototype.__class__ = VerticalListFixedRowLayout.prototype.constructor = $hxClasses["feathers.layout.VerticalListFixedRowLayout"] = VerticalListFixedRowLayout;

// Init



// Statics




// Export

exports["default"] = VerticalListFixedRowLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/VerticalListLayout.js":
/*!********************************************************!*\
  !*** ./lib/_gen/feathers/layout/VerticalListLayout.js ***!
  \********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.VerticalListLayout

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_layout_IKeyboardNavigationLayout() {return __webpack_require__(/*! ./../../feathers/layout/IKeyboardNavigationLayout */ "./lib/_gen/feathers/layout/IKeyboardNavigationLayout.js");}
function feathers_layout_IVirtualLayout() {return __webpack_require__(/*! ./../../feathers/layout/IVirtualLayout */ "./lib/_gen/feathers/layout/IVirtualLayout.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_layout__$VerticalListLayout_VirtualCacheItem() {return __webpack_require__(/*! ./../../feathers/layout/_VerticalListLayout/VirtualCacheItem */ "./lib/_gen/feathers/layout/_VerticalListLayout/VirtualCacheItem.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_ILayoutObject() {return __webpack_require__(/*! ./../../feathers/layout/ILayoutObject */ "./lib/_gen/feathers/layout/ILayoutObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}
function feathers_events_ScrollEvent() {return __webpack_require__(/*! ./../../feathers/events/ScrollEvent */ "./lib/_gen/feathers/events/ScrollEvent.js");}
function feathers_layout_LayoutBoundsResult() {return __webpack_require__(/*! ./../../feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}
function feathers_layout_VirtualLayoutRange() {return __webpack_require__(/*! ./../../feathers/layout/VirtualLayoutRange */ "./lib/_gen/feathers/layout/VirtualLayoutRange.js");}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}

// Constructor

var VerticalListLayout = function() {
	this._widthResetEnabled = true;
	this._contentJustify = false;
	this._verticalAlign = (feathers_layout_VerticalAlign().default).TOP;
	this._minGap = 0.0;
	this._gap = 0.0;
	this._paddingLeft = 0.0;
	this._paddingBottom = 0.0;
	this._paddingRight = 0.0;
	this._paddingTop = 0.0;
	this._requestedMaxRowCount = null;
	this._requestedMinRowCount = null;
	this._requestedRowCount = null;
	this._scrollY = 0.0;
	this._scrollX = 0.0;
	(openfl_events_EventDispatcher()).call(this);
}

// Meta

VerticalListLayout.__name__ = "feathers.layout.VerticalListLayout";
VerticalListLayout.__isInterface__ = false;
VerticalListLayout.__interfaces__ = [(feathers_layout_IKeyboardNavigationLayout().default),(feathers_layout_IVirtualLayout().default)];
VerticalListLayout.__super__ = (openfl_events_EventDispatcher());
VerticalListLayout.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_scrollX: function() {
		return this._scrollX;
	},
	set_scrollX: function(value) {
		this._scrollX = value;
		return this._scrollX;
	},
	get_scrollY: function() {
		return this._scrollY;
	},
	set_scrollY: function(value) {
		this._scrollY = value;
		return this._scrollY;
	},
	get_virtualCache: function() {
		return this._virtualCache;
	},
	set_virtualCache: function(value) {
		this._virtualCache = value;
		return this._virtualCache;
	},
	get_elasticTop: function() {
		return true;
	},
	get_elasticRight: function() {
		return false;
	},
	get_elasticBottom: function() {
		return true;
	},
	get_elasticLeft: function() {
		return false;
	},
	get_requestedRowCount: function() {
		return this._requestedRowCount;
	},
	set_requestedRowCount: function(value) {
		if(this._requestedRowCount == value) {
			return this._requestedRowCount;
		}
		this._requestedRowCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedRowCount;
	},
	get_requestedMinRowCount: function() {
		return this._requestedMinRowCount;
	},
	set_requestedMinRowCount: function(value) {
		if(this._requestedMinRowCount == value) {
			return this._requestedMinRowCount;
		}
		this._requestedMinRowCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedMinRowCount;
	},
	get_requestedMaxRowCount: function() {
		return this._requestedMaxRowCount;
	},
	set_requestedMaxRowCount: function(value) {
		if(this._requestedMaxRowCount == value) {
			return this._requestedMaxRowCount;
		}
		this._requestedMaxRowCount = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._requestedMaxRowCount;
	},
	get_paddingTop: function() {
		return this._paddingTop;
	},
	set_paddingTop: function(value) {
		if(this._paddingTop == value) {
			return this._paddingTop;
		}
		this._paddingTop = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingTop;
	},
	get_paddingRight: function() {
		return this._paddingRight;
	},
	set_paddingRight: function(value) {
		if(this._paddingRight == value) {
			return this._paddingRight;
		}
		this._paddingRight = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingRight;
	},
	get_paddingBottom: function() {
		return this._paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(this._paddingBottom == value) {
			return this._paddingBottom;
		}
		this._paddingBottom = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingBottom;
	},
	get_paddingLeft: function() {
		return this._paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(this._paddingLeft == value) {
			return this._paddingLeft;
		}
		this._paddingLeft = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._paddingLeft;
	},
	get_gap: function() {
		return this._gap;
	},
	set_gap: function(value) {
		if(this._gap == value) {
			return this._gap;
		}
		this._gap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._gap;
	},
	get_minGap: function() {
		return this._minGap;
	},
	set_minGap: function(value) {
		if(this._minGap == value) {
			return this._minGap;
		}
		this._minGap = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._minGap;
	},
	get_verticalAlign: function() {
		return this._verticalAlign;
	},
	set_verticalAlign: function(value) {
		if(this._verticalAlign == value) {
			return this._verticalAlign;
		}
		this._verticalAlign = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._verticalAlign;
	},
	get_contentJustify: function() {
		return this._contentJustify;
	},
	set_contentJustify: function(value) {
		if(this._contentJustify == value) {
			return this._contentJustify;
		}
		this._contentJustify = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._contentJustify;
	},
	get_widthResetEnabled: function() {
		return this._widthResetEnabled;
	},
	set_widthResetEnabled: function(value) {
		if(this._widthResetEnabled == value) {
			return this._widthResetEnabled;
		}
		this._widthResetEnabled = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._widthResetEnabled;
	},
	setPadding: function(value) {
		this.set_paddingTop(value);
		this.set_paddingRight(value);
		this.set_paddingBottom(value);
		this.set_paddingLeft(value);
	},
	layout: function(items,measurements,result) {
		var adjustedGap = this._gap;
		var hasFlexGap = this._gap == 1.0 / 0.0;
		if(hasFlexGap) {
			adjustedGap = this._minGap;
		}
		var maxItemWidth = this.calculateMaxItemWidth(items,measurements);
		var viewPortWidth = this.calculateViewPortWidth(maxItemWidth,measurements);
		var minItemWidth = viewPortWidth - this._paddingLeft - this._paddingRight;
		var itemWidth = maxItemWidth;
		if(!this._contentJustify || itemWidth < minItemWidth) {
			itemWidth = minItemWidth;
		}
		var virtualRowHeight = this.calculateVirtualRowHeight(items,itemWidth);
		var positionY = this._paddingTop;
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var item = items[i];
			if(item == null) {
				var itemHeight = virtualRowHeight;
				if(this._virtualCache != null) {
					var cacheItem = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$VerticalListLayout_VirtualCacheItem().default));
					if(cacheItem != null && cacheItem.itemHeight != null) {
						itemHeight = cacheItem.itemHeight;
					}
				}
				positionY += itemHeight + adjustedGap;
				continue;
			}
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				if(!((js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default))).get_includeInLayout()) {
					continue;
				}
			}
			item.set_x(this._paddingLeft);
			item.set_y(positionY);
			item.set_width(itemWidth);
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
			var itemHeight1 = item.get_height();
			if(this._virtualCache != null) {
				var cacheItem1 = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$VerticalListLayout_VirtualCacheItem().default));
				if(cacheItem1 != null && (cacheItem1.itemHeight == null || cacheItem1.itemHeight != itemHeight1)) {
					var cachedHeight = cacheItem1.itemHeight;
					cacheItem1.itemHeight = itemHeight1;
					if(cachedHeight == null && positionY < this.get_scrollY()) {
						var offsetY = itemHeight1 - virtualRowHeight;
						(feathers_events_ScrollEvent().default).dispatch(this,"scroll",false,false,0.0,offsetY);
					}
					if(cachedHeight != null || itemHeight1 != virtualRowHeight) {
						(feathers_events_FeathersEvent().default).dispatch(this,"change");
					}
				}
			}
			positionY += itemHeight1 + adjustedGap;
		}
		if(items.length > 0) {
			positionY -= adjustedGap;
		}
		var viewPortHeight = positionY += this._paddingBottom;
		if(measurements.height != null) {
			viewPortHeight = measurements.height;
		} else {
			if(this._requestedRowCount != null) {
				viewPortHeight = this._paddingTop + this._paddingBottom + (this._requestedRowCount * (virtualRowHeight + adjustedGap) - adjustedGap);
			} else if(this._requestedMinRowCount != null && items.length < this._requestedMinRowCount) {
				viewPortHeight = this._paddingTop + this._paddingBottom + (this._requestedMinRowCount * (virtualRowHeight + adjustedGap) - adjustedGap);
			} else if(this._requestedMaxRowCount != null && items.length > this._requestedMaxRowCount) {
				viewPortHeight = this._paddingTop + this._paddingBottom + (this._requestedMaxRowCount * (virtualRowHeight + adjustedGap) - adjustedGap);
			}
			if(measurements.minHeight != null && viewPortHeight < measurements.minHeight) {
				viewPortHeight = measurements.minHeight;
			} else if(measurements.maxHeight != null && viewPortHeight > measurements.maxHeight) {
				viewPortHeight = measurements.maxHeight;
			}
		}
		this.applyVerticalAlign(items,positionY - this._paddingTop - this._paddingBottom,viewPortHeight);
		if(result == null) {
			result = new (feathers_layout_LayoutBoundsResult().default)();
		}
		result.contentX = 0.0;
		result.contentY = 0.0;
		result.contentWidth = itemWidth + this._paddingLeft + this._paddingRight;
		result.contentHeight = positionY;
		if(this._requestedMinRowCount != null) {
			result.contentMinHeight = this._paddingTop + this._paddingBottom + (this._requestedMinRowCount * (virtualRowHeight + adjustedGap) - adjustedGap);
		}
		result.viewPortWidth = viewPortWidth;
		result.viewPortHeight = viewPortHeight;
		return result;
	},
	calculateMaxItemWidth: function(items,measurements) {
		var maxItemWidth = 0.0;
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var item = items[i];
			if(this._virtualCache != null && this._virtualCache.length > i) {
				var cacheItem = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$VerticalListLayout_VirtualCacheItem().default));
				if(cacheItem != null) {
					var itemWidth = cacheItem.itemWidth;
					if(maxItemWidth < itemWidth) {
						maxItemWidth = itemWidth;
					}
					continue;
				}
			}
			if(item == null) {
				continue;
			}
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				if(!((js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default))).get_includeInLayout()) {
					continue;
				}
			}
			if(this._widthResetEnabled && measurements.width == null && (js_Boot().default).__implements(item,(feathers_core_IMeasureObject().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IMeasureObject().default))).resetWidth();
			}
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
			var itemWidth1 = item.get_width();
			if(maxItemWidth < itemWidth1) {
				maxItemWidth = itemWidth1;
			}
			if(this._virtualCache != null) {
				var cacheItem1 = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$VerticalListLayout_VirtualCacheItem().default));
				if(cacheItem1 == null) {
					if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
						((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
					}
					cacheItem1 = new (feathers_layout__$VerticalListLayout_VirtualCacheItem().default)(itemWidth1,null);
					this._virtualCache[i] = cacheItem1;
				}
			}
		}
		if(measurements.maxWidth != null) {
			var maxJustifyWidth = measurements.maxWidth - this._paddingLeft - this._paddingRight;
			if(maxItemWidth > maxJustifyWidth) {
				maxItemWidth = maxJustifyWidth;
			}
		}
		return maxItemWidth;
	},
	calculateViewPortWidth: function(maxItemWidth,measurements) {
		if(measurements.width != null) {
			return measurements.width;
		}
		return maxItemWidth + this._paddingLeft + this._paddingRight;
	},
	calculateVirtualRowHeight: function(items,itemWidth) {
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var item = items[i];
			if(item == null) {
				if(this._virtualCache == null || this._virtualCache.length <= i) {
					continue;
				}
				var cacheItem = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$VerticalListLayout_VirtualCacheItem().default));
				if(cacheItem == null || cacheItem.itemHeight == null) {
					continue;
				}
				return cacheItem.itemHeight;
			}
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				if(!((js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default))).get_includeInLayout()) {
					continue;
				}
			}
			item.set_width(itemWidth);
			if((js_Boot().default).__implements(item,(feathers_core_IValidating().default))) {
				((js_Boot().default).__cast(item , (feathers_core_IValidating().default))).validateNow();
			}
			var itemHeight = item.get_height();
			if(this._virtualCache != null) {
				var cacheItem1 = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$VerticalListLayout_VirtualCacheItem().default));
				if(cacheItem1 != null && (cacheItem1.itemHeight == null || cacheItem1.itemHeight != itemHeight)) {
					cacheItem1.itemHeight = itemHeight;
					(feathers_events_FeathersEvent().default).dispatch(this,"change");
				}
			}
			return itemHeight;
		}
		return 0.0;
	},
	getVisibleIndices: function(itemCount,width,height,result) {
		var adjustedGap = this._gap;
		var hasFlexGap = this._gap == 1.0 / 0.0;
		if(hasFlexGap) {
			adjustedGap = this._minGap;
		}
		var startIndex = -1;
		var endIndex = -1;
		var estimatedItemHeight = null;
		var positionY = this._paddingTop;
		var scrollY = this._scrollY;
		if(scrollY < 0.0) {
			scrollY = 0.0;
		}
		var minItems = 0;
		var maxY = scrollY + height;
		var skippedMissingItems = 0;
		var _g = 0;
		var _g1 = itemCount;
		while(_g < _g1) {
			var i = _g++;
			var itemHeight = 0.0;
			if(this._virtualCache != null) {
				var cacheItem = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$VerticalListLayout_VirtualCacheItem().default));
				if(cacheItem != null && cacheItem.itemHeight != null) {
					itemHeight = cacheItem.itemHeight;
					if(estimatedItemHeight == null) {
						estimatedItemHeight = itemHeight;
						minItems = Math.ceil(height / (estimatedItemHeight + adjustedGap)) + 1;
						if(skippedMissingItems > 0) {
							var _g2 = 0;
							var _g11 = skippedMissingItems;
							while(_g2 < _g11) {
								var j = _g2++;
								positionY += estimatedItemHeight + adjustedGap;
								if(startIndex == -1 && positionY >= scrollY) {
									startIndex = j;
								}
								if(startIndex != -1) {
									endIndex = j;
									if(positionY >= maxY && endIndex - startIndex + 1 >= minItems) {
										break;
									}
								}
							}
							skippedMissingItems = 0;
						}
					}
				} else if(estimatedItemHeight != null) {
					itemHeight = estimatedItemHeight;
				} else {
					if(skippedMissingItems < 5) {
						++skippedMissingItems;
						continue;
					}
					startIndex = 0;
					endIndex = 0;
					break;
				}
			}
			positionY += itemHeight + adjustedGap;
			if(startIndex == -1 && positionY >= scrollY) {
				startIndex = i;
			}
			if(startIndex != -1) {
				endIndex = i;
				if(positionY >= maxY && endIndex - startIndex + 1 >= minItems) {
					break;
				}
			}
		}
		if(startIndex == -1 && this._verticalAlign != (feathers_layout_VerticalAlign().default).TOP) {
			startIndex = itemCount - 1;
			endIndex = startIndex;
		}
		if((positionY < maxY || endIndex - startIndex + 1 < minItems) && startIndex > 0) {
			while(true) {
				--startIndex;
				var itemHeight1 = 0.0;
				if(this._virtualCache != null) {
					var cacheItem1 = (Std().default).downcast(this._virtualCache[startIndex],(feathers_layout__$VerticalListLayout_VirtualCacheItem().default));
					if(cacheItem1 != null && cacheItem1.itemHeight != null) {
						itemHeight1 = cacheItem1.itemHeight;
						if(estimatedItemHeight == null) {
							estimatedItemHeight = itemHeight1;
							minItems = Math.ceil(height / (estimatedItemHeight + adjustedGap)) + 1;
						}
					} else if(estimatedItemHeight != null) {
						itemHeight1 = estimatedItemHeight;
					}
				}
				positionY += itemHeight1 + adjustedGap;
				if(positionY >= maxY && endIndex - startIndex + 1 >= minItems) {
					break;
				}
				if(!(startIndex > 0)) {
					break;
				}
			}
		}
		if(startIndex < 0) {
			startIndex = 0;
		}
		if(estimatedItemHeight == null) {
			endIndex = startIndex;
		} else if(endIndex < 0) {
			endIndex = startIndex;
		}
		if(result == null) {
			return new (feathers_layout_VirtualLayoutRange().default)(startIndex,endIndex);
		}
		result.start = startIndex;
		result.end = endIndex;
		return result;
	},
	getNearestScrollPositionForIndex: function(index,itemCount,width,height,result) {
		var adjustedGap = this._gap;
		var hasFlexGap = this._gap == 1.0 / 0.0;
		if(hasFlexGap) {
			adjustedGap = this._minGap;
		}
		var estimatedItemHeight = null;
		var minY = 0.0;
		var maxY = 0.0;
		var positionY = this._paddingTop;
		var _g = 0;
		var _g1 = itemCount;
		while(_g < _g1) {
			var i = _g++;
			var itemHeight = 0.0;
			if(this._virtualCache != null) {
				var cacheItem = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$VerticalListLayout_VirtualCacheItem().default));
				if(cacheItem != null && cacheItem.itemHeight != null) {
					itemHeight = cacheItem.itemHeight;
					if(estimatedItemHeight == null) {
						estimatedItemHeight = itemHeight;
					}
				} else if(estimatedItemHeight != null) {
					itemHeight = estimatedItemHeight;
				}
			}
			if(i == index) {
				maxY = positionY;
				minY = maxY + itemHeight - height;
				break;
			}
			positionY += itemHeight + adjustedGap;
		}
		var targetY = this._scrollY;
		if(targetY < minY) {
			targetY = minY;
		} else if(targetY > maxY) {
			targetY = maxY;
		}
		if(result == null) {
			result = new (openfl_geom_Point())();
		}
		result.x = this._scrollX;
		result.y = targetY;
		return result;
	},
	findNextKeyboardIndex: function(startIndex,event,wrapArrowKeys,items,indicesToSkip,viewPortWidth,viewPortHeight) {
		if(items.length == 0) {
			return -1;
		}
		var adjustedGap = this._gap;
		var hasFlexGap = this._gap == 1.0 / 0.0;
		if(hasFlexGap) {
			adjustedGap = this._minGap;
		}
		var estimatedItemHeight = null;
		var _g = 0;
		var _g1 = items.length;
		while(_g < _g1) {
			var i = _g++;
			var itemHeight = 0.0;
			if(this._virtualCache != null) {
				var cacheItem = (Std().default).downcast(this._virtualCache[i],(feathers_layout__$VerticalListLayout_VirtualCacheItem().default));
				if(cacheItem != null && cacheItem.itemHeight != null) {
					itemHeight = cacheItem.itemHeight;
					if(estimatedItemHeight == null) {
						estimatedItemHeight = itemHeight;
						break;
					}
				}
			}
		}
		var maxIndex = items.length - 1;
		var result = startIndex;
		if(result == -1) {
			switch(event.keyCode) {
			case 38:
				result = wrapArrowKeys ? maxIndex : -1;
				break;
			case 40:
				result = 0;
				break;
			default:
				result = -1;
			}
			if(result == -1) {
				return result;
			}
			if(indicesToSkip == null || indicesToSkip.indexOf(result) == -1) {
				return result;
			}
		}
		var needsAnotherPass = true;
		var nextKeyCode = event.keyCode;
		var lastResult = result;
		while(needsAnotherPass) {
			needsAnotherPass = false;
			switch(nextKeyCode) {
			case 33:
				var yPosition = 0.0;
				var i1 = startIndex;
				while(i1 >= 0) {
					var item = items[i1];
					var itemHeight1 = estimatedItemHeight;
					if(item == null) {
						if(this._virtualCache != null) {
							var cacheItem1 = (Std().default).downcast(this._virtualCache[i1],(feathers_layout__$VerticalListLayout_VirtualCacheItem().default));
							if(cacheItem1 != null && cacheItem1.itemHeight != null) {
								itemHeight1 = cacheItem1.itemHeight;
							}
						}
					} else {
						itemHeight1 = item.get_height();
					}
					yPosition += itemHeight1;
					if(indicesToSkip != null && indicesToSkip.indexOf(i1) != -1) {
						yPosition += adjustedGap;
						--i1;
						continue;
					}
					if(yPosition > viewPortHeight) {
						break;
					}
					yPosition += adjustedGap;
					result = i1;
					--i1;
				}
				nextKeyCode = 38;
				break;
			case 34:
				var yPosition1 = 0.0;
				var _g2 = startIndex;
				var _g3 = items.length;
				while(_g2 < _g3) {
					var i2 = _g2++;
					var item1 = items[i2];
					var itemHeight2 = estimatedItemHeight;
					if(item1 == null) {
						if(this._virtualCache != null) {
							var cacheItem2 = (Std().default).downcast(this._virtualCache[i2],(feathers_layout__$VerticalListLayout_VirtualCacheItem().default));
							if(cacheItem2 != null && cacheItem2.itemHeight != null) {
								itemHeight2 = cacheItem2.itemHeight;
							}
						}
					} else {
						itemHeight2 = item1.get_height();
					}
					yPosition1 += itemHeight2;
					if(indicesToSkip != null && indicesToSkip.indexOf(i2) != -1) {
						yPosition1 += adjustedGap;
						continue;
					}
					if(yPosition1 > viewPortHeight) {
						break;
					}
					yPosition1 += adjustedGap;
					result = i2;
				}
				nextKeyCode = 40;
				break;
			case 35:
				var i3 = maxIndex;
				while(i3 > startIndex) {
					if(indicesToSkip == null || indicesToSkip.indexOf(i3) == -1) {
						result = i3;
						break;
					}
					--i3;
				}
				break;
			case 36:
				var _g21 = 0;
				var _g31 = startIndex;
				while(_g21 < _g31) {
					var i4 = _g21++;
					if(indicesToSkip == null || indicesToSkip.indexOf(i4) == -1) {
						result = i4;
						break;
					}
				}
				break;
			case 38:
				--result;
				break;
			case 40:
				++result;
				break;
			default:
				return startIndex;
			}
			if(result < 0) {
				if(wrapArrowKeys) {
					result = maxIndex;
				} else {
					result = 0;
				}
			} else if(result > maxIndex) {
				if(wrapArrowKeys) {
					result = 0;
				} else {
					result = maxIndex;
				}
			}
			if(indicesToSkip != null && indicesToSkip.indexOf(result) != -1) {
				if(result == lastResult) {
					return startIndex;
				}
				needsAnotherPass = true;
			}
			lastResult = result;
		}
		return result;
	},
	applyVerticalAlign: function(items,contentHeight,viewPortHeight) {
		var alignOffset = 0.0;
		var gapOffset = 0.0;
		var maxAlignmentHeight = viewPortHeight - this._paddingTop - this._paddingBottom;
		var adjustedGap = this._gap;
		var hasFlexGap = this._gap == 1.0 / 0.0;
		if(hasFlexGap) {
			adjustedGap = this._minGap;
			if(items.length > 1 && maxAlignmentHeight > contentHeight) {
				adjustedGap += (maxAlignmentHeight - contentHeight) / (items.length - 1);
			}
			gapOffset = adjustedGap - this._minGap;
		} else {
			switch(this._verticalAlign._hx_index) {
			case 0:
				alignOffset = 0.0;
				break;
			case 1:
				alignOffset = (maxAlignmentHeight - contentHeight) / 2.0;
				break;
			case 2:
				alignOffset = maxAlignmentHeight - contentHeight;
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown vertical align: " + (Std().default).string(this._verticalAlign)));
			}
			if(alignOffset < 0.0) {
				alignOffset = 0.0;
			}
		}
		if(alignOffset == 0.0 && gapOffset == 0.0) {
			return;
		}
		var totalOffset = alignOffset;
		var _g = 0;
		while(_g < items.length) {
			var item = items[_g];
			++_g;
			var layoutObject = null;
			if((js_Boot().default).__implements(item,(feathers_layout_ILayoutObject().default))) {
				layoutObject = (js_Boot().default).__cast(item , (feathers_layout_ILayoutObject().default));
				if(!layoutObject.get_includeInLayout()) {
					continue;
				}
			}
			if(item != null) {
				item.set_y(Math.max(this._paddingTop,item.get_y() + totalOffset));
			}
			totalOffset += gapOffset;
		}
	}
});
VerticalListLayout.prototype.__class__ = VerticalListLayout.prototype.constructor = $hxClasses["feathers.layout.VerticalListLayout"] = VerticalListLayout;

// Init



// Statics




// Export

exports["default"] = VerticalListLayout;

/***/ }),

/***/ "./lib/_gen/feathers/layout/VirtualLayoutRange.js":
/*!********************************************************!*\
  !*** ./lib/_gen/feathers/layout/VirtualLayoutRange.js ***!
  \********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout.VirtualLayoutRange

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var VirtualLayoutRange = function(start,end) {
	this.start = start;
	this.end = end;
}

// Meta

VirtualLayoutRange.__name__ = "feathers.layout.VirtualLayoutRange";
VirtualLayoutRange.__isInterface__ = false;
VirtualLayoutRange.prototype = {
	
};
VirtualLayoutRange.prototype.__class__ = VirtualLayoutRange.prototype.constructor = $hxClasses["feathers.layout.VirtualLayoutRange"] = VirtualLayoutRange;

// Init



// Statics




// Export

exports["default"] = VirtualLayoutRange;

/***/ }),

/***/ "./lib/_gen/feathers/layout/_AnchorLayout/AbstractAnchor_Impl_.js":
/*!************************************************************************!*\
  !*** ./lib/_gen/feathers/layout/_AnchorLayout/AbstractAnchor_Impl_.js ***!
  \************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout._AnchorLayout.AbstractAnchor_Impl_

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function feathers_layout_Anchor() {return __webpack_require__(/*! ./../../../feathers/layout/Anchor */ "./lib/_gen/feathers/layout/Anchor.js");}

// Constructor

var AbstractAnchor_Impl_ = function(){}

// Meta

AbstractAnchor_Impl_.__name__ = "feathers.layout._AnchorLayout.AbstractAnchor_Impl_";
AbstractAnchor_Impl_.__isInterface__ = false;
AbstractAnchor_Impl_.prototype = {
	
};
AbstractAnchor_Impl_.prototype.__class__ = AbstractAnchor_Impl_.prototype.constructor = $hxClasses["feathers.layout._AnchorLayout.AbstractAnchor_Impl_"] = AbstractAnchor_Impl_;

// Init



// Statics

AbstractAnchor_Impl_.fromPixels = function(pixels) {
	return new (feathers_layout_Anchor().default)(pixels);
}
AbstractAnchor_Impl_.fromDisplayObject = function(relativeTo) {
	return new (feathers_layout_Anchor().default)(0.0,relativeTo);
}


// Export

exports["default"] = AbstractAnchor_Impl_;

/***/ }),

/***/ "./lib/_gen/feathers/layout/_HorizontalListLayout/VirtualCacheItem.js":
/*!****************************************************************************!*\
  !*** ./lib/_gen/feathers/layout/_HorizontalListLayout/VirtualCacheItem.js ***!
  \****************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout._HorizontalListLayout.VirtualCacheItem

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var VirtualCacheItem = function(itemWidth,itemHeight) {
	this.itemWidth = itemWidth;
	this.itemHeight = itemHeight;
}

// Meta

VirtualCacheItem.__name__ = "feathers.layout._HorizontalListLayout.VirtualCacheItem";
VirtualCacheItem.__isInterface__ = false;
VirtualCacheItem.prototype = {
	
};
VirtualCacheItem.prototype.__class__ = VirtualCacheItem.prototype.constructor = $hxClasses["feathers.layout._HorizontalListLayout.VirtualCacheItem"] = VirtualCacheItem;

// Init



// Statics




// Export

exports["default"] = VirtualCacheItem;

/***/ }),

/***/ "./lib/_gen/feathers/layout/_PagedTiledRowsListLayout/VirtualCacheItem.js":
/*!********************************************************************************!*\
  !*** ./lib/_gen/feathers/layout/_PagedTiledRowsListLayout/VirtualCacheItem.js ***!
  \********************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout._PagedTiledRowsListLayout.VirtualCacheItem

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var VirtualCacheItem = function(itemWidth,itemHeight) {
	this.itemWidth = itemWidth;
	this.itemHeight = itemHeight;
}

// Meta

VirtualCacheItem.__name__ = "feathers.layout._PagedTiledRowsListLayout.VirtualCacheItem";
VirtualCacheItem.__isInterface__ = false;
VirtualCacheItem.prototype = {
	
};
VirtualCacheItem.prototype.__class__ = VirtualCacheItem.prototype.constructor = $hxClasses["feathers.layout._PagedTiledRowsListLayout.VirtualCacheItem"] = VirtualCacheItem;

// Init



// Statics




// Export

exports["default"] = VirtualCacheItem;

/***/ }),

/***/ "./lib/_gen/feathers/layout/_TiledRowsListLayout/VirtualCacheItem.js":
/*!***************************************************************************!*\
  !*** ./lib/_gen/feathers/layout/_TiledRowsListLayout/VirtualCacheItem.js ***!
  \***************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout._TiledRowsListLayout.VirtualCacheItem

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var VirtualCacheItem = function(itemWidth,itemHeight) {
	this.itemWidth = itemWidth;
	this.itemHeight = itemHeight;
}

// Meta

VirtualCacheItem.__name__ = "feathers.layout._TiledRowsListLayout.VirtualCacheItem";
VirtualCacheItem.__isInterface__ = false;
VirtualCacheItem.prototype = {
	
};
VirtualCacheItem.prototype.__class__ = VirtualCacheItem.prototype.constructor = $hxClasses["feathers.layout._TiledRowsListLayout.VirtualCacheItem"] = VirtualCacheItem;

// Init



// Statics




// Export

exports["default"] = VirtualCacheItem;

/***/ }),

/***/ "./lib/_gen/feathers/layout/_VerticalListFixedRowLayout/VirtualCacheItem.js":
/*!**********************************************************************************!*\
  !*** ./lib/_gen/feathers/layout/_VerticalListFixedRowLayout/VirtualCacheItem.js ***!
  \**********************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout._VerticalListFixedRowLayout.VirtualCacheItem

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var VirtualCacheItem = function(itemWidth,itemHeight) {
	this.itemWidth = itemWidth;
	this.itemHeight = itemHeight;
}

// Meta

VirtualCacheItem.__name__ = "feathers.layout._VerticalListFixedRowLayout.VirtualCacheItem";
VirtualCacheItem.__isInterface__ = false;
VirtualCacheItem.prototype = {
	
};
VirtualCacheItem.prototype.__class__ = VirtualCacheItem.prototype.constructor = $hxClasses["feathers.layout._VerticalListFixedRowLayout.VirtualCacheItem"] = VirtualCacheItem;

// Init



// Statics




// Export

exports["default"] = VirtualCacheItem;

/***/ }),

/***/ "./lib/_gen/feathers/layout/_VerticalListLayout/VirtualCacheItem.js":
/*!**************************************************************************!*\
  !*** ./lib/_gen/feathers/layout/_VerticalListLayout/VirtualCacheItem.js ***!
  \**************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.layout._VerticalListLayout.VirtualCacheItem

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var VirtualCacheItem = function(itemWidth,itemHeight) {
	this.itemWidth = itemWidth;
	this.itemHeight = itemHeight;
}

// Meta

VirtualCacheItem.__name__ = "feathers.layout._VerticalListLayout.VirtualCacheItem";
VirtualCacheItem.__isInterface__ = false;
VirtualCacheItem.prototype = {
	
};
VirtualCacheItem.prototype.__class__ = VirtualCacheItem.prototype.constructor = $hxClasses["feathers.layout._VerticalListLayout.VirtualCacheItem"] = VirtualCacheItem;

// Init



// Statics




// Export

exports["default"] = VirtualCacheItem;

/***/ }),

/***/ "./lib/_gen/feathers/motion/effects/BaseDelegateEffectContext.js":
/*!***********************************************************************!*\
  !*** ./lib/_gen/feathers/motion/effects/BaseDelegateEffectContext.js ***!
  \***********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.motion.effects.BaseDelegateEffectContext

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_motion_effects_IEffectContext() {return __webpack_require__(/*! ./../../../feathers/motion/effects/IEffectContext */ "./lib/_gen/feathers/motion/effects/IEffectContext.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}

// Constructor

var BaseDelegateEffectContext = function(context) {
	(openfl_events_EventDispatcher()).call(this);
	this._context = context;
	this._context.addEventListener("change",$bind(this,this.baseDelegateEffectContext_context_changeHandler));
	this._context.addEventListener("complete",$bind(this,this.baseDelegateEffectContext_context_completeHandler));
}

// Meta

BaseDelegateEffectContext.__name__ = "feathers.motion.effects.BaseDelegateEffectContext";
BaseDelegateEffectContext.__isInterface__ = false;
BaseDelegateEffectContext.__interfaces__ = [(feathers_motion_effects_IEffectContext())];
BaseDelegateEffectContext.__super__ = (openfl_events_EventDispatcher());
BaseDelegateEffectContext.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_context: function() {
		return this._context;
	},
	get_target: function() {
		return this.get_context().get_target();
	},
	get_duration: function() {
		return this.get_context().get_duration();
	},
	get_position: function() {
		return this.get_context().get_position();
	},
	set_position: function(value) {
		this.get_context().set_position(value);
		return this.get_context().get_position();
	},
	play: function() {
		this._context.play();
	},
	playReverse: function() {
		this._context.playReverse();
	},
	pause: function() {
		this._context.pause();
	},
	stop: function() {
		this._context.stop();
	},
	toEnd: function() {
		this._context.toEnd();
	},
	interrupt: function() {
		this._context.interrupt();
	},
	baseDelegateEffectContext_context_changeHandler: function(event) {
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
	},
	baseDelegateEffectContext_context_completeHandler: function(event) {
		(feathers_events_FeathersEvent().default).dispatch(this,"complete");
	}
});
BaseDelegateEffectContext.prototype.__class__ = BaseDelegateEffectContext.prototype.constructor = $hxClasses["feathers.motion.effects.BaseDelegateEffectContext"] = BaseDelegateEffectContext;

// Init



// Statics




// Export

exports["default"] = BaseDelegateEffectContext;

/***/ }),

/***/ "./lib/_gen/feathers/motion/effects/BaseEffectContext.js":
/*!***************************************************************!*\
  !*** ./lib/_gen/feathers/motion/effects/BaseEffectContext.js ***!
  \***************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.motion.effects.BaseEffectContext

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_motion_effects_IEffectContext() {return __webpack_require__(/*! ./../../../feathers/motion/effects/IEffectContext */ "./lib/_gen/feathers/motion/effects/IEffectContext.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function motion_Actuate() {return (__webpack_require__(/*! motion */ "motion").Actuate);}

// Constructor

var BaseEffectContext = function(target,duration,ease) {
	this._reversed = false;
	this._playing = false;
	this._position = 0.0;
	this._duration = 0.0;
	(openfl_events_EventDispatcher()).call(this);
	this._target = target;
	this._duration = duration;
	this._ease = ease;
}

// Meta

BaseEffectContext.__name__ = "feathers.motion.effects.BaseEffectContext";
BaseEffectContext.__isInterface__ = false;
BaseEffectContext.__interfaces__ = [(feathers_motion_effects_IEffectContext())];
BaseEffectContext.__super__ = (openfl_events_EventDispatcher());
BaseEffectContext.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_target: function() {
		return this._target;
	},
	get_duration: function() {
		return this._duration;
	},
	get_position: function() {
		return this._position;
	},
	set_position: function(value) {
		if(this._position == value) {
			return this._position;
		}
		this._position = value;
		this.updateEffect();
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._position;
	},
	get_ease: function() {
		return this._ease;
	},
	play: function() {
		var _gthis = this;
		if(this._playing && !this._reversed) {
			return;
		}
		if(this._animatePlayback != null) {
			(motion_Actuate()).stop(this._animatePlayback,null,false,false);
			this._animatePlayback = null;
		}
		this._playing = true;
		this._reversed = false;
		var duration = this._duration * (1.0 - this._position);
		this._animatePlayback = (motion_Actuate()).update(function(value) {
			_gthis.set_position(value);
		},duration,[this._position],[1.0]);
		this._animatePlayback.ease(this._ease);
		this._animatePlayback.onComplete($bind(this,this.animatePlayback_onComplete));
	},
	playReverse: function() {
		var _gthis = this;
		if(this._playing && this._reversed) {
			return;
		}
		if(this._animatePlayback != null) {
			(motion_Actuate()).stop(this._animatePlayback,null,false,false);
			this._animatePlayback = null;
		}
		this._playing = true;
		this._reversed = true;
		var duration = this._duration * this._position;
		this._animatePlayback = (motion_Actuate()).update(function(value) {
			_gthis.set_position(value);
		},duration,[this._position],[0.0]);
		this._animatePlayback.ease(this._ease);
		this._animatePlayback.onComplete($bind(this,this.animatePlayback_onComplete));
	},
	pause: function() {
		if(!this._playing) {
			return;
		}
		if(this._animatePlayback != null) {
			(motion_Actuate()).stop(this._animatePlayback,null,false,false);
			this._animatePlayback = null;
		}
		this._playing = false;
	},
	stop: function() {
		this.pause();
		this.cleanupEffect();
		(feathers_events_FeathersEvent().default).dispatch(this,"complete");
	},
	toEnd: function() {
		this.pause();
		this._position = 1.0;
		this.cleanupEffect();
		(feathers_events_FeathersEvent().default).dispatch(this,"complete");
	},
	interrupt: function() {
		this.toEnd();
	},
	prepareEffect: function() {
	},
	updateEffect: function() {
	},
	cleanupEffect: function() {
	},
	animatePlayback_onComplete: function() {
		this._animatePlayback = null;
		this.cleanupEffect();
		(feathers_events_FeathersEvent().default).dispatch(this,"complete");
	}
});
BaseEffectContext.prototype.__class__ = BaseEffectContext.prototype.constructor = $hxClasses["feathers.motion.effects.BaseEffectContext"] = BaseEffectContext;

// Init



// Statics




// Export

exports["default"] = BaseEffectContext;

/***/ }),

/***/ "./lib/_gen/feathers/motion/effects/EffectInterruptBehavior.js":
/*!*********************************************************************!*\
  !*** ./lib/_gen/feathers/motion/effects/EffectInterruptBehavior.js ***!
  \*********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.motion.effects.EffectInterruptBehavior

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var EffectInterruptBehavior = $hxEnums["feathers.motion.effects.EffectInterruptBehavior"] = { __ename__ : "feathers.motion.effects.EffectInterruptBehavior", __constructs__ : ["END","STOP"]
  ,STOP: {_hx_index:1,__enum__:"feathers.motion.effects.EffectInterruptBehavior",toString:$estr}
  ,END: {_hx_index:0,__enum__:"feathers.motion.effects.EffectInterruptBehavior",toString:$estr}
};

exports["default"] = EffectInterruptBehavior;

/***/ }),

/***/ "./lib/_gen/feathers/motion/effects/EventToPositionEffectContext.js":
/*!**************************************************************************!*\
  !*** ./lib/_gen/feathers/motion/effects/EventToPositionEffectContext.js ***!
  \**************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.motion.effects.EventToPositionEffectContext

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_motion_effects_BaseDelegateEffectContext() {return __webpack_require__(/*! ./../../../feathers/motion/effects/BaseDelegateEffectContext */ "./lib/_gen/feathers/motion/effects/BaseDelegateEffectContext.js");}

// Constructor

var EventToPositionEffectContext = function(context,dispatcher,eventType,callback) {
	this._paused = true;
	(feathers_motion_effects_BaseDelegateEffectContext()).call(this,context);
	this.set_callback(callback);
	this.set_eventType(eventType);
	this.set_dispatcher(dispatcher);
}

// Meta

EventToPositionEffectContext.__name__ = "feathers.motion.effects.EventToPositionEffectContext";
EventToPositionEffectContext.__isInterface__ = false;
EventToPositionEffectContext.__super__ = (feathers_motion_effects_BaseDelegateEffectContext());
EventToPositionEffectContext.prototype = $extend((feathers_motion_effects_BaseDelegateEffectContext()).prototype, {
	get_dispatcher: function() {
		return this._dispatcher;
	},
	set_dispatcher: function(value) {
		if(this._dispatcher == value) {
			return this._dispatcher;
		}
		this.clearEvent();
		this._dispatcher = value;
		this.updateEvent();
		return this.get_dispatcher();
	},
	get_eventType: function() {
		return this._eventType;
	},
	set_eventType: function(value) {
		if(this._eventType == value) {
			return this._eventType;
		}
		this.clearEvent();
		this._eventType = value;
		this.updateEvent();
		return this._eventType;
	},
	get_callback: function() {
		return this._callback;
	},
	set_callback: function(value) {
		if(this._callback == value) {
			return this._callback;
		}
		this._callback = value;
		return this._callback;
	},
	play: function() {
		this._paused = false;
	},
	playReverse: function() {
		this._paused = false;
	},
	pause: function() {
		this._paused = true;
	},
	clearEvent: function() {
		if(this._dispatcher == null || this._eventType == null) {
			return;
		}
		this._dispatcher.removeEventListener(this._eventType,$bind(this,this.eventToPositionEffectContext_dispatcher_eventHandler));
	},
	updateEvent: function() {
		if(this._dispatcher == null || this._eventType == null) {
			return;
		}
		this._dispatcher.addEventListener(this._eventType,$bind(this,this.eventToPositionEffectContext_dispatcher_eventHandler),false,0,true);
	},
	eventToPositionEffectContext_dispatcher_eventHandler: function(event) {
		if(this._paused) {
			return;
		}
		this.set_position(this._callback(event));
	}
});
EventToPositionEffectContext.prototype.__class__ = EventToPositionEffectContext.prototype.constructor = $hxClasses["feathers.motion.effects.EventToPositionEffectContext"] = EventToPositionEffectContext;

// Init



// Statics




// Export

exports["default"] = EventToPositionEffectContext;

/***/ }),

/***/ "./lib/_gen/feathers/motion/effects/IEffectContext.js":
/*!************************************************************!*\
  !*** ./lib/_gen/feathers/motion/effects/IEffectContext.js ***!
  \************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.motion.effects.IEffectContext

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function openfl_events_IEventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.IEventDispatcher);}

// Constructor

var IEffectContext = function() {}

// Meta

IEffectContext.__name__ = "feathers.motion.effects.IEffectContext";
IEffectContext.__isInterface__ = true;
IEffectContext.__interfaces__ = [(openfl_events_IEventDispatcher())];
IEffectContext.prototype = {
	
};
IEffectContext.prototype.__class__ = IEffectContext.prototype.constructor = $hxClasses["feathers.motion.effects.IEffectContext"] = IEffectContext;

// Init



// Statics




// Export

exports["default"] = IEffectContext;

/***/ }),

/***/ "./lib/_gen/feathers/motion/effects/NoOpEffectContext.js":
/*!***************************************************************!*\
  !*** ./lib/_gen/feathers/motion/effects/NoOpEffectContext.js ***!
  \***************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.motion.effects.NoOpEffectContext

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_motion_effects_IEffectContext() {return __webpack_require__(/*! ./../../../feathers/motion/effects/IEffectContext */ "./lib/_gen/feathers/motion/effects/IEffectContext.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_RangeError() {return (__webpack_require__(/*! openfl */ "openfl").errors.RangeError);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}

// Constructor

var NoOpEffectContext = function(target) {
	this._position = 0.0;
	this._duration = 0.0;
	(openfl_events_EventDispatcher()).call(this);
	this._target = target;
}

// Meta

NoOpEffectContext.__name__ = "feathers.motion.effects.NoOpEffectContext";
NoOpEffectContext.__isInterface__ = false;
NoOpEffectContext.__interfaces__ = [(feathers_motion_effects_IEffectContext())];
NoOpEffectContext.__super__ = (openfl_events_EventDispatcher());
NoOpEffectContext.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_target: function() {
		return this._target;
	},
	get_duration: function() {
		return this._duration;
	},
	get_position: function() {
		return this._position;
	},
	set_position: function(value) {
		if(value != 0.0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Position must always be 0.0"));
		}
		return this._position;
	},
	play: function() {
		this.toEnd();
	},
	pause: function() {
	},
	playReverse: function() {
		this.toEnd();
	},
	stop: function() {
		this.toEnd();
	},
	toEnd: function() {
		(feathers_events_FeathersEvent().default).dispatch(this,"complete");
	},
	interrupt: function() {
		this.toEnd();
	}
});
NoOpEffectContext.prototype.__class__ = NoOpEffectContext.prototype.constructor = $hxClasses["feathers.motion.effects.NoOpEffectContext"] = NoOpEffectContext;

// Init



// Statics




// Export

exports["default"] = NoOpEffectContext;

/***/ }),

/***/ "./lib/_gen/feathers/motion/effects/actuate/ActuateEffectContext.js":
/*!**************************************************************************!*\
  !*** ./lib/_gen/feathers/motion/effects/actuate/ActuateEffectContext.js ***!
  \**************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.motion.effects.actuate.ActuateEffectContext

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_motion_effects_BaseEffectContext() {return __webpack_require__(/*! ./../../../../feathers/motion/effects/BaseEffectContext */ "./lib/_gen/feathers/motion/effects/BaseEffectContext.js");}
function feathers_motion_effects_EffectInterruptBehavior() {return __webpack_require__(/*! ./../../../../feathers/motion/effects/EffectInterruptBehavior */ "./lib/_gen/feathers/motion/effects/EffectInterruptBehavior.js");}
function Reflect() {return __webpack_require__(/*! ./../../../../Reflect */ "./lib/_gen/Reflect.js");}
function motion_easing_Linear() {return (__webpack_require__(/*! motion */ "motion").easing.Linear);}

// Constructor

var ActuateEffectContext = function(target,actuator,interruptBehavior) {
	if(interruptBehavior == null) {
		interruptBehavior = (feathers_motion_effects_EffectInterruptBehavior()).END;
	}
	this._actuator = actuator;
	this.interruptBehavior = interruptBehavior;
	var originalEase = this._actuator.getEase();
	this._actuator.ease((motion_easing_Linear()).get_easeNone());
	this._onComplete = this._actuator.getOnComplete();
	this._onCompleteParams = this._actuator.getOnCompleteParams();
	this._actuator.onComplete(null,null);
	if(target == null) {
		target = this._actuator.getTarget();
	}
	(feathers_motion_effects_BaseEffectContext()).call(this,target,this._actuator.getDuration(),originalEase);
}

// Meta

ActuateEffectContext.__name__ = "feathers.motion.effects.actuate.ActuateEffectContext";
ActuateEffectContext.__isInterface__ = false;
ActuateEffectContext.__super__ = (feathers_motion_effects_BaseEffectContext());
ActuateEffectContext.prototype = $extend((feathers_motion_effects_BaseEffectContext()).prototype, {
	get_actuator: function() {
		return this._actuator;
	},
	interrupt: function() {
		if(this.interruptBehavior == (feathers_motion_effects_EffectInterruptBehavior()).STOP) {
			this.stop();
			return;
		}
		this.toEnd();
	},
	updateEffect: function() {
		this._actuator.goto(this.get_position());
	},
	cleanupEffect: function() {
		if(this._onComplete != null) {
			var params = this._onCompleteParams;
			if(params == null) {
				params = [];
			}
			(Reflect().default).callMethod(this._onComplete,this._onComplete,params);
		}
	}
});
ActuateEffectContext.prototype.__class__ = ActuateEffectContext.prototype.constructor = $hxClasses["feathers.motion.effects.actuate.ActuateEffectContext"] = ActuateEffectContext;

// Init



// Statics




// Export

exports["default"] = ActuateEffectContext;

/***/ }),

/***/ "./lib/_gen/feathers/motion/effects/actuate/ActuateForEffects.js":
/*!***********************************************************************!*\
  !*** ./lib/_gen/feathers/motion/effects/actuate/ActuateForEffects.js ***!
  \***********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.motion.effects.actuate.ActuateForEffects

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function motion_Actuate() {return (__webpack_require__(/*! motion */ "motion").Actuate);}
function feathers_motion_effects_actuate_SimpleEffectActuator() {return __webpack_require__(/*! ./../../../../feathers/motion/effects/actuate/SimpleEffectActuator */ "./lib/_gen/feathers/motion/effects/actuate/SimpleEffectActuator.js");}
function js_Boot() {return __webpack_require__(/*! ./../../../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_motion_effects_actuate_IReadableGenericActuator() {return __webpack_require__(/*! ./../../../../feathers/motion/effects/actuate/IReadableGenericActuator */ "./lib/_gen/feathers/motion/effects/actuate/IReadableGenericActuator.js");}
function feathers_motion_effects_actuate_MethodEffectActuator() {return __webpack_require__(/*! ./../../../../feathers/motion/effects/actuate/MethodEffectActuator */ "./lib/_gen/feathers/motion/effects/actuate/MethodEffectActuator.js");}

// Constructor

var ActuateForEffects = function(){}

// Meta

ActuateForEffects.__name__ = "feathers.motion.effects.actuate.ActuateForEffects";
ActuateForEffects.__isInterface__ = false;
ActuateForEffects.prototype = {
	
};
ActuateForEffects.prototype.__class__ = ActuateForEffects.prototype.constructor = $hxClasses["feathers.motion.effects.actuate.ActuateForEffects"] = ActuateForEffects;

// Init



// Statics

ActuateForEffects.tween = function(target,duration,properties,overwrite) {
	if(overwrite == null) {
		overwrite = true;
	}
	var result = (motion_Actuate()).tween(target,duration,properties,overwrite,(feathers_motion_effects_actuate_SimpleEffectActuator()));
	return (js_Boot().default).__cast(result , (feathers_motion_effects_actuate_IReadableGenericActuator()));
}
ActuateForEffects.update = function(target,duration,start,end,overwrite) {
	if(overwrite == null) {
		overwrite = true;
	}
	var properties = { start : start, end : end};
	var result = (motion_Actuate()).tween(target,duration,properties,overwrite,(feathers_motion_effects_actuate_MethodEffectActuator()));
	return (js_Boot().default).__cast(result , (feathers_motion_effects_actuate_IReadableGenericActuator()));
}


// Export

exports["default"] = ActuateForEffects;

/***/ }),

/***/ "./lib/_gen/feathers/motion/effects/actuate/IGotoActuator.js":
/*!*******************************************************************!*\
  !*** ./lib/_gen/feathers/motion/effects/actuate/IGotoActuator.js ***!
  \*******************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.motion.effects.actuate.IGotoActuator

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function motion_actuators_IGenericActuator() {return (__webpack_require__(/*! motion */ "motion").actuators.IGenericActuator);}

// Constructor

var IGotoActuator = function() {}

// Meta

IGotoActuator.__name__ = "feathers.motion.effects.actuate.IGotoActuator";
IGotoActuator.__isInterface__ = true;
IGotoActuator.__interfaces__ = [(motion_actuators_IGenericActuator())];
IGotoActuator.prototype = {
	
};
IGotoActuator.prototype.__class__ = IGotoActuator.prototype.constructor = $hxClasses["feathers.motion.effects.actuate.IGotoActuator"] = IGotoActuator;

// Init



// Statics




// Export

exports["default"] = IGotoActuator;

/***/ }),

/***/ "./lib/_gen/feathers/motion/effects/actuate/IReadableGenericActuator.js":
/*!******************************************************************************!*\
  !*** ./lib/_gen/feathers/motion/effects/actuate/IReadableGenericActuator.js ***!
  \******************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.motion.effects.actuate.IReadableGenericActuator

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_motion_effects_actuate_IGotoActuator() {return __webpack_require__(/*! ./../../../../feathers/motion/effects/actuate/IGotoActuator */ "./lib/_gen/feathers/motion/effects/actuate/IGotoActuator.js");}
function motion_actuators_IGenericActuator() {return (__webpack_require__(/*! motion */ "motion").actuators.IGenericActuator);}

// Constructor

var IReadableGenericActuator = function() {}

// Meta

IReadableGenericActuator.__name__ = "feathers.motion.effects.actuate.IReadableGenericActuator";
IReadableGenericActuator.__isInterface__ = true;
IReadableGenericActuator.__interfaces__ = [(feathers_motion_effects_actuate_IGotoActuator()),(motion_actuators_IGenericActuator())];
IReadableGenericActuator.prototype = {
	
};
IReadableGenericActuator.prototype.__class__ = IReadableGenericActuator.prototype.constructor = $hxClasses["feathers.motion.effects.actuate.IReadableGenericActuator"] = IReadableGenericActuator;

// Init



// Statics




// Export

exports["default"] = IReadableGenericActuator;

/***/ }),

/***/ "./lib/_gen/feathers/motion/effects/actuate/MethodEffectActuator.js":
/*!**************************************************************************!*\
  !*** ./lib/_gen/feathers/motion/effects/actuate/MethodEffectActuator.js ***!
  \**************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.motion.effects.actuate.MethodEffectActuator

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_motion_effects_actuate_IReadableGenericActuator() {return __webpack_require__(/*! ./../../../../feathers/motion/effects/actuate/IReadableGenericActuator */ "./lib/_gen/feathers/motion/effects/actuate/IReadableGenericActuator.js");}
function motion_actuators_MethodActuator() {return (__webpack_require__(/*! motion */ "motion").actuators.MethodActuator);}
function Reflect() {return __webpack_require__(/*! ./../../../../Reflect */ "./lib/_gen/Reflect.js");}

// Constructor

var MethodEffectActuator = function(target,duration,properties) {
	(motion_actuators_MethodActuator()).call(this,target,duration,properties);
}

// Meta

MethodEffectActuator.__name__ = "feathers.motion.effects.actuate.MethodEffectActuator";
MethodEffectActuator.__isInterface__ = false;
MethodEffectActuator.__interfaces__ = [(feathers_motion_effects_actuate_IReadableGenericActuator())];
MethodEffectActuator.__super__ = (motion_actuators_MethodActuator());
MethodEffectActuator.prototype = $extend((motion_actuators_MethodActuator()).prototype, {
	getTarget: function() {
		return this.target;
	},
	getDuration: function() {
		return this.duration;
	},
	getEase: function() {
		return this._ease;
	},
	getAutoVisible: function() {
		return this._autoVisible;
	},
	getDelay: function() {
		return this._delay;
	},
	getReflect: function() {
		return this._reflect;
	},
	getRepeat: function() {
		return this._repeat;
	},
	getReverse: function() {
		return this._reverse;
	},
	getSmartRotation: function() {
		return this._smartRotation;
	},
	getSnapping: function() {
		return this._snapping;
	},
	getOnComplete: function() {
		return this._onComplete;
	},
	getOnCompleteParams: function() {
		return this._onCompleteParams;
	},
	getOnRepeat: function() {
		return this._onRepeat;
	},
	getOnRepeatParams: function() {
		return this._onRepeatParams;
	},
	getOnUpdate: function() {
		return this._onUpdate;
	},
	getOnUpdateParams: function() {
		return this._onUpdateParams;
	},
	getOnPause: function() {
		return this._onPause;
	},
	getOnPauseParams: function() {
		return this._onPauseParams;
	},
	getOnResume: function() {
		return this._onResume;
	},
	getOnResumeParams: function() {
		return this._onResumeParams;
	},
	goto: function(tweenPosition) {
		var details;
		var easing;
		var i;
		if(!this.initialized) {
			this.initialize();
		}
		if(!this.special) {
			easing = this._ease.calculate(tweenPosition);
			var _g = 0;
			var _g1 = this.detailsLength;
			while(_g < _g1) {
				var i1 = _g++;
				details = this.propertyDetails[i1];
				this.setProperty(details,details.start + details.change * easing);
			}
		} else {
			if(!this._reverse) {
				easing = this._ease.calculate(tweenPosition);
			} else {
				easing = this._ease.calculate(1 - tweenPosition);
			}
			var endValue;
			var _g2 = 0;
			var _g11 = this.detailsLength;
			while(_g2 < _g11) {
				var i2 = _g2++;
				details = this.propertyDetails[i2];
				if(this._smartRotation && (details.propertyName == "rotation" || details.propertyName == "rotationX" || details.propertyName == "rotationY" || details.propertyName == "rotationZ")) {
					var rotation = details.change % 360;
					if(rotation > 180) {
						rotation -= 360;
					} else if(rotation < -180) {
						rotation += 360;
					}
					endValue = details.start + rotation * easing;
				} else {
					endValue = details.start + details.change * easing;
				}
				if(!this._snapping) {
					this.setProperty(details,endValue);
				} else {
					this.setProperty(details,Math.round(endValue));
				}
			}
		}
		var _g3 = 0;
		var _g12 = this.properties.start.length;
		while(_g3 < _g12) {
			var i3 = _g3++;
			this.currentParameters[i3] = (Reflect().default).field(this.tweenProperties,"param" + i3);
		}
		this.callMethod(this.target,this.currentParameters);
	},
	update: function(currentTime) {
		if(!this.paused) {
			var tweenPosition = (currentTime - this.timeOffset) / this.duration;
			if(tweenPosition > 1) {
				tweenPosition = 1;
			}
			this.goto(tweenPosition);
			if(tweenPosition == 1) {
				if(this._repeat == 0) {
					this.active = false;
					if(this.toggleVisible && this.getField(this.target,"alpha") == 0) {
						this.setField(this.target,"visible",false);
					}
					this.complete(true);
					return;
				} else {
					if(this._onRepeat != null) {
						this.callMethod(this._onRepeat,this._onRepeatParams);
					}
					if(this._reflect) {
						this._reverse = !this._reverse;
					}
					this.startTime = currentTime;
					this.timeOffset = this.startTime + this._delay;
					if(this._repeat > 0) {
						this._repeat--;
					}
				}
			}
			if(this.sendChange) {
				this.change();
			}
		}
	}
});
MethodEffectActuator.prototype.__class__ = MethodEffectActuator.prototype.constructor = $hxClasses["feathers.motion.effects.actuate.MethodEffectActuator"] = MethodEffectActuator;

// Init



// Statics




// Export

exports["default"] = MethodEffectActuator;

/***/ }),

/***/ "./lib/_gen/feathers/motion/effects/actuate/SimpleEffectActuator.js":
/*!**************************************************************************!*\
  !*** ./lib/_gen/feathers/motion/effects/actuate/SimpleEffectActuator.js ***!
  \**************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.motion.effects.actuate.SimpleEffectActuator

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_motion_effects_actuate_IReadableGenericActuator() {return __webpack_require__(/*! ./../../../../feathers/motion/effects/actuate/IReadableGenericActuator */ "./lib/_gen/feathers/motion/effects/actuate/IReadableGenericActuator.js");}
function motion_actuators_SimpleActuator() {return (__webpack_require__(/*! motion */ "motion").actuators.SimpleActuator);}

// Constructor

var SimpleEffectActuator = function(target,duration,properties) {
	(motion_actuators_SimpleActuator()).call(this,target,duration,properties);
}

// Meta

SimpleEffectActuator.__name__ = "feathers.motion.effects.actuate.SimpleEffectActuator";
SimpleEffectActuator.__isInterface__ = false;
SimpleEffectActuator.__interfaces__ = [(feathers_motion_effects_actuate_IReadableGenericActuator())];
SimpleEffectActuator.__super__ = (motion_actuators_SimpleActuator());
SimpleEffectActuator.prototype = $extend((motion_actuators_SimpleActuator()).prototype, {
	getTarget: function() {
		return this.target;
	},
	getDuration: function() {
		return this.duration;
	},
	getEase: function() {
		return this._ease;
	},
	getAutoVisible: function() {
		return this._autoVisible;
	},
	getDelay: function() {
		return this._delay;
	},
	getReflect: function() {
		return this._reflect;
	},
	getRepeat: function() {
		return this._repeat;
	},
	getReverse: function() {
		return this._reverse;
	},
	getSmartRotation: function() {
		return this._smartRotation;
	},
	getSnapping: function() {
		return this._snapping;
	},
	getOnComplete: function() {
		return this._onComplete;
	},
	getOnCompleteParams: function() {
		return this._onCompleteParams;
	},
	getOnRepeat: function() {
		return this._onRepeat;
	},
	getOnRepeatParams: function() {
		return this._onRepeatParams;
	},
	getOnUpdate: function() {
		return this._onUpdate;
	},
	getOnUpdateParams: function() {
		return this._onUpdateParams;
	},
	getOnPause: function() {
		return this._onPause;
	},
	getOnPauseParams: function() {
		return this._onPauseParams;
	},
	getOnResume: function() {
		return this._onResume;
	},
	getOnResumeParams: function() {
		return this._onResumeParams;
	},
	goto: function(tweenPosition) {
		var details;
		var easing;
		var i;
		if(!this.initialized) {
			this.initialize();
		}
		if(!this.special) {
			easing = this._ease.calculate(tweenPosition);
			var _g = 0;
			var _g1 = this.detailsLength;
			while(_g < _g1) {
				var i1 = _g++;
				details = this.propertyDetails[i1];
				this.setProperty(details,details.start + details.change * easing);
			}
		} else {
			if(!this._reverse) {
				easing = this._ease.calculate(tweenPosition);
			} else {
				easing = this._ease.calculate(1 - tweenPosition);
			}
			var endValue;
			var _g2 = 0;
			var _g11 = this.detailsLength;
			while(_g2 < _g11) {
				var i2 = _g2++;
				details = this.propertyDetails[i2];
				if(this._smartRotation && (details.propertyName == "rotation" || details.propertyName == "rotationX" || details.propertyName == "rotationY" || details.propertyName == "rotationZ")) {
					var rotation = details.change % 360;
					if(rotation > 180) {
						rotation -= 360;
					} else if(rotation < -180) {
						rotation += 360;
					}
					endValue = details.start + rotation * easing;
				} else {
					endValue = details.start + details.change * easing;
				}
				if(!this._snapping) {
					this.setProperty(details,endValue);
				} else {
					this.setProperty(details,Math.round(endValue));
				}
			}
		}
	},
	update: function(currentTime) {
		if(!this.paused) {
			var tweenPosition = (currentTime - this.timeOffset) / this.duration;
			if(tweenPosition > 1) {
				tweenPosition = 1;
			}
			this.goto(tweenPosition);
			if(tweenPosition == 1) {
				if(this._repeat == 0) {
					this.active = false;
					if(this.toggleVisible && this.getField(this.target,"alpha") == 0) {
						this.setField(this.target,"visible",false);
					}
					this.complete(true);
					return;
				} else {
					if(this._onRepeat != null) {
						this.callMethod(this._onRepeat,this._onRepeatParams);
					}
					if(this._reflect) {
						this._reverse = !this._reverse;
					}
					this.startTime = currentTime;
					this.timeOffset = this.startTime + this._delay;
					if(this._repeat > 0) {
						this._repeat--;
					}
				}
			}
			if(this.sendChange) {
				this.change();
			}
		}
	}
});
SimpleEffectActuator.prototype.__class__ = SimpleEffectActuator.prototype.constructor = $hxClasses["feathers.motion.effects.actuate.SimpleEffectActuator"] = SimpleEffectActuator;

// Init



// Statics




// Export

exports["default"] = SimpleEffectActuator;

/***/ }),

/***/ "./lib/_gen/feathers/motion/transitions/ColorFadeTransitionBuilder.js":
/*!****************************************************************************!*\
  !*** ./lib/_gen/feathers/motion/transitions/ColorFadeTransitionBuilder.js ***!
  \****************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.motion.transitions.ColorFadeTransitionBuilder

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function openfl_display_Shape() {return (__webpack_require__(/*! openfl */ "openfl").display.Shape);}
function feathers_motion_effects_actuate_ActuateForEffects() {return __webpack_require__(/*! ./../../../feathers/motion/effects/actuate/ActuateForEffects */ "./lib/_gen/feathers/motion/effects/actuate/ActuateForEffects.js");}
function motion_Actuate() {return (__webpack_require__(/*! motion */ "motion").Actuate);}
function feathers_motion_effects_actuate_ActuateEffectContext() {return __webpack_require__(/*! ./../../../feathers/motion/effects/actuate/ActuateEffectContext */ "./lib/_gen/feathers/motion/effects/actuate/ActuateEffectContext.js");}

// Constructor

var ColorFadeTransitionBuilder = function(color,duration,ease) {
	if(duration == null) {
		duration = 0.5;
	}
	if(color == null) {
		color = 0;
	}
	this._color = color;
	this._duration = duration;
	this._ease = ease;
}

// Meta

ColorFadeTransitionBuilder.__name__ = "feathers.motion.transitions.ColorFadeTransitionBuilder";
ColorFadeTransitionBuilder.__isInterface__ = false;
ColorFadeTransitionBuilder.prototype = {
	setBlack: function() {
		this._color = 0;
		return this;
	},
	setWhite: function() {
		this._color = 16777215;
		return this;
	},
	setColor: function(color) {
		this._color = color;
		return this;
	},
	setDuration: function(duration) {
		this._duration = duration;
		return this;
	},
	setEase: function(ease) {
		this._ease = ease;
		return this;
	},
	setInterruptBehavior: function(interruptBehavior) {
		this._interruptBehavior = interruptBehavior;
		return this;
	},
	build: function() {
		var color = this._color;
		var duration = this._duration;
		var ease = this._ease;
		var interruptBehavior = this._interruptBehavior;
		return function(oldView,newView) {
			if(oldView == null && newView == null) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())(ColorFadeTransitionBuilder.VIEW_REQUIRED_ERROR));
			}
			var parent = null;
			var width = 0.0;
			var height = 0.0;
			if(oldView != null) {
				parent = oldView.parent;
				width = oldView.get_width();
				height = oldView.get_height();
			}
			if(newView != null) {
				parent = newView.parent;
				width = Math.max(width,newView.get_width());
				height = Math.max(height,newView.get_height());
				newView.set_visible(false);
			}
			var overlay = new (openfl_display_Shape())();
			overlay.get_graphics().beginFill(color);
			overlay.get_graphics().drawRect(0.0,0.0,width,height);
			overlay.get_graphics().endFill();
			overlay.set_alpha(0.0);
			parent.addChild(overlay);
			var actuator = (feathers_motion_effects_actuate_ActuateForEffects()).update(function(ratio) {
				if(ratio < 0.5) {
					if(oldView != null) {
						oldView.set_visible(true);
					}
					if(newView != null) {
						newView.set_visible(false);
					}
					return overlay.set_alpha(ratio * 2.0);
				} else {
					if(oldView != null) {
						oldView.set_visible(false);
					}
					if(newView != null) {
						newView.set_visible(true);
					}
					return overlay.set_alpha((1.0 - ratio) * 2.0);
				}
			},duration,[0.0],[1.0]);
			if(ease != null) {
				actuator.ease(ease);
			}
			actuator.onComplete(function() {
				if(oldView != null) {
					oldView.set_visible(true);
				}
				if(newView != null) {
					newView.set_visible(true);
				}
				return parent.removeChild(overlay);
			});
			(motion_Actuate()).pause(actuator);
			return new (feathers_motion_effects_actuate_ActuateEffectContext())(null,actuator,interruptBehavior);
		};
	}
};
ColorFadeTransitionBuilder.prototype.__class__ = ColorFadeTransitionBuilder.prototype.constructor = $hxClasses["feathers.motion.transitions.ColorFadeTransitionBuilder"] = ColorFadeTransitionBuilder;

// Init



// Statics


ColorFadeTransitionBuilder.VIEW_REQUIRED_ERROR = "Cannot transition if both old view and new view are null."

// Export

exports["default"] = ColorFadeTransitionBuilder;

/***/ }),

/***/ "./lib/_gen/feathers/motion/transitions/CoverTransitionBuilder.js":
/*!************************************************************************!*\
  !*** ./lib/_gen/feathers/motion/transitions/CoverTransitionBuilder.js ***!
  \************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.motion.transitions.CoverTransitionBuilder

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function feathers_motion_effects_actuate_ActuateForEffects() {return __webpack_require__(/*! ./../../../feathers/motion/effects/actuate/ActuateForEffects */ "./lib/_gen/feathers/motion/effects/actuate/ActuateForEffects.js");}
function motion_Actuate() {return (__webpack_require__(/*! motion */ "motion").Actuate);}
function feathers_motion_effects_actuate_ActuateEffectContext() {return __webpack_require__(/*! ./../../../feathers/motion/effects/actuate/ActuateEffectContext */ "./lib/_gen/feathers/motion/effects/actuate/ActuateEffectContext.js");}

// Constructor

var CoverTransitionBuilder = function(angleDegrees,duration,ease) {
	if(duration == null) {
		duration = 0.5;
	}
	if(angleDegrees == null) {
		angleDegrees = 0.0;
	}
	this._angle = angleDegrees;
	this._duration = duration;
	this._ease = ease;
}

// Meta

CoverTransitionBuilder.__name__ = "feathers.motion.transitions.CoverTransitionBuilder";
CoverTransitionBuilder.__isInterface__ = false;
CoverTransitionBuilder.prototype = {
	setAngle: function(angleDegrees) {
		this._angle = angleDegrees;
		return this;
	},
	setRadians: function(angleRadians) {
		this._angle = angleRadians * 180.0 / Math.PI;
		return this;
	},
	setUp: function() {
		this._angle = 90.0;
		return this;
	},
	setDown: function() {
		this._angle = 270.0;
		return this;
	},
	setLeft: function() {
		this._angle = 180.0;
		return this;
	},
	setRight: function() {
		this._angle = 0.0;
		return this;
	},
	setDuration: function(duration) {
		this._duration = duration;
		return this;
	},
	setEase: function(ease) {
		this._ease = ease;
		return this;
	},
	setInterruptBehavior: function(interruptBehavior) {
		this._interruptBehavior = interruptBehavior;
		return this;
	},
	build: function() {
		var angle = this._angle % 360.0;
		if(angle < 0.0) {
			angle += 360.0;
		}
		var duration = this._duration;
		var ease = this._ease;
		var interruptBehavior = this._interruptBehavior;
		return function(oldView,newView) {
			if(oldView == null && newView == null) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())(CoverTransitionBuilder.VIEW_REQUIRED_ERROR));
			}
			var parent = null;
			var width = 0.0;
			var height = 0.0;
			if(oldView != null) {
				parent = oldView.parent;
				width = oldView.get_width();
				height = oldView.get_height();
			}
			if(newView != null) {
				parent = newView.parent;
				width = Math.max(width,newView.get_width());
				height = Math.max(height,newView.get_height());
			}
			var endX = 0.0;
			var endY = 0.0;
			if(angle >= 0.0 && angle < 45.0) {
				endX = width;
				var hy = width / Math.cos(angle * Math.PI / 180.0);
				endY = -Math.sqrt(hy * hy - width * width);
			} else if(angle >= 45.0 && angle < 90.0) {
				endY = -height;
				var hy1 = height / Math.sin(angle * Math.PI / 180.0);
				endX = Math.sqrt(hy1 * hy1 - height * height);
			} else if(angle >= 90.0 && angle < 135.0) {
				endY = -height;
				var hy2 = height / Math.cos((angle - 90.0) * Math.PI / 180.0);
				endX = -Math.sqrt(hy2 * hy2 - height * height);
			} else if(angle >= 135.0 && angle < 180.0) {
				endX = -width;
				var hy3 = width / Math.sin((angle - 90.0) * Math.PI / 180.0);
				endY = -Math.sqrt(hy3 * hy3 - width * width);
			} else if(angle >= 180.0 && angle < 225.0) {
				endX = -width;
				var hy4 = width / Math.cos((angle - 180.0) * Math.PI / 180.0);
				endY = Math.sqrt(hy4 * hy4 - width * width);
			} else if(angle >= 225.0 && angle < 270.0) {
				endY = height;
				var hy5 = height / Math.sin((angle - 180.0) * Math.PI / 180.0);
				endX = -Math.sqrt(hy5 * hy5 - height * height);
			} else if(angle >= 270.0 && angle < 315.0) {
				endY = height;
				var hy6 = height / Math.cos((angle - 270.0) * Math.PI / 180.0);
				endX = Math.sqrt(hy6 * hy6 - height * height);
			} else {
				endX = width;
				var hy7 = width / Math.sin((angle - 270.0) * Math.PI / 180.0);
				endY = Math.sqrt(hy7 * hy7 - width * width);
			}
			var startX = -endX;
			var startY = -endY;
			if(oldView != null) {
				oldView.set_x(0.0);
				oldView.set_y(0.0);
			}
			if(newView != null) {
				newView.set_x(startX);
				newView.set_y(startY);
			}
			if(parent != null && oldView != null && newView != null) {
				var oldViewIndex = parent.getChildIndex(oldView);
				var newViewIndex = parent.getChildIndex(newView);
				if(oldViewIndex > newViewIndex) {
					parent.swapChildren(oldView,newView);
				}
			}
			var actuator = (feathers_motion_effects_actuate_ActuateForEffects()).update(function(x,y) {
				if(newView != null) {
					newView.set_x(x);
					newView.set_y(y);
				}
				return;
			},duration,[startX,startY],[0.0,0.0]);
			if(ease != null) {
				actuator.ease(ease);
			}
			(motion_Actuate()).pause(actuator);
			return new (feathers_motion_effects_actuate_ActuateEffectContext())(null,actuator,interruptBehavior);
		};
	}
};
CoverTransitionBuilder.prototype.__class__ = CoverTransitionBuilder.prototype.constructor = $hxClasses["feathers.motion.transitions.CoverTransitionBuilder"] = CoverTransitionBuilder;

// Init



// Statics


CoverTransitionBuilder.VIEW_REQUIRED_ERROR = "Cannot transition if both old view and new view are null."

// Export

exports["default"] = CoverTransitionBuilder;

/***/ }),

/***/ "./lib/_gen/feathers/motion/transitions/FadeTransitionBuilder.js":
/*!***********************************************************************!*\
  !*** ./lib/_gen/feathers/motion/transitions/FadeTransitionBuilder.js ***!
  \***********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.motion.transitions.FadeTransitionBuilder

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function feathers_motion_effects_actuate_ActuateForEffects() {return __webpack_require__(/*! ./../../../feathers/motion/effects/actuate/ActuateForEffects */ "./lib/_gen/feathers/motion/effects/actuate/ActuateForEffects.js");}
function motion_Actuate() {return (__webpack_require__(/*! motion */ "motion").Actuate);}
function feathers_motion_effects_actuate_ActuateEffectContext() {return __webpack_require__(/*! ./../../../feathers/motion/effects/actuate/ActuateEffectContext */ "./lib/_gen/feathers/motion/effects/actuate/ActuateEffectContext.js");}

// Constructor

var FadeTransitionBuilder = function(fadeIn,fadeOut,duration,ease) {
	if(duration == null) {
		duration = 0.5;
	}
	if(fadeOut == null) {
		fadeOut = true;
	}
	if(fadeIn == null) {
		fadeIn = true;
	}
	this._fadeIn = fadeIn;
	this._fadeOut = fadeOut;
	this._duration = duration;
	this._ease = ease;
}

// Meta

FadeTransitionBuilder.__name__ = "feathers.motion.transitions.FadeTransitionBuilder";
FadeTransitionBuilder.__isInterface__ = false;
FadeTransitionBuilder.prototype = {
	setFadeIn: function(fadeIn) {
		this._fadeIn = fadeIn;
		return this;
	},
	setFadeOut: function(fadeOut) {
		this._fadeOut = fadeOut;
		return this;
	},
	setDuration: function(duration) {
		this._duration = duration;
		return this;
	},
	setEase: function(ease) {
		this._ease = ease;
		return this;
	},
	setInterruptBehavior: function(interruptBehavior) {
		this._interruptBehavior = interruptBehavior;
		return this;
	},
	build: function() {
		var fadeIn = this._fadeIn;
		var fadeOut = this._fadeOut;
		var duration = this._duration;
		var ease = this._ease;
		var interruptBehavior = this._interruptBehavior;
		return function(oldView,newView) {
			if(oldView == null && newView == null) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())(FadeTransitionBuilder.VIEW_REQUIRED_ERROR));
			}
			var parent = null;
			var oldStartAlpha = 1.0;
			var oldEndAlpha = 0.0;
			var newStartAlpha = 0.0;
			var newEndAlpha = 1.0;
			if(oldView != null) {
				parent = oldView.parent;
				oldStartAlpha = oldView.get_alpha();
				oldEndAlpha = fadeOut ? 0.0 : oldStartAlpha;
			}
			if(newView != null) {
				parent = newView.parent;
				newStartAlpha = fadeIn ? 0.0 : newView.get_alpha();
				newEndAlpha = fadeIn ? 1.0 : newStartAlpha;
				newView.set_alpha(newStartAlpha);
			}
			if(parent != null && oldView != null && newView != null) {
				var oldViewIndex = parent.getChildIndex(oldView);
				var newViewIndex = parent.getChildIndex(newView);
				if(fadeIn && oldViewIndex > newViewIndex) {
					parent.setChildIndex(oldView,newViewIndex);
				} else if(!fadeIn && fadeOut && newViewIndex > oldViewIndex) {
					parent.setChildIndex(newView,oldViewIndex);
				}
			}
			var actuator = (feathers_motion_effects_actuate_ActuateForEffects()).update(function(alpha1,alpha2) {
				if(oldView != null) {
					oldView.set_alpha(alpha1);
				}
				if(newView != null) {
					newView.set_alpha(alpha2);
				}
				return;
			},duration,[oldStartAlpha,newStartAlpha],[oldEndAlpha,newEndAlpha]);
			if(ease != null) {
				actuator.ease(ease);
			}
			(motion_Actuate()).pause(actuator);
			return new (feathers_motion_effects_actuate_ActuateEffectContext())(null,actuator,interruptBehavior);
		};
	}
};
FadeTransitionBuilder.prototype.__class__ = FadeTransitionBuilder.prototype.constructor = $hxClasses["feathers.motion.transitions.FadeTransitionBuilder"] = FadeTransitionBuilder;

// Init



// Statics


FadeTransitionBuilder.VIEW_REQUIRED_ERROR = "Cannot transition if both old view and new view are null."

// Export

exports["default"] = FadeTransitionBuilder;

/***/ }),

/***/ "./lib/_gen/feathers/motion/transitions/FadeTransitions.js":
/*!*****************************************************************!*\
  !*** ./lib/_gen/feathers/motion/transitions/FadeTransitions.js ***!
  \*****************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.motion.transitions.FadeTransitions

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function feathers_motion_transitions_FadeTransitionBuilder() {return __webpack_require__(/*! ./../../../feathers/motion/transitions/FadeTransitionBuilder */ "./lib/_gen/feathers/motion/transitions/FadeTransitionBuilder.js");}

// Constructor

var FadeTransitions = function(){}

// Meta

FadeTransitions.__name__ = "feathers.motion.transitions.FadeTransitions";
FadeTransitions.__isInterface__ = false;
FadeTransitions.prototype = {
	
};
FadeTransitions.prototype.__class__ = FadeTransitions.prototype.constructor = $hxClasses["feathers.motion.transitions.FadeTransitions"] = FadeTransitions;

// Init



// Statics

FadeTransitions.crossFade = function(duration,ease,interruptBehavior) {
	if(duration == null) {
		duration = 0.5;
	}
	return new (feathers_motion_transitions_FadeTransitionBuilder())().setFadeIn(true).setFadeOut(true).setDuration(duration).setEase(ease).setInterruptBehavior(interruptBehavior).build();
}


// Export

exports["default"] = FadeTransitions;

/***/ }),

/***/ "./lib/_gen/feathers/motion/transitions/IrisTransitionBuilder.js":
/*!***********************************************************************!*\
  !*** ./lib/_gen/feathers/motion/transitions/IrisTransitionBuilder.js ***!
  \***********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.motion.transitions.IrisTransitionBuilder

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function openfl_display_Shape() {return (__webpack_require__(/*! openfl */ "openfl").display.Shape);}
function feathers_motion_effects_actuate_ActuateForEffects() {return __webpack_require__(/*! ./../../../feathers/motion/effects/actuate/ActuateForEffects */ "./lib/_gen/feathers/motion/effects/actuate/ActuateForEffects.js");}
function motion_Actuate() {return (__webpack_require__(/*! motion */ "motion").Actuate);}
function feathers_motion_effects_actuate_ActuateEffectContext() {return __webpack_require__(/*! ./../../../feathers/motion/effects/actuate/ActuateEffectContext */ "./lib/_gen/feathers/motion/effects/actuate/ActuateEffectContext.js");}

// Constructor

var IrisTransitionBuilder = function(open,originRatioX,originRatioY,duration,ease) {
	if(duration == null) {
		duration = 0.5;
	}
	if(originRatioY == null) {
		originRatioY = 0.5;
	}
	if(originRatioX == null) {
		originRatioX = 0.5;
	}
	if(open == null) {
		open = true;
	}
	this._open = open;
	this._originRatioX = originRatioX;
	this._originRatioY = originRatioY;
	this._duration = duration;
	this._ease = ease;
}

// Meta

IrisTransitionBuilder.__name__ = "feathers.motion.transitions.IrisTransitionBuilder";
IrisTransitionBuilder.__isInterface__ = false;
IrisTransitionBuilder.prototype = {
	setOpen: function(open) {
		this._open = open;
		return this;
	},
	setOriginRatioX: function(originRatioX) {
		this._originRatioX = originRatioX;
		this._originX = null;
		return this;
	},
	setOriginRatioY: function(originRatioY) {
		this._originRatioY = originRatioY;
		this._originY = null;
		return this;
	},
	setOriginX: function(originX) {
		this._originX = originX;
		this._originRatioX = null;
		return this;
	},
	setOriginY: function(originY) {
		this._originY = originY;
		this._originRatioY = null;
		return this;
	},
	setDuration: function(duration) {
		this._duration = duration;
		return this;
	},
	setEase: function(ease) {
		this._ease = ease;
		return this;
	},
	setInterruptBehavior: function(interruptBehavior) {
		this._interruptBehavior = interruptBehavior;
		return this;
	},
	build: function() {
		var open = this._open;
		var originX = this._originX;
		var originY = this._originY;
		var originRatioX = this._originRatioX;
		var originRatioY = this._originRatioY;
		var duration = this._duration;
		var ease = this._ease;
		var interruptBehavior = this._interruptBehavior;
		return function(oldView,newView) {
			if(oldView == null && newView == null) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())(IrisTransitionBuilder.VIEW_REQUIRED_ERROR));
			}
			var parent = null;
			var width = 0.0;
			var height = 0.0;
			var oldViewMask = null;
			var newViewMask = null;
			var oldViewOldMask = null;
			var newViewOldMask = null;
			if(oldView != null) {
				parent = oldView.parent;
				width = oldView.get_width();
				height = oldView.get_height();
				oldViewOldMask = oldView.get_mask();
			}
			if(newView != null) {
				parent = newView.parent;
				width = Math.max(width,newView.get_width());
				height = Math.max(height,newView.get_height());
				newViewOldMask = newView.get_mask();
			}
			var startScale = open ? 0.0 : 1.0;
			var endScale = open ? 1.0 : 0.0;
			var currentOriginX = originX;
			if(currentOriginX == null) {
				currentOriginX = width * originRatioX;
			}
			var currentOriginY = originY;
			if(currentOriginY == null) {
				currentOriginY = height * originRatioY;
			}
			var halfWidth = width / 2.0;
			var halfHeight = height / 2.0;
			var p1 = new (openfl_geom_Point())(halfWidth,halfHeight);
			var p2 = new (openfl_geom_Point())(currentOriginX,currentOriginY);
			var radiusFromCenter = p1.get_length();
			var radius = radiusFromCenter;
			if(!p1.equals(p2)) {
				var distanceFromCenterToOrigin = (openfl_geom_Point()).distance(p1,p2);
				radius = radiusFromCenter + distanceFromCenterToOrigin;
			}
			if(newView != null && open) {
				newViewMask = new (openfl_display_Shape())();
				newViewMask.set_x(currentOriginX);
				newViewMask.set_y(currentOriginY);
				newViewMask.get_graphics().beginFill(16711935);
				newViewMask.get_graphics().drawCircle(0.0,0.0,radius);
				newViewMask.get_graphics().endFill();
				newViewMask.set_scaleX(0.0);
				newViewMask.set_scaleY(0.0);
				newView.set_mask(newViewMask);
				parent.addChild(newViewMask);
				if(oldView != null) {
					var oldViewIndex = parent.getChildIndex(oldView);
					var newViewIndex = parent.getChildIndex(newView);
					if(oldViewIndex > newViewIndex) {
						parent.swapChildren(oldView,newView);
					}
				}
			}
			if(oldView != null && !open) {
				oldViewMask = new (openfl_display_Shape())();
				oldViewMask.set_x(currentOriginX);
				oldViewMask.set_y(currentOriginY);
				oldViewMask.get_graphics().beginFill(16711935);
				oldViewMask.get_graphics().drawCircle(0,0,radius);
				oldViewMask.get_graphics().endFill();
				oldView.set_mask(oldViewMask);
				parent.addChild(oldViewMask);
				if(newView != null) {
					var oldViewIndex1 = parent.getChildIndex(oldView);
					var newViewIndex1 = parent.getChildIndex(newView);
					if(newViewIndex1 > oldViewIndex1) {
						parent.swapChildren(oldView,newView);
					}
				}
			}
			var actuator = (feathers_motion_effects_actuate_ActuateForEffects()).update(function(scale) {
				if(oldViewMask != null) {
					oldViewMask.set_scaleX(scale);
					oldViewMask.set_scaleY(scale);
				}
				if(newViewMask != null) {
					newViewMask.set_scaleX(scale);
					newViewMask.set_scaleY(scale);
				}
				return;
			},duration,[startScale],[endScale]);
			if(ease != null) {
				actuator.ease(ease);
			}
			actuator.onComplete(function() {
				if(oldView != null) {
					oldView.set_mask(oldViewOldMask);
				}
				if(newView != null) {
					newView.set_mask(newViewOldMask);
				}
				if(oldViewMask != null) {
					parent.removeChild(oldViewMask);
				}
				if(newViewMask != null) {
					parent.removeChild(newViewMask);
				}
				return;
			});
			(motion_Actuate()).pause(actuator);
			return new (feathers_motion_effects_actuate_ActuateEffectContext())(null,actuator,interruptBehavior);
		};
	}
};
IrisTransitionBuilder.prototype.__class__ = IrisTransitionBuilder.prototype.constructor = $hxClasses["feathers.motion.transitions.IrisTransitionBuilder"] = IrisTransitionBuilder;

// Init



// Statics


IrisTransitionBuilder.VIEW_REQUIRED_ERROR = "Cannot transition if both old view and new view are null."

// Export

exports["default"] = IrisTransitionBuilder;

/***/ }),

/***/ "./lib/_gen/feathers/motion/transitions/RevealTransitionBuilder.js":
/*!*************************************************************************!*\
  !*** ./lib/_gen/feathers/motion/transitions/RevealTransitionBuilder.js ***!
  \*************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.motion.transitions.RevealTransitionBuilder

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function feathers_motion_effects_actuate_ActuateForEffects() {return __webpack_require__(/*! ./../../../feathers/motion/effects/actuate/ActuateForEffects */ "./lib/_gen/feathers/motion/effects/actuate/ActuateForEffects.js");}
function motion_Actuate() {return (__webpack_require__(/*! motion */ "motion").Actuate);}
function feathers_motion_effects_actuate_ActuateEffectContext() {return __webpack_require__(/*! ./../../../feathers/motion/effects/actuate/ActuateEffectContext */ "./lib/_gen/feathers/motion/effects/actuate/ActuateEffectContext.js");}

// Constructor

var RevealTransitionBuilder = function(angleDegrees,duration,ease) {
	if(duration == null) {
		duration = 0.5;
	}
	if(angleDegrees == null) {
		angleDegrees = 0.0;
	}
	this._angle = angleDegrees;
	this._duration = duration;
	this._ease = ease;
}

// Meta

RevealTransitionBuilder.__name__ = "feathers.motion.transitions.RevealTransitionBuilder";
RevealTransitionBuilder.__isInterface__ = false;
RevealTransitionBuilder.prototype = {
	setAngle: function(angleDegrees) {
		this._angle = angleDegrees;
		return this;
	},
	setRadians: function(angleRadians) {
		this._angle = angleRadians * 180.0 / Math.PI;
		return this;
	},
	setUp: function() {
		this._angle = 90.0;
		return this;
	},
	setDown: function() {
		this._angle = 270.0;
		return this;
	},
	setLeft: function() {
		this._angle = 180.0;
		return this;
	},
	setRight: function() {
		this._angle = 0.0;
		return this;
	},
	setDuration: function(duration) {
		this._duration = duration;
		return this;
	},
	setEase: function(ease) {
		this._ease = ease;
		return this;
	},
	setInterruptBehavior: function(interruptBehavior) {
		this._interruptBehavior = interruptBehavior;
		return this;
	},
	build: function() {
		var angle = this._angle % 360.0;
		if(angle < 0.0) {
			angle += 360.0;
		}
		var duration = this._duration;
		var ease = this._ease;
		var interruptBehavior = this._interruptBehavior;
		return function(oldView,newView) {
			if(oldView == null && newView == null) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())(RevealTransitionBuilder.VIEW_REQUIRED_ERROR));
			}
			var parent = null;
			var width = 0.0;
			var height = 0.0;
			if(oldView != null) {
				parent = oldView.parent;
				width = oldView.get_width();
				height = oldView.get_height();
			}
			if(newView != null) {
				parent = newView.parent;
				width = Math.max(width,newView.get_width());
				height = Math.max(height,newView.get_height());
			}
			var endX = 0.0;
			var endY = 0.0;
			if(angle >= 0.0 && angle < 45.0) {
				endX = width;
				var hy = width / Math.cos(angle * Math.PI / 180.0);
				endY = -Math.sqrt(hy * hy - width * width);
			} else if(angle >= 45.0 && angle < 90.0) {
				endY = -height;
				var hy1 = height / Math.sin(angle * Math.PI / 180.0);
				endX = Math.sqrt(hy1 * hy1 - height * height);
			} else if(angle >= 90.0 && angle < 135.0) {
				endY = -height;
				var hy2 = height / Math.cos((angle - 90.0) * Math.PI / 180.0);
				endX = -Math.sqrt(hy2 * hy2 - height * height);
			} else if(angle >= 135.0 && angle < 180.0) {
				endX = -width;
				var hy3 = width / Math.sin((angle - 90.0) * Math.PI / 180.0);
				endY = -Math.sqrt(hy3 * hy3 - width * width);
			} else if(angle >= 180.0 && angle < 225.0) {
				endX = -width;
				var hy4 = width / Math.cos((angle - 180.0) * Math.PI / 180.0);
				endY = Math.sqrt(hy4 * hy4 - width * width);
			} else if(angle >= 225.0 && angle < 270.0) {
				endY = height;
				var hy5 = height / Math.sin((angle - 180.0) * Math.PI / 180.0);
				endX = -Math.sqrt(hy5 * hy5 - height * height);
			} else if(angle >= 270.0 && angle < 315.0) {
				endY = height;
				var hy6 = height / Math.cos((angle - 270.0) * Math.PI / 180.0);
				endX = Math.sqrt(hy6 * hy6 - height * height);
			} else {
				endX = width;
				var hy7 = width / Math.sin((angle - 270.0) * Math.PI / 180.0);
				endY = Math.sqrt(hy7 * hy7 - width * width);
			}
			if(newView != null) {
				newView.set_x(0.0);
				newView.set_y(0.0);
			}
			if(parent != null && oldView != null && newView != null) {
				var oldViewIndex = parent.getChildIndex(oldView);
				var newViewIndex = parent.getChildIndex(newView);
				if(newViewIndex > oldViewIndex) {
					parent.swapChildren(oldView,newView);
				}
			}
			var actuator = (feathers_motion_effects_actuate_ActuateForEffects()).update(function(x,y) {
				if(oldView != null) {
					oldView.set_x(x);
					oldView.set_y(y);
				}
				return;
			},duration,[0.0,0.0],[endX,endY]);
			if(ease != null) {
				actuator.ease(ease);
			}
			(motion_Actuate()).pause(actuator);
			return new (feathers_motion_effects_actuate_ActuateEffectContext())(null,actuator,interruptBehavior);
		};
	}
};
RevealTransitionBuilder.prototype.__class__ = RevealTransitionBuilder.prototype.constructor = $hxClasses["feathers.motion.transitions.RevealTransitionBuilder"] = RevealTransitionBuilder;

// Init



// Statics


RevealTransitionBuilder.VIEW_REQUIRED_ERROR = "Cannot transition if both old view and new view are null."

// Export

exports["default"] = RevealTransitionBuilder;

/***/ }),

/***/ "./lib/_gen/feathers/motion/transitions/SlideTransitionBuilder.js":
/*!************************************************************************!*\
  !*** ./lib/_gen/feathers/motion/transitions/SlideTransitionBuilder.js ***!
  \************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.motion.transitions.SlideTransitionBuilder

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_RangeError() {return (__webpack_require__(/*! openfl */ "openfl").errors.RangeError);}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function feathers_motion_effects_actuate_ActuateForEffects() {return __webpack_require__(/*! ./../../../feathers/motion/effects/actuate/ActuateForEffects */ "./lib/_gen/feathers/motion/effects/actuate/ActuateForEffects.js");}
function motion_Actuate() {return (__webpack_require__(/*! motion */ "motion").Actuate);}
function feathers_motion_effects_actuate_ActuateEffectContext() {return __webpack_require__(/*! ./../../../feathers/motion/effects/actuate/ActuateEffectContext */ "./lib/_gen/feathers/motion/effects/actuate/ActuateEffectContext.js");}

// Constructor

var SlideTransitionBuilder = function(angleDegrees,duration,ease) {
	if(duration == null) {
		duration = 0.5;
	}
	if(angleDegrees == null) {
		angleDegrees = 0.0;
	}
	this._parallax = 1.0;
	this._angle = angleDegrees;
	this._duration = duration;
	this._ease = ease;
}

// Meta

SlideTransitionBuilder.__name__ = "feathers.motion.transitions.SlideTransitionBuilder";
SlideTransitionBuilder.__isInterface__ = false;
SlideTransitionBuilder.prototype = {
	setAngle: function(angleDegrees) {
		this._angle = angleDegrees;
		return this;
	},
	setRadians: function(angleRadians) {
		this._angle = angleRadians * 180.0 / Math.PI;
		return this;
	},
	setUp: function() {
		this._angle = 90.0;
		return this;
	},
	setDown: function() {
		this._angle = 270.0;
		return this;
	},
	setLeft: function() {
		this._angle = 180.0;
		return this;
	},
	setRight: function() {
		this._angle = 0.0;
		return this;
	},
	setDuration: function(duration) {
		this._duration = duration;
		return this;
	},
	setEase: function(ease) {
		this._ease = ease;
		return this;
	},
	setParallax: function(parallax) {
		if(parallax < 0.0 || parallax > 1.0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_RangeError())("Invalid parallax value: " + parallax + ". Expected a value between 0.0 and 1.0."));
		}
		this._parallax = parallax;
		return this;
	},
	setInterruptBehavior: function(interruptBehavior) {
		this._interruptBehavior = interruptBehavior;
		return this;
	},
	build: function() {
		var _gthis = this;
		var angle = this._angle % 360.0;
		if(angle < 0.0) {
			angle += 360.0;
		}
		var duration = this._duration;
		var ease = this._ease;
		var interruptBehavior = this._interruptBehavior;
		return function(oldView,newView) {
			if(oldView == null && newView == null) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())(SlideTransitionBuilder.VIEW_REQUIRED_ERROR));
			}
			var parent = null;
			var width = 0.0;
			var height = 0.0;
			if(oldView != null) {
				parent = oldView.parent;
				width = oldView.get_width();
				height = oldView.get_height();
			}
			if(newView != null) {
				parent = newView.parent;
				width = Math.max(width,newView.get_width());
				height = Math.max(height,newView.get_height());
			}
			var endX = 0.0;
			var endY = 0.0;
			if(angle >= 0.0 && angle < 45.0) {
				endX = width;
				var hy = width / Math.cos(angle * Math.PI / 180.0);
				endY = -Math.sqrt(hy * hy - width * width);
			} else if(angle >= 45.0 && angle < 90.0) {
				endY = -height;
				var hy1 = height / Math.sin(angle * Math.PI / 180.0);
				endX = Math.sqrt(hy1 * hy1 - height * height);
			} else if(angle >= 90.0 && angle < 135.0) {
				endY = -height;
				var hy2 = height / Math.cos((angle - 90.0) * Math.PI / 180.0);
				endX = -Math.sqrt(hy2 * hy2 - height * height);
			} else if(angle >= 135.0 && angle < 180.0) {
				endX = -width;
				var hy3 = width / Math.sin((angle - 90.0) * Math.PI / 180.0);
				endY = -Math.sqrt(hy3 * hy3 - width * width);
			} else if(angle >= 180.0 && angle < 225.0) {
				endX = -width;
				var hy4 = width / Math.cos((angle - 180.0) * Math.PI / 180.0);
				endY = Math.sqrt(hy4 * hy4 - width * width);
			} else if(angle >= 225.0 && angle < 270.0) {
				endY = height;
				var hy5 = height / Math.sin((angle - 180.0) * Math.PI / 180.0);
				endX = -Math.sqrt(hy5 * hy5 - height * height);
			} else if(angle >= 270.0 && angle < 315.0) {
				endY = height;
				var hy6 = height / Math.cos((angle - 270.0) * Math.PI / 180.0);
				endX = Math.sqrt(hy6 * hy6 - height * height);
			} else {
				endX = width;
				var hy7 = width / Math.sin((angle - 270.0) * Math.PI / 180.0);
				endY = Math.sqrt(hy7 * hy7 - width * width);
			}
			if(newView != null) {
				newView.set_x(-endX);
				newView.set_y(-endY);
			}
			if(parent != null && oldView != null && newView != null) {
				var oldViewIndex = parent.getChildIndex(oldView);
				var newViewIndex = parent.getChildIndex(newView);
				if(oldViewIndex > newViewIndex) {
					parent.swapChildren(oldView,newView);
				}
			}
			var actuator = (feathers_motion_effects_actuate_ActuateForEffects()).update(function(x,y) {
				if(oldView != null) {
					oldView.set_x(x * _gthis._parallax);
					oldView.set_y(y * _gthis._parallax);
				}
				if(newView != null) {
					newView.set_x(x - endX);
					newView.set_y(y - endY);
				}
				return;
			},duration,[0.0,0.0],[endX,endY]);
			if(ease != null) {
				actuator.ease(ease);
			}
			(motion_Actuate()).pause(actuator);
			return new (feathers_motion_effects_actuate_ActuateEffectContext())(null,actuator,interruptBehavior);
		};
	}
};
SlideTransitionBuilder.prototype.__class__ = SlideTransitionBuilder.prototype.constructor = $hxClasses["feathers.motion.transitions.SlideTransitionBuilder"] = SlideTransitionBuilder;

// Init



// Statics


SlideTransitionBuilder.VIEW_REQUIRED_ERROR = "Cannot transition if both old view and new view are null."

// Export

exports["default"] = SlideTransitionBuilder;

/***/ }),

/***/ "./lib/_gen/feathers/motion/transitions/SlideTransitions.js":
/*!******************************************************************!*\
  !*** ./lib/_gen/feathers/motion/transitions/SlideTransitions.js ***!
  \******************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.motion.transitions.SlideTransitions

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function feathers_motion_transitions_SlideTransitionBuilder() {return __webpack_require__(/*! ./../../../feathers/motion/transitions/SlideTransitionBuilder */ "./lib/_gen/feathers/motion/transitions/SlideTransitionBuilder.js");}

// Constructor

var SlideTransitions = function(){}

// Meta

SlideTransitions.__name__ = "feathers.motion.transitions.SlideTransitions";
SlideTransitions.__isInterface__ = false;
SlideTransitions.prototype = {
	
};
SlideTransitions.prototype.__class__ = SlideTransitions.prototype.constructor = $hxClasses["feathers.motion.transitions.SlideTransitions"] = SlideTransitions;

// Init



// Statics

SlideTransitions.left = function(duration,ease,interruptBehavior) {
	if(duration == null) {
		duration = 0.5;
	}
	return new (feathers_motion_transitions_SlideTransitionBuilder())().setLeft().setDuration(duration).setEase(ease).setInterruptBehavior(interruptBehavior).build();
}
SlideTransitions.right = function(duration,ease,interruptBehavior) {
	if(duration == null) {
		duration = 0.5;
	}
	return new (feathers_motion_transitions_SlideTransitionBuilder())().setRight().setDuration(duration).setEase(ease).setInterruptBehavior(interruptBehavior).build();
}
SlideTransitions.up = function(duration,ease,interruptBehavior) {
	if(duration == null) {
		duration = 0.5;
	}
	return new (feathers_motion_transitions_SlideTransitionBuilder())().setUp().setDuration(duration).setEase(ease).setInterruptBehavior(interruptBehavior).build();
}
SlideTransitions.down = function(duration,ease,interruptBehavior) {
	if(duration == null) {
		duration = 0.5;
	}
	return new (feathers_motion_transitions_SlideTransitionBuilder())().setDown().setDuration(duration).setEase(ease).setInterruptBehavior(interruptBehavior).build();
}


// Export

exports["default"] = SlideTransitions;

/***/ }),

/***/ "./lib/_gen/feathers/motion/transitions/WipeTransitionBuilder.js":
/*!***********************************************************************!*\
  !*** ./lib/_gen/feathers/motion/transitions/WipeTransitionBuilder.js ***!
  \***********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.motion.transitions.WipeTransitionBuilder

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function openfl_display_Shape() {return (__webpack_require__(/*! openfl */ "openfl").display.Shape);}
function feathers_motion_effects_actuate_ActuateForEffects() {return __webpack_require__(/*! ./../../../feathers/motion/effects/actuate/ActuateForEffects */ "./lib/_gen/feathers/motion/effects/actuate/ActuateForEffects.js");}
function motion_Actuate() {return (__webpack_require__(/*! motion */ "motion").Actuate);}
function feathers_motion_effects_actuate_ActuateEffectContext() {return __webpack_require__(/*! ./../../../feathers/motion/effects/actuate/ActuateEffectContext */ "./lib/_gen/feathers/motion/effects/actuate/ActuateEffectContext.js");}

// Constructor

var WipeTransitionBuilder = function(angleDegrees,duration,ease) {
	if(duration == null) {
		duration = 0.5;
	}
	if(angleDegrees == null) {
		angleDegrees = 0.0;
	}
	this._angle = angleDegrees;
	this._duration = duration;
	this._ease = ease;
}

// Meta

WipeTransitionBuilder.__name__ = "feathers.motion.transitions.WipeTransitionBuilder";
WipeTransitionBuilder.__isInterface__ = false;
WipeTransitionBuilder.prototype = {
	setAngle: function(angleDegrees) {
		this._angle = angleDegrees;
		return this;
	},
	setRadians: function(angleRadians) {
		this._angle = angleRadians * 180.0 / Math.PI;
		return this;
	},
	setUp: function() {
		this._angle = 90.0;
		return this;
	},
	setDown: function() {
		this._angle = 270.0;
		return this;
	},
	setLeft: function() {
		this._angle = 180.0;
		return this;
	},
	setRight: function() {
		this._angle = 0.0;
		return this;
	},
	setDuration: function(duration) {
		this._duration = duration;
		return this;
	},
	setEase: function(ease) {
		this._ease = ease;
		return this;
	},
	setInterruptBehavior: function(interruptBehavior) {
		this._interruptBehavior = interruptBehavior;
		return this;
	},
	build: function() {
		var angle = this._angle % 360.0;
		if(angle < 0.0) {
			angle += 360.0;
		}
		var duration = this._duration;
		var ease = this._ease;
		var interruptBehavior = this._interruptBehavior;
		return function(oldView,newView) {
			if(oldView == null && newView == null) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())(WipeTransitionBuilder.VIEW_REQUIRED_ERROR));
			}
			var parent = null;
			var width = 0.0;
			var height = 0.0;
			var oldViewMask = null;
			var newViewMask = null;
			var oldViewOldMask = null;
			var newViewOldMask = null;
			if(oldView != null) {
				parent = oldView.parent;
				width = oldView.get_width();
				height = oldView.get_height();
				oldViewOldMask = oldView.get_mask();
				oldViewMask = new (openfl_display_Shape())();
			}
			if(newView != null) {
				parent = newView.parent;
				width = Math.max(width,newView.get_width());
				height = Math.max(height,newView.get_height());
				newViewOldMask = newView.get_mask();
				newViewMask = new (openfl_display_Shape())();
			}
			var radians90 = Math.PI / 2.0;
			var radiansAngle = angle % 90 * Math.PI / 180.0;
			var sin90 = Math.sin(radians90);
			var sinAngle = Math.sin(radiansAngle);
			var sinOther = Math.sin(radians90 - radiansAngle);
			var maskWidth = 0.0;
			var maskHeight = 0.0;
			var startX = 0.0;
			var startY = 0.0;
			var endX = 0.0;
			var endY = 0.0;
			if(angle >= 0.0 && angle < 90.0) {
				var mW1 = height * sinOther / sin90;
				var mW2 = width * sinAngle / sin90;
				var mH1 = height * sinAngle / sin90;
				var mH2 = width * sinOther / sin90;
				maskWidth = mW1 + mW2;
				maskHeight = mH1 + mH2;
				var xStartOffset = mW1 * sinAngle / sin90;
				var yStartOffset = mW1 * sinOther / sin90;
				var xEndOffset = mW2 * sinAngle / sin90;
				var yEndOffset = mW2 * sinOther / sin90;
				startX = -xStartOffset;
				startY = height - yStartOffset;
				endX = width - xEndOffset;
				endY = -yEndOffset;
			} else if(angle >= 90.0 && angle < 180.0) {
				var mW11 = width * sinOther / sin90;
				var mW21 = height * sinAngle / sin90;
				var mH11 = width * sinAngle / sin90;
				var mH21 = height * sinOther / sin90;
				maskWidth = mW11 + mW21;
				maskHeight = mH11 + mH21;
				var xStartOffset1 = mH11 * sinAngle / sin90;
				var yStartOffset1 = mH11 * sinOther / sin90;
				var yEndOffset1 = mW21 * sinAngle / sin90;
				var xEndOffset1 = mW21 * sinOther / sin90;
				startX = xStartOffset1;
				startY = height + yStartOffset1;
				endX = -xEndOffset1;
				endY = yEndOffset1;
			} else if(angle >= 180.0 && angle < 270.0) {
				var mW12 = width * sinAngle / sin90;
				var mW22 = height * sinOther / sin90;
				var mH12 = width * sinOther / sin90;
				var mH22 = height * sinAngle / sin90;
				maskWidth = mW12 + mW22;
				maskHeight = mH12 + mH22;
				var xStartOffset2 = mH22 * sinOther / sin90;
				var yStartOffset2 = mH22 * sinAngle / sin90;
				var xEndOffset2 = mW12 * sinAngle / sin90;
				var yEndOffset2 = mW12 * sinOther / sin90;
				startX = width + xStartOffset2;
				startY = height - yStartOffset2;
				endX = xEndOffset2;
				endY = height + yEndOffset2;
			} else if(angle >= 270.0 && angle < 360.0) {
				var mW13 = width * sinOther / sin90;
				var mW23 = height * sinAngle / sin90;
				var mH13 = height * sinOther / sin90;
				var mH23 = width * sinAngle / sin90;
				maskWidth = mW13 + mW23;
				maskHeight = mH13 + mH23;
				var xStartOffset3 = mH23 * sinAngle / sin90;
				var yStartOffset3 = mH23 * sinOther / sin90;
				var xEndOffset3 = mW23 * sinOther / sin90;
				var yEndOffset3 = mW23 * sinAngle / sin90;
				startX = width - xStartOffset3;
				startY = -yStartOffset3;
				endX = width + xEndOffset3;
				endY = height - yEndOffset3;
			}
			if(oldViewMask != null) {
				oldViewMask.set_rotation(90.0 - angle);
				oldViewMask.get_graphics().beginFill(16711935);
				oldViewMask.get_graphics().drawRect(0.0,0.0,maskWidth,maskHeight);
				oldViewMask.get_graphics().endFill();
				oldViewMask.set_x(endX);
				oldViewMask.set_y(endY);
				parent.addChild(oldViewMask);
				oldView.set_mask(oldViewMask);
			}
			if(newViewMask != null) {
				newViewMask.set_rotation(90.0 - angle);
				newViewMask.get_graphics().beginFill(16711935);
				newViewMask.get_graphics().drawRect(0.0,0.0,maskWidth,maskHeight);
				newViewMask.get_graphics().endFill();
				newViewMask.set_x(startX);
				newViewMask.set_y(startY);
				parent.addChild(newViewMask);
				newView.set_mask(newViewMask);
			}
			var actuator = (feathers_motion_effects_actuate_ActuateForEffects()).update(function(x,y) {
				if(newViewMask != null) {
					newViewMask.set_x(x);
					newViewMask.set_y(y);
				}
				if(oldViewMask != null) {
					oldViewMask.set_x(x + (endX - startX));
					oldViewMask.set_y(y + (endY - startY));
				}
				return;
			},duration,[startX,startY],[endX,endY]);
			if(ease != null) {
				actuator.ease(ease);
			}
			actuator.onComplete(function() {
				if(oldView != null) {
					oldView.set_mask(oldViewOldMask);
				}
				if(newView != null) {
					newView.set_mask(newViewOldMask);
				}
				if(oldViewMask != null) {
					parent.removeChild(oldViewMask);
				}
				if(newViewMask != null) {
					parent.removeChild(newViewMask);
				}
				return;
			});
			(motion_Actuate()).pause(actuator);
			return new (feathers_motion_effects_actuate_ActuateEffectContext())(null,actuator,interruptBehavior);
		};
	}
};
WipeTransitionBuilder.prototype.__class__ = WipeTransitionBuilder.prototype.constructor = $hxClasses["feathers.motion.transitions.WipeTransitionBuilder"] = WipeTransitionBuilder;

// Init



// Statics


WipeTransitionBuilder.VIEW_REQUIRED_ERROR = "Cannot transition if both old view and new view are null."

// Export

exports["default"] = WipeTransitionBuilder;

/***/ }),

/***/ "./lib/_gen/feathers/skins/BaseGraphicsPathSkin.js":
/*!*********************************************************!*\
  !*** ./lib/_gen/feathers/skins/BaseGraphicsPathSkin.js ***!
  \*********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.skins.BaseGraphicsPathSkin

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_skins_ProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/ProgrammaticSkin */ "./lib/_gen/feathers/skins/ProgrammaticSkin.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function haxe_ds_EnumValueMap() {return __webpack_require__(/*! ./../../haxe/ds/EnumValueMap */ "./lib/_gen/haxe/ds/EnumValueMap.js");}
function feathers_graphics_FillStyle() {return __webpack_require__(/*! ./../../feathers/graphics/FillStyle */ "./lib/_gen/feathers/graphics/FillStyle.js");}
function openfl_geom_Matrix() {return (__webpack_require__(/*! openfl */ "openfl").geom.Matrix);}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IStateContext() {return __webpack_require__(/*! ./../../feathers/core/IStateContext */ "./lib/_gen/feathers/core/IStateContext.js");}
function feathers_controls_IToggle() {return __webpack_require__(/*! ./../../feathers/controls/IToggle */ "./lib/_gen/feathers/controls/IToggle.js");}

// Constructor

var BaseGraphicsPathSkin = function(fill,border) {
	this._previousFill = null;
	this._previousBorder = null;
	(feathers_skins_ProgrammaticSkin().default).call(this);
	this.set_fill(fill);
	this.set_border(border);
}

// Meta

BaseGraphicsPathSkin.__name__ = "feathers.skins.BaseGraphicsPathSkin";
BaseGraphicsPathSkin.__isInterface__ = false;
BaseGraphicsPathSkin.__super__ = (feathers_skins_ProgrammaticSkin().default);
BaseGraphicsPathSkin.prototype = $extend((feathers_skins_ProgrammaticSkin().default).prototype, {
	get_fill: function() {
		return this._fill;
	},
	set_fill: function(value) {
		if(this._fill == value) {
			return this._fill;
		}
		if(this._previousFill == this._fill) {
			this._previousFill = null;
		}
		this._fill = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._fill;
	},
	get_disabledFill: function() {
		return this._disabledFill;
	},
	set_disabledFill: function(value) {
		if(this._disabledFill == value) {
			return this._disabledFill;
		}
		if(this._previousFill == this._disabledFill) {
			this._previousFill = null;
		}
		this._disabledFill = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._disabledFill;
	},
	get_selectedFill: function() {
		return this._selectedFill;
	},
	set_selectedFill: function(value) {
		if(this._selectedFill == value) {
			return this._selectedFill;
		}
		if(this._previousFill == this._selectedFill) {
			this._previousFill = null;
		}
		this._selectedFill = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._selectedFill;
	},
	get_border: function() {
		return this._border;
	},
	set_border: function(value) {
		if(this._border == value) {
			return this._border;
		}
		if(this._previousBorder == this._border) {
			this._previousBorder = null;
		}
		this._border = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._border;
	},
	get_disabledBorder: function() {
		return this._disabledBorder;
	},
	set_disabledBorder: function(value) {
		if(this._disabledBorder == value) {
			return this._disabledBorder;
		}
		if(this._previousBorder == this._disabledBorder) {
			this._previousBorder = null;
		}
		this._disabledBorder = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._disabledBorder;
	},
	get_selectedBorder: function() {
		return this._selectedBorder;
	},
	set_selectedBorder: function(value) {
		if(this._selectedBorder == value) {
			return this._selectedBorder;
		}
		if(this._previousBorder == this._selectedBorder) {
			this._previousBorder = null;
		}
		this._selectedBorder = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._selectedBorder;
	},
	getFillForState: function(state) {
		if(this._stateToFill == null) {
			return null;
		}
		return this._stateToFill.get(state);
	},
	setFillForState: function(state,fill) {
		if(this._stateToFill == null) {
			this._stateToFill = new (haxe_ds_EnumValueMap().default)();
		}
		var oldFill = this._stateToFill.get(state);
		if(oldFill == fill) {
			return;
		}
		if(this._previousFill == oldFill) {
			this._previousFill = null;
		}
		this._stateToFill.set(state,fill);
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	getBorderForState: function(state) {
		if(this._stateToBorder == null) {
			return null;
		}
		return this._stateToBorder.get(state);
	},
	setBorderForState: function(state,border) {
		if(this._stateToBorder == null) {
			this._stateToBorder = new (haxe_ds_EnumValueMap().default)();
		}
		var oldBorder = this._stateToBorder.get(state);
		if(oldBorder == border) {
			return;
		}
		if(this._previousBorder == oldBorder) {
			this._previousBorder = null;
		}
		this._stateToBorder.set(state,border);
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	update: function() {
		this._previousBorder = this.getCurrentBorder();
		this._previousFill = this.getCurrentFill();
		this.get_graphics().clear();
		this.draw();
	},
	draw: function() {
		this.applyLineStyle(this.getCurrentBorder());
		var currentFill = this.getCurrentFill();
		this.applyFillStyle(currentFill);
		this.drawPath();
		if(currentFill != null && currentFill != (feathers_graphics_FillStyle().default).None) {
			this.get_graphics().endFill();
		}
	},
	drawPath: function() {
	},
	applyLineStyle: function(lineStyle) {
		if(lineStyle == null) {
			return;
		}
		switch(lineStyle._hx_index) {
		case 0:
			var miterLimit = lineStyle.miterLimit;
			var joints = lineStyle.joints;
			var caps = lineStyle.caps;
			var scaleMode = lineStyle.scaleMode;
			var pixelHinting = lineStyle.pixelHinting;
			var alpha = lineStyle.alpha;
			var color = lineStyle.color;
			var thickness = lineStyle.thickness;
			if(color == null) {
				color = 0;
			}
			if(alpha == null) {
				alpha = 1.0;
			}
			if(pixelHinting == null) {
				pixelHinting = false;
			}
			if(scaleMode == null) {
				scaleMode = "normal";
			}
			if(miterLimit == null) {
				miterLimit = 3.0;
			}
			this.get_graphics().lineStyle(thickness,color,alpha,pixelHinting,scaleMode,caps,joints,miterLimit);
			break;
		case 1:
			var smooth = lineStyle.smooth;
			var repeat = lineStyle.repeat;
			var matrix = lineStyle.matrix;
			var bitmapData = lineStyle.bitmapData;
			var thickness1 = lineStyle.thickness;
			if(repeat == null) {
				repeat = true;
			}
			if(smooth == null) {
				smooth = false;
			}
			this.get_graphics().lineStyle(thickness1);
			this.get_graphics().lineBitmapStyle(bitmapData,matrix,repeat,smooth);
			break;
		case 2:
			var focalPointRatio = lineStyle.focalPointRatio;
			var interpolationMethod = lineStyle.interpolationMethod;
			var spreadMethod = lineStyle.spreadMethod;
			var matrixCallback = lineStyle.matrix;
			var ratios = lineStyle.ratios;
			var alphas = lineStyle.alphas;
			var colors = lineStyle.colors;
			var type = lineStyle.type;
			var thickness2 = lineStyle.thickness;
			var callback = matrixCallback;
			if(callback == null) {
				callback = $bind(this,this.getDefaultGradientMatrix);
			}
			if(spreadMethod == null) {
				spreadMethod = "pad";
			}
			if(interpolationMethod == null) {
				interpolationMethod = "rgb";
			}
			if(focalPointRatio == null) {
				focalPointRatio = 0.0;
			}
			var matrix1 = callback(this.getDefaultGradientMatrixWidth(),this.getDefaultGradientMatrixHeight(),this.getDefaultGradientMatrixRadians(),this.getDefaultGradientMatrixTx(),this.getDefaultGradientMatrixTy());
			this.get_graphics().lineStyle(thickness2);
			this.get_graphics().lineGradientStyle(type,colors,alphas,ratios,matrix1,spreadMethod,interpolationMethod,focalPointRatio);
			break;
		case 3:
			this.get_graphics().lineStyle(NaN,0,0.0);
			break;
		}
	},
	applyFillStyle: function(fillStyle) {
		if(fillStyle == null) {
			return;
		}
		switch(fillStyle._hx_index) {
		case 0:
			var alpha = fillStyle.alpha;
			var color = fillStyle.color;
			if(alpha == null) {
				alpha = 1.0;
			}
			this.get_graphics().beginFill(color,alpha);
			break;
		case 1:
			var smooth = fillStyle.smoothing;
			var repeat = fillStyle.repeat;
			var matrix = fillStyle.matrix;
			var bitmapData = fillStyle.bitmapData;
			if(repeat == null) {
				repeat = true;
			}
			if(smooth == null) {
				smooth = false;
			}
			this.get_graphics().beginBitmapFill(bitmapData,matrix,repeat,smooth);
			break;
		case 2:
			var focalPointRatio = fillStyle.focalPointRatio;
			var interpolationMethod = fillStyle.interpolationMethod;
			var spreadMethod = fillStyle.spreadMethod;
			var matrixCallback = fillStyle.matrix;
			var ratios = fillStyle.ratios;
			var alphas = fillStyle.alphas;
			var colors = fillStyle.colors;
			var type = fillStyle.type;
			var callback = matrixCallback;
			if(callback == null) {
				callback = $bind(this,this.getDefaultGradientMatrix);
			}
			if(spreadMethod == null) {
				spreadMethod = "pad";
			}
			if(interpolationMethod == null) {
				interpolationMethod = "rgb";
			}
			if(focalPointRatio == null) {
				focalPointRatio = 0.0;
			}
			var matrix1 = callback(this.getDefaultGradientMatrixWidth(),this.getDefaultGradientMatrixHeight(),this.getDefaultGradientMatrixRadians(),this.getDefaultGradientMatrixTx(),this.getDefaultGradientMatrixTy());
			this.get_graphics().beginGradientFill(type,colors,alphas,ratios,matrix1,spreadMethod,interpolationMethod,focalPointRatio);
			break;
		case 3:
			return;
		}
	},
	getLineThickness: function(lineStyle) {
		if(lineStyle == null) {
			return 0;
		}
		switch(lineStyle._hx_index) {
		case 0:
			var _g7 = lineStyle.miterLimit;
			var _g6 = lineStyle.joints;
			var _g5 = lineStyle.caps;
			var _g4 = lineStyle.scaleMode;
			var _g3 = lineStyle.pixelHinting;
			var _g2 = lineStyle.alpha;
			var _g1 = lineStyle.color;
			var thickness = lineStyle.thickness;
			return thickness;
		case 2:
			var _g16 = lineStyle.focalPointRatio;
			var _g15 = lineStyle.interpolationMethod;
			var _g14 = lineStyle.spreadMethod;
			var _g13 = lineStyle.matrix;
			var matrixCallback = lineStyle.ratios;
			var ratios = lineStyle.alphas;
			var alphas = lineStyle.colors;
			var colors = lineStyle.type;
			var thickness1 = lineStyle.thickness;
			return thickness1;
		default:
			return 0;
		}
	},
	getDefaultGradientMatrix: function(width,height,radians,tx,ty) {
		if(ty == null) {
			ty = 0.0;
		}
		if(tx == null) {
			tx = 0.0;
		}
		if(radians == null) {
			radians = 0.0;
		}
		var matrix = new (openfl_geom_Matrix())();
		matrix.createGradientBox(width,height,radians,tx,ty);
		return matrix;
	},
	getDefaultGradientMatrixWidth: function() {
		return this.actualWidth;
	},
	getDefaultGradientMatrixHeight: function() {
		return this.actualHeight;
	},
	getDefaultGradientMatrixRadians: function() {
		return 0.0;
	},
	getDefaultGradientMatrixTx: function() {
		return 0.0;
	},
	getDefaultGradientMatrixTy: function() {
		return 0.0;
	},
	getCurrentBorder: function() {
		if(this._previousBorder != null) {
			return this._previousBorder;
		}
		return this.getCurrentBorderWithoutCache();
	},
	getCurrentBorderWithoutCache: function() {
		var stateContext = this._stateContext;
		if(stateContext == null && (js_Boot().default).__implements(this._uiContext,(feathers_core_IStateContext().default))) {
			stateContext = (js_Boot().default).__cast(this._uiContext , (feathers_core_IStateContext().default));
		}
		if(this._stateToBorder != null && stateContext != null) {
			var result = this._stateToBorder.get(stateContext.get_currentState());
			if(result != null) {
				return result;
			}
		}
		if(this._uiContext == null) {
			return this._border;
		}
		if(this._disabledBorder != null) {
			if(!this._uiContext.get_enabled()) {
				return this._disabledBorder;
			}
		}
		if(this._selectedBorder != null && (js_Boot().default).__implements(this._uiContext,(feathers_controls_IToggle().default))) {
			var toggle = (js_Boot().default).__cast(this._uiContext , (feathers_controls_IToggle().default));
			if(toggle.get_selected()) {
				return this._selectedBorder;
			}
		}
		return this._border;
	},
	getCurrentFill: function() {
		if(this._previousFill != null) {
			return this._previousFill;
		}
		return this.getCurrentFillWithoutCache();
	},
	getCurrentFillWithoutCache: function() {
		var stateContext = this._stateContext;
		if(stateContext == null && (js_Boot().default).__implements(this._uiContext,(feathers_core_IStateContext().default))) {
			stateContext = (js_Boot().default).__cast(this._uiContext , (feathers_core_IStateContext().default));
		}
		if(this._stateToFill != null && stateContext != null) {
			var result = this._stateToFill.get(stateContext.get_currentState());
			if(result != null) {
				return result;
			}
		}
		if(this._uiContext == null) {
			return this._fill;
		}
		if(this._disabledFill != null) {
			if(!this._uiContext.get_enabled()) {
				return this._disabledFill;
			}
		}
		if(this._selectedFill != null && (js_Boot().default).__implements(this._uiContext,(feathers_controls_IToggle().default))) {
			var toggle = (js_Boot().default).__cast(this._uiContext , (feathers_controls_IToggle().default));
			if(toggle.get_selected()) {
				return this._selectedFill;
			}
		}
		return this._fill;
	},
	needsStateUpdate: function() {
		var updated = false;
		if(this._previousBorder != this.getCurrentBorderWithoutCache()) {
			this._previousBorder = null;
			updated = true;
		}
		if(this._previousFill != this.getCurrentFillWithoutCache()) {
			this._previousFill = null;
			updated = true;
		}
		return updated;
	}
});
BaseGraphicsPathSkin.prototype.__class__ = BaseGraphicsPathSkin.prototype.constructor = $hxClasses["feathers.skins.BaseGraphicsPathSkin"] = BaseGraphicsPathSkin;

// Init



// Statics




// Export

exports["default"] = BaseGraphicsPathSkin;

/***/ }),

/***/ "./lib/_gen/feathers/skins/CircleSkin.js":
/*!***********************************************!*\
  !*** ./lib/_gen/feathers/skins/CircleSkin.js ***!
  \***********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.skins.CircleSkin

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_skins_BaseGraphicsPathSkin() {return __webpack_require__(/*! ./../../feathers/skins/BaseGraphicsPathSkin */ "./lib/_gen/feathers/skins/BaseGraphicsPathSkin.js");}

// Constructor

var CircleSkin = function(fill,border) {
	(feathers_skins_BaseGraphicsPathSkin().default).call(this,fill,border);
}

// Meta

CircleSkin.__name__ = "feathers.skins.CircleSkin";
CircleSkin.__isInterface__ = false;
CircleSkin.__super__ = (feathers_skins_BaseGraphicsPathSkin().default);
CircleSkin.prototype = $extend((feathers_skins_BaseGraphicsPathSkin().default).prototype, {
	drawPath: function() {
		var radius = this.getRadius();
		this.get_graphics().drawCircle(this.actualWidth / 2.0,this.actualHeight / 2.0,radius);
	},
	getRadius: function() {
		var currentBorder = this.getCurrentBorder();
		var thicknessOffset = this.getLineThickness(currentBorder) / 2.0;
		var shorterSide = this.actualWidth;
		if(shorterSide > this.actualHeight) {
			shorterSide = this.actualHeight;
		}
		var radius = shorterSide / 2.0 - thicknessOffset;
		return Math.max(0.0,radius);
	},
	getDefaultGradientMatrixWidth: function() {
		return this.getRadius();
	},
	getDefaultGradientMatrixHeight: function() {
		return this.getRadius();
	},
	getDefaultGradientMatrixTx: function() {
		var drawWidth = Math.max(0.0,this.actualWidth - this.getRadius());
		return drawWidth / 2.0;
	},
	getDefaultGradientMatrixTy: function() {
		var drawHeight = Math.max(0.0,this.actualHeight - this.getRadius());
		return drawHeight / 2.0;
	}
});
CircleSkin.prototype.__class__ = CircleSkin.prototype.constructor = $hxClasses["feathers.skins.CircleSkin"] = CircleSkin;

// Init



// Statics




// Export

exports["default"] = CircleSkin;

/***/ }),

/***/ "./lib/_gen/feathers/skins/DonutSkin.js":
/*!**********************************************!*\
  !*** ./lib/_gen/feathers/skins/DonutSkin.js ***!
  \**********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.skins.DonutSkin

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_skins_BaseGraphicsPathSkin() {return __webpack_require__(/*! ./../../feathers/skins/BaseGraphicsPathSkin */ "./lib/_gen/feathers/skins/BaseGraphicsPathSkin.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}

// Constructor

var DonutSkin = function(fill,border) {
	this._thickness = 1.0;
	(feathers_skins_BaseGraphicsPathSkin().default).call(this,fill,border);
}

// Meta

DonutSkin.__name__ = "feathers.skins.DonutSkin";
DonutSkin.__isInterface__ = false;
DonutSkin.__super__ = (feathers_skins_BaseGraphicsPathSkin().default);
DonutSkin.prototype = $extend((feathers_skins_BaseGraphicsPathSkin().default).prototype, {
	get_thickness: function() {
		return this._thickness;
	},
	set_thickness: function(value) {
		if(this._thickness == value) {
			return this._thickness;
		}
		this._thickness = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._thickness;
	},
	drawPath: function() {
		var radius = this.getRadius();
		var innerRadius = this.getInnerRadius();
		this.get_graphics().drawCircle(this.actualWidth / 2.0,this.actualHeight / 2.0,radius);
		if(innerRadius == 0.0) {
			return;
		}
		this.get_graphics().drawCircle(this.actualWidth / 2.0,this.actualHeight / 2.0,innerRadius);
	},
	getRadius: function() {
		var currentBorder = this.getCurrentBorder();
		var thicknessOffset = this.getLineThickness(currentBorder) / 2.0;
		var shorterSide = this.actualWidth;
		if(shorterSide > this.actualHeight) {
			shorterSide = this.actualHeight;
		}
		var radius = shorterSide / 2.0 - thicknessOffset;
		return Math.max(0.0,radius);
	},
	getInnerRadius: function() {
		var currentBorder = this.getCurrentBorder();
		var thicknessOffset = this.getLineThickness(currentBorder) / 2.0;
		var shorterSide = this.actualWidth;
		if(shorterSide > this.actualHeight) {
			shorterSide = this.actualHeight;
		}
		var radius = shorterSide / 2.0 - thicknessOffset;
		return Math.max(0.0,radius - Math.max(0.0,this.get_thickness()));
	},
	getDefaultGradientMatrixWidth: function() {
		return this.getRadius();
	},
	getDefaultGradientMatrixHeight: function() {
		return this.getRadius();
	},
	getDefaultGradientMatrixTx: function() {
		var drawWidth = Math.max(0.0,this.actualWidth - this.getRadius());
		return drawWidth / 2.0;
	},
	getDefaultGradientMatrixTy: function() {
		var drawHeight = Math.max(0.0,this.actualHeight - this.getRadius());
		return drawHeight / 2.0;
	}
});
DonutSkin.prototype.__class__ = DonutSkin.prototype.constructor = $hxClasses["feathers.skins.DonutSkin"] = DonutSkin;

// Init



// Statics




// Export

exports["default"] = DonutSkin;

/***/ }),

/***/ "./lib/_gen/feathers/skins/EllipseSkin.js":
/*!************************************************!*\
  !*** ./lib/_gen/feathers/skins/EllipseSkin.js ***!
  \************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.skins.EllipseSkin

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_skins_BaseGraphicsPathSkin() {return __webpack_require__(/*! ./../../feathers/skins/BaseGraphicsPathSkin */ "./lib/_gen/feathers/skins/BaseGraphicsPathSkin.js");}

// Constructor

var EllipseSkin = function(fill,border) {
	(feathers_skins_BaseGraphicsPathSkin().default).call(this,fill,border);
}

// Meta

EllipseSkin.__name__ = "feathers.skins.EllipseSkin";
EllipseSkin.__isInterface__ = false;
EllipseSkin.__super__ = (feathers_skins_BaseGraphicsPathSkin().default);
EllipseSkin.prototype = $extend((feathers_skins_BaseGraphicsPathSkin().default).prototype, {
	drawPath: function() {
		var currentBorder = this.getCurrentBorder();
		var thickness = this.getLineThickness(currentBorder);
		var thicknessOffset = thickness / 2.0;
		var drawWidth = Math.max(0.0,this.actualWidth - thickness);
		var drawHeight = Math.max(0.0,this.actualHeight - thickness);
		this.get_graphics().drawEllipse(thicknessOffset,thicknessOffset,drawWidth,drawHeight);
	}
});
EllipseSkin.prototype.__class__ = EllipseSkin.prototype.constructor = $hxClasses["feathers.skins.EllipseSkin"] = EllipseSkin;

// Init



// Statics




// Export

exports["default"] = EllipseSkin;

/***/ }),

/***/ "./lib/_gen/feathers/skins/HorizontalLineSkin.js":
/*!*******************************************************!*\
  !*** ./lib/_gen/feathers/skins/HorizontalLineSkin.js ***!
  \*******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.skins.HorizontalLineSkin

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_skins_BaseGraphicsPathSkin() {return __webpack_require__(/*! ./../../feathers/skins/BaseGraphicsPathSkin */ "./lib/_gen/feathers/skins/BaseGraphicsPathSkin.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}

// Constructor

var HorizontalLineSkin = function(fill,border) {
	this._paddingRight = 0.0;
	this._paddingLeft = 0.0;
	this._verticalAlign = (feathers_layout_VerticalAlign().default).MIDDLE;
	(feathers_skins_BaseGraphicsPathSkin().default).call(this,fill,border);
}

// Meta

HorizontalLineSkin.__name__ = "feathers.skins.HorizontalLineSkin";
HorizontalLineSkin.__isInterface__ = false;
HorizontalLineSkin.__super__ = (feathers_skins_BaseGraphicsPathSkin().default);
HorizontalLineSkin.prototype = $extend((feathers_skins_BaseGraphicsPathSkin().default).prototype, {
	get_verticalAlign: function() {
		return this._verticalAlign;
	},
	set_verticalAlign: function(value) {
		if(this._verticalAlign == value) {
			return this._verticalAlign;
		}
		this._verticalAlign = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._verticalAlign;
	},
	get_paddingLeft: function() {
		return this._paddingLeft;
	},
	set_paddingLeft: function(value) {
		if(this._paddingLeft == value) {
			return this._paddingLeft;
		}
		this._paddingLeft = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._paddingLeft;
	},
	get_paddingRight: function() {
		return this._paddingRight;
	},
	set_paddingRight: function(value) {
		if(this._paddingRight == value) {
			return this._paddingRight;
		}
		this._paddingRight = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._paddingRight;
	},
	draw: function() {
		var currentBorder = this.getCurrentBorder();
		var thicknessOffset = this.getLineThickness(currentBorder) / 2.0;
		var currentFill = this.getCurrentFill();
		if(currentFill != null) {
			this.applyFillStyle(currentFill);
			this.get_graphics().drawRect(0.0,0.0,this.actualWidth,this.actualHeight);
			this.get_graphics().endFill();
		}
		var minLineX = Math.min(this.actualWidth,thicknessOffset + this._paddingLeft);
		var maxLineX = Math.max(minLineX,this.actualWidth - thicknessOffset - this._paddingLeft - this._paddingRight);
		var positionY;
		switch(this._verticalAlign._hx_index) {
		case 0:
			positionY = thicknessOffset;
			break;
		case 1:
			positionY = this.actualHeight / 2.0;
			break;
		case 2:
			positionY = this.actualHeight - thicknessOffset;
			break;
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown vertical align: " + (Std().default).string(this._verticalAlign)));
		}
		this.applyLineStyle(currentBorder);
		this.get_graphics().moveTo(minLineX,positionY);
		this.get_graphics().lineTo(maxLineX,positionY);
	}
});
HorizontalLineSkin.prototype.__class__ = HorizontalLineSkin.prototype.constructor = $hxClasses["feathers.skins.HorizontalLineSkin"] = HorizontalLineSkin;

// Init



// Statics




// Export

exports["default"] = HorizontalLineSkin;

/***/ }),

/***/ "./lib/_gen/feathers/skins/IIndeterminateSkin.js":
/*!*******************************************************!*\
  !*** ./lib/_gen/feathers/skins/IIndeterminateSkin.js ***!
  \*******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.skins.IIndeterminateSkin

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}

// Constructor

var IIndeterminateSkin = function() {}

// Meta

IIndeterminateSkin.__name__ = "feathers.skins.IIndeterminateSkin";
IIndeterminateSkin.__isInterface__ = true;
IIndeterminateSkin.__interfaces__ = [(feathers_skins_IProgrammaticSkin().default)];
IIndeterminateSkin.prototype = {
	
};
IIndeterminateSkin.prototype.__class__ = IIndeterminateSkin.prototype.constructor = $hxClasses["feathers.skins.IIndeterminateSkin"] = IIndeterminateSkin;

// Init



// Statics




// Export

exports["default"] = IIndeterminateSkin;

/***/ }),

/***/ "./lib/_gen/feathers/skins/IProgrammaticSkin.js":
/*!******************************************************!*\
  !*** ./lib/_gen/feathers/skins/IProgrammaticSkin.js ***!
  \******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.skins.IProgrammaticSkin

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}

// Constructor

var IProgrammaticSkin = function() {}

// Meta

IProgrammaticSkin.__name__ = "feathers.skins.IProgrammaticSkin";
IProgrammaticSkin.__isInterface__ = true;
IProgrammaticSkin.__interfaces__ = [(feathers_core_IMeasureObject().default)];
IProgrammaticSkin.prototype = {
	
};
IProgrammaticSkin.prototype.__class__ = IProgrammaticSkin.prototype.constructor = $hxClasses["feathers.skins.IProgrammaticSkin"] = IProgrammaticSkin;

// Init



// Statics




// Export

exports["default"] = IProgrammaticSkin;

/***/ }),

/***/ "./lib/_gen/feathers/skins/LeftAndRightBorderSkin.js":
/*!***********************************************************!*\
  !*** ./lib/_gen/feathers/skins/LeftAndRightBorderSkin.js ***!
  \***********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.skins.LeftAndRightBorderSkin

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_skins_BaseGraphicsPathSkin() {return __webpack_require__(/*! ./../../feathers/skins/BaseGraphicsPathSkin */ "./lib/_gen/feathers/skins/BaseGraphicsPathSkin.js");}

// Constructor

var LeftAndRightBorderSkin = function(fill,border) {
	(feathers_skins_BaseGraphicsPathSkin().default).call(this,fill,border);
}

// Meta

LeftAndRightBorderSkin.__name__ = "feathers.skins.LeftAndRightBorderSkin";
LeftAndRightBorderSkin.__isInterface__ = false;
LeftAndRightBorderSkin.__super__ = (feathers_skins_BaseGraphicsPathSkin().default);
LeftAndRightBorderSkin.prototype = $extend((feathers_skins_BaseGraphicsPathSkin().default).prototype, {
	draw: function() {
		var currentBorder = this.getCurrentBorder();
		var thickness = this.getLineThickness(currentBorder);
		var thicknessOffset = thickness / 2.0;
		var currentFill = this.getCurrentFill();
		if(currentFill != null) {
			this.applyFillStyle(currentFill);
			this.get_graphics().drawRect(thicknessOffset,0.0,Math.max(0.0,this.actualWidth - thickness),this.actualHeight);
			this.get_graphics().endFill();
		}
		var minLineX = Math.min(this.actualWidth,thicknessOffset);
		var minLineY = Math.min(this.actualHeight,thicknessOffset);
		var maxLineX = Math.max(minLineX,this.actualWidth - thicknessOffset);
		var maxLineY = Math.max(minLineY,this.actualHeight - thicknessOffset);
		this.applyLineStyle(currentBorder);
		this.get_graphics().moveTo(minLineX,minLineY);
		this.get_graphics().lineTo(minLineX,maxLineY);
		this.get_graphics().moveTo(maxLineX,minLineY);
		this.get_graphics().lineTo(maxLineX,maxLineY);
	}
});
LeftAndRightBorderSkin.prototype.__class__ = LeftAndRightBorderSkin.prototype.constructor = $hxClasses["feathers.skins.LeftAndRightBorderSkin"] = LeftAndRightBorderSkin;

// Init



// Statics




// Export

exports["default"] = LeftAndRightBorderSkin;

/***/ }),

/***/ "./lib/_gen/feathers/skins/MultiSkin.js":
/*!**********************************************!*\
  !*** ./lib/_gen/feathers/skins/MultiSkin.js ***!
  \**********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.skins.MultiSkin

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_skins_ProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/ProgrammaticSkin */ "./lib/_gen/feathers/skins/ProgrammaticSkin.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function haxe_ds_EnumValueMap() {return __webpack_require__(/*! ./../../haxe/ds/EnumValueMap */ "./lib/_gen/haxe/ds/EnumValueMap.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IUIControl() {return __webpack_require__(/*! ./../../feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");}
function feathers_layout_Measurements() {return __webpack_require__(/*! ./../../feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_core_IStateObserver() {return __webpack_require__(/*! ./../../feathers/core/IStateObserver */ "./lib/_gen/feathers/core/IStateObserver.js");}
function feathers_core_IStateContext() {return __webpack_require__(/*! ./../../feathers/core/IStateContext */ "./lib/_gen/feathers/core/IStateContext.js");}
function feathers_controls_IToggle() {return __webpack_require__(/*! ./../../feathers/controls/IToggle */ "./lib/_gen/feathers/controls/IToggle.js");}
function feathers_utils_MeasurementsUtil() {return __webpack_require__(/*! ./../../feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}
function feathers_core_IValidating() {return __webpack_require__(/*! ./../../feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");}

// Constructor

var MultiSkin = function(defaultView) {
	(feathers_skins_ProgrammaticSkin().default).call(this);
	this.mouseChildren = false;
	this.set_defaultView(defaultView);
}

// Meta

MultiSkin.__name__ = "feathers.skins.MultiSkin";
MultiSkin.__isInterface__ = false;
MultiSkin.__super__ = (feathers_skins_ProgrammaticSkin().default);
MultiSkin.prototype = $extend((feathers_skins_ProgrammaticSkin().default).prototype, {
	get_defaultView: function() {
		return this._defaultView;
	},
	set_defaultView: function(value) {
		if(this._defaultView == value) {
			return this._defaultView;
		}
		this._defaultView = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._defaultView;
	},
	get_disabledView: function() {
		return this._disabledView;
	},
	set_disabledView: function(value) {
		if(this._disabledView == value) {
			return this._disabledView;
		}
		this._disabledView = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._disabledView;
	},
	get_selectedView: function() {
		return this._selectedView;
	},
	set_selectedView: function(value) {
		if(this._selectedView == value) {
			return this._disabledView;
		}
		this._selectedView = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._selectedView;
	},
	getViewForState: function(state) {
		if(this._stateToView == null) {
			return null;
		}
		return this._stateToView.get(state);
	},
	setViewForState: function(state,view) {
		if(this._stateToView == null) {
			this._stateToView = new (haxe_ds_EnumValueMap().default)();
		}
		if(this._stateToView.get(state) == view) {
			return;
		}
		this._stateToView.set(state,view);
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
	},
	update: function() {
		this.refreshView();
		this.measure();
		this.layoutView();
		this._previousView = this._currentView;
	},
	refreshView: function() {
		var oldView = this._currentView;
		this._currentView = this.getCurrentView();
		if(this._currentView == oldView) {
			return;
		}
		this.removeCurrentView(oldView);
		if(this._currentView == null) {
			this._currentViewMeasurements = null;
			return;
		}
		if((js_Boot().default).__implements(this._currentView,(feathers_core_IUIControl().default))) {
			((js_Boot().default).__cast(this._currentView , (feathers_core_IUIControl().default))).initializeNow();
		}
		if(this._currentViewMeasurements == null) {
			this._currentViewMeasurements = new (feathers_layout_Measurements().default)(this._currentView);
		} else {
			this._currentViewMeasurements.save(this._currentView);
		}
		if((js_Boot().default).__implements(this._currentView,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(this._currentView , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(this._uiContext);
		}
		if((js_Boot().default).__implements(this._currentView,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(this._currentView , (feathers_core_IStateObserver().default))).set_stateContext(this._stateContext);
		}
		this.addChild(this._currentView);
	},
	removeCurrentView: function(view) {
		if(view == null) {
			return;
		}
		if((js_Boot().default).__implements(view,(feathers_skins_IProgrammaticSkin().default))) {
			((js_Boot().default).__cast(view , (feathers_skins_IProgrammaticSkin().default))).set_uiContext(null);
		}
		if((js_Boot().default).__implements(view,(feathers_core_IStateObserver().default))) {
			((js_Boot().default).__cast(view , (feathers_core_IStateObserver().default))).set_stateContext(null);
		}
		this._currentViewMeasurements.restore(view);
		if(view.parent == this) {
			this.removeChild(view);
		}
	},
	getCurrentView: function() {
		if(this._previousView != null) {
			return this._previousView;
		}
		return this.getCurrentViewWithoutCache();
	},
	getCurrentViewWithoutCache: function() {
		var stateContext = this._stateContext;
		if(stateContext == null && (js_Boot().default).__implements(this._uiContext,(feathers_core_IStateContext().default))) {
			stateContext = (js_Boot().default).__cast(this._uiContext , (feathers_core_IStateContext().default));
		}
		if(this._stateToView != null && stateContext != null) {
			var result = this._stateToView.get(stateContext.get_currentState());
			if(result != null) {
				return result;
			}
		}
		if(this._uiContext == null) {
			return this._defaultView;
		}
		if(this._disabledView != null) {
			if(!this._uiContext.get_enabled()) {
				return this._disabledView;
			}
		}
		if(this._selectedView != null && (js_Boot().default).__implements(this._uiContext,(feathers_controls_IToggle().default))) {
			var toggle = (js_Boot().default).__cast(this._uiContext , (feathers_controls_IToggle().default));
			if(toggle.get_selected()) {
				return this._selectedView;
			}
		}
		return this._defaultView;
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		var needsMinWidth = this.get_explicitMinWidth() == null;
		var needsMinHeight = this.get_explicitMinHeight() == null;
		var needsMaxWidth = this.get_explicitMaxWidth() == null;
		var needsMaxHeight = this.get_explicitMaxHeight() == null;
		if(!needsWidth && !needsHeight && !needsMinWidth && !needsMinHeight && !needsMaxWidth && !needsMaxHeight) {
			return false;
		}
		if(this._currentView != null) {
			(feathers_utils_MeasurementsUtil().default).resetFluidlyWithParent(this._currentViewMeasurements,this._currentView,this);
		}
		var measureSkin = null;
		if((js_Boot().default).__implements(this._currentView,(feathers_core_IMeasureObject().default))) {
			measureSkin = (js_Boot().default).__cast(this._currentView , (feathers_core_IMeasureObject().default));
		}
		if((js_Boot().default).__implements(this._currentView,(feathers_core_IValidating().default))) {
			((js_Boot().default).__cast(this._currentView , (feathers_core_IValidating().default))).validateNow();
		}
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			newWidth = 0.0;
			if(this._currentView != null) {
				newWidth = Math.max(this._currentView.get_width(),newWidth);
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			newHeight = 0.0;
			if(this._currentView != null) {
				newHeight = Math.max(this._currentView.get_height(),newHeight);
			}
		}
		var newMinWidth = this.get_explicitMinWidth();
		if(needsMinWidth) {
			newMinWidth = 0.0;
			if(measureSkin != null) {
				newMinWidth = Math.max(measureSkin.get_minWidth(),newMinWidth);
			} else if(this._currentViewMeasurements != null) {
				newMinWidth = Math.max(this._currentViewMeasurements.minWidth,newMinWidth);
			}
		}
		var newMinHeight = this.get_explicitMinHeight();
		if(needsMinHeight) {
			newMinHeight = 0.0;
			if(measureSkin != null) {
				newMinHeight = Math.max(measureSkin.get_minHeight(),newMinHeight);
			} else if(this._currentViewMeasurements != null) {
				newMinHeight = Math.max(this._currentViewMeasurements.minHeight,newMinHeight);
			}
		}
		var newMaxWidth = this.get_explicitMaxWidth();
		if(needsMaxWidth) {
			newMaxWidth = 1.0 / 0.0;
			if(measureSkin != null) {
				newMaxWidth = measureSkin.get_maxWidth();
			} else if(this._currentViewMeasurements != null) {
				newMaxWidth = this._currentViewMeasurements.maxWidth;
			}
		}
		var newMaxHeight = this.get_explicitMaxHeight();
		if(needsMaxHeight) {
			newMaxHeight = 1.0 / 0.0;
			if(measureSkin != null) {
				newMaxHeight = measureSkin.get_maxHeight();
			} else if(this._currentViewMeasurements != null) {
				newMaxHeight = this._currentViewMeasurements.maxHeight;
			}
		}
		return this.saveMeasurements(newWidth,newHeight,newMinWidth,newMinHeight,newMaxWidth,newMaxHeight);
	},
	layoutView: function() {
		if(this._currentView == null) {
			return;
		}
		if(this._currentView.get_width() != this.actualWidth) {
			this._currentView.set_width(this.actualWidth);
		}
		if(this._currentView.get_height() != this.actualHeight) {
			this._currentView.set_height(this.actualHeight);
		}
	},
	needsStateUpdate: function() {
		var updated = false;
		if(this._previousView != this.getCurrentViewWithoutCache()) {
			this._previousView = null;
			updated = true;
		}
		return updated;
	}
});
MultiSkin.prototype.__class__ = MultiSkin.prototype.constructor = $hxClasses["feathers.skins.MultiSkin"] = MultiSkin;

// Init



// Statics




// Export

exports["default"] = MultiSkin;

/***/ }),

/***/ "./lib/_gen/feathers/skins/OverAndUnderlineSkin.js":
/*!*********************************************************!*\
  !*** ./lib/_gen/feathers/skins/OverAndUnderlineSkin.js ***!
  \*********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.skins.OverAndUnderlineSkin

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_skins_TopAndBottomBorderSkin() {return __webpack_require__(/*! ./../../feathers/skins/TopAndBottomBorderSkin */ "./lib/_gen/feathers/skins/TopAndBottomBorderSkin.js");}

// Constructor

var OverAndUnderlineSkin = function(fill,border) {
	(feathers_skins_TopAndBottomBorderSkin().default).call(this,fill,border);
}

// Meta

OverAndUnderlineSkin.__name__ = "feathers.skins.OverAndUnderlineSkin";
OverAndUnderlineSkin.__isInterface__ = false;
OverAndUnderlineSkin.__super__ = (feathers_skins_TopAndBottomBorderSkin().default);
OverAndUnderlineSkin.prototype = $extend((feathers_skins_TopAndBottomBorderSkin().default).prototype, {
	
});
OverAndUnderlineSkin.prototype.__class__ = OverAndUnderlineSkin.prototype.constructor = $hxClasses["feathers.skins.OverAndUnderlineSkin"] = OverAndUnderlineSkin;

// Init



// Statics




// Export

exports["default"] = OverAndUnderlineSkin;

/***/ }),

/***/ "./lib/_gen/feathers/skins/PillSkin.js":
/*!*********************************************!*\
  !*** ./lib/_gen/feathers/skins/PillSkin.js ***!
  \*********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.skins.PillSkin

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_skins_BaseGraphicsPathSkin() {return __webpack_require__(/*! ./../../feathers/skins/BaseGraphicsPathSkin */ "./lib/_gen/feathers/skins/BaseGraphicsPathSkin.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_layout_Direction() {return __webpack_require__(/*! ./../../feathers/layout/Direction */ "./lib/_gen/feathers/layout/Direction.js");}

// Constructor

var PillSkin = function(fill,border,capDirection) {
	if(capDirection == null) {
		capDirection = (feathers_layout_Direction().default).HORIZONTAL;
	}
	(feathers_skins_BaseGraphicsPathSkin().default).call(this,fill,border);
	this._capDirection = capDirection;
}

// Meta

PillSkin.__name__ = "feathers.skins.PillSkin";
PillSkin.__isInterface__ = false;
PillSkin.__super__ = (feathers_skins_BaseGraphicsPathSkin().default);
PillSkin.prototype = $extend((feathers_skins_BaseGraphicsPathSkin().default).prototype, {
	get_capDirection: function() {
		return this._capDirection;
	},
	set_capDirection: function(value) {
		if(this._capDirection == value) {
			return this._capDirection;
		}
		this._capDirection = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._capDirection;
	},
	drawPath: function() {
		var currentBorder = this.getCurrentBorder();
		var thickness = this.getLineThickness(currentBorder);
		var thicknessOffset = thickness / 2.0;
		var drawWidth = Math.max(0.0,this.actualWidth - thickness);
		var drawHeight = Math.max(0.0,this.actualHeight - thickness);
		var ellipseSize = this.get_capDirection() == (feathers_layout_Direction().default).VERTICAL ? this.actualWidth : this.actualHeight;
		this.get_graphics().drawRoundRect(thicknessOffset,thicknessOffset,drawWidth,drawHeight,ellipseSize);
	}
});
PillSkin.prototype.__class__ = PillSkin.prototype.constructor = $hxClasses["feathers.skins.PillSkin"] = PillSkin;

// Init



// Statics




// Export

exports["default"] = PillSkin;

/***/ }),

/***/ "./lib/_gen/feathers/skins/ProgrammaticSkin.js":
/*!*****************************************************!*\
  !*** ./lib/_gen/feathers/skins/ProgrammaticSkin.js ***!
  \*****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.skins.ProgrammaticSkin

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_core_IStateObserver() {return __webpack_require__(/*! ./../../feathers/core/IStateObserver */ "./lib/_gen/feathers/core/IStateObserver.js");}
function feathers_skins_IProgrammaticSkin() {return __webpack_require__(/*! ./../../feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");}
function feathers_core_MeasureSprite() {return __webpack_require__(/*! ./../../feathers/core/MeasureSprite */ "./lib/_gen/feathers/core/MeasureSprite.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_controls_IToggle() {return __webpack_require__(/*! ./../../feathers/controls/IToggle */ "./lib/_gen/feathers/controls/IToggle.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}

// Constructor

var ProgrammaticSkin = function() {
	(feathers_core_MeasureSprite().default).call(this);
	this.mouseChildren = false;
	this.set_tabEnabled(false);
	this.set_tabChildren(false);
}

// Meta

ProgrammaticSkin.__name__ = "feathers.skins.ProgrammaticSkin";
ProgrammaticSkin.__isInterface__ = false;
ProgrammaticSkin.__interfaces__ = [(feathers_core_IStateObserver().default),(feathers_skins_IProgrammaticSkin().default)];
ProgrammaticSkin.__super__ = (feathers_core_MeasureSprite().default);
ProgrammaticSkin.prototype = $extend((feathers_core_MeasureSprite().default).prototype, {
	get_uiContext: function() {
		return this._uiContext;
	},
	set_uiContext: function(value) {
		if(this._uiContext == value) {
			return this._uiContext;
		}
		if(this._uiContext != null) {
			this._uiContext.removeEventListener("stateChange",$bind(this,this.uiContext_stateChangeHandler));
			if((js_Boot().default).__implements(this._uiContext,(feathers_controls_IToggle().default))) {
				this._uiContext.removeEventListener("change",$bind(this,this.uiContextToggle_changeHandler));
			}
			this.onRemoveUIContext();
		}
		this._uiContext = value;
		if(this._uiContext != null) {
			this._uiContext.addEventListener("stateChange",$bind(this,this.uiContext_stateChangeHandler),false,0,true);
			if((js_Boot().default).__implements(this._uiContext,(feathers_controls_IToggle().default))) {
				this._uiContext.addEventListener("change",$bind(this,this.uiContextToggle_changeHandler));
			}
			this.onAddUIContext();
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._uiContext;
	},
	get_stateContext: function() {
		return this._stateContext;
	},
	set_stateContext: function(value) {
		if(this._stateContext == value) {
			return this._stateContext;
		}
		if(this._stateContext != null) {
			this._stateContext.removeEventListener("stateChange",$bind(this,this.stateContext_stateChangeHandler));
		}
		this._stateContext = value;
		if(this._stateContext != null) {
			this._stateContext.addEventListener("stateChange",$bind(this,this.stateContext_stateChangeHandler),false,0,true);
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._stateContext;
	},
	onAddUIContext: function() {
	},
	onRemoveUIContext: function() {
	},
	update: function() {
	},
	needsStateUpdate: function() {
		return true;
	},
	checkForStateChange: function() {
		if(!this.needsStateUpdate()) {
			return;
		}
		this.setInvalid((feathers_core_InvalidationFlag().default).STATE);
	},
	uiContext_stateChangeHandler: function(event) {
		this.checkForStateChange();
	},
	uiContextToggle_changeHandler: function(event) {
		this.checkForStateChange();
	},
	stateContext_stateChangeHandler: function(event) {
		this.checkForStateChange();
	},
	stateContextToggle_changeHandler: function(event) {
		this.checkForStateChange();
	}
});
ProgrammaticSkin.prototype.__class__ = ProgrammaticSkin.prototype.constructor = $hxClasses["feathers.skins.ProgrammaticSkin"] = ProgrammaticSkin;

// Init



// Statics




// Export

exports["default"] = ProgrammaticSkin;

/***/ }),

/***/ "./lib/_gen/feathers/skins/RectangleSkin.js":
/*!**************************************************!*\
  !*** ./lib/_gen/feathers/skins/RectangleSkin.js ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.skins.RectangleSkin

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_skins_BaseGraphicsPathSkin() {return __webpack_require__(/*! ./../../feathers/skins/BaseGraphicsPathSkin */ "./lib/_gen/feathers/skins/BaseGraphicsPathSkin.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}

// Constructor

var RectangleSkin = function(fill,border) {
	this._cornerRadius = 0.0;
	(feathers_skins_BaseGraphicsPathSkin().default).call(this,fill,border);
}

// Meta

RectangleSkin.__name__ = "feathers.skins.RectangleSkin";
RectangleSkin.__isInterface__ = false;
RectangleSkin.__super__ = (feathers_skins_BaseGraphicsPathSkin().default);
RectangleSkin.prototype = $extend((feathers_skins_BaseGraphicsPathSkin().default).prototype, {
	get_cornerRadius: function() {
		return this._cornerRadius;
	},
	set_cornerRadius: function(value) {
		if(this._cornerRadius == value) {
			return this._cornerRadius;
		}
		this._cornerRadius = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._cornerRadius;
	},
	drawPath: function() {
		var currentBorder = this.getCurrentBorder();
		var thickness = this.getLineThickness(currentBorder);
		var thicknessOffset = thickness / 2.0;
		var drawWidth = Math.max(0.0,this.actualWidth - thickness);
		var drawHeight = Math.max(0.0,this.actualHeight - thickness);
		if(this._cornerRadius == 0.0) {
			this.get_graphics().drawRect(thicknessOffset,thicknessOffset,drawWidth,drawHeight);
		} else {
			var ellipseSize = this._cornerRadius * 2.0;
			ellipseSize = Math.min(ellipseSize,Math.min(this.actualWidth,this.actualHeight));
			this.get_graphics().drawRoundRect(thicknessOffset,thicknessOffset,drawWidth,drawHeight,ellipseSize);
		}
	}
});
RectangleSkin.prototype.__class__ = RectangleSkin.prototype.constructor = $hxClasses["feathers.skins.RectangleSkin"] = RectangleSkin;

// Init



// Statics




// Export

exports["default"] = RectangleSkin;

/***/ }),

/***/ "./lib/_gen/feathers/skins/TabSkin.js":
/*!********************************************!*\
  !*** ./lib/_gen/feathers/skins/TabSkin.js ***!
  \********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.skins.TabSkin

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_skins_BaseGraphicsPathSkin() {return __webpack_require__(/*! ./../../feathers/skins/BaseGraphicsPathSkin */ "./lib/_gen/feathers/skins/BaseGraphicsPathSkin.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}

// Constructor

var TabSkin = function(fill,border,cornerRadius) {
	if(cornerRadius == null) {
		cornerRadius = 0.0;
	}
	this._cornerRadius = 0.0;
	this._drawBaseBorder = true;
	this._cornerRadiusPosition = (feathers_layout_RelativePosition().default).TOP;
	(feathers_skins_BaseGraphicsPathSkin().default).call(this,fill,border);
	this._cornerRadius = cornerRadius;
}

// Meta

TabSkin.__name__ = "feathers.skins.TabSkin";
TabSkin.__isInterface__ = false;
TabSkin.__super__ = (feathers_skins_BaseGraphicsPathSkin().default);
TabSkin.prototype = $extend((feathers_skins_BaseGraphicsPathSkin().default).prototype, {
	get_cornerRadiusPosition: function() {
		return this._cornerRadiusPosition;
	},
	set_cornerRadiusPosition: function(value) {
		if(this._cornerRadiusPosition == value) {
			return this._cornerRadiusPosition;
		}
		this._cornerRadiusPosition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._cornerRadiusPosition;
	},
	get_drawBaseBorder: function() {
		return this._drawBaseBorder;
	},
	set_drawBaseBorder: function(value) {
		if(this._drawBaseBorder == value) {
			return this._drawBaseBorder;
		}
		this._drawBaseBorder = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._drawBaseBorder;
	},
	get_cornerRadius: function() {
		return this._cornerRadius;
	},
	set_cornerRadius: function(value) {
		if(this._cornerRadius == value) {
			return this._cornerRadius;
		}
		this._cornerRadius = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._cornerRadius;
	},
	drawPath: function() {
		var currentBorder = this.getCurrentBorder();
		var thicknessOffset = this.getLineThickness(currentBorder) / 2.0;
		var drawWidth = Math.max(0.0,this.actualWidth - thicknessOffset);
		var drawHeight = Math.max(0.0,this.actualHeight - thicknessOffset);
		var adjustedCornerRadius = Math.min(this._cornerRadius,Math.min(this.actualWidth / 2.0,this.actualHeight / 2.0));
		if(adjustedCornerRadius == 0.0 && this._drawBaseBorder) {
			this.get_graphics().drawRect(thicknessOffset,thicknessOffset,drawWidth,drawHeight);
		} else {
			switch(this._cornerRadiusPosition._hx_index) {
			case 0:
				this.get_graphics().moveTo(thicknessOffset + adjustedCornerRadius,thicknessOffset);
				this.get_graphics().lineTo(drawWidth - adjustedCornerRadius,thicknessOffset);
				this.get_graphics().curveTo(drawWidth,thicknessOffset,drawWidth,thicknessOffset + adjustedCornerRadius);
				if(this._drawBaseBorder) {
					this.get_graphics().lineTo(drawWidth,drawHeight);
					this.get_graphics().lineTo(thicknessOffset,drawHeight);
				} else {
					this.get_graphics().lineTo(drawWidth,this.actualHeight);
					this.get_graphics().lineStyle(0.0,null,0.0,null,null,null,null,0.0);
					this.get_graphics().lineTo(thicknessOffset,this.actualHeight);
					this.applyLineStyle(currentBorder);
				}
				this.get_graphics().lineTo(thicknessOffset,thicknessOffset + adjustedCornerRadius);
				this.get_graphics().curveTo(thicknessOffset,thicknessOffset,thicknessOffset + adjustedCornerRadius,thicknessOffset);
				break;
			case 1:
				this.get_graphics().moveTo(thicknessOffset,thicknessOffset);
				this.get_graphics().lineTo(drawWidth - adjustedCornerRadius,thicknessOffset);
				this.get_graphics().curveTo(drawWidth,thicknessOffset,drawWidth,thicknessOffset + adjustedCornerRadius);
				this.get_graphics().lineTo(drawWidth,drawHeight - adjustedCornerRadius);
				this.get_graphics().curveTo(drawWidth,drawHeight,drawWidth - adjustedCornerRadius,drawHeight);
				if(this._drawBaseBorder) {
					this.get_graphics().lineTo(thicknessOffset,drawHeight);
					this.get_graphics().lineTo(thicknessOffset,thicknessOffset);
				} else {
					this.get_graphics().lineTo(0.0,drawHeight);
					this.get_graphics().lineStyle(0.0,null,0.0,null,null,null,null,0.0);
					this.get_graphics().lineTo(0.0,thicknessOffset);
					this.applyLineStyle(currentBorder);
				}
				break;
			case 2:
				if(this._drawBaseBorder) {
					this.get_graphics().moveTo(thicknessOffset,thicknessOffset);
					this.get_graphics().lineTo(drawWidth,thicknessOffset);
				} else {
					this.get_graphics().lineStyle(0.0,null,0.0,null,null,null,null,0.0);
					this.get_graphics().moveTo(thicknessOffset,0.0);
					this.get_graphics().lineTo(drawWidth,0.0);
					this.applyLineStyle(currentBorder);
				}
				this.get_graphics().lineTo(drawWidth,drawHeight - adjustedCornerRadius);
				this.get_graphics().curveTo(drawWidth,drawHeight,drawWidth - adjustedCornerRadius,drawHeight);
				this.get_graphics().lineTo(thicknessOffset + adjustedCornerRadius,drawHeight);
				this.get_graphics().curveTo(thicknessOffset,drawHeight,thicknessOffset,drawHeight - adjustedCornerRadius);
				this.get_graphics().lineTo(thicknessOffset,thicknessOffset);
				break;
			case 3:
				this.get_graphics().moveTo(thicknessOffset + adjustedCornerRadius,thicknessOffset);
				if(this._drawBaseBorder) {
					this.get_graphics().lineTo(drawWidth,thicknessOffset);
					this.get_graphics().lineTo(drawWidth,drawHeight);
				} else {
					this.get_graphics().lineTo(this.actualWidth,thicknessOffset);
					this.get_graphics().lineStyle(0.0,null,0.0,null,null,null,null,0.0);
					this.get_graphics().lineTo(this.actualWidth,drawHeight);
					this.applyLineStyle(currentBorder);
				}
				this.get_graphics().lineTo(thicknessOffset + adjustedCornerRadius,drawHeight);
				this.get_graphics().curveTo(thicknessOffset,drawHeight,thicknessOffset,drawHeight - adjustedCornerRadius);
				this.get_graphics().lineTo(thicknessOffset,thicknessOffset + adjustedCornerRadius);
				this.get_graphics().curveTo(thicknessOffset,thicknessOffset,thicknessOffset + adjustedCornerRadius,thicknessOffset);
				break;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Tab cornerRadiusPosition not supported: " + (Std().default).string(this._cornerRadiusPosition)));
			}
		}
	}
});
TabSkin.prototype.__class__ = TabSkin.prototype.constructor = $hxClasses["feathers.skins.TabSkin"] = TabSkin;

// Init



// Statics




// Export

exports["default"] = TabSkin;

/***/ }),

/***/ "./lib/_gen/feathers/skins/TopAndBottomBorderSkin.js":
/*!***********************************************************!*\
  !*** ./lib/_gen/feathers/skins/TopAndBottomBorderSkin.js ***!
  \***********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.skins.TopAndBottomBorderSkin

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_skins_BaseGraphicsPathSkin() {return __webpack_require__(/*! ./../../feathers/skins/BaseGraphicsPathSkin */ "./lib/_gen/feathers/skins/BaseGraphicsPathSkin.js");}

// Constructor

var TopAndBottomBorderSkin = function(fill,border) {
	(feathers_skins_BaseGraphicsPathSkin().default).call(this,fill,border);
}

// Meta

TopAndBottomBorderSkin.__name__ = "feathers.skins.TopAndBottomBorderSkin";
TopAndBottomBorderSkin.__isInterface__ = false;
TopAndBottomBorderSkin.__super__ = (feathers_skins_BaseGraphicsPathSkin().default);
TopAndBottomBorderSkin.prototype = $extend((feathers_skins_BaseGraphicsPathSkin().default).prototype, {
	draw: function() {
		var currentBorder = this.getCurrentBorder();
		var thickness = this.getLineThickness(currentBorder);
		var thicknessOffset = thickness / 2.0;
		var currentFill = this.getCurrentFill();
		if(currentFill != null) {
			this.applyFillStyle(currentFill);
			this.get_graphics().drawRect(0.0,thicknessOffset,this.actualWidth,Math.max(0.0,this.actualHeight - thickness));
			this.get_graphics().endFill();
		}
		var minLineX = Math.min(this.actualWidth,thicknessOffset);
		var minLineY = Math.min(this.actualHeight,thicknessOffset);
		var maxLineX = Math.max(minLineX,this.actualWidth - thicknessOffset);
		var maxLineY = Math.max(minLineY,this.actualHeight - thicknessOffset);
		this.applyLineStyle(currentBorder);
		this.get_graphics().moveTo(minLineX,minLineY);
		this.get_graphics().lineTo(maxLineX,minLineY);
		this.get_graphics().moveTo(minLineX,maxLineY);
		this.get_graphics().lineTo(maxLineX,maxLineY);
	}
});
TopAndBottomBorderSkin.prototype.__class__ = TopAndBottomBorderSkin.prototype.constructor = $hxClasses["feathers.skins.TopAndBottomBorderSkin"] = TopAndBottomBorderSkin;

// Init



// Statics




// Export

exports["default"] = TopAndBottomBorderSkin;

/***/ }),

/***/ "./lib/_gen/feathers/skins/TriangleSkin.js":
/*!*************************************************!*\
  !*** ./lib/_gen/feathers/skins/TriangleSkin.js ***!
  \*************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.skins.TriangleSkin

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_skins_BaseGraphicsPathSkin() {return __webpack_require__(/*! ./../../feathers/skins/BaseGraphicsPathSkin */ "./lib/_gen/feathers/skins/BaseGraphicsPathSkin.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}

// Constructor

var TriangleSkin = function(fill,border) {
	this._drawBaseBorder = true;
	this._pointPosition = (feathers_layout_RelativePosition().default).TOP;
	(feathers_skins_BaseGraphicsPathSkin().default).call(this,fill,border);
}

// Meta

TriangleSkin.__name__ = "feathers.skins.TriangleSkin";
TriangleSkin.__isInterface__ = false;
TriangleSkin.__super__ = (feathers_skins_BaseGraphicsPathSkin().default);
TriangleSkin.prototype = $extend((feathers_skins_BaseGraphicsPathSkin().default).prototype, {
	get_pointPosition: function() {
		return this._pointPosition;
	},
	set_pointPosition: function(value) {
		if(this._pointPosition == value) {
			return this._pointPosition;
		}
		this._pointPosition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._pointPosition;
	},
	get_drawBaseBorder: function() {
		return this._drawBaseBorder;
	},
	set_drawBaseBorder: function(value) {
		if(this._drawBaseBorder == value) {
			return this._drawBaseBorder;
		}
		this._drawBaseBorder = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._drawBaseBorder;
	},
	drawPath: function() {
		var currentBorder = this.getCurrentBorder();
		var thicknessOffset = this.getLineThickness(currentBorder) / 2.0;
		var maxX = Math.max(0.0,this.actualWidth - thicknessOffset);
		var maxY = Math.max(0.0,this.actualHeight - thicknessOffset);
		switch(this._pointPosition._hx_index) {
		case 0:
			this.get_graphics().moveTo(this.actualWidth / 2.0,thicknessOffset);
			if(this._drawBaseBorder) {
				this.get_graphics().lineTo(maxX,maxY);
				this.get_graphics().lineTo(thicknessOffset,maxY);
			} else {
				this.get_graphics().lineTo(maxX,this.actualHeight);
				this.get_graphics().lineStyle(0.0,null,0.0,null,null,null,null,0.0);
				this.get_graphics().lineTo(thicknessOffset,this.actualHeight);
				this.applyLineStyle(currentBorder);
			}
			this.get_graphics().lineTo(this.actualWidth / 2.0,thicknessOffset);
			break;
		case 1:
			if(this._drawBaseBorder) {
				this.get_graphics().moveTo(thicknessOffset,thicknessOffset);
			} else {
				this.get_graphics().moveTo(0.0,thicknessOffset);
			}
			this.get_graphics().lineTo(maxX,this.actualHeight / 2.0);
			if(this._drawBaseBorder) {
				this.get_graphics().lineTo(thicknessOffset,maxY);
				this.get_graphics().lineTo(thicknessOffset,thicknessOffset);
			} else {
				this.get_graphics().lineTo(0.0,maxY);
				this.get_graphics().lineStyle(0.0,null,0.0,null,null,null,null,0.0);
				this.get_graphics().lineTo(0.0,thicknessOffset);
				this.applyLineStyle(currentBorder);
			}
			break;
		case 2:
			if(this._drawBaseBorder) {
				this.get_graphics().moveTo(thicknessOffset,thicknessOffset);
				this.get_graphics().lineTo(maxX,thicknessOffset);
			} else {
				this.get_graphics().lineStyle(0.0,null,0.0,null,null,null,null,0.0);
				this.get_graphics().moveTo(thicknessOffset,0.0);
				this.get_graphics().lineTo(maxX,0.0);
				this.applyLineStyle(currentBorder);
			}
			this.get_graphics().lineTo(this.actualWidth / 2.0,maxY);
			if(this._drawBaseBorder) {
				this.get_graphics().lineTo(thicknessOffset,thicknessOffset);
			} else {
				this.get_graphics().lineTo(thicknessOffset,0.0);
			}
			break;
		case 3:
			if(this._drawBaseBorder) {
				this.get_graphics().moveTo(maxX,thicknessOffset);
				this.get_graphics().lineTo(maxX,maxY);
			} else {
				this.get_graphics().moveTo(this.actualWidth,thicknessOffset);
				this.get_graphics().lineStyle(0.0,null,0.0,null,null,null,null,0.0);
				this.get_graphics().lineTo(this.actualWidth,maxY);
				this.applyLineStyle(currentBorder);
			}
			this.get_graphics().lineTo(thicknessOffset,this.actualHeight / 2.0);
			if(this._drawBaseBorder) {
				this.get_graphics().lineTo(maxX,thicknessOffset);
			} else {
				this.get_graphics().lineTo(this.actualWidth,thicknessOffset);
			}
			break;
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Triangle pointPosition not supported: " + (Std().default).string(this._pointPosition)));
		}
	}
});
TriangleSkin.prototype.__class__ = TriangleSkin.prototype.constructor = $hxClasses["feathers.skins.TriangleSkin"] = TriangleSkin;

// Init



// Statics




// Export

exports["default"] = TriangleSkin;

/***/ }),

/***/ "./lib/_gen/feathers/skins/UnderlineSkin.js":
/*!**************************************************!*\
  !*** ./lib/_gen/feathers/skins/UnderlineSkin.js ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.skins.UnderlineSkin

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_skins_BaseGraphicsPathSkin() {return __webpack_require__(/*! ./../../feathers/skins/BaseGraphicsPathSkin */ "./lib/_gen/feathers/skins/BaseGraphicsPathSkin.js");}

// Constructor

var UnderlineSkin = function(fill,border) {
	(feathers_skins_BaseGraphicsPathSkin().default).call(this,fill,border);
}

// Meta

UnderlineSkin.__name__ = "feathers.skins.UnderlineSkin";
UnderlineSkin.__isInterface__ = false;
UnderlineSkin.__super__ = (feathers_skins_BaseGraphicsPathSkin().default);
UnderlineSkin.prototype = $extend((feathers_skins_BaseGraphicsPathSkin().default).prototype, {
	draw: function() {
		var currentBorder = this.getCurrentBorder();
		var thicknessOffset = this.getLineThickness(currentBorder) / 2.0;
		var currentFill = this.getCurrentFill();
		if(currentFill != null) {
			this.applyFillStyle(currentFill);
			this.get_graphics().drawRect(0.0,0.0,this.actualWidth,Math.max(0.0,this.actualHeight - thicknessOffset));
			this.get_graphics().endFill();
		}
		var minLineX = Math.min(this.actualWidth,thicknessOffset);
		var minLineY = Math.min(this.actualHeight,thicknessOffset);
		var maxLineX = Math.max(minLineX,this.actualWidth - thicknessOffset);
		var maxLineY = Math.max(minLineY,this.actualHeight - thicknessOffset);
		this.applyLineStyle(currentBorder);
		this.get_graphics().moveTo(minLineX,maxLineY);
		this.get_graphics().lineTo(maxLineX,maxLineY);
	}
});
UnderlineSkin.prototype.__class__ = UnderlineSkin.prototype.constructor = $hxClasses["feathers.skins.UnderlineSkin"] = UnderlineSkin;

// Init



// Statics




// Export

exports["default"] = UnderlineSkin;

/***/ }),

/***/ "./lib/_gen/feathers/skins/VerticalLineSkin.js":
/*!*****************************************************!*\
  !*** ./lib/_gen/feathers/skins/VerticalLineSkin.js ***!
  \*****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.skins.VerticalLineSkin

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_skins_BaseGraphicsPathSkin() {return __webpack_require__(/*! ./../../feathers/skins/BaseGraphicsPathSkin */ "./lib/_gen/feathers/skins/BaseGraphicsPathSkin.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}

// Constructor

var VerticalLineSkin = function(fill,border) {
	this._paddingBottom = 0.0;
	this._paddingTop = 0.0;
	this._horizontalAlign = (feathers_layout_HorizontalAlign().default).CENTER;
	(feathers_skins_BaseGraphicsPathSkin().default).call(this,fill,border);
}

// Meta

VerticalLineSkin.__name__ = "feathers.skins.VerticalLineSkin";
VerticalLineSkin.__isInterface__ = false;
VerticalLineSkin.__super__ = (feathers_skins_BaseGraphicsPathSkin().default);
VerticalLineSkin.prototype = $extend((feathers_skins_BaseGraphicsPathSkin().default).prototype, {
	get_horizontalAlign: function() {
		return this._horizontalAlign;
	},
	set_horizontalAlign: function(value) {
		if(this._horizontalAlign == value) {
			return this._horizontalAlign;
		}
		this._horizontalAlign = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._horizontalAlign;
	},
	get_paddingTop: function() {
		return this._paddingTop;
	},
	set_paddingTop: function(value) {
		if(this._paddingTop == value) {
			return this._paddingTop;
		}
		this._paddingTop = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._paddingTop;
	},
	get_paddingBottom: function() {
		return this._paddingBottom;
	},
	set_paddingBottom: function(value) {
		if(this._paddingBottom == value) {
			return this._paddingBottom;
		}
		this._paddingBottom = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._paddingBottom;
	},
	draw: function() {
		var currentBorder = this.getCurrentBorder();
		var thicknessOffset = this.getLineThickness(currentBorder) / 2.0;
		var currentFill = this.getCurrentFill();
		if(currentFill != null) {
			this.applyFillStyle(currentFill);
			this.get_graphics().drawRect(0.0,0.0,this.actualWidth,this.actualHeight);
			this.get_graphics().endFill();
		}
		var positionX;
		switch(this._horizontalAlign._hx_index) {
		case 0:
			positionX = thicknessOffset;
			break;
		case 1:
			positionX = this.actualWidth / 2.0;
			break;
		case 2:
			positionX = this.actualWidth - thicknessOffset;
			break;
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown horizontal align: " + (Std().default).string(this._horizontalAlign)));
		}
		var minLineY = Math.min(this.actualHeight,thicknessOffset + this._paddingTop);
		var maxLineY = Math.max(minLineY,this.actualHeight - thicknessOffset - this._paddingTop - this._paddingBottom);
		this.applyLineStyle(currentBorder);
		this.get_graphics().moveTo(positionX,minLineY);
		this.get_graphics().lineTo(positionX,maxLineY);
	}
});
VerticalLineSkin.prototype.__class__ = VerticalLineSkin.prototype.constructor = $hxClasses["feathers.skins.VerticalLineSkin"] = VerticalLineSkin;

// Init



// Statics




// Export

exports["default"] = VerticalLineSkin;

/***/ }),

/***/ "./lib/_gen/feathers/skins/activity/DotsActivitySkin.js":
/*!**************************************************************!*\
  !*** ./lib/_gen/feathers/skins/activity/DotsActivitySkin.js ***!
  \**************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.skins.activity.DotsActivitySkin

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_skins_IIndeterminateSkin() {return __webpack_require__(/*! ./../../../feathers/skins/IIndeterminateSkin */ "./lib/_gen/feathers/skins/IIndeterminateSkin.js");}
function feathers_skins_ProgrammaticSkin() {return __webpack_require__(/*! ./../../../feathers/skins/ProgrammaticSkin */ "./lib/_gen/feathers/skins/ProgrammaticSkin.js");}
function feathers_core_InvalidationFlag() {return __webpack_require__(/*! ./../../../feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");}
function feathers_utils_MathUtil() {return __webpack_require__(/*! ./../../../feathers/utils/MathUtil */ "./lib/_gen/feathers/utils/MathUtil.js");}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function Std() {return __webpack_require__(/*! ./../../../Std */ "./lib/_gen/Std.js");}

// Constructor

var DotsActivitySkin = function() {
	this._endDotAlpha = 0.0;
	this._dotAlpha = 1.0;
	this._endDotColor = null;
	this._dotColor = 0;
	this._endDotRadius = null;
	this._dotRadius = 3.0;
	this._numEmptyDots = 0;
	this._numDots = 8;
	this._indeterminatePosition = 0.0;
	(feathers_skins_ProgrammaticSkin().default).call(this);
}

// Meta

DotsActivitySkin.__name__ = "feathers.skins.activity.DotsActivitySkin";
DotsActivitySkin.__isInterface__ = false;
DotsActivitySkin.__interfaces__ = [(feathers_skins_IIndeterminateSkin().default)];
DotsActivitySkin.__super__ = (feathers_skins_ProgrammaticSkin().default);
DotsActivitySkin.prototype = $extend((feathers_skins_ProgrammaticSkin().default).prototype, {
	get_indeterminatePosition: function() {
		return this._indeterminatePosition;
	},
	set_indeterminatePosition: function(value) {
		if(this._indeterminatePosition == value) {
			return this._indeterminatePosition;
		}
		this._indeterminatePosition = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).DATA);
		return this._indeterminatePosition;
	},
	get_numDots: function() {
		return this._numDots;
	},
	set_numDots: function(value) {
		if(this._numDots == value) {
			return this._numDots;
		}
		this._numDots = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._numDots;
	},
	get_numEmptyDots: function() {
		return this._numEmptyDots;
	},
	set_numEmptyDots: function(value) {
		if(this._numEmptyDots == value) {
			return this._numEmptyDots;
		}
		this._numEmptyDots = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._numEmptyDots;
	},
	get_dotRadius: function() {
		return this._dotRadius;
	},
	set_dotRadius: function(value) {
		if(this._dotRadius == value) {
			return this._dotRadius;
		}
		this._dotRadius = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._dotRadius;
	},
	get_endDotRadius: function() {
		return this._endDotRadius;
	},
	set_endDotRadius: function(value) {
		if(this._endDotRadius == value) {
			return this._endDotRadius;
		}
		this._endDotRadius = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._endDotRadius;
	},
	get_dotColor: function() {
		return this._dotColor;
	},
	set_dotColor: function(value) {
		if(this._dotColor == value) {
			return this._dotColor;
		}
		this._dotColor = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._dotColor;
	},
	get_endDotColor: function() {
		return this._endDotColor;
	},
	set_endDotColor: function(value) {
		if(this._endDotColor == value) {
			return this._endDotColor;
		}
		this._endDotColor = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._endDotColor;
	},
	get_dotAlpha: function() {
		return this._dotAlpha;
	},
	set_dotAlpha: function(value) {
		if(this._dotAlpha == value) {
			return this._dotAlpha;
		}
		this._dotAlpha = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._dotAlpha;
	},
	get_endDotAlpha: function() {
		return this._endDotAlpha;
	},
	set_endDotAlpha: function(value) {
		if(this._endDotAlpha == value) {
			return this._endDotAlpha;
		}
		this._endDotAlpha = value;
		this.setInvalid((feathers_core_InvalidationFlag().default).STYLES);
		return this._endDotAlpha;
	},
	update: function() {
		var dataInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).DATA);
		var sizeInvalid = this.isInvalid((feathers_core_InvalidationFlag().default).SIZE);
		sizeInvalid = this.measure() || sizeInvalid;
		if(dataInvalid || sizeInvalid) {
			this.drawSkin();
		}
	},
	measure: function() {
		var needsWidth = this.get_explicitWidth() == null;
		var needsHeight = this.get_explicitHeight() == null;
		if(!needsWidth && !needsHeight) {
			return false;
		}
		var endDotRadius = this._dotRadius;
		if(this._endDotRadius != null) {
			endDotRadius = this._endDotRadius;
		}
		var maxDotRadius = Math.max(this.get_dotRadius(),endDotRadius);
		var newWidth = this.get_explicitWidth();
		if(needsWidth) {
			if(needsHeight) {
				newWidth = maxDotRadius * this._numDots;
			} else {
				newWidth = this.get_explicitHeight();
			}
		}
		var newHeight = this.get_explicitHeight();
		if(needsHeight) {
			if(needsHeight) {
				newHeight = maxDotRadius * this._numDots;
			} else {
				newHeight = this.get_explicitWidth();
			}
		}
		return this.saveMeasurements(newWidth,newHeight);
	},
	drawSkin: function() {
		this.get_graphics().clear();
		if(this._numDots == 0) {
			return;
		}
		var radius = Math.min(this.actualWidth,this.actualHeight) / 2.0;
		var centerX = this.actualWidth / 2.0;
		var centerY = this.actualHeight / 2.0;
		var degreesPerSegment = 360.0 / this._numDots;
		var nearestAngle = (feathers_utils_MathUtil().default).roundToNearest(this._indeterminatePosition * 360.0,degreesPerSegment);
		var endDotRadius = this._dotRadius;
		if(this._endDotRadius != null) {
			endDotRadius = this._endDotRadius;
		}
		var maxDotRadius = Math.max(this.get_dotRadius(),endDotRadius);
		var adjustScale = true;
		var adjustAlpha = true;
		this.get_graphics().beginFill(16711935,0.0);
		this.get_graphics().drawCircle(centerX,centerY,radius);
		this.get_graphics().endFill();
		var numEmptyDots = 0;
		if(this._numDots > this._numEmptyDots) {
			numEmptyDots = this._numEmptyDots;
		}
		var _g = 0;
		var _g1 = this._numDots;
		while(_g < _g1) {
			var i = _g++;
			var point = (openfl_geom_Point()).polar(radius - maxDotRadius,-i * 2.0 * Math.PI / this._numDots + nearestAngle * Math.PI / 180.0);
			var ratio = i / (this._numDots - numEmptyDots);
			var currentColor = this._dotColor;
			if(this._endDotColor != null && this._endDotColor != this._dotColor) {
				currentColor = this.blendColors(this._dotColor,this._endDotColor,ratio);
			}
			var currentAlpha = this._dotAlpha;
			if(adjustAlpha) {
				currentAlpha = this._dotAlpha - (this._dotAlpha - this._endDotAlpha) * ratio;
			}
			var currentRadius = this.get_dotRadius();
			if(adjustScale) {
				currentRadius = this.get_dotRadius() - (this.get_dotRadius() - endDotRadius) * ratio;
			}
			this.get_graphics().beginFill(currentColor,currentAlpha);
			this.get_graphics().drawCircle(centerX + point.x,centerY + point.y,currentRadius);
			this.get_graphics().endFill();
		}
	},
	blendColors: function(color1,color2,ratio) {
		var r1 = color1 >>> 16 & 255;
		var g1 = color1 >>> 8 & 255;
		var b1 = color1 & 255;
		var r2 = color2 >>> 16 & 255;
		var g2 = color2 >>> 8 & 255;
		var b2 = color2 & 255;
		var r3 = r1 + (Std().default).int((r2 - r1) * ratio);
		var g3 = g1 + (Std().default).int((g2 - g1) * ratio);
		var b3 = b1 + (Std().default).int((b2 - b1) * ratio);
		return r3 << 16 | g3 << 8 | b3;
	}
});
DotsActivitySkin.prototype.__class__ = DotsActivitySkin.prototype.constructor = $hxClasses["feathers.skins.activity.DotsActivitySkin"] = DotsActivitySkin;

// Init



// Statics




// Export

exports["default"] = DotsActivitySkin;

/***/ }),

/***/ "./lib/_gen/feathers/style/ClassVariantStyleProvider.js":
/*!**************************************************************!*\
  !*** ./lib/_gen/feathers/style/ClassVariantStyleProvider.js ***!
  \**************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.style.ClassVariantStyleProvider

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_style_IStyleProvider() {return __webpack_require__(/*! ./../../feathers/style/IStyleProvider */ "./lib/_gen/feathers/style/IStyleProvider.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function haxe_ds_EnumValueMap() {return __webpack_require__(/*! ./../../haxe/ds/EnumValueMap */ "./lib/_gen/haxe/ds/EnumValueMap.js");}
function Type() {return __webpack_require__(/*! ./../../Type */ "./lib/_gen/Type.js");}
function feathers_style__$ClassVariantStyleProvider_StyleTarget() {return __webpack_require__(/*! ./../../feathers/style/_ClassVariantStyleProvider/StyleTarget */ "./lib/_gen/feathers/style/_ClassVariantStyleProvider/StyleTarget.js");}
function Reflect() {return __webpack_require__(/*! ./../../Reflect */ "./lib/_gen/Reflect.js");}
function feathers_events_StyleProviderEvent() {return __webpack_require__(/*! ./../../feathers/events/StyleProviderEvent */ "./lib/_gen/feathers/events/StyleProviderEvent.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_style_IVariantStyleObject() {return __webpack_require__(/*! ./../../feathers/style/IVariantStyleObject */ "./lib/_gen/feathers/style/IVariantStyleObject.js");}

// Constructor

var ClassVariantStyleProvider = function() {
	(openfl_events_EventDispatcher()).call(this);
}

// Meta

ClassVariantStyleProvider.__name__ = "feathers.style.ClassVariantStyleProvider";
ClassVariantStyleProvider.__isInterface__ = false;
ClassVariantStyleProvider.__interfaces__ = [(feathers_style_IStyleProvider().default)];
ClassVariantStyleProvider.__super__ = (openfl_events_EventDispatcher());
ClassVariantStyleProvider.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	setStyleFunction: function(type,variant,callback) {
		var _gthis = this;
		if(this.styleTargets == null) {
			this.styleTargets = new (haxe_ds_EnumValueMap().default)();
		}
		var typeName = (Type().default).getClassName(type);
		var styleTarget = variant == null ? (feathers_style__$ClassVariantStyleProvider_StyleTarget().default).Class(typeName) : (feathers_style__$ClassVariantStyleProvider_StyleTarget().default).ClassAndVariant(typeName,variant);
		if(callback == null) {
			if(!this.styleTargets.exists(styleTarget)) {
				return;
			}
			this.styleTargets.remove(styleTarget);
		} else {
			var oldCallback = this.styleTargets.get(styleTarget);
			if((Reflect().default).compareMethods(callback,oldCallback) || (Reflect().default).compare(callback,oldCallback) == 0) {
				return;
			}
			this.styleTargets.set(styleTarget,callback);
		}
		(feathers_events_StyleProviderEvent().default).dispatch(this,"stylesChange",function(target) {
			var styleContext = _gthis.getStyleContext(target);
			var variant1 = _gthis.getVariant(target);
			var otherCallback = _gthis.getStyleFunctionInternal(styleContext,variant1,false);
			if(!(Reflect().default).compareMethods(callback,otherCallback)) {
				return (Reflect().default).compare(callback,otherCallback) == 0;
			} else {
				return true;
			}
		});
	},
	getStyleFunction: function(type,variant) {
		return this.getStyleFunctionInternal(type,variant,true);
	},
	applyStyles: function(target) {
		if(this.styleTargets == null) {
			return;
		}
		var styleContext = this.getStyleContext(target);
		var variant = this.getVariant(target);
		var callback = this.getStyleFunctionInternal(styleContext,variant,false);
		if(callback == null) {
			return;
		}
		callback(target);
	},
	getStyleContext: function(target) {
		var styleContext = null;
		if((js_Boot().default).__implements(target,(feathers_style_IVariantStyleObject().default))) {
			var variantObject = (js_Boot().default).__cast(target , (feathers_style_IVariantStyleObject().default));
			styleContext = variantObject.get_styleContext();
		}
		if(styleContext == null) {
			styleContext = (Type().default).getClass(target);
		}
		return styleContext;
	},
	getVariant: function(target) {
		var variant = null;
		if((js_Boot().default).__implements(target,(feathers_style_IVariantStyleObject().default))) {
			var variantObject = (js_Boot().default).__cast(target , (feathers_style_IVariantStyleObject().default));
			variant = variantObject.get_variant();
		}
		return variant;
	},
	getStyleFunctionInternal: function(type,variant,strict) {
		if(this.styleTargets == null) {
			return null;
		}
		var typeName = (Type().default).getClassName(type);
		var styleTarget = variant == null ? (feathers_style__$ClassVariantStyleProvider_StyleTarget().default).Class(typeName) : (feathers_style__$ClassVariantStyleProvider_StyleTarget().default).ClassAndVariant(typeName,variant);
		var result = this.styleTargets.get(styleTarget);
		if(result != null || strict) {
			return result;
		}
		return this.styleTargets.get((feathers_style__$ClassVariantStyleProvider_StyleTarget().default).Class(typeName));
	}
});
ClassVariantStyleProvider.prototype.__class__ = ClassVariantStyleProvider.prototype.constructor = $hxClasses["feathers.style.ClassVariantStyleProvider"] = ClassVariantStyleProvider;

// Init



// Statics




// Export

exports["default"] = ClassVariantStyleProvider;

/***/ }),

/***/ "./lib/_gen/feathers/style/FunctionStyleProvider.js":
/*!**********************************************************!*\
  !*** ./lib/_gen/feathers/style/FunctionStyleProvider.js ***!
  \**********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.style.FunctionStyleProvider

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_style_IStyleProvider() {return __webpack_require__(/*! ./../../feathers/style/IStyleProvider */ "./lib/_gen/feathers/style/IStyleProvider.js");}
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_StyleProviderEvent() {return __webpack_require__(/*! ./../../feathers/events/StyleProviderEvent */ "./lib/_gen/feathers/events/StyleProviderEvent.js");}

// Constructor

var FunctionStyleProvider = function(callback) {
	(openfl_events_EventDispatcher()).call(this);
	this.set_callback(callback);
}

// Meta

FunctionStyleProvider.__name__ = "feathers.style.FunctionStyleProvider";
FunctionStyleProvider.__isInterface__ = false;
FunctionStyleProvider.__interfaces__ = [(feathers_style_IStyleProvider().default)];
FunctionStyleProvider.__super__ = (openfl_events_EventDispatcher());
FunctionStyleProvider.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_callback: function() {
		return this._callback;
	},
	set_callback: function(value) {
		if(this._callback == value) {
			return this._callback;
		}
		this._callback = value;
		(feathers_events_StyleProviderEvent().default).dispatch(this,"stylesChange");
		return this._callback;
	},
	applyStyles: function(target) {
		if(this._callback == null) {
			return;
		}
		this._callback(target);
	}
});
FunctionStyleProvider.prototype.__class__ = FunctionStyleProvider.prototype.constructor = $hxClasses["feathers.style.FunctionStyleProvider"] = FunctionStyleProvider;

// Init



// Statics




// Export

exports["default"] = FunctionStyleProvider;

/***/ }),

/***/ "./lib/_gen/feathers/style/IDarkModeTheme.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/style/IDarkModeTheme.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.style.IDarkModeTheme

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_style_ITheme() {return __webpack_require__(/*! ./../../feathers/style/ITheme */ "./lib/_gen/feathers/style/ITheme.js");}

// Constructor

var IDarkModeTheme = function() {}

// Meta

IDarkModeTheme.__name__ = "feathers.style.IDarkModeTheme";
IDarkModeTheme.__isInterface__ = true;
IDarkModeTheme.__interfaces__ = [(feathers_style_ITheme().default)];
IDarkModeTheme.prototype = {
	
};
IDarkModeTheme.prototype.__class__ = IDarkModeTheme.prototype.constructor = $hxClasses["feathers.style.IDarkModeTheme"] = IDarkModeTheme;

// Init



// Statics




// Export

exports["default"] = IDarkModeTheme;

/***/ }),

/***/ "./lib/_gen/feathers/style/IStyleObject.js":
/*!*************************************************!*\
  !*** ./lib/_gen/feathers/style/IStyleObject.js ***!
  \*************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.style.IStyleObject

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var IStyleObject = function() {}

// Meta

IStyleObject.__name__ = "feathers.style.IStyleObject";
IStyleObject.__isInterface__ = true;
IStyleObject.prototype = {
	
};
IStyleObject.prototype.__class__ = IStyleObject.prototype.constructor = $hxClasses["feathers.style.IStyleObject"] = IStyleObject;

// Init



// Statics




// Export

exports["default"] = IStyleObject;

/***/ }),

/***/ "./lib/_gen/feathers/style/IStyleProvider.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/style/IStyleProvider.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.style.IStyleProvider

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function openfl_events_IEventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.IEventDispatcher);}

// Constructor

var IStyleProvider = function() {}

// Meta

IStyleProvider.__name__ = "feathers.style.IStyleProvider";
IStyleProvider.__isInterface__ = true;
IStyleProvider.__interfaces__ = [(openfl_events_IEventDispatcher())];
IStyleProvider.prototype = {
	
};
IStyleProvider.prototype.__class__ = IStyleProvider.prototype.constructor = $hxClasses["feathers.style.IStyleProvider"] = IStyleProvider;

// Init



// Statics




// Export

exports["default"] = IStyleProvider;

/***/ }),

/***/ "./lib/_gen/feathers/style/ITheme.js":
/*!*******************************************!*\
  !*** ./lib/_gen/feathers/style/ITheme.js ***!
  \*******************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.style.ITheme

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var ITheme = function() {}

// Meta

ITheme.__name__ = "feathers.style.ITheme";
ITheme.__isInterface__ = true;
ITheme.prototype = {
	
};
ITheme.prototype.__class__ = ITheme.prototype.constructor = $hxClasses["feathers.style.ITheme"] = ITheme;

// Init



// Statics




// Export

exports["default"] = ITheme;

/***/ }),

/***/ "./lib/_gen/feathers/style/IVariantStyleObject.js":
/*!********************************************************!*\
  !*** ./lib/_gen/feathers/style/IVariantStyleObject.js ***!
  \********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.style.IVariantStyleObject

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
function feathers_style_IStyleObject() {return __webpack_require__(/*! ./../../feathers/style/IStyleObject */ "./lib/_gen/feathers/style/IStyleObject.js");}

// Constructor

var IVariantStyleObject = function() {}

// Meta

IVariantStyleObject.__name__ = "feathers.style.IVariantStyleObject";
IVariantStyleObject.__isInterface__ = true;
IVariantStyleObject.__interfaces__ = [(feathers_style_IStyleObject().default)];
IVariantStyleObject.prototype = {
	
};
IVariantStyleObject.prototype.__class__ = IVariantStyleObject.prototype.constructor = $hxClasses["feathers.style.IVariantStyleObject"] = IVariantStyleObject;

// Init



// Statics




// Export

exports["default"] = IVariantStyleObject;

/***/ }),

/***/ "./lib/_gen/feathers/style/Theme.js":
/*!******************************************!*\
  !*** ./lib/_gen/feathers/style/Theme.js ***!
  \******************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.style.Theme

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function feathers_themes_steel_DefaultSteelTheme() {return __webpack_require__(/*! ./../../feathers/themes/steel/DefaultSteelTheme */ "./lib/_gen/feathers/themes/steel/DefaultSteelTheme.js");}
function haxe_ds_ObjectMap() {return __webpack_require__(/*! ./../../haxe/ds/ObjectMap */ "./lib/_gen/haxe/ds/ObjectMap.js");}
function openfl_display_DisplayObject() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObject);}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_style_IStyleObject() {return __webpack_require__(/*! ./../../feathers/style/IStyleObject */ "./lib/_gen/feathers/style/IStyleObject.js");}

// Constructor

var Theme = function(){}

// Meta

Theme.__name__ = "feathers.style.Theme";
Theme.__isInterface__ = false;
Theme.prototype = {
	
};
Theme.prototype.__class__ = Theme.prototype.constructor = $hxClasses["feathers.style.Theme"] = Theme;

// Init



// Statics

Theme.get_fallbackTheme = function() {
	if(Theme._fallbackTheme == null) {
		Theme._fallbackTheme = new (feathers_themes_steel_DefaultSteelTheme().default)();
	}
	return Theme._fallbackTheme;
}
Theme.setTheme = function(theme,root,disposeOldTheme) {
	if(disposeOldTheme == null) {
		disposeOldTheme = true;
	}
	var oldTheme = null;
	if(root == null) {
		oldTheme = Theme.primaryTheme;
		Theme.primaryTheme = theme;
	} else if(Theme.roots == null) {
		Theme.roots = [root];
		var _g = new (haxe_ds_ObjectMap().default)();
		_g.set(root,theme);
		Theme.rootToTheme = _g;
	} else {
		oldTheme = Theme.rootToTheme.get(root);
		if(oldTheme == null) {
			Theme.roots.push(root);
		}
		Theme.rootToTheme.set(root,theme);
	}
	if(oldTheme != null && disposeOldTheme) {
		oldTheme.dispose();
	}
}
Theme.getTheme = function(object) {
	if(((object) instanceof (openfl_display_DisplayObject()))) {
		var current = (js_Boot().default).__cast(object , (openfl_display_DisplayObject()));
		while(current != null) {
			if((js_Boot().default).__implements(current,(feathers_style_IStyleObject().default))) {
				var currentStylable = (js_Boot().default).__cast(current , (feathers_style_IStyleObject().default));
				if(!currentStylable.get_themeEnabled()) {
					return null;
				}
			}
			current = current.parent;
		}
		if(Theme.roots != null) {
			var displayObject = (js_Boot().default).__cast(object , (openfl_display_DisplayObject()));
			var _g = 0;
			var _g1 = Theme.roots;
			while(_g < _g1.length) {
				var root = _g1[_g];
				++_g;
				if(root.contains(displayObject)) {
					return Theme.rootToTheme.get(root);
				}
			}
		}
	} else if(object != null && !object.get_themeEnabled()) {
		return null;
	}
	if(Theme.primaryTheme != null) {
		return Theme.primaryTheme;
	}
	return Theme.get_fallbackTheme();
}
Theme.roots = null

// Export

exports["default"] = Theme;

/***/ }),

/***/ "./lib/_gen/feathers/style/_ClassVariantStyleProvider/StyleTarget.js":
/*!***************************************************************************!*\
  !*** ./lib/_gen/feathers/style/_ClassVariantStyleProvider/StyleTarget.js ***!
  \***************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.style._ClassVariantStyleProvider.StyleTarget

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var StyleTarget = $hxEnums["feathers.style._ClassVariantStyleProvider.StyleTarget"] = { __ename__ : "feathers.style._ClassVariantStyleProvider.StyleTarget", __constructs__ : ["Class","ClassAndVariant"]
  ,ClassAndVariant: ($_=function(type,variant) { return {_hx_index:1,type:type,variant:variant,__enum__:"feathers.style._ClassVariantStyleProvider.StyleTarget",toString:$estr}; },$_.__params__ = ["type","variant"],$_)
  ,Class: ($_=function(type) { return {_hx_index:0,type:type,__enum__:"feathers.style._ClassVariantStyleProvider.StyleTarget",toString:$estr}; },$_.__params__ = ["type"],$_)
};

exports["default"] = StyleTarget;

/***/ }),

/***/ "./lib/_gen/feathers/text/TextFormat.js":
/*!**********************************************!*\
  !*** ./lib/_gen/feathers/text/TextFormat.js ***!
  \**********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.text.TextFormat

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_utils_TextFormatUtil() {return __webpack_require__(/*! ./../../feathers/utils/TextFormatUtil */ "./lib/_gen/feathers/utils/TextFormatUtil.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function openfl_text_TextFormat() {return (__webpack_require__(/*! openfl */ "openfl").text.TextFormat);}

// Constructor

var TextFormat = function(font,size,color,bold,italic,underline,url,target,align,leftMargin,rightMargin,indent,leading) {
	(openfl_events_EventDispatcher()).call(this);
	this._textFormat = new (openfl_text_TextFormat())(font,size,color,bold,italic,underline,url,target,align,leftMargin,rightMargin,indent,leading);
}

// Meta

TextFormat.__name__ = "feathers.text.TextFormat";
TextFormat.__isInterface__ = false;
TextFormat.__super__ = (openfl_events_EventDispatcher());
TextFormat.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_font: function() {
		return this._textFormat.font;
	},
	set_font: function(value) {
		if(this._textFormat.font == value) {
			return this._textFormat.font;
		}
		this._textFormat = (feathers_utils_TextFormatUtil().default).clone(this._textFormat);
		this._textFormat.font = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._textFormat.font;
	},
	get_size: function() {
		return this._textFormat.size;
	},
	set_size: function(value) {
		if(this._textFormat.size == value) {
			return this._textFormat.size;
		}
		this._textFormat = (feathers_utils_TextFormatUtil().default).clone(this._textFormat);
		this._textFormat.size = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._textFormat.size;
	},
	get_color: function() {
		return this._textFormat.color;
	},
	set_color: function(value) {
		if(this._textFormat.color == value) {
			return this._textFormat.color;
		}
		this._textFormat = (feathers_utils_TextFormatUtil().default).clone(this._textFormat);
		this._textFormat.color = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._textFormat.color;
	},
	get_bold: function() {
		return this._textFormat.bold;
	},
	set_bold: function(value) {
		if(this._textFormat.bold == value) {
			return this._textFormat.bold;
		}
		this._textFormat = (feathers_utils_TextFormatUtil().default).clone(this._textFormat);
		this._textFormat.bold = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._textFormat.bold;
	},
	get_italic: function() {
		return this._textFormat.italic;
	},
	set_italic: function(value) {
		if(this._textFormat.italic == value) {
			return this._textFormat.italic;
		}
		this._textFormat = (feathers_utils_TextFormatUtil().default).clone(this._textFormat);
		this._textFormat.italic = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._textFormat.italic;
	},
	get_underline: function() {
		return this._textFormat.underline;
	},
	set_underline: function(value) {
		if(this._textFormat.underline == value) {
			return this._textFormat.underline;
		}
		this._textFormat = (feathers_utils_TextFormatUtil().default).clone(this._textFormat);
		this._textFormat.underline = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._textFormat.underline;
	},
	get_url: function() {
		return this._textFormat.url;
	},
	set_url: function(value) {
		if(this._textFormat.url == value) {
			return this._textFormat.url;
		}
		this._textFormat = (feathers_utils_TextFormatUtil().default).clone(this._textFormat);
		this._textFormat.url = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._textFormat.url;
	},
	get_target: function() {
		return this._textFormat.target;
	},
	set_target: function(value) {
		if(this._textFormat.target == value) {
			return this._textFormat.target;
		}
		this._textFormat = (feathers_utils_TextFormatUtil().default).clone(this._textFormat);
		this._textFormat.target = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._textFormat.target;
	},
	get_align: function() {
		return this._textFormat.align;
	},
	set_align: function(value) {
		if(this._textFormat.align == value) {
			return this._textFormat.align;
		}
		this._textFormat = (feathers_utils_TextFormatUtil().default).clone(this._textFormat);
		this._textFormat.align = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._textFormat.align;
	},
	get_leftMargin: function() {
		return this._textFormat.leftMargin;
	},
	set_leftMargin: function(value) {
		if(this._textFormat.leftMargin == value) {
			return this._textFormat.leftMargin;
		}
		this._textFormat = (feathers_utils_TextFormatUtil().default).clone(this._textFormat);
		this._textFormat.leftMargin = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._textFormat.leftMargin;
	},
	get_rightMargin: function() {
		return this._textFormat.rightMargin;
	},
	set_rightMargin: function(value) {
		if(this._textFormat.rightMargin == value) {
			return this._textFormat.rightMargin;
		}
		this._textFormat = (feathers_utils_TextFormatUtil().default).clone(this._textFormat);
		this._textFormat.rightMargin = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._textFormat.rightMargin;
	},
	get_indent: function() {
		return this._textFormat.indent;
	},
	set_indent: function(value) {
		if(this._textFormat.indent == value) {
			return this._textFormat.indent;
		}
		this._textFormat = (feathers_utils_TextFormatUtil().default).clone(this._textFormat);
		this._textFormat.indent = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._textFormat.indent;
	},
	get_leading: function() {
		return this._textFormat.leading;
	},
	set_leading: function(value) {
		if(this._textFormat.leading == value) {
			return this._textFormat.leading;
		}
		this._textFormat = (feathers_utils_TextFormatUtil().default).clone(this._textFormat);
		this._textFormat.leading = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._textFormat.leading;
	},
	get_blockIndent: function() {
		return this._textFormat.blockIndent;
	},
	set_blockIndent: function(value) {
		if(this._textFormat.blockIndent == value) {
			return this._textFormat.blockIndent;
		}
		this._textFormat = (feathers_utils_TextFormatUtil().default).clone(this._textFormat);
		this._textFormat.blockIndent = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._textFormat.blockIndent;
	},
	get_bullet: function() {
		return this._textFormat.bullet;
	},
	set_bullet: function(value) {
		if(this._textFormat.bullet == value) {
			return this._textFormat.bullet;
		}
		this._textFormat = (feathers_utils_TextFormatUtil().default).clone(this._textFormat);
		this._textFormat.bullet = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._textFormat.bullet;
	},
	get_kerning: function() {
		return this._textFormat.kerning;
	},
	set_kerning: function(value) {
		if(this._textFormat.kerning == value) {
			return this._textFormat.kerning;
		}
		this._textFormat = (feathers_utils_TextFormatUtil().default).clone(this._textFormat);
		this._textFormat.kerning = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._textFormat.kerning;
	},
	get_letterSpacing: function() {
		return this._textFormat.letterSpacing;
	},
	set_letterSpacing: function(value) {
		if(this._textFormat.letterSpacing == value) {
			return this._textFormat.letterSpacing;
		}
		this._textFormat = (feathers_utils_TextFormatUtil().default).clone(this._textFormat);
		this._textFormat.letterSpacing = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._textFormat.letterSpacing;
	},
	get_tabStops: function() {
		return this._textFormat.tabStops;
	},
	set_tabStops: function(value) {
		if(this._textFormat.tabStops == value) {
			return this._textFormat.tabStops;
		}
		this._textFormat = (feathers_utils_TextFormatUtil().default).clone(this._textFormat);
		this._textFormat.tabStops = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._textFormat.tabStops;
	},
	clone: function() {
		var clone = new TextFormat(this.get_font(),this.get_size(),this.get_color(),this.get_bold(),this.get_italic(),this.get_underline(),this.get_url(),this.get_target(),this.get_align(),this.get_leftMargin(),this.get_rightMargin(),this.get_indent(),this.get_leading());
		clone._textFormat.blockIndent = this.get_blockIndent();
		clone._textFormat.bullet = this.get_bullet();
		clone._textFormat.kerning = this.get_kerning();
		clone._textFormat.letterSpacing = this.get_letterSpacing();
		clone._textFormat.tabStops = this.get_tabStops();
		return clone;
	},
	toSimpleTextFormat: function() {
		return this._textFormat;
	}
});
TextFormat.prototype.__class__ = TextFormat.prototype.constructor = $hxClasses["feathers.text.TextFormat"] = TextFormat;

// Init



// Statics




// Export

exports["default"] = TextFormat;

/***/ }),

/***/ "./lib/_gen/feathers/themes/ClassVariantTheme.js":
/*!*******************************************************!*\
  !*** ./lib/_gen/feathers/themes/ClassVariantTheme.js ***!
  \*******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.ClassVariantTheme

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function feathers_style_ITheme() {return __webpack_require__(/*! ./../../feathers/style/ITheme */ "./lib/_gen/feathers/style/ITheme.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_style_IVariantStyleObject() {return __webpack_require__(/*! ./../../feathers/style/IVariantStyleObject */ "./lib/_gen/feathers/style/IVariantStyleObject.js");}
function Type() {return __webpack_require__(/*! ./../../Type */ "./lib/_gen/Type.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_style_ClassVariantStyleProvider() {return __webpack_require__(/*! ./../../feathers/style/ClassVariantStyleProvider */ "./lib/_gen/feathers/style/ClassVariantStyleProvider.js");}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}

// Constructor

var ClassVariantTheme = function() {
	this.styleProvider = new (feathers_style_ClassVariantStyleProvider().default)();
}

// Meta

ClassVariantTheme.__name__ = "feathers.themes.ClassVariantTheme";
ClassVariantTheme.__isInterface__ = false;
ClassVariantTheme.__interfaces__ = [(feathers_style_ITheme().default)];
ClassVariantTheme.prototype = {
	getStyleProvider: function(target) {
		var styleContext = null;
		var variant = null;
		if((js_Boot().default).__implements(target,(feathers_style_IVariantStyleObject().default))) {
			var variantObject = (js_Boot().default).__cast(target , (feathers_style_IVariantStyleObject().default));
			styleContext = variantObject.get_styleContext();
			variant = variantObject.get_variant();
		}
		if(styleContext == null) {
			styleContext = (Type().default).getClass(target);
		}
		var styleFunction = this.styleProvider.getStyleFunction(styleContext,variant);
		if(styleFunction != null) {
			return this.styleProvider;
		}
		if(variant == null) {
			return null;
		}
		var fallbackTheme = (feathers_style_Theme().default).get_fallbackTheme();
		if(fallbackTheme != null && fallbackTheme != this && ((fallbackTheme) instanceof ClassVariantTheme)) {
			var fallbackStyleProvider = (Std().default).downcast(fallbackTheme.getStyleProvider(target),(feathers_style_ClassVariantStyleProvider().default));
			if(fallbackStyleProvider != null) {
				var styleFunction1 = fallbackStyleProvider.getStyleFunction(styleContext,variant);
				if(styleFunction1 != null) {
					return null;
				}
			}
		}
		styleFunction = this.styleProvider.getStyleFunction(styleContext,null);
		if(styleFunction != null) {
			return this.styleProvider;
		}
		return null;
	},
	dispose: function() {
		(feathers_events_FeathersEvent().default).dispatch(this.styleProvider,"clear");
	}
};
ClassVariantTheme.prototype.__class__ = ClassVariantTheme.prototype.constructor = $hxClasses["feathers.themes.ClassVariantTheme"] = ClassVariantTheme;

// Init



// Statics




// Export

exports["default"] = ClassVariantTheme;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js":
/*!**********************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/BaseSteelTheme.js ***!
  \**********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.BaseSteelTheme

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_style_IDarkModeTheme() {return __webpack_require__(/*! ./../../../feathers/style/IDarkModeTheme */ "./lib/_gen/feathers/style/IDarkModeTheme.js");}
function feathers_themes_ClassVariantTheme() {return __webpack_require__(/*! ./../../../feathers/themes/ClassVariantTheme */ "./lib/_gen/feathers/themes/ClassVariantTheme.js");}
function feathers_events_StyleProviderEvent() {return __webpack_require__(/*! ./../../../feathers/events/StyleProviderEvent */ "./lib/_gen/feathers/events/StyleProviderEvent.js");}
function feathers_graphics_FillStyle() {return __webpack_require__(/*! ./../../../feathers/graphics/FillStyle */ "./lib/_gen/feathers/graphics/FillStyle.js");}
function feathers_graphics__$CreateGradientBoxMatrix_CreateGradientBoxMatrix_$Impl_$() {return __webpack_require__(/*! ./../../../feathers/graphics/_CreateGradientBoxMatrix/CreateGradientBoxMatrix_Impl_ */ "./lib/_gen/feathers/graphics/_CreateGradientBoxMatrix/CreateGradientBoxMatrix_Impl_.js");}
function feathers_graphics_LineStyle() {return __webpack_require__(/*! ./../../../feathers/graphics/LineStyle */ "./lib/_gen/feathers/graphics/LineStyle.js");}
function feathers_text_TextFormat() {return __webpack_require__(/*! ./../../../feathers/text/TextFormat */ "./lib/_gen/feathers/text/TextFormat.js");}
function feathers_style_ClassVariantStyleProvider() {return __webpack_require__(/*! ./../../../feathers/style/ClassVariantStyleProvider */ "./lib/_gen/feathers/style/ClassVariantStyleProvider.js");}
function js_Boot() {return __webpack_require__(/*! ./../../../js/Boot */ "./lib/_gen/js/Boot.js");}

// Constructor

var BaseSteelTheme = function(themeColor,darkThemeColor) {
	this._darkMode = false;
	(feathers_themes_ClassVariantTheme().default).call(this);
	this.customThemeColor = themeColor;
	this.customDarkThemeColor = darkThemeColor;
	this.refreshColors();
	this.refreshFonts();
	this.styleProvider = new (feathers_style_ClassVariantStyleProvider().default)();
	var htmlWindow = (js_Boot().default).__cast($global , Window);
	this.mediaQueryList = htmlWindow.matchMedia("(hover: hover) and (pointer: fine)");
	this.mediaQueryList.addListener($bind(this,this.mediaQueryList_changeHandler));
}

// Meta

BaseSteelTheme.__name__ = "feathers.themes.steel.BaseSteelTheme";
BaseSteelTheme.__isInterface__ = false;
BaseSteelTheme.__interfaces__ = [(feathers_style_IDarkModeTheme().default)];
BaseSteelTheme.__super__ = (feathers_themes_ClassVariantTheme().default);
BaseSteelTheme.prototype = $extend((feathers_themes_ClassVariantTheme().default).prototype, {
	get_darkMode: function() {
		return this._darkMode;
	},
	set_darkMode: function(value) {
		if(this._darkMode == value) {
			return this._darkMode;
		}
		this._darkMode = value;
		this.refreshColors();
		(feathers_events_StyleProviderEvent().default).dispatch(this.styleProvider,"stylesChange");
		return this._darkMode;
	},
	dispose: function() {
		if(this.mediaQueryList != null) {
			this.mediaQueryList.removeListener($bind(this,this.mediaQueryList_changeHandler));
			this.mediaQueryList = null;
		}
		(feathers_themes_ClassVariantTheme().default).prototype.dispose.call(this);
	},
	refreshColors: function() {
		if(this._darkMode) {
			if(this.customDarkThemeColor != null) {
				this.themeColor = this.customDarkThemeColor;
			} else if(this.customThemeColor != null) {
				this.themeColor = this.customThemeColor;
			} else {
				this.themeColor = 5205919;
			}
			this.offsetThemeColor = this.darken(this.themeColor,986895);
			this.rootFillColor = 3684408;
			this.controlFillColor1 = 6250335;
			this.controlFillColor2 = 5000268;
			this.controlDisabledFillColor = 3158064;
			this.scrollBarThumbFillColor = 7303023;
			this.scrollBarThumbDisabledFillColor = 4144959;
			this.insetFillColor = 1579032;
			this.disabledInsetFillColor = 2631720;
			this.insetBorderColor = 4737096;
			this.disabledInsetBorderColor = 3684408;
			this.selectedInsetBorderColor = this.themeColor;
			this.activeFillBorderColor = this.darken(this.themeColor,3092271);
			this.selectedBorderColor = this.lighten(this.themeColor,986895);
			this.focusBorderColor = this.lighten(this.themeColor,986895);
			this.containerFillColor = 3684408;
			this.headerFillColor = 4144959;
			this.overlayFillColor = 7303023;
			this.subHeadingFillColor = 2894892;
			this.dangerFillColor = 10440527;
			this.offsetDangerFillColor = this.darken(this.dangerFillColor,986895);
			this.dangerBorderColor = this.darken(this.dangerFillColor,3092271);
			this.borderColor = 526344;
			this.dividerColor = 2631720;
			this.subHeadingDividerColor = 789516;
			this.textColor = 15856113;
			this.disabledTextColor = 9408399;
			this.secondaryTextColor = 11513775;
			this.dangerTextColor = 13385535;
		} else {
			if(this.customThemeColor != null) {
				this.themeColor = this.customThemeColor;
			} else {
				this.themeColor = 10535152;
			}
			this.offsetThemeColor = this.darken(this.themeColor,986895);
			this.rootFillColor = 16316664;
			this.controlFillColor1 = 16777215;
			this.controlFillColor2 = 15263976;
			this.controlDisabledFillColor = 15724527;
			this.scrollBarThumbFillColor = 9408399;
			this.scrollBarThumbDisabledFillColor = 13619151;
			this.insetFillColor = 16579836;
			this.disabledInsetFillColor = 15856113;
			this.insetBorderColor = 11316396;
			this.disabledInsetBorderColor = 13421772;
			this.selectedInsetBorderColor = this.darken(this.themeColor,3092271);
			this.activeFillBorderColor = this.darken(this.themeColor,3092271);
			this.selectedBorderColor = this.darken(this.themeColor,3092271);
			this.focusBorderColor = this.darken(this.themeColor,3092271);
			this.containerFillColor = 16316664;
			this.headerFillColor = 15527148;
			this.overlayFillColor = 9408399;
			this.subHeadingFillColor = 14671839;
			this.dangerFillColor = 15769760;
			this.offsetDangerFillColor = this.darken(this.dangerFillColor,986895);
			this.dangerBorderColor = this.darken(this.dangerFillColor,3092271);
			this.borderColor = 11316396;
			this.dividerColor = 14671839;
			this.subHeadingDividerColor = 13619151;
			this.textColor = 2039583;
			this.disabledTextColor = 10461087;
			this.secondaryTextColor = 7303023;
			this.dangerTextColor = 13385535;
		}
	},
	refreshFonts: function() {
		this.fontName = "_sans";
		this.refreshFontSizes();
	},
	refreshFontSizes: function() {
		this.fontSize = 14;
		this.headerFontSize = 18;
		this.detailFontSize = 12;
	},
	getThemeFill: function() {
		return (feathers_graphics_FillStyle().default).SolidColor(this.themeColor);
	},
	getControlFill: function() {
		return (feathers_graphics_FillStyle().default).SolidColor(this.controlFillColor2);
	},
	getControlDisabledFill: function() {
		return (feathers_graphics_FillStyle().default).SolidColor(this.controlDisabledFillColor,0.7);
	},
	getButtonFill: function() {
		return (feathers_graphics_FillStyle().default).Gradient("linear",[this.controlFillColor1,this.controlFillColor2],[1.0,1.0],[0,255],(feathers_graphics__$CreateGradientBoxMatrix_CreateGradientBoxMatrix_$Impl_$().default).fromRadians(Math.PI / 2.0));
	},
	getButtonDownFill: function() {
		return (feathers_graphics_FillStyle().default).Gradient("linear",[this.controlFillColor2,this.controlFillColor1],[1.0,1.0],[0,255],(feathers_graphics__$CreateGradientBoxMatrix_CreateGradientBoxMatrix_$Impl_$().default).fromRadians(Math.PI / 2.0));
	},
	getButtonDisabledFill: function() {
		return (feathers_graphics_FillStyle().default).SolidColor(this.controlDisabledFillColor,0.7);
	},
	getScrollBarThumbFill: function() {
		return (feathers_graphics_FillStyle().default).SolidColor(this.scrollBarThumbFillColor);
	},
	getScrollBarThumbDisabledFill: function() {
		return (feathers_graphics_FillStyle().default).SolidColor(this.scrollBarThumbDisabledFillColor,0.7);
	},
	getBorder: function(thickness) {
		if(thickness == null) {
			thickness = 1.0;
		}
		return (feathers_graphics_LineStyle().default).SolidColor(thickness,this.borderColor);
	},
	getButtonBorder: function(thickness) {
		if(thickness == null) {
			thickness = 1.0;
		}
		return (feathers_graphics_LineStyle().default).SolidColor(thickness,this.borderColor);
	},
	getInsetBorder: function(thickness) {
		if(thickness == null) {
			thickness = 1.0;
		}
		return (feathers_graphics_LineStyle().default).SolidColor(thickness,this.insetBorderColor);
	},
	getDisabledInsetBorder: function(thickness) {
		if(thickness == null) {
			thickness = 1.0;
		}
		return (feathers_graphics_LineStyle().default).SolidColor(thickness,this.disabledInsetBorderColor);
	},
	getSelectedInsetBorder: function(thickness) {
		if(thickness == null) {
			thickness = 1.0;
		}
		return (feathers_graphics_LineStyle().default).SolidColor(thickness,this.selectedInsetBorderColor);
	},
	getThemeBorder: function(thickness) {
		if(thickness == null) {
			thickness = 1.0;
		}
		return (feathers_graphics_LineStyle().default).SolidColor(thickness,this.themeColor);
	},
	getSelectedBorder: function(thickness) {
		if(thickness == null) {
			thickness = 1.0;
		}
		return (feathers_graphics_LineStyle().default).SolidColor(thickness,this.selectedBorderColor);
	},
	getActiveFillBorder: function(thickness) {
		if(thickness == null) {
			thickness = 1.0;
		}
		return (feathers_graphics_LineStyle().default).SolidColor(thickness,this.activeFillBorderColor);
	},
	getContainerBorder: function(thickness) {
		if(thickness == null) {
			thickness = 1.0;
		}
		return (feathers_graphics_LineStyle().default).SolidColor(thickness,this.borderColor);
	},
	getDividerBorder: function(thickness) {
		if(thickness == null) {
			thickness = 1.0;
		}
		return (feathers_graphics_LineStyle().default).SolidColor(thickness,this.dividerColor);
	},
	getDividerFill: function() {
		return (feathers_graphics_FillStyle().default).SolidColor(this.dividerColor);
	},
	getSubHeadingDividerBorder: function(thickness) {
		if(thickness == null) {
			thickness = 1.0;
		}
		return (feathers_graphics_LineStyle().default).SolidColor(thickness,this.subHeadingDividerColor);
	},
	getSubHeadingDividerFill: function() {
		return (feathers_graphics_FillStyle().default).SolidColor(this.subHeadingDividerColor);
	},
	getFocusBorder: function(thickness) {
		if(thickness == null) {
			thickness = 1.0;
		}
		return (feathers_graphics_LineStyle().default).SolidColor(thickness,this.focusBorderColor);
	},
	getInsetFill: function() {
		return (feathers_graphics_FillStyle().default).SolidColor(this.insetFillColor);
	},
	getDisabledInsetFill: function() {
		return (feathers_graphics_FillStyle().default).SolidColor(this.disabledInsetFillColor);
	},
	getActiveThemeFill: function() {
		var colors = [this.themeColor,this.offsetThemeColor];
		return (feathers_graphics_FillStyle().default).Gradient("linear",colors,[1.0,1.0],[0,255],(feathers_graphics__$CreateGradientBoxMatrix_CreateGradientBoxMatrix_$Impl_$().default).fromRadians(Math.PI / 2.0));
	},
	getReversedActiveThemeFill: function() {
		var colors = [this.offsetThemeColor,this.themeColor];
		return (feathers_graphics_FillStyle().default).Gradient("linear",colors,[1.0,1.0],[0,255],(feathers_graphics__$CreateGradientBoxMatrix_CreateGradientBoxMatrix_$Impl_$().default).fromRadians(Math.PI / 2.0));
	},
	getDangerFill: function() {
		var colors = [this.dangerFillColor,this.offsetDangerFillColor];
		return (feathers_graphics_FillStyle().default).Gradient("linear",colors,[1.0,1.0],[0,255],(feathers_graphics__$CreateGradientBoxMatrix_CreateGradientBoxMatrix_$Impl_$().default).fromRadians(Math.PI / 2.0));
	},
	getReversedDangerFill: function() {
		var colors = [this.offsetDangerFillColor,this.dangerFillColor];
		return (feathers_graphics_FillStyle().default).Gradient("linear",colors,[1.0,1.0],[0,255],(feathers_graphics__$CreateGradientBoxMatrix_CreateGradientBoxMatrix_$Impl_$().default).fromRadians(Math.PI / 2.0));
	},
	getDangerBorder: function(thickness) {
		if(thickness == null) {
			thickness = 1.0;
		}
		return (feathers_graphics_LineStyle().default).SolidColor(thickness,this.dangerBorderColor);
	},
	getOverlayFill: function() {
		return (feathers_graphics_FillStyle().default).SolidColor(this.overlayFillColor,0.8);
	},
	getRootFill: function() {
		return (feathers_graphics_FillStyle().default).SolidColor(this.rootFillColor);
	},
	getContainerFill: function() {
		return (feathers_graphics_FillStyle().default).SolidColor(this.containerFillColor);
	},
	getSubHeadingFill: function() {
		return (feathers_graphics_FillStyle().default).SolidColor(this.subHeadingFillColor);
	},
	getTextFormat: function(align) {
		if(align == null) {
			align = "left";
		}
		return new (feathers_text_TextFormat().default)(this.fontName,this.fontSize,this.textColor,null,null,null,null,null,align);
	},
	getDisabledTextFormat: function(align) {
		if(align == null) {
			align = "left";
		}
		return new (feathers_text_TextFormat().default)(this.fontName,this.fontSize,this.disabledTextColor,null,null,null,null,null,align);
	},
	getSecondaryTextFormat: function(align) {
		if(align == null) {
			align = "left";
		}
		return new (feathers_text_TextFormat().default)(this.fontName,this.fontSize,this.secondaryTextColor,null,null,null,null,null,align);
	},
	getDangerTextFormat: function(align) {
		if(align == null) {
			align = "left";
		}
		return new (feathers_text_TextFormat().default)(this.fontName,this.fontSize,this.dangerTextColor,null,null,null,null,null,align);
	},
	getHeaderTextFormat: function(align) {
		if(align == null) {
			align = "left";
		}
		return new (feathers_text_TextFormat().default)(this.fontName,this.headerFontSize,this.textColor,null,null,null,null,null,align);
	},
	getDisabledHeaderTextFormat: function(align) {
		if(align == null) {
			align = "left";
		}
		return new (feathers_text_TextFormat().default)(this.fontName,this.headerFontSize,this.disabledTextColor,null,null,null,null,null,align);
	},
	getDetailTextFormat: function(align) {
		if(align == null) {
			align = "left";
		}
		return new (feathers_text_TextFormat().default)(this.fontName,this.detailFontSize,this.secondaryTextColor,null,null,null,null,null,align);
	},
	getDisabledDetailTextFormat: function(align) {
		if(align == null) {
			align = "left";
		}
		return new (feathers_text_TextFormat().default)(this.fontName,this.detailFontSize,this.disabledTextColor,null,null,null,null,null,align);
	},
	getHeaderFill: function() {
		return (feathers_graphics_FillStyle().default).SolidColor(this.headerFillColor);
	},
	lighten: function(color,offset) {
		var r1 = color >> 16 & 255;
		var g1 = color >> 8 & 255;
		var b1 = color & 255;
		var r2 = offset >> 16 & 255;
		var g2 = offset >> 8 & 255;
		var b2 = offset & 255;
		r1 += r2;
		if(r1 > 255) {
			r1 = 255;
		}
		g1 += g2;
		if(g1 > 255) {
			g1 = 255;
		}
		b1 += b2;
		if(b1 > 255) {
			b1 = 255;
		}
		return (r1 << 16) + (g1 << 8) + b1;
	},
	darken: function(color,offset) {
		var r1 = color >> 16 & 255;
		var g1 = color >> 8 & 255;
		var b1 = color & 255;
		var r2 = offset >> 16 & 255;
		var g2 = offset >> 8 & 255;
		var b2 = offset & 255;
		r1 -= r2;
		if(r1 < 0) {
			r1 = 0;
		}
		g1 -= g2;
		if(g1 < 0) {
			g1 = 0;
		}
		b1 -= b2;
		if(b1 < 0) {
			b1 = 0;
		}
		return (r1 << 16) + (g1 << 8) + b1;
	},
	mediaQueryList_changeHandler: function(event) {
		(feathers_events_StyleProviderEvent().default).dispatch(this.styleProvider,"stylesChange");
	}
});
BaseSteelTheme.prototype.__class__ = BaseSteelTheme.prototype.constructor = $hxClasses["feathers.themes.steel.BaseSteelTheme"] = BaseSteelTheme;

// Init



// Statics




// Export

exports["default"] = BaseSteelTheme;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/DefaultSteelTheme.js":
/*!*************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/DefaultSteelTheme.js ***!
  \*************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.DefaultSteelTheme

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}

// Constructor

var DefaultSteelTheme = function(themeColor,darkThemeColor) {
	(feathers_themes_steel_BaseSteelTheme().default).call(this,themeColor,darkThemeColor);
}

// Meta

DefaultSteelTheme.__name__ = "feathers.themes.steel.DefaultSteelTheme";
DefaultSteelTheme.__isInterface__ = false;
DefaultSteelTheme.__super__ = (feathers_themes_steel_BaseSteelTheme().default);
DefaultSteelTheme.prototype = $extend((feathers_themes_steel_BaseSteelTheme().default).prototype, {
	
});
DefaultSteelTheme.prototype.__class__ = DefaultSteelTheme.prototype.constructor = $hxClasses["feathers.themes.steel.DefaultSteelTheme"] = DefaultSteelTheme;

// Init



// Statics




// Export

exports["default"] = DefaultSteelTheme;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/SteelTheme.js":
/*!******************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/SteelTheme.js ***!
  \******************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.SteelTheme

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_themes_steel_components_SteelActivityIndicatorStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelActivityIndicatorStyles */ "./lib/_gen/feathers/themes/steel/components/SteelActivityIndicatorStyles.js");}
function feathers_themes_steel_components_SteelAlertStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelAlertStyles */ "./lib/_gen/feathers/themes/steel/components/SteelAlertStyles.js");}
function feathers_themes_steel_components_SteelApplicationStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelApplicationStyles */ "./lib/_gen/feathers/themes/steel/components/SteelApplicationStyles.js");}
function feathers_themes_steel_components_SteelButtonStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelButtonStyles */ "./lib/_gen/feathers/themes/steel/components/SteelButtonStyles.js");}
function feathers_themes_steel_components_SteelButtonBarStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelButtonBarStyles */ "./lib/_gen/feathers/themes/steel/components/SteelButtonBarStyles.js");}
function feathers_themes_steel_components_SteelCalloutStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelCalloutStyles */ "./lib/_gen/feathers/themes/steel/components/SteelCalloutStyles.js");}
function feathers_themes_steel_components_SteelCheckStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelCheckStyles */ "./lib/_gen/feathers/themes/steel/components/SteelCheckStyles.js");}
function feathers_themes_steel_components_SteelComboBoxStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelComboBoxStyles */ "./lib/_gen/feathers/themes/steel/components/SteelComboBoxStyles.js");}
function feathers_themes_steel_components_SteelDatePickerStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelDatePickerStyles */ "./lib/_gen/feathers/themes/steel/components/SteelDatePickerStyles.js");}
function feathers_themes_steel_components_SteelDrawerStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelDrawerStyles */ "./lib/_gen/feathers/themes/steel/components/SteelDrawerStyles.js");}
function feathers_themes_steel_components_SteelFormStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelFormStyles */ "./lib/_gen/feathers/themes/steel/components/SteelFormStyles.js");}
function feathers_themes_steel_components_SteelFormItemStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelFormItemStyles */ "./lib/_gen/feathers/themes/steel/components/SteelFormItemStyles.js");}
function feathers_themes_steel_components_SteelGridViewStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelGridViewStyles */ "./lib/_gen/feathers/themes/steel/components/SteelGridViewStyles.js");}
function feathers_themes_steel_components_SteelGroupListViewStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelGroupListViewStyles */ "./lib/_gen/feathers/themes/steel/components/SteelGroupListViewStyles.js");}
function feathers_themes_steel_components_SteelHDividedBoxStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelHDividedBoxStyles */ "./lib/_gen/feathers/themes/steel/components/SteelHDividedBoxStyles.js");}
function feathers_themes_steel_components_SteelHeaderStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelHeaderStyles */ "./lib/_gen/feathers/themes/steel/components/SteelHeaderStyles.js");}
function feathers_themes_steel_components_SteelHProgressBarStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelHProgressBarStyles */ "./lib/_gen/feathers/themes/steel/components/SteelHProgressBarStyles.js");}
function feathers_themes_steel_components_SteelHScrollBarStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelHScrollBarStyles */ "./lib/_gen/feathers/themes/steel/components/SteelHScrollBarStyles.js");}
function feathers_themes_steel_components_SteelHSliderStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelHSliderStyles */ "./lib/_gen/feathers/themes/steel/components/SteelHSliderStyles.js");}
function feathers_themes_steel_components_SteelHierarchicalItemRendererStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelHierarchicalItemRendererStyles */ "./lib/_gen/feathers/themes/steel/components/SteelHierarchicalItemRendererStyles.js");}
function feathers_themes_steel_components_SteelItemRendererStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelItemRendererStyles */ "./lib/_gen/feathers/themes/steel/components/SteelItemRendererStyles.js");}
function feathers_themes_steel_components_SteelLabelStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelLabelStyles */ "./lib/_gen/feathers/themes/steel/components/SteelLabelStyles.js");}
function feathers_themes_steel_components_SteelLayoutGroupStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelLayoutGroupStyles */ "./lib/_gen/feathers/themes/steel/components/SteelLayoutGroupStyles.js");}
function feathers_themes_steel_components_SteelLayoutGroupItemRendererStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelLayoutGroupItemRendererStyles */ "./lib/_gen/feathers/themes/steel/components/SteelLayoutGroupItemRendererStyles.js");}
function feathers_themes_steel_components_SteelListViewStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelListViewStyles */ "./lib/_gen/feathers/themes/steel/components/SteelListViewStyles.js");}
function feathers_themes_steel_components_SteelNumericStepperStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelNumericStepperStyles */ "./lib/_gen/feathers/themes/steel/components/SteelNumericStepperStyles.js");}
function feathers_themes_steel_components_SteelPageIndicatorStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelPageIndicatorStyles */ "./lib/_gen/feathers/themes/steel/components/SteelPageIndicatorStyles.js");}
function feathers_themes_steel_components_SteelPageNavigatorStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelPageNavigatorStyles */ "./lib/_gen/feathers/themes/steel/components/SteelPageNavigatorStyles.js");}
function feathers_themes_steel_components_SteelPanelStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelPanelStyles */ "./lib/_gen/feathers/themes/steel/components/SteelPanelStyles.js");}
function feathers_themes_steel_components_SteelPopUpDatePickerStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelPopUpDatePickerStyles */ "./lib/_gen/feathers/themes/steel/components/SteelPopUpDatePickerStyles.js");}
function feathers_themes_steel_components_SteelPopUpListViewStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelPopUpListViewStyles */ "./lib/_gen/feathers/themes/steel/components/SteelPopUpListViewStyles.js");}
function feathers_themes_steel_components_SteelRadioStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelRadioStyles */ "./lib/_gen/feathers/themes/steel/components/SteelRadioStyles.js");}
function feathers_themes_steel_components_SteelRouterNavigatorStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelRouterNavigatorStyles */ "./lib/_gen/feathers/themes/steel/components/SteelRouterNavigatorStyles.js");}
function feathers_themes_steel_components_SteelScrollContainerStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelScrollContainerStyles */ "./lib/_gen/feathers/themes/steel/components/SteelScrollContainerStyles.js");}
function feathers_themes_steel_components_SteelStackNavigatorStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelStackNavigatorStyles */ "./lib/_gen/feathers/themes/steel/components/SteelStackNavigatorStyles.js");}
function feathers_themes_steel_components_SteelTabBarStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelTabBarStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTabBarStyles.js");}
function feathers_themes_steel_components_SteelTabNavigatorStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelTabNavigatorStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTabNavigatorStyles.js");}
function feathers_themes_steel_components_SteelTextAreaStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelTextAreaStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTextAreaStyles.js");}
function feathers_themes_steel_components_SteelTextCalloutStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelTextCalloutStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTextCalloutStyles.js");}
function feathers_themes_steel_components_SteelTextInputStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelTextInputStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTextInputStyles.js");}
function feathers_themes_steel_components_SteelToggleButtonStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelToggleButtonStyles */ "./lib/_gen/feathers/themes/steel/components/SteelToggleButtonStyles.js");}
function feathers_themes_steel_components_SteelToggleSwitchStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelToggleSwitchStyles */ "./lib/_gen/feathers/themes/steel/components/SteelToggleSwitchStyles.js");}
function feathers_themes_steel_components_SteelToolTipStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelToolTipStyles */ "./lib/_gen/feathers/themes/steel/components/SteelToolTipStyles.js");}
function feathers_themes_steel_components_SteelTreeGridViewStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelTreeGridViewStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTreeGridViewStyles.js");}
function feathers_themes_steel_components_SteelTreeViewStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelTreeViewStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTreeViewStyles.js");}
function feathers_themes_steel_components_SteelVDividedBoxStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelVDividedBoxStyles */ "./lib/_gen/feathers/themes/steel/components/SteelVDividedBoxStyles.js");}
function feathers_themes_steel_components_SteelVProgressBarStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelVProgressBarStyles */ "./lib/_gen/feathers/themes/steel/components/SteelVProgressBarStyles.js");}
function feathers_themes_steel_components_SteelVScrollBarStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelVScrollBarStyles */ "./lib/_gen/feathers/themes/steel/components/SteelVScrollBarStyles.js");}
function feathers_themes_steel_components_SteelVSliderStyles() {return __webpack_require__(/*! ./../../../feathers/themes/steel/components/SteelVSliderStyles */ "./lib/_gen/feathers/themes/steel/components/SteelVSliderStyles.js");}

// Constructor

var SteelTheme = function(themeColor,darkThemeColor) {
	(feathers_themes_steel_BaseSteelTheme().default).call(this,themeColor,darkThemeColor);
	(feathers_themes_steel_components_SteelActivityIndicatorStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelAlertStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelApplicationStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelButtonStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelButtonBarStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelCalloutStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelCheckStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelComboBoxStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelDatePickerStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelDrawerStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelFormStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelFormItemStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelGridViewStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelGroupListViewStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelHDividedBoxStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelHeaderStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelHProgressBarStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelHScrollBarStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelHSliderStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelHierarchicalItemRendererStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelItemRendererStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelLabelStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelLayoutGroupStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelLayoutGroupItemRendererStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelListViewStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelNumericStepperStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelPageIndicatorStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelPageNavigatorStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelPanelStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelPopUpDatePickerStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelPopUpListViewStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelRadioStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelRouterNavigatorStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelScrollContainerStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelStackNavigatorStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelTabBarStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelTabNavigatorStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelTextAreaStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelTextCalloutStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelTextInputStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelToggleButtonStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelToggleSwitchStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelToolTipStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelTreeGridViewStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelTreeViewStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelVDividedBoxStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelVProgressBarStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelVScrollBarStyles().default).initialize(this);
	(feathers_themes_steel_components_SteelVSliderStyles().default).initialize(this);
}

// Meta

SteelTheme.__name__ = "feathers.themes.steel.SteelTheme";
SteelTheme.__isInterface__ = false;
SteelTheme.__super__ = (feathers_themes_steel_BaseSteelTheme().default);
SteelTheme.prototype = $extend((feathers_themes_steel_BaseSteelTheme().default).prototype, {
	
});
SteelTheme.prototype.__class__ = SteelTheme.prototype.constructor = $hxClasses["feathers.themes.steel.SteelTheme"] = SteelTheme;

// Init



// Statics




// Export

exports["default"] = SteelTheme;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelActivityIndicatorStyles.js":
/*!***********************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelActivityIndicatorStyles.js ***!
  \***********************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelActivityIndicatorStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_ActivityIndicator() {return __webpack_require__(/*! ./../../../../feathers/controls/ActivityIndicator */ "./lib/_gen/feathers/controls/ActivityIndicator.js");}
function feathers_skins_activity_DotsActivitySkin() {return __webpack_require__(/*! ./../../../../feathers/skins/activity/DotsActivitySkin */ "./lib/_gen/feathers/skins/activity/DotsActivitySkin.js");}

// Constructor

var SteelActivityIndicatorStyles = function(){}

// Meta

SteelActivityIndicatorStyles.__name__ = "feathers.themes.steel.components.SteelActivityIndicatorStyles";
SteelActivityIndicatorStyles.__isInterface__ = false;
SteelActivityIndicatorStyles.prototype = {
	
};
SteelActivityIndicatorStyles.prototype.__class__ = SteelActivityIndicatorStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelActivityIndicatorStyles"] = SteelActivityIndicatorStyles;

// Init



// Statics

SteelActivityIndicatorStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_ActivityIndicator().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_ActivityIndicator().default),null,function(indicator) {
			if(indicator.get_activitySkin() == null) {
				var activitySkin = new (feathers_skins_activity_DotsActivitySkin().default)();
				activitySkin.set_numDots(8);
				activitySkin.set_dotRadius(3.0);
				activitySkin.set_endDotRadius(null);
				activitySkin.set_dotColor(theme.textColor);
				activitySkin.set_endDotColor(null);
				activitySkin.set_dotAlpha(1.0);
				activitySkin.set_endDotAlpha(0.0);
				var size = 1.1 * activitySkin.get_dotRadius() * activitySkin.get_numDots();
				activitySkin.set_width(size);
				activitySkin.set_height(size);
				indicator.set_activitySkin(activitySkin);
			}
		});
	}
}


// Export

exports["default"] = SteelActivityIndicatorStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelAlertStyles.js":
/*!***********************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelAlertStyles.js ***!
  \***********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelAlertStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_Alert() {return __webpack_require__(/*! ./../../../../feathers/controls/Alert */ "./lib/_gen/feathers/controls/Alert.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_layout_HorizontalLayout() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalLayout */ "./lib/_gen/feathers/layout/HorizontalLayout.js");}
function feathers_controls_ButtonBar() {return __webpack_require__(/*! ./../../../../feathers/controls/ButtonBar */ "./lib/_gen/feathers/controls/ButtonBar.js");}
function feathers_layout_HorizontalDistributedLayout() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalDistributedLayout */ "./lib/_gen/feathers/layout/HorizontalDistributedLayout.js");}
function feathers_controls_Label() {return __webpack_require__(/*! ./../../../../feathers/controls/Label */ "./lib/_gen/feathers/controls/Label.js");}
function feathers_layout_HorizontalLayoutData() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalLayoutData */ "./lib/_gen/feathers/layout/HorizontalLayoutData.js");}

// Constructor

var SteelAlertStyles = function(){}

// Meta

SteelAlertStyles.__name__ = "feathers.themes.steel.components.SteelAlertStyles";
SteelAlertStyles.__isInterface__ = false;
SteelAlertStyles.prototype = {
	
};
SteelAlertStyles.prototype.__class__ = SteelAlertStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelAlertStyles"] = SteelAlertStyles;

// Init



// Statics

SteelAlertStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_Alert().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_Alert().default),null,function(alert) {
			var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
			alert.set_autoHideScrollBars(!isDesktop);
			alert.set_fixedScrollBars(isDesktop);
			if(alert.get_backgroundSkin() == null) {
				var backgroundSkin = new (feathers_skins_RectangleSkin().default)();
				backgroundSkin.set_fill(theme.getContainerFill());
				backgroundSkin.set_maxWidth(276.0);
				alert.set_backgroundSkin(backgroundSkin);
			}
			if(alert.get_layout() == null) {
				var layout = new (feathers_layout_HorizontalLayout().default)();
				layout.set_paddingTop(10.0);
				layout.set_paddingRight(10.0);
				layout.set_paddingBottom(10.0);
				layout.set_paddingLeft(10.0);
				layout.set_gap(6.0);
				layout.set_percentWidthResetEnabled(true);
				alert.set_layout(layout);
			}
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_ButtonBar().default),(feathers_controls_Alert().default).CHILD_VARIANT_BUTTON_BAR) == null) {
		styleProvider.setStyleFunction((feathers_controls_ButtonBar().default),(feathers_controls_Alert().default).CHILD_VARIANT_BUTTON_BAR,function(buttonBar) {
			if(buttonBar.get_layout() == null) {
				var layout1 = new (feathers_layout_HorizontalDistributedLayout().default)();
				layout1.set_paddingTop(10.0);
				layout1.set_paddingRight(10.0);
				layout1.set_paddingBottom(10.0);
				layout1.set_paddingLeft(10.0);
				layout1.set_gap(6.0);
				buttonBar.set_layout(layout1);
			}
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_Label().default),(feathers_controls_Alert().default).CHILD_VARIANT_MESSAGE_LABEL) == null) {
		styleProvider.setStyleFunction((feathers_controls_Label().default),(feathers_controls_Alert().default).CHILD_VARIANT_MESSAGE_LABEL,function(label) {
			if(label.get_textFormat() == null) {
				label.set_textFormat(theme.getTextFormat());
			}
			if(label.get_disabledTextFormat() == null) {
				label.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			if(label.get_layoutData() == null) {
				label.set_layoutData((feathers_layout_HorizontalLayoutData().default).fillHorizontal());
			}
			label.set_wordWrap(true);
		});
	}
}


// Export

exports["default"] = SteelAlertStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelApplicationStyles.js":
/*!*****************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelApplicationStyles.js ***!
  \*****************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelApplicationStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_Application() {return __webpack_require__(/*! ./../../../../feathers/controls/Application */ "./lib/_gen/feathers/controls/Application.js");}
function feathers_core_ScreenDensityScaleManager() {return __webpack_require__(/*! ./../../../../feathers/core/ScreenDensityScaleManager */ "./lib/_gen/feathers/core/ScreenDensityScaleManager.js");}

// Constructor

var SteelApplicationStyles = function(){}

// Meta

SteelApplicationStyles.__name__ = "feathers.themes.steel.components.SteelApplicationStyles";
SteelApplicationStyles.__isInterface__ = false;
SteelApplicationStyles.prototype = {
	
};
SteelApplicationStyles.prototype.__class__ = SteelApplicationStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelApplicationStyles"] = SteelApplicationStyles;

// Init



// Statics

SteelApplicationStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_Application().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_Application().default),null,function(app) {
			if(app.get_scaleManager() == null) {
				app.set_scaleManager(new (feathers_core_ScreenDensityScaleManager().default)());
			}
		});
	}
}
SteelApplicationStyles.refreshStageColor = function(stage,theme) {
	if(stage == null) {
		return;
	}
	stage.set_color(theme.rootFillColor);
}


// Export

exports["default"] = SteelApplicationStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelButtonBarStyles.js":
/*!***************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelButtonBarStyles.js ***!
  \***************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelButtonBarStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_ButtonBar() {return __webpack_require__(/*! ./../../../../feathers/controls/ButtonBar */ "./lib/_gen/feathers/controls/ButtonBar.js");}
function feathers_layout_HorizontalLayout() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalLayout */ "./lib/_gen/feathers/layout/HorizontalLayout.js");}

// Constructor

var SteelButtonBarStyles = function(){}

// Meta

SteelButtonBarStyles.__name__ = "feathers.themes.steel.components.SteelButtonBarStyles";
SteelButtonBarStyles.__isInterface__ = false;
SteelButtonBarStyles.prototype = {
	
};
SteelButtonBarStyles.prototype.__class__ = SteelButtonBarStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelButtonBarStyles"] = SteelButtonBarStyles;

// Init



// Statics

SteelButtonBarStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_ButtonBar().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_ButtonBar().default),null,function(tabBar) {
			if(tabBar.get_layout() == null) {
				var layout = new (feathers_layout_HorizontalLayout().default)();
				layout.set_gap(6.0);
				tabBar.set_layout(layout);
			}
		});
	}
}


// Export

exports["default"] = SteelButtonBarStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelButtonStyles.js":
/*!************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelButtonStyles.js ***!
  \************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelButtonStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_Button() {return __webpack_require__(/*! ./../../../../feathers/controls/Button */ "./lib/_gen/feathers/controls/Button.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_controls_ButtonState() {return __webpack_require__(/*! ./../../../../feathers/controls/ButtonState */ "./lib/_gen/feathers/controls/ButtonState.js");}

// Constructor

var SteelButtonStyles = function(){}

// Meta

SteelButtonStyles.__name__ = "feathers.themes.steel.components.SteelButtonStyles";
SteelButtonStyles.__isInterface__ = false;
SteelButtonStyles.prototype = {
	
};
SteelButtonStyles.prototype.__class__ = SteelButtonStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelButtonStyles"] = SteelButtonStyles;

// Init



// Statics

SteelButtonStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_Button().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_Button().default),null,function(button) {
			if(button.get_backgroundSkin() == null) {
				var skin = new (feathers_skins_RectangleSkin().default)();
				skin.set_fill(theme.getButtonFill());
				skin.set_disabledFill(theme.getButtonDisabledFill());
				skin.setFillForState((feathers_controls_ButtonState().default).DOWN,theme.getReversedActiveThemeFill());
				skin.set_border(theme.getButtonBorder());
				skin.setBorderForState((feathers_controls_ButtonState().default).DOWN,theme.getActiveFillBorder());
				skin.set_cornerRadius(3.0);
				button.set_backgroundSkin(skin);
			}
			if(button.get_focusRectSkin() == null) {
				var focusRectSkin = new (feathers_skins_RectangleSkin().default)();
				focusRectSkin.set_fill(null);
				focusRectSkin.set_border(theme.getFocusBorder());
				focusRectSkin.set_cornerRadius(3.0);
				button.set_focusRectSkin(focusRectSkin);
			}
			if(button.get_textFormat() == null) {
				button.set_textFormat(theme.getTextFormat());
			}
			if(button.get_disabledTextFormat() == null) {
				button.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			button.set_paddingTop(4.0);
			button.set_paddingRight(10.0);
			button.set_paddingBottom(4.0);
			button.set_paddingLeft(10.0);
			button.set_gap(4.0);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_Button().default),(feathers_controls_Button().default).VARIANT_PRIMARY) == null) {
		styleProvider.setStyleFunction((feathers_controls_Button().default),(feathers_controls_Button().default).VARIANT_PRIMARY,function(button1) {
			if(button1.get_backgroundSkin() == null) {
				var skin1 = new (feathers_skins_RectangleSkin().default)();
				skin1.set_fill(theme.getActiveThemeFill());
				skin1.set_disabledFill(theme.getButtonDisabledFill());
				skin1.setFillForState((feathers_controls_ButtonState().default).DOWN,theme.getReversedActiveThemeFill());
				skin1.set_border(theme.getActiveFillBorder());
				skin1.set_disabledBorder(theme.getButtonBorder());
				skin1.set_cornerRadius(3.0);
				button1.set_backgroundSkin(skin1);
			}
			if(button1.get_focusRectSkin() == null) {
				var focusRectSkin1 = new (feathers_skins_RectangleSkin().default)();
				focusRectSkin1.set_fill(null);
				focusRectSkin1.set_border(theme.getFocusBorder());
				focusRectSkin1.set_cornerRadius(3.0);
				button1.set_focusRectSkin(focusRectSkin1);
			}
			if(button1.get_textFormat() == null) {
				button1.set_textFormat(theme.getTextFormat());
			}
			if(button1.get_disabledTextFormat() == null) {
				button1.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			button1.set_paddingTop(4.0);
			button1.set_paddingRight(10.0);
			button1.set_paddingBottom(4.0);
			button1.set_paddingLeft(10.0);
			button1.set_gap(4.0);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_Button().default),(feathers_controls_Button().default).VARIANT_DANGER) == null) {
		styleProvider.setStyleFunction((feathers_controls_Button().default),(feathers_controls_Button().default).VARIANT_DANGER,function(button2) {
			if(button2.get_backgroundSkin() == null) {
				var skin2 = new (feathers_skins_RectangleSkin().default)();
				skin2.set_fill(theme.getDangerFill());
				skin2.set_disabledFill(theme.getButtonDisabledFill());
				skin2.setFillForState((feathers_controls_ButtonState().default).DOWN,theme.getReversedDangerFill());
				skin2.set_border(theme.getDangerBorder());
				skin2.set_disabledBorder(theme.getButtonBorder());
				skin2.set_cornerRadius(3.0);
				button2.set_backgroundSkin(skin2);
			}
			if(button2.get_focusRectSkin() == null) {
				var focusRectSkin2 = new (feathers_skins_RectangleSkin().default)();
				focusRectSkin2.set_fill(null);
				focusRectSkin2.set_border(theme.getFocusBorder());
				focusRectSkin2.set_cornerRadius(3.0);
				button2.set_focusRectSkin(focusRectSkin2);
			}
			if(button2.get_textFormat() == null) {
				button2.set_textFormat(theme.getTextFormat());
			}
			if(button2.get_disabledTextFormat() == null) {
				button2.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			button2.set_paddingTop(4.0);
			button2.set_paddingRight(10.0);
			button2.set_paddingBottom(4.0);
			button2.set_paddingLeft(10.0);
			button2.set_gap(4.0);
		});
	}
}


// Export

exports["default"] = SteelButtonStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelCalendarGridStyles.js":
/*!******************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelCalendarGridStyles.js ***!
  \******************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelCalendarGridStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_ToggleButton() {return __webpack_require__(/*! ./../../../../feathers/controls/ToggleButton */ "./lib/_gen/feathers/controls/ToggleButton.js");}
function feathers_controls_CalendarGrid() {return __webpack_require__(/*! ./../../../../feathers/controls/CalendarGrid */ "./lib/_gen/feathers/controls/CalendarGrid.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_graphics_FillStyle() {return __webpack_require__(/*! ./../../../../feathers/graphics/FillStyle */ "./lib/_gen/feathers/graphics/FillStyle.js");}
function feathers_controls_ToggleButtonState() {return __webpack_require__(/*! ./../../../../feathers/controls/ToggleButtonState */ "./lib/_gen/feathers/controls/ToggleButtonState.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}
function feathers_controls_Label() {return __webpack_require__(/*! ./../../../../feathers/controls/Label */ "./lib/_gen/feathers/controls/Label.js");}

// Constructor

var SteelCalendarGridStyles = function(){}

// Meta

SteelCalendarGridStyles.__name__ = "feathers.themes.steel.components.SteelCalendarGridStyles";
SteelCalendarGridStyles.__isInterface__ = false;
SteelCalendarGridStyles.prototype = {
	
};
SteelCalendarGridStyles.prototype.__class__ = SteelCalendarGridStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelCalendarGridStyles"] = SteelCalendarGridStyles;

// Init



// Statics

SteelCalendarGridStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_ToggleButton().default),(feathers_controls_CalendarGrid().default).CHILD_VARIANT_DATE_TOGGLE_BUTTON) == null) {
		styleProvider.setStyleFunction((feathers_controls_ToggleButton().default),(feathers_controls_CalendarGrid().default).CHILD_VARIANT_DATE_TOGGLE_BUTTON,function(button) {
			var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
			if(button.get_backgroundSkin() == null) {
				var backgroundSkin = new (feathers_skins_RectangleSkin().default)();
				backgroundSkin.set_fill((feathers_graphics_FillStyle().default).SolidColor(16711935,0.0));
				backgroundSkin.set_selectedFill(theme.getActiveThemeFill());
				backgroundSkin.setFillForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getReversedActiveThemeFill());
				backgroundSkin.set_selectedBorder(theme.getSelectedBorder());
				backgroundSkin.setBorderForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getActiveFillBorder());
				if(isDesktop) {
					backgroundSkin.set_width(20.0);
					backgroundSkin.set_height(20.0);
				} else {
					backgroundSkin.set_width(32.0);
					backgroundSkin.set_height(32.0);
				}
				backgroundSkin.set_cornerRadius(4.0);
				button.set_backgroundSkin(backgroundSkin);
			}
			button.set_textFormat(theme.getTextFormat());
			button.set_disabledTextFormat(theme.getDisabledTextFormat());
			button.set_horizontalAlign((feathers_layout_HorizontalAlign().default).CENTER);
			button.set_verticalAlign((feathers_layout_VerticalAlign().default).MIDDLE);
			button.set_paddingTop(2.0);
			button.set_paddingRight(2.0);
			button.set_paddingBottom(2.0);
			button.set_paddingLeft(2.0);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_ToggleButton().default),(feathers_controls_CalendarGrid().default).CHILD_VARIANT_MUTED_DATE_TOGGLE_BUTTON) == null) {
		styleProvider.setStyleFunction((feathers_controls_ToggleButton().default),(feathers_controls_CalendarGrid().default).CHILD_VARIANT_MUTED_DATE_TOGGLE_BUTTON,function(button1) {
			var isDesktop1 = (feathers_utils_DeviceUtil().default).isDesktop();
			if(button1.get_backgroundSkin() == null) {
				var backgroundSkin1 = new (feathers_skins_RectangleSkin().default)();
				backgroundSkin1.set_fill((feathers_graphics_FillStyle().default).SolidColor(16711935,0.0));
				backgroundSkin1.set_selectedFill(theme.getActiveThemeFill());
				backgroundSkin1.setFillForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getReversedActiveThemeFill());
				backgroundSkin1.set_selectedBorder(theme.getSelectedBorder());
				backgroundSkin1.setBorderForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getActiveFillBorder());
				if(isDesktop1) {
					backgroundSkin1.set_width(20.0);
					backgroundSkin1.set_height(20.0);
				} else {
					backgroundSkin1.set_width(32.0);
					backgroundSkin1.set_height(32.0);
				}
				backgroundSkin1.set_cornerRadius(4.0);
				button1.set_backgroundSkin(backgroundSkin1);
			}
			button1.set_textFormat(theme.getSecondaryTextFormat());
			button1.set_disabledTextFormat(theme.getDisabledTextFormat());
			button1.set_horizontalAlign((feathers_layout_HorizontalAlign().default).CENTER);
			button1.set_verticalAlign((feathers_layout_VerticalAlign().default).MIDDLE);
			button1.set_paddingTop(2.0);
			button1.set_paddingRight(2.0);
			button1.set_paddingBottom(2.0);
			button1.set_paddingLeft(2.0);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_Label().default),(feathers_controls_CalendarGrid().default).CHILD_VARIANT_WEEKDAY_LABEL) == null) {
		styleProvider.setStyleFunction((feathers_controls_Label().default),(feathers_controls_CalendarGrid().default).CHILD_VARIANT_WEEKDAY_LABEL,function(label) {
			if(label.get_textFormat() == null) {
				label.set_textFormat(theme.getSecondaryTextFormat("center"));
			}
			if(label.get_disabledTextFormat() == null) {
				label.set_disabledTextFormat(theme.getDisabledTextFormat("center"));
			}
			label.set_verticalAlign((feathers_layout_VerticalAlign().default).MIDDLE);
		});
	}
}


// Export

exports["default"] = SteelCalendarGridStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelCalloutStyles.js":
/*!*************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelCalloutStyles.js ***!
  \*************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelCalloutStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_Callout() {return __webpack_require__(/*! ./../../../../feathers/controls/Callout */ "./lib/_gen/feathers/controls/Callout.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_skins_TriangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/TriangleSkin */ "./lib/_gen/feathers/skins/TriangleSkin.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}

// Constructor

var SteelCalloutStyles = function(){}

// Meta

SteelCalloutStyles.__name__ = "feathers.themes.steel.components.SteelCalloutStyles";
SteelCalloutStyles.__isInterface__ = false;
SteelCalloutStyles.prototype = {
	
};
SteelCalloutStyles.prototype.__class__ = SteelCalloutStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelCalloutStyles"] = SteelCalloutStyles;

// Init



// Statics

SteelCalloutStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_Callout().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_Callout().default),null,function(callout) {
			if(callout.get_backgroundSkin() == null) {
				var backgroundSkin = new (feathers_skins_RectangleSkin().default)();
				backgroundSkin.set_fill(theme.getContainerFill());
				backgroundSkin.set_border(theme.getContainerBorder());
				callout.set_backgroundSkin(backgroundSkin);
			}
			if(callout.get_topArrowSkin() == null) {
				var topArrowSkin = new (feathers_skins_TriangleSkin().default)();
				topArrowSkin.set_pointPosition((feathers_layout_RelativePosition().default).TOP);
				topArrowSkin.set_drawBaseBorder(false);
				topArrowSkin.set_fill(theme.getContainerFill());
				topArrowSkin.set_border(theme.getContainerBorder());
				topArrowSkin.set_width(14.0);
				topArrowSkin.set_height(8.0);
				callout.set_topArrowSkin(topArrowSkin);
			}
			if(callout.get_rightArrowSkin() == null) {
				var rightArrowSkin = new (feathers_skins_TriangleSkin().default)();
				rightArrowSkin.set_pointPosition((feathers_layout_RelativePosition().default).RIGHT);
				rightArrowSkin.set_drawBaseBorder(false);
				rightArrowSkin.set_fill(theme.getContainerFill());
				rightArrowSkin.set_border(theme.getContainerBorder());
				rightArrowSkin.set_width(8.0);
				rightArrowSkin.set_height(14.0);
				callout.set_rightArrowSkin(rightArrowSkin);
			}
			if(callout.get_bottomArrowSkin() == null) {
				var bottomArrowSkin = new (feathers_skins_TriangleSkin().default)();
				bottomArrowSkin.set_pointPosition((feathers_layout_RelativePosition().default).BOTTOM);
				bottomArrowSkin.set_drawBaseBorder(false);
				bottomArrowSkin.set_fill(theme.getContainerFill());
				bottomArrowSkin.set_border(theme.getContainerBorder());
				bottomArrowSkin.set_width(14.0);
				bottomArrowSkin.set_height(8.0);
				callout.set_bottomArrowSkin(bottomArrowSkin);
			}
			if(callout.get_leftArrowSkin() == null) {
				var leftArrowSkin = new (feathers_skins_TriangleSkin().default)();
				leftArrowSkin.set_pointPosition((feathers_layout_RelativePosition().default).LEFT);
				leftArrowSkin.set_drawBaseBorder(false);
				leftArrowSkin.set_fill(theme.getContainerFill());
				leftArrowSkin.set_border(theme.getContainerBorder());
				leftArrowSkin.set_width(8.0);
				leftArrowSkin.set_height(14.0);
				callout.set_leftArrowSkin(leftArrowSkin);
			}
			callout.set_topArrowGap(-1.0);
			callout.set_rightArrowGap(-1.0);
			callout.set_bottomArrowGap(-1.0);
			callout.set_leftArrowGap(-1.0);
			callout.set_paddingTop(1.0);
			callout.set_paddingRight(1.0);
			callout.set_paddingBottom(1.0);
			callout.set_paddingLeft(1.0);
			callout.set_marginTop(10.0);
			callout.set_marginRight(10.0);
			callout.set_marginBottom(10.0);
			callout.set_marginLeft(10.0);
		});
	}
}


// Export

exports["default"] = SteelCalloutStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelCheckStyles.js":
/*!***********************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelCheckStyles.js ***!
  \***********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelCheckStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_Check() {return __webpack_require__(/*! ./../../../../feathers/controls/Check */ "./lib/_gen/feathers/controls/Check.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_graphics_FillStyle() {return __webpack_require__(/*! ./../../../../feathers/graphics/FillStyle */ "./lib/_gen/feathers/graphics/FillStyle.js");}
function feathers_skins_MultiSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/MultiSkin */ "./lib/_gen/feathers/skins/MultiSkin.js");}
function feathers_controls_ToggleButtonState() {return __webpack_require__(/*! ./../../../../feathers/controls/ToggleButtonState */ "./lib/_gen/feathers/controls/ToggleButtonState.js");}
function openfl_display_Shape() {return (__webpack_require__(/*! openfl */ "openfl").display.Shape);}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}

// Constructor

var SteelCheckStyles = function(){}

// Meta

SteelCheckStyles.__name__ = "feathers.themes.steel.components.SteelCheckStyles";
SteelCheckStyles.__isInterface__ = false;
SteelCheckStyles.prototype = {
	
};
SteelCheckStyles.prototype.__class__ = SteelCheckStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelCheckStyles"] = SteelCheckStyles;

// Init



// Statics

SteelCheckStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_Check().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_Check().default),null,function(check) {
			if(check.get_textFormat() == null) {
				check.set_textFormat(theme.getTextFormat());
			}
			if(check.get_disabledTextFormat() == null) {
				check.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			if(check.get_backgroundSkin() == null) {
				var backgroundSkin = new (feathers_skins_RectangleSkin().default)();
				backgroundSkin.set_fill((feathers_graphics_FillStyle().default).SolidColor(0,0.0));
				backgroundSkin.set_border(null);
				check.set_backgroundSkin(backgroundSkin);
			}
			if(check.get_icon() == null) {
				var icon = new (feathers_skins_MultiSkin().default)();
				check.set_icon(icon);
				var defaultIcon = new (feathers_skins_RectangleSkin().default)();
				defaultIcon.set_width(20.0);
				defaultIcon.set_height(20.0);
				defaultIcon.set_minWidth(20.0);
				defaultIcon.set_minHeight(20.0);
				defaultIcon.set_border(theme.getInsetBorder());
				defaultIcon.set_disabledBorder(theme.getDisabledInsetBorder());
				defaultIcon.setBorderForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getSelectedInsetBorder());
				defaultIcon.set_fill(theme.getInsetFill());
				defaultIcon.set_disabledFill(theme.getDisabledInsetFill());
				icon.set_defaultView(defaultIcon);
				var selectedIcon = new (feathers_skins_RectangleSkin().default)();
				selectedIcon.set_width(20.0);
				selectedIcon.set_height(20.0);
				selectedIcon.set_minWidth(20.0);
				selectedIcon.set_minHeight(20.0);
				selectedIcon.set_border(theme.getSelectedInsetBorder());
				selectedIcon.set_disabledBorder(theme.getDisabledInsetBorder());
				selectedIcon.setBorderForState((feathers_controls_ToggleButtonState().default).DOWN(true),theme.getSelectedInsetBorder());
				selectedIcon.set_fill(theme.getReversedActiveThemeFill());
				selectedIcon.set_disabledFill(theme.getDisabledInsetFill());
				var checkMark = new (openfl_display_Shape())();
				checkMark.get_graphics().beginFill(theme.textColor);
				checkMark.get_graphics().drawRect(-1.0,-8.0,3.0,14.0);
				checkMark.get_graphics().endFill();
				checkMark.get_graphics().beginFill(theme.textColor);
				checkMark.get_graphics().drawRect(-5.0,3.0,5.0,3.0);
				checkMark.get_graphics().endFill();
				checkMark.set_rotation(45.0);
				checkMark.set_x(10.0);
				checkMark.set_y(10.0);
				selectedIcon.addChild(checkMark);
				icon.set_selectedView(selectedIcon);
				var disabledAndSelectedIcon = new (feathers_skins_RectangleSkin().default)();
				disabledAndSelectedIcon.set_width(20.0);
				disabledAndSelectedIcon.set_height(20.0);
				disabledAndSelectedIcon.set_minWidth(20.0);
				disabledAndSelectedIcon.set_minHeight(20.0);
				disabledAndSelectedIcon.set_border(theme.getDisabledInsetBorder());
				disabledAndSelectedIcon.set_fill(theme.getDisabledInsetFill());
				var disabledCheckMark = new (openfl_display_Shape())();
				disabledCheckMark.get_graphics().beginFill(theme.disabledTextColor);
				disabledCheckMark.get_graphics().drawRect(-1.0,-8.0,3.0,14.0);
				disabledCheckMark.get_graphics().endFill();
				disabledCheckMark.get_graphics().beginFill(theme.disabledTextColor);
				disabledCheckMark.get_graphics().drawRect(-5.0,3.0,5.0,3.0);
				disabledCheckMark.get_graphics().endFill();
				disabledCheckMark.set_rotation(45.0);
				disabledCheckMark.set_x(10.0);
				disabledCheckMark.set_y(10.0);
				disabledAndSelectedIcon.addChild(disabledCheckMark);
				icon.setViewForState((feathers_controls_ToggleButtonState().default).DISABLED(true),disabledAndSelectedIcon);
			}
			if(check.get_focusRectSkin() == null) {
				var focusRectSkin = new (feathers_skins_RectangleSkin().default)();
				focusRectSkin.set_fill(null);
				focusRectSkin.set_border(theme.getFocusBorder());
				focusRectSkin.set_cornerRadius(3.0);
				check.set_focusRectSkin(focusRectSkin);
				check.set_focusPaddingTop(3.0);
				check.set_focusPaddingRight(3.0);
				check.set_focusPaddingBottom(3.0);
				check.set_focusPaddingLeft(3.0);
			}
			check.set_horizontalAlign((feathers_layout_HorizontalAlign().default).LEFT);
			check.set_gap(4.0);
		});
	}
}


// Export

exports["default"] = SteelCheckStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelComboBoxStyles.js":
/*!**************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelComboBoxStyles.js ***!
  \**************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelComboBoxStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_Button() {return __webpack_require__(/*! ./../../../../feathers/controls/Button */ "./lib/_gen/feathers/controls/Button.js");}
function feathers_controls_ComboBox() {return __webpack_require__(/*! ./../../../../feathers/controls/ComboBox */ "./lib/_gen/feathers/controls/ComboBox.js");}
function feathers_skins_TabSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/TabSkin */ "./lib/_gen/feathers/skins/TabSkin.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}
function feathers_controls_ButtonState() {return __webpack_require__(/*! ./../../../../feathers/controls/ButtonState */ "./lib/_gen/feathers/controls/ButtonState.js");}
function feathers_skins_TriangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/TriangleSkin */ "./lib/_gen/feathers/skins/TriangleSkin.js");}
function feathers_graphics_FillStyle() {return __webpack_require__(/*! ./../../../../feathers/graphics/FillStyle */ "./lib/_gen/feathers/graphics/FillStyle.js");}
function feathers_controls_TextInput() {return __webpack_require__(/*! ./../../../../feathers/controls/TextInput */ "./lib/_gen/feathers/controls/TextInput.js");}
function feathers_controls_TextInputState() {return __webpack_require__(/*! ./../../../../feathers/controls/TextInputState */ "./lib/_gen/feathers/controls/TextInputState.js");}
function feathers_controls_ListView() {return __webpack_require__(/*! ./../../../../feathers/controls/ListView */ "./lib/_gen/feathers/controls/ListView.js");}

// Constructor

var SteelComboBoxStyles = function(){}

// Meta

SteelComboBoxStyles.__name__ = "feathers.themes.steel.components.SteelComboBoxStyles";
SteelComboBoxStyles.__isInterface__ = false;
SteelComboBoxStyles.prototype = {
	
};
SteelComboBoxStyles.prototype.__class__ = SteelComboBoxStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelComboBoxStyles"] = SteelComboBoxStyles;

// Init



// Statics

SteelComboBoxStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_Button().default),(feathers_controls_ComboBox().default).CHILD_VARIANT_BUTTON) == null) {
		styleProvider.setStyleFunction((feathers_controls_Button().default),(feathers_controls_ComboBox().default).CHILD_VARIANT_BUTTON,function(button) {
			if(button.get_backgroundSkin() == null) {
				var skin = new (feathers_skins_TabSkin().default)();
				skin.set_cornerRadiusPosition((feathers_layout_RelativePosition().default).RIGHT);
				skin.set_fill(theme.getButtonFill());
				skin.set_disabledFill(theme.getButtonDisabledFill());
				skin.setFillForState((feathers_controls_ButtonState().default).DOWN,theme.getReversedActiveThemeFill());
				skin.set_border(theme.getButtonBorder());
				skin.setBorderForState((feathers_controls_ButtonState().default).DOWN,theme.getActiveFillBorder());
				skin.set_cornerRadius(3.0);
				button.set_backgroundSkin(skin);
			}
			if(button.get_icon() == null) {
				var icon = new (feathers_skins_TriangleSkin().default)();
				icon.set_pointPosition((feathers_layout_RelativePosition().default).BOTTOM);
				icon.set_fill((feathers_graphics_FillStyle().default).SolidColor(theme.textColor));
				icon.set_disabledFill((feathers_graphics_FillStyle().default).SolidColor(theme.disabledTextColor));
				icon.set_width(8.0);
				icon.set_height(4.0);
				button.set_icon(icon);
			}
			button.set_paddingTop(4.0);
			button.set_paddingRight(10.0);
			button.set_paddingBottom(4.0);
			button.set_paddingLeft(10.0);
			button.set_gap(4.0);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_TextInput().default),(feathers_controls_ComboBox().default).CHILD_VARIANT_TEXT_INPUT) == null) {
		styleProvider.setStyleFunction((feathers_controls_TextInput().default),(feathers_controls_ComboBox().default).CHILD_VARIANT_TEXT_INPUT,function(input) {
			if(input.get_backgroundSkin() == null) {
				var inputSkin = new (feathers_skins_TabSkin().default)();
				inputSkin.set_cornerRadiusPosition((feathers_layout_RelativePosition().default).LEFT);
				inputSkin.set_cornerRadius(3.0);
				inputSkin.set_drawBaseBorder(false);
				inputSkin.set_width(160.0);
				inputSkin.set_fill(theme.getInsetFill());
				inputSkin.set_border(theme.getInsetBorder());
				inputSkin.set_disabledFill(theme.getDisabledInsetFill());
				inputSkin.setBorderForState((feathers_controls_TextInputState().default).FOCUSED,theme.getThemeBorder());
				input.set_backgroundSkin(inputSkin);
			}
			if(input.get_textFormat() == null) {
				input.set_textFormat(theme.getTextFormat());
			}
			if(input.get_disabledTextFormat() == null) {
				input.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			if(input.get_promptTextFormat() == null) {
				input.set_promptTextFormat(theme.getSecondaryTextFormat());
			}
			input.set_paddingTop(6.0);
			input.set_paddingRight(10.0);
			input.set_paddingBottom(6.0);
			input.set_paddingLeft(10.0);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_ListView().default),(feathers_controls_ComboBox().default).CHILD_VARIANT_LIST_VIEW) == null) {
		styleProvider.setStyleFunction((feathers_controls_ListView().default),(feathers_controls_ComboBox().default).CHILD_VARIANT_LIST_VIEW,function(listView) {
			(theme.styleProvider.getStyleFunction((feathers_controls_ListView().default),(feathers_controls_ListView().default).VARIANT_POP_UP))(listView);
		});
	}
}


// Export

exports["default"] = SteelComboBoxStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelDatePickerStyles.js":
/*!****************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelDatePickerStyles.js ***!
  \****************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelDatePickerStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_DatePicker() {return __webpack_require__(/*! ./../../../../feathers/controls/DatePicker */ "./lib/_gen/feathers/controls/DatePicker.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_controls_Label() {return __webpack_require__(/*! ./../../../../feathers/controls/Label */ "./lib/_gen/feathers/controls/Label.js");}
function feathers_controls_Button() {return __webpack_require__(/*! ./../../../../feathers/controls/Button */ "./lib/_gen/feathers/controls/Button.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_controls_ButtonState() {return __webpack_require__(/*! ./../../../../feathers/controls/ButtonState */ "./lib/_gen/feathers/controls/ButtonState.js");}
function openfl_display_Shape() {return (__webpack_require__(/*! openfl */ "openfl").display.Shape);}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}
function feathers_controls_dataRenderers_ItemRenderer() {return __webpack_require__(/*! ./../../../../feathers/controls/dataRenderers/ItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ItemRenderer.js");}
function feathers_graphics_FillStyle() {return __webpack_require__(/*! ./../../../../feathers/graphics/FillStyle */ "./lib/_gen/feathers/graphics/FillStyle.js");}
function feathers_controls_ToggleButtonState() {return __webpack_require__(/*! ./../../../../feathers/controls/ToggleButtonState */ "./lib/_gen/feathers/controls/ToggleButtonState.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}

// Constructor

var SteelDatePickerStyles = function(){}

// Meta

SteelDatePickerStyles.__name__ = "feathers.themes.steel.components.SteelDatePickerStyles";
SteelDatePickerStyles.__isInterface__ = false;
SteelDatePickerStyles.prototype = {
	
};
SteelDatePickerStyles.prototype.__class__ = SteelDatePickerStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelDatePickerStyles"] = SteelDatePickerStyles;

// Init



// Statics

SteelDatePickerStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_DatePicker().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_DatePicker().default),null,function(datePicker) {
			if(datePicker.get_backgroundSkin() == null) {
				var backgroundSkin = new (feathers_skins_RectangleSkin().default)();
				backgroundSkin.set_fill(theme.getContainerFill());
				datePicker.set_backgroundSkin(backgroundSkin);
			}
			datePicker.set_headerGap(2.0);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_Label().default),(feathers_controls_DatePicker().default).CHILD_VARIANT_MONTH_TITLE_VIEW) == null) {
		styleProvider.setStyleFunction((feathers_controls_Label().default),(feathers_controls_DatePicker().default).CHILD_VARIANT_MONTH_TITLE_VIEW,function(view) {
			if(view.get_textFormat() == null) {
				view.set_textFormat(theme.getTextFormat());
			}
			if(view.get_disabledTextFormat() == null) {
				view.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_Button().default),(feathers_controls_DatePicker().default).CHILD_VARIANT_DECREMENT_MONTH_BUTTON) == null) {
		styleProvider.setStyleFunction((feathers_controls_Button().default),(feathers_controls_DatePicker().default).CHILD_VARIANT_DECREMENT_MONTH_BUTTON,function(button) {
			var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
			if(button.get_backgroundSkin() == null) {
				var skin = new (feathers_skins_RectangleSkin().default)();
				skin.set_fill(theme.getButtonFill());
				skin.setFillForState((feathers_controls_ButtonState().default).DOWN,theme.getReversedActiveThemeFill());
				skin.setFillForState((feathers_controls_ButtonState().default).DISABLED,theme.getButtonDisabledFill());
				skin.set_border(theme.getButtonBorder());
				skin.setBorderForState((feathers_controls_ButtonState().default).DOWN,theme.getActiveFillBorder());
				skin.set_cornerRadius(3.0);
				if(isDesktop) {
					skin.set_width(20.0);
					skin.set_height(20.0);
				} else {
					skin.set_width(24.0);
					skin.set_height(24.0);
				}
				button.set_backgroundSkin(skin);
			}
			if(button.get_icon() == null) {
				var icon = new (openfl_display_Shape())();
				SteelDatePickerStyles.drawDecrementMonthIcon(icon,theme.textColor);
				button.set_icon(icon);
			}
			if(button.getIconForState((feathers_controls_ButtonState().default).DISABLED) == null) {
				var disabledIcon = new (openfl_display_Shape())();
				SteelDatePickerStyles.drawDecrementMonthIcon(disabledIcon,theme.disabledTextColor);
				button.setIconForState((feathers_controls_ButtonState().default).DISABLED,disabledIcon);
			}
			button.setPadding(4.0);
			button.set_gap(4.0);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_Button().default),(feathers_controls_DatePicker().default).CHILD_VARIANT_INCREMENT_MONTH_BUTTON) == null) {
		styleProvider.setStyleFunction((feathers_controls_Button().default),(feathers_controls_DatePicker().default).CHILD_VARIANT_INCREMENT_MONTH_BUTTON,function(button1) {
			var isDesktop1 = (feathers_utils_DeviceUtil().default).isDesktop();
			if(button1.get_backgroundSkin() == null) {
				var skin1 = new (feathers_skins_RectangleSkin().default)();
				skin1.set_fill(theme.getButtonFill());
				skin1.setFillForState((feathers_controls_ButtonState().default).DOWN,theme.getReversedActiveThemeFill());
				skin1.setFillForState((feathers_controls_ButtonState().default).DISABLED,theme.getButtonDisabledFill());
				skin1.set_border(theme.getButtonBorder());
				skin1.setBorderForState((feathers_controls_ButtonState().default).DOWN,theme.getActiveFillBorder());
				skin1.set_cornerRadius(3.0);
				if(isDesktop1) {
					skin1.set_width(20.0);
					skin1.set_height(20.0);
				} else {
					skin1.set_width(24.0);
					skin1.set_height(24.0);
				}
				button1.set_backgroundSkin(skin1);
			}
			if(button1.get_icon() == null) {
				var icon1 = new (openfl_display_Shape())();
				SteelDatePickerStyles.drawIncrementMonthIcon(icon1,theme.textColor);
				button1.set_icon(icon1);
			}
			if(button1.getIconForState((feathers_controls_ButtonState().default).DISABLED) == null) {
				var disabledIcon1 = new (openfl_display_Shape())();
				SteelDatePickerStyles.drawIncrementMonthIcon(disabledIcon1,theme.disabledTextColor);
				button1.setIconForState((feathers_controls_ButtonState().default).DISABLED,disabledIcon1);
			}
			button1.setPadding(4.0);
			button1.set_gap(4.0);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_Button().default),(feathers_controls_DatePicker().default).CHILD_VARIANT_DECREMENT_YEAR_BUTTON) == null) {
		styleProvider.setStyleFunction((feathers_controls_Button().default),(feathers_controls_DatePicker().default).CHILD_VARIANT_DECREMENT_YEAR_BUTTON,function(button2) {
			var isDesktop2 = (feathers_utils_DeviceUtil().default).isDesktop();
			if(button2.get_backgroundSkin() == null) {
				var skin2 = new (feathers_skins_RectangleSkin().default)();
				skin2.set_fill(theme.getButtonFill());
				skin2.setFillForState((feathers_controls_ButtonState().default).DOWN,theme.getReversedActiveThemeFill());
				skin2.setFillForState((feathers_controls_ButtonState().default).DISABLED,theme.getButtonDisabledFill());
				skin2.set_border(theme.getButtonBorder());
				skin2.setBorderForState((feathers_controls_ButtonState().default).DOWN,theme.getActiveFillBorder());
				skin2.set_cornerRadius(3.0);
				if(isDesktop2) {
					skin2.set_width(20.0);
					skin2.set_height(20.0);
				} else {
					skin2.set_width(24.0);
					skin2.set_height(24.0);
				}
				button2.set_backgroundSkin(skin2);
			}
			if(button2.get_icon() == null) {
				var icon2 = new (openfl_display_Shape())();
				SteelDatePickerStyles.drawDecrementYearIcon(icon2,theme.textColor);
				button2.set_icon(icon2);
			}
			if(button2.getIconForState((feathers_controls_ButtonState().default).DISABLED) == null) {
				var disabledIcon2 = new (openfl_display_Shape())();
				SteelDatePickerStyles.drawDecrementYearIcon(disabledIcon2,theme.disabledTextColor);
				button2.setIconForState((feathers_controls_ButtonState().default).DISABLED,disabledIcon2);
			}
			button2.setPadding(4.0);
			button2.set_gap(4.0);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_Button().default),(feathers_controls_DatePicker().default).CHILD_VARIANT_INCREMENT_YEAR_BUTTON) == null) {
		styleProvider.setStyleFunction((feathers_controls_Button().default),(feathers_controls_DatePicker().default).CHILD_VARIANT_INCREMENT_YEAR_BUTTON,function(button3) {
			var isDesktop3 = (feathers_utils_DeviceUtil().default).isDesktop();
			if(button3.get_backgroundSkin() == null) {
				var skin3 = new (feathers_skins_RectangleSkin().default)();
				skin3.set_fill(theme.getButtonFill());
				skin3.setFillForState((feathers_controls_ButtonState().default).DOWN,theme.getReversedActiveThemeFill());
				skin3.setFillForState((feathers_controls_ButtonState().default).DISABLED,theme.getButtonDisabledFill());
				skin3.set_border(theme.getButtonBorder());
				skin3.setBorderForState((feathers_controls_ButtonState().default).DOWN,theme.getActiveFillBorder());
				skin3.set_cornerRadius(3.0);
				if(isDesktop3) {
					skin3.set_width(20.0);
					skin3.set_height(20.0);
				} else {
					skin3.set_width(24.0);
					skin3.set_height(24.0);
				}
				button3.set_backgroundSkin(skin3);
			}
			if(button3.get_icon() == null) {
				var icon3 = new (openfl_display_Shape())();
				SteelDatePickerStyles.drawIncrementYearIcon(icon3,theme.textColor);
				button3.set_icon(icon3);
			}
			if(button3.getIconForState((feathers_controls_ButtonState().default).DISABLED) == null) {
				var disabledIcon3 = new (openfl_display_Shape())();
				SteelDatePickerStyles.drawIncrementYearIcon(disabledIcon3,theme.disabledTextColor);
				button3.setIconForState((feathers_controls_ButtonState().default).DISABLED,disabledIcon3);
			}
			button3.setPadding(4.0);
			button3.set_gap(4.0);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_Label().default),(feathers_controls_DatePicker().default).CHILD_VARIANT_WEEKDAY_LABEL) == null) {
		styleProvider.setStyleFunction((feathers_controls_Label().default),(feathers_controls_DatePicker().default).CHILD_VARIANT_WEEKDAY_LABEL,function(label) {
			if(label.get_textFormat() == null) {
				label.set_textFormat(theme.getSecondaryTextFormat("center"));
			}
			if(label.get_disabledTextFormat() == null) {
				label.set_disabledTextFormat(theme.getDisabledTextFormat("center"));
			}
			label.set_verticalAlign((feathers_layout_VerticalAlign().default).MIDDLE);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_dataRenderers_ItemRenderer().default),(feathers_controls_DatePicker().default).CHILD_VARIANT_DATE_RENDERER) == null) {
		styleProvider.setStyleFunction((feathers_controls_dataRenderers_ItemRenderer().default),(feathers_controls_DatePicker().default).CHILD_VARIANT_DATE_RENDERER,function(dateRenderer) {
			var isDesktop4 = (feathers_utils_DeviceUtil().default).isDesktop();
			if(dateRenderer.get_backgroundSkin() == null) {
				var backgroundSkin1 = new (feathers_skins_RectangleSkin().default)();
				backgroundSkin1.set_fill((feathers_graphics_FillStyle().default).SolidColor(16711935,0.0));
				backgroundSkin1.set_selectedFill(theme.getActiveThemeFill());
				backgroundSkin1.setFillForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getReversedActiveThemeFill());
				backgroundSkin1.set_selectedBorder(theme.getSelectedBorder());
				backgroundSkin1.setBorderForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getActiveFillBorder());
				if(isDesktop4) {
					backgroundSkin1.set_width(20.0);
					backgroundSkin1.set_height(20.0);
				} else {
					backgroundSkin1.set_width(32.0);
					backgroundSkin1.set_height(32.0);
				}
				backgroundSkin1.set_cornerRadius(4.0);
				dateRenderer.set_backgroundSkin(backgroundSkin1);
			}
			if(dateRenderer.get_textFormat() == null) {
				dateRenderer.set_textFormat(theme.getTextFormat());
			}
			if(dateRenderer.get_disabledTextFormat() == null) {
				dateRenderer.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			if(dateRenderer.get_secondaryTextFormat() == null) {
				dateRenderer.set_secondaryTextFormat(theme.getDetailTextFormat());
			}
			if(dateRenderer.get_disabledSecondaryTextFormat() == null) {
				dateRenderer.set_disabledSecondaryTextFormat(theme.getDisabledDetailTextFormat());
			}
			dateRenderer.set_horizontalAlign((feathers_layout_HorizontalAlign().default).CENTER);
			dateRenderer.set_verticalAlign((feathers_layout_VerticalAlign().default).MIDDLE);
			dateRenderer.set_paddingTop(2.0);
			dateRenderer.set_paddingRight(2.0);
			dateRenderer.set_paddingBottom(2.0);
			dateRenderer.set_paddingLeft(2.0);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_dataRenderers_ItemRenderer().default),(feathers_controls_DatePicker().default).CHILD_VARIANT_MUTED_DATE_RENDERER) == null) {
		styleProvider.setStyleFunction((feathers_controls_dataRenderers_ItemRenderer().default),(feathers_controls_DatePicker().default).CHILD_VARIANT_MUTED_DATE_RENDERER,function(dateRenderer1) {
			var isDesktop5 = (feathers_utils_DeviceUtil().default).isDesktop();
			if(dateRenderer1.get_backgroundSkin() == null) {
				var backgroundSkin2 = new (feathers_skins_RectangleSkin().default)();
				backgroundSkin2.set_fill((feathers_graphics_FillStyle().default).SolidColor(16711935,0.0));
				backgroundSkin2.set_selectedFill(theme.getActiveThemeFill());
				backgroundSkin2.setFillForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getReversedActiveThemeFill());
				backgroundSkin2.set_selectedBorder(theme.getSelectedBorder());
				backgroundSkin2.setBorderForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getActiveFillBorder());
				if(isDesktop5) {
					backgroundSkin2.set_width(20.0);
					backgroundSkin2.set_height(20.0);
				} else {
					backgroundSkin2.set_width(32.0);
					backgroundSkin2.set_height(32.0);
				}
				backgroundSkin2.set_cornerRadius(4.0);
				dateRenderer1.set_backgroundSkin(backgroundSkin2);
			}
			if(dateRenderer1.get_textFormat() == null) {
				dateRenderer1.set_textFormat(theme.getSecondaryTextFormat());
			}
			if(dateRenderer1.get_disabledTextFormat() == null) {
				dateRenderer1.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			if(dateRenderer1.get_secondaryTextFormat() == null) {
				dateRenderer1.set_secondaryTextFormat(theme.getDetailTextFormat());
			}
			if(dateRenderer1.get_disabledSecondaryTextFormat() == null) {
				dateRenderer1.set_disabledSecondaryTextFormat(theme.getDisabledDetailTextFormat());
			}
			dateRenderer1.set_horizontalAlign((feathers_layout_HorizontalAlign().default).CENTER);
			dateRenderer1.set_verticalAlign((feathers_layout_VerticalAlign().default).MIDDLE);
			dateRenderer1.set_paddingTop(2.0);
			dateRenderer1.set_paddingRight(2.0);
			dateRenderer1.set_paddingBottom(2.0);
			dateRenderer1.set_paddingLeft(2.0);
		});
	}
}
SteelDatePickerStyles.drawDecrementMonthIcon = function(icon,color) {
	icon.get_graphics().beginFill(16711935,0.0);
	icon.get_graphics().drawRect(0.0,0.0,8.0,8.0);
	icon.get_graphics().endFill();
	icon.get_graphics().beginFill(color);
	icon.get_graphics().moveTo(2.0,4.0);
	icon.get_graphics().lineTo(6.0,0.0);
	icon.get_graphics().lineTo(6.0,8.0);
	icon.get_graphics().lineTo(2.0,4.0);
	icon.get_graphics().endFill();
}
SteelDatePickerStyles.drawIncrementMonthIcon = function(icon,color) {
	icon.get_graphics().beginFill(16711935,0.0);
	icon.get_graphics().drawRect(0.0,0.0,8.0,8.0);
	icon.get_graphics().endFill();
	icon.get_graphics().beginFill(color);
	icon.get_graphics().moveTo(2.0,0.0);
	icon.get_graphics().lineTo(6.0,4.0);
	icon.get_graphics().lineTo(2.0,8.0);
	icon.get_graphics().lineTo(2.0,0.0);
	icon.get_graphics().endFill();
}
SteelDatePickerStyles.drawDecrementYearIcon = function(icon,color) {
	icon.get_graphics().beginFill(color);
	icon.get_graphics().moveTo(0.0,4.0);
	icon.get_graphics().lineTo(4.0,0.0);
	icon.get_graphics().lineTo(4.0,8.0);
	icon.get_graphics().lineTo(0.0,4.0);
	icon.get_graphics().moveTo(4.0,4.0);
	icon.get_graphics().lineTo(8.0,0.0);
	icon.get_graphics().lineTo(8.0,8.0);
	icon.get_graphics().lineTo(4.0,4.0);
	icon.get_graphics().endFill();
}
SteelDatePickerStyles.drawIncrementYearIcon = function(icon,color) {
	icon.get_graphics().beginFill(color);
	icon.get_graphics().moveTo(0.0,0.0);
	icon.get_graphics().lineTo(4.0,4.0);
	icon.get_graphics().lineTo(0.0,8.0);
	icon.get_graphics().lineTo(0.0,0.0);
	icon.get_graphics().moveTo(4.0,0.0);
	icon.get_graphics().lineTo(8.0,4.0);
	icon.get_graphics().lineTo(4.0,8.0);
	icon.get_graphics().lineTo(4.0,0.0);
	icon.get_graphics().endFill();
}


// Export

exports["default"] = SteelDatePickerStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelDrawerStyles.js":
/*!************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelDrawerStyles.js ***!
  \************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelDrawerStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_Drawer() {return __webpack_require__(/*! ./../../../../feathers/controls/Drawer */ "./lib/_gen/feathers/controls/Drawer.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}

// Constructor

var SteelDrawerStyles = function(){}

// Meta

SteelDrawerStyles.__name__ = "feathers.themes.steel.components.SteelDrawerStyles";
SteelDrawerStyles.__isInterface__ = false;
SteelDrawerStyles.prototype = {
	
};
SteelDrawerStyles.prototype.__class__ = SteelDrawerStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelDrawerStyles"] = SteelDrawerStyles;

// Init



// Statics

SteelDrawerStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_Drawer().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_Drawer().default),null,function(drawer) {
			if(drawer.get_overlaySkin() == null) {
				var overlaySkin = new (feathers_skins_RectangleSkin().default)();
				overlaySkin.set_fill(theme.getOverlayFill());
				overlaySkin.set_border(null);
				overlaySkin.set_width(1.0);
				overlaySkin.set_height(1.0);
				drawer.set_overlaySkin(overlaySkin);
			}
		});
	}
}


// Export

exports["default"] = SteelDrawerStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelFormItemStyles.js":
/*!**************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelFormItemStyles.js ***!
  \**************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelFormItemStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_FormItem() {return __webpack_require__(/*! ./../../../../feathers/controls/FormItem */ "./lib/_gen/feathers/controls/FormItem.js");}
function openfl_display_Shape() {return (__webpack_require__(/*! openfl */ "openfl").display.Shape);}

// Constructor

var SteelFormItemStyles = function(){}

// Meta

SteelFormItemStyles.__name__ = "feathers.themes.steel.components.SteelFormItemStyles";
SteelFormItemStyles.__isInterface__ = false;
SteelFormItemStyles.prototype = {
	
};
SteelFormItemStyles.prototype.__class__ = SteelFormItemStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelFormItemStyles"] = SteelFormItemStyles;

// Init



// Statics

SteelFormItemStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_FormItem().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_FormItem().default),null,function(formItem) {
			if(formItem.get_requiredSkin() == null) {
				var requiredSkin = new (openfl_display_Shape())();
				requiredSkin.get_graphics().lineStyle(1.0,theme.dangerTextColor);
				requiredSkin.get_graphics().moveTo(4.0,0.5);
				requiredSkin.get_graphics().lineTo(4.0,6.5);
				requiredSkin.get_graphics().moveTo(1.0,1.5);
				requiredSkin.get_graphics().lineTo(7.0,5.5);
				requiredSkin.get_graphics().moveTo(1.0,5.5);
				requiredSkin.get_graphics().lineTo(7.0,1.5);
				requiredSkin.get_graphics().lineStyle();
				requiredSkin.get_graphics().beginFill(16711935,0.0);
				requiredSkin.get_graphics().drawRect(0.0,0.0,8.0,7.0);
				requiredSkin.get_graphics().endFill();
				formItem.set_requiredSkin(requiredSkin);
			}
			if(formItem.get_textFormat() == null) {
				formItem.set_textFormat(theme.getTextFormat());
			}
			if(formItem.get_disabledTextFormat() == null) {
				formItem.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			formItem.set_gap(6.0);
		});
	}
}


// Export

exports["default"] = SteelFormItemStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelFormStyles.js":
/*!**********************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelFormStyles.js ***!
  \**********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelFormStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_Form() {return __webpack_require__(/*! ./../../../../feathers/controls/Form */ "./lib/_gen/feathers/controls/Form.js");}
function feathers_layout_FormLayout() {return __webpack_require__(/*! ./../../../../feathers/layout/FormLayout */ "./lib/_gen/feathers/layout/FormLayout.js");}

// Constructor

var SteelFormStyles = function(){}

// Meta

SteelFormStyles.__name__ = "feathers.themes.steel.components.SteelFormStyles";
SteelFormStyles.__isInterface__ = false;
SteelFormStyles.prototype = {
	
};
SteelFormStyles.prototype.__class__ = SteelFormStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelFormStyles"] = SteelFormStyles;

// Init



// Statics

SteelFormStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_Form().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_Form().default),null,function(form) {
			if(form.get_layout() == null) {
				var layout = new (feathers_layout_FormLayout().default)();
				layout.set_gap(6.0);
				form.set_layout(layout);
			}
		});
	}
}


// Export

exports["default"] = SteelFormStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelGridViewHeaderRendererStyles.js":
/*!****************************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelGridViewHeaderRendererStyles.js ***!
  \****************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelGridViewHeaderRendererStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_dataRenderers_GridViewHeaderRenderer() {return __webpack_require__(/*! ./../../../../feathers/controls/dataRenderers/GridViewHeaderRenderer */ "./lib/_gen/feathers/controls/dataRenderers/GridViewHeaderRenderer.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_skins_TriangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/TriangleSkin */ "./lib/_gen/feathers/skins/TriangleSkin.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}
function feathers_graphics_FillStyle() {return __webpack_require__(/*! ./../../../../feathers/graphics/FillStyle */ "./lib/_gen/feathers/graphics/FillStyle.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}

// Constructor

var SteelGridViewHeaderRendererStyles = function(){}

// Meta

SteelGridViewHeaderRendererStyles.__name__ = "feathers.themes.steel.components.SteelGridViewHeaderRendererStyles";
SteelGridViewHeaderRendererStyles.__isInterface__ = false;
SteelGridViewHeaderRendererStyles.prototype = {
	
};
SteelGridViewHeaderRendererStyles.prototype.__class__ = SteelGridViewHeaderRendererStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelGridViewHeaderRendererStyles"] = SteelGridViewHeaderRendererStyles;

// Init



// Statics

SteelGridViewHeaderRendererStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_dataRenderers_GridViewHeaderRenderer().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_dataRenderers_GridViewHeaderRenderer().default),null,function(itemRenderer) {
			var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
			if(itemRenderer.get_backgroundSkin() == null) {
				var skin = new (feathers_skins_RectangleSkin().default)();
				skin.set_fill(theme.getSubHeadingFill());
				if(isDesktop) {
					skin.set_width(22.0);
					skin.set_height(22.0);
					skin.set_minWidth(22.0);
					skin.set_minHeight(22.0);
				} else {
					skin.set_width(44.0);
					skin.set_height(44.0);
					skin.set_minWidth(44.0);
					skin.set_minHeight(44.0);
				}
				itemRenderer.set_backgroundSkin(skin);
			}
			if(itemRenderer.get_sortAscendingIcon() == null) {
				var sortAscendingIcon = new (feathers_skins_TriangleSkin().default)();
				sortAscendingIcon.set_pointPosition((feathers_layout_RelativePosition().default).TOP);
				sortAscendingIcon.set_fill((feathers_graphics_FillStyle().default).SolidColor(theme.textColor));
				sortAscendingIcon.set_disabledFill((feathers_graphics_FillStyle().default).SolidColor(theme.disabledTextColor));
				sortAscendingIcon.set_width(8.0);
				sortAscendingIcon.set_height(4.0);
				itemRenderer.set_sortAscendingIcon(sortAscendingIcon);
			}
			if(itemRenderer.get_sortDescendingIcon() == null) {
				var sortDescendingIcon = new (feathers_skins_TriangleSkin().default)();
				sortDescendingIcon.set_pointPosition((feathers_layout_RelativePosition().default).BOTTOM);
				sortDescendingIcon.set_fill((feathers_graphics_FillStyle().default).SolidColor(theme.textColor));
				sortDescendingIcon.set_disabledFill((feathers_graphics_FillStyle().default).SolidColor(theme.disabledTextColor));
				sortDescendingIcon.set_width(8.0);
				sortDescendingIcon.set_height(4.0);
				itemRenderer.set_sortDescendingIcon(sortDescendingIcon);
			}
			if(itemRenderer.get_textFormat() == null) {
				itemRenderer.set_textFormat(theme.getTextFormat());
			}
			if(itemRenderer.get_disabledTextFormat() == null) {
				itemRenderer.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			if(itemRenderer.get_secondaryTextFormat() == null) {
				itemRenderer.set_secondaryTextFormat(theme.getDetailTextFormat());
			}
			if(itemRenderer.get_disabledSecondaryTextFormat() == null) {
				itemRenderer.set_disabledSecondaryTextFormat(theme.getDisabledDetailTextFormat());
			}
			itemRenderer.set_paddingTop(4.0);
			itemRenderer.set_paddingRight(10.0);
			itemRenderer.set_paddingBottom(4.0);
			itemRenderer.set_paddingLeft(10.0);
			itemRenderer.set_gap(4.0);
			itemRenderer.set_horizontalAlign((feathers_layout_HorizontalAlign().default).LEFT);
		});
	}
}


// Export

exports["default"] = SteelGridViewHeaderRendererStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelGridViewStyles.js":
/*!**************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelGridViewStyles.js ***!
  \**************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelGridViewStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_layout_VerticalListLayout() {return __webpack_require__(/*! ./../../../../feathers/layout/VerticalListLayout */ "./lib/_gen/feathers/layout/VerticalListLayout.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_controls_GridView() {return __webpack_require__(/*! ./../../../../feathers/controls/GridView */ "./lib/_gen/feathers/controls/GridView.js");}
function feathers_controls_dataRenderers_ItemRenderer() {return __webpack_require__(/*! ./../../../../feathers/controls/dataRenderers/ItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ItemRenderer.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}
function feathers_controls_Button() {return __webpack_require__(/*! ./../../../../feathers/controls/Button */ "./lib/_gen/feathers/controls/Button.js");}
function feathers_skins_VerticalLineSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/VerticalLineSkin */ "./lib/_gen/feathers/skins/VerticalLineSkin.js");}
function feathers_graphics_FillStyle() {return __webpack_require__(/*! ./../../../../feathers/graphics/FillStyle */ "./lib/_gen/feathers/graphics/FillStyle.js");}
function feathers_controls_ButtonState() {return __webpack_require__(/*! ./../../../../feathers/controls/ButtonState */ "./lib/_gen/feathers/controls/ButtonState.js");}

// Constructor

var SteelGridViewStyles = function(){}

// Meta

SteelGridViewStyles.__name__ = "feathers.themes.steel.components.SteelGridViewStyles";
SteelGridViewStyles.__isInterface__ = false;
SteelGridViewStyles.prototype = {
	
};
SteelGridViewStyles.prototype.__class__ = SteelGridViewStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelGridViewStyles"] = SteelGridViewStyles;

// Init



// Statics

SteelGridViewStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleGridViewWithBorderVariant = function(gridView) {
		var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
		gridView.set_autoHideScrollBars(!isDesktop);
		gridView.set_fixedScrollBars(isDesktop);
		if(gridView.get_layout() == null) {
			var layout = new (feathers_layout_VerticalListLayout().default)();
			layout.set_requestedRowCount(5.0);
			gridView.set_layout(layout);
		}
		if(gridView.get_backgroundSkin() == null) {
			var backgroundSkin = new (feathers_skins_RectangleSkin().default)();
			backgroundSkin.set_fill(theme.getContainerFill());
			backgroundSkin.set_border(theme.getContainerBorder());
			backgroundSkin.set_width(10.0);
			backgroundSkin.set_height(10.0);
			gridView.set_backgroundSkin(backgroundSkin);
		}
		if(gridView.get_columnResizeSkin() == null) {
			var columnResizeSkin = new (feathers_skins_RectangleSkin().default)();
			columnResizeSkin.set_fill(theme.getThemeFill());
			columnResizeSkin.set_border(null);
			columnResizeSkin.set_width(2.0);
			columnResizeSkin.set_height(2.0);
			gridView.set_columnResizeSkin(columnResizeSkin);
		}
		if(gridView.get_focusRectSkin() == null) {
			var focusRectSkin = new (feathers_skins_RectangleSkin().default)();
			focusRectSkin.set_fill(null);
			focusRectSkin.set_border(theme.getFocusBorder());
			gridView.set_focusRectSkin(focusRectSkin);
		}
		gridView.set_showHeaderDividersOnlyWhenResizable(true);
		gridView.set_paddingTop(1.0);
		gridView.set_paddingRight(1.0);
		gridView.set_paddingBottom(1.0);
		gridView.set_paddingLeft(1.0);
	};
	var styleGridViewWithBorderlessVariant = function(gridView1) {
		var isDesktop1 = (feathers_utils_DeviceUtil().default).isDesktop();
		gridView1.set_autoHideScrollBars(!isDesktop1);
		gridView1.set_fixedScrollBars(isDesktop1);
		if(gridView1.get_layout() == null) {
			var layout1 = new (feathers_layout_VerticalListLayout().default)();
			layout1.set_requestedRowCount(5.0);
			gridView1.set_layout(layout1);
		}
		if(gridView1.get_backgroundSkin() == null) {
			var backgroundSkin1 = new (feathers_skins_RectangleSkin().default)();
			backgroundSkin1.set_fill(theme.getContainerFill());
			backgroundSkin1.set_width(10.0);
			backgroundSkin1.set_height(10.0);
			gridView1.set_backgroundSkin(backgroundSkin1);
		}
		if(gridView1.get_columnResizeSkin() == null) {
			var columnResizeSkin1 = new (feathers_skins_RectangleSkin().default)();
			columnResizeSkin1.set_fill(theme.getThemeFill());
			columnResizeSkin1.set_border(null);
			columnResizeSkin1.set_width(2.0);
			columnResizeSkin1.set_height(2.0);
			gridView1.set_columnResizeSkin(columnResizeSkin1);
		}
		if(gridView1.get_focusRectSkin() == null) {
			var skin = new (feathers_skins_RectangleSkin().default)();
			skin.set_fill(null);
			skin.set_border(theme.getFocusBorder());
			gridView1.set_focusRectSkin(skin);
		}
		gridView1.set_showHeaderDividersOnlyWhenResizable(true);
	};
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_GridView().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_GridView().default),null,function(gridView2) {
			var isDesktop2 = (feathers_utils_DeviceUtil().default).isDesktop();
			if(isDesktop2) {
				styleGridViewWithBorderVariant(gridView2);
			} else {
				styleGridViewWithBorderlessVariant(gridView2);
			}
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_GridView().default),(feathers_controls_GridView().default).VARIANT_BORDER) == null) {
		styleProvider.setStyleFunction((feathers_controls_GridView().default),(feathers_controls_GridView().default).VARIANT_BORDER,styleGridViewWithBorderVariant);
	}
	if(styleProvider.getStyleFunction((feathers_controls_GridView().default),(feathers_controls_GridView().default).VARIANT_BORDERLESS) == null) {
		styleProvider.setStyleFunction((feathers_controls_GridView().default),(feathers_controls_GridView().default).VARIANT_BORDERLESS,styleGridViewWithBorderlessVariant);
	}
	if(styleProvider.getStyleFunction((feathers_controls_dataRenderers_ItemRenderer().default),(feathers_controls_GridView().default).CHILD_VARIANT_HEADER_RENDERER) == null) {
		styleProvider.setStyleFunction((feathers_controls_dataRenderers_ItemRenderer().default),(feathers_controls_GridView().default).CHILD_VARIANT_HEADER_RENDERER,function(itemRenderer) {
			var isDesktop3 = (feathers_utils_DeviceUtil().default).isDesktop();
			if(itemRenderer.get_backgroundSkin() == null) {
				var skin1 = new (feathers_skins_RectangleSkin().default)();
				skin1.set_fill(theme.getSubHeadingFill());
				if(isDesktop3) {
					skin1.set_width(22.0);
					skin1.set_height(22.0);
					skin1.set_minWidth(22.0);
					skin1.set_minHeight(22.0);
				} else {
					skin1.set_width(44.0);
					skin1.set_height(44.0);
					skin1.set_minWidth(44.0);
					skin1.set_minHeight(44.0);
				}
				itemRenderer.set_backgroundSkin(skin1);
			}
			if(itemRenderer.get_textFormat() == null) {
				itemRenderer.set_textFormat(theme.getTextFormat());
			}
			if(itemRenderer.get_disabledTextFormat() == null) {
				itemRenderer.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			if(itemRenderer.get_secondaryTextFormat() == null) {
				itemRenderer.set_secondaryTextFormat(theme.getDetailTextFormat());
			}
			if(itemRenderer.get_disabledSecondaryTextFormat() == null) {
				itemRenderer.set_disabledSecondaryTextFormat(theme.getDisabledDetailTextFormat());
			}
			itemRenderer.set_paddingTop(4.0);
			itemRenderer.set_paddingRight(10.0);
			itemRenderer.set_paddingBottom(4.0);
			itemRenderer.set_paddingLeft(10.0);
			itemRenderer.set_gap(4.0);
			itemRenderer.set_horizontalAlign((feathers_layout_HorizontalAlign().default).LEFT);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_Button().default),(feathers_controls_GridView().default).CHILD_VARIANT_HEADER_DIVIDER) == null) {
		styleProvider.setStyleFunction((feathers_controls_Button().default),(feathers_controls_GridView().default).CHILD_VARIANT_HEADER_DIVIDER,function(headerDivider) {
			var isDesktop4 = (feathers_utils_DeviceUtil().default).isDesktop();
			if(headerDivider.get_backgroundSkin() == null) {
				var skin2 = new (feathers_skins_VerticalLineSkin().default)();
				skin2.set_border(theme.getSubHeadingDividerBorder());
				skin2.set_fill((feathers_graphics_FillStyle().default).SolidColor(16711935,0.0));
				skin2.setBorderForState((feathers_controls_ButtonState().default).HOVER,theme.getThemeBorder());
				if(isDesktop4) {
					skin2.set_width(6.0);
					skin2.set_height(1.0);
					skin2.set_minWidth(6.0);
					skin2.set_minHeight(1.0);
				} else {
					skin2.set_width(10.0);
					skin2.set_height(1.0);
					skin2.set_minWidth(10.0);
					skin2.set_minHeight(1.0);
				}
				headerDivider.set_backgroundSkin(skin2);
			}
		});
	}
}


// Export

exports["default"] = SteelGridViewStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelGroupListViewStyles.js":
/*!*******************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelGroupListViewStyles.js ***!
  \*******************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelGroupListViewStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_layout_VerticalListLayout() {return __webpack_require__(/*! ./../../../../feathers/layout/VerticalListLayout */ "./lib/_gen/feathers/layout/VerticalListLayout.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_controls_GroupListView() {return __webpack_require__(/*! ./../../../../feathers/controls/GroupListView */ "./lib/_gen/feathers/controls/GroupListView.js");}
function feathers_controls_dataRenderers_ItemRenderer() {return __webpack_require__(/*! ./../../../../feathers/controls/dataRenderers/ItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ItemRenderer.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}

// Constructor

var SteelGroupListViewStyles = function(){}

// Meta

SteelGroupListViewStyles.__name__ = "feathers.themes.steel.components.SteelGroupListViewStyles";
SteelGroupListViewStyles.__isInterface__ = false;
SteelGroupListViewStyles.prototype = {
	
};
SteelGroupListViewStyles.prototype.__class__ = SteelGroupListViewStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelGroupListViewStyles"] = SteelGroupListViewStyles;

// Init



// Statics

SteelGroupListViewStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleGroupListViewWithBorderVariant = function(listView) {
		var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
		listView.set_autoHideScrollBars(!isDesktop);
		listView.set_fixedScrollBars(isDesktop);
		if(listView.get_layout() == null) {
			var layout = new (feathers_layout_VerticalListLayout().default)();
			layout.set_requestedRowCount(5.0);
			listView.set_layout(layout);
		}
		if(listView.get_backgroundSkin() == null) {
			var backgroundSkin = new (feathers_skins_RectangleSkin().default)();
			backgroundSkin.set_fill(theme.getContainerFill());
			backgroundSkin.set_border(theme.getContainerBorder());
			backgroundSkin.set_width(10.0);
			backgroundSkin.set_height(10.0);
			listView.set_backgroundSkin(backgroundSkin);
		}
		if(listView.get_focusRectSkin() == null) {
			var focusRectSkin = new (feathers_skins_RectangleSkin().default)();
			focusRectSkin.set_fill(null);
			focusRectSkin.set_border(theme.getFocusBorder());
			listView.set_focusRectSkin(focusRectSkin);
		}
		listView.set_paddingTop(1.0);
		listView.set_paddingRight(1.0);
		listView.set_paddingBottom(1.0);
		listView.set_paddingLeft(1.0);
	};
	var styleGroupListViewWithBorderlessVariant = function(listView1) {
		var isDesktop1 = (feathers_utils_DeviceUtil().default).isDesktop();
		listView1.set_autoHideScrollBars(!isDesktop1);
		listView1.set_fixedScrollBars(isDesktop1);
		if(listView1.get_layout() == null) {
			var layout1 = new (feathers_layout_VerticalListLayout().default)();
			layout1.set_requestedRowCount(5.0);
			listView1.set_layout(layout1);
		}
		if(listView1.get_backgroundSkin() == null) {
			var backgroundSkin1 = new (feathers_skins_RectangleSkin().default)();
			backgroundSkin1.set_fill(theme.getContainerFill());
			backgroundSkin1.set_width(10.0);
			backgroundSkin1.set_height(10.0);
			listView1.set_backgroundSkin(backgroundSkin1);
		}
		if(listView1.get_focusRectSkin() == null) {
			var skin = new (feathers_skins_RectangleSkin().default)();
			skin.set_fill(null);
			skin.set_border(theme.getFocusBorder());
			listView1.set_focusRectSkin(skin);
		}
	};
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_GroupListView().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_GroupListView().default),null,function(listView2) {
			var isDesktop2 = (feathers_utils_DeviceUtil().default).isDesktop();
			if(isDesktop2) {
				styleGroupListViewWithBorderVariant(listView2);
			} else {
				styleGroupListViewWithBorderlessVariant(listView2);
			}
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_GroupListView().default),(feathers_controls_GroupListView().default).VARIANT_BORDER) == null) {
		styleProvider.setStyleFunction((feathers_controls_GroupListView().default),(feathers_controls_GroupListView().default).VARIANT_BORDER,styleGroupListViewWithBorderVariant);
	}
	if(styleProvider.getStyleFunction((feathers_controls_GroupListView().default),(feathers_controls_GroupListView().default).VARIANT_BORDERLESS) == null) {
		styleProvider.setStyleFunction((feathers_controls_GroupListView().default),(feathers_controls_GroupListView().default).VARIANT_BORDERLESS,styleGroupListViewWithBorderlessVariant);
	}
	if(styleProvider.getStyleFunction((feathers_controls_dataRenderers_ItemRenderer().default),(feathers_controls_GroupListView().default).CHILD_VARIANT_HEADER_RENDERER) == null) {
		styleProvider.setStyleFunction((feathers_controls_dataRenderers_ItemRenderer().default),(feathers_controls_GroupListView().default).CHILD_VARIANT_HEADER_RENDERER,function(itemRenderer) {
			if(itemRenderer.get_backgroundSkin() == null) {
				var skin1 = new (feathers_skins_RectangleSkin().default)();
				skin1.set_fill(theme.getSubHeadingFill());
				skin1.set_width(22.0);
				skin1.set_height(22.0);
				skin1.set_minWidth(22.0);
				skin1.set_minHeight(22.0);
				itemRenderer.set_backgroundSkin(skin1);
			}
			if(itemRenderer.get_textFormat() == null) {
				itemRenderer.set_textFormat(theme.getTextFormat());
			}
			if(itemRenderer.get_disabledTextFormat() == null) {
				itemRenderer.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			if(itemRenderer.get_secondaryTextFormat() == null) {
				itemRenderer.set_secondaryTextFormat(theme.getDetailTextFormat());
			}
			if(itemRenderer.get_disabledSecondaryTextFormat() == null) {
				itemRenderer.set_disabledSecondaryTextFormat(theme.getDisabledDetailTextFormat());
			}
			itemRenderer.set_paddingTop(4.0);
			itemRenderer.set_paddingRight(10.0);
			itemRenderer.set_paddingBottom(4.0);
			itemRenderer.set_paddingLeft(10.0);
			itemRenderer.set_gap(4.0);
			itemRenderer.set_horizontalAlign((feathers_layout_HorizontalAlign().default).LEFT);
		});
	}
}


// Export

exports["default"] = SteelGroupListViewStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelHDividedBoxStyles.js":
/*!*****************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelHDividedBoxStyles.js ***!
  \*****************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelHDividedBoxStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_HDividedBox() {return __webpack_require__(/*! ./../../../../feathers/controls/HDividedBox */ "./lib/_gen/feathers/controls/HDividedBox.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}

// Constructor

var SteelHDividedBoxStyles = function(){}

// Meta

SteelHDividedBoxStyles.__name__ = "feathers.themes.steel.components.SteelHDividedBoxStyles";
SteelHDividedBoxStyles.__isInterface__ = false;
SteelHDividedBoxStyles.prototype = {
	
};
SteelHDividedBoxStyles.prototype.__class__ = SteelHDividedBoxStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelHDividedBoxStyles"] = SteelHDividedBoxStyles;

// Init



// Statics

SteelHDividedBoxStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_HDividedBox().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_HDividedBox().default),null,function(dividedBox) {
			if(dividedBox.get_resizeDraggingSkin() == null) {
				var resizeDraggingSkin = new (feathers_skins_RectangleSkin().default)();
				resizeDraggingSkin.set_fill(theme.getThemeFill());
				resizeDraggingSkin.set_border(null);
				resizeDraggingSkin.set_width(2.0);
				resizeDraggingSkin.set_height(2.0);
				dividedBox.set_resizeDraggingSkin(resizeDraggingSkin);
			}
		});
	}
}


// Export

exports["default"] = SteelHDividedBoxStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelHProgressBarStyles.js":
/*!******************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelHProgressBarStyles.js ***!
  \******************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelHProgressBarStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_HProgressBar() {return __webpack_require__(/*! ./../../../../feathers/controls/HProgressBar */ "./lib/_gen/feathers/controls/HProgressBar.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}

// Constructor

var SteelHProgressBarStyles = function(){}

// Meta

SteelHProgressBarStyles.__name__ = "feathers.themes.steel.components.SteelHProgressBarStyles";
SteelHProgressBarStyles.__isInterface__ = false;
SteelHProgressBarStyles.prototype = {
	
};
SteelHProgressBarStyles.prototype.__class__ = SteelHProgressBarStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelHProgressBarStyles"] = SteelHProgressBarStyles;

// Init



// Statics

SteelHProgressBarStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_HProgressBar().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_HProgressBar().default),null,function(progress) {
			if(progress.get_fillSkin() == null) {
				var fillSkin = new (feathers_skins_RectangleSkin().default)();
				fillSkin.set_fill(theme.getActiveThemeFill());
				fillSkin.set_disabledFill(theme.getControlDisabledFill());
				fillSkin.set_border(theme.getActiveFillBorder());
				fillSkin.set_disabledBorder(theme.getDisabledInsetBorder());
				fillSkin.set_cornerRadius(8.0);
				fillSkin.set_minWidth(8.0);
				fillSkin.set_height(8.0);
				progress.set_fillSkin(fillSkin);
			}
			if(progress.get_backgroundSkin() == null) {
				var backgroundSkin = new (feathers_skins_RectangleSkin().default)();
				backgroundSkin.set_fill(theme.getInsetFill());
				backgroundSkin.set_disabledFill(theme.getDisabledInsetFill());
				backgroundSkin.set_border(theme.getInsetBorder());
				backgroundSkin.set_disabledBorder(theme.getDisabledInsetBorder());
				backgroundSkin.set_cornerRadius(8.0);
				backgroundSkin.set_width(200.0);
				backgroundSkin.set_height(8.0);
				progress.set_backgroundSkin(backgroundSkin);
			}
		});
	}
}


// Export

exports["default"] = SteelHProgressBarStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelHScrollBarStyles.js":
/*!****************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelHScrollBarStyles.js ***!
  \****************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelHScrollBarStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_HScrollBar() {return __webpack_require__(/*! ./../../../../feathers/controls/HScrollBar */ "./lib/_gen/feathers/controls/HScrollBar.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_controls_BasicButton() {return __webpack_require__(/*! ./../../../../feathers/controls/BasicButton */ "./lib/_gen/feathers/controls/BasicButton.js");}

// Constructor

var SteelHScrollBarStyles = function(){}

// Meta

SteelHScrollBarStyles.__name__ = "feathers.themes.steel.components.SteelHScrollBarStyles";
SteelHScrollBarStyles.__isInterface__ = false;
SteelHScrollBarStyles.prototype = {
	
};
SteelHScrollBarStyles.prototype.__class__ = SteelHScrollBarStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelHScrollBarStyles"] = SteelHScrollBarStyles;

// Init



// Statics

SteelHScrollBarStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_HScrollBar().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_HScrollBar().default),null,function(scrollBar) {
			var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
			if(scrollBar.get_thumbSkin() == null) {
				var thumbSkin = new (feathers_skins_RectangleSkin().default)();
				thumbSkin.set_fill(theme.getScrollBarThumbFill());
				thumbSkin.set_disabledFill(theme.getScrollBarThumbDisabledFill());
				var size = isDesktop ? 6.0 : 4.0;
				thumbSkin.set_width(size);
				thumbSkin.set_height(size);
				thumbSkin.set_minWidth(size);
				thumbSkin.set_minHeight(size);
				thumbSkin.set_cornerRadius(size / 2.0);
				var thumb = new (feathers_controls_BasicButton().default)();
				thumb.set_keepDownStateOnRollOut(true);
				thumb.set_backgroundSkin(thumbSkin);
				scrollBar.set_thumbSkin(thumb);
			}
			if(isDesktop && scrollBar.get_trackSkin() == null) {
				var trackSkin = new (feathers_skins_RectangleSkin().default)();
				trackSkin.set_fill(theme.getControlFill());
				trackSkin.set_disabledFill(theme.getControlDisabledFill());
				trackSkin.set_width(12.0);
				trackSkin.set_height(12.0);
				trackSkin.set_minWidth(12.0);
				trackSkin.set_minHeight(12.0);
				scrollBar.set_trackSkin(trackSkin);
			}
			scrollBar.set_paddingTop(2.0);
			scrollBar.set_paddingRight(2.0);
			scrollBar.set_paddingBottom(2.0);
			scrollBar.set_paddingLeft(2.0);
		});
	}
}


// Export

exports["default"] = SteelHScrollBarStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelHSliderStyles.js":
/*!*************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelHSliderStyles.js ***!
  \*************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelHSliderStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_HSlider() {return __webpack_require__(/*! ./../../../../feathers/controls/HSlider */ "./lib/_gen/feathers/controls/HSlider.js");}
function feathers_controls_Button() {return __webpack_require__(/*! ./../../../../feathers/controls/Button */ "./lib/_gen/feathers/controls/Button.js");}
function feathers_skins_CircleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/CircleSkin */ "./lib/_gen/feathers/skins/CircleSkin.js");}
function feathers_controls_ButtonState() {return __webpack_require__(/*! ./../../../../feathers/controls/ButtonState */ "./lib/_gen/feathers/controls/ButtonState.js");}
function feathers_skins_TabSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/TabSkin */ "./lib/_gen/feathers/skins/TabSkin.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}

// Constructor

var SteelHSliderStyles = function(){}

// Meta

SteelHSliderStyles.__name__ = "feathers.themes.steel.components.SteelHSliderStyles";
SteelHSliderStyles.__isInterface__ = false;
SteelHSliderStyles.prototype = {
	
};
SteelHSliderStyles.prototype.__class__ = SteelHSliderStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelHSliderStyles"] = SteelHSliderStyles;

// Init



// Statics

SteelHSliderStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_HSlider().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_HSlider().default),null,function(slider) {
			if(slider.get_thumbSkin() == null) {
				var thumb = new (feathers_controls_Button().default)();
				thumb.set_styleProvider(null);
				thumb.set_keepDownStateOnRollOut(true);
				var backgroundSkin = new (feathers_skins_CircleSkin().default)();
				backgroundSkin.set_fill(theme.getButtonFill());
				backgroundSkin.set_border(theme.getButtonBorder());
				backgroundSkin.setFillForState((feathers_controls_ButtonState().default).DOWN,theme.getButtonDownFill());
				backgroundSkin.setFillForState((feathers_controls_ButtonState().default).DISABLED,theme.getButtonDisabledFill());
				backgroundSkin.set_width(24.0);
				backgroundSkin.set_height(24.0);
				thumb.set_backgroundSkin(backgroundSkin);
				var focusRectSkin = new (feathers_skins_CircleSkin().default)();
				focusRectSkin.set_fill(null);
				focusRectSkin.set_border(theme.getFocusBorder());
				thumb.set_focusRectSkin(focusRectSkin);
				slider.set_thumbSkin(thumb);
			}
			if(slider.get_trackSkin() == null) {
				var trackSkin = new (feathers_skins_TabSkin().default)();
				trackSkin.set_fill(theme.getActiveThemeFill());
				trackSkin.set_border(theme.getActiveFillBorder());
				trackSkin.set_cornerRadius(8.0);
				trackSkin.set_cornerRadiusPosition((feathers_layout_RelativePosition().default).LEFT);
				trackSkin.set_width(100.0);
				trackSkin.set_height(8.0);
				slider.set_trackSkin(trackSkin);
				if(slider.get_secondaryTrackSkin() == null) {
					var secondaryTrackSkin = new (feathers_skins_TabSkin().default)();
					secondaryTrackSkin.set_fill(theme.getInsetFill());
					secondaryTrackSkin.set_border(theme.getInsetBorder());
					secondaryTrackSkin.set_cornerRadius(8.0);
					secondaryTrackSkin.set_cornerRadiusPosition((feathers_layout_RelativePosition().default).RIGHT);
					secondaryTrackSkin.set_width(100.0);
					secondaryTrackSkin.set_height(8.0);
					slider.set_secondaryTrackSkin(secondaryTrackSkin);
				}
			}
		});
	}
}


// Export

exports["default"] = SteelHSliderStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelHeaderStyles.js":
/*!************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelHeaderStyles.js ***!
  \************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelHeaderStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_Header() {return __webpack_require__(/*! ./../../../../feathers/controls/Header */ "./lib/_gen/feathers/controls/Header.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}

// Constructor

var SteelHeaderStyles = function(){}

// Meta

SteelHeaderStyles.__name__ = "feathers.themes.steel.components.SteelHeaderStyles";
SteelHeaderStyles.__isInterface__ = false;
SteelHeaderStyles.prototype = {
	
};
SteelHeaderStyles.prototype.__class__ = SteelHeaderStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelHeaderStyles"] = SteelHeaderStyles;

// Init



// Statics

SteelHeaderStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_Header().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_Header().default),null,function(header) {
			if(header.get_backgroundSkin() == null) {
				var backgroundSkin = new (feathers_skins_RectangleSkin().default)();
				backgroundSkin.set_fill(theme.getHeaderFill());
				backgroundSkin.set_width(44.0);
				backgroundSkin.set_height(44.0);
				backgroundSkin.set_minHeight(44.0);
				header.set_backgroundSkin(backgroundSkin);
			}
			if(header.get_textFormat() == null) {
				header.set_textFormat(theme.getHeaderTextFormat());
			}
			if(header.get_disabledTextFormat() == null) {
				header.set_disabledTextFormat(theme.getDisabledHeaderTextFormat());
			}
			header.set_paddingTop(10.0);
			header.set_paddingRight(10.0);
			header.set_paddingBottom(10.0);
			header.set_paddingLeft(10.0);
			header.set_minGap(10.0);
		});
	}
}


// Export

exports["default"] = SteelHeaderStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelHierarchicalItemRendererStyles.js":
/*!******************************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelHierarchicalItemRendererStyles.js ***!
  \******************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelHierarchicalItemRendererStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_dataRenderers_HierarchicalItemRenderer() {return __webpack_require__(/*! ./../../../../feathers/controls/dataRenderers/HierarchicalItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/HierarchicalItemRenderer.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_skins_UnderlineSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/UnderlineSkin */ "./lib/_gen/feathers/skins/UnderlineSkin.js");}
function feathers_controls_ToggleButtonState() {return __webpack_require__(/*! ./../../../../feathers/controls/ToggleButtonState */ "./lib/_gen/feathers/controls/ToggleButtonState.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}
function feathers_controls_ToggleButton() {return __webpack_require__(/*! ./../../../../feathers/controls/ToggleButton */ "./lib/_gen/feathers/controls/ToggleButton.js");}
function feathers_skins_MultiSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/MultiSkin */ "./lib/_gen/feathers/skins/MultiSkin.js");}
function openfl_display_Shape() {return (__webpack_require__(/*! openfl */ "openfl").display.Shape);}

// Constructor

var SteelHierarchicalItemRendererStyles = function(){}

// Meta

SteelHierarchicalItemRendererStyles.__name__ = "feathers.themes.steel.components.SteelHierarchicalItemRendererStyles";
SteelHierarchicalItemRendererStyles.__isInterface__ = false;
SteelHierarchicalItemRendererStyles.prototype = {
	
};
SteelHierarchicalItemRendererStyles.prototype.__class__ = SteelHierarchicalItemRendererStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelHierarchicalItemRendererStyles"] = SteelHierarchicalItemRendererStyles;

// Init



// Statics

SteelHierarchicalItemRendererStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_dataRenderers_HierarchicalItemRenderer().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_dataRenderers_HierarchicalItemRenderer().default),null,function(itemRenderer) {
			var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
			if(itemRenderer.get_backgroundSkin() == null) {
				var skin = new (feathers_skins_UnderlineSkin().default)();
				skin.set_fill(theme.getContainerFill());
				skin.set_border(theme.getDividerBorder());
				skin.set_selectedFill(theme.getActiveThemeFill());
				skin.setFillForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getActiveThemeFill());
				if(isDesktop) {
					skin.set_width(32.0);
					skin.set_height(32.0);
					skin.set_minWidth(32.0);
					skin.set_minHeight(32.0);
				} else {
					skin.set_width(44.0);
					skin.set_height(44.0);
					skin.set_minWidth(44.0);
					skin.set_minHeight(44.0);
				}
				itemRenderer.set_backgroundSkin(skin);
			}
			if(itemRenderer.get_textFormat() == null) {
				itemRenderer.set_textFormat(theme.getTextFormat());
			}
			if(itemRenderer.get_disabledTextFormat() == null) {
				itemRenderer.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			if(itemRenderer.get_secondaryTextFormat() == null) {
				itemRenderer.set_secondaryTextFormat(theme.getDetailTextFormat());
			}
			if(itemRenderer.get_disabledSecondaryTextFormat() == null) {
				itemRenderer.set_disabledSecondaryTextFormat(theme.getDisabledDetailTextFormat());
			}
			itemRenderer.set_paddingTop(4.0);
			itemRenderer.set_paddingRight(10.0);
			itemRenderer.set_paddingBottom(4.0);
			itemRenderer.set_paddingLeft(10.0);
			itemRenderer.set_gap(4.0);
			itemRenderer.set_indentation(20.0);
			itemRenderer.set_horizontalAlign((feathers_layout_HorizontalAlign().default).LEFT);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_ToggleButton().default),(feathers_controls_dataRenderers_HierarchicalItemRenderer().default).CHILD_VARIANT_DISCLOSURE_BUTTON) == null) {
		styleProvider.setStyleFunction((feathers_controls_ToggleButton().default),(feathers_controls_dataRenderers_HierarchicalItemRenderer().default).CHILD_VARIANT_DISCLOSURE_BUTTON,function(button) {
			if(button.get_icon() == null) {
				var icon = new (feathers_skins_MultiSkin().default)();
				button.set_icon(icon);
				var defaultIcon = new (openfl_display_Shape())();
				SteelHierarchicalItemRendererStyles.drawDisclosureClosedIcon(defaultIcon,theme.textColor);
				icon.set_defaultView(defaultIcon);
				var disabledIcon = new (openfl_display_Shape())();
				SteelHierarchicalItemRendererStyles.drawDisclosureClosedIcon(disabledIcon,theme.disabledTextColor);
				icon.set_disabledView(disabledIcon);
				var selectedIcon = new (openfl_display_Shape())();
				SteelHierarchicalItemRendererStyles.drawDisclosureOpenIcon(selectedIcon,theme.textColor);
				icon.set_selectedView(selectedIcon);
				var selectedDisabledIcon = new (openfl_display_Shape())();
				SteelHierarchicalItemRendererStyles.drawDisclosureOpenIcon(selectedDisabledIcon,theme.disabledTextColor);
				icon.setViewForState((feathers_controls_ToggleButtonState().default).DISABLED(true),selectedDisabledIcon);
			}
		});
	}
}
SteelHierarchicalItemRendererStyles.drawDisclosureClosedIcon = function(icon,color) {
	icon.get_graphics().beginFill(16711935,0.0);
	icon.get_graphics().drawRect(0.0,0.0,20.0,20.0);
	icon.get_graphics().endFill();
	icon.get_graphics().beginFill(color);
	icon.get_graphics().moveTo(4.0,4.0);
	icon.get_graphics().lineTo(16.0,10.0);
	icon.get_graphics().lineTo(4.0,16.0);
	icon.get_graphics().lineTo(4.0,4.0);
	icon.get_graphics().endFill();
}
SteelHierarchicalItemRendererStyles.drawDisclosureOpenIcon = function(icon,color) {
	icon.get_graphics().beginFill(16711935,0.0);
	icon.get_graphics().drawRect(0.0,0.0,20.0,20.0);
	icon.get_graphics().endFill();
	icon.get_graphics().beginFill(color);
	icon.get_graphics().moveTo(4.0,4.0);
	icon.get_graphics().lineTo(16.0,4.0);
	icon.get_graphics().lineTo(10.0,16.0);
	icon.get_graphics().lineTo(4.0,4.0);
	icon.get_graphics().endFill();
}


// Export

exports["default"] = SteelHierarchicalItemRendererStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelItemRendererStyles.js":
/*!******************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelItemRendererStyles.js ***!
  \******************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelItemRendererStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_dataRenderers_ItemRenderer() {return __webpack_require__(/*! ./../../../../feathers/controls/dataRenderers/ItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ItemRenderer.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_skins_UnderlineSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/UnderlineSkin */ "./lib/_gen/feathers/skins/UnderlineSkin.js");}
function feathers_controls_ToggleButtonState() {return __webpack_require__(/*! ./../../../../feathers/controls/ToggleButtonState */ "./lib/_gen/feathers/controls/ToggleButtonState.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}

// Constructor

var SteelItemRendererStyles = function(){}

// Meta

SteelItemRendererStyles.__name__ = "feathers.themes.steel.components.SteelItemRendererStyles";
SteelItemRendererStyles.__isInterface__ = false;
SteelItemRendererStyles.prototype = {
	
};
SteelItemRendererStyles.prototype.__class__ = SteelItemRendererStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelItemRendererStyles"] = SteelItemRendererStyles;

// Init



// Statics

SteelItemRendererStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_dataRenderers_ItemRenderer().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_dataRenderers_ItemRenderer().default),null,function(itemRenderer) {
			var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
			if(itemRenderer.get_backgroundSkin() == null) {
				var skin = new (feathers_skins_UnderlineSkin().default)();
				skin.set_fill(theme.getContainerFill());
				skin.set_border(theme.getDividerBorder());
				skin.set_selectedFill(theme.getActiveThemeFill());
				skin.setFillForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getActiveThemeFill());
				if(isDesktop) {
					skin.set_width(32.0);
					skin.set_height(32.0);
					skin.set_minWidth(32.0);
					skin.set_minHeight(32.0);
				} else {
					skin.set_width(44.0);
					skin.set_height(44.0);
					skin.set_minWidth(44.0);
					skin.set_minHeight(44.0);
				}
				itemRenderer.set_backgroundSkin(skin);
			}
			if(itemRenderer.get_textFormat() == null) {
				itemRenderer.set_textFormat(theme.getTextFormat());
			}
			if(itemRenderer.get_disabledTextFormat() == null) {
				itemRenderer.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			if(itemRenderer.get_secondaryTextFormat() == null) {
				itemRenderer.set_secondaryTextFormat(theme.getDetailTextFormat());
			}
			if(itemRenderer.get_disabledSecondaryTextFormat() == null) {
				itemRenderer.set_disabledSecondaryTextFormat(theme.getDisabledDetailTextFormat());
			}
			itemRenderer.set_paddingTop(4.0);
			itemRenderer.set_paddingRight(10.0);
			itemRenderer.set_paddingBottom(4.0);
			itemRenderer.set_paddingLeft(10.0);
			itemRenderer.set_gap(4.0);
			itemRenderer.set_horizontalAlign((feathers_layout_HorizontalAlign().default).LEFT);
		});
	}
}


// Export

exports["default"] = SteelItemRendererStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelLabelStyles.js":
/*!***********************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelLabelStyles.js ***!
  \***********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelLabelStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_Label() {return __webpack_require__(/*! ./../../../../feathers/controls/Label */ "./lib/_gen/feathers/controls/Label.js");}

// Constructor

var SteelLabelStyles = function(){}

// Meta

SteelLabelStyles.__name__ = "feathers.themes.steel.components.SteelLabelStyles";
SteelLabelStyles.__isInterface__ = false;
SteelLabelStyles.prototype = {
	
};
SteelLabelStyles.prototype.__class__ = SteelLabelStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelLabelStyles"] = SteelLabelStyles;

// Init



// Statics

SteelLabelStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_Label().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_Label().default),null,function(label) {
			if(label.get_textFormat() == null) {
				label.set_textFormat(theme.getTextFormat());
			}
			if(label.get_disabledTextFormat() == null) {
				label.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_Label().default),(feathers_controls_Label().default).VARIANT_HEADING) == null) {
		styleProvider.setStyleFunction((feathers_controls_Label().default),(feathers_controls_Label().default).VARIANT_HEADING,function(label1) {
			if(label1.get_textFormat() == null) {
				label1.set_textFormat(theme.getHeaderTextFormat());
			}
			if(label1.get_disabledTextFormat() == null) {
				label1.set_disabledTextFormat(theme.getDisabledHeaderTextFormat());
			}
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_Label().default),(feathers_controls_Label().default).VARIANT_DETAIL) == null) {
		styleProvider.setStyleFunction((feathers_controls_Label().default),(feathers_controls_Label().default).VARIANT_DETAIL,function(label2) {
			if(label2.get_textFormat() == null) {
				label2.set_textFormat(theme.getDetailTextFormat());
			}
			if(label2.get_disabledTextFormat() == null) {
				label2.set_disabledTextFormat(theme.getDisabledDetailTextFormat());
			}
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_Label().default),(feathers_controls_Label().default).VARIANT_DANGER) == null) {
		styleProvider.setStyleFunction((feathers_controls_Label().default),(feathers_controls_Label().default).VARIANT_DANGER,function(label3) {
			if(label3.get_textFormat() == null) {
				label3.set_textFormat(theme.getDangerTextFormat());
			}
			if(label3.get_disabledTextFormat() == null) {
				label3.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
		});
	}
}


// Export

exports["default"] = SteelLabelStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelLayoutGroupItemRendererStyles.js":
/*!*****************************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelLayoutGroupItemRendererStyles.js ***!
  \*****************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelLayoutGroupItemRendererStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_dataRenderers_LayoutGroupItemRenderer() {return __webpack_require__(/*! ./../../../../feathers/controls/dataRenderers/LayoutGroupItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/LayoutGroupItemRenderer.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_skins_UnderlineSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/UnderlineSkin */ "./lib/_gen/feathers/skins/UnderlineSkin.js");}
function feathers_controls_ToggleButtonState() {return __webpack_require__(/*! ./../../../../feathers/controls/ToggleButtonState */ "./lib/_gen/feathers/controls/ToggleButtonState.js");}

// Constructor

var SteelLayoutGroupItemRendererStyles = function(){}

// Meta

SteelLayoutGroupItemRendererStyles.__name__ = "feathers.themes.steel.components.SteelLayoutGroupItemRendererStyles";
SteelLayoutGroupItemRendererStyles.__isInterface__ = false;
SteelLayoutGroupItemRendererStyles.prototype = {
	
};
SteelLayoutGroupItemRendererStyles.prototype.__class__ = SteelLayoutGroupItemRendererStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelLayoutGroupItemRendererStyles"] = SteelLayoutGroupItemRendererStyles;

// Init



// Statics

SteelLayoutGroupItemRendererStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_dataRenderers_LayoutGroupItemRenderer().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_dataRenderers_LayoutGroupItemRenderer().default),null,function(itemRenderer) {
			var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
			if(itemRenderer.get_backgroundSkin() == null) {
				var skin = new (feathers_skins_UnderlineSkin().default)();
				skin.set_fill(theme.getContainerFill());
				skin.set_border(theme.getDividerBorder());
				skin.set_selectedFill(theme.getActiveThemeFill());
				skin.setFillForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getActiveThemeFill());
				if(isDesktop) {
					skin.set_width(32.0);
					skin.set_height(32.0);
					skin.set_minWidth(32.0);
					skin.set_minHeight(32.0);
				} else {
					skin.set_width(44.0);
					skin.set_height(44.0);
					skin.set_minWidth(44.0);
					skin.set_minHeight(44.0);
				}
				itemRenderer.set_backgroundSkin(skin);
			}
		});
	}
}


// Export

exports["default"] = SteelLayoutGroupItemRendererStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelLayoutGroupStyles.js":
/*!*****************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelLayoutGroupStyles.js ***!
  \*****************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelLayoutGroupStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_LayoutGroup() {return __webpack_require__(/*! ./../../../../feathers/controls/LayoutGroup */ "./lib/_gen/feathers/controls/LayoutGroup.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_layout_HorizontalLayout() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalLayout */ "./lib/_gen/feathers/layout/HorizontalLayout.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}

// Constructor

var SteelLayoutGroupStyles = function(){}

// Meta

SteelLayoutGroupStyles.__name__ = "feathers.themes.steel.components.SteelLayoutGroupStyles";
SteelLayoutGroupStyles.__isInterface__ = false;
SteelLayoutGroupStyles.prototype = {
	
};
SteelLayoutGroupStyles.prototype.__class__ = SteelLayoutGroupStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelLayoutGroupStyles"] = SteelLayoutGroupStyles;

// Init



// Statics

SteelLayoutGroupStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_LayoutGroup().default),(feathers_controls_LayoutGroup().default).VARIANT_TOOL_BAR) == null) {
		styleProvider.setStyleFunction((feathers_controls_LayoutGroup().default),(feathers_controls_LayoutGroup().default).VARIANT_TOOL_BAR,function(group) {
			if(group.get_backgroundSkin() == null) {
				var backgroundSkin = new (feathers_skins_RectangleSkin().default)();
				backgroundSkin.set_fill(theme.getHeaderFill());
				backgroundSkin.set_width(44.0);
				backgroundSkin.set_height(44.0);
				backgroundSkin.set_minHeight(44.0);
				group.set_backgroundSkin(backgroundSkin);
			}
			if(group.get_layout() == null) {
				var layout = new (feathers_layout_HorizontalLayout().default)();
				layout.set_horizontalAlign((feathers_layout_HorizontalAlign().default).LEFT);
				layout.set_verticalAlign((feathers_layout_VerticalAlign().default).MIDDLE);
				layout.set_paddingTop(4.0);
				layout.set_paddingRight(10.0);
				layout.set_paddingBottom(4.0);
				layout.set_paddingLeft(10.0);
				layout.set_gap(4.0);
				group.set_layout(layout);
			}
		});
	}
}


// Export

exports["default"] = SteelLayoutGroupStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelListViewStyles.js":
/*!**************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelListViewStyles.js ***!
  \**************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelListViewStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_layout_VerticalListLayout() {return __webpack_require__(/*! ./../../../../feathers/layout/VerticalListLayout */ "./lib/_gen/feathers/layout/VerticalListLayout.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_controls_ListView() {return __webpack_require__(/*! ./../../../../feathers/controls/ListView */ "./lib/_gen/feathers/controls/ListView.js");}

// Constructor

var SteelListViewStyles = function(){}

// Meta

SteelListViewStyles.__name__ = "feathers.themes.steel.components.SteelListViewStyles";
SteelListViewStyles.__isInterface__ = false;
SteelListViewStyles.prototype = {
	
};
SteelListViewStyles.prototype.__class__ = SteelListViewStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelListViewStyles"] = SteelListViewStyles;

// Init



// Statics

SteelListViewStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleListViewWithBorderVariant = function(listView) {
		var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
		listView.set_autoHideScrollBars(!isDesktop);
		listView.set_fixedScrollBars(isDesktop);
		if(listView.get_layout() == null) {
			var layout = new (feathers_layout_VerticalListLayout().default)();
			layout.set_requestedRowCount(5.0);
			listView.set_layout(layout);
		}
		if(listView.get_backgroundSkin() == null) {
			var backgroundSkin = new (feathers_skins_RectangleSkin().default)();
			backgroundSkin.set_fill(theme.getContainerFill());
			backgroundSkin.set_border(theme.getContainerBorder());
			backgroundSkin.set_width(10.0);
			backgroundSkin.set_height(10.0);
			listView.set_backgroundSkin(backgroundSkin);
		}
		if(listView.get_focusRectSkin() == null) {
			var focusRectSkin = new (feathers_skins_RectangleSkin().default)();
			focusRectSkin.set_fill(null);
			focusRectSkin.set_border(theme.getFocusBorder());
			listView.set_focusRectSkin(focusRectSkin);
		}
		listView.set_paddingTop(1.0);
		listView.set_paddingRight(1.0);
		listView.set_paddingBottom(1.0);
		listView.set_paddingLeft(1.0);
	};
	var styleListViewWithBorderlessVariant = function(listView1) {
		var isDesktop1 = (feathers_utils_DeviceUtil().default).isDesktop();
		listView1.set_autoHideScrollBars(!isDesktop1);
		listView1.set_fixedScrollBars(isDesktop1);
		if(listView1.get_layout() == null) {
			var layout1 = new (feathers_layout_VerticalListLayout().default)();
			layout1.set_requestedRowCount(5.0);
			listView1.set_layout(layout1);
		}
		if(listView1.get_backgroundSkin() == null) {
			var backgroundSkin1 = new (feathers_skins_RectangleSkin().default)();
			backgroundSkin1.set_fill(theme.getContainerFill());
			backgroundSkin1.set_width(10.0);
			backgroundSkin1.set_height(10.0);
			listView1.set_backgroundSkin(backgroundSkin1);
		}
		if(listView1.get_focusRectSkin() == null) {
			var focusRectSkin1 = new (feathers_skins_RectangleSkin().default)();
			focusRectSkin1.set_fill(null);
			focusRectSkin1.set_border(theme.getFocusBorder());
			listView1.set_focusRectSkin(focusRectSkin1);
		}
	};
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_ListView().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_ListView().default),null,function(listView2) {
			var isDesktop2 = (feathers_utils_DeviceUtil().default).isDesktop();
			if(isDesktop2) {
				styleListViewWithBorderVariant(listView2);
			} else {
				styleListViewWithBorderlessVariant(listView2);
			}
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_ListView().default),(feathers_controls_ListView().default).VARIANT_BORDER) == null) {
		styleProvider.setStyleFunction((feathers_controls_ListView().default),(feathers_controls_ListView().default).VARIANT_BORDER,styleListViewWithBorderVariant);
	}
	if(styleProvider.getStyleFunction((feathers_controls_ListView().default),(feathers_controls_ListView().default).VARIANT_BORDERLESS) == null) {
		styleProvider.setStyleFunction((feathers_controls_ListView().default),(feathers_controls_ListView().default).VARIANT_BORDERLESS,styleListViewWithBorderlessVariant);
	}
	if(styleProvider.getStyleFunction((feathers_controls_ListView().default),(feathers_controls_ListView().default).VARIANT_POP_UP) == null) {
		styleProvider.setStyleFunction((feathers_controls_ListView().default),(feathers_controls_ListView().default).VARIANT_POP_UP,function(listView3) {
			if(listView3.get_layout() == null) {
				var layout2 = new (feathers_layout_VerticalListLayout().default)();
				layout2.set_requestedMinRowCount(1.0);
				layout2.set_requestedMaxRowCount(5.0);
				listView3.set_layout(layout2);
			}
			styleListViewWithBorderVariant(listView3);
		});
	}
}


// Export

exports["default"] = SteelListViewStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelNumericStepperStyles.js":
/*!********************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelNumericStepperStyles.js ***!
  \********************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelNumericStepperStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_Button() {return __webpack_require__(/*! ./../../../../feathers/controls/Button */ "./lib/_gen/feathers/controls/Button.js");}
function feathers_controls_NumericStepper() {return __webpack_require__(/*! ./../../../../feathers/controls/NumericStepper */ "./lib/_gen/feathers/controls/NumericStepper.js");}
function feathers_skins_TabSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/TabSkin */ "./lib/_gen/feathers/skins/TabSkin.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}
function feathers_controls_ButtonState() {return __webpack_require__(/*! ./../../../../feathers/controls/ButtonState */ "./lib/_gen/feathers/controls/ButtonState.js");}
function feathers_controls_TextInput() {return __webpack_require__(/*! ./../../../../feathers/controls/TextInput */ "./lib/_gen/feathers/controls/TextInput.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_controls_TextInputState() {return __webpack_require__(/*! ./../../../../feathers/controls/TextInputState */ "./lib/_gen/feathers/controls/TextInputState.js");}

// Constructor

var SteelNumericStepperStyles = function(){}

// Meta

SteelNumericStepperStyles.__name__ = "feathers.themes.steel.components.SteelNumericStepperStyles";
SteelNumericStepperStyles.__isInterface__ = false;
SteelNumericStepperStyles.prototype = {
	
};
SteelNumericStepperStyles.prototype.__class__ = SteelNumericStepperStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelNumericStepperStyles"] = SteelNumericStepperStyles;

// Init



// Statics

SteelNumericStepperStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_Button().default),(feathers_controls_NumericStepper().default).CHILD_VARIANT_DECREMENT_BUTTON) == null) {
		styleProvider.setStyleFunction((feathers_controls_Button().default),(feathers_controls_NumericStepper().default).CHILD_VARIANT_DECREMENT_BUTTON,function(button) {
			if(button.get_backgroundSkin() == null) {
				var skin = new (feathers_skins_TabSkin().default)();
				skin.set_cornerRadiusPosition((feathers_layout_RelativePosition().default).LEFT);
				skin.set_drawBaseBorder(false);
				skin.set_fill(theme.getButtonFill());
				skin.set_disabledFill(theme.getButtonDisabledFill());
				skin.setFillForState((feathers_controls_ButtonState().default).DOWN,theme.getReversedActiveThemeFill());
				skin.set_border(theme.getButtonBorder());
				skin.setBorderForState((feathers_controls_ButtonState().default).DOWN,theme.getActiveFillBorder());
				skin.set_cornerRadius(3.0);
				button.set_backgroundSkin(skin);
			}
			if(button.get_textFormat() == null) {
				button.set_textFormat(theme.getTextFormat());
			}
			if(button.get_disabledTextFormat() == null) {
				button.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			button.set_paddingTop(4.0);
			button.set_paddingRight(10.0);
			button.set_paddingBottom(4.0);
			button.set_paddingLeft(10.0);
			button.set_gap(4.0);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_Button().default),(feathers_controls_NumericStepper().default).CHILD_VARIANT_INCREMENT_BUTTON) == null) {
		styleProvider.setStyleFunction((feathers_controls_Button().default),(feathers_controls_NumericStepper().default).CHILD_VARIANT_INCREMENT_BUTTON,function(button1) {
			if(button1.get_backgroundSkin() == null) {
				var skin1 = new (feathers_skins_TabSkin().default)();
				skin1.set_cornerRadiusPosition((feathers_layout_RelativePosition().default).RIGHT);
				skin1.set_drawBaseBorder(false);
				skin1.set_fill(theme.getButtonFill());
				skin1.set_disabledFill(theme.getButtonDisabledFill());
				skin1.setFillForState((feathers_controls_ButtonState().default).DOWN,theme.getReversedActiveThemeFill());
				skin1.set_border(theme.getButtonBorder());
				skin1.setBorderForState((feathers_controls_ButtonState().default).DOWN,theme.getActiveFillBorder());
				skin1.set_cornerRadius(3.0);
				button1.set_backgroundSkin(skin1);
			}
			if(button1.get_textFormat() == null) {
				button1.set_textFormat(theme.getTextFormat());
			}
			if(button1.get_disabledTextFormat() == null) {
				button1.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			button1.set_paddingTop(4.0);
			button1.set_paddingRight(10.0);
			button1.set_paddingBottom(4.0);
			button1.set_paddingLeft(10.0);
			button1.set_gap(4.0);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_TextInput().default),(feathers_controls_NumericStepper().default).CHILD_VARIANT_TEXT_INPUT) == null) {
		styleProvider.setStyleFunction((feathers_controls_TextInput().default),(feathers_controls_NumericStepper().default).CHILD_VARIANT_TEXT_INPUT,function(input) {
			if(input.get_backgroundSkin() == null) {
				var inputSkin = new (feathers_skins_RectangleSkin().default)();
				inputSkin.set_width(3.0);
				inputSkin.set_fill(theme.getInsetFill());
				inputSkin.set_border(theme.getInsetBorder());
				inputSkin.set_disabledFill(theme.getDisabledInsetFill());
				inputSkin.setBorderForState((feathers_controls_TextInputState().default).FOCUSED,theme.getThemeBorder());
				input.set_backgroundSkin(inputSkin);
			}
			if(input.get_textFormat() == null) {
				input.set_textFormat(theme.getTextFormat());
			}
			if(input.get_disabledTextFormat() == null) {
				input.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			if(input.get_promptTextFormat() == null) {
				input.set_promptTextFormat(theme.getSecondaryTextFormat());
			}
			input.set_paddingTop(6.0);
			input.set_paddingRight(10.0);
			input.set_paddingBottom(6.0);
			input.set_paddingLeft(10.0);
		});
	}
}


// Export

exports["default"] = SteelNumericStepperStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelPageIndicatorStyles.js":
/*!*******************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelPageIndicatorStyles.js ***!
  \*******************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelPageIndicatorStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_PageIndicator() {return __webpack_require__(/*! ./../../../../feathers/controls/PageIndicator */ "./lib/_gen/feathers/controls/PageIndicator.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_layout_HorizontalLayout() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalLayout */ "./lib/_gen/feathers/layout/HorizontalLayout.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}
function feathers_layout_VerticalAlign() {return __webpack_require__(/*! ./../../../../feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");}
function feathers_controls_ToggleButton() {return __webpack_require__(/*! ./../../../../feathers/controls/ToggleButton */ "./lib/_gen/feathers/controls/ToggleButton.js");}
function feathers_skins_CircleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/CircleSkin */ "./lib/_gen/feathers/skins/CircleSkin.js");}
function feathers_controls_ToggleButtonState() {return __webpack_require__(/*! ./../../../../feathers/controls/ToggleButtonState */ "./lib/_gen/feathers/controls/ToggleButtonState.js");}

// Constructor

var SteelPageIndicatorStyles = function(){}

// Meta

SteelPageIndicatorStyles.__name__ = "feathers.themes.steel.components.SteelPageIndicatorStyles";
SteelPageIndicatorStyles.__isInterface__ = false;
SteelPageIndicatorStyles.prototype = {
	
};
SteelPageIndicatorStyles.prototype.__class__ = SteelPageIndicatorStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelPageIndicatorStyles"] = SteelPageIndicatorStyles;

// Init



// Statics

SteelPageIndicatorStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_PageIndicator().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_PageIndicator().default),null,function(pages) {
			if(pages.get_focusRectSkin() == null) {
				var focusRectSkin = new (feathers_skins_RectangleSkin().default)();
				focusRectSkin.set_fill(null);
				focusRectSkin.set_border(theme.getFocusBorder());
				focusRectSkin.set_cornerRadius(3.0);
				pages.set_focusRectSkin(focusRectSkin);
			}
			if(pages.get_layout() == null) {
				var layout = new (feathers_layout_HorizontalLayout().default)();
				layout.set_gap(10.0);
				layout.set_paddingTop(4.0);
				layout.set_paddingRight(4.0);
				layout.set_paddingBottom(4.0);
				layout.set_paddingLeft(4.0);
				layout.set_horizontalAlign((feathers_layout_HorizontalAlign().default).CENTER);
				layout.set_verticalAlign((feathers_layout_VerticalAlign().default).MIDDLE);
				pages.set_layout(layout);
			}
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_ToggleButton().default),(feathers_controls_PageIndicator().default).CHILD_VARIANT_TOGGLE_BUTTON) == null) {
		styleProvider.setStyleFunction((feathers_controls_ToggleButton().default),(feathers_controls_PageIndicator().default).CHILD_VARIANT_TOGGLE_BUTTON,function(button) {
			if(button.get_backgroundSkin() == null) {
				var skin = new (feathers_skins_CircleSkin().default)();
				skin.set_fill(theme.getButtonFill());
				skin.set_disabledFill(theme.getButtonDisabledFill());
				skin.set_selectedFill(theme.getThemeFill());
				skin.setFillForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getReversedActiveThemeFill());
				skin.setFillForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getReversedActiveThemeFill());
				skin.set_border(theme.getButtonBorder());
				skin.set_selectedBorder(theme.getSelectedInsetBorder());
				skin.setBorderForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getActiveFillBorder());
				skin.set_minWidth(10.0);
				skin.set_minHeight(10.0);
				button.set_backgroundSkin(skin);
			}
		});
	}
}


// Export

exports["default"] = SteelPageIndicatorStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelPageNavigatorStyles.js":
/*!*******************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelPageNavigatorStyles.js ***!
  \*******************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelPageNavigatorStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_navigators_PageNavigator() {return __webpack_require__(/*! ./../../../../feathers/controls/navigators/PageNavigator */ "./lib/_gen/feathers/controls/navigators/PageNavigator.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}
function feathers_motion_transitions_SlideTransitionBuilder() {return __webpack_require__(/*! ./../../../../feathers/motion/transitions/SlideTransitionBuilder */ "./lib/_gen/feathers/motion/transitions/SlideTransitionBuilder.js");}

// Constructor

var SteelPageNavigatorStyles = function(){}

// Meta

SteelPageNavigatorStyles.__name__ = "feathers.themes.steel.components.SteelPageNavigatorStyles";
SteelPageNavigatorStyles.__isInterface__ = false;
SteelPageNavigatorStyles.prototype = {
	
};
SteelPageNavigatorStyles.prototype.__class__ = SteelPageNavigatorStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelPageNavigatorStyles"] = SteelPageNavigatorStyles;

// Init



// Statics

SteelPageNavigatorStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_navigators_PageNavigator().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_navigators_PageNavigator().default),null,function(navigator) {
			navigator.set_pageIndicatorPosition((feathers_layout_RelativePosition().default).BOTTOM);
			navigator.set_previousTransition(new (feathers_motion_transitions_SlideTransitionBuilder())().setRight().build());
			navigator.set_nextTransition(new (feathers_motion_transitions_SlideTransitionBuilder())().setLeft().build());
		});
	}
}


// Export

exports["default"] = SteelPageNavigatorStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelPanelStyles.js":
/*!***********************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelPanelStyles.js ***!
  \***********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelPanelStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_Panel() {return __webpack_require__(/*! ./../../../../feathers/controls/Panel */ "./lib/_gen/feathers/controls/Panel.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}

// Constructor

var SteelPanelStyles = function(){}

// Meta

SteelPanelStyles.__name__ = "feathers.themes.steel.components.SteelPanelStyles";
SteelPanelStyles.__isInterface__ = false;
SteelPanelStyles.prototype = {
	
};
SteelPanelStyles.prototype.__class__ = SteelPanelStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelPanelStyles"] = SteelPanelStyles;

// Init



// Statics

SteelPanelStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_Panel().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_Panel().default),null,function(panel) {
			var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
			panel.set_autoHideScrollBars(!isDesktop);
			panel.set_fixedScrollBars(isDesktop);
			if(panel.get_backgroundSkin() == null) {
				var backgroundSkin = new (feathers_skins_RectangleSkin().default)();
				backgroundSkin.set_fill(theme.getContainerFill());
				panel.set_backgroundSkin(backgroundSkin);
			}
		});
	}
}


// Export

exports["default"] = SteelPanelStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelPopUpDatePickerStyles.js":
/*!*********************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelPopUpDatePickerStyles.js ***!
  \*********************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelPopUpDatePickerStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_Button() {return __webpack_require__(/*! ./../../../../feathers/controls/Button */ "./lib/_gen/feathers/controls/Button.js");}
function feathers_controls_PopUpDatePicker() {return __webpack_require__(/*! ./../../../../feathers/controls/PopUpDatePicker */ "./lib/_gen/feathers/controls/PopUpDatePicker.js");}
function feathers_skins_TabSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/TabSkin */ "./lib/_gen/feathers/skins/TabSkin.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}
function feathers_controls_ButtonState() {return __webpack_require__(/*! ./../../../../feathers/controls/ButtonState */ "./lib/_gen/feathers/controls/ButtonState.js");}
function openfl_display_Shape() {return (__webpack_require__(/*! openfl */ "openfl").display.Shape);}
function feathers_controls_TextInput() {return __webpack_require__(/*! ./../../../../feathers/controls/TextInput */ "./lib/_gen/feathers/controls/TextInput.js");}
function feathers_controls_TextInputState() {return __webpack_require__(/*! ./../../../../feathers/controls/TextInputState */ "./lib/_gen/feathers/controls/TextInputState.js");}
function feathers_controls_DatePicker() {return __webpack_require__(/*! ./../../../../feathers/controls/DatePicker */ "./lib/_gen/feathers/controls/DatePicker.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}

// Constructor

var SteelPopUpDatePickerStyles = function(){}

// Meta

SteelPopUpDatePickerStyles.__name__ = "feathers.themes.steel.components.SteelPopUpDatePickerStyles";
SteelPopUpDatePickerStyles.__isInterface__ = false;
SteelPopUpDatePickerStyles.prototype = {
	
};
SteelPopUpDatePickerStyles.prototype.__class__ = SteelPopUpDatePickerStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelPopUpDatePickerStyles"] = SteelPopUpDatePickerStyles;

// Init



// Statics

SteelPopUpDatePickerStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_Button().default),(feathers_controls_PopUpDatePicker().default).CHILD_VARIANT_BUTTON) == null) {
		styleProvider.setStyleFunction((feathers_controls_Button().default),(feathers_controls_PopUpDatePicker().default).CHILD_VARIANT_BUTTON,function(button) {
			if(button.get_backgroundSkin() == null) {
				var skin = new (feathers_skins_TabSkin().default)();
				skin.set_cornerRadiusPosition((feathers_layout_RelativePosition().default).RIGHT);
				skin.set_fill(theme.getButtonFill());
				skin.set_disabledFill(theme.getButtonDisabledFill());
				skin.setFillForState((feathers_controls_ButtonState().default).DOWN,theme.getReversedActiveThemeFill());
				skin.set_border(theme.getButtonBorder());
				skin.setBorderForState((feathers_controls_ButtonState().default).DOWN,theme.getActiveFillBorder());
				skin.set_cornerRadius(3.0);
				button.set_backgroundSkin(skin);
			}
			if(button.get_icon() == null) {
				var icon = new (openfl_display_Shape())();
				SteelPopUpDatePickerStyles.drawIcon(icon,theme.textColor);
				button.set_icon(icon);
				if(button.getIconForState((feathers_controls_ButtonState().default).DISABLED) == null) {
					var disabledIcon = new (openfl_display_Shape())();
					SteelPopUpDatePickerStyles.drawIcon(disabledIcon,theme.disabledTextColor);
					button.setIconForState((feathers_controls_ButtonState().default).DISABLED,disabledIcon);
				}
			}
			button.set_paddingTop(4.0);
			button.set_paddingRight(10.0);
			button.set_paddingBottom(4.0);
			button.set_paddingLeft(10.0);
			button.set_gap(4.0);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_TextInput().default),(feathers_controls_PopUpDatePicker().default).CHILD_VARIANT_TEXT_INPUT) == null) {
		styleProvider.setStyleFunction((feathers_controls_TextInput().default),(feathers_controls_PopUpDatePicker().default).CHILD_VARIANT_TEXT_INPUT,function(input) {
			if(input.get_backgroundSkin() == null) {
				var inputSkin = new (feathers_skins_TabSkin().default)();
				inputSkin.set_cornerRadiusPosition((feathers_layout_RelativePosition().default).LEFT);
				inputSkin.set_cornerRadius(3.0);
				inputSkin.set_drawBaseBorder(false);
				inputSkin.set_width(160.0);
				inputSkin.set_fill(theme.getInsetFill());
				inputSkin.set_disabledFill(theme.getDisabledInsetFill());
				inputSkin.set_border(theme.getInsetBorder());
				inputSkin.setBorderForState((feathers_controls_TextInputState().default).FOCUSED,theme.getThemeBorder());
				input.set_backgroundSkin(inputSkin);
			}
			if(input.get_textFormat() == null) {
				input.set_textFormat(theme.getTextFormat());
			}
			if(input.get_disabledTextFormat() == null) {
				input.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			if(input.get_promptTextFormat() == null) {
				input.set_promptTextFormat(theme.getSecondaryTextFormat());
			}
			input.set_paddingTop(6.0);
			input.set_paddingRight(10.0);
			input.set_paddingBottom(6.0);
			input.set_paddingLeft(10.0);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_DatePicker().default),(feathers_controls_PopUpDatePicker().default).CHILD_VARIANT_DATE_PICKER) == null) {
		styleProvider.setStyleFunction((feathers_controls_DatePicker().default),(feathers_controls_PopUpDatePicker().default).CHILD_VARIANT_DATE_PICKER,function(datePicker) {
			if(datePicker.get_backgroundSkin() == null) {
				var backgroundSkin = new (feathers_skins_RectangleSkin().default)();
				backgroundSkin.set_fill(theme.getContainerFill());
				backgroundSkin.set_border(theme.getContainerBorder());
				backgroundSkin.set_cornerRadius(4.0);
				datePicker.set_backgroundSkin(backgroundSkin);
			}
			datePicker.setPadding(6.0);
			datePicker.set_headerGap(2.0);
		});
	}
}
SteelPopUpDatePickerStyles.drawIcon = function(icon,iconColor) {
	icon.get_graphics().lineStyle(1.0,iconColor);
	icon.get_graphics().drawRect(0.5,1.5,11.0,10.0);
	icon.get_graphics().moveTo(3.0,0.5);
	icon.get_graphics().lineTo(3.0,1.5);
	icon.get_graphics().moveTo(9.0,0.5);
	icon.get_graphics().lineTo(9.0,1.5);
	icon.get_graphics().lineStyle();
	icon.get_graphics().beginFill(iconColor);
	icon.get_graphics().drawRect(1.0,2.0,11.0,2.0);
	icon.get_graphics().drawRect(2.0,5.0,2.0,2.0);
	icon.get_graphics().drawRect(5.0,5.0,2.0,2.0);
	icon.get_graphics().drawRect(8.0,5.0,2.0,2.0);
	icon.get_graphics().drawRect(2.0,8.0,2.0,2.0);
	icon.get_graphics().drawRect(5.0,8.0,2.0,2.0);
	icon.get_graphics().drawRect(8.0,8.0,2.0,2.0);
	icon.get_graphics().endFill();
}


// Export

exports["default"] = SteelPopUpDatePickerStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelPopUpListViewStyles.js":
/*!*******************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelPopUpListViewStyles.js ***!
  \*******************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelPopUpListViewStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_PopUpListView() {return __webpack_require__(/*! ./../../../../feathers/controls/PopUpListView */ "./lib/_gen/feathers/controls/PopUpListView.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_controls_popups_DropDownPopUpAdapter() {return __webpack_require__(/*! ./../../../../feathers/controls/popups/DropDownPopUpAdapter */ "./lib/_gen/feathers/controls/popups/DropDownPopUpAdapter.js");}
function feathers_controls_Button() {return __webpack_require__(/*! ./../../../../feathers/controls/Button */ "./lib/_gen/feathers/controls/Button.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}
function feathers_skins_TriangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/TriangleSkin */ "./lib/_gen/feathers/skins/TriangleSkin.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}
function feathers_graphics_FillStyle() {return __webpack_require__(/*! ./../../../../feathers/graphics/FillStyle */ "./lib/_gen/feathers/graphics/FillStyle.js");}
function feathers_controls_ListView() {return __webpack_require__(/*! ./../../../../feathers/controls/ListView */ "./lib/_gen/feathers/controls/ListView.js");}

// Constructor

var SteelPopUpListViewStyles = function(){}

// Meta

SteelPopUpListViewStyles.__name__ = "feathers.themes.steel.components.SteelPopUpListViewStyles";
SteelPopUpListViewStyles.__isInterface__ = false;
SteelPopUpListViewStyles.prototype = {
	
};
SteelPopUpListViewStyles.prototype.__class__ = SteelPopUpListViewStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelPopUpListViewStyles"] = SteelPopUpListViewStyles;

// Init



// Statics

SteelPopUpListViewStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_PopUpListView().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_PopUpListView().default),null,function(listView) {
			var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
			if(isDesktop) {
				listView.set_popUpAdapter(new (feathers_controls_popups_DropDownPopUpAdapter().default)());
			}
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_Button().default),(feathers_controls_PopUpListView().default).CHILD_VARIANT_BUTTON) == null) {
		styleProvider.setStyleFunction((feathers_controls_Button().default),(feathers_controls_PopUpListView().default).CHILD_VARIANT_BUTTON,function(button) {
			(theme.styleProvider.getStyleFunction((feathers_controls_Button().default),null))(button);
			button.set_horizontalAlign((feathers_layout_HorizontalAlign().default).LEFT);
			button.set_gap(1.0 / 0.0);
			button.set_minGap(6.0);
			if(button.get_icon() == null) {
				var icon = new (feathers_skins_TriangleSkin().default)();
				icon.set_pointPosition((feathers_layout_RelativePosition().default).BOTTOM);
				icon.set_fill((feathers_graphics_FillStyle().default).SolidColor(theme.textColor));
				icon.set_disabledFill((feathers_graphics_FillStyle().default).SolidColor(theme.disabledTextColor));
				icon.set_width(8.0);
				icon.set_height(4.0);
				button.set_icon(icon);
			}
			button.set_iconPosition((feathers_layout_RelativePosition().default).RIGHT);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_ListView().default),(feathers_controls_PopUpListView().default).CHILD_VARIANT_LIST_VIEW) == null) {
		styleProvider.setStyleFunction((feathers_controls_ListView().default),(feathers_controls_PopUpListView().default).CHILD_VARIANT_LIST_VIEW,function(listView1) {
			(theme.styleProvider.getStyleFunction((feathers_controls_ListView().default),(feathers_controls_ListView().default).VARIANT_POP_UP))(listView1);
		});
	}
}


// Export

exports["default"] = SteelPopUpListViewStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelRadioStyles.js":
/*!***********************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelRadioStyles.js ***!
  \***********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelRadioStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_Radio() {return __webpack_require__(/*! ./../../../../feathers/controls/Radio */ "./lib/_gen/feathers/controls/Radio.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_graphics_FillStyle() {return __webpack_require__(/*! ./../../../../feathers/graphics/FillStyle */ "./lib/_gen/feathers/graphics/FillStyle.js");}
function feathers_skins_MultiSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/MultiSkin */ "./lib/_gen/feathers/skins/MultiSkin.js");}
function feathers_skins_CircleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/CircleSkin */ "./lib/_gen/feathers/skins/CircleSkin.js");}
function feathers_controls_ToggleButtonState() {return __webpack_require__(/*! ./../../../../feathers/controls/ToggleButtonState */ "./lib/_gen/feathers/controls/ToggleButtonState.js");}
function openfl_display_Shape() {return (__webpack_require__(/*! openfl */ "openfl").display.Shape);}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}

// Constructor

var SteelRadioStyles = function(){}

// Meta

SteelRadioStyles.__name__ = "feathers.themes.steel.components.SteelRadioStyles";
SteelRadioStyles.__isInterface__ = false;
SteelRadioStyles.prototype = {
	
};
SteelRadioStyles.prototype.__class__ = SteelRadioStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelRadioStyles"] = SteelRadioStyles;

// Init



// Statics

SteelRadioStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_Radio().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_Radio().default),null,function(radio) {
			if(radio.get_textFormat() == null) {
				radio.set_textFormat(theme.getTextFormat());
			}
			if(radio.get_disabledTextFormat() == null) {
				radio.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			if(radio.get_backgroundSkin() == null) {
				var backgroundSkin = new (feathers_skins_RectangleSkin().default)();
				backgroundSkin.set_fill((feathers_graphics_FillStyle().default).SolidColor(0,0.0));
				backgroundSkin.set_border(null);
				radio.set_backgroundSkin(backgroundSkin);
			}
			if(radio.get_icon() == null) {
				var icon = new (feathers_skins_MultiSkin().default)();
				radio.set_icon(icon);
				var defaultIcon = new (feathers_skins_CircleSkin().default)();
				defaultIcon.set_width(20.0);
				defaultIcon.set_height(20.0);
				defaultIcon.set_minWidth(20.0);
				defaultIcon.set_minHeight(20.0);
				defaultIcon.set_border(theme.getInsetBorder());
				defaultIcon.set_disabledBorder(theme.getDisabledInsetBorder());
				defaultIcon.setBorderForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getSelectedInsetBorder());
				defaultIcon.set_fill(theme.getInsetFill());
				defaultIcon.set_disabledFill(theme.getDisabledInsetFill());
				icon.set_defaultView(defaultIcon);
				var selectedIcon = new (feathers_skins_CircleSkin().default)();
				selectedIcon.set_width(20.0);
				selectedIcon.set_height(20.0);
				selectedIcon.set_minWidth(20.0);
				selectedIcon.set_minHeight(20.0);
				selectedIcon.set_border(theme.getSelectedInsetBorder());
				selectedIcon.set_disabledBorder(theme.getDisabledInsetBorder());
				selectedIcon.setBorderForState((feathers_controls_ToggleButtonState().default).DOWN(true),theme.getSelectedInsetBorder());
				selectedIcon.set_fill(theme.getReversedActiveThemeFill());
				selectedIcon.set_disabledFill(theme.getDisabledInsetFill());
				var symbol = new (openfl_display_Shape())();
				symbol.get_graphics().beginFill(theme.textColor);
				symbol.get_graphics().drawCircle(10.0,10.0,4.0);
				symbol.get_graphics().endFill();
				selectedIcon.addChild(symbol);
				icon.set_selectedView(selectedIcon);
				var disabledAndSelectedIcon = new (feathers_skins_CircleSkin().default)();
				disabledAndSelectedIcon.set_width(20.0);
				disabledAndSelectedIcon.set_height(20.0);
				disabledAndSelectedIcon.set_minWidth(20.0);
				disabledAndSelectedIcon.set_minHeight(20.0);
				disabledAndSelectedIcon.set_border(theme.getDisabledInsetBorder(2.0));
				disabledAndSelectedIcon.set_fill(theme.getDisabledInsetFill());
				var disabledSymbol = new (openfl_display_Shape())();
				disabledSymbol.get_graphics().beginFill(theme.disabledTextColor);
				disabledSymbol.get_graphics().drawCircle(10.0,10.0,4.0);
				disabledSymbol.get_graphics().endFill();
				disabledAndSelectedIcon.addChild(disabledSymbol);
				icon.setViewForState((feathers_controls_ToggleButtonState().default).DISABLED(true),disabledAndSelectedIcon);
			}
			if(radio.get_focusRectSkin() == null) {
				var focusRectSkin = new (feathers_skins_RectangleSkin().default)();
				focusRectSkin.set_fill(null);
				focusRectSkin.set_border(theme.getFocusBorder());
				focusRectSkin.set_cornerRadius(3.0);
				radio.set_focusRectSkin(focusRectSkin);
				radio.set_focusPaddingTop(3.0);
				radio.set_focusPaddingRight(3.0);
				radio.set_focusPaddingBottom(3.0);
				radio.set_focusPaddingLeft(3.0);
			}
			radio.set_horizontalAlign((feathers_layout_HorizontalAlign().default).LEFT);
			radio.set_gap(4.0);
		});
	}
}


// Export

exports["default"] = SteelRadioStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelRouterNavigatorStyles.js":
/*!*********************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelRouterNavigatorStyles.js ***!
  \*********************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelRouterNavigatorStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_navigators_RouterNavigator() {return __webpack_require__(/*! ./../../../../feathers/controls/navigators/RouterNavigator */ "./lib/_gen/feathers/controls/navigators/RouterNavigator.js");}
function feathers_motion_transitions_SlideTransitionBuilder() {return __webpack_require__(/*! ./../../../../feathers/motion/transitions/SlideTransitionBuilder */ "./lib/_gen/feathers/motion/transitions/SlideTransitionBuilder.js");}

// Constructor

var SteelRouterNavigatorStyles = function(){}

// Meta

SteelRouterNavigatorStyles.__name__ = "feathers.themes.steel.components.SteelRouterNavigatorStyles";
SteelRouterNavigatorStyles.__isInterface__ = false;
SteelRouterNavigatorStyles.prototype = {
	
};
SteelRouterNavigatorStyles.prototype.__class__ = SteelRouterNavigatorStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelRouterNavigatorStyles"] = SteelRouterNavigatorStyles;

// Init



// Statics

SteelRouterNavigatorStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_navigators_RouterNavigator().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_navigators_RouterNavigator().default),null,function(navigator) {
			navigator.set_backTransition(new (feathers_motion_transitions_SlideTransitionBuilder())().setRight().build());
			navigator.set_forwardTransition(new (feathers_motion_transitions_SlideTransitionBuilder())().setLeft().build());
		});
	}
}


// Export

exports["default"] = SteelRouterNavigatorStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelScrollContainerStyles.js":
/*!*********************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelScrollContainerStyles.js ***!
  \*********************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelScrollContainerStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_ScrollContainer() {return __webpack_require__(/*! ./../../../../feathers/controls/ScrollContainer */ "./lib/_gen/feathers/controls/ScrollContainer.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}

// Constructor

var SteelScrollContainerStyles = function(){}

// Meta

SteelScrollContainerStyles.__name__ = "feathers.themes.steel.components.SteelScrollContainerStyles";
SteelScrollContainerStyles.__isInterface__ = false;
SteelScrollContainerStyles.prototype = {
	
};
SteelScrollContainerStyles.prototype.__class__ = SteelScrollContainerStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelScrollContainerStyles"] = SteelScrollContainerStyles;

// Init



// Statics

SteelScrollContainerStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_ScrollContainer().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_ScrollContainer().default),null,function(container) {
			var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
			container.set_autoHideScrollBars(!isDesktop);
			container.set_fixedScrollBars(isDesktop);
			if(container.get_backgroundSkin() == null) {
				var backgroundSkin = new (feathers_skins_RectangleSkin().default)();
				backgroundSkin.set_fill(theme.getContainerFill());
				container.set_backgroundSkin(backgroundSkin);
			}
			if(container.get_focusRectSkin() == null) {
				var focusRectSkin = new (feathers_skins_RectangleSkin().default)();
				focusRectSkin.set_fill(null);
				focusRectSkin.set_border(theme.getFocusBorder());
				container.set_focusRectSkin(focusRectSkin);
			}
		});
	}
}


// Export

exports["default"] = SteelScrollContainerStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelSortOrderHeaderRendererStyles.js":
/*!*****************************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelSortOrderHeaderRendererStyles.js ***!
  \*****************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelSortOrderHeaderRendererStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_dataRenderers_SortOrderHeaderRenderer() {return __webpack_require__(/*! ./../../../../feathers/controls/dataRenderers/SortOrderHeaderRenderer */ "./lib/_gen/feathers/controls/dataRenderers/SortOrderHeaderRenderer.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_skins_TriangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/TriangleSkin */ "./lib/_gen/feathers/skins/TriangleSkin.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}
function feathers_graphics_FillStyle() {return __webpack_require__(/*! ./../../../../feathers/graphics/FillStyle */ "./lib/_gen/feathers/graphics/FillStyle.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}

// Constructor

var SteelSortOrderHeaderRendererStyles = function(){}

// Meta

SteelSortOrderHeaderRendererStyles.__name__ = "feathers.themes.steel.components.SteelSortOrderHeaderRendererStyles";
SteelSortOrderHeaderRendererStyles.__isInterface__ = false;
SteelSortOrderHeaderRendererStyles.prototype = {
	
};
SteelSortOrderHeaderRendererStyles.prototype.__class__ = SteelSortOrderHeaderRendererStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelSortOrderHeaderRendererStyles"] = SteelSortOrderHeaderRendererStyles;

// Init



// Statics

SteelSortOrderHeaderRendererStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_dataRenderers_SortOrderHeaderRenderer().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_dataRenderers_SortOrderHeaderRenderer().default),null,function(itemRenderer) {
			var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
			if(itemRenderer.get_backgroundSkin() == null) {
				var skin = new (feathers_skins_RectangleSkin().default)();
				skin.set_fill(theme.getSubHeadingFill());
				if(isDesktop) {
					skin.set_width(22.0);
					skin.set_height(22.0);
					skin.set_minWidth(22.0);
					skin.set_minHeight(22.0);
				} else {
					skin.set_width(44.0);
					skin.set_height(44.0);
					skin.set_minWidth(44.0);
					skin.set_minHeight(44.0);
				}
				itemRenderer.set_backgroundSkin(skin);
			}
			if(itemRenderer.get_sortAscendingIcon() == null) {
				var sortAscendingIcon = new (feathers_skins_TriangleSkin().default)();
				sortAscendingIcon.set_pointPosition((feathers_layout_RelativePosition().default).TOP);
				sortAscendingIcon.set_fill((feathers_graphics_FillStyle().default).SolidColor(theme.textColor));
				sortAscendingIcon.set_disabledFill((feathers_graphics_FillStyle().default).SolidColor(theme.disabledTextColor));
				sortAscendingIcon.set_width(8.0);
				sortAscendingIcon.set_height(4.0);
				itemRenderer.set_sortAscendingIcon(sortAscendingIcon);
			}
			if(itemRenderer.get_sortDescendingIcon() == null) {
				var sortDescendingIcon = new (feathers_skins_TriangleSkin().default)();
				sortDescendingIcon.set_pointPosition((feathers_layout_RelativePosition().default).BOTTOM);
				sortDescendingIcon.set_fill((feathers_graphics_FillStyle().default).SolidColor(theme.textColor));
				sortDescendingIcon.set_disabledFill((feathers_graphics_FillStyle().default).SolidColor(theme.disabledTextColor));
				sortDescendingIcon.set_width(8.0);
				sortDescendingIcon.set_height(4.0);
				itemRenderer.set_sortDescendingIcon(sortDescendingIcon);
			}
			if(itemRenderer.get_textFormat() == null) {
				itemRenderer.set_textFormat(theme.getTextFormat());
			}
			if(itemRenderer.get_disabledTextFormat() == null) {
				itemRenderer.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			if(itemRenderer.get_secondaryTextFormat() == null) {
				itemRenderer.set_secondaryTextFormat(theme.getDetailTextFormat());
			}
			if(itemRenderer.get_disabledSecondaryTextFormat() == null) {
				itemRenderer.set_disabledSecondaryTextFormat(theme.getDisabledDetailTextFormat());
			}
			itemRenderer.set_paddingTop(4.0);
			itemRenderer.set_paddingRight(10.0);
			itemRenderer.set_paddingBottom(4.0);
			itemRenderer.set_paddingLeft(10.0);
			itemRenderer.set_gap(4.0);
			itemRenderer.set_horizontalAlign((feathers_layout_HorizontalAlign().default).LEFT);
		});
	}
}


// Export

exports["default"] = SteelSortOrderHeaderRendererStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelStackNavigatorStyles.js":
/*!********************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelStackNavigatorStyles.js ***!
  \********************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelStackNavigatorStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_navigators_StackNavigator() {return __webpack_require__(/*! ./../../../../feathers/controls/navigators/StackNavigator */ "./lib/_gen/feathers/controls/navigators/StackNavigator.js");}
function feathers_motion_transitions_SlideTransitionBuilder() {return __webpack_require__(/*! ./../../../../feathers/motion/transitions/SlideTransitionBuilder */ "./lib/_gen/feathers/motion/transitions/SlideTransitionBuilder.js");}

// Constructor

var SteelStackNavigatorStyles = function(){}

// Meta

SteelStackNavigatorStyles.__name__ = "feathers.themes.steel.components.SteelStackNavigatorStyles";
SteelStackNavigatorStyles.__isInterface__ = false;
SteelStackNavigatorStyles.prototype = {
	
};
SteelStackNavigatorStyles.prototype.__class__ = SteelStackNavigatorStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelStackNavigatorStyles"] = SteelStackNavigatorStyles;

// Init



// Statics

SteelStackNavigatorStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_navigators_StackNavigator().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_navigators_StackNavigator().default),null,function(navigator) {
			navigator.set_popTransition(new (feathers_motion_transitions_SlideTransitionBuilder())().setRight().build());
			navigator.set_pushTransition(new (feathers_motion_transitions_SlideTransitionBuilder())().setLeft().build());
		});
	}
}


// Export

exports["default"] = SteelStackNavigatorStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelTabBarStyles.js":
/*!************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelTabBarStyles.js ***!
  \************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelTabBarStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_TabBar() {return __webpack_require__(/*! ./../../../../feathers/controls/TabBar */ "./lib/_gen/feathers/controls/TabBar.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_layout_HorizontalLayout() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalLayout */ "./lib/_gen/feathers/layout/HorizontalLayout.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}
function feathers_controls_ToggleButton() {return __webpack_require__(/*! ./../../../../feathers/controls/ToggleButton */ "./lib/_gen/feathers/controls/ToggleButton.js");}
function feathers_skins_TabSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/TabSkin */ "./lib/_gen/feathers/skins/TabSkin.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}
function feathers_controls_ToggleButtonState() {return __webpack_require__(/*! ./../../../../feathers/controls/ToggleButtonState */ "./lib/_gen/feathers/controls/ToggleButtonState.js");}

// Constructor

var SteelTabBarStyles = function(){}

// Meta

SteelTabBarStyles.__name__ = "feathers.themes.steel.components.SteelTabBarStyles";
SteelTabBarStyles.__isInterface__ = false;
SteelTabBarStyles.prototype = {
	
};
SteelTabBarStyles.prototype.__class__ = SteelTabBarStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelTabBarStyles"] = SteelTabBarStyles;

// Init



// Statics

SteelTabBarStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_TabBar().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_TabBar().default),null,function(tabBar) {
			var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
			if(tabBar.get_backgroundSkin() == null) {
				var skin = new (feathers_skins_RectangleSkin().default)();
				skin.set_fill(theme.getControlFill());
				skin.set_disabledFill(theme.getControlDisabledFill());
				tabBar.set_backgroundSkin(skin);
			}
			if(tabBar.get_focusRectSkin() == null) {
				var focusRectSkin = new (feathers_skins_RectangleSkin().default)();
				focusRectSkin.set_fill(null);
				focusRectSkin.set_border(theme.getFocusBorder());
				tabBar.set_focusRectSkin(focusRectSkin);
			}
			if(tabBar.get_layout() == null) {
				var layout = new (feathers_layout_HorizontalLayout().default)();
				if(!isDesktop) {
					layout.set_horizontalAlign((feathers_layout_HorizontalAlign().default).CENTER);
				}
				tabBar.set_layout(layout);
			}
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_ToggleButton().default),(feathers_controls_TabBar().default).CHILD_VARIANT_TAB) == null) {
		styleProvider.setStyleFunction((feathers_controls_ToggleButton().default),(feathers_controls_TabBar().default).CHILD_VARIANT_TAB,function(button) {
			var isDesktop1 = (feathers_utils_DeviceUtil().default).isDesktop();
			if(button.get_backgroundSkin() == null) {
				var skin1 = null;
				if(isDesktop1) {
					var desktopSkin = new (feathers_skins_TabSkin().default)();
					desktopSkin.set_cornerRadius(3.0);
					desktopSkin.set_cornerRadiusPosition((feathers_layout_RelativePosition().default).TOP);
					desktopSkin.set_drawBaseBorder(false);
					desktopSkin.set_maxWidth(100.0);
					desktopSkin.set_minWidth(20.0);
					skin1 = desktopSkin;
				} else {
					var mobileSkin = new (feathers_skins_RectangleSkin().default)();
					mobileSkin.set_minWidth(44.0);
					mobileSkin.set_minHeight(44.0);
					skin1 = mobileSkin;
				}
				skin1.set_fill(theme.getButtonFill());
				skin1.set_disabledFill(theme.getButtonDisabledFill());
				skin1.set_selectedFill(theme.getThemeFill());
				skin1.setFillForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getReversedActiveThemeFill());
				skin1.setFillForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getReversedActiveThemeFill());
				skin1.set_border(theme.getButtonBorder());
				skin1.set_selectedBorder(theme.getActiveFillBorder());
				skin1.setBorderForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getActiveFillBorder());
				button.set_backgroundSkin(skin1);
			}
			if(button.get_textFormat() == null) {
				button.set_textFormat(theme.getTextFormat());
			}
			if(button.get_disabledTextFormat() == null) {
				button.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			button.set_paddingTop(4.0);
			button.set_paddingRight(10.0);
			button.set_paddingBottom(4.0);
			button.set_paddingLeft(10.0);
			button.set_gap(4.0);
		});
	}
}


// Export

exports["default"] = SteelTabBarStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelTabNavigatorStyles.js":
/*!******************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelTabNavigatorStyles.js ***!
  \******************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelTabNavigatorStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_navigators_TabNavigator() {return __webpack_require__(/*! ./../../../../feathers/controls/navigators/TabNavigator */ "./lib/_gen/feathers/controls/navigators/TabNavigator.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}
function feathers_motion_transitions_SlideTransitionBuilder() {return __webpack_require__(/*! ./../../../../feathers/motion/transitions/SlideTransitionBuilder */ "./lib/_gen/feathers/motion/transitions/SlideTransitionBuilder.js");}

// Constructor

var SteelTabNavigatorStyles = function(){}

// Meta

SteelTabNavigatorStyles.__name__ = "feathers.themes.steel.components.SteelTabNavigatorStyles";
SteelTabNavigatorStyles.__isInterface__ = false;
SteelTabNavigatorStyles.prototype = {
	
};
SteelTabNavigatorStyles.prototype.__class__ = SteelTabNavigatorStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelTabNavigatorStyles"] = SteelTabNavigatorStyles;

// Init



// Statics

SteelTabNavigatorStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_navigators_TabNavigator().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_navigators_TabNavigator().default),null,function(navigator) {
			var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
			navigator.set_tabBarPosition(isDesktop ? (feathers_layout_RelativePosition().default).TOP : (feathers_layout_RelativePosition().default).BOTTOM);
			if(!isDesktop) {
				navigator.set_previousTransition(new (feathers_motion_transitions_SlideTransitionBuilder())().setRight().build());
				navigator.set_nextTransition(new (feathers_motion_transitions_SlideTransitionBuilder())().setLeft().build());
			}
		});
	}
}


// Export

exports["default"] = SteelTabNavigatorStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelTextAreaStyles.js":
/*!**************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelTextAreaStyles.js ***!
  \**************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelTextAreaStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_TextArea() {return __webpack_require__(/*! ./../../../../feathers/controls/TextArea */ "./lib/_gen/feathers/controls/TextArea.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_controls_TextInputState() {return __webpack_require__(/*! ./../../../../feathers/controls/TextInputState */ "./lib/_gen/feathers/controls/TextInputState.js");}
function feathers_controls_TextCallout() {return __webpack_require__(/*! ./../../../../feathers/controls/TextCallout */ "./lib/_gen/feathers/controls/TextCallout.js");}

// Constructor

var SteelTextAreaStyles = function(){}

// Meta

SteelTextAreaStyles.__name__ = "feathers.themes.steel.components.SteelTextAreaStyles";
SteelTextAreaStyles.__isInterface__ = false;
SteelTextAreaStyles.prototype = {
	
};
SteelTextAreaStyles.prototype.__class__ = SteelTextAreaStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelTextAreaStyles"] = SteelTextAreaStyles;

// Init



// Statics

SteelTextAreaStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_TextArea().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_TextArea().default),null,function(textArea) {
			var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
			textArea.set_autoHideScrollBars(!isDesktop);
			textArea.set_fixedScrollBars(isDesktop);
			if(textArea.get_backgroundSkin() == null) {
				var backgroundSkin = new (feathers_skins_RectangleSkin().default)();
				backgroundSkin.set_cornerRadius(3.0);
				backgroundSkin.set_width(160.0);
				backgroundSkin.set_height(120.0);
				backgroundSkin.set_fill(theme.getInsetFill());
				backgroundSkin.set_border(theme.getInsetBorder());
				backgroundSkin.setBorderForState((feathers_controls_TextInputState().default).FOCUSED,theme.getThemeBorder());
				backgroundSkin.setBorderForState((feathers_controls_TextInputState().default).ERROR,theme.getDangerBorder());
				textArea.set_backgroundSkin(backgroundSkin);
			}
			if(textArea.get_textFormat() == null) {
				textArea.set_textFormat(theme.getTextFormat());
			}
			if(textArea.get_disabledTextFormat() == null) {
				textArea.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			if(textArea.get_promptTextFormat() == null) {
				textArea.set_promptTextFormat(theme.getSecondaryTextFormat());
			}
			textArea.set_paddingTop(1.0);
			textArea.set_paddingRight(1.0);
			textArea.set_paddingBottom(1.0);
			textArea.set_paddingLeft(1.0);
			textArea.set_textPaddingTop(4.0);
			textArea.set_textPaddingRight(9.0);
			textArea.set_textPaddingBottom(5.0);
			textArea.set_textPaddingLeft(9.0);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_TextCallout().default),(feathers_controls_TextArea().default).CHILD_VARIANT_ERROR_CALLOUT) == null) {
		styleProvider.setStyleFunction((feathers_controls_TextCallout().default),(feathers_controls_TextArea().default).CHILD_VARIANT_ERROR_CALLOUT,function(callout) {
			(theme.styleProvider.getStyleFunction((feathers_controls_TextCallout().default),(feathers_controls_TextCallout().default).VARIANT_DANGER))(callout);
		});
	}
}


// Export

exports["default"] = SteelTextAreaStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelTextCalloutStyles.js":
/*!*****************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelTextCalloutStyles.js ***!
  \*****************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelTextCalloutStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_TextCallout() {return __webpack_require__(/*! ./../../../../feathers/controls/TextCallout */ "./lib/_gen/feathers/controls/TextCallout.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_skins_TriangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/TriangleSkin */ "./lib/_gen/feathers/skins/TriangleSkin.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}

// Constructor

var SteelTextCalloutStyles = function(){}

// Meta

SteelTextCalloutStyles.__name__ = "feathers.themes.steel.components.SteelTextCalloutStyles";
SteelTextCalloutStyles.__isInterface__ = false;
SteelTextCalloutStyles.prototype = {
	
};
SteelTextCalloutStyles.prototype.__class__ = SteelTextCalloutStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelTextCalloutStyles"] = SteelTextCalloutStyles;

// Init



// Statics

SteelTextCalloutStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_TextCallout().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_TextCallout().default),null,function(callout) {
			if(callout.get_textFormat() == null) {
				callout.set_textFormat(theme.getTextFormat());
			}
			if(callout.get_disabledTextFormat() == null) {
				callout.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			if(callout.get_backgroundSkin() == null) {
				var backgroundSkin = new (feathers_skins_RectangleSkin().default)();
				backgroundSkin.set_fill(theme.getContainerFill());
				backgroundSkin.set_border(theme.getContainerBorder());
				callout.set_backgroundSkin(backgroundSkin);
			}
			if(callout.get_topArrowSkin() == null) {
				var topArrowSkin = new (feathers_skins_TriangleSkin().default)();
				topArrowSkin.set_pointPosition((feathers_layout_RelativePosition().default).TOP);
				topArrowSkin.set_drawBaseBorder(false);
				topArrowSkin.set_fill(theme.getContainerFill());
				topArrowSkin.set_border(theme.getContainerBorder());
				topArrowSkin.set_width(10.0);
				topArrowSkin.set_height(6.0);
				callout.set_topArrowSkin(topArrowSkin);
			}
			if(callout.get_rightArrowSkin() == null) {
				var rightArrowSkin = new (feathers_skins_TriangleSkin().default)();
				rightArrowSkin.set_pointPosition((feathers_layout_RelativePosition().default).RIGHT);
				rightArrowSkin.set_drawBaseBorder(false);
				rightArrowSkin.set_fill(theme.getContainerFill());
				rightArrowSkin.set_border(theme.getContainerBorder());
				rightArrowSkin.set_width(6.0);
				rightArrowSkin.set_height(10.0);
				callout.set_rightArrowSkin(rightArrowSkin);
			}
			if(callout.get_bottomArrowSkin() == null) {
				var bottomArrowSkin = new (feathers_skins_TriangleSkin().default)();
				bottomArrowSkin.set_pointPosition((feathers_layout_RelativePosition().default).BOTTOM);
				bottomArrowSkin.set_drawBaseBorder(false);
				bottomArrowSkin.set_fill(theme.getContainerFill());
				bottomArrowSkin.set_border(theme.getContainerBorder());
				bottomArrowSkin.set_width(10.0);
				bottomArrowSkin.set_height(6.0);
				callout.set_bottomArrowSkin(bottomArrowSkin);
			}
			if(callout.get_leftArrowSkin() == null) {
				var leftArrowSkin = new (feathers_skins_TriangleSkin().default)();
				leftArrowSkin.set_pointPosition((feathers_layout_RelativePosition().default).LEFT);
				leftArrowSkin.set_drawBaseBorder(false);
				leftArrowSkin.set_fill(theme.getContainerFill());
				leftArrowSkin.set_border(theme.getContainerBorder());
				leftArrowSkin.set_width(6.0);
				leftArrowSkin.set_height(10.0);
				callout.set_leftArrowSkin(leftArrowSkin);
			}
			callout.set_topArrowGap(-1.0);
			callout.set_rightArrowGap(-1.0);
			callout.set_bottomArrowGap(-1.0);
			callout.set_leftArrowGap(-1.0);
			callout.set_paddingTop(1.0);
			callout.set_paddingRight(1.0);
			callout.set_paddingBottom(1.0);
			callout.set_paddingLeft(1.0);
			callout.set_marginTop(10.0);
			callout.set_marginRight(10.0);
			callout.set_marginBottom(10.0);
			callout.set_marginLeft(10.0);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_TextCallout().default),(feathers_controls_TextCallout().default).VARIANT_DANGER) == null) {
		styleProvider.setStyleFunction((feathers_controls_TextCallout().default),(feathers_controls_TextCallout().default).VARIANT_DANGER,function(callout1) {
			if(callout1.get_textFormat() == null) {
				callout1.set_textFormat(theme.getTextFormat());
			}
			if(callout1.get_disabledTextFormat() == null) {
				callout1.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			if(callout1.get_backgroundSkin() == null) {
				var backgroundSkin1 = new (feathers_skins_RectangleSkin().default)();
				backgroundSkin1.set_fill(theme.getDangerFill());
				backgroundSkin1.set_border(theme.getDangerBorder());
				callout1.set_backgroundSkin(backgroundSkin1);
			}
			if(callout1.get_topArrowSkin() == null) {
				var topArrowSkin1 = new (feathers_skins_TriangleSkin().default)();
				topArrowSkin1.set_pointPosition((feathers_layout_RelativePosition().default).TOP);
				topArrowSkin1.set_drawBaseBorder(false);
				topArrowSkin1.set_fill(theme.getDangerFill());
				topArrowSkin1.set_border(theme.getDangerBorder());
				topArrowSkin1.set_width(10.0);
				topArrowSkin1.set_height(6.0);
				callout1.set_topArrowSkin(topArrowSkin1);
			}
			if(callout1.get_rightArrowSkin() == null) {
				var rightArrowSkin1 = new (feathers_skins_TriangleSkin().default)();
				rightArrowSkin1.set_pointPosition((feathers_layout_RelativePosition().default).RIGHT);
				rightArrowSkin1.set_drawBaseBorder(false);
				rightArrowSkin1.set_fill(theme.getDangerFill());
				rightArrowSkin1.set_border(theme.getDangerBorder());
				rightArrowSkin1.set_width(6.0);
				rightArrowSkin1.set_height(10.0);
				callout1.set_rightArrowSkin(rightArrowSkin1);
			}
			if(callout1.get_bottomArrowSkin() == null) {
				var bottomArrowSkin1 = new (feathers_skins_TriangleSkin().default)();
				bottomArrowSkin1.set_pointPosition((feathers_layout_RelativePosition().default).BOTTOM);
				bottomArrowSkin1.set_drawBaseBorder(false);
				bottomArrowSkin1.set_fill(theme.getDangerFill());
				bottomArrowSkin1.set_border(theme.getDangerBorder());
				bottomArrowSkin1.set_width(10.0);
				bottomArrowSkin1.set_height(6.0);
				callout1.set_bottomArrowSkin(bottomArrowSkin1);
			}
			if(callout1.get_leftArrowSkin() == null) {
				var leftArrowSkin1 = new (feathers_skins_TriangleSkin().default)();
				leftArrowSkin1.set_pointPosition((feathers_layout_RelativePosition().default).LEFT);
				leftArrowSkin1.set_drawBaseBorder(false);
				leftArrowSkin1.set_fill(theme.getDangerFill());
				leftArrowSkin1.set_border(theme.getDangerBorder());
				leftArrowSkin1.set_width(6.0);
				leftArrowSkin1.set_height(10.0);
				callout1.set_leftArrowSkin(leftArrowSkin1);
			}
			callout1.set_topArrowGap(-1.0);
			callout1.set_rightArrowGap(-1.0);
			callout1.set_bottomArrowGap(-1.0);
			callout1.set_leftArrowGap(-1.0);
			callout1.set_paddingTop(1.0);
			callout1.set_paddingRight(1.0);
			callout1.set_paddingBottom(1.0);
			callout1.set_paddingLeft(1.0);
			callout1.set_marginTop(10.0);
			callout1.set_marginRight(10.0);
			callout1.set_marginBottom(10.0);
			callout1.set_marginLeft(10.0);
		});
	}
}


// Export

exports["default"] = SteelTextCalloutStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelTextInputStyles.js":
/*!***************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelTextInputStyles.js ***!
  \***************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelTextInputStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_TextInput() {return __webpack_require__(/*! ./../../../../feathers/controls/TextInput */ "./lib/_gen/feathers/controls/TextInput.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_controls_TextInputState() {return __webpack_require__(/*! ./../../../../feathers/controls/TextInputState */ "./lib/_gen/feathers/controls/TextInputState.js");}
function feathers_skins_PillSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/PillSkin */ "./lib/_gen/feathers/skins/PillSkin.js");}
function feathers_layout_Direction() {return __webpack_require__(/*! ./../../../../feathers/layout/Direction */ "./lib/_gen/feathers/layout/Direction.js");}
function feathers_controls_TextCallout() {return __webpack_require__(/*! ./../../../../feathers/controls/TextCallout */ "./lib/_gen/feathers/controls/TextCallout.js");}

// Constructor

var SteelTextInputStyles = function(){}

// Meta

SteelTextInputStyles.__name__ = "feathers.themes.steel.components.SteelTextInputStyles";
SteelTextInputStyles.__isInterface__ = false;
SteelTextInputStyles.prototype = {
	
};
SteelTextInputStyles.prototype.__class__ = SteelTextInputStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelTextInputStyles"] = SteelTextInputStyles;

// Init



// Statics

SteelTextInputStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_TextInput().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_TextInput().default),null,function(input) {
			if(input.get_backgroundSkin() == null) {
				var inputSkin = new (feathers_skins_RectangleSkin().default)();
				inputSkin.set_cornerRadius(3.0);
				inputSkin.set_width(160.0);
				inputSkin.set_fill(theme.getInsetFill());
				inputSkin.set_border(theme.getInsetBorder());
				inputSkin.set_disabledFill(theme.getDisabledInsetFill());
				inputSkin.setBorderForState((feathers_controls_TextInputState().default).FOCUSED,theme.getThemeBorder());
				inputSkin.setBorderForState((feathers_controls_TextInputState().default).ERROR,theme.getDangerBorder());
				input.set_backgroundSkin(inputSkin);
			}
			if(input.get_textFormat() == null) {
				input.set_textFormat(theme.getTextFormat());
			}
			if(input.get_disabledTextFormat() == null) {
				input.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			if(input.get_promptTextFormat() == null) {
				input.set_promptTextFormat(theme.getSecondaryTextFormat());
			}
			input.set_paddingTop(6.0);
			input.set_paddingRight(10.0);
			input.set_paddingBottom(6.0);
			input.set_paddingLeft(10.0);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_TextInput().default),(feathers_controls_TextInput().default).VARIANT_SEARCH) == null) {
		styleProvider.setStyleFunction((feathers_controls_TextInput().default),(feathers_controls_TextInput().default).VARIANT_SEARCH,function(input1) {
			if(input1.get_backgroundSkin() == null) {
				var inputSkin1 = new (feathers_skins_PillSkin().default)();
				inputSkin1.set_capDirection((feathers_layout_Direction().default).HORIZONTAL);
				inputSkin1.set_width(160.0);
				inputSkin1.set_fill(theme.getInsetFill());
				inputSkin1.set_border(theme.getInsetBorder());
				inputSkin1.set_disabledFill(theme.getDisabledInsetFill());
				inputSkin1.setBorderForState((feathers_controls_TextInputState().default).FOCUSED,theme.getThemeBorder());
				input1.set_backgroundSkin(inputSkin1);
			}
			if(input1.get_textFormat() == null) {
				input1.set_textFormat(theme.getTextFormat());
			}
			if(input1.get_disabledTextFormat() == null) {
				input1.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			if(input1.get_promptTextFormat() == null) {
				input1.set_promptTextFormat(theme.getSecondaryTextFormat());
			}
			input1.set_paddingTop(6.0);
			input1.set_paddingRight(10.0);
			input1.set_paddingBottom(6.0);
			input1.set_paddingLeft(10.0);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_TextCallout().default),(feathers_controls_TextInput().default).CHILD_VARIANT_ERROR_CALLOUT) == null) {
		styleProvider.setStyleFunction((feathers_controls_TextCallout().default),(feathers_controls_TextInput().default).CHILD_VARIANT_ERROR_CALLOUT,function(callout) {
			(theme.styleProvider.getStyleFunction((feathers_controls_TextCallout().default),(feathers_controls_TextCallout().default).VARIANT_DANGER))(callout);
		});
	}
}


// Export

exports["default"] = SteelTextInputStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelToggleButtonStyles.js":
/*!******************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelToggleButtonStyles.js ***!
  \******************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelToggleButtonStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_ToggleButton() {return __webpack_require__(/*! ./../../../../feathers/controls/ToggleButton */ "./lib/_gen/feathers/controls/ToggleButton.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_controls_ToggleButtonState() {return __webpack_require__(/*! ./../../../../feathers/controls/ToggleButtonState */ "./lib/_gen/feathers/controls/ToggleButtonState.js");}

// Constructor

var SteelToggleButtonStyles = function(){}

// Meta

SteelToggleButtonStyles.__name__ = "feathers.themes.steel.components.SteelToggleButtonStyles";
SteelToggleButtonStyles.__isInterface__ = false;
SteelToggleButtonStyles.prototype = {
	
};
SteelToggleButtonStyles.prototype.__class__ = SteelToggleButtonStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelToggleButtonStyles"] = SteelToggleButtonStyles;

// Init



// Statics

SteelToggleButtonStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_ToggleButton().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_ToggleButton().default),null,function(button) {
			if(button.get_backgroundSkin() == null) {
				var skin = new (feathers_skins_RectangleSkin().default)();
				skin.set_fill(theme.getButtonFill());
				skin.set_disabledFill(theme.getButtonDisabledFill());
				skin.set_selectedFill(theme.getThemeFill());
				skin.setFillForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getReversedActiveThemeFill());
				skin.setFillForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getReversedActiveThemeFill());
				skin.set_border(theme.getButtonBorder());
				skin.set_selectedBorder(theme.getSelectedBorder());
				skin.setBorderForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getActiveFillBorder());
				skin.setBorderForState((feathers_controls_ToggleButtonState().default).DOWN(true),theme.getActiveFillBorder());
				skin.set_cornerRadius(3.0);
				button.set_backgroundSkin(skin);
			}
			if(button.get_focusRectSkin() == null) {
				var focusRectSkin = new (feathers_skins_RectangleSkin().default)();
				focusRectSkin.set_fill(null);
				focusRectSkin.set_border(theme.getFocusBorder());
				focusRectSkin.set_cornerRadius(3.0);
				button.set_focusRectSkin(focusRectSkin);
			}
			if(button.get_textFormat() == null) {
				button.set_textFormat(theme.getTextFormat());
			}
			if(button.get_disabledTextFormat() == null) {
				button.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			button.set_paddingTop(4.0);
			button.set_paddingRight(10.0);
			button.set_paddingBottom(4.0);
			button.set_paddingLeft(10.0);
			button.set_gap(4.0);
		});
	}
}


// Export

exports["default"] = SteelToggleButtonStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelToggleSwitchStyles.js":
/*!******************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelToggleSwitchStyles.js ***!
  \******************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelToggleSwitchStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_ToggleSwitch() {return __webpack_require__(/*! ./../../../../feathers/controls/ToggleSwitch */ "./lib/_gen/feathers/controls/ToggleSwitch.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_controls_BasicToggleButton() {return __webpack_require__(/*! ./../../../../feathers/controls/BasicToggleButton */ "./lib/_gen/feathers/controls/BasicToggleButton.js");}
function feathers_skins_CircleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/CircleSkin */ "./lib/_gen/feathers/skins/CircleSkin.js");}

// Constructor

var SteelToggleSwitchStyles = function(){}

// Meta

SteelToggleSwitchStyles.__name__ = "feathers.themes.steel.components.SteelToggleSwitchStyles";
SteelToggleSwitchStyles.__isInterface__ = false;
SteelToggleSwitchStyles.prototype = {
	
};
SteelToggleSwitchStyles.prototype.__class__ = SteelToggleSwitchStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelToggleSwitchStyles"] = SteelToggleSwitchStyles;

// Init



// Statics

SteelToggleSwitchStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_ToggleSwitch().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_ToggleSwitch().default),null,function(toggle) {
			if(toggle.get_trackSkin() == null) {
				var trackSkin = new (feathers_skins_RectangleSkin().default)();
				trackSkin.set_width(64.0);
				trackSkin.set_height(32.0);
				trackSkin.set_minWidth(64.0);
				trackSkin.set_minHeight(32.0);
				trackSkin.set_cornerRadius(16.0);
				trackSkin.set_border(theme.getInsetBorder());
				trackSkin.set_disabledBorder(theme.getInsetBorder());
				trackSkin.set_selectedBorder(theme.getSelectedInsetBorder());
				trackSkin.set_fill(theme.getInsetFill());
				trackSkin.set_selectedFill(theme.getReversedActiveThemeFill());
				trackSkin.set_disabledFill(theme.getDisabledInsetFill());
				var track = new (feathers_controls_BasicToggleButton().default)();
				track.set_toggleable(false);
				track.set_keepDownStateOnRollOut(true);
				track.set_backgroundSkin(trackSkin);
				toggle.set_trackSkin(track);
			}
			if(toggle.get_thumbSkin() == null) {
				var thumbSkin = new (feathers_skins_CircleSkin().default)();
				thumbSkin.set_width(32.0);
				thumbSkin.set_height(32.0);
				thumbSkin.set_minWidth(32.0);
				thumbSkin.set_minHeight(32.0);
				thumbSkin.set_border(theme.getBorder());
				thumbSkin.set_disabledBorder(theme.getBorder());
				thumbSkin.set_fill(theme.getButtonFill());
				thumbSkin.set_disabledFill(theme.getButtonDisabledFill());
				var thumb = new (feathers_controls_BasicToggleButton().default)();
				thumb.set_toggleable(false);
				thumb.set_keepDownStateOnRollOut(true);
				thumb.set_backgroundSkin(thumbSkin);
				toggle.set_thumbSkin(thumb);
			}
			if(toggle.get_focusRectSkin() == null) {
				var focusRectSkin = new (feathers_skins_RectangleSkin().default)();
				focusRectSkin.set_fill(null);
				focusRectSkin.set_border(theme.getFocusBorder());
				focusRectSkin.set_cornerRadius(16.0);
				toggle.set_focusRectSkin(focusRectSkin);
			}
		});
	}
}


// Export

exports["default"] = SteelToggleSwitchStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelToolTipStyles.js":
/*!*************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelToolTipStyles.js ***!
  \*************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelToolTipStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_Label() {return __webpack_require__(/*! ./../../../../feathers/controls/Label */ "./lib/_gen/feathers/controls/Label.js");}
function feathers_core_DefaultToolTipManager() {return __webpack_require__(/*! ./../../../../feathers/core/DefaultToolTipManager */ "./lib/_gen/feathers/core/DefaultToolTipManager.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}

// Constructor

var SteelToolTipStyles = function(){}

// Meta

SteelToolTipStyles.__name__ = "feathers.themes.steel.components.SteelToolTipStyles";
SteelToolTipStyles.__isInterface__ = false;
SteelToolTipStyles.prototype = {
	
};
SteelToolTipStyles.prototype.__class__ = SteelToolTipStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelToolTipStyles"] = SteelToolTipStyles;

// Init



// Statics

SteelToolTipStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_Label().default),(feathers_core_DefaultToolTipManager().default).CHILD_VARIANT_TOOL_TIP) == null) {
		styleProvider.setStyleFunction((feathers_controls_Label().default),(feathers_core_DefaultToolTipManager().default).CHILD_VARIANT_TOOL_TIP,function(label) {
			if(label.get_backgroundSkin() == null) {
				var backgroundSkin = new (feathers_skins_RectangleSkin().default)();
				backgroundSkin.set_border(theme.getBorder());
				backgroundSkin.set_fill(theme.getContainerFill());
				backgroundSkin.set_cornerRadius(2.0);
				backgroundSkin.set_maxWidth(276.0);
				label.set_backgroundSkin(backgroundSkin);
			}
			if(label.get_textFormat() == null) {
				label.set_textFormat(theme.getTextFormat());
			}
			if(label.get_disabledTextFormat() == null) {
				label.set_disabledTextFormat(theme.getDisabledDetailTextFormat());
			}
			label.set_wordWrap(true);
			label.set_paddingTop(2.0);
			label.set_paddingRight(2.0);
			label.set_paddingBottom(2.0);
			label.set_paddingLeft(2.0);
		});
	}
}


// Export

exports["default"] = SteelToolTipStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelTreeGridViewStyles.js":
/*!******************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelTreeGridViewStyles.js ***!
  \******************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelTreeGridViewStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_layout_VerticalListLayout() {return __webpack_require__(/*! ./../../../../feathers/layout/VerticalListLayout */ "./lib/_gen/feathers/layout/VerticalListLayout.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_controls_TreeGridView() {return __webpack_require__(/*! ./../../../../feathers/controls/TreeGridView */ "./lib/_gen/feathers/controls/TreeGridView.js");}
function feathers_controls_dataRenderers_ItemRenderer() {return __webpack_require__(/*! ./../../../../feathers/controls/dataRenderers/ItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ItemRenderer.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}
function feathers_controls_Button() {return __webpack_require__(/*! ./../../../../feathers/controls/Button */ "./lib/_gen/feathers/controls/Button.js");}
function feathers_skins_VerticalLineSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/VerticalLineSkin */ "./lib/_gen/feathers/skins/VerticalLineSkin.js");}
function feathers_graphics_FillStyle() {return __webpack_require__(/*! ./../../../../feathers/graphics/FillStyle */ "./lib/_gen/feathers/graphics/FillStyle.js");}
function feathers_controls_ButtonState() {return __webpack_require__(/*! ./../../../../feathers/controls/ButtonState */ "./lib/_gen/feathers/controls/ButtonState.js");}

// Constructor

var SteelTreeGridViewStyles = function(){}

// Meta

SteelTreeGridViewStyles.__name__ = "feathers.themes.steel.components.SteelTreeGridViewStyles";
SteelTreeGridViewStyles.__isInterface__ = false;
SteelTreeGridViewStyles.prototype = {
	
};
SteelTreeGridViewStyles.prototype.__class__ = SteelTreeGridViewStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelTreeGridViewStyles"] = SteelTreeGridViewStyles;

// Init



// Statics

SteelTreeGridViewStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleGridViewWithBorderVariant = function(gridView) {
		var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
		gridView.set_autoHideScrollBars(!isDesktop);
		gridView.set_fixedScrollBars(isDesktop);
		if(gridView.get_layout() == null) {
			var layout = new (feathers_layout_VerticalListLayout().default)();
			layout.set_requestedRowCount(5.0);
			gridView.set_layout(layout);
		}
		if(gridView.get_backgroundSkin() == null) {
			var backgroundSkin = new (feathers_skins_RectangleSkin().default)();
			backgroundSkin.set_fill(theme.getContainerFill());
			backgroundSkin.set_border(theme.getContainerBorder());
			backgroundSkin.set_width(10.0);
			backgroundSkin.set_height(10.0);
			gridView.set_backgroundSkin(backgroundSkin);
		}
		if(gridView.get_columnResizeSkin() == null) {
			var columnResizeSkin = new (feathers_skins_RectangleSkin().default)();
			columnResizeSkin.set_fill(theme.getThemeFill());
			columnResizeSkin.set_border(null);
			columnResizeSkin.set_width(2.0);
			columnResizeSkin.set_height(2.0);
			gridView.set_columnResizeSkin(columnResizeSkin);
		}
		if(gridView.get_focusRectSkin() == null) {
			var focusRectSkin = new (feathers_skins_RectangleSkin().default)();
			focusRectSkin.set_fill(null);
			focusRectSkin.set_border(theme.getFocusBorder());
			gridView.set_focusRectSkin(focusRectSkin);
		}
		gridView.set_showHeaderDividersOnlyWhenResizable(true);
		gridView.set_paddingTop(1.0);
		gridView.set_paddingRight(1.0);
		gridView.set_paddingBottom(1.0);
		gridView.set_paddingLeft(1.0);
	};
	var styleGridViewWithBorderlessVariant = function(gridView1) {
		var isDesktop1 = (feathers_utils_DeviceUtil().default).isDesktop();
		gridView1.set_autoHideScrollBars(!isDesktop1);
		gridView1.set_fixedScrollBars(isDesktop1);
		if(gridView1.get_layout() == null) {
			var layout1 = new (feathers_layout_VerticalListLayout().default)();
			layout1.set_requestedRowCount(5.0);
			gridView1.set_layout(layout1);
		}
		if(gridView1.get_backgroundSkin() == null) {
			var backgroundSkin1 = new (feathers_skins_RectangleSkin().default)();
			backgroundSkin1.set_fill(theme.getContainerFill());
			backgroundSkin1.set_width(10.0);
			backgroundSkin1.set_height(10.0);
			gridView1.set_backgroundSkin(backgroundSkin1);
		}
		if(gridView1.get_columnResizeSkin() == null) {
			var columnResizeSkin1 = new (feathers_skins_RectangleSkin().default)();
			columnResizeSkin1.set_fill(theme.getThemeFill());
			columnResizeSkin1.set_border(null);
			columnResizeSkin1.set_width(2.0);
			columnResizeSkin1.set_height(2.0);
			gridView1.set_columnResizeSkin(columnResizeSkin1);
		}
		if(gridView1.get_focusRectSkin() == null) {
			var skin = new (feathers_skins_RectangleSkin().default)();
			skin.set_fill(null);
			skin.set_border(theme.getFocusBorder());
			gridView1.set_focusRectSkin(skin);
		}
		gridView1.set_showHeaderDividersOnlyWhenResizable(true);
	};
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_TreeGridView().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_TreeGridView().default),null,function(gridView2) {
			var isDesktop2 = (feathers_utils_DeviceUtil().default).isDesktop();
			if(isDesktop2) {
				styleGridViewWithBorderVariant(gridView2);
			} else {
				styleGridViewWithBorderlessVariant(gridView2);
			}
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_TreeGridView().default),(feathers_controls_TreeGridView().default).VARIANT_BORDER) == null) {
		styleProvider.setStyleFunction((feathers_controls_TreeGridView().default),(feathers_controls_TreeGridView().default).VARIANT_BORDER,styleGridViewWithBorderVariant);
	}
	if(styleProvider.getStyleFunction((feathers_controls_TreeGridView().default),(feathers_controls_TreeGridView().default).VARIANT_BORDERLESS) == null) {
		styleProvider.setStyleFunction((feathers_controls_TreeGridView().default),(feathers_controls_TreeGridView().default).VARIANT_BORDERLESS,styleGridViewWithBorderlessVariant);
	}
	if(styleProvider.getStyleFunction((feathers_controls_dataRenderers_ItemRenderer().default),(feathers_controls_TreeGridView().default).CHILD_VARIANT_HEADER_RENDERER) == null) {
		styleProvider.setStyleFunction((feathers_controls_dataRenderers_ItemRenderer().default),(feathers_controls_TreeGridView().default).CHILD_VARIANT_HEADER_RENDERER,function(itemRenderer) {
			var isDesktop3 = (feathers_utils_DeviceUtil().default).isDesktop();
			if(itemRenderer.get_backgroundSkin() == null) {
				var skin1 = new (feathers_skins_RectangleSkin().default)();
				skin1.set_fill(theme.getSubHeadingFill());
				if(isDesktop3) {
					skin1.set_width(22.0);
					skin1.set_height(22.0);
					skin1.set_minWidth(22.0);
					skin1.set_minHeight(22.0);
				} else {
					skin1.set_width(44.0);
					skin1.set_height(44.0);
					skin1.set_minWidth(44.0);
					skin1.set_minHeight(44.0);
				}
				itemRenderer.set_backgroundSkin(skin1);
			}
			if(itemRenderer.get_textFormat() == null) {
				itemRenderer.set_textFormat(theme.getTextFormat());
			}
			if(itemRenderer.get_disabledTextFormat() == null) {
				itemRenderer.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			if(itemRenderer.get_secondaryTextFormat() == null) {
				itemRenderer.set_secondaryTextFormat(theme.getDetailTextFormat());
			}
			if(itemRenderer.get_disabledSecondaryTextFormat() == null) {
				itemRenderer.set_disabledSecondaryTextFormat(theme.getDisabledDetailTextFormat());
			}
			itemRenderer.set_paddingTop(4.0);
			itemRenderer.set_paddingRight(10.0);
			itemRenderer.set_paddingBottom(4.0);
			itemRenderer.set_paddingLeft(10.0);
			itemRenderer.set_gap(4.0);
			itemRenderer.set_horizontalAlign((feathers_layout_HorizontalAlign().default).LEFT);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_Button().default),(feathers_controls_TreeGridView().default).CHILD_VARIANT_HEADER_DIVIDER) == null) {
		styleProvider.setStyleFunction((feathers_controls_Button().default),(feathers_controls_TreeGridView().default).CHILD_VARIANT_HEADER_DIVIDER,function(headerDivider) {
			var isDesktop4 = (feathers_utils_DeviceUtil().default).isDesktop();
			if(headerDivider.get_backgroundSkin() == null) {
				var skin2 = new (feathers_skins_VerticalLineSkin().default)();
				skin2.set_border(theme.getSubHeadingDividerBorder());
				skin2.set_fill((feathers_graphics_FillStyle().default).SolidColor(16711935,0.0));
				skin2.setBorderForState((feathers_controls_ButtonState().default).HOVER,theme.getThemeBorder());
				if(isDesktop4) {
					skin2.set_width(6.0);
					skin2.set_height(1.0);
					skin2.set_minWidth(6.0);
					skin2.set_minHeight(1.0);
				} else {
					skin2.set_width(10.0);
					skin2.set_height(1.0);
					skin2.set_minWidth(10.0);
					skin2.set_minHeight(1.0);
				}
				headerDivider.set_backgroundSkin(skin2);
			}
		});
	}
}


// Export

exports["default"] = SteelTreeGridViewStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelTreeViewItemRendererStyles.js":
/*!**************************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelTreeViewItemRendererStyles.js ***!
  \**************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelTreeViewItemRendererStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_dataRenderers_TreeViewItemRenderer() {return __webpack_require__(/*! ./../../../../feathers/controls/dataRenderers/TreeViewItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/TreeViewItemRenderer.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_skins_UnderlineSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/UnderlineSkin */ "./lib/_gen/feathers/skins/UnderlineSkin.js");}
function feathers_controls_ToggleButtonState() {return __webpack_require__(/*! ./../../../../feathers/controls/ToggleButtonState */ "./lib/_gen/feathers/controls/ToggleButtonState.js");}
function feathers_layout_HorizontalAlign() {return __webpack_require__(/*! ./../../../../feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");}
function feathers_controls_ToggleButton() {return __webpack_require__(/*! ./../../../../feathers/controls/ToggleButton */ "./lib/_gen/feathers/controls/ToggleButton.js");}
function feathers_skins_MultiSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/MultiSkin */ "./lib/_gen/feathers/skins/MultiSkin.js");}
function openfl_display_Shape() {return (__webpack_require__(/*! openfl */ "openfl").display.Shape);}

// Constructor

var SteelTreeViewItemRendererStyles = function(){}

// Meta

SteelTreeViewItemRendererStyles.__name__ = "feathers.themes.steel.components.SteelTreeViewItemRendererStyles";
SteelTreeViewItemRendererStyles.__isInterface__ = false;
SteelTreeViewItemRendererStyles.prototype = {
	
};
SteelTreeViewItemRendererStyles.prototype.__class__ = SteelTreeViewItemRendererStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelTreeViewItemRendererStyles"] = SteelTreeViewItemRendererStyles;

// Init



// Statics

SteelTreeViewItemRendererStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_dataRenderers_TreeViewItemRenderer().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_dataRenderers_TreeViewItemRenderer().default),null,function(itemRenderer) {
			var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
			if(itemRenderer.get_backgroundSkin() == null) {
				var skin = new (feathers_skins_UnderlineSkin().default)();
				skin.set_fill(theme.getContainerFill());
				skin.set_border(theme.getDividerBorder());
				skin.set_selectedFill(theme.getActiveThemeFill());
				skin.setFillForState((feathers_controls_ToggleButtonState().default).DOWN(false),theme.getActiveThemeFill());
				if(isDesktop) {
					skin.set_width(32.0);
					skin.set_height(32.0);
					skin.set_minWidth(32.0);
					skin.set_minHeight(32.0);
				} else {
					skin.set_width(44.0);
					skin.set_height(44.0);
					skin.set_minWidth(44.0);
					skin.set_minHeight(44.0);
				}
				itemRenderer.set_backgroundSkin(skin);
			}
			if(itemRenderer.get_textFormat() == null) {
				itemRenderer.set_textFormat(theme.getTextFormat());
			}
			if(itemRenderer.get_disabledTextFormat() == null) {
				itemRenderer.set_disabledTextFormat(theme.getDisabledTextFormat());
			}
			if(itemRenderer.get_secondaryTextFormat() == null) {
				itemRenderer.set_secondaryTextFormat(theme.getDetailTextFormat());
			}
			if(itemRenderer.get_disabledSecondaryTextFormat() == null) {
				itemRenderer.set_disabledSecondaryTextFormat(theme.getDisabledDetailTextFormat());
			}
			itemRenderer.set_paddingTop(4.0);
			itemRenderer.set_paddingRight(10.0);
			itemRenderer.set_paddingBottom(4.0);
			itemRenderer.set_paddingLeft(10.0);
			itemRenderer.set_gap(4.0);
			itemRenderer.set_indentation(20.0);
			itemRenderer.set_horizontalAlign((feathers_layout_HorizontalAlign().default).LEFT);
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_ToggleButton().default),(feathers_controls_dataRenderers_TreeViewItemRenderer().default).CHILD_VARIANT_DISCLOSURE_BUTTON) == null) {
		styleProvider.setStyleFunction((feathers_controls_ToggleButton().default),(feathers_controls_dataRenderers_TreeViewItemRenderer().default).CHILD_VARIANT_DISCLOSURE_BUTTON,function(button) {
			if(button.get_icon() == null) {
				var icon = new (feathers_skins_MultiSkin().default)();
				button.set_icon(icon);
				var defaultIcon = new (openfl_display_Shape())();
				defaultIcon.get_graphics().beginFill(16711935,0.0);
				defaultIcon.get_graphics().drawRect(0.0,0.0,20.0,20.0);
				defaultIcon.get_graphics().endFill();
				defaultIcon.get_graphics().beginFill(theme.textColor);
				defaultIcon.get_graphics().moveTo(4.0,4.0);
				defaultIcon.get_graphics().lineTo(16.0,10.0);
				defaultIcon.get_graphics().lineTo(4.0,16.0);
				defaultIcon.get_graphics().lineTo(4.0,4.0);
				defaultIcon.get_graphics().endFill();
				icon.set_defaultView(defaultIcon);
				var disabledIcon = new (openfl_display_Shape())();
				disabledIcon.get_graphics().beginFill(16711935,0.0);
				disabledIcon.get_graphics().drawRect(0.0,0.0,20.0,20.0);
				disabledIcon.get_graphics().endFill();
				disabledIcon.get_graphics().beginFill(theme.disabledTextColor);
				disabledIcon.get_graphics().moveTo(4.0,4.0);
				disabledIcon.get_graphics().lineTo(16.0,10.0);
				disabledIcon.get_graphics().lineTo(4.0,16.0);
				disabledIcon.get_graphics().lineTo(4.0,4.0);
				disabledIcon.get_graphics().endFill();
				icon.set_disabledView(disabledIcon);
				var selectedIcon = new (openfl_display_Shape())();
				selectedIcon.get_graphics().beginFill(16711935,0.0);
				selectedIcon.get_graphics().drawRect(0.0,0.0,20.0,20.0);
				selectedIcon.get_graphics().endFill();
				selectedIcon.get_graphics().beginFill(theme.textColor);
				selectedIcon.get_graphics().moveTo(4.0,4.0);
				selectedIcon.get_graphics().lineTo(16.0,4.0);
				selectedIcon.get_graphics().lineTo(10.0,16.0);
				selectedIcon.get_graphics().lineTo(4.0,4.0);
				selectedIcon.get_graphics().endFill();
				icon.set_selectedView(selectedIcon);
				var selectedDisabledIcon = new (openfl_display_Shape())();
				selectedDisabledIcon.get_graphics().beginFill(16711935,0.0);
				selectedDisabledIcon.get_graphics().drawRect(0.0,0.0,20.0,20.0);
				selectedDisabledIcon.get_graphics().endFill();
				selectedDisabledIcon.get_graphics().beginFill(theme.disabledTextColor);
				selectedDisabledIcon.get_graphics().moveTo(4.0,4.0);
				selectedDisabledIcon.get_graphics().lineTo(16.0,4.0);
				selectedDisabledIcon.get_graphics().lineTo(10.0,16.0);
				selectedDisabledIcon.get_graphics().lineTo(4.0,4.0);
				selectedDisabledIcon.get_graphics().endFill();
				icon.setViewForState((feathers_controls_ToggleButtonState().default).DISABLED(true),selectedDisabledIcon);
			}
		});
	}
}


// Export

exports["default"] = SteelTreeViewItemRendererStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelTreeViewStyles.js":
/*!**************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelTreeViewStyles.js ***!
  \**************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelTreeViewStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_layout_VerticalListLayout() {return __webpack_require__(/*! ./../../../../feathers/layout/VerticalListLayout */ "./lib/_gen/feathers/layout/VerticalListLayout.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_controls_TreeView() {return __webpack_require__(/*! ./../../../../feathers/controls/TreeView */ "./lib/_gen/feathers/controls/TreeView.js");}

// Constructor

var SteelTreeViewStyles = function(){}

// Meta

SteelTreeViewStyles.__name__ = "feathers.themes.steel.components.SteelTreeViewStyles";
SteelTreeViewStyles.__isInterface__ = false;
SteelTreeViewStyles.prototype = {
	
};
SteelTreeViewStyles.prototype.__class__ = SteelTreeViewStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelTreeViewStyles"] = SteelTreeViewStyles;

// Init



// Statics

SteelTreeViewStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleTreeViewWithBorderVariant = function(treeView) {
		var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
		treeView.set_autoHideScrollBars(!isDesktop);
		treeView.set_fixedScrollBars(isDesktop);
		if(treeView.get_layout() == null) {
			var layout = new (feathers_layout_VerticalListLayout().default)();
			layout.set_requestedRowCount(5.0);
			treeView.set_layout(layout);
		}
		if(treeView.get_backgroundSkin() == null) {
			var backgroundSkin = new (feathers_skins_RectangleSkin().default)();
			backgroundSkin.set_fill(theme.getContainerFill());
			backgroundSkin.set_border(theme.getContainerBorder());
			backgroundSkin.set_width(10.0);
			backgroundSkin.set_height(10.0);
			treeView.set_backgroundSkin(backgroundSkin);
		}
		if(treeView.get_focusRectSkin() == null) {
			var focusRectSkin = new (feathers_skins_RectangleSkin().default)();
			focusRectSkin.set_fill(null);
			focusRectSkin.set_border(theme.getFocusBorder());
			treeView.set_focusRectSkin(focusRectSkin);
		}
		treeView.set_paddingTop(1.0);
		treeView.set_paddingRight(1.0);
		treeView.set_paddingBottom(1.0);
		treeView.set_paddingLeft(1.0);
	};
	var styleTreeViewWithBorderlessVariant = function(treeView1) {
		var isDesktop1 = (feathers_utils_DeviceUtil().default).isDesktop();
		treeView1.set_autoHideScrollBars(!isDesktop1);
		treeView1.set_fixedScrollBars(isDesktop1);
		if(treeView1.get_layout() == null) {
			treeView1.set_layout(new (feathers_layout_VerticalListLayout().default)());
		}
		if(treeView1.get_backgroundSkin() == null) {
			var backgroundSkin1 = new (feathers_skins_RectangleSkin().default)();
			backgroundSkin1.set_fill(theme.getContainerFill());
			backgroundSkin1.set_width(10.0);
			backgroundSkin1.set_height(10.0);
			treeView1.set_backgroundSkin(backgroundSkin1);
		}
		if(treeView1.get_focusRectSkin() == null) {
			var skin = new (feathers_skins_RectangleSkin().default)();
			skin.set_fill(null);
			skin.set_border(theme.getFocusBorder());
			treeView1.set_focusRectSkin(skin);
		}
	};
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_TreeView().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_TreeView().default),null,function(treeView2) {
			var isDesktop2 = (feathers_utils_DeviceUtil().default).isDesktop();
			if(isDesktop2) {
				styleTreeViewWithBorderVariant(treeView2);
			} else {
				styleTreeViewWithBorderlessVariant(treeView2);
			}
		});
	}
	if(styleProvider.getStyleFunction((feathers_controls_TreeView().default),(feathers_controls_TreeView().default).VARIANT_BORDER) == null) {
		styleProvider.setStyleFunction((feathers_controls_TreeView().default),(feathers_controls_TreeView().default).VARIANT_BORDER,styleTreeViewWithBorderVariant);
	}
	if(styleProvider.getStyleFunction((feathers_controls_TreeView().default),(feathers_controls_TreeView().default).VARIANT_BORDERLESS) == null) {
		styleProvider.setStyleFunction((feathers_controls_TreeView().default),(feathers_controls_TreeView().default).VARIANT_BORDERLESS,styleTreeViewWithBorderlessVariant);
	}
}


// Export

exports["default"] = SteelTreeViewStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelVDividedBoxStyles.js":
/*!*****************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelVDividedBoxStyles.js ***!
  \*****************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelVDividedBoxStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_VDividedBox() {return __webpack_require__(/*! ./../../../../feathers/controls/VDividedBox */ "./lib/_gen/feathers/controls/VDividedBox.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}

// Constructor

var SteelVDividedBoxStyles = function(){}

// Meta

SteelVDividedBoxStyles.__name__ = "feathers.themes.steel.components.SteelVDividedBoxStyles";
SteelVDividedBoxStyles.__isInterface__ = false;
SteelVDividedBoxStyles.prototype = {
	
};
SteelVDividedBoxStyles.prototype.__class__ = SteelVDividedBoxStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelVDividedBoxStyles"] = SteelVDividedBoxStyles;

// Init



// Statics

SteelVDividedBoxStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_VDividedBox().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_VDividedBox().default),null,function(dividedBox) {
			if(dividedBox.get_resizeDraggingSkin() == null) {
				var resizeDraggingSkin = new (feathers_skins_RectangleSkin().default)();
				resizeDraggingSkin.set_fill(theme.getThemeFill());
				resizeDraggingSkin.set_border(null);
				resizeDraggingSkin.set_width(2.0);
				resizeDraggingSkin.set_height(2.0);
				dividedBox.set_resizeDraggingSkin(resizeDraggingSkin);
			}
		});
	}
}


// Export

exports["default"] = SteelVDividedBoxStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelVProgressBarStyles.js":
/*!******************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelVProgressBarStyles.js ***!
  \******************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelVProgressBarStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_VProgressBar() {return __webpack_require__(/*! ./../../../../feathers/controls/VProgressBar */ "./lib/_gen/feathers/controls/VProgressBar.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}

// Constructor

var SteelVProgressBarStyles = function(){}

// Meta

SteelVProgressBarStyles.__name__ = "feathers.themes.steel.components.SteelVProgressBarStyles";
SteelVProgressBarStyles.__isInterface__ = false;
SteelVProgressBarStyles.prototype = {
	
};
SteelVProgressBarStyles.prototype.__class__ = SteelVProgressBarStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelVProgressBarStyles"] = SteelVProgressBarStyles;

// Init



// Statics

SteelVProgressBarStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_VProgressBar().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_VProgressBar().default),null,function(progress) {
			if(progress.get_fillSkin() == null) {
				var fillSkin = new (feathers_skins_RectangleSkin().default)();
				fillSkin.set_fill(theme.getActiveThemeFill());
				fillSkin.set_disabledFill(theme.getControlDisabledFill());
				fillSkin.set_border(theme.getActiveFillBorder());
				fillSkin.set_disabledBorder(theme.getDisabledInsetBorder());
				fillSkin.set_cornerRadius(8.0);
				fillSkin.set_width(8.0);
				fillSkin.set_minHeight(8.0);
				progress.set_fillSkin(fillSkin);
			}
			if(progress.get_backgroundSkin() == null) {
				var backgroundSkin = new (feathers_skins_RectangleSkin().default)();
				backgroundSkin.set_fill(theme.getInsetFill());
				backgroundSkin.set_disabledFill(theme.getDisabledInsetFill());
				backgroundSkin.set_border(theme.getInsetBorder());
				backgroundSkin.set_disabledBorder(theme.getDisabledInsetBorder());
				backgroundSkin.set_cornerRadius(8.0);
				backgroundSkin.set_width(8.0);
				backgroundSkin.set_height(200.0);
				progress.set_backgroundSkin(backgroundSkin);
			}
		});
	}
}


// Export

exports["default"] = SteelVProgressBarStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelVScrollBarStyles.js":
/*!****************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelVScrollBarStyles.js ***!
  \****************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelVScrollBarStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_VScrollBar() {return __webpack_require__(/*! ./../../../../feathers/controls/VScrollBar */ "./lib/_gen/feathers/controls/VScrollBar.js");}
function feathers_utils_DeviceUtil() {return __webpack_require__(/*! ./../../../../feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");}
function feathers_skins_RectangleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");}
function feathers_controls_BasicButton() {return __webpack_require__(/*! ./../../../../feathers/controls/BasicButton */ "./lib/_gen/feathers/controls/BasicButton.js");}

// Constructor

var SteelVScrollBarStyles = function(){}

// Meta

SteelVScrollBarStyles.__name__ = "feathers.themes.steel.components.SteelVScrollBarStyles";
SteelVScrollBarStyles.__isInterface__ = false;
SteelVScrollBarStyles.prototype = {
	
};
SteelVScrollBarStyles.prototype.__class__ = SteelVScrollBarStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelVScrollBarStyles"] = SteelVScrollBarStyles;

// Init



// Statics

SteelVScrollBarStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_VScrollBar().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_VScrollBar().default),null,function(scrollBar) {
			var isDesktop = (feathers_utils_DeviceUtil().default).isDesktop();
			if(scrollBar.get_thumbSkin() == null) {
				var thumbSkin = new (feathers_skins_RectangleSkin().default)();
				thumbSkin.set_fill(theme.getScrollBarThumbFill());
				thumbSkin.set_disabledFill(theme.getScrollBarThumbDisabledFill());
				var size = isDesktop ? 6.0 : 4.0;
				thumbSkin.set_width(size);
				thumbSkin.set_height(size);
				thumbSkin.set_minWidth(size);
				thumbSkin.set_minHeight(size);
				thumbSkin.set_cornerRadius(size / 2.0);
				var thumb = new (feathers_controls_BasicButton().default)();
				thumb.set_keepDownStateOnRollOut(true);
				thumb.set_backgroundSkin(thumbSkin);
				scrollBar.set_thumbSkin(thumb);
			}
			if(isDesktop && scrollBar.get_trackSkin() == null) {
				var trackSkin = new (feathers_skins_RectangleSkin().default)();
				trackSkin.set_fill(theme.getControlFill());
				trackSkin.set_disabledFill(theme.getControlDisabledFill());
				trackSkin.set_width(12.0);
				trackSkin.set_height(12.0);
				trackSkin.set_minWidth(12.0);
				trackSkin.set_minHeight(12.0);
				scrollBar.set_trackSkin(trackSkin);
			}
			scrollBar.set_paddingTop(2.0);
			scrollBar.set_paddingRight(2.0);
			scrollBar.set_paddingBottom(2.0);
			scrollBar.set_paddingLeft(2.0);
		});
	}
}


// Export

exports["default"] = SteelVScrollBarStyles;

/***/ }),

/***/ "./lib/_gen/feathers/themes/steel/components/SteelVSliderStyles.js":
/*!*************************************************************************!*\
  !*** ./lib/_gen/feathers/themes/steel/components/SteelVSliderStyles.js ***!
  \*************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.themes.steel.components.SteelVSliderStyles

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Std() {return __webpack_require__(/*! ./../../../../Std */ "./lib/_gen/Std.js");}
function feathers_style_Theme() {return __webpack_require__(/*! ./../../../../feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");}
function feathers_themes_steel_BaseSteelTheme() {return __webpack_require__(/*! ./../../../../feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");}
function feathers_controls_VSlider() {return __webpack_require__(/*! ./../../../../feathers/controls/VSlider */ "./lib/_gen/feathers/controls/VSlider.js");}
function feathers_controls_Button() {return __webpack_require__(/*! ./../../../../feathers/controls/Button */ "./lib/_gen/feathers/controls/Button.js");}
function feathers_skins_CircleSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/CircleSkin */ "./lib/_gen/feathers/skins/CircleSkin.js");}
function feathers_controls_ButtonState() {return __webpack_require__(/*! ./../../../../feathers/controls/ButtonState */ "./lib/_gen/feathers/controls/ButtonState.js");}
function feathers_skins_TabSkin() {return __webpack_require__(/*! ./../../../../feathers/skins/TabSkin */ "./lib/_gen/feathers/skins/TabSkin.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}

// Constructor

var SteelVSliderStyles = function(){}

// Meta

SteelVSliderStyles.__name__ = "feathers.themes.steel.components.SteelVSliderStyles";
SteelVSliderStyles.__isInterface__ = false;
SteelVSliderStyles.prototype = {
	
};
SteelVSliderStyles.prototype.__class__ = SteelVSliderStyles.prototype.constructor = $hxClasses["feathers.themes.steel.components.SteelVSliderStyles"] = SteelVSliderStyles;

// Init



// Statics

SteelVSliderStyles.initialize = function(theme) {
	if(theme == null) {
		theme = (Std().default).downcast((feathers_style_Theme().default).get_fallbackTheme(),(feathers_themes_steel_BaseSteelTheme().default));
	}
	if(theme == null) {
		return;
	}
	var styleProvider = theme.styleProvider;
	if(styleProvider.getStyleFunction((feathers_controls_VSlider().default),null) == null) {
		styleProvider.setStyleFunction((feathers_controls_VSlider().default),null,function(slider) {
			if(slider.get_thumbSkin() == null) {
				var thumb = new (feathers_controls_Button().default)();
				thumb.set_styleProvider(null);
				thumb.set_keepDownStateOnRollOut(true);
				var backgroundSkin = new (feathers_skins_CircleSkin().default)();
				backgroundSkin.set_fill(theme.getButtonFill());
				backgroundSkin.set_border(theme.getButtonBorder());
				backgroundSkin.setFillForState((feathers_controls_ButtonState().default).DOWN,theme.getButtonDownFill());
				backgroundSkin.setFillForState((feathers_controls_ButtonState().default).DISABLED,theme.getButtonDisabledFill());
				backgroundSkin.set_width(24.0);
				backgroundSkin.set_height(24.0);
				thumb.set_backgroundSkin(backgroundSkin);
				var focusRectSkin = new (feathers_skins_CircleSkin().default)();
				focusRectSkin.set_fill(null);
				focusRectSkin.set_border(theme.getFocusBorder());
				thumb.set_focusRectSkin(focusRectSkin);
				slider.set_thumbSkin(thumb);
			}
			if(slider.get_trackSkin() == null) {
				var trackSkin = new (feathers_skins_TabSkin().default)();
				trackSkin.set_fill(theme.getActiveThemeFill());
				trackSkin.set_border(theme.getActiveFillBorder());
				trackSkin.set_cornerRadius(8.0);
				trackSkin.set_cornerRadiusPosition((feathers_layout_RelativePosition().default).BOTTOM);
				trackSkin.set_width(8.0);
				trackSkin.set_height(100.0);
				slider.set_trackSkin(trackSkin);
				if(slider.get_secondaryTrackSkin() == null) {
					var secondaryTrackSkin = new (feathers_skins_TabSkin().default)();
					secondaryTrackSkin.set_fill(theme.getInsetFill());
					secondaryTrackSkin.set_border(theme.getInsetBorder());
					secondaryTrackSkin.set_cornerRadius(8.0);
					secondaryTrackSkin.set_cornerRadiusPosition((feathers_layout_RelativePosition().default).TOP);
					secondaryTrackSkin.set_width(8.0);
					secondaryTrackSkin.set_height(100.0);
					slider.set_secondaryTrackSkin(secondaryTrackSkin);
				}
			}
		});
	}
}


// Export

exports["default"] = SteelVSliderStyles;

/***/ }),

/***/ "./lib/_gen/feathers/utils/BitmapDataCache.js":
/*!****************************************************!*\
  !*** ./lib/_gen/feathers/utils/BitmapDataCache.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.BitmapDataCache

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function haxe_ds_StringMap() {return __webpack_require__(/*! ./../../haxe/ds/StringMap */ "./lib/_gen/haxe/ds/StringMap.js");}

// Constructor

var BitmapDataCache = function(maxUnretained) {
	if(maxUnretained == null) {
		maxUnretained = 2147483647;
	}
	this._retainCounts = new (haxe_ds_StringMap().default)();
	this._retainedBitmapData = new (haxe_ds_StringMap().default)();
	this._unretainedBitmapData = new (haxe_ds_StringMap().default)();
	this._unretainedKeys = [];
	this._maxUnretained = maxUnretained;
}

// Meta

BitmapDataCache.__name__ = "feathers.utils.BitmapDataCache";
BitmapDataCache.__isInterface__ = false;
BitmapDataCache.prototype = {
	get_maxUnretained: function() {
		return this._maxUnretained;
	},
	set_maxUnretained: function(value) {
		if(this._maxUnretained == value) {
			return this._maxUnretained;
		}
		this._maxUnretained = value;
		if(this._unretainedKeys.length > value) {
			this.trimCache();
		}
		return this._maxUnretained;
	},
	dispose: function() {
		var bitmapData = this._unretainedBitmapData.iterator();
		while(bitmapData.hasNext()) {
			var bitmapData1 = bitmapData.next();
			bitmapData1.dispose();
		}
		var bitmapData2 = this._retainedBitmapData.iterator();
		while(bitmapData2.hasNext()) {
			var bitmapData3 = bitmapData2.next();
			bitmapData3.dispose();
		}
		this._retainedBitmapData = null;
		this._unretainedBitmapData = null;
		this._retainCounts = null;
	},
	addBitmapData: function(key,bitmapData,retain) {
		if(retain == null) {
			retain = true;
		}
		if(this._retainedBitmapData == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Cannot add BitmapData after the cache has been disposed."));
		}
		if(this._unretainedBitmapData.exists(key) || this._retainedBitmapData.exists(key)) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Key \"" + key + "\" already exists in the cache."));
		}
		if(retain) {
			this._retainedBitmapData.set(key,bitmapData);
			this._retainCounts.set(key,1);
			return;
		}
		this._unretainedBitmapData.set(key,bitmapData);
		this._unretainedKeys[this._unretainedKeys.length] = key;
		if(this._unretainedKeys.length > this._maxUnretained) {
			this.trimCache();
		}
	},
	removeBitmapData: function(key,dispose) {
		if(dispose == null) {
			dispose = false;
		}
		if(this._unretainedBitmapData == null) {
			return;
		}
		var bitmapData = this._unretainedBitmapData.get(key);
		if(bitmapData != null) {
			this.removeUnretainedKey(key);
		} else {
			bitmapData = this._retainedBitmapData.get(key);
			this._retainedBitmapData.remove(key);
			this._retainCounts.remove(key);
		}
		if(dispose && bitmapData != null) {
			bitmapData.dispose();
		}
	},
	hasTexture: function(key) {
		if(!(this._retainedBitmapData != null && this._retainedBitmapData.exists(key))) {
			if(this._unretainedBitmapData != null) {
				return this._unretainedBitmapData.exists(key);
			} else {
				return false;
			}
		} else {
			return true;
		}
	},
	getRetainCount: function(key) {
		if(this._retainCounts != null && this._retainCounts.exists(key)) {
			return this._retainCounts.get(key);
		}
		return 0;
	},
	retainBitmapData: function(key) {
		if(this._retainedBitmapData == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Cannot retain BitmapData after the cache has been disposed."));
		}
		if(this._retainedBitmapData.exists(key)) {
			var count = this._retainCounts.get(key);
			++count;
			this._retainCounts.set(key,count);
			return this._retainedBitmapData.get(key);
		}
		if(!this._unretainedBitmapData.exists(key)) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("BitmapData with key \"" + key + "\" cannot be retained because it has not been added to the cache."));
		}
		var bitmapData = this._unretainedBitmapData.get(key);
		this.removeUnretainedKey(key);
		this._retainedBitmapData.set(key,bitmapData);
		this._retainCounts.set(key,1);
		return bitmapData;
	},
	releaseBitmapData: function(key) {
		if(this._retainedBitmapData == null || !this._retainedBitmapData.exists(key)) {
			return;
		}
		var count = this._retainCounts.get(key);
		--count;
		if(count == 0) {
			var bitmapData = this._retainedBitmapData.get(key);
			this._retainCounts.remove(key);
			this._retainedBitmapData.remove(key);
			this._unretainedBitmapData.set(key,bitmapData);
			this._unretainedKeys[this._unretainedKeys.length] = key;
			if(this._unretainedKeys.length > this._maxUnretained) {
				this.trimCache();
			}
		} else {
			this._retainCounts.set(key,count);
		}
	},
	removeUnretainedKey: function(key) {
		var index = this._unretainedKeys.indexOf(key);
		if(index == -1) {
			return;
		}
		this._unretainedKeys.splice(index,1);
		this._unretainedBitmapData.remove(key);
	},
	trimCache: function() {
		var currentCount = this._unretainedKeys.length;
		var maxCount = this._maxUnretained;
		while(currentCount > maxCount) {
			var key = this._unretainedKeys.shift();
			var bitmapData = this._unretainedBitmapData.get(key);
			bitmapData.dispose();
			this._unretainedBitmapData.remove(key);
			--currentCount;
		}
	}
};
BitmapDataCache.prototype.__class__ = BitmapDataCache.prototype.constructor = $hxClasses["feathers.utils.BitmapDataCache"] = BitmapDataCache;

// Init



// Statics




// Export

exports["default"] = BitmapDataCache;

/***/ }),

/***/ "./lib/_gen/feathers/utils/DPadFocusUtil.js":
/*!**************************************************!*\
  !*** ./lib/_gen/feathers/utils/DPadFocusUtil.js ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.DPadFocusUtil

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}

// Constructor

var DPadFocusUtil = function(){}

// Meta

DPadFocusUtil.__name__ = "feathers.utils.DPadFocusUtil";
DPadFocusUtil.__isInterface__ = false;
DPadFocusUtil.prototype = {
	
};
DPadFocusUtil.prototype.__class__ = DPadFocusUtil.prototype.constructor = $hxClasses["feathers.utils.DPadFocusUtil"] = DPadFocusUtil;

// Init



// Statics

DPadFocusUtil.isBetterFocusForRelativePosition = function(object1,object2,focusedRect,relativePosition) {
	var rect = object1.getBounds(object1.stage);
	var minPrimaryDistance1 = DPadFocusUtil.calculateMinPrimaryAxisDistanceForRelativePosition(focusedRect,rect,relativePosition);
	if(minPrimaryDistance1 == Infinity) {
		return false;
	}
	var maxPrimaryDistance1 = DPadFocusUtil.calculateMaxPrimaryAxisDistanceForRelativePosition(focusedRect,rect,relativePosition);
	var secondaryDistance1 = DPadFocusUtil.calculateSecondaryAxisDistanceForRelativePosition(focusedRect,rect,relativePosition);
	var onSameAxis1 = DPadFocusUtil.itemsAreOnSameAxis(focusedRect,rect,relativePosition);
	var minPrimaryDistance2 = Infinity;
	var maxPrimaryDistance2 = Infinity;
	var secondaryDistance2 = Infinity;
	var onSameAxis2 = false;
	if(object2 != null) {
		rect = object2.getBounds(object2.stage);
		minPrimaryDistance2 = DPadFocusUtil.calculateMinPrimaryAxisDistanceForRelativePosition(focusedRect,rect,relativePosition);
		maxPrimaryDistance2 = DPadFocusUtil.calculateMaxPrimaryAxisDistanceForRelativePosition(focusedRect,rect,relativePosition);
		secondaryDistance2 = DPadFocusUtil.calculateSecondaryAxisDistanceForRelativePosition(focusedRect,rect,relativePosition);
		onSameAxis2 = DPadFocusUtil.itemsAreOnSameAxis(focusedRect,rect,relativePosition);
	}
	if(onSameAxis1 && onSameAxis2) {
		if(minPrimaryDistance1 > 0.0) {
			return minPrimaryDistance1 < minPrimaryDistance2;
		} else {
			return false;
		}
	}
	var isVertical = relativePosition == (feathers_layout_RelativePosition().default).TOP || relativePosition == (feathers_layout_RelativePosition().default).BOTTOM;
	if(onSameAxis1) {
		if(isVertical) {
			if(minPrimaryDistance1 > 0.0 && minPrimaryDistance1 < maxPrimaryDistance2) {
				return true;
			}
		} else {
			return true;
		}
	} else if(onSameAxis2) {
		if(isVertical) {
			if(minPrimaryDistance2 > 0.0 && minPrimaryDistance2 < maxPrimaryDistance1) {
				return false;
			}
		} else {
			return false;
		}
	}
	var weightedDistance1 = 13.0 * minPrimaryDistance1 * minPrimaryDistance1 + secondaryDistance1 * secondaryDistance1;
	var weightedDistance2 = 13.0 * minPrimaryDistance2 * minPrimaryDistance2 + secondaryDistance2 * secondaryDistance2;
	return weightedDistance1 < weightedDistance2;
}
DPadFocusUtil.calculateSecondaryAxisDistanceForRelativePosition = function(globalRect1,globalRect2,position) {
	if(position == (feathers_layout_RelativePosition().default).TOP || position == (feathers_layout_RelativePosition().default).BOTTOM) {
		return Math.abs(globalRect1.x + globalRect1.width / 2.0 - (globalRect2.x + globalRect2.width / 2.0));
	}
	return Math.abs(globalRect1.y + globalRect1.height / 2.0 - (globalRect2.y + globalRect2.height / 2.0));
}
DPadFocusUtil.calculateMaxPrimaryAxisDistanceForRelativePosition = function(globalRect1,globalRect2,position) {
	switch(position._hx_index) {
	case 0:
		if(globalRect1.get_bottom() > globalRect2.get_bottom() || globalRect1.y >= globalRect2.get_bottom()) {
			var result = globalRect1.get_bottom() - globalRect2.y;
			if(result > 0.0) {
				return result;
			}
		}
		break;
	case 1:
		if(globalRect1.x < globalRect2.x || globalRect1.get_right() <= globalRect2.x) {
			var result1 = globalRect2.get_right() - globalRect1.x;
			if(result1 > 0.0) {
				return result1;
			}
		}
		break;
	case 2:
		if(globalRect1.y < globalRect2.y || globalRect1.get_bottom() <= globalRect2.y) {
			var result2 = globalRect2.get_bottom() - globalRect1.y;
			if(result2 > 0.0) {
				return result2;
			}
		}
		break;
	case 3:
		if(globalRect1.get_right() > globalRect2.get_right() || globalRect1.x >= globalRect2.get_right()) {
			var result3 = globalRect1.get_right() - globalRect2.x;
			if(result3 > 0.0) {
				return result3;
			}
		}
		break;
	default:
	}
	return Infinity;
}
DPadFocusUtil.calculateMinPrimaryAxisDistanceForRelativePosition = function(globalRect1,globalRect2,position) {
	switch(position._hx_index) {
	case 0:
		if(globalRect1.get_bottom() > globalRect2.get_bottom() || globalRect1.y >= globalRect2.get_bottom()) {
			var result = globalRect1.get_bottom() - globalRect2.get_bottom();
			if(result > 0.0) {
				return result;
			}
		}
		break;
	case 1:
		if(globalRect1.x < globalRect2.x || globalRect1.get_right() <= globalRect2.x) {
			var result1 = globalRect2.x - globalRect1.x;
			if(result1 > 0.0) {
				return result1;
			}
		}
		break;
	case 2:
		if(globalRect1.y < globalRect2.y || globalRect1.get_bottom() <= globalRect2.y) {
			var result2 = globalRect2.y - globalRect1.y;
			if(result2 > 0.0) {
				return result2;
			}
		}
		break;
	case 3:
		if(globalRect1.get_right() > globalRect2.get_right() || globalRect1.x >= globalRect2.get_right()) {
			var result3 = globalRect1.get_right() - globalRect2.get_right();
			if(result3 > 0.0) {
				return result3;
			}
		}
		break;
	default:
	}
	return Infinity;
}
DPadFocusUtil.itemsAreOnSameAxis = function(globalRect1,globalRect2,position) {
	if(position == (feathers_layout_RelativePosition().default).TOP || position == (feathers_layout_RelativePosition().default).BOTTOM) {
		if(globalRect1.x <= globalRect2.get_right()) {
			return globalRect2.x <= globalRect1.get_right();
		} else {
			return false;
		}
	}
	if(globalRect1.y <= globalRect2.get_bottom()) {
		return globalRect2.y <= globalRect1.get_bottom();
	} else {
		return false;
	}
}


// Export

exports["default"] = DPadFocusUtil;

/***/ }),

/***/ "./lib/_gen/feathers/utils/DateUtil.js":
/*!*********************************************!*\
  !*** ./lib/_gen/feathers/utils/DateUtil.js ***!
  \*********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.DateUtil

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);

// Constructor

var DateUtil = function(){}

// Meta

DateUtil.__name__ = "feathers.utils.DateUtil";
DateUtil.__isInterface__ = false;
DateUtil.prototype = {
	
};
DateUtil.prototype.__class__ = DateUtil.prototype.constructor = $hxClasses["feathers.utils.DateUtil"] = DateUtil;

// Init



// Statics

DateUtil.getDaysInMonth = function(month,year) {
	if(month == 1 && year != null && DateUtil.isLeapYear(year)) {
		return DateUtil.FEBRUARY_NUMBER_OF_DAYS_LEAP_YEAR;
	}
	return DateUtil.MONTH_NUMBER_OF_DAYS[month];
}
DateUtil.isLeapYear = function(year) {
	if(year % 100 == 0) {
		return year % 400 == 0;
	}
	return year % 4 == 0;
}
DateUtil.MONTH_NUMBER_OF_DAYS = [31,28,31,30,31,30,31,31,30,31,30,31]
DateUtil.FEBRUARY_NUMBER_OF_DAYS_LEAP_YEAR = 29

// Export

exports["default"] = DateUtil;

/***/ }),

/***/ "./lib/_gen/feathers/utils/DeviceUtil.js":
/*!***********************************************!*\
  !*** ./lib/_gen/feathers/utils/DeviceUtil.js ***!
  \***********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.DeviceUtil

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}

// Constructor

var DeviceUtil = function(){}

// Meta

DeviceUtil.__name__ = "feathers.utils.DeviceUtil";
DeviceUtil.__isInterface__ = false;
DeviceUtil.prototype = {
	
};
DeviceUtil.prototype.__class__ = DeviceUtil.prototype.constructor = $hxClasses["feathers.utils.DeviceUtil"] = DeviceUtil;

// Init



// Statics

DeviceUtil.isDesktop = function() {
	var htmlWindow = (js_Boot().default).__cast($global , Window);
	return htmlWindow.matchMedia(DeviceUtil.MEDIA_QUERY_DESKTOP).matches;
}
DeviceUtil.isMobile = function() {
	var htmlWindow = (js_Boot().default).__cast($global , Window);
	return htmlWindow.matchMedia(DeviceUtil.MEDIA_QUERY_MOBILE).matches;
}
DeviceUtil.MEDIA_QUERY_DESKTOP = "screen and (hover: hover) and (pointer: fine)"
DeviceUtil.MEDIA_QUERY_MOBILE = "screen and (hover: none) and (pointer: coarse)"

// Export

exports["default"] = DeviceUtil;

/***/ }),

/***/ "./lib/_gen/feathers/utils/DisplayObjectFactory.js":
/*!*********************************************************!*\
  !*** ./lib/_gen/feathers/utils/DisplayObjectFactory.js ***!
  \*********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.DisplayObjectFactory

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Type() {return __webpack_require__(/*! ./../../Type */ "./lib/_gen/Type.js");}

// Constructor

var DisplayObjectFactory = function() {
}

// Meta

DisplayObjectFactory.__name__ = "feathers.utils.DisplayObjectFactory";
DisplayObjectFactory.__isInterface__ = false;
DisplayObjectFactory.prototype = {
	create: function() {
		return null;
	},
	destroy: function(target) {
	}
};
DisplayObjectFactory.prototype.__class__ = DisplayObjectFactory.prototype.constructor = $hxClasses["feathers.utils.DisplayObjectFactory"] = DisplayObjectFactory;

// Init



// Statics

DisplayObjectFactory.withDisplayObject = function(displayObject,destroy) {
	var item = new DisplayObjectFactory();
	item.create = function() {
		return displayObject;
	};
	item.destroy = destroy;
	return item;
}
DisplayObjectFactory.withClass = function(displayObjectType,destroy) {
	var item = new DisplayObjectFactory();
	item.create = function() {
		return (Type().default).createInstance(displayObjectType,[]);
	};
	item.destroy = destroy;
	return item;
}
DisplayObjectFactory.withFunction = function(create,destroy) {
	var item = new DisplayObjectFactory();
	item.create = create;
	item.destroy = destroy;
	return item;
}


// Export

exports["default"] = DisplayObjectFactory;

/***/ }),

/***/ "./lib/_gen/feathers/utils/DisplayObjectRecycler.js":
/*!**********************************************************!*\
  !*** ./lib/_gen/feathers/utils/DisplayObjectRecycler.js ***!
  \**********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.DisplayObjectRecycler

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function feathers_utils_DisplayObjectFactory() {return __webpack_require__(/*! ./../../feathers/utils/DisplayObjectFactory */ "./lib/_gen/feathers/utils/DisplayObjectFactory.js");}
function Type() {return __webpack_require__(/*! ./../../Type */ "./lib/_gen/Type.js");}

// Constructor

var DisplayObjectRecycler = function() {
	(feathers_utils_DisplayObjectFactory().default).call(this);
}

// Meta

DisplayObjectRecycler.__name__ = "feathers.utils.DisplayObjectRecycler";
DisplayObjectRecycler.__isInterface__ = false;
DisplayObjectRecycler.__super__ = (feathers_utils_DisplayObjectFactory().default);
DisplayObjectRecycler.prototype = $extend((feathers_utils_DisplayObjectFactory().default).prototype, {
	update: function(target,state) {
	},
	reset: function(target,state) {
	}
});
DisplayObjectRecycler.prototype.__class__ = DisplayObjectRecycler.prototype.constructor = $hxClasses["feathers.utils.DisplayObjectRecycler"] = DisplayObjectRecycler;

// Init



// Statics

DisplayObjectRecycler.withClass = function(displayObjectType,update,reset,destroy) {
	var item = new DisplayObjectRecycler();
	item.create = function() {
		return (Type().default).createInstance(displayObjectType,[]);
	};
	item.update = update;
	item.reset = reset;
	item.destroy = destroy;
	return item;
}
DisplayObjectRecycler.withFunction = function(create,update,reset,destroy) {
	var item = new DisplayObjectRecycler();
	item.create = create;
	item.update = update;
	item.reset = reset;
	item.destroy = destroy;
	return item;
}


// Export

exports["default"] = DisplayObjectRecycler;

/***/ }),

/***/ "./lib/_gen/feathers/utils/DisplayUtil.js":
/*!************************************************!*\
  !*** ./lib/_gen/feathers/utils/DisplayUtil.js ***!
  \************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.DisplayUtil

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}

// Constructor

var DisplayUtil = function(){}

// Meta

DisplayUtil.__name__ = "feathers.utils.DisplayUtil";
DisplayUtil.__isInterface__ = false;
DisplayUtil.prototype = {
	
};
DisplayUtil.prototype.__class__ = DisplayUtil.prototype.constructor = $hxClasses["feathers.utils.DisplayUtil"] = DisplayUtil;

// Init



// Statics

DisplayUtil.getDisplayObjectDepthFromStage = function(target) {
	if(target.stage == null) {
		return -1;
	}
	var count = 0;
	while(target.parent != null) {
		target = target.parent;
		++count;
	}
	return count;
}
DisplayUtil.getConcatenatedScaleX = function(target) {
	if(target == null) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("getConcatenatedScaleX target must not be null"));
	}
	var result = 1.0;
	var current = target;
	while(true) {
		result /= current.get_scaleX();
		current = current.parent;
		if(!(current != null && current != current.stage)) {
			break;
		}
	}
	return result;
}
DisplayUtil.getConcatenatedScaleY = function(target) {
	if(target == null) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("getConcatenatedScaleY target must not be null"));
	}
	var result = 1.0;
	var current = target;
	while(true) {
		result /= current.get_scaleY();
		current = current.parent;
		if(!(current != null && current != current.stage)) {
			break;
		}
	}
	return result;
}
DisplayUtil.getConcatenatedScale = function(target,result) {
	if(target == null) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("getConcatenatedScale target must not be null"));
	}
	var resultX = 1.0;
	var resultY = 1.0;
	var current = target;
	while(true) {
		resultX /= current.get_scaleX();
		resultY /= current.get_scaleY();
		current = current.parent;
		if(!(current != null && current != current.stage)) {
			break;
		}
	}
	if(result == null) {
		return new (openfl_geom_Point())(resultX,resultY);
	}
	result.setTo(resultX,resultY);
	return result;
}


// Export

exports["default"] = DisplayUtil;

/***/ }),

/***/ "./lib/_gen/feathers/utils/EdgePuller.js":
/*!***********************************************!*\
  !*** ./lib/_gen/feathers/utils/EdgePuller.js ***!
  \***********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.EdgePuller

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_FeathersEvent() {return __webpack_require__(/*! ./../../feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function feathers_utils_DisplayUtil() {return __webpack_require__(/*! ./../../feathers/utils/DisplayUtil */ "./lib/_gen/feathers/utils/DisplayUtil.js");}
function openfl_geom_Point() {return (__webpack_require__(/*! openfl */ "openfl").geom.Point);}
function motion_Actuate() {return (__webpack_require__(/*! motion */ "motion").Actuate);}
function openfl_display_DisplayObjectContainer() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObjectContainer);}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_layout_RelativePosition() {return __webpack_require__(/*! ./../../feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");}
function openfl_Lib() {return (__webpack_require__(/*! openfl */ "openfl").Lib);}
function motion_actuators_SimpleActuator() {return (__webpack_require__(/*! motion */ "motion").actuators.SimpleActuator);}
function openfl_display_Stage() {return (__webpack_require__(/*! openfl */ "openfl").display.Stage);}
function motion_easing_Quart() {return (__webpack_require__(/*! motion */ "motion").easing.Quart);}

// Constructor

var EdgePuller = function(target,pullableEdge,maxPullDistance) {
	if(pullableEdge == null) {
		pullableEdge = (feathers_layout_RelativePosition().default).LEFT;
	}
	this._animatePull = null;
	this._savedTouchMoves = [];
	this._targetPullDistance = 0.0;
	this._startPullDistance = 0.0;
	this._startTouch = 0.0;
	this._restoreMouseChildren = false;
	this._touchPointIsSimulated = false;
	this._touchPointID = null;
	this._snapDuration = 0.5;
	this._opened = false;
	this._pendingOpened = null;
	this._pullableEdge = (feathers_layout_RelativePosition().default).LEFT;
	this._activeBorderSize = null;
	this._pullDistance = 0.0;
	this._maxPullDistance = null;
	this.simulateTouch = false;
	this.ease = (motion_easing_Quart()).easeOut;
	this.minDragDistance = 6.0;
	this._dragging = false;
	this._active = false;
	this.enabled = true;
	(openfl_events_EventDispatcher()).call(this);
	this.set_target(target);
	this.set_pullableEdge(pullableEdge);
	this.set_maxPullDistance(maxPullDistance);
}

// Meta

EdgePuller.__name__ = "feathers.utils.EdgePuller";
EdgePuller.__isInterface__ = false;
EdgePuller.__super__ = (openfl_events_EventDispatcher());
EdgePuller.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_active: function() {
		return this._active;
	},
	get_dragging: function() {
		return this._dragging;
	},
	get_target: function() {
		return this._target;
	},
	set_target: function(value) {
		if(this._target == value) {
			return this._target;
		}
		if(this._target != null) {
			this.cleanupAfterDrag();
			this._target.removeEventListener("mouseDown",$bind(this,this.edgePuller_target_mouseDownHandler));
			this._target.removeEventListener("mouseDown",$bind(this,this.edgePuller_target_mouseDownCaptureHandler),true);
			this._target.removeEventListener("touchBegin",$bind(this,this.edgePuller_target_touchBeginHandler));
			this._target.removeEventListener("touchBegin",$bind(this,this.edgePuller_target_touchBeginCaptureHandler),true);
			this._target.removeEventListener("addedToStage",$bind(this,this.edgePuller_target_addedToStageHandler));
			this._target.removeEventListener("removedFromStage",$bind(this,this.edgePuller_target_removedFromStageHandler));
			this.removeStageEvents();
		}
		this._target = value;
		if(this._target != null) {
			this._target.addEventListener("mouseDown",$bind(this,this.edgePuller_target_mouseDownHandler),false,0,true);
			this._target.addEventListener("mouseDown",$bind(this,this.edgePuller_target_mouseDownCaptureHandler),true,0,true);
			this._target.addEventListener("touchBegin",$bind(this,this.edgePuller_target_touchBeginHandler),false,0,true);
			this._target.addEventListener("touchBegin",$bind(this,this.edgePuller_target_touchBeginCaptureHandler),true,0,true);
			this._target.addEventListener("addedToStage",$bind(this,this.edgePuller_target_addedToStageHandler),false,0,true);
			this._target.addEventListener("removedFromStage",$bind(this,this.edgePuller_target_removedFromStageHandler),false,0,true);
			this.addStageEvents();
		}
		return this._target;
	},
	get_maxPullDistance: function() {
		return this._maxPullDistance;
	},
	set_maxPullDistance: function(value) {
		if(this._maxPullDistance == value) {
			return this._maxPullDistance;
		}
		this._maxPullDistance = value;
		return this._maxPullDistance;
	},
	get_pullDistance: function() {
		return this._pullDistance;
	},
	get_activeBorderSize: function() {
		return this._activeBorderSize;
	},
	set_activeBorderSize: function(value) {
		if(this._activeBorderSize == value) {
			return this._activeBorderSize;
		}
		this._activeBorderSize = value;
		return this._activeBorderSize;
	},
	get_pullableEdge: function() {
		return this._pullableEdge;
	},
	set_pullableEdge: function(value) {
		if(this._pullableEdge == value) {
			return this._pullableEdge;
		}
		this._pullableEdge = value;
		return this._pullableEdge;
	},
	get_opened: function() {
		if(this._pendingOpened != null) {
			return this._pendingOpened;
		}
		return this._opened;
	},
	set_opened: function(value) {
		if(this._pendingOpened != null) {
			if(this._pendingOpened == value) {
				return this._pendingOpened;
			}
		} else if(this._opened == value) {
			return this._opened;
		}
		this._pendingOpened = value;
		if(this._pendingOpened) {
			this.throwTo(this.getMaxPullDistance());
		} else {
			this.throwTo(0.0);
		}
		return this._pendingOpened;
	},
	get_snapDuration: function() {
		return this._snapDuration;
	},
	set_snapDuration: function(value) {
		if(this._snapDuration == value) {
			return this._snapDuration;
		}
		this._snapDuration = value;
		return this._snapDuration;
	},
	get_touchPointID: function() {
		return this._touchPointID;
	},
	get_touchPointIsSimulated: function() {
		return this._touchPointIsSimulated;
	},
	setOpened: function(value) {
		this._pendingOpened = null;
		if(this._opened == value) {
			return this._opened;
		}
		this._opened = value;
		if(this._opened) {
			(feathers_events_FeathersEvent().default).dispatch(this,"open");
		} else {
			(feathers_events_FeathersEvent().default).dispatch(this,"close");
		}
		return this._opened;
	},
	setPullDistance: function(value) {
		if(this._pullDistance == value) {
			return this._pullDistance;
		}
		this._pullDistance = value;
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return this._pullDistance;
	},
	getMaxPullDistance: function() {
		if(this._maxPullDistance != null) {
			return this._maxPullDistance;
		}
		switch(this._pullableEdge._hx_index) {
		case 0:
			return this._target.get_height();
		case 1:
			return this._target.get_width();
		case 2:
			return this._target.get_height();
		case 3:
			return this._target.get_width();
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown pullable edge position: " + (Std().default).string(this._pullableEdge)));
		}
	},
	getTouchPosition: function(stageX,stageY) {
		switch(this._pullableEdge._hx_index) {
		case 0:
			return stageY;
		case 1:
			return stageX;
		case 2:
			return stageY;
		case 3:
			return stageX;
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown pullable edge position: " + (Std().default).string(this._pullableEdge)));
		}
	},
	getTouchScale: function() {
		switch(this._pullableEdge._hx_index) {
		case 0:
			return (feathers_utils_DisplayUtil().default).getConcatenatedScaleY(this._target);
		case 1:
			return (feathers_utils_DisplayUtil().default).getConcatenatedScaleX(this._target);
		case 2:
			return (feathers_utils_DisplayUtil().default).getConcatenatedScaleY(this._target);
		case 3:
			return (feathers_utils_DisplayUtil().default).getConcatenatedScaleX(this._target);
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown pullable edge position: " + (Std().default).string(this._pullableEdge)));
		}
	},
	isInActiveBorder: function(stageX,stageY,activeBorderSize) {
		var point = new (openfl_geom_Point())(stageX,stageY);
		point = this._target.globalToLocal(point);
		switch(this._pullableEdge._hx_index) {
		case 0:
			if(point.y >= 0.0) {
				return point.y < activeBorderSize;
			} else {
				return false;
			}
			break;
		case 1:
			if(point.x >= this._target.get_width() - activeBorderSize) {
				return point.x < this._target.get_width();
			} else {
				return false;
			}
			break;
		case 2:
			if(point.y >= this._target.get_height() - activeBorderSize) {
				return point.y < this._target.get_height();
			} else {
				return false;
			}
			break;
		case 3:
			if(point.x >= 0.0) {
				return point.x < activeBorderSize;
			} else {
				return false;
			}
			break;
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown pullable edge position: " + (Std().default).string(this._pullableEdge)));
		}
	},
	checkMinDrag: function(touchOffset) {
		if(this._opened) {
			switch(this._pullableEdge._hx_index) {
			case 0:
				return touchOffset < -this.minDragDistance;
			case 1:
				return touchOffset > this.minDragDistance;
			case 2:
				return touchOffset > this.minDragDistance;
			case 3:
				return touchOffset < -this.minDragDistance;
			default:
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown pullable edge position: " + (Std().default).string(this._pullableEdge)));
			}
		}
		switch(this._pullableEdge._hx_index) {
		case 0:
			return touchOffset > this.minDragDistance;
		case 1:
			return touchOffset < -this.minDragDistance;
		case 2:
			return touchOffset < -this.minDragDistance;
		case 3:
			return touchOffset > this.minDragDistance;
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown pullable edge position: " + (Std().default).string(this._pullableEdge)));
		}
	},
	touchBegin: function(touchPointID,simulatedTouch,stageX,stageY) {
		if(!this.enabled) {
			return;
		}
		if(simulatedTouch && !this.simulateTouch) {
			return;
		}
		if(this._touchPointID != null) {
			return;
		}
		if(!this._opened && this._activeBorderSize != null) {
			if(!this.isInActiveBorder(stageX,stageY,this._activeBorderSize)) {
				return;
			}
		}
		if(this._animatePull != null) {
			(motion_Actuate()).stop(this._animatePull,null,false,false);
			this._animatePull = null;
		}
		this._target.stage.addEventListener("mouseMove",$bind(this,this.edgePuller_target_stage_mouseMoveHandler),false,0,true);
		this._target.stage.addEventListener("mouseUp",$bind(this,this.edgePuller_target_stage_mouseUpHandler),false,0,true);
		this._target.stage.addEventListener("touchMove",$bind(this,this.edgePuller_target_stage_touchMoveHandler),false,0,true);
		this._target.stage.addEventListener("touchEnd",$bind(this,this.edgePuller_target_stage_touchEndHandler),false,0,true);
		if(((this._target) instanceof (openfl_display_DisplayObjectContainer()))) {
			var container = (js_Boot().default).__cast(this._target , (openfl_display_DisplayObjectContainer()));
			if(this._active) {
				container.mouseChildren = false;
			}
		}
		this._pendingOpened = null;
		this._touchPointID = touchPointID;
		this._touchPointIsSimulated = simulatedTouch;
		this._startTouch = this.getTouchPosition(stageX,stageY);
		this._startPullDistance = this._pullDistance;
		this._savedTouchMoves.length = 0;
	},
	touchMove: function(touchPointID,simulatedTouch,stageX,stageY) {
		if(this._touchPointID == null) {
			return;
		}
		if(this._touchPointID != touchPointID) {
			return;
		}
		if(this._touchPointIsSimulated != simulatedTouch) {
			return;
		}
		var touchPosition = this.getTouchPosition(stageX,stageY);
		var touchOffset = touchPosition - this._startTouch;
		var touchScale = this.getTouchScale();
		touchOffset *= touchScale;
		if(!this._dragging && this.enabled && this.checkMinDrag(touchOffset)) {
			this._startTouch = touchPosition;
			touchOffset = 0.0;
			this._dragging = this.startPull();
		}
		if(!this._dragging) {
			return;
		}
		var maxPullDistance = this.getMaxPullDistance();
		var pullDistance = this._startPullDistance;
		if(this._pullableEdge == (feathers_layout_RelativePosition().default).RIGHT || this._pullableEdge == (feathers_layout_RelativePosition().default).BOTTOM) {
			pullDistance -= touchOffset;
		} else {
			pullDistance += touchOffset;
		}
		if(pullDistance < 0.0) {
			pullDistance = 0.0;
		} else if(pullDistance > maxPullDistance) {
			pullDistance = maxPullDistance;
		}
		this.setPullDistance(pullDistance);
		if(this._savedTouchMoves.length > 60) {
			this._savedTouchMoves.length = 30;
		}
		this._savedTouchMoves.push(pullDistance);
		this._savedTouchMoves.push((openfl_Lib()).getTimer());
	},
	touchEnd: function(touchPointID,simulatedTouch) {
		if(this._touchPointID == null) {
			return;
		}
		if(this._touchPointID != touchPointID) {
			return;
		}
		if(this._touchPointIsSimulated != simulatedTouch) {
			return;
		}
		this.cleanupAfterDrag();
		if(!this._dragging) {
			return;
		}
		var targetTime = (openfl_Lib()).getTimer() - 100;
		var endIndex = this._savedTouchMoves.length - 1;
		var startIndex = endIndex;
		var i = endIndex;
		while(endIndex > 0 && this._savedTouchMoves[i] > targetTime) {
			startIndex = i;
			i -= 2;
		}
		var velocity = 0.0;
		if(this._dragging && startIndex != endIndex) {
			var timeOffset = this._savedTouchMoves[endIndex] - this._savedTouchMoves[startIndex];
			var moved = this._pullDistance - this._savedTouchMoves[startIndex - 1];
			velocity = moved / timeOffset;
		}
		if(velocity != 0.0 || this._dragging) {
			this.throwWithVelocity(velocity);
		} else {
			this.completeDrag();
		}
	},
	startPull: function() {
		if(this._active) {
			return true;
		}
		this._active = true;
		var result = true;
		if(this._opened) {
			result = (feathers_events_FeathersEvent().default).dispatch(this,"closing",false,true);
		} else {
			result = (feathers_events_FeathersEvent().default).dispatch(this,"opening",false,true);
		}
		if(!result) {
			this._active = false;
			this._dragging = false;
			this.cleanupAfterDrag();
			return false;
		}
		if(((this._target) instanceof (openfl_display_DisplayObjectContainer()))) {
			var container = (js_Boot().default).__cast(this._target , (openfl_display_DisplayObjectContainer()));
			this._restoreMouseChildren = container.mouseChildren;
			container.mouseChildren = false;
		}
		(feathers_events_FeathersEvent().default).dispatch(this,"change");
		return true;
	},
	completeDrag: function() {
		this._dragging = false;
		this.completePull();
	},
	completePull: function() {
		if(!this._active || this._dragging || this._animatePull != null) {
			return;
		}
		this._active = false;
		if(((this._target) instanceof (openfl_display_DisplayObjectContainer()))) {
			var container = (js_Boot().default).__cast(this._target , (openfl_display_DisplayObjectContainer()));
			container.mouseChildren = this._restoreMouseChildren;
		}
		var oldOpened = this._opened;
		var newOpened = this._pullDistance != 0.0;
		this.setOpened(newOpened);
		if(newOpened == oldOpened) {
			(feathers_events_FeathersEvent().default).dispatch(this,"cancel");
		}
	},
	addStageEvents: function() {
		if(this._target == null || this._target.stage == null) {
			return;
		}
		this._target.stage.addEventListener("touchBegin",$bind(this,this.edgePuller_target_stage_touchBeginHandler),false,0,true);
		this._target.stage.addEventListener("mouseDown",$bind(this,this.edgePuller_target_stage_mouseDownHandler),false,0,true);
	},
	removeStageEvents: function() {
		if(this._target == null || this._target.stage == null) {
			return;
		}
		this._target.stage.removeEventListener("touchBegin",$bind(this,this.edgePuller_target_stage_touchBeginHandler));
		this._target.stage.removeEventListener("mouseDown",$bind(this,this.edgePuller_target_stage_mouseDownHandler));
	},
	cleanupAfterDrag: function() {
		if(this._touchPointID == null) {
			return;
		}
		this._touchPointID = null;
		this._touchPointIsSimulated = false;
		if(this._target.stage != null) {
			this._target.stage.removeEventListener("mouseMove",$bind(this,this.edgePuller_target_stage_mouseMoveHandler));
			this._target.stage.removeEventListener("mouseUp",$bind(this,this.edgePuller_target_stage_mouseUpHandler));
			this._target.stage.removeEventListener("touchMove",$bind(this,this.edgePuller_target_stage_touchMoveHandler));
			this._target.stage.removeEventListener("touchEnd",$bind(this,this.edgePuller_target_stage_touchEndHandler));
		}
	},
	throwWithVelocity: function(velocity) {
		var maxPullDistance = this.getMaxPullDistance();
		var targetPosition = 0.0;
		if(Math.abs(velocity) <= EdgePuller.MINIMUM_VELOCITY) {
			targetPosition = this._pullDistance < maxPullDistance / 2.0 ? 0.0 : maxPullDistance;
		} else {
			targetPosition = velocity < 0.0 ? 0.0 : maxPullDistance;
		}
		this.throwTo(targetPosition);
	},
	throwTo: function(targetPosition) {
		var _gthis = this;
		var pullChanged = false;
		if(targetPosition != null) {
			if(this._animatePull != null) {
				(motion_Actuate()).stop(this._animatePull,null,false,false);
				this._animatePull = null;
			}
			if(this._pullDistance != targetPosition) {
				pullChanged = true;
				if(!this.startPull()) {
					return;
				}
				this._startPullDistance = this._pullDistance;
				this._targetPullDistance = targetPosition;
				if(this._snapDuration > 0.0) {
					var tween = (motion_Actuate()).update(function(pullDistance) {
						return _gthis.setPullDistance(pullDistance);
					},this._snapDuration,[this._startPullDistance],[this._targetPullDistance],true);
					this._animatePull = (js_Boot().default).__cast(tween , (motion_actuators_SimpleActuator()));
					this._animatePull.ease(this.ease);
					this._animatePull.onComplete($bind(this,this.animatePull_onComplete));
				} else {
					this.setPullDistance(this._targetPullDistance);
					this.completeDrag();
				}
			} else {
				this.completeDrag();
			}
		}
	},
	animatePull_onComplete: function() {
		this._animatePull = null;
		this.completeDrag();
	},
	edgePuller_target_addedToStageHandler: function(event) {
		this.addStageEvents();
	},
	edgePuller_target_removedFromStageHandler: function(event) {
		this.removeStageEvents();
		this.cleanupAfterDrag();
	},
	edgePuller_target_touchBeginCaptureHandler: function(event) {
		if(!this._active) {
			return;
		}
		event.stopImmediatePropagation();
		this.edgePuller_target_touchBeginHandler(event);
	},
	edgePuller_target_touchBeginHandler: function(event) {
		if(this.simulateTouch && event.isPrimaryTouchPoint) {
			return;
		}
		this.touchBegin(event.touchPointID,false,event.stageX,event.stageY);
	},
	edgePuller_target_mouseDownCaptureHandler: function(event) {
		if(!this._active) {
			return;
		}
		event.stopImmediatePropagation();
		this.edgePuller_target_mouseDownHandler(event);
	},
	edgePuller_target_mouseDownHandler: function(event) {
		if(this._opened) {
			return;
		}
		var stage = this._target.stage;
		if(stage == null) {
			return;
		}
		this.touchBegin(EdgePuller.POINTER_ID_MOUSE,true,stage.get_mouseX(),stage.get_mouseY());
	},
	edgePuller_target_stage_touchMoveHandler: function(event) {
		this.touchMove(event.touchPointID,false,event.stageX,event.stageY);
	},
	edgePuller_target_stage_mouseMoveHandler: function(event) {
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		this.touchMove(EdgePuller.POINTER_ID_MOUSE,true,stage.get_mouseX(),stage.get_mouseY());
	},
	edgePuller_target_stage_touchEndHandler: function(event) {
		this.touchEnd(event.touchPointID,false);
	},
	edgePuller_target_stage_mouseUpHandler: function(event) {
		this.touchEnd(EdgePuller.POINTER_ID_MOUSE,true);
	},
	edgePuller_target_stage_touchBeginHandler: function(event) {
		if(!this._opened || !this.enabled || this._touchPointID != null) {
			return;
		}
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		var maxPullDistance = this.getMaxPullDistance();
		if(!this.isInActiveBorder(event.stageX,event.stageY,maxPullDistance)) {
			this._touchPointID = event.touchPointID;
			stage.addEventListener("touchMove",$bind(this,this.edgePuller_target_stage_touchMoveHandler2),false,0,true);
			stage.addEventListener("touchEnd",$bind(this,this.edgePuller_target_stage_touchEndHandler2),false,0,true);
			return;
		}
		this.touchBegin(event.touchPointID,false,event.stageX,event.stageY);
	},
	edgePuller_target_stage_touchMoveHandler2: function(event) {
		if(this._touchPointID == null || event.touchPointID != this._touchPointID) {
			return;
		}
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		var maxPullDistance = this.getMaxPullDistance();
		var point = new (openfl_geom_Point())(event.stageX,event.stageY);
		point = this._target.globalToLocal(point);
		switch(this._pullableEdge._hx_index) {
		case 0:
			if(point.y > maxPullDistance || point.y < 0.0) {
				return;
			}
			break;
		case 1:
			if(point.x < this._target.get_width() - maxPullDistance || point.x > this._target.get_width()) {
				return;
			}
			break;
		case 2:
			if(point.y < this._target.get_height() - maxPullDistance || point.y > this._target.get_height()) {
				return;
			}
			break;
		case 3:
			if(point.x > maxPullDistance || point.x < 0.0) {
				return;
			}
			break;
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown pullable edge position: " + (Std().default).string(this._pullableEdge)));
		}
		stage.removeEventListener("touchMove",$bind(this,this.edgePuller_target_stage_touchMoveHandler2));
		stage.removeEventListener("touchEnd",$bind(this,this.edgePuller_target_stage_touchEndHandler2));
		this._touchPointID = null;
		this._touchPointIsSimulated = false;
		this.touchBegin(event.touchPointID,false,event.stageX,event.stageY);
	},
	edgePuller_target_stage_touchEndHandler2: function(event) {
		if(this._touchPointID == null || event.touchPointID != this._touchPointID) {
			return;
		}
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		stage.removeEventListener("touchMove",$bind(this,this.edgePuller_target_stage_touchMoveHandler2));
		stage.removeEventListener("touchEnd",$bind(this,this.edgePuller_target_stage_touchEndHandler2));
		this._touchPointID = null;
		this._touchPointIsSimulated = false;
	},
	edgePuller_target_stage_mouseDownHandler: function(event) {
		if(!this._opened || !this.enabled || this._touchPointID != null || !this.simulateTouch) {
			return;
		}
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		var maxPullDistance = this.getMaxPullDistance();
		if(!this.isInActiveBorder(stage.get_mouseX(),stage.get_mouseY(),maxPullDistance)) {
			this._touchPointID = EdgePuller.POINTER_ID_MOUSE;
			this._touchPointIsSimulated = true;
			stage.addEventListener("mouseMove",$bind(this,this.edgePuller_target_stage_mouseMoveHandler2),false,0,true);
			stage.addEventListener("mouseUp",$bind(this,this.edgePuller_target_stage_mouseUpHandler2),false,0,true);
			return;
		}
		this.touchBegin(EdgePuller.POINTER_ID_MOUSE,true,stage.get_mouseX(),stage.get_mouseY());
	},
	edgePuller_target_stage_mouseMoveHandler2: function(event) {
		if(!this._touchPointIsSimulated || this._touchPointID == null || EdgePuller.POINTER_ID_MOUSE != this._touchPointID) {
			return;
		}
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		var maxPullDistance = this.getMaxPullDistance();
		var point = new (openfl_geom_Point())(stage.get_mouseX(),stage.get_mouseY());
		point = this._target.globalToLocal(point);
		switch(this._pullableEdge._hx_index) {
		case 0:
			if(point.y > maxPullDistance || point.y < 0.0) {
				return;
			}
			break;
		case 1:
			if(point.x < this._target.get_width() - maxPullDistance || point.x > this._target.get_width()) {
				return;
			}
			break;
		case 2:
			if(point.y < this._target.get_height() - maxPullDistance || point.y > this._target.get_height()) {
				return;
			}
			break;
		case 3:
			if(point.x > maxPullDistance || point.x < 0.0) {
				return;
			}
			break;
		default:
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Unknown pullable edge position: " + (Std().default).string(this._pullableEdge)));
		}
		stage.removeEventListener("mouseMove",$bind(this,this.edgePuller_target_stage_mouseMoveHandler2));
		stage.removeEventListener("mouseUp",$bind(this,this.edgePuller_target_stage_mouseUpHandler2));
		this._touchPointID = null;
		this._touchPointIsSimulated = false;
		this.touchBegin(EdgePuller.POINTER_ID_MOUSE,true,stage.get_mouseX(),stage.get_mouseY());
	},
	edgePuller_target_stage_mouseUpHandler2: function(event) {
		if(!this._touchPointIsSimulated || this._touchPointID == null || EdgePuller.POINTER_ID_MOUSE != this._touchPointID) {
			return;
		}
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		stage.removeEventListener("mouseMove",$bind(this,this.edgePuller_target_stage_mouseMoveHandler2));
		stage.removeEventListener("mouseUp",$bind(this,this.edgePuller_target_stage_mouseUpHandler2));
		this._touchPointID = null;
		this._touchPointIsSimulated = false;
	}
});
EdgePuller.prototype.__class__ = EdgePuller.prototype.constructor = $hxClasses["feathers.utils.EdgePuller"] = EdgePuller;

// Init



// Statics


EdgePuller.MINIMUM_VELOCITY = 0.02
EdgePuller.POINTER_ID_MOUSE = -1000

// Export

exports["default"] = EdgePuller;

/***/ }),

/***/ "./lib/_gen/feathers/utils/ExclusivePointer.js":
/*!*****************************************************!*\
  !*** ./lib/_gen/feathers/utils/ExclusivePointer.js ***!
  \*****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.ExclusivePointer

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function openfl_display_DisplayObject() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObject);}
function haxe_ds_ObjectMap() {return __webpack_require__(/*! ./../../haxe/ds/ObjectMap */ "./lib/_gen/haxe/ds/ObjectMap.js");}
function haxe_ds_IntMap() {return __webpack_require__(/*! ./../../haxe/ds/IntMap */ "./lib/_gen/haxe/ds/IntMap.js");}

// Constructor

var ExclusivePointer = function(stage) {
	this._touchClaims = new (haxe_ds_IntMap().default)();
	this._mouseClaim = null;
	this._stageListenerCount = 0;
	if(stage == null) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Stage cannot be null."));
	}
	this._stage = stage;
}

// Meta

ExclusivePointer.__name__ = "feathers.utils.ExclusivePointer";
ExclusivePointer.__isInterface__ = false;
ExclusivePointer.prototype = {
	claimTouch: function(touchPointID,target) {
		if(target == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Target cannot be null."));
		}
		if(target.stage != this._stage) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Target cannot claim a pointer on the selected stage because it appears on a different stage."));
		}
		var existingTarget = this._touchClaims.get(touchPointID);
		if(existingTarget != null) {
			return false;
		}
		this._touchClaims.set(touchPointID,target);
		target.addEventListener("removedFromStage",$bind(this,this.exclusivePointer_target_removedFromStageHandler),false,0,true);
		if(this._stageListenerCount == 0) {
			this._stage.addEventListener("mouseUp",$bind(this,this.exclusivePointer_stage_mouseUpHandler),false,0,true);
			this._stage.addEventListener("touchEnd",$bind(this,this.exclusivePointer_stage_touchEndHandler),false,0,true);
		}
		this._stageListenerCount++;
		return true;
	},
	claimMouse: function(target) {
		if(target == null) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Target cannot be null."));
		}
		if(target.stage != this._stage) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Target cannot claim a pointer on the selected stage because it appears on a different stage."));
		}
		if(this._mouseClaim != null) {
			return false;
		}
		this._mouseClaim = target;
		target.addEventListener("removedFromStage",$bind(this,this.exclusivePointer_target_removedFromStageHandler),false,0,true);
		if(this._stageListenerCount == 0) {
			this._stage.addEventListener("mouseUp",$bind(this,this.exclusivePointer_stage_mouseUpHandler),false,0,true);
			this._stage.addEventListener("touchEnd",$bind(this,this.exclusivePointer_stage_touchEndHandler),false,0,true);
		}
		this._stageListenerCount++;
		return true;
	},
	removeTouchClaim: function(touchPointID) {
		var existingTarget = this._touchClaims.get(touchPointID);
		if(existingTarget == null) {
			return;
		}
		this._touchClaims.remove(touchPointID);
		if(!this.hasClaimOn(existingTarget)) {
			existingTarget.removeEventListener("removedFromStage",$bind(this,this.exclusivePointer_target_removedFromStageHandler));
		}
		this._stageListenerCount--;
		if(this._stageListenerCount == 0) {
			this._stage.removeEventListener("mouseUp",$bind(this,this.exclusivePointer_stage_mouseUpHandler));
			this._stage.removeEventListener("touchEnd",$bind(this,this.exclusivePointer_stage_touchEndHandler));
		}
	},
	removeMouseClaim: function() {
		var existingTarget = this._mouseClaim;
		if(existingTarget == null) {
			return;
		}
		this._mouseClaim = null;
		if(!this.hasClaimOn(existingTarget)) {
			existingTarget.removeEventListener("removedFromStage",$bind(this,this.exclusivePointer_target_removedFromStageHandler));
		}
		this._stageListenerCount--;
		if(this._stageListenerCount == 0) {
			this._stage.removeEventListener("mouseUp",$bind(this,this.exclusivePointer_stage_mouseUpHandler));
			this._stage.removeEventListener("touchEnd",$bind(this,this.exclusivePointer_stage_touchEndHandler));
		}
	},
	hasClaim: function() {
		if(this._mouseClaim != null) {
			return true;
		}
		var touchPointID = this._touchClaims.keys();
		while(touchPointID.hasNext()) {
			var touchPointID1 = touchPointID.next();
			return true;
		}
		return false;
	},
	getTouchClaim: function(touchPointID) {
		return this._touchClaims.get(touchPointID);
	},
	getMouseClaim: function() {
		return this._mouseClaim;
	},
	removeAllClaims: function() {
		var touchPointID = this._touchClaims.keys();
		while(touchPointID.hasNext()) {
			var touchPointID1 = touchPointID.next();
			this.removeTouchClaim(touchPointID1);
		}
		this.removeMouseClaim();
	},
	dispose: function() {
		this.removeAllClaims();
	},
	hasClaimOn: function(target) {
		if(this._mouseClaim == target) {
			return true;
		}
		var _g = this._touchClaims.keyValueIterator();
		while(_g.hasNext()) {
			var _g1 = _g.next();
			var touchPointID = _g1.key;
			var existingTarget = _g1.value;
			if(existingTarget == target) {
				return true;
			}
		}
		return false;
	},
	exclusivePointer_target_removedFromStageHandler: function(event) {
		var target = (js_Boot().default).__cast(event.currentTarget , (openfl_display_DisplayObject()));
		if(this._mouseClaim == target) {
			this.removeMouseClaim();
		}
		var _g = this._touchClaims.keyValueIterator();
		while(_g.hasNext()) {
			var _g1 = _g.next();
			var touchPointID = _g1.key;
			var existingTarget = _g1.value;
			if(existingTarget == target) {
				this.removeTouchClaim(touchPointID);
			}
		}
	},
	exclusivePointer_stage_mouseUpHandler: function(event) {
		this.removeMouseClaim();
	},
	exclusivePointer_stage_touchEndHandler: function(event) {
		this.removeTouchClaim(event.touchPointID);
	}
};
ExclusivePointer.prototype.__class__ = ExclusivePointer.prototype.constructor = $hxClasses["feathers.utils.ExclusivePointer"] = ExclusivePointer;

// Init



// Statics

ExclusivePointer.forStage = function(stage) {
	if(stage == null) {
		throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Stage cannot be null."));
	}
	var exclusivePointer = ExclusivePointer.stageToObject.get(stage);
	if(exclusivePointer != null) {
		return exclusivePointer;
	}
	exclusivePointer = new ExclusivePointer(stage);
	ExclusivePointer.stageToObject.set(stage,exclusivePointer);
	return exclusivePointer;
}
ExclusivePointer.disposeForStage = function(stage) {
	var exclusivePointer = ExclusivePointer.stageToObject.get(stage);
	if(exclusivePointer == null) {
		return;
	}
	exclusivePointer.dispose();
	ExclusivePointer.stageToObject.remove(stage);
}
ExclusivePointer.stageToObject = new (haxe_ds_ObjectMap().default)()

// Export

exports["default"] = ExclusivePointer;

/***/ }),

/***/ "./lib/_gen/feathers/utils/FocusUtil.js":
/*!**********************************************!*\
  !*** ./lib/_gen/feathers/utils/FocusUtil.js ***!
  \**********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.FocusUtil

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}
function feathers_core_IFocusExtras() {return __webpack_require__(/*! ./../../feathers/core/IFocusExtras */ "./lib/_gen/feathers/core/IFocusExtras.js");}
function feathers_core_IFocusContainer() {return __webpack_require__(/*! ./../../feathers/core/IFocusContainer */ "./lib/_gen/feathers/core/IFocusContainer.js");}
function openfl_display_DisplayObjectContainer() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObjectContainer);}

// Constructor

var FocusUtil = function(){}

// Meta

FocusUtil.__name__ = "feathers.utils.FocusUtil";
FocusUtil.__isInterface__ = false;
FocusUtil.prototype = {
	
};
FocusUtil.prototype.__class__ = FocusUtil.prototype.constructor = $hxClasses["feathers.utils.FocusUtil"] = FocusUtil;

// Init



// Statics

FocusUtil.findAllFocusableObjects = function(target,result) {
	if(result == null) {
		result = [];
	}
	if((js_Boot().default).__implements(target,(feathers_core_IFocusObject().default))) {
		var focusableObject = (js_Boot().default).__cast(target , (feathers_core_IFocusObject().default));
		if(focusableObject.get_focusEnabled()) {
			result.push(focusableObject);
		}
	}
	if((js_Boot().default).__implements(target,(feathers_core_IFocusExtras().default))) {
		var focusExtras = (js_Boot().default).__cast(target , (feathers_core_IFocusExtras().default));
		var extras = focusExtras.get_focusExtrasBefore();
		if(extras != null) {
			var _g = 0;
			var _g1 = extras.length;
			while(_g < _g1) {
				var i = _g++;
				var childOfTarget = extras[i];
				FocusUtil.findAllFocusableObjects(childOfTarget,result);
			}
		}
	}
	if((js_Boot().default).__implements(target,(feathers_core_IFocusObject().default))) {
		if((js_Boot().default).__implements(target,(feathers_core_IFocusContainer().default)) && ((js_Boot().default).__cast(target , (feathers_core_IFocusContainer().default))).get_childFocusEnabled()) {
			var otherContainer = (js_Boot().default).__cast(target , (openfl_display_DisplayObjectContainer()));
			var _g2 = 0;
			var _g11 = otherContainer.get_numChildren();
			while(_g2 < _g11) {
				var i1 = _g2++;
				var childOfTarget1 = otherContainer.getChildAt(i1);
				FocusUtil.findAllFocusableObjects(childOfTarget1,result);
			}
		}
	} else if(((target) instanceof (openfl_display_DisplayObjectContainer()))) {
		var otherContainer1 = (js_Boot().default).__cast(target , (openfl_display_DisplayObjectContainer()));
		var _g3 = 0;
		var _g12 = otherContainer1.get_numChildren();
		while(_g3 < _g12) {
			var i2 = _g3++;
			var childOfTarget2 = otherContainer1.getChildAt(i2);
			FocusUtil.findAllFocusableObjects(childOfTarget2,result);
		}
	}
	if((js_Boot().default).__implements(target,(feathers_core_IFocusExtras().default))) {
		var focusExtras1 = (js_Boot().default).__cast(target , (feathers_core_IFocusExtras().default));
		var extras1 = focusExtras1.get_focusExtrasAfter();
		if(extras1 != null) {
			var _g4 = 0;
			var _g13 = extras1.length;
			while(_g4 < _g13) {
				var i3 = _g4++;
				var childOfTarget3 = extras1[i3];
				FocusUtil.findAllFocusableObjects(childOfTarget3,result);
			}
		}
	}
	return result;
}


// Export

exports["default"] = FocusUtil;

/***/ }),

/***/ "./lib/_gen/feathers/utils/KeyToState.js":
/*!***********************************************!*\
  !*** ./lib/_gen/feathers/utils/KeyToState.js ***!
  \***********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.KeyToState

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IStateContext() {return __webpack_require__(/*! ./../../feathers/core/IStateContext */ "./lib/_gen/feathers/core/IStateContext.js");}
function feathers_core_IFocusObject() {return __webpack_require__(/*! ./../../feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");}

// Constructor

var KeyToState = function(target,callback,upState,downState) {
	this._downKeyCode = null;
	this._enabled = true;
	this._downState = null;
	this._upState = null;
	this._callback = null;
	this._target = null;
	this.set_target(target);
	if(upState != null) {
		this._upState = upState;
	}
	if(downState != null) {
		this.set_downState(downState);
	}
	this._currentState = this._upState;
	this.set_callback(callback);
}

// Meta

KeyToState.__name__ = "feathers.utils.KeyToState";
KeyToState.__isInterface__ = false;
KeyToState.prototype = {
	get_target: function() {
		return this._target;
	},
	set_target: function(value) {
		if(this._target == value) {
			return this._target;
		}
		if(this._target != null) {
			this._target.removeEventListener("removedFromStage",$bind(this,this.keyToState_target_removedFromStageHandler));
			this._target.removeEventListener("focusOut",$bind(this,this.keyToState_target_focusOutHandler));
			this._target.removeEventListener("keyDown",$bind(this,this.keyToState_target_keyDownHandler));
			this._target.removeEventListener("keyUp",$bind(this,this.keyToState_target_keyUpHandler));
		}
		this._target = value;
		if(this._target != null) {
			this._currentState = this._upState;
			this._target.addEventListener("removedFromStage",$bind(this,this.keyToState_target_removedFromStageHandler));
			this._target.addEventListener("focusOut",$bind(this,this.keyToState_target_focusOutHandler));
			this._target.addEventListener("keyDown",$bind(this,this.keyToState_target_keyDownHandler));
			this._target.addEventListener("keyUp",$bind(this,this.keyToState_target_keyUpHandler));
		}
		return this._target;
	},
	get_callback: function() {
		return this._callback;
	},
	set_callback: function(value) {
		if(this._callback == value) {
			return this._callback;
		}
		this._callback = value;
		if(this._callback != null) {
			this._callback(this._currentState);
		}
		return this._callback;
	},
	get_currentState: function() {
		return this._currentState;
	},
	get_upState: function() {
		return this._upState;
	},
	set_upState: function(value) {
		this._upState = value;
		return this._upState;
	},
	get_downState: function() {
		return this._downState;
	},
	set_downState: function(value) {
		this._downState = value;
		return this._downState;
	},
	get_enabled: function() {
		return this._enabled;
	},
	set_enabled: function(value) {
		if(this._enabled == value) {
			return this._enabled;
		}
		this._enabled = value;
		if(!this._enabled) {
			this.resetKeyState();
		}
		return this._enabled;
	},
	changeState: function(value) {
		var oldState = this._currentState;
		if((js_Boot().default).__implements(this._target,(feathers_core_IStateContext().default))) {
			oldState = ((js_Boot().default).__cast(this._target , (feathers_core_IStateContext().default))).get_currentState();
		}
		this._currentState = value;
		if(oldState == value) {
			return;
		}
		if(this._callback != null) {
			this._callback(value);
		}
	},
	resetKeyState: function() {
		if(this._downKeyCode == null) {
			return;
		}
		this._downKeyCode = null;
		this.changeState(this._upState);
	},
	keyToState_target_removedFromStageHandler: function(event) {
		this.resetKeyState();
	},
	keyToState_target_focusOutHandler: function(event) {
		this.resetKeyState();
	},
	keyToState_target_keyDownHandler: function(event) {
		if((js_Boot().default).__implements(this._target,(feathers_core_IFocusObject().default))) {
			var focusObject = (js_Boot().default).__cast(this._target , (feathers_core_IFocusObject().default));
			var focusManager = focusObject.get_focusManager();
			if(focusManager != null && focusManager.get_focus() != focusObject) {
				return;
			}
		}
		if(!this._enabled || this._downKeyCode != null || event.keyCode != 32 && event.keyCode != 13) {
			return;
		}
		this._downKeyCode = event.keyCode;
		this.changeState(this._downState);
	},
	keyToState_target_keyUpHandler: function(event) {
		if(event.keyCode != this._downKeyCode) {
			return;
		}
		this.resetKeyState();
	}
};
KeyToState.prototype.__class__ = KeyToState.prototype.constructor = $hxClasses["feathers.utils.KeyToState"] = KeyToState;

// Init



// Statics




// Export

exports["default"] = KeyToState;

/***/ }),

/***/ "./lib/_gen/feathers/utils/LongPress.js":
/*!**********************************************!*\
  !*** ./lib/_gen/feathers/utils/LongPress.js ***!
  \**********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.LongPress

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function openfl_Lib() {return (__webpack_require__(/*! openfl */ "openfl").Lib);}
function feathers_events_LongPressEvent() {return __webpack_require__(/*! ./../../feathers/events/LongPressEvent */ "./lib/_gen/feathers/events/LongPressEvent.js");}

// Constructor

var LongPress = function(target,eventFactory) {
	this._stopNextTrigger = false;
	this._enabled = true;
	this._eventFactory = null;
	this.duration = 0.5;
	this._target = null;
	this.set_target(target);
	this.set_eventFactory(eventFactory);
}

// Meta

LongPress.__name__ = "feathers.utils.LongPress";
LongPress.__isInterface__ = false;
LongPress.prototype = {
	get_target: function() {
		return this._target;
	},
	set_target: function(value) {
		if(this._target == value) {
			return this._target;
		}
		if(this._target != null) {
			this.cleanupMouseEvents();
			this.cleanupTouchEvents();
			this._target.removeEventListener("removedFromStage",$bind(this,this.longPress_target_removedFromStageHandler));
			this._target.removeEventListener("mouseDown",$bind(this,this.longPress_target_mouseDownHandler));
			this._target.removeEventListener("touchBegin",$bind(this,this.longPress_target_touchBeginHandler));
			this._target.removeEventListener("trigger",$bind(this,this.longPress_target_triggerHandler));
		}
		this._target = value;
		if(this._target != null) {
			this._target.addEventListener("removedFromStage",$bind(this,this.longPress_target_removedFromStageHandler),false,0,true);
			this._target.addEventListener("mouseDown",$bind(this,this.longPress_target_mouseDownHandler),false,0,true);
			this._target.addEventListener("touchBegin",$bind(this,this.longPress_target_touchBeginHandler),false,0,true);
			this._target.addEventListener("trigger",$bind(this,this.longPress_target_triggerHandler),false,10,true);
		}
		return this._target;
	},
	get_eventFactory: function() {
		return this._eventFactory;
	},
	set_eventFactory: function(value) {
		if(this._eventFactory == value) {
			return this._eventFactory;
		}
		this._eventFactory = value;
		return this._eventFactory;
	},
	get_enabled: function() {
		return this._enabled;
	},
	set_enabled: function(value) {
		this._enabled = value;
		return this._enabled;
	},
	get_customHitTest: function() {
		return this._customHitTest;
	},
	set_customHitTest: function(value) {
		this._customHitTest = value;
		return this._customHitTest;
	},
	cleanupMouseEvents: function() {
		if(this._target == null) {
			return;
		}
		var stage = this._target.stage;
		if(stage != null) {
			stage.removeEventListener("mouseMove",$bind(this,this.longPress_target_stage_mouseMoveHandler));
			stage.removeEventListener("mouseUp",$bind(this,this.longPress_target_stage_mouseUpHandler));
		}
		this._target.removeEventListener("enterFrame",$bind(this,this.longPress_target_enterFrameHandler));
		this._savedMouseEvent = null;
	},
	cleanupTouchEvents: function() {
		if(this._target == null) {
			return;
		}
		var stage = this._target.stage;
		if(stage != null) {
			stage.removeEventListener("touchMove",$bind(this,this.longPress_target_stage_touchMoveHandler));
			stage.removeEventListener("touchEnd",$bind(this,this.longPress_target_stage_touchEndHandler));
		}
		this._target.removeEventListener("enterFrame",$bind(this,this.longPress_target_enterFrameHandler));
		this._savedTouchEvent = null;
	},
	longPress_target_removedFromStageHandler: function(event) {
		this.cleanupMouseEvents();
		this.cleanupTouchEvents();
	},
	longPress_target_mouseDownHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(this._customHitTest != null && !this._customHitTest(event.stageX,event.stageY)) {
			return;
		}
		this._startTime = (openfl_Lib()).getTimer();
		this._stopNextTrigger = false;
		this._savedMouseEvent = event.clone();
		var stage = this._target.stage;
		stage.addEventListener("mouseMove",$bind(this,this.longPress_target_stage_mouseMoveHandler),false,0,true);
		stage.addEventListener("mouseUp",$bind(this,this.longPress_target_stage_mouseUpHandler),false,0,true);
		this._target.addEventListener("enterFrame",$bind(this,this.longPress_target_enterFrameHandler));
	},
	longPress_target_touchBeginHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(event.isPrimaryTouchPoint) {
			return;
		}
		if(this._customHitTest != null && !this._customHitTest(event.stageX,event.stageY)) {
			return;
		}
		this._startTime = (openfl_Lib()).getTimer();
		this._stopNextTrigger = false;
		this._savedTouchEvent = event.clone();
		var stage = this._target.stage;
		stage.addEventListener("touchMove",$bind(this,this.longPress_target_stage_touchMoveHandler),false,0,true);
		stage.addEventListener("touchEnd",$bind(this,this.longPress_target_stage_touchEndHandler),false,0,true);
		this._target.addEventListener("enterFrame",$bind(this,this.longPress_target_enterFrameHandler));
	},
	longPress_target_stage_mouseMoveHandler: function(event) {
		this._savedMouseEvent.localX = event.localX;
		this._savedMouseEvent.localY = event.localY;
		this._savedMouseEvent.stageX = event.stageX;
		this._savedMouseEvent.stageY = event.stageY;
		this._savedMouseEvent.altKey = event.altKey;
		this._savedMouseEvent.ctrlKey = event.ctrlKey;
		this._savedMouseEvent.commandKey = event.commandKey;
		this._savedMouseEvent.shiftKey = event.shiftKey;
	},
	longPress_target_stage_touchMoveHandler: function(event) {
		if(this._savedTouchEvent.touchPointID != event.touchPointID) {
			return;
		}
		this._savedTouchEvent.localX = event.localX;
		this._savedTouchEvent.localY = event.localY;
		this._savedTouchEvent.stageX = event.stageX;
		this._savedTouchEvent.stageY = event.stageY;
		this._savedTouchEvent.altKey = event.altKey;
		this._savedTouchEvent.ctrlKey = event.ctrlKey;
		this._savedTouchEvent.commandKey = event.commandKey;
		this._savedTouchEvent.shiftKey = event.shiftKey;
	},
	longPress_target_stage_mouseUpHandler: function(event) {
		this.cleanupMouseEvents();
	},
	longPress_target_stage_touchEndHandler: function(event) {
		if(this._savedTouchEvent.touchPointID != event.touchPointID) {
			return;
		}
		this.cleanupTouchEvents();
	},
	longPress_target_triggerHandler: function(event) {
		if(!this._stopNextTrigger) {
			return;
		}
		this._stopNextTrigger = false;
		event.stopImmediatePropagation();
	},
	longPress_target_enterFrameHandler: function(event) {
		var accumulatedTime = ((openfl_Lib()).getTimer() - this._startTime) / 1000.0;
		if(accumulatedTime < this.duration) {
			return;
		}
		this._stopNextTrigger = true;
		if(this._savedMouseEvent != null) {
			var mouseEvent = this._savedMouseEvent;
			this.cleanupMouseEvents();
			if(this._eventFactory != null) {
				this._target.dispatchEvent(this._eventFactory());
				return;
			}
			(feathers_events_LongPressEvent().default).dispatchFromMouseEvent(this._target,mouseEvent);
			return;
		}
		var touchEvent = this._savedTouchEvent;
		this.cleanupTouchEvents();
		if(this._eventFactory != null) {
			this._target.dispatchEvent(this._eventFactory());
			return;
		}
		(feathers_events_LongPressEvent().default).dispatchFromTouchEvent(this._target,touchEvent);
	}
};
LongPress.prototype.__class__ = LongPress.prototype.constructor = $hxClasses["feathers.utils.LongPress"] = LongPress;

// Init



// Statics




// Export

exports["default"] = LongPress;

/***/ }),

/***/ "./lib/_gen/feathers/utils/MathUtil.js":
/*!*********************************************!*\
  !*** ./lib/_gen/feathers/utils/MathUtil.js ***!
  \*********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.MathUtil

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);

// Constructor

var MathUtil = function(){}

// Meta

MathUtil.__name__ = "feathers.utils.MathUtil";
MathUtil.__isInterface__ = false;
MathUtil.prototype = {
	
};
MathUtil.prototype.__class__ = MathUtil.prototype.constructor = $hxClasses["feathers.utils.MathUtil"] = MathUtil;

// Init



// Statics

MathUtil.roundDownToNearest = function(number,nearest) {
	if(nearest == null) {
		nearest = 1.0;
	}
	if(nearest == 0) {
		return number;
	}
	return Math.floor(MathUtil.roundToPrecision(number / nearest,10)) * nearest;
}
MathUtil.roundUpToNearest = function(number,nearest) {
	if(nearest == null) {
		nearest = 1.0;
	}
	if(nearest == 0) {
		return number;
	}
	return Math.ceil(MathUtil.roundToPrecision(number / nearest,10)) * nearest;
}
MathUtil.roundToNearest = function(number,nearest) {
	if(nearest == null) {
		nearest = 1.0;
	}
	if(nearest == 0) {
		return number;
	}
	return Math.round(MathUtil.roundToPrecision(number / nearest,10)) * nearest;
}
MathUtil.roundToPrecision = function(number,precision) {
	if(precision == null) {
		precision = 0;
	}
	var decimalPlaces = Math.pow(10,precision);
	return Math.round(decimalPlaces * number) / decimalPlaces;
}
MathUtil.fuzzyEquals = function(n1,n2,maxDifference) {
	if(maxDifference == null) {
		maxDifference = 0.000001;
	}
	return Math.abs(n1 - n2) <= maxDifference;
}


// Export

exports["default"] = MathUtil;

/***/ }),

/***/ "./lib/_gen/feathers/utils/MeasurementsUtil.js":
/*!*****************************************************!*\
  !*** ./lib/_gen/feathers/utils/MeasurementsUtil.js ***!
  \*****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.MeasurementsUtil

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IMeasureObject() {return __webpack_require__(/*! ./../../feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");}

// Constructor

var MeasurementsUtil = function(){}

// Meta

MeasurementsUtil.__name__ = "feathers.utils.MeasurementsUtil";
MeasurementsUtil.__isInterface__ = false;
MeasurementsUtil.prototype = {
	
};
MeasurementsUtil.prototype.__class__ = MeasurementsUtil.prototype.constructor = $hxClasses["feathers.utils.MeasurementsUtil"] = MeasurementsUtil;

// Init



// Statics

MeasurementsUtil.resetFluidlyWithParentValues = function(measurements,target,parentExplicitWidth,parentExplicitHeight,parentExplicitMinWidth,parentExplicitMinHeight,parentExplicitMaxWidth,parentExplicitMaxHeight) {
	if(target == null) {
		return;
	}
	if((js_Boot().default).__implements(target,(feathers_core_IMeasureObject().default))) {
		var measureTarget = (js_Boot().default).__cast(target , (feathers_core_IMeasureObject().default));
		var width = parentExplicitWidth;
		if(width == null) {
			width = measurements.width;
		}
		if(width == null) {
			measureTarget.resetWidth();
		} else {
			measureTarget.set_width(width);
		}
		var height = parentExplicitHeight;
		if(height == null) {
			height = measurements.height;
		}
		if(height == null) {
			measureTarget.resetHeight();
		} else {
			measureTarget.set_height(height);
		}
		var minWidth = parentExplicitMinWidth;
		if(minWidth == null || measureTarget.get_explicitMinWidth() != null && measureTarget.get_explicitMinWidth() > minWidth) {
			minWidth = measureTarget.get_explicitMinWidth();
		}
		if(minWidth == null) {
			minWidth = 0.0;
		}
		measureTarget.set_minWidth(minWidth);
		var minHeight = parentExplicitMinHeight;
		if(minHeight == null || measureTarget.get_explicitMinHeight() != null && measureTarget.get_explicitMinHeight() > minHeight) {
			minHeight = measureTarget.get_explicitMinHeight();
		}
		if(minHeight == null) {
			minHeight = 0.0;
		}
		measureTarget.set_minHeight(minHeight);
		var maxWidth = parentExplicitMaxWidth;
		if(maxWidth == null || measureTarget.get_explicitMaxWidth() != null && measureTarget.get_explicitMaxWidth() < maxWidth) {
			maxWidth = measureTarget.get_explicitMaxWidth();
		}
		if(maxWidth == null) {
			maxWidth = 1.0 / 0.0;
		}
		measureTarget.set_maxWidth(maxWidth);
		var maxHeight = parentExplicitMaxHeight;
		if(maxHeight == null || measureTarget.get_explicitMaxHeight() != null && measureTarget.get_explicitMaxHeight() < maxHeight) {
			maxHeight = measureTarget.get_explicitMaxHeight();
		}
		if(maxHeight == null) {
			maxHeight = 1.0 / 0.0;
		}
		measureTarget.set_maxHeight(maxHeight);
		return;
	}
	if(parentExplicitWidth != null) {
		target.set_width(parentExplicitWidth);
	} else if(measurements.width != null) {
		target.set_width(measurements.width);
	}
	if(parentExplicitHeight != null) {
		target.set_height(parentExplicitHeight);
	} else if(measurements.height != null) {
		target.set_height(measurements.height);
	}
}
MeasurementsUtil.resetFluidlyWithParent = function(measurements,target,parent) {
	MeasurementsUtil.resetFluidlyWithParentValues(measurements,target,parent.get_explicitWidth(),parent.get_explicitHeight(),parent.get_explicitMinWidth(),parent.get_explicitMinHeight(),parent.get_explicitMaxWidth(),parent.get_explicitMaxHeight());
	return;
}


// Export

exports["default"] = MeasurementsUtil;

/***/ }),

/***/ "./lib/_gen/feathers/utils/Path2EReg.js":
/*!**********************************************!*\
  !*** ./lib/_gen/feathers/utils/Path2EReg.js ***!
  \**********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.Path2EReg

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function EReg() {return __webpack_require__(/*! ./../../EReg */ "./lib/_gen/EReg.js");}
function haxe_CallStack() {return __webpack_require__(/*! ./../../haxe/CallStack */ "./lib/_gen/haxe/CallStack.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function feathers_utils__$Path2EReg_Token() {return __webpack_require__(/*! ./../../feathers/utils/_Path2EReg/Token */ "./lib/_gen/feathers/utils/_Path2EReg/Token.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function StringTools() {return __webpack_require__(/*! ./../../StringTools */ "./lib/_gen/StringTools.js");}

// Constructor

var Path2EReg = function(){}

// Meta

Path2EReg.__name__ = "feathers.utils.Path2EReg";
Path2EReg.__isInterface__ = false;
Path2EReg.prototype = {
	
};
Path2EReg.prototype.__class__ = Path2EReg.prototype.constructor = $hxClasses["feathers.utils.Path2EReg"] = Path2EReg;

// Init



// Statics

Path2EReg.parse = function(str) {
	var matcher = new (EReg().default)(["(\\\\.)","([\\/.])?(?:(?:\\:(\\w+)(?:\\(((?:\\\\.|[^\\\\()])+)\\))?|\\(((?:\\\\.|[^\\\\()])+)\\))([+*?])?|(\\*))"].join("|"),"g");
	var tokens = [];
	var key = 0;
	var index = 0;
	var path = "";
	var matched = function(index1) {
		try {
			return matcher.matched(index1);
		} catch( e ) {
			(haxe_CallStack().default).lastException = e;
			var e1 = ((e) instanceof (js__$Boot_HaxeError().default)) ? e.val : e;
			return null;
		}
	};
	matcher.map(str,function(matcher1) {
		var m = matched(0);
		var escaped = matched(1);
		var offset = matcher1.matchedPos().pos;
		path += str.substring(index,offset);
		index = offset + m.length;
		if(escaped != null) {
			path += escaped.charAt(1);
			return "";
		}
		var next = str.charAt(index);
		var prefix = matched(2);
		var name = matched(3);
		var capture = matched(4);
		var group = matched(5);
		var modifier = matched(6);
		var asterisk = matched(7);
		var delimiter = prefix == null ? "/" : prefix;
		if(path != "") {
			tokens.push((feathers_utils__$Path2EReg_Token().default).Static(path));
			path = "";
		}
		var tmp;
		if(name == null) {
			key += 1;
			tmp = "" + (key - 1);
		} else {
			tmp = name;
		}
		var tmp1;
		if(capture == null) {
			if(group == null) {
				if(asterisk == null) {
					tmp1 = "[^" + delimiter + "]+?";
				} else {
					var x = asterisk;
					tmp1 = ".*";
				}
			} else {
				var x1 = group;
				tmp1 = x1;
			}
		} else {
			var x2 = capture;
			tmp1 = x2;
		}
		var tmp2 = (feathers_utils__$Path2EReg_Token().default).Capture({ name : tmp, prefix : prefix == null ? "" : prefix, delimiter : delimiter, optional : modifier == "?" || modifier == "*", repeat : modifier == "+" || modifier == "*", partial : prefix != null && next != "" && next != prefix, asterisk : asterisk != null, pattern : Path2EReg.escapeGroup(tmp1)});
		tokens.push(tmp2);
		return "";
	});
	if(index < str.length) {
		path += (HxOverrides().default).substr(str,index,null);
	}
	if(path != "") {
		tokens.push((feathers_utils__$Path2EReg_Token().default).Static(path));
	}
	return tokens;
}
Path2EReg.tokensToEReg = function(tokens,options) {
	options = Path2EReg.defaults(options);
	var strict = options.strict;
	var end = options.end;
	var route = "";
	var lastToken = tokens[tokens.length - 1];
	var endsWithSlash;
	if(lastToken._hx_index == 0) {
		var token = lastToken.token;
		endsWithSlash = token.charAt(token.length - 1) == "/";
	} else {
		endsWithSlash = false;
	}
	var _g1 = 0;
	while(_g1 < tokens.length) {
		var token1 = tokens[_g1];
		++_g1;
		switch(token1._hx_index) {
		case 0:
			var token2 = token1.token;
			route += Path2EReg.escapeString(token2);
			break;
		case 1:
			var token3 = token1.key;
			var prefix = Path2EReg.escapeString(token3.prefix);
			var capture = "(?:" + token3.pattern + ")";
			if(token3.repeat) {
				capture += "(?:" + prefix + capture + ")*";
			}
			if(token3.optional) {
				if(!token3.partial) {
					capture = "(?:" + prefix + "(" + capture + "))?";
				} else {
					capture = prefix + "(" + capture + ")?";
				}
			} else {
				capture = prefix + "(" + capture + ")";
			}
			route += capture;
			break;
		}
	}
	if(!strict) {
		route = (endsWithSlash ? (HxOverrides().default).substr(route,0,route.length - 2) : route) + "(?:\\/(?=$))?";
	}
	if(end) {
		route += "$";
	} else {
		route += strict && endsWithSlash ? "" : "(?=\\/|$)";
	}
	return new (EReg().default)("^" + route,Path2EReg.flags(options));
}
Path2EReg.defaults = function(options) {
	options = options == null ? { } : options;
	return { strict : options.strict == null ? false : options.strict, end : options.end == null ? true : options.end, sensitive : options.sensitive == null ? false : options.sensitive};
}
Path2EReg.escapeGroup = function(group) {
	var chars = "=!:$/()".split("");
	var _g = 0;
	while(_g < chars.length) {
		var char = chars[_g];
		++_g;
		group = (StringTools().default).replace(group,char,"\\" + char);
	}
	return group;
}
Path2EReg.escapeString = function(str) {
	var chars = "\\.+*?=^!:${}()[]|/".split("");
	var _g = 0;
	while(_g < chars.length) {
		var char = chars[_g];
		++_g;
		str = (StringTools().default).replace(str,char,"\\" + char);
	}
	return str;
}
Path2EReg.flags = function(options) {
	if(options.sensitive) {
		return "";
	} else {
		return "i";
	}
}
Path2EReg.encodeAsterisk = function(str) {
	return new (EReg().default)("[?#]","g").map(str,function(matcher) {
		var c = matcher.matched(0);
		return "%" + (StringTools().default).hex((HxOverrides().default).cca(c,0)).toUpperCase();
	});
}
Path2EReg.toEReg = function(path,options) {
	var tokens = Path2EReg.parse(path);
	var keys = [];
	var _g = 0;
	while(_g < tokens.length) {
		var token = tokens[_g];
		++_g;
		if(token._hx_index == 1) {
			var key = token.key;
			keys.push(key);
		} else {
			continue;
		}
	}
	return { ereg : Path2EReg.tokensToEReg(tokens,options), keys : keys};
}


// Export

exports["default"] = Path2EReg;

/***/ }),

/***/ "./lib/_gen/feathers/utils/PointerToState.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/utils/PointerToState.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.PointerToState

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function feathers_core_IStateContext() {return __webpack_require__(/*! ./../../feathers/core/IStateContext */ "./lib/_gen/feathers/core/IStateContext.js");}
function openfl_display_Stage() {return (__webpack_require__(/*! openfl */ "openfl").display.Stage);}

// Constructor

var PointerToState = function(target,callback,upState,downState,hoverState) {
	this._down = false;
	this._hoverBeforeDown = false;
	this._keepDownStateOnRollOut = false;
	this._enabled = true;
	this._hoverState = null;
	this._downState = null;
	this._upState = null;
	this._callback = null;
	this._stateContext = null;
	this._target = null;
	this.set_target(target);
	if(upState != null) {
		this.set_upState(upState);
	}
	if(downState != null) {
		this.set_downState(downState);
	}
	if(hoverState != null) {
		this.set_hoverState(hoverState);
	}
	this._currentState = this._upState;
	this.set_callback(callback);
}

// Meta

PointerToState.__name__ = "feathers.utils.PointerToState";
PointerToState.__isInterface__ = false;
PointerToState.prototype = {
	get_target: function() {
		return this._target;
	},
	set_target: function(value) {
		if(this._target == value) {
			return this._target;
		}
		if(this._target != null) {
			this._target.removeEventListener("removedFromStage",$bind(this,this.pointerToState_target_removedFromStageHandler));
			this._target.removeEventListener("rollOver",$bind(this,this.pointerToState_target_rollOverHandler));
			this._target.removeEventListener("rollOut",$bind(this,this.pointerToState_target_rollOutHandler));
			this._target.removeEventListener("mouseDown",$bind(this,this.pointerToState_target_mouseDownHandler));
		}
		this._target = value;
		if(this._target != null) {
			this._currentState = this._upState;
			this._target.addEventListener("removedFromStage",$bind(this,this.pointerToState_target_removedFromStageHandler));
			this._target.addEventListener("rollOver",$bind(this,this.pointerToState_target_rollOverHandler));
			this._target.addEventListener("rollOut",$bind(this,this.pointerToState_target_rollOutHandler));
			this._target.addEventListener("mouseDown",$bind(this,this.pointerToState_target_mouseDownHandler));
		}
		return this._target;
	},
	get_stateContext: function() {
		return this._stateContext;
	},
	set_stateContext: function(value) {
		if(this._stateContext == value) {
			return this._stateContext;
		}
		this._stateContext = value;
		return this._stateContext;
	},
	get_callback: function() {
		return this._callback;
	},
	set_callback: function(value) {
		if(this._callback == value) {
			return this._callback;
		}
		this._callback = value;
		if(this._callback != null) {
			this._callback(this._currentState);
		}
		return this._callback;
	},
	get_currentState: function() {
		return this._currentState;
	},
	get_upState: function() {
		return this._upState;
	},
	set_upState: function(value) {
		this._upState = value;
		return this._upState;
	},
	get_downState: function() {
		return this._downState;
	},
	set_downState: function(value) {
		this._downState = value;
		return this._downState;
	},
	get_hoverState: function() {
		return this._hoverState;
	},
	set_hoverState: function(value) {
		this._hoverState = value;
		return this._hoverState;
	},
	get_enabled: function() {
		return this._enabled;
	},
	set_enabled: function(value) {
		this._enabled = value;
		return this._enabled;
	},
	get_keepDownStateOnRollOut: function() {
		return this._keepDownStateOnRollOut;
	},
	set_keepDownStateOnRollOut: function(value) {
		this._keepDownStateOnRollOut = value;
		return this._keepDownStateOnRollOut;
	},
	get_customHitTest: function() {
		return this._customHitTest;
	},
	set_customHitTest: function(value) {
		this._customHitTest = value;
		return this._customHitTest;
	},
	changeState: function(value) {
		var oldState = this._currentState;
		var targetStateContext = this._stateContext;
		if(targetStateContext == null && (js_Boot().default).__implements(this._target,(feathers_core_IStateContext().default))) {
			targetStateContext = this._target;
		}
		if(targetStateContext != null) {
			oldState = targetStateContext.get_currentState();
		}
		this._currentState = value;
		if(oldState == value) {
			return;
		}
		if(this._callback != null) {
			this._callback(value);
		}
	},
	resetTouchState: function() {
		this._hoverBeforeDown = false;
		this.changeState(this._upState);
	},
	pointerToState_target_removedFromStageHandler: function(event) {
		if(this._target.stage != null) {
			this._target.stage.removeEventListener("mouseUp",$bind(this,this.pointerToState_stage_mouseUpHandler));
		}
		this.resetTouchState();
	},
	pointerToState_target_rollOverHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(this._customHitTest != null && !this._customHitTest(event.stageX,event.stageY)) {
			return;
		}
		this._hoverBeforeDown = true;
		if(this._down) {
			this.changeState(this._downState);
		} else {
			this.changeState(this._hoverState);
		}
	},
	pointerToState_target_rollOutHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		this._hoverBeforeDown = false;
		if(this._keepDownStateOnRollOut && this._down) {
			this.changeState(this._downState);
			return;
		}
		this.changeState(this._upState);
	},
	pointerToState_target_mouseDownHandler: function(event) {
		if(!this._enabled || this._target.stage == null) {
			return;
		}
		if(this._customHitTest != null && !this._customHitTest(event.stageX,event.stageY)) {
			return;
		}
		this._down = true;
		this._target.stage.addEventListener("mouseUp",$bind(this,this.pointerToState_stage_mouseUpHandler),false,0,true);
		this.changeState(this._downState);
	},
	pointerToState_stage_mouseUpHandler: function(event) {
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		this._down = false;
		stage.removeEventListener("mouseUp",$bind(this,this.pointerToState_stage_mouseUpHandler));
		if(this._hoverBeforeDown && this._target.hitTestPoint(event.stageX,event.stageY)) {
			this.changeState(this._hoverState);
		} else {
			this.resetTouchState();
		}
	}
};
PointerToState.prototype.__class__ = PointerToState.prototype.constructor = $hxClasses["feathers.utils.PointerToState"] = PointerToState;

// Init



// Statics




// Export

exports["default"] = PointerToState;

/***/ }),

/***/ "./lib/_gen/feathers/utils/PointerTrigger.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/utils/PointerTrigger.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.PointerTrigger

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function feathers_events_TriggerEvent() {return __webpack_require__(/*! ./../../feathers/events/TriggerEvent */ "./lib/_gen/feathers/events/TriggerEvent.js");}

// Constructor

var PointerTrigger = function(target,eventFactory) {
	this._enabled = true;
	this._eventFactory = null;
	this._target = null;
	this.set_target(target);
	this.set_eventFactory(eventFactory);
}

// Meta

PointerTrigger.__name__ = "feathers.utils.PointerTrigger";
PointerTrigger.__isInterface__ = false;
PointerTrigger.prototype = {
	get_target: function() {
		return this._target;
	},
	set_target: function(value) {
		if(this._target == value) {
			return this._target;
		}
		if(this._target != null) {
			this._target.removeEventListener("click",$bind(this,this.pointerTrigger_target_clickHandler));
			this._target.removeEventListener("touchTap",$bind(this,this.pointerTrigger_target_touchTapHandler));
		}
		this._target = value;
		if(this._target != null) {
			this._target.addEventListener("click",$bind(this,this.pointerTrigger_target_clickHandler));
		}
		return this._target;
	},
	get_eventFactory: function() {
		return this._eventFactory;
	},
	set_eventFactory: function(value) {
		if(this._eventFactory == value) {
			return this._eventFactory;
		}
		this._eventFactory = value;
		return this._eventFactory;
	},
	get_enabled: function() {
		return this._enabled;
	},
	set_enabled: function(value) {
		this._enabled = value;
		return this._enabled;
	},
	get_customHitTest: function() {
		return this._customHitTest;
	},
	set_customHitTest: function(value) {
		this._customHitTest = value;
		return this._customHitTest;
	},
	pointerTrigger_target_clickHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(this._customHitTest != null && !this._customHitTest(event.stageX,event.stageY)) {
			return;
		}
		if(this._eventFactory != null) {
			this._target.dispatchEvent(this._eventFactory());
			return;
		}
		(feathers_events_TriggerEvent().default).dispatchFromMouseEvent(this._target,event);
	},
	pointerTrigger_target_touchTapHandler: function(event) {
		if(!this._enabled) {
			return;
		}
		if(event.isPrimaryTouchPoint) {
			return;
		}
		if(this._customHitTest != null && !this._customHitTest(event.stageX,event.stageY)) {
			return;
		}
		if(this._eventFactory != null) {
			this._target.dispatchEvent(this._eventFactory());
			return;
		}
		(feathers_events_TriggerEvent().default).dispatchFromTouchEvent(this._target,event);
	}
};
PointerTrigger.prototype.__class__ = PointerTrigger.prototype.constructor = $hxClasses["feathers.utils.PointerTrigger"] = PointerTrigger;

// Init



// Statics




// Export

exports["default"] = PointerTrigger;

/***/ }),

/***/ "./lib/_gen/feathers/utils/PopUpUtil.js":
/*!**********************************************!*\
  !*** ./lib/_gen/feathers/utils/PopUpUtil.js ***!
  \**********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.PopUpUtil

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function feathers_core_PopUpManager() {return __webpack_require__(/*! ./../../feathers/core/PopUpManager */ "./lib/_gen/feathers/core/PopUpManager.js");}
function openfl_display_DisplayObjectContainer() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObjectContainer);}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}

// Constructor

var PopUpUtil = function(){}

// Meta

PopUpUtil.__name__ = "feathers.utils.PopUpUtil";
PopUpUtil.__isInterface__ = false;
PopUpUtil.prototype = {
	
};
PopUpUtil.prototype.__class__ = PopUpUtil.prototype.constructor = $hxClasses["feathers.utils.PopUpUtil"] = PopUpUtil;

// Init



// Statics

PopUpUtil.isTopLevelPopUpOrIsContainedByTopLevelPopUp = function(target) {
	if(target.stage == null) {
		return false;
	}
	var popUpManager = (feathers_core_PopUpManager().default).forStage(target.stage);
	var _g = popUpManager.get_popUpCount() - popUpManager.get_topLevelPopUpCount();
	var _g1 = popUpManager.get_popUpCount();
	while(_g < _g1) {
		var i = _g++;
		var popUp = popUpManager.getPopUpAt(i);
		if(target == popUp) {
			return true;
		}
		if(((popUp) instanceof (openfl_display_DisplayObjectContainer()))) {
			var popUpContainer = (js_Boot().default).__cast(popUp , (openfl_display_DisplayObjectContainer()));
			if(popUpContainer.contains(target)) {
				return true;
			}
		}
	}
	return false;
}


// Export

exports["default"] = PopUpUtil;

/***/ }),

/***/ "./lib/_gen/feathers/utils/ScaleUtil.js":
/*!**********************************************!*\
  !*** ./lib/_gen/feathers/utils/ScaleUtil.js ***!
  \**********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.ScaleUtil

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function openfl_geom_Rectangle() {return (__webpack_require__(/*! openfl */ "openfl").geom.Rectangle);}

// Constructor

var ScaleUtil = function(){}

// Meta

ScaleUtil.__name__ = "feathers.utils.ScaleUtil";
ScaleUtil.__isInterface__ = false;
ScaleUtil.prototype = {
	
};
ScaleUtil.prototype.__class__ = ScaleUtil.prototype.constructor = $hxClasses["feathers.utils.ScaleUtil"] = ScaleUtil;

// Init



// Statics

ScaleUtil.fitRectangle = function(original,into,result) {
	var width = original.width;
	var height = original.height;
	var intoWidth = into.width;
	var intoHeight = into.height;
	var scale = ScaleUtil.scaleToFit(width,height,intoWidth,intoHeight);
	if(result == null) {
		result = new (openfl_geom_Rectangle())();
	}
	var resultWidth = width * scale;
	var resultHeight = height * scale;
	result.width = resultWidth;
	result.height = resultHeight;
	result.x = into.x + (intoWidth - resultWidth) / 2.0;
	result.y = into.y + (intoHeight - resultHeight) / 2.0;
	return result;
}
ScaleUtil.fillRectangle = function(original,into,result) {
	var width = original.width;
	var height = original.height;
	var intoWidth = into.width;
	var intoHeight = into.height;
	var scale = ScaleUtil.scaleToFill(width,height,intoWidth,intoHeight);
	if(result == null) {
		result = new (openfl_geom_Rectangle())();
	}
	var resultWidth = width * scale;
	var resultHeight = height * scale;
	result.width = resultWidth;
	result.height = resultHeight;
	result.x = into.x + (intoWidth - resultWidth) / 2.0;
	result.y = into.y + (intoHeight - resultHeight) / 2.0;
	return result;
}
ScaleUtil.scaleToFit = function(originalWidth,originalHeight,targetWidth,targetHeight) {
	var widthRatio = targetWidth / originalWidth;
	var heightRatio = targetHeight / originalHeight;
	if(widthRatio < heightRatio) {
		return widthRatio;
	}
	return heightRatio;
}
ScaleUtil.scaleToFill = function(originalWidth,originalHeight,targetWidth,targetHeight) {
	var widthRatio = targetWidth / originalWidth;
	var heightRatio = targetHeight / originalHeight;
	if(widthRatio > heightRatio) {
		return widthRatio;
	}
	return heightRatio;
}


// Export

exports["default"] = ScaleUtil;

/***/ }),

/***/ "./lib/_gen/feathers/utils/ScreenDensityScaleCalculator.js":
/*!*****************************************************************!*\
  !*** ./lib/_gen/feathers/utils/ScreenDensityScaleCalculator.js ***!
  \*****************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.ScreenDensityScaleCalculator

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_errors_ArgumentError() {return (__webpack_require__(/*! openfl */ "openfl").errors.ArgumentError);}
function feathers_utils__$ScreenDensityScaleCalculator_ScreenDensityBucket() {return __webpack_require__(/*! ./../../feathers/utils/_ScreenDensityScaleCalculator/ScreenDensityBucket */ "./lib/_gen/feathers/utils/_ScreenDensityScaleCalculator/ScreenDensityBucket.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function openfl_errors_IllegalOperationError() {return (__webpack_require__(/*! openfl */ "openfl").errors.IllegalOperationError);}

// Constructor

var ScreenDensityScaleCalculator = function() {
	this._buckets = [];
}

// Meta

ScreenDensityScaleCalculator.__name__ = "feathers.utils.ScreenDensityScaleCalculator";
ScreenDensityScaleCalculator.__isInterface__ = false;
ScreenDensityScaleCalculator.prototype = {
	addScaleForDensity: function(density,scale) {
		var i = this._buckets.length;
		var _g = 0;
		var _g1 = this._buckets;
		while(_g < _g1.length) {
			var bucket = _g1[_g];
			++_g;
			if(bucket.density > density) {
				break;
			}
			if(bucket.density == density) {
				throw new (js__$Boot_HaxeError().default)(new (openfl_errors_ArgumentError())("Screen density cannot be added more than once: " + density));
			}
		}
		var _this = this._buckets;
		var x = new (feathers_utils__$ScreenDensityScaleCalculator_ScreenDensityBucket().default)(density,scale);
		_this.splice(i,0,x);
	},
	removeScaleForDensity: function(density) {
		var _g = 0;
		var _g1 = this._buckets;
		while(_g < _g1.length) {
			var bucket = _g1[_g];
			++_g;
			if(bucket.density == density) {
				(HxOverrides().default).remove(this._buckets,bucket);
				return;
			}
		}
	},
	getScale: function(density) {
		if(this._buckets.length == 0) {
			throw new (js__$Boot_HaxeError().default)(new (openfl_errors_IllegalOperationError())("Cannot choose scale because none have been added"));
		}
		var bucket = this._buckets[0];
		if(density <= bucket.density) {
			return bucket.scale;
		}
		var previousBucket = bucket;
		var _g = 1;
		var _g1 = this._buckets.length;
		while(_g < _g1) {
			var i = _g++;
			bucket = this._buckets[i];
			if(density > bucket.density) {
				previousBucket = bucket;
				continue;
			}
			var midDPI = (bucket.density + previousBucket.density) / 2.0;
			if(density < midDPI) {
				return previousBucket.scale;
			}
			return bucket.scale;
		}
		return bucket.scale;
	}
};
ScreenDensityScaleCalculator.prototype.__class__ = ScreenDensityScaleCalculator.prototype.constructor = $hxClasses["feathers.utils.ScreenDensityScaleCalculator"] = ScreenDensityScaleCalculator;

// Init



// Statics




// Export

exports["default"] = ScreenDensityScaleCalculator;

/***/ }),

/***/ "./lib/_gen/feathers/utils/Scroller.js":
/*!*********************************************!*\
  !*** ./lib/_gen/feathers/utils/Scroller.js ***!
  \*********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.Scroller

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $bind = (__webpack_require__(/*! ./../../bind_stub */ "./lib/_gen/bind_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function openfl_events_EventDispatcher() {return (__webpack_require__(/*! openfl */ "openfl").events.EventDispatcher);}
function feathers_events_ScrollEvent() {return __webpack_require__(/*! ./../../feathers/events/ScrollEvent */ "./lib/_gen/feathers/events/ScrollEvent.js");}
function js_Boot() {return __webpack_require__(/*! ./../../js/Boot */ "./lib/_gen/js/Boot.js");}
function motion_Actuate() {return (__webpack_require__(/*! motion */ "motion").Actuate);}
function openfl_Lib() {return (__webpack_require__(/*! openfl */ "openfl").Lib);}
function motion_actuators_SimpleActuator() {return (__webpack_require__(/*! motion */ "motion").actuators.SimpleActuator);}
function openfl_display_DisplayObjectContainer() {return (__webpack_require__(/*! openfl */ "openfl").display.DisplayObjectContainer);}
function openfl_display_Stage() {return (__webpack_require__(/*! openfl */ "openfl").display.Stage);}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function motion_easing_Quart() {return (__webpack_require__(/*! motion */ "motion").easing.Quart);}

// Constructor

var Scroller = function(target) {
	this._touchPointIsSimulated = false;
	this._touchPointID = null;
	this._previousTouchPointID = null;
	this.snappingToEdge = false;
	this.targetScrollY = 0.0;
	this.targetScrollX = 0.0;
	this.animateScrollYEndRatio = 1.0;
	this.animateScrollXEndRatio = 1.0;
	this.animateScrollY = null;
	this.animateScrollX = null;
	this.savedScrollMoves = [];
	this.startScrollY = 0.0;
	this.startScrollX = 0.0;
	this.startTouchY = 0.0;
	this.startTouchX = 0.0;
	this.restoreMouseChildren = false;
	this._fixedThrowDuration = 2.996998998998728;
	this._logDecelerationRate = -0.0020020026706730793;
	this.snapPositionsY = null;
	this.snapPositionsX = null;
	this._decelerationRate = 0.998;
	this.simulateTouch = false;
	this.mouseWheelDuration = 0.0;
	this._mouseWheelDeltaMode = 1;
	this.mouseWheelYScrollsX = false;
	this.mouseWheelDeltaY = 10.0;
	this.mouseWheelDeltaX = 10.0;
	this.bounceEase = null;
	this.ease = (motion_easing_Quart()).easeOut;
	this.elasticSnapDuration = 0.5;
	this.throwElasticity = 0.05;
	this.elasticity = 0.33;
	this.forceElasticLeft = false;
	this.forceElasticBottom = false;
	this.forceElasticRight = false;
	this.forceElasticTop = false;
	this.elasticEdges = true;
	this.minDragDistance = 6.0;
	this._draggingY = false;
	this._draggingX = false;
	this._scrolling = false;
	this._contentHeight = 0.0;
	this._contentWidth = 0.0;
	this._visibleHeight = 0.0;
	this._visibleWidth = 0.0;
	this._maxScrollY = 0.0;
	this._maxScrollX = 0.0;
	this._minScrollY = 0.0;
	this._minScrollX = 0.0;
	this._scrollY = 0.0;
	this._scrollX = 0.0;
	this.enabledY = true;
	this.enabledX = true;
	(openfl_events_EventDispatcher()).call(this);
	this.set_target(target);
}

// Meta

Scroller.__name__ = "feathers.utils.Scroller";
Scroller.__isInterface__ = false;
Scroller.__super__ = (openfl_events_EventDispatcher());
Scroller.prototype = $extend((openfl_events_EventDispatcher()).prototype, {
	get_scrollX: function() {
		return this._scrollX;
	},
	set_scrollX: function(value) {
		if(this._scrollX == value) {
			return this._scrollX;
		}
		this._scrollX = value;
		(feathers_events_ScrollEvent().default).dispatch(this,"scroll",false,false,this._scrollX,this._scrollY);
		return this._scrollX;
	},
	get_scrollY: function() {
		return this._scrollY;
	},
	set_scrollY: function(value) {
		if(this._scrollY == value) {
			return this._scrollY;
		}
		this._scrollY = value;
		(feathers_events_ScrollEvent().default).dispatch(this,"scroll",false,false,this._scrollX,this._scrollY);
		return this._scrollY;
	},
	get_restrictedScrollX: function() {
		return this._scrollX;
	},
	set_restrictedScrollX: function(value) {
		if(value < this._minScrollX) {
			value = this._minScrollX;
		} else if(value > this._maxScrollX) {
			value = this._maxScrollX;
		}
		if(this._scrollX == value) {
			return this._scrollX;
		}
		this._scrollX = value;
		(feathers_events_ScrollEvent().default).dispatch(this,"scroll",false,false,this._scrollX,this._scrollY);
		return this._scrollX;
	},
	get_restrictedScrollY: function() {
		return this._scrollY;
	},
	set_restrictedScrollY: function(value) {
		if(value < this._minScrollY) {
			value = this._minScrollY;
		} else if(value > this._maxScrollY) {
			value = this._maxScrollY;
		}
		if(this._scrollY == value) {
			return this._scrollY;
		}
		this._scrollY = value;
		(feathers_events_ScrollEvent().default).dispatch(this,"scroll",false,false,this._scrollX,this._scrollY);
		return this._scrollY;
	},
	get_minScrollX: function() {
		return this._minScrollX;
	},
	get_minScrollY: function() {
		return this._minScrollY;
	},
	get_maxScrollX: function() {
		return this._maxScrollX;
	},
	get_maxScrollY: function() {
		return this._maxScrollY;
	},
	get_visibleWidth: function() {
		return this._visibleWidth;
	},
	get_visibleHeight: function() {
		return this._visibleHeight;
	},
	get_contentWidth: function() {
		return this._contentWidth;
	},
	get_contentHeight: function() {
		return this._contentHeight;
	},
	get_scrolling: function() {
		return this._scrolling;
	},
	get_draggingX: function() {
		return this._draggingX;
	},
	get_draggingY: function() {
		return this._draggingY;
	},
	get_decelerationRate: function() {
		return this._decelerationRate;
	},
	set_decelerationRate: function(value) {
		if(this._decelerationRate == value) {
			return this._decelerationRate;
		}
		this._decelerationRate = value;
		this._logDecelerationRate = Math.log(this._decelerationRate);
		this._fixedThrowDuration = -0.1 / Math.log(Math.pow(this._decelerationRate,16.6666666666666679));
		return this._decelerationRate;
	},
	get_target: function() {
		return this._target;
	},
	set_target: function(value) {
		if(this._target == value) {
			return this._target;
		}
		if(this._target != null) {
			this.cleanupAfterDrag();
			this._target.removeEventListener("removedFromStage",$bind(this,this.scroller_target_removedFromStageHandler));
			this._target.removeEventListener("mouseDown",$bind(this,this.scroller_target_mouseDownHandler));
			this._target.removeEventListener("mouseDown",$bind(this,this.scroller_target_mouseDownCaptureHandler),true);
			this._target.removeEventListener("mouseWheel",$bind(this,this.scroller_target_mouseWheelHandler));
			var $window = (js_Boot().default).__cast($global , Window);
			$window.removeEventListener("wheel",$bind(this,this.scroller_window_wheelCaptureHandler),{ capture : true});
			this._target.removeEventListener("touchBegin",$bind(this,this.scroller_target_touchBeginHandler));
			this._target.removeEventListener("touchBegin",$bind(this,this.scroller_target_touchBeginCaptureHandler),true);
			this._target.removeEventListener("click",$bind(this,this.scroller_target_clickCaptureHandler),true);
			this._target.removeEventListener("touchTap",$bind(this,this.scroller_target_touchTapCaptureHandler),true);
		}
		this._target = value;
		if(this._target != null) {
			this._target.addEventListener("mouseDown",$bind(this,this.scroller_target_mouseDownHandler),false,0,true);
			this._target.addEventListener("mouseDown",$bind(this,this.scroller_target_mouseDownCaptureHandler),true,0,true);
			this._target.addEventListener("mouseWheel",$bind(this,this.scroller_target_mouseWheelHandler),false,0,true);
			var window1 = (js_Boot().default).__cast($global , Window);
			window1.addEventListener("wheel",$bind(this,this.scroller_window_wheelCaptureHandler),{ capture : true});
			this._target.addEventListener("touchBegin",$bind(this,this.scroller_target_touchBeginHandler),false,0,true);
			this._target.addEventListener("touchBegin",$bind(this,this.scroller_target_touchBeginCaptureHandler),true,0,true);
			this._target.addEventListener("click",$bind(this,this.scroller_target_clickCaptureHandler),true,0,true);
		}
		return this._target;
	},
	get_touchPointID: function() {
		return this._touchPointID;
	},
	get_touchPointIsSimulated: function() {
		return this._touchPointIsSimulated;
	},
	setDimensions: function(visibleWidth,visibleHeight,contentWidth,contentHeight) {
		this._visibleWidth = visibleWidth != null ? visibleWidth : 0.0;
		this._visibleHeight = visibleHeight != null ? visibleHeight : 0.0;
		this._contentWidth = contentWidth != null ? contentWidth : 0.0;
		this._contentHeight = contentHeight != null ? contentHeight : 0.0;
		this.calculateMinAndMax();
	},
	applyScrollRestrictions: function() {
		var scrollChanged = false;
		if(this._scrollX < this._minScrollX) {
			this._scrollX = this._minScrollX;
			scrollChanged = true;
		} else if(this._scrollX > this._maxScrollX) {
			this._scrollX = this._maxScrollX;
			scrollChanged = true;
		}
		if(this._scrollY < this._minScrollY) {
			this._scrollY = this._minScrollY;
			scrollChanged = true;
		} else if(this._scrollY > this._maxScrollY) {
			this._scrollY = this._maxScrollY;
			scrollChanged = true;
		}
		if(scrollChanged) {
			(feathers_events_ScrollEvent().default).dispatch(this,"scroll",false,false,this._scrollX,this._scrollY);
		}
	},
	stop: function() {
		if(this.animateScrollX != null) {
			(motion_Actuate()).stop(this.animateScrollX,null,false,false);
			this.animateScrollX = null;
		}
		if(this.animateScrollY != null) {
			(motion_Actuate()).stop(this.animateScrollY,null,false,false);
			this.animateScrollY = null;
		}
		this.cleanupAfterDrag();
		this._draggingX = false;
		this._draggingY = false;
		this.completeScroll();
	},
	applyLayoutShift: function(x,y) {
		if(x != null) {
			var animateScrollX = this.animateScrollX;
			this.animateScrollX = null;
			if(animateScrollX != null) {
				(motion_Actuate()).stop(animateScrollX,null,false,false);
			}
			this.startScrollX += x;
			var _g = this;
			_g.set_scrollX(_g.get_scrollX() + x);
			var i = 0;
			while(i < this.savedScrollMoves.length) {
				this.savedScrollMoves[i] += x;
				i += 3;
			}
			if(animateScrollX != null) {
				var newTargetScrollX = this.targetScrollX + x;
				var position = (openfl_Lib()).getTimer() / 1000.0 - animateScrollX.startTime;
				var newDuration = animateScrollX.duration - position;
				this.throwTo(newTargetScrollX,null,newDuration,animateScrollX._ease);
			}
		}
		if(y != null) {
			var animateScrollY = this.animateScrollY;
			this.animateScrollY = null;
			if(animateScrollY != null) {
				(motion_Actuate()).stop(animateScrollY,null,false,false);
			}
			this.startScrollY += y;
			var _g1 = this;
			_g1.set_scrollY(_g1.get_scrollY() + y);
			var i1 = 1;
			while(i1 < this.savedScrollMoves.length) {
				this.savedScrollMoves[i1] += y;
				i1 += 3;
			}
			if(animateScrollY != null) {
				var newTargetScrollY = this.targetScrollY + y;
				var position1 = (openfl_Lib()).getTimer() / 1000.0 - animateScrollY.startTime;
				var newDuration1 = animateScrollY.duration - position1;
				this.throwTo(null,newTargetScrollY,newDuration1,animateScrollY._ease);
			}
		}
	},
	throwTo: function(scrollX,scrollY,duration,ease) {
		var _gthis = this;
		if(duration == null) {
			duration = this._fixedThrowDuration;
		}
		if(ease == null) {
			ease = this.ease;
		}
		var scrollChanged = false;
		if(scrollX != null) {
			if(this.animateScrollX != null) {
				(motion_Actuate()).stop(this.animateScrollX,null,false,false);
				this.animateScrollX = null;
			}
			if(this._scrollX != scrollX) {
				scrollChanged = true;
				this.startScroll();
				if(duration == 0.0) {
					this.set_scrollX(scrollX);
				} else {
					this.startScrollX = this._scrollX;
					this.targetScrollX = scrollX;
					var tween = (motion_Actuate()).update(function(scrollX1) {
						if(scrollX1 == null) {
							scrollX1 = _gthis.targetScrollX;
						}
						return _gthis.set_scrollX(scrollX1);
					},duration,[this._scrollX],[this.targetScrollX],true);
					this.animateScrollX = (js_Boot().default).__cast(tween , (motion_actuators_SimpleActuator()));
					this.animateScrollX.ease(ease);
					this.animateScrollX.onComplete($bind(this,this.animateScrollX_onComplete));
					this.refreshAnimateScrollXEndRatio();
				}
			} else {
				this.finishScrollX();
			}
		}
		if(scrollY != null) {
			if(this.animateScrollY != null) {
				(motion_Actuate()).stop(this.animateScrollY,null,false,false);
				this.animateScrollY = null;
			}
			if(this._scrollY != scrollY) {
				scrollChanged = true;
				this.startScroll();
				if(duration == 0.0) {
					this.set_scrollY(scrollY);
				} else {
					this.startScrollY = this._scrollY;
					this.targetScrollY = scrollY;
					var tween1 = (motion_Actuate()).update(function(scrollY1) {
						if(scrollY1 == null) {
							scrollY1 = _gthis.targetScrollY;
						}
						return _gthis.set_scrollY(scrollY1);
					},duration,[this._scrollY],[this.targetScrollY],true);
					this.animateScrollY = (js_Boot().default).__cast(tween1 , (motion_actuators_SimpleActuator()));
					this.animateScrollY.ease(ease);
					this.animateScrollY.onComplete($bind(this,this.animateScrollY_onComplete));
					this.refreshAnimateScrollYEndRatio();
				}
			} else {
				this.finishScrollY();
			}
		}
		if(scrollChanged && duration == 0.0) {
			this.completeScroll();
		}
	},
	throwWithVelocity: function(velocityX,velocityY) {
		var targetX = null;
		var targetY = null;
		if(velocityX != null) {
			if(Math.abs(velocityX) <= Scroller.MINIMUM_VELOCITY) {
				this.finishScrollX();
			} else if(this.snapPositionsX != null) {
				var _g = 0;
				var _g1 = this.snapPositionsX.length;
				while(_g < _g1) {
					var i = _g++;
					var posX = this.snapPositionsX[i];
					if(velocityX < 0.0) {
						targetX = posX;
						if(posX > this._scrollX) {
							break;
						}
					}
					if(velocityX > 0.0) {
						targetX = i == 0 ? posX : this.snapPositionsX[i - 1];
						if(posX >= this._scrollX) {
							break;
						}
					}
				}
			} else {
				targetX = this._scrollX + this.calculateDistanceFromVelocity(velocityX);
			}
		}
		if(velocityY != null) {
			if(Math.abs(velocityY) <= Scroller.MINIMUM_VELOCITY) {
				this.finishScrollY();
			} else if(this.snapPositionsY != null) {
				var _g2 = 0;
				var _g11 = this.snapPositionsY.length;
				while(_g2 < _g11) {
					var i1 = _g2++;
					var posY = this.snapPositionsY[i1];
					if(velocityY < 0.0) {
						targetY = posY;
						if(posY > this._scrollY) {
							break;
						}
					}
					if(velocityY > 0.0) {
						targetY = i1 == 0 ? posY : this.snapPositionsY[i1 - 1];
						if(posY >= this._scrollY) {
							break;
						}
					}
				}
			} else {
				targetY = this._scrollY + this.calculateDistanceFromVelocity(velocityY);
			}
		}
		this.throwTo(targetX,targetY,this._fixedThrowDuration);
	},
	calculateDistanceFromVelocity: function(velocity) {
		return (velocity - Scroller.MINIMUM_VELOCITY) / this._logDecelerationRate;
	},
	refreshAnimateScrollXEndRatio: function() {
		var distance = Math.abs(this.targetScrollX - this.startScrollX);
		var ratioOutOfBounds = 0.0;
		if(this.targetScrollX > this._maxScrollX) {
			ratioOutOfBounds = (this.targetScrollX - this._maxScrollX) / distance;
		} else if(this.targetScrollX < this._minScrollX) {
			ratioOutOfBounds = (this._minScrollX - this.targetScrollX) / distance;
		}
		if(ratioOutOfBounds > 0.0) {
			if(this.elasticEdges) {
				this.animateScrollXEndRatio = 1.0 - ratioOutOfBounds + ratioOutOfBounds * this.throwElasticity;
			} else {
				this.animateScrollXEndRatio = 1.0 - ratioOutOfBounds;
			}
		} else {
			this.animateScrollXEndRatio = 1.0;
		}
		if(this.animateScrollX != null) {
			if(this.animateScrollXEndRatio < 1.0) {
				this.animateScrollX.onUpdate($bind(this,this.animateScrollX_endRatio_onUpdate));
			} else {
				this.animateScrollX.onUpdate(null);
			}
		}
	},
	refreshAnimateScrollYEndRatio: function() {
		var distance = Math.abs(this.targetScrollY - this.startScrollY);
		var ratioOutOfBounds = 0.0;
		if(this.targetScrollY > this._maxScrollY) {
			ratioOutOfBounds = (this.targetScrollY - this._maxScrollY) / distance;
		} else if(this.targetScrollY < this._minScrollY) {
			ratioOutOfBounds = (this._minScrollY - this.targetScrollY) / distance;
		}
		if(ratioOutOfBounds > 0.0) {
			if(this.elasticEdges) {
				this.animateScrollYEndRatio = 1.0 - ratioOutOfBounds + ratioOutOfBounds * this.throwElasticity;
			} else {
				this.animateScrollYEndRatio = 1.0 - ratioOutOfBounds;
			}
		} else {
			this.animateScrollYEndRatio = 1.0;
		}
		if(this.animateScrollY != null) {
			if(this.animateScrollYEndRatio < 1.0) {
				this.animateScrollY.onUpdate($bind(this,this.animateScrollY_endRatio_onUpdate));
			} else {
				this.animateScrollY.onUpdate(null);
			}
		}
	},
	calculateMinAndMax: function() {
		var oldMinScrollX = this._minScrollX;
		var oldMaxScrollX = this._maxScrollX;
		var oldMinScrollY = this._minScrollY;
		var oldMaxScrollY = this._maxScrollY;
		this._minScrollX = 0.0;
		this._minScrollY = 0.0;
		this._maxScrollX = Math.max(this._contentWidth,this._visibleWidth) - this._visibleWidth;
		this._maxScrollY = Math.max(this._contentHeight,this._visibleHeight) - this._visibleHeight;
		if(oldMinScrollX != this._minScrollX || oldMaxScrollX != this._maxScrollX) {
			this.refreshAnimateScrollXEndRatio();
		}
		if(oldMinScrollY != this._minScrollY || oldMaxScrollY != this._maxScrollY) {
			this.refreshAnimateScrollYEndRatio();
		}
	},
	startScroll: function() {
		if(this._scrolling) {
			return;
		}
		this._scrolling = true;
		if(((this._target) instanceof (openfl_display_DisplayObjectContainer()))) {
			var container = (js_Boot().default).__cast(this._target , (openfl_display_DisplayObjectContainer()));
			this.restoreMouseChildren = container.mouseChildren;
			container.mouseChildren = false;
		}
		(feathers_events_ScrollEvent().default).dispatch(this,"scrollStart",false,false,this._scrollX,this._scrollY);
	},
	completeScroll: function() {
		if(!this._scrolling || this._draggingX || this._draggingY || this.animateScrollX != null || this.animateScrollY != null) {
			return;
		}
		this._scrolling = false;
		if(((this._target) instanceof (openfl_display_DisplayObjectContainer()))) {
			var container = (js_Boot().default).__cast(this._target , (openfl_display_DisplayObjectContainer()));
			container.mouseChildren = this.restoreMouseChildren;
		}
		(feathers_events_ScrollEvent().default).dispatch(this,"scrollComplete",false,false,this._scrollX,this._scrollY);
	},
	finishScrollX: function() {
		this._draggingX = false;
		var targetScrollX = null;
		if(this.snapPositionsX != null) {
			var minOffsetX = Infinity;
			var _g = 0;
			var _g1 = this.snapPositionsX;
			while(_g < _g1.length) {
				var snapX = _g1[_g];
				++_g;
				var offsetX = Math.abs(snapX - this._scrollX);
				if(minOffsetX > offsetX) {
					minOffsetX = offsetX;
					targetScrollX = snapX;
				}
			}
			if(targetScrollX == this._scrollX) {
				targetScrollX = null;
			}
		}
		if(this._scrollX < this._minScrollX) {
			targetScrollX = this._minScrollX;
		} else if(this._scrollX > this._maxScrollX) {
			targetScrollX = this._maxScrollX;
		}
		if(targetScrollX == null) {
			this.completeScroll();
		} else {
			var duration = Math.abs(this._scrollX - targetScrollX) >= 1.0 ? this.elasticSnapDuration : 0.0;
			this.throwTo(targetScrollX,null,duration,this.bounceEase);
		}
	},
	finishScrollY: function() {
		this._draggingY = false;
		var targetScrollY = null;
		if(this.snapPositionsY != null) {
			var minOffsetY = Infinity;
			var _g = 0;
			var _g1 = this.snapPositionsY;
			while(_g < _g1.length) {
				var snapY = _g1[_g];
				++_g;
				var offsetY = Math.abs(snapY - this._scrollY);
				if(minOffsetY > offsetY) {
					minOffsetY = offsetY;
					targetScrollY = snapY;
				}
			}
			if(targetScrollY == this._scrollY) {
				targetScrollY = null;
			}
		}
		if(this._scrollY < this._minScrollY) {
			targetScrollY = this._minScrollY;
		} else if(this._scrollY > this._maxScrollY) {
			targetScrollY = this._maxScrollY;
		}
		if(targetScrollY == null) {
			this.completeScroll();
		} else {
			var duration = Math.abs(this._scrollY - targetScrollY) >= 1.0 ? this.elasticSnapDuration : 0.0;
			this.throwTo(null,targetScrollY,duration,this.bounceEase);
		}
	},
	animateScrollX_endRatio_onUpdate: function() {
		var time = (openfl_Lib()).getTimer() / 1000.0;
		var currentTime = time - this.animateScrollX.startTime;
		var ratio = currentTime / this.animateScrollX.duration;
		var ease = this.animateScrollX._ease;
		if(ease != null) {
			ratio = ease.calculate(ratio);
		}
		if(ratio >= this.animateScrollXEndRatio && currentTime < this.animateScrollX.duration) {
			if(!this.elasticEdges) {
				if(this._scrollX < this._minScrollX) {
					this.set_scrollX(this._minScrollX);
				} else if(this._scrollX > this._maxScrollX) {
					this.set_scrollX(this._maxScrollX);
				}
			}
			(motion_Actuate()).stop(this.animateScrollX,null,false,false);
			this.animateScrollX = null;
			this.finishScrollX();
			return;
		}
	},
	animateScrollX_onComplete: function() {
		this.animateScrollX = null;
		this.finishScrollX();
	},
	animateScrollY_endRatio_onUpdate: function() {
		var time = (openfl_Lib()).getTimer() / 1000.0;
		var currentTime = time - this.animateScrollY.startTime;
		var ratio = currentTime / this.animateScrollY.duration;
		var ease = this.animateScrollY._ease;
		if(ease != null) {
			ratio = ease.calculate(ratio);
		}
		if(ratio >= this.animateScrollYEndRatio && currentTime < this.animateScrollY.duration) {
			if(!this.elasticEdges) {
				if(this._scrollY < this._minScrollY) {
					this.set_scrollY(this._minScrollY);
				} else if(this._scrollY > this._maxScrollY) {
					this.set_scrollY(this._maxScrollY);
				}
			}
			(motion_Actuate()).stop(this.animateScrollY,null,false,false);
			this.animateScrollY = null;
			this.finishScrollY();
			return;
		}
	},
	animateScrollY_onComplete: function() {
		this.animateScrollY = null;
		this.finishScrollY();
	},
	cleanupAfterDrag: function() {
		if(this._touchPointID == null) {
			return;
		}
		this._previousTouchPointID = this._scrolling ? this._touchPointID : null;
		this._touchPointID = null;
		this._touchPointIsSimulated = false;
		this._target.removeEventListener("removedFromStage",$bind(this,this.scroller_target_removedFromStageHandler));
		if(this._target.stage != null) {
			this._target.stage.removeEventListener("mouseMove",$bind(this,this.scroller_target_stage_mouseMoveHandler));
			this._target.stage.removeEventListener("mouseUp",$bind(this,this.scroller_target_stage_mouseUpHandler));
			this._target.stage.removeEventListener("touchMove",$bind(this,this.scroller_target_stage_touchMoveHandler));
			this._target.stage.removeEventListener("touchEnd",$bind(this,this.scroller_target_stage_touchEndHandler));
		}
	},
	scroller_target_removedFromStageHandler: function(event) {
		this.cleanupAfterDrag();
	},
	touchBegin: function(touchPointID,simulatedTouch,stageX,stageY) {
		if(simulatedTouch && !this.simulateTouch) {
			return;
		}
		if(this._touchPointID != null) {
			return;
		}
		if(this.animateScrollX != null) {
			(motion_Actuate()).stop(this.animateScrollX,null,false,false);
			this.animateScrollX = null;
		}
		if(this.animateScrollY != null) {
			(motion_Actuate()).stop(this.animateScrollY,null,false,false);
			this.animateScrollY = null;
		}
		this._target.addEventListener("removedFromStage",$bind(this,this.scroller_target_removedFromStageHandler),false,0,true);
		this._target.stage.addEventListener("mouseMove",$bind(this,this.scroller_target_stage_mouseMoveHandler),false,0,true);
		this._target.stage.addEventListener("mouseUp",$bind(this,this.scroller_target_stage_mouseUpHandler),false,0,true);
		this._target.stage.addEventListener("touchMove",$bind(this,this.scroller_target_stage_touchMoveHandler),false,0,true);
		this._target.stage.addEventListener("touchEnd",$bind(this,this.scroller_target_stage_touchEndHandler),false,0,true);
		if(((this._target) instanceof (openfl_display_DisplayObjectContainer()))) {
			var container = (js_Boot().default).__cast(this._target , (openfl_display_DisplayObjectContainer()));
			if(this._scrolling) {
				container.mouseChildren = false;
			}
		}
		this._previousTouchPointID = null;
		this._touchPointID = touchPointID;
		this._touchPointIsSimulated = simulatedTouch;
		this.startTouchX = stageX;
		this.startTouchY = stageY;
		this.startScrollX = this._scrollX;
		this.startScrollY = this._scrollY;
		this.savedScrollMoves.length = 0;
	},
	touchMove: function(touchPointID,simulatedTouch,stageX,stageY) {
		if(this._touchPointID == null) {
			return;
		}
		if(this._touchPointID != touchPointID) {
			return;
		}
		if(this._touchPointIsSimulated != simulatedTouch) {
			return;
		}
		var touchOffsetX = stageX - this.startTouchX;
		var touchOffsetY = stageY - this.startTouchY;
		var scaleX = 1.0;
		var scaleY = 1.0;
		var current = this._target;
		while(current != current.stage) {
			scaleX /= current.get_scaleX();
			scaleY /= current.get_scaleY();
			current = current.parent;
		}
		touchOffsetX *= scaleX;
		touchOffsetY *= scaleY;
		var canDragX = this.canDragX();
		var canDragY = this.canDragY();
		if(!this._draggingX && canDragX && Math.abs(touchOffsetX) > this.minDragDistance) {
			this.startTouchX = stageX;
			touchOffsetX = 0.0;
			this._draggingX = true;
			if(!this._draggingY) {
				this.startScroll();
				if(this._touchPointID == null) {
					return;
				}
			}
		}
		if(!this._draggingY && canDragY && Math.abs(touchOffsetY) > this.minDragDistance) {
			this.startTouchY = stageY;
			touchOffsetY = 0.0;
			this._draggingY = true;
			if(!this._draggingX) {
				this.startScroll();
				if(this._touchPointID == null) {
					return;
				}
			}
		}
		if(!this._draggingX && !this._draggingY) {
			return;
		}
		var scrollX = this.startScrollX;
		if(canDragX) {
			scrollX -= touchOffsetX;
			if(this.elasticEdges) {
				var minElasticScrollX = this._minScrollX;
				if(minElasticScrollX > this.startScrollX) {
					minElasticScrollX = this.startScrollX;
				}
				var maxElasticScrollX = this._maxScrollX;
				if(maxElasticScrollX < this.startScrollX) {
					maxElasticScrollX = this.startScrollX;
				}
				if(scrollX < this._minScrollX) {
					if(this._maxScrollX > this._minScrollX || this.forceElasticLeft) {
						scrollX -= (scrollX - minElasticScrollX) * (1.0 - this.elasticity);
					} else {
						scrollX = this._minScrollX;
					}
				} else if(scrollX > this._maxScrollX) {
					if(this._maxScrollX > this._minScrollX || this.forceElasticRight) {
						scrollX -= (scrollX - maxElasticScrollX) * (1.0 - this.elasticity);
					} else {
						scrollX = this._maxScrollX;
					}
				}
			} else if(scrollX < this._minScrollX) {
				scrollX = this._minScrollX;
			} else if(scrollX > this._maxScrollX) {
				scrollX = this._maxScrollX;
			}
		}
		var scrollY = this.startScrollY;
		if(canDragY) {
			scrollY -= touchOffsetY;
			if(this.elasticEdges) {
				var minElasticScrollY = this._minScrollY;
				if(minElasticScrollY > this.startScrollY) {
					minElasticScrollY = this.startScrollY;
				}
				var maxElasticScrollY = this._maxScrollY;
				if(maxElasticScrollY < this.startScrollY) {
					maxElasticScrollY = this.startScrollY;
				}
				if(scrollY < this._minScrollY) {
					if(this._maxScrollY > this._minScrollY || this.forceElasticTop) {
						scrollY -= (scrollY - minElasticScrollY) * (1.0 - this.elasticity);
					} else {
						scrollY = this._minScrollY;
					}
				} else if(scrollY > this._maxScrollY) {
					if(this._maxScrollY > this._minScrollY || this.forceElasticBottom) {
						scrollY -= (scrollY - maxElasticScrollY) * (1.0 - this.elasticity);
					} else {
						scrollY = this._maxScrollY;
					}
				}
			} else if(scrollY < this._minScrollY) {
				scrollY = this._minScrollY;
			} else if(scrollY > this._maxScrollY) {
				scrollY = this._maxScrollY;
			}
		}
		this.set_scrollX(scrollX);
		this.set_scrollY(scrollY);
		if(this.savedScrollMoves.length > 60) {
			this.savedScrollMoves.length = 30;
		}
		this.savedScrollMoves.push(scrollX);
		this.savedScrollMoves.push(scrollY);
		this.savedScrollMoves.push((openfl_Lib()).getTimer());
	},
	touchEnd: function(touchPointID,simulatedTouch) {
		if(this._touchPointID == null) {
			return;
		}
		if(this._touchPointID != touchPointID) {
			return;
		}
		if(this._touchPointIsSimulated != simulatedTouch) {
			return;
		}
		this.cleanupAfterDrag();
		var finishingX = !this.canDragX();
		var finishingY = !this.canDragY();
		if(this._scrollX < this._minScrollX || this._scrollX > this._maxScrollX) {
			finishingX = true;
			this.finishScrollX();
		}
		if(this._scrollY < this._minScrollY || this._scrollY > this._maxScrollY) {
			finishingY = true;
			this.finishScrollY();
		}
		if(finishingX && finishingY) {
			return;
		}
		if(!this._draggingX && !this._draggingY) {
			return;
		}
		var targetTime = (openfl_Lib()).getTimer() - 100;
		var endIndex = this.savedScrollMoves.length - 1;
		var startIndex = endIndex;
		var i = endIndex;
		while(endIndex > 0 && this.savedScrollMoves[i] > targetTime) {
			startIndex = i;
			i -= 3;
		}
		if(startIndex == endIndex) {
			if(!finishingX && this._draggingX) {
				this.finishScrollX();
			}
			if(!finishingY && this._draggingY) {
				this.finishScrollY();
			}
			return;
		}
		var timeOffset = this.savedScrollMoves[endIndex] - this.savedScrollMoves[startIndex];
		var velocityX = null;
		var velocityY = null;
		if(timeOffset > 0.0) {
			if(!finishingX && this._draggingX) {
				var movedX = this._scrollX - this.savedScrollMoves[startIndex - 2];
				velocityX = -movedX / timeOffset;
			}
			if(!finishingY && this._draggingY) {
				var movedY = this._scrollY - this.savedScrollMoves[startIndex - 1];
				velocityY = -movedY / timeOffset;
			}
		}
		if(velocityX != null || velocityY != null) {
			this.throwWithVelocity(velocityX,velocityY);
		}
		if(velocityX == null && this._draggingX) {
			this.finishScrollX();
		}
		if(velocityY == null && this._draggingY) {
			this.finishScrollY();
		}
	},
	canDragX: function() {
		if(this.enabledX) {
			if(!(this._maxScrollX > this._minScrollX || this.forceElasticLeft)) {
				return this.forceElasticRight;
			} else {
				return true;
			}
		} else {
			return false;
		}
	},
	canDragY: function() {
		if(this.enabledY) {
			if(!(this._maxScrollY > this._minScrollY || this.forceElasticTop)) {
				return this.forceElasticBottom;
			} else {
				return true;
			}
		} else {
			return false;
		}
	},
	scroller_target_touchBeginCaptureHandler: function(event) {
		if(!this._scrolling) {
			return;
		}
		event.stopImmediatePropagation();
		this.scroller_target_touchBeginHandler(event);
	},
	scroller_target_touchBeginHandler: function(event) {
		if(this.simulateTouch && event.isPrimaryTouchPoint) {
			return;
		}
		this.touchBegin(event.touchPointID,false,event.stageX,event.stageY);
	},
	scroller_target_mouseDownCaptureHandler: function(event) {
		if(!this._scrolling) {
			return;
		}
		event.stopImmediatePropagation();
		this.scroller_target_mouseDownHandler(event);
	},
	scroller_target_mouseDownHandler: function(event) {
		var stage = this._target.stage;
		if(stage == null) {
			return;
		}
		this.touchBegin(Scroller.POINTER_ID_MOUSE,true,stage.get_mouseX(),stage.get_mouseY());
	},
	scroller_target_stage_touchMoveHandler: function(event) {
		this.touchMove(event.touchPointID,false,event.stageX,event.stageY);
	},
	scroller_target_stage_mouseMoveHandler: function(event) {
		var stage = (js_Boot().default).__cast(event.currentTarget , (openfl_display_Stage()));
		this.touchMove(Scroller.POINTER_ID_MOUSE,true,stage.get_mouseX(),stage.get_mouseY());
	},
	scroller_target_stage_touchEndHandler: function(event) {
		this.touchEnd(event.touchPointID,false);
	},
	scroller_target_clickCaptureHandler: function(event) {
		if(this._previousTouchPointID == null) {
			return;
		}
		this._previousTouchPointID = null;
		event.stopImmediatePropagation();
	},
	scroller_target_touchTapCaptureHandler: function(event) {
		if(this._previousTouchPointID == null || this._previousTouchPointID != event.touchPointID) {
			return;
		}
		if(event.isPrimaryTouchPoint) {
			this._previousTouchPointID = Scroller.POINTER_ID_MOUSE;
			return;
		}
		this._previousTouchPointID = null;
		event.stopImmediatePropagation();
	},
	scroller_target_stage_mouseUpHandler: function(event) {
		this.touchEnd(Scroller.POINTER_ID_MOUSE,true);
	},
	scroller_window_wheelCaptureHandler: function(event) {
		this._mouseWheelDeltaMode = event.deltaMode;
	},
	scroller_target_mouseWheelHandler: function(event) {
		if(this._scrolling) {
			event.stopImmediatePropagation();
			this.stop();
		}
		var deltaLines = event.delta;
		switch(this._mouseWheelDeltaMode) {
		case 0:
			if(deltaLines < 0) {
				deltaLines = (Std().default).int(Math.min(-1.0,deltaLines / 40));
			} else {
				deltaLines = (Std().default).int(Math.max(1.0,deltaLines / 40));
			}
			break;
		case 2:
			deltaLines *= 16;
			break;
		}
		var newScrollX = null;
		var newScrollY = null;
		if(this.mouseWheelYScrollsX) {
			var targetScrollX = this._scrollX;
			if(this.animateScrollX != null) {
				targetScrollX = this.targetScrollX;
			}
			newScrollX = targetScrollX - deltaLines * this.mouseWheelDeltaX;
			if(newScrollX < this._minScrollX) {
				newScrollX = this._minScrollX;
			} else if(newScrollX > this._maxScrollX) {
				newScrollX = this._maxScrollX;
			}
		} else {
			var targetScrollY = this._scrollY;
			if(this.animateScrollY != null) {
				targetScrollY = this.targetScrollY;
			}
			newScrollY = targetScrollY - deltaLines * this.mouseWheelDeltaY;
			if(newScrollY < this._minScrollY) {
				newScrollY = this._minScrollY;
			} else if(newScrollY > this._maxScrollY) {
				newScrollY = this._maxScrollY;
			}
		}
		if((newScrollX == null || newScrollX == this._scrollX) && (newScrollY == null || newScrollY == this._scrollY)) {
			return;
		}
		event.preventDefault();
		if(!this._scrolling) {
			event.stopImmediatePropagation();
			this.stop();
		}
		if(newScrollX != null) {
			this._draggingX = true;
		}
		if(newScrollY != null) {
			this._draggingY = true;
		}
		if(this.mouseWheelDuration > 0.0) {
			this.throwTo(newScrollX,newScrollY,this.mouseWheelDuration,this.ease);
		} else {
			this.startScroll();
			if(newScrollX != null) {
				this.set_scrollX(newScrollX);
			}
			if(newScrollY != null) {
				this.set_scrollY(newScrollY);
			}
			this._draggingX = false;
			this._draggingY = false;
			this.completeScroll();
		}
	}
});
Scroller.prototype.__class__ = Scroller.prototype.constructor = $hxClasses["feathers.utils.Scroller"] = Scroller;

// Init



// Statics


Scroller.MINIMUM_VELOCITY = 0.02
Scroller.POINTER_ID_MOUSE = -1000

// Export

exports["default"] = Scroller;

/***/ }),

/***/ "./lib/_gen/feathers/utils/TextFormatUtil.js":
/*!***************************************************!*\
  !*** ./lib/_gen/feathers/utils/TextFormatUtil.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils.TextFormatUtil

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function openfl_text_TextFormat() {return (__webpack_require__(/*! openfl */ "openfl").text.TextFormat);}

// Constructor

var TextFormatUtil = function(){}

// Meta

TextFormatUtil.__name__ = "feathers.utils.TextFormatUtil";
TextFormatUtil.__isInterface__ = false;
TextFormatUtil.prototype = {
	
};
TextFormatUtil.prototype.__class__ = TextFormatUtil.prototype.constructor = $hxClasses["feathers.utils.TextFormatUtil"] = TextFormatUtil;

// Init



// Statics

TextFormatUtil.clone = function(original) {
	var clone = new (openfl_text_TextFormat())(original.font,original.size,original.color,original.bold,original.italic,original.underline,original.url,original.target,original.align,original.leftMargin,original.rightMargin,original.indent,original.leading);
	clone.blockIndent = original.blockIndent;
	clone.bullet = original.bullet;
	clone.kerning = original.kerning;
	clone.letterSpacing = original.letterSpacing;
	clone.tabStops = original.tabStops;
	return clone;
}


// Export

exports["default"] = TextFormatUtil;

/***/ }),

/***/ "./lib/_gen/feathers/utils/_Path2EReg/Token.js":
/*!*****************************************************!*\
  !*** ./lib/_gen/feathers/utils/_Path2EReg/Token.js ***!
  \*****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: feathers.utils._Path2EReg.Token

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../../../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var Token = $hxEnums["feathers.utils._Path2EReg.Token"] = { __ename__ : "feathers.utils._Path2EReg.Token", __constructs__ : ["Static","Capture"]
  ,Static: ($_=function(token) { return {_hx_index:0,token:token,__enum__:"feathers.utils._Path2EReg.Token",toString:$estr}; },$_.__params__ = ["token"],$_)
  ,Capture: ($_=function(key) { return {_hx_index:1,key:key,__enum__:"feathers.utils._Path2EReg.Token",toString:$estr}; },$_.__params__ = ["key"],$_)
};

exports["default"] = Token;

/***/ }),

/***/ "./lib/_gen/feathers/utils/_ScreenDensityScaleCalculator/ScreenDensityBucket.js":
/*!**************************************************************************************!*\
  !*** ./lib/_gen/feathers/utils/_ScreenDensityScaleCalculator/ScreenDensityBucket.js ***!
  \**************************************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: feathers.utils._ScreenDensityScaleCalculator.ScreenDensityBucket

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var ScreenDensityBucket = function(density,scale) {
	this.density = density;
	this.scale = scale;
}

// Meta

ScreenDensityBucket.__name__ = "feathers.utils._ScreenDensityScaleCalculator.ScreenDensityBucket";
ScreenDensityBucket.__isInterface__ = false;
ScreenDensityBucket.prototype = {
	
};
ScreenDensityBucket.prototype.__class__ = ScreenDensityBucket.prototype.constructor = $hxClasses["feathers.utils._ScreenDensityScaleCalculator.ScreenDensityBucket"] = ScreenDensityBucket;

// Init



// Statics




// Export

exports["default"] = ScreenDensityBucket;

/***/ }),

/***/ "./lib/_gen/haxe/CallStack.js":
/*!************************************!*\
  !*** ./lib/_gen/haxe/CallStack.js ***!
  \************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: haxe.CallStack

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function HxOverrides() {return __webpack_require__(/*! ./../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function haxe_StackItem() {return __webpack_require__(/*! ./../haxe/StackItem */ "./lib/_gen/haxe/StackItem.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function StringBuf() {return __webpack_require__(/*! ./../StringBuf */ "./lib/_gen/StringBuf.js");}
function EReg() {return __webpack_require__(/*! ./../EReg */ "./lib/_gen/EReg.js");}
function Std() {return __webpack_require__(/*! ./../Std */ "./lib/_gen/Std.js");}
function StringTools() {return __webpack_require__(/*! ./../StringTools */ "./lib/_gen/StringTools.js");}

// Constructor

var CallStack = function(){}

// Meta

CallStack.__name__ = "haxe.CallStack";
CallStack.__isInterface__ = false;
CallStack.prototype = {
	
};
CallStack.prototype.__class__ = CallStack.prototype.constructor = $hxClasses["haxe.CallStack"] = CallStack;

// Init



// Statics

CallStack.getStack = function(e) {
	if(e == null) {
		return [];
	}
	var oldValue = Error.prepareStackTrace;
	Error.prepareStackTrace = function(error,callsites) {
		var stack = [];
		var _g = 0;
		while(_g < callsites.length) {
			var site = callsites[_g];
			++_g;
			if(CallStack.wrapCallSite != null) {
				site = CallStack.wrapCallSite(site);
			}
			var method = null;
			var fullName = site.getFunctionName();
			if(fullName != null) {
				var idx = fullName.lastIndexOf(".");
				if(idx >= 0) {
					var className = (HxOverrides().default).substr(fullName,0,idx);
					var methodName = (HxOverrides().default).substr(fullName,idx + 1,null);
					method = (haxe_StackItem().default).Method(className,methodName);
				}
			}
			var fileName = site.getFileName();
			var fileAddr = fileName == null ? -1 : fileName.indexOf("file:");
			if(CallStack.wrapCallSite != null && fileAddr > 0) {
				fileName = (HxOverrides().default).substr(fileName,fileAddr + 6,null);
			}
			stack.push((haxe_StackItem().default).FilePos(method,fileName,site.getLineNumber(),site.getColumnNumber()));
		}
		return stack;
	};
	var a = CallStack.makeStack(e.stack);
	Error.prepareStackTrace = oldValue;
	return a;
}
CallStack.callStack = function() {
	try {
		throw new Error();
	} catch( e ) {
		CallStack.lastException = e;
		var e1 = ((e) instanceof (js__$Boot_HaxeError().default)) ? e.val : e;
		var a = CallStack.getStack(e);
		a.shift();
		return a;
	}
}
CallStack.exceptionStack = function() {
	return CallStack.getStack(CallStack.lastException);
}
CallStack.toString = function(stack) {
	var b = new (StringBuf().default)();
	var _g = 0;
	while(_g < stack.length) {
		var s = stack[_g];
		++_g;
		b.add("\nCalled from ");
		CallStack.itemToString(b,s);
	}
	return b.toString();
}
CallStack.itemToString = function(b,s) {
	switch(s._hx_index) {
	case 0:
		b.add("a C function");
		break;
	case 1:
		var m = s.m;
		b.add("module ");
		b.add(m);
		break;
	case 2:
		var col = s.column;
		var line = s.line;
		var file = s.file;
		var s1 = s.s;
		if(s1 != null) {
			CallStack.itemToString(b,s1);
			b.add(" (");
		}
		b.add(file);
		b.add(" line ");
		b.add(line);
		if(col != null) {
			b.add(" column ");
			b.add(col);
		}
		if(s1 != null) {
			b.add(")");
		}
		break;
	case 3:
		var meth = s.method;
		var cname = s.classname;
		b.add(cname == null ? "<unknown>" : cname);
		b.add(".");
		b.add(meth);
		break;
	case 4:
		var n = s.v;
		b.add("local function #");
		b.add(n);
		break;
	}
}
CallStack.makeStack = function(s) {
	if(s == null) {
		return [];
	} else if(typeof(s) == "string") {
		var stack = s.split("\n");
		if(stack[0] == "Error") {
			stack.shift();
		}
		var m = [];
		var rie10 = new (EReg().default)("^   at ([A-Za-z0-9_. ]+) \\(([^)]+):([0-9]+):([0-9]+)\\)$","");
		var _g = 0;
		while(_g < stack.length) {
			var line = stack[_g];
			++_g;
			if(rie10.match(line)) {
				var path = rie10.matched(1).split(".");
				var meth = path.pop();
				var file = rie10.matched(2);
				var line1 = (Std().default).parseInt(rie10.matched(3));
				var column = (Std().default).parseInt(rie10.matched(4));
				m.push((haxe_StackItem().default).FilePos(meth == "Anonymous function" ? (haxe_StackItem().default).LocalFunction() : meth == "Global code" ? null : (haxe_StackItem().default).Method(path.join("."),meth),file,line1,column));
			} else {
				m.push((haxe_StackItem().default).Module((StringTools().default).trim(line)));
			}
		}
		return m;
	} else {
		return s;
	}
}


// Export

exports["default"] = CallStack;

/***/ }),

/***/ "./lib/_gen/haxe/IMap.js":
/*!*******************************!*\
  !*** ./lib/_gen/haxe/IMap.js ***!
  \*******************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: haxe.IMap

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var IMap = function() {}

// Meta

IMap.__name__ = "haxe.IMap";
IMap.__isInterface__ = true;
IMap.prototype = {
	
};
IMap.prototype.__class__ = IMap.prototype.constructor = $hxClasses["haxe.IMap"] = IMap;

// Init



// Statics




// Export

exports["default"] = IMap;

/***/ }),

/***/ "./lib/_gen/haxe/StackItem.js":
/*!************************************!*\
  !*** ./lib/_gen/haxe/StackItem.js ***!
  \************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Enum: haxe.StackItem

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

// Imports

var $estr = (__webpack_require__(/*! ./../estr_stub */ "./lib/_gen/estr_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Definition

var StackItem = $hxEnums["haxe.StackItem"] = { __ename__ : "haxe.StackItem", __constructs__ : ["CFunction","Module","FilePos","Method","LocalFunction"]
  ,Module: ($_=function(m) { return {_hx_index:1,m:m,__enum__:"haxe.StackItem",toString:$estr}; },$_.__params__ = ["m"],$_)
  ,Method: ($_=function(classname,method) { return {_hx_index:3,classname:classname,method:method,__enum__:"haxe.StackItem",toString:$estr}; },$_.__params__ = ["classname","method"],$_)
  ,LocalFunction: ($_=function(v) { return {_hx_index:4,v:v,__enum__:"haxe.StackItem",toString:$estr}; },$_.__params__ = ["v"],$_)
  ,FilePos: ($_=function(s,file,line,column) { return {_hx_index:2,s:s,file:file,line:line,column:column,__enum__:"haxe.StackItem",toString:$estr}; },$_.__params__ = ["s","file","line","column"],$_)
  ,CFunction: {_hx_index:0,__enum__:"haxe.StackItem",toString:$estr}
};

exports["default"] = StackItem;

/***/ }),

/***/ "./lib/_gen/haxe/ds/BalancedTree.js":
/*!******************************************!*\
  !*** ./lib/_gen/haxe/ds/BalancedTree.js ***!
  \******************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: haxe.ds.BalancedTree

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function haxe_IMap() {return __webpack_require__(/*! ./../../haxe/IMap */ "./lib/_gen/haxe/IMap.js");}
function haxe_CallStack() {return __webpack_require__(/*! ./../../haxe/CallStack */ "./lib/_gen/haxe/CallStack.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function haxe_ds_TreeNode() {return __webpack_require__(/*! ./../../haxe/ds/TreeNode */ "./lib/_gen/haxe/ds/TreeNode.js");}
function Reflect() {return __webpack_require__(/*! ./../../Reflect */ "./lib/_gen/Reflect.js");}

// Constructor

var BalancedTree = function() {
}

// Meta

BalancedTree.__name__ = "haxe.ds.BalancedTree";
BalancedTree.__isInterface__ = false;
BalancedTree.__interfaces__ = [(haxe_IMap().default)];
BalancedTree.prototype = {
	set: function(key,value) {
		this.root = this.setLoop(key,value,this.root);
	},
	get: function(key) {
		var node = this.root;
		while(node != null) {
			var c = this.compare(key,node.key);
			if(c == 0) {
				return node.value;
			}
			if(c < 0) {
				node = node.left;
			} else {
				node = node.right;
			}
		}
		return null;
	},
	remove: function(key) {
		try {
			this.root = this.removeLoop(key,this.root);
			return true;
		} catch( e ) {
			(haxe_CallStack().default).lastException = e;
			var e1 = ((e) instanceof (js__$Boot_HaxeError().default)) ? e.val : e;
			if(typeof(e1) == "string") {
				var e2 = e1;
				return false;
			} else {
				throw e;
			}
		}
	},
	exists: function(key) {
		var node = this.root;
		while(node != null) {
			var c = this.compare(key,node.key);
			if(c == 0) {
				return true;
			} else if(c < 0) {
				node = node.left;
			} else {
				node = node.right;
			}
		}
		return false;
	},
	keys: function() {
		var ret = [];
		this.keysLoop(this.root,ret);
		return (HxOverrides().default).iter(ret);
	},
	setLoop: function(k,v,node) {
		if(node == null) {
			return new (haxe_ds_TreeNode().default)(null,k,v,null);
		}
		var c = this.compare(k,node.key);
		if(c == 0) {
			return new (haxe_ds_TreeNode().default)(node.left,k,v,node.right,node == null ? 0 : node._height);
		} else if(c < 0) {
			var nl = this.setLoop(k,v,node.left);
			return this.balance(nl,node.key,node.value,node.right);
		} else {
			var nr = this.setLoop(k,v,node.right);
			return this.balance(node.left,node.key,node.value,nr);
		}
	},
	removeLoop: function(k,node) {
		if(node == null) {
			throw new (js__$Boot_HaxeError().default)("Not_found");
		}
		var c = this.compare(k,node.key);
		if(c == 0) {
			return this.merge(node.left,node.right);
		} else if(c < 0) {
			return this.balance(this.removeLoop(k,node.left),node.key,node.value,node.right);
		} else {
			return this.balance(node.left,node.key,node.value,this.removeLoop(k,node.right));
		}
	},
	keysLoop: function(node,acc) {
		if(node != null) {
			this.keysLoop(node.left,acc);
			acc.push(node.key);
			this.keysLoop(node.right,acc);
		}
	},
	merge: function(t1,t2) {
		if(t1 == null) {
			return t2;
		}
		if(t2 == null) {
			return t1;
		}
		var t = this.minBinding(t2);
		return this.balance(t1,t.key,t.value,this.removeMinBinding(t2));
	},
	minBinding: function(t) {
		if(t == null) {
			throw new (js__$Boot_HaxeError().default)("Not_found");
		} else if(t.left == null) {
			return t;
		} else {
			return this.minBinding(t.left);
		}
	},
	removeMinBinding: function(t) {
		if(t.left == null) {
			return t.right;
		} else {
			return this.balance(this.removeMinBinding(t.left),t.key,t.value,t.right);
		}
	},
	balance: function(l,k,v,r) {
		var hl = l == null ? 0 : l._height;
		var hr = r == null ? 0 : r._height;
		if(hl > hr + 2) {
			var _this = l.left;
			var _this1 = l.right;
			if((_this == null ? 0 : _this._height) >= (_this1 == null ? 0 : _this1._height)) {
				return new (haxe_ds_TreeNode().default)(l.left,l.key,l.value,new (haxe_ds_TreeNode().default)(l.right,k,v,r));
			} else {
				return new (haxe_ds_TreeNode().default)(new (haxe_ds_TreeNode().default)(l.left,l.key,l.value,l.right.left),l.right.key,l.right.value,new (haxe_ds_TreeNode().default)(l.right.right,k,v,r));
			}
		} else if(hr > hl + 2) {
			var _this2 = r.right;
			var _this3 = r.left;
			if((_this2 == null ? 0 : _this2._height) > (_this3 == null ? 0 : _this3._height)) {
				return new (haxe_ds_TreeNode().default)(new (haxe_ds_TreeNode().default)(l,k,v,r.left),r.key,r.value,r.right);
			} else {
				return new (haxe_ds_TreeNode().default)(new (haxe_ds_TreeNode().default)(l,k,v,r.left.left),r.left.key,r.left.value,new (haxe_ds_TreeNode().default)(r.left.right,r.key,r.value,r.right));
			}
		} else {
			return new (haxe_ds_TreeNode().default)(l,k,v,r,(hl > hr ? hl : hr) + 1);
		}
	},
	compare: function(k1,k2) {
		return (Reflect().default).compare(k1,k2);
	},
	clear: function() {
		this.root = null;
	}
};
BalancedTree.prototype.__class__ = BalancedTree.prototype.constructor = $hxClasses["haxe.ds.BalancedTree"] = BalancedTree;

// Init



// Statics




// Export

exports["default"] = BalancedTree;

/***/ }),

/***/ "./lib/_gen/haxe/ds/EnumValueMap.js":
/*!******************************************!*\
  !*** ./lib/_gen/haxe/ds/EnumValueMap.js ***!
  \******************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: haxe.ds.EnumValueMap

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);
function haxe_IMap() {return __webpack_require__(/*! ./../../haxe/IMap */ "./lib/_gen/haxe/IMap.js");}
function haxe_ds_BalancedTree() {return __webpack_require__(/*! ./../../haxe/ds/BalancedTree */ "./lib/_gen/haxe/ds/BalancedTree.js");}
function Type() {return __webpack_require__(/*! ./../../Type */ "./lib/_gen/Type.js");}
function Reflect() {return __webpack_require__(/*! ./../../Reflect */ "./lib/_gen/Reflect.js");}

// Constructor

var EnumValueMap = function() {
	(haxe_ds_BalancedTree().default).call(this);
}

// Meta

EnumValueMap.__name__ = "haxe.ds.EnumValueMap";
EnumValueMap.__isInterface__ = false;
EnumValueMap.__interfaces__ = [(haxe_IMap().default)];
EnumValueMap.__super__ = (haxe_ds_BalancedTree().default);
EnumValueMap.prototype = $extend((haxe_ds_BalancedTree().default).prototype, {
	compare: function(k1,k2) {
		var d = (Type().default).enumIndex(k1) - (Type().default).enumIndex(k2);
		if(d != 0) {
			return d;
		}
		var p1 = (Type().default).enumParameters(k1);
		var p2 = (Type().default).enumParameters(k2);
		if(p1.length == 0 && p2.length == 0) {
			return 0;
		}
		return this.compareArgs(p1,p2);
	},
	compareArgs: function(a1,a2) {
		var ld = a1.length - a2.length;
		if(ld != 0) {
			return ld;
		}
		var _g = 0;
		var _g1 = a1.length;
		while(_g < _g1) {
			var i = _g++;
			var d = this.compareArg(a1[i],a2[i]);
			if(d != 0) {
				return d;
			}
		}
		return 0;
	},
	compareArg: function(v1,v2) {
		if((Reflect().default).isEnumValue(v1) && (Reflect().default).isEnumValue(v2)) {
			return this.compare(v1,v2);
		} else if(((v1) instanceof Array) && ((v2) instanceof Array)) {
			return this.compareArgs(v1,v2);
		} else {
			return (Reflect().default).compare(v1,v2);
		}
	}
});
EnumValueMap.prototype.__class__ = EnumValueMap.prototype.constructor = $hxClasses["haxe.ds.EnumValueMap"] = EnumValueMap;

// Init



// Statics




// Export

exports["default"] = EnumValueMap;

/***/ }),

/***/ "./lib/_gen/haxe/ds/IntMap.js":
/*!************************************!*\
  !*** ./lib/_gen/haxe/ds/IntMap.js ***!
  \************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: haxe.ds.IntMap

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function haxe_IMap() {return __webpack_require__(/*! ./../../haxe/IMap */ "./lib/_gen/haxe/IMap.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function haxe_iterators_MapKeyValueIterator() {return __webpack_require__(/*! ./../../haxe/iterators/MapKeyValueIterator */ "./lib/_gen/haxe/iterators/MapKeyValueIterator.js");}

// Constructor

var IntMap = function() {
	this.h = { };
}

// Meta

IntMap.__name__ = "haxe.ds.IntMap";
IntMap.__isInterface__ = false;
IntMap.__interfaces__ = [(haxe_IMap().default)];
IntMap.prototype = {
	set: function(key,value) {
		this.h[key] = value;
	},
	get: function(key) {
		return this.h[key];
	},
	exists: function(key) {
		return this.h.hasOwnProperty(key);
	},
	remove: function(key) {
		if(!this.h.hasOwnProperty(key)) {
			return false;
		}
		delete(this.h[key]);
		return true;
	},
	keys: function() {
		var a = [];
		for( var key in this.h ) this.h.hasOwnProperty(key) ? a.push(key | 0) : null;
		return (HxOverrides().default).iter(a);
	},
	iterator: function() {
		return { ref : this.h, it : this.keys(), hasNext : function() {
			return this.it.hasNext();
		}, next : function() {
			var i = this.it.next();
			return this.ref[i];
		}};
	},
	keyValueIterator: function() {
		return new (haxe_iterators_MapKeyValueIterator().default)(this);
	}
};
IntMap.prototype.__class__ = IntMap.prototype.constructor = $hxClasses["haxe.ds.IntMap"] = IntMap;

// Init



// Statics




// Export

exports["default"] = IntMap;

/***/ }),

/***/ "./lib/_gen/haxe/ds/List.js":
/*!**********************************!*\
  !*** ./lib/_gen/haxe/ds/List.js ***!
  \**********************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: haxe.ds.List

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function haxe_ds__$List_ListNode() {return __webpack_require__(/*! ./../../haxe/ds/_List/ListNode */ "./lib/_gen/haxe/ds/_List/ListNode.js");}
function haxe_ds__$List_ListIterator() {return __webpack_require__(/*! ./../../haxe/ds/_List/ListIterator */ "./lib/_gen/haxe/ds/_List/ListIterator.js");}

// Constructor

var List = function() {
	this.length = 0;
}

// Meta

List.__name__ = "haxe.ds.List";
List.__isInterface__ = false;
List.prototype = {
	add: function(item) {
		var x = new (haxe_ds__$List_ListNode().default)(item,null);
		if(this.h == null) {
			this.h = x;
		} else {
			this.q.next = x;
		}
		this.q = x;
		this.length++;
	},
	push: function(item) {
		var x = new (haxe_ds__$List_ListNode().default)(item,this.h);
		this.h = x;
		if(this.q == null) {
			this.q = x;
		}
		this.length++;
	},
	pop: function() {
		if(this.h == null) {
			return null;
		}
		var x = this.h.item;
		this.h = this.h.next;
		if(this.h == null) {
			this.q = null;
		}
		this.length--;
		return x;
	},
	clear: function() {
		this.h = null;
		this.q = null;
		this.length = 0;
	},
	remove: function(v) {
		var prev = null;
		var l = this.h;
		while(l != null) {
			if(l.item == v) {
				if(prev == null) {
					this.h = l.next;
				} else {
					prev.next = l.next;
				}
				if(this.q == l) {
					this.q = prev;
				}
				this.length--;
				return true;
			}
			prev = l;
			l = l.next;
		}
		return false;
	},
	iterator: function() {
		return new (haxe_ds__$List_ListIterator().default)(this.h);
	}
};
List.prototype.__class__ = List.prototype.constructor = $hxClasses["haxe.ds.List"] = List;

// Init



// Statics




// Export

exports["default"] = List;

/***/ }),

/***/ "./lib/_gen/haxe/ds/ObjectMap.js":
/*!***************************************!*\
  !*** ./lib/_gen/haxe/ds/ObjectMap.js ***!
  \***************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: haxe.ds.ObjectMap

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function haxe_IMap() {return __webpack_require__(/*! ./../../haxe/IMap */ "./lib/_gen/haxe/IMap.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function haxe_iterators_MapKeyValueIterator() {return __webpack_require__(/*! ./../../haxe/iterators/MapKeyValueIterator */ "./lib/_gen/haxe/iterators/MapKeyValueIterator.js");}
function js_Lib() {return __webpack_require__(/*! ./../../js/Lib */ "./lib/_gen/js/Lib.js");}

// Constructor

var ObjectMap = function() {
	this.h = { __keys__ : { }};
}

// Meta

ObjectMap.__name__ = "haxe.ds.ObjectMap";
ObjectMap.__isInterface__ = false;
ObjectMap.__interfaces__ = [(haxe_IMap().default)];
ObjectMap.prototype = {
	set: function(key,value) {
		var id = ObjectMap.getId(key) || ObjectMap.assignId(key);
		this.h[id] = value;
		this.h.__keys__[id] = key;
	},
	get: function(key) {
		return this.h[ObjectMap.getId(key)];
	},
	exists: function(key) {
		return this.h.__keys__[ObjectMap.getId(key)] != null;
	},
	remove: function(key) {
		var id = ObjectMap.getId(key);
		if(this.h.__keys__[id] == null) {
			return false;
		}
		delete(this.h[id]);
		delete(this.h.__keys__[id]);
		return true;
	},
	keys: function() {
		var a = [];
		for( var key in this.h.__keys__ ) {
		if(this.h.hasOwnProperty(key)) {
			a.push(this.h.__keys__[key]);
		}
		}
		return (HxOverrides().default).iter(a);
	},
	iterator: function() {
		return { ref : this.h, it : this.keys(), hasNext : function() {
			return this.it.hasNext();
		}, next : function() {
			var i = this.it.next();
			return this.ref[ObjectMap.getId(i)];
		}};
	},
	keyValueIterator: function() {
		return new (haxe_iterators_MapKeyValueIterator().default)(this);
	}
};
ObjectMap.prototype.__class__ = ObjectMap.prototype.constructor = $hxClasses["haxe.ds.ObjectMap"] = ObjectMap;

// Init

ObjectMap.count = 0;

// Statics

ObjectMap.assignId = function(obj) {
	return (obj.__id__ = (js_Lib().default).getNextHaxeUID());
}
ObjectMap.getId = function(obj) {
	return obj.__id__;
}


// Export

exports["default"] = ObjectMap;

/***/ }),

/***/ "./lib/_gen/haxe/ds/StringMap.js":
/*!***************************************!*\
  !*** ./lib/_gen/haxe/ds/StringMap.js ***!
  \***************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: haxe.ds.StringMap

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function haxe_IMap() {return __webpack_require__(/*! ./../../haxe/IMap */ "./lib/_gen/haxe/IMap.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}
function haxe_ds__$StringMap_StringMapIterator() {return __webpack_require__(/*! ./../../haxe/ds/_StringMap/StringMapIterator */ "./lib/_gen/haxe/ds/_StringMap/StringMapIterator.js");}
function haxe_iterators_MapKeyValueIterator() {return __webpack_require__(/*! ./../../haxe/iterators/MapKeyValueIterator */ "./lib/_gen/haxe/iterators/MapKeyValueIterator.js");}

// Constructor

var StringMap = function() {
	this.h = { };
}

// Meta

StringMap.__name__ = "haxe.ds.StringMap";
StringMap.__isInterface__ = false;
StringMap.__interfaces__ = [(haxe_IMap().default)];
StringMap.prototype = {
	isReserved: function(key) {
		return __map_reserved[key] != null;
	},
	set: function(key,value) {
		if(this.isReserved(key)) {
			this.setReserved(key,value);
		} else {
			this.h[key] = value;
		}
	},
	get: function(key) {
		if(this.isReserved(key)) {
			return this.getReserved(key);
		}
		return this.h[key];
	},
	exists: function(key) {
		if(this.isReserved(key)) {
			return this.existsReserved(key);
		}
		return this.h.hasOwnProperty(key);
	},
	setReserved: function(key,value) {
		if(this.rh == null) {
			this.rh = { };
		}
		this.rh["$" + key] = value;
	},
	getReserved: function(key) {
		if(this.rh == null) {
			return null;
		} else {
			return this.rh["$" + key];
		}
	},
	existsReserved: function(key) {
		if(this.rh == null) {
			return false;
		}
		return this.rh.hasOwnProperty("$" + key);
	},
	remove: function(key) {
		if(this.isReserved(key)) {
			key = "$" + key;
			if(this.rh == null || !this.rh.hasOwnProperty(key)) {
				return false;
			}
			delete(this.rh[key]);
			return true;
		} else {
			if(!this.h.hasOwnProperty(key)) {
				return false;
			}
			delete(this.h[key]);
			return true;
		}
	},
	keys: function() {
		return (HxOverrides().default).iter(this.arrayKeys());
	},
	arrayKeys: function() {
		var out = [];
		for( var key in this.h ) {
		if(this.h.hasOwnProperty(key)) {
			out.push(key);
		}
		}
		if(this.rh != null) {
			for( var key in this.rh ) {
			if(key.charCodeAt(0) == 36) {
				out.push(key.substr(1));
			}
			}
		}
		return out;
	},
	iterator: function() {
		return new (haxe_ds__$StringMap_StringMapIterator().default)(this,this.arrayKeys());
	},
	keyValueIterator: function() {
		return new (haxe_iterators_MapKeyValueIterator().default)(this);
	},
	clear: function() {
		this.h = { };
		this.rh = null;
	}
};
StringMap.prototype.__class__ = StringMap.prototype.constructor = $hxClasses["haxe.ds.StringMap"] = StringMap;

// Init

var __map_reserved = {};;

// Statics




// Export

exports["default"] = StringMap;

/***/ }),

/***/ "./lib/_gen/haxe/ds/TreeNode.js":
/*!**************************************!*\
  !*** ./lib/_gen/haxe/ds/TreeNode.js ***!
  \**************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: haxe.ds.TreeNode

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var TreeNode = function(l,k,v,r,h) {
	if(h == null) {
		h = -1;
	}
	this.left = l;
	this.key = k;
	this.value = v;
	this.right = r;
	if(h == -1) {
		var tmp;
		var _this = this.left;
		var _this1 = this.right;
		if((_this == null ? 0 : _this._height) > (_this1 == null ? 0 : _this1._height)) {
			var _this2 = this.left;
			tmp = _this2 == null ? 0 : _this2._height;
		} else {
			var _this3 = this.right;
			tmp = _this3 == null ? 0 : _this3._height;
		}
		this._height = tmp + 1;
	} else {
		this._height = h;
	}
}

// Meta

TreeNode.__name__ = "haxe.ds.TreeNode";
TreeNode.__isInterface__ = false;
TreeNode.prototype = {
	
};
TreeNode.prototype.__class__ = TreeNode.prototype.constructor = $hxClasses["haxe.ds.TreeNode"] = TreeNode;

// Init



// Statics




// Export

exports["default"] = TreeNode;

/***/ }),

/***/ "./lib/_gen/haxe/ds/_List/ListIterator.js":
/*!************************************************!*\
  !*** ./lib/_gen/haxe/ds/_List/ListIterator.js ***!
  \************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: haxe.ds._List.ListIterator

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var ListIterator = function(head) {
	this.head = head;
}

// Meta

ListIterator.__name__ = "haxe.ds._List.ListIterator";
ListIterator.__isInterface__ = false;
ListIterator.prototype = {
	hasNext: function() {
		return this.head != null;
	},
	next: function() {
		var val = this.head.item;
		this.head = this.head.next;
		return val;
	}
};
ListIterator.prototype.__class__ = ListIterator.prototype.constructor = $hxClasses["haxe.ds._List.ListIterator"] = ListIterator;

// Init



// Statics




// Export

exports["default"] = ListIterator;

/***/ }),

/***/ "./lib/_gen/haxe/ds/_List/ListNode.js":
/*!********************************************!*\
  !*** ./lib/_gen/haxe/ds/_List/ListNode.js ***!
  \********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: haxe.ds._List.ListNode

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var ListNode = function(item,next) {
	this.item = item;
	this.next = next;
}

// Meta

ListNode.__name__ = "haxe.ds._List.ListNode";
ListNode.__isInterface__ = false;
ListNode.prototype = {
	
};
ListNode.prototype.__class__ = ListNode.prototype.constructor = $hxClasses["haxe.ds._List.ListNode"] = ListNode;

// Init



// Statics




// Export

exports["default"] = ListNode;

/***/ }),

/***/ "./lib/_gen/haxe/ds/_StringMap/StringMapIterator.js":
/*!**********************************************************!*\
  !*** ./lib/_gen/haxe/ds/_StringMap/StringMapIterator.js ***!
  \**********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: haxe.ds._StringMap.StringMapIterator

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var StringMapIterator = function(map,keys) {
	this.map = map;
	this.keys = keys;
	this.index = 0;
	this.count = keys.length;
}

// Meta

StringMapIterator.__name__ = "haxe.ds._StringMap.StringMapIterator";
StringMapIterator.__isInterface__ = false;
StringMapIterator.prototype = {
	hasNext: function() {
		return this.index < this.count;
	},
	next: function() {
		return this.map.get(this.keys[this.index++]);
	}
};
StringMapIterator.prototype.__class__ = StringMapIterator.prototype.constructor = $hxClasses["haxe.ds._StringMap.StringMapIterator"] = StringMapIterator;

// Init



// Statics




// Export

exports["default"] = StringMapIterator;

/***/ }),

/***/ "./lib/_gen/haxe/iterators/MapKeyValueIterator.js":
/*!********************************************************!*\
  !*** ./lib/_gen/haxe/iterators/MapKeyValueIterator.js ***!
  \********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: haxe.iterators.MapKeyValueIterator

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var MapKeyValueIterator = function(map) {
	this.map = map;
	this.keys = map.keys();
}

// Meta

MapKeyValueIterator.__name__ = "haxe.iterators.MapKeyValueIterator";
MapKeyValueIterator.__isInterface__ = false;
MapKeyValueIterator.prototype = {
	hasNext: function() {
		return this.keys.hasNext();
	},
	next: function() {
		var key = this.keys.next();
		return { value : this.map.get(key), key : key};
	}
};
MapKeyValueIterator.prototype.__class__ = MapKeyValueIterator.prototype.constructor = $hxClasses["haxe.iterators.MapKeyValueIterator"] = MapKeyValueIterator;

// Init



// Statics




// Export

exports["default"] = MapKeyValueIterator;

/***/ }),

/***/ "./lib/_gen/haxe/iterators/StringIteratorUnicode.js":
/*!**********************************************************!*\
  !*** ./lib/_gen/haxe/iterators/StringIteratorUnicode.js ***!
  \**********************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: haxe.iterators.StringIteratorUnicode

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function StringTools() {return __webpack_require__(/*! ./../../StringTools */ "./lib/_gen/StringTools.js");}

// Constructor

var StringIteratorUnicode = function(s) {
	this.offset = 0;
	this.s = s;
}

// Meta

StringIteratorUnicode.__name__ = "haxe.iterators.StringIteratorUnicode";
StringIteratorUnicode.__isInterface__ = false;
StringIteratorUnicode.prototype = {
	hasNext: function() {
		return this.offset < this.s.length;
	},
	next: function() {
		var c = (StringTools().default).utf16CodePointAt(this.s,this.offset++);
		if(c >= 65536) {
			this.offset++;
		}
		return c;
	}
};
StringIteratorUnicode.prototype.__class__ = StringIteratorUnicode.prototype.constructor = $hxClasses["haxe.iterators.StringIteratorUnicode"] = StringIteratorUnicode;

// Init



// Statics




// Export

exports["default"] = StringIteratorUnicode;

/***/ }),

/***/ "./lib/_gen/hxClasses_stub.js":
/*!************************************!*\
  !*** ./lib/_gen/hxClasses_stub.js ***!
  \************************************/
/***/ ((__unused_webpack_module, exports) => {

Object.defineProperty(exports, "__esModule", ({value: true}));

exports["default"] = {
	Enum: {}
};

/***/ }),

/***/ "./lib/_gen/hxEnums_stub.js":
/*!**********************************!*\
  !*** ./lib/_gen/hxEnums_stub.js ***!
  \**********************************/
/***/ ((__unused_webpack_module, exports) => {

Object.defineProperty(exports, "__esModule", ({value: true}));

exports["default"] = {};

/***/ }),

/***/ "./lib/_gen/import_stub.js":
/*!*********************************!*\
  !*** ./lib/_gen/import_stub.js ***!
  \*********************************/
/***/ ((__unused_webpack_module, exports) => {

Object.defineProperty(exports, "__esModule", ({value: true}));

// exports.default = function $import(obj) {
// 	if(obj && obj.__esModule) {
// 		// if(!obj.hasOwnProperty('default')) obj.default = obj;
// 		return obj;
// 	} else { 
// 		var newObj = {};
// 		if (obj != null) {
// 			for (var key in obj) {
// 				if (Object.prototype.hasOwnProperty.call(obj, key))
// 					newObj[key] = obj[key];
// 			}
// 		} 
// 		newObj.default = obj;
// 		return newObj;
// 	}
// }
exports["default"] = function $import(obj) {
	return obj && obj.__esModule ? obj : {default: obj};
}


/***/ }),

/***/ "./lib/_gen/js/Boot.js":
/*!*****************************!*\
  !*** ./lib/_gen/js/Boot.js ***!
  \*****************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: js.Boot

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function haxe_CallStack() {return __webpack_require__(/*! ./../haxe/CallStack */ "./lib/_gen/haxe/CallStack.js");}
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function Std() {return __webpack_require__(/*! ./../Std */ "./lib/_gen/Std.js");}

// Constructor

var Boot = function(){}

// Meta

Boot.__name__ = "js.Boot";
Boot.__isInterface__ = false;
Boot.prototype = {
	
};
Boot.prototype.__class__ = Boot.prototype.constructor = $hxClasses["js.Boot"] = Boot;

// Init

Boot.__toStr = ({ }).toString;

// Statics

Boot.isClass = function(o) {
	return o.__name__;
}
Boot.isInterface = function(o) {
	return o.__isInterface__;
}
Boot.isEnum = function(e) {
	return e.__ename__;
}
Boot.getClass = function(o) {
	if(o == null) {
		return null;
	} else if(((o) instanceof Array)) {
		return Array
	} else {
		var cl = o.__class__;
		if(cl != null) {
			return cl;
		}
		var name = Boot.__nativeClassName(o);
		if(name != null) {
			return Boot.__resolveNativeClass(name);
		}
		return null;
	}
}
Boot.__string_rec = function(o,s) {
	if(o == null) {
		return "null";
	}
	if(s.length >= 5) {
		return "<...>";
	}
	var t = typeof(o);
	if(t == "function" && (Boot.isClass(o) || Boot.isEnum(o))) {
		t = "object";
	}
	switch(t) {
	case "function":
		return "<function>";
	case "object":
		if(o.__enum__) {
			var e = $hxEnums[o.__enum__];
			var n = e.__constructs__[o._hx_index];
			var con = e[n];
			if(con.__params__) {
				s = s + "\t";
				return n + "(" + ((function($this) {
					var $r;
					var _g = [];
					{
						var _g1 = 0;
						var _g2 = con.__params__;
						while(true) {
							if(!(_g1 < _g2.length)) {
								break;
							}
							var p = _g2[_g1];
							_g1 = _g1 + 1;
							_g.push(Boot.__string_rec(o[p],s));
						}
					}
					$r = _g;
					return $r;
				}(this))).join(",") + ")";
			} else {
				return n;
			}
		}
		if(((o) instanceof Array)) {
			var str = "[";
			s += "\t";
			var _g3 = 0;
			var _g11 = o.length;
			while(_g3 < _g11) {
				var i = _g3++;
				str += (i > 0 ? "," : "") + Boot.__string_rec(o[i],s);
			}
			str += "]";
			return str;
		}
		var tostr;
		try {
			tostr = o.toString;
		} catch( e1 ) {
			(haxe_CallStack().default).lastException = e1;
			var e2 = ((e1) instanceof (js__$Boot_HaxeError().default)) ? e1.val : e1;
			return "???";
		}
		if(tostr != null && tostr != Object.toString && typeof(tostr) == "function") {
			var s2 = o.toString();
			if(s2 != "[object Object]") {
				return s2;
			}
		}
		var str1 = "{\n";
		s += "\t";
		var hasp = o.hasOwnProperty != null;
		var k = null;
		for( k in o ) {
		if(hasp && !o.hasOwnProperty(k)) {
			continue;
		}
		if(k == "prototype" || k == "__class__" || k == "__super__" || k == "__interfaces__" || k == "__properties__") {
			continue;
		}
		if(str1.length != 2) {
			str1 += ", \n";
		}
		str1 += s + k + " : " + Boot.__string_rec(o[k],s);
		}
		s = s.substring(1);
		str1 += "\n" + s + "}";
		return str1;
	case "string":
		return o;
	default:
		return String(o);
	}
}
Boot.__interfLoop = function(cc,cl) {
	if(cc == null) {
		return false;
	}
	if(cc == cl) {
		return true;
	}
	if(Object.prototype.hasOwnProperty.call(cc,"__interfaces__")) {
		var intf = cc.__interfaces__;
		var _g = 0;
		var _g1 = intf.length;
		while(_g < _g1) {
			var i = _g++;
			var i1 = intf[i];
			if(i1 == cl || Boot.__interfLoop(i1,cl)) {
				return true;
			}
		}
	}
	return Boot.__interfLoop(cc.__super__,cl);
}
Boot.__instanceof = function(o,cl) {
	if(cl == null) {
		return false;
	}
	switch(cl) {
	case Array:
		return ((o) instanceof Array);
	case $hxClasses["Bool"]:
		return typeof(o) == "boolean";
	case $hxClasses["Dynamic"]:
		return o != null;
	case $hxClasses["Float"]:
		return typeof(o) == "number";
	case $hxClasses["Int"]:
		if(typeof(o) == "number") {
			return ((o | 0) === o);
		} else {
			return false;
		}
		break;
	case String:
		return typeof(o) == "string";
	default:
		if(o != null) {
			if(typeof(cl) == "function") {
				if(Boot.__downcastCheck(o,cl)) {
					return true;
				}
			} else if(typeof(cl) == "object" && Boot.__isNativeObj(cl)) {
				if(((o) instanceof cl)) {
					return true;
				}
			}
		} else {
			return false;
		}
		if(cl == $hxClasses["Class"] ? o.__name__ != null : false) {
			return true;
		}
		if(cl == $hxClasses["Enum"] ? o.__ename__ != null : false) {
			return true;
		}
		return o.__enum__ != null ? $hxEnums[o.__enum__] == cl : false;
	}
}
Boot.__downcastCheck = function(o,cl) {
	if(!((o) instanceof cl)) {
		if(Boot.isInterface(cl)) {
			return Boot.__interfLoop(Boot.getClass(o),cl);
		} else {
			return false;
		}
	} else {
		return true;
	}
}
Boot.__implements = function(o,iface) {
	return Boot.__interfLoop(Boot.getClass(o),iface);
}
Boot.__cast = function(o,t) {
	if(o == null || Boot.__instanceof(o,t)) {
		return o;
	} else {
		throw new (js__$Boot_HaxeError().default)("Cannot cast " + (Std().default).string(o) + " to " + (Std().default).string(t));
	}
}
Boot.__nativeClassName = function(o) {
	var name = Boot.__toStr.call(o).slice(8,-1);
	if(name == "Object" || name == "Function" || name == "Math" || name == "JSON") {
		return null;
	}
	return name;
}
Boot.__isNativeObj = function(o) {
	return Boot.__nativeClassName(o) != null;
}
Boot.__resolveNativeClass = function(name) {
	return $global[name];
}


// Export

exports["default"] = Boot;

/***/ }),

/***/ "./lib/_gen/js/Lib.js":
/*!****************************!*\
  !*** ./lib/_gen/js/Lib.js ***!
  \****************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: js.Lib

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var Lib = function(){}

// Meta

Lib.__name__ = "js.Lib";
Lib.__isInterface__ = false;
Lib.prototype = {
	
};
Lib.prototype.__class__ = Lib.prototype.constructor = $hxClasses["js.Lib"] = Lib;

// Init



// Statics

Lib.get_undefined = function() {
	return undefined;
}
Lib.getNextHaxeUID = function() {
	return $global.$haxeUID++;
}


// Export

exports["default"] = Lib;

/***/ }),

/***/ "./lib/_gen/js/_Boot/HaxeError.js":
/*!****************************************!*\
  !*** ./lib/_gen/js/_Boot/HaxeError.js ***!
  \****************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: js._Boot.HaxeError

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
var $extend = (__webpack_require__(/*! ./../../extend_stub */ "./lib/_gen/extend_stub.js")["default"]);

// Constructor

var HaxeError = function(val) {
	Error.call(this);
	this.val = val;
	if(Error.captureStackTrace) {
		Error.captureStackTrace(this,HaxeError);
	}
}

// Meta

HaxeError.__name__ = "js._Boot.HaxeError";
HaxeError.__isInterface__ = false;
HaxeError.__super__ = Error;
HaxeError.prototype = $extend(Error.prototype, {
	
});
HaxeError.prototype.__class__ = HaxeError.prototype.constructor = $hxClasses["js._Boot.HaxeError"] = HaxeError;

// Init

Object.defineProperty(HaxeError.prototype,"message",{ get : function() {
	return String(this.val);
}});

// Statics

HaxeError.wrap = function(val) {
	if(((val) instanceof Error)) {
		return val;
	} else {
		return new HaxeError(val);
	}
}


// Export

exports["default"] = HaxeError;

/***/ }),

/***/ "./lib/_gen/lime/math/Matrix3.js":
/*!***************************************!*\
  !*** ./lib/_gen/lime/math/Matrix3.js ***!
  \***************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: lime.math.Matrix3

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function lime_math_Vector2() {return __webpack_require__(/*! ./../../lime/math/Vector2 */ "./lib/_gen/lime/math/Vector2.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function lime_math_Rectangle() {return __webpack_require__(/*! ./../../lime/math/Rectangle */ "./lib/_gen/lime/math/Rectangle.js");}

// Constructor

var Matrix3 = function(a,b,c,d,tx,ty) {
	if(ty == null) {
		ty = 0;
	}
	if(tx == null) {
		tx = 0;
	}
	if(d == null) {
		d = 1;
	}
	if(c == null) {
		c = 0;
	}
	if(b == null) {
		b = 0;
	}
	if(a == null) {
		a = 1;
	}
	this.a = a;
	this.b = b;
	this.c = c;
	this.d = d;
	this.tx = tx;
	this.ty = ty;
}

// Meta

Matrix3.__name__ = "lime.math.Matrix3";
Matrix3.__isInterface__ = false;
Matrix3.prototype = {
	clone: function() {
		return new Matrix3(this.a,this.b,this.c,this.d,this.tx,this.ty);
	},
	concat: function(m) {
		var a1 = this.a * m.a + this.b * m.c;
		this.b = this.a * m.b + this.b * m.d;
		this.a = a1;
		var c1 = this.c * m.a + this.d * m.c;
		this.d = this.c * m.b + this.d * m.d;
		this.c = c1;
		var tx1 = this.tx * m.a + this.ty * m.c + m.tx;
		this.ty = this.tx * m.b + this.ty * m.d + m.ty;
		this.tx = tx1;
	},
	copyColumnFrom: function(column,vector4) {
		if(column > 2) {
			throw new (js__$Boot_HaxeError().default)("Column " + column + " out of bounds (2)");
		} else if(column == 0) {
			this.a = vector4.x;
			this.b = vector4.y;
		} else if(column == 1) {
			this.c = vector4.x;
			this.d = vector4.y;
		} else {
			this.tx = vector4.x;
			this.ty = vector4.y;
		}
	},
	copyColumnTo: function(column,vector4) {
		if(column > 2) {
			throw new (js__$Boot_HaxeError().default)("Column " + column + " out of bounds (2)");
		} else if(column == 0) {
			vector4.x = this.a;
			vector4.y = this.b;
			vector4.z = 0;
		} else if(column == 1) {
			vector4.x = this.c;
			vector4.y = this.d;
			vector4.z = 0;
		} else {
			vector4.x = this.tx;
			vector4.y = this.ty;
			vector4.z = 1;
		}
	},
	copyFrom: function(sourceMatrix3) {
		this.a = sourceMatrix3.a;
		this.b = sourceMatrix3.b;
		this.c = sourceMatrix3.c;
		this.d = sourceMatrix3.d;
		this.tx = sourceMatrix3.tx;
		this.ty = sourceMatrix3.ty;
	},
	copyRowFrom: function(row,vector4) {
		if(row > 2) {
			throw new (js__$Boot_HaxeError().default)("Row " + row + " out of bounds (2)");
		} else if(row == 0) {
			this.a = vector4.x;
			this.c = vector4.y;
			this.tx = vector4.z;
		} else if(row == 1) {
			this.b = vector4.x;
			this.d = vector4.y;
			this.ty = vector4.z;
		}
	},
	copyRowTo: function(row,vector4) {
		if(row > 2) {
			throw new (js__$Boot_HaxeError().default)("Row " + row + " out of bounds (2)");
		} else if(row == 0) {
			vector4.x = this.a;
			vector4.y = this.c;
			vector4.z = this.tx;
		} else if(row == 1) {
			vector4.x = this.b;
			vector4.y = this.d;
			vector4.z = this.ty;
		} else {
			vector4.setTo(0,0,1);
		}
	},
	createBox: function(scaleX,scaleY,rotation,tx,ty) {
		if(ty == null) {
			ty = 0;
		}
		if(tx == null) {
			tx = 0;
		}
		if(rotation == null) {
			rotation = 0;
		}
		if(rotation != 0) {
			var cos = Math.cos(rotation);
			var sin = Math.sin(rotation);
			this.a = cos * scaleX;
			this.b = sin * scaleY;
			this.c = -sin * scaleX;
			this.d = cos * scaleY;
		} else {
			this.a = scaleX;
			this.b = 0;
			this.c = 0;
			this.d = scaleY;
		}
		this.tx = tx;
		this.ty = ty;
	},
	createGradientBox: function(width,height,rotation,tx,ty) {
		if(ty == null) {
			ty = 0;
		}
		if(tx == null) {
			tx = 0;
		}
		if(rotation == null) {
			rotation = 0;
		}
		this.a = width / 1638.4;
		this.d = height / 1638.4;
		if(rotation != 0) {
			var cos = Math.cos(rotation);
			var sin = Math.sin(rotation);
			this.b = sin * this.d;
			this.c = -sin * this.a;
			this.a *= cos;
			this.d *= cos;
		} else {
			this.b = 0;
			this.c = 0;
		}
		this.tx = tx + width / 2;
		this.ty = ty + height / 2;
	},
	equals: function(matrix3) {
		if(matrix3 != null && this.tx == matrix3.tx && this.ty == matrix3.ty && this.a == matrix3.a && this.b == matrix3.b && this.c == matrix3.c) {
			return this.d == matrix3.d;
		} else {
			return false;
		}
	},
	deltaTransformVector: function(Vector2,result) {
		if(result == null) {
			result = new (lime_math_Vector2().default)();
		}
		result.x = Vector2.x * this.a + Vector2.y * this.c;
		result.y = Vector2.x * this.b + Vector2.y * this.d;
		return result;
	},
	identity: function() {
		this.a = 1;
		this.b = 0;
		this.c = 0;
		this.d = 1;
		this.tx = 0;
		this.ty = 0;
	},
	invert: function() {
		var norm = this.a * this.d - this.b * this.c;
		if(norm == 0) {
			this.a = this.b = this.c = this.d = 0;
			this.tx = -this.tx;
			this.ty = -this.ty;
		} else {
			norm = 1.0 / norm;
			var a1 = this.d * norm;
			this.d = this.a * norm;
			this.a = a1;
			this.b *= -norm;
			this.c *= -norm;
			var tx1 = -this.a * this.tx - this.c * this.ty;
			this.ty = -this.b * this.tx - this.d * this.ty;
			this.tx = tx1;
		}
		return this;
	},
	rotate: function(theta) {
		var cos = Math.cos(theta);
		var sin = Math.sin(theta);
		var a1 = this.a * cos - this.b * sin;
		this.b = this.a * sin + this.b * cos;
		this.a = a1;
		var c1 = this.c * cos - this.d * sin;
		this.d = this.c * sin + this.d * cos;
		this.c = c1;
		var tx1 = this.tx * cos - this.ty * sin;
		this.ty = this.tx * sin + this.ty * cos;
		this.tx = tx1;
	},
	scale: function(sx,sy) {
		this.a *= sx;
		this.b *= sy;
		this.c *= sx;
		this.d *= sy;
		this.tx *= sx;
		this.ty *= sy;
	},
	setRotation: function(theta,scale) {
		if(scale == null) {
			scale = 1;
		}
		this.a = Math.cos(theta) * scale;
		this.c = Math.sin(theta) * scale;
		this.b = -this.c;
		this.d = this.a;
	},
	setTo: function(a,b,c,d,tx,ty) {
		this.a = a;
		this.b = b;
		this.c = c;
		this.d = d;
		this.tx = tx;
		this.ty = ty;
	},
	to3DString: function(roundPixels) {
		if(roundPixels == null) {
			roundPixels = false;
		}
		if(roundPixels) {
			return "matrix3d(" + this.a + ", " + this.b + ", " + "0, 0, " + this.c + ", " + this.d + ", " + "0, 0, 0, 0, 1, 0, " + (Std().default).int(this.tx) + ", " + (Std().default).int(this.ty) + ", 0, 1)";
		} else {
			return "matrix3d(" + this.a + ", " + this.b + ", " + "0, 0, " + this.c + ", " + this.d + ", " + "0, 0, 0, 0, 1, 0, " + this.tx + ", " + this.ty + ", 0, 1)";
		}
	},
	toString: function() {
		return "matrix(" + this.a + ", " + this.b + ", " + this.c + ", " + this.d + ", " + this.tx + ", " + this.ty + ")";
	},
	transformRect: function(rect,result) {
		if(result == null) {
			result = new (lime_math_Rectangle().default)();
		}
		var tx0 = this.a * rect.x + this.c * rect.y;
		var tx1 = tx0;
		var ty0 = this.b * rect.x + this.d * rect.y;
		var ty1 = ty0;
		var tx = this.a * (rect.x + rect.width) + this.c * rect.y;
		var ty = this.b * (rect.x + rect.width) + this.d * rect.y;
		if(tx < tx0) {
			tx0 = tx;
		}
		if(ty < ty0) {
			ty0 = ty;
		}
		if(tx > tx1) {
			tx1 = tx;
		}
		if(ty > ty1) {
			ty1 = ty;
		}
		tx = this.a * (rect.x + rect.width) + this.c * (rect.y + rect.height);
		ty = this.b * (rect.x + rect.width) + this.d * (rect.y + rect.height);
		if(tx < tx0) {
			tx0 = tx;
		}
		if(ty < ty0) {
			ty0 = ty;
		}
		if(tx > tx1) {
			tx1 = tx;
		}
		if(ty > ty1) {
			ty1 = ty;
		}
		tx = this.a * rect.x + this.c * (rect.y + rect.height);
		ty = this.b * rect.x + this.d * (rect.y + rect.height);
		if(tx < tx0) {
			tx0 = tx;
		}
		if(ty < ty0) {
			ty0 = ty;
		}
		if(tx > tx1) {
			tx1 = tx;
		}
		if(ty > ty1) {
			ty1 = ty;
		}
		result.setTo(tx0 + tx,ty0 + ty,tx1 - tx0,ty1 - ty0);
		return result;
	},
	transformVector: function(pos,result) {
		if(result == null) {
			result = new (lime_math_Vector2().default)();
		}
		result.x = pos.x * this.a + pos.y * this.c + this.tx;
		result.y = pos.x * this.b + pos.y * this.d + this.ty;
		return result;
	},
	translate: function(dx,dy) {
		this.tx += dx;
		this.ty += dy;
	}
};
Matrix3.prototype.__class__ = Matrix3.prototype.constructor = $hxClasses["lime.math.Matrix3"] = Matrix3;

// Init



// Statics


Matrix3.__identity = new Matrix3()

// Export

exports["default"] = Matrix3;

/***/ }),

/***/ "./lib/_gen/lime/math/Rectangle.js":
/*!*****************************************!*\
  !*** ./lib/_gen/lime/math/Rectangle.js ***!
  \*****************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: lime.math.Rectangle

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function lime_math_Vector2() {return __webpack_require__(/*! ./../../lime/math/Vector2 */ "./lib/_gen/lime/math/Vector2.js");}

// Constructor

var Rectangle = function(x,y,width,height) {
	if(height == null) {
		height = 0;
	}
	if(width == null) {
		width = 0;
	}
	if(y == null) {
		y = 0;
	}
	if(x == null) {
		x = 0;
	}
	this.x = x;
	this.y = y;
	this.width = width;
	this.height = height;
}

// Meta

Rectangle.__name__ = "lime.math.Rectangle";
Rectangle.__isInterface__ = false;
Rectangle.prototype = {
	clone: function() {
		return new Rectangle(this.x,this.y,this.width,this.height);
	},
	contains: function(x,y) {
		if(x >= this.x && y >= this.y && x < this.get_right()) {
			return y < this.get_bottom();
		} else {
			return false;
		}
	},
	containsPoint: function(point) {
		return this.containsVector(point);
	},
	containsRect: function(rect) {
		if(rect.width <= 0 || rect.height <= 0) {
			if(rect.x > this.x && rect.y > this.y && rect.get_right() < this.get_right()) {
				return rect.get_bottom() < this.get_bottom();
			} else {
				return false;
			}
		} else if(rect.x >= this.x && rect.y >= this.y && rect.get_right() <= this.get_right()) {
			return rect.get_bottom() <= this.get_bottom();
		} else {
			return false;
		}
	},
	containsVector: function(vector) {
		return this.contains(vector.x,vector.y);
	},
	copyFrom: function(sourceRect) {
		this.x = sourceRect.x;
		this.y = sourceRect.y;
		this.width = sourceRect.width;
		this.height = sourceRect.height;
	},
	equals: function(toCompare) {
		if(toCompare != null && this.x == toCompare.x && this.y == toCompare.y && this.width == toCompare.width) {
			return this.height == toCompare.height;
		} else {
			return false;
		}
	},
	inflate: function(dx,dy) {
		this.x -= dx;
		this.width += dx * 2;
		this.y -= dy;
		this.height += dy * 2;
	},
	inflateVector: function(vector) {
		this.inflate(vector.x,vector.y);
	},
	intersection: function(toIntersect,result) {
		if(result == null) {
			result = new Rectangle();
		}
		var x0 = this.x < toIntersect.x ? toIntersect.x : this.x;
		var x1 = this.get_right() > toIntersect.get_right() ? toIntersect.get_right() : this.get_right();
		if(x1 <= x0) {
			result.setEmpty();
			return result;
		}
		var y0 = this.y < toIntersect.y ? toIntersect.y : this.y;
		var y1 = this.get_bottom() > toIntersect.get_bottom() ? toIntersect.get_bottom() : this.get_bottom();
		if(y1 <= y0) {
			result.setEmpty();
			return result;
		}
		result.x = x0;
		result.y = y0;
		result.width = x1 - x0;
		result.height = y1 - y0;
		return result;
	},
	intersects: function(toIntersect) {
		var x0 = this.x < toIntersect.x ? toIntersect.x : this.x;
		var x1 = this.get_right() > toIntersect.get_right() ? toIntersect.get_right() : this.get_right();
		if(x1 <= x0) {
			return false;
		}
		var y0 = this.y < toIntersect.y ? toIntersect.y : this.y;
		var y1 = this.get_bottom() > toIntersect.get_bottom() ? toIntersect.get_bottom() : this.get_bottom();
		return y1 > y0;
	},
	isEmpty: function() {
		if(!(this.width <= 0)) {
			return this.height <= 0;
		} else {
			return true;
		}
	},
	offset: function(dx,dy) {
		this.x += dx;
		this.y += dy;
	},
	offsetVector: function(vector) {
		this.x += vector.x;
		this.y += vector.y;
	},
	setEmpty: function() {
		this.x = this.y = this.width = this.height = 0;
	},
	setTo: function(xa,ya,widtha,heighta) {
		this.x = xa;
		this.y = ya;
		this.width = widtha;
		this.height = heighta;
	},
	union: function(toUnion,result) {
		if(result == null) {
			result = new Rectangle();
		}
		if(this.width == 0 || this.height == 0) {
			result.copyFrom(toUnion);
		} else if(toUnion.width == 0 || toUnion.height == 0) {
			result.copyFrom(this);
		} else {
			var x0 = this.x > toUnion.x ? toUnion.x : this.x;
			var x1 = this.get_right() < toUnion.get_right() ? toUnion.get_right() : this.get_right();
			var y0 = this.y > toUnion.y ? toUnion.y : this.y;
			var y1 = this.get_bottom() < toUnion.get_bottom() ? toUnion.get_bottom() : this.get_bottom();
			result.setTo(x0,y0,x1 - x0,y1 - y0);
		}
		return result;
	},
	__toFlashRectangle: function() {
		return null;
	},
	get_bottom: function() {
		return this.y + this.height;
	},
	set_bottom: function(b) {
		this.height = b - this.y;
		return b;
	},
	get_bottomRight: function() {
		return new (lime_math_Vector2().default)(this.x + this.width,this.y + this.height);
	},
	set_bottomRight: function(p) {
		this.width = p.x - this.x;
		this.height = p.y - this.y;
		return p.clone();
	},
	get_left: function() {
		return this.x;
	},
	set_left: function(l) {
		this.width -= l - this.x;
		this.x = l;
		return l;
	},
	get_right: function() {
		return this.x + this.width;
	},
	set_right: function(r) {
		this.width = r - this.x;
		return r;
	},
	get_size: function() {
		return new (lime_math_Vector2().default)(this.width,this.height);
	},
	set_size: function(p) {
		this.width = p.x;
		this.height = p.y;
		return p.clone();
	},
	get_top: function() {
		return this.y;
	},
	set_top: function(t) {
		this.height -= t - this.y;
		this.y = t;
		return t;
	},
	get_topLeft: function() {
		return new (lime_math_Vector2().default)(this.x,this.y);
	},
	set_topLeft: function(p) {
		this.x = p.x;
		this.y = p.y;
		return p.clone();
	}
};
Rectangle.prototype.__class__ = Rectangle.prototype.constructor = $hxClasses["lime.math.Rectangle"] = Rectangle;

// Init



// Statics




// Export

exports["default"] = Rectangle;

/***/ }),

/***/ "./lib/_gen/lime/math/Vector2.js":
/*!***************************************!*\
  !*** ./lib/_gen/lime/math/Vector2.js ***!
  \***************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: lime.math.Vector2

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);

// Constructor

var Vector2 = function(x,y) {
	if(y == null) {
		y = 0;
	}
	if(x == null) {
		x = 0;
	}
	this.x = x;
	this.y = y;
}

// Meta

Vector2.__name__ = "lime.math.Vector2";
Vector2.__isInterface__ = false;
Vector2.prototype = {
	add: function(v,result) {
		if(result == null) {
			result = new Vector2();
		}
		result.setTo(v.x + this.x,v.y + this.y);
		return result;
	},
	clone: function() {
		return new Vector2(this.x,this.y);
	},
	equals: function(toCompare) {
		if(toCompare != null && toCompare.x == this.x) {
			return toCompare.y == this.y;
		} else {
			return false;
		}
	},
	normalize: function(thickness) {
		if(this.x == 0 && this.y == 0) {
			return;
		} else {
			var norm = thickness / Math.sqrt(this.x * this.x + this.y * this.y);
			this.x *= norm;
			this.y *= norm;
		}
	},
	offset: function(dx,dy) {
		this.x += dx;
		this.y += dy;
	},
	setTo: function(xa,ya) {
		this.x = xa;
		this.y = ya;
	},
	subtract: function(v,result) {
		if(result == null) {
			result = new Vector2();
		}
		result.setTo(this.x - v.x,this.y - v.y);
		return result;
	},
	__toFlashPoint: function() {
		return null;
	},
	get_length: function() {
		return Math.sqrt(this.x * this.x + this.y * this.y);
	},
	get_lengthSquared: function() {
		return this.x * this.x + this.y * this.y;
	}
};
Vector2.prototype.__class__ = Vector2.prototype.constructor = $hxClasses["lime.math.Vector2"] = Vector2;

// Init



// Statics

Vector2.distance = function(pt1,pt2) {
	var dx = pt1.x - pt2.x;
	var dy = pt1.y - pt2.y;
	return Math.sqrt(dx * dx + dy * dy);
}
Vector2.interpolate = function(pt1,pt2,f,result) {
	if(result == null) {
		result = new Vector2();
	}
	result.setTo(pt2.x + f * (pt1.x - pt2.x),pt2.y + f * (pt1.y - pt2.y));
	return result;
}
Vector2.polar = function(len,angle,result) {
	if(result == null) {
		result = new Vector2();
	}
	result.setTo(len * Math.cos(angle),len * Math.sin(angle));
	return result;
}


// Export

exports["default"] = Vector2;

/***/ }),

/***/ "./lib/_gen/lime/utils/ObjectPool.js":
/*!*******************************************!*\
  !*** ./lib/_gen/lime/utils/ObjectPool.js ***!
  \*******************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: lime.utils.ObjectPool

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function haxe_ds_ObjectMap() {return __webpack_require__(/*! ./../../haxe/ds/ObjectMap */ "./lib/_gen/haxe/ds/ObjectMap.js");}
function haxe_ds_List() {return __webpack_require__(/*! ./../../haxe/ds/List */ "./lib/_gen/haxe/ds/List.js");}

// Constructor

var ObjectPool = function(create,clean,size) {
	this.__pool = new (haxe_ds_ObjectMap().default)();
	this.activeObjects = 0;
	this.inactiveObjects = 0;
	this.__inactiveObject0 = null;
	this.__inactiveObject1 = null;
	this.__inactiveObjectList = new (haxe_ds_List().default)();
	if(create != null) {
		this.create = create;
	}
	if(clean != null) {
		this.clean = clean;
	}
	if(size != null) {
		this.set_size(size);
	}
}

// Meta

ObjectPool.__name__ = "lime.utils.ObjectPool";
ObjectPool.__isInterface__ = false;
ObjectPool.prototype = {
	add: function(object) {
		if(!this.__pool.exists(object)) {
			this.__pool.set(object,false);
			this.clean(object);
			this.__addInactive(object);
		}
	},
	clean: function(object) {
	},
	clear: function() {
		this.__pool = new (haxe_ds_ObjectMap().default)();
		this.activeObjects = 0;
		this.inactiveObjects = 0;
		this.__inactiveObject0 = null;
		this.__inactiveObject1 = null;
		this.__inactiveObjectList.clear();
	},
	create: function() {
		return null;
	},
	get: function() {
		var object = null;
		if(this.inactiveObjects > 0) {
			object = this.__getInactive();
		} else if(this.__size == null || this.activeObjects < this.__size) {
			object = this.create();
			if(object != null) {
				this.__pool.set(object,true);
				this.activeObjects++;
			}
		}
		return object;
	},
	release: function(object) {
		this.activeObjects--;
		if(this.__size == null || this.activeObjects + this.inactiveObjects < this.__size) {
			this.clean(object);
			this.__addInactive(object);
		} else {
			this.__pool.remove(object);
		}
	},
	remove: function(object) {
		if(this.__pool.exists(object)) {
			this.__pool.remove(object);
			if(this.__inactiveObject0 == object) {
				this.__inactiveObject0 = null;
				this.inactiveObjects--;
			} else if(this.__inactiveObject1 == object) {
				this.__inactiveObject1 = null;
				this.inactiveObjects--;
			} else if(this.__inactiveObjectList.remove(object)) {
				this.inactiveObjects--;
			} else {
				this.activeObjects--;
			}
		}
	},
	__addInactive: function(object) {
		if(this.__inactiveObject0 == null) {
			this.__inactiveObject0 = object;
		} else if(this.__inactiveObject1 == null) {
			this.__inactiveObject1 = object;
		} else {
			this.__inactiveObjectList.add(object);
		}
		this.inactiveObjects++;
	},
	__getInactive: function() {
		var object = null;
		if(this.__inactiveObject0 != null) {
			object = this.__inactiveObject0;
			this.__inactiveObject0 = null;
		} else if(this.__inactiveObject1 != null) {
			object = this.__inactiveObject1;
			this.__inactiveObject1 = null;
		} else {
			object = this.__inactiveObjectList.pop();
			if(this.__inactiveObjectList.length > 0) {
				this.__inactiveObject0 = this.__inactiveObjectList.pop();
			}
			if(this.__inactiveObjectList.length > 0) {
				this.__inactiveObject1 = this.__inactiveObjectList.pop();
			}
		}
		this.inactiveObjects--;
		this.activeObjects++;
		return object;
	},
	__removeInactive: function(count) {
		if(count <= 0 || this.inactiveObjects == 0) {
			return;
		}
		if(this.__inactiveObject0 != null) {
			this.__pool.remove(this.__inactiveObject0);
			this.__inactiveObject0 = null;
			this.inactiveObjects--;
			--count;
		}
		if(count == 0 || this.inactiveObjects == 0) {
			return;
		}
		if(this.__inactiveObject1 != null) {
			this.__pool.remove(this.__inactiveObject1);
			this.__inactiveObject1 = null;
			this.inactiveObjects--;
			--count;
		}
		if(count == 0 || this.inactiveObjects == 0) {
			return;
		}
		var object = this.__inactiveObjectList.iterator();
		while(object.hasNext()) {
			var object1 = object.next();
			this.__pool.remove(object1);
			this.__inactiveObjectList.remove(object1);
			this.inactiveObjects--;
			--count;
			if(count == 0 || this.inactiveObjects == 0) {
				return;
			}
		}
	},
	get_size: function() {
		return this.__size;
	},
	set_size: function(value) {
		if(value == null) {
			this.__size = null;
		} else {
			var current = this.inactiveObjects + this.activeObjects;
			this.__size = value;
			if(current > value) {
				this.__removeInactive(current - value);
			} else if(value > current) {
				var object;
				var _g = 0;
				var _g1 = value - current;
				while(_g < _g1) {
					var i = _g++;
					object = this.create();
					if(object != null) {
						this.__pool.set(object,false);
						this.__inactiveObjectList.add(object);
						this.inactiveObjects++;
					} else {
						break;
					}
				}
			}
		}
		return value;
	}
};
ObjectPool.prototype.__class__ = ObjectPool.prototype.constructor = $hxClasses["lime.utils.ObjectPool"] = ObjectPool;

// Init



// Statics




// Export

exports["default"] = ObjectPool;

/***/ }),

/***/ "./lib/_gen/openfl/events/EventDispatcher.js":
/*!***************************************************!*\
  !*** ./lib/_gen/openfl/events/EventDispatcher.js ***!
  \***************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: openfl.events.EventDispatcher

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function openfl_events_IEventDispatcher() {return __webpack_require__(/*! ./../../openfl/events/IEventDispatcher */ "./lib/_gen/openfl/events/IEventDispatcher.js");}
function haxe_ds_StringMap() {return __webpack_require__(/*! ./../../haxe/ds/StringMap */ "./lib/_gen/haxe/ds/StringMap.js");}
function openfl_events__$EventDispatcher_Listener() {return __webpack_require__(/*! ./../../openfl/events/_EventDispatcher/Listener */ "./lib/_gen/openfl/events/_EventDispatcher/Listener.js");}
function openfl_events__$EventDispatcher_DispatchIterator() {return __webpack_require__(/*! ./../../openfl/events/_EventDispatcher/DispatchIterator */ "./lib/_gen/openfl/events/_EventDispatcher/DispatchIterator.js");}
function Type() {return __webpack_require__(/*! ./../../Type */ "./lib/_gen/Type.js");}
function HxOverrides() {return __webpack_require__(/*! ./../../HxOverrides */ "./lib/_gen/HxOverrides.js");}

// Constructor

var EventDispatcher = function(target) {
	if(target != null) {
		this.__targetDispatcher = target;
	}
}

// Meta

EventDispatcher.__name__ = "openfl.events.EventDispatcher";
EventDispatcher.__isInterface__ = false;
EventDispatcher.__interfaces__ = [(openfl_events_IEventDispatcher().default)];
EventDispatcher.prototype = {
	addEventListener: function(type,listener,useCapture,priority,useWeakReference) {
		if(useWeakReference == null) {
			useWeakReference = false;
		}
		if(priority == null) {
			priority = 0;
		}
		if(useCapture == null) {
			useCapture = false;
		}
		if(listener == null) {
			return;
		}
		if(this.__eventMap == null) {
			this.__eventMap = new (haxe_ds_StringMap().default)();
			this.__iterators = new (haxe_ds_StringMap().default)();
		}
		if(!this.__eventMap.exists(type)) {
			var list = [];
			list.push(new (openfl_events__$EventDispatcher_Listener().default)(listener,useCapture,priority));
			var iterator = new (openfl_events__$EventDispatcher_DispatchIterator().default)(list);
			this.__eventMap.set(type,list);
			this.__iterators.set(type,[iterator]);
		} else {
			var list1 = this.__eventMap.get(type);
			var _g = 0;
			var _g1 = list1.length;
			while(_g < _g1) {
				var i = _g++;
				if(list1[i].match(listener,useCapture)) {
					return;
				}
			}
			var iterators = this.__iterators.get(type);
			var _g2 = 0;
			while(_g2 < iterators.length) {
				var iterator1 = iterators[_g2];
				++_g2;
				if(iterator1.active) {
					iterator1.copy();
				}
			}
			this.__addListenerByPriority(list1,new (openfl_events__$EventDispatcher_Listener().default)(listener,useCapture,priority));
		}
	},
	dispatchEvent: function(event) {
		if(this.__targetDispatcher != null) {
			event.target = this.__targetDispatcher;
		} else {
			event.target = this;
		}
		return this.__dispatchEvent(event);
	},
	hasEventListener: function(type) {
		if(this.__eventMap == null) {
			return false;
		}
		return this.__eventMap.exists(type);
	},
	removeEventListener: function(type,listener,useCapture) {
		if(useCapture == null) {
			useCapture = false;
		}
		if(this.__eventMap == null || listener == null) {
			return;
		}
		var list = this.__eventMap.get(type);
		if(list == null) {
			return;
		}
		var iterators = this.__iterators.get(type);
		var _g = 0;
		var _g1 = list.length;
		while(_g < _g1) {
			var i = _g++;
			if(list[i].match(listener,useCapture)) {
				var _g2 = 0;
				while(_g2 < iterators.length) {
					var iterator = iterators[_g2];
					++_g2;
					iterator.remove(list[i],i);
				}
				list.splice(i,1);
				break;
			}
		}
		if(list.length == 0) {
			this.__eventMap.remove(type);
			this.__iterators.remove(type);
		}
		if(!this.__eventMap.iterator().hasNext()) {
			this.__eventMap = null;
			this.__iterators = null;
		}
	},
	toString: function() {
		var full = (Type().default).getClassName((Type().default).getClass(this));
		var short = full.split(".").pop();
		return "[object " + short + "]";
	},
	willTrigger: function(type) {
		return this.hasEventListener(type);
	},
	__dispatchEvent: function(event) {
		if(this.__eventMap == null || event == null) {
			return true;
		}
		var type = event.type;
		var list = this.__eventMap.get(type);
		if(list == null) {
			return true;
		}
		if(event.target == null) {
			if(this.__targetDispatcher != null) {
				event.target = this.__targetDispatcher;
			} else {
				event.target = this;
			}
		}
		event.currentTarget = this;
		var capture = event.eventPhase == 1;
		var iterators = this.__iterators.get(type);
		var iterator = iterators[0];
		if(iterator.active) {
			iterator = new (openfl_events__$EventDispatcher_DispatchIterator().default)(list);
			iterators.push(iterator);
		}
		iterator.start();
		var listener = iterator;
		while(listener.hasNext()) {
			var listener1 = listener.next();
			if(listener1 == null) {
				continue;
			}
			if(listener1.useCapture == capture) {
				listener1.callback(event);
				if(event.__isCanceledNow) {
					break;
				}
			}
		}
		iterator.stop();
		if(iterator != iterators[0]) {
			(HxOverrides().default).remove(iterators,iterator);
		} else {
			iterator.reset(list);
		}
		return !event.isDefaultPrevented();
	},
	__removeAllListeners: function() {
		this.__eventMap = null;
		this.__iterators = null;
	},
	__addListenerByPriority: function(list,listener) {
		var numElements = list.length;
		var addAtPosition = numElements;
		var _g = 0;
		var _g1 = numElements;
		while(_g < _g1) {
			var i = _g++;
			if(list[i].priority < listener.priority) {
				addAtPosition = i;
				break;
			}
		}
		list.splice(addAtPosition,0,listener);
	}
};
EventDispatcher.prototype.__class__ = EventDispatcher.prototype.constructor = $hxClasses["openfl.events.EventDispatcher"] = EventDispatcher;

// Init



// Statics




// Export

exports["default"] = EventDispatcher;

/***/ }),

/***/ "./lib/_gen/openfl/events/IEventDispatcher.js":
/*!****************************************************!*\
  !*** ./lib/_gen/openfl/events/IEventDispatcher.js ***!
  \****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: openfl.events.IEventDispatcher

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var IEventDispatcher = function() {}

// Meta

IEventDispatcher.__name__ = "openfl.events.IEventDispatcher";
IEventDispatcher.__isInterface__ = true;
IEventDispatcher.prototype = {
	
};
IEventDispatcher.prototype.__class__ = IEventDispatcher.prototype.constructor = $hxClasses["openfl.events.IEventDispatcher"] = IEventDispatcher;

// Init



// Statics




// Export

exports["default"] = IEventDispatcher;

/***/ }),

/***/ "./lib/_gen/openfl/events/_EventDispatcher/DispatchIterator.js":
/*!*********************************************************************!*\
  !*** ./lib/_gen/openfl/events/_EventDispatcher/DispatchIterator.js ***!
  \*********************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: openfl.events._EventDispatcher.DispatchIterator

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);

// Constructor

var DispatchIterator = function(list) {
	this.active = false;
	this.reset(list);
}

// Meta

DispatchIterator.__name__ = "openfl.events._EventDispatcher.DispatchIterator";
DispatchIterator.__isInterface__ = false;
DispatchIterator.prototype = {
	copy: function() {
		if(!this.isCopy) {
			this.list = this.list.slice();
			this.isCopy = true;
		}
	},
	hasNext: function() {
		return this.index < this.list.length;
	},
	next: function() {
		return this.list[this.index++];
	},
	remove: function(listener,listIndex) {
		if(this.active) {
			if(!this.isCopy) {
				if(listIndex < this.index) {
					this.index--;
				}
			} else {
				var _g = this.index;
				var _g1 = this.list.length;
				while(_g < _g1) {
					var i = _g++;
					if(this.list[i] == listener) {
						this.list.splice(i,1);
						break;
					}
				}
			}
		}
	},
	reset: function(list) {
		this.list = list;
		this.isCopy = false;
		this.index = 0;
	},
	start: function() {
		this.active = true;
	},
	stop: function() {
		this.active = false;
	}
};
DispatchIterator.prototype.__class__ = DispatchIterator.prototype.constructor = $hxClasses["openfl.events._EventDispatcher.DispatchIterator"] = DispatchIterator;

// Init



// Statics


DispatchIterator.__meta__ = { obj : { SuppressWarnings : ["checkstyle:FieldDocComment"]}}

// Export

exports["default"] = DispatchIterator;

/***/ }),

/***/ "./lib/_gen/openfl/events/_EventDispatcher/Listener.js":
/*!*************************************************************!*\
  !*** ./lib/_gen/openfl/events/_EventDispatcher/Listener.js ***!
  \*************************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: openfl.events._EventDispatcher.Listener

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function Reflect() {return __webpack_require__(/*! ./../../../Reflect */ "./lib/_gen/Reflect.js");}

// Constructor

var Listener = function(callback,useCapture,priority) {
	this.callback = callback;
	this.useCapture = useCapture;
	this.priority = priority;
}

// Meta

Listener.__name__ = "openfl.events._EventDispatcher.Listener";
Listener.__isInterface__ = false;
Listener.prototype = {
	match: function(callback,useCapture) {
		if((Reflect().default).compareMethods(this.callback,callback)) {
			return this.useCapture == useCapture;
		} else {
			return false;
		}
	}
};
Listener.prototype.__class__ = Listener.prototype.constructor = $hxClasses["openfl.events._EventDispatcher.Listener"] = Listener;

// Init



// Statics


Listener.__meta__ = { obj : { SuppressWarnings : ["checkstyle:FieldDocComment"]}}

// Export

exports["default"] = Listener;

/***/ }),

/***/ "./lib/_gen/openfl/geom/Matrix.js":
/*!****************************************!*\
  !*** ./lib/_gen/openfl/geom/Matrix.js ***!
  \****************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: openfl.geom.Matrix

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function js__$Boot_HaxeError() {return __webpack_require__(/*! ./../../js/_Boot/HaxeError */ "./lib/_gen/js/_Boot/HaxeError.js");}
function openfl_geom_Point() {return __webpack_require__(/*! ./../../openfl/geom/Point */ "./lib/_gen/openfl/geom/Point.js");}
function Std() {return __webpack_require__(/*! ./../../Std */ "./lib/_gen/Std.js");}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}
function lime_math_Matrix3() {return __webpack_require__(/*! ./../../lime/math/Matrix3 */ "./lib/_gen/lime/math/Matrix3.js");}

// Constructor

var Matrix = function(a,b,c,d,tx,ty) {
	if(ty == null) {
		ty = 0;
	}
	if(tx == null) {
		tx = 0;
	}
	if(d == null) {
		d = 1;
	}
	if(c == null) {
		c = 0;
	}
	if(b == null) {
		b = 0;
	}
	if(a == null) {
		a = 1;
	}
	this.a = a;
	this.b = b;
	this.c = c;
	this.d = d;
	this.tx = tx;
	this.ty = ty;
}

// Meta

Matrix.__name__ = "openfl.geom.Matrix";
Matrix.__isInterface__ = false;
Matrix.prototype = {
	clone: function() {
		return new Matrix(this.a,this.b,this.c,this.d,this.tx,this.ty);
	},
	concat: function(m) {
		var a1 = this.a * m.a + this.b * m.c;
		this.b = this.a * m.b + this.b * m.d;
		this.a = a1;
		var c1 = this.c * m.a + this.d * m.c;
		this.d = this.c * m.b + this.d * m.d;
		this.c = c1;
		var tx1 = this.tx * m.a + this.ty * m.c + m.tx;
		this.ty = this.tx * m.b + this.ty * m.d + m.ty;
		this.tx = tx1;
	},
	copyColumnFrom: function(column,vector3D) {
		if(column > 2) {
			throw new (js__$Boot_HaxeError().default)("Column " + column + " out of bounds (2)");
		} else if(column == 0) {
			this.a = vector3D.x;
			this.b = vector3D.y;
		} else if(column == 1) {
			this.c = vector3D.x;
			this.d = vector3D.y;
		} else {
			this.tx = vector3D.x;
			this.ty = vector3D.y;
		}
	},
	copyColumnTo: function(column,vector3D) {
		if(column > 2) {
			throw new (js__$Boot_HaxeError().default)("Column " + column + " out of bounds (2)");
		} else if(column == 0) {
			vector3D.x = this.a;
			vector3D.y = this.b;
			vector3D.z = 0;
		} else if(column == 1) {
			vector3D.x = this.c;
			vector3D.y = this.d;
			vector3D.z = 0;
		} else {
			vector3D.x = this.tx;
			vector3D.y = this.ty;
			vector3D.z = 1;
		}
	},
	copyFrom: function(sourceMatrix) {
		this.a = sourceMatrix.a;
		this.b = sourceMatrix.b;
		this.c = sourceMatrix.c;
		this.d = sourceMatrix.d;
		this.tx = sourceMatrix.tx;
		this.ty = sourceMatrix.ty;
	},
	copyRowFrom: function(row,vector3D) {
		if(row > 2) {
			throw new (js__$Boot_HaxeError().default)("Row " + row + " out of bounds (2)");
		} else if(row == 0) {
			this.a = vector3D.x;
			this.c = vector3D.y;
			this.tx = vector3D.z;
		} else if(row == 1) {
			this.b = vector3D.x;
			this.d = vector3D.y;
			this.ty = vector3D.z;
		}
	},
	copyRowTo: function(row,vector3D) {
		if(row > 2) {
			throw new (js__$Boot_HaxeError().default)("Row " + row + " out of bounds (2)");
		} else if(row == 0) {
			vector3D.x = this.a;
			vector3D.y = this.c;
			vector3D.z = this.tx;
		} else if(row == 1) {
			vector3D.x = this.b;
			vector3D.y = this.d;
			vector3D.z = this.ty;
		} else {
			vector3D.setTo(0,0,1);
		}
	},
	createBox: function(scaleX,scaleY,rotation,tx,ty) {
		if(ty == null) {
			ty = 0;
		}
		if(tx == null) {
			tx = 0;
		}
		if(rotation == null) {
			rotation = 0;
		}
		if(rotation != 0) {
			var cos = Math.cos(rotation);
			var sin = Math.sin(rotation);
			this.a = cos * scaleX;
			this.b = sin * scaleY;
			this.c = -sin * scaleX;
			this.d = cos * scaleY;
		} else {
			this.a = scaleX;
			this.b = 0;
			this.c = 0;
			this.d = scaleY;
		}
		this.tx = tx;
		this.ty = ty;
	},
	createGradientBox: function(width,height,rotation,tx,ty) {
		if(ty == null) {
			ty = 0;
		}
		if(tx == null) {
			tx = 0;
		}
		if(rotation == null) {
			rotation = 0;
		}
		this.a = width / 1638.4;
		this.d = height / 1638.4;
		if(rotation != 0) {
			var cos = Math.cos(rotation);
			var sin = Math.sin(rotation);
			this.b = sin * this.d;
			this.c = -sin * this.a;
			this.a *= cos;
			this.d *= cos;
		} else {
			this.b = 0;
			this.c = 0;
		}
		this.tx = tx + width / 2;
		this.ty = ty + height / 2;
	},
	deltaTransformPoint: function(point) {
		return new (openfl_geom_Point().default)(point.x * this.a + point.y * this.c,point.x * this.b + point.y * this.d);
	},
	equals: function(matrix) {
		if(matrix != null && this.tx == matrix.tx && this.ty == matrix.ty && this.a == matrix.a && this.b == matrix.b && this.c == matrix.c) {
			return this.d == matrix.d;
		} else {
			return false;
		}
	},
	identity: function() {
		this.a = 1;
		this.b = 0;
		this.c = 0;
		this.d = 1;
		this.tx = 0;
		this.ty = 0;
	},
	invert: function() {
		var norm = this.a * this.d - this.b * this.c;
		if(norm == 0) {
			this.a = this.b = this.c = this.d = 0;
			this.tx = -this.tx;
			this.ty = -this.ty;
		} else {
			norm = 1.0 / norm;
			var a1 = this.d * norm;
			this.d = this.a * norm;
			this.a = a1;
			this.b *= -norm;
			this.c *= -norm;
			var tx1 = -this.a * this.tx - this.c * this.ty;
			this.ty = -this.b * this.tx - this.d * this.ty;
			this.tx = tx1;
		}
		return this;
	},
	rotate: function(theta) {
		var cos = Math.cos(theta);
		var sin = Math.sin(theta);
		var a1 = this.a * cos - this.b * sin;
		this.b = this.a * sin + this.b * cos;
		this.a = a1;
		var c1 = this.c * cos - this.d * sin;
		this.d = this.c * sin + this.d * cos;
		this.c = c1;
		var tx1 = this.tx * cos - this.ty * sin;
		this.ty = this.tx * sin + this.ty * cos;
		this.tx = tx1;
	},
	scale: function(sx,sy) {
		this.a *= sx;
		this.b *= sy;
		this.c *= sx;
		this.d *= sy;
		this.tx *= sx;
		this.ty *= sy;
	},
	setRotation: function(theta,scale) {
		if(scale == null) {
			scale = 1;
		}
		this.a = Math.cos(theta) * scale;
		this.c = Math.sin(theta) * scale;
		this.b = -this.c;
		this.d = this.a;
	},
	setTo: function(a,b,c,d,tx,ty) {
		this.a = a;
		this.b = b;
		this.c = c;
		this.d = d;
		this.tx = tx;
		this.ty = ty;
	},
	to3DString: function(roundPixels) {
		if(roundPixels == null) {
			roundPixels = false;
		}
		if(roundPixels) {
			return "matrix3d(" + this.a + ", " + this.b + ", 0, 0, " + this.c + ", " + this.d + ", 0, 0, 0, 0, 1, 0, " + (Std().default).int(this.tx) + ", " + (Std().default).int(this.ty) + ", 0, 1)";
		} else {
			return "matrix3d(" + this.a + ", " + this.b + ", 0, 0, " + this.c + ", " + this.d + ", 0, 0, 0, 0, 1, 0, " + this.tx + ", " + this.ty + ", 0, 1)";
		}
	},
	toMozString: function() {
		return "matrix(" + this.a + ", " + this.b + ", " + this.c + ", " + this.d + ", " + this.tx + "px, " + this.ty + "px)";
	},
	toString: function() {
		return "matrix(" + this.a + ", " + this.b + ", " + this.c + ", " + this.d + ", " + this.tx + ", " + this.ty + ")";
	},
	transformPoint: function(pos) {
		return new (openfl_geom_Point().default)(this.__transformX(pos.x,pos.y),this.__transformY(pos.x,pos.y));
	},
	translate: function(dx,dy) {
		this.tx += dx;
		this.ty += dy;
	},
	toArray: function(transpose) {
		if(transpose == null) {
			transpose = false;
		}
		if(this.__array == null) {
			var array = null;
			var vector = null;
			var view = null;
			var buffer = null;
			var len = null;
			var this1 = new Float32Array(9);
			this.__array = this1;
		}
		if(transpose) {
			this.__array[0] = this.a;
			this.__array[1] = this.b;
			this.__array[2] = 0;
			this.__array[3] = this.c;
			this.__array[4] = this.d;
			this.__array[5] = 0;
			this.__array[6] = this.tx;
			this.__array[7] = this.ty;
			this.__array[8] = 1;
		} else {
			this.__array[0] = this.a;
			this.__array[1] = this.c;
			this.__array[2] = this.tx;
			this.__array[3] = this.b;
			this.__array[4] = this.d;
			this.__array[5] = this.ty;
			this.__array[6] = 0;
			this.__array[7] = 0;
			this.__array[8] = 1;
		}
		return this.__array;
	},
	__cleanValues: function() {
		this.a = Math.round(this.a * 1000) / 1000;
		this.b = Math.round(this.b * 1000) / 1000;
		this.c = Math.round(this.c * 1000) / 1000;
		this.d = Math.round(this.d * 1000) / 1000;
		this.tx = Math.round(this.tx * 10) / 10;
		this.ty = Math.round(this.ty * 10) / 10;
	},
	__toMatrix3: function() {
		Matrix.__matrix3.setTo(this.a,this.b,this.c,this.d,this.tx,this.ty);
		return Matrix.__matrix3;
	},
	__transformInversePoint: function(point) {
		var norm = this.a * this.d - this.b * this.c;
		if(norm == 0) {
			point.x = -this.tx;
			point.y = -this.ty;
		} else {
			var px = 1.0 / norm * (this.c * (this.ty - point.y) + this.d * (point.x - this.tx));
			point.y = 1.0 / norm * (this.a * (point.y - this.ty) + this.b * (this.tx - point.x));
			point.x = px;
		}
	},
	__transformInverseX: function(px,py) {
		var norm = this.a * this.d - this.b * this.c;
		if(norm == 0) {
			return -this.tx;
		} else {
			return 1.0 / norm * (this.c * (this.ty - py) + this.d * (px - this.tx));
		}
	},
	__transformInverseY: function(px,py) {
		var norm = this.a * this.d - this.b * this.c;
		if(norm == 0) {
			return -this.ty;
		} else {
			return 1.0 / norm * (this.a * (py - this.ty) + this.b * (this.tx - px));
		}
	},
	__transformPoint: function(point) {
		var px = point.x;
		var py = point.y;
		point.x = this.__transformX(px,py);
		point.y = this.__transformY(px,py);
	},
	__transformX: function(px,py) {
		return px * this.a + py * this.c + this.tx;
	},
	__transformY: function(px,py) {
		return px * this.b + py * this.d + this.ty;
	},
	__translateTransformed: function(px,py) {
		this.tx = this.__transformX(px,py);
		this.ty = this.__transformY(px,py);
	}
};
Matrix.prototype.__class__ = Matrix.prototype.constructor = $hxClasses["openfl.geom.Matrix"] = Matrix;

// Init



// Statics


Matrix.__meta__ = { fields : { equals : { SuppressWarnings : ["checkstyle:FieldDocComment"]}, to3DString : { SuppressWarnings : ["checkstyle:FieldDocComment"]}, toMozString : { SuppressWarnings : ["checkstyle:FieldDocComment"]}}}
Matrix.__identity = new Matrix()
Matrix.__pool = new (lime_utils_ObjectPool().default)(function() {
	return new Matrix();
},function(m) {
	m.identity();
})
Matrix.__matrix3 = new (lime_math_Matrix3().default)()

// Export

exports["default"] = Matrix;

/***/ }),

/***/ "./lib/_gen/openfl/geom/Point.js":
/*!***************************************!*\
  !*** ./lib/_gen/openfl/geom/Point.js ***!
  \***************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

// Class: openfl.geom.Point

var $global = typeof window != "undefined" ? window : typeof __webpack_require__.g != "undefined" ? __webpack_require__.g : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = (__webpack_require__(/*! ./../../hxClasses_stub */ "./lib/_gen/hxClasses_stub.js")["default"]);
var $hxEnums = (__webpack_require__(/*! ./../../hxEnums_stub */ "./lib/_gen/hxEnums_stub.js")["default"]);
var $import = (__webpack_require__(/*! ./../../import_stub */ "./lib/_gen/import_stub.js")["default"]);
function lime_math_Vector2() {return __webpack_require__(/*! ./../../lime/math/Vector2 */ "./lib/_gen/lime/math/Vector2.js");}
function lime_utils_ObjectPool() {return __webpack_require__(/*! ./../../lime/utils/ObjectPool */ "./lib/_gen/lime/utils/ObjectPool.js");}

// Constructor

var Point = function(x,y) {
	if(y == null) {
		y = 0;
	}
	if(x == null) {
		x = 0;
	}
	this.x = x;
	this.y = y;
}

// Meta

Point.__name__ = "openfl.geom.Point";
Point.__isInterface__ = false;
Point.prototype = {
	add: function(v) {
		return new Point(v.x + this.x,v.y + this.y);
	},
	clone: function() {
		return new Point(this.x,this.y);
	},
	copyFrom: function(sourcePoint) {
		this.x = sourcePoint.x;
		this.y = sourcePoint.y;
	},
	equals: function(toCompare) {
		if(toCompare != null && toCompare.x == this.x) {
			return toCompare.y == this.y;
		} else {
			return false;
		}
	},
	normalize: function(thickness) {
		if(this.x == 0 && this.y == 0) {
			return;
		} else {
			var norm = thickness / Math.sqrt(this.x * this.x + this.y * this.y);
			this.x *= norm;
			this.y *= norm;
		}
	},
	offset: function(dx,dy) {
		this.x += dx;
		this.y += dy;
	},
	setTo: function(xa,ya) {
		this.x = xa;
		this.y = ya;
	},
	subtract: function(v) {
		return new Point(this.x - v.x,this.y - v.y);
	},
	toString: function() {
		return "(x=" + this.x + ", y=" + this.y + ")";
	},
	__toLimeVector2: function() {
		if(Point.__limeVector2 == null) {
			Point.__limeVector2 = new (lime_math_Vector2().default)();
		}
		Point.__limeVector2.setTo(this.x,this.y);
		return Point.__limeVector2;
	},
	get_length: function() {
		return Math.sqrt(this.x * this.x + this.y * this.y);
	}
};
Point.prototype.__class__ = Point.prototype.constructor = $hxClasses["openfl.geom.Point"] = Point;

// Init

Object.defineProperty(Point.prototype,"length",{ get : function () { return this.get_length (); }});

// Statics

Point.distance = function(pt1,pt2) {
	var dx = pt1.x - pt2.x;
	var dy = pt1.y - pt2.y;
	return Math.sqrt(dx * dx + dy * dy);
}
Point.interpolate = function(pt1,pt2,f) {
	return new Point(pt2.x + f * (pt1.x - pt2.x),pt2.y + f * (pt1.y - pt2.y));
}
Point.polar = function(len,angle) {
	return new Point(len * Math.cos(angle),len * Math.sin(angle));
}
Point.__pool = new (lime_utils_ObjectPool().default)(function() {
	return new Point();
},function(p) {
	p.setTo(0,0);
})

// Export

exports["default"] = Point;

/***/ }),

/***/ "./lib/feathers/controls/ActivityIndicator.js":
/*!****************************************************!*\
  !*** ./lib/feathers/controls/ActivityIndicator.js ***!
  \****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/ActivityIndicator */ "./lib/_gen/feathers/controls/ActivityIndicator.js");

/***/ }),

/***/ "./lib/feathers/controls/Alert.js":
/*!****************************************!*\
  !*** ./lib/feathers/controls/Alert.js ***!
  \****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/Alert */ "./lib/_gen/feathers/controls/Alert.js");

/***/ }),

/***/ "./lib/feathers/controls/Application.js":
/*!**********************************************!*\
  !*** ./lib/feathers/controls/Application.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/Application */ "./lib/_gen/feathers/controls/Application.js");

/***/ }),

/***/ "./lib/feathers/controls/AssetLoader.js":
/*!**********************************************!*\
  !*** ./lib/feathers/controls/AssetLoader.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/AssetLoader */ "./lib/_gen/feathers/controls/AssetLoader.js");

/***/ }),

/***/ "./lib/feathers/controls/BasicButton.js":
/*!**********************************************!*\
  !*** ./lib/feathers/controls/BasicButton.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/BasicButton */ "./lib/_gen/feathers/controls/BasicButton.js");

/***/ }),

/***/ "./lib/feathers/controls/BasicToggleButton.js":
/*!****************************************************!*\
  !*** ./lib/feathers/controls/BasicToggleButton.js ***!
  \****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/BasicToggleButton */ "./lib/_gen/feathers/controls/BasicToggleButton.js");

/***/ }),

/***/ "./lib/feathers/controls/Button.js":
/*!*****************************************!*\
  !*** ./lib/feathers/controls/Button.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/Button */ "./lib/_gen/feathers/controls/Button.js");

/***/ }),

/***/ "./lib/feathers/controls/ButtonBar.js":
/*!********************************************!*\
  !*** ./lib/feathers/controls/ButtonBar.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/ButtonBar */ "./lib/_gen/feathers/controls/ButtonBar.js");

/***/ }),

/***/ "./lib/feathers/controls/ButtonState.js":
/*!**********************************************!*\
  !*** ./lib/feathers/controls/ButtonState.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/ButtonState */ "./lib/_gen/feathers/controls/ButtonState.js");

/***/ }),

/***/ "./lib/feathers/controls/CalendarGrid.js":
/*!***********************************************!*\
  !*** ./lib/feathers/controls/CalendarGrid.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/CalendarGrid */ "./lib/_gen/feathers/controls/CalendarGrid.js");

/***/ }),

/***/ "./lib/feathers/controls/Callout.js":
/*!******************************************!*\
  !*** ./lib/feathers/controls/Callout.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/Callout */ "./lib/_gen/feathers/controls/Callout.js");

/***/ }),

/***/ "./lib/feathers/controls/Check.js":
/*!****************************************!*\
  !*** ./lib/feathers/controls/Check.js ***!
  \****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/Check */ "./lib/_gen/feathers/controls/Check.js");

/***/ }),

/***/ "./lib/feathers/controls/ComboBox.js":
/*!*******************************************!*\
  !*** ./lib/feathers/controls/ComboBox.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/ComboBox */ "./lib/_gen/feathers/controls/ComboBox.js");

/***/ }),

/***/ "./lib/feathers/controls/DatePicker.js":
/*!*********************************************!*\
  !*** ./lib/feathers/controls/DatePicker.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/DatePicker */ "./lib/_gen/feathers/controls/DatePicker.js");

/***/ }),

/***/ "./lib/feathers/controls/Drawer.js":
/*!*****************************************!*\
  !*** ./lib/feathers/controls/Drawer.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/Drawer */ "./lib/_gen/feathers/controls/Drawer.js");

/***/ }),

/***/ "./lib/feathers/controls/Form.js":
/*!***************************************!*\
  !*** ./lib/feathers/controls/Form.js ***!
  \***************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/Form */ "./lib/_gen/feathers/controls/Form.js");

/***/ }),

/***/ "./lib/feathers/controls/FormItem.js":
/*!*******************************************!*\
  !*** ./lib/feathers/controls/FormItem.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/FormItem */ "./lib/_gen/feathers/controls/FormItem.js");

/***/ }),

/***/ "./lib/feathers/controls/GridView.js":
/*!*******************************************!*\
  !*** ./lib/feathers/controls/GridView.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/GridView */ "./lib/_gen/feathers/controls/GridView.js");

/***/ }),

/***/ "./lib/feathers/controls/GridViewColumn.js":
/*!*************************************************!*\
  !*** ./lib/feathers/controls/GridViewColumn.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/GridViewColumn */ "./lib/_gen/feathers/controls/GridViewColumn.js");

/***/ }),

/***/ "./lib/feathers/controls/GridViewRowState.js":
/*!***************************************************!*\
  !*** ./lib/feathers/controls/GridViewRowState.js ***!
  \***************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/GridViewRowState */ "./lib/_gen/feathers/controls/GridViewRowState.js");

/***/ }),

/***/ "./lib/feathers/controls/GroupListView.js":
/*!************************************************!*\
  !*** ./lib/feathers/controls/GroupListView.js ***!
  \************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/GroupListView */ "./lib/_gen/feathers/controls/GroupListView.js");

/***/ }),

/***/ "./lib/feathers/controls/HDividedBox.js":
/*!**********************************************!*\
  !*** ./lib/feathers/controls/HDividedBox.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/HDividedBox */ "./lib/_gen/feathers/controls/HDividedBox.js");

/***/ }),

/***/ "./lib/feathers/controls/HProgressBar.js":
/*!***********************************************!*\
  !*** ./lib/feathers/controls/HProgressBar.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/HProgressBar */ "./lib/_gen/feathers/controls/HProgressBar.js");

/***/ }),

/***/ "./lib/feathers/controls/HScrollBar.js":
/*!*********************************************!*\
  !*** ./lib/feathers/controls/HScrollBar.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/HScrollBar */ "./lib/_gen/feathers/controls/HScrollBar.js");

/***/ }),

/***/ "./lib/feathers/controls/HSlider.js":
/*!******************************************!*\
  !*** ./lib/feathers/controls/HSlider.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/HSlider */ "./lib/_gen/feathers/controls/HSlider.js");

/***/ }),

/***/ "./lib/feathers/controls/Header.js":
/*!*****************************************!*\
  !*** ./lib/feathers/controls/Header.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/Header */ "./lib/_gen/feathers/controls/Header.js");

/***/ }),

/***/ "./lib/feathers/controls/IGridViewColumn.js":
/*!**************************************************!*\
  !*** ./lib/feathers/controls/IGridViewColumn.js ***!
  \**************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/IGridViewColumn */ "./lib/_gen/feathers/controls/IGridViewColumn.js");

/***/ }),

/***/ "./lib/feathers/controls/IGroupedToggle.js":
/*!*************************************************!*\
  !*** ./lib/feathers/controls/IGroupedToggle.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/IGroupedToggle */ "./lib/_gen/feathers/controls/IGroupedToggle.js");

/***/ }),

/***/ "./lib/feathers/controls/IRange.js":
/*!*****************************************!*\
  !*** ./lib/feathers/controls/IRange.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/IRange */ "./lib/_gen/feathers/controls/IRange.js");

/***/ }),

/***/ "./lib/feathers/controls/IScrollBar.js":
/*!*********************************************!*\
  !*** ./lib/feathers/controls/IScrollBar.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/IScrollBar */ "./lib/_gen/feathers/controls/IScrollBar.js");

/***/ }),

/***/ "./lib/feathers/controls/IToggle.js":
/*!******************************************!*\
  !*** ./lib/feathers/controls/IToggle.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/IToggle */ "./lib/_gen/feathers/controls/IToggle.js");

/***/ }),

/***/ "./lib/feathers/controls/ITriggerView.js":
/*!***********************************************!*\
  !*** ./lib/feathers/controls/ITriggerView.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/ITriggerView */ "./lib/_gen/feathers/controls/ITriggerView.js");

/***/ }),

/***/ "./lib/feathers/controls/Label.js":
/*!****************************************!*\
  !*** ./lib/feathers/controls/Label.js ***!
  \****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/Label */ "./lib/_gen/feathers/controls/Label.js");

/***/ }),

/***/ "./lib/feathers/controls/LayoutGroup.js":
/*!**********************************************!*\
  !*** ./lib/feathers/controls/LayoutGroup.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/LayoutGroup */ "./lib/_gen/feathers/controls/LayoutGroup.js");

/***/ }),

/***/ "./lib/feathers/controls/ListView.js":
/*!*******************************************!*\
  !*** ./lib/feathers/controls/ListView.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/ListView */ "./lib/_gen/feathers/controls/ListView.js");

/***/ }),

/***/ "./lib/feathers/controls/NumericStepper.js":
/*!*************************************************!*\
  !*** ./lib/feathers/controls/NumericStepper.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/NumericStepper */ "./lib/_gen/feathers/controls/NumericStepper.js");

/***/ }),

/***/ "./lib/feathers/controls/PageIndicator.js":
/*!************************************************!*\
  !*** ./lib/feathers/controls/PageIndicator.js ***!
  \************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/PageIndicator */ "./lib/_gen/feathers/controls/PageIndicator.js");

/***/ }),

/***/ "./lib/feathers/controls/PageIndicatorInteractionMode.js":
/*!***************************************************************!*\
  !*** ./lib/feathers/controls/PageIndicatorInteractionMode.js ***!
  \***************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/PageIndicatorInteractionMode */ "./lib/_gen/feathers/controls/PageIndicatorInteractionMode.js");

/***/ }),

/***/ "./lib/feathers/controls/Panel.js":
/*!****************************************!*\
  !*** ./lib/feathers/controls/Panel.js ***!
  \****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/Panel */ "./lib/_gen/feathers/controls/Panel.js");

/***/ }),

/***/ "./lib/feathers/controls/PopUpDatePicker.js":
/*!**************************************************!*\
  !*** ./lib/feathers/controls/PopUpDatePicker.js ***!
  \**************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/PopUpDatePicker */ "./lib/_gen/feathers/controls/PopUpDatePicker.js");

/***/ }),

/***/ "./lib/feathers/controls/PopUpListView.js":
/*!************************************************!*\
  !*** ./lib/feathers/controls/PopUpListView.js ***!
  \************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/PopUpListView */ "./lib/_gen/feathers/controls/PopUpListView.js");

/***/ }),

/***/ "./lib/feathers/controls/ProgressBarFillMode.js":
/*!******************************************************!*\
  !*** ./lib/feathers/controls/ProgressBarFillMode.js ***!
  \******************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/ProgressBarFillMode */ "./lib/_gen/feathers/controls/ProgressBarFillMode.js");

/***/ }),

/***/ "./lib/feathers/controls/Radio.js":
/*!****************************************!*\
  !*** ./lib/feathers/controls/Radio.js ***!
  \****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/Radio */ "./lib/_gen/feathers/controls/Radio.js");

/***/ }),

/***/ "./lib/feathers/controls/ScrollContainer.js":
/*!**************************************************!*\
  !*** ./lib/feathers/controls/ScrollContainer.js ***!
  \**************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/ScrollContainer */ "./lib/_gen/feathers/controls/ScrollContainer.js");

/***/ }),

/***/ "./lib/feathers/controls/ScrollMode.js":
/*!*********************************************!*\
  !*** ./lib/feathers/controls/ScrollMode.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/ScrollMode */ "./lib/_gen/feathers/controls/ScrollMode.js");

/***/ }),

/***/ "./lib/feathers/controls/ScrollPolicy.js":
/*!***********************************************!*\
  !*** ./lib/feathers/controls/ScrollPolicy.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/ScrollPolicy */ "./lib/_gen/feathers/controls/ScrollPolicy.js");

/***/ }),

/***/ "./lib/feathers/controls/TabBar.js":
/*!*****************************************!*\
  !*** ./lib/feathers/controls/TabBar.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/TabBar */ "./lib/_gen/feathers/controls/TabBar.js");

/***/ }),

/***/ "./lib/feathers/controls/TextArea.js":
/*!*******************************************!*\
  !*** ./lib/feathers/controls/TextArea.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/TextArea */ "./lib/_gen/feathers/controls/TextArea.js");

/***/ }),

/***/ "./lib/feathers/controls/TextCallout.js":
/*!**********************************************!*\
  !*** ./lib/feathers/controls/TextCallout.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/TextCallout */ "./lib/_gen/feathers/controls/TextCallout.js");

/***/ }),

/***/ "./lib/feathers/controls/TextInput.js":
/*!********************************************!*\
  !*** ./lib/feathers/controls/TextInput.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/TextInput */ "./lib/_gen/feathers/controls/TextInput.js");

/***/ }),

/***/ "./lib/feathers/controls/TextInputState.js":
/*!*************************************************!*\
  !*** ./lib/feathers/controls/TextInputState.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/TextInputState */ "./lib/_gen/feathers/controls/TextInputState.js");

/***/ }),

/***/ "./lib/feathers/controls/ToggleButton.js":
/*!***********************************************!*\
  !*** ./lib/feathers/controls/ToggleButton.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/ToggleButton */ "./lib/_gen/feathers/controls/ToggleButton.js");

/***/ }),

/***/ "./lib/feathers/controls/ToggleButtonState.js":
/*!****************************************************!*\
  !*** ./lib/feathers/controls/ToggleButtonState.js ***!
  \****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/ToggleButtonState */ "./lib/_gen/feathers/controls/ToggleButtonState.js");

/***/ }),

/***/ "./lib/feathers/controls/ToggleSwitch.js":
/*!***********************************************!*\
  !*** ./lib/feathers/controls/ToggleSwitch.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/ToggleSwitch */ "./lib/_gen/feathers/controls/ToggleSwitch.js");

/***/ }),

/***/ "./lib/feathers/controls/TreeGridView.js":
/*!***********************************************!*\
  !*** ./lib/feathers/controls/TreeGridView.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/TreeGridView */ "./lib/_gen/feathers/controls/TreeGridView.js");

/***/ }),

/***/ "./lib/feathers/controls/TreeGridViewColumn.js":
/*!*****************************************************!*\
  !*** ./lib/feathers/controls/TreeGridViewColumn.js ***!
  \*****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/TreeGridViewColumn */ "./lib/_gen/feathers/controls/TreeGridViewColumn.js");

/***/ }),

/***/ "./lib/feathers/controls/TreeGridViewRowState.js":
/*!*******************************************************!*\
  !*** ./lib/feathers/controls/TreeGridViewRowState.js ***!
  \*******************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/TreeGridViewRowState */ "./lib/_gen/feathers/controls/TreeGridViewRowState.js");

/***/ }),

/***/ "./lib/feathers/controls/TreeView.js":
/*!*******************************************!*\
  !*** ./lib/feathers/controls/TreeView.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/TreeView */ "./lib/_gen/feathers/controls/TreeView.js");

/***/ }),

/***/ "./lib/feathers/controls/VDividedBox.js":
/*!**********************************************!*\
  !*** ./lib/feathers/controls/VDividedBox.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/VDividedBox */ "./lib/_gen/feathers/controls/VDividedBox.js");

/***/ }),

/***/ "./lib/feathers/controls/VProgressBar.js":
/*!***********************************************!*\
  !*** ./lib/feathers/controls/VProgressBar.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/VProgressBar */ "./lib/_gen/feathers/controls/VProgressBar.js");

/***/ }),

/***/ "./lib/feathers/controls/VScrollBar.js":
/*!*********************************************!*\
  !*** ./lib/feathers/controls/VScrollBar.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/VScrollBar */ "./lib/_gen/feathers/controls/VScrollBar.js");

/***/ }),

/***/ "./lib/feathers/controls/VSlider.js":
/*!******************************************!*\
  !*** ./lib/feathers/controls/VSlider.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/controls/VSlider */ "./lib/_gen/feathers/controls/VSlider.js");

/***/ }),

/***/ "./lib/feathers/controls/dataRenderers/GridViewHeaderRenderer.js":
/*!***********************************************************************!*\
  !*** ./lib/feathers/controls/dataRenderers/GridViewHeaderRenderer.js ***!
  \***********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/dataRenderers/GridViewHeaderRenderer */ "./lib/_gen/feathers/controls/dataRenderers/GridViewHeaderRenderer.js");

/***/ }),

/***/ "./lib/feathers/controls/dataRenderers/GridViewRowRenderer.js":
/*!********************************************************************!*\
  !*** ./lib/feathers/controls/dataRenderers/GridViewRowRenderer.js ***!
  \********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/dataRenderers/GridViewRowRenderer */ "./lib/_gen/feathers/controls/dataRenderers/GridViewRowRenderer.js");

/***/ }),

/***/ "./lib/feathers/controls/dataRenderers/HierarchicalItemRenderer.js":
/*!*************************************************************************!*\
  !*** ./lib/feathers/controls/dataRenderers/HierarchicalItemRenderer.js ***!
  \*************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/dataRenderers/HierarchicalItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/HierarchicalItemRenderer.js");

/***/ }),

/***/ "./lib/feathers/controls/dataRenderers/IDataRenderer.js":
/*!**************************************************************!*\
  !*** ./lib/feathers/controls/dataRenderers/IDataRenderer.js ***!
  \**************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/dataRenderers/IDataRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IDataRenderer.js");

/***/ }),

/***/ "./lib/feathers/controls/dataRenderers/IGridViewCellRenderer.js":
/*!**********************************************************************!*\
  !*** ./lib/feathers/controls/dataRenderers/IGridViewCellRenderer.js ***!
  \**********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/dataRenderers/IGridViewCellRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IGridViewCellRenderer.js");

/***/ }),

/***/ "./lib/feathers/controls/dataRenderers/IGridViewHeaderRenderer.js":
/*!************************************************************************!*\
  !*** ./lib/feathers/controls/dataRenderers/IGridViewHeaderRenderer.js ***!
  \************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/dataRenderers/IGridViewHeaderRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IGridViewHeaderRenderer.js");

/***/ }),

/***/ "./lib/feathers/controls/dataRenderers/IGroupListViewItemRenderer.js":
/*!***************************************************************************!*\
  !*** ./lib/feathers/controls/dataRenderers/IGroupListViewItemRenderer.js ***!
  \***************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/dataRenderers/IGroupListViewItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IGroupListViewItemRenderer.js");

/***/ }),

/***/ "./lib/feathers/controls/dataRenderers/IHierarchicalDepthItemRenderer.js":
/*!*******************************************************************************!*\
  !*** ./lib/feathers/controls/dataRenderers/IHierarchicalDepthItemRenderer.js ***!
  \*******************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/dataRenderers/IHierarchicalDepthItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IHierarchicalDepthItemRenderer.js");

/***/ }),

/***/ "./lib/feathers/controls/dataRenderers/IHierarchicalItemRenderer.js":
/*!**************************************************************************!*\
  !*** ./lib/feathers/controls/dataRenderers/IHierarchicalItemRenderer.js ***!
  \**************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/dataRenderers/IHierarchicalItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IHierarchicalItemRenderer.js");

/***/ }),

/***/ "./lib/feathers/controls/dataRenderers/IListViewItemRenderer.js":
/*!**********************************************************************!*\
  !*** ./lib/feathers/controls/dataRenderers/IListViewItemRenderer.js ***!
  \**********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/dataRenderers/IListViewItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IListViewItemRenderer.js");

/***/ }),

/***/ "./lib/feathers/controls/dataRenderers/IOptionalHierarchyItemRenderer.js":
/*!*******************************************************************************!*\
  !*** ./lib/feathers/controls/dataRenderers/IOptionalHierarchyItemRenderer.js ***!
  \*******************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/dataRenderers/IOptionalHierarchyItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/IOptionalHierarchyItemRenderer.js");

/***/ }),

/***/ "./lib/feathers/controls/dataRenderers/ITreeGridViewCellRenderer.js":
/*!**************************************************************************!*\
  !*** ./lib/feathers/controls/dataRenderers/ITreeGridViewCellRenderer.js ***!
  \**************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/dataRenderers/ITreeGridViewCellRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ITreeGridViewCellRenderer.js");

/***/ }),

/***/ "./lib/feathers/controls/dataRenderers/ITreeGridViewHeaderRenderer.js":
/*!****************************************************************************!*\
  !*** ./lib/feathers/controls/dataRenderers/ITreeGridViewHeaderRenderer.js ***!
  \****************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/dataRenderers/ITreeGridViewHeaderRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ITreeGridViewHeaderRenderer.js");

/***/ }),

/***/ "./lib/feathers/controls/dataRenderers/ITreeViewItemRenderer.js":
/*!**********************************************************************!*\
  !*** ./lib/feathers/controls/dataRenderers/ITreeViewItemRenderer.js ***!
  \**********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/dataRenderers/ITreeViewItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ITreeViewItemRenderer.js");

/***/ }),

/***/ "./lib/feathers/controls/dataRenderers/ItemRenderer.js":
/*!*************************************************************!*\
  !*** ./lib/feathers/controls/dataRenderers/ItemRenderer.js ***!
  \*************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/dataRenderers/ItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/ItemRenderer.js");

/***/ }),

/***/ "./lib/feathers/controls/dataRenderers/LayoutGroupItemRenderer.js":
/*!************************************************************************!*\
  !*** ./lib/feathers/controls/dataRenderers/LayoutGroupItemRenderer.js ***!
  \************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/dataRenderers/LayoutGroupItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/LayoutGroupItemRenderer.js");

/***/ }),

/***/ "./lib/feathers/controls/dataRenderers/SortOrderHeaderRenderer.js":
/*!************************************************************************!*\
  !*** ./lib/feathers/controls/dataRenderers/SortOrderHeaderRenderer.js ***!
  \************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/dataRenderers/SortOrderHeaderRenderer */ "./lib/_gen/feathers/controls/dataRenderers/SortOrderHeaderRenderer.js");

/***/ }),

/***/ "./lib/feathers/controls/dataRenderers/TreeGridViewCellRenderer.js":
/*!*************************************************************************!*\
  !*** ./lib/feathers/controls/dataRenderers/TreeGridViewCellRenderer.js ***!
  \*************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/dataRenderers/TreeGridViewCellRenderer */ "./lib/_gen/feathers/controls/dataRenderers/TreeGridViewCellRenderer.js");

/***/ }),

/***/ "./lib/feathers/controls/dataRenderers/TreeGridViewRowRenderer.js":
/*!************************************************************************!*\
  !*** ./lib/feathers/controls/dataRenderers/TreeGridViewRowRenderer.js ***!
  \************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/dataRenderers/TreeGridViewRowRenderer */ "./lib/_gen/feathers/controls/dataRenderers/TreeGridViewRowRenderer.js");

/***/ }),

/***/ "./lib/feathers/controls/dataRenderers/TreeViewItemRenderer.js":
/*!*********************************************************************!*\
  !*** ./lib/feathers/controls/dataRenderers/TreeViewItemRenderer.js ***!
  \*********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/dataRenderers/TreeViewItemRenderer */ "./lib/_gen/feathers/controls/dataRenderers/TreeViewItemRenderer.js");

/***/ }),

/***/ "./lib/feathers/controls/dataRenderers/index.js":
/*!******************************************************!*\
  !*** ./lib/feathers/controls/dataRenderers/index.js ***!
  \******************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	GridViewHeaderRenderer: (__webpack_require__(/*! ./GridViewHeaderRenderer */ "./lib/feathers/controls/dataRenderers/GridViewHeaderRenderer.js")["default"]),
	GridViewRowRenderer: (__webpack_require__(/*! ./GridViewRowRenderer */ "./lib/feathers/controls/dataRenderers/GridViewRowRenderer.js")["default"]),
	HierarchicalItemRenderer: (__webpack_require__(/*! ./HierarchicalItemRenderer */ "./lib/feathers/controls/dataRenderers/HierarchicalItemRenderer.js")["default"]),
	IDataRenderer: (__webpack_require__(/*! ./IDataRenderer */ "./lib/feathers/controls/dataRenderers/IDataRenderer.js")["default"]),
	IGridViewCellRenderer: (__webpack_require__(/*! ./IGridViewCellRenderer */ "./lib/feathers/controls/dataRenderers/IGridViewCellRenderer.js")["default"]),
	IGridViewHeaderRenderer: (__webpack_require__(/*! ./IGridViewHeaderRenderer */ "./lib/feathers/controls/dataRenderers/IGridViewHeaderRenderer.js")["default"]),
	IGroupListViewItemRenderer: (__webpack_require__(/*! ./IGroupListViewItemRenderer */ "./lib/feathers/controls/dataRenderers/IGroupListViewItemRenderer.js")["default"]),
	IHierarchicalDepthItemRenderer: (__webpack_require__(/*! ./IHierarchicalDepthItemRenderer */ "./lib/feathers/controls/dataRenderers/IHierarchicalDepthItemRenderer.js")["default"]),
	IHierarchicalItemRenderer: (__webpack_require__(/*! ./IHierarchicalItemRenderer */ "./lib/feathers/controls/dataRenderers/IHierarchicalItemRenderer.js")["default"]),
	IListViewItemRenderer: (__webpack_require__(/*! ./IListViewItemRenderer */ "./lib/feathers/controls/dataRenderers/IListViewItemRenderer.js")["default"]),
	IOptionalHierarchyItemRenderer: (__webpack_require__(/*! ./IOptionalHierarchyItemRenderer */ "./lib/feathers/controls/dataRenderers/IOptionalHierarchyItemRenderer.js")["default"]),
	ITreeGridViewCellRenderer: (__webpack_require__(/*! ./ITreeGridViewCellRenderer */ "./lib/feathers/controls/dataRenderers/ITreeGridViewCellRenderer.js")["default"]),
	ITreeGridViewHeaderRenderer: (__webpack_require__(/*! ./ITreeGridViewHeaderRenderer */ "./lib/feathers/controls/dataRenderers/ITreeGridViewHeaderRenderer.js")["default"]),
	ITreeViewItemRenderer: (__webpack_require__(/*! ./ITreeViewItemRenderer */ "./lib/feathers/controls/dataRenderers/ITreeViewItemRenderer.js")["default"]),
	ItemRenderer: (__webpack_require__(/*! ./ItemRenderer */ "./lib/feathers/controls/dataRenderers/ItemRenderer.js")["default"]),
	LayoutGroupItemRenderer: (__webpack_require__(/*! ./LayoutGroupItemRenderer */ "./lib/feathers/controls/dataRenderers/LayoutGroupItemRenderer.js")["default"]),
	SortOrderHeaderRenderer: (__webpack_require__(/*! ./SortOrderHeaderRenderer */ "./lib/feathers/controls/dataRenderers/SortOrderHeaderRenderer.js")["default"]),
	TreeGridViewCellRenderer: (__webpack_require__(/*! ./TreeGridViewCellRenderer */ "./lib/feathers/controls/dataRenderers/TreeGridViewCellRenderer.js")["default"]),
	TreeGridViewRowRenderer: (__webpack_require__(/*! ./TreeGridViewRowRenderer */ "./lib/feathers/controls/dataRenderers/TreeGridViewRowRenderer.js")["default"]),
	TreeViewItemRenderer: (__webpack_require__(/*! ./TreeViewItemRenderer */ "./lib/feathers/controls/dataRenderers/TreeViewItemRenderer.js")["default"]),
}

/***/ }),

/***/ "./lib/feathers/controls/index.js":
/*!****************************************!*\
  !*** ./lib/feathers/controls/index.js ***!
  \****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	ActivityIndicator: (__webpack_require__(/*! ./ActivityIndicator */ "./lib/feathers/controls/ActivityIndicator.js")["default"]),
	Alert: (__webpack_require__(/*! ./Alert */ "./lib/feathers/controls/Alert.js")["default"]),
	Application: (__webpack_require__(/*! ./Application */ "./lib/feathers/controls/Application.js")["default"]),
	AssetLoader: (__webpack_require__(/*! ./AssetLoader */ "./lib/feathers/controls/AssetLoader.js")["default"]),
	BasicButton: (__webpack_require__(/*! ./BasicButton */ "./lib/feathers/controls/BasicButton.js")["default"]),
	BasicToggleButton: (__webpack_require__(/*! ./BasicToggleButton */ "./lib/feathers/controls/BasicToggleButton.js")["default"]),
	Button: (__webpack_require__(/*! ./Button */ "./lib/feathers/controls/Button.js")["default"]),
	ButtonBar: (__webpack_require__(/*! ./ButtonBar */ "./lib/feathers/controls/ButtonBar.js")["default"]),
	ButtonState: (__webpack_require__(/*! ./ButtonState */ "./lib/feathers/controls/ButtonState.js")["default"]),
	CalendarGrid: (__webpack_require__(/*! ./CalendarGrid */ "./lib/feathers/controls/CalendarGrid.js")["default"]),
	Callout: (__webpack_require__(/*! ./Callout */ "./lib/feathers/controls/Callout.js")["default"]),
	Check: (__webpack_require__(/*! ./Check */ "./lib/feathers/controls/Check.js")["default"]),
	ComboBox: (__webpack_require__(/*! ./ComboBox */ "./lib/feathers/controls/ComboBox.js")["default"]),
	DatePicker: (__webpack_require__(/*! ./DatePicker */ "./lib/feathers/controls/DatePicker.js")["default"]),
	Drawer: (__webpack_require__(/*! ./Drawer */ "./lib/feathers/controls/Drawer.js")["default"]),
	Form: (__webpack_require__(/*! ./Form */ "./lib/feathers/controls/Form.js")["default"]),
	FormItem: (__webpack_require__(/*! ./FormItem */ "./lib/feathers/controls/FormItem.js")["default"]),
	GridView: (__webpack_require__(/*! ./GridView */ "./lib/feathers/controls/GridView.js")["default"]),
	GridViewColumn: (__webpack_require__(/*! ./GridViewColumn */ "./lib/feathers/controls/GridViewColumn.js")["default"]),
	GridViewRowState: (__webpack_require__(/*! ./GridViewRowState */ "./lib/feathers/controls/GridViewRowState.js")["default"]),
	GroupListView: (__webpack_require__(/*! ./GroupListView */ "./lib/feathers/controls/GroupListView.js")["default"]),
	HDividedBox: (__webpack_require__(/*! ./HDividedBox */ "./lib/feathers/controls/HDividedBox.js")["default"]),
	HProgressBar: (__webpack_require__(/*! ./HProgressBar */ "./lib/feathers/controls/HProgressBar.js")["default"]),
	HScrollBar: (__webpack_require__(/*! ./HScrollBar */ "./lib/feathers/controls/HScrollBar.js")["default"]),
	HSlider: (__webpack_require__(/*! ./HSlider */ "./lib/feathers/controls/HSlider.js")["default"]),
	Header: (__webpack_require__(/*! ./Header */ "./lib/feathers/controls/Header.js")["default"]),
	IGridViewColumn: (__webpack_require__(/*! ./IGridViewColumn */ "./lib/feathers/controls/IGridViewColumn.js")["default"]),
	IGroupedToggle: (__webpack_require__(/*! ./IGroupedToggle */ "./lib/feathers/controls/IGroupedToggle.js")["default"]),
	IRange: (__webpack_require__(/*! ./IRange */ "./lib/feathers/controls/IRange.js")["default"]),
	IScrollBar: (__webpack_require__(/*! ./IScrollBar */ "./lib/feathers/controls/IScrollBar.js")["default"]),
	IToggle: (__webpack_require__(/*! ./IToggle */ "./lib/feathers/controls/IToggle.js")["default"]),
	ITriggerView: (__webpack_require__(/*! ./ITriggerView */ "./lib/feathers/controls/ITriggerView.js")["default"]),
	Label: (__webpack_require__(/*! ./Label */ "./lib/feathers/controls/Label.js")["default"]),
	LayoutGroup: (__webpack_require__(/*! ./LayoutGroup */ "./lib/feathers/controls/LayoutGroup.js")["default"]),
	ListView: (__webpack_require__(/*! ./ListView */ "./lib/feathers/controls/ListView.js")["default"]),
	NumericStepper: (__webpack_require__(/*! ./NumericStepper */ "./lib/feathers/controls/NumericStepper.js")["default"]),
	PageIndicator: (__webpack_require__(/*! ./PageIndicator */ "./lib/feathers/controls/PageIndicator.js")["default"]),
	PageIndicatorInteractionMode: (__webpack_require__(/*! ./PageIndicatorInteractionMode */ "./lib/feathers/controls/PageIndicatorInteractionMode.js")["default"]),
	Panel: (__webpack_require__(/*! ./Panel */ "./lib/feathers/controls/Panel.js")["default"]),
	PopUpDatePicker: (__webpack_require__(/*! ./PopUpDatePicker */ "./lib/feathers/controls/PopUpDatePicker.js")["default"]),
	PopUpListView: (__webpack_require__(/*! ./PopUpListView */ "./lib/feathers/controls/PopUpListView.js")["default"]),
	ProgressBarFillMode: (__webpack_require__(/*! ./ProgressBarFillMode */ "./lib/feathers/controls/ProgressBarFillMode.js")["default"]),
	Radio: (__webpack_require__(/*! ./Radio */ "./lib/feathers/controls/Radio.js")["default"]),
	ScrollContainer: (__webpack_require__(/*! ./ScrollContainer */ "./lib/feathers/controls/ScrollContainer.js")["default"]),
	ScrollMode: (__webpack_require__(/*! ./ScrollMode */ "./lib/feathers/controls/ScrollMode.js")["default"]),
	ScrollPolicy: (__webpack_require__(/*! ./ScrollPolicy */ "./lib/feathers/controls/ScrollPolicy.js")["default"]),
	TabBar: (__webpack_require__(/*! ./TabBar */ "./lib/feathers/controls/TabBar.js")["default"]),
	TextArea: (__webpack_require__(/*! ./TextArea */ "./lib/feathers/controls/TextArea.js")["default"]),
	TextCallout: (__webpack_require__(/*! ./TextCallout */ "./lib/feathers/controls/TextCallout.js")["default"]),
	TextInput: (__webpack_require__(/*! ./TextInput */ "./lib/feathers/controls/TextInput.js")["default"]),
	TextInputState: (__webpack_require__(/*! ./TextInputState */ "./lib/feathers/controls/TextInputState.js")["default"]),
	ToggleButton: (__webpack_require__(/*! ./ToggleButton */ "./lib/feathers/controls/ToggleButton.js")["default"]),
	ToggleButtonState: (__webpack_require__(/*! ./ToggleButtonState */ "./lib/feathers/controls/ToggleButtonState.js")["default"]),
	ToggleSwitch: (__webpack_require__(/*! ./ToggleSwitch */ "./lib/feathers/controls/ToggleSwitch.js")["default"]),
	TreeGridView: (__webpack_require__(/*! ./TreeGridView */ "./lib/feathers/controls/TreeGridView.js")["default"]),
	TreeGridViewColumn: (__webpack_require__(/*! ./TreeGridViewColumn */ "./lib/feathers/controls/TreeGridViewColumn.js")["default"]),
	TreeGridViewRowState: (__webpack_require__(/*! ./TreeGridViewRowState */ "./lib/feathers/controls/TreeGridViewRowState.js")["default"]),
	TreeView: (__webpack_require__(/*! ./TreeView */ "./lib/feathers/controls/TreeView.js")["default"]),
	VDividedBox: (__webpack_require__(/*! ./VDividedBox */ "./lib/feathers/controls/VDividedBox.js")["default"]),
	VProgressBar: (__webpack_require__(/*! ./VProgressBar */ "./lib/feathers/controls/VProgressBar.js")["default"]),
	VScrollBar: (__webpack_require__(/*! ./VScrollBar */ "./lib/feathers/controls/VScrollBar.js")["default"]),
	VSlider: (__webpack_require__(/*! ./VSlider */ "./lib/feathers/controls/VSlider.js")["default"]),
	dataRenderers: __webpack_require__(/*! ./dataRenderers */ "./lib/feathers/controls/dataRenderers/index.js"),
	navigators: __webpack_require__(/*! ./navigators */ "./lib/feathers/controls/navigators/index.js"),
	popups: __webpack_require__(/*! ./popups */ "./lib/feathers/controls/popups/index.js"),
	supportClasses: __webpack_require__(/*! ./supportClasses */ "./lib/feathers/controls/supportClasses/index.js"),
}

/***/ }),

/***/ "./lib/feathers/controls/navigators/BaseNavigator.js":
/*!***********************************************************!*\
  !*** ./lib/feathers/controls/navigators/BaseNavigator.js ***!
  \***********************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/navigators/BaseNavigator */ "./lib/_gen/feathers/controls/navigators/BaseNavigator.js");

/***/ }),

/***/ "./lib/feathers/controls/navigators/PageItem.js":
/*!******************************************************!*\
  !*** ./lib/feathers/controls/navigators/PageItem.js ***!
  \******************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/navigators/PageItem */ "./lib/_gen/feathers/controls/navigators/PageItem.js");

/***/ }),

/***/ "./lib/feathers/controls/navigators/PageNavigator.js":
/*!***********************************************************!*\
  !*** ./lib/feathers/controls/navigators/PageNavigator.js ***!
  \***********************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/navigators/PageNavigator */ "./lib/_gen/feathers/controls/navigators/PageNavigator.js");

/***/ }),

/***/ "./lib/feathers/controls/navigators/Route.js":
/*!***************************************************!*\
  !*** ./lib/feathers/controls/navigators/Route.js ***!
  \***************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/navigators/Route */ "./lib/_gen/feathers/controls/navigators/Route.js");

/***/ }),

/***/ "./lib/feathers/controls/navigators/RouterAction.js":
/*!**********************************************************!*\
  !*** ./lib/feathers/controls/navigators/RouterAction.js ***!
  \**********************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/navigators/RouterAction */ "./lib/_gen/feathers/controls/navigators/RouterAction.js");

/***/ }),

/***/ "./lib/feathers/controls/navigators/RouterNavigator.js":
/*!*************************************************************!*\
  !*** ./lib/feathers/controls/navigators/RouterNavigator.js ***!
  \*************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/navigators/RouterNavigator */ "./lib/_gen/feathers/controls/navigators/RouterNavigator.js");

/***/ }),

/***/ "./lib/feathers/controls/navigators/StackAction.js":
/*!*********************************************************!*\
  !*** ./lib/feathers/controls/navigators/StackAction.js ***!
  \*********************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/navigators/StackAction */ "./lib/_gen/feathers/controls/navigators/StackAction.js");

/***/ }),

/***/ "./lib/feathers/controls/navigators/StackItem.js":
/*!*******************************************************!*\
  !*** ./lib/feathers/controls/navigators/StackItem.js ***!
  \*******************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/navigators/StackItem */ "./lib/_gen/feathers/controls/navigators/StackItem.js");

/***/ }),

/***/ "./lib/feathers/controls/navigators/StackNavigator.js":
/*!************************************************************!*\
  !*** ./lib/feathers/controls/navigators/StackNavigator.js ***!
  \************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/navigators/StackNavigator */ "./lib/_gen/feathers/controls/navigators/StackNavigator.js");

/***/ }),

/***/ "./lib/feathers/controls/navigators/TabItem.js":
/*!*****************************************************!*\
  !*** ./lib/feathers/controls/navigators/TabItem.js ***!
  \*****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/navigators/TabItem */ "./lib/_gen/feathers/controls/navigators/TabItem.js");

/***/ }),

/***/ "./lib/feathers/controls/navigators/TabNavigator.js":
/*!**********************************************************!*\
  !*** ./lib/feathers/controls/navigators/TabNavigator.js ***!
  \**********************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/navigators/TabNavigator */ "./lib/_gen/feathers/controls/navigators/TabNavigator.js");

/***/ }),

/***/ "./lib/feathers/controls/navigators/index.js":
/*!***************************************************!*\
  !*** ./lib/feathers/controls/navigators/index.js ***!
  \***************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	BaseNavigator: (__webpack_require__(/*! ./BaseNavigator */ "./lib/feathers/controls/navigators/BaseNavigator.js")["default"]),
	PageItem: (__webpack_require__(/*! ./PageItem */ "./lib/feathers/controls/navigators/PageItem.js")["default"]),
	PageNavigator: (__webpack_require__(/*! ./PageNavigator */ "./lib/feathers/controls/navigators/PageNavigator.js")["default"]),
	Route: (__webpack_require__(/*! ./Route */ "./lib/feathers/controls/navigators/Route.js")["default"]),
	RouterAction: (__webpack_require__(/*! ./RouterAction */ "./lib/feathers/controls/navigators/RouterAction.js")["default"]),
	RouterNavigator: (__webpack_require__(/*! ./RouterNavigator */ "./lib/feathers/controls/navigators/RouterNavigator.js")["default"]),
	StackAction: (__webpack_require__(/*! ./StackAction */ "./lib/feathers/controls/navigators/StackAction.js")["default"]),
	StackItem: (__webpack_require__(/*! ./StackItem */ "./lib/feathers/controls/navigators/StackItem.js")["default"]),
	StackNavigator: (__webpack_require__(/*! ./StackNavigator */ "./lib/feathers/controls/navigators/StackNavigator.js")["default"]),
	TabItem: (__webpack_require__(/*! ./TabItem */ "./lib/feathers/controls/navigators/TabItem.js")["default"]),
	TabNavigator: (__webpack_require__(/*! ./TabNavigator */ "./lib/feathers/controls/navigators/TabNavigator.js")["default"]),
}

/***/ }),

/***/ "./lib/feathers/controls/popups/CalloutPopUpAdapter.js":
/*!*************************************************************!*\
  !*** ./lib/feathers/controls/popups/CalloutPopUpAdapter.js ***!
  \*************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/popups/CalloutPopUpAdapter */ "./lib/_gen/feathers/controls/popups/CalloutPopUpAdapter.js");

/***/ }),

/***/ "./lib/feathers/controls/popups/DropDownPopUpAdapter.js":
/*!**************************************************************!*\
  !*** ./lib/feathers/controls/popups/DropDownPopUpAdapter.js ***!
  \**************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/popups/DropDownPopUpAdapter */ "./lib/_gen/feathers/controls/popups/DropDownPopUpAdapter.js");

/***/ }),

/***/ "./lib/feathers/controls/popups/IPopUpAdapter.js":
/*!*******************************************************!*\
  !*** ./lib/feathers/controls/popups/IPopUpAdapter.js ***!
  \*******************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/popups/IPopUpAdapter */ "./lib/_gen/feathers/controls/popups/IPopUpAdapter.js");

/***/ }),

/***/ "./lib/feathers/controls/popups/index.js":
/*!***********************************************!*\
  !*** ./lib/feathers/controls/popups/index.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	CalloutPopUpAdapter: (__webpack_require__(/*! ./CalloutPopUpAdapter */ "./lib/feathers/controls/popups/CalloutPopUpAdapter.js")["default"]),
	DropDownPopUpAdapter: (__webpack_require__(/*! ./DropDownPopUpAdapter */ "./lib/feathers/controls/popups/DropDownPopUpAdapter.js")["default"]),
	IPopUpAdapter: (__webpack_require__(/*! ./IPopUpAdapter */ "./lib/feathers/controls/popups/IPopUpAdapter.js")["default"]),
}

/***/ }),

/***/ "./lib/feathers/controls/supportClasses/AdvancedLayoutViewPort.js":
/*!************************************************************************!*\
  !*** ./lib/feathers/controls/supportClasses/AdvancedLayoutViewPort.js ***!
  \************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/supportClasses/AdvancedLayoutViewPort */ "./lib/_gen/feathers/controls/supportClasses/AdvancedLayoutViewPort.js");

/***/ }),

/***/ "./lib/feathers/controls/supportClasses/BaseDividedBox.js":
/*!****************************************************************!*\
  !*** ./lib/feathers/controls/supportClasses/BaseDividedBox.js ***!
  \****************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/supportClasses/BaseDividedBox */ "./lib/_gen/feathers/controls/supportClasses/BaseDividedBox.js");

/***/ }),

/***/ "./lib/feathers/controls/supportClasses/BaseProgressBar.js":
/*!*****************************************************************!*\
  !*** ./lib/feathers/controls/supportClasses/BaseProgressBar.js ***!
  \*****************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/supportClasses/BaseProgressBar */ "./lib/_gen/feathers/controls/supportClasses/BaseProgressBar.js");

/***/ }),

/***/ "./lib/feathers/controls/supportClasses/BaseScrollBar.js":
/*!***************************************************************!*\
  !*** ./lib/feathers/controls/supportClasses/BaseScrollBar.js ***!
  \***************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/supportClasses/BaseScrollBar */ "./lib/_gen/feathers/controls/supportClasses/BaseScrollBar.js");

/***/ }),

/***/ "./lib/feathers/controls/supportClasses/BaseScrollContainer.js":
/*!*********************************************************************!*\
  !*** ./lib/feathers/controls/supportClasses/BaseScrollContainer.js ***!
  \*********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/supportClasses/BaseScrollContainer */ "./lib/_gen/feathers/controls/supportClasses/BaseScrollContainer.js");

/***/ }),

/***/ "./lib/feathers/controls/supportClasses/BaseSlider.js":
/*!************************************************************!*\
  !*** ./lib/feathers/controls/supportClasses/BaseSlider.js ***!
  \************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/supportClasses/BaseSlider */ "./lib/_gen/feathers/controls/supportClasses/BaseSlider.js");

/***/ }),

/***/ "./lib/feathers/controls/supportClasses/IViewPort.js":
/*!***********************************************************!*\
  !*** ./lib/feathers/controls/supportClasses/IViewPort.js ***!
  \***********************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/supportClasses/IViewPort */ "./lib/_gen/feathers/controls/supportClasses/IViewPort.js");

/***/ }),

/***/ "./lib/feathers/controls/supportClasses/LayoutViewPort.js":
/*!****************************************************************!*\
  !*** ./lib/feathers/controls/supportClasses/LayoutViewPort.js ***!
  \****************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/supportClasses/LayoutViewPort */ "./lib/_gen/feathers/controls/supportClasses/LayoutViewPort.js");

/***/ }),

/***/ "./lib/feathers/controls/supportClasses/TextFieldViewPort.js":
/*!*******************************************************************!*\
  !*** ./lib/feathers/controls/supportClasses/TextFieldViewPort.js ***!
  \*******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/controls/supportClasses/TextFieldViewPort */ "./lib/_gen/feathers/controls/supportClasses/TextFieldViewPort.js");

/***/ }),

/***/ "./lib/feathers/controls/supportClasses/index.js":
/*!*******************************************************!*\
  !*** ./lib/feathers/controls/supportClasses/index.js ***!
  \*******************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	AdvancedLayoutViewPort: (__webpack_require__(/*! ./AdvancedLayoutViewPort */ "./lib/feathers/controls/supportClasses/AdvancedLayoutViewPort.js")["default"]),
	BaseDividedBox: (__webpack_require__(/*! ./BaseDividedBox */ "./lib/feathers/controls/supportClasses/BaseDividedBox.js")["default"]),
	BaseProgressBar: (__webpack_require__(/*! ./BaseProgressBar */ "./lib/feathers/controls/supportClasses/BaseProgressBar.js")["default"]),
	BaseScrollBar: (__webpack_require__(/*! ./BaseScrollBar */ "./lib/feathers/controls/supportClasses/BaseScrollBar.js")["default"]),
	BaseScrollContainer: (__webpack_require__(/*! ./BaseScrollContainer */ "./lib/feathers/controls/supportClasses/BaseScrollContainer.js")["default"]),
	BaseSlider: (__webpack_require__(/*! ./BaseSlider */ "./lib/feathers/controls/supportClasses/BaseSlider.js")["default"]),
	IViewPort: (__webpack_require__(/*! ./IViewPort */ "./lib/feathers/controls/supportClasses/IViewPort.js")["default"]),
	LayoutViewPort: (__webpack_require__(/*! ./LayoutViewPort */ "./lib/feathers/controls/supportClasses/LayoutViewPort.js")["default"]),
	TextFieldViewPort: (__webpack_require__(/*! ./TextFieldViewPort */ "./lib/feathers/controls/supportClasses/TextFieldViewPort.js")["default"]),
}

/***/ }),

/***/ "./lib/feathers/core/CustomScaleManager.js":
/*!*************************************************!*\
  !*** ./lib/feathers/core/CustomScaleManager.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/CustomScaleManager */ "./lib/_gen/feathers/core/CustomScaleManager.js");

/***/ }),

/***/ "./lib/feathers/core/DefaultFocusManager.js":
/*!**************************************************!*\
  !*** ./lib/feathers/core/DefaultFocusManager.js ***!
  \**************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/DefaultFocusManager */ "./lib/_gen/feathers/core/DefaultFocusManager.js");

/***/ }),

/***/ "./lib/feathers/core/DefaultPopUpManager.js":
/*!**************************************************!*\
  !*** ./lib/feathers/core/DefaultPopUpManager.js ***!
  \**************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/DefaultPopUpManager */ "./lib/_gen/feathers/core/DefaultPopUpManager.js");

/***/ }),

/***/ "./lib/feathers/core/DefaultToolTipManager.js":
/*!****************************************************!*\
  !*** ./lib/feathers/core/DefaultToolTipManager.js ***!
  \****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/DefaultToolTipManager */ "./lib/_gen/feathers/core/DefaultToolTipManager.js");

/***/ }),

/***/ "./lib/feathers/core/FeathersControl.js":
/*!**********************************************!*\
  !*** ./lib/feathers/core/FeathersControl.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/FeathersControl */ "./lib/_gen/feathers/core/FeathersControl.js");

/***/ }),

/***/ "./lib/feathers/core/FocusManager.js":
/*!*******************************************!*\
  !*** ./lib/feathers/core/FocusManager.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/FocusManager */ "./lib/_gen/feathers/core/FocusManager.js");

/***/ }),

/***/ "./lib/feathers/core/IDataSelector.js":
/*!********************************************!*\
  !*** ./lib/feathers/core/IDataSelector.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IDataSelector */ "./lib/_gen/feathers/core/IDataSelector.js");

/***/ }),

/***/ "./lib/feathers/core/IDateSelector.js":
/*!********************************************!*\
  !*** ./lib/feathers/core/IDateSelector.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IDateSelector */ "./lib/_gen/feathers/core/IDateSelector.js");

/***/ }),

/***/ "./lib/feathers/core/IDisplayObject.js":
/*!*********************************************!*\
  !*** ./lib/feathers/core/IDisplayObject.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IDisplayObject */ "./lib/_gen/feathers/core/IDisplayObject.js");

/***/ }),

/***/ "./lib/feathers/core/IFocusContainer.js":
/*!**********************************************!*\
  !*** ./lib/feathers/core/IFocusContainer.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IFocusContainer */ "./lib/_gen/feathers/core/IFocusContainer.js");

/***/ }),

/***/ "./lib/feathers/core/IFocusExclusions.js":
/*!***********************************************!*\
  !*** ./lib/feathers/core/IFocusExclusions.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IFocusExclusions */ "./lib/_gen/feathers/core/IFocusExclusions.js");

/***/ }),

/***/ "./lib/feathers/core/IFocusExtras.js":
/*!*******************************************!*\
  !*** ./lib/feathers/core/IFocusExtras.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IFocusExtras */ "./lib/_gen/feathers/core/IFocusExtras.js");

/***/ }),

/***/ "./lib/feathers/core/IFocusManager.js":
/*!********************************************!*\
  !*** ./lib/feathers/core/IFocusManager.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IFocusManager */ "./lib/_gen/feathers/core/IFocusManager.js");

/***/ }),

/***/ "./lib/feathers/core/IFocusManagerAware.js":
/*!*************************************************!*\
  !*** ./lib/feathers/core/IFocusManagerAware.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IFocusManagerAware */ "./lib/_gen/feathers/core/IFocusManagerAware.js");

/***/ }),

/***/ "./lib/feathers/core/IFocusObject.js":
/*!*******************************************!*\
  !*** ./lib/feathers/core/IFocusObject.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IFocusObject */ "./lib/_gen/feathers/core/IFocusObject.js");

/***/ }),

/***/ "./lib/feathers/core/IHTMLTextControl.js":
/*!***********************************************!*\
  !*** ./lib/feathers/core/IHTMLTextControl.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IHTMLTextControl */ "./lib/_gen/feathers/core/IHTMLTextControl.js");

/***/ }),

/***/ "./lib/feathers/core/IIndexSelector.js":
/*!*********************************************!*\
  !*** ./lib/feathers/core/IIndexSelector.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IIndexSelector */ "./lib/_gen/feathers/core/IIndexSelector.js");

/***/ }),

/***/ "./lib/feathers/core/IMeasureObject.js":
/*!*********************************************!*\
  !*** ./lib/feathers/core/IMeasureObject.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IMeasureObject */ "./lib/_gen/feathers/core/IMeasureObject.js");

/***/ }),

/***/ "./lib/feathers/core/IOpenCloseToggle.js":
/*!***********************************************!*\
  !*** ./lib/feathers/core/IOpenCloseToggle.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IOpenCloseToggle */ "./lib/_gen/feathers/core/IOpenCloseToggle.js");

/***/ }),

/***/ "./lib/feathers/core/IPointerDelegate.js":
/*!***********************************************!*\
  !*** ./lib/feathers/core/IPointerDelegate.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IPointerDelegate */ "./lib/_gen/feathers/core/IPointerDelegate.js");

/***/ }),

/***/ "./lib/feathers/core/IPopUpManager.js":
/*!********************************************!*\
  !*** ./lib/feathers/core/IPopUpManager.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IPopUpManager */ "./lib/_gen/feathers/core/IPopUpManager.js");

/***/ }),

/***/ "./lib/feathers/core/IScaleManager.js":
/*!********************************************!*\
  !*** ./lib/feathers/core/IScaleManager.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IScaleManager */ "./lib/_gen/feathers/core/IScaleManager.js");

/***/ }),

/***/ "./lib/feathers/core/IStageFocusDelegate.js":
/*!**************************************************!*\
  !*** ./lib/feathers/core/IStageFocusDelegate.js ***!
  \**************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IStageFocusDelegate */ "./lib/_gen/feathers/core/IStageFocusDelegate.js");

/***/ }),

/***/ "./lib/feathers/core/IStateContext.js":
/*!********************************************!*\
  !*** ./lib/feathers/core/IStateContext.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IStateContext */ "./lib/_gen/feathers/core/IStateContext.js");

/***/ }),

/***/ "./lib/feathers/core/IStateObserver.js":
/*!*********************************************!*\
  !*** ./lib/feathers/core/IStateObserver.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IStateObserver */ "./lib/_gen/feathers/core/IStateObserver.js");

/***/ }),

/***/ "./lib/feathers/core/ITextControl.js":
/*!*******************************************!*\
  !*** ./lib/feathers/core/ITextControl.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/ITextControl */ "./lib/_gen/feathers/core/ITextControl.js");

/***/ }),

/***/ "./lib/feathers/core/IToolTipManager.js":
/*!**********************************************!*\
  !*** ./lib/feathers/core/IToolTipManager.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IToolTipManager */ "./lib/_gen/feathers/core/IToolTipManager.js");

/***/ }),

/***/ "./lib/feathers/core/IUIControl.js":
/*!*****************************************!*\
  !*** ./lib/feathers/core/IUIControl.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IUIControl */ "./lib/_gen/feathers/core/IUIControl.js");

/***/ }),

/***/ "./lib/feathers/core/IValidating.js":
/*!******************************************!*\
  !*** ./lib/feathers/core/IValidating.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/IValidating */ "./lib/_gen/feathers/core/IValidating.js");

/***/ }),

/***/ "./lib/feathers/core/InvalidationFlag.js":
/*!***********************************************!*\
  !*** ./lib/feathers/core/InvalidationFlag.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/InvalidationFlag */ "./lib/_gen/feathers/core/InvalidationFlag.js");

/***/ }),

/***/ "./lib/feathers/core/LetterboxScaleManager.js":
/*!****************************************************!*\
  !*** ./lib/feathers/core/LetterboxScaleManager.js ***!
  \****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/LetterboxScaleManager */ "./lib/_gen/feathers/core/LetterboxScaleManager.js");

/***/ }),

/***/ "./lib/feathers/core/MeasureSprite.js":
/*!********************************************!*\
  !*** ./lib/feathers/core/MeasureSprite.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/MeasureSprite */ "./lib/_gen/feathers/core/MeasureSprite.js");

/***/ }),

/***/ "./lib/feathers/core/PopUpManager.js":
/*!*******************************************!*\
  !*** ./lib/feathers/core/PopUpManager.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/PopUpManager */ "./lib/_gen/feathers/core/PopUpManager.js");

/***/ }),

/***/ "./lib/feathers/core/ScreenDensityScaleManager.js":
/*!********************************************************!*\
  !*** ./lib/feathers/core/ScreenDensityScaleManager.js ***!
  \********************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/ScreenDensityScaleManager */ "./lib/_gen/feathers/core/ScreenDensityScaleManager.js");

/***/ }),

/***/ "./lib/feathers/core/ToggleGroup.js":
/*!******************************************!*\
  !*** ./lib/feathers/core/ToggleGroup.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/ToggleGroup */ "./lib/_gen/feathers/core/ToggleGroup.js");

/***/ }),

/***/ "./lib/feathers/core/ToolTipManager.js":
/*!*********************************************!*\
  !*** ./lib/feathers/core/ToolTipManager.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/ToolTipManager */ "./lib/_gen/feathers/core/ToolTipManager.js");

/***/ }),

/***/ "./lib/feathers/core/ValidatingSprite.js":
/*!***********************************************!*\
  !*** ./lib/feathers/core/ValidatingSprite.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/ValidatingSprite */ "./lib/_gen/feathers/core/ValidatingSprite.js");

/***/ }),

/***/ "./lib/feathers/core/ValidationQueue.js":
/*!**********************************************!*\
  !*** ./lib/feathers/core/ValidationQueue.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/core/ValidationQueue */ "./lib/_gen/feathers/core/ValidationQueue.js");

/***/ }),

/***/ "./lib/feathers/core/index.js":
/*!************************************!*\
  !*** ./lib/feathers/core/index.js ***!
  \************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	CustomScaleManager: (__webpack_require__(/*! ./CustomScaleManager */ "./lib/feathers/core/CustomScaleManager.js")["default"]),
	DefaultFocusManager: (__webpack_require__(/*! ./DefaultFocusManager */ "./lib/feathers/core/DefaultFocusManager.js")["default"]),
	DefaultPopUpManager: (__webpack_require__(/*! ./DefaultPopUpManager */ "./lib/feathers/core/DefaultPopUpManager.js")["default"]),
	DefaultToolTipManager: (__webpack_require__(/*! ./DefaultToolTipManager */ "./lib/feathers/core/DefaultToolTipManager.js")["default"]),
	FeathersControl: (__webpack_require__(/*! ./FeathersControl */ "./lib/feathers/core/FeathersControl.js")["default"]),
	FocusManager: (__webpack_require__(/*! ./FocusManager */ "./lib/feathers/core/FocusManager.js")["default"]),
	IDataSelector: (__webpack_require__(/*! ./IDataSelector */ "./lib/feathers/core/IDataSelector.js")["default"]),
	IDateSelector: (__webpack_require__(/*! ./IDateSelector */ "./lib/feathers/core/IDateSelector.js")["default"]),
	IDisplayObject: (__webpack_require__(/*! ./IDisplayObject */ "./lib/feathers/core/IDisplayObject.js")["default"]),
	IFocusContainer: (__webpack_require__(/*! ./IFocusContainer */ "./lib/feathers/core/IFocusContainer.js")["default"]),
	IFocusExclusions: (__webpack_require__(/*! ./IFocusExclusions */ "./lib/feathers/core/IFocusExclusions.js")["default"]),
	IFocusExtras: (__webpack_require__(/*! ./IFocusExtras */ "./lib/feathers/core/IFocusExtras.js")["default"]),
	IFocusManager: (__webpack_require__(/*! ./IFocusManager */ "./lib/feathers/core/IFocusManager.js")["default"]),
	IFocusManagerAware: (__webpack_require__(/*! ./IFocusManagerAware */ "./lib/feathers/core/IFocusManagerAware.js")["default"]),
	IFocusObject: (__webpack_require__(/*! ./IFocusObject */ "./lib/feathers/core/IFocusObject.js")["default"]),
	IHTMLTextControl: (__webpack_require__(/*! ./IHTMLTextControl */ "./lib/feathers/core/IHTMLTextControl.js")["default"]),
	IIndexSelector: (__webpack_require__(/*! ./IIndexSelector */ "./lib/feathers/core/IIndexSelector.js")["default"]),
	IMeasureObject: (__webpack_require__(/*! ./IMeasureObject */ "./lib/feathers/core/IMeasureObject.js")["default"]),
	IOpenCloseToggle: (__webpack_require__(/*! ./IOpenCloseToggle */ "./lib/feathers/core/IOpenCloseToggle.js")["default"]),
	IPointerDelegate: (__webpack_require__(/*! ./IPointerDelegate */ "./lib/feathers/core/IPointerDelegate.js")["default"]),
	IPopUpManager: (__webpack_require__(/*! ./IPopUpManager */ "./lib/feathers/core/IPopUpManager.js")["default"]),
	IScaleManager: (__webpack_require__(/*! ./IScaleManager */ "./lib/feathers/core/IScaleManager.js")["default"]),
	IStageFocusDelegate: (__webpack_require__(/*! ./IStageFocusDelegate */ "./lib/feathers/core/IStageFocusDelegate.js")["default"]),
	IStateContext: (__webpack_require__(/*! ./IStateContext */ "./lib/feathers/core/IStateContext.js")["default"]),
	IStateObserver: (__webpack_require__(/*! ./IStateObserver */ "./lib/feathers/core/IStateObserver.js")["default"]),
	ITextControl: (__webpack_require__(/*! ./ITextControl */ "./lib/feathers/core/ITextControl.js")["default"]),
	IToolTipManager: (__webpack_require__(/*! ./IToolTipManager */ "./lib/feathers/core/IToolTipManager.js")["default"]),
	IUIControl: (__webpack_require__(/*! ./IUIControl */ "./lib/feathers/core/IUIControl.js")["default"]),
	IValidating: (__webpack_require__(/*! ./IValidating */ "./lib/feathers/core/IValidating.js")["default"]),
	InvalidationFlag: (__webpack_require__(/*! ./InvalidationFlag */ "./lib/feathers/core/InvalidationFlag.js")["default"]),
	LetterboxScaleManager: (__webpack_require__(/*! ./LetterboxScaleManager */ "./lib/feathers/core/LetterboxScaleManager.js")["default"]),
	MeasureSprite: (__webpack_require__(/*! ./MeasureSprite */ "./lib/feathers/core/MeasureSprite.js")["default"]),
	PopUpManager: (__webpack_require__(/*! ./PopUpManager */ "./lib/feathers/core/PopUpManager.js")["default"]),
	ScreenDensityScaleManager: (__webpack_require__(/*! ./ScreenDensityScaleManager */ "./lib/feathers/core/ScreenDensityScaleManager.js")["default"]),
	ToggleGroup: (__webpack_require__(/*! ./ToggleGroup */ "./lib/feathers/core/ToggleGroup.js")["default"]),
	ToolTipManager: (__webpack_require__(/*! ./ToolTipManager */ "./lib/feathers/core/ToolTipManager.js")["default"]),
	ValidatingSprite: (__webpack_require__(/*! ./ValidatingSprite */ "./lib/feathers/core/ValidatingSprite.js")["default"]),
	ValidationQueue: (__webpack_require__(/*! ./ValidationQueue */ "./lib/feathers/core/ValidationQueue.js")["default"]),
}

/***/ }),

/***/ "./lib/feathers/data/ArrayCollection.js":
/*!**********************************************!*\
  !*** ./lib/feathers/data/ArrayCollection.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/data/ArrayCollection */ "./lib/_gen/feathers/data/ArrayCollection.js");

/***/ }),

/***/ "./lib/feathers/data/ArrayHierarchicalCollection.js":
/*!**********************************************************!*\
  !*** ./lib/feathers/data/ArrayHierarchicalCollection.js ***!
  \**********************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/data/ArrayHierarchicalCollection */ "./lib/_gen/feathers/data/ArrayHierarchicalCollection.js");

/***/ }),

/***/ "./lib/feathers/data/ButtonBarItemState.js":
/*!*************************************************!*\
  !*** ./lib/feathers/data/ButtonBarItemState.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/data/ButtonBarItemState */ "./lib/_gen/feathers/data/ButtonBarItemState.js");

/***/ }),

/***/ "./lib/feathers/data/DatePickerItemState.js":
/*!**************************************************!*\
  !*** ./lib/feathers/data/DatePickerItemState.js ***!
  \**************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/data/DatePickerItemState */ "./lib/_gen/feathers/data/DatePickerItemState.js");

/***/ }),

/***/ "./lib/feathers/data/GridViewCellState.js":
/*!************************************************!*\
  !*** ./lib/feathers/data/GridViewCellState.js ***!
  \************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/data/GridViewCellState */ "./lib/_gen/feathers/data/GridViewCellState.js");

/***/ }),

/***/ "./lib/feathers/data/GridViewHeaderState.js":
/*!**************************************************!*\
  !*** ./lib/feathers/data/GridViewHeaderState.js ***!
  \**************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/data/GridViewHeaderState */ "./lib/_gen/feathers/data/GridViewHeaderState.js");

/***/ }),

/***/ "./lib/feathers/data/GroupListViewItemState.js":
/*!*****************************************************!*\
  !*** ./lib/feathers/data/GroupListViewItemState.js ***!
  \*****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/data/GroupListViewItemState */ "./lib/_gen/feathers/data/GroupListViewItemState.js");

/***/ }),

/***/ "./lib/feathers/data/GroupListViewItemType.js":
/*!****************************************************!*\
  !*** ./lib/feathers/data/GroupListViewItemType.js ***!
  \****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/data/GroupListViewItemType */ "./lib/_gen/feathers/data/GroupListViewItemType.js");

/***/ }),

/***/ "./lib/feathers/data/IFlatCollection.js":
/*!**********************************************!*\
  !*** ./lib/feathers/data/IFlatCollection.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/data/IFlatCollection */ "./lib/_gen/feathers/data/IFlatCollection.js");

/***/ }),

/***/ "./lib/feathers/data/IHierarchicalCollection.js":
/*!******************************************************!*\
  !*** ./lib/feathers/data/IHierarchicalCollection.js ***!
  \******************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/data/IHierarchicalCollection */ "./lib/_gen/feathers/data/IHierarchicalCollection.js");

/***/ }),

/***/ "./lib/feathers/data/ISortOrderObserver.js":
/*!*************************************************!*\
  !*** ./lib/feathers/data/ISortOrderObserver.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/data/ISortOrderObserver */ "./lib/_gen/feathers/data/ISortOrderObserver.js");

/***/ }),

/***/ "./lib/feathers/data/ListViewItemState.js":
/*!************************************************!*\
  !*** ./lib/feathers/data/ListViewItemState.js ***!
  \************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/data/ListViewItemState */ "./lib/_gen/feathers/data/ListViewItemState.js");

/***/ }),

/***/ "./lib/feathers/data/PageIndicatorItemState.js":
/*!*****************************************************!*\
  !*** ./lib/feathers/data/PageIndicatorItemState.js ***!
  \*****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/data/PageIndicatorItemState */ "./lib/_gen/feathers/data/PageIndicatorItemState.js");

/***/ }),

/***/ "./lib/feathers/data/RouteState.js":
/*!*****************************************!*\
  !*** ./lib/feathers/data/RouteState.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/data/RouteState */ "./lib/_gen/feathers/data/RouteState.js");

/***/ }),

/***/ "./lib/feathers/data/SortOrder.js":
/*!****************************************!*\
  !*** ./lib/feathers/data/SortOrder.js ***!
  \****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/data/SortOrder */ "./lib/_gen/feathers/data/SortOrder.js");

/***/ }),

/***/ "./lib/feathers/data/TabBarItemState.js":
/*!**********************************************!*\
  !*** ./lib/feathers/data/TabBarItemState.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/data/TabBarItemState */ "./lib/_gen/feathers/data/TabBarItemState.js");

/***/ }),

/***/ "./lib/feathers/data/TreeCollection.js":
/*!*********************************************!*\
  !*** ./lib/feathers/data/TreeCollection.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/data/TreeCollection */ "./lib/_gen/feathers/data/TreeCollection.js");

/***/ }),

/***/ "./lib/feathers/data/TreeGridViewCellState.js":
/*!****************************************************!*\
  !*** ./lib/feathers/data/TreeGridViewCellState.js ***!
  \****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/data/TreeGridViewCellState */ "./lib/_gen/feathers/data/TreeGridViewCellState.js");

/***/ }),

/***/ "./lib/feathers/data/TreeGridViewHeaderState.js":
/*!******************************************************!*\
  !*** ./lib/feathers/data/TreeGridViewHeaderState.js ***!
  \******************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/data/TreeGridViewHeaderState */ "./lib/_gen/feathers/data/TreeGridViewHeaderState.js");

/***/ }),

/***/ "./lib/feathers/data/TreeNode.js":
/*!***************************************!*\
  !*** ./lib/feathers/data/TreeNode.js ***!
  \***************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/data/TreeNode */ "./lib/_gen/feathers/data/TreeNode.js");

/***/ }),

/***/ "./lib/feathers/data/TreeViewItemState.js":
/*!************************************************!*\
  !*** ./lib/feathers/data/TreeViewItemState.js ***!
  \************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/data/TreeViewItemState */ "./lib/_gen/feathers/data/TreeViewItemState.js");

/***/ }),

/***/ "./lib/feathers/data/index.js":
/*!************************************!*\
  !*** ./lib/feathers/data/index.js ***!
  \************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	ArrayCollection: (__webpack_require__(/*! ./ArrayCollection */ "./lib/feathers/data/ArrayCollection.js")["default"]),
	ArrayHierarchicalCollection: (__webpack_require__(/*! ./ArrayHierarchicalCollection */ "./lib/feathers/data/ArrayHierarchicalCollection.js")["default"]),
	ButtonBarItemState: (__webpack_require__(/*! ./ButtonBarItemState */ "./lib/feathers/data/ButtonBarItemState.js")["default"]),
	DatePickerItemState: (__webpack_require__(/*! ./DatePickerItemState */ "./lib/feathers/data/DatePickerItemState.js")["default"]),
	GridViewCellState: (__webpack_require__(/*! ./GridViewCellState */ "./lib/feathers/data/GridViewCellState.js")["default"]),
	GridViewHeaderState: (__webpack_require__(/*! ./GridViewHeaderState */ "./lib/feathers/data/GridViewHeaderState.js")["default"]),
	GroupListViewItemState: (__webpack_require__(/*! ./GroupListViewItemState */ "./lib/feathers/data/GroupListViewItemState.js")["default"]),
	GroupListViewItemType: (__webpack_require__(/*! ./GroupListViewItemType */ "./lib/feathers/data/GroupListViewItemType.js")["default"]),
	IFlatCollection: (__webpack_require__(/*! ./IFlatCollection */ "./lib/feathers/data/IFlatCollection.js")["default"]),
	IHierarchicalCollection: (__webpack_require__(/*! ./IHierarchicalCollection */ "./lib/feathers/data/IHierarchicalCollection.js")["default"]),
	ISortOrderObserver: (__webpack_require__(/*! ./ISortOrderObserver */ "./lib/feathers/data/ISortOrderObserver.js")["default"]),
	ListViewItemState: (__webpack_require__(/*! ./ListViewItemState */ "./lib/feathers/data/ListViewItemState.js")["default"]),
	PageIndicatorItemState: (__webpack_require__(/*! ./PageIndicatorItemState */ "./lib/feathers/data/PageIndicatorItemState.js")["default"]),
	RouteState: (__webpack_require__(/*! ./RouteState */ "./lib/feathers/data/RouteState.js")["default"]),
	SortOrder: (__webpack_require__(/*! ./SortOrder */ "./lib/feathers/data/SortOrder.js")["default"]),
	TabBarItemState: (__webpack_require__(/*! ./TabBarItemState */ "./lib/feathers/data/TabBarItemState.js")["default"]),
	TreeCollection: (__webpack_require__(/*! ./TreeCollection */ "./lib/feathers/data/TreeCollection.js")["default"]),
	TreeGridViewCellState: (__webpack_require__(/*! ./TreeGridViewCellState */ "./lib/feathers/data/TreeGridViewCellState.js")["default"]),
	TreeGridViewHeaderState: (__webpack_require__(/*! ./TreeGridViewHeaderState */ "./lib/feathers/data/TreeGridViewHeaderState.js")["default"]),
	TreeNode: (__webpack_require__(/*! ./TreeNode */ "./lib/feathers/data/TreeNode.js")["default"]),
	TreeViewItemState: (__webpack_require__(/*! ./TreeViewItemState */ "./lib/feathers/data/TreeViewItemState.js")["default"]),
}

/***/ }),

/***/ "./lib/feathers/display/Scale9Bitmap.js":
/*!**********************************************!*\
  !*** ./lib/feathers/display/Scale9Bitmap.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/display/Scale9Bitmap */ "./lib/_gen/feathers/display/Scale9Bitmap.js");

/***/ }),

/***/ "./lib/feathers/display/index.js":
/*!***************************************!*\
  !*** ./lib/feathers/display/index.js ***!
  \***************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	Scale9Bitmap: (__webpack_require__(/*! ./Scale9Bitmap */ "./lib/feathers/display/Scale9Bitmap.js")["default"]),
}

/***/ }),

/***/ "./lib/feathers/events/ButtonBarEvent.js":
/*!***********************************************!*\
  !*** ./lib/feathers/events/ButtonBarEvent.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/events/ButtonBarEvent */ "./lib/_gen/feathers/events/ButtonBarEvent.js");

/***/ }),

/***/ "./lib/feathers/events/DatePickerEvent.js":
/*!************************************************!*\
  !*** ./lib/feathers/events/DatePickerEvent.js ***!
  \************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/events/DatePickerEvent */ "./lib/_gen/feathers/events/DatePickerEvent.js");

/***/ }),

/***/ "./lib/feathers/events/FeathersEvent.js":
/*!**********************************************!*\
  !*** ./lib/feathers/events/FeathersEvent.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/events/FeathersEvent */ "./lib/_gen/feathers/events/FeathersEvent.js");

/***/ }),

/***/ "./lib/feathers/events/FlatCollectionEvent.js":
/*!****************************************************!*\
  !*** ./lib/feathers/events/FlatCollectionEvent.js ***!
  \****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/events/FlatCollectionEvent */ "./lib/_gen/feathers/events/FlatCollectionEvent.js");

/***/ }),

/***/ "./lib/feathers/events/FormEvent.js":
/*!******************************************!*\
  !*** ./lib/feathers/events/FormEvent.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/events/FormEvent */ "./lib/_gen/feathers/events/FormEvent.js");

/***/ }),

/***/ "./lib/feathers/events/GridViewEvent.js":
/*!**********************************************!*\
  !*** ./lib/feathers/events/GridViewEvent.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/events/GridViewEvent */ "./lib/_gen/feathers/events/GridViewEvent.js");

/***/ }),

/***/ "./lib/feathers/events/GroupListViewEvent.js":
/*!***************************************************!*\
  !*** ./lib/feathers/events/GroupListViewEvent.js ***!
  \***************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/events/GroupListViewEvent */ "./lib/_gen/feathers/events/GroupListViewEvent.js");

/***/ }),

/***/ "./lib/feathers/events/HierarchicalCollectionEvent.js":
/*!************************************************************!*\
  !*** ./lib/feathers/events/HierarchicalCollectionEvent.js ***!
  \************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/events/HierarchicalCollectionEvent */ "./lib/_gen/feathers/events/HierarchicalCollectionEvent.js");

/***/ }),

/***/ "./lib/feathers/events/ListViewEvent.js":
/*!**********************************************!*\
  !*** ./lib/feathers/events/ListViewEvent.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/events/ListViewEvent */ "./lib/_gen/feathers/events/ListViewEvent.js");

/***/ }),

/***/ "./lib/feathers/events/LongPressEvent.js":
/*!***********************************************!*\
  !*** ./lib/feathers/events/LongPressEvent.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/events/LongPressEvent */ "./lib/_gen/feathers/events/LongPressEvent.js");

/***/ }),

/***/ "./lib/feathers/events/ScrollEvent.js":
/*!********************************************!*\
  !*** ./lib/feathers/events/ScrollEvent.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/events/ScrollEvent */ "./lib/_gen/feathers/events/ScrollEvent.js");

/***/ }),

/***/ "./lib/feathers/events/StyleProviderEvent.js":
/*!***************************************************!*\
  !*** ./lib/feathers/events/StyleProviderEvent.js ***!
  \***************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/events/StyleProviderEvent */ "./lib/_gen/feathers/events/StyleProviderEvent.js");

/***/ }),

/***/ "./lib/feathers/events/TabBarEvent.js":
/*!********************************************!*\
  !*** ./lib/feathers/events/TabBarEvent.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/events/TabBarEvent */ "./lib/_gen/feathers/events/TabBarEvent.js");

/***/ }),

/***/ "./lib/feathers/events/TransitionEvent.js":
/*!************************************************!*\
  !*** ./lib/feathers/events/TransitionEvent.js ***!
  \************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/events/TransitionEvent */ "./lib/_gen/feathers/events/TransitionEvent.js");

/***/ }),

/***/ "./lib/feathers/events/TreeGridViewEvent.js":
/*!**************************************************!*\
  !*** ./lib/feathers/events/TreeGridViewEvent.js ***!
  \**************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/events/TreeGridViewEvent */ "./lib/_gen/feathers/events/TreeGridViewEvent.js");

/***/ }),

/***/ "./lib/feathers/events/TreeViewEvent.js":
/*!**********************************************!*\
  !*** ./lib/feathers/events/TreeViewEvent.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/events/TreeViewEvent */ "./lib/_gen/feathers/events/TreeViewEvent.js");

/***/ }),

/***/ "./lib/feathers/events/TriggerEvent.js":
/*!*********************************************!*\
  !*** ./lib/feathers/events/TriggerEvent.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/events/TriggerEvent */ "./lib/_gen/feathers/events/TriggerEvent.js");

/***/ }),

/***/ "./lib/feathers/events/index.js":
/*!**************************************!*\
  !*** ./lib/feathers/events/index.js ***!
  \**************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	ButtonBarEvent: (__webpack_require__(/*! ./ButtonBarEvent */ "./lib/feathers/events/ButtonBarEvent.js")["default"]),
	DatePickerEvent: (__webpack_require__(/*! ./DatePickerEvent */ "./lib/feathers/events/DatePickerEvent.js")["default"]),
	FeathersEvent: (__webpack_require__(/*! ./FeathersEvent */ "./lib/feathers/events/FeathersEvent.js")["default"]),
	FlatCollectionEvent: (__webpack_require__(/*! ./FlatCollectionEvent */ "./lib/feathers/events/FlatCollectionEvent.js")["default"]),
	FormEvent: (__webpack_require__(/*! ./FormEvent */ "./lib/feathers/events/FormEvent.js")["default"]),
	GridViewEvent: (__webpack_require__(/*! ./GridViewEvent */ "./lib/feathers/events/GridViewEvent.js")["default"]),
	GroupListViewEvent: (__webpack_require__(/*! ./GroupListViewEvent */ "./lib/feathers/events/GroupListViewEvent.js")["default"]),
	HierarchicalCollectionEvent: (__webpack_require__(/*! ./HierarchicalCollectionEvent */ "./lib/feathers/events/HierarchicalCollectionEvent.js")["default"]),
	ListViewEvent: (__webpack_require__(/*! ./ListViewEvent */ "./lib/feathers/events/ListViewEvent.js")["default"]),
	LongPressEvent: (__webpack_require__(/*! ./LongPressEvent */ "./lib/feathers/events/LongPressEvent.js")["default"]),
	ScrollEvent: (__webpack_require__(/*! ./ScrollEvent */ "./lib/feathers/events/ScrollEvent.js")["default"]),
	StyleProviderEvent: (__webpack_require__(/*! ./StyleProviderEvent */ "./lib/feathers/events/StyleProviderEvent.js")["default"]),
	TabBarEvent: (__webpack_require__(/*! ./TabBarEvent */ "./lib/feathers/events/TabBarEvent.js")["default"]),
	TransitionEvent: (__webpack_require__(/*! ./TransitionEvent */ "./lib/feathers/events/TransitionEvent.js")["default"]),
	TreeGridViewEvent: (__webpack_require__(/*! ./TreeGridViewEvent */ "./lib/feathers/events/TreeGridViewEvent.js")["default"]),
	TreeViewEvent: (__webpack_require__(/*! ./TreeViewEvent */ "./lib/feathers/events/TreeViewEvent.js")["default"]),
	TriggerEvent: (__webpack_require__(/*! ./TriggerEvent */ "./lib/feathers/events/TriggerEvent.js")["default"]),
}

/***/ }),

/***/ "./lib/feathers/graphics/FillStyle.js":
/*!********************************************!*\
  !*** ./lib/feathers/graphics/FillStyle.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/graphics/FillStyle */ "./lib/_gen/feathers/graphics/FillStyle.js");

/***/ }),

/***/ "./lib/feathers/graphics/GradientBoxTransform.js":
/*!*******************************************************!*\
  !*** ./lib/feathers/graphics/GradientBoxTransform.js ***!
  \*******************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/graphics/GradientBoxTransform */ "./lib/_gen/feathers/graphics/GradientBoxTransform.js");

/***/ }),

/***/ "./lib/feathers/graphics/LineStyle.js":
/*!********************************************!*\
  !*** ./lib/feathers/graphics/LineStyle.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/graphics/LineStyle */ "./lib/_gen/feathers/graphics/LineStyle.js");

/***/ }),

/***/ "./lib/feathers/graphics/index.js":
/*!****************************************!*\
  !*** ./lib/feathers/graphics/index.js ***!
  \****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	FillStyle: (__webpack_require__(/*! ./FillStyle */ "./lib/feathers/graphics/FillStyle.js")["default"]),
	GradientBoxTransform: (__webpack_require__(/*! ./GradientBoxTransform */ "./lib/feathers/graphics/GradientBoxTransform.js")["default"]),
	LineStyle: (__webpack_require__(/*! ./LineStyle */ "./lib/feathers/graphics/LineStyle.js")["default"]),
}

/***/ }),

/***/ "./lib/feathers/index.js":
/*!*******************************!*\
  !*** ./lib/feathers/index.js ***!
  \*******************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	core: __webpack_require__(/*! ./core */ "./lib/feathers/core/index.js"),
	controls: __webpack_require__(/*! ./controls */ "./lib/feathers/controls/index.js"),
	events: __webpack_require__(/*! ./events */ "./lib/feathers/events/index.js"),
	graphics: __webpack_require__(/*! ./graphics */ "./lib/feathers/graphics/index.js"),
	display: __webpack_require__(/*! ./display */ "./lib/feathers/display/index.js"),
	layout: __webpack_require__(/*! ./layout */ "./lib/feathers/layout/index.js"),
	data: __webpack_require__(/*! ./data */ "./lib/feathers/data/index.js"),
	skins: __webpack_require__(/*! ./skins */ "./lib/feathers/skins/index.js"),
	style: __webpack_require__(/*! ./style */ "./lib/feathers/style/index.js"),
	text: __webpack_require__(/*! ./text */ "./lib/feathers/text/index.js"),
	themes: __webpack_require__(/*! ./themes */ "./lib/feathers/themes/index.js"),
	utils: __webpack_require__(/*! ./utils */ "./lib/feathers/utils/index.js"),
	motion: __webpack_require__(/*! ./motion */ "./lib/feathers/motion/index.js"),
}

/***/ }),

/***/ "./lib/feathers/layout/Anchor.js":
/*!***************************************!*\
  !*** ./lib/feathers/layout/Anchor.js ***!
  \***************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/Anchor */ "./lib/_gen/feathers/layout/Anchor.js");

/***/ }),

/***/ "./lib/feathers/layout/AnchorLayout.js":
/*!*********************************************!*\
  !*** ./lib/feathers/layout/AnchorLayout.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/AnchorLayout */ "./lib/_gen/feathers/layout/AnchorLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/AnchorLayoutData.js":
/*!*************************************************!*\
  !*** ./lib/feathers/layout/AnchorLayoutData.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/AnchorLayoutData */ "./lib/_gen/feathers/layout/AnchorLayoutData.js");

/***/ }),

/***/ "./lib/feathers/layout/AutoSizeMode.js":
/*!*********************************************!*\
  !*** ./lib/feathers/layout/AutoSizeMode.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/AutoSizeMode */ "./lib/_gen/feathers/layout/AutoSizeMode.js");

/***/ }),

/***/ "./lib/feathers/layout/CalendarGridLayout.js":
/*!***************************************************!*\
  !*** ./lib/feathers/layout/CalendarGridLayout.js ***!
  \***************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/CalendarGridLayout */ "./lib/_gen/feathers/layout/CalendarGridLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/Direction.js":
/*!******************************************!*\
  !*** ./lib/feathers/layout/Direction.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/Direction */ "./lib/_gen/feathers/layout/Direction.js");

/***/ }),

/***/ "./lib/feathers/layout/FlowRowsLayout.js":
/*!***********************************************!*\
  !*** ./lib/feathers/layout/FlowRowsLayout.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/FlowRowsLayout */ "./lib/_gen/feathers/layout/FlowRowsLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/FormLayout.js":
/*!*******************************************!*\
  !*** ./lib/feathers/layout/FormLayout.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/FormLayout */ "./lib/_gen/feathers/layout/FormLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/GridViewRowLayout.js":
/*!**************************************************!*\
  !*** ./lib/feathers/layout/GridViewRowLayout.js ***!
  \**************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/GridViewRowLayout */ "./lib/_gen/feathers/layout/GridViewRowLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/HDividedBoxLayout.js":
/*!**************************************************!*\
  !*** ./lib/feathers/layout/HDividedBoxLayout.js ***!
  \**************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/HDividedBoxLayout */ "./lib/_gen/feathers/layout/HDividedBoxLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/HorizontalAlign.js":
/*!************************************************!*\
  !*** ./lib/feathers/layout/HorizontalAlign.js ***!
  \************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/HorizontalAlign */ "./lib/_gen/feathers/layout/HorizontalAlign.js");

/***/ }),

/***/ "./lib/feathers/layout/HorizontalDistributedLayout.js":
/*!************************************************************!*\
  !*** ./lib/feathers/layout/HorizontalDistributedLayout.js ***!
  \************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/HorizontalDistributedLayout */ "./lib/_gen/feathers/layout/HorizontalDistributedLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/HorizontalLayout.js":
/*!*************************************************!*\
  !*** ./lib/feathers/layout/HorizontalLayout.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/HorizontalLayout */ "./lib/_gen/feathers/layout/HorizontalLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/HorizontalLayoutData.js":
/*!*****************************************************!*\
  !*** ./lib/feathers/layout/HorizontalLayoutData.js ***!
  \*****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/HorizontalLayoutData */ "./lib/_gen/feathers/layout/HorizontalLayoutData.js");

/***/ }),

/***/ "./lib/feathers/layout/HorizontalListLayout.js":
/*!*****************************************************!*\
  !*** ./lib/feathers/layout/HorizontalListLayout.js ***!
  \*****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/HorizontalListLayout */ "./lib/_gen/feathers/layout/HorizontalListLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/IKeyboardNavigationLayout.js":
/*!**********************************************************!*\
  !*** ./lib/feathers/layout/IKeyboardNavigationLayout.js ***!
  \**********************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/IKeyboardNavigationLayout */ "./lib/_gen/feathers/layout/IKeyboardNavigationLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/ILayout.js":
/*!****************************************!*\
  !*** ./lib/feathers/layout/ILayout.js ***!
  \****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/ILayout */ "./lib/_gen/feathers/layout/ILayout.js");

/***/ }),

/***/ "./lib/feathers/layout/ILayoutData.js":
/*!********************************************!*\
  !*** ./lib/feathers/layout/ILayoutData.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/ILayoutData */ "./lib/_gen/feathers/layout/ILayoutData.js");

/***/ }),

/***/ "./lib/feathers/layout/ILayoutIndexObject.js":
/*!***************************************************!*\
  !*** ./lib/feathers/layout/ILayoutIndexObject.js ***!
  \***************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/ILayoutIndexObject */ "./lib/_gen/feathers/layout/ILayoutIndexObject.js");

/***/ }),

/***/ "./lib/feathers/layout/ILayoutObject.js":
/*!**********************************************!*\
  !*** ./lib/feathers/layout/ILayoutObject.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/ILayoutObject */ "./lib/_gen/feathers/layout/ILayoutObject.js");

/***/ }),

/***/ "./lib/feathers/layout/IScrollLayout.js":
/*!**********************************************!*\
  !*** ./lib/feathers/layout/IScrollLayout.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/IScrollLayout */ "./lib/_gen/feathers/layout/IScrollLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/ISnapLayout.js":
/*!********************************************!*\
  !*** ./lib/feathers/layout/ISnapLayout.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/ISnapLayout */ "./lib/_gen/feathers/layout/ISnapLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/IVirtualLayout.js":
/*!***********************************************!*\
  !*** ./lib/feathers/layout/IVirtualLayout.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/IVirtualLayout */ "./lib/_gen/feathers/layout/IVirtualLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/LayoutBoundsResult.js":
/*!***************************************************!*\
  !*** ./lib/feathers/layout/LayoutBoundsResult.js ***!
  \***************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/LayoutBoundsResult */ "./lib/_gen/feathers/layout/LayoutBoundsResult.js");

/***/ }),

/***/ "./lib/feathers/layout/Measurements.js":
/*!*********************************************!*\
  !*** ./lib/feathers/layout/Measurements.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/Measurements */ "./lib/_gen/feathers/layout/Measurements.js");

/***/ }),

/***/ "./lib/feathers/layout/PagedTiledRowsListLayout.js":
/*!*********************************************************!*\
  !*** ./lib/feathers/layout/PagedTiledRowsListLayout.js ***!
  \*********************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/PagedTiledRowsListLayout */ "./lib/_gen/feathers/layout/PagedTiledRowsListLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/RelativePosition.js":
/*!*************************************************!*\
  !*** ./lib/feathers/layout/RelativePosition.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/RelativePosition */ "./lib/_gen/feathers/layout/RelativePosition.js");

/***/ }),

/***/ "./lib/feathers/layout/ResponsiveGridLayout.js":
/*!*****************************************************!*\
  !*** ./lib/feathers/layout/ResponsiveGridLayout.js ***!
  \*****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/ResponsiveGridLayout */ "./lib/_gen/feathers/layout/ResponsiveGridLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/ResponsiveGridLayoutData.js":
/*!*********************************************************!*\
  !*** ./lib/feathers/layout/ResponsiveGridLayoutData.js ***!
  \*********************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/ResponsiveGridLayoutData */ "./lib/_gen/feathers/layout/ResponsiveGridLayoutData.js");

/***/ }),

/***/ "./lib/feathers/layout/TiledRowsLayout.js":
/*!************************************************!*\
  !*** ./lib/feathers/layout/TiledRowsLayout.js ***!
  \************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/TiledRowsLayout */ "./lib/_gen/feathers/layout/TiledRowsLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/TiledRowsListLayout.js":
/*!****************************************************!*\
  !*** ./lib/feathers/layout/TiledRowsListLayout.js ***!
  \****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/TiledRowsListLayout */ "./lib/_gen/feathers/layout/TiledRowsListLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/VDividedBoxLayout.js":
/*!**************************************************!*\
  !*** ./lib/feathers/layout/VDividedBoxLayout.js ***!
  \**************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/VDividedBoxLayout */ "./lib/_gen/feathers/layout/VDividedBoxLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/VerticalAlign.js":
/*!**********************************************!*\
  !*** ./lib/feathers/layout/VerticalAlign.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/VerticalAlign */ "./lib/_gen/feathers/layout/VerticalAlign.js");

/***/ }),

/***/ "./lib/feathers/layout/VerticalDistributedLayout.js":
/*!**********************************************************!*\
  !*** ./lib/feathers/layout/VerticalDistributedLayout.js ***!
  \**********************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/VerticalDistributedLayout */ "./lib/_gen/feathers/layout/VerticalDistributedLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/VerticalLayout.js":
/*!***********************************************!*\
  !*** ./lib/feathers/layout/VerticalLayout.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/VerticalLayout */ "./lib/_gen/feathers/layout/VerticalLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/VerticalLayoutData.js":
/*!***************************************************!*\
  !*** ./lib/feathers/layout/VerticalLayoutData.js ***!
  \***************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/VerticalLayoutData */ "./lib/_gen/feathers/layout/VerticalLayoutData.js");

/***/ }),

/***/ "./lib/feathers/layout/VerticalListFixedRowLayout.js":
/*!***********************************************************!*\
  !*** ./lib/feathers/layout/VerticalListFixedRowLayout.js ***!
  \***********************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/VerticalListFixedRowLayout */ "./lib/_gen/feathers/layout/VerticalListFixedRowLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/VerticalListLayout.js":
/*!***************************************************!*\
  !*** ./lib/feathers/layout/VerticalListLayout.js ***!
  \***************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/VerticalListLayout */ "./lib/_gen/feathers/layout/VerticalListLayout.js");

/***/ }),

/***/ "./lib/feathers/layout/VirtualLayoutRange.js":
/*!***************************************************!*\
  !*** ./lib/feathers/layout/VirtualLayoutRange.js ***!
  \***************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/layout/VirtualLayoutRange */ "./lib/_gen/feathers/layout/VirtualLayoutRange.js");

/***/ }),

/***/ "./lib/feathers/layout/index.js":
/*!**************************************!*\
  !*** ./lib/feathers/layout/index.js ***!
  \**************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	Anchor: (__webpack_require__(/*! ./Anchor */ "./lib/feathers/layout/Anchor.js")["default"]),
	AnchorLayout: (__webpack_require__(/*! ./AnchorLayout */ "./lib/feathers/layout/AnchorLayout.js")["default"]),
	AnchorLayoutData: (__webpack_require__(/*! ./AnchorLayoutData */ "./lib/feathers/layout/AnchorLayoutData.js")["default"]),
	AutoSizeMode: (__webpack_require__(/*! ./AutoSizeMode */ "./lib/feathers/layout/AutoSizeMode.js")["default"]),
	CalendarGridLayout: (__webpack_require__(/*! ./CalendarGridLayout */ "./lib/feathers/layout/CalendarGridLayout.js")["default"]),
	Direction: (__webpack_require__(/*! ./Direction */ "./lib/feathers/layout/Direction.js")["default"]),
	FlowRowsLayout: (__webpack_require__(/*! ./FlowRowsLayout */ "./lib/feathers/layout/FlowRowsLayout.js")["default"]),
	FormLayout: (__webpack_require__(/*! ./FormLayout */ "./lib/feathers/layout/FormLayout.js")["default"]),
	GridViewRowLayout: (__webpack_require__(/*! ./GridViewRowLayout */ "./lib/feathers/layout/GridViewRowLayout.js")["default"]),
	HDividedBoxLayout: (__webpack_require__(/*! ./HDividedBoxLayout */ "./lib/feathers/layout/HDividedBoxLayout.js")["default"]),
	HorizontalAlign: (__webpack_require__(/*! ./HorizontalAlign */ "./lib/feathers/layout/HorizontalAlign.js")["default"]),
	HorizontalDistributedLayout: (__webpack_require__(/*! ./HorizontalDistributedLayout */ "./lib/feathers/layout/HorizontalDistributedLayout.js")["default"]),
	HorizontalLayout: (__webpack_require__(/*! ./HorizontalLayout */ "./lib/feathers/layout/HorizontalLayout.js")["default"]),
	HorizontalLayoutData: (__webpack_require__(/*! ./HorizontalLayoutData */ "./lib/feathers/layout/HorizontalLayoutData.js")["default"]),
	HorizontalListLayout: (__webpack_require__(/*! ./HorizontalListLayout */ "./lib/feathers/layout/HorizontalListLayout.js")["default"]),
	IKeyboardNavigationLayout: (__webpack_require__(/*! ./IKeyboardNavigationLayout */ "./lib/feathers/layout/IKeyboardNavigationLayout.js")["default"]),
	ILayout: (__webpack_require__(/*! ./ILayout */ "./lib/feathers/layout/ILayout.js")["default"]),
	ILayoutData: (__webpack_require__(/*! ./ILayoutData */ "./lib/feathers/layout/ILayoutData.js")["default"]),
	ILayoutIndexObject: (__webpack_require__(/*! ./ILayoutIndexObject */ "./lib/feathers/layout/ILayoutIndexObject.js")["default"]),
	ILayoutObject: (__webpack_require__(/*! ./ILayoutObject */ "./lib/feathers/layout/ILayoutObject.js")["default"]),
	IScrollLayout: (__webpack_require__(/*! ./IScrollLayout */ "./lib/feathers/layout/IScrollLayout.js")["default"]),
	ISnapLayout: (__webpack_require__(/*! ./ISnapLayout */ "./lib/feathers/layout/ISnapLayout.js")["default"]),
	IVirtualLayout: (__webpack_require__(/*! ./IVirtualLayout */ "./lib/feathers/layout/IVirtualLayout.js")["default"]),
	LayoutBoundsResult: (__webpack_require__(/*! ./LayoutBoundsResult */ "./lib/feathers/layout/LayoutBoundsResult.js")["default"]),
	Measurements: (__webpack_require__(/*! ./Measurements */ "./lib/feathers/layout/Measurements.js")["default"]),
	PagedTiledRowsListLayout: (__webpack_require__(/*! ./PagedTiledRowsListLayout */ "./lib/feathers/layout/PagedTiledRowsListLayout.js")["default"]),
	RelativePosition: (__webpack_require__(/*! ./RelativePosition */ "./lib/feathers/layout/RelativePosition.js")["default"]),
	ResponsiveGridLayout: (__webpack_require__(/*! ./ResponsiveGridLayout */ "./lib/feathers/layout/ResponsiveGridLayout.js")["default"]),
	ResponsiveGridLayoutData: (__webpack_require__(/*! ./ResponsiveGridLayoutData */ "./lib/feathers/layout/ResponsiveGridLayoutData.js")["default"]),
	TiledRowsLayout: (__webpack_require__(/*! ./TiledRowsLayout */ "./lib/feathers/layout/TiledRowsLayout.js")["default"]),
	TiledRowsListLayout: (__webpack_require__(/*! ./TiledRowsListLayout */ "./lib/feathers/layout/TiledRowsListLayout.js")["default"]),
	VDividedBoxLayout: (__webpack_require__(/*! ./VDividedBoxLayout */ "./lib/feathers/layout/VDividedBoxLayout.js")["default"]),
	VerticalAlign: (__webpack_require__(/*! ./VerticalAlign */ "./lib/feathers/layout/VerticalAlign.js")["default"]),
	VerticalDistributedLayout: (__webpack_require__(/*! ./VerticalDistributedLayout */ "./lib/feathers/layout/VerticalDistributedLayout.js")["default"]),
	VerticalLayout: (__webpack_require__(/*! ./VerticalLayout */ "./lib/feathers/layout/VerticalLayout.js")["default"]),
	VerticalLayoutData: (__webpack_require__(/*! ./VerticalLayoutData */ "./lib/feathers/layout/VerticalLayoutData.js")["default"]),
	VerticalListFixedRowLayout: (__webpack_require__(/*! ./VerticalListFixedRowLayout */ "./lib/feathers/layout/VerticalListFixedRowLayout.js")["default"]),
	VerticalListLayout: (__webpack_require__(/*! ./VerticalListLayout */ "./lib/feathers/layout/VerticalListLayout.js")["default"]),
	VirtualLayoutRange: (__webpack_require__(/*! ./VirtualLayoutRange */ "./lib/feathers/layout/VirtualLayoutRange.js")["default"]),
}

/***/ }),

/***/ "./lib/feathers/motion/effects/BaseDelegateEffectContext.js":
/*!******************************************************************!*\
  !*** ./lib/feathers/motion/effects/BaseDelegateEffectContext.js ***!
  \******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/motion/effects/BaseDelegateEffectContext */ "./lib/_gen/feathers/motion/effects/BaseDelegateEffectContext.js");

/***/ }),

/***/ "./lib/feathers/motion/effects/BaseEffectContext.js":
/*!**********************************************************!*\
  !*** ./lib/feathers/motion/effects/BaseEffectContext.js ***!
  \**********************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/motion/effects/BaseEffectContext */ "./lib/_gen/feathers/motion/effects/BaseEffectContext.js");

/***/ }),

/***/ "./lib/feathers/motion/effects/EffectInterruptBehavior.js":
/*!****************************************************************!*\
  !*** ./lib/feathers/motion/effects/EffectInterruptBehavior.js ***!
  \****************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/motion/effects/EffectInterruptBehavior */ "./lib/_gen/feathers/motion/effects/EffectInterruptBehavior.js");

/***/ }),

/***/ "./lib/feathers/motion/effects/EventToPositionEffectContext.js":
/*!*********************************************************************!*\
  !*** ./lib/feathers/motion/effects/EventToPositionEffectContext.js ***!
  \*********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/motion/effects/EventToPositionEffectContext */ "./lib/_gen/feathers/motion/effects/EventToPositionEffectContext.js");

/***/ }),

/***/ "./lib/feathers/motion/effects/IEffectContext.js":
/*!*******************************************************!*\
  !*** ./lib/feathers/motion/effects/IEffectContext.js ***!
  \*******************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/motion/effects/IEffectContext */ "./lib/_gen/feathers/motion/effects/IEffectContext.js");

/***/ }),

/***/ "./lib/feathers/motion/effects/NoOpEffectContext.js":
/*!**********************************************************!*\
  !*** ./lib/feathers/motion/effects/NoOpEffectContext.js ***!
  \**********************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/motion/effects/NoOpEffectContext */ "./lib/_gen/feathers/motion/effects/NoOpEffectContext.js");

/***/ }),

/***/ "./lib/feathers/motion/effects/actuate/ActuateEffectContext.js":
/*!*********************************************************************!*\
  !*** ./lib/feathers/motion/effects/actuate/ActuateEffectContext.js ***!
  \*********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/motion/effects/actuate/ActuateEffectContext */ "./lib/_gen/feathers/motion/effects/actuate/ActuateEffectContext.js");

/***/ }),

/***/ "./lib/feathers/motion/effects/actuate/ActuateForEffects.js":
/*!******************************************************************!*\
  !*** ./lib/feathers/motion/effects/actuate/ActuateForEffects.js ***!
  \******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/motion/effects/actuate/ActuateForEffects */ "./lib/_gen/feathers/motion/effects/actuate/ActuateForEffects.js");

/***/ }),

/***/ "./lib/feathers/motion/effects/actuate/IGotoActuator.js":
/*!**************************************************************!*\
  !*** ./lib/feathers/motion/effects/actuate/IGotoActuator.js ***!
  \**************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/motion/effects/actuate/IGotoActuator */ "./lib/_gen/feathers/motion/effects/actuate/IGotoActuator.js");

/***/ }),

/***/ "./lib/feathers/motion/effects/actuate/IReadableGenericActuator.js":
/*!*************************************************************************!*\
  !*** ./lib/feathers/motion/effects/actuate/IReadableGenericActuator.js ***!
  \*************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/motion/effects/actuate/IReadableGenericActuator */ "./lib/_gen/feathers/motion/effects/actuate/IReadableGenericActuator.js");

/***/ }),

/***/ "./lib/feathers/motion/effects/actuate/MethodEffectActuator.js":
/*!*********************************************************************!*\
  !*** ./lib/feathers/motion/effects/actuate/MethodEffectActuator.js ***!
  \*********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/motion/effects/actuate/MethodEffectActuator */ "./lib/_gen/feathers/motion/effects/actuate/MethodEffectActuator.js");

/***/ }),

/***/ "./lib/feathers/motion/effects/actuate/SimpleEffectActuator.js":
/*!*********************************************************************!*\
  !*** ./lib/feathers/motion/effects/actuate/SimpleEffectActuator.js ***!
  \*********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/motion/effects/actuate/SimpleEffectActuator */ "./lib/_gen/feathers/motion/effects/actuate/SimpleEffectActuator.js");

/***/ }),

/***/ "./lib/feathers/motion/effects/actuate/index.js":
/*!******************************************************!*\
  !*** ./lib/feathers/motion/effects/actuate/index.js ***!
  \******************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	ActuateEffectContext: (__webpack_require__(/*! ./ActuateEffectContext */ "./lib/feathers/motion/effects/actuate/ActuateEffectContext.js")["default"]),
	ActuateForEffects: (__webpack_require__(/*! ./ActuateForEffects */ "./lib/feathers/motion/effects/actuate/ActuateForEffects.js")["default"]),
	IGotoActuator: (__webpack_require__(/*! ./IGotoActuator */ "./lib/feathers/motion/effects/actuate/IGotoActuator.js")["default"]),
	IReadableGenericActuator: (__webpack_require__(/*! ./IReadableGenericActuator */ "./lib/feathers/motion/effects/actuate/IReadableGenericActuator.js")["default"]),
	MethodEffectActuator: (__webpack_require__(/*! ./MethodEffectActuator */ "./lib/feathers/motion/effects/actuate/MethodEffectActuator.js")["default"]),
	SimpleEffectActuator: (__webpack_require__(/*! ./SimpleEffectActuator */ "./lib/feathers/motion/effects/actuate/SimpleEffectActuator.js")["default"]),
}

/***/ }),

/***/ "./lib/feathers/motion/effects/index.js":
/*!**********************************************!*\
  !*** ./lib/feathers/motion/effects/index.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	BaseDelegateEffectContext: (__webpack_require__(/*! ./BaseDelegateEffectContext */ "./lib/feathers/motion/effects/BaseDelegateEffectContext.js")["default"]),
	BaseEffectContext: (__webpack_require__(/*! ./BaseEffectContext */ "./lib/feathers/motion/effects/BaseEffectContext.js")["default"]),
	EffectInterruptBehavior: (__webpack_require__(/*! ./EffectInterruptBehavior */ "./lib/feathers/motion/effects/EffectInterruptBehavior.js")["default"]),
	EventToPositionEffectContext: (__webpack_require__(/*! ./EventToPositionEffectContext */ "./lib/feathers/motion/effects/EventToPositionEffectContext.js")["default"]),
	IEffectContext: (__webpack_require__(/*! ./IEffectContext */ "./lib/feathers/motion/effects/IEffectContext.js")["default"]),
	NoOpEffectContext: (__webpack_require__(/*! ./NoOpEffectContext */ "./lib/feathers/motion/effects/NoOpEffectContext.js")["default"]),
	actuate: __webpack_require__(/*! ./actuate */ "./lib/feathers/motion/effects/actuate/index.js"),
}

/***/ }),

/***/ "./lib/feathers/motion/index.js":
/*!**************************************!*\
  !*** ./lib/feathers/motion/index.js ***!
  \**************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	effects: __webpack_require__(/*! ./effects */ "./lib/feathers/motion/effects/index.js"),
	transitions: __webpack_require__(/*! ./transitions */ "./lib/feathers/motion/transitions/index.js"),
}

/***/ }),

/***/ "./lib/feathers/motion/transitions/ColorFadeTransitionBuilder.js":
/*!***********************************************************************!*\
  !*** ./lib/feathers/motion/transitions/ColorFadeTransitionBuilder.js ***!
  \***********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/motion/transitions/ColorFadeTransitionBuilder */ "./lib/_gen/feathers/motion/transitions/ColorFadeTransitionBuilder.js");

/***/ }),

/***/ "./lib/feathers/motion/transitions/CoverTransitionBuilder.js":
/*!*******************************************************************!*\
  !*** ./lib/feathers/motion/transitions/CoverTransitionBuilder.js ***!
  \*******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/motion/transitions/CoverTransitionBuilder */ "./lib/_gen/feathers/motion/transitions/CoverTransitionBuilder.js");

/***/ }),

/***/ "./lib/feathers/motion/transitions/FadeTransitionBuilder.js":
/*!******************************************************************!*\
  !*** ./lib/feathers/motion/transitions/FadeTransitionBuilder.js ***!
  \******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/motion/transitions/FadeTransitionBuilder */ "./lib/_gen/feathers/motion/transitions/FadeTransitionBuilder.js");

/***/ }),

/***/ "./lib/feathers/motion/transitions/FadeTransitions.js":
/*!************************************************************!*\
  !*** ./lib/feathers/motion/transitions/FadeTransitions.js ***!
  \************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/motion/transitions/FadeTransitions */ "./lib/_gen/feathers/motion/transitions/FadeTransitions.js");

/***/ }),

/***/ "./lib/feathers/motion/transitions/IrisTransitionBuilder.js":
/*!******************************************************************!*\
  !*** ./lib/feathers/motion/transitions/IrisTransitionBuilder.js ***!
  \******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/motion/transitions/IrisTransitionBuilder */ "./lib/_gen/feathers/motion/transitions/IrisTransitionBuilder.js");

/***/ }),

/***/ "./lib/feathers/motion/transitions/RevealTransitionBuilder.js":
/*!********************************************************************!*\
  !*** ./lib/feathers/motion/transitions/RevealTransitionBuilder.js ***!
  \********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/motion/transitions/RevealTransitionBuilder */ "./lib/_gen/feathers/motion/transitions/RevealTransitionBuilder.js");

/***/ }),

/***/ "./lib/feathers/motion/transitions/SlideTransitionBuilder.js":
/*!*******************************************************************!*\
  !*** ./lib/feathers/motion/transitions/SlideTransitionBuilder.js ***!
  \*******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/motion/transitions/SlideTransitionBuilder */ "./lib/_gen/feathers/motion/transitions/SlideTransitionBuilder.js");

/***/ }),

/***/ "./lib/feathers/motion/transitions/SlideTransitions.js":
/*!*************************************************************!*\
  !*** ./lib/feathers/motion/transitions/SlideTransitions.js ***!
  \*************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/motion/transitions/SlideTransitions */ "./lib/_gen/feathers/motion/transitions/SlideTransitions.js");

/***/ }),

/***/ "./lib/feathers/motion/transitions/WipeTransitionBuilder.js":
/*!******************************************************************!*\
  !*** ./lib/feathers/motion/transitions/WipeTransitionBuilder.js ***!
  \******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/motion/transitions/WipeTransitionBuilder */ "./lib/_gen/feathers/motion/transitions/WipeTransitionBuilder.js");

/***/ }),

/***/ "./lib/feathers/motion/transitions/index.js":
/*!**************************************************!*\
  !*** ./lib/feathers/motion/transitions/index.js ***!
  \**************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	ColorFadeTransitionBuilder: (__webpack_require__(/*! ./ColorFadeTransitionBuilder */ "./lib/feathers/motion/transitions/ColorFadeTransitionBuilder.js")["default"]),
	CoverTransitionBuilder: (__webpack_require__(/*! ./CoverTransitionBuilder */ "./lib/feathers/motion/transitions/CoverTransitionBuilder.js")["default"]),
	FadeTransitionBuilder: (__webpack_require__(/*! ./FadeTransitionBuilder */ "./lib/feathers/motion/transitions/FadeTransitionBuilder.js")["default"]),
	FadeTransitions: (__webpack_require__(/*! ./FadeTransitions */ "./lib/feathers/motion/transitions/FadeTransitions.js")["default"]),
	IrisTransitionBuilder: (__webpack_require__(/*! ./IrisTransitionBuilder */ "./lib/feathers/motion/transitions/IrisTransitionBuilder.js")["default"]),
	RevealTransitionBuilder: (__webpack_require__(/*! ./RevealTransitionBuilder */ "./lib/feathers/motion/transitions/RevealTransitionBuilder.js")["default"]),
	SlideTransitionBuilder: (__webpack_require__(/*! ./SlideTransitionBuilder */ "./lib/feathers/motion/transitions/SlideTransitionBuilder.js")["default"]),
	SlideTransitions: (__webpack_require__(/*! ./SlideTransitions */ "./lib/feathers/motion/transitions/SlideTransitions.js")["default"]),
	WipeTransitionBuilder: (__webpack_require__(/*! ./WipeTransitionBuilder */ "./lib/feathers/motion/transitions/WipeTransitionBuilder.js")["default"]),
}

/***/ }),

/***/ "./lib/feathers/skins/BaseGraphicsPathSkin.js":
/*!****************************************************!*\
  !*** ./lib/feathers/skins/BaseGraphicsPathSkin.js ***!
  \****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/skins/BaseGraphicsPathSkin */ "./lib/_gen/feathers/skins/BaseGraphicsPathSkin.js");

/***/ }),

/***/ "./lib/feathers/skins/CircleSkin.js":
/*!******************************************!*\
  !*** ./lib/feathers/skins/CircleSkin.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/skins/CircleSkin */ "./lib/_gen/feathers/skins/CircleSkin.js");

/***/ }),

/***/ "./lib/feathers/skins/DonutSkin.js":
/*!*****************************************!*\
  !*** ./lib/feathers/skins/DonutSkin.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/skins/DonutSkin */ "./lib/_gen/feathers/skins/DonutSkin.js");

/***/ }),

/***/ "./lib/feathers/skins/EllipseSkin.js":
/*!*******************************************!*\
  !*** ./lib/feathers/skins/EllipseSkin.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/skins/EllipseSkin */ "./lib/_gen/feathers/skins/EllipseSkin.js");

/***/ }),

/***/ "./lib/feathers/skins/HorizontalLineSkin.js":
/*!**************************************************!*\
  !*** ./lib/feathers/skins/HorizontalLineSkin.js ***!
  \**************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/skins/HorizontalLineSkin */ "./lib/_gen/feathers/skins/HorizontalLineSkin.js");

/***/ }),

/***/ "./lib/feathers/skins/IIndeterminateSkin.js":
/*!**************************************************!*\
  !*** ./lib/feathers/skins/IIndeterminateSkin.js ***!
  \**************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/skins/IIndeterminateSkin */ "./lib/_gen/feathers/skins/IIndeterminateSkin.js");

/***/ }),

/***/ "./lib/feathers/skins/IProgrammaticSkin.js":
/*!*************************************************!*\
  !*** ./lib/feathers/skins/IProgrammaticSkin.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/skins/IProgrammaticSkin */ "./lib/_gen/feathers/skins/IProgrammaticSkin.js");

/***/ }),

/***/ "./lib/feathers/skins/LeftAndRightBorderSkin.js":
/*!******************************************************!*\
  !*** ./lib/feathers/skins/LeftAndRightBorderSkin.js ***!
  \******************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/skins/LeftAndRightBorderSkin */ "./lib/_gen/feathers/skins/LeftAndRightBorderSkin.js");

/***/ }),

/***/ "./lib/feathers/skins/MultiSkin.js":
/*!*****************************************!*\
  !*** ./lib/feathers/skins/MultiSkin.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/skins/MultiSkin */ "./lib/_gen/feathers/skins/MultiSkin.js");

/***/ }),

/***/ "./lib/feathers/skins/OverAndUnderlineSkin.js":
/*!****************************************************!*\
  !*** ./lib/feathers/skins/OverAndUnderlineSkin.js ***!
  \****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/skins/OverAndUnderlineSkin */ "./lib/_gen/feathers/skins/OverAndUnderlineSkin.js");

/***/ }),

/***/ "./lib/feathers/skins/PillSkin.js":
/*!****************************************!*\
  !*** ./lib/feathers/skins/PillSkin.js ***!
  \****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/skins/PillSkin */ "./lib/_gen/feathers/skins/PillSkin.js");

/***/ }),

/***/ "./lib/feathers/skins/ProgrammaticSkin.js":
/*!************************************************!*\
  !*** ./lib/feathers/skins/ProgrammaticSkin.js ***!
  \************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/skins/ProgrammaticSkin */ "./lib/_gen/feathers/skins/ProgrammaticSkin.js");

/***/ }),

/***/ "./lib/feathers/skins/RectangleSkin.js":
/*!*********************************************!*\
  !*** ./lib/feathers/skins/RectangleSkin.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/skins/RectangleSkin */ "./lib/_gen/feathers/skins/RectangleSkin.js");

/***/ }),

/***/ "./lib/feathers/skins/TabSkin.js":
/*!***************************************!*\
  !*** ./lib/feathers/skins/TabSkin.js ***!
  \***************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/skins/TabSkin */ "./lib/_gen/feathers/skins/TabSkin.js");

/***/ }),

/***/ "./lib/feathers/skins/TopAndBottomBorderSkin.js":
/*!******************************************************!*\
  !*** ./lib/feathers/skins/TopAndBottomBorderSkin.js ***!
  \******************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/skins/TopAndBottomBorderSkin */ "./lib/_gen/feathers/skins/TopAndBottomBorderSkin.js");

/***/ }),

/***/ "./lib/feathers/skins/TriangleSkin.js":
/*!********************************************!*\
  !*** ./lib/feathers/skins/TriangleSkin.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/skins/TriangleSkin */ "./lib/_gen/feathers/skins/TriangleSkin.js");

/***/ }),

/***/ "./lib/feathers/skins/UnderlineSkin.js":
/*!*********************************************!*\
  !*** ./lib/feathers/skins/UnderlineSkin.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/skins/UnderlineSkin */ "./lib/_gen/feathers/skins/UnderlineSkin.js");

/***/ }),

/***/ "./lib/feathers/skins/VerticalLineSkin.js":
/*!************************************************!*\
  !*** ./lib/feathers/skins/VerticalLineSkin.js ***!
  \************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/skins/VerticalLineSkin */ "./lib/_gen/feathers/skins/VerticalLineSkin.js");

/***/ }),

/***/ "./lib/feathers/skins/activity/DotsActivitySkin.js":
/*!*********************************************************!*\
  !*** ./lib/feathers/skins/activity/DotsActivitySkin.js ***!
  \*********************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/skins/activity/DotsActivitySkin */ "./lib/_gen/feathers/skins/activity/DotsActivitySkin.js");

/***/ }),

/***/ "./lib/feathers/skins/activity/index.js":
/*!**********************************************!*\
  !*** ./lib/feathers/skins/activity/index.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	DotsActivitySkin: (__webpack_require__(/*! ./DotsActivitySkin */ "./lib/feathers/skins/activity/DotsActivitySkin.js")["default"]),
}

/***/ }),

/***/ "./lib/feathers/skins/index.js":
/*!*************************************!*\
  !*** ./lib/feathers/skins/index.js ***!
  \*************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	BaseGraphicsPathSkin: (__webpack_require__(/*! ./BaseGraphicsPathSkin */ "./lib/feathers/skins/BaseGraphicsPathSkin.js")["default"]),
	CircleSkin: (__webpack_require__(/*! ./CircleSkin */ "./lib/feathers/skins/CircleSkin.js")["default"]),
	DonutSkin: (__webpack_require__(/*! ./DonutSkin */ "./lib/feathers/skins/DonutSkin.js")["default"]),
	EllipseSkin: (__webpack_require__(/*! ./EllipseSkin */ "./lib/feathers/skins/EllipseSkin.js")["default"]),
	HorizontalLineSkin: (__webpack_require__(/*! ./HorizontalLineSkin */ "./lib/feathers/skins/HorizontalLineSkin.js")["default"]),
	IIndeterminateSkin: (__webpack_require__(/*! ./IIndeterminateSkin */ "./lib/feathers/skins/IIndeterminateSkin.js")["default"]),
	IProgrammaticSkin: (__webpack_require__(/*! ./IProgrammaticSkin */ "./lib/feathers/skins/IProgrammaticSkin.js")["default"]),
	LeftAndRightBorderSkin: (__webpack_require__(/*! ./LeftAndRightBorderSkin */ "./lib/feathers/skins/LeftAndRightBorderSkin.js")["default"]),
	MultiSkin: (__webpack_require__(/*! ./MultiSkin */ "./lib/feathers/skins/MultiSkin.js")["default"]),
	OverAndUnderlineSkin: (__webpack_require__(/*! ./OverAndUnderlineSkin */ "./lib/feathers/skins/OverAndUnderlineSkin.js")["default"]),
	PillSkin: (__webpack_require__(/*! ./PillSkin */ "./lib/feathers/skins/PillSkin.js")["default"]),
	ProgrammaticSkin: (__webpack_require__(/*! ./ProgrammaticSkin */ "./lib/feathers/skins/ProgrammaticSkin.js")["default"]),
	RectangleSkin: (__webpack_require__(/*! ./RectangleSkin */ "./lib/feathers/skins/RectangleSkin.js")["default"]),
	TabSkin: (__webpack_require__(/*! ./TabSkin */ "./lib/feathers/skins/TabSkin.js")["default"]),
	TopAndBottomBorderSkin: (__webpack_require__(/*! ./TopAndBottomBorderSkin */ "./lib/feathers/skins/TopAndBottomBorderSkin.js")["default"]),
	TriangleSkin: (__webpack_require__(/*! ./TriangleSkin */ "./lib/feathers/skins/TriangleSkin.js")["default"]),
	UnderlineSkin: (__webpack_require__(/*! ./UnderlineSkin */ "./lib/feathers/skins/UnderlineSkin.js")["default"]),
	VerticalLineSkin: (__webpack_require__(/*! ./VerticalLineSkin */ "./lib/feathers/skins/VerticalLineSkin.js")["default"]),
	activity: __webpack_require__(/*! ./activity */ "./lib/feathers/skins/activity/index.js"),
}

/***/ }),

/***/ "./lib/feathers/style/ClassVariantStyleProvider.js":
/*!*********************************************************!*\
  !*** ./lib/feathers/style/ClassVariantStyleProvider.js ***!
  \*********************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/style/ClassVariantStyleProvider */ "./lib/_gen/feathers/style/ClassVariantStyleProvider.js");

/***/ }),

/***/ "./lib/feathers/style/FunctionStyleProvider.js":
/*!*****************************************************!*\
  !*** ./lib/feathers/style/FunctionStyleProvider.js ***!
  \*****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/style/FunctionStyleProvider */ "./lib/_gen/feathers/style/FunctionStyleProvider.js");

/***/ }),

/***/ "./lib/feathers/style/IDarkModeTheme.js":
/*!**********************************************!*\
  !*** ./lib/feathers/style/IDarkModeTheme.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/style/IDarkModeTheme */ "./lib/_gen/feathers/style/IDarkModeTheme.js");

/***/ }),

/***/ "./lib/feathers/style/IStyleObject.js":
/*!********************************************!*\
  !*** ./lib/feathers/style/IStyleObject.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/style/IStyleObject */ "./lib/_gen/feathers/style/IStyleObject.js");

/***/ }),

/***/ "./lib/feathers/style/IStyleProvider.js":
/*!**********************************************!*\
  !*** ./lib/feathers/style/IStyleProvider.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/style/IStyleProvider */ "./lib/_gen/feathers/style/IStyleProvider.js");

/***/ }),

/***/ "./lib/feathers/style/ITheme.js":
/*!**************************************!*\
  !*** ./lib/feathers/style/ITheme.js ***!
  \**************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/style/ITheme */ "./lib/_gen/feathers/style/ITheme.js");

/***/ }),

/***/ "./lib/feathers/style/IVariantStyleObject.js":
/*!***************************************************!*\
  !*** ./lib/feathers/style/IVariantStyleObject.js ***!
  \***************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/style/IVariantStyleObject */ "./lib/_gen/feathers/style/IVariantStyleObject.js");

/***/ }),

/***/ "./lib/feathers/style/Theme.js":
/*!*************************************!*\
  !*** ./lib/feathers/style/Theme.js ***!
  \*************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/style/Theme */ "./lib/_gen/feathers/style/Theme.js");

/***/ }),

/***/ "./lib/feathers/style/index.js":
/*!*************************************!*\
  !*** ./lib/feathers/style/index.js ***!
  \*************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	ClassVariantStyleProvider: (__webpack_require__(/*! ./ClassVariantStyleProvider */ "./lib/feathers/style/ClassVariantStyleProvider.js")["default"]),
	FunctionStyleProvider: (__webpack_require__(/*! ./FunctionStyleProvider */ "./lib/feathers/style/FunctionStyleProvider.js")["default"]),
	IDarkModeTheme: (__webpack_require__(/*! ./IDarkModeTheme */ "./lib/feathers/style/IDarkModeTheme.js")["default"]),
	IStyleObject: (__webpack_require__(/*! ./IStyleObject */ "./lib/feathers/style/IStyleObject.js")["default"]),
	IStyleProvider: (__webpack_require__(/*! ./IStyleProvider */ "./lib/feathers/style/IStyleProvider.js")["default"]),
	ITheme: (__webpack_require__(/*! ./ITheme */ "./lib/feathers/style/ITheme.js")["default"]),
	IVariantStyleObject: (__webpack_require__(/*! ./IVariantStyleObject */ "./lib/feathers/style/IVariantStyleObject.js")["default"]),
	Theme: (__webpack_require__(/*! ./Theme */ "./lib/feathers/style/Theme.js")["default"]),
}

/***/ }),

/***/ "./lib/feathers/text/TextFormat.js":
/*!*****************************************!*\
  !*** ./lib/feathers/text/TextFormat.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/text/TextFormat */ "./lib/_gen/feathers/text/TextFormat.js");

/***/ }),

/***/ "./lib/feathers/text/index.js":
/*!************************************!*\
  !*** ./lib/feathers/text/index.js ***!
  \************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	TextFormat: (__webpack_require__(/*! ./TextFormat */ "./lib/feathers/text/TextFormat.js")["default"]),
}

/***/ }),

/***/ "./lib/feathers/themes/ClassVariantTheme.js":
/*!**************************************************!*\
  !*** ./lib/feathers/themes/ClassVariantTheme.js ***!
  \**************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/themes/ClassVariantTheme */ "./lib/_gen/feathers/themes/ClassVariantTheme.js");

/***/ }),

/***/ "./lib/feathers/themes/index.js":
/*!**************************************!*\
  !*** ./lib/feathers/themes/index.js ***!
  \**************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	ClassVariantTheme: (__webpack_require__(/*! ./ClassVariantTheme */ "./lib/feathers/themes/ClassVariantTheme.js")["default"]),
	steel: __webpack_require__(/*! ./steel */ "./lib/feathers/themes/steel/index.js"),
}

/***/ }),

/***/ "./lib/feathers/themes/steel/BaseSteelTheme.js":
/*!*****************************************************!*\
  !*** ./lib/feathers/themes/steel/BaseSteelTheme.js ***!
  \*****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/themes/steel/BaseSteelTheme */ "./lib/_gen/feathers/themes/steel/BaseSteelTheme.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/DefaultSteelTheme.js":
/*!********************************************************!*\
  !*** ./lib/feathers/themes/steel/DefaultSteelTheme.js ***!
  \********************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/themes/steel/DefaultSteelTheme */ "./lib/_gen/feathers/themes/steel/DefaultSteelTheme.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/SteelTheme.js":
/*!*************************************************!*\
  !*** ./lib/feathers/themes/steel/SteelTheme.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../_gen/feathers/themes/steel/SteelTheme */ "./lib/_gen/feathers/themes/steel/SteelTheme.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelActivityIndicatorStyles.js":
/*!******************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelActivityIndicatorStyles.js ***!
  \******************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelActivityIndicatorStyles */ "./lib/_gen/feathers/themes/steel/components/SteelActivityIndicatorStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelAlertStyles.js":
/*!******************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelAlertStyles.js ***!
  \******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelAlertStyles */ "./lib/_gen/feathers/themes/steel/components/SteelAlertStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelApplicationStyles.js":
/*!************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelApplicationStyles.js ***!
  \************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelApplicationStyles */ "./lib/_gen/feathers/themes/steel/components/SteelApplicationStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelButtonBarStyles.js":
/*!**********************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelButtonBarStyles.js ***!
  \**********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelButtonBarStyles */ "./lib/_gen/feathers/themes/steel/components/SteelButtonBarStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelButtonStyles.js":
/*!*******************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelButtonStyles.js ***!
  \*******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelButtonStyles */ "./lib/_gen/feathers/themes/steel/components/SteelButtonStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelCalendarGridStyles.js":
/*!*************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelCalendarGridStyles.js ***!
  \*************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelCalendarGridStyles */ "./lib/_gen/feathers/themes/steel/components/SteelCalendarGridStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelCalloutStyles.js":
/*!********************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelCalloutStyles.js ***!
  \********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelCalloutStyles */ "./lib/_gen/feathers/themes/steel/components/SteelCalloutStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelCheckStyles.js":
/*!******************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelCheckStyles.js ***!
  \******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelCheckStyles */ "./lib/_gen/feathers/themes/steel/components/SteelCheckStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelComboBoxStyles.js":
/*!*********************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelComboBoxStyles.js ***!
  \*********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelComboBoxStyles */ "./lib/_gen/feathers/themes/steel/components/SteelComboBoxStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelDatePickerStyles.js":
/*!***********************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelDatePickerStyles.js ***!
  \***********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelDatePickerStyles */ "./lib/_gen/feathers/themes/steel/components/SteelDatePickerStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelDrawerStyles.js":
/*!*******************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelDrawerStyles.js ***!
  \*******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelDrawerStyles */ "./lib/_gen/feathers/themes/steel/components/SteelDrawerStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelFormItemStyles.js":
/*!*********************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelFormItemStyles.js ***!
  \*********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelFormItemStyles */ "./lib/_gen/feathers/themes/steel/components/SteelFormItemStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelFormStyles.js":
/*!*****************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelFormStyles.js ***!
  \*****************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelFormStyles */ "./lib/_gen/feathers/themes/steel/components/SteelFormStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelGridViewHeaderRendererStyles.js":
/*!***********************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelGridViewHeaderRendererStyles.js ***!
  \***********************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelGridViewHeaderRendererStyles */ "./lib/_gen/feathers/themes/steel/components/SteelGridViewHeaderRendererStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelGridViewStyles.js":
/*!*********************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelGridViewStyles.js ***!
  \*********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelGridViewStyles */ "./lib/_gen/feathers/themes/steel/components/SteelGridViewStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelGroupListViewStyles.js":
/*!**************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelGroupListViewStyles.js ***!
  \**************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelGroupListViewStyles */ "./lib/_gen/feathers/themes/steel/components/SteelGroupListViewStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelHDividedBoxStyles.js":
/*!************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelHDividedBoxStyles.js ***!
  \************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelHDividedBoxStyles */ "./lib/_gen/feathers/themes/steel/components/SteelHDividedBoxStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelHProgressBarStyles.js":
/*!*************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelHProgressBarStyles.js ***!
  \*************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelHProgressBarStyles */ "./lib/_gen/feathers/themes/steel/components/SteelHProgressBarStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelHScrollBarStyles.js":
/*!***********************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelHScrollBarStyles.js ***!
  \***********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelHScrollBarStyles */ "./lib/_gen/feathers/themes/steel/components/SteelHScrollBarStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelHSliderStyles.js":
/*!********************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelHSliderStyles.js ***!
  \********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelHSliderStyles */ "./lib/_gen/feathers/themes/steel/components/SteelHSliderStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelHeaderStyles.js":
/*!*******************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelHeaderStyles.js ***!
  \*******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelHeaderStyles */ "./lib/_gen/feathers/themes/steel/components/SteelHeaderStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelHierarchicalItemRendererStyles.js":
/*!*************************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelHierarchicalItemRendererStyles.js ***!
  \*************************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelHierarchicalItemRendererStyles */ "./lib/_gen/feathers/themes/steel/components/SteelHierarchicalItemRendererStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelItemRendererStyles.js":
/*!*************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelItemRendererStyles.js ***!
  \*************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelItemRendererStyles */ "./lib/_gen/feathers/themes/steel/components/SteelItemRendererStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelLabelStyles.js":
/*!******************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelLabelStyles.js ***!
  \******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelLabelStyles */ "./lib/_gen/feathers/themes/steel/components/SteelLabelStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelLayoutGroupItemRendererStyles.js":
/*!************************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelLayoutGroupItemRendererStyles.js ***!
  \************************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelLayoutGroupItemRendererStyles */ "./lib/_gen/feathers/themes/steel/components/SteelLayoutGroupItemRendererStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelLayoutGroupStyles.js":
/*!************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelLayoutGroupStyles.js ***!
  \************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelLayoutGroupStyles */ "./lib/_gen/feathers/themes/steel/components/SteelLayoutGroupStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelListViewStyles.js":
/*!*********************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelListViewStyles.js ***!
  \*********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelListViewStyles */ "./lib/_gen/feathers/themes/steel/components/SteelListViewStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelNumericStepperStyles.js":
/*!***************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelNumericStepperStyles.js ***!
  \***************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelNumericStepperStyles */ "./lib/_gen/feathers/themes/steel/components/SteelNumericStepperStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelPageIndicatorStyles.js":
/*!**************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelPageIndicatorStyles.js ***!
  \**************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelPageIndicatorStyles */ "./lib/_gen/feathers/themes/steel/components/SteelPageIndicatorStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelPageNavigatorStyles.js":
/*!**************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelPageNavigatorStyles.js ***!
  \**************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelPageNavigatorStyles */ "./lib/_gen/feathers/themes/steel/components/SteelPageNavigatorStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelPanelStyles.js":
/*!******************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelPanelStyles.js ***!
  \******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelPanelStyles */ "./lib/_gen/feathers/themes/steel/components/SteelPanelStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelPopUpDatePickerStyles.js":
/*!****************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelPopUpDatePickerStyles.js ***!
  \****************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelPopUpDatePickerStyles */ "./lib/_gen/feathers/themes/steel/components/SteelPopUpDatePickerStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelPopUpListViewStyles.js":
/*!**************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelPopUpListViewStyles.js ***!
  \**************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelPopUpListViewStyles */ "./lib/_gen/feathers/themes/steel/components/SteelPopUpListViewStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelRadioStyles.js":
/*!******************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelRadioStyles.js ***!
  \******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelRadioStyles */ "./lib/_gen/feathers/themes/steel/components/SteelRadioStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelRouterNavigatorStyles.js":
/*!****************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelRouterNavigatorStyles.js ***!
  \****************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelRouterNavigatorStyles */ "./lib/_gen/feathers/themes/steel/components/SteelRouterNavigatorStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelScrollContainerStyles.js":
/*!****************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelScrollContainerStyles.js ***!
  \****************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelScrollContainerStyles */ "./lib/_gen/feathers/themes/steel/components/SteelScrollContainerStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelSortOrderHeaderRendererStyles.js":
/*!************************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelSortOrderHeaderRendererStyles.js ***!
  \************************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelSortOrderHeaderRendererStyles */ "./lib/_gen/feathers/themes/steel/components/SteelSortOrderHeaderRendererStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelStackNavigatorStyles.js":
/*!***************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelStackNavigatorStyles.js ***!
  \***************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelStackNavigatorStyles */ "./lib/_gen/feathers/themes/steel/components/SteelStackNavigatorStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelTabBarStyles.js":
/*!*******************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelTabBarStyles.js ***!
  \*******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelTabBarStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTabBarStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelTabNavigatorStyles.js":
/*!*************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelTabNavigatorStyles.js ***!
  \*************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelTabNavigatorStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTabNavigatorStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelTextAreaStyles.js":
/*!*********************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelTextAreaStyles.js ***!
  \*********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelTextAreaStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTextAreaStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelTextCalloutStyles.js":
/*!************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelTextCalloutStyles.js ***!
  \************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelTextCalloutStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTextCalloutStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelTextInputStyles.js":
/*!**********************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelTextInputStyles.js ***!
  \**********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelTextInputStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTextInputStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelToggleButtonStyles.js":
/*!*************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelToggleButtonStyles.js ***!
  \*************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelToggleButtonStyles */ "./lib/_gen/feathers/themes/steel/components/SteelToggleButtonStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelToggleSwitchStyles.js":
/*!*************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelToggleSwitchStyles.js ***!
  \*************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelToggleSwitchStyles */ "./lib/_gen/feathers/themes/steel/components/SteelToggleSwitchStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelToolTipStyles.js":
/*!********************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelToolTipStyles.js ***!
  \********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelToolTipStyles */ "./lib/_gen/feathers/themes/steel/components/SteelToolTipStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelTreeGridViewStyles.js":
/*!*************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelTreeGridViewStyles.js ***!
  \*************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelTreeGridViewStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTreeGridViewStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelTreeViewItemRendererStyles.js":
/*!*********************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelTreeViewItemRendererStyles.js ***!
  \*********************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelTreeViewItemRendererStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTreeViewItemRendererStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelTreeViewStyles.js":
/*!*********************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelTreeViewStyles.js ***!
  \*********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelTreeViewStyles */ "./lib/_gen/feathers/themes/steel/components/SteelTreeViewStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelVDividedBoxStyles.js":
/*!************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelVDividedBoxStyles.js ***!
  \************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelVDividedBoxStyles */ "./lib/_gen/feathers/themes/steel/components/SteelVDividedBoxStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelVProgressBarStyles.js":
/*!*************************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelVProgressBarStyles.js ***!
  \*************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelVProgressBarStyles */ "./lib/_gen/feathers/themes/steel/components/SteelVProgressBarStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelVScrollBarStyles.js":
/*!***********************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelVScrollBarStyles.js ***!
  \***********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelVScrollBarStyles */ "./lib/_gen/feathers/themes/steel/components/SteelVScrollBarStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/SteelVSliderStyles.js":
/*!********************************************************************!*\
  !*** ./lib/feathers/themes/steel/components/SteelVSliderStyles.js ***!
  \********************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../../../_gen/feathers/themes/steel/components/SteelVSliderStyles */ "./lib/_gen/feathers/themes/steel/components/SteelVSliderStyles.js");

/***/ }),

/***/ "./lib/feathers/themes/steel/components/index.js":
/*!*******************************************************!*\
  !*** ./lib/feathers/themes/steel/components/index.js ***!
  \*******************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	SteelActivityIndicatorStyles: (__webpack_require__(/*! ./SteelActivityIndicatorStyles */ "./lib/feathers/themes/steel/components/SteelActivityIndicatorStyles.js")["default"]),
	SteelAlertStyles: (__webpack_require__(/*! ./SteelAlertStyles */ "./lib/feathers/themes/steel/components/SteelAlertStyles.js")["default"]),
	SteelApplicationStyles: (__webpack_require__(/*! ./SteelApplicationStyles */ "./lib/feathers/themes/steel/components/SteelApplicationStyles.js")["default"]),
	SteelButtonBarStyles: (__webpack_require__(/*! ./SteelButtonBarStyles */ "./lib/feathers/themes/steel/components/SteelButtonBarStyles.js")["default"]),
	SteelButtonStyles: (__webpack_require__(/*! ./SteelButtonStyles */ "./lib/feathers/themes/steel/components/SteelButtonStyles.js")["default"]),
	SteelCalendarGridStyles: (__webpack_require__(/*! ./SteelCalendarGridStyles */ "./lib/feathers/themes/steel/components/SteelCalendarGridStyles.js")["default"]),
	SteelCalloutStyles: (__webpack_require__(/*! ./SteelCalloutStyles */ "./lib/feathers/themes/steel/components/SteelCalloutStyles.js")["default"]),
	SteelCheckStyles: (__webpack_require__(/*! ./SteelCheckStyles */ "./lib/feathers/themes/steel/components/SteelCheckStyles.js")["default"]),
	SteelComboBoxStyles: (__webpack_require__(/*! ./SteelComboBoxStyles */ "./lib/feathers/themes/steel/components/SteelComboBoxStyles.js")["default"]),
	SteelDatePickerStyles: (__webpack_require__(/*! ./SteelDatePickerStyles */ "./lib/feathers/themes/steel/components/SteelDatePickerStyles.js")["default"]),
	SteelDrawerStyles: (__webpack_require__(/*! ./SteelDrawerStyles */ "./lib/feathers/themes/steel/components/SteelDrawerStyles.js")["default"]),
	SteelFormItemStyles: (__webpack_require__(/*! ./SteelFormItemStyles */ "./lib/feathers/themes/steel/components/SteelFormItemStyles.js")["default"]),
	SteelFormStyles: (__webpack_require__(/*! ./SteelFormStyles */ "./lib/feathers/themes/steel/components/SteelFormStyles.js")["default"]),
	SteelGridViewHeaderRendererStyles: (__webpack_require__(/*! ./SteelGridViewHeaderRendererStyles */ "./lib/feathers/themes/steel/components/SteelGridViewHeaderRendererStyles.js")["default"]),
	SteelGridViewStyles: (__webpack_require__(/*! ./SteelGridViewStyles */ "./lib/feathers/themes/steel/components/SteelGridViewStyles.js")["default"]),
	SteelGroupListViewStyles: (__webpack_require__(/*! ./SteelGroupListViewStyles */ "./lib/feathers/themes/steel/components/SteelGroupListViewStyles.js")["default"]),
	SteelHDividedBoxStyles: (__webpack_require__(/*! ./SteelHDividedBoxStyles */ "./lib/feathers/themes/steel/components/SteelHDividedBoxStyles.js")["default"]),
	SteelHProgressBarStyles: (__webpack_require__(/*! ./SteelHProgressBarStyles */ "./lib/feathers/themes/steel/components/SteelHProgressBarStyles.js")["default"]),
	SteelHScrollBarStyles: (__webpack_require__(/*! ./SteelHScrollBarStyles */ "./lib/feathers/themes/steel/components/SteelHScrollBarStyles.js")["default"]),
	SteelHSliderStyles: (__webpack_require__(/*! ./SteelHSliderStyles */ "./lib/feathers/themes/steel/components/SteelHSliderStyles.js")["default"]),
	SteelHeaderStyles: (__webpack_require__(/*! ./SteelHeaderStyles */ "./lib/feathers/themes/steel/components/SteelHeaderStyles.js")["default"]),
	SteelHierarchicalItemRendererStyles: (__webpack_require__(/*! ./SteelHierarchicalItemRendererStyles */ "./lib/feathers/themes/steel/components/SteelHierarchicalItemRendererStyles.js")["default"]),
	SteelItemRendererStyles: (__webpack_require__(/*! ./SteelItemRendererStyles */ "./lib/feathers/themes/steel/components/SteelItemRendererStyles.js")["default"]),
	SteelLabelStyles: (__webpack_require__(/*! ./SteelLabelStyles */ "./lib/feathers/themes/steel/components/SteelLabelStyles.js")["default"]),
	SteelLayoutGroupItemRendererStyles: (__webpack_require__(/*! ./SteelLayoutGroupItemRendererStyles */ "./lib/feathers/themes/steel/components/SteelLayoutGroupItemRendererStyles.js")["default"]),
	SteelLayoutGroupStyles: (__webpack_require__(/*! ./SteelLayoutGroupStyles */ "./lib/feathers/themes/steel/components/SteelLayoutGroupStyles.js")["default"]),
	SteelListViewStyles: (__webpack_require__(/*! ./SteelListViewStyles */ "./lib/feathers/themes/steel/components/SteelListViewStyles.js")["default"]),
	SteelNumericStepperStyles: (__webpack_require__(/*! ./SteelNumericStepperStyles */ "./lib/feathers/themes/steel/components/SteelNumericStepperStyles.js")["default"]),
	SteelPageIndicatorStyles: (__webpack_require__(/*! ./SteelPageIndicatorStyles */ "./lib/feathers/themes/steel/components/SteelPageIndicatorStyles.js")["default"]),
	SteelPageNavigatorStyles: (__webpack_require__(/*! ./SteelPageNavigatorStyles */ "./lib/feathers/themes/steel/components/SteelPageNavigatorStyles.js")["default"]),
	SteelPanelStyles: (__webpack_require__(/*! ./SteelPanelStyles */ "./lib/feathers/themes/steel/components/SteelPanelStyles.js")["default"]),
	SteelPopUpDatePickerStyles: (__webpack_require__(/*! ./SteelPopUpDatePickerStyles */ "./lib/feathers/themes/steel/components/SteelPopUpDatePickerStyles.js")["default"]),
	SteelPopUpListViewStyles: (__webpack_require__(/*! ./SteelPopUpListViewStyles */ "./lib/feathers/themes/steel/components/SteelPopUpListViewStyles.js")["default"]),
	SteelRadioStyles: (__webpack_require__(/*! ./SteelRadioStyles */ "./lib/feathers/themes/steel/components/SteelRadioStyles.js")["default"]),
	SteelRouterNavigatorStyles: (__webpack_require__(/*! ./SteelRouterNavigatorStyles */ "./lib/feathers/themes/steel/components/SteelRouterNavigatorStyles.js")["default"]),
	SteelScrollContainerStyles: (__webpack_require__(/*! ./SteelScrollContainerStyles */ "./lib/feathers/themes/steel/components/SteelScrollContainerStyles.js")["default"]),
	SteelSortOrderHeaderRendererStyles: (__webpack_require__(/*! ./SteelSortOrderHeaderRendererStyles */ "./lib/feathers/themes/steel/components/SteelSortOrderHeaderRendererStyles.js")["default"]),
	SteelStackNavigatorStyles: (__webpack_require__(/*! ./SteelStackNavigatorStyles */ "./lib/feathers/themes/steel/components/SteelStackNavigatorStyles.js")["default"]),
	SteelTabBarStyles: (__webpack_require__(/*! ./SteelTabBarStyles */ "./lib/feathers/themes/steel/components/SteelTabBarStyles.js")["default"]),
	SteelTabNavigatorStyles: (__webpack_require__(/*! ./SteelTabNavigatorStyles */ "./lib/feathers/themes/steel/components/SteelTabNavigatorStyles.js")["default"]),
	SteelTextAreaStyles: (__webpack_require__(/*! ./SteelTextAreaStyles */ "./lib/feathers/themes/steel/components/SteelTextAreaStyles.js")["default"]),
	SteelTextCalloutStyles: (__webpack_require__(/*! ./SteelTextCalloutStyles */ "./lib/feathers/themes/steel/components/SteelTextCalloutStyles.js")["default"]),
	SteelTextInputStyles: (__webpack_require__(/*! ./SteelTextInputStyles */ "./lib/feathers/themes/steel/components/SteelTextInputStyles.js")["default"]),
	SteelToggleButtonStyles: (__webpack_require__(/*! ./SteelToggleButtonStyles */ "./lib/feathers/themes/steel/components/SteelToggleButtonStyles.js")["default"]),
	SteelToggleSwitchStyles: (__webpack_require__(/*! ./SteelToggleSwitchStyles */ "./lib/feathers/themes/steel/components/SteelToggleSwitchStyles.js")["default"]),
	SteelToolTipStyles: (__webpack_require__(/*! ./SteelToolTipStyles */ "./lib/feathers/themes/steel/components/SteelToolTipStyles.js")["default"]),
	SteelTreeGridViewStyles: (__webpack_require__(/*! ./SteelTreeGridViewStyles */ "./lib/feathers/themes/steel/components/SteelTreeGridViewStyles.js")["default"]),
	SteelTreeViewItemRendererStyles: (__webpack_require__(/*! ./SteelTreeViewItemRendererStyles */ "./lib/feathers/themes/steel/components/SteelTreeViewItemRendererStyles.js")["default"]),
	SteelTreeViewStyles: (__webpack_require__(/*! ./SteelTreeViewStyles */ "./lib/feathers/themes/steel/components/SteelTreeViewStyles.js")["default"]),
	SteelVDividedBoxStyles: (__webpack_require__(/*! ./SteelVDividedBoxStyles */ "./lib/feathers/themes/steel/components/SteelVDividedBoxStyles.js")["default"]),
	SteelVProgressBarStyles: (__webpack_require__(/*! ./SteelVProgressBarStyles */ "./lib/feathers/themes/steel/components/SteelVProgressBarStyles.js")["default"]),
	SteelVScrollBarStyles: (__webpack_require__(/*! ./SteelVScrollBarStyles */ "./lib/feathers/themes/steel/components/SteelVScrollBarStyles.js")["default"]),
	SteelVSliderStyles: (__webpack_require__(/*! ./SteelVSliderStyles */ "./lib/feathers/themes/steel/components/SteelVSliderStyles.js")["default"]),
}

/***/ }),

/***/ "./lib/feathers/themes/steel/index.js":
/*!********************************************!*\
  !*** ./lib/feathers/themes/steel/index.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	BaseSteelTheme: (__webpack_require__(/*! ./BaseSteelTheme */ "./lib/feathers/themes/steel/BaseSteelTheme.js")["default"]),
	DefaultSteelTheme: (__webpack_require__(/*! ./DefaultSteelTheme */ "./lib/feathers/themes/steel/DefaultSteelTheme.js")["default"]),
	SteelTheme: (__webpack_require__(/*! ./SteelTheme */ "./lib/feathers/themes/steel/SteelTheme.js")["default"]),
	components: __webpack_require__(/*! ./components */ "./lib/feathers/themes/steel/components/index.js"),
}

/***/ }),

/***/ "./lib/feathers/utils/BitmapDataCache.js":
/*!***********************************************!*\
  !*** ./lib/feathers/utils/BitmapDataCache.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/BitmapDataCache */ "./lib/_gen/feathers/utils/BitmapDataCache.js");

/***/ }),

/***/ "./lib/feathers/utils/DPadFocusUtil.js":
/*!*********************************************!*\
  !*** ./lib/feathers/utils/DPadFocusUtil.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/DPadFocusUtil */ "./lib/_gen/feathers/utils/DPadFocusUtil.js");

/***/ }),

/***/ "./lib/feathers/utils/DateUtil.js":
/*!****************************************!*\
  !*** ./lib/feathers/utils/DateUtil.js ***!
  \****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/DateUtil */ "./lib/_gen/feathers/utils/DateUtil.js");

/***/ }),

/***/ "./lib/feathers/utils/DeviceUtil.js":
/*!******************************************!*\
  !*** ./lib/feathers/utils/DeviceUtil.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/DeviceUtil */ "./lib/_gen/feathers/utils/DeviceUtil.js");

/***/ }),

/***/ "./lib/feathers/utils/DisplayObjectFactory.js":
/*!****************************************************!*\
  !*** ./lib/feathers/utils/DisplayObjectFactory.js ***!
  \****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/DisplayObjectFactory */ "./lib/_gen/feathers/utils/DisplayObjectFactory.js");

/***/ }),

/***/ "./lib/feathers/utils/DisplayObjectRecycler.js":
/*!*****************************************************!*\
  !*** ./lib/feathers/utils/DisplayObjectRecycler.js ***!
  \*****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/DisplayObjectRecycler */ "./lib/_gen/feathers/utils/DisplayObjectRecycler.js");

/***/ }),

/***/ "./lib/feathers/utils/DisplayUtil.js":
/*!*******************************************!*\
  !*** ./lib/feathers/utils/DisplayUtil.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/DisplayUtil */ "./lib/_gen/feathers/utils/DisplayUtil.js");

/***/ }),

/***/ "./lib/feathers/utils/EdgePuller.js":
/*!******************************************!*\
  !*** ./lib/feathers/utils/EdgePuller.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/EdgePuller */ "./lib/_gen/feathers/utils/EdgePuller.js");

/***/ }),

/***/ "./lib/feathers/utils/ExclusivePointer.js":
/*!************************************************!*\
  !*** ./lib/feathers/utils/ExclusivePointer.js ***!
  \************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/ExclusivePointer */ "./lib/_gen/feathers/utils/ExclusivePointer.js");

/***/ }),

/***/ "./lib/feathers/utils/FocusUtil.js":
/*!*****************************************!*\
  !*** ./lib/feathers/utils/FocusUtil.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/FocusUtil */ "./lib/_gen/feathers/utils/FocusUtil.js");

/***/ }),

/***/ "./lib/feathers/utils/KeyToState.js":
/*!******************************************!*\
  !*** ./lib/feathers/utils/KeyToState.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/KeyToState */ "./lib/_gen/feathers/utils/KeyToState.js");

/***/ }),

/***/ "./lib/feathers/utils/LongPress.js":
/*!*****************************************!*\
  !*** ./lib/feathers/utils/LongPress.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/LongPress */ "./lib/_gen/feathers/utils/LongPress.js");

/***/ }),

/***/ "./lib/feathers/utils/MathUtil.js":
/*!****************************************!*\
  !*** ./lib/feathers/utils/MathUtil.js ***!
  \****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/MathUtil */ "./lib/_gen/feathers/utils/MathUtil.js");

/***/ }),

/***/ "./lib/feathers/utils/MeasurementsUtil.js":
/*!************************************************!*\
  !*** ./lib/feathers/utils/MeasurementsUtil.js ***!
  \************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/MeasurementsUtil */ "./lib/_gen/feathers/utils/MeasurementsUtil.js");

/***/ }),

/***/ "./lib/feathers/utils/Path2EReg.js":
/*!*****************************************!*\
  !*** ./lib/feathers/utils/Path2EReg.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/Path2EReg */ "./lib/_gen/feathers/utils/Path2EReg.js");

/***/ }),

/***/ "./lib/feathers/utils/PointerToState.js":
/*!**********************************************!*\
  !*** ./lib/feathers/utils/PointerToState.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/PointerToState */ "./lib/_gen/feathers/utils/PointerToState.js");

/***/ }),

/***/ "./lib/feathers/utils/PointerTrigger.js":
/*!**********************************************!*\
  !*** ./lib/feathers/utils/PointerTrigger.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/PointerTrigger */ "./lib/_gen/feathers/utils/PointerTrigger.js");

/***/ }),

/***/ "./lib/feathers/utils/PopUpUtil.js":
/*!*****************************************!*\
  !*** ./lib/feathers/utils/PopUpUtil.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/PopUpUtil */ "./lib/_gen/feathers/utils/PopUpUtil.js");

/***/ }),

/***/ "./lib/feathers/utils/ScaleUtil.js":
/*!*****************************************!*\
  !*** ./lib/feathers/utils/ScaleUtil.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/ScaleUtil */ "./lib/_gen/feathers/utils/ScaleUtil.js");

/***/ }),

/***/ "./lib/feathers/utils/ScreenDensityScaleCalculator.js":
/*!************************************************************!*\
  !*** ./lib/feathers/utils/ScreenDensityScaleCalculator.js ***!
  \************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/ScreenDensityScaleCalculator */ "./lib/_gen/feathers/utils/ScreenDensityScaleCalculator.js");

/***/ }),

/***/ "./lib/feathers/utils/Scroller.js":
/*!****************************************!*\
  !*** ./lib/feathers/utils/Scroller.js ***!
  \****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/Scroller */ "./lib/_gen/feathers/utils/Scroller.js");

/***/ }),

/***/ "./lib/feathers/utils/TextFormatUtil.js":
/*!**********************************************!*\
  !*** ./lib/feathers/utils/TextFormatUtil.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./../../_gen/feathers/utils/TextFormatUtil */ "./lib/_gen/feathers/utils/TextFormatUtil.js");

/***/ }),

/***/ "./lib/feathers/utils/index.js":
/*!*************************************!*\
  !*** ./lib/feathers/utils/index.js ***!
  \*************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = {
	BitmapDataCache: (__webpack_require__(/*! ./BitmapDataCache */ "./lib/feathers/utils/BitmapDataCache.js")["default"]),
	DPadFocusUtil: (__webpack_require__(/*! ./DPadFocusUtil */ "./lib/feathers/utils/DPadFocusUtil.js")["default"]),
	DateUtil: (__webpack_require__(/*! ./DateUtil */ "./lib/feathers/utils/DateUtil.js")["default"]),
	DeviceUtil: (__webpack_require__(/*! ./DeviceUtil */ "./lib/feathers/utils/DeviceUtil.js")["default"]),
	DisplayObjectFactory: (__webpack_require__(/*! ./DisplayObjectFactory */ "./lib/feathers/utils/DisplayObjectFactory.js")["default"]),
	DisplayObjectRecycler: (__webpack_require__(/*! ./DisplayObjectRecycler */ "./lib/feathers/utils/DisplayObjectRecycler.js")["default"]),
	DisplayUtil: (__webpack_require__(/*! ./DisplayUtil */ "./lib/feathers/utils/DisplayUtil.js")["default"]),
	EdgePuller: (__webpack_require__(/*! ./EdgePuller */ "./lib/feathers/utils/EdgePuller.js")["default"]),
	ExclusivePointer: (__webpack_require__(/*! ./ExclusivePointer */ "./lib/feathers/utils/ExclusivePointer.js")["default"]),
	FocusUtil: (__webpack_require__(/*! ./FocusUtil */ "./lib/feathers/utils/FocusUtil.js")["default"]),
	KeyToState: (__webpack_require__(/*! ./KeyToState */ "./lib/feathers/utils/KeyToState.js")["default"]),
	LongPress: (__webpack_require__(/*! ./LongPress */ "./lib/feathers/utils/LongPress.js")["default"]),
	MathUtil: (__webpack_require__(/*! ./MathUtil */ "./lib/feathers/utils/MathUtil.js")["default"]),
	MeasurementsUtil: (__webpack_require__(/*! ./MeasurementsUtil */ "./lib/feathers/utils/MeasurementsUtil.js")["default"]),
	Path2EReg: (__webpack_require__(/*! ./Path2EReg */ "./lib/feathers/utils/Path2EReg.js")["default"]),
	PointerToState: (__webpack_require__(/*! ./PointerToState */ "./lib/feathers/utils/PointerToState.js")["default"]),
	PointerTrigger: (__webpack_require__(/*! ./PointerTrigger */ "./lib/feathers/utils/PointerTrigger.js")["default"]),
	PopUpUtil: (__webpack_require__(/*! ./PopUpUtil */ "./lib/feathers/utils/PopUpUtil.js")["default"]),
	ScaleUtil: (__webpack_require__(/*! ./ScaleUtil */ "./lib/feathers/utils/ScaleUtil.js")["default"]),
	ScreenDensityScaleCalculator: (__webpack_require__(/*! ./ScreenDensityScaleCalculator */ "./lib/feathers/utils/ScreenDensityScaleCalculator.js")["default"]),
	Scroller: (__webpack_require__(/*! ./Scroller */ "./lib/feathers/utils/Scroller.js")["default"]),
	TextFormatUtil: (__webpack_require__(/*! ./TextFormatUtil */ "./lib/feathers/utils/TextFormatUtil.js")["default"]),
}

/***/ }),

/***/ "./lib/feathersui-defineProperties-wrapper.js":
/*!****************************************************!*\
  !*** ./lib/feathersui-defineProperties-wrapper.js ***!
  \****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const feathers = __webpack_require__(/*! ./feathers/index.js */ "./lib/feathers/index.js");Object.defineProperty(feathers.controls.Radio.prototype, "toggleGroup", { get: function() { return this.get_toggleGroup() }, set: function(value) { return this.set_toggleGroup(value); } });Object.defineProperty(feathers.controls.Alert.prototype, "text", { get: function() { return this.get_text() }, set: function(value) { return this.set_text(value); } });Object.defineProperty(feathers.controls.Alert.prototype, "htmlText", { get: function() { return this.get_htmlText() }, set: function(value) { return this.set_htmlText(value); } });Object.defineProperty(feathers.controls.Alert.prototype, "titleText", { get: function() { return this.get_titleText() }, set: function(value) { return this.set_titleText(value); } });Object.defineProperty(feathers.controls.Alert.prototype, "messageLabelFactory", { get: function() { return this.get_messageLabelFactory() }, set: function(value) { return this.set_messageLabelFactory(value); } });Object.defineProperty(feathers.controls.Alert.prototype, "headerFactory", { get: function() { return this.get_headerFactory() }, set: function(value) { return this.set_headerFactory(value); } });Object.defineProperty(feathers.controls.Alert.prototype, "buttonBarFactory", { get: function() { return this.get_buttonBarFactory() }, set: function(value) { return this.set_buttonBarFactory(value); } });Object.defineProperty(feathers.controls.Alert.prototype, "buttonsDataProvider", { get: function() { return this.get_buttonsDataProvider() }, set: function(value) { return this.set_buttonsDataProvider(value); } });Object.defineProperty(feathers.controls.Alert.prototype, "icon", { get: function() { return this.get_icon() }, set: function(value) { return this.set_icon(value); } });Object.defineProperty(feathers.controls.Alert.prototype, "customButtonBarVariant", { get: function() { return this.get_customButtonBarVariant() }, set: function(value) { return this.set_customButtonBarVariant(value); } });Object.defineProperty(feathers.controls.Alert.prototype, "customHeaderVariant", { get: function() { return this.get_customHeaderVariant() }, set: function(value) { return this.set_customHeaderVariant(value); } });Object.defineProperty(feathers.controls.Alert.prototype, "customMessageLabelVariant", { get: function() { return this.get_customMessageLabelVariant() }, set: function(value) { return this.set_customMessageLabelVariant(value); } });Object.defineProperty(feathers.core.IMeasureObject.prototype, "explicitWidth", { get: function() { return this.get_explicitWidth() }, set: function(value) { return this.set_explicitWidth(value); } });Object.defineProperty(feathers.core.IMeasureObject.prototype, "explicitHeight", { get: function() { return this.get_explicitHeight() }, set: function(value) { return this.set_explicitHeight(value); } });Object.defineProperty(feathers.core.IMeasureObject.prototype, "explicitMinWidth", { get: function() { return this.get_explicitMinWidth() }, set: function(value) { return this.set_explicitMinWidth(value); } });Object.defineProperty(feathers.core.IMeasureObject.prototype, "explicitMinHeight", { get: function() { return this.get_explicitMinHeight() }, set: function(value) { return this.set_explicitMinHeight(value); } });Object.defineProperty(feathers.core.IMeasureObject.prototype, "explicitMaxWidth", { get: function() { return this.get_explicitMaxWidth() }, set: function(value) { return this.set_explicitMaxWidth(value); } });Object.defineProperty(feathers.core.IMeasureObject.prototype, "explicitMaxHeight", { get: function() { return this.get_explicitMaxHeight() }, set: function(value) { return this.set_explicitMaxHeight(value); } });Object.defineProperty(feathers.core.IMeasureObject.prototype, "minWidth", { get: function() { return this.get_minWidth() }, set: function(value) { return this.set_minWidth(value); } });Object.defineProperty(feathers.core.IMeasureObject.prototype, "minHeight", { get: function() { return this.get_minHeight() }, set: function(value) { return this.set_minHeight(value); } });Object.defineProperty(feathers.core.IMeasureObject.prototype, "maxWidth", { get: function() { return this.get_maxWidth() }, set: function(value) { return this.set_maxWidth(value); } });Object.defineProperty(feathers.core.IMeasureObject.prototype, "maxHeight", { get: function() { return this.get_maxHeight() }, set: function(value) { return this.set_maxHeight(value); } });Object.defineProperty(feathers.skins.IIndeterminateSkin.prototype, "indeterminatePosition", { get: function() { return this.get_indeterminatePosition() }, set: function(value) { return this.set_indeterminatePosition(value); } });Object.defineProperty(feathers.layout.TiledRowsLayout.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.layout.TiledRowsLayout.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.layout.TiledRowsLayout.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.layout.TiledRowsLayout.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.layout.TiledRowsLayout.prototype, "horizontalGap", { get: function() { return this.get_horizontalGap() }, set: function(value) { return this.set_horizontalGap(value); } });Object.defineProperty(feathers.layout.TiledRowsLayout.prototype, "minHorizontalGap", { get: function() { return this.get_minHorizontalGap() }, set: function(value) { return this.set_minHorizontalGap(value); } });Object.defineProperty(feathers.layout.TiledRowsLayout.prototype, "verticalGap", { get: function() { return this.get_verticalGap() }, set: function(value) { return this.set_verticalGap(value); } });Object.defineProperty(feathers.layout.TiledRowsLayout.prototype, "minVerticalGap", { get: function() { return this.get_minVerticalGap() }, set: function(value) { return this.set_minVerticalGap(value); } });Object.defineProperty(feathers.layout.TiledRowsLayout.prototype, "horizontalAlign", { get: function() { return this.get_horizontalAlign() }, set: function(value) { return this.set_horizontalAlign(value); } });Object.defineProperty(feathers.layout.TiledRowsLayout.prototype, "verticalAlign", { get: function() { return this.get_verticalAlign() }, set: function(value) { return this.set_verticalAlign(value); } });Object.defineProperty(feathers.layout.TiledRowsLayout.prototype, "alignEmptyHorizontalTiles", { get: function() { return this.get_alignEmptyHorizontalTiles() }, set: function(value) { return this.set_alignEmptyHorizontalTiles(value); } });Object.defineProperty(feathers.layout.TiledRowsLayout.prototype, "requestedColumnCount", { get: function() { return this.get_requestedColumnCount() }, set: function(value) { return this.set_requestedColumnCount(value); } });Object.defineProperty(feathers.layout.TiledRowsLayout.prototype, "requestedMinColumnCount", { get: function() { return this.get_requestedMinColumnCount() }, set: function(value) { return this.set_requestedMinColumnCount(value); } });Object.defineProperty(feathers.layout.TiledRowsLayout.prototype, "requestedMaxColumnCount", { get: function() { return this.get_requestedMaxColumnCount() }, set: function(value) { return this.set_requestedMaxColumnCount(value); } });Object.defineProperty(feathers.controls.BasicButton.prototype, "currentState", { get: function() { return this.get_currentState() }, set: function(value) { return this.set_currentState(value); } });Object.defineProperty(feathers.controls.BasicButton.prototype, "keepDownStateOnRollOut", { get: function() { return this.get_keepDownStateOnRollOut() }, set: function(value) { return this.set_keepDownStateOnRollOut(value); } });Object.defineProperty(feathers.controls.BasicButton.prototype, "backgroundSkin", { get: function() { return this.get_backgroundSkin() }, set: function(value) { return this.set_backgroundSkin(value); } });Object.defineProperty(feathers.controls.Button.prototype, "text", { get: function() { return this.get_text() }, set: function(value) { return this.set_text(value); } });Object.defineProperty(feathers.controls.Button.prototype, "htmlText", { get: function() { return this.get_htmlText() }, set: function(value) { return this.set_htmlText(value); } });Object.defineProperty(feathers.controls.Button.prototype, "baseline", { get: function() { return this.get_baseline() }, set: function(value) { return this.set_baseline(value); } });Object.defineProperty(feathers.controls.Button.prototype, "textFormat", { get: function() { return this.get_textFormat() }, set: function(value) { return this.set_textFormat(value); } });Object.defineProperty(feathers.controls.Button.prototype, "disabledTextFormat", { get: function() { return this.get_disabledTextFormat() }, set: function(value) { return this.set_disabledTextFormat(value); } });Object.defineProperty(feathers.controls.Button.prototype, "embedFonts", { get: function() { return this.get_embedFonts() }, set: function(value) { return this.set_embedFonts(value); } });Object.defineProperty(feathers.controls.Button.prototype, "wordWrap", { get: function() { return this.get_wordWrap() }, set: function(value) { return this.set_wordWrap(value); } });Object.defineProperty(feathers.controls.Button.prototype, "icon", { get: function() { return this.get_icon() }, set: function(value) { return this.set_icon(value); } });Object.defineProperty(feathers.controls.Button.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.controls.Button.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.controls.Button.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.controls.Button.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.controls.Button.prototype, "horizontalAlign", { get: function() { return this.get_horizontalAlign() }, set: function(value) { return this.set_horizontalAlign(value); } });Object.defineProperty(feathers.controls.Button.prototype, "verticalAlign", { get: function() { return this.get_verticalAlign() }, set: function(value) { return this.set_verticalAlign(value); } });Object.defineProperty(feathers.controls.Button.prototype, "iconPosition", { get: function() { return this.get_iconPosition() }, set: function(value) { return this.set_iconPosition(value); } });Object.defineProperty(feathers.controls.Button.prototype, "gap", { get: function() { return this.get_gap() }, set: function(value) { return this.set_gap(value); } });Object.defineProperty(feathers.controls.Button.prototype, "minGap", { get: function() { return this.get_minGap() }, set: function(value) { return this.set_minGap(value); } });Object.defineProperty(feathers.controls.Button.prototype, "iconOffsetX", { get: function() { return this.get_iconOffsetX() }, set: function(value) { return this.set_iconOffsetX(value); } });Object.defineProperty(feathers.controls.Button.prototype, "iconOffsetY", { get: function() { return this.get_iconOffsetY() }, set: function(value) { return this.set_iconOffsetY(value); } });Object.defineProperty(feathers.controls.Button.prototype, "textOffsetX", { get: function() { return this.get_textOffsetX() }, set: function(value) { return this.set_textOffsetX(value); } });Object.defineProperty(feathers.controls.Button.prototype, "textOffsetY", { get: function() { return this.get_textOffsetY() }, set: function(value) { return this.set_textOffsetY(value); } });Object.defineProperty(feathers.controls.Button.prototype, "showText", { get: function() { return this.get_showText() }, set: function(value) { return this.set_showText(value); } });Object.defineProperty(feathers.controls.navigators.BaseNavigator.prototype, "activeItemID", { get: function() { return this.get_activeItemID() }, set: function(value) { return this.set_activeItemID(value); } });Object.defineProperty(feathers.controls.navigators.BaseNavigator.prototype, "activeItemView", { get: function() { return this.get_activeItemView() }, set: function(value) { return this.set_activeItemView(value); } });Object.defineProperty(feathers.controls.navigators.BaseNavigator.prototype, "transitionActive", { get: function() { return this.get_transitionActive() }, set: function(value) { return this.set_transitionActive(value); } });Object.defineProperty(feathers.controls.navigators.BaseNavigator.prototype, "childFocusEnabled", { get: function() { return this.get_childFocusEnabled() }, set: function(value) { return this.set_childFocusEnabled(value); } });Object.defineProperty(feathers.controls.navigators.BaseNavigator.prototype, "autoSizeMode", { get: function() { return this.get_autoSizeMode() }, set: function(value) { return this.set_autoSizeMode(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "viewPort", { get: function() { return this.get_viewPort() }, set: function(value) { return this.set_viewPort(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "backgroundSkin", { get: function() { return this.get_backgroundSkin() }, set: function(value) { return this.set_backgroundSkin(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "disabledBackgroundSkin", { get: function() { return this.get_disabledBackgroundSkin() }, set: function(value) { return this.set_disabledBackgroundSkin(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "maskSkin", { get: function() { return this.get_maskSkin() }, set: function(value) { return this.set_maskSkin(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "viewPortMaskSkin", { get: function() { return this.get_viewPortMaskSkin() }, set: function(value) { return this.set_viewPortMaskSkin(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "fixedScrollBars", { get: function() { return this.get_fixedScrollBars() }, set: function(value) { return this.set_fixedScrollBars(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "showScrollBars", { get: function() { return this.get_showScrollBars() }, set: function(value) { return this.set_showScrollBars(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "autoHideScrollBars", { get: function() { return this.get_autoHideScrollBars() }, set: function(value) { return this.set_autoHideScrollBars(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "scrollBarXFactory", { get: function() { return this.get_scrollBarXFactory() }, set: function(value) { return this.set_scrollBarXFactory(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "scrollBarYFactory", { get: function() { return this.get_scrollBarYFactory() }, set: function(value) { return this.set_scrollBarYFactory(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "scrollerFactory", { get: function() { return this.get_scrollerFactory() }, set: function(value) { return this.set_scrollerFactory(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "scrollX", { get: function() { return this.get_scrollX() }, set: function(value) { return this.set_scrollX(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "restrictedScrollX", { get: function() { return this.get_restrictedScrollX() }, set: function(value) { return this.set_restrictedScrollX(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "scrollY", { get: function() { return this.get_scrollY() }, set: function(value) { return this.set_scrollY(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "restrictedScrollY", { get: function() { return this.get_restrictedScrollY() }, set: function(value) { return this.set_restrictedScrollY(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "minScrollX", { get: function() { return this.get_minScrollX() }, set: function(value) { return this.set_minScrollX(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "minScrollY", { get: function() { return this.get_minScrollY() }, set: function(value) { return this.set_minScrollY(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "maxScrollX", { get: function() { return this.get_maxScrollX() }, set: function(value) { return this.set_maxScrollX(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "maxScrollY", { get: function() { return this.get_maxScrollY() }, set: function(value) { return this.set_maxScrollY(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "scrollStepX", { get: function() { return this.get_scrollStepX() }, set: function(value) { return this.set_scrollStepX(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "scrollStepY", { get: function() { return this.get_scrollStepY() }, set: function(value) { return this.set_scrollStepY(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "scrollPolicyX", { get: function() { return this.get_scrollPolicyX() }, set: function(value) { return this.set_scrollPolicyX(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "scrollPolicyY", { get: function() { return this.get_scrollPolicyY() }, set: function(value) { return this.set_scrollPolicyY(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "scrollBarXPosition", { get: function() { return this.get_scrollBarXPosition() }, set: function(value) { return this.set_scrollBarXPosition(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "scrollBarYPosition", { get: function() { return this.get_scrollBarYPosition() }, set: function(value) { return this.set_scrollBarYPosition(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "showScrollBarMinimumDuration", { get: function() { return this.get_showScrollBarMinimumDuration() }, set: function(value) { return this.set_showScrollBarMinimumDuration(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "hideScrollBarDuration", { get: function() { return this.get_hideScrollBarDuration() }, set: function(value) { return this.set_hideScrollBarDuration(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "hideScrollBarEase", { get: function() { return this.get_hideScrollBarEase() }, set: function(value) { return this.set_hideScrollBarEase(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "scrollPixelSnapping", { get: function() { return this.get_scrollPixelSnapping() }, set: function(value) { return this.set_scrollPixelSnapping(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "measureViewPort", { get: function() { return this.get_measureViewPort() }, set: function(value) { return this.set_measureViewPort(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollContainer.prototype, "scrollMode", { get: function() { return this.get_scrollMode() }, set: function(value) { return this.set_scrollMode(value); } });Object.defineProperty(feathers.controls.dataRenderers.SortOrderHeaderRenderer.prototype, "sortOrder", { get: function() { return this.get_sortOrder() }, set: function(value) { return this.set_sortOrder(value); } });Object.defineProperty(feathers.controls.dataRenderers.SortOrderHeaderRenderer.prototype, "sortAscendingIcon", { get: function() { return this.get_sortAscendingIcon() }, set: function(value) { return this.set_sortAscendingIcon(value); } });Object.defineProperty(feathers.controls.dataRenderers.SortOrderHeaderRenderer.prototype, "sortDescendingIcon", { get: function() { return this.get_sortDescendingIcon() }, set: function(value) { return this.set_sortDescendingIcon(value); } });Object.defineProperty(feathers.skins.TabSkin.prototype, "cornerRadiusPosition", { get: function() { return this.get_cornerRadiusPosition() }, set: function(value) { return this.set_cornerRadiusPosition(value); } });Object.defineProperty(feathers.skins.TabSkin.prototype, "drawBaseBorder", { get: function() { return this.get_drawBaseBorder() }, set: function(value) { return this.set_drawBaseBorder(value); } });Object.defineProperty(feathers.skins.TabSkin.prototype, "cornerRadius", { get: function() { return this.get_cornerRadius() }, set: function(value) { return this.set_cornerRadius(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "scrollX", { get: function() { return this.get_scrollX() }, set: function(value) { return this.set_scrollX(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "scrollY", { get: function() { return this.get_scrollY() }, set: function(value) { return this.set_scrollY(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "virtualCache", { get: function() { return this.get_virtualCache() }, set: function(value) { return this.set_virtualCache(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "elasticTop", { get: function() { return this.get_elasticTop() }, set: function(value) { return this.set_elasticTop(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "elasticRight", { get: function() { return this.get_elasticRight() }, set: function(value) { return this.set_elasticRight(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "elasticBottom", { get: function() { return this.get_elasticBottom() }, set: function(value) { return this.set_elasticBottom(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "elasticLeft", { get: function() { return this.get_elasticLeft() }, set: function(value) { return this.set_elasticLeft(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "alignEmptyHorizontalTiles", { get: function() { return this.get_alignEmptyHorizontalTiles() }, set: function(value) { return this.set_alignEmptyHorizontalTiles(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "horizontalAlign", { get: function() { return this.get_horizontalAlign() }, set: function(value) { return this.set_horizontalAlign(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "verticalAlign", { get: function() { return this.get_verticalAlign() }, set: function(value) { return this.set_verticalAlign(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "horizontalGap", { get: function() { return this.get_horizontalGap() }, set: function(value) { return this.set_horizontalGap(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "minHorizontalGap", { get: function() { return this.get_minHorizontalGap() }, set: function(value) { return this.set_minHorizontalGap(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "verticalGap", { get: function() { return this.get_verticalGap() }, set: function(value) { return this.set_verticalGap(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "minVerticalGap", { get: function() { return this.get_minVerticalGap() }, set: function(value) { return this.set_minVerticalGap(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "requestedColumnCount", { get: function() { return this.get_requestedColumnCount() }, set: function(value) { return this.set_requestedColumnCount(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "requestedMinColumnCount", { get: function() { return this.get_requestedMinColumnCount() }, set: function(value) { return this.set_requestedMinColumnCount(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "requestedMaxColumnCount", { get: function() { return this.get_requestedMaxColumnCount() }, set: function(value) { return this.set_requestedMaxColumnCount(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "requestedRowCount", { get: function() { return this.get_requestedRowCount() }, set: function(value) { return this.set_requestedRowCount(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "requestedMinRowCount", { get: function() { return this.get_requestedMinRowCount() }, set: function(value) { return this.set_requestedMinRowCount(value); } });Object.defineProperty(feathers.layout.TiledRowsListLayout.prototype, "requestedMaxRowCount", { get: function() { return this.get_requestedMaxRowCount() }, set: function(value) { return this.set_requestedMaxRowCount(value); } });Object.defineProperty(feathers.controls.dataRenderers.TreeGridViewRowRenderer.prototype, "treeGridView", { get: function() { return this.get_treeGridView() }, set: function(value) { return this.set_treeGridView(value); } });Object.defineProperty(feathers.controls.dataRenderers.TreeGridViewRowRenderer.prototype, "selected", { get: function() { return this.get_selected() }, set: function(value) { return this.set_selected(value); } });Object.defineProperty(feathers.controls.dataRenderers.TreeGridViewRowRenderer.prototype, "rowLocation", { get: function() { return this.get_rowLocation() }, set: function(value) { return this.set_rowLocation(value); } });Object.defineProperty(feathers.controls.dataRenderers.TreeGridViewRowRenderer.prototype, "layoutIndex", { get: function() { return this.get_layoutIndex() }, set: function(value) { return this.set_layoutIndex(value); } });Object.defineProperty(feathers.controls.dataRenderers.TreeGridViewRowRenderer.prototype, "branch", { get: function() { return this.get_branch() }, set: function(value) { return this.set_branch(value); } });Object.defineProperty(feathers.controls.dataRenderers.TreeGridViewRowRenderer.prototype, "opened", { get: function() { return this.get_opened() }, set: function(value) { return this.set_opened(value); } });Object.defineProperty(feathers.controls.dataRenderers.TreeGridViewRowRenderer.prototype, "data", { get: function() { return this.get_data() }, set: function(value) { return this.set_data(value); } });Object.defineProperty(feathers.controls.dataRenderers.TreeGridViewRowRenderer.prototype, "columns", { get: function() { return this.get_columns() }, set: function(value) { return this.set_columns(value); } });Object.defineProperty(feathers.controls.dataRenderers.TreeGridViewRowRenderer.prototype, "cellRendererRecycler", { get: function() { return this.get_cellRendererRecycler() }, set: function(value) { return this.set_cellRendererRecycler(value); } });Object.defineProperty(feathers.controls.dataRenderers.TreeGridViewRowRenderer.prototype, "forceCellStateUpdate", { get: function() { return this.get_forceCellStateUpdate() }, set: function(value) { return this.set_forceCellStateUpdate(value); } });Object.defineProperty(feathers.controls.dataRenderers.TreeGridViewRowRenderer.prototype, "customCellRendererVariant", { get: function() { return this.get_customCellRendererVariant() }, set: function(value) { return this.set_customCellRendererVariant(value); } });Object.defineProperty(feathers.controls.dataRenderers.TreeGridViewRowRenderer.prototype, "customColumnWidths", { get: function() { return this.get_customColumnWidths() }, set: function(value) { return this.set_customColumnWidths(value); } });Object.defineProperty(feathers.utils.Scroller.prototype, "scrollX", { get: function() { return this.get_scrollX() }, set: function(value) { return this.set_scrollX(value); } });Object.defineProperty(feathers.utils.Scroller.prototype, "scrollY", { get: function() { return this.get_scrollY() }, set: function(value) { return this.set_scrollY(value); } });Object.defineProperty(feathers.utils.Scroller.prototype, "restrictedScrollX", { get: function() { return this.get_restrictedScrollX() }, set: function(value) { return this.set_restrictedScrollX(value); } });Object.defineProperty(feathers.utils.Scroller.prototype, "restrictedScrollY", { get: function() { return this.get_restrictedScrollY() }, set: function(value) { return this.set_restrictedScrollY(value); } });Object.defineProperty(feathers.utils.Scroller.prototype, "minScrollX", { get: function() { return this.get_minScrollX() }, set: function(value) { return this.set_minScrollX(value); } });Object.defineProperty(feathers.utils.Scroller.prototype, "minScrollY", { get: function() { return this.get_minScrollY() }, set: function(value) { return this.set_minScrollY(value); } });Object.defineProperty(feathers.utils.Scroller.prototype, "maxScrollX", { get: function() { return this.get_maxScrollX() }, set: function(value) { return this.set_maxScrollX(value); } });Object.defineProperty(feathers.utils.Scroller.prototype, "maxScrollY", { get: function() { return this.get_maxScrollY() }, set: function(value) { return this.set_maxScrollY(value); } });Object.defineProperty(feathers.utils.Scroller.prototype, "visibleWidth", { get: function() { return this.get_visibleWidth() }, set: function(value) { return this.set_visibleWidth(value); } });Object.defineProperty(feathers.utils.Scroller.prototype, "visibleHeight", { get: function() { return this.get_visibleHeight() }, set: function(value) { return this.set_visibleHeight(value); } });Object.defineProperty(feathers.utils.Scroller.prototype, "contentWidth", { get: function() { return this.get_contentWidth() }, set: function(value) { return this.set_contentWidth(value); } });Object.defineProperty(feathers.utils.Scroller.prototype, "contentHeight", { get: function() { return this.get_contentHeight() }, set: function(value) { return this.set_contentHeight(value); } });Object.defineProperty(feathers.utils.Scroller.prototype, "scrolling", { get: function() { return this.get_scrolling() }, set: function(value) { return this.set_scrolling(value); } });Object.defineProperty(feathers.utils.Scroller.prototype, "draggingX", { get: function() { return this.get_draggingX() }, set: function(value) { return this.set_draggingX(value); } });Object.defineProperty(feathers.utils.Scroller.prototype, "draggingY", { get: function() { return this.get_draggingY() }, set: function(value) { return this.set_draggingY(value); } });Object.defineProperty(feathers.utils.Scroller.prototype, "decelerationRate", { get: function() { return this.get_decelerationRate() }, set: function(value) { return this.set_decelerationRate(value); } });Object.defineProperty(feathers.utils.Scroller.prototype, "target", { get: function() { return this.get_target() }, set: function(value) { return this.set_target(value); } });Object.defineProperty(feathers.utils.Scroller.prototype, "touchPointID", { get: function() { return this.get_touchPointID() }, set: function(value) { return this.set_touchPointID(value); } });Object.defineProperty(feathers.utils.Scroller.prototype, "touchPointIsSimulated", { get: function() { return this.get_touchPointIsSimulated() }, set: function(value) { return this.set_touchPointIsSimulated(value); } });Object.defineProperty(feathers.core.DefaultToolTipManager.prototype, "root", { get: function() { return this.get_root() }, set: function(value) { return this.set_root(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "scrollX", { get: function() { return this.get_scrollX() }, set: function(value) { return this.set_scrollX(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "scrollY", { get: function() { return this.get_scrollY() }, set: function(value) { return this.set_scrollY(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "virtualCache", { get: function() { return this.get_virtualCache() }, set: function(value) { return this.set_virtualCache(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "elasticTop", { get: function() { return this.get_elasticTop() }, set: function(value) { return this.set_elasticTop(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "elasticRight", { get: function() { return this.get_elasticRight() }, set: function(value) { return this.set_elasticRight(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "elasticBottom", { get: function() { return this.get_elasticBottom() }, set: function(value) { return this.set_elasticBottom(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "elasticLeft", { get: function() { return this.get_elasticLeft() }, set: function(value) { return this.set_elasticLeft(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "alignEmptyHorizontalTiles", { get: function() { return this.get_alignEmptyHorizontalTiles() }, set: function(value) { return this.set_alignEmptyHorizontalTiles(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "horizontalAlign", { get: function() { return this.get_horizontalAlign() }, set: function(value) { return this.set_horizontalAlign(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "alignEmptyVerticalTiles", { get: function() { return this.get_alignEmptyVerticalTiles() }, set: function(value) { return this.set_alignEmptyVerticalTiles(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "verticalAlign", { get: function() { return this.get_verticalAlign() }, set: function(value) { return this.set_verticalAlign(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "pageDirection", { get: function() { return this.get_pageDirection() }, set: function(value) { return this.set_pageDirection(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "horizontalGap", { get: function() { return this.get_horizontalGap() }, set: function(value) { return this.set_horizontalGap(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "minHorizontalGap", { get: function() { return this.get_minHorizontalGap() }, set: function(value) { return this.set_minHorizontalGap(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "verticalGap", { get: function() { return this.get_verticalGap() }, set: function(value) { return this.set_verticalGap(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "minVerticalGap", { get: function() { return this.get_minVerticalGap() }, set: function(value) { return this.set_minVerticalGap(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "requestedColumnCount", { get: function() { return this.get_requestedColumnCount() }, set: function(value) { return this.set_requestedColumnCount(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "requestedMinColumnCount", { get: function() { return this.get_requestedMinColumnCount() }, set: function(value) { return this.set_requestedMinColumnCount(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "requestedMaxColumnCount", { get: function() { return this.get_requestedMaxColumnCount() }, set: function(value) { return this.set_requestedMaxColumnCount(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "requestedRowCount", { get: function() { return this.get_requestedRowCount() }, set: function(value) { return this.set_requestedRowCount(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "requestedMinRowCount", { get: function() { return this.get_requestedMinRowCount() }, set: function(value) { return this.set_requestedMinRowCount(value); } });Object.defineProperty(feathers.layout.PagedTiledRowsListLayout.prototype, "requestedMaxRowCount", { get: function() { return this.get_requestedMaxRowCount() }, set: function(value) { return this.set_requestedMaxRowCount(value); } });Object.defineProperty(feathers.controls.dataRenderers.IDataRenderer.prototype, "data", { get: function() { return this.get_data() }, set: function(value) { return this.set_data(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "editable", { get: function() { return this.get_editable() }, set: function(value) { return this.set_editable(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "selectable", { get: function() { return this.get_selectable() }, set: function(value) { return this.set_selectable(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "currentState", { get: function() { return this.get_currentState() }, set: function(value) { return this.set_currentState(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "text", { get: function() { return this.get_text() }, set: function(value) { return this.set_text(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "baseline", { get: function() { return this.get_baseline() }, set: function(value) { return this.set_baseline(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "prompt", { get: function() { return this.get_prompt() }, set: function(value) { return this.set_prompt(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "restrict", { get: function() { return this.get_restrict() }, set: function(value) { return this.set_restrict(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "displayAsPassword", { get: function() { return this.get_displayAsPassword() }, set: function(value) { return this.set_displayAsPassword(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "errorString", { get: function() { return this.get_errorString() }, set: function(value) { return this.set_errorString(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "errorStringCalloutOpen", { get: function() { return this.get_errorStringCalloutOpen() }, set: function(value) { return this.set_errorStringCalloutOpen(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "smoothScrolling", { get: function() { return this.get_smoothScrolling() }, set: function(value) { return this.set_smoothScrolling(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "textFormat", { get: function() { return this.get_textFormat() }, set: function(value) { return this.set_textFormat(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "disabledTextFormat", { get: function() { return this.get_disabledTextFormat() }, set: function(value) { return this.set_disabledTextFormat(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "promptTextFormat", { get: function() { return this.get_promptTextFormat() }, set: function(value) { return this.set_promptTextFormat(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "embedFonts", { get: function() { return this.get_embedFonts() }, set: function(value) { return this.set_embedFonts(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "wordWrap", { get: function() { return this.get_wordWrap() }, set: function(value) { return this.set_wordWrap(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "textPaddingTop", { get: function() { return this.get_textPaddingTop() }, set: function(value) { return this.set_textPaddingTop(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "textPaddingRight", { get: function() { return this.get_textPaddingRight() }, set: function(value) { return this.set_textPaddingRight(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "textPaddingBottom", { get: function() { return this.get_textPaddingBottom() }, set: function(value) { return this.set_textPaddingBottom(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "textPaddingLeft", { get: function() { return this.get_textPaddingLeft() }, set: function(value) { return this.set_textPaddingLeft(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "showPromptWhenEmptyAndFocused", { get: function() { return this.get_showPromptWhenEmptyAndFocused() }, set: function(value) { return this.set_showPromptWhenEmptyAndFocused(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "selectionAnchorIndex", { get: function() { return this.get_selectionAnchorIndex() }, set: function(value) { return this.set_selectionAnchorIndex(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "selectionActiveIndex", { get: function() { return this.get_selectionActiveIndex() }, set: function(value) { return this.set_selectionActiveIndex(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "maxChars", { get: function() { return this.get_maxChars() }, set: function(value) { return this.set_maxChars(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "customErrorCalloutVariant", { get: function() { return this.get_customErrorCalloutVariant() }, set: function(value) { return this.set_customErrorCalloutVariant(value); } });Object.defineProperty(feathers.controls.TextArea.prototype, "stageFocusTarget", { get: function() { return this.get_stageFocusTarget() }, set: function(value) { return this.set_stageFocusTarget(value); } });Object.defineProperty(feathers.controls.dataRenderers.ITreeGridViewHeaderRenderer.prototype, "column", { get: function() { return this.get_column() }, set: function(value) { return this.set_column(value); } });Object.defineProperty(feathers.controls.dataRenderers.ITreeGridViewHeaderRenderer.prototype, "columnIndex", { get: function() { return this.get_columnIndex() }, set: function(value) { return this.set_columnIndex(value); } });Object.defineProperty(feathers.controls.dataRenderers.ITreeGridViewHeaderRenderer.prototype, "treeGridViewOwner", { get: function() { return this.get_treeGridViewOwner() }, set: function(value) { return this.set_treeGridViewOwner(value); } });Object.defineProperty(feathers.layout.FlowRowsLayout.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.layout.FlowRowsLayout.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.layout.FlowRowsLayout.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.layout.FlowRowsLayout.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.layout.FlowRowsLayout.prototype, "horizontalGap", { get: function() { return this.get_horizontalGap() }, set: function(value) { return this.set_horizontalGap(value); } });Object.defineProperty(feathers.layout.FlowRowsLayout.prototype, "verticalGap", { get: function() { return this.get_verticalGap() }, set: function(value) { return this.set_verticalGap(value); } });Object.defineProperty(feathers.layout.FlowRowsLayout.prototype, "horizontalAlign", { get: function() { return this.get_horizontalAlign() }, set: function(value) { return this.set_horizontalAlign(value); } });Object.defineProperty(feathers.layout.FlowRowsLayout.prototype, "verticalAlign", { get: function() { return this.get_verticalAlign() }, set: function(value) { return this.set_verticalAlign(value); } });Object.defineProperty(feathers.layout.FlowRowsLayout.prototype, "rowVerticalAlign", { get: function() { return this.get_rowVerticalAlign() }, set: function(value) { return this.set_rowVerticalAlign(value); } });Object.defineProperty(feathers.layout.FlowRowsLayout.prototype, "justifyResetEnabled", { get: function() { return this.get_justifyResetEnabled() }, set: function(value) { return this.set_justifyResetEnabled(value); } });Object.defineProperty(feathers.skins.activity.DotsActivitySkin.prototype, "indeterminatePosition", { get: function() { return this.get_indeterminatePosition() }, set: function(value) { return this.set_indeterminatePosition(value); } });Object.defineProperty(feathers.skins.activity.DotsActivitySkin.prototype, "numDots", { get: function() { return this.get_numDots() }, set: function(value) { return this.set_numDots(value); } });Object.defineProperty(feathers.skins.activity.DotsActivitySkin.prototype, "numEmptyDots", { get: function() { return this.get_numEmptyDots() }, set: function(value) { return this.set_numEmptyDots(value); } });Object.defineProperty(feathers.skins.activity.DotsActivitySkin.prototype, "dotRadius", { get: function() { return this.get_dotRadius() }, set: function(value) { return this.set_dotRadius(value); } });Object.defineProperty(feathers.skins.activity.DotsActivitySkin.prototype, "endDotRadius", { get: function() { return this.get_endDotRadius() }, set: function(value) { return this.set_endDotRadius(value); } });Object.defineProperty(feathers.skins.activity.DotsActivitySkin.prototype, "dotColor", { get: function() { return this.get_dotColor() }, set: function(value) { return this.set_dotColor(value); } });Object.defineProperty(feathers.skins.activity.DotsActivitySkin.prototype, "endDotColor", { get: function() { return this.get_endDotColor() }, set: function(value) { return this.set_endDotColor(value); } });Object.defineProperty(feathers.skins.activity.DotsActivitySkin.prototype, "dotAlpha", { get: function() { return this.get_dotAlpha() }, set: function(value) { return this.set_dotAlpha(value); } });Object.defineProperty(feathers.skins.activity.DotsActivitySkin.prototype, "endDotAlpha", { get: function() { return this.get_endDotAlpha() }, set: function(value) { return this.set_endDotAlpha(value); } });Object.defineProperty(feathers.core.ToggleGroup.prototype, "numItems", { get: function() { return this.get_numItems() }, set: function(value) { return this.set_numItems(value); } });Object.defineProperty(feathers.core.ToggleGroup.prototype, "selectedIndex", { get: function() { return this.get_selectedIndex() }, set: function(value) { return this.set_selectedIndex(value); } });Object.defineProperty(feathers.core.ToggleGroup.prototype, "maxSelectedIndex", { get: function() { return this.get_maxSelectedIndex() }, set: function(value) { return this.set_maxSelectedIndex(value); } });Object.defineProperty(feathers.core.ToggleGroup.prototype, "selectedItem", { get: function() { return this.get_selectedItem() }, set: function(value) { return this.set_selectedItem(value); } });Object.defineProperty(feathers.core.ToggleGroup.prototype, "requireSelection", { get: function() { return this.get_requireSelection() }, set: function(value) { return this.set_requireSelection(value); } });Object.defineProperty(feathers.core.IFocusManager.prototype, "root", { get: function() { return this.get_root() }, set: function(value) { return this.set_root(value); } });Object.defineProperty(feathers.core.IFocusManager.prototype, "focus", { get: function() { return this.get_focus() }, set: function(value) { return this.set_focus(value); } });Object.defineProperty(feathers.core.IFocusManager.prototype, "focusPane", { get: function() { return this.get_focusPane() }, set: function(value) { return this.set_focusPane(value); } });Object.defineProperty(feathers.core.IFocusManager.prototype, "showFocusIndicator", { get: function() { return this.get_showFocusIndicator() }, set: function(value) { return this.set_showFocusIndicator(value); } });Object.defineProperty(feathers.core.IFocusManager.prototype, "enabled", { get: function() { return this.get_enabled() }, set: function(value) { return this.set_enabled(value); } });Object.defineProperty(feathers.core.FeathersControl.prototype, "initialized", { get: function() { return this.get_initialized() }, set: function(value) { return this.set_initialized(value); } });Object.defineProperty(feathers.core.FeathersControl.prototype, "created", { get: function() { return this.get_created() }, set: function(value) { return this.set_created(value); } });Object.defineProperty(feathers.core.FeathersControl.prototype, "enabled", { get: function() { return this.get_enabled() }, set: function(value) { return this.set_enabled(value); } });Object.defineProperty(feathers.core.FeathersControl.prototype, "toolTip", { get: function() { return this.get_toolTip() }, set: function(value) { return this.set_toolTip(value); } });Object.defineProperty(feathers.core.FeathersControl.prototype, "themeEnabled", { get: function() { return this.get_themeEnabled() }, set: function(value) { return this.set_themeEnabled(value); } });Object.defineProperty(feathers.core.FeathersControl.prototype, "styleProvider", { get: function() { return this.get_styleProvider() }, set: function(value) { return this.set_styleProvider(value); } });Object.defineProperty(feathers.core.FeathersControl.prototype, "styleContext", { get: function() { return this.get_styleContext() }, set: function(value) { return this.set_styleContext(value); } });Object.defineProperty(feathers.core.FeathersControl.prototype, "includeInLayout", { get: function() { return this.get_includeInLayout() }, set: function(value) { return this.set_includeInLayout(value); } });Object.defineProperty(feathers.core.FeathersControl.prototype, "layoutData", { get: function() { return this.get_layoutData() }, set: function(value) { return this.set_layoutData(value); } });Object.defineProperty(feathers.core.FeathersControl.prototype, "focusManager", { get: function() { return this.get_focusManager() }, set: function(value) { return this.set_focusManager(value); } });Object.defineProperty(feathers.core.FeathersControl.prototype, "focusOwner", { get: function() { return this.get_focusOwner() }, set: function(value) { return this.set_focusOwner(value); } });Object.defineProperty(feathers.core.FeathersControl.prototype, "rawTabEnabled", { get: function() { return this.get_rawTabEnabled() }, set: function(value) { return this.set_rawTabEnabled(value); } });Object.defineProperty(feathers.core.FeathersControl.prototype, "focusEnabled", { get: function() { return this.get_focusEnabled() }, set: function(value) { return this.set_focusEnabled(value); } });Object.defineProperty(feathers.core.FeathersControl.prototype, "focusRectSkin", { get: function() { return this.get_focusRectSkin() }, set: function(value) { return this.set_focusRectSkin(value); } });Object.defineProperty(feathers.core.FeathersControl.prototype, "focusPaddingTop", { get: function() { return this.get_focusPaddingTop() }, set: function(value) { return this.set_focusPaddingTop(value); } });Object.defineProperty(feathers.core.FeathersControl.prototype, "focusPaddingRight", { get: function() { return this.get_focusPaddingRight() }, set: function(value) { return this.set_focusPaddingRight(value); } });Object.defineProperty(feathers.core.FeathersControl.prototype, "focusPaddingBottom", { get: function() { return this.get_focusPaddingBottom() }, set: function(value) { return this.set_focusPaddingBottom(value); } });Object.defineProperty(feathers.core.FeathersControl.prototype, "focusPaddingLeft", { get: function() { return this.get_focusPaddingLeft() }, set: function(value) { return this.set_focusPaddingLeft(value); } });Object.defineProperty(feathers.core.FeathersControl.prototype, "variant", { get: function() { return this.get_variant() }, set: function(value) { return this.set_variant(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseDividedBox.prototype, "autoSizeMode", { get: function() { return this.get_autoSizeMode() }, set: function(value) { return this.set_autoSizeMode(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseDividedBox.prototype, "backgroundSkin", { get: function() { return this.get_backgroundSkin() }, set: function(value) { return this.set_backgroundSkin(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseDividedBox.prototype, "disabledBackgroundSkin", { get: function() { return this.get_disabledBackgroundSkin() }, set: function(value) { return this.set_disabledBackgroundSkin(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseDividedBox.prototype, "resizeDraggingSkin", { get: function() { return this.get_resizeDraggingSkin() }, set: function(value) { return this.set_resizeDraggingSkin(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseDividedBox.prototype, "dividerFactory", { get: function() { return this.get_dividerFactory() }, set: function(value) { return this.set_dividerFactory(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseDividedBox.prototype, "xmlContent", { get: function() { return this.get_xmlContent() }, set: function(value) { return this.set_xmlContent(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseDividedBox.prototype, "numRawChildren", { get: function() { return this.get_numRawChildren() }, set: function(value) { return this.set_numRawChildren(value); } });Object.defineProperty(feathers.controls.ButtonBar.prototype, "dataProvider", { get: function() { return this.get_dataProvider() }, set: function(value) { return this.set_dataProvider(value); } });Object.defineProperty(feathers.controls.ButtonBar.prototype, "customButtonVariant", { get: function() { return this.get_customButtonVariant() }, set: function(value) { return this.set_customButtonVariant(value); } });Object.defineProperty(feathers.controls.ButtonBar.prototype, "buttonRecycler", { get: function() { return this.get_buttonRecycler() }, set: function(value) { return this.set_buttonRecycler(value); } });Object.defineProperty(feathers.controls.ButtonBar.prototype, "forceItemStateUpdate", { get: function() { return this.get_forceItemStateUpdate() }, set: function(value) { return this.set_forceItemStateUpdate(value); } });Object.defineProperty(feathers.controls.ButtonBar.prototype, "buttonRecyclerIDFunction", { get: function() { return this.get_buttonRecyclerIDFunction() }, set: function(value) { return this.set_buttonRecyclerIDFunction(value); } });Object.defineProperty(feathers.controls.ButtonBar.prototype, "layout", { get: function() { return this.get_layout() }, set: function(value) { return this.set_layout(value); } });Object.defineProperty(feathers.controls.ButtonBar.prototype, "backgroundSkin", { get: function() { return this.get_backgroundSkin() }, set: function(value) { return this.set_backgroundSkin(value); } });Object.defineProperty(feathers.controls.ButtonBar.prototype, "disabledBackgroundSkin", { get: function() { return this.get_disabledBackgroundSkin() }, set: function(value) { return this.set_disabledBackgroundSkin(value); } });Object.defineProperty(feathers.utils.LongPress.prototype, "target", { get: function() { return this.get_target() }, set: function(value) { return this.set_target(value); } });Object.defineProperty(feathers.utils.LongPress.prototype, "eventFactory", { get: function() { return this.get_eventFactory() }, set: function(value) { return this.set_eventFactory(value); } });Object.defineProperty(feathers.utils.LongPress.prototype, "enabled", { get: function() { return this.get_enabled() }, set: function(value) { return this.set_enabled(value); } });Object.defineProperty(feathers.utils.LongPress.prototype, "customHitTest", { get: function() { return this.get_customHitTest() }, set: function(value) { return this.set_customHitTest(value); } });Object.defineProperty(feathers.core.ITextControl.prototype, "text", { get: function() { return this.get_text() }, set: function(value) { return this.set_text(value); } });Object.defineProperty(feathers.core.ITextControl.prototype, "baseline", { get: function() { return this.get_baseline() }, set: function(value) { return this.set_baseline(value); } });Object.defineProperty(feathers.controls.IScrollBar.prototype, "step", { get: function() { return this.get_step() }, set: function(value) { return this.set_step(value); } });Object.defineProperty(feathers.controls.IScrollBar.prototype, "page", { get: function() { return this.get_page() }, set: function(value) { return this.set_page(value); } });Object.defineProperty(feathers.controls.dataRenderers.IOptionalHierarchyItemRenderer.prototype, "showHierarchy", { get: function() { return this.get_showHierarchy() }, set: function(value) { return this.set_showHierarchy(value); } });Object.defineProperty(feathers.core.IPointerDelegate.prototype, "pointerTarget", { get: function() { return this.get_pointerTarget() }, set: function(value) { return this.set_pointerTarget(value); } });Object.defineProperty(feathers.layout.HDividedBoxLayout.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.layout.HDividedBoxLayout.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.layout.HDividedBoxLayout.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.layout.HDividedBoxLayout.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.layout.HDividedBoxLayout.prototype, "verticalAlign", { get: function() { return this.get_verticalAlign() }, set: function(value) { return this.set_verticalAlign(value); } });Object.defineProperty(feathers.layout.HDividedBoxLayout.prototype, "customItemWidths", { get: function() { return this.get_customItemWidths() }, set: function(value) { return this.set_customItemWidths(value); } });Object.defineProperty(feathers.layout.HDividedBoxLayout.prototype, "fallbackFluidIndex", { get: function() { return this.get_fallbackFluidIndex() }, set: function(value) { return this.set_fallbackFluidIndex(value); } });Object.defineProperty(feathers.data.TreeCollection.prototype, "array", { get: function() { return this.get_array() }, set: function(value) { return this.set_array(value); } });Object.defineProperty(feathers.data.TreeCollection.prototype, "filterFunction", { get: function() { return this.get_filterFunction() }, set: function(value) { return this.set_filterFunction(value); } });Object.defineProperty(feathers.data.TreeCollection.prototype, "sortCompareFunction", { get: function() { return this.get_sortCompareFunction() }, set: function(value) { return this.set_sortCompareFunction(value); } });Object.defineProperty(feathers.controls.NumericStepper.prototype, "value", { get: function() { return this.get_value() }, set: function(value) { return this.set_value(value); } });Object.defineProperty(feathers.controls.NumericStepper.prototype, "minimum", { get: function() { return this.get_minimum() }, set: function(value) { return this.set_minimum(value); } });Object.defineProperty(feathers.controls.NumericStepper.prototype, "maximum", { get: function() { return this.get_maximum() }, set: function(value) { return this.set_maximum(value); } });Object.defineProperty(feathers.controls.NumericStepper.prototype, "step", { get: function() { return this.get_step() }, set: function(value) { return this.set_step(value); } });Object.defineProperty(feathers.controls.NumericStepper.prototype, "snapInterval", { get: function() { return this.get_snapInterval() }, set: function(value) { return this.set_snapInterval(value); } });Object.defineProperty(feathers.controls.NumericStepper.prototype, "editable", { get: function() { return this.get_editable() }, set: function(value) { return this.set_editable(value); } });Object.defineProperty(feathers.controls.NumericStepper.prototype, "enableButtonsAtRangeLimits", { get: function() { return this.get_enableButtonsAtRangeLimits() }, set: function(value) { return this.set_enableButtonsAtRangeLimits(value); } });Object.defineProperty(feathers.controls.NumericStepper.prototype, "valueFormatFunction", { get: function() { return this.get_valueFormatFunction() }, set: function(value) { return this.set_valueFormatFunction(value); } });Object.defineProperty(feathers.controls.NumericStepper.prototype, "valueParseFunction", { get: function() { return this.get_valueParseFunction() }, set: function(value) { return this.set_valueParseFunction(value); } });Object.defineProperty(feathers.controls.NumericStepper.prototype, "stageFocusTarget", { get: function() { return this.get_stageFocusTarget() }, set: function(value) { return this.set_stageFocusTarget(value); } });Object.defineProperty(feathers.controls.NumericStepper.prototype, "decrementButtonFactory", { get: function() { return this.get_decrementButtonFactory() }, set: function(value) { return this.set_decrementButtonFactory(value); } });Object.defineProperty(feathers.controls.NumericStepper.prototype, "incrementButtonFactory", { get: function() { return this.get_incrementButtonFactory() }, set: function(value) { return this.set_incrementButtonFactory(value); } });Object.defineProperty(feathers.controls.NumericStepper.prototype, "textInputFactory", { get: function() { return this.get_textInputFactory() }, set: function(value) { return this.set_textInputFactory(value); } });Object.defineProperty(feathers.controls.NumericStepper.prototype, "customDecrementButtonVariant", { get: function() { return this.get_customDecrementButtonVariant() }, set: function(value) { return this.set_customDecrementButtonVariant(value); } });Object.defineProperty(feathers.controls.NumericStepper.prototype, "customIncrementButtonVariant", { get: function() { return this.get_customIncrementButtonVariant() }, set: function(value) { return this.set_customIncrementButtonVariant(value); } });Object.defineProperty(feathers.controls.NumericStepper.prototype, "customTextInputVariant", { get: function() { return this.get_customTextInputVariant() }, set: function(value) { return this.set_customTextInputVariant(value); } });Object.defineProperty(feathers.controls.NumericStepper.prototype, "textInputPosition", { get: function() { return this.get_textInputPosition() }, set: function(value) { return this.set_textInputPosition(value); } });Object.defineProperty(feathers.controls.NumericStepper.prototype, "buttonDirection", { get: function() { return this.get_buttonDirection() }, set: function(value) { return this.set_buttonDirection(value); } });Object.defineProperty(feathers.controls.NumericStepper.prototype, "textInputGap", { get: function() { return this.get_textInputGap() }, set: function(value) { return this.set_textInputGap(value); } });Object.defineProperty(feathers.controls.NumericStepper.prototype, "buttonGap", { get: function() { return this.get_buttonGap() }, set: function(value) { return this.set_buttonGap(value); } });Object.defineProperty(feathers.controls.LayoutGroup.prototype, "layout", { get: function() { return this.get_layout() }, set: function(value) { return this.set_layout(value); } });Object.defineProperty(feathers.controls.LayoutGroup.prototype, "backgroundSkin", { get: function() { return this.get_backgroundSkin() }, set: function(value) { return this.set_backgroundSkin(value); } });Object.defineProperty(feathers.controls.LayoutGroup.prototype, "disabledBackgroundSkin", { get: function() { return this.get_disabledBackgroundSkin() }, set: function(value) { return this.set_disabledBackgroundSkin(value); } });Object.defineProperty(feathers.controls.LayoutGroup.prototype, "maskSkin", { get: function() { return this.get_maskSkin() }, set: function(value) { return this.set_maskSkin(value); } });Object.defineProperty(feathers.controls.LayoutGroup.prototype, "autoSizeMode", { get: function() { return this.get_autoSizeMode() }, set: function(value) { return this.set_autoSizeMode(value); } });Object.defineProperty(feathers.controls.LayoutGroup.prototype, "_numChildren", { get: function() { return this.get__numChildren() }, set: function(value) { return this.set__numChildren(value); } });Object.defineProperty(feathers.controls.LayoutGroup.prototype, "xmlContent", { get: function() { return this.get_xmlContent() }, set: function(value) { return this.set_xmlContent(value); } });Object.defineProperty(feathers.controls.PopUpListView.prototype, "stageFocusTarget", { get: function() { return this.get_stageFocusTarget() }, set: function(value) { return this.set_stageFocusTarget(value); } });Object.defineProperty(feathers.controls.PopUpListView.prototype, "dataProvider", { get: function() { return this.get_dataProvider() }, set: function(value) { return this.set_dataProvider(value); } });Object.defineProperty(feathers.controls.PopUpListView.prototype, "selectedIndex", { get: function() { return this.get_selectedIndex() }, set: function(value) { return this.set_selectedIndex(value); } });Object.defineProperty(feathers.controls.PopUpListView.prototype, "maxSelectedIndex", { get: function() { return this.get_maxSelectedIndex() }, set: function(value) { return this.set_maxSelectedIndex(value); } });Object.defineProperty(feathers.controls.PopUpListView.prototype, "selectedItem", { get: function() { return this.get_selectedItem() }, set: function(value) { return this.set_selectedItem(value); } });Object.defineProperty(feathers.controls.PopUpListView.prototype, "prompt", { get: function() { return this.get_prompt() }, set: function(value) { return this.set_prompt(value); } });Object.defineProperty(feathers.controls.PopUpListView.prototype, "itemRendererRecycler", { get: function() { return this.get_itemRendererRecycler() }, set: function(value) { return this.set_itemRendererRecycler(value); } });Object.defineProperty(feathers.controls.PopUpListView.prototype, "popUpAdapter", { get: function() { return this.get_popUpAdapter() }, set: function(value) { return this.set_popUpAdapter(value); } });Object.defineProperty(feathers.controls.PopUpListView.prototype, "customButtonVariant", { get: function() { return this.get_customButtonVariant() }, set: function(value) { return this.set_customButtonVariant(value); } });Object.defineProperty(feathers.controls.PopUpListView.prototype, "customListViewVariant", { get: function() { return this.get_customListViewVariant() }, set: function(value) { return this.set_customListViewVariant(value); } });Object.defineProperty(feathers.controls.PopUpListView.prototype, "buttonFactory", { get: function() { return this.get_buttonFactory() }, set: function(value) { return this.set_buttonFactory(value); } });Object.defineProperty(feathers.controls.PopUpListView.prototype, "listViewFactory", { get: function() { return this.get_listViewFactory() }, set: function(value) { return this.set_listViewFactory(value); } });Object.defineProperty(feathers.controls.PopUpListView.prototype, "open", { get: function() { return this.get_open() }, set: function(value) { return this.set_open(value); } });Object.defineProperty(feathers.controls.TreeGridView.prototype, "childFocusEnabled", { get: function() { return this.get_childFocusEnabled() }, set: function(value) { return this.set_childFocusEnabled(value); } });Object.defineProperty(feathers.controls.TreeGridView.prototype, "dataProvider", { get: function() { return this.get_dataProvider() }, set: function(value) { return this.set_dataProvider(value); } });Object.defineProperty(feathers.controls.TreeGridView.prototype, "columns", { get: function() { return this.get_columns() }, set: function(value) { return this.set_columns(value); } });Object.defineProperty(feathers.controls.TreeGridView.prototype, "headerRendererRecycler", { get: function() { return this.get_headerRendererRecycler() }, set: function(value) { return this.set_headerRendererRecycler(value); } });Object.defineProperty(feathers.controls.TreeGridView.prototype, "customCellRendererVariant", { get: function() { return this.get_customCellRendererVariant() }, set: function(value) { return this.set_customCellRendererVariant(value); } });Object.defineProperty(feathers.controls.TreeGridView.prototype, "customHeaderRendererVariant", { get: function() { return this.get_customHeaderRendererVariant() }, set: function(value) { return this.set_customHeaderRendererVariant(value); } });Object.defineProperty(feathers.controls.TreeGridView.prototype, "headerDividerFactory", { get: function() { return this.get_headerDividerFactory() }, set: function(value) { return this.set_headerDividerFactory(value); } });Object.defineProperty(feathers.controls.TreeGridView.prototype, "customHeaderDividerVariant", { get: function() { return this.get_customHeaderDividerVariant() }, set: function(value) { return this.set_customHeaderDividerVariant(value); } });Object.defineProperty(feathers.controls.TreeGridView.prototype, "columnDividerFactory", { get: function() { return this.get_columnDividerFactory() }, set: function(value) { return this.set_columnDividerFactory(value); } });Object.defineProperty(feathers.controls.TreeGridView.prototype, "customColumnDividerVariant", { get: function() { return this.get_customColumnDividerVariant() }, set: function(value) { return this.set_customColumnDividerVariant(value); } });Object.defineProperty(feathers.controls.TreeGridView.prototype, "forceItemStateUpdate", { get: function() { return this.get_forceItemStateUpdate() }, set: function(value) { return this.set_forceItemStateUpdate(value); } });Object.defineProperty(feathers.controls.TreeGridView.prototype, "selectedLocation", { get: function() { return this.get_selectedLocation() }, set: function(value) { return this.set_selectedLocation(value); } });Object.defineProperty(feathers.controls.TreeGridView.prototype, "selectedItem", { get: function() { return this.get_selectedItem() }, set: function(value) { return this.set_selectedItem(value); } });Object.defineProperty(feathers.controls.TreeGridView.prototype, "layout", { get: function() { return this.get_layout() }, set: function(value) { return this.set_layout(value); } });Object.defineProperty(feathers.controls.TreeGridView.prototype, "virtualLayout", { get: function() { return this.get_virtualLayout() }, set: function(value) { return this.set_virtualLayout(value); } });Object.defineProperty(feathers.controls.TreeGridView.prototype, "cellRendererRecycler", { get: function() { return this.get_cellRendererRecycler() }, set: function(value) { return this.set_cellRendererRecycler(value); } });Object.defineProperty(feathers.controls.TreeGridView.prototype, "resizableColumns", { get: function() { return this.get_resizableColumns() }, set: function(value) { return this.set_resizableColumns(value); } });Object.defineProperty(feathers.controls.TreeGridView.prototype, "columnResizeSkin", { get: function() { return this.get_columnResizeSkin() }, set: function(value) { return this.set_columnResizeSkin(value); } });Object.defineProperty(feathers.controls.TreeGridView.prototype, "selectable", { get: function() { return this.get_selectable() }, set: function(value) { return this.set_selectable(value); } });Object.defineProperty(feathers.controls.TreeGridView.prototype, "extendedScrollBarY", { get: function() { return this.get_extendedScrollBarY() }, set: function(value) { return this.set_extendedScrollBarY(value); } });Object.defineProperty(feathers.controls.TreeGridView.prototype, "showHeaderDividersOnlyWhenResizable", { get: function() { return this.get_showHeaderDividersOnlyWhenResizable() }, set: function(value) { return this.set_showHeaderDividersOnlyWhenResizable(value); } });Object.defineProperty(feathers.controls.AssetLoader.prototype, "source", { get: function() { return this.get_source() }, set: function(value) { return this.set_source(value); } });Object.defineProperty(feathers.controls.AssetLoader.prototype, "originalSourceWidth", { get: function() { return this.get_originalSourceWidth() }, set: function(value) { return this.set_originalSourceWidth(value); } });Object.defineProperty(feathers.controls.AssetLoader.prototype, "originalSourceHeight", { get: function() { return this.get_originalSourceHeight() }, set: function(value) { return this.set_originalSourceHeight(value); } });Object.defineProperty(feathers.controls.AssetLoader.prototype, "scaleMode", { get: function() { return this.get_scaleMode() }, set: function(value) { return this.set_scaleMode(value); } });Object.defineProperty(feathers.core.IHTMLTextControl.prototype, "htmlText", { get: function() { return this.get_htmlText() }, set: function(value) { return this.set_htmlText(value); } });Object.defineProperty(feathers.core.IToolTipManager.prototype, "root", { get: function() { return this.get_root() }, set: function(value) { return this.set_root(value); } });Object.defineProperty(feathers.data.ArrayCollection.prototype, "array", { get: function() { return this.get_array() }, set: function(value) { return this.set_array(value); } });Object.defineProperty(feathers.data.ArrayCollection.prototype, "length", { get: function() { return this.get_length() }, set: function(value) { return this.set_length(value); } });Object.defineProperty(feathers.data.ArrayCollection.prototype, "filterFunction", { get: function() { return this.get_filterFunction() }, set: function(value) { return this.set_filterFunction(value); } });Object.defineProperty(feathers.data.ArrayCollection.prototype, "sortCompareFunction", { get: function() { return this.get_sortCompareFunction() }, set: function(value) { return this.set_sortCompareFunction(value); } });Object.defineProperty(feathers.core.IDataSelector.prototype, "selectedItem", { get: function() { return this.get_selectedItem() }, set: function(value) { return this.set_selectedItem(value); } });Object.defineProperty(feathers.controls.popups.CalloutPopUpAdapter.prototype, "active", { get: function() { return this.get_active() }, set: function(value) { return this.set_active(value); } });Object.defineProperty(feathers.controls.popups.CalloutPopUpAdapter.prototype, "fitContentToOriginWidth", { get: function() { return this.get_fitContentToOriginWidth() }, set: function(value) { return this.set_fitContentToOriginWidth(value); } });Object.defineProperty(feathers.controls.popups.CalloutPopUpAdapter.prototype, "persistent", { get: function() { return this.get_persistent() }, set: function(value) { return this.set_persistent(value); } });Object.defineProperty(feathers.motion.effects.BaseDelegateEffectContext.prototype, "context", { get: function() { return this.get_context() }, set: function(value) { return this.set_context(value); } });Object.defineProperty(feathers.motion.effects.BaseDelegateEffectContext.prototype, "target", { get: function() { return this.get_target() }, set: function(value) { return this.set_target(value); } });Object.defineProperty(feathers.motion.effects.BaseDelegateEffectContext.prototype, "duration", { get: function() { return this.get_duration() }, set: function(value) { return this.set_duration(value); } });Object.defineProperty(feathers.motion.effects.BaseDelegateEffectContext.prototype, "position", { get: function() { return this.get_position() }, set: function(value) { return this.set_position(value); } });Object.defineProperty(feathers.controls.GroupListView.prototype, "childFocusEnabled", { get: function() { return this.get_childFocusEnabled() }, set: function(value) { return this.set_childFocusEnabled(value); } });Object.defineProperty(feathers.controls.GroupListView.prototype, "dataProvider", { get: function() { return this.get_dataProvider() }, set: function(value) { return this.set_dataProvider(value); } });Object.defineProperty(feathers.controls.GroupListView.prototype, "selectedLocation", { get: function() { return this.get_selectedLocation() }, set: function(value) { return this.set_selectedLocation(value); } });Object.defineProperty(feathers.controls.GroupListView.prototype, "selectedItem", { get: function() { return this.get_selectedItem() }, set: function(value) { return this.set_selectedItem(value); } });Object.defineProperty(feathers.controls.GroupListView.prototype, "layout", { get: function() { return this.get_layout() }, set: function(value) { return this.set_layout(value); } });Object.defineProperty(feathers.controls.GroupListView.prototype, "customHeaderRendererVariant", { get: function() { return this.get_customHeaderRendererVariant() }, set: function(value) { return this.set_customHeaderRendererVariant(value); } });Object.defineProperty(feathers.controls.GroupListView.prototype, "customItemRendererVariant", { get: function() { return this.get_customItemRendererVariant() }, set: function(value) { return this.set_customItemRendererVariant(value); } });Object.defineProperty(feathers.controls.GroupListView.prototype, "forceItemStateUpdate", { get: function() { return this.get_forceItemStateUpdate() }, set: function(value) { return this.set_forceItemStateUpdate(value); } });Object.defineProperty(feathers.controls.GroupListView.prototype, "itemRendererRecycler", { get: function() { return this.get_itemRendererRecycler() }, set: function(value) { return this.set_itemRendererRecycler(value); } });Object.defineProperty(feathers.controls.GroupListView.prototype, "headerRendererRecycler", { get: function() { return this.get_headerRendererRecycler() }, set: function(value) { return this.set_headerRendererRecycler(value); } });Object.defineProperty(feathers.controls.GroupListView.prototype, "itemRendererRecyclerIDFunction", { get: function() { return this.get_itemRendererRecyclerIDFunction() }, set: function(value) { return this.set_itemRendererRecyclerIDFunction(value); } });Object.defineProperty(feathers.controls.GroupListView.prototype, "headerRendererRecyclerIDFunction", { get: function() { return this.get_headerRendererRecyclerIDFunction() }, set: function(value) { return this.set_headerRendererRecyclerIDFunction(value); } });Object.defineProperty(feathers.controls.GroupListView.prototype, "selectable", { get: function() { return this.get_selectable() }, set: function(value) { return this.set_selectable(value); } });Object.defineProperty(feathers.controls.GroupListView.prototype, "virtualLayout", { get: function() { return this.get_virtualLayout() }, set: function(value) { return this.set_virtualLayout(value); } });Object.defineProperty(feathers.layout.FormLayout.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.layout.FormLayout.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.layout.FormLayout.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.layout.FormLayout.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.layout.FormLayout.prototype, "gap", { get: function() { return this.get_gap() }, set: function(value) { return this.set_gap(value); } });Object.defineProperty(feathers.layout.FormLayout.prototype, "verticalAlign", { get: function() { return this.get_verticalAlign() }, set: function(value) { return this.set_verticalAlign(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayout.prototype, "columnCount", { get: function() { return this.get_columnCount() }, set: function(value) { return this.set_columnCount(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayout.prototype, "sm", { get: function() { return this.get_sm() }, set: function(value) { return this.set_sm(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayout.prototype, "md", { get: function() { return this.get_md() }, set: function(value) { return this.set_md(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayout.prototype, "lg", { get: function() { return this.get_lg() }, set: function(value) { return this.set_lg(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayout.prototype, "xl", { get: function() { return this.get_xl() }, set: function(value) { return this.set_xl(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayout.prototype, "xxl", { get: function() { return this.get_xxl() }, set: function(value) { return this.set_xxl(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayout.prototype, "rowGap", { get: function() { return this.get_rowGap() }, set: function(value) { return this.set_rowGap(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayout.prototype, "columnGap", { get: function() { return this.get_columnGap() }, set: function(value) { return this.set_columnGap(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayout.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayout.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayout.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayout.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayout.prototype, "rowVerticalAlign", { get: function() { return this.get_rowVerticalAlign() }, set: function(value) { return this.set_rowVerticalAlign(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayout.prototype, "justifyResetEnabled", { get: function() { return this.get_justifyResetEnabled() }, set: function(value) { return this.set_justifyResetEnabled(value); } });Object.defineProperty(feathers.motion.effects.EventToPositionEffectContext.prototype, "dispatcher", { get: function() { return this.get_dispatcher() }, set: function(value) { return this.set_dispatcher(value); } });Object.defineProperty(feathers.motion.effects.EventToPositionEffectContext.prototype, "eventType", { get: function() { return this.get_eventType() }, set: function(value) { return this.set_eventType(value); } });Object.defineProperty(feathers.motion.effects.EventToPositionEffectContext.prototype, "callback", { get: function() { return this.get_callback() }, set: function(value) { return this.set_callback(value); } });Object.defineProperty(feathers.controls.dataRenderers.ItemRenderer.prototype, "data", { get: function() { return this.get_data() }, set: function(value) { return this.set_data(value); } });Object.defineProperty(feathers.controls.dataRenderers.ItemRenderer.prototype, "secondaryText", { get: function() { return this.get_secondaryText() }, set: function(value) { return this.set_secondaryText(value); } });Object.defineProperty(feathers.controls.dataRenderers.ItemRenderer.prototype, "secondaryHtmlText", { get: function() { return this.get_secondaryHtmlText() }, set: function(value) { return this.set_secondaryHtmlText(value); } });Object.defineProperty(feathers.controls.dataRenderers.ItemRenderer.prototype, "childFocusEnabled", { get: function() { return this.get_childFocusEnabled() }, set: function(value) { return this.set_childFocusEnabled(value); } });Object.defineProperty(feathers.controls.dataRenderers.ItemRenderer.prototype, "layoutIndex", { get: function() { return this.get_layoutIndex() }, set: function(value) { return this.set_layoutIndex(value); } });Object.defineProperty(feathers.controls.dataRenderers.ItemRenderer.prototype, "pointerTarget", { get: function() { return this.get_pointerTarget() }, set: function(value) { return this.set_pointerTarget(value); } });Object.defineProperty(feathers.controls.dataRenderers.ItemRenderer.prototype, "secondaryTextFormat", { get: function() { return this.get_secondaryTextFormat() }, set: function(value) { return this.set_secondaryTextFormat(value); } });Object.defineProperty(feathers.controls.dataRenderers.ItemRenderer.prototype, "disabledSecondaryTextFormat", { get: function() { return this.get_disabledSecondaryTextFormat() }, set: function(value) { return this.set_disabledSecondaryTextFormat(value); } });Object.defineProperty(feathers.controls.dataRenderers.ItemRenderer.prototype, "selectedSecondaryTextFormat", { get: function() { return this.get_selectedSecondaryTextFormat() }, set: function(value) { return this.set_selectedSecondaryTextFormat(value); } });Object.defineProperty(feathers.controls.dataRenderers.ItemRenderer.prototype, "alternateBackgroundSkin", { get: function() { return this.get_alternateBackgroundSkin() }, set: function(value) { return this.set_alternateBackgroundSkin(value); } });Object.defineProperty(feathers.controls.dataRenderers.ItemRenderer.prototype, "showSecondaryText", { get: function() { return this.get_showSecondaryText() }, set: function(value) { return this.set_showSecondaryText(value); } });Object.defineProperty(feathers.controls.dataRenderers.ItemRenderer.prototype, "accessoryView", { get: function() { return this.get_accessoryView() }, set: function(value) { return this.set_accessoryView(value); } });Object.defineProperty(feathers.themes.steel.BaseSteelTheme.prototype, "darkMode", { get: function() { return this.get_darkMode() }, set: function(value) { return this.set_darkMode(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollBar.prototype, "value", { get: function() { return this.get_value() }, set: function(value) { return this.set_value(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollBar.prototype, "minimum", { get: function() { return this.get_minimum() }, set: function(value) { return this.set_minimum(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollBar.prototype, "maximum", { get: function() { return this.get_maximum() }, set: function(value) { return this.set_maximum(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollBar.prototype, "step", { get: function() { return this.get_step() }, set: function(value) { return this.set_step(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollBar.prototype, "snapInterval", { get: function() { return this.get_snapInterval() }, set: function(value) { return this.set_snapInterval(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollBar.prototype, "page", { get: function() { return this.get_page() }, set: function(value) { return this.set_page(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollBar.prototype, "thumbSkin", { get: function() { return this.get_thumbSkin() }, set: function(value) { return this.set_thumbSkin(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollBar.prototype, "trackSkin", { get: function() { return this.get_trackSkin() }, set: function(value) { return this.set_trackSkin(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollBar.prototype, "secondaryTrackSkin", { get: function() { return this.get_secondaryTrackSkin() }, set: function(value) { return this.set_secondaryTrackSkin(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollBar.prototype, "fixedThumbSize", { get: function() { return this.get_fixedThumbSize() }, set: function(value) { return this.set_fixedThumbSize(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollBar.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollBar.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollBar.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollBar.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseScrollBar.prototype, "hideThumbWhenDisabled", { get: function() { return this.get_hideThumbWhenDisabled() }, set: function(value) { return this.set_hideThumbWhenDisabled(value); } });Object.defineProperty(feathers.core.IPopUpManager.prototype, "overlayFactory", { get: function() { return this.get_overlayFactory() }, set: function(value) { return this.set_overlayFactory(value); } });Object.defineProperty(feathers.core.IPopUpManager.prototype, "root", { get: function() { return this.get_root() }, set: function(value) { return this.set_root(value); } });Object.defineProperty(feathers.core.IPopUpManager.prototype, "popUpCount", { get: function() { return this.get_popUpCount() }, set: function(value) { return this.set_popUpCount(value); } });Object.defineProperty(feathers.core.IPopUpManager.prototype, "topLevelPopUpCount", { get: function() { return this.get_topLevelPopUpCount() }, set: function(value) { return this.set_topLevelPopUpCount(value); } });Object.defineProperty(feathers.controls.navigators.StackNavigator.prototype, "pushTransition", { get: function() { return this.get_pushTransition() }, set: function(value) { return this.set_pushTransition(value); } });Object.defineProperty(feathers.controls.navigators.StackNavigator.prototype, "popTransition", { get: function() { return this.get_popTransition() }, set: function(value) { return this.set_popTransition(value); } });Object.defineProperty(feathers.controls.navigators.StackNavigator.prototype, "replaceTransition", { get: function() { return this.get_replaceTransition() }, set: function(value) { return this.set_replaceTransition(value); } });Object.defineProperty(feathers.controls.navigators.StackNavigator.prototype, "stackSize", { get: function() { return this.get_stackSize() }, set: function(value) { return this.set_stackSize(value); } });Object.defineProperty(feathers.controls.navigators.StackNavigator.prototype, "rootItemID", { get: function() { return this.get_rootItemID() }, set: function(value) { return this.set_rootItemID(value); } });Object.defineProperty(feathers.controls.navigators.StackNavigator.prototype, "popSwipeEnabled", { get: function() { return this.get_popSwipeEnabled() }, set: function(value) { return this.set_popSwipeEnabled(value); } });Object.defineProperty(feathers.controls.navigators.StackNavigator.prototype, "simulateTouch", { get: function() { return this.get_simulateTouch() }, set: function(value) { return this.set_simulateTouch(value); } });Object.defineProperty(feathers.controls.navigators.StackNavigator.prototype, "popSwipeActiveEdgeSize", { get: function() { return this.get_popSwipeActiveEdgeSize() }, set: function(value) { return this.set_popSwipeActiveEdgeSize(value); } });Object.defineProperty(feathers.controls.Panel.prototype, "header", { get: function() { return this.get_header() }, set: function(value) { return this.set_header(value); } });Object.defineProperty(feathers.controls.Panel.prototype, "footer", { get: function() { return this.get_footer() }, set: function(value) { return this.set_footer(value); } });Object.defineProperty(feathers.controls.Panel.prototype, "focusExtrasBefore", { get: function() { return this.get_focusExtrasBefore() }, set: function(value) { return this.set_focusExtrasBefore(value); } });Object.defineProperty(feathers.controls.Panel.prototype, "focusExtrasAfter", { get: function() { return this.get_focusExtrasAfter() }, set: function(value) { return this.set_focusExtrasAfter(value); } });Object.defineProperty(feathers.layout.AnchorLayoutData.prototype, "top", { get: function() { return this.get_top() }, set: function(value) { return this.set_top(value); } });Object.defineProperty(feathers.layout.AnchorLayoutData.prototype, "right", { get: function() { return this.get_right() }, set: function(value) { return this.set_right(value); } });Object.defineProperty(feathers.layout.AnchorLayoutData.prototype, "bottom", { get: function() { return this.get_bottom() }, set: function(value) { return this.set_bottom(value); } });Object.defineProperty(feathers.layout.AnchorLayoutData.prototype, "left", { get: function() { return this.get_left() }, set: function(value) { return this.set_left(value); } });Object.defineProperty(feathers.layout.AnchorLayoutData.prototype, "horizontalCenter", { get: function() { return this.get_horizontalCenter() }, set: function(value) { return this.set_horizontalCenter(value); } });Object.defineProperty(feathers.layout.AnchorLayoutData.prototype, "verticalCenter", { get: function() { return this.get_verticalCenter() }, set: function(value) { return this.set_verticalCenter(value); } });Object.defineProperty(feathers.core.IStageFocusDelegate.prototype, "stageFocusTarget", { get: function() { return this.get_stageFocusTarget() }, set: function(value) { return this.set_stageFocusTarget(value); } });Object.defineProperty(feathers.controls.TabBar.prototype, "dataProvider", { get: function() { return this.get_dataProvider() }, set: function(value) { return this.set_dataProvider(value); } });Object.defineProperty(feathers.controls.TabBar.prototype, "selectedIndex", { get: function() { return this.get_selectedIndex() }, set: function(value) { return this.set_selectedIndex(value); } });Object.defineProperty(feathers.controls.TabBar.prototype, "maxSelectedIndex", { get: function() { return this.get_maxSelectedIndex() }, set: function(value) { return this.set_maxSelectedIndex(value); } });Object.defineProperty(feathers.controls.TabBar.prototype, "selectedItem", { get: function() { return this.get_selectedItem() }, set: function(value) { return this.set_selectedItem(value); } });Object.defineProperty(feathers.controls.TabBar.prototype, "customTabVariant", { get: function() { return this.get_customTabVariant() }, set: function(value) { return this.set_customTabVariant(value); } });Object.defineProperty(feathers.controls.TabBar.prototype, "tabRecycler", { get: function() { return this.get_tabRecycler() }, set: function(value) { return this.set_tabRecycler(value); } });Object.defineProperty(feathers.controls.TabBar.prototype, "forceItemStateUpdate", { get: function() { return this.get_forceItemStateUpdate() }, set: function(value) { return this.set_forceItemStateUpdate(value); } });Object.defineProperty(feathers.controls.TabBar.prototype, "tabRecyclerIDFunction", { get: function() { return this.get_tabRecyclerIDFunction() }, set: function(value) { return this.set_tabRecyclerIDFunction(value); } });Object.defineProperty(feathers.controls.TabBar.prototype, "layout", { get: function() { return this.get_layout() }, set: function(value) { return this.set_layout(value); } });Object.defineProperty(feathers.controls.TabBar.prototype, "backgroundSkin", { get: function() { return this.get_backgroundSkin() }, set: function(value) { return this.set_backgroundSkin(value); } });Object.defineProperty(feathers.controls.TabBar.prototype, "disabledBackgroundSkin", { get: function() { return this.get_disabledBackgroundSkin() }, set: function(value) { return this.set_disabledBackgroundSkin(value); } });Object.defineProperty(feathers.controls.Application.prototype, "scaleFactor", { get: function() { return this.get_scaleFactor() }, set: function(value) { return this.set_scaleFactor(value); } });Object.defineProperty(feathers.controls.Application.prototype, "scaleManager", { get: function() { return this.get_scaleManager() }, set: function(value) { return this.set_scaleManager(value); } });Object.defineProperty(feathers.utils.PointerTrigger.prototype, "target", { get: function() { return this.get_target() }, set: function(value) { return this.set_target(value); } });Object.defineProperty(feathers.utils.PointerTrigger.prototype, "eventFactory", { get: function() { return this.get_eventFactory() }, set: function(value) { return this.set_eventFactory(value); } });Object.defineProperty(feathers.utils.PointerTrigger.prototype, "enabled", { get: function() { return this.get_enabled() }, set: function(value) { return this.set_enabled(value); } });Object.defineProperty(feathers.utils.PointerTrigger.prototype, "customHitTest", { get: function() { return this.get_customHitTest() }, set: function(value) { return this.set_customHitTest(value); } });Object.defineProperty(feathers.controls.supportClasses.AdvancedLayoutViewPort.prototype, "minVisibleWidth", { get: function() { return this.get_minVisibleWidth() }, set: function(value) { return this.set_minVisibleWidth(value); } });Object.defineProperty(feathers.controls.supportClasses.AdvancedLayoutViewPort.prototype, "maxVisibleWidth", { get: function() { return this.get_maxVisibleWidth() }, set: function(value) { return this.set_maxVisibleWidth(value); } });Object.defineProperty(feathers.controls.supportClasses.AdvancedLayoutViewPort.prototype, "visibleWidth", { get: function() { return this.get_visibleWidth() }, set: function(value) { return this.set_visibleWidth(value); } });Object.defineProperty(feathers.controls.supportClasses.AdvancedLayoutViewPort.prototype, "minVisibleHeight", { get: function() { return this.get_minVisibleHeight() }, set: function(value) { return this.set_minVisibleHeight(value); } });Object.defineProperty(feathers.controls.supportClasses.AdvancedLayoutViewPort.prototype, "maxVisibleHeight", { get: function() { return this.get_maxVisibleHeight() }, set: function(value) { return this.set_maxVisibleHeight(value); } });Object.defineProperty(feathers.controls.supportClasses.AdvancedLayoutViewPort.prototype, "visibleHeight", { get: function() { return this.get_visibleHeight() }, set: function(value) { return this.set_visibleHeight(value); } });Object.defineProperty(feathers.controls.supportClasses.AdvancedLayoutViewPort.prototype, "layout", { get: function() { return this.get_layout() }, set: function(value) { return this.set_layout(value); } });Object.defineProperty(feathers.controls.supportClasses.AdvancedLayoutViewPort.prototype, "scrollX", { get: function() { return this.get_scrollX() }, set: function(value) { return this.set_scrollX(value); } });Object.defineProperty(feathers.controls.supportClasses.AdvancedLayoutViewPort.prototype, "scrollY", { get: function() { return this.get_scrollY() }, set: function(value) { return this.set_scrollY(value); } });Object.defineProperty(feathers.controls.supportClasses.AdvancedLayoutViewPort.prototype, "snapPositionsX", { get: function() { return this.get_snapPositionsX() }, set: function(value) { return this.set_snapPositionsX(value); } });Object.defineProperty(feathers.controls.supportClasses.AdvancedLayoutViewPort.prototype, "snapPositionsY", { get: function() { return this.get_snapPositionsY() }, set: function(value) { return this.set_snapPositionsY(value); } });Object.defineProperty(feathers.controls.supportClasses.AdvancedLayoutViewPort.prototype, "scroller", { get: function() { return this.get_scroller() }, set: function(value) { return this.set_scroller(value); } });Object.defineProperty(feathers.skins.BaseGraphicsPathSkin.prototype, "fill", { get: function() { return this.get_fill() }, set: function(value) { return this.set_fill(value); } });Object.defineProperty(feathers.skins.BaseGraphicsPathSkin.prototype, "disabledFill", { get: function() { return this.get_disabledFill() }, set: function(value) { return this.set_disabledFill(value); } });Object.defineProperty(feathers.skins.BaseGraphicsPathSkin.prototype, "selectedFill", { get: function() { return this.get_selectedFill() }, set: function(value) { return this.set_selectedFill(value); } });Object.defineProperty(feathers.skins.BaseGraphicsPathSkin.prototype, "border", { get: function() { return this.get_border() }, set: function(value) { return this.set_border(value); } });Object.defineProperty(feathers.skins.BaseGraphicsPathSkin.prototype, "disabledBorder", { get: function() { return this.get_disabledBorder() }, set: function(value) { return this.set_disabledBorder(value); } });Object.defineProperty(feathers.skins.BaseGraphicsPathSkin.prototype, "selectedBorder", { get: function() { return this.get_selectedBorder() }, set: function(value) { return this.set_selectedBorder(value); } });Object.defineProperty(feathers.core.IStateContext.prototype, "currentState", { get: function() { return this.get_currentState() }, set: function(value) { return this.set_currentState(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "text", { get: function() { return this.get_text() }, set: function(value) { return this.set_text(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "htmlText", { get: function() { return this.get_htmlText() }, set: function(value) { return this.set_htmlText(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "baseline", { get: function() { return this.get_baseline() }, set: function(value) { return this.set_baseline(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "content", { get: function() { return this.get_content() }, set: function(value) { return this.set_content(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "selectable", { get: function() { return this.get_selectable() }, set: function(value) { return this.set_selectable(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "selectionBeginIndex", { get: function() { return this.get_selectionBeginIndex() }, set: function(value) { return this.set_selectionBeginIndex(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "selectionEndIndex", { get: function() { return this.get_selectionEndIndex() }, set: function(value) { return this.set_selectionEndIndex(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "required", { get: function() { return this.get_required() }, set: function(value) { return this.set_required(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "requiredSkin", { get: function() { return this.get_requiredSkin() }, set: function(value) { return this.set_requiredSkin(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "textFormat", { get: function() { return this.get_textFormat() }, set: function(value) { return this.set_textFormat(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "disabledTextFormat", { get: function() { return this.get_disabledTextFormat() }, set: function(value) { return this.set_disabledTextFormat(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "embedFonts", { get: function() { return this.get_embedFonts() }, set: function(value) { return this.set_embedFonts(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "gap", { get: function() { return this.get_gap() }, set: function(value) { return this.set_gap(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "horizontalAlign", { get: function() { return this.get_horizontalAlign() }, set: function(value) { return this.set_horizontalAlign(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "verticalAlign", { get: function() { return this.get_verticalAlign() }, set: function(value) { return this.set_verticalAlign(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "wordWrap", { get: function() { return this.get_wordWrap() }, set: function(value) { return this.set_wordWrap(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "customTextColumnWidth", { get: function() { return this.get_customTextColumnWidth() }, set: function(value) { return this.set_customTextColumnWidth(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "backgroundSkin", { get: function() { return this.get_backgroundSkin() }, set: function(value) { return this.set_backgroundSkin(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "disabledBackgroundSkin", { get: function() { return this.get_disabledBackgroundSkin() }, set: function(value) { return this.set_disabledBackgroundSkin(value); } });Object.defineProperty(feathers.controls.FormItem.prototype, "textPosition", { get: function() { return this.get_textPosition() }, set: function(value) { return this.set_textPosition(value); } });Object.defineProperty(feathers.skins.PillSkin.prototype, "capDirection", { get: function() { return this.get_capDirection() }, set: function(value) { return this.set_capDirection(value); } });Object.defineProperty(feathers.text.TextFormat.prototype, "font", { get: function() { return this.get_font() }, set: function(value) { return this.set_font(value); } });Object.defineProperty(feathers.text.TextFormat.prototype, "size", { get: function() { return this.get_size() }, set: function(value) { return this.set_size(value); } });Object.defineProperty(feathers.text.TextFormat.prototype, "color", { get: function() { return this.get_color() }, set: function(value) { return this.set_color(value); } });Object.defineProperty(feathers.text.TextFormat.prototype, "bold", { get: function() { return this.get_bold() }, set: function(value) { return this.set_bold(value); } });Object.defineProperty(feathers.text.TextFormat.prototype, "italic", { get: function() { return this.get_italic() }, set: function(value) { return this.set_italic(value); } });Object.defineProperty(feathers.text.TextFormat.prototype, "underline", { get: function() { return this.get_underline() }, set: function(value) { return this.set_underline(value); } });Object.defineProperty(feathers.text.TextFormat.prototype, "url", { get: function() { return this.get_url() }, set: function(value) { return this.set_url(value); } });Object.defineProperty(feathers.text.TextFormat.prototype, "target", { get: function() { return this.get_target() }, set: function(value) { return this.set_target(value); } });Object.defineProperty(feathers.text.TextFormat.prototype, "align", { get: function() { return this.get_align() }, set: function(value) { return this.set_align(value); } });Object.defineProperty(feathers.text.TextFormat.prototype, "leftMargin", { get: function() { return this.get_leftMargin() }, set: function(value) { return this.set_leftMargin(value); } });Object.defineProperty(feathers.text.TextFormat.prototype, "rightMargin", { get: function() { return this.get_rightMargin() }, set: function(value) { return this.set_rightMargin(value); } });Object.defineProperty(feathers.text.TextFormat.prototype, "indent", { get: function() { return this.get_indent() }, set: function(value) { return this.set_indent(value); } });Object.defineProperty(feathers.text.TextFormat.prototype, "leading", { get: function() { return this.get_leading() }, set: function(value) { return this.set_leading(value); } });Object.defineProperty(feathers.text.TextFormat.prototype, "blockIndent", { get: function() { return this.get_blockIndent() }, set: function(value) { return this.set_blockIndent(value); } });Object.defineProperty(feathers.text.TextFormat.prototype, "bullet", { get: function() { return this.get_bullet() }, set: function(value) { return this.set_bullet(value); } });Object.defineProperty(feathers.text.TextFormat.prototype, "kerning", { get: function() { return this.get_kerning() }, set: function(value) { return this.set_kerning(value); } });Object.defineProperty(feathers.text.TextFormat.prototype, "letterSpacing", { get: function() { return this.get_letterSpacing() }, set: function(value) { return this.set_letterSpacing(value); } });Object.defineProperty(feathers.text.TextFormat.prototype, "tabStops", { get: function() { return this.get_tabStops() }, set: function(value) { return this.set_tabStops(value); } });Object.defineProperty(feathers.controls.ToggleSwitch.prototype, "selected", { get: function() { return this.get_selected() }, set: function(value) { return this.set_selected(value); } });Object.defineProperty(feathers.controls.ToggleSwitch.prototype, "thumbSkin", { get: function() { return this.get_thumbSkin() }, set: function(value) { return this.set_thumbSkin(value); } });Object.defineProperty(feathers.controls.ToggleSwitch.prototype, "trackSkin", { get: function() { return this.get_trackSkin() }, set: function(value) { return this.set_trackSkin(value); } });Object.defineProperty(feathers.controls.ToggleSwitch.prototype, "secondaryTrackSkin", { get: function() { return this.get_secondaryTrackSkin() }, set: function(value) { return this.set_secondaryTrackSkin(value); } });Object.defineProperty(feathers.controls.ToggleSwitch.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.controls.ToggleSwitch.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.controls.ToggleSwitch.prototype, "toggleDuration", { get: function() { return this.get_toggleDuration() }, set: function(value) { return this.set_toggleDuration(value); } });Object.defineProperty(feathers.controls.ToggleSwitch.prototype, "toggleEase", { get: function() { return this.get_toggleEase() }, set: function(value) { return this.set_toggleEase(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "displayedFullYear", { get: function() { return this.get_displayedFullYear() }, set: function(value) { return this.set_displayedFullYear(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "displayedMonth", { get: function() { return this.get_displayedMonth() }, set: function(value) { return this.set_displayedMonth(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "selectable", { get: function() { return this.get_selectable() }, set: function(value) { return this.set_selectable(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "selectedDate", { get: function() { return this.get_selectedDate() }, set: function(value) { return this.set_selectedDate(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "backgroundSkin", { get: function() { return this.get_backgroundSkin() }, set: function(value) { return this.set_backgroundSkin(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "disabledBackgroundSkin", { get: function() { return this.get_disabledBackgroundSkin() }, set: function(value) { return this.set_disabledBackgroundSkin(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "decrementMonthButtonFactory", { get: function() { return this.get_decrementMonthButtonFactory() }, set: function(value) { return this.set_decrementMonthButtonFactory(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "customDecrementMonthButtonVariant", { get: function() { return this.get_customDecrementMonthButtonVariant() }, set: function(value) { return this.set_customDecrementMonthButtonVariant(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "incrementMonthButtonFactory", { get: function() { return this.get_incrementMonthButtonFactory() }, set: function(value) { return this.set_incrementMonthButtonFactory(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "customIncrementMonthButtonVariant", { get: function() { return this.get_customIncrementMonthButtonVariant() }, set: function(value) { return this.set_customIncrementMonthButtonVariant(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "decrementYearButtonFactory", { get: function() { return this.get_decrementYearButtonFactory() }, set: function(value) { return this.set_decrementYearButtonFactory(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "customDecrementYearButtonVariant", { get: function() { return this.get_customDecrementYearButtonVariant() }, set: function(value) { return this.set_customDecrementYearButtonVariant(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "incrementYearButtonFactory", { get: function() { return this.get_incrementYearButtonFactory() }, set: function(value) { return this.set_incrementYearButtonFactory(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "customIncrementYearButtonVariant", { get: function() { return this.get_customIncrementYearButtonVariant() }, set: function(value) { return this.set_customIncrementYearButtonVariant(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "monthTitleViewFactory", { get: function() { return this.get_monthTitleViewFactory() }, set: function(value) { return this.set_monthTitleViewFactory(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "customMonthTitleViewVariant", { get: function() { return this.get_customMonthTitleViewVariant() }, set: function(value) { return this.set_customMonthTitleViewVariant(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "headerGap", { get: function() { return this.get_headerGap() }, set: function(value) { return this.set_headerGap(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "monthTitleViewPosition", { get: function() { return this.get_monthTitleViewPosition() }, set: function(value) { return this.set_monthTitleViewPosition(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "showMonthTitleView", { get: function() { return this.get_showMonthTitleView() }, set: function(value) { return this.set_showMonthTitleView(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "showMonthButtons", { get: function() { return this.get_showMonthButtons() }, set: function(value) { return this.set_showMonthButtons(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "showYearButtons", { get: function() { return this.get_showYearButtons() }, set: function(value) { return this.set_showYearButtons(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "showWeekdayLabels", { get: function() { return this.get_showWeekdayLabels() }, set: function(value) { return this.set_showWeekdayLabels(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "requestedLocaleIDName", { get: function() { return this.get_requestedLocaleIDName() }, set: function(value) { return this.set_requestedLocaleIDName(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "actualLocaleIDName", { get: function() { return this.get_actualLocaleIDName() }, set: function(value) { return this.set_actualLocaleIDName(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "customMonthNames", { get: function() { return this.get_customMonthNames() }, set: function(value) { return this.set_customMonthNames(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "customWeekdayNames", { get: function() { return this.get_customWeekdayNames() }, set: function(value) { return this.set_customWeekdayNames(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "customStartOfWeek", { get: function() { return this.get_customStartOfWeek() }, set: function(value) { return this.set_customStartOfWeek(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "weekdayLabelFactory", { get: function() { return this.get_weekdayLabelFactory() }, set: function(value) { return this.set_weekdayLabelFactory(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "customWeekdayLabelVariant", { get: function() { return this.get_customWeekdayLabelVariant() }, set: function(value) { return this.set_customWeekdayLabelVariant(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "customDateRendererVariant", { get: function() { return this.get_customDateRendererVariant() }, set: function(value) { return this.set_customDateRendererVariant(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "customMutedDateRendererVariant", { get: function() { return this.get_customMutedDateRendererVariant() }, set: function(value) { return this.set_customMutedDateRendererVariant(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "dateRendererRecycler", { get: function() { return this.get_dateRendererRecycler() }, set: function(value) { return this.set_dateRendererRecycler(value); } });Object.defineProperty(feathers.controls.DatePicker.prototype, "showDatesFromAdjacentMonths", { get: function() { return this.get_showDatesFromAdjacentMonths() }, set: function(value) { return this.set_showDatesFromAdjacentMonths(value); } });Object.defineProperty(feathers.controls.dataRenderers.ITreeGridViewCellRenderer.prototype, "column", { get: function() { return this.get_column() }, set: function(value) { return this.set_column(value); } });Object.defineProperty(feathers.controls.dataRenderers.ITreeGridViewCellRenderer.prototype, "columnIndex", { get: function() { return this.get_columnIndex() }, set: function(value) { return this.set_columnIndex(value); } });Object.defineProperty(feathers.controls.dataRenderers.ITreeGridViewCellRenderer.prototype, "rowLocation", { get: function() { return this.get_rowLocation() }, set: function(value) { return this.set_rowLocation(value); } });Object.defineProperty(feathers.controls.dataRenderers.ITreeGridViewCellRenderer.prototype, "treeGridViewOwner", { get: function() { return this.get_treeGridViewOwner() }, set: function(value) { return this.set_treeGridViewOwner(value); } });Object.defineProperty(feathers.layout.HorizontalLayoutData.prototype, "percentWidth", { get: function() { return this.get_percentWidth() }, set: function(value) { return this.set_percentWidth(value); } });Object.defineProperty(feathers.layout.HorizontalLayoutData.prototype, "percentHeight", { get: function() { return this.get_percentHeight() }, set: function(value) { return this.set_percentHeight(value); } });Object.defineProperty(feathers.layout.HorizontalLayoutData.prototype, "marginLeft", { get: function() { return this.get_marginLeft() }, set: function(value) { return this.set_marginLeft(value); } });Object.defineProperty(feathers.layout.HorizontalLayoutData.prototype, "marginRight", { get: function() { return this.get_marginRight() }, set: function(value) { return this.set_marginRight(value); } });Object.defineProperty(feathers.core.ValidatingSprite.prototype, "validating", { get: function() { return this.get_validating() }, set: function(value) { return this.set_validating(value); } });Object.defineProperty(feathers.core.ValidatingSprite.prototype, "depth", { get: function() { return this.get_depth() }, set: function(value) { return this.set_depth(value); } });Object.defineProperty(feathers.controls.ListView.prototype, "childFocusEnabled", { get: function() { return this.get_childFocusEnabled() }, set: function(value) { return this.set_childFocusEnabled(value); } });Object.defineProperty(feathers.controls.ListView.prototype, "dataProvider", { get: function() { return this.get_dataProvider() }, set: function(value) { return this.set_dataProvider(value); } });Object.defineProperty(feathers.controls.ListView.prototype, "selectedIndex", { get: function() { return this.get_selectedIndex() }, set: function(value) { return this.set_selectedIndex(value); } });Object.defineProperty(feathers.controls.ListView.prototype, "maxSelectedIndex", { get: function() { return this.get_maxSelectedIndex() }, set: function(value) { return this.set_maxSelectedIndex(value); } });Object.defineProperty(feathers.controls.ListView.prototype, "selectedItem", { get: function() { return this.get_selectedItem() }, set: function(value) { return this.set_selectedItem(value); } });Object.defineProperty(feathers.controls.ListView.prototype, "allowMultipleSelection", { get: function() { return this.get_allowMultipleSelection() }, set: function(value) { return this.set_allowMultipleSelection(value); } });Object.defineProperty(feathers.controls.ListView.prototype, "selectedIndices", { get: function() { return this.get_selectedIndices() }, set: function(value) { return this.set_selectedIndices(value); } });Object.defineProperty(feathers.controls.ListView.prototype, "selectedItems", { get: function() { return this.get_selectedItems() }, set: function(value) { return this.set_selectedItems(value); } });Object.defineProperty(feathers.controls.ListView.prototype, "layout", { get: function() { return this.get_layout() }, set: function(value) { return this.set_layout(value); } });Object.defineProperty(feathers.controls.ListView.prototype, "customItemRendererVariant", { get: function() { return this.get_customItemRendererVariant() }, set: function(value) { return this.set_customItemRendererVariant(value); } });Object.defineProperty(feathers.controls.ListView.prototype, "itemRendererRecycler", { get: function() { return this.get_itemRendererRecycler() }, set: function(value) { return this.set_itemRendererRecycler(value); } });Object.defineProperty(feathers.controls.ListView.prototype, "forceItemStateUpdate", { get: function() { return this.get_forceItemStateUpdate() }, set: function(value) { return this.set_forceItemStateUpdate(value); } });Object.defineProperty(feathers.controls.ListView.prototype, "itemRendererRecyclerIDFunction", { get: function() { return this.get_itemRendererRecyclerIDFunction() }, set: function(value) { return this.set_itemRendererRecyclerIDFunction(value); } });Object.defineProperty(feathers.controls.ListView.prototype, "selectable", { get: function() { return this.get_selectable() }, set: function(value) { return this.set_selectable(value); } });Object.defineProperty(feathers.controls.ListView.prototype, "virtualLayout", { get: function() { return this.get_virtualLayout() }, set: function(value) { return this.set_virtualLayout(value); } });Object.defineProperty(feathers.layout.VerticalDistributedLayout.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.layout.VerticalDistributedLayout.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.layout.VerticalDistributedLayout.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.layout.VerticalDistributedLayout.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.layout.VerticalDistributedLayout.prototype, "gap", { get: function() { return this.get_gap() }, set: function(value) { return this.set_gap(value); } });Object.defineProperty(feathers.layout.VerticalDistributedLayout.prototype, "maxItemHeight", { get: function() { return this.get_maxItemHeight() }, set: function(value) { return this.set_maxItemHeight(value); } });Object.defineProperty(feathers.layout.VerticalDistributedLayout.prototype, "minItemHeight", { get: function() { return this.get_minItemHeight() }, set: function(value) { return this.set_minItemHeight(value); } });Object.defineProperty(feathers.layout.VerticalDistributedLayout.prototype, "horizontalAlign", { get: function() { return this.get_horizontalAlign() }, set: function(value) { return this.set_horizontalAlign(value); } });Object.defineProperty(feathers.style.IStyleObject.prototype, "themeEnabled", { get: function() { return this.get_themeEnabled() }, set: function(value) { return this.set_themeEnabled(value); } });Object.defineProperty(feathers.layout.AnchorLayout.prototype, "value", { get: function() { return this.get_value() }, set: function(value) { return this.set_value(value); } });Object.defineProperty(feathers.layout.AnchorLayout.prototype, "relativeTo", { get: function() { return this.get_relativeTo() }, set: function(value) { return this.set_relativeTo(value); } });Object.defineProperty(feathers.controls.Form.prototype, "submitButton", { get: function() { return this.get_submitButton() }, set: function(value) { return this.set_submitButton(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayoutData.prototype, "span", { get: function() { return this.get_span() }, set: function(value) { return this.set_span(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayoutData.prototype, "offset", { get: function() { return this.get_offset() }, set: function(value) { return this.set_offset(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayoutData.prototype, "display", { get: function() { return this.get_display() }, set: function(value) { return this.set_display(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayoutData.prototype, "smSpan", { get: function() { return this.get_smSpan() }, set: function(value) { return this.set_smSpan(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayoutData.prototype, "smOffset", { get: function() { return this.get_smOffset() }, set: function(value) { return this.set_smOffset(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayoutData.prototype, "smDisplay", { get: function() { return this.get_smDisplay() }, set: function(value) { return this.set_smDisplay(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayoutData.prototype, "mdSpan", { get: function() { return this.get_mdSpan() }, set: function(value) { return this.set_mdSpan(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayoutData.prototype, "mdOffset", { get: function() { return this.get_mdOffset() }, set: function(value) { return this.set_mdOffset(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayoutData.prototype, "mdDisplay", { get: function() { return this.get_mdDisplay() }, set: function(value) { return this.set_mdDisplay(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayoutData.prototype, "lgSpan", { get: function() { return this.get_lgSpan() }, set: function(value) { return this.set_lgSpan(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayoutData.prototype, "lgOffset", { get: function() { return this.get_lgOffset() }, set: function(value) { return this.set_lgOffset(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayoutData.prototype, "lgDisplay", { get: function() { return this.get_lgDisplay() }, set: function(value) { return this.set_lgDisplay(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayoutData.prototype, "xlSpan", { get: function() { return this.get_xlSpan() }, set: function(value) { return this.set_xlSpan(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayoutData.prototype, "xlOffset", { get: function() { return this.get_xlOffset() }, set: function(value) { return this.set_xlOffset(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayoutData.prototype, "xlDisplay", { get: function() { return this.get_xlDisplay() }, set: function(value) { return this.set_xlDisplay(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayoutData.prototype, "xxlSpan", { get: function() { return this.get_xxlSpan() }, set: function(value) { return this.set_xxlSpan(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayoutData.prototype, "xxlOffset", { get: function() { return this.get_xxlOffset() }, set: function(value) { return this.set_xxlOffset(value); } });Object.defineProperty(feathers.layout.ResponsiveGridLayoutData.prototype, "xxlDisplay", { get: function() { return this.get_xxlDisplay() }, set: function(value) { return this.set_xxlDisplay(value); } });Object.defineProperty(feathers.controls.supportClasses.LayoutViewPort.prototype, "minVisibleWidth", { get: function() { return this.get_minVisibleWidth() }, set: function(value) { return this.set_minVisibleWidth(value); } });Object.defineProperty(feathers.controls.supportClasses.LayoutViewPort.prototype, "maxVisibleWidth", { get: function() { return this.get_maxVisibleWidth() }, set: function(value) { return this.set_maxVisibleWidth(value); } });Object.defineProperty(feathers.controls.supportClasses.LayoutViewPort.prototype, "visibleWidth", { get: function() { return this.get_visibleWidth() }, set: function(value) { return this.set_visibleWidth(value); } });Object.defineProperty(feathers.controls.supportClasses.LayoutViewPort.prototype, "minVisibleHeight", { get: function() { return this.get_minVisibleHeight() }, set: function(value) { return this.set_minVisibleHeight(value); } });Object.defineProperty(feathers.controls.supportClasses.LayoutViewPort.prototype, "maxVisibleHeight", { get: function() { return this.get_maxVisibleHeight() }, set: function(value) { return this.set_maxVisibleHeight(value); } });Object.defineProperty(feathers.controls.supportClasses.LayoutViewPort.prototype, "visibleHeight", { get: function() { return this.get_visibleHeight() }, set: function(value) { return this.set_visibleHeight(value); } });Object.defineProperty(feathers.controls.supportClasses.LayoutViewPort.prototype, "scrollX", { get: function() { return this.get_scrollX() }, set: function(value) { return this.set_scrollX(value); } });Object.defineProperty(feathers.controls.supportClasses.LayoutViewPort.prototype, "scrollY", { get: function() { return this.get_scrollY() }, set: function(value) { return this.set_scrollY(value); } });Object.defineProperty(feathers.controls.supportClasses.LayoutViewPort.prototype, "snapPositionsX", { get: function() { return this.get_snapPositionsX() }, set: function(value) { return this.set_snapPositionsX(value); } });Object.defineProperty(feathers.controls.supportClasses.LayoutViewPort.prototype, "snapPositionsY", { get: function() { return this.get_snapPositionsY() }, set: function(value) { return this.set_snapPositionsY(value); } });Object.defineProperty(feathers.controls.supportClasses.LayoutViewPort.prototype, "manageChildVisibility", { get: function() { return this.get_manageChildVisibility() }, set: function(value) { return this.set_manageChildVisibility(value); } });Object.defineProperty(feathers.motion.effects.IEffectContext.prototype, "target", { get: function() { return this.get_target() }, set: function(value) { return this.set_target(value); } });Object.defineProperty(feathers.motion.effects.IEffectContext.prototype, "duration", { get: function() { return this.get_duration() }, set: function(value) { return this.set_duration(value); } });Object.defineProperty(feathers.motion.effects.IEffectContext.prototype, "position", { get: function() { return this.get_position() }, set: function(value) { return this.set_position(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseSlider.prototype, "value", { get: function() { return this.get_value() }, set: function(value) { return this.set_value(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseSlider.prototype, "minimum", { get: function() { return this.get_minimum() }, set: function(value) { return this.set_minimum(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseSlider.prototype, "maximum", { get: function() { return this.get_maximum() }, set: function(value) { return this.set_maximum(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseSlider.prototype, "step", { get: function() { return this.get_step() }, set: function(value) { return this.set_step(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseSlider.prototype, "snapInterval", { get: function() { return this.get_snapInterval() }, set: function(value) { return this.set_snapInterval(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseSlider.prototype, "thumbSkin", { get: function() { return this.get_thumbSkin() }, set: function(value) { return this.set_thumbSkin(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseSlider.prototype, "trackSkin", { get: function() { return this.get_trackSkin() }, set: function(value) { return this.set_trackSkin(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseSlider.prototype, "secondaryTrackSkin", { get: function() { return this.get_secondaryTrackSkin() }, set: function(value) { return this.set_secondaryTrackSkin(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseSlider.prototype, "minimumPadding", { get: function() { return this.get_minimumPadding() }, set: function(value) { return this.set_minimumPadding(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseSlider.prototype, "maximumPadding", { get: function() { return this.get_maximumPadding() }, set: function(value) { return this.set_maximumPadding(value); } });Object.defineProperty(feathers.controls.Drawer.prototype, "focusExclusions", { get: function() { return this.get_focusExclusions() }, set: function(value) { return this.set_focusExclusions(value); } });Object.defineProperty(feathers.controls.Drawer.prototype, "drawer", { get: function() { return this.get_drawer() }, set: function(value) { return this.set_drawer(value); } });Object.defineProperty(feathers.controls.Drawer.prototype, "content", { get: function() { return this.get_content() }, set: function(value) { return this.set_content(value); } });Object.defineProperty(feathers.controls.Drawer.prototype, "pullableEdge", { get: function() { return this.get_pullableEdge() }, set: function(value) { return this.set_pullableEdge(value); } });Object.defineProperty(feathers.controls.Drawer.prototype, "opened", { get: function() { return this.get_opened() }, set: function(value) { return this.set_opened(value); } });Object.defineProperty(feathers.controls.Drawer.prototype, "autoSizeMode", { get: function() { return this.get_autoSizeMode() }, set: function(value) { return this.set_autoSizeMode(value); } });Object.defineProperty(feathers.controls.Drawer.prototype, "simulateTouch", { get: function() { return this.get_simulateTouch() }, set: function(value) { return this.set_simulateTouch(value); } });Object.defineProperty(feathers.controls.Drawer.prototype, "overlaySkin", { get: function() { return this.get_overlaySkin() }, set: function(value) { return this.set_overlaySkin(value); } });Object.defineProperty(feathers.controls.Drawer.prototype, "clickOverlayToClose", { get: function() { return this.get_clickOverlayToClose() }, set: function(value) { return this.set_clickOverlayToClose(value); } });Object.defineProperty(feathers.controls.Drawer.prototype, "swipeCloseEnabled", { get: function() { return this.get_swipeCloseEnabled() }, set: function(value) { return this.set_swipeCloseEnabled(value); } });Object.defineProperty(feathers.controls.Drawer.prototype, "swipeOpenEnabled", { get: function() { return this.get_swipeOpenEnabled() }, set: function(value) { return this.set_swipeOpenEnabled(value); } });Object.defineProperty(feathers.style.IVariantStyleObject.prototype, "styleContext", { get: function() { return this.get_styleContext() }, set: function(value) { return this.set_styleContext(value); } });Object.defineProperty(feathers.style.IVariantStyleObject.prototype, "variant", { get: function() { return this.get_variant() }, set: function(value) { return this.set_variant(value); } });Object.defineProperty(feathers.core.IFocusExclusions.prototype, "focusExclusions", { get: function() { return this.get_focusExclusions() }, set: function(value) { return this.set_focusExclusions(value); } });Object.defineProperty(feathers.layout.HorizontalListLayout.prototype, "scrollX", { get: function() { return this.get_scrollX() }, set: function(value) { return this.set_scrollX(value); } });Object.defineProperty(feathers.layout.HorizontalListLayout.prototype, "scrollY", { get: function() { return this.get_scrollY() }, set: function(value) { return this.set_scrollY(value); } });Object.defineProperty(feathers.layout.HorizontalListLayout.prototype, "virtualCache", { get: function() { return this.get_virtualCache() }, set: function(value) { return this.set_virtualCache(value); } });Object.defineProperty(feathers.layout.HorizontalListLayout.prototype, "elasticTop", { get: function() { return this.get_elasticTop() }, set: function(value) { return this.set_elasticTop(value); } });Object.defineProperty(feathers.layout.HorizontalListLayout.prototype, "elasticRight", { get: function() { return this.get_elasticRight() }, set: function(value) { return this.set_elasticRight(value); } });Object.defineProperty(feathers.layout.HorizontalListLayout.prototype, "elasticBottom", { get: function() { return this.get_elasticBottom() }, set: function(value) { return this.set_elasticBottom(value); } });Object.defineProperty(feathers.layout.HorizontalListLayout.prototype, "elasticLeft", { get: function() { return this.get_elasticLeft() }, set: function(value) { return this.set_elasticLeft(value); } });Object.defineProperty(feathers.layout.HorizontalListLayout.prototype, "requestedColumnCount", { get: function() { return this.get_requestedColumnCount() }, set: function(value) { return this.set_requestedColumnCount(value); } });Object.defineProperty(feathers.layout.HorizontalListLayout.prototype, "requestedMinColumnCount", { get: function() { return this.get_requestedMinColumnCount() }, set: function(value) { return this.set_requestedMinColumnCount(value); } });Object.defineProperty(feathers.layout.HorizontalListLayout.prototype, "requestedMaxColumnCount", { get: function() { return this.get_requestedMaxColumnCount() }, set: function(value) { return this.set_requestedMaxColumnCount(value); } });Object.defineProperty(feathers.layout.HorizontalListLayout.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.layout.HorizontalListLayout.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.layout.HorizontalListLayout.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.layout.HorizontalListLayout.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.layout.HorizontalListLayout.prototype, "gap", { get: function() { return this.get_gap() }, set: function(value) { return this.set_gap(value); } });Object.defineProperty(feathers.layout.HorizontalListLayout.prototype, "minGap", { get: function() { return this.get_minGap() }, set: function(value) { return this.set_minGap(value); } });Object.defineProperty(feathers.layout.HorizontalListLayout.prototype, "horizontalAlign", { get: function() { return this.get_horizontalAlign() }, set: function(value) { return this.set_horizontalAlign(value); } });Object.defineProperty(feathers.layout.HorizontalListLayout.prototype, "contentJustify", { get: function() { return this.get_contentJustify() }, set: function(value) { return this.set_contentJustify(value); } });Object.defineProperty(feathers.layout.HorizontalListLayout.prototype, "heightResetEnabled", { get: function() { return this.get_heightResetEnabled() }, set: function(value) { return this.set_heightResetEnabled(value); } });Object.defineProperty(feathers.motion.effects.NoOpEffectContext.prototype, "target", { get: function() { return this.get_target() }, set: function(value) { return this.set_target(value); } });Object.defineProperty(feathers.motion.effects.NoOpEffectContext.prototype, "duration", { get: function() { return this.get_duration() }, set: function(value) { return this.set_duration(value); } });Object.defineProperty(feathers.motion.effects.NoOpEffectContext.prototype, "position", { get: function() { return this.get_position() }, set: function(value) { return this.set_position(value); } });Object.defineProperty(feathers.core.IFocusManagerAware.prototype, "focusManager", { get: function() { return this.get_focusManager() }, set: function(value) { return this.set_focusManager(value); } });Object.defineProperty(feathers.controls.TextCallout.prototype, "text", { get: function() { return this.get_text() }, set: function(value) { return this.set_text(value); } });Object.defineProperty(feathers.controls.TextCallout.prototype, "htmlText", { get: function() { return this.get_htmlText() }, set: function(value) { return this.set_htmlText(value); } });Object.defineProperty(feathers.controls.TextCallout.prototype, "baseline", { get: function() { return this.get_baseline() }, set: function(value) { return this.set_baseline(value); } });Object.defineProperty(feathers.controls.TextCallout.prototype, "textFormat", { get: function() { return this.get_textFormat() }, set: function(value) { return this.set_textFormat(value); } });Object.defineProperty(feathers.controls.TextCallout.prototype, "embedFonts", { get: function() { return this.get_embedFonts() }, set: function(value) { return this.set_embedFonts(value); } });Object.defineProperty(feathers.controls.TextCallout.prototype, "disabledTextFormat", { get: function() { return this.get_disabledTextFormat() }, set: function(value) { return this.set_disabledTextFormat(value); } });Object.defineProperty(feathers.controls.TextCallout.prototype, "wordWrap", { get: function() { return this.get_wordWrap() }, set: function(value) { return this.set_wordWrap(value); } });Object.defineProperty(feathers.controls.BasicToggleButton.prototype, "currentState", { get: function() { return this.get_currentState() }, set: function(value) { return this.set_currentState(value); } });Object.defineProperty(feathers.controls.BasicToggleButton.prototype, "selected", { get: function() { return this.get_selected() }, set: function(value) { return this.set_selected(value); } });Object.defineProperty(feathers.controls.BasicToggleButton.prototype, "toggleable", { get: function() { return this.get_toggleable() }, set: function(value) { return this.set_toggleable(value); } });Object.defineProperty(feathers.controls.BasicToggleButton.prototype, "keepDownStateOnRollOut", { get: function() { return this.get_keepDownStateOnRollOut() }, set: function(value) { return this.set_keepDownStateOnRollOut(value); } });Object.defineProperty(feathers.controls.BasicToggleButton.prototype, "backgroundSkin", { get: function() { return this.get_backgroundSkin() }, set: function(value) { return this.set_backgroundSkin(value); } });Object.defineProperty(feathers.controls.BasicToggleButton.prototype, "selectedBackgroundSkin", { get: function() { return this.get_selectedBackgroundSkin() }, set: function(value) { return this.set_selectedBackgroundSkin(value); } });Object.defineProperty(feathers.core.IFocusExtras.prototype, "focusExtrasBefore", { get: function() { return this.get_focusExtrasBefore() }, set: function(value) { return this.set_focusExtrasBefore(value); } });Object.defineProperty(feathers.core.IFocusExtras.prototype, "focusExtrasAfter", { get: function() { return this.get_focusExtrasAfter() }, set: function(value) { return this.set_focusExtrasAfter(value); } });Object.defineProperty(feathers.skins.DonutSkin.prototype, "thickness", { get: function() { return this.get_thickness() }, set: function(value) { return this.set_thickness(value); } });Object.defineProperty(feathers.core.LetterboxScaleManager.prototype, "target", { get: function() { return this.get_target() }, set: function(value) { return this.set_target(value); } });Object.defineProperty(feathers.core.LetterboxScaleManager.prototype, "originalWidth", { get: function() { return this.get_originalWidth() }, set: function(value) { return this.set_originalWidth(value); } });Object.defineProperty(feathers.core.LetterboxScaleManager.prototype, "originalHeight", { get: function() { return this.get_originalHeight() }, set: function(value) { return this.set_originalHeight(value); } });Object.defineProperty(feathers.layout.VerticalListFixedRowLayout.prototype, "scrollX", { get: function() { return this.get_scrollX() }, set: function(value) { return this.set_scrollX(value); } });Object.defineProperty(feathers.layout.VerticalListFixedRowLayout.prototype, "scrollY", { get: function() { return this.get_scrollY() }, set: function(value) { return this.set_scrollY(value); } });Object.defineProperty(feathers.layout.VerticalListFixedRowLayout.prototype, "virtualCache", { get: function() { return this.get_virtualCache() }, set: function(value) { return this.set_virtualCache(value); } });Object.defineProperty(feathers.layout.VerticalListFixedRowLayout.prototype, "elasticTop", { get: function() { return this.get_elasticTop() }, set: function(value) { return this.set_elasticTop(value); } });Object.defineProperty(feathers.layout.VerticalListFixedRowLayout.prototype, "elasticRight", { get: function() { return this.get_elasticRight() }, set: function(value) { return this.set_elasticRight(value); } });Object.defineProperty(feathers.layout.VerticalListFixedRowLayout.prototype, "elasticBottom", { get: function() { return this.get_elasticBottom() }, set: function(value) { return this.set_elasticBottom(value); } });Object.defineProperty(feathers.layout.VerticalListFixedRowLayout.prototype, "elasticLeft", { get: function() { return this.get_elasticLeft() }, set: function(value) { return this.set_elasticLeft(value); } });Object.defineProperty(feathers.layout.VerticalListFixedRowLayout.prototype, "rowHeight", { get: function() { return this.get_rowHeight() }, set: function(value) { return this.set_rowHeight(value); } });Object.defineProperty(feathers.layout.VerticalListFixedRowLayout.prototype, "requestedRowCount", { get: function() { return this.get_requestedRowCount() }, set: function(value) { return this.set_requestedRowCount(value); } });Object.defineProperty(feathers.layout.VerticalListFixedRowLayout.prototype, "requestedMinRowCount", { get: function() { return this.get_requestedMinRowCount() }, set: function(value) { return this.set_requestedMinRowCount(value); } });Object.defineProperty(feathers.layout.VerticalListFixedRowLayout.prototype, "requestedMaxRowCount", { get: function() { return this.get_requestedMaxRowCount() }, set: function(value) { return this.set_requestedMaxRowCount(value); } });Object.defineProperty(feathers.layout.VerticalListFixedRowLayout.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.layout.VerticalListFixedRowLayout.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.layout.VerticalListFixedRowLayout.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.layout.VerticalListFixedRowLayout.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.layout.VerticalListFixedRowLayout.prototype, "gap", { get: function() { return this.get_gap() }, set: function(value) { return this.set_gap(value); } });Object.defineProperty(feathers.layout.VerticalListFixedRowLayout.prototype, "minGap", { get: function() { return this.get_minGap() }, set: function(value) { return this.set_minGap(value); } });Object.defineProperty(feathers.layout.VerticalListFixedRowLayout.prototype, "verticalAlign", { get: function() { return this.get_verticalAlign() }, set: function(value) { return this.set_verticalAlign(value); } });Object.defineProperty(feathers.layout.VerticalListFixedRowLayout.prototype, "contentJustify", { get: function() { return this.get_contentJustify() }, set: function(value) { return this.set_contentJustify(value); } });Object.defineProperty(feathers.data.ArrayHierarchicalCollection.prototype, "array", { get: function() { return this.get_array() }, set: function(value) { return this.set_array(value); } });Object.defineProperty(feathers.data.ArrayHierarchicalCollection.prototype, "itemToChildren", { get: function() { return this.get_itemToChildren() }, set: function(value) { return this.set_itemToChildren(value); } });Object.defineProperty(feathers.data.ArrayHierarchicalCollection.prototype, "filterFunction", { get: function() { return this.get_filterFunction() }, set: function(value) { return this.set_filterFunction(value); } });Object.defineProperty(feathers.data.ArrayHierarchicalCollection.prototype, "sortCompareFunction", { get: function() { return this.get_sortCompareFunction() }, set: function(value) { return this.set_sortCompareFunction(value); } });Object.defineProperty(feathers.controls.dataRenderers.GridViewRowRenderer.prototype, "gridView", { get: function() { return this.get_gridView() }, set: function(value) { return this.set_gridView(value); } });Object.defineProperty(feathers.controls.dataRenderers.GridViewRowRenderer.prototype, "selected", { get: function() { return this.get_selected() }, set: function(value) { return this.set_selected(value); } });Object.defineProperty(feathers.controls.dataRenderers.GridViewRowRenderer.prototype, "rowIndex", { get: function() { return this.get_rowIndex() }, set: function(value) { return this.set_rowIndex(value); } });Object.defineProperty(feathers.controls.dataRenderers.GridViewRowRenderer.prototype, "data", { get: function() { return this.get_data() }, set: function(value) { return this.set_data(value); } });Object.defineProperty(feathers.controls.dataRenderers.GridViewRowRenderer.prototype, "columns", { get: function() { return this.get_columns() }, set: function(value) { return this.set_columns(value); } });Object.defineProperty(feathers.controls.dataRenderers.GridViewRowRenderer.prototype, "cellRendererRecycler", { get: function() { return this.get_cellRendererRecycler() }, set: function(value) { return this.set_cellRendererRecycler(value); } });Object.defineProperty(feathers.controls.dataRenderers.GridViewRowRenderer.prototype, "forceCellStateUpdate", { get: function() { return this.get_forceCellStateUpdate() }, set: function(value) { return this.set_forceCellStateUpdate(value); } });Object.defineProperty(feathers.controls.dataRenderers.GridViewRowRenderer.prototype, "customCellRendererVariant", { get: function() { return this.get_customCellRendererVariant() }, set: function(value) { return this.set_customCellRendererVariant(value); } });Object.defineProperty(feathers.controls.dataRenderers.GridViewRowRenderer.prototype, "customColumnWidths", { get: function() { return this.get_customColumnWidths() }, set: function(value) { return this.set_customColumnWidths(value); } });Object.defineProperty(feathers.skins.MultiSkin.prototype, "defaultView", { get: function() { return this.get_defaultView() }, set: function(value) { return this.set_defaultView(value); } });Object.defineProperty(feathers.skins.MultiSkin.prototype, "disabledView", { get: function() { return this.get_disabledView() }, set: function(value) { return this.set_disabledView(value); } });Object.defineProperty(feathers.skins.MultiSkin.prototype, "selectedView", { get: function() { return this.get_selectedView() }, set: function(value) { return this.set_selectedView(value); } });Object.defineProperty(feathers.layout.HorizontalLayout.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.layout.HorizontalLayout.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.layout.HorizontalLayout.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.layout.HorizontalLayout.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.layout.HorizontalLayout.prototype, "gap", { get: function() { return this.get_gap() }, set: function(value) { return this.set_gap(value); } });Object.defineProperty(feathers.layout.HorizontalLayout.prototype, "minGap", { get: function() { return this.get_minGap() }, set: function(value) { return this.set_minGap(value); } });Object.defineProperty(feathers.layout.HorizontalLayout.prototype, "horizontalAlign", { get: function() { return this.get_horizontalAlign() }, set: function(value) { return this.set_horizontalAlign(value); } });Object.defineProperty(feathers.layout.HorizontalLayout.prototype, "verticalAlign", { get: function() { return this.get_verticalAlign() }, set: function(value) { return this.set_verticalAlign(value); } });Object.defineProperty(feathers.layout.HorizontalLayout.prototype, "justifyResetEnabled", { get: function() { return this.get_justifyResetEnabled() }, set: function(value) { return this.set_justifyResetEnabled(value); } });Object.defineProperty(feathers.layout.HorizontalLayout.prototype, "percentWidthResetEnabled", { get: function() { return this.get_percentWidthResetEnabled() }, set: function(value) { return this.set_percentWidthResetEnabled(value); } });Object.defineProperty(feathers.layout.HorizontalLayout.prototype, "percentHeightResetEnabled", { get: function() { return this.get_percentHeightResetEnabled() }, set: function(value) { return this.set_percentHeightResetEnabled(value); } });Object.defineProperty(feathers.display.Scale9Bitmap.prototype, "smoothing", { get: function() { return this.get_smoothing() }, set: function(value) { return this.set_smoothing(value); } });Object.defineProperty(feathers.display.Scale9Bitmap.prototype, "bitmapData", { get: function() { return this.get_bitmapData() }, set: function(value) { return this.set_bitmapData(value); } });Object.defineProperty(feathers.controls.navigators.TabNavigator.prototype, "dataProvider", { get: function() { return this.get_dataProvider() }, set: function(value) { return this.set_dataProvider(value); } });Object.defineProperty(feathers.controls.navigators.TabNavigator.prototype, "selectedIndex", { get: function() { return this.get_selectedIndex() }, set: function(value) { return this.set_selectedIndex(value); } });Object.defineProperty(feathers.controls.navigators.TabNavigator.prototype, "maxSelectedIndex", { get: function() { return this.get_maxSelectedIndex() }, set: function(value) { return this.set_maxSelectedIndex(value); } });Object.defineProperty(feathers.controls.navigators.TabNavigator.prototype, "selectedItem", { get: function() { return this.get_selectedItem() }, set: function(value) { return this.set_selectedItem(value); } });Object.defineProperty(feathers.controls.navigators.TabNavigator.prototype, "tabBarPosition", { get: function() { return this.get_tabBarPosition() }, set: function(value) { return this.set_tabBarPosition(value); } });Object.defineProperty(feathers.controls.navigators.TabNavigator.prototype, "swipeEnabled", { get: function() { return this.get_swipeEnabled() }, set: function(value) { return this.set_swipeEnabled(value); } });Object.defineProperty(feathers.controls.navigators.TabNavigator.prototype, "simulateTouch", { get: function() { return this.get_simulateTouch() }, set: function(value) { return this.set_simulateTouch(value); } });Object.defineProperty(feathers.controls.navigators.TabNavigator.prototype, "previousTransition", { get: function() { return this.get_previousTransition() }, set: function(value) { return this.set_previousTransition(value); } });Object.defineProperty(feathers.controls.navigators.TabNavigator.prototype, "nextTransition", { get: function() { return this.get_nextTransition() }, set: function(value) { return this.set_nextTransition(value); } });Object.defineProperty(feathers.controls.navigators.TabNavigator.prototype, "gap", { get: function() { return this.get_gap() }, set: function(value) { return this.set_gap(value); } });Object.defineProperty(feathers.controls.navigators.TabNavigator.prototype, "customTabBarVariant", { get: function() { return this.get_customTabBarVariant() }, set: function(value) { return this.set_customTabBarVariant(value); } });Object.defineProperty(feathers.controls.navigators.TabNavigator.prototype, "tabBarFactory", { get: function() { return this.get_tabBarFactory() }, set: function(value) { return this.set_tabBarFactory(value); } });Object.defineProperty(feathers.core.CustomScaleManager.prototype, "target", { get: function() { return this.get_target() }, set: function(value) { return this.set_target(value); } });Object.defineProperty(feathers.core.CustomScaleManager.prototype, "customScale", { get: function() { return this.get_customScale() }, set: function(value) { return this.set_customScale(value); } });Object.defineProperty(feathers.core.CustomScaleManager.prototype, "customBounds", { get: function() { return this.get_customBounds() }, set: function(value) { return this.set_customBounds(value); } });Object.defineProperty(feathers.skins.RectangleSkin.prototype, "cornerRadius", { get: function() { return this.get_cornerRadius() }, set: function(value) { return this.set_cornerRadius(value); } });Object.defineProperty(feathers.skins.ProgrammaticSkin.prototype, "uiContext", { get: function() { return this.get_uiContext() }, set: function(value) { return this.set_uiContext(value); } });Object.defineProperty(feathers.skins.ProgrammaticSkin.prototype, "stateContext", { get: function() { return this.get_stateContext() }, set: function(value) { return this.set_stateContext(value); } });Object.defineProperty(feathers.core.IValidating.prototype, "depth", { get: function() { return this.get_depth() }, set: function(value) { return this.set_depth(value); } });Object.defineProperty(feathers.controls.ScrollContainer.prototype, "layout", { get: function() { return this.get_layout() }, set: function(value) { return this.set_layout(value); } });Object.defineProperty(feathers.controls.ScrollContainer.prototype, "xmlContent", { get: function() { return this.get_xmlContent() }, set: function(value) { return this.set_xmlContent(value); } });Object.defineProperty(feathers.controls.ScrollContainer.prototype, "childFocusEnabled", { get: function() { return this.get_childFocusEnabled() }, set: function(value) { return this.set_childFocusEnabled(value); } });Object.defineProperty(feathers.controls.ScrollContainer.prototype, "autoSizeMode", { get: function() { return this.get_autoSizeMode() }, set: function(value) { return this.set_autoSizeMode(value); } });Object.defineProperty(feathers.controls.ScrollContainer.prototype, "manageChildVisibility", { get: function() { return this.get_manageChildVisibility() }, set: function(value) { return this.set_manageChildVisibility(value); } });Object.defineProperty(feathers.controls.ScrollContainer.prototype, "numRawChildren", { get: function() { return this.get_numRawChildren() }, set: function(value) { return this.set_numRawChildren(value); } });Object.defineProperty(feathers.controls.TreeView.prototype, "childFocusEnabled", { get: function() { return this.get_childFocusEnabled() }, set: function(value) { return this.set_childFocusEnabled(value); } });Object.defineProperty(feathers.controls.TreeView.prototype, "dataProvider", { get: function() { return this.get_dataProvider() }, set: function(value) { return this.set_dataProvider(value); } });Object.defineProperty(feathers.controls.TreeView.prototype, "selectedLocation", { get: function() { return this.get_selectedLocation() }, set: function(value) { return this.set_selectedLocation(value); } });Object.defineProperty(feathers.controls.TreeView.prototype, "selectedItem", { get: function() { return this.get_selectedItem() }, set: function(value) { return this.set_selectedItem(value); } });Object.defineProperty(feathers.controls.TreeView.prototype, "layout", { get: function() { return this.get_layout() }, set: function(value) { return this.set_layout(value); } });Object.defineProperty(feathers.controls.TreeView.prototype, "customItemRendererVariant", { get: function() { return this.get_customItemRendererVariant() }, set: function(value) { return this.set_customItemRendererVariant(value); } });Object.defineProperty(feathers.controls.TreeView.prototype, "itemRendererRecycler", { get: function() { return this.get_itemRendererRecycler() }, set: function(value) { return this.set_itemRendererRecycler(value); } });Object.defineProperty(feathers.controls.TreeView.prototype, "forceItemStateUpdate", { get: function() { return this.get_forceItemStateUpdate() }, set: function(value) { return this.set_forceItemStateUpdate(value); } });Object.defineProperty(feathers.controls.TreeView.prototype, "itemRendererRecyclerIDFunction", { get: function() { return this.get_itemRendererRecyclerIDFunction() }, set: function(value) { return this.set_itemRendererRecyclerIDFunction(value); } });Object.defineProperty(feathers.controls.TreeView.prototype, "selectable", { get: function() { return this.get_selectable() }, set: function(value) { return this.set_selectable(value); } });Object.defineProperty(feathers.controls.TreeView.prototype, "virtualLayout", { get: function() { return this.get_virtualLayout() }, set: function(value) { return this.set_virtualLayout(value); } });Object.defineProperty(feathers.layout.GridViewRowLayout.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.layout.GridViewRowLayout.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.layout.GridViewRowLayout.prototype, "columns", { get: function() { return this.get_columns() }, set: function(value) { return this.set_columns(value); } });Object.defineProperty(feathers.layout.GridViewRowLayout.prototype, "customColumnWidths", { get: function() { return this.get_customColumnWidths() }, set: function(value) { return this.set_customColumnWidths(value); } });Object.defineProperty(feathers.layout.GridViewRowLayout.prototype, "heightResetEnabled", { get: function() { return this.get_heightResetEnabled() }, set: function(value) { return this.set_heightResetEnabled(value); } });Object.defineProperty(feathers.layout.ILayoutObject.prototype, "includeInLayout", { get: function() { return this.get_includeInLayout() }, set: function(value) { return this.set_includeInLayout(value); } });Object.defineProperty(feathers.layout.ILayoutObject.prototype, "layoutData", { get: function() { return this.get_layoutData() }, set: function(value) { return this.set_layoutData(value); } });Object.defineProperty(feathers.utils.EdgePuller.prototype, "active", { get: function() { return this.get_active() }, set: function(value) { return this.set_active(value); } });Object.defineProperty(feathers.utils.EdgePuller.prototype, "dragging", { get: function() { return this.get_dragging() }, set: function(value) { return this.set_dragging(value); } });Object.defineProperty(feathers.utils.EdgePuller.prototype, "target", { get: function() { return this.get_target() }, set: function(value) { return this.set_target(value); } });Object.defineProperty(feathers.utils.EdgePuller.prototype, "maxPullDistance", { get: function() { return this.get_maxPullDistance() }, set: function(value) { return this.set_maxPullDistance(value); } });Object.defineProperty(feathers.utils.EdgePuller.prototype, "pullDistance", { get: function() { return this.get_pullDistance() }, set: function(value) { return this.set_pullDistance(value); } });Object.defineProperty(feathers.utils.EdgePuller.prototype, "activeBorderSize", { get: function() { return this.get_activeBorderSize() }, set: function(value) { return this.set_activeBorderSize(value); } });Object.defineProperty(feathers.utils.EdgePuller.prototype, "pullableEdge", { get: function() { return this.get_pullableEdge() }, set: function(value) { return this.set_pullableEdge(value); } });Object.defineProperty(feathers.utils.EdgePuller.prototype, "opened", { get: function() { return this.get_opened() }, set: function(value) { return this.set_opened(value); } });Object.defineProperty(feathers.utils.EdgePuller.prototype, "snapDuration", { get: function() { return this.get_snapDuration() }, set: function(value) { return this.set_snapDuration(value); } });Object.defineProperty(feathers.utils.EdgePuller.prototype, "touchPointID", { get: function() { return this.get_touchPointID() }, set: function(value) { return this.set_touchPointID(value); } });Object.defineProperty(feathers.utils.EdgePuller.prototype, "touchPointIsSimulated", { get: function() { return this.get_touchPointIsSimulated() }, set: function(value) { return this.set_touchPointIsSimulated(value); } });Object.defineProperty(feathers.motion.effects.actuate.ActuateEffectContext.prototype, "actuator", { get: function() { return this.get_actuator() }, set: function(value) { return this.set_actuator(value); } });Object.defineProperty(feathers.layout.VerticalLayout.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.layout.VerticalLayout.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.layout.VerticalLayout.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.layout.VerticalLayout.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.layout.VerticalLayout.prototype, "gap", { get: function() { return this.get_gap() }, set: function(value) { return this.set_gap(value); } });Object.defineProperty(feathers.layout.VerticalLayout.prototype, "minGap", { get: function() { return this.get_minGap() }, set: function(value) { return this.set_minGap(value); } });Object.defineProperty(feathers.layout.VerticalLayout.prototype, "horizontalAlign", { get: function() { return this.get_horizontalAlign() }, set: function(value) { return this.set_horizontalAlign(value); } });Object.defineProperty(feathers.layout.VerticalLayout.prototype, "verticalAlign", { get: function() { return this.get_verticalAlign() }, set: function(value) { return this.set_verticalAlign(value); } });Object.defineProperty(feathers.layout.VerticalLayout.prototype, "justifyResetEnabled", { get: function() { return this.get_justifyResetEnabled() }, set: function(value) { return this.set_justifyResetEnabled(value); } });Object.defineProperty(feathers.layout.VerticalLayout.prototype, "percentWidthResetEnabled", { get: function() { return this.get_percentWidthResetEnabled() }, set: function(value) { return this.set_percentWidthResetEnabled(value); } });Object.defineProperty(feathers.layout.VerticalLayout.prototype, "percentHeightResetEnabled", { get: function() { return this.get_percentHeightResetEnabled() }, set: function(value) { return this.set_percentHeightResetEnabled(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "text", { get: function() { return this.get_text() }, set: function(value) { return this.set_text(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "htmlText", { get: function() { return this.get_htmlText() }, set: function(value) { return this.set_htmlText(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "baseline", { get: function() { return this.get_baseline() }, set: function(value) { return this.set_baseline(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "icon", { get: function() { return this.get_icon() }, set: function(value) { return this.set_icon(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "disabledIcon", { get: function() { return this.get_disabledIcon() }, set: function(value) { return this.set_disabledIcon(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "selectedIcon", { get: function() { return this.get_selectedIcon() }, set: function(value) { return this.set_selectedIcon(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "textFormat", { get: function() { return this.get_textFormat() }, set: function(value) { return this.set_textFormat(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "embedFonts", { get: function() { return this.get_embedFonts() }, set: function(value) { return this.set_embedFonts(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "wordWrap", { get: function() { return this.get_wordWrap() }, set: function(value) { return this.set_wordWrap(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "disabledTextFormat", { get: function() { return this.get_disabledTextFormat() }, set: function(value) { return this.set_disabledTextFormat(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "selectedTextFormat", { get: function() { return this.get_selectedTextFormat() }, set: function(value) { return this.set_selectedTextFormat(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "iconPosition", { get: function() { return this.get_iconPosition() }, set: function(value) { return this.set_iconPosition(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "gap", { get: function() { return this.get_gap() }, set: function(value) { return this.set_gap(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "minGap", { get: function() { return this.get_minGap() }, set: function(value) { return this.set_minGap(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "horizontalAlign", { get: function() { return this.get_horizontalAlign() }, set: function(value) { return this.set_horizontalAlign(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "verticalAlign", { get: function() { return this.get_verticalAlign() }, set: function(value) { return this.set_verticalAlign(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "iconOffsetX", { get: function() { return this.get_iconOffsetX() }, set: function(value) { return this.set_iconOffsetX(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "iconOffsetY", { get: function() { return this.get_iconOffsetY() }, set: function(value) { return this.set_iconOffsetY(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "textOffsetX", { get: function() { return this.get_textOffsetX() }, set: function(value) { return this.set_textOffsetX(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "textOffsetY", { get: function() { return this.get_textOffsetY() }, set: function(value) { return this.set_textOffsetY(value); } });Object.defineProperty(feathers.controls.ToggleButton.prototype, "showText", { get: function() { return this.get_showText() }, set: function(value) { return this.set_showText(value); } });Object.defineProperty(feathers.skins.VerticalLineSkin.prototype, "horizontalAlign", { get: function() { return this.get_horizontalAlign() }, set: function(value) { return this.set_horizontalAlign(value); } });Object.defineProperty(feathers.skins.VerticalLineSkin.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.skins.VerticalLineSkin.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.controls.navigators.PageNavigator.prototype, "dataProvider", { get: function() { return this.get_dataProvider() }, set: function(value) { return this.set_dataProvider(value); } });Object.defineProperty(feathers.controls.navigators.PageNavigator.prototype, "selectedIndex", { get: function() { return this.get_selectedIndex() }, set: function(value) { return this.set_selectedIndex(value); } });Object.defineProperty(feathers.controls.navigators.PageNavigator.prototype, "maxSelectedIndex", { get: function() { return this.get_maxSelectedIndex() }, set: function(value) { return this.set_maxSelectedIndex(value); } });Object.defineProperty(feathers.controls.navigators.PageNavigator.prototype, "selectedItem", { get: function() { return this.get_selectedItem() }, set: function(value) { return this.set_selectedItem(value); } });Object.defineProperty(feathers.controls.navigators.PageNavigator.prototype, "pageIndicatorPosition", { get: function() { return this.get_pageIndicatorPosition() }, set: function(value) { return this.set_pageIndicatorPosition(value); } });Object.defineProperty(feathers.controls.navigators.PageNavigator.prototype, "swipeEnabled", { get: function() { return this.get_swipeEnabled() }, set: function(value) { return this.set_swipeEnabled(value); } });Object.defineProperty(feathers.controls.navigators.PageNavigator.prototype, "simulateTouch", { get: function() { return this.get_simulateTouch() }, set: function(value) { return this.set_simulateTouch(value); } });Object.defineProperty(feathers.controls.navigators.PageNavigator.prototype, "previousTransition", { get: function() { return this.get_previousTransition() }, set: function(value) { return this.set_previousTransition(value); } });Object.defineProperty(feathers.controls.navigators.PageNavigator.prototype, "nextTransition", { get: function() { return this.get_nextTransition() }, set: function(value) { return this.set_nextTransition(value); } });Object.defineProperty(feathers.controls.navigators.PageNavigator.prototype, "gap", { get: function() { return this.get_gap() }, set: function(value) { return this.set_gap(value); } });Object.defineProperty(feathers.controls.navigators.PageNavigator.prototype, "customPageIndicatorVariant", { get: function() { return this.get_customPageIndicatorVariant() }, set: function(value) { return this.set_customPageIndicatorVariant(value); } });Object.defineProperty(feathers.controls.navigators.PageNavigator.prototype, "pageIndicatorFactory", { get: function() { return this.get_pageIndicatorFactory() }, set: function(value) { return this.set_pageIndicatorFactory(value); } });Object.defineProperty(feathers.skins.HorizontalLineSkin.prototype, "verticalAlign", { get: function() { return this.get_verticalAlign() }, set: function(value) { return this.set_verticalAlign(value); } });Object.defineProperty(feathers.skins.HorizontalLineSkin.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.skins.HorizontalLineSkin.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.motion.effects.BaseEffectContext.prototype, "target", { get: function() { return this.get_target() }, set: function(value) { return this.set_target(value); } });Object.defineProperty(feathers.motion.effects.BaseEffectContext.prototype, "duration", { get: function() { return this.get_duration() }, set: function(value) { return this.set_duration(value); } });Object.defineProperty(feathers.motion.effects.BaseEffectContext.prototype, "position", { get: function() { return this.get_position() }, set: function(value) { return this.set_position(value); } });Object.defineProperty(feathers.motion.effects.BaseEffectContext.prototype, "ease", { get: function() { return this.get_ease() }, set: function(value) { return this.set_ease(value); } });Object.defineProperty(feathers.controls.dataRenderers.ITreeViewItemRenderer.prototype, "location", { get: function() { return this.get_location() }, set: function(value) { return this.set_location(value); } });Object.defineProperty(feathers.controls.dataRenderers.ITreeViewItemRenderer.prototype, "treeViewOwner", { get: function() { return this.get_treeViewOwner() }, set: function(value) { return this.set_treeViewOwner(value); } });Object.defineProperty(feathers.core.ValidationQueue.prototype, "validating", { get: function() { return this.get_validating() }, set: function(value) { return this.set_validating(value); } });Object.defineProperty(feathers.controls.IGroupedToggle.prototype, "toggleGroup", { get: function() { return this.get_toggleGroup() }, set: function(value) { return this.set_toggleGroup(value); } });Object.defineProperty(feathers.core.IDisplayObject.prototype, "x", { get: function() { return this.get_x() }, set: function(value) { return this.set_x(value); } });Object.defineProperty(feathers.core.IDisplayObject.prototype, "y", { get: function() { return this.get_y() }, set: function(value) { return this.set_y(value); } });Object.defineProperty(feathers.core.IDisplayObject.prototype, "alpha", { get: function() { return this.get_alpha() }, set: function(value) { return this.set_alpha(value); } });Object.defineProperty(feathers.core.IDisplayObject.prototype, "width", { get: function() { return this.get_width() }, set: function(value) { return this.set_width(value); } });Object.defineProperty(feathers.core.IDisplayObject.prototype, "height", { get: function() { return this.get_height() }, set: function(value) { return this.set_height(value); } });Object.defineProperty(feathers.core.IDisplayObject.prototype, "scaleX", { get: function() { return this.get_scaleX() }, set: function(value) { return this.set_scaleX(value); } });Object.defineProperty(feathers.core.IDisplayObject.prototype, "scaleY", { get: function() { return this.get_scaleY() }, set: function(value) { return this.set_scaleY(value); } });Object.defineProperty(feathers.core.IDisplayObject.prototype, "visible", { get: function() { return this.get_visible() }, set: function(value) { return this.set_visible(value); } });Object.defineProperty(feathers.skins.IProgrammaticSkin.prototype, "uiContext", { get: function() { return this.get_uiContext() }, set: function(value) { return this.set_uiContext(value); } });Object.defineProperty(feathers.core.IUIControl.prototype, "enabled", { get: function() { return this.get_enabled() }, set: function(value) { return this.set_enabled(value); } });Object.defineProperty(feathers.core.IUIControl.prototype, "toolTip", { get: function() { return this.get_toolTip() }, set: function(value) { return this.set_toolTip(value); } });Object.defineProperty(feathers.utils.BitmapDataCache.prototype, "maxUnretained", { get: function() { return this.get_maxUnretained() }, set: function(value) { return this.set_maxUnretained(value); } });Object.defineProperty(feathers.controls.dataRenderers.LayoutGroupItemRenderer.prototype, "data", { get: function() { return this.get_data() }, set: function(value) { return this.set_data(value); } });Object.defineProperty(feathers.controls.dataRenderers.LayoutGroupItemRenderer.prototype, "currentState", { get: function() { return this.get_currentState() }, set: function(value) { return this.set_currentState(value); } });Object.defineProperty(feathers.controls.dataRenderers.LayoutGroupItemRenderer.prototype, "layoutIndex", { get: function() { return this.get_layoutIndex() }, set: function(value) { return this.set_layoutIndex(value); } });Object.defineProperty(feathers.controls.dataRenderers.LayoutGroupItemRenderer.prototype, "selected", { get: function() { return this.get_selected() }, set: function(value) { return this.set_selected(value); } });Object.defineProperty(feathers.controls.dataRenderers.LayoutGroupItemRenderer.prototype, "pointerTarget", { get: function() { return this.get_pointerTarget() }, set: function(value) { return this.set_pointerTarget(value); } });Object.defineProperty(feathers.controls.dataRenderers.LayoutGroupItemRenderer.prototype, "selectedBackgroundSkin", { get: function() { return this.get_selectedBackgroundSkin() }, set: function(value) { return this.set_selectedBackgroundSkin(value); } });Object.defineProperty(feathers.controls.dataRenderers.LayoutGroupItemRenderer.prototype, "alternateBackgroundSkin", { get: function() { return this.get_alternateBackgroundSkin() }, set: function(value) { return this.set_alternateBackgroundSkin(value); } });Object.defineProperty(feathers.style.FunctionStyleProvider.prototype, "callback", { get: function() { return this.get_callback() }, set: function(value) { return this.set_callback(value); } });Object.defineProperty(feathers.controls.dataRenderers.IGroupListViewItemRenderer.prototype, "location", { get: function() { return this.get_location() }, set: function(value) { return this.set_location(value); } });Object.defineProperty(feathers.controls.dataRenderers.IGroupListViewItemRenderer.prototype, "groupListViewOwner", { get: function() { return this.get_groupListViewOwner() }, set: function(value) { return this.set_groupListViewOwner(value); } });Object.defineProperty(feathers.controls.supportClasses.IViewPort.prototype, "visibleWidth", { get: function() { return this.get_visibleWidth() }, set: function(value) { return this.set_visibleWidth(value); } });Object.defineProperty(feathers.controls.supportClasses.IViewPort.prototype, "visibleHeight", { get: function() { return this.get_visibleHeight() }, set: function(value) { return this.set_visibleHeight(value); } });Object.defineProperty(feathers.controls.supportClasses.IViewPort.prototype, "minVisibleWidth", { get: function() { return this.get_minVisibleWidth() }, set: function(value) { return this.set_minVisibleWidth(value); } });Object.defineProperty(feathers.controls.supportClasses.IViewPort.prototype, "minVisibleHeight", { get: function() { return this.get_minVisibleHeight() }, set: function(value) { return this.set_minVisibleHeight(value); } });Object.defineProperty(feathers.controls.supportClasses.IViewPort.prototype, "maxVisibleWidth", { get: function() { return this.get_maxVisibleWidth() }, set: function(value) { return this.set_maxVisibleWidth(value); } });Object.defineProperty(feathers.controls.supportClasses.IViewPort.prototype, "maxVisibleHeight", { get: function() { return this.get_maxVisibleHeight() }, set: function(value) { return this.set_maxVisibleHeight(value); } });Object.defineProperty(feathers.controls.supportClasses.IViewPort.prototype, "scrollX", { get: function() { return this.get_scrollX() }, set: function(value) { return this.set_scrollX(value); } });Object.defineProperty(feathers.controls.supportClasses.IViewPort.prototype, "scrollY", { get: function() { return this.get_scrollY() }, set: function(value) { return this.set_scrollY(value); } });Object.defineProperty(feathers.data.IHierarchicalCollection.prototype, "filterFunction", { get: function() { return this.get_filterFunction() }, set: function(value) { return this.set_filterFunction(value); } });Object.defineProperty(feathers.data.IHierarchicalCollection.prototype, "sortCompareFunction", { get: function() { return this.get_sortCompareFunction() }, set: function(value) { return this.set_sortCompareFunction(value); } });Object.defineProperty(feathers.style.IDarkModeTheme.prototype, "darkMode", { get: function() { return this.get_darkMode() }, set: function(value) { return this.set_darkMode(value); } });Object.defineProperty(feathers.controls.Label.prototype, "text", { get: function() { return this.get_text() }, set: function(value) { return this.set_text(value); } });Object.defineProperty(feathers.controls.Label.prototype, "baseline", { get: function() { return this.get_baseline() }, set: function(value) { return this.set_baseline(value); } });Object.defineProperty(feathers.controls.Label.prototype, "htmlText", { get: function() { return this.get_htmlText() }, set: function(value) { return this.set_htmlText(value); } });Object.defineProperty(feathers.controls.Label.prototype, "textFormat", { get: function() { return this.get_textFormat() }, set: function(value) { return this.set_textFormat(value); } });Object.defineProperty(feathers.controls.Label.prototype, "embedFonts", { get: function() { return this.get_embedFonts() }, set: function(value) { return this.set_embedFonts(value); } });Object.defineProperty(feathers.controls.Label.prototype, "selectable", { get: function() { return this.get_selectable() }, set: function(value) { return this.set_selectable(value); } });Object.defineProperty(feathers.controls.Label.prototype, "stageFocusTarget", { get: function() { return this.get_stageFocusTarget() }, set: function(value) { return this.set_stageFocusTarget(value); } });Object.defineProperty(feathers.controls.Label.prototype, "selectionBeginIndex", { get: function() { return this.get_selectionBeginIndex() }, set: function(value) { return this.set_selectionBeginIndex(value); } });Object.defineProperty(feathers.controls.Label.prototype, "selectionEndIndex", { get: function() { return this.get_selectionEndIndex() }, set: function(value) { return this.set_selectionEndIndex(value); } });Object.defineProperty(feathers.controls.Label.prototype, "disabledTextFormat", { get: function() { return this.get_disabledTextFormat() }, set: function(value) { return this.set_disabledTextFormat(value); } });Object.defineProperty(feathers.controls.Label.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.controls.Label.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.controls.Label.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.controls.Label.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.controls.Label.prototype, "verticalAlign", { get: function() { return this.get_verticalAlign() }, set: function(value) { return this.set_verticalAlign(value); } });Object.defineProperty(feathers.controls.Label.prototype, "wordWrap", { get: function() { return this.get_wordWrap() }, set: function(value) { return this.set_wordWrap(value); } });Object.defineProperty(feathers.controls.Label.prototype, "backgroundSkin", { get: function() { return this.get_backgroundSkin() }, set: function(value) { return this.set_backgroundSkin(value); } });Object.defineProperty(feathers.controls.Label.prototype, "disabledBackgroundSkin", { get: function() { return this.get_disabledBackgroundSkin() }, set: function(value) { return this.set_disabledBackgroundSkin(value); } });Object.defineProperty(feathers.skins.TriangleSkin.prototype, "pointPosition", { get: function() { return this.get_pointPosition() }, set: function(value) { return this.set_pointPosition(value); } });Object.defineProperty(feathers.skins.TriangleSkin.prototype, "drawBaseBorder", { get: function() { return this.get_drawBaseBorder() }, set: function(value) { return this.set_drawBaseBorder(value); } });Object.defineProperty(feathers.core.IOpenCloseToggle.prototype, "opened", { get: function() { return this.get_opened() }, set: function(value) { return this.set_opened(value); } });Object.defineProperty(feathers.layout.CalendarGridLayout.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.layout.CalendarGridLayout.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.layout.CalendarGridLayout.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.layout.CalendarGridLayout.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.layout.CalendarGridLayout.prototype, "horizontalGap", { get: function() { return this.get_horizontalGap() }, set: function(value) { return this.set_horizontalGap(value); } });Object.defineProperty(feathers.layout.CalendarGridLayout.prototype, "verticalGap", { get: function() { return this.get_verticalGap() }, set: function(value) { return this.set_verticalGap(value); } });Object.defineProperty(feathers.controls.ComboBox.prototype, "stageFocusTarget", { get: function() { return this.get_stageFocusTarget() }, set: function(value) { return this.set_stageFocusTarget(value); } });Object.defineProperty(feathers.controls.ComboBox.prototype, "dataProvider", { get: function() { return this.get_dataProvider() }, set: function(value) { return this.set_dataProvider(value); } });Object.defineProperty(feathers.controls.ComboBox.prototype, "allowCustomUserValue", { get: function() { return this.get_allowCustomUserValue() }, set: function(value) { return this.set_allowCustomUserValue(value); } });Object.defineProperty(feathers.controls.ComboBox.prototype, "selectedIndex", { get: function() { return this.get_selectedIndex() }, set: function(value) { return this.set_selectedIndex(value); } });Object.defineProperty(feathers.controls.ComboBox.prototype, "maxSelectedIndex", { get: function() { return this.get_maxSelectedIndex() }, set: function(value) { return this.set_maxSelectedIndex(value); } });Object.defineProperty(feathers.controls.ComboBox.prototype, "selectedItem", { get: function() { return this.get_selectedItem() }, set: function(value) { return this.set_selectedItem(value); } });Object.defineProperty(feathers.controls.ComboBox.prototype, "prompt", { get: function() { return this.get_prompt() }, set: function(value) { return this.set_prompt(value); } });Object.defineProperty(feathers.controls.ComboBox.prototype, "itemRendererRecycler", { get: function() { return this.get_itemRendererRecycler() }, set: function(value) { return this.set_itemRendererRecycler(value); } });Object.defineProperty(feathers.controls.ComboBox.prototype, "popUpAdapter", { get: function() { return this.get_popUpAdapter() }, set: function(value) { return this.set_popUpAdapter(value); } });Object.defineProperty(feathers.controls.ComboBox.prototype, "customTextInputVariant", { get: function() { return this.get_customTextInputVariant() }, set: function(value) { return this.set_customTextInputVariant(value); } });Object.defineProperty(feathers.controls.ComboBox.prototype, "customButtonVariant", { get: function() { return this.get_customButtonVariant() }, set: function(value) { return this.set_customButtonVariant(value); } });Object.defineProperty(feathers.controls.ComboBox.prototype, "customListViewVariant", { get: function() { return this.get_customListViewVariant() }, set: function(value) { return this.set_customListViewVariant(value); } });Object.defineProperty(feathers.controls.ComboBox.prototype, "buttonFactory", { get: function() { return this.get_buttonFactory() }, set: function(value) { return this.set_buttonFactory(value); } });Object.defineProperty(feathers.controls.ComboBox.prototype, "textInputFactory", { get: function() { return this.get_textInputFactory() }, set: function(value) { return this.set_textInputFactory(value); } });Object.defineProperty(feathers.controls.ComboBox.prototype, "listViewFactory", { get: function() { return this.get_listViewFactory() }, set: function(value) { return this.set_listViewFactory(value); } });Object.defineProperty(feathers.controls.ComboBox.prototype, "open", { get: function() { return this.get_open() }, set: function(value) { return this.set_open(value); } });Object.defineProperty(feathers.controls.dataRenderers.IGridViewCellRenderer.prototype, "column", { get: function() { return this.get_column() }, set: function(value) { return this.set_column(value); } });Object.defineProperty(feathers.controls.dataRenderers.IGridViewCellRenderer.prototype, "columnIndex", { get: function() { return this.get_columnIndex() }, set: function(value) { return this.set_columnIndex(value); } });Object.defineProperty(feathers.controls.dataRenderers.IGridViewCellRenderer.prototype, "rowIndex", { get: function() { return this.get_rowIndex() }, set: function(value) { return this.set_rowIndex(value); } });Object.defineProperty(feathers.controls.dataRenderers.IGridViewCellRenderer.prototype, "gridViewOwner", { get: function() { return this.get_gridViewOwner() }, set: function(value) { return this.set_gridViewOwner(value); } });Object.defineProperty(feathers.layout.VDividedBoxLayout.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.layout.VDividedBoxLayout.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.layout.VDividedBoxLayout.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.layout.VDividedBoxLayout.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.layout.VDividedBoxLayout.prototype, "horizontalAlign", { get: function() { return this.get_horizontalAlign() }, set: function(value) { return this.set_horizontalAlign(value); } });Object.defineProperty(feathers.layout.VDividedBoxLayout.prototype, "customItemHeights", { get: function() { return this.get_customItemHeights() }, set: function(value) { return this.set_customItemHeights(value); } });Object.defineProperty(feathers.layout.VDividedBoxLayout.prototype, "fallbackFluidIndex", { get: function() { return this.get_fallbackFluidIndex() }, set: function(value) { return this.set_fallbackFluidIndex(value); } });Object.defineProperty(feathers.core.IFocusContainer.prototype, "childFocusEnabled", { get: function() { return this.get_childFocusEnabled() }, set: function(value) { return this.set_childFocusEnabled(value); } });Object.defineProperty(feathers.core.IStateObserver.prototype, "stateContext", { get: function() { return this.get_stateContext() }, set: function(value) { return this.set_stateContext(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "content", { get: function() { return this.get_content() }, set: function(value) { return this.set_content(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "origin", { get: function() { return this.get_origin() }, set: function(value) { return this.set_origin(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "gap", { get: function() { return this.get_gap() }, set: function(value) { return this.set_gap(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "marginTop", { get: function() { return this.get_marginTop() }, set: function(value) { return this.set_marginTop(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "marginRight", { get: function() { return this.get_marginRight() }, set: function(value) { return this.set_marginRight(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "marginBottom", { get: function() { return this.get_marginBottom() }, set: function(value) { return this.set_marginBottom(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "marginLeft", { get: function() { return this.get_marginLeft() }, set: function(value) { return this.set_marginLeft(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "horizontalAlign", { get: function() { return this.get_horizontalAlign() }, set: function(value) { return this.set_horizontalAlign(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "verticalAlign", { get: function() { return this.get_verticalAlign() }, set: function(value) { return this.set_verticalAlign(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "arrowPosition", { get: function() { return this.get_arrowPosition() }, set: function(value) { return this.set_arrowPosition(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "backgroundSkin", { get: function() { return this.get_backgroundSkin() }, set: function(value) { return this.set_backgroundSkin(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "topArrowSkin", { get: function() { return this.get_topArrowSkin() }, set: function(value) { return this.set_topArrowSkin(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "rightArrowSkin", { get: function() { return this.get_rightArrowSkin() }, set: function(value) { return this.set_rightArrowSkin(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "bottomArrowSkin", { get: function() { return this.get_bottomArrowSkin() }, set: function(value) { return this.set_bottomArrowSkin(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "leftArrowSkin", { get: function() { return this.get_leftArrowSkin() }, set: function(value) { return this.set_leftArrowSkin(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "topArrowGap", { get: function() { return this.get_topArrowGap() }, set: function(value) { return this.set_topArrowGap(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "rightArrowGap", { get: function() { return this.get_rightArrowGap() }, set: function(value) { return this.set_rightArrowGap(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "bottomArrowGap", { get: function() { return this.get_bottomArrowGap() }, set: function(value) { return this.set_bottomArrowGap(value); } });Object.defineProperty(feathers.controls.Callout.prototype, "leftArrowGap", { get: function() { return this.get_leftArrowGap() }, set: function(value) { return this.set_leftArrowGap(value); } });Object.defineProperty(feathers.core.DefaultPopUpManager.prototype, "root", { get: function() { return this.get_root() }, set: function(value) { return this.set_root(value); } });Object.defineProperty(feathers.core.DefaultPopUpManager.prototype, "overlayFactory", { get: function() { return this.get_overlayFactory() }, set: function(value) { return this.set_overlayFactory(value); } });Object.defineProperty(feathers.core.DefaultPopUpManager.prototype, "popUpCount", { get: function() { return this.get_popUpCount() }, set: function(value) { return this.set_popUpCount(value); } });Object.defineProperty(feathers.core.DefaultPopUpManager.prototype, "topLevelPopUpCount", { get: function() { return this.get_topLevelPopUpCount() }, set: function(value) { return this.set_topLevelPopUpCount(value); } });Object.defineProperty(feathers.controls.Header.prototype, "text", { get: function() { return this.get_text() }, set: function(value) { return this.set_text(value); } });Object.defineProperty(feathers.controls.Header.prototype, "baseline", { get: function() { return this.get_baseline() }, set: function(value) { return this.set_baseline(value); } });Object.defineProperty(feathers.controls.Header.prototype, "htmlText", { get: function() { return this.get_htmlText() }, set: function(value) { return this.set_htmlText(value); } });Object.defineProperty(feathers.controls.Header.prototype, "textFormat", { get: function() { return this.get_textFormat() }, set: function(value) { return this.set_textFormat(value); } });Object.defineProperty(feathers.controls.Header.prototype, "embedFonts", { get: function() { return this.get_embedFonts() }, set: function(value) { return this.set_embedFonts(value); } });Object.defineProperty(feathers.controls.Header.prototype, "disabledTextFormat", { get: function() { return this.get_disabledTextFormat() }, set: function(value) { return this.set_disabledTextFormat(value); } });Object.defineProperty(feathers.controls.Header.prototype, "backgroundSkin", { get: function() { return this.get_backgroundSkin() }, set: function(value) { return this.set_backgroundSkin(value); } });Object.defineProperty(feathers.controls.Header.prototype, "disabledBackgroundSkin", { get: function() { return this.get_disabledBackgroundSkin() }, set: function(value) { return this.set_disabledBackgroundSkin(value); } });Object.defineProperty(feathers.controls.Header.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.controls.Header.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.controls.Header.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.controls.Header.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.controls.Header.prototype, "minGap", { get: function() { return this.get_minGap() }, set: function(value) { return this.set_minGap(value); } });Object.defineProperty(feathers.controls.Header.prototype, "verticalAlign", { get: function() { return this.get_verticalAlign() }, set: function(value) { return this.set_verticalAlign(value); } });Object.defineProperty(feathers.controls.Header.prototype, "leftView", { get: function() { return this.get_leftView() }, set: function(value) { return this.set_leftView(value); } });Object.defineProperty(feathers.controls.Header.prototype, "rightView", { get: function() { return this.get_rightView() }, set: function(value) { return this.set_rightView(value); } });Object.defineProperty(feathers.core.DefaultFocusManager.prototype, "enabled", { get: function() { return this.get_enabled() }, set: function(value) { return this.set_enabled(value); } });Object.defineProperty(feathers.core.DefaultFocusManager.prototype, "root", { get: function() { return this.get_root() }, set: function(value) { return this.set_root(value); } });Object.defineProperty(feathers.core.DefaultFocusManager.prototype, "focusPane", { get: function() { return this.get_focusPane() }, set: function(value) { return this.set_focusPane(value); } });Object.defineProperty(feathers.core.DefaultFocusManager.prototype, "showFocusIndicator", { get: function() { return this.get_showFocusIndicator() }, set: function(value) { return this.set_showFocusIndicator(value); } });Object.defineProperty(feathers.core.DefaultFocusManager.prototype, "focus", { get: function() { return this.get_focus() }, set: function(value) { return this.set_focus(value); } });Object.defineProperty(feathers.utils.KeyToState.prototype, "target", { get: function() { return this.get_target() }, set: function(value) { return this.set_target(value); } });Object.defineProperty(feathers.utils.KeyToState.prototype, "callback", { get: function() { return this.get_callback() }, set: function(value) { return this.set_callback(value); } });Object.defineProperty(feathers.utils.KeyToState.prototype, "currentState", { get: function() { return this.get_currentState() }, set: function(value) { return this.set_currentState(value); } });Object.defineProperty(feathers.utils.KeyToState.prototype, "upState", { get: function() { return this.get_upState() }, set: function(value) { return this.set_upState(value); } });Object.defineProperty(feathers.utils.KeyToState.prototype, "downState", { get: function() { return this.get_downState() }, set: function(value) { return this.set_downState(value); } });Object.defineProperty(feathers.utils.KeyToState.prototype, "enabled", { get: function() { return this.get_enabled() }, set: function(value) { return this.set_enabled(value); } });Object.defineProperty(feathers.core.IFocusObject.prototype, "focusEnabled", { get: function() { return this.get_focusEnabled() }, set: function(value) { return this.set_focusEnabled(value); } });Object.defineProperty(feathers.core.IFocusObject.prototype, "focusOwner", { get: function() { return this.get_focusOwner() }, set: function(value) { return this.set_focusOwner(value); } });Object.defineProperty(feathers.controls.dataRenderers.IHierarchicalItemRenderer.prototype, "branch", { get: function() { return this.get_branch() }, set: function(value) { return this.set_branch(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "childFocusEnabled", { get: function() { return this.get_childFocusEnabled() }, set: function(value) { return this.set_childFocusEnabled(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "dataProvider", { get: function() { return this.get_dataProvider() }, set: function(value) { return this.set_dataProvider(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "columns", { get: function() { return this.get_columns() }, set: function(value) { return this.set_columns(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "headerRendererRecycler", { get: function() { return this.get_headerRendererRecycler() }, set: function(value) { return this.set_headerRendererRecycler(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "forceItemStateUpdate", { get: function() { return this.get_forceItemStateUpdate() }, set: function(value) { return this.set_forceItemStateUpdate(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "customCellRendererVariant", { get: function() { return this.get_customCellRendererVariant() }, set: function(value) { return this.set_customCellRendererVariant(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "customHeaderRendererVariant", { get: function() { return this.get_customHeaderRendererVariant() }, set: function(value) { return this.set_customHeaderRendererVariant(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "headerDividerFactory", { get: function() { return this.get_headerDividerFactory() }, set: function(value) { return this.set_headerDividerFactory(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "customHeaderDividerVariant", { get: function() { return this.get_customHeaderDividerVariant() }, set: function(value) { return this.set_customHeaderDividerVariant(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "columnDividerFactory", { get: function() { return this.get_columnDividerFactory() }, set: function(value) { return this.set_columnDividerFactory(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "customColumnDividerVariant", { get: function() { return this.get_customColumnDividerVariant() }, set: function(value) { return this.set_customColumnDividerVariant(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "selectedIndex", { get: function() { return this.get_selectedIndex() }, set: function(value) { return this.set_selectedIndex(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "maxSelectedIndex", { get: function() { return this.get_maxSelectedIndex() }, set: function(value) { return this.set_maxSelectedIndex(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "selectedItem", { get: function() { return this.get_selectedItem() }, set: function(value) { return this.set_selectedItem(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "allowMultipleSelection", { get: function() { return this.get_allowMultipleSelection() }, set: function(value) { return this.set_allowMultipleSelection(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "selectedIndices", { get: function() { return this.get_selectedIndices() }, set: function(value) { return this.set_selectedIndices(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "selectedItems", { get: function() { return this.get_selectedItems() }, set: function(value) { return this.set_selectedItems(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "layout", { get: function() { return this.get_layout() }, set: function(value) { return this.set_layout(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "virtualLayout", { get: function() { return this.get_virtualLayout() }, set: function(value) { return this.set_virtualLayout(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "cellRendererRecycler", { get: function() { return this.get_cellRendererRecycler() }, set: function(value) { return this.set_cellRendererRecycler(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "sortableColumns", { get: function() { return this.get_sortableColumns() }, set: function(value) { return this.set_sortableColumns(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "resizableColumns", { get: function() { return this.get_resizableColumns() }, set: function(value) { return this.set_resizableColumns(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "columnResizeSkin", { get: function() { return this.get_columnResizeSkin() }, set: function(value) { return this.set_columnResizeSkin(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "sortOrder", { get: function() { return this.get_sortOrder() }, set: function(value) { return this.set_sortOrder(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "sortedColumn", { get: function() { return this.get_sortedColumn() }, set: function(value) { return this.set_sortedColumn(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "selectable", { get: function() { return this.get_selectable() }, set: function(value) { return this.set_selectable(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "extendedScrollBarY", { get: function() { return this.get_extendedScrollBarY() }, set: function(value) { return this.set_extendedScrollBarY(value); } });Object.defineProperty(feathers.controls.GridView.prototype, "showHeaderDividersOnlyWhenResizable", { get: function() { return this.get_showHeaderDividersOnlyWhenResizable() }, set: function(value) { return this.set_showHeaderDividersOnlyWhenResizable(value); } });Object.defineProperty(feathers.controls.dataRenderers.IGridViewHeaderRenderer.prototype, "column", { get: function() { return this.get_column() }, set: function(value) { return this.set_column(value); } });Object.defineProperty(feathers.controls.dataRenderers.IGridViewHeaderRenderer.prototype, "columnIndex", { get: function() { return this.get_columnIndex() }, set: function(value) { return this.set_columnIndex(value); } });Object.defineProperty(feathers.controls.dataRenderers.IGridViewHeaderRenderer.prototype, "gridViewOwner", { get: function() { return this.get_gridViewOwner() }, set: function(value) { return this.set_gridViewOwner(value); } });Object.defineProperty(feathers.controls.ActivityIndicator.prototype, "activitySkin", { get: function() { return this.get_activitySkin() }, set: function(value) { return this.set_activitySkin(value); } });Object.defineProperty(feathers.controls.ActivityIndicator.prototype, "indeterminateDuration", { get: function() { return this.get_indeterminateDuration() }, set: function(value) { return this.set_indeterminateDuration(value); } });Object.defineProperty(feathers.layout.ILayoutIndexObject.prototype, "layoutIndex", { get: function() { return this.get_layoutIndex() }, set: function(value) { return this.set_layoutIndex(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "textField", { get: function() { return this.get_textField() }, set: function(value) { return this.set_textField(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "textFieldType", { get: function() { return this.get_textFieldType() }, set: function(value) { return this.set_textFieldType(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "text", { get: function() { return this.get_text() }, set: function(value) { return this.set_text(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "baseline", { get: function() { return this.get_baseline() }, set: function(value) { return this.set_baseline(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "wordWrap", { get: function() { return this.get_wordWrap() }, set: function(value) { return this.set_wordWrap(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "multiline", { get: function() { return this.get_multiline() }, set: function(value) { return this.set_multiline(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "restrict", { get: function() { return this.get_restrict() }, set: function(value) { return this.set_restrict(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "displayAsPassword", { get: function() { return this.get_displayAsPassword() }, set: function(value) { return this.set_displayAsPassword(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "maxChars", { get: function() { return this.get_maxChars() }, set: function(value) { return this.set_maxChars(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "selectable", { get: function() { return this.get_selectable() }, set: function(value) { return this.set_selectable(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "smoothScrolling", { get: function() { return this.get_smoothScrolling() }, set: function(value) { return this.set_smoothScrolling(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "textFormat", { get: function() { return this.get_textFormat() }, set: function(value) { return this.set_textFormat(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "embedFonts", { get: function() { return this.get_embedFonts() }, set: function(value) { return this.set_embedFonts(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "stageFocusTarget", { get: function() { return this.get_stageFocusTarget() }, set: function(value) { return this.set_stageFocusTarget(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "minVisibleWidth", { get: function() { return this.get_minVisibleWidth() }, set: function(value) { return this.set_minVisibleWidth(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "maxVisibleWidth", { get: function() { return this.get_maxVisibleWidth() }, set: function(value) { return this.set_maxVisibleWidth(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "visibleWidth", { get: function() { return this.get_visibleWidth() }, set: function(value) { return this.set_visibleWidth(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "minVisibleHeight", { get: function() { return this.get_minVisibleHeight() }, set: function(value) { return this.set_minVisibleHeight(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "maxVisibleHeight", { get: function() { return this.get_maxVisibleHeight() }, set: function(value) { return this.set_maxVisibleHeight(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "visibleHeight", { get: function() { return this.get_visibleHeight() }, set: function(value) { return this.set_visibleHeight(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "scrollX", { get: function() { return this.get_scrollX() }, set: function(value) { return this.set_scrollX(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "scrollY", { get: function() { return this.get_scrollY() }, set: function(value) { return this.set_scrollY(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "selectionAnchorIndex", { get: function() { return this.get_selectionAnchorIndex() }, set: function(value) { return this.set_selectionAnchorIndex(value); } });Object.defineProperty(feathers.controls.supportClasses.TextFieldViewPort.prototype, "selectionActiveIndex", { get: function() { return this.get_selectionActiveIndex() }, set: function(value) { return this.set_selectionActiveIndex(value); } });Object.defineProperty(feathers.data.ISortOrderObserver.prototype, "sortOrder", { get: function() { return this.get_sortOrder() }, set: function(value) { return this.set_sortOrder(value); } });Object.defineProperty(feathers.controls.PageIndicator.prototype, "selectedIndex", { get: function() { return this.get_selectedIndex() }, set: function(value) { return this.set_selectedIndex(value); } });Object.defineProperty(feathers.controls.PageIndicator.prototype, "maxSelectedIndex", { get: function() { return this.get_maxSelectedIndex() }, set: function(value) { return this.set_maxSelectedIndex(value); } });Object.defineProperty(feathers.controls.PageIndicator.prototype, "customToggleButtonVariant", { get: function() { return this.get_customToggleButtonVariant() }, set: function(value) { return this.set_customToggleButtonVariant(value); } });Object.defineProperty(feathers.controls.PageIndicator.prototype, "toggleButtonRecycler", { get: function() { return this.get_toggleButtonRecycler() }, set: function(value) { return this.set_toggleButtonRecycler(value); } });Object.defineProperty(feathers.controls.PageIndicator.prototype, "layout", { get: function() { return this.get_layout() }, set: function(value) { return this.set_layout(value); } });Object.defineProperty(feathers.controls.PageIndicator.prototype, "backgroundSkin", { get: function() { return this.get_backgroundSkin() }, set: function(value) { return this.set_backgroundSkin(value); } });Object.defineProperty(feathers.controls.PageIndicator.prototype, "disabledBackgroundSkin", { get: function() { return this.get_disabledBackgroundSkin() }, set: function(value) { return this.set_disabledBackgroundSkin(value); } });Object.defineProperty(feathers.controls.PageIndicator.prototype, "interactionMode", { get: function() { return this.get_interactionMode() }, set: function(value) { return this.set_interactionMode(value); } });Object.defineProperty(feathers.controls.navigators.RouterNavigator.prototype, "forwardTransition", { get: function() { return this.get_forwardTransition() }, set: function(value) { return this.set_forwardTransition(value); } });Object.defineProperty(feathers.controls.navigators.RouterNavigator.prototype, "backTransition", { get: function() { return this.get_backTransition() }, set: function(value) { return this.set_backTransition(value); } });Object.defineProperty(feathers.controls.navigators.RouterNavigator.prototype, "replaceTransition", { get: function() { return this.get_replaceTransition() }, set: function(value) { return this.set_replaceTransition(value); } });Object.defineProperty(feathers.controls.navigators.RouterNavigator.prototype, "preferHashRouting", { get: function() { return this.get_preferHashRouting() }, set: function(value) { return this.set_preferHashRouting(value); } });Object.defineProperty(feathers.controls.navigators.RouterNavigator.prototype, "location", { get: function() { return this.get_location() }, set: function(value) { return this.set_location(value); } });Object.defineProperty(feathers.controls.navigators.RouterNavigator.prototype, "pathname", { get: function() { return this.get_pathname() }, set: function(value) { return this.set_pathname(value); } });Object.defineProperty(feathers.core.MeasureSprite.prototype, "explicitWidth", { get: function() { return this.get_explicitWidth() }, set: function(value) { return this.set_explicitWidth(value); } });Object.defineProperty(feathers.core.MeasureSprite.prototype, "explicitHeight", { get: function() { return this.get_explicitHeight() }, set: function(value) { return this.set_explicitHeight(value); } });Object.defineProperty(feathers.core.MeasureSprite.prototype, "explicitMinWidth", { get: function() { return this.get_explicitMinWidth() }, set: function(value) { return this.set_explicitMinWidth(value); } });Object.defineProperty(feathers.core.MeasureSprite.prototype, "explicitMinHeight", { get: function() { return this.get_explicitMinHeight() }, set: function(value) { return this.set_explicitMinHeight(value); } });Object.defineProperty(feathers.core.MeasureSprite.prototype, "minWidth", { get: function() { return this.get_minWidth() }, set: function(value) { return this.set_minWidth(value); } });Object.defineProperty(feathers.core.MeasureSprite.prototype, "minHeight", { get: function() { return this.get_minHeight() }, set: function(value) { return this.set_minHeight(value); } });Object.defineProperty(feathers.core.MeasureSprite.prototype, "explicitMaxWidth", { get: function() { return this.get_explicitMaxWidth() }, set: function(value) { return this.set_explicitMaxWidth(value); } });Object.defineProperty(feathers.core.MeasureSprite.prototype, "explicitMaxHeight", { get: function() { return this.get_explicitMaxHeight() }, set: function(value) { return this.set_explicitMaxHeight(value); } });Object.defineProperty(feathers.core.MeasureSprite.prototype, "maxWidth", { get: function() { return this.get_maxWidth() }, set: function(value) { return this.set_maxWidth(value); } });Object.defineProperty(feathers.core.MeasureSprite.prototype, "maxHeight", { get: function() { return this.get_maxHeight() }, set: function(value) { return this.set_maxHeight(value); } });Object.defineProperty(feathers.controls.PopUpDatePicker.prototype, "stageFocusTarget", { get: function() { return this.get_stageFocusTarget() }, set: function(value) { return this.set_stageFocusTarget(value); } });Object.defineProperty(feathers.controls.PopUpDatePicker.prototype, "selectedDate", { get: function() { return this.get_selectedDate() }, set: function(value) { return this.set_selectedDate(value); } });Object.defineProperty(feathers.controls.PopUpDatePicker.prototype, "prompt", { get: function() { return this.get_prompt() }, set: function(value) { return this.set_prompt(value); } });Object.defineProperty(feathers.controls.PopUpDatePicker.prototype, "popUpAdapter", { get: function() { return this.get_popUpAdapter() }, set: function(value) { return this.set_popUpAdapter(value); } });Object.defineProperty(feathers.controls.PopUpDatePicker.prototype, "customTextInputVariant", { get: function() { return this.get_customTextInputVariant() }, set: function(value) { return this.set_customTextInputVariant(value); } });Object.defineProperty(feathers.controls.PopUpDatePicker.prototype, "customButtonVariant", { get: function() { return this.get_customButtonVariant() }, set: function(value) { return this.set_customButtonVariant(value); } });Object.defineProperty(feathers.controls.PopUpDatePicker.prototype, "customDatePickerVariant", { get: function() { return this.get_customDatePickerVariant() }, set: function(value) { return this.set_customDatePickerVariant(value); } });Object.defineProperty(feathers.controls.PopUpDatePicker.prototype, "buttonFactory", { get: function() { return this.get_buttonFactory() }, set: function(value) { return this.set_buttonFactory(value); } });Object.defineProperty(feathers.controls.PopUpDatePicker.prototype, "textInputFactory", { get: function() { return this.get_textInputFactory() }, set: function(value) { return this.set_textInputFactory(value); } });Object.defineProperty(feathers.controls.PopUpDatePicker.prototype, "datePickerFactory", { get: function() { return this.get_datePickerFactory() }, set: function(value) { return this.set_datePickerFactory(value); } });Object.defineProperty(feathers.controls.PopUpDatePicker.prototype, "requestedLocaleIDName", { get: function() { return this.get_requestedLocaleIDName() }, set: function(value) { return this.set_requestedLocaleIDName(value); } });Object.defineProperty(feathers.controls.PopUpDatePicker.prototype, "actualLocaleIDName", { get: function() { return this.get_actualLocaleIDName() }, set: function(value) { return this.set_actualLocaleIDName(value); } });Object.defineProperty(feathers.controls.PopUpDatePicker.prototype, "customMonthNames", { get: function() { return this.get_customMonthNames() }, set: function(value) { return this.set_customMonthNames(value); } });Object.defineProperty(feathers.controls.PopUpDatePicker.prototype, "customWeekdayNames", { get: function() { return this.get_customWeekdayNames() }, set: function(value) { return this.set_customWeekdayNames(value); } });Object.defineProperty(feathers.controls.PopUpDatePicker.prototype, "customStartOfWeek", { get: function() { return this.get_customStartOfWeek() }, set: function(value) { return this.set_customStartOfWeek(value); } });Object.defineProperty(feathers.controls.PopUpDatePicker.prototype, "open", { get: function() { return this.get_open() }, set: function(value) { return this.set_open(value); } });Object.defineProperty(feathers.layout.VerticalLayoutData.prototype, "percentWidth", { get: function() { return this.get_percentWidth() }, set: function(value) { return this.set_percentWidth(value); } });Object.defineProperty(feathers.layout.VerticalLayoutData.prototype, "percentHeight", { get: function() { return this.get_percentHeight() }, set: function(value) { return this.set_percentHeight(value); } });Object.defineProperty(feathers.layout.VerticalLayoutData.prototype, "marginTop", { get: function() { return this.get_marginTop() }, set: function(value) { return this.set_marginTop(value); } });Object.defineProperty(feathers.layout.VerticalLayoutData.prototype, "marginBottom", { get: function() { return this.get_marginBottom() }, set: function(value) { return this.set_marginBottom(value); } });Object.defineProperty(feathers.layout.HorizontalDistributedLayout.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.layout.HorizontalDistributedLayout.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.layout.HorizontalDistributedLayout.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.layout.HorizontalDistributedLayout.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.layout.HorizontalDistributedLayout.prototype, "gap", { get: function() { return this.get_gap() }, set: function(value) { return this.set_gap(value); } });Object.defineProperty(feathers.layout.HorizontalDistributedLayout.prototype, "maxItemWidth", { get: function() { return this.get_maxItemWidth() }, set: function(value) { return this.set_maxItemWidth(value); } });Object.defineProperty(feathers.layout.HorizontalDistributedLayout.prototype, "minItemWidth", { get: function() { return this.get_minItemWidth() }, set: function(value) { return this.set_minItemWidth(value); } });Object.defineProperty(feathers.layout.HorizontalDistributedLayout.prototype, "verticalAlign", { get: function() { return this.get_verticalAlign() }, set: function(value) { return this.set_verticalAlign(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "editable", { get: function() { return this.get_editable() }, set: function(value) { return this.set_editable(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "selectable", { get: function() { return this.get_selectable() }, set: function(value) { return this.set_selectable(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "stageFocusTarget", { get: function() { return this.get_stageFocusTarget() }, set: function(value) { return this.set_stageFocusTarget(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "currentState", { get: function() { return this.get_currentState() }, set: function(value) { return this.set_currentState(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "backgroundSkin", { get: function() { return this.get_backgroundSkin() }, set: function(value) { return this.set_backgroundSkin(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "showPromptWhenEmptyAndFocused", { get: function() { return this.get_showPromptWhenEmptyAndFocused() }, set: function(value) { return this.set_showPromptWhenEmptyAndFocused(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "leftView", { get: function() { return this.get_leftView() }, set: function(value) { return this.set_leftView(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "leftViewGap", { get: function() { return this.get_leftViewGap() }, set: function(value) { return this.set_leftViewGap(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "rightView", { get: function() { return this.get_rightView() }, set: function(value) { return this.set_rightView(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "rightViewGap", { get: function() { return this.get_rightViewGap() }, set: function(value) { return this.set_rightViewGap(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "text", { get: function() { return this.get_text() }, set: function(value) { return this.set_text(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "measureText", { get: function() { return this.get_measureText() }, set: function(value) { return this.set_measureText(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "baseline", { get: function() { return this.get_baseline() }, set: function(value) { return this.set_baseline(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "prompt", { get: function() { return this.get_prompt() }, set: function(value) { return this.set_prompt(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "restrict", { get: function() { return this.get_restrict() }, set: function(value) { return this.set_restrict(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "displayAsPassword", { get: function() { return this.get_displayAsPassword() }, set: function(value) { return this.set_displayAsPassword(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "errorString", { get: function() { return this.get_errorString() }, set: function(value) { return this.set_errorString(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "errorStringCalloutOpen", { get: function() { return this.get_errorStringCalloutOpen() }, set: function(value) { return this.set_errorStringCalloutOpen(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "textFormat", { get: function() { return this.get_textFormat() }, set: function(value) { return this.set_textFormat(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "disabledTextFormat", { get: function() { return this.get_disabledTextFormat() }, set: function(value) { return this.set_disabledTextFormat(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "promptTextFormat", { get: function() { return this.get_promptTextFormat() }, set: function(value) { return this.set_promptTextFormat(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "embedFonts", { get: function() { return this.get_embedFonts() }, set: function(value) { return this.set_embedFonts(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "verticalAlign", { get: function() { return this.get_verticalAlign() }, set: function(value) { return this.set_verticalAlign(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "scrollX", { get: function() { return this.get_scrollX() }, set: function(value) { return this.set_scrollX(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "selectionAnchorIndex", { get: function() { return this.get_selectionAnchorIndex() }, set: function(value) { return this.set_selectionAnchorIndex(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "selectionActiveIndex", { get: function() { return this.get_selectionActiveIndex() }, set: function(value) { return this.set_selectionActiveIndex(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "maxChars", { get: function() { return this.get_maxChars() }, set: function(value) { return this.set_maxChars(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "autoSizeWidth", { get: function() { return this.get_autoSizeWidth() }, set: function(value) { return this.set_autoSizeWidth(value); } });Object.defineProperty(feathers.controls.TextInput.prototype, "customErrorCalloutVariant", { get: function() { return this.get_customErrorCalloutVariant() }, set: function(value) { return this.set_customErrorCalloutVariant(value); } });Object.defineProperty(feathers.layout.VerticalListLayout.prototype, "scrollX", { get: function() { return this.get_scrollX() }, set: function(value) { return this.set_scrollX(value); } });Object.defineProperty(feathers.layout.VerticalListLayout.prototype, "scrollY", { get: function() { return this.get_scrollY() }, set: function(value) { return this.set_scrollY(value); } });Object.defineProperty(feathers.layout.VerticalListLayout.prototype, "virtualCache", { get: function() { return this.get_virtualCache() }, set: function(value) { return this.set_virtualCache(value); } });Object.defineProperty(feathers.layout.VerticalListLayout.prototype, "elasticTop", { get: function() { return this.get_elasticTop() }, set: function(value) { return this.set_elasticTop(value); } });Object.defineProperty(feathers.layout.VerticalListLayout.prototype, "elasticRight", { get: function() { return this.get_elasticRight() }, set: function(value) { return this.set_elasticRight(value); } });Object.defineProperty(feathers.layout.VerticalListLayout.prototype, "elasticBottom", { get: function() { return this.get_elasticBottom() }, set: function(value) { return this.set_elasticBottom(value); } });Object.defineProperty(feathers.layout.VerticalListLayout.prototype, "elasticLeft", { get: function() { return this.get_elasticLeft() }, set: function(value) { return this.set_elasticLeft(value); } });Object.defineProperty(feathers.layout.VerticalListLayout.prototype, "requestedRowCount", { get: function() { return this.get_requestedRowCount() }, set: function(value) { return this.set_requestedRowCount(value); } });Object.defineProperty(feathers.layout.VerticalListLayout.prototype, "requestedMinRowCount", { get: function() { return this.get_requestedMinRowCount() }, set: function(value) { return this.set_requestedMinRowCount(value); } });Object.defineProperty(feathers.layout.VerticalListLayout.prototype, "requestedMaxRowCount", { get: function() { return this.get_requestedMaxRowCount() }, set: function(value) { return this.set_requestedMaxRowCount(value); } });Object.defineProperty(feathers.layout.VerticalListLayout.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.layout.VerticalListLayout.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.layout.VerticalListLayout.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.layout.VerticalListLayout.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.layout.VerticalListLayout.prototype, "gap", { get: function() { return this.get_gap() }, set: function(value) { return this.set_gap(value); } });Object.defineProperty(feathers.layout.VerticalListLayout.prototype, "minGap", { get: function() { return this.get_minGap() }, set: function(value) { return this.set_minGap(value); } });Object.defineProperty(feathers.layout.VerticalListLayout.prototype, "verticalAlign", { get: function() { return this.get_verticalAlign() }, set: function(value) { return this.set_verticalAlign(value); } });Object.defineProperty(feathers.layout.VerticalListLayout.prototype, "contentJustify", { get: function() { return this.get_contentJustify() }, set: function(value) { return this.set_contentJustify(value); } });Object.defineProperty(feathers.layout.VerticalListLayout.prototype, "widthResetEnabled", { get: function() { return this.get_widthResetEnabled() }, set: function(value) { return this.set_widthResetEnabled(value); } });Object.defineProperty(feathers.controls.popups.DropDownPopUpAdapter.prototype, "active", { get: function() { return this.get_active() }, set: function(value) { return this.set_active(value); } });Object.defineProperty(feathers.controls.popups.DropDownPopUpAdapter.prototype, "gap", { get: function() { return this.get_gap() }, set: function(value) { return this.set_gap(value); } });Object.defineProperty(feathers.controls.popups.DropDownPopUpAdapter.prototype, "fitContentToOriginWidth", { get: function() { return this.get_fitContentToOriginWidth() }, set: function(value) { return this.set_fitContentToOriginWidth(value); } });Object.defineProperty(feathers.controls.popups.DropDownPopUpAdapter.prototype, "persistent", { get: function() { return this.get_persistent() }, set: function(value) { return this.set_persistent(value); } });Object.defineProperty(feathers.core.IScaleManager.prototype, "target", { get: function() { return this.get_target() }, set: function(value) { return this.set_target(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseProgressBar.prototype, "value", { get: function() { return this.get_value() }, set: function(value) { return this.set_value(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseProgressBar.prototype, "minimum", { get: function() { return this.get_minimum() }, set: function(value) { return this.set_minimum(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseProgressBar.prototype, "maximum", { get: function() { return this.get_maximum() }, set: function(value) { return this.set_maximum(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseProgressBar.prototype, "backgroundSkin", { get: function() { return this.get_backgroundSkin() }, set: function(value) { return this.set_backgroundSkin(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseProgressBar.prototype, "disabledBackgroundSkin", { get: function() { return this.get_disabledBackgroundSkin() }, set: function(value) { return this.set_disabledBackgroundSkin(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseProgressBar.prototype, "fillSkin", { get: function() { return this.get_fillSkin() }, set: function(value) { return this.set_fillSkin(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseProgressBar.prototype, "disabledFillSkin", { get: function() { return this.get_disabledFillSkin() }, set: function(value) { return this.set_disabledFillSkin(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseProgressBar.prototype, "fillMode", { get: function() { return this.get_fillMode() }, set: function(value) { return this.set_fillMode(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseProgressBar.prototype, "paddingTop", { get: function() { return this.get_paddingTop() }, set: function(value) { return this.set_paddingTop(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseProgressBar.prototype, "paddingRight", { get: function() { return this.get_paddingRight() }, set: function(value) { return this.set_paddingRight(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseProgressBar.prototype, "paddingBottom", { get: function() { return this.get_paddingBottom() }, set: function(value) { return this.set_paddingBottom(value); } });Object.defineProperty(feathers.controls.supportClasses.BaseProgressBar.prototype, "paddingLeft", { get: function() { return this.get_paddingLeft() }, set: function(value) { return this.set_paddingLeft(value); } });Object.defineProperty(feathers.layout.IScrollLayout.prototype, "scrollX", { get: function() { return this.get_scrollX() }, set: function(value) { return this.set_scrollX(value); } });Object.defineProperty(feathers.layout.IScrollLayout.prototype, "scrollY", { get: function() { return this.get_scrollY() }, set: function(value) { return this.set_scrollY(value); } });Object.defineProperty(feathers.layout.IScrollLayout.prototype, "elasticTop", { get: function() { return this.get_elasticTop() }, set: function(value) { return this.set_elasticTop(value); } });Object.defineProperty(feathers.layout.IScrollLayout.prototype, "elasticRight", { get: function() { return this.get_elasticRight() }, set: function(value) { return this.set_elasticRight(value); } });Object.defineProperty(feathers.layout.IScrollLayout.prototype, "elasticBottom", { get: function() { return this.get_elasticBottom() }, set: function(value) { return this.set_elasticBottom(value); } });Object.defineProperty(feathers.layout.IScrollLayout.prototype, "elasticLeft", { get: function() { return this.get_elasticLeft() }, set: function(value) { return this.set_elasticLeft(value); } });Object.defineProperty(feathers.core.IIndexSelector.prototype, "selectedIndex", { get: function() { return this.get_selectedIndex() }, set: function(value) { return this.set_selectedIndex(value); } });Object.defineProperty(feathers.core.IIndexSelector.prototype, "maxSelectedIndex", { get: function() { return this.get_maxSelectedIndex() }, set: function(value) { return this.set_maxSelectedIndex(value); } });Object.defineProperty(feathers.controls.dataRenderers.HierarchicalItemRenderer.prototype, "hierarchyDepth", { get: function() { return this.get_hierarchyDepth() }, set: function(value) { return this.set_hierarchyDepth(value); } });Object.defineProperty(feathers.controls.dataRenderers.HierarchicalItemRenderer.prototype, "branch", { get: function() { return this.get_branch() }, set: function(value) { return this.set_branch(value); } });Object.defineProperty(feathers.controls.dataRenderers.HierarchicalItemRenderer.prototype, "opened", { get: function() { return this.get_opened() }, set: function(value) { return this.set_opened(value); } });Object.defineProperty(feathers.controls.dataRenderers.HierarchicalItemRenderer.prototype, "showHierarchy", { get: function() { return this.get_showHierarchy() }, set: function(value) { return this.set_showHierarchy(value); } });Object.defineProperty(feathers.controls.dataRenderers.HierarchicalItemRenderer.prototype, "indentation", { get: function() { return this.get_indentation() }, set: function(value) { return this.set_indentation(value); } });Object.defineProperty(feathers.controls.dataRenderers.HierarchicalItemRenderer.prototype, "branchIcon", { get: function() { return this.get_branchIcon() }, set: function(value) { return this.set_branchIcon(value); } });Object.defineProperty(feathers.controls.dataRenderers.HierarchicalItemRenderer.prototype, "branchOpenIcon", { get: function() { return this.get_branchOpenIcon() }, set: function(value) { return this.set_branchOpenIcon(value); } });Object.defineProperty(feathers.controls.dataRenderers.HierarchicalItemRenderer.prototype, "branchClosedIcon", { get: function() { return this.get_branchClosedIcon() }, set: function(value) { return this.set_branchClosedIcon(value); } });Object.defineProperty(feathers.controls.dataRenderers.HierarchicalItemRenderer.prototype, "leafIcon", { get: function() { return this.get_leafIcon() }, set: function(value) { return this.set_leafIcon(value); } });Object.defineProperty(feathers.controls.dataRenderers.HierarchicalItemRenderer.prototype, "customDisclosureButtonVariant", { get: function() { return this.get_customDisclosureButtonVariant() }, set: function(value) { return this.set_customDisclosureButtonVariant(value); } });Object.defineProperty(feathers.controls.dataRenderers.HierarchicalItemRenderer.prototype, "disclosureButtonFactory", { get: function() { return this.get_disclosureButtonFactory() }, set: function(value) { return this.set_disclosureButtonFactory(value); } });Object.defineProperty(feathers.controls.IToggle.prototype, "selected", { get: function() { return this.get_selected() }, set: function(value) { return this.set_selected(value); } });Object.defineProperty(feathers.controls.dataRenderers.IListViewItemRenderer.prototype, "index", { get: function() { return this.get_index() }, set: function(value) { return this.set_index(value); } });Object.defineProperty(feathers.controls.dataRenderers.IListViewItemRenderer.prototype, "listViewOwner", { get: function() { return this.get_listViewOwner() }, set: function(value) { return this.set_listViewOwner(value); } });Object.defineProperty(feathers.controls.IRange.prototype, "value", { get: function() { return this.get_value() }, set: function(value) { return this.set_value(value); } });Object.defineProperty(feathers.controls.IRange.prototype, "minimum", { get: function() { return this.get_minimum() }, set: function(value) { return this.set_minimum(value); } });Object.defineProperty(feathers.controls.IRange.prototype, "maximum", { get: function() { return this.get_maximum() }, set: function(value) { return this.set_maximum(value); } });Object.defineProperty(feathers.layout.IVirtualLayout.prototype, "virtualCache", { get: function() { return this.get_virtualCache() }, set: function(value) { return this.set_virtualCache(value); } });Object.defineProperty(feathers.data.IFlatCollection.prototype, "length", { get: function() { return this.get_length() }, set: function(value) { return this.set_length(value); } });Object.defineProperty(feathers.data.IFlatCollection.prototype, "filterFunction", { get: function() { return this.get_filterFunction() }, set: function(value) { return this.set_filterFunction(value); } });Object.defineProperty(feathers.data.IFlatCollection.prototype, "sortCompareFunction", { get: function() { return this.get_sortCompareFunction() }, set: function(value) { return this.set_sortCompareFunction(value); } });Object.defineProperty(feathers.controls.dataRenderers.IHierarchicalDepthItemRenderer.prototype, "hierarchyDepth", { get: function() { return this.get_hierarchyDepth() }, set: function(value) { return this.set_hierarchyDepth(value); } });Object.defineProperty(feathers.controls.popups.IPopUpAdapter.prototype, "active", { get: function() { return this.get_active() }, set: function(value) { return this.set_active(value); } });Object.defineProperty(feathers.controls.popups.IPopUpAdapter.prototype, "persistent", { get: function() { return this.get_persistent() }, set: function(value) { return this.set_persistent(value); } });Object.defineProperty(feathers.core.ScreenDensityScaleManager.prototype, "target", { get: function() { return this.get_target() }, set: function(value) { return this.set_target(value); } });Object.defineProperty(feathers.core.ScreenDensityScaleManager.prototype, "scaler", { get: function() { return this.get_scaler() }, set: function(value) { return this.set_scaler(value); } });Object.defineProperty(feathers.utils.PointerToState.prototype, "target", { get: function() { return this.get_target() }, set: function(value) { return this.set_target(value); } });Object.defineProperty(feathers.utils.PointerToState.prototype, "stateContext", { get: function() { return this.get_stateContext() }, set: function(value) { return this.set_stateContext(value); } });Object.defineProperty(feathers.utils.PointerToState.prototype, "callback", { get: function() { return this.get_callback() }, set: function(value) { return this.set_callback(value); } });Object.defineProperty(feathers.utils.PointerToState.prototype, "currentState", { get: function() { return this.get_currentState() }, set: function(value) { return this.set_currentState(value); } });Object.defineProperty(feathers.utils.PointerToState.prototype, "upState", { get: function() { return this.get_upState() }, set: function(value) { return this.set_upState(value); } });Object.defineProperty(feathers.utils.PointerToState.prototype, "downState", { get: function() { return this.get_downState() }, set: function(value) { return this.set_downState(value); } });Object.defineProperty(feathers.utils.PointerToState.prototype, "hoverState", { get: function() { return this.get_hoverState() }, set: function(value) { return this.set_hoverState(value); } });Object.defineProperty(feathers.utils.PointerToState.prototype, "enabled", { get: function() { return this.get_enabled() }, set: function(value) { return this.set_enabled(value); } });Object.defineProperty(feathers.utils.PointerToState.prototype, "keepDownStateOnRollOut", { get: function() { return this.get_keepDownStateOnRollOut() }, set: function(value) { return this.set_keepDownStateOnRollOut(value); } });Object.defineProperty(feathers.utils.PointerToState.prototype, "customHitTest", { get: function() { return this.get_customHitTest() }, set: function(value) { return this.set_customHitTest(value); } });Object.defineProperty(feathers.core.IDateSelector.prototype, "selectedDate", { get: function() { return this.get_selectedDate() }, set: function(value) { return this.set_selectedDate(value); } });module.exports = feathers;

/***/ }),

/***/ "./lib/feathersui-patch.js":
/*!*********************************!*\
  !*** ./lib/feathersui-patch.js ***!
  \*********************************/
/***/ (() => {

if(typeof $haxeUID === "undefined") $haxeUID = 0;

/***/ }),

/***/ "motion":
/*!******************************************************************************************!*\
  !*** external {"commonjs":"motion","commonjs2":"motion","amd":"motion","root":"motion"} ***!
  \******************************************************************************************/
/***/ ((module) => {

"use strict";
module.exports = __WEBPACK_EXTERNAL_MODULE_motion__;

/***/ }),

/***/ "openfl":
/*!******************************************************************************************!*\
  !*** external {"commonjs":"openfl","commonjs2":"openfl","amd":"openfl","root":"openfl"} ***!
  \******************************************************************************************/
/***/ ((module) => {

"use strict";
module.exports = __WEBPACK_EXTERNAL_MODULE_openfl__;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/global */
/******/ 	(() => {
/******/ 		__webpack_require__.g = (function() {
/******/ 			if (typeof globalThis === 'object') return globalThis;
/******/ 			try {
/******/ 				return this || new Function('return this')();
/******/ 			} catch (e) {
/******/ 				if (typeof window === 'object') return window;
/******/ 			}
/******/ 		})();
/******/ 	})();
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	__webpack_require__("./lib/feathersui-patch.js");
/******/ 	// This entry module is referenced by other modules so it can't be inlined
/******/ 	var __webpack_exports__ = __webpack_require__("./lib/feathersui-defineProperties-wrapper.js");
/******/ 	
/******/ 	return __webpack_exports__;
/******/ })()
;
});
//# sourceMappingURL=feathersui-openfl.js.map